// Automatically generated file. DO NOT EDIT.
// Generated by gen-device-svd.go from esp32c3.svd, see https://github.com/posborne/cmsis-svd/tree/master/data/Espressif

// +build esp,esp32c3

// 32-bit RISC-V MCU & 2.4 GHz Wi-Fi & Bluetooth 5 (LE)
//
//     Copyright 2021 Espressif Systems (Shanghai) PTE LTD Licensed under the Apache License, Version 2.0 (the "License"); you may not use this file except in compliance with the License. You may obtain a copy of the License at http://www.apache.org/licenses/LICENSE-2.0 Unless required by applicable law or agreed to in writing, software distributed under the License is distributed on an "AS IS" BASIS, WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied. See the License for the specific language governing permissions and limitations under the License.
package esp

import (
	"runtime/volatile"
	"unsafe"
)

// Some information about this device.
const (
	Device       = "ESP32-C3"
	CPU          = "RV32IMC"
	FPUPresent   = false
	NVICPrioBits = 4
)

// Interrupt numbers.
const (
	// Highest interrupt number on this device.
	IRQ_max = 0
)

// Pseudo function call that is replaced by the compiler with the actual
// functions registered through interrupt.New.
//go:linkname callHandlers runtime/interrupt.callHandlers
func callHandlers(num int)
func HandleInterrupt(num int) {
	switch num {
	}
}

// Peripherals.
var (
	// Peripheral AES
	AES = (*AES_Type)(unsafe.Pointer(uintptr(0x6003a000)))

	// Peripheral APB_CTRL
	APB_CTRL = (*APB_CTRL_Type)(unsafe.Pointer(uintptr(0x60026000)))

	// Peripheral APB_SARADC
	APB_SARADC = (*APB_SARADC_Type)(unsafe.Pointer(uintptr(0x60040000)))

	// Peripheral ASSIST_DEBUG
	ASSIST_DEBUG = (*ASSIST_DEBUG_Type)(unsafe.Pointer(uintptr(0x600ce000)))

	// Peripheral DMA
	DMA = (*DMA_Type)(unsafe.Pointer(uintptr(0x6003f000)))

	// Peripheral DS
	DS = (*DS_Type)(unsafe.Pointer(uintptr(0x6003d000)))

	// Peripheral EFUSE
	EFUSE = (*EFUSE_Type)(unsafe.Pointer(uintptr(0x60008800)))

	// Peripheral GPIO
	GPIO = (*GPIO_Type)(unsafe.Pointer(uintptr(0x60004000)))

	// Peripheral GPIOSD
	GPIOSD = (*GPIOSD_Type)(unsafe.Pointer(uintptr(0x60004f00)))

	// Peripheral HMAC
	HMAC = (*HMAC_Type)(unsafe.Pointer(uintptr(0x6003e000)))

	// Peripheral I2C
	I2C = (*I2C_Type)(unsafe.Pointer(uintptr(0x60013000)))

	// Peripheral I2S
	I2S = (*I2S_Type)(unsafe.Pointer(uintptr(0x6002d000)))

	// Peripheral INTERRUPT_CORE0
	INTERRUPT_CORE0 = (*INTERRUPT_CORE0_Type)(unsafe.Pointer(uintptr(0x600c2000)))

	// Peripheral IO_MUX
	IO_MUX = (*IO_MUX_Type)(unsafe.Pointer(uintptr(0x60009000)))

	// Peripheral LEDC
	LEDC = (*LEDC_Type)(unsafe.Pointer(uintptr(0x60019000)))

	// Peripheral RMT
	RMT = (*RMT_Type)(unsafe.Pointer(uintptr(0x60016000)))

	// Peripheral RSA
	RSA = (*RSA_Type)(unsafe.Pointer(uintptr(0x6003c000)))

	// Peripheral RTC_CNTL
	RTC_CNTL = (*RTC_CNTL_Type)(unsafe.Pointer(uintptr(0x60008000)))

	// Peripheral SENSITIVE
	SENSITIVE = (*SENSITIVE_Type)(unsafe.Pointer(uintptr(0x600c1000)))

	// Peripheral SHA
	SHA = (*SHA_Type)(unsafe.Pointer(uintptr(0x6003b000)))

	// Peripheral SPI0
	SPI0 = (*SPI0_Type)(unsafe.Pointer(uintptr(0x60003000)))

	// Peripheral SPI1
	SPI1 = (*SPI1_Type)(unsafe.Pointer(uintptr(0x60002000)))

	// Peripheral SPI2
	SPI2 = (*SPI2_Type)(unsafe.Pointer(uintptr(0x60024000)))

	// Peripheral SYSTEM
	SYSTEM = (*SYSTEM_Type)(unsafe.Pointer(uintptr(0x600c0000)))

	// Peripheral SYSTIMER
	SYSTIMER = (*SYSTIMER_Type)(unsafe.Pointer(uintptr(0x60023000)))

	// Peripheral TIMG
	TIMG0 = (*TIMG_Type)(unsafe.Pointer(uintptr(0x6001f000)))

	// Peripheral UART
	UART0 = (*UART_Type)(unsafe.Pointer(uintptr(0x60000000)))

	// Peripheral UHCI
	UHCI0 = (*UHCI_Type)(unsafe.Pointer(uintptr(0x60014000)))

	// Peripheral USB_DEVICE
	USB_DEVICE = (*USB_DEVICE_Type)(unsafe.Pointer(uintptr(0x60043000)))

	// Peripheral XTS_AES
	XTS_AES = (*XTS_AES_Type)(unsafe.Pointer(uintptr(0x600cc000)))

	// Peripheral TIMG
	TIMG1 = (*TIMG_Type)(unsafe.Pointer(uintptr(0x60020000)))

	// Peripheral UART
	UART1 = (*UART_Type)(unsafe.Pointer(uintptr(0x60010000)))

	// Peripheral UHCI
	UHCI1 = (*UHCI_Type)(unsafe.Pointer(uintptr(0x6000c000)))
)

// Peripheral AES
type AES_Type struct {
	KEY_0             volatile.Register32 // 0x0
	KEY_1             volatile.Register32 // 0x4
	KEY_2             volatile.Register32 // 0x8
	KEY_3             volatile.Register32 // 0xC
	KEY_4             volatile.Register32 // 0x10
	KEY_5             volatile.Register32 // 0x14
	KEY_6             volatile.Register32 // 0x18
	KEY_7             volatile.Register32 // 0x1C
	TEXT_IN_0         volatile.Register32 // 0x20
	TEXT_IN_1         volatile.Register32 // 0x24
	TEXT_IN_2         volatile.Register32 // 0x28
	TEXT_IN_3         volatile.Register32 // 0x2C
	TEXT_OUT_0        volatile.Register32 // 0x30
	TEXT_OUT_1        volatile.Register32 // 0x34
	TEXT_OUT_2        volatile.Register32 // 0x38
	TEXT_OUT_3        volatile.Register32 // 0x3C
	MODE              volatile.Register32 // 0x40
	ENDIAN            volatile.Register32 // 0x44
	TRIGGER           volatile.Register32 // 0x48
	STATE             volatile.Register32 // 0x4C
	IV_MEM            volatile.Register32 // 0x50
	_                 [12]byte
	H_MEM             volatile.Register32 // 0x60
	_                 [12]byte
	J0_MEM            volatile.Register32 // 0x70
	_                 [12]byte
	T0_MEM            volatile.Register32 // 0x80
	_                 [12]byte
	DMA_ENABLE        volatile.Register32 // 0x90
	BLOCK_MODE        volatile.Register32 // 0x94
	BLOCK_NUM         volatile.Register32 // 0x98
	INC_SEL           volatile.Register32 // 0x9C
	AAD_BLOCK_NUM     volatile.Register32 // 0xA0
	REMAINDER_BIT_NUM volatile.Register32 // 0xA4
	CONTINUE          volatile.Register32 // 0xA8
	INT_CLEAR         volatile.Register32 // 0xAC
	INT_ENA           volatile.Register32 // 0xB0
	DATE              volatile.Register32 // 0xB4
	DMA_EXIT          volatile.Register32 // 0xB8
}

// AES.KEY_0: Key material key_0 configure register
func (o *AES_Type) SetKEY_0(value uint32) {
	volatile.StoreUint32(&o.KEY_0.Reg, value)
}
func (o *AES_Type) GetKEY_0() uint32 {
	return volatile.LoadUint32(&o.KEY_0.Reg)
}

// AES.KEY_1: Key material key_1 configure register
func (o *AES_Type) SetKEY_1(value uint32) {
	volatile.StoreUint32(&o.KEY_1.Reg, value)
}
func (o *AES_Type) GetKEY_1() uint32 {
	return volatile.LoadUint32(&o.KEY_1.Reg)
}

// AES.KEY_2: Key material key_2 configure register
func (o *AES_Type) SetKEY_2(value uint32) {
	volatile.StoreUint32(&o.KEY_2.Reg, value)
}
func (o *AES_Type) GetKEY_2() uint32 {
	return volatile.LoadUint32(&o.KEY_2.Reg)
}

// AES.KEY_3: Key material key_3 configure register
func (o *AES_Type) SetKEY_3(value uint32) {
	volatile.StoreUint32(&o.KEY_3.Reg, value)
}
func (o *AES_Type) GetKEY_3() uint32 {
	return volatile.LoadUint32(&o.KEY_3.Reg)
}

// AES.KEY_4: Key material key_4 configure register
func (o *AES_Type) SetKEY_4(value uint32) {
	volatile.StoreUint32(&o.KEY_4.Reg, value)
}
func (o *AES_Type) GetKEY_4() uint32 {
	return volatile.LoadUint32(&o.KEY_4.Reg)
}

// AES.KEY_5: Key material key_5 configure register
func (o *AES_Type) SetKEY_5(value uint32) {
	volatile.StoreUint32(&o.KEY_5.Reg, value)
}
func (o *AES_Type) GetKEY_5() uint32 {
	return volatile.LoadUint32(&o.KEY_5.Reg)
}

// AES.KEY_6: Key material key_6 configure register
func (o *AES_Type) SetKEY_6(value uint32) {
	volatile.StoreUint32(&o.KEY_6.Reg, value)
}
func (o *AES_Type) GetKEY_6() uint32 {
	return volatile.LoadUint32(&o.KEY_6.Reg)
}

// AES.KEY_7: Key material key_7 configure register
func (o *AES_Type) SetKEY_7(value uint32) {
	volatile.StoreUint32(&o.KEY_7.Reg, value)
}
func (o *AES_Type) GetKEY_7() uint32 {
	return volatile.LoadUint32(&o.KEY_7.Reg)
}

// AES.TEXT_IN_0: source text material text_in_0 configure register
func (o *AES_Type) SetTEXT_IN_0(value uint32) {
	volatile.StoreUint32(&o.TEXT_IN_0.Reg, value)
}
func (o *AES_Type) GetTEXT_IN_0() uint32 {
	return volatile.LoadUint32(&o.TEXT_IN_0.Reg)
}

// AES.TEXT_IN_1: source text material text_in_1 configure register
func (o *AES_Type) SetTEXT_IN_1(value uint32) {
	volatile.StoreUint32(&o.TEXT_IN_1.Reg, value)
}
func (o *AES_Type) GetTEXT_IN_1() uint32 {
	return volatile.LoadUint32(&o.TEXT_IN_1.Reg)
}

// AES.TEXT_IN_2: source text material text_in_2 configure register
func (o *AES_Type) SetTEXT_IN_2(value uint32) {
	volatile.StoreUint32(&o.TEXT_IN_2.Reg, value)
}
func (o *AES_Type) GetTEXT_IN_2() uint32 {
	return volatile.LoadUint32(&o.TEXT_IN_2.Reg)
}

// AES.TEXT_IN_3: source text material text_in_3 configure register
func (o *AES_Type) SetTEXT_IN_3(value uint32) {
	volatile.StoreUint32(&o.TEXT_IN_3.Reg, value)
}
func (o *AES_Type) GetTEXT_IN_3() uint32 {
	return volatile.LoadUint32(&o.TEXT_IN_3.Reg)
}

// AES.TEXT_OUT_0: result text material text_out_0 configure register
func (o *AES_Type) SetTEXT_OUT_0(value uint32) {
	volatile.StoreUint32(&o.TEXT_OUT_0.Reg, value)
}
func (o *AES_Type) GetTEXT_OUT_0() uint32 {
	return volatile.LoadUint32(&o.TEXT_OUT_0.Reg)
}

// AES.TEXT_OUT_1: result text material text_out_1 configure register
func (o *AES_Type) SetTEXT_OUT_1(value uint32) {
	volatile.StoreUint32(&o.TEXT_OUT_1.Reg, value)
}
func (o *AES_Type) GetTEXT_OUT_1() uint32 {
	return volatile.LoadUint32(&o.TEXT_OUT_1.Reg)
}

// AES.TEXT_OUT_2: result text material text_out_2 configure register
func (o *AES_Type) SetTEXT_OUT_2(value uint32) {
	volatile.StoreUint32(&o.TEXT_OUT_2.Reg, value)
}
func (o *AES_Type) GetTEXT_OUT_2() uint32 {
	return volatile.LoadUint32(&o.TEXT_OUT_2.Reg)
}

// AES.TEXT_OUT_3: result text material text_out_3 configure register
func (o *AES_Type) SetTEXT_OUT_3(value uint32) {
	volatile.StoreUint32(&o.TEXT_OUT_3.Reg, value)
}
func (o *AES_Type) GetTEXT_OUT_3() uint32 {
	return volatile.LoadUint32(&o.TEXT_OUT_3.Reg)
}

// AES.MODE: AES Mode register
func (o *AES_Type) SetMODE(value uint32) {
	volatile.StoreUint32(&o.MODE.Reg, volatile.LoadUint32(&o.MODE.Reg)&^(0x7)|value)
}
func (o *AES_Type) GetMODE() uint32 {
	return volatile.LoadUint32(&o.MODE.Reg) & 0x7
}

// AES.ENDIAN: AES Endian configure register
func (o *AES_Type) SetENDIAN(value uint32) {
	volatile.StoreUint32(&o.ENDIAN.Reg, volatile.LoadUint32(&o.ENDIAN.Reg)&^(0x3f)|value)
}
func (o *AES_Type) GetENDIAN() uint32 {
	return volatile.LoadUint32(&o.ENDIAN.Reg) & 0x3f
}

// AES.TRIGGER: AES trigger register
func (o *AES_Type) SetTRIGGER(value uint32) {
	volatile.StoreUint32(&o.TRIGGER.Reg, volatile.LoadUint32(&o.TRIGGER.Reg)&^(0x1)|value)
}
func (o *AES_Type) GetTRIGGER() uint32 {
	return volatile.LoadUint32(&o.TRIGGER.Reg) & 0x1
}

// AES.STATE: AES state register
func (o *AES_Type) SetSTATE(value uint32) {
	volatile.StoreUint32(&o.STATE.Reg, volatile.LoadUint32(&o.STATE.Reg)&^(0x3)|value)
}
func (o *AES_Type) GetSTATE() uint32 {
	return volatile.LoadUint32(&o.STATE.Reg) & 0x3
}

// AES.DMA_ENABLE: DMA-AES working mode register
func (o *AES_Type) SetDMA_ENABLE(value uint32) {
	volatile.StoreUint32(&o.DMA_ENABLE.Reg, volatile.LoadUint32(&o.DMA_ENABLE.Reg)&^(0x1)|value)
}
func (o *AES_Type) GetDMA_ENABLE() uint32 {
	return volatile.LoadUint32(&o.DMA_ENABLE.Reg) & 0x1
}

// AES.BLOCK_MODE: AES cipher block mode register
func (o *AES_Type) SetBLOCK_MODE(value uint32) {
	volatile.StoreUint32(&o.BLOCK_MODE.Reg, volatile.LoadUint32(&o.BLOCK_MODE.Reg)&^(0x7)|value)
}
func (o *AES_Type) GetBLOCK_MODE() uint32 {
	return volatile.LoadUint32(&o.BLOCK_MODE.Reg) & 0x7
}

// AES.BLOCK_NUM: AES block number register
func (o *AES_Type) SetBLOCK_NUM(value uint32) {
	volatile.StoreUint32(&o.BLOCK_NUM.Reg, value)
}
func (o *AES_Type) GetBLOCK_NUM() uint32 {
	return volatile.LoadUint32(&o.BLOCK_NUM.Reg)
}

// AES.INC_SEL: Standard incrementing function configure register
func (o *AES_Type) SetINC_SEL(value uint32) {
	volatile.StoreUint32(&o.INC_SEL.Reg, volatile.LoadUint32(&o.INC_SEL.Reg)&^(0x1)|value)
}
func (o *AES_Type) GetINC_SEL() uint32 {
	return volatile.LoadUint32(&o.INC_SEL.Reg) & 0x1
}

// AES.AAD_BLOCK_NUM: Additional Authential Data block number register
func (o *AES_Type) SetAAD_BLOCK_NUM(value uint32) {
	volatile.StoreUint32(&o.AAD_BLOCK_NUM.Reg, value)
}
func (o *AES_Type) GetAAD_BLOCK_NUM() uint32 {
	return volatile.LoadUint32(&o.AAD_BLOCK_NUM.Reg)
}

// AES.REMAINDER_BIT_NUM: AES remainder bit number register
func (o *AES_Type) SetREMAINDER_BIT_NUM(value uint32) {
	volatile.StoreUint32(&o.REMAINDER_BIT_NUM.Reg, volatile.LoadUint32(&o.REMAINDER_BIT_NUM.Reg)&^(0x7f)|value)
}
func (o *AES_Type) GetREMAINDER_BIT_NUM() uint32 {
	return volatile.LoadUint32(&o.REMAINDER_BIT_NUM.Reg) & 0x7f
}

// AES.CONTINUE: AES continue register
func (o *AES_Type) SetCONTINUE(value uint32) {
	volatile.StoreUint32(&o.CONTINUE.Reg, volatile.LoadUint32(&o.CONTINUE.Reg)&^(0x1)|value)
}
func (o *AES_Type) GetCONTINUE() uint32 {
	return volatile.LoadUint32(&o.CONTINUE.Reg) & 0x1
}

// AES.INT_CLEAR: AES Interrupt clear register
func (o *AES_Type) SetINT_CLEAR(value uint32) {
	volatile.StoreUint32(&o.INT_CLEAR.Reg, volatile.LoadUint32(&o.INT_CLEAR.Reg)&^(0x1)|value)
}
func (o *AES_Type) GetINT_CLEAR() uint32 {
	return volatile.LoadUint32(&o.INT_CLEAR.Reg) & 0x1
}

// AES.INT_ENA: AES Interrupt enable register
func (o *AES_Type) SetINT_ENA(value uint32) {
	volatile.StoreUint32(&o.INT_ENA.Reg, volatile.LoadUint32(&o.INT_ENA.Reg)&^(0x1)|value)
}
func (o *AES_Type) GetINT_ENA() uint32 {
	return volatile.LoadUint32(&o.INT_ENA.Reg) & 0x1
}

// AES.DATE: AES version control register
func (o *AES_Type) SetDATE(value uint32) {
	volatile.StoreUint32(&o.DATE.Reg, volatile.LoadUint32(&o.DATE.Reg)&^(0x3fffffff)|value)
}
func (o *AES_Type) GetDATE() uint32 {
	return volatile.LoadUint32(&o.DATE.Reg) & 0x3fffffff
}

// AES.DMA_EXIT: AES-DMA exit config
func (o *AES_Type) SetDMA_EXIT(value uint32) {
	volatile.StoreUint32(&o.DMA_EXIT.Reg, volatile.LoadUint32(&o.DMA_EXIT.Reg)&^(0x1)|value)
}
func (o *AES_Type) GetDMA_EXIT() uint32 {
	return volatile.LoadUint32(&o.DMA_EXIT.Reg) & 0x1
}

// Peripheral APB_CTRL
type APB_CTRL_Type struct {
	SYSCLK_CONF          volatile.Register32 // 0x0
	TICK_CONF            volatile.Register32 // 0x4
	CLK_OUT_EN           volatile.Register32 // 0x8
	WIFI_BB_CFG          volatile.Register32 // 0xC
	WIFI_BB_CFG_2        volatile.Register32 // 0x10
	WIFI_CLK_EN          volatile.Register32 // 0x14
	WIFI_RST_EN          volatile.Register32 // 0x18
	HOST_INF_SEL         volatile.Register32 // 0x1C
	EXT_MEM_PMS_LOCK     volatile.Register32 // 0x20
	_                    [4]byte
	FLASH_ACE0_ATTR      volatile.Register32 // 0x28
	FLASH_ACE1_ATTR      volatile.Register32 // 0x2C
	FLASH_ACE2_ATTR      volatile.Register32 // 0x30
	FLASH_ACE3_ATTR      volatile.Register32 // 0x34
	FLASH_ACE0_ADDR      volatile.Register32 // 0x38
	FLASH_ACE1_ADDR      volatile.Register32 // 0x3C
	FLASH_ACE2_ADDR      volatile.Register32 // 0x40
	FLASH_ACE3_ADDR      volatile.Register32 // 0x44
	FLASH_ACE0_SIZE      volatile.Register32 // 0x48
	FLASH_ACE1_SIZE      volatile.Register32 // 0x4C
	FLASH_ACE2_SIZE      volatile.Register32 // 0x50
	FLASH_ACE3_SIZE      volatile.Register32 // 0x54
	_                    [48]byte
	SPI_MEM_PMS_CTRL     volatile.Register32 // 0x88
	SPI_MEM_REJECT_ADDR  volatile.Register32 // 0x8C
	SDIO_CTRL            volatile.Register32 // 0x90
	REDCY_SIG0           volatile.Register32 // 0x94
	REDCY_SIG1           volatile.Register32 // 0x98
	FRONT_END_MEM_PD     volatile.Register32 // 0x9C
	RETENTION_CTRL       volatile.Register32 // 0xA0
	CLKGATE_FORCE_ON     volatile.Register32 // 0xA4
	MEM_POWER_DOWN       volatile.Register32 // 0xA8
	MEM_POWER_UP         volatile.Register32 // 0xAC
	RND_DATA             volatile.Register32 // 0xB0
	PERI_BACKUP_CONFIG   volatile.Register32 // 0xB4
	PERI_BACKUP_APB_ADDR volatile.Register32 // 0xB8
	PERI_BACKUP_MEM_ADDR volatile.Register32 // 0xBC
	PERI_BACKUP_INT_RAW  volatile.Register32 // 0xC0
	PERI_BACKUP_INT_ST   volatile.Register32 // 0xC4
	PERI_BACKUP_INT_ENA  volatile.Register32 // 0xC8
	_                    [4]byte
	PERI_BACKUP_INT_CLR  volatile.Register32 // 0xD0
	_                    [808]byte
	DATE                 volatile.Register32 // 0x3FC
}

// APB_CTRL.SYSCLK_CONF: APB_CTRL_SYSCLK_CONF_REG
func (o *APB_CTRL_Type) SetSYSCLK_CONF_PRE_DIV_CNT(value uint32) {
	volatile.StoreUint32(&o.SYSCLK_CONF.Reg, volatile.LoadUint32(&o.SYSCLK_CONF.Reg)&^(0x3ff)|value)
}
func (o *APB_CTRL_Type) GetSYSCLK_CONF_PRE_DIV_CNT() uint32 {
	return volatile.LoadUint32(&o.SYSCLK_CONF.Reg) & 0x3ff
}
func (o *APB_CTRL_Type) SetSYSCLK_CONF_CLK_320M_EN(value uint32) {
	volatile.StoreUint32(&o.SYSCLK_CONF.Reg, volatile.LoadUint32(&o.SYSCLK_CONF.Reg)&^(0x400)|value<<10)
}
func (o *APB_CTRL_Type) GetSYSCLK_CONF_CLK_320M_EN() uint32 {
	return (volatile.LoadUint32(&o.SYSCLK_CONF.Reg) & 0x400) >> 10
}
func (o *APB_CTRL_Type) SetSYSCLK_CONF_CLK_EN(value uint32) {
	volatile.StoreUint32(&o.SYSCLK_CONF.Reg, volatile.LoadUint32(&o.SYSCLK_CONF.Reg)&^(0x800)|value<<11)
}
func (o *APB_CTRL_Type) GetSYSCLK_CONF_CLK_EN() uint32 {
	return (volatile.LoadUint32(&o.SYSCLK_CONF.Reg) & 0x800) >> 11
}
func (o *APB_CTRL_Type) SetSYSCLK_CONF_RST_TICK_CNT(value uint32) {
	volatile.StoreUint32(&o.SYSCLK_CONF.Reg, volatile.LoadUint32(&o.SYSCLK_CONF.Reg)&^(0x1000)|value<<12)
}
func (o *APB_CTRL_Type) GetSYSCLK_CONF_RST_TICK_CNT() uint32 {
	return (volatile.LoadUint32(&o.SYSCLK_CONF.Reg) & 0x1000) >> 12
}

// APB_CTRL.TICK_CONF: APB_CTRL_TICK_CONF_REG
func (o *APB_CTRL_Type) SetTICK_CONF_XTAL_TICK_NUM(value uint32) {
	volatile.StoreUint32(&o.TICK_CONF.Reg, volatile.LoadUint32(&o.TICK_CONF.Reg)&^(0xff)|value)
}
func (o *APB_CTRL_Type) GetTICK_CONF_XTAL_TICK_NUM() uint32 {
	return volatile.LoadUint32(&o.TICK_CONF.Reg) & 0xff
}
func (o *APB_CTRL_Type) SetTICK_CONF_CK8M_TICK_NUM(value uint32) {
	volatile.StoreUint32(&o.TICK_CONF.Reg, volatile.LoadUint32(&o.TICK_CONF.Reg)&^(0xff00)|value<<8)
}
func (o *APB_CTRL_Type) GetTICK_CONF_CK8M_TICK_NUM() uint32 {
	return (volatile.LoadUint32(&o.TICK_CONF.Reg) & 0xff00) >> 8
}
func (o *APB_CTRL_Type) SetTICK_CONF_TICK_ENABLE(value uint32) {
	volatile.StoreUint32(&o.TICK_CONF.Reg, volatile.LoadUint32(&o.TICK_CONF.Reg)&^(0x10000)|value<<16)
}
func (o *APB_CTRL_Type) GetTICK_CONF_TICK_ENABLE() uint32 {
	return (volatile.LoadUint32(&o.TICK_CONF.Reg) & 0x10000) >> 16
}

// APB_CTRL.CLK_OUT_EN: APB_CTRL_CLK_OUT_EN_REG
func (o *APB_CTRL_Type) SetCLK_OUT_EN_CLK20_OEN(value uint32) {
	volatile.StoreUint32(&o.CLK_OUT_EN.Reg, volatile.LoadUint32(&o.CLK_OUT_EN.Reg)&^(0x1)|value)
}
func (o *APB_CTRL_Type) GetCLK_OUT_EN_CLK20_OEN() uint32 {
	return volatile.LoadUint32(&o.CLK_OUT_EN.Reg) & 0x1
}
func (o *APB_CTRL_Type) SetCLK_OUT_EN_CLK22_OEN(value uint32) {
	volatile.StoreUint32(&o.CLK_OUT_EN.Reg, volatile.LoadUint32(&o.CLK_OUT_EN.Reg)&^(0x2)|value<<1)
}
func (o *APB_CTRL_Type) GetCLK_OUT_EN_CLK22_OEN() uint32 {
	return (volatile.LoadUint32(&o.CLK_OUT_EN.Reg) & 0x2) >> 1
}
func (o *APB_CTRL_Type) SetCLK_OUT_EN_CLK44_OEN(value uint32) {
	volatile.StoreUint32(&o.CLK_OUT_EN.Reg, volatile.LoadUint32(&o.CLK_OUT_EN.Reg)&^(0x4)|value<<2)
}
func (o *APB_CTRL_Type) GetCLK_OUT_EN_CLK44_OEN() uint32 {
	return (volatile.LoadUint32(&o.CLK_OUT_EN.Reg) & 0x4) >> 2
}
func (o *APB_CTRL_Type) SetCLK_OUT_EN_CLK_BB_OEN(value uint32) {
	volatile.StoreUint32(&o.CLK_OUT_EN.Reg, volatile.LoadUint32(&o.CLK_OUT_EN.Reg)&^(0x8)|value<<3)
}
func (o *APB_CTRL_Type) GetCLK_OUT_EN_CLK_BB_OEN() uint32 {
	return (volatile.LoadUint32(&o.CLK_OUT_EN.Reg) & 0x8) >> 3
}
func (o *APB_CTRL_Type) SetCLK_OUT_EN_CLK80_OEN(value uint32) {
	volatile.StoreUint32(&o.CLK_OUT_EN.Reg, volatile.LoadUint32(&o.CLK_OUT_EN.Reg)&^(0x10)|value<<4)
}
func (o *APB_CTRL_Type) GetCLK_OUT_EN_CLK80_OEN() uint32 {
	return (volatile.LoadUint32(&o.CLK_OUT_EN.Reg) & 0x10) >> 4
}
func (o *APB_CTRL_Type) SetCLK_OUT_EN_CLK160_OEN(value uint32) {
	volatile.StoreUint32(&o.CLK_OUT_EN.Reg, volatile.LoadUint32(&o.CLK_OUT_EN.Reg)&^(0x20)|value<<5)
}
func (o *APB_CTRL_Type) GetCLK_OUT_EN_CLK160_OEN() uint32 {
	return (volatile.LoadUint32(&o.CLK_OUT_EN.Reg) & 0x20) >> 5
}
func (o *APB_CTRL_Type) SetCLK_OUT_EN_CLK_320M_OEN(value uint32) {
	volatile.StoreUint32(&o.CLK_OUT_EN.Reg, volatile.LoadUint32(&o.CLK_OUT_EN.Reg)&^(0x40)|value<<6)
}
func (o *APB_CTRL_Type) GetCLK_OUT_EN_CLK_320M_OEN() uint32 {
	return (volatile.LoadUint32(&o.CLK_OUT_EN.Reg) & 0x40) >> 6
}
func (o *APB_CTRL_Type) SetCLK_OUT_EN_CLK_ADC_INF_OEN(value uint32) {
	volatile.StoreUint32(&o.CLK_OUT_EN.Reg, volatile.LoadUint32(&o.CLK_OUT_EN.Reg)&^(0x80)|value<<7)
}
func (o *APB_CTRL_Type) GetCLK_OUT_EN_CLK_ADC_INF_OEN() uint32 {
	return (volatile.LoadUint32(&o.CLK_OUT_EN.Reg) & 0x80) >> 7
}
func (o *APB_CTRL_Type) SetCLK_OUT_EN_CLK_DAC_CPU_OEN(value uint32) {
	volatile.StoreUint32(&o.CLK_OUT_EN.Reg, volatile.LoadUint32(&o.CLK_OUT_EN.Reg)&^(0x100)|value<<8)
}
func (o *APB_CTRL_Type) GetCLK_OUT_EN_CLK_DAC_CPU_OEN() uint32 {
	return (volatile.LoadUint32(&o.CLK_OUT_EN.Reg) & 0x100) >> 8
}
func (o *APB_CTRL_Type) SetCLK_OUT_EN_CLK40X_BB_OEN(value uint32) {
	volatile.StoreUint32(&o.CLK_OUT_EN.Reg, volatile.LoadUint32(&o.CLK_OUT_EN.Reg)&^(0x200)|value<<9)
}
func (o *APB_CTRL_Type) GetCLK_OUT_EN_CLK40X_BB_OEN() uint32 {
	return (volatile.LoadUint32(&o.CLK_OUT_EN.Reg) & 0x200) >> 9
}
func (o *APB_CTRL_Type) SetCLK_OUT_EN_CLK_XTAL_OEN(value uint32) {
	volatile.StoreUint32(&o.CLK_OUT_EN.Reg, volatile.LoadUint32(&o.CLK_OUT_EN.Reg)&^(0x400)|value<<10)
}
func (o *APB_CTRL_Type) GetCLK_OUT_EN_CLK_XTAL_OEN() uint32 {
	return (volatile.LoadUint32(&o.CLK_OUT_EN.Reg) & 0x400) >> 10
}

// APB_CTRL.WIFI_BB_CFG: APB_CTRL_WIFI_BB_CFG_REG
func (o *APB_CTRL_Type) SetWIFI_BB_CFG(value uint32) {
	volatile.StoreUint32(&o.WIFI_BB_CFG.Reg, value)
}
func (o *APB_CTRL_Type) GetWIFI_BB_CFG() uint32 {
	return volatile.LoadUint32(&o.WIFI_BB_CFG.Reg)
}

// APB_CTRL.WIFI_BB_CFG_2: APB_CTRL_WIFI_BB_CFG_2_REG
func (o *APB_CTRL_Type) SetWIFI_BB_CFG_2(value uint32) {
	volatile.StoreUint32(&o.WIFI_BB_CFG_2.Reg, value)
}
func (o *APB_CTRL_Type) GetWIFI_BB_CFG_2() uint32 {
	return volatile.LoadUint32(&o.WIFI_BB_CFG_2.Reg)
}

// APB_CTRL.WIFI_CLK_EN: APB_CTRL_WIFI_CLK_EN_REG
func (o *APB_CTRL_Type) SetWIFI_CLK_EN(value uint32) {
	volatile.StoreUint32(&o.WIFI_CLK_EN.Reg, value)
}
func (o *APB_CTRL_Type) GetWIFI_CLK_EN() uint32 {
	return volatile.LoadUint32(&o.WIFI_CLK_EN.Reg)
}

// APB_CTRL.WIFI_RST_EN: APB_CTRL_WIFI_RST_EN_REG
func (o *APB_CTRL_Type) SetWIFI_RST_EN(value uint32) {
	volatile.StoreUint32(&o.WIFI_RST_EN.Reg, value)
}
func (o *APB_CTRL_Type) GetWIFI_RST_EN() uint32 {
	return volatile.LoadUint32(&o.WIFI_RST_EN.Reg)
}

// APB_CTRL.HOST_INF_SEL: APB_CTRL_HOST_INF_SEL_REG
func (o *APB_CTRL_Type) SetHOST_INF_SEL_PERI_IO_SWAP(value uint32) {
	volatile.StoreUint32(&o.HOST_INF_SEL.Reg, volatile.LoadUint32(&o.HOST_INF_SEL.Reg)&^(0xff)|value)
}
func (o *APB_CTRL_Type) GetHOST_INF_SEL_PERI_IO_SWAP() uint32 {
	return volatile.LoadUint32(&o.HOST_INF_SEL.Reg) & 0xff
}

// APB_CTRL.EXT_MEM_PMS_LOCK: APB_CTRL_EXT_MEM_PMS_LOCK_REG
func (o *APB_CTRL_Type) SetEXT_MEM_PMS_LOCK(value uint32) {
	volatile.StoreUint32(&o.EXT_MEM_PMS_LOCK.Reg, volatile.LoadUint32(&o.EXT_MEM_PMS_LOCK.Reg)&^(0x1)|value)
}
func (o *APB_CTRL_Type) GetEXT_MEM_PMS_LOCK() uint32 {
	return volatile.LoadUint32(&o.EXT_MEM_PMS_LOCK.Reg) & 0x1
}

// APB_CTRL.FLASH_ACE0_ATTR: APB_CTRL_FLASH_ACE0_ATTR_REG
func (o *APB_CTRL_Type) SetFLASH_ACE0_ATTR(value uint32) {
	volatile.StoreUint32(&o.FLASH_ACE0_ATTR.Reg, volatile.LoadUint32(&o.FLASH_ACE0_ATTR.Reg)&^(0x3)|value)
}
func (o *APB_CTRL_Type) GetFLASH_ACE0_ATTR() uint32 {
	return volatile.LoadUint32(&o.FLASH_ACE0_ATTR.Reg) & 0x3
}

// APB_CTRL.FLASH_ACE1_ATTR: APB_CTRL_FLASH_ACE1_ATTR_REG
func (o *APB_CTRL_Type) SetFLASH_ACE1_ATTR(value uint32) {
	volatile.StoreUint32(&o.FLASH_ACE1_ATTR.Reg, volatile.LoadUint32(&o.FLASH_ACE1_ATTR.Reg)&^(0x3)|value)
}
func (o *APB_CTRL_Type) GetFLASH_ACE1_ATTR() uint32 {
	return volatile.LoadUint32(&o.FLASH_ACE1_ATTR.Reg) & 0x3
}

// APB_CTRL.FLASH_ACE2_ATTR: APB_CTRL_FLASH_ACE2_ATTR_REG
func (o *APB_CTRL_Type) SetFLASH_ACE2_ATTR(value uint32) {
	volatile.StoreUint32(&o.FLASH_ACE2_ATTR.Reg, volatile.LoadUint32(&o.FLASH_ACE2_ATTR.Reg)&^(0x3)|value)
}
func (o *APB_CTRL_Type) GetFLASH_ACE2_ATTR() uint32 {
	return volatile.LoadUint32(&o.FLASH_ACE2_ATTR.Reg) & 0x3
}

// APB_CTRL.FLASH_ACE3_ATTR: APB_CTRL_FLASH_ACE3_ATTR_REG
func (o *APB_CTRL_Type) SetFLASH_ACE3_ATTR(value uint32) {
	volatile.StoreUint32(&o.FLASH_ACE3_ATTR.Reg, volatile.LoadUint32(&o.FLASH_ACE3_ATTR.Reg)&^(0x3)|value)
}
func (o *APB_CTRL_Type) GetFLASH_ACE3_ATTR() uint32 {
	return volatile.LoadUint32(&o.FLASH_ACE3_ATTR.Reg) & 0x3
}

// APB_CTRL.FLASH_ACE0_ADDR: APB_CTRL_FLASH_ACE0_ADDR_REG
func (o *APB_CTRL_Type) SetFLASH_ACE0_ADDR(value uint32) {
	volatile.StoreUint32(&o.FLASH_ACE0_ADDR.Reg, value)
}
func (o *APB_CTRL_Type) GetFLASH_ACE0_ADDR() uint32 {
	return volatile.LoadUint32(&o.FLASH_ACE0_ADDR.Reg)
}

// APB_CTRL.FLASH_ACE1_ADDR: APB_CTRL_FLASH_ACE1_ADDR_REG
func (o *APB_CTRL_Type) SetFLASH_ACE1_ADDR(value uint32) {
	volatile.StoreUint32(&o.FLASH_ACE1_ADDR.Reg, value)
}
func (o *APB_CTRL_Type) GetFLASH_ACE1_ADDR() uint32 {
	return volatile.LoadUint32(&o.FLASH_ACE1_ADDR.Reg)
}

// APB_CTRL.FLASH_ACE2_ADDR: APB_CTRL_FLASH_ACE2_ADDR_REG
func (o *APB_CTRL_Type) SetFLASH_ACE2_ADDR(value uint32) {
	volatile.StoreUint32(&o.FLASH_ACE2_ADDR.Reg, value)
}
func (o *APB_CTRL_Type) GetFLASH_ACE2_ADDR() uint32 {
	return volatile.LoadUint32(&o.FLASH_ACE2_ADDR.Reg)
}

// APB_CTRL.FLASH_ACE3_ADDR: APB_CTRL_FLASH_ACE3_ADDR_REG
func (o *APB_CTRL_Type) SetFLASH_ACE3_ADDR(value uint32) {
	volatile.StoreUint32(&o.FLASH_ACE3_ADDR.Reg, value)
}
func (o *APB_CTRL_Type) GetFLASH_ACE3_ADDR() uint32 {
	return volatile.LoadUint32(&o.FLASH_ACE3_ADDR.Reg)
}

// APB_CTRL.FLASH_ACE0_SIZE: APB_CTRL_FLASH_ACE0_SIZE_REG
func (o *APB_CTRL_Type) SetFLASH_ACE0_SIZE(value uint32) {
	volatile.StoreUint32(&o.FLASH_ACE0_SIZE.Reg, volatile.LoadUint32(&o.FLASH_ACE0_SIZE.Reg)&^(0x1fff)|value)
}
func (o *APB_CTRL_Type) GetFLASH_ACE0_SIZE() uint32 {
	return volatile.LoadUint32(&o.FLASH_ACE0_SIZE.Reg) & 0x1fff
}

// APB_CTRL.FLASH_ACE1_SIZE: APB_CTRL_FLASH_ACE1_SIZE_REG
func (o *APB_CTRL_Type) SetFLASH_ACE1_SIZE(value uint32) {
	volatile.StoreUint32(&o.FLASH_ACE1_SIZE.Reg, volatile.LoadUint32(&o.FLASH_ACE1_SIZE.Reg)&^(0x1fff)|value)
}
func (o *APB_CTRL_Type) GetFLASH_ACE1_SIZE() uint32 {
	return volatile.LoadUint32(&o.FLASH_ACE1_SIZE.Reg) & 0x1fff
}

// APB_CTRL.FLASH_ACE2_SIZE: APB_CTRL_FLASH_ACE2_SIZE_REG
func (o *APB_CTRL_Type) SetFLASH_ACE2_SIZE(value uint32) {
	volatile.StoreUint32(&o.FLASH_ACE2_SIZE.Reg, volatile.LoadUint32(&o.FLASH_ACE2_SIZE.Reg)&^(0x1fff)|value)
}
func (o *APB_CTRL_Type) GetFLASH_ACE2_SIZE() uint32 {
	return volatile.LoadUint32(&o.FLASH_ACE2_SIZE.Reg) & 0x1fff
}

// APB_CTRL.FLASH_ACE3_SIZE: APB_CTRL_FLASH_ACE3_SIZE_REG
func (o *APB_CTRL_Type) SetFLASH_ACE3_SIZE(value uint32) {
	volatile.StoreUint32(&o.FLASH_ACE3_SIZE.Reg, volatile.LoadUint32(&o.FLASH_ACE3_SIZE.Reg)&^(0x1fff)|value)
}
func (o *APB_CTRL_Type) GetFLASH_ACE3_SIZE() uint32 {
	return volatile.LoadUint32(&o.FLASH_ACE3_SIZE.Reg) & 0x1fff
}

// APB_CTRL.SPI_MEM_PMS_CTRL: APB_CTRL_SPI_MEM_PMS_CTRL_REG
func (o *APB_CTRL_Type) SetSPI_MEM_PMS_CTRL_SPI_MEM_REJECT_INT(value uint32) {
	volatile.StoreUint32(&o.SPI_MEM_PMS_CTRL.Reg, volatile.LoadUint32(&o.SPI_MEM_PMS_CTRL.Reg)&^(0x1)|value)
}
func (o *APB_CTRL_Type) GetSPI_MEM_PMS_CTRL_SPI_MEM_REJECT_INT() uint32 {
	return volatile.LoadUint32(&o.SPI_MEM_PMS_CTRL.Reg) & 0x1
}
func (o *APB_CTRL_Type) SetSPI_MEM_PMS_CTRL_SPI_MEM_REJECT_CLR(value uint32) {
	volatile.StoreUint32(&o.SPI_MEM_PMS_CTRL.Reg, volatile.LoadUint32(&o.SPI_MEM_PMS_CTRL.Reg)&^(0x2)|value<<1)
}
func (o *APB_CTRL_Type) GetSPI_MEM_PMS_CTRL_SPI_MEM_REJECT_CLR() uint32 {
	return (volatile.LoadUint32(&o.SPI_MEM_PMS_CTRL.Reg) & 0x2) >> 1
}
func (o *APB_CTRL_Type) SetSPI_MEM_PMS_CTRL_SPI_MEM_REJECT_CDE(value uint32) {
	volatile.StoreUint32(&o.SPI_MEM_PMS_CTRL.Reg, volatile.LoadUint32(&o.SPI_MEM_PMS_CTRL.Reg)&^(0x7c)|value<<2)
}
func (o *APB_CTRL_Type) GetSPI_MEM_PMS_CTRL_SPI_MEM_REJECT_CDE() uint32 {
	return (volatile.LoadUint32(&o.SPI_MEM_PMS_CTRL.Reg) & 0x7c) >> 2
}

// APB_CTRL.SPI_MEM_REJECT_ADDR: APB_CTRL_SPI_MEM_REJECT_ADDR_REG
func (o *APB_CTRL_Type) SetSPI_MEM_REJECT_ADDR(value uint32) {
	volatile.StoreUint32(&o.SPI_MEM_REJECT_ADDR.Reg, value)
}
func (o *APB_CTRL_Type) GetSPI_MEM_REJECT_ADDR() uint32 {
	return volatile.LoadUint32(&o.SPI_MEM_REJECT_ADDR.Reg)
}

// APB_CTRL.SDIO_CTRL: APB_CTRL_SDIO_CTRL_REG
func (o *APB_CTRL_Type) SetSDIO_CTRL_SDIO_WIN_ACCESS_EN(value uint32) {
	volatile.StoreUint32(&o.SDIO_CTRL.Reg, volatile.LoadUint32(&o.SDIO_CTRL.Reg)&^(0x1)|value)
}
func (o *APB_CTRL_Type) GetSDIO_CTRL_SDIO_WIN_ACCESS_EN() uint32 {
	return volatile.LoadUint32(&o.SDIO_CTRL.Reg) & 0x1
}

// APB_CTRL.REDCY_SIG0: APB_CTRL_REDCY_SIG0_REG
func (o *APB_CTRL_Type) SetREDCY_SIG0(value uint32) {
	volatile.StoreUint32(&o.REDCY_SIG0.Reg, volatile.LoadUint32(&o.REDCY_SIG0.Reg)&^(0x7fffffff)|value)
}
func (o *APB_CTRL_Type) GetREDCY_SIG0() uint32 {
	return volatile.LoadUint32(&o.REDCY_SIG0.Reg) & 0x7fffffff
}
func (o *APB_CTRL_Type) SetREDCY_SIG0_REDCY_ANDOR(value uint32) {
	volatile.StoreUint32(&o.REDCY_SIG0.Reg, volatile.LoadUint32(&o.REDCY_SIG0.Reg)&^(0x80000000)|value<<31)
}
func (o *APB_CTRL_Type) GetREDCY_SIG0_REDCY_ANDOR() uint32 {
	return (volatile.LoadUint32(&o.REDCY_SIG0.Reg) & 0x80000000) >> 31
}

// APB_CTRL.REDCY_SIG1: APB_CTRL_REDCY_SIG1_REG
func (o *APB_CTRL_Type) SetREDCY_SIG1(value uint32) {
	volatile.StoreUint32(&o.REDCY_SIG1.Reg, volatile.LoadUint32(&o.REDCY_SIG1.Reg)&^(0x7fffffff)|value)
}
func (o *APB_CTRL_Type) GetREDCY_SIG1() uint32 {
	return volatile.LoadUint32(&o.REDCY_SIG1.Reg) & 0x7fffffff
}
func (o *APB_CTRL_Type) SetREDCY_SIG1_REDCY_NANDOR(value uint32) {
	volatile.StoreUint32(&o.REDCY_SIG1.Reg, volatile.LoadUint32(&o.REDCY_SIG1.Reg)&^(0x80000000)|value<<31)
}
func (o *APB_CTRL_Type) GetREDCY_SIG1_REDCY_NANDOR() uint32 {
	return (volatile.LoadUint32(&o.REDCY_SIG1.Reg) & 0x80000000) >> 31
}

// APB_CTRL.FRONT_END_MEM_PD: APB_CTRL_FRONT_END_MEM_PD_REG
func (o *APB_CTRL_Type) SetFRONT_END_MEM_PD_AGC_MEM_FORCE_PU(value uint32) {
	volatile.StoreUint32(&o.FRONT_END_MEM_PD.Reg, volatile.LoadUint32(&o.FRONT_END_MEM_PD.Reg)&^(0x1)|value)
}
func (o *APB_CTRL_Type) GetFRONT_END_MEM_PD_AGC_MEM_FORCE_PU() uint32 {
	return volatile.LoadUint32(&o.FRONT_END_MEM_PD.Reg) & 0x1
}
func (o *APB_CTRL_Type) SetFRONT_END_MEM_PD_AGC_MEM_FORCE_PD(value uint32) {
	volatile.StoreUint32(&o.FRONT_END_MEM_PD.Reg, volatile.LoadUint32(&o.FRONT_END_MEM_PD.Reg)&^(0x2)|value<<1)
}
func (o *APB_CTRL_Type) GetFRONT_END_MEM_PD_AGC_MEM_FORCE_PD() uint32 {
	return (volatile.LoadUint32(&o.FRONT_END_MEM_PD.Reg) & 0x2) >> 1
}
func (o *APB_CTRL_Type) SetFRONT_END_MEM_PD_PBUS_MEM_FORCE_PU(value uint32) {
	volatile.StoreUint32(&o.FRONT_END_MEM_PD.Reg, volatile.LoadUint32(&o.FRONT_END_MEM_PD.Reg)&^(0x4)|value<<2)
}
func (o *APB_CTRL_Type) GetFRONT_END_MEM_PD_PBUS_MEM_FORCE_PU() uint32 {
	return (volatile.LoadUint32(&o.FRONT_END_MEM_PD.Reg) & 0x4) >> 2
}
func (o *APB_CTRL_Type) SetFRONT_END_MEM_PD_PBUS_MEM_FORCE_PD(value uint32) {
	volatile.StoreUint32(&o.FRONT_END_MEM_PD.Reg, volatile.LoadUint32(&o.FRONT_END_MEM_PD.Reg)&^(0x8)|value<<3)
}
func (o *APB_CTRL_Type) GetFRONT_END_MEM_PD_PBUS_MEM_FORCE_PD() uint32 {
	return (volatile.LoadUint32(&o.FRONT_END_MEM_PD.Reg) & 0x8) >> 3
}
func (o *APB_CTRL_Type) SetFRONT_END_MEM_PD_DC_MEM_FORCE_PU(value uint32) {
	volatile.StoreUint32(&o.FRONT_END_MEM_PD.Reg, volatile.LoadUint32(&o.FRONT_END_MEM_PD.Reg)&^(0x10)|value<<4)
}
func (o *APB_CTRL_Type) GetFRONT_END_MEM_PD_DC_MEM_FORCE_PU() uint32 {
	return (volatile.LoadUint32(&o.FRONT_END_MEM_PD.Reg) & 0x10) >> 4
}
func (o *APB_CTRL_Type) SetFRONT_END_MEM_PD_DC_MEM_FORCE_PD(value uint32) {
	volatile.StoreUint32(&o.FRONT_END_MEM_PD.Reg, volatile.LoadUint32(&o.FRONT_END_MEM_PD.Reg)&^(0x20)|value<<5)
}
func (o *APB_CTRL_Type) GetFRONT_END_MEM_PD_DC_MEM_FORCE_PD() uint32 {
	return (volatile.LoadUint32(&o.FRONT_END_MEM_PD.Reg) & 0x20) >> 5
}

// APB_CTRL.RETENTION_CTRL: APB_CTRL_RETENTION_CTRL_REG
func (o *APB_CTRL_Type) SetRETENTION_CTRL_RETENTION_LINK_ADDR(value uint32) {
	volatile.StoreUint32(&o.RETENTION_CTRL.Reg, volatile.LoadUint32(&o.RETENTION_CTRL.Reg)&^(0x7ffffff)|value)
}
func (o *APB_CTRL_Type) GetRETENTION_CTRL_RETENTION_LINK_ADDR() uint32 {
	return volatile.LoadUint32(&o.RETENTION_CTRL.Reg) & 0x7ffffff
}
func (o *APB_CTRL_Type) SetRETENTION_CTRL_NOBYPASS_CPU_ISO_RST(value uint32) {
	volatile.StoreUint32(&o.RETENTION_CTRL.Reg, volatile.LoadUint32(&o.RETENTION_CTRL.Reg)&^(0x8000000)|value<<27)
}
func (o *APB_CTRL_Type) GetRETENTION_CTRL_NOBYPASS_CPU_ISO_RST() uint32 {
	return (volatile.LoadUint32(&o.RETENTION_CTRL.Reg) & 0x8000000) >> 27
}

// APB_CTRL.CLKGATE_FORCE_ON: APB_CTRL_CLKGATE_FORCE_ON_REG
func (o *APB_CTRL_Type) SetCLKGATE_FORCE_ON_ROM_CLKGATE_FORCE_ON(value uint32) {
	volatile.StoreUint32(&o.CLKGATE_FORCE_ON.Reg, volatile.LoadUint32(&o.CLKGATE_FORCE_ON.Reg)&^(0x3)|value)
}
func (o *APB_CTRL_Type) GetCLKGATE_FORCE_ON_ROM_CLKGATE_FORCE_ON() uint32 {
	return volatile.LoadUint32(&o.CLKGATE_FORCE_ON.Reg) & 0x3
}
func (o *APB_CTRL_Type) SetCLKGATE_FORCE_ON_SRAM_CLKGATE_FORCE_ON(value uint32) {
	volatile.StoreUint32(&o.CLKGATE_FORCE_ON.Reg, volatile.LoadUint32(&o.CLKGATE_FORCE_ON.Reg)&^(0x3c)|value<<2)
}
func (o *APB_CTRL_Type) GetCLKGATE_FORCE_ON_SRAM_CLKGATE_FORCE_ON() uint32 {
	return (volatile.LoadUint32(&o.CLKGATE_FORCE_ON.Reg) & 0x3c) >> 2
}

// APB_CTRL.MEM_POWER_DOWN: APB_CTRL_MEM_POWER_DOWN_REG
func (o *APB_CTRL_Type) SetMEM_POWER_DOWN_ROM_POWER_DOWN(value uint32) {
	volatile.StoreUint32(&o.MEM_POWER_DOWN.Reg, volatile.LoadUint32(&o.MEM_POWER_DOWN.Reg)&^(0x3)|value)
}
func (o *APB_CTRL_Type) GetMEM_POWER_DOWN_ROM_POWER_DOWN() uint32 {
	return volatile.LoadUint32(&o.MEM_POWER_DOWN.Reg) & 0x3
}
func (o *APB_CTRL_Type) SetMEM_POWER_DOWN_SRAM_POWER_DOWN(value uint32) {
	volatile.StoreUint32(&o.MEM_POWER_DOWN.Reg, volatile.LoadUint32(&o.MEM_POWER_DOWN.Reg)&^(0x3c)|value<<2)
}
func (o *APB_CTRL_Type) GetMEM_POWER_DOWN_SRAM_POWER_DOWN() uint32 {
	return (volatile.LoadUint32(&o.MEM_POWER_DOWN.Reg) & 0x3c) >> 2
}

// APB_CTRL.MEM_POWER_UP: APB_CTRL_MEM_POWER_UP_REG
func (o *APB_CTRL_Type) SetMEM_POWER_UP_ROM_POWER_UP(value uint32) {
	volatile.StoreUint32(&o.MEM_POWER_UP.Reg, volatile.LoadUint32(&o.MEM_POWER_UP.Reg)&^(0x3)|value)
}
func (o *APB_CTRL_Type) GetMEM_POWER_UP_ROM_POWER_UP() uint32 {
	return volatile.LoadUint32(&o.MEM_POWER_UP.Reg) & 0x3
}
func (o *APB_CTRL_Type) SetMEM_POWER_UP_SRAM_POWER_UP(value uint32) {
	volatile.StoreUint32(&o.MEM_POWER_UP.Reg, volatile.LoadUint32(&o.MEM_POWER_UP.Reg)&^(0x3c)|value<<2)
}
func (o *APB_CTRL_Type) GetMEM_POWER_UP_SRAM_POWER_UP() uint32 {
	return (volatile.LoadUint32(&o.MEM_POWER_UP.Reg) & 0x3c) >> 2
}

// APB_CTRL.RND_DATA: APB_CTRL_RND_DATA_REG
func (o *APB_CTRL_Type) SetRND_DATA(value uint32) {
	volatile.StoreUint32(&o.RND_DATA.Reg, value)
}
func (o *APB_CTRL_Type) GetRND_DATA() uint32 {
	return volatile.LoadUint32(&o.RND_DATA.Reg)
}

// APB_CTRL.PERI_BACKUP_CONFIG: APB_CTRL_PERI_BACKUP_CONFIG_REG
func (o *APB_CTRL_Type) SetPERI_BACKUP_CONFIG_PERI_BACKUP_FLOW_ERR(value uint32) {
	volatile.StoreUint32(&o.PERI_BACKUP_CONFIG.Reg, volatile.LoadUint32(&o.PERI_BACKUP_CONFIG.Reg)&^(0x6)|value<<1)
}
func (o *APB_CTRL_Type) GetPERI_BACKUP_CONFIG_PERI_BACKUP_FLOW_ERR() uint32 {
	return (volatile.LoadUint32(&o.PERI_BACKUP_CONFIG.Reg) & 0x6) >> 1
}
func (o *APB_CTRL_Type) SetPERI_BACKUP_CONFIG_PERI_BACKUP_BURST_LIMIT(value uint32) {
	volatile.StoreUint32(&o.PERI_BACKUP_CONFIG.Reg, volatile.LoadUint32(&o.PERI_BACKUP_CONFIG.Reg)&^(0x1f0)|value<<4)
}
func (o *APB_CTRL_Type) GetPERI_BACKUP_CONFIG_PERI_BACKUP_BURST_LIMIT() uint32 {
	return (volatile.LoadUint32(&o.PERI_BACKUP_CONFIG.Reg) & 0x1f0) >> 4
}
func (o *APB_CTRL_Type) SetPERI_BACKUP_CONFIG_PERI_BACKUP_TOUT_THRES(value uint32) {
	volatile.StoreUint32(&o.PERI_BACKUP_CONFIG.Reg, volatile.LoadUint32(&o.PERI_BACKUP_CONFIG.Reg)&^(0x7fe00)|value<<9)
}
func (o *APB_CTRL_Type) GetPERI_BACKUP_CONFIG_PERI_BACKUP_TOUT_THRES() uint32 {
	return (volatile.LoadUint32(&o.PERI_BACKUP_CONFIG.Reg) & 0x7fe00) >> 9
}
func (o *APB_CTRL_Type) SetPERI_BACKUP_CONFIG_PERI_BACKUP_SIZE(value uint32) {
	volatile.StoreUint32(&o.PERI_BACKUP_CONFIG.Reg, volatile.LoadUint32(&o.PERI_BACKUP_CONFIG.Reg)&^(0x1ff80000)|value<<19)
}
func (o *APB_CTRL_Type) GetPERI_BACKUP_CONFIG_PERI_BACKUP_SIZE() uint32 {
	return (volatile.LoadUint32(&o.PERI_BACKUP_CONFIG.Reg) & 0x1ff80000) >> 19
}
func (o *APB_CTRL_Type) SetPERI_BACKUP_CONFIG_PERI_BACKUP_START(value uint32) {
	volatile.StoreUint32(&o.PERI_BACKUP_CONFIG.Reg, volatile.LoadUint32(&o.PERI_BACKUP_CONFIG.Reg)&^(0x20000000)|value<<29)
}
func (o *APB_CTRL_Type) GetPERI_BACKUP_CONFIG_PERI_BACKUP_START() uint32 {
	return (volatile.LoadUint32(&o.PERI_BACKUP_CONFIG.Reg) & 0x20000000) >> 29
}
func (o *APB_CTRL_Type) SetPERI_BACKUP_CONFIG_PERI_BACKUP_TO_MEM(value uint32) {
	volatile.StoreUint32(&o.PERI_BACKUP_CONFIG.Reg, volatile.LoadUint32(&o.PERI_BACKUP_CONFIG.Reg)&^(0x40000000)|value<<30)
}
func (o *APB_CTRL_Type) GetPERI_BACKUP_CONFIG_PERI_BACKUP_TO_MEM() uint32 {
	return (volatile.LoadUint32(&o.PERI_BACKUP_CONFIG.Reg) & 0x40000000) >> 30
}
func (o *APB_CTRL_Type) SetPERI_BACKUP_CONFIG_PERI_BACKUP_ENA(value uint32) {
	volatile.StoreUint32(&o.PERI_BACKUP_CONFIG.Reg, volatile.LoadUint32(&o.PERI_BACKUP_CONFIG.Reg)&^(0x80000000)|value<<31)
}
func (o *APB_CTRL_Type) GetPERI_BACKUP_CONFIG_PERI_BACKUP_ENA() uint32 {
	return (volatile.LoadUint32(&o.PERI_BACKUP_CONFIG.Reg) & 0x80000000) >> 31
}

// APB_CTRL.PERI_BACKUP_APB_ADDR: APB_CTRL_PERI_BACKUP_APB_ADDR_REG
func (o *APB_CTRL_Type) SetPERI_BACKUP_APB_ADDR(value uint32) {
	volatile.StoreUint32(&o.PERI_BACKUP_APB_ADDR.Reg, value)
}
func (o *APB_CTRL_Type) GetPERI_BACKUP_APB_ADDR() uint32 {
	return volatile.LoadUint32(&o.PERI_BACKUP_APB_ADDR.Reg)
}

// APB_CTRL.PERI_BACKUP_MEM_ADDR: APB_CTRL_PERI_BACKUP_MEM_ADDR_REG
func (o *APB_CTRL_Type) SetPERI_BACKUP_MEM_ADDR(value uint32) {
	volatile.StoreUint32(&o.PERI_BACKUP_MEM_ADDR.Reg, value)
}
func (o *APB_CTRL_Type) GetPERI_BACKUP_MEM_ADDR() uint32 {
	return volatile.LoadUint32(&o.PERI_BACKUP_MEM_ADDR.Reg)
}

// APB_CTRL.PERI_BACKUP_INT_RAW: APB_CTRL_PERI_BACKUP_INT_RAW_REG
func (o *APB_CTRL_Type) SetPERI_BACKUP_INT_RAW_PERI_BACKUP_DONE_INT_RAW(value uint32) {
	volatile.StoreUint32(&o.PERI_BACKUP_INT_RAW.Reg, volatile.LoadUint32(&o.PERI_BACKUP_INT_RAW.Reg)&^(0x1)|value)
}
func (o *APB_CTRL_Type) GetPERI_BACKUP_INT_RAW_PERI_BACKUP_DONE_INT_RAW() uint32 {
	return volatile.LoadUint32(&o.PERI_BACKUP_INT_RAW.Reg) & 0x1
}
func (o *APB_CTRL_Type) SetPERI_BACKUP_INT_RAW_PERI_BACKUP_ERR_INT_RAW(value uint32) {
	volatile.StoreUint32(&o.PERI_BACKUP_INT_RAW.Reg, volatile.LoadUint32(&o.PERI_BACKUP_INT_RAW.Reg)&^(0x2)|value<<1)
}
func (o *APB_CTRL_Type) GetPERI_BACKUP_INT_RAW_PERI_BACKUP_ERR_INT_RAW() uint32 {
	return (volatile.LoadUint32(&o.PERI_BACKUP_INT_RAW.Reg) & 0x2) >> 1
}

// APB_CTRL.PERI_BACKUP_INT_ST: APB_CTRL_PERI_BACKUP_INT_ST_REG
func (o *APB_CTRL_Type) SetPERI_BACKUP_INT_ST_PERI_BACKUP_DONE_INT_ST(value uint32) {
	volatile.StoreUint32(&o.PERI_BACKUP_INT_ST.Reg, volatile.LoadUint32(&o.PERI_BACKUP_INT_ST.Reg)&^(0x1)|value)
}
func (o *APB_CTRL_Type) GetPERI_BACKUP_INT_ST_PERI_BACKUP_DONE_INT_ST() uint32 {
	return volatile.LoadUint32(&o.PERI_BACKUP_INT_ST.Reg) & 0x1
}
func (o *APB_CTRL_Type) SetPERI_BACKUP_INT_ST_PERI_BACKUP_ERR_INT_ST(value uint32) {
	volatile.StoreUint32(&o.PERI_BACKUP_INT_ST.Reg, volatile.LoadUint32(&o.PERI_BACKUP_INT_ST.Reg)&^(0x2)|value<<1)
}
func (o *APB_CTRL_Type) GetPERI_BACKUP_INT_ST_PERI_BACKUP_ERR_INT_ST() uint32 {
	return (volatile.LoadUint32(&o.PERI_BACKUP_INT_ST.Reg) & 0x2) >> 1
}

// APB_CTRL.PERI_BACKUP_INT_ENA: APB_CTRL_PERI_BACKUP_INT_ENA_REG
func (o *APB_CTRL_Type) SetPERI_BACKUP_INT_ENA_PERI_BACKUP_DONE_INT_ENA(value uint32) {
	volatile.StoreUint32(&o.PERI_BACKUP_INT_ENA.Reg, volatile.LoadUint32(&o.PERI_BACKUP_INT_ENA.Reg)&^(0x1)|value)
}
func (o *APB_CTRL_Type) GetPERI_BACKUP_INT_ENA_PERI_BACKUP_DONE_INT_ENA() uint32 {
	return volatile.LoadUint32(&o.PERI_BACKUP_INT_ENA.Reg) & 0x1
}
func (o *APB_CTRL_Type) SetPERI_BACKUP_INT_ENA_PERI_BACKUP_ERR_INT_ENA(value uint32) {
	volatile.StoreUint32(&o.PERI_BACKUP_INT_ENA.Reg, volatile.LoadUint32(&o.PERI_BACKUP_INT_ENA.Reg)&^(0x2)|value<<1)
}
func (o *APB_CTRL_Type) GetPERI_BACKUP_INT_ENA_PERI_BACKUP_ERR_INT_ENA() uint32 {
	return (volatile.LoadUint32(&o.PERI_BACKUP_INT_ENA.Reg) & 0x2) >> 1
}

// APB_CTRL.PERI_BACKUP_INT_CLR: APB_CTRL_PERI_BACKUP_INT_CLR_REG
func (o *APB_CTRL_Type) SetPERI_BACKUP_INT_CLR_PERI_BACKUP_DONE_INT_CLR(value uint32) {
	volatile.StoreUint32(&o.PERI_BACKUP_INT_CLR.Reg, volatile.LoadUint32(&o.PERI_BACKUP_INT_CLR.Reg)&^(0x1)|value)
}
func (o *APB_CTRL_Type) GetPERI_BACKUP_INT_CLR_PERI_BACKUP_DONE_INT_CLR() uint32 {
	return volatile.LoadUint32(&o.PERI_BACKUP_INT_CLR.Reg) & 0x1
}
func (o *APB_CTRL_Type) SetPERI_BACKUP_INT_CLR_PERI_BACKUP_ERR_INT_CLR(value uint32) {
	volatile.StoreUint32(&o.PERI_BACKUP_INT_CLR.Reg, volatile.LoadUint32(&o.PERI_BACKUP_INT_CLR.Reg)&^(0x2)|value<<1)
}
func (o *APB_CTRL_Type) GetPERI_BACKUP_INT_CLR_PERI_BACKUP_ERR_INT_CLR() uint32 {
	return (volatile.LoadUint32(&o.PERI_BACKUP_INT_CLR.Reg) & 0x2) >> 1
}

// APB_CTRL.DATE: APB_CTRL_DATE_REG
func (o *APB_CTRL_Type) SetDATE(value uint32) {
	volatile.StoreUint32(&o.DATE.Reg, value)
}
func (o *APB_CTRL_Type) GetDATE() uint32 {
	return volatile.LoadUint32(&o.DATE.Reg)
}

// Peripheral APB_SARADC
type APB_SARADC_Type struct {
	CTRL            volatile.Register32 // 0x0
	CTRL2           volatile.Register32 // 0x4
	FILTER_CTRL1    volatile.Register32 // 0x8
	FSM_WAIT        volatile.Register32 // 0xC
	SAR1_STATUS     volatile.Register32 // 0x10
	SAR2_STATUS     volatile.Register32 // 0x14
	SAR_PATT_TAB1   volatile.Register32 // 0x18
	SAR_PATT_TAB2   volatile.Register32 // 0x1C
	ONETIME_SAMPLE  volatile.Register32 // 0x20
	ARB_CTRL        volatile.Register32 // 0x24
	FILTER_CTRL0    volatile.Register32 // 0x28
	SAR1DATA_STATUS volatile.Register32 // 0x2C
	SAR2DATA_STATUS volatile.Register32 // 0x30
	THRES0_CTRL     volatile.Register32 // 0x34
	THRES1_CTRL     volatile.Register32 // 0x38
	THRES_CTRL      volatile.Register32 // 0x3C
	INT_ENA         volatile.Register32 // 0x40
	INT_RAW         volatile.Register32 // 0x44
	INT_ST          volatile.Register32 // 0x48
	INT_CLR         volatile.Register32 // 0x4C
	DMA_CONF        volatile.Register32 // 0x50
	CLKM_CONF       volatile.Register32 // 0x54
	APB_TSENS_CTRL  volatile.Register32 // 0x58
	TSENS_CTRL2     volatile.Register32 // 0x5C
	CALI            volatile.Register32 // 0x60
	_               [920]byte
	CTRL_DATE       volatile.Register32 // 0x3FC
}

// APB_SARADC.CTRL: digital saradc configure register
func (o *APB_SARADC_Type) SetCTRL_SARADC_START_FORCE(value uint32) {
	volatile.StoreUint32(&o.CTRL.Reg, volatile.LoadUint32(&o.CTRL.Reg)&^(0x1)|value)
}
func (o *APB_SARADC_Type) GetCTRL_SARADC_START_FORCE() uint32 {
	return volatile.LoadUint32(&o.CTRL.Reg) & 0x1
}
func (o *APB_SARADC_Type) SetCTRL_SARADC_START(value uint32) {
	volatile.StoreUint32(&o.CTRL.Reg, volatile.LoadUint32(&o.CTRL.Reg)&^(0x2)|value<<1)
}
func (o *APB_SARADC_Type) GetCTRL_SARADC_START() uint32 {
	return (volatile.LoadUint32(&o.CTRL.Reg) & 0x2) >> 1
}
func (o *APB_SARADC_Type) SetCTRL_SARADC_SAR_CLK_GATED(value uint32) {
	volatile.StoreUint32(&o.CTRL.Reg, volatile.LoadUint32(&o.CTRL.Reg)&^(0x40)|value<<6)
}
func (o *APB_SARADC_Type) GetCTRL_SARADC_SAR_CLK_GATED() uint32 {
	return (volatile.LoadUint32(&o.CTRL.Reg) & 0x40) >> 6
}
func (o *APB_SARADC_Type) SetCTRL_SARADC_SAR_CLK_DIV(value uint32) {
	volatile.StoreUint32(&o.CTRL.Reg, volatile.LoadUint32(&o.CTRL.Reg)&^(0x7f80)|value<<7)
}
func (o *APB_SARADC_Type) GetCTRL_SARADC_SAR_CLK_DIV() uint32 {
	return (volatile.LoadUint32(&o.CTRL.Reg) & 0x7f80) >> 7
}
func (o *APB_SARADC_Type) SetCTRL_SARADC_SAR_PATT_LEN(value uint32) {
	volatile.StoreUint32(&o.CTRL.Reg, volatile.LoadUint32(&o.CTRL.Reg)&^(0x38000)|value<<15)
}
func (o *APB_SARADC_Type) GetCTRL_SARADC_SAR_PATT_LEN() uint32 {
	return (volatile.LoadUint32(&o.CTRL.Reg) & 0x38000) >> 15
}
func (o *APB_SARADC_Type) SetCTRL_SARADC_SAR_PATT_P_CLEAR(value uint32) {
	volatile.StoreUint32(&o.CTRL.Reg, volatile.LoadUint32(&o.CTRL.Reg)&^(0x800000)|value<<23)
}
func (o *APB_SARADC_Type) GetCTRL_SARADC_SAR_PATT_P_CLEAR() uint32 {
	return (volatile.LoadUint32(&o.CTRL.Reg) & 0x800000) >> 23
}
func (o *APB_SARADC_Type) SetCTRL_SARADC_XPD_SAR_FORCE(value uint32) {
	volatile.StoreUint32(&o.CTRL.Reg, volatile.LoadUint32(&o.CTRL.Reg)&^(0x18000000)|value<<27)
}
func (o *APB_SARADC_Type) GetCTRL_SARADC_XPD_SAR_FORCE() uint32 {
	return (volatile.LoadUint32(&o.CTRL.Reg) & 0x18000000) >> 27
}
func (o *APB_SARADC_Type) SetCTRL_SARADC_WAIT_ARB_CYCLE(value uint32) {
	volatile.StoreUint32(&o.CTRL.Reg, volatile.LoadUint32(&o.CTRL.Reg)&^(0xc0000000)|value<<30)
}
func (o *APB_SARADC_Type) GetCTRL_SARADC_WAIT_ARB_CYCLE() uint32 {
	return (volatile.LoadUint32(&o.CTRL.Reg) & 0xc0000000) >> 30
}

// APB_SARADC.CTRL2: digital saradc configure register
func (o *APB_SARADC_Type) SetCTRL2_SARADC_MEAS_NUM_LIMIT(value uint32) {
	volatile.StoreUint32(&o.CTRL2.Reg, volatile.LoadUint32(&o.CTRL2.Reg)&^(0x1)|value)
}
func (o *APB_SARADC_Type) GetCTRL2_SARADC_MEAS_NUM_LIMIT() uint32 {
	return volatile.LoadUint32(&o.CTRL2.Reg) & 0x1
}
func (o *APB_SARADC_Type) SetCTRL2_SARADC_MAX_MEAS_NUM(value uint32) {
	volatile.StoreUint32(&o.CTRL2.Reg, volatile.LoadUint32(&o.CTRL2.Reg)&^(0x1fe)|value<<1)
}
func (o *APB_SARADC_Type) GetCTRL2_SARADC_MAX_MEAS_NUM() uint32 {
	return (volatile.LoadUint32(&o.CTRL2.Reg) & 0x1fe) >> 1
}
func (o *APB_SARADC_Type) SetCTRL2_SARADC_SAR1_INV(value uint32) {
	volatile.StoreUint32(&o.CTRL2.Reg, volatile.LoadUint32(&o.CTRL2.Reg)&^(0x200)|value<<9)
}
func (o *APB_SARADC_Type) GetCTRL2_SARADC_SAR1_INV() uint32 {
	return (volatile.LoadUint32(&o.CTRL2.Reg) & 0x200) >> 9
}
func (o *APB_SARADC_Type) SetCTRL2_SARADC_SAR2_INV(value uint32) {
	volatile.StoreUint32(&o.CTRL2.Reg, volatile.LoadUint32(&o.CTRL2.Reg)&^(0x400)|value<<10)
}
func (o *APB_SARADC_Type) GetCTRL2_SARADC_SAR2_INV() uint32 {
	return (volatile.LoadUint32(&o.CTRL2.Reg) & 0x400) >> 10
}
func (o *APB_SARADC_Type) SetCTRL2_SARADC_TIMER_TARGET(value uint32) {
	volatile.StoreUint32(&o.CTRL2.Reg, volatile.LoadUint32(&o.CTRL2.Reg)&^(0xfff000)|value<<12)
}
func (o *APB_SARADC_Type) GetCTRL2_SARADC_TIMER_TARGET() uint32 {
	return (volatile.LoadUint32(&o.CTRL2.Reg) & 0xfff000) >> 12
}
func (o *APB_SARADC_Type) SetCTRL2_SARADC_TIMER_EN(value uint32) {
	volatile.StoreUint32(&o.CTRL2.Reg, volatile.LoadUint32(&o.CTRL2.Reg)&^(0x1000000)|value<<24)
}
func (o *APB_SARADC_Type) GetCTRL2_SARADC_TIMER_EN() uint32 {
	return (volatile.LoadUint32(&o.CTRL2.Reg) & 0x1000000) >> 24
}

// APB_SARADC.FILTER_CTRL1: digital saradc configure register
func (o *APB_SARADC_Type) SetFILTER_CTRL1_APB_SARADC_FILTER_FACTOR1(value uint32) {
	volatile.StoreUint32(&o.FILTER_CTRL1.Reg, volatile.LoadUint32(&o.FILTER_CTRL1.Reg)&^(0x1c000000)|value<<26)
}
func (o *APB_SARADC_Type) GetFILTER_CTRL1_APB_SARADC_FILTER_FACTOR1() uint32 {
	return (volatile.LoadUint32(&o.FILTER_CTRL1.Reg) & 0x1c000000) >> 26
}
func (o *APB_SARADC_Type) SetFILTER_CTRL1_APB_SARADC_FILTER_FACTOR0(value uint32) {
	volatile.StoreUint32(&o.FILTER_CTRL1.Reg, volatile.LoadUint32(&o.FILTER_CTRL1.Reg)&^(0xe0000000)|value<<29)
}
func (o *APB_SARADC_Type) GetFILTER_CTRL1_APB_SARADC_FILTER_FACTOR0() uint32 {
	return (volatile.LoadUint32(&o.FILTER_CTRL1.Reg) & 0xe0000000) >> 29
}

// APB_SARADC.FSM_WAIT: digital saradc configure register
func (o *APB_SARADC_Type) SetFSM_WAIT_SARADC_XPD_WAIT(value uint32) {
	volatile.StoreUint32(&o.FSM_WAIT.Reg, volatile.LoadUint32(&o.FSM_WAIT.Reg)&^(0xff)|value)
}
func (o *APB_SARADC_Type) GetFSM_WAIT_SARADC_XPD_WAIT() uint32 {
	return volatile.LoadUint32(&o.FSM_WAIT.Reg) & 0xff
}
func (o *APB_SARADC_Type) SetFSM_WAIT_SARADC_RSTB_WAIT(value uint32) {
	volatile.StoreUint32(&o.FSM_WAIT.Reg, volatile.LoadUint32(&o.FSM_WAIT.Reg)&^(0xff00)|value<<8)
}
func (o *APB_SARADC_Type) GetFSM_WAIT_SARADC_RSTB_WAIT() uint32 {
	return (volatile.LoadUint32(&o.FSM_WAIT.Reg) & 0xff00) >> 8
}
func (o *APB_SARADC_Type) SetFSM_WAIT_SARADC_STANDBY_WAIT(value uint32) {
	volatile.StoreUint32(&o.FSM_WAIT.Reg, volatile.LoadUint32(&o.FSM_WAIT.Reg)&^(0xff0000)|value<<16)
}
func (o *APB_SARADC_Type) GetFSM_WAIT_SARADC_STANDBY_WAIT() uint32 {
	return (volatile.LoadUint32(&o.FSM_WAIT.Reg) & 0xff0000) >> 16
}

// APB_SARADC.SAR1_STATUS: digital saradc configure register
func (o *APB_SARADC_Type) SetSAR1_STATUS(value uint32) {
	volatile.StoreUint32(&o.SAR1_STATUS.Reg, value)
}
func (o *APB_SARADC_Type) GetSAR1_STATUS() uint32 {
	return volatile.LoadUint32(&o.SAR1_STATUS.Reg)
}

// APB_SARADC.SAR2_STATUS: digital saradc configure register
func (o *APB_SARADC_Type) SetSAR2_STATUS(value uint32) {
	volatile.StoreUint32(&o.SAR2_STATUS.Reg, value)
}
func (o *APB_SARADC_Type) GetSAR2_STATUS() uint32 {
	return volatile.LoadUint32(&o.SAR2_STATUS.Reg)
}

// APB_SARADC.SAR_PATT_TAB1: digital saradc configure register
func (o *APB_SARADC_Type) SetSAR_PATT_TAB1_SARADC_SAR_PATT_TAB1(value uint32) {
	volatile.StoreUint32(&o.SAR_PATT_TAB1.Reg, volatile.LoadUint32(&o.SAR_PATT_TAB1.Reg)&^(0xffffff)|value)
}
func (o *APB_SARADC_Type) GetSAR_PATT_TAB1_SARADC_SAR_PATT_TAB1() uint32 {
	return volatile.LoadUint32(&o.SAR_PATT_TAB1.Reg) & 0xffffff
}

// APB_SARADC.SAR_PATT_TAB2: digital saradc configure register
func (o *APB_SARADC_Type) SetSAR_PATT_TAB2_SARADC_SAR_PATT_TAB2(value uint32) {
	volatile.StoreUint32(&o.SAR_PATT_TAB2.Reg, volatile.LoadUint32(&o.SAR_PATT_TAB2.Reg)&^(0xffffff)|value)
}
func (o *APB_SARADC_Type) GetSAR_PATT_TAB2_SARADC_SAR_PATT_TAB2() uint32 {
	return volatile.LoadUint32(&o.SAR_PATT_TAB2.Reg) & 0xffffff
}

// APB_SARADC.ONETIME_SAMPLE: digital saradc configure register
func (o *APB_SARADC_Type) SetONETIME_SAMPLE_SARADC_ONETIME_ATTEN(value uint32) {
	volatile.StoreUint32(&o.ONETIME_SAMPLE.Reg, volatile.LoadUint32(&o.ONETIME_SAMPLE.Reg)&^(0x1800000)|value<<23)
}
func (o *APB_SARADC_Type) GetONETIME_SAMPLE_SARADC_ONETIME_ATTEN() uint32 {
	return (volatile.LoadUint32(&o.ONETIME_SAMPLE.Reg) & 0x1800000) >> 23
}
func (o *APB_SARADC_Type) SetONETIME_SAMPLE_SARADC_ONETIME_CHANNEL(value uint32) {
	volatile.StoreUint32(&o.ONETIME_SAMPLE.Reg, volatile.LoadUint32(&o.ONETIME_SAMPLE.Reg)&^(0x1e000000)|value<<25)
}
func (o *APB_SARADC_Type) GetONETIME_SAMPLE_SARADC_ONETIME_CHANNEL() uint32 {
	return (volatile.LoadUint32(&o.ONETIME_SAMPLE.Reg) & 0x1e000000) >> 25
}
func (o *APB_SARADC_Type) SetONETIME_SAMPLE_SARADC_ONETIME_START(value uint32) {
	volatile.StoreUint32(&o.ONETIME_SAMPLE.Reg, volatile.LoadUint32(&o.ONETIME_SAMPLE.Reg)&^(0x20000000)|value<<29)
}
func (o *APB_SARADC_Type) GetONETIME_SAMPLE_SARADC_ONETIME_START() uint32 {
	return (volatile.LoadUint32(&o.ONETIME_SAMPLE.Reg) & 0x20000000) >> 29
}
func (o *APB_SARADC_Type) SetONETIME_SAMPLE_SARADC2_ONETIME_SAMPLE(value uint32) {
	volatile.StoreUint32(&o.ONETIME_SAMPLE.Reg, volatile.LoadUint32(&o.ONETIME_SAMPLE.Reg)&^(0x40000000)|value<<30)
}
func (o *APB_SARADC_Type) GetONETIME_SAMPLE_SARADC2_ONETIME_SAMPLE() uint32 {
	return (volatile.LoadUint32(&o.ONETIME_SAMPLE.Reg) & 0x40000000) >> 30
}
func (o *APB_SARADC_Type) SetONETIME_SAMPLE_SARADC1_ONETIME_SAMPLE(value uint32) {
	volatile.StoreUint32(&o.ONETIME_SAMPLE.Reg, volatile.LoadUint32(&o.ONETIME_SAMPLE.Reg)&^(0x80000000)|value<<31)
}
func (o *APB_SARADC_Type) GetONETIME_SAMPLE_SARADC1_ONETIME_SAMPLE() uint32 {
	return (volatile.LoadUint32(&o.ONETIME_SAMPLE.Reg) & 0x80000000) >> 31
}

// APB_SARADC.ARB_CTRL: digital saradc configure register
func (o *APB_SARADC_Type) SetARB_CTRL_ADC_ARB_APB_FORCE(value uint32) {
	volatile.StoreUint32(&o.ARB_CTRL.Reg, volatile.LoadUint32(&o.ARB_CTRL.Reg)&^(0x4)|value<<2)
}
func (o *APB_SARADC_Type) GetARB_CTRL_ADC_ARB_APB_FORCE() uint32 {
	return (volatile.LoadUint32(&o.ARB_CTRL.Reg) & 0x4) >> 2
}
func (o *APB_SARADC_Type) SetARB_CTRL_ADC_ARB_RTC_FORCE(value uint32) {
	volatile.StoreUint32(&o.ARB_CTRL.Reg, volatile.LoadUint32(&o.ARB_CTRL.Reg)&^(0x8)|value<<3)
}
func (o *APB_SARADC_Type) GetARB_CTRL_ADC_ARB_RTC_FORCE() uint32 {
	return (volatile.LoadUint32(&o.ARB_CTRL.Reg) & 0x8) >> 3
}
func (o *APB_SARADC_Type) SetARB_CTRL_ADC_ARB_WIFI_FORCE(value uint32) {
	volatile.StoreUint32(&o.ARB_CTRL.Reg, volatile.LoadUint32(&o.ARB_CTRL.Reg)&^(0x10)|value<<4)
}
func (o *APB_SARADC_Type) GetARB_CTRL_ADC_ARB_WIFI_FORCE() uint32 {
	return (volatile.LoadUint32(&o.ARB_CTRL.Reg) & 0x10) >> 4
}
func (o *APB_SARADC_Type) SetARB_CTRL_ADC_ARB_GRANT_FORCE(value uint32) {
	volatile.StoreUint32(&o.ARB_CTRL.Reg, volatile.LoadUint32(&o.ARB_CTRL.Reg)&^(0x20)|value<<5)
}
func (o *APB_SARADC_Type) GetARB_CTRL_ADC_ARB_GRANT_FORCE() uint32 {
	return (volatile.LoadUint32(&o.ARB_CTRL.Reg) & 0x20) >> 5
}
func (o *APB_SARADC_Type) SetARB_CTRL_ADC_ARB_APB_PRIORITY(value uint32) {
	volatile.StoreUint32(&o.ARB_CTRL.Reg, volatile.LoadUint32(&o.ARB_CTRL.Reg)&^(0xc0)|value<<6)
}
func (o *APB_SARADC_Type) GetARB_CTRL_ADC_ARB_APB_PRIORITY() uint32 {
	return (volatile.LoadUint32(&o.ARB_CTRL.Reg) & 0xc0) >> 6
}
func (o *APB_SARADC_Type) SetARB_CTRL_ADC_ARB_RTC_PRIORITY(value uint32) {
	volatile.StoreUint32(&o.ARB_CTRL.Reg, volatile.LoadUint32(&o.ARB_CTRL.Reg)&^(0x300)|value<<8)
}
func (o *APB_SARADC_Type) GetARB_CTRL_ADC_ARB_RTC_PRIORITY() uint32 {
	return (volatile.LoadUint32(&o.ARB_CTRL.Reg) & 0x300) >> 8
}
func (o *APB_SARADC_Type) SetARB_CTRL_ADC_ARB_WIFI_PRIORITY(value uint32) {
	volatile.StoreUint32(&o.ARB_CTRL.Reg, volatile.LoadUint32(&o.ARB_CTRL.Reg)&^(0xc00)|value<<10)
}
func (o *APB_SARADC_Type) GetARB_CTRL_ADC_ARB_WIFI_PRIORITY() uint32 {
	return (volatile.LoadUint32(&o.ARB_CTRL.Reg) & 0xc00) >> 10
}
func (o *APB_SARADC_Type) SetARB_CTRL_ADC_ARB_FIX_PRIORITY(value uint32) {
	volatile.StoreUint32(&o.ARB_CTRL.Reg, volatile.LoadUint32(&o.ARB_CTRL.Reg)&^(0x1000)|value<<12)
}
func (o *APB_SARADC_Type) GetARB_CTRL_ADC_ARB_FIX_PRIORITY() uint32 {
	return (volatile.LoadUint32(&o.ARB_CTRL.Reg) & 0x1000) >> 12
}

// APB_SARADC.FILTER_CTRL0: digital saradc configure register
func (o *APB_SARADC_Type) SetFILTER_CTRL0_APB_SARADC_FILTER_CHANNEL1(value uint32) {
	volatile.StoreUint32(&o.FILTER_CTRL0.Reg, volatile.LoadUint32(&o.FILTER_CTRL0.Reg)&^(0x3c0000)|value<<18)
}
func (o *APB_SARADC_Type) GetFILTER_CTRL0_APB_SARADC_FILTER_CHANNEL1() uint32 {
	return (volatile.LoadUint32(&o.FILTER_CTRL0.Reg) & 0x3c0000) >> 18
}
func (o *APB_SARADC_Type) SetFILTER_CTRL0_APB_SARADC_FILTER_CHANNEL0(value uint32) {
	volatile.StoreUint32(&o.FILTER_CTRL0.Reg, volatile.LoadUint32(&o.FILTER_CTRL0.Reg)&^(0x3c00000)|value<<22)
}
func (o *APB_SARADC_Type) GetFILTER_CTRL0_APB_SARADC_FILTER_CHANNEL0() uint32 {
	return (volatile.LoadUint32(&o.FILTER_CTRL0.Reg) & 0x3c00000) >> 22
}
func (o *APB_SARADC_Type) SetFILTER_CTRL0_APB_SARADC_FILTER_RESET(value uint32) {
	volatile.StoreUint32(&o.FILTER_CTRL0.Reg, volatile.LoadUint32(&o.FILTER_CTRL0.Reg)&^(0x80000000)|value<<31)
}
func (o *APB_SARADC_Type) GetFILTER_CTRL0_APB_SARADC_FILTER_RESET() uint32 {
	return (volatile.LoadUint32(&o.FILTER_CTRL0.Reg) & 0x80000000) >> 31
}

// APB_SARADC.SAR1DATA_STATUS: digital saradc configure register
func (o *APB_SARADC_Type) SetSAR1DATA_STATUS_APB_SARADC1_DATA(value uint32) {
	volatile.StoreUint32(&o.SAR1DATA_STATUS.Reg, volatile.LoadUint32(&o.SAR1DATA_STATUS.Reg)&^(0x1ffff)|value)
}
func (o *APB_SARADC_Type) GetSAR1DATA_STATUS_APB_SARADC1_DATA() uint32 {
	return volatile.LoadUint32(&o.SAR1DATA_STATUS.Reg) & 0x1ffff
}

// APB_SARADC.SAR2DATA_STATUS: digital saradc configure register
func (o *APB_SARADC_Type) SetSAR2DATA_STATUS_APB_SARADC2_DATA(value uint32) {
	volatile.StoreUint32(&o.SAR2DATA_STATUS.Reg, volatile.LoadUint32(&o.SAR2DATA_STATUS.Reg)&^(0x1ffff)|value)
}
func (o *APB_SARADC_Type) GetSAR2DATA_STATUS_APB_SARADC2_DATA() uint32 {
	return volatile.LoadUint32(&o.SAR2DATA_STATUS.Reg) & 0x1ffff
}

// APB_SARADC.THRES0_CTRL: digital saradc configure register
func (o *APB_SARADC_Type) SetTHRES0_CTRL_APB_SARADC_THRES0_CHANNEL(value uint32) {
	volatile.StoreUint32(&o.THRES0_CTRL.Reg, volatile.LoadUint32(&o.THRES0_CTRL.Reg)&^(0xf)|value)
}
func (o *APB_SARADC_Type) GetTHRES0_CTRL_APB_SARADC_THRES0_CHANNEL() uint32 {
	return volatile.LoadUint32(&o.THRES0_CTRL.Reg) & 0xf
}
func (o *APB_SARADC_Type) SetTHRES0_CTRL_APB_SARADC_THRES0_HIGH(value uint32) {
	volatile.StoreUint32(&o.THRES0_CTRL.Reg, volatile.LoadUint32(&o.THRES0_CTRL.Reg)&^(0x3ffe0)|value<<5)
}
func (o *APB_SARADC_Type) GetTHRES0_CTRL_APB_SARADC_THRES0_HIGH() uint32 {
	return (volatile.LoadUint32(&o.THRES0_CTRL.Reg) & 0x3ffe0) >> 5
}
func (o *APB_SARADC_Type) SetTHRES0_CTRL_APB_SARADC_THRES0_LOW(value uint32) {
	volatile.StoreUint32(&o.THRES0_CTRL.Reg, volatile.LoadUint32(&o.THRES0_CTRL.Reg)&^(0x7ffc0000)|value<<18)
}
func (o *APB_SARADC_Type) GetTHRES0_CTRL_APB_SARADC_THRES0_LOW() uint32 {
	return (volatile.LoadUint32(&o.THRES0_CTRL.Reg) & 0x7ffc0000) >> 18
}

// APB_SARADC.THRES1_CTRL: digital saradc configure register
func (o *APB_SARADC_Type) SetTHRES1_CTRL_APB_SARADC_THRES1_CHANNEL(value uint32) {
	volatile.StoreUint32(&o.THRES1_CTRL.Reg, volatile.LoadUint32(&o.THRES1_CTRL.Reg)&^(0xf)|value)
}
func (o *APB_SARADC_Type) GetTHRES1_CTRL_APB_SARADC_THRES1_CHANNEL() uint32 {
	return volatile.LoadUint32(&o.THRES1_CTRL.Reg) & 0xf
}
func (o *APB_SARADC_Type) SetTHRES1_CTRL_APB_SARADC_THRES1_HIGH(value uint32) {
	volatile.StoreUint32(&o.THRES1_CTRL.Reg, volatile.LoadUint32(&o.THRES1_CTRL.Reg)&^(0x3ffe0)|value<<5)
}
func (o *APB_SARADC_Type) GetTHRES1_CTRL_APB_SARADC_THRES1_HIGH() uint32 {
	return (volatile.LoadUint32(&o.THRES1_CTRL.Reg) & 0x3ffe0) >> 5
}
func (o *APB_SARADC_Type) SetTHRES1_CTRL_APB_SARADC_THRES1_LOW(value uint32) {
	volatile.StoreUint32(&o.THRES1_CTRL.Reg, volatile.LoadUint32(&o.THRES1_CTRL.Reg)&^(0x7ffc0000)|value<<18)
}
func (o *APB_SARADC_Type) GetTHRES1_CTRL_APB_SARADC_THRES1_LOW() uint32 {
	return (volatile.LoadUint32(&o.THRES1_CTRL.Reg) & 0x7ffc0000) >> 18
}

// APB_SARADC.THRES_CTRL: digital saradc configure register
func (o *APB_SARADC_Type) SetTHRES_CTRL_APB_SARADC_THRES_ALL_EN(value uint32) {
	volatile.StoreUint32(&o.THRES_CTRL.Reg, volatile.LoadUint32(&o.THRES_CTRL.Reg)&^(0x8000000)|value<<27)
}
func (o *APB_SARADC_Type) GetTHRES_CTRL_APB_SARADC_THRES_ALL_EN() uint32 {
	return (volatile.LoadUint32(&o.THRES_CTRL.Reg) & 0x8000000) >> 27
}
func (o *APB_SARADC_Type) SetTHRES_CTRL_APB_SARADC_THRES1_EN(value uint32) {
	volatile.StoreUint32(&o.THRES_CTRL.Reg, volatile.LoadUint32(&o.THRES_CTRL.Reg)&^(0x40000000)|value<<30)
}
func (o *APB_SARADC_Type) GetTHRES_CTRL_APB_SARADC_THRES1_EN() uint32 {
	return (volatile.LoadUint32(&o.THRES_CTRL.Reg) & 0x40000000) >> 30
}
func (o *APB_SARADC_Type) SetTHRES_CTRL_APB_SARADC_THRES0_EN(value uint32) {
	volatile.StoreUint32(&o.THRES_CTRL.Reg, volatile.LoadUint32(&o.THRES_CTRL.Reg)&^(0x80000000)|value<<31)
}
func (o *APB_SARADC_Type) GetTHRES_CTRL_APB_SARADC_THRES0_EN() uint32 {
	return (volatile.LoadUint32(&o.THRES_CTRL.Reg) & 0x80000000) >> 31
}

// APB_SARADC.INT_ENA: digital saradc int register
func (o *APB_SARADC_Type) SetINT_ENA_APB_SARADC_THRES1_LOW_INT_ENA(value uint32) {
	volatile.StoreUint32(&o.INT_ENA.Reg, volatile.LoadUint32(&o.INT_ENA.Reg)&^(0x4000000)|value<<26)
}
func (o *APB_SARADC_Type) GetINT_ENA_APB_SARADC_THRES1_LOW_INT_ENA() uint32 {
	return (volatile.LoadUint32(&o.INT_ENA.Reg) & 0x4000000) >> 26
}
func (o *APB_SARADC_Type) SetINT_ENA_APB_SARADC_THRES0_LOW_INT_ENA(value uint32) {
	volatile.StoreUint32(&o.INT_ENA.Reg, volatile.LoadUint32(&o.INT_ENA.Reg)&^(0x8000000)|value<<27)
}
func (o *APB_SARADC_Type) GetINT_ENA_APB_SARADC_THRES0_LOW_INT_ENA() uint32 {
	return (volatile.LoadUint32(&o.INT_ENA.Reg) & 0x8000000) >> 27
}
func (o *APB_SARADC_Type) SetINT_ENA_APB_SARADC_THRES1_HIGH_INT_ENA(value uint32) {
	volatile.StoreUint32(&o.INT_ENA.Reg, volatile.LoadUint32(&o.INT_ENA.Reg)&^(0x10000000)|value<<28)
}
func (o *APB_SARADC_Type) GetINT_ENA_APB_SARADC_THRES1_HIGH_INT_ENA() uint32 {
	return (volatile.LoadUint32(&o.INT_ENA.Reg) & 0x10000000) >> 28
}
func (o *APB_SARADC_Type) SetINT_ENA_APB_SARADC_THRES0_HIGH_INT_ENA(value uint32) {
	volatile.StoreUint32(&o.INT_ENA.Reg, volatile.LoadUint32(&o.INT_ENA.Reg)&^(0x20000000)|value<<29)
}
func (o *APB_SARADC_Type) GetINT_ENA_APB_SARADC_THRES0_HIGH_INT_ENA() uint32 {
	return (volatile.LoadUint32(&o.INT_ENA.Reg) & 0x20000000) >> 29
}
func (o *APB_SARADC_Type) SetINT_ENA_APB_SARADC2_DONE_INT_ENA(value uint32) {
	volatile.StoreUint32(&o.INT_ENA.Reg, volatile.LoadUint32(&o.INT_ENA.Reg)&^(0x40000000)|value<<30)
}
func (o *APB_SARADC_Type) GetINT_ENA_APB_SARADC2_DONE_INT_ENA() uint32 {
	return (volatile.LoadUint32(&o.INT_ENA.Reg) & 0x40000000) >> 30
}
func (o *APB_SARADC_Type) SetINT_ENA_APB_SARADC1_DONE_INT_ENA(value uint32) {
	volatile.StoreUint32(&o.INT_ENA.Reg, volatile.LoadUint32(&o.INT_ENA.Reg)&^(0x80000000)|value<<31)
}
func (o *APB_SARADC_Type) GetINT_ENA_APB_SARADC1_DONE_INT_ENA() uint32 {
	return (volatile.LoadUint32(&o.INT_ENA.Reg) & 0x80000000) >> 31
}

// APB_SARADC.INT_RAW: digital saradc int register
func (o *APB_SARADC_Type) SetINT_RAW_APB_SARADC_THRES1_LOW_INT_RAW(value uint32) {
	volatile.StoreUint32(&o.INT_RAW.Reg, volatile.LoadUint32(&o.INT_RAW.Reg)&^(0x4000000)|value<<26)
}
func (o *APB_SARADC_Type) GetINT_RAW_APB_SARADC_THRES1_LOW_INT_RAW() uint32 {
	return (volatile.LoadUint32(&o.INT_RAW.Reg) & 0x4000000) >> 26
}
func (o *APB_SARADC_Type) SetINT_RAW_APB_SARADC_THRES0_LOW_INT_RAW(value uint32) {
	volatile.StoreUint32(&o.INT_RAW.Reg, volatile.LoadUint32(&o.INT_RAW.Reg)&^(0x8000000)|value<<27)
}
func (o *APB_SARADC_Type) GetINT_RAW_APB_SARADC_THRES0_LOW_INT_RAW() uint32 {
	return (volatile.LoadUint32(&o.INT_RAW.Reg) & 0x8000000) >> 27
}
func (o *APB_SARADC_Type) SetINT_RAW_APB_SARADC_THRES1_HIGH_INT_RAW(value uint32) {
	volatile.StoreUint32(&o.INT_RAW.Reg, volatile.LoadUint32(&o.INT_RAW.Reg)&^(0x10000000)|value<<28)
}
func (o *APB_SARADC_Type) GetINT_RAW_APB_SARADC_THRES1_HIGH_INT_RAW() uint32 {
	return (volatile.LoadUint32(&o.INT_RAW.Reg) & 0x10000000) >> 28
}
func (o *APB_SARADC_Type) SetINT_RAW_APB_SARADC_THRES0_HIGH_INT_RAW(value uint32) {
	volatile.StoreUint32(&o.INT_RAW.Reg, volatile.LoadUint32(&o.INT_RAW.Reg)&^(0x20000000)|value<<29)
}
func (o *APB_SARADC_Type) GetINT_RAW_APB_SARADC_THRES0_HIGH_INT_RAW() uint32 {
	return (volatile.LoadUint32(&o.INT_RAW.Reg) & 0x20000000) >> 29
}
func (o *APB_SARADC_Type) SetINT_RAW_APB_SARADC2_DONE_INT_RAW(value uint32) {
	volatile.StoreUint32(&o.INT_RAW.Reg, volatile.LoadUint32(&o.INT_RAW.Reg)&^(0x40000000)|value<<30)
}
func (o *APB_SARADC_Type) GetINT_RAW_APB_SARADC2_DONE_INT_RAW() uint32 {
	return (volatile.LoadUint32(&o.INT_RAW.Reg) & 0x40000000) >> 30
}
func (o *APB_SARADC_Type) SetINT_RAW_APB_SARADC1_DONE_INT_RAW(value uint32) {
	volatile.StoreUint32(&o.INT_RAW.Reg, volatile.LoadUint32(&o.INT_RAW.Reg)&^(0x80000000)|value<<31)
}
func (o *APB_SARADC_Type) GetINT_RAW_APB_SARADC1_DONE_INT_RAW() uint32 {
	return (volatile.LoadUint32(&o.INT_RAW.Reg) & 0x80000000) >> 31
}

// APB_SARADC.INT_ST: digital saradc int register
func (o *APB_SARADC_Type) SetINT_ST_APB_SARADC_THRES1_LOW_INT_ST(value uint32) {
	volatile.StoreUint32(&o.INT_ST.Reg, volatile.LoadUint32(&o.INT_ST.Reg)&^(0x4000000)|value<<26)
}
func (o *APB_SARADC_Type) GetINT_ST_APB_SARADC_THRES1_LOW_INT_ST() uint32 {
	return (volatile.LoadUint32(&o.INT_ST.Reg) & 0x4000000) >> 26
}
func (o *APB_SARADC_Type) SetINT_ST_APB_SARADC_THRES0_LOW_INT_ST(value uint32) {
	volatile.StoreUint32(&o.INT_ST.Reg, volatile.LoadUint32(&o.INT_ST.Reg)&^(0x8000000)|value<<27)
}
func (o *APB_SARADC_Type) GetINT_ST_APB_SARADC_THRES0_LOW_INT_ST() uint32 {
	return (volatile.LoadUint32(&o.INT_ST.Reg) & 0x8000000) >> 27
}
func (o *APB_SARADC_Type) SetINT_ST_APB_SARADC_THRES1_HIGH_INT_ST(value uint32) {
	volatile.StoreUint32(&o.INT_ST.Reg, volatile.LoadUint32(&o.INT_ST.Reg)&^(0x10000000)|value<<28)
}
func (o *APB_SARADC_Type) GetINT_ST_APB_SARADC_THRES1_HIGH_INT_ST() uint32 {
	return (volatile.LoadUint32(&o.INT_ST.Reg) & 0x10000000) >> 28
}
func (o *APB_SARADC_Type) SetINT_ST_APB_SARADC_THRES0_HIGH_INT_ST(value uint32) {
	volatile.StoreUint32(&o.INT_ST.Reg, volatile.LoadUint32(&o.INT_ST.Reg)&^(0x20000000)|value<<29)
}
func (o *APB_SARADC_Type) GetINT_ST_APB_SARADC_THRES0_HIGH_INT_ST() uint32 {
	return (volatile.LoadUint32(&o.INT_ST.Reg) & 0x20000000) >> 29
}
func (o *APB_SARADC_Type) SetINT_ST_APB_SARADC2_DONE_INT_ST(value uint32) {
	volatile.StoreUint32(&o.INT_ST.Reg, volatile.LoadUint32(&o.INT_ST.Reg)&^(0x40000000)|value<<30)
}
func (o *APB_SARADC_Type) GetINT_ST_APB_SARADC2_DONE_INT_ST() uint32 {
	return (volatile.LoadUint32(&o.INT_ST.Reg) & 0x40000000) >> 30
}
func (o *APB_SARADC_Type) SetINT_ST_APB_SARADC1_DONE_INT_ST(value uint32) {
	volatile.StoreUint32(&o.INT_ST.Reg, volatile.LoadUint32(&o.INT_ST.Reg)&^(0x80000000)|value<<31)
}
func (o *APB_SARADC_Type) GetINT_ST_APB_SARADC1_DONE_INT_ST() uint32 {
	return (volatile.LoadUint32(&o.INT_ST.Reg) & 0x80000000) >> 31
}

// APB_SARADC.INT_CLR: digital saradc int register
func (o *APB_SARADC_Type) SetINT_CLR_APB_SARADC_THRES1_LOW_INT_CLR(value uint32) {
	volatile.StoreUint32(&o.INT_CLR.Reg, volatile.LoadUint32(&o.INT_CLR.Reg)&^(0x4000000)|value<<26)
}
func (o *APB_SARADC_Type) GetINT_CLR_APB_SARADC_THRES1_LOW_INT_CLR() uint32 {
	return (volatile.LoadUint32(&o.INT_CLR.Reg) & 0x4000000) >> 26
}
func (o *APB_SARADC_Type) SetINT_CLR_APB_SARADC_THRES0_LOW_INT_CLR(value uint32) {
	volatile.StoreUint32(&o.INT_CLR.Reg, volatile.LoadUint32(&o.INT_CLR.Reg)&^(0x8000000)|value<<27)
}
func (o *APB_SARADC_Type) GetINT_CLR_APB_SARADC_THRES0_LOW_INT_CLR() uint32 {
	return (volatile.LoadUint32(&o.INT_CLR.Reg) & 0x8000000) >> 27
}
func (o *APB_SARADC_Type) SetINT_CLR_APB_SARADC_THRES1_HIGH_INT_CLR(value uint32) {
	volatile.StoreUint32(&o.INT_CLR.Reg, volatile.LoadUint32(&o.INT_CLR.Reg)&^(0x10000000)|value<<28)
}
func (o *APB_SARADC_Type) GetINT_CLR_APB_SARADC_THRES1_HIGH_INT_CLR() uint32 {
	return (volatile.LoadUint32(&o.INT_CLR.Reg) & 0x10000000) >> 28
}
func (o *APB_SARADC_Type) SetINT_CLR_APB_SARADC_THRES0_HIGH_INT_CLR(value uint32) {
	volatile.StoreUint32(&o.INT_CLR.Reg, volatile.LoadUint32(&o.INT_CLR.Reg)&^(0x20000000)|value<<29)
}
func (o *APB_SARADC_Type) GetINT_CLR_APB_SARADC_THRES0_HIGH_INT_CLR() uint32 {
	return (volatile.LoadUint32(&o.INT_CLR.Reg) & 0x20000000) >> 29
}
func (o *APB_SARADC_Type) SetINT_CLR_APB_SARADC2_DONE_INT_CLR(value uint32) {
	volatile.StoreUint32(&o.INT_CLR.Reg, volatile.LoadUint32(&o.INT_CLR.Reg)&^(0x40000000)|value<<30)
}
func (o *APB_SARADC_Type) GetINT_CLR_APB_SARADC2_DONE_INT_CLR() uint32 {
	return (volatile.LoadUint32(&o.INT_CLR.Reg) & 0x40000000) >> 30
}
func (o *APB_SARADC_Type) SetINT_CLR_APB_SARADC1_DONE_INT_CLR(value uint32) {
	volatile.StoreUint32(&o.INT_CLR.Reg, volatile.LoadUint32(&o.INT_CLR.Reg)&^(0x80000000)|value<<31)
}
func (o *APB_SARADC_Type) GetINT_CLR_APB_SARADC1_DONE_INT_CLR() uint32 {
	return (volatile.LoadUint32(&o.INT_CLR.Reg) & 0x80000000) >> 31
}

// APB_SARADC.DMA_CONF: digital saradc configure register
func (o *APB_SARADC_Type) SetDMA_CONF_APB_ADC_EOF_NUM(value uint32) {
	volatile.StoreUint32(&o.DMA_CONF.Reg, volatile.LoadUint32(&o.DMA_CONF.Reg)&^(0xffff)|value)
}
func (o *APB_SARADC_Type) GetDMA_CONF_APB_ADC_EOF_NUM() uint32 {
	return volatile.LoadUint32(&o.DMA_CONF.Reg) & 0xffff
}
func (o *APB_SARADC_Type) SetDMA_CONF_APB_ADC_RESET_FSM(value uint32) {
	volatile.StoreUint32(&o.DMA_CONF.Reg, volatile.LoadUint32(&o.DMA_CONF.Reg)&^(0x40000000)|value<<30)
}
func (o *APB_SARADC_Type) GetDMA_CONF_APB_ADC_RESET_FSM() uint32 {
	return (volatile.LoadUint32(&o.DMA_CONF.Reg) & 0x40000000) >> 30
}
func (o *APB_SARADC_Type) SetDMA_CONF_APB_ADC_TRANS(value uint32) {
	volatile.StoreUint32(&o.DMA_CONF.Reg, volatile.LoadUint32(&o.DMA_CONF.Reg)&^(0x80000000)|value<<31)
}
func (o *APB_SARADC_Type) GetDMA_CONF_APB_ADC_TRANS() uint32 {
	return (volatile.LoadUint32(&o.DMA_CONF.Reg) & 0x80000000) >> 31
}

// APB_SARADC.CLKM_CONF: digital saradc configure register
func (o *APB_SARADC_Type) SetCLKM_CONF_CLKM_DIV_NUM(value uint32) {
	volatile.StoreUint32(&o.CLKM_CONF.Reg, volatile.LoadUint32(&o.CLKM_CONF.Reg)&^(0xff)|value)
}
func (o *APB_SARADC_Type) GetCLKM_CONF_CLKM_DIV_NUM() uint32 {
	return volatile.LoadUint32(&o.CLKM_CONF.Reg) & 0xff
}
func (o *APB_SARADC_Type) SetCLKM_CONF_CLKM_DIV_B(value uint32) {
	volatile.StoreUint32(&o.CLKM_CONF.Reg, volatile.LoadUint32(&o.CLKM_CONF.Reg)&^(0x3f00)|value<<8)
}
func (o *APB_SARADC_Type) GetCLKM_CONF_CLKM_DIV_B() uint32 {
	return (volatile.LoadUint32(&o.CLKM_CONF.Reg) & 0x3f00) >> 8
}
func (o *APB_SARADC_Type) SetCLKM_CONF_CLKM_DIV_A(value uint32) {
	volatile.StoreUint32(&o.CLKM_CONF.Reg, volatile.LoadUint32(&o.CLKM_CONF.Reg)&^(0xfc000)|value<<14)
}
func (o *APB_SARADC_Type) GetCLKM_CONF_CLKM_DIV_A() uint32 {
	return (volatile.LoadUint32(&o.CLKM_CONF.Reg) & 0xfc000) >> 14
}
func (o *APB_SARADC_Type) SetCLKM_CONF_CLK_EN(value uint32) {
	volatile.StoreUint32(&o.CLKM_CONF.Reg, volatile.LoadUint32(&o.CLKM_CONF.Reg)&^(0x100000)|value<<20)
}
func (o *APB_SARADC_Type) GetCLKM_CONF_CLK_EN() uint32 {
	return (volatile.LoadUint32(&o.CLKM_CONF.Reg) & 0x100000) >> 20
}
func (o *APB_SARADC_Type) SetCLKM_CONF_CLK_SEL(value uint32) {
	volatile.StoreUint32(&o.CLKM_CONF.Reg, volatile.LoadUint32(&o.CLKM_CONF.Reg)&^(0x600000)|value<<21)
}
func (o *APB_SARADC_Type) GetCLKM_CONF_CLK_SEL() uint32 {
	return (volatile.LoadUint32(&o.CLKM_CONF.Reg) & 0x600000) >> 21
}

// APB_SARADC.APB_TSENS_CTRL: digital tsens configure register
func (o *APB_SARADC_Type) SetAPB_TSENS_CTRL_TSENS_OUT(value uint32) {
	volatile.StoreUint32(&o.APB_TSENS_CTRL.Reg, volatile.LoadUint32(&o.APB_TSENS_CTRL.Reg)&^(0xff)|value)
}
func (o *APB_SARADC_Type) GetAPB_TSENS_CTRL_TSENS_OUT() uint32 {
	return volatile.LoadUint32(&o.APB_TSENS_CTRL.Reg) & 0xff
}
func (o *APB_SARADC_Type) SetAPB_TSENS_CTRL_TSENS_IN_INV(value uint32) {
	volatile.StoreUint32(&o.APB_TSENS_CTRL.Reg, volatile.LoadUint32(&o.APB_TSENS_CTRL.Reg)&^(0x2000)|value<<13)
}
func (o *APB_SARADC_Type) GetAPB_TSENS_CTRL_TSENS_IN_INV() uint32 {
	return (volatile.LoadUint32(&o.APB_TSENS_CTRL.Reg) & 0x2000) >> 13
}
func (o *APB_SARADC_Type) SetAPB_TSENS_CTRL_TSENS_CLK_DIV(value uint32) {
	volatile.StoreUint32(&o.APB_TSENS_CTRL.Reg, volatile.LoadUint32(&o.APB_TSENS_CTRL.Reg)&^(0x3fc000)|value<<14)
}
func (o *APB_SARADC_Type) GetAPB_TSENS_CTRL_TSENS_CLK_DIV() uint32 {
	return (volatile.LoadUint32(&o.APB_TSENS_CTRL.Reg) & 0x3fc000) >> 14
}
func (o *APB_SARADC_Type) SetAPB_TSENS_CTRL_TSENS_PU(value uint32) {
	volatile.StoreUint32(&o.APB_TSENS_CTRL.Reg, volatile.LoadUint32(&o.APB_TSENS_CTRL.Reg)&^(0x400000)|value<<22)
}
func (o *APB_SARADC_Type) GetAPB_TSENS_CTRL_TSENS_PU() uint32 {
	return (volatile.LoadUint32(&o.APB_TSENS_CTRL.Reg) & 0x400000) >> 22
}

// APB_SARADC.TSENS_CTRL2: digital tsens configure register
func (o *APB_SARADC_Type) SetTSENS_CTRL2_TSENS_XPD_WAIT(value uint32) {
	volatile.StoreUint32(&o.TSENS_CTRL2.Reg, volatile.LoadUint32(&o.TSENS_CTRL2.Reg)&^(0xfff)|value)
}
func (o *APB_SARADC_Type) GetTSENS_CTRL2_TSENS_XPD_WAIT() uint32 {
	return volatile.LoadUint32(&o.TSENS_CTRL2.Reg) & 0xfff
}
func (o *APB_SARADC_Type) SetTSENS_CTRL2_TSENS_XPD_FORCE(value uint32) {
	volatile.StoreUint32(&o.TSENS_CTRL2.Reg, volatile.LoadUint32(&o.TSENS_CTRL2.Reg)&^(0x3000)|value<<12)
}
func (o *APB_SARADC_Type) GetTSENS_CTRL2_TSENS_XPD_FORCE() uint32 {
	return (volatile.LoadUint32(&o.TSENS_CTRL2.Reg) & 0x3000) >> 12
}
func (o *APB_SARADC_Type) SetTSENS_CTRL2_TSENS_CLK_INV(value uint32) {
	volatile.StoreUint32(&o.TSENS_CTRL2.Reg, volatile.LoadUint32(&o.TSENS_CTRL2.Reg)&^(0x4000)|value<<14)
}
func (o *APB_SARADC_Type) GetTSENS_CTRL2_TSENS_CLK_INV() uint32 {
	return (volatile.LoadUint32(&o.TSENS_CTRL2.Reg) & 0x4000) >> 14
}
func (o *APB_SARADC_Type) SetTSENS_CTRL2_TSENS_CLK_SEL(value uint32) {
	volatile.StoreUint32(&o.TSENS_CTRL2.Reg, volatile.LoadUint32(&o.TSENS_CTRL2.Reg)&^(0x8000)|value<<15)
}
func (o *APB_SARADC_Type) GetTSENS_CTRL2_TSENS_CLK_SEL() uint32 {
	return (volatile.LoadUint32(&o.TSENS_CTRL2.Reg) & 0x8000) >> 15
}

// APB_SARADC.CALI: digital saradc configure register
func (o *APB_SARADC_Type) SetCALI_APB_SARADC_CALI_CFG(value uint32) {
	volatile.StoreUint32(&o.CALI.Reg, volatile.LoadUint32(&o.CALI.Reg)&^(0x1ffff)|value)
}
func (o *APB_SARADC_Type) GetCALI_APB_SARADC_CALI_CFG() uint32 {
	return volatile.LoadUint32(&o.CALI.Reg) & 0x1ffff
}

// APB_SARADC.CTRL_DATE: version
func (o *APB_SARADC_Type) SetCTRL_DATE(value uint32) {
	volatile.StoreUint32(&o.CTRL_DATE.Reg, value)
}
func (o *APB_SARADC_Type) GetCTRL_DATE() uint32 {
	return volatile.LoadUint32(&o.CTRL_DATE.Reg)
}

// Peripheral ASSIST_DEBUG
type ASSIST_DEBUG_Type struct {
	C0RE_0_MONTR_ENA                       volatile.Register32 // 0x0
	CORE_0_INTR_RAW                        volatile.Register32 // 0x4
	CORE_0_INTR_ENA                        volatile.Register32 // 0x8
	CORE_0_INTR_CLR                        volatile.Register32 // 0xC
	CORE_0_AREA_DRAM0_0_MIN                volatile.Register32 // 0x10
	CORE_0_AREA_DRAM0_0_MAX                volatile.Register32 // 0x14
	CORE_0_AREA_DRAM0_1_MIN                volatile.Register32 // 0x18
	CORE_0_AREA_DRAM0_1_MAX                volatile.Register32 // 0x1C
	CORE_0_AREA_PIF_0_MIN                  volatile.Register32 // 0x20
	CORE_0_AREA_PIF_0_MAX                  volatile.Register32 // 0x24
	CORE_0_AREA_PIF_1_MIN                  volatile.Register32 // 0x28
	CORE_0_AREA_PIF_1_MAX                  volatile.Register32 // 0x2C
	CORE_0_AREA_PC                         volatile.Register32 // 0x30
	CORE_0_AREA_SP                         volatile.Register32 // 0x34
	CORE_0_SP_MIN                          volatile.Register32 // 0x38
	CORE_0_SP_MAX                          volatile.Register32 // 0x3C
	CORE_0_SP_PC                           volatile.Register32 // 0x40
	CORE_0_RCD_EN                          volatile.Register32 // 0x44
	CORE_0_RCD_PDEBUGPC                    volatile.Register32 // 0x48
	CORE_0_RCD_PDEBUGSP                    volatile.Register32 // 0x4C
	CORE_0_IRAM0_EXCEPTION_MONITOR_0       volatile.Register32 // 0x50
	CORE_0_IRAM0_EXCEPTION_MONITOR_1       volatile.Register32 // 0x54
	CORE_0_DRAM0_EXCEPTION_MONITOR_0       volatile.Register32 // 0x58
	CORE_0_DRAM0_EXCEPTION_MONITOR_1       volatile.Register32 // 0x5C
	CORE_0_DRAM0_EXCEPTION_MONITOR_2       volatile.Register32 // 0x60
	CORE_0_DRAM0_EXCEPTION_MONITOR_3       volatile.Register32 // 0x64
	CORE_X_IRAM0_DRAM0_EXCEPTION_MONITOR_0 volatile.Register32 // 0x68
	CORE_X_IRAM0_DRAM0_EXCEPTION_MONITOR_1 volatile.Register32 // 0x6C
	LOG_SETTING                            volatile.Register32 // 0x70
	LOG_DATA_0                             volatile.Register32 // 0x74
	LOG_DATA_MASK                          volatile.Register32 // 0x78
	LOG_MIN                                volatile.Register32 // 0x7C
	LOG_MAX                                volatile.Register32 // 0x80
	LOG_MEM_START                          volatile.Register32 // 0x84
	LOG_MEM_END                            volatile.Register32 // 0x88
	LOG_MEM_WRITING_ADDR                   volatile.Register32 // 0x8C
	LOG_MEM_FULL_FLAG                      volatile.Register32 // 0x90
	C0RE_0_LASTPC_BEFORE_EXCEPTION         volatile.Register32 // 0x94
	C0RE_0_DEBUG_MODE                      volatile.Register32 // 0x98
	_                                      [352]byte
	DATE                                   volatile.Register32 // 0x1FC
}

// ASSIST_DEBUG.C0RE_0_MONTR_ENA: ASSIST_DEBUG_C0RE_0_MONTR_ENA_REG
func (o *ASSIST_DEBUG_Type) SetC0RE_0_MONTR_ENA_CORE_0_AREA_DRAM0_0_RD_ENA(value uint32) {
	volatile.StoreUint32(&o.C0RE_0_MONTR_ENA.Reg, volatile.LoadUint32(&o.C0RE_0_MONTR_ENA.Reg)&^(0x1)|value)
}
func (o *ASSIST_DEBUG_Type) GetC0RE_0_MONTR_ENA_CORE_0_AREA_DRAM0_0_RD_ENA() uint32 {
	return volatile.LoadUint32(&o.C0RE_0_MONTR_ENA.Reg) & 0x1
}
func (o *ASSIST_DEBUG_Type) SetC0RE_0_MONTR_ENA_CORE_0_AREA_DRAM0_0_WR_ENA(value uint32) {
	volatile.StoreUint32(&o.C0RE_0_MONTR_ENA.Reg, volatile.LoadUint32(&o.C0RE_0_MONTR_ENA.Reg)&^(0x2)|value<<1)
}
func (o *ASSIST_DEBUG_Type) GetC0RE_0_MONTR_ENA_CORE_0_AREA_DRAM0_0_WR_ENA() uint32 {
	return (volatile.LoadUint32(&o.C0RE_0_MONTR_ENA.Reg) & 0x2) >> 1
}
func (o *ASSIST_DEBUG_Type) SetC0RE_0_MONTR_ENA_CORE_0_AREA_DRAM0_1_RD_ENA(value uint32) {
	volatile.StoreUint32(&o.C0RE_0_MONTR_ENA.Reg, volatile.LoadUint32(&o.C0RE_0_MONTR_ENA.Reg)&^(0x4)|value<<2)
}
func (o *ASSIST_DEBUG_Type) GetC0RE_0_MONTR_ENA_CORE_0_AREA_DRAM0_1_RD_ENA() uint32 {
	return (volatile.LoadUint32(&o.C0RE_0_MONTR_ENA.Reg) & 0x4) >> 2
}
func (o *ASSIST_DEBUG_Type) SetC0RE_0_MONTR_ENA_CORE_0_AREA_DRAM0_1_WR_ENA(value uint32) {
	volatile.StoreUint32(&o.C0RE_0_MONTR_ENA.Reg, volatile.LoadUint32(&o.C0RE_0_MONTR_ENA.Reg)&^(0x8)|value<<3)
}
func (o *ASSIST_DEBUG_Type) GetC0RE_0_MONTR_ENA_CORE_0_AREA_DRAM0_1_WR_ENA() uint32 {
	return (volatile.LoadUint32(&o.C0RE_0_MONTR_ENA.Reg) & 0x8) >> 3
}
func (o *ASSIST_DEBUG_Type) SetC0RE_0_MONTR_ENA_CORE_0_AREA_PIF_0_RD_ENA(value uint32) {
	volatile.StoreUint32(&o.C0RE_0_MONTR_ENA.Reg, volatile.LoadUint32(&o.C0RE_0_MONTR_ENA.Reg)&^(0x10)|value<<4)
}
func (o *ASSIST_DEBUG_Type) GetC0RE_0_MONTR_ENA_CORE_0_AREA_PIF_0_RD_ENA() uint32 {
	return (volatile.LoadUint32(&o.C0RE_0_MONTR_ENA.Reg) & 0x10) >> 4
}
func (o *ASSIST_DEBUG_Type) SetC0RE_0_MONTR_ENA_CORE_0_AREA_PIF_0_WR_ENA(value uint32) {
	volatile.StoreUint32(&o.C0RE_0_MONTR_ENA.Reg, volatile.LoadUint32(&o.C0RE_0_MONTR_ENA.Reg)&^(0x20)|value<<5)
}
func (o *ASSIST_DEBUG_Type) GetC0RE_0_MONTR_ENA_CORE_0_AREA_PIF_0_WR_ENA() uint32 {
	return (volatile.LoadUint32(&o.C0RE_0_MONTR_ENA.Reg) & 0x20) >> 5
}
func (o *ASSIST_DEBUG_Type) SetC0RE_0_MONTR_ENA_CORE_0_AREA_PIF_1_RD_ENA(value uint32) {
	volatile.StoreUint32(&o.C0RE_0_MONTR_ENA.Reg, volatile.LoadUint32(&o.C0RE_0_MONTR_ENA.Reg)&^(0x40)|value<<6)
}
func (o *ASSIST_DEBUG_Type) GetC0RE_0_MONTR_ENA_CORE_0_AREA_PIF_1_RD_ENA() uint32 {
	return (volatile.LoadUint32(&o.C0RE_0_MONTR_ENA.Reg) & 0x40) >> 6
}
func (o *ASSIST_DEBUG_Type) SetC0RE_0_MONTR_ENA_CORE_0_AREA_PIF_1_WR_ENA(value uint32) {
	volatile.StoreUint32(&o.C0RE_0_MONTR_ENA.Reg, volatile.LoadUint32(&o.C0RE_0_MONTR_ENA.Reg)&^(0x80)|value<<7)
}
func (o *ASSIST_DEBUG_Type) GetC0RE_0_MONTR_ENA_CORE_0_AREA_PIF_1_WR_ENA() uint32 {
	return (volatile.LoadUint32(&o.C0RE_0_MONTR_ENA.Reg) & 0x80) >> 7
}
func (o *ASSIST_DEBUG_Type) SetC0RE_0_MONTR_ENA_CORE_0_SP_SPILL_MIN_ENA(value uint32) {
	volatile.StoreUint32(&o.C0RE_0_MONTR_ENA.Reg, volatile.LoadUint32(&o.C0RE_0_MONTR_ENA.Reg)&^(0x100)|value<<8)
}
func (o *ASSIST_DEBUG_Type) GetC0RE_0_MONTR_ENA_CORE_0_SP_SPILL_MIN_ENA() uint32 {
	return (volatile.LoadUint32(&o.C0RE_0_MONTR_ENA.Reg) & 0x100) >> 8
}
func (o *ASSIST_DEBUG_Type) SetC0RE_0_MONTR_ENA_CORE_0_SP_SPILL_MAX_ENA(value uint32) {
	volatile.StoreUint32(&o.C0RE_0_MONTR_ENA.Reg, volatile.LoadUint32(&o.C0RE_0_MONTR_ENA.Reg)&^(0x200)|value<<9)
}
func (o *ASSIST_DEBUG_Type) GetC0RE_0_MONTR_ENA_CORE_0_SP_SPILL_MAX_ENA() uint32 {
	return (volatile.LoadUint32(&o.C0RE_0_MONTR_ENA.Reg) & 0x200) >> 9
}
func (o *ASSIST_DEBUG_Type) SetC0RE_0_MONTR_ENA_CORE_0_IRAM0_EXCEPTION_MONITOR_ENA(value uint32) {
	volatile.StoreUint32(&o.C0RE_0_MONTR_ENA.Reg, volatile.LoadUint32(&o.C0RE_0_MONTR_ENA.Reg)&^(0x400)|value<<10)
}
func (o *ASSIST_DEBUG_Type) GetC0RE_0_MONTR_ENA_CORE_0_IRAM0_EXCEPTION_MONITOR_ENA() uint32 {
	return (volatile.LoadUint32(&o.C0RE_0_MONTR_ENA.Reg) & 0x400) >> 10
}
func (o *ASSIST_DEBUG_Type) SetC0RE_0_MONTR_ENA_CORE_0_DRAM0_EXCEPTION_MONITOR_ENA(value uint32) {
	volatile.StoreUint32(&o.C0RE_0_MONTR_ENA.Reg, volatile.LoadUint32(&o.C0RE_0_MONTR_ENA.Reg)&^(0x800)|value<<11)
}
func (o *ASSIST_DEBUG_Type) GetC0RE_0_MONTR_ENA_CORE_0_DRAM0_EXCEPTION_MONITOR_ENA() uint32 {
	return (volatile.LoadUint32(&o.C0RE_0_MONTR_ENA.Reg) & 0x800) >> 11
}

// ASSIST_DEBUG.CORE_0_INTR_RAW: ASSIST_DEBUG_CORE_0_INTR_RAW_REG
func (o *ASSIST_DEBUG_Type) SetCORE_0_INTR_RAW_CORE_0_AREA_DRAM0_0_RD_RAW(value uint32) {
	volatile.StoreUint32(&o.CORE_0_INTR_RAW.Reg, volatile.LoadUint32(&o.CORE_0_INTR_RAW.Reg)&^(0x1)|value)
}
func (o *ASSIST_DEBUG_Type) GetCORE_0_INTR_RAW_CORE_0_AREA_DRAM0_0_RD_RAW() uint32 {
	return volatile.LoadUint32(&o.CORE_0_INTR_RAW.Reg) & 0x1
}
func (o *ASSIST_DEBUG_Type) SetCORE_0_INTR_RAW_CORE_0_AREA_DRAM0_0_WR_RAW(value uint32) {
	volatile.StoreUint32(&o.CORE_0_INTR_RAW.Reg, volatile.LoadUint32(&o.CORE_0_INTR_RAW.Reg)&^(0x2)|value<<1)
}
func (o *ASSIST_DEBUG_Type) GetCORE_0_INTR_RAW_CORE_0_AREA_DRAM0_0_WR_RAW() uint32 {
	return (volatile.LoadUint32(&o.CORE_0_INTR_RAW.Reg) & 0x2) >> 1
}
func (o *ASSIST_DEBUG_Type) SetCORE_0_INTR_RAW_CORE_0_AREA_DRAM0_1_RD_RAW(value uint32) {
	volatile.StoreUint32(&o.CORE_0_INTR_RAW.Reg, volatile.LoadUint32(&o.CORE_0_INTR_RAW.Reg)&^(0x4)|value<<2)
}
func (o *ASSIST_DEBUG_Type) GetCORE_0_INTR_RAW_CORE_0_AREA_DRAM0_1_RD_RAW() uint32 {
	return (volatile.LoadUint32(&o.CORE_0_INTR_RAW.Reg) & 0x4) >> 2
}
func (o *ASSIST_DEBUG_Type) SetCORE_0_INTR_RAW_CORE_0_AREA_DRAM0_1_WR_RAW(value uint32) {
	volatile.StoreUint32(&o.CORE_0_INTR_RAW.Reg, volatile.LoadUint32(&o.CORE_0_INTR_RAW.Reg)&^(0x8)|value<<3)
}
func (o *ASSIST_DEBUG_Type) GetCORE_0_INTR_RAW_CORE_0_AREA_DRAM0_1_WR_RAW() uint32 {
	return (volatile.LoadUint32(&o.CORE_0_INTR_RAW.Reg) & 0x8) >> 3
}
func (o *ASSIST_DEBUG_Type) SetCORE_0_INTR_RAW_CORE_0_AREA_PIF_0_RD_RAW(value uint32) {
	volatile.StoreUint32(&o.CORE_0_INTR_RAW.Reg, volatile.LoadUint32(&o.CORE_0_INTR_RAW.Reg)&^(0x10)|value<<4)
}
func (o *ASSIST_DEBUG_Type) GetCORE_0_INTR_RAW_CORE_0_AREA_PIF_0_RD_RAW() uint32 {
	return (volatile.LoadUint32(&o.CORE_0_INTR_RAW.Reg) & 0x10) >> 4
}
func (o *ASSIST_DEBUG_Type) SetCORE_0_INTR_RAW_CORE_0_AREA_PIF_0_WR_RAW(value uint32) {
	volatile.StoreUint32(&o.CORE_0_INTR_RAW.Reg, volatile.LoadUint32(&o.CORE_0_INTR_RAW.Reg)&^(0x20)|value<<5)
}
func (o *ASSIST_DEBUG_Type) GetCORE_0_INTR_RAW_CORE_0_AREA_PIF_0_WR_RAW() uint32 {
	return (volatile.LoadUint32(&o.CORE_0_INTR_RAW.Reg) & 0x20) >> 5
}
func (o *ASSIST_DEBUG_Type) SetCORE_0_INTR_RAW_CORE_0_AREA_PIF_1_RD_RAW(value uint32) {
	volatile.StoreUint32(&o.CORE_0_INTR_RAW.Reg, volatile.LoadUint32(&o.CORE_0_INTR_RAW.Reg)&^(0x40)|value<<6)
}
func (o *ASSIST_DEBUG_Type) GetCORE_0_INTR_RAW_CORE_0_AREA_PIF_1_RD_RAW() uint32 {
	return (volatile.LoadUint32(&o.CORE_0_INTR_RAW.Reg) & 0x40) >> 6
}
func (o *ASSIST_DEBUG_Type) SetCORE_0_INTR_RAW_CORE_0_AREA_PIF_1_WR_RAW(value uint32) {
	volatile.StoreUint32(&o.CORE_0_INTR_RAW.Reg, volatile.LoadUint32(&o.CORE_0_INTR_RAW.Reg)&^(0x80)|value<<7)
}
func (o *ASSIST_DEBUG_Type) GetCORE_0_INTR_RAW_CORE_0_AREA_PIF_1_WR_RAW() uint32 {
	return (volatile.LoadUint32(&o.CORE_0_INTR_RAW.Reg) & 0x80) >> 7
}
func (o *ASSIST_DEBUG_Type) SetCORE_0_INTR_RAW_CORE_0_SP_SPILL_MIN_RAW(value uint32) {
	volatile.StoreUint32(&o.CORE_0_INTR_RAW.Reg, volatile.LoadUint32(&o.CORE_0_INTR_RAW.Reg)&^(0x100)|value<<8)
}
func (o *ASSIST_DEBUG_Type) GetCORE_0_INTR_RAW_CORE_0_SP_SPILL_MIN_RAW() uint32 {
	return (volatile.LoadUint32(&o.CORE_0_INTR_RAW.Reg) & 0x100) >> 8
}
func (o *ASSIST_DEBUG_Type) SetCORE_0_INTR_RAW_CORE_0_SP_SPILL_MAX_RAW(value uint32) {
	volatile.StoreUint32(&o.CORE_0_INTR_RAW.Reg, volatile.LoadUint32(&o.CORE_0_INTR_RAW.Reg)&^(0x200)|value<<9)
}
func (o *ASSIST_DEBUG_Type) GetCORE_0_INTR_RAW_CORE_0_SP_SPILL_MAX_RAW() uint32 {
	return (volatile.LoadUint32(&o.CORE_0_INTR_RAW.Reg) & 0x200) >> 9
}
func (o *ASSIST_DEBUG_Type) SetCORE_0_INTR_RAW_CORE_0_IRAM0_EXCEPTION_MONITOR_RAW(value uint32) {
	volatile.StoreUint32(&o.CORE_0_INTR_RAW.Reg, volatile.LoadUint32(&o.CORE_0_INTR_RAW.Reg)&^(0x400)|value<<10)
}
func (o *ASSIST_DEBUG_Type) GetCORE_0_INTR_RAW_CORE_0_IRAM0_EXCEPTION_MONITOR_RAW() uint32 {
	return (volatile.LoadUint32(&o.CORE_0_INTR_RAW.Reg) & 0x400) >> 10
}
func (o *ASSIST_DEBUG_Type) SetCORE_0_INTR_RAW_CORE_0_DRAM0_EXCEPTION_MONITOR_RAW(value uint32) {
	volatile.StoreUint32(&o.CORE_0_INTR_RAW.Reg, volatile.LoadUint32(&o.CORE_0_INTR_RAW.Reg)&^(0x800)|value<<11)
}
func (o *ASSIST_DEBUG_Type) GetCORE_0_INTR_RAW_CORE_0_DRAM0_EXCEPTION_MONITOR_RAW() uint32 {
	return (volatile.LoadUint32(&o.CORE_0_INTR_RAW.Reg) & 0x800) >> 11
}

// ASSIST_DEBUG.CORE_0_INTR_ENA: ASSIST_DEBUG_CORE_0_INTR_ENA_REG
func (o *ASSIST_DEBUG_Type) SetCORE_0_INTR_ENA_CORE_0_AREA_DRAM0_0_RD_INTR_ENA(value uint32) {
	volatile.StoreUint32(&o.CORE_0_INTR_ENA.Reg, volatile.LoadUint32(&o.CORE_0_INTR_ENA.Reg)&^(0x1)|value)
}
func (o *ASSIST_DEBUG_Type) GetCORE_0_INTR_ENA_CORE_0_AREA_DRAM0_0_RD_INTR_ENA() uint32 {
	return volatile.LoadUint32(&o.CORE_0_INTR_ENA.Reg) & 0x1
}
func (o *ASSIST_DEBUG_Type) SetCORE_0_INTR_ENA_CORE_0_AREA_DRAM0_0_WR_INTR_ENA(value uint32) {
	volatile.StoreUint32(&o.CORE_0_INTR_ENA.Reg, volatile.LoadUint32(&o.CORE_0_INTR_ENA.Reg)&^(0x2)|value<<1)
}
func (o *ASSIST_DEBUG_Type) GetCORE_0_INTR_ENA_CORE_0_AREA_DRAM0_0_WR_INTR_ENA() uint32 {
	return (volatile.LoadUint32(&o.CORE_0_INTR_ENA.Reg) & 0x2) >> 1
}
func (o *ASSIST_DEBUG_Type) SetCORE_0_INTR_ENA_CORE_0_AREA_DRAM0_1_RD_INTR_ENA(value uint32) {
	volatile.StoreUint32(&o.CORE_0_INTR_ENA.Reg, volatile.LoadUint32(&o.CORE_0_INTR_ENA.Reg)&^(0x4)|value<<2)
}
func (o *ASSIST_DEBUG_Type) GetCORE_0_INTR_ENA_CORE_0_AREA_DRAM0_1_RD_INTR_ENA() uint32 {
	return (volatile.LoadUint32(&o.CORE_0_INTR_ENA.Reg) & 0x4) >> 2
}
func (o *ASSIST_DEBUG_Type) SetCORE_0_INTR_ENA_CORE_0_AREA_DRAM0_1_WR_INTR_ENA(value uint32) {
	volatile.StoreUint32(&o.CORE_0_INTR_ENA.Reg, volatile.LoadUint32(&o.CORE_0_INTR_ENA.Reg)&^(0x8)|value<<3)
}
func (o *ASSIST_DEBUG_Type) GetCORE_0_INTR_ENA_CORE_0_AREA_DRAM0_1_WR_INTR_ENA() uint32 {
	return (volatile.LoadUint32(&o.CORE_0_INTR_ENA.Reg) & 0x8) >> 3
}
func (o *ASSIST_DEBUG_Type) SetCORE_0_INTR_ENA_CORE_0_AREA_PIF_0_RD_INTR_ENA(value uint32) {
	volatile.StoreUint32(&o.CORE_0_INTR_ENA.Reg, volatile.LoadUint32(&o.CORE_0_INTR_ENA.Reg)&^(0x10)|value<<4)
}
func (o *ASSIST_DEBUG_Type) GetCORE_0_INTR_ENA_CORE_0_AREA_PIF_0_RD_INTR_ENA() uint32 {
	return (volatile.LoadUint32(&o.CORE_0_INTR_ENA.Reg) & 0x10) >> 4
}
func (o *ASSIST_DEBUG_Type) SetCORE_0_INTR_ENA_CORE_0_AREA_PIF_0_WR_INTR_ENA(value uint32) {
	volatile.StoreUint32(&o.CORE_0_INTR_ENA.Reg, volatile.LoadUint32(&o.CORE_0_INTR_ENA.Reg)&^(0x20)|value<<5)
}
func (o *ASSIST_DEBUG_Type) GetCORE_0_INTR_ENA_CORE_0_AREA_PIF_0_WR_INTR_ENA() uint32 {
	return (volatile.LoadUint32(&o.CORE_0_INTR_ENA.Reg) & 0x20) >> 5
}
func (o *ASSIST_DEBUG_Type) SetCORE_0_INTR_ENA_CORE_0_AREA_PIF_1_RD_INTR_ENA(value uint32) {
	volatile.StoreUint32(&o.CORE_0_INTR_ENA.Reg, volatile.LoadUint32(&o.CORE_0_INTR_ENA.Reg)&^(0x40)|value<<6)
}
func (o *ASSIST_DEBUG_Type) GetCORE_0_INTR_ENA_CORE_0_AREA_PIF_1_RD_INTR_ENA() uint32 {
	return (volatile.LoadUint32(&o.CORE_0_INTR_ENA.Reg) & 0x40) >> 6
}
func (o *ASSIST_DEBUG_Type) SetCORE_0_INTR_ENA_CORE_0_AREA_PIF_1_WR_INTR_ENA(value uint32) {
	volatile.StoreUint32(&o.CORE_0_INTR_ENA.Reg, volatile.LoadUint32(&o.CORE_0_INTR_ENA.Reg)&^(0x80)|value<<7)
}
func (o *ASSIST_DEBUG_Type) GetCORE_0_INTR_ENA_CORE_0_AREA_PIF_1_WR_INTR_ENA() uint32 {
	return (volatile.LoadUint32(&o.CORE_0_INTR_ENA.Reg) & 0x80) >> 7
}
func (o *ASSIST_DEBUG_Type) SetCORE_0_INTR_ENA_CORE_0_SP_SPILL_MIN_INTR_ENA(value uint32) {
	volatile.StoreUint32(&o.CORE_0_INTR_ENA.Reg, volatile.LoadUint32(&o.CORE_0_INTR_ENA.Reg)&^(0x100)|value<<8)
}
func (o *ASSIST_DEBUG_Type) GetCORE_0_INTR_ENA_CORE_0_SP_SPILL_MIN_INTR_ENA() uint32 {
	return (volatile.LoadUint32(&o.CORE_0_INTR_ENA.Reg) & 0x100) >> 8
}
func (o *ASSIST_DEBUG_Type) SetCORE_0_INTR_ENA_CORE_0_SP_SPILL_MAX_INTR_ENA(value uint32) {
	volatile.StoreUint32(&o.CORE_0_INTR_ENA.Reg, volatile.LoadUint32(&o.CORE_0_INTR_ENA.Reg)&^(0x200)|value<<9)
}
func (o *ASSIST_DEBUG_Type) GetCORE_0_INTR_ENA_CORE_0_SP_SPILL_MAX_INTR_ENA() uint32 {
	return (volatile.LoadUint32(&o.CORE_0_INTR_ENA.Reg) & 0x200) >> 9
}
func (o *ASSIST_DEBUG_Type) SetCORE_0_INTR_ENA_CORE_0_IRAM0_EXCEPTION_MONITOR_RLS(value uint32) {
	volatile.StoreUint32(&o.CORE_0_INTR_ENA.Reg, volatile.LoadUint32(&o.CORE_0_INTR_ENA.Reg)&^(0x400)|value<<10)
}
func (o *ASSIST_DEBUG_Type) GetCORE_0_INTR_ENA_CORE_0_IRAM0_EXCEPTION_MONITOR_RLS() uint32 {
	return (volatile.LoadUint32(&o.CORE_0_INTR_ENA.Reg) & 0x400) >> 10
}
func (o *ASSIST_DEBUG_Type) SetCORE_0_INTR_ENA_CORE_0_DRAM0_EXCEPTION_MONITOR_RLS(value uint32) {
	volatile.StoreUint32(&o.CORE_0_INTR_ENA.Reg, volatile.LoadUint32(&o.CORE_0_INTR_ENA.Reg)&^(0x800)|value<<11)
}
func (o *ASSIST_DEBUG_Type) GetCORE_0_INTR_ENA_CORE_0_DRAM0_EXCEPTION_MONITOR_RLS() uint32 {
	return (volatile.LoadUint32(&o.CORE_0_INTR_ENA.Reg) & 0x800) >> 11
}

// ASSIST_DEBUG.CORE_0_INTR_CLR: ASSIST_DEBUG_CORE_0_INTR_CLR_REG
func (o *ASSIST_DEBUG_Type) SetCORE_0_INTR_CLR_CORE_0_AREA_DRAM0_0_RD_CLR(value uint32) {
	volatile.StoreUint32(&o.CORE_0_INTR_CLR.Reg, volatile.LoadUint32(&o.CORE_0_INTR_CLR.Reg)&^(0x1)|value)
}
func (o *ASSIST_DEBUG_Type) GetCORE_0_INTR_CLR_CORE_0_AREA_DRAM0_0_RD_CLR() uint32 {
	return volatile.LoadUint32(&o.CORE_0_INTR_CLR.Reg) & 0x1
}
func (o *ASSIST_DEBUG_Type) SetCORE_0_INTR_CLR_CORE_0_AREA_DRAM0_0_WR_CLR(value uint32) {
	volatile.StoreUint32(&o.CORE_0_INTR_CLR.Reg, volatile.LoadUint32(&o.CORE_0_INTR_CLR.Reg)&^(0x2)|value<<1)
}
func (o *ASSIST_DEBUG_Type) GetCORE_0_INTR_CLR_CORE_0_AREA_DRAM0_0_WR_CLR() uint32 {
	return (volatile.LoadUint32(&o.CORE_0_INTR_CLR.Reg) & 0x2) >> 1
}
func (o *ASSIST_DEBUG_Type) SetCORE_0_INTR_CLR_CORE_0_AREA_DRAM0_1_RD_CLR(value uint32) {
	volatile.StoreUint32(&o.CORE_0_INTR_CLR.Reg, volatile.LoadUint32(&o.CORE_0_INTR_CLR.Reg)&^(0x4)|value<<2)
}
func (o *ASSIST_DEBUG_Type) GetCORE_0_INTR_CLR_CORE_0_AREA_DRAM0_1_RD_CLR() uint32 {
	return (volatile.LoadUint32(&o.CORE_0_INTR_CLR.Reg) & 0x4) >> 2
}
func (o *ASSIST_DEBUG_Type) SetCORE_0_INTR_CLR_CORE_0_AREA_DRAM0_1_WR_CLR(value uint32) {
	volatile.StoreUint32(&o.CORE_0_INTR_CLR.Reg, volatile.LoadUint32(&o.CORE_0_INTR_CLR.Reg)&^(0x8)|value<<3)
}
func (o *ASSIST_DEBUG_Type) GetCORE_0_INTR_CLR_CORE_0_AREA_DRAM0_1_WR_CLR() uint32 {
	return (volatile.LoadUint32(&o.CORE_0_INTR_CLR.Reg) & 0x8) >> 3
}
func (o *ASSIST_DEBUG_Type) SetCORE_0_INTR_CLR_CORE_0_AREA_PIF_0_RD_CLR(value uint32) {
	volatile.StoreUint32(&o.CORE_0_INTR_CLR.Reg, volatile.LoadUint32(&o.CORE_0_INTR_CLR.Reg)&^(0x10)|value<<4)
}
func (o *ASSIST_DEBUG_Type) GetCORE_0_INTR_CLR_CORE_0_AREA_PIF_0_RD_CLR() uint32 {
	return (volatile.LoadUint32(&o.CORE_0_INTR_CLR.Reg) & 0x10) >> 4
}
func (o *ASSIST_DEBUG_Type) SetCORE_0_INTR_CLR_CORE_0_AREA_PIF_0_WR_CLR(value uint32) {
	volatile.StoreUint32(&o.CORE_0_INTR_CLR.Reg, volatile.LoadUint32(&o.CORE_0_INTR_CLR.Reg)&^(0x20)|value<<5)
}
func (o *ASSIST_DEBUG_Type) GetCORE_0_INTR_CLR_CORE_0_AREA_PIF_0_WR_CLR() uint32 {
	return (volatile.LoadUint32(&o.CORE_0_INTR_CLR.Reg) & 0x20) >> 5
}
func (o *ASSIST_DEBUG_Type) SetCORE_0_INTR_CLR_CORE_0_AREA_PIF_1_RD_CLR(value uint32) {
	volatile.StoreUint32(&o.CORE_0_INTR_CLR.Reg, volatile.LoadUint32(&o.CORE_0_INTR_CLR.Reg)&^(0x40)|value<<6)
}
func (o *ASSIST_DEBUG_Type) GetCORE_0_INTR_CLR_CORE_0_AREA_PIF_1_RD_CLR() uint32 {
	return (volatile.LoadUint32(&o.CORE_0_INTR_CLR.Reg) & 0x40) >> 6
}
func (o *ASSIST_DEBUG_Type) SetCORE_0_INTR_CLR_CORE_0_AREA_PIF_1_WR_CLR(value uint32) {
	volatile.StoreUint32(&o.CORE_0_INTR_CLR.Reg, volatile.LoadUint32(&o.CORE_0_INTR_CLR.Reg)&^(0x80)|value<<7)
}
func (o *ASSIST_DEBUG_Type) GetCORE_0_INTR_CLR_CORE_0_AREA_PIF_1_WR_CLR() uint32 {
	return (volatile.LoadUint32(&o.CORE_0_INTR_CLR.Reg) & 0x80) >> 7
}
func (o *ASSIST_DEBUG_Type) SetCORE_0_INTR_CLR_CORE_0_SP_SPILL_MIN_CLR(value uint32) {
	volatile.StoreUint32(&o.CORE_0_INTR_CLR.Reg, volatile.LoadUint32(&o.CORE_0_INTR_CLR.Reg)&^(0x100)|value<<8)
}
func (o *ASSIST_DEBUG_Type) GetCORE_0_INTR_CLR_CORE_0_SP_SPILL_MIN_CLR() uint32 {
	return (volatile.LoadUint32(&o.CORE_0_INTR_CLR.Reg) & 0x100) >> 8
}
func (o *ASSIST_DEBUG_Type) SetCORE_0_INTR_CLR_CORE_0_SP_SPILL_MAX_CLR(value uint32) {
	volatile.StoreUint32(&o.CORE_0_INTR_CLR.Reg, volatile.LoadUint32(&o.CORE_0_INTR_CLR.Reg)&^(0x200)|value<<9)
}
func (o *ASSIST_DEBUG_Type) GetCORE_0_INTR_CLR_CORE_0_SP_SPILL_MAX_CLR() uint32 {
	return (volatile.LoadUint32(&o.CORE_0_INTR_CLR.Reg) & 0x200) >> 9
}
func (o *ASSIST_DEBUG_Type) SetCORE_0_INTR_CLR_CORE_0_IRAM0_EXCEPTION_MONITOR_CLR(value uint32) {
	volatile.StoreUint32(&o.CORE_0_INTR_CLR.Reg, volatile.LoadUint32(&o.CORE_0_INTR_CLR.Reg)&^(0x400)|value<<10)
}
func (o *ASSIST_DEBUG_Type) GetCORE_0_INTR_CLR_CORE_0_IRAM0_EXCEPTION_MONITOR_CLR() uint32 {
	return (volatile.LoadUint32(&o.CORE_0_INTR_CLR.Reg) & 0x400) >> 10
}
func (o *ASSIST_DEBUG_Type) SetCORE_0_INTR_CLR_CORE_0_DRAM0_EXCEPTION_MONITOR_CLR(value uint32) {
	volatile.StoreUint32(&o.CORE_0_INTR_CLR.Reg, volatile.LoadUint32(&o.CORE_0_INTR_CLR.Reg)&^(0x800)|value<<11)
}
func (o *ASSIST_DEBUG_Type) GetCORE_0_INTR_CLR_CORE_0_DRAM0_EXCEPTION_MONITOR_CLR() uint32 {
	return (volatile.LoadUint32(&o.CORE_0_INTR_CLR.Reg) & 0x800) >> 11
}

// ASSIST_DEBUG.CORE_0_AREA_DRAM0_0_MIN: ASSIST_DEBUG_CORE_0_AREA_DRAM0_0_MIN_REG
func (o *ASSIST_DEBUG_Type) SetCORE_0_AREA_DRAM0_0_MIN(value uint32) {
	volatile.StoreUint32(&o.CORE_0_AREA_DRAM0_0_MIN.Reg, value)
}
func (o *ASSIST_DEBUG_Type) GetCORE_0_AREA_DRAM0_0_MIN() uint32 {
	return volatile.LoadUint32(&o.CORE_0_AREA_DRAM0_0_MIN.Reg)
}

// ASSIST_DEBUG.CORE_0_AREA_DRAM0_0_MAX: ASSIST_DEBUG_CORE_0_AREA_DRAM0_0_MAX_REG
func (o *ASSIST_DEBUG_Type) SetCORE_0_AREA_DRAM0_0_MAX(value uint32) {
	volatile.StoreUint32(&o.CORE_0_AREA_DRAM0_0_MAX.Reg, value)
}
func (o *ASSIST_DEBUG_Type) GetCORE_0_AREA_DRAM0_0_MAX() uint32 {
	return volatile.LoadUint32(&o.CORE_0_AREA_DRAM0_0_MAX.Reg)
}

// ASSIST_DEBUG.CORE_0_AREA_DRAM0_1_MIN: ASSIST_DEBUG_CORE_0_AREA_DRAM0_1_MIN_REG
func (o *ASSIST_DEBUG_Type) SetCORE_0_AREA_DRAM0_1_MIN(value uint32) {
	volatile.StoreUint32(&o.CORE_0_AREA_DRAM0_1_MIN.Reg, value)
}
func (o *ASSIST_DEBUG_Type) GetCORE_0_AREA_DRAM0_1_MIN() uint32 {
	return volatile.LoadUint32(&o.CORE_0_AREA_DRAM0_1_MIN.Reg)
}

// ASSIST_DEBUG.CORE_0_AREA_DRAM0_1_MAX: ASSIST_DEBUG_CORE_0_AREA_DRAM0_1_MAX_REG
func (o *ASSIST_DEBUG_Type) SetCORE_0_AREA_DRAM0_1_MAX(value uint32) {
	volatile.StoreUint32(&o.CORE_0_AREA_DRAM0_1_MAX.Reg, value)
}
func (o *ASSIST_DEBUG_Type) GetCORE_0_AREA_DRAM0_1_MAX() uint32 {
	return volatile.LoadUint32(&o.CORE_0_AREA_DRAM0_1_MAX.Reg)
}

// ASSIST_DEBUG.CORE_0_AREA_PIF_0_MIN: ASSIST_DEBUG_CORE_0_AREA_PIF_0_MIN_REG
func (o *ASSIST_DEBUG_Type) SetCORE_0_AREA_PIF_0_MIN(value uint32) {
	volatile.StoreUint32(&o.CORE_0_AREA_PIF_0_MIN.Reg, value)
}
func (o *ASSIST_DEBUG_Type) GetCORE_0_AREA_PIF_0_MIN() uint32 {
	return volatile.LoadUint32(&o.CORE_0_AREA_PIF_0_MIN.Reg)
}

// ASSIST_DEBUG.CORE_0_AREA_PIF_0_MAX: ASSIST_DEBUG_CORE_0_AREA_PIF_0_MAX_REG
func (o *ASSIST_DEBUG_Type) SetCORE_0_AREA_PIF_0_MAX(value uint32) {
	volatile.StoreUint32(&o.CORE_0_AREA_PIF_0_MAX.Reg, value)
}
func (o *ASSIST_DEBUG_Type) GetCORE_0_AREA_PIF_0_MAX() uint32 {
	return volatile.LoadUint32(&o.CORE_0_AREA_PIF_0_MAX.Reg)
}

// ASSIST_DEBUG.CORE_0_AREA_PIF_1_MIN: ASSIST_DEBUG_CORE_0_AREA_PIF_1_MIN_REG
func (o *ASSIST_DEBUG_Type) SetCORE_0_AREA_PIF_1_MIN(value uint32) {
	volatile.StoreUint32(&o.CORE_0_AREA_PIF_1_MIN.Reg, value)
}
func (o *ASSIST_DEBUG_Type) GetCORE_0_AREA_PIF_1_MIN() uint32 {
	return volatile.LoadUint32(&o.CORE_0_AREA_PIF_1_MIN.Reg)
}

// ASSIST_DEBUG.CORE_0_AREA_PIF_1_MAX: ASSIST_DEBUG_CORE_0_AREA_PIF_1_MAX_REG
func (o *ASSIST_DEBUG_Type) SetCORE_0_AREA_PIF_1_MAX(value uint32) {
	volatile.StoreUint32(&o.CORE_0_AREA_PIF_1_MAX.Reg, value)
}
func (o *ASSIST_DEBUG_Type) GetCORE_0_AREA_PIF_1_MAX() uint32 {
	return volatile.LoadUint32(&o.CORE_0_AREA_PIF_1_MAX.Reg)
}

// ASSIST_DEBUG.CORE_0_AREA_PC: ASSIST_DEBUG_CORE_0_AREA_PC_REG
func (o *ASSIST_DEBUG_Type) SetCORE_0_AREA_PC(value uint32) {
	volatile.StoreUint32(&o.CORE_0_AREA_PC.Reg, value)
}
func (o *ASSIST_DEBUG_Type) GetCORE_0_AREA_PC() uint32 {
	return volatile.LoadUint32(&o.CORE_0_AREA_PC.Reg)
}

// ASSIST_DEBUG.CORE_0_AREA_SP: ASSIST_DEBUG_CORE_0_AREA_SP_REG
func (o *ASSIST_DEBUG_Type) SetCORE_0_AREA_SP(value uint32) {
	volatile.StoreUint32(&o.CORE_0_AREA_SP.Reg, value)
}
func (o *ASSIST_DEBUG_Type) GetCORE_0_AREA_SP() uint32 {
	return volatile.LoadUint32(&o.CORE_0_AREA_SP.Reg)
}

// ASSIST_DEBUG.CORE_0_SP_MIN: ASSIST_DEBUG_CORE_0_SP_MIN_REG
func (o *ASSIST_DEBUG_Type) SetCORE_0_SP_MIN(value uint32) {
	volatile.StoreUint32(&o.CORE_0_SP_MIN.Reg, value)
}
func (o *ASSIST_DEBUG_Type) GetCORE_0_SP_MIN() uint32 {
	return volatile.LoadUint32(&o.CORE_0_SP_MIN.Reg)
}

// ASSIST_DEBUG.CORE_0_SP_MAX: ASSIST_DEBUG_CORE_0_SP_MAX_REG
func (o *ASSIST_DEBUG_Type) SetCORE_0_SP_MAX(value uint32) {
	volatile.StoreUint32(&o.CORE_0_SP_MAX.Reg, value)
}
func (o *ASSIST_DEBUG_Type) GetCORE_0_SP_MAX() uint32 {
	return volatile.LoadUint32(&o.CORE_0_SP_MAX.Reg)
}

// ASSIST_DEBUG.CORE_0_SP_PC: ASSIST_DEBUG_CORE_0_SP_PC_REG
func (o *ASSIST_DEBUG_Type) SetCORE_0_SP_PC(value uint32) {
	volatile.StoreUint32(&o.CORE_0_SP_PC.Reg, value)
}
func (o *ASSIST_DEBUG_Type) GetCORE_0_SP_PC() uint32 {
	return volatile.LoadUint32(&o.CORE_0_SP_PC.Reg)
}

// ASSIST_DEBUG.CORE_0_RCD_EN: ASSIST_DEBUG_CORE_0_RCD_EN_REG
func (o *ASSIST_DEBUG_Type) SetCORE_0_RCD_EN_CORE_0_RCD_RECORDEN(value uint32) {
	volatile.StoreUint32(&o.CORE_0_RCD_EN.Reg, volatile.LoadUint32(&o.CORE_0_RCD_EN.Reg)&^(0x1)|value)
}
func (o *ASSIST_DEBUG_Type) GetCORE_0_RCD_EN_CORE_0_RCD_RECORDEN() uint32 {
	return volatile.LoadUint32(&o.CORE_0_RCD_EN.Reg) & 0x1
}
func (o *ASSIST_DEBUG_Type) SetCORE_0_RCD_EN_CORE_0_RCD_PDEBUGEN(value uint32) {
	volatile.StoreUint32(&o.CORE_0_RCD_EN.Reg, volatile.LoadUint32(&o.CORE_0_RCD_EN.Reg)&^(0x2)|value<<1)
}
func (o *ASSIST_DEBUG_Type) GetCORE_0_RCD_EN_CORE_0_RCD_PDEBUGEN() uint32 {
	return (volatile.LoadUint32(&o.CORE_0_RCD_EN.Reg) & 0x2) >> 1
}

// ASSIST_DEBUG.CORE_0_RCD_PDEBUGPC: ASSIST_DEBUG_CORE_0_RCD_PDEBUGPC_REG
func (o *ASSIST_DEBUG_Type) SetCORE_0_RCD_PDEBUGPC(value uint32) {
	volatile.StoreUint32(&o.CORE_0_RCD_PDEBUGPC.Reg, value)
}
func (o *ASSIST_DEBUG_Type) GetCORE_0_RCD_PDEBUGPC() uint32 {
	return volatile.LoadUint32(&o.CORE_0_RCD_PDEBUGPC.Reg)
}

// ASSIST_DEBUG.CORE_0_RCD_PDEBUGSP: ASSIST_DEBUG_CORE_0_RCD_PDEBUGSP_REG
func (o *ASSIST_DEBUG_Type) SetCORE_0_RCD_PDEBUGSP(value uint32) {
	volatile.StoreUint32(&o.CORE_0_RCD_PDEBUGSP.Reg, value)
}
func (o *ASSIST_DEBUG_Type) GetCORE_0_RCD_PDEBUGSP() uint32 {
	return volatile.LoadUint32(&o.CORE_0_RCD_PDEBUGSP.Reg)
}

// ASSIST_DEBUG.CORE_0_IRAM0_EXCEPTION_MONITOR_0: ASSIST_DEBUG_CORE_0_RCD_PDEBUGSP_REG
func (o *ASSIST_DEBUG_Type) SetCORE_0_IRAM0_EXCEPTION_MONITOR_0_CORE_0_IRAM0_RECORDING_ADDR_0(value uint32) {
	volatile.StoreUint32(&o.CORE_0_IRAM0_EXCEPTION_MONITOR_0.Reg, volatile.LoadUint32(&o.CORE_0_IRAM0_EXCEPTION_MONITOR_0.Reg)&^(0xffffff)|value)
}
func (o *ASSIST_DEBUG_Type) GetCORE_0_IRAM0_EXCEPTION_MONITOR_0_CORE_0_IRAM0_RECORDING_ADDR_0() uint32 {
	return volatile.LoadUint32(&o.CORE_0_IRAM0_EXCEPTION_MONITOR_0.Reg) & 0xffffff
}
func (o *ASSIST_DEBUG_Type) SetCORE_0_IRAM0_EXCEPTION_MONITOR_0_CORE_0_IRAM0_RECORDING_WR_0(value uint32) {
	volatile.StoreUint32(&o.CORE_0_IRAM0_EXCEPTION_MONITOR_0.Reg, volatile.LoadUint32(&o.CORE_0_IRAM0_EXCEPTION_MONITOR_0.Reg)&^(0x1000000)|value<<24)
}
func (o *ASSIST_DEBUG_Type) GetCORE_0_IRAM0_EXCEPTION_MONITOR_0_CORE_0_IRAM0_RECORDING_WR_0() uint32 {
	return (volatile.LoadUint32(&o.CORE_0_IRAM0_EXCEPTION_MONITOR_0.Reg) & 0x1000000) >> 24
}
func (o *ASSIST_DEBUG_Type) SetCORE_0_IRAM0_EXCEPTION_MONITOR_0_CORE_0_IRAM0_RECORDING_LOADSTORE_0(value uint32) {
	volatile.StoreUint32(&o.CORE_0_IRAM0_EXCEPTION_MONITOR_0.Reg, volatile.LoadUint32(&o.CORE_0_IRAM0_EXCEPTION_MONITOR_0.Reg)&^(0x2000000)|value<<25)
}
func (o *ASSIST_DEBUG_Type) GetCORE_0_IRAM0_EXCEPTION_MONITOR_0_CORE_0_IRAM0_RECORDING_LOADSTORE_0() uint32 {
	return (volatile.LoadUint32(&o.CORE_0_IRAM0_EXCEPTION_MONITOR_0.Reg) & 0x2000000) >> 25
}

// ASSIST_DEBUG.CORE_0_IRAM0_EXCEPTION_MONITOR_1: ASSIST_DEBUG_CORE_0_IRAM0_EXCEPTION_MONITOR_1_REG
func (o *ASSIST_DEBUG_Type) SetCORE_0_IRAM0_EXCEPTION_MONITOR_1_CORE_0_IRAM0_RECORDING_ADDR_1(value uint32) {
	volatile.StoreUint32(&o.CORE_0_IRAM0_EXCEPTION_MONITOR_1.Reg, volatile.LoadUint32(&o.CORE_0_IRAM0_EXCEPTION_MONITOR_1.Reg)&^(0xffffff)|value)
}
func (o *ASSIST_DEBUG_Type) GetCORE_0_IRAM0_EXCEPTION_MONITOR_1_CORE_0_IRAM0_RECORDING_ADDR_1() uint32 {
	return volatile.LoadUint32(&o.CORE_0_IRAM0_EXCEPTION_MONITOR_1.Reg) & 0xffffff
}
func (o *ASSIST_DEBUG_Type) SetCORE_0_IRAM0_EXCEPTION_MONITOR_1_CORE_0_IRAM0_RECORDING_WR_1(value uint32) {
	volatile.StoreUint32(&o.CORE_0_IRAM0_EXCEPTION_MONITOR_1.Reg, volatile.LoadUint32(&o.CORE_0_IRAM0_EXCEPTION_MONITOR_1.Reg)&^(0x1000000)|value<<24)
}
func (o *ASSIST_DEBUG_Type) GetCORE_0_IRAM0_EXCEPTION_MONITOR_1_CORE_0_IRAM0_RECORDING_WR_1() uint32 {
	return (volatile.LoadUint32(&o.CORE_0_IRAM0_EXCEPTION_MONITOR_1.Reg) & 0x1000000) >> 24
}
func (o *ASSIST_DEBUG_Type) SetCORE_0_IRAM0_EXCEPTION_MONITOR_1_CORE_0_IRAM0_RECORDING_LOADSTORE_1(value uint32) {
	volatile.StoreUint32(&o.CORE_0_IRAM0_EXCEPTION_MONITOR_1.Reg, volatile.LoadUint32(&o.CORE_0_IRAM0_EXCEPTION_MONITOR_1.Reg)&^(0x2000000)|value<<25)
}
func (o *ASSIST_DEBUG_Type) GetCORE_0_IRAM0_EXCEPTION_MONITOR_1_CORE_0_IRAM0_RECORDING_LOADSTORE_1() uint32 {
	return (volatile.LoadUint32(&o.CORE_0_IRAM0_EXCEPTION_MONITOR_1.Reg) & 0x2000000) >> 25
}

// ASSIST_DEBUG.CORE_0_DRAM0_EXCEPTION_MONITOR_0: ASSIST_DEBUG_CORE_0_DRAM0_EXCEPTION_MONITOR_0_REG
func (o *ASSIST_DEBUG_Type) SetCORE_0_DRAM0_EXCEPTION_MONITOR_0_CORE_0_DRAM0_RECORDING_ADDR_0(value uint32) {
	volatile.StoreUint32(&o.CORE_0_DRAM0_EXCEPTION_MONITOR_0.Reg, volatile.LoadUint32(&o.CORE_0_DRAM0_EXCEPTION_MONITOR_0.Reg)&^(0xffffff)|value)
}
func (o *ASSIST_DEBUG_Type) GetCORE_0_DRAM0_EXCEPTION_MONITOR_0_CORE_0_DRAM0_RECORDING_ADDR_0() uint32 {
	return volatile.LoadUint32(&o.CORE_0_DRAM0_EXCEPTION_MONITOR_0.Reg) & 0xffffff
}
func (o *ASSIST_DEBUG_Type) SetCORE_0_DRAM0_EXCEPTION_MONITOR_0_CORE_0_DRAM0_RECORDING_WR_0(value uint32) {
	volatile.StoreUint32(&o.CORE_0_DRAM0_EXCEPTION_MONITOR_0.Reg, volatile.LoadUint32(&o.CORE_0_DRAM0_EXCEPTION_MONITOR_0.Reg)&^(0x1000000)|value<<24)
}
func (o *ASSIST_DEBUG_Type) GetCORE_0_DRAM0_EXCEPTION_MONITOR_0_CORE_0_DRAM0_RECORDING_WR_0() uint32 {
	return (volatile.LoadUint32(&o.CORE_0_DRAM0_EXCEPTION_MONITOR_0.Reg) & 0x1000000) >> 24
}
func (o *ASSIST_DEBUG_Type) SetCORE_0_DRAM0_EXCEPTION_MONITOR_0_CORE_0_DRAM0_RECORDING_BYTEEN_0(value uint32) {
	volatile.StoreUint32(&o.CORE_0_DRAM0_EXCEPTION_MONITOR_0.Reg, volatile.LoadUint32(&o.CORE_0_DRAM0_EXCEPTION_MONITOR_0.Reg)&^(0x1e000000)|value<<25)
}
func (o *ASSIST_DEBUG_Type) GetCORE_0_DRAM0_EXCEPTION_MONITOR_0_CORE_0_DRAM0_RECORDING_BYTEEN_0() uint32 {
	return (volatile.LoadUint32(&o.CORE_0_DRAM0_EXCEPTION_MONITOR_0.Reg) & 0x1e000000) >> 25
}

// ASSIST_DEBUG.CORE_0_DRAM0_EXCEPTION_MONITOR_1: ASSIST_DEBUG_CORE_0_DRAM0_EXCEPTION_MONITOR_1_REG
func (o *ASSIST_DEBUG_Type) SetCORE_0_DRAM0_EXCEPTION_MONITOR_1(value uint32) {
	volatile.StoreUint32(&o.CORE_0_DRAM0_EXCEPTION_MONITOR_1.Reg, value)
}
func (o *ASSIST_DEBUG_Type) GetCORE_0_DRAM0_EXCEPTION_MONITOR_1() uint32 {
	return volatile.LoadUint32(&o.CORE_0_DRAM0_EXCEPTION_MONITOR_1.Reg)
}

// ASSIST_DEBUG.CORE_0_DRAM0_EXCEPTION_MONITOR_2: ASSIST_DEBUG_CORE_0_DRAM0_EXCEPTION_MONITOR_1_REG
func (o *ASSIST_DEBUG_Type) SetCORE_0_DRAM0_EXCEPTION_MONITOR_2_CORE_0_DRAM0_RECORDING_ADDR_1(value uint32) {
	volatile.StoreUint32(&o.CORE_0_DRAM0_EXCEPTION_MONITOR_2.Reg, volatile.LoadUint32(&o.CORE_0_DRAM0_EXCEPTION_MONITOR_2.Reg)&^(0xffffff)|value)
}
func (o *ASSIST_DEBUG_Type) GetCORE_0_DRAM0_EXCEPTION_MONITOR_2_CORE_0_DRAM0_RECORDING_ADDR_1() uint32 {
	return volatile.LoadUint32(&o.CORE_0_DRAM0_EXCEPTION_MONITOR_2.Reg) & 0xffffff
}
func (o *ASSIST_DEBUG_Type) SetCORE_0_DRAM0_EXCEPTION_MONITOR_2_CORE_0_DRAM0_RECORDING_WR_1(value uint32) {
	volatile.StoreUint32(&o.CORE_0_DRAM0_EXCEPTION_MONITOR_2.Reg, volatile.LoadUint32(&o.CORE_0_DRAM0_EXCEPTION_MONITOR_2.Reg)&^(0x1000000)|value<<24)
}
func (o *ASSIST_DEBUG_Type) GetCORE_0_DRAM0_EXCEPTION_MONITOR_2_CORE_0_DRAM0_RECORDING_WR_1() uint32 {
	return (volatile.LoadUint32(&o.CORE_0_DRAM0_EXCEPTION_MONITOR_2.Reg) & 0x1000000) >> 24
}
func (o *ASSIST_DEBUG_Type) SetCORE_0_DRAM0_EXCEPTION_MONITOR_2_CORE_0_DRAM0_RECORDING_BYTEEN_1(value uint32) {
	volatile.StoreUint32(&o.CORE_0_DRAM0_EXCEPTION_MONITOR_2.Reg, volatile.LoadUint32(&o.CORE_0_DRAM0_EXCEPTION_MONITOR_2.Reg)&^(0x1e000000)|value<<25)
}
func (o *ASSIST_DEBUG_Type) GetCORE_0_DRAM0_EXCEPTION_MONITOR_2_CORE_0_DRAM0_RECORDING_BYTEEN_1() uint32 {
	return (volatile.LoadUint32(&o.CORE_0_DRAM0_EXCEPTION_MONITOR_2.Reg) & 0x1e000000) >> 25
}

// ASSIST_DEBUG.CORE_0_DRAM0_EXCEPTION_MONITOR_3: ASSIST_DEBUG_CORE_0_DRAM0_EXCEPTION_MONITOR_3_REG
func (o *ASSIST_DEBUG_Type) SetCORE_0_DRAM0_EXCEPTION_MONITOR_3(value uint32) {
	volatile.StoreUint32(&o.CORE_0_DRAM0_EXCEPTION_MONITOR_3.Reg, value)
}
func (o *ASSIST_DEBUG_Type) GetCORE_0_DRAM0_EXCEPTION_MONITOR_3() uint32 {
	return volatile.LoadUint32(&o.CORE_0_DRAM0_EXCEPTION_MONITOR_3.Reg)
}

// ASSIST_DEBUG.CORE_X_IRAM0_DRAM0_EXCEPTION_MONITOR_0: ASSIST_DEBUG_CORE_X_IRAM0_DRAM0_EXCEPTION_MONITOR_0_REG
func (o *ASSIST_DEBUG_Type) SetCORE_X_IRAM0_DRAM0_EXCEPTION_MONITOR_0_CORE_X_IRAM0_DRAM0_LIMIT_CYCLE_0(value uint32) {
	volatile.StoreUint32(&o.CORE_X_IRAM0_DRAM0_EXCEPTION_MONITOR_0.Reg, volatile.LoadUint32(&o.CORE_X_IRAM0_DRAM0_EXCEPTION_MONITOR_0.Reg)&^(0xfffff)|value)
}
func (o *ASSIST_DEBUG_Type) GetCORE_X_IRAM0_DRAM0_EXCEPTION_MONITOR_0_CORE_X_IRAM0_DRAM0_LIMIT_CYCLE_0() uint32 {
	return volatile.LoadUint32(&o.CORE_X_IRAM0_DRAM0_EXCEPTION_MONITOR_0.Reg) & 0xfffff
}

// ASSIST_DEBUG.CORE_X_IRAM0_DRAM0_EXCEPTION_MONITOR_1: ASSIST_DEBUG_CORE_X_IRAM0_DRAM0_EXCEPTION_MONITOR_1_REG
func (o *ASSIST_DEBUG_Type) SetCORE_X_IRAM0_DRAM0_EXCEPTION_MONITOR_1_CORE_X_IRAM0_DRAM0_LIMIT_CYCLE_1(value uint32) {
	volatile.StoreUint32(&o.CORE_X_IRAM0_DRAM0_EXCEPTION_MONITOR_1.Reg, volatile.LoadUint32(&o.CORE_X_IRAM0_DRAM0_EXCEPTION_MONITOR_1.Reg)&^(0xfffff)|value)
}
func (o *ASSIST_DEBUG_Type) GetCORE_X_IRAM0_DRAM0_EXCEPTION_MONITOR_1_CORE_X_IRAM0_DRAM0_LIMIT_CYCLE_1() uint32 {
	return volatile.LoadUint32(&o.CORE_X_IRAM0_DRAM0_EXCEPTION_MONITOR_1.Reg) & 0xfffff
}

// ASSIST_DEBUG.LOG_SETTING: ASSIST_DEBUG_LOG_SETTING
func (o *ASSIST_DEBUG_Type) SetLOG_SETTING_LOG_ENA(value uint32) {
	volatile.StoreUint32(&o.LOG_SETTING.Reg, volatile.LoadUint32(&o.LOG_SETTING.Reg)&^(0x7)|value)
}
func (o *ASSIST_DEBUG_Type) GetLOG_SETTING_LOG_ENA() uint32 {
	return volatile.LoadUint32(&o.LOG_SETTING.Reg) & 0x7
}
func (o *ASSIST_DEBUG_Type) SetLOG_SETTING_LOG_MODE(value uint32) {
	volatile.StoreUint32(&o.LOG_SETTING.Reg, volatile.LoadUint32(&o.LOG_SETTING.Reg)&^(0x78)|value<<3)
}
func (o *ASSIST_DEBUG_Type) GetLOG_SETTING_LOG_MODE() uint32 {
	return (volatile.LoadUint32(&o.LOG_SETTING.Reg) & 0x78) >> 3
}
func (o *ASSIST_DEBUG_Type) SetLOG_SETTING_LOG_MEM_LOOP_ENABLE(value uint32) {
	volatile.StoreUint32(&o.LOG_SETTING.Reg, volatile.LoadUint32(&o.LOG_SETTING.Reg)&^(0x80)|value<<7)
}
func (o *ASSIST_DEBUG_Type) GetLOG_SETTING_LOG_MEM_LOOP_ENABLE() uint32 {
	return (volatile.LoadUint32(&o.LOG_SETTING.Reg) & 0x80) >> 7
}

// ASSIST_DEBUG.LOG_DATA_0: ASSIST_DEBUG_LOG_DATA_0_REG
func (o *ASSIST_DEBUG_Type) SetLOG_DATA_0(value uint32) {
	volatile.StoreUint32(&o.LOG_DATA_0.Reg, value)
}
func (o *ASSIST_DEBUG_Type) GetLOG_DATA_0() uint32 {
	return volatile.LoadUint32(&o.LOG_DATA_0.Reg)
}

// ASSIST_DEBUG.LOG_DATA_MASK: ASSIST_DEBUG_LOG_DATA_MASK_REG
func (o *ASSIST_DEBUG_Type) SetLOG_DATA_MASK_LOG_DATA_SIZE(value uint32) {
	volatile.StoreUint32(&o.LOG_DATA_MASK.Reg, volatile.LoadUint32(&o.LOG_DATA_MASK.Reg)&^(0xffff)|value)
}
func (o *ASSIST_DEBUG_Type) GetLOG_DATA_MASK_LOG_DATA_SIZE() uint32 {
	return volatile.LoadUint32(&o.LOG_DATA_MASK.Reg) & 0xffff
}

// ASSIST_DEBUG.LOG_MIN: ASSIST_DEBUG_LOG_MIN_REG
func (o *ASSIST_DEBUG_Type) SetLOG_MIN(value uint32) {
	volatile.StoreUint32(&o.LOG_MIN.Reg, value)
}
func (o *ASSIST_DEBUG_Type) GetLOG_MIN() uint32 {
	return volatile.LoadUint32(&o.LOG_MIN.Reg)
}

// ASSIST_DEBUG.LOG_MAX: ASSIST_DEBUG_LOG_MAX_REG
func (o *ASSIST_DEBUG_Type) SetLOG_MAX(value uint32) {
	volatile.StoreUint32(&o.LOG_MAX.Reg, value)
}
func (o *ASSIST_DEBUG_Type) GetLOG_MAX() uint32 {
	return volatile.LoadUint32(&o.LOG_MAX.Reg)
}

// ASSIST_DEBUG.LOG_MEM_START: ASSIST_DEBUG_LOG_MEM_START_REG
func (o *ASSIST_DEBUG_Type) SetLOG_MEM_START(value uint32) {
	volatile.StoreUint32(&o.LOG_MEM_START.Reg, value)
}
func (o *ASSIST_DEBUG_Type) GetLOG_MEM_START() uint32 {
	return volatile.LoadUint32(&o.LOG_MEM_START.Reg)
}

// ASSIST_DEBUG.LOG_MEM_END: ASSIST_DEBUG_LOG_MEM_END_REG
func (o *ASSIST_DEBUG_Type) SetLOG_MEM_END(value uint32) {
	volatile.StoreUint32(&o.LOG_MEM_END.Reg, value)
}
func (o *ASSIST_DEBUG_Type) GetLOG_MEM_END() uint32 {
	return volatile.LoadUint32(&o.LOG_MEM_END.Reg)
}

// ASSIST_DEBUG.LOG_MEM_WRITING_ADDR: ASSIST_DEBUG_LOG_MEM_WRITING_ADDR_REG
func (o *ASSIST_DEBUG_Type) SetLOG_MEM_WRITING_ADDR(value uint32) {
	volatile.StoreUint32(&o.LOG_MEM_WRITING_ADDR.Reg, value)
}
func (o *ASSIST_DEBUG_Type) GetLOG_MEM_WRITING_ADDR() uint32 {
	return volatile.LoadUint32(&o.LOG_MEM_WRITING_ADDR.Reg)
}

// ASSIST_DEBUG.LOG_MEM_FULL_FLAG: ASSIST_DEBUG_LOG_MEM_FULL_FLAG_REG
func (o *ASSIST_DEBUG_Type) SetLOG_MEM_FULL_FLAG(value uint32) {
	volatile.StoreUint32(&o.LOG_MEM_FULL_FLAG.Reg, volatile.LoadUint32(&o.LOG_MEM_FULL_FLAG.Reg)&^(0x1)|value)
}
func (o *ASSIST_DEBUG_Type) GetLOG_MEM_FULL_FLAG() uint32 {
	return volatile.LoadUint32(&o.LOG_MEM_FULL_FLAG.Reg) & 0x1
}
func (o *ASSIST_DEBUG_Type) SetLOG_MEM_FULL_FLAG_CLR_LOG_MEM_FULL_FLAG(value uint32) {
	volatile.StoreUint32(&o.LOG_MEM_FULL_FLAG.Reg, volatile.LoadUint32(&o.LOG_MEM_FULL_FLAG.Reg)&^(0x2)|value<<1)
}
func (o *ASSIST_DEBUG_Type) GetLOG_MEM_FULL_FLAG_CLR_LOG_MEM_FULL_FLAG() uint32 {
	return (volatile.LoadUint32(&o.LOG_MEM_FULL_FLAG.Reg) & 0x2) >> 1
}

// ASSIST_DEBUG.C0RE_0_LASTPC_BEFORE_EXCEPTION: ASSIST_DEBUG_C0RE_0_LASTPC_BEFORE_EXCEPTION
func (o *ASSIST_DEBUG_Type) SetC0RE_0_LASTPC_BEFORE_EXCEPTION(value uint32) {
	volatile.StoreUint32(&o.C0RE_0_LASTPC_BEFORE_EXCEPTION.Reg, value)
}
func (o *ASSIST_DEBUG_Type) GetC0RE_0_LASTPC_BEFORE_EXCEPTION() uint32 {
	return volatile.LoadUint32(&o.C0RE_0_LASTPC_BEFORE_EXCEPTION.Reg)
}

// ASSIST_DEBUG.C0RE_0_DEBUG_MODE: ASSIST_DEBUG_C0RE_0_DEBUG_MODE
func (o *ASSIST_DEBUG_Type) SetC0RE_0_DEBUG_MODE_CORE_0_DEBUG_MODE(value uint32) {
	volatile.StoreUint32(&o.C0RE_0_DEBUG_MODE.Reg, volatile.LoadUint32(&o.C0RE_0_DEBUG_MODE.Reg)&^(0x1)|value)
}
func (o *ASSIST_DEBUG_Type) GetC0RE_0_DEBUG_MODE_CORE_0_DEBUG_MODE() uint32 {
	return volatile.LoadUint32(&o.C0RE_0_DEBUG_MODE.Reg) & 0x1
}
func (o *ASSIST_DEBUG_Type) SetC0RE_0_DEBUG_MODE_CORE_0_DEBUG_MODULE_ACTIVE(value uint32) {
	volatile.StoreUint32(&o.C0RE_0_DEBUG_MODE.Reg, volatile.LoadUint32(&o.C0RE_0_DEBUG_MODE.Reg)&^(0x2)|value<<1)
}
func (o *ASSIST_DEBUG_Type) GetC0RE_0_DEBUG_MODE_CORE_0_DEBUG_MODULE_ACTIVE() uint32 {
	return (volatile.LoadUint32(&o.C0RE_0_DEBUG_MODE.Reg) & 0x2) >> 1
}

// ASSIST_DEBUG.DATE: ASSIST_DEBUG_DATE_REG
func (o *ASSIST_DEBUG_Type) SetDATE_ASSIST_DEBUG_DATE(value uint32) {
	volatile.StoreUint32(&o.DATE.Reg, volatile.LoadUint32(&o.DATE.Reg)&^(0xfffffff)|value)
}
func (o *ASSIST_DEBUG_Type) GetDATE_ASSIST_DEBUG_DATE() uint32 {
	return volatile.LoadUint32(&o.DATE.Reg) & 0xfffffff
}

// Peripheral DMA
type DMA_Type struct {
	INT_RAW_CH0              volatile.Register32 // 0x0
	INT_ST_CH0               volatile.Register32 // 0x4
	INT_ENA_CH0              volatile.Register32 // 0x8
	INT_CLR_CH0              volatile.Register32 // 0xC
	INT_RAW_CH1              volatile.Register32 // 0x10
	INT_ST_CH1               volatile.Register32 // 0x14
	INT_ENA_CH1              volatile.Register32 // 0x18
	INT_CLR_CH1              volatile.Register32 // 0x1C
	INT_RAW_CH2              volatile.Register32 // 0x20
	INT_ST_CH2               volatile.Register32 // 0x24
	INT_ENA_CH2              volatile.Register32 // 0x28
	INT_CLR_CH2              volatile.Register32 // 0x2C
	_                        [16]byte
	AHB_TEST                 volatile.Register32 // 0x40
	MISC_CONF                volatile.Register32 // 0x44
	DATE                     volatile.Register32 // 0x48
	_                        [36]byte
	IN_CONF0_CH0             volatile.Register32 // 0x70
	IN_CONF1_CH0             volatile.Register32 // 0x74
	INFIFO_STATUS_CH0        volatile.Register32 // 0x78
	IN_POP_CH0               volatile.Register32 // 0x7C
	IN_LINK_CH0              volatile.Register32 // 0x80
	IN_STATE_CH0             volatile.Register32 // 0x84
	IN_SUC_EOF_DES_ADDR_CH0  volatile.Register32 // 0x88
	IN_ERR_EOF_DES_ADDR_CH0  volatile.Register32 // 0x8C
	IN_DSCR_CH0              volatile.Register32 // 0x90
	IN_DSCR_BF0_CH0          volatile.Register32 // 0x94
	IN_DSCR_BF1_CH0          volatile.Register32 // 0x98
	IN_PRI_CH0               volatile.Register32 // 0x9C
	IN_PERI_SEL_CH0          volatile.Register32 // 0xA0
	_                        [44]byte
	OUT_CONF0_CH0            volatile.Register32 // 0xD0
	OUT_CONF1_CH0            volatile.Register32 // 0xD4
	OUTFIFO_STATUS_CH0       volatile.Register32 // 0xD8
	OUT_PUSH_CH0             volatile.Register32 // 0xDC
	OUT_LINK_CH0             volatile.Register32 // 0xE0
	OUT_STATE_CH0            volatile.Register32 // 0xE4
	OUT_EOF_DES_ADDR_CH0     volatile.Register32 // 0xE8
	OUT_EOF_BFR_DES_ADDR_CH0 volatile.Register32 // 0xEC
	OUT_DSCR_CH0             volatile.Register32 // 0xF0
	OUT_DSCR_BF0_CH0         volatile.Register32 // 0xF4
	OUT_DSCR_BF1_CH0         volatile.Register32 // 0xF8
	OUT_PRI_CH0              volatile.Register32 // 0xFC
	OUT_PERI_SEL_CH0         volatile.Register32 // 0x100
	_                        [44]byte
	IN_CONF0_CH1             volatile.Register32 // 0x130
	IN_CONF1_CH1             volatile.Register32 // 0x134
	INFIFO_STATUS_CH1        volatile.Register32 // 0x138
	IN_POP_CH1               volatile.Register32 // 0x13C
	IN_LINK_CH1              volatile.Register32 // 0x140
	IN_STATE_CH1             volatile.Register32 // 0x144
	IN_SUC_EOF_DES_ADDR_CH1  volatile.Register32 // 0x148
	IN_ERR_EOF_DES_ADDR_CH1  volatile.Register32 // 0x14C
	IN_DSCR_CH1              volatile.Register32 // 0x150
	IN_DSCR_BF0_CH1          volatile.Register32 // 0x154
	IN_DSCR_BF1_CH1          volatile.Register32 // 0x158
	IN_PRI_CH1               volatile.Register32 // 0x15C
	IN_PERI_SEL_CH1          volatile.Register32 // 0x160
	_                        [44]byte
	OUT_CONF0_CH1            volatile.Register32 // 0x190
	OUT_CONF1_CH1            volatile.Register32 // 0x194
	OUTFIFO_STATUS_CH1       volatile.Register32 // 0x198
	OUT_PUSH_CH1             volatile.Register32 // 0x19C
	OUT_LINK_CH1             volatile.Register32 // 0x1A0
	OUT_STATE_CH1            volatile.Register32 // 0x1A4
	OUT_EOF_DES_ADDR_CH1     volatile.Register32 // 0x1A8
	OUT_EOF_BFR_DES_ADDR_CH1 volatile.Register32 // 0x1AC
	OUT_DSCR_CH1             volatile.Register32 // 0x1B0
	OUT_DSCR_BF0_CH1         volatile.Register32 // 0x1B4
	OUT_DSCR_BF1_CH1         volatile.Register32 // 0x1B8
	OUT_PRI_CH1              volatile.Register32 // 0x1BC
	OUT_PERI_SEL_CH1         volatile.Register32 // 0x1C0
	_                        [44]byte
	IN_CONF0_CH2             volatile.Register32 // 0x1F0
	IN_CONF1_CH2             volatile.Register32 // 0x1F4
	INFIFO_STATUS_CH2        volatile.Register32 // 0x1F8
	IN_POP_CH2               volatile.Register32 // 0x1FC
	IN_LINK_CH2              volatile.Register32 // 0x200
	IN_STATE_CH2             volatile.Register32 // 0x204
	IN_SUC_EOF_DES_ADDR_CH2  volatile.Register32 // 0x208
	IN_ERR_EOF_DES_ADDR_CH2  volatile.Register32 // 0x20C
	IN_DSCR_CH2              volatile.Register32 // 0x210
	IN_DSCR_BF0_CH2          volatile.Register32 // 0x214
	IN_DSCR_BF1_CH2          volatile.Register32 // 0x218
	IN_PRI_CH2               volatile.Register32 // 0x21C
	IN_PERI_SEL_CH2          volatile.Register32 // 0x220
	_                        [44]byte
	OUT_CONF0_CH2            volatile.Register32 // 0x250
	OUT_CONF1_CH2            volatile.Register32 // 0x254
	OUTFIFO_STATUS_CH2       volatile.Register32 // 0x258
	OUT_PUSH_CH2             volatile.Register32 // 0x25C
	OUT_LINK_CH2             volatile.Register32 // 0x260
	OUT_STATE_CH2            volatile.Register32 // 0x264
	OUT_EOF_DES_ADDR_CH2     volatile.Register32 // 0x268
	OUT_EOF_BFR_DES_ADDR_CH2 volatile.Register32 // 0x26C
	OUT_DSCR_CH2             volatile.Register32 // 0x270
	OUT_DSCR_BF0_CH2         volatile.Register32 // 0x274
	OUT_DSCR_BF1_CH2         volatile.Register32 // 0x278
	OUT_PRI_CH2              volatile.Register32 // 0x27C
	OUT_PERI_SEL_CH2         volatile.Register32 // 0x280
}

// DMA.INT_RAW_CH0: DMA_INT_RAW_CH0_REG.
func (o *DMA_Type) SetINT_RAW_CH0_IN_DONE_CH0_INT_RAW(value uint32) {
	volatile.StoreUint32(&o.INT_RAW_CH0.Reg, volatile.LoadUint32(&o.INT_RAW_CH0.Reg)&^(0x1)|value)
}
func (o *DMA_Type) GetINT_RAW_CH0_IN_DONE_CH0_INT_RAW() uint32 {
	return volatile.LoadUint32(&o.INT_RAW_CH0.Reg) & 0x1
}
func (o *DMA_Type) SetINT_RAW_CH0_IN_SUC_EOF_CH0_INT_RAW(value uint32) {
	volatile.StoreUint32(&o.INT_RAW_CH0.Reg, volatile.LoadUint32(&o.INT_RAW_CH0.Reg)&^(0x2)|value<<1)
}
func (o *DMA_Type) GetINT_RAW_CH0_IN_SUC_EOF_CH0_INT_RAW() uint32 {
	return (volatile.LoadUint32(&o.INT_RAW_CH0.Reg) & 0x2) >> 1
}
func (o *DMA_Type) SetINT_RAW_CH0_IN_ERR_EOF_CH0_INT_RAW(value uint32) {
	volatile.StoreUint32(&o.INT_RAW_CH0.Reg, volatile.LoadUint32(&o.INT_RAW_CH0.Reg)&^(0x4)|value<<2)
}
func (o *DMA_Type) GetINT_RAW_CH0_IN_ERR_EOF_CH0_INT_RAW() uint32 {
	return (volatile.LoadUint32(&o.INT_RAW_CH0.Reg) & 0x4) >> 2
}
func (o *DMA_Type) SetINT_RAW_CH0_OUT_DONE_CH0_INT_RAW(value uint32) {
	volatile.StoreUint32(&o.INT_RAW_CH0.Reg, volatile.LoadUint32(&o.INT_RAW_CH0.Reg)&^(0x8)|value<<3)
}
func (o *DMA_Type) GetINT_RAW_CH0_OUT_DONE_CH0_INT_RAW() uint32 {
	return (volatile.LoadUint32(&o.INT_RAW_CH0.Reg) & 0x8) >> 3
}
func (o *DMA_Type) SetINT_RAW_CH0_OUT_EOF_CH0_INT_RAW(value uint32) {
	volatile.StoreUint32(&o.INT_RAW_CH0.Reg, volatile.LoadUint32(&o.INT_RAW_CH0.Reg)&^(0x10)|value<<4)
}
func (o *DMA_Type) GetINT_RAW_CH0_OUT_EOF_CH0_INT_RAW() uint32 {
	return (volatile.LoadUint32(&o.INT_RAW_CH0.Reg) & 0x10) >> 4
}
func (o *DMA_Type) SetINT_RAW_CH0_IN_DSCR_ERR_CH0_INT_RAW(value uint32) {
	volatile.StoreUint32(&o.INT_RAW_CH0.Reg, volatile.LoadUint32(&o.INT_RAW_CH0.Reg)&^(0x20)|value<<5)
}
func (o *DMA_Type) GetINT_RAW_CH0_IN_DSCR_ERR_CH0_INT_RAW() uint32 {
	return (volatile.LoadUint32(&o.INT_RAW_CH0.Reg) & 0x20) >> 5
}
func (o *DMA_Type) SetINT_RAW_CH0_OUT_DSCR_ERR_CH0_INT_RAW(value uint32) {
	volatile.StoreUint32(&o.INT_RAW_CH0.Reg, volatile.LoadUint32(&o.INT_RAW_CH0.Reg)&^(0x40)|value<<6)
}
func (o *DMA_Type) GetINT_RAW_CH0_OUT_DSCR_ERR_CH0_INT_RAW() uint32 {
	return (volatile.LoadUint32(&o.INT_RAW_CH0.Reg) & 0x40) >> 6
}
func (o *DMA_Type) SetINT_RAW_CH0_IN_DSCR_EMPTY_CH0_INT_RAW(value uint32) {
	volatile.StoreUint32(&o.INT_RAW_CH0.Reg, volatile.LoadUint32(&o.INT_RAW_CH0.Reg)&^(0x80)|value<<7)
}
func (o *DMA_Type) GetINT_RAW_CH0_IN_DSCR_EMPTY_CH0_INT_RAW() uint32 {
	return (volatile.LoadUint32(&o.INT_RAW_CH0.Reg) & 0x80) >> 7
}
func (o *DMA_Type) SetINT_RAW_CH0_OUT_TOTAL_EOF_CH0_INT_RAW(value uint32) {
	volatile.StoreUint32(&o.INT_RAW_CH0.Reg, volatile.LoadUint32(&o.INT_RAW_CH0.Reg)&^(0x100)|value<<8)
}
func (o *DMA_Type) GetINT_RAW_CH0_OUT_TOTAL_EOF_CH0_INT_RAW() uint32 {
	return (volatile.LoadUint32(&o.INT_RAW_CH0.Reg) & 0x100) >> 8
}
func (o *DMA_Type) SetINT_RAW_CH0_INFIFO_OVF_CH0_INT_RAW(value uint32) {
	volatile.StoreUint32(&o.INT_RAW_CH0.Reg, volatile.LoadUint32(&o.INT_RAW_CH0.Reg)&^(0x200)|value<<9)
}
func (o *DMA_Type) GetINT_RAW_CH0_INFIFO_OVF_CH0_INT_RAW() uint32 {
	return (volatile.LoadUint32(&o.INT_RAW_CH0.Reg) & 0x200) >> 9
}
func (o *DMA_Type) SetINT_RAW_CH0_INFIFO_UDF_CH0_INT_RAW(value uint32) {
	volatile.StoreUint32(&o.INT_RAW_CH0.Reg, volatile.LoadUint32(&o.INT_RAW_CH0.Reg)&^(0x400)|value<<10)
}
func (o *DMA_Type) GetINT_RAW_CH0_INFIFO_UDF_CH0_INT_RAW() uint32 {
	return (volatile.LoadUint32(&o.INT_RAW_CH0.Reg) & 0x400) >> 10
}
func (o *DMA_Type) SetINT_RAW_CH0_OUTFIFO_OVF_CH0_INT_RAW(value uint32) {
	volatile.StoreUint32(&o.INT_RAW_CH0.Reg, volatile.LoadUint32(&o.INT_RAW_CH0.Reg)&^(0x800)|value<<11)
}
func (o *DMA_Type) GetINT_RAW_CH0_OUTFIFO_OVF_CH0_INT_RAW() uint32 {
	return (volatile.LoadUint32(&o.INT_RAW_CH0.Reg) & 0x800) >> 11
}
func (o *DMA_Type) SetINT_RAW_CH0_OUTFIFO_UDF_CH0_INT_RAW(value uint32) {
	volatile.StoreUint32(&o.INT_RAW_CH0.Reg, volatile.LoadUint32(&o.INT_RAW_CH0.Reg)&^(0x1000)|value<<12)
}
func (o *DMA_Type) GetINT_RAW_CH0_OUTFIFO_UDF_CH0_INT_RAW() uint32 {
	return (volatile.LoadUint32(&o.INT_RAW_CH0.Reg) & 0x1000) >> 12
}

// DMA.INT_ST_CH0: DMA_INT_ST_CH0_REG.
func (o *DMA_Type) SetINT_ST_CH0_IN_DONE_CH0_INT_ST(value uint32) {
	volatile.StoreUint32(&o.INT_ST_CH0.Reg, volatile.LoadUint32(&o.INT_ST_CH0.Reg)&^(0x1)|value)
}
func (o *DMA_Type) GetINT_ST_CH0_IN_DONE_CH0_INT_ST() uint32 {
	return volatile.LoadUint32(&o.INT_ST_CH0.Reg) & 0x1
}
func (o *DMA_Type) SetINT_ST_CH0_IN_SUC_EOF_CH0_INT_ST(value uint32) {
	volatile.StoreUint32(&o.INT_ST_CH0.Reg, volatile.LoadUint32(&o.INT_ST_CH0.Reg)&^(0x2)|value<<1)
}
func (o *DMA_Type) GetINT_ST_CH0_IN_SUC_EOF_CH0_INT_ST() uint32 {
	return (volatile.LoadUint32(&o.INT_ST_CH0.Reg) & 0x2) >> 1
}
func (o *DMA_Type) SetINT_ST_CH0_IN_ERR_EOF_CH0_INT_ST(value uint32) {
	volatile.StoreUint32(&o.INT_ST_CH0.Reg, volatile.LoadUint32(&o.INT_ST_CH0.Reg)&^(0x4)|value<<2)
}
func (o *DMA_Type) GetINT_ST_CH0_IN_ERR_EOF_CH0_INT_ST() uint32 {
	return (volatile.LoadUint32(&o.INT_ST_CH0.Reg) & 0x4) >> 2
}
func (o *DMA_Type) SetINT_ST_CH0_OUT_DONE_CH0_INT_ST(value uint32) {
	volatile.StoreUint32(&o.INT_ST_CH0.Reg, volatile.LoadUint32(&o.INT_ST_CH0.Reg)&^(0x8)|value<<3)
}
func (o *DMA_Type) GetINT_ST_CH0_OUT_DONE_CH0_INT_ST() uint32 {
	return (volatile.LoadUint32(&o.INT_ST_CH0.Reg) & 0x8) >> 3
}
func (o *DMA_Type) SetINT_ST_CH0_OUT_EOF_CH0_INT_ST(value uint32) {
	volatile.StoreUint32(&o.INT_ST_CH0.Reg, volatile.LoadUint32(&o.INT_ST_CH0.Reg)&^(0x10)|value<<4)
}
func (o *DMA_Type) GetINT_ST_CH0_OUT_EOF_CH0_INT_ST() uint32 {
	return (volatile.LoadUint32(&o.INT_ST_CH0.Reg) & 0x10) >> 4
}
func (o *DMA_Type) SetINT_ST_CH0_IN_DSCR_ERR_CH0_INT_ST(value uint32) {
	volatile.StoreUint32(&o.INT_ST_CH0.Reg, volatile.LoadUint32(&o.INT_ST_CH0.Reg)&^(0x20)|value<<5)
}
func (o *DMA_Type) GetINT_ST_CH0_IN_DSCR_ERR_CH0_INT_ST() uint32 {
	return (volatile.LoadUint32(&o.INT_ST_CH0.Reg) & 0x20) >> 5
}
func (o *DMA_Type) SetINT_ST_CH0_OUT_DSCR_ERR_CH0_INT_ST(value uint32) {
	volatile.StoreUint32(&o.INT_ST_CH0.Reg, volatile.LoadUint32(&o.INT_ST_CH0.Reg)&^(0x40)|value<<6)
}
func (o *DMA_Type) GetINT_ST_CH0_OUT_DSCR_ERR_CH0_INT_ST() uint32 {
	return (volatile.LoadUint32(&o.INT_ST_CH0.Reg) & 0x40) >> 6
}
func (o *DMA_Type) SetINT_ST_CH0_IN_DSCR_EMPTY_CH0_INT_ST(value uint32) {
	volatile.StoreUint32(&o.INT_ST_CH0.Reg, volatile.LoadUint32(&o.INT_ST_CH0.Reg)&^(0x80)|value<<7)
}
func (o *DMA_Type) GetINT_ST_CH0_IN_DSCR_EMPTY_CH0_INT_ST() uint32 {
	return (volatile.LoadUint32(&o.INT_ST_CH0.Reg) & 0x80) >> 7
}
func (o *DMA_Type) SetINT_ST_CH0_OUT_TOTAL_EOF_CH0_INT_ST(value uint32) {
	volatile.StoreUint32(&o.INT_ST_CH0.Reg, volatile.LoadUint32(&o.INT_ST_CH0.Reg)&^(0x100)|value<<8)
}
func (o *DMA_Type) GetINT_ST_CH0_OUT_TOTAL_EOF_CH0_INT_ST() uint32 {
	return (volatile.LoadUint32(&o.INT_ST_CH0.Reg) & 0x100) >> 8
}
func (o *DMA_Type) SetINT_ST_CH0_INFIFO_OVF_CH0_INT_ST(value uint32) {
	volatile.StoreUint32(&o.INT_ST_CH0.Reg, volatile.LoadUint32(&o.INT_ST_CH0.Reg)&^(0x200)|value<<9)
}
func (o *DMA_Type) GetINT_ST_CH0_INFIFO_OVF_CH0_INT_ST() uint32 {
	return (volatile.LoadUint32(&o.INT_ST_CH0.Reg) & 0x200) >> 9
}
func (o *DMA_Type) SetINT_ST_CH0_INFIFO_UDF_CH0_INT_ST(value uint32) {
	volatile.StoreUint32(&o.INT_ST_CH0.Reg, volatile.LoadUint32(&o.INT_ST_CH0.Reg)&^(0x400)|value<<10)
}
func (o *DMA_Type) GetINT_ST_CH0_INFIFO_UDF_CH0_INT_ST() uint32 {
	return (volatile.LoadUint32(&o.INT_ST_CH0.Reg) & 0x400) >> 10
}
func (o *DMA_Type) SetINT_ST_CH0_OUTFIFO_OVF_CH0_INT_ST(value uint32) {
	volatile.StoreUint32(&o.INT_ST_CH0.Reg, volatile.LoadUint32(&o.INT_ST_CH0.Reg)&^(0x800)|value<<11)
}
func (o *DMA_Type) GetINT_ST_CH0_OUTFIFO_OVF_CH0_INT_ST() uint32 {
	return (volatile.LoadUint32(&o.INT_ST_CH0.Reg) & 0x800) >> 11
}
func (o *DMA_Type) SetINT_ST_CH0_OUTFIFO_UDF_CH0_INT_ST(value uint32) {
	volatile.StoreUint32(&o.INT_ST_CH0.Reg, volatile.LoadUint32(&o.INT_ST_CH0.Reg)&^(0x1000)|value<<12)
}
func (o *DMA_Type) GetINT_ST_CH0_OUTFIFO_UDF_CH0_INT_ST() uint32 {
	return (volatile.LoadUint32(&o.INT_ST_CH0.Reg) & 0x1000) >> 12
}

// DMA.INT_ENA_CH0: DMA_INT_ENA_CH0_REG.
func (o *DMA_Type) SetINT_ENA_CH0_IN_DONE_CH0_INT_ENA(value uint32) {
	volatile.StoreUint32(&o.INT_ENA_CH0.Reg, volatile.LoadUint32(&o.INT_ENA_CH0.Reg)&^(0x1)|value)
}
func (o *DMA_Type) GetINT_ENA_CH0_IN_DONE_CH0_INT_ENA() uint32 {
	return volatile.LoadUint32(&o.INT_ENA_CH0.Reg) & 0x1
}
func (o *DMA_Type) SetINT_ENA_CH0_IN_SUC_EOF_CH0_INT_ENA(value uint32) {
	volatile.StoreUint32(&o.INT_ENA_CH0.Reg, volatile.LoadUint32(&o.INT_ENA_CH0.Reg)&^(0x2)|value<<1)
}
func (o *DMA_Type) GetINT_ENA_CH0_IN_SUC_EOF_CH0_INT_ENA() uint32 {
	return (volatile.LoadUint32(&o.INT_ENA_CH0.Reg) & 0x2) >> 1
}
func (o *DMA_Type) SetINT_ENA_CH0_IN_ERR_EOF_CH0_INT_ENA(value uint32) {
	volatile.StoreUint32(&o.INT_ENA_CH0.Reg, volatile.LoadUint32(&o.INT_ENA_CH0.Reg)&^(0x4)|value<<2)
}
func (o *DMA_Type) GetINT_ENA_CH0_IN_ERR_EOF_CH0_INT_ENA() uint32 {
	return (volatile.LoadUint32(&o.INT_ENA_CH0.Reg) & 0x4) >> 2
}
func (o *DMA_Type) SetINT_ENA_CH0_OUT_DONE_CH0_INT_ENA(value uint32) {
	volatile.StoreUint32(&o.INT_ENA_CH0.Reg, volatile.LoadUint32(&o.INT_ENA_CH0.Reg)&^(0x8)|value<<3)
}
func (o *DMA_Type) GetINT_ENA_CH0_OUT_DONE_CH0_INT_ENA() uint32 {
	return (volatile.LoadUint32(&o.INT_ENA_CH0.Reg) & 0x8) >> 3
}
func (o *DMA_Type) SetINT_ENA_CH0_OUT_EOF_CH0_INT_ENA(value uint32) {
	volatile.StoreUint32(&o.INT_ENA_CH0.Reg, volatile.LoadUint32(&o.INT_ENA_CH0.Reg)&^(0x10)|value<<4)
}
func (o *DMA_Type) GetINT_ENA_CH0_OUT_EOF_CH0_INT_ENA() uint32 {
	return (volatile.LoadUint32(&o.INT_ENA_CH0.Reg) & 0x10) >> 4
}
func (o *DMA_Type) SetINT_ENA_CH0_IN_DSCR_ERR_CH0_INT_ENA(value uint32) {
	volatile.StoreUint32(&o.INT_ENA_CH0.Reg, volatile.LoadUint32(&o.INT_ENA_CH0.Reg)&^(0x20)|value<<5)
}
func (o *DMA_Type) GetINT_ENA_CH0_IN_DSCR_ERR_CH0_INT_ENA() uint32 {
	return (volatile.LoadUint32(&o.INT_ENA_CH0.Reg) & 0x20) >> 5
}
func (o *DMA_Type) SetINT_ENA_CH0_OUT_DSCR_ERR_CH0_INT_ENA(value uint32) {
	volatile.StoreUint32(&o.INT_ENA_CH0.Reg, volatile.LoadUint32(&o.INT_ENA_CH0.Reg)&^(0x40)|value<<6)
}
func (o *DMA_Type) GetINT_ENA_CH0_OUT_DSCR_ERR_CH0_INT_ENA() uint32 {
	return (volatile.LoadUint32(&o.INT_ENA_CH0.Reg) & 0x40) >> 6
}
func (o *DMA_Type) SetINT_ENA_CH0_IN_DSCR_EMPTY_CH0_INT_ENA(value uint32) {
	volatile.StoreUint32(&o.INT_ENA_CH0.Reg, volatile.LoadUint32(&o.INT_ENA_CH0.Reg)&^(0x80)|value<<7)
}
func (o *DMA_Type) GetINT_ENA_CH0_IN_DSCR_EMPTY_CH0_INT_ENA() uint32 {
	return (volatile.LoadUint32(&o.INT_ENA_CH0.Reg) & 0x80) >> 7
}
func (o *DMA_Type) SetINT_ENA_CH0_OUT_TOTAL_EOF_CH0_INT_ENA(value uint32) {
	volatile.StoreUint32(&o.INT_ENA_CH0.Reg, volatile.LoadUint32(&o.INT_ENA_CH0.Reg)&^(0x100)|value<<8)
}
func (o *DMA_Type) GetINT_ENA_CH0_OUT_TOTAL_EOF_CH0_INT_ENA() uint32 {
	return (volatile.LoadUint32(&o.INT_ENA_CH0.Reg) & 0x100) >> 8
}
func (o *DMA_Type) SetINT_ENA_CH0_INFIFO_OVF_CH0_INT_ENA(value uint32) {
	volatile.StoreUint32(&o.INT_ENA_CH0.Reg, volatile.LoadUint32(&o.INT_ENA_CH0.Reg)&^(0x200)|value<<9)
}
func (o *DMA_Type) GetINT_ENA_CH0_INFIFO_OVF_CH0_INT_ENA() uint32 {
	return (volatile.LoadUint32(&o.INT_ENA_CH0.Reg) & 0x200) >> 9
}
func (o *DMA_Type) SetINT_ENA_CH0_INFIFO_UDF_CH0_INT_ENA(value uint32) {
	volatile.StoreUint32(&o.INT_ENA_CH0.Reg, volatile.LoadUint32(&o.INT_ENA_CH0.Reg)&^(0x400)|value<<10)
}
func (o *DMA_Type) GetINT_ENA_CH0_INFIFO_UDF_CH0_INT_ENA() uint32 {
	return (volatile.LoadUint32(&o.INT_ENA_CH0.Reg) & 0x400) >> 10
}
func (o *DMA_Type) SetINT_ENA_CH0_OUTFIFO_OVF_CH0_INT_ENA(value uint32) {
	volatile.StoreUint32(&o.INT_ENA_CH0.Reg, volatile.LoadUint32(&o.INT_ENA_CH0.Reg)&^(0x800)|value<<11)
}
func (o *DMA_Type) GetINT_ENA_CH0_OUTFIFO_OVF_CH0_INT_ENA() uint32 {
	return (volatile.LoadUint32(&o.INT_ENA_CH0.Reg) & 0x800) >> 11
}
func (o *DMA_Type) SetINT_ENA_CH0_OUTFIFO_UDF_CH0_INT_ENA(value uint32) {
	volatile.StoreUint32(&o.INT_ENA_CH0.Reg, volatile.LoadUint32(&o.INT_ENA_CH0.Reg)&^(0x1000)|value<<12)
}
func (o *DMA_Type) GetINT_ENA_CH0_OUTFIFO_UDF_CH0_INT_ENA() uint32 {
	return (volatile.LoadUint32(&o.INT_ENA_CH0.Reg) & 0x1000) >> 12
}

// DMA.INT_CLR_CH0: DMA_INT_CLR_CH0_REG.
func (o *DMA_Type) SetINT_CLR_CH0_IN_DONE_CH0_INT_CLR(value uint32) {
	volatile.StoreUint32(&o.INT_CLR_CH0.Reg, volatile.LoadUint32(&o.INT_CLR_CH0.Reg)&^(0x1)|value)
}
func (o *DMA_Type) GetINT_CLR_CH0_IN_DONE_CH0_INT_CLR() uint32 {
	return volatile.LoadUint32(&o.INT_CLR_CH0.Reg) & 0x1
}
func (o *DMA_Type) SetINT_CLR_CH0_IN_SUC_EOF_CH0_INT_CLR(value uint32) {
	volatile.StoreUint32(&o.INT_CLR_CH0.Reg, volatile.LoadUint32(&o.INT_CLR_CH0.Reg)&^(0x2)|value<<1)
}
func (o *DMA_Type) GetINT_CLR_CH0_IN_SUC_EOF_CH0_INT_CLR() uint32 {
	return (volatile.LoadUint32(&o.INT_CLR_CH0.Reg) & 0x2) >> 1
}
func (o *DMA_Type) SetINT_CLR_CH0_IN_ERR_EOF_CH0_INT_CLR(value uint32) {
	volatile.StoreUint32(&o.INT_CLR_CH0.Reg, volatile.LoadUint32(&o.INT_CLR_CH0.Reg)&^(0x4)|value<<2)
}
func (o *DMA_Type) GetINT_CLR_CH0_IN_ERR_EOF_CH0_INT_CLR() uint32 {
	return (volatile.LoadUint32(&o.INT_CLR_CH0.Reg) & 0x4) >> 2
}
func (o *DMA_Type) SetINT_CLR_CH0_OUT_DONE_CH0_INT_CLR(value uint32) {
	volatile.StoreUint32(&o.INT_CLR_CH0.Reg, volatile.LoadUint32(&o.INT_CLR_CH0.Reg)&^(0x8)|value<<3)
}
func (o *DMA_Type) GetINT_CLR_CH0_OUT_DONE_CH0_INT_CLR() uint32 {
	return (volatile.LoadUint32(&o.INT_CLR_CH0.Reg) & 0x8) >> 3
}
func (o *DMA_Type) SetINT_CLR_CH0_OUT_EOF_CH0_INT_CLR(value uint32) {
	volatile.StoreUint32(&o.INT_CLR_CH0.Reg, volatile.LoadUint32(&o.INT_CLR_CH0.Reg)&^(0x10)|value<<4)
}
func (o *DMA_Type) GetINT_CLR_CH0_OUT_EOF_CH0_INT_CLR() uint32 {
	return (volatile.LoadUint32(&o.INT_CLR_CH0.Reg) & 0x10) >> 4
}
func (o *DMA_Type) SetINT_CLR_CH0_IN_DSCR_ERR_CH0_INT_CLR(value uint32) {
	volatile.StoreUint32(&o.INT_CLR_CH0.Reg, volatile.LoadUint32(&o.INT_CLR_CH0.Reg)&^(0x20)|value<<5)
}
func (o *DMA_Type) GetINT_CLR_CH0_IN_DSCR_ERR_CH0_INT_CLR() uint32 {
	return (volatile.LoadUint32(&o.INT_CLR_CH0.Reg) & 0x20) >> 5
}
func (o *DMA_Type) SetINT_CLR_CH0_OUT_DSCR_ERR_CH0_INT_CLR(value uint32) {
	volatile.StoreUint32(&o.INT_CLR_CH0.Reg, volatile.LoadUint32(&o.INT_CLR_CH0.Reg)&^(0x40)|value<<6)
}
func (o *DMA_Type) GetINT_CLR_CH0_OUT_DSCR_ERR_CH0_INT_CLR() uint32 {
	return (volatile.LoadUint32(&o.INT_CLR_CH0.Reg) & 0x40) >> 6
}
func (o *DMA_Type) SetINT_CLR_CH0_IN_DSCR_EMPTY_CH0_INT_CLR(value uint32) {
	volatile.StoreUint32(&o.INT_CLR_CH0.Reg, volatile.LoadUint32(&o.INT_CLR_CH0.Reg)&^(0x80)|value<<7)
}
func (o *DMA_Type) GetINT_CLR_CH0_IN_DSCR_EMPTY_CH0_INT_CLR() uint32 {
	return (volatile.LoadUint32(&o.INT_CLR_CH0.Reg) & 0x80) >> 7
}
func (o *DMA_Type) SetINT_CLR_CH0_OUT_TOTAL_EOF_CH0_INT_CLR(value uint32) {
	volatile.StoreUint32(&o.INT_CLR_CH0.Reg, volatile.LoadUint32(&o.INT_CLR_CH0.Reg)&^(0x100)|value<<8)
}
func (o *DMA_Type) GetINT_CLR_CH0_OUT_TOTAL_EOF_CH0_INT_CLR() uint32 {
	return (volatile.LoadUint32(&o.INT_CLR_CH0.Reg) & 0x100) >> 8
}
func (o *DMA_Type) SetINT_CLR_CH0_INFIFO_OVF_CH0_INT_CLR(value uint32) {
	volatile.StoreUint32(&o.INT_CLR_CH0.Reg, volatile.LoadUint32(&o.INT_CLR_CH0.Reg)&^(0x200)|value<<9)
}
func (o *DMA_Type) GetINT_CLR_CH0_INFIFO_OVF_CH0_INT_CLR() uint32 {
	return (volatile.LoadUint32(&o.INT_CLR_CH0.Reg) & 0x200) >> 9
}
func (o *DMA_Type) SetINT_CLR_CH0_INFIFO_UDF_CH0_INT_CLR(value uint32) {
	volatile.StoreUint32(&o.INT_CLR_CH0.Reg, volatile.LoadUint32(&o.INT_CLR_CH0.Reg)&^(0x400)|value<<10)
}
func (o *DMA_Type) GetINT_CLR_CH0_INFIFO_UDF_CH0_INT_CLR() uint32 {
	return (volatile.LoadUint32(&o.INT_CLR_CH0.Reg) & 0x400) >> 10
}
func (o *DMA_Type) SetINT_CLR_CH0_OUTFIFO_OVF_CH0_INT_CLR(value uint32) {
	volatile.StoreUint32(&o.INT_CLR_CH0.Reg, volatile.LoadUint32(&o.INT_CLR_CH0.Reg)&^(0x800)|value<<11)
}
func (o *DMA_Type) GetINT_CLR_CH0_OUTFIFO_OVF_CH0_INT_CLR() uint32 {
	return (volatile.LoadUint32(&o.INT_CLR_CH0.Reg) & 0x800) >> 11
}
func (o *DMA_Type) SetINT_CLR_CH0_OUTFIFO_UDF_CH0_INT_CLR(value uint32) {
	volatile.StoreUint32(&o.INT_CLR_CH0.Reg, volatile.LoadUint32(&o.INT_CLR_CH0.Reg)&^(0x1000)|value<<12)
}
func (o *DMA_Type) GetINT_CLR_CH0_OUTFIFO_UDF_CH0_INT_CLR() uint32 {
	return (volatile.LoadUint32(&o.INT_CLR_CH0.Reg) & 0x1000) >> 12
}

// DMA.INT_RAW_CH1: DMA_INT_RAW_CH1_REG.
func (o *DMA_Type) SetINT_RAW_CH1_IN_DONE_CH1_INT_RAW(value uint32) {
	volatile.StoreUint32(&o.INT_RAW_CH1.Reg, volatile.LoadUint32(&o.INT_RAW_CH1.Reg)&^(0x1)|value)
}
func (o *DMA_Type) GetINT_RAW_CH1_IN_DONE_CH1_INT_RAW() uint32 {
	return volatile.LoadUint32(&o.INT_RAW_CH1.Reg) & 0x1
}
func (o *DMA_Type) SetINT_RAW_CH1_IN_SUC_EOF_CH1_INT_RAW(value uint32) {
	volatile.StoreUint32(&o.INT_RAW_CH1.Reg, volatile.LoadUint32(&o.INT_RAW_CH1.Reg)&^(0x2)|value<<1)
}
func (o *DMA_Type) GetINT_RAW_CH1_IN_SUC_EOF_CH1_INT_RAW() uint32 {
	return (volatile.LoadUint32(&o.INT_RAW_CH1.Reg) & 0x2) >> 1
}
func (o *DMA_Type) SetINT_RAW_CH1_IN_ERR_EOF_CH1_INT_RAW(value uint32) {
	volatile.StoreUint32(&o.INT_RAW_CH1.Reg, volatile.LoadUint32(&o.INT_RAW_CH1.Reg)&^(0x4)|value<<2)
}
func (o *DMA_Type) GetINT_RAW_CH1_IN_ERR_EOF_CH1_INT_RAW() uint32 {
	return (volatile.LoadUint32(&o.INT_RAW_CH1.Reg) & 0x4) >> 2
}
func (o *DMA_Type) SetINT_RAW_CH1_OUT_DONE_CH1_INT_RAW(value uint32) {
	volatile.StoreUint32(&o.INT_RAW_CH1.Reg, volatile.LoadUint32(&o.INT_RAW_CH1.Reg)&^(0x8)|value<<3)
}
func (o *DMA_Type) GetINT_RAW_CH1_OUT_DONE_CH1_INT_RAW() uint32 {
	return (volatile.LoadUint32(&o.INT_RAW_CH1.Reg) & 0x8) >> 3
}
func (o *DMA_Type) SetINT_RAW_CH1_OUT_EOF_CH1_INT_RAW(value uint32) {
	volatile.StoreUint32(&o.INT_RAW_CH1.Reg, volatile.LoadUint32(&o.INT_RAW_CH1.Reg)&^(0x10)|value<<4)
}
func (o *DMA_Type) GetINT_RAW_CH1_OUT_EOF_CH1_INT_RAW() uint32 {
	return (volatile.LoadUint32(&o.INT_RAW_CH1.Reg) & 0x10) >> 4
}
func (o *DMA_Type) SetINT_RAW_CH1_IN_DSCR_ERR_CH1_INT_RAW(value uint32) {
	volatile.StoreUint32(&o.INT_RAW_CH1.Reg, volatile.LoadUint32(&o.INT_RAW_CH1.Reg)&^(0x20)|value<<5)
}
func (o *DMA_Type) GetINT_RAW_CH1_IN_DSCR_ERR_CH1_INT_RAW() uint32 {
	return (volatile.LoadUint32(&o.INT_RAW_CH1.Reg) & 0x20) >> 5
}
func (o *DMA_Type) SetINT_RAW_CH1_OUT_DSCR_ERR_CH1_INT_RAW(value uint32) {
	volatile.StoreUint32(&o.INT_RAW_CH1.Reg, volatile.LoadUint32(&o.INT_RAW_CH1.Reg)&^(0x40)|value<<6)
}
func (o *DMA_Type) GetINT_RAW_CH1_OUT_DSCR_ERR_CH1_INT_RAW() uint32 {
	return (volatile.LoadUint32(&o.INT_RAW_CH1.Reg) & 0x40) >> 6
}
func (o *DMA_Type) SetINT_RAW_CH1_IN_DSCR_EMPTY_CH1_INT_RAW(value uint32) {
	volatile.StoreUint32(&o.INT_RAW_CH1.Reg, volatile.LoadUint32(&o.INT_RAW_CH1.Reg)&^(0x80)|value<<7)
}
func (o *DMA_Type) GetINT_RAW_CH1_IN_DSCR_EMPTY_CH1_INT_RAW() uint32 {
	return (volatile.LoadUint32(&o.INT_RAW_CH1.Reg) & 0x80) >> 7
}
func (o *DMA_Type) SetINT_RAW_CH1_OUT_TOTAL_EOF_CH1_INT_RAW(value uint32) {
	volatile.StoreUint32(&o.INT_RAW_CH1.Reg, volatile.LoadUint32(&o.INT_RAW_CH1.Reg)&^(0x100)|value<<8)
}
func (o *DMA_Type) GetINT_RAW_CH1_OUT_TOTAL_EOF_CH1_INT_RAW() uint32 {
	return (volatile.LoadUint32(&o.INT_RAW_CH1.Reg) & 0x100) >> 8
}
func (o *DMA_Type) SetINT_RAW_CH1_INFIFO_OVF_CH1_INT_RAW(value uint32) {
	volatile.StoreUint32(&o.INT_RAW_CH1.Reg, volatile.LoadUint32(&o.INT_RAW_CH1.Reg)&^(0x200)|value<<9)
}
func (o *DMA_Type) GetINT_RAW_CH1_INFIFO_OVF_CH1_INT_RAW() uint32 {
	return (volatile.LoadUint32(&o.INT_RAW_CH1.Reg) & 0x200) >> 9
}
func (o *DMA_Type) SetINT_RAW_CH1_INFIFO_UDF_CH1_INT_RAW(value uint32) {
	volatile.StoreUint32(&o.INT_RAW_CH1.Reg, volatile.LoadUint32(&o.INT_RAW_CH1.Reg)&^(0x400)|value<<10)
}
func (o *DMA_Type) GetINT_RAW_CH1_INFIFO_UDF_CH1_INT_RAW() uint32 {
	return (volatile.LoadUint32(&o.INT_RAW_CH1.Reg) & 0x400) >> 10
}
func (o *DMA_Type) SetINT_RAW_CH1_OUTFIFO_OVF_CH1_INT_RAW(value uint32) {
	volatile.StoreUint32(&o.INT_RAW_CH1.Reg, volatile.LoadUint32(&o.INT_RAW_CH1.Reg)&^(0x800)|value<<11)
}
func (o *DMA_Type) GetINT_RAW_CH1_OUTFIFO_OVF_CH1_INT_RAW() uint32 {
	return (volatile.LoadUint32(&o.INT_RAW_CH1.Reg) & 0x800) >> 11
}
func (o *DMA_Type) SetINT_RAW_CH1_OUTFIFO_UDF_CH1_INT_RAW(value uint32) {
	volatile.StoreUint32(&o.INT_RAW_CH1.Reg, volatile.LoadUint32(&o.INT_RAW_CH1.Reg)&^(0x1000)|value<<12)
}
func (o *DMA_Type) GetINT_RAW_CH1_OUTFIFO_UDF_CH1_INT_RAW() uint32 {
	return (volatile.LoadUint32(&o.INT_RAW_CH1.Reg) & 0x1000) >> 12
}

// DMA.INT_ST_CH1: DMA_INT_ST_CH1_REG.
func (o *DMA_Type) SetINT_ST_CH1_IN_DONE_CH1_INT_ST(value uint32) {
	volatile.StoreUint32(&o.INT_ST_CH1.Reg, volatile.LoadUint32(&o.INT_ST_CH1.Reg)&^(0x1)|value)
}
func (o *DMA_Type) GetINT_ST_CH1_IN_DONE_CH1_INT_ST() uint32 {
	return volatile.LoadUint32(&o.INT_ST_CH1.Reg) & 0x1
}
func (o *DMA_Type) SetINT_ST_CH1_IN_SUC_EOF_CH1_INT_ST(value uint32) {
	volatile.StoreUint32(&o.INT_ST_CH1.Reg, volatile.LoadUint32(&o.INT_ST_CH1.Reg)&^(0x2)|value<<1)
}
func (o *DMA_Type) GetINT_ST_CH1_IN_SUC_EOF_CH1_INT_ST() uint32 {
	return (volatile.LoadUint32(&o.INT_ST_CH1.Reg) & 0x2) >> 1
}
func (o *DMA_Type) SetINT_ST_CH1_IN_ERR_EOF_CH1_INT_ST(value uint32) {
	volatile.StoreUint32(&o.INT_ST_CH1.Reg, volatile.LoadUint32(&o.INT_ST_CH1.Reg)&^(0x4)|value<<2)
}
func (o *DMA_Type) GetINT_ST_CH1_IN_ERR_EOF_CH1_INT_ST() uint32 {
	return (volatile.LoadUint32(&o.INT_ST_CH1.Reg) & 0x4) >> 2
}
func (o *DMA_Type) SetINT_ST_CH1_OUT_DONE_CH1_INT_ST(value uint32) {
	volatile.StoreUint32(&o.INT_ST_CH1.Reg, volatile.LoadUint32(&o.INT_ST_CH1.Reg)&^(0x8)|value<<3)
}
func (o *DMA_Type) GetINT_ST_CH1_OUT_DONE_CH1_INT_ST() uint32 {
	return (volatile.LoadUint32(&o.INT_ST_CH1.Reg) & 0x8) >> 3
}
func (o *DMA_Type) SetINT_ST_CH1_OUT_EOF_CH1_INT_ST(value uint32) {
	volatile.StoreUint32(&o.INT_ST_CH1.Reg, volatile.LoadUint32(&o.INT_ST_CH1.Reg)&^(0x10)|value<<4)
}
func (o *DMA_Type) GetINT_ST_CH1_OUT_EOF_CH1_INT_ST() uint32 {
	return (volatile.LoadUint32(&o.INT_ST_CH1.Reg) & 0x10) >> 4
}
func (o *DMA_Type) SetINT_ST_CH1_IN_DSCR_ERR_CH1_INT_ST(value uint32) {
	volatile.StoreUint32(&o.INT_ST_CH1.Reg, volatile.LoadUint32(&o.INT_ST_CH1.Reg)&^(0x20)|value<<5)
}
func (o *DMA_Type) GetINT_ST_CH1_IN_DSCR_ERR_CH1_INT_ST() uint32 {
	return (volatile.LoadUint32(&o.INT_ST_CH1.Reg) & 0x20) >> 5
}
func (o *DMA_Type) SetINT_ST_CH1_OUT_DSCR_ERR_CH1_INT_ST(value uint32) {
	volatile.StoreUint32(&o.INT_ST_CH1.Reg, volatile.LoadUint32(&o.INT_ST_CH1.Reg)&^(0x40)|value<<6)
}
func (o *DMA_Type) GetINT_ST_CH1_OUT_DSCR_ERR_CH1_INT_ST() uint32 {
	return (volatile.LoadUint32(&o.INT_ST_CH1.Reg) & 0x40) >> 6
}
func (o *DMA_Type) SetINT_ST_CH1_IN_DSCR_EMPTY_CH1_INT_ST(value uint32) {
	volatile.StoreUint32(&o.INT_ST_CH1.Reg, volatile.LoadUint32(&o.INT_ST_CH1.Reg)&^(0x80)|value<<7)
}
func (o *DMA_Type) GetINT_ST_CH1_IN_DSCR_EMPTY_CH1_INT_ST() uint32 {
	return (volatile.LoadUint32(&o.INT_ST_CH1.Reg) & 0x80) >> 7
}
func (o *DMA_Type) SetINT_ST_CH1_OUT_TOTAL_EOF_CH1_INT_ST(value uint32) {
	volatile.StoreUint32(&o.INT_ST_CH1.Reg, volatile.LoadUint32(&o.INT_ST_CH1.Reg)&^(0x100)|value<<8)
}
func (o *DMA_Type) GetINT_ST_CH1_OUT_TOTAL_EOF_CH1_INT_ST() uint32 {
	return (volatile.LoadUint32(&o.INT_ST_CH1.Reg) & 0x100) >> 8
}
func (o *DMA_Type) SetINT_ST_CH1_INFIFO_OVF_CH1_INT_ST(value uint32) {
	volatile.StoreUint32(&o.INT_ST_CH1.Reg, volatile.LoadUint32(&o.INT_ST_CH1.Reg)&^(0x200)|value<<9)
}
func (o *DMA_Type) GetINT_ST_CH1_INFIFO_OVF_CH1_INT_ST() uint32 {
	return (volatile.LoadUint32(&o.INT_ST_CH1.Reg) & 0x200) >> 9
}
func (o *DMA_Type) SetINT_ST_CH1_INFIFO_UDF_CH1_INT_ST(value uint32) {
	volatile.StoreUint32(&o.INT_ST_CH1.Reg, volatile.LoadUint32(&o.INT_ST_CH1.Reg)&^(0x400)|value<<10)
}
func (o *DMA_Type) GetINT_ST_CH1_INFIFO_UDF_CH1_INT_ST() uint32 {
	return (volatile.LoadUint32(&o.INT_ST_CH1.Reg) & 0x400) >> 10
}
func (o *DMA_Type) SetINT_ST_CH1_OUTFIFO_OVF_CH1_INT_ST(value uint32) {
	volatile.StoreUint32(&o.INT_ST_CH1.Reg, volatile.LoadUint32(&o.INT_ST_CH1.Reg)&^(0x800)|value<<11)
}
func (o *DMA_Type) GetINT_ST_CH1_OUTFIFO_OVF_CH1_INT_ST() uint32 {
	return (volatile.LoadUint32(&o.INT_ST_CH1.Reg) & 0x800) >> 11
}
func (o *DMA_Type) SetINT_ST_CH1_OUTFIFO_UDF_CH1_INT_ST(value uint32) {
	volatile.StoreUint32(&o.INT_ST_CH1.Reg, volatile.LoadUint32(&o.INT_ST_CH1.Reg)&^(0x1000)|value<<12)
}
func (o *DMA_Type) GetINT_ST_CH1_OUTFIFO_UDF_CH1_INT_ST() uint32 {
	return (volatile.LoadUint32(&o.INT_ST_CH1.Reg) & 0x1000) >> 12
}

// DMA.INT_ENA_CH1: DMA_INT_ENA_CH1_REG.
func (o *DMA_Type) SetINT_ENA_CH1_IN_DONE_CH1_INT_ENA(value uint32) {
	volatile.StoreUint32(&o.INT_ENA_CH1.Reg, volatile.LoadUint32(&o.INT_ENA_CH1.Reg)&^(0x1)|value)
}
func (o *DMA_Type) GetINT_ENA_CH1_IN_DONE_CH1_INT_ENA() uint32 {
	return volatile.LoadUint32(&o.INT_ENA_CH1.Reg) & 0x1
}
func (o *DMA_Type) SetINT_ENA_CH1_IN_SUC_EOF_CH1_INT_ENA(value uint32) {
	volatile.StoreUint32(&o.INT_ENA_CH1.Reg, volatile.LoadUint32(&o.INT_ENA_CH1.Reg)&^(0x2)|value<<1)
}
func (o *DMA_Type) GetINT_ENA_CH1_IN_SUC_EOF_CH1_INT_ENA() uint32 {
	return (volatile.LoadUint32(&o.INT_ENA_CH1.Reg) & 0x2) >> 1
}
func (o *DMA_Type) SetINT_ENA_CH1_IN_ERR_EOF_CH1_INT_ENA(value uint32) {
	volatile.StoreUint32(&o.INT_ENA_CH1.Reg, volatile.LoadUint32(&o.INT_ENA_CH1.Reg)&^(0x4)|value<<2)
}
func (o *DMA_Type) GetINT_ENA_CH1_IN_ERR_EOF_CH1_INT_ENA() uint32 {
	return (volatile.LoadUint32(&o.INT_ENA_CH1.Reg) & 0x4) >> 2
}
func (o *DMA_Type) SetINT_ENA_CH1_OUT_DONE_CH1_INT_ENA(value uint32) {
	volatile.StoreUint32(&o.INT_ENA_CH1.Reg, volatile.LoadUint32(&o.INT_ENA_CH1.Reg)&^(0x8)|value<<3)
}
func (o *DMA_Type) GetINT_ENA_CH1_OUT_DONE_CH1_INT_ENA() uint32 {
	return (volatile.LoadUint32(&o.INT_ENA_CH1.Reg) & 0x8) >> 3
}
func (o *DMA_Type) SetINT_ENA_CH1_OUT_EOF_CH1_INT_ENA(value uint32) {
	volatile.StoreUint32(&o.INT_ENA_CH1.Reg, volatile.LoadUint32(&o.INT_ENA_CH1.Reg)&^(0x10)|value<<4)
}
func (o *DMA_Type) GetINT_ENA_CH1_OUT_EOF_CH1_INT_ENA() uint32 {
	return (volatile.LoadUint32(&o.INT_ENA_CH1.Reg) & 0x10) >> 4
}
func (o *DMA_Type) SetINT_ENA_CH1_IN_DSCR_ERR_CH1_INT_ENA(value uint32) {
	volatile.StoreUint32(&o.INT_ENA_CH1.Reg, volatile.LoadUint32(&o.INT_ENA_CH1.Reg)&^(0x20)|value<<5)
}
func (o *DMA_Type) GetINT_ENA_CH1_IN_DSCR_ERR_CH1_INT_ENA() uint32 {
	return (volatile.LoadUint32(&o.INT_ENA_CH1.Reg) & 0x20) >> 5
}
func (o *DMA_Type) SetINT_ENA_CH1_OUT_DSCR_ERR_CH1_INT_ENA(value uint32) {
	volatile.StoreUint32(&o.INT_ENA_CH1.Reg, volatile.LoadUint32(&o.INT_ENA_CH1.Reg)&^(0x40)|value<<6)
}
func (o *DMA_Type) GetINT_ENA_CH1_OUT_DSCR_ERR_CH1_INT_ENA() uint32 {
	return (volatile.LoadUint32(&o.INT_ENA_CH1.Reg) & 0x40) >> 6
}
func (o *DMA_Type) SetINT_ENA_CH1_IN_DSCR_EMPTY_CH1_INT_ENA(value uint32) {
	volatile.StoreUint32(&o.INT_ENA_CH1.Reg, volatile.LoadUint32(&o.INT_ENA_CH1.Reg)&^(0x80)|value<<7)
}
func (o *DMA_Type) GetINT_ENA_CH1_IN_DSCR_EMPTY_CH1_INT_ENA() uint32 {
	return (volatile.LoadUint32(&o.INT_ENA_CH1.Reg) & 0x80) >> 7
}
func (o *DMA_Type) SetINT_ENA_CH1_OUT_TOTAL_EOF_CH1_INT_ENA(value uint32) {
	volatile.StoreUint32(&o.INT_ENA_CH1.Reg, volatile.LoadUint32(&o.INT_ENA_CH1.Reg)&^(0x100)|value<<8)
}
func (o *DMA_Type) GetINT_ENA_CH1_OUT_TOTAL_EOF_CH1_INT_ENA() uint32 {
	return (volatile.LoadUint32(&o.INT_ENA_CH1.Reg) & 0x100) >> 8
}
func (o *DMA_Type) SetINT_ENA_CH1_INFIFO_OVF_CH1_INT_ENA(value uint32) {
	volatile.StoreUint32(&o.INT_ENA_CH1.Reg, volatile.LoadUint32(&o.INT_ENA_CH1.Reg)&^(0x200)|value<<9)
}
func (o *DMA_Type) GetINT_ENA_CH1_INFIFO_OVF_CH1_INT_ENA() uint32 {
	return (volatile.LoadUint32(&o.INT_ENA_CH1.Reg) & 0x200) >> 9
}
func (o *DMA_Type) SetINT_ENA_CH1_INFIFO_UDF_CH1_INT_ENA(value uint32) {
	volatile.StoreUint32(&o.INT_ENA_CH1.Reg, volatile.LoadUint32(&o.INT_ENA_CH1.Reg)&^(0x400)|value<<10)
}
func (o *DMA_Type) GetINT_ENA_CH1_INFIFO_UDF_CH1_INT_ENA() uint32 {
	return (volatile.LoadUint32(&o.INT_ENA_CH1.Reg) & 0x400) >> 10
}
func (o *DMA_Type) SetINT_ENA_CH1_OUTFIFO_OVF_CH1_INT_ENA(value uint32) {
	volatile.StoreUint32(&o.INT_ENA_CH1.Reg, volatile.LoadUint32(&o.INT_ENA_CH1.Reg)&^(0x800)|value<<11)
}
func (o *DMA_Type) GetINT_ENA_CH1_OUTFIFO_OVF_CH1_INT_ENA() uint32 {
	return (volatile.LoadUint32(&o.INT_ENA_CH1.Reg) & 0x800) >> 11
}
func (o *DMA_Type) SetINT_ENA_CH1_OUTFIFO_UDF_CH1_INT_ENA(value uint32) {
	volatile.StoreUint32(&o.INT_ENA_CH1.Reg, volatile.LoadUint32(&o.INT_ENA_CH1.Reg)&^(0x1000)|value<<12)
}
func (o *DMA_Type) GetINT_ENA_CH1_OUTFIFO_UDF_CH1_INT_ENA() uint32 {
	return (volatile.LoadUint32(&o.INT_ENA_CH1.Reg) & 0x1000) >> 12
}

// DMA.INT_CLR_CH1: DMA_INT_CLR_CH1_REG.
func (o *DMA_Type) SetINT_CLR_CH1_IN_DONE_CH1_INT_CLR(value uint32) {
	volatile.StoreUint32(&o.INT_CLR_CH1.Reg, volatile.LoadUint32(&o.INT_CLR_CH1.Reg)&^(0x1)|value)
}
func (o *DMA_Type) GetINT_CLR_CH1_IN_DONE_CH1_INT_CLR() uint32 {
	return volatile.LoadUint32(&o.INT_CLR_CH1.Reg) & 0x1
}
func (o *DMA_Type) SetINT_CLR_CH1_IN_SUC_EOF_CH1_INT_CLR(value uint32) {
	volatile.StoreUint32(&o.INT_CLR_CH1.Reg, volatile.LoadUint32(&o.INT_CLR_CH1.Reg)&^(0x2)|value<<1)
}
func (o *DMA_Type) GetINT_CLR_CH1_IN_SUC_EOF_CH1_INT_CLR() uint32 {
	return (volatile.LoadUint32(&o.INT_CLR_CH1.Reg) & 0x2) >> 1
}
func (o *DMA_Type) SetINT_CLR_CH1_IN_ERR_EOF_CH1_INT_CLR(value uint32) {
	volatile.StoreUint32(&o.INT_CLR_CH1.Reg, volatile.LoadUint32(&o.INT_CLR_CH1.Reg)&^(0x4)|value<<2)
}
func (o *DMA_Type) GetINT_CLR_CH1_IN_ERR_EOF_CH1_INT_CLR() uint32 {
	return (volatile.LoadUint32(&o.INT_CLR_CH1.Reg) & 0x4) >> 2
}
func (o *DMA_Type) SetINT_CLR_CH1_OUT_DONE_CH1_INT_CLR(value uint32) {
	volatile.StoreUint32(&o.INT_CLR_CH1.Reg, volatile.LoadUint32(&o.INT_CLR_CH1.Reg)&^(0x8)|value<<3)
}
func (o *DMA_Type) GetINT_CLR_CH1_OUT_DONE_CH1_INT_CLR() uint32 {
	return (volatile.LoadUint32(&o.INT_CLR_CH1.Reg) & 0x8) >> 3
}
func (o *DMA_Type) SetINT_CLR_CH1_OUT_EOF_CH1_INT_CLR(value uint32) {
	volatile.StoreUint32(&o.INT_CLR_CH1.Reg, volatile.LoadUint32(&o.INT_CLR_CH1.Reg)&^(0x10)|value<<4)
}
func (o *DMA_Type) GetINT_CLR_CH1_OUT_EOF_CH1_INT_CLR() uint32 {
	return (volatile.LoadUint32(&o.INT_CLR_CH1.Reg) & 0x10) >> 4
}
func (o *DMA_Type) SetINT_CLR_CH1_IN_DSCR_ERR_CH1_INT_CLR(value uint32) {
	volatile.StoreUint32(&o.INT_CLR_CH1.Reg, volatile.LoadUint32(&o.INT_CLR_CH1.Reg)&^(0x20)|value<<5)
}
func (o *DMA_Type) GetINT_CLR_CH1_IN_DSCR_ERR_CH1_INT_CLR() uint32 {
	return (volatile.LoadUint32(&o.INT_CLR_CH1.Reg) & 0x20) >> 5
}
func (o *DMA_Type) SetINT_CLR_CH1_OUT_DSCR_ERR_CH1_INT_CLR(value uint32) {
	volatile.StoreUint32(&o.INT_CLR_CH1.Reg, volatile.LoadUint32(&o.INT_CLR_CH1.Reg)&^(0x40)|value<<6)
}
func (o *DMA_Type) GetINT_CLR_CH1_OUT_DSCR_ERR_CH1_INT_CLR() uint32 {
	return (volatile.LoadUint32(&o.INT_CLR_CH1.Reg) & 0x40) >> 6
}
func (o *DMA_Type) SetINT_CLR_CH1_IN_DSCR_EMPTY_CH1_INT_CLR(value uint32) {
	volatile.StoreUint32(&o.INT_CLR_CH1.Reg, volatile.LoadUint32(&o.INT_CLR_CH1.Reg)&^(0x80)|value<<7)
}
func (o *DMA_Type) GetINT_CLR_CH1_IN_DSCR_EMPTY_CH1_INT_CLR() uint32 {
	return (volatile.LoadUint32(&o.INT_CLR_CH1.Reg) & 0x80) >> 7
}
func (o *DMA_Type) SetINT_CLR_CH1_OUT_TOTAL_EOF_CH1_INT_CLR(value uint32) {
	volatile.StoreUint32(&o.INT_CLR_CH1.Reg, volatile.LoadUint32(&o.INT_CLR_CH1.Reg)&^(0x100)|value<<8)
}
func (o *DMA_Type) GetINT_CLR_CH1_OUT_TOTAL_EOF_CH1_INT_CLR() uint32 {
	return (volatile.LoadUint32(&o.INT_CLR_CH1.Reg) & 0x100) >> 8
}
func (o *DMA_Type) SetINT_CLR_CH1_INFIFO_OVF_CH1_INT_CLR(value uint32) {
	volatile.StoreUint32(&o.INT_CLR_CH1.Reg, volatile.LoadUint32(&o.INT_CLR_CH1.Reg)&^(0x200)|value<<9)
}
func (o *DMA_Type) GetINT_CLR_CH1_INFIFO_OVF_CH1_INT_CLR() uint32 {
	return (volatile.LoadUint32(&o.INT_CLR_CH1.Reg) & 0x200) >> 9
}
func (o *DMA_Type) SetINT_CLR_CH1_INFIFO_UDF_CH1_INT_CLR(value uint32) {
	volatile.StoreUint32(&o.INT_CLR_CH1.Reg, volatile.LoadUint32(&o.INT_CLR_CH1.Reg)&^(0x400)|value<<10)
}
func (o *DMA_Type) GetINT_CLR_CH1_INFIFO_UDF_CH1_INT_CLR() uint32 {
	return (volatile.LoadUint32(&o.INT_CLR_CH1.Reg) & 0x400) >> 10
}
func (o *DMA_Type) SetINT_CLR_CH1_OUTFIFO_OVF_CH1_INT_CLR(value uint32) {
	volatile.StoreUint32(&o.INT_CLR_CH1.Reg, volatile.LoadUint32(&o.INT_CLR_CH1.Reg)&^(0x800)|value<<11)
}
func (o *DMA_Type) GetINT_CLR_CH1_OUTFIFO_OVF_CH1_INT_CLR() uint32 {
	return (volatile.LoadUint32(&o.INT_CLR_CH1.Reg) & 0x800) >> 11
}
func (o *DMA_Type) SetINT_CLR_CH1_OUTFIFO_UDF_CH1_INT_CLR(value uint32) {
	volatile.StoreUint32(&o.INT_CLR_CH1.Reg, volatile.LoadUint32(&o.INT_CLR_CH1.Reg)&^(0x1000)|value<<12)
}
func (o *DMA_Type) GetINT_CLR_CH1_OUTFIFO_UDF_CH1_INT_CLR() uint32 {
	return (volatile.LoadUint32(&o.INT_CLR_CH1.Reg) & 0x1000) >> 12
}

// DMA.INT_RAW_CH2: DMA_INT_RAW_CH2_REG.
func (o *DMA_Type) SetINT_RAW_CH2_IN_DONE_CH2_INT_RAW(value uint32) {
	volatile.StoreUint32(&o.INT_RAW_CH2.Reg, volatile.LoadUint32(&o.INT_RAW_CH2.Reg)&^(0x1)|value)
}
func (o *DMA_Type) GetINT_RAW_CH2_IN_DONE_CH2_INT_RAW() uint32 {
	return volatile.LoadUint32(&o.INT_RAW_CH2.Reg) & 0x1
}
func (o *DMA_Type) SetINT_RAW_CH2_IN_SUC_EOF_CH2_INT_RAW(value uint32) {
	volatile.StoreUint32(&o.INT_RAW_CH2.Reg, volatile.LoadUint32(&o.INT_RAW_CH2.Reg)&^(0x2)|value<<1)
}
func (o *DMA_Type) GetINT_RAW_CH2_IN_SUC_EOF_CH2_INT_RAW() uint32 {
	return (volatile.LoadUint32(&o.INT_RAW_CH2.Reg) & 0x2) >> 1
}
func (o *DMA_Type) SetINT_RAW_CH2_IN_ERR_EOF_CH2_INT_RAW(value uint32) {
	volatile.StoreUint32(&o.INT_RAW_CH2.Reg, volatile.LoadUint32(&o.INT_RAW_CH2.Reg)&^(0x4)|value<<2)
}
func (o *DMA_Type) GetINT_RAW_CH2_IN_ERR_EOF_CH2_INT_RAW() uint32 {
	return (volatile.LoadUint32(&o.INT_RAW_CH2.Reg) & 0x4) >> 2
}
func (o *DMA_Type) SetINT_RAW_CH2_OUT_DONE_CH2_INT_RAW(value uint32) {
	volatile.StoreUint32(&o.INT_RAW_CH2.Reg, volatile.LoadUint32(&o.INT_RAW_CH2.Reg)&^(0x8)|value<<3)
}
func (o *DMA_Type) GetINT_RAW_CH2_OUT_DONE_CH2_INT_RAW() uint32 {
	return (volatile.LoadUint32(&o.INT_RAW_CH2.Reg) & 0x8) >> 3
}
func (o *DMA_Type) SetINT_RAW_CH2_OUT_EOF_CH2_INT_RAW(value uint32) {
	volatile.StoreUint32(&o.INT_RAW_CH2.Reg, volatile.LoadUint32(&o.INT_RAW_CH2.Reg)&^(0x10)|value<<4)
}
func (o *DMA_Type) GetINT_RAW_CH2_OUT_EOF_CH2_INT_RAW() uint32 {
	return (volatile.LoadUint32(&o.INT_RAW_CH2.Reg) & 0x10) >> 4
}
func (o *DMA_Type) SetINT_RAW_CH2_IN_DSCR_ERR_CH2_INT_RAW(value uint32) {
	volatile.StoreUint32(&o.INT_RAW_CH2.Reg, volatile.LoadUint32(&o.INT_RAW_CH2.Reg)&^(0x20)|value<<5)
}
func (o *DMA_Type) GetINT_RAW_CH2_IN_DSCR_ERR_CH2_INT_RAW() uint32 {
	return (volatile.LoadUint32(&o.INT_RAW_CH2.Reg) & 0x20) >> 5
}
func (o *DMA_Type) SetINT_RAW_CH2_OUT_DSCR_ERR_CH2_INT_RAW(value uint32) {
	volatile.StoreUint32(&o.INT_RAW_CH2.Reg, volatile.LoadUint32(&o.INT_RAW_CH2.Reg)&^(0x40)|value<<6)
}
func (o *DMA_Type) GetINT_RAW_CH2_OUT_DSCR_ERR_CH2_INT_RAW() uint32 {
	return (volatile.LoadUint32(&o.INT_RAW_CH2.Reg) & 0x40) >> 6
}
func (o *DMA_Type) SetINT_RAW_CH2_IN_DSCR_EMPTY_CH2_INT_RAW(value uint32) {
	volatile.StoreUint32(&o.INT_RAW_CH2.Reg, volatile.LoadUint32(&o.INT_RAW_CH2.Reg)&^(0x80)|value<<7)
}
func (o *DMA_Type) GetINT_RAW_CH2_IN_DSCR_EMPTY_CH2_INT_RAW() uint32 {
	return (volatile.LoadUint32(&o.INT_RAW_CH2.Reg) & 0x80) >> 7
}
func (o *DMA_Type) SetINT_RAW_CH2_OUT_TOTAL_EOF_CH2_INT_RAW(value uint32) {
	volatile.StoreUint32(&o.INT_RAW_CH2.Reg, volatile.LoadUint32(&o.INT_RAW_CH2.Reg)&^(0x100)|value<<8)
}
func (o *DMA_Type) GetINT_RAW_CH2_OUT_TOTAL_EOF_CH2_INT_RAW() uint32 {
	return (volatile.LoadUint32(&o.INT_RAW_CH2.Reg) & 0x100) >> 8
}
func (o *DMA_Type) SetINT_RAW_CH2_INFIFO_OVF_CH2_INT_RAW(value uint32) {
	volatile.StoreUint32(&o.INT_RAW_CH2.Reg, volatile.LoadUint32(&o.INT_RAW_CH2.Reg)&^(0x200)|value<<9)
}
func (o *DMA_Type) GetINT_RAW_CH2_INFIFO_OVF_CH2_INT_RAW() uint32 {
	return (volatile.LoadUint32(&o.INT_RAW_CH2.Reg) & 0x200) >> 9
}
func (o *DMA_Type) SetINT_RAW_CH2_INFIFO_UDF_CH2_INT_RAW(value uint32) {
	volatile.StoreUint32(&o.INT_RAW_CH2.Reg, volatile.LoadUint32(&o.INT_RAW_CH2.Reg)&^(0x400)|value<<10)
}
func (o *DMA_Type) GetINT_RAW_CH2_INFIFO_UDF_CH2_INT_RAW() uint32 {
	return (volatile.LoadUint32(&o.INT_RAW_CH2.Reg) & 0x400) >> 10
}
func (o *DMA_Type) SetINT_RAW_CH2_OUTFIFO_OVF_CH2_INT_RAW(value uint32) {
	volatile.StoreUint32(&o.INT_RAW_CH2.Reg, volatile.LoadUint32(&o.INT_RAW_CH2.Reg)&^(0x800)|value<<11)
}
func (o *DMA_Type) GetINT_RAW_CH2_OUTFIFO_OVF_CH2_INT_RAW() uint32 {
	return (volatile.LoadUint32(&o.INT_RAW_CH2.Reg) & 0x800) >> 11
}
func (o *DMA_Type) SetINT_RAW_CH2_OUTFIFO_UDF_CH2_INT_RAW(value uint32) {
	volatile.StoreUint32(&o.INT_RAW_CH2.Reg, volatile.LoadUint32(&o.INT_RAW_CH2.Reg)&^(0x1000)|value<<12)
}
func (o *DMA_Type) GetINT_RAW_CH2_OUTFIFO_UDF_CH2_INT_RAW() uint32 {
	return (volatile.LoadUint32(&o.INT_RAW_CH2.Reg) & 0x1000) >> 12
}

// DMA.INT_ST_CH2: DMA_INT_ST_CH2_REG.
func (o *DMA_Type) SetINT_ST_CH2_IN_DONE_CH2_INT_ST(value uint32) {
	volatile.StoreUint32(&o.INT_ST_CH2.Reg, volatile.LoadUint32(&o.INT_ST_CH2.Reg)&^(0x1)|value)
}
func (o *DMA_Type) GetINT_ST_CH2_IN_DONE_CH2_INT_ST() uint32 {
	return volatile.LoadUint32(&o.INT_ST_CH2.Reg) & 0x1
}
func (o *DMA_Type) SetINT_ST_CH2_IN_SUC_EOF_CH2_INT_ST(value uint32) {
	volatile.StoreUint32(&o.INT_ST_CH2.Reg, volatile.LoadUint32(&o.INT_ST_CH2.Reg)&^(0x2)|value<<1)
}
func (o *DMA_Type) GetINT_ST_CH2_IN_SUC_EOF_CH2_INT_ST() uint32 {
	return (volatile.LoadUint32(&o.INT_ST_CH2.Reg) & 0x2) >> 1
}
func (o *DMA_Type) SetINT_ST_CH2_IN_ERR_EOF_CH2_INT_ST(value uint32) {
	volatile.StoreUint32(&o.INT_ST_CH2.Reg, volatile.LoadUint32(&o.INT_ST_CH2.Reg)&^(0x4)|value<<2)
}
func (o *DMA_Type) GetINT_ST_CH2_IN_ERR_EOF_CH2_INT_ST() uint32 {
	return (volatile.LoadUint32(&o.INT_ST_CH2.Reg) & 0x4) >> 2
}
func (o *DMA_Type) SetINT_ST_CH2_OUT_DONE_CH2_INT_ST(value uint32) {
	volatile.StoreUint32(&o.INT_ST_CH2.Reg, volatile.LoadUint32(&o.INT_ST_CH2.Reg)&^(0x8)|value<<3)
}
func (o *DMA_Type) GetINT_ST_CH2_OUT_DONE_CH2_INT_ST() uint32 {
	return (volatile.LoadUint32(&o.INT_ST_CH2.Reg) & 0x8) >> 3
}
func (o *DMA_Type) SetINT_ST_CH2_OUT_EOF_CH2_INT_ST(value uint32) {
	volatile.StoreUint32(&o.INT_ST_CH2.Reg, volatile.LoadUint32(&o.INT_ST_CH2.Reg)&^(0x10)|value<<4)
}
func (o *DMA_Type) GetINT_ST_CH2_OUT_EOF_CH2_INT_ST() uint32 {
	return (volatile.LoadUint32(&o.INT_ST_CH2.Reg) & 0x10) >> 4
}
func (o *DMA_Type) SetINT_ST_CH2_IN_DSCR_ERR_CH2_INT_ST(value uint32) {
	volatile.StoreUint32(&o.INT_ST_CH2.Reg, volatile.LoadUint32(&o.INT_ST_CH2.Reg)&^(0x20)|value<<5)
}
func (o *DMA_Type) GetINT_ST_CH2_IN_DSCR_ERR_CH2_INT_ST() uint32 {
	return (volatile.LoadUint32(&o.INT_ST_CH2.Reg) & 0x20) >> 5
}
func (o *DMA_Type) SetINT_ST_CH2_OUT_DSCR_ERR_CH2_INT_ST(value uint32) {
	volatile.StoreUint32(&o.INT_ST_CH2.Reg, volatile.LoadUint32(&o.INT_ST_CH2.Reg)&^(0x40)|value<<6)
}
func (o *DMA_Type) GetINT_ST_CH2_OUT_DSCR_ERR_CH2_INT_ST() uint32 {
	return (volatile.LoadUint32(&o.INT_ST_CH2.Reg) & 0x40) >> 6
}
func (o *DMA_Type) SetINT_ST_CH2_IN_DSCR_EMPTY_CH2_INT_ST(value uint32) {
	volatile.StoreUint32(&o.INT_ST_CH2.Reg, volatile.LoadUint32(&o.INT_ST_CH2.Reg)&^(0x80)|value<<7)
}
func (o *DMA_Type) GetINT_ST_CH2_IN_DSCR_EMPTY_CH2_INT_ST() uint32 {
	return (volatile.LoadUint32(&o.INT_ST_CH2.Reg) & 0x80) >> 7
}
func (o *DMA_Type) SetINT_ST_CH2_OUT_TOTAL_EOF_CH2_INT_ST(value uint32) {
	volatile.StoreUint32(&o.INT_ST_CH2.Reg, volatile.LoadUint32(&o.INT_ST_CH2.Reg)&^(0x100)|value<<8)
}
func (o *DMA_Type) GetINT_ST_CH2_OUT_TOTAL_EOF_CH2_INT_ST() uint32 {
	return (volatile.LoadUint32(&o.INT_ST_CH2.Reg) & 0x100) >> 8
}
func (o *DMA_Type) SetINT_ST_CH2_INFIFO_OVF_CH2_INT_ST(value uint32) {
	volatile.StoreUint32(&o.INT_ST_CH2.Reg, volatile.LoadUint32(&o.INT_ST_CH2.Reg)&^(0x200)|value<<9)
}
func (o *DMA_Type) GetINT_ST_CH2_INFIFO_OVF_CH2_INT_ST() uint32 {
	return (volatile.LoadUint32(&o.INT_ST_CH2.Reg) & 0x200) >> 9
}
func (o *DMA_Type) SetINT_ST_CH2_INFIFO_UDF_CH2_INT_ST(value uint32) {
	volatile.StoreUint32(&o.INT_ST_CH2.Reg, volatile.LoadUint32(&o.INT_ST_CH2.Reg)&^(0x400)|value<<10)
}
func (o *DMA_Type) GetINT_ST_CH2_INFIFO_UDF_CH2_INT_ST() uint32 {
	return (volatile.LoadUint32(&o.INT_ST_CH2.Reg) & 0x400) >> 10
}
func (o *DMA_Type) SetINT_ST_CH2_OUTFIFO_OVF_CH2_INT_ST(value uint32) {
	volatile.StoreUint32(&o.INT_ST_CH2.Reg, volatile.LoadUint32(&o.INT_ST_CH2.Reg)&^(0x800)|value<<11)
}
func (o *DMA_Type) GetINT_ST_CH2_OUTFIFO_OVF_CH2_INT_ST() uint32 {
	return (volatile.LoadUint32(&o.INT_ST_CH2.Reg) & 0x800) >> 11
}
func (o *DMA_Type) SetINT_ST_CH2_OUTFIFO_UDF_CH2_INT_ST(value uint32) {
	volatile.StoreUint32(&o.INT_ST_CH2.Reg, volatile.LoadUint32(&o.INT_ST_CH2.Reg)&^(0x1000)|value<<12)
}
func (o *DMA_Type) GetINT_ST_CH2_OUTFIFO_UDF_CH2_INT_ST() uint32 {
	return (volatile.LoadUint32(&o.INT_ST_CH2.Reg) & 0x1000) >> 12
}

// DMA.INT_ENA_CH2: DMA_INT_ENA_CH2_REG.
func (o *DMA_Type) SetINT_ENA_CH2_IN_DONE_CH2_INT_ENA(value uint32) {
	volatile.StoreUint32(&o.INT_ENA_CH2.Reg, volatile.LoadUint32(&o.INT_ENA_CH2.Reg)&^(0x1)|value)
}
func (o *DMA_Type) GetINT_ENA_CH2_IN_DONE_CH2_INT_ENA() uint32 {
	return volatile.LoadUint32(&o.INT_ENA_CH2.Reg) & 0x1
}
func (o *DMA_Type) SetINT_ENA_CH2_IN_SUC_EOF_CH2_INT_ENA(value uint32) {
	volatile.StoreUint32(&o.INT_ENA_CH2.Reg, volatile.LoadUint32(&o.INT_ENA_CH2.Reg)&^(0x2)|value<<1)
}
func (o *DMA_Type) GetINT_ENA_CH2_IN_SUC_EOF_CH2_INT_ENA() uint32 {
	return (volatile.LoadUint32(&o.INT_ENA_CH2.Reg) & 0x2) >> 1
}
func (o *DMA_Type) SetINT_ENA_CH2_IN_ERR_EOF_CH2_INT_ENA(value uint32) {
	volatile.StoreUint32(&o.INT_ENA_CH2.Reg, volatile.LoadUint32(&o.INT_ENA_CH2.Reg)&^(0x4)|value<<2)
}
func (o *DMA_Type) GetINT_ENA_CH2_IN_ERR_EOF_CH2_INT_ENA() uint32 {
	return (volatile.LoadUint32(&o.INT_ENA_CH2.Reg) & 0x4) >> 2
}
func (o *DMA_Type) SetINT_ENA_CH2_OUT_DONE_CH2_INT_ENA(value uint32) {
	volatile.StoreUint32(&o.INT_ENA_CH2.Reg, volatile.LoadUint32(&o.INT_ENA_CH2.Reg)&^(0x8)|value<<3)
}
func (o *DMA_Type) GetINT_ENA_CH2_OUT_DONE_CH2_INT_ENA() uint32 {
	return (volatile.LoadUint32(&o.INT_ENA_CH2.Reg) & 0x8) >> 3
}
func (o *DMA_Type) SetINT_ENA_CH2_OUT_EOF_CH2_INT_ENA(value uint32) {
	volatile.StoreUint32(&o.INT_ENA_CH2.Reg, volatile.LoadUint32(&o.INT_ENA_CH2.Reg)&^(0x10)|value<<4)
}
func (o *DMA_Type) GetINT_ENA_CH2_OUT_EOF_CH2_INT_ENA() uint32 {
	return (volatile.LoadUint32(&o.INT_ENA_CH2.Reg) & 0x10) >> 4
}
func (o *DMA_Type) SetINT_ENA_CH2_IN_DSCR_ERR_CH2_INT_ENA(value uint32) {
	volatile.StoreUint32(&o.INT_ENA_CH2.Reg, volatile.LoadUint32(&o.INT_ENA_CH2.Reg)&^(0x20)|value<<5)
}
func (o *DMA_Type) GetINT_ENA_CH2_IN_DSCR_ERR_CH2_INT_ENA() uint32 {
	return (volatile.LoadUint32(&o.INT_ENA_CH2.Reg) & 0x20) >> 5
}
func (o *DMA_Type) SetINT_ENA_CH2_OUT_DSCR_ERR_CH2_INT_ENA(value uint32) {
	volatile.StoreUint32(&o.INT_ENA_CH2.Reg, volatile.LoadUint32(&o.INT_ENA_CH2.Reg)&^(0x40)|value<<6)
}
func (o *DMA_Type) GetINT_ENA_CH2_OUT_DSCR_ERR_CH2_INT_ENA() uint32 {
	return (volatile.LoadUint32(&o.INT_ENA_CH2.Reg) & 0x40) >> 6
}
func (o *DMA_Type) SetINT_ENA_CH2_IN_DSCR_EMPTY_CH2_INT_ENA(value uint32) {
	volatile.StoreUint32(&o.INT_ENA_CH2.Reg, volatile.LoadUint32(&o.INT_ENA_CH2.Reg)&^(0x80)|value<<7)
}
func (o *DMA_Type) GetINT_ENA_CH2_IN_DSCR_EMPTY_CH2_INT_ENA() uint32 {
	return (volatile.LoadUint32(&o.INT_ENA_CH2.Reg) & 0x80) >> 7
}
func (o *DMA_Type) SetINT_ENA_CH2_OUT_TOTAL_EOF_CH2_INT_ENA(value uint32) {
	volatile.StoreUint32(&o.INT_ENA_CH2.Reg, volatile.LoadUint32(&o.INT_ENA_CH2.Reg)&^(0x100)|value<<8)
}
func (o *DMA_Type) GetINT_ENA_CH2_OUT_TOTAL_EOF_CH2_INT_ENA() uint32 {
	return (volatile.LoadUint32(&o.INT_ENA_CH2.Reg) & 0x100) >> 8
}
func (o *DMA_Type) SetINT_ENA_CH2_INFIFO_OVF_CH2_INT_ENA(value uint32) {
	volatile.StoreUint32(&o.INT_ENA_CH2.Reg, volatile.LoadUint32(&o.INT_ENA_CH2.Reg)&^(0x200)|value<<9)
}
func (o *DMA_Type) GetINT_ENA_CH2_INFIFO_OVF_CH2_INT_ENA() uint32 {
	return (volatile.LoadUint32(&o.INT_ENA_CH2.Reg) & 0x200) >> 9
}
func (o *DMA_Type) SetINT_ENA_CH2_INFIFO_UDF_CH2_INT_ENA(value uint32) {
	volatile.StoreUint32(&o.INT_ENA_CH2.Reg, volatile.LoadUint32(&o.INT_ENA_CH2.Reg)&^(0x400)|value<<10)
}
func (o *DMA_Type) GetINT_ENA_CH2_INFIFO_UDF_CH2_INT_ENA() uint32 {
	return (volatile.LoadUint32(&o.INT_ENA_CH2.Reg) & 0x400) >> 10
}
func (o *DMA_Type) SetINT_ENA_CH2_OUTFIFO_OVF_CH2_INT_ENA(value uint32) {
	volatile.StoreUint32(&o.INT_ENA_CH2.Reg, volatile.LoadUint32(&o.INT_ENA_CH2.Reg)&^(0x800)|value<<11)
}
func (o *DMA_Type) GetINT_ENA_CH2_OUTFIFO_OVF_CH2_INT_ENA() uint32 {
	return (volatile.LoadUint32(&o.INT_ENA_CH2.Reg) & 0x800) >> 11
}
func (o *DMA_Type) SetINT_ENA_CH2_OUTFIFO_UDF_CH2_INT_ENA(value uint32) {
	volatile.StoreUint32(&o.INT_ENA_CH2.Reg, volatile.LoadUint32(&o.INT_ENA_CH2.Reg)&^(0x1000)|value<<12)
}
func (o *DMA_Type) GetINT_ENA_CH2_OUTFIFO_UDF_CH2_INT_ENA() uint32 {
	return (volatile.LoadUint32(&o.INT_ENA_CH2.Reg) & 0x1000) >> 12
}

// DMA.INT_CLR_CH2: DMA_INT_CLR_CH2_REG.
func (o *DMA_Type) SetINT_CLR_CH2_IN_DONE_CH2_INT_CLR(value uint32) {
	volatile.StoreUint32(&o.INT_CLR_CH2.Reg, volatile.LoadUint32(&o.INT_CLR_CH2.Reg)&^(0x1)|value)
}
func (o *DMA_Type) GetINT_CLR_CH2_IN_DONE_CH2_INT_CLR() uint32 {
	return volatile.LoadUint32(&o.INT_CLR_CH2.Reg) & 0x1
}
func (o *DMA_Type) SetINT_CLR_CH2_IN_SUC_EOF_CH2_INT_CLR(value uint32) {
	volatile.StoreUint32(&o.INT_CLR_CH2.Reg, volatile.LoadUint32(&o.INT_CLR_CH2.Reg)&^(0x2)|value<<1)
}
func (o *DMA_Type) GetINT_CLR_CH2_IN_SUC_EOF_CH2_INT_CLR() uint32 {
	return (volatile.LoadUint32(&o.INT_CLR_CH2.Reg) & 0x2) >> 1
}
func (o *DMA_Type) SetINT_CLR_CH2_IN_ERR_EOF_CH2_INT_CLR(value uint32) {
	volatile.StoreUint32(&o.INT_CLR_CH2.Reg, volatile.LoadUint32(&o.INT_CLR_CH2.Reg)&^(0x4)|value<<2)
}
func (o *DMA_Type) GetINT_CLR_CH2_IN_ERR_EOF_CH2_INT_CLR() uint32 {
	return (volatile.LoadUint32(&o.INT_CLR_CH2.Reg) & 0x4) >> 2
}
func (o *DMA_Type) SetINT_CLR_CH2_OUT_DONE_CH2_INT_CLR(value uint32) {
	volatile.StoreUint32(&o.INT_CLR_CH2.Reg, volatile.LoadUint32(&o.INT_CLR_CH2.Reg)&^(0x8)|value<<3)
}
func (o *DMA_Type) GetINT_CLR_CH2_OUT_DONE_CH2_INT_CLR() uint32 {
	return (volatile.LoadUint32(&o.INT_CLR_CH2.Reg) & 0x8) >> 3
}
func (o *DMA_Type) SetINT_CLR_CH2_OUT_EOF_CH2_INT_CLR(value uint32) {
	volatile.StoreUint32(&o.INT_CLR_CH2.Reg, volatile.LoadUint32(&o.INT_CLR_CH2.Reg)&^(0x10)|value<<4)
}
func (o *DMA_Type) GetINT_CLR_CH2_OUT_EOF_CH2_INT_CLR() uint32 {
	return (volatile.LoadUint32(&o.INT_CLR_CH2.Reg) & 0x10) >> 4
}
func (o *DMA_Type) SetINT_CLR_CH2_IN_DSCR_ERR_CH2_INT_CLR(value uint32) {
	volatile.StoreUint32(&o.INT_CLR_CH2.Reg, volatile.LoadUint32(&o.INT_CLR_CH2.Reg)&^(0x20)|value<<5)
}
func (o *DMA_Type) GetINT_CLR_CH2_IN_DSCR_ERR_CH2_INT_CLR() uint32 {
	return (volatile.LoadUint32(&o.INT_CLR_CH2.Reg) & 0x20) >> 5
}
func (o *DMA_Type) SetINT_CLR_CH2_OUT_DSCR_ERR_CH2_INT_CLR(value uint32) {
	volatile.StoreUint32(&o.INT_CLR_CH2.Reg, volatile.LoadUint32(&o.INT_CLR_CH2.Reg)&^(0x40)|value<<6)
}
func (o *DMA_Type) GetINT_CLR_CH2_OUT_DSCR_ERR_CH2_INT_CLR() uint32 {
	return (volatile.LoadUint32(&o.INT_CLR_CH2.Reg) & 0x40) >> 6
}
func (o *DMA_Type) SetINT_CLR_CH2_IN_DSCR_EMPTY_CH2_INT_CLR(value uint32) {
	volatile.StoreUint32(&o.INT_CLR_CH2.Reg, volatile.LoadUint32(&o.INT_CLR_CH2.Reg)&^(0x80)|value<<7)
}
func (o *DMA_Type) GetINT_CLR_CH2_IN_DSCR_EMPTY_CH2_INT_CLR() uint32 {
	return (volatile.LoadUint32(&o.INT_CLR_CH2.Reg) & 0x80) >> 7
}
func (o *DMA_Type) SetINT_CLR_CH2_OUT_TOTAL_EOF_CH2_INT_CLR(value uint32) {
	volatile.StoreUint32(&o.INT_CLR_CH2.Reg, volatile.LoadUint32(&o.INT_CLR_CH2.Reg)&^(0x100)|value<<8)
}
func (o *DMA_Type) GetINT_CLR_CH2_OUT_TOTAL_EOF_CH2_INT_CLR() uint32 {
	return (volatile.LoadUint32(&o.INT_CLR_CH2.Reg) & 0x100) >> 8
}
func (o *DMA_Type) SetINT_CLR_CH2_INFIFO_OVF_CH2_INT_CLR(value uint32) {
	volatile.StoreUint32(&o.INT_CLR_CH2.Reg, volatile.LoadUint32(&o.INT_CLR_CH2.Reg)&^(0x200)|value<<9)
}
func (o *DMA_Type) GetINT_CLR_CH2_INFIFO_OVF_CH2_INT_CLR() uint32 {
	return (volatile.LoadUint32(&o.INT_CLR_CH2.Reg) & 0x200) >> 9
}
func (o *DMA_Type) SetINT_CLR_CH2_INFIFO_UDF_CH2_INT_CLR(value uint32) {
	volatile.StoreUint32(&o.INT_CLR_CH2.Reg, volatile.LoadUint32(&o.INT_CLR_CH2.Reg)&^(0x400)|value<<10)
}
func (o *DMA_Type) GetINT_CLR_CH2_INFIFO_UDF_CH2_INT_CLR() uint32 {
	return (volatile.LoadUint32(&o.INT_CLR_CH2.Reg) & 0x400) >> 10
}
func (o *DMA_Type) SetINT_CLR_CH2_OUTFIFO_OVF_CH2_INT_CLR(value uint32) {
	volatile.StoreUint32(&o.INT_CLR_CH2.Reg, volatile.LoadUint32(&o.INT_CLR_CH2.Reg)&^(0x800)|value<<11)
}
func (o *DMA_Type) GetINT_CLR_CH2_OUTFIFO_OVF_CH2_INT_CLR() uint32 {
	return (volatile.LoadUint32(&o.INT_CLR_CH2.Reg) & 0x800) >> 11
}
func (o *DMA_Type) SetINT_CLR_CH2_OUTFIFO_UDF_CH2_INT_CLR(value uint32) {
	volatile.StoreUint32(&o.INT_CLR_CH2.Reg, volatile.LoadUint32(&o.INT_CLR_CH2.Reg)&^(0x1000)|value<<12)
}
func (o *DMA_Type) GetINT_CLR_CH2_OUTFIFO_UDF_CH2_INT_CLR() uint32 {
	return (volatile.LoadUint32(&o.INT_CLR_CH2.Reg) & 0x1000) >> 12
}

// DMA.AHB_TEST: DMA_AHB_TEST_REG.
func (o *DMA_Type) SetAHB_TEST_AHB_TESTMODE(value uint32) {
	volatile.StoreUint32(&o.AHB_TEST.Reg, volatile.LoadUint32(&o.AHB_TEST.Reg)&^(0x7)|value)
}
func (o *DMA_Type) GetAHB_TEST_AHB_TESTMODE() uint32 {
	return volatile.LoadUint32(&o.AHB_TEST.Reg) & 0x7
}
func (o *DMA_Type) SetAHB_TEST_AHB_TESTADDR(value uint32) {
	volatile.StoreUint32(&o.AHB_TEST.Reg, volatile.LoadUint32(&o.AHB_TEST.Reg)&^(0x30)|value<<4)
}
func (o *DMA_Type) GetAHB_TEST_AHB_TESTADDR() uint32 {
	return (volatile.LoadUint32(&o.AHB_TEST.Reg) & 0x30) >> 4
}

// DMA.MISC_CONF: DMA_MISC_CONF_REG.
func (o *DMA_Type) SetMISC_CONF_AHBM_RST_INTER(value uint32) {
	volatile.StoreUint32(&o.MISC_CONF.Reg, volatile.LoadUint32(&o.MISC_CONF.Reg)&^(0x1)|value)
}
func (o *DMA_Type) GetMISC_CONF_AHBM_RST_INTER() uint32 {
	return volatile.LoadUint32(&o.MISC_CONF.Reg) & 0x1
}
func (o *DMA_Type) SetMISC_CONF_ARB_PRI_DIS(value uint32) {
	volatile.StoreUint32(&o.MISC_CONF.Reg, volatile.LoadUint32(&o.MISC_CONF.Reg)&^(0x4)|value<<2)
}
func (o *DMA_Type) GetMISC_CONF_ARB_PRI_DIS() uint32 {
	return (volatile.LoadUint32(&o.MISC_CONF.Reg) & 0x4) >> 2
}
func (o *DMA_Type) SetMISC_CONF_CLK_EN(value uint32) {
	volatile.StoreUint32(&o.MISC_CONF.Reg, volatile.LoadUint32(&o.MISC_CONF.Reg)&^(0x8)|value<<3)
}
func (o *DMA_Type) GetMISC_CONF_CLK_EN() uint32 {
	return (volatile.LoadUint32(&o.MISC_CONF.Reg) & 0x8) >> 3
}

// DMA.DATE: DMA_DATE_REG.
func (o *DMA_Type) SetDATE(value uint32) {
	volatile.StoreUint32(&o.DATE.Reg, value)
}
func (o *DMA_Type) GetDATE() uint32 {
	return volatile.LoadUint32(&o.DATE.Reg)
}

// DMA.IN_CONF0_CH0: DMA_IN_CONF0_CH0_REG.
func (o *DMA_Type) SetIN_CONF0_CH0_IN_RST_CH0(value uint32) {
	volatile.StoreUint32(&o.IN_CONF0_CH0.Reg, volatile.LoadUint32(&o.IN_CONF0_CH0.Reg)&^(0x1)|value)
}
func (o *DMA_Type) GetIN_CONF0_CH0_IN_RST_CH0() uint32 {
	return volatile.LoadUint32(&o.IN_CONF0_CH0.Reg) & 0x1
}
func (o *DMA_Type) SetIN_CONF0_CH0_IN_LOOP_TEST_CH0(value uint32) {
	volatile.StoreUint32(&o.IN_CONF0_CH0.Reg, volatile.LoadUint32(&o.IN_CONF0_CH0.Reg)&^(0x2)|value<<1)
}
func (o *DMA_Type) GetIN_CONF0_CH0_IN_LOOP_TEST_CH0() uint32 {
	return (volatile.LoadUint32(&o.IN_CONF0_CH0.Reg) & 0x2) >> 1
}
func (o *DMA_Type) SetIN_CONF0_CH0_INDSCR_BURST_EN_CH0(value uint32) {
	volatile.StoreUint32(&o.IN_CONF0_CH0.Reg, volatile.LoadUint32(&o.IN_CONF0_CH0.Reg)&^(0x4)|value<<2)
}
func (o *DMA_Type) GetIN_CONF0_CH0_INDSCR_BURST_EN_CH0() uint32 {
	return (volatile.LoadUint32(&o.IN_CONF0_CH0.Reg) & 0x4) >> 2
}
func (o *DMA_Type) SetIN_CONF0_CH0_IN_DATA_BURST_EN_CH0(value uint32) {
	volatile.StoreUint32(&o.IN_CONF0_CH0.Reg, volatile.LoadUint32(&o.IN_CONF0_CH0.Reg)&^(0x8)|value<<3)
}
func (o *DMA_Type) GetIN_CONF0_CH0_IN_DATA_BURST_EN_CH0() uint32 {
	return (volatile.LoadUint32(&o.IN_CONF0_CH0.Reg) & 0x8) >> 3
}
func (o *DMA_Type) SetIN_CONF0_CH0_MEM_TRANS_EN_CH0(value uint32) {
	volatile.StoreUint32(&o.IN_CONF0_CH0.Reg, volatile.LoadUint32(&o.IN_CONF0_CH0.Reg)&^(0x10)|value<<4)
}
func (o *DMA_Type) GetIN_CONF0_CH0_MEM_TRANS_EN_CH0() uint32 {
	return (volatile.LoadUint32(&o.IN_CONF0_CH0.Reg) & 0x10) >> 4
}

// DMA.IN_CONF1_CH0: DMA_IN_CONF1_CH0_REG.
func (o *DMA_Type) SetIN_CONF1_CH0_IN_CHECK_OWNER_CH0(value uint32) {
	volatile.StoreUint32(&o.IN_CONF1_CH0.Reg, volatile.LoadUint32(&o.IN_CONF1_CH0.Reg)&^(0x1000)|value<<12)
}
func (o *DMA_Type) GetIN_CONF1_CH0_IN_CHECK_OWNER_CH0() uint32 {
	return (volatile.LoadUint32(&o.IN_CONF1_CH0.Reg) & 0x1000) >> 12
}

// DMA.INFIFO_STATUS_CH0: DMA_INFIFO_STATUS_CH0_REG.
func (o *DMA_Type) SetINFIFO_STATUS_CH0_INFIFO_FULL_CH0(value uint32) {
	volatile.StoreUint32(&o.INFIFO_STATUS_CH0.Reg, volatile.LoadUint32(&o.INFIFO_STATUS_CH0.Reg)&^(0x1)|value)
}
func (o *DMA_Type) GetINFIFO_STATUS_CH0_INFIFO_FULL_CH0() uint32 {
	return volatile.LoadUint32(&o.INFIFO_STATUS_CH0.Reg) & 0x1
}
func (o *DMA_Type) SetINFIFO_STATUS_CH0_INFIFO_EMPTY_CH0(value uint32) {
	volatile.StoreUint32(&o.INFIFO_STATUS_CH0.Reg, volatile.LoadUint32(&o.INFIFO_STATUS_CH0.Reg)&^(0x2)|value<<1)
}
func (o *DMA_Type) GetINFIFO_STATUS_CH0_INFIFO_EMPTY_CH0() uint32 {
	return (volatile.LoadUint32(&o.INFIFO_STATUS_CH0.Reg) & 0x2) >> 1
}
func (o *DMA_Type) SetINFIFO_STATUS_CH0_INFIFO_CNT_CH0(value uint32) {
	volatile.StoreUint32(&o.INFIFO_STATUS_CH0.Reg, volatile.LoadUint32(&o.INFIFO_STATUS_CH0.Reg)&^(0xfc)|value<<2)
}
func (o *DMA_Type) GetINFIFO_STATUS_CH0_INFIFO_CNT_CH0() uint32 {
	return (volatile.LoadUint32(&o.INFIFO_STATUS_CH0.Reg) & 0xfc) >> 2
}
func (o *DMA_Type) SetINFIFO_STATUS_CH0_IN_REMAIN_UNDER_1B_CH0(value uint32) {
	volatile.StoreUint32(&o.INFIFO_STATUS_CH0.Reg, volatile.LoadUint32(&o.INFIFO_STATUS_CH0.Reg)&^(0x800000)|value<<23)
}
func (o *DMA_Type) GetINFIFO_STATUS_CH0_IN_REMAIN_UNDER_1B_CH0() uint32 {
	return (volatile.LoadUint32(&o.INFIFO_STATUS_CH0.Reg) & 0x800000) >> 23
}
func (o *DMA_Type) SetINFIFO_STATUS_CH0_IN_REMAIN_UNDER_2B_CH0(value uint32) {
	volatile.StoreUint32(&o.INFIFO_STATUS_CH0.Reg, volatile.LoadUint32(&o.INFIFO_STATUS_CH0.Reg)&^(0x1000000)|value<<24)
}
func (o *DMA_Type) GetINFIFO_STATUS_CH0_IN_REMAIN_UNDER_2B_CH0() uint32 {
	return (volatile.LoadUint32(&o.INFIFO_STATUS_CH0.Reg) & 0x1000000) >> 24
}
func (o *DMA_Type) SetINFIFO_STATUS_CH0_IN_REMAIN_UNDER_3B_CH0(value uint32) {
	volatile.StoreUint32(&o.INFIFO_STATUS_CH0.Reg, volatile.LoadUint32(&o.INFIFO_STATUS_CH0.Reg)&^(0x2000000)|value<<25)
}
func (o *DMA_Type) GetINFIFO_STATUS_CH0_IN_REMAIN_UNDER_3B_CH0() uint32 {
	return (volatile.LoadUint32(&o.INFIFO_STATUS_CH0.Reg) & 0x2000000) >> 25
}
func (o *DMA_Type) SetINFIFO_STATUS_CH0_IN_REMAIN_UNDER_4B_CH0(value uint32) {
	volatile.StoreUint32(&o.INFIFO_STATUS_CH0.Reg, volatile.LoadUint32(&o.INFIFO_STATUS_CH0.Reg)&^(0x4000000)|value<<26)
}
func (o *DMA_Type) GetINFIFO_STATUS_CH0_IN_REMAIN_UNDER_4B_CH0() uint32 {
	return (volatile.LoadUint32(&o.INFIFO_STATUS_CH0.Reg) & 0x4000000) >> 26
}
func (o *DMA_Type) SetINFIFO_STATUS_CH0_IN_BUF_HUNGRY_CH0(value uint32) {
	volatile.StoreUint32(&o.INFIFO_STATUS_CH0.Reg, volatile.LoadUint32(&o.INFIFO_STATUS_CH0.Reg)&^(0x8000000)|value<<27)
}
func (o *DMA_Type) GetINFIFO_STATUS_CH0_IN_BUF_HUNGRY_CH0() uint32 {
	return (volatile.LoadUint32(&o.INFIFO_STATUS_CH0.Reg) & 0x8000000) >> 27
}

// DMA.IN_POP_CH0: DMA_IN_POP_CH0_REG.
func (o *DMA_Type) SetIN_POP_CH0_INFIFO_RDATA_CH0(value uint32) {
	volatile.StoreUint32(&o.IN_POP_CH0.Reg, volatile.LoadUint32(&o.IN_POP_CH0.Reg)&^(0xfff)|value)
}
func (o *DMA_Type) GetIN_POP_CH0_INFIFO_RDATA_CH0() uint32 {
	return volatile.LoadUint32(&o.IN_POP_CH0.Reg) & 0xfff
}
func (o *DMA_Type) SetIN_POP_CH0_INFIFO_POP_CH0(value uint32) {
	volatile.StoreUint32(&o.IN_POP_CH0.Reg, volatile.LoadUint32(&o.IN_POP_CH0.Reg)&^(0x1000)|value<<12)
}
func (o *DMA_Type) GetIN_POP_CH0_INFIFO_POP_CH0() uint32 {
	return (volatile.LoadUint32(&o.IN_POP_CH0.Reg) & 0x1000) >> 12
}

// DMA.IN_LINK_CH0: DMA_IN_LINK_CH0_REG.
func (o *DMA_Type) SetIN_LINK_CH0_INLINK_ADDR_CH0(value uint32) {
	volatile.StoreUint32(&o.IN_LINK_CH0.Reg, volatile.LoadUint32(&o.IN_LINK_CH0.Reg)&^(0xfffff)|value)
}
func (o *DMA_Type) GetIN_LINK_CH0_INLINK_ADDR_CH0() uint32 {
	return volatile.LoadUint32(&o.IN_LINK_CH0.Reg) & 0xfffff
}
func (o *DMA_Type) SetIN_LINK_CH0_INLINK_AUTO_RET_CH0(value uint32) {
	volatile.StoreUint32(&o.IN_LINK_CH0.Reg, volatile.LoadUint32(&o.IN_LINK_CH0.Reg)&^(0x100000)|value<<20)
}
func (o *DMA_Type) GetIN_LINK_CH0_INLINK_AUTO_RET_CH0() uint32 {
	return (volatile.LoadUint32(&o.IN_LINK_CH0.Reg) & 0x100000) >> 20
}
func (o *DMA_Type) SetIN_LINK_CH0_INLINK_STOP_CH0(value uint32) {
	volatile.StoreUint32(&o.IN_LINK_CH0.Reg, volatile.LoadUint32(&o.IN_LINK_CH0.Reg)&^(0x200000)|value<<21)
}
func (o *DMA_Type) GetIN_LINK_CH0_INLINK_STOP_CH0() uint32 {
	return (volatile.LoadUint32(&o.IN_LINK_CH0.Reg) & 0x200000) >> 21
}
func (o *DMA_Type) SetIN_LINK_CH0_INLINK_START_CH0(value uint32) {
	volatile.StoreUint32(&o.IN_LINK_CH0.Reg, volatile.LoadUint32(&o.IN_LINK_CH0.Reg)&^(0x400000)|value<<22)
}
func (o *DMA_Type) GetIN_LINK_CH0_INLINK_START_CH0() uint32 {
	return (volatile.LoadUint32(&o.IN_LINK_CH0.Reg) & 0x400000) >> 22
}
func (o *DMA_Type) SetIN_LINK_CH0_INLINK_RESTART_CH0(value uint32) {
	volatile.StoreUint32(&o.IN_LINK_CH0.Reg, volatile.LoadUint32(&o.IN_LINK_CH0.Reg)&^(0x800000)|value<<23)
}
func (o *DMA_Type) GetIN_LINK_CH0_INLINK_RESTART_CH0() uint32 {
	return (volatile.LoadUint32(&o.IN_LINK_CH0.Reg) & 0x800000) >> 23
}
func (o *DMA_Type) SetIN_LINK_CH0_INLINK_PARK_CH0(value uint32) {
	volatile.StoreUint32(&o.IN_LINK_CH0.Reg, volatile.LoadUint32(&o.IN_LINK_CH0.Reg)&^(0x1000000)|value<<24)
}
func (o *DMA_Type) GetIN_LINK_CH0_INLINK_PARK_CH0() uint32 {
	return (volatile.LoadUint32(&o.IN_LINK_CH0.Reg) & 0x1000000) >> 24
}

// DMA.IN_STATE_CH0: DMA_IN_STATE_CH0_REG.
func (o *DMA_Type) SetIN_STATE_CH0_INLINK_DSCR_ADDR_CH0(value uint32) {
	volatile.StoreUint32(&o.IN_STATE_CH0.Reg, volatile.LoadUint32(&o.IN_STATE_CH0.Reg)&^(0x3ffff)|value)
}
func (o *DMA_Type) GetIN_STATE_CH0_INLINK_DSCR_ADDR_CH0() uint32 {
	return volatile.LoadUint32(&o.IN_STATE_CH0.Reg) & 0x3ffff
}
func (o *DMA_Type) SetIN_STATE_CH0_IN_DSCR_STATE_CH0(value uint32) {
	volatile.StoreUint32(&o.IN_STATE_CH0.Reg, volatile.LoadUint32(&o.IN_STATE_CH0.Reg)&^(0xc0000)|value<<18)
}
func (o *DMA_Type) GetIN_STATE_CH0_IN_DSCR_STATE_CH0() uint32 {
	return (volatile.LoadUint32(&o.IN_STATE_CH0.Reg) & 0xc0000) >> 18
}
func (o *DMA_Type) SetIN_STATE_CH0(value uint32) {
	volatile.StoreUint32(&o.IN_STATE_CH0.Reg, volatile.LoadUint32(&o.IN_STATE_CH0.Reg)&^(0x700000)|value<<20)
}
func (o *DMA_Type) GetIN_STATE_CH0() uint32 {
	return (volatile.LoadUint32(&o.IN_STATE_CH0.Reg) & 0x700000) >> 20
}

// DMA.IN_SUC_EOF_DES_ADDR_CH0: DMA_IN_SUC_EOF_DES_ADDR_CH0_REG.
func (o *DMA_Type) SetIN_SUC_EOF_DES_ADDR_CH0(value uint32) {
	volatile.StoreUint32(&o.IN_SUC_EOF_DES_ADDR_CH0.Reg, value)
}
func (o *DMA_Type) GetIN_SUC_EOF_DES_ADDR_CH0() uint32 {
	return volatile.LoadUint32(&o.IN_SUC_EOF_DES_ADDR_CH0.Reg)
}

// DMA.IN_ERR_EOF_DES_ADDR_CH0: DMA_IN_ERR_EOF_DES_ADDR_CH0_REG.
func (o *DMA_Type) SetIN_ERR_EOF_DES_ADDR_CH0(value uint32) {
	volatile.StoreUint32(&o.IN_ERR_EOF_DES_ADDR_CH0.Reg, value)
}
func (o *DMA_Type) GetIN_ERR_EOF_DES_ADDR_CH0() uint32 {
	return volatile.LoadUint32(&o.IN_ERR_EOF_DES_ADDR_CH0.Reg)
}

// DMA.IN_DSCR_CH0: DMA_IN_DSCR_CH0_REG.
func (o *DMA_Type) SetIN_DSCR_CH0(value uint32) {
	volatile.StoreUint32(&o.IN_DSCR_CH0.Reg, value)
}
func (o *DMA_Type) GetIN_DSCR_CH0() uint32 {
	return volatile.LoadUint32(&o.IN_DSCR_CH0.Reg)
}

// DMA.IN_DSCR_BF0_CH0: DMA_IN_DSCR_BF0_CH0_REG.
func (o *DMA_Type) SetIN_DSCR_BF0_CH0(value uint32) {
	volatile.StoreUint32(&o.IN_DSCR_BF0_CH0.Reg, value)
}
func (o *DMA_Type) GetIN_DSCR_BF0_CH0() uint32 {
	return volatile.LoadUint32(&o.IN_DSCR_BF0_CH0.Reg)
}

// DMA.IN_DSCR_BF1_CH0: DMA_IN_DSCR_BF1_CH0_REG.
func (o *DMA_Type) SetIN_DSCR_BF1_CH0(value uint32) {
	volatile.StoreUint32(&o.IN_DSCR_BF1_CH0.Reg, value)
}
func (o *DMA_Type) GetIN_DSCR_BF1_CH0() uint32 {
	return volatile.LoadUint32(&o.IN_DSCR_BF1_CH0.Reg)
}

// DMA.IN_PRI_CH0: DMA_IN_PRI_CH0_REG.
func (o *DMA_Type) SetIN_PRI_CH0_RX_PRI_CH0(value uint32) {
	volatile.StoreUint32(&o.IN_PRI_CH0.Reg, volatile.LoadUint32(&o.IN_PRI_CH0.Reg)&^(0xf)|value)
}
func (o *DMA_Type) GetIN_PRI_CH0_RX_PRI_CH0() uint32 {
	return volatile.LoadUint32(&o.IN_PRI_CH0.Reg) & 0xf
}

// DMA.IN_PERI_SEL_CH0: DMA_IN_PERI_SEL_CH0_REG.
func (o *DMA_Type) SetIN_PERI_SEL_CH0_PERI_IN_SEL_CH0(value uint32) {
	volatile.StoreUint32(&o.IN_PERI_SEL_CH0.Reg, volatile.LoadUint32(&o.IN_PERI_SEL_CH0.Reg)&^(0x3f)|value)
}
func (o *DMA_Type) GetIN_PERI_SEL_CH0_PERI_IN_SEL_CH0() uint32 {
	return volatile.LoadUint32(&o.IN_PERI_SEL_CH0.Reg) & 0x3f
}

// DMA.OUT_CONF0_CH0: DMA_OUT_CONF0_CH0_REG.
func (o *DMA_Type) SetOUT_CONF0_CH0_OUT_RST_CH0(value uint32) {
	volatile.StoreUint32(&o.OUT_CONF0_CH0.Reg, volatile.LoadUint32(&o.OUT_CONF0_CH0.Reg)&^(0x1)|value)
}
func (o *DMA_Type) GetOUT_CONF0_CH0_OUT_RST_CH0() uint32 {
	return volatile.LoadUint32(&o.OUT_CONF0_CH0.Reg) & 0x1
}
func (o *DMA_Type) SetOUT_CONF0_CH0_OUT_LOOP_TEST_CH0(value uint32) {
	volatile.StoreUint32(&o.OUT_CONF0_CH0.Reg, volatile.LoadUint32(&o.OUT_CONF0_CH0.Reg)&^(0x2)|value<<1)
}
func (o *DMA_Type) GetOUT_CONF0_CH0_OUT_LOOP_TEST_CH0() uint32 {
	return (volatile.LoadUint32(&o.OUT_CONF0_CH0.Reg) & 0x2) >> 1
}
func (o *DMA_Type) SetOUT_CONF0_CH0_OUT_AUTO_WRBACK_CH0(value uint32) {
	volatile.StoreUint32(&o.OUT_CONF0_CH0.Reg, volatile.LoadUint32(&o.OUT_CONF0_CH0.Reg)&^(0x4)|value<<2)
}
func (o *DMA_Type) GetOUT_CONF0_CH0_OUT_AUTO_WRBACK_CH0() uint32 {
	return (volatile.LoadUint32(&o.OUT_CONF0_CH0.Reg) & 0x4) >> 2
}
func (o *DMA_Type) SetOUT_CONF0_CH0_OUT_EOF_MODE_CH0(value uint32) {
	volatile.StoreUint32(&o.OUT_CONF0_CH0.Reg, volatile.LoadUint32(&o.OUT_CONF0_CH0.Reg)&^(0x8)|value<<3)
}
func (o *DMA_Type) GetOUT_CONF0_CH0_OUT_EOF_MODE_CH0() uint32 {
	return (volatile.LoadUint32(&o.OUT_CONF0_CH0.Reg) & 0x8) >> 3
}
func (o *DMA_Type) SetOUT_CONF0_CH0_OUTDSCR_BURST_EN_CH0(value uint32) {
	volatile.StoreUint32(&o.OUT_CONF0_CH0.Reg, volatile.LoadUint32(&o.OUT_CONF0_CH0.Reg)&^(0x10)|value<<4)
}
func (o *DMA_Type) GetOUT_CONF0_CH0_OUTDSCR_BURST_EN_CH0() uint32 {
	return (volatile.LoadUint32(&o.OUT_CONF0_CH0.Reg) & 0x10) >> 4
}
func (o *DMA_Type) SetOUT_CONF0_CH0_OUT_DATA_BURST_EN_CH0(value uint32) {
	volatile.StoreUint32(&o.OUT_CONF0_CH0.Reg, volatile.LoadUint32(&o.OUT_CONF0_CH0.Reg)&^(0x20)|value<<5)
}
func (o *DMA_Type) GetOUT_CONF0_CH0_OUT_DATA_BURST_EN_CH0() uint32 {
	return (volatile.LoadUint32(&o.OUT_CONF0_CH0.Reg) & 0x20) >> 5
}

// DMA.OUT_CONF1_CH0: DMA_OUT_CONF1_CH0_REG.
func (o *DMA_Type) SetOUT_CONF1_CH0_OUT_CHECK_OWNER_CH0(value uint32) {
	volatile.StoreUint32(&o.OUT_CONF1_CH0.Reg, volatile.LoadUint32(&o.OUT_CONF1_CH0.Reg)&^(0x1000)|value<<12)
}
func (o *DMA_Type) GetOUT_CONF1_CH0_OUT_CHECK_OWNER_CH0() uint32 {
	return (volatile.LoadUint32(&o.OUT_CONF1_CH0.Reg) & 0x1000) >> 12
}

// DMA.OUTFIFO_STATUS_CH0: DMA_OUTFIFO_STATUS_CH0_REG.
func (o *DMA_Type) SetOUTFIFO_STATUS_CH0_OUTFIFO_FULL_CH0(value uint32) {
	volatile.StoreUint32(&o.OUTFIFO_STATUS_CH0.Reg, volatile.LoadUint32(&o.OUTFIFO_STATUS_CH0.Reg)&^(0x1)|value)
}
func (o *DMA_Type) GetOUTFIFO_STATUS_CH0_OUTFIFO_FULL_CH0() uint32 {
	return volatile.LoadUint32(&o.OUTFIFO_STATUS_CH0.Reg) & 0x1
}
func (o *DMA_Type) SetOUTFIFO_STATUS_CH0_OUTFIFO_EMPTY_CH0(value uint32) {
	volatile.StoreUint32(&o.OUTFIFO_STATUS_CH0.Reg, volatile.LoadUint32(&o.OUTFIFO_STATUS_CH0.Reg)&^(0x2)|value<<1)
}
func (o *DMA_Type) GetOUTFIFO_STATUS_CH0_OUTFIFO_EMPTY_CH0() uint32 {
	return (volatile.LoadUint32(&o.OUTFIFO_STATUS_CH0.Reg) & 0x2) >> 1
}
func (o *DMA_Type) SetOUTFIFO_STATUS_CH0_OUTFIFO_CNT_CH0(value uint32) {
	volatile.StoreUint32(&o.OUTFIFO_STATUS_CH0.Reg, volatile.LoadUint32(&o.OUTFIFO_STATUS_CH0.Reg)&^(0xfc)|value<<2)
}
func (o *DMA_Type) GetOUTFIFO_STATUS_CH0_OUTFIFO_CNT_CH0() uint32 {
	return (volatile.LoadUint32(&o.OUTFIFO_STATUS_CH0.Reg) & 0xfc) >> 2
}
func (o *DMA_Type) SetOUTFIFO_STATUS_CH0_OUT_REMAIN_UNDER_1B_CH0(value uint32) {
	volatile.StoreUint32(&o.OUTFIFO_STATUS_CH0.Reg, volatile.LoadUint32(&o.OUTFIFO_STATUS_CH0.Reg)&^(0x800000)|value<<23)
}
func (o *DMA_Type) GetOUTFIFO_STATUS_CH0_OUT_REMAIN_UNDER_1B_CH0() uint32 {
	return (volatile.LoadUint32(&o.OUTFIFO_STATUS_CH0.Reg) & 0x800000) >> 23
}
func (o *DMA_Type) SetOUTFIFO_STATUS_CH0_OUT_REMAIN_UNDER_2B_CH0(value uint32) {
	volatile.StoreUint32(&o.OUTFIFO_STATUS_CH0.Reg, volatile.LoadUint32(&o.OUTFIFO_STATUS_CH0.Reg)&^(0x1000000)|value<<24)
}
func (o *DMA_Type) GetOUTFIFO_STATUS_CH0_OUT_REMAIN_UNDER_2B_CH0() uint32 {
	return (volatile.LoadUint32(&o.OUTFIFO_STATUS_CH0.Reg) & 0x1000000) >> 24
}
func (o *DMA_Type) SetOUTFIFO_STATUS_CH0_OUT_REMAIN_UNDER_3B_CH0(value uint32) {
	volatile.StoreUint32(&o.OUTFIFO_STATUS_CH0.Reg, volatile.LoadUint32(&o.OUTFIFO_STATUS_CH0.Reg)&^(0x2000000)|value<<25)
}
func (o *DMA_Type) GetOUTFIFO_STATUS_CH0_OUT_REMAIN_UNDER_3B_CH0() uint32 {
	return (volatile.LoadUint32(&o.OUTFIFO_STATUS_CH0.Reg) & 0x2000000) >> 25
}
func (o *DMA_Type) SetOUTFIFO_STATUS_CH0_OUT_REMAIN_UNDER_4B_CH0(value uint32) {
	volatile.StoreUint32(&o.OUTFIFO_STATUS_CH0.Reg, volatile.LoadUint32(&o.OUTFIFO_STATUS_CH0.Reg)&^(0x4000000)|value<<26)
}
func (o *DMA_Type) GetOUTFIFO_STATUS_CH0_OUT_REMAIN_UNDER_4B_CH0() uint32 {
	return (volatile.LoadUint32(&o.OUTFIFO_STATUS_CH0.Reg) & 0x4000000) >> 26
}

// DMA.OUT_PUSH_CH0: DMA_OUT_PUSH_CH0_REG.
func (o *DMA_Type) SetOUT_PUSH_CH0_OUTFIFO_WDATA_CH0(value uint32) {
	volatile.StoreUint32(&o.OUT_PUSH_CH0.Reg, volatile.LoadUint32(&o.OUT_PUSH_CH0.Reg)&^(0x1ff)|value)
}
func (o *DMA_Type) GetOUT_PUSH_CH0_OUTFIFO_WDATA_CH0() uint32 {
	return volatile.LoadUint32(&o.OUT_PUSH_CH0.Reg) & 0x1ff
}
func (o *DMA_Type) SetOUT_PUSH_CH0_OUTFIFO_PUSH_CH0(value uint32) {
	volatile.StoreUint32(&o.OUT_PUSH_CH0.Reg, volatile.LoadUint32(&o.OUT_PUSH_CH0.Reg)&^(0x200)|value<<9)
}
func (o *DMA_Type) GetOUT_PUSH_CH0_OUTFIFO_PUSH_CH0() uint32 {
	return (volatile.LoadUint32(&o.OUT_PUSH_CH0.Reg) & 0x200) >> 9
}

// DMA.OUT_LINK_CH0: DMA_OUT_LINK_CH0_REG.
func (o *DMA_Type) SetOUT_LINK_CH0_OUTLINK_ADDR_CH0(value uint32) {
	volatile.StoreUint32(&o.OUT_LINK_CH0.Reg, volatile.LoadUint32(&o.OUT_LINK_CH0.Reg)&^(0xfffff)|value)
}
func (o *DMA_Type) GetOUT_LINK_CH0_OUTLINK_ADDR_CH0() uint32 {
	return volatile.LoadUint32(&o.OUT_LINK_CH0.Reg) & 0xfffff
}
func (o *DMA_Type) SetOUT_LINK_CH0_OUTLINK_STOP_CH0(value uint32) {
	volatile.StoreUint32(&o.OUT_LINK_CH0.Reg, volatile.LoadUint32(&o.OUT_LINK_CH0.Reg)&^(0x100000)|value<<20)
}
func (o *DMA_Type) GetOUT_LINK_CH0_OUTLINK_STOP_CH0() uint32 {
	return (volatile.LoadUint32(&o.OUT_LINK_CH0.Reg) & 0x100000) >> 20
}
func (o *DMA_Type) SetOUT_LINK_CH0_OUTLINK_START_CH0(value uint32) {
	volatile.StoreUint32(&o.OUT_LINK_CH0.Reg, volatile.LoadUint32(&o.OUT_LINK_CH0.Reg)&^(0x200000)|value<<21)
}
func (o *DMA_Type) GetOUT_LINK_CH0_OUTLINK_START_CH0() uint32 {
	return (volatile.LoadUint32(&o.OUT_LINK_CH0.Reg) & 0x200000) >> 21
}
func (o *DMA_Type) SetOUT_LINK_CH0_OUTLINK_RESTART_CH0(value uint32) {
	volatile.StoreUint32(&o.OUT_LINK_CH0.Reg, volatile.LoadUint32(&o.OUT_LINK_CH0.Reg)&^(0x400000)|value<<22)
}
func (o *DMA_Type) GetOUT_LINK_CH0_OUTLINK_RESTART_CH0() uint32 {
	return (volatile.LoadUint32(&o.OUT_LINK_CH0.Reg) & 0x400000) >> 22
}
func (o *DMA_Type) SetOUT_LINK_CH0_OUTLINK_PARK_CH0(value uint32) {
	volatile.StoreUint32(&o.OUT_LINK_CH0.Reg, volatile.LoadUint32(&o.OUT_LINK_CH0.Reg)&^(0x800000)|value<<23)
}
func (o *DMA_Type) GetOUT_LINK_CH0_OUTLINK_PARK_CH0() uint32 {
	return (volatile.LoadUint32(&o.OUT_LINK_CH0.Reg) & 0x800000) >> 23
}

// DMA.OUT_STATE_CH0: DMA_OUT_STATE_CH0_REG.
func (o *DMA_Type) SetOUT_STATE_CH0_OUTLINK_DSCR_ADDR_CH0(value uint32) {
	volatile.StoreUint32(&o.OUT_STATE_CH0.Reg, volatile.LoadUint32(&o.OUT_STATE_CH0.Reg)&^(0x3ffff)|value)
}
func (o *DMA_Type) GetOUT_STATE_CH0_OUTLINK_DSCR_ADDR_CH0() uint32 {
	return volatile.LoadUint32(&o.OUT_STATE_CH0.Reg) & 0x3ffff
}
func (o *DMA_Type) SetOUT_STATE_CH0_OUT_DSCR_STATE_CH0(value uint32) {
	volatile.StoreUint32(&o.OUT_STATE_CH0.Reg, volatile.LoadUint32(&o.OUT_STATE_CH0.Reg)&^(0xc0000)|value<<18)
}
func (o *DMA_Type) GetOUT_STATE_CH0_OUT_DSCR_STATE_CH0() uint32 {
	return (volatile.LoadUint32(&o.OUT_STATE_CH0.Reg) & 0xc0000) >> 18
}
func (o *DMA_Type) SetOUT_STATE_CH0(value uint32) {
	volatile.StoreUint32(&o.OUT_STATE_CH0.Reg, volatile.LoadUint32(&o.OUT_STATE_CH0.Reg)&^(0x700000)|value<<20)
}
func (o *DMA_Type) GetOUT_STATE_CH0() uint32 {
	return (volatile.LoadUint32(&o.OUT_STATE_CH0.Reg) & 0x700000) >> 20
}

// DMA.OUT_EOF_DES_ADDR_CH0: DMA_OUT_EOF_DES_ADDR_CH0_REG.
func (o *DMA_Type) SetOUT_EOF_DES_ADDR_CH0(value uint32) {
	volatile.StoreUint32(&o.OUT_EOF_DES_ADDR_CH0.Reg, value)
}
func (o *DMA_Type) GetOUT_EOF_DES_ADDR_CH0() uint32 {
	return volatile.LoadUint32(&o.OUT_EOF_DES_ADDR_CH0.Reg)
}

// DMA.OUT_EOF_BFR_DES_ADDR_CH0: DMA_OUT_EOF_BFR_DES_ADDR_CH0_REG.
func (o *DMA_Type) SetOUT_EOF_BFR_DES_ADDR_CH0(value uint32) {
	volatile.StoreUint32(&o.OUT_EOF_BFR_DES_ADDR_CH0.Reg, value)
}
func (o *DMA_Type) GetOUT_EOF_BFR_DES_ADDR_CH0() uint32 {
	return volatile.LoadUint32(&o.OUT_EOF_BFR_DES_ADDR_CH0.Reg)
}

// DMA.OUT_DSCR_CH0: DMA_OUT_DSCR_CH0_REG.
func (o *DMA_Type) SetOUT_DSCR_CH0(value uint32) {
	volatile.StoreUint32(&o.OUT_DSCR_CH0.Reg, value)
}
func (o *DMA_Type) GetOUT_DSCR_CH0() uint32 {
	return volatile.LoadUint32(&o.OUT_DSCR_CH0.Reg)
}

// DMA.OUT_DSCR_BF0_CH0: DMA_OUT_DSCR_BF0_CH0_REG.
func (o *DMA_Type) SetOUT_DSCR_BF0_CH0(value uint32) {
	volatile.StoreUint32(&o.OUT_DSCR_BF0_CH0.Reg, value)
}
func (o *DMA_Type) GetOUT_DSCR_BF0_CH0() uint32 {
	return volatile.LoadUint32(&o.OUT_DSCR_BF0_CH0.Reg)
}

// DMA.OUT_DSCR_BF1_CH0: DMA_OUT_DSCR_BF1_CH0_REG.
func (o *DMA_Type) SetOUT_DSCR_BF1_CH0(value uint32) {
	volatile.StoreUint32(&o.OUT_DSCR_BF1_CH0.Reg, value)
}
func (o *DMA_Type) GetOUT_DSCR_BF1_CH0() uint32 {
	return volatile.LoadUint32(&o.OUT_DSCR_BF1_CH0.Reg)
}

// DMA.OUT_PRI_CH0: DMA_OUT_PRI_CH0_REG.
func (o *DMA_Type) SetOUT_PRI_CH0_TX_PRI_CH0(value uint32) {
	volatile.StoreUint32(&o.OUT_PRI_CH0.Reg, volatile.LoadUint32(&o.OUT_PRI_CH0.Reg)&^(0xf)|value)
}
func (o *DMA_Type) GetOUT_PRI_CH0_TX_PRI_CH0() uint32 {
	return volatile.LoadUint32(&o.OUT_PRI_CH0.Reg) & 0xf
}

// DMA.OUT_PERI_SEL_CH0: DMA_OUT_PERI_SEL_CH0_REG.
func (o *DMA_Type) SetOUT_PERI_SEL_CH0_PERI_OUT_SEL_CH0(value uint32) {
	volatile.StoreUint32(&o.OUT_PERI_SEL_CH0.Reg, volatile.LoadUint32(&o.OUT_PERI_SEL_CH0.Reg)&^(0x3f)|value)
}
func (o *DMA_Type) GetOUT_PERI_SEL_CH0_PERI_OUT_SEL_CH0() uint32 {
	return volatile.LoadUint32(&o.OUT_PERI_SEL_CH0.Reg) & 0x3f
}

// DMA.IN_CONF0_CH1: DMA_IN_CONF0_CH1_REG.
func (o *DMA_Type) SetIN_CONF0_CH1_IN_RST_CH1(value uint32) {
	volatile.StoreUint32(&o.IN_CONF0_CH1.Reg, volatile.LoadUint32(&o.IN_CONF0_CH1.Reg)&^(0x1)|value)
}
func (o *DMA_Type) GetIN_CONF0_CH1_IN_RST_CH1() uint32 {
	return volatile.LoadUint32(&o.IN_CONF0_CH1.Reg) & 0x1
}
func (o *DMA_Type) SetIN_CONF0_CH1_IN_LOOP_TEST_CH1(value uint32) {
	volatile.StoreUint32(&o.IN_CONF0_CH1.Reg, volatile.LoadUint32(&o.IN_CONF0_CH1.Reg)&^(0x2)|value<<1)
}
func (o *DMA_Type) GetIN_CONF0_CH1_IN_LOOP_TEST_CH1() uint32 {
	return (volatile.LoadUint32(&o.IN_CONF0_CH1.Reg) & 0x2) >> 1
}
func (o *DMA_Type) SetIN_CONF0_CH1_INDSCR_BURST_EN_CH1(value uint32) {
	volatile.StoreUint32(&o.IN_CONF0_CH1.Reg, volatile.LoadUint32(&o.IN_CONF0_CH1.Reg)&^(0x4)|value<<2)
}
func (o *DMA_Type) GetIN_CONF0_CH1_INDSCR_BURST_EN_CH1() uint32 {
	return (volatile.LoadUint32(&o.IN_CONF0_CH1.Reg) & 0x4) >> 2
}
func (o *DMA_Type) SetIN_CONF0_CH1_IN_DATA_BURST_EN_CH1(value uint32) {
	volatile.StoreUint32(&o.IN_CONF0_CH1.Reg, volatile.LoadUint32(&o.IN_CONF0_CH1.Reg)&^(0x8)|value<<3)
}
func (o *DMA_Type) GetIN_CONF0_CH1_IN_DATA_BURST_EN_CH1() uint32 {
	return (volatile.LoadUint32(&o.IN_CONF0_CH1.Reg) & 0x8) >> 3
}
func (o *DMA_Type) SetIN_CONF0_CH1_MEM_TRANS_EN_CH1(value uint32) {
	volatile.StoreUint32(&o.IN_CONF0_CH1.Reg, volatile.LoadUint32(&o.IN_CONF0_CH1.Reg)&^(0x10)|value<<4)
}
func (o *DMA_Type) GetIN_CONF0_CH1_MEM_TRANS_EN_CH1() uint32 {
	return (volatile.LoadUint32(&o.IN_CONF0_CH1.Reg) & 0x10) >> 4
}

// DMA.IN_CONF1_CH1: DMA_IN_CONF1_CH1_REG.
func (o *DMA_Type) SetIN_CONF1_CH1_IN_CHECK_OWNER_CH1(value uint32) {
	volatile.StoreUint32(&o.IN_CONF1_CH1.Reg, volatile.LoadUint32(&o.IN_CONF1_CH1.Reg)&^(0x1000)|value<<12)
}
func (o *DMA_Type) GetIN_CONF1_CH1_IN_CHECK_OWNER_CH1() uint32 {
	return (volatile.LoadUint32(&o.IN_CONF1_CH1.Reg) & 0x1000) >> 12
}

// DMA.INFIFO_STATUS_CH1: DMA_INFIFO_STATUS_CH1_REG.
func (o *DMA_Type) SetINFIFO_STATUS_CH1_INFIFO_FULL_CH1(value uint32) {
	volatile.StoreUint32(&o.INFIFO_STATUS_CH1.Reg, volatile.LoadUint32(&o.INFIFO_STATUS_CH1.Reg)&^(0x1)|value)
}
func (o *DMA_Type) GetINFIFO_STATUS_CH1_INFIFO_FULL_CH1() uint32 {
	return volatile.LoadUint32(&o.INFIFO_STATUS_CH1.Reg) & 0x1
}
func (o *DMA_Type) SetINFIFO_STATUS_CH1_INFIFO_EMPTY_CH1(value uint32) {
	volatile.StoreUint32(&o.INFIFO_STATUS_CH1.Reg, volatile.LoadUint32(&o.INFIFO_STATUS_CH1.Reg)&^(0x2)|value<<1)
}
func (o *DMA_Type) GetINFIFO_STATUS_CH1_INFIFO_EMPTY_CH1() uint32 {
	return (volatile.LoadUint32(&o.INFIFO_STATUS_CH1.Reg) & 0x2) >> 1
}
func (o *DMA_Type) SetINFIFO_STATUS_CH1_INFIFO_CNT_CH1(value uint32) {
	volatile.StoreUint32(&o.INFIFO_STATUS_CH1.Reg, volatile.LoadUint32(&o.INFIFO_STATUS_CH1.Reg)&^(0xfc)|value<<2)
}
func (o *DMA_Type) GetINFIFO_STATUS_CH1_INFIFO_CNT_CH1() uint32 {
	return (volatile.LoadUint32(&o.INFIFO_STATUS_CH1.Reg) & 0xfc) >> 2
}
func (o *DMA_Type) SetINFIFO_STATUS_CH1_IN_REMAIN_UNDER_1B_CH1(value uint32) {
	volatile.StoreUint32(&o.INFIFO_STATUS_CH1.Reg, volatile.LoadUint32(&o.INFIFO_STATUS_CH1.Reg)&^(0x800000)|value<<23)
}
func (o *DMA_Type) GetINFIFO_STATUS_CH1_IN_REMAIN_UNDER_1B_CH1() uint32 {
	return (volatile.LoadUint32(&o.INFIFO_STATUS_CH1.Reg) & 0x800000) >> 23
}
func (o *DMA_Type) SetINFIFO_STATUS_CH1_IN_REMAIN_UNDER_2B_CH1(value uint32) {
	volatile.StoreUint32(&o.INFIFO_STATUS_CH1.Reg, volatile.LoadUint32(&o.INFIFO_STATUS_CH1.Reg)&^(0x1000000)|value<<24)
}
func (o *DMA_Type) GetINFIFO_STATUS_CH1_IN_REMAIN_UNDER_2B_CH1() uint32 {
	return (volatile.LoadUint32(&o.INFIFO_STATUS_CH1.Reg) & 0x1000000) >> 24
}
func (o *DMA_Type) SetINFIFO_STATUS_CH1_IN_REMAIN_UNDER_3B_CH1(value uint32) {
	volatile.StoreUint32(&o.INFIFO_STATUS_CH1.Reg, volatile.LoadUint32(&o.INFIFO_STATUS_CH1.Reg)&^(0x2000000)|value<<25)
}
func (o *DMA_Type) GetINFIFO_STATUS_CH1_IN_REMAIN_UNDER_3B_CH1() uint32 {
	return (volatile.LoadUint32(&o.INFIFO_STATUS_CH1.Reg) & 0x2000000) >> 25
}
func (o *DMA_Type) SetINFIFO_STATUS_CH1_IN_REMAIN_UNDER_4B_CH1(value uint32) {
	volatile.StoreUint32(&o.INFIFO_STATUS_CH1.Reg, volatile.LoadUint32(&o.INFIFO_STATUS_CH1.Reg)&^(0x4000000)|value<<26)
}
func (o *DMA_Type) GetINFIFO_STATUS_CH1_IN_REMAIN_UNDER_4B_CH1() uint32 {
	return (volatile.LoadUint32(&o.INFIFO_STATUS_CH1.Reg) & 0x4000000) >> 26
}
func (o *DMA_Type) SetINFIFO_STATUS_CH1_IN_BUF_HUNGRY_CH1(value uint32) {
	volatile.StoreUint32(&o.INFIFO_STATUS_CH1.Reg, volatile.LoadUint32(&o.INFIFO_STATUS_CH1.Reg)&^(0x8000000)|value<<27)
}
func (o *DMA_Type) GetINFIFO_STATUS_CH1_IN_BUF_HUNGRY_CH1() uint32 {
	return (volatile.LoadUint32(&o.INFIFO_STATUS_CH1.Reg) & 0x8000000) >> 27
}

// DMA.IN_POP_CH1: DMA_IN_POP_CH1_REG.
func (o *DMA_Type) SetIN_POP_CH1_INFIFO_RDATA_CH1(value uint32) {
	volatile.StoreUint32(&o.IN_POP_CH1.Reg, volatile.LoadUint32(&o.IN_POP_CH1.Reg)&^(0xfff)|value)
}
func (o *DMA_Type) GetIN_POP_CH1_INFIFO_RDATA_CH1() uint32 {
	return volatile.LoadUint32(&o.IN_POP_CH1.Reg) & 0xfff
}
func (o *DMA_Type) SetIN_POP_CH1_INFIFO_POP_CH1(value uint32) {
	volatile.StoreUint32(&o.IN_POP_CH1.Reg, volatile.LoadUint32(&o.IN_POP_CH1.Reg)&^(0x1000)|value<<12)
}
func (o *DMA_Type) GetIN_POP_CH1_INFIFO_POP_CH1() uint32 {
	return (volatile.LoadUint32(&o.IN_POP_CH1.Reg) & 0x1000) >> 12
}

// DMA.IN_LINK_CH1: DMA_IN_LINK_CH1_REG.
func (o *DMA_Type) SetIN_LINK_CH1_INLINK_ADDR_CH1(value uint32) {
	volatile.StoreUint32(&o.IN_LINK_CH1.Reg, volatile.LoadUint32(&o.IN_LINK_CH1.Reg)&^(0xfffff)|value)
}
func (o *DMA_Type) GetIN_LINK_CH1_INLINK_ADDR_CH1() uint32 {
	return volatile.LoadUint32(&o.IN_LINK_CH1.Reg) & 0xfffff
}
func (o *DMA_Type) SetIN_LINK_CH1_INLINK_AUTO_RET_CH1(value uint32) {
	volatile.StoreUint32(&o.IN_LINK_CH1.Reg, volatile.LoadUint32(&o.IN_LINK_CH1.Reg)&^(0x100000)|value<<20)
}
func (o *DMA_Type) GetIN_LINK_CH1_INLINK_AUTO_RET_CH1() uint32 {
	return (volatile.LoadUint32(&o.IN_LINK_CH1.Reg) & 0x100000) >> 20
}
func (o *DMA_Type) SetIN_LINK_CH1_INLINK_STOP_CH1(value uint32) {
	volatile.StoreUint32(&o.IN_LINK_CH1.Reg, volatile.LoadUint32(&o.IN_LINK_CH1.Reg)&^(0x200000)|value<<21)
}
func (o *DMA_Type) GetIN_LINK_CH1_INLINK_STOP_CH1() uint32 {
	return (volatile.LoadUint32(&o.IN_LINK_CH1.Reg) & 0x200000) >> 21
}
func (o *DMA_Type) SetIN_LINK_CH1_INLINK_START_CH1(value uint32) {
	volatile.StoreUint32(&o.IN_LINK_CH1.Reg, volatile.LoadUint32(&o.IN_LINK_CH1.Reg)&^(0x400000)|value<<22)
}
func (o *DMA_Type) GetIN_LINK_CH1_INLINK_START_CH1() uint32 {
	return (volatile.LoadUint32(&o.IN_LINK_CH1.Reg) & 0x400000) >> 22
}
func (o *DMA_Type) SetIN_LINK_CH1_INLINK_RESTART_CH1(value uint32) {
	volatile.StoreUint32(&o.IN_LINK_CH1.Reg, volatile.LoadUint32(&o.IN_LINK_CH1.Reg)&^(0x800000)|value<<23)
}
func (o *DMA_Type) GetIN_LINK_CH1_INLINK_RESTART_CH1() uint32 {
	return (volatile.LoadUint32(&o.IN_LINK_CH1.Reg) & 0x800000) >> 23
}
func (o *DMA_Type) SetIN_LINK_CH1_INLINK_PARK_CH1(value uint32) {
	volatile.StoreUint32(&o.IN_LINK_CH1.Reg, volatile.LoadUint32(&o.IN_LINK_CH1.Reg)&^(0x1000000)|value<<24)
}
func (o *DMA_Type) GetIN_LINK_CH1_INLINK_PARK_CH1() uint32 {
	return (volatile.LoadUint32(&o.IN_LINK_CH1.Reg) & 0x1000000) >> 24
}

// DMA.IN_STATE_CH1: DMA_IN_STATE_CH1_REG.
func (o *DMA_Type) SetIN_STATE_CH1_INLINK_DSCR_ADDR_CH1(value uint32) {
	volatile.StoreUint32(&o.IN_STATE_CH1.Reg, volatile.LoadUint32(&o.IN_STATE_CH1.Reg)&^(0x3ffff)|value)
}
func (o *DMA_Type) GetIN_STATE_CH1_INLINK_DSCR_ADDR_CH1() uint32 {
	return volatile.LoadUint32(&o.IN_STATE_CH1.Reg) & 0x3ffff
}
func (o *DMA_Type) SetIN_STATE_CH1_IN_DSCR_STATE_CH1(value uint32) {
	volatile.StoreUint32(&o.IN_STATE_CH1.Reg, volatile.LoadUint32(&o.IN_STATE_CH1.Reg)&^(0xc0000)|value<<18)
}
func (o *DMA_Type) GetIN_STATE_CH1_IN_DSCR_STATE_CH1() uint32 {
	return (volatile.LoadUint32(&o.IN_STATE_CH1.Reg) & 0xc0000) >> 18
}
func (o *DMA_Type) SetIN_STATE_CH1(value uint32) {
	volatile.StoreUint32(&o.IN_STATE_CH1.Reg, volatile.LoadUint32(&o.IN_STATE_CH1.Reg)&^(0x700000)|value<<20)
}
func (o *DMA_Type) GetIN_STATE_CH1() uint32 {
	return (volatile.LoadUint32(&o.IN_STATE_CH1.Reg) & 0x700000) >> 20
}

// DMA.IN_SUC_EOF_DES_ADDR_CH1: DMA_IN_SUC_EOF_DES_ADDR_CH1_REG.
func (o *DMA_Type) SetIN_SUC_EOF_DES_ADDR_CH1(value uint32) {
	volatile.StoreUint32(&o.IN_SUC_EOF_DES_ADDR_CH1.Reg, value)
}
func (o *DMA_Type) GetIN_SUC_EOF_DES_ADDR_CH1() uint32 {
	return volatile.LoadUint32(&o.IN_SUC_EOF_DES_ADDR_CH1.Reg)
}

// DMA.IN_ERR_EOF_DES_ADDR_CH1: DMA_IN_ERR_EOF_DES_ADDR_CH1_REG.
func (o *DMA_Type) SetIN_ERR_EOF_DES_ADDR_CH1(value uint32) {
	volatile.StoreUint32(&o.IN_ERR_EOF_DES_ADDR_CH1.Reg, value)
}
func (o *DMA_Type) GetIN_ERR_EOF_DES_ADDR_CH1() uint32 {
	return volatile.LoadUint32(&o.IN_ERR_EOF_DES_ADDR_CH1.Reg)
}

// DMA.IN_DSCR_CH1: DMA_IN_DSCR_CH1_REG.
func (o *DMA_Type) SetIN_DSCR_CH1(value uint32) {
	volatile.StoreUint32(&o.IN_DSCR_CH1.Reg, value)
}
func (o *DMA_Type) GetIN_DSCR_CH1() uint32 {
	return volatile.LoadUint32(&o.IN_DSCR_CH1.Reg)
}

// DMA.IN_DSCR_BF0_CH1: DMA_IN_DSCR_BF0_CH1_REG.
func (o *DMA_Type) SetIN_DSCR_BF0_CH1(value uint32) {
	volatile.StoreUint32(&o.IN_DSCR_BF0_CH1.Reg, value)
}
func (o *DMA_Type) GetIN_DSCR_BF0_CH1() uint32 {
	return volatile.LoadUint32(&o.IN_DSCR_BF0_CH1.Reg)
}

// DMA.IN_DSCR_BF1_CH1: DMA_IN_DSCR_BF1_CH1_REG.
func (o *DMA_Type) SetIN_DSCR_BF1_CH1(value uint32) {
	volatile.StoreUint32(&o.IN_DSCR_BF1_CH1.Reg, value)
}
func (o *DMA_Type) GetIN_DSCR_BF1_CH1() uint32 {
	return volatile.LoadUint32(&o.IN_DSCR_BF1_CH1.Reg)
}

// DMA.IN_PRI_CH1: DMA_IN_PRI_CH1_REG.
func (o *DMA_Type) SetIN_PRI_CH1_RX_PRI_CH1(value uint32) {
	volatile.StoreUint32(&o.IN_PRI_CH1.Reg, volatile.LoadUint32(&o.IN_PRI_CH1.Reg)&^(0xf)|value)
}
func (o *DMA_Type) GetIN_PRI_CH1_RX_PRI_CH1() uint32 {
	return volatile.LoadUint32(&o.IN_PRI_CH1.Reg) & 0xf
}

// DMA.IN_PERI_SEL_CH1: DMA_IN_PERI_SEL_CH1_REG.
func (o *DMA_Type) SetIN_PERI_SEL_CH1_PERI_IN_SEL_CH1(value uint32) {
	volatile.StoreUint32(&o.IN_PERI_SEL_CH1.Reg, volatile.LoadUint32(&o.IN_PERI_SEL_CH1.Reg)&^(0x3f)|value)
}
func (o *DMA_Type) GetIN_PERI_SEL_CH1_PERI_IN_SEL_CH1() uint32 {
	return volatile.LoadUint32(&o.IN_PERI_SEL_CH1.Reg) & 0x3f
}

// DMA.OUT_CONF0_CH1: DMA_OUT_CONF0_CH1_REG.
func (o *DMA_Type) SetOUT_CONF0_CH1_OUT_RST_CH1(value uint32) {
	volatile.StoreUint32(&o.OUT_CONF0_CH1.Reg, volatile.LoadUint32(&o.OUT_CONF0_CH1.Reg)&^(0x1)|value)
}
func (o *DMA_Type) GetOUT_CONF0_CH1_OUT_RST_CH1() uint32 {
	return volatile.LoadUint32(&o.OUT_CONF0_CH1.Reg) & 0x1
}
func (o *DMA_Type) SetOUT_CONF0_CH1_OUT_LOOP_TEST_CH1(value uint32) {
	volatile.StoreUint32(&o.OUT_CONF0_CH1.Reg, volatile.LoadUint32(&o.OUT_CONF0_CH1.Reg)&^(0x2)|value<<1)
}
func (o *DMA_Type) GetOUT_CONF0_CH1_OUT_LOOP_TEST_CH1() uint32 {
	return (volatile.LoadUint32(&o.OUT_CONF0_CH1.Reg) & 0x2) >> 1
}
func (o *DMA_Type) SetOUT_CONF0_CH1_OUT_AUTO_WRBACK_CH1(value uint32) {
	volatile.StoreUint32(&o.OUT_CONF0_CH1.Reg, volatile.LoadUint32(&o.OUT_CONF0_CH1.Reg)&^(0x4)|value<<2)
}
func (o *DMA_Type) GetOUT_CONF0_CH1_OUT_AUTO_WRBACK_CH1() uint32 {
	return (volatile.LoadUint32(&o.OUT_CONF0_CH1.Reg) & 0x4) >> 2
}
func (o *DMA_Type) SetOUT_CONF0_CH1_OUT_EOF_MODE_CH1(value uint32) {
	volatile.StoreUint32(&o.OUT_CONF0_CH1.Reg, volatile.LoadUint32(&o.OUT_CONF0_CH1.Reg)&^(0x8)|value<<3)
}
func (o *DMA_Type) GetOUT_CONF0_CH1_OUT_EOF_MODE_CH1() uint32 {
	return (volatile.LoadUint32(&o.OUT_CONF0_CH1.Reg) & 0x8) >> 3
}
func (o *DMA_Type) SetOUT_CONF0_CH1_OUTDSCR_BURST_EN_CH1(value uint32) {
	volatile.StoreUint32(&o.OUT_CONF0_CH1.Reg, volatile.LoadUint32(&o.OUT_CONF0_CH1.Reg)&^(0x10)|value<<4)
}
func (o *DMA_Type) GetOUT_CONF0_CH1_OUTDSCR_BURST_EN_CH1() uint32 {
	return (volatile.LoadUint32(&o.OUT_CONF0_CH1.Reg) & 0x10) >> 4
}
func (o *DMA_Type) SetOUT_CONF0_CH1_OUT_DATA_BURST_EN_CH1(value uint32) {
	volatile.StoreUint32(&o.OUT_CONF0_CH1.Reg, volatile.LoadUint32(&o.OUT_CONF0_CH1.Reg)&^(0x20)|value<<5)
}
func (o *DMA_Type) GetOUT_CONF0_CH1_OUT_DATA_BURST_EN_CH1() uint32 {
	return (volatile.LoadUint32(&o.OUT_CONF0_CH1.Reg) & 0x20) >> 5
}

// DMA.OUT_CONF1_CH1: DMA_OUT_CONF1_CH1_REG.
func (o *DMA_Type) SetOUT_CONF1_CH1_OUT_CHECK_OWNER_CH1(value uint32) {
	volatile.StoreUint32(&o.OUT_CONF1_CH1.Reg, volatile.LoadUint32(&o.OUT_CONF1_CH1.Reg)&^(0x1000)|value<<12)
}
func (o *DMA_Type) GetOUT_CONF1_CH1_OUT_CHECK_OWNER_CH1() uint32 {
	return (volatile.LoadUint32(&o.OUT_CONF1_CH1.Reg) & 0x1000) >> 12
}

// DMA.OUTFIFO_STATUS_CH1: DMA_OUTFIFO_STATUS_CH1_REG.
func (o *DMA_Type) SetOUTFIFO_STATUS_CH1_OUTFIFO_FULL_CH1(value uint32) {
	volatile.StoreUint32(&o.OUTFIFO_STATUS_CH1.Reg, volatile.LoadUint32(&o.OUTFIFO_STATUS_CH1.Reg)&^(0x1)|value)
}
func (o *DMA_Type) GetOUTFIFO_STATUS_CH1_OUTFIFO_FULL_CH1() uint32 {
	return volatile.LoadUint32(&o.OUTFIFO_STATUS_CH1.Reg) & 0x1
}
func (o *DMA_Type) SetOUTFIFO_STATUS_CH1_OUTFIFO_EMPTY_CH1(value uint32) {
	volatile.StoreUint32(&o.OUTFIFO_STATUS_CH1.Reg, volatile.LoadUint32(&o.OUTFIFO_STATUS_CH1.Reg)&^(0x2)|value<<1)
}
func (o *DMA_Type) GetOUTFIFO_STATUS_CH1_OUTFIFO_EMPTY_CH1() uint32 {
	return (volatile.LoadUint32(&o.OUTFIFO_STATUS_CH1.Reg) & 0x2) >> 1
}
func (o *DMA_Type) SetOUTFIFO_STATUS_CH1_OUTFIFO_CNT_CH1(value uint32) {
	volatile.StoreUint32(&o.OUTFIFO_STATUS_CH1.Reg, volatile.LoadUint32(&o.OUTFIFO_STATUS_CH1.Reg)&^(0xfc)|value<<2)
}
func (o *DMA_Type) GetOUTFIFO_STATUS_CH1_OUTFIFO_CNT_CH1() uint32 {
	return (volatile.LoadUint32(&o.OUTFIFO_STATUS_CH1.Reg) & 0xfc) >> 2
}
func (o *DMA_Type) SetOUTFIFO_STATUS_CH1_OUT_REMAIN_UNDER_1B_CH1(value uint32) {
	volatile.StoreUint32(&o.OUTFIFO_STATUS_CH1.Reg, volatile.LoadUint32(&o.OUTFIFO_STATUS_CH1.Reg)&^(0x800000)|value<<23)
}
func (o *DMA_Type) GetOUTFIFO_STATUS_CH1_OUT_REMAIN_UNDER_1B_CH1() uint32 {
	return (volatile.LoadUint32(&o.OUTFIFO_STATUS_CH1.Reg) & 0x800000) >> 23
}
func (o *DMA_Type) SetOUTFIFO_STATUS_CH1_OUT_REMAIN_UNDER_2B_CH1(value uint32) {
	volatile.StoreUint32(&o.OUTFIFO_STATUS_CH1.Reg, volatile.LoadUint32(&o.OUTFIFO_STATUS_CH1.Reg)&^(0x1000000)|value<<24)
}
func (o *DMA_Type) GetOUTFIFO_STATUS_CH1_OUT_REMAIN_UNDER_2B_CH1() uint32 {
	return (volatile.LoadUint32(&o.OUTFIFO_STATUS_CH1.Reg) & 0x1000000) >> 24
}
func (o *DMA_Type) SetOUTFIFO_STATUS_CH1_OUT_REMAIN_UNDER_3B_CH1(value uint32) {
	volatile.StoreUint32(&o.OUTFIFO_STATUS_CH1.Reg, volatile.LoadUint32(&o.OUTFIFO_STATUS_CH1.Reg)&^(0x2000000)|value<<25)
}
func (o *DMA_Type) GetOUTFIFO_STATUS_CH1_OUT_REMAIN_UNDER_3B_CH1() uint32 {
	return (volatile.LoadUint32(&o.OUTFIFO_STATUS_CH1.Reg) & 0x2000000) >> 25
}
func (o *DMA_Type) SetOUTFIFO_STATUS_CH1_OUT_REMAIN_UNDER_4B_CH1(value uint32) {
	volatile.StoreUint32(&o.OUTFIFO_STATUS_CH1.Reg, volatile.LoadUint32(&o.OUTFIFO_STATUS_CH1.Reg)&^(0x4000000)|value<<26)
}
func (o *DMA_Type) GetOUTFIFO_STATUS_CH1_OUT_REMAIN_UNDER_4B_CH1() uint32 {
	return (volatile.LoadUint32(&o.OUTFIFO_STATUS_CH1.Reg) & 0x4000000) >> 26
}

// DMA.OUT_PUSH_CH1: DMA_OUT_PUSH_CH1_REG.
func (o *DMA_Type) SetOUT_PUSH_CH1_OUTFIFO_WDATA_CH1(value uint32) {
	volatile.StoreUint32(&o.OUT_PUSH_CH1.Reg, volatile.LoadUint32(&o.OUT_PUSH_CH1.Reg)&^(0x1ff)|value)
}
func (o *DMA_Type) GetOUT_PUSH_CH1_OUTFIFO_WDATA_CH1() uint32 {
	return volatile.LoadUint32(&o.OUT_PUSH_CH1.Reg) & 0x1ff
}
func (o *DMA_Type) SetOUT_PUSH_CH1_OUTFIFO_PUSH_CH1(value uint32) {
	volatile.StoreUint32(&o.OUT_PUSH_CH1.Reg, volatile.LoadUint32(&o.OUT_PUSH_CH1.Reg)&^(0x200)|value<<9)
}
func (o *DMA_Type) GetOUT_PUSH_CH1_OUTFIFO_PUSH_CH1() uint32 {
	return (volatile.LoadUint32(&o.OUT_PUSH_CH1.Reg) & 0x200) >> 9
}

// DMA.OUT_LINK_CH1: DMA_OUT_LINK_CH1_REG.
func (o *DMA_Type) SetOUT_LINK_CH1_OUTLINK_ADDR_CH1(value uint32) {
	volatile.StoreUint32(&o.OUT_LINK_CH1.Reg, volatile.LoadUint32(&o.OUT_LINK_CH1.Reg)&^(0xfffff)|value)
}
func (o *DMA_Type) GetOUT_LINK_CH1_OUTLINK_ADDR_CH1() uint32 {
	return volatile.LoadUint32(&o.OUT_LINK_CH1.Reg) & 0xfffff
}
func (o *DMA_Type) SetOUT_LINK_CH1_OUTLINK_STOP_CH1(value uint32) {
	volatile.StoreUint32(&o.OUT_LINK_CH1.Reg, volatile.LoadUint32(&o.OUT_LINK_CH1.Reg)&^(0x100000)|value<<20)
}
func (o *DMA_Type) GetOUT_LINK_CH1_OUTLINK_STOP_CH1() uint32 {
	return (volatile.LoadUint32(&o.OUT_LINK_CH1.Reg) & 0x100000) >> 20
}
func (o *DMA_Type) SetOUT_LINK_CH1_OUTLINK_START_CH1(value uint32) {
	volatile.StoreUint32(&o.OUT_LINK_CH1.Reg, volatile.LoadUint32(&o.OUT_LINK_CH1.Reg)&^(0x200000)|value<<21)
}
func (o *DMA_Type) GetOUT_LINK_CH1_OUTLINK_START_CH1() uint32 {
	return (volatile.LoadUint32(&o.OUT_LINK_CH1.Reg) & 0x200000) >> 21
}
func (o *DMA_Type) SetOUT_LINK_CH1_OUTLINK_RESTART_CH1(value uint32) {
	volatile.StoreUint32(&o.OUT_LINK_CH1.Reg, volatile.LoadUint32(&o.OUT_LINK_CH1.Reg)&^(0x400000)|value<<22)
}
func (o *DMA_Type) GetOUT_LINK_CH1_OUTLINK_RESTART_CH1() uint32 {
	return (volatile.LoadUint32(&o.OUT_LINK_CH1.Reg) & 0x400000) >> 22
}
func (o *DMA_Type) SetOUT_LINK_CH1_OUTLINK_PARK_CH1(value uint32) {
	volatile.StoreUint32(&o.OUT_LINK_CH1.Reg, volatile.LoadUint32(&o.OUT_LINK_CH1.Reg)&^(0x800000)|value<<23)
}
func (o *DMA_Type) GetOUT_LINK_CH1_OUTLINK_PARK_CH1() uint32 {
	return (volatile.LoadUint32(&o.OUT_LINK_CH1.Reg) & 0x800000) >> 23
}

// DMA.OUT_STATE_CH1: DMA_OUT_STATE_CH1_REG.
func (o *DMA_Type) SetOUT_STATE_CH1_OUTLINK_DSCR_ADDR_CH1(value uint32) {
	volatile.StoreUint32(&o.OUT_STATE_CH1.Reg, volatile.LoadUint32(&o.OUT_STATE_CH1.Reg)&^(0x3ffff)|value)
}
func (o *DMA_Type) GetOUT_STATE_CH1_OUTLINK_DSCR_ADDR_CH1() uint32 {
	return volatile.LoadUint32(&o.OUT_STATE_CH1.Reg) & 0x3ffff
}
func (o *DMA_Type) SetOUT_STATE_CH1_OUT_DSCR_STATE_CH1(value uint32) {
	volatile.StoreUint32(&o.OUT_STATE_CH1.Reg, volatile.LoadUint32(&o.OUT_STATE_CH1.Reg)&^(0xc0000)|value<<18)
}
func (o *DMA_Type) GetOUT_STATE_CH1_OUT_DSCR_STATE_CH1() uint32 {
	return (volatile.LoadUint32(&o.OUT_STATE_CH1.Reg) & 0xc0000) >> 18
}
func (o *DMA_Type) SetOUT_STATE_CH1(value uint32) {
	volatile.StoreUint32(&o.OUT_STATE_CH1.Reg, volatile.LoadUint32(&o.OUT_STATE_CH1.Reg)&^(0x700000)|value<<20)
}
func (o *DMA_Type) GetOUT_STATE_CH1() uint32 {
	return (volatile.LoadUint32(&o.OUT_STATE_CH1.Reg) & 0x700000) >> 20
}

// DMA.OUT_EOF_DES_ADDR_CH1: DMA_OUT_EOF_DES_ADDR_CH1_REG.
func (o *DMA_Type) SetOUT_EOF_DES_ADDR_CH1(value uint32) {
	volatile.StoreUint32(&o.OUT_EOF_DES_ADDR_CH1.Reg, value)
}
func (o *DMA_Type) GetOUT_EOF_DES_ADDR_CH1() uint32 {
	return volatile.LoadUint32(&o.OUT_EOF_DES_ADDR_CH1.Reg)
}

// DMA.OUT_EOF_BFR_DES_ADDR_CH1: DMA_OUT_EOF_BFR_DES_ADDR_CH1_REG.
func (o *DMA_Type) SetOUT_EOF_BFR_DES_ADDR_CH1(value uint32) {
	volatile.StoreUint32(&o.OUT_EOF_BFR_DES_ADDR_CH1.Reg, value)
}
func (o *DMA_Type) GetOUT_EOF_BFR_DES_ADDR_CH1() uint32 {
	return volatile.LoadUint32(&o.OUT_EOF_BFR_DES_ADDR_CH1.Reg)
}

// DMA.OUT_DSCR_CH1: DMA_OUT_DSCR_CH1_REG.
func (o *DMA_Type) SetOUT_DSCR_CH1(value uint32) {
	volatile.StoreUint32(&o.OUT_DSCR_CH1.Reg, value)
}
func (o *DMA_Type) GetOUT_DSCR_CH1() uint32 {
	return volatile.LoadUint32(&o.OUT_DSCR_CH1.Reg)
}

// DMA.OUT_DSCR_BF0_CH1: DMA_OUT_DSCR_BF0_CH1_REG.
func (o *DMA_Type) SetOUT_DSCR_BF0_CH1(value uint32) {
	volatile.StoreUint32(&o.OUT_DSCR_BF0_CH1.Reg, value)
}
func (o *DMA_Type) GetOUT_DSCR_BF0_CH1() uint32 {
	return volatile.LoadUint32(&o.OUT_DSCR_BF0_CH1.Reg)
}

// DMA.OUT_DSCR_BF1_CH1: DMA_OUT_DSCR_BF1_CH1_REG.
func (o *DMA_Type) SetOUT_DSCR_BF1_CH1(value uint32) {
	volatile.StoreUint32(&o.OUT_DSCR_BF1_CH1.Reg, value)
}
func (o *DMA_Type) GetOUT_DSCR_BF1_CH1() uint32 {
	return volatile.LoadUint32(&o.OUT_DSCR_BF1_CH1.Reg)
}

// DMA.OUT_PRI_CH1: DMA_OUT_PRI_CH1_REG.
func (o *DMA_Type) SetOUT_PRI_CH1_TX_PRI_CH1(value uint32) {
	volatile.StoreUint32(&o.OUT_PRI_CH1.Reg, volatile.LoadUint32(&o.OUT_PRI_CH1.Reg)&^(0xf)|value)
}
func (o *DMA_Type) GetOUT_PRI_CH1_TX_PRI_CH1() uint32 {
	return volatile.LoadUint32(&o.OUT_PRI_CH1.Reg) & 0xf
}

// DMA.OUT_PERI_SEL_CH1: DMA_OUT_PERI_SEL_CH1_REG.
func (o *DMA_Type) SetOUT_PERI_SEL_CH1_PERI_OUT_SEL_CH1(value uint32) {
	volatile.StoreUint32(&o.OUT_PERI_SEL_CH1.Reg, volatile.LoadUint32(&o.OUT_PERI_SEL_CH1.Reg)&^(0x3f)|value)
}
func (o *DMA_Type) GetOUT_PERI_SEL_CH1_PERI_OUT_SEL_CH1() uint32 {
	return volatile.LoadUint32(&o.OUT_PERI_SEL_CH1.Reg) & 0x3f
}

// DMA.IN_CONF0_CH2: DMA_IN_CONF0_CH2_REG.
func (o *DMA_Type) SetIN_CONF0_CH2_IN_RST_CH2(value uint32) {
	volatile.StoreUint32(&o.IN_CONF0_CH2.Reg, volatile.LoadUint32(&o.IN_CONF0_CH2.Reg)&^(0x1)|value)
}
func (o *DMA_Type) GetIN_CONF0_CH2_IN_RST_CH2() uint32 {
	return volatile.LoadUint32(&o.IN_CONF0_CH2.Reg) & 0x1
}
func (o *DMA_Type) SetIN_CONF0_CH2_IN_LOOP_TEST_CH2(value uint32) {
	volatile.StoreUint32(&o.IN_CONF0_CH2.Reg, volatile.LoadUint32(&o.IN_CONF0_CH2.Reg)&^(0x2)|value<<1)
}
func (o *DMA_Type) GetIN_CONF0_CH2_IN_LOOP_TEST_CH2() uint32 {
	return (volatile.LoadUint32(&o.IN_CONF0_CH2.Reg) & 0x2) >> 1
}
func (o *DMA_Type) SetIN_CONF0_CH2_INDSCR_BURST_EN_CH2(value uint32) {
	volatile.StoreUint32(&o.IN_CONF0_CH2.Reg, volatile.LoadUint32(&o.IN_CONF0_CH2.Reg)&^(0x4)|value<<2)
}
func (o *DMA_Type) GetIN_CONF0_CH2_INDSCR_BURST_EN_CH2() uint32 {
	return (volatile.LoadUint32(&o.IN_CONF0_CH2.Reg) & 0x4) >> 2
}
func (o *DMA_Type) SetIN_CONF0_CH2_IN_DATA_BURST_EN_CH2(value uint32) {
	volatile.StoreUint32(&o.IN_CONF0_CH2.Reg, volatile.LoadUint32(&o.IN_CONF0_CH2.Reg)&^(0x8)|value<<3)
}
func (o *DMA_Type) GetIN_CONF0_CH2_IN_DATA_BURST_EN_CH2() uint32 {
	return (volatile.LoadUint32(&o.IN_CONF0_CH2.Reg) & 0x8) >> 3
}
func (o *DMA_Type) SetIN_CONF0_CH2_MEM_TRANS_EN_CH2(value uint32) {
	volatile.StoreUint32(&o.IN_CONF0_CH2.Reg, volatile.LoadUint32(&o.IN_CONF0_CH2.Reg)&^(0x10)|value<<4)
}
func (o *DMA_Type) GetIN_CONF0_CH2_MEM_TRANS_EN_CH2() uint32 {
	return (volatile.LoadUint32(&o.IN_CONF0_CH2.Reg) & 0x10) >> 4
}

// DMA.IN_CONF1_CH2: DMA_IN_CONF1_CH2_REG.
func (o *DMA_Type) SetIN_CONF1_CH2_IN_CHECK_OWNER_CH2(value uint32) {
	volatile.StoreUint32(&o.IN_CONF1_CH2.Reg, volatile.LoadUint32(&o.IN_CONF1_CH2.Reg)&^(0x1000)|value<<12)
}
func (o *DMA_Type) GetIN_CONF1_CH2_IN_CHECK_OWNER_CH2() uint32 {
	return (volatile.LoadUint32(&o.IN_CONF1_CH2.Reg) & 0x1000) >> 12
}

// DMA.INFIFO_STATUS_CH2: DMA_INFIFO_STATUS_CH2_REG.
func (o *DMA_Type) SetINFIFO_STATUS_CH2_INFIFO_FULL_CH2(value uint32) {
	volatile.StoreUint32(&o.INFIFO_STATUS_CH2.Reg, volatile.LoadUint32(&o.INFIFO_STATUS_CH2.Reg)&^(0x1)|value)
}
func (o *DMA_Type) GetINFIFO_STATUS_CH2_INFIFO_FULL_CH2() uint32 {
	return volatile.LoadUint32(&o.INFIFO_STATUS_CH2.Reg) & 0x1
}
func (o *DMA_Type) SetINFIFO_STATUS_CH2_INFIFO_EMPTY_CH2(value uint32) {
	volatile.StoreUint32(&o.INFIFO_STATUS_CH2.Reg, volatile.LoadUint32(&o.INFIFO_STATUS_CH2.Reg)&^(0x2)|value<<1)
}
func (o *DMA_Type) GetINFIFO_STATUS_CH2_INFIFO_EMPTY_CH2() uint32 {
	return (volatile.LoadUint32(&o.INFIFO_STATUS_CH2.Reg) & 0x2) >> 1
}
func (o *DMA_Type) SetINFIFO_STATUS_CH2_INFIFO_CNT_CH2(value uint32) {
	volatile.StoreUint32(&o.INFIFO_STATUS_CH2.Reg, volatile.LoadUint32(&o.INFIFO_STATUS_CH2.Reg)&^(0xfc)|value<<2)
}
func (o *DMA_Type) GetINFIFO_STATUS_CH2_INFIFO_CNT_CH2() uint32 {
	return (volatile.LoadUint32(&o.INFIFO_STATUS_CH2.Reg) & 0xfc) >> 2
}
func (o *DMA_Type) SetINFIFO_STATUS_CH2_IN_REMAIN_UNDER_1B_CH2(value uint32) {
	volatile.StoreUint32(&o.INFIFO_STATUS_CH2.Reg, volatile.LoadUint32(&o.INFIFO_STATUS_CH2.Reg)&^(0x800000)|value<<23)
}
func (o *DMA_Type) GetINFIFO_STATUS_CH2_IN_REMAIN_UNDER_1B_CH2() uint32 {
	return (volatile.LoadUint32(&o.INFIFO_STATUS_CH2.Reg) & 0x800000) >> 23
}
func (o *DMA_Type) SetINFIFO_STATUS_CH2_IN_REMAIN_UNDER_2B_CH2(value uint32) {
	volatile.StoreUint32(&o.INFIFO_STATUS_CH2.Reg, volatile.LoadUint32(&o.INFIFO_STATUS_CH2.Reg)&^(0x1000000)|value<<24)
}
func (o *DMA_Type) GetINFIFO_STATUS_CH2_IN_REMAIN_UNDER_2B_CH2() uint32 {
	return (volatile.LoadUint32(&o.INFIFO_STATUS_CH2.Reg) & 0x1000000) >> 24
}
func (o *DMA_Type) SetINFIFO_STATUS_CH2_IN_REMAIN_UNDER_3B_CH2(value uint32) {
	volatile.StoreUint32(&o.INFIFO_STATUS_CH2.Reg, volatile.LoadUint32(&o.INFIFO_STATUS_CH2.Reg)&^(0x2000000)|value<<25)
}
func (o *DMA_Type) GetINFIFO_STATUS_CH2_IN_REMAIN_UNDER_3B_CH2() uint32 {
	return (volatile.LoadUint32(&o.INFIFO_STATUS_CH2.Reg) & 0x2000000) >> 25
}
func (o *DMA_Type) SetINFIFO_STATUS_CH2_IN_REMAIN_UNDER_4B_CH2(value uint32) {
	volatile.StoreUint32(&o.INFIFO_STATUS_CH2.Reg, volatile.LoadUint32(&o.INFIFO_STATUS_CH2.Reg)&^(0x4000000)|value<<26)
}
func (o *DMA_Type) GetINFIFO_STATUS_CH2_IN_REMAIN_UNDER_4B_CH2() uint32 {
	return (volatile.LoadUint32(&o.INFIFO_STATUS_CH2.Reg) & 0x4000000) >> 26
}
func (o *DMA_Type) SetINFIFO_STATUS_CH2_IN_BUF_HUNGRY_CH2(value uint32) {
	volatile.StoreUint32(&o.INFIFO_STATUS_CH2.Reg, volatile.LoadUint32(&o.INFIFO_STATUS_CH2.Reg)&^(0x8000000)|value<<27)
}
func (o *DMA_Type) GetINFIFO_STATUS_CH2_IN_BUF_HUNGRY_CH2() uint32 {
	return (volatile.LoadUint32(&o.INFIFO_STATUS_CH2.Reg) & 0x8000000) >> 27
}

// DMA.IN_POP_CH2: DMA_IN_POP_CH2_REG.
func (o *DMA_Type) SetIN_POP_CH2_INFIFO_RDATA_CH2(value uint32) {
	volatile.StoreUint32(&o.IN_POP_CH2.Reg, volatile.LoadUint32(&o.IN_POP_CH2.Reg)&^(0xfff)|value)
}
func (o *DMA_Type) GetIN_POP_CH2_INFIFO_RDATA_CH2() uint32 {
	return volatile.LoadUint32(&o.IN_POP_CH2.Reg) & 0xfff
}
func (o *DMA_Type) SetIN_POP_CH2_INFIFO_POP_CH2(value uint32) {
	volatile.StoreUint32(&o.IN_POP_CH2.Reg, volatile.LoadUint32(&o.IN_POP_CH2.Reg)&^(0x1000)|value<<12)
}
func (o *DMA_Type) GetIN_POP_CH2_INFIFO_POP_CH2() uint32 {
	return (volatile.LoadUint32(&o.IN_POP_CH2.Reg) & 0x1000) >> 12
}

// DMA.IN_LINK_CH2: DMA_IN_LINK_CH2_REG.
func (o *DMA_Type) SetIN_LINK_CH2_INLINK_ADDR_CH2(value uint32) {
	volatile.StoreUint32(&o.IN_LINK_CH2.Reg, volatile.LoadUint32(&o.IN_LINK_CH2.Reg)&^(0xfffff)|value)
}
func (o *DMA_Type) GetIN_LINK_CH2_INLINK_ADDR_CH2() uint32 {
	return volatile.LoadUint32(&o.IN_LINK_CH2.Reg) & 0xfffff
}
func (o *DMA_Type) SetIN_LINK_CH2_INLINK_AUTO_RET_CH2(value uint32) {
	volatile.StoreUint32(&o.IN_LINK_CH2.Reg, volatile.LoadUint32(&o.IN_LINK_CH2.Reg)&^(0x100000)|value<<20)
}
func (o *DMA_Type) GetIN_LINK_CH2_INLINK_AUTO_RET_CH2() uint32 {
	return (volatile.LoadUint32(&o.IN_LINK_CH2.Reg) & 0x100000) >> 20
}
func (o *DMA_Type) SetIN_LINK_CH2_INLINK_STOP_CH2(value uint32) {
	volatile.StoreUint32(&o.IN_LINK_CH2.Reg, volatile.LoadUint32(&o.IN_LINK_CH2.Reg)&^(0x200000)|value<<21)
}
func (o *DMA_Type) GetIN_LINK_CH2_INLINK_STOP_CH2() uint32 {
	return (volatile.LoadUint32(&o.IN_LINK_CH2.Reg) & 0x200000) >> 21
}
func (o *DMA_Type) SetIN_LINK_CH2_INLINK_START_CH2(value uint32) {
	volatile.StoreUint32(&o.IN_LINK_CH2.Reg, volatile.LoadUint32(&o.IN_LINK_CH2.Reg)&^(0x400000)|value<<22)
}
func (o *DMA_Type) GetIN_LINK_CH2_INLINK_START_CH2() uint32 {
	return (volatile.LoadUint32(&o.IN_LINK_CH2.Reg) & 0x400000) >> 22
}
func (o *DMA_Type) SetIN_LINK_CH2_INLINK_RESTART_CH2(value uint32) {
	volatile.StoreUint32(&o.IN_LINK_CH2.Reg, volatile.LoadUint32(&o.IN_LINK_CH2.Reg)&^(0x800000)|value<<23)
}
func (o *DMA_Type) GetIN_LINK_CH2_INLINK_RESTART_CH2() uint32 {
	return (volatile.LoadUint32(&o.IN_LINK_CH2.Reg) & 0x800000) >> 23
}
func (o *DMA_Type) SetIN_LINK_CH2_INLINK_PARK_CH2(value uint32) {
	volatile.StoreUint32(&o.IN_LINK_CH2.Reg, volatile.LoadUint32(&o.IN_LINK_CH2.Reg)&^(0x1000000)|value<<24)
}
func (o *DMA_Type) GetIN_LINK_CH2_INLINK_PARK_CH2() uint32 {
	return (volatile.LoadUint32(&o.IN_LINK_CH2.Reg) & 0x1000000) >> 24
}

// DMA.IN_STATE_CH2: DMA_IN_STATE_CH2_REG.
func (o *DMA_Type) SetIN_STATE_CH2_INLINK_DSCR_ADDR_CH2(value uint32) {
	volatile.StoreUint32(&o.IN_STATE_CH2.Reg, volatile.LoadUint32(&o.IN_STATE_CH2.Reg)&^(0x3ffff)|value)
}
func (o *DMA_Type) GetIN_STATE_CH2_INLINK_DSCR_ADDR_CH2() uint32 {
	return volatile.LoadUint32(&o.IN_STATE_CH2.Reg) & 0x3ffff
}
func (o *DMA_Type) SetIN_STATE_CH2_IN_DSCR_STATE_CH2(value uint32) {
	volatile.StoreUint32(&o.IN_STATE_CH2.Reg, volatile.LoadUint32(&o.IN_STATE_CH2.Reg)&^(0xc0000)|value<<18)
}
func (o *DMA_Type) GetIN_STATE_CH2_IN_DSCR_STATE_CH2() uint32 {
	return (volatile.LoadUint32(&o.IN_STATE_CH2.Reg) & 0xc0000) >> 18
}
func (o *DMA_Type) SetIN_STATE_CH2(value uint32) {
	volatile.StoreUint32(&o.IN_STATE_CH2.Reg, volatile.LoadUint32(&o.IN_STATE_CH2.Reg)&^(0x700000)|value<<20)
}
func (o *DMA_Type) GetIN_STATE_CH2() uint32 {
	return (volatile.LoadUint32(&o.IN_STATE_CH2.Reg) & 0x700000) >> 20
}

// DMA.IN_SUC_EOF_DES_ADDR_CH2: DMA_IN_SUC_EOF_DES_ADDR_CH2_REG.
func (o *DMA_Type) SetIN_SUC_EOF_DES_ADDR_CH2(value uint32) {
	volatile.StoreUint32(&o.IN_SUC_EOF_DES_ADDR_CH2.Reg, value)
}
func (o *DMA_Type) GetIN_SUC_EOF_DES_ADDR_CH2() uint32 {
	return volatile.LoadUint32(&o.IN_SUC_EOF_DES_ADDR_CH2.Reg)
}

// DMA.IN_ERR_EOF_DES_ADDR_CH2: DMA_IN_ERR_EOF_DES_ADDR_CH2_REG.
func (o *DMA_Type) SetIN_ERR_EOF_DES_ADDR_CH2(value uint32) {
	volatile.StoreUint32(&o.IN_ERR_EOF_DES_ADDR_CH2.Reg, value)
}
func (o *DMA_Type) GetIN_ERR_EOF_DES_ADDR_CH2() uint32 {
	return volatile.LoadUint32(&o.IN_ERR_EOF_DES_ADDR_CH2.Reg)
}

// DMA.IN_DSCR_CH2: DMA_IN_DSCR_CH2_REG.
func (o *DMA_Type) SetIN_DSCR_CH2(value uint32) {
	volatile.StoreUint32(&o.IN_DSCR_CH2.Reg, value)
}
func (o *DMA_Type) GetIN_DSCR_CH2() uint32 {
	return volatile.LoadUint32(&o.IN_DSCR_CH2.Reg)
}

// DMA.IN_DSCR_BF0_CH2: DMA_IN_DSCR_BF0_CH2_REG.
func (o *DMA_Type) SetIN_DSCR_BF0_CH2(value uint32) {
	volatile.StoreUint32(&o.IN_DSCR_BF0_CH2.Reg, value)
}
func (o *DMA_Type) GetIN_DSCR_BF0_CH2() uint32 {
	return volatile.LoadUint32(&o.IN_DSCR_BF0_CH2.Reg)
}

// DMA.IN_DSCR_BF1_CH2: DMA_IN_DSCR_BF1_CH2_REG.
func (o *DMA_Type) SetIN_DSCR_BF1_CH2(value uint32) {
	volatile.StoreUint32(&o.IN_DSCR_BF1_CH2.Reg, value)
}
func (o *DMA_Type) GetIN_DSCR_BF1_CH2() uint32 {
	return volatile.LoadUint32(&o.IN_DSCR_BF1_CH2.Reg)
}

// DMA.IN_PRI_CH2: DMA_IN_PRI_CH2_REG.
func (o *DMA_Type) SetIN_PRI_CH2_RX_PRI_CH2(value uint32) {
	volatile.StoreUint32(&o.IN_PRI_CH2.Reg, volatile.LoadUint32(&o.IN_PRI_CH2.Reg)&^(0xf)|value)
}
func (o *DMA_Type) GetIN_PRI_CH2_RX_PRI_CH2() uint32 {
	return volatile.LoadUint32(&o.IN_PRI_CH2.Reg) & 0xf
}

// DMA.IN_PERI_SEL_CH2: DMA_IN_PERI_SEL_CH2_REG.
func (o *DMA_Type) SetIN_PERI_SEL_CH2_PERI_IN_SEL_CH2(value uint32) {
	volatile.StoreUint32(&o.IN_PERI_SEL_CH2.Reg, volatile.LoadUint32(&o.IN_PERI_SEL_CH2.Reg)&^(0x3f)|value)
}
func (o *DMA_Type) GetIN_PERI_SEL_CH2_PERI_IN_SEL_CH2() uint32 {
	return volatile.LoadUint32(&o.IN_PERI_SEL_CH2.Reg) & 0x3f
}

// DMA.OUT_CONF0_CH2: DMA_OUT_CONF0_CH2_REG.
func (o *DMA_Type) SetOUT_CONF0_CH2_OUT_RST_CH2(value uint32) {
	volatile.StoreUint32(&o.OUT_CONF0_CH2.Reg, volatile.LoadUint32(&o.OUT_CONF0_CH2.Reg)&^(0x1)|value)
}
func (o *DMA_Type) GetOUT_CONF0_CH2_OUT_RST_CH2() uint32 {
	return volatile.LoadUint32(&o.OUT_CONF0_CH2.Reg) & 0x1
}
func (o *DMA_Type) SetOUT_CONF0_CH2_OUT_LOOP_TEST_CH2(value uint32) {
	volatile.StoreUint32(&o.OUT_CONF0_CH2.Reg, volatile.LoadUint32(&o.OUT_CONF0_CH2.Reg)&^(0x2)|value<<1)
}
func (o *DMA_Type) GetOUT_CONF0_CH2_OUT_LOOP_TEST_CH2() uint32 {
	return (volatile.LoadUint32(&o.OUT_CONF0_CH2.Reg) & 0x2) >> 1
}
func (o *DMA_Type) SetOUT_CONF0_CH2_OUT_AUTO_WRBACK_CH2(value uint32) {
	volatile.StoreUint32(&o.OUT_CONF0_CH2.Reg, volatile.LoadUint32(&o.OUT_CONF0_CH2.Reg)&^(0x4)|value<<2)
}
func (o *DMA_Type) GetOUT_CONF0_CH2_OUT_AUTO_WRBACK_CH2() uint32 {
	return (volatile.LoadUint32(&o.OUT_CONF0_CH2.Reg) & 0x4) >> 2
}
func (o *DMA_Type) SetOUT_CONF0_CH2_OUT_EOF_MODE_CH2(value uint32) {
	volatile.StoreUint32(&o.OUT_CONF0_CH2.Reg, volatile.LoadUint32(&o.OUT_CONF0_CH2.Reg)&^(0x8)|value<<3)
}
func (o *DMA_Type) GetOUT_CONF0_CH2_OUT_EOF_MODE_CH2() uint32 {
	return (volatile.LoadUint32(&o.OUT_CONF0_CH2.Reg) & 0x8) >> 3
}
func (o *DMA_Type) SetOUT_CONF0_CH2_OUTDSCR_BURST_EN_CH2(value uint32) {
	volatile.StoreUint32(&o.OUT_CONF0_CH2.Reg, volatile.LoadUint32(&o.OUT_CONF0_CH2.Reg)&^(0x10)|value<<4)
}
func (o *DMA_Type) GetOUT_CONF0_CH2_OUTDSCR_BURST_EN_CH2() uint32 {
	return (volatile.LoadUint32(&o.OUT_CONF0_CH2.Reg) & 0x10) >> 4
}
func (o *DMA_Type) SetOUT_CONF0_CH2_OUT_DATA_BURST_EN_CH2(value uint32) {
	volatile.StoreUint32(&o.OUT_CONF0_CH2.Reg, volatile.LoadUint32(&o.OUT_CONF0_CH2.Reg)&^(0x20)|value<<5)
}
func (o *DMA_Type) GetOUT_CONF0_CH2_OUT_DATA_BURST_EN_CH2() uint32 {
	return (volatile.LoadUint32(&o.OUT_CONF0_CH2.Reg) & 0x20) >> 5
}

// DMA.OUT_CONF1_CH2: DMA_OUT_CONF1_CH2_REG.
func (o *DMA_Type) SetOUT_CONF1_CH2_OUT_CHECK_OWNER_CH2(value uint32) {
	volatile.StoreUint32(&o.OUT_CONF1_CH2.Reg, volatile.LoadUint32(&o.OUT_CONF1_CH2.Reg)&^(0x1000)|value<<12)
}
func (o *DMA_Type) GetOUT_CONF1_CH2_OUT_CHECK_OWNER_CH2() uint32 {
	return (volatile.LoadUint32(&o.OUT_CONF1_CH2.Reg) & 0x1000) >> 12
}

// DMA.OUTFIFO_STATUS_CH2: DMA_OUTFIFO_STATUS_CH2_REG.
func (o *DMA_Type) SetOUTFIFO_STATUS_CH2_OUTFIFO_FULL_CH2(value uint32) {
	volatile.StoreUint32(&o.OUTFIFO_STATUS_CH2.Reg, volatile.LoadUint32(&o.OUTFIFO_STATUS_CH2.Reg)&^(0x1)|value)
}
func (o *DMA_Type) GetOUTFIFO_STATUS_CH2_OUTFIFO_FULL_CH2() uint32 {
	return volatile.LoadUint32(&o.OUTFIFO_STATUS_CH2.Reg) & 0x1
}
func (o *DMA_Type) SetOUTFIFO_STATUS_CH2_OUTFIFO_EMPTY_CH2(value uint32) {
	volatile.StoreUint32(&o.OUTFIFO_STATUS_CH2.Reg, volatile.LoadUint32(&o.OUTFIFO_STATUS_CH2.Reg)&^(0x2)|value<<1)
}
func (o *DMA_Type) GetOUTFIFO_STATUS_CH2_OUTFIFO_EMPTY_CH2() uint32 {
	return (volatile.LoadUint32(&o.OUTFIFO_STATUS_CH2.Reg) & 0x2) >> 1
}
func (o *DMA_Type) SetOUTFIFO_STATUS_CH2_OUTFIFO_CNT_CH2(value uint32) {
	volatile.StoreUint32(&o.OUTFIFO_STATUS_CH2.Reg, volatile.LoadUint32(&o.OUTFIFO_STATUS_CH2.Reg)&^(0xfc)|value<<2)
}
func (o *DMA_Type) GetOUTFIFO_STATUS_CH2_OUTFIFO_CNT_CH2() uint32 {
	return (volatile.LoadUint32(&o.OUTFIFO_STATUS_CH2.Reg) & 0xfc) >> 2
}
func (o *DMA_Type) SetOUTFIFO_STATUS_CH2_OUT_REMAIN_UNDER_1B_CH2(value uint32) {
	volatile.StoreUint32(&o.OUTFIFO_STATUS_CH2.Reg, volatile.LoadUint32(&o.OUTFIFO_STATUS_CH2.Reg)&^(0x800000)|value<<23)
}
func (o *DMA_Type) GetOUTFIFO_STATUS_CH2_OUT_REMAIN_UNDER_1B_CH2() uint32 {
	return (volatile.LoadUint32(&o.OUTFIFO_STATUS_CH2.Reg) & 0x800000) >> 23
}
func (o *DMA_Type) SetOUTFIFO_STATUS_CH2_OUT_REMAIN_UNDER_2B_CH2(value uint32) {
	volatile.StoreUint32(&o.OUTFIFO_STATUS_CH2.Reg, volatile.LoadUint32(&o.OUTFIFO_STATUS_CH2.Reg)&^(0x1000000)|value<<24)
}
func (o *DMA_Type) GetOUTFIFO_STATUS_CH2_OUT_REMAIN_UNDER_2B_CH2() uint32 {
	return (volatile.LoadUint32(&o.OUTFIFO_STATUS_CH2.Reg) & 0x1000000) >> 24
}
func (o *DMA_Type) SetOUTFIFO_STATUS_CH2_OUT_REMAIN_UNDER_3B_CH2(value uint32) {
	volatile.StoreUint32(&o.OUTFIFO_STATUS_CH2.Reg, volatile.LoadUint32(&o.OUTFIFO_STATUS_CH2.Reg)&^(0x2000000)|value<<25)
}
func (o *DMA_Type) GetOUTFIFO_STATUS_CH2_OUT_REMAIN_UNDER_3B_CH2() uint32 {
	return (volatile.LoadUint32(&o.OUTFIFO_STATUS_CH2.Reg) & 0x2000000) >> 25
}
func (o *DMA_Type) SetOUTFIFO_STATUS_CH2_OUT_REMAIN_UNDER_4B_CH2(value uint32) {
	volatile.StoreUint32(&o.OUTFIFO_STATUS_CH2.Reg, volatile.LoadUint32(&o.OUTFIFO_STATUS_CH2.Reg)&^(0x4000000)|value<<26)
}
func (o *DMA_Type) GetOUTFIFO_STATUS_CH2_OUT_REMAIN_UNDER_4B_CH2() uint32 {
	return (volatile.LoadUint32(&o.OUTFIFO_STATUS_CH2.Reg) & 0x4000000) >> 26
}

// DMA.OUT_PUSH_CH2: DMA_OUT_PUSH_CH2_REG.
func (o *DMA_Type) SetOUT_PUSH_CH2_OUTFIFO_WDATA_CH2(value uint32) {
	volatile.StoreUint32(&o.OUT_PUSH_CH2.Reg, volatile.LoadUint32(&o.OUT_PUSH_CH2.Reg)&^(0x1ff)|value)
}
func (o *DMA_Type) GetOUT_PUSH_CH2_OUTFIFO_WDATA_CH2() uint32 {
	return volatile.LoadUint32(&o.OUT_PUSH_CH2.Reg) & 0x1ff
}
func (o *DMA_Type) SetOUT_PUSH_CH2_OUTFIFO_PUSH_CH2(value uint32) {
	volatile.StoreUint32(&o.OUT_PUSH_CH2.Reg, volatile.LoadUint32(&o.OUT_PUSH_CH2.Reg)&^(0x200)|value<<9)
}
func (o *DMA_Type) GetOUT_PUSH_CH2_OUTFIFO_PUSH_CH2() uint32 {
	return (volatile.LoadUint32(&o.OUT_PUSH_CH2.Reg) & 0x200) >> 9
}

// DMA.OUT_LINK_CH2: DMA_OUT_LINK_CH2_REG.
func (o *DMA_Type) SetOUT_LINK_CH2_OUTLINK_ADDR_CH2(value uint32) {
	volatile.StoreUint32(&o.OUT_LINK_CH2.Reg, volatile.LoadUint32(&o.OUT_LINK_CH2.Reg)&^(0xfffff)|value)
}
func (o *DMA_Type) GetOUT_LINK_CH2_OUTLINK_ADDR_CH2() uint32 {
	return volatile.LoadUint32(&o.OUT_LINK_CH2.Reg) & 0xfffff
}
func (o *DMA_Type) SetOUT_LINK_CH2_OUTLINK_STOP_CH2(value uint32) {
	volatile.StoreUint32(&o.OUT_LINK_CH2.Reg, volatile.LoadUint32(&o.OUT_LINK_CH2.Reg)&^(0x100000)|value<<20)
}
func (o *DMA_Type) GetOUT_LINK_CH2_OUTLINK_STOP_CH2() uint32 {
	return (volatile.LoadUint32(&o.OUT_LINK_CH2.Reg) & 0x100000) >> 20
}
func (o *DMA_Type) SetOUT_LINK_CH2_OUTLINK_START_CH2(value uint32) {
	volatile.StoreUint32(&o.OUT_LINK_CH2.Reg, volatile.LoadUint32(&o.OUT_LINK_CH2.Reg)&^(0x200000)|value<<21)
}
func (o *DMA_Type) GetOUT_LINK_CH2_OUTLINK_START_CH2() uint32 {
	return (volatile.LoadUint32(&o.OUT_LINK_CH2.Reg) & 0x200000) >> 21
}
func (o *DMA_Type) SetOUT_LINK_CH2_OUTLINK_RESTART_CH2(value uint32) {
	volatile.StoreUint32(&o.OUT_LINK_CH2.Reg, volatile.LoadUint32(&o.OUT_LINK_CH2.Reg)&^(0x400000)|value<<22)
}
func (o *DMA_Type) GetOUT_LINK_CH2_OUTLINK_RESTART_CH2() uint32 {
	return (volatile.LoadUint32(&o.OUT_LINK_CH2.Reg) & 0x400000) >> 22
}
func (o *DMA_Type) SetOUT_LINK_CH2_OUTLINK_PARK_CH2(value uint32) {
	volatile.StoreUint32(&o.OUT_LINK_CH2.Reg, volatile.LoadUint32(&o.OUT_LINK_CH2.Reg)&^(0x800000)|value<<23)
}
func (o *DMA_Type) GetOUT_LINK_CH2_OUTLINK_PARK_CH2() uint32 {
	return (volatile.LoadUint32(&o.OUT_LINK_CH2.Reg) & 0x800000) >> 23
}

// DMA.OUT_STATE_CH2: DMA_OUT_STATE_CH2_REG.
func (o *DMA_Type) SetOUT_STATE_CH2_OUTLINK_DSCR_ADDR_CH2(value uint32) {
	volatile.StoreUint32(&o.OUT_STATE_CH2.Reg, volatile.LoadUint32(&o.OUT_STATE_CH2.Reg)&^(0x3ffff)|value)
}
func (o *DMA_Type) GetOUT_STATE_CH2_OUTLINK_DSCR_ADDR_CH2() uint32 {
	return volatile.LoadUint32(&o.OUT_STATE_CH2.Reg) & 0x3ffff
}
func (o *DMA_Type) SetOUT_STATE_CH2_OUT_DSCR_STATE_CH2(value uint32) {
	volatile.StoreUint32(&o.OUT_STATE_CH2.Reg, volatile.LoadUint32(&o.OUT_STATE_CH2.Reg)&^(0xc0000)|value<<18)
}
func (o *DMA_Type) GetOUT_STATE_CH2_OUT_DSCR_STATE_CH2() uint32 {
	return (volatile.LoadUint32(&o.OUT_STATE_CH2.Reg) & 0xc0000) >> 18
}
func (o *DMA_Type) SetOUT_STATE_CH2(value uint32) {
	volatile.StoreUint32(&o.OUT_STATE_CH2.Reg, volatile.LoadUint32(&o.OUT_STATE_CH2.Reg)&^(0x700000)|value<<20)
}
func (o *DMA_Type) GetOUT_STATE_CH2() uint32 {
	return (volatile.LoadUint32(&o.OUT_STATE_CH2.Reg) & 0x700000) >> 20
}

// DMA.OUT_EOF_DES_ADDR_CH2: DMA_OUT_EOF_DES_ADDR_CH2_REG.
func (o *DMA_Type) SetOUT_EOF_DES_ADDR_CH2(value uint32) {
	volatile.StoreUint32(&o.OUT_EOF_DES_ADDR_CH2.Reg, value)
}
func (o *DMA_Type) GetOUT_EOF_DES_ADDR_CH2() uint32 {
	return volatile.LoadUint32(&o.OUT_EOF_DES_ADDR_CH2.Reg)
}

// DMA.OUT_EOF_BFR_DES_ADDR_CH2: DMA_OUT_EOF_BFR_DES_ADDR_CH2_REG.
func (o *DMA_Type) SetOUT_EOF_BFR_DES_ADDR_CH2(value uint32) {
	volatile.StoreUint32(&o.OUT_EOF_BFR_DES_ADDR_CH2.Reg, value)
}
func (o *DMA_Type) GetOUT_EOF_BFR_DES_ADDR_CH2() uint32 {
	return volatile.LoadUint32(&o.OUT_EOF_BFR_DES_ADDR_CH2.Reg)
}

// DMA.OUT_DSCR_CH2: DMA_OUT_DSCR_CH2_REG.
func (o *DMA_Type) SetOUT_DSCR_CH2(value uint32) {
	volatile.StoreUint32(&o.OUT_DSCR_CH2.Reg, value)
}
func (o *DMA_Type) GetOUT_DSCR_CH2() uint32 {
	return volatile.LoadUint32(&o.OUT_DSCR_CH2.Reg)
}

// DMA.OUT_DSCR_BF0_CH2: DMA_OUT_DSCR_BF0_CH2_REG.
func (o *DMA_Type) SetOUT_DSCR_BF0_CH2(value uint32) {
	volatile.StoreUint32(&o.OUT_DSCR_BF0_CH2.Reg, value)
}
func (o *DMA_Type) GetOUT_DSCR_BF0_CH2() uint32 {
	return volatile.LoadUint32(&o.OUT_DSCR_BF0_CH2.Reg)
}

// DMA.OUT_DSCR_BF1_CH2: DMA_OUT_DSCR_BF1_CH2_REG.
func (o *DMA_Type) SetOUT_DSCR_BF1_CH2(value uint32) {
	volatile.StoreUint32(&o.OUT_DSCR_BF1_CH2.Reg, value)
}
func (o *DMA_Type) GetOUT_DSCR_BF1_CH2() uint32 {
	return volatile.LoadUint32(&o.OUT_DSCR_BF1_CH2.Reg)
}

// DMA.OUT_PRI_CH2: DMA_OUT_PRI_CH2_REG.
func (o *DMA_Type) SetOUT_PRI_CH2_TX_PRI_CH2(value uint32) {
	volatile.StoreUint32(&o.OUT_PRI_CH2.Reg, volatile.LoadUint32(&o.OUT_PRI_CH2.Reg)&^(0xf)|value)
}
func (o *DMA_Type) GetOUT_PRI_CH2_TX_PRI_CH2() uint32 {
	return volatile.LoadUint32(&o.OUT_PRI_CH2.Reg) & 0xf
}

// DMA.OUT_PERI_SEL_CH2: DMA_OUT_PERI_SEL_CH2_REG.
func (o *DMA_Type) SetOUT_PERI_SEL_CH2_PERI_OUT_SEL_CH2(value uint32) {
	volatile.StoreUint32(&o.OUT_PERI_SEL_CH2.Reg, volatile.LoadUint32(&o.OUT_PERI_SEL_CH2.Reg)&^(0x3f)|value)
}
func (o *DMA_Type) GetOUT_PERI_SEL_CH2_PERI_OUT_SEL_CH2() uint32 {
	return volatile.LoadUint32(&o.OUT_PERI_SEL_CH2.Reg) & 0x3f
}

// Peripheral DS
type DS_Type struct {
	Y_MEM           volatile.Register32 // 0x0
	_               [508]byte
	M_MEM           volatile.Register32 // 0x200
	_               [508]byte
	RB_MEM          volatile.Register32 // 0x400
	_               [508]byte
	BOX_MEM         volatile.Register32 // 0x600
	_               [508]byte
	X_MEM           volatile.Register32 // 0x800
	_               [508]byte
	Z_MEM           volatile.Register32 // 0xA00
	_               [1020]byte
	SET_START       volatile.Register32 // 0xE00
	SET_CONTINUE    volatile.Register32 // 0xE04
	SET_FINISH      volatile.Register32 // 0xE08
	QUERY_BUSY      volatile.Register32 // 0xE0C
	QUERY_KEY_WRONG volatile.Register32 // 0xE10
	QUERY_CHECK     volatile.Register32 // 0xE14
	_               [8]byte
	DATE            volatile.Register32 // 0xE20
}

// DS.SET_START: DS start control register
func (o *DS_Type) SetSET_START(value uint32) {
	volatile.StoreUint32(&o.SET_START.Reg, volatile.LoadUint32(&o.SET_START.Reg)&^(0x1)|value)
}
func (o *DS_Type) GetSET_START() uint32 {
	return volatile.LoadUint32(&o.SET_START.Reg) & 0x1
}

// DS.SET_CONTINUE: DS continue control register
func (o *DS_Type) SetSET_CONTINUE(value uint32) {
	volatile.StoreUint32(&o.SET_CONTINUE.Reg, volatile.LoadUint32(&o.SET_CONTINUE.Reg)&^(0x1)|value)
}
func (o *DS_Type) GetSET_CONTINUE() uint32 {
	return volatile.LoadUint32(&o.SET_CONTINUE.Reg) & 0x1
}

// DS.SET_FINISH: DS finish control register
func (o *DS_Type) SetSET_FINISH(value uint32) {
	volatile.StoreUint32(&o.SET_FINISH.Reg, volatile.LoadUint32(&o.SET_FINISH.Reg)&^(0x1)|value)
}
func (o *DS_Type) GetSET_FINISH() uint32 {
	return volatile.LoadUint32(&o.SET_FINISH.Reg) & 0x1
}

// DS.QUERY_BUSY: DS query busy register
func (o *DS_Type) SetQUERY_BUSY(value uint32) {
	volatile.StoreUint32(&o.QUERY_BUSY.Reg, volatile.LoadUint32(&o.QUERY_BUSY.Reg)&^(0x1)|value)
}
func (o *DS_Type) GetQUERY_BUSY() uint32 {
	return volatile.LoadUint32(&o.QUERY_BUSY.Reg) & 0x1
}

// DS.QUERY_KEY_WRONG: DS query key-wrong counter register
func (o *DS_Type) SetQUERY_KEY_WRONG(value uint32) {
	volatile.StoreUint32(&o.QUERY_KEY_WRONG.Reg, volatile.LoadUint32(&o.QUERY_KEY_WRONG.Reg)&^(0xf)|value)
}
func (o *DS_Type) GetQUERY_KEY_WRONG() uint32 {
	return volatile.LoadUint32(&o.QUERY_KEY_WRONG.Reg) & 0xf
}

// DS.QUERY_CHECK: DS query check result register
func (o *DS_Type) SetQUERY_CHECK_MD_ERROR(value uint32) {
	volatile.StoreUint32(&o.QUERY_CHECK.Reg, volatile.LoadUint32(&o.QUERY_CHECK.Reg)&^(0x1)|value)
}
func (o *DS_Type) GetQUERY_CHECK_MD_ERROR() uint32 {
	return volatile.LoadUint32(&o.QUERY_CHECK.Reg) & 0x1
}
func (o *DS_Type) SetQUERY_CHECK_PADDING_BAD(value uint32) {
	volatile.StoreUint32(&o.QUERY_CHECK.Reg, volatile.LoadUint32(&o.QUERY_CHECK.Reg)&^(0x2)|value<<1)
}
func (o *DS_Type) GetQUERY_CHECK_PADDING_BAD() uint32 {
	return (volatile.LoadUint32(&o.QUERY_CHECK.Reg) & 0x2) >> 1
}

// DS.DATE: DS version control register
func (o *DS_Type) SetDATE(value uint32) {
	volatile.StoreUint32(&o.DATE.Reg, volatile.LoadUint32(&o.DATE.Reg)&^(0x3fffffff)|value)
}
func (o *DS_Type) GetDATE() uint32 {
	return volatile.LoadUint32(&o.DATE.Reg) & 0x3fffffff
}

// Peripheral EFUSE
type EFUSE_Type struct {
	PGM_DATA0          volatile.Register32 // 0x0
	PGM_DATA1          volatile.Register32 // 0x4
	PGM_DATA2          volatile.Register32 // 0x8
	PGM_DATA3          volatile.Register32 // 0xC
	PGM_DATA4          volatile.Register32 // 0x10
	PGM_DATA5          volatile.Register32 // 0x14
	PGM_DATA6          volatile.Register32 // 0x18
	PGM_DATA7          volatile.Register32 // 0x1C
	PGM_CHECK_VALUE0   volatile.Register32 // 0x20
	PGM_CHECK_VALUE1   volatile.Register32 // 0x24
	PGM_CHECK_VALUE2   volatile.Register32 // 0x28
	RD_WR_DIS          volatile.Register32 // 0x2C
	RD_REPEAT_DATA0    volatile.Register32 // 0x30
	RD_REPEAT_DATA1    volatile.Register32 // 0x34
	RD_REPEAT_DATA2    volatile.Register32 // 0x38
	RD_REPEAT_DATA3    volatile.Register32 // 0x3C
	RD_REPEAT_DATA4    volatile.Register32 // 0x40
	RD_MAC_SPI_SYS_0   volatile.Register32 // 0x44
	RD_MAC_SPI_SYS_1   volatile.Register32 // 0x48
	RD_MAC_SPI_SYS_2   volatile.Register32 // 0x4C
	RD_MAC_SPI_SYS_3   volatile.Register32 // 0x50
	RD_MAC_SPI_SYS_4   volatile.Register32 // 0x54
	RD_MAC_SPI_SYS_5   volatile.Register32 // 0x58
	RD_SYS_PART1_DATA0 volatile.Register32 // 0x5C
	RD_SYS_PART1_DATA1 volatile.Register32 // 0x60
	RD_SYS_PART1_DATA2 volatile.Register32 // 0x64
	RD_SYS_PART1_DATA3 volatile.Register32 // 0x68
	RD_SYS_PART1_DATA4 volatile.Register32 // 0x6C
	RD_SYS_PART1_DATA5 volatile.Register32 // 0x70
	RD_SYS_PART1_DATA6 volatile.Register32 // 0x74
	RD_SYS_PART1_DATA7 volatile.Register32 // 0x78
	RD_USR_DATA0       volatile.Register32 // 0x7C
	RD_USR_DATA1       volatile.Register32 // 0x80
	RD_USR_DATA2       volatile.Register32 // 0x84
	RD_USR_DATA3       volatile.Register32 // 0x88
	RD_USR_DATA4       volatile.Register32 // 0x8C
	RD_USR_DATA5       volatile.Register32 // 0x90
	RD_USR_DATA6       volatile.Register32 // 0x94
	RD_USR_DATA7       volatile.Register32 // 0x98
	RD_KEY0_DATA0      volatile.Register32 // 0x9C
	RD_KEY0_DATA1      volatile.Register32 // 0xA0
	RD_KEY0_DATA2      volatile.Register32 // 0xA4
	RD_KEY0_DATA3      volatile.Register32 // 0xA8
	RD_KEY0_DATA4      volatile.Register32 // 0xAC
	RD_KEY0_DATA5      volatile.Register32 // 0xB0
	RD_KEY0_DATA6      volatile.Register32 // 0xB4
	RD_KEY0_DATA7      volatile.Register32 // 0xB8
	RD_KEY1_DATA0      volatile.Register32 // 0xBC
	RD_KEY1_DATA1      volatile.Register32 // 0xC0
	RD_KEY1_DATA2      volatile.Register32 // 0xC4
	RD_KEY1_DATA3      volatile.Register32 // 0xC8
	RD_KEY1_DATA4      volatile.Register32 // 0xCC
	RD_KEY1_DATA5      volatile.Register32 // 0xD0
	RD_KEY1_DATA6      volatile.Register32 // 0xD4
	RD_KEY1_DATA7      volatile.Register32 // 0xD8
	RD_KEY2_DATA0      volatile.Register32 // 0xDC
	RD_KEY2_DATA1      volatile.Register32 // 0xE0
	RD_KEY2_DATA2      volatile.Register32 // 0xE4
	RD_KEY2_DATA3      volatile.Register32 // 0xE8
	RD_KEY2_DATA4      volatile.Register32 // 0xEC
	RD_KEY2_DATA5      volatile.Register32 // 0xF0
	RD_KEY2_DATA6      volatile.Register32 // 0xF4
	RD_KEY2_DATA7      volatile.Register32 // 0xF8
	RD_KEY3_DATA0      volatile.Register32 // 0xFC
	RD_KEY3_DATA1      volatile.Register32 // 0x100
	RD_KEY3_DATA2      volatile.Register32 // 0x104
	RD_KEY3_DATA3      volatile.Register32 // 0x108
	RD_KEY3_DATA4      volatile.Register32 // 0x10C
	RD_KEY3_DATA5      volatile.Register32 // 0x110
	RD_KEY3_DATA6      volatile.Register32 // 0x114
	RD_KEY3_DATA7      volatile.Register32 // 0x118
	RD_KEY4_DATA0      volatile.Register32 // 0x11C
	RD_KEY4_DATA1      volatile.Register32 // 0x120
	RD_KEY4_DATA2      volatile.Register32 // 0x124
	RD_KEY4_DATA3      volatile.Register32 // 0x128
	RD_KEY4_DATA4      volatile.Register32 // 0x12C
	RD_KEY4_DATA5      volatile.Register32 // 0x130
	RD_KEY4_DATA6      volatile.Register32 // 0x134
	RD_KEY4_DATA7      volatile.Register32 // 0x138
	RD_KEY5_DATA0      volatile.Register32 // 0x13C
	RD_KEY5_DATA1      volatile.Register32 // 0x140
	RD_KEY5_DATA2      volatile.Register32 // 0x144
	RD_KEY5_DATA3      volatile.Register32 // 0x148
	RD_KEY5_DATA4      volatile.Register32 // 0x14C
	RD_KEY5_DATA5      volatile.Register32 // 0x150
	RD_KEY5_DATA6      volatile.Register32 // 0x154
	RD_KEY5_DATA7      volatile.Register32 // 0x158
	RD_SYS_PART2_DATA0 volatile.Register32 // 0x15C
	RD_SYS_PART2_DATA1 volatile.Register32 // 0x160
	RD_SYS_PART2_DATA2 volatile.Register32 // 0x164
	RD_SYS_PART2_DATA3 volatile.Register32 // 0x168
	RD_SYS_PART2_DATA4 volatile.Register32 // 0x16C
	RD_SYS_PART2_DATA5 volatile.Register32 // 0x170
	RD_SYS_PART2_DATA6 volatile.Register32 // 0x174
	RD_SYS_PART2_DATA7 volatile.Register32 // 0x178
	RD_REPEAT_ERR0     volatile.Register32 // 0x17C
	RD_REPEAT_ERR1     volatile.Register32 // 0x180
	RD_REPEAT_ERR2     volatile.Register32 // 0x184
	RD_REPEAT_ERR3     volatile.Register32 // 0x188
	_                  [4]byte
	RD_REPEAT_ERR4     volatile.Register32 // 0x190
	_                  [44]byte
	RD_RS_ERR0         volatile.Register32 // 0x1C0
	RD_RS_ERR1         volatile.Register32 // 0x1C4
	CLK                volatile.Register32 // 0x1C8
	CONF               volatile.Register32 // 0x1CC
	STATUS             volatile.Register32 // 0x1D0
	CMD                volatile.Register32 // 0x1D4
	INT_RAW            volatile.Register32 // 0x1D8
	INT_ST             volatile.Register32 // 0x1DC
	INT_ENA            volatile.Register32 // 0x1E0
	INT_CLR            volatile.Register32 // 0x1E4
	DAC_CONF           volatile.Register32 // 0x1E8
	RD_TIM_CONF        volatile.Register32 // 0x1EC
	WR_TIM_CONF1       volatile.Register32 // 0x1F0
	WR_TIM_CONF2       volatile.Register32 // 0x1F4
	_                  [4]byte
	DATE               volatile.Register32 // 0x1FC
}

// EFUSE.PGM_DATA0: Register 0 that stores data to be programmed.
func (o *EFUSE_Type) SetPGM_DATA0(value uint32) {
	volatile.StoreUint32(&o.PGM_DATA0.Reg, value)
}
func (o *EFUSE_Type) GetPGM_DATA0() uint32 {
	return volatile.LoadUint32(&o.PGM_DATA0.Reg)
}

// EFUSE.PGM_DATA1: Register 1 that stores data to be programmed.
func (o *EFUSE_Type) SetPGM_DATA1(value uint32) {
	volatile.StoreUint32(&o.PGM_DATA1.Reg, value)
}
func (o *EFUSE_Type) GetPGM_DATA1() uint32 {
	return volatile.LoadUint32(&o.PGM_DATA1.Reg)
}

// EFUSE.PGM_DATA2: Register 2 that stores data to be programmed.
func (o *EFUSE_Type) SetPGM_DATA2(value uint32) {
	volatile.StoreUint32(&o.PGM_DATA2.Reg, value)
}
func (o *EFUSE_Type) GetPGM_DATA2() uint32 {
	return volatile.LoadUint32(&o.PGM_DATA2.Reg)
}

// EFUSE.PGM_DATA3: Register 3 that stores data to be programmed.
func (o *EFUSE_Type) SetPGM_DATA3(value uint32) {
	volatile.StoreUint32(&o.PGM_DATA3.Reg, value)
}
func (o *EFUSE_Type) GetPGM_DATA3() uint32 {
	return volatile.LoadUint32(&o.PGM_DATA3.Reg)
}

// EFUSE.PGM_DATA4: Register 4 that stores data to be programmed.
func (o *EFUSE_Type) SetPGM_DATA4(value uint32) {
	volatile.StoreUint32(&o.PGM_DATA4.Reg, value)
}
func (o *EFUSE_Type) GetPGM_DATA4() uint32 {
	return volatile.LoadUint32(&o.PGM_DATA4.Reg)
}

// EFUSE.PGM_DATA5: Register 5 that stores data to be programmed.
func (o *EFUSE_Type) SetPGM_DATA5(value uint32) {
	volatile.StoreUint32(&o.PGM_DATA5.Reg, value)
}
func (o *EFUSE_Type) GetPGM_DATA5() uint32 {
	return volatile.LoadUint32(&o.PGM_DATA5.Reg)
}

// EFUSE.PGM_DATA6: Register 6 that stores data to be programmed.
func (o *EFUSE_Type) SetPGM_DATA6(value uint32) {
	volatile.StoreUint32(&o.PGM_DATA6.Reg, value)
}
func (o *EFUSE_Type) GetPGM_DATA6() uint32 {
	return volatile.LoadUint32(&o.PGM_DATA6.Reg)
}

// EFUSE.PGM_DATA7: Register 7 that stores data to be programmed.
func (o *EFUSE_Type) SetPGM_DATA7(value uint32) {
	volatile.StoreUint32(&o.PGM_DATA7.Reg, value)
}
func (o *EFUSE_Type) GetPGM_DATA7() uint32 {
	return volatile.LoadUint32(&o.PGM_DATA7.Reg)
}

// EFUSE.PGM_CHECK_VALUE0: Register 0 that stores the RS code to be programmed.
func (o *EFUSE_Type) SetPGM_CHECK_VALUE0(value uint32) {
	volatile.StoreUint32(&o.PGM_CHECK_VALUE0.Reg, value)
}
func (o *EFUSE_Type) GetPGM_CHECK_VALUE0() uint32 {
	return volatile.LoadUint32(&o.PGM_CHECK_VALUE0.Reg)
}

// EFUSE.PGM_CHECK_VALUE1: Register 1 that stores the RS code to be programmed.
func (o *EFUSE_Type) SetPGM_CHECK_VALUE1(value uint32) {
	volatile.StoreUint32(&o.PGM_CHECK_VALUE1.Reg, value)
}
func (o *EFUSE_Type) GetPGM_CHECK_VALUE1() uint32 {
	return volatile.LoadUint32(&o.PGM_CHECK_VALUE1.Reg)
}

// EFUSE.PGM_CHECK_VALUE2: Register 2 that stores the RS code to be programmed.
func (o *EFUSE_Type) SetPGM_CHECK_VALUE2(value uint32) {
	volatile.StoreUint32(&o.PGM_CHECK_VALUE2.Reg, value)
}
func (o *EFUSE_Type) GetPGM_CHECK_VALUE2() uint32 {
	return volatile.LoadUint32(&o.PGM_CHECK_VALUE2.Reg)
}

// EFUSE.RD_WR_DIS: BLOCK0 data register 0.
func (o *EFUSE_Type) SetRD_WR_DIS(value uint32) {
	volatile.StoreUint32(&o.RD_WR_DIS.Reg, value)
}
func (o *EFUSE_Type) GetRD_WR_DIS() uint32 {
	return volatile.LoadUint32(&o.RD_WR_DIS.Reg)
}

// EFUSE.RD_REPEAT_DATA0: BLOCK0 data register 1.
func (o *EFUSE_Type) SetRD_REPEAT_DATA0_RD_DIS(value uint32) {
	volatile.StoreUint32(&o.RD_REPEAT_DATA0.Reg, volatile.LoadUint32(&o.RD_REPEAT_DATA0.Reg)&^(0x7f)|value)
}
func (o *EFUSE_Type) GetRD_REPEAT_DATA0_RD_DIS() uint32 {
	return volatile.LoadUint32(&o.RD_REPEAT_DATA0.Reg) & 0x7f
}
func (o *EFUSE_Type) SetRD_REPEAT_DATA0_DIS_RTC_RAM_BOOT(value uint32) {
	volatile.StoreUint32(&o.RD_REPEAT_DATA0.Reg, volatile.LoadUint32(&o.RD_REPEAT_DATA0.Reg)&^(0x80)|value<<7)
}
func (o *EFUSE_Type) GetRD_REPEAT_DATA0_DIS_RTC_RAM_BOOT() uint32 {
	return (volatile.LoadUint32(&o.RD_REPEAT_DATA0.Reg) & 0x80) >> 7
}
func (o *EFUSE_Type) SetRD_REPEAT_DATA0_DIS_ICACHE(value uint32) {
	volatile.StoreUint32(&o.RD_REPEAT_DATA0.Reg, volatile.LoadUint32(&o.RD_REPEAT_DATA0.Reg)&^(0x100)|value<<8)
}
func (o *EFUSE_Type) GetRD_REPEAT_DATA0_DIS_ICACHE() uint32 {
	return (volatile.LoadUint32(&o.RD_REPEAT_DATA0.Reg) & 0x100) >> 8
}
func (o *EFUSE_Type) SetRD_REPEAT_DATA0_DIS_USB_JTAG(value uint32) {
	volatile.StoreUint32(&o.RD_REPEAT_DATA0.Reg, volatile.LoadUint32(&o.RD_REPEAT_DATA0.Reg)&^(0x200)|value<<9)
}
func (o *EFUSE_Type) GetRD_REPEAT_DATA0_DIS_USB_JTAG() uint32 {
	return (volatile.LoadUint32(&o.RD_REPEAT_DATA0.Reg) & 0x200) >> 9
}
func (o *EFUSE_Type) SetRD_REPEAT_DATA0_DIS_DOWNLOAD_ICACHE(value uint32) {
	volatile.StoreUint32(&o.RD_REPEAT_DATA0.Reg, volatile.LoadUint32(&o.RD_REPEAT_DATA0.Reg)&^(0x400)|value<<10)
}
func (o *EFUSE_Type) GetRD_REPEAT_DATA0_DIS_DOWNLOAD_ICACHE() uint32 {
	return (volatile.LoadUint32(&o.RD_REPEAT_DATA0.Reg) & 0x400) >> 10
}
func (o *EFUSE_Type) SetRD_REPEAT_DATA0_DIS_USB_DEVICE(value uint32) {
	volatile.StoreUint32(&o.RD_REPEAT_DATA0.Reg, volatile.LoadUint32(&o.RD_REPEAT_DATA0.Reg)&^(0x800)|value<<11)
}
func (o *EFUSE_Type) GetRD_REPEAT_DATA0_DIS_USB_DEVICE() uint32 {
	return (volatile.LoadUint32(&o.RD_REPEAT_DATA0.Reg) & 0x800) >> 11
}
func (o *EFUSE_Type) SetRD_REPEAT_DATA0_DIS_FORCE_DOWNLOAD(value uint32) {
	volatile.StoreUint32(&o.RD_REPEAT_DATA0.Reg, volatile.LoadUint32(&o.RD_REPEAT_DATA0.Reg)&^(0x1000)|value<<12)
}
func (o *EFUSE_Type) GetRD_REPEAT_DATA0_DIS_FORCE_DOWNLOAD() uint32 {
	return (volatile.LoadUint32(&o.RD_REPEAT_DATA0.Reg) & 0x1000) >> 12
}
func (o *EFUSE_Type) SetRD_REPEAT_DATA0_RPT4_RESERVED6(value uint32) {
	volatile.StoreUint32(&o.RD_REPEAT_DATA0.Reg, volatile.LoadUint32(&o.RD_REPEAT_DATA0.Reg)&^(0x2000)|value<<13)
}
func (o *EFUSE_Type) GetRD_REPEAT_DATA0_RPT4_RESERVED6() uint32 {
	return (volatile.LoadUint32(&o.RD_REPEAT_DATA0.Reg) & 0x2000) >> 13
}
func (o *EFUSE_Type) SetRD_REPEAT_DATA0_DIS_CAN(value uint32) {
	volatile.StoreUint32(&o.RD_REPEAT_DATA0.Reg, volatile.LoadUint32(&o.RD_REPEAT_DATA0.Reg)&^(0x4000)|value<<14)
}
func (o *EFUSE_Type) GetRD_REPEAT_DATA0_DIS_CAN() uint32 {
	return (volatile.LoadUint32(&o.RD_REPEAT_DATA0.Reg) & 0x4000) >> 14
}
func (o *EFUSE_Type) SetRD_REPEAT_DATA0_JTAG_SEL_ENABLE(value uint32) {
	volatile.StoreUint32(&o.RD_REPEAT_DATA0.Reg, volatile.LoadUint32(&o.RD_REPEAT_DATA0.Reg)&^(0x8000)|value<<15)
}
func (o *EFUSE_Type) GetRD_REPEAT_DATA0_JTAG_SEL_ENABLE() uint32 {
	return (volatile.LoadUint32(&o.RD_REPEAT_DATA0.Reg) & 0x8000) >> 15
}
func (o *EFUSE_Type) SetRD_REPEAT_DATA0_SOFT_DIS_JTAG(value uint32) {
	volatile.StoreUint32(&o.RD_REPEAT_DATA0.Reg, volatile.LoadUint32(&o.RD_REPEAT_DATA0.Reg)&^(0x70000)|value<<16)
}
func (o *EFUSE_Type) GetRD_REPEAT_DATA0_SOFT_DIS_JTAG() uint32 {
	return (volatile.LoadUint32(&o.RD_REPEAT_DATA0.Reg) & 0x70000) >> 16
}
func (o *EFUSE_Type) SetRD_REPEAT_DATA0_DIS_PAD_JTAG(value uint32) {
	volatile.StoreUint32(&o.RD_REPEAT_DATA0.Reg, volatile.LoadUint32(&o.RD_REPEAT_DATA0.Reg)&^(0x80000)|value<<19)
}
func (o *EFUSE_Type) GetRD_REPEAT_DATA0_DIS_PAD_JTAG() uint32 {
	return (volatile.LoadUint32(&o.RD_REPEAT_DATA0.Reg) & 0x80000) >> 19
}
func (o *EFUSE_Type) SetRD_REPEAT_DATA0_DIS_DOWNLOAD_MANUAL_ENCRYPT(value uint32) {
	volatile.StoreUint32(&o.RD_REPEAT_DATA0.Reg, volatile.LoadUint32(&o.RD_REPEAT_DATA0.Reg)&^(0x100000)|value<<20)
}
func (o *EFUSE_Type) GetRD_REPEAT_DATA0_DIS_DOWNLOAD_MANUAL_ENCRYPT() uint32 {
	return (volatile.LoadUint32(&o.RD_REPEAT_DATA0.Reg) & 0x100000) >> 20
}
func (o *EFUSE_Type) SetRD_REPEAT_DATA0_USB_DREFH(value uint32) {
	volatile.StoreUint32(&o.RD_REPEAT_DATA0.Reg, volatile.LoadUint32(&o.RD_REPEAT_DATA0.Reg)&^(0x600000)|value<<21)
}
func (o *EFUSE_Type) GetRD_REPEAT_DATA0_USB_DREFH() uint32 {
	return (volatile.LoadUint32(&o.RD_REPEAT_DATA0.Reg) & 0x600000) >> 21
}
func (o *EFUSE_Type) SetRD_REPEAT_DATA0_USB_DREFL(value uint32) {
	volatile.StoreUint32(&o.RD_REPEAT_DATA0.Reg, volatile.LoadUint32(&o.RD_REPEAT_DATA0.Reg)&^(0x1800000)|value<<23)
}
func (o *EFUSE_Type) GetRD_REPEAT_DATA0_USB_DREFL() uint32 {
	return (volatile.LoadUint32(&o.RD_REPEAT_DATA0.Reg) & 0x1800000) >> 23
}
func (o *EFUSE_Type) SetRD_REPEAT_DATA0_USB_EXCHG_PINS(value uint32) {
	volatile.StoreUint32(&o.RD_REPEAT_DATA0.Reg, volatile.LoadUint32(&o.RD_REPEAT_DATA0.Reg)&^(0x2000000)|value<<25)
}
func (o *EFUSE_Type) GetRD_REPEAT_DATA0_USB_EXCHG_PINS() uint32 {
	return (volatile.LoadUint32(&o.RD_REPEAT_DATA0.Reg) & 0x2000000) >> 25
}
func (o *EFUSE_Type) SetRD_REPEAT_DATA0_VDD_SPI_AS_GPIO(value uint32) {
	volatile.StoreUint32(&o.RD_REPEAT_DATA0.Reg, volatile.LoadUint32(&o.RD_REPEAT_DATA0.Reg)&^(0x4000000)|value<<26)
}
func (o *EFUSE_Type) GetRD_REPEAT_DATA0_VDD_SPI_AS_GPIO() uint32 {
	return (volatile.LoadUint32(&o.RD_REPEAT_DATA0.Reg) & 0x4000000) >> 26
}
func (o *EFUSE_Type) SetRD_REPEAT_DATA0_BTLC_GPIO_ENABLE(value uint32) {
	volatile.StoreUint32(&o.RD_REPEAT_DATA0.Reg, volatile.LoadUint32(&o.RD_REPEAT_DATA0.Reg)&^(0x18000000)|value<<27)
}
func (o *EFUSE_Type) GetRD_REPEAT_DATA0_BTLC_GPIO_ENABLE() uint32 {
	return (volatile.LoadUint32(&o.RD_REPEAT_DATA0.Reg) & 0x18000000) >> 27
}
func (o *EFUSE_Type) SetRD_REPEAT_DATA0_POWERGLITCH_EN(value uint32) {
	volatile.StoreUint32(&o.RD_REPEAT_DATA0.Reg, volatile.LoadUint32(&o.RD_REPEAT_DATA0.Reg)&^(0x20000000)|value<<29)
}
func (o *EFUSE_Type) GetRD_REPEAT_DATA0_POWERGLITCH_EN() uint32 {
	return (volatile.LoadUint32(&o.RD_REPEAT_DATA0.Reg) & 0x20000000) >> 29
}
func (o *EFUSE_Type) SetRD_REPEAT_DATA0_POWER_GLITCH_DSENSE(value uint32) {
	volatile.StoreUint32(&o.RD_REPEAT_DATA0.Reg, volatile.LoadUint32(&o.RD_REPEAT_DATA0.Reg)&^(0xc0000000)|value<<30)
}
func (o *EFUSE_Type) GetRD_REPEAT_DATA0_POWER_GLITCH_DSENSE() uint32 {
	return (volatile.LoadUint32(&o.RD_REPEAT_DATA0.Reg) & 0xc0000000) >> 30
}

// EFUSE.RD_REPEAT_DATA1: BLOCK0 data register 2.
func (o *EFUSE_Type) SetRD_REPEAT_DATA1_RPT4_RESERVED2(value uint32) {
	volatile.StoreUint32(&o.RD_REPEAT_DATA1.Reg, volatile.LoadUint32(&o.RD_REPEAT_DATA1.Reg)&^(0xffff)|value)
}
func (o *EFUSE_Type) GetRD_REPEAT_DATA1_RPT4_RESERVED2() uint32 {
	return volatile.LoadUint32(&o.RD_REPEAT_DATA1.Reg) & 0xffff
}
func (o *EFUSE_Type) SetRD_REPEAT_DATA1_WDT_DELAY_SEL(value uint32) {
	volatile.StoreUint32(&o.RD_REPEAT_DATA1.Reg, volatile.LoadUint32(&o.RD_REPEAT_DATA1.Reg)&^(0x30000)|value<<16)
}
func (o *EFUSE_Type) GetRD_REPEAT_DATA1_WDT_DELAY_SEL() uint32 {
	return (volatile.LoadUint32(&o.RD_REPEAT_DATA1.Reg) & 0x30000) >> 16
}
func (o *EFUSE_Type) SetRD_REPEAT_DATA1_SPI_BOOT_CRYPT_CNT(value uint32) {
	volatile.StoreUint32(&o.RD_REPEAT_DATA1.Reg, volatile.LoadUint32(&o.RD_REPEAT_DATA1.Reg)&^(0x1c0000)|value<<18)
}
func (o *EFUSE_Type) GetRD_REPEAT_DATA1_SPI_BOOT_CRYPT_CNT() uint32 {
	return (volatile.LoadUint32(&o.RD_REPEAT_DATA1.Reg) & 0x1c0000) >> 18
}
func (o *EFUSE_Type) SetRD_REPEAT_DATA1_SECURE_BOOT_KEY_REVOKE0(value uint32) {
	volatile.StoreUint32(&o.RD_REPEAT_DATA1.Reg, volatile.LoadUint32(&o.RD_REPEAT_DATA1.Reg)&^(0x200000)|value<<21)
}
func (o *EFUSE_Type) GetRD_REPEAT_DATA1_SECURE_BOOT_KEY_REVOKE0() uint32 {
	return (volatile.LoadUint32(&o.RD_REPEAT_DATA1.Reg) & 0x200000) >> 21
}
func (o *EFUSE_Type) SetRD_REPEAT_DATA1_SECURE_BOOT_KEY_REVOKE1(value uint32) {
	volatile.StoreUint32(&o.RD_REPEAT_DATA1.Reg, volatile.LoadUint32(&o.RD_REPEAT_DATA1.Reg)&^(0x400000)|value<<22)
}
func (o *EFUSE_Type) GetRD_REPEAT_DATA1_SECURE_BOOT_KEY_REVOKE1() uint32 {
	return (volatile.LoadUint32(&o.RD_REPEAT_DATA1.Reg) & 0x400000) >> 22
}
func (o *EFUSE_Type) SetRD_REPEAT_DATA1_SECURE_BOOT_KEY_REVOKE2(value uint32) {
	volatile.StoreUint32(&o.RD_REPEAT_DATA1.Reg, volatile.LoadUint32(&o.RD_REPEAT_DATA1.Reg)&^(0x800000)|value<<23)
}
func (o *EFUSE_Type) GetRD_REPEAT_DATA1_SECURE_BOOT_KEY_REVOKE2() uint32 {
	return (volatile.LoadUint32(&o.RD_REPEAT_DATA1.Reg) & 0x800000) >> 23
}
func (o *EFUSE_Type) SetRD_REPEAT_DATA1_KEY_PURPOSE_0(value uint32) {
	volatile.StoreUint32(&o.RD_REPEAT_DATA1.Reg, volatile.LoadUint32(&o.RD_REPEAT_DATA1.Reg)&^(0xf000000)|value<<24)
}
func (o *EFUSE_Type) GetRD_REPEAT_DATA1_KEY_PURPOSE_0() uint32 {
	return (volatile.LoadUint32(&o.RD_REPEAT_DATA1.Reg) & 0xf000000) >> 24
}
func (o *EFUSE_Type) SetRD_REPEAT_DATA1_KEY_PURPOSE_1(value uint32) {
	volatile.StoreUint32(&o.RD_REPEAT_DATA1.Reg, volatile.LoadUint32(&o.RD_REPEAT_DATA1.Reg)&^(0xf0000000)|value<<28)
}
func (o *EFUSE_Type) GetRD_REPEAT_DATA1_KEY_PURPOSE_1() uint32 {
	return (volatile.LoadUint32(&o.RD_REPEAT_DATA1.Reg) & 0xf0000000) >> 28
}

// EFUSE.RD_REPEAT_DATA2: BLOCK0 data register 3.
func (o *EFUSE_Type) SetRD_REPEAT_DATA2_KEY_PURPOSE_2(value uint32) {
	volatile.StoreUint32(&o.RD_REPEAT_DATA2.Reg, volatile.LoadUint32(&o.RD_REPEAT_DATA2.Reg)&^(0xf)|value)
}
func (o *EFUSE_Type) GetRD_REPEAT_DATA2_KEY_PURPOSE_2() uint32 {
	return volatile.LoadUint32(&o.RD_REPEAT_DATA2.Reg) & 0xf
}
func (o *EFUSE_Type) SetRD_REPEAT_DATA2_KEY_PURPOSE_3(value uint32) {
	volatile.StoreUint32(&o.RD_REPEAT_DATA2.Reg, volatile.LoadUint32(&o.RD_REPEAT_DATA2.Reg)&^(0xf0)|value<<4)
}
func (o *EFUSE_Type) GetRD_REPEAT_DATA2_KEY_PURPOSE_3() uint32 {
	return (volatile.LoadUint32(&o.RD_REPEAT_DATA2.Reg) & 0xf0) >> 4
}
func (o *EFUSE_Type) SetRD_REPEAT_DATA2_KEY_PURPOSE_4(value uint32) {
	volatile.StoreUint32(&o.RD_REPEAT_DATA2.Reg, volatile.LoadUint32(&o.RD_REPEAT_DATA2.Reg)&^(0xf00)|value<<8)
}
func (o *EFUSE_Type) GetRD_REPEAT_DATA2_KEY_PURPOSE_4() uint32 {
	return (volatile.LoadUint32(&o.RD_REPEAT_DATA2.Reg) & 0xf00) >> 8
}
func (o *EFUSE_Type) SetRD_REPEAT_DATA2_KEY_PURPOSE_5(value uint32) {
	volatile.StoreUint32(&o.RD_REPEAT_DATA2.Reg, volatile.LoadUint32(&o.RD_REPEAT_DATA2.Reg)&^(0xf000)|value<<12)
}
func (o *EFUSE_Type) GetRD_REPEAT_DATA2_KEY_PURPOSE_5() uint32 {
	return (volatile.LoadUint32(&o.RD_REPEAT_DATA2.Reg) & 0xf000) >> 12
}
func (o *EFUSE_Type) SetRD_REPEAT_DATA2_RPT4_RESERVED3(value uint32) {
	volatile.StoreUint32(&o.RD_REPEAT_DATA2.Reg, volatile.LoadUint32(&o.RD_REPEAT_DATA2.Reg)&^(0xf0000)|value<<16)
}
func (o *EFUSE_Type) GetRD_REPEAT_DATA2_RPT4_RESERVED3() uint32 {
	return (volatile.LoadUint32(&o.RD_REPEAT_DATA2.Reg) & 0xf0000) >> 16
}
func (o *EFUSE_Type) SetRD_REPEAT_DATA2_SECURE_BOOT_EN(value uint32) {
	volatile.StoreUint32(&o.RD_REPEAT_DATA2.Reg, volatile.LoadUint32(&o.RD_REPEAT_DATA2.Reg)&^(0x100000)|value<<20)
}
func (o *EFUSE_Type) GetRD_REPEAT_DATA2_SECURE_BOOT_EN() uint32 {
	return (volatile.LoadUint32(&o.RD_REPEAT_DATA2.Reg) & 0x100000) >> 20
}
func (o *EFUSE_Type) SetRD_REPEAT_DATA2_SECURE_BOOT_AGGRESSIVE_REVOKE(value uint32) {
	volatile.StoreUint32(&o.RD_REPEAT_DATA2.Reg, volatile.LoadUint32(&o.RD_REPEAT_DATA2.Reg)&^(0x200000)|value<<21)
}
func (o *EFUSE_Type) GetRD_REPEAT_DATA2_SECURE_BOOT_AGGRESSIVE_REVOKE() uint32 {
	return (volatile.LoadUint32(&o.RD_REPEAT_DATA2.Reg) & 0x200000) >> 21
}
func (o *EFUSE_Type) SetRD_REPEAT_DATA2_RPT4_RESERVED0(value uint32) {
	volatile.StoreUint32(&o.RD_REPEAT_DATA2.Reg, volatile.LoadUint32(&o.RD_REPEAT_DATA2.Reg)&^(0xfc00000)|value<<22)
}
func (o *EFUSE_Type) GetRD_REPEAT_DATA2_RPT4_RESERVED0() uint32 {
	return (volatile.LoadUint32(&o.RD_REPEAT_DATA2.Reg) & 0xfc00000) >> 22
}
func (o *EFUSE_Type) SetRD_REPEAT_DATA2_FLASH_TPUW(value uint32) {
	volatile.StoreUint32(&o.RD_REPEAT_DATA2.Reg, volatile.LoadUint32(&o.RD_REPEAT_DATA2.Reg)&^(0xf0000000)|value<<28)
}
func (o *EFUSE_Type) GetRD_REPEAT_DATA2_FLASH_TPUW() uint32 {
	return (volatile.LoadUint32(&o.RD_REPEAT_DATA2.Reg) & 0xf0000000) >> 28
}

// EFUSE.RD_REPEAT_DATA3: BLOCK0 data register 4.
func (o *EFUSE_Type) SetRD_REPEAT_DATA3_DIS_DOWNLOAD_MODE(value uint32) {
	volatile.StoreUint32(&o.RD_REPEAT_DATA3.Reg, volatile.LoadUint32(&o.RD_REPEAT_DATA3.Reg)&^(0x1)|value)
}
func (o *EFUSE_Type) GetRD_REPEAT_DATA3_DIS_DOWNLOAD_MODE() uint32 {
	return volatile.LoadUint32(&o.RD_REPEAT_DATA3.Reg) & 0x1
}
func (o *EFUSE_Type) SetRD_REPEAT_DATA3_DIS_LEGACY_SPI_BOOT(value uint32) {
	volatile.StoreUint32(&o.RD_REPEAT_DATA3.Reg, volatile.LoadUint32(&o.RD_REPEAT_DATA3.Reg)&^(0x2)|value<<1)
}
func (o *EFUSE_Type) GetRD_REPEAT_DATA3_DIS_LEGACY_SPI_BOOT() uint32 {
	return (volatile.LoadUint32(&o.RD_REPEAT_DATA3.Reg) & 0x2) >> 1
}
func (o *EFUSE_Type) SetRD_REPEAT_DATA3_UART_PRINT_CHANNEL(value uint32) {
	volatile.StoreUint32(&o.RD_REPEAT_DATA3.Reg, volatile.LoadUint32(&o.RD_REPEAT_DATA3.Reg)&^(0x4)|value<<2)
}
func (o *EFUSE_Type) GetRD_REPEAT_DATA3_UART_PRINT_CHANNEL() uint32 {
	return (volatile.LoadUint32(&o.RD_REPEAT_DATA3.Reg) & 0x4) >> 2
}
func (o *EFUSE_Type) SetRD_REPEAT_DATA3_FLASH_ECC_MODE(value uint32) {
	volatile.StoreUint32(&o.RD_REPEAT_DATA3.Reg, volatile.LoadUint32(&o.RD_REPEAT_DATA3.Reg)&^(0x8)|value<<3)
}
func (o *EFUSE_Type) GetRD_REPEAT_DATA3_FLASH_ECC_MODE() uint32 {
	return (volatile.LoadUint32(&o.RD_REPEAT_DATA3.Reg) & 0x8) >> 3
}
func (o *EFUSE_Type) SetRD_REPEAT_DATA3_DIS_USB_DOWNLOAD_MODE(value uint32) {
	volatile.StoreUint32(&o.RD_REPEAT_DATA3.Reg, volatile.LoadUint32(&o.RD_REPEAT_DATA3.Reg)&^(0x10)|value<<4)
}
func (o *EFUSE_Type) GetRD_REPEAT_DATA3_DIS_USB_DOWNLOAD_MODE() uint32 {
	return (volatile.LoadUint32(&o.RD_REPEAT_DATA3.Reg) & 0x10) >> 4
}
func (o *EFUSE_Type) SetRD_REPEAT_DATA3_ENABLE_SECURITY_DOWNLOAD(value uint32) {
	volatile.StoreUint32(&o.RD_REPEAT_DATA3.Reg, volatile.LoadUint32(&o.RD_REPEAT_DATA3.Reg)&^(0x20)|value<<5)
}
func (o *EFUSE_Type) GetRD_REPEAT_DATA3_ENABLE_SECURITY_DOWNLOAD() uint32 {
	return (volatile.LoadUint32(&o.RD_REPEAT_DATA3.Reg) & 0x20) >> 5
}
func (o *EFUSE_Type) SetRD_REPEAT_DATA3_UART_PRINT_CONTROL(value uint32) {
	volatile.StoreUint32(&o.RD_REPEAT_DATA3.Reg, volatile.LoadUint32(&o.RD_REPEAT_DATA3.Reg)&^(0xc0)|value<<6)
}
func (o *EFUSE_Type) GetRD_REPEAT_DATA3_UART_PRINT_CONTROL() uint32 {
	return (volatile.LoadUint32(&o.RD_REPEAT_DATA3.Reg) & 0xc0) >> 6
}
func (o *EFUSE_Type) SetRD_REPEAT_DATA3_PIN_POWER_SELECTION(value uint32) {
	volatile.StoreUint32(&o.RD_REPEAT_DATA3.Reg, volatile.LoadUint32(&o.RD_REPEAT_DATA3.Reg)&^(0x100)|value<<8)
}
func (o *EFUSE_Type) GetRD_REPEAT_DATA3_PIN_POWER_SELECTION() uint32 {
	return (volatile.LoadUint32(&o.RD_REPEAT_DATA3.Reg) & 0x100) >> 8
}
func (o *EFUSE_Type) SetRD_REPEAT_DATA3_FLASH_TYPE(value uint32) {
	volatile.StoreUint32(&o.RD_REPEAT_DATA3.Reg, volatile.LoadUint32(&o.RD_REPEAT_DATA3.Reg)&^(0x200)|value<<9)
}
func (o *EFUSE_Type) GetRD_REPEAT_DATA3_FLASH_TYPE() uint32 {
	return (volatile.LoadUint32(&o.RD_REPEAT_DATA3.Reg) & 0x200) >> 9
}
func (o *EFUSE_Type) SetRD_REPEAT_DATA3_FLASH_PAGE_SIZE(value uint32) {
	volatile.StoreUint32(&o.RD_REPEAT_DATA3.Reg, volatile.LoadUint32(&o.RD_REPEAT_DATA3.Reg)&^(0xc00)|value<<10)
}
func (o *EFUSE_Type) GetRD_REPEAT_DATA3_FLASH_PAGE_SIZE() uint32 {
	return (volatile.LoadUint32(&o.RD_REPEAT_DATA3.Reg) & 0xc00) >> 10
}
func (o *EFUSE_Type) SetRD_REPEAT_DATA3_FLASH_ECC_EN(value uint32) {
	volatile.StoreUint32(&o.RD_REPEAT_DATA3.Reg, volatile.LoadUint32(&o.RD_REPEAT_DATA3.Reg)&^(0x1000)|value<<12)
}
func (o *EFUSE_Type) GetRD_REPEAT_DATA3_FLASH_ECC_EN() uint32 {
	return (volatile.LoadUint32(&o.RD_REPEAT_DATA3.Reg) & 0x1000) >> 12
}
func (o *EFUSE_Type) SetRD_REPEAT_DATA3_FORCE_SEND_RESUME(value uint32) {
	volatile.StoreUint32(&o.RD_REPEAT_DATA3.Reg, volatile.LoadUint32(&o.RD_REPEAT_DATA3.Reg)&^(0x2000)|value<<13)
}
func (o *EFUSE_Type) GetRD_REPEAT_DATA3_FORCE_SEND_RESUME() uint32 {
	return (volatile.LoadUint32(&o.RD_REPEAT_DATA3.Reg) & 0x2000) >> 13
}
func (o *EFUSE_Type) SetRD_REPEAT_DATA3_SECURE_VERSION(value uint32) {
	volatile.StoreUint32(&o.RD_REPEAT_DATA3.Reg, volatile.LoadUint32(&o.RD_REPEAT_DATA3.Reg)&^(0x3fffc000)|value<<14)
}
func (o *EFUSE_Type) GetRD_REPEAT_DATA3_SECURE_VERSION() uint32 {
	return (volatile.LoadUint32(&o.RD_REPEAT_DATA3.Reg) & 0x3fffc000) >> 14
}
func (o *EFUSE_Type) SetRD_REPEAT_DATA3_RPT4_RESERVED1(value uint32) {
	volatile.StoreUint32(&o.RD_REPEAT_DATA3.Reg, volatile.LoadUint32(&o.RD_REPEAT_DATA3.Reg)&^(0xc0000000)|value<<30)
}
func (o *EFUSE_Type) GetRD_REPEAT_DATA3_RPT4_RESERVED1() uint32 {
	return (volatile.LoadUint32(&o.RD_REPEAT_DATA3.Reg) & 0xc0000000) >> 30
}

// EFUSE.RD_REPEAT_DATA4: BLOCK0 data register 5.
func (o *EFUSE_Type) SetRD_REPEAT_DATA4_RPT4_RESERVED4(value uint32) {
	volatile.StoreUint32(&o.RD_REPEAT_DATA4.Reg, volatile.LoadUint32(&o.RD_REPEAT_DATA4.Reg)&^(0xffffff)|value)
}
func (o *EFUSE_Type) GetRD_REPEAT_DATA4_RPT4_RESERVED4() uint32 {
	return volatile.LoadUint32(&o.RD_REPEAT_DATA4.Reg) & 0xffffff
}

// EFUSE.RD_MAC_SPI_SYS_0: BLOCK1 data register 0.
func (o *EFUSE_Type) SetRD_MAC_SPI_SYS_0(value uint32) {
	volatile.StoreUint32(&o.RD_MAC_SPI_SYS_0.Reg, value)
}
func (o *EFUSE_Type) GetRD_MAC_SPI_SYS_0() uint32 {
	return volatile.LoadUint32(&o.RD_MAC_SPI_SYS_0.Reg)
}

// EFUSE.RD_MAC_SPI_SYS_1: BLOCK1 data register 1.
func (o *EFUSE_Type) SetRD_MAC_SPI_SYS_1_MAC_1(value uint32) {
	volatile.StoreUint32(&o.RD_MAC_SPI_SYS_1.Reg, volatile.LoadUint32(&o.RD_MAC_SPI_SYS_1.Reg)&^(0xffff)|value)
}
func (o *EFUSE_Type) GetRD_MAC_SPI_SYS_1_MAC_1() uint32 {
	return volatile.LoadUint32(&o.RD_MAC_SPI_SYS_1.Reg) & 0xffff
}
func (o *EFUSE_Type) SetRD_MAC_SPI_SYS_1_SPI_PAD_CONF_0(value uint32) {
	volatile.StoreUint32(&o.RD_MAC_SPI_SYS_1.Reg, volatile.LoadUint32(&o.RD_MAC_SPI_SYS_1.Reg)&^(0xffff0000)|value<<16)
}
func (o *EFUSE_Type) GetRD_MAC_SPI_SYS_1_SPI_PAD_CONF_0() uint32 {
	return (volatile.LoadUint32(&o.RD_MAC_SPI_SYS_1.Reg) & 0xffff0000) >> 16
}

// EFUSE.RD_MAC_SPI_SYS_2: BLOCK1 data register 2.
func (o *EFUSE_Type) SetRD_MAC_SPI_SYS_2(value uint32) {
	volatile.StoreUint32(&o.RD_MAC_SPI_SYS_2.Reg, value)
}
func (o *EFUSE_Type) GetRD_MAC_SPI_SYS_2() uint32 {
	return volatile.LoadUint32(&o.RD_MAC_SPI_SYS_2.Reg)
}

// EFUSE.RD_MAC_SPI_SYS_3: BLOCK1 data register 3.
func (o *EFUSE_Type) SetRD_MAC_SPI_SYS_3_SPI_PAD_CONF_2(value uint32) {
	volatile.StoreUint32(&o.RD_MAC_SPI_SYS_3.Reg, volatile.LoadUint32(&o.RD_MAC_SPI_SYS_3.Reg)&^(0x3ffff)|value)
}
func (o *EFUSE_Type) GetRD_MAC_SPI_SYS_3_SPI_PAD_CONF_2() uint32 {
	return volatile.LoadUint32(&o.RD_MAC_SPI_SYS_3.Reg) & 0x3ffff
}
func (o *EFUSE_Type) SetRD_MAC_SPI_SYS_3_SYS_DATA_PART0_0(value uint32) {
	volatile.StoreUint32(&o.RD_MAC_SPI_SYS_3.Reg, volatile.LoadUint32(&o.RD_MAC_SPI_SYS_3.Reg)&^(0xfffc0000)|value<<18)
}
func (o *EFUSE_Type) GetRD_MAC_SPI_SYS_3_SYS_DATA_PART0_0() uint32 {
	return (volatile.LoadUint32(&o.RD_MAC_SPI_SYS_3.Reg) & 0xfffc0000) >> 18
}

// EFUSE.RD_MAC_SPI_SYS_4: BLOCK1 data register 4.
func (o *EFUSE_Type) SetRD_MAC_SPI_SYS_4(value uint32) {
	volatile.StoreUint32(&o.RD_MAC_SPI_SYS_4.Reg, value)
}
func (o *EFUSE_Type) GetRD_MAC_SPI_SYS_4() uint32 {
	return volatile.LoadUint32(&o.RD_MAC_SPI_SYS_4.Reg)
}

// EFUSE.RD_MAC_SPI_SYS_5: BLOCK1 data register 5.
func (o *EFUSE_Type) SetRD_MAC_SPI_SYS_5(value uint32) {
	volatile.StoreUint32(&o.RD_MAC_SPI_SYS_5.Reg, value)
}
func (o *EFUSE_Type) GetRD_MAC_SPI_SYS_5() uint32 {
	return volatile.LoadUint32(&o.RD_MAC_SPI_SYS_5.Reg)
}

// EFUSE.RD_SYS_PART1_DATA0: Register 0 of BLOCK2 (system).
func (o *EFUSE_Type) SetRD_SYS_PART1_DATA0(value uint32) {
	volatile.StoreUint32(&o.RD_SYS_PART1_DATA0.Reg, value)
}
func (o *EFUSE_Type) GetRD_SYS_PART1_DATA0() uint32 {
	return volatile.LoadUint32(&o.RD_SYS_PART1_DATA0.Reg)
}

// EFUSE.RD_SYS_PART1_DATA1: Register 1 of BLOCK2 (system).
func (o *EFUSE_Type) SetRD_SYS_PART1_DATA1(value uint32) {
	volatile.StoreUint32(&o.RD_SYS_PART1_DATA1.Reg, value)
}
func (o *EFUSE_Type) GetRD_SYS_PART1_DATA1() uint32 {
	return volatile.LoadUint32(&o.RD_SYS_PART1_DATA1.Reg)
}

// EFUSE.RD_SYS_PART1_DATA2: Register 2 of BLOCK2 (system).
func (o *EFUSE_Type) SetRD_SYS_PART1_DATA2(value uint32) {
	volatile.StoreUint32(&o.RD_SYS_PART1_DATA2.Reg, value)
}
func (o *EFUSE_Type) GetRD_SYS_PART1_DATA2() uint32 {
	return volatile.LoadUint32(&o.RD_SYS_PART1_DATA2.Reg)
}

// EFUSE.RD_SYS_PART1_DATA3: Register 3 of BLOCK2 (system).
func (o *EFUSE_Type) SetRD_SYS_PART1_DATA3(value uint32) {
	volatile.StoreUint32(&o.RD_SYS_PART1_DATA3.Reg, value)
}
func (o *EFUSE_Type) GetRD_SYS_PART1_DATA3() uint32 {
	return volatile.LoadUint32(&o.RD_SYS_PART1_DATA3.Reg)
}

// EFUSE.RD_SYS_PART1_DATA4: Register 4 of BLOCK2 (system).
func (o *EFUSE_Type) SetRD_SYS_PART1_DATA4(value uint32) {
	volatile.StoreUint32(&o.RD_SYS_PART1_DATA4.Reg, value)
}
func (o *EFUSE_Type) GetRD_SYS_PART1_DATA4() uint32 {
	return volatile.LoadUint32(&o.RD_SYS_PART1_DATA4.Reg)
}

// EFUSE.RD_SYS_PART1_DATA5: Register 5 of BLOCK2 (system).
func (o *EFUSE_Type) SetRD_SYS_PART1_DATA5(value uint32) {
	volatile.StoreUint32(&o.RD_SYS_PART1_DATA5.Reg, value)
}
func (o *EFUSE_Type) GetRD_SYS_PART1_DATA5() uint32 {
	return volatile.LoadUint32(&o.RD_SYS_PART1_DATA5.Reg)
}

// EFUSE.RD_SYS_PART1_DATA6: Register 6 of BLOCK2 (system).
func (o *EFUSE_Type) SetRD_SYS_PART1_DATA6(value uint32) {
	volatile.StoreUint32(&o.RD_SYS_PART1_DATA6.Reg, value)
}
func (o *EFUSE_Type) GetRD_SYS_PART1_DATA6() uint32 {
	return volatile.LoadUint32(&o.RD_SYS_PART1_DATA6.Reg)
}

// EFUSE.RD_SYS_PART1_DATA7: Register 7 of BLOCK2 (system).
func (o *EFUSE_Type) SetRD_SYS_PART1_DATA7(value uint32) {
	volatile.StoreUint32(&o.RD_SYS_PART1_DATA7.Reg, value)
}
func (o *EFUSE_Type) GetRD_SYS_PART1_DATA7() uint32 {
	return volatile.LoadUint32(&o.RD_SYS_PART1_DATA7.Reg)
}

// EFUSE.RD_USR_DATA0: Register 0 of BLOCK3 (user).
func (o *EFUSE_Type) SetRD_USR_DATA0(value uint32) {
	volatile.StoreUint32(&o.RD_USR_DATA0.Reg, value)
}
func (o *EFUSE_Type) GetRD_USR_DATA0() uint32 {
	return volatile.LoadUint32(&o.RD_USR_DATA0.Reg)
}

// EFUSE.RD_USR_DATA1: Register 1 of BLOCK3 (user).
func (o *EFUSE_Type) SetRD_USR_DATA1(value uint32) {
	volatile.StoreUint32(&o.RD_USR_DATA1.Reg, value)
}
func (o *EFUSE_Type) GetRD_USR_DATA1() uint32 {
	return volatile.LoadUint32(&o.RD_USR_DATA1.Reg)
}

// EFUSE.RD_USR_DATA2: Register 2 of BLOCK3 (user).
func (o *EFUSE_Type) SetRD_USR_DATA2(value uint32) {
	volatile.StoreUint32(&o.RD_USR_DATA2.Reg, value)
}
func (o *EFUSE_Type) GetRD_USR_DATA2() uint32 {
	return volatile.LoadUint32(&o.RD_USR_DATA2.Reg)
}

// EFUSE.RD_USR_DATA3: Register 3 of BLOCK3 (user).
func (o *EFUSE_Type) SetRD_USR_DATA3(value uint32) {
	volatile.StoreUint32(&o.RD_USR_DATA3.Reg, value)
}
func (o *EFUSE_Type) GetRD_USR_DATA3() uint32 {
	return volatile.LoadUint32(&o.RD_USR_DATA3.Reg)
}

// EFUSE.RD_USR_DATA4: Register 4 of BLOCK3 (user).
func (o *EFUSE_Type) SetRD_USR_DATA4(value uint32) {
	volatile.StoreUint32(&o.RD_USR_DATA4.Reg, value)
}
func (o *EFUSE_Type) GetRD_USR_DATA4() uint32 {
	return volatile.LoadUint32(&o.RD_USR_DATA4.Reg)
}

// EFUSE.RD_USR_DATA5: Register 5 of BLOCK3 (user).
func (o *EFUSE_Type) SetRD_USR_DATA5(value uint32) {
	volatile.StoreUint32(&o.RD_USR_DATA5.Reg, value)
}
func (o *EFUSE_Type) GetRD_USR_DATA5() uint32 {
	return volatile.LoadUint32(&o.RD_USR_DATA5.Reg)
}

// EFUSE.RD_USR_DATA6: Register 6 of BLOCK3 (user).
func (o *EFUSE_Type) SetRD_USR_DATA6(value uint32) {
	volatile.StoreUint32(&o.RD_USR_DATA6.Reg, value)
}
func (o *EFUSE_Type) GetRD_USR_DATA6() uint32 {
	return volatile.LoadUint32(&o.RD_USR_DATA6.Reg)
}

// EFUSE.RD_USR_DATA7: Register 7 of BLOCK3 (user).
func (o *EFUSE_Type) SetRD_USR_DATA7(value uint32) {
	volatile.StoreUint32(&o.RD_USR_DATA7.Reg, value)
}
func (o *EFUSE_Type) GetRD_USR_DATA7() uint32 {
	return volatile.LoadUint32(&o.RD_USR_DATA7.Reg)
}

// EFUSE.RD_KEY0_DATA0: Register 0 of BLOCK4 (KEY0).
func (o *EFUSE_Type) SetRD_KEY0_DATA0(value uint32) {
	volatile.StoreUint32(&o.RD_KEY0_DATA0.Reg, value)
}
func (o *EFUSE_Type) GetRD_KEY0_DATA0() uint32 {
	return volatile.LoadUint32(&o.RD_KEY0_DATA0.Reg)
}

// EFUSE.RD_KEY0_DATA1: Register 1 of BLOCK4 (KEY0).
func (o *EFUSE_Type) SetRD_KEY0_DATA1(value uint32) {
	volatile.StoreUint32(&o.RD_KEY0_DATA1.Reg, value)
}
func (o *EFUSE_Type) GetRD_KEY0_DATA1() uint32 {
	return volatile.LoadUint32(&o.RD_KEY0_DATA1.Reg)
}

// EFUSE.RD_KEY0_DATA2: Register 2 of BLOCK4 (KEY0).
func (o *EFUSE_Type) SetRD_KEY0_DATA2(value uint32) {
	volatile.StoreUint32(&o.RD_KEY0_DATA2.Reg, value)
}
func (o *EFUSE_Type) GetRD_KEY0_DATA2() uint32 {
	return volatile.LoadUint32(&o.RD_KEY0_DATA2.Reg)
}

// EFUSE.RD_KEY0_DATA3: Register 3 of BLOCK4 (KEY0).
func (o *EFUSE_Type) SetRD_KEY0_DATA3(value uint32) {
	volatile.StoreUint32(&o.RD_KEY0_DATA3.Reg, value)
}
func (o *EFUSE_Type) GetRD_KEY0_DATA3() uint32 {
	return volatile.LoadUint32(&o.RD_KEY0_DATA3.Reg)
}

// EFUSE.RD_KEY0_DATA4: Register 4 of BLOCK4 (KEY0).
func (o *EFUSE_Type) SetRD_KEY0_DATA4(value uint32) {
	volatile.StoreUint32(&o.RD_KEY0_DATA4.Reg, value)
}
func (o *EFUSE_Type) GetRD_KEY0_DATA4() uint32 {
	return volatile.LoadUint32(&o.RD_KEY0_DATA4.Reg)
}

// EFUSE.RD_KEY0_DATA5: Register 5 of BLOCK4 (KEY0).
func (o *EFUSE_Type) SetRD_KEY0_DATA5(value uint32) {
	volatile.StoreUint32(&o.RD_KEY0_DATA5.Reg, value)
}
func (o *EFUSE_Type) GetRD_KEY0_DATA5() uint32 {
	return volatile.LoadUint32(&o.RD_KEY0_DATA5.Reg)
}

// EFUSE.RD_KEY0_DATA6: Register 6 of BLOCK4 (KEY0).
func (o *EFUSE_Type) SetRD_KEY0_DATA6(value uint32) {
	volatile.StoreUint32(&o.RD_KEY0_DATA6.Reg, value)
}
func (o *EFUSE_Type) GetRD_KEY0_DATA6() uint32 {
	return volatile.LoadUint32(&o.RD_KEY0_DATA6.Reg)
}

// EFUSE.RD_KEY0_DATA7: Register 7 of BLOCK4 (KEY0).
func (o *EFUSE_Type) SetRD_KEY0_DATA7(value uint32) {
	volatile.StoreUint32(&o.RD_KEY0_DATA7.Reg, value)
}
func (o *EFUSE_Type) GetRD_KEY0_DATA7() uint32 {
	return volatile.LoadUint32(&o.RD_KEY0_DATA7.Reg)
}

// EFUSE.RD_KEY1_DATA0: Register 0 of BLOCK5 (KEY1).
func (o *EFUSE_Type) SetRD_KEY1_DATA0(value uint32) {
	volatile.StoreUint32(&o.RD_KEY1_DATA0.Reg, value)
}
func (o *EFUSE_Type) GetRD_KEY1_DATA0() uint32 {
	return volatile.LoadUint32(&o.RD_KEY1_DATA0.Reg)
}

// EFUSE.RD_KEY1_DATA1: Register 1 of BLOCK5 (KEY1).
func (o *EFUSE_Type) SetRD_KEY1_DATA1(value uint32) {
	volatile.StoreUint32(&o.RD_KEY1_DATA1.Reg, value)
}
func (o *EFUSE_Type) GetRD_KEY1_DATA1() uint32 {
	return volatile.LoadUint32(&o.RD_KEY1_DATA1.Reg)
}

// EFUSE.RD_KEY1_DATA2: Register 2 of BLOCK5 (KEY1).
func (o *EFUSE_Type) SetRD_KEY1_DATA2(value uint32) {
	volatile.StoreUint32(&o.RD_KEY1_DATA2.Reg, value)
}
func (o *EFUSE_Type) GetRD_KEY1_DATA2() uint32 {
	return volatile.LoadUint32(&o.RD_KEY1_DATA2.Reg)
}

// EFUSE.RD_KEY1_DATA3: Register 3 of BLOCK5 (KEY1).
func (o *EFUSE_Type) SetRD_KEY1_DATA3(value uint32) {
	volatile.StoreUint32(&o.RD_KEY1_DATA3.Reg, value)
}
func (o *EFUSE_Type) GetRD_KEY1_DATA3() uint32 {
	return volatile.LoadUint32(&o.RD_KEY1_DATA3.Reg)
}

// EFUSE.RD_KEY1_DATA4: Register 4 of BLOCK5 (KEY1).
func (o *EFUSE_Type) SetRD_KEY1_DATA4(value uint32) {
	volatile.StoreUint32(&o.RD_KEY1_DATA4.Reg, value)
}
func (o *EFUSE_Type) GetRD_KEY1_DATA4() uint32 {
	return volatile.LoadUint32(&o.RD_KEY1_DATA4.Reg)
}

// EFUSE.RD_KEY1_DATA5: Register 5 of BLOCK5 (KEY1).
func (o *EFUSE_Type) SetRD_KEY1_DATA5(value uint32) {
	volatile.StoreUint32(&o.RD_KEY1_DATA5.Reg, value)
}
func (o *EFUSE_Type) GetRD_KEY1_DATA5() uint32 {
	return volatile.LoadUint32(&o.RD_KEY1_DATA5.Reg)
}

// EFUSE.RD_KEY1_DATA6: Register 6 of BLOCK5 (KEY1).
func (o *EFUSE_Type) SetRD_KEY1_DATA6(value uint32) {
	volatile.StoreUint32(&o.RD_KEY1_DATA6.Reg, value)
}
func (o *EFUSE_Type) GetRD_KEY1_DATA6() uint32 {
	return volatile.LoadUint32(&o.RD_KEY1_DATA6.Reg)
}

// EFUSE.RD_KEY1_DATA7: Register 7 of BLOCK5 (KEY1).
func (o *EFUSE_Type) SetRD_KEY1_DATA7(value uint32) {
	volatile.StoreUint32(&o.RD_KEY1_DATA7.Reg, value)
}
func (o *EFUSE_Type) GetRD_KEY1_DATA7() uint32 {
	return volatile.LoadUint32(&o.RD_KEY1_DATA7.Reg)
}

// EFUSE.RD_KEY2_DATA0: Register 0 of BLOCK6 (KEY2).
func (o *EFUSE_Type) SetRD_KEY2_DATA0(value uint32) {
	volatile.StoreUint32(&o.RD_KEY2_DATA0.Reg, value)
}
func (o *EFUSE_Type) GetRD_KEY2_DATA0() uint32 {
	return volatile.LoadUint32(&o.RD_KEY2_DATA0.Reg)
}

// EFUSE.RD_KEY2_DATA1: Register 1 of BLOCK6 (KEY2).
func (o *EFUSE_Type) SetRD_KEY2_DATA1(value uint32) {
	volatile.StoreUint32(&o.RD_KEY2_DATA1.Reg, value)
}
func (o *EFUSE_Type) GetRD_KEY2_DATA1() uint32 {
	return volatile.LoadUint32(&o.RD_KEY2_DATA1.Reg)
}

// EFUSE.RD_KEY2_DATA2: Register 2 of BLOCK6 (KEY2).
func (o *EFUSE_Type) SetRD_KEY2_DATA2(value uint32) {
	volatile.StoreUint32(&o.RD_KEY2_DATA2.Reg, value)
}
func (o *EFUSE_Type) GetRD_KEY2_DATA2() uint32 {
	return volatile.LoadUint32(&o.RD_KEY2_DATA2.Reg)
}

// EFUSE.RD_KEY2_DATA3: Register 3 of BLOCK6 (KEY2).
func (o *EFUSE_Type) SetRD_KEY2_DATA3(value uint32) {
	volatile.StoreUint32(&o.RD_KEY2_DATA3.Reg, value)
}
func (o *EFUSE_Type) GetRD_KEY2_DATA3() uint32 {
	return volatile.LoadUint32(&o.RD_KEY2_DATA3.Reg)
}

// EFUSE.RD_KEY2_DATA4: Register 4 of BLOCK6 (KEY2).
func (o *EFUSE_Type) SetRD_KEY2_DATA4(value uint32) {
	volatile.StoreUint32(&o.RD_KEY2_DATA4.Reg, value)
}
func (o *EFUSE_Type) GetRD_KEY2_DATA4() uint32 {
	return volatile.LoadUint32(&o.RD_KEY2_DATA4.Reg)
}

// EFUSE.RD_KEY2_DATA5: Register 5 of BLOCK6 (KEY2).
func (o *EFUSE_Type) SetRD_KEY2_DATA5(value uint32) {
	volatile.StoreUint32(&o.RD_KEY2_DATA5.Reg, value)
}
func (o *EFUSE_Type) GetRD_KEY2_DATA5() uint32 {
	return volatile.LoadUint32(&o.RD_KEY2_DATA5.Reg)
}

// EFUSE.RD_KEY2_DATA6: Register 6 of BLOCK6 (KEY2).
func (o *EFUSE_Type) SetRD_KEY2_DATA6(value uint32) {
	volatile.StoreUint32(&o.RD_KEY2_DATA6.Reg, value)
}
func (o *EFUSE_Type) GetRD_KEY2_DATA6() uint32 {
	return volatile.LoadUint32(&o.RD_KEY2_DATA6.Reg)
}

// EFUSE.RD_KEY2_DATA7: Register 7 of BLOCK6 (KEY2).
func (o *EFUSE_Type) SetRD_KEY2_DATA7(value uint32) {
	volatile.StoreUint32(&o.RD_KEY2_DATA7.Reg, value)
}
func (o *EFUSE_Type) GetRD_KEY2_DATA7() uint32 {
	return volatile.LoadUint32(&o.RD_KEY2_DATA7.Reg)
}

// EFUSE.RD_KEY3_DATA0: Register 0 of BLOCK7 (KEY3).
func (o *EFUSE_Type) SetRD_KEY3_DATA0(value uint32) {
	volatile.StoreUint32(&o.RD_KEY3_DATA0.Reg, value)
}
func (o *EFUSE_Type) GetRD_KEY3_DATA0() uint32 {
	return volatile.LoadUint32(&o.RD_KEY3_DATA0.Reg)
}

// EFUSE.RD_KEY3_DATA1: Register 1 of BLOCK7 (KEY3).
func (o *EFUSE_Type) SetRD_KEY3_DATA1(value uint32) {
	volatile.StoreUint32(&o.RD_KEY3_DATA1.Reg, value)
}
func (o *EFUSE_Type) GetRD_KEY3_DATA1() uint32 {
	return volatile.LoadUint32(&o.RD_KEY3_DATA1.Reg)
}

// EFUSE.RD_KEY3_DATA2: Register 2 of BLOCK7 (KEY3).
func (o *EFUSE_Type) SetRD_KEY3_DATA2(value uint32) {
	volatile.StoreUint32(&o.RD_KEY3_DATA2.Reg, value)
}
func (o *EFUSE_Type) GetRD_KEY3_DATA2() uint32 {
	return volatile.LoadUint32(&o.RD_KEY3_DATA2.Reg)
}

// EFUSE.RD_KEY3_DATA3: Register 3 of BLOCK7 (KEY3).
func (o *EFUSE_Type) SetRD_KEY3_DATA3(value uint32) {
	volatile.StoreUint32(&o.RD_KEY3_DATA3.Reg, value)
}
func (o *EFUSE_Type) GetRD_KEY3_DATA3() uint32 {
	return volatile.LoadUint32(&o.RD_KEY3_DATA3.Reg)
}

// EFUSE.RD_KEY3_DATA4: Register 4 of BLOCK7 (KEY3).
func (o *EFUSE_Type) SetRD_KEY3_DATA4(value uint32) {
	volatile.StoreUint32(&o.RD_KEY3_DATA4.Reg, value)
}
func (o *EFUSE_Type) GetRD_KEY3_DATA4() uint32 {
	return volatile.LoadUint32(&o.RD_KEY3_DATA4.Reg)
}

// EFUSE.RD_KEY3_DATA5: Register 5 of BLOCK7 (KEY3).
func (o *EFUSE_Type) SetRD_KEY3_DATA5(value uint32) {
	volatile.StoreUint32(&o.RD_KEY3_DATA5.Reg, value)
}
func (o *EFUSE_Type) GetRD_KEY3_DATA5() uint32 {
	return volatile.LoadUint32(&o.RD_KEY3_DATA5.Reg)
}

// EFUSE.RD_KEY3_DATA6: Register 6 of BLOCK7 (KEY3).
func (o *EFUSE_Type) SetRD_KEY3_DATA6(value uint32) {
	volatile.StoreUint32(&o.RD_KEY3_DATA6.Reg, value)
}
func (o *EFUSE_Type) GetRD_KEY3_DATA6() uint32 {
	return volatile.LoadUint32(&o.RD_KEY3_DATA6.Reg)
}

// EFUSE.RD_KEY3_DATA7: Register 7 of BLOCK7 (KEY3).
func (o *EFUSE_Type) SetRD_KEY3_DATA7(value uint32) {
	volatile.StoreUint32(&o.RD_KEY3_DATA7.Reg, value)
}
func (o *EFUSE_Type) GetRD_KEY3_DATA7() uint32 {
	return volatile.LoadUint32(&o.RD_KEY3_DATA7.Reg)
}

// EFUSE.RD_KEY4_DATA0: Register 0 of BLOCK8 (KEY4).
func (o *EFUSE_Type) SetRD_KEY4_DATA0(value uint32) {
	volatile.StoreUint32(&o.RD_KEY4_DATA0.Reg, value)
}
func (o *EFUSE_Type) GetRD_KEY4_DATA0() uint32 {
	return volatile.LoadUint32(&o.RD_KEY4_DATA0.Reg)
}

// EFUSE.RD_KEY4_DATA1: Register 1 of BLOCK8 (KEY4).
func (o *EFUSE_Type) SetRD_KEY4_DATA1(value uint32) {
	volatile.StoreUint32(&o.RD_KEY4_DATA1.Reg, value)
}
func (o *EFUSE_Type) GetRD_KEY4_DATA1() uint32 {
	return volatile.LoadUint32(&o.RD_KEY4_DATA1.Reg)
}

// EFUSE.RD_KEY4_DATA2: Register 2 of BLOCK8 (KEY4).
func (o *EFUSE_Type) SetRD_KEY4_DATA2(value uint32) {
	volatile.StoreUint32(&o.RD_KEY4_DATA2.Reg, value)
}
func (o *EFUSE_Type) GetRD_KEY4_DATA2() uint32 {
	return volatile.LoadUint32(&o.RD_KEY4_DATA2.Reg)
}

// EFUSE.RD_KEY4_DATA3: Register 3 of BLOCK8 (KEY4).
func (o *EFUSE_Type) SetRD_KEY4_DATA3(value uint32) {
	volatile.StoreUint32(&o.RD_KEY4_DATA3.Reg, value)
}
func (o *EFUSE_Type) GetRD_KEY4_DATA3() uint32 {
	return volatile.LoadUint32(&o.RD_KEY4_DATA3.Reg)
}

// EFUSE.RD_KEY4_DATA4: Register 4 of BLOCK8 (KEY4).
func (o *EFUSE_Type) SetRD_KEY4_DATA4(value uint32) {
	volatile.StoreUint32(&o.RD_KEY4_DATA4.Reg, value)
}
func (o *EFUSE_Type) GetRD_KEY4_DATA4() uint32 {
	return volatile.LoadUint32(&o.RD_KEY4_DATA4.Reg)
}

// EFUSE.RD_KEY4_DATA5: Register 5 of BLOCK8 (KEY4).
func (o *EFUSE_Type) SetRD_KEY4_DATA5(value uint32) {
	volatile.StoreUint32(&o.RD_KEY4_DATA5.Reg, value)
}
func (o *EFUSE_Type) GetRD_KEY4_DATA5() uint32 {
	return volatile.LoadUint32(&o.RD_KEY4_DATA5.Reg)
}

// EFUSE.RD_KEY4_DATA6: Register 6 of BLOCK8 (KEY4).
func (o *EFUSE_Type) SetRD_KEY4_DATA6(value uint32) {
	volatile.StoreUint32(&o.RD_KEY4_DATA6.Reg, value)
}
func (o *EFUSE_Type) GetRD_KEY4_DATA6() uint32 {
	return volatile.LoadUint32(&o.RD_KEY4_DATA6.Reg)
}

// EFUSE.RD_KEY4_DATA7: Register 7 of BLOCK8 (KEY4).
func (o *EFUSE_Type) SetRD_KEY4_DATA7(value uint32) {
	volatile.StoreUint32(&o.RD_KEY4_DATA7.Reg, value)
}
func (o *EFUSE_Type) GetRD_KEY4_DATA7() uint32 {
	return volatile.LoadUint32(&o.RD_KEY4_DATA7.Reg)
}

// EFUSE.RD_KEY5_DATA0: Register 0 of BLOCK9 (KEY5).
func (o *EFUSE_Type) SetRD_KEY5_DATA0(value uint32) {
	volatile.StoreUint32(&o.RD_KEY5_DATA0.Reg, value)
}
func (o *EFUSE_Type) GetRD_KEY5_DATA0() uint32 {
	return volatile.LoadUint32(&o.RD_KEY5_DATA0.Reg)
}

// EFUSE.RD_KEY5_DATA1: Register 1 of BLOCK9 (KEY5).
func (o *EFUSE_Type) SetRD_KEY5_DATA1(value uint32) {
	volatile.StoreUint32(&o.RD_KEY5_DATA1.Reg, value)
}
func (o *EFUSE_Type) GetRD_KEY5_DATA1() uint32 {
	return volatile.LoadUint32(&o.RD_KEY5_DATA1.Reg)
}

// EFUSE.RD_KEY5_DATA2: Register 2 of BLOCK9 (KEY5).
func (o *EFUSE_Type) SetRD_KEY5_DATA2(value uint32) {
	volatile.StoreUint32(&o.RD_KEY5_DATA2.Reg, value)
}
func (o *EFUSE_Type) GetRD_KEY5_DATA2() uint32 {
	return volatile.LoadUint32(&o.RD_KEY5_DATA2.Reg)
}

// EFUSE.RD_KEY5_DATA3: Register 3 of BLOCK9 (KEY5).
func (o *EFUSE_Type) SetRD_KEY5_DATA3(value uint32) {
	volatile.StoreUint32(&o.RD_KEY5_DATA3.Reg, value)
}
func (o *EFUSE_Type) GetRD_KEY5_DATA3() uint32 {
	return volatile.LoadUint32(&o.RD_KEY5_DATA3.Reg)
}

// EFUSE.RD_KEY5_DATA4: Register 4 of BLOCK9 (KEY5).
func (o *EFUSE_Type) SetRD_KEY5_DATA4(value uint32) {
	volatile.StoreUint32(&o.RD_KEY5_DATA4.Reg, value)
}
func (o *EFUSE_Type) GetRD_KEY5_DATA4() uint32 {
	return volatile.LoadUint32(&o.RD_KEY5_DATA4.Reg)
}

// EFUSE.RD_KEY5_DATA5: Register 5 of BLOCK9 (KEY5).
func (o *EFUSE_Type) SetRD_KEY5_DATA5(value uint32) {
	volatile.StoreUint32(&o.RD_KEY5_DATA5.Reg, value)
}
func (o *EFUSE_Type) GetRD_KEY5_DATA5() uint32 {
	return volatile.LoadUint32(&o.RD_KEY5_DATA5.Reg)
}

// EFUSE.RD_KEY5_DATA6: Register 6 of BLOCK9 (KEY5).
func (o *EFUSE_Type) SetRD_KEY5_DATA6(value uint32) {
	volatile.StoreUint32(&o.RD_KEY5_DATA6.Reg, value)
}
func (o *EFUSE_Type) GetRD_KEY5_DATA6() uint32 {
	return volatile.LoadUint32(&o.RD_KEY5_DATA6.Reg)
}

// EFUSE.RD_KEY5_DATA7: Register 7 of BLOCK9 (KEY5).
func (o *EFUSE_Type) SetRD_KEY5_DATA7(value uint32) {
	volatile.StoreUint32(&o.RD_KEY5_DATA7.Reg, value)
}
func (o *EFUSE_Type) GetRD_KEY5_DATA7() uint32 {
	return volatile.LoadUint32(&o.RD_KEY5_DATA7.Reg)
}

// EFUSE.RD_SYS_PART2_DATA0: Register 0 of BLOCK10 (system).
func (o *EFUSE_Type) SetRD_SYS_PART2_DATA0(value uint32) {
	volatile.StoreUint32(&o.RD_SYS_PART2_DATA0.Reg, value)
}
func (o *EFUSE_Type) GetRD_SYS_PART2_DATA0() uint32 {
	return volatile.LoadUint32(&o.RD_SYS_PART2_DATA0.Reg)
}

// EFUSE.RD_SYS_PART2_DATA1: Register 1 of BLOCK9 (KEY5).
func (o *EFUSE_Type) SetRD_SYS_PART2_DATA1(value uint32) {
	volatile.StoreUint32(&o.RD_SYS_PART2_DATA1.Reg, value)
}
func (o *EFUSE_Type) GetRD_SYS_PART2_DATA1() uint32 {
	return volatile.LoadUint32(&o.RD_SYS_PART2_DATA1.Reg)
}

// EFUSE.RD_SYS_PART2_DATA2: Register 2 of BLOCK10 (system).
func (o *EFUSE_Type) SetRD_SYS_PART2_DATA2(value uint32) {
	volatile.StoreUint32(&o.RD_SYS_PART2_DATA2.Reg, value)
}
func (o *EFUSE_Type) GetRD_SYS_PART2_DATA2() uint32 {
	return volatile.LoadUint32(&o.RD_SYS_PART2_DATA2.Reg)
}

// EFUSE.RD_SYS_PART2_DATA3: Register 3 of BLOCK10 (system).
func (o *EFUSE_Type) SetRD_SYS_PART2_DATA3(value uint32) {
	volatile.StoreUint32(&o.RD_SYS_PART2_DATA3.Reg, value)
}
func (o *EFUSE_Type) GetRD_SYS_PART2_DATA3() uint32 {
	return volatile.LoadUint32(&o.RD_SYS_PART2_DATA3.Reg)
}

// EFUSE.RD_SYS_PART2_DATA4: Register 4 of BLOCK10 (system).
func (o *EFUSE_Type) SetRD_SYS_PART2_DATA4(value uint32) {
	volatile.StoreUint32(&o.RD_SYS_PART2_DATA4.Reg, value)
}
func (o *EFUSE_Type) GetRD_SYS_PART2_DATA4() uint32 {
	return volatile.LoadUint32(&o.RD_SYS_PART2_DATA4.Reg)
}

// EFUSE.RD_SYS_PART2_DATA5: Register 5 of BLOCK10 (system).
func (o *EFUSE_Type) SetRD_SYS_PART2_DATA5(value uint32) {
	volatile.StoreUint32(&o.RD_SYS_PART2_DATA5.Reg, value)
}
func (o *EFUSE_Type) GetRD_SYS_PART2_DATA5() uint32 {
	return volatile.LoadUint32(&o.RD_SYS_PART2_DATA5.Reg)
}

// EFUSE.RD_SYS_PART2_DATA6: Register 6 of BLOCK10 (system).
func (o *EFUSE_Type) SetRD_SYS_PART2_DATA6(value uint32) {
	volatile.StoreUint32(&o.RD_SYS_PART2_DATA6.Reg, value)
}
func (o *EFUSE_Type) GetRD_SYS_PART2_DATA6() uint32 {
	return volatile.LoadUint32(&o.RD_SYS_PART2_DATA6.Reg)
}

// EFUSE.RD_SYS_PART2_DATA7: Register 7 of BLOCK10 (system).
func (o *EFUSE_Type) SetRD_SYS_PART2_DATA7(value uint32) {
	volatile.StoreUint32(&o.RD_SYS_PART2_DATA7.Reg, value)
}
func (o *EFUSE_Type) GetRD_SYS_PART2_DATA7() uint32 {
	return volatile.LoadUint32(&o.RD_SYS_PART2_DATA7.Reg)
}

// EFUSE.RD_REPEAT_ERR0: Programming error record register 0 of BLOCK0.
func (o *EFUSE_Type) SetRD_REPEAT_ERR0_RD_DIS_ERR(value uint32) {
	volatile.StoreUint32(&o.RD_REPEAT_ERR0.Reg, volatile.LoadUint32(&o.RD_REPEAT_ERR0.Reg)&^(0x7f)|value)
}
func (o *EFUSE_Type) GetRD_REPEAT_ERR0_RD_DIS_ERR() uint32 {
	return volatile.LoadUint32(&o.RD_REPEAT_ERR0.Reg) & 0x7f
}
func (o *EFUSE_Type) SetRD_REPEAT_ERR0_DIS_RTC_RAM_BOOT_ERR(value uint32) {
	volatile.StoreUint32(&o.RD_REPEAT_ERR0.Reg, volatile.LoadUint32(&o.RD_REPEAT_ERR0.Reg)&^(0x80)|value<<7)
}
func (o *EFUSE_Type) GetRD_REPEAT_ERR0_DIS_RTC_RAM_BOOT_ERR() uint32 {
	return (volatile.LoadUint32(&o.RD_REPEAT_ERR0.Reg) & 0x80) >> 7
}
func (o *EFUSE_Type) SetRD_REPEAT_ERR0_DIS_ICACHE_ERR(value uint32) {
	volatile.StoreUint32(&o.RD_REPEAT_ERR0.Reg, volatile.LoadUint32(&o.RD_REPEAT_ERR0.Reg)&^(0x100)|value<<8)
}
func (o *EFUSE_Type) GetRD_REPEAT_ERR0_DIS_ICACHE_ERR() uint32 {
	return (volatile.LoadUint32(&o.RD_REPEAT_ERR0.Reg) & 0x100) >> 8
}
func (o *EFUSE_Type) SetRD_REPEAT_ERR0_DIS_USB_JTAG_ERR(value uint32) {
	volatile.StoreUint32(&o.RD_REPEAT_ERR0.Reg, volatile.LoadUint32(&o.RD_REPEAT_ERR0.Reg)&^(0x200)|value<<9)
}
func (o *EFUSE_Type) GetRD_REPEAT_ERR0_DIS_USB_JTAG_ERR() uint32 {
	return (volatile.LoadUint32(&o.RD_REPEAT_ERR0.Reg) & 0x200) >> 9
}
func (o *EFUSE_Type) SetRD_REPEAT_ERR0_DIS_DOWNLOAD_ICACHE_ERR(value uint32) {
	volatile.StoreUint32(&o.RD_REPEAT_ERR0.Reg, volatile.LoadUint32(&o.RD_REPEAT_ERR0.Reg)&^(0x400)|value<<10)
}
func (o *EFUSE_Type) GetRD_REPEAT_ERR0_DIS_DOWNLOAD_ICACHE_ERR() uint32 {
	return (volatile.LoadUint32(&o.RD_REPEAT_ERR0.Reg) & 0x400) >> 10
}
func (o *EFUSE_Type) SetRD_REPEAT_ERR0_DIS_USB_DEVICE_ERR(value uint32) {
	volatile.StoreUint32(&o.RD_REPEAT_ERR0.Reg, volatile.LoadUint32(&o.RD_REPEAT_ERR0.Reg)&^(0x800)|value<<11)
}
func (o *EFUSE_Type) GetRD_REPEAT_ERR0_DIS_USB_DEVICE_ERR() uint32 {
	return (volatile.LoadUint32(&o.RD_REPEAT_ERR0.Reg) & 0x800) >> 11
}
func (o *EFUSE_Type) SetRD_REPEAT_ERR0_DIS_FORCE_DOWNLOAD_ERR(value uint32) {
	volatile.StoreUint32(&o.RD_REPEAT_ERR0.Reg, volatile.LoadUint32(&o.RD_REPEAT_ERR0.Reg)&^(0x1000)|value<<12)
}
func (o *EFUSE_Type) GetRD_REPEAT_ERR0_DIS_FORCE_DOWNLOAD_ERR() uint32 {
	return (volatile.LoadUint32(&o.RD_REPEAT_ERR0.Reg) & 0x1000) >> 12
}
func (o *EFUSE_Type) SetRD_REPEAT_ERR0_RPT4_RESERVED6_ERR(value uint32) {
	volatile.StoreUint32(&o.RD_REPEAT_ERR0.Reg, volatile.LoadUint32(&o.RD_REPEAT_ERR0.Reg)&^(0x2000)|value<<13)
}
func (o *EFUSE_Type) GetRD_REPEAT_ERR0_RPT4_RESERVED6_ERR() uint32 {
	return (volatile.LoadUint32(&o.RD_REPEAT_ERR0.Reg) & 0x2000) >> 13
}
func (o *EFUSE_Type) SetRD_REPEAT_ERR0_DIS_CAN_ERR(value uint32) {
	volatile.StoreUint32(&o.RD_REPEAT_ERR0.Reg, volatile.LoadUint32(&o.RD_REPEAT_ERR0.Reg)&^(0x4000)|value<<14)
}
func (o *EFUSE_Type) GetRD_REPEAT_ERR0_DIS_CAN_ERR() uint32 {
	return (volatile.LoadUint32(&o.RD_REPEAT_ERR0.Reg) & 0x4000) >> 14
}
func (o *EFUSE_Type) SetRD_REPEAT_ERR0_JTAG_SEL_ENABLE_ERR(value uint32) {
	volatile.StoreUint32(&o.RD_REPEAT_ERR0.Reg, volatile.LoadUint32(&o.RD_REPEAT_ERR0.Reg)&^(0x8000)|value<<15)
}
func (o *EFUSE_Type) GetRD_REPEAT_ERR0_JTAG_SEL_ENABLE_ERR() uint32 {
	return (volatile.LoadUint32(&o.RD_REPEAT_ERR0.Reg) & 0x8000) >> 15
}
func (o *EFUSE_Type) SetRD_REPEAT_ERR0_SOFT_DIS_JTAG_ERR(value uint32) {
	volatile.StoreUint32(&o.RD_REPEAT_ERR0.Reg, volatile.LoadUint32(&o.RD_REPEAT_ERR0.Reg)&^(0x70000)|value<<16)
}
func (o *EFUSE_Type) GetRD_REPEAT_ERR0_SOFT_DIS_JTAG_ERR() uint32 {
	return (volatile.LoadUint32(&o.RD_REPEAT_ERR0.Reg) & 0x70000) >> 16
}
func (o *EFUSE_Type) SetRD_REPEAT_ERR0_DIS_PAD_JTAG_ERR(value uint32) {
	volatile.StoreUint32(&o.RD_REPEAT_ERR0.Reg, volatile.LoadUint32(&o.RD_REPEAT_ERR0.Reg)&^(0x80000)|value<<19)
}
func (o *EFUSE_Type) GetRD_REPEAT_ERR0_DIS_PAD_JTAG_ERR() uint32 {
	return (volatile.LoadUint32(&o.RD_REPEAT_ERR0.Reg) & 0x80000) >> 19
}
func (o *EFUSE_Type) SetRD_REPEAT_ERR0_DIS_DOWNLOAD_MANUAL_ENCRYPT_ERR(value uint32) {
	volatile.StoreUint32(&o.RD_REPEAT_ERR0.Reg, volatile.LoadUint32(&o.RD_REPEAT_ERR0.Reg)&^(0x100000)|value<<20)
}
func (o *EFUSE_Type) GetRD_REPEAT_ERR0_DIS_DOWNLOAD_MANUAL_ENCRYPT_ERR() uint32 {
	return (volatile.LoadUint32(&o.RD_REPEAT_ERR0.Reg) & 0x100000) >> 20
}
func (o *EFUSE_Type) SetRD_REPEAT_ERR0_USB_DREFH_ERR(value uint32) {
	volatile.StoreUint32(&o.RD_REPEAT_ERR0.Reg, volatile.LoadUint32(&o.RD_REPEAT_ERR0.Reg)&^(0x600000)|value<<21)
}
func (o *EFUSE_Type) GetRD_REPEAT_ERR0_USB_DREFH_ERR() uint32 {
	return (volatile.LoadUint32(&o.RD_REPEAT_ERR0.Reg) & 0x600000) >> 21
}
func (o *EFUSE_Type) SetRD_REPEAT_ERR0_USB_DREFL_ERR(value uint32) {
	volatile.StoreUint32(&o.RD_REPEAT_ERR0.Reg, volatile.LoadUint32(&o.RD_REPEAT_ERR0.Reg)&^(0x1800000)|value<<23)
}
func (o *EFUSE_Type) GetRD_REPEAT_ERR0_USB_DREFL_ERR() uint32 {
	return (volatile.LoadUint32(&o.RD_REPEAT_ERR0.Reg) & 0x1800000) >> 23
}
func (o *EFUSE_Type) SetRD_REPEAT_ERR0_USB_EXCHG_PINS_ERR(value uint32) {
	volatile.StoreUint32(&o.RD_REPEAT_ERR0.Reg, volatile.LoadUint32(&o.RD_REPEAT_ERR0.Reg)&^(0x2000000)|value<<25)
}
func (o *EFUSE_Type) GetRD_REPEAT_ERR0_USB_EXCHG_PINS_ERR() uint32 {
	return (volatile.LoadUint32(&o.RD_REPEAT_ERR0.Reg) & 0x2000000) >> 25
}
func (o *EFUSE_Type) SetRD_REPEAT_ERR0_VDD_SPI_AS_GPIO_ERR(value uint32) {
	volatile.StoreUint32(&o.RD_REPEAT_ERR0.Reg, volatile.LoadUint32(&o.RD_REPEAT_ERR0.Reg)&^(0x4000000)|value<<26)
}
func (o *EFUSE_Type) GetRD_REPEAT_ERR0_VDD_SPI_AS_GPIO_ERR() uint32 {
	return (volatile.LoadUint32(&o.RD_REPEAT_ERR0.Reg) & 0x4000000) >> 26
}
func (o *EFUSE_Type) SetRD_REPEAT_ERR0_BTLC_GPIO_ENABLE_ERR(value uint32) {
	volatile.StoreUint32(&o.RD_REPEAT_ERR0.Reg, volatile.LoadUint32(&o.RD_REPEAT_ERR0.Reg)&^(0x18000000)|value<<27)
}
func (o *EFUSE_Type) GetRD_REPEAT_ERR0_BTLC_GPIO_ENABLE_ERR() uint32 {
	return (volatile.LoadUint32(&o.RD_REPEAT_ERR0.Reg) & 0x18000000) >> 27
}
func (o *EFUSE_Type) SetRD_REPEAT_ERR0_POWERGLITCH_EN_ERR(value uint32) {
	volatile.StoreUint32(&o.RD_REPEAT_ERR0.Reg, volatile.LoadUint32(&o.RD_REPEAT_ERR0.Reg)&^(0x20000000)|value<<29)
}
func (o *EFUSE_Type) GetRD_REPEAT_ERR0_POWERGLITCH_EN_ERR() uint32 {
	return (volatile.LoadUint32(&o.RD_REPEAT_ERR0.Reg) & 0x20000000) >> 29
}
func (o *EFUSE_Type) SetRD_REPEAT_ERR0_POWER_GLITCH_DSENSE_ERR(value uint32) {
	volatile.StoreUint32(&o.RD_REPEAT_ERR0.Reg, volatile.LoadUint32(&o.RD_REPEAT_ERR0.Reg)&^(0xc0000000)|value<<30)
}
func (o *EFUSE_Type) GetRD_REPEAT_ERR0_POWER_GLITCH_DSENSE_ERR() uint32 {
	return (volatile.LoadUint32(&o.RD_REPEAT_ERR0.Reg) & 0xc0000000) >> 30
}

// EFUSE.RD_REPEAT_ERR1: Programming error record register 1 of BLOCK0.
func (o *EFUSE_Type) SetRD_REPEAT_ERR1_RPT4_RESERVED2_ERR(value uint32) {
	volatile.StoreUint32(&o.RD_REPEAT_ERR1.Reg, volatile.LoadUint32(&o.RD_REPEAT_ERR1.Reg)&^(0xffff)|value)
}
func (o *EFUSE_Type) GetRD_REPEAT_ERR1_RPT4_RESERVED2_ERR() uint32 {
	return volatile.LoadUint32(&o.RD_REPEAT_ERR1.Reg) & 0xffff
}
func (o *EFUSE_Type) SetRD_REPEAT_ERR1_WDT_DELAY_SEL_ERR(value uint32) {
	volatile.StoreUint32(&o.RD_REPEAT_ERR1.Reg, volatile.LoadUint32(&o.RD_REPEAT_ERR1.Reg)&^(0x30000)|value<<16)
}
func (o *EFUSE_Type) GetRD_REPEAT_ERR1_WDT_DELAY_SEL_ERR() uint32 {
	return (volatile.LoadUint32(&o.RD_REPEAT_ERR1.Reg) & 0x30000) >> 16
}
func (o *EFUSE_Type) SetRD_REPEAT_ERR1_SPI_BOOT_CRYPT_CNT_ERR(value uint32) {
	volatile.StoreUint32(&o.RD_REPEAT_ERR1.Reg, volatile.LoadUint32(&o.RD_REPEAT_ERR1.Reg)&^(0x1c0000)|value<<18)
}
func (o *EFUSE_Type) GetRD_REPEAT_ERR1_SPI_BOOT_CRYPT_CNT_ERR() uint32 {
	return (volatile.LoadUint32(&o.RD_REPEAT_ERR1.Reg) & 0x1c0000) >> 18
}
func (o *EFUSE_Type) SetRD_REPEAT_ERR1_SECURE_BOOT_KEY_REVOKE0_ERR(value uint32) {
	volatile.StoreUint32(&o.RD_REPEAT_ERR1.Reg, volatile.LoadUint32(&o.RD_REPEAT_ERR1.Reg)&^(0x200000)|value<<21)
}
func (o *EFUSE_Type) GetRD_REPEAT_ERR1_SECURE_BOOT_KEY_REVOKE0_ERR() uint32 {
	return (volatile.LoadUint32(&o.RD_REPEAT_ERR1.Reg) & 0x200000) >> 21
}
func (o *EFUSE_Type) SetRD_REPEAT_ERR1_SECURE_BOOT_KEY_REVOKE1_ERR(value uint32) {
	volatile.StoreUint32(&o.RD_REPEAT_ERR1.Reg, volatile.LoadUint32(&o.RD_REPEAT_ERR1.Reg)&^(0x400000)|value<<22)
}
func (o *EFUSE_Type) GetRD_REPEAT_ERR1_SECURE_BOOT_KEY_REVOKE1_ERR() uint32 {
	return (volatile.LoadUint32(&o.RD_REPEAT_ERR1.Reg) & 0x400000) >> 22
}
func (o *EFUSE_Type) SetRD_REPEAT_ERR1_SECURE_BOOT_KEY_REVOKE2_ERR(value uint32) {
	volatile.StoreUint32(&o.RD_REPEAT_ERR1.Reg, volatile.LoadUint32(&o.RD_REPEAT_ERR1.Reg)&^(0x800000)|value<<23)
}
func (o *EFUSE_Type) GetRD_REPEAT_ERR1_SECURE_BOOT_KEY_REVOKE2_ERR() uint32 {
	return (volatile.LoadUint32(&o.RD_REPEAT_ERR1.Reg) & 0x800000) >> 23
}
func (o *EFUSE_Type) SetRD_REPEAT_ERR1_KEY_PURPOSE_0_ERR(value uint32) {
	volatile.StoreUint32(&o.RD_REPEAT_ERR1.Reg, volatile.LoadUint32(&o.RD_REPEAT_ERR1.Reg)&^(0xf000000)|value<<24)
}
func (o *EFUSE_Type) GetRD_REPEAT_ERR1_KEY_PURPOSE_0_ERR() uint32 {
	return (volatile.LoadUint32(&o.RD_REPEAT_ERR1.Reg) & 0xf000000) >> 24
}
func (o *EFUSE_Type) SetRD_REPEAT_ERR1_KEY_PURPOSE_1_ERR(value uint32) {
	volatile.StoreUint32(&o.RD_REPEAT_ERR1.Reg, volatile.LoadUint32(&o.RD_REPEAT_ERR1.Reg)&^(0xf0000000)|value<<28)
}
func (o *EFUSE_Type) GetRD_REPEAT_ERR1_KEY_PURPOSE_1_ERR() uint32 {
	return (volatile.LoadUint32(&o.RD_REPEAT_ERR1.Reg) & 0xf0000000) >> 28
}

// EFUSE.RD_REPEAT_ERR2: Programming error record register 2 of BLOCK0.
func (o *EFUSE_Type) SetRD_REPEAT_ERR2_KEY_PURPOSE_2_ERR(value uint32) {
	volatile.StoreUint32(&o.RD_REPEAT_ERR2.Reg, volatile.LoadUint32(&o.RD_REPEAT_ERR2.Reg)&^(0xf)|value)
}
func (o *EFUSE_Type) GetRD_REPEAT_ERR2_KEY_PURPOSE_2_ERR() uint32 {
	return volatile.LoadUint32(&o.RD_REPEAT_ERR2.Reg) & 0xf
}
func (o *EFUSE_Type) SetRD_REPEAT_ERR2_KEY_PURPOSE_3_ERR(value uint32) {
	volatile.StoreUint32(&o.RD_REPEAT_ERR2.Reg, volatile.LoadUint32(&o.RD_REPEAT_ERR2.Reg)&^(0xf0)|value<<4)
}
func (o *EFUSE_Type) GetRD_REPEAT_ERR2_KEY_PURPOSE_3_ERR() uint32 {
	return (volatile.LoadUint32(&o.RD_REPEAT_ERR2.Reg) & 0xf0) >> 4
}
func (o *EFUSE_Type) SetRD_REPEAT_ERR2_KEY_PURPOSE_4_ERR(value uint32) {
	volatile.StoreUint32(&o.RD_REPEAT_ERR2.Reg, volatile.LoadUint32(&o.RD_REPEAT_ERR2.Reg)&^(0xf00)|value<<8)
}
func (o *EFUSE_Type) GetRD_REPEAT_ERR2_KEY_PURPOSE_4_ERR() uint32 {
	return (volatile.LoadUint32(&o.RD_REPEAT_ERR2.Reg) & 0xf00) >> 8
}
func (o *EFUSE_Type) SetRD_REPEAT_ERR2_KEY_PURPOSE_5_ERR(value uint32) {
	volatile.StoreUint32(&o.RD_REPEAT_ERR2.Reg, volatile.LoadUint32(&o.RD_REPEAT_ERR2.Reg)&^(0xf000)|value<<12)
}
func (o *EFUSE_Type) GetRD_REPEAT_ERR2_KEY_PURPOSE_5_ERR() uint32 {
	return (volatile.LoadUint32(&o.RD_REPEAT_ERR2.Reg) & 0xf000) >> 12
}
func (o *EFUSE_Type) SetRD_REPEAT_ERR2_RPT4_RESERVED3_ERR(value uint32) {
	volatile.StoreUint32(&o.RD_REPEAT_ERR2.Reg, volatile.LoadUint32(&o.RD_REPEAT_ERR2.Reg)&^(0xf0000)|value<<16)
}
func (o *EFUSE_Type) GetRD_REPEAT_ERR2_RPT4_RESERVED3_ERR() uint32 {
	return (volatile.LoadUint32(&o.RD_REPEAT_ERR2.Reg) & 0xf0000) >> 16
}
func (o *EFUSE_Type) SetRD_REPEAT_ERR2_SECURE_BOOT_EN_ERR(value uint32) {
	volatile.StoreUint32(&o.RD_REPEAT_ERR2.Reg, volatile.LoadUint32(&o.RD_REPEAT_ERR2.Reg)&^(0x100000)|value<<20)
}
func (o *EFUSE_Type) GetRD_REPEAT_ERR2_SECURE_BOOT_EN_ERR() uint32 {
	return (volatile.LoadUint32(&o.RD_REPEAT_ERR2.Reg) & 0x100000) >> 20
}
func (o *EFUSE_Type) SetRD_REPEAT_ERR2_SECURE_BOOT_AGGRESSIVE_REVOKE_ERR(value uint32) {
	volatile.StoreUint32(&o.RD_REPEAT_ERR2.Reg, volatile.LoadUint32(&o.RD_REPEAT_ERR2.Reg)&^(0x200000)|value<<21)
}
func (o *EFUSE_Type) GetRD_REPEAT_ERR2_SECURE_BOOT_AGGRESSIVE_REVOKE_ERR() uint32 {
	return (volatile.LoadUint32(&o.RD_REPEAT_ERR2.Reg) & 0x200000) >> 21
}
func (o *EFUSE_Type) SetRD_REPEAT_ERR2_RPT4_RESERVED0_ERR(value uint32) {
	volatile.StoreUint32(&o.RD_REPEAT_ERR2.Reg, volatile.LoadUint32(&o.RD_REPEAT_ERR2.Reg)&^(0xfc00000)|value<<22)
}
func (o *EFUSE_Type) GetRD_REPEAT_ERR2_RPT4_RESERVED0_ERR() uint32 {
	return (volatile.LoadUint32(&o.RD_REPEAT_ERR2.Reg) & 0xfc00000) >> 22
}
func (o *EFUSE_Type) SetRD_REPEAT_ERR2_FLASH_TPUW_ERR(value uint32) {
	volatile.StoreUint32(&o.RD_REPEAT_ERR2.Reg, volatile.LoadUint32(&o.RD_REPEAT_ERR2.Reg)&^(0xf0000000)|value<<28)
}
func (o *EFUSE_Type) GetRD_REPEAT_ERR2_FLASH_TPUW_ERR() uint32 {
	return (volatile.LoadUint32(&o.RD_REPEAT_ERR2.Reg) & 0xf0000000) >> 28
}

// EFUSE.RD_REPEAT_ERR3: Programming error record register 3 of BLOCK0.
func (o *EFUSE_Type) SetRD_REPEAT_ERR3_DIS_DOWNLOAD_MODE_ERR(value uint32) {
	volatile.StoreUint32(&o.RD_REPEAT_ERR3.Reg, volatile.LoadUint32(&o.RD_REPEAT_ERR3.Reg)&^(0x1)|value)
}
func (o *EFUSE_Type) GetRD_REPEAT_ERR3_DIS_DOWNLOAD_MODE_ERR() uint32 {
	return volatile.LoadUint32(&o.RD_REPEAT_ERR3.Reg) & 0x1
}
func (o *EFUSE_Type) SetRD_REPEAT_ERR3_DIS_LEGACY_SPI_BOOT_ERR(value uint32) {
	volatile.StoreUint32(&o.RD_REPEAT_ERR3.Reg, volatile.LoadUint32(&o.RD_REPEAT_ERR3.Reg)&^(0x2)|value<<1)
}
func (o *EFUSE_Type) GetRD_REPEAT_ERR3_DIS_LEGACY_SPI_BOOT_ERR() uint32 {
	return (volatile.LoadUint32(&o.RD_REPEAT_ERR3.Reg) & 0x2) >> 1
}
func (o *EFUSE_Type) SetRD_REPEAT_ERR3_UART_PRINT_CHANNEL_ERR(value uint32) {
	volatile.StoreUint32(&o.RD_REPEAT_ERR3.Reg, volatile.LoadUint32(&o.RD_REPEAT_ERR3.Reg)&^(0x4)|value<<2)
}
func (o *EFUSE_Type) GetRD_REPEAT_ERR3_UART_PRINT_CHANNEL_ERR() uint32 {
	return (volatile.LoadUint32(&o.RD_REPEAT_ERR3.Reg) & 0x4) >> 2
}
func (o *EFUSE_Type) SetRD_REPEAT_ERR3_FLASH_ECC_MODE_ERR(value uint32) {
	volatile.StoreUint32(&o.RD_REPEAT_ERR3.Reg, volatile.LoadUint32(&o.RD_REPEAT_ERR3.Reg)&^(0x8)|value<<3)
}
func (o *EFUSE_Type) GetRD_REPEAT_ERR3_FLASH_ECC_MODE_ERR() uint32 {
	return (volatile.LoadUint32(&o.RD_REPEAT_ERR3.Reg) & 0x8) >> 3
}
func (o *EFUSE_Type) SetRD_REPEAT_ERR3_DIS_USB_DOWNLOAD_MODE_ERR(value uint32) {
	volatile.StoreUint32(&o.RD_REPEAT_ERR3.Reg, volatile.LoadUint32(&o.RD_REPEAT_ERR3.Reg)&^(0x10)|value<<4)
}
func (o *EFUSE_Type) GetRD_REPEAT_ERR3_DIS_USB_DOWNLOAD_MODE_ERR() uint32 {
	return (volatile.LoadUint32(&o.RD_REPEAT_ERR3.Reg) & 0x10) >> 4
}
func (o *EFUSE_Type) SetRD_REPEAT_ERR3_ENABLE_SECURITY_DOWNLOAD_ERR(value uint32) {
	volatile.StoreUint32(&o.RD_REPEAT_ERR3.Reg, volatile.LoadUint32(&o.RD_REPEAT_ERR3.Reg)&^(0x20)|value<<5)
}
func (o *EFUSE_Type) GetRD_REPEAT_ERR3_ENABLE_SECURITY_DOWNLOAD_ERR() uint32 {
	return (volatile.LoadUint32(&o.RD_REPEAT_ERR3.Reg) & 0x20) >> 5
}
func (o *EFUSE_Type) SetRD_REPEAT_ERR3_UART_PRINT_CONTROL_ERR(value uint32) {
	volatile.StoreUint32(&o.RD_REPEAT_ERR3.Reg, volatile.LoadUint32(&o.RD_REPEAT_ERR3.Reg)&^(0xc0)|value<<6)
}
func (o *EFUSE_Type) GetRD_REPEAT_ERR3_UART_PRINT_CONTROL_ERR() uint32 {
	return (volatile.LoadUint32(&o.RD_REPEAT_ERR3.Reg) & 0xc0) >> 6
}
func (o *EFUSE_Type) SetRD_REPEAT_ERR3_PIN_POWER_SELECTION_ERR(value uint32) {
	volatile.StoreUint32(&o.RD_REPEAT_ERR3.Reg, volatile.LoadUint32(&o.RD_REPEAT_ERR3.Reg)&^(0x100)|value<<8)
}
func (o *EFUSE_Type) GetRD_REPEAT_ERR3_PIN_POWER_SELECTION_ERR() uint32 {
	return (volatile.LoadUint32(&o.RD_REPEAT_ERR3.Reg) & 0x100) >> 8
}
func (o *EFUSE_Type) SetRD_REPEAT_ERR3_FLASH_TYPE_ERR(value uint32) {
	volatile.StoreUint32(&o.RD_REPEAT_ERR3.Reg, volatile.LoadUint32(&o.RD_REPEAT_ERR3.Reg)&^(0x200)|value<<9)
}
func (o *EFUSE_Type) GetRD_REPEAT_ERR3_FLASH_TYPE_ERR() uint32 {
	return (volatile.LoadUint32(&o.RD_REPEAT_ERR3.Reg) & 0x200) >> 9
}
func (o *EFUSE_Type) SetRD_REPEAT_ERR3_FLASH_PAGE_SIZE_ERR(value uint32) {
	volatile.StoreUint32(&o.RD_REPEAT_ERR3.Reg, volatile.LoadUint32(&o.RD_REPEAT_ERR3.Reg)&^(0xc00)|value<<10)
}
func (o *EFUSE_Type) GetRD_REPEAT_ERR3_FLASH_PAGE_SIZE_ERR() uint32 {
	return (volatile.LoadUint32(&o.RD_REPEAT_ERR3.Reg) & 0xc00) >> 10
}
func (o *EFUSE_Type) SetRD_REPEAT_ERR3_FLASH_ECC_EN_ERR(value uint32) {
	volatile.StoreUint32(&o.RD_REPEAT_ERR3.Reg, volatile.LoadUint32(&o.RD_REPEAT_ERR3.Reg)&^(0x1000)|value<<12)
}
func (o *EFUSE_Type) GetRD_REPEAT_ERR3_FLASH_ECC_EN_ERR() uint32 {
	return (volatile.LoadUint32(&o.RD_REPEAT_ERR3.Reg) & 0x1000) >> 12
}
func (o *EFUSE_Type) SetRD_REPEAT_ERR3_FORCE_SEND_RESUME_ERR(value uint32) {
	volatile.StoreUint32(&o.RD_REPEAT_ERR3.Reg, volatile.LoadUint32(&o.RD_REPEAT_ERR3.Reg)&^(0x2000)|value<<13)
}
func (o *EFUSE_Type) GetRD_REPEAT_ERR3_FORCE_SEND_RESUME_ERR() uint32 {
	return (volatile.LoadUint32(&o.RD_REPEAT_ERR3.Reg) & 0x2000) >> 13
}
func (o *EFUSE_Type) SetRD_REPEAT_ERR3_SECURE_VERSION_ERR(value uint32) {
	volatile.StoreUint32(&o.RD_REPEAT_ERR3.Reg, volatile.LoadUint32(&o.RD_REPEAT_ERR3.Reg)&^(0x3fffc000)|value<<14)
}
func (o *EFUSE_Type) GetRD_REPEAT_ERR3_SECURE_VERSION_ERR() uint32 {
	return (volatile.LoadUint32(&o.RD_REPEAT_ERR3.Reg) & 0x3fffc000) >> 14
}
func (o *EFUSE_Type) SetRD_REPEAT_ERR3_RPT4_RESERVED1_ERR(value uint32) {
	volatile.StoreUint32(&o.RD_REPEAT_ERR3.Reg, volatile.LoadUint32(&o.RD_REPEAT_ERR3.Reg)&^(0xc0000000)|value<<30)
}
func (o *EFUSE_Type) GetRD_REPEAT_ERR3_RPT4_RESERVED1_ERR() uint32 {
	return (volatile.LoadUint32(&o.RD_REPEAT_ERR3.Reg) & 0xc0000000) >> 30
}

// EFUSE.RD_REPEAT_ERR4: Programming error record register 4 of BLOCK0.
func (o *EFUSE_Type) SetRD_REPEAT_ERR4_RPT4_RESERVED4_ERR(value uint32) {
	volatile.StoreUint32(&o.RD_REPEAT_ERR4.Reg, volatile.LoadUint32(&o.RD_REPEAT_ERR4.Reg)&^(0xffffff)|value)
}
func (o *EFUSE_Type) GetRD_REPEAT_ERR4_RPT4_RESERVED4_ERR() uint32 {
	return volatile.LoadUint32(&o.RD_REPEAT_ERR4.Reg) & 0xffffff
}

// EFUSE.RD_RS_ERR0: Programming error record register 0 of BLOCK1-10.
func (o *EFUSE_Type) SetRD_RS_ERR0_MAC_SPI_8M_ERR_NUM(value uint32) {
	volatile.StoreUint32(&o.RD_RS_ERR0.Reg, volatile.LoadUint32(&o.RD_RS_ERR0.Reg)&^(0x7)|value)
}
func (o *EFUSE_Type) GetRD_RS_ERR0_MAC_SPI_8M_ERR_NUM() uint32 {
	return volatile.LoadUint32(&o.RD_RS_ERR0.Reg) & 0x7
}
func (o *EFUSE_Type) SetRD_RS_ERR0_MAC_SPI_8M_FAIL(value uint32) {
	volatile.StoreUint32(&o.RD_RS_ERR0.Reg, volatile.LoadUint32(&o.RD_RS_ERR0.Reg)&^(0x8)|value<<3)
}
func (o *EFUSE_Type) GetRD_RS_ERR0_MAC_SPI_8M_FAIL() uint32 {
	return (volatile.LoadUint32(&o.RD_RS_ERR0.Reg) & 0x8) >> 3
}
func (o *EFUSE_Type) SetRD_RS_ERR0_SYS_PART1_NUM(value uint32) {
	volatile.StoreUint32(&o.RD_RS_ERR0.Reg, volatile.LoadUint32(&o.RD_RS_ERR0.Reg)&^(0x70)|value<<4)
}
func (o *EFUSE_Type) GetRD_RS_ERR0_SYS_PART1_NUM() uint32 {
	return (volatile.LoadUint32(&o.RD_RS_ERR0.Reg) & 0x70) >> 4
}
func (o *EFUSE_Type) SetRD_RS_ERR0_SYS_PART1_FAIL(value uint32) {
	volatile.StoreUint32(&o.RD_RS_ERR0.Reg, volatile.LoadUint32(&o.RD_RS_ERR0.Reg)&^(0x80)|value<<7)
}
func (o *EFUSE_Type) GetRD_RS_ERR0_SYS_PART1_FAIL() uint32 {
	return (volatile.LoadUint32(&o.RD_RS_ERR0.Reg) & 0x80) >> 7
}
func (o *EFUSE_Type) SetRD_RS_ERR0_USR_DATA_ERR_NUM(value uint32) {
	volatile.StoreUint32(&o.RD_RS_ERR0.Reg, volatile.LoadUint32(&o.RD_RS_ERR0.Reg)&^(0x700)|value<<8)
}
func (o *EFUSE_Type) GetRD_RS_ERR0_USR_DATA_ERR_NUM() uint32 {
	return (volatile.LoadUint32(&o.RD_RS_ERR0.Reg) & 0x700) >> 8
}
func (o *EFUSE_Type) SetRD_RS_ERR0_USR_DATA_FAIL(value uint32) {
	volatile.StoreUint32(&o.RD_RS_ERR0.Reg, volatile.LoadUint32(&o.RD_RS_ERR0.Reg)&^(0x800)|value<<11)
}
func (o *EFUSE_Type) GetRD_RS_ERR0_USR_DATA_FAIL() uint32 {
	return (volatile.LoadUint32(&o.RD_RS_ERR0.Reg) & 0x800) >> 11
}
func (o *EFUSE_Type) SetRD_RS_ERR0_KEY0_ERR_NUM(value uint32) {
	volatile.StoreUint32(&o.RD_RS_ERR0.Reg, volatile.LoadUint32(&o.RD_RS_ERR0.Reg)&^(0x7000)|value<<12)
}
func (o *EFUSE_Type) GetRD_RS_ERR0_KEY0_ERR_NUM() uint32 {
	return (volatile.LoadUint32(&o.RD_RS_ERR0.Reg) & 0x7000) >> 12
}
func (o *EFUSE_Type) SetRD_RS_ERR0_KEY0_FAIL(value uint32) {
	volatile.StoreUint32(&o.RD_RS_ERR0.Reg, volatile.LoadUint32(&o.RD_RS_ERR0.Reg)&^(0x8000)|value<<15)
}
func (o *EFUSE_Type) GetRD_RS_ERR0_KEY0_FAIL() uint32 {
	return (volatile.LoadUint32(&o.RD_RS_ERR0.Reg) & 0x8000) >> 15
}
func (o *EFUSE_Type) SetRD_RS_ERR0_KEY1_ERR_NUM(value uint32) {
	volatile.StoreUint32(&o.RD_RS_ERR0.Reg, volatile.LoadUint32(&o.RD_RS_ERR0.Reg)&^(0x70000)|value<<16)
}
func (o *EFUSE_Type) GetRD_RS_ERR0_KEY1_ERR_NUM() uint32 {
	return (volatile.LoadUint32(&o.RD_RS_ERR0.Reg) & 0x70000) >> 16
}
func (o *EFUSE_Type) SetRD_RS_ERR0_KEY1_FAIL(value uint32) {
	volatile.StoreUint32(&o.RD_RS_ERR0.Reg, volatile.LoadUint32(&o.RD_RS_ERR0.Reg)&^(0x80000)|value<<19)
}
func (o *EFUSE_Type) GetRD_RS_ERR0_KEY1_FAIL() uint32 {
	return (volatile.LoadUint32(&o.RD_RS_ERR0.Reg) & 0x80000) >> 19
}
func (o *EFUSE_Type) SetRD_RS_ERR0_KEY2_ERR_NUM(value uint32) {
	volatile.StoreUint32(&o.RD_RS_ERR0.Reg, volatile.LoadUint32(&o.RD_RS_ERR0.Reg)&^(0x700000)|value<<20)
}
func (o *EFUSE_Type) GetRD_RS_ERR0_KEY2_ERR_NUM() uint32 {
	return (volatile.LoadUint32(&o.RD_RS_ERR0.Reg) & 0x700000) >> 20
}
func (o *EFUSE_Type) SetRD_RS_ERR0_KEY2_FAIL(value uint32) {
	volatile.StoreUint32(&o.RD_RS_ERR0.Reg, volatile.LoadUint32(&o.RD_RS_ERR0.Reg)&^(0x800000)|value<<23)
}
func (o *EFUSE_Type) GetRD_RS_ERR0_KEY2_FAIL() uint32 {
	return (volatile.LoadUint32(&o.RD_RS_ERR0.Reg) & 0x800000) >> 23
}
func (o *EFUSE_Type) SetRD_RS_ERR0_KEY3_ERR_NUM(value uint32) {
	volatile.StoreUint32(&o.RD_RS_ERR0.Reg, volatile.LoadUint32(&o.RD_RS_ERR0.Reg)&^(0x7000000)|value<<24)
}
func (o *EFUSE_Type) GetRD_RS_ERR0_KEY3_ERR_NUM() uint32 {
	return (volatile.LoadUint32(&o.RD_RS_ERR0.Reg) & 0x7000000) >> 24
}
func (o *EFUSE_Type) SetRD_RS_ERR0_KEY3_FAIL(value uint32) {
	volatile.StoreUint32(&o.RD_RS_ERR0.Reg, volatile.LoadUint32(&o.RD_RS_ERR0.Reg)&^(0x8000000)|value<<27)
}
func (o *EFUSE_Type) GetRD_RS_ERR0_KEY3_FAIL() uint32 {
	return (volatile.LoadUint32(&o.RD_RS_ERR0.Reg) & 0x8000000) >> 27
}
func (o *EFUSE_Type) SetRD_RS_ERR0_KEY4_ERR_NUM(value uint32) {
	volatile.StoreUint32(&o.RD_RS_ERR0.Reg, volatile.LoadUint32(&o.RD_RS_ERR0.Reg)&^(0x70000000)|value<<28)
}
func (o *EFUSE_Type) GetRD_RS_ERR0_KEY4_ERR_NUM() uint32 {
	return (volatile.LoadUint32(&o.RD_RS_ERR0.Reg) & 0x70000000) >> 28
}
func (o *EFUSE_Type) SetRD_RS_ERR0_KEY4_FAIL(value uint32) {
	volatile.StoreUint32(&o.RD_RS_ERR0.Reg, volatile.LoadUint32(&o.RD_RS_ERR0.Reg)&^(0x80000000)|value<<31)
}
func (o *EFUSE_Type) GetRD_RS_ERR0_KEY4_FAIL() uint32 {
	return (volatile.LoadUint32(&o.RD_RS_ERR0.Reg) & 0x80000000) >> 31
}

// EFUSE.RD_RS_ERR1: Programming error record register 1 of BLOCK1-10.
func (o *EFUSE_Type) SetRD_RS_ERR1_KEY5_ERR_NUM(value uint32) {
	volatile.StoreUint32(&o.RD_RS_ERR1.Reg, volatile.LoadUint32(&o.RD_RS_ERR1.Reg)&^(0x7)|value)
}
func (o *EFUSE_Type) GetRD_RS_ERR1_KEY5_ERR_NUM() uint32 {
	return volatile.LoadUint32(&o.RD_RS_ERR1.Reg) & 0x7
}
func (o *EFUSE_Type) SetRD_RS_ERR1_KEY5_FAIL(value uint32) {
	volatile.StoreUint32(&o.RD_RS_ERR1.Reg, volatile.LoadUint32(&o.RD_RS_ERR1.Reg)&^(0x8)|value<<3)
}
func (o *EFUSE_Type) GetRD_RS_ERR1_KEY5_FAIL() uint32 {
	return (volatile.LoadUint32(&o.RD_RS_ERR1.Reg) & 0x8) >> 3
}
func (o *EFUSE_Type) SetRD_RS_ERR1_SYS_PART2_ERR_NUM(value uint32) {
	volatile.StoreUint32(&o.RD_RS_ERR1.Reg, volatile.LoadUint32(&o.RD_RS_ERR1.Reg)&^(0x70)|value<<4)
}
func (o *EFUSE_Type) GetRD_RS_ERR1_SYS_PART2_ERR_NUM() uint32 {
	return (volatile.LoadUint32(&o.RD_RS_ERR1.Reg) & 0x70) >> 4
}
func (o *EFUSE_Type) SetRD_RS_ERR1_SYS_PART2_FAIL(value uint32) {
	volatile.StoreUint32(&o.RD_RS_ERR1.Reg, volatile.LoadUint32(&o.RD_RS_ERR1.Reg)&^(0x80)|value<<7)
}
func (o *EFUSE_Type) GetRD_RS_ERR1_SYS_PART2_FAIL() uint32 {
	return (volatile.LoadUint32(&o.RD_RS_ERR1.Reg) & 0x80) >> 7
}

// EFUSE.CLK: eFuse clcok configuration register.
func (o *EFUSE_Type) SetCLK_EFUSE_MEM_FORCE_PD(value uint32) {
	volatile.StoreUint32(&o.CLK.Reg, volatile.LoadUint32(&o.CLK.Reg)&^(0x1)|value)
}
func (o *EFUSE_Type) GetCLK_EFUSE_MEM_FORCE_PD() uint32 {
	return volatile.LoadUint32(&o.CLK.Reg) & 0x1
}
func (o *EFUSE_Type) SetCLK_MEM_CLK_FORCE_ON(value uint32) {
	volatile.StoreUint32(&o.CLK.Reg, volatile.LoadUint32(&o.CLK.Reg)&^(0x2)|value<<1)
}
func (o *EFUSE_Type) GetCLK_MEM_CLK_FORCE_ON() uint32 {
	return (volatile.LoadUint32(&o.CLK.Reg) & 0x2) >> 1
}
func (o *EFUSE_Type) SetCLK_EFUSE_MEM_FORCE_PU(value uint32) {
	volatile.StoreUint32(&o.CLK.Reg, volatile.LoadUint32(&o.CLK.Reg)&^(0x4)|value<<2)
}
func (o *EFUSE_Type) GetCLK_EFUSE_MEM_FORCE_PU() uint32 {
	return (volatile.LoadUint32(&o.CLK.Reg) & 0x4) >> 2
}
func (o *EFUSE_Type) SetCLK_EN(value uint32) {
	volatile.StoreUint32(&o.CLK.Reg, volatile.LoadUint32(&o.CLK.Reg)&^(0x10000)|value<<16)
}
func (o *EFUSE_Type) GetCLK_EN() uint32 {
	return (volatile.LoadUint32(&o.CLK.Reg) & 0x10000) >> 16
}

// EFUSE.CONF: eFuse operation mode configuraiton register;
func (o *EFUSE_Type) SetCONF_OP_CODE(value uint32) {
	volatile.StoreUint32(&o.CONF.Reg, volatile.LoadUint32(&o.CONF.Reg)&^(0xffff)|value)
}
func (o *EFUSE_Type) GetCONF_OP_CODE() uint32 {
	return volatile.LoadUint32(&o.CONF.Reg) & 0xffff
}

// EFUSE.STATUS: eFuse status register.
func (o *EFUSE_Type) SetSTATUS_STATE(value uint32) {
	volatile.StoreUint32(&o.STATUS.Reg, volatile.LoadUint32(&o.STATUS.Reg)&^(0xf)|value)
}
func (o *EFUSE_Type) GetSTATUS_STATE() uint32 {
	return volatile.LoadUint32(&o.STATUS.Reg) & 0xf
}
func (o *EFUSE_Type) SetSTATUS_OTP_LOAD_SW(value uint32) {
	volatile.StoreUint32(&o.STATUS.Reg, volatile.LoadUint32(&o.STATUS.Reg)&^(0x10)|value<<4)
}
func (o *EFUSE_Type) GetSTATUS_OTP_LOAD_SW() uint32 {
	return (volatile.LoadUint32(&o.STATUS.Reg) & 0x10) >> 4
}
func (o *EFUSE_Type) SetSTATUS_OTP_VDDQ_C_SYNC2(value uint32) {
	volatile.StoreUint32(&o.STATUS.Reg, volatile.LoadUint32(&o.STATUS.Reg)&^(0x20)|value<<5)
}
func (o *EFUSE_Type) GetSTATUS_OTP_VDDQ_C_SYNC2() uint32 {
	return (volatile.LoadUint32(&o.STATUS.Reg) & 0x20) >> 5
}
func (o *EFUSE_Type) SetSTATUS_OTP_STROBE_SW(value uint32) {
	volatile.StoreUint32(&o.STATUS.Reg, volatile.LoadUint32(&o.STATUS.Reg)&^(0x40)|value<<6)
}
func (o *EFUSE_Type) GetSTATUS_OTP_STROBE_SW() uint32 {
	return (volatile.LoadUint32(&o.STATUS.Reg) & 0x40) >> 6
}
func (o *EFUSE_Type) SetSTATUS_OTP_CSB_SW(value uint32) {
	volatile.StoreUint32(&o.STATUS.Reg, volatile.LoadUint32(&o.STATUS.Reg)&^(0x80)|value<<7)
}
func (o *EFUSE_Type) GetSTATUS_OTP_CSB_SW() uint32 {
	return (volatile.LoadUint32(&o.STATUS.Reg) & 0x80) >> 7
}
func (o *EFUSE_Type) SetSTATUS_OTP_PGENB_SW(value uint32) {
	volatile.StoreUint32(&o.STATUS.Reg, volatile.LoadUint32(&o.STATUS.Reg)&^(0x100)|value<<8)
}
func (o *EFUSE_Type) GetSTATUS_OTP_PGENB_SW() uint32 {
	return (volatile.LoadUint32(&o.STATUS.Reg) & 0x100) >> 8
}
func (o *EFUSE_Type) SetSTATUS_OTP_VDDQ_IS_SW(value uint32) {
	volatile.StoreUint32(&o.STATUS.Reg, volatile.LoadUint32(&o.STATUS.Reg)&^(0x200)|value<<9)
}
func (o *EFUSE_Type) GetSTATUS_OTP_VDDQ_IS_SW() uint32 {
	return (volatile.LoadUint32(&o.STATUS.Reg) & 0x200) >> 9
}
func (o *EFUSE_Type) SetSTATUS_REPEAT_ERR_CNT(value uint32) {
	volatile.StoreUint32(&o.STATUS.Reg, volatile.LoadUint32(&o.STATUS.Reg)&^(0x3fc00)|value<<10)
}
func (o *EFUSE_Type) GetSTATUS_REPEAT_ERR_CNT() uint32 {
	return (volatile.LoadUint32(&o.STATUS.Reg) & 0x3fc00) >> 10
}

// EFUSE.CMD: eFuse command register.
func (o *EFUSE_Type) SetCMD_READ_CMD(value uint32) {
	volatile.StoreUint32(&o.CMD.Reg, volatile.LoadUint32(&o.CMD.Reg)&^(0x1)|value)
}
func (o *EFUSE_Type) GetCMD_READ_CMD() uint32 {
	return volatile.LoadUint32(&o.CMD.Reg) & 0x1
}
func (o *EFUSE_Type) SetCMD_PGM_CMD(value uint32) {
	volatile.StoreUint32(&o.CMD.Reg, volatile.LoadUint32(&o.CMD.Reg)&^(0x2)|value<<1)
}
func (o *EFUSE_Type) GetCMD_PGM_CMD() uint32 {
	return (volatile.LoadUint32(&o.CMD.Reg) & 0x2) >> 1
}
func (o *EFUSE_Type) SetCMD_BLK_NUM(value uint32) {
	volatile.StoreUint32(&o.CMD.Reg, volatile.LoadUint32(&o.CMD.Reg)&^(0x3c)|value<<2)
}
func (o *EFUSE_Type) GetCMD_BLK_NUM() uint32 {
	return (volatile.LoadUint32(&o.CMD.Reg) & 0x3c) >> 2
}

// EFUSE.INT_RAW: eFuse raw interrupt register.
func (o *EFUSE_Type) SetINT_RAW_READ_DONE_INT_RAW(value uint32) {
	volatile.StoreUint32(&o.INT_RAW.Reg, volatile.LoadUint32(&o.INT_RAW.Reg)&^(0x1)|value)
}
func (o *EFUSE_Type) GetINT_RAW_READ_DONE_INT_RAW() uint32 {
	return volatile.LoadUint32(&o.INT_RAW.Reg) & 0x1
}
func (o *EFUSE_Type) SetINT_RAW_PGM_DONE_INT_RAW(value uint32) {
	volatile.StoreUint32(&o.INT_RAW.Reg, volatile.LoadUint32(&o.INT_RAW.Reg)&^(0x2)|value<<1)
}
func (o *EFUSE_Type) GetINT_RAW_PGM_DONE_INT_RAW() uint32 {
	return (volatile.LoadUint32(&o.INT_RAW.Reg) & 0x2) >> 1
}

// EFUSE.INT_ST: eFuse interrupt status register.
func (o *EFUSE_Type) SetINT_ST_READ_DONE_INT_ST(value uint32) {
	volatile.StoreUint32(&o.INT_ST.Reg, volatile.LoadUint32(&o.INT_ST.Reg)&^(0x1)|value)
}
func (o *EFUSE_Type) GetINT_ST_READ_DONE_INT_ST() uint32 {
	return volatile.LoadUint32(&o.INT_ST.Reg) & 0x1
}
func (o *EFUSE_Type) SetINT_ST_PGM_DONE_INT_ST(value uint32) {
	volatile.StoreUint32(&o.INT_ST.Reg, volatile.LoadUint32(&o.INT_ST.Reg)&^(0x2)|value<<1)
}
func (o *EFUSE_Type) GetINT_ST_PGM_DONE_INT_ST() uint32 {
	return (volatile.LoadUint32(&o.INT_ST.Reg) & 0x2) >> 1
}

// EFUSE.INT_ENA: eFuse interrupt enable register.
func (o *EFUSE_Type) SetINT_ENA_READ_DONE_INT_ENA(value uint32) {
	volatile.StoreUint32(&o.INT_ENA.Reg, volatile.LoadUint32(&o.INT_ENA.Reg)&^(0x1)|value)
}
func (o *EFUSE_Type) GetINT_ENA_READ_DONE_INT_ENA() uint32 {
	return volatile.LoadUint32(&o.INT_ENA.Reg) & 0x1
}
func (o *EFUSE_Type) SetINT_ENA_PGM_DONE_INT_ENA(value uint32) {
	volatile.StoreUint32(&o.INT_ENA.Reg, volatile.LoadUint32(&o.INT_ENA.Reg)&^(0x2)|value<<1)
}
func (o *EFUSE_Type) GetINT_ENA_PGM_DONE_INT_ENA() uint32 {
	return (volatile.LoadUint32(&o.INT_ENA.Reg) & 0x2) >> 1
}

// EFUSE.INT_CLR: eFuse interrupt clear register.
func (o *EFUSE_Type) SetINT_CLR_READ_DONE_INT_CLR(value uint32) {
	volatile.StoreUint32(&o.INT_CLR.Reg, volatile.LoadUint32(&o.INT_CLR.Reg)&^(0x1)|value)
}
func (o *EFUSE_Type) GetINT_CLR_READ_DONE_INT_CLR() uint32 {
	return volatile.LoadUint32(&o.INT_CLR.Reg) & 0x1
}
func (o *EFUSE_Type) SetINT_CLR_PGM_DONE_INT_CLR(value uint32) {
	volatile.StoreUint32(&o.INT_CLR.Reg, volatile.LoadUint32(&o.INT_CLR.Reg)&^(0x2)|value<<1)
}
func (o *EFUSE_Type) GetINT_CLR_PGM_DONE_INT_CLR() uint32 {
	return (volatile.LoadUint32(&o.INT_CLR.Reg) & 0x2) >> 1
}

// EFUSE.DAC_CONF: Controls the eFuse programming voltage.
func (o *EFUSE_Type) SetDAC_CONF_DAC_CLK_DIV(value uint32) {
	volatile.StoreUint32(&o.DAC_CONF.Reg, volatile.LoadUint32(&o.DAC_CONF.Reg)&^(0xff)|value)
}
func (o *EFUSE_Type) GetDAC_CONF_DAC_CLK_DIV() uint32 {
	return volatile.LoadUint32(&o.DAC_CONF.Reg) & 0xff
}
func (o *EFUSE_Type) SetDAC_CONF_DAC_CLK_PAD_SEL(value uint32) {
	volatile.StoreUint32(&o.DAC_CONF.Reg, volatile.LoadUint32(&o.DAC_CONF.Reg)&^(0x100)|value<<8)
}
func (o *EFUSE_Type) GetDAC_CONF_DAC_CLK_PAD_SEL() uint32 {
	return (volatile.LoadUint32(&o.DAC_CONF.Reg) & 0x100) >> 8
}
func (o *EFUSE_Type) SetDAC_CONF_DAC_NUM(value uint32) {
	volatile.StoreUint32(&o.DAC_CONF.Reg, volatile.LoadUint32(&o.DAC_CONF.Reg)&^(0x1fe00)|value<<9)
}
func (o *EFUSE_Type) GetDAC_CONF_DAC_NUM() uint32 {
	return (volatile.LoadUint32(&o.DAC_CONF.Reg) & 0x1fe00) >> 9
}
func (o *EFUSE_Type) SetDAC_CONF_OE_CLR(value uint32) {
	volatile.StoreUint32(&o.DAC_CONF.Reg, volatile.LoadUint32(&o.DAC_CONF.Reg)&^(0x20000)|value<<17)
}
func (o *EFUSE_Type) GetDAC_CONF_OE_CLR() uint32 {
	return (volatile.LoadUint32(&o.DAC_CONF.Reg) & 0x20000) >> 17
}

// EFUSE.RD_TIM_CONF: Configures read timing parameters.
func (o *EFUSE_Type) SetRD_TIM_CONF_READ_INIT_NUM(value uint32) {
	volatile.StoreUint32(&o.RD_TIM_CONF.Reg, volatile.LoadUint32(&o.RD_TIM_CONF.Reg)&^(0xff000000)|value<<24)
}
func (o *EFUSE_Type) GetRD_TIM_CONF_READ_INIT_NUM() uint32 {
	return (volatile.LoadUint32(&o.RD_TIM_CONF.Reg) & 0xff000000) >> 24
}

// EFUSE.WR_TIM_CONF1: Configurarion register 1 of eFuse programming timing parameters.
func (o *EFUSE_Type) SetWR_TIM_CONF1_PWR_ON_NUM(value uint32) {
	volatile.StoreUint32(&o.WR_TIM_CONF1.Reg, volatile.LoadUint32(&o.WR_TIM_CONF1.Reg)&^(0xffff00)|value<<8)
}
func (o *EFUSE_Type) GetWR_TIM_CONF1_PWR_ON_NUM() uint32 {
	return (volatile.LoadUint32(&o.WR_TIM_CONF1.Reg) & 0xffff00) >> 8
}

// EFUSE.WR_TIM_CONF2: Configurarion register 2 of eFuse programming timing parameters.
func (o *EFUSE_Type) SetWR_TIM_CONF2_PWR_OFF_NUM(value uint32) {
	volatile.StoreUint32(&o.WR_TIM_CONF2.Reg, volatile.LoadUint32(&o.WR_TIM_CONF2.Reg)&^(0xffff)|value)
}
func (o *EFUSE_Type) GetWR_TIM_CONF2_PWR_OFF_NUM() uint32 {
	return volatile.LoadUint32(&o.WR_TIM_CONF2.Reg) & 0xffff
}

// EFUSE.DATE: eFuse version register.
func (o *EFUSE_Type) SetDATE(value uint32) {
	volatile.StoreUint32(&o.DATE.Reg, volatile.LoadUint32(&o.DATE.Reg)&^(0xfffffff)|value)
}
func (o *EFUSE_Type) GetDATE() uint32 {
	return volatile.LoadUint32(&o.DATE.Reg) & 0xfffffff
}

// Peripheral GPIO
type GPIO_Type struct {
	BT_SELECT          volatile.Register32 // 0x0
	OUT                volatile.Register32 // 0x4
	OUT_W1TS           volatile.Register32 // 0x8
	OUT_W1TC           volatile.Register32 // 0xC
	_                  [12]byte
	SDIO_SELECT        volatile.Register32 // 0x1C
	ENABLE             volatile.Register32 // 0x20
	ENABLE_W1TS        volatile.Register32 // 0x24
	ENABLE_W1TC        volatile.Register32 // 0x28
	_                  [12]byte
	STRAP              volatile.Register32 // 0x38
	IN                 volatile.Register32 // 0x3C
	_                  [4]byte
	STATUS             volatile.Register32 // 0x44
	STATUS_W1TS        volatile.Register32 // 0x48
	STATUS_W1TC        volatile.Register32 // 0x4C
	_                  [12]byte
	PCPU_INT           volatile.Register32 // 0x5C
	PCPU_NMI_INT       volatile.Register32 // 0x60
	CPUSDIO_INT        volatile.Register32 // 0x64
	_                  [12]byte
	PIN0               volatile.Register32 // 0x74
	PIN1               volatile.Register32 // 0x78
	PIN2               volatile.Register32 // 0x7C
	PIN3               volatile.Register32 // 0x80
	PIN4               volatile.Register32 // 0x84
	PIN5               volatile.Register32 // 0x88
	PIN6               volatile.Register32 // 0x8C
	PIN7               volatile.Register32 // 0x90
	PIN8               volatile.Register32 // 0x94
	PIN9               volatile.Register32 // 0x98
	PIN10              volatile.Register32 // 0x9C
	PIN11              volatile.Register32 // 0xA0
	PIN12              volatile.Register32 // 0xA4
	PIN13              volatile.Register32 // 0xA8
	PIN14              volatile.Register32 // 0xAC
	PIN15              volatile.Register32 // 0xB0
	PIN16              volatile.Register32 // 0xB4
	PIN17              volatile.Register32 // 0xB8
	PIN18              volatile.Register32 // 0xBC
	PIN19              volatile.Register32 // 0xC0
	PIN20              volatile.Register32 // 0xC4
	PIN21              volatile.Register32 // 0xC8
	PIN22              volatile.Register32 // 0xCC
	PIN23              volatile.Register32 // 0xD0
	PIN24              volatile.Register32 // 0xD4
	PIN25              volatile.Register32 // 0xD8
	_                  [112]byte
	STATUS_NEXT        volatile.Register32 // 0x14C
	_                  [4]byte
	FUNC0_IN_SEL_CFG   volatile.Register32 // 0x154
	FUNC1_IN_SEL_CFG   volatile.Register32 // 0x158
	FUNC2_IN_SEL_CFG   volatile.Register32 // 0x15C
	FUNC3_IN_SEL_CFG   volatile.Register32 // 0x160
	FUNC4_IN_SEL_CFG   volatile.Register32 // 0x164
	FUNC5_IN_SEL_CFG   volatile.Register32 // 0x168
	FUNC6_IN_SEL_CFG   volatile.Register32 // 0x16C
	FUNC7_IN_SEL_CFG   volatile.Register32 // 0x170
	FUNC8_IN_SEL_CFG   volatile.Register32 // 0x174
	FUNC9_IN_SEL_CFG   volatile.Register32 // 0x178
	FUNC10_IN_SEL_CFG  volatile.Register32 // 0x17C
	FUNC11_IN_SEL_CFG  volatile.Register32 // 0x180
	FUNC12_IN_SEL_CFG  volatile.Register32 // 0x184
	FUNC13_IN_SEL_CFG  volatile.Register32 // 0x188
	FUNC14_IN_SEL_CFG  volatile.Register32 // 0x18C
	FUNC15_IN_SEL_CFG  volatile.Register32 // 0x190
	FUNC16_IN_SEL_CFG  volatile.Register32 // 0x194
	FUNC17_IN_SEL_CFG  volatile.Register32 // 0x198
	FUNC18_IN_SEL_CFG  volatile.Register32 // 0x19C
	FUNC19_IN_SEL_CFG  volatile.Register32 // 0x1A0
	FUNC20_IN_SEL_CFG  volatile.Register32 // 0x1A4
	FUNC21_IN_SEL_CFG  volatile.Register32 // 0x1A8
	FUNC22_IN_SEL_CFG  volatile.Register32 // 0x1AC
	FUNC23_IN_SEL_CFG  volatile.Register32 // 0x1B0
	FUNC24_IN_SEL_CFG  volatile.Register32 // 0x1B4
	FUNC25_IN_SEL_CFG  volatile.Register32 // 0x1B8
	FUNC26_IN_SEL_CFG  volatile.Register32 // 0x1BC
	FUNC27_IN_SEL_CFG  volatile.Register32 // 0x1C0
	FUNC28_IN_SEL_CFG  volatile.Register32 // 0x1C4
	FUNC29_IN_SEL_CFG  volatile.Register32 // 0x1C8
	FUNC30_IN_SEL_CFG  volatile.Register32 // 0x1CC
	FUNC31_IN_SEL_CFG  volatile.Register32 // 0x1D0
	FUNC32_IN_SEL_CFG  volatile.Register32 // 0x1D4
	FUNC33_IN_SEL_CFG  volatile.Register32 // 0x1D8
	FUNC34_IN_SEL_CFG  volatile.Register32 // 0x1DC
	FUNC35_IN_SEL_CFG  volatile.Register32 // 0x1E0
	FUNC36_IN_SEL_CFG  volatile.Register32 // 0x1E4
	FUNC37_IN_SEL_CFG  volatile.Register32 // 0x1E8
	FUNC38_IN_SEL_CFG  volatile.Register32 // 0x1EC
	FUNC39_IN_SEL_CFG  volatile.Register32 // 0x1F0
	FUNC40_IN_SEL_CFG  volatile.Register32 // 0x1F4
	FUNC41_IN_SEL_CFG  volatile.Register32 // 0x1F8
	FUNC42_IN_SEL_CFG  volatile.Register32 // 0x1FC
	FUNC43_IN_SEL_CFG  volatile.Register32 // 0x200
	FUNC44_IN_SEL_CFG  volatile.Register32 // 0x204
	FUNC45_IN_SEL_CFG  volatile.Register32 // 0x208
	FUNC46_IN_SEL_CFG  volatile.Register32 // 0x20C
	FUNC47_IN_SEL_CFG  volatile.Register32 // 0x210
	FUNC48_IN_SEL_CFG  volatile.Register32 // 0x214
	FUNC49_IN_SEL_CFG  volatile.Register32 // 0x218
	FUNC50_IN_SEL_CFG  volatile.Register32 // 0x21C
	FUNC51_IN_SEL_CFG  volatile.Register32 // 0x220
	FUNC52_IN_SEL_CFG  volatile.Register32 // 0x224
	FUNC53_IN_SEL_CFG  volatile.Register32 // 0x228
	FUNC54_IN_SEL_CFG  volatile.Register32 // 0x22C
	FUNC55_IN_SEL_CFG  volatile.Register32 // 0x230
	FUNC56_IN_SEL_CFG  volatile.Register32 // 0x234
	FUNC57_IN_SEL_CFG  volatile.Register32 // 0x238
	FUNC58_IN_SEL_CFG  volatile.Register32 // 0x23C
	FUNC59_IN_SEL_CFG  volatile.Register32 // 0x240
	FUNC60_IN_SEL_CFG  volatile.Register32 // 0x244
	FUNC61_IN_SEL_CFG  volatile.Register32 // 0x248
	FUNC62_IN_SEL_CFG  volatile.Register32 // 0x24C
	FUNC63_IN_SEL_CFG  volatile.Register32 // 0x250
	FUNC64_IN_SEL_CFG  volatile.Register32 // 0x254
	FUNC65_IN_SEL_CFG  volatile.Register32 // 0x258
	FUNC66_IN_SEL_CFG  volatile.Register32 // 0x25C
	FUNC67_IN_SEL_CFG  volatile.Register32 // 0x260
	FUNC68_IN_SEL_CFG  volatile.Register32 // 0x264
	FUNC69_IN_SEL_CFG  volatile.Register32 // 0x268
	FUNC70_IN_SEL_CFG  volatile.Register32 // 0x26C
	FUNC71_IN_SEL_CFG  volatile.Register32 // 0x270
	FUNC72_IN_SEL_CFG  volatile.Register32 // 0x274
	FUNC73_IN_SEL_CFG  volatile.Register32 // 0x278
	FUNC74_IN_SEL_CFG  volatile.Register32 // 0x27C
	FUNC75_IN_SEL_CFG  volatile.Register32 // 0x280
	FUNC76_IN_SEL_CFG  volatile.Register32 // 0x284
	FUNC77_IN_SEL_CFG  volatile.Register32 // 0x288
	FUNC78_IN_SEL_CFG  volatile.Register32 // 0x28C
	FUNC79_IN_SEL_CFG  volatile.Register32 // 0x290
	FUNC80_IN_SEL_CFG  volatile.Register32 // 0x294
	FUNC81_IN_SEL_CFG  volatile.Register32 // 0x298
	FUNC82_IN_SEL_CFG  volatile.Register32 // 0x29C
	FUNC83_IN_SEL_CFG  volatile.Register32 // 0x2A0
	FUNC84_IN_SEL_CFG  volatile.Register32 // 0x2A4
	FUNC85_IN_SEL_CFG  volatile.Register32 // 0x2A8
	FUNC86_IN_SEL_CFG  volatile.Register32 // 0x2AC
	FUNC87_IN_SEL_CFG  volatile.Register32 // 0x2B0
	FUNC88_IN_SEL_CFG  volatile.Register32 // 0x2B4
	FUNC89_IN_SEL_CFG  volatile.Register32 // 0x2B8
	FUNC90_IN_SEL_CFG  volatile.Register32 // 0x2BC
	FUNC91_IN_SEL_CFG  volatile.Register32 // 0x2C0
	FUNC92_IN_SEL_CFG  volatile.Register32 // 0x2C4
	FUNC93_IN_SEL_CFG  volatile.Register32 // 0x2C8
	FUNC94_IN_SEL_CFG  volatile.Register32 // 0x2CC
	FUNC95_IN_SEL_CFG  volatile.Register32 // 0x2D0
	FUNC96_IN_SEL_CFG  volatile.Register32 // 0x2D4
	FUNC97_IN_SEL_CFG  volatile.Register32 // 0x2D8
	FUNC98_IN_SEL_CFG  volatile.Register32 // 0x2DC
	FUNC99_IN_SEL_CFG  volatile.Register32 // 0x2E0
	FUNC100_IN_SEL_CFG volatile.Register32 // 0x2E4
	FUNC101_IN_SEL_CFG volatile.Register32 // 0x2E8
	FUNC102_IN_SEL_CFG volatile.Register32 // 0x2EC
	FUNC103_IN_SEL_CFG volatile.Register32 // 0x2F0
	FUNC104_IN_SEL_CFG volatile.Register32 // 0x2F4
	FUNC105_IN_SEL_CFG volatile.Register32 // 0x2F8
	FUNC106_IN_SEL_CFG volatile.Register32 // 0x2FC
	FUNC107_IN_SEL_CFG volatile.Register32 // 0x300
	FUNC108_IN_SEL_CFG volatile.Register32 // 0x304
	FUNC109_IN_SEL_CFG volatile.Register32 // 0x308
	FUNC110_IN_SEL_CFG volatile.Register32 // 0x30C
	FUNC111_IN_SEL_CFG volatile.Register32 // 0x310
	FUNC112_IN_SEL_CFG volatile.Register32 // 0x314
	FUNC113_IN_SEL_CFG volatile.Register32 // 0x318
	FUNC114_IN_SEL_CFG volatile.Register32 // 0x31C
	FUNC115_IN_SEL_CFG volatile.Register32 // 0x320
	FUNC116_IN_SEL_CFG volatile.Register32 // 0x324
	FUNC117_IN_SEL_CFG volatile.Register32 // 0x328
	FUNC118_IN_SEL_CFG volatile.Register32 // 0x32C
	FUNC119_IN_SEL_CFG volatile.Register32 // 0x330
	FUNC120_IN_SEL_CFG volatile.Register32 // 0x334
	FUNC121_IN_SEL_CFG volatile.Register32 // 0x338
	FUNC122_IN_SEL_CFG volatile.Register32 // 0x33C
	FUNC123_IN_SEL_CFG volatile.Register32 // 0x340
	FUNC124_IN_SEL_CFG volatile.Register32 // 0x344
	FUNC125_IN_SEL_CFG volatile.Register32 // 0x348
	FUNC126_IN_SEL_CFG volatile.Register32 // 0x34C
	FUNC127_IN_SEL_CFG volatile.Register32 // 0x350
	_                  [512]byte
	FUNC0_OUT_SEL_CFG  volatile.Register32 // 0x554
	FUNC1_OUT_SEL_CFG  volatile.Register32 // 0x558
	FUNC2_OUT_SEL_CFG  volatile.Register32 // 0x55C
	FUNC3_OUT_SEL_CFG  volatile.Register32 // 0x560
	FUNC4_OUT_SEL_CFG  volatile.Register32 // 0x564
	FUNC5_OUT_SEL_CFG  volatile.Register32 // 0x568
	FUNC6_OUT_SEL_CFG  volatile.Register32 // 0x56C
	FUNC7_OUT_SEL_CFG  volatile.Register32 // 0x570
	FUNC8_OUT_SEL_CFG  volatile.Register32 // 0x574
	FUNC9_OUT_SEL_CFG  volatile.Register32 // 0x578
	FUNC10_OUT_SEL_CFG volatile.Register32 // 0x57C
	FUNC11_OUT_SEL_CFG volatile.Register32 // 0x580
	FUNC12_OUT_SEL_CFG volatile.Register32 // 0x584
	FUNC13_OUT_SEL_CFG volatile.Register32 // 0x588
	FUNC14_OUT_SEL_CFG volatile.Register32 // 0x58C
	FUNC15_OUT_SEL_CFG volatile.Register32 // 0x590
	FUNC16_OUT_SEL_CFG volatile.Register32 // 0x594
	FUNC17_OUT_SEL_CFG volatile.Register32 // 0x598
	FUNC18_OUT_SEL_CFG volatile.Register32 // 0x59C
	FUNC19_OUT_SEL_CFG volatile.Register32 // 0x5A0
	FUNC20_OUT_SEL_CFG volatile.Register32 // 0x5A4
	FUNC21_OUT_SEL_CFG volatile.Register32 // 0x5A8
	FUNC22_OUT_SEL_CFG volatile.Register32 // 0x5AC
	FUNC23_OUT_SEL_CFG volatile.Register32 // 0x5B0
	FUNC24_OUT_SEL_CFG volatile.Register32 // 0x5B4
	FUNC25_OUT_SEL_CFG volatile.Register32 // 0x5B8
	_                  [112]byte
	CLOCK_GATE         volatile.Register32 // 0x62C
	_                  [204]byte
	REG_DATE           volatile.Register32 // 0x6FC
}

// GPIO.BT_SELECT: GPIO bit select register
func (o *GPIO_Type) SetBT_SELECT(value uint32) {
	volatile.StoreUint32(&o.BT_SELECT.Reg, value)
}
func (o *GPIO_Type) GetBT_SELECT() uint32 {
	return volatile.LoadUint32(&o.BT_SELECT.Reg)
}

// GPIO.OUT: GPIO output register
func (o *GPIO_Type) SetOUT_DATA_ORIG(value uint32) {
	volatile.StoreUint32(&o.OUT.Reg, volatile.LoadUint32(&o.OUT.Reg)&^(0x3ffffff)|value)
}
func (o *GPIO_Type) GetOUT_DATA_ORIG() uint32 {
	return volatile.LoadUint32(&o.OUT.Reg) & 0x3ffffff
}

// GPIO.OUT_W1TS: GPIO output set register
func (o *GPIO_Type) SetOUT_W1TS(value uint32) {
	volatile.StoreUint32(&o.OUT_W1TS.Reg, volatile.LoadUint32(&o.OUT_W1TS.Reg)&^(0x3ffffff)|value)
}
func (o *GPIO_Type) GetOUT_W1TS() uint32 {
	return volatile.LoadUint32(&o.OUT_W1TS.Reg) & 0x3ffffff
}

// GPIO.OUT_W1TC: GPIO output clear register
func (o *GPIO_Type) SetOUT_W1TC(value uint32) {
	volatile.StoreUint32(&o.OUT_W1TC.Reg, volatile.LoadUint32(&o.OUT_W1TC.Reg)&^(0x3ffffff)|value)
}
func (o *GPIO_Type) GetOUT_W1TC() uint32 {
	return volatile.LoadUint32(&o.OUT_W1TC.Reg) & 0x3ffffff
}

// GPIO.SDIO_SELECT: GPIO sdio select register
func (o *GPIO_Type) SetSDIO_SELECT_SDIO_SEL(value uint32) {
	volatile.StoreUint32(&o.SDIO_SELECT.Reg, volatile.LoadUint32(&o.SDIO_SELECT.Reg)&^(0xff)|value)
}
func (o *GPIO_Type) GetSDIO_SELECT_SDIO_SEL() uint32 {
	return volatile.LoadUint32(&o.SDIO_SELECT.Reg) & 0xff
}

// GPIO.ENABLE: GPIO output enable register
func (o *GPIO_Type) SetENABLE_DATA(value uint32) {
	volatile.StoreUint32(&o.ENABLE.Reg, volatile.LoadUint32(&o.ENABLE.Reg)&^(0x3ffffff)|value)
}
func (o *GPIO_Type) GetENABLE_DATA() uint32 {
	return volatile.LoadUint32(&o.ENABLE.Reg) & 0x3ffffff
}

// GPIO.ENABLE_W1TS: GPIO output enable set register
func (o *GPIO_Type) SetENABLE_W1TS(value uint32) {
	volatile.StoreUint32(&o.ENABLE_W1TS.Reg, volatile.LoadUint32(&o.ENABLE_W1TS.Reg)&^(0x3ffffff)|value)
}
func (o *GPIO_Type) GetENABLE_W1TS() uint32 {
	return volatile.LoadUint32(&o.ENABLE_W1TS.Reg) & 0x3ffffff
}

// GPIO.ENABLE_W1TC: GPIO output enable clear register
func (o *GPIO_Type) SetENABLE_W1TC(value uint32) {
	volatile.StoreUint32(&o.ENABLE_W1TC.Reg, volatile.LoadUint32(&o.ENABLE_W1TC.Reg)&^(0x3ffffff)|value)
}
func (o *GPIO_Type) GetENABLE_W1TC() uint32 {
	return volatile.LoadUint32(&o.ENABLE_W1TC.Reg) & 0x3ffffff
}

// GPIO.STRAP: pad strapping register
func (o *GPIO_Type) SetSTRAP_STRAPPING(value uint32) {
	volatile.StoreUint32(&o.STRAP.Reg, volatile.LoadUint32(&o.STRAP.Reg)&^(0xffff)|value)
}
func (o *GPIO_Type) GetSTRAP_STRAPPING() uint32 {
	return volatile.LoadUint32(&o.STRAP.Reg) & 0xffff
}

// GPIO.IN: GPIO input register
func (o *GPIO_Type) SetIN_DATA_NEXT(value uint32) {
	volatile.StoreUint32(&o.IN.Reg, volatile.LoadUint32(&o.IN.Reg)&^(0x3ffffff)|value)
}
func (o *GPIO_Type) GetIN_DATA_NEXT() uint32 {
	return volatile.LoadUint32(&o.IN.Reg) & 0x3ffffff
}

// GPIO.STATUS: GPIO interrupt status register
func (o *GPIO_Type) SetSTATUS_INTERRUPT(value uint32) {
	volatile.StoreUint32(&o.STATUS.Reg, volatile.LoadUint32(&o.STATUS.Reg)&^(0x3ffffff)|value)
}
func (o *GPIO_Type) GetSTATUS_INTERRUPT() uint32 {
	return volatile.LoadUint32(&o.STATUS.Reg) & 0x3ffffff
}

// GPIO.STATUS_W1TS: GPIO interrupt status set register
func (o *GPIO_Type) SetSTATUS_W1TS(value uint32) {
	volatile.StoreUint32(&o.STATUS_W1TS.Reg, volatile.LoadUint32(&o.STATUS_W1TS.Reg)&^(0x3ffffff)|value)
}
func (o *GPIO_Type) GetSTATUS_W1TS() uint32 {
	return volatile.LoadUint32(&o.STATUS_W1TS.Reg) & 0x3ffffff
}

// GPIO.STATUS_W1TC: GPIO interrupt status clear register
func (o *GPIO_Type) SetSTATUS_W1TC(value uint32) {
	volatile.StoreUint32(&o.STATUS_W1TC.Reg, volatile.LoadUint32(&o.STATUS_W1TC.Reg)&^(0x3ffffff)|value)
}
func (o *GPIO_Type) GetSTATUS_W1TC() uint32 {
	return volatile.LoadUint32(&o.STATUS_W1TC.Reg) & 0x3ffffff
}

// GPIO.PCPU_INT: GPIO PRO_CPU interrupt status register
func (o *GPIO_Type) SetPCPU_INT_PROCPU_INT(value uint32) {
	volatile.StoreUint32(&o.PCPU_INT.Reg, volatile.LoadUint32(&o.PCPU_INT.Reg)&^(0x3ffffff)|value)
}
func (o *GPIO_Type) GetPCPU_INT_PROCPU_INT() uint32 {
	return volatile.LoadUint32(&o.PCPU_INT.Reg) & 0x3ffffff
}

// GPIO.PCPU_NMI_INT: GPIO PRO_CPU(not shielded) interrupt status register
func (o *GPIO_Type) SetPCPU_NMI_INT_PROCPU_NMI_INT(value uint32) {
	volatile.StoreUint32(&o.PCPU_NMI_INT.Reg, volatile.LoadUint32(&o.PCPU_NMI_INT.Reg)&^(0x3ffffff)|value)
}
func (o *GPIO_Type) GetPCPU_NMI_INT_PROCPU_NMI_INT() uint32 {
	return volatile.LoadUint32(&o.PCPU_NMI_INT.Reg) & 0x3ffffff
}

// GPIO.CPUSDIO_INT: GPIO CPUSDIO interrupt status register
func (o *GPIO_Type) SetCPUSDIO_INT_SDIO_INT(value uint32) {
	volatile.StoreUint32(&o.CPUSDIO_INT.Reg, volatile.LoadUint32(&o.CPUSDIO_INT.Reg)&^(0x3ffffff)|value)
}
func (o *GPIO_Type) GetCPUSDIO_INT_SDIO_INT() uint32 {
	return volatile.LoadUint32(&o.CPUSDIO_INT.Reg) & 0x3ffffff
}

// GPIO.PIN0: GPIO pin configuration register
func (o *GPIO_Type) SetPIN0_PIN_SYNC2_BYPASS(value uint32) {
	volatile.StoreUint32(&o.PIN0.Reg, volatile.LoadUint32(&o.PIN0.Reg)&^(0x3)|value)
}
func (o *GPIO_Type) GetPIN0_PIN_SYNC2_BYPASS() uint32 {
	return volatile.LoadUint32(&o.PIN0.Reg) & 0x3
}
func (o *GPIO_Type) SetPIN0_PIN_PAD_DRIVER(value uint32) {
	volatile.StoreUint32(&o.PIN0.Reg, volatile.LoadUint32(&o.PIN0.Reg)&^(0x4)|value<<2)
}
func (o *GPIO_Type) GetPIN0_PIN_PAD_DRIVER() uint32 {
	return (volatile.LoadUint32(&o.PIN0.Reg) & 0x4) >> 2
}
func (o *GPIO_Type) SetPIN0_PIN_SYNC1_BYPASS(value uint32) {
	volatile.StoreUint32(&o.PIN0.Reg, volatile.LoadUint32(&o.PIN0.Reg)&^(0x18)|value<<3)
}
func (o *GPIO_Type) GetPIN0_PIN_SYNC1_BYPASS() uint32 {
	return (volatile.LoadUint32(&o.PIN0.Reg) & 0x18) >> 3
}
func (o *GPIO_Type) SetPIN0_PIN_INT_TYPE(value uint32) {
	volatile.StoreUint32(&o.PIN0.Reg, volatile.LoadUint32(&o.PIN0.Reg)&^(0x380)|value<<7)
}
func (o *GPIO_Type) GetPIN0_PIN_INT_TYPE() uint32 {
	return (volatile.LoadUint32(&o.PIN0.Reg) & 0x380) >> 7
}
func (o *GPIO_Type) SetPIN0_PIN_WAKEUP_ENABLE(value uint32) {
	volatile.StoreUint32(&o.PIN0.Reg, volatile.LoadUint32(&o.PIN0.Reg)&^(0x400)|value<<10)
}
func (o *GPIO_Type) GetPIN0_PIN_WAKEUP_ENABLE() uint32 {
	return (volatile.LoadUint32(&o.PIN0.Reg) & 0x400) >> 10
}
func (o *GPIO_Type) SetPIN0_PIN_CONFIG(value uint32) {
	volatile.StoreUint32(&o.PIN0.Reg, volatile.LoadUint32(&o.PIN0.Reg)&^(0x1800)|value<<11)
}
func (o *GPIO_Type) GetPIN0_PIN_CONFIG() uint32 {
	return (volatile.LoadUint32(&o.PIN0.Reg) & 0x1800) >> 11
}
func (o *GPIO_Type) SetPIN0_PIN_INT_ENA(value uint32) {
	volatile.StoreUint32(&o.PIN0.Reg, volatile.LoadUint32(&o.PIN0.Reg)&^(0x3e000)|value<<13)
}
func (o *GPIO_Type) GetPIN0_PIN_INT_ENA() uint32 {
	return (volatile.LoadUint32(&o.PIN0.Reg) & 0x3e000) >> 13
}

// GPIO.PIN1: GPIO pin configuration register
func (o *GPIO_Type) SetPIN1_PIN_SYNC2_BYPASS(value uint32) {
	volatile.StoreUint32(&o.PIN1.Reg, volatile.LoadUint32(&o.PIN1.Reg)&^(0x3)|value)
}
func (o *GPIO_Type) GetPIN1_PIN_SYNC2_BYPASS() uint32 {
	return volatile.LoadUint32(&o.PIN1.Reg) & 0x3
}
func (o *GPIO_Type) SetPIN1_PIN_PAD_DRIVER(value uint32) {
	volatile.StoreUint32(&o.PIN1.Reg, volatile.LoadUint32(&o.PIN1.Reg)&^(0x4)|value<<2)
}
func (o *GPIO_Type) GetPIN1_PIN_PAD_DRIVER() uint32 {
	return (volatile.LoadUint32(&o.PIN1.Reg) & 0x4) >> 2
}
func (o *GPIO_Type) SetPIN1_PIN_SYNC1_BYPASS(value uint32) {
	volatile.StoreUint32(&o.PIN1.Reg, volatile.LoadUint32(&o.PIN1.Reg)&^(0x18)|value<<3)
}
func (o *GPIO_Type) GetPIN1_PIN_SYNC1_BYPASS() uint32 {
	return (volatile.LoadUint32(&o.PIN1.Reg) & 0x18) >> 3
}
func (o *GPIO_Type) SetPIN1_PIN_INT_TYPE(value uint32) {
	volatile.StoreUint32(&o.PIN1.Reg, volatile.LoadUint32(&o.PIN1.Reg)&^(0x380)|value<<7)
}
func (o *GPIO_Type) GetPIN1_PIN_INT_TYPE() uint32 {
	return (volatile.LoadUint32(&o.PIN1.Reg) & 0x380) >> 7
}
func (o *GPIO_Type) SetPIN1_PIN_WAKEUP_ENABLE(value uint32) {
	volatile.StoreUint32(&o.PIN1.Reg, volatile.LoadUint32(&o.PIN1.Reg)&^(0x400)|value<<10)
}
func (o *GPIO_Type) GetPIN1_PIN_WAKEUP_ENABLE() uint32 {
	return (volatile.LoadUint32(&o.PIN1.Reg) & 0x400) >> 10
}
func (o *GPIO_Type) SetPIN1_PIN_CONFIG(value uint32) {
	volatile.StoreUint32(&o.PIN1.Reg, volatile.LoadUint32(&o.PIN1.Reg)&^(0x1800)|value<<11)
}
func (o *GPIO_Type) GetPIN1_PIN_CONFIG() uint32 {
	return (volatile.LoadUint32(&o.PIN1.Reg) & 0x1800) >> 11
}
func (o *GPIO_Type) SetPIN1_PIN_INT_ENA(value uint32) {
	volatile.StoreUint32(&o.PIN1.Reg, volatile.LoadUint32(&o.PIN1.Reg)&^(0x3e000)|value<<13)
}
func (o *GPIO_Type) GetPIN1_PIN_INT_ENA() uint32 {
	return (volatile.LoadUint32(&o.PIN1.Reg) & 0x3e000) >> 13
}

// GPIO.PIN2: GPIO pin configuration register
func (o *GPIO_Type) SetPIN2_PIN_SYNC2_BYPASS(value uint32) {
	volatile.StoreUint32(&o.PIN2.Reg, volatile.LoadUint32(&o.PIN2.Reg)&^(0x3)|value)
}
func (o *GPIO_Type) GetPIN2_PIN_SYNC2_BYPASS() uint32 {
	return volatile.LoadUint32(&o.PIN2.Reg) & 0x3
}
func (o *GPIO_Type) SetPIN2_PIN_PAD_DRIVER(value uint32) {
	volatile.StoreUint32(&o.PIN2.Reg, volatile.LoadUint32(&o.PIN2.Reg)&^(0x4)|value<<2)
}
func (o *GPIO_Type) GetPIN2_PIN_PAD_DRIVER() uint32 {
	return (volatile.LoadUint32(&o.PIN2.Reg) & 0x4) >> 2
}
func (o *GPIO_Type) SetPIN2_PIN_SYNC1_BYPASS(value uint32) {
	volatile.StoreUint32(&o.PIN2.Reg, volatile.LoadUint32(&o.PIN2.Reg)&^(0x18)|value<<3)
}
func (o *GPIO_Type) GetPIN2_PIN_SYNC1_BYPASS() uint32 {
	return (volatile.LoadUint32(&o.PIN2.Reg) & 0x18) >> 3
}
func (o *GPIO_Type) SetPIN2_PIN_INT_TYPE(value uint32) {
	volatile.StoreUint32(&o.PIN2.Reg, volatile.LoadUint32(&o.PIN2.Reg)&^(0x380)|value<<7)
}
func (o *GPIO_Type) GetPIN2_PIN_INT_TYPE() uint32 {
	return (volatile.LoadUint32(&o.PIN2.Reg) & 0x380) >> 7
}
func (o *GPIO_Type) SetPIN2_PIN_WAKEUP_ENABLE(value uint32) {
	volatile.StoreUint32(&o.PIN2.Reg, volatile.LoadUint32(&o.PIN2.Reg)&^(0x400)|value<<10)
}
func (o *GPIO_Type) GetPIN2_PIN_WAKEUP_ENABLE() uint32 {
	return (volatile.LoadUint32(&o.PIN2.Reg) & 0x400) >> 10
}
func (o *GPIO_Type) SetPIN2_PIN_CONFIG(value uint32) {
	volatile.StoreUint32(&o.PIN2.Reg, volatile.LoadUint32(&o.PIN2.Reg)&^(0x1800)|value<<11)
}
func (o *GPIO_Type) GetPIN2_PIN_CONFIG() uint32 {
	return (volatile.LoadUint32(&o.PIN2.Reg) & 0x1800) >> 11
}
func (o *GPIO_Type) SetPIN2_PIN_INT_ENA(value uint32) {
	volatile.StoreUint32(&o.PIN2.Reg, volatile.LoadUint32(&o.PIN2.Reg)&^(0x3e000)|value<<13)
}
func (o *GPIO_Type) GetPIN2_PIN_INT_ENA() uint32 {
	return (volatile.LoadUint32(&o.PIN2.Reg) & 0x3e000) >> 13
}

// GPIO.PIN3: GPIO pin configuration register
func (o *GPIO_Type) SetPIN3_PIN_SYNC2_BYPASS(value uint32) {
	volatile.StoreUint32(&o.PIN3.Reg, volatile.LoadUint32(&o.PIN3.Reg)&^(0x3)|value)
}
func (o *GPIO_Type) GetPIN3_PIN_SYNC2_BYPASS() uint32 {
	return volatile.LoadUint32(&o.PIN3.Reg) & 0x3
}
func (o *GPIO_Type) SetPIN3_PIN_PAD_DRIVER(value uint32) {
	volatile.StoreUint32(&o.PIN3.Reg, volatile.LoadUint32(&o.PIN3.Reg)&^(0x4)|value<<2)
}
func (o *GPIO_Type) GetPIN3_PIN_PAD_DRIVER() uint32 {
	return (volatile.LoadUint32(&o.PIN3.Reg) & 0x4) >> 2
}
func (o *GPIO_Type) SetPIN3_PIN_SYNC1_BYPASS(value uint32) {
	volatile.StoreUint32(&o.PIN3.Reg, volatile.LoadUint32(&o.PIN3.Reg)&^(0x18)|value<<3)
}
func (o *GPIO_Type) GetPIN3_PIN_SYNC1_BYPASS() uint32 {
	return (volatile.LoadUint32(&o.PIN3.Reg) & 0x18) >> 3
}
func (o *GPIO_Type) SetPIN3_PIN_INT_TYPE(value uint32) {
	volatile.StoreUint32(&o.PIN3.Reg, volatile.LoadUint32(&o.PIN3.Reg)&^(0x380)|value<<7)
}
func (o *GPIO_Type) GetPIN3_PIN_INT_TYPE() uint32 {
	return (volatile.LoadUint32(&o.PIN3.Reg) & 0x380) >> 7
}
func (o *GPIO_Type) SetPIN3_PIN_WAKEUP_ENABLE(value uint32) {
	volatile.StoreUint32(&o.PIN3.Reg, volatile.LoadUint32(&o.PIN3.Reg)&^(0x400)|value<<10)
}
func (o *GPIO_Type) GetPIN3_PIN_WAKEUP_ENABLE() uint32 {
	return (volatile.LoadUint32(&o.PIN3.Reg) & 0x400) >> 10
}
func (o *GPIO_Type) SetPIN3_PIN_CONFIG(value uint32) {
	volatile.StoreUint32(&o.PIN3.Reg, volatile.LoadUint32(&o.PIN3.Reg)&^(0x1800)|value<<11)
}
func (o *GPIO_Type) GetPIN3_PIN_CONFIG() uint32 {
	return (volatile.LoadUint32(&o.PIN3.Reg) & 0x1800) >> 11
}
func (o *GPIO_Type) SetPIN3_PIN_INT_ENA(value uint32) {
	volatile.StoreUint32(&o.PIN3.Reg, volatile.LoadUint32(&o.PIN3.Reg)&^(0x3e000)|value<<13)
}
func (o *GPIO_Type) GetPIN3_PIN_INT_ENA() uint32 {
	return (volatile.LoadUint32(&o.PIN3.Reg) & 0x3e000) >> 13
}

// GPIO.PIN4: GPIO pin configuration register
func (o *GPIO_Type) SetPIN4_PIN_SYNC2_BYPASS(value uint32) {
	volatile.StoreUint32(&o.PIN4.Reg, volatile.LoadUint32(&o.PIN4.Reg)&^(0x3)|value)
}
func (o *GPIO_Type) GetPIN4_PIN_SYNC2_BYPASS() uint32 {
	return volatile.LoadUint32(&o.PIN4.Reg) & 0x3
}
func (o *GPIO_Type) SetPIN4_PIN_PAD_DRIVER(value uint32) {
	volatile.StoreUint32(&o.PIN4.Reg, volatile.LoadUint32(&o.PIN4.Reg)&^(0x4)|value<<2)
}
func (o *GPIO_Type) GetPIN4_PIN_PAD_DRIVER() uint32 {
	return (volatile.LoadUint32(&o.PIN4.Reg) & 0x4) >> 2
}
func (o *GPIO_Type) SetPIN4_PIN_SYNC1_BYPASS(value uint32) {
	volatile.StoreUint32(&o.PIN4.Reg, volatile.LoadUint32(&o.PIN4.Reg)&^(0x18)|value<<3)
}
func (o *GPIO_Type) GetPIN4_PIN_SYNC1_BYPASS() uint32 {
	return (volatile.LoadUint32(&o.PIN4.Reg) & 0x18) >> 3
}
func (o *GPIO_Type) SetPIN4_PIN_INT_TYPE(value uint32) {
	volatile.StoreUint32(&o.PIN4.Reg, volatile.LoadUint32(&o.PIN4.Reg)&^(0x380)|value<<7)
}
func (o *GPIO_Type) GetPIN4_PIN_INT_TYPE() uint32 {
	return (volatile.LoadUint32(&o.PIN4.Reg) & 0x380) >> 7
}
func (o *GPIO_Type) SetPIN4_PIN_WAKEUP_ENABLE(value uint32) {
	volatile.StoreUint32(&o.PIN4.Reg, volatile.LoadUint32(&o.PIN4.Reg)&^(0x400)|value<<10)
}
func (o *GPIO_Type) GetPIN4_PIN_WAKEUP_ENABLE() uint32 {
	return (volatile.LoadUint32(&o.PIN4.Reg) & 0x400) >> 10
}
func (o *GPIO_Type) SetPIN4_PIN_CONFIG(value uint32) {
	volatile.StoreUint32(&o.PIN4.Reg, volatile.LoadUint32(&o.PIN4.Reg)&^(0x1800)|value<<11)
}
func (o *GPIO_Type) GetPIN4_PIN_CONFIG() uint32 {
	return (volatile.LoadUint32(&o.PIN4.Reg) & 0x1800) >> 11
}
func (o *GPIO_Type) SetPIN4_PIN_INT_ENA(value uint32) {
	volatile.StoreUint32(&o.PIN4.Reg, volatile.LoadUint32(&o.PIN4.Reg)&^(0x3e000)|value<<13)
}
func (o *GPIO_Type) GetPIN4_PIN_INT_ENA() uint32 {
	return (volatile.LoadUint32(&o.PIN4.Reg) & 0x3e000) >> 13
}

// GPIO.PIN5: GPIO pin configuration register
func (o *GPIO_Type) SetPIN5_PIN_SYNC2_BYPASS(value uint32) {
	volatile.StoreUint32(&o.PIN5.Reg, volatile.LoadUint32(&o.PIN5.Reg)&^(0x3)|value)
}
func (o *GPIO_Type) GetPIN5_PIN_SYNC2_BYPASS() uint32 {
	return volatile.LoadUint32(&o.PIN5.Reg) & 0x3
}
func (o *GPIO_Type) SetPIN5_PIN_PAD_DRIVER(value uint32) {
	volatile.StoreUint32(&o.PIN5.Reg, volatile.LoadUint32(&o.PIN5.Reg)&^(0x4)|value<<2)
}
func (o *GPIO_Type) GetPIN5_PIN_PAD_DRIVER() uint32 {
	return (volatile.LoadUint32(&o.PIN5.Reg) & 0x4) >> 2
}
func (o *GPIO_Type) SetPIN5_PIN_SYNC1_BYPASS(value uint32) {
	volatile.StoreUint32(&o.PIN5.Reg, volatile.LoadUint32(&o.PIN5.Reg)&^(0x18)|value<<3)
}
func (o *GPIO_Type) GetPIN5_PIN_SYNC1_BYPASS() uint32 {
	return (volatile.LoadUint32(&o.PIN5.Reg) & 0x18) >> 3
}
func (o *GPIO_Type) SetPIN5_PIN_INT_TYPE(value uint32) {
	volatile.StoreUint32(&o.PIN5.Reg, volatile.LoadUint32(&o.PIN5.Reg)&^(0x380)|value<<7)
}
func (o *GPIO_Type) GetPIN5_PIN_INT_TYPE() uint32 {
	return (volatile.LoadUint32(&o.PIN5.Reg) & 0x380) >> 7
}
func (o *GPIO_Type) SetPIN5_PIN_WAKEUP_ENABLE(value uint32) {
	volatile.StoreUint32(&o.PIN5.Reg, volatile.LoadUint32(&o.PIN5.Reg)&^(0x400)|value<<10)
}
func (o *GPIO_Type) GetPIN5_PIN_WAKEUP_ENABLE() uint32 {
	return (volatile.LoadUint32(&o.PIN5.Reg) & 0x400) >> 10
}
func (o *GPIO_Type) SetPIN5_PIN_CONFIG(value uint32) {
	volatile.StoreUint32(&o.PIN5.Reg, volatile.LoadUint32(&o.PIN5.Reg)&^(0x1800)|value<<11)
}
func (o *GPIO_Type) GetPIN5_PIN_CONFIG() uint32 {
	return (volatile.LoadUint32(&o.PIN5.Reg) & 0x1800) >> 11
}
func (o *GPIO_Type) SetPIN5_PIN_INT_ENA(value uint32) {
	volatile.StoreUint32(&o.PIN5.Reg, volatile.LoadUint32(&o.PIN5.Reg)&^(0x3e000)|value<<13)
}
func (o *GPIO_Type) GetPIN5_PIN_INT_ENA() uint32 {
	return (volatile.LoadUint32(&o.PIN5.Reg) & 0x3e000) >> 13
}

// GPIO.PIN6: GPIO pin configuration register
func (o *GPIO_Type) SetPIN6_PIN_SYNC2_BYPASS(value uint32) {
	volatile.StoreUint32(&o.PIN6.Reg, volatile.LoadUint32(&o.PIN6.Reg)&^(0x3)|value)
}
func (o *GPIO_Type) GetPIN6_PIN_SYNC2_BYPASS() uint32 {
	return volatile.LoadUint32(&o.PIN6.Reg) & 0x3
}
func (o *GPIO_Type) SetPIN6_PIN_PAD_DRIVER(value uint32) {
	volatile.StoreUint32(&o.PIN6.Reg, volatile.LoadUint32(&o.PIN6.Reg)&^(0x4)|value<<2)
}
func (o *GPIO_Type) GetPIN6_PIN_PAD_DRIVER() uint32 {
	return (volatile.LoadUint32(&o.PIN6.Reg) & 0x4) >> 2
}
func (o *GPIO_Type) SetPIN6_PIN_SYNC1_BYPASS(value uint32) {
	volatile.StoreUint32(&o.PIN6.Reg, volatile.LoadUint32(&o.PIN6.Reg)&^(0x18)|value<<3)
}
func (o *GPIO_Type) GetPIN6_PIN_SYNC1_BYPASS() uint32 {
	return (volatile.LoadUint32(&o.PIN6.Reg) & 0x18) >> 3
}
func (o *GPIO_Type) SetPIN6_PIN_INT_TYPE(value uint32) {
	volatile.StoreUint32(&o.PIN6.Reg, volatile.LoadUint32(&o.PIN6.Reg)&^(0x380)|value<<7)
}
func (o *GPIO_Type) GetPIN6_PIN_INT_TYPE() uint32 {
	return (volatile.LoadUint32(&o.PIN6.Reg) & 0x380) >> 7
}
func (o *GPIO_Type) SetPIN6_PIN_WAKEUP_ENABLE(value uint32) {
	volatile.StoreUint32(&o.PIN6.Reg, volatile.LoadUint32(&o.PIN6.Reg)&^(0x400)|value<<10)
}
func (o *GPIO_Type) GetPIN6_PIN_WAKEUP_ENABLE() uint32 {
	return (volatile.LoadUint32(&o.PIN6.Reg) & 0x400) >> 10
}
func (o *GPIO_Type) SetPIN6_PIN_CONFIG(value uint32) {
	volatile.StoreUint32(&o.PIN6.Reg, volatile.LoadUint32(&o.PIN6.Reg)&^(0x1800)|value<<11)
}
func (o *GPIO_Type) GetPIN6_PIN_CONFIG() uint32 {
	return (volatile.LoadUint32(&o.PIN6.Reg) & 0x1800) >> 11
}
func (o *GPIO_Type) SetPIN6_PIN_INT_ENA(value uint32) {
	volatile.StoreUint32(&o.PIN6.Reg, volatile.LoadUint32(&o.PIN6.Reg)&^(0x3e000)|value<<13)
}
func (o *GPIO_Type) GetPIN6_PIN_INT_ENA() uint32 {
	return (volatile.LoadUint32(&o.PIN6.Reg) & 0x3e000) >> 13
}

// GPIO.PIN7: GPIO pin configuration register
func (o *GPIO_Type) SetPIN7_PIN_SYNC2_BYPASS(value uint32) {
	volatile.StoreUint32(&o.PIN7.Reg, volatile.LoadUint32(&o.PIN7.Reg)&^(0x3)|value)
}
func (o *GPIO_Type) GetPIN7_PIN_SYNC2_BYPASS() uint32 {
	return volatile.LoadUint32(&o.PIN7.Reg) & 0x3
}
func (o *GPIO_Type) SetPIN7_PIN_PAD_DRIVER(value uint32) {
	volatile.StoreUint32(&o.PIN7.Reg, volatile.LoadUint32(&o.PIN7.Reg)&^(0x4)|value<<2)
}
func (o *GPIO_Type) GetPIN7_PIN_PAD_DRIVER() uint32 {
	return (volatile.LoadUint32(&o.PIN7.Reg) & 0x4) >> 2
}
func (o *GPIO_Type) SetPIN7_PIN_SYNC1_BYPASS(value uint32) {
	volatile.StoreUint32(&o.PIN7.Reg, volatile.LoadUint32(&o.PIN7.Reg)&^(0x18)|value<<3)
}
func (o *GPIO_Type) GetPIN7_PIN_SYNC1_BYPASS() uint32 {
	return (volatile.LoadUint32(&o.PIN7.Reg) & 0x18) >> 3
}
func (o *GPIO_Type) SetPIN7_PIN_INT_TYPE(value uint32) {
	volatile.StoreUint32(&o.PIN7.Reg, volatile.LoadUint32(&o.PIN7.Reg)&^(0x380)|value<<7)
}
func (o *GPIO_Type) GetPIN7_PIN_INT_TYPE() uint32 {
	return (volatile.LoadUint32(&o.PIN7.Reg) & 0x380) >> 7
}
func (o *GPIO_Type) SetPIN7_PIN_WAKEUP_ENABLE(value uint32) {
	volatile.StoreUint32(&o.PIN7.Reg, volatile.LoadUint32(&o.PIN7.Reg)&^(0x400)|value<<10)
}
func (o *GPIO_Type) GetPIN7_PIN_WAKEUP_ENABLE() uint32 {
	return (volatile.LoadUint32(&o.PIN7.Reg) & 0x400) >> 10
}
func (o *GPIO_Type) SetPIN7_PIN_CONFIG(value uint32) {
	volatile.StoreUint32(&o.PIN7.Reg, volatile.LoadUint32(&o.PIN7.Reg)&^(0x1800)|value<<11)
}
func (o *GPIO_Type) GetPIN7_PIN_CONFIG() uint32 {
	return (volatile.LoadUint32(&o.PIN7.Reg) & 0x1800) >> 11
}
func (o *GPIO_Type) SetPIN7_PIN_INT_ENA(value uint32) {
	volatile.StoreUint32(&o.PIN7.Reg, volatile.LoadUint32(&o.PIN7.Reg)&^(0x3e000)|value<<13)
}
func (o *GPIO_Type) GetPIN7_PIN_INT_ENA() uint32 {
	return (volatile.LoadUint32(&o.PIN7.Reg) & 0x3e000) >> 13
}

// GPIO.PIN8: GPIO pin configuration register
func (o *GPIO_Type) SetPIN8_PIN_SYNC2_BYPASS(value uint32) {
	volatile.StoreUint32(&o.PIN8.Reg, volatile.LoadUint32(&o.PIN8.Reg)&^(0x3)|value)
}
func (o *GPIO_Type) GetPIN8_PIN_SYNC2_BYPASS() uint32 {
	return volatile.LoadUint32(&o.PIN8.Reg) & 0x3
}
func (o *GPIO_Type) SetPIN8_PIN_PAD_DRIVER(value uint32) {
	volatile.StoreUint32(&o.PIN8.Reg, volatile.LoadUint32(&o.PIN8.Reg)&^(0x4)|value<<2)
}
func (o *GPIO_Type) GetPIN8_PIN_PAD_DRIVER() uint32 {
	return (volatile.LoadUint32(&o.PIN8.Reg) & 0x4) >> 2
}
func (o *GPIO_Type) SetPIN8_PIN_SYNC1_BYPASS(value uint32) {
	volatile.StoreUint32(&o.PIN8.Reg, volatile.LoadUint32(&o.PIN8.Reg)&^(0x18)|value<<3)
}
func (o *GPIO_Type) GetPIN8_PIN_SYNC1_BYPASS() uint32 {
	return (volatile.LoadUint32(&o.PIN8.Reg) & 0x18) >> 3
}
func (o *GPIO_Type) SetPIN8_PIN_INT_TYPE(value uint32) {
	volatile.StoreUint32(&o.PIN8.Reg, volatile.LoadUint32(&o.PIN8.Reg)&^(0x380)|value<<7)
}
func (o *GPIO_Type) GetPIN8_PIN_INT_TYPE() uint32 {
	return (volatile.LoadUint32(&o.PIN8.Reg) & 0x380) >> 7
}
func (o *GPIO_Type) SetPIN8_PIN_WAKEUP_ENABLE(value uint32) {
	volatile.StoreUint32(&o.PIN8.Reg, volatile.LoadUint32(&o.PIN8.Reg)&^(0x400)|value<<10)
}
func (o *GPIO_Type) GetPIN8_PIN_WAKEUP_ENABLE() uint32 {
	return (volatile.LoadUint32(&o.PIN8.Reg) & 0x400) >> 10
}
func (o *GPIO_Type) SetPIN8_PIN_CONFIG(value uint32) {
	volatile.StoreUint32(&o.PIN8.Reg, volatile.LoadUint32(&o.PIN8.Reg)&^(0x1800)|value<<11)
}
func (o *GPIO_Type) GetPIN8_PIN_CONFIG() uint32 {
	return (volatile.LoadUint32(&o.PIN8.Reg) & 0x1800) >> 11
}
func (o *GPIO_Type) SetPIN8_PIN_INT_ENA(value uint32) {
	volatile.StoreUint32(&o.PIN8.Reg, volatile.LoadUint32(&o.PIN8.Reg)&^(0x3e000)|value<<13)
}
func (o *GPIO_Type) GetPIN8_PIN_INT_ENA() uint32 {
	return (volatile.LoadUint32(&o.PIN8.Reg) & 0x3e000) >> 13
}

// GPIO.PIN9: GPIO pin configuration register
func (o *GPIO_Type) SetPIN9_PIN_SYNC2_BYPASS(value uint32) {
	volatile.StoreUint32(&o.PIN9.Reg, volatile.LoadUint32(&o.PIN9.Reg)&^(0x3)|value)
}
func (o *GPIO_Type) GetPIN9_PIN_SYNC2_BYPASS() uint32 {
	return volatile.LoadUint32(&o.PIN9.Reg) & 0x3
}
func (o *GPIO_Type) SetPIN9_PIN_PAD_DRIVER(value uint32) {
	volatile.StoreUint32(&o.PIN9.Reg, volatile.LoadUint32(&o.PIN9.Reg)&^(0x4)|value<<2)
}
func (o *GPIO_Type) GetPIN9_PIN_PAD_DRIVER() uint32 {
	return (volatile.LoadUint32(&o.PIN9.Reg) & 0x4) >> 2
}
func (o *GPIO_Type) SetPIN9_PIN_SYNC1_BYPASS(value uint32) {
	volatile.StoreUint32(&o.PIN9.Reg, volatile.LoadUint32(&o.PIN9.Reg)&^(0x18)|value<<3)
}
func (o *GPIO_Type) GetPIN9_PIN_SYNC1_BYPASS() uint32 {
	return (volatile.LoadUint32(&o.PIN9.Reg) & 0x18) >> 3
}
func (o *GPIO_Type) SetPIN9_PIN_INT_TYPE(value uint32) {
	volatile.StoreUint32(&o.PIN9.Reg, volatile.LoadUint32(&o.PIN9.Reg)&^(0x380)|value<<7)
}
func (o *GPIO_Type) GetPIN9_PIN_INT_TYPE() uint32 {
	return (volatile.LoadUint32(&o.PIN9.Reg) & 0x380) >> 7
}
func (o *GPIO_Type) SetPIN9_PIN_WAKEUP_ENABLE(value uint32) {
	volatile.StoreUint32(&o.PIN9.Reg, volatile.LoadUint32(&o.PIN9.Reg)&^(0x400)|value<<10)
}
func (o *GPIO_Type) GetPIN9_PIN_WAKEUP_ENABLE() uint32 {
	return (volatile.LoadUint32(&o.PIN9.Reg) & 0x400) >> 10
}
func (o *GPIO_Type) SetPIN9_PIN_CONFIG(value uint32) {
	volatile.StoreUint32(&o.PIN9.Reg, volatile.LoadUint32(&o.PIN9.Reg)&^(0x1800)|value<<11)
}
func (o *GPIO_Type) GetPIN9_PIN_CONFIG() uint32 {
	return (volatile.LoadUint32(&o.PIN9.Reg) & 0x1800) >> 11
}
func (o *GPIO_Type) SetPIN9_PIN_INT_ENA(value uint32) {
	volatile.StoreUint32(&o.PIN9.Reg, volatile.LoadUint32(&o.PIN9.Reg)&^(0x3e000)|value<<13)
}
func (o *GPIO_Type) GetPIN9_PIN_INT_ENA() uint32 {
	return (volatile.LoadUint32(&o.PIN9.Reg) & 0x3e000) >> 13
}

// GPIO.PIN10: GPIO pin configuration register
func (o *GPIO_Type) SetPIN10_PIN_SYNC2_BYPASS(value uint32) {
	volatile.StoreUint32(&o.PIN10.Reg, volatile.LoadUint32(&o.PIN10.Reg)&^(0x3)|value)
}
func (o *GPIO_Type) GetPIN10_PIN_SYNC2_BYPASS() uint32 {
	return volatile.LoadUint32(&o.PIN10.Reg) & 0x3
}
func (o *GPIO_Type) SetPIN10_PIN_PAD_DRIVER(value uint32) {
	volatile.StoreUint32(&o.PIN10.Reg, volatile.LoadUint32(&o.PIN10.Reg)&^(0x4)|value<<2)
}
func (o *GPIO_Type) GetPIN10_PIN_PAD_DRIVER() uint32 {
	return (volatile.LoadUint32(&o.PIN10.Reg) & 0x4) >> 2
}
func (o *GPIO_Type) SetPIN10_PIN_SYNC1_BYPASS(value uint32) {
	volatile.StoreUint32(&o.PIN10.Reg, volatile.LoadUint32(&o.PIN10.Reg)&^(0x18)|value<<3)
}
func (o *GPIO_Type) GetPIN10_PIN_SYNC1_BYPASS() uint32 {
	return (volatile.LoadUint32(&o.PIN10.Reg) & 0x18) >> 3
}
func (o *GPIO_Type) SetPIN10_PIN_INT_TYPE(value uint32) {
	volatile.StoreUint32(&o.PIN10.Reg, volatile.LoadUint32(&o.PIN10.Reg)&^(0x380)|value<<7)
}
func (o *GPIO_Type) GetPIN10_PIN_INT_TYPE() uint32 {
	return (volatile.LoadUint32(&o.PIN10.Reg) & 0x380) >> 7
}
func (o *GPIO_Type) SetPIN10_PIN_WAKEUP_ENABLE(value uint32) {
	volatile.StoreUint32(&o.PIN10.Reg, volatile.LoadUint32(&o.PIN10.Reg)&^(0x400)|value<<10)
}
func (o *GPIO_Type) GetPIN10_PIN_WAKEUP_ENABLE() uint32 {
	return (volatile.LoadUint32(&o.PIN10.Reg) & 0x400) >> 10
}
func (o *GPIO_Type) SetPIN10_PIN_CONFIG(value uint32) {
	volatile.StoreUint32(&o.PIN10.Reg, volatile.LoadUint32(&o.PIN10.Reg)&^(0x1800)|value<<11)
}
func (o *GPIO_Type) GetPIN10_PIN_CONFIG() uint32 {
	return (volatile.LoadUint32(&o.PIN10.Reg) & 0x1800) >> 11
}
func (o *GPIO_Type) SetPIN10_PIN_INT_ENA(value uint32) {
	volatile.StoreUint32(&o.PIN10.Reg, volatile.LoadUint32(&o.PIN10.Reg)&^(0x3e000)|value<<13)
}
func (o *GPIO_Type) GetPIN10_PIN_INT_ENA() uint32 {
	return (volatile.LoadUint32(&o.PIN10.Reg) & 0x3e000) >> 13
}

// GPIO.PIN11: GPIO pin configuration register
func (o *GPIO_Type) SetPIN11_PIN_SYNC2_BYPASS(value uint32) {
	volatile.StoreUint32(&o.PIN11.Reg, volatile.LoadUint32(&o.PIN11.Reg)&^(0x3)|value)
}
func (o *GPIO_Type) GetPIN11_PIN_SYNC2_BYPASS() uint32 {
	return volatile.LoadUint32(&o.PIN11.Reg) & 0x3
}
func (o *GPIO_Type) SetPIN11_PIN_PAD_DRIVER(value uint32) {
	volatile.StoreUint32(&o.PIN11.Reg, volatile.LoadUint32(&o.PIN11.Reg)&^(0x4)|value<<2)
}
func (o *GPIO_Type) GetPIN11_PIN_PAD_DRIVER() uint32 {
	return (volatile.LoadUint32(&o.PIN11.Reg) & 0x4) >> 2
}
func (o *GPIO_Type) SetPIN11_PIN_SYNC1_BYPASS(value uint32) {
	volatile.StoreUint32(&o.PIN11.Reg, volatile.LoadUint32(&o.PIN11.Reg)&^(0x18)|value<<3)
}
func (o *GPIO_Type) GetPIN11_PIN_SYNC1_BYPASS() uint32 {
	return (volatile.LoadUint32(&o.PIN11.Reg) & 0x18) >> 3
}
func (o *GPIO_Type) SetPIN11_PIN_INT_TYPE(value uint32) {
	volatile.StoreUint32(&o.PIN11.Reg, volatile.LoadUint32(&o.PIN11.Reg)&^(0x380)|value<<7)
}
func (o *GPIO_Type) GetPIN11_PIN_INT_TYPE() uint32 {
	return (volatile.LoadUint32(&o.PIN11.Reg) & 0x380) >> 7
}
func (o *GPIO_Type) SetPIN11_PIN_WAKEUP_ENABLE(value uint32) {
	volatile.StoreUint32(&o.PIN11.Reg, volatile.LoadUint32(&o.PIN11.Reg)&^(0x400)|value<<10)
}
func (o *GPIO_Type) GetPIN11_PIN_WAKEUP_ENABLE() uint32 {
	return (volatile.LoadUint32(&o.PIN11.Reg) & 0x400) >> 10
}
func (o *GPIO_Type) SetPIN11_PIN_CONFIG(value uint32) {
	volatile.StoreUint32(&o.PIN11.Reg, volatile.LoadUint32(&o.PIN11.Reg)&^(0x1800)|value<<11)
}
func (o *GPIO_Type) GetPIN11_PIN_CONFIG() uint32 {
	return (volatile.LoadUint32(&o.PIN11.Reg) & 0x1800) >> 11
}
func (o *GPIO_Type) SetPIN11_PIN_INT_ENA(value uint32) {
	volatile.StoreUint32(&o.PIN11.Reg, volatile.LoadUint32(&o.PIN11.Reg)&^(0x3e000)|value<<13)
}
func (o *GPIO_Type) GetPIN11_PIN_INT_ENA() uint32 {
	return (volatile.LoadUint32(&o.PIN11.Reg) & 0x3e000) >> 13
}

// GPIO.PIN12: GPIO pin configuration register
func (o *GPIO_Type) SetPIN12_PIN_SYNC2_BYPASS(value uint32) {
	volatile.StoreUint32(&o.PIN12.Reg, volatile.LoadUint32(&o.PIN12.Reg)&^(0x3)|value)
}
func (o *GPIO_Type) GetPIN12_PIN_SYNC2_BYPASS() uint32 {
	return volatile.LoadUint32(&o.PIN12.Reg) & 0x3
}
func (o *GPIO_Type) SetPIN12_PIN_PAD_DRIVER(value uint32) {
	volatile.StoreUint32(&o.PIN12.Reg, volatile.LoadUint32(&o.PIN12.Reg)&^(0x4)|value<<2)
}
func (o *GPIO_Type) GetPIN12_PIN_PAD_DRIVER() uint32 {
	return (volatile.LoadUint32(&o.PIN12.Reg) & 0x4) >> 2
}
func (o *GPIO_Type) SetPIN12_PIN_SYNC1_BYPASS(value uint32) {
	volatile.StoreUint32(&o.PIN12.Reg, volatile.LoadUint32(&o.PIN12.Reg)&^(0x18)|value<<3)
}
func (o *GPIO_Type) GetPIN12_PIN_SYNC1_BYPASS() uint32 {
	return (volatile.LoadUint32(&o.PIN12.Reg) & 0x18) >> 3
}
func (o *GPIO_Type) SetPIN12_PIN_INT_TYPE(value uint32) {
	volatile.StoreUint32(&o.PIN12.Reg, volatile.LoadUint32(&o.PIN12.Reg)&^(0x380)|value<<7)
}
func (o *GPIO_Type) GetPIN12_PIN_INT_TYPE() uint32 {
	return (volatile.LoadUint32(&o.PIN12.Reg) & 0x380) >> 7
}
func (o *GPIO_Type) SetPIN12_PIN_WAKEUP_ENABLE(value uint32) {
	volatile.StoreUint32(&o.PIN12.Reg, volatile.LoadUint32(&o.PIN12.Reg)&^(0x400)|value<<10)
}
func (o *GPIO_Type) GetPIN12_PIN_WAKEUP_ENABLE() uint32 {
	return (volatile.LoadUint32(&o.PIN12.Reg) & 0x400) >> 10
}
func (o *GPIO_Type) SetPIN12_PIN_CONFIG(value uint32) {
	volatile.StoreUint32(&o.PIN12.Reg, volatile.LoadUint32(&o.PIN12.Reg)&^(0x1800)|value<<11)
}
func (o *GPIO_Type) GetPIN12_PIN_CONFIG() uint32 {
	return (volatile.LoadUint32(&o.PIN12.Reg) & 0x1800) >> 11
}
func (o *GPIO_Type) SetPIN12_PIN_INT_ENA(value uint32) {
	volatile.StoreUint32(&o.PIN12.Reg, volatile.LoadUint32(&o.PIN12.Reg)&^(0x3e000)|value<<13)
}
func (o *GPIO_Type) GetPIN12_PIN_INT_ENA() uint32 {
	return (volatile.LoadUint32(&o.PIN12.Reg) & 0x3e000) >> 13
}

// GPIO.PIN13: GPIO pin configuration register
func (o *GPIO_Type) SetPIN13_PIN_SYNC2_BYPASS(value uint32) {
	volatile.StoreUint32(&o.PIN13.Reg, volatile.LoadUint32(&o.PIN13.Reg)&^(0x3)|value)
}
func (o *GPIO_Type) GetPIN13_PIN_SYNC2_BYPASS() uint32 {
	return volatile.LoadUint32(&o.PIN13.Reg) & 0x3
}
func (o *GPIO_Type) SetPIN13_PIN_PAD_DRIVER(value uint32) {
	volatile.StoreUint32(&o.PIN13.Reg, volatile.LoadUint32(&o.PIN13.Reg)&^(0x4)|value<<2)
}
func (o *GPIO_Type) GetPIN13_PIN_PAD_DRIVER() uint32 {
	return (volatile.LoadUint32(&o.PIN13.Reg) & 0x4) >> 2
}
func (o *GPIO_Type) SetPIN13_PIN_SYNC1_BYPASS(value uint32) {
	volatile.StoreUint32(&o.PIN13.Reg, volatile.LoadUint32(&o.PIN13.Reg)&^(0x18)|value<<3)
}
func (o *GPIO_Type) GetPIN13_PIN_SYNC1_BYPASS() uint32 {
	return (volatile.LoadUint32(&o.PIN13.Reg) & 0x18) >> 3
}
func (o *GPIO_Type) SetPIN13_PIN_INT_TYPE(value uint32) {
	volatile.StoreUint32(&o.PIN13.Reg, volatile.LoadUint32(&o.PIN13.Reg)&^(0x380)|value<<7)
}
func (o *GPIO_Type) GetPIN13_PIN_INT_TYPE() uint32 {
	return (volatile.LoadUint32(&o.PIN13.Reg) & 0x380) >> 7
}
func (o *GPIO_Type) SetPIN13_PIN_WAKEUP_ENABLE(value uint32) {
	volatile.StoreUint32(&o.PIN13.Reg, volatile.LoadUint32(&o.PIN13.Reg)&^(0x400)|value<<10)
}
func (o *GPIO_Type) GetPIN13_PIN_WAKEUP_ENABLE() uint32 {
	return (volatile.LoadUint32(&o.PIN13.Reg) & 0x400) >> 10
}
func (o *GPIO_Type) SetPIN13_PIN_CONFIG(value uint32) {
	volatile.StoreUint32(&o.PIN13.Reg, volatile.LoadUint32(&o.PIN13.Reg)&^(0x1800)|value<<11)
}
func (o *GPIO_Type) GetPIN13_PIN_CONFIG() uint32 {
	return (volatile.LoadUint32(&o.PIN13.Reg) & 0x1800) >> 11
}
func (o *GPIO_Type) SetPIN13_PIN_INT_ENA(value uint32) {
	volatile.StoreUint32(&o.PIN13.Reg, volatile.LoadUint32(&o.PIN13.Reg)&^(0x3e000)|value<<13)
}
func (o *GPIO_Type) GetPIN13_PIN_INT_ENA() uint32 {
	return (volatile.LoadUint32(&o.PIN13.Reg) & 0x3e000) >> 13
}

// GPIO.PIN14: GPIO pin configuration register
func (o *GPIO_Type) SetPIN14_PIN_SYNC2_BYPASS(value uint32) {
	volatile.StoreUint32(&o.PIN14.Reg, volatile.LoadUint32(&o.PIN14.Reg)&^(0x3)|value)
}
func (o *GPIO_Type) GetPIN14_PIN_SYNC2_BYPASS() uint32 {
	return volatile.LoadUint32(&o.PIN14.Reg) & 0x3
}
func (o *GPIO_Type) SetPIN14_PIN_PAD_DRIVER(value uint32) {
	volatile.StoreUint32(&o.PIN14.Reg, volatile.LoadUint32(&o.PIN14.Reg)&^(0x4)|value<<2)
}
func (o *GPIO_Type) GetPIN14_PIN_PAD_DRIVER() uint32 {
	return (volatile.LoadUint32(&o.PIN14.Reg) & 0x4) >> 2
}
func (o *GPIO_Type) SetPIN14_PIN_SYNC1_BYPASS(value uint32) {
	volatile.StoreUint32(&o.PIN14.Reg, volatile.LoadUint32(&o.PIN14.Reg)&^(0x18)|value<<3)
}
func (o *GPIO_Type) GetPIN14_PIN_SYNC1_BYPASS() uint32 {
	return (volatile.LoadUint32(&o.PIN14.Reg) & 0x18) >> 3
}
func (o *GPIO_Type) SetPIN14_PIN_INT_TYPE(value uint32) {
	volatile.StoreUint32(&o.PIN14.Reg, volatile.LoadUint32(&o.PIN14.Reg)&^(0x380)|value<<7)
}
func (o *GPIO_Type) GetPIN14_PIN_INT_TYPE() uint32 {
	return (volatile.LoadUint32(&o.PIN14.Reg) & 0x380) >> 7
}
func (o *GPIO_Type) SetPIN14_PIN_WAKEUP_ENABLE(value uint32) {
	volatile.StoreUint32(&o.PIN14.Reg, volatile.LoadUint32(&o.PIN14.Reg)&^(0x400)|value<<10)
}
func (o *GPIO_Type) GetPIN14_PIN_WAKEUP_ENABLE() uint32 {
	return (volatile.LoadUint32(&o.PIN14.Reg) & 0x400) >> 10
}
func (o *GPIO_Type) SetPIN14_PIN_CONFIG(value uint32) {
	volatile.StoreUint32(&o.PIN14.Reg, volatile.LoadUint32(&o.PIN14.Reg)&^(0x1800)|value<<11)
}
func (o *GPIO_Type) GetPIN14_PIN_CONFIG() uint32 {
	return (volatile.LoadUint32(&o.PIN14.Reg) & 0x1800) >> 11
}
func (o *GPIO_Type) SetPIN14_PIN_INT_ENA(value uint32) {
	volatile.StoreUint32(&o.PIN14.Reg, volatile.LoadUint32(&o.PIN14.Reg)&^(0x3e000)|value<<13)
}
func (o *GPIO_Type) GetPIN14_PIN_INT_ENA() uint32 {
	return (volatile.LoadUint32(&o.PIN14.Reg) & 0x3e000) >> 13
}

// GPIO.PIN15: GPIO pin configuration register
func (o *GPIO_Type) SetPIN15_PIN_SYNC2_BYPASS(value uint32) {
	volatile.StoreUint32(&o.PIN15.Reg, volatile.LoadUint32(&o.PIN15.Reg)&^(0x3)|value)
}
func (o *GPIO_Type) GetPIN15_PIN_SYNC2_BYPASS() uint32 {
	return volatile.LoadUint32(&o.PIN15.Reg) & 0x3
}
func (o *GPIO_Type) SetPIN15_PIN_PAD_DRIVER(value uint32) {
	volatile.StoreUint32(&o.PIN15.Reg, volatile.LoadUint32(&o.PIN15.Reg)&^(0x4)|value<<2)
}
func (o *GPIO_Type) GetPIN15_PIN_PAD_DRIVER() uint32 {
	return (volatile.LoadUint32(&o.PIN15.Reg) & 0x4) >> 2
}
func (o *GPIO_Type) SetPIN15_PIN_SYNC1_BYPASS(value uint32) {
	volatile.StoreUint32(&o.PIN15.Reg, volatile.LoadUint32(&o.PIN15.Reg)&^(0x18)|value<<3)
}
func (o *GPIO_Type) GetPIN15_PIN_SYNC1_BYPASS() uint32 {
	return (volatile.LoadUint32(&o.PIN15.Reg) & 0x18) >> 3
}
func (o *GPIO_Type) SetPIN15_PIN_INT_TYPE(value uint32) {
	volatile.StoreUint32(&o.PIN15.Reg, volatile.LoadUint32(&o.PIN15.Reg)&^(0x380)|value<<7)
}
func (o *GPIO_Type) GetPIN15_PIN_INT_TYPE() uint32 {
	return (volatile.LoadUint32(&o.PIN15.Reg) & 0x380) >> 7
}
func (o *GPIO_Type) SetPIN15_PIN_WAKEUP_ENABLE(value uint32) {
	volatile.StoreUint32(&o.PIN15.Reg, volatile.LoadUint32(&o.PIN15.Reg)&^(0x400)|value<<10)
}
func (o *GPIO_Type) GetPIN15_PIN_WAKEUP_ENABLE() uint32 {
	return (volatile.LoadUint32(&o.PIN15.Reg) & 0x400) >> 10
}
func (o *GPIO_Type) SetPIN15_PIN_CONFIG(value uint32) {
	volatile.StoreUint32(&o.PIN15.Reg, volatile.LoadUint32(&o.PIN15.Reg)&^(0x1800)|value<<11)
}
func (o *GPIO_Type) GetPIN15_PIN_CONFIG() uint32 {
	return (volatile.LoadUint32(&o.PIN15.Reg) & 0x1800) >> 11
}
func (o *GPIO_Type) SetPIN15_PIN_INT_ENA(value uint32) {
	volatile.StoreUint32(&o.PIN15.Reg, volatile.LoadUint32(&o.PIN15.Reg)&^(0x3e000)|value<<13)
}
func (o *GPIO_Type) GetPIN15_PIN_INT_ENA() uint32 {
	return (volatile.LoadUint32(&o.PIN15.Reg) & 0x3e000) >> 13
}

// GPIO.PIN16: GPIO pin configuration register
func (o *GPIO_Type) SetPIN16_PIN_SYNC2_BYPASS(value uint32) {
	volatile.StoreUint32(&o.PIN16.Reg, volatile.LoadUint32(&o.PIN16.Reg)&^(0x3)|value)
}
func (o *GPIO_Type) GetPIN16_PIN_SYNC2_BYPASS() uint32 {
	return volatile.LoadUint32(&o.PIN16.Reg) & 0x3
}
func (o *GPIO_Type) SetPIN16_PIN_PAD_DRIVER(value uint32) {
	volatile.StoreUint32(&o.PIN16.Reg, volatile.LoadUint32(&o.PIN16.Reg)&^(0x4)|value<<2)
}
func (o *GPIO_Type) GetPIN16_PIN_PAD_DRIVER() uint32 {
	return (volatile.LoadUint32(&o.PIN16.Reg) & 0x4) >> 2
}
func (o *GPIO_Type) SetPIN16_PIN_SYNC1_BYPASS(value uint32) {
	volatile.StoreUint32(&o.PIN16.Reg, volatile.LoadUint32(&o.PIN16.Reg)&^(0x18)|value<<3)
}
func (o *GPIO_Type) GetPIN16_PIN_SYNC1_BYPASS() uint32 {
	return (volatile.LoadUint32(&o.PIN16.Reg) & 0x18) >> 3
}
func (o *GPIO_Type) SetPIN16_PIN_INT_TYPE(value uint32) {
	volatile.StoreUint32(&o.PIN16.Reg, volatile.LoadUint32(&o.PIN16.Reg)&^(0x380)|value<<7)
}
func (o *GPIO_Type) GetPIN16_PIN_INT_TYPE() uint32 {
	return (volatile.LoadUint32(&o.PIN16.Reg) & 0x380) >> 7
}
func (o *GPIO_Type) SetPIN16_PIN_WAKEUP_ENABLE(value uint32) {
	volatile.StoreUint32(&o.PIN16.Reg, volatile.LoadUint32(&o.PIN16.Reg)&^(0x400)|value<<10)
}
func (o *GPIO_Type) GetPIN16_PIN_WAKEUP_ENABLE() uint32 {
	return (volatile.LoadUint32(&o.PIN16.Reg) & 0x400) >> 10
}
func (o *GPIO_Type) SetPIN16_PIN_CONFIG(value uint32) {
	volatile.StoreUint32(&o.PIN16.Reg, volatile.LoadUint32(&o.PIN16.Reg)&^(0x1800)|value<<11)
}
func (o *GPIO_Type) GetPIN16_PIN_CONFIG() uint32 {
	return (volatile.LoadUint32(&o.PIN16.Reg) & 0x1800) >> 11
}
func (o *GPIO_Type) SetPIN16_PIN_INT_ENA(value uint32) {
	volatile.StoreUint32(&o.PIN16.Reg, volatile.LoadUint32(&o.PIN16.Reg)&^(0x3e000)|value<<13)
}
func (o *GPIO_Type) GetPIN16_PIN_INT_ENA() uint32 {
	return (volatile.LoadUint32(&o.PIN16.Reg) & 0x3e000) >> 13
}

// GPIO.PIN17: GPIO pin configuration register
func (o *GPIO_Type) SetPIN17_PIN_SYNC2_BYPASS(value uint32) {
	volatile.StoreUint32(&o.PIN17.Reg, volatile.LoadUint32(&o.PIN17.Reg)&^(0x3)|value)
}
func (o *GPIO_Type) GetPIN17_PIN_SYNC2_BYPASS() uint32 {
	return volatile.LoadUint32(&o.PIN17.Reg) & 0x3
}
func (o *GPIO_Type) SetPIN17_PIN_PAD_DRIVER(value uint32) {
	volatile.StoreUint32(&o.PIN17.Reg, volatile.LoadUint32(&o.PIN17.Reg)&^(0x4)|value<<2)
}
func (o *GPIO_Type) GetPIN17_PIN_PAD_DRIVER() uint32 {
	return (volatile.LoadUint32(&o.PIN17.Reg) & 0x4) >> 2
}
func (o *GPIO_Type) SetPIN17_PIN_SYNC1_BYPASS(value uint32) {
	volatile.StoreUint32(&o.PIN17.Reg, volatile.LoadUint32(&o.PIN17.Reg)&^(0x18)|value<<3)
}
func (o *GPIO_Type) GetPIN17_PIN_SYNC1_BYPASS() uint32 {
	return (volatile.LoadUint32(&o.PIN17.Reg) & 0x18) >> 3
}
func (o *GPIO_Type) SetPIN17_PIN_INT_TYPE(value uint32) {
	volatile.StoreUint32(&o.PIN17.Reg, volatile.LoadUint32(&o.PIN17.Reg)&^(0x380)|value<<7)
}
func (o *GPIO_Type) GetPIN17_PIN_INT_TYPE() uint32 {
	return (volatile.LoadUint32(&o.PIN17.Reg) & 0x380) >> 7
}
func (o *GPIO_Type) SetPIN17_PIN_WAKEUP_ENABLE(value uint32) {
	volatile.StoreUint32(&o.PIN17.Reg, volatile.LoadUint32(&o.PIN17.Reg)&^(0x400)|value<<10)
}
func (o *GPIO_Type) GetPIN17_PIN_WAKEUP_ENABLE() uint32 {
	return (volatile.LoadUint32(&o.PIN17.Reg) & 0x400) >> 10
}
func (o *GPIO_Type) SetPIN17_PIN_CONFIG(value uint32) {
	volatile.StoreUint32(&o.PIN17.Reg, volatile.LoadUint32(&o.PIN17.Reg)&^(0x1800)|value<<11)
}
func (o *GPIO_Type) GetPIN17_PIN_CONFIG() uint32 {
	return (volatile.LoadUint32(&o.PIN17.Reg) & 0x1800) >> 11
}
func (o *GPIO_Type) SetPIN17_PIN_INT_ENA(value uint32) {
	volatile.StoreUint32(&o.PIN17.Reg, volatile.LoadUint32(&o.PIN17.Reg)&^(0x3e000)|value<<13)
}
func (o *GPIO_Type) GetPIN17_PIN_INT_ENA() uint32 {
	return (volatile.LoadUint32(&o.PIN17.Reg) & 0x3e000) >> 13
}

// GPIO.PIN18: GPIO pin configuration register
func (o *GPIO_Type) SetPIN18_PIN_SYNC2_BYPASS(value uint32) {
	volatile.StoreUint32(&o.PIN18.Reg, volatile.LoadUint32(&o.PIN18.Reg)&^(0x3)|value)
}
func (o *GPIO_Type) GetPIN18_PIN_SYNC2_BYPASS() uint32 {
	return volatile.LoadUint32(&o.PIN18.Reg) & 0x3
}
func (o *GPIO_Type) SetPIN18_PIN_PAD_DRIVER(value uint32) {
	volatile.StoreUint32(&o.PIN18.Reg, volatile.LoadUint32(&o.PIN18.Reg)&^(0x4)|value<<2)
}
func (o *GPIO_Type) GetPIN18_PIN_PAD_DRIVER() uint32 {
	return (volatile.LoadUint32(&o.PIN18.Reg) & 0x4) >> 2
}
func (o *GPIO_Type) SetPIN18_PIN_SYNC1_BYPASS(value uint32) {
	volatile.StoreUint32(&o.PIN18.Reg, volatile.LoadUint32(&o.PIN18.Reg)&^(0x18)|value<<3)
}
func (o *GPIO_Type) GetPIN18_PIN_SYNC1_BYPASS() uint32 {
	return (volatile.LoadUint32(&o.PIN18.Reg) & 0x18) >> 3
}
func (o *GPIO_Type) SetPIN18_PIN_INT_TYPE(value uint32) {
	volatile.StoreUint32(&o.PIN18.Reg, volatile.LoadUint32(&o.PIN18.Reg)&^(0x380)|value<<7)
}
func (o *GPIO_Type) GetPIN18_PIN_INT_TYPE() uint32 {
	return (volatile.LoadUint32(&o.PIN18.Reg) & 0x380) >> 7
}
func (o *GPIO_Type) SetPIN18_PIN_WAKEUP_ENABLE(value uint32) {
	volatile.StoreUint32(&o.PIN18.Reg, volatile.LoadUint32(&o.PIN18.Reg)&^(0x400)|value<<10)
}
func (o *GPIO_Type) GetPIN18_PIN_WAKEUP_ENABLE() uint32 {
	return (volatile.LoadUint32(&o.PIN18.Reg) & 0x400) >> 10
}
func (o *GPIO_Type) SetPIN18_PIN_CONFIG(value uint32) {
	volatile.StoreUint32(&o.PIN18.Reg, volatile.LoadUint32(&o.PIN18.Reg)&^(0x1800)|value<<11)
}
func (o *GPIO_Type) GetPIN18_PIN_CONFIG() uint32 {
	return (volatile.LoadUint32(&o.PIN18.Reg) & 0x1800) >> 11
}
func (o *GPIO_Type) SetPIN18_PIN_INT_ENA(value uint32) {
	volatile.StoreUint32(&o.PIN18.Reg, volatile.LoadUint32(&o.PIN18.Reg)&^(0x3e000)|value<<13)
}
func (o *GPIO_Type) GetPIN18_PIN_INT_ENA() uint32 {
	return (volatile.LoadUint32(&o.PIN18.Reg) & 0x3e000) >> 13
}

// GPIO.PIN19: GPIO pin configuration register
func (o *GPIO_Type) SetPIN19_PIN_SYNC2_BYPASS(value uint32) {
	volatile.StoreUint32(&o.PIN19.Reg, volatile.LoadUint32(&o.PIN19.Reg)&^(0x3)|value)
}
func (o *GPIO_Type) GetPIN19_PIN_SYNC2_BYPASS() uint32 {
	return volatile.LoadUint32(&o.PIN19.Reg) & 0x3
}
func (o *GPIO_Type) SetPIN19_PIN_PAD_DRIVER(value uint32) {
	volatile.StoreUint32(&o.PIN19.Reg, volatile.LoadUint32(&o.PIN19.Reg)&^(0x4)|value<<2)
}
func (o *GPIO_Type) GetPIN19_PIN_PAD_DRIVER() uint32 {
	return (volatile.LoadUint32(&o.PIN19.Reg) & 0x4) >> 2
}
func (o *GPIO_Type) SetPIN19_PIN_SYNC1_BYPASS(value uint32) {
	volatile.StoreUint32(&o.PIN19.Reg, volatile.LoadUint32(&o.PIN19.Reg)&^(0x18)|value<<3)
}
func (o *GPIO_Type) GetPIN19_PIN_SYNC1_BYPASS() uint32 {
	return (volatile.LoadUint32(&o.PIN19.Reg) & 0x18) >> 3
}
func (o *GPIO_Type) SetPIN19_PIN_INT_TYPE(value uint32) {
	volatile.StoreUint32(&o.PIN19.Reg, volatile.LoadUint32(&o.PIN19.Reg)&^(0x380)|value<<7)
}
func (o *GPIO_Type) GetPIN19_PIN_INT_TYPE() uint32 {
	return (volatile.LoadUint32(&o.PIN19.Reg) & 0x380) >> 7
}
func (o *GPIO_Type) SetPIN19_PIN_WAKEUP_ENABLE(value uint32) {
	volatile.StoreUint32(&o.PIN19.Reg, volatile.LoadUint32(&o.PIN19.Reg)&^(0x400)|value<<10)
}
func (o *GPIO_Type) GetPIN19_PIN_WAKEUP_ENABLE() uint32 {
	return (volatile.LoadUint32(&o.PIN19.Reg) & 0x400) >> 10
}
func (o *GPIO_Type) SetPIN19_PIN_CONFIG(value uint32) {
	volatile.StoreUint32(&o.PIN19.Reg, volatile.LoadUint32(&o.PIN19.Reg)&^(0x1800)|value<<11)
}
func (o *GPIO_Type) GetPIN19_PIN_CONFIG() uint32 {
	return (volatile.LoadUint32(&o.PIN19.Reg) & 0x1800) >> 11
}
func (o *GPIO_Type) SetPIN19_PIN_INT_ENA(value uint32) {
	volatile.StoreUint32(&o.PIN19.Reg, volatile.LoadUint32(&o.PIN19.Reg)&^(0x3e000)|value<<13)
}
func (o *GPIO_Type) GetPIN19_PIN_INT_ENA() uint32 {
	return (volatile.LoadUint32(&o.PIN19.Reg) & 0x3e000) >> 13
}

// GPIO.PIN20: GPIO pin configuration register
func (o *GPIO_Type) SetPIN20_PIN_SYNC2_BYPASS(value uint32) {
	volatile.StoreUint32(&o.PIN20.Reg, volatile.LoadUint32(&o.PIN20.Reg)&^(0x3)|value)
}
func (o *GPIO_Type) GetPIN20_PIN_SYNC2_BYPASS() uint32 {
	return volatile.LoadUint32(&o.PIN20.Reg) & 0x3
}
func (o *GPIO_Type) SetPIN20_PIN_PAD_DRIVER(value uint32) {
	volatile.StoreUint32(&o.PIN20.Reg, volatile.LoadUint32(&o.PIN20.Reg)&^(0x4)|value<<2)
}
func (o *GPIO_Type) GetPIN20_PIN_PAD_DRIVER() uint32 {
	return (volatile.LoadUint32(&o.PIN20.Reg) & 0x4) >> 2
}
func (o *GPIO_Type) SetPIN20_PIN_SYNC1_BYPASS(value uint32) {
	volatile.StoreUint32(&o.PIN20.Reg, volatile.LoadUint32(&o.PIN20.Reg)&^(0x18)|value<<3)
}
func (o *GPIO_Type) GetPIN20_PIN_SYNC1_BYPASS() uint32 {
	return (volatile.LoadUint32(&o.PIN20.Reg) & 0x18) >> 3
}
func (o *GPIO_Type) SetPIN20_PIN_INT_TYPE(value uint32) {
	volatile.StoreUint32(&o.PIN20.Reg, volatile.LoadUint32(&o.PIN20.Reg)&^(0x380)|value<<7)
}
func (o *GPIO_Type) GetPIN20_PIN_INT_TYPE() uint32 {
	return (volatile.LoadUint32(&o.PIN20.Reg) & 0x380) >> 7
}
func (o *GPIO_Type) SetPIN20_PIN_WAKEUP_ENABLE(value uint32) {
	volatile.StoreUint32(&o.PIN20.Reg, volatile.LoadUint32(&o.PIN20.Reg)&^(0x400)|value<<10)
}
func (o *GPIO_Type) GetPIN20_PIN_WAKEUP_ENABLE() uint32 {
	return (volatile.LoadUint32(&o.PIN20.Reg) & 0x400) >> 10
}
func (o *GPIO_Type) SetPIN20_PIN_CONFIG(value uint32) {
	volatile.StoreUint32(&o.PIN20.Reg, volatile.LoadUint32(&o.PIN20.Reg)&^(0x1800)|value<<11)
}
func (o *GPIO_Type) GetPIN20_PIN_CONFIG() uint32 {
	return (volatile.LoadUint32(&o.PIN20.Reg) & 0x1800) >> 11
}
func (o *GPIO_Type) SetPIN20_PIN_INT_ENA(value uint32) {
	volatile.StoreUint32(&o.PIN20.Reg, volatile.LoadUint32(&o.PIN20.Reg)&^(0x3e000)|value<<13)
}
func (o *GPIO_Type) GetPIN20_PIN_INT_ENA() uint32 {
	return (volatile.LoadUint32(&o.PIN20.Reg) & 0x3e000) >> 13
}

// GPIO.PIN21: GPIO pin configuration register
func (o *GPIO_Type) SetPIN21_PIN_SYNC2_BYPASS(value uint32) {
	volatile.StoreUint32(&o.PIN21.Reg, volatile.LoadUint32(&o.PIN21.Reg)&^(0x3)|value)
}
func (o *GPIO_Type) GetPIN21_PIN_SYNC2_BYPASS() uint32 {
	return volatile.LoadUint32(&o.PIN21.Reg) & 0x3
}
func (o *GPIO_Type) SetPIN21_PIN_PAD_DRIVER(value uint32) {
	volatile.StoreUint32(&o.PIN21.Reg, volatile.LoadUint32(&o.PIN21.Reg)&^(0x4)|value<<2)
}
func (o *GPIO_Type) GetPIN21_PIN_PAD_DRIVER() uint32 {
	return (volatile.LoadUint32(&o.PIN21.Reg) & 0x4) >> 2
}
func (o *GPIO_Type) SetPIN21_PIN_SYNC1_BYPASS(value uint32) {
	volatile.StoreUint32(&o.PIN21.Reg, volatile.LoadUint32(&o.PIN21.Reg)&^(0x18)|value<<3)
}
func (o *GPIO_Type) GetPIN21_PIN_SYNC1_BYPASS() uint32 {
	return (volatile.LoadUint32(&o.PIN21.Reg) & 0x18) >> 3
}
func (o *GPIO_Type) SetPIN21_PIN_INT_TYPE(value uint32) {
	volatile.StoreUint32(&o.PIN21.Reg, volatile.LoadUint32(&o.PIN21.Reg)&^(0x380)|value<<7)
}
func (o *GPIO_Type) GetPIN21_PIN_INT_TYPE() uint32 {
	return (volatile.LoadUint32(&o.PIN21.Reg) & 0x380) >> 7
}
func (o *GPIO_Type) SetPIN21_PIN_WAKEUP_ENABLE(value uint32) {
	volatile.StoreUint32(&o.PIN21.Reg, volatile.LoadUint32(&o.PIN21.Reg)&^(0x400)|value<<10)
}
func (o *GPIO_Type) GetPIN21_PIN_WAKEUP_ENABLE() uint32 {
	return (volatile.LoadUint32(&o.PIN21.Reg) & 0x400) >> 10
}
func (o *GPIO_Type) SetPIN21_PIN_CONFIG(value uint32) {
	volatile.StoreUint32(&o.PIN21.Reg, volatile.LoadUint32(&o.PIN21.Reg)&^(0x1800)|value<<11)
}
func (o *GPIO_Type) GetPIN21_PIN_CONFIG() uint32 {
	return (volatile.LoadUint32(&o.PIN21.Reg) & 0x1800) >> 11
}
func (o *GPIO_Type) SetPIN21_PIN_INT_ENA(value uint32) {
	volatile.StoreUint32(&o.PIN21.Reg, volatile.LoadUint32(&o.PIN21.Reg)&^(0x3e000)|value<<13)
}
func (o *GPIO_Type) GetPIN21_PIN_INT_ENA() uint32 {
	return (volatile.LoadUint32(&o.PIN21.Reg) & 0x3e000) >> 13
}

// GPIO.PIN22: GPIO pin configuration register
func (o *GPIO_Type) SetPIN22_PIN_SYNC2_BYPASS(value uint32) {
	volatile.StoreUint32(&o.PIN22.Reg, volatile.LoadUint32(&o.PIN22.Reg)&^(0x3)|value)
}
func (o *GPIO_Type) GetPIN22_PIN_SYNC2_BYPASS() uint32 {
	return volatile.LoadUint32(&o.PIN22.Reg) & 0x3
}
func (o *GPIO_Type) SetPIN22_PIN_PAD_DRIVER(value uint32) {
	volatile.StoreUint32(&o.PIN22.Reg, volatile.LoadUint32(&o.PIN22.Reg)&^(0x4)|value<<2)
}
func (o *GPIO_Type) GetPIN22_PIN_PAD_DRIVER() uint32 {
	return (volatile.LoadUint32(&o.PIN22.Reg) & 0x4) >> 2
}
func (o *GPIO_Type) SetPIN22_PIN_SYNC1_BYPASS(value uint32) {
	volatile.StoreUint32(&o.PIN22.Reg, volatile.LoadUint32(&o.PIN22.Reg)&^(0x18)|value<<3)
}
func (o *GPIO_Type) GetPIN22_PIN_SYNC1_BYPASS() uint32 {
	return (volatile.LoadUint32(&o.PIN22.Reg) & 0x18) >> 3
}
func (o *GPIO_Type) SetPIN22_PIN_INT_TYPE(value uint32) {
	volatile.StoreUint32(&o.PIN22.Reg, volatile.LoadUint32(&o.PIN22.Reg)&^(0x380)|value<<7)
}
func (o *GPIO_Type) GetPIN22_PIN_INT_TYPE() uint32 {
	return (volatile.LoadUint32(&o.PIN22.Reg) & 0x380) >> 7
}
func (o *GPIO_Type) SetPIN22_PIN_WAKEUP_ENABLE(value uint32) {
	volatile.StoreUint32(&o.PIN22.Reg, volatile.LoadUint32(&o.PIN22.Reg)&^(0x400)|value<<10)
}
func (o *GPIO_Type) GetPIN22_PIN_WAKEUP_ENABLE() uint32 {
	return (volatile.LoadUint32(&o.PIN22.Reg) & 0x400) >> 10
}
func (o *GPIO_Type) SetPIN22_PIN_CONFIG(value uint32) {
	volatile.StoreUint32(&o.PIN22.Reg, volatile.LoadUint32(&o.PIN22.Reg)&^(0x1800)|value<<11)
}
func (o *GPIO_Type) GetPIN22_PIN_CONFIG() uint32 {
	return (volatile.LoadUint32(&o.PIN22.Reg) & 0x1800) >> 11
}
func (o *GPIO_Type) SetPIN22_PIN_INT_ENA(value uint32) {
	volatile.StoreUint32(&o.PIN22.Reg, volatile.LoadUint32(&o.PIN22.Reg)&^(0x3e000)|value<<13)
}
func (o *GPIO_Type) GetPIN22_PIN_INT_ENA() uint32 {
	return (volatile.LoadUint32(&o.PIN22.Reg) & 0x3e000) >> 13
}

// GPIO.PIN23: GPIO pin configuration register
func (o *GPIO_Type) SetPIN23_PIN_SYNC2_BYPASS(value uint32) {
	volatile.StoreUint32(&o.PIN23.Reg, volatile.LoadUint32(&o.PIN23.Reg)&^(0x3)|value)
}
func (o *GPIO_Type) GetPIN23_PIN_SYNC2_BYPASS() uint32 {
	return volatile.LoadUint32(&o.PIN23.Reg) & 0x3
}
func (o *GPIO_Type) SetPIN23_PIN_PAD_DRIVER(value uint32) {
	volatile.StoreUint32(&o.PIN23.Reg, volatile.LoadUint32(&o.PIN23.Reg)&^(0x4)|value<<2)
}
func (o *GPIO_Type) GetPIN23_PIN_PAD_DRIVER() uint32 {
	return (volatile.LoadUint32(&o.PIN23.Reg) & 0x4) >> 2
}
func (o *GPIO_Type) SetPIN23_PIN_SYNC1_BYPASS(value uint32) {
	volatile.StoreUint32(&o.PIN23.Reg, volatile.LoadUint32(&o.PIN23.Reg)&^(0x18)|value<<3)
}
func (o *GPIO_Type) GetPIN23_PIN_SYNC1_BYPASS() uint32 {
	return (volatile.LoadUint32(&o.PIN23.Reg) & 0x18) >> 3
}
func (o *GPIO_Type) SetPIN23_PIN_INT_TYPE(value uint32) {
	volatile.StoreUint32(&o.PIN23.Reg, volatile.LoadUint32(&o.PIN23.Reg)&^(0x380)|value<<7)
}
func (o *GPIO_Type) GetPIN23_PIN_INT_TYPE() uint32 {
	return (volatile.LoadUint32(&o.PIN23.Reg) & 0x380) >> 7
}
func (o *GPIO_Type) SetPIN23_PIN_WAKEUP_ENABLE(value uint32) {
	volatile.StoreUint32(&o.PIN23.Reg, volatile.LoadUint32(&o.PIN23.Reg)&^(0x400)|value<<10)
}
func (o *GPIO_Type) GetPIN23_PIN_WAKEUP_ENABLE() uint32 {
	return (volatile.LoadUint32(&o.PIN23.Reg) & 0x400) >> 10
}
func (o *GPIO_Type) SetPIN23_PIN_CONFIG(value uint32) {
	volatile.StoreUint32(&o.PIN23.Reg, volatile.LoadUint32(&o.PIN23.Reg)&^(0x1800)|value<<11)
}
func (o *GPIO_Type) GetPIN23_PIN_CONFIG() uint32 {
	return (volatile.LoadUint32(&o.PIN23.Reg) & 0x1800) >> 11
}
func (o *GPIO_Type) SetPIN23_PIN_INT_ENA(value uint32) {
	volatile.StoreUint32(&o.PIN23.Reg, volatile.LoadUint32(&o.PIN23.Reg)&^(0x3e000)|value<<13)
}
func (o *GPIO_Type) GetPIN23_PIN_INT_ENA() uint32 {
	return (volatile.LoadUint32(&o.PIN23.Reg) & 0x3e000) >> 13
}

// GPIO.PIN24: GPIO pin configuration register
func (o *GPIO_Type) SetPIN24_PIN_SYNC2_BYPASS(value uint32) {
	volatile.StoreUint32(&o.PIN24.Reg, volatile.LoadUint32(&o.PIN24.Reg)&^(0x3)|value)
}
func (o *GPIO_Type) GetPIN24_PIN_SYNC2_BYPASS() uint32 {
	return volatile.LoadUint32(&o.PIN24.Reg) & 0x3
}
func (o *GPIO_Type) SetPIN24_PIN_PAD_DRIVER(value uint32) {
	volatile.StoreUint32(&o.PIN24.Reg, volatile.LoadUint32(&o.PIN24.Reg)&^(0x4)|value<<2)
}
func (o *GPIO_Type) GetPIN24_PIN_PAD_DRIVER() uint32 {
	return (volatile.LoadUint32(&o.PIN24.Reg) & 0x4) >> 2
}
func (o *GPIO_Type) SetPIN24_PIN_SYNC1_BYPASS(value uint32) {
	volatile.StoreUint32(&o.PIN24.Reg, volatile.LoadUint32(&o.PIN24.Reg)&^(0x18)|value<<3)
}
func (o *GPIO_Type) GetPIN24_PIN_SYNC1_BYPASS() uint32 {
	return (volatile.LoadUint32(&o.PIN24.Reg) & 0x18) >> 3
}
func (o *GPIO_Type) SetPIN24_PIN_INT_TYPE(value uint32) {
	volatile.StoreUint32(&o.PIN24.Reg, volatile.LoadUint32(&o.PIN24.Reg)&^(0x380)|value<<7)
}
func (o *GPIO_Type) GetPIN24_PIN_INT_TYPE() uint32 {
	return (volatile.LoadUint32(&o.PIN24.Reg) & 0x380) >> 7
}
func (o *GPIO_Type) SetPIN24_PIN_WAKEUP_ENABLE(value uint32) {
	volatile.StoreUint32(&o.PIN24.Reg, volatile.LoadUint32(&o.PIN24.Reg)&^(0x400)|value<<10)
}
func (o *GPIO_Type) GetPIN24_PIN_WAKEUP_ENABLE() uint32 {
	return (volatile.LoadUint32(&o.PIN24.Reg) & 0x400) >> 10
}
func (o *GPIO_Type) SetPIN24_PIN_CONFIG(value uint32) {
	volatile.StoreUint32(&o.PIN24.Reg, volatile.LoadUint32(&o.PIN24.Reg)&^(0x1800)|value<<11)
}
func (o *GPIO_Type) GetPIN24_PIN_CONFIG() uint32 {
	return (volatile.LoadUint32(&o.PIN24.Reg) & 0x1800) >> 11
}
func (o *GPIO_Type) SetPIN24_PIN_INT_ENA(value uint32) {
	volatile.StoreUint32(&o.PIN24.Reg, volatile.LoadUint32(&o.PIN24.Reg)&^(0x3e000)|value<<13)
}
func (o *GPIO_Type) GetPIN24_PIN_INT_ENA() uint32 {
	return (volatile.LoadUint32(&o.PIN24.Reg) & 0x3e000) >> 13
}

// GPIO.PIN25: GPIO pin configuration register
func (o *GPIO_Type) SetPIN25_PIN_SYNC2_BYPASS(value uint32) {
	volatile.StoreUint32(&o.PIN25.Reg, volatile.LoadUint32(&o.PIN25.Reg)&^(0x3)|value)
}
func (o *GPIO_Type) GetPIN25_PIN_SYNC2_BYPASS() uint32 {
	return volatile.LoadUint32(&o.PIN25.Reg) & 0x3
}
func (o *GPIO_Type) SetPIN25_PIN_PAD_DRIVER(value uint32) {
	volatile.StoreUint32(&o.PIN25.Reg, volatile.LoadUint32(&o.PIN25.Reg)&^(0x4)|value<<2)
}
func (o *GPIO_Type) GetPIN25_PIN_PAD_DRIVER() uint32 {
	return (volatile.LoadUint32(&o.PIN25.Reg) & 0x4) >> 2
}
func (o *GPIO_Type) SetPIN25_PIN_SYNC1_BYPASS(value uint32) {
	volatile.StoreUint32(&o.PIN25.Reg, volatile.LoadUint32(&o.PIN25.Reg)&^(0x18)|value<<3)
}
func (o *GPIO_Type) GetPIN25_PIN_SYNC1_BYPASS() uint32 {
	return (volatile.LoadUint32(&o.PIN25.Reg) & 0x18) >> 3
}
func (o *GPIO_Type) SetPIN25_PIN_INT_TYPE(value uint32) {
	volatile.StoreUint32(&o.PIN25.Reg, volatile.LoadUint32(&o.PIN25.Reg)&^(0x380)|value<<7)
}
func (o *GPIO_Type) GetPIN25_PIN_INT_TYPE() uint32 {
	return (volatile.LoadUint32(&o.PIN25.Reg) & 0x380) >> 7
}
func (o *GPIO_Type) SetPIN25_PIN_WAKEUP_ENABLE(value uint32) {
	volatile.StoreUint32(&o.PIN25.Reg, volatile.LoadUint32(&o.PIN25.Reg)&^(0x400)|value<<10)
}
func (o *GPIO_Type) GetPIN25_PIN_WAKEUP_ENABLE() uint32 {
	return (volatile.LoadUint32(&o.PIN25.Reg) & 0x400) >> 10
}
func (o *GPIO_Type) SetPIN25_PIN_CONFIG(value uint32) {
	volatile.StoreUint32(&o.PIN25.Reg, volatile.LoadUint32(&o.PIN25.Reg)&^(0x1800)|value<<11)
}
func (o *GPIO_Type) GetPIN25_PIN_CONFIG() uint32 {
	return (volatile.LoadUint32(&o.PIN25.Reg) & 0x1800) >> 11
}
func (o *GPIO_Type) SetPIN25_PIN_INT_ENA(value uint32) {
	volatile.StoreUint32(&o.PIN25.Reg, volatile.LoadUint32(&o.PIN25.Reg)&^(0x3e000)|value<<13)
}
func (o *GPIO_Type) GetPIN25_PIN_INT_ENA() uint32 {
	return (volatile.LoadUint32(&o.PIN25.Reg) & 0x3e000) >> 13
}

// GPIO.STATUS_NEXT: GPIO interrupt source register
func (o *GPIO_Type) SetSTATUS_NEXT_STATUS_INTERRUPT_NEXT(value uint32) {
	volatile.StoreUint32(&o.STATUS_NEXT.Reg, volatile.LoadUint32(&o.STATUS_NEXT.Reg)&^(0x3ffffff)|value)
}
func (o *GPIO_Type) GetSTATUS_NEXT_STATUS_INTERRUPT_NEXT() uint32 {
	return volatile.LoadUint32(&o.STATUS_NEXT.Reg) & 0x3ffffff
}

// GPIO.FUNC0_IN_SEL_CFG: GPIO input function configuration register
func (o *GPIO_Type) SetFUNC0_IN_SEL_CFG_FUNC_IN_SEL(value uint32) {
	volatile.StoreUint32(&o.FUNC0_IN_SEL_CFG.Reg, volatile.LoadUint32(&o.FUNC0_IN_SEL_CFG.Reg)&^(0x1f)|value)
}
func (o *GPIO_Type) GetFUNC0_IN_SEL_CFG_FUNC_IN_SEL() uint32 {
	return volatile.LoadUint32(&o.FUNC0_IN_SEL_CFG.Reg) & 0x1f
}
func (o *GPIO_Type) SetFUNC0_IN_SEL_CFG_FUNC_IN_INV_SEL(value uint32) {
	volatile.StoreUint32(&o.FUNC0_IN_SEL_CFG.Reg, volatile.LoadUint32(&o.FUNC0_IN_SEL_CFG.Reg)&^(0x20)|value<<5)
}
func (o *GPIO_Type) GetFUNC0_IN_SEL_CFG_FUNC_IN_INV_SEL() uint32 {
	return (volatile.LoadUint32(&o.FUNC0_IN_SEL_CFG.Reg) & 0x20) >> 5
}
func (o *GPIO_Type) SetFUNC0_IN_SEL_CFG_SIG_IN_SEL(value uint32) {
	volatile.StoreUint32(&o.FUNC0_IN_SEL_CFG.Reg, volatile.LoadUint32(&o.FUNC0_IN_SEL_CFG.Reg)&^(0x40)|value<<6)
}
func (o *GPIO_Type) GetFUNC0_IN_SEL_CFG_SIG_IN_SEL() uint32 {
	return (volatile.LoadUint32(&o.FUNC0_IN_SEL_CFG.Reg) & 0x40) >> 6
}

// GPIO.FUNC1_IN_SEL_CFG: GPIO input function configuration register
func (o *GPIO_Type) SetFUNC1_IN_SEL_CFG_FUNC_IN_SEL(value uint32) {
	volatile.StoreUint32(&o.FUNC1_IN_SEL_CFG.Reg, volatile.LoadUint32(&o.FUNC1_IN_SEL_CFG.Reg)&^(0x1f)|value)
}
func (o *GPIO_Type) GetFUNC1_IN_SEL_CFG_FUNC_IN_SEL() uint32 {
	return volatile.LoadUint32(&o.FUNC1_IN_SEL_CFG.Reg) & 0x1f
}
func (o *GPIO_Type) SetFUNC1_IN_SEL_CFG_FUNC_IN_INV_SEL(value uint32) {
	volatile.StoreUint32(&o.FUNC1_IN_SEL_CFG.Reg, volatile.LoadUint32(&o.FUNC1_IN_SEL_CFG.Reg)&^(0x20)|value<<5)
}
func (o *GPIO_Type) GetFUNC1_IN_SEL_CFG_FUNC_IN_INV_SEL() uint32 {
	return (volatile.LoadUint32(&o.FUNC1_IN_SEL_CFG.Reg) & 0x20) >> 5
}
func (o *GPIO_Type) SetFUNC1_IN_SEL_CFG_SIG_IN_SEL(value uint32) {
	volatile.StoreUint32(&o.FUNC1_IN_SEL_CFG.Reg, volatile.LoadUint32(&o.FUNC1_IN_SEL_CFG.Reg)&^(0x40)|value<<6)
}
func (o *GPIO_Type) GetFUNC1_IN_SEL_CFG_SIG_IN_SEL() uint32 {
	return (volatile.LoadUint32(&o.FUNC1_IN_SEL_CFG.Reg) & 0x40) >> 6
}

// GPIO.FUNC2_IN_SEL_CFG: GPIO input function configuration register
func (o *GPIO_Type) SetFUNC2_IN_SEL_CFG_FUNC_IN_SEL(value uint32) {
	volatile.StoreUint32(&o.FUNC2_IN_SEL_CFG.Reg, volatile.LoadUint32(&o.FUNC2_IN_SEL_CFG.Reg)&^(0x1f)|value)
}
func (o *GPIO_Type) GetFUNC2_IN_SEL_CFG_FUNC_IN_SEL() uint32 {
	return volatile.LoadUint32(&o.FUNC2_IN_SEL_CFG.Reg) & 0x1f
}
func (o *GPIO_Type) SetFUNC2_IN_SEL_CFG_FUNC_IN_INV_SEL(value uint32) {
	volatile.StoreUint32(&o.FUNC2_IN_SEL_CFG.Reg, volatile.LoadUint32(&o.FUNC2_IN_SEL_CFG.Reg)&^(0x20)|value<<5)
}
func (o *GPIO_Type) GetFUNC2_IN_SEL_CFG_FUNC_IN_INV_SEL() uint32 {
	return (volatile.LoadUint32(&o.FUNC2_IN_SEL_CFG.Reg) & 0x20) >> 5
}
func (o *GPIO_Type) SetFUNC2_IN_SEL_CFG_SIG_IN_SEL(value uint32) {
	volatile.StoreUint32(&o.FUNC2_IN_SEL_CFG.Reg, volatile.LoadUint32(&o.FUNC2_IN_SEL_CFG.Reg)&^(0x40)|value<<6)
}
func (o *GPIO_Type) GetFUNC2_IN_SEL_CFG_SIG_IN_SEL() uint32 {
	return (volatile.LoadUint32(&o.FUNC2_IN_SEL_CFG.Reg) & 0x40) >> 6
}

// GPIO.FUNC3_IN_SEL_CFG: GPIO input function configuration register
func (o *GPIO_Type) SetFUNC3_IN_SEL_CFG_FUNC_IN_SEL(value uint32) {
	volatile.StoreUint32(&o.FUNC3_IN_SEL_CFG.Reg, volatile.LoadUint32(&o.FUNC3_IN_SEL_CFG.Reg)&^(0x1f)|value)
}
func (o *GPIO_Type) GetFUNC3_IN_SEL_CFG_FUNC_IN_SEL() uint32 {
	return volatile.LoadUint32(&o.FUNC3_IN_SEL_CFG.Reg) & 0x1f
}
func (o *GPIO_Type) SetFUNC3_IN_SEL_CFG_FUNC_IN_INV_SEL(value uint32) {
	volatile.StoreUint32(&o.FUNC3_IN_SEL_CFG.Reg, volatile.LoadUint32(&o.FUNC3_IN_SEL_CFG.Reg)&^(0x20)|value<<5)
}
func (o *GPIO_Type) GetFUNC3_IN_SEL_CFG_FUNC_IN_INV_SEL() uint32 {
	return (volatile.LoadUint32(&o.FUNC3_IN_SEL_CFG.Reg) & 0x20) >> 5
}
func (o *GPIO_Type) SetFUNC3_IN_SEL_CFG_SIG_IN_SEL(value uint32) {
	volatile.StoreUint32(&o.FUNC3_IN_SEL_CFG.Reg, volatile.LoadUint32(&o.FUNC3_IN_SEL_CFG.Reg)&^(0x40)|value<<6)
}
func (o *GPIO_Type) GetFUNC3_IN_SEL_CFG_SIG_IN_SEL() uint32 {
	return (volatile.LoadUint32(&o.FUNC3_IN_SEL_CFG.Reg) & 0x40) >> 6
}

// GPIO.FUNC4_IN_SEL_CFG: GPIO input function configuration register
func (o *GPIO_Type) SetFUNC4_IN_SEL_CFG_FUNC_IN_SEL(value uint32) {
	volatile.StoreUint32(&o.FUNC4_IN_SEL_CFG.Reg, volatile.LoadUint32(&o.FUNC4_IN_SEL_CFG.Reg)&^(0x1f)|value)
}
func (o *GPIO_Type) GetFUNC4_IN_SEL_CFG_FUNC_IN_SEL() uint32 {
	return volatile.LoadUint32(&o.FUNC4_IN_SEL_CFG.Reg) & 0x1f
}
func (o *GPIO_Type) SetFUNC4_IN_SEL_CFG_FUNC_IN_INV_SEL(value uint32) {
	volatile.StoreUint32(&o.FUNC4_IN_SEL_CFG.Reg, volatile.LoadUint32(&o.FUNC4_IN_SEL_CFG.Reg)&^(0x20)|value<<5)
}
func (o *GPIO_Type) GetFUNC4_IN_SEL_CFG_FUNC_IN_INV_SEL() uint32 {
	return (volatile.LoadUint32(&o.FUNC4_IN_SEL_CFG.Reg) & 0x20) >> 5
}
func (o *GPIO_Type) SetFUNC4_IN_SEL_CFG_SIG_IN_SEL(value uint32) {
	volatile.StoreUint32(&o.FUNC4_IN_SEL_CFG.Reg, volatile.LoadUint32(&o.FUNC4_IN_SEL_CFG.Reg)&^(0x40)|value<<6)
}
func (o *GPIO_Type) GetFUNC4_IN_SEL_CFG_SIG_IN_SEL() uint32 {
	return (volatile.LoadUint32(&o.FUNC4_IN_SEL_CFG.Reg) & 0x40) >> 6
}

// GPIO.FUNC5_IN_SEL_CFG: GPIO input function configuration register
func (o *GPIO_Type) SetFUNC5_IN_SEL_CFG_FUNC_IN_SEL(value uint32) {
	volatile.StoreUint32(&o.FUNC5_IN_SEL_CFG.Reg, volatile.LoadUint32(&o.FUNC5_IN_SEL_CFG.Reg)&^(0x1f)|value)
}
func (o *GPIO_Type) GetFUNC5_IN_SEL_CFG_FUNC_IN_SEL() uint32 {
	return volatile.LoadUint32(&o.FUNC5_IN_SEL_CFG.Reg) & 0x1f
}
func (o *GPIO_Type) SetFUNC5_IN_SEL_CFG_FUNC_IN_INV_SEL(value uint32) {
	volatile.StoreUint32(&o.FUNC5_IN_SEL_CFG.Reg, volatile.LoadUint32(&o.FUNC5_IN_SEL_CFG.Reg)&^(0x20)|value<<5)
}
func (o *GPIO_Type) GetFUNC5_IN_SEL_CFG_FUNC_IN_INV_SEL() uint32 {
	return (volatile.LoadUint32(&o.FUNC5_IN_SEL_CFG.Reg) & 0x20) >> 5
}
func (o *GPIO_Type) SetFUNC5_IN_SEL_CFG_SIG_IN_SEL(value uint32) {
	volatile.StoreUint32(&o.FUNC5_IN_SEL_CFG.Reg, volatile.LoadUint32(&o.FUNC5_IN_SEL_CFG.Reg)&^(0x40)|value<<6)
}
func (o *GPIO_Type) GetFUNC5_IN_SEL_CFG_SIG_IN_SEL() uint32 {
	return (volatile.LoadUint32(&o.FUNC5_IN_SEL_CFG.Reg) & 0x40) >> 6
}

// GPIO.FUNC6_IN_SEL_CFG: GPIO input function configuration register
func (o *GPIO_Type) SetFUNC6_IN_SEL_CFG_FUNC_IN_SEL(value uint32) {
	volatile.StoreUint32(&o.FUNC6_IN_SEL_CFG.Reg, volatile.LoadUint32(&o.FUNC6_IN_SEL_CFG.Reg)&^(0x1f)|value)
}
func (o *GPIO_Type) GetFUNC6_IN_SEL_CFG_FUNC_IN_SEL() uint32 {
	return volatile.LoadUint32(&o.FUNC6_IN_SEL_CFG.Reg) & 0x1f
}
func (o *GPIO_Type) SetFUNC6_IN_SEL_CFG_FUNC_IN_INV_SEL(value uint32) {
	volatile.StoreUint32(&o.FUNC6_IN_SEL_CFG.Reg, volatile.LoadUint32(&o.FUNC6_IN_SEL_CFG.Reg)&^(0x20)|value<<5)
}
func (o *GPIO_Type) GetFUNC6_IN_SEL_CFG_FUNC_IN_INV_SEL() uint32 {
	return (volatile.LoadUint32(&o.FUNC6_IN_SEL_CFG.Reg) & 0x20) >> 5
}
func (o *GPIO_Type) SetFUNC6_IN_SEL_CFG_SIG_IN_SEL(value uint32) {
	volatile.StoreUint32(&o.FUNC6_IN_SEL_CFG.Reg, volatile.LoadUint32(&o.FUNC6_IN_SEL_CFG.Reg)&^(0x40)|value<<6)
}
func (o *GPIO_Type) GetFUNC6_IN_SEL_CFG_SIG_IN_SEL() uint32 {
	return (volatile.LoadUint32(&o.FUNC6_IN_SEL_CFG.Reg) & 0x40) >> 6
}

// GPIO.FUNC7_IN_SEL_CFG: GPIO input function configuration register
func (o *GPIO_Type) SetFUNC7_IN_SEL_CFG_FUNC_IN_SEL(value uint32) {
	volatile.StoreUint32(&o.FUNC7_IN_SEL_CFG.Reg, volatile.LoadUint32(&o.FUNC7_IN_SEL_CFG.Reg)&^(0x1f)|value)
}
func (o *GPIO_Type) GetFUNC7_IN_SEL_CFG_FUNC_IN_SEL() uint32 {
	return volatile.LoadUint32(&o.FUNC7_IN_SEL_CFG.Reg) & 0x1f
}
func (o *GPIO_Type) SetFUNC7_IN_SEL_CFG_FUNC_IN_INV_SEL(value uint32) {
	volatile.StoreUint32(&o.FUNC7_IN_SEL_CFG.Reg, volatile.LoadUint32(&o.FUNC7_IN_SEL_CFG.Reg)&^(0x20)|value<<5)
}
func (o *GPIO_Type) GetFUNC7_IN_SEL_CFG_FUNC_IN_INV_SEL() uint32 {
	return (volatile.LoadUint32(&o.FUNC7_IN_SEL_CFG.Reg) & 0x20) >> 5
}
func (o *GPIO_Type) SetFUNC7_IN_SEL_CFG_SIG_IN_SEL(value uint32) {
	volatile.StoreUint32(&o.FUNC7_IN_SEL_CFG.Reg, volatile.LoadUint32(&o.FUNC7_IN_SEL_CFG.Reg)&^(0x40)|value<<6)
}
func (o *GPIO_Type) GetFUNC7_IN_SEL_CFG_SIG_IN_SEL() uint32 {
	return (volatile.LoadUint32(&o.FUNC7_IN_SEL_CFG.Reg) & 0x40) >> 6
}

// GPIO.FUNC8_IN_SEL_CFG: GPIO input function configuration register
func (o *GPIO_Type) SetFUNC8_IN_SEL_CFG_FUNC_IN_SEL(value uint32) {
	volatile.StoreUint32(&o.FUNC8_IN_SEL_CFG.Reg, volatile.LoadUint32(&o.FUNC8_IN_SEL_CFG.Reg)&^(0x1f)|value)
}
func (o *GPIO_Type) GetFUNC8_IN_SEL_CFG_FUNC_IN_SEL() uint32 {
	return volatile.LoadUint32(&o.FUNC8_IN_SEL_CFG.Reg) & 0x1f
}
func (o *GPIO_Type) SetFUNC8_IN_SEL_CFG_FUNC_IN_INV_SEL(value uint32) {
	volatile.StoreUint32(&o.FUNC8_IN_SEL_CFG.Reg, volatile.LoadUint32(&o.FUNC8_IN_SEL_CFG.Reg)&^(0x20)|value<<5)
}
func (o *GPIO_Type) GetFUNC8_IN_SEL_CFG_FUNC_IN_INV_SEL() uint32 {
	return (volatile.LoadUint32(&o.FUNC8_IN_SEL_CFG.Reg) & 0x20) >> 5
}
func (o *GPIO_Type) SetFUNC8_IN_SEL_CFG_SIG_IN_SEL(value uint32) {
	volatile.StoreUint32(&o.FUNC8_IN_SEL_CFG.Reg, volatile.LoadUint32(&o.FUNC8_IN_SEL_CFG.Reg)&^(0x40)|value<<6)
}
func (o *GPIO_Type) GetFUNC8_IN_SEL_CFG_SIG_IN_SEL() uint32 {
	return (volatile.LoadUint32(&o.FUNC8_IN_SEL_CFG.Reg) & 0x40) >> 6
}

// GPIO.FUNC9_IN_SEL_CFG: GPIO input function configuration register
func (o *GPIO_Type) SetFUNC9_IN_SEL_CFG_FUNC_IN_SEL(value uint32) {
	volatile.StoreUint32(&o.FUNC9_IN_SEL_CFG.Reg, volatile.LoadUint32(&o.FUNC9_IN_SEL_CFG.Reg)&^(0x1f)|value)
}
func (o *GPIO_Type) GetFUNC9_IN_SEL_CFG_FUNC_IN_SEL() uint32 {
	return volatile.LoadUint32(&o.FUNC9_IN_SEL_CFG.Reg) & 0x1f
}
func (o *GPIO_Type) SetFUNC9_IN_SEL_CFG_FUNC_IN_INV_SEL(value uint32) {
	volatile.StoreUint32(&o.FUNC9_IN_SEL_CFG.Reg, volatile.LoadUint32(&o.FUNC9_IN_SEL_CFG.Reg)&^(0x20)|value<<5)
}
func (o *GPIO_Type) GetFUNC9_IN_SEL_CFG_FUNC_IN_INV_SEL() uint32 {
	return (volatile.LoadUint32(&o.FUNC9_IN_SEL_CFG.Reg) & 0x20) >> 5
}
func (o *GPIO_Type) SetFUNC9_IN_SEL_CFG_SIG_IN_SEL(value uint32) {
	volatile.StoreUint32(&o.FUNC9_IN_SEL_CFG.Reg, volatile.LoadUint32(&o.FUNC9_IN_SEL_CFG.Reg)&^(0x40)|value<<6)
}
func (o *GPIO_Type) GetFUNC9_IN_SEL_CFG_SIG_IN_SEL() uint32 {
	return (volatile.LoadUint32(&o.FUNC9_IN_SEL_CFG.Reg) & 0x40) >> 6
}

// GPIO.FUNC10_IN_SEL_CFG: GPIO input function configuration register
func (o *GPIO_Type) SetFUNC10_IN_SEL_CFG_FUNC_IN_SEL(value uint32) {
	volatile.StoreUint32(&o.FUNC10_IN_SEL_CFG.Reg, volatile.LoadUint32(&o.FUNC10_IN_SEL_CFG.Reg)&^(0x1f)|value)
}
func (o *GPIO_Type) GetFUNC10_IN_SEL_CFG_FUNC_IN_SEL() uint32 {
	return volatile.LoadUint32(&o.FUNC10_IN_SEL_CFG.Reg) & 0x1f
}
func (o *GPIO_Type) SetFUNC10_IN_SEL_CFG_FUNC_IN_INV_SEL(value uint32) {
	volatile.StoreUint32(&o.FUNC10_IN_SEL_CFG.Reg, volatile.LoadUint32(&o.FUNC10_IN_SEL_CFG.Reg)&^(0x20)|value<<5)
}
func (o *GPIO_Type) GetFUNC10_IN_SEL_CFG_FUNC_IN_INV_SEL() uint32 {
	return (volatile.LoadUint32(&o.FUNC10_IN_SEL_CFG.Reg) & 0x20) >> 5
}
func (o *GPIO_Type) SetFUNC10_IN_SEL_CFG_SIG_IN_SEL(value uint32) {
	volatile.StoreUint32(&o.FUNC10_IN_SEL_CFG.Reg, volatile.LoadUint32(&o.FUNC10_IN_SEL_CFG.Reg)&^(0x40)|value<<6)
}
func (o *GPIO_Type) GetFUNC10_IN_SEL_CFG_SIG_IN_SEL() uint32 {
	return (volatile.LoadUint32(&o.FUNC10_IN_SEL_CFG.Reg) & 0x40) >> 6
}

// GPIO.FUNC11_IN_SEL_CFG: GPIO input function configuration register
func (o *GPIO_Type) SetFUNC11_IN_SEL_CFG_FUNC_IN_SEL(value uint32) {
	volatile.StoreUint32(&o.FUNC11_IN_SEL_CFG.Reg, volatile.LoadUint32(&o.FUNC11_IN_SEL_CFG.Reg)&^(0x1f)|value)
}
func (o *GPIO_Type) GetFUNC11_IN_SEL_CFG_FUNC_IN_SEL() uint32 {
	return volatile.LoadUint32(&o.FUNC11_IN_SEL_CFG.Reg) & 0x1f
}
func (o *GPIO_Type) SetFUNC11_IN_SEL_CFG_FUNC_IN_INV_SEL(value uint32) {
	volatile.StoreUint32(&o.FUNC11_IN_SEL_CFG.Reg, volatile.LoadUint32(&o.FUNC11_IN_SEL_CFG.Reg)&^(0x20)|value<<5)
}
func (o *GPIO_Type) GetFUNC11_IN_SEL_CFG_FUNC_IN_INV_SEL() uint32 {
	return (volatile.LoadUint32(&o.FUNC11_IN_SEL_CFG.Reg) & 0x20) >> 5
}
func (o *GPIO_Type) SetFUNC11_IN_SEL_CFG_SIG_IN_SEL(value uint32) {
	volatile.StoreUint32(&o.FUNC11_IN_SEL_CFG.Reg, volatile.LoadUint32(&o.FUNC11_IN_SEL_CFG.Reg)&^(0x40)|value<<6)
}
func (o *GPIO_Type) GetFUNC11_IN_SEL_CFG_SIG_IN_SEL() uint32 {
	return (volatile.LoadUint32(&o.FUNC11_IN_SEL_CFG.Reg) & 0x40) >> 6
}

// GPIO.FUNC12_IN_SEL_CFG: GPIO input function configuration register
func (o *GPIO_Type) SetFUNC12_IN_SEL_CFG_FUNC_IN_SEL(value uint32) {
	volatile.StoreUint32(&o.FUNC12_IN_SEL_CFG.Reg, volatile.LoadUint32(&o.FUNC12_IN_SEL_CFG.Reg)&^(0x1f)|value)
}
func (o *GPIO_Type) GetFUNC12_IN_SEL_CFG_FUNC_IN_SEL() uint32 {
	return volatile.LoadUint32(&o.FUNC12_IN_SEL_CFG.Reg) & 0x1f
}
func (o *GPIO_Type) SetFUNC12_IN_SEL_CFG_FUNC_IN_INV_SEL(value uint32) {
	volatile.StoreUint32(&o.FUNC12_IN_SEL_CFG.Reg, volatile.LoadUint32(&o.FUNC12_IN_SEL_CFG.Reg)&^(0x20)|value<<5)
}
func (o *GPIO_Type) GetFUNC12_IN_SEL_CFG_FUNC_IN_INV_SEL() uint32 {
	return (volatile.LoadUint32(&o.FUNC12_IN_SEL_CFG.Reg) & 0x20) >> 5
}
func (o *GPIO_Type) SetFUNC12_IN_SEL_CFG_SIG_IN_SEL(value uint32) {
	volatile.StoreUint32(&o.FUNC12_IN_SEL_CFG.Reg, volatile.LoadUint32(&o.FUNC12_IN_SEL_CFG.Reg)&^(0x40)|value<<6)
}
func (o *GPIO_Type) GetFUNC12_IN_SEL_CFG_SIG_IN_SEL() uint32 {
	return (volatile.LoadUint32(&o.FUNC12_IN_SEL_CFG.Reg) & 0x40) >> 6
}

// GPIO.FUNC13_IN_SEL_CFG: GPIO input function configuration register
func (o *GPIO_Type) SetFUNC13_IN_SEL_CFG_FUNC_IN_SEL(value uint32) {
	volatile.StoreUint32(&o.FUNC13_IN_SEL_CFG.Reg, volatile.LoadUint32(&o.FUNC13_IN_SEL_CFG.Reg)&^(0x1f)|value)
}
func (o *GPIO_Type) GetFUNC13_IN_SEL_CFG_FUNC_IN_SEL() uint32 {
	return volatile.LoadUint32(&o.FUNC13_IN_SEL_CFG.Reg) & 0x1f
}
func (o *GPIO_Type) SetFUNC13_IN_SEL_CFG_FUNC_IN_INV_SEL(value uint32) {
	volatile.StoreUint32(&o.FUNC13_IN_SEL_CFG.Reg, volatile.LoadUint32(&o.FUNC13_IN_SEL_CFG.Reg)&^(0x20)|value<<5)
}
func (o *GPIO_Type) GetFUNC13_IN_SEL_CFG_FUNC_IN_INV_SEL() uint32 {
	return (volatile.LoadUint32(&o.FUNC13_IN_SEL_CFG.Reg) & 0x20) >> 5
}
func (o *GPIO_Type) SetFUNC13_IN_SEL_CFG_SIG_IN_SEL(value uint32) {
	volatile.StoreUint32(&o.FUNC13_IN_SEL_CFG.Reg, volatile.LoadUint32(&o.FUNC13_IN_SEL_CFG.Reg)&^(0x40)|value<<6)
}
func (o *GPIO_Type) GetFUNC13_IN_SEL_CFG_SIG_IN_SEL() uint32 {
	return (volatile.LoadUint32(&o.FUNC13_IN_SEL_CFG.Reg) & 0x40) >> 6
}

// GPIO.FUNC14_IN_SEL_CFG: GPIO input function configuration register
func (o *GPIO_Type) SetFUNC14_IN_SEL_CFG_FUNC_IN_SEL(value uint32) {
	volatile.StoreUint32(&o.FUNC14_IN_SEL_CFG.Reg, volatile.LoadUint32(&o.FUNC14_IN_SEL_CFG.Reg)&^(0x1f)|value)
}
func (o *GPIO_Type) GetFUNC14_IN_SEL_CFG_FUNC_IN_SEL() uint32 {
	return volatile.LoadUint32(&o.FUNC14_IN_SEL_CFG.Reg) & 0x1f
}
func (o *GPIO_Type) SetFUNC14_IN_SEL_CFG_FUNC_IN_INV_SEL(value uint32) {
	volatile.StoreUint32(&o.FUNC14_IN_SEL_CFG.Reg, volatile.LoadUint32(&o.FUNC14_IN_SEL_CFG.Reg)&^(0x20)|value<<5)
}
func (o *GPIO_Type) GetFUNC14_IN_SEL_CFG_FUNC_IN_INV_SEL() uint32 {
	return (volatile.LoadUint32(&o.FUNC14_IN_SEL_CFG.Reg) & 0x20) >> 5
}
func (o *GPIO_Type) SetFUNC14_IN_SEL_CFG_SIG_IN_SEL(value uint32) {
	volatile.StoreUint32(&o.FUNC14_IN_SEL_CFG.Reg, volatile.LoadUint32(&o.FUNC14_IN_SEL_CFG.Reg)&^(0x40)|value<<6)
}
func (o *GPIO_Type) GetFUNC14_IN_SEL_CFG_SIG_IN_SEL() uint32 {
	return (volatile.LoadUint32(&o.FUNC14_IN_SEL_CFG.Reg) & 0x40) >> 6
}

// GPIO.FUNC15_IN_SEL_CFG: GPIO input function configuration register
func (o *GPIO_Type) SetFUNC15_IN_SEL_CFG_FUNC_IN_SEL(value uint32) {
	volatile.StoreUint32(&o.FUNC15_IN_SEL_CFG.Reg, volatile.LoadUint32(&o.FUNC15_IN_SEL_CFG.Reg)&^(0x1f)|value)
}
func (o *GPIO_Type) GetFUNC15_IN_SEL_CFG_FUNC_IN_SEL() uint32 {
	return volatile.LoadUint32(&o.FUNC15_IN_SEL_CFG.Reg) & 0x1f
}
func (o *GPIO_Type) SetFUNC15_IN_SEL_CFG_FUNC_IN_INV_SEL(value uint32) {
	volatile.StoreUint32(&o.FUNC15_IN_SEL_CFG.Reg, volatile.LoadUint32(&o.FUNC15_IN_SEL_CFG.Reg)&^(0x20)|value<<5)
}
func (o *GPIO_Type) GetFUNC15_IN_SEL_CFG_FUNC_IN_INV_SEL() uint32 {
	return (volatile.LoadUint32(&o.FUNC15_IN_SEL_CFG.Reg) & 0x20) >> 5
}
func (o *GPIO_Type) SetFUNC15_IN_SEL_CFG_SIG_IN_SEL(value uint32) {
	volatile.StoreUint32(&o.FUNC15_IN_SEL_CFG.Reg, volatile.LoadUint32(&o.FUNC15_IN_SEL_CFG.Reg)&^(0x40)|value<<6)
}
func (o *GPIO_Type) GetFUNC15_IN_SEL_CFG_SIG_IN_SEL() uint32 {
	return (volatile.LoadUint32(&o.FUNC15_IN_SEL_CFG.Reg) & 0x40) >> 6
}

// GPIO.FUNC16_IN_SEL_CFG: GPIO input function configuration register
func (o *GPIO_Type) SetFUNC16_IN_SEL_CFG_FUNC_IN_SEL(value uint32) {
	volatile.StoreUint32(&o.FUNC16_IN_SEL_CFG.Reg, volatile.LoadUint32(&o.FUNC16_IN_SEL_CFG.Reg)&^(0x1f)|value)
}
func (o *GPIO_Type) GetFUNC16_IN_SEL_CFG_FUNC_IN_SEL() uint32 {
	return volatile.LoadUint32(&o.FUNC16_IN_SEL_CFG.Reg) & 0x1f
}
func (o *GPIO_Type) SetFUNC16_IN_SEL_CFG_FUNC_IN_INV_SEL(value uint32) {
	volatile.StoreUint32(&o.FUNC16_IN_SEL_CFG.Reg, volatile.LoadUint32(&o.FUNC16_IN_SEL_CFG.Reg)&^(0x20)|value<<5)
}
func (o *GPIO_Type) GetFUNC16_IN_SEL_CFG_FUNC_IN_INV_SEL() uint32 {
	return (volatile.LoadUint32(&o.FUNC16_IN_SEL_CFG.Reg) & 0x20) >> 5
}
func (o *GPIO_Type) SetFUNC16_IN_SEL_CFG_SIG_IN_SEL(value uint32) {
	volatile.StoreUint32(&o.FUNC16_IN_SEL_CFG.Reg, volatile.LoadUint32(&o.FUNC16_IN_SEL_CFG.Reg)&^(0x40)|value<<6)
}
func (o *GPIO_Type) GetFUNC16_IN_SEL_CFG_SIG_IN_SEL() uint32 {
	return (volatile.LoadUint32(&o.FUNC16_IN_SEL_CFG.Reg) & 0x40) >> 6
}

// GPIO.FUNC17_IN_SEL_CFG: GPIO input function configuration register
func (o *GPIO_Type) SetFUNC17_IN_SEL_CFG_FUNC_IN_SEL(value uint32) {
	volatile.StoreUint32(&o.FUNC17_IN_SEL_CFG.Reg, volatile.LoadUint32(&o.FUNC17_IN_SEL_CFG.Reg)&^(0x1f)|value)
}
func (o *GPIO_Type) GetFUNC17_IN_SEL_CFG_FUNC_IN_SEL() uint32 {
	return volatile.LoadUint32(&o.FUNC17_IN_SEL_CFG.Reg) & 0x1f
}
func (o *GPIO_Type) SetFUNC17_IN_SEL_CFG_FUNC_IN_INV_SEL(value uint32) {
	volatile.StoreUint32(&o.FUNC17_IN_SEL_CFG.Reg, volatile.LoadUint32(&o.FUNC17_IN_SEL_CFG.Reg)&^(0x20)|value<<5)
}
func (o *GPIO_Type) GetFUNC17_IN_SEL_CFG_FUNC_IN_INV_SEL() uint32 {
	return (volatile.LoadUint32(&o.FUNC17_IN_SEL_CFG.Reg) & 0x20) >> 5
}
func (o *GPIO_Type) SetFUNC17_IN_SEL_CFG_SIG_IN_SEL(value uint32) {
	volatile.StoreUint32(&o.FUNC17_IN_SEL_CFG.Reg, volatile.LoadUint32(&o.FUNC17_IN_SEL_CFG.Reg)&^(0x40)|value<<6)
}
func (o *GPIO_Type) GetFUNC17_IN_SEL_CFG_SIG_IN_SEL() uint32 {
	return (volatile.LoadUint32(&o.FUNC17_IN_SEL_CFG.Reg) & 0x40) >> 6
}

// GPIO.FUNC18_IN_SEL_CFG: GPIO input function configuration register
func (o *GPIO_Type) SetFUNC18_IN_SEL_CFG_FUNC_IN_SEL(value uint32) {
	volatile.StoreUint32(&o.FUNC18_IN_SEL_CFG.Reg, volatile.LoadUint32(&o.FUNC18_IN_SEL_CFG.Reg)&^(0x1f)|value)
}
func (o *GPIO_Type) GetFUNC18_IN_SEL_CFG_FUNC_IN_SEL() uint32 {
	return volatile.LoadUint32(&o.FUNC18_IN_SEL_CFG.Reg) & 0x1f
}
func (o *GPIO_Type) SetFUNC18_IN_SEL_CFG_FUNC_IN_INV_SEL(value uint32) {
	volatile.StoreUint32(&o.FUNC18_IN_SEL_CFG.Reg, volatile.LoadUint32(&o.FUNC18_IN_SEL_CFG.Reg)&^(0x20)|value<<5)
}
func (o *GPIO_Type) GetFUNC18_IN_SEL_CFG_FUNC_IN_INV_SEL() uint32 {
	return (volatile.LoadUint32(&o.FUNC18_IN_SEL_CFG.Reg) & 0x20) >> 5
}
func (o *GPIO_Type) SetFUNC18_IN_SEL_CFG_SIG_IN_SEL(value uint32) {
	volatile.StoreUint32(&o.FUNC18_IN_SEL_CFG.Reg, volatile.LoadUint32(&o.FUNC18_IN_SEL_CFG.Reg)&^(0x40)|value<<6)
}
func (o *GPIO_Type) GetFUNC18_IN_SEL_CFG_SIG_IN_SEL() uint32 {
	return (volatile.LoadUint32(&o.FUNC18_IN_SEL_CFG.Reg) & 0x40) >> 6
}

// GPIO.FUNC19_IN_SEL_CFG: GPIO input function configuration register
func (o *GPIO_Type) SetFUNC19_IN_SEL_CFG_FUNC_IN_SEL(value uint32) {
	volatile.StoreUint32(&o.FUNC19_IN_SEL_CFG.Reg, volatile.LoadUint32(&o.FUNC19_IN_SEL_CFG.Reg)&^(0x1f)|value)
}
func (o *GPIO_Type) GetFUNC19_IN_SEL_CFG_FUNC_IN_SEL() uint32 {
	return volatile.LoadUint32(&o.FUNC19_IN_SEL_CFG.Reg) & 0x1f
}
func (o *GPIO_Type) SetFUNC19_IN_SEL_CFG_FUNC_IN_INV_SEL(value uint32) {
	volatile.StoreUint32(&o.FUNC19_IN_SEL_CFG.Reg, volatile.LoadUint32(&o.FUNC19_IN_SEL_CFG.Reg)&^(0x20)|value<<5)
}
func (o *GPIO_Type) GetFUNC19_IN_SEL_CFG_FUNC_IN_INV_SEL() uint32 {
	return (volatile.LoadUint32(&o.FUNC19_IN_SEL_CFG.Reg) & 0x20) >> 5
}
func (o *GPIO_Type) SetFUNC19_IN_SEL_CFG_SIG_IN_SEL(value uint32) {
	volatile.StoreUint32(&o.FUNC19_IN_SEL_CFG.Reg, volatile.LoadUint32(&o.FUNC19_IN_SEL_CFG.Reg)&^(0x40)|value<<6)
}
func (o *GPIO_Type) GetFUNC19_IN_SEL_CFG_SIG_IN_SEL() uint32 {
	return (volatile.LoadUint32(&o.FUNC19_IN_SEL_CFG.Reg) & 0x40) >> 6
}

// GPIO.FUNC20_IN_SEL_CFG: GPIO input function configuration register
func (o *GPIO_Type) SetFUNC20_IN_SEL_CFG_FUNC_IN_SEL(value uint32) {
	volatile.StoreUint32(&o.FUNC20_IN_SEL_CFG.Reg, volatile.LoadUint32(&o.FUNC20_IN_SEL_CFG.Reg)&^(0x1f)|value)
}
func (o *GPIO_Type) GetFUNC20_IN_SEL_CFG_FUNC_IN_SEL() uint32 {
	return volatile.LoadUint32(&o.FUNC20_IN_SEL_CFG.Reg) & 0x1f
}
func (o *GPIO_Type) SetFUNC20_IN_SEL_CFG_FUNC_IN_INV_SEL(value uint32) {
	volatile.StoreUint32(&o.FUNC20_IN_SEL_CFG.Reg, volatile.LoadUint32(&o.FUNC20_IN_SEL_CFG.Reg)&^(0x20)|value<<5)
}
func (o *GPIO_Type) GetFUNC20_IN_SEL_CFG_FUNC_IN_INV_SEL() uint32 {
	return (volatile.LoadUint32(&o.FUNC20_IN_SEL_CFG.Reg) & 0x20) >> 5
}
func (o *GPIO_Type) SetFUNC20_IN_SEL_CFG_SIG_IN_SEL(value uint32) {
	volatile.StoreUint32(&o.FUNC20_IN_SEL_CFG.Reg, volatile.LoadUint32(&o.FUNC20_IN_SEL_CFG.Reg)&^(0x40)|value<<6)
}
func (o *GPIO_Type) GetFUNC20_IN_SEL_CFG_SIG_IN_SEL() uint32 {
	return (volatile.LoadUint32(&o.FUNC20_IN_SEL_CFG.Reg) & 0x40) >> 6
}

// GPIO.FUNC21_IN_SEL_CFG: GPIO input function configuration register
func (o *GPIO_Type) SetFUNC21_IN_SEL_CFG_FUNC_IN_SEL(value uint32) {
	volatile.StoreUint32(&o.FUNC21_IN_SEL_CFG.Reg, volatile.LoadUint32(&o.FUNC21_IN_SEL_CFG.Reg)&^(0x1f)|value)
}
func (o *GPIO_Type) GetFUNC21_IN_SEL_CFG_FUNC_IN_SEL() uint32 {
	return volatile.LoadUint32(&o.FUNC21_IN_SEL_CFG.Reg) & 0x1f
}
func (o *GPIO_Type) SetFUNC21_IN_SEL_CFG_FUNC_IN_INV_SEL(value uint32) {
	volatile.StoreUint32(&o.FUNC21_IN_SEL_CFG.Reg, volatile.LoadUint32(&o.FUNC21_IN_SEL_CFG.Reg)&^(0x20)|value<<5)
}
func (o *GPIO_Type) GetFUNC21_IN_SEL_CFG_FUNC_IN_INV_SEL() uint32 {
	return (volatile.LoadUint32(&o.FUNC21_IN_SEL_CFG.Reg) & 0x20) >> 5
}
func (o *GPIO_Type) SetFUNC21_IN_SEL_CFG_SIG_IN_SEL(value uint32) {
	volatile.StoreUint32(&o.FUNC21_IN_SEL_CFG.Reg, volatile.LoadUint32(&o.FUNC21_IN_SEL_CFG.Reg)&^(0x40)|value<<6)
}
func (o *GPIO_Type) GetFUNC21_IN_SEL_CFG_SIG_IN_SEL() uint32 {
	return (volatile.LoadUint32(&o.FUNC21_IN_SEL_CFG.Reg) & 0x40) >> 6
}

// GPIO.FUNC22_IN_SEL_CFG: GPIO input function configuration register
func (o *GPIO_Type) SetFUNC22_IN_SEL_CFG_FUNC_IN_SEL(value uint32) {
	volatile.StoreUint32(&o.FUNC22_IN_SEL_CFG.Reg, volatile.LoadUint32(&o.FUNC22_IN_SEL_CFG.Reg)&^(0x1f)|value)
}
func (o *GPIO_Type) GetFUNC22_IN_SEL_CFG_FUNC_IN_SEL() uint32 {
	return volatile.LoadUint32(&o.FUNC22_IN_SEL_CFG.Reg) & 0x1f
}
func (o *GPIO_Type) SetFUNC22_IN_SEL_CFG_FUNC_IN_INV_SEL(value uint32) {
	volatile.StoreUint32(&o.FUNC22_IN_SEL_CFG.Reg, volatile.LoadUint32(&o.FUNC22_IN_SEL_CFG.Reg)&^(0x20)|value<<5)
}
func (o *GPIO_Type) GetFUNC22_IN_SEL_CFG_FUNC_IN_INV_SEL() uint32 {
	return (volatile.LoadUint32(&o.FUNC22_IN_SEL_CFG.Reg) & 0x20) >> 5
}
func (o *GPIO_Type) SetFUNC22_IN_SEL_CFG_SIG_IN_SEL(value uint32) {
	volatile.StoreUint32(&o.FUNC22_IN_SEL_CFG.Reg, volatile.LoadUint32(&o.FUNC22_IN_SEL_CFG.Reg)&^(0x40)|value<<6)
}
func (o *GPIO_Type) GetFUNC22_IN_SEL_CFG_SIG_IN_SEL() uint32 {
	return (volatile.LoadUint32(&o.FUNC22_IN_SEL_CFG.Reg) & 0x40) >> 6
}

// GPIO.FUNC23_IN_SEL_CFG: GPIO input function configuration register
func (o *GPIO_Type) SetFUNC23_IN_SEL_CFG_FUNC_IN_SEL(value uint32) {
	volatile.StoreUint32(&o.FUNC23_IN_SEL_CFG.Reg, volatile.LoadUint32(&o.FUNC23_IN_SEL_CFG.Reg)&^(0x1f)|value)
}
func (o *GPIO_Type) GetFUNC23_IN_SEL_CFG_FUNC_IN_SEL() uint32 {
	return volatile.LoadUint32(&o.FUNC23_IN_SEL_CFG.Reg) & 0x1f
}
func (o *GPIO_Type) SetFUNC23_IN_SEL_CFG_FUNC_IN_INV_SEL(value uint32) {
	volatile.StoreUint32(&o.FUNC23_IN_SEL_CFG.Reg, volatile.LoadUint32(&o.FUNC23_IN_SEL_CFG.Reg)&^(0x20)|value<<5)
}
func (o *GPIO_Type) GetFUNC23_IN_SEL_CFG_FUNC_IN_INV_SEL() uint32 {
	return (volatile.LoadUint32(&o.FUNC23_IN_SEL_CFG.Reg) & 0x20) >> 5
}
func (o *GPIO_Type) SetFUNC23_IN_SEL_CFG_SIG_IN_SEL(value uint32) {
	volatile.StoreUint32(&o.FUNC23_IN_SEL_CFG.Reg, volatile.LoadUint32(&o.FUNC23_IN_SEL_CFG.Reg)&^(0x40)|value<<6)
}
func (o *GPIO_Type) GetFUNC23_IN_SEL_CFG_SIG_IN_SEL() uint32 {
	return (volatile.LoadUint32(&o.FUNC23_IN_SEL_CFG.Reg) & 0x40) >> 6
}

// GPIO.FUNC24_IN_SEL_CFG: GPIO input function configuration register
func (o *GPIO_Type) SetFUNC24_IN_SEL_CFG_FUNC_IN_SEL(value uint32) {
	volatile.StoreUint32(&o.FUNC24_IN_SEL_CFG.Reg, volatile.LoadUint32(&o.FUNC24_IN_SEL_CFG.Reg)&^(0x1f)|value)
}
func (o *GPIO_Type) GetFUNC24_IN_SEL_CFG_FUNC_IN_SEL() uint32 {
	return volatile.LoadUint32(&o.FUNC24_IN_SEL_CFG.Reg) & 0x1f
}
func (o *GPIO_Type) SetFUNC24_IN_SEL_CFG_FUNC_IN_INV_SEL(value uint32) {
	volatile.StoreUint32(&o.FUNC24_IN_SEL_CFG.Reg, volatile.LoadUint32(&o.FUNC24_IN_SEL_CFG.Reg)&^(0x20)|value<<5)
}
func (o *GPIO_Type) GetFUNC24_IN_SEL_CFG_FUNC_IN_INV_SEL() uint32 {
	return (volatile.LoadUint32(&o.FUNC24_IN_SEL_CFG.Reg) & 0x20) >> 5
}
func (o *GPIO_Type) SetFUNC24_IN_SEL_CFG_SIG_IN_SEL(value uint32) {
	volatile.StoreUint32(&o.FUNC24_IN_SEL_CFG.Reg, volatile.LoadUint32(&o.FUNC24_IN_SEL_CFG.Reg)&^(0x40)|value<<6)
}
func (o *GPIO_Type) GetFUNC24_IN_SEL_CFG_SIG_IN_SEL() uint32 {
	return (volatile.LoadUint32(&o.FUNC24_IN_SEL_CFG.Reg) & 0x40) >> 6
}

// GPIO.FUNC25_IN_SEL_CFG: GPIO input function configuration register
func (o *GPIO_Type) SetFUNC25_IN_SEL_CFG_FUNC_IN_SEL(value uint32) {
	volatile.StoreUint32(&o.FUNC25_IN_SEL_CFG.Reg, volatile.LoadUint32(&o.FUNC25_IN_SEL_CFG.Reg)&^(0x1f)|value)
}
func (o *GPIO_Type) GetFUNC25_IN_SEL_CFG_FUNC_IN_SEL() uint32 {
	return volatile.LoadUint32(&o.FUNC25_IN_SEL_CFG.Reg) & 0x1f
}
func (o *GPIO_Type) SetFUNC25_IN_SEL_CFG_FUNC_IN_INV_SEL(value uint32) {
	volatile.StoreUint32(&o.FUNC25_IN_SEL_CFG.Reg, volatile.LoadUint32(&o.FUNC25_IN_SEL_CFG.Reg)&^(0x20)|value<<5)
}
func (o *GPIO_Type) GetFUNC25_IN_SEL_CFG_FUNC_IN_INV_SEL() uint32 {
	return (volatile.LoadUint32(&o.FUNC25_IN_SEL_CFG.Reg) & 0x20) >> 5
}
func (o *GPIO_Type) SetFUNC25_IN_SEL_CFG_SIG_IN_SEL(value uint32) {
	volatile.StoreUint32(&o.FUNC25_IN_SEL_CFG.Reg, volatile.LoadUint32(&o.FUNC25_IN_SEL_CFG.Reg)&^(0x40)|value<<6)
}
func (o *GPIO_Type) GetFUNC25_IN_SEL_CFG_SIG_IN_SEL() uint32 {
	return (volatile.LoadUint32(&o.FUNC25_IN_SEL_CFG.Reg) & 0x40) >> 6
}

// GPIO.FUNC26_IN_SEL_CFG: GPIO input function configuration register
func (o *GPIO_Type) SetFUNC26_IN_SEL_CFG_FUNC_IN_SEL(value uint32) {
	volatile.StoreUint32(&o.FUNC26_IN_SEL_CFG.Reg, volatile.LoadUint32(&o.FUNC26_IN_SEL_CFG.Reg)&^(0x1f)|value)
}
func (o *GPIO_Type) GetFUNC26_IN_SEL_CFG_FUNC_IN_SEL() uint32 {
	return volatile.LoadUint32(&o.FUNC26_IN_SEL_CFG.Reg) & 0x1f
}
func (o *GPIO_Type) SetFUNC26_IN_SEL_CFG_FUNC_IN_INV_SEL(value uint32) {
	volatile.StoreUint32(&o.FUNC26_IN_SEL_CFG.Reg, volatile.LoadUint32(&o.FUNC26_IN_SEL_CFG.Reg)&^(0x20)|value<<5)
}
func (o *GPIO_Type) GetFUNC26_IN_SEL_CFG_FUNC_IN_INV_SEL() uint32 {
	return (volatile.LoadUint32(&o.FUNC26_IN_SEL_CFG.Reg) & 0x20) >> 5
}
func (o *GPIO_Type) SetFUNC26_IN_SEL_CFG_SIG_IN_SEL(value uint32) {
	volatile.StoreUint32(&o.FUNC26_IN_SEL_CFG.Reg, volatile.LoadUint32(&o.FUNC26_IN_SEL_CFG.Reg)&^(0x40)|value<<6)
}
func (o *GPIO_Type) GetFUNC26_IN_SEL_CFG_SIG_IN_SEL() uint32 {
	return (volatile.LoadUint32(&o.FUNC26_IN_SEL_CFG.Reg) & 0x40) >> 6
}

// GPIO.FUNC27_IN_SEL_CFG: GPIO input function configuration register
func (o *GPIO_Type) SetFUNC27_IN_SEL_CFG_FUNC_IN_SEL(value uint32) {
	volatile.StoreUint32(&o.FUNC27_IN_SEL_CFG.Reg, volatile.LoadUint32(&o.FUNC27_IN_SEL_CFG.Reg)&^(0x1f)|value)
}
func (o *GPIO_Type) GetFUNC27_IN_SEL_CFG_FUNC_IN_SEL() uint32 {
	return volatile.LoadUint32(&o.FUNC27_IN_SEL_CFG.Reg) & 0x1f
}
func (o *GPIO_Type) SetFUNC27_IN_SEL_CFG_FUNC_IN_INV_SEL(value uint32) {
	volatile.StoreUint32(&o.FUNC27_IN_SEL_CFG.Reg, volatile.LoadUint32(&o.FUNC27_IN_SEL_CFG.Reg)&^(0x20)|value<<5)
}
func (o *GPIO_Type) GetFUNC27_IN_SEL_CFG_FUNC_IN_INV_SEL() uint32 {
	return (volatile.LoadUint32(&o.FUNC27_IN_SEL_CFG.Reg) & 0x20) >> 5
}
func (o *GPIO_Type) SetFUNC27_IN_SEL_CFG_SIG_IN_SEL(value uint32) {
	volatile.StoreUint32(&o.FUNC27_IN_SEL_CFG.Reg, volatile.LoadUint32(&o.FUNC27_IN_SEL_CFG.Reg)&^(0x40)|value<<6)
}
func (o *GPIO_Type) GetFUNC27_IN_SEL_CFG_SIG_IN_SEL() uint32 {
	return (volatile.LoadUint32(&o.FUNC27_IN_SEL_CFG.Reg) & 0x40) >> 6
}

// GPIO.FUNC28_IN_SEL_CFG: GPIO input function configuration register
func (o *GPIO_Type) SetFUNC28_IN_SEL_CFG_FUNC_IN_SEL(value uint32) {
	volatile.StoreUint32(&o.FUNC28_IN_SEL_CFG.Reg, volatile.LoadUint32(&o.FUNC28_IN_SEL_CFG.Reg)&^(0x1f)|value)
}
func (o *GPIO_Type) GetFUNC28_IN_SEL_CFG_FUNC_IN_SEL() uint32 {
	return volatile.LoadUint32(&o.FUNC28_IN_SEL_CFG.Reg) & 0x1f
}
func (o *GPIO_Type) SetFUNC28_IN_SEL_CFG_FUNC_IN_INV_SEL(value uint32) {
	volatile.StoreUint32(&o.FUNC28_IN_SEL_CFG.Reg, volatile.LoadUint32(&o.FUNC28_IN_SEL_CFG.Reg)&^(0x20)|value<<5)
}
func (o *GPIO_Type) GetFUNC28_IN_SEL_CFG_FUNC_IN_INV_SEL() uint32 {
	return (volatile.LoadUint32(&o.FUNC28_IN_SEL_CFG.Reg) & 0x20) >> 5
}
func (o *GPIO_Type) SetFUNC28_IN_SEL_CFG_SIG_IN_SEL(value uint32) {
	volatile.StoreUint32(&o.FUNC28_IN_SEL_CFG.Reg, volatile.LoadUint32(&o.FUNC28_IN_SEL_CFG.Reg)&^(0x40)|value<<6)
}
func (o *GPIO_Type) GetFUNC28_IN_SEL_CFG_SIG_IN_SEL() uint32 {
	return (volatile.LoadUint32(&o.FUNC28_IN_SEL_CFG.Reg) & 0x40) >> 6
}

// GPIO.FUNC29_IN_SEL_CFG: GPIO input function configuration register
func (o *GPIO_Type) SetFUNC29_IN_SEL_CFG_FUNC_IN_SEL(value uint32) {
	volatile.StoreUint32(&o.FUNC29_IN_SEL_CFG.Reg, volatile.LoadUint32(&o.FUNC29_IN_SEL_CFG.Reg)&^(0x1f)|value)
}
func (o *GPIO_Type) GetFUNC29_IN_SEL_CFG_FUNC_IN_SEL() uint32 {
	return volatile.LoadUint32(&o.FUNC29_IN_SEL_CFG.Reg) & 0x1f
}
func (o *GPIO_Type) SetFUNC29_IN_SEL_CFG_FUNC_IN_INV_SEL(value uint32) {
	volatile.StoreUint32(&o.FUNC29_IN_SEL_CFG.Reg, volatile.LoadUint32(&o.FUNC29_IN_SEL_CFG.Reg)&^(0x20)|value<<5)
}
func (o *GPIO_Type) GetFUNC29_IN_SEL_CFG_FUNC_IN_INV_SEL() uint32 {
	return (volatile.LoadUint32(&o.FUNC29_IN_SEL_CFG.Reg) & 0x20) >> 5
}
func (o *GPIO_Type) SetFUNC29_IN_SEL_CFG_SIG_IN_SEL(value uint32) {
	volatile.StoreUint32(&o.FUNC29_IN_SEL_CFG.Reg, volatile.LoadUint32(&o.FUNC29_IN_SEL_CFG.Reg)&^(0x40)|value<<6)
}
func (o *GPIO_Type) GetFUNC29_IN_SEL_CFG_SIG_IN_SEL() uint32 {
	return (volatile.LoadUint32(&o.FUNC29_IN_SEL_CFG.Reg) & 0x40) >> 6
}

// GPIO.FUNC30_IN_SEL_CFG: GPIO input function configuration register
func (o *GPIO_Type) SetFUNC30_IN_SEL_CFG_FUNC_IN_SEL(value uint32) {
	volatile.StoreUint32(&o.FUNC30_IN_SEL_CFG.Reg, volatile.LoadUint32(&o.FUNC30_IN_SEL_CFG.Reg)&^(0x1f)|value)
}
func (o *GPIO_Type) GetFUNC30_IN_SEL_CFG_FUNC_IN_SEL() uint32 {
	return volatile.LoadUint32(&o.FUNC30_IN_SEL_CFG.Reg) & 0x1f
}
func (o *GPIO_Type) SetFUNC30_IN_SEL_CFG_FUNC_IN_INV_SEL(value uint32) {
	volatile.StoreUint32(&o.FUNC30_IN_SEL_CFG.Reg, volatile.LoadUint32(&o.FUNC30_IN_SEL_CFG.Reg)&^(0x20)|value<<5)
}
func (o *GPIO_Type) GetFUNC30_IN_SEL_CFG_FUNC_IN_INV_SEL() uint32 {
	return (volatile.LoadUint32(&o.FUNC30_IN_SEL_CFG.Reg) & 0x20) >> 5
}
func (o *GPIO_Type) SetFUNC30_IN_SEL_CFG_SIG_IN_SEL(value uint32) {
	volatile.StoreUint32(&o.FUNC30_IN_SEL_CFG.Reg, volatile.LoadUint32(&o.FUNC30_IN_SEL_CFG.Reg)&^(0x40)|value<<6)
}
func (o *GPIO_Type) GetFUNC30_IN_SEL_CFG_SIG_IN_SEL() uint32 {
	return (volatile.LoadUint32(&o.FUNC30_IN_SEL_CFG.Reg) & 0x40) >> 6
}

// GPIO.FUNC31_IN_SEL_CFG: GPIO input function configuration register
func (o *GPIO_Type) SetFUNC31_IN_SEL_CFG_FUNC_IN_SEL(value uint32) {
	volatile.StoreUint32(&o.FUNC31_IN_SEL_CFG.Reg, volatile.LoadUint32(&o.FUNC31_IN_SEL_CFG.Reg)&^(0x1f)|value)
}
func (o *GPIO_Type) GetFUNC31_IN_SEL_CFG_FUNC_IN_SEL() uint32 {
	return volatile.LoadUint32(&o.FUNC31_IN_SEL_CFG.Reg) & 0x1f
}
func (o *GPIO_Type) SetFUNC31_IN_SEL_CFG_FUNC_IN_INV_SEL(value uint32) {
	volatile.StoreUint32(&o.FUNC31_IN_SEL_CFG.Reg, volatile.LoadUint32(&o.FUNC31_IN_SEL_CFG.Reg)&^(0x20)|value<<5)
}
func (o *GPIO_Type) GetFUNC31_IN_SEL_CFG_FUNC_IN_INV_SEL() uint32 {
	return (volatile.LoadUint32(&o.FUNC31_IN_SEL_CFG.Reg) & 0x20) >> 5
}
func (o *GPIO_Type) SetFUNC31_IN_SEL_CFG_SIG_IN_SEL(value uint32) {
	volatile.StoreUint32(&o.FUNC31_IN_SEL_CFG.Reg, volatile.LoadUint32(&o.FUNC31_IN_SEL_CFG.Reg)&^(0x40)|value<<6)
}
func (o *GPIO_Type) GetFUNC31_IN_SEL_CFG_SIG_IN_SEL() uint32 {
	return (volatile.LoadUint32(&o.FUNC31_IN_SEL_CFG.Reg) & 0x40) >> 6
}

// GPIO.FUNC32_IN_SEL_CFG: GPIO input function configuration register
func (o *GPIO_Type) SetFUNC32_IN_SEL_CFG_FUNC_IN_SEL(value uint32) {
	volatile.StoreUint32(&o.FUNC32_IN_SEL_CFG.Reg, volatile.LoadUint32(&o.FUNC32_IN_SEL_CFG.Reg)&^(0x1f)|value)
}
func (o *GPIO_Type) GetFUNC32_IN_SEL_CFG_FUNC_IN_SEL() uint32 {
	return volatile.LoadUint32(&o.FUNC32_IN_SEL_CFG.Reg) & 0x1f
}
func (o *GPIO_Type) SetFUNC32_IN_SEL_CFG_FUNC_IN_INV_SEL(value uint32) {
	volatile.StoreUint32(&o.FUNC32_IN_SEL_CFG.Reg, volatile.LoadUint32(&o.FUNC32_IN_SEL_CFG.Reg)&^(0x20)|value<<5)
}
func (o *GPIO_Type) GetFUNC32_IN_SEL_CFG_FUNC_IN_INV_SEL() uint32 {
	return (volatile.LoadUint32(&o.FUNC32_IN_SEL_CFG.Reg) & 0x20) >> 5
}
func (o *GPIO_Type) SetFUNC32_IN_SEL_CFG_SIG_IN_SEL(value uint32) {
	volatile.StoreUint32(&o.FUNC32_IN_SEL_CFG.Reg, volatile.LoadUint32(&o.FUNC32_IN_SEL_CFG.Reg)&^(0x40)|value<<6)
}
func (o *GPIO_Type) GetFUNC32_IN_SEL_CFG_SIG_IN_SEL() uint32 {
	return (volatile.LoadUint32(&o.FUNC32_IN_SEL_CFG.Reg) & 0x40) >> 6
}

// GPIO.FUNC33_IN_SEL_CFG: GPIO input function configuration register
func (o *GPIO_Type) SetFUNC33_IN_SEL_CFG_FUNC_IN_SEL(value uint32) {
	volatile.StoreUint32(&o.FUNC33_IN_SEL_CFG.Reg, volatile.LoadUint32(&o.FUNC33_IN_SEL_CFG.Reg)&^(0x1f)|value)
}
func (o *GPIO_Type) GetFUNC33_IN_SEL_CFG_FUNC_IN_SEL() uint32 {
	return volatile.LoadUint32(&o.FUNC33_IN_SEL_CFG.Reg) & 0x1f
}
func (o *GPIO_Type) SetFUNC33_IN_SEL_CFG_FUNC_IN_INV_SEL(value uint32) {
	volatile.StoreUint32(&o.FUNC33_IN_SEL_CFG.Reg, volatile.LoadUint32(&o.FUNC33_IN_SEL_CFG.Reg)&^(0x20)|value<<5)
}
func (o *GPIO_Type) GetFUNC33_IN_SEL_CFG_FUNC_IN_INV_SEL() uint32 {
	return (volatile.LoadUint32(&o.FUNC33_IN_SEL_CFG.Reg) & 0x20) >> 5
}
func (o *GPIO_Type) SetFUNC33_IN_SEL_CFG_SIG_IN_SEL(value uint32) {
	volatile.StoreUint32(&o.FUNC33_IN_SEL_CFG.Reg, volatile.LoadUint32(&o.FUNC33_IN_SEL_CFG.Reg)&^(0x40)|value<<6)
}
func (o *GPIO_Type) GetFUNC33_IN_SEL_CFG_SIG_IN_SEL() uint32 {
	return (volatile.LoadUint32(&o.FUNC33_IN_SEL_CFG.Reg) & 0x40) >> 6
}

// GPIO.FUNC34_IN_SEL_CFG: GPIO input function configuration register
func (o *GPIO_Type) SetFUNC34_IN_SEL_CFG_FUNC_IN_SEL(value uint32) {
	volatile.StoreUint32(&o.FUNC34_IN_SEL_CFG.Reg, volatile.LoadUint32(&o.FUNC34_IN_SEL_CFG.Reg)&^(0x1f)|value)
}
func (o *GPIO_Type) GetFUNC34_IN_SEL_CFG_FUNC_IN_SEL() uint32 {
	return volatile.LoadUint32(&o.FUNC34_IN_SEL_CFG.Reg) & 0x1f
}
func (o *GPIO_Type) SetFUNC34_IN_SEL_CFG_FUNC_IN_INV_SEL(value uint32) {
	volatile.StoreUint32(&o.FUNC34_IN_SEL_CFG.Reg, volatile.LoadUint32(&o.FUNC34_IN_SEL_CFG.Reg)&^(0x20)|value<<5)
}
func (o *GPIO_Type) GetFUNC34_IN_SEL_CFG_FUNC_IN_INV_SEL() uint32 {
	return (volatile.LoadUint32(&o.FUNC34_IN_SEL_CFG.Reg) & 0x20) >> 5
}
func (o *GPIO_Type) SetFUNC34_IN_SEL_CFG_SIG_IN_SEL(value uint32) {
	volatile.StoreUint32(&o.FUNC34_IN_SEL_CFG.Reg, volatile.LoadUint32(&o.FUNC34_IN_SEL_CFG.Reg)&^(0x40)|value<<6)
}
func (o *GPIO_Type) GetFUNC34_IN_SEL_CFG_SIG_IN_SEL() uint32 {
	return (volatile.LoadUint32(&o.FUNC34_IN_SEL_CFG.Reg) & 0x40) >> 6
}

// GPIO.FUNC35_IN_SEL_CFG: GPIO input function configuration register
func (o *GPIO_Type) SetFUNC35_IN_SEL_CFG_FUNC_IN_SEL(value uint32) {
	volatile.StoreUint32(&o.FUNC35_IN_SEL_CFG.Reg, volatile.LoadUint32(&o.FUNC35_IN_SEL_CFG.Reg)&^(0x1f)|value)
}
func (o *GPIO_Type) GetFUNC35_IN_SEL_CFG_FUNC_IN_SEL() uint32 {
	return volatile.LoadUint32(&o.FUNC35_IN_SEL_CFG.Reg) & 0x1f
}
func (o *GPIO_Type) SetFUNC35_IN_SEL_CFG_FUNC_IN_INV_SEL(value uint32) {
	volatile.StoreUint32(&o.FUNC35_IN_SEL_CFG.Reg, volatile.LoadUint32(&o.FUNC35_IN_SEL_CFG.Reg)&^(0x20)|value<<5)
}
func (o *GPIO_Type) GetFUNC35_IN_SEL_CFG_FUNC_IN_INV_SEL() uint32 {
	return (volatile.LoadUint32(&o.FUNC35_IN_SEL_CFG.Reg) & 0x20) >> 5
}
func (o *GPIO_Type) SetFUNC35_IN_SEL_CFG_SIG_IN_SEL(value uint32) {
	volatile.StoreUint32(&o.FUNC35_IN_SEL_CFG.Reg, volatile.LoadUint32(&o.FUNC35_IN_SEL_CFG.Reg)&^(0x40)|value<<6)
}
func (o *GPIO_Type) GetFUNC35_IN_SEL_CFG_SIG_IN_SEL() uint32 {
	return (volatile.LoadUint32(&o.FUNC35_IN_SEL_CFG.Reg) & 0x40) >> 6
}

// GPIO.FUNC36_IN_SEL_CFG: GPIO input function configuration register
func (o *GPIO_Type) SetFUNC36_IN_SEL_CFG_FUNC_IN_SEL(value uint32) {
	volatile.StoreUint32(&o.FUNC36_IN_SEL_CFG.Reg, volatile.LoadUint32(&o.FUNC36_IN_SEL_CFG.Reg)&^(0x1f)|value)
}
func (o *GPIO_Type) GetFUNC36_IN_SEL_CFG_FUNC_IN_SEL() uint32 {
	return volatile.LoadUint32(&o.FUNC36_IN_SEL_CFG.Reg) & 0x1f
}
func (o *GPIO_Type) SetFUNC36_IN_SEL_CFG_FUNC_IN_INV_SEL(value uint32) {
	volatile.StoreUint32(&o.FUNC36_IN_SEL_CFG.Reg, volatile.LoadUint32(&o.FUNC36_IN_SEL_CFG.Reg)&^(0x20)|value<<5)
}
func (o *GPIO_Type) GetFUNC36_IN_SEL_CFG_FUNC_IN_INV_SEL() uint32 {
	return (volatile.LoadUint32(&o.FUNC36_IN_SEL_CFG.Reg) & 0x20) >> 5
}
func (o *GPIO_Type) SetFUNC36_IN_SEL_CFG_SIG_IN_SEL(value uint32) {
	volatile.StoreUint32(&o.FUNC36_IN_SEL_CFG.Reg, volatile.LoadUint32(&o.FUNC36_IN_SEL_CFG.Reg)&^(0x40)|value<<6)
}
func (o *GPIO_Type) GetFUNC36_IN_SEL_CFG_SIG_IN_SEL() uint32 {
	return (volatile.LoadUint32(&o.FUNC36_IN_SEL_CFG.Reg) & 0x40) >> 6
}

// GPIO.FUNC37_IN_SEL_CFG: GPIO input function configuration register
func (o *GPIO_Type) SetFUNC37_IN_SEL_CFG_FUNC_IN_SEL(value uint32) {
	volatile.StoreUint32(&o.FUNC37_IN_SEL_CFG.Reg, volatile.LoadUint32(&o.FUNC37_IN_SEL_CFG.Reg)&^(0x1f)|value)
}
func (o *GPIO_Type) GetFUNC37_IN_SEL_CFG_FUNC_IN_SEL() uint32 {
	return volatile.LoadUint32(&o.FUNC37_IN_SEL_CFG.Reg) & 0x1f
}
func (o *GPIO_Type) SetFUNC37_IN_SEL_CFG_FUNC_IN_INV_SEL(value uint32) {
	volatile.StoreUint32(&o.FUNC37_IN_SEL_CFG.Reg, volatile.LoadUint32(&o.FUNC37_IN_SEL_CFG.Reg)&^(0x20)|value<<5)
}
func (o *GPIO_Type) GetFUNC37_IN_SEL_CFG_FUNC_IN_INV_SEL() uint32 {
	return (volatile.LoadUint32(&o.FUNC37_IN_SEL_CFG.Reg) & 0x20) >> 5
}
func (o *GPIO_Type) SetFUNC37_IN_SEL_CFG_SIG_IN_SEL(value uint32) {
	volatile.StoreUint32(&o.FUNC37_IN_SEL_CFG.Reg, volatile.LoadUint32(&o.FUNC37_IN_SEL_CFG.Reg)&^(0x40)|value<<6)
}
func (o *GPIO_Type) GetFUNC37_IN_SEL_CFG_SIG_IN_SEL() uint32 {
	return (volatile.LoadUint32(&o.FUNC37_IN_SEL_CFG.Reg) & 0x40) >> 6
}

// GPIO.FUNC38_IN_SEL_CFG: GPIO input function configuration register
func (o *GPIO_Type) SetFUNC38_IN_SEL_CFG_FUNC_IN_SEL(value uint32) {
	volatile.StoreUint32(&o.FUNC38_IN_SEL_CFG.Reg, volatile.LoadUint32(&o.FUNC38_IN_SEL_CFG.Reg)&^(0x1f)|value)
}
func (o *GPIO_Type) GetFUNC38_IN_SEL_CFG_FUNC_IN_SEL() uint32 {
	return volatile.LoadUint32(&o.FUNC38_IN_SEL_CFG.Reg) & 0x1f
}
func (o *GPIO_Type) SetFUNC38_IN_SEL_CFG_FUNC_IN_INV_SEL(value uint32) {
	volatile.StoreUint32(&o.FUNC38_IN_SEL_CFG.Reg, volatile.LoadUint32(&o.FUNC38_IN_SEL_CFG.Reg)&^(0x20)|value<<5)
}
func (o *GPIO_Type) GetFUNC38_IN_SEL_CFG_FUNC_IN_INV_SEL() uint32 {
	return (volatile.LoadUint32(&o.FUNC38_IN_SEL_CFG.Reg) & 0x20) >> 5
}
func (o *GPIO_Type) SetFUNC38_IN_SEL_CFG_SIG_IN_SEL(value uint32) {
	volatile.StoreUint32(&o.FUNC38_IN_SEL_CFG.Reg, volatile.LoadUint32(&o.FUNC38_IN_SEL_CFG.Reg)&^(0x40)|value<<6)
}
func (o *GPIO_Type) GetFUNC38_IN_SEL_CFG_SIG_IN_SEL() uint32 {
	return (volatile.LoadUint32(&o.FUNC38_IN_SEL_CFG.Reg) & 0x40) >> 6
}

// GPIO.FUNC39_IN_SEL_CFG: GPIO input function configuration register
func (o *GPIO_Type) SetFUNC39_IN_SEL_CFG_FUNC_IN_SEL(value uint32) {
	volatile.StoreUint32(&o.FUNC39_IN_SEL_CFG.Reg, volatile.LoadUint32(&o.FUNC39_IN_SEL_CFG.Reg)&^(0x1f)|value)
}
func (o *GPIO_Type) GetFUNC39_IN_SEL_CFG_FUNC_IN_SEL() uint32 {
	return volatile.LoadUint32(&o.FUNC39_IN_SEL_CFG.Reg) & 0x1f
}
func (o *GPIO_Type) SetFUNC39_IN_SEL_CFG_FUNC_IN_INV_SEL(value uint32) {
	volatile.StoreUint32(&o.FUNC39_IN_SEL_CFG.Reg, volatile.LoadUint32(&o.FUNC39_IN_SEL_CFG.Reg)&^(0x20)|value<<5)
}
func (o *GPIO_Type) GetFUNC39_IN_SEL_CFG_FUNC_IN_INV_SEL() uint32 {
	return (volatile.LoadUint32(&o.FUNC39_IN_SEL_CFG.Reg) & 0x20) >> 5
}
func (o *GPIO_Type) SetFUNC39_IN_SEL_CFG_SIG_IN_SEL(value uint32) {
	volatile.StoreUint32(&o.FUNC39_IN_SEL_CFG.Reg, volatile.LoadUint32(&o.FUNC39_IN_SEL_CFG.Reg)&^(0x40)|value<<6)
}
func (o *GPIO_Type) GetFUNC39_IN_SEL_CFG_SIG_IN_SEL() uint32 {
	return (volatile.LoadUint32(&o.FUNC39_IN_SEL_CFG.Reg) & 0x40) >> 6
}

// GPIO.FUNC40_IN_SEL_CFG: GPIO input function configuration register
func (o *GPIO_Type) SetFUNC40_IN_SEL_CFG_FUNC_IN_SEL(value uint32) {
	volatile.StoreUint32(&o.FUNC40_IN_SEL_CFG.Reg, volatile.LoadUint32(&o.FUNC40_IN_SEL_CFG.Reg)&^(0x1f)|value)
}
func (o *GPIO_Type) GetFUNC40_IN_SEL_CFG_FUNC_IN_SEL() uint32 {
	return volatile.LoadUint32(&o.FUNC40_IN_SEL_CFG.Reg) & 0x1f
}
func (o *GPIO_Type) SetFUNC40_IN_SEL_CFG_FUNC_IN_INV_SEL(value uint32) {
	volatile.StoreUint32(&o.FUNC40_IN_SEL_CFG.Reg, volatile.LoadUint32(&o.FUNC40_IN_SEL_CFG.Reg)&^(0x20)|value<<5)
}
func (o *GPIO_Type) GetFUNC40_IN_SEL_CFG_FUNC_IN_INV_SEL() uint32 {
	return (volatile.LoadUint32(&o.FUNC40_IN_SEL_CFG.Reg) & 0x20) >> 5
}
func (o *GPIO_Type) SetFUNC40_IN_SEL_CFG_SIG_IN_SEL(value uint32) {
	volatile.StoreUint32(&o.FUNC40_IN_SEL_CFG.Reg, volatile.LoadUint32(&o.FUNC40_IN_SEL_CFG.Reg)&^(0x40)|value<<6)
}
func (o *GPIO_Type) GetFUNC40_IN_SEL_CFG_SIG_IN_SEL() uint32 {
	return (volatile.LoadUint32(&o.FUNC40_IN_SEL_CFG.Reg) & 0x40) >> 6
}

// GPIO.FUNC41_IN_SEL_CFG: GPIO input function configuration register
func (o *GPIO_Type) SetFUNC41_IN_SEL_CFG_FUNC_IN_SEL(value uint32) {
	volatile.StoreUint32(&o.FUNC41_IN_SEL_CFG.Reg, volatile.LoadUint32(&o.FUNC41_IN_SEL_CFG.Reg)&^(0x1f)|value)
}
func (o *GPIO_Type) GetFUNC41_IN_SEL_CFG_FUNC_IN_SEL() uint32 {
	return volatile.LoadUint32(&o.FUNC41_IN_SEL_CFG.Reg) & 0x1f
}
func (o *GPIO_Type) SetFUNC41_IN_SEL_CFG_FUNC_IN_INV_SEL(value uint32) {
	volatile.StoreUint32(&o.FUNC41_IN_SEL_CFG.Reg, volatile.LoadUint32(&o.FUNC41_IN_SEL_CFG.Reg)&^(0x20)|value<<5)
}
func (o *GPIO_Type) GetFUNC41_IN_SEL_CFG_FUNC_IN_INV_SEL() uint32 {
	return (volatile.LoadUint32(&o.FUNC41_IN_SEL_CFG.Reg) & 0x20) >> 5
}
func (o *GPIO_Type) SetFUNC41_IN_SEL_CFG_SIG_IN_SEL(value uint32) {
	volatile.StoreUint32(&o.FUNC41_IN_SEL_CFG.Reg, volatile.LoadUint32(&o.FUNC41_IN_SEL_CFG.Reg)&^(0x40)|value<<6)
}
func (o *GPIO_Type) GetFUNC41_IN_SEL_CFG_SIG_IN_SEL() uint32 {
	return (volatile.LoadUint32(&o.FUNC41_IN_SEL_CFG.Reg) & 0x40) >> 6
}

// GPIO.FUNC42_IN_SEL_CFG: GPIO input function configuration register
func (o *GPIO_Type) SetFUNC42_IN_SEL_CFG_FUNC_IN_SEL(value uint32) {
	volatile.StoreUint32(&o.FUNC42_IN_SEL_CFG.Reg, volatile.LoadUint32(&o.FUNC42_IN_SEL_CFG.Reg)&^(0x1f)|value)
}
func (o *GPIO_Type) GetFUNC42_IN_SEL_CFG_FUNC_IN_SEL() uint32 {
	return volatile.LoadUint32(&o.FUNC42_IN_SEL_CFG.Reg) & 0x1f
}
func (o *GPIO_Type) SetFUNC42_IN_SEL_CFG_FUNC_IN_INV_SEL(value uint32) {
	volatile.StoreUint32(&o.FUNC42_IN_SEL_CFG.Reg, volatile.LoadUint32(&o.FUNC42_IN_SEL_CFG.Reg)&^(0x20)|value<<5)
}
func (o *GPIO_Type) GetFUNC42_IN_SEL_CFG_FUNC_IN_INV_SEL() uint32 {
	return (volatile.LoadUint32(&o.FUNC42_IN_SEL_CFG.Reg) & 0x20) >> 5
}
func (o *GPIO_Type) SetFUNC42_IN_SEL_CFG_SIG_IN_SEL(value uint32) {
	volatile.StoreUint32(&o.FUNC42_IN_SEL_CFG.Reg, volatile.LoadUint32(&o.FUNC42_IN_SEL_CFG.Reg)&^(0x40)|value<<6)
}
func (o *GPIO_Type) GetFUNC42_IN_SEL_CFG_SIG_IN_SEL() uint32 {
	return (volatile.LoadUint32(&o.FUNC42_IN_SEL_CFG.Reg) & 0x40) >> 6
}

// GPIO.FUNC43_IN_SEL_CFG: GPIO input function configuration register
func (o *GPIO_Type) SetFUNC43_IN_SEL_CFG_FUNC_IN_SEL(value uint32) {
	volatile.StoreUint32(&o.FUNC43_IN_SEL_CFG.Reg, volatile.LoadUint32(&o.FUNC43_IN_SEL_CFG.Reg)&^(0x1f)|value)
}
func (o *GPIO_Type) GetFUNC43_IN_SEL_CFG_FUNC_IN_SEL() uint32 {
	return volatile.LoadUint32(&o.FUNC43_IN_SEL_CFG.Reg) & 0x1f
}
func (o *GPIO_Type) SetFUNC43_IN_SEL_CFG_FUNC_IN_INV_SEL(value uint32) {
	volatile.StoreUint32(&o.FUNC43_IN_SEL_CFG.Reg, volatile.LoadUint32(&o.FUNC43_IN_SEL_CFG.Reg)&^(0x20)|value<<5)
}
func (o *GPIO_Type) GetFUNC43_IN_SEL_CFG_FUNC_IN_INV_SEL() uint32 {
	return (volatile.LoadUint32(&o.FUNC43_IN_SEL_CFG.Reg) & 0x20) >> 5
}
func (o *GPIO_Type) SetFUNC43_IN_SEL_CFG_SIG_IN_SEL(value uint32) {
	volatile.StoreUint32(&o.FUNC43_IN_SEL_CFG.Reg, volatile.LoadUint32(&o.FUNC43_IN_SEL_CFG.Reg)&^(0x40)|value<<6)
}
func (o *GPIO_Type) GetFUNC43_IN_SEL_CFG_SIG_IN_SEL() uint32 {
	return (volatile.LoadUint32(&o.FUNC43_IN_SEL_CFG.Reg) & 0x40) >> 6
}

// GPIO.FUNC44_IN_SEL_CFG: GPIO input function configuration register
func (o *GPIO_Type) SetFUNC44_IN_SEL_CFG_FUNC_IN_SEL(value uint32) {
	volatile.StoreUint32(&o.FUNC44_IN_SEL_CFG.Reg, volatile.LoadUint32(&o.FUNC44_IN_SEL_CFG.Reg)&^(0x1f)|value)
}
func (o *GPIO_Type) GetFUNC44_IN_SEL_CFG_FUNC_IN_SEL() uint32 {
	return volatile.LoadUint32(&o.FUNC44_IN_SEL_CFG.Reg) & 0x1f
}
func (o *GPIO_Type) SetFUNC44_IN_SEL_CFG_FUNC_IN_INV_SEL(value uint32) {
	volatile.StoreUint32(&o.FUNC44_IN_SEL_CFG.Reg, volatile.LoadUint32(&o.FUNC44_IN_SEL_CFG.Reg)&^(0x20)|value<<5)
}
func (o *GPIO_Type) GetFUNC44_IN_SEL_CFG_FUNC_IN_INV_SEL() uint32 {
	return (volatile.LoadUint32(&o.FUNC44_IN_SEL_CFG.Reg) & 0x20) >> 5
}
func (o *GPIO_Type) SetFUNC44_IN_SEL_CFG_SIG_IN_SEL(value uint32) {
	volatile.StoreUint32(&o.FUNC44_IN_SEL_CFG.Reg, volatile.LoadUint32(&o.FUNC44_IN_SEL_CFG.Reg)&^(0x40)|value<<6)
}
func (o *GPIO_Type) GetFUNC44_IN_SEL_CFG_SIG_IN_SEL() uint32 {
	return (volatile.LoadUint32(&o.FUNC44_IN_SEL_CFG.Reg) & 0x40) >> 6
}

// GPIO.FUNC45_IN_SEL_CFG: GPIO input function configuration register
func (o *GPIO_Type) SetFUNC45_IN_SEL_CFG_FUNC_IN_SEL(value uint32) {
	volatile.StoreUint32(&o.FUNC45_IN_SEL_CFG.Reg, volatile.LoadUint32(&o.FUNC45_IN_SEL_CFG.Reg)&^(0x1f)|value)
}
func (o *GPIO_Type) GetFUNC45_IN_SEL_CFG_FUNC_IN_SEL() uint32 {
	return volatile.LoadUint32(&o.FUNC45_IN_SEL_CFG.Reg) & 0x1f
}
func (o *GPIO_Type) SetFUNC45_IN_SEL_CFG_FUNC_IN_INV_SEL(value uint32) {
	volatile.StoreUint32(&o.FUNC45_IN_SEL_CFG.Reg, volatile.LoadUint32(&o.FUNC45_IN_SEL_CFG.Reg)&^(0x20)|value<<5)
}
func (o *GPIO_Type) GetFUNC45_IN_SEL_CFG_FUNC_IN_INV_SEL() uint32 {
	return (volatile.LoadUint32(&o.FUNC45_IN_SEL_CFG.Reg) & 0x20) >> 5
}
func (o *GPIO_Type) SetFUNC45_IN_SEL_CFG_SIG_IN_SEL(value uint32) {
	volatile.StoreUint32(&o.FUNC45_IN_SEL_CFG.Reg, volatile.LoadUint32(&o.FUNC45_IN_SEL_CFG.Reg)&^(0x40)|value<<6)
}
func (o *GPIO_Type) GetFUNC45_IN_SEL_CFG_SIG_IN_SEL() uint32 {
	return (volatile.LoadUint32(&o.FUNC45_IN_SEL_CFG.Reg) & 0x40) >> 6
}

// GPIO.FUNC46_IN_SEL_CFG: GPIO input function configuration register
func (o *GPIO_Type) SetFUNC46_IN_SEL_CFG_FUNC_IN_SEL(value uint32) {
	volatile.StoreUint32(&o.FUNC46_IN_SEL_CFG.Reg, volatile.LoadUint32(&o.FUNC46_IN_SEL_CFG.Reg)&^(0x1f)|value)
}
func (o *GPIO_Type) GetFUNC46_IN_SEL_CFG_FUNC_IN_SEL() uint32 {
	return volatile.LoadUint32(&o.FUNC46_IN_SEL_CFG.Reg) & 0x1f
}
func (o *GPIO_Type) SetFUNC46_IN_SEL_CFG_FUNC_IN_INV_SEL(value uint32) {
	volatile.StoreUint32(&o.FUNC46_IN_SEL_CFG.Reg, volatile.LoadUint32(&o.FUNC46_IN_SEL_CFG.Reg)&^(0x20)|value<<5)
}
func (o *GPIO_Type) GetFUNC46_IN_SEL_CFG_FUNC_IN_INV_SEL() uint32 {
	return (volatile.LoadUint32(&o.FUNC46_IN_SEL_CFG.Reg) & 0x20) >> 5
}
func (o *GPIO_Type) SetFUNC46_IN_SEL_CFG_SIG_IN_SEL(value uint32) {
	volatile.StoreUint32(&o.FUNC46_IN_SEL_CFG.Reg, volatile.LoadUint32(&o.FUNC46_IN_SEL_CFG.Reg)&^(0x40)|value<<6)
}
func (o *GPIO_Type) GetFUNC46_IN_SEL_CFG_SIG_IN_SEL() uint32 {
	return (volatile.LoadUint32(&o.FUNC46_IN_SEL_CFG.Reg) & 0x40) >> 6
}

// GPIO.FUNC47_IN_SEL_CFG: GPIO input function configuration register
func (o *GPIO_Type) SetFUNC47_IN_SEL_CFG_FUNC_IN_SEL(value uint32) {
	volatile.StoreUint32(&o.FUNC47_IN_SEL_CFG.Reg, volatile.LoadUint32(&o.FUNC47_IN_SEL_CFG.Reg)&^(0x1f)|value)
}
func (o *GPIO_Type) GetFUNC47_IN_SEL_CFG_FUNC_IN_SEL() uint32 {
	return volatile.LoadUint32(&o.FUNC47_IN_SEL_CFG.Reg) & 0x1f
}
func (o *GPIO_Type) SetFUNC47_IN_SEL_CFG_FUNC_IN_INV_SEL(value uint32) {
	volatile.StoreUint32(&o.FUNC47_IN_SEL_CFG.Reg, volatile.LoadUint32(&o.FUNC47_IN_SEL_CFG.Reg)&^(0x20)|value<<5)
}
func (o *GPIO_Type) GetFUNC47_IN_SEL_CFG_FUNC_IN_INV_SEL() uint32 {
	return (volatile.LoadUint32(&o.FUNC47_IN_SEL_CFG.Reg) & 0x20) >> 5
}
func (o *GPIO_Type) SetFUNC47_IN_SEL_CFG_SIG_IN_SEL(value uint32) {
	volatile.StoreUint32(&o.FUNC47_IN_SEL_CFG.Reg, volatile.LoadUint32(&o.FUNC47_IN_SEL_CFG.Reg)&^(0x40)|value<<6)
}
func (o *GPIO_Type) GetFUNC47_IN_SEL_CFG_SIG_IN_SEL() uint32 {
	return (volatile.LoadUint32(&o.FUNC47_IN_SEL_CFG.Reg) & 0x40) >> 6
}

// GPIO.FUNC48_IN_SEL_CFG: GPIO input function configuration register
func (o *GPIO_Type) SetFUNC48_IN_SEL_CFG_FUNC_IN_SEL(value uint32) {
	volatile.StoreUint32(&o.FUNC48_IN_SEL_CFG.Reg, volatile.LoadUint32(&o.FUNC48_IN_SEL_CFG.Reg)&^(0x1f)|value)
}
func (o *GPIO_Type) GetFUNC48_IN_SEL_CFG_FUNC_IN_SEL() uint32 {
	return volatile.LoadUint32(&o.FUNC48_IN_SEL_CFG.Reg) & 0x1f
}
func (o *GPIO_Type) SetFUNC48_IN_SEL_CFG_FUNC_IN_INV_SEL(value uint32) {
	volatile.StoreUint32(&o.FUNC48_IN_SEL_CFG.Reg, volatile.LoadUint32(&o.FUNC48_IN_SEL_CFG.Reg)&^(0x20)|value<<5)
}
func (o *GPIO_Type) GetFUNC48_IN_SEL_CFG_FUNC_IN_INV_SEL() uint32 {
	return (volatile.LoadUint32(&o.FUNC48_IN_SEL_CFG.Reg) & 0x20) >> 5
}
func (o *GPIO_Type) SetFUNC48_IN_SEL_CFG_SIG_IN_SEL(value uint32) {
	volatile.StoreUint32(&o.FUNC48_IN_SEL_CFG.Reg, volatile.LoadUint32(&o.FUNC48_IN_SEL_CFG.Reg)&^(0x40)|value<<6)
}
func (o *GPIO_Type) GetFUNC48_IN_SEL_CFG_SIG_IN_SEL() uint32 {
	return (volatile.LoadUint32(&o.FUNC48_IN_SEL_CFG.Reg) & 0x40) >> 6
}

// GPIO.FUNC49_IN_SEL_CFG: GPIO input function configuration register
func (o *GPIO_Type) SetFUNC49_IN_SEL_CFG_FUNC_IN_SEL(value uint32) {
	volatile.StoreUint32(&o.FUNC49_IN_SEL_CFG.Reg, volatile.LoadUint32(&o.FUNC49_IN_SEL_CFG.Reg)&^(0x1f)|value)
}
func (o *GPIO_Type) GetFUNC49_IN_SEL_CFG_FUNC_IN_SEL() uint32 {
	return volatile.LoadUint32(&o.FUNC49_IN_SEL_CFG.Reg) & 0x1f
}
func (o *GPIO_Type) SetFUNC49_IN_SEL_CFG_FUNC_IN_INV_SEL(value uint32) {
	volatile.StoreUint32(&o.FUNC49_IN_SEL_CFG.Reg, volatile.LoadUint32(&o.FUNC49_IN_SEL_CFG.Reg)&^(0x20)|value<<5)
}
func (o *GPIO_Type) GetFUNC49_IN_SEL_CFG_FUNC_IN_INV_SEL() uint32 {
	return (volatile.LoadUint32(&o.FUNC49_IN_SEL_CFG.Reg) & 0x20) >> 5
}
func (o *GPIO_Type) SetFUNC49_IN_SEL_CFG_SIG_IN_SEL(value uint32) {
	volatile.StoreUint32(&o.FUNC49_IN_SEL_CFG.Reg, volatile.LoadUint32(&o.FUNC49_IN_SEL_CFG.Reg)&^(0x40)|value<<6)
}
func (o *GPIO_Type) GetFUNC49_IN_SEL_CFG_SIG_IN_SEL() uint32 {
	return (volatile.LoadUint32(&o.FUNC49_IN_SEL_CFG.Reg) & 0x40) >> 6
}

// GPIO.FUNC50_IN_SEL_CFG: GPIO input function configuration register
func (o *GPIO_Type) SetFUNC50_IN_SEL_CFG_FUNC_IN_SEL(value uint32) {
	volatile.StoreUint32(&o.FUNC50_IN_SEL_CFG.Reg, volatile.LoadUint32(&o.FUNC50_IN_SEL_CFG.Reg)&^(0x1f)|value)
}
func (o *GPIO_Type) GetFUNC50_IN_SEL_CFG_FUNC_IN_SEL() uint32 {
	return volatile.LoadUint32(&o.FUNC50_IN_SEL_CFG.Reg) & 0x1f
}
func (o *GPIO_Type) SetFUNC50_IN_SEL_CFG_FUNC_IN_INV_SEL(value uint32) {
	volatile.StoreUint32(&o.FUNC50_IN_SEL_CFG.Reg, volatile.LoadUint32(&o.FUNC50_IN_SEL_CFG.Reg)&^(0x20)|value<<5)
}
func (o *GPIO_Type) GetFUNC50_IN_SEL_CFG_FUNC_IN_INV_SEL() uint32 {
	return (volatile.LoadUint32(&o.FUNC50_IN_SEL_CFG.Reg) & 0x20) >> 5
}
func (o *GPIO_Type) SetFUNC50_IN_SEL_CFG_SIG_IN_SEL(value uint32) {
	volatile.StoreUint32(&o.FUNC50_IN_SEL_CFG.Reg, volatile.LoadUint32(&o.FUNC50_IN_SEL_CFG.Reg)&^(0x40)|value<<6)
}
func (o *GPIO_Type) GetFUNC50_IN_SEL_CFG_SIG_IN_SEL() uint32 {
	return (volatile.LoadUint32(&o.FUNC50_IN_SEL_CFG.Reg) & 0x40) >> 6
}

// GPIO.FUNC51_IN_SEL_CFG: GPIO input function configuration register
func (o *GPIO_Type) SetFUNC51_IN_SEL_CFG_FUNC_IN_SEL(value uint32) {
	volatile.StoreUint32(&o.FUNC51_IN_SEL_CFG.Reg, volatile.LoadUint32(&o.FUNC51_IN_SEL_CFG.Reg)&^(0x1f)|value)
}
func (o *GPIO_Type) GetFUNC51_IN_SEL_CFG_FUNC_IN_SEL() uint32 {
	return volatile.LoadUint32(&o.FUNC51_IN_SEL_CFG.Reg) & 0x1f
}
func (o *GPIO_Type) SetFUNC51_IN_SEL_CFG_FUNC_IN_INV_SEL(value uint32) {
	volatile.StoreUint32(&o.FUNC51_IN_SEL_CFG.Reg, volatile.LoadUint32(&o.FUNC51_IN_SEL_CFG.Reg)&^(0x20)|value<<5)
}
func (o *GPIO_Type) GetFUNC51_IN_SEL_CFG_FUNC_IN_INV_SEL() uint32 {
	return (volatile.LoadUint32(&o.FUNC51_IN_SEL_CFG.Reg) & 0x20) >> 5
}
func (o *GPIO_Type) SetFUNC51_IN_SEL_CFG_SIG_IN_SEL(value uint32) {
	volatile.StoreUint32(&o.FUNC51_IN_SEL_CFG.Reg, volatile.LoadUint32(&o.FUNC51_IN_SEL_CFG.Reg)&^(0x40)|value<<6)
}
func (o *GPIO_Type) GetFUNC51_IN_SEL_CFG_SIG_IN_SEL() uint32 {
	return (volatile.LoadUint32(&o.FUNC51_IN_SEL_CFG.Reg) & 0x40) >> 6
}

// GPIO.FUNC52_IN_SEL_CFG: GPIO input function configuration register
func (o *GPIO_Type) SetFUNC52_IN_SEL_CFG_FUNC_IN_SEL(value uint32) {
	volatile.StoreUint32(&o.FUNC52_IN_SEL_CFG.Reg, volatile.LoadUint32(&o.FUNC52_IN_SEL_CFG.Reg)&^(0x1f)|value)
}
func (o *GPIO_Type) GetFUNC52_IN_SEL_CFG_FUNC_IN_SEL() uint32 {
	return volatile.LoadUint32(&o.FUNC52_IN_SEL_CFG.Reg) & 0x1f
}
func (o *GPIO_Type) SetFUNC52_IN_SEL_CFG_FUNC_IN_INV_SEL(value uint32) {
	volatile.StoreUint32(&o.FUNC52_IN_SEL_CFG.Reg, volatile.LoadUint32(&o.FUNC52_IN_SEL_CFG.Reg)&^(0x20)|value<<5)
}
func (o *GPIO_Type) GetFUNC52_IN_SEL_CFG_FUNC_IN_INV_SEL() uint32 {
	return (volatile.LoadUint32(&o.FUNC52_IN_SEL_CFG.Reg) & 0x20) >> 5
}
func (o *GPIO_Type) SetFUNC52_IN_SEL_CFG_SIG_IN_SEL(value uint32) {
	volatile.StoreUint32(&o.FUNC52_IN_SEL_CFG.Reg, volatile.LoadUint32(&o.FUNC52_IN_SEL_CFG.Reg)&^(0x40)|value<<6)
}
func (o *GPIO_Type) GetFUNC52_IN_SEL_CFG_SIG_IN_SEL() uint32 {
	return (volatile.LoadUint32(&o.FUNC52_IN_SEL_CFG.Reg) & 0x40) >> 6
}

// GPIO.FUNC53_IN_SEL_CFG: GPIO input function configuration register
func (o *GPIO_Type) SetFUNC53_IN_SEL_CFG_FUNC_IN_SEL(value uint32) {
	volatile.StoreUint32(&o.FUNC53_IN_SEL_CFG.Reg, volatile.LoadUint32(&o.FUNC53_IN_SEL_CFG.Reg)&^(0x1f)|value)
}
func (o *GPIO_Type) GetFUNC53_IN_SEL_CFG_FUNC_IN_SEL() uint32 {
	return volatile.LoadUint32(&o.FUNC53_IN_SEL_CFG.Reg) & 0x1f
}
func (o *GPIO_Type) SetFUNC53_IN_SEL_CFG_FUNC_IN_INV_SEL(value uint32) {
	volatile.StoreUint32(&o.FUNC53_IN_SEL_CFG.Reg, volatile.LoadUint32(&o.FUNC53_IN_SEL_CFG.Reg)&^(0x20)|value<<5)
}
func (o *GPIO_Type) GetFUNC53_IN_SEL_CFG_FUNC_IN_INV_SEL() uint32 {
	return (volatile.LoadUint32(&o.FUNC53_IN_SEL_CFG.Reg) & 0x20) >> 5
}
func (o *GPIO_Type) SetFUNC53_IN_SEL_CFG_SIG_IN_SEL(value uint32) {
	volatile.StoreUint32(&o.FUNC53_IN_SEL_CFG.Reg, volatile.LoadUint32(&o.FUNC53_IN_SEL_CFG.Reg)&^(0x40)|value<<6)
}
func (o *GPIO_Type) GetFUNC53_IN_SEL_CFG_SIG_IN_SEL() uint32 {
	return (volatile.LoadUint32(&o.FUNC53_IN_SEL_CFG.Reg) & 0x40) >> 6
}

// GPIO.FUNC54_IN_SEL_CFG: GPIO input function configuration register
func (o *GPIO_Type) SetFUNC54_IN_SEL_CFG_FUNC_IN_SEL(value uint32) {
	volatile.StoreUint32(&o.FUNC54_IN_SEL_CFG.Reg, volatile.LoadUint32(&o.FUNC54_IN_SEL_CFG.Reg)&^(0x1f)|value)
}
func (o *GPIO_Type) GetFUNC54_IN_SEL_CFG_FUNC_IN_SEL() uint32 {
	return volatile.LoadUint32(&o.FUNC54_IN_SEL_CFG.Reg) & 0x1f
}
func (o *GPIO_Type) SetFUNC54_IN_SEL_CFG_FUNC_IN_INV_SEL(value uint32) {
	volatile.StoreUint32(&o.FUNC54_IN_SEL_CFG.Reg, volatile.LoadUint32(&o.FUNC54_IN_SEL_CFG.Reg)&^(0x20)|value<<5)
}
func (o *GPIO_Type) GetFUNC54_IN_SEL_CFG_FUNC_IN_INV_SEL() uint32 {
	return (volatile.LoadUint32(&o.FUNC54_IN_SEL_CFG.Reg) & 0x20) >> 5
}
func (o *GPIO_Type) SetFUNC54_IN_SEL_CFG_SIG_IN_SEL(value uint32) {
	volatile.StoreUint32(&o.FUNC54_IN_SEL_CFG.Reg, volatile.LoadUint32(&o.FUNC54_IN_SEL_CFG.Reg)&^(0x40)|value<<6)
}
func (o *GPIO_Type) GetFUNC54_IN_SEL_CFG_SIG_IN_SEL() uint32 {
	return (volatile.LoadUint32(&o.FUNC54_IN_SEL_CFG.Reg) & 0x40) >> 6
}

// GPIO.FUNC55_IN_SEL_CFG: GPIO input function configuration register
func (o *GPIO_Type) SetFUNC55_IN_SEL_CFG_FUNC_IN_SEL(value uint32) {
	volatile.StoreUint32(&o.FUNC55_IN_SEL_CFG.Reg, volatile.LoadUint32(&o.FUNC55_IN_SEL_CFG.Reg)&^(0x1f)|value)
}
func (o *GPIO_Type) GetFUNC55_IN_SEL_CFG_FUNC_IN_SEL() uint32 {
	return volatile.LoadUint32(&o.FUNC55_IN_SEL_CFG.Reg) & 0x1f
}
func (o *GPIO_Type) SetFUNC55_IN_SEL_CFG_FUNC_IN_INV_SEL(value uint32) {
	volatile.StoreUint32(&o.FUNC55_IN_SEL_CFG.Reg, volatile.LoadUint32(&o.FUNC55_IN_SEL_CFG.Reg)&^(0x20)|value<<5)
}
func (o *GPIO_Type) GetFUNC55_IN_SEL_CFG_FUNC_IN_INV_SEL() uint32 {
	return (volatile.LoadUint32(&o.FUNC55_IN_SEL_CFG.Reg) & 0x20) >> 5
}
func (o *GPIO_Type) SetFUNC55_IN_SEL_CFG_SIG_IN_SEL(value uint32) {
	volatile.StoreUint32(&o.FUNC55_IN_SEL_CFG.Reg, volatile.LoadUint32(&o.FUNC55_IN_SEL_CFG.Reg)&^(0x40)|value<<6)
}
func (o *GPIO_Type) GetFUNC55_IN_SEL_CFG_SIG_IN_SEL() uint32 {
	return (volatile.LoadUint32(&o.FUNC55_IN_SEL_CFG.Reg) & 0x40) >> 6
}

// GPIO.FUNC56_IN_SEL_CFG: GPIO input function configuration register
func (o *GPIO_Type) SetFUNC56_IN_SEL_CFG_FUNC_IN_SEL(value uint32) {
	volatile.StoreUint32(&o.FUNC56_IN_SEL_CFG.Reg, volatile.LoadUint32(&o.FUNC56_IN_SEL_CFG.Reg)&^(0x1f)|value)
}
func (o *GPIO_Type) GetFUNC56_IN_SEL_CFG_FUNC_IN_SEL() uint32 {
	return volatile.LoadUint32(&o.FUNC56_IN_SEL_CFG.Reg) & 0x1f
}
func (o *GPIO_Type) SetFUNC56_IN_SEL_CFG_FUNC_IN_INV_SEL(value uint32) {
	volatile.StoreUint32(&o.FUNC56_IN_SEL_CFG.Reg, volatile.LoadUint32(&o.FUNC56_IN_SEL_CFG.Reg)&^(0x20)|value<<5)
}
func (o *GPIO_Type) GetFUNC56_IN_SEL_CFG_FUNC_IN_INV_SEL() uint32 {
	return (volatile.LoadUint32(&o.FUNC56_IN_SEL_CFG.Reg) & 0x20) >> 5
}
func (o *GPIO_Type) SetFUNC56_IN_SEL_CFG_SIG_IN_SEL(value uint32) {
	volatile.StoreUint32(&o.FUNC56_IN_SEL_CFG.Reg, volatile.LoadUint32(&o.FUNC56_IN_SEL_CFG.Reg)&^(0x40)|value<<6)
}
func (o *GPIO_Type) GetFUNC56_IN_SEL_CFG_SIG_IN_SEL() uint32 {
	return (volatile.LoadUint32(&o.FUNC56_IN_SEL_CFG.Reg) & 0x40) >> 6
}

// GPIO.FUNC57_IN_SEL_CFG: GPIO input function configuration register
func (o *GPIO_Type) SetFUNC57_IN_SEL_CFG_FUNC_IN_SEL(value uint32) {
	volatile.StoreUint32(&o.FUNC57_IN_SEL_CFG.Reg, volatile.LoadUint32(&o.FUNC57_IN_SEL_CFG.Reg)&^(0x1f)|value)
}
func (o *GPIO_Type) GetFUNC57_IN_SEL_CFG_FUNC_IN_SEL() uint32 {
	return volatile.LoadUint32(&o.FUNC57_IN_SEL_CFG.Reg) & 0x1f
}
func (o *GPIO_Type) SetFUNC57_IN_SEL_CFG_FUNC_IN_INV_SEL(value uint32) {
	volatile.StoreUint32(&o.FUNC57_IN_SEL_CFG.Reg, volatile.LoadUint32(&o.FUNC57_IN_SEL_CFG.Reg)&^(0x20)|value<<5)
}
func (o *GPIO_Type) GetFUNC57_IN_SEL_CFG_FUNC_IN_INV_SEL() uint32 {
	return (volatile.LoadUint32(&o.FUNC57_IN_SEL_CFG.Reg) & 0x20) >> 5
}
func (o *GPIO_Type) SetFUNC57_IN_SEL_CFG_SIG_IN_SEL(value uint32) {
	volatile.StoreUint32(&o.FUNC57_IN_SEL_CFG.Reg, volatile.LoadUint32(&o.FUNC57_IN_SEL_CFG.Reg)&^(0x40)|value<<6)
}
func (o *GPIO_Type) GetFUNC57_IN_SEL_CFG_SIG_IN_SEL() uint32 {
	return (volatile.LoadUint32(&o.FUNC57_IN_SEL_CFG.Reg) & 0x40) >> 6
}

// GPIO.FUNC58_IN_SEL_CFG: GPIO input function configuration register
func (o *GPIO_Type) SetFUNC58_IN_SEL_CFG_FUNC_IN_SEL(value uint32) {
	volatile.StoreUint32(&o.FUNC58_IN_SEL_CFG.Reg, volatile.LoadUint32(&o.FUNC58_IN_SEL_CFG.Reg)&^(0x1f)|value)
}
func (o *GPIO_Type) GetFUNC58_IN_SEL_CFG_FUNC_IN_SEL() uint32 {
	return volatile.LoadUint32(&o.FUNC58_IN_SEL_CFG.Reg) & 0x1f
}
func (o *GPIO_Type) SetFUNC58_IN_SEL_CFG_FUNC_IN_INV_SEL(value uint32) {
	volatile.StoreUint32(&o.FUNC58_IN_SEL_CFG.Reg, volatile.LoadUint32(&o.FUNC58_IN_SEL_CFG.Reg)&^(0x20)|value<<5)
}
func (o *GPIO_Type) GetFUNC58_IN_SEL_CFG_FUNC_IN_INV_SEL() uint32 {
	return (volatile.LoadUint32(&o.FUNC58_IN_SEL_CFG.Reg) & 0x20) >> 5
}
func (o *GPIO_Type) SetFUNC58_IN_SEL_CFG_SIG_IN_SEL(value uint32) {
	volatile.StoreUint32(&o.FUNC58_IN_SEL_CFG.Reg, volatile.LoadUint32(&o.FUNC58_IN_SEL_CFG.Reg)&^(0x40)|value<<6)
}
func (o *GPIO_Type) GetFUNC58_IN_SEL_CFG_SIG_IN_SEL() uint32 {
	return (volatile.LoadUint32(&o.FUNC58_IN_SEL_CFG.Reg) & 0x40) >> 6
}

// GPIO.FUNC59_IN_SEL_CFG: GPIO input function configuration register
func (o *GPIO_Type) SetFUNC59_IN_SEL_CFG_FUNC_IN_SEL(value uint32) {
	volatile.StoreUint32(&o.FUNC59_IN_SEL_CFG.Reg, volatile.LoadUint32(&o.FUNC59_IN_SEL_CFG.Reg)&^(0x1f)|value)
}
func (o *GPIO_Type) GetFUNC59_IN_SEL_CFG_FUNC_IN_SEL() uint32 {
	return volatile.LoadUint32(&o.FUNC59_IN_SEL_CFG.Reg) & 0x1f
}
func (o *GPIO_Type) SetFUNC59_IN_SEL_CFG_FUNC_IN_INV_SEL(value uint32) {
	volatile.StoreUint32(&o.FUNC59_IN_SEL_CFG.Reg, volatile.LoadUint32(&o.FUNC59_IN_SEL_CFG.Reg)&^(0x20)|value<<5)
}
func (o *GPIO_Type) GetFUNC59_IN_SEL_CFG_FUNC_IN_INV_SEL() uint32 {
	return (volatile.LoadUint32(&o.FUNC59_IN_SEL_CFG.Reg) & 0x20) >> 5
}
func (o *GPIO_Type) SetFUNC59_IN_SEL_CFG_SIG_IN_SEL(value uint32) {
	volatile.StoreUint32(&o.FUNC59_IN_SEL_CFG.Reg, volatile.LoadUint32(&o.FUNC59_IN_SEL_CFG.Reg)&^(0x40)|value<<6)
}
func (o *GPIO_Type) GetFUNC59_IN_SEL_CFG_SIG_IN_SEL() uint32 {
	return (volatile.LoadUint32(&o.FUNC59_IN_SEL_CFG.Reg) & 0x40) >> 6
}

// GPIO.FUNC60_IN_SEL_CFG: GPIO input function configuration register
func (o *GPIO_Type) SetFUNC60_IN_SEL_CFG_FUNC_IN_SEL(value uint32) {
	volatile.StoreUint32(&o.FUNC60_IN_SEL_CFG.Reg, volatile.LoadUint32(&o.FUNC60_IN_SEL_CFG.Reg)&^(0x1f)|value)
}
func (o *GPIO_Type) GetFUNC60_IN_SEL_CFG_FUNC_IN_SEL() uint32 {
	return volatile.LoadUint32(&o.FUNC60_IN_SEL_CFG.Reg) & 0x1f
}
func (o *GPIO_Type) SetFUNC60_IN_SEL_CFG_FUNC_IN_INV_SEL(value uint32) {
	volatile.StoreUint32(&o.FUNC60_IN_SEL_CFG.Reg, volatile.LoadUint32(&o.FUNC60_IN_SEL_CFG.Reg)&^(0x20)|value<<5)
}
func (o *GPIO_Type) GetFUNC60_IN_SEL_CFG_FUNC_IN_INV_SEL() uint32 {
	return (volatile.LoadUint32(&o.FUNC60_IN_SEL_CFG.Reg) & 0x20) >> 5
}
func (o *GPIO_Type) SetFUNC60_IN_SEL_CFG_SIG_IN_SEL(value uint32) {
	volatile.StoreUint32(&o.FUNC60_IN_SEL_CFG.Reg, volatile.LoadUint32(&o.FUNC60_IN_SEL_CFG.Reg)&^(0x40)|value<<6)
}
func (o *GPIO_Type) GetFUNC60_IN_SEL_CFG_SIG_IN_SEL() uint32 {
	return (volatile.LoadUint32(&o.FUNC60_IN_SEL_CFG.Reg) & 0x40) >> 6
}

// GPIO.FUNC61_IN_SEL_CFG: GPIO input function configuration register
func (o *GPIO_Type) SetFUNC61_IN_SEL_CFG_FUNC_IN_SEL(value uint32) {
	volatile.StoreUint32(&o.FUNC61_IN_SEL_CFG.Reg, volatile.LoadUint32(&o.FUNC61_IN_SEL_CFG.Reg)&^(0x1f)|value)
}
func (o *GPIO_Type) GetFUNC61_IN_SEL_CFG_FUNC_IN_SEL() uint32 {
	return volatile.LoadUint32(&o.FUNC61_IN_SEL_CFG.Reg) & 0x1f
}
func (o *GPIO_Type) SetFUNC61_IN_SEL_CFG_FUNC_IN_INV_SEL(value uint32) {
	volatile.StoreUint32(&o.FUNC61_IN_SEL_CFG.Reg, volatile.LoadUint32(&o.FUNC61_IN_SEL_CFG.Reg)&^(0x20)|value<<5)
}
func (o *GPIO_Type) GetFUNC61_IN_SEL_CFG_FUNC_IN_INV_SEL() uint32 {
	return (volatile.LoadUint32(&o.FUNC61_IN_SEL_CFG.Reg) & 0x20) >> 5
}
func (o *GPIO_Type) SetFUNC61_IN_SEL_CFG_SIG_IN_SEL(value uint32) {
	volatile.StoreUint32(&o.FUNC61_IN_SEL_CFG.Reg, volatile.LoadUint32(&o.FUNC61_IN_SEL_CFG.Reg)&^(0x40)|value<<6)
}
func (o *GPIO_Type) GetFUNC61_IN_SEL_CFG_SIG_IN_SEL() uint32 {
	return (volatile.LoadUint32(&o.FUNC61_IN_SEL_CFG.Reg) & 0x40) >> 6
}

// GPIO.FUNC62_IN_SEL_CFG: GPIO input function configuration register
func (o *GPIO_Type) SetFUNC62_IN_SEL_CFG_FUNC_IN_SEL(value uint32) {
	volatile.StoreUint32(&o.FUNC62_IN_SEL_CFG.Reg, volatile.LoadUint32(&o.FUNC62_IN_SEL_CFG.Reg)&^(0x1f)|value)
}
func (o *GPIO_Type) GetFUNC62_IN_SEL_CFG_FUNC_IN_SEL() uint32 {
	return volatile.LoadUint32(&o.FUNC62_IN_SEL_CFG.Reg) & 0x1f
}
func (o *GPIO_Type) SetFUNC62_IN_SEL_CFG_FUNC_IN_INV_SEL(value uint32) {
	volatile.StoreUint32(&o.FUNC62_IN_SEL_CFG.Reg, volatile.LoadUint32(&o.FUNC62_IN_SEL_CFG.Reg)&^(0x20)|value<<5)
}
func (o *GPIO_Type) GetFUNC62_IN_SEL_CFG_FUNC_IN_INV_SEL() uint32 {
	return (volatile.LoadUint32(&o.FUNC62_IN_SEL_CFG.Reg) & 0x20) >> 5
}
func (o *GPIO_Type) SetFUNC62_IN_SEL_CFG_SIG_IN_SEL(value uint32) {
	volatile.StoreUint32(&o.FUNC62_IN_SEL_CFG.Reg, volatile.LoadUint32(&o.FUNC62_IN_SEL_CFG.Reg)&^(0x40)|value<<6)
}
func (o *GPIO_Type) GetFUNC62_IN_SEL_CFG_SIG_IN_SEL() uint32 {
	return (volatile.LoadUint32(&o.FUNC62_IN_SEL_CFG.Reg) & 0x40) >> 6
}

// GPIO.FUNC63_IN_SEL_CFG: GPIO input function configuration register
func (o *GPIO_Type) SetFUNC63_IN_SEL_CFG_FUNC_IN_SEL(value uint32) {
	volatile.StoreUint32(&o.FUNC63_IN_SEL_CFG.Reg, volatile.LoadUint32(&o.FUNC63_IN_SEL_CFG.Reg)&^(0x1f)|value)
}
func (o *GPIO_Type) GetFUNC63_IN_SEL_CFG_FUNC_IN_SEL() uint32 {
	return volatile.LoadUint32(&o.FUNC63_IN_SEL_CFG.Reg) & 0x1f
}
func (o *GPIO_Type) SetFUNC63_IN_SEL_CFG_FUNC_IN_INV_SEL(value uint32) {
	volatile.StoreUint32(&o.FUNC63_IN_SEL_CFG.Reg, volatile.LoadUint32(&o.FUNC63_IN_SEL_CFG.Reg)&^(0x20)|value<<5)
}
func (o *GPIO_Type) GetFUNC63_IN_SEL_CFG_FUNC_IN_INV_SEL() uint32 {
	return (volatile.LoadUint32(&o.FUNC63_IN_SEL_CFG.Reg) & 0x20) >> 5
}
func (o *GPIO_Type) SetFUNC63_IN_SEL_CFG_SIG_IN_SEL(value uint32) {
	volatile.StoreUint32(&o.FUNC63_IN_SEL_CFG.Reg, volatile.LoadUint32(&o.FUNC63_IN_SEL_CFG.Reg)&^(0x40)|value<<6)
}
func (o *GPIO_Type) GetFUNC63_IN_SEL_CFG_SIG_IN_SEL() uint32 {
	return (volatile.LoadUint32(&o.FUNC63_IN_SEL_CFG.Reg) & 0x40) >> 6
}

// GPIO.FUNC64_IN_SEL_CFG: GPIO input function configuration register
func (o *GPIO_Type) SetFUNC64_IN_SEL_CFG_FUNC_IN_SEL(value uint32) {
	volatile.StoreUint32(&o.FUNC64_IN_SEL_CFG.Reg, volatile.LoadUint32(&o.FUNC64_IN_SEL_CFG.Reg)&^(0x1f)|value)
}
func (o *GPIO_Type) GetFUNC64_IN_SEL_CFG_FUNC_IN_SEL() uint32 {
	return volatile.LoadUint32(&o.FUNC64_IN_SEL_CFG.Reg) & 0x1f
}
func (o *GPIO_Type) SetFUNC64_IN_SEL_CFG_FUNC_IN_INV_SEL(value uint32) {
	volatile.StoreUint32(&o.FUNC64_IN_SEL_CFG.Reg, volatile.LoadUint32(&o.FUNC64_IN_SEL_CFG.Reg)&^(0x20)|value<<5)
}
func (o *GPIO_Type) GetFUNC64_IN_SEL_CFG_FUNC_IN_INV_SEL() uint32 {
	return (volatile.LoadUint32(&o.FUNC64_IN_SEL_CFG.Reg) & 0x20) >> 5
}
func (o *GPIO_Type) SetFUNC64_IN_SEL_CFG_SIG_IN_SEL(value uint32) {
	volatile.StoreUint32(&o.FUNC64_IN_SEL_CFG.Reg, volatile.LoadUint32(&o.FUNC64_IN_SEL_CFG.Reg)&^(0x40)|value<<6)
}
func (o *GPIO_Type) GetFUNC64_IN_SEL_CFG_SIG_IN_SEL() uint32 {
	return (volatile.LoadUint32(&o.FUNC64_IN_SEL_CFG.Reg) & 0x40) >> 6
}

// GPIO.FUNC65_IN_SEL_CFG: GPIO input function configuration register
func (o *GPIO_Type) SetFUNC65_IN_SEL_CFG_FUNC_IN_SEL(value uint32) {
	volatile.StoreUint32(&o.FUNC65_IN_SEL_CFG.Reg, volatile.LoadUint32(&o.FUNC65_IN_SEL_CFG.Reg)&^(0x1f)|value)
}
func (o *GPIO_Type) GetFUNC65_IN_SEL_CFG_FUNC_IN_SEL() uint32 {
	return volatile.LoadUint32(&o.FUNC65_IN_SEL_CFG.Reg) & 0x1f
}
func (o *GPIO_Type) SetFUNC65_IN_SEL_CFG_FUNC_IN_INV_SEL(value uint32) {
	volatile.StoreUint32(&o.FUNC65_IN_SEL_CFG.Reg, volatile.LoadUint32(&o.FUNC65_IN_SEL_CFG.Reg)&^(0x20)|value<<5)
}
func (o *GPIO_Type) GetFUNC65_IN_SEL_CFG_FUNC_IN_INV_SEL() uint32 {
	return (volatile.LoadUint32(&o.FUNC65_IN_SEL_CFG.Reg) & 0x20) >> 5
}
func (o *GPIO_Type) SetFUNC65_IN_SEL_CFG_SIG_IN_SEL(value uint32) {
	volatile.StoreUint32(&o.FUNC65_IN_SEL_CFG.Reg, volatile.LoadUint32(&o.FUNC65_IN_SEL_CFG.Reg)&^(0x40)|value<<6)
}
func (o *GPIO_Type) GetFUNC65_IN_SEL_CFG_SIG_IN_SEL() uint32 {
	return (volatile.LoadUint32(&o.FUNC65_IN_SEL_CFG.Reg) & 0x40) >> 6
}

// GPIO.FUNC66_IN_SEL_CFG: GPIO input function configuration register
func (o *GPIO_Type) SetFUNC66_IN_SEL_CFG_FUNC_IN_SEL(value uint32) {
	volatile.StoreUint32(&o.FUNC66_IN_SEL_CFG.Reg, volatile.LoadUint32(&o.FUNC66_IN_SEL_CFG.Reg)&^(0x1f)|value)
}
func (o *GPIO_Type) GetFUNC66_IN_SEL_CFG_FUNC_IN_SEL() uint32 {
	return volatile.LoadUint32(&o.FUNC66_IN_SEL_CFG.Reg) & 0x1f
}
func (o *GPIO_Type) SetFUNC66_IN_SEL_CFG_FUNC_IN_INV_SEL(value uint32) {
	volatile.StoreUint32(&o.FUNC66_IN_SEL_CFG.Reg, volatile.LoadUint32(&o.FUNC66_IN_SEL_CFG.Reg)&^(0x20)|value<<5)
}
func (o *GPIO_Type) GetFUNC66_IN_SEL_CFG_FUNC_IN_INV_SEL() uint32 {
	return (volatile.LoadUint32(&o.FUNC66_IN_SEL_CFG.Reg) & 0x20) >> 5
}
func (o *GPIO_Type) SetFUNC66_IN_SEL_CFG_SIG_IN_SEL(value uint32) {
	volatile.StoreUint32(&o.FUNC66_IN_SEL_CFG.Reg, volatile.LoadUint32(&o.FUNC66_IN_SEL_CFG.Reg)&^(0x40)|value<<6)
}
func (o *GPIO_Type) GetFUNC66_IN_SEL_CFG_SIG_IN_SEL() uint32 {
	return (volatile.LoadUint32(&o.FUNC66_IN_SEL_CFG.Reg) & 0x40) >> 6
}

// GPIO.FUNC67_IN_SEL_CFG: GPIO input function configuration register
func (o *GPIO_Type) SetFUNC67_IN_SEL_CFG_FUNC_IN_SEL(value uint32) {
	volatile.StoreUint32(&o.FUNC67_IN_SEL_CFG.Reg, volatile.LoadUint32(&o.FUNC67_IN_SEL_CFG.Reg)&^(0x1f)|value)
}
func (o *GPIO_Type) GetFUNC67_IN_SEL_CFG_FUNC_IN_SEL() uint32 {
	return volatile.LoadUint32(&o.FUNC67_IN_SEL_CFG.Reg) & 0x1f
}
func (o *GPIO_Type) SetFUNC67_IN_SEL_CFG_FUNC_IN_INV_SEL(value uint32) {
	volatile.StoreUint32(&o.FUNC67_IN_SEL_CFG.Reg, volatile.LoadUint32(&o.FUNC67_IN_SEL_CFG.Reg)&^(0x20)|value<<5)
}
func (o *GPIO_Type) GetFUNC67_IN_SEL_CFG_FUNC_IN_INV_SEL() uint32 {
	return (volatile.LoadUint32(&o.FUNC67_IN_SEL_CFG.Reg) & 0x20) >> 5
}
func (o *GPIO_Type) SetFUNC67_IN_SEL_CFG_SIG_IN_SEL(value uint32) {
	volatile.StoreUint32(&o.FUNC67_IN_SEL_CFG.Reg, volatile.LoadUint32(&o.FUNC67_IN_SEL_CFG.Reg)&^(0x40)|value<<6)
}
func (o *GPIO_Type) GetFUNC67_IN_SEL_CFG_SIG_IN_SEL() uint32 {
	return (volatile.LoadUint32(&o.FUNC67_IN_SEL_CFG.Reg) & 0x40) >> 6
}

// GPIO.FUNC68_IN_SEL_CFG: GPIO input function configuration register
func (o *GPIO_Type) SetFUNC68_IN_SEL_CFG_FUNC_IN_SEL(value uint32) {
	volatile.StoreUint32(&o.FUNC68_IN_SEL_CFG.Reg, volatile.LoadUint32(&o.FUNC68_IN_SEL_CFG.Reg)&^(0x1f)|value)
}
func (o *GPIO_Type) GetFUNC68_IN_SEL_CFG_FUNC_IN_SEL() uint32 {
	return volatile.LoadUint32(&o.FUNC68_IN_SEL_CFG.Reg) & 0x1f
}
func (o *GPIO_Type) SetFUNC68_IN_SEL_CFG_FUNC_IN_INV_SEL(value uint32) {
	volatile.StoreUint32(&o.FUNC68_IN_SEL_CFG.Reg, volatile.LoadUint32(&o.FUNC68_IN_SEL_CFG.Reg)&^(0x20)|value<<5)
}
func (o *GPIO_Type) GetFUNC68_IN_SEL_CFG_FUNC_IN_INV_SEL() uint32 {
	return (volatile.LoadUint32(&o.FUNC68_IN_SEL_CFG.Reg) & 0x20) >> 5
}
func (o *GPIO_Type) SetFUNC68_IN_SEL_CFG_SIG_IN_SEL(value uint32) {
	volatile.StoreUint32(&o.FUNC68_IN_SEL_CFG.Reg, volatile.LoadUint32(&o.FUNC68_IN_SEL_CFG.Reg)&^(0x40)|value<<6)
}
func (o *GPIO_Type) GetFUNC68_IN_SEL_CFG_SIG_IN_SEL() uint32 {
	return (volatile.LoadUint32(&o.FUNC68_IN_SEL_CFG.Reg) & 0x40) >> 6
}

// GPIO.FUNC69_IN_SEL_CFG: GPIO input function configuration register
func (o *GPIO_Type) SetFUNC69_IN_SEL_CFG_FUNC_IN_SEL(value uint32) {
	volatile.StoreUint32(&o.FUNC69_IN_SEL_CFG.Reg, volatile.LoadUint32(&o.FUNC69_IN_SEL_CFG.Reg)&^(0x1f)|value)
}
func (o *GPIO_Type) GetFUNC69_IN_SEL_CFG_FUNC_IN_SEL() uint32 {
	return volatile.LoadUint32(&o.FUNC69_IN_SEL_CFG.Reg) & 0x1f
}
func (o *GPIO_Type) SetFUNC69_IN_SEL_CFG_FUNC_IN_INV_SEL(value uint32) {
	volatile.StoreUint32(&o.FUNC69_IN_SEL_CFG.Reg, volatile.LoadUint32(&o.FUNC69_IN_SEL_CFG.Reg)&^(0x20)|value<<5)
}
func (o *GPIO_Type) GetFUNC69_IN_SEL_CFG_FUNC_IN_INV_SEL() uint32 {
	return (volatile.LoadUint32(&o.FUNC69_IN_SEL_CFG.Reg) & 0x20) >> 5
}
func (o *GPIO_Type) SetFUNC69_IN_SEL_CFG_SIG_IN_SEL(value uint32) {
	volatile.StoreUint32(&o.FUNC69_IN_SEL_CFG.Reg, volatile.LoadUint32(&o.FUNC69_IN_SEL_CFG.Reg)&^(0x40)|value<<6)
}
func (o *GPIO_Type) GetFUNC69_IN_SEL_CFG_SIG_IN_SEL() uint32 {
	return (volatile.LoadUint32(&o.FUNC69_IN_SEL_CFG.Reg) & 0x40) >> 6
}

// GPIO.FUNC70_IN_SEL_CFG: GPIO input function configuration register
func (o *GPIO_Type) SetFUNC70_IN_SEL_CFG_FUNC_IN_SEL(value uint32) {
	volatile.StoreUint32(&o.FUNC70_IN_SEL_CFG.Reg, volatile.LoadUint32(&o.FUNC70_IN_SEL_CFG.Reg)&^(0x1f)|value)
}
func (o *GPIO_Type) GetFUNC70_IN_SEL_CFG_FUNC_IN_SEL() uint32 {
	return volatile.LoadUint32(&o.FUNC70_IN_SEL_CFG.Reg) & 0x1f
}
func (o *GPIO_Type) SetFUNC70_IN_SEL_CFG_FUNC_IN_INV_SEL(value uint32) {
	volatile.StoreUint32(&o.FUNC70_IN_SEL_CFG.Reg, volatile.LoadUint32(&o.FUNC70_IN_SEL_CFG.Reg)&^(0x20)|value<<5)
}
func (o *GPIO_Type) GetFUNC70_IN_SEL_CFG_FUNC_IN_INV_SEL() uint32 {
	return (volatile.LoadUint32(&o.FUNC70_IN_SEL_CFG.Reg) & 0x20) >> 5
}
func (o *GPIO_Type) SetFUNC70_IN_SEL_CFG_SIG_IN_SEL(value uint32) {
	volatile.StoreUint32(&o.FUNC70_IN_SEL_CFG.Reg, volatile.LoadUint32(&o.FUNC70_IN_SEL_CFG.Reg)&^(0x40)|value<<6)
}
func (o *GPIO_Type) GetFUNC70_IN_SEL_CFG_SIG_IN_SEL() uint32 {
	return (volatile.LoadUint32(&o.FUNC70_IN_SEL_CFG.Reg) & 0x40) >> 6
}

// GPIO.FUNC71_IN_SEL_CFG: GPIO input function configuration register
func (o *GPIO_Type) SetFUNC71_IN_SEL_CFG_FUNC_IN_SEL(value uint32) {
	volatile.StoreUint32(&o.FUNC71_IN_SEL_CFG.Reg, volatile.LoadUint32(&o.FUNC71_IN_SEL_CFG.Reg)&^(0x1f)|value)
}
func (o *GPIO_Type) GetFUNC71_IN_SEL_CFG_FUNC_IN_SEL() uint32 {
	return volatile.LoadUint32(&o.FUNC71_IN_SEL_CFG.Reg) & 0x1f
}
func (o *GPIO_Type) SetFUNC71_IN_SEL_CFG_FUNC_IN_INV_SEL(value uint32) {
	volatile.StoreUint32(&o.FUNC71_IN_SEL_CFG.Reg, volatile.LoadUint32(&o.FUNC71_IN_SEL_CFG.Reg)&^(0x20)|value<<5)
}
func (o *GPIO_Type) GetFUNC71_IN_SEL_CFG_FUNC_IN_INV_SEL() uint32 {
	return (volatile.LoadUint32(&o.FUNC71_IN_SEL_CFG.Reg) & 0x20) >> 5
}
func (o *GPIO_Type) SetFUNC71_IN_SEL_CFG_SIG_IN_SEL(value uint32) {
	volatile.StoreUint32(&o.FUNC71_IN_SEL_CFG.Reg, volatile.LoadUint32(&o.FUNC71_IN_SEL_CFG.Reg)&^(0x40)|value<<6)
}
func (o *GPIO_Type) GetFUNC71_IN_SEL_CFG_SIG_IN_SEL() uint32 {
	return (volatile.LoadUint32(&o.FUNC71_IN_SEL_CFG.Reg) & 0x40) >> 6
}

// GPIO.FUNC72_IN_SEL_CFG: GPIO input function configuration register
func (o *GPIO_Type) SetFUNC72_IN_SEL_CFG_FUNC_IN_SEL(value uint32) {
	volatile.StoreUint32(&o.FUNC72_IN_SEL_CFG.Reg, volatile.LoadUint32(&o.FUNC72_IN_SEL_CFG.Reg)&^(0x1f)|value)
}
func (o *GPIO_Type) GetFUNC72_IN_SEL_CFG_FUNC_IN_SEL() uint32 {
	return volatile.LoadUint32(&o.FUNC72_IN_SEL_CFG.Reg) & 0x1f
}
func (o *GPIO_Type) SetFUNC72_IN_SEL_CFG_FUNC_IN_INV_SEL(value uint32) {
	volatile.StoreUint32(&o.FUNC72_IN_SEL_CFG.Reg, volatile.LoadUint32(&o.FUNC72_IN_SEL_CFG.Reg)&^(0x20)|value<<5)
}
func (o *GPIO_Type) GetFUNC72_IN_SEL_CFG_FUNC_IN_INV_SEL() uint32 {
	return (volatile.LoadUint32(&o.FUNC72_IN_SEL_CFG.Reg) & 0x20) >> 5
}
func (o *GPIO_Type) SetFUNC72_IN_SEL_CFG_SIG_IN_SEL(value uint32) {
	volatile.StoreUint32(&o.FUNC72_IN_SEL_CFG.Reg, volatile.LoadUint32(&o.FUNC72_IN_SEL_CFG.Reg)&^(0x40)|value<<6)
}
func (o *GPIO_Type) GetFUNC72_IN_SEL_CFG_SIG_IN_SEL() uint32 {
	return (volatile.LoadUint32(&o.FUNC72_IN_SEL_CFG.Reg) & 0x40) >> 6
}

// GPIO.FUNC73_IN_SEL_CFG: GPIO input function configuration register
func (o *GPIO_Type) SetFUNC73_IN_SEL_CFG_FUNC_IN_SEL(value uint32) {
	volatile.StoreUint32(&o.FUNC73_IN_SEL_CFG.Reg, volatile.LoadUint32(&o.FUNC73_IN_SEL_CFG.Reg)&^(0x1f)|value)
}
func (o *GPIO_Type) GetFUNC73_IN_SEL_CFG_FUNC_IN_SEL() uint32 {
	return volatile.LoadUint32(&o.FUNC73_IN_SEL_CFG.Reg) & 0x1f
}
func (o *GPIO_Type) SetFUNC73_IN_SEL_CFG_FUNC_IN_INV_SEL(value uint32) {
	volatile.StoreUint32(&o.FUNC73_IN_SEL_CFG.Reg, volatile.LoadUint32(&o.FUNC73_IN_SEL_CFG.Reg)&^(0x20)|value<<5)
}
func (o *GPIO_Type) GetFUNC73_IN_SEL_CFG_FUNC_IN_INV_SEL() uint32 {
	return (volatile.LoadUint32(&o.FUNC73_IN_SEL_CFG.Reg) & 0x20) >> 5
}
func (o *GPIO_Type) SetFUNC73_IN_SEL_CFG_SIG_IN_SEL(value uint32) {
	volatile.StoreUint32(&o.FUNC73_IN_SEL_CFG.Reg, volatile.LoadUint32(&o.FUNC73_IN_SEL_CFG.Reg)&^(0x40)|value<<6)
}
func (o *GPIO_Type) GetFUNC73_IN_SEL_CFG_SIG_IN_SEL() uint32 {
	return (volatile.LoadUint32(&o.FUNC73_IN_SEL_CFG.Reg) & 0x40) >> 6
}

// GPIO.FUNC74_IN_SEL_CFG: GPIO input function configuration register
func (o *GPIO_Type) SetFUNC74_IN_SEL_CFG_FUNC_IN_SEL(value uint32) {
	volatile.StoreUint32(&o.FUNC74_IN_SEL_CFG.Reg, volatile.LoadUint32(&o.FUNC74_IN_SEL_CFG.Reg)&^(0x1f)|value)
}
func (o *GPIO_Type) GetFUNC74_IN_SEL_CFG_FUNC_IN_SEL() uint32 {
	return volatile.LoadUint32(&o.FUNC74_IN_SEL_CFG.Reg) & 0x1f
}
func (o *GPIO_Type) SetFUNC74_IN_SEL_CFG_FUNC_IN_INV_SEL(value uint32) {
	volatile.StoreUint32(&o.FUNC74_IN_SEL_CFG.Reg, volatile.LoadUint32(&o.FUNC74_IN_SEL_CFG.Reg)&^(0x20)|value<<5)
}
func (o *GPIO_Type) GetFUNC74_IN_SEL_CFG_FUNC_IN_INV_SEL() uint32 {
	return (volatile.LoadUint32(&o.FUNC74_IN_SEL_CFG.Reg) & 0x20) >> 5
}
func (o *GPIO_Type) SetFUNC74_IN_SEL_CFG_SIG_IN_SEL(value uint32) {
	volatile.StoreUint32(&o.FUNC74_IN_SEL_CFG.Reg, volatile.LoadUint32(&o.FUNC74_IN_SEL_CFG.Reg)&^(0x40)|value<<6)
}
func (o *GPIO_Type) GetFUNC74_IN_SEL_CFG_SIG_IN_SEL() uint32 {
	return (volatile.LoadUint32(&o.FUNC74_IN_SEL_CFG.Reg) & 0x40) >> 6
}

// GPIO.FUNC75_IN_SEL_CFG: GPIO input function configuration register
func (o *GPIO_Type) SetFUNC75_IN_SEL_CFG_FUNC_IN_SEL(value uint32) {
	volatile.StoreUint32(&o.FUNC75_IN_SEL_CFG.Reg, volatile.LoadUint32(&o.FUNC75_IN_SEL_CFG.Reg)&^(0x1f)|value)
}
func (o *GPIO_Type) GetFUNC75_IN_SEL_CFG_FUNC_IN_SEL() uint32 {
	return volatile.LoadUint32(&o.FUNC75_IN_SEL_CFG.Reg) & 0x1f
}
func (o *GPIO_Type) SetFUNC75_IN_SEL_CFG_FUNC_IN_INV_SEL(value uint32) {
	volatile.StoreUint32(&o.FUNC75_IN_SEL_CFG.Reg, volatile.LoadUint32(&o.FUNC75_IN_SEL_CFG.Reg)&^(0x20)|value<<5)
}
func (o *GPIO_Type) GetFUNC75_IN_SEL_CFG_FUNC_IN_INV_SEL() uint32 {
	return (volatile.LoadUint32(&o.FUNC75_IN_SEL_CFG.Reg) & 0x20) >> 5
}
func (o *GPIO_Type) SetFUNC75_IN_SEL_CFG_SIG_IN_SEL(value uint32) {
	volatile.StoreUint32(&o.FUNC75_IN_SEL_CFG.Reg, volatile.LoadUint32(&o.FUNC75_IN_SEL_CFG.Reg)&^(0x40)|value<<6)
}
func (o *GPIO_Type) GetFUNC75_IN_SEL_CFG_SIG_IN_SEL() uint32 {
	return (volatile.LoadUint32(&o.FUNC75_IN_SEL_CFG.Reg) & 0x40) >> 6
}

// GPIO.FUNC76_IN_SEL_CFG: GPIO input function configuration register
func (o *GPIO_Type) SetFUNC76_IN_SEL_CFG_FUNC_IN_SEL(value uint32) {
	volatile.StoreUint32(&o.FUNC76_IN_SEL_CFG.Reg, volatile.LoadUint32(&o.FUNC76_IN_SEL_CFG.Reg)&^(0x1f)|value)
}
func (o *GPIO_Type) GetFUNC76_IN_SEL_CFG_FUNC_IN_SEL() uint32 {
	return volatile.LoadUint32(&o.FUNC76_IN_SEL_CFG.Reg) & 0x1f
}
func (o *GPIO_Type) SetFUNC76_IN_SEL_CFG_FUNC_IN_INV_SEL(value uint32) {
	volatile.StoreUint32(&o.FUNC76_IN_SEL_CFG.Reg, volatile.LoadUint32(&o.FUNC76_IN_SEL_CFG.Reg)&^(0x20)|value<<5)
}
func (o *GPIO_Type) GetFUNC76_IN_SEL_CFG_FUNC_IN_INV_SEL() uint32 {
	return (volatile.LoadUint32(&o.FUNC76_IN_SEL_CFG.Reg) & 0x20) >> 5
}
func (o *GPIO_Type) SetFUNC76_IN_SEL_CFG_SIG_IN_SEL(value uint32) {
	volatile.StoreUint32(&o.FUNC76_IN_SEL_CFG.Reg, volatile.LoadUint32(&o.FUNC76_IN_SEL_CFG.Reg)&^(0x40)|value<<6)
}
func (o *GPIO_Type) GetFUNC76_IN_SEL_CFG_SIG_IN_SEL() uint32 {
	return (volatile.LoadUint32(&o.FUNC76_IN_SEL_CFG.Reg) & 0x40) >> 6
}

// GPIO.FUNC77_IN_SEL_CFG: GPIO input function configuration register
func (o *GPIO_Type) SetFUNC77_IN_SEL_CFG_FUNC_IN_SEL(value uint32) {
	volatile.StoreUint32(&o.FUNC77_IN_SEL_CFG.Reg, volatile.LoadUint32(&o.FUNC77_IN_SEL_CFG.Reg)&^(0x1f)|value)
}
func (o *GPIO_Type) GetFUNC77_IN_SEL_CFG_FUNC_IN_SEL() uint32 {
	return volatile.LoadUint32(&o.FUNC77_IN_SEL_CFG.Reg) & 0x1f
}
func (o *GPIO_Type) SetFUNC77_IN_SEL_CFG_FUNC_IN_INV_SEL(value uint32) {
	volatile.StoreUint32(&o.FUNC77_IN_SEL_CFG.Reg, volatile.LoadUint32(&o.FUNC77_IN_SEL_CFG.Reg)&^(0x20)|value<<5)
}
func (o *GPIO_Type) GetFUNC77_IN_SEL_CFG_FUNC_IN_INV_SEL() uint32 {
	return (volatile.LoadUint32(&o.FUNC77_IN_SEL_CFG.Reg) & 0x20) >> 5
}
func (o *GPIO_Type) SetFUNC77_IN_SEL_CFG_SIG_IN_SEL(value uint32) {
	volatile.StoreUint32(&o.FUNC77_IN_SEL_CFG.Reg, volatile.LoadUint32(&o.FUNC77_IN_SEL_CFG.Reg)&^(0x40)|value<<6)
}
func (o *GPIO_Type) GetFUNC77_IN_SEL_CFG_SIG_IN_SEL() uint32 {
	return (volatile.LoadUint32(&o.FUNC77_IN_SEL_CFG.Reg) & 0x40) >> 6
}

// GPIO.FUNC78_IN_SEL_CFG: GPIO input function configuration register
func (o *GPIO_Type) SetFUNC78_IN_SEL_CFG_FUNC_IN_SEL(value uint32) {
	volatile.StoreUint32(&o.FUNC78_IN_SEL_CFG.Reg, volatile.LoadUint32(&o.FUNC78_IN_SEL_CFG.Reg)&^(0x1f)|value)
}
func (o *GPIO_Type) GetFUNC78_IN_SEL_CFG_FUNC_IN_SEL() uint32 {
	return volatile.LoadUint32(&o.FUNC78_IN_SEL_CFG.Reg) & 0x1f
}
func (o *GPIO_Type) SetFUNC78_IN_SEL_CFG_FUNC_IN_INV_SEL(value uint32) {
	volatile.StoreUint32(&o.FUNC78_IN_SEL_CFG.Reg, volatile.LoadUint32(&o.FUNC78_IN_SEL_CFG.Reg)&^(0x20)|value<<5)
}
func (o *GPIO_Type) GetFUNC78_IN_SEL_CFG_FUNC_IN_INV_SEL() uint32 {
	return (volatile.LoadUint32(&o.FUNC78_IN_SEL_CFG.Reg) & 0x20) >> 5
}
func (o *GPIO_Type) SetFUNC78_IN_SEL_CFG_SIG_IN_SEL(value uint32) {
	volatile.StoreUint32(&o.FUNC78_IN_SEL_CFG.Reg, volatile.LoadUint32(&o.FUNC78_IN_SEL_CFG.Reg)&^(0x40)|value<<6)
}
func (o *GPIO_Type) GetFUNC78_IN_SEL_CFG_SIG_IN_SEL() uint32 {
	return (volatile.LoadUint32(&o.FUNC78_IN_SEL_CFG.Reg) & 0x40) >> 6
}

// GPIO.FUNC79_IN_SEL_CFG: GPIO input function configuration register
func (o *GPIO_Type) SetFUNC79_IN_SEL_CFG_FUNC_IN_SEL(value uint32) {
	volatile.StoreUint32(&o.FUNC79_IN_SEL_CFG.Reg, volatile.LoadUint32(&o.FUNC79_IN_SEL_CFG.Reg)&^(0x1f)|value)
}
func (o *GPIO_Type) GetFUNC79_IN_SEL_CFG_FUNC_IN_SEL() uint32 {
	return volatile.LoadUint32(&o.FUNC79_IN_SEL_CFG.Reg) & 0x1f
}
func (o *GPIO_Type) SetFUNC79_IN_SEL_CFG_FUNC_IN_INV_SEL(value uint32) {
	volatile.StoreUint32(&o.FUNC79_IN_SEL_CFG.Reg, volatile.LoadUint32(&o.FUNC79_IN_SEL_CFG.Reg)&^(0x20)|value<<5)
}
func (o *GPIO_Type) GetFUNC79_IN_SEL_CFG_FUNC_IN_INV_SEL() uint32 {
	return (volatile.LoadUint32(&o.FUNC79_IN_SEL_CFG.Reg) & 0x20) >> 5
}
func (o *GPIO_Type) SetFUNC79_IN_SEL_CFG_SIG_IN_SEL(value uint32) {
	volatile.StoreUint32(&o.FUNC79_IN_SEL_CFG.Reg, volatile.LoadUint32(&o.FUNC79_IN_SEL_CFG.Reg)&^(0x40)|value<<6)
}
func (o *GPIO_Type) GetFUNC79_IN_SEL_CFG_SIG_IN_SEL() uint32 {
	return (volatile.LoadUint32(&o.FUNC79_IN_SEL_CFG.Reg) & 0x40) >> 6
}

// GPIO.FUNC80_IN_SEL_CFG: GPIO input function configuration register
func (o *GPIO_Type) SetFUNC80_IN_SEL_CFG_FUNC_IN_SEL(value uint32) {
	volatile.StoreUint32(&o.FUNC80_IN_SEL_CFG.Reg, volatile.LoadUint32(&o.FUNC80_IN_SEL_CFG.Reg)&^(0x1f)|value)
}
func (o *GPIO_Type) GetFUNC80_IN_SEL_CFG_FUNC_IN_SEL() uint32 {
	return volatile.LoadUint32(&o.FUNC80_IN_SEL_CFG.Reg) & 0x1f
}
func (o *GPIO_Type) SetFUNC80_IN_SEL_CFG_FUNC_IN_INV_SEL(value uint32) {
	volatile.StoreUint32(&o.FUNC80_IN_SEL_CFG.Reg, volatile.LoadUint32(&o.FUNC80_IN_SEL_CFG.Reg)&^(0x20)|value<<5)
}
func (o *GPIO_Type) GetFUNC80_IN_SEL_CFG_FUNC_IN_INV_SEL() uint32 {
	return (volatile.LoadUint32(&o.FUNC80_IN_SEL_CFG.Reg) & 0x20) >> 5
}
func (o *GPIO_Type) SetFUNC80_IN_SEL_CFG_SIG_IN_SEL(value uint32) {
	volatile.StoreUint32(&o.FUNC80_IN_SEL_CFG.Reg, volatile.LoadUint32(&o.FUNC80_IN_SEL_CFG.Reg)&^(0x40)|value<<6)
}
func (o *GPIO_Type) GetFUNC80_IN_SEL_CFG_SIG_IN_SEL() uint32 {
	return (volatile.LoadUint32(&o.FUNC80_IN_SEL_CFG.Reg) & 0x40) >> 6
}

// GPIO.FUNC81_IN_SEL_CFG: GPIO input function configuration register
func (o *GPIO_Type) SetFUNC81_IN_SEL_CFG_FUNC_IN_SEL(value uint32) {
	volatile.StoreUint32(&o.FUNC81_IN_SEL_CFG.Reg, volatile.LoadUint32(&o.FUNC81_IN_SEL_CFG.Reg)&^(0x1f)|value)
}
func (o *GPIO_Type) GetFUNC81_IN_SEL_CFG_FUNC_IN_SEL() uint32 {
	return volatile.LoadUint32(&o.FUNC81_IN_SEL_CFG.Reg) & 0x1f
}
func (o *GPIO_Type) SetFUNC81_IN_SEL_CFG_FUNC_IN_INV_SEL(value uint32) {
	volatile.StoreUint32(&o.FUNC81_IN_SEL_CFG.Reg, volatile.LoadUint32(&o.FUNC81_IN_SEL_CFG.Reg)&^(0x20)|value<<5)
}
func (o *GPIO_Type) GetFUNC81_IN_SEL_CFG_FUNC_IN_INV_SEL() uint32 {
	return (volatile.LoadUint32(&o.FUNC81_IN_SEL_CFG.Reg) & 0x20) >> 5
}
func (o *GPIO_Type) SetFUNC81_IN_SEL_CFG_SIG_IN_SEL(value uint32) {
	volatile.StoreUint32(&o.FUNC81_IN_SEL_CFG.Reg, volatile.LoadUint32(&o.FUNC81_IN_SEL_CFG.Reg)&^(0x40)|value<<6)
}
func (o *GPIO_Type) GetFUNC81_IN_SEL_CFG_SIG_IN_SEL() uint32 {
	return (volatile.LoadUint32(&o.FUNC81_IN_SEL_CFG.Reg) & 0x40) >> 6
}

// GPIO.FUNC82_IN_SEL_CFG: GPIO input function configuration register
func (o *GPIO_Type) SetFUNC82_IN_SEL_CFG_FUNC_IN_SEL(value uint32) {
	volatile.StoreUint32(&o.FUNC82_IN_SEL_CFG.Reg, volatile.LoadUint32(&o.FUNC82_IN_SEL_CFG.Reg)&^(0x1f)|value)
}
func (o *GPIO_Type) GetFUNC82_IN_SEL_CFG_FUNC_IN_SEL() uint32 {
	return volatile.LoadUint32(&o.FUNC82_IN_SEL_CFG.Reg) & 0x1f
}
func (o *GPIO_Type) SetFUNC82_IN_SEL_CFG_FUNC_IN_INV_SEL(value uint32) {
	volatile.StoreUint32(&o.FUNC82_IN_SEL_CFG.Reg, volatile.LoadUint32(&o.FUNC82_IN_SEL_CFG.Reg)&^(0x20)|value<<5)
}
func (o *GPIO_Type) GetFUNC82_IN_SEL_CFG_FUNC_IN_INV_SEL() uint32 {
	return (volatile.LoadUint32(&o.FUNC82_IN_SEL_CFG.Reg) & 0x20) >> 5
}
func (o *GPIO_Type) SetFUNC82_IN_SEL_CFG_SIG_IN_SEL(value uint32) {
	volatile.StoreUint32(&o.FUNC82_IN_SEL_CFG.Reg, volatile.LoadUint32(&o.FUNC82_IN_SEL_CFG.Reg)&^(0x40)|value<<6)
}
func (o *GPIO_Type) GetFUNC82_IN_SEL_CFG_SIG_IN_SEL() uint32 {
	return (volatile.LoadUint32(&o.FUNC82_IN_SEL_CFG.Reg) & 0x40) >> 6
}

// GPIO.FUNC83_IN_SEL_CFG: GPIO input function configuration register
func (o *GPIO_Type) SetFUNC83_IN_SEL_CFG_FUNC_IN_SEL(value uint32) {
	volatile.StoreUint32(&o.FUNC83_IN_SEL_CFG.Reg, volatile.LoadUint32(&o.FUNC83_IN_SEL_CFG.Reg)&^(0x1f)|value)
}
func (o *GPIO_Type) GetFUNC83_IN_SEL_CFG_FUNC_IN_SEL() uint32 {
	return volatile.LoadUint32(&o.FUNC83_IN_SEL_CFG.Reg) & 0x1f
}
func (o *GPIO_Type) SetFUNC83_IN_SEL_CFG_FUNC_IN_INV_SEL(value uint32) {
	volatile.StoreUint32(&o.FUNC83_IN_SEL_CFG.Reg, volatile.LoadUint32(&o.FUNC83_IN_SEL_CFG.Reg)&^(0x20)|value<<5)
}
func (o *GPIO_Type) GetFUNC83_IN_SEL_CFG_FUNC_IN_INV_SEL() uint32 {
	return (volatile.LoadUint32(&o.FUNC83_IN_SEL_CFG.Reg) & 0x20) >> 5
}
func (o *GPIO_Type) SetFUNC83_IN_SEL_CFG_SIG_IN_SEL(value uint32) {
	volatile.StoreUint32(&o.FUNC83_IN_SEL_CFG.Reg, volatile.LoadUint32(&o.FUNC83_IN_SEL_CFG.Reg)&^(0x40)|value<<6)
}
func (o *GPIO_Type) GetFUNC83_IN_SEL_CFG_SIG_IN_SEL() uint32 {
	return (volatile.LoadUint32(&o.FUNC83_IN_SEL_CFG.Reg) & 0x40) >> 6
}

// GPIO.FUNC84_IN_SEL_CFG: GPIO input function configuration register
func (o *GPIO_Type) SetFUNC84_IN_SEL_CFG_FUNC_IN_SEL(value uint32) {
	volatile.StoreUint32(&o.FUNC84_IN_SEL_CFG.Reg, volatile.LoadUint32(&o.FUNC84_IN_SEL_CFG.Reg)&^(0x1f)|value)
}
func (o *GPIO_Type) GetFUNC84_IN_SEL_CFG_FUNC_IN_SEL() uint32 {
	return volatile.LoadUint32(&o.FUNC84_IN_SEL_CFG.Reg) & 0x1f
}
func (o *GPIO_Type) SetFUNC84_IN_SEL_CFG_FUNC_IN_INV_SEL(value uint32) {
	volatile.StoreUint32(&o.FUNC84_IN_SEL_CFG.Reg, volatile.LoadUint32(&o.FUNC84_IN_SEL_CFG.Reg)&^(0x20)|value<<5)
}
func (o *GPIO_Type) GetFUNC84_IN_SEL_CFG_FUNC_IN_INV_SEL() uint32 {
	return (volatile.LoadUint32(&o.FUNC84_IN_SEL_CFG.Reg) & 0x20) >> 5
}
func (o *GPIO_Type) SetFUNC84_IN_SEL_CFG_SIG_IN_SEL(value uint32) {
	volatile.StoreUint32(&o.FUNC84_IN_SEL_CFG.Reg, volatile.LoadUint32(&o.FUNC84_IN_SEL_CFG.Reg)&^(0x40)|value<<6)
}
func (o *GPIO_Type) GetFUNC84_IN_SEL_CFG_SIG_IN_SEL() uint32 {
	return (volatile.LoadUint32(&o.FUNC84_IN_SEL_CFG.Reg) & 0x40) >> 6
}

// GPIO.FUNC85_IN_SEL_CFG: GPIO input function configuration register
func (o *GPIO_Type) SetFUNC85_IN_SEL_CFG_FUNC_IN_SEL(value uint32) {
	volatile.StoreUint32(&o.FUNC85_IN_SEL_CFG.Reg, volatile.LoadUint32(&o.FUNC85_IN_SEL_CFG.Reg)&^(0x1f)|value)
}
func (o *GPIO_Type) GetFUNC85_IN_SEL_CFG_FUNC_IN_SEL() uint32 {
	return volatile.LoadUint32(&o.FUNC85_IN_SEL_CFG.Reg) & 0x1f
}
func (o *GPIO_Type) SetFUNC85_IN_SEL_CFG_FUNC_IN_INV_SEL(value uint32) {
	volatile.StoreUint32(&o.FUNC85_IN_SEL_CFG.Reg, volatile.LoadUint32(&o.FUNC85_IN_SEL_CFG.Reg)&^(0x20)|value<<5)
}
func (o *GPIO_Type) GetFUNC85_IN_SEL_CFG_FUNC_IN_INV_SEL() uint32 {
	return (volatile.LoadUint32(&o.FUNC85_IN_SEL_CFG.Reg) & 0x20) >> 5
}
func (o *GPIO_Type) SetFUNC85_IN_SEL_CFG_SIG_IN_SEL(value uint32) {
	volatile.StoreUint32(&o.FUNC85_IN_SEL_CFG.Reg, volatile.LoadUint32(&o.FUNC85_IN_SEL_CFG.Reg)&^(0x40)|value<<6)
}
func (o *GPIO_Type) GetFUNC85_IN_SEL_CFG_SIG_IN_SEL() uint32 {
	return (volatile.LoadUint32(&o.FUNC85_IN_SEL_CFG.Reg) & 0x40) >> 6
}

// GPIO.FUNC86_IN_SEL_CFG: GPIO input function configuration register
func (o *GPIO_Type) SetFUNC86_IN_SEL_CFG_FUNC_IN_SEL(value uint32) {
	volatile.StoreUint32(&o.FUNC86_IN_SEL_CFG.Reg, volatile.LoadUint32(&o.FUNC86_IN_SEL_CFG.Reg)&^(0x1f)|value)
}
func (o *GPIO_Type) GetFUNC86_IN_SEL_CFG_FUNC_IN_SEL() uint32 {
	return volatile.LoadUint32(&o.FUNC86_IN_SEL_CFG.Reg) & 0x1f
}
func (o *GPIO_Type) SetFUNC86_IN_SEL_CFG_FUNC_IN_INV_SEL(value uint32) {
	volatile.StoreUint32(&o.FUNC86_IN_SEL_CFG.Reg, volatile.LoadUint32(&o.FUNC86_IN_SEL_CFG.Reg)&^(0x20)|value<<5)
}
func (o *GPIO_Type) GetFUNC86_IN_SEL_CFG_FUNC_IN_INV_SEL() uint32 {
	return (volatile.LoadUint32(&o.FUNC86_IN_SEL_CFG.Reg) & 0x20) >> 5
}
func (o *GPIO_Type) SetFUNC86_IN_SEL_CFG_SIG_IN_SEL(value uint32) {
	volatile.StoreUint32(&o.FUNC86_IN_SEL_CFG.Reg, volatile.LoadUint32(&o.FUNC86_IN_SEL_CFG.Reg)&^(0x40)|value<<6)
}
func (o *GPIO_Type) GetFUNC86_IN_SEL_CFG_SIG_IN_SEL() uint32 {
	return (volatile.LoadUint32(&o.FUNC86_IN_SEL_CFG.Reg) & 0x40) >> 6
}

// GPIO.FUNC87_IN_SEL_CFG: GPIO input function configuration register
func (o *GPIO_Type) SetFUNC87_IN_SEL_CFG_FUNC_IN_SEL(value uint32) {
	volatile.StoreUint32(&o.FUNC87_IN_SEL_CFG.Reg, volatile.LoadUint32(&o.FUNC87_IN_SEL_CFG.Reg)&^(0x1f)|value)
}
func (o *GPIO_Type) GetFUNC87_IN_SEL_CFG_FUNC_IN_SEL() uint32 {
	return volatile.LoadUint32(&o.FUNC87_IN_SEL_CFG.Reg) & 0x1f
}
func (o *GPIO_Type) SetFUNC87_IN_SEL_CFG_FUNC_IN_INV_SEL(value uint32) {
	volatile.StoreUint32(&o.FUNC87_IN_SEL_CFG.Reg, volatile.LoadUint32(&o.FUNC87_IN_SEL_CFG.Reg)&^(0x20)|value<<5)
}
func (o *GPIO_Type) GetFUNC87_IN_SEL_CFG_FUNC_IN_INV_SEL() uint32 {
	return (volatile.LoadUint32(&o.FUNC87_IN_SEL_CFG.Reg) & 0x20) >> 5
}
func (o *GPIO_Type) SetFUNC87_IN_SEL_CFG_SIG_IN_SEL(value uint32) {
	volatile.StoreUint32(&o.FUNC87_IN_SEL_CFG.Reg, volatile.LoadUint32(&o.FUNC87_IN_SEL_CFG.Reg)&^(0x40)|value<<6)
}
func (o *GPIO_Type) GetFUNC87_IN_SEL_CFG_SIG_IN_SEL() uint32 {
	return (volatile.LoadUint32(&o.FUNC87_IN_SEL_CFG.Reg) & 0x40) >> 6
}

// GPIO.FUNC88_IN_SEL_CFG: GPIO input function configuration register
func (o *GPIO_Type) SetFUNC88_IN_SEL_CFG_FUNC_IN_SEL(value uint32) {
	volatile.StoreUint32(&o.FUNC88_IN_SEL_CFG.Reg, volatile.LoadUint32(&o.FUNC88_IN_SEL_CFG.Reg)&^(0x1f)|value)
}
func (o *GPIO_Type) GetFUNC88_IN_SEL_CFG_FUNC_IN_SEL() uint32 {
	return volatile.LoadUint32(&o.FUNC88_IN_SEL_CFG.Reg) & 0x1f
}
func (o *GPIO_Type) SetFUNC88_IN_SEL_CFG_FUNC_IN_INV_SEL(value uint32) {
	volatile.StoreUint32(&o.FUNC88_IN_SEL_CFG.Reg, volatile.LoadUint32(&o.FUNC88_IN_SEL_CFG.Reg)&^(0x20)|value<<5)
}
func (o *GPIO_Type) GetFUNC88_IN_SEL_CFG_FUNC_IN_INV_SEL() uint32 {
	return (volatile.LoadUint32(&o.FUNC88_IN_SEL_CFG.Reg) & 0x20) >> 5
}
func (o *GPIO_Type) SetFUNC88_IN_SEL_CFG_SIG_IN_SEL(value uint32) {
	volatile.StoreUint32(&o.FUNC88_IN_SEL_CFG.Reg, volatile.LoadUint32(&o.FUNC88_IN_SEL_CFG.Reg)&^(0x40)|value<<6)
}
func (o *GPIO_Type) GetFUNC88_IN_SEL_CFG_SIG_IN_SEL() uint32 {
	return (volatile.LoadUint32(&o.FUNC88_IN_SEL_CFG.Reg) & 0x40) >> 6
}

// GPIO.FUNC89_IN_SEL_CFG: GPIO input function configuration register
func (o *GPIO_Type) SetFUNC89_IN_SEL_CFG_FUNC_IN_SEL(value uint32) {
	volatile.StoreUint32(&o.FUNC89_IN_SEL_CFG.Reg, volatile.LoadUint32(&o.FUNC89_IN_SEL_CFG.Reg)&^(0x1f)|value)
}
func (o *GPIO_Type) GetFUNC89_IN_SEL_CFG_FUNC_IN_SEL() uint32 {
	return volatile.LoadUint32(&o.FUNC89_IN_SEL_CFG.Reg) & 0x1f
}
func (o *GPIO_Type) SetFUNC89_IN_SEL_CFG_FUNC_IN_INV_SEL(value uint32) {
	volatile.StoreUint32(&o.FUNC89_IN_SEL_CFG.Reg, volatile.LoadUint32(&o.FUNC89_IN_SEL_CFG.Reg)&^(0x20)|value<<5)
}
func (o *GPIO_Type) GetFUNC89_IN_SEL_CFG_FUNC_IN_INV_SEL() uint32 {
	return (volatile.LoadUint32(&o.FUNC89_IN_SEL_CFG.Reg) & 0x20) >> 5
}
func (o *GPIO_Type) SetFUNC89_IN_SEL_CFG_SIG_IN_SEL(value uint32) {
	volatile.StoreUint32(&o.FUNC89_IN_SEL_CFG.Reg, volatile.LoadUint32(&o.FUNC89_IN_SEL_CFG.Reg)&^(0x40)|value<<6)
}
func (o *GPIO_Type) GetFUNC89_IN_SEL_CFG_SIG_IN_SEL() uint32 {
	return (volatile.LoadUint32(&o.FUNC89_IN_SEL_CFG.Reg) & 0x40) >> 6
}

// GPIO.FUNC90_IN_SEL_CFG: GPIO input function configuration register
func (o *GPIO_Type) SetFUNC90_IN_SEL_CFG_FUNC_IN_SEL(value uint32) {
	volatile.StoreUint32(&o.FUNC90_IN_SEL_CFG.Reg, volatile.LoadUint32(&o.FUNC90_IN_SEL_CFG.Reg)&^(0x1f)|value)
}
func (o *GPIO_Type) GetFUNC90_IN_SEL_CFG_FUNC_IN_SEL() uint32 {
	return volatile.LoadUint32(&o.FUNC90_IN_SEL_CFG.Reg) & 0x1f
}
func (o *GPIO_Type) SetFUNC90_IN_SEL_CFG_FUNC_IN_INV_SEL(value uint32) {
	volatile.StoreUint32(&o.FUNC90_IN_SEL_CFG.Reg, volatile.LoadUint32(&o.FUNC90_IN_SEL_CFG.Reg)&^(0x20)|value<<5)
}
func (o *GPIO_Type) GetFUNC90_IN_SEL_CFG_FUNC_IN_INV_SEL() uint32 {
	return (volatile.LoadUint32(&o.FUNC90_IN_SEL_CFG.Reg) & 0x20) >> 5
}
func (o *GPIO_Type) SetFUNC90_IN_SEL_CFG_SIG_IN_SEL(value uint32) {
	volatile.StoreUint32(&o.FUNC90_IN_SEL_CFG.Reg, volatile.LoadUint32(&o.FUNC90_IN_SEL_CFG.Reg)&^(0x40)|value<<6)
}
func (o *GPIO_Type) GetFUNC90_IN_SEL_CFG_SIG_IN_SEL() uint32 {
	return (volatile.LoadUint32(&o.FUNC90_IN_SEL_CFG.Reg) & 0x40) >> 6
}

// GPIO.FUNC91_IN_SEL_CFG: GPIO input function configuration register
func (o *GPIO_Type) SetFUNC91_IN_SEL_CFG_FUNC_IN_SEL(value uint32) {
	volatile.StoreUint32(&o.FUNC91_IN_SEL_CFG.Reg, volatile.LoadUint32(&o.FUNC91_IN_SEL_CFG.Reg)&^(0x1f)|value)
}
func (o *GPIO_Type) GetFUNC91_IN_SEL_CFG_FUNC_IN_SEL() uint32 {
	return volatile.LoadUint32(&o.FUNC91_IN_SEL_CFG.Reg) & 0x1f
}
func (o *GPIO_Type) SetFUNC91_IN_SEL_CFG_FUNC_IN_INV_SEL(value uint32) {
	volatile.StoreUint32(&o.FUNC91_IN_SEL_CFG.Reg, volatile.LoadUint32(&o.FUNC91_IN_SEL_CFG.Reg)&^(0x20)|value<<5)
}
func (o *GPIO_Type) GetFUNC91_IN_SEL_CFG_FUNC_IN_INV_SEL() uint32 {
	return (volatile.LoadUint32(&o.FUNC91_IN_SEL_CFG.Reg) & 0x20) >> 5
}
func (o *GPIO_Type) SetFUNC91_IN_SEL_CFG_SIG_IN_SEL(value uint32) {
	volatile.StoreUint32(&o.FUNC91_IN_SEL_CFG.Reg, volatile.LoadUint32(&o.FUNC91_IN_SEL_CFG.Reg)&^(0x40)|value<<6)
}
func (o *GPIO_Type) GetFUNC91_IN_SEL_CFG_SIG_IN_SEL() uint32 {
	return (volatile.LoadUint32(&o.FUNC91_IN_SEL_CFG.Reg) & 0x40) >> 6
}

// GPIO.FUNC92_IN_SEL_CFG: GPIO input function configuration register
func (o *GPIO_Type) SetFUNC92_IN_SEL_CFG_FUNC_IN_SEL(value uint32) {
	volatile.StoreUint32(&o.FUNC92_IN_SEL_CFG.Reg, volatile.LoadUint32(&o.FUNC92_IN_SEL_CFG.Reg)&^(0x1f)|value)
}
func (o *GPIO_Type) GetFUNC92_IN_SEL_CFG_FUNC_IN_SEL() uint32 {
	return volatile.LoadUint32(&o.FUNC92_IN_SEL_CFG.Reg) & 0x1f
}
func (o *GPIO_Type) SetFUNC92_IN_SEL_CFG_FUNC_IN_INV_SEL(value uint32) {
	volatile.StoreUint32(&o.FUNC92_IN_SEL_CFG.Reg, volatile.LoadUint32(&o.FUNC92_IN_SEL_CFG.Reg)&^(0x20)|value<<5)
}
func (o *GPIO_Type) GetFUNC92_IN_SEL_CFG_FUNC_IN_INV_SEL() uint32 {
	return (volatile.LoadUint32(&o.FUNC92_IN_SEL_CFG.Reg) & 0x20) >> 5
}
func (o *GPIO_Type) SetFUNC92_IN_SEL_CFG_SIG_IN_SEL(value uint32) {
	volatile.StoreUint32(&o.FUNC92_IN_SEL_CFG.Reg, volatile.LoadUint32(&o.FUNC92_IN_SEL_CFG.Reg)&^(0x40)|value<<6)
}
func (o *GPIO_Type) GetFUNC92_IN_SEL_CFG_SIG_IN_SEL() uint32 {
	return (volatile.LoadUint32(&o.FUNC92_IN_SEL_CFG.Reg) & 0x40) >> 6
}

// GPIO.FUNC93_IN_SEL_CFG: GPIO input function configuration register
func (o *GPIO_Type) SetFUNC93_IN_SEL_CFG_FUNC_IN_SEL(value uint32) {
	volatile.StoreUint32(&o.FUNC93_IN_SEL_CFG.Reg, volatile.LoadUint32(&o.FUNC93_IN_SEL_CFG.Reg)&^(0x1f)|value)
}
func (o *GPIO_Type) GetFUNC93_IN_SEL_CFG_FUNC_IN_SEL() uint32 {
	return volatile.LoadUint32(&o.FUNC93_IN_SEL_CFG.Reg) & 0x1f
}
func (o *GPIO_Type) SetFUNC93_IN_SEL_CFG_FUNC_IN_INV_SEL(value uint32) {
	volatile.StoreUint32(&o.FUNC93_IN_SEL_CFG.Reg, volatile.LoadUint32(&o.FUNC93_IN_SEL_CFG.Reg)&^(0x20)|value<<5)
}
func (o *GPIO_Type) GetFUNC93_IN_SEL_CFG_FUNC_IN_INV_SEL() uint32 {
	return (volatile.LoadUint32(&o.FUNC93_IN_SEL_CFG.Reg) & 0x20) >> 5
}
func (o *GPIO_Type) SetFUNC93_IN_SEL_CFG_SIG_IN_SEL(value uint32) {
	volatile.StoreUint32(&o.FUNC93_IN_SEL_CFG.Reg, volatile.LoadUint32(&o.FUNC93_IN_SEL_CFG.Reg)&^(0x40)|value<<6)
}
func (o *GPIO_Type) GetFUNC93_IN_SEL_CFG_SIG_IN_SEL() uint32 {
	return (volatile.LoadUint32(&o.FUNC93_IN_SEL_CFG.Reg) & 0x40) >> 6
}

// GPIO.FUNC94_IN_SEL_CFG: GPIO input function configuration register
func (o *GPIO_Type) SetFUNC94_IN_SEL_CFG_FUNC_IN_SEL(value uint32) {
	volatile.StoreUint32(&o.FUNC94_IN_SEL_CFG.Reg, volatile.LoadUint32(&o.FUNC94_IN_SEL_CFG.Reg)&^(0x1f)|value)
}
func (o *GPIO_Type) GetFUNC94_IN_SEL_CFG_FUNC_IN_SEL() uint32 {
	return volatile.LoadUint32(&o.FUNC94_IN_SEL_CFG.Reg) & 0x1f
}
func (o *GPIO_Type) SetFUNC94_IN_SEL_CFG_FUNC_IN_INV_SEL(value uint32) {
	volatile.StoreUint32(&o.FUNC94_IN_SEL_CFG.Reg, volatile.LoadUint32(&o.FUNC94_IN_SEL_CFG.Reg)&^(0x20)|value<<5)
}
func (o *GPIO_Type) GetFUNC94_IN_SEL_CFG_FUNC_IN_INV_SEL() uint32 {
	return (volatile.LoadUint32(&o.FUNC94_IN_SEL_CFG.Reg) & 0x20) >> 5
}
func (o *GPIO_Type) SetFUNC94_IN_SEL_CFG_SIG_IN_SEL(value uint32) {
	volatile.StoreUint32(&o.FUNC94_IN_SEL_CFG.Reg, volatile.LoadUint32(&o.FUNC94_IN_SEL_CFG.Reg)&^(0x40)|value<<6)
}
func (o *GPIO_Type) GetFUNC94_IN_SEL_CFG_SIG_IN_SEL() uint32 {
	return (volatile.LoadUint32(&o.FUNC94_IN_SEL_CFG.Reg) & 0x40) >> 6
}

// GPIO.FUNC95_IN_SEL_CFG: GPIO input function configuration register
func (o *GPIO_Type) SetFUNC95_IN_SEL_CFG_FUNC_IN_SEL(value uint32) {
	volatile.StoreUint32(&o.FUNC95_IN_SEL_CFG.Reg, volatile.LoadUint32(&o.FUNC95_IN_SEL_CFG.Reg)&^(0x1f)|value)
}
func (o *GPIO_Type) GetFUNC95_IN_SEL_CFG_FUNC_IN_SEL() uint32 {
	return volatile.LoadUint32(&o.FUNC95_IN_SEL_CFG.Reg) & 0x1f
}
func (o *GPIO_Type) SetFUNC95_IN_SEL_CFG_FUNC_IN_INV_SEL(value uint32) {
	volatile.StoreUint32(&o.FUNC95_IN_SEL_CFG.Reg, volatile.LoadUint32(&o.FUNC95_IN_SEL_CFG.Reg)&^(0x20)|value<<5)
}
func (o *GPIO_Type) GetFUNC95_IN_SEL_CFG_FUNC_IN_INV_SEL() uint32 {
	return (volatile.LoadUint32(&o.FUNC95_IN_SEL_CFG.Reg) & 0x20) >> 5
}
func (o *GPIO_Type) SetFUNC95_IN_SEL_CFG_SIG_IN_SEL(value uint32) {
	volatile.StoreUint32(&o.FUNC95_IN_SEL_CFG.Reg, volatile.LoadUint32(&o.FUNC95_IN_SEL_CFG.Reg)&^(0x40)|value<<6)
}
func (o *GPIO_Type) GetFUNC95_IN_SEL_CFG_SIG_IN_SEL() uint32 {
	return (volatile.LoadUint32(&o.FUNC95_IN_SEL_CFG.Reg) & 0x40) >> 6
}

// GPIO.FUNC96_IN_SEL_CFG: GPIO input function configuration register
func (o *GPIO_Type) SetFUNC96_IN_SEL_CFG_FUNC_IN_SEL(value uint32) {
	volatile.StoreUint32(&o.FUNC96_IN_SEL_CFG.Reg, volatile.LoadUint32(&o.FUNC96_IN_SEL_CFG.Reg)&^(0x1f)|value)
}
func (o *GPIO_Type) GetFUNC96_IN_SEL_CFG_FUNC_IN_SEL() uint32 {
	return volatile.LoadUint32(&o.FUNC96_IN_SEL_CFG.Reg) & 0x1f
}
func (o *GPIO_Type) SetFUNC96_IN_SEL_CFG_FUNC_IN_INV_SEL(value uint32) {
	volatile.StoreUint32(&o.FUNC96_IN_SEL_CFG.Reg, volatile.LoadUint32(&o.FUNC96_IN_SEL_CFG.Reg)&^(0x20)|value<<5)
}
func (o *GPIO_Type) GetFUNC96_IN_SEL_CFG_FUNC_IN_INV_SEL() uint32 {
	return (volatile.LoadUint32(&o.FUNC96_IN_SEL_CFG.Reg) & 0x20) >> 5
}
func (o *GPIO_Type) SetFUNC96_IN_SEL_CFG_SIG_IN_SEL(value uint32) {
	volatile.StoreUint32(&o.FUNC96_IN_SEL_CFG.Reg, volatile.LoadUint32(&o.FUNC96_IN_SEL_CFG.Reg)&^(0x40)|value<<6)
}
func (o *GPIO_Type) GetFUNC96_IN_SEL_CFG_SIG_IN_SEL() uint32 {
	return (volatile.LoadUint32(&o.FUNC96_IN_SEL_CFG.Reg) & 0x40) >> 6
}

// GPIO.FUNC97_IN_SEL_CFG: GPIO input function configuration register
func (o *GPIO_Type) SetFUNC97_IN_SEL_CFG_FUNC_IN_SEL(value uint32) {
	volatile.StoreUint32(&o.FUNC97_IN_SEL_CFG.Reg, volatile.LoadUint32(&o.FUNC97_IN_SEL_CFG.Reg)&^(0x1f)|value)
}
func (o *GPIO_Type) GetFUNC97_IN_SEL_CFG_FUNC_IN_SEL() uint32 {
	return volatile.LoadUint32(&o.FUNC97_IN_SEL_CFG.Reg) & 0x1f
}
func (o *GPIO_Type) SetFUNC97_IN_SEL_CFG_FUNC_IN_INV_SEL(value uint32) {
	volatile.StoreUint32(&o.FUNC97_IN_SEL_CFG.Reg, volatile.LoadUint32(&o.FUNC97_IN_SEL_CFG.Reg)&^(0x20)|value<<5)
}
func (o *GPIO_Type) GetFUNC97_IN_SEL_CFG_FUNC_IN_INV_SEL() uint32 {
	return (volatile.LoadUint32(&o.FUNC97_IN_SEL_CFG.Reg) & 0x20) >> 5
}
func (o *GPIO_Type) SetFUNC97_IN_SEL_CFG_SIG_IN_SEL(value uint32) {
	volatile.StoreUint32(&o.FUNC97_IN_SEL_CFG.Reg, volatile.LoadUint32(&o.FUNC97_IN_SEL_CFG.Reg)&^(0x40)|value<<6)
}
func (o *GPIO_Type) GetFUNC97_IN_SEL_CFG_SIG_IN_SEL() uint32 {
	return (volatile.LoadUint32(&o.FUNC97_IN_SEL_CFG.Reg) & 0x40) >> 6
}

// GPIO.FUNC98_IN_SEL_CFG: GPIO input function configuration register
func (o *GPIO_Type) SetFUNC98_IN_SEL_CFG_FUNC_IN_SEL(value uint32) {
	volatile.StoreUint32(&o.FUNC98_IN_SEL_CFG.Reg, volatile.LoadUint32(&o.FUNC98_IN_SEL_CFG.Reg)&^(0x1f)|value)
}
func (o *GPIO_Type) GetFUNC98_IN_SEL_CFG_FUNC_IN_SEL() uint32 {
	return volatile.LoadUint32(&o.FUNC98_IN_SEL_CFG.Reg) & 0x1f
}
func (o *GPIO_Type) SetFUNC98_IN_SEL_CFG_FUNC_IN_INV_SEL(value uint32) {
	volatile.StoreUint32(&o.FUNC98_IN_SEL_CFG.Reg, volatile.LoadUint32(&o.FUNC98_IN_SEL_CFG.Reg)&^(0x20)|value<<5)
}
func (o *GPIO_Type) GetFUNC98_IN_SEL_CFG_FUNC_IN_INV_SEL() uint32 {
	return (volatile.LoadUint32(&o.FUNC98_IN_SEL_CFG.Reg) & 0x20) >> 5
}
func (o *GPIO_Type) SetFUNC98_IN_SEL_CFG_SIG_IN_SEL(value uint32) {
	volatile.StoreUint32(&o.FUNC98_IN_SEL_CFG.Reg, volatile.LoadUint32(&o.FUNC98_IN_SEL_CFG.Reg)&^(0x40)|value<<6)
}
func (o *GPIO_Type) GetFUNC98_IN_SEL_CFG_SIG_IN_SEL() uint32 {
	return (volatile.LoadUint32(&o.FUNC98_IN_SEL_CFG.Reg) & 0x40) >> 6
}

// GPIO.FUNC99_IN_SEL_CFG: GPIO input function configuration register
func (o *GPIO_Type) SetFUNC99_IN_SEL_CFG_FUNC_IN_SEL(value uint32) {
	volatile.StoreUint32(&o.FUNC99_IN_SEL_CFG.Reg, volatile.LoadUint32(&o.FUNC99_IN_SEL_CFG.Reg)&^(0x1f)|value)
}
func (o *GPIO_Type) GetFUNC99_IN_SEL_CFG_FUNC_IN_SEL() uint32 {
	return volatile.LoadUint32(&o.FUNC99_IN_SEL_CFG.Reg) & 0x1f
}
func (o *GPIO_Type) SetFUNC99_IN_SEL_CFG_FUNC_IN_INV_SEL(value uint32) {
	volatile.StoreUint32(&o.FUNC99_IN_SEL_CFG.Reg, volatile.LoadUint32(&o.FUNC99_IN_SEL_CFG.Reg)&^(0x20)|value<<5)
}
func (o *GPIO_Type) GetFUNC99_IN_SEL_CFG_FUNC_IN_INV_SEL() uint32 {
	return (volatile.LoadUint32(&o.FUNC99_IN_SEL_CFG.Reg) & 0x20) >> 5
}
func (o *GPIO_Type) SetFUNC99_IN_SEL_CFG_SIG_IN_SEL(value uint32) {
	volatile.StoreUint32(&o.FUNC99_IN_SEL_CFG.Reg, volatile.LoadUint32(&o.FUNC99_IN_SEL_CFG.Reg)&^(0x40)|value<<6)
}
func (o *GPIO_Type) GetFUNC99_IN_SEL_CFG_SIG_IN_SEL() uint32 {
	return (volatile.LoadUint32(&o.FUNC99_IN_SEL_CFG.Reg) & 0x40) >> 6
}

// GPIO.FUNC100_IN_SEL_CFG: GPIO input function configuration register
func (o *GPIO_Type) SetFUNC100_IN_SEL_CFG_FUNC_IN_SEL(value uint32) {
	volatile.StoreUint32(&o.FUNC100_IN_SEL_CFG.Reg, volatile.LoadUint32(&o.FUNC100_IN_SEL_CFG.Reg)&^(0x1f)|value)
}
func (o *GPIO_Type) GetFUNC100_IN_SEL_CFG_FUNC_IN_SEL() uint32 {
	return volatile.LoadUint32(&o.FUNC100_IN_SEL_CFG.Reg) & 0x1f
}
func (o *GPIO_Type) SetFUNC100_IN_SEL_CFG_FUNC_IN_INV_SEL(value uint32) {
	volatile.StoreUint32(&o.FUNC100_IN_SEL_CFG.Reg, volatile.LoadUint32(&o.FUNC100_IN_SEL_CFG.Reg)&^(0x20)|value<<5)
}
func (o *GPIO_Type) GetFUNC100_IN_SEL_CFG_FUNC_IN_INV_SEL() uint32 {
	return (volatile.LoadUint32(&o.FUNC100_IN_SEL_CFG.Reg) & 0x20) >> 5
}
func (o *GPIO_Type) SetFUNC100_IN_SEL_CFG_SIG_IN_SEL(value uint32) {
	volatile.StoreUint32(&o.FUNC100_IN_SEL_CFG.Reg, volatile.LoadUint32(&o.FUNC100_IN_SEL_CFG.Reg)&^(0x40)|value<<6)
}
func (o *GPIO_Type) GetFUNC100_IN_SEL_CFG_SIG_IN_SEL() uint32 {
	return (volatile.LoadUint32(&o.FUNC100_IN_SEL_CFG.Reg) & 0x40) >> 6
}

// GPIO.FUNC101_IN_SEL_CFG: GPIO input function configuration register
func (o *GPIO_Type) SetFUNC101_IN_SEL_CFG_FUNC_IN_SEL(value uint32) {
	volatile.StoreUint32(&o.FUNC101_IN_SEL_CFG.Reg, volatile.LoadUint32(&o.FUNC101_IN_SEL_CFG.Reg)&^(0x1f)|value)
}
func (o *GPIO_Type) GetFUNC101_IN_SEL_CFG_FUNC_IN_SEL() uint32 {
	return volatile.LoadUint32(&o.FUNC101_IN_SEL_CFG.Reg) & 0x1f
}
func (o *GPIO_Type) SetFUNC101_IN_SEL_CFG_FUNC_IN_INV_SEL(value uint32) {
	volatile.StoreUint32(&o.FUNC101_IN_SEL_CFG.Reg, volatile.LoadUint32(&o.FUNC101_IN_SEL_CFG.Reg)&^(0x20)|value<<5)
}
func (o *GPIO_Type) GetFUNC101_IN_SEL_CFG_FUNC_IN_INV_SEL() uint32 {
	return (volatile.LoadUint32(&o.FUNC101_IN_SEL_CFG.Reg) & 0x20) >> 5
}
func (o *GPIO_Type) SetFUNC101_IN_SEL_CFG_SIG_IN_SEL(value uint32) {
	volatile.StoreUint32(&o.FUNC101_IN_SEL_CFG.Reg, volatile.LoadUint32(&o.FUNC101_IN_SEL_CFG.Reg)&^(0x40)|value<<6)
}
func (o *GPIO_Type) GetFUNC101_IN_SEL_CFG_SIG_IN_SEL() uint32 {
	return (volatile.LoadUint32(&o.FUNC101_IN_SEL_CFG.Reg) & 0x40) >> 6
}

// GPIO.FUNC102_IN_SEL_CFG: GPIO input function configuration register
func (o *GPIO_Type) SetFUNC102_IN_SEL_CFG_FUNC_IN_SEL(value uint32) {
	volatile.StoreUint32(&o.FUNC102_IN_SEL_CFG.Reg, volatile.LoadUint32(&o.FUNC102_IN_SEL_CFG.Reg)&^(0x1f)|value)
}
func (o *GPIO_Type) GetFUNC102_IN_SEL_CFG_FUNC_IN_SEL() uint32 {
	return volatile.LoadUint32(&o.FUNC102_IN_SEL_CFG.Reg) & 0x1f
}
func (o *GPIO_Type) SetFUNC102_IN_SEL_CFG_FUNC_IN_INV_SEL(value uint32) {
	volatile.StoreUint32(&o.FUNC102_IN_SEL_CFG.Reg, volatile.LoadUint32(&o.FUNC102_IN_SEL_CFG.Reg)&^(0x20)|value<<5)
}
func (o *GPIO_Type) GetFUNC102_IN_SEL_CFG_FUNC_IN_INV_SEL() uint32 {
	return (volatile.LoadUint32(&o.FUNC102_IN_SEL_CFG.Reg) & 0x20) >> 5
}
func (o *GPIO_Type) SetFUNC102_IN_SEL_CFG_SIG_IN_SEL(value uint32) {
	volatile.StoreUint32(&o.FUNC102_IN_SEL_CFG.Reg, volatile.LoadUint32(&o.FUNC102_IN_SEL_CFG.Reg)&^(0x40)|value<<6)
}
func (o *GPIO_Type) GetFUNC102_IN_SEL_CFG_SIG_IN_SEL() uint32 {
	return (volatile.LoadUint32(&o.FUNC102_IN_SEL_CFG.Reg) & 0x40) >> 6
}

// GPIO.FUNC103_IN_SEL_CFG: GPIO input function configuration register
func (o *GPIO_Type) SetFUNC103_IN_SEL_CFG_FUNC_IN_SEL(value uint32) {
	volatile.StoreUint32(&o.FUNC103_IN_SEL_CFG.Reg, volatile.LoadUint32(&o.FUNC103_IN_SEL_CFG.Reg)&^(0x1f)|value)
}
func (o *GPIO_Type) GetFUNC103_IN_SEL_CFG_FUNC_IN_SEL() uint32 {
	return volatile.LoadUint32(&o.FUNC103_IN_SEL_CFG.Reg) & 0x1f
}
func (o *GPIO_Type) SetFUNC103_IN_SEL_CFG_FUNC_IN_INV_SEL(value uint32) {
	volatile.StoreUint32(&o.FUNC103_IN_SEL_CFG.Reg, volatile.LoadUint32(&o.FUNC103_IN_SEL_CFG.Reg)&^(0x20)|value<<5)
}
func (o *GPIO_Type) GetFUNC103_IN_SEL_CFG_FUNC_IN_INV_SEL() uint32 {
	return (volatile.LoadUint32(&o.FUNC103_IN_SEL_CFG.Reg) & 0x20) >> 5
}
func (o *GPIO_Type) SetFUNC103_IN_SEL_CFG_SIG_IN_SEL(value uint32) {
	volatile.StoreUint32(&o.FUNC103_IN_SEL_CFG.Reg, volatile.LoadUint32(&o.FUNC103_IN_SEL_CFG.Reg)&^(0x40)|value<<6)
}
func (o *GPIO_Type) GetFUNC103_IN_SEL_CFG_SIG_IN_SEL() uint32 {
	return (volatile.LoadUint32(&o.FUNC103_IN_SEL_CFG.Reg) & 0x40) >> 6
}

// GPIO.FUNC104_IN_SEL_CFG: GPIO input function configuration register
func (o *GPIO_Type) SetFUNC104_IN_SEL_CFG_FUNC_IN_SEL(value uint32) {
	volatile.StoreUint32(&o.FUNC104_IN_SEL_CFG.Reg, volatile.LoadUint32(&o.FUNC104_IN_SEL_CFG.Reg)&^(0x1f)|value)
}
func (o *GPIO_Type) GetFUNC104_IN_SEL_CFG_FUNC_IN_SEL() uint32 {
	return volatile.LoadUint32(&o.FUNC104_IN_SEL_CFG.Reg) & 0x1f
}
func (o *GPIO_Type) SetFUNC104_IN_SEL_CFG_FUNC_IN_INV_SEL(value uint32) {
	volatile.StoreUint32(&o.FUNC104_IN_SEL_CFG.Reg, volatile.LoadUint32(&o.FUNC104_IN_SEL_CFG.Reg)&^(0x20)|value<<5)
}
func (o *GPIO_Type) GetFUNC104_IN_SEL_CFG_FUNC_IN_INV_SEL() uint32 {
	return (volatile.LoadUint32(&o.FUNC104_IN_SEL_CFG.Reg) & 0x20) >> 5
}
func (o *GPIO_Type) SetFUNC104_IN_SEL_CFG_SIG_IN_SEL(value uint32) {
	volatile.StoreUint32(&o.FUNC104_IN_SEL_CFG.Reg, volatile.LoadUint32(&o.FUNC104_IN_SEL_CFG.Reg)&^(0x40)|value<<6)
}
func (o *GPIO_Type) GetFUNC104_IN_SEL_CFG_SIG_IN_SEL() uint32 {
	return (volatile.LoadUint32(&o.FUNC104_IN_SEL_CFG.Reg) & 0x40) >> 6
}

// GPIO.FUNC105_IN_SEL_CFG: GPIO input function configuration register
func (o *GPIO_Type) SetFUNC105_IN_SEL_CFG_FUNC_IN_SEL(value uint32) {
	volatile.StoreUint32(&o.FUNC105_IN_SEL_CFG.Reg, volatile.LoadUint32(&o.FUNC105_IN_SEL_CFG.Reg)&^(0x1f)|value)
}
func (o *GPIO_Type) GetFUNC105_IN_SEL_CFG_FUNC_IN_SEL() uint32 {
	return volatile.LoadUint32(&o.FUNC105_IN_SEL_CFG.Reg) & 0x1f
}
func (o *GPIO_Type) SetFUNC105_IN_SEL_CFG_FUNC_IN_INV_SEL(value uint32) {
	volatile.StoreUint32(&o.FUNC105_IN_SEL_CFG.Reg, volatile.LoadUint32(&o.FUNC105_IN_SEL_CFG.Reg)&^(0x20)|value<<5)
}
func (o *GPIO_Type) GetFUNC105_IN_SEL_CFG_FUNC_IN_INV_SEL() uint32 {
	return (volatile.LoadUint32(&o.FUNC105_IN_SEL_CFG.Reg) & 0x20) >> 5
}
func (o *GPIO_Type) SetFUNC105_IN_SEL_CFG_SIG_IN_SEL(value uint32) {
	volatile.StoreUint32(&o.FUNC105_IN_SEL_CFG.Reg, volatile.LoadUint32(&o.FUNC105_IN_SEL_CFG.Reg)&^(0x40)|value<<6)
}
func (o *GPIO_Type) GetFUNC105_IN_SEL_CFG_SIG_IN_SEL() uint32 {
	return (volatile.LoadUint32(&o.FUNC105_IN_SEL_CFG.Reg) & 0x40) >> 6
}

// GPIO.FUNC106_IN_SEL_CFG: GPIO input function configuration register
func (o *GPIO_Type) SetFUNC106_IN_SEL_CFG_FUNC_IN_SEL(value uint32) {
	volatile.StoreUint32(&o.FUNC106_IN_SEL_CFG.Reg, volatile.LoadUint32(&o.FUNC106_IN_SEL_CFG.Reg)&^(0x1f)|value)
}
func (o *GPIO_Type) GetFUNC106_IN_SEL_CFG_FUNC_IN_SEL() uint32 {
	return volatile.LoadUint32(&o.FUNC106_IN_SEL_CFG.Reg) & 0x1f
}
func (o *GPIO_Type) SetFUNC106_IN_SEL_CFG_FUNC_IN_INV_SEL(value uint32) {
	volatile.StoreUint32(&o.FUNC106_IN_SEL_CFG.Reg, volatile.LoadUint32(&o.FUNC106_IN_SEL_CFG.Reg)&^(0x20)|value<<5)
}
func (o *GPIO_Type) GetFUNC106_IN_SEL_CFG_FUNC_IN_INV_SEL() uint32 {
	return (volatile.LoadUint32(&o.FUNC106_IN_SEL_CFG.Reg) & 0x20) >> 5
}
func (o *GPIO_Type) SetFUNC106_IN_SEL_CFG_SIG_IN_SEL(value uint32) {
	volatile.StoreUint32(&o.FUNC106_IN_SEL_CFG.Reg, volatile.LoadUint32(&o.FUNC106_IN_SEL_CFG.Reg)&^(0x40)|value<<6)
}
func (o *GPIO_Type) GetFUNC106_IN_SEL_CFG_SIG_IN_SEL() uint32 {
	return (volatile.LoadUint32(&o.FUNC106_IN_SEL_CFG.Reg) & 0x40) >> 6
}

// GPIO.FUNC107_IN_SEL_CFG: GPIO input function configuration register
func (o *GPIO_Type) SetFUNC107_IN_SEL_CFG_FUNC_IN_SEL(value uint32) {
	volatile.StoreUint32(&o.FUNC107_IN_SEL_CFG.Reg, volatile.LoadUint32(&o.FUNC107_IN_SEL_CFG.Reg)&^(0x1f)|value)
}
func (o *GPIO_Type) GetFUNC107_IN_SEL_CFG_FUNC_IN_SEL() uint32 {
	return volatile.LoadUint32(&o.FUNC107_IN_SEL_CFG.Reg) & 0x1f
}
func (o *GPIO_Type) SetFUNC107_IN_SEL_CFG_FUNC_IN_INV_SEL(value uint32) {
	volatile.StoreUint32(&o.FUNC107_IN_SEL_CFG.Reg, volatile.LoadUint32(&o.FUNC107_IN_SEL_CFG.Reg)&^(0x20)|value<<5)
}
func (o *GPIO_Type) GetFUNC107_IN_SEL_CFG_FUNC_IN_INV_SEL() uint32 {
	return (volatile.LoadUint32(&o.FUNC107_IN_SEL_CFG.Reg) & 0x20) >> 5
}
func (o *GPIO_Type) SetFUNC107_IN_SEL_CFG_SIG_IN_SEL(value uint32) {
	volatile.StoreUint32(&o.FUNC107_IN_SEL_CFG.Reg, volatile.LoadUint32(&o.FUNC107_IN_SEL_CFG.Reg)&^(0x40)|value<<6)
}
func (o *GPIO_Type) GetFUNC107_IN_SEL_CFG_SIG_IN_SEL() uint32 {
	return (volatile.LoadUint32(&o.FUNC107_IN_SEL_CFG.Reg) & 0x40) >> 6
}

// GPIO.FUNC108_IN_SEL_CFG: GPIO input function configuration register
func (o *GPIO_Type) SetFUNC108_IN_SEL_CFG_FUNC_IN_SEL(value uint32) {
	volatile.StoreUint32(&o.FUNC108_IN_SEL_CFG.Reg, volatile.LoadUint32(&o.FUNC108_IN_SEL_CFG.Reg)&^(0x1f)|value)
}
func (o *GPIO_Type) GetFUNC108_IN_SEL_CFG_FUNC_IN_SEL() uint32 {
	return volatile.LoadUint32(&o.FUNC108_IN_SEL_CFG.Reg) & 0x1f
}
func (o *GPIO_Type) SetFUNC108_IN_SEL_CFG_FUNC_IN_INV_SEL(value uint32) {
	volatile.StoreUint32(&o.FUNC108_IN_SEL_CFG.Reg, volatile.LoadUint32(&o.FUNC108_IN_SEL_CFG.Reg)&^(0x20)|value<<5)
}
func (o *GPIO_Type) GetFUNC108_IN_SEL_CFG_FUNC_IN_INV_SEL() uint32 {
	return (volatile.LoadUint32(&o.FUNC108_IN_SEL_CFG.Reg) & 0x20) >> 5
}
func (o *GPIO_Type) SetFUNC108_IN_SEL_CFG_SIG_IN_SEL(value uint32) {
	volatile.StoreUint32(&o.FUNC108_IN_SEL_CFG.Reg, volatile.LoadUint32(&o.FUNC108_IN_SEL_CFG.Reg)&^(0x40)|value<<6)
}
func (o *GPIO_Type) GetFUNC108_IN_SEL_CFG_SIG_IN_SEL() uint32 {
	return (volatile.LoadUint32(&o.FUNC108_IN_SEL_CFG.Reg) & 0x40) >> 6
}

// GPIO.FUNC109_IN_SEL_CFG: GPIO input function configuration register
func (o *GPIO_Type) SetFUNC109_IN_SEL_CFG_FUNC_IN_SEL(value uint32) {
	volatile.StoreUint32(&o.FUNC109_IN_SEL_CFG.Reg, volatile.LoadUint32(&o.FUNC109_IN_SEL_CFG.Reg)&^(0x1f)|value)
}
func (o *GPIO_Type) GetFUNC109_IN_SEL_CFG_FUNC_IN_SEL() uint32 {
	return volatile.LoadUint32(&o.FUNC109_IN_SEL_CFG.Reg) & 0x1f
}
func (o *GPIO_Type) SetFUNC109_IN_SEL_CFG_FUNC_IN_INV_SEL(value uint32) {
	volatile.StoreUint32(&o.FUNC109_IN_SEL_CFG.Reg, volatile.LoadUint32(&o.FUNC109_IN_SEL_CFG.Reg)&^(0x20)|value<<5)
}
func (o *GPIO_Type) GetFUNC109_IN_SEL_CFG_FUNC_IN_INV_SEL() uint32 {
	return (volatile.LoadUint32(&o.FUNC109_IN_SEL_CFG.Reg) & 0x20) >> 5
}
func (o *GPIO_Type) SetFUNC109_IN_SEL_CFG_SIG_IN_SEL(value uint32) {
	volatile.StoreUint32(&o.FUNC109_IN_SEL_CFG.Reg, volatile.LoadUint32(&o.FUNC109_IN_SEL_CFG.Reg)&^(0x40)|value<<6)
}
func (o *GPIO_Type) GetFUNC109_IN_SEL_CFG_SIG_IN_SEL() uint32 {
	return (volatile.LoadUint32(&o.FUNC109_IN_SEL_CFG.Reg) & 0x40) >> 6
}

// GPIO.FUNC110_IN_SEL_CFG: GPIO input function configuration register
func (o *GPIO_Type) SetFUNC110_IN_SEL_CFG_FUNC_IN_SEL(value uint32) {
	volatile.StoreUint32(&o.FUNC110_IN_SEL_CFG.Reg, volatile.LoadUint32(&o.FUNC110_IN_SEL_CFG.Reg)&^(0x1f)|value)
}
func (o *GPIO_Type) GetFUNC110_IN_SEL_CFG_FUNC_IN_SEL() uint32 {
	return volatile.LoadUint32(&o.FUNC110_IN_SEL_CFG.Reg) & 0x1f
}
func (o *GPIO_Type) SetFUNC110_IN_SEL_CFG_FUNC_IN_INV_SEL(value uint32) {
	volatile.StoreUint32(&o.FUNC110_IN_SEL_CFG.Reg, volatile.LoadUint32(&o.FUNC110_IN_SEL_CFG.Reg)&^(0x20)|value<<5)
}
func (o *GPIO_Type) GetFUNC110_IN_SEL_CFG_FUNC_IN_INV_SEL() uint32 {
	return (volatile.LoadUint32(&o.FUNC110_IN_SEL_CFG.Reg) & 0x20) >> 5
}
func (o *GPIO_Type) SetFUNC110_IN_SEL_CFG_SIG_IN_SEL(value uint32) {
	volatile.StoreUint32(&o.FUNC110_IN_SEL_CFG.Reg, volatile.LoadUint32(&o.FUNC110_IN_SEL_CFG.Reg)&^(0x40)|value<<6)
}
func (o *GPIO_Type) GetFUNC110_IN_SEL_CFG_SIG_IN_SEL() uint32 {
	return (volatile.LoadUint32(&o.FUNC110_IN_SEL_CFG.Reg) & 0x40) >> 6
}

// GPIO.FUNC111_IN_SEL_CFG: GPIO input function configuration register
func (o *GPIO_Type) SetFUNC111_IN_SEL_CFG_FUNC_IN_SEL(value uint32) {
	volatile.StoreUint32(&o.FUNC111_IN_SEL_CFG.Reg, volatile.LoadUint32(&o.FUNC111_IN_SEL_CFG.Reg)&^(0x1f)|value)
}
func (o *GPIO_Type) GetFUNC111_IN_SEL_CFG_FUNC_IN_SEL() uint32 {
	return volatile.LoadUint32(&o.FUNC111_IN_SEL_CFG.Reg) & 0x1f
}
func (o *GPIO_Type) SetFUNC111_IN_SEL_CFG_FUNC_IN_INV_SEL(value uint32) {
	volatile.StoreUint32(&o.FUNC111_IN_SEL_CFG.Reg, volatile.LoadUint32(&o.FUNC111_IN_SEL_CFG.Reg)&^(0x20)|value<<5)
}
func (o *GPIO_Type) GetFUNC111_IN_SEL_CFG_FUNC_IN_INV_SEL() uint32 {
	return (volatile.LoadUint32(&o.FUNC111_IN_SEL_CFG.Reg) & 0x20) >> 5
}
func (o *GPIO_Type) SetFUNC111_IN_SEL_CFG_SIG_IN_SEL(value uint32) {
	volatile.StoreUint32(&o.FUNC111_IN_SEL_CFG.Reg, volatile.LoadUint32(&o.FUNC111_IN_SEL_CFG.Reg)&^(0x40)|value<<6)
}
func (o *GPIO_Type) GetFUNC111_IN_SEL_CFG_SIG_IN_SEL() uint32 {
	return (volatile.LoadUint32(&o.FUNC111_IN_SEL_CFG.Reg) & 0x40) >> 6
}

// GPIO.FUNC112_IN_SEL_CFG: GPIO input function configuration register
func (o *GPIO_Type) SetFUNC112_IN_SEL_CFG_FUNC_IN_SEL(value uint32) {
	volatile.StoreUint32(&o.FUNC112_IN_SEL_CFG.Reg, volatile.LoadUint32(&o.FUNC112_IN_SEL_CFG.Reg)&^(0x1f)|value)
}
func (o *GPIO_Type) GetFUNC112_IN_SEL_CFG_FUNC_IN_SEL() uint32 {
	return volatile.LoadUint32(&o.FUNC112_IN_SEL_CFG.Reg) & 0x1f
}
func (o *GPIO_Type) SetFUNC112_IN_SEL_CFG_FUNC_IN_INV_SEL(value uint32) {
	volatile.StoreUint32(&o.FUNC112_IN_SEL_CFG.Reg, volatile.LoadUint32(&o.FUNC112_IN_SEL_CFG.Reg)&^(0x20)|value<<5)
}
func (o *GPIO_Type) GetFUNC112_IN_SEL_CFG_FUNC_IN_INV_SEL() uint32 {
	return (volatile.LoadUint32(&o.FUNC112_IN_SEL_CFG.Reg) & 0x20) >> 5
}
func (o *GPIO_Type) SetFUNC112_IN_SEL_CFG_SIG_IN_SEL(value uint32) {
	volatile.StoreUint32(&o.FUNC112_IN_SEL_CFG.Reg, volatile.LoadUint32(&o.FUNC112_IN_SEL_CFG.Reg)&^(0x40)|value<<6)
}
func (o *GPIO_Type) GetFUNC112_IN_SEL_CFG_SIG_IN_SEL() uint32 {
	return (volatile.LoadUint32(&o.FUNC112_IN_SEL_CFG.Reg) & 0x40) >> 6
}

// GPIO.FUNC113_IN_SEL_CFG: GPIO input function configuration register
func (o *GPIO_Type) SetFUNC113_IN_SEL_CFG_FUNC_IN_SEL(value uint32) {
	volatile.StoreUint32(&o.FUNC113_IN_SEL_CFG.Reg, volatile.LoadUint32(&o.FUNC113_IN_SEL_CFG.Reg)&^(0x1f)|value)
}
func (o *GPIO_Type) GetFUNC113_IN_SEL_CFG_FUNC_IN_SEL() uint32 {
	return volatile.LoadUint32(&o.FUNC113_IN_SEL_CFG.Reg) & 0x1f
}
func (o *GPIO_Type) SetFUNC113_IN_SEL_CFG_FUNC_IN_INV_SEL(value uint32) {
	volatile.StoreUint32(&o.FUNC113_IN_SEL_CFG.Reg, volatile.LoadUint32(&o.FUNC113_IN_SEL_CFG.Reg)&^(0x20)|value<<5)
}
func (o *GPIO_Type) GetFUNC113_IN_SEL_CFG_FUNC_IN_INV_SEL() uint32 {
	return (volatile.LoadUint32(&o.FUNC113_IN_SEL_CFG.Reg) & 0x20) >> 5
}
func (o *GPIO_Type) SetFUNC113_IN_SEL_CFG_SIG_IN_SEL(value uint32) {
	volatile.StoreUint32(&o.FUNC113_IN_SEL_CFG.Reg, volatile.LoadUint32(&o.FUNC113_IN_SEL_CFG.Reg)&^(0x40)|value<<6)
}
func (o *GPIO_Type) GetFUNC113_IN_SEL_CFG_SIG_IN_SEL() uint32 {
	return (volatile.LoadUint32(&o.FUNC113_IN_SEL_CFG.Reg) & 0x40) >> 6
}

// GPIO.FUNC114_IN_SEL_CFG: GPIO input function configuration register
func (o *GPIO_Type) SetFUNC114_IN_SEL_CFG_FUNC_IN_SEL(value uint32) {
	volatile.StoreUint32(&o.FUNC114_IN_SEL_CFG.Reg, volatile.LoadUint32(&o.FUNC114_IN_SEL_CFG.Reg)&^(0x1f)|value)
}
func (o *GPIO_Type) GetFUNC114_IN_SEL_CFG_FUNC_IN_SEL() uint32 {
	return volatile.LoadUint32(&o.FUNC114_IN_SEL_CFG.Reg) & 0x1f
}
func (o *GPIO_Type) SetFUNC114_IN_SEL_CFG_FUNC_IN_INV_SEL(value uint32) {
	volatile.StoreUint32(&o.FUNC114_IN_SEL_CFG.Reg, volatile.LoadUint32(&o.FUNC114_IN_SEL_CFG.Reg)&^(0x20)|value<<5)
}
func (o *GPIO_Type) GetFUNC114_IN_SEL_CFG_FUNC_IN_INV_SEL() uint32 {
	return (volatile.LoadUint32(&o.FUNC114_IN_SEL_CFG.Reg) & 0x20) >> 5
}
func (o *GPIO_Type) SetFUNC114_IN_SEL_CFG_SIG_IN_SEL(value uint32) {
	volatile.StoreUint32(&o.FUNC114_IN_SEL_CFG.Reg, volatile.LoadUint32(&o.FUNC114_IN_SEL_CFG.Reg)&^(0x40)|value<<6)
}
func (o *GPIO_Type) GetFUNC114_IN_SEL_CFG_SIG_IN_SEL() uint32 {
	return (volatile.LoadUint32(&o.FUNC114_IN_SEL_CFG.Reg) & 0x40) >> 6
}

// GPIO.FUNC115_IN_SEL_CFG: GPIO input function configuration register
func (o *GPIO_Type) SetFUNC115_IN_SEL_CFG_FUNC_IN_SEL(value uint32) {
	volatile.StoreUint32(&o.FUNC115_IN_SEL_CFG.Reg, volatile.LoadUint32(&o.FUNC115_IN_SEL_CFG.Reg)&^(0x1f)|value)
}
func (o *GPIO_Type) GetFUNC115_IN_SEL_CFG_FUNC_IN_SEL() uint32 {
	return volatile.LoadUint32(&o.FUNC115_IN_SEL_CFG.Reg) & 0x1f
}
func (o *GPIO_Type) SetFUNC115_IN_SEL_CFG_FUNC_IN_INV_SEL(value uint32) {
	volatile.StoreUint32(&o.FUNC115_IN_SEL_CFG.Reg, volatile.LoadUint32(&o.FUNC115_IN_SEL_CFG.Reg)&^(0x20)|value<<5)
}
func (o *GPIO_Type) GetFUNC115_IN_SEL_CFG_FUNC_IN_INV_SEL() uint32 {
	return (volatile.LoadUint32(&o.FUNC115_IN_SEL_CFG.Reg) & 0x20) >> 5
}
func (o *GPIO_Type) SetFUNC115_IN_SEL_CFG_SIG_IN_SEL(value uint32) {
	volatile.StoreUint32(&o.FUNC115_IN_SEL_CFG.Reg, volatile.LoadUint32(&o.FUNC115_IN_SEL_CFG.Reg)&^(0x40)|value<<6)
}
func (o *GPIO_Type) GetFUNC115_IN_SEL_CFG_SIG_IN_SEL() uint32 {
	return (volatile.LoadUint32(&o.FUNC115_IN_SEL_CFG.Reg) & 0x40) >> 6
}

// GPIO.FUNC116_IN_SEL_CFG: GPIO input function configuration register
func (o *GPIO_Type) SetFUNC116_IN_SEL_CFG_FUNC_IN_SEL(value uint32) {
	volatile.StoreUint32(&o.FUNC116_IN_SEL_CFG.Reg, volatile.LoadUint32(&o.FUNC116_IN_SEL_CFG.Reg)&^(0x1f)|value)
}
func (o *GPIO_Type) GetFUNC116_IN_SEL_CFG_FUNC_IN_SEL() uint32 {
	return volatile.LoadUint32(&o.FUNC116_IN_SEL_CFG.Reg) & 0x1f
}
func (o *GPIO_Type) SetFUNC116_IN_SEL_CFG_FUNC_IN_INV_SEL(value uint32) {
	volatile.StoreUint32(&o.FUNC116_IN_SEL_CFG.Reg, volatile.LoadUint32(&o.FUNC116_IN_SEL_CFG.Reg)&^(0x20)|value<<5)
}
func (o *GPIO_Type) GetFUNC116_IN_SEL_CFG_FUNC_IN_INV_SEL() uint32 {
	return (volatile.LoadUint32(&o.FUNC116_IN_SEL_CFG.Reg) & 0x20) >> 5
}
func (o *GPIO_Type) SetFUNC116_IN_SEL_CFG_SIG_IN_SEL(value uint32) {
	volatile.StoreUint32(&o.FUNC116_IN_SEL_CFG.Reg, volatile.LoadUint32(&o.FUNC116_IN_SEL_CFG.Reg)&^(0x40)|value<<6)
}
func (o *GPIO_Type) GetFUNC116_IN_SEL_CFG_SIG_IN_SEL() uint32 {
	return (volatile.LoadUint32(&o.FUNC116_IN_SEL_CFG.Reg) & 0x40) >> 6
}

// GPIO.FUNC117_IN_SEL_CFG: GPIO input function configuration register
func (o *GPIO_Type) SetFUNC117_IN_SEL_CFG_FUNC_IN_SEL(value uint32) {
	volatile.StoreUint32(&o.FUNC117_IN_SEL_CFG.Reg, volatile.LoadUint32(&o.FUNC117_IN_SEL_CFG.Reg)&^(0x1f)|value)
}
func (o *GPIO_Type) GetFUNC117_IN_SEL_CFG_FUNC_IN_SEL() uint32 {
	return volatile.LoadUint32(&o.FUNC117_IN_SEL_CFG.Reg) & 0x1f
}
func (o *GPIO_Type) SetFUNC117_IN_SEL_CFG_FUNC_IN_INV_SEL(value uint32) {
	volatile.StoreUint32(&o.FUNC117_IN_SEL_CFG.Reg, volatile.LoadUint32(&o.FUNC117_IN_SEL_CFG.Reg)&^(0x20)|value<<5)
}
func (o *GPIO_Type) GetFUNC117_IN_SEL_CFG_FUNC_IN_INV_SEL() uint32 {
	return (volatile.LoadUint32(&o.FUNC117_IN_SEL_CFG.Reg) & 0x20) >> 5
}
func (o *GPIO_Type) SetFUNC117_IN_SEL_CFG_SIG_IN_SEL(value uint32) {
	volatile.StoreUint32(&o.FUNC117_IN_SEL_CFG.Reg, volatile.LoadUint32(&o.FUNC117_IN_SEL_CFG.Reg)&^(0x40)|value<<6)
}
func (o *GPIO_Type) GetFUNC117_IN_SEL_CFG_SIG_IN_SEL() uint32 {
	return (volatile.LoadUint32(&o.FUNC117_IN_SEL_CFG.Reg) & 0x40) >> 6
}

// GPIO.FUNC118_IN_SEL_CFG: GPIO input function configuration register
func (o *GPIO_Type) SetFUNC118_IN_SEL_CFG_FUNC_IN_SEL(value uint32) {
	volatile.StoreUint32(&o.FUNC118_IN_SEL_CFG.Reg, volatile.LoadUint32(&o.FUNC118_IN_SEL_CFG.Reg)&^(0x1f)|value)
}
func (o *GPIO_Type) GetFUNC118_IN_SEL_CFG_FUNC_IN_SEL() uint32 {
	return volatile.LoadUint32(&o.FUNC118_IN_SEL_CFG.Reg) & 0x1f
}
func (o *GPIO_Type) SetFUNC118_IN_SEL_CFG_FUNC_IN_INV_SEL(value uint32) {
	volatile.StoreUint32(&o.FUNC118_IN_SEL_CFG.Reg, volatile.LoadUint32(&o.FUNC118_IN_SEL_CFG.Reg)&^(0x20)|value<<5)
}
func (o *GPIO_Type) GetFUNC118_IN_SEL_CFG_FUNC_IN_INV_SEL() uint32 {
	return (volatile.LoadUint32(&o.FUNC118_IN_SEL_CFG.Reg) & 0x20) >> 5
}
func (o *GPIO_Type) SetFUNC118_IN_SEL_CFG_SIG_IN_SEL(value uint32) {
	volatile.StoreUint32(&o.FUNC118_IN_SEL_CFG.Reg, volatile.LoadUint32(&o.FUNC118_IN_SEL_CFG.Reg)&^(0x40)|value<<6)
}
func (o *GPIO_Type) GetFUNC118_IN_SEL_CFG_SIG_IN_SEL() uint32 {
	return (volatile.LoadUint32(&o.FUNC118_IN_SEL_CFG.Reg) & 0x40) >> 6
}

// GPIO.FUNC119_IN_SEL_CFG: GPIO input function configuration register
func (o *GPIO_Type) SetFUNC119_IN_SEL_CFG_FUNC_IN_SEL(value uint32) {
	volatile.StoreUint32(&o.FUNC119_IN_SEL_CFG.Reg, volatile.LoadUint32(&o.FUNC119_IN_SEL_CFG.Reg)&^(0x1f)|value)
}
func (o *GPIO_Type) GetFUNC119_IN_SEL_CFG_FUNC_IN_SEL() uint32 {
	return volatile.LoadUint32(&o.FUNC119_IN_SEL_CFG.Reg) & 0x1f
}
func (o *GPIO_Type) SetFUNC119_IN_SEL_CFG_FUNC_IN_INV_SEL(value uint32) {
	volatile.StoreUint32(&o.FUNC119_IN_SEL_CFG.Reg, volatile.LoadUint32(&o.FUNC119_IN_SEL_CFG.Reg)&^(0x20)|value<<5)
}
func (o *GPIO_Type) GetFUNC119_IN_SEL_CFG_FUNC_IN_INV_SEL() uint32 {
	return (volatile.LoadUint32(&o.FUNC119_IN_SEL_CFG.Reg) & 0x20) >> 5
}
func (o *GPIO_Type) SetFUNC119_IN_SEL_CFG_SIG_IN_SEL(value uint32) {
	volatile.StoreUint32(&o.FUNC119_IN_SEL_CFG.Reg, volatile.LoadUint32(&o.FUNC119_IN_SEL_CFG.Reg)&^(0x40)|value<<6)
}
func (o *GPIO_Type) GetFUNC119_IN_SEL_CFG_SIG_IN_SEL() uint32 {
	return (volatile.LoadUint32(&o.FUNC119_IN_SEL_CFG.Reg) & 0x40) >> 6
}

// GPIO.FUNC120_IN_SEL_CFG: GPIO input function configuration register
func (o *GPIO_Type) SetFUNC120_IN_SEL_CFG_FUNC_IN_SEL(value uint32) {
	volatile.StoreUint32(&o.FUNC120_IN_SEL_CFG.Reg, volatile.LoadUint32(&o.FUNC120_IN_SEL_CFG.Reg)&^(0x1f)|value)
}
func (o *GPIO_Type) GetFUNC120_IN_SEL_CFG_FUNC_IN_SEL() uint32 {
	return volatile.LoadUint32(&o.FUNC120_IN_SEL_CFG.Reg) & 0x1f
}
func (o *GPIO_Type) SetFUNC120_IN_SEL_CFG_FUNC_IN_INV_SEL(value uint32) {
	volatile.StoreUint32(&o.FUNC120_IN_SEL_CFG.Reg, volatile.LoadUint32(&o.FUNC120_IN_SEL_CFG.Reg)&^(0x20)|value<<5)
}
func (o *GPIO_Type) GetFUNC120_IN_SEL_CFG_FUNC_IN_INV_SEL() uint32 {
	return (volatile.LoadUint32(&o.FUNC120_IN_SEL_CFG.Reg) & 0x20) >> 5
}
func (o *GPIO_Type) SetFUNC120_IN_SEL_CFG_SIG_IN_SEL(value uint32) {
	volatile.StoreUint32(&o.FUNC120_IN_SEL_CFG.Reg, volatile.LoadUint32(&o.FUNC120_IN_SEL_CFG.Reg)&^(0x40)|value<<6)
}
func (o *GPIO_Type) GetFUNC120_IN_SEL_CFG_SIG_IN_SEL() uint32 {
	return (volatile.LoadUint32(&o.FUNC120_IN_SEL_CFG.Reg) & 0x40) >> 6
}

// GPIO.FUNC121_IN_SEL_CFG: GPIO input function configuration register
func (o *GPIO_Type) SetFUNC121_IN_SEL_CFG_FUNC_IN_SEL(value uint32) {
	volatile.StoreUint32(&o.FUNC121_IN_SEL_CFG.Reg, volatile.LoadUint32(&o.FUNC121_IN_SEL_CFG.Reg)&^(0x1f)|value)
}
func (o *GPIO_Type) GetFUNC121_IN_SEL_CFG_FUNC_IN_SEL() uint32 {
	return volatile.LoadUint32(&o.FUNC121_IN_SEL_CFG.Reg) & 0x1f
}
func (o *GPIO_Type) SetFUNC121_IN_SEL_CFG_FUNC_IN_INV_SEL(value uint32) {
	volatile.StoreUint32(&o.FUNC121_IN_SEL_CFG.Reg, volatile.LoadUint32(&o.FUNC121_IN_SEL_CFG.Reg)&^(0x20)|value<<5)
}
func (o *GPIO_Type) GetFUNC121_IN_SEL_CFG_FUNC_IN_INV_SEL() uint32 {
	return (volatile.LoadUint32(&o.FUNC121_IN_SEL_CFG.Reg) & 0x20) >> 5
}
func (o *GPIO_Type) SetFUNC121_IN_SEL_CFG_SIG_IN_SEL(value uint32) {
	volatile.StoreUint32(&o.FUNC121_IN_SEL_CFG.Reg, volatile.LoadUint32(&o.FUNC121_IN_SEL_CFG.Reg)&^(0x40)|value<<6)
}
func (o *GPIO_Type) GetFUNC121_IN_SEL_CFG_SIG_IN_SEL() uint32 {
	return (volatile.LoadUint32(&o.FUNC121_IN_SEL_CFG.Reg) & 0x40) >> 6
}

// GPIO.FUNC122_IN_SEL_CFG: GPIO input function configuration register
func (o *GPIO_Type) SetFUNC122_IN_SEL_CFG_FUNC_IN_SEL(value uint32) {
	volatile.StoreUint32(&o.FUNC122_IN_SEL_CFG.Reg, volatile.LoadUint32(&o.FUNC122_IN_SEL_CFG.Reg)&^(0x1f)|value)
}
func (o *GPIO_Type) GetFUNC122_IN_SEL_CFG_FUNC_IN_SEL() uint32 {
	return volatile.LoadUint32(&o.FUNC122_IN_SEL_CFG.Reg) & 0x1f
}
func (o *GPIO_Type) SetFUNC122_IN_SEL_CFG_FUNC_IN_INV_SEL(value uint32) {
	volatile.StoreUint32(&o.FUNC122_IN_SEL_CFG.Reg, volatile.LoadUint32(&o.FUNC122_IN_SEL_CFG.Reg)&^(0x20)|value<<5)
}
func (o *GPIO_Type) GetFUNC122_IN_SEL_CFG_FUNC_IN_INV_SEL() uint32 {
	return (volatile.LoadUint32(&o.FUNC122_IN_SEL_CFG.Reg) & 0x20) >> 5
}
func (o *GPIO_Type) SetFUNC122_IN_SEL_CFG_SIG_IN_SEL(value uint32) {
	volatile.StoreUint32(&o.FUNC122_IN_SEL_CFG.Reg, volatile.LoadUint32(&o.FUNC122_IN_SEL_CFG.Reg)&^(0x40)|value<<6)
}
func (o *GPIO_Type) GetFUNC122_IN_SEL_CFG_SIG_IN_SEL() uint32 {
	return (volatile.LoadUint32(&o.FUNC122_IN_SEL_CFG.Reg) & 0x40) >> 6
}

// GPIO.FUNC123_IN_SEL_CFG: GPIO input function configuration register
func (o *GPIO_Type) SetFUNC123_IN_SEL_CFG_FUNC_IN_SEL(value uint32) {
	volatile.StoreUint32(&o.FUNC123_IN_SEL_CFG.Reg, volatile.LoadUint32(&o.FUNC123_IN_SEL_CFG.Reg)&^(0x1f)|value)
}
func (o *GPIO_Type) GetFUNC123_IN_SEL_CFG_FUNC_IN_SEL() uint32 {
	return volatile.LoadUint32(&o.FUNC123_IN_SEL_CFG.Reg) & 0x1f
}
func (o *GPIO_Type) SetFUNC123_IN_SEL_CFG_FUNC_IN_INV_SEL(value uint32) {
	volatile.StoreUint32(&o.FUNC123_IN_SEL_CFG.Reg, volatile.LoadUint32(&o.FUNC123_IN_SEL_CFG.Reg)&^(0x20)|value<<5)
}
func (o *GPIO_Type) GetFUNC123_IN_SEL_CFG_FUNC_IN_INV_SEL() uint32 {
	return (volatile.LoadUint32(&o.FUNC123_IN_SEL_CFG.Reg) & 0x20) >> 5
}
func (o *GPIO_Type) SetFUNC123_IN_SEL_CFG_SIG_IN_SEL(value uint32) {
	volatile.StoreUint32(&o.FUNC123_IN_SEL_CFG.Reg, volatile.LoadUint32(&o.FUNC123_IN_SEL_CFG.Reg)&^(0x40)|value<<6)
}
func (o *GPIO_Type) GetFUNC123_IN_SEL_CFG_SIG_IN_SEL() uint32 {
	return (volatile.LoadUint32(&o.FUNC123_IN_SEL_CFG.Reg) & 0x40) >> 6
}

// GPIO.FUNC124_IN_SEL_CFG: GPIO input function configuration register
func (o *GPIO_Type) SetFUNC124_IN_SEL_CFG_FUNC_IN_SEL(value uint32) {
	volatile.StoreUint32(&o.FUNC124_IN_SEL_CFG.Reg, volatile.LoadUint32(&o.FUNC124_IN_SEL_CFG.Reg)&^(0x1f)|value)
}
func (o *GPIO_Type) GetFUNC124_IN_SEL_CFG_FUNC_IN_SEL() uint32 {
	return volatile.LoadUint32(&o.FUNC124_IN_SEL_CFG.Reg) & 0x1f
}
func (o *GPIO_Type) SetFUNC124_IN_SEL_CFG_FUNC_IN_INV_SEL(value uint32) {
	volatile.StoreUint32(&o.FUNC124_IN_SEL_CFG.Reg, volatile.LoadUint32(&o.FUNC124_IN_SEL_CFG.Reg)&^(0x20)|value<<5)
}
func (o *GPIO_Type) GetFUNC124_IN_SEL_CFG_FUNC_IN_INV_SEL() uint32 {
	return (volatile.LoadUint32(&o.FUNC124_IN_SEL_CFG.Reg) & 0x20) >> 5
}
func (o *GPIO_Type) SetFUNC124_IN_SEL_CFG_SIG_IN_SEL(value uint32) {
	volatile.StoreUint32(&o.FUNC124_IN_SEL_CFG.Reg, volatile.LoadUint32(&o.FUNC124_IN_SEL_CFG.Reg)&^(0x40)|value<<6)
}
func (o *GPIO_Type) GetFUNC124_IN_SEL_CFG_SIG_IN_SEL() uint32 {
	return (volatile.LoadUint32(&o.FUNC124_IN_SEL_CFG.Reg) & 0x40) >> 6
}

// GPIO.FUNC125_IN_SEL_CFG: GPIO input function configuration register
func (o *GPIO_Type) SetFUNC125_IN_SEL_CFG_FUNC_IN_SEL(value uint32) {
	volatile.StoreUint32(&o.FUNC125_IN_SEL_CFG.Reg, volatile.LoadUint32(&o.FUNC125_IN_SEL_CFG.Reg)&^(0x1f)|value)
}
func (o *GPIO_Type) GetFUNC125_IN_SEL_CFG_FUNC_IN_SEL() uint32 {
	return volatile.LoadUint32(&o.FUNC125_IN_SEL_CFG.Reg) & 0x1f
}
func (o *GPIO_Type) SetFUNC125_IN_SEL_CFG_FUNC_IN_INV_SEL(value uint32) {
	volatile.StoreUint32(&o.FUNC125_IN_SEL_CFG.Reg, volatile.LoadUint32(&o.FUNC125_IN_SEL_CFG.Reg)&^(0x20)|value<<5)
}
func (o *GPIO_Type) GetFUNC125_IN_SEL_CFG_FUNC_IN_INV_SEL() uint32 {
	return (volatile.LoadUint32(&o.FUNC125_IN_SEL_CFG.Reg) & 0x20) >> 5
}
func (o *GPIO_Type) SetFUNC125_IN_SEL_CFG_SIG_IN_SEL(value uint32) {
	volatile.StoreUint32(&o.FUNC125_IN_SEL_CFG.Reg, volatile.LoadUint32(&o.FUNC125_IN_SEL_CFG.Reg)&^(0x40)|value<<6)
}
func (o *GPIO_Type) GetFUNC125_IN_SEL_CFG_SIG_IN_SEL() uint32 {
	return (volatile.LoadUint32(&o.FUNC125_IN_SEL_CFG.Reg) & 0x40) >> 6
}

// GPIO.FUNC126_IN_SEL_CFG: GPIO input function configuration register
func (o *GPIO_Type) SetFUNC126_IN_SEL_CFG_FUNC_IN_SEL(value uint32) {
	volatile.StoreUint32(&o.FUNC126_IN_SEL_CFG.Reg, volatile.LoadUint32(&o.FUNC126_IN_SEL_CFG.Reg)&^(0x1f)|value)
}
func (o *GPIO_Type) GetFUNC126_IN_SEL_CFG_FUNC_IN_SEL() uint32 {
	return volatile.LoadUint32(&o.FUNC126_IN_SEL_CFG.Reg) & 0x1f
}
func (o *GPIO_Type) SetFUNC126_IN_SEL_CFG_FUNC_IN_INV_SEL(value uint32) {
	volatile.StoreUint32(&o.FUNC126_IN_SEL_CFG.Reg, volatile.LoadUint32(&o.FUNC126_IN_SEL_CFG.Reg)&^(0x20)|value<<5)
}
func (o *GPIO_Type) GetFUNC126_IN_SEL_CFG_FUNC_IN_INV_SEL() uint32 {
	return (volatile.LoadUint32(&o.FUNC126_IN_SEL_CFG.Reg) & 0x20) >> 5
}
func (o *GPIO_Type) SetFUNC126_IN_SEL_CFG_SIG_IN_SEL(value uint32) {
	volatile.StoreUint32(&o.FUNC126_IN_SEL_CFG.Reg, volatile.LoadUint32(&o.FUNC126_IN_SEL_CFG.Reg)&^(0x40)|value<<6)
}
func (o *GPIO_Type) GetFUNC126_IN_SEL_CFG_SIG_IN_SEL() uint32 {
	return (volatile.LoadUint32(&o.FUNC126_IN_SEL_CFG.Reg) & 0x40) >> 6
}

// GPIO.FUNC127_IN_SEL_CFG: GPIO input function configuration register
func (o *GPIO_Type) SetFUNC127_IN_SEL_CFG_FUNC_IN_SEL(value uint32) {
	volatile.StoreUint32(&o.FUNC127_IN_SEL_CFG.Reg, volatile.LoadUint32(&o.FUNC127_IN_SEL_CFG.Reg)&^(0x1f)|value)
}
func (o *GPIO_Type) GetFUNC127_IN_SEL_CFG_FUNC_IN_SEL() uint32 {
	return volatile.LoadUint32(&o.FUNC127_IN_SEL_CFG.Reg) & 0x1f
}
func (o *GPIO_Type) SetFUNC127_IN_SEL_CFG_FUNC_IN_INV_SEL(value uint32) {
	volatile.StoreUint32(&o.FUNC127_IN_SEL_CFG.Reg, volatile.LoadUint32(&o.FUNC127_IN_SEL_CFG.Reg)&^(0x20)|value<<5)
}
func (o *GPIO_Type) GetFUNC127_IN_SEL_CFG_FUNC_IN_INV_SEL() uint32 {
	return (volatile.LoadUint32(&o.FUNC127_IN_SEL_CFG.Reg) & 0x20) >> 5
}
func (o *GPIO_Type) SetFUNC127_IN_SEL_CFG_SIG_IN_SEL(value uint32) {
	volatile.StoreUint32(&o.FUNC127_IN_SEL_CFG.Reg, volatile.LoadUint32(&o.FUNC127_IN_SEL_CFG.Reg)&^(0x40)|value<<6)
}
func (o *GPIO_Type) GetFUNC127_IN_SEL_CFG_SIG_IN_SEL() uint32 {
	return (volatile.LoadUint32(&o.FUNC127_IN_SEL_CFG.Reg) & 0x40) >> 6
}

// GPIO.FUNC0_OUT_SEL_CFG: GPIO output function select register
func (o *GPIO_Type) SetFUNC0_OUT_SEL_CFG_FUNC_OUT_SEL(value uint32) {
	volatile.StoreUint32(&o.FUNC0_OUT_SEL_CFG.Reg, volatile.LoadUint32(&o.FUNC0_OUT_SEL_CFG.Reg)&^(0xff)|value)
}
func (o *GPIO_Type) GetFUNC0_OUT_SEL_CFG_FUNC_OUT_SEL() uint32 {
	return volatile.LoadUint32(&o.FUNC0_OUT_SEL_CFG.Reg) & 0xff
}
func (o *GPIO_Type) SetFUNC0_OUT_SEL_CFG_FUNC_OUT_INV_SEL(value uint32) {
	volatile.StoreUint32(&o.FUNC0_OUT_SEL_CFG.Reg, volatile.LoadUint32(&o.FUNC0_OUT_SEL_CFG.Reg)&^(0x100)|value<<8)
}
func (o *GPIO_Type) GetFUNC0_OUT_SEL_CFG_FUNC_OUT_INV_SEL() uint32 {
	return (volatile.LoadUint32(&o.FUNC0_OUT_SEL_CFG.Reg) & 0x100) >> 8
}
func (o *GPIO_Type) SetFUNC0_OUT_SEL_CFG_FUNC_OEN_SEL(value uint32) {
	volatile.StoreUint32(&o.FUNC0_OUT_SEL_CFG.Reg, volatile.LoadUint32(&o.FUNC0_OUT_SEL_CFG.Reg)&^(0x200)|value<<9)
}
func (o *GPIO_Type) GetFUNC0_OUT_SEL_CFG_FUNC_OEN_SEL() uint32 {
	return (volatile.LoadUint32(&o.FUNC0_OUT_SEL_CFG.Reg) & 0x200) >> 9
}
func (o *GPIO_Type) SetFUNC0_OUT_SEL_CFG_FUNC_OEN_INV_SEL(value uint32) {
	volatile.StoreUint32(&o.FUNC0_OUT_SEL_CFG.Reg, volatile.LoadUint32(&o.FUNC0_OUT_SEL_CFG.Reg)&^(0x400)|value<<10)
}
func (o *GPIO_Type) GetFUNC0_OUT_SEL_CFG_FUNC_OEN_INV_SEL() uint32 {
	return (volatile.LoadUint32(&o.FUNC0_OUT_SEL_CFG.Reg) & 0x400) >> 10
}

// GPIO.FUNC1_OUT_SEL_CFG: GPIO output function select register
func (o *GPIO_Type) SetFUNC1_OUT_SEL_CFG_FUNC_OUT_SEL(value uint32) {
	volatile.StoreUint32(&o.FUNC1_OUT_SEL_CFG.Reg, volatile.LoadUint32(&o.FUNC1_OUT_SEL_CFG.Reg)&^(0xff)|value)
}
func (o *GPIO_Type) GetFUNC1_OUT_SEL_CFG_FUNC_OUT_SEL() uint32 {
	return volatile.LoadUint32(&o.FUNC1_OUT_SEL_CFG.Reg) & 0xff
}
func (o *GPIO_Type) SetFUNC1_OUT_SEL_CFG_FUNC_OUT_INV_SEL(value uint32) {
	volatile.StoreUint32(&o.FUNC1_OUT_SEL_CFG.Reg, volatile.LoadUint32(&o.FUNC1_OUT_SEL_CFG.Reg)&^(0x100)|value<<8)
}
func (o *GPIO_Type) GetFUNC1_OUT_SEL_CFG_FUNC_OUT_INV_SEL() uint32 {
	return (volatile.LoadUint32(&o.FUNC1_OUT_SEL_CFG.Reg) & 0x100) >> 8
}
func (o *GPIO_Type) SetFUNC1_OUT_SEL_CFG_FUNC_OEN_SEL(value uint32) {
	volatile.StoreUint32(&o.FUNC1_OUT_SEL_CFG.Reg, volatile.LoadUint32(&o.FUNC1_OUT_SEL_CFG.Reg)&^(0x200)|value<<9)
}
func (o *GPIO_Type) GetFUNC1_OUT_SEL_CFG_FUNC_OEN_SEL() uint32 {
	return (volatile.LoadUint32(&o.FUNC1_OUT_SEL_CFG.Reg) & 0x200) >> 9
}
func (o *GPIO_Type) SetFUNC1_OUT_SEL_CFG_FUNC_OEN_INV_SEL(value uint32) {
	volatile.StoreUint32(&o.FUNC1_OUT_SEL_CFG.Reg, volatile.LoadUint32(&o.FUNC1_OUT_SEL_CFG.Reg)&^(0x400)|value<<10)
}
func (o *GPIO_Type) GetFUNC1_OUT_SEL_CFG_FUNC_OEN_INV_SEL() uint32 {
	return (volatile.LoadUint32(&o.FUNC1_OUT_SEL_CFG.Reg) & 0x400) >> 10
}

// GPIO.FUNC2_OUT_SEL_CFG: GPIO output function select register
func (o *GPIO_Type) SetFUNC2_OUT_SEL_CFG_FUNC_OUT_SEL(value uint32) {
	volatile.StoreUint32(&o.FUNC2_OUT_SEL_CFG.Reg, volatile.LoadUint32(&o.FUNC2_OUT_SEL_CFG.Reg)&^(0xff)|value)
}
func (o *GPIO_Type) GetFUNC2_OUT_SEL_CFG_FUNC_OUT_SEL() uint32 {
	return volatile.LoadUint32(&o.FUNC2_OUT_SEL_CFG.Reg) & 0xff
}
func (o *GPIO_Type) SetFUNC2_OUT_SEL_CFG_FUNC_OUT_INV_SEL(value uint32) {
	volatile.StoreUint32(&o.FUNC2_OUT_SEL_CFG.Reg, volatile.LoadUint32(&o.FUNC2_OUT_SEL_CFG.Reg)&^(0x100)|value<<8)
}
func (o *GPIO_Type) GetFUNC2_OUT_SEL_CFG_FUNC_OUT_INV_SEL() uint32 {
	return (volatile.LoadUint32(&o.FUNC2_OUT_SEL_CFG.Reg) & 0x100) >> 8
}
func (o *GPIO_Type) SetFUNC2_OUT_SEL_CFG_FUNC_OEN_SEL(value uint32) {
	volatile.StoreUint32(&o.FUNC2_OUT_SEL_CFG.Reg, volatile.LoadUint32(&o.FUNC2_OUT_SEL_CFG.Reg)&^(0x200)|value<<9)
}
func (o *GPIO_Type) GetFUNC2_OUT_SEL_CFG_FUNC_OEN_SEL() uint32 {
	return (volatile.LoadUint32(&o.FUNC2_OUT_SEL_CFG.Reg) & 0x200) >> 9
}
func (o *GPIO_Type) SetFUNC2_OUT_SEL_CFG_FUNC_OEN_INV_SEL(value uint32) {
	volatile.StoreUint32(&o.FUNC2_OUT_SEL_CFG.Reg, volatile.LoadUint32(&o.FUNC2_OUT_SEL_CFG.Reg)&^(0x400)|value<<10)
}
func (o *GPIO_Type) GetFUNC2_OUT_SEL_CFG_FUNC_OEN_INV_SEL() uint32 {
	return (volatile.LoadUint32(&o.FUNC2_OUT_SEL_CFG.Reg) & 0x400) >> 10
}

// GPIO.FUNC3_OUT_SEL_CFG: GPIO output function select register
func (o *GPIO_Type) SetFUNC3_OUT_SEL_CFG_FUNC_OUT_SEL(value uint32) {
	volatile.StoreUint32(&o.FUNC3_OUT_SEL_CFG.Reg, volatile.LoadUint32(&o.FUNC3_OUT_SEL_CFG.Reg)&^(0xff)|value)
}
func (o *GPIO_Type) GetFUNC3_OUT_SEL_CFG_FUNC_OUT_SEL() uint32 {
	return volatile.LoadUint32(&o.FUNC3_OUT_SEL_CFG.Reg) & 0xff
}
func (o *GPIO_Type) SetFUNC3_OUT_SEL_CFG_FUNC_OUT_INV_SEL(value uint32) {
	volatile.StoreUint32(&o.FUNC3_OUT_SEL_CFG.Reg, volatile.LoadUint32(&o.FUNC3_OUT_SEL_CFG.Reg)&^(0x100)|value<<8)
}
func (o *GPIO_Type) GetFUNC3_OUT_SEL_CFG_FUNC_OUT_INV_SEL() uint32 {
	return (volatile.LoadUint32(&o.FUNC3_OUT_SEL_CFG.Reg) & 0x100) >> 8
}
func (o *GPIO_Type) SetFUNC3_OUT_SEL_CFG_FUNC_OEN_SEL(value uint32) {
	volatile.StoreUint32(&o.FUNC3_OUT_SEL_CFG.Reg, volatile.LoadUint32(&o.FUNC3_OUT_SEL_CFG.Reg)&^(0x200)|value<<9)
}
func (o *GPIO_Type) GetFUNC3_OUT_SEL_CFG_FUNC_OEN_SEL() uint32 {
	return (volatile.LoadUint32(&o.FUNC3_OUT_SEL_CFG.Reg) & 0x200) >> 9
}
func (o *GPIO_Type) SetFUNC3_OUT_SEL_CFG_FUNC_OEN_INV_SEL(value uint32) {
	volatile.StoreUint32(&o.FUNC3_OUT_SEL_CFG.Reg, volatile.LoadUint32(&o.FUNC3_OUT_SEL_CFG.Reg)&^(0x400)|value<<10)
}
func (o *GPIO_Type) GetFUNC3_OUT_SEL_CFG_FUNC_OEN_INV_SEL() uint32 {
	return (volatile.LoadUint32(&o.FUNC3_OUT_SEL_CFG.Reg) & 0x400) >> 10
}

// GPIO.FUNC4_OUT_SEL_CFG: GPIO output function select register
func (o *GPIO_Type) SetFUNC4_OUT_SEL_CFG_FUNC_OUT_SEL(value uint32) {
	volatile.StoreUint32(&o.FUNC4_OUT_SEL_CFG.Reg, volatile.LoadUint32(&o.FUNC4_OUT_SEL_CFG.Reg)&^(0xff)|value)
}
func (o *GPIO_Type) GetFUNC4_OUT_SEL_CFG_FUNC_OUT_SEL() uint32 {
	return volatile.LoadUint32(&o.FUNC4_OUT_SEL_CFG.Reg) & 0xff
}
func (o *GPIO_Type) SetFUNC4_OUT_SEL_CFG_FUNC_OUT_INV_SEL(value uint32) {
	volatile.StoreUint32(&o.FUNC4_OUT_SEL_CFG.Reg, volatile.LoadUint32(&o.FUNC4_OUT_SEL_CFG.Reg)&^(0x100)|value<<8)
}
func (o *GPIO_Type) GetFUNC4_OUT_SEL_CFG_FUNC_OUT_INV_SEL() uint32 {
	return (volatile.LoadUint32(&o.FUNC4_OUT_SEL_CFG.Reg) & 0x100) >> 8
}
func (o *GPIO_Type) SetFUNC4_OUT_SEL_CFG_FUNC_OEN_SEL(value uint32) {
	volatile.StoreUint32(&o.FUNC4_OUT_SEL_CFG.Reg, volatile.LoadUint32(&o.FUNC4_OUT_SEL_CFG.Reg)&^(0x200)|value<<9)
}
func (o *GPIO_Type) GetFUNC4_OUT_SEL_CFG_FUNC_OEN_SEL() uint32 {
	return (volatile.LoadUint32(&o.FUNC4_OUT_SEL_CFG.Reg) & 0x200) >> 9
}
func (o *GPIO_Type) SetFUNC4_OUT_SEL_CFG_FUNC_OEN_INV_SEL(value uint32) {
	volatile.StoreUint32(&o.FUNC4_OUT_SEL_CFG.Reg, volatile.LoadUint32(&o.FUNC4_OUT_SEL_CFG.Reg)&^(0x400)|value<<10)
}
func (o *GPIO_Type) GetFUNC4_OUT_SEL_CFG_FUNC_OEN_INV_SEL() uint32 {
	return (volatile.LoadUint32(&o.FUNC4_OUT_SEL_CFG.Reg) & 0x400) >> 10
}

// GPIO.FUNC5_OUT_SEL_CFG: GPIO output function select register
func (o *GPIO_Type) SetFUNC5_OUT_SEL_CFG_FUNC_OUT_SEL(value uint32) {
	volatile.StoreUint32(&o.FUNC5_OUT_SEL_CFG.Reg, volatile.LoadUint32(&o.FUNC5_OUT_SEL_CFG.Reg)&^(0xff)|value)
}
func (o *GPIO_Type) GetFUNC5_OUT_SEL_CFG_FUNC_OUT_SEL() uint32 {
	return volatile.LoadUint32(&o.FUNC5_OUT_SEL_CFG.Reg) & 0xff
}
func (o *GPIO_Type) SetFUNC5_OUT_SEL_CFG_FUNC_OUT_INV_SEL(value uint32) {
	volatile.StoreUint32(&o.FUNC5_OUT_SEL_CFG.Reg, volatile.LoadUint32(&o.FUNC5_OUT_SEL_CFG.Reg)&^(0x100)|value<<8)
}
func (o *GPIO_Type) GetFUNC5_OUT_SEL_CFG_FUNC_OUT_INV_SEL() uint32 {
	return (volatile.LoadUint32(&o.FUNC5_OUT_SEL_CFG.Reg) & 0x100) >> 8
}
func (o *GPIO_Type) SetFUNC5_OUT_SEL_CFG_FUNC_OEN_SEL(value uint32) {
	volatile.StoreUint32(&o.FUNC5_OUT_SEL_CFG.Reg, volatile.LoadUint32(&o.FUNC5_OUT_SEL_CFG.Reg)&^(0x200)|value<<9)
}
func (o *GPIO_Type) GetFUNC5_OUT_SEL_CFG_FUNC_OEN_SEL() uint32 {
	return (volatile.LoadUint32(&o.FUNC5_OUT_SEL_CFG.Reg) & 0x200) >> 9
}
func (o *GPIO_Type) SetFUNC5_OUT_SEL_CFG_FUNC_OEN_INV_SEL(value uint32) {
	volatile.StoreUint32(&o.FUNC5_OUT_SEL_CFG.Reg, volatile.LoadUint32(&o.FUNC5_OUT_SEL_CFG.Reg)&^(0x400)|value<<10)
}
func (o *GPIO_Type) GetFUNC5_OUT_SEL_CFG_FUNC_OEN_INV_SEL() uint32 {
	return (volatile.LoadUint32(&o.FUNC5_OUT_SEL_CFG.Reg) & 0x400) >> 10
}

// GPIO.FUNC6_OUT_SEL_CFG: GPIO output function select register
func (o *GPIO_Type) SetFUNC6_OUT_SEL_CFG_FUNC_OUT_SEL(value uint32) {
	volatile.StoreUint32(&o.FUNC6_OUT_SEL_CFG.Reg, volatile.LoadUint32(&o.FUNC6_OUT_SEL_CFG.Reg)&^(0xff)|value)
}
func (o *GPIO_Type) GetFUNC6_OUT_SEL_CFG_FUNC_OUT_SEL() uint32 {
	return volatile.LoadUint32(&o.FUNC6_OUT_SEL_CFG.Reg) & 0xff
}
func (o *GPIO_Type) SetFUNC6_OUT_SEL_CFG_FUNC_OUT_INV_SEL(value uint32) {
	volatile.StoreUint32(&o.FUNC6_OUT_SEL_CFG.Reg, volatile.LoadUint32(&o.FUNC6_OUT_SEL_CFG.Reg)&^(0x100)|value<<8)
}
func (o *GPIO_Type) GetFUNC6_OUT_SEL_CFG_FUNC_OUT_INV_SEL() uint32 {
	return (volatile.LoadUint32(&o.FUNC6_OUT_SEL_CFG.Reg) & 0x100) >> 8
}
func (o *GPIO_Type) SetFUNC6_OUT_SEL_CFG_FUNC_OEN_SEL(value uint32) {
	volatile.StoreUint32(&o.FUNC6_OUT_SEL_CFG.Reg, volatile.LoadUint32(&o.FUNC6_OUT_SEL_CFG.Reg)&^(0x200)|value<<9)
}
func (o *GPIO_Type) GetFUNC6_OUT_SEL_CFG_FUNC_OEN_SEL() uint32 {
	return (volatile.LoadUint32(&o.FUNC6_OUT_SEL_CFG.Reg) & 0x200) >> 9
}
func (o *GPIO_Type) SetFUNC6_OUT_SEL_CFG_FUNC_OEN_INV_SEL(value uint32) {
	volatile.StoreUint32(&o.FUNC6_OUT_SEL_CFG.Reg, volatile.LoadUint32(&o.FUNC6_OUT_SEL_CFG.Reg)&^(0x400)|value<<10)
}
func (o *GPIO_Type) GetFUNC6_OUT_SEL_CFG_FUNC_OEN_INV_SEL() uint32 {
	return (volatile.LoadUint32(&o.FUNC6_OUT_SEL_CFG.Reg) & 0x400) >> 10
}

// GPIO.FUNC7_OUT_SEL_CFG: GPIO output function select register
func (o *GPIO_Type) SetFUNC7_OUT_SEL_CFG_FUNC_OUT_SEL(value uint32) {
	volatile.StoreUint32(&o.FUNC7_OUT_SEL_CFG.Reg, volatile.LoadUint32(&o.FUNC7_OUT_SEL_CFG.Reg)&^(0xff)|value)
}
func (o *GPIO_Type) GetFUNC7_OUT_SEL_CFG_FUNC_OUT_SEL() uint32 {
	return volatile.LoadUint32(&o.FUNC7_OUT_SEL_CFG.Reg) & 0xff
}
func (o *GPIO_Type) SetFUNC7_OUT_SEL_CFG_FUNC_OUT_INV_SEL(value uint32) {
	volatile.StoreUint32(&o.FUNC7_OUT_SEL_CFG.Reg, volatile.LoadUint32(&o.FUNC7_OUT_SEL_CFG.Reg)&^(0x100)|value<<8)
}
func (o *GPIO_Type) GetFUNC7_OUT_SEL_CFG_FUNC_OUT_INV_SEL() uint32 {
	return (volatile.LoadUint32(&o.FUNC7_OUT_SEL_CFG.Reg) & 0x100) >> 8
}
func (o *GPIO_Type) SetFUNC7_OUT_SEL_CFG_FUNC_OEN_SEL(value uint32) {
	volatile.StoreUint32(&o.FUNC7_OUT_SEL_CFG.Reg, volatile.LoadUint32(&o.FUNC7_OUT_SEL_CFG.Reg)&^(0x200)|value<<9)
}
func (o *GPIO_Type) GetFUNC7_OUT_SEL_CFG_FUNC_OEN_SEL() uint32 {
	return (volatile.LoadUint32(&o.FUNC7_OUT_SEL_CFG.Reg) & 0x200) >> 9
}
func (o *GPIO_Type) SetFUNC7_OUT_SEL_CFG_FUNC_OEN_INV_SEL(value uint32) {
	volatile.StoreUint32(&o.FUNC7_OUT_SEL_CFG.Reg, volatile.LoadUint32(&o.FUNC7_OUT_SEL_CFG.Reg)&^(0x400)|value<<10)
}
func (o *GPIO_Type) GetFUNC7_OUT_SEL_CFG_FUNC_OEN_INV_SEL() uint32 {
	return (volatile.LoadUint32(&o.FUNC7_OUT_SEL_CFG.Reg) & 0x400) >> 10
}

// GPIO.FUNC8_OUT_SEL_CFG: GPIO output function select register
func (o *GPIO_Type) SetFUNC8_OUT_SEL_CFG_FUNC_OUT_SEL(value uint32) {
	volatile.StoreUint32(&o.FUNC8_OUT_SEL_CFG.Reg, volatile.LoadUint32(&o.FUNC8_OUT_SEL_CFG.Reg)&^(0xff)|value)
}
func (o *GPIO_Type) GetFUNC8_OUT_SEL_CFG_FUNC_OUT_SEL() uint32 {
	return volatile.LoadUint32(&o.FUNC8_OUT_SEL_CFG.Reg) & 0xff
}
func (o *GPIO_Type) SetFUNC8_OUT_SEL_CFG_FUNC_OUT_INV_SEL(value uint32) {
	volatile.StoreUint32(&o.FUNC8_OUT_SEL_CFG.Reg, volatile.LoadUint32(&o.FUNC8_OUT_SEL_CFG.Reg)&^(0x100)|value<<8)
}
func (o *GPIO_Type) GetFUNC8_OUT_SEL_CFG_FUNC_OUT_INV_SEL() uint32 {
	return (volatile.LoadUint32(&o.FUNC8_OUT_SEL_CFG.Reg) & 0x100) >> 8
}
func (o *GPIO_Type) SetFUNC8_OUT_SEL_CFG_FUNC_OEN_SEL(value uint32) {
	volatile.StoreUint32(&o.FUNC8_OUT_SEL_CFG.Reg, volatile.LoadUint32(&o.FUNC8_OUT_SEL_CFG.Reg)&^(0x200)|value<<9)
}
func (o *GPIO_Type) GetFUNC8_OUT_SEL_CFG_FUNC_OEN_SEL() uint32 {
	return (volatile.LoadUint32(&o.FUNC8_OUT_SEL_CFG.Reg) & 0x200) >> 9
}
func (o *GPIO_Type) SetFUNC8_OUT_SEL_CFG_FUNC_OEN_INV_SEL(value uint32) {
	volatile.StoreUint32(&o.FUNC8_OUT_SEL_CFG.Reg, volatile.LoadUint32(&o.FUNC8_OUT_SEL_CFG.Reg)&^(0x400)|value<<10)
}
func (o *GPIO_Type) GetFUNC8_OUT_SEL_CFG_FUNC_OEN_INV_SEL() uint32 {
	return (volatile.LoadUint32(&o.FUNC8_OUT_SEL_CFG.Reg) & 0x400) >> 10
}

// GPIO.FUNC9_OUT_SEL_CFG: GPIO output function select register
func (o *GPIO_Type) SetFUNC9_OUT_SEL_CFG_FUNC_OUT_SEL(value uint32) {
	volatile.StoreUint32(&o.FUNC9_OUT_SEL_CFG.Reg, volatile.LoadUint32(&o.FUNC9_OUT_SEL_CFG.Reg)&^(0xff)|value)
}
func (o *GPIO_Type) GetFUNC9_OUT_SEL_CFG_FUNC_OUT_SEL() uint32 {
	return volatile.LoadUint32(&o.FUNC9_OUT_SEL_CFG.Reg) & 0xff
}
func (o *GPIO_Type) SetFUNC9_OUT_SEL_CFG_FUNC_OUT_INV_SEL(value uint32) {
	volatile.StoreUint32(&o.FUNC9_OUT_SEL_CFG.Reg, volatile.LoadUint32(&o.FUNC9_OUT_SEL_CFG.Reg)&^(0x100)|value<<8)
}
func (o *GPIO_Type) GetFUNC9_OUT_SEL_CFG_FUNC_OUT_INV_SEL() uint32 {
	return (volatile.LoadUint32(&o.FUNC9_OUT_SEL_CFG.Reg) & 0x100) >> 8
}
func (o *GPIO_Type) SetFUNC9_OUT_SEL_CFG_FUNC_OEN_SEL(value uint32) {
	volatile.StoreUint32(&o.FUNC9_OUT_SEL_CFG.Reg, volatile.LoadUint32(&o.FUNC9_OUT_SEL_CFG.Reg)&^(0x200)|value<<9)
}
func (o *GPIO_Type) GetFUNC9_OUT_SEL_CFG_FUNC_OEN_SEL() uint32 {
	return (volatile.LoadUint32(&o.FUNC9_OUT_SEL_CFG.Reg) & 0x200) >> 9
}
func (o *GPIO_Type) SetFUNC9_OUT_SEL_CFG_FUNC_OEN_INV_SEL(value uint32) {
	volatile.StoreUint32(&o.FUNC9_OUT_SEL_CFG.Reg, volatile.LoadUint32(&o.FUNC9_OUT_SEL_CFG.Reg)&^(0x400)|value<<10)
}
func (o *GPIO_Type) GetFUNC9_OUT_SEL_CFG_FUNC_OEN_INV_SEL() uint32 {
	return (volatile.LoadUint32(&o.FUNC9_OUT_SEL_CFG.Reg) & 0x400) >> 10
}

// GPIO.FUNC10_OUT_SEL_CFG: GPIO output function select register
func (o *GPIO_Type) SetFUNC10_OUT_SEL_CFG_FUNC_OUT_SEL(value uint32) {
	volatile.StoreUint32(&o.FUNC10_OUT_SEL_CFG.Reg, volatile.LoadUint32(&o.FUNC10_OUT_SEL_CFG.Reg)&^(0xff)|value)
}
func (o *GPIO_Type) GetFUNC10_OUT_SEL_CFG_FUNC_OUT_SEL() uint32 {
	return volatile.LoadUint32(&o.FUNC10_OUT_SEL_CFG.Reg) & 0xff
}
func (o *GPIO_Type) SetFUNC10_OUT_SEL_CFG_FUNC_OUT_INV_SEL(value uint32) {
	volatile.StoreUint32(&o.FUNC10_OUT_SEL_CFG.Reg, volatile.LoadUint32(&o.FUNC10_OUT_SEL_CFG.Reg)&^(0x100)|value<<8)
}
func (o *GPIO_Type) GetFUNC10_OUT_SEL_CFG_FUNC_OUT_INV_SEL() uint32 {
	return (volatile.LoadUint32(&o.FUNC10_OUT_SEL_CFG.Reg) & 0x100) >> 8
}
func (o *GPIO_Type) SetFUNC10_OUT_SEL_CFG_FUNC_OEN_SEL(value uint32) {
	volatile.StoreUint32(&o.FUNC10_OUT_SEL_CFG.Reg, volatile.LoadUint32(&o.FUNC10_OUT_SEL_CFG.Reg)&^(0x200)|value<<9)
}
func (o *GPIO_Type) GetFUNC10_OUT_SEL_CFG_FUNC_OEN_SEL() uint32 {
	return (volatile.LoadUint32(&o.FUNC10_OUT_SEL_CFG.Reg) & 0x200) >> 9
}
func (o *GPIO_Type) SetFUNC10_OUT_SEL_CFG_FUNC_OEN_INV_SEL(value uint32) {
	volatile.StoreUint32(&o.FUNC10_OUT_SEL_CFG.Reg, volatile.LoadUint32(&o.FUNC10_OUT_SEL_CFG.Reg)&^(0x400)|value<<10)
}
func (o *GPIO_Type) GetFUNC10_OUT_SEL_CFG_FUNC_OEN_INV_SEL() uint32 {
	return (volatile.LoadUint32(&o.FUNC10_OUT_SEL_CFG.Reg) & 0x400) >> 10
}

// GPIO.FUNC11_OUT_SEL_CFG: GPIO output function select register
func (o *GPIO_Type) SetFUNC11_OUT_SEL_CFG_FUNC_OUT_SEL(value uint32) {
	volatile.StoreUint32(&o.FUNC11_OUT_SEL_CFG.Reg, volatile.LoadUint32(&o.FUNC11_OUT_SEL_CFG.Reg)&^(0xff)|value)
}
func (o *GPIO_Type) GetFUNC11_OUT_SEL_CFG_FUNC_OUT_SEL() uint32 {
	return volatile.LoadUint32(&o.FUNC11_OUT_SEL_CFG.Reg) & 0xff
}
func (o *GPIO_Type) SetFUNC11_OUT_SEL_CFG_FUNC_OUT_INV_SEL(value uint32) {
	volatile.StoreUint32(&o.FUNC11_OUT_SEL_CFG.Reg, volatile.LoadUint32(&o.FUNC11_OUT_SEL_CFG.Reg)&^(0x100)|value<<8)
}
func (o *GPIO_Type) GetFUNC11_OUT_SEL_CFG_FUNC_OUT_INV_SEL() uint32 {
	return (volatile.LoadUint32(&o.FUNC11_OUT_SEL_CFG.Reg) & 0x100) >> 8
}
func (o *GPIO_Type) SetFUNC11_OUT_SEL_CFG_FUNC_OEN_SEL(value uint32) {
	volatile.StoreUint32(&o.FUNC11_OUT_SEL_CFG.Reg, volatile.LoadUint32(&o.FUNC11_OUT_SEL_CFG.Reg)&^(0x200)|value<<9)
}
func (o *GPIO_Type) GetFUNC11_OUT_SEL_CFG_FUNC_OEN_SEL() uint32 {
	return (volatile.LoadUint32(&o.FUNC11_OUT_SEL_CFG.Reg) & 0x200) >> 9
}
func (o *GPIO_Type) SetFUNC11_OUT_SEL_CFG_FUNC_OEN_INV_SEL(value uint32) {
	volatile.StoreUint32(&o.FUNC11_OUT_SEL_CFG.Reg, volatile.LoadUint32(&o.FUNC11_OUT_SEL_CFG.Reg)&^(0x400)|value<<10)
}
func (o *GPIO_Type) GetFUNC11_OUT_SEL_CFG_FUNC_OEN_INV_SEL() uint32 {
	return (volatile.LoadUint32(&o.FUNC11_OUT_SEL_CFG.Reg) & 0x400) >> 10
}

// GPIO.FUNC12_OUT_SEL_CFG: GPIO output function select register
func (o *GPIO_Type) SetFUNC12_OUT_SEL_CFG_FUNC_OUT_SEL(value uint32) {
	volatile.StoreUint32(&o.FUNC12_OUT_SEL_CFG.Reg, volatile.LoadUint32(&o.FUNC12_OUT_SEL_CFG.Reg)&^(0xff)|value)
}
func (o *GPIO_Type) GetFUNC12_OUT_SEL_CFG_FUNC_OUT_SEL() uint32 {
	return volatile.LoadUint32(&o.FUNC12_OUT_SEL_CFG.Reg) & 0xff
}
func (o *GPIO_Type) SetFUNC12_OUT_SEL_CFG_FUNC_OUT_INV_SEL(value uint32) {
	volatile.StoreUint32(&o.FUNC12_OUT_SEL_CFG.Reg, volatile.LoadUint32(&o.FUNC12_OUT_SEL_CFG.Reg)&^(0x100)|value<<8)
}
func (o *GPIO_Type) GetFUNC12_OUT_SEL_CFG_FUNC_OUT_INV_SEL() uint32 {
	return (volatile.LoadUint32(&o.FUNC12_OUT_SEL_CFG.Reg) & 0x100) >> 8
}
func (o *GPIO_Type) SetFUNC12_OUT_SEL_CFG_FUNC_OEN_SEL(value uint32) {
	volatile.StoreUint32(&o.FUNC12_OUT_SEL_CFG.Reg, volatile.LoadUint32(&o.FUNC12_OUT_SEL_CFG.Reg)&^(0x200)|value<<9)
}
func (o *GPIO_Type) GetFUNC12_OUT_SEL_CFG_FUNC_OEN_SEL() uint32 {
	return (volatile.LoadUint32(&o.FUNC12_OUT_SEL_CFG.Reg) & 0x200) >> 9
}
func (o *GPIO_Type) SetFUNC12_OUT_SEL_CFG_FUNC_OEN_INV_SEL(value uint32) {
	volatile.StoreUint32(&o.FUNC12_OUT_SEL_CFG.Reg, volatile.LoadUint32(&o.FUNC12_OUT_SEL_CFG.Reg)&^(0x400)|value<<10)
}
func (o *GPIO_Type) GetFUNC12_OUT_SEL_CFG_FUNC_OEN_INV_SEL() uint32 {
	return (volatile.LoadUint32(&o.FUNC12_OUT_SEL_CFG.Reg) & 0x400) >> 10
}

// GPIO.FUNC13_OUT_SEL_CFG: GPIO output function select register
func (o *GPIO_Type) SetFUNC13_OUT_SEL_CFG_FUNC_OUT_SEL(value uint32) {
	volatile.StoreUint32(&o.FUNC13_OUT_SEL_CFG.Reg, volatile.LoadUint32(&o.FUNC13_OUT_SEL_CFG.Reg)&^(0xff)|value)
}
func (o *GPIO_Type) GetFUNC13_OUT_SEL_CFG_FUNC_OUT_SEL() uint32 {
	return volatile.LoadUint32(&o.FUNC13_OUT_SEL_CFG.Reg) & 0xff
}
func (o *GPIO_Type) SetFUNC13_OUT_SEL_CFG_FUNC_OUT_INV_SEL(value uint32) {
	volatile.StoreUint32(&o.FUNC13_OUT_SEL_CFG.Reg, volatile.LoadUint32(&o.FUNC13_OUT_SEL_CFG.Reg)&^(0x100)|value<<8)
}
func (o *GPIO_Type) GetFUNC13_OUT_SEL_CFG_FUNC_OUT_INV_SEL() uint32 {
	return (volatile.LoadUint32(&o.FUNC13_OUT_SEL_CFG.Reg) & 0x100) >> 8
}
func (o *GPIO_Type) SetFUNC13_OUT_SEL_CFG_FUNC_OEN_SEL(value uint32) {
	volatile.StoreUint32(&o.FUNC13_OUT_SEL_CFG.Reg, volatile.LoadUint32(&o.FUNC13_OUT_SEL_CFG.Reg)&^(0x200)|value<<9)
}
func (o *GPIO_Type) GetFUNC13_OUT_SEL_CFG_FUNC_OEN_SEL() uint32 {
	return (volatile.LoadUint32(&o.FUNC13_OUT_SEL_CFG.Reg) & 0x200) >> 9
}
func (o *GPIO_Type) SetFUNC13_OUT_SEL_CFG_FUNC_OEN_INV_SEL(value uint32) {
	volatile.StoreUint32(&o.FUNC13_OUT_SEL_CFG.Reg, volatile.LoadUint32(&o.FUNC13_OUT_SEL_CFG.Reg)&^(0x400)|value<<10)
}
func (o *GPIO_Type) GetFUNC13_OUT_SEL_CFG_FUNC_OEN_INV_SEL() uint32 {
	return (volatile.LoadUint32(&o.FUNC13_OUT_SEL_CFG.Reg) & 0x400) >> 10
}

// GPIO.FUNC14_OUT_SEL_CFG: GPIO output function select register
func (o *GPIO_Type) SetFUNC14_OUT_SEL_CFG_FUNC_OUT_SEL(value uint32) {
	volatile.StoreUint32(&o.FUNC14_OUT_SEL_CFG.Reg, volatile.LoadUint32(&o.FUNC14_OUT_SEL_CFG.Reg)&^(0xff)|value)
}
func (o *GPIO_Type) GetFUNC14_OUT_SEL_CFG_FUNC_OUT_SEL() uint32 {
	return volatile.LoadUint32(&o.FUNC14_OUT_SEL_CFG.Reg) & 0xff
}
func (o *GPIO_Type) SetFUNC14_OUT_SEL_CFG_FUNC_OUT_INV_SEL(value uint32) {
	volatile.StoreUint32(&o.FUNC14_OUT_SEL_CFG.Reg, volatile.LoadUint32(&o.FUNC14_OUT_SEL_CFG.Reg)&^(0x100)|value<<8)
}
func (o *GPIO_Type) GetFUNC14_OUT_SEL_CFG_FUNC_OUT_INV_SEL() uint32 {
	return (volatile.LoadUint32(&o.FUNC14_OUT_SEL_CFG.Reg) & 0x100) >> 8
}
func (o *GPIO_Type) SetFUNC14_OUT_SEL_CFG_FUNC_OEN_SEL(value uint32) {
	volatile.StoreUint32(&o.FUNC14_OUT_SEL_CFG.Reg, volatile.LoadUint32(&o.FUNC14_OUT_SEL_CFG.Reg)&^(0x200)|value<<9)
}
func (o *GPIO_Type) GetFUNC14_OUT_SEL_CFG_FUNC_OEN_SEL() uint32 {
	return (volatile.LoadUint32(&o.FUNC14_OUT_SEL_CFG.Reg) & 0x200) >> 9
}
func (o *GPIO_Type) SetFUNC14_OUT_SEL_CFG_FUNC_OEN_INV_SEL(value uint32) {
	volatile.StoreUint32(&o.FUNC14_OUT_SEL_CFG.Reg, volatile.LoadUint32(&o.FUNC14_OUT_SEL_CFG.Reg)&^(0x400)|value<<10)
}
func (o *GPIO_Type) GetFUNC14_OUT_SEL_CFG_FUNC_OEN_INV_SEL() uint32 {
	return (volatile.LoadUint32(&o.FUNC14_OUT_SEL_CFG.Reg) & 0x400) >> 10
}

// GPIO.FUNC15_OUT_SEL_CFG: GPIO output function select register
func (o *GPIO_Type) SetFUNC15_OUT_SEL_CFG_FUNC_OUT_SEL(value uint32) {
	volatile.StoreUint32(&o.FUNC15_OUT_SEL_CFG.Reg, volatile.LoadUint32(&o.FUNC15_OUT_SEL_CFG.Reg)&^(0xff)|value)
}
func (o *GPIO_Type) GetFUNC15_OUT_SEL_CFG_FUNC_OUT_SEL() uint32 {
	return volatile.LoadUint32(&o.FUNC15_OUT_SEL_CFG.Reg) & 0xff
}
func (o *GPIO_Type) SetFUNC15_OUT_SEL_CFG_FUNC_OUT_INV_SEL(value uint32) {
	volatile.StoreUint32(&o.FUNC15_OUT_SEL_CFG.Reg, volatile.LoadUint32(&o.FUNC15_OUT_SEL_CFG.Reg)&^(0x100)|value<<8)
}
func (o *GPIO_Type) GetFUNC15_OUT_SEL_CFG_FUNC_OUT_INV_SEL() uint32 {
	return (volatile.LoadUint32(&o.FUNC15_OUT_SEL_CFG.Reg) & 0x100) >> 8
}
func (o *GPIO_Type) SetFUNC15_OUT_SEL_CFG_FUNC_OEN_SEL(value uint32) {
	volatile.StoreUint32(&o.FUNC15_OUT_SEL_CFG.Reg, volatile.LoadUint32(&o.FUNC15_OUT_SEL_CFG.Reg)&^(0x200)|value<<9)
}
func (o *GPIO_Type) GetFUNC15_OUT_SEL_CFG_FUNC_OEN_SEL() uint32 {
	return (volatile.LoadUint32(&o.FUNC15_OUT_SEL_CFG.Reg) & 0x200) >> 9
}
func (o *GPIO_Type) SetFUNC15_OUT_SEL_CFG_FUNC_OEN_INV_SEL(value uint32) {
	volatile.StoreUint32(&o.FUNC15_OUT_SEL_CFG.Reg, volatile.LoadUint32(&o.FUNC15_OUT_SEL_CFG.Reg)&^(0x400)|value<<10)
}
func (o *GPIO_Type) GetFUNC15_OUT_SEL_CFG_FUNC_OEN_INV_SEL() uint32 {
	return (volatile.LoadUint32(&o.FUNC15_OUT_SEL_CFG.Reg) & 0x400) >> 10
}

// GPIO.FUNC16_OUT_SEL_CFG: GPIO output function select register
func (o *GPIO_Type) SetFUNC16_OUT_SEL_CFG_FUNC_OUT_SEL(value uint32) {
	volatile.StoreUint32(&o.FUNC16_OUT_SEL_CFG.Reg, volatile.LoadUint32(&o.FUNC16_OUT_SEL_CFG.Reg)&^(0xff)|value)
}
func (o *GPIO_Type) GetFUNC16_OUT_SEL_CFG_FUNC_OUT_SEL() uint32 {
	return volatile.LoadUint32(&o.FUNC16_OUT_SEL_CFG.Reg) & 0xff
}
func (o *GPIO_Type) SetFUNC16_OUT_SEL_CFG_FUNC_OUT_INV_SEL(value uint32) {
	volatile.StoreUint32(&o.FUNC16_OUT_SEL_CFG.Reg, volatile.LoadUint32(&o.FUNC16_OUT_SEL_CFG.Reg)&^(0x100)|value<<8)
}
func (o *GPIO_Type) GetFUNC16_OUT_SEL_CFG_FUNC_OUT_INV_SEL() uint32 {
	return (volatile.LoadUint32(&o.FUNC16_OUT_SEL_CFG.Reg) & 0x100) >> 8
}
func (o *GPIO_Type) SetFUNC16_OUT_SEL_CFG_FUNC_OEN_SEL(value uint32) {
	volatile.StoreUint32(&o.FUNC16_OUT_SEL_CFG.Reg, volatile.LoadUint32(&o.FUNC16_OUT_SEL_CFG.Reg)&^(0x200)|value<<9)
}
func (o *GPIO_Type) GetFUNC16_OUT_SEL_CFG_FUNC_OEN_SEL() uint32 {
	return (volatile.LoadUint32(&o.FUNC16_OUT_SEL_CFG.Reg) & 0x200) >> 9
}
func (o *GPIO_Type) SetFUNC16_OUT_SEL_CFG_FUNC_OEN_INV_SEL(value uint32) {
	volatile.StoreUint32(&o.FUNC16_OUT_SEL_CFG.Reg, volatile.LoadUint32(&o.FUNC16_OUT_SEL_CFG.Reg)&^(0x400)|value<<10)
}
func (o *GPIO_Type) GetFUNC16_OUT_SEL_CFG_FUNC_OEN_INV_SEL() uint32 {
	return (volatile.LoadUint32(&o.FUNC16_OUT_SEL_CFG.Reg) & 0x400) >> 10
}

// GPIO.FUNC17_OUT_SEL_CFG: GPIO output function select register
func (o *GPIO_Type) SetFUNC17_OUT_SEL_CFG_FUNC_OUT_SEL(value uint32) {
	volatile.StoreUint32(&o.FUNC17_OUT_SEL_CFG.Reg, volatile.LoadUint32(&o.FUNC17_OUT_SEL_CFG.Reg)&^(0xff)|value)
}
func (o *GPIO_Type) GetFUNC17_OUT_SEL_CFG_FUNC_OUT_SEL() uint32 {
	return volatile.LoadUint32(&o.FUNC17_OUT_SEL_CFG.Reg) & 0xff
}
func (o *GPIO_Type) SetFUNC17_OUT_SEL_CFG_FUNC_OUT_INV_SEL(value uint32) {
	volatile.StoreUint32(&o.FUNC17_OUT_SEL_CFG.Reg, volatile.LoadUint32(&o.FUNC17_OUT_SEL_CFG.Reg)&^(0x100)|value<<8)
}
func (o *GPIO_Type) GetFUNC17_OUT_SEL_CFG_FUNC_OUT_INV_SEL() uint32 {
	return (volatile.LoadUint32(&o.FUNC17_OUT_SEL_CFG.Reg) & 0x100) >> 8
}
func (o *GPIO_Type) SetFUNC17_OUT_SEL_CFG_FUNC_OEN_SEL(value uint32) {
	volatile.StoreUint32(&o.FUNC17_OUT_SEL_CFG.Reg, volatile.LoadUint32(&o.FUNC17_OUT_SEL_CFG.Reg)&^(0x200)|value<<9)
}
func (o *GPIO_Type) GetFUNC17_OUT_SEL_CFG_FUNC_OEN_SEL() uint32 {
	return (volatile.LoadUint32(&o.FUNC17_OUT_SEL_CFG.Reg) & 0x200) >> 9
}
func (o *GPIO_Type) SetFUNC17_OUT_SEL_CFG_FUNC_OEN_INV_SEL(value uint32) {
	volatile.StoreUint32(&o.FUNC17_OUT_SEL_CFG.Reg, volatile.LoadUint32(&o.FUNC17_OUT_SEL_CFG.Reg)&^(0x400)|value<<10)
}
func (o *GPIO_Type) GetFUNC17_OUT_SEL_CFG_FUNC_OEN_INV_SEL() uint32 {
	return (volatile.LoadUint32(&o.FUNC17_OUT_SEL_CFG.Reg) & 0x400) >> 10
}

// GPIO.FUNC18_OUT_SEL_CFG: GPIO output function select register
func (o *GPIO_Type) SetFUNC18_OUT_SEL_CFG_FUNC_OUT_SEL(value uint32) {
	volatile.StoreUint32(&o.FUNC18_OUT_SEL_CFG.Reg, volatile.LoadUint32(&o.FUNC18_OUT_SEL_CFG.Reg)&^(0xff)|value)
}
func (o *GPIO_Type) GetFUNC18_OUT_SEL_CFG_FUNC_OUT_SEL() uint32 {
	return volatile.LoadUint32(&o.FUNC18_OUT_SEL_CFG.Reg) & 0xff
}
func (o *GPIO_Type) SetFUNC18_OUT_SEL_CFG_FUNC_OUT_INV_SEL(value uint32) {
	volatile.StoreUint32(&o.FUNC18_OUT_SEL_CFG.Reg, volatile.LoadUint32(&o.FUNC18_OUT_SEL_CFG.Reg)&^(0x100)|value<<8)
}
func (o *GPIO_Type) GetFUNC18_OUT_SEL_CFG_FUNC_OUT_INV_SEL() uint32 {
	return (volatile.LoadUint32(&o.FUNC18_OUT_SEL_CFG.Reg) & 0x100) >> 8
}
func (o *GPIO_Type) SetFUNC18_OUT_SEL_CFG_FUNC_OEN_SEL(value uint32) {
	volatile.StoreUint32(&o.FUNC18_OUT_SEL_CFG.Reg, volatile.LoadUint32(&o.FUNC18_OUT_SEL_CFG.Reg)&^(0x200)|value<<9)
}
func (o *GPIO_Type) GetFUNC18_OUT_SEL_CFG_FUNC_OEN_SEL() uint32 {
	return (volatile.LoadUint32(&o.FUNC18_OUT_SEL_CFG.Reg) & 0x200) >> 9
}
func (o *GPIO_Type) SetFUNC18_OUT_SEL_CFG_FUNC_OEN_INV_SEL(value uint32) {
	volatile.StoreUint32(&o.FUNC18_OUT_SEL_CFG.Reg, volatile.LoadUint32(&o.FUNC18_OUT_SEL_CFG.Reg)&^(0x400)|value<<10)
}
func (o *GPIO_Type) GetFUNC18_OUT_SEL_CFG_FUNC_OEN_INV_SEL() uint32 {
	return (volatile.LoadUint32(&o.FUNC18_OUT_SEL_CFG.Reg) & 0x400) >> 10
}

// GPIO.FUNC19_OUT_SEL_CFG: GPIO output function select register
func (o *GPIO_Type) SetFUNC19_OUT_SEL_CFG_FUNC_OUT_SEL(value uint32) {
	volatile.StoreUint32(&o.FUNC19_OUT_SEL_CFG.Reg, volatile.LoadUint32(&o.FUNC19_OUT_SEL_CFG.Reg)&^(0xff)|value)
}
func (o *GPIO_Type) GetFUNC19_OUT_SEL_CFG_FUNC_OUT_SEL() uint32 {
	return volatile.LoadUint32(&o.FUNC19_OUT_SEL_CFG.Reg) & 0xff
}
func (o *GPIO_Type) SetFUNC19_OUT_SEL_CFG_FUNC_OUT_INV_SEL(value uint32) {
	volatile.StoreUint32(&o.FUNC19_OUT_SEL_CFG.Reg, volatile.LoadUint32(&o.FUNC19_OUT_SEL_CFG.Reg)&^(0x100)|value<<8)
}
func (o *GPIO_Type) GetFUNC19_OUT_SEL_CFG_FUNC_OUT_INV_SEL() uint32 {
	return (volatile.LoadUint32(&o.FUNC19_OUT_SEL_CFG.Reg) & 0x100) >> 8
}
func (o *GPIO_Type) SetFUNC19_OUT_SEL_CFG_FUNC_OEN_SEL(value uint32) {
	volatile.StoreUint32(&o.FUNC19_OUT_SEL_CFG.Reg, volatile.LoadUint32(&o.FUNC19_OUT_SEL_CFG.Reg)&^(0x200)|value<<9)
}
func (o *GPIO_Type) GetFUNC19_OUT_SEL_CFG_FUNC_OEN_SEL() uint32 {
	return (volatile.LoadUint32(&o.FUNC19_OUT_SEL_CFG.Reg) & 0x200) >> 9
}
func (o *GPIO_Type) SetFUNC19_OUT_SEL_CFG_FUNC_OEN_INV_SEL(value uint32) {
	volatile.StoreUint32(&o.FUNC19_OUT_SEL_CFG.Reg, volatile.LoadUint32(&o.FUNC19_OUT_SEL_CFG.Reg)&^(0x400)|value<<10)
}
func (o *GPIO_Type) GetFUNC19_OUT_SEL_CFG_FUNC_OEN_INV_SEL() uint32 {
	return (volatile.LoadUint32(&o.FUNC19_OUT_SEL_CFG.Reg) & 0x400) >> 10
}

// GPIO.FUNC20_OUT_SEL_CFG: GPIO output function select register
func (o *GPIO_Type) SetFUNC20_OUT_SEL_CFG_FUNC_OUT_SEL(value uint32) {
	volatile.StoreUint32(&o.FUNC20_OUT_SEL_CFG.Reg, volatile.LoadUint32(&o.FUNC20_OUT_SEL_CFG.Reg)&^(0xff)|value)
}
func (o *GPIO_Type) GetFUNC20_OUT_SEL_CFG_FUNC_OUT_SEL() uint32 {
	return volatile.LoadUint32(&o.FUNC20_OUT_SEL_CFG.Reg) & 0xff
}
func (o *GPIO_Type) SetFUNC20_OUT_SEL_CFG_FUNC_OUT_INV_SEL(value uint32) {
	volatile.StoreUint32(&o.FUNC20_OUT_SEL_CFG.Reg, volatile.LoadUint32(&o.FUNC20_OUT_SEL_CFG.Reg)&^(0x100)|value<<8)
}
func (o *GPIO_Type) GetFUNC20_OUT_SEL_CFG_FUNC_OUT_INV_SEL() uint32 {
	return (volatile.LoadUint32(&o.FUNC20_OUT_SEL_CFG.Reg) & 0x100) >> 8
}
func (o *GPIO_Type) SetFUNC20_OUT_SEL_CFG_FUNC_OEN_SEL(value uint32) {
	volatile.StoreUint32(&o.FUNC20_OUT_SEL_CFG.Reg, volatile.LoadUint32(&o.FUNC20_OUT_SEL_CFG.Reg)&^(0x200)|value<<9)
}
func (o *GPIO_Type) GetFUNC20_OUT_SEL_CFG_FUNC_OEN_SEL() uint32 {
	return (volatile.LoadUint32(&o.FUNC20_OUT_SEL_CFG.Reg) & 0x200) >> 9
}
func (o *GPIO_Type) SetFUNC20_OUT_SEL_CFG_FUNC_OEN_INV_SEL(value uint32) {
	volatile.StoreUint32(&o.FUNC20_OUT_SEL_CFG.Reg, volatile.LoadUint32(&o.FUNC20_OUT_SEL_CFG.Reg)&^(0x400)|value<<10)
}
func (o *GPIO_Type) GetFUNC20_OUT_SEL_CFG_FUNC_OEN_INV_SEL() uint32 {
	return (volatile.LoadUint32(&o.FUNC20_OUT_SEL_CFG.Reg) & 0x400) >> 10
}

// GPIO.FUNC21_OUT_SEL_CFG: GPIO output function select register
func (o *GPIO_Type) SetFUNC21_OUT_SEL_CFG_FUNC_OUT_SEL(value uint32) {
	volatile.StoreUint32(&o.FUNC21_OUT_SEL_CFG.Reg, volatile.LoadUint32(&o.FUNC21_OUT_SEL_CFG.Reg)&^(0xff)|value)
}
func (o *GPIO_Type) GetFUNC21_OUT_SEL_CFG_FUNC_OUT_SEL() uint32 {
	return volatile.LoadUint32(&o.FUNC21_OUT_SEL_CFG.Reg) & 0xff
}
func (o *GPIO_Type) SetFUNC21_OUT_SEL_CFG_FUNC_OUT_INV_SEL(value uint32) {
	volatile.StoreUint32(&o.FUNC21_OUT_SEL_CFG.Reg, volatile.LoadUint32(&o.FUNC21_OUT_SEL_CFG.Reg)&^(0x100)|value<<8)
}
func (o *GPIO_Type) GetFUNC21_OUT_SEL_CFG_FUNC_OUT_INV_SEL() uint32 {
	return (volatile.LoadUint32(&o.FUNC21_OUT_SEL_CFG.Reg) & 0x100) >> 8
}
func (o *GPIO_Type) SetFUNC21_OUT_SEL_CFG_FUNC_OEN_SEL(value uint32) {
	volatile.StoreUint32(&o.FUNC21_OUT_SEL_CFG.Reg, volatile.LoadUint32(&o.FUNC21_OUT_SEL_CFG.Reg)&^(0x200)|value<<9)
}
func (o *GPIO_Type) GetFUNC21_OUT_SEL_CFG_FUNC_OEN_SEL() uint32 {
	return (volatile.LoadUint32(&o.FUNC21_OUT_SEL_CFG.Reg) & 0x200) >> 9
}
func (o *GPIO_Type) SetFUNC21_OUT_SEL_CFG_FUNC_OEN_INV_SEL(value uint32) {
	volatile.StoreUint32(&o.FUNC21_OUT_SEL_CFG.Reg, volatile.LoadUint32(&o.FUNC21_OUT_SEL_CFG.Reg)&^(0x400)|value<<10)
}
func (o *GPIO_Type) GetFUNC21_OUT_SEL_CFG_FUNC_OEN_INV_SEL() uint32 {
	return (volatile.LoadUint32(&o.FUNC21_OUT_SEL_CFG.Reg) & 0x400) >> 10
}

// GPIO.FUNC22_OUT_SEL_CFG: GPIO output function select register
func (o *GPIO_Type) SetFUNC22_OUT_SEL_CFG_FUNC_OUT_SEL(value uint32) {
	volatile.StoreUint32(&o.FUNC22_OUT_SEL_CFG.Reg, volatile.LoadUint32(&o.FUNC22_OUT_SEL_CFG.Reg)&^(0xff)|value)
}
func (o *GPIO_Type) GetFUNC22_OUT_SEL_CFG_FUNC_OUT_SEL() uint32 {
	return volatile.LoadUint32(&o.FUNC22_OUT_SEL_CFG.Reg) & 0xff
}
func (o *GPIO_Type) SetFUNC22_OUT_SEL_CFG_FUNC_OUT_INV_SEL(value uint32) {
	volatile.StoreUint32(&o.FUNC22_OUT_SEL_CFG.Reg, volatile.LoadUint32(&o.FUNC22_OUT_SEL_CFG.Reg)&^(0x100)|value<<8)
}
func (o *GPIO_Type) GetFUNC22_OUT_SEL_CFG_FUNC_OUT_INV_SEL() uint32 {
	return (volatile.LoadUint32(&o.FUNC22_OUT_SEL_CFG.Reg) & 0x100) >> 8
}
func (o *GPIO_Type) SetFUNC22_OUT_SEL_CFG_FUNC_OEN_SEL(value uint32) {
	volatile.StoreUint32(&o.FUNC22_OUT_SEL_CFG.Reg, volatile.LoadUint32(&o.FUNC22_OUT_SEL_CFG.Reg)&^(0x200)|value<<9)
}
func (o *GPIO_Type) GetFUNC22_OUT_SEL_CFG_FUNC_OEN_SEL() uint32 {
	return (volatile.LoadUint32(&o.FUNC22_OUT_SEL_CFG.Reg) & 0x200) >> 9
}
func (o *GPIO_Type) SetFUNC22_OUT_SEL_CFG_FUNC_OEN_INV_SEL(value uint32) {
	volatile.StoreUint32(&o.FUNC22_OUT_SEL_CFG.Reg, volatile.LoadUint32(&o.FUNC22_OUT_SEL_CFG.Reg)&^(0x400)|value<<10)
}
func (o *GPIO_Type) GetFUNC22_OUT_SEL_CFG_FUNC_OEN_INV_SEL() uint32 {
	return (volatile.LoadUint32(&o.FUNC22_OUT_SEL_CFG.Reg) & 0x400) >> 10
}

// GPIO.FUNC23_OUT_SEL_CFG: GPIO output function select register
func (o *GPIO_Type) SetFUNC23_OUT_SEL_CFG_FUNC_OUT_SEL(value uint32) {
	volatile.StoreUint32(&o.FUNC23_OUT_SEL_CFG.Reg, volatile.LoadUint32(&o.FUNC23_OUT_SEL_CFG.Reg)&^(0xff)|value)
}
func (o *GPIO_Type) GetFUNC23_OUT_SEL_CFG_FUNC_OUT_SEL() uint32 {
	return volatile.LoadUint32(&o.FUNC23_OUT_SEL_CFG.Reg) & 0xff
}
func (o *GPIO_Type) SetFUNC23_OUT_SEL_CFG_FUNC_OUT_INV_SEL(value uint32) {
	volatile.StoreUint32(&o.FUNC23_OUT_SEL_CFG.Reg, volatile.LoadUint32(&o.FUNC23_OUT_SEL_CFG.Reg)&^(0x100)|value<<8)
}
func (o *GPIO_Type) GetFUNC23_OUT_SEL_CFG_FUNC_OUT_INV_SEL() uint32 {
	return (volatile.LoadUint32(&o.FUNC23_OUT_SEL_CFG.Reg) & 0x100) >> 8
}
func (o *GPIO_Type) SetFUNC23_OUT_SEL_CFG_FUNC_OEN_SEL(value uint32) {
	volatile.StoreUint32(&o.FUNC23_OUT_SEL_CFG.Reg, volatile.LoadUint32(&o.FUNC23_OUT_SEL_CFG.Reg)&^(0x200)|value<<9)
}
func (o *GPIO_Type) GetFUNC23_OUT_SEL_CFG_FUNC_OEN_SEL() uint32 {
	return (volatile.LoadUint32(&o.FUNC23_OUT_SEL_CFG.Reg) & 0x200) >> 9
}
func (o *GPIO_Type) SetFUNC23_OUT_SEL_CFG_FUNC_OEN_INV_SEL(value uint32) {
	volatile.StoreUint32(&o.FUNC23_OUT_SEL_CFG.Reg, volatile.LoadUint32(&o.FUNC23_OUT_SEL_CFG.Reg)&^(0x400)|value<<10)
}
func (o *GPIO_Type) GetFUNC23_OUT_SEL_CFG_FUNC_OEN_INV_SEL() uint32 {
	return (volatile.LoadUint32(&o.FUNC23_OUT_SEL_CFG.Reg) & 0x400) >> 10
}

// GPIO.FUNC24_OUT_SEL_CFG: GPIO output function select register
func (o *GPIO_Type) SetFUNC24_OUT_SEL_CFG_FUNC_OUT_SEL(value uint32) {
	volatile.StoreUint32(&o.FUNC24_OUT_SEL_CFG.Reg, volatile.LoadUint32(&o.FUNC24_OUT_SEL_CFG.Reg)&^(0xff)|value)
}
func (o *GPIO_Type) GetFUNC24_OUT_SEL_CFG_FUNC_OUT_SEL() uint32 {
	return volatile.LoadUint32(&o.FUNC24_OUT_SEL_CFG.Reg) & 0xff
}
func (o *GPIO_Type) SetFUNC24_OUT_SEL_CFG_FUNC_OUT_INV_SEL(value uint32) {
	volatile.StoreUint32(&o.FUNC24_OUT_SEL_CFG.Reg, volatile.LoadUint32(&o.FUNC24_OUT_SEL_CFG.Reg)&^(0x100)|value<<8)
}
func (o *GPIO_Type) GetFUNC24_OUT_SEL_CFG_FUNC_OUT_INV_SEL() uint32 {
	return (volatile.LoadUint32(&o.FUNC24_OUT_SEL_CFG.Reg) & 0x100) >> 8
}
func (o *GPIO_Type) SetFUNC24_OUT_SEL_CFG_FUNC_OEN_SEL(value uint32) {
	volatile.StoreUint32(&o.FUNC24_OUT_SEL_CFG.Reg, volatile.LoadUint32(&o.FUNC24_OUT_SEL_CFG.Reg)&^(0x200)|value<<9)
}
func (o *GPIO_Type) GetFUNC24_OUT_SEL_CFG_FUNC_OEN_SEL() uint32 {
	return (volatile.LoadUint32(&o.FUNC24_OUT_SEL_CFG.Reg) & 0x200) >> 9
}
func (o *GPIO_Type) SetFUNC24_OUT_SEL_CFG_FUNC_OEN_INV_SEL(value uint32) {
	volatile.StoreUint32(&o.FUNC24_OUT_SEL_CFG.Reg, volatile.LoadUint32(&o.FUNC24_OUT_SEL_CFG.Reg)&^(0x400)|value<<10)
}
func (o *GPIO_Type) GetFUNC24_OUT_SEL_CFG_FUNC_OEN_INV_SEL() uint32 {
	return (volatile.LoadUint32(&o.FUNC24_OUT_SEL_CFG.Reg) & 0x400) >> 10
}

// GPIO.FUNC25_OUT_SEL_CFG: GPIO output function select register
func (o *GPIO_Type) SetFUNC25_OUT_SEL_CFG_FUNC_OUT_SEL(value uint32) {
	volatile.StoreUint32(&o.FUNC25_OUT_SEL_CFG.Reg, volatile.LoadUint32(&o.FUNC25_OUT_SEL_CFG.Reg)&^(0xff)|value)
}
func (o *GPIO_Type) GetFUNC25_OUT_SEL_CFG_FUNC_OUT_SEL() uint32 {
	return volatile.LoadUint32(&o.FUNC25_OUT_SEL_CFG.Reg) & 0xff
}
func (o *GPIO_Type) SetFUNC25_OUT_SEL_CFG_FUNC_OUT_INV_SEL(value uint32) {
	volatile.StoreUint32(&o.FUNC25_OUT_SEL_CFG.Reg, volatile.LoadUint32(&o.FUNC25_OUT_SEL_CFG.Reg)&^(0x100)|value<<8)
}
func (o *GPIO_Type) GetFUNC25_OUT_SEL_CFG_FUNC_OUT_INV_SEL() uint32 {
	return (volatile.LoadUint32(&o.FUNC25_OUT_SEL_CFG.Reg) & 0x100) >> 8
}
func (o *GPIO_Type) SetFUNC25_OUT_SEL_CFG_FUNC_OEN_SEL(value uint32) {
	volatile.StoreUint32(&o.FUNC25_OUT_SEL_CFG.Reg, volatile.LoadUint32(&o.FUNC25_OUT_SEL_CFG.Reg)&^(0x200)|value<<9)
}
func (o *GPIO_Type) GetFUNC25_OUT_SEL_CFG_FUNC_OEN_SEL() uint32 {
	return (volatile.LoadUint32(&o.FUNC25_OUT_SEL_CFG.Reg) & 0x200) >> 9
}
func (o *GPIO_Type) SetFUNC25_OUT_SEL_CFG_FUNC_OEN_INV_SEL(value uint32) {
	volatile.StoreUint32(&o.FUNC25_OUT_SEL_CFG.Reg, volatile.LoadUint32(&o.FUNC25_OUT_SEL_CFG.Reg)&^(0x400)|value<<10)
}
func (o *GPIO_Type) GetFUNC25_OUT_SEL_CFG_FUNC_OEN_INV_SEL() uint32 {
	return (volatile.LoadUint32(&o.FUNC25_OUT_SEL_CFG.Reg) & 0x400) >> 10
}

// GPIO.CLOCK_GATE: GPIO clock gate register
func (o *GPIO_Type) SetCLOCK_GATE_CLK_EN(value uint32) {
	volatile.StoreUint32(&o.CLOCK_GATE.Reg, volatile.LoadUint32(&o.CLOCK_GATE.Reg)&^(0x1)|value)
}
func (o *GPIO_Type) GetCLOCK_GATE_CLK_EN() uint32 {
	return volatile.LoadUint32(&o.CLOCK_GATE.Reg) & 0x1
}

// GPIO.REG_DATE: GPIO version register
func (o *GPIO_Type) SetREG_DATE(value uint32) {
	volatile.StoreUint32(&o.REG_DATE.Reg, volatile.LoadUint32(&o.REG_DATE.Reg)&^(0xfffffff)|value)
}
func (o *GPIO_Type) GetREG_DATE() uint32 {
	return volatile.LoadUint32(&o.REG_DATE.Reg) & 0xfffffff
}

// Peripheral GPIOSD
type GPIOSD_Type struct {
	SIGMADELTA0        volatile.Register32 // 0x0
	SIGMADELTA1        volatile.Register32 // 0x4
	SIGMADELTA2        volatile.Register32 // 0x8
	SIGMADELTA3        volatile.Register32 // 0xC
	_                  [16]byte
	SIGMADELTA_CG      volatile.Register32 // 0x20
	SIGMADELTA_MISC    volatile.Register32 // 0x24
	SIGMADELTA_VERSION volatile.Register32 // 0x28
}

// GPIOSD.SIGMADELTA0: Duty Cycle Configure Register of SDM%s
func (o *GPIOSD_Type) SetSIGMADELTA0_SD0_IN(value uint32) {
	volatile.StoreUint32(&o.SIGMADELTA0.Reg, volatile.LoadUint32(&o.SIGMADELTA0.Reg)&^(0xff)|value)
}
func (o *GPIOSD_Type) GetSIGMADELTA0_SD0_IN() uint32 {
	return volatile.LoadUint32(&o.SIGMADELTA0.Reg) & 0xff
}
func (o *GPIOSD_Type) SetSIGMADELTA0_SD0_PRESCALE(value uint32) {
	volatile.StoreUint32(&o.SIGMADELTA0.Reg, volatile.LoadUint32(&o.SIGMADELTA0.Reg)&^(0xff00)|value<<8)
}
func (o *GPIOSD_Type) GetSIGMADELTA0_SD0_PRESCALE() uint32 {
	return (volatile.LoadUint32(&o.SIGMADELTA0.Reg) & 0xff00) >> 8
}

// GPIOSD.SIGMADELTA1: Duty Cycle Configure Register of SDM%s
func (o *GPIOSD_Type) SetSIGMADELTA1_SD0_IN(value uint32) {
	volatile.StoreUint32(&o.SIGMADELTA1.Reg, volatile.LoadUint32(&o.SIGMADELTA1.Reg)&^(0xff)|value)
}
func (o *GPIOSD_Type) GetSIGMADELTA1_SD0_IN() uint32 {
	return volatile.LoadUint32(&o.SIGMADELTA1.Reg) & 0xff
}
func (o *GPIOSD_Type) SetSIGMADELTA1_SD0_PRESCALE(value uint32) {
	volatile.StoreUint32(&o.SIGMADELTA1.Reg, volatile.LoadUint32(&o.SIGMADELTA1.Reg)&^(0xff00)|value<<8)
}
func (o *GPIOSD_Type) GetSIGMADELTA1_SD0_PRESCALE() uint32 {
	return (volatile.LoadUint32(&o.SIGMADELTA1.Reg) & 0xff00) >> 8
}

// GPIOSD.SIGMADELTA2: Duty Cycle Configure Register of SDM%s
func (o *GPIOSD_Type) SetSIGMADELTA2_SD0_IN(value uint32) {
	volatile.StoreUint32(&o.SIGMADELTA2.Reg, volatile.LoadUint32(&o.SIGMADELTA2.Reg)&^(0xff)|value)
}
func (o *GPIOSD_Type) GetSIGMADELTA2_SD0_IN() uint32 {
	return volatile.LoadUint32(&o.SIGMADELTA2.Reg) & 0xff
}
func (o *GPIOSD_Type) SetSIGMADELTA2_SD0_PRESCALE(value uint32) {
	volatile.StoreUint32(&o.SIGMADELTA2.Reg, volatile.LoadUint32(&o.SIGMADELTA2.Reg)&^(0xff00)|value<<8)
}
func (o *GPIOSD_Type) GetSIGMADELTA2_SD0_PRESCALE() uint32 {
	return (volatile.LoadUint32(&o.SIGMADELTA2.Reg) & 0xff00) >> 8
}

// GPIOSD.SIGMADELTA3: Duty Cycle Configure Register of SDM%s
func (o *GPIOSD_Type) SetSIGMADELTA3_SD0_IN(value uint32) {
	volatile.StoreUint32(&o.SIGMADELTA3.Reg, volatile.LoadUint32(&o.SIGMADELTA3.Reg)&^(0xff)|value)
}
func (o *GPIOSD_Type) GetSIGMADELTA3_SD0_IN() uint32 {
	return volatile.LoadUint32(&o.SIGMADELTA3.Reg) & 0xff
}
func (o *GPIOSD_Type) SetSIGMADELTA3_SD0_PRESCALE(value uint32) {
	volatile.StoreUint32(&o.SIGMADELTA3.Reg, volatile.LoadUint32(&o.SIGMADELTA3.Reg)&^(0xff00)|value<<8)
}
func (o *GPIOSD_Type) GetSIGMADELTA3_SD0_PRESCALE() uint32 {
	return (volatile.LoadUint32(&o.SIGMADELTA3.Reg) & 0xff00) >> 8
}

// GPIOSD.SIGMADELTA_CG: Clock Gating Configure Register
func (o *GPIOSD_Type) SetSIGMADELTA_CG_CLK_EN(value uint32) {
	volatile.StoreUint32(&o.SIGMADELTA_CG.Reg, volatile.LoadUint32(&o.SIGMADELTA_CG.Reg)&^(0x80000000)|value<<31)
}
func (o *GPIOSD_Type) GetSIGMADELTA_CG_CLK_EN() uint32 {
	return (volatile.LoadUint32(&o.SIGMADELTA_CG.Reg) & 0x80000000) >> 31
}

// GPIOSD.SIGMADELTA_MISC: MISC Register
func (o *GPIOSD_Type) SetSIGMADELTA_MISC_FUNCTION_CLK_EN(value uint32) {
	volatile.StoreUint32(&o.SIGMADELTA_MISC.Reg, volatile.LoadUint32(&o.SIGMADELTA_MISC.Reg)&^(0x40000000)|value<<30)
}
func (o *GPIOSD_Type) GetSIGMADELTA_MISC_FUNCTION_CLK_EN() uint32 {
	return (volatile.LoadUint32(&o.SIGMADELTA_MISC.Reg) & 0x40000000) >> 30
}
func (o *GPIOSD_Type) SetSIGMADELTA_MISC_SPI_SWAP(value uint32) {
	volatile.StoreUint32(&o.SIGMADELTA_MISC.Reg, volatile.LoadUint32(&o.SIGMADELTA_MISC.Reg)&^(0x80000000)|value<<31)
}
func (o *GPIOSD_Type) GetSIGMADELTA_MISC_SPI_SWAP() uint32 {
	return (volatile.LoadUint32(&o.SIGMADELTA_MISC.Reg) & 0x80000000) >> 31
}

// GPIOSD.SIGMADELTA_VERSION: Version Control Register
func (o *GPIOSD_Type) SetSIGMADELTA_VERSION_GPIO_SD_DATE(value uint32) {
	volatile.StoreUint32(&o.SIGMADELTA_VERSION.Reg, volatile.LoadUint32(&o.SIGMADELTA_VERSION.Reg)&^(0xfffffff)|value)
}
func (o *GPIOSD_Type) GetSIGMADELTA_VERSION_GPIO_SD_DATE() uint32 {
	return volatile.LoadUint32(&o.SIGMADELTA_VERSION.Reg) & 0xfffffff
}

// Peripheral HMAC
type HMAC_Type struct {
	_                   [64]byte
	SET_START           volatile.Register32 // 0x40
	SET_PARA_PURPOSE    volatile.Register32 // 0x44
	SET_PARA_KEY        volatile.Register32 // 0x48
	SET_PARA_FINISH     volatile.Register32 // 0x4C
	SET_MESSAGE_ONE     volatile.Register32 // 0x50
	SET_MESSAGE_ING     volatile.Register32 // 0x54
	SET_MESSAGE_END     volatile.Register32 // 0x58
	SET_RESULT_FINISH   volatile.Register32 // 0x5C
	SET_INVALIDATE_JTAG volatile.Register32 // 0x60
	SET_INVALIDATE_DS   volatile.Register32 // 0x64
	QUERY_ERROR         volatile.Register32 // 0x68
	QUERY_BUSY          volatile.Register32 // 0x6C
	_                   [16]byte
	WR_MESSAGE_MEM      volatile.Register32 // 0x80
	_                   [60]byte
	RD_RESULT_MEM       volatile.Register32 // 0xC0
	_                   [44]byte
	SET_MESSAGE_PAD     volatile.Register32 // 0xF0
	ONE_BLOCK           volatile.Register32 // 0xF4
	SOFT_JTAG_CTRL      volatile.Register32 // 0xF8
	WR_JTAG             volatile.Register32 // 0xFC
}

// HMAC.SET_START: Process control register 0.
func (o *HMAC_Type) SetSET_START(value uint32) {
	volatile.StoreUint32(&o.SET_START.Reg, volatile.LoadUint32(&o.SET_START.Reg)&^(0x1)|value)
}
func (o *HMAC_Type) GetSET_START() uint32 {
	return volatile.LoadUint32(&o.SET_START.Reg) & 0x1
}

// HMAC.SET_PARA_PURPOSE: Configure purpose.
func (o *HMAC_Type) SetSET_PARA_PURPOSE_PURPOSE_SET(value uint32) {
	volatile.StoreUint32(&o.SET_PARA_PURPOSE.Reg, volatile.LoadUint32(&o.SET_PARA_PURPOSE.Reg)&^(0xf)|value)
}
func (o *HMAC_Type) GetSET_PARA_PURPOSE_PURPOSE_SET() uint32 {
	return volatile.LoadUint32(&o.SET_PARA_PURPOSE.Reg) & 0xf
}

// HMAC.SET_PARA_KEY: Configure key.
func (o *HMAC_Type) SetSET_PARA_KEY_KEY_SET(value uint32) {
	volatile.StoreUint32(&o.SET_PARA_KEY.Reg, volatile.LoadUint32(&o.SET_PARA_KEY.Reg)&^(0x7)|value)
}
func (o *HMAC_Type) GetSET_PARA_KEY_KEY_SET() uint32 {
	return volatile.LoadUint32(&o.SET_PARA_KEY.Reg) & 0x7
}

// HMAC.SET_PARA_FINISH: Finish initial configuration.
func (o *HMAC_Type) SetSET_PARA_FINISH_SET_PARA_END(value uint32) {
	volatile.StoreUint32(&o.SET_PARA_FINISH.Reg, volatile.LoadUint32(&o.SET_PARA_FINISH.Reg)&^(0x1)|value)
}
func (o *HMAC_Type) GetSET_PARA_FINISH_SET_PARA_END() uint32 {
	return volatile.LoadUint32(&o.SET_PARA_FINISH.Reg) & 0x1
}

// HMAC.SET_MESSAGE_ONE: Process control register 1.
func (o *HMAC_Type) SetSET_MESSAGE_ONE_SET_TEXT_ONE(value uint32) {
	volatile.StoreUint32(&o.SET_MESSAGE_ONE.Reg, volatile.LoadUint32(&o.SET_MESSAGE_ONE.Reg)&^(0x1)|value)
}
func (o *HMAC_Type) GetSET_MESSAGE_ONE_SET_TEXT_ONE() uint32 {
	return volatile.LoadUint32(&o.SET_MESSAGE_ONE.Reg) & 0x1
}

// HMAC.SET_MESSAGE_ING: Process control register 2.
func (o *HMAC_Type) SetSET_MESSAGE_ING_SET_TEXT_ING(value uint32) {
	volatile.StoreUint32(&o.SET_MESSAGE_ING.Reg, volatile.LoadUint32(&o.SET_MESSAGE_ING.Reg)&^(0x1)|value)
}
func (o *HMAC_Type) GetSET_MESSAGE_ING_SET_TEXT_ING() uint32 {
	return volatile.LoadUint32(&o.SET_MESSAGE_ING.Reg) & 0x1
}

// HMAC.SET_MESSAGE_END: Process control register 3.
func (o *HMAC_Type) SetSET_MESSAGE_END_SET_TEXT_END(value uint32) {
	volatile.StoreUint32(&o.SET_MESSAGE_END.Reg, volatile.LoadUint32(&o.SET_MESSAGE_END.Reg)&^(0x1)|value)
}
func (o *HMAC_Type) GetSET_MESSAGE_END_SET_TEXT_END() uint32 {
	return volatile.LoadUint32(&o.SET_MESSAGE_END.Reg) & 0x1
}

// HMAC.SET_RESULT_FINISH: Process control register 4.
func (o *HMAC_Type) SetSET_RESULT_FINISH_SET_RESULT_END(value uint32) {
	volatile.StoreUint32(&o.SET_RESULT_FINISH.Reg, volatile.LoadUint32(&o.SET_RESULT_FINISH.Reg)&^(0x1)|value)
}
func (o *HMAC_Type) GetSET_RESULT_FINISH_SET_RESULT_END() uint32 {
	return volatile.LoadUint32(&o.SET_RESULT_FINISH.Reg) & 0x1
}

// HMAC.SET_INVALIDATE_JTAG: Invalidate register 0.
func (o *HMAC_Type) SetSET_INVALIDATE_JTAG(value uint32) {
	volatile.StoreUint32(&o.SET_INVALIDATE_JTAG.Reg, volatile.LoadUint32(&o.SET_INVALIDATE_JTAG.Reg)&^(0x1)|value)
}
func (o *HMAC_Type) GetSET_INVALIDATE_JTAG() uint32 {
	return volatile.LoadUint32(&o.SET_INVALIDATE_JTAG.Reg) & 0x1
}

// HMAC.SET_INVALIDATE_DS: Invalidate register 1.
func (o *HMAC_Type) SetSET_INVALIDATE_DS(value uint32) {
	volatile.StoreUint32(&o.SET_INVALIDATE_DS.Reg, volatile.LoadUint32(&o.SET_INVALIDATE_DS.Reg)&^(0x1)|value)
}
func (o *HMAC_Type) GetSET_INVALIDATE_DS() uint32 {
	return volatile.LoadUint32(&o.SET_INVALIDATE_DS.Reg) & 0x1
}

// HMAC.QUERY_ERROR: Error register.
func (o *HMAC_Type) SetQUERY_ERROR_QUREY_CHECK(value uint32) {
	volatile.StoreUint32(&o.QUERY_ERROR.Reg, volatile.LoadUint32(&o.QUERY_ERROR.Reg)&^(0x1)|value)
}
func (o *HMAC_Type) GetQUERY_ERROR_QUREY_CHECK() uint32 {
	return volatile.LoadUint32(&o.QUERY_ERROR.Reg) & 0x1
}

// HMAC.QUERY_BUSY: Busy register.
func (o *HMAC_Type) SetQUERY_BUSY_BUSY_STATE(value uint32) {
	volatile.StoreUint32(&o.QUERY_BUSY.Reg, volatile.LoadUint32(&o.QUERY_BUSY.Reg)&^(0x1)|value)
}
func (o *HMAC_Type) GetQUERY_BUSY_BUSY_STATE() uint32 {
	return volatile.LoadUint32(&o.QUERY_BUSY.Reg) & 0x1
}

// HMAC.SET_MESSAGE_PAD: Process control register 5.
func (o *HMAC_Type) SetSET_MESSAGE_PAD_SET_TEXT_PAD(value uint32) {
	volatile.StoreUint32(&o.SET_MESSAGE_PAD.Reg, volatile.LoadUint32(&o.SET_MESSAGE_PAD.Reg)&^(0x1)|value)
}
func (o *HMAC_Type) GetSET_MESSAGE_PAD_SET_TEXT_PAD() uint32 {
	return volatile.LoadUint32(&o.SET_MESSAGE_PAD.Reg) & 0x1
}

// HMAC.ONE_BLOCK: Process control register 6.
func (o *HMAC_Type) SetONE_BLOCK_SET_ONE_BLOCK(value uint32) {
	volatile.StoreUint32(&o.ONE_BLOCK.Reg, volatile.LoadUint32(&o.ONE_BLOCK.Reg)&^(0x1)|value)
}
func (o *HMAC_Type) GetONE_BLOCK_SET_ONE_BLOCK() uint32 {
	return volatile.LoadUint32(&o.ONE_BLOCK.Reg) & 0x1
}

// HMAC.SOFT_JTAG_CTRL: Jtag register 0.
func (o *HMAC_Type) SetSOFT_JTAG_CTRL(value uint32) {
	volatile.StoreUint32(&o.SOFT_JTAG_CTRL.Reg, volatile.LoadUint32(&o.SOFT_JTAG_CTRL.Reg)&^(0x1)|value)
}
func (o *HMAC_Type) GetSOFT_JTAG_CTRL() uint32 {
	return volatile.LoadUint32(&o.SOFT_JTAG_CTRL.Reg) & 0x1
}

// HMAC.WR_JTAG: Jtag register 1.
func (o *HMAC_Type) SetWR_JTAG(value uint32) {
	volatile.StoreUint32(&o.WR_JTAG.Reg, value)
}
func (o *HMAC_Type) GetWR_JTAG() uint32 {
	return volatile.LoadUint32(&o.WR_JTAG.Reg)
}

// Peripheral I2C
type I2C_Type struct {
	SCL_LOW_PERIOD       volatile.Register32 // 0x0
	CTR                  volatile.Register32 // 0x4
	SR                   volatile.Register32 // 0x8
	TO                   volatile.Register32 // 0xC
	SLAVE_ADDR           volatile.Register32 // 0x10
	FIFO_ST              volatile.Register32 // 0x14
	FIFO_CONF            volatile.Register32 // 0x18
	FIFO_DATA            volatile.Register32 // 0x1C
	INT_RAW              volatile.Register32 // 0x20
	INT_CLR              volatile.Register32 // 0x24
	INT_ENA              volatile.Register32 // 0x28
	INT_STATUS           volatile.Register32 // 0x2C
	SDA_HOLD             volatile.Register32 // 0x30
	SDA_SAMPLE           volatile.Register32 // 0x34
	SCL_HIGH_PERIOD      volatile.Register32 // 0x38
	_                    [4]byte
	SCL_START_HOLD       volatile.Register32 // 0x40
	SCL_RSTART_SETUP     volatile.Register32 // 0x44
	SCL_STOP_HOLD        volatile.Register32 // 0x48
	SCL_STOP_SETUP       volatile.Register32 // 0x4C
	FILTER_CFG           volatile.Register32 // 0x50
	CLK_CONF             volatile.Register32 // 0x54
	COMD0                volatile.Register32 // 0x58
	COMD1                volatile.Register32 // 0x5C
	COMD2                volatile.Register32 // 0x60
	COMD3                volatile.Register32 // 0x64
	COMD4                volatile.Register32 // 0x68
	COMD5                volatile.Register32 // 0x6C
	COMD6                volatile.Register32 // 0x70
	COMD7                volatile.Register32 // 0x74
	SCL_ST_TIME_OUT      volatile.Register32 // 0x78
	SCL_MAIN_ST_TIME_OUT volatile.Register32 // 0x7C
	SCL_SP_CONF          volatile.Register32 // 0x80
	SCL_STRETCH_CONF     volatile.Register32 // 0x84
	_                    [112]byte
	DATE                 volatile.Register32 // 0xF8
	_                    [4]byte
	TXFIFO_START_ADDR    volatile.Register32 // 0x100
	_                    [124]byte
	RXFIFO_START_ADDR    volatile.Register32 // 0x180
}

// I2C.SCL_LOW_PERIOD: I2C_SCL_LOW_PERIOD_REG
func (o *I2C_Type) SetSCL_LOW_PERIOD(value uint32) {
	volatile.StoreUint32(&o.SCL_LOW_PERIOD.Reg, volatile.LoadUint32(&o.SCL_LOW_PERIOD.Reg)&^(0x1ff)|value)
}
func (o *I2C_Type) GetSCL_LOW_PERIOD() uint32 {
	return volatile.LoadUint32(&o.SCL_LOW_PERIOD.Reg) & 0x1ff
}

// I2C.CTR: I2C_CTR_REG
func (o *I2C_Type) SetCTR_SDA_FORCE_OUT(value uint32) {
	volatile.StoreUint32(&o.CTR.Reg, volatile.LoadUint32(&o.CTR.Reg)&^(0x1)|value)
}
func (o *I2C_Type) GetCTR_SDA_FORCE_OUT() uint32 {
	return volatile.LoadUint32(&o.CTR.Reg) & 0x1
}
func (o *I2C_Type) SetCTR_SCL_FORCE_OUT(value uint32) {
	volatile.StoreUint32(&o.CTR.Reg, volatile.LoadUint32(&o.CTR.Reg)&^(0x2)|value<<1)
}
func (o *I2C_Type) GetCTR_SCL_FORCE_OUT() uint32 {
	return (volatile.LoadUint32(&o.CTR.Reg) & 0x2) >> 1
}
func (o *I2C_Type) SetCTR_SAMPLE_SCL_LEVEL(value uint32) {
	volatile.StoreUint32(&o.CTR.Reg, volatile.LoadUint32(&o.CTR.Reg)&^(0x4)|value<<2)
}
func (o *I2C_Type) GetCTR_SAMPLE_SCL_LEVEL() uint32 {
	return (volatile.LoadUint32(&o.CTR.Reg) & 0x4) >> 2
}
func (o *I2C_Type) SetCTR_RX_FULL_ACK_LEVEL(value uint32) {
	volatile.StoreUint32(&o.CTR.Reg, volatile.LoadUint32(&o.CTR.Reg)&^(0x8)|value<<3)
}
func (o *I2C_Type) GetCTR_RX_FULL_ACK_LEVEL() uint32 {
	return (volatile.LoadUint32(&o.CTR.Reg) & 0x8) >> 3
}
func (o *I2C_Type) SetCTR_MS_MODE(value uint32) {
	volatile.StoreUint32(&o.CTR.Reg, volatile.LoadUint32(&o.CTR.Reg)&^(0x10)|value<<4)
}
func (o *I2C_Type) GetCTR_MS_MODE() uint32 {
	return (volatile.LoadUint32(&o.CTR.Reg) & 0x10) >> 4
}
func (o *I2C_Type) SetCTR_TRANS_START(value uint32) {
	volatile.StoreUint32(&o.CTR.Reg, volatile.LoadUint32(&o.CTR.Reg)&^(0x20)|value<<5)
}
func (o *I2C_Type) GetCTR_TRANS_START() uint32 {
	return (volatile.LoadUint32(&o.CTR.Reg) & 0x20) >> 5
}
func (o *I2C_Type) SetCTR_TX_LSB_FIRST(value uint32) {
	volatile.StoreUint32(&o.CTR.Reg, volatile.LoadUint32(&o.CTR.Reg)&^(0x40)|value<<6)
}
func (o *I2C_Type) GetCTR_TX_LSB_FIRST() uint32 {
	return (volatile.LoadUint32(&o.CTR.Reg) & 0x40) >> 6
}
func (o *I2C_Type) SetCTR_RX_LSB_FIRST(value uint32) {
	volatile.StoreUint32(&o.CTR.Reg, volatile.LoadUint32(&o.CTR.Reg)&^(0x80)|value<<7)
}
func (o *I2C_Type) GetCTR_RX_LSB_FIRST() uint32 {
	return (volatile.LoadUint32(&o.CTR.Reg) & 0x80) >> 7
}
func (o *I2C_Type) SetCTR_CLK_EN(value uint32) {
	volatile.StoreUint32(&o.CTR.Reg, volatile.LoadUint32(&o.CTR.Reg)&^(0x100)|value<<8)
}
func (o *I2C_Type) GetCTR_CLK_EN() uint32 {
	return (volatile.LoadUint32(&o.CTR.Reg) & 0x100) >> 8
}
func (o *I2C_Type) SetCTR_ARBITRATION_EN(value uint32) {
	volatile.StoreUint32(&o.CTR.Reg, volatile.LoadUint32(&o.CTR.Reg)&^(0x200)|value<<9)
}
func (o *I2C_Type) GetCTR_ARBITRATION_EN() uint32 {
	return (volatile.LoadUint32(&o.CTR.Reg) & 0x200) >> 9
}
func (o *I2C_Type) SetCTR_FSM_RST(value uint32) {
	volatile.StoreUint32(&o.CTR.Reg, volatile.LoadUint32(&o.CTR.Reg)&^(0x400)|value<<10)
}
func (o *I2C_Type) GetCTR_FSM_RST() uint32 {
	return (volatile.LoadUint32(&o.CTR.Reg) & 0x400) >> 10
}
func (o *I2C_Type) SetCTR_CONF_UPGATE(value uint32) {
	volatile.StoreUint32(&o.CTR.Reg, volatile.LoadUint32(&o.CTR.Reg)&^(0x800)|value<<11)
}
func (o *I2C_Type) GetCTR_CONF_UPGATE() uint32 {
	return (volatile.LoadUint32(&o.CTR.Reg) & 0x800) >> 11
}
func (o *I2C_Type) SetCTR_SLV_TX_AUTO_START_EN(value uint32) {
	volatile.StoreUint32(&o.CTR.Reg, volatile.LoadUint32(&o.CTR.Reg)&^(0x1000)|value<<12)
}
func (o *I2C_Type) GetCTR_SLV_TX_AUTO_START_EN() uint32 {
	return (volatile.LoadUint32(&o.CTR.Reg) & 0x1000) >> 12
}
func (o *I2C_Type) SetCTR_ADDR_10BIT_RW_CHECK_EN(value uint32) {
	volatile.StoreUint32(&o.CTR.Reg, volatile.LoadUint32(&o.CTR.Reg)&^(0x2000)|value<<13)
}
func (o *I2C_Type) GetCTR_ADDR_10BIT_RW_CHECK_EN() uint32 {
	return (volatile.LoadUint32(&o.CTR.Reg) & 0x2000) >> 13
}
func (o *I2C_Type) SetCTR_ADDR_BROADCASTING_EN(value uint32) {
	volatile.StoreUint32(&o.CTR.Reg, volatile.LoadUint32(&o.CTR.Reg)&^(0x4000)|value<<14)
}
func (o *I2C_Type) GetCTR_ADDR_BROADCASTING_EN() uint32 {
	return (volatile.LoadUint32(&o.CTR.Reg) & 0x4000) >> 14
}

// I2C.SR: I2C_SR_REG
func (o *I2C_Type) SetSR_RESP_REC(value uint32) {
	volatile.StoreUint32(&o.SR.Reg, volatile.LoadUint32(&o.SR.Reg)&^(0x1)|value)
}
func (o *I2C_Type) GetSR_RESP_REC() uint32 {
	return volatile.LoadUint32(&o.SR.Reg) & 0x1
}
func (o *I2C_Type) SetSR_SLAVE_RW(value uint32) {
	volatile.StoreUint32(&o.SR.Reg, volatile.LoadUint32(&o.SR.Reg)&^(0x2)|value<<1)
}
func (o *I2C_Type) GetSR_SLAVE_RW() uint32 {
	return (volatile.LoadUint32(&o.SR.Reg) & 0x2) >> 1
}
func (o *I2C_Type) SetSR_ARB_LOST(value uint32) {
	volatile.StoreUint32(&o.SR.Reg, volatile.LoadUint32(&o.SR.Reg)&^(0x8)|value<<3)
}
func (o *I2C_Type) GetSR_ARB_LOST() uint32 {
	return (volatile.LoadUint32(&o.SR.Reg) & 0x8) >> 3
}
func (o *I2C_Type) SetSR_BUS_BUSY(value uint32) {
	volatile.StoreUint32(&o.SR.Reg, volatile.LoadUint32(&o.SR.Reg)&^(0x10)|value<<4)
}
func (o *I2C_Type) GetSR_BUS_BUSY() uint32 {
	return (volatile.LoadUint32(&o.SR.Reg) & 0x10) >> 4
}
func (o *I2C_Type) SetSR_SLAVE_ADDRESSED(value uint32) {
	volatile.StoreUint32(&o.SR.Reg, volatile.LoadUint32(&o.SR.Reg)&^(0x20)|value<<5)
}
func (o *I2C_Type) GetSR_SLAVE_ADDRESSED() uint32 {
	return (volatile.LoadUint32(&o.SR.Reg) & 0x20) >> 5
}
func (o *I2C_Type) SetSR_RXFIFO_CNT(value uint32) {
	volatile.StoreUint32(&o.SR.Reg, volatile.LoadUint32(&o.SR.Reg)&^(0x3f00)|value<<8)
}
func (o *I2C_Type) GetSR_RXFIFO_CNT() uint32 {
	return (volatile.LoadUint32(&o.SR.Reg) & 0x3f00) >> 8
}
func (o *I2C_Type) SetSR_STRETCH_CAUSE(value uint32) {
	volatile.StoreUint32(&o.SR.Reg, volatile.LoadUint32(&o.SR.Reg)&^(0xc000)|value<<14)
}
func (o *I2C_Type) GetSR_STRETCH_CAUSE() uint32 {
	return (volatile.LoadUint32(&o.SR.Reg) & 0xc000) >> 14
}
func (o *I2C_Type) SetSR_TXFIFO_CNT(value uint32) {
	volatile.StoreUint32(&o.SR.Reg, volatile.LoadUint32(&o.SR.Reg)&^(0xfc0000)|value<<18)
}
func (o *I2C_Type) GetSR_TXFIFO_CNT() uint32 {
	return (volatile.LoadUint32(&o.SR.Reg) & 0xfc0000) >> 18
}
func (o *I2C_Type) SetSR_SCL_MAIN_STATE_LAST(value uint32) {
	volatile.StoreUint32(&o.SR.Reg, volatile.LoadUint32(&o.SR.Reg)&^(0x7000000)|value<<24)
}
func (o *I2C_Type) GetSR_SCL_MAIN_STATE_LAST() uint32 {
	return (volatile.LoadUint32(&o.SR.Reg) & 0x7000000) >> 24
}
func (o *I2C_Type) SetSR_SCL_STATE_LAST(value uint32) {
	volatile.StoreUint32(&o.SR.Reg, volatile.LoadUint32(&o.SR.Reg)&^(0x70000000)|value<<28)
}
func (o *I2C_Type) GetSR_SCL_STATE_LAST() uint32 {
	return (volatile.LoadUint32(&o.SR.Reg) & 0x70000000) >> 28
}

// I2C.TO: I2C_TO_REG
func (o *I2C_Type) SetTO_TIME_OUT_VALUE(value uint32) {
	volatile.StoreUint32(&o.TO.Reg, volatile.LoadUint32(&o.TO.Reg)&^(0x1f)|value)
}
func (o *I2C_Type) GetTO_TIME_OUT_VALUE() uint32 {
	return volatile.LoadUint32(&o.TO.Reg) & 0x1f
}
func (o *I2C_Type) SetTO_TIME_OUT_EN(value uint32) {
	volatile.StoreUint32(&o.TO.Reg, volatile.LoadUint32(&o.TO.Reg)&^(0x20)|value<<5)
}
func (o *I2C_Type) GetTO_TIME_OUT_EN() uint32 {
	return (volatile.LoadUint32(&o.TO.Reg) & 0x20) >> 5
}

// I2C.SLAVE_ADDR: I2C_SLAVE_ADDR_REG
func (o *I2C_Type) SetSLAVE_ADDR(value uint32) {
	volatile.StoreUint32(&o.SLAVE_ADDR.Reg, volatile.LoadUint32(&o.SLAVE_ADDR.Reg)&^(0x7fff)|value)
}
func (o *I2C_Type) GetSLAVE_ADDR() uint32 {
	return volatile.LoadUint32(&o.SLAVE_ADDR.Reg) & 0x7fff
}
func (o *I2C_Type) SetSLAVE_ADDR_ADDR_10BIT_EN(value uint32) {
	volatile.StoreUint32(&o.SLAVE_ADDR.Reg, volatile.LoadUint32(&o.SLAVE_ADDR.Reg)&^(0x80000000)|value<<31)
}
func (o *I2C_Type) GetSLAVE_ADDR_ADDR_10BIT_EN() uint32 {
	return (volatile.LoadUint32(&o.SLAVE_ADDR.Reg) & 0x80000000) >> 31
}

// I2C.FIFO_ST: I2C_FIFO_ST_REG
func (o *I2C_Type) SetFIFO_ST_RXFIFO_RADDR(value uint32) {
	volatile.StoreUint32(&o.FIFO_ST.Reg, volatile.LoadUint32(&o.FIFO_ST.Reg)&^(0x1f)|value)
}
func (o *I2C_Type) GetFIFO_ST_RXFIFO_RADDR() uint32 {
	return volatile.LoadUint32(&o.FIFO_ST.Reg) & 0x1f
}
func (o *I2C_Type) SetFIFO_ST_RXFIFO_WADDR(value uint32) {
	volatile.StoreUint32(&o.FIFO_ST.Reg, volatile.LoadUint32(&o.FIFO_ST.Reg)&^(0x3e0)|value<<5)
}
func (o *I2C_Type) GetFIFO_ST_RXFIFO_WADDR() uint32 {
	return (volatile.LoadUint32(&o.FIFO_ST.Reg) & 0x3e0) >> 5
}
func (o *I2C_Type) SetFIFO_ST_TXFIFO_RADDR(value uint32) {
	volatile.StoreUint32(&o.FIFO_ST.Reg, volatile.LoadUint32(&o.FIFO_ST.Reg)&^(0x7c00)|value<<10)
}
func (o *I2C_Type) GetFIFO_ST_TXFIFO_RADDR() uint32 {
	return (volatile.LoadUint32(&o.FIFO_ST.Reg) & 0x7c00) >> 10
}
func (o *I2C_Type) SetFIFO_ST_TXFIFO_WADDR(value uint32) {
	volatile.StoreUint32(&o.FIFO_ST.Reg, volatile.LoadUint32(&o.FIFO_ST.Reg)&^(0xf8000)|value<<15)
}
func (o *I2C_Type) GetFIFO_ST_TXFIFO_WADDR() uint32 {
	return (volatile.LoadUint32(&o.FIFO_ST.Reg) & 0xf8000) >> 15
}
func (o *I2C_Type) SetFIFO_ST_SLAVE_RW_POINT(value uint32) {
	volatile.StoreUint32(&o.FIFO_ST.Reg, volatile.LoadUint32(&o.FIFO_ST.Reg)&^(0x3fc00000)|value<<22)
}
func (o *I2C_Type) GetFIFO_ST_SLAVE_RW_POINT() uint32 {
	return (volatile.LoadUint32(&o.FIFO_ST.Reg) & 0x3fc00000) >> 22
}

// I2C.FIFO_CONF: I2C_FIFO_CONF_REG
func (o *I2C_Type) SetFIFO_CONF_RXFIFO_WM_THRHD(value uint32) {
	volatile.StoreUint32(&o.FIFO_CONF.Reg, volatile.LoadUint32(&o.FIFO_CONF.Reg)&^(0x1f)|value)
}
func (o *I2C_Type) GetFIFO_CONF_RXFIFO_WM_THRHD() uint32 {
	return volatile.LoadUint32(&o.FIFO_CONF.Reg) & 0x1f
}
func (o *I2C_Type) SetFIFO_CONF_TXFIFO_WM_THRHD(value uint32) {
	volatile.StoreUint32(&o.FIFO_CONF.Reg, volatile.LoadUint32(&o.FIFO_CONF.Reg)&^(0x3e0)|value<<5)
}
func (o *I2C_Type) GetFIFO_CONF_TXFIFO_WM_THRHD() uint32 {
	return (volatile.LoadUint32(&o.FIFO_CONF.Reg) & 0x3e0) >> 5
}
func (o *I2C_Type) SetFIFO_CONF_NONFIFO_EN(value uint32) {
	volatile.StoreUint32(&o.FIFO_CONF.Reg, volatile.LoadUint32(&o.FIFO_CONF.Reg)&^(0x400)|value<<10)
}
func (o *I2C_Type) GetFIFO_CONF_NONFIFO_EN() uint32 {
	return (volatile.LoadUint32(&o.FIFO_CONF.Reg) & 0x400) >> 10
}
func (o *I2C_Type) SetFIFO_CONF_FIFO_ADDR_CFG_EN(value uint32) {
	volatile.StoreUint32(&o.FIFO_CONF.Reg, volatile.LoadUint32(&o.FIFO_CONF.Reg)&^(0x800)|value<<11)
}
func (o *I2C_Type) GetFIFO_CONF_FIFO_ADDR_CFG_EN() uint32 {
	return (volatile.LoadUint32(&o.FIFO_CONF.Reg) & 0x800) >> 11
}
func (o *I2C_Type) SetFIFO_CONF_RX_FIFO_RST(value uint32) {
	volatile.StoreUint32(&o.FIFO_CONF.Reg, volatile.LoadUint32(&o.FIFO_CONF.Reg)&^(0x1000)|value<<12)
}
func (o *I2C_Type) GetFIFO_CONF_RX_FIFO_RST() uint32 {
	return (volatile.LoadUint32(&o.FIFO_CONF.Reg) & 0x1000) >> 12
}
func (o *I2C_Type) SetFIFO_CONF_TX_FIFO_RST(value uint32) {
	volatile.StoreUint32(&o.FIFO_CONF.Reg, volatile.LoadUint32(&o.FIFO_CONF.Reg)&^(0x2000)|value<<13)
}
func (o *I2C_Type) GetFIFO_CONF_TX_FIFO_RST() uint32 {
	return (volatile.LoadUint32(&o.FIFO_CONF.Reg) & 0x2000) >> 13
}
func (o *I2C_Type) SetFIFO_CONF_FIFO_PRT_EN(value uint32) {
	volatile.StoreUint32(&o.FIFO_CONF.Reg, volatile.LoadUint32(&o.FIFO_CONF.Reg)&^(0x4000)|value<<14)
}
func (o *I2C_Type) GetFIFO_CONF_FIFO_PRT_EN() uint32 {
	return (volatile.LoadUint32(&o.FIFO_CONF.Reg) & 0x4000) >> 14
}

// I2C.FIFO_DATA: I2C_FIFO_DATA_REG
func (o *I2C_Type) SetFIFO_DATA_FIFO_RDATA(value uint32) {
	volatile.StoreUint32(&o.FIFO_DATA.Reg, volatile.LoadUint32(&o.FIFO_DATA.Reg)&^(0xff)|value)
}
func (o *I2C_Type) GetFIFO_DATA_FIFO_RDATA() uint32 {
	return volatile.LoadUint32(&o.FIFO_DATA.Reg) & 0xff
}

// I2C.INT_RAW: I2C_INT_RAW_REG
func (o *I2C_Type) SetINT_RAW_RXFIFO_WM_INT_RAW(value uint32) {
	volatile.StoreUint32(&o.INT_RAW.Reg, volatile.LoadUint32(&o.INT_RAW.Reg)&^(0x1)|value)
}
func (o *I2C_Type) GetINT_RAW_RXFIFO_WM_INT_RAW() uint32 {
	return volatile.LoadUint32(&o.INT_RAW.Reg) & 0x1
}
func (o *I2C_Type) SetINT_RAW_TXFIFO_WM_INT_RAW(value uint32) {
	volatile.StoreUint32(&o.INT_RAW.Reg, volatile.LoadUint32(&o.INT_RAW.Reg)&^(0x2)|value<<1)
}
func (o *I2C_Type) GetINT_RAW_TXFIFO_WM_INT_RAW() uint32 {
	return (volatile.LoadUint32(&o.INT_RAW.Reg) & 0x2) >> 1
}
func (o *I2C_Type) SetINT_RAW_RXFIFO_OVF_INT_RAW(value uint32) {
	volatile.StoreUint32(&o.INT_RAW.Reg, volatile.LoadUint32(&o.INT_RAW.Reg)&^(0x4)|value<<2)
}
func (o *I2C_Type) GetINT_RAW_RXFIFO_OVF_INT_RAW() uint32 {
	return (volatile.LoadUint32(&o.INT_RAW.Reg) & 0x4) >> 2
}
func (o *I2C_Type) SetINT_RAW_END_DETECT_INT_RAW(value uint32) {
	volatile.StoreUint32(&o.INT_RAW.Reg, volatile.LoadUint32(&o.INT_RAW.Reg)&^(0x8)|value<<3)
}
func (o *I2C_Type) GetINT_RAW_END_DETECT_INT_RAW() uint32 {
	return (volatile.LoadUint32(&o.INT_RAW.Reg) & 0x8) >> 3
}
func (o *I2C_Type) SetINT_RAW_BYTE_TRANS_DONE_INT_RAW(value uint32) {
	volatile.StoreUint32(&o.INT_RAW.Reg, volatile.LoadUint32(&o.INT_RAW.Reg)&^(0x10)|value<<4)
}
func (o *I2C_Type) GetINT_RAW_BYTE_TRANS_DONE_INT_RAW() uint32 {
	return (volatile.LoadUint32(&o.INT_RAW.Reg) & 0x10) >> 4
}
func (o *I2C_Type) SetINT_RAW_ARBITRATION_LOST_INT_RAW(value uint32) {
	volatile.StoreUint32(&o.INT_RAW.Reg, volatile.LoadUint32(&o.INT_RAW.Reg)&^(0x20)|value<<5)
}
func (o *I2C_Type) GetINT_RAW_ARBITRATION_LOST_INT_RAW() uint32 {
	return (volatile.LoadUint32(&o.INT_RAW.Reg) & 0x20) >> 5
}
func (o *I2C_Type) SetINT_RAW_MST_TXFIFO_UDF_INT_RAW(value uint32) {
	volatile.StoreUint32(&o.INT_RAW.Reg, volatile.LoadUint32(&o.INT_RAW.Reg)&^(0x40)|value<<6)
}
func (o *I2C_Type) GetINT_RAW_MST_TXFIFO_UDF_INT_RAW() uint32 {
	return (volatile.LoadUint32(&o.INT_RAW.Reg) & 0x40) >> 6
}
func (o *I2C_Type) SetINT_RAW_TRANS_COMPLETE_INT_RAW(value uint32) {
	volatile.StoreUint32(&o.INT_RAW.Reg, volatile.LoadUint32(&o.INT_RAW.Reg)&^(0x80)|value<<7)
}
func (o *I2C_Type) GetINT_RAW_TRANS_COMPLETE_INT_RAW() uint32 {
	return (volatile.LoadUint32(&o.INT_RAW.Reg) & 0x80) >> 7
}
func (o *I2C_Type) SetINT_RAW_TIME_OUT_INT_RAW(value uint32) {
	volatile.StoreUint32(&o.INT_RAW.Reg, volatile.LoadUint32(&o.INT_RAW.Reg)&^(0x100)|value<<8)
}
func (o *I2C_Type) GetINT_RAW_TIME_OUT_INT_RAW() uint32 {
	return (volatile.LoadUint32(&o.INT_RAW.Reg) & 0x100) >> 8
}
func (o *I2C_Type) SetINT_RAW_TRANS_START_INT_RAW(value uint32) {
	volatile.StoreUint32(&o.INT_RAW.Reg, volatile.LoadUint32(&o.INT_RAW.Reg)&^(0x200)|value<<9)
}
func (o *I2C_Type) GetINT_RAW_TRANS_START_INT_RAW() uint32 {
	return (volatile.LoadUint32(&o.INT_RAW.Reg) & 0x200) >> 9
}
func (o *I2C_Type) SetINT_RAW_NACK_INT_RAW(value uint32) {
	volatile.StoreUint32(&o.INT_RAW.Reg, volatile.LoadUint32(&o.INT_RAW.Reg)&^(0x400)|value<<10)
}
func (o *I2C_Type) GetINT_RAW_NACK_INT_RAW() uint32 {
	return (volatile.LoadUint32(&o.INT_RAW.Reg) & 0x400) >> 10
}
func (o *I2C_Type) SetINT_RAW_TXFIFO_OVF_INT_RAW(value uint32) {
	volatile.StoreUint32(&o.INT_RAW.Reg, volatile.LoadUint32(&o.INT_RAW.Reg)&^(0x800)|value<<11)
}
func (o *I2C_Type) GetINT_RAW_TXFIFO_OVF_INT_RAW() uint32 {
	return (volatile.LoadUint32(&o.INT_RAW.Reg) & 0x800) >> 11
}
func (o *I2C_Type) SetINT_RAW_RXFIFO_UDF_INT_RAW(value uint32) {
	volatile.StoreUint32(&o.INT_RAW.Reg, volatile.LoadUint32(&o.INT_RAW.Reg)&^(0x1000)|value<<12)
}
func (o *I2C_Type) GetINT_RAW_RXFIFO_UDF_INT_RAW() uint32 {
	return (volatile.LoadUint32(&o.INT_RAW.Reg) & 0x1000) >> 12
}
func (o *I2C_Type) SetINT_RAW_SCL_ST_TO_INT_RAW(value uint32) {
	volatile.StoreUint32(&o.INT_RAW.Reg, volatile.LoadUint32(&o.INT_RAW.Reg)&^(0x2000)|value<<13)
}
func (o *I2C_Type) GetINT_RAW_SCL_ST_TO_INT_RAW() uint32 {
	return (volatile.LoadUint32(&o.INT_RAW.Reg) & 0x2000) >> 13
}
func (o *I2C_Type) SetINT_RAW_SCL_MAIN_ST_TO_INT_RAW(value uint32) {
	volatile.StoreUint32(&o.INT_RAW.Reg, volatile.LoadUint32(&o.INT_RAW.Reg)&^(0x4000)|value<<14)
}
func (o *I2C_Type) GetINT_RAW_SCL_MAIN_ST_TO_INT_RAW() uint32 {
	return (volatile.LoadUint32(&o.INT_RAW.Reg) & 0x4000) >> 14
}
func (o *I2C_Type) SetINT_RAW_DET_START_INT_RAW(value uint32) {
	volatile.StoreUint32(&o.INT_RAW.Reg, volatile.LoadUint32(&o.INT_RAW.Reg)&^(0x8000)|value<<15)
}
func (o *I2C_Type) GetINT_RAW_DET_START_INT_RAW() uint32 {
	return (volatile.LoadUint32(&o.INT_RAW.Reg) & 0x8000) >> 15
}
func (o *I2C_Type) SetINT_RAW_SLAVE_STRETCH_INT_RAW(value uint32) {
	volatile.StoreUint32(&o.INT_RAW.Reg, volatile.LoadUint32(&o.INT_RAW.Reg)&^(0x10000)|value<<16)
}
func (o *I2C_Type) GetINT_RAW_SLAVE_STRETCH_INT_RAW() uint32 {
	return (volatile.LoadUint32(&o.INT_RAW.Reg) & 0x10000) >> 16
}
func (o *I2C_Type) SetINT_RAW_GENERAL_CALL_INT_RAW(value uint32) {
	volatile.StoreUint32(&o.INT_RAW.Reg, volatile.LoadUint32(&o.INT_RAW.Reg)&^(0x20000)|value<<17)
}
func (o *I2C_Type) GetINT_RAW_GENERAL_CALL_INT_RAW() uint32 {
	return (volatile.LoadUint32(&o.INT_RAW.Reg) & 0x20000) >> 17
}

// I2C.INT_CLR: I2C_INT_CLR_REG
func (o *I2C_Type) SetINT_CLR_RXFIFO_WM_INT_CLR(value uint32) {
	volatile.StoreUint32(&o.INT_CLR.Reg, volatile.LoadUint32(&o.INT_CLR.Reg)&^(0x1)|value)
}
func (o *I2C_Type) GetINT_CLR_RXFIFO_WM_INT_CLR() uint32 {
	return volatile.LoadUint32(&o.INT_CLR.Reg) & 0x1
}
func (o *I2C_Type) SetINT_CLR_TXFIFO_WM_INT_CLR(value uint32) {
	volatile.StoreUint32(&o.INT_CLR.Reg, volatile.LoadUint32(&o.INT_CLR.Reg)&^(0x2)|value<<1)
}
func (o *I2C_Type) GetINT_CLR_TXFIFO_WM_INT_CLR() uint32 {
	return (volatile.LoadUint32(&o.INT_CLR.Reg) & 0x2) >> 1
}
func (o *I2C_Type) SetINT_CLR_RXFIFO_OVF_INT_CLR(value uint32) {
	volatile.StoreUint32(&o.INT_CLR.Reg, volatile.LoadUint32(&o.INT_CLR.Reg)&^(0x4)|value<<2)
}
func (o *I2C_Type) GetINT_CLR_RXFIFO_OVF_INT_CLR() uint32 {
	return (volatile.LoadUint32(&o.INT_CLR.Reg) & 0x4) >> 2
}
func (o *I2C_Type) SetINT_CLR_END_DETECT_INT_CLR(value uint32) {
	volatile.StoreUint32(&o.INT_CLR.Reg, volatile.LoadUint32(&o.INT_CLR.Reg)&^(0x8)|value<<3)
}
func (o *I2C_Type) GetINT_CLR_END_DETECT_INT_CLR() uint32 {
	return (volatile.LoadUint32(&o.INT_CLR.Reg) & 0x8) >> 3
}
func (o *I2C_Type) SetINT_CLR_BYTE_TRANS_DONE_INT_CLR(value uint32) {
	volatile.StoreUint32(&o.INT_CLR.Reg, volatile.LoadUint32(&o.INT_CLR.Reg)&^(0x10)|value<<4)
}
func (o *I2C_Type) GetINT_CLR_BYTE_TRANS_DONE_INT_CLR() uint32 {
	return (volatile.LoadUint32(&o.INT_CLR.Reg) & 0x10) >> 4
}
func (o *I2C_Type) SetINT_CLR_ARBITRATION_LOST_INT_CLR(value uint32) {
	volatile.StoreUint32(&o.INT_CLR.Reg, volatile.LoadUint32(&o.INT_CLR.Reg)&^(0x20)|value<<5)
}
func (o *I2C_Type) GetINT_CLR_ARBITRATION_LOST_INT_CLR() uint32 {
	return (volatile.LoadUint32(&o.INT_CLR.Reg) & 0x20) >> 5
}
func (o *I2C_Type) SetINT_CLR_MST_TXFIFO_UDF_INT_CLR(value uint32) {
	volatile.StoreUint32(&o.INT_CLR.Reg, volatile.LoadUint32(&o.INT_CLR.Reg)&^(0x40)|value<<6)
}
func (o *I2C_Type) GetINT_CLR_MST_TXFIFO_UDF_INT_CLR() uint32 {
	return (volatile.LoadUint32(&o.INT_CLR.Reg) & 0x40) >> 6
}
func (o *I2C_Type) SetINT_CLR_TRANS_COMPLETE_INT_CLR(value uint32) {
	volatile.StoreUint32(&o.INT_CLR.Reg, volatile.LoadUint32(&o.INT_CLR.Reg)&^(0x80)|value<<7)
}
func (o *I2C_Type) GetINT_CLR_TRANS_COMPLETE_INT_CLR() uint32 {
	return (volatile.LoadUint32(&o.INT_CLR.Reg) & 0x80) >> 7
}
func (o *I2C_Type) SetINT_CLR_TIME_OUT_INT_CLR(value uint32) {
	volatile.StoreUint32(&o.INT_CLR.Reg, volatile.LoadUint32(&o.INT_CLR.Reg)&^(0x100)|value<<8)
}
func (o *I2C_Type) GetINT_CLR_TIME_OUT_INT_CLR() uint32 {
	return (volatile.LoadUint32(&o.INT_CLR.Reg) & 0x100) >> 8
}
func (o *I2C_Type) SetINT_CLR_TRANS_START_INT_CLR(value uint32) {
	volatile.StoreUint32(&o.INT_CLR.Reg, volatile.LoadUint32(&o.INT_CLR.Reg)&^(0x200)|value<<9)
}
func (o *I2C_Type) GetINT_CLR_TRANS_START_INT_CLR() uint32 {
	return (volatile.LoadUint32(&o.INT_CLR.Reg) & 0x200) >> 9
}
func (o *I2C_Type) SetINT_CLR_NACK_INT_CLR(value uint32) {
	volatile.StoreUint32(&o.INT_CLR.Reg, volatile.LoadUint32(&o.INT_CLR.Reg)&^(0x400)|value<<10)
}
func (o *I2C_Type) GetINT_CLR_NACK_INT_CLR() uint32 {
	return (volatile.LoadUint32(&o.INT_CLR.Reg) & 0x400) >> 10
}
func (o *I2C_Type) SetINT_CLR_TXFIFO_OVF_INT_CLR(value uint32) {
	volatile.StoreUint32(&o.INT_CLR.Reg, volatile.LoadUint32(&o.INT_CLR.Reg)&^(0x800)|value<<11)
}
func (o *I2C_Type) GetINT_CLR_TXFIFO_OVF_INT_CLR() uint32 {
	return (volatile.LoadUint32(&o.INT_CLR.Reg) & 0x800) >> 11
}
func (o *I2C_Type) SetINT_CLR_RXFIFO_UDF_INT_CLR(value uint32) {
	volatile.StoreUint32(&o.INT_CLR.Reg, volatile.LoadUint32(&o.INT_CLR.Reg)&^(0x1000)|value<<12)
}
func (o *I2C_Type) GetINT_CLR_RXFIFO_UDF_INT_CLR() uint32 {
	return (volatile.LoadUint32(&o.INT_CLR.Reg) & 0x1000) >> 12
}
func (o *I2C_Type) SetINT_CLR_SCL_ST_TO_INT_CLR(value uint32) {
	volatile.StoreUint32(&o.INT_CLR.Reg, volatile.LoadUint32(&o.INT_CLR.Reg)&^(0x2000)|value<<13)
}
func (o *I2C_Type) GetINT_CLR_SCL_ST_TO_INT_CLR() uint32 {
	return (volatile.LoadUint32(&o.INT_CLR.Reg) & 0x2000) >> 13
}
func (o *I2C_Type) SetINT_CLR_SCL_MAIN_ST_TO_INT_CLR(value uint32) {
	volatile.StoreUint32(&o.INT_CLR.Reg, volatile.LoadUint32(&o.INT_CLR.Reg)&^(0x4000)|value<<14)
}
func (o *I2C_Type) GetINT_CLR_SCL_MAIN_ST_TO_INT_CLR() uint32 {
	return (volatile.LoadUint32(&o.INT_CLR.Reg) & 0x4000) >> 14
}
func (o *I2C_Type) SetINT_CLR_DET_START_INT_CLR(value uint32) {
	volatile.StoreUint32(&o.INT_CLR.Reg, volatile.LoadUint32(&o.INT_CLR.Reg)&^(0x8000)|value<<15)
}
func (o *I2C_Type) GetINT_CLR_DET_START_INT_CLR() uint32 {
	return (volatile.LoadUint32(&o.INT_CLR.Reg) & 0x8000) >> 15
}
func (o *I2C_Type) SetINT_CLR_SLAVE_STRETCH_INT_CLR(value uint32) {
	volatile.StoreUint32(&o.INT_CLR.Reg, volatile.LoadUint32(&o.INT_CLR.Reg)&^(0x10000)|value<<16)
}
func (o *I2C_Type) GetINT_CLR_SLAVE_STRETCH_INT_CLR() uint32 {
	return (volatile.LoadUint32(&o.INT_CLR.Reg) & 0x10000) >> 16
}
func (o *I2C_Type) SetINT_CLR_GENERAL_CALL_INT_CLR(value uint32) {
	volatile.StoreUint32(&o.INT_CLR.Reg, volatile.LoadUint32(&o.INT_CLR.Reg)&^(0x20000)|value<<17)
}
func (o *I2C_Type) GetINT_CLR_GENERAL_CALL_INT_CLR() uint32 {
	return (volatile.LoadUint32(&o.INT_CLR.Reg) & 0x20000) >> 17
}

// I2C.INT_ENA: I2C_INT_ENA_REG
func (o *I2C_Type) SetINT_ENA_RXFIFO_WM_INT_ENA(value uint32) {
	volatile.StoreUint32(&o.INT_ENA.Reg, volatile.LoadUint32(&o.INT_ENA.Reg)&^(0x1)|value)
}
func (o *I2C_Type) GetINT_ENA_RXFIFO_WM_INT_ENA() uint32 {
	return volatile.LoadUint32(&o.INT_ENA.Reg) & 0x1
}
func (o *I2C_Type) SetINT_ENA_TXFIFO_WM_INT_ENA(value uint32) {
	volatile.StoreUint32(&o.INT_ENA.Reg, volatile.LoadUint32(&o.INT_ENA.Reg)&^(0x2)|value<<1)
}
func (o *I2C_Type) GetINT_ENA_TXFIFO_WM_INT_ENA() uint32 {
	return (volatile.LoadUint32(&o.INT_ENA.Reg) & 0x2) >> 1
}
func (o *I2C_Type) SetINT_ENA_RXFIFO_OVF_INT_ENA(value uint32) {
	volatile.StoreUint32(&o.INT_ENA.Reg, volatile.LoadUint32(&o.INT_ENA.Reg)&^(0x4)|value<<2)
}
func (o *I2C_Type) GetINT_ENA_RXFIFO_OVF_INT_ENA() uint32 {
	return (volatile.LoadUint32(&o.INT_ENA.Reg) & 0x4) >> 2
}
func (o *I2C_Type) SetINT_ENA_END_DETECT_INT_ENA(value uint32) {
	volatile.StoreUint32(&o.INT_ENA.Reg, volatile.LoadUint32(&o.INT_ENA.Reg)&^(0x8)|value<<3)
}
func (o *I2C_Type) GetINT_ENA_END_DETECT_INT_ENA() uint32 {
	return (volatile.LoadUint32(&o.INT_ENA.Reg) & 0x8) >> 3
}
func (o *I2C_Type) SetINT_ENA_BYTE_TRANS_DONE_INT_ENA(value uint32) {
	volatile.StoreUint32(&o.INT_ENA.Reg, volatile.LoadUint32(&o.INT_ENA.Reg)&^(0x10)|value<<4)
}
func (o *I2C_Type) GetINT_ENA_BYTE_TRANS_DONE_INT_ENA() uint32 {
	return (volatile.LoadUint32(&o.INT_ENA.Reg) & 0x10) >> 4
}
func (o *I2C_Type) SetINT_ENA_ARBITRATION_LOST_INT_ENA(value uint32) {
	volatile.StoreUint32(&o.INT_ENA.Reg, volatile.LoadUint32(&o.INT_ENA.Reg)&^(0x20)|value<<5)
}
func (o *I2C_Type) GetINT_ENA_ARBITRATION_LOST_INT_ENA() uint32 {
	return (volatile.LoadUint32(&o.INT_ENA.Reg) & 0x20) >> 5
}
func (o *I2C_Type) SetINT_ENA_MST_TXFIFO_UDF_INT_ENA(value uint32) {
	volatile.StoreUint32(&o.INT_ENA.Reg, volatile.LoadUint32(&o.INT_ENA.Reg)&^(0x40)|value<<6)
}
func (o *I2C_Type) GetINT_ENA_MST_TXFIFO_UDF_INT_ENA() uint32 {
	return (volatile.LoadUint32(&o.INT_ENA.Reg) & 0x40) >> 6
}
func (o *I2C_Type) SetINT_ENA_TRANS_COMPLETE_INT_ENA(value uint32) {
	volatile.StoreUint32(&o.INT_ENA.Reg, volatile.LoadUint32(&o.INT_ENA.Reg)&^(0x80)|value<<7)
}
func (o *I2C_Type) GetINT_ENA_TRANS_COMPLETE_INT_ENA() uint32 {
	return (volatile.LoadUint32(&o.INT_ENA.Reg) & 0x80) >> 7
}
func (o *I2C_Type) SetINT_ENA_TIME_OUT_INT_ENA(value uint32) {
	volatile.StoreUint32(&o.INT_ENA.Reg, volatile.LoadUint32(&o.INT_ENA.Reg)&^(0x100)|value<<8)
}
func (o *I2C_Type) GetINT_ENA_TIME_OUT_INT_ENA() uint32 {
	return (volatile.LoadUint32(&o.INT_ENA.Reg) & 0x100) >> 8
}
func (o *I2C_Type) SetINT_ENA_TRANS_START_INT_ENA(value uint32) {
	volatile.StoreUint32(&o.INT_ENA.Reg, volatile.LoadUint32(&o.INT_ENA.Reg)&^(0x200)|value<<9)
}
func (o *I2C_Type) GetINT_ENA_TRANS_START_INT_ENA() uint32 {
	return (volatile.LoadUint32(&o.INT_ENA.Reg) & 0x200) >> 9
}
func (o *I2C_Type) SetINT_ENA_NACK_INT_ENA(value uint32) {
	volatile.StoreUint32(&o.INT_ENA.Reg, volatile.LoadUint32(&o.INT_ENA.Reg)&^(0x400)|value<<10)
}
func (o *I2C_Type) GetINT_ENA_NACK_INT_ENA() uint32 {
	return (volatile.LoadUint32(&o.INT_ENA.Reg) & 0x400) >> 10
}
func (o *I2C_Type) SetINT_ENA_TXFIFO_OVF_INT_ENA(value uint32) {
	volatile.StoreUint32(&o.INT_ENA.Reg, volatile.LoadUint32(&o.INT_ENA.Reg)&^(0x800)|value<<11)
}
func (o *I2C_Type) GetINT_ENA_TXFIFO_OVF_INT_ENA() uint32 {
	return (volatile.LoadUint32(&o.INT_ENA.Reg) & 0x800) >> 11
}
func (o *I2C_Type) SetINT_ENA_RXFIFO_UDF_INT_ENA(value uint32) {
	volatile.StoreUint32(&o.INT_ENA.Reg, volatile.LoadUint32(&o.INT_ENA.Reg)&^(0x1000)|value<<12)
}
func (o *I2C_Type) GetINT_ENA_RXFIFO_UDF_INT_ENA() uint32 {
	return (volatile.LoadUint32(&o.INT_ENA.Reg) & 0x1000) >> 12
}
func (o *I2C_Type) SetINT_ENA_SCL_ST_TO_INT_ENA(value uint32) {
	volatile.StoreUint32(&o.INT_ENA.Reg, volatile.LoadUint32(&o.INT_ENA.Reg)&^(0x2000)|value<<13)
}
func (o *I2C_Type) GetINT_ENA_SCL_ST_TO_INT_ENA() uint32 {
	return (volatile.LoadUint32(&o.INT_ENA.Reg) & 0x2000) >> 13
}
func (o *I2C_Type) SetINT_ENA_SCL_MAIN_ST_TO_INT_ENA(value uint32) {
	volatile.StoreUint32(&o.INT_ENA.Reg, volatile.LoadUint32(&o.INT_ENA.Reg)&^(0x4000)|value<<14)
}
func (o *I2C_Type) GetINT_ENA_SCL_MAIN_ST_TO_INT_ENA() uint32 {
	return (volatile.LoadUint32(&o.INT_ENA.Reg) & 0x4000) >> 14
}
func (o *I2C_Type) SetINT_ENA_DET_START_INT_ENA(value uint32) {
	volatile.StoreUint32(&o.INT_ENA.Reg, volatile.LoadUint32(&o.INT_ENA.Reg)&^(0x8000)|value<<15)
}
func (o *I2C_Type) GetINT_ENA_DET_START_INT_ENA() uint32 {
	return (volatile.LoadUint32(&o.INT_ENA.Reg) & 0x8000) >> 15
}
func (o *I2C_Type) SetINT_ENA_SLAVE_STRETCH_INT_ENA(value uint32) {
	volatile.StoreUint32(&o.INT_ENA.Reg, volatile.LoadUint32(&o.INT_ENA.Reg)&^(0x10000)|value<<16)
}
func (o *I2C_Type) GetINT_ENA_SLAVE_STRETCH_INT_ENA() uint32 {
	return (volatile.LoadUint32(&o.INT_ENA.Reg) & 0x10000) >> 16
}
func (o *I2C_Type) SetINT_ENA_GENERAL_CALL_INT_ENA(value uint32) {
	volatile.StoreUint32(&o.INT_ENA.Reg, volatile.LoadUint32(&o.INT_ENA.Reg)&^(0x20000)|value<<17)
}
func (o *I2C_Type) GetINT_ENA_GENERAL_CALL_INT_ENA() uint32 {
	return (volatile.LoadUint32(&o.INT_ENA.Reg) & 0x20000) >> 17
}

// I2C.INT_STATUS: I2C_INT_STATUS_REG
func (o *I2C_Type) SetINT_STATUS_RXFIFO_WM_INT_ST(value uint32) {
	volatile.StoreUint32(&o.INT_STATUS.Reg, volatile.LoadUint32(&o.INT_STATUS.Reg)&^(0x1)|value)
}
func (o *I2C_Type) GetINT_STATUS_RXFIFO_WM_INT_ST() uint32 {
	return volatile.LoadUint32(&o.INT_STATUS.Reg) & 0x1
}
func (o *I2C_Type) SetINT_STATUS_TXFIFO_WM_INT_ST(value uint32) {
	volatile.StoreUint32(&o.INT_STATUS.Reg, volatile.LoadUint32(&o.INT_STATUS.Reg)&^(0x2)|value<<1)
}
func (o *I2C_Type) GetINT_STATUS_TXFIFO_WM_INT_ST() uint32 {
	return (volatile.LoadUint32(&o.INT_STATUS.Reg) & 0x2) >> 1
}
func (o *I2C_Type) SetINT_STATUS_RXFIFO_OVF_INT_ST(value uint32) {
	volatile.StoreUint32(&o.INT_STATUS.Reg, volatile.LoadUint32(&o.INT_STATUS.Reg)&^(0x4)|value<<2)
}
func (o *I2C_Type) GetINT_STATUS_RXFIFO_OVF_INT_ST() uint32 {
	return (volatile.LoadUint32(&o.INT_STATUS.Reg) & 0x4) >> 2
}
func (o *I2C_Type) SetINT_STATUS_END_DETECT_INT_ST(value uint32) {
	volatile.StoreUint32(&o.INT_STATUS.Reg, volatile.LoadUint32(&o.INT_STATUS.Reg)&^(0x8)|value<<3)
}
func (o *I2C_Type) GetINT_STATUS_END_DETECT_INT_ST() uint32 {
	return (volatile.LoadUint32(&o.INT_STATUS.Reg) & 0x8) >> 3
}
func (o *I2C_Type) SetINT_STATUS_BYTE_TRANS_DONE_INT_ST(value uint32) {
	volatile.StoreUint32(&o.INT_STATUS.Reg, volatile.LoadUint32(&o.INT_STATUS.Reg)&^(0x10)|value<<4)
}
func (o *I2C_Type) GetINT_STATUS_BYTE_TRANS_DONE_INT_ST() uint32 {
	return (volatile.LoadUint32(&o.INT_STATUS.Reg) & 0x10) >> 4
}
func (o *I2C_Type) SetINT_STATUS_ARBITRATION_LOST_INT_ST(value uint32) {
	volatile.StoreUint32(&o.INT_STATUS.Reg, volatile.LoadUint32(&o.INT_STATUS.Reg)&^(0x20)|value<<5)
}
func (o *I2C_Type) GetINT_STATUS_ARBITRATION_LOST_INT_ST() uint32 {
	return (volatile.LoadUint32(&o.INT_STATUS.Reg) & 0x20) >> 5
}
func (o *I2C_Type) SetINT_STATUS_MST_TXFIFO_UDF_INT_ST(value uint32) {
	volatile.StoreUint32(&o.INT_STATUS.Reg, volatile.LoadUint32(&o.INT_STATUS.Reg)&^(0x40)|value<<6)
}
func (o *I2C_Type) GetINT_STATUS_MST_TXFIFO_UDF_INT_ST() uint32 {
	return (volatile.LoadUint32(&o.INT_STATUS.Reg) & 0x40) >> 6
}
func (o *I2C_Type) SetINT_STATUS_TRANS_COMPLETE_INT_ST(value uint32) {
	volatile.StoreUint32(&o.INT_STATUS.Reg, volatile.LoadUint32(&o.INT_STATUS.Reg)&^(0x80)|value<<7)
}
func (o *I2C_Type) GetINT_STATUS_TRANS_COMPLETE_INT_ST() uint32 {
	return (volatile.LoadUint32(&o.INT_STATUS.Reg) & 0x80) >> 7
}
func (o *I2C_Type) SetINT_STATUS_TIME_OUT_INT_ST(value uint32) {
	volatile.StoreUint32(&o.INT_STATUS.Reg, volatile.LoadUint32(&o.INT_STATUS.Reg)&^(0x100)|value<<8)
}
func (o *I2C_Type) GetINT_STATUS_TIME_OUT_INT_ST() uint32 {
	return (volatile.LoadUint32(&o.INT_STATUS.Reg) & 0x100) >> 8
}
func (o *I2C_Type) SetINT_STATUS_TRANS_START_INT_ST(value uint32) {
	volatile.StoreUint32(&o.INT_STATUS.Reg, volatile.LoadUint32(&o.INT_STATUS.Reg)&^(0x200)|value<<9)
}
func (o *I2C_Type) GetINT_STATUS_TRANS_START_INT_ST() uint32 {
	return (volatile.LoadUint32(&o.INT_STATUS.Reg) & 0x200) >> 9
}
func (o *I2C_Type) SetINT_STATUS_NACK_INT_ST(value uint32) {
	volatile.StoreUint32(&o.INT_STATUS.Reg, volatile.LoadUint32(&o.INT_STATUS.Reg)&^(0x400)|value<<10)
}
func (o *I2C_Type) GetINT_STATUS_NACK_INT_ST() uint32 {
	return (volatile.LoadUint32(&o.INT_STATUS.Reg) & 0x400) >> 10
}
func (o *I2C_Type) SetINT_STATUS_TXFIFO_OVF_INT_ST(value uint32) {
	volatile.StoreUint32(&o.INT_STATUS.Reg, volatile.LoadUint32(&o.INT_STATUS.Reg)&^(0x800)|value<<11)
}
func (o *I2C_Type) GetINT_STATUS_TXFIFO_OVF_INT_ST() uint32 {
	return (volatile.LoadUint32(&o.INT_STATUS.Reg) & 0x800) >> 11
}
func (o *I2C_Type) SetINT_STATUS_RXFIFO_UDF_INT_ST(value uint32) {
	volatile.StoreUint32(&o.INT_STATUS.Reg, volatile.LoadUint32(&o.INT_STATUS.Reg)&^(0x1000)|value<<12)
}
func (o *I2C_Type) GetINT_STATUS_RXFIFO_UDF_INT_ST() uint32 {
	return (volatile.LoadUint32(&o.INT_STATUS.Reg) & 0x1000) >> 12
}
func (o *I2C_Type) SetINT_STATUS_SCL_ST_TO_INT_ST(value uint32) {
	volatile.StoreUint32(&o.INT_STATUS.Reg, volatile.LoadUint32(&o.INT_STATUS.Reg)&^(0x2000)|value<<13)
}
func (o *I2C_Type) GetINT_STATUS_SCL_ST_TO_INT_ST() uint32 {
	return (volatile.LoadUint32(&o.INT_STATUS.Reg) & 0x2000) >> 13
}
func (o *I2C_Type) SetINT_STATUS_SCL_MAIN_ST_TO_INT_ST(value uint32) {
	volatile.StoreUint32(&o.INT_STATUS.Reg, volatile.LoadUint32(&o.INT_STATUS.Reg)&^(0x4000)|value<<14)
}
func (o *I2C_Type) GetINT_STATUS_SCL_MAIN_ST_TO_INT_ST() uint32 {
	return (volatile.LoadUint32(&o.INT_STATUS.Reg) & 0x4000) >> 14
}
func (o *I2C_Type) SetINT_STATUS_DET_START_INT_ST(value uint32) {
	volatile.StoreUint32(&o.INT_STATUS.Reg, volatile.LoadUint32(&o.INT_STATUS.Reg)&^(0x8000)|value<<15)
}
func (o *I2C_Type) GetINT_STATUS_DET_START_INT_ST() uint32 {
	return (volatile.LoadUint32(&o.INT_STATUS.Reg) & 0x8000) >> 15
}
func (o *I2C_Type) SetINT_STATUS_SLAVE_STRETCH_INT_ST(value uint32) {
	volatile.StoreUint32(&o.INT_STATUS.Reg, volatile.LoadUint32(&o.INT_STATUS.Reg)&^(0x10000)|value<<16)
}
func (o *I2C_Type) GetINT_STATUS_SLAVE_STRETCH_INT_ST() uint32 {
	return (volatile.LoadUint32(&o.INT_STATUS.Reg) & 0x10000) >> 16
}
func (o *I2C_Type) SetINT_STATUS_GENERAL_CALL_INT_ST(value uint32) {
	volatile.StoreUint32(&o.INT_STATUS.Reg, volatile.LoadUint32(&o.INT_STATUS.Reg)&^(0x20000)|value<<17)
}
func (o *I2C_Type) GetINT_STATUS_GENERAL_CALL_INT_ST() uint32 {
	return (volatile.LoadUint32(&o.INT_STATUS.Reg) & 0x20000) >> 17
}

// I2C.SDA_HOLD: I2C_SDA_HOLD_REG
func (o *I2C_Type) SetSDA_HOLD_TIME(value uint32) {
	volatile.StoreUint32(&o.SDA_HOLD.Reg, volatile.LoadUint32(&o.SDA_HOLD.Reg)&^(0x1ff)|value)
}
func (o *I2C_Type) GetSDA_HOLD_TIME() uint32 {
	return volatile.LoadUint32(&o.SDA_HOLD.Reg) & 0x1ff
}

// I2C.SDA_SAMPLE: I2C_SDA_SAMPLE_REG
func (o *I2C_Type) SetSDA_SAMPLE_TIME(value uint32) {
	volatile.StoreUint32(&o.SDA_SAMPLE.Reg, volatile.LoadUint32(&o.SDA_SAMPLE.Reg)&^(0x1ff)|value)
}
func (o *I2C_Type) GetSDA_SAMPLE_TIME() uint32 {
	return volatile.LoadUint32(&o.SDA_SAMPLE.Reg) & 0x1ff
}

// I2C.SCL_HIGH_PERIOD: I2C_SCL_HIGH_PERIOD_REG
func (o *I2C_Type) SetSCL_HIGH_PERIOD(value uint32) {
	volatile.StoreUint32(&o.SCL_HIGH_PERIOD.Reg, volatile.LoadUint32(&o.SCL_HIGH_PERIOD.Reg)&^(0x1ff)|value)
}
func (o *I2C_Type) GetSCL_HIGH_PERIOD() uint32 {
	return volatile.LoadUint32(&o.SCL_HIGH_PERIOD.Reg) & 0x1ff
}
func (o *I2C_Type) SetSCL_HIGH_PERIOD_SCL_WAIT_HIGH_PERIOD(value uint32) {
	volatile.StoreUint32(&o.SCL_HIGH_PERIOD.Reg, volatile.LoadUint32(&o.SCL_HIGH_PERIOD.Reg)&^(0xfe00)|value<<9)
}
func (o *I2C_Type) GetSCL_HIGH_PERIOD_SCL_WAIT_HIGH_PERIOD() uint32 {
	return (volatile.LoadUint32(&o.SCL_HIGH_PERIOD.Reg) & 0xfe00) >> 9
}

// I2C.SCL_START_HOLD: I2C_SCL_START_HOLD_REG
func (o *I2C_Type) SetSCL_START_HOLD_TIME(value uint32) {
	volatile.StoreUint32(&o.SCL_START_HOLD.Reg, volatile.LoadUint32(&o.SCL_START_HOLD.Reg)&^(0x1ff)|value)
}
func (o *I2C_Type) GetSCL_START_HOLD_TIME() uint32 {
	return volatile.LoadUint32(&o.SCL_START_HOLD.Reg) & 0x1ff
}

// I2C.SCL_RSTART_SETUP: I2C_SCL_RSTART_SETUP_REG
func (o *I2C_Type) SetSCL_RSTART_SETUP_TIME(value uint32) {
	volatile.StoreUint32(&o.SCL_RSTART_SETUP.Reg, volatile.LoadUint32(&o.SCL_RSTART_SETUP.Reg)&^(0x1ff)|value)
}
func (o *I2C_Type) GetSCL_RSTART_SETUP_TIME() uint32 {
	return volatile.LoadUint32(&o.SCL_RSTART_SETUP.Reg) & 0x1ff
}

// I2C.SCL_STOP_HOLD: I2C_SCL_STOP_HOLD_REG
func (o *I2C_Type) SetSCL_STOP_HOLD_TIME(value uint32) {
	volatile.StoreUint32(&o.SCL_STOP_HOLD.Reg, volatile.LoadUint32(&o.SCL_STOP_HOLD.Reg)&^(0x1ff)|value)
}
func (o *I2C_Type) GetSCL_STOP_HOLD_TIME() uint32 {
	return volatile.LoadUint32(&o.SCL_STOP_HOLD.Reg) & 0x1ff
}

// I2C.SCL_STOP_SETUP: I2C_SCL_STOP_SETUP_REG
func (o *I2C_Type) SetSCL_STOP_SETUP_TIME(value uint32) {
	volatile.StoreUint32(&o.SCL_STOP_SETUP.Reg, volatile.LoadUint32(&o.SCL_STOP_SETUP.Reg)&^(0x1ff)|value)
}
func (o *I2C_Type) GetSCL_STOP_SETUP_TIME() uint32 {
	return volatile.LoadUint32(&o.SCL_STOP_SETUP.Reg) & 0x1ff
}

// I2C.FILTER_CFG: I2C_FILTER_CFG_REG
func (o *I2C_Type) SetFILTER_CFG_SCL_FILTER_THRES(value uint32) {
	volatile.StoreUint32(&o.FILTER_CFG.Reg, volatile.LoadUint32(&o.FILTER_CFG.Reg)&^(0xf)|value)
}
func (o *I2C_Type) GetFILTER_CFG_SCL_FILTER_THRES() uint32 {
	return volatile.LoadUint32(&o.FILTER_CFG.Reg) & 0xf
}
func (o *I2C_Type) SetFILTER_CFG_SDA_FILTER_THRES(value uint32) {
	volatile.StoreUint32(&o.FILTER_CFG.Reg, volatile.LoadUint32(&o.FILTER_CFG.Reg)&^(0xf0)|value<<4)
}
func (o *I2C_Type) GetFILTER_CFG_SDA_FILTER_THRES() uint32 {
	return (volatile.LoadUint32(&o.FILTER_CFG.Reg) & 0xf0) >> 4
}
func (o *I2C_Type) SetFILTER_CFG_SCL_FILTER_EN(value uint32) {
	volatile.StoreUint32(&o.FILTER_CFG.Reg, volatile.LoadUint32(&o.FILTER_CFG.Reg)&^(0x100)|value<<8)
}
func (o *I2C_Type) GetFILTER_CFG_SCL_FILTER_EN() uint32 {
	return (volatile.LoadUint32(&o.FILTER_CFG.Reg) & 0x100) >> 8
}
func (o *I2C_Type) SetFILTER_CFG_SDA_FILTER_EN(value uint32) {
	volatile.StoreUint32(&o.FILTER_CFG.Reg, volatile.LoadUint32(&o.FILTER_CFG.Reg)&^(0x200)|value<<9)
}
func (o *I2C_Type) GetFILTER_CFG_SDA_FILTER_EN() uint32 {
	return (volatile.LoadUint32(&o.FILTER_CFG.Reg) & 0x200) >> 9
}

// I2C.CLK_CONF: I2C_CLK_CONF_REG
func (o *I2C_Type) SetCLK_CONF_SCLK_DIV_NUM(value uint32) {
	volatile.StoreUint32(&o.CLK_CONF.Reg, volatile.LoadUint32(&o.CLK_CONF.Reg)&^(0xff)|value)
}
func (o *I2C_Type) GetCLK_CONF_SCLK_DIV_NUM() uint32 {
	return volatile.LoadUint32(&o.CLK_CONF.Reg) & 0xff
}
func (o *I2C_Type) SetCLK_CONF_SCLK_DIV_A(value uint32) {
	volatile.StoreUint32(&o.CLK_CONF.Reg, volatile.LoadUint32(&o.CLK_CONF.Reg)&^(0x3f00)|value<<8)
}
func (o *I2C_Type) GetCLK_CONF_SCLK_DIV_A() uint32 {
	return (volatile.LoadUint32(&o.CLK_CONF.Reg) & 0x3f00) >> 8
}
func (o *I2C_Type) SetCLK_CONF_SCLK_DIV_B(value uint32) {
	volatile.StoreUint32(&o.CLK_CONF.Reg, volatile.LoadUint32(&o.CLK_CONF.Reg)&^(0xfc000)|value<<14)
}
func (o *I2C_Type) GetCLK_CONF_SCLK_DIV_B() uint32 {
	return (volatile.LoadUint32(&o.CLK_CONF.Reg) & 0xfc000) >> 14
}
func (o *I2C_Type) SetCLK_CONF_SCLK_SEL(value uint32) {
	volatile.StoreUint32(&o.CLK_CONF.Reg, volatile.LoadUint32(&o.CLK_CONF.Reg)&^(0x100000)|value<<20)
}
func (o *I2C_Type) GetCLK_CONF_SCLK_SEL() uint32 {
	return (volatile.LoadUint32(&o.CLK_CONF.Reg) & 0x100000) >> 20
}
func (o *I2C_Type) SetCLK_CONF_SCLK_ACTIVE(value uint32) {
	volatile.StoreUint32(&o.CLK_CONF.Reg, volatile.LoadUint32(&o.CLK_CONF.Reg)&^(0x200000)|value<<21)
}
func (o *I2C_Type) GetCLK_CONF_SCLK_ACTIVE() uint32 {
	return (volatile.LoadUint32(&o.CLK_CONF.Reg) & 0x200000) >> 21
}

// I2C.COMD0: I2C_COMD%s_REG
func (o *I2C_Type) SetCOMD0_COMMAND(value uint32) {
	volatile.StoreUint32(&o.COMD0.Reg, volatile.LoadUint32(&o.COMD0.Reg)&^(0x3fff)|value)
}
func (o *I2C_Type) GetCOMD0_COMMAND() uint32 {
	return volatile.LoadUint32(&o.COMD0.Reg) & 0x3fff
}
func (o *I2C_Type) SetCOMD0_COMMAND_DONE(value uint32) {
	volatile.StoreUint32(&o.COMD0.Reg, volatile.LoadUint32(&o.COMD0.Reg)&^(0x80000000)|value<<31)
}
func (o *I2C_Type) GetCOMD0_COMMAND_DONE() uint32 {
	return (volatile.LoadUint32(&o.COMD0.Reg) & 0x80000000) >> 31
}

// I2C.COMD1: I2C_COMD%s_REG
func (o *I2C_Type) SetCOMD1_COMMAND(value uint32) {
	volatile.StoreUint32(&o.COMD1.Reg, volatile.LoadUint32(&o.COMD1.Reg)&^(0x3fff)|value)
}
func (o *I2C_Type) GetCOMD1_COMMAND() uint32 {
	return volatile.LoadUint32(&o.COMD1.Reg) & 0x3fff
}
func (o *I2C_Type) SetCOMD1_COMMAND_DONE(value uint32) {
	volatile.StoreUint32(&o.COMD1.Reg, volatile.LoadUint32(&o.COMD1.Reg)&^(0x80000000)|value<<31)
}
func (o *I2C_Type) GetCOMD1_COMMAND_DONE() uint32 {
	return (volatile.LoadUint32(&o.COMD1.Reg) & 0x80000000) >> 31
}

// I2C.COMD2: I2C_COMD%s_REG
func (o *I2C_Type) SetCOMD2_COMMAND(value uint32) {
	volatile.StoreUint32(&o.COMD2.Reg, volatile.LoadUint32(&o.COMD2.Reg)&^(0x3fff)|value)
}
func (o *I2C_Type) GetCOMD2_COMMAND() uint32 {
	return volatile.LoadUint32(&o.COMD2.Reg) & 0x3fff
}
func (o *I2C_Type) SetCOMD2_COMMAND_DONE(value uint32) {
	volatile.StoreUint32(&o.COMD2.Reg, volatile.LoadUint32(&o.COMD2.Reg)&^(0x80000000)|value<<31)
}
func (o *I2C_Type) GetCOMD2_COMMAND_DONE() uint32 {
	return (volatile.LoadUint32(&o.COMD2.Reg) & 0x80000000) >> 31
}

// I2C.COMD3: I2C_COMD%s_REG
func (o *I2C_Type) SetCOMD3_COMMAND(value uint32) {
	volatile.StoreUint32(&o.COMD3.Reg, volatile.LoadUint32(&o.COMD3.Reg)&^(0x3fff)|value)
}
func (o *I2C_Type) GetCOMD3_COMMAND() uint32 {
	return volatile.LoadUint32(&o.COMD3.Reg) & 0x3fff
}
func (o *I2C_Type) SetCOMD3_COMMAND_DONE(value uint32) {
	volatile.StoreUint32(&o.COMD3.Reg, volatile.LoadUint32(&o.COMD3.Reg)&^(0x80000000)|value<<31)
}
func (o *I2C_Type) GetCOMD3_COMMAND_DONE() uint32 {
	return (volatile.LoadUint32(&o.COMD3.Reg) & 0x80000000) >> 31
}

// I2C.COMD4: I2C_COMD%s_REG
func (o *I2C_Type) SetCOMD4_COMMAND(value uint32) {
	volatile.StoreUint32(&o.COMD4.Reg, volatile.LoadUint32(&o.COMD4.Reg)&^(0x3fff)|value)
}
func (o *I2C_Type) GetCOMD4_COMMAND() uint32 {
	return volatile.LoadUint32(&o.COMD4.Reg) & 0x3fff
}
func (o *I2C_Type) SetCOMD4_COMMAND_DONE(value uint32) {
	volatile.StoreUint32(&o.COMD4.Reg, volatile.LoadUint32(&o.COMD4.Reg)&^(0x80000000)|value<<31)
}
func (o *I2C_Type) GetCOMD4_COMMAND_DONE() uint32 {
	return (volatile.LoadUint32(&o.COMD4.Reg) & 0x80000000) >> 31
}

// I2C.COMD5: I2C_COMD%s_REG
func (o *I2C_Type) SetCOMD5_COMMAND(value uint32) {
	volatile.StoreUint32(&o.COMD5.Reg, volatile.LoadUint32(&o.COMD5.Reg)&^(0x3fff)|value)
}
func (o *I2C_Type) GetCOMD5_COMMAND() uint32 {
	return volatile.LoadUint32(&o.COMD5.Reg) & 0x3fff
}
func (o *I2C_Type) SetCOMD5_COMMAND_DONE(value uint32) {
	volatile.StoreUint32(&o.COMD5.Reg, volatile.LoadUint32(&o.COMD5.Reg)&^(0x80000000)|value<<31)
}
func (o *I2C_Type) GetCOMD5_COMMAND_DONE() uint32 {
	return (volatile.LoadUint32(&o.COMD5.Reg) & 0x80000000) >> 31
}

// I2C.COMD6: I2C_COMD%s_REG
func (o *I2C_Type) SetCOMD6_COMMAND(value uint32) {
	volatile.StoreUint32(&o.COMD6.Reg, volatile.LoadUint32(&o.COMD6.Reg)&^(0x3fff)|value)
}
func (o *I2C_Type) GetCOMD6_COMMAND() uint32 {
	return volatile.LoadUint32(&o.COMD6.Reg) & 0x3fff
}
func (o *I2C_Type) SetCOMD6_COMMAND_DONE(value uint32) {
	volatile.StoreUint32(&o.COMD6.Reg, volatile.LoadUint32(&o.COMD6.Reg)&^(0x80000000)|value<<31)
}
func (o *I2C_Type) GetCOMD6_COMMAND_DONE() uint32 {
	return (volatile.LoadUint32(&o.COMD6.Reg) & 0x80000000) >> 31
}

// I2C.COMD7: I2C_COMD%s_REG
func (o *I2C_Type) SetCOMD7_COMMAND(value uint32) {
	volatile.StoreUint32(&o.COMD7.Reg, volatile.LoadUint32(&o.COMD7.Reg)&^(0x3fff)|value)
}
func (o *I2C_Type) GetCOMD7_COMMAND() uint32 {
	return volatile.LoadUint32(&o.COMD7.Reg) & 0x3fff
}
func (o *I2C_Type) SetCOMD7_COMMAND_DONE(value uint32) {
	volatile.StoreUint32(&o.COMD7.Reg, volatile.LoadUint32(&o.COMD7.Reg)&^(0x80000000)|value<<31)
}
func (o *I2C_Type) GetCOMD7_COMMAND_DONE() uint32 {
	return (volatile.LoadUint32(&o.COMD7.Reg) & 0x80000000) >> 31
}

// I2C.SCL_ST_TIME_OUT: I2C_SCL_ST_TIME_OUT_REG
func (o *I2C_Type) SetSCL_ST_TIME_OUT_SCL_ST_TO_I2C(value uint32) {
	volatile.StoreUint32(&o.SCL_ST_TIME_OUT.Reg, volatile.LoadUint32(&o.SCL_ST_TIME_OUT.Reg)&^(0x1f)|value)
}
func (o *I2C_Type) GetSCL_ST_TIME_OUT_SCL_ST_TO_I2C() uint32 {
	return volatile.LoadUint32(&o.SCL_ST_TIME_OUT.Reg) & 0x1f
}

// I2C.SCL_MAIN_ST_TIME_OUT: I2C_SCL_MAIN_ST_TIME_OUT_REG
func (o *I2C_Type) SetSCL_MAIN_ST_TIME_OUT_SCL_MAIN_ST_TO_I2C(value uint32) {
	volatile.StoreUint32(&o.SCL_MAIN_ST_TIME_OUT.Reg, volatile.LoadUint32(&o.SCL_MAIN_ST_TIME_OUT.Reg)&^(0x1f)|value)
}
func (o *I2C_Type) GetSCL_MAIN_ST_TIME_OUT_SCL_MAIN_ST_TO_I2C() uint32 {
	return volatile.LoadUint32(&o.SCL_MAIN_ST_TIME_OUT.Reg) & 0x1f
}

// I2C.SCL_SP_CONF: I2C_SCL_SP_CONF_REG
func (o *I2C_Type) SetSCL_SP_CONF_SCL_RST_SLV_EN(value uint32) {
	volatile.StoreUint32(&o.SCL_SP_CONF.Reg, volatile.LoadUint32(&o.SCL_SP_CONF.Reg)&^(0x1)|value)
}
func (o *I2C_Type) GetSCL_SP_CONF_SCL_RST_SLV_EN() uint32 {
	return volatile.LoadUint32(&o.SCL_SP_CONF.Reg) & 0x1
}
func (o *I2C_Type) SetSCL_SP_CONF_SCL_RST_SLV_NUM(value uint32) {
	volatile.StoreUint32(&o.SCL_SP_CONF.Reg, volatile.LoadUint32(&o.SCL_SP_CONF.Reg)&^(0x3e)|value<<1)
}
func (o *I2C_Type) GetSCL_SP_CONF_SCL_RST_SLV_NUM() uint32 {
	return (volatile.LoadUint32(&o.SCL_SP_CONF.Reg) & 0x3e) >> 1
}
func (o *I2C_Type) SetSCL_SP_CONF_SCL_PD_EN(value uint32) {
	volatile.StoreUint32(&o.SCL_SP_CONF.Reg, volatile.LoadUint32(&o.SCL_SP_CONF.Reg)&^(0x40)|value<<6)
}
func (o *I2C_Type) GetSCL_SP_CONF_SCL_PD_EN() uint32 {
	return (volatile.LoadUint32(&o.SCL_SP_CONF.Reg) & 0x40) >> 6
}
func (o *I2C_Type) SetSCL_SP_CONF_SDA_PD_EN(value uint32) {
	volatile.StoreUint32(&o.SCL_SP_CONF.Reg, volatile.LoadUint32(&o.SCL_SP_CONF.Reg)&^(0x80)|value<<7)
}
func (o *I2C_Type) GetSCL_SP_CONF_SDA_PD_EN() uint32 {
	return (volatile.LoadUint32(&o.SCL_SP_CONF.Reg) & 0x80) >> 7
}

// I2C.SCL_STRETCH_CONF: I2C_SCL_STRETCH_CONF_REG
func (o *I2C_Type) SetSCL_STRETCH_CONF_STRETCH_PROTECT_NUM(value uint32) {
	volatile.StoreUint32(&o.SCL_STRETCH_CONF.Reg, volatile.LoadUint32(&o.SCL_STRETCH_CONF.Reg)&^(0x3ff)|value)
}
func (o *I2C_Type) GetSCL_STRETCH_CONF_STRETCH_PROTECT_NUM() uint32 {
	return volatile.LoadUint32(&o.SCL_STRETCH_CONF.Reg) & 0x3ff
}
func (o *I2C_Type) SetSCL_STRETCH_CONF_SLAVE_SCL_STRETCH_EN(value uint32) {
	volatile.StoreUint32(&o.SCL_STRETCH_CONF.Reg, volatile.LoadUint32(&o.SCL_STRETCH_CONF.Reg)&^(0x400)|value<<10)
}
func (o *I2C_Type) GetSCL_STRETCH_CONF_SLAVE_SCL_STRETCH_EN() uint32 {
	return (volatile.LoadUint32(&o.SCL_STRETCH_CONF.Reg) & 0x400) >> 10
}
func (o *I2C_Type) SetSCL_STRETCH_CONF_SLAVE_SCL_STRETCH_CLR(value uint32) {
	volatile.StoreUint32(&o.SCL_STRETCH_CONF.Reg, volatile.LoadUint32(&o.SCL_STRETCH_CONF.Reg)&^(0x800)|value<<11)
}
func (o *I2C_Type) GetSCL_STRETCH_CONF_SLAVE_SCL_STRETCH_CLR() uint32 {
	return (volatile.LoadUint32(&o.SCL_STRETCH_CONF.Reg) & 0x800) >> 11
}
func (o *I2C_Type) SetSCL_STRETCH_CONF_SLAVE_BYTE_ACK_CTL_EN(value uint32) {
	volatile.StoreUint32(&o.SCL_STRETCH_CONF.Reg, volatile.LoadUint32(&o.SCL_STRETCH_CONF.Reg)&^(0x1000)|value<<12)
}
func (o *I2C_Type) GetSCL_STRETCH_CONF_SLAVE_BYTE_ACK_CTL_EN() uint32 {
	return (volatile.LoadUint32(&o.SCL_STRETCH_CONF.Reg) & 0x1000) >> 12
}
func (o *I2C_Type) SetSCL_STRETCH_CONF_SLAVE_BYTE_ACK_LVL(value uint32) {
	volatile.StoreUint32(&o.SCL_STRETCH_CONF.Reg, volatile.LoadUint32(&o.SCL_STRETCH_CONF.Reg)&^(0x2000)|value<<13)
}
func (o *I2C_Type) GetSCL_STRETCH_CONF_SLAVE_BYTE_ACK_LVL() uint32 {
	return (volatile.LoadUint32(&o.SCL_STRETCH_CONF.Reg) & 0x2000) >> 13
}

// I2C.DATE: I2C_DATE_REG
func (o *I2C_Type) SetDATE(value uint32) {
	volatile.StoreUint32(&o.DATE.Reg, value)
}
func (o *I2C_Type) GetDATE() uint32 {
	return volatile.LoadUint32(&o.DATE.Reg)
}

// I2C.TXFIFO_START_ADDR: I2C_TXFIFO_START_ADDR_REG
func (o *I2C_Type) SetTXFIFO_START_ADDR(value uint32) {
	volatile.StoreUint32(&o.TXFIFO_START_ADDR.Reg, value)
}
func (o *I2C_Type) GetTXFIFO_START_ADDR() uint32 {
	return volatile.LoadUint32(&o.TXFIFO_START_ADDR.Reg)
}

// I2C.RXFIFO_START_ADDR: I2C_RXFIFO_START_ADDR_REG
func (o *I2C_Type) SetRXFIFO_START_ADDR(value uint32) {
	volatile.StoreUint32(&o.RXFIFO_START_ADDR.Reg, value)
}
func (o *I2C_Type) GetRXFIFO_START_ADDR() uint32 {
	return volatile.LoadUint32(&o.RXFIFO_START_ADDR.Reg)
}

// Peripheral I2S
type I2S_Type struct {
	_                [12]byte
	INT_RAW          volatile.Register32 // 0xC
	INT_ST           volatile.Register32 // 0x10
	INT_ENA          volatile.Register32 // 0x14
	INT_CLR          volatile.Register32 // 0x18
	_                [4]byte
	RX_CONF          volatile.Register32 // 0x20
	TX_CONF          volatile.Register32 // 0x24
	RX_CONF1         volatile.Register32 // 0x28
	TX_CONF1         volatile.Register32 // 0x2C
	RX_CLKM_CONF     volatile.Register32 // 0x30
	TX_CLKM_CONF     volatile.Register32 // 0x34
	RX_CLKM_DIV_CONF volatile.Register32 // 0x38
	TX_CLKM_DIV_CONF volatile.Register32 // 0x3C
	TX_PCM2PDM_CONF  volatile.Register32 // 0x40
	TX_PCM2PDM_CONF1 volatile.Register32 // 0x44
	_                [8]byte
	RX_TDM_CTRL      volatile.Register32 // 0x50
	TX_TDM_CTRL      volatile.Register32 // 0x54
	RX_TIMING        volatile.Register32 // 0x58
	TX_TIMING        volatile.Register32 // 0x5C
	LC_HUNG_CONF     volatile.Register32 // 0x60
	RXEOF_NUM        volatile.Register32 // 0x64
	CONF_SIGLE_DATA  volatile.Register32 // 0x68
	STATE            volatile.Register32 // 0x6C
	_                [16]byte
	DATE             volatile.Register32 // 0x80
}

// I2S.INT_RAW: I2S interrupt raw register, valid in level.
func (o *I2S_Type) SetINT_RAW_RX_DONE_INT_RAW(value uint32) {
	volatile.StoreUint32(&o.INT_RAW.Reg, volatile.LoadUint32(&o.INT_RAW.Reg)&^(0x1)|value)
}
func (o *I2S_Type) GetINT_RAW_RX_DONE_INT_RAW() uint32 {
	return volatile.LoadUint32(&o.INT_RAW.Reg) & 0x1
}
func (o *I2S_Type) SetINT_RAW_TX_DONE_INT_RAW(value uint32) {
	volatile.StoreUint32(&o.INT_RAW.Reg, volatile.LoadUint32(&o.INT_RAW.Reg)&^(0x2)|value<<1)
}
func (o *I2S_Type) GetINT_RAW_TX_DONE_INT_RAW() uint32 {
	return (volatile.LoadUint32(&o.INT_RAW.Reg) & 0x2) >> 1
}
func (o *I2S_Type) SetINT_RAW_RX_HUNG_INT_RAW(value uint32) {
	volatile.StoreUint32(&o.INT_RAW.Reg, volatile.LoadUint32(&o.INT_RAW.Reg)&^(0x4)|value<<2)
}
func (o *I2S_Type) GetINT_RAW_RX_HUNG_INT_RAW() uint32 {
	return (volatile.LoadUint32(&o.INT_RAW.Reg) & 0x4) >> 2
}
func (o *I2S_Type) SetINT_RAW_TX_HUNG_INT_RAW(value uint32) {
	volatile.StoreUint32(&o.INT_RAW.Reg, volatile.LoadUint32(&o.INT_RAW.Reg)&^(0x8)|value<<3)
}
func (o *I2S_Type) GetINT_RAW_TX_HUNG_INT_RAW() uint32 {
	return (volatile.LoadUint32(&o.INT_RAW.Reg) & 0x8) >> 3
}

// I2S.INT_ST: I2S interrupt status register.
func (o *I2S_Type) SetINT_ST_RX_DONE_INT_ST(value uint32) {
	volatile.StoreUint32(&o.INT_ST.Reg, volatile.LoadUint32(&o.INT_ST.Reg)&^(0x1)|value)
}
func (o *I2S_Type) GetINT_ST_RX_DONE_INT_ST() uint32 {
	return volatile.LoadUint32(&o.INT_ST.Reg) & 0x1
}
func (o *I2S_Type) SetINT_ST_TX_DONE_INT_ST(value uint32) {
	volatile.StoreUint32(&o.INT_ST.Reg, volatile.LoadUint32(&o.INT_ST.Reg)&^(0x2)|value<<1)
}
func (o *I2S_Type) GetINT_ST_TX_DONE_INT_ST() uint32 {
	return (volatile.LoadUint32(&o.INT_ST.Reg) & 0x2) >> 1
}
func (o *I2S_Type) SetINT_ST_RX_HUNG_INT_ST(value uint32) {
	volatile.StoreUint32(&o.INT_ST.Reg, volatile.LoadUint32(&o.INT_ST.Reg)&^(0x4)|value<<2)
}
func (o *I2S_Type) GetINT_ST_RX_HUNG_INT_ST() uint32 {
	return (volatile.LoadUint32(&o.INT_ST.Reg) & 0x4) >> 2
}
func (o *I2S_Type) SetINT_ST_TX_HUNG_INT_ST(value uint32) {
	volatile.StoreUint32(&o.INT_ST.Reg, volatile.LoadUint32(&o.INT_ST.Reg)&^(0x8)|value<<3)
}
func (o *I2S_Type) GetINT_ST_TX_HUNG_INT_ST() uint32 {
	return (volatile.LoadUint32(&o.INT_ST.Reg) & 0x8) >> 3
}

// I2S.INT_ENA: I2S interrupt enable register.
func (o *I2S_Type) SetINT_ENA_RX_DONE_INT_ENA(value uint32) {
	volatile.StoreUint32(&o.INT_ENA.Reg, volatile.LoadUint32(&o.INT_ENA.Reg)&^(0x1)|value)
}
func (o *I2S_Type) GetINT_ENA_RX_DONE_INT_ENA() uint32 {
	return volatile.LoadUint32(&o.INT_ENA.Reg) & 0x1
}
func (o *I2S_Type) SetINT_ENA_TX_DONE_INT_ENA(value uint32) {
	volatile.StoreUint32(&o.INT_ENA.Reg, volatile.LoadUint32(&o.INT_ENA.Reg)&^(0x2)|value<<1)
}
func (o *I2S_Type) GetINT_ENA_TX_DONE_INT_ENA() uint32 {
	return (volatile.LoadUint32(&o.INT_ENA.Reg) & 0x2) >> 1
}
func (o *I2S_Type) SetINT_ENA_RX_HUNG_INT_ENA(value uint32) {
	volatile.StoreUint32(&o.INT_ENA.Reg, volatile.LoadUint32(&o.INT_ENA.Reg)&^(0x4)|value<<2)
}
func (o *I2S_Type) GetINT_ENA_RX_HUNG_INT_ENA() uint32 {
	return (volatile.LoadUint32(&o.INT_ENA.Reg) & 0x4) >> 2
}
func (o *I2S_Type) SetINT_ENA_TX_HUNG_INT_ENA(value uint32) {
	volatile.StoreUint32(&o.INT_ENA.Reg, volatile.LoadUint32(&o.INT_ENA.Reg)&^(0x8)|value<<3)
}
func (o *I2S_Type) GetINT_ENA_TX_HUNG_INT_ENA() uint32 {
	return (volatile.LoadUint32(&o.INT_ENA.Reg) & 0x8) >> 3
}

// I2S.INT_CLR: I2S interrupt clear register.
func (o *I2S_Type) SetINT_CLR_RX_DONE_INT_CLR(value uint32) {
	volatile.StoreUint32(&o.INT_CLR.Reg, volatile.LoadUint32(&o.INT_CLR.Reg)&^(0x1)|value)
}
func (o *I2S_Type) GetINT_CLR_RX_DONE_INT_CLR() uint32 {
	return volatile.LoadUint32(&o.INT_CLR.Reg) & 0x1
}
func (o *I2S_Type) SetINT_CLR_TX_DONE_INT_CLR(value uint32) {
	volatile.StoreUint32(&o.INT_CLR.Reg, volatile.LoadUint32(&o.INT_CLR.Reg)&^(0x2)|value<<1)
}
func (o *I2S_Type) GetINT_CLR_TX_DONE_INT_CLR() uint32 {
	return (volatile.LoadUint32(&o.INT_CLR.Reg) & 0x2) >> 1
}
func (o *I2S_Type) SetINT_CLR_RX_HUNG_INT_CLR(value uint32) {
	volatile.StoreUint32(&o.INT_CLR.Reg, volatile.LoadUint32(&o.INT_CLR.Reg)&^(0x4)|value<<2)
}
func (o *I2S_Type) GetINT_CLR_RX_HUNG_INT_CLR() uint32 {
	return (volatile.LoadUint32(&o.INT_CLR.Reg) & 0x4) >> 2
}
func (o *I2S_Type) SetINT_CLR_TX_HUNG_INT_CLR(value uint32) {
	volatile.StoreUint32(&o.INT_CLR.Reg, volatile.LoadUint32(&o.INT_CLR.Reg)&^(0x8)|value<<3)
}
func (o *I2S_Type) GetINT_CLR_TX_HUNG_INT_CLR() uint32 {
	return (volatile.LoadUint32(&o.INT_CLR.Reg) & 0x8) >> 3
}

// I2S.RX_CONF: I2S RX configure register
func (o *I2S_Type) SetRX_CONF_RX_RESET(value uint32) {
	volatile.StoreUint32(&o.RX_CONF.Reg, volatile.LoadUint32(&o.RX_CONF.Reg)&^(0x1)|value)
}
func (o *I2S_Type) GetRX_CONF_RX_RESET() uint32 {
	return volatile.LoadUint32(&o.RX_CONF.Reg) & 0x1
}
func (o *I2S_Type) SetRX_CONF_RX_FIFO_RESET(value uint32) {
	volatile.StoreUint32(&o.RX_CONF.Reg, volatile.LoadUint32(&o.RX_CONF.Reg)&^(0x2)|value<<1)
}
func (o *I2S_Type) GetRX_CONF_RX_FIFO_RESET() uint32 {
	return (volatile.LoadUint32(&o.RX_CONF.Reg) & 0x2) >> 1
}
func (o *I2S_Type) SetRX_CONF_RX_START(value uint32) {
	volatile.StoreUint32(&o.RX_CONF.Reg, volatile.LoadUint32(&o.RX_CONF.Reg)&^(0x4)|value<<2)
}
func (o *I2S_Type) GetRX_CONF_RX_START() uint32 {
	return (volatile.LoadUint32(&o.RX_CONF.Reg) & 0x4) >> 2
}
func (o *I2S_Type) SetRX_CONF_RX_SLAVE_MOD(value uint32) {
	volatile.StoreUint32(&o.RX_CONF.Reg, volatile.LoadUint32(&o.RX_CONF.Reg)&^(0x8)|value<<3)
}
func (o *I2S_Type) GetRX_CONF_RX_SLAVE_MOD() uint32 {
	return (volatile.LoadUint32(&o.RX_CONF.Reg) & 0x8) >> 3
}
func (o *I2S_Type) SetRX_CONF_RX_MONO(value uint32) {
	volatile.StoreUint32(&o.RX_CONF.Reg, volatile.LoadUint32(&o.RX_CONF.Reg)&^(0x20)|value<<5)
}
func (o *I2S_Type) GetRX_CONF_RX_MONO() uint32 {
	return (volatile.LoadUint32(&o.RX_CONF.Reg) & 0x20) >> 5
}
func (o *I2S_Type) SetRX_CONF_RX_BIG_ENDIAN(value uint32) {
	volatile.StoreUint32(&o.RX_CONF.Reg, volatile.LoadUint32(&o.RX_CONF.Reg)&^(0x80)|value<<7)
}
func (o *I2S_Type) GetRX_CONF_RX_BIG_ENDIAN() uint32 {
	return (volatile.LoadUint32(&o.RX_CONF.Reg) & 0x80) >> 7
}
func (o *I2S_Type) SetRX_CONF_RX_UPDATE(value uint32) {
	volatile.StoreUint32(&o.RX_CONF.Reg, volatile.LoadUint32(&o.RX_CONF.Reg)&^(0x100)|value<<8)
}
func (o *I2S_Type) GetRX_CONF_RX_UPDATE() uint32 {
	return (volatile.LoadUint32(&o.RX_CONF.Reg) & 0x100) >> 8
}
func (o *I2S_Type) SetRX_CONF_RX_MONO_FST_VLD(value uint32) {
	volatile.StoreUint32(&o.RX_CONF.Reg, volatile.LoadUint32(&o.RX_CONF.Reg)&^(0x200)|value<<9)
}
func (o *I2S_Type) GetRX_CONF_RX_MONO_FST_VLD() uint32 {
	return (volatile.LoadUint32(&o.RX_CONF.Reg) & 0x200) >> 9
}
func (o *I2S_Type) SetRX_CONF_RX_PCM_CONF(value uint32) {
	volatile.StoreUint32(&o.RX_CONF.Reg, volatile.LoadUint32(&o.RX_CONF.Reg)&^(0xc00)|value<<10)
}
func (o *I2S_Type) GetRX_CONF_RX_PCM_CONF() uint32 {
	return (volatile.LoadUint32(&o.RX_CONF.Reg) & 0xc00) >> 10
}
func (o *I2S_Type) SetRX_CONF_RX_PCM_BYPASS(value uint32) {
	volatile.StoreUint32(&o.RX_CONF.Reg, volatile.LoadUint32(&o.RX_CONF.Reg)&^(0x1000)|value<<12)
}
func (o *I2S_Type) GetRX_CONF_RX_PCM_BYPASS() uint32 {
	return (volatile.LoadUint32(&o.RX_CONF.Reg) & 0x1000) >> 12
}
func (o *I2S_Type) SetRX_CONF_RX_STOP_MODE(value uint32) {
	volatile.StoreUint32(&o.RX_CONF.Reg, volatile.LoadUint32(&o.RX_CONF.Reg)&^(0x6000)|value<<13)
}
func (o *I2S_Type) GetRX_CONF_RX_STOP_MODE() uint32 {
	return (volatile.LoadUint32(&o.RX_CONF.Reg) & 0x6000) >> 13
}
func (o *I2S_Type) SetRX_CONF_RX_LEFT_ALIGN(value uint32) {
	volatile.StoreUint32(&o.RX_CONF.Reg, volatile.LoadUint32(&o.RX_CONF.Reg)&^(0x8000)|value<<15)
}
func (o *I2S_Type) GetRX_CONF_RX_LEFT_ALIGN() uint32 {
	return (volatile.LoadUint32(&o.RX_CONF.Reg) & 0x8000) >> 15
}
func (o *I2S_Type) SetRX_CONF_RX_24_FILL_EN(value uint32) {
	volatile.StoreUint32(&o.RX_CONF.Reg, volatile.LoadUint32(&o.RX_CONF.Reg)&^(0x10000)|value<<16)
}
func (o *I2S_Type) GetRX_CONF_RX_24_FILL_EN() uint32 {
	return (volatile.LoadUint32(&o.RX_CONF.Reg) & 0x10000) >> 16
}
func (o *I2S_Type) SetRX_CONF_RX_WS_IDLE_POL(value uint32) {
	volatile.StoreUint32(&o.RX_CONF.Reg, volatile.LoadUint32(&o.RX_CONF.Reg)&^(0x20000)|value<<17)
}
func (o *I2S_Type) GetRX_CONF_RX_WS_IDLE_POL() uint32 {
	return (volatile.LoadUint32(&o.RX_CONF.Reg) & 0x20000) >> 17
}
func (o *I2S_Type) SetRX_CONF_RX_BIT_ORDER(value uint32) {
	volatile.StoreUint32(&o.RX_CONF.Reg, volatile.LoadUint32(&o.RX_CONF.Reg)&^(0x40000)|value<<18)
}
func (o *I2S_Type) GetRX_CONF_RX_BIT_ORDER() uint32 {
	return (volatile.LoadUint32(&o.RX_CONF.Reg) & 0x40000) >> 18
}
func (o *I2S_Type) SetRX_CONF_RX_TDM_EN(value uint32) {
	volatile.StoreUint32(&o.RX_CONF.Reg, volatile.LoadUint32(&o.RX_CONF.Reg)&^(0x80000)|value<<19)
}
func (o *I2S_Type) GetRX_CONF_RX_TDM_EN() uint32 {
	return (volatile.LoadUint32(&o.RX_CONF.Reg) & 0x80000) >> 19
}
func (o *I2S_Type) SetRX_CONF_RX_PDM_EN(value uint32) {
	volatile.StoreUint32(&o.RX_CONF.Reg, volatile.LoadUint32(&o.RX_CONF.Reg)&^(0x100000)|value<<20)
}
func (o *I2S_Type) GetRX_CONF_RX_PDM_EN() uint32 {
	return (volatile.LoadUint32(&o.RX_CONF.Reg) & 0x100000) >> 20
}

// I2S.TX_CONF: I2S TX configure register
func (o *I2S_Type) SetTX_CONF_TX_RESET(value uint32) {
	volatile.StoreUint32(&o.TX_CONF.Reg, volatile.LoadUint32(&o.TX_CONF.Reg)&^(0x1)|value)
}
func (o *I2S_Type) GetTX_CONF_TX_RESET() uint32 {
	return volatile.LoadUint32(&o.TX_CONF.Reg) & 0x1
}
func (o *I2S_Type) SetTX_CONF_TX_FIFO_RESET(value uint32) {
	volatile.StoreUint32(&o.TX_CONF.Reg, volatile.LoadUint32(&o.TX_CONF.Reg)&^(0x2)|value<<1)
}
func (o *I2S_Type) GetTX_CONF_TX_FIFO_RESET() uint32 {
	return (volatile.LoadUint32(&o.TX_CONF.Reg) & 0x2) >> 1
}
func (o *I2S_Type) SetTX_CONF_TX_START(value uint32) {
	volatile.StoreUint32(&o.TX_CONF.Reg, volatile.LoadUint32(&o.TX_CONF.Reg)&^(0x4)|value<<2)
}
func (o *I2S_Type) GetTX_CONF_TX_START() uint32 {
	return (volatile.LoadUint32(&o.TX_CONF.Reg) & 0x4) >> 2
}
func (o *I2S_Type) SetTX_CONF_TX_SLAVE_MOD(value uint32) {
	volatile.StoreUint32(&o.TX_CONF.Reg, volatile.LoadUint32(&o.TX_CONF.Reg)&^(0x8)|value<<3)
}
func (o *I2S_Type) GetTX_CONF_TX_SLAVE_MOD() uint32 {
	return (volatile.LoadUint32(&o.TX_CONF.Reg) & 0x8) >> 3
}
func (o *I2S_Type) SetTX_CONF_TX_MONO(value uint32) {
	volatile.StoreUint32(&o.TX_CONF.Reg, volatile.LoadUint32(&o.TX_CONF.Reg)&^(0x20)|value<<5)
}
func (o *I2S_Type) GetTX_CONF_TX_MONO() uint32 {
	return (volatile.LoadUint32(&o.TX_CONF.Reg) & 0x20) >> 5
}
func (o *I2S_Type) SetTX_CONF_TX_CHAN_EQUAL(value uint32) {
	volatile.StoreUint32(&o.TX_CONF.Reg, volatile.LoadUint32(&o.TX_CONF.Reg)&^(0x40)|value<<6)
}
func (o *I2S_Type) GetTX_CONF_TX_CHAN_EQUAL() uint32 {
	return (volatile.LoadUint32(&o.TX_CONF.Reg) & 0x40) >> 6
}
func (o *I2S_Type) SetTX_CONF_TX_BIG_ENDIAN(value uint32) {
	volatile.StoreUint32(&o.TX_CONF.Reg, volatile.LoadUint32(&o.TX_CONF.Reg)&^(0x80)|value<<7)
}
func (o *I2S_Type) GetTX_CONF_TX_BIG_ENDIAN() uint32 {
	return (volatile.LoadUint32(&o.TX_CONF.Reg) & 0x80) >> 7
}
func (o *I2S_Type) SetTX_CONF_TX_UPDATE(value uint32) {
	volatile.StoreUint32(&o.TX_CONF.Reg, volatile.LoadUint32(&o.TX_CONF.Reg)&^(0x100)|value<<8)
}
func (o *I2S_Type) GetTX_CONF_TX_UPDATE() uint32 {
	return (volatile.LoadUint32(&o.TX_CONF.Reg) & 0x100) >> 8
}
func (o *I2S_Type) SetTX_CONF_TX_MONO_FST_VLD(value uint32) {
	volatile.StoreUint32(&o.TX_CONF.Reg, volatile.LoadUint32(&o.TX_CONF.Reg)&^(0x200)|value<<9)
}
func (o *I2S_Type) GetTX_CONF_TX_MONO_FST_VLD() uint32 {
	return (volatile.LoadUint32(&o.TX_CONF.Reg) & 0x200) >> 9
}
func (o *I2S_Type) SetTX_CONF_TX_PCM_CONF(value uint32) {
	volatile.StoreUint32(&o.TX_CONF.Reg, volatile.LoadUint32(&o.TX_CONF.Reg)&^(0xc00)|value<<10)
}
func (o *I2S_Type) GetTX_CONF_TX_PCM_CONF() uint32 {
	return (volatile.LoadUint32(&o.TX_CONF.Reg) & 0xc00) >> 10
}
func (o *I2S_Type) SetTX_CONF_TX_PCM_BYPASS(value uint32) {
	volatile.StoreUint32(&o.TX_CONF.Reg, volatile.LoadUint32(&o.TX_CONF.Reg)&^(0x1000)|value<<12)
}
func (o *I2S_Type) GetTX_CONF_TX_PCM_BYPASS() uint32 {
	return (volatile.LoadUint32(&o.TX_CONF.Reg) & 0x1000) >> 12
}
func (o *I2S_Type) SetTX_CONF_TX_STOP_EN(value uint32) {
	volatile.StoreUint32(&o.TX_CONF.Reg, volatile.LoadUint32(&o.TX_CONF.Reg)&^(0x2000)|value<<13)
}
func (o *I2S_Type) GetTX_CONF_TX_STOP_EN() uint32 {
	return (volatile.LoadUint32(&o.TX_CONF.Reg) & 0x2000) >> 13
}
func (o *I2S_Type) SetTX_CONF_TX_LEFT_ALIGN(value uint32) {
	volatile.StoreUint32(&o.TX_CONF.Reg, volatile.LoadUint32(&o.TX_CONF.Reg)&^(0x8000)|value<<15)
}
func (o *I2S_Type) GetTX_CONF_TX_LEFT_ALIGN() uint32 {
	return (volatile.LoadUint32(&o.TX_CONF.Reg) & 0x8000) >> 15
}
func (o *I2S_Type) SetTX_CONF_TX_24_FILL_EN(value uint32) {
	volatile.StoreUint32(&o.TX_CONF.Reg, volatile.LoadUint32(&o.TX_CONF.Reg)&^(0x10000)|value<<16)
}
func (o *I2S_Type) GetTX_CONF_TX_24_FILL_EN() uint32 {
	return (volatile.LoadUint32(&o.TX_CONF.Reg) & 0x10000) >> 16
}
func (o *I2S_Type) SetTX_CONF_TX_WS_IDLE_POL(value uint32) {
	volatile.StoreUint32(&o.TX_CONF.Reg, volatile.LoadUint32(&o.TX_CONF.Reg)&^(0x20000)|value<<17)
}
func (o *I2S_Type) GetTX_CONF_TX_WS_IDLE_POL() uint32 {
	return (volatile.LoadUint32(&o.TX_CONF.Reg) & 0x20000) >> 17
}
func (o *I2S_Type) SetTX_CONF_TX_BIT_ORDER(value uint32) {
	volatile.StoreUint32(&o.TX_CONF.Reg, volatile.LoadUint32(&o.TX_CONF.Reg)&^(0x40000)|value<<18)
}
func (o *I2S_Type) GetTX_CONF_TX_BIT_ORDER() uint32 {
	return (volatile.LoadUint32(&o.TX_CONF.Reg) & 0x40000) >> 18
}
func (o *I2S_Type) SetTX_CONF_TX_TDM_EN(value uint32) {
	volatile.StoreUint32(&o.TX_CONF.Reg, volatile.LoadUint32(&o.TX_CONF.Reg)&^(0x80000)|value<<19)
}
func (o *I2S_Type) GetTX_CONF_TX_TDM_EN() uint32 {
	return (volatile.LoadUint32(&o.TX_CONF.Reg) & 0x80000) >> 19
}
func (o *I2S_Type) SetTX_CONF_TX_PDM_EN(value uint32) {
	volatile.StoreUint32(&o.TX_CONF.Reg, volatile.LoadUint32(&o.TX_CONF.Reg)&^(0x100000)|value<<20)
}
func (o *I2S_Type) GetTX_CONF_TX_PDM_EN() uint32 {
	return (volatile.LoadUint32(&o.TX_CONF.Reg) & 0x100000) >> 20
}
func (o *I2S_Type) SetTX_CONF_TX_CHAN_MOD(value uint32) {
	volatile.StoreUint32(&o.TX_CONF.Reg, volatile.LoadUint32(&o.TX_CONF.Reg)&^(0x7000000)|value<<24)
}
func (o *I2S_Type) GetTX_CONF_TX_CHAN_MOD() uint32 {
	return (volatile.LoadUint32(&o.TX_CONF.Reg) & 0x7000000) >> 24
}
func (o *I2S_Type) SetTX_CONF_SIG_LOOPBACK(value uint32) {
	volatile.StoreUint32(&o.TX_CONF.Reg, volatile.LoadUint32(&o.TX_CONF.Reg)&^(0x8000000)|value<<27)
}
func (o *I2S_Type) GetTX_CONF_SIG_LOOPBACK() uint32 {
	return (volatile.LoadUint32(&o.TX_CONF.Reg) & 0x8000000) >> 27
}

// I2S.RX_CONF1: I2S RX configure register 1
func (o *I2S_Type) SetRX_CONF1_RX_TDM_WS_WIDTH(value uint32) {
	volatile.StoreUint32(&o.RX_CONF1.Reg, volatile.LoadUint32(&o.RX_CONF1.Reg)&^(0x7f)|value)
}
func (o *I2S_Type) GetRX_CONF1_RX_TDM_WS_WIDTH() uint32 {
	return volatile.LoadUint32(&o.RX_CONF1.Reg) & 0x7f
}
func (o *I2S_Type) SetRX_CONF1_RX_BCK_DIV_NUM(value uint32) {
	volatile.StoreUint32(&o.RX_CONF1.Reg, volatile.LoadUint32(&o.RX_CONF1.Reg)&^(0x1f80)|value<<7)
}
func (o *I2S_Type) GetRX_CONF1_RX_BCK_DIV_NUM() uint32 {
	return (volatile.LoadUint32(&o.RX_CONF1.Reg) & 0x1f80) >> 7
}
func (o *I2S_Type) SetRX_CONF1_RX_BITS_MOD(value uint32) {
	volatile.StoreUint32(&o.RX_CONF1.Reg, volatile.LoadUint32(&o.RX_CONF1.Reg)&^(0x3e000)|value<<13)
}
func (o *I2S_Type) GetRX_CONF1_RX_BITS_MOD() uint32 {
	return (volatile.LoadUint32(&o.RX_CONF1.Reg) & 0x3e000) >> 13
}
func (o *I2S_Type) SetRX_CONF1_RX_HALF_SAMPLE_BITS(value uint32) {
	volatile.StoreUint32(&o.RX_CONF1.Reg, volatile.LoadUint32(&o.RX_CONF1.Reg)&^(0xfc0000)|value<<18)
}
func (o *I2S_Type) GetRX_CONF1_RX_HALF_SAMPLE_BITS() uint32 {
	return (volatile.LoadUint32(&o.RX_CONF1.Reg) & 0xfc0000) >> 18
}
func (o *I2S_Type) SetRX_CONF1_RX_TDM_CHAN_BITS(value uint32) {
	volatile.StoreUint32(&o.RX_CONF1.Reg, volatile.LoadUint32(&o.RX_CONF1.Reg)&^(0x1f000000)|value<<24)
}
func (o *I2S_Type) GetRX_CONF1_RX_TDM_CHAN_BITS() uint32 {
	return (volatile.LoadUint32(&o.RX_CONF1.Reg) & 0x1f000000) >> 24
}
func (o *I2S_Type) SetRX_CONF1_RX_MSB_SHIFT(value uint32) {
	volatile.StoreUint32(&o.RX_CONF1.Reg, volatile.LoadUint32(&o.RX_CONF1.Reg)&^(0x20000000)|value<<29)
}
func (o *I2S_Type) GetRX_CONF1_RX_MSB_SHIFT() uint32 {
	return (volatile.LoadUint32(&o.RX_CONF1.Reg) & 0x20000000) >> 29
}

// I2S.TX_CONF1: I2S TX configure register 1
func (o *I2S_Type) SetTX_CONF1_TX_TDM_WS_WIDTH(value uint32) {
	volatile.StoreUint32(&o.TX_CONF1.Reg, volatile.LoadUint32(&o.TX_CONF1.Reg)&^(0x7f)|value)
}
func (o *I2S_Type) GetTX_CONF1_TX_TDM_WS_WIDTH() uint32 {
	return volatile.LoadUint32(&o.TX_CONF1.Reg) & 0x7f
}
func (o *I2S_Type) SetTX_CONF1_TX_BCK_DIV_NUM(value uint32) {
	volatile.StoreUint32(&o.TX_CONF1.Reg, volatile.LoadUint32(&o.TX_CONF1.Reg)&^(0x1f80)|value<<7)
}
func (o *I2S_Type) GetTX_CONF1_TX_BCK_DIV_NUM() uint32 {
	return (volatile.LoadUint32(&o.TX_CONF1.Reg) & 0x1f80) >> 7
}
func (o *I2S_Type) SetTX_CONF1_TX_BITS_MOD(value uint32) {
	volatile.StoreUint32(&o.TX_CONF1.Reg, volatile.LoadUint32(&o.TX_CONF1.Reg)&^(0x3e000)|value<<13)
}
func (o *I2S_Type) GetTX_CONF1_TX_BITS_MOD() uint32 {
	return (volatile.LoadUint32(&o.TX_CONF1.Reg) & 0x3e000) >> 13
}
func (o *I2S_Type) SetTX_CONF1_TX_HALF_SAMPLE_BITS(value uint32) {
	volatile.StoreUint32(&o.TX_CONF1.Reg, volatile.LoadUint32(&o.TX_CONF1.Reg)&^(0xfc0000)|value<<18)
}
func (o *I2S_Type) GetTX_CONF1_TX_HALF_SAMPLE_BITS() uint32 {
	return (volatile.LoadUint32(&o.TX_CONF1.Reg) & 0xfc0000) >> 18
}
func (o *I2S_Type) SetTX_CONF1_TX_TDM_CHAN_BITS(value uint32) {
	volatile.StoreUint32(&o.TX_CONF1.Reg, volatile.LoadUint32(&o.TX_CONF1.Reg)&^(0x1f000000)|value<<24)
}
func (o *I2S_Type) GetTX_CONF1_TX_TDM_CHAN_BITS() uint32 {
	return (volatile.LoadUint32(&o.TX_CONF1.Reg) & 0x1f000000) >> 24
}
func (o *I2S_Type) SetTX_CONF1_TX_MSB_SHIFT(value uint32) {
	volatile.StoreUint32(&o.TX_CONF1.Reg, volatile.LoadUint32(&o.TX_CONF1.Reg)&^(0x20000000)|value<<29)
}
func (o *I2S_Type) GetTX_CONF1_TX_MSB_SHIFT() uint32 {
	return (volatile.LoadUint32(&o.TX_CONF1.Reg) & 0x20000000) >> 29
}
func (o *I2S_Type) SetTX_CONF1_TX_BCK_NO_DLY(value uint32) {
	volatile.StoreUint32(&o.TX_CONF1.Reg, volatile.LoadUint32(&o.TX_CONF1.Reg)&^(0x40000000)|value<<30)
}
func (o *I2S_Type) GetTX_CONF1_TX_BCK_NO_DLY() uint32 {
	return (volatile.LoadUint32(&o.TX_CONF1.Reg) & 0x40000000) >> 30
}

// I2S.RX_CLKM_CONF: I2S RX clock configure register
func (o *I2S_Type) SetRX_CLKM_CONF_RX_CLKM_DIV_NUM(value uint32) {
	volatile.StoreUint32(&o.RX_CLKM_CONF.Reg, volatile.LoadUint32(&o.RX_CLKM_CONF.Reg)&^(0xff)|value)
}
func (o *I2S_Type) GetRX_CLKM_CONF_RX_CLKM_DIV_NUM() uint32 {
	return volatile.LoadUint32(&o.RX_CLKM_CONF.Reg) & 0xff
}
func (o *I2S_Type) SetRX_CLKM_CONF_RX_CLK_ACTIVE(value uint32) {
	volatile.StoreUint32(&o.RX_CLKM_CONF.Reg, volatile.LoadUint32(&o.RX_CLKM_CONF.Reg)&^(0x4000000)|value<<26)
}
func (o *I2S_Type) GetRX_CLKM_CONF_RX_CLK_ACTIVE() uint32 {
	return (volatile.LoadUint32(&o.RX_CLKM_CONF.Reg) & 0x4000000) >> 26
}
func (o *I2S_Type) SetRX_CLKM_CONF_RX_CLK_SEL(value uint32) {
	volatile.StoreUint32(&o.RX_CLKM_CONF.Reg, volatile.LoadUint32(&o.RX_CLKM_CONF.Reg)&^(0x18000000)|value<<27)
}
func (o *I2S_Type) GetRX_CLKM_CONF_RX_CLK_SEL() uint32 {
	return (volatile.LoadUint32(&o.RX_CLKM_CONF.Reg) & 0x18000000) >> 27
}
func (o *I2S_Type) SetRX_CLKM_CONF_MCLK_SEL(value uint32) {
	volatile.StoreUint32(&o.RX_CLKM_CONF.Reg, volatile.LoadUint32(&o.RX_CLKM_CONF.Reg)&^(0x20000000)|value<<29)
}
func (o *I2S_Type) GetRX_CLKM_CONF_MCLK_SEL() uint32 {
	return (volatile.LoadUint32(&o.RX_CLKM_CONF.Reg) & 0x20000000) >> 29
}

// I2S.TX_CLKM_CONF: I2S TX clock configure register
func (o *I2S_Type) SetTX_CLKM_CONF_TX_CLKM_DIV_NUM(value uint32) {
	volatile.StoreUint32(&o.TX_CLKM_CONF.Reg, volatile.LoadUint32(&o.TX_CLKM_CONF.Reg)&^(0xff)|value)
}
func (o *I2S_Type) GetTX_CLKM_CONF_TX_CLKM_DIV_NUM() uint32 {
	return volatile.LoadUint32(&o.TX_CLKM_CONF.Reg) & 0xff
}
func (o *I2S_Type) SetTX_CLKM_CONF_TX_CLK_ACTIVE(value uint32) {
	volatile.StoreUint32(&o.TX_CLKM_CONF.Reg, volatile.LoadUint32(&o.TX_CLKM_CONF.Reg)&^(0x4000000)|value<<26)
}
func (o *I2S_Type) GetTX_CLKM_CONF_TX_CLK_ACTIVE() uint32 {
	return (volatile.LoadUint32(&o.TX_CLKM_CONF.Reg) & 0x4000000) >> 26
}
func (o *I2S_Type) SetTX_CLKM_CONF_TX_CLK_SEL(value uint32) {
	volatile.StoreUint32(&o.TX_CLKM_CONF.Reg, volatile.LoadUint32(&o.TX_CLKM_CONF.Reg)&^(0x18000000)|value<<27)
}
func (o *I2S_Type) GetTX_CLKM_CONF_TX_CLK_SEL() uint32 {
	return (volatile.LoadUint32(&o.TX_CLKM_CONF.Reg) & 0x18000000) >> 27
}
func (o *I2S_Type) SetTX_CLKM_CONF_CLK_EN(value uint32) {
	volatile.StoreUint32(&o.TX_CLKM_CONF.Reg, volatile.LoadUint32(&o.TX_CLKM_CONF.Reg)&^(0x20000000)|value<<29)
}
func (o *I2S_Type) GetTX_CLKM_CONF_CLK_EN() uint32 {
	return (volatile.LoadUint32(&o.TX_CLKM_CONF.Reg) & 0x20000000) >> 29
}

// I2S.RX_CLKM_DIV_CONF: I2S RX module clock divider configure register
func (o *I2S_Type) SetRX_CLKM_DIV_CONF_RX_CLKM_DIV_Z(value uint32) {
	volatile.StoreUint32(&o.RX_CLKM_DIV_CONF.Reg, volatile.LoadUint32(&o.RX_CLKM_DIV_CONF.Reg)&^(0x1ff)|value)
}
func (o *I2S_Type) GetRX_CLKM_DIV_CONF_RX_CLKM_DIV_Z() uint32 {
	return volatile.LoadUint32(&o.RX_CLKM_DIV_CONF.Reg) & 0x1ff
}
func (o *I2S_Type) SetRX_CLKM_DIV_CONF_RX_CLKM_DIV_Y(value uint32) {
	volatile.StoreUint32(&o.RX_CLKM_DIV_CONF.Reg, volatile.LoadUint32(&o.RX_CLKM_DIV_CONF.Reg)&^(0x3fe00)|value<<9)
}
func (o *I2S_Type) GetRX_CLKM_DIV_CONF_RX_CLKM_DIV_Y() uint32 {
	return (volatile.LoadUint32(&o.RX_CLKM_DIV_CONF.Reg) & 0x3fe00) >> 9
}
func (o *I2S_Type) SetRX_CLKM_DIV_CONF_RX_CLKM_DIV_X(value uint32) {
	volatile.StoreUint32(&o.RX_CLKM_DIV_CONF.Reg, volatile.LoadUint32(&o.RX_CLKM_DIV_CONF.Reg)&^(0x7fc0000)|value<<18)
}
func (o *I2S_Type) GetRX_CLKM_DIV_CONF_RX_CLKM_DIV_X() uint32 {
	return (volatile.LoadUint32(&o.RX_CLKM_DIV_CONF.Reg) & 0x7fc0000) >> 18
}
func (o *I2S_Type) SetRX_CLKM_DIV_CONF_RX_CLKM_DIV_YN1(value uint32) {
	volatile.StoreUint32(&o.RX_CLKM_DIV_CONF.Reg, volatile.LoadUint32(&o.RX_CLKM_DIV_CONF.Reg)&^(0x8000000)|value<<27)
}
func (o *I2S_Type) GetRX_CLKM_DIV_CONF_RX_CLKM_DIV_YN1() uint32 {
	return (volatile.LoadUint32(&o.RX_CLKM_DIV_CONF.Reg) & 0x8000000) >> 27
}

// I2S.TX_CLKM_DIV_CONF: I2S TX module clock divider configure register
func (o *I2S_Type) SetTX_CLKM_DIV_CONF_TX_CLKM_DIV_Z(value uint32) {
	volatile.StoreUint32(&o.TX_CLKM_DIV_CONF.Reg, volatile.LoadUint32(&o.TX_CLKM_DIV_CONF.Reg)&^(0x1ff)|value)
}
func (o *I2S_Type) GetTX_CLKM_DIV_CONF_TX_CLKM_DIV_Z() uint32 {
	return volatile.LoadUint32(&o.TX_CLKM_DIV_CONF.Reg) & 0x1ff
}
func (o *I2S_Type) SetTX_CLKM_DIV_CONF_TX_CLKM_DIV_Y(value uint32) {
	volatile.StoreUint32(&o.TX_CLKM_DIV_CONF.Reg, volatile.LoadUint32(&o.TX_CLKM_DIV_CONF.Reg)&^(0x3fe00)|value<<9)
}
func (o *I2S_Type) GetTX_CLKM_DIV_CONF_TX_CLKM_DIV_Y() uint32 {
	return (volatile.LoadUint32(&o.TX_CLKM_DIV_CONF.Reg) & 0x3fe00) >> 9
}
func (o *I2S_Type) SetTX_CLKM_DIV_CONF_TX_CLKM_DIV_X(value uint32) {
	volatile.StoreUint32(&o.TX_CLKM_DIV_CONF.Reg, volatile.LoadUint32(&o.TX_CLKM_DIV_CONF.Reg)&^(0x7fc0000)|value<<18)
}
func (o *I2S_Type) GetTX_CLKM_DIV_CONF_TX_CLKM_DIV_X() uint32 {
	return (volatile.LoadUint32(&o.TX_CLKM_DIV_CONF.Reg) & 0x7fc0000) >> 18
}
func (o *I2S_Type) SetTX_CLKM_DIV_CONF_TX_CLKM_DIV_YN1(value uint32) {
	volatile.StoreUint32(&o.TX_CLKM_DIV_CONF.Reg, volatile.LoadUint32(&o.TX_CLKM_DIV_CONF.Reg)&^(0x8000000)|value<<27)
}
func (o *I2S_Type) GetTX_CLKM_DIV_CONF_TX_CLKM_DIV_YN1() uint32 {
	return (volatile.LoadUint32(&o.TX_CLKM_DIV_CONF.Reg) & 0x8000000) >> 27
}

// I2S.TX_PCM2PDM_CONF: I2S TX PCM2PDM configuration register
func (o *I2S_Type) SetTX_PCM2PDM_CONF_TX_PDM_HP_BYPASS(value uint32) {
	volatile.StoreUint32(&o.TX_PCM2PDM_CONF.Reg, volatile.LoadUint32(&o.TX_PCM2PDM_CONF.Reg)&^(0x1)|value)
}
func (o *I2S_Type) GetTX_PCM2PDM_CONF_TX_PDM_HP_BYPASS() uint32 {
	return volatile.LoadUint32(&o.TX_PCM2PDM_CONF.Reg) & 0x1
}
func (o *I2S_Type) SetTX_PCM2PDM_CONF_TX_PDM_SINC_OSR2(value uint32) {
	volatile.StoreUint32(&o.TX_PCM2PDM_CONF.Reg, volatile.LoadUint32(&o.TX_PCM2PDM_CONF.Reg)&^(0x1e)|value<<1)
}
func (o *I2S_Type) GetTX_PCM2PDM_CONF_TX_PDM_SINC_OSR2() uint32 {
	return (volatile.LoadUint32(&o.TX_PCM2PDM_CONF.Reg) & 0x1e) >> 1
}
func (o *I2S_Type) SetTX_PCM2PDM_CONF_TX_PDM_PRESCALE(value uint32) {
	volatile.StoreUint32(&o.TX_PCM2PDM_CONF.Reg, volatile.LoadUint32(&o.TX_PCM2PDM_CONF.Reg)&^(0x1fe0)|value<<5)
}
func (o *I2S_Type) GetTX_PCM2PDM_CONF_TX_PDM_PRESCALE() uint32 {
	return (volatile.LoadUint32(&o.TX_PCM2PDM_CONF.Reg) & 0x1fe0) >> 5
}
func (o *I2S_Type) SetTX_PCM2PDM_CONF_TX_PDM_HP_IN_SHIFT(value uint32) {
	volatile.StoreUint32(&o.TX_PCM2PDM_CONF.Reg, volatile.LoadUint32(&o.TX_PCM2PDM_CONF.Reg)&^(0x6000)|value<<13)
}
func (o *I2S_Type) GetTX_PCM2PDM_CONF_TX_PDM_HP_IN_SHIFT() uint32 {
	return (volatile.LoadUint32(&o.TX_PCM2PDM_CONF.Reg) & 0x6000) >> 13
}
func (o *I2S_Type) SetTX_PCM2PDM_CONF_TX_PDM_LP_IN_SHIFT(value uint32) {
	volatile.StoreUint32(&o.TX_PCM2PDM_CONF.Reg, volatile.LoadUint32(&o.TX_PCM2PDM_CONF.Reg)&^(0x18000)|value<<15)
}
func (o *I2S_Type) GetTX_PCM2PDM_CONF_TX_PDM_LP_IN_SHIFT() uint32 {
	return (volatile.LoadUint32(&o.TX_PCM2PDM_CONF.Reg) & 0x18000) >> 15
}
func (o *I2S_Type) SetTX_PCM2PDM_CONF_TX_PDM_SINC_IN_SHIFT(value uint32) {
	volatile.StoreUint32(&o.TX_PCM2PDM_CONF.Reg, volatile.LoadUint32(&o.TX_PCM2PDM_CONF.Reg)&^(0x60000)|value<<17)
}
func (o *I2S_Type) GetTX_PCM2PDM_CONF_TX_PDM_SINC_IN_SHIFT() uint32 {
	return (volatile.LoadUint32(&o.TX_PCM2PDM_CONF.Reg) & 0x60000) >> 17
}
func (o *I2S_Type) SetTX_PCM2PDM_CONF_TX_PDM_SIGMADELTA_IN_SHIFT(value uint32) {
	volatile.StoreUint32(&o.TX_PCM2PDM_CONF.Reg, volatile.LoadUint32(&o.TX_PCM2PDM_CONF.Reg)&^(0x180000)|value<<19)
}
func (o *I2S_Type) GetTX_PCM2PDM_CONF_TX_PDM_SIGMADELTA_IN_SHIFT() uint32 {
	return (volatile.LoadUint32(&o.TX_PCM2PDM_CONF.Reg) & 0x180000) >> 19
}
func (o *I2S_Type) SetTX_PCM2PDM_CONF_TX_PDM_SIGMADELTA_DITHER2(value uint32) {
	volatile.StoreUint32(&o.TX_PCM2PDM_CONF.Reg, volatile.LoadUint32(&o.TX_PCM2PDM_CONF.Reg)&^(0x200000)|value<<21)
}
func (o *I2S_Type) GetTX_PCM2PDM_CONF_TX_PDM_SIGMADELTA_DITHER2() uint32 {
	return (volatile.LoadUint32(&o.TX_PCM2PDM_CONF.Reg) & 0x200000) >> 21
}
func (o *I2S_Type) SetTX_PCM2PDM_CONF_TX_PDM_SIGMADELTA_DITHER(value uint32) {
	volatile.StoreUint32(&o.TX_PCM2PDM_CONF.Reg, volatile.LoadUint32(&o.TX_PCM2PDM_CONF.Reg)&^(0x400000)|value<<22)
}
func (o *I2S_Type) GetTX_PCM2PDM_CONF_TX_PDM_SIGMADELTA_DITHER() uint32 {
	return (volatile.LoadUint32(&o.TX_PCM2PDM_CONF.Reg) & 0x400000) >> 22
}
func (o *I2S_Type) SetTX_PCM2PDM_CONF_TX_PDM_DAC_2OUT_EN(value uint32) {
	volatile.StoreUint32(&o.TX_PCM2PDM_CONF.Reg, volatile.LoadUint32(&o.TX_PCM2PDM_CONF.Reg)&^(0x800000)|value<<23)
}
func (o *I2S_Type) GetTX_PCM2PDM_CONF_TX_PDM_DAC_2OUT_EN() uint32 {
	return (volatile.LoadUint32(&o.TX_PCM2PDM_CONF.Reg) & 0x800000) >> 23
}
func (o *I2S_Type) SetTX_PCM2PDM_CONF_TX_PDM_DAC_MODE_EN(value uint32) {
	volatile.StoreUint32(&o.TX_PCM2PDM_CONF.Reg, volatile.LoadUint32(&o.TX_PCM2PDM_CONF.Reg)&^(0x1000000)|value<<24)
}
func (o *I2S_Type) GetTX_PCM2PDM_CONF_TX_PDM_DAC_MODE_EN() uint32 {
	return (volatile.LoadUint32(&o.TX_PCM2PDM_CONF.Reg) & 0x1000000) >> 24
}
func (o *I2S_Type) SetTX_PCM2PDM_CONF_PCM2PDM_CONV_EN(value uint32) {
	volatile.StoreUint32(&o.TX_PCM2PDM_CONF.Reg, volatile.LoadUint32(&o.TX_PCM2PDM_CONF.Reg)&^(0x2000000)|value<<25)
}
func (o *I2S_Type) GetTX_PCM2PDM_CONF_PCM2PDM_CONV_EN() uint32 {
	return (volatile.LoadUint32(&o.TX_PCM2PDM_CONF.Reg) & 0x2000000) >> 25
}

// I2S.TX_PCM2PDM_CONF1: I2S TX PCM2PDM configuration register
func (o *I2S_Type) SetTX_PCM2PDM_CONF1_TX_PDM_FP(value uint32) {
	volatile.StoreUint32(&o.TX_PCM2PDM_CONF1.Reg, volatile.LoadUint32(&o.TX_PCM2PDM_CONF1.Reg)&^(0x3ff)|value)
}
func (o *I2S_Type) GetTX_PCM2PDM_CONF1_TX_PDM_FP() uint32 {
	return volatile.LoadUint32(&o.TX_PCM2PDM_CONF1.Reg) & 0x3ff
}
func (o *I2S_Type) SetTX_PCM2PDM_CONF1_TX_PDM_FS(value uint32) {
	volatile.StoreUint32(&o.TX_PCM2PDM_CONF1.Reg, volatile.LoadUint32(&o.TX_PCM2PDM_CONF1.Reg)&^(0xffc00)|value<<10)
}
func (o *I2S_Type) GetTX_PCM2PDM_CONF1_TX_PDM_FS() uint32 {
	return (volatile.LoadUint32(&o.TX_PCM2PDM_CONF1.Reg) & 0xffc00) >> 10
}
func (o *I2S_Type) SetTX_PCM2PDM_CONF1_TX_IIR_HP_MULT12_5(value uint32) {
	volatile.StoreUint32(&o.TX_PCM2PDM_CONF1.Reg, volatile.LoadUint32(&o.TX_PCM2PDM_CONF1.Reg)&^(0x700000)|value<<20)
}
func (o *I2S_Type) GetTX_PCM2PDM_CONF1_TX_IIR_HP_MULT12_5() uint32 {
	return (volatile.LoadUint32(&o.TX_PCM2PDM_CONF1.Reg) & 0x700000) >> 20
}
func (o *I2S_Type) SetTX_PCM2PDM_CONF1_TX_IIR_HP_MULT12_0(value uint32) {
	volatile.StoreUint32(&o.TX_PCM2PDM_CONF1.Reg, volatile.LoadUint32(&o.TX_PCM2PDM_CONF1.Reg)&^(0x3800000)|value<<23)
}
func (o *I2S_Type) GetTX_PCM2PDM_CONF1_TX_IIR_HP_MULT12_0() uint32 {
	return (volatile.LoadUint32(&o.TX_PCM2PDM_CONF1.Reg) & 0x3800000) >> 23
}

// I2S.RX_TDM_CTRL: I2S TX TDM mode control register
func (o *I2S_Type) SetRX_TDM_CTRL_RX_TDM_PDM_CHAN0_EN(value uint32) {
	volatile.StoreUint32(&o.RX_TDM_CTRL.Reg, volatile.LoadUint32(&o.RX_TDM_CTRL.Reg)&^(0x1)|value)
}
func (o *I2S_Type) GetRX_TDM_CTRL_RX_TDM_PDM_CHAN0_EN() uint32 {
	return volatile.LoadUint32(&o.RX_TDM_CTRL.Reg) & 0x1
}
func (o *I2S_Type) SetRX_TDM_CTRL_RX_TDM_PDM_CHAN1_EN(value uint32) {
	volatile.StoreUint32(&o.RX_TDM_CTRL.Reg, volatile.LoadUint32(&o.RX_TDM_CTRL.Reg)&^(0x2)|value<<1)
}
func (o *I2S_Type) GetRX_TDM_CTRL_RX_TDM_PDM_CHAN1_EN() uint32 {
	return (volatile.LoadUint32(&o.RX_TDM_CTRL.Reg) & 0x2) >> 1
}
func (o *I2S_Type) SetRX_TDM_CTRL_RX_TDM_PDM_CHAN2_EN(value uint32) {
	volatile.StoreUint32(&o.RX_TDM_CTRL.Reg, volatile.LoadUint32(&o.RX_TDM_CTRL.Reg)&^(0x4)|value<<2)
}
func (o *I2S_Type) GetRX_TDM_CTRL_RX_TDM_PDM_CHAN2_EN() uint32 {
	return (volatile.LoadUint32(&o.RX_TDM_CTRL.Reg) & 0x4) >> 2
}
func (o *I2S_Type) SetRX_TDM_CTRL_RX_TDM_PDM_CHAN3_EN(value uint32) {
	volatile.StoreUint32(&o.RX_TDM_CTRL.Reg, volatile.LoadUint32(&o.RX_TDM_CTRL.Reg)&^(0x8)|value<<3)
}
func (o *I2S_Type) GetRX_TDM_CTRL_RX_TDM_PDM_CHAN3_EN() uint32 {
	return (volatile.LoadUint32(&o.RX_TDM_CTRL.Reg) & 0x8) >> 3
}
func (o *I2S_Type) SetRX_TDM_CTRL_RX_TDM_PDM_CHAN4_EN(value uint32) {
	volatile.StoreUint32(&o.RX_TDM_CTRL.Reg, volatile.LoadUint32(&o.RX_TDM_CTRL.Reg)&^(0x10)|value<<4)
}
func (o *I2S_Type) GetRX_TDM_CTRL_RX_TDM_PDM_CHAN4_EN() uint32 {
	return (volatile.LoadUint32(&o.RX_TDM_CTRL.Reg) & 0x10) >> 4
}
func (o *I2S_Type) SetRX_TDM_CTRL_RX_TDM_PDM_CHAN5_EN(value uint32) {
	volatile.StoreUint32(&o.RX_TDM_CTRL.Reg, volatile.LoadUint32(&o.RX_TDM_CTRL.Reg)&^(0x20)|value<<5)
}
func (o *I2S_Type) GetRX_TDM_CTRL_RX_TDM_PDM_CHAN5_EN() uint32 {
	return (volatile.LoadUint32(&o.RX_TDM_CTRL.Reg) & 0x20) >> 5
}
func (o *I2S_Type) SetRX_TDM_CTRL_RX_TDM_PDM_CHAN6_EN(value uint32) {
	volatile.StoreUint32(&o.RX_TDM_CTRL.Reg, volatile.LoadUint32(&o.RX_TDM_CTRL.Reg)&^(0x40)|value<<6)
}
func (o *I2S_Type) GetRX_TDM_CTRL_RX_TDM_PDM_CHAN6_EN() uint32 {
	return (volatile.LoadUint32(&o.RX_TDM_CTRL.Reg) & 0x40) >> 6
}
func (o *I2S_Type) SetRX_TDM_CTRL_RX_TDM_PDM_CHAN7_EN(value uint32) {
	volatile.StoreUint32(&o.RX_TDM_CTRL.Reg, volatile.LoadUint32(&o.RX_TDM_CTRL.Reg)&^(0x80)|value<<7)
}
func (o *I2S_Type) GetRX_TDM_CTRL_RX_TDM_PDM_CHAN7_EN() uint32 {
	return (volatile.LoadUint32(&o.RX_TDM_CTRL.Reg) & 0x80) >> 7
}
func (o *I2S_Type) SetRX_TDM_CTRL_RX_TDM_CHAN8_EN(value uint32) {
	volatile.StoreUint32(&o.RX_TDM_CTRL.Reg, volatile.LoadUint32(&o.RX_TDM_CTRL.Reg)&^(0x100)|value<<8)
}
func (o *I2S_Type) GetRX_TDM_CTRL_RX_TDM_CHAN8_EN() uint32 {
	return (volatile.LoadUint32(&o.RX_TDM_CTRL.Reg) & 0x100) >> 8
}
func (o *I2S_Type) SetRX_TDM_CTRL_RX_TDM_CHAN9_EN(value uint32) {
	volatile.StoreUint32(&o.RX_TDM_CTRL.Reg, volatile.LoadUint32(&o.RX_TDM_CTRL.Reg)&^(0x200)|value<<9)
}
func (o *I2S_Type) GetRX_TDM_CTRL_RX_TDM_CHAN9_EN() uint32 {
	return (volatile.LoadUint32(&o.RX_TDM_CTRL.Reg) & 0x200) >> 9
}
func (o *I2S_Type) SetRX_TDM_CTRL_RX_TDM_CHAN10_EN(value uint32) {
	volatile.StoreUint32(&o.RX_TDM_CTRL.Reg, volatile.LoadUint32(&o.RX_TDM_CTRL.Reg)&^(0x400)|value<<10)
}
func (o *I2S_Type) GetRX_TDM_CTRL_RX_TDM_CHAN10_EN() uint32 {
	return (volatile.LoadUint32(&o.RX_TDM_CTRL.Reg) & 0x400) >> 10
}
func (o *I2S_Type) SetRX_TDM_CTRL_RX_TDM_CHAN11_EN(value uint32) {
	volatile.StoreUint32(&o.RX_TDM_CTRL.Reg, volatile.LoadUint32(&o.RX_TDM_CTRL.Reg)&^(0x800)|value<<11)
}
func (o *I2S_Type) GetRX_TDM_CTRL_RX_TDM_CHAN11_EN() uint32 {
	return (volatile.LoadUint32(&o.RX_TDM_CTRL.Reg) & 0x800) >> 11
}
func (o *I2S_Type) SetRX_TDM_CTRL_RX_TDM_CHAN12_EN(value uint32) {
	volatile.StoreUint32(&o.RX_TDM_CTRL.Reg, volatile.LoadUint32(&o.RX_TDM_CTRL.Reg)&^(0x1000)|value<<12)
}
func (o *I2S_Type) GetRX_TDM_CTRL_RX_TDM_CHAN12_EN() uint32 {
	return (volatile.LoadUint32(&o.RX_TDM_CTRL.Reg) & 0x1000) >> 12
}
func (o *I2S_Type) SetRX_TDM_CTRL_RX_TDM_CHAN13_EN(value uint32) {
	volatile.StoreUint32(&o.RX_TDM_CTRL.Reg, volatile.LoadUint32(&o.RX_TDM_CTRL.Reg)&^(0x2000)|value<<13)
}
func (o *I2S_Type) GetRX_TDM_CTRL_RX_TDM_CHAN13_EN() uint32 {
	return (volatile.LoadUint32(&o.RX_TDM_CTRL.Reg) & 0x2000) >> 13
}
func (o *I2S_Type) SetRX_TDM_CTRL_RX_TDM_CHAN14_EN(value uint32) {
	volatile.StoreUint32(&o.RX_TDM_CTRL.Reg, volatile.LoadUint32(&o.RX_TDM_CTRL.Reg)&^(0x4000)|value<<14)
}
func (o *I2S_Type) GetRX_TDM_CTRL_RX_TDM_CHAN14_EN() uint32 {
	return (volatile.LoadUint32(&o.RX_TDM_CTRL.Reg) & 0x4000) >> 14
}
func (o *I2S_Type) SetRX_TDM_CTRL_RX_TDM_CHAN15_EN(value uint32) {
	volatile.StoreUint32(&o.RX_TDM_CTRL.Reg, volatile.LoadUint32(&o.RX_TDM_CTRL.Reg)&^(0x8000)|value<<15)
}
func (o *I2S_Type) GetRX_TDM_CTRL_RX_TDM_CHAN15_EN() uint32 {
	return (volatile.LoadUint32(&o.RX_TDM_CTRL.Reg) & 0x8000) >> 15
}
func (o *I2S_Type) SetRX_TDM_CTRL_RX_TDM_TOT_CHAN_NUM(value uint32) {
	volatile.StoreUint32(&o.RX_TDM_CTRL.Reg, volatile.LoadUint32(&o.RX_TDM_CTRL.Reg)&^(0xf0000)|value<<16)
}
func (o *I2S_Type) GetRX_TDM_CTRL_RX_TDM_TOT_CHAN_NUM() uint32 {
	return (volatile.LoadUint32(&o.RX_TDM_CTRL.Reg) & 0xf0000) >> 16
}

// I2S.TX_TDM_CTRL: I2S TX TDM mode control register
func (o *I2S_Type) SetTX_TDM_CTRL_TX_TDM_CHAN0_EN(value uint32) {
	volatile.StoreUint32(&o.TX_TDM_CTRL.Reg, volatile.LoadUint32(&o.TX_TDM_CTRL.Reg)&^(0x1)|value)
}
func (o *I2S_Type) GetTX_TDM_CTRL_TX_TDM_CHAN0_EN() uint32 {
	return volatile.LoadUint32(&o.TX_TDM_CTRL.Reg) & 0x1
}
func (o *I2S_Type) SetTX_TDM_CTRL_TX_TDM_CHAN1_EN(value uint32) {
	volatile.StoreUint32(&o.TX_TDM_CTRL.Reg, volatile.LoadUint32(&o.TX_TDM_CTRL.Reg)&^(0x2)|value<<1)
}
func (o *I2S_Type) GetTX_TDM_CTRL_TX_TDM_CHAN1_EN() uint32 {
	return (volatile.LoadUint32(&o.TX_TDM_CTRL.Reg) & 0x2) >> 1
}
func (o *I2S_Type) SetTX_TDM_CTRL_TX_TDM_CHAN2_EN(value uint32) {
	volatile.StoreUint32(&o.TX_TDM_CTRL.Reg, volatile.LoadUint32(&o.TX_TDM_CTRL.Reg)&^(0x4)|value<<2)
}
func (o *I2S_Type) GetTX_TDM_CTRL_TX_TDM_CHAN2_EN() uint32 {
	return (volatile.LoadUint32(&o.TX_TDM_CTRL.Reg) & 0x4) >> 2
}
func (o *I2S_Type) SetTX_TDM_CTRL_TX_TDM_CHAN3_EN(value uint32) {
	volatile.StoreUint32(&o.TX_TDM_CTRL.Reg, volatile.LoadUint32(&o.TX_TDM_CTRL.Reg)&^(0x8)|value<<3)
}
func (o *I2S_Type) GetTX_TDM_CTRL_TX_TDM_CHAN3_EN() uint32 {
	return (volatile.LoadUint32(&o.TX_TDM_CTRL.Reg) & 0x8) >> 3
}
func (o *I2S_Type) SetTX_TDM_CTRL_TX_TDM_CHAN4_EN(value uint32) {
	volatile.StoreUint32(&o.TX_TDM_CTRL.Reg, volatile.LoadUint32(&o.TX_TDM_CTRL.Reg)&^(0x10)|value<<4)
}
func (o *I2S_Type) GetTX_TDM_CTRL_TX_TDM_CHAN4_EN() uint32 {
	return (volatile.LoadUint32(&o.TX_TDM_CTRL.Reg) & 0x10) >> 4
}
func (o *I2S_Type) SetTX_TDM_CTRL_TX_TDM_CHAN5_EN(value uint32) {
	volatile.StoreUint32(&o.TX_TDM_CTRL.Reg, volatile.LoadUint32(&o.TX_TDM_CTRL.Reg)&^(0x20)|value<<5)
}
func (o *I2S_Type) GetTX_TDM_CTRL_TX_TDM_CHAN5_EN() uint32 {
	return (volatile.LoadUint32(&o.TX_TDM_CTRL.Reg) & 0x20) >> 5
}
func (o *I2S_Type) SetTX_TDM_CTRL_TX_TDM_CHAN6_EN(value uint32) {
	volatile.StoreUint32(&o.TX_TDM_CTRL.Reg, volatile.LoadUint32(&o.TX_TDM_CTRL.Reg)&^(0x40)|value<<6)
}
func (o *I2S_Type) GetTX_TDM_CTRL_TX_TDM_CHAN6_EN() uint32 {
	return (volatile.LoadUint32(&o.TX_TDM_CTRL.Reg) & 0x40) >> 6
}
func (o *I2S_Type) SetTX_TDM_CTRL_TX_TDM_CHAN7_EN(value uint32) {
	volatile.StoreUint32(&o.TX_TDM_CTRL.Reg, volatile.LoadUint32(&o.TX_TDM_CTRL.Reg)&^(0x80)|value<<7)
}
func (o *I2S_Type) GetTX_TDM_CTRL_TX_TDM_CHAN7_EN() uint32 {
	return (volatile.LoadUint32(&o.TX_TDM_CTRL.Reg) & 0x80) >> 7
}
func (o *I2S_Type) SetTX_TDM_CTRL_TX_TDM_CHAN8_EN(value uint32) {
	volatile.StoreUint32(&o.TX_TDM_CTRL.Reg, volatile.LoadUint32(&o.TX_TDM_CTRL.Reg)&^(0x100)|value<<8)
}
func (o *I2S_Type) GetTX_TDM_CTRL_TX_TDM_CHAN8_EN() uint32 {
	return (volatile.LoadUint32(&o.TX_TDM_CTRL.Reg) & 0x100) >> 8
}
func (o *I2S_Type) SetTX_TDM_CTRL_TX_TDM_CHAN9_EN(value uint32) {
	volatile.StoreUint32(&o.TX_TDM_CTRL.Reg, volatile.LoadUint32(&o.TX_TDM_CTRL.Reg)&^(0x200)|value<<9)
}
func (o *I2S_Type) GetTX_TDM_CTRL_TX_TDM_CHAN9_EN() uint32 {
	return (volatile.LoadUint32(&o.TX_TDM_CTRL.Reg) & 0x200) >> 9
}
func (o *I2S_Type) SetTX_TDM_CTRL_TX_TDM_CHAN10_EN(value uint32) {
	volatile.StoreUint32(&o.TX_TDM_CTRL.Reg, volatile.LoadUint32(&o.TX_TDM_CTRL.Reg)&^(0x400)|value<<10)
}
func (o *I2S_Type) GetTX_TDM_CTRL_TX_TDM_CHAN10_EN() uint32 {
	return (volatile.LoadUint32(&o.TX_TDM_CTRL.Reg) & 0x400) >> 10
}
func (o *I2S_Type) SetTX_TDM_CTRL_TX_TDM_CHAN11_EN(value uint32) {
	volatile.StoreUint32(&o.TX_TDM_CTRL.Reg, volatile.LoadUint32(&o.TX_TDM_CTRL.Reg)&^(0x800)|value<<11)
}
func (o *I2S_Type) GetTX_TDM_CTRL_TX_TDM_CHAN11_EN() uint32 {
	return (volatile.LoadUint32(&o.TX_TDM_CTRL.Reg) & 0x800) >> 11
}
func (o *I2S_Type) SetTX_TDM_CTRL_TX_TDM_CHAN12_EN(value uint32) {
	volatile.StoreUint32(&o.TX_TDM_CTRL.Reg, volatile.LoadUint32(&o.TX_TDM_CTRL.Reg)&^(0x1000)|value<<12)
}
func (o *I2S_Type) GetTX_TDM_CTRL_TX_TDM_CHAN12_EN() uint32 {
	return (volatile.LoadUint32(&o.TX_TDM_CTRL.Reg) & 0x1000) >> 12
}
func (o *I2S_Type) SetTX_TDM_CTRL_TX_TDM_CHAN13_EN(value uint32) {
	volatile.StoreUint32(&o.TX_TDM_CTRL.Reg, volatile.LoadUint32(&o.TX_TDM_CTRL.Reg)&^(0x2000)|value<<13)
}
func (o *I2S_Type) GetTX_TDM_CTRL_TX_TDM_CHAN13_EN() uint32 {
	return (volatile.LoadUint32(&o.TX_TDM_CTRL.Reg) & 0x2000) >> 13
}
func (o *I2S_Type) SetTX_TDM_CTRL_TX_TDM_CHAN14_EN(value uint32) {
	volatile.StoreUint32(&o.TX_TDM_CTRL.Reg, volatile.LoadUint32(&o.TX_TDM_CTRL.Reg)&^(0x4000)|value<<14)
}
func (o *I2S_Type) GetTX_TDM_CTRL_TX_TDM_CHAN14_EN() uint32 {
	return (volatile.LoadUint32(&o.TX_TDM_CTRL.Reg) & 0x4000) >> 14
}
func (o *I2S_Type) SetTX_TDM_CTRL_TX_TDM_CHAN15_EN(value uint32) {
	volatile.StoreUint32(&o.TX_TDM_CTRL.Reg, volatile.LoadUint32(&o.TX_TDM_CTRL.Reg)&^(0x8000)|value<<15)
}
func (o *I2S_Type) GetTX_TDM_CTRL_TX_TDM_CHAN15_EN() uint32 {
	return (volatile.LoadUint32(&o.TX_TDM_CTRL.Reg) & 0x8000) >> 15
}
func (o *I2S_Type) SetTX_TDM_CTRL_TX_TDM_TOT_CHAN_NUM(value uint32) {
	volatile.StoreUint32(&o.TX_TDM_CTRL.Reg, volatile.LoadUint32(&o.TX_TDM_CTRL.Reg)&^(0xf0000)|value<<16)
}
func (o *I2S_Type) GetTX_TDM_CTRL_TX_TDM_TOT_CHAN_NUM() uint32 {
	return (volatile.LoadUint32(&o.TX_TDM_CTRL.Reg) & 0xf0000) >> 16
}
func (o *I2S_Type) SetTX_TDM_CTRL_TX_TDM_SKIP_MSK_EN(value uint32) {
	volatile.StoreUint32(&o.TX_TDM_CTRL.Reg, volatile.LoadUint32(&o.TX_TDM_CTRL.Reg)&^(0x100000)|value<<20)
}
func (o *I2S_Type) GetTX_TDM_CTRL_TX_TDM_SKIP_MSK_EN() uint32 {
	return (volatile.LoadUint32(&o.TX_TDM_CTRL.Reg) & 0x100000) >> 20
}

// I2S.RX_TIMING: I2S RX timing control register
func (o *I2S_Type) SetRX_TIMING_RX_SD_IN_DM(value uint32) {
	volatile.StoreUint32(&o.RX_TIMING.Reg, volatile.LoadUint32(&o.RX_TIMING.Reg)&^(0x3)|value)
}
func (o *I2S_Type) GetRX_TIMING_RX_SD_IN_DM() uint32 {
	return volatile.LoadUint32(&o.RX_TIMING.Reg) & 0x3
}
func (o *I2S_Type) SetRX_TIMING_RX_WS_OUT_DM(value uint32) {
	volatile.StoreUint32(&o.RX_TIMING.Reg, volatile.LoadUint32(&o.RX_TIMING.Reg)&^(0x30000)|value<<16)
}
func (o *I2S_Type) GetRX_TIMING_RX_WS_OUT_DM() uint32 {
	return (volatile.LoadUint32(&o.RX_TIMING.Reg) & 0x30000) >> 16
}
func (o *I2S_Type) SetRX_TIMING_RX_BCK_OUT_DM(value uint32) {
	volatile.StoreUint32(&o.RX_TIMING.Reg, volatile.LoadUint32(&o.RX_TIMING.Reg)&^(0x300000)|value<<20)
}
func (o *I2S_Type) GetRX_TIMING_RX_BCK_OUT_DM() uint32 {
	return (volatile.LoadUint32(&o.RX_TIMING.Reg) & 0x300000) >> 20
}
func (o *I2S_Type) SetRX_TIMING_RX_WS_IN_DM(value uint32) {
	volatile.StoreUint32(&o.RX_TIMING.Reg, volatile.LoadUint32(&o.RX_TIMING.Reg)&^(0x3000000)|value<<24)
}
func (o *I2S_Type) GetRX_TIMING_RX_WS_IN_DM() uint32 {
	return (volatile.LoadUint32(&o.RX_TIMING.Reg) & 0x3000000) >> 24
}
func (o *I2S_Type) SetRX_TIMING_RX_BCK_IN_DM(value uint32) {
	volatile.StoreUint32(&o.RX_TIMING.Reg, volatile.LoadUint32(&o.RX_TIMING.Reg)&^(0x30000000)|value<<28)
}
func (o *I2S_Type) GetRX_TIMING_RX_BCK_IN_DM() uint32 {
	return (volatile.LoadUint32(&o.RX_TIMING.Reg) & 0x30000000) >> 28
}

// I2S.TX_TIMING: I2S TX timing control register
func (o *I2S_Type) SetTX_TIMING_TX_SD_OUT_DM(value uint32) {
	volatile.StoreUint32(&o.TX_TIMING.Reg, volatile.LoadUint32(&o.TX_TIMING.Reg)&^(0x3)|value)
}
func (o *I2S_Type) GetTX_TIMING_TX_SD_OUT_DM() uint32 {
	return volatile.LoadUint32(&o.TX_TIMING.Reg) & 0x3
}
func (o *I2S_Type) SetTX_TIMING_TX_SD1_OUT_DM(value uint32) {
	volatile.StoreUint32(&o.TX_TIMING.Reg, volatile.LoadUint32(&o.TX_TIMING.Reg)&^(0x30)|value<<4)
}
func (o *I2S_Type) GetTX_TIMING_TX_SD1_OUT_DM() uint32 {
	return (volatile.LoadUint32(&o.TX_TIMING.Reg) & 0x30) >> 4
}
func (o *I2S_Type) SetTX_TIMING_TX_WS_OUT_DM(value uint32) {
	volatile.StoreUint32(&o.TX_TIMING.Reg, volatile.LoadUint32(&o.TX_TIMING.Reg)&^(0x30000)|value<<16)
}
func (o *I2S_Type) GetTX_TIMING_TX_WS_OUT_DM() uint32 {
	return (volatile.LoadUint32(&o.TX_TIMING.Reg) & 0x30000) >> 16
}
func (o *I2S_Type) SetTX_TIMING_TX_BCK_OUT_DM(value uint32) {
	volatile.StoreUint32(&o.TX_TIMING.Reg, volatile.LoadUint32(&o.TX_TIMING.Reg)&^(0x300000)|value<<20)
}
func (o *I2S_Type) GetTX_TIMING_TX_BCK_OUT_DM() uint32 {
	return (volatile.LoadUint32(&o.TX_TIMING.Reg) & 0x300000) >> 20
}
func (o *I2S_Type) SetTX_TIMING_TX_WS_IN_DM(value uint32) {
	volatile.StoreUint32(&o.TX_TIMING.Reg, volatile.LoadUint32(&o.TX_TIMING.Reg)&^(0x3000000)|value<<24)
}
func (o *I2S_Type) GetTX_TIMING_TX_WS_IN_DM() uint32 {
	return (volatile.LoadUint32(&o.TX_TIMING.Reg) & 0x3000000) >> 24
}
func (o *I2S_Type) SetTX_TIMING_TX_BCK_IN_DM(value uint32) {
	volatile.StoreUint32(&o.TX_TIMING.Reg, volatile.LoadUint32(&o.TX_TIMING.Reg)&^(0x30000000)|value<<28)
}
func (o *I2S_Type) GetTX_TIMING_TX_BCK_IN_DM() uint32 {
	return (volatile.LoadUint32(&o.TX_TIMING.Reg) & 0x30000000) >> 28
}

// I2S.LC_HUNG_CONF: I2S HUNG configure register.
func (o *I2S_Type) SetLC_HUNG_CONF_LC_FIFO_TIMEOUT(value uint32) {
	volatile.StoreUint32(&o.LC_HUNG_CONF.Reg, volatile.LoadUint32(&o.LC_HUNG_CONF.Reg)&^(0xff)|value)
}
func (o *I2S_Type) GetLC_HUNG_CONF_LC_FIFO_TIMEOUT() uint32 {
	return volatile.LoadUint32(&o.LC_HUNG_CONF.Reg) & 0xff
}
func (o *I2S_Type) SetLC_HUNG_CONF_LC_FIFO_TIMEOUT_SHIFT(value uint32) {
	volatile.StoreUint32(&o.LC_HUNG_CONF.Reg, volatile.LoadUint32(&o.LC_HUNG_CONF.Reg)&^(0x700)|value<<8)
}
func (o *I2S_Type) GetLC_HUNG_CONF_LC_FIFO_TIMEOUT_SHIFT() uint32 {
	return (volatile.LoadUint32(&o.LC_HUNG_CONF.Reg) & 0x700) >> 8
}
func (o *I2S_Type) SetLC_HUNG_CONF_LC_FIFO_TIMEOUT_ENA(value uint32) {
	volatile.StoreUint32(&o.LC_HUNG_CONF.Reg, volatile.LoadUint32(&o.LC_HUNG_CONF.Reg)&^(0x800)|value<<11)
}
func (o *I2S_Type) GetLC_HUNG_CONF_LC_FIFO_TIMEOUT_ENA() uint32 {
	return (volatile.LoadUint32(&o.LC_HUNG_CONF.Reg) & 0x800) >> 11
}

// I2S.RXEOF_NUM: I2S RX data number control register.
func (o *I2S_Type) SetRXEOF_NUM_RX_EOF_NUM(value uint32) {
	volatile.StoreUint32(&o.RXEOF_NUM.Reg, volatile.LoadUint32(&o.RXEOF_NUM.Reg)&^(0xfff)|value)
}
func (o *I2S_Type) GetRXEOF_NUM_RX_EOF_NUM() uint32 {
	return volatile.LoadUint32(&o.RXEOF_NUM.Reg) & 0xfff
}

// I2S.CONF_SIGLE_DATA: I2S signal data register
func (o *I2S_Type) SetCONF_SIGLE_DATA(value uint32) {
	volatile.StoreUint32(&o.CONF_SIGLE_DATA.Reg, value)
}
func (o *I2S_Type) GetCONF_SIGLE_DATA() uint32 {
	return volatile.LoadUint32(&o.CONF_SIGLE_DATA.Reg)
}

// I2S.STATE: I2S TX status register
func (o *I2S_Type) SetSTATE_TX_IDLE(value uint32) {
	volatile.StoreUint32(&o.STATE.Reg, volatile.LoadUint32(&o.STATE.Reg)&^(0x1)|value)
}
func (o *I2S_Type) GetSTATE_TX_IDLE() uint32 {
	return volatile.LoadUint32(&o.STATE.Reg) & 0x1
}

// I2S.DATE: Version control register
func (o *I2S_Type) SetDATE(value uint32) {
	volatile.StoreUint32(&o.DATE.Reg, volatile.LoadUint32(&o.DATE.Reg)&^(0xfffffff)|value)
}
func (o *I2S_Type) GetDATE() uint32 {
	return volatile.LoadUint32(&o.DATE.Reg) & 0xfffffff
}

// Peripheral INTERRUPT_CORE0
type INTERRUPT_CORE0_Type struct {
	MAC_INTR_MAP                                 volatile.Register32 // 0x0
	MAC_NMI_MAP                                  volatile.Register32 // 0x4
	PWR_INTR_MAP                                 volatile.Register32 // 0x8
	BB_INT_MAP                                   volatile.Register32 // 0xC
	BT_MAC_INT_MAP                               volatile.Register32 // 0x10
	BT_BB_INT_MAP                                volatile.Register32 // 0x14
	BT_BB_NMI_MAP                                volatile.Register32 // 0x18
	RWBT_IRQ_MAP                                 volatile.Register32 // 0x1C
	RWBLE_IRQ_MAP                                volatile.Register32 // 0x20
	RWBT_NMI_MAP                                 volatile.Register32 // 0x24
	RWBLE_NMI_MAP                                volatile.Register32 // 0x28
	I2C_MST_INT_MAP                              volatile.Register32 // 0x2C
	SLC0_INTR_MAP                                volatile.Register32 // 0x30
	SLC1_INTR_MAP                                volatile.Register32 // 0x34
	APB_CTRL_INTR_MAP                            volatile.Register32 // 0x38
	UHCI0_INTR_MAP                               volatile.Register32 // 0x3C
	GPIO_INTERRUPT_PRO_MAP                       volatile.Register32 // 0x40
	GPIO_INTERRUPT_PRO_NMI_MAP                   volatile.Register32 // 0x44
	SPI_INTR_1_MAP                               volatile.Register32 // 0x48
	SPI_INTR_2_MAP                               volatile.Register32 // 0x4C
	I2S1_INT_MAP                                 volatile.Register32 // 0x50
	UART_INTR_MAP                                volatile.Register32 // 0x54
	UART1_INTR_MAP                               volatile.Register32 // 0x58
	LEDC_INT_MAP                                 volatile.Register32 // 0x5C
	EFUSE_INT_MAP                                volatile.Register32 // 0x60
	CAN_INT_MAP                                  volatile.Register32 // 0x64
	USB_INTR_MAP                                 volatile.Register32 // 0x68
	RTC_CORE_INTR_MAP                            volatile.Register32 // 0x6C
	RMT_INTR_MAP                                 volatile.Register32 // 0x70
	I2C_EXT0_INTR_MAP                            volatile.Register32 // 0x74
	TIMER_INT1_MAP                               volatile.Register32 // 0x78
	TIMER_INT2_MAP                               volatile.Register32 // 0x7C
	TG_T0_INT_MAP                                volatile.Register32 // 0x80
	TG_WDT_INT_MAP                               volatile.Register32 // 0x84
	TG1_T0_INT_MAP                               volatile.Register32 // 0x88
	TG1_WDT_INT_MAP                              volatile.Register32 // 0x8C
	CACHE_IA_INT_MAP                             volatile.Register32 // 0x90
	SYSTIMER_TARGET0_INT_MAP                     volatile.Register32 // 0x94
	SYSTIMER_TARGET1_INT_MAP                     volatile.Register32 // 0x98
	SYSTIMER_TARGET2_INT_MAP                     volatile.Register32 // 0x9C
	SPI_MEM_REJECT_INTR_MAP                      volatile.Register32 // 0xA0
	ICACHE_PRELOAD_INT_MAP                       volatile.Register32 // 0xA4
	ICACHE_SYNC_INT_MAP                          volatile.Register32 // 0xA8
	APB_ADC_INT_MAP                              volatile.Register32 // 0xAC
	DMA_CH0_INT_MAP                              volatile.Register32 // 0xB0
	DMA_CH1_INT_MAP                              volatile.Register32 // 0xB4
	DMA_CH2_INT_MAP                              volatile.Register32 // 0xB8
	RSA_INT_MAP                                  volatile.Register32 // 0xBC
	AES_INT_MAP                                  volatile.Register32 // 0xC0
	SHA_INT_MAP                                  volatile.Register32 // 0xC4
	CPU_INTR_FROM_CPU_0_MAP                      volatile.Register32 // 0xC8
	CPU_INTR_FROM_CPU_1_MAP                      volatile.Register32 // 0xCC
	CPU_INTR_FROM_CPU_2_MAP                      volatile.Register32 // 0xD0
	CPU_INTR_FROM_CPU_3_MAP                      volatile.Register32 // 0xD4
	ASSIST_DEBUG_INTR_MAP                        volatile.Register32 // 0xD8
	DMA_APBPERI_PMS_MONITOR_VIOLATE_INTR_MAP     volatile.Register32 // 0xDC
	CORE_0_IRAM0_PMS_MONITOR_VIOLATE_INTR_MAP    volatile.Register32 // 0xE0
	CORE_0_DRAM0_PMS_MONITOR_VIOLATE_INTR_MAP    volatile.Register32 // 0xE4
	CORE_0_PIF_PMS_MONITOR_VIOLATE_INTR_MAP      volatile.Register32 // 0xE8
	CORE_0_PIF_PMS_MONITOR_VIOLATE_SIZE_INTR_MAP volatile.Register32 // 0xEC
	BACKUP_PMS_VIOLATE_INTR_MAP                  volatile.Register32 // 0xF0
	CACHE_CORE0_ACS_INT_MAP                      volatile.Register32 // 0xF4
	INTR_STATUS_REG_0                            volatile.Register32 // 0xF8
	INTR_STATUS_REG_1                            volatile.Register32 // 0xFC
	CLOCK_GATE                                   volatile.Register32 // 0x100
	CPU_INT_ENABLE                               volatile.Register32 // 0x104
	CPU_INT_TYPE                                 volatile.Register32 // 0x108
	CPU_INT_CLEAR                                volatile.Register32 // 0x10C
	CPU_INT_EIP_STATUS                           volatile.Register32 // 0x110
	CPU_INT_PRI_0                                volatile.Register32 // 0x114
	CPU_INT_PRI_1                                volatile.Register32 // 0x118
	CPU_INT_PRI_2                                volatile.Register32 // 0x11C
	CPU_INT_PRI_3                                volatile.Register32 // 0x120
	CPU_INT_PRI_4                                volatile.Register32 // 0x124
	CPU_INT_PRI_5                                volatile.Register32 // 0x128
	CPU_INT_PRI_6                                volatile.Register32 // 0x12C
	CPU_INT_PRI_7                                volatile.Register32 // 0x130
	CPU_INT_PRI_8                                volatile.Register32 // 0x134
	CPU_INT_PRI_9                                volatile.Register32 // 0x138
	CPU_INT_PRI_10                               volatile.Register32 // 0x13C
	CPU_INT_PRI_11                               volatile.Register32 // 0x140
	CPU_INT_PRI_12                               volatile.Register32 // 0x144
	CPU_INT_PRI_13                               volatile.Register32 // 0x148
	CPU_INT_PRI_14                               volatile.Register32 // 0x14C
	CPU_INT_PRI_15                               volatile.Register32 // 0x150
	CPU_INT_PRI_16                               volatile.Register32 // 0x154
	CPU_INT_PRI_17                               volatile.Register32 // 0x158
	CPU_INT_PRI_18                               volatile.Register32 // 0x15C
	CPU_INT_PRI_19                               volatile.Register32 // 0x160
	CPU_INT_PRI_20                               volatile.Register32 // 0x164
	CPU_INT_PRI_21                               volatile.Register32 // 0x168
	CPU_INT_PRI_22                               volatile.Register32 // 0x16C
	CPU_INT_PRI_23                               volatile.Register32 // 0x170
	CPU_INT_PRI_24                               volatile.Register32 // 0x174
	CPU_INT_PRI_25                               volatile.Register32 // 0x178
	CPU_INT_PRI_26                               volatile.Register32 // 0x17C
	CPU_INT_PRI_27                               volatile.Register32 // 0x180
	CPU_INT_PRI_28                               volatile.Register32 // 0x184
	CPU_INT_PRI_29                               volatile.Register32 // 0x188
	CPU_INT_PRI_30                               volatile.Register32 // 0x18C
	CPU_INT_PRI_31                               volatile.Register32 // 0x190
	CPU_INT_THRESH                               volatile.Register32 // 0x194
	_                                            [1636]byte
	INTERRUPT_REG_DATE                           volatile.Register32 // 0x7FC
}

// INTERRUPT_CORE0.MAC_INTR_MAP: mac intr map register
func (o *INTERRUPT_CORE0_Type) SetMAC_INTR_MAP(value uint32) {
	volatile.StoreUint32(&o.MAC_INTR_MAP.Reg, volatile.LoadUint32(&o.MAC_INTR_MAP.Reg)&^(0x1f)|value)
}
func (o *INTERRUPT_CORE0_Type) GetMAC_INTR_MAP() uint32 {
	return volatile.LoadUint32(&o.MAC_INTR_MAP.Reg) & 0x1f
}

// INTERRUPT_CORE0.MAC_NMI_MAP: mac nmi_intr map register
func (o *INTERRUPT_CORE0_Type) SetMAC_NMI_MAP(value uint32) {
	volatile.StoreUint32(&o.MAC_NMI_MAP.Reg, volatile.LoadUint32(&o.MAC_NMI_MAP.Reg)&^(0x1f)|value)
}
func (o *INTERRUPT_CORE0_Type) GetMAC_NMI_MAP() uint32 {
	return volatile.LoadUint32(&o.MAC_NMI_MAP.Reg) & 0x1f
}

// INTERRUPT_CORE0.PWR_INTR_MAP: pwr intr map register
func (o *INTERRUPT_CORE0_Type) SetPWR_INTR_MAP(value uint32) {
	volatile.StoreUint32(&o.PWR_INTR_MAP.Reg, volatile.LoadUint32(&o.PWR_INTR_MAP.Reg)&^(0x1f)|value)
}
func (o *INTERRUPT_CORE0_Type) GetPWR_INTR_MAP() uint32 {
	return volatile.LoadUint32(&o.PWR_INTR_MAP.Reg) & 0x1f
}

// INTERRUPT_CORE0.BB_INT_MAP: bb intr map register
func (o *INTERRUPT_CORE0_Type) SetBB_INT_MAP(value uint32) {
	volatile.StoreUint32(&o.BB_INT_MAP.Reg, volatile.LoadUint32(&o.BB_INT_MAP.Reg)&^(0x1f)|value)
}
func (o *INTERRUPT_CORE0_Type) GetBB_INT_MAP() uint32 {
	return volatile.LoadUint32(&o.BB_INT_MAP.Reg) & 0x1f
}

// INTERRUPT_CORE0.BT_MAC_INT_MAP: bt intr map register
func (o *INTERRUPT_CORE0_Type) SetBT_MAC_INT_MAP(value uint32) {
	volatile.StoreUint32(&o.BT_MAC_INT_MAP.Reg, volatile.LoadUint32(&o.BT_MAC_INT_MAP.Reg)&^(0x1f)|value)
}
func (o *INTERRUPT_CORE0_Type) GetBT_MAC_INT_MAP() uint32 {
	return volatile.LoadUint32(&o.BT_MAC_INT_MAP.Reg) & 0x1f
}

// INTERRUPT_CORE0.BT_BB_INT_MAP: bb_bt intr map register
func (o *INTERRUPT_CORE0_Type) SetBT_BB_INT_MAP(value uint32) {
	volatile.StoreUint32(&o.BT_BB_INT_MAP.Reg, volatile.LoadUint32(&o.BT_BB_INT_MAP.Reg)&^(0x1f)|value)
}
func (o *INTERRUPT_CORE0_Type) GetBT_BB_INT_MAP() uint32 {
	return volatile.LoadUint32(&o.BT_BB_INT_MAP.Reg) & 0x1f
}

// INTERRUPT_CORE0.BT_BB_NMI_MAP: bb_bt_nmi intr map register
func (o *INTERRUPT_CORE0_Type) SetBT_BB_NMI_MAP(value uint32) {
	volatile.StoreUint32(&o.BT_BB_NMI_MAP.Reg, volatile.LoadUint32(&o.BT_BB_NMI_MAP.Reg)&^(0x1f)|value)
}
func (o *INTERRUPT_CORE0_Type) GetBT_BB_NMI_MAP() uint32 {
	return volatile.LoadUint32(&o.BT_BB_NMI_MAP.Reg) & 0x1f
}

// INTERRUPT_CORE0.RWBT_IRQ_MAP: rwbt intr map register
func (o *INTERRUPT_CORE0_Type) SetRWBT_IRQ_MAP(value uint32) {
	volatile.StoreUint32(&o.RWBT_IRQ_MAP.Reg, volatile.LoadUint32(&o.RWBT_IRQ_MAP.Reg)&^(0x1f)|value)
}
func (o *INTERRUPT_CORE0_Type) GetRWBT_IRQ_MAP() uint32 {
	return volatile.LoadUint32(&o.RWBT_IRQ_MAP.Reg) & 0x1f
}

// INTERRUPT_CORE0.RWBLE_IRQ_MAP: rwble intr map register
func (o *INTERRUPT_CORE0_Type) SetRWBLE_IRQ_MAP(value uint32) {
	volatile.StoreUint32(&o.RWBLE_IRQ_MAP.Reg, volatile.LoadUint32(&o.RWBLE_IRQ_MAP.Reg)&^(0x1f)|value)
}
func (o *INTERRUPT_CORE0_Type) GetRWBLE_IRQ_MAP() uint32 {
	return volatile.LoadUint32(&o.RWBLE_IRQ_MAP.Reg) & 0x1f
}

// INTERRUPT_CORE0.RWBT_NMI_MAP: rwbt_nmi intr map register
func (o *INTERRUPT_CORE0_Type) SetRWBT_NMI_MAP(value uint32) {
	volatile.StoreUint32(&o.RWBT_NMI_MAP.Reg, volatile.LoadUint32(&o.RWBT_NMI_MAP.Reg)&^(0x1f)|value)
}
func (o *INTERRUPT_CORE0_Type) GetRWBT_NMI_MAP() uint32 {
	return volatile.LoadUint32(&o.RWBT_NMI_MAP.Reg) & 0x1f
}

// INTERRUPT_CORE0.RWBLE_NMI_MAP: rwble_nmi intr map register
func (o *INTERRUPT_CORE0_Type) SetRWBLE_NMI_MAP(value uint32) {
	volatile.StoreUint32(&o.RWBLE_NMI_MAP.Reg, volatile.LoadUint32(&o.RWBLE_NMI_MAP.Reg)&^(0x1f)|value)
}
func (o *INTERRUPT_CORE0_Type) GetRWBLE_NMI_MAP() uint32 {
	return volatile.LoadUint32(&o.RWBLE_NMI_MAP.Reg) & 0x1f
}

// INTERRUPT_CORE0.I2C_MST_INT_MAP: i2c intr map register
func (o *INTERRUPT_CORE0_Type) SetI2C_MST_INT_MAP(value uint32) {
	volatile.StoreUint32(&o.I2C_MST_INT_MAP.Reg, volatile.LoadUint32(&o.I2C_MST_INT_MAP.Reg)&^(0x1f)|value)
}
func (o *INTERRUPT_CORE0_Type) GetI2C_MST_INT_MAP() uint32 {
	return volatile.LoadUint32(&o.I2C_MST_INT_MAP.Reg) & 0x1f
}

// INTERRUPT_CORE0.SLC0_INTR_MAP: slc0 intr map register
func (o *INTERRUPT_CORE0_Type) SetSLC0_INTR_MAP(value uint32) {
	volatile.StoreUint32(&o.SLC0_INTR_MAP.Reg, volatile.LoadUint32(&o.SLC0_INTR_MAP.Reg)&^(0x1f)|value)
}
func (o *INTERRUPT_CORE0_Type) GetSLC0_INTR_MAP() uint32 {
	return volatile.LoadUint32(&o.SLC0_INTR_MAP.Reg) & 0x1f
}

// INTERRUPT_CORE0.SLC1_INTR_MAP: slc1 intr map register
func (o *INTERRUPT_CORE0_Type) SetSLC1_INTR_MAP(value uint32) {
	volatile.StoreUint32(&o.SLC1_INTR_MAP.Reg, volatile.LoadUint32(&o.SLC1_INTR_MAP.Reg)&^(0x1f)|value)
}
func (o *INTERRUPT_CORE0_Type) GetSLC1_INTR_MAP() uint32 {
	return volatile.LoadUint32(&o.SLC1_INTR_MAP.Reg) & 0x1f
}

// INTERRUPT_CORE0.APB_CTRL_INTR_MAP: apb_ctrl intr map register
func (o *INTERRUPT_CORE0_Type) SetAPB_CTRL_INTR_MAP(value uint32) {
	volatile.StoreUint32(&o.APB_CTRL_INTR_MAP.Reg, volatile.LoadUint32(&o.APB_CTRL_INTR_MAP.Reg)&^(0x1f)|value)
}
func (o *INTERRUPT_CORE0_Type) GetAPB_CTRL_INTR_MAP() uint32 {
	return volatile.LoadUint32(&o.APB_CTRL_INTR_MAP.Reg) & 0x1f
}

// INTERRUPT_CORE0.UHCI0_INTR_MAP: uchi0 intr map register
func (o *INTERRUPT_CORE0_Type) SetUHCI0_INTR_MAP(value uint32) {
	volatile.StoreUint32(&o.UHCI0_INTR_MAP.Reg, volatile.LoadUint32(&o.UHCI0_INTR_MAP.Reg)&^(0x1f)|value)
}
func (o *INTERRUPT_CORE0_Type) GetUHCI0_INTR_MAP() uint32 {
	return volatile.LoadUint32(&o.UHCI0_INTR_MAP.Reg) & 0x1f
}

// INTERRUPT_CORE0.GPIO_INTERRUPT_PRO_MAP: gpio intr map register
func (o *INTERRUPT_CORE0_Type) SetGPIO_INTERRUPT_PRO_MAP(value uint32) {
	volatile.StoreUint32(&o.GPIO_INTERRUPT_PRO_MAP.Reg, volatile.LoadUint32(&o.GPIO_INTERRUPT_PRO_MAP.Reg)&^(0x1f)|value)
}
func (o *INTERRUPT_CORE0_Type) GetGPIO_INTERRUPT_PRO_MAP() uint32 {
	return volatile.LoadUint32(&o.GPIO_INTERRUPT_PRO_MAP.Reg) & 0x1f
}

// INTERRUPT_CORE0.GPIO_INTERRUPT_PRO_NMI_MAP: gpio_pro intr map register
func (o *INTERRUPT_CORE0_Type) SetGPIO_INTERRUPT_PRO_NMI_MAP(value uint32) {
	volatile.StoreUint32(&o.GPIO_INTERRUPT_PRO_NMI_MAP.Reg, volatile.LoadUint32(&o.GPIO_INTERRUPT_PRO_NMI_MAP.Reg)&^(0x1f)|value)
}
func (o *INTERRUPT_CORE0_Type) GetGPIO_INTERRUPT_PRO_NMI_MAP() uint32 {
	return volatile.LoadUint32(&o.GPIO_INTERRUPT_PRO_NMI_MAP.Reg) & 0x1f
}

// INTERRUPT_CORE0.SPI_INTR_1_MAP: gpio_pro_nmi intr map register
func (o *INTERRUPT_CORE0_Type) SetSPI_INTR_1_MAP(value uint32) {
	volatile.StoreUint32(&o.SPI_INTR_1_MAP.Reg, volatile.LoadUint32(&o.SPI_INTR_1_MAP.Reg)&^(0x1f)|value)
}
func (o *INTERRUPT_CORE0_Type) GetSPI_INTR_1_MAP() uint32 {
	return volatile.LoadUint32(&o.SPI_INTR_1_MAP.Reg) & 0x1f
}

// INTERRUPT_CORE0.SPI_INTR_2_MAP: spi1 intr map register
func (o *INTERRUPT_CORE0_Type) SetSPI_INTR_2_MAP(value uint32) {
	volatile.StoreUint32(&o.SPI_INTR_2_MAP.Reg, volatile.LoadUint32(&o.SPI_INTR_2_MAP.Reg)&^(0x1f)|value)
}
func (o *INTERRUPT_CORE0_Type) GetSPI_INTR_2_MAP() uint32 {
	return volatile.LoadUint32(&o.SPI_INTR_2_MAP.Reg) & 0x1f
}

// INTERRUPT_CORE0.I2S1_INT_MAP: spi2 intr map register
func (o *INTERRUPT_CORE0_Type) SetI2S1_INT_MAP(value uint32) {
	volatile.StoreUint32(&o.I2S1_INT_MAP.Reg, volatile.LoadUint32(&o.I2S1_INT_MAP.Reg)&^(0x1f)|value)
}
func (o *INTERRUPT_CORE0_Type) GetI2S1_INT_MAP() uint32 {
	return volatile.LoadUint32(&o.I2S1_INT_MAP.Reg) & 0x1f
}

// INTERRUPT_CORE0.UART_INTR_MAP: i2s1 intr map register
func (o *INTERRUPT_CORE0_Type) SetUART_INTR_MAP(value uint32) {
	volatile.StoreUint32(&o.UART_INTR_MAP.Reg, volatile.LoadUint32(&o.UART_INTR_MAP.Reg)&^(0x1f)|value)
}
func (o *INTERRUPT_CORE0_Type) GetUART_INTR_MAP() uint32 {
	return volatile.LoadUint32(&o.UART_INTR_MAP.Reg) & 0x1f
}

// INTERRUPT_CORE0.UART1_INTR_MAP: uart1 intr map register
func (o *INTERRUPT_CORE0_Type) SetUART1_INTR_MAP(value uint32) {
	volatile.StoreUint32(&o.UART1_INTR_MAP.Reg, volatile.LoadUint32(&o.UART1_INTR_MAP.Reg)&^(0x1f)|value)
}
func (o *INTERRUPT_CORE0_Type) GetUART1_INTR_MAP() uint32 {
	return volatile.LoadUint32(&o.UART1_INTR_MAP.Reg) & 0x1f
}

// INTERRUPT_CORE0.LEDC_INT_MAP: ledc intr map register
func (o *INTERRUPT_CORE0_Type) SetLEDC_INT_MAP(value uint32) {
	volatile.StoreUint32(&o.LEDC_INT_MAP.Reg, volatile.LoadUint32(&o.LEDC_INT_MAP.Reg)&^(0x1f)|value)
}
func (o *INTERRUPT_CORE0_Type) GetLEDC_INT_MAP() uint32 {
	return volatile.LoadUint32(&o.LEDC_INT_MAP.Reg) & 0x1f
}

// INTERRUPT_CORE0.EFUSE_INT_MAP: efuse intr map register
func (o *INTERRUPT_CORE0_Type) SetEFUSE_INT_MAP(value uint32) {
	volatile.StoreUint32(&o.EFUSE_INT_MAP.Reg, volatile.LoadUint32(&o.EFUSE_INT_MAP.Reg)&^(0x1f)|value)
}
func (o *INTERRUPT_CORE0_Type) GetEFUSE_INT_MAP() uint32 {
	return volatile.LoadUint32(&o.EFUSE_INT_MAP.Reg) & 0x1f
}

// INTERRUPT_CORE0.CAN_INT_MAP: can intr map register
func (o *INTERRUPT_CORE0_Type) SetCAN_INT_MAP(value uint32) {
	volatile.StoreUint32(&o.CAN_INT_MAP.Reg, volatile.LoadUint32(&o.CAN_INT_MAP.Reg)&^(0x1f)|value)
}
func (o *INTERRUPT_CORE0_Type) GetCAN_INT_MAP() uint32 {
	return volatile.LoadUint32(&o.CAN_INT_MAP.Reg) & 0x1f
}

// INTERRUPT_CORE0.USB_INTR_MAP: usb intr map register
func (o *INTERRUPT_CORE0_Type) SetUSB_INTR_MAP(value uint32) {
	volatile.StoreUint32(&o.USB_INTR_MAP.Reg, volatile.LoadUint32(&o.USB_INTR_MAP.Reg)&^(0x1f)|value)
}
func (o *INTERRUPT_CORE0_Type) GetUSB_INTR_MAP() uint32 {
	return volatile.LoadUint32(&o.USB_INTR_MAP.Reg) & 0x1f
}

// INTERRUPT_CORE0.RTC_CORE_INTR_MAP: rtc intr map register
func (o *INTERRUPT_CORE0_Type) SetRTC_CORE_INTR_MAP(value uint32) {
	volatile.StoreUint32(&o.RTC_CORE_INTR_MAP.Reg, volatile.LoadUint32(&o.RTC_CORE_INTR_MAP.Reg)&^(0x1f)|value)
}
func (o *INTERRUPT_CORE0_Type) GetRTC_CORE_INTR_MAP() uint32 {
	return volatile.LoadUint32(&o.RTC_CORE_INTR_MAP.Reg) & 0x1f
}

// INTERRUPT_CORE0.RMT_INTR_MAP: rmt intr map register
func (o *INTERRUPT_CORE0_Type) SetRMT_INTR_MAP(value uint32) {
	volatile.StoreUint32(&o.RMT_INTR_MAP.Reg, volatile.LoadUint32(&o.RMT_INTR_MAP.Reg)&^(0x1f)|value)
}
func (o *INTERRUPT_CORE0_Type) GetRMT_INTR_MAP() uint32 {
	return volatile.LoadUint32(&o.RMT_INTR_MAP.Reg) & 0x1f
}

// INTERRUPT_CORE0.I2C_EXT0_INTR_MAP: i2c intr map register
func (o *INTERRUPT_CORE0_Type) SetI2C_EXT0_INTR_MAP(value uint32) {
	volatile.StoreUint32(&o.I2C_EXT0_INTR_MAP.Reg, volatile.LoadUint32(&o.I2C_EXT0_INTR_MAP.Reg)&^(0x1f)|value)
}
func (o *INTERRUPT_CORE0_Type) GetI2C_EXT0_INTR_MAP() uint32 {
	return volatile.LoadUint32(&o.I2C_EXT0_INTR_MAP.Reg) & 0x1f
}

// INTERRUPT_CORE0.TIMER_INT1_MAP: timer1 intr map register
func (o *INTERRUPT_CORE0_Type) SetTIMER_INT1_MAP(value uint32) {
	volatile.StoreUint32(&o.TIMER_INT1_MAP.Reg, volatile.LoadUint32(&o.TIMER_INT1_MAP.Reg)&^(0x1f)|value)
}
func (o *INTERRUPT_CORE0_Type) GetTIMER_INT1_MAP() uint32 {
	return volatile.LoadUint32(&o.TIMER_INT1_MAP.Reg) & 0x1f
}

// INTERRUPT_CORE0.TIMER_INT2_MAP: timer2 intr map register
func (o *INTERRUPT_CORE0_Type) SetTIMER_INT2_MAP(value uint32) {
	volatile.StoreUint32(&o.TIMER_INT2_MAP.Reg, volatile.LoadUint32(&o.TIMER_INT2_MAP.Reg)&^(0x1f)|value)
}
func (o *INTERRUPT_CORE0_Type) GetTIMER_INT2_MAP() uint32 {
	return volatile.LoadUint32(&o.TIMER_INT2_MAP.Reg) & 0x1f
}

// INTERRUPT_CORE0.TG_T0_INT_MAP: tg to intr map register
func (o *INTERRUPT_CORE0_Type) SetTG_T0_INT_MAP(value uint32) {
	volatile.StoreUint32(&o.TG_T0_INT_MAP.Reg, volatile.LoadUint32(&o.TG_T0_INT_MAP.Reg)&^(0x1f)|value)
}
func (o *INTERRUPT_CORE0_Type) GetTG_T0_INT_MAP() uint32 {
	return volatile.LoadUint32(&o.TG_T0_INT_MAP.Reg) & 0x1f
}

// INTERRUPT_CORE0.TG_WDT_INT_MAP: tg wdt intr map register
func (o *INTERRUPT_CORE0_Type) SetTG_WDT_INT_MAP(value uint32) {
	volatile.StoreUint32(&o.TG_WDT_INT_MAP.Reg, volatile.LoadUint32(&o.TG_WDT_INT_MAP.Reg)&^(0x1f)|value)
}
func (o *INTERRUPT_CORE0_Type) GetTG_WDT_INT_MAP() uint32 {
	return volatile.LoadUint32(&o.TG_WDT_INT_MAP.Reg) & 0x1f
}

// INTERRUPT_CORE0.TG1_T0_INT_MAP: tg1 to intr map register
func (o *INTERRUPT_CORE0_Type) SetTG1_T0_INT_MAP(value uint32) {
	volatile.StoreUint32(&o.TG1_T0_INT_MAP.Reg, volatile.LoadUint32(&o.TG1_T0_INT_MAP.Reg)&^(0x1f)|value)
}
func (o *INTERRUPT_CORE0_Type) GetTG1_T0_INT_MAP() uint32 {
	return volatile.LoadUint32(&o.TG1_T0_INT_MAP.Reg) & 0x1f
}

// INTERRUPT_CORE0.TG1_WDT_INT_MAP: tg1 wdt intr map register
func (o *INTERRUPT_CORE0_Type) SetTG1_WDT_INT_MAP(value uint32) {
	volatile.StoreUint32(&o.TG1_WDT_INT_MAP.Reg, volatile.LoadUint32(&o.TG1_WDT_INT_MAP.Reg)&^(0x1f)|value)
}
func (o *INTERRUPT_CORE0_Type) GetTG1_WDT_INT_MAP() uint32 {
	return volatile.LoadUint32(&o.TG1_WDT_INT_MAP.Reg) & 0x1f
}

// INTERRUPT_CORE0.CACHE_IA_INT_MAP: cache ia intr map register
func (o *INTERRUPT_CORE0_Type) SetCACHE_IA_INT_MAP(value uint32) {
	volatile.StoreUint32(&o.CACHE_IA_INT_MAP.Reg, volatile.LoadUint32(&o.CACHE_IA_INT_MAP.Reg)&^(0x1f)|value)
}
func (o *INTERRUPT_CORE0_Type) GetCACHE_IA_INT_MAP() uint32 {
	return volatile.LoadUint32(&o.CACHE_IA_INT_MAP.Reg) & 0x1f
}

// INTERRUPT_CORE0.SYSTIMER_TARGET0_INT_MAP: systimer intr map register
func (o *INTERRUPT_CORE0_Type) SetSYSTIMER_TARGET0_INT_MAP(value uint32) {
	volatile.StoreUint32(&o.SYSTIMER_TARGET0_INT_MAP.Reg, volatile.LoadUint32(&o.SYSTIMER_TARGET0_INT_MAP.Reg)&^(0x1f)|value)
}
func (o *INTERRUPT_CORE0_Type) GetSYSTIMER_TARGET0_INT_MAP() uint32 {
	return volatile.LoadUint32(&o.SYSTIMER_TARGET0_INT_MAP.Reg) & 0x1f
}

// INTERRUPT_CORE0.SYSTIMER_TARGET1_INT_MAP: systimer target1 intr map register
func (o *INTERRUPT_CORE0_Type) SetSYSTIMER_TARGET1_INT_MAP(value uint32) {
	volatile.StoreUint32(&o.SYSTIMER_TARGET1_INT_MAP.Reg, volatile.LoadUint32(&o.SYSTIMER_TARGET1_INT_MAP.Reg)&^(0x1f)|value)
}
func (o *INTERRUPT_CORE0_Type) GetSYSTIMER_TARGET1_INT_MAP() uint32 {
	return volatile.LoadUint32(&o.SYSTIMER_TARGET1_INT_MAP.Reg) & 0x1f
}

// INTERRUPT_CORE0.SYSTIMER_TARGET2_INT_MAP: systimer target2 intr map register
func (o *INTERRUPT_CORE0_Type) SetSYSTIMER_TARGET2_INT_MAP(value uint32) {
	volatile.StoreUint32(&o.SYSTIMER_TARGET2_INT_MAP.Reg, volatile.LoadUint32(&o.SYSTIMER_TARGET2_INT_MAP.Reg)&^(0x1f)|value)
}
func (o *INTERRUPT_CORE0_Type) GetSYSTIMER_TARGET2_INT_MAP() uint32 {
	return volatile.LoadUint32(&o.SYSTIMER_TARGET2_INT_MAP.Reg) & 0x1f
}

// INTERRUPT_CORE0.SPI_MEM_REJECT_INTR_MAP: spi mem reject intr map register
func (o *INTERRUPT_CORE0_Type) SetSPI_MEM_REJECT_INTR_MAP(value uint32) {
	volatile.StoreUint32(&o.SPI_MEM_REJECT_INTR_MAP.Reg, volatile.LoadUint32(&o.SPI_MEM_REJECT_INTR_MAP.Reg)&^(0x1f)|value)
}
func (o *INTERRUPT_CORE0_Type) GetSPI_MEM_REJECT_INTR_MAP() uint32 {
	return volatile.LoadUint32(&o.SPI_MEM_REJECT_INTR_MAP.Reg) & 0x1f
}

// INTERRUPT_CORE0.ICACHE_PRELOAD_INT_MAP: icache perload intr map register
func (o *INTERRUPT_CORE0_Type) SetICACHE_PRELOAD_INT_MAP(value uint32) {
	volatile.StoreUint32(&o.ICACHE_PRELOAD_INT_MAP.Reg, volatile.LoadUint32(&o.ICACHE_PRELOAD_INT_MAP.Reg)&^(0x1f)|value)
}
func (o *INTERRUPT_CORE0_Type) GetICACHE_PRELOAD_INT_MAP() uint32 {
	return volatile.LoadUint32(&o.ICACHE_PRELOAD_INT_MAP.Reg) & 0x1f
}

// INTERRUPT_CORE0.ICACHE_SYNC_INT_MAP: icache sync intr map register
func (o *INTERRUPT_CORE0_Type) SetICACHE_SYNC_INT_MAP(value uint32) {
	volatile.StoreUint32(&o.ICACHE_SYNC_INT_MAP.Reg, volatile.LoadUint32(&o.ICACHE_SYNC_INT_MAP.Reg)&^(0x1f)|value)
}
func (o *INTERRUPT_CORE0_Type) GetICACHE_SYNC_INT_MAP() uint32 {
	return volatile.LoadUint32(&o.ICACHE_SYNC_INT_MAP.Reg) & 0x1f
}

// INTERRUPT_CORE0.APB_ADC_INT_MAP: adc intr map register
func (o *INTERRUPT_CORE0_Type) SetAPB_ADC_INT_MAP(value uint32) {
	volatile.StoreUint32(&o.APB_ADC_INT_MAP.Reg, volatile.LoadUint32(&o.APB_ADC_INT_MAP.Reg)&^(0x1f)|value)
}
func (o *INTERRUPT_CORE0_Type) GetAPB_ADC_INT_MAP() uint32 {
	return volatile.LoadUint32(&o.APB_ADC_INT_MAP.Reg) & 0x1f
}

// INTERRUPT_CORE0.DMA_CH0_INT_MAP: dma ch0 intr map register
func (o *INTERRUPT_CORE0_Type) SetDMA_CH0_INT_MAP(value uint32) {
	volatile.StoreUint32(&o.DMA_CH0_INT_MAP.Reg, volatile.LoadUint32(&o.DMA_CH0_INT_MAP.Reg)&^(0x1f)|value)
}
func (o *INTERRUPT_CORE0_Type) GetDMA_CH0_INT_MAP() uint32 {
	return volatile.LoadUint32(&o.DMA_CH0_INT_MAP.Reg) & 0x1f
}

// INTERRUPT_CORE0.DMA_CH1_INT_MAP: dma ch1 intr map register
func (o *INTERRUPT_CORE0_Type) SetDMA_CH1_INT_MAP(value uint32) {
	volatile.StoreUint32(&o.DMA_CH1_INT_MAP.Reg, volatile.LoadUint32(&o.DMA_CH1_INT_MAP.Reg)&^(0x1f)|value)
}
func (o *INTERRUPT_CORE0_Type) GetDMA_CH1_INT_MAP() uint32 {
	return volatile.LoadUint32(&o.DMA_CH1_INT_MAP.Reg) & 0x1f
}

// INTERRUPT_CORE0.DMA_CH2_INT_MAP: dma ch2 intr map register
func (o *INTERRUPT_CORE0_Type) SetDMA_CH2_INT_MAP(value uint32) {
	volatile.StoreUint32(&o.DMA_CH2_INT_MAP.Reg, volatile.LoadUint32(&o.DMA_CH2_INT_MAP.Reg)&^(0x1f)|value)
}
func (o *INTERRUPT_CORE0_Type) GetDMA_CH2_INT_MAP() uint32 {
	return volatile.LoadUint32(&o.DMA_CH2_INT_MAP.Reg) & 0x1f
}

// INTERRUPT_CORE0.RSA_INT_MAP: rsa intr map register
func (o *INTERRUPT_CORE0_Type) SetRSA_INT_MAP(value uint32) {
	volatile.StoreUint32(&o.RSA_INT_MAP.Reg, volatile.LoadUint32(&o.RSA_INT_MAP.Reg)&^(0x1f)|value)
}
func (o *INTERRUPT_CORE0_Type) GetRSA_INT_MAP() uint32 {
	return volatile.LoadUint32(&o.RSA_INT_MAP.Reg) & 0x1f
}

// INTERRUPT_CORE0.AES_INT_MAP: aes intr map register
func (o *INTERRUPT_CORE0_Type) SetAES_INT_MAP(value uint32) {
	volatile.StoreUint32(&o.AES_INT_MAP.Reg, volatile.LoadUint32(&o.AES_INT_MAP.Reg)&^(0x1f)|value)
}
func (o *INTERRUPT_CORE0_Type) GetAES_INT_MAP() uint32 {
	return volatile.LoadUint32(&o.AES_INT_MAP.Reg) & 0x1f
}

// INTERRUPT_CORE0.SHA_INT_MAP: sha intr map register
func (o *INTERRUPT_CORE0_Type) SetSHA_INT_MAP(value uint32) {
	volatile.StoreUint32(&o.SHA_INT_MAP.Reg, volatile.LoadUint32(&o.SHA_INT_MAP.Reg)&^(0x1f)|value)
}
func (o *INTERRUPT_CORE0_Type) GetSHA_INT_MAP() uint32 {
	return volatile.LoadUint32(&o.SHA_INT_MAP.Reg) & 0x1f
}

// INTERRUPT_CORE0.CPU_INTR_FROM_CPU_0_MAP: cpu from cpu 0 intr map register
func (o *INTERRUPT_CORE0_Type) SetCPU_INTR_FROM_CPU_0_MAP(value uint32) {
	volatile.StoreUint32(&o.CPU_INTR_FROM_CPU_0_MAP.Reg, volatile.LoadUint32(&o.CPU_INTR_FROM_CPU_0_MAP.Reg)&^(0x1f)|value)
}
func (o *INTERRUPT_CORE0_Type) GetCPU_INTR_FROM_CPU_0_MAP() uint32 {
	return volatile.LoadUint32(&o.CPU_INTR_FROM_CPU_0_MAP.Reg) & 0x1f
}

// INTERRUPT_CORE0.CPU_INTR_FROM_CPU_1_MAP: cpu from cpu 0 intr map register
func (o *INTERRUPT_CORE0_Type) SetCPU_INTR_FROM_CPU_1_MAP(value uint32) {
	volatile.StoreUint32(&o.CPU_INTR_FROM_CPU_1_MAP.Reg, volatile.LoadUint32(&o.CPU_INTR_FROM_CPU_1_MAP.Reg)&^(0x1f)|value)
}
func (o *INTERRUPT_CORE0_Type) GetCPU_INTR_FROM_CPU_1_MAP() uint32 {
	return volatile.LoadUint32(&o.CPU_INTR_FROM_CPU_1_MAP.Reg) & 0x1f
}

// INTERRUPT_CORE0.CPU_INTR_FROM_CPU_2_MAP: cpu from cpu 1 intr map register
func (o *INTERRUPT_CORE0_Type) SetCPU_INTR_FROM_CPU_2_MAP(value uint32) {
	volatile.StoreUint32(&o.CPU_INTR_FROM_CPU_2_MAP.Reg, volatile.LoadUint32(&o.CPU_INTR_FROM_CPU_2_MAP.Reg)&^(0x1f)|value)
}
func (o *INTERRUPT_CORE0_Type) GetCPU_INTR_FROM_CPU_2_MAP() uint32 {
	return volatile.LoadUint32(&o.CPU_INTR_FROM_CPU_2_MAP.Reg) & 0x1f
}

// INTERRUPT_CORE0.CPU_INTR_FROM_CPU_3_MAP: cpu from cpu 3 intr map register
func (o *INTERRUPT_CORE0_Type) SetCPU_INTR_FROM_CPU_3_MAP(value uint32) {
	volatile.StoreUint32(&o.CPU_INTR_FROM_CPU_3_MAP.Reg, volatile.LoadUint32(&o.CPU_INTR_FROM_CPU_3_MAP.Reg)&^(0x1f)|value)
}
func (o *INTERRUPT_CORE0_Type) GetCPU_INTR_FROM_CPU_3_MAP() uint32 {
	return volatile.LoadUint32(&o.CPU_INTR_FROM_CPU_3_MAP.Reg) & 0x1f
}

// INTERRUPT_CORE0.ASSIST_DEBUG_INTR_MAP: assist debug intr map register
func (o *INTERRUPT_CORE0_Type) SetASSIST_DEBUG_INTR_MAP(value uint32) {
	volatile.StoreUint32(&o.ASSIST_DEBUG_INTR_MAP.Reg, volatile.LoadUint32(&o.ASSIST_DEBUG_INTR_MAP.Reg)&^(0x1f)|value)
}
func (o *INTERRUPT_CORE0_Type) GetASSIST_DEBUG_INTR_MAP() uint32 {
	return volatile.LoadUint32(&o.ASSIST_DEBUG_INTR_MAP.Reg) & 0x1f
}

// INTERRUPT_CORE0.DMA_APBPERI_PMS_MONITOR_VIOLATE_INTR_MAP: dma pms violatile intr map register
func (o *INTERRUPT_CORE0_Type) SetDMA_APBPERI_PMS_MONITOR_VIOLATE_INTR_MAP(value uint32) {
	volatile.StoreUint32(&o.DMA_APBPERI_PMS_MONITOR_VIOLATE_INTR_MAP.Reg, volatile.LoadUint32(&o.DMA_APBPERI_PMS_MONITOR_VIOLATE_INTR_MAP.Reg)&^(0x1f)|value)
}
func (o *INTERRUPT_CORE0_Type) GetDMA_APBPERI_PMS_MONITOR_VIOLATE_INTR_MAP() uint32 {
	return volatile.LoadUint32(&o.DMA_APBPERI_PMS_MONITOR_VIOLATE_INTR_MAP.Reg) & 0x1f
}

// INTERRUPT_CORE0.CORE_0_IRAM0_PMS_MONITOR_VIOLATE_INTR_MAP: iram0 pms violatile intr map register
func (o *INTERRUPT_CORE0_Type) SetCORE_0_IRAM0_PMS_MONITOR_VIOLATE_INTR_MAP(value uint32) {
	volatile.StoreUint32(&o.CORE_0_IRAM0_PMS_MONITOR_VIOLATE_INTR_MAP.Reg, volatile.LoadUint32(&o.CORE_0_IRAM0_PMS_MONITOR_VIOLATE_INTR_MAP.Reg)&^(0x1f)|value)
}
func (o *INTERRUPT_CORE0_Type) GetCORE_0_IRAM0_PMS_MONITOR_VIOLATE_INTR_MAP() uint32 {
	return volatile.LoadUint32(&o.CORE_0_IRAM0_PMS_MONITOR_VIOLATE_INTR_MAP.Reg) & 0x1f
}

// INTERRUPT_CORE0.CORE_0_DRAM0_PMS_MONITOR_VIOLATE_INTR_MAP: mac intr map register
func (o *INTERRUPT_CORE0_Type) SetCORE_0_DRAM0_PMS_MONITOR_VIOLATE_INTR_MAP(value uint32) {
	volatile.StoreUint32(&o.CORE_0_DRAM0_PMS_MONITOR_VIOLATE_INTR_MAP.Reg, volatile.LoadUint32(&o.CORE_0_DRAM0_PMS_MONITOR_VIOLATE_INTR_MAP.Reg)&^(0x1f)|value)
}
func (o *INTERRUPT_CORE0_Type) GetCORE_0_DRAM0_PMS_MONITOR_VIOLATE_INTR_MAP() uint32 {
	return volatile.LoadUint32(&o.CORE_0_DRAM0_PMS_MONITOR_VIOLATE_INTR_MAP.Reg) & 0x1f
}

// INTERRUPT_CORE0.CORE_0_PIF_PMS_MONITOR_VIOLATE_INTR_MAP: mac intr map register
func (o *INTERRUPT_CORE0_Type) SetCORE_0_PIF_PMS_MONITOR_VIOLATE_INTR_MAP(value uint32) {
	volatile.StoreUint32(&o.CORE_0_PIF_PMS_MONITOR_VIOLATE_INTR_MAP.Reg, volatile.LoadUint32(&o.CORE_0_PIF_PMS_MONITOR_VIOLATE_INTR_MAP.Reg)&^(0x1f)|value)
}
func (o *INTERRUPT_CORE0_Type) GetCORE_0_PIF_PMS_MONITOR_VIOLATE_INTR_MAP() uint32 {
	return volatile.LoadUint32(&o.CORE_0_PIF_PMS_MONITOR_VIOLATE_INTR_MAP.Reg) & 0x1f
}

// INTERRUPT_CORE0.CORE_0_PIF_PMS_MONITOR_VIOLATE_SIZE_INTR_MAP: mac intr map register
func (o *INTERRUPT_CORE0_Type) SetCORE_0_PIF_PMS_MONITOR_VIOLATE_SIZE_INTR_MAP(value uint32) {
	volatile.StoreUint32(&o.CORE_0_PIF_PMS_MONITOR_VIOLATE_SIZE_INTR_MAP.Reg, volatile.LoadUint32(&o.CORE_0_PIF_PMS_MONITOR_VIOLATE_SIZE_INTR_MAP.Reg)&^(0x1f)|value)
}
func (o *INTERRUPT_CORE0_Type) GetCORE_0_PIF_PMS_MONITOR_VIOLATE_SIZE_INTR_MAP() uint32 {
	return volatile.LoadUint32(&o.CORE_0_PIF_PMS_MONITOR_VIOLATE_SIZE_INTR_MAP.Reg) & 0x1f
}

// INTERRUPT_CORE0.BACKUP_PMS_VIOLATE_INTR_MAP: mac intr map register
func (o *INTERRUPT_CORE0_Type) SetBACKUP_PMS_VIOLATE_INTR_MAP(value uint32) {
	volatile.StoreUint32(&o.BACKUP_PMS_VIOLATE_INTR_MAP.Reg, volatile.LoadUint32(&o.BACKUP_PMS_VIOLATE_INTR_MAP.Reg)&^(0x1f)|value)
}
func (o *INTERRUPT_CORE0_Type) GetBACKUP_PMS_VIOLATE_INTR_MAP() uint32 {
	return volatile.LoadUint32(&o.BACKUP_PMS_VIOLATE_INTR_MAP.Reg) & 0x1f
}

// INTERRUPT_CORE0.CACHE_CORE0_ACS_INT_MAP: mac intr map register
func (o *INTERRUPT_CORE0_Type) SetCACHE_CORE0_ACS_INT_MAP(value uint32) {
	volatile.StoreUint32(&o.CACHE_CORE0_ACS_INT_MAP.Reg, volatile.LoadUint32(&o.CACHE_CORE0_ACS_INT_MAP.Reg)&^(0x1f)|value)
}
func (o *INTERRUPT_CORE0_Type) GetCACHE_CORE0_ACS_INT_MAP() uint32 {
	return volatile.LoadUint32(&o.CACHE_CORE0_ACS_INT_MAP.Reg) & 0x1f
}

// INTERRUPT_CORE0.INTR_STATUS_REG_0: mac intr map register
func (o *INTERRUPT_CORE0_Type) SetINTR_STATUS_REG_0(value uint32) {
	volatile.StoreUint32(&o.INTR_STATUS_REG_0.Reg, value)
}
func (o *INTERRUPT_CORE0_Type) GetINTR_STATUS_REG_0() uint32 {
	return volatile.LoadUint32(&o.INTR_STATUS_REG_0.Reg)
}

// INTERRUPT_CORE0.INTR_STATUS_REG_1: mac intr map register
func (o *INTERRUPT_CORE0_Type) SetINTR_STATUS_REG_1(value uint32) {
	volatile.StoreUint32(&o.INTR_STATUS_REG_1.Reg, value)
}
func (o *INTERRUPT_CORE0_Type) GetINTR_STATUS_REG_1() uint32 {
	return volatile.LoadUint32(&o.INTR_STATUS_REG_1.Reg)
}

// INTERRUPT_CORE0.CLOCK_GATE: mac intr map register
func (o *INTERRUPT_CORE0_Type) SetCLOCK_GATE_REG_CLK_EN(value uint32) {
	volatile.StoreUint32(&o.CLOCK_GATE.Reg, volatile.LoadUint32(&o.CLOCK_GATE.Reg)&^(0x1)|value)
}
func (o *INTERRUPT_CORE0_Type) GetCLOCK_GATE_REG_CLK_EN() uint32 {
	return volatile.LoadUint32(&o.CLOCK_GATE.Reg) & 0x1
}

// INTERRUPT_CORE0.CPU_INT_ENABLE: mac intr map register
func (o *INTERRUPT_CORE0_Type) SetCPU_INT_ENABLE(value uint32) {
	volatile.StoreUint32(&o.CPU_INT_ENABLE.Reg, value)
}
func (o *INTERRUPT_CORE0_Type) GetCPU_INT_ENABLE() uint32 {
	return volatile.LoadUint32(&o.CPU_INT_ENABLE.Reg)
}

// INTERRUPT_CORE0.CPU_INT_TYPE: mac intr map register
func (o *INTERRUPT_CORE0_Type) SetCPU_INT_TYPE(value uint32) {
	volatile.StoreUint32(&o.CPU_INT_TYPE.Reg, value)
}
func (o *INTERRUPT_CORE0_Type) GetCPU_INT_TYPE() uint32 {
	return volatile.LoadUint32(&o.CPU_INT_TYPE.Reg)
}

// INTERRUPT_CORE0.CPU_INT_CLEAR: mac intr map register
func (o *INTERRUPT_CORE0_Type) SetCPU_INT_CLEAR(value uint32) {
	volatile.StoreUint32(&o.CPU_INT_CLEAR.Reg, value)
}
func (o *INTERRUPT_CORE0_Type) GetCPU_INT_CLEAR() uint32 {
	return volatile.LoadUint32(&o.CPU_INT_CLEAR.Reg)
}

// INTERRUPT_CORE0.CPU_INT_EIP_STATUS: mac intr map register
func (o *INTERRUPT_CORE0_Type) SetCPU_INT_EIP_STATUS(value uint32) {
	volatile.StoreUint32(&o.CPU_INT_EIP_STATUS.Reg, value)
}
func (o *INTERRUPT_CORE0_Type) GetCPU_INT_EIP_STATUS() uint32 {
	return volatile.LoadUint32(&o.CPU_INT_EIP_STATUS.Reg)
}

// INTERRUPT_CORE0.CPU_INT_PRI_0: mac intr map register
func (o *INTERRUPT_CORE0_Type) SetCPU_INT_PRI_0_CPU_PRI_0_MAP(value uint32) {
	volatile.StoreUint32(&o.CPU_INT_PRI_0.Reg, volatile.LoadUint32(&o.CPU_INT_PRI_0.Reg)&^(0xf)|value)
}
func (o *INTERRUPT_CORE0_Type) GetCPU_INT_PRI_0_CPU_PRI_0_MAP() uint32 {
	return volatile.LoadUint32(&o.CPU_INT_PRI_0.Reg) & 0xf
}

// INTERRUPT_CORE0.CPU_INT_PRI_1: mac intr map register
func (o *INTERRUPT_CORE0_Type) SetCPU_INT_PRI_1_CPU_PRI_1_MAP(value uint32) {
	volatile.StoreUint32(&o.CPU_INT_PRI_1.Reg, volatile.LoadUint32(&o.CPU_INT_PRI_1.Reg)&^(0xf)|value)
}
func (o *INTERRUPT_CORE0_Type) GetCPU_INT_PRI_1_CPU_PRI_1_MAP() uint32 {
	return volatile.LoadUint32(&o.CPU_INT_PRI_1.Reg) & 0xf
}

// INTERRUPT_CORE0.CPU_INT_PRI_2: mac intr map register
func (o *INTERRUPT_CORE0_Type) SetCPU_INT_PRI_2_CPU_PRI_2_MAP(value uint32) {
	volatile.StoreUint32(&o.CPU_INT_PRI_2.Reg, volatile.LoadUint32(&o.CPU_INT_PRI_2.Reg)&^(0xf)|value)
}
func (o *INTERRUPT_CORE0_Type) GetCPU_INT_PRI_2_CPU_PRI_2_MAP() uint32 {
	return volatile.LoadUint32(&o.CPU_INT_PRI_2.Reg) & 0xf
}

// INTERRUPT_CORE0.CPU_INT_PRI_3: mac intr map register
func (o *INTERRUPT_CORE0_Type) SetCPU_INT_PRI_3_CPU_PRI_3_MAP(value uint32) {
	volatile.StoreUint32(&o.CPU_INT_PRI_3.Reg, volatile.LoadUint32(&o.CPU_INT_PRI_3.Reg)&^(0xf)|value)
}
func (o *INTERRUPT_CORE0_Type) GetCPU_INT_PRI_3_CPU_PRI_3_MAP() uint32 {
	return volatile.LoadUint32(&o.CPU_INT_PRI_3.Reg) & 0xf
}

// INTERRUPT_CORE0.CPU_INT_PRI_4: mac intr map register
func (o *INTERRUPT_CORE0_Type) SetCPU_INT_PRI_4_CPU_PRI_4_MAP(value uint32) {
	volatile.StoreUint32(&o.CPU_INT_PRI_4.Reg, volatile.LoadUint32(&o.CPU_INT_PRI_4.Reg)&^(0xf)|value)
}
func (o *INTERRUPT_CORE0_Type) GetCPU_INT_PRI_4_CPU_PRI_4_MAP() uint32 {
	return volatile.LoadUint32(&o.CPU_INT_PRI_4.Reg) & 0xf
}

// INTERRUPT_CORE0.CPU_INT_PRI_5: mac intr map register
func (o *INTERRUPT_CORE0_Type) SetCPU_INT_PRI_5_CPU_PRI_5_MAP(value uint32) {
	volatile.StoreUint32(&o.CPU_INT_PRI_5.Reg, volatile.LoadUint32(&o.CPU_INT_PRI_5.Reg)&^(0xf)|value)
}
func (o *INTERRUPT_CORE0_Type) GetCPU_INT_PRI_5_CPU_PRI_5_MAP() uint32 {
	return volatile.LoadUint32(&o.CPU_INT_PRI_5.Reg) & 0xf
}

// INTERRUPT_CORE0.CPU_INT_PRI_6: mac intr map register
func (o *INTERRUPT_CORE0_Type) SetCPU_INT_PRI_6_CPU_PRI_6_MAP(value uint32) {
	volatile.StoreUint32(&o.CPU_INT_PRI_6.Reg, volatile.LoadUint32(&o.CPU_INT_PRI_6.Reg)&^(0xf)|value)
}
func (o *INTERRUPT_CORE0_Type) GetCPU_INT_PRI_6_CPU_PRI_6_MAP() uint32 {
	return volatile.LoadUint32(&o.CPU_INT_PRI_6.Reg) & 0xf
}

// INTERRUPT_CORE0.CPU_INT_PRI_7: mac intr map register
func (o *INTERRUPT_CORE0_Type) SetCPU_INT_PRI_7_CPU_PRI_7_MAP(value uint32) {
	volatile.StoreUint32(&o.CPU_INT_PRI_7.Reg, volatile.LoadUint32(&o.CPU_INT_PRI_7.Reg)&^(0xf)|value)
}
func (o *INTERRUPT_CORE0_Type) GetCPU_INT_PRI_7_CPU_PRI_7_MAP() uint32 {
	return volatile.LoadUint32(&o.CPU_INT_PRI_7.Reg) & 0xf
}

// INTERRUPT_CORE0.CPU_INT_PRI_8: mac intr map register
func (o *INTERRUPT_CORE0_Type) SetCPU_INT_PRI_8_CPU_PRI_8_MAP(value uint32) {
	volatile.StoreUint32(&o.CPU_INT_PRI_8.Reg, volatile.LoadUint32(&o.CPU_INT_PRI_8.Reg)&^(0xf)|value)
}
func (o *INTERRUPT_CORE0_Type) GetCPU_INT_PRI_8_CPU_PRI_8_MAP() uint32 {
	return volatile.LoadUint32(&o.CPU_INT_PRI_8.Reg) & 0xf
}

// INTERRUPT_CORE0.CPU_INT_PRI_9: mac intr map register
func (o *INTERRUPT_CORE0_Type) SetCPU_INT_PRI_9_CPU_PRI_9_MAP(value uint32) {
	volatile.StoreUint32(&o.CPU_INT_PRI_9.Reg, volatile.LoadUint32(&o.CPU_INT_PRI_9.Reg)&^(0xf)|value)
}
func (o *INTERRUPT_CORE0_Type) GetCPU_INT_PRI_9_CPU_PRI_9_MAP() uint32 {
	return volatile.LoadUint32(&o.CPU_INT_PRI_9.Reg) & 0xf
}

// INTERRUPT_CORE0.CPU_INT_PRI_10: mac intr map register
func (o *INTERRUPT_CORE0_Type) SetCPU_INT_PRI_10_CPU_PRI_10_MAP(value uint32) {
	volatile.StoreUint32(&o.CPU_INT_PRI_10.Reg, volatile.LoadUint32(&o.CPU_INT_PRI_10.Reg)&^(0xf)|value)
}
func (o *INTERRUPT_CORE0_Type) GetCPU_INT_PRI_10_CPU_PRI_10_MAP() uint32 {
	return volatile.LoadUint32(&o.CPU_INT_PRI_10.Reg) & 0xf
}

// INTERRUPT_CORE0.CPU_INT_PRI_11: mac intr map register
func (o *INTERRUPT_CORE0_Type) SetCPU_INT_PRI_11_CPU_PRI_11_MAP(value uint32) {
	volatile.StoreUint32(&o.CPU_INT_PRI_11.Reg, volatile.LoadUint32(&o.CPU_INT_PRI_11.Reg)&^(0xf)|value)
}
func (o *INTERRUPT_CORE0_Type) GetCPU_INT_PRI_11_CPU_PRI_11_MAP() uint32 {
	return volatile.LoadUint32(&o.CPU_INT_PRI_11.Reg) & 0xf
}

// INTERRUPT_CORE0.CPU_INT_PRI_12: mac intr map register
func (o *INTERRUPT_CORE0_Type) SetCPU_INT_PRI_12_CPU_PRI_12_MAP(value uint32) {
	volatile.StoreUint32(&o.CPU_INT_PRI_12.Reg, volatile.LoadUint32(&o.CPU_INT_PRI_12.Reg)&^(0xf)|value)
}
func (o *INTERRUPT_CORE0_Type) GetCPU_INT_PRI_12_CPU_PRI_12_MAP() uint32 {
	return volatile.LoadUint32(&o.CPU_INT_PRI_12.Reg) & 0xf
}

// INTERRUPT_CORE0.CPU_INT_PRI_13: mac intr map register
func (o *INTERRUPT_CORE0_Type) SetCPU_INT_PRI_13_CPU_PRI_13_MAP(value uint32) {
	volatile.StoreUint32(&o.CPU_INT_PRI_13.Reg, volatile.LoadUint32(&o.CPU_INT_PRI_13.Reg)&^(0xf)|value)
}
func (o *INTERRUPT_CORE0_Type) GetCPU_INT_PRI_13_CPU_PRI_13_MAP() uint32 {
	return volatile.LoadUint32(&o.CPU_INT_PRI_13.Reg) & 0xf
}

// INTERRUPT_CORE0.CPU_INT_PRI_14: mac intr map register
func (o *INTERRUPT_CORE0_Type) SetCPU_INT_PRI_14_CPU_PRI_14_MAP(value uint32) {
	volatile.StoreUint32(&o.CPU_INT_PRI_14.Reg, volatile.LoadUint32(&o.CPU_INT_PRI_14.Reg)&^(0xf)|value)
}
func (o *INTERRUPT_CORE0_Type) GetCPU_INT_PRI_14_CPU_PRI_14_MAP() uint32 {
	return volatile.LoadUint32(&o.CPU_INT_PRI_14.Reg) & 0xf
}

// INTERRUPT_CORE0.CPU_INT_PRI_15: mac intr map register
func (o *INTERRUPT_CORE0_Type) SetCPU_INT_PRI_15_CPU_PRI_15_MAP(value uint32) {
	volatile.StoreUint32(&o.CPU_INT_PRI_15.Reg, volatile.LoadUint32(&o.CPU_INT_PRI_15.Reg)&^(0xf)|value)
}
func (o *INTERRUPT_CORE0_Type) GetCPU_INT_PRI_15_CPU_PRI_15_MAP() uint32 {
	return volatile.LoadUint32(&o.CPU_INT_PRI_15.Reg) & 0xf
}

// INTERRUPT_CORE0.CPU_INT_PRI_16: mac intr map register
func (o *INTERRUPT_CORE0_Type) SetCPU_INT_PRI_16_CPU_PRI_16_MAP(value uint32) {
	volatile.StoreUint32(&o.CPU_INT_PRI_16.Reg, volatile.LoadUint32(&o.CPU_INT_PRI_16.Reg)&^(0xf)|value)
}
func (o *INTERRUPT_CORE0_Type) GetCPU_INT_PRI_16_CPU_PRI_16_MAP() uint32 {
	return volatile.LoadUint32(&o.CPU_INT_PRI_16.Reg) & 0xf
}

// INTERRUPT_CORE0.CPU_INT_PRI_17: mac intr map register
func (o *INTERRUPT_CORE0_Type) SetCPU_INT_PRI_17_CPU_PRI_17_MAP(value uint32) {
	volatile.StoreUint32(&o.CPU_INT_PRI_17.Reg, volatile.LoadUint32(&o.CPU_INT_PRI_17.Reg)&^(0xf)|value)
}
func (o *INTERRUPT_CORE0_Type) GetCPU_INT_PRI_17_CPU_PRI_17_MAP() uint32 {
	return volatile.LoadUint32(&o.CPU_INT_PRI_17.Reg) & 0xf
}

// INTERRUPT_CORE0.CPU_INT_PRI_18: mac intr map register
func (o *INTERRUPT_CORE0_Type) SetCPU_INT_PRI_18_CPU_PRI_18_MAP(value uint32) {
	volatile.StoreUint32(&o.CPU_INT_PRI_18.Reg, volatile.LoadUint32(&o.CPU_INT_PRI_18.Reg)&^(0xf)|value)
}
func (o *INTERRUPT_CORE0_Type) GetCPU_INT_PRI_18_CPU_PRI_18_MAP() uint32 {
	return volatile.LoadUint32(&o.CPU_INT_PRI_18.Reg) & 0xf
}

// INTERRUPT_CORE0.CPU_INT_PRI_19: mac intr map register
func (o *INTERRUPT_CORE0_Type) SetCPU_INT_PRI_19_CPU_PRI_19_MAP(value uint32) {
	volatile.StoreUint32(&o.CPU_INT_PRI_19.Reg, volatile.LoadUint32(&o.CPU_INT_PRI_19.Reg)&^(0xf)|value)
}
func (o *INTERRUPT_CORE0_Type) GetCPU_INT_PRI_19_CPU_PRI_19_MAP() uint32 {
	return volatile.LoadUint32(&o.CPU_INT_PRI_19.Reg) & 0xf
}

// INTERRUPT_CORE0.CPU_INT_PRI_20: mac intr map register
func (o *INTERRUPT_CORE0_Type) SetCPU_INT_PRI_20_CPU_PRI_20_MAP(value uint32) {
	volatile.StoreUint32(&o.CPU_INT_PRI_20.Reg, volatile.LoadUint32(&o.CPU_INT_PRI_20.Reg)&^(0xf)|value)
}
func (o *INTERRUPT_CORE0_Type) GetCPU_INT_PRI_20_CPU_PRI_20_MAP() uint32 {
	return volatile.LoadUint32(&o.CPU_INT_PRI_20.Reg) & 0xf
}

// INTERRUPT_CORE0.CPU_INT_PRI_21: mac intr map register
func (o *INTERRUPT_CORE0_Type) SetCPU_INT_PRI_21_CPU_PRI_21_MAP(value uint32) {
	volatile.StoreUint32(&o.CPU_INT_PRI_21.Reg, volatile.LoadUint32(&o.CPU_INT_PRI_21.Reg)&^(0xf)|value)
}
func (o *INTERRUPT_CORE0_Type) GetCPU_INT_PRI_21_CPU_PRI_21_MAP() uint32 {
	return volatile.LoadUint32(&o.CPU_INT_PRI_21.Reg) & 0xf
}

// INTERRUPT_CORE0.CPU_INT_PRI_22: mac intr map register
func (o *INTERRUPT_CORE0_Type) SetCPU_INT_PRI_22_CPU_PRI_22_MAP(value uint32) {
	volatile.StoreUint32(&o.CPU_INT_PRI_22.Reg, volatile.LoadUint32(&o.CPU_INT_PRI_22.Reg)&^(0xf)|value)
}
func (o *INTERRUPT_CORE0_Type) GetCPU_INT_PRI_22_CPU_PRI_22_MAP() uint32 {
	return volatile.LoadUint32(&o.CPU_INT_PRI_22.Reg) & 0xf
}

// INTERRUPT_CORE0.CPU_INT_PRI_23: mac intr map register
func (o *INTERRUPT_CORE0_Type) SetCPU_INT_PRI_23_CPU_PRI_23_MAP(value uint32) {
	volatile.StoreUint32(&o.CPU_INT_PRI_23.Reg, volatile.LoadUint32(&o.CPU_INT_PRI_23.Reg)&^(0xf)|value)
}
func (o *INTERRUPT_CORE0_Type) GetCPU_INT_PRI_23_CPU_PRI_23_MAP() uint32 {
	return volatile.LoadUint32(&o.CPU_INT_PRI_23.Reg) & 0xf
}

// INTERRUPT_CORE0.CPU_INT_PRI_24: mac intr map register
func (o *INTERRUPT_CORE0_Type) SetCPU_INT_PRI_24_CPU_PRI_24_MAP(value uint32) {
	volatile.StoreUint32(&o.CPU_INT_PRI_24.Reg, volatile.LoadUint32(&o.CPU_INT_PRI_24.Reg)&^(0xf)|value)
}
func (o *INTERRUPT_CORE0_Type) GetCPU_INT_PRI_24_CPU_PRI_24_MAP() uint32 {
	return volatile.LoadUint32(&o.CPU_INT_PRI_24.Reg) & 0xf
}

// INTERRUPT_CORE0.CPU_INT_PRI_25: mac intr map register
func (o *INTERRUPT_CORE0_Type) SetCPU_INT_PRI_25_CPU_PRI_25_MAP(value uint32) {
	volatile.StoreUint32(&o.CPU_INT_PRI_25.Reg, volatile.LoadUint32(&o.CPU_INT_PRI_25.Reg)&^(0xf)|value)
}
func (o *INTERRUPT_CORE0_Type) GetCPU_INT_PRI_25_CPU_PRI_25_MAP() uint32 {
	return volatile.LoadUint32(&o.CPU_INT_PRI_25.Reg) & 0xf
}

// INTERRUPT_CORE0.CPU_INT_PRI_26: mac intr map register
func (o *INTERRUPT_CORE0_Type) SetCPU_INT_PRI_26_CPU_PRI_26_MAP(value uint32) {
	volatile.StoreUint32(&o.CPU_INT_PRI_26.Reg, volatile.LoadUint32(&o.CPU_INT_PRI_26.Reg)&^(0xf)|value)
}
func (o *INTERRUPT_CORE0_Type) GetCPU_INT_PRI_26_CPU_PRI_26_MAP() uint32 {
	return volatile.LoadUint32(&o.CPU_INT_PRI_26.Reg) & 0xf
}

// INTERRUPT_CORE0.CPU_INT_PRI_27: mac intr map register
func (o *INTERRUPT_CORE0_Type) SetCPU_INT_PRI_27_CPU_PRI_27_MAP(value uint32) {
	volatile.StoreUint32(&o.CPU_INT_PRI_27.Reg, volatile.LoadUint32(&o.CPU_INT_PRI_27.Reg)&^(0xf)|value)
}
func (o *INTERRUPT_CORE0_Type) GetCPU_INT_PRI_27_CPU_PRI_27_MAP() uint32 {
	return volatile.LoadUint32(&o.CPU_INT_PRI_27.Reg) & 0xf
}

// INTERRUPT_CORE0.CPU_INT_PRI_28: mac intr map register
func (o *INTERRUPT_CORE0_Type) SetCPU_INT_PRI_28_CPU_PRI_28_MAP(value uint32) {
	volatile.StoreUint32(&o.CPU_INT_PRI_28.Reg, volatile.LoadUint32(&o.CPU_INT_PRI_28.Reg)&^(0xf)|value)
}
func (o *INTERRUPT_CORE0_Type) GetCPU_INT_PRI_28_CPU_PRI_28_MAP() uint32 {
	return volatile.LoadUint32(&o.CPU_INT_PRI_28.Reg) & 0xf
}

// INTERRUPT_CORE0.CPU_INT_PRI_29: mac intr map register
func (o *INTERRUPT_CORE0_Type) SetCPU_INT_PRI_29_CPU_PRI_29_MAP(value uint32) {
	volatile.StoreUint32(&o.CPU_INT_PRI_29.Reg, volatile.LoadUint32(&o.CPU_INT_PRI_29.Reg)&^(0xf)|value)
}
func (o *INTERRUPT_CORE0_Type) GetCPU_INT_PRI_29_CPU_PRI_29_MAP() uint32 {
	return volatile.LoadUint32(&o.CPU_INT_PRI_29.Reg) & 0xf
}

// INTERRUPT_CORE0.CPU_INT_PRI_30: mac intr map register
func (o *INTERRUPT_CORE0_Type) SetCPU_INT_PRI_30_CPU_PRI_30_MAP(value uint32) {
	volatile.StoreUint32(&o.CPU_INT_PRI_30.Reg, volatile.LoadUint32(&o.CPU_INT_PRI_30.Reg)&^(0xf)|value)
}
func (o *INTERRUPT_CORE0_Type) GetCPU_INT_PRI_30_CPU_PRI_30_MAP() uint32 {
	return volatile.LoadUint32(&o.CPU_INT_PRI_30.Reg) & 0xf
}

// INTERRUPT_CORE0.CPU_INT_PRI_31: mac intr map register
func (o *INTERRUPT_CORE0_Type) SetCPU_INT_PRI_31_CPU_PRI_31_MAP(value uint32) {
	volatile.StoreUint32(&o.CPU_INT_PRI_31.Reg, volatile.LoadUint32(&o.CPU_INT_PRI_31.Reg)&^(0xf)|value)
}
func (o *INTERRUPT_CORE0_Type) GetCPU_INT_PRI_31_CPU_PRI_31_MAP() uint32 {
	return volatile.LoadUint32(&o.CPU_INT_PRI_31.Reg) & 0xf
}

// INTERRUPT_CORE0.CPU_INT_THRESH: mac intr map register
func (o *INTERRUPT_CORE0_Type) SetCPU_INT_THRESH(value uint32) {
	volatile.StoreUint32(&o.CPU_INT_THRESH.Reg, volatile.LoadUint32(&o.CPU_INT_THRESH.Reg)&^(0xf)|value)
}
func (o *INTERRUPT_CORE0_Type) GetCPU_INT_THRESH() uint32 {
	return volatile.LoadUint32(&o.CPU_INT_THRESH.Reg) & 0xf
}

// INTERRUPT_CORE0.INTERRUPT_REG_DATE: mac intr map register
func (o *INTERRUPT_CORE0_Type) SetINTERRUPT_REG_DATE(value uint32) {
	volatile.StoreUint32(&o.INTERRUPT_REG_DATE.Reg, volatile.LoadUint32(&o.INTERRUPT_REG_DATE.Reg)&^(0xfffffff)|value)
}
func (o *INTERRUPT_CORE0_Type) GetINTERRUPT_REG_DATE() uint32 {
	return volatile.LoadUint32(&o.INTERRUPT_REG_DATE.Reg) & 0xfffffff
}

// Peripheral IO_MUX
type IO_MUX_Type struct {
	PIN_CTRL volatile.Register32 // 0x0
	GPIO0    volatile.Register32 // 0x4
	GPIO1    volatile.Register32 // 0x8
	GPIO2    volatile.Register32 // 0xC
	GPIO3    volatile.Register32 // 0x10
	GPIO4    volatile.Register32 // 0x14
	GPIO5    volatile.Register32 // 0x18
	GPIO6    volatile.Register32 // 0x1C
	GPIO7    volatile.Register32 // 0x20
	GPIO8    volatile.Register32 // 0x24
	GPIO9    volatile.Register32 // 0x28
	GPIO10   volatile.Register32 // 0x2C
	GPIO11   volatile.Register32 // 0x30
	GPIO12   volatile.Register32 // 0x34
	GPIO13   volatile.Register32 // 0x38
	GPIO14   volatile.Register32 // 0x3C
	GPIO15   volatile.Register32 // 0x40
	GPIO16   volatile.Register32 // 0x44
	GPIO17   volatile.Register32 // 0x48
	GPIO18   volatile.Register32 // 0x4C
	GPIO19   volatile.Register32 // 0x50
	GPIO20   volatile.Register32 // 0x54
	GPIO21   volatile.Register32 // 0x58
	_        [160]byte
	DATE     volatile.Register32 // 0xFC
}

// IO_MUX.PIN_CTRL: Clock Output Configuration Register
func (o *IO_MUX_Type) SetPIN_CTRL_CLK_OUT1(value uint32) {
	volatile.StoreUint32(&o.PIN_CTRL.Reg, volatile.LoadUint32(&o.PIN_CTRL.Reg)&^(0xf)|value)
}
func (o *IO_MUX_Type) GetPIN_CTRL_CLK_OUT1() uint32 {
	return volatile.LoadUint32(&o.PIN_CTRL.Reg) & 0xf
}
func (o *IO_MUX_Type) SetPIN_CTRL_CLK_OUT2(value uint32) {
	volatile.StoreUint32(&o.PIN_CTRL.Reg, volatile.LoadUint32(&o.PIN_CTRL.Reg)&^(0xf0)|value<<4)
}
func (o *IO_MUX_Type) GetPIN_CTRL_CLK_OUT2() uint32 {
	return (volatile.LoadUint32(&o.PIN_CTRL.Reg) & 0xf0) >> 4
}
func (o *IO_MUX_Type) SetPIN_CTRL_CLK_OUT3(value uint32) {
	volatile.StoreUint32(&o.PIN_CTRL.Reg, volatile.LoadUint32(&o.PIN_CTRL.Reg)&^(0xf00)|value<<8)
}
func (o *IO_MUX_Type) GetPIN_CTRL_CLK_OUT3() uint32 {
	return (volatile.LoadUint32(&o.PIN_CTRL.Reg) & 0xf00) >> 8
}

// IO_MUX.GPIO0: IO MUX Configure Register for pad XTAL_32K_P
func (o *IO_MUX_Type) SetGPIO0_MCU_OE(value uint32) {
	volatile.StoreUint32(&o.GPIO0.Reg, volatile.LoadUint32(&o.GPIO0.Reg)&^(0x1)|value)
}
func (o *IO_MUX_Type) GetGPIO0_MCU_OE() uint32 {
	return volatile.LoadUint32(&o.GPIO0.Reg) & 0x1
}
func (o *IO_MUX_Type) SetGPIO0_SLP_SEL(value uint32) {
	volatile.StoreUint32(&o.GPIO0.Reg, volatile.LoadUint32(&o.GPIO0.Reg)&^(0x2)|value<<1)
}
func (o *IO_MUX_Type) GetGPIO0_SLP_SEL() uint32 {
	return (volatile.LoadUint32(&o.GPIO0.Reg) & 0x2) >> 1
}
func (o *IO_MUX_Type) SetGPIO0_MCU_WPD(value uint32) {
	volatile.StoreUint32(&o.GPIO0.Reg, volatile.LoadUint32(&o.GPIO0.Reg)&^(0x4)|value<<2)
}
func (o *IO_MUX_Type) GetGPIO0_MCU_WPD() uint32 {
	return (volatile.LoadUint32(&o.GPIO0.Reg) & 0x4) >> 2
}
func (o *IO_MUX_Type) SetGPIO0_MCU_WPU(value uint32) {
	volatile.StoreUint32(&o.GPIO0.Reg, volatile.LoadUint32(&o.GPIO0.Reg)&^(0x8)|value<<3)
}
func (o *IO_MUX_Type) GetGPIO0_MCU_WPU() uint32 {
	return (volatile.LoadUint32(&o.GPIO0.Reg) & 0x8) >> 3
}
func (o *IO_MUX_Type) SetGPIO0_MCU_IE(value uint32) {
	volatile.StoreUint32(&o.GPIO0.Reg, volatile.LoadUint32(&o.GPIO0.Reg)&^(0x10)|value<<4)
}
func (o *IO_MUX_Type) GetGPIO0_MCU_IE() uint32 {
	return (volatile.LoadUint32(&o.GPIO0.Reg) & 0x10) >> 4
}
func (o *IO_MUX_Type) SetGPIO0_FUN_WPD(value uint32) {
	volatile.StoreUint32(&o.GPIO0.Reg, volatile.LoadUint32(&o.GPIO0.Reg)&^(0x80)|value<<7)
}
func (o *IO_MUX_Type) GetGPIO0_FUN_WPD() uint32 {
	return (volatile.LoadUint32(&o.GPIO0.Reg) & 0x80) >> 7
}
func (o *IO_MUX_Type) SetGPIO0_FUN_WPU(value uint32) {
	volatile.StoreUint32(&o.GPIO0.Reg, volatile.LoadUint32(&o.GPIO0.Reg)&^(0x100)|value<<8)
}
func (o *IO_MUX_Type) GetGPIO0_FUN_WPU() uint32 {
	return (volatile.LoadUint32(&o.GPIO0.Reg) & 0x100) >> 8
}
func (o *IO_MUX_Type) SetGPIO0_FUN_IE(value uint32) {
	volatile.StoreUint32(&o.GPIO0.Reg, volatile.LoadUint32(&o.GPIO0.Reg)&^(0x200)|value<<9)
}
func (o *IO_MUX_Type) GetGPIO0_FUN_IE() uint32 {
	return (volatile.LoadUint32(&o.GPIO0.Reg) & 0x200) >> 9
}
func (o *IO_MUX_Type) SetGPIO0_FUN_DRV(value uint32) {
	volatile.StoreUint32(&o.GPIO0.Reg, volatile.LoadUint32(&o.GPIO0.Reg)&^(0xc00)|value<<10)
}
func (o *IO_MUX_Type) GetGPIO0_FUN_DRV() uint32 {
	return (volatile.LoadUint32(&o.GPIO0.Reg) & 0xc00) >> 10
}
func (o *IO_MUX_Type) SetGPIO0_MCU_SEL(value uint32) {
	volatile.StoreUint32(&o.GPIO0.Reg, volatile.LoadUint32(&o.GPIO0.Reg)&^(0x7000)|value<<12)
}
func (o *IO_MUX_Type) GetGPIO0_MCU_SEL() uint32 {
	return (volatile.LoadUint32(&o.GPIO0.Reg) & 0x7000) >> 12
}
func (o *IO_MUX_Type) SetGPIO0_FILTER_EN(value uint32) {
	volatile.StoreUint32(&o.GPIO0.Reg, volatile.LoadUint32(&o.GPIO0.Reg)&^(0x8000)|value<<15)
}
func (o *IO_MUX_Type) GetGPIO0_FILTER_EN() uint32 {
	return (volatile.LoadUint32(&o.GPIO0.Reg) & 0x8000) >> 15
}

// IO_MUX.GPIO1: IO MUX Configure Register for pad XTAL_32K_P
func (o *IO_MUX_Type) SetGPIO1_MCU_OE(value uint32) {
	volatile.StoreUint32(&o.GPIO1.Reg, volatile.LoadUint32(&o.GPIO1.Reg)&^(0x1)|value)
}
func (o *IO_MUX_Type) GetGPIO1_MCU_OE() uint32 {
	return volatile.LoadUint32(&o.GPIO1.Reg) & 0x1
}
func (o *IO_MUX_Type) SetGPIO1_SLP_SEL(value uint32) {
	volatile.StoreUint32(&o.GPIO1.Reg, volatile.LoadUint32(&o.GPIO1.Reg)&^(0x2)|value<<1)
}
func (o *IO_MUX_Type) GetGPIO1_SLP_SEL() uint32 {
	return (volatile.LoadUint32(&o.GPIO1.Reg) & 0x2) >> 1
}
func (o *IO_MUX_Type) SetGPIO1_MCU_WPD(value uint32) {
	volatile.StoreUint32(&o.GPIO1.Reg, volatile.LoadUint32(&o.GPIO1.Reg)&^(0x4)|value<<2)
}
func (o *IO_MUX_Type) GetGPIO1_MCU_WPD() uint32 {
	return (volatile.LoadUint32(&o.GPIO1.Reg) & 0x4) >> 2
}
func (o *IO_MUX_Type) SetGPIO1_MCU_WPU(value uint32) {
	volatile.StoreUint32(&o.GPIO1.Reg, volatile.LoadUint32(&o.GPIO1.Reg)&^(0x8)|value<<3)
}
func (o *IO_MUX_Type) GetGPIO1_MCU_WPU() uint32 {
	return (volatile.LoadUint32(&o.GPIO1.Reg) & 0x8) >> 3
}
func (o *IO_MUX_Type) SetGPIO1_MCU_IE(value uint32) {
	volatile.StoreUint32(&o.GPIO1.Reg, volatile.LoadUint32(&o.GPIO1.Reg)&^(0x10)|value<<4)
}
func (o *IO_MUX_Type) GetGPIO1_MCU_IE() uint32 {
	return (volatile.LoadUint32(&o.GPIO1.Reg) & 0x10) >> 4
}
func (o *IO_MUX_Type) SetGPIO1_FUN_WPD(value uint32) {
	volatile.StoreUint32(&o.GPIO1.Reg, volatile.LoadUint32(&o.GPIO1.Reg)&^(0x80)|value<<7)
}
func (o *IO_MUX_Type) GetGPIO1_FUN_WPD() uint32 {
	return (volatile.LoadUint32(&o.GPIO1.Reg) & 0x80) >> 7
}
func (o *IO_MUX_Type) SetGPIO1_FUN_WPU(value uint32) {
	volatile.StoreUint32(&o.GPIO1.Reg, volatile.LoadUint32(&o.GPIO1.Reg)&^(0x100)|value<<8)
}
func (o *IO_MUX_Type) GetGPIO1_FUN_WPU() uint32 {
	return (volatile.LoadUint32(&o.GPIO1.Reg) & 0x100) >> 8
}
func (o *IO_MUX_Type) SetGPIO1_FUN_IE(value uint32) {
	volatile.StoreUint32(&o.GPIO1.Reg, volatile.LoadUint32(&o.GPIO1.Reg)&^(0x200)|value<<9)
}
func (o *IO_MUX_Type) GetGPIO1_FUN_IE() uint32 {
	return (volatile.LoadUint32(&o.GPIO1.Reg) & 0x200) >> 9
}
func (o *IO_MUX_Type) SetGPIO1_FUN_DRV(value uint32) {
	volatile.StoreUint32(&o.GPIO1.Reg, volatile.LoadUint32(&o.GPIO1.Reg)&^(0xc00)|value<<10)
}
func (o *IO_MUX_Type) GetGPIO1_FUN_DRV() uint32 {
	return (volatile.LoadUint32(&o.GPIO1.Reg) & 0xc00) >> 10
}
func (o *IO_MUX_Type) SetGPIO1_MCU_SEL(value uint32) {
	volatile.StoreUint32(&o.GPIO1.Reg, volatile.LoadUint32(&o.GPIO1.Reg)&^(0x7000)|value<<12)
}
func (o *IO_MUX_Type) GetGPIO1_MCU_SEL() uint32 {
	return (volatile.LoadUint32(&o.GPIO1.Reg) & 0x7000) >> 12
}
func (o *IO_MUX_Type) SetGPIO1_FILTER_EN(value uint32) {
	volatile.StoreUint32(&o.GPIO1.Reg, volatile.LoadUint32(&o.GPIO1.Reg)&^(0x8000)|value<<15)
}
func (o *IO_MUX_Type) GetGPIO1_FILTER_EN() uint32 {
	return (volatile.LoadUint32(&o.GPIO1.Reg) & 0x8000) >> 15
}

// IO_MUX.GPIO2: IO MUX Configure Register for pad XTAL_32K_P
func (o *IO_MUX_Type) SetGPIO2_MCU_OE(value uint32) {
	volatile.StoreUint32(&o.GPIO2.Reg, volatile.LoadUint32(&o.GPIO2.Reg)&^(0x1)|value)
}
func (o *IO_MUX_Type) GetGPIO2_MCU_OE() uint32 {
	return volatile.LoadUint32(&o.GPIO2.Reg) & 0x1
}
func (o *IO_MUX_Type) SetGPIO2_SLP_SEL(value uint32) {
	volatile.StoreUint32(&o.GPIO2.Reg, volatile.LoadUint32(&o.GPIO2.Reg)&^(0x2)|value<<1)
}
func (o *IO_MUX_Type) GetGPIO2_SLP_SEL() uint32 {
	return (volatile.LoadUint32(&o.GPIO2.Reg) & 0x2) >> 1
}
func (o *IO_MUX_Type) SetGPIO2_MCU_WPD(value uint32) {
	volatile.StoreUint32(&o.GPIO2.Reg, volatile.LoadUint32(&o.GPIO2.Reg)&^(0x4)|value<<2)
}
func (o *IO_MUX_Type) GetGPIO2_MCU_WPD() uint32 {
	return (volatile.LoadUint32(&o.GPIO2.Reg) & 0x4) >> 2
}
func (o *IO_MUX_Type) SetGPIO2_MCU_WPU(value uint32) {
	volatile.StoreUint32(&o.GPIO2.Reg, volatile.LoadUint32(&o.GPIO2.Reg)&^(0x8)|value<<3)
}
func (o *IO_MUX_Type) GetGPIO2_MCU_WPU() uint32 {
	return (volatile.LoadUint32(&o.GPIO2.Reg) & 0x8) >> 3
}
func (o *IO_MUX_Type) SetGPIO2_MCU_IE(value uint32) {
	volatile.StoreUint32(&o.GPIO2.Reg, volatile.LoadUint32(&o.GPIO2.Reg)&^(0x10)|value<<4)
}
func (o *IO_MUX_Type) GetGPIO2_MCU_IE() uint32 {
	return (volatile.LoadUint32(&o.GPIO2.Reg) & 0x10) >> 4
}
func (o *IO_MUX_Type) SetGPIO2_FUN_WPD(value uint32) {
	volatile.StoreUint32(&o.GPIO2.Reg, volatile.LoadUint32(&o.GPIO2.Reg)&^(0x80)|value<<7)
}
func (o *IO_MUX_Type) GetGPIO2_FUN_WPD() uint32 {
	return (volatile.LoadUint32(&o.GPIO2.Reg) & 0x80) >> 7
}
func (o *IO_MUX_Type) SetGPIO2_FUN_WPU(value uint32) {
	volatile.StoreUint32(&o.GPIO2.Reg, volatile.LoadUint32(&o.GPIO2.Reg)&^(0x100)|value<<8)
}
func (o *IO_MUX_Type) GetGPIO2_FUN_WPU() uint32 {
	return (volatile.LoadUint32(&o.GPIO2.Reg) & 0x100) >> 8
}
func (o *IO_MUX_Type) SetGPIO2_FUN_IE(value uint32) {
	volatile.StoreUint32(&o.GPIO2.Reg, volatile.LoadUint32(&o.GPIO2.Reg)&^(0x200)|value<<9)
}
func (o *IO_MUX_Type) GetGPIO2_FUN_IE() uint32 {
	return (volatile.LoadUint32(&o.GPIO2.Reg) & 0x200) >> 9
}
func (o *IO_MUX_Type) SetGPIO2_FUN_DRV(value uint32) {
	volatile.StoreUint32(&o.GPIO2.Reg, volatile.LoadUint32(&o.GPIO2.Reg)&^(0xc00)|value<<10)
}
func (o *IO_MUX_Type) GetGPIO2_FUN_DRV() uint32 {
	return (volatile.LoadUint32(&o.GPIO2.Reg) & 0xc00) >> 10
}
func (o *IO_MUX_Type) SetGPIO2_MCU_SEL(value uint32) {
	volatile.StoreUint32(&o.GPIO2.Reg, volatile.LoadUint32(&o.GPIO2.Reg)&^(0x7000)|value<<12)
}
func (o *IO_MUX_Type) GetGPIO2_MCU_SEL() uint32 {
	return (volatile.LoadUint32(&o.GPIO2.Reg) & 0x7000) >> 12
}
func (o *IO_MUX_Type) SetGPIO2_FILTER_EN(value uint32) {
	volatile.StoreUint32(&o.GPIO2.Reg, volatile.LoadUint32(&o.GPIO2.Reg)&^(0x8000)|value<<15)
}
func (o *IO_MUX_Type) GetGPIO2_FILTER_EN() uint32 {
	return (volatile.LoadUint32(&o.GPIO2.Reg) & 0x8000) >> 15
}

// IO_MUX.GPIO3: IO MUX Configure Register for pad XTAL_32K_P
func (o *IO_MUX_Type) SetGPIO3_MCU_OE(value uint32) {
	volatile.StoreUint32(&o.GPIO3.Reg, volatile.LoadUint32(&o.GPIO3.Reg)&^(0x1)|value)
}
func (o *IO_MUX_Type) GetGPIO3_MCU_OE() uint32 {
	return volatile.LoadUint32(&o.GPIO3.Reg) & 0x1
}
func (o *IO_MUX_Type) SetGPIO3_SLP_SEL(value uint32) {
	volatile.StoreUint32(&o.GPIO3.Reg, volatile.LoadUint32(&o.GPIO3.Reg)&^(0x2)|value<<1)
}
func (o *IO_MUX_Type) GetGPIO3_SLP_SEL() uint32 {
	return (volatile.LoadUint32(&o.GPIO3.Reg) & 0x2) >> 1
}
func (o *IO_MUX_Type) SetGPIO3_MCU_WPD(value uint32) {
	volatile.StoreUint32(&o.GPIO3.Reg, volatile.LoadUint32(&o.GPIO3.Reg)&^(0x4)|value<<2)
}
func (o *IO_MUX_Type) GetGPIO3_MCU_WPD() uint32 {
	return (volatile.LoadUint32(&o.GPIO3.Reg) & 0x4) >> 2
}
func (o *IO_MUX_Type) SetGPIO3_MCU_WPU(value uint32) {
	volatile.StoreUint32(&o.GPIO3.Reg, volatile.LoadUint32(&o.GPIO3.Reg)&^(0x8)|value<<3)
}
func (o *IO_MUX_Type) GetGPIO3_MCU_WPU() uint32 {
	return (volatile.LoadUint32(&o.GPIO3.Reg) & 0x8) >> 3
}
func (o *IO_MUX_Type) SetGPIO3_MCU_IE(value uint32) {
	volatile.StoreUint32(&o.GPIO3.Reg, volatile.LoadUint32(&o.GPIO3.Reg)&^(0x10)|value<<4)
}
func (o *IO_MUX_Type) GetGPIO3_MCU_IE() uint32 {
	return (volatile.LoadUint32(&o.GPIO3.Reg) & 0x10) >> 4
}
func (o *IO_MUX_Type) SetGPIO3_FUN_WPD(value uint32) {
	volatile.StoreUint32(&o.GPIO3.Reg, volatile.LoadUint32(&o.GPIO3.Reg)&^(0x80)|value<<7)
}
func (o *IO_MUX_Type) GetGPIO3_FUN_WPD() uint32 {
	return (volatile.LoadUint32(&o.GPIO3.Reg) & 0x80) >> 7
}
func (o *IO_MUX_Type) SetGPIO3_FUN_WPU(value uint32) {
	volatile.StoreUint32(&o.GPIO3.Reg, volatile.LoadUint32(&o.GPIO3.Reg)&^(0x100)|value<<8)
}
func (o *IO_MUX_Type) GetGPIO3_FUN_WPU() uint32 {
	return (volatile.LoadUint32(&o.GPIO3.Reg) & 0x100) >> 8
}
func (o *IO_MUX_Type) SetGPIO3_FUN_IE(value uint32) {
	volatile.StoreUint32(&o.GPIO3.Reg, volatile.LoadUint32(&o.GPIO3.Reg)&^(0x200)|value<<9)
}
func (o *IO_MUX_Type) GetGPIO3_FUN_IE() uint32 {
	return (volatile.LoadUint32(&o.GPIO3.Reg) & 0x200) >> 9
}
func (o *IO_MUX_Type) SetGPIO3_FUN_DRV(value uint32) {
	volatile.StoreUint32(&o.GPIO3.Reg, volatile.LoadUint32(&o.GPIO3.Reg)&^(0xc00)|value<<10)
}
func (o *IO_MUX_Type) GetGPIO3_FUN_DRV() uint32 {
	return (volatile.LoadUint32(&o.GPIO3.Reg) & 0xc00) >> 10
}
func (o *IO_MUX_Type) SetGPIO3_MCU_SEL(value uint32) {
	volatile.StoreUint32(&o.GPIO3.Reg, volatile.LoadUint32(&o.GPIO3.Reg)&^(0x7000)|value<<12)
}
func (o *IO_MUX_Type) GetGPIO3_MCU_SEL() uint32 {
	return (volatile.LoadUint32(&o.GPIO3.Reg) & 0x7000) >> 12
}
func (o *IO_MUX_Type) SetGPIO3_FILTER_EN(value uint32) {
	volatile.StoreUint32(&o.GPIO3.Reg, volatile.LoadUint32(&o.GPIO3.Reg)&^(0x8000)|value<<15)
}
func (o *IO_MUX_Type) GetGPIO3_FILTER_EN() uint32 {
	return (volatile.LoadUint32(&o.GPIO3.Reg) & 0x8000) >> 15
}

// IO_MUX.GPIO4: IO MUX Configure Register for pad XTAL_32K_P
func (o *IO_MUX_Type) SetGPIO4_MCU_OE(value uint32) {
	volatile.StoreUint32(&o.GPIO4.Reg, volatile.LoadUint32(&o.GPIO4.Reg)&^(0x1)|value)
}
func (o *IO_MUX_Type) GetGPIO4_MCU_OE() uint32 {
	return volatile.LoadUint32(&o.GPIO4.Reg) & 0x1
}
func (o *IO_MUX_Type) SetGPIO4_SLP_SEL(value uint32) {
	volatile.StoreUint32(&o.GPIO4.Reg, volatile.LoadUint32(&o.GPIO4.Reg)&^(0x2)|value<<1)
}
func (o *IO_MUX_Type) GetGPIO4_SLP_SEL() uint32 {
	return (volatile.LoadUint32(&o.GPIO4.Reg) & 0x2) >> 1
}
func (o *IO_MUX_Type) SetGPIO4_MCU_WPD(value uint32) {
	volatile.StoreUint32(&o.GPIO4.Reg, volatile.LoadUint32(&o.GPIO4.Reg)&^(0x4)|value<<2)
}
func (o *IO_MUX_Type) GetGPIO4_MCU_WPD() uint32 {
	return (volatile.LoadUint32(&o.GPIO4.Reg) & 0x4) >> 2
}
func (o *IO_MUX_Type) SetGPIO4_MCU_WPU(value uint32) {
	volatile.StoreUint32(&o.GPIO4.Reg, volatile.LoadUint32(&o.GPIO4.Reg)&^(0x8)|value<<3)
}
func (o *IO_MUX_Type) GetGPIO4_MCU_WPU() uint32 {
	return (volatile.LoadUint32(&o.GPIO4.Reg) & 0x8) >> 3
}
func (o *IO_MUX_Type) SetGPIO4_MCU_IE(value uint32) {
	volatile.StoreUint32(&o.GPIO4.Reg, volatile.LoadUint32(&o.GPIO4.Reg)&^(0x10)|value<<4)
}
func (o *IO_MUX_Type) GetGPIO4_MCU_IE() uint32 {
	return (volatile.LoadUint32(&o.GPIO4.Reg) & 0x10) >> 4
}
func (o *IO_MUX_Type) SetGPIO4_FUN_WPD(value uint32) {
	volatile.StoreUint32(&o.GPIO4.Reg, volatile.LoadUint32(&o.GPIO4.Reg)&^(0x80)|value<<7)
}
func (o *IO_MUX_Type) GetGPIO4_FUN_WPD() uint32 {
	return (volatile.LoadUint32(&o.GPIO4.Reg) & 0x80) >> 7
}
func (o *IO_MUX_Type) SetGPIO4_FUN_WPU(value uint32) {
	volatile.StoreUint32(&o.GPIO4.Reg, volatile.LoadUint32(&o.GPIO4.Reg)&^(0x100)|value<<8)
}
func (o *IO_MUX_Type) GetGPIO4_FUN_WPU() uint32 {
	return (volatile.LoadUint32(&o.GPIO4.Reg) & 0x100) >> 8
}
func (o *IO_MUX_Type) SetGPIO4_FUN_IE(value uint32) {
	volatile.StoreUint32(&o.GPIO4.Reg, volatile.LoadUint32(&o.GPIO4.Reg)&^(0x200)|value<<9)
}
func (o *IO_MUX_Type) GetGPIO4_FUN_IE() uint32 {
	return (volatile.LoadUint32(&o.GPIO4.Reg) & 0x200) >> 9
}
func (o *IO_MUX_Type) SetGPIO4_FUN_DRV(value uint32) {
	volatile.StoreUint32(&o.GPIO4.Reg, volatile.LoadUint32(&o.GPIO4.Reg)&^(0xc00)|value<<10)
}
func (o *IO_MUX_Type) GetGPIO4_FUN_DRV() uint32 {
	return (volatile.LoadUint32(&o.GPIO4.Reg) & 0xc00) >> 10
}
func (o *IO_MUX_Type) SetGPIO4_MCU_SEL(value uint32) {
	volatile.StoreUint32(&o.GPIO4.Reg, volatile.LoadUint32(&o.GPIO4.Reg)&^(0x7000)|value<<12)
}
func (o *IO_MUX_Type) GetGPIO4_MCU_SEL() uint32 {
	return (volatile.LoadUint32(&o.GPIO4.Reg) & 0x7000) >> 12
}
func (o *IO_MUX_Type) SetGPIO4_FILTER_EN(value uint32) {
	volatile.StoreUint32(&o.GPIO4.Reg, volatile.LoadUint32(&o.GPIO4.Reg)&^(0x8000)|value<<15)
}
func (o *IO_MUX_Type) GetGPIO4_FILTER_EN() uint32 {
	return (volatile.LoadUint32(&o.GPIO4.Reg) & 0x8000) >> 15
}

// IO_MUX.GPIO5: IO MUX Configure Register for pad XTAL_32K_P
func (o *IO_MUX_Type) SetGPIO5_MCU_OE(value uint32) {
	volatile.StoreUint32(&o.GPIO5.Reg, volatile.LoadUint32(&o.GPIO5.Reg)&^(0x1)|value)
}
func (o *IO_MUX_Type) GetGPIO5_MCU_OE() uint32 {
	return volatile.LoadUint32(&o.GPIO5.Reg) & 0x1
}
func (o *IO_MUX_Type) SetGPIO5_SLP_SEL(value uint32) {
	volatile.StoreUint32(&o.GPIO5.Reg, volatile.LoadUint32(&o.GPIO5.Reg)&^(0x2)|value<<1)
}
func (o *IO_MUX_Type) GetGPIO5_SLP_SEL() uint32 {
	return (volatile.LoadUint32(&o.GPIO5.Reg) & 0x2) >> 1
}
func (o *IO_MUX_Type) SetGPIO5_MCU_WPD(value uint32) {
	volatile.StoreUint32(&o.GPIO5.Reg, volatile.LoadUint32(&o.GPIO5.Reg)&^(0x4)|value<<2)
}
func (o *IO_MUX_Type) GetGPIO5_MCU_WPD() uint32 {
	return (volatile.LoadUint32(&o.GPIO5.Reg) & 0x4) >> 2
}
func (o *IO_MUX_Type) SetGPIO5_MCU_WPU(value uint32) {
	volatile.StoreUint32(&o.GPIO5.Reg, volatile.LoadUint32(&o.GPIO5.Reg)&^(0x8)|value<<3)
}
func (o *IO_MUX_Type) GetGPIO5_MCU_WPU() uint32 {
	return (volatile.LoadUint32(&o.GPIO5.Reg) & 0x8) >> 3
}
func (o *IO_MUX_Type) SetGPIO5_MCU_IE(value uint32) {
	volatile.StoreUint32(&o.GPIO5.Reg, volatile.LoadUint32(&o.GPIO5.Reg)&^(0x10)|value<<4)
}
func (o *IO_MUX_Type) GetGPIO5_MCU_IE() uint32 {
	return (volatile.LoadUint32(&o.GPIO5.Reg) & 0x10) >> 4
}
func (o *IO_MUX_Type) SetGPIO5_FUN_WPD(value uint32) {
	volatile.StoreUint32(&o.GPIO5.Reg, volatile.LoadUint32(&o.GPIO5.Reg)&^(0x80)|value<<7)
}
func (o *IO_MUX_Type) GetGPIO5_FUN_WPD() uint32 {
	return (volatile.LoadUint32(&o.GPIO5.Reg) & 0x80) >> 7
}
func (o *IO_MUX_Type) SetGPIO5_FUN_WPU(value uint32) {
	volatile.StoreUint32(&o.GPIO5.Reg, volatile.LoadUint32(&o.GPIO5.Reg)&^(0x100)|value<<8)
}
func (o *IO_MUX_Type) GetGPIO5_FUN_WPU() uint32 {
	return (volatile.LoadUint32(&o.GPIO5.Reg) & 0x100) >> 8
}
func (o *IO_MUX_Type) SetGPIO5_FUN_IE(value uint32) {
	volatile.StoreUint32(&o.GPIO5.Reg, volatile.LoadUint32(&o.GPIO5.Reg)&^(0x200)|value<<9)
}
func (o *IO_MUX_Type) GetGPIO5_FUN_IE() uint32 {
	return (volatile.LoadUint32(&o.GPIO5.Reg) & 0x200) >> 9
}
func (o *IO_MUX_Type) SetGPIO5_FUN_DRV(value uint32) {
	volatile.StoreUint32(&o.GPIO5.Reg, volatile.LoadUint32(&o.GPIO5.Reg)&^(0xc00)|value<<10)
}
func (o *IO_MUX_Type) GetGPIO5_FUN_DRV() uint32 {
	return (volatile.LoadUint32(&o.GPIO5.Reg) & 0xc00) >> 10
}
func (o *IO_MUX_Type) SetGPIO5_MCU_SEL(value uint32) {
	volatile.StoreUint32(&o.GPIO5.Reg, volatile.LoadUint32(&o.GPIO5.Reg)&^(0x7000)|value<<12)
}
func (o *IO_MUX_Type) GetGPIO5_MCU_SEL() uint32 {
	return (volatile.LoadUint32(&o.GPIO5.Reg) & 0x7000) >> 12
}
func (o *IO_MUX_Type) SetGPIO5_FILTER_EN(value uint32) {
	volatile.StoreUint32(&o.GPIO5.Reg, volatile.LoadUint32(&o.GPIO5.Reg)&^(0x8000)|value<<15)
}
func (o *IO_MUX_Type) GetGPIO5_FILTER_EN() uint32 {
	return (volatile.LoadUint32(&o.GPIO5.Reg) & 0x8000) >> 15
}

// IO_MUX.GPIO6: IO MUX Configure Register for pad XTAL_32K_P
func (o *IO_MUX_Type) SetGPIO6_MCU_OE(value uint32) {
	volatile.StoreUint32(&o.GPIO6.Reg, volatile.LoadUint32(&o.GPIO6.Reg)&^(0x1)|value)
}
func (o *IO_MUX_Type) GetGPIO6_MCU_OE() uint32 {
	return volatile.LoadUint32(&o.GPIO6.Reg) & 0x1
}
func (o *IO_MUX_Type) SetGPIO6_SLP_SEL(value uint32) {
	volatile.StoreUint32(&o.GPIO6.Reg, volatile.LoadUint32(&o.GPIO6.Reg)&^(0x2)|value<<1)
}
func (o *IO_MUX_Type) GetGPIO6_SLP_SEL() uint32 {
	return (volatile.LoadUint32(&o.GPIO6.Reg) & 0x2) >> 1
}
func (o *IO_MUX_Type) SetGPIO6_MCU_WPD(value uint32) {
	volatile.StoreUint32(&o.GPIO6.Reg, volatile.LoadUint32(&o.GPIO6.Reg)&^(0x4)|value<<2)
}
func (o *IO_MUX_Type) GetGPIO6_MCU_WPD() uint32 {
	return (volatile.LoadUint32(&o.GPIO6.Reg) & 0x4) >> 2
}
func (o *IO_MUX_Type) SetGPIO6_MCU_WPU(value uint32) {
	volatile.StoreUint32(&o.GPIO6.Reg, volatile.LoadUint32(&o.GPIO6.Reg)&^(0x8)|value<<3)
}
func (o *IO_MUX_Type) GetGPIO6_MCU_WPU() uint32 {
	return (volatile.LoadUint32(&o.GPIO6.Reg) & 0x8) >> 3
}
func (o *IO_MUX_Type) SetGPIO6_MCU_IE(value uint32) {
	volatile.StoreUint32(&o.GPIO6.Reg, volatile.LoadUint32(&o.GPIO6.Reg)&^(0x10)|value<<4)
}
func (o *IO_MUX_Type) GetGPIO6_MCU_IE() uint32 {
	return (volatile.LoadUint32(&o.GPIO6.Reg) & 0x10) >> 4
}
func (o *IO_MUX_Type) SetGPIO6_FUN_WPD(value uint32) {
	volatile.StoreUint32(&o.GPIO6.Reg, volatile.LoadUint32(&o.GPIO6.Reg)&^(0x80)|value<<7)
}
func (o *IO_MUX_Type) GetGPIO6_FUN_WPD() uint32 {
	return (volatile.LoadUint32(&o.GPIO6.Reg) & 0x80) >> 7
}
func (o *IO_MUX_Type) SetGPIO6_FUN_WPU(value uint32) {
	volatile.StoreUint32(&o.GPIO6.Reg, volatile.LoadUint32(&o.GPIO6.Reg)&^(0x100)|value<<8)
}
func (o *IO_MUX_Type) GetGPIO6_FUN_WPU() uint32 {
	return (volatile.LoadUint32(&o.GPIO6.Reg) & 0x100) >> 8
}
func (o *IO_MUX_Type) SetGPIO6_FUN_IE(value uint32) {
	volatile.StoreUint32(&o.GPIO6.Reg, volatile.LoadUint32(&o.GPIO6.Reg)&^(0x200)|value<<9)
}
func (o *IO_MUX_Type) GetGPIO6_FUN_IE() uint32 {
	return (volatile.LoadUint32(&o.GPIO6.Reg) & 0x200) >> 9
}
func (o *IO_MUX_Type) SetGPIO6_FUN_DRV(value uint32) {
	volatile.StoreUint32(&o.GPIO6.Reg, volatile.LoadUint32(&o.GPIO6.Reg)&^(0xc00)|value<<10)
}
func (o *IO_MUX_Type) GetGPIO6_FUN_DRV() uint32 {
	return (volatile.LoadUint32(&o.GPIO6.Reg) & 0xc00) >> 10
}
func (o *IO_MUX_Type) SetGPIO6_MCU_SEL(value uint32) {
	volatile.StoreUint32(&o.GPIO6.Reg, volatile.LoadUint32(&o.GPIO6.Reg)&^(0x7000)|value<<12)
}
func (o *IO_MUX_Type) GetGPIO6_MCU_SEL() uint32 {
	return (volatile.LoadUint32(&o.GPIO6.Reg) & 0x7000) >> 12
}
func (o *IO_MUX_Type) SetGPIO6_FILTER_EN(value uint32) {
	volatile.StoreUint32(&o.GPIO6.Reg, volatile.LoadUint32(&o.GPIO6.Reg)&^(0x8000)|value<<15)
}
func (o *IO_MUX_Type) GetGPIO6_FILTER_EN() uint32 {
	return (volatile.LoadUint32(&o.GPIO6.Reg) & 0x8000) >> 15
}

// IO_MUX.GPIO7: IO MUX Configure Register for pad XTAL_32K_P
func (o *IO_MUX_Type) SetGPIO7_MCU_OE(value uint32) {
	volatile.StoreUint32(&o.GPIO7.Reg, volatile.LoadUint32(&o.GPIO7.Reg)&^(0x1)|value)
}
func (o *IO_MUX_Type) GetGPIO7_MCU_OE() uint32 {
	return volatile.LoadUint32(&o.GPIO7.Reg) & 0x1
}
func (o *IO_MUX_Type) SetGPIO7_SLP_SEL(value uint32) {
	volatile.StoreUint32(&o.GPIO7.Reg, volatile.LoadUint32(&o.GPIO7.Reg)&^(0x2)|value<<1)
}
func (o *IO_MUX_Type) GetGPIO7_SLP_SEL() uint32 {
	return (volatile.LoadUint32(&o.GPIO7.Reg) & 0x2) >> 1
}
func (o *IO_MUX_Type) SetGPIO7_MCU_WPD(value uint32) {
	volatile.StoreUint32(&o.GPIO7.Reg, volatile.LoadUint32(&o.GPIO7.Reg)&^(0x4)|value<<2)
}
func (o *IO_MUX_Type) GetGPIO7_MCU_WPD() uint32 {
	return (volatile.LoadUint32(&o.GPIO7.Reg) & 0x4) >> 2
}
func (o *IO_MUX_Type) SetGPIO7_MCU_WPU(value uint32) {
	volatile.StoreUint32(&o.GPIO7.Reg, volatile.LoadUint32(&o.GPIO7.Reg)&^(0x8)|value<<3)
}
func (o *IO_MUX_Type) GetGPIO7_MCU_WPU() uint32 {
	return (volatile.LoadUint32(&o.GPIO7.Reg) & 0x8) >> 3
}
func (o *IO_MUX_Type) SetGPIO7_MCU_IE(value uint32) {
	volatile.StoreUint32(&o.GPIO7.Reg, volatile.LoadUint32(&o.GPIO7.Reg)&^(0x10)|value<<4)
}
func (o *IO_MUX_Type) GetGPIO7_MCU_IE() uint32 {
	return (volatile.LoadUint32(&o.GPIO7.Reg) & 0x10) >> 4
}
func (o *IO_MUX_Type) SetGPIO7_FUN_WPD(value uint32) {
	volatile.StoreUint32(&o.GPIO7.Reg, volatile.LoadUint32(&o.GPIO7.Reg)&^(0x80)|value<<7)
}
func (o *IO_MUX_Type) GetGPIO7_FUN_WPD() uint32 {
	return (volatile.LoadUint32(&o.GPIO7.Reg) & 0x80) >> 7
}
func (o *IO_MUX_Type) SetGPIO7_FUN_WPU(value uint32) {
	volatile.StoreUint32(&o.GPIO7.Reg, volatile.LoadUint32(&o.GPIO7.Reg)&^(0x100)|value<<8)
}
func (o *IO_MUX_Type) GetGPIO7_FUN_WPU() uint32 {
	return (volatile.LoadUint32(&o.GPIO7.Reg) & 0x100) >> 8
}
func (o *IO_MUX_Type) SetGPIO7_FUN_IE(value uint32) {
	volatile.StoreUint32(&o.GPIO7.Reg, volatile.LoadUint32(&o.GPIO7.Reg)&^(0x200)|value<<9)
}
func (o *IO_MUX_Type) GetGPIO7_FUN_IE() uint32 {
	return (volatile.LoadUint32(&o.GPIO7.Reg) & 0x200) >> 9
}
func (o *IO_MUX_Type) SetGPIO7_FUN_DRV(value uint32) {
	volatile.StoreUint32(&o.GPIO7.Reg, volatile.LoadUint32(&o.GPIO7.Reg)&^(0xc00)|value<<10)
}
func (o *IO_MUX_Type) GetGPIO7_FUN_DRV() uint32 {
	return (volatile.LoadUint32(&o.GPIO7.Reg) & 0xc00) >> 10
}
func (o *IO_MUX_Type) SetGPIO7_MCU_SEL(value uint32) {
	volatile.StoreUint32(&o.GPIO7.Reg, volatile.LoadUint32(&o.GPIO7.Reg)&^(0x7000)|value<<12)
}
func (o *IO_MUX_Type) GetGPIO7_MCU_SEL() uint32 {
	return (volatile.LoadUint32(&o.GPIO7.Reg) & 0x7000) >> 12
}
func (o *IO_MUX_Type) SetGPIO7_FILTER_EN(value uint32) {
	volatile.StoreUint32(&o.GPIO7.Reg, volatile.LoadUint32(&o.GPIO7.Reg)&^(0x8000)|value<<15)
}
func (o *IO_MUX_Type) GetGPIO7_FILTER_EN() uint32 {
	return (volatile.LoadUint32(&o.GPIO7.Reg) & 0x8000) >> 15
}

// IO_MUX.GPIO8: IO MUX Configure Register for pad XTAL_32K_P
func (o *IO_MUX_Type) SetGPIO8_MCU_OE(value uint32) {
	volatile.StoreUint32(&o.GPIO8.Reg, volatile.LoadUint32(&o.GPIO8.Reg)&^(0x1)|value)
}
func (o *IO_MUX_Type) GetGPIO8_MCU_OE() uint32 {
	return volatile.LoadUint32(&o.GPIO8.Reg) & 0x1
}
func (o *IO_MUX_Type) SetGPIO8_SLP_SEL(value uint32) {
	volatile.StoreUint32(&o.GPIO8.Reg, volatile.LoadUint32(&o.GPIO8.Reg)&^(0x2)|value<<1)
}
func (o *IO_MUX_Type) GetGPIO8_SLP_SEL() uint32 {
	return (volatile.LoadUint32(&o.GPIO8.Reg) & 0x2) >> 1
}
func (o *IO_MUX_Type) SetGPIO8_MCU_WPD(value uint32) {
	volatile.StoreUint32(&o.GPIO8.Reg, volatile.LoadUint32(&o.GPIO8.Reg)&^(0x4)|value<<2)
}
func (o *IO_MUX_Type) GetGPIO8_MCU_WPD() uint32 {
	return (volatile.LoadUint32(&o.GPIO8.Reg) & 0x4) >> 2
}
func (o *IO_MUX_Type) SetGPIO8_MCU_WPU(value uint32) {
	volatile.StoreUint32(&o.GPIO8.Reg, volatile.LoadUint32(&o.GPIO8.Reg)&^(0x8)|value<<3)
}
func (o *IO_MUX_Type) GetGPIO8_MCU_WPU() uint32 {
	return (volatile.LoadUint32(&o.GPIO8.Reg) & 0x8) >> 3
}
func (o *IO_MUX_Type) SetGPIO8_MCU_IE(value uint32) {
	volatile.StoreUint32(&o.GPIO8.Reg, volatile.LoadUint32(&o.GPIO8.Reg)&^(0x10)|value<<4)
}
func (o *IO_MUX_Type) GetGPIO8_MCU_IE() uint32 {
	return (volatile.LoadUint32(&o.GPIO8.Reg) & 0x10) >> 4
}
func (o *IO_MUX_Type) SetGPIO8_FUN_WPD(value uint32) {
	volatile.StoreUint32(&o.GPIO8.Reg, volatile.LoadUint32(&o.GPIO8.Reg)&^(0x80)|value<<7)
}
func (o *IO_MUX_Type) GetGPIO8_FUN_WPD() uint32 {
	return (volatile.LoadUint32(&o.GPIO8.Reg) & 0x80) >> 7
}
func (o *IO_MUX_Type) SetGPIO8_FUN_WPU(value uint32) {
	volatile.StoreUint32(&o.GPIO8.Reg, volatile.LoadUint32(&o.GPIO8.Reg)&^(0x100)|value<<8)
}
func (o *IO_MUX_Type) GetGPIO8_FUN_WPU() uint32 {
	return (volatile.LoadUint32(&o.GPIO8.Reg) & 0x100) >> 8
}
func (o *IO_MUX_Type) SetGPIO8_FUN_IE(value uint32) {
	volatile.StoreUint32(&o.GPIO8.Reg, volatile.LoadUint32(&o.GPIO8.Reg)&^(0x200)|value<<9)
}
func (o *IO_MUX_Type) GetGPIO8_FUN_IE() uint32 {
	return (volatile.LoadUint32(&o.GPIO8.Reg) & 0x200) >> 9
}
func (o *IO_MUX_Type) SetGPIO8_FUN_DRV(value uint32) {
	volatile.StoreUint32(&o.GPIO8.Reg, volatile.LoadUint32(&o.GPIO8.Reg)&^(0xc00)|value<<10)
}
func (o *IO_MUX_Type) GetGPIO8_FUN_DRV() uint32 {
	return (volatile.LoadUint32(&o.GPIO8.Reg) & 0xc00) >> 10
}
func (o *IO_MUX_Type) SetGPIO8_MCU_SEL(value uint32) {
	volatile.StoreUint32(&o.GPIO8.Reg, volatile.LoadUint32(&o.GPIO8.Reg)&^(0x7000)|value<<12)
}
func (o *IO_MUX_Type) GetGPIO8_MCU_SEL() uint32 {
	return (volatile.LoadUint32(&o.GPIO8.Reg) & 0x7000) >> 12
}
func (o *IO_MUX_Type) SetGPIO8_FILTER_EN(value uint32) {
	volatile.StoreUint32(&o.GPIO8.Reg, volatile.LoadUint32(&o.GPIO8.Reg)&^(0x8000)|value<<15)
}
func (o *IO_MUX_Type) GetGPIO8_FILTER_EN() uint32 {
	return (volatile.LoadUint32(&o.GPIO8.Reg) & 0x8000) >> 15
}

// IO_MUX.GPIO9: IO MUX Configure Register for pad XTAL_32K_P
func (o *IO_MUX_Type) SetGPIO9_MCU_OE(value uint32) {
	volatile.StoreUint32(&o.GPIO9.Reg, volatile.LoadUint32(&o.GPIO9.Reg)&^(0x1)|value)
}
func (o *IO_MUX_Type) GetGPIO9_MCU_OE() uint32 {
	return volatile.LoadUint32(&o.GPIO9.Reg) & 0x1
}
func (o *IO_MUX_Type) SetGPIO9_SLP_SEL(value uint32) {
	volatile.StoreUint32(&o.GPIO9.Reg, volatile.LoadUint32(&o.GPIO9.Reg)&^(0x2)|value<<1)
}
func (o *IO_MUX_Type) GetGPIO9_SLP_SEL() uint32 {
	return (volatile.LoadUint32(&o.GPIO9.Reg) & 0x2) >> 1
}
func (o *IO_MUX_Type) SetGPIO9_MCU_WPD(value uint32) {
	volatile.StoreUint32(&o.GPIO9.Reg, volatile.LoadUint32(&o.GPIO9.Reg)&^(0x4)|value<<2)
}
func (o *IO_MUX_Type) GetGPIO9_MCU_WPD() uint32 {
	return (volatile.LoadUint32(&o.GPIO9.Reg) & 0x4) >> 2
}
func (o *IO_MUX_Type) SetGPIO9_MCU_WPU(value uint32) {
	volatile.StoreUint32(&o.GPIO9.Reg, volatile.LoadUint32(&o.GPIO9.Reg)&^(0x8)|value<<3)
}
func (o *IO_MUX_Type) GetGPIO9_MCU_WPU() uint32 {
	return (volatile.LoadUint32(&o.GPIO9.Reg) & 0x8) >> 3
}
func (o *IO_MUX_Type) SetGPIO9_MCU_IE(value uint32) {
	volatile.StoreUint32(&o.GPIO9.Reg, volatile.LoadUint32(&o.GPIO9.Reg)&^(0x10)|value<<4)
}
func (o *IO_MUX_Type) GetGPIO9_MCU_IE() uint32 {
	return (volatile.LoadUint32(&o.GPIO9.Reg) & 0x10) >> 4
}
func (o *IO_MUX_Type) SetGPIO9_FUN_WPD(value uint32) {
	volatile.StoreUint32(&o.GPIO9.Reg, volatile.LoadUint32(&o.GPIO9.Reg)&^(0x80)|value<<7)
}
func (o *IO_MUX_Type) GetGPIO9_FUN_WPD() uint32 {
	return (volatile.LoadUint32(&o.GPIO9.Reg) & 0x80) >> 7
}
func (o *IO_MUX_Type) SetGPIO9_FUN_WPU(value uint32) {
	volatile.StoreUint32(&o.GPIO9.Reg, volatile.LoadUint32(&o.GPIO9.Reg)&^(0x100)|value<<8)
}
func (o *IO_MUX_Type) GetGPIO9_FUN_WPU() uint32 {
	return (volatile.LoadUint32(&o.GPIO9.Reg) & 0x100) >> 8
}
func (o *IO_MUX_Type) SetGPIO9_FUN_IE(value uint32) {
	volatile.StoreUint32(&o.GPIO9.Reg, volatile.LoadUint32(&o.GPIO9.Reg)&^(0x200)|value<<9)
}
func (o *IO_MUX_Type) GetGPIO9_FUN_IE() uint32 {
	return (volatile.LoadUint32(&o.GPIO9.Reg) & 0x200) >> 9
}
func (o *IO_MUX_Type) SetGPIO9_FUN_DRV(value uint32) {
	volatile.StoreUint32(&o.GPIO9.Reg, volatile.LoadUint32(&o.GPIO9.Reg)&^(0xc00)|value<<10)
}
func (o *IO_MUX_Type) GetGPIO9_FUN_DRV() uint32 {
	return (volatile.LoadUint32(&o.GPIO9.Reg) & 0xc00) >> 10
}
func (o *IO_MUX_Type) SetGPIO9_MCU_SEL(value uint32) {
	volatile.StoreUint32(&o.GPIO9.Reg, volatile.LoadUint32(&o.GPIO9.Reg)&^(0x7000)|value<<12)
}
func (o *IO_MUX_Type) GetGPIO9_MCU_SEL() uint32 {
	return (volatile.LoadUint32(&o.GPIO9.Reg) & 0x7000) >> 12
}
func (o *IO_MUX_Type) SetGPIO9_FILTER_EN(value uint32) {
	volatile.StoreUint32(&o.GPIO9.Reg, volatile.LoadUint32(&o.GPIO9.Reg)&^(0x8000)|value<<15)
}
func (o *IO_MUX_Type) GetGPIO9_FILTER_EN() uint32 {
	return (volatile.LoadUint32(&o.GPIO9.Reg) & 0x8000) >> 15
}

// IO_MUX.GPIO10: IO MUX Configure Register for pad XTAL_32K_P
func (o *IO_MUX_Type) SetGPIO10_MCU_OE(value uint32) {
	volatile.StoreUint32(&o.GPIO10.Reg, volatile.LoadUint32(&o.GPIO10.Reg)&^(0x1)|value)
}
func (o *IO_MUX_Type) GetGPIO10_MCU_OE() uint32 {
	return volatile.LoadUint32(&o.GPIO10.Reg) & 0x1
}
func (o *IO_MUX_Type) SetGPIO10_SLP_SEL(value uint32) {
	volatile.StoreUint32(&o.GPIO10.Reg, volatile.LoadUint32(&o.GPIO10.Reg)&^(0x2)|value<<1)
}
func (o *IO_MUX_Type) GetGPIO10_SLP_SEL() uint32 {
	return (volatile.LoadUint32(&o.GPIO10.Reg) & 0x2) >> 1
}
func (o *IO_MUX_Type) SetGPIO10_MCU_WPD(value uint32) {
	volatile.StoreUint32(&o.GPIO10.Reg, volatile.LoadUint32(&o.GPIO10.Reg)&^(0x4)|value<<2)
}
func (o *IO_MUX_Type) GetGPIO10_MCU_WPD() uint32 {
	return (volatile.LoadUint32(&o.GPIO10.Reg) & 0x4) >> 2
}
func (o *IO_MUX_Type) SetGPIO10_MCU_WPU(value uint32) {
	volatile.StoreUint32(&o.GPIO10.Reg, volatile.LoadUint32(&o.GPIO10.Reg)&^(0x8)|value<<3)
}
func (o *IO_MUX_Type) GetGPIO10_MCU_WPU() uint32 {
	return (volatile.LoadUint32(&o.GPIO10.Reg) & 0x8) >> 3
}
func (o *IO_MUX_Type) SetGPIO10_MCU_IE(value uint32) {
	volatile.StoreUint32(&o.GPIO10.Reg, volatile.LoadUint32(&o.GPIO10.Reg)&^(0x10)|value<<4)
}
func (o *IO_MUX_Type) GetGPIO10_MCU_IE() uint32 {
	return (volatile.LoadUint32(&o.GPIO10.Reg) & 0x10) >> 4
}
func (o *IO_MUX_Type) SetGPIO10_FUN_WPD(value uint32) {
	volatile.StoreUint32(&o.GPIO10.Reg, volatile.LoadUint32(&o.GPIO10.Reg)&^(0x80)|value<<7)
}
func (o *IO_MUX_Type) GetGPIO10_FUN_WPD() uint32 {
	return (volatile.LoadUint32(&o.GPIO10.Reg) & 0x80) >> 7
}
func (o *IO_MUX_Type) SetGPIO10_FUN_WPU(value uint32) {
	volatile.StoreUint32(&o.GPIO10.Reg, volatile.LoadUint32(&o.GPIO10.Reg)&^(0x100)|value<<8)
}
func (o *IO_MUX_Type) GetGPIO10_FUN_WPU() uint32 {
	return (volatile.LoadUint32(&o.GPIO10.Reg) & 0x100) >> 8
}
func (o *IO_MUX_Type) SetGPIO10_FUN_IE(value uint32) {
	volatile.StoreUint32(&o.GPIO10.Reg, volatile.LoadUint32(&o.GPIO10.Reg)&^(0x200)|value<<9)
}
func (o *IO_MUX_Type) GetGPIO10_FUN_IE() uint32 {
	return (volatile.LoadUint32(&o.GPIO10.Reg) & 0x200) >> 9
}
func (o *IO_MUX_Type) SetGPIO10_FUN_DRV(value uint32) {
	volatile.StoreUint32(&o.GPIO10.Reg, volatile.LoadUint32(&o.GPIO10.Reg)&^(0xc00)|value<<10)
}
func (o *IO_MUX_Type) GetGPIO10_FUN_DRV() uint32 {
	return (volatile.LoadUint32(&o.GPIO10.Reg) & 0xc00) >> 10
}
func (o *IO_MUX_Type) SetGPIO10_MCU_SEL(value uint32) {
	volatile.StoreUint32(&o.GPIO10.Reg, volatile.LoadUint32(&o.GPIO10.Reg)&^(0x7000)|value<<12)
}
func (o *IO_MUX_Type) GetGPIO10_MCU_SEL() uint32 {
	return (volatile.LoadUint32(&o.GPIO10.Reg) & 0x7000) >> 12
}
func (o *IO_MUX_Type) SetGPIO10_FILTER_EN(value uint32) {
	volatile.StoreUint32(&o.GPIO10.Reg, volatile.LoadUint32(&o.GPIO10.Reg)&^(0x8000)|value<<15)
}
func (o *IO_MUX_Type) GetGPIO10_FILTER_EN() uint32 {
	return (volatile.LoadUint32(&o.GPIO10.Reg) & 0x8000) >> 15
}

// IO_MUX.GPIO11: IO MUX Configure Register for pad XTAL_32K_P
func (o *IO_MUX_Type) SetGPIO11_MCU_OE(value uint32) {
	volatile.StoreUint32(&o.GPIO11.Reg, volatile.LoadUint32(&o.GPIO11.Reg)&^(0x1)|value)
}
func (o *IO_MUX_Type) GetGPIO11_MCU_OE() uint32 {
	return volatile.LoadUint32(&o.GPIO11.Reg) & 0x1
}
func (o *IO_MUX_Type) SetGPIO11_SLP_SEL(value uint32) {
	volatile.StoreUint32(&o.GPIO11.Reg, volatile.LoadUint32(&o.GPIO11.Reg)&^(0x2)|value<<1)
}
func (o *IO_MUX_Type) GetGPIO11_SLP_SEL() uint32 {
	return (volatile.LoadUint32(&o.GPIO11.Reg) & 0x2) >> 1
}
func (o *IO_MUX_Type) SetGPIO11_MCU_WPD(value uint32) {
	volatile.StoreUint32(&o.GPIO11.Reg, volatile.LoadUint32(&o.GPIO11.Reg)&^(0x4)|value<<2)
}
func (o *IO_MUX_Type) GetGPIO11_MCU_WPD() uint32 {
	return (volatile.LoadUint32(&o.GPIO11.Reg) & 0x4) >> 2
}
func (o *IO_MUX_Type) SetGPIO11_MCU_WPU(value uint32) {
	volatile.StoreUint32(&o.GPIO11.Reg, volatile.LoadUint32(&o.GPIO11.Reg)&^(0x8)|value<<3)
}
func (o *IO_MUX_Type) GetGPIO11_MCU_WPU() uint32 {
	return (volatile.LoadUint32(&o.GPIO11.Reg) & 0x8) >> 3
}
func (o *IO_MUX_Type) SetGPIO11_MCU_IE(value uint32) {
	volatile.StoreUint32(&o.GPIO11.Reg, volatile.LoadUint32(&o.GPIO11.Reg)&^(0x10)|value<<4)
}
func (o *IO_MUX_Type) GetGPIO11_MCU_IE() uint32 {
	return (volatile.LoadUint32(&o.GPIO11.Reg) & 0x10) >> 4
}
func (o *IO_MUX_Type) SetGPIO11_FUN_WPD(value uint32) {
	volatile.StoreUint32(&o.GPIO11.Reg, volatile.LoadUint32(&o.GPIO11.Reg)&^(0x80)|value<<7)
}
func (o *IO_MUX_Type) GetGPIO11_FUN_WPD() uint32 {
	return (volatile.LoadUint32(&o.GPIO11.Reg) & 0x80) >> 7
}
func (o *IO_MUX_Type) SetGPIO11_FUN_WPU(value uint32) {
	volatile.StoreUint32(&o.GPIO11.Reg, volatile.LoadUint32(&o.GPIO11.Reg)&^(0x100)|value<<8)
}
func (o *IO_MUX_Type) GetGPIO11_FUN_WPU() uint32 {
	return (volatile.LoadUint32(&o.GPIO11.Reg) & 0x100) >> 8
}
func (o *IO_MUX_Type) SetGPIO11_FUN_IE(value uint32) {
	volatile.StoreUint32(&o.GPIO11.Reg, volatile.LoadUint32(&o.GPIO11.Reg)&^(0x200)|value<<9)
}
func (o *IO_MUX_Type) GetGPIO11_FUN_IE() uint32 {
	return (volatile.LoadUint32(&o.GPIO11.Reg) & 0x200) >> 9
}
func (o *IO_MUX_Type) SetGPIO11_FUN_DRV(value uint32) {
	volatile.StoreUint32(&o.GPIO11.Reg, volatile.LoadUint32(&o.GPIO11.Reg)&^(0xc00)|value<<10)
}
func (o *IO_MUX_Type) GetGPIO11_FUN_DRV() uint32 {
	return (volatile.LoadUint32(&o.GPIO11.Reg) & 0xc00) >> 10
}
func (o *IO_MUX_Type) SetGPIO11_MCU_SEL(value uint32) {
	volatile.StoreUint32(&o.GPIO11.Reg, volatile.LoadUint32(&o.GPIO11.Reg)&^(0x7000)|value<<12)
}
func (o *IO_MUX_Type) GetGPIO11_MCU_SEL() uint32 {
	return (volatile.LoadUint32(&o.GPIO11.Reg) & 0x7000) >> 12
}
func (o *IO_MUX_Type) SetGPIO11_FILTER_EN(value uint32) {
	volatile.StoreUint32(&o.GPIO11.Reg, volatile.LoadUint32(&o.GPIO11.Reg)&^(0x8000)|value<<15)
}
func (o *IO_MUX_Type) GetGPIO11_FILTER_EN() uint32 {
	return (volatile.LoadUint32(&o.GPIO11.Reg) & 0x8000) >> 15
}

// IO_MUX.GPIO12: IO MUX Configure Register for pad XTAL_32K_P
func (o *IO_MUX_Type) SetGPIO12_MCU_OE(value uint32) {
	volatile.StoreUint32(&o.GPIO12.Reg, volatile.LoadUint32(&o.GPIO12.Reg)&^(0x1)|value)
}
func (o *IO_MUX_Type) GetGPIO12_MCU_OE() uint32 {
	return volatile.LoadUint32(&o.GPIO12.Reg) & 0x1
}
func (o *IO_MUX_Type) SetGPIO12_SLP_SEL(value uint32) {
	volatile.StoreUint32(&o.GPIO12.Reg, volatile.LoadUint32(&o.GPIO12.Reg)&^(0x2)|value<<1)
}
func (o *IO_MUX_Type) GetGPIO12_SLP_SEL() uint32 {
	return (volatile.LoadUint32(&o.GPIO12.Reg) & 0x2) >> 1
}
func (o *IO_MUX_Type) SetGPIO12_MCU_WPD(value uint32) {
	volatile.StoreUint32(&o.GPIO12.Reg, volatile.LoadUint32(&o.GPIO12.Reg)&^(0x4)|value<<2)
}
func (o *IO_MUX_Type) GetGPIO12_MCU_WPD() uint32 {
	return (volatile.LoadUint32(&o.GPIO12.Reg) & 0x4) >> 2
}
func (o *IO_MUX_Type) SetGPIO12_MCU_WPU(value uint32) {
	volatile.StoreUint32(&o.GPIO12.Reg, volatile.LoadUint32(&o.GPIO12.Reg)&^(0x8)|value<<3)
}
func (o *IO_MUX_Type) GetGPIO12_MCU_WPU() uint32 {
	return (volatile.LoadUint32(&o.GPIO12.Reg) & 0x8) >> 3
}
func (o *IO_MUX_Type) SetGPIO12_MCU_IE(value uint32) {
	volatile.StoreUint32(&o.GPIO12.Reg, volatile.LoadUint32(&o.GPIO12.Reg)&^(0x10)|value<<4)
}
func (o *IO_MUX_Type) GetGPIO12_MCU_IE() uint32 {
	return (volatile.LoadUint32(&o.GPIO12.Reg) & 0x10) >> 4
}
func (o *IO_MUX_Type) SetGPIO12_FUN_WPD(value uint32) {
	volatile.StoreUint32(&o.GPIO12.Reg, volatile.LoadUint32(&o.GPIO12.Reg)&^(0x80)|value<<7)
}
func (o *IO_MUX_Type) GetGPIO12_FUN_WPD() uint32 {
	return (volatile.LoadUint32(&o.GPIO12.Reg) & 0x80) >> 7
}
func (o *IO_MUX_Type) SetGPIO12_FUN_WPU(value uint32) {
	volatile.StoreUint32(&o.GPIO12.Reg, volatile.LoadUint32(&o.GPIO12.Reg)&^(0x100)|value<<8)
}
func (o *IO_MUX_Type) GetGPIO12_FUN_WPU() uint32 {
	return (volatile.LoadUint32(&o.GPIO12.Reg) & 0x100) >> 8
}
func (o *IO_MUX_Type) SetGPIO12_FUN_IE(value uint32) {
	volatile.StoreUint32(&o.GPIO12.Reg, volatile.LoadUint32(&o.GPIO12.Reg)&^(0x200)|value<<9)
}
func (o *IO_MUX_Type) GetGPIO12_FUN_IE() uint32 {
	return (volatile.LoadUint32(&o.GPIO12.Reg) & 0x200) >> 9
}
func (o *IO_MUX_Type) SetGPIO12_FUN_DRV(value uint32) {
	volatile.StoreUint32(&o.GPIO12.Reg, volatile.LoadUint32(&o.GPIO12.Reg)&^(0xc00)|value<<10)
}
func (o *IO_MUX_Type) GetGPIO12_FUN_DRV() uint32 {
	return (volatile.LoadUint32(&o.GPIO12.Reg) & 0xc00) >> 10
}
func (o *IO_MUX_Type) SetGPIO12_MCU_SEL(value uint32) {
	volatile.StoreUint32(&o.GPIO12.Reg, volatile.LoadUint32(&o.GPIO12.Reg)&^(0x7000)|value<<12)
}
func (o *IO_MUX_Type) GetGPIO12_MCU_SEL() uint32 {
	return (volatile.LoadUint32(&o.GPIO12.Reg) & 0x7000) >> 12
}
func (o *IO_MUX_Type) SetGPIO12_FILTER_EN(value uint32) {
	volatile.StoreUint32(&o.GPIO12.Reg, volatile.LoadUint32(&o.GPIO12.Reg)&^(0x8000)|value<<15)
}
func (o *IO_MUX_Type) GetGPIO12_FILTER_EN() uint32 {
	return (volatile.LoadUint32(&o.GPIO12.Reg) & 0x8000) >> 15
}

// IO_MUX.GPIO13: IO MUX Configure Register for pad XTAL_32K_P
func (o *IO_MUX_Type) SetGPIO13_MCU_OE(value uint32) {
	volatile.StoreUint32(&o.GPIO13.Reg, volatile.LoadUint32(&o.GPIO13.Reg)&^(0x1)|value)
}
func (o *IO_MUX_Type) GetGPIO13_MCU_OE() uint32 {
	return volatile.LoadUint32(&o.GPIO13.Reg) & 0x1
}
func (o *IO_MUX_Type) SetGPIO13_SLP_SEL(value uint32) {
	volatile.StoreUint32(&o.GPIO13.Reg, volatile.LoadUint32(&o.GPIO13.Reg)&^(0x2)|value<<1)
}
func (o *IO_MUX_Type) GetGPIO13_SLP_SEL() uint32 {
	return (volatile.LoadUint32(&o.GPIO13.Reg) & 0x2) >> 1
}
func (o *IO_MUX_Type) SetGPIO13_MCU_WPD(value uint32) {
	volatile.StoreUint32(&o.GPIO13.Reg, volatile.LoadUint32(&o.GPIO13.Reg)&^(0x4)|value<<2)
}
func (o *IO_MUX_Type) GetGPIO13_MCU_WPD() uint32 {
	return (volatile.LoadUint32(&o.GPIO13.Reg) & 0x4) >> 2
}
func (o *IO_MUX_Type) SetGPIO13_MCU_WPU(value uint32) {
	volatile.StoreUint32(&o.GPIO13.Reg, volatile.LoadUint32(&o.GPIO13.Reg)&^(0x8)|value<<3)
}
func (o *IO_MUX_Type) GetGPIO13_MCU_WPU() uint32 {
	return (volatile.LoadUint32(&o.GPIO13.Reg) & 0x8) >> 3
}
func (o *IO_MUX_Type) SetGPIO13_MCU_IE(value uint32) {
	volatile.StoreUint32(&o.GPIO13.Reg, volatile.LoadUint32(&o.GPIO13.Reg)&^(0x10)|value<<4)
}
func (o *IO_MUX_Type) GetGPIO13_MCU_IE() uint32 {
	return (volatile.LoadUint32(&o.GPIO13.Reg) & 0x10) >> 4
}
func (o *IO_MUX_Type) SetGPIO13_FUN_WPD(value uint32) {
	volatile.StoreUint32(&o.GPIO13.Reg, volatile.LoadUint32(&o.GPIO13.Reg)&^(0x80)|value<<7)
}
func (o *IO_MUX_Type) GetGPIO13_FUN_WPD() uint32 {
	return (volatile.LoadUint32(&o.GPIO13.Reg) & 0x80) >> 7
}
func (o *IO_MUX_Type) SetGPIO13_FUN_WPU(value uint32) {
	volatile.StoreUint32(&o.GPIO13.Reg, volatile.LoadUint32(&o.GPIO13.Reg)&^(0x100)|value<<8)
}
func (o *IO_MUX_Type) GetGPIO13_FUN_WPU() uint32 {
	return (volatile.LoadUint32(&o.GPIO13.Reg) & 0x100) >> 8
}
func (o *IO_MUX_Type) SetGPIO13_FUN_IE(value uint32) {
	volatile.StoreUint32(&o.GPIO13.Reg, volatile.LoadUint32(&o.GPIO13.Reg)&^(0x200)|value<<9)
}
func (o *IO_MUX_Type) GetGPIO13_FUN_IE() uint32 {
	return (volatile.LoadUint32(&o.GPIO13.Reg) & 0x200) >> 9
}
func (o *IO_MUX_Type) SetGPIO13_FUN_DRV(value uint32) {
	volatile.StoreUint32(&o.GPIO13.Reg, volatile.LoadUint32(&o.GPIO13.Reg)&^(0xc00)|value<<10)
}
func (o *IO_MUX_Type) GetGPIO13_FUN_DRV() uint32 {
	return (volatile.LoadUint32(&o.GPIO13.Reg) & 0xc00) >> 10
}
func (o *IO_MUX_Type) SetGPIO13_MCU_SEL(value uint32) {
	volatile.StoreUint32(&o.GPIO13.Reg, volatile.LoadUint32(&o.GPIO13.Reg)&^(0x7000)|value<<12)
}
func (o *IO_MUX_Type) GetGPIO13_MCU_SEL() uint32 {
	return (volatile.LoadUint32(&o.GPIO13.Reg) & 0x7000) >> 12
}
func (o *IO_MUX_Type) SetGPIO13_FILTER_EN(value uint32) {
	volatile.StoreUint32(&o.GPIO13.Reg, volatile.LoadUint32(&o.GPIO13.Reg)&^(0x8000)|value<<15)
}
func (o *IO_MUX_Type) GetGPIO13_FILTER_EN() uint32 {
	return (volatile.LoadUint32(&o.GPIO13.Reg) & 0x8000) >> 15
}

// IO_MUX.GPIO14: IO MUX Configure Register for pad XTAL_32K_P
func (o *IO_MUX_Type) SetGPIO14_MCU_OE(value uint32) {
	volatile.StoreUint32(&o.GPIO14.Reg, volatile.LoadUint32(&o.GPIO14.Reg)&^(0x1)|value)
}
func (o *IO_MUX_Type) GetGPIO14_MCU_OE() uint32 {
	return volatile.LoadUint32(&o.GPIO14.Reg) & 0x1
}
func (o *IO_MUX_Type) SetGPIO14_SLP_SEL(value uint32) {
	volatile.StoreUint32(&o.GPIO14.Reg, volatile.LoadUint32(&o.GPIO14.Reg)&^(0x2)|value<<1)
}
func (o *IO_MUX_Type) GetGPIO14_SLP_SEL() uint32 {
	return (volatile.LoadUint32(&o.GPIO14.Reg) & 0x2) >> 1
}
func (o *IO_MUX_Type) SetGPIO14_MCU_WPD(value uint32) {
	volatile.StoreUint32(&o.GPIO14.Reg, volatile.LoadUint32(&o.GPIO14.Reg)&^(0x4)|value<<2)
}
func (o *IO_MUX_Type) GetGPIO14_MCU_WPD() uint32 {
	return (volatile.LoadUint32(&o.GPIO14.Reg) & 0x4) >> 2
}
func (o *IO_MUX_Type) SetGPIO14_MCU_WPU(value uint32) {
	volatile.StoreUint32(&o.GPIO14.Reg, volatile.LoadUint32(&o.GPIO14.Reg)&^(0x8)|value<<3)
}
func (o *IO_MUX_Type) GetGPIO14_MCU_WPU() uint32 {
	return (volatile.LoadUint32(&o.GPIO14.Reg) & 0x8) >> 3
}
func (o *IO_MUX_Type) SetGPIO14_MCU_IE(value uint32) {
	volatile.StoreUint32(&o.GPIO14.Reg, volatile.LoadUint32(&o.GPIO14.Reg)&^(0x10)|value<<4)
}
func (o *IO_MUX_Type) GetGPIO14_MCU_IE() uint32 {
	return (volatile.LoadUint32(&o.GPIO14.Reg) & 0x10) >> 4
}
func (o *IO_MUX_Type) SetGPIO14_FUN_WPD(value uint32) {
	volatile.StoreUint32(&o.GPIO14.Reg, volatile.LoadUint32(&o.GPIO14.Reg)&^(0x80)|value<<7)
}
func (o *IO_MUX_Type) GetGPIO14_FUN_WPD() uint32 {
	return (volatile.LoadUint32(&o.GPIO14.Reg) & 0x80) >> 7
}
func (o *IO_MUX_Type) SetGPIO14_FUN_WPU(value uint32) {
	volatile.StoreUint32(&o.GPIO14.Reg, volatile.LoadUint32(&o.GPIO14.Reg)&^(0x100)|value<<8)
}
func (o *IO_MUX_Type) GetGPIO14_FUN_WPU() uint32 {
	return (volatile.LoadUint32(&o.GPIO14.Reg) & 0x100) >> 8
}
func (o *IO_MUX_Type) SetGPIO14_FUN_IE(value uint32) {
	volatile.StoreUint32(&o.GPIO14.Reg, volatile.LoadUint32(&o.GPIO14.Reg)&^(0x200)|value<<9)
}
func (o *IO_MUX_Type) GetGPIO14_FUN_IE() uint32 {
	return (volatile.LoadUint32(&o.GPIO14.Reg) & 0x200) >> 9
}
func (o *IO_MUX_Type) SetGPIO14_FUN_DRV(value uint32) {
	volatile.StoreUint32(&o.GPIO14.Reg, volatile.LoadUint32(&o.GPIO14.Reg)&^(0xc00)|value<<10)
}
func (o *IO_MUX_Type) GetGPIO14_FUN_DRV() uint32 {
	return (volatile.LoadUint32(&o.GPIO14.Reg) & 0xc00) >> 10
}
func (o *IO_MUX_Type) SetGPIO14_MCU_SEL(value uint32) {
	volatile.StoreUint32(&o.GPIO14.Reg, volatile.LoadUint32(&o.GPIO14.Reg)&^(0x7000)|value<<12)
}
func (o *IO_MUX_Type) GetGPIO14_MCU_SEL() uint32 {
	return (volatile.LoadUint32(&o.GPIO14.Reg) & 0x7000) >> 12
}
func (o *IO_MUX_Type) SetGPIO14_FILTER_EN(value uint32) {
	volatile.StoreUint32(&o.GPIO14.Reg, volatile.LoadUint32(&o.GPIO14.Reg)&^(0x8000)|value<<15)
}
func (o *IO_MUX_Type) GetGPIO14_FILTER_EN() uint32 {
	return (volatile.LoadUint32(&o.GPIO14.Reg) & 0x8000) >> 15
}

// IO_MUX.GPIO15: IO MUX Configure Register for pad XTAL_32K_P
func (o *IO_MUX_Type) SetGPIO15_MCU_OE(value uint32) {
	volatile.StoreUint32(&o.GPIO15.Reg, volatile.LoadUint32(&o.GPIO15.Reg)&^(0x1)|value)
}
func (o *IO_MUX_Type) GetGPIO15_MCU_OE() uint32 {
	return volatile.LoadUint32(&o.GPIO15.Reg) & 0x1
}
func (o *IO_MUX_Type) SetGPIO15_SLP_SEL(value uint32) {
	volatile.StoreUint32(&o.GPIO15.Reg, volatile.LoadUint32(&o.GPIO15.Reg)&^(0x2)|value<<1)
}
func (o *IO_MUX_Type) GetGPIO15_SLP_SEL() uint32 {
	return (volatile.LoadUint32(&o.GPIO15.Reg) & 0x2) >> 1
}
func (o *IO_MUX_Type) SetGPIO15_MCU_WPD(value uint32) {
	volatile.StoreUint32(&o.GPIO15.Reg, volatile.LoadUint32(&o.GPIO15.Reg)&^(0x4)|value<<2)
}
func (o *IO_MUX_Type) GetGPIO15_MCU_WPD() uint32 {
	return (volatile.LoadUint32(&o.GPIO15.Reg) & 0x4) >> 2
}
func (o *IO_MUX_Type) SetGPIO15_MCU_WPU(value uint32) {
	volatile.StoreUint32(&o.GPIO15.Reg, volatile.LoadUint32(&o.GPIO15.Reg)&^(0x8)|value<<3)
}
func (o *IO_MUX_Type) GetGPIO15_MCU_WPU() uint32 {
	return (volatile.LoadUint32(&o.GPIO15.Reg) & 0x8) >> 3
}
func (o *IO_MUX_Type) SetGPIO15_MCU_IE(value uint32) {
	volatile.StoreUint32(&o.GPIO15.Reg, volatile.LoadUint32(&o.GPIO15.Reg)&^(0x10)|value<<4)
}
func (o *IO_MUX_Type) GetGPIO15_MCU_IE() uint32 {
	return (volatile.LoadUint32(&o.GPIO15.Reg) & 0x10) >> 4
}
func (o *IO_MUX_Type) SetGPIO15_FUN_WPD(value uint32) {
	volatile.StoreUint32(&o.GPIO15.Reg, volatile.LoadUint32(&o.GPIO15.Reg)&^(0x80)|value<<7)
}
func (o *IO_MUX_Type) GetGPIO15_FUN_WPD() uint32 {
	return (volatile.LoadUint32(&o.GPIO15.Reg) & 0x80) >> 7
}
func (o *IO_MUX_Type) SetGPIO15_FUN_WPU(value uint32) {
	volatile.StoreUint32(&o.GPIO15.Reg, volatile.LoadUint32(&o.GPIO15.Reg)&^(0x100)|value<<8)
}
func (o *IO_MUX_Type) GetGPIO15_FUN_WPU() uint32 {
	return (volatile.LoadUint32(&o.GPIO15.Reg) & 0x100) >> 8
}
func (o *IO_MUX_Type) SetGPIO15_FUN_IE(value uint32) {
	volatile.StoreUint32(&o.GPIO15.Reg, volatile.LoadUint32(&o.GPIO15.Reg)&^(0x200)|value<<9)
}
func (o *IO_MUX_Type) GetGPIO15_FUN_IE() uint32 {
	return (volatile.LoadUint32(&o.GPIO15.Reg) & 0x200) >> 9
}
func (o *IO_MUX_Type) SetGPIO15_FUN_DRV(value uint32) {
	volatile.StoreUint32(&o.GPIO15.Reg, volatile.LoadUint32(&o.GPIO15.Reg)&^(0xc00)|value<<10)
}
func (o *IO_MUX_Type) GetGPIO15_FUN_DRV() uint32 {
	return (volatile.LoadUint32(&o.GPIO15.Reg) & 0xc00) >> 10
}
func (o *IO_MUX_Type) SetGPIO15_MCU_SEL(value uint32) {
	volatile.StoreUint32(&o.GPIO15.Reg, volatile.LoadUint32(&o.GPIO15.Reg)&^(0x7000)|value<<12)
}
func (o *IO_MUX_Type) GetGPIO15_MCU_SEL() uint32 {
	return (volatile.LoadUint32(&o.GPIO15.Reg) & 0x7000) >> 12
}
func (o *IO_MUX_Type) SetGPIO15_FILTER_EN(value uint32) {
	volatile.StoreUint32(&o.GPIO15.Reg, volatile.LoadUint32(&o.GPIO15.Reg)&^(0x8000)|value<<15)
}
func (o *IO_MUX_Type) GetGPIO15_FILTER_EN() uint32 {
	return (volatile.LoadUint32(&o.GPIO15.Reg) & 0x8000) >> 15
}

// IO_MUX.GPIO16: IO MUX Configure Register for pad XTAL_32K_P
func (o *IO_MUX_Type) SetGPIO16_MCU_OE(value uint32) {
	volatile.StoreUint32(&o.GPIO16.Reg, volatile.LoadUint32(&o.GPIO16.Reg)&^(0x1)|value)
}
func (o *IO_MUX_Type) GetGPIO16_MCU_OE() uint32 {
	return volatile.LoadUint32(&o.GPIO16.Reg) & 0x1
}
func (o *IO_MUX_Type) SetGPIO16_SLP_SEL(value uint32) {
	volatile.StoreUint32(&o.GPIO16.Reg, volatile.LoadUint32(&o.GPIO16.Reg)&^(0x2)|value<<1)
}
func (o *IO_MUX_Type) GetGPIO16_SLP_SEL() uint32 {
	return (volatile.LoadUint32(&o.GPIO16.Reg) & 0x2) >> 1
}
func (o *IO_MUX_Type) SetGPIO16_MCU_WPD(value uint32) {
	volatile.StoreUint32(&o.GPIO16.Reg, volatile.LoadUint32(&o.GPIO16.Reg)&^(0x4)|value<<2)
}
func (o *IO_MUX_Type) GetGPIO16_MCU_WPD() uint32 {
	return (volatile.LoadUint32(&o.GPIO16.Reg) & 0x4) >> 2
}
func (o *IO_MUX_Type) SetGPIO16_MCU_WPU(value uint32) {
	volatile.StoreUint32(&o.GPIO16.Reg, volatile.LoadUint32(&o.GPIO16.Reg)&^(0x8)|value<<3)
}
func (o *IO_MUX_Type) GetGPIO16_MCU_WPU() uint32 {
	return (volatile.LoadUint32(&o.GPIO16.Reg) & 0x8) >> 3
}
func (o *IO_MUX_Type) SetGPIO16_MCU_IE(value uint32) {
	volatile.StoreUint32(&o.GPIO16.Reg, volatile.LoadUint32(&o.GPIO16.Reg)&^(0x10)|value<<4)
}
func (o *IO_MUX_Type) GetGPIO16_MCU_IE() uint32 {
	return (volatile.LoadUint32(&o.GPIO16.Reg) & 0x10) >> 4
}
func (o *IO_MUX_Type) SetGPIO16_FUN_WPD(value uint32) {
	volatile.StoreUint32(&o.GPIO16.Reg, volatile.LoadUint32(&o.GPIO16.Reg)&^(0x80)|value<<7)
}
func (o *IO_MUX_Type) GetGPIO16_FUN_WPD() uint32 {
	return (volatile.LoadUint32(&o.GPIO16.Reg) & 0x80) >> 7
}
func (o *IO_MUX_Type) SetGPIO16_FUN_WPU(value uint32) {
	volatile.StoreUint32(&o.GPIO16.Reg, volatile.LoadUint32(&o.GPIO16.Reg)&^(0x100)|value<<8)
}
func (o *IO_MUX_Type) GetGPIO16_FUN_WPU() uint32 {
	return (volatile.LoadUint32(&o.GPIO16.Reg) & 0x100) >> 8
}
func (o *IO_MUX_Type) SetGPIO16_FUN_IE(value uint32) {
	volatile.StoreUint32(&o.GPIO16.Reg, volatile.LoadUint32(&o.GPIO16.Reg)&^(0x200)|value<<9)
}
func (o *IO_MUX_Type) GetGPIO16_FUN_IE() uint32 {
	return (volatile.LoadUint32(&o.GPIO16.Reg) & 0x200) >> 9
}
func (o *IO_MUX_Type) SetGPIO16_FUN_DRV(value uint32) {
	volatile.StoreUint32(&o.GPIO16.Reg, volatile.LoadUint32(&o.GPIO16.Reg)&^(0xc00)|value<<10)
}
func (o *IO_MUX_Type) GetGPIO16_FUN_DRV() uint32 {
	return (volatile.LoadUint32(&o.GPIO16.Reg) & 0xc00) >> 10
}
func (o *IO_MUX_Type) SetGPIO16_MCU_SEL(value uint32) {
	volatile.StoreUint32(&o.GPIO16.Reg, volatile.LoadUint32(&o.GPIO16.Reg)&^(0x7000)|value<<12)
}
func (o *IO_MUX_Type) GetGPIO16_MCU_SEL() uint32 {
	return (volatile.LoadUint32(&o.GPIO16.Reg) & 0x7000) >> 12
}
func (o *IO_MUX_Type) SetGPIO16_FILTER_EN(value uint32) {
	volatile.StoreUint32(&o.GPIO16.Reg, volatile.LoadUint32(&o.GPIO16.Reg)&^(0x8000)|value<<15)
}
func (o *IO_MUX_Type) GetGPIO16_FILTER_EN() uint32 {
	return (volatile.LoadUint32(&o.GPIO16.Reg) & 0x8000) >> 15
}

// IO_MUX.GPIO17: IO MUX Configure Register for pad XTAL_32K_P
func (o *IO_MUX_Type) SetGPIO17_MCU_OE(value uint32) {
	volatile.StoreUint32(&o.GPIO17.Reg, volatile.LoadUint32(&o.GPIO17.Reg)&^(0x1)|value)
}
func (o *IO_MUX_Type) GetGPIO17_MCU_OE() uint32 {
	return volatile.LoadUint32(&o.GPIO17.Reg) & 0x1
}
func (o *IO_MUX_Type) SetGPIO17_SLP_SEL(value uint32) {
	volatile.StoreUint32(&o.GPIO17.Reg, volatile.LoadUint32(&o.GPIO17.Reg)&^(0x2)|value<<1)
}
func (o *IO_MUX_Type) GetGPIO17_SLP_SEL() uint32 {
	return (volatile.LoadUint32(&o.GPIO17.Reg) & 0x2) >> 1
}
func (o *IO_MUX_Type) SetGPIO17_MCU_WPD(value uint32) {
	volatile.StoreUint32(&o.GPIO17.Reg, volatile.LoadUint32(&o.GPIO17.Reg)&^(0x4)|value<<2)
}
func (o *IO_MUX_Type) GetGPIO17_MCU_WPD() uint32 {
	return (volatile.LoadUint32(&o.GPIO17.Reg) & 0x4) >> 2
}
func (o *IO_MUX_Type) SetGPIO17_MCU_WPU(value uint32) {
	volatile.StoreUint32(&o.GPIO17.Reg, volatile.LoadUint32(&o.GPIO17.Reg)&^(0x8)|value<<3)
}
func (o *IO_MUX_Type) GetGPIO17_MCU_WPU() uint32 {
	return (volatile.LoadUint32(&o.GPIO17.Reg) & 0x8) >> 3
}
func (o *IO_MUX_Type) SetGPIO17_MCU_IE(value uint32) {
	volatile.StoreUint32(&o.GPIO17.Reg, volatile.LoadUint32(&o.GPIO17.Reg)&^(0x10)|value<<4)
}
func (o *IO_MUX_Type) GetGPIO17_MCU_IE() uint32 {
	return (volatile.LoadUint32(&o.GPIO17.Reg) & 0x10) >> 4
}
func (o *IO_MUX_Type) SetGPIO17_FUN_WPD(value uint32) {
	volatile.StoreUint32(&o.GPIO17.Reg, volatile.LoadUint32(&o.GPIO17.Reg)&^(0x80)|value<<7)
}
func (o *IO_MUX_Type) GetGPIO17_FUN_WPD() uint32 {
	return (volatile.LoadUint32(&o.GPIO17.Reg) & 0x80) >> 7
}
func (o *IO_MUX_Type) SetGPIO17_FUN_WPU(value uint32) {
	volatile.StoreUint32(&o.GPIO17.Reg, volatile.LoadUint32(&o.GPIO17.Reg)&^(0x100)|value<<8)
}
func (o *IO_MUX_Type) GetGPIO17_FUN_WPU() uint32 {
	return (volatile.LoadUint32(&o.GPIO17.Reg) & 0x100) >> 8
}
func (o *IO_MUX_Type) SetGPIO17_FUN_IE(value uint32) {
	volatile.StoreUint32(&o.GPIO17.Reg, volatile.LoadUint32(&o.GPIO17.Reg)&^(0x200)|value<<9)
}
func (o *IO_MUX_Type) GetGPIO17_FUN_IE() uint32 {
	return (volatile.LoadUint32(&o.GPIO17.Reg) & 0x200) >> 9
}
func (o *IO_MUX_Type) SetGPIO17_FUN_DRV(value uint32) {
	volatile.StoreUint32(&o.GPIO17.Reg, volatile.LoadUint32(&o.GPIO17.Reg)&^(0xc00)|value<<10)
}
func (o *IO_MUX_Type) GetGPIO17_FUN_DRV() uint32 {
	return (volatile.LoadUint32(&o.GPIO17.Reg) & 0xc00) >> 10
}
func (o *IO_MUX_Type) SetGPIO17_MCU_SEL(value uint32) {
	volatile.StoreUint32(&o.GPIO17.Reg, volatile.LoadUint32(&o.GPIO17.Reg)&^(0x7000)|value<<12)
}
func (o *IO_MUX_Type) GetGPIO17_MCU_SEL() uint32 {
	return (volatile.LoadUint32(&o.GPIO17.Reg) & 0x7000) >> 12
}
func (o *IO_MUX_Type) SetGPIO17_FILTER_EN(value uint32) {
	volatile.StoreUint32(&o.GPIO17.Reg, volatile.LoadUint32(&o.GPIO17.Reg)&^(0x8000)|value<<15)
}
func (o *IO_MUX_Type) GetGPIO17_FILTER_EN() uint32 {
	return (volatile.LoadUint32(&o.GPIO17.Reg) & 0x8000) >> 15
}

// IO_MUX.GPIO18: IO MUX Configure Register for pad XTAL_32K_P
func (o *IO_MUX_Type) SetGPIO18_MCU_OE(value uint32) {
	volatile.StoreUint32(&o.GPIO18.Reg, volatile.LoadUint32(&o.GPIO18.Reg)&^(0x1)|value)
}
func (o *IO_MUX_Type) GetGPIO18_MCU_OE() uint32 {
	return volatile.LoadUint32(&o.GPIO18.Reg) & 0x1
}
func (o *IO_MUX_Type) SetGPIO18_SLP_SEL(value uint32) {
	volatile.StoreUint32(&o.GPIO18.Reg, volatile.LoadUint32(&o.GPIO18.Reg)&^(0x2)|value<<1)
}
func (o *IO_MUX_Type) GetGPIO18_SLP_SEL() uint32 {
	return (volatile.LoadUint32(&o.GPIO18.Reg) & 0x2) >> 1
}
func (o *IO_MUX_Type) SetGPIO18_MCU_WPD(value uint32) {
	volatile.StoreUint32(&o.GPIO18.Reg, volatile.LoadUint32(&o.GPIO18.Reg)&^(0x4)|value<<2)
}
func (o *IO_MUX_Type) GetGPIO18_MCU_WPD() uint32 {
	return (volatile.LoadUint32(&o.GPIO18.Reg) & 0x4) >> 2
}
func (o *IO_MUX_Type) SetGPIO18_MCU_WPU(value uint32) {
	volatile.StoreUint32(&o.GPIO18.Reg, volatile.LoadUint32(&o.GPIO18.Reg)&^(0x8)|value<<3)
}
func (o *IO_MUX_Type) GetGPIO18_MCU_WPU() uint32 {
	return (volatile.LoadUint32(&o.GPIO18.Reg) & 0x8) >> 3
}
func (o *IO_MUX_Type) SetGPIO18_MCU_IE(value uint32) {
	volatile.StoreUint32(&o.GPIO18.Reg, volatile.LoadUint32(&o.GPIO18.Reg)&^(0x10)|value<<4)
}
func (o *IO_MUX_Type) GetGPIO18_MCU_IE() uint32 {
	return (volatile.LoadUint32(&o.GPIO18.Reg) & 0x10) >> 4
}
func (o *IO_MUX_Type) SetGPIO18_FUN_WPD(value uint32) {
	volatile.StoreUint32(&o.GPIO18.Reg, volatile.LoadUint32(&o.GPIO18.Reg)&^(0x80)|value<<7)
}
func (o *IO_MUX_Type) GetGPIO18_FUN_WPD() uint32 {
	return (volatile.LoadUint32(&o.GPIO18.Reg) & 0x80) >> 7
}
func (o *IO_MUX_Type) SetGPIO18_FUN_WPU(value uint32) {
	volatile.StoreUint32(&o.GPIO18.Reg, volatile.LoadUint32(&o.GPIO18.Reg)&^(0x100)|value<<8)
}
func (o *IO_MUX_Type) GetGPIO18_FUN_WPU() uint32 {
	return (volatile.LoadUint32(&o.GPIO18.Reg) & 0x100) >> 8
}
func (o *IO_MUX_Type) SetGPIO18_FUN_IE(value uint32) {
	volatile.StoreUint32(&o.GPIO18.Reg, volatile.LoadUint32(&o.GPIO18.Reg)&^(0x200)|value<<9)
}
func (o *IO_MUX_Type) GetGPIO18_FUN_IE() uint32 {
	return (volatile.LoadUint32(&o.GPIO18.Reg) & 0x200) >> 9
}
func (o *IO_MUX_Type) SetGPIO18_FUN_DRV(value uint32) {
	volatile.StoreUint32(&o.GPIO18.Reg, volatile.LoadUint32(&o.GPIO18.Reg)&^(0xc00)|value<<10)
}
func (o *IO_MUX_Type) GetGPIO18_FUN_DRV() uint32 {
	return (volatile.LoadUint32(&o.GPIO18.Reg) & 0xc00) >> 10
}
func (o *IO_MUX_Type) SetGPIO18_MCU_SEL(value uint32) {
	volatile.StoreUint32(&o.GPIO18.Reg, volatile.LoadUint32(&o.GPIO18.Reg)&^(0x7000)|value<<12)
}
func (o *IO_MUX_Type) GetGPIO18_MCU_SEL() uint32 {
	return (volatile.LoadUint32(&o.GPIO18.Reg) & 0x7000) >> 12
}
func (o *IO_MUX_Type) SetGPIO18_FILTER_EN(value uint32) {
	volatile.StoreUint32(&o.GPIO18.Reg, volatile.LoadUint32(&o.GPIO18.Reg)&^(0x8000)|value<<15)
}
func (o *IO_MUX_Type) GetGPIO18_FILTER_EN() uint32 {
	return (volatile.LoadUint32(&o.GPIO18.Reg) & 0x8000) >> 15
}

// IO_MUX.GPIO19: IO MUX Configure Register for pad XTAL_32K_P
func (o *IO_MUX_Type) SetGPIO19_MCU_OE(value uint32) {
	volatile.StoreUint32(&o.GPIO19.Reg, volatile.LoadUint32(&o.GPIO19.Reg)&^(0x1)|value)
}
func (o *IO_MUX_Type) GetGPIO19_MCU_OE() uint32 {
	return volatile.LoadUint32(&o.GPIO19.Reg) & 0x1
}
func (o *IO_MUX_Type) SetGPIO19_SLP_SEL(value uint32) {
	volatile.StoreUint32(&o.GPIO19.Reg, volatile.LoadUint32(&o.GPIO19.Reg)&^(0x2)|value<<1)
}
func (o *IO_MUX_Type) GetGPIO19_SLP_SEL() uint32 {
	return (volatile.LoadUint32(&o.GPIO19.Reg) & 0x2) >> 1
}
func (o *IO_MUX_Type) SetGPIO19_MCU_WPD(value uint32) {
	volatile.StoreUint32(&o.GPIO19.Reg, volatile.LoadUint32(&o.GPIO19.Reg)&^(0x4)|value<<2)
}
func (o *IO_MUX_Type) GetGPIO19_MCU_WPD() uint32 {
	return (volatile.LoadUint32(&o.GPIO19.Reg) & 0x4) >> 2
}
func (o *IO_MUX_Type) SetGPIO19_MCU_WPU(value uint32) {
	volatile.StoreUint32(&o.GPIO19.Reg, volatile.LoadUint32(&o.GPIO19.Reg)&^(0x8)|value<<3)
}
func (o *IO_MUX_Type) GetGPIO19_MCU_WPU() uint32 {
	return (volatile.LoadUint32(&o.GPIO19.Reg) & 0x8) >> 3
}
func (o *IO_MUX_Type) SetGPIO19_MCU_IE(value uint32) {
	volatile.StoreUint32(&o.GPIO19.Reg, volatile.LoadUint32(&o.GPIO19.Reg)&^(0x10)|value<<4)
}
func (o *IO_MUX_Type) GetGPIO19_MCU_IE() uint32 {
	return (volatile.LoadUint32(&o.GPIO19.Reg) & 0x10) >> 4
}
func (o *IO_MUX_Type) SetGPIO19_FUN_WPD(value uint32) {
	volatile.StoreUint32(&o.GPIO19.Reg, volatile.LoadUint32(&o.GPIO19.Reg)&^(0x80)|value<<7)
}
func (o *IO_MUX_Type) GetGPIO19_FUN_WPD() uint32 {
	return (volatile.LoadUint32(&o.GPIO19.Reg) & 0x80) >> 7
}
func (o *IO_MUX_Type) SetGPIO19_FUN_WPU(value uint32) {
	volatile.StoreUint32(&o.GPIO19.Reg, volatile.LoadUint32(&o.GPIO19.Reg)&^(0x100)|value<<8)
}
func (o *IO_MUX_Type) GetGPIO19_FUN_WPU() uint32 {
	return (volatile.LoadUint32(&o.GPIO19.Reg) & 0x100) >> 8
}
func (o *IO_MUX_Type) SetGPIO19_FUN_IE(value uint32) {
	volatile.StoreUint32(&o.GPIO19.Reg, volatile.LoadUint32(&o.GPIO19.Reg)&^(0x200)|value<<9)
}
func (o *IO_MUX_Type) GetGPIO19_FUN_IE() uint32 {
	return (volatile.LoadUint32(&o.GPIO19.Reg) & 0x200) >> 9
}
func (o *IO_MUX_Type) SetGPIO19_FUN_DRV(value uint32) {
	volatile.StoreUint32(&o.GPIO19.Reg, volatile.LoadUint32(&o.GPIO19.Reg)&^(0xc00)|value<<10)
}
func (o *IO_MUX_Type) GetGPIO19_FUN_DRV() uint32 {
	return (volatile.LoadUint32(&o.GPIO19.Reg) & 0xc00) >> 10
}
func (o *IO_MUX_Type) SetGPIO19_MCU_SEL(value uint32) {
	volatile.StoreUint32(&o.GPIO19.Reg, volatile.LoadUint32(&o.GPIO19.Reg)&^(0x7000)|value<<12)
}
func (o *IO_MUX_Type) GetGPIO19_MCU_SEL() uint32 {
	return (volatile.LoadUint32(&o.GPIO19.Reg) & 0x7000) >> 12
}
func (o *IO_MUX_Type) SetGPIO19_FILTER_EN(value uint32) {
	volatile.StoreUint32(&o.GPIO19.Reg, volatile.LoadUint32(&o.GPIO19.Reg)&^(0x8000)|value<<15)
}
func (o *IO_MUX_Type) GetGPIO19_FILTER_EN() uint32 {
	return (volatile.LoadUint32(&o.GPIO19.Reg) & 0x8000) >> 15
}

// IO_MUX.GPIO20: IO MUX Configure Register for pad XTAL_32K_P
func (o *IO_MUX_Type) SetGPIO20_MCU_OE(value uint32) {
	volatile.StoreUint32(&o.GPIO20.Reg, volatile.LoadUint32(&o.GPIO20.Reg)&^(0x1)|value)
}
func (o *IO_MUX_Type) GetGPIO20_MCU_OE() uint32 {
	return volatile.LoadUint32(&o.GPIO20.Reg) & 0x1
}
func (o *IO_MUX_Type) SetGPIO20_SLP_SEL(value uint32) {
	volatile.StoreUint32(&o.GPIO20.Reg, volatile.LoadUint32(&o.GPIO20.Reg)&^(0x2)|value<<1)
}
func (o *IO_MUX_Type) GetGPIO20_SLP_SEL() uint32 {
	return (volatile.LoadUint32(&o.GPIO20.Reg) & 0x2) >> 1
}
func (o *IO_MUX_Type) SetGPIO20_MCU_WPD(value uint32) {
	volatile.StoreUint32(&o.GPIO20.Reg, volatile.LoadUint32(&o.GPIO20.Reg)&^(0x4)|value<<2)
}
func (o *IO_MUX_Type) GetGPIO20_MCU_WPD() uint32 {
	return (volatile.LoadUint32(&o.GPIO20.Reg) & 0x4) >> 2
}
func (o *IO_MUX_Type) SetGPIO20_MCU_WPU(value uint32) {
	volatile.StoreUint32(&o.GPIO20.Reg, volatile.LoadUint32(&o.GPIO20.Reg)&^(0x8)|value<<3)
}
func (o *IO_MUX_Type) GetGPIO20_MCU_WPU() uint32 {
	return (volatile.LoadUint32(&o.GPIO20.Reg) & 0x8) >> 3
}
func (o *IO_MUX_Type) SetGPIO20_MCU_IE(value uint32) {
	volatile.StoreUint32(&o.GPIO20.Reg, volatile.LoadUint32(&o.GPIO20.Reg)&^(0x10)|value<<4)
}
func (o *IO_MUX_Type) GetGPIO20_MCU_IE() uint32 {
	return (volatile.LoadUint32(&o.GPIO20.Reg) & 0x10) >> 4
}
func (o *IO_MUX_Type) SetGPIO20_FUN_WPD(value uint32) {
	volatile.StoreUint32(&o.GPIO20.Reg, volatile.LoadUint32(&o.GPIO20.Reg)&^(0x80)|value<<7)
}
func (o *IO_MUX_Type) GetGPIO20_FUN_WPD() uint32 {
	return (volatile.LoadUint32(&o.GPIO20.Reg) & 0x80) >> 7
}
func (o *IO_MUX_Type) SetGPIO20_FUN_WPU(value uint32) {
	volatile.StoreUint32(&o.GPIO20.Reg, volatile.LoadUint32(&o.GPIO20.Reg)&^(0x100)|value<<8)
}
func (o *IO_MUX_Type) GetGPIO20_FUN_WPU() uint32 {
	return (volatile.LoadUint32(&o.GPIO20.Reg) & 0x100) >> 8
}
func (o *IO_MUX_Type) SetGPIO20_FUN_IE(value uint32) {
	volatile.StoreUint32(&o.GPIO20.Reg, volatile.LoadUint32(&o.GPIO20.Reg)&^(0x200)|value<<9)
}
func (o *IO_MUX_Type) GetGPIO20_FUN_IE() uint32 {
	return (volatile.LoadUint32(&o.GPIO20.Reg) & 0x200) >> 9
}
func (o *IO_MUX_Type) SetGPIO20_FUN_DRV(value uint32) {
	volatile.StoreUint32(&o.GPIO20.Reg, volatile.LoadUint32(&o.GPIO20.Reg)&^(0xc00)|value<<10)
}
func (o *IO_MUX_Type) GetGPIO20_FUN_DRV() uint32 {
	return (volatile.LoadUint32(&o.GPIO20.Reg) & 0xc00) >> 10
}
func (o *IO_MUX_Type) SetGPIO20_MCU_SEL(value uint32) {
	volatile.StoreUint32(&o.GPIO20.Reg, volatile.LoadUint32(&o.GPIO20.Reg)&^(0x7000)|value<<12)
}
func (o *IO_MUX_Type) GetGPIO20_MCU_SEL() uint32 {
	return (volatile.LoadUint32(&o.GPIO20.Reg) & 0x7000) >> 12
}
func (o *IO_MUX_Type) SetGPIO20_FILTER_EN(value uint32) {
	volatile.StoreUint32(&o.GPIO20.Reg, volatile.LoadUint32(&o.GPIO20.Reg)&^(0x8000)|value<<15)
}
func (o *IO_MUX_Type) GetGPIO20_FILTER_EN() uint32 {
	return (volatile.LoadUint32(&o.GPIO20.Reg) & 0x8000) >> 15
}

// IO_MUX.GPIO21: IO MUX Configure Register for pad XTAL_32K_P
func (o *IO_MUX_Type) SetGPIO21_MCU_OE(value uint32) {
	volatile.StoreUint32(&o.GPIO21.Reg, volatile.LoadUint32(&o.GPIO21.Reg)&^(0x1)|value)
}
func (o *IO_MUX_Type) GetGPIO21_MCU_OE() uint32 {
	return volatile.LoadUint32(&o.GPIO21.Reg) & 0x1
}
func (o *IO_MUX_Type) SetGPIO21_SLP_SEL(value uint32) {
	volatile.StoreUint32(&o.GPIO21.Reg, volatile.LoadUint32(&o.GPIO21.Reg)&^(0x2)|value<<1)
}
func (o *IO_MUX_Type) GetGPIO21_SLP_SEL() uint32 {
	return (volatile.LoadUint32(&o.GPIO21.Reg) & 0x2) >> 1
}
func (o *IO_MUX_Type) SetGPIO21_MCU_WPD(value uint32) {
	volatile.StoreUint32(&o.GPIO21.Reg, volatile.LoadUint32(&o.GPIO21.Reg)&^(0x4)|value<<2)
}
func (o *IO_MUX_Type) GetGPIO21_MCU_WPD() uint32 {
	return (volatile.LoadUint32(&o.GPIO21.Reg) & 0x4) >> 2
}
func (o *IO_MUX_Type) SetGPIO21_MCU_WPU(value uint32) {
	volatile.StoreUint32(&o.GPIO21.Reg, volatile.LoadUint32(&o.GPIO21.Reg)&^(0x8)|value<<3)
}
func (o *IO_MUX_Type) GetGPIO21_MCU_WPU() uint32 {
	return (volatile.LoadUint32(&o.GPIO21.Reg) & 0x8) >> 3
}
func (o *IO_MUX_Type) SetGPIO21_MCU_IE(value uint32) {
	volatile.StoreUint32(&o.GPIO21.Reg, volatile.LoadUint32(&o.GPIO21.Reg)&^(0x10)|value<<4)
}
func (o *IO_MUX_Type) GetGPIO21_MCU_IE() uint32 {
	return (volatile.LoadUint32(&o.GPIO21.Reg) & 0x10) >> 4
}
func (o *IO_MUX_Type) SetGPIO21_FUN_WPD(value uint32) {
	volatile.StoreUint32(&o.GPIO21.Reg, volatile.LoadUint32(&o.GPIO21.Reg)&^(0x80)|value<<7)
}
func (o *IO_MUX_Type) GetGPIO21_FUN_WPD() uint32 {
	return (volatile.LoadUint32(&o.GPIO21.Reg) & 0x80) >> 7
}
func (o *IO_MUX_Type) SetGPIO21_FUN_WPU(value uint32) {
	volatile.StoreUint32(&o.GPIO21.Reg, volatile.LoadUint32(&o.GPIO21.Reg)&^(0x100)|value<<8)
}
func (o *IO_MUX_Type) GetGPIO21_FUN_WPU() uint32 {
	return (volatile.LoadUint32(&o.GPIO21.Reg) & 0x100) >> 8
}
func (o *IO_MUX_Type) SetGPIO21_FUN_IE(value uint32) {
	volatile.StoreUint32(&o.GPIO21.Reg, volatile.LoadUint32(&o.GPIO21.Reg)&^(0x200)|value<<9)
}
func (o *IO_MUX_Type) GetGPIO21_FUN_IE() uint32 {
	return (volatile.LoadUint32(&o.GPIO21.Reg) & 0x200) >> 9
}
func (o *IO_MUX_Type) SetGPIO21_FUN_DRV(value uint32) {
	volatile.StoreUint32(&o.GPIO21.Reg, volatile.LoadUint32(&o.GPIO21.Reg)&^(0xc00)|value<<10)
}
func (o *IO_MUX_Type) GetGPIO21_FUN_DRV() uint32 {
	return (volatile.LoadUint32(&o.GPIO21.Reg) & 0xc00) >> 10
}
func (o *IO_MUX_Type) SetGPIO21_MCU_SEL(value uint32) {
	volatile.StoreUint32(&o.GPIO21.Reg, volatile.LoadUint32(&o.GPIO21.Reg)&^(0x7000)|value<<12)
}
func (o *IO_MUX_Type) GetGPIO21_MCU_SEL() uint32 {
	return (volatile.LoadUint32(&o.GPIO21.Reg) & 0x7000) >> 12
}
func (o *IO_MUX_Type) SetGPIO21_FILTER_EN(value uint32) {
	volatile.StoreUint32(&o.GPIO21.Reg, volatile.LoadUint32(&o.GPIO21.Reg)&^(0x8000)|value<<15)
}
func (o *IO_MUX_Type) GetGPIO21_FILTER_EN() uint32 {
	return (volatile.LoadUint32(&o.GPIO21.Reg) & 0x8000) >> 15
}

// IO_MUX.DATE: IO MUX Version Control Register
func (o *IO_MUX_Type) SetDATE_REG_DATE(value uint32) {
	volatile.StoreUint32(&o.DATE.Reg, volatile.LoadUint32(&o.DATE.Reg)&^(0xfffffff)|value)
}
func (o *IO_MUX_Type) GetDATE_REG_DATE() uint32 {
	return volatile.LoadUint32(&o.DATE.Reg) & 0xfffffff
}

// Peripheral LEDC
type LEDC_Type struct {
	LSCH0_CONF0    volatile.Register32 // 0x0
	LSCH0_HPOINT   volatile.Register32 // 0x4
	LSCH0_DUTY     volatile.Register32 // 0x8
	LSCH0_CONF1    volatile.Register32 // 0xC
	LSCH0_DUTY_R   volatile.Register32 // 0x10
	LSCH1_CONF0    volatile.Register32 // 0x14
	LSCH1_HPOINT   volatile.Register32 // 0x18
	LSCH1_DUTY     volatile.Register32 // 0x1C
	LSCH1_CONF1    volatile.Register32 // 0x20
	LSCH1_DUTY_R   volatile.Register32 // 0x24
	LSCH2_CONF0    volatile.Register32 // 0x28
	LSCH2_HPOINT   volatile.Register32 // 0x2C
	LSCH2_DUTY     volatile.Register32 // 0x30
	LSCH2_CONF1    volatile.Register32 // 0x34
	LSCH2_DUTY_R   volatile.Register32 // 0x38
	LSCH3_CONF0    volatile.Register32 // 0x3C
	LSCH3_HPOINT   volatile.Register32 // 0x40
	LSCH3_DUTY     volatile.Register32 // 0x44
	LSCH3_CONF1    volatile.Register32 // 0x48
	LSCH3_DUTY_R   volatile.Register32 // 0x4C
	LSCH4_CONF0    volatile.Register32 // 0x50
	LSCH4_HPOINT   volatile.Register32 // 0x54
	LSCH4_DUTY     volatile.Register32 // 0x58
	LSCH4_CONF1    volatile.Register32 // 0x5C
	LSCH4_DUTY_R   volatile.Register32 // 0x60
	LSCH5_CONF0    volatile.Register32 // 0x64
	LSCH5_HPOINT   volatile.Register32 // 0x68
	LSCH5_DUTY     volatile.Register32 // 0x6C
	LSCH5_CONF1    volatile.Register32 // 0x70
	LSCH5_DUTY_R   volatile.Register32 // 0x74
	_              [40]byte
	LSTIMER0_CONF  volatile.Register32 // 0xA0
	LSTIMER0_VALUE volatile.Register32 // 0xA4
	LSTIMER1_CONF  volatile.Register32 // 0xA8
	LSTIMER1_VALUE volatile.Register32 // 0xAC
	LSTIMER2_CONF  volatile.Register32 // 0xB0
	LSTIMER2_VALUE volatile.Register32 // 0xB4
	LSTIMER3_CONF  volatile.Register32 // 0xB8
	LSTIMER3_VALUE volatile.Register32 // 0xBC
	INT_RAW        volatile.Register32 // 0xC0
	INT_ST         volatile.Register32 // 0xC4
	INT_ENA        volatile.Register32 // 0xC8
	INT_CLR        volatile.Register32 // 0xCC
	CONF           volatile.Register32 // 0xD0
	_              [40]byte
	DATE           volatile.Register32 // 0xFC
}

// LEDC.LSCH0_CONF0: LEDC_LSCH0_CONF0.
func (o *LEDC_Type) SetLSCH0_CONF0_TIMER_SEL_LSCH0(value uint32) {
	volatile.StoreUint32(&o.LSCH0_CONF0.Reg, volatile.LoadUint32(&o.LSCH0_CONF0.Reg)&^(0x3)|value)
}
func (o *LEDC_Type) GetLSCH0_CONF0_TIMER_SEL_LSCH0() uint32 {
	return volatile.LoadUint32(&o.LSCH0_CONF0.Reg) & 0x3
}
func (o *LEDC_Type) SetLSCH0_CONF0_SIG_OUT_EN_LSCH0(value uint32) {
	volatile.StoreUint32(&o.LSCH0_CONF0.Reg, volatile.LoadUint32(&o.LSCH0_CONF0.Reg)&^(0x4)|value<<2)
}
func (o *LEDC_Type) GetLSCH0_CONF0_SIG_OUT_EN_LSCH0() uint32 {
	return (volatile.LoadUint32(&o.LSCH0_CONF0.Reg) & 0x4) >> 2
}
func (o *LEDC_Type) SetLSCH0_CONF0_IDLE_LV_LSCH0(value uint32) {
	volatile.StoreUint32(&o.LSCH0_CONF0.Reg, volatile.LoadUint32(&o.LSCH0_CONF0.Reg)&^(0x8)|value<<3)
}
func (o *LEDC_Type) GetLSCH0_CONF0_IDLE_LV_LSCH0() uint32 {
	return (volatile.LoadUint32(&o.LSCH0_CONF0.Reg) & 0x8) >> 3
}
func (o *LEDC_Type) SetLSCH0_CONF0_PARA_UP_LSCH0(value uint32) {
	volatile.StoreUint32(&o.LSCH0_CONF0.Reg, volatile.LoadUint32(&o.LSCH0_CONF0.Reg)&^(0x10)|value<<4)
}
func (o *LEDC_Type) GetLSCH0_CONF0_PARA_UP_LSCH0() uint32 {
	return (volatile.LoadUint32(&o.LSCH0_CONF0.Reg) & 0x10) >> 4
}
func (o *LEDC_Type) SetLSCH0_CONF0_OVF_NUM_LSCH0(value uint32) {
	volatile.StoreUint32(&o.LSCH0_CONF0.Reg, volatile.LoadUint32(&o.LSCH0_CONF0.Reg)&^(0x7fe0)|value<<5)
}
func (o *LEDC_Type) GetLSCH0_CONF0_OVF_NUM_LSCH0() uint32 {
	return (volatile.LoadUint32(&o.LSCH0_CONF0.Reg) & 0x7fe0) >> 5
}
func (o *LEDC_Type) SetLSCH0_CONF0_OVF_CNT_EN_LSCH0(value uint32) {
	volatile.StoreUint32(&o.LSCH0_CONF0.Reg, volatile.LoadUint32(&o.LSCH0_CONF0.Reg)&^(0x8000)|value<<15)
}
func (o *LEDC_Type) GetLSCH0_CONF0_OVF_CNT_EN_LSCH0() uint32 {
	return (volatile.LoadUint32(&o.LSCH0_CONF0.Reg) & 0x8000) >> 15
}
func (o *LEDC_Type) SetLSCH0_CONF0_OVF_CNT_RESET_LSCH0(value uint32) {
	volatile.StoreUint32(&o.LSCH0_CONF0.Reg, volatile.LoadUint32(&o.LSCH0_CONF0.Reg)&^(0x10000)|value<<16)
}
func (o *LEDC_Type) GetLSCH0_CONF0_OVF_CNT_RESET_LSCH0() uint32 {
	return (volatile.LoadUint32(&o.LSCH0_CONF0.Reg) & 0x10000) >> 16
}

// LEDC.LSCH0_HPOINT: LEDC_LSCH0_HPOINT.
func (o *LEDC_Type) SetLSCH0_HPOINT_HPOINT_LSCH0(value uint32) {
	volatile.StoreUint32(&o.LSCH0_HPOINT.Reg, volatile.LoadUint32(&o.LSCH0_HPOINT.Reg)&^(0x3fff)|value)
}
func (o *LEDC_Type) GetLSCH0_HPOINT_HPOINT_LSCH0() uint32 {
	return volatile.LoadUint32(&o.LSCH0_HPOINT.Reg) & 0x3fff
}

// LEDC.LSCH0_DUTY: LEDC_LSCH0_DUTY.
func (o *LEDC_Type) SetLSCH0_DUTY_DUTY_LSCH0(value uint32) {
	volatile.StoreUint32(&o.LSCH0_DUTY.Reg, volatile.LoadUint32(&o.LSCH0_DUTY.Reg)&^(0x7ffff)|value)
}
func (o *LEDC_Type) GetLSCH0_DUTY_DUTY_LSCH0() uint32 {
	return volatile.LoadUint32(&o.LSCH0_DUTY.Reg) & 0x7ffff
}

// LEDC.LSCH0_CONF1: LEDC_LSCH0_CONF1.
func (o *LEDC_Type) SetLSCH0_CONF1_DUTY_SCALE_LSCH0(value uint32) {
	volatile.StoreUint32(&o.LSCH0_CONF1.Reg, volatile.LoadUint32(&o.LSCH0_CONF1.Reg)&^(0x3ff)|value)
}
func (o *LEDC_Type) GetLSCH0_CONF1_DUTY_SCALE_LSCH0() uint32 {
	return volatile.LoadUint32(&o.LSCH0_CONF1.Reg) & 0x3ff
}
func (o *LEDC_Type) SetLSCH0_CONF1_DUTY_CYCLE_LSCH0(value uint32) {
	volatile.StoreUint32(&o.LSCH0_CONF1.Reg, volatile.LoadUint32(&o.LSCH0_CONF1.Reg)&^(0xffc00)|value<<10)
}
func (o *LEDC_Type) GetLSCH0_CONF1_DUTY_CYCLE_LSCH0() uint32 {
	return (volatile.LoadUint32(&o.LSCH0_CONF1.Reg) & 0xffc00) >> 10
}
func (o *LEDC_Type) SetLSCH0_CONF1_DUTY_NUM_LSCH0(value uint32) {
	volatile.StoreUint32(&o.LSCH0_CONF1.Reg, volatile.LoadUint32(&o.LSCH0_CONF1.Reg)&^(0x3ff00000)|value<<20)
}
func (o *LEDC_Type) GetLSCH0_CONF1_DUTY_NUM_LSCH0() uint32 {
	return (volatile.LoadUint32(&o.LSCH0_CONF1.Reg) & 0x3ff00000) >> 20
}
func (o *LEDC_Type) SetLSCH0_CONF1_DUTY_INC_LSCH0(value uint32) {
	volatile.StoreUint32(&o.LSCH0_CONF1.Reg, volatile.LoadUint32(&o.LSCH0_CONF1.Reg)&^(0x40000000)|value<<30)
}
func (o *LEDC_Type) GetLSCH0_CONF1_DUTY_INC_LSCH0() uint32 {
	return (volatile.LoadUint32(&o.LSCH0_CONF1.Reg) & 0x40000000) >> 30
}
func (o *LEDC_Type) SetLSCH0_CONF1_DUTY_START_LSCH0(value uint32) {
	volatile.StoreUint32(&o.LSCH0_CONF1.Reg, volatile.LoadUint32(&o.LSCH0_CONF1.Reg)&^(0x80000000)|value<<31)
}
func (o *LEDC_Type) GetLSCH0_CONF1_DUTY_START_LSCH0() uint32 {
	return (volatile.LoadUint32(&o.LSCH0_CONF1.Reg) & 0x80000000) >> 31
}

// LEDC.LSCH0_DUTY_R: LEDC_LSCH0_DUTY_R.
func (o *LEDC_Type) SetLSCH0_DUTY_R_DUTY_LSCH0_R(value uint32) {
	volatile.StoreUint32(&o.LSCH0_DUTY_R.Reg, volatile.LoadUint32(&o.LSCH0_DUTY_R.Reg)&^(0x7ffff)|value)
}
func (o *LEDC_Type) GetLSCH0_DUTY_R_DUTY_LSCH0_R() uint32 {
	return volatile.LoadUint32(&o.LSCH0_DUTY_R.Reg) & 0x7ffff
}

// LEDC.LSCH1_CONF0: LEDC_LSCH1_CONF0.
func (o *LEDC_Type) SetLSCH1_CONF0_TIMER_SEL_LSCH1(value uint32) {
	volatile.StoreUint32(&o.LSCH1_CONF0.Reg, volatile.LoadUint32(&o.LSCH1_CONF0.Reg)&^(0x3)|value)
}
func (o *LEDC_Type) GetLSCH1_CONF0_TIMER_SEL_LSCH1() uint32 {
	return volatile.LoadUint32(&o.LSCH1_CONF0.Reg) & 0x3
}
func (o *LEDC_Type) SetLSCH1_CONF0_SIG_OUT_EN_LSCH1(value uint32) {
	volatile.StoreUint32(&o.LSCH1_CONF0.Reg, volatile.LoadUint32(&o.LSCH1_CONF0.Reg)&^(0x4)|value<<2)
}
func (o *LEDC_Type) GetLSCH1_CONF0_SIG_OUT_EN_LSCH1() uint32 {
	return (volatile.LoadUint32(&o.LSCH1_CONF0.Reg) & 0x4) >> 2
}
func (o *LEDC_Type) SetLSCH1_CONF0_IDLE_LV_LSCH1(value uint32) {
	volatile.StoreUint32(&o.LSCH1_CONF0.Reg, volatile.LoadUint32(&o.LSCH1_CONF0.Reg)&^(0x8)|value<<3)
}
func (o *LEDC_Type) GetLSCH1_CONF0_IDLE_LV_LSCH1() uint32 {
	return (volatile.LoadUint32(&o.LSCH1_CONF0.Reg) & 0x8) >> 3
}
func (o *LEDC_Type) SetLSCH1_CONF0_PARA_UP_LSCH1(value uint32) {
	volatile.StoreUint32(&o.LSCH1_CONF0.Reg, volatile.LoadUint32(&o.LSCH1_CONF0.Reg)&^(0x10)|value<<4)
}
func (o *LEDC_Type) GetLSCH1_CONF0_PARA_UP_LSCH1() uint32 {
	return (volatile.LoadUint32(&o.LSCH1_CONF0.Reg) & 0x10) >> 4
}
func (o *LEDC_Type) SetLSCH1_CONF0_OVF_NUM_LSCH1(value uint32) {
	volatile.StoreUint32(&o.LSCH1_CONF0.Reg, volatile.LoadUint32(&o.LSCH1_CONF0.Reg)&^(0x7fe0)|value<<5)
}
func (o *LEDC_Type) GetLSCH1_CONF0_OVF_NUM_LSCH1() uint32 {
	return (volatile.LoadUint32(&o.LSCH1_CONF0.Reg) & 0x7fe0) >> 5
}
func (o *LEDC_Type) SetLSCH1_CONF0_OVF_CNT_EN_LSCH1(value uint32) {
	volatile.StoreUint32(&o.LSCH1_CONF0.Reg, volatile.LoadUint32(&o.LSCH1_CONF0.Reg)&^(0x8000)|value<<15)
}
func (o *LEDC_Type) GetLSCH1_CONF0_OVF_CNT_EN_LSCH1() uint32 {
	return (volatile.LoadUint32(&o.LSCH1_CONF0.Reg) & 0x8000) >> 15
}
func (o *LEDC_Type) SetLSCH1_CONF0_OVF_CNT_RESET_LSCH1(value uint32) {
	volatile.StoreUint32(&o.LSCH1_CONF0.Reg, volatile.LoadUint32(&o.LSCH1_CONF0.Reg)&^(0x10000)|value<<16)
}
func (o *LEDC_Type) GetLSCH1_CONF0_OVF_CNT_RESET_LSCH1() uint32 {
	return (volatile.LoadUint32(&o.LSCH1_CONF0.Reg) & 0x10000) >> 16
}

// LEDC.LSCH1_HPOINT: LEDC_LSCH1_HPOINT.
func (o *LEDC_Type) SetLSCH1_HPOINT_HPOINT_LSCH1(value uint32) {
	volatile.StoreUint32(&o.LSCH1_HPOINT.Reg, volatile.LoadUint32(&o.LSCH1_HPOINT.Reg)&^(0x3fff)|value)
}
func (o *LEDC_Type) GetLSCH1_HPOINT_HPOINT_LSCH1() uint32 {
	return volatile.LoadUint32(&o.LSCH1_HPOINT.Reg) & 0x3fff
}

// LEDC.LSCH1_DUTY: LEDC_LSCH1_DUTY.
func (o *LEDC_Type) SetLSCH1_DUTY_DUTY_LSCH1(value uint32) {
	volatile.StoreUint32(&o.LSCH1_DUTY.Reg, volatile.LoadUint32(&o.LSCH1_DUTY.Reg)&^(0x7ffff)|value)
}
func (o *LEDC_Type) GetLSCH1_DUTY_DUTY_LSCH1() uint32 {
	return volatile.LoadUint32(&o.LSCH1_DUTY.Reg) & 0x7ffff
}

// LEDC.LSCH1_CONF1: LEDC_LSCH1_CONF1.
func (o *LEDC_Type) SetLSCH1_CONF1_DUTY_SCALE_LSCH1(value uint32) {
	volatile.StoreUint32(&o.LSCH1_CONF1.Reg, volatile.LoadUint32(&o.LSCH1_CONF1.Reg)&^(0x3ff)|value)
}
func (o *LEDC_Type) GetLSCH1_CONF1_DUTY_SCALE_LSCH1() uint32 {
	return volatile.LoadUint32(&o.LSCH1_CONF1.Reg) & 0x3ff
}
func (o *LEDC_Type) SetLSCH1_CONF1_DUTY_CYCLE_LSCH1(value uint32) {
	volatile.StoreUint32(&o.LSCH1_CONF1.Reg, volatile.LoadUint32(&o.LSCH1_CONF1.Reg)&^(0xffc00)|value<<10)
}
func (o *LEDC_Type) GetLSCH1_CONF1_DUTY_CYCLE_LSCH1() uint32 {
	return (volatile.LoadUint32(&o.LSCH1_CONF1.Reg) & 0xffc00) >> 10
}
func (o *LEDC_Type) SetLSCH1_CONF1_DUTY_NUM_LSCH1(value uint32) {
	volatile.StoreUint32(&o.LSCH1_CONF1.Reg, volatile.LoadUint32(&o.LSCH1_CONF1.Reg)&^(0x3ff00000)|value<<20)
}
func (o *LEDC_Type) GetLSCH1_CONF1_DUTY_NUM_LSCH1() uint32 {
	return (volatile.LoadUint32(&o.LSCH1_CONF1.Reg) & 0x3ff00000) >> 20
}
func (o *LEDC_Type) SetLSCH1_CONF1_DUTY_INC_LSCH1(value uint32) {
	volatile.StoreUint32(&o.LSCH1_CONF1.Reg, volatile.LoadUint32(&o.LSCH1_CONF1.Reg)&^(0x40000000)|value<<30)
}
func (o *LEDC_Type) GetLSCH1_CONF1_DUTY_INC_LSCH1() uint32 {
	return (volatile.LoadUint32(&o.LSCH1_CONF1.Reg) & 0x40000000) >> 30
}
func (o *LEDC_Type) SetLSCH1_CONF1_DUTY_START_LSCH1(value uint32) {
	volatile.StoreUint32(&o.LSCH1_CONF1.Reg, volatile.LoadUint32(&o.LSCH1_CONF1.Reg)&^(0x80000000)|value<<31)
}
func (o *LEDC_Type) GetLSCH1_CONF1_DUTY_START_LSCH1() uint32 {
	return (volatile.LoadUint32(&o.LSCH1_CONF1.Reg) & 0x80000000) >> 31
}

// LEDC.LSCH1_DUTY_R: LEDC_LSCH1_DUTY_R.
func (o *LEDC_Type) SetLSCH1_DUTY_R_DUTY_LSCH1_R(value uint32) {
	volatile.StoreUint32(&o.LSCH1_DUTY_R.Reg, volatile.LoadUint32(&o.LSCH1_DUTY_R.Reg)&^(0x7ffff)|value)
}
func (o *LEDC_Type) GetLSCH1_DUTY_R_DUTY_LSCH1_R() uint32 {
	return volatile.LoadUint32(&o.LSCH1_DUTY_R.Reg) & 0x7ffff
}

// LEDC.LSCH2_CONF0: LEDC_LSCH2_CONF0.
func (o *LEDC_Type) SetLSCH2_CONF0_TIMER_SEL_LSCH2(value uint32) {
	volatile.StoreUint32(&o.LSCH2_CONF0.Reg, volatile.LoadUint32(&o.LSCH2_CONF0.Reg)&^(0x3)|value)
}
func (o *LEDC_Type) GetLSCH2_CONF0_TIMER_SEL_LSCH2() uint32 {
	return volatile.LoadUint32(&o.LSCH2_CONF0.Reg) & 0x3
}
func (o *LEDC_Type) SetLSCH2_CONF0_SIG_OUT_EN_LSCH2(value uint32) {
	volatile.StoreUint32(&o.LSCH2_CONF0.Reg, volatile.LoadUint32(&o.LSCH2_CONF0.Reg)&^(0x4)|value<<2)
}
func (o *LEDC_Type) GetLSCH2_CONF0_SIG_OUT_EN_LSCH2() uint32 {
	return (volatile.LoadUint32(&o.LSCH2_CONF0.Reg) & 0x4) >> 2
}
func (o *LEDC_Type) SetLSCH2_CONF0_IDLE_LV_LSCH2(value uint32) {
	volatile.StoreUint32(&o.LSCH2_CONF0.Reg, volatile.LoadUint32(&o.LSCH2_CONF0.Reg)&^(0x8)|value<<3)
}
func (o *LEDC_Type) GetLSCH2_CONF0_IDLE_LV_LSCH2() uint32 {
	return (volatile.LoadUint32(&o.LSCH2_CONF0.Reg) & 0x8) >> 3
}
func (o *LEDC_Type) SetLSCH2_CONF0_PARA_UP_LSCH2(value uint32) {
	volatile.StoreUint32(&o.LSCH2_CONF0.Reg, volatile.LoadUint32(&o.LSCH2_CONF0.Reg)&^(0x10)|value<<4)
}
func (o *LEDC_Type) GetLSCH2_CONF0_PARA_UP_LSCH2() uint32 {
	return (volatile.LoadUint32(&o.LSCH2_CONF0.Reg) & 0x10) >> 4
}
func (o *LEDC_Type) SetLSCH2_CONF0_OVF_NUM_LSCH2(value uint32) {
	volatile.StoreUint32(&o.LSCH2_CONF0.Reg, volatile.LoadUint32(&o.LSCH2_CONF0.Reg)&^(0x7fe0)|value<<5)
}
func (o *LEDC_Type) GetLSCH2_CONF0_OVF_NUM_LSCH2() uint32 {
	return (volatile.LoadUint32(&o.LSCH2_CONF0.Reg) & 0x7fe0) >> 5
}
func (o *LEDC_Type) SetLSCH2_CONF0_OVF_CNT_EN_LSCH2(value uint32) {
	volatile.StoreUint32(&o.LSCH2_CONF0.Reg, volatile.LoadUint32(&o.LSCH2_CONF0.Reg)&^(0x8000)|value<<15)
}
func (o *LEDC_Type) GetLSCH2_CONF0_OVF_CNT_EN_LSCH2() uint32 {
	return (volatile.LoadUint32(&o.LSCH2_CONF0.Reg) & 0x8000) >> 15
}
func (o *LEDC_Type) SetLSCH2_CONF0_OVF_CNT_RESET_LSCH2(value uint32) {
	volatile.StoreUint32(&o.LSCH2_CONF0.Reg, volatile.LoadUint32(&o.LSCH2_CONF0.Reg)&^(0x10000)|value<<16)
}
func (o *LEDC_Type) GetLSCH2_CONF0_OVF_CNT_RESET_LSCH2() uint32 {
	return (volatile.LoadUint32(&o.LSCH2_CONF0.Reg) & 0x10000) >> 16
}

// LEDC.LSCH2_HPOINT: LEDC_LSCH2_HPOINT.
func (o *LEDC_Type) SetLSCH2_HPOINT_HPOINT_LSCH2(value uint32) {
	volatile.StoreUint32(&o.LSCH2_HPOINT.Reg, volatile.LoadUint32(&o.LSCH2_HPOINT.Reg)&^(0x3fff)|value)
}
func (o *LEDC_Type) GetLSCH2_HPOINT_HPOINT_LSCH2() uint32 {
	return volatile.LoadUint32(&o.LSCH2_HPOINT.Reg) & 0x3fff
}

// LEDC.LSCH2_DUTY: LEDC_LSCH2_DUTY.
func (o *LEDC_Type) SetLSCH2_DUTY_DUTY_LSCH2(value uint32) {
	volatile.StoreUint32(&o.LSCH2_DUTY.Reg, volatile.LoadUint32(&o.LSCH2_DUTY.Reg)&^(0x7ffff)|value)
}
func (o *LEDC_Type) GetLSCH2_DUTY_DUTY_LSCH2() uint32 {
	return volatile.LoadUint32(&o.LSCH2_DUTY.Reg) & 0x7ffff
}

// LEDC.LSCH2_CONF1: LEDC_LSCH2_CONF1.
func (o *LEDC_Type) SetLSCH2_CONF1_DUTY_SCALE_LSCH2(value uint32) {
	volatile.StoreUint32(&o.LSCH2_CONF1.Reg, volatile.LoadUint32(&o.LSCH2_CONF1.Reg)&^(0x3ff)|value)
}
func (o *LEDC_Type) GetLSCH2_CONF1_DUTY_SCALE_LSCH2() uint32 {
	return volatile.LoadUint32(&o.LSCH2_CONF1.Reg) & 0x3ff
}
func (o *LEDC_Type) SetLSCH2_CONF1_DUTY_CYCLE_LSCH2(value uint32) {
	volatile.StoreUint32(&o.LSCH2_CONF1.Reg, volatile.LoadUint32(&o.LSCH2_CONF1.Reg)&^(0xffc00)|value<<10)
}
func (o *LEDC_Type) GetLSCH2_CONF1_DUTY_CYCLE_LSCH2() uint32 {
	return (volatile.LoadUint32(&o.LSCH2_CONF1.Reg) & 0xffc00) >> 10
}
func (o *LEDC_Type) SetLSCH2_CONF1_DUTY_NUM_LSCH2(value uint32) {
	volatile.StoreUint32(&o.LSCH2_CONF1.Reg, volatile.LoadUint32(&o.LSCH2_CONF1.Reg)&^(0x3ff00000)|value<<20)
}
func (o *LEDC_Type) GetLSCH2_CONF1_DUTY_NUM_LSCH2() uint32 {
	return (volatile.LoadUint32(&o.LSCH2_CONF1.Reg) & 0x3ff00000) >> 20
}
func (o *LEDC_Type) SetLSCH2_CONF1_DUTY_INC_LSCH2(value uint32) {
	volatile.StoreUint32(&o.LSCH2_CONF1.Reg, volatile.LoadUint32(&o.LSCH2_CONF1.Reg)&^(0x40000000)|value<<30)
}
func (o *LEDC_Type) GetLSCH2_CONF1_DUTY_INC_LSCH2() uint32 {
	return (volatile.LoadUint32(&o.LSCH2_CONF1.Reg) & 0x40000000) >> 30
}
func (o *LEDC_Type) SetLSCH2_CONF1_DUTY_START_LSCH2(value uint32) {
	volatile.StoreUint32(&o.LSCH2_CONF1.Reg, volatile.LoadUint32(&o.LSCH2_CONF1.Reg)&^(0x80000000)|value<<31)
}
func (o *LEDC_Type) GetLSCH2_CONF1_DUTY_START_LSCH2() uint32 {
	return (volatile.LoadUint32(&o.LSCH2_CONF1.Reg) & 0x80000000) >> 31
}

// LEDC.LSCH2_DUTY_R: LEDC_LSCH2_DUTY_R.
func (o *LEDC_Type) SetLSCH2_DUTY_R_DUTY_LSCH2_R(value uint32) {
	volatile.StoreUint32(&o.LSCH2_DUTY_R.Reg, volatile.LoadUint32(&o.LSCH2_DUTY_R.Reg)&^(0x7ffff)|value)
}
func (o *LEDC_Type) GetLSCH2_DUTY_R_DUTY_LSCH2_R() uint32 {
	return volatile.LoadUint32(&o.LSCH2_DUTY_R.Reg) & 0x7ffff
}

// LEDC.LSCH3_CONF0: LEDC_LSCH3_CONF0.
func (o *LEDC_Type) SetLSCH3_CONF0_TIMER_SEL_LSCH3(value uint32) {
	volatile.StoreUint32(&o.LSCH3_CONF0.Reg, volatile.LoadUint32(&o.LSCH3_CONF0.Reg)&^(0x3)|value)
}
func (o *LEDC_Type) GetLSCH3_CONF0_TIMER_SEL_LSCH3() uint32 {
	return volatile.LoadUint32(&o.LSCH3_CONF0.Reg) & 0x3
}
func (o *LEDC_Type) SetLSCH3_CONF0_SIG_OUT_EN_LSCH3(value uint32) {
	volatile.StoreUint32(&o.LSCH3_CONF0.Reg, volatile.LoadUint32(&o.LSCH3_CONF0.Reg)&^(0x4)|value<<2)
}
func (o *LEDC_Type) GetLSCH3_CONF0_SIG_OUT_EN_LSCH3() uint32 {
	return (volatile.LoadUint32(&o.LSCH3_CONF0.Reg) & 0x4) >> 2
}
func (o *LEDC_Type) SetLSCH3_CONF0_IDLE_LV_LSCH3(value uint32) {
	volatile.StoreUint32(&o.LSCH3_CONF0.Reg, volatile.LoadUint32(&o.LSCH3_CONF0.Reg)&^(0x8)|value<<3)
}
func (o *LEDC_Type) GetLSCH3_CONF0_IDLE_LV_LSCH3() uint32 {
	return (volatile.LoadUint32(&o.LSCH3_CONF0.Reg) & 0x8) >> 3
}
func (o *LEDC_Type) SetLSCH3_CONF0_PARA_UP_LSCH3(value uint32) {
	volatile.StoreUint32(&o.LSCH3_CONF0.Reg, volatile.LoadUint32(&o.LSCH3_CONF0.Reg)&^(0x10)|value<<4)
}
func (o *LEDC_Type) GetLSCH3_CONF0_PARA_UP_LSCH3() uint32 {
	return (volatile.LoadUint32(&o.LSCH3_CONF0.Reg) & 0x10) >> 4
}
func (o *LEDC_Type) SetLSCH3_CONF0_OVF_NUM_LSCH3(value uint32) {
	volatile.StoreUint32(&o.LSCH3_CONF0.Reg, volatile.LoadUint32(&o.LSCH3_CONF0.Reg)&^(0x7fe0)|value<<5)
}
func (o *LEDC_Type) GetLSCH3_CONF0_OVF_NUM_LSCH3() uint32 {
	return (volatile.LoadUint32(&o.LSCH3_CONF0.Reg) & 0x7fe0) >> 5
}
func (o *LEDC_Type) SetLSCH3_CONF0_OVF_CNT_EN_LSCH3(value uint32) {
	volatile.StoreUint32(&o.LSCH3_CONF0.Reg, volatile.LoadUint32(&o.LSCH3_CONF0.Reg)&^(0x8000)|value<<15)
}
func (o *LEDC_Type) GetLSCH3_CONF0_OVF_CNT_EN_LSCH3() uint32 {
	return (volatile.LoadUint32(&o.LSCH3_CONF0.Reg) & 0x8000) >> 15
}
func (o *LEDC_Type) SetLSCH3_CONF0_OVF_CNT_RESET_LSCH3(value uint32) {
	volatile.StoreUint32(&o.LSCH3_CONF0.Reg, volatile.LoadUint32(&o.LSCH3_CONF0.Reg)&^(0x10000)|value<<16)
}
func (o *LEDC_Type) GetLSCH3_CONF0_OVF_CNT_RESET_LSCH3() uint32 {
	return (volatile.LoadUint32(&o.LSCH3_CONF0.Reg) & 0x10000) >> 16
}

// LEDC.LSCH3_HPOINT: LEDC_LSCH3_HPOINT.
func (o *LEDC_Type) SetLSCH3_HPOINT_HPOINT_LSCH3(value uint32) {
	volatile.StoreUint32(&o.LSCH3_HPOINT.Reg, volatile.LoadUint32(&o.LSCH3_HPOINT.Reg)&^(0x3fff)|value)
}
func (o *LEDC_Type) GetLSCH3_HPOINT_HPOINT_LSCH3() uint32 {
	return volatile.LoadUint32(&o.LSCH3_HPOINT.Reg) & 0x3fff
}

// LEDC.LSCH3_DUTY: LEDC_LSCH3_DUTY.
func (o *LEDC_Type) SetLSCH3_DUTY_DUTY_LSCH3(value uint32) {
	volatile.StoreUint32(&o.LSCH3_DUTY.Reg, volatile.LoadUint32(&o.LSCH3_DUTY.Reg)&^(0x7ffff)|value)
}
func (o *LEDC_Type) GetLSCH3_DUTY_DUTY_LSCH3() uint32 {
	return volatile.LoadUint32(&o.LSCH3_DUTY.Reg) & 0x7ffff
}

// LEDC.LSCH3_CONF1: LEDC_LSCH3_CONF1.
func (o *LEDC_Type) SetLSCH3_CONF1_DUTY_SCALE_LSCH3(value uint32) {
	volatile.StoreUint32(&o.LSCH3_CONF1.Reg, volatile.LoadUint32(&o.LSCH3_CONF1.Reg)&^(0x3ff)|value)
}
func (o *LEDC_Type) GetLSCH3_CONF1_DUTY_SCALE_LSCH3() uint32 {
	return volatile.LoadUint32(&o.LSCH3_CONF1.Reg) & 0x3ff
}
func (o *LEDC_Type) SetLSCH3_CONF1_DUTY_CYCLE_LSCH3(value uint32) {
	volatile.StoreUint32(&o.LSCH3_CONF1.Reg, volatile.LoadUint32(&o.LSCH3_CONF1.Reg)&^(0xffc00)|value<<10)
}
func (o *LEDC_Type) GetLSCH3_CONF1_DUTY_CYCLE_LSCH3() uint32 {
	return (volatile.LoadUint32(&o.LSCH3_CONF1.Reg) & 0xffc00) >> 10
}
func (o *LEDC_Type) SetLSCH3_CONF1_DUTY_NUM_LSCH3(value uint32) {
	volatile.StoreUint32(&o.LSCH3_CONF1.Reg, volatile.LoadUint32(&o.LSCH3_CONF1.Reg)&^(0x3ff00000)|value<<20)
}
func (o *LEDC_Type) GetLSCH3_CONF1_DUTY_NUM_LSCH3() uint32 {
	return (volatile.LoadUint32(&o.LSCH3_CONF1.Reg) & 0x3ff00000) >> 20
}
func (o *LEDC_Type) SetLSCH3_CONF1_DUTY_INC_LSCH3(value uint32) {
	volatile.StoreUint32(&o.LSCH3_CONF1.Reg, volatile.LoadUint32(&o.LSCH3_CONF1.Reg)&^(0x40000000)|value<<30)
}
func (o *LEDC_Type) GetLSCH3_CONF1_DUTY_INC_LSCH3() uint32 {
	return (volatile.LoadUint32(&o.LSCH3_CONF1.Reg) & 0x40000000) >> 30
}
func (o *LEDC_Type) SetLSCH3_CONF1_DUTY_START_LSCH3(value uint32) {
	volatile.StoreUint32(&o.LSCH3_CONF1.Reg, volatile.LoadUint32(&o.LSCH3_CONF1.Reg)&^(0x80000000)|value<<31)
}
func (o *LEDC_Type) GetLSCH3_CONF1_DUTY_START_LSCH3() uint32 {
	return (volatile.LoadUint32(&o.LSCH3_CONF1.Reg) & 0x80000000) >> 31
}

// LEDC.LSCH3_DUTY_R: LEDC_LSCH3_DUTY_R.
func (o *LEDC_Type) SetLSCH3_DUTY_R_DUTY_LSCH3_R(value uint32) {
	volatile.StoreUint32(&o.LSCH3_DUTY_R.Reg, volatile.LoadUint32(&o.LSCH3_DUTY_R.Reg)&^(0x7ffff)|value)
}
func (o *LEDC_Type) GetLSCH3_DUTY_R_DUTY_LSCH3_R() uint32 {
	return volatile.LoadUint32(&o.LSCH3_DUTY_R.Reg) & 0x7ffff
}

// LEDC.LSCH4_CONF0: LEDC_LSCH4_CONF0.
func (o *LEDC_Type) SetLSCH4_CONF0_TIMER_SEL_LSCH4(value uint32) {
	volatile.StoreUint32(&o.LSCH4_CONF0.Reg, volatile.LoadUint32(&o.LSCH4_CONF0.Reg)&^(0x3)|value)
}
func (o *LEDC_Type) GetLSCH4_CONF0_TIMER_SEL_LSCH4() uint32 {
	return volatile.LoadUint32(&o.LSCH4_CONF0.Reg) & 0x3
}
func (o *LEDC_Type) SetLSCH4_CONF0_SIG_OUT_EN_LSCH4(value uint32) {
	volatile.StoreUint32(&o.LSCH4_CONF0.Reg, volatile.LoadUint32(&o.LSCH4_CONF0.Reg)&^(0x4)|value<<2)
}
func (o *LEDC_Type) GetLSCH4_CONF0_SIG_OUT_EN_LSCH4() uint32 {
	return (volatile.LoadUint32(&o.LSCH4_CONF0.Reg) & 0x4) >> 2
}
func (o *LEDC_Type) SetLSCH4_CONF0_IDLE_LV_LSCH4(value uint32) {
	volatile.StoreUint32(&o.LSCH4_CONF0.Reg, volatile.LoadUint32(&o.LSCH4_CONF0.Reg)&^(0x8)|value<<3)
}
func (o *LEDC_Type) GetLSCH4_CONF0_IDLE_LV_LSCH4() uint32 {
	return (volatile.LoadUint32(&o.LSCH4_CONF0.Reg) & 0x8) >> 3
}
func (o *LEDC_Type) SetLSCH4_CONF0_PARA_UP_LSCH4(value uint32) {
	volatile.StoreUint32(&o.LSCH4_CONF0.Reg, volatile.LoadUint32(&o.LSCH4_CONF0.Reg)&^(0x10)|value<<4)
}
func (o *LEDC_Type) GetLSCH4_CONF0_PARA_UP_LSCH4() uint32 {
	return (volatile.LoadUint32(&o.LSCH4_CONF0.Reg) & 0x10) >> 4
}
func (o *LEDC_Type) SetLSCH4_CONF0_OVF_NUM_LSCH4(value uint32) {
	volatile.StoreUint32(&o.LSCH4_CONF0.Reg, volatile.LoadUint32(&o.LSCH4_CONF0.Reg)&^(0x7fe0)|value<<5)
}
func (o *LEDC_Type) GetLSCH4_CONF0_OVF_NUM_LSCH4() uint32 {
	return (volatile.LoadUint32(&o.LSCH4_CONF0.Reg) & 0x7fe0) >> 5
}
func (o *LEDC_Type) SetLSCH4_CONF0_OVF_CNT_EN_LSCH4(value uint32) {
	volatile.StoreUint32(&o.LSCH4_CONF0.Reg, volatile.LoadUint32(&o.LSCH4_CONF0.Reg)&^(0x8000)|value<<15)
}
func (o *LEDC_Type) GetLSCH4_CONF0_OVF_CNT_EN_LSCH4() uint32 {
	return (volatile.LoadUint32(&o.LSCH4_CONF0.Reg) & 0x8000) >> 15
}
func (o *LEDC_Type) SetLSCH4_CONF0_OVF_CNT_RESET_LSCH4(value uint32) {
	volatile.StoreUint32(&o.LSCH4_CONF0.Reg, volatile.LoadUint32(&o.LSCH4_CONF0.Reg)&^(0x10000)|value<<16)
}
func (o *LEDC_Type) GetLSCH4_CONF0_OVF_CNT_RESET_LSCH4() uint32 {
	return (volatile.LoadUint32(&o.LSCH4_CONF0.Reg) & 0x10000) >> 16
}

// LEDC.LSCH4_HPOINT: LEDC_LSCH4_HPOINT.
func (o *LEDC_Type) SetLSCH4_HPOINT_HPOINT_LSCH4(value uint32) {
	volatile.StoreUint32(&o.LSCH4_HPOINT.Reg, volatile.LoadUint32(&o.LSCH4_HPOINT.Reg)&^(0x3fff)|value)
}
func (o *LEDC_Type) GetLSCH4_HPOINT_HPOINT_LSCH4() uint32 {
	return volatile.LoadUint32(&o.LSCH4_HPOINT.Reg) & 0x3fff
}

// LEDC.LSCH4_DUTY: LEDC_LSCH4_DUTY.
func (o *LEDC_Type) SetLSCH4_DUTY_DUTY_LSCH4(value uint32) {
	volatile.StoreUint32(&o.LSCH4_DUTY.Reg, volatile.LoadUint32(&o.LSCH4_DUTY.Reg)&^(0x7ffff)|value)
}
func (o *LEDC_Type) GetLSCH4_DUTY_DUTY_LSCH4() uint32 {
	return volatile.LoadUint32(&o.LSCH4_DUTY.Reg) & 0x7ffff
}

// LEDC.LSCH4_CONF1: LEDC_LSCH4_CONF1.
func (o *LEDC_Type) SetLSCH4_CONF1_DUTY_SCALE_LSCH4(value uint32) {
	volatile.StoreUint32(&o.LSCH4_CONF1.Reg, volatile.LoadUint32(&o.LSCH4_CONF1.Reg)&^(0x3ff)|value)
}
func (o *LEDC_Type) GetLSCH4_CONF1_DUTY_SCALE_LSCH4() uint32 {
	return volatile.LoadUint32(&o.LSCH4_CONF1.Reg) & 0x3ff
}
func (o *LEDC_Type) SetLSCH4_CONF1_DUTY_CYCLE_LSCH4(value uint32) {
	volatile.StoreUint32(&o.LSCH4_CONF1.Reg, volatile.LoadUint32(&o.LSCH4_CONF1.Reg)&^(0xffc00)|value<<10)
}
func (o *LEDC_Type) GetLSCH4_CONF1_DUTY_CYCLE_LSCH4() uint32 {
	return (volatile.LoadUint32(&o.LSCH4_CONF1.Reg) & 0xffc00) >> 10
}
func (o *LEDC_Type) SetLSCH4_CONF1_DUTY_NUM_LSCH4(value uint32) {
	volatile.StoreUint32(&o.LSCH4_CONF1.Reg, volatile.LoadUint32(&o.LSCH4_CONF1.Reg)&^(0x3ff00000)|value<<20)
}
func (o *LEDC_Type) GetLSCH4_CONF1_DUTY_NUM_LSCH4() uint32 {
	return (volatile.LoadUint32(&o.LSCH4_CONF1.Reg) & 0x3ff00000) >> 20
}
func (o *LEDC_Type) SetLSCH4_CONF1_DUTY_INC_LSCH4(value uint32) {
	volatile.StoreUint32(&o.LSCH4_CONF1.Reg, volatile.LoadUint32(&o.LSCH4_CONF1.Reg)&^(0x40000000)|value<<30)
}
func (o *LEDC_Type) GetLSCH4_CONF1_DUTY_INC_LSCH4() uint32 {
	return (volatile.LoadUint32(&o.LSCH4_CONF1.Reg) & 0x40000000) >> 30
}
func (o *LEDC_Type) SetLSCH4_CONF1_DUTY_START_LSCH4(value uint32) {
	volatile.StoreUint32(&o.LSCH4_CONF1.Reg, volatile.LoadUint32(&o.LSCH4_CONF1.Reg)&^(0x80000000)|value<<31)
}
func (o *LEDC_Type) GetLSCH4_CONF1_DUTY_START_LSCH4() uint32 {
	return (volatile.LoadUint32(&o.LSCH4_CONF1.Reg) & 0x80000000) >> 31
}

// LEDC.LSCH4_DUTY_R: LEDC_LSCH4_DUTY_R.
func (o *LEDC_Type) SetLSCH4_DUTY_R_DUTY_LSCH4_R(value uint32) {
	volatile.StoreUint32(&o.LSCH4_DUTY_R.Reg, volatile.LoadUint32(&o.LSCH4_DUTY_R.Reg)&^(0x7ffff)|value)
}
func (o *LEDC_Type) GetLSCH4_DUTY_R_DUTY_LSCH4_R() uint32 {
	return volatile.LoadUint32(&o.LSCH4_DUTY_R.Reg) & 0x7ffff
}

// LEDC.LSCH5_CONF0: LEDC_LSCH5_CONF0.
func (o *LEDC_Type) SetLSCH5_CONF0_TIMER_SEL_LSCH5(value uint32) {
	volatile.StoreUint32(&o.LSCH5_CONF0.Reg, volatile.LoadUint32(&o.LSCH5_CONF0.Reg)&^(0x3)|value)
}
func (o *LEDC_Type) GetLSCH5_CONF0_TIMER_SEL_LSCH5() uint32 {
	return volatile.LoadUint32(&o.LSCH5_CONF0.Reg) & 0x3
}
func (o *LEDC_Type) SetLSCH5_CONF0_SIG_OUT_EN_LSCH5(value uint32) {
	volatile.StoreUint32(&o.LSCH5_CONF0.Reg, volatile.LoadUint32(&o.LSCH5_CONF0.Reg)&^(0x4)|value<<2)
}
func (o *LEDC_Type) GetLSCH5_CONF0_SIG_OUT_EN_LSCH5() uint32 {
	return (volatile.LoadUint32(&o.LSCH5_CONF0.Reg) & 0x4) >> 2
}
func (o *LEDC_Type) SetLSCH5_CONF0_IDLE_LV_LSCH5(value uint32) {
	volatile.StoreUint32(&o.LSCH5_CONF0.Reg, volatile.LoadUint32(&o.LSCH5_CONF0.Reg)&^(0x8)|value<<3)
}
func (o *LEDC_Type) GetLSCH5_CONF0_IDLE_LV_LSCH5() uint32 {
	return (volatile.LoadUint32(&o.LSCH5_CONF0.Reg) & 0x8) >> 3
}
func (o *LEDC_Type) SetLSCH5_CONF0_PARA_UP_LSCH5(value uint32) {
	volatile.StoreUint32(&o.LSCH5_CONF0.Reg, volatile.LoadUint32(&o.LSCH5_CONF0.Reg)&^(0x10)|value<<4)
}
func (o *LEDC_Type) GetLSCH5_CONF0_PARA_UP_LSCH5() uint32 {
	return (volatile.LoadUint32(&o.LSCH5_CONF0.Reg) & 0x10) >> 4
}
func (o *LEDC_Type) SetLSCH5_CONF0_OVF_NUM_LSCH5(value uint32) {
	volatile.StoreUint32(&o.LSCH5_CONF0.Reg, volatile.LoadUint32(&o.LSCH5_CONF0.Reg)&^(0x7fe0)|value<<5)
}
func (o *LEDC_Type) GetLSCH5_CONF0_OVF_NUM_LSCH5() uint32 {
	return (volatile.LoadUint32(&o.LSCH5_CONF0.Reg) & 0x7fe0) >> 5
}
func (o *LEDC_Type) SetLSCH5_CONF0_OVF_CNT_EN_LSCH5(value uint32) {
	volatile.StoreUint32(&o.LSCH5_CONF0.Reg, volatile.LoadUint32(&o.LSCH5_CONF0.Reg)&^(0x8000)|value<<15)
}
func (o *LEDC_Type) GetLSCH5_CONF0_OVF_CNT_EN_LSCH5() uint32 {
	return (volatile.LoadUint32(&o.LSCH5_CONF0.Reg) & 0x8000) >> 15
}
func (o *LEDC_Type) SetLSCH5_CONF0_OVF_CNT_RESET_LSCH5(value uint32) {
	volatile.StoreUint32(&o.LSCH5_CONF0.Reg, volatile.LoadUint32(&o.LSCH5_CONF0.Reg)&^(0x10000)|value<<16)
}
func (o *LEDC_Type) GetLSCH5_CONF0_OVF_CNT_RESET_LSCH5() uint32 {
	return (volatile.LoadUint32(&o.LSCH5_CONF0.Reg) & 0x10000) >> 16
}

// LEDC.LSCH5_HPOINT: LEDC_LSCH5_HPOINT.
func (o *LEDC_Type) SetLSCH5_HPOINT_HPOINT_LSCH5(value uint32) {
	volatile.StoreUint32(&o.LSCH5_HPOINT.Reg, volatile.LoadUint32(&o.LSCH5_HPOINT.Reg)&^(0x3fff)|value)
}
func (o *LEDC_Type) GetLSCH5_HPOINT_HPOINT_LSCH5() uint32 {
	return volatile.LoadUint32(&o.LSCH5_HPOINT.Reg) & 0x3fff
}

// LEDC.LSCH5_DUTY: LEDC_LSCH5_DUTY.
func (o *LEDC_Type) SetLSCH5_DUTY_DUTY_LSCH5(value uint32) {
	volatile.StoreUint32(&o.LSCH5_DUTY.Reg, volatile.LoadUint32(&o.LSCH5_DUTY.Reg)&^(0x7ffff)|value)
}
func (o *LEDC_Type) GetLSCH5_DUTY_DUTY_LSCH5() uint32 {
	return volatile.LoadUint32(&o.LSCH5_DUTY.Reg) & 0x7ffff
}

// LEDC.LSCH5_CONF1: LEDC_LSCH5_CONF1.
func (o *LEDC_Type) SetLSCH5_CONF1_DUTY_SCALE_LSCH5(value uint32) {
	volatile.StoreUint32(&o.LSCH5_CONF1.Reg, volatile.LoadUint32(&o.LSCH5_CONF1.Reg)&^(0x3ff)|value)
}
func (o *LEDC_Type) GetLSCH5_CONF1_DUTY_SCALE_LSCH5() uint32 {
	return volatile.LoadUint32(&o.LSCH5_CONF1.Reg) & 0x3ff
}
func (o *LEDC_Type) SetLSCH5_CONF1_DUTY_CYCLE_LSCH5(value uint32) {
	volatile.StoreUint32(&o.LSCH5_CONF1.Reg, volatile.LoadUint32(&o.LSCH5_CONF1.Reg)&^(0xffc00)|value<<10)
}
func (o *LEDC_Type) GetLSCH5_CONF1_DUTY_CYCLE_LSCH5() uint32 {
	return (volatile.LoadUint32(&o.LSCH5_CONF1.Reg) & 0xffc00) >> 10
}
func (o *LEDC_Type) SetLSCH5_CONF1_DUTY_NUM_LSCH5(value uint32) {
	volatile.StoreUint32(&o.LSCH5_CONF1.Reg, volatile.LoadUint32(&o.LSCH5_CONF1.Reg)&^(0x3ff00000)|value<<20)
}
func (o *LEDC_Type) GetLSCH5_CONF1_DUTY_NUM_LSCH5() uint32 {
	return (volatile.LoadUint32(&o.LSCH5_CONF1.Reg) & 0x3ff00000) >> 20
}
func (o *LEDC_Type) SetLSCH5_CONF1_DUTY_INC_LSCH5(value uint32) {
	volatile.StoreUint32(&o.LSCH5_CONF1.Reg, volatile.LoadUint32(&o.LSCH5_CONF1.Reg)&^(0x40000000)|value<<30)
}
func (o *LEDC_Type) GetLSCH5_CONF1_DUTY_INC_LSCH5() uint32 {
	return (volatile.LoadUint32(&o.LSCH5_CONF1.Reg) & 0x40000000) >> 30
}
func (o *LEDC_Type) SetLSCH5_CONF1_DUTY_START_LSCH5(value uint32) {
	volatile.StoreUint32(&o.LSCH5_CONF1.Reg, volatile.LoadUint32(&o.LSCH5_CONF1.Reg)&^(0x80000000)|value<<31)
}
func (o *LEDC_Type) GetLSCH5_CONF1_DUTY_START_LSCH5() uint32 {
	return (volatile.LoadUint32(&o.LSCH5_CONF1.Reg) & 0x80000000) >> 31
}

// LEDC.LSCH5_DUTY_R: LEDC_LSCH5_DUTY_R.
func (o *LEDC_Type) SetLSCH5_DUTY_R_DUTY_LSCH5_R(value uint32) {
	volatile.StoreUint32(&o.LSCH5_DUTY_R.Reg, volatile.LoadUint32(&o.LSCH5_DUTY_R.Reg)&^(0x7ffff)|value)
}
func (o *LEDC_Type) GetLSCH5_DUTY_R_DUTY_LSCH5_R() uint32 {
	return volatile.LoadUint32(&o.LSCH5_DUTY_R.Reg) & 0x7ffff
}

// LEDC.LSTIMER0_CONF: LEDC_LSTIMER0_CONF.
func (o *LEDC_Type) SetLSTIMER0_CONF_LSTIMER0_DUTY_RES(value uint32) {
	volatile.StoreUint32(&o.LSTIMER0_CONF.Reg, volatile.LoadUint32(&o.LSTIMER0_CONF.Reg)&^(0xf)|value)
}
func (o *LEDC_Type) GetLSTIMER0_CONF_LSTIMER0_DUTY_RES() uint32 {
	return volatile.LoadUint32(&o.LSTIMER0_CONF.Reg) & 0xf
}
func (o *LEDC_Type) SetLSTIMER0_CONF_CLK_DIV_LSTIMER0(value uint32) {
	volatile.StoreUint32(&o.LSTIMER0_CONF.Reg, volatile.LoadUint32(&o.LSTIMER0_CONF.Reg)&^(0x3ffff0)|value<<4)
}
func (o *LEDC_Type) GetLSTIMER0_CONF_CLK_DIV_LSTIMER0() uint32 {
	return (volatile.LoadUint32(&o.LSTIMER0_CONF.Reg) & 0x3ffff0) >> 4
}
func (o *LEDC_Type) SetLSTIMER0_CONF_LSTIMER0_PAUSE(value uint32) {
	volatile.StoreUint32(&o.LSTIMER0_CONF.Reg, volatile.LoadUint32(&o.LSTIMER0_CONF.Reg)&^(0x400000)|value<<22)
}
func (o *LEDC_Type) GetLSTIMER0_CONF_LSTIMER0_PAUSE() uint32 {
	return (volatile.LoadUint32(&o.LSTIMER0_CONF.Reg) & 0x400000) >> 22
}
func (o *LEDC_Type) SetLSTIMER0_CONF_LSTIMER0_RST(value uint32) {
	volatile.StoreUint32(&o.LSTIMER0_CONF.Reg, volatile.LoadUint32(&o.LSTIMER0_CONF.Reg)&^(0x800000)|value<<23)
}
func (o *LEDC_Type) GetLSTIMER0_CONF_LSTIMER0_RST() uint32 {
	return (volatile.LoadUint32(&o.LSTIMER0_CONF.Reg) & 0x800000) >> 23
}
func (o *LEDC_Type) SetLSTIMER0_CONF_TICK_SEL_LSTIMER0(value uint32) {
	volatile.StoreUint32(&o.LSTIMER0_CONF.Reg, volatile.LoadUint32(&o.LSTIMER0_CONF.Reg)&^(0x1000000)|value<<24)
}
func (o *LEDC_Type) GetLSTIMER0_CONF_TICK_SEL_LSTIMER0() uint32 {
	return (volatile.LoadUint32(&o.LSTIMER0_CONF.Reg) & 0x1000000) >> 24
}
func (o *LEDC_Type) SetLSTIMER0_CONF_LSTIMER0_PARA_UP(value uint32) {
	volatile.StoreUint32(&o.LSTIMER0_CONF.Reg, volatile.LoadUint32(&o.LSTIMER0_CONF.Reg)&^(0x2000000)|value<<25)
}
func (o *LEDC_Type) GetLSTIMER0_CONF_LSTIMER0_PARA_UP() uint32 {
	return (volatile.LoadUint32(&o.LSTIMER0_CONF.Reg) & 0x2000000) >> 25
}

// LEDC.LSTIMER0_VALUE: LEDC_LSTIMER0_VALUE.
func (o *LEDC_Type) SetLSTIMER0_VALUE_LSTIMER0_CNT(value uint32) {
	volatile.StoreUint32(&o.LSTIMER0_VALUE.Reg, volatile.LoadUint32(&o.LSTIMER0_VALUE.Reg)&^(0x3fff)|value)
}
func (o *LEDC_Type) GetLSTIMER0_VALUE_LSTIMER0_CNT() uint32 {
	return volatile.LoadUint32(&o.LSTIMER0_VALUE.Reg) & 0x3fff
}

// LEDC.LSTIMER1_CONF: LEDC_LSTIMER1_CONF.
func (o *LEDC_Type) SetLSTIMER1_CONF_LSTIMER1_DUTY_RES(value uint32) {
	volatile.StoreUint32(&o.LSTIMER1_CONF.Reg, volatile.LoadUint32(&o.LSTIMER1_CONF.Reg)&^(0xf)|value)
}
func (o *LEDC_Type) GetLSTIMER1_CONF_LSTIMER1_DUTY_RES() uint32 {
	return volatile.LoadUint32(&o.LSTIMER1_CONF.Reg) & 0xf
}
func (o *LEDC_Type) SetLSTIMER1_CONF_CLK_DIV_LSTIMER1(value uint32) {
	volatile.StoreUint32(&o.LSTIMER1_CONF.Reg, volatile.LoadUint32(&o.LSTIMER1_CONF.Reg)&^(0x3ffff0)|value<<4)
}
func (o *LEDC_Type) GetLSTIMER1_CONF_CLK_DIV_LSTIMER1() uint32 {
	return (volatile.LoadUint32(&o.LSTIMER1_CONF.Reg) & 0x3ffff0) >> 4
}
func (o *LEDC_Type) SetLSTIMER1_CONF_LSTIMER1_PAUSE(value uint32) {
	volatile.StoreUint32(&o.LSTIMER1_CONF.Reg, volatile.LoadUint32(&o.LSTIMER1_CONF.Reg)&^(0x400000)|value<<22)
}
func (o *LEDC_Type) GetLSTIMER1_CONF_LSTIMER1_PAUSE() uint32 {
	return (volatile.LoadUint32(&o.LSTIMER1_CONF.Reg) & 0x400000) >> 22
}
func (o *LEDC_Type) SetLSTIMER1_CONF_LSTIMER1_RST(value uint32) {
	volatile.StoreUint32(&o.LSTIMER1_CONF.Reg, volatile.LoadUint32(&o.LSTIMER1_CONF.Reg)&^(0x800000)|value<<23)
}
func (o *LEDC_Type) GetLSTIMER1_CONF_LSTIMER1_RST() uint32 {
	return (volatile.LoadUint32(&o.LSTIMER1_CONF.Reg) & 0x800000) >> 23
}
func (o *LEDC_Type) SetLSTIMER1_CONF_TICK_SEL_LSTIMER1(value uint32) {
	volatile.StoreUint32(&o.LSTIMER1_CONF.Reg, volatile.LoadUint32(&o.LSTIMER1_CONF.Reg)&^(0x1000000)|value<<24)
}
func (o *LEDC_Type) GetLSTIMER1_CONF_TICK_SEL_LSTIMER1() uint32 {
	return (volatile.LoadUint32(&o.LSTIMER1_CONF.Reg) & 0x1000000) >> 24
}
func (o *LEDC_Type) SetLSTIMER1_CONF_LSTIMER1_PARA_UP(value uint32) {
	volatile.StoreUint32(&o.LSTIMER1_CONF.Reg, volatile.LoadUint32(&o.LSTIMER1_CONF.Reg)&^(0x2000000)|value<<25)
}
func (o *LEDC_Type) GetLSTIMER1_CONF_LSTIMER1_PARA_UP() uint32 {
	return (volatile.LoadUint32(&o.LSTIMER1_CONF.Reg) & 0x2000000) >> 25
}

// LEDC.LSTIMER1_VALUE: LEDC_LSTIMER1_VALUE.
func (o *LEDC_Type) SetLSTIMER1_VALUE_LSTIMER1_CNT(value uint32) {
	volatile.StoreUint32(&o.LSTIMER1_VALUE.Reg, volatile.LoadUint32(&o.LSTIMER1_VALUE.Reg)&^(0x3fff)|value)
}
func (o *LEDC_Type) GetLSTIMER1_VALUE_LSTIMER1_CNT() uint32 {
	return volatile.LoadUint32(&o.LSTIMER1_VALUE.Reg) & 0x3fff
}

// LEDC.LSTIMER2_CONF: LEDC_LSTIMER2_CONF.
func (o *LEDC_Type) SetLSTIMER2_CONF_LSTIMER2_DUTY_RES(value uint32) {
	volatile.StoreUint32(&o.LSTIMER2_CONF.Reg, volatile.LoadUint32(&o.LSTIMER2_CONF.Reg)&^(0xf)|value)
}
func (o *LEDC_Type) GetLSTIMER2_CONF_LSTIMER2_DUTY_RES() uint32 {
	return volatile.LoadUint32(&o.LSTIMER2_CONF.Reg) & 0xf
}
func (o *LEDC_Type) SetLSTIMER2_CONF_CLK_DIV_LSTIMER2(value uint32) {
	volatile.StoreUint32(&o.LSTIMER2_CONF.Reg, volatile.LoadUint32(&o.LSTIMER2_CONF.Reg)&^(0x3ffff0)|value<<4)
}
func (o *LEDC_Type) GetLSTIMER2_CONF_CLK_DIV_LSTIMER2() uint32 {
	return (volatile.LoadUint32(&o.LSTIMER2_CONF.Reg) & 0x3ffff0) >> 4
}
func (o *LEDC_Type) SetLSTIMER2_CONF_LSTIMER2_PAUSE(value uint32) {
	volatile.StoreUint32(&o.LSTIMER2_CONF.Reg, volatile.LoadUint32(&o.LSTIMER2_CONF.Reg)&^(0x400000)|value<<22)
}
func (o *LEDC_Type) GetLSTIMER2_CONF_LSTIMER2_PAUSE() uint32 {
	return (volatile.LoadUint32(&o.LSTIMER2_CONF.Reg) & 0x400000) >> 22
}
func (o *LEDC_Type) SetLSTIMER2_CONF_LSTIMER2_RST(value uint32) {
	volatile.StoreUint32(&o.LSTIMER2_CONF.Reg, volatile.LoadUint32(&o.LSTIMER2_CONF.Reg)&^(0x800000)|value<<23)
}
func (o *LEDC_Type) GetLSTIMER2_CONF_LSTIMER2_RST() uint32 {
	return (volatile.LoadUint32(&o.LSTIMER2_CONF.Reg) & 0x800000) >> 23
}
func (o *LEDC_Type) SetLSTIMER2_CONF_TICK_SEL_LSTIMER2(value uint32) {
	volatile.StoreUint32(&o.LSTIMER2_CONF.Reg, volatile.LoadUint32(&o.LSTIMER2_CONF.Reg)&^(0x1000000)|value<<24)
}
func (o *LEDC_Type) GetLSTIMER2_CONF_TICK_SEL_LSTIMER2() uint32 {
	return (volatile.LoadUint32(&o.LSTIMER2_CONF.Reg) & 0x1000000) >> 24
}
func (o *LEDC_Type) SetLSTIMER2_CONF_LSTIMER2_PARA_UP(value uint32) {
	volatile.StoreUint32(&o.LSTIMER2_CONF.Reg, volatile.LoadUint32(&o.LSTIMER2_CONF.Reg)&^(0x2000000)|value<<25)
}
func (o *LEDC_Type) GetLSTIMER2_CONF_LSTIMER2_PARA_UP() uint32 {
	return (volatile.LoadUint32(&o.LSTIMER2_CONF.Reg) & 0x2000000) >> 25
}

// LEDC.LSTIMER2_VALUE: LEDC_LSTIMER2_VALUE.
func (o *LEDC_Type) SetLSTIMER2_VALUE_LSTIMER2_CNT(value uint32) {
	volatile.StoreUint32(&o.LSTIMER2_VALUE.Reg, volatile.LoadUint32(&o.LSTIMER2_VALUE.Reg)&^(0x3fff)|value)
}
func (o *LEDC_Type) GetLSTIMER2_VALUE_LSTIMER2_CNT() uint32 {
	return volatile.LoadUint32(&o.LSTIMER2_VALUE.Reg) & 0x3fff
}

// LEDC.LSTIMER3_CONF: LEDC_LSTIMER3_CONF.
func (o *LEDC_Type) SetLSTIMER3_CONF_LSTIMER3_DUTY_RES(value uint32) {
	volatile.StoreUint32(&o.LSTIMER3_CONF.Reg, volatile.LoadUint32(&o.LSTIMER3_CONF.Reg)&^(0xf)|value)
}
func (o *LEDC_Type) GetLSTIMER3_CONF_LSTIMER3_DUTY_RES() uint32 {
	return volatile.LoadUint32(&o.LSTIMER3_CONF.Reg) & 0xf
}
func (o *LEDC_Type) SetLSTIMER3_CONF_CLK_DIV_LSTIMER3(value uint32) {
	volatile.StoreUint32(&o.LSTIMER3_CONF.Reg, volatile.LoadUint32(&o.LSTIMER3_CONF.Reg)&^(0x3ffff0)|value<<4)
}
func (o *LEDC_Type) GetLSTIMER3_CONF_CLK_DIV_LSTIMER3() uint32 {
	return (volatile.LoadUint32(&o.LSTIMER3_CONF.Reg) & 0x3ffff0) >> 4
}
func (o *LEDC_Type) SetLSTIMER3_CONF_LSTIMER3_PAUSE(value uint32) {
	volatile.StoreUint32(&o.LSTIMER3_CONF.Reg, volatile.LoadUint32(&o.LSTIMER3_CONF.Reg)&^(0x400000)|value<<22)
}
func (o *LEDC_Type) GetLSTIMER3_CONF_LSTIMER3_PAUSE() uint32 {
	return (volatile.LoadUint32(&o.LSTIMER3_CONF.Reg) & 0x400000) >> 22
}
func (o *LEDC_Type) SetLSTIMER3_CONF_LSTIMER3_RST(value uint32) {
	volatile.StoreUint32(&o.LSTIMER3_CONF.Reg, volatile.LoadUint32(&o.LSTIMER3_CONF.Reg)&^(0x800000)|value<<23)
}
func (o *LEDC_Type) GetLSTIMER3_CONF_LSTIMER3_RST() uint32 {
	return (volatile.LoadUint32(&o.LSTIMER3_CONF.Reg) & 0x800000) >> 23
}
func (o *LEDC_Type) SetLSTIMER3_CONF_TICK_SEL_LSTIMER3(value uint32) {
	volatile.StoreUint32(&o.LSTIMER3_CONF.Reg, volatile.LoadUint32(&o.LSTIMER3_CONF.Reg)&^(0x1000000)|value<<24)
}
func (o *LEDC_Type) GetLSTIMER3_CONF_TICK_SEL_LSTIMER3() uint32 {
	return (volatile.LoadUint32(&o.LSTIMER3_CONF.Reg) & 0x1000000) >> 24
}
func (o *LEDC_Type) SetLSTIMER3_CONF_LSTIMER3_PARA_UP(value uint32) {
	volatile.StoreUint32(&o.LSTIMER3_CONF.Reg, volatile.LoadUint32(&o.LSTIMER3_CONF.Reg)&^(0x2000000)|value<<25)
}
func (o *LEDC_Type) GetLSTIMER3_CONF_LSTIMER3_PARA_UP() uint32 {
	return (volatile.LoadUint32(&o.LSTIMER3_CONF.Reg) & 0x2000000) >> 25
}

// LEDC.LSTIMER3_VALUE: LEDC_LSTIMER3_VALUE.
func (o *LEDC_Type) SetLSTIMER3_VALUE_LSTIMER3_CNT(value uint32) {
	volatile.StoreUint32(&o.LSTIMER3_VALUE.Reg, volatile.LoadUint32(&o.LSTIMER3_VALUE.Reg)&^(0x3fff)|value)
}
func (o *LEDC_Type) GetLSTIMER3_VALUE_LSTIMER3_CNT() uint32 {
	return volatile.LoadUint32(&o.LSTIMER3_VALUE.Reg) & 0x3fff
}

// LEDC.INT_RAW: LEDC_INT_RAW.
func (o *LEDC_Type) SetINT_RAW_LSTIMER0_OVF_INT_RAW(value uint32) {
	volatile.StoreUint32(&o.INT_RAW.Reg, volatile.LoadUint32(&o.INT_RAW.Reg)&^(0x1)|value)
}
func (o *LEDC_Type) GetINT_RAW_LSTIMER0_OVF_INT_RAW() uint32 {
	return volatile.LoadUint32(&o.INT_RAW.Reg) & 0x1
}
func (o *LEDC_Type) SetINT_RAW_LSTIMER1_OVF_INT_RAW(value uint32) {
	volatile.StoreUint32(&o.INT_RAW.Reg, volatile.LoadUint32(&o.INT_RAW.Reg)&^(0x2)|value<<1)
}
func (o *LEDC_Type) GetINT_RAW_LSTIMER1_OVF_INT_RAW() uint32 {
	return (volatile.LoadUint32(&o.INT_RAW.Reg) & 0x2) >> 1
}
func (o *LEDC_Type) SetINT_RAW_LSTIMER2_OVF_INT_RAW(value uint32) {
	volatile.StoreUint32(&o.INT_RAW.Reg, volatile.LoadUint32(&o.INT_RAW.Reg)&^(0x4)|value<<2)
}
func (o *LEDC_Type) GetINT_RAW_LSTIMER2_OVF_INT_RAW() uint32 {
	return (volatile.LoadUint32(&o.INT_RAW.Reg) & 0x4) >> 2
}
func (o *LEDC_Type) SetINT_RAW_LSTIMER3_OVF_INT_RAW(value uint32) {
	volatile.StoreUint32(&o.INT_RAW.Reg, volatile.LoadUint32(&o.INT_RAW.Reg)&^(0x8)|value<<3)
}
func (o *LEDC_Type) GetINT_RAW_LSTIMER3_OVF_INT_RAW() uint32 {
	return (volatile.LoadUint32(&o.INT_RAW.Reg) & 0x8) >> 3
}
func (o *LEDC_Type) SetINT_RAW_DUTY_CHNG_END_LSCH0_INT_RAW(value uint32) {
	volatile.StoreUint32(&o.INT_RAW.Reg, volatile.LoadUint32(&o.INT_RAW.Reg)&^(0x10)|value<<4)
}
func (o *LEDC_Type) GetINT_RAW_DUTY_CHNG_END_LSCH0_INT_RAW() uint32 {
	return (volatile.LoadUint32(&o.INT_RAW.Reg) & 0x10) >> 4
}
func (o *LEDC_Type) SetINT_RAW_DUTY_CHNG_END_LSCH1_INT_RAW(value uint32) {
	volatile.StoreUint32(&o.INT_RAW.Reg, volatile.LoadUint32(&o.INT_RAW.Reg)&^(0x20)|value<<5)
}
func (o *LEDC_Type) GetINT_RAW_DUTY_CHNG_END_LSCH1_INT_RAW() uint32 {
	return (volatile.LoadUint32(&o.INT_RAW.Reg) & 0x20) >> 5
}
func (o *LEDC_Type) SetINT_RAW_DUTY_CHNG_END_LSCH2_INT_RAW(value uint32) {
	volatile.StoreUint32(&o.INT_RAW.Reg, volatile.LoadUint32(&o.INT_RAW.Reg)&^(0x40)|value<<6)
}
func (o *LEDC_Type) GetINT_RAW_DUTY_CHNG_END_LSCH2_INT_RAW() uint32 {
	return (volatile.LoadUint32(&o.INT_RAW.Reg) & 0x40) >> 6
}
func (o *LEDC_Type) SetINT_RAW_DUTY_CHNG_END_LSCH3_INT_RAW(value uint32) {
	volatile.StoreUint32(&o.INT_RAW.Reg, volatile.LoadUint32(&o.INT_RAW.Reg)&^(0x80)|value<<7)
}
func (o *LEDC_Type) GetINT_RAW_DUTY_CHNG_END_LSCH3_INT_RAW() uint32 {
	return (volatile.LoadUint32(&o.INT_RAW.Reg) & 0x80) >> 7
}
func (o *LEDC_Type) SetINT_RAW_DUTY_CHNG_END_LSCH4_INT_RAW(value uint32) {
	volatile.StoreUint32(&o.INT_RAW.Reg, volatile.LoadUint32(&o.INT_RAW.Reg)&^(0x100)|value<<8)
}
func (o *LEDC_Type) GetINT_RAW_DUTY_CHNG_END_LSCH4_INT_RAW() uint32 {
	return (volatile.LoadUint32(&o.INT_RAW.Reg) & 0x100) >> 8
}
func (o *LEDC_Type) SetINT_RAW_DUTY_CHNG_END_LSCH5_INT_RAW(value uint32) {
	volatile.StoreUint32(&o.INT_RAW.Reg, volatile.LoadUint32(&o.INT_RAW.Reg)&^(0x200)|value<<9)
}
func (o *LEDC_Type) GetINT_RAW_DUTY_CHNG_END_LSCH5_INT_RAW() uint32 {
	return (volatile.LoadUint32(&o.INT_RAW.Reg) & 0x200) >> 9
}
func (o *LEDC_Type) SetINT_RAW_OVF_CNT_LSCH0_INT_RAW(value uint32) {
	volatile.StoreUint32(&o.INT_RAW.Reg, volatile.LoadUint32(&o.INT_RAW.Reg)&^(0x400)|value<<10)
}
func (o *LEDC_Type) GetINT_RAW_OVF_CNT_LSCH0_INT_RAW() uint32 {
	return (volatile.LoadUint32(&o.INT_RAW.Reg) & 0x400) >> 10
}
func (o *LEDC_Type) SetINT_RAW_OVF_CNT_LSCH1_INT_RAW(value uint32) {
	volatile.StoreUint32(&o.INT_RAW.Reg, volatile.LoadUint32(&o.INT_RAW.Reg)&^(0x800)|value<<11)
}
func (o *LEDC_Type) GetINT_RAW_OVF_CNT_LSCH1_INT_RAW() uint32 {
	return (volatile.LoadUint32(&o.INT_RAW.Reg) & 0x800) >> 11
}
func (o *LEDC_Type) SetINT_RAW_OVF_CNT_LSCH2_INT_RAW(value uint32) {
	volatile.StoreUint32(&o.INT_RAW.Reg, volatile.LoadUint32(&o.INT_RAW.Reg)&^(0x1000)|value<<12)
}
func (o *LEDC_Type) GetINT_RAW_OVF_CNT_LSCH2_INT_RAW() uint32 {
	return (volatile.LoadUint32(&o.INT_RAW.Reg) & 0x1000) >> 12
}
func (o *LEDC_Type) SetINT_RAW_OVF_CNT_LSCH3_INT_RAW(value uint32) {
	volatile.StoreUint32(&o.INT_RAW.Reg, volatile.LoadUint32(&o.INT_RAW.Reg)&^(0x2000)|value<<13)
}
func (o *LEDC_Type) GetINT_RAW_OVF_CNT_LSCH3_INT_RAW() uint32 {
	return (volatile.LoadUint32(&o.INT_RAW.Reg) & 0x2000) >> 13
}
func (o *LEDC_Type) SetINT_RAW_OVF_CNT_LSCH4_INT_RAW(value uint32) {
	volatile.StoreUint32(&o.INT_RAW.Reg, volatile.LoadUint32(&o.INT_RAW.Reg)&^(0x4000)|value<<14)
}
func (o *LEDC_Type) GetINT_RAW_OVF_CNT_LSCH4_INT_RAW() uint32 {
	return (volatile.LoadUint32(&o.INT_RAW.Reg) & 0x4000) >> 14
}
func (o *LEDC_Type) SetINT_RAW_OVF_CNT_LSCH5_INT_RAW(value uint32) {
	volatile.StoreUint32(&o.INT_RAW.Reg, volatile.LoadUint32(&o.INT_RAW.Reg)&^(0x8000)|value<<15)
}
func (o *LEDC_Type) GetINT_RAW_OVF_CNT_LSCH5_INT_RAW() uint32 {
	return (volatile.LoadUint32(&o.INT_RAW.Reg) & 0x8000) >> 15
}

// LEDC.INT_ST: LEDC_INT_ST.
func (o *LEDC_Type) SetINT_ST_LSTIMER0_OVF_INT_ST(value uint32) {
	volatile.StoreUint32(&o.INT_ST.Reg, volatile.LoadUint32(&o.INT_ST.Reg)&^(0x1)|value)
}
func (o *LEDC_Type) GetINT_ST_LSTIMER0_OVF_INT_ST() uint32 {
	return volatile.LoadUint32(&o.INT_ST.Reg) & 0x1
}
func (o *LEDC_Type) SetINT_ST_LSTIMER1_OVF_INT_ST(value uint32) {
	volatile.StoreUint32(&o.INT_ST.Reg, volatile.LoadUint32(&o.INT_ST.Reg)&^(0x2)|value<<1)
}
func (o *LEDC_Type) GetINT_ST_LSTIMER1_OVF_INT_ST() uint32 {
	return (volatile.LoadUint32(&o.INT_ST.Reg) & 0x2) >> 1
}
func (o *LEDC_Type) SetINT_ST_LSTIMER2_OVF_INT_ST(value uint32) {
	volatile.StoreUint32(&o.INT_ST.Reg, volatile.LoadUint32(&o.INT_ST.Reg)&^(0x4)|value<<2)
}
func (o *LEDC_Type) GetINT_ST_LSTIMER2_OVF_INT_ST() uint32 {
	return (volatile.LoadUint32(&o.INT_ST.Reg) & 0x4) >> 2
}
func (o *LEDC_Type) SetINT_ST_LSTIMER3_OVF_INT_ST(value uint32) {
	volatile.StoreUint32(&o.INT_ST.Reg, volatile.LoadUint32(&o.INT_ST.Reg)&^(0x8)|value<<3)
}
func (o *LEDC_Type) GetINT_ST_LSTIMER3_OVF_INT_ST() uint32 {
	return (volatile.LoadUint32(&o.INT_ST.Reg) & 0x8) >> 3
}
func (o *LEDC_Type) SetINT_ST_DUTY_CHNG_END_LSCH0_INT_ST(value uint32) {
	volatile.StoreUint32(&o.INT_ST.Reg, volatile.LoadUint32(&o.INT_ST.Reg)&^(0x10)|value<<4)
}
func (o *LEDC_Type) GetINT_ST_DUTY_CHNG_END_LSCH0_INT_ST() uint32 {
	return (volatile.LoadUint32(&o.INT_ST.Reg) & 0x10) >> 4
}
func (o *LEDC_Type) SetINT_ST_DUTY_CHNG_END_LSCH1_INT_ST(value uint32) {
	volatile.StoreUint32(&o.INT_ST.Reg, volatile.LoadUint32(&o.INT_ST.Reg)&^(0x20)|value<<5)
}
func (o *LEDC_Type) GetINT_ST_DUTY_CHNG_END_LSCH1_INT_ST() uint32 {
	return (volatile.LoadUint32(&o.INT_ST.Reg) & 0x20) >> 5
}
func (o *LEDC_Type) SetINT_ST_DUTY_CHNG_END_LSCH2_INT_ST(value uint32) {
	volatile.StoreUint32(&o.INT_ST.Reg, volatile.LoadUint32(&o.INT_ST.Reg)&^(0x40)|value<<6)
}
func (o *LEDC_Type) GetINT_ST_DUTY_CHNG_END_LSCH2_INT_ST() uint32 {
	return (volatile.LoadUint32(&o.INT_ST.Reg) & 0x40) >> 6
}
func (o *LEDC_Type) SetINT_ST_DUTY_CHNG_END_LSCH3_INT_ST(value uint32) {
	volatile.StoreUint32(&o.INT_ST.Reg, volatile.LoadUint32(&o.INT_ST.Reg)&^(0x80)|value<<7)
}
func (o *LEDC_Type) GetINT_ST_DUTY_CHNG_END_LSCH3_INT_ST() uint32 {
	return (volatile.LoadUint32(&o.INT_ST.Reg) & 0x80) >> 7
}
func (o *LEDC_Type) SetINT_ST_DUTY_CHNG_END_LSCH4_INT_ST(value uint32) {
	volatile.StoreUint32(&o.INT_ST.Reg, volatile.LoadUint32(&o.INT_ST.Reg)&^(0x100)|value<<8)
}
func (o *LEDC_Type) GetINT_ST_DUTY_CHNG_END_LSCH4_INT_ST() uint32 {
	return (volatile.LoadUint32(&o.INT_ST.Reg) & 0x100) >> 8
}
func (o *LEDC_Type) SetINT_ST_DUTY_CHNG_END_LSCH5_INT_ST(value uint32) {
	volatile.StoreUint32(&o.INT_ST.Reg, volatile.LoadUint32(&o.INT_ST.Reg)&^(0x200)|value<<9)
}
func (o *LEDC_Type) GetINT_ST_DUTY_CHNG_END_LSCH5_INT_ST() uint32 {
	return (volatile.LoadUint32(&o.INT_ST.Reg) & 0x200) >> 9
}
func (o *LEDC_Type) SetINT_ST_OVF_CNT_LSCH0_INT_ST(value uint32) {
	volatile.StoreUint32(&o.INT_ST.Reg, volatile.LoadUint32(&o.INT_ST.Reg)&^(0x400)|value<<10)
}
func (o *LEDC_Type) GetINT_ST_OVF_CNT_LSCH0_INT_ST() uint32 {
	return (volatile.LoadUint32(&o.INT_ST.Reg) & 0x400) >> 10
}
func (o *LEDC_Type) SetINT_ST_OVF_CNT_LSCH1_INT_ST(value uint32) {
	volatile.StoreUint32(&o.INT_ST.Reg, volatile.LoadUint32(&o.INT_ST.Reg)&^(0x800)|value<<11)
}
func (o *LEDC_Type) GetINT_ST_OVF_CNT_LSCH1_INT_ST() uint32 {
	return (volatile.LoadUint32(&o.INT_ST.Reg) & 0x800) >> 11
}
func (o *LEDC_Type) SetINT_ST_OVF_CNT_LSCH2_INT_ST(value uint32) {
	volatile.StoreUint32(&o.INT_ST.Reg, volatile.LoadUint32(&o.INT_ST.Reg)&^(0x1000)|value<<12)
}
func (o *LEDC_Type) GetINT_ST_OVF_CNT_LSCH2_INT_ST() uint32 {
	return (volatile.LoadUint32(&o.INT_ST.Reg) & 0x1000) >> 12
}
func (o *LEDC_Type) SetINT_ST_OVF_CNT_LSCH3_INT_ST(value uint32) {
	volatile.StoreUint32(&o.INT_ST.Reg, volatile.LoadUint32(&o.INT_ST.Reg)&^(0x2000)|value<<13)
}
func (o *LEDC_Type) GetINT_ST_OVF_CNT_LSCH3_INT_ST() uint32 {
	return (volatile.LoadUint32(&o.INT_ST.Reg) & 0x2000) >> 13
}
func (o *LEDC_Type) SetINT_ST_OVF_CNT_LSCH4_INT_ST(value uint32) {
	volatile.StoreUint32(&o.INT_ST.Reg, volatile.LoadUint32(&o.INT_ST.Reg)&^(0x4000)|value<<14)
}
func (o *LEDC_Type) GetINT_ST_OVF_CNT_LSCH4_INT_ST() uint32 {
	return (volatile.LoadUint32(&o.INT_ST.Reg) & 0x4000) >> 14
}
func (o *LEDC_Type) SetINT_ST_OVF_CNT_LSCH5_INT_ST(value uint32) {
	volatile.StoreUint32(&o.INT_ST.Reg, volatile.LoadUint32(&o.INT_ST.Reg)&^(0x8000)|value<<15)
}
func (o *LEDC_Type) GetINT_ST_OVF_CNT_LSCH5_INT_ST() uint32 {
	return (volatile.LoadUint32(&o.INT_ST.Reg) & 0x8000) >> 15
}

// LEDC.INT_ENA: LEDC_INT_ENA.
func (o *LEDC_Type) SetINT_ENA_LSTIMER0_OVF_INT_ENA(value uint32) {
	volatile.StoreUint32(&o.INT_ENA.Reg, volatile.LoadUint32(&o.INT_ENA.Reg)&^(0x1)|value)
}
func (o *LEDC_Type) GetINT_ENA_LSTIMER0_OVF_INT_ENA() uint32 {
	return volatile.LoadUint32(&o.INT_ENA.Reg) & 0x1
}
func (o *LEDC_Type) SetINT_ENA_LSTIMER1_OVF_INT_ENA(value uint32) {
	volatile.StoreUint32(&o.INT_ENA.Reg, volatile.LoadUint32(&o.INT_ENA.Reg)&^(0x2)|value<<1)
}
func (o *LEDC_Type) GetINT_ENA_LSTIMER1_OVF_INT_ENA() uint32 {
	return (volatile.LoadUint32(&o.INT_ENA.Reg) & 0x2) >> 1
}
func (o *LEDC_Type) SetINT_ENA_LSTIMER2_OVF_INT_ENA(value uint32) {
	volatile.StoreUint32(&o.INT_ENA.Reg, volatile.LoadUint32(&o.INT_ENA.Reg)&^(0x4)|value<<2)
}
func (o *LEDC_Type) GetINT_ENA_LSTIMER2_OVF_INT_ENA() uint32 {
	return (volatile.LoadUint32(&o.INT_ENA.Reg) & 0x4) >> 2
}
func (o *LEDC_Type) SetINT_ENA_LSTIMER3_OVF_INT_ENA(value uint32) {
	volatile.StoreUint32(&o.INT_ENA.Reg, volatile.LoadUint32(&o.INT_ENA.Reg)&^(0x8)|value<<3)
}
func (o *LEDC_Type) GetINT_ENA_LSTIMER3_OVF_INT_ENA() uint32 {
	return (volatile.LoadUint32(&o.INT_ENA.Reg) & 0x8) >> 3
}
func (o *LEDC_Type) SetINT_ENA_DUTY_CHNG_END_LSCH0_INT_ENA(value uint32) {
	volatile.StoreUint32(&o.INT_ENA.Reg, volatile.LoadUint32(&o.INT_ENA.Reg)&^(0x10)|value<<4)
}
func (o *LEDC_Type) GetINT_ENA_DUTY_CHNG_END_LSCH0_INT_ENA() uint32 {
	return (volatile.LoadUint32(&o.INT_ENA.Reg) & 0x10) >> 4
}
func (o *LEDC_Type) SetINT_ENA_DUTY_CHNG_END_LSCH1_INT_ENA(value uint32) {
	volatile.StoreUint32(&o.INT_ENA.Reg, volatile.LoadUint32(&o.INT_ENA.Reg)&^(0x20)|value<<5)
}
func (o *LEDC_Type) GetINT_ENA_DUTY_CHNG_END_LSCH1_INT_ENA() uint32 {
	return (volatile.LoadUint32(&o.INT_ENA.Reg) & 0x20) >> 5
}
func (o *LEDC_Type) SetINT_ENA_DUTY_CHNG_END_LSCH2_INT_ENA(value uint32) {
	volatile.StoreUint32(&o.INT_ENA.Reg, volatile.LoadUint32(&o.INT_ENA.Reg)&^(0x40)|value<<6)
}
func (o *LEDC_Type) GetINT_ENA_DUTY_CHNG_END_LSCH2_INT_ENA() uint32 {
	return (volatile.LoadUint32(&o.INT_ENA.Reg) & 0x40) >> 6
}
func (o *LEDC_Type) SetINT_ENA_DUTY_CHNG_END_LSCH3_INT_ENA(value uint32) {
	volatile.StoreUint32(&o.INT_ENA.Reg, volatile.LoadUint32(&o.INT_ENA.Reg)&^(0x80)|value<<7)
}
func (o *LEDC_Type) GetINT_ENA_DUTY_CHNG_END_LSCH3_INT_ENA() uint32 {
	return (volatile.LoadUint32(&o.INT_ENA.Reg) & 0x80) >> 7
}
func (o *LEDC_Type) SetINT_ENA_DUTY_CHNG_END_LSCH4_INT_ENA(value uint32) {
	volatile.StoreUint32(&o.INT_ENA.Reg, volatile.LoadUint32(&o.INT_ENA.Reg)&^(0x100)|value<<8)
}
func (o *LEDC_Type) GetINT_ENA_DUTY_CHNG_END_LSCH4_INT_ENA() uint32 {
	return (volatile.LoadUint32(&o.INT_ENA.Reg) & 0x100) >> 8
}
func (o *LEDC_Type) SetINT_ENA_DUTY_CHNG_END_LSCH5_INT_ENA(value uint32) {
	volatile.StoreUint32(&o.INT_ENA.Reg, volatile.LoadUint32(&o.INT_ENA.Reg)&^(0x200)|value<<9)
}
func (o *LEDC_Type) GetINT_ENA_DUTY_CHNG_END_LSCH5_INT_ENA() uint32 {
	return (volatile.LoadUint32(&o.INT_ENA.Reg) & 0x200) >> 9
}
func (o *LEDC_Type) SetINT_ENA_OVF_CNT_LSCH0_INT_ENA(value uint32) {
	volatile.StoreUint32(&o.INT_ENA.Reg, volatile.LoadUint32(&o.INT_ENA.Reg)&^(0x400)|value<<10)
}
func (o *LEDC_Type) GetINT_ENA_OVF_CNT_LSCH0_INT_ENA() uint32 {
	return (volatile.LoadUint32(&o.INT_ENA.Reg) & 0x400) >> 10
}
func (o *LEDC_Type) SetINT_ENA_OVF_CNT_LSCH1_INT_ENA(value uint32) {
	volatile.StoreUint32(&o.INT_ENA.Reg, volatile.LoadUint32(&o.INT_ENA.Reg)&^(0x800)|value<<11)
}
func (o *LEDC_Type) GetINT_ENA_OVF_CNT_LSCH1_INT_ENA() uint32 {
	return (volatile.LoadUint32(&o.INT_ENA.Reg) & 0x800) >> 11
}
func (o *LEDC_Type) SetINT_ENA_OVF_CNT_LSCH2_INT_ENA(value uint32) {
	volatile.StoreUint32(&o.INT_ENA.Reg, volatile.LoadUint32(&o.INT_ENA.Reg)&^(0x1000)|value<<12)
}
func (o *LEDC_Type) GetINT_ENA_OVF_CNT_LSCH2_INT_ENA() uint32 {
	return (volatile.LoadUint32(&o.INT_ENA.Reg) & 0x1000) >> 12
}
func (o *LEDC_Type) SetINT_ENA_OVF_CNT_LSCH3_INT_ENA(value uint32) {
	volatile.StoreUint32(&o.INT_ENA.Reg, volatile.LoadUint32(&o.INT_ENA.Reg)&^(0x2000)|value<<13)
}
func (o *LEDC_Type) GetINT_ENA_OVF_CNT_LSCH3_INT_ENA() uint32 {
	return (volatile.LoadUint32(&o.INT_ENA.Reg) & 0x2000) >> 13
}
func (o *LEDC_Type) SetINT_ENA_OVF_CNT_LSCH4_INT_ENA(value uint32) {
	volatile.StoreUint32(&o.INT_ENA.Reg, volatile.LoadUint32(&o.INT_ENA.Reg)&^(0x4000)|value<<14)
}
func (o *LEDC_Type) GetINT_ENA_OVF_CNT_LSCH4_INT_ENA() uint32 {
	return (volatile.LoadUint32(&o.INT_ENA.Reg) & 0x4000) >> 14
}
func (o *LEDC_Type) SetINT_ENA_OVF_CNT_LSCH5_INT_ENA(value uint32) {
	volatile.StoreUint32(&o.INT_ENA.Reg, volatile.LoadUint32(&o.INT_ENA.Reg)&^(0x8000)|value<<15)
}
func (o *LEDC_Type) GetINT_ENA_OVF_CNT_LSCH5_INT_ENA() uint32 {
	return (volatile.LoadUint32(&o.INT_ENA.Reg) & 0x8000) >> 15
}

// LEDC.INT_CLR: LEDC_INT_CLR.
func (o *LEDC_Type) SetINT_CLR_LSTIMER0_OVF_INT_CLR(value uint32) {
	volatile.StoreUint32(&o.INT_CLR.Reg, volatile.LoadUint32(&o.INT_CLR.Reg)&^(0x1)|value)
}
func (o *LEDC_Type) GetINT_CLR_LSTIMER0_OVF_INT_CLR() uint32 {
	return volatile.LoadUint32(&o.INT_CLR.Reg) & 0x1
}
func (o *LEDC_Type) SetINT_CLR_LSTIMER1_OVF_INT_CLR(value uint32) {
	volatile.StoreUint32(&o.INT_CLR.Reg, volatile.LoadUint32(&o.INT_CLR.Reg)&^(0x2)|value<<1)
}
func (o *LEDC_Type) GetINT_CLR_LSTIMER1_OVF_INT_CLR() uint32 {
	return (volatile.LoadUint32(&o.INT_CLR.Reg) & 0x2) >> 1
}
func (o *LEDC_Type) SetINT_CLR_LSTIMER2_OVF_INT_CLR(value uint32) {
	volatile.StoreUint32(&o.INT_CLR.Reg, volatile.LoadUint32(&o.INT_CLR.Reg)&^(0x4)|value<<2)
}
func (o *LEDC_Type) GetINT_CLR_LSTIMER2_OVF_INT_CLR() uint32 {
	return (volatile.LoadUint32(&o.INT_CLR.Reg) & 0x4) >> 2
}
func (o *LEDC_Type) SetINT_CLR_LSTIMER3_OVF_INT_CLR(value uint32) {
	volatile.StoreUint32(&o.INT_CLR.Reg, volatile.LoadUint32(&o.INT_CLR.Reg)&^(0x8)|value<<3)
}
func (o *LEDC_Type) GetINT_CLR_LSTIMER3_OVF_INT_CLR() uint32 {
	return (volatile.LoadUint32(&o.INT_CLR.Reg) & 0x8) >> 3
}
func (o *LEDC_Type) SetINT_CLR_DUTY_CHNG_END_LSCH0_INT_CLR(value uint32) {
	volatile.StoreUint32(&o.INT_CLR.Reg, volatile.LoadUint32(&o.INT_CLR.Reg)&^(0x10)|value<<4)
}
func (o *LEDC_Type) GetINT_CLR_DUTY_CHNG_END_LSCH0_INT_CLR() uint32 {
	return (volatile.LoadUint32(&o.INT_CLR.Reg) & 0x10) >> 4
}
func (o *LEDC_Type) SetINT_CLR_DUTY_CHNG_END_LSCH1_INT_CLR(value uint32) {
	volatile.StoreUint32(&o.INT_CLR.Reg, volatile.LoadUint32(&o.INT_CLR.Reg)&^(0x20)|value<<5)
}
func (o *LEDC_Type) GetINT_CLR_DUTY_CHNG_END_LSCH1_INT_CLR() uint32 {
	return (volatile.LoadUint32(&o.INT_CLR.Reg) & 0x20) >> 5
}
func (o *LEDC_Type) SetINT_CLR_DUTY_CHNG_END_LSCH2_INT_CLR(value uint32) {
	volatile.StoreUint32(&o.INT_CLR.Reg, volatile.LoadUint32(&o.INT_CLR.Reg)&^(0x40)|value<<6)
}
func (o *LEDC_Type) GetINT_CLR_DUTY_CHNG_END_LSCH2_INT_CLR() uint32 {
	return (volatile.LoadUint32(&o.INT_CLR.Reg) & 0x40) >> 6
}
func (o *LEDC_Type) SetINT_CLR_DUTY_CHNG_END_LSCH3_INT_CLR(value uint32) {
	volatile.StoreUint32(&o.INT_CLR.Reg, volatile.LoadUint32(&o.INT_CLR.Reg)&^(0x80)|value<<7)
}
func (o *LEDC_Type) GetINT_CLR_DUTY_CHNG_END_LSCH3_INT_CLR() uint32 {
	return (volatile.LoadUint32(&o.INT_CLR.Reg) & 0x80) >> 7
}
func (o *LEDC_Type) SetINT_CLR_DUTY_CHNG_END_LSCH4_INT_CLR(value uint32) {
	volatile.StoreUint32(&o.INT_CLR.Reg, volatile.LoadUint32(&o.INT_CLR.Reg)&^(0x100)|value<<8)
}
func (o *LEDC_Type) GetINT_CLR_DUTY_CHNG_END_LSCH4_INT_CLR() uint32 {
	return (volatile.LoadUint32(&o.INT_CLR.Reg) & 0x100) >> 8
}
func (o *LEDC_Type) SetINT_CLR_DUTY_CHNG_END_LSCH5_INT_CLR(value uint32) {
	volatile.StoreUint32(&o.INT_CLR.Reg, volatile.LoadUint32(&o.INT_CLR.Reg)&^(0x200)|value<<9)
}
func (o *LEDC_Type) GetINT_CLR_DUTY_CHNG_END_LSCH5_INT_CLR() uint32 {
	return (volatile.LoadUint32(&o.INT_CLR.Reg) & 0x200) >> 9
}
func (o *LEDC_Type) SetINT_CLR_OVF_CNT_LSCH0_INT_CLR(value uint32) {
	volatile.StoreUint32(&o.INT_CLR.Reg, volatile.LoadUint32(&o.INT_CLR.Reg)&^(0x400)|value<<10)
}
func (o *LEDC_Type) GetINT_CLR_OVF_CNT_LSCH0_INT_CLR() uint32 {
	return (volatile.LoadUint32(&o.INT_CLR.Reg) & 0x400) >> 10
}
func (o *LEDC_Type) SetINT_CLR_OVF_CNT_LSCH1_INT_CLR(value uint32) {
	volatile.StoreUint32(&o.INT_CLR.Reg, volatile.LoadUint32(&o.INT_CLR.Reg)&^(0x800)|value<<11)
}
func (o *LEDC_Type) GetINT_CLR_OVF_CNT_LSCH1_INT_CLR() uint32 {
	return (volatile.LoadUint32(&o.INT_CLR.Reg) & 0x800) >> 11
}
func (o *LEDC_Type) SetINT_CLR_OVF_CNT_LSCH2_INT_CLR(value uint32) {
	volatile.StoreUint32(&o.INT_CLR.Reg, volatile.LoadUint32(&o.INT_CLR.Reg)&^(0x1000)|value<<12)
}
func (o *LEDC_Type) GetINT_CLR_OVF_CNT_LSCH2_INT_CLR() uint32 {
	return (volatile.LoadUint32(&o.INT_CLR.Reg) & 0x1000) >> 12
}
func (o *LEDC_Type) SetINT_CLR_OVF_CNT_LSCH3_INT_CLR(value uint32) {
	volatile.StoreUint32(&o.INT_CLR.Reg, volatile.LoadUint32(&o.INT_CLR.Reg)&^(0x2000)|value<<13)
}
func (o *LEDC_Type) GetINT_CLR_OVF_CNT_LSCH3_INT_CLR() uint32 {
	return (volatile.LoadUint32(&o.INT_CLR.Reg) & 0x2000) >> 13
}
func (o *LEDC_Type) SetINT_CLR_OVF_CNT_LSCH4_INT_CLR(value uint32) {
	volatile.StoreUint32(&o.INT_CLR.Reg, volatile.LoadUint32(&o.INT_CLR.Reg)&^(0x4000)|value<<14)
}
func (o *LEDC_Type) GetINT_CLR_OVF_CNT_LSCH4_INT_CLR() uint32 {
	return (volatile.LoadUint32(&o.INT_CLR.Reg) & 0x4000) >> 14
}
func (o *LEDC_Type) SetINT_CLR_OVF_CNT_LSCH5_INT_CLR(value uint32) {
	volatile.StoreUint32(&o.INT_CLR.Reg, volatile.LoadUint32(&o.INT_CLR.Reg)&^(0x8000)|value<<15)
}
func (o *LEDC_Type) GetINT_CLR_OVF_CNT_LSCH5_INT_CLR() uint32 {
	return (volatile.LoadUint32(&o.INT_CLR.Reg) & 0x8000) >> 15
}

// LEDC.CONF: LEDC_CONF.
func (o *LEDC_Type) SetCONF_APB_CLK_SEL(value uint32) {
	volatile.StoreUint32(&o.CONF.Reg, volatile.LoadUint32(&o.CONF.Reg)&^(0x3)|value)
}
func (o *LEDC_Type) GetCONF_APB_CLK_SEL() uint32 {
	return volatile.LoadUint32(&o.CONF.Reg) & 0x3
}
func (o *LEDC_Type) SetCONF_CLK_EN(value uint32) {
	volatile.StoreUint32(&o.CONF.Reg, volatile.LoadUint32(&o.CONF.Reg)&^(0x80000000)|value<<31)
}
func (o *LEDC_Type) GetCONF_CLK_EN() uint32 {
	return (volatile.LoadUint32(&o.CONF.Reg) & 0x80000000) >> 31
}

// LEDC.DATE: LEDC_DATE.
func (o *LEDC_Type) SetDATE(value uint32) {
	volatile.StoreUint32(&o.DATE.Reg, value)
}
func (o *LEDC_Type) GetDATE() uint32 {
	return volatile.LoadUint32(&o.DATE.Reg)
}

// Peripheral RMT
type RMT_Type struct {
	CH0DATA           volatile.Register32 // 0x0
	CH1DATA           volatile.Register32 // 0x4
	CH2DATA           volatile.Register32 // 0x8
	CH3DATA           volatile.Register32 // 0xC
	CH0CONF0          volatile.Register32 // 0x10
	CH1CONF0          volatile.Register32 // 0x14
	CH2CONF0          volatile.Register32 // 0x18
	CH2CONF1          volatile.Register32 // 0x1C
	CH3CONF0          volatile.Register32 // 0x20
	CH3CONF1          volatile.Register32 // 0x24
	CH0STATUS         volatile.Register32 // 0x28
	CH1STATUS         volatile.Register32 // 0x2C
	CH2STATUS         volatile.Register32 // 0x30
	CH3STATUS         volatile.Register32 // 0x34
	INT_RAW           volatile.Register32 // 0x38
	INT_ST            volatile.Register32 // 0x3C
	INT_ENA           volatile.Register32 // 0x40
	INT_CLR           volatile.Register32 // 0x44
	CH0CARRIER_DUTY   volatile.Register32 // 0x48
	CH1CARRIER_DUTY   volatile.Register32 // 0x4C
	CH2_RX_CARRIER_RM volatile.Register32 // 0x50
	CH3_RX_CARRIER_RM volatile.Register32 // 0x54
	CH0_TX_LIM        volatile.Register32 // 0x58
	CH1_TX_LIM        volatile.Register32 // 0x5C
	CH2_RX_LIM        volatile.Register32 // 0x60
	CH3_RX_LIM        volatile.Register32 // 0x64
	SYS_CONF          volatile.Register32 // 0x68
	TX_SIM            volatile.Register32 // 0x6C
	REF_CNT_RST       volatile.Register32 // 0x70
	_                 [88]byte
	DATE              volatile.Register32 // 0xCC
}

// RMT.CH0DATA: RMT_CH0DATA_REG.
func (o *RMT_Type) SetCH0DATA(value uint32) {
	volatile.StoreUint32(&o.CH0DATA.Reg, value)
}
func (o *RMT_Type) GetCH0DATA() uint32 {
	return volatile.LoadUint32(&o.CH0DATA.Reg)
}

// RMT.CH1DATA: RMT_CH1DATA_REG.
func (o *RMT_Type) SetCH1DATA(value uint32) {
	volatile.StoreUint32(&o.CH1DATA.Reg, value)
}
func (o *RMT_Type) GetCH1DATA() uint32 {
	return volatile.LoadUint32(&o.CH1DATA.Reg)
}

// RMT.CH2DATA: RMT_CH2DATA_REG.
func (o *RMT_Type) SetCH2DATA(value uint32) {
	volatile.StoreUint32(&o.CH2DATA.Reg, value)
}
func (o *RMT_Type) GetCH2DATA() uint32 {
	return volatile.LoadUint32(&o.CH2DATA.Reg)
}

// RMT.CH3DATA: RMT_CH3DATA_REG.
func (o *RMT_Type) SetCH3DATA(value uint32) {
	volatile.StoreUint32(&o.CH3DATA.Reg, value)
}
func (o *RMT_Type) GetCH3DATA() uint32 {
	return volatile.LoadUint32(&o.CH3DATA.Reg)
}

// RMT.CH0CONF0: RMT_CH0CONF0_REG.
func (o *RMT_Type) SetCH0CONF0_TX_START_CH0(value uint32) {
	volatile.StoreUint32(&o.CH0CONF0.Reg, volatile.LoadUint32(&o.CH0CONF0.Reg)&^(0x1)|value)
}
func (o *RMT_Type) GetCH0CONF0_TX_START_CH0() uint32 {
	return volatile.LoadUint32(&o.CH0CONF0.Reg) & 0x1
}
func (o *RMT_Type) SetCH0CONF0_MEM_RD_RST_CH0(value uint32) {
	volatile.StoreUint32(&o.CH0CONF0.Reg, volatile.LoadUint32(&o.CH0CONF0.Reg)&^(0x2)|value<<1)
}
func (o *RMT_Type) GetCH0CONF0_MEM_RD_RST_CH0() uint32 {
	return (volatile.LoadUint32(&o.CH0CONF0.Reg) & 0x2) >> 1
}
func (o *RMT_Type) SetCH0CONF0_APB_MEM_RST_CH0(value uint32) {
	volatile.StoreUint32(&o.CH0CONF0.Reg, volatile.LoadUint32(&o.CH0CONF0.Reg)&^(0x4)|value<<2)
}
func (o *RMT_Type) GetCH0CONF0_APB_MEM_RST_CH0() uint32 {
	return (volatile.LoadUint32(&o.CH0CONF0.Reg) & 0x4) >> 2
}
func (o *RMT_Type) SetCH0CONF0_TX_CONTI_MODE_CH0(value uint32) {
	volatile.StoreUint32(&o.CH0CONF0.Reg, volatile.LoadUint32(&o.CH0CONF0.Reg)&^(0x8)|value<<3)
}
func (o *RMT_Type) GetCH0CONF0_TX_CONTI_MODE_CH0() uint32 {
	return (volatile.LoadUint32(&o.CH0CONF0.Reg) & 0x8) >> 3
}
func (o *RMT_Type) SetCH0CONF0_MEM_TX_WRAP_EN_CH0(value uint32) {
	volatile.StoreUint32(&o.CH0CONF0.Reg, volatile.LoadUint32(&o.CH0CONF0.Reg)&^(0x10)|value<<4)
}
func (o *RMT_Type) GetCH0CONF0_MEM_TX_WRAP_EN_CH0() uint32 {
	return (volatile.LoadUint32(&o.CH0CONF0.Reg) & 0x10) >> 4
}
func (o *RMT_Type) SetCH0CONF0_IDLE_OUT_LV_CH0(value uint32) {
	volatile.StoreUint32(&o.CH0CONF0.Reg, volatile.LoadUint32(&o.CH0CONF0.Reg)&^(0x20)|value<<5)
}
func (o *RMT_Type) GetCH0CONF0_IDLE_OUT_LV_CH0() uint32 {
	return (volatile.LoadUint32(&o.CH0CONF0.Reg) & 0x20) >> 5
}
func (o *RMT_Type) SetCH0CONF0_IDLE_OUT_EN_CH0(value uint32) {
	volatile.StoreUint32(&o.CH0CONF0.Reg, volatile.LoadUint32(&o.CH0CONF0.Reg)&^(0x40)|value<<6)
}
func (o *RMT_Type) GetCH0CONF0_IDLE_OUT_EN_CH0() uint32 {
	return (volatile.LoadUint32(&o.CH0CONF0.Reg) & 0x40) >> 6
}
func (o *RMT_Type) SetCH0CONF0_TX_STOP_CH0(value uint32) {
	volatile.StoreUint32(&o.CH0CONF0.Reg, volatile.LoadUint32(&o.CH0CONF0.Reg)&^(0x80)|value<<7)
}
func (o *RMT_Type) GetCH0CONF0_TX_STOP_CH0() uint32 {
	return (volatile.LoadUint32(&o.CH0CONF0.Reg) & 0x80) >> 7
}
func (o *RMT_Type) SetCH0CONF0_DIV_CNT_CH0(value uint32) {
	volatile.StoreUint32(&o.CH0CONF0.Reg, volatile.LoadUint32(&o.CH0CONF0.Reg)&^(0xff00)|value<<8)
}
func (o *RMT_Type) GetCH0CONF0_DIV_CNT_CH0() uint32 {
	return (volatile.LoadUint32(&o.CH0CONF0.Reg) & 0xff00) >> 8
}
func (o *RMT_Type) SetCH0CONF0_MEM_SIZE_CH0(value uint32) {
	volatile.StoreUint32(&o.CH0CONF0.Reg, volatile.LoadUint32(&o.CH0CONF0.Reg)&^(0x70000)|value<<16)
}
func (o *RMT_Type) GetCH0CONF0_MEM_SIZE_CH0() uint32 {
	return (volatile.LoadUint32(&o.CH0CONF0.Reg) & 0x70000) >> 16
}
func (o *RMT_Type) SetCH0CONF0_CARRIER_EFF_EN_CH0(value uint32) {
	volatile.StoreUint32(&o.CH0CONF0.Reg, volatile.LoadUint32(&o.CH0CONF0.Reg)&^(0x100000)|value<<20)
}
func (o *RMT_Type) GetCH0CONF0_CARRIER_EFF_EN_CH0() uint32 {
	return (volatile.LoadUint32(&o.CH0CONF0.Reg) & 0x100000) >> 20
}
func (o *RMT_Type) SetCH0CONF0_CARRIER_EN_CH0(value uint32) {
	volatile.StoreUint32(&o.CH0CONF0.Reg, volatile.LoadUint32(&o.CH0CONF0.Reg)&^(0x200000)|value<<21)
}
func (o *RMT_Type) GetCH0CONF0_CARRIER_EN_CH0() uint32 {
	return (volatile.LoadUint32(&o.CH0CONF0.Reg) & 0x200000) >> 21
}
func (o *RMT_Type) SetCH0CONF0_CARRIER_OUT_LV_CH0(value uint32) {
	volatile.StoreUint32(&o.CH0CONF0.Reg, volatile.LoadUint32(&o.CH0CONF0.Reg)&^(0x400000)|value<<22)
}
func (o *RMT_Type) GetCH0CONF0_CARRIER_OUT_LV_CH0() uint32 {
	return (volatile.LoadUint32(&o.CH0CONF0.Reg) & 0x400000) >> 22
}
func (o *RMT_Type) SetCH0CONF0_AFIFO_RST_CH0(value uint32) {
	volatile.StoreUint32(&o.CH0CONF0.Reg, volatile.LoadUint32(&o.CH0CONF0.Reg)&^(0x800000)|value<<23)
}
func (o *RMT_Type) GetCH0CONF0_AFIFO_RST_CH0() uint32 {
	return (volatile.LoadUint32(&o.CH0CONF0.Reg) & 0x800000) >> 23
}
func (o *RMT_Type) SetCH0CONF0_REG_CONF_UPDATE_CH0(value uint32) {
	volatile.StoreUint32(&o.CH0CONF0.Reg, volatile.LoadUint32(&o.CH0CONF0.Reg)&^(0x1000000)|value<<24)
}
func (o *RMT_Type) GetCH0CONF0_REG_CONF_UPDATE_CH0() uint32 {
	return (volatile.LoadUint32(&o.CH0CONF0.Reg) & 0x1000000) >> 24
}

// RMT.CH1CONF0: RMT_CH1CONF0_REG.
func (o *RMT_Type) SetCH1CONF0_TX_START_CH1(value uint32) {
	volatile.StoreUint32(&o.CH1CONF0.Reg, volatile.LoadUint32(&o.CH1CONF0.Reg)&^(0x1)|value)
}
func (o *RMT_Type) GetCH1CONF0_TX_START_CH1() uint32 {
	return volatile.LoadUint32(&o.CH1CONF0.Reg) & 0x1
}
func (o *RMT_Type) SetCH1CONF0_MEM_RD_RST_CH1(value uint32) {
	volatile.StoreUint32(&o.CH1CONF0.Reg, volatile.LoadUint32(&o.CH1CONF0.Reg)&^(0x2)|value<<1)
}
func (o *RMT_Type) GetCH1CONF0_MEM_RD_RST_CH1() uint32 {
	return (volatile.LoadUint32(&o.CH1CONF0.Reg) & 0x2) >> 1
}
func (o *RMT_Type) SetCH1CONF0_APB_MEM_RST_CH1(value uint32) {
	volatile.StoreUint32(&o.CH1CONF0.Reg, volatile.LoadUint32(&o.CH1CONF0.Reg)&^(0x4)|value<<2)
}
func (o *RMT_Type) GetCH1CONF0_APB_MEM_RST_CH1() uint32 {
	return (volatile.LoadUint32(&o.CH1CONF0.Reg) & 0x4) >> 2
}
func (o *RMT_Type) SetCH1CONF0_TX_CONTI_MODE_CH1(value uint32) {
	volatile.StoreUint32(&o.CH1CONF0.Reg, volatile.LoadUint32(&o.CH1CONF0.Reg)&^(0x8)|value<<3)
}
func (o *RMT_Type) GetCH1CONF0_TX_CONTI_MODE_CH1() uint32 {
	return (volatile.LoadUint32(&o.CH1CONF0.Reg) & 0x8) >> 3
}
func (o *RMT_Type) SetCH1CONF0_MEM_TX_WRAP_EN_CH1(value uint32) {
	volatile.StoreUint32(&o.CH1CONF0.Reg, volatile.LoadUint32(&o.CH1CONF0.Reg)&^(0x10)|value<<4)
}
func (o *RMT_Type) GetCH1CONF0_MEM_TX_WRAP_EN_CH1() uint32 {
	return (volatile.LoadUint32(&o.CH1CONF0.Reg) & 0x10) >> 4
}
func (o *RMT_Type) SetCH1CONF0_IDLE_OUT_LV_CH1(value uint32) {
	volatile.StoreUint32(&o.CH1CONF0.Reg, volatile.LoadUint32(&o.CH1CONF0.Reg)&^(0x20)|value<<5)
}
func (o *RMT_Type) GetCH1CONF0_IDLE_OUT_LV_CH1() uint32 {
	return (volatile.LoadUint32(&o.CH1CONF0.Reg) & 0x20) >> 5
}
func (o *RMT_Type) SetCH1CONF0_IDLE_OUT_EN_CH1(value uint32) {
	volatile.StoreUint32(&o.CH1CONF0.Reg, volatile.LoadUint32(&o.CH1CONF0.Reg)&^(0x40)|value<<6)
}
func (o *RMT_Type) GetCH1CONF0_IDLE_OUT_EN_CH1() uint32 {
	return (volatile.LoadUint32(&o.CH1CONF0.Reg) & 0x40) >> 6
}
func (o *RMT_Type) SetCH1CONF0_TX_STOP_CH1(value uint32) {
	volatile.StoreUint32(&o.CH1CONF0.Reg, volatile.LoadUint32(&o.CH1CONF0.Reg)&^(0x80)|value<<7)
}
func (o *RMT_Type) GetCH1CONF0_TX_STOP_CH1() uint32 {
	return (volatile.LoadUint32(&o.CH1CONF0.Reg) & 0x80) >> 7
}
func (o *RMT_Type) SetCH1CONF0_DIV_CNT_CH1(value uint32) {
	volatile.StoreUint32(&o.CH1CONF0.Reg, volatile.LoadUint32(&o.CH1CONF0.Reg)&^(0xff00)|value<<8)
}
func (o *RMT_Type) GetCH1CONF0_DIV_CNT_CH1() uint32 {
	return (volatile.LoadUint32(&o.CH1CONF0.Reg) & 0xff00) >> 8
}
func (o *RMT_Type) SetCH1CONF0_MEM_SIZE_CH1(value uint32) {
	volatile.StoreUint32(&o.CH1CONF0.Reg, volatile.LoadUint32(&o.CH1CONF0.Reg)&^(0x70000)|value<<16)
}
func (o *RMT_Type) GetCH1CONF0_MEM_SIZE_CH1() uint32 {
	return (volatile.LoadUint32(&o.CH1CONF0.Reg) & 0x70000) >> 16
}
func (o *RMT_Type) SetCH1CONF0_CARRIER_EFF_EN_CH1(value uint32) {
	volatile.StoreUint32(&o.CH1CONF0.Reg, volatile.LoadUint32(&o.CH1CONF0.Reg)&^(0x100000)|value<<20)
}
func (o *RMT_Type) GetCH1CONF0_CARRIER_EFF_EN_CH1() uint32 {
	return (volatile.LoadUint32(&o.CH1CONF0.Reg) & 0x100000) >> 20
}
func (o *RMT_Type) SetCH1CONF0_CARRIER_EN_CH1(value uint32) {
	volatile.StoreUint32(&o.CH1CONF0.Reg, volatile.LoadUint32(&o.CH1CONF0.Reg)&^(0x200000)|value<<21)
}
func (o *RMT_Type) GetCH1CONF0_CARRIER_EN_CH1() uint32 {
	return (volatile.LoadUint32(&o.CH1CONF0.Reg) & 0x200000) >> 21
}
func (o *RMT_Type) SetCH1CONF0_CARRIER_OUT_LV_CH1(value uint32) {
	volatile.StoreUint32(&o.CH1CONF0.Reg, volatile.LoadUint32(&o.CH1CONF0.Reg)&^(0x400000)|value<<22)
}
func (o *RMT_Type) GetCH1CONF0_CARRIER_OUT_LV_CH1() uint32 {
	return (volatile.LoadUint32(&o.CH1CONF0.Reg) & 0x400000) >> 22
}
func (o *RMT_Type) SetCH1CONF0_AFIFO_RST_CH1(value uint32) {
	volatile.StoreUint32(&o.CH1CONF0.Reg, volatile.LoadUint32(&o.CH1CONF0.Reg)&^(0x800000)|value<<23)
}
func (o *RMT_Type) GetCH1CONF0_AFIFO_RST_CH1() uint32 {
	return (volatile.LoadUint32(&o.CH1CONF0.Reg) & 0x800000) >> 23
}
func (o *RMT_Type) SetCH1CONF0_CONF_UPDATE_CH1(value uint32) {
	volatile.StoreUint32(&o.CH1CONF0.Reg, volatile.LoadUint32(&o.CH1CONF0.Reg)&^(0x1000000)|value<<24)
}
func (o *RMT_Type) GetCH1CONF0_CONF_UPDATE_CH1() uint32 {
	return (volatile.LoadUint32(&o.CH1CONF0.Reg) & 0x1000000) >> 24
}

// RMT.CH2CONF0: RMT_CH2CONF0_REG.
func (o *RMT_Type) SetCH2CONF0_DIV_CNT_CH2(value uint32) {
	volatile.StoreUint32(&o.CH2CONF0.Reg, volatile.LoadUint32(&o.CH2CONF0.Reg)&^(0xff)|value)
}
func (o *RMT_Type) GetCH2CONF0_DIV_CNT_CH2() uint32 {
	return volatile.LoadUint32(&o.CH2CONF0.Reg) & 0xff
}
func (o *RMT_Type) SetCH2CONF0_IDLE_THRES_CH2(value uint32) {
	volatile.StoreUint32(&o.CH2CONF0.Reg, volatile.LoadUint32(&o.CH2CONF0.Reg)&^(0x7fff00)|value<<8)
}
func (o *RMT_Type) GetCH2CONF0_IDLE_THRES_CH2() uint32 {
	return (volatile.LoadUint32(&o.CH2CONF0.Reg) & 0x7fff00) >> 8
}
func (o *RMT_Type) SetCH2CONF0_MEM_SIZE_CH2(value uint32) {
	volatile.StoreUint32(&o.CH2CONF0.Reg, volatile.LoadUint32(&o.CH2CONF0.Reg)&^(0x3800000)|value<<23)
}
func (o *RMT_Type) GetCH2CONF0_MEM_SIZE_CH2() uint32 {
	return (volatile.LoadUint32(&o.CH2CONF0.Reg) & 0x3800000) >> 23
}
func (o *RMT_Type) SetCH2CONF0_CARRIER_EN_CH2(value uint32) {
	volatile.StoreUint32(&o.CH2CONF0.Reg, volatile.LoadUint32(&o.CH2CONF0.Reg)&^(0x10000000)|value<<28)
}
func (o *RMT_Type) GetCH2CONF0_CARRIER_EN_CH2() uint32 {
	return (volatile.LoadUint32(&o.CH2CONF0.Reg) & 0x10000000) >> 28
}
func (o *RMT_Type) SetCH2CONF0_CARRIER_OUT_LV_CH2(value uint32) {
	volatile.StoreUint32(&o.CH2CONF0.Reg, volatile.LoadUint32(&o.CH2CONF0.Reg)&^(0x20000000)|value<<29)
}
func (o *RMT_Type) GetCH2CONF0_CARRIER_OUT_LV_CH2() uint32 {
	return (volatile.LoadUint32(&o.CH2CONF0.Reg) & 0x20000000) >> 29
}

// RMT.CH2CONF1: RMT_CH2CONF1_REG.
func (o *RMT_Type) SetCH2CONF1_RX_EN_CH2(value uint32) {
	volatile.StoreUint32(&o.CH2CONF1.Reg, volatile.LoadUint32(&o.CH2CONF1.Reg)&^(0x1)|value)
}
func (o *RMT_Type) GetCH2CONF1_RX_EN_CH2() uint32 {
	return volatile.LoadUint32(&o.CH2CONF1.Reg) & 0x1
}
func (o *RMT_Type) SetCH2CONF1_MEM_WR_RST_CH2(value uint32) {
	volatile.StoreUint32(&o.CH2CONF1.Reg, volatile.LoadUint32(&o.CH2CONF1.Reg)&^(0x2)|value<<1)
}
func (o *RMT_Type) GetCH2CONF1_MEM_WR_RST_CH2() uint32 {
	return (volatile.LoadUint32(&o.CH2CONF1.Reg) & 0x2) >> 1
}
func (o *RMT_Type) SetCH2CONF1_APB_MEM_RST_CH2(value uint32) {
	volatile.StoreUint32(&o.CH2CONF1.Reg, volatile.LoadUint32(&o.CH2CONF1.Reg)&^(0x4)|value<<2)
}
func (o *RMT_Type) GetCH2CONF1_APB_MEM_RST_CH2() uint32 {
	return (volatile.LoadUint32(&o.CH2CONF1.Reg) & 0x4) >> 2
}
func (o *RMT_Type) SetCH2CONF1_MEM_OWNER_CH2(value uint32) {
	volatile.StoreUint32(&o.CH2CONF1.Reg, volatile.LoadUint32(&o.CH2CONF1.Reg)&^(0x8)|value<<3)
}
func (o *RMT_Type) GetCH2CONF1_MEM_OWNER_CH2() uint32 {
	return (volatile.LoadUint32(&o.CH2CONF1.Reg) & 0x8) >> 3
}
func (o *RMT_Type) SetCH2CONF1_RX_FILTER_EN_CH2(value uint32) {
	volatile.StoreUint32(&o.CH2CONF1.Reg, volatile.LoadUint32(&o.CH2CONF1.Reg)&^(0x10)|value<<4)
}
func (o *RMT_Type) GetCH2CONF1_RX_FILTER_EN_CH2() uint32 {
	return (volatile.LoadUint32(&o.CH2CONF1.Reg) & 0x10) >> 4
}
func (o *RMT_Type) SetCH2CONF1_RX_FILTER_THRES_CH2(value uint32) {
	volatile.StoreUint32(&o.CH2CONF1.Reg, volatile.LoadUint32(&o.CH2CONF1.Reg)&^(0x1fe0)|value<<5)
}
func (o *RMT_Type) GetCH2CONF1_RX_FILTER_THRES_CH2() uint32 {
	return (volatile.LoadUint32(&o.CH2CONF1.Reg) & 0x1fe0) >> 5
}
func (o *RMT_Type) SetCH2CONF1_MEM_RX_WRAP_EN_CH2(value uint32) {
	volatile.StoreUint32(&o.CH2CONF1.Reg, volatile.LoadUint32(&o.CH2CONF1.Reg)&^(0x2000)|value<<13)
}
func (o *RMT_Type) GetCH2CONF1_MEM_RX_WRAP_EN_CH2() uint32 {
	return (volatile.LoadUint32(&o.CH2CONF1.Reg) & 0x2000) >> 13
}
func (o *RMT_Type) SetCH2CONF1_AFIFO_RST_CH2(value uint32) {
	volatile.StoreUint32(&o.CH2CONF1.Reg, volatile.LoadUint32(&o.CH2CONF1.Reg)&^(0x4000)|value<<14)
}
func (o *RMT_Type) GetCH2CONF1_AFIFO_RST_CH2() uint32 {
	return (volatile.LoadUint32(&o.CH2CONF1.Reg) & 0x4000) >> 14
}
func (o *RMT_Type) SetCH2CONF1_CONF_UPDATE_CH2(value uint32) {
	volatile.StoreUint32(&o.CH2CONF1.Reg, volatile.LoadUint32(&o.CH2CONF1.Reg)&^(0x8000)|value<<15)
}
func (o *RMT_Type) GetCH2CONF1_CONF_UPDATE_CH2() uint32 {
	return (volatile.LoadUint32(&o.CH2CONF1.Reg) & 0x8000) >> 15
}

// RMT.CH3CONF0: RMT_CH3CONF0_REG.
func (o *RMT_Type) SetCH3CONF0_DIV_CNT_CH3(value uint32) {
	volatile.StoreUint32(&o.CH3CONF0.Reg, volatile.LoadUint32(&o.CH3CONF0.Reg)&^(0xff)|value)
}
func (o *RMT_Type) GetCH3CONF0_DIV_CNT_CH3() uint32 {
	return volatile.LoadUint32(&o.CH3CONF0.Reg) & 0xff
}
func (o *RMT_Type) SetCH3CONF0_IDLE_THRES_CH3(value uint32) {
	volatile.StoreUint32(&o.CH3CONF0.Reg, volatile.LoadUint32(&o.CH3CONF0.Reg)&^(0x7fff00)|value<<8)
}
func (o *RMT_Type) GetCH3CONF0_IDLE_THRES_CH3() uint32 {
	return (volatile.LoadUint32(&o.CH3CONF0.Reg) & 0x7fff00) >> 8
}
func (o *RMT_Type) SetCH3CONF0_MEM_SIZE_CH3(value uint32) {
	volatile.StoreUint32(&o.CH3CONF0.Reg, volatile.LoadUint32(&o.CH3CONF0.Reg)&^(0x3800000)|value<<23)
}
func (o *RMT_Type) GetCH3CONF0_MEM_SIZE_CH3() uint32 {
	return (volatile.LoadUint32(&o.CH3CONF0.Reg) & 0x3800000) >> 23
}
func (o *RMT_Type) SetCH3CONF0_CARRIER_EN_CH3(value uint32) {
	volatile.StoreUint32(&o.CH3CONF0.Reg, volatile.LoadUint32(&o.CH3CONF0.Reg)&^(0x10000000)|value<<28)
}
func (o *RMT_Type) GetCH3CONF0_CARRIER_EN_CH3() uint32 {
	return (volatile.LoadUint32(&o.CH3CONF0.Reg) & 0x10000000) >> 28
}
func (o *RMT_Type) SetCH3CONF0_CARRIER_OUT_LV_CH3(value uint32) {
	volatile.StoreUint32(&o.CH3CONF0.Reg, volatile.LoadUint32(&o.CH3CONF0.Reg)&^(0x20000000)|value<<29)
}
func (o *RMT_Type) GetCH3CONF0_CARRIER_OUT_LV_CH3() uint32 {
	return (volatile.LoadUint32(&o.CH3CONF0.Reg) & 0x20000000) >> 29
}

// RMT.CH3CONF1: RMT_CH3CONF1_REG.
func (o *RMT_Type) SetCH3CONF1_RX_EN_CH3(value uint32) {
	volatile.StoreUint32(&o.CH3CONF1.Reg, volatile.LoadUint32(&o.CH3CONF1.Reg)&^(0x1)|value)
}
func (o *RMT_Type) GetCH3CONF1_RX_EN_CH3() uint32 {
	return volatile.LoadUint32(&o.CH3CONF1.Reg) & 0x1
}
func (o *RMT_Type) SetCH3CONF1_MEM_WR_RST_CH3(value uint32) {
	volatile.StoreUint32(&o.CH3CONF1.Reg, volatile.LoadUint32(&o.CH3CONF1.Reg)&^(0x2)|value<<1)
}
func (o *RMT_Type) GetCH3CONF1_MEM_WR_RST_CH3() uint32 {
	return (volatile.LoadUint32(&o.CH3CONF1.Reg) & 0x2) >> 1
}
func (o *RMT_Type) SetCH3CONF1_APB_MEM_RST_CH3(value uint32) {
	volatile.StoreUint32(&o.CH3CONF1.Reg, volatile.LoadUint32(&o.CH3CONF1.Reg)&^(0x4)|value<<2)
}
func (o *RMT_Type) GetCH3CONF1_APB_MEM_RST_CH3() uint32 {
	return (volatile.LoadUint32(&o.CH3CONF1.Reg) & 0x4) >> 2
}
func (o *RMT_Type) SetCH3CONF1_MEM_OWNER_CH3(value uint32) {
	volatile.StoreUint32(&o.CH3CONF1.Reg, volatile.LoadUint32(&o.CH3CONF1.Reg)&^(0x8)|value<<3)
}
func (o *RMT_Type) GetCH3CONF1_MEM_OWNER_CH3() uint32 {
	return (volatile.LoadUint32(&o.CH3CONF1.Reg) & 0x8) >> 3
}
func (o *RMT_Type) SetCH3CONF1_RX_FILTER_EN_CH3(value uint32) {
	volatile.StoreUint32(&o.CH3CONF1.Reg, volatile.LoadUint32(&o.CH3CONF1.Reg)&^(0x10)|value<<4)
}
func (o *RMT_Type) GetCH3CONF1_RX_FILTER_EN_CH3() uint32 {
	return (volatile.LoadUint32(&o.CH3CONF1.Reg) & 0x10) >> 4
}
func (o *RMT_Type) SetCH3CONF1_RX_FILTER_THRES_CH3(value uint32) {
	volatile.StoreUint32(&o.CH3CONF1.Reg, volatile.LoadUint32(&o.CH3CONF1.Reg)&^(0x1fe0)|value<<5)
}
func (o *RMT_Type) GetCH3CONF1_RX_FILTER_THRES_CH3() uint32 {
	return (volatile.LoadUint32(&o.CH3CONF1.Reg) & 0x1fe0) >> 5
}
func (o *RMT_Type) SetCH3CONF1_MEM_RX_WRAP_EN_CH3(value uint32) {
	volatile.StoreUint32(&o.CH3CONF1.Reg, volatile.LoadUint32(&o.CH3CONF1.Reg)&^(0x2000)|value<<13)
}
func (o *RMT_Type) GetCH3CONF1_MEM_RX_WRAP_EN_CH3() uint32 {
	return (volatile.LoadUint32(&o.CH3CONF1.Reg) & 0x2000) >> 13
}
func (o *RMT_Type) SetCH3CONF1_AFIFO_RST_CH3(value uint32) {
	volatile.StoreUint32(&o.CH3CONF1.Reg, volatile.LoadUint32(&o.CH3CONF1.Reg)&^(0x4000)|value<<14)
}
func (o *RMT_Type) GetCH3CONF1_AFIFO_RST_CH3() uint32 {
	return (volatile.LoadUint32(&o.CH3CONF1.Reg) & 0x4000) >> 14
}
func (o *RMT_Type) SetCH3CONF1_CONF_UPDATE_CH3(value uint32) {
	volatile.StoreUint32(&o.CH3CONF1.Reg, volatile.LoadUint32(&o.CH3CONF1.Reg)&^(0x8000)|value<<15)
}
func (o *RMT_Type) GetCH3CONF1_CONF_UPDATE_CH3() uint32 {
	return (volatile.LoadUint32(&o.CH3CONF1.Reg) & 0x8000) >> 15
}

// RMT.CH0STATUS: RMT_CH0STATUS_REG.
func (o *RMT_Type) SetCH0STATUS_MEM_RADDR_EX_CH0(value uint32) {
	volatile.StoreUint32(&o.CH0STATUS.Reg, volatile.LoadUint32(&o.CH0STATUS.Reg)&^(0x1ff)|value)
}
func (o *RMT_Type) GetCH0STATUS_MEM_RADDR_EX_CH0() uint32 {
	return volatile.LoadUint32(&o.CH0STATUS.Reg) & 0x1ff
}
func (o *RMT_Type) SetCH0STATUS_STATE_CH0(value uint32) {
	volatile.StoreUint32(&o.CH0STATUS.Reg, volatile.LoadUint32(&o.CH0STATUS.Reg)&^(0xe00)|value<<9)
}
func (o *RMT_Type) GetCH0STATUS_STATE_CH0() uint32 {
	return (volatile.LoadUint32(&o.CH0STATUS.Reg) & 0xe00) >> 9
}
func (o *RMT_Type) SetCH0STATUS_APB_MEM_WADDR_CH0(value uint32) {
	volatile.StoreUint32(&o.CH0STATUS.Reg, volatile.LoadUint32(&o.CH0STATUS.Reg)&^(0x1ff000)|value<<12)
}
func (o *RMT_Type) GetCH0STATUS_APB_MEM_WADDR_CH0() uint32 {
	return (volatile.LoadUint32(&o.CH0STATUS.Reg) & 0x1ff000) >> 12
}
func (o *RMT_Type) SetCH0STATUS_APB_MEM_RD_ERR_CH0(value uint32) {
	volatile.StoreUint32(&o.CH0STATUS.Reg, volatile.LoadUint32(&o.CH0STATUS.Reg)&^(0x200000)|value<<21)
}
func (o *RMT_Type) GetCH0STATUS_APB_MEM_RD_ERR_CH0() uint32 {
	return (volatile.LoadUint32(&o.CH0STATUS.Reg) & 0x200000) >> 21
}
func (o *RMT_Type) SetCH0STATUS_MEM_EMPTY_CH0(value uint32) {
	volatile.StoreUint32(&o.CH0STATUS.Reg, volatile.LoadUint32(&o.CH0STATUS.Reg)&^(0x400000)|value<<22)
}
func (o *RMT_Type) GetCH0STATUS_MEM_EMPTY_CH0() uint32 {
	return (volatile.LoadUint32(&o.CH0STATUS.Reg) & 0x400000) >> 22
}
func (o *RMT_Type) SetCH0STATUS_APB_MEM_WR_ERR_CH0(value uint32) {
	volatile.StoreUint32(&o.CH0STATUS.Reg, volatile.LoadUint32(&o.CH0STATUS.Reg)&^(0x800000)|value<<23)
}
func (o *RMT_Type) GetCH0STATUS_APB_MEM_WR_ERR_CH0() uint32 {
	return (volatile.LoadUint32(&o.CH0STATUS.Reg) & 0x800000) >> 23
}
func (o *RMT_Type) SetCH0STATUS_APB_MEM_RADDR_CH0(value uint32) {
	volatile.StoreUint32(&o.CH0STATUS.Reg, volatile.LoadUint32(&o.CH0STATUS.Reg)&^(0xff000000)|value<<24)
}
func (o *RMT_Type) GetCH0STATUS_APB_MEM_RADDR_CH0() uint32 {
	return (volatile.LoadUint32(&o.CH0STATUS.Reg) & 0xff000000) >> 24
}

// RMT.CH1STATUS: RMT_CH1STATUS_REG.
func (o *RMT_Type) SetCH1STATUS_MEM_RADDR_EX_CH1(value uint32) {
	volatile.StoreUint32(&o.CH1STATUS.Reg, volatile.LoadUint32(&o.CH1STATUS.Reg)&^(0x1ff)|value)
}
func (o *RMT_Type) GetCH1STATUS_MEM_RADDR_EX_CH1() uint32 {
	return volatile.LoadUint32(&o.CH1STATUS.Reg) & 0x1ff
}
func (o *RMT_Type) SetCH1STATUS_STATE_CH1(value uint32) {
	volatile.StoreUint32(&o.CH1STATUS.Reg, volatile.LoadUint32(&o.CH1STATUS.Reg)&^(0xe00)|value<<9)
}
func (o *RMT_Type) GetCH1STATUS_STATE_CH1() uint32 {
	return (volatile.LoadUint32(&o.CH1STATUS.Reg) & 0xe00) >> 9
}
func (o *RMT_Type) SetCH1STATUS_APB_MEM_WADDR_CH1(value uint32) {
	volatile.StoreUint32(&o.CH1STATUS.Reg, volatile.LoadUint32(&o.CH1STATUS.Reg)&^(0x1ff000)|value<<12)
}
func (o *RMT_Type) GetCH1STATUS_APB_MEM_WADDR_CH1() uint32 {
	return (volatile.LoadUint32(&o.CH1STATUS.Reg) & 0x1ff000) >> 12
}
func (o *RMT_Type) SetCH1STATUS_APB_MEM_RD_ERR_CH1(value uint32) {
	volatile.StoreUint32(&o.CH1STATUS.Reg, volatile.LoadUint32(&o.CH1STATUS.Reg)&^(0x200000)|value<<21)
}
func (o *RMT_Type) GetCH1STATUS_APB_MEM_RD_ERR_CH1() uint32 {
	return (volatile.LoadUint32(&o.CH1STATUS.Reg) & 0x200000) >> 21
}
func (o *RMT_Type) SetCH1STATUS_MEM_EMPTY_CH1(value uint32) {
	volatile.StoreUint32(&o.CH1STATUS.Reg, volatile.LoadUint32(&o.CH1STATUS.Reg)&^(0x400000)|value<<22)
}
func (o *RMT_Type) GetCH1STATUS_MEM_EMPTY_CH1() uint32 {
	return (volatile.LoadUint32(&o.CH1STATUS.Reg) & 0x400000) >> 22
}
func (o *RMT_Type) SetCH1STATUS_APB_MEM_WR_ERR_CH1(value uint32) {
	volatile.StoreUint32(&o.CH1STATUS.Reg, volatile.LoadUint32(&o.CH1STATUS.Reg)&^(0x800000)|value<<23)
}
func (o *RMT_Type) GetCH1STATUS_APB_MEM_WR_ERR_CH1() uint32 {
	return (volatile.LoadUint32(&o.CH1STATUS.Reg) & 0x800000) >> 23
}
func (o *RMT_Type) SetCH1STATUS_APB_MEM_RADDR_CH1(value uint32) {
	volatile.StoreUint32(&o.CH1STATUS.Reg, volatile.LoadUint32(&o.CH1STATUS.Reg)&^(0xff000000)|value<<24)
}
func (o *RMT_Type) GetCH1STATUS_APB_MEM_RADDR_CH1() uint32 {
	return (volatile.LoadUint32(&o.CH1STATUS.Reg) & 0xff000000) >> 24
}

// RMT.CH2STATUS: RMT_CH2STATUS_REG.
func (o *RMT_Type) SetCH2STATUS_MEM_WADDR_EX_CH2(value uint32) {
	volatile.StoreUint32(&o.CH2STATUS.Reg, volatile.LoadUint32(&o.CH2STATUS.Reg)&^(0x1ff)|value)
}
func (o *RMT_Type) GetCH2STATUS_MEM_WADDR_EX_CH2() uint32 {
	return volatile.LoadUint32(&o.CH2STATUS.Reg) & 0x1ff
}
func (o *RMT_Type) SetCH2STATUS_APB_MEM_RADDR_CH2(value uint32) {
	volatile.StoreUint32(&o.CH2STATUS.Reg, volatile.LoadUint32(&o.CH2STATUS.Reg)&^(0x1ff000)|value<<12)
}
func (o *RMT_Type) GetCH2STATUS_APB_MEM_RADDR_CH2() uint32 {
	return (volatile.LoadUint32(&o.CH2STATUS.Reg) & 0x1ff000) >> 12
}
func (o *RMT_Type) SetCH2STATUS_STATE_CH2(value uint32) {
	volatile.StoreUint32(&o.CH2STATUS.Reg, volatile.LoadUint32(&o.CH2STATUS.Reg)&^(0x1c00000)|value<<22)
}
func (o *RMT_Type) GetCH2STATUS_STATE_CH2() uint32 {
	return (volatile.LoadUint32(&o.CH2STATUS.Reg) & 0x1c00000) >> 22
}
func (o *RMT_Type) SetCH2STATUS_MEM_OWNER_ERR_CH2(value uint32) {
	volatile.StoreUint32(&o.CH2STATUS.Reg, volatile.LoadUint32(&o.CH2STATUS.Reg)&^(0x2000000)|value<<25)
}
func (o *RMT_Type) GetCH2STATUS_MEM_OWNER_ERR_CH2() uint32 {
	return (volatile.LoadUint32(&o.CH2STATUS.Reg) & 0x2000000) >> 25
}
func (o *RMT_Type) SetCH2STATUS_MEM_FULL_CH2(value uint32) {
	volatile.StoreUint32(&o.CH2STATUS.Reg, volatile.LoadUint32(&o.CH2STATUS.Reg)&^(0x4000000)|value<<26)
}
func (o *RMT_Type) GetCH2STATUS_MEM_FULL_CH2() uint32 {
	return (volatile.LoadUint32(&o.CH2STATUS.Reg) & 0x4000000) >> 26
}
func (o *RMT_Type) SetCH2STATUS_APB_MEM_RD_ERR_CH2(value uint32) {
	volatile.StoreUint32(&o.CH2STATUS.Reg, volatile.LoadUint32(&o.CH2STATUS.Reg)&^(0x8000000)|value<<27)
}
func (o *RMT_Type) GetCH2STATUS_APB_MEM_RD_ERR_CH2() uint32 {
	return (volatile.LoadUint32(&o.CH2STATUS.Reg) & 0x8000000) >> 27
}

// RMT.CH3STATUS: RMT_CH3STATUS_REG.
func (o *RMT_Type) SetCH3STATUS_MEM_WADDR_EX_CH3(value uint32) {
	volatile.StoreUint32(&o.CH3STATUS.Reg, volatile.LoadUint32(&o.CH3STATUS.Reg)&^(0x1ff)|value)
}
func (o *RMT_Type) GetCH3STATUS_MEM_WADDR_EX_CH3() uint32 {
	return volatile.LoadUint32(&o.CH3STATUS.Reg) & 0x1ff
}
func (o *RMT_Type) SetCH3STATUS_APB_MEM_RADDR_CH3(value uint32) {
	volatile.StoreUint32(&o.CH3STATUS.Reg, volatile.LoadUint32(&o.CH3STATUS.Reg)&^(0x1ff000)|value<<12)
}
func (o *RMT_Type) GetCH3STATUS_APB_MEM_RADDR_CH3() uint32 {
	return (volatile.LoadUint32(&o.CH3STATUS.Reg) & 0x1ff000) >> 12
}
func (o *RMT_Type) SetCH3STATUS_STATE_CH3(value uint32) {
	volatile.StoreUint32(&o.CH3STATUS.Reg, volatile.LoadUint32(&o.CH3STATUS.Reg)&^(0x1c00000)|value<<22)
}
func (o *RMT_Type) GetCH3STATUS_STATE_CH3() uint32 {
	return (volatile.LoadUint32(&o.CH3STATUS.Reg) & 0x1c00000) >> 22
}
func (o *RMT_Type) SetCH3STATUS_MEM_OWNER_ERR_CH3(value uint32) {
	volatile.StoreUint32(&o.CH3STATUS.Reg, volatile.LoadUint32(&o.CH3STATUS.Reg)&^(0x2000000)|value<<25)
}
func (o *RMT_Type) GetCH3STATUS_MEM_OWNER_ERR_CH3() uint32 {
	return (volatile.LoadUint32(&o.CH3STATUS.Reg) & 0x2000000) >> 25
}
func (o *RMT_Type) SetCH3STATUS_MEM_FULL_CH3(value uint32) {
	volatile.StoreUint32(&o.CH3STATUS.Reg, volatile.LoadUint32(&o.CH3STATUS.Reg)&^(0x4000000)|value<<26)
}
func (o *RMT_Type) GetCH3STATUS_MEM_FULL_CH3() uint32 {
	return (volatile.LoadUint32(&o.CH3STATUS.Reg) & 0x4000000) >> 26
}
func (o *RMT_Type) SetCH3STATUS_APB_MEM_RD_ERR_CH3(value uint32) {
	volatile.StoreUint32(&o.CH3STATUS.Reg, volatile.LoadUint32(&o.CH3STATUS.Reg)&^(0x8000000)|value<<27)
}
func (o *RMT_Type) GetCH3STATUS_APB_MEM_RD_ERR_CH3() uint32 {
	return (volatile.LoadUint32(&o.CH3STATUS.Reg) & 0x8000000) >> 27
}

// RMT.INT_RAW: RMT_INT_RAW_REG.
func (o *RMT_Type) SetINT_RAW_CH0_TX_END_INT_RAW(value uint32) {
	volatile.StoreUint32(&o.INT_RAW.Reg, volatile.LoadUint32(&o.INT_RAW.Reg)&^(0x1)|value)
}
func (o *RMT_Type) GetINT_RAW_CH0_TX_END_INT_RAW() uint32 {
	return volatile.LoadUint32(&o.INT_RAW.Reg) & 0x1
}
func (o *RMT_Type) SetINT_RAW_CH1_TX_END_INT_RAW(value uint32) {
	volatile.StoreUint32(&o.INT_RAW.Reg, volatile.LoadUint32(&o.INT_RAW.Reg)&^(0x2)|value<<1)
}
func (o *RMT_Type) GetINT_RAW_CH1_TX_END_INT_RAW() uint32 {
	return (volatile.LoadUint32(&o.INT_RAW.Reg) & 0x2) >> 1
}
func (o *RMT_Type) SetINT_RAW_CH2_RX_END_INT_RAW(value uint32) {
	volatile.StoreUint32(&o.INT_RAW.Reg, volatile.LoadUint32(&o.INT_RAW.Reg)&^(0x4)|value<<2)
}
func (o *RMT_Type) GetINT_RAW_CH2_RX_END_INT_RAW() uint32 {
	return (volatile.LoadUint32(&o.INT_RAW.Reg) & 0x4) >> 2
}
func (o *RMT_Type) SetINT_RAW_CH3_RX_END_INT_RAW(value uint32) {
	volatile.StoreUint32(&o.INT_RAW.Reg, volatile.LoadUint32(&o.INT_RAW.Reg)&^(0x8)|value<<3)
}
func (o *RMT_Type) GetINT_RAW_CH3_RX_END_INT_RAW() uint32 {
	return (volatile.LoadUint32(&o.INT_RAW.Reg) & 0x8) >> 3
}
func (o *RMT_Type) SetINT_RAW_CH0_ERR_INT_RAW(value uint32) {
	volatile.StoreUint32(&o.INT_RAW.Reg, volatile.LoadUint32(&o.INT_RAW.Reg)&^(0x10)|value<<4)
}
func (o *RMT_Type) GetINT_RAW_CH0_ERR_INT_RAW() uint32 {
	return (volatile.LoadUint32(&o.INT_RAW.Reg) & 0x10) >> 4
}
func (o *RMT_Type) SetINT_RAW_CH1_ERR_INT_RAW(value uint32) {
	volatile.StoreUint32(&o.INT_RAW.Reg, volatile.LoadUint32(&o.INT_RAW.Reg)&^(0x20)|value<<5)
}
func (o *RMT_Type) GetINT_RAW_CH1_ERR_INT_RAW() uint32 {
	return (volatile.LoadUint32(&o.INT_RAW.Reg) & 0x20) >> 5
}
func (o *RMT_Type) SetINT_RAW_CH2_ERR_INT_RAW(value uint32) {
	volatile.StoreUint32(&o.INT_RAW.Reg, volatile.LoadUint32(&o.INT_RAW.Reg)&^(0x40)|value<<6)
}
func (o *RMT_Type) GetINT_RAW_CH2_ERR_INT_RAW() uint32 {
	return (volatile.LoadUint32(&o.INT_RAW.Reg) & 0x40) >> 6
}
func (o *RMT_Type) SetINT_RAW_CH3_ERR_INT_RAW(value uint32) {
	volatile.StoreUint32(&o.INT_RAW.Reg, volatile.LoadUint32(&o.INT_RAW.Reg)&^(0x80)|value<<7)
}
func (o *RMT_Type) GetINT_RAW_CH3_ERR_INT_RAW() uint32 {
	return (volatile.LoadUint32(&o.INT_RAW.Reg) & 0x80) >> 7
}
func (o *RMT_Type) SetINT_RAW_CH0_TX_THR_EVENT_INT_RAW(value uint32) {
	volatile.StoreUint32(&o.INT_RAW.Reg, volatile.LoadUint32(&o.INT_RAW.Reg)&^(0x100)|value<<8)
}
func (o *RMT_Type) GetINT_RAW_CH0_TX_THR_EVENT_INT_RAW() uint32 {
	return (volatile.LoadUint32(&o.INT_RAW.Reg) & 0x100) >> 8
}
func (o *RMT_Type) SetINT_RAW_CH1_TX_THR_EVENT_INT_RAW(value uint32) {
	volatile.StoreUint32(&o.INT_RAW.Reg, volatile.LoadUint32(&o.INT_RAW.Reg)&^(0x200)|value<<9)
}
func (o *RMT_Type) GetINT_RAW_CH1_TX_THR_EVENT_INT_RAW() uint32 {
	return (volatile.LoadUint32(&o.INT_RAW.Reg) & 0x200) >> 9
}
func (o *RMT_Type) SetINT_RAW_CH2_RX_THR_EVENT_INT_RAW(value uint32) {
	volatile.StoreUint32(&o.INT_RAW.Reg, volatile.LoadUint32(&o.INT_RAW.Reg)&^(0x400)|value<<10)
}
func (o *RMT_Type) GetINT_RAW_CH2_RX_THR_EVENT_INT_RAW() uint32 {
	return (volatile.LoadUint32(&o.INT_RAW.Reg) & 0x400) >> 10
}
func (o *RMT_Type) SetINT_RAW_CH3_RX_THR_EVENT_INT_RAW(value uint32) {
	volatile.StoreUint32(&o.INT_RAW.Reg, volatile.LoadUint32(&o.INT_RAW.Reg)&^(0x800)|value<<11)
}
func (o *RMT_Type) GetINT_RAW_CH3_RX_THR_EVENT_INT_RAW() uint32 {
	return (volatile.LoadUint32(&o.INT_RAW.Reg) & 0x800) >> 11
}
func (o *RMT_Type) SetINT_RAW_CH0_TX_LOOP_INT_RAW(value uint32) {
	volatile.StoreUint32(&o.INT_RAW.Reg, volatile.LoadUint32(&o.INT_RAW.Reg)&^(0x1000)|value<<12)
}
func (o *RMT_Type) GetINT_RAW_CH0_TX_LOOP_INT_RAW() uint32 {
	return (volatile.LoadUint32(&o.INT_RAW.Reg) & 0x1000) >> 12
}
func (o *RMT_Type) SetINT_RAW_CH1_TX_LOOP_INT_RAW(value uint32) {
	volatile.StoreUint32(&o.INT_RAW.Reg, volatile.LoadUint32(&o.INT_RAW.Reg)&^(0x2000)|value<<13)
}
func (o *RMT_Type) GetINT_RAW_CH1_TX_LOOP_INT_RAW() uint32 {
	return (volatile.LoadUint32(&o.INT_RAW.Reg) & 0x2000) >> 13
}

// RMT.INT_ST: RMT_INT_ST_REG.
func (o *RMT_Type) SetINT_ST_CH0_TX_END_INT_ST(value uint32) {
	volatile.StoreUint32(&o.INT_ST.Reg, volatile.LoadUint32(&o.INT_ST.Reg)&^(0x1)|value)
}
func (o *RMT_Type) GetINT_ST_CH0_TX_END_INT_ST() uint32 {
	return volatile.LoadUint32(&o.INT_ST.Reg) & 0x1
}
func (o *RMT_Type) SetINT_ST_CH1_TX_END_INT_ST(value uint32) {
	volatile.StoreUint32(&o.INT_ST.Reg, volatile.LoadUint32(&o.INT_ST.Reg)&^(0x2)|value<<1)
}
func (o *RMT_Type) GetINT_ST_CH1_TX_END_INT_ST() uint32 {
	return (volatile.LoadUint32(&o.INT_ST.Reg) & 0x2) >> 1
}
func (o *RMT_Type) SetINT_ST_CH2_RX_END_INT_ST(value uint32) {
	volatile.StoreUint32(&o.INT_ST.Reg, volatile.LoadUint32(&o.INT_ST.Reg)&^(0x4)|value<<2)
}
func (o *RMT_Type) GetINT_ST_CH2_RX_END_INT_ST() uint32 {
	return (volatile.LoadUint32(&o.INT_ST.Reg) & 0x4) >> 2
}
func (o *RMT_Type) SetINT_ST_CH3_RX_END_INT_ST(value uint32) {
	volatile.StoreUint32(&o.INT_ST.Reg, volatile.LoadUint32(&o.INT_ST.Reg)&^(0x8)|value<<3)
}
func (o *RMT_Type) GetINT_ST_CH3_RX_END_INT_ST() uint32 {
	return (volatile.LoadUint32(&o.INT_ST.Reg) & 0x8) >> 3
}
func (o *RMT_Type) SetINT_ST_CH0_ERR_INT_ST(value uint32) {
	volatile.StoreUint32(&o.INT_ST.Reg, volatile.LoadUint32(&o.INT_ST.Reg)&^(0x10)|value<<4)
}
func (o *RMT_Type) GetINT_ST_CH0_ERR_INT_ST() uint32 {
	return (volatile.LoadUint32(&o.INT_ST.Reg) & 0x10) >> 4
}
func (o *RMT_Type) SetINT_ST_CH1_ERR_INT_ST(value uint32) {
	volatile.StoreUint32(&o.INT_ST.Reg, volatile.LoadUint32(&o.INT_ST.Reg)&^(0x20)|value<<5)
}
func (o *RMT_Type) GetINT_ST_CH1_ERR_INT_ST() uint32 {
	return (volatile.LoadUint32(&o.INT_ST.Reg) & 0x20) >> 5
}
func (o *RMT_Type) SetINT_ST_CH2_ERR_INT_ST(value uint32) {
	volatile.StoreUint32(&o.INT_ST.Reg, volatile.LoadUint32(&o.INT_ST.Reg)&^(0x40)|value<<6)
}
func (o *RMT_Type) GetINT_ST_CH2_ERR_INT_ST() uint32 {
	return (volatile.LoadUint32(&o.INT_ST.Reg) & 0x40) >> 6
}
func (o *RMT_Type) SetINT_ST_CH3_ERR_INT_ST(value uint32) {
	volatile.StoreUint32(&o.INT_ST.Reg, volatile.LoadUint32(&o.INT_ST.Reg)&^(0x80)|value<<7)
}
func (o *RMT_Type) GetINT_ST_CH3_ERR_INT_ST() uint32 {
	return (volatile.LoadUint32(&o.INT_ST.Reg) & 0x80) >> 7
}
func (o *RMT_Type) SetINT_ST_CH0_TX_THR_EVENT_INT_ST(value uint32) {
	volatile.StoreUint32(&o.INT_ST.Reg, volatile.LoadUint32(&o.INT_ST.Reg)&^(0x100)|value<<8)
}
func (o *RMT_Type) GetINT_ST_CH0_TX_THR_EVENT_INT_ST() uint32 {
	return (volatile.LoadUint32(&o.INT_ST.Reg) & 0x100) >> 8
}
func (o *RMT_Type) SetINT_ST_CH1_TX_THR_EVENT_INT_ST(value uint32) {
	volatile.StoreUint32(&o.INT_ST.Reg, volatile.LoadUint32(&o.INT_ST.Reg)&^(0x200)|value<<9)
}
func (o *RMT_Type) GetINT_ST_CH1_TX_THR_EVENT_INT_ST() uint32 {
	return (volatile.LoadUint32(&o.INT_ST.Reg) & 0x200) >> 9
}
func (o *RMT_Type) SetINT_ST_CH2_RX_THR_EVENT_INT_ST(value uint32) {
	volatile.StoreUint32(&o.INT_ST.Reg, volatile.LoadUint32(&o.INT_ST.Reg)&^(0x400)|value<<10)
}
func (o *RMT_Type) GetINT_ST_CH2_RX_THR_EVENT_INT_ST() uint32 {
	return (volatile.LoadUint32(&o.INT_ST.Reg) & 0x400) >> 10
}
func (o *RMT_Type) SetINT_ST_CH3_RX_THR_EVENT_INT_ST(value uint32) {
	volatile.StoreUint32(&o.INT_ST.Reg, volatile.LoadUint32(&o.INT_ST.Reg)&^(0x800)|value<<11)
}
func (o *RMT_Type) GetINT_ST_CH3_RX_THR_EVENT_INT_ST() uint32 {
	return (volatile.LoadUint32(&o.INT_ST.Reg) & 0x800) >> 11
}
func (o *RMT_Type) SetINT_ST_CH0_TX_LOOP_INT_ST(value uint32) {
	volatile.StoreUint32(&o.INT_ST.Reg, volatile.LoadUint32(&o.INT_ST.Reg)&^(0x1000)|value<<12)
}
func (o *RMT_Type) GetINT_ST_CH0_TX_LOOP_INT_ST() uint32 {
	return (volatile.LoadUint32(&o.INT_ST.Reg) & 0x1000) >> 12
}
func (o *RMT_Type) SetINT_ST_CH1_TX_LOOP_INT_ST(value uint32) {
	volatile.StoreUint32(&o.INT_ST.Reg, volatile.LoadUint32(&o.INT_ST.Reg)&^(0x2000)|value<<13)
}
func (o *RMT_Type) GetINT_ST_CH1_TX_LOOP_INT_ST() uint32 {
	return (volatile.LoadUint32(&o.INT_ST.Reg) & 0x2000) >> 13
}

// RMT.INT_ENA: RMT_INT_ENA_REG.
func (o *RMT_Type) SetINT_ENA_CH0_TX_END_INT_ENA(value uint32) {
	volatile.StoreUint32(&o.INT_ENA.Reg, volatile.LoadUint32(&o.INT_ENA.Reg)&^(0x1)|value)
}
func (o *RMT_Type) GetINT_ENA_CH0_TX_END_INT_ENA() uint32 {
	return volatile.LoadUint32(&o.INT_ENA.Reg) & 0x1
}
func (o *RMT_Type) SetINT_ENA_CH1_TX_END_INT_ENA(value uint32) {
	volatile.StoreUint32(&o.INT_ENA.Reg, volatile.LoadUint32(&o.INT_ENA.Reg)&^(0x2)|value<<1)
}
func (o *RMT_Type) GetINT_ENA_CH1_TX_END_INT_ENA() uint32 {
	return (volatile.LoadUint32(&o.INT_ENA.Reg) & 0x2) >> 1
}
func (o *RMT_Type) SetINT_ENA_CH2_RX_END_INT_ENA(value uint32) {
	volatile.StoreUint32(&o.INT_ENA.Reg, volatile.LoadUint32(&o.INT_ENA.Reg)&^(0x4)|value<<2)
}
func (o *RMT_Type) GetINT_ENA_CH2_RX_END_INT_ENA() uint32 {
	return (volatile.LoadUint32(&o.INT_ENA.Reg) & 0x4) >> 2
}
func (o *RMT_Type) SetINT_ENA_CH3_RX_END_INT_ENA(value uint32) {
	volatile.StoreUint32(&o.INT_ENA.Reg, volatile.LoadUint32(&o.INT_ENA.Reg)&^(0x8)|value<<3)
}
func (o *RMT_Type) GetINT_ENA_CH3_RX_END_INT_ENA() uint32 {
	return (volatile.LoadUint32(&o.INT_ENA.Reg) & 0x8) >> 3
}
func (o *RMT_Type) SetINT_ENA_CH0_ERR_INT_ENA(value uint32) {
	volatile.StoreUint32(&o.INT_ENA.Reg, volatile.LoadUint32(&o.INT_ENA.Reg)&^(0x10)|value<<4)
}
func (o *RMT_Type) GetINT_ENA_CH0_ERR_INT_ENA() uint32 {
	return (volatile.LoadUint32(&o.INT_ENA.Reg) & 0x10) >> 4
}
func (o *RMT_Type) SetINT_ENA_CH1_ERR_INT_ENA(value uint32) {
	volatile.StoreUint32(&o.INT_ENA.Reg, volatile.LoadUint32(&o.INT_ENA.Reg)&^(0x20)|value<<5)
}
func (o *RMT_Type) GetINT_ENA_CH1_ERR_INT_ENA() uint32 {
	return (volatile.LoadUint32(&o.INT_ENA.Reg) & 0x20) >> 5
}
func (o *RMT_Type) SetINT_ENA_CH2_ERR_INT_ENA(value uint32) {
	volatile.StoreUint32(&o.INT_ENA.Reg, volatile.LoadUint32(&o.INT_ENA.Reg)&^(0x40)|value<<6)
}
func (o *RMT_Type) GetINT_ENA_CH2_ERR_INT_ENA() uint32 {
	return (volatile.LoadUint32(&o.INT_ENA.Reg) & 0x40) >> 6
}
func (o *RMT_Type) SetINT_ENA_CH3_ERR_INT_ENA(value uint32) {
	volatile.StoreUint32(&o.INT_ENA.Reg, volatile.LoadUint32(&o.INT_ENA.Reg)&^(0x80)|value<<7)
}
func (o *RMT_Type) GetINT_ENA_CH3_ERR_INT_ENA() uint32 {
	return (volatile.LoadUint32(&o.INT_ENA.Reg) & 0x80) >> 7
}
func (o *RMT_Type) SetINT_ENA_CH0_TX_THR_EVENT_INT_ENA(value uint32) {
	volatile.StoreUint32(&o.INT_ENA.Reg, volatile.LoadUint32(&o.INT_ENA.Reg)&^(0x100)|value<<8)
}
func (o *RMT_Type) GetINT_ENA_CH0_TX_THR_EVENT_INT_ENA() uint32 {
	return (volatile.LoadUint32(&o.INT_ENA.Reg) & 0x100) >> 8
}
func (o *RMT_Type) SetINT_ENA_CH1_TX_THR_EVENT_INT_ENA(value uint32) {
	volatile.StoreUint32(&o.INT_ENA.Reg, volatile.LoadUint32(&o.INT_ENA.Reg)&^(0x200)|value<<9)
}
func (o *RMT_Type) GetINT_ENA_CH1_TX_THR_EVENT_INT_ENA() uint32 {
	return (volatile.LoadUint32(&o.INT_ENA.Reg) & 0x200) >> 9
}
func (o *RMT_Type) SetINT_ENA_CH2_RX_THR_EVENT_INT_ENA(value uint32) {
	volatile.StoreUint32(&o.INT_ENA.Reg, volatile.LoadUint32(&o.INT_ENA.Reg)&^(0x400)|value<<10)
}
func (o *RMT_Type) GetINT_ENA_CH2_RX_THR_EVENT_INT_ENA() uint32 {
	return (volatile.LoadUint32(&o.INT_ENA.Reg) & 0x400) >> 10
}
func (o *RMT_Type) SetINT_ENA_CH3_RX_THR_EVENT_INT_ENA(value uint32) {
	volatile.StoreUint32(&o.INT_ENA.Reg, volatile.LoadUint32(&o.INT_ENA.Reg)&^(0x800)|value<<11)
}
func (o *RMT_Type) GetINT_ENA_CH3_RX_THR_EVENT_INT_ENA() uint32 {
	return (volatile.LoadUint32(&o.INT_ENA.Reg) & 0x800) >> 11
}
func (o *RMT_Type) SetINT_ENA_CH0_TX_LOOP_INT_ENA(value uint32) {
	volatile.StoreUint32(&o.INT_ENA.Reg, volatile.LoadUint32(&o.INT_ENA.Reg)&^(0x1000)|value<<12)
}
func (o *RMT_Type) GetINT_ENA_CH0_TX_LOOP_INT_ENA() uint32 {
	return (volatile.LoadUint32(&o.INT_ENA.Reg) & 0x1000) >> 12
}
func (o *RMT_Type) SetINT_ENA_CH1_TX_LOOP_INT_ENA(value uint32) {
	volatile.StoreUint32(&o.INT_ENA.Reg, volatile.LoadUint32(&o.INT_ENA.Reg)&^(0x2000)|value<<13)
}
func (o *RMT_Type) GetINT_ENA_CH1_TX_LOOP_INT_ENA() uint32 {
	return (volatile.LoadUint32(&o.INT_ENA.Reg) & 0x2000) >> 13
}

// RMT.INT_CLR: RMT_INT_CLR_REG.
func (o *RMT_Type) SetINT_CLR_CH0_TX_END_INT_CLR(value uint32) {
	volatile.StoreUint32(&o.INT_CLR.Reg, volatile.LoadUint32(&o.INT_CLR.Reg)&^(0x1)|value)
}
func (o *RMT_Type) GetINT_CLR_CH0_TX_END_INT_CLR() uint32 {
	return volatile.LoadUint32(&o.INT_CLR.Reg) & 0x1
}
func (o *RMT_Type) SetINT_CLR_CH1_TX_END_INT_CLR(value uint32) {
	volatile.StoreUint32(&o.INT_CLR.Reg, volatile.LoadUint32(&o.INT_CLR.Reg)&^(0x2)|value<<1)
}
func (o *RMT_Type) GetINT_CLR_CH1_TX_END_INT_CLR() uint32 {
	return (volatile.LoadUint32(&o.INT_CLR.Reg) & 0x2) >> 1
}
func (o *RMT_Type) SetINT_CLR_CH2_RX_END_INT_CLR(value uint32) {
	volatile.StoreUint32(&o.INT_CLR.Reg, volatile.LoadUint32(&o.INT_CLR.Reg)&^(0x4)|value<<2)
}
func (o *RMT_Type) GetINT_CLR_CH2_RX_END_INT_CLR() uint32 {
	return (volatile.LoadUint32(&o.INT_CLR.Reg) & 0x4) >> 2
}
func (o *RMT_Type) SetINT_CLR_CH3_RX_END_INT_CLR(value uint32) {
	volatile.StoreUint32(&o.INT_CLR.Reg, volatile.LoadUint32(&o.INT_CLR.Reg)&^(0x8)|value<<3)
}
func (o *RMT_Type) GetINT_CLR_CH3_RX_END_INT_CLR() uint32 {
	return (volatile.LoadUint32(&o.INT_CLR.Reg) & 0x8) >> 3
}
func (o *RMT_Type) SetINT_CLR_CH0_ERR_INT_CLR(value uint32) {
	volatile.StoreUint32(&o.INT_CLR.Reg, volatile.LoadUint32(&o.INT_CLR.Reg)&^(0x10)|value<<4)
}
func (o *RMT_Type) GetINT_CLR_CH0_ERR_INT_CLR() uint32 {
	return (volatile.LoadUint32(&o.INT_CLR.Reg) & 0x10) >> 4
}
func (o *RMT_Type) SetINT_CLR_CH1_ERR_INT_CLR(value uint32) {
	volatile.StoreUint32(&o.INT_CLR.Reg, volatile.LoadUint32(&o.INT_CLR.Reg)&^(0x20)|value<<5)
}
func (o *RMT_Type) GetINT_CLR_CH1_ERR_INT_CLR() uint32 {
	return (volatile.LoadUint32(&o.INT_CLR.Reg) & 0x20) >> 5
}
func (o *RMT_Type) SetINT_CLR_CH2_ERR_INT_CLR(value uint32) {
	volatile.StoreUint32(&o.INT_CLR.Reg, volatile.LoadUint32(&o.INT_CLR.Reg)&^(0x40)|value<<6)
}
func (o *RMT_Type) GetINT_CLR_CH2_ERR_INT_CLR() uint32 {
	return (volatile.LoadUint32(&o.INT_CLR.Reg) & 0x40) >> 6
}
func (o *RMT_Type) SetINT_CLR_CH3_ERR_INT_CLR(value uint32) {
	volatile.StoreUint32(&o.INT_CLR.Reg, volatile.LoadUint32(&o.INT_CLR.Reg)&^(0x80)|value<<7)
}
func (o *RMT_Type) GetINT_CLR_CH3_ERR_INT_CLR() uint32 {
	return (volatile.LoadUint32(&o.INT_CLR.Reg) & 0x80) >> 7
}
func (o *RMT_Type) SetINT_CLR_CH0_TX_THR_EVENT_INT_CLR(value uint32) {
	volatile.StoreUint32(&o.INT_CLR.Reg, volatile.LoadUint32(&o.INT_CLR.Reg)&^(0x100)|value<<8)
}
func (o *RMT_Type) GetINT_CLR_CH0_TX_THR_EVENT_INT_CLR() uint32 {
	return (volatile.LoadUint32(&o.INT_CLR.Reg) & 0x100) >> 8
}
func (o *RMT_Type) SetINT_CLR_CH1_TX_THR_EVENT_INT_CLR(value uint32) {
	volatile.StoreUint32(&o.INT_CLR.Reg, volatile.LoadUint32(&o.INT_CLR.Reg)&^(0x200)|value<<9)
}
func (o *RMT_Type) GetINT_CLR_CH1_TX_THR_EVENT_INT_CLR() uint32 {
	return (volatile.LoadUint32(&o.INT_CLR.Reg) & 0x200) >> 9
}
func (o *RMT_Type) SetINT_CLR_CH2_RX_THR_EVENT_INT_CLR(value uint32) {
	volatile.StoreUint32(&o.INT_CLR.Reg, volatile.LoadUint32(&o.INT_CLR.Reg)&^(0x400)|value<<10)
}
func (o *RMT_Type) GetINT_CLR_CH2_RX_THR_EVENT_INT_CLR() uint32 {
	return (volatile.LoadUint32(&o.INT_CLR.Reg) & 0x400) >> 10
}
func (o *RMT_Type) SetINT_CLR_CH3_RX_THR_EVENT_INT_CLR(value uint32) {
	volatile.StoreUint32(&o.INT_CLR.Reg, volatile.LoadUint32(&o.INT_CLR.Reg)&^(0x800)|value<<11)
}
func (o *RMT_Type) GetINT_CLR_CH3_RX_THR_EVENT_INT_CLR() uint32 {
	return (volatile.LoadUint32(&o.INT_CLR.Reg) & 0x800) >> 11
}
func (o *RMT_Type) SetINT_CLR_CH0_TX_LOOP_INT_CLR(value uint32) {
	volatile.StoreUint32(&o.INT_CLR.Reg, volatile.LoadUint32(&o.INT_CLR.Reg)&^(0x1000)|value<<12)
}
func (o *RMT_Type) GetINT_CLR_CH0_TX_LOOP_INT_CLR() uint32 {
	return (volatile.LoadUint32(&o.INT_CLR.Reg) & 0x1000) >> 12
}
func (o *RMT_Type) SetINT_CLR_CH1_TX_LOOP_INT_CLR(value uint32) {
	volatile.StoreUint32(&o.INT_CLR.Reg, volatile.LoadUint32(&o.INT_CLR.Reg)&^(0x2000)|value<<13)
}
func (o *RMT_Type) GetINT_CLR_CH1_TX_LOOP_INT_CLR() uint32 {
	return (volatile.LoadUint32(&o.INT_CLR.Reg) & 0x2000) >> 13
}

// RMT.CH0CARRIER_DUTY: RMT_CH0CARRIER_DUTY_REG.
func (o *RMT_Type) SetCH0CARRIER_DUTY_CARRIER_LOW_CH0(value uint32) {
	volatile.StoreUint32(&o.CH0CARRIER_DUTY.Reg, volatile.LoadUint32(&o.CH0CARRIER_DUTY.Reg)&^(0xffff)|value)
}
func (o *RMT_Type) GetCH0CARRIER_DUTY_CARRIER_LOW_CH0() uint32 {
	return volatile.LoadUint32(&o.CH0CARRIER_DUTY.Reg) & 0xffff
}
func (o *RMT_Type) SetCH0CARRIER_DUTY_CARRIER_HIGH_CH0(value uint32) {
	volatile.StoreUint32(&o.CH0CARRIER_DUTY.Reg, volatile.LoadUint32(&o.CH0CARRIER_DUTY.Reg)&^(0xffff0000)|value<<16)
}
func (o *RMT_Type) GetCH0CARRIER_DUTY_CARRIER_HIGH_CH0() uint32 {
	return (volatile.LoadUint32(&o.CH0CARRIER_DUTY.Reg) & 0xffff0000) >> 16
}

// RMT.CH1CARRIER_DUTY: RMT_CH1CARRIER_DUTY_REG.
func (o *RMT_Type) SetCH1CARRIER_DUTY_CARRIER_LOW_CH1(value uint32) {
	volatile.StoreUint32(&o.CH1CARRIER_DUTY.Reg, volatile.LoadUint32(&o.CH1CARRIER_DUTY.Reg)&^(0xffff)|value)
}
func (o *RMT_Type) GetCH1CARRIER_DUTY_CARRIER_LOW_CH1() uint32 {
	return volatile.LoadUint32(&o.CH1CARRIER_DUTY.Reg) & 0xffff
}
func (o *RMT_Type) SetCH1CARRIER_DUTY_CARRIER_HIGH_CH1(value uint32) {
	volatile.StoreUint32(&o.CH1CARRIER_DUTY.Reg, volatile.LoadUint32(&o.CH1CARRIER_DUTY.Reg)&^(0xffff0000)|value<<16)
}
func (o *RMT_Type) GetCH1CARRIER_DUTY_CARRIER_HIGH_CH1() uint32 {
	return (volatile.LoadUint32(&o.CH1CARRIER_DUTY.Reg) & 0xffff0000) >> 16
}

// RMT.CH2_RX_CARRIER_RM: RMT_CH2_RX_CARRIER_RM_REG.
func (o *RMT_Type) SetCH2_RX_CARRIER_RM_CARRIER_LOW_THRES_CH2(value uint32) {
	volatile.StoreUint32(&o.CH2_RX_CARRIER_RM.Reg, volatile.LoadUint32(&o.CH2_RX_CARRIER_RM.Reg)&^(0xffff)|value)
}
func (o *RMT_Type) GetCH2_RX_CARRIER_RM_CARRIER_LOW_THRES_CH2() uint32 {
	return volatile.LoadUint32(&o.CH2_RX_CARRIER_RM.Reg) & 0xffff
}
func (o *RMT_Type) SetCH2_RX_CARRIER_RM_CARRIER_HIGH_THRES_CH2(value uint32) {
	volatile.StoreUint32(&o.CH2_RX_CARRIER_RM.Reg, volatile.LoadUint32(&o.CH2_RX_CARRIER_RM.Reg)&^(0xffff0000)|value<<16)
}
func (o *RMT_Type) GetCH2_RX_CARRIER_RM_CARRIER_HIGH_THRES_CH2() uint32 {
	return (volatile.LoadUint32(&o.CH2_RX_CARRIER_RM.Reg) & 0xffff0000) >> 16
}

// RMT.CH3_RX_CARRIER_RM: RMT_CH3_RX_CARRIER_RM_REG.
func (o *RMT_Type) SetCH3_RX_CARRIER_RM_CARRIER_LOW_THRES_CH3(value uint32) {
	volatile.StoreUint32(&o.CH3_RX_CARRIER_RM.Reg, volatile.LoadUint32(&o.CH3_RX_CARRIER_RM.Reg)&^(0xffff)|value)
}
func (o *RMT_Type) GetCH3_RX_CARRIER_RM_CARRIER_LOW_THRES_CH3() uint32 {
	return volatile.LoadUint32(&o.CH3_RX_CARRIER_RM.Reg) & 0xffff
}
func (o *RMT_Type) SetCH3_RX_CARRIER_RM_CARRIER_HIGH_THRES_CH3(value uint32) {
	volatile.StoreUint32(&o.CH3_RX_CARRIER_RM.Reg, volatile.LoadUint32(&o.CH3_RX_CARRIER_RM.Reg)&^(0xffff0000)|value<<16)
}
func (o *RMT_Type) GetCH3_RX_CARRIER_RM_CARRIER_HIGH_THRES_CH3() uint32 {
	return (volatile.LoadUint32(&o.CH3_RX_CARRIER_RM.Reg) & 0xffff0000) >> 16
}

// RMT.CH0_TX_LIM: RMT_CH0_TX_LIM_REG.
func (o *RMT_Type) SetCH0_TX_LIM_RMT_TX_LIM_CH0(value uint32) {
	volatile.StoreUint32(&o.CH0_TX_LIM.Reg, volatile.LoadUint32(&o.CH0_TX_LIM.Reg)&^(0x1ff)|value)
}
func (o *RMT_Type) GetCH0_TX_LIM_RMT_TX_LIM_CH0() uint32 {
	return volatile.LoadUint32(&o.CH0_TX_LIM.Reg) & 0x1ff
}
func (o *RMT_Type) SetCH0_TX_LIM_RMT_TX_LOOP_NUM_CH0(value uint32) {
	volatile.StoreUint32(&o.CH0_TX_LIM.Reg, volatile.LoadUint32(&o.CH0_TX_LIM.Reg)&^(0x7fe00)|value<<9)
}
func (o *RMT_Type) GetCH0_TX_LIM_RMT_TX_LOOP_NUM_CH0() uint32 {
	return (volatile.LoadUint32(&o.CH0_TX_LIM.Reg) & 0x7fe00) >> 9
}
func (o *RMT_Type) SetCH0_TX_LIM_RMT_TX_LOOP_CNT_EN_CH0(value uint32) {
	volatile.StoreUint32(&o.CH0_TX_LIM.Reg, volatile.LoadUint32(&o.CH0_TX_LIM.Reg)&^(0x80000)|value<<19)
}
func (o *RMT_Type) GetCH0_TX_LIM_RMT_TX_LOOP_CNT_EN_CH0() uint32 {
	return (volatile.LoadUint32(&o.CH0_TX_LIM.Reg) & 0x80000) >> 19
}
func (o *RMT_Type) SetCH0_TX_LIM_LOOP_COUNT_RESET_CH0(value uint32) {
	volatile.StoreUint32(&o.CH0_TX_LIM.Reg, volatile.LoadUint32(&o.CH0_TX_LIM.Reg)&^(0x100000)|value<<20)
}
func (o *RMT_Type) GetCH0_TX_LIM_LOOP_COUNT_RESET_CH0() uint32 {
	return (volatile.LoadUint32(&o.CH0_TX_LIM.Reg) & 0x100000) >> 20
}

// RMT.CH1_TX_LIM: RMT_CH1_TX_LIM_REG.
func (o *RMT_Type) SetCH1_TX_LIM_RMT_TX_LIM_CH1(value uint32) {
	volatile.StoreUint32(&o.CH1_TX_LIM.Reg, volatile.LoadUint32(&o.CH1_TX_LIM.Reg)&^(0x1ff)|value)
}
func (o *RMT_Type) GetCH1_TX_LIM_RMT_TX_LIM_CH1() uint32 {
	return volatile.LoadUint32(&o.CH1_TX_LIM.Reg) & 0x1ff
}
func (o *RMT_Type) SetCH1_TX_LIM_RMT_TX_LOOP_NUM_CH1(value uint32) {
	volatile.StoreUint32(&o.CH1_TX_LIM.Reg, volatile.LoadUint32(&o.CH1_TX_LIM.Reg)&^(0x7fe00)|value<<9)
}
func (o *RMT_Type) GetCH1_TX_LIM_RMT_TX_LOOP_NUM_CH1() uint32 {
	return (volatile.LoadUint32(&o.CH1_TX_LIM.Reg) & 0x7fe00) >> 9
}
func (o *RMT_Type) SetCH1_TX_LIM_RMT_TX_LOOP_CNT_EN_CH1(value uint32) {
	volatile.StoreUint32(&o.CH1_TX_LIM.Reg, volatile.LoadUint32(&o.CH1_TX_LIM.Reg)&^(0x80000)|value<<19)
}
func (o *RMT_Type) GetCH1_TX_LIM_RMT_TX_LOOP_CNT_EN_CH1() uint32 {
	return (volatile.LoadUint32(&o.CH1_TX_LIM.Reg) & 0x80000) >> 19
}
func (o *RMT_Type) SetCH1_TX_LIM_LOOP_COUNT_RESET_CH1(value uint32) {
	volatile.StoreUint32(&o.CH1_TX_LIM.Reg, volatile.LoadUint32(&o.CH1_TX_LIM.Reg)&^(0x100000)|value<<20)
}
func (o *RMT_Type) GetCH1_TX_LIM_LOOP_COUNT_RESET_CH1() uint32 {
	return (volatile.LoadUint32(&o.CH1_TX_LIM.Reg) & 0x100000) >> 20
}

// RMT.CH2_RX_LIM: RMT_CH2_RX_LIM_REG.
func (o *RMT_Type) SetCH2_RX_LIM_RMT_RX_LIM_CH2(value uint32) {
	volatile.StoreUint32(&o.CH2_RX_LIM.Reg, volatile.LoadUint32(&o.CH2_RX_LIM.Reg)&^(0x1ff)|value)
}
func (o *RMT_Type) GetCH2_RX_LIM_RMT_RX_LIM_CH2() uint32 {
	return volatile.LoadUint32(&o.CH2_RX_LIM.Reg) & 0x1ff
}

// RMT.CH3_RX_LIM: RMT_CH3_RX_LIM_REG.
func (o *RMT_Type) SetCH3_RX_LIM_RMT_RX_LIM_CH3(value uint32) {
	volatile.StoreUint32(&o.CH3_RX_LIM.Reg, volatile.LoadUint32(&o.CH3_RX_LIM.Reg)&^(0x1ff)|value)
}
func (o *RMT_Type) GetCH3_RX_LIM_RMT_RX_LIM_CH3() uint32 {
	return volatile.LoadUint32(&o.CH3_RX_LIM.Reg) & 0x1ff
}

// RMT.SYS_CONF: RMT_SYS_CONF_REG.
func (o *RMT_Type) SetSYS_CONF_APB_FIFO_MASK(value uint32) {
	volatile.StoreUint32(&o.SYS_CONF.Reg, volatile.LoadUint32(&o.SYS_CONF.Reg)&^(0x1)|value)
}
func (o *RMT_Type) GetSYS_CONF_APB_FIFO_MASK() uint32 {
	return volatile.LoadUint32(&o.SYS_CONF.Reg) & 0x1
}
func (o *RMT_Type) SetSYS_CONF_MEM_CLK_FORCE_ON(value uint32) {
	volatile.StoreUint32(&o.SYS_CONF.Reg, volatile.LoadUint32(&o.SYS_CONF.Reg)&^(0x2)|value<<1)
}
func (o *RMT_Type) GetSYS_CONF_MEM_CLK_FORCE_ON() uint32 {
	return (volatile.LoadUint32(&o.SYS_CONF.Reg) & 0x2) >> 1
}
func (o *RMT_Type) SetSYS_CONF_RMT_MEM_FORCE_PD(value uint32) {
	volatile.StoreUint32(&o.SYS_CONF.Reg, volatile.LoadUint32(&o.SYS_CONF.Reg)&^(0x4)|value<<2)
}
func (o *RMT_Type) GetSYS_CONF_RMT_MEM_FORCE_PD() uint32 {
	return (volatile.LoadUint32(&o.SYS_CONF.Reg) & 0x4) >> 2
}
func (o *RMT_Type) SetSYS_CONF_RMT_MEM_FORCE_PU(value uint32) {
	volatile.StoreUint32(&o.SYS_CONF.Reg, volatile.LoadUint32(&o.SYS_CONF.Reg)&^(0x8)|value<<3)
}
func (o *RMT_Type) GetSYS_CONF_RMT_MEM_FORCE_PU() uint32 {
	return (volatile.LoadUint32(&o.SYS_CONF.Reg) & 0x8) >> 3
}
func (o *RMT_Type) SetSYS_CONF_RMT_SCLK_DIV_NUM(value uint32) {
	volatile.StoreUint32(&o.SYS_CONF.Reg, volatile.LoadUint32(&o.SYS_CONF.Reg)&^(0xff0)|value<<4)
}
func (o *RMT_Type) GetSYS_CONF_RMT_SCLK_DIV_NUM() uint32 {
	return (volatile.LoadUint32(&o.SYS_CONF.Reg) & 0xff0) >> 4
}
func (o *RMT_Type) SetSYS_CONF_RMT_SCLK_DIV_A(value uint32) {
	volatile.StoreUint32(&o.SYS_CONF.Reg, volatile.LoadUint32(&o.SYS_CONF.Reg)&^(0x3f000)|value<<12)
}
func (o *RMT_Type) GetSYS_CONF_RMT_SCLK_DIV_A() uint32 {
	return (volatile.LoadUint32(&o.SYS_CONF.Reg) & 0x3f000) >> 12
}
func (o *RMT_Type) SetSYS_CONF_RMT_SCLK_DIV_B(value uint32) {
	volatile.StoreUint32(&o.SYS_CONF.Reg, volatile.LoadUint32(&o.SYS_CONF.Reg)&^(0xfc0000)|value<<18)
}
func (o *RMT_Type) GetSYS_CONF_RMT_SCLK_DIV_B() uint32 {
	return (volatile.LoadUint32(&o.SYS_CONF.Reg) & 0xfc0000) >> 18
}
func (o *RMT_Type) SetSYS_CONF_RMT_SCLK_SEL(value uint32) {
	volatile.StoreUint32(&o.SYS_CONF.Reg, volatile.LoadUint32(&o.SYS_CONF.Reg)&^(0x3000000)|value<<24)
}
func (o *RMT_Type) GetSYS_CONF_RMT_SCLK_SEL() uint32 {
	return (volatile.LoadUint32(&o.SYS_CONF.Reg) & 0x3000000) >> 24
}
func (o *RMT_Type) SetSYS_CONF_RMT_SCLK_ACTIVE(value uint32) {
	volatile.StoreUint32(&o.SYS_CONF.Reg, volatile.LoadUint32(&o.SYS_CONF.Reg)&^(0x4000000)|value<<26)
}
func (o *RMT_Type) GetSYS_CONF_RMT_SCLK_ACTIVE() uint32 {
	return (volatile.LoadUint32(&o.SYS_CONF.Reg) & 0x4000000) >> 26
}
func (o *RMT_Type) SetSYS_CONF_CLK_EN(value uint32) {
	volatile.StoreUint32(&o.SYS_CONF.Reg, volatile.LoadUint32(&o.SYS_CONF.Reg)&^(0x80000000)|value<<31)
}
func (o *RMT_Type) GetSYS_CONF_CLK_EN() uint32 {
	return (volatile.LoadUint32(&o.SYS_CONF.Reg) & 0x80000000) >> 31
}

// RMT.TX_SIM: RMT_TX_SIM_REG.
func (o *RMT_Type) SetTX_SIM_RMT_TX_SIM_CH0(value uint32) {
	volatile.StoreUint32(&o.TX_SIM.Reg, volatile.LoadUint32(&o.TX_SIM.Reg)&^(0x1)|value)
}
func (o *RMT_Type) GetTX_SIM_RMT_TX_SIM_CH0() uint32 {
	return volatile.LoadUint32(&o.TX_SIM.Reg) & 0x1
}
func (o *RMT_Type) SetTX_SIM_RMT_TX_SIM_CH1(value uint32) {
	volatile.StoreUint32(&o.TX_SIM.Reg, volatile.LoadUint32(&o.TX_SIM.Reg)&^(0x2)|value<<1)
}
func (o *RMT_Type) GetTX_SIM_RMT_TX_SIM_CH1() uint32 {
	return (volatile.LoadUint32(&o.TX_SIM.Reg) & 0x2) >> 1
}
func (o *RMT_Type) SetTX_SIM_RMT_TX_SIM_EN(value uint32) {
	volatile.StoreUint32(&o.TX_SIM.Reg, volatile.LoadUint32(&o.TX_SIM.Reg)&^(0x4)|value<<2)
}
func (o *RMT_Type) GetTX_SIM_RMT_TX_SIM_EN() uint32 {
	return (volatile.LoadUint32(&o.TX_SIM.Reg) & 0x4) >> 2
}

// RMT.REF_CNT_RST: RMT_REF_CNT_RST_REG.
func (o *RMT_Type) SetREF_CNT_RST_CH0(value uint32) {
	volatile.StoreUint32(&o.REF_CNT_RST.Reg, volatile.LoadUint32(&o.REF_CNT_RST.Reg)&^(0x1)|value)
}
func (o *RMT_Type) GetREF_CNT_RST_CH0() uint32 {
	return volatile.LoadUint32(&o.REF_CNT_RST.Reg) & 0x1
}
func (o *RMT_Type) SetREF_CNT_RST_CH1(value uint32) {
	volatile.StoreUint32(&o.REF_CNT_RST.Reg, volatile.LoadUint32(&o.REF_CNT_RST.Reg)&^(0x2)|value<<1)
}
func (o *RMT_Type) GetREF_CNT_RST_CH1() uint32 {
	return (volatile.LoadUint32(&o.REF_CNT_RST.Reg) & 0x2) >> 1
}
func (o *RMT_Type) SetREF_CNT_RST_CH2(value uint32) {
	volatile.StoreUint32(&o.REF_CNT_RST.Reg, volatile.LoadUint32(&o.REF_CNT_RST.Reg)&^(0x4)|value<<2)
}
func (o *RMT_Type) GetREF_CNT_RST_CH2() uint32 {
	return (volatile.LoadUint32(&o.REF_CNT_RST.Reg) & 0x4) >> 2
}
func (o *RMT_Type) SetREF_CNT_RST_CH3(value uint32) {
	volatile.StoreUint32(&o.REF_CNT_RST.Reg, volatile.LoadUint32(&o.REF_CNT_RST.Reg)&^(0x8)|value<<3)
}
func (o *RMT_Type) GetREF_CNT_RST_CH3() uint32 {
	return (volatile.LoadUint32(&o.REF_CNT_RST.Reg) & 0x8) >> 3
}

// RMT.DATE: RMT_DATE_REG.
func (o *RMT_Type) SetDATE_RMT_DATE(value uint32) {
	volatile.StoreUint32(&o.DATE.Reg, volatile.LoadUint32(&o.DATE.Reg)&^(0xfffffff)|value)
}
func (o *RMT_Type) GetDATE_RMT_DATE() uint32 {
	return volatile.LoadUint32(&o.DATE.Reg) & 0xfffffff
}

// Peripheral RSA
type RSA_Type struct {
	M_MEM             volatile.Register32 // 0x0
	_                 [508]byte
	Z_MEM             volatile.Register32 // 0x200
	_                 [508]byte
	Y_MEM             volatile.Register32 // 0x400
	_                 [508]byte
	X_MEM             volatile.Register32 // 0x600
	_                 [508]byte
	M_PRIME           volatile.Register32 // 0x800
	MODE              volatile.Register32 // 0x804
	QUERY_CLEAN       volatile.Register32 // 0x808
	SET_START_MODEXP  volatile.Register32 // 0x80C
	SET_START_MODMULT volatile.Register32 // 0x810
	SET_START_MULT    volatile.Register32 // 0x814
	QUERY_IDLE        volatile.Register32 // 0x818
	INT_CLR           volatile.Register32 // 0x81C
	CONSTANT_TIME     volatile.Register32 // 0x820
	SEARCH_ENABLE     volatile.Register32 // 0x824
	SEARCH_POS        volatile.Register32 // 0x828
	INT_ENA           volatile.Register32 // 0x82C
	DATE              volatile.Register32 // 0x830
}

// RSA.M_PRIME: RSA M_prime register
func (o *RSA_Type) SetM_PRIME(value uint32) {
	volatile.StoreUint32(&o.M_PRIME.Reg, value)
}
func (o *RSA_Type) GetM_PRIME() uint32 {
	return volatile.LoadUint32(&o.M_PRIME.Reg)
}

// RSA.MODE: RSA mode register
func (o *RSA_Type) SetMODE(value uint32) {
	volatile.StoreUint32(&o.MODE.Reg, volatile.LoadUint32(&o.MODE.Reg)&^(0x7f)|value)
}
func (o *RSA_Type) GetMODE() uint32 {
	return volatile.LoadUint32(&o.MODE.Reg) & 0x7f
}

// RSA.QUERY_CLEAN: RSA query clean register
func (o *RSA_Type) SetQUERY_CLEAN(value uint32) {
	volatile.StoreUint32(&o.QUERY_CLEAN.Reg, volatile.LoadUint32(&o.QUERY_CLEAN.Reg)&^(0x1)|value)
}
func (o *RSA_Type) GetQUERY_CLEAN() uint32 {
	return volatile.LoadUint32(&o.QUERY_CLEAN.Reg) & 0x1
}

// RSA.SET_START_MODEXP: RSA modular exponentiation trigger register.
func (o *RSA_Type) SetSET_START_MODEXP(value uint32) {
	volatile.StoreUint32(&o.SET_START_MODEXP.Reg, volatile.LoadUint32(&o.SET_START_MODEXP.Reg)&^(0x1)|value)
}
func (o *RSA_Type) GetSET_START_MODEXP() uint32 {
	return volatile.LoadUint32(&o.SET_START_MODEXP.Reg) & 0x1
}

// RSA.SET_START_MODMULT: RSA modular multiplication trigger register.
func (o *RSA_Type) SetSET_START_MODMULT(value uint32) {
	volatile.StoreUint32(&o.SET_START_MODMULT.Reg, volatile.LoadUint32(&o.SET_START_MODMULT.Reg)&^(0x1)|value)
}
func (o *RSA_Type) GetSET_START_MODMULT() uint32 {
	return volatile.LoadUint32(&o.SET_START_MODMULT.Reg) & 0x1
}

// RSA.SET_START_MULT: RSA normal multiplication trigger register.
func (o *RSA_Type) SetSET_START_MULT(value uint32) {
	volatile.StoreUint32(&o.SET_START_MULT.Reg, volatile.LoadUint32(&o.SET_START_MULT.Reg)&^(0x1)|value)
}
func (o *RSA_Type) GetSET_START_MULT() uint32 {
	return volatile.LoadUint32(&o.SET_START_MULT.Reg) & 0x1
}

// RSA.QUERY_IDLE: RSA query idle register
func (o *RSA_Type) SetQUERY_IDLE(value uint32) {
	volatile.StoreUint32(&o.QUERY_IDLE.Reg, volatile.LoadUint32(&o.QUERY_IDLE.Reg)&^(0x1)|value)
}
func (o *RSA_Type) GetQUERY_IDLE() uint32 {
	return volatile.LoadUint32(&o.QUERY_IDLE.Reg) & 0x1
}

// RSA.INT_CLR: RSA interrupt clear register
func (o *RSA_Type) SetINT_CLR_CLEAR_INTERRUPT(value uint32) {
	volatile.StoreUint32(&o.INT_CLR.Reg, volatile.LoadUint32(&o.INT_CLR.Reg)&^(0x1)|value)
}
func (o *RSA_Type) GetINT_CLR_CLEAR_INTERRUPT() uint32 {
	return volatile.LoadUint32(&o.INT_CLR.Reg) & 0x1
}

// RSA.CONSTANT_TIME: RSA constant time option register
func (o *RSA_Type) SetCONSTANT_TIME(value uint32) {
	volatile.StoreUint32(&o.CONSTANT_TIME.Reg, volatile.LoadUint32(&o.CONSTANT_TIME.Reg)&^(0x1)|value)
}
func (o *RSA_Type) GetCONSTANT_TIME() uint32 {
	return volatile.LoadUint32(&o.CONSTANT_TIME.Reg) & 0x1
}

// RSA.SEARCH_ENABLE: RSA search option
func (o *RSA_Type) SetSEARCH_ENABLE(value uint32) {
	volatile.StoreUint32(&o.SEARCH_ENABLE.Reg, volatile.LoadUint32(&o.SEARCH_ENABLE.Reg)&^(0x1)|value)
}
func (o *RSA_Type) GetSEARCH_ENABLE() uint32 {
	return volatile.LoadUint32(&o.SEARCH_ENABLE.Reg) & 0x1
}

// RSA.SEARCH_POS: RSA search position configure register
func (o *RSA_Type) SetSEARCH_POS(value uint32) {
	volatile.StoreUint32(&o.SEARCH_POS.Reg, volatile.LoadUint32(&o.SEARCH_POS.Reg)&^(0xfff)|value)
}
func (o *RSA_Type) GetSEARCH_POS() uint32 {
	return volatile.LoadUint32(&o.SEARCH_POS.Reg) & 0xfff
}

// RSA.INT_ENA: RSA interrupt enable register
func (o *RSA_Type) SetINT_ENA(value uint32) {
	volatile.StoreUint32(&o.INT_ENA.Reg, volatile.LoadUint32(&o.INT_ENA.Reg)&^(0x1)|value)
}
func (o *RSA_Type) GetINT_ENA() uint32 {
	return volatile.LoadUint32(&o.INT_ENA.Reg) & 0x1
}

// RSA.DATE: RSA version control register
func (o *RSA_Type) SetDATE(value uint32) {
	volatile.StoreUint32(&o.DATE.Reg, volatile.LoadUint32(&o.DATE.Reg)&^(0x3fffffff)|value)
}
func (o *RSA_Type) GetDATE() uint32 {
	return volatile.LoadUint32(&o.DATE.Reg) & 0x3fffffff
}

// Peripheral RTC_CNTL
type RTC_CNTL_Type struct {
	RTC_OPTIONS0            volatile.Register32 // 0x0
	RTC_SLP_TIMER0          volatile.Register32 // 0x4
	RTC_SLP_TIMER1          volatile.Register32 // 0x8
	RTC_TIME_UPDATE         volatile.Register32 // 0xC
	RTC_TIME_LOW0           volatile.Register32 // 0x10
	RTC_TIME_HIGH0          volatile.Register32 // 0x14
	RTC_STATE0              volatile.Register32 // 0x18
	RTC_TIMER1              volatile.Register32 // 0x1C
	RTC_TIMER2              volatile.Register32 // 0x20
	RTC_TIMER3              volatile.Register32 // 0x24
	RTC_TIMER4              volatile.Register32 // 0x28
	RTC_TIMER5              volatile.Register32 // 0x2C
	RTC_TIMER6              volatile.Register32 // 0x30
	RTC_ANA_CONF            volatile.Register32 // 0x34
	RTC_RESET_STATE         volatile.Register32 // 0x38
	RTC_WAKEUP_STATE        volatile.Register32 // 0x3C
	INT_ENA_RTC             volatile.Register32 // 0x40
	INT_RAW_RTC             volatile.Register32 // 0x44
	INT_ST_RTC              volatile.Register32 // 0x48
	INT_CLR_RTC             volatile.Register32 // 0x4C
	RTC_STORE0              volatile.Register32 // 0x50
	RTC_STORE1              volatile.Register32 // 0x54
	RTC_STORE2              volatile.Register32 // 0x58
	RTC_STORE3              volatile.Register32 // 0x5C
	RTC_EXT_XTL_CONF        volatile.Register32 // 0x60
	RTC_EXT_WAKEUP_CONF     volatile.Register32 // 0x64
	RTC_SLP_REJECT_CONF     volatile.Register32 // 0x68
	RTC_CPU_PERIOD_CONF     volatile.Register32 // 0x6C
	RTC_CLK_CONF            volatile.Register32 // 0x70
	RTC_SLOW_CLK_CONF       volatile.Register32 // 0x74
	RTC_SDIO_CONF           volatile.Register32 // 0x78
	RTC_BIAS_CONF           volatile.Register32 // 0x7C
	RTC                     volatile.Register32 // 0x80
	RTC_PWC                 volatile.Register32 // 0x84
	DIG_PWC                 volatile.Register32 // 0x88
	DIG_ISO                 volatile.Register32 // 0x8C
	RTC_WDTCONFIG0          volatile.Register32 // 0x90
	RTC_WDTCONFIG1          volatile.Register32 // 0x94
	RTC_WDTCONFIG2          volatile.Register32 // 0x98
	RTC_WDTCONFIG3          volatile.Register32 // 0x9C
	RTC_WDTCONFIG4          volatile.Register32 // 0xA0
	RTC_WDTFEED             volatile.Register32 // 0xA4
	RTC_WDTWPROTECT         volatile.Register32 // 0xA8
	RTC_SWD_CONF            volatile.Register32 // 0xAC
	RTC_SWD_WPROTECT        volatile.Register32 // 0xB0
	RTC_SW_CPU_STALL        volatile.Register32 // 0xB4
	RTC_STORE4              volatile.Register32 // 0xB8
	RTC_STORE5              volatile.Register32 // 0xBC
	RTC_STORE6              volatile.Register32 // 0xC0
	RTC_STORE7              volatile.Register32 // 0xC4
	RTC_LOW_POWER_ST        volatile.Register32 // 0xC8
	RTC_DIAG0               volatile.Register32 // 0xCC
	RTC_PAD_HOLD            volatile.Register32 // 0xD0
	DIG_PAD_HOLD            volatile.Register32 // 0xD4
	RTC_BROWN_OUT           volatile.Register32 // 0xD8
	RTC_TIME_LOW1           volatile.Register32 // 0xDC
	RTC_TIME_HIGH1          volatile.Register32 // 0xE0
	RTC_XTAL32K_CLK_FACTOR  volatile.Register32 // 0xE4
	RTC_XTAL32K_CONF        volatile.Register32 // 0xE8
	RTC_USB_CONF            volatile.Register32 // 0xEC
	RTC_SLP_REJECT_CAUSE    volatile.Register32 // 0xF0
	RTC_OPTION1             volatile.Register32 // 0xF4
	RTC_SLP_WAKEUP_CAUSE    volatile.Register32 // 0xF8
	RTC_ULP_CP_TIMER_1      volatile.Register32 // 0xFC
	INT_ENA_RTC_W1TS        volatile.Register32 // 0x100
	INT_ENA_RTC_W1TC        volatile.Register32 // 0x104
	RTC_CNTL_RETENTION_CTRL volatile.Register32 // 0x108
	RTC_FIB_SEL             volatile.Register32 // 0x10C
	RTC_CNTL_GPIO_WAKEUP    volatile.Register32 // 0x110
	RTC_CNTL_DBG_SEL        volatile.Register32 // 0x114
	RTC_CNTL_DBG_MAP        volatile.Register32 // 0x118
	RTC_CNTL_SENSOR_CTRL    volatile.Register32 // 0x11C
	RTC_CNTL_DBG_SAR_SEL    volatile.Register32 // 0x120
	RTC_CNTL_PG_CTRL        volatile.Register32 // 0x124
	_                       [212]byte
	DATE                    volatile.Register32 // 0x1FC
}

// RTC_CNTL.RTC_OPTIONS0: rtc configure register
func (o *RTC_CNTL_Type) SetRTC_OPTIONS0_SW_STALL_APPCPU_C0(value uint32) {
	volatile.StoreUint32(&o.RTC_OPTIONS0.Reg, volatile.LoadUint32(&o.RTC_OPTIONS0.Reg)&^(0x3)|value)
}
func (o *RTC_CNTL_Type) GetRTC_OPTIONS0_SW_STALL_APPCPU_C0() uint32 {
	return volatile.LoadUint32(&o.RTC_OPTIONS0.Reg) & 0x3
}
func (o *RTC_CNTL_Type) SetRTC_OPTIONS0_SW_STALL_PROCPU_C0(value uint32) {
	volatile.StoreUint32(&o.RTC_OPTIONS0.Reg, volatile.LoadUint32(&o.RTC_OPTIONS0.Reg)&^(0xc)|value<<2)
}
func (o *RTC_CNTL_Type) GetRTC_OPTIONS0_SW_STALL_PROCPU_C0() uint32 {
	return (volatile.LoadUint32(&o.RTC_OPTIONS0.Reg) & 0xc) >> 2
}
func (o *RTC_CNTL_Type) SetRTC_OPTIONS0_SW_APPCPU_RST(value uint32) {
	volatile.StoreUint32(&o.RTC_OPTIONS0.Reg, volatile.LoadUint32(&o.RTC_OPTIONS0.Reg)&^(0x10)|value<<4)
}
func (o *RTC_CNTL_Type) GetRTC_OPTIONS0_SW_APPCPU_RST() uint32 {
	return (volatile.LoadUint32(&o.RTC_OPTIONS0.Reg) & 0x10) >> 4
}
func (o *RTC_CNTL_Type) SetRTC_OPTIONS0_SW_PROCPU_RST(value uint32) {
	volatile.StoreUint32(&o.RTC_OPTIONS0.Reg, volatile.LoadUint32(&o.RTC_OPTIONS0.Reg)&^(0x20)|value<<5)
}
func (o *RTC_CNTL_Type) GetRTC_OPTIONS0_SW_PROCPU_RST() uint32 {
	return (volatile.LoadUint32(&o.RTC_OPTIONS0.Reg) & 0x20) >> 5
}
func (o *RTC_CNTL_Type) SetRTC_OPTIONS0_BB_I2C_FORCE_PD(value uint32) {
	volatile.StoreUint32(&o.RTC_OPTIONS0.Reg, volatile.LoadUint32(&o.RTC_OPTIONS0.Reg)&^(0x40)|value<<6)
}
func (o *RTC_CNTL_Type) GetRTC_OPTIONS0_BB_I2C_FORCE_PD() uint32 {
	return (volatile.LoadUint32(&o.RTC_OPTIONS0.Reg) & 0x40) >> 6
}
func (o *RTC_CNTL_Type) SetRTC_OPTIONS0_BB_I2C_FORCE_PU(value uint32) {
	volatile.StoreUint32(&o.RTC_OPTIONS0.Reg, volatile.LoadUint32(&o.RTC_OPTIONS0.Reg)&^(0x80)|value<<7)
}
func (o *RTC_CNTL_Type) GetRTC_OPTIONS0_BB_I2C_FORCE_PU() uint32 {
	return (volatile.LoadUint32(&o.RTC_OPTIONS0.Reg) & 0x80) >> 7
}
func (o *RTC_CNTL_Type) SetRTC_OPTIONS0_BBPLL_I2C_FORCE_PD(value uint32) {
	volatile.StoreUint32(&o.RTC_OPTIONS0.Reg, volatile.LoadUint32(&o.RTC_OPTIONS0.Reg)&^(0x100)|value<<8)
}
func (o *RTC_CNTL_Type) GetRTC_OPTIONS0_BBPLL_I2C_FORCE_PD() uint32 {
	return (volatile.LoadUint32(&o.RTC_OPTIONS0.Reg) & 0x100) >> 8
}
func (o *RTC_CNTL_Type) SetRTC_OPTIONS0_BBPLL_I2C_FORCE_PU(value uint32) {
	volatile.StoreUint32(&o.RTC_OPTIONS0.Reg, volatile.LoadUint32(&o.RTC_OPTIONS0.Reg)&^(0x200)|value<<9)
}
func (o *RTC_CNTL_Type) GetRTC_OPTIONS0_BBPLL_I2C_FORCE_PU() uint32 {
	return (volatile.LoadUint32(&o.RTC_OPTIONS0.Reg) & 0x200) >> 9
}
func (o *RTC_CNTL_Type) SetRTC_OPTIONS0_BBPLL_FORCE_PD(value uint32) {
	volatile.StoreUint32(&o.RTC_OPTIONS0.Reg, volatile.LoadUint32(&o.RTC_OPTIONS0.Reg)&^(0x400)|value<<10)
}
func (o *RTC_CNTL_Type) GetRTC_OPTIONS0_BBPLL_FORCE_PD() uint32 {
	return (volatile.LoadUint32(&o.RTC_OPTIONS0.Reg) & 0x400) >> 10
}
func (o *RTC_CNTL_Type) SetRTC_OPTIONS0_BBPLL_FORCE_PU(value uint32) {
	volatile.StoreUint32(&o.RTC_OPTIONS0.Reg, volatile.LoadUint32(&o.RTC_OPTIONS0.Reg)&^(0x800)|value<<11)
}
func (o *RTC_CNTL_Type) GetRTC_OPTIONS0_BBPLL_FORCE_PU() uint32 {
	return (volatile.LoadUint32(&o.RTC_OPTIONS0.Reg) & 0x800) >> 11
}
func (o *RTC_CNTL_Type) SetRTC_OPTIONS0_XTL_FORCE_PD(value uint32) {
	volatile.StoreUint32(&o.RTC_OPTIONS0.Reg, volatile.LoadUint32(&o.RTC_OPTIONS0.Reg)&^(0x1000)|value<<12)
}
func (o *RTC_CNTL_Type) GetRTC_OPTIONS0_XTL_FORCE_PD() uint32 {
	return (volatile.LoadUint32(&o.RTC_OPTIONS0.Reg) & 0x1000) >> 12
}
func (o *RTC_CNTL_Type) SetRTC_OPTIONS0_XTL_FORCE_PU(value uint32) {
	volatile.StoreUint32(&o.RTC_OPTIONS0.Reg, volatile.LoadUint32(&o.RTC_OPTIONS0.Reg)&^(0x2000)|value<<13)
}
func (o *RTC_CNTL_Type) GetRTC_OPTIONS0_XTL_FORCE_PU() uint32 {
	return (volatile.LoadUint32(&o.RTC_OPTIONS0.Reg) & 0x2000) >> 13
}
func (o *RTC_CNTL_Type) SetRTC_OPTIONS0_XTL_EN_WAIT(value uint32) {
	volatile.StoreUint32(&o.RTC_OPTIONS0.Reg, volatile.LoadUint32(&o.RTC_OPTIONS0.Reg)&^(0x3c000)|value<<14)
}
func (o *RTC_CNTL_Type) GetRTC_OPTIONS0_XTL_EN_WAIT() uint32 {
	return (volatile.LoadUint32(&o.RTC_OPTIONS0.Reg) & 0x3c000) >> 14
}
func (o *RTC_CNTL_Type) SetRTC_OPTIONS0_XTL_EXT_CTR_SEL(value uint32) {
	volatile.StoreUint32(&o.RTC_OPTIONS0.Reg, volatile.LoadUint32(&o.RTC_OPTIONS0.Reg)&^(0x700000)|value<<20)
}
func (o *RTC_CNTL_Type) GetRTC_OPTIONS0_XTL_EXT_CTR_SEL() uint32 {
	return (volatile.LoadUint32(&o.RTC_OPTIONS0.Reg) & 0x700000) >> 20
}
func (o *RTC_CNTL_Type) SetRTC_OPTIONS0_XTL_FORCE_ISO(value uint32) {
	volatile.StoreUint32(&o.RTC_OPTIONS0.Reg, volatile.LoadUint32(&o.RTC_OPTIONS0.Reg)&^(0x800000)|value<<23)
}
func (o *RTC_CNTL_Type) GetRTC_OPTIONS0_XTL_FORCE_ISO() uint32 {
	return (volatile.LoadUint32(&o.RTC_OPTIONS0.Reg) & 0x800000) >> 23
}
func (o *RTC_CNTL_Type) SetRTC_OPTIONS0_PLL_FORCE_ISO(value uint32) {
	volatile.StoreUint32(&o.RTC_OPTIONS0.Reg, volatile.LoadUint32(&o.RTC_OPTIONS0.Reg)&^(0x1000000)|value<<24)
}
func (o *RTC_CNTL_Type) GetRTC_OPTIONS0_PLL_FORCE_ISO() uint32 {
	return (volatile.LoadUint32(&o.RTC_OPTIONS0.Reg) & 0x1000000) >> 24
}
func (o *RTC_CNTL_Type) SetRTC_OPTIONS0_ANALOG_FORCE_ISO(value uint32) {
	volatile.StoreUint32(&o.RTC_OPTIONS0.Reg, volatile.LoadUint32(&o.RTC_OPTIONS0.Reg)&^(0x2000000)|value<<25)
}
func (o *RTC_CNTL_Type) GetRTC_OPTIONS0_ANALOG_FORCE_ISO() uint32 {
	return (volatile.LoadUint32(&o.RTC_OPTIONS0.Reg) & 0x2000000) >> 25
}
func (o *RTC_CNTL_Type) SetRTC_OPTIONS0_XTL_FORCE_NOISO(value uint32) {
	volatile.StoreUint32(&o.RTC_OPTIONS0.Reg, volatile.LoadUint32(&o.RTC_OPTIONS0.Reg)&^(0x4000000)|value<<26)
}
func (o *RTC_CNTL_Type) GetRTC_OPTIONS0_XTL_FORCE_NOISO() uint32 {
	return (volatile.LoadUint32(&o.RTC_OPTIONS0.Reg) & 0x4000000) >> 26
}
func (o *RTC_CNTL_Type) SetRTC_OPTIONS0_PLL_FORCE_NOISO(value uint32) {
	volatile.StoreUint32(&o.RTC_OPTIONS0.Reg, volatile.LoadUint32(&o.RTC_OPTIONS0.Reg)&^(0x8000000)|value<<27)
}
func (o *RTC_CNTL_Type) GetRTC_OPTIONS0_PLL_FORCE_NOISO() uint32 {
	return (volatile.LoadUint32(&o.RTC_OPTIONS0.Reg) & 0x8000000) >> 27
}
func (o *RTC_CNTL_Type) SetRTC_OPTIONS0_ANALOG_FORCE_NOISO(value uint32) {
	volatile.StoreUint32(&o.RTC_OPTIONS0.Reg, volatile.LoadUint32(&o.RTC_OPTIONS0.Reg)&^(0x10000000)|value<<28)
}
func (o *RTC_CNTL_Type) GetRTC_OPTIONS0_ANALOG_FORCE_NOISO() uint32 {
	return (volatile.LoadUint32(&o.RTC_OPTIONS0.Reg) & 0x10000000) >> 28
}
func (o *RTC_CNTL_Type) SetRTC_OPTIONS0_DG_WRAP_FORCE_RST(value uint32) {
	volatile.StoreUint32(&o.RTC_OPTIONS0.Reg, volatile.LoadUint32(&o.RTC_OPTIONS0.Reg)&^(0x20000000)|value<<29)
}
func (o *RTC_CNTL_Type) GetRTC_OPTIONS0_DG_WRAP_FORCE_RST() uint32 {
	return (volatile.LoadUint32(&o.RTC_OPTIONS0.Reg) & 0x20000000) >> 29
}
func (o *RTC_CNTL_Type) SetRTC_OPTIONS0_DG_WRAP_FORCE_NORST(value uint32) {
	volatile.StoreUint32(&o.RTC_OPTIONS0.Reg, volatile.LoadUint32(&o.RTC_OPTIONS0.Reg)&^(0x40000000)|value<<30)
}
func (o *RTC_CNTL_Type) GetRTC_OPTIONS0_DG_WRAP_FORCE_NORST() uint32 {
	return (volatile.LoadUint32(&o.RTC_OPTIONS0.Reg) & 0x40000000) >> 30
}
func (o *RTC_CNTL_Type) SetRTC_OPTIONS0_SW_SYS_RST(value uint32) {
	volatile.StoreUint32(&o.RTC_OPTIONS0.Reg, volatile.LoadUint32(&o.RTC_OPTIONS0.Reg)&^(0x80000000)|value<<31)
}
func (o *RTC_CNTL_Type) GetRTC_OPTIONS0_SW_SYS_RST() uint32 {
	return (volatile.LoadUint32(&o.RTC_OPTIONS0.Reg) & 0x80000000) >> 31
}

// RTC_CNTL.RTC_SLP_TIMER0: rtc configure register
func (o *RTC_CNTL_Type) SetRTC_SLP_TIMER0(value uint32) {
	volatile.StoreUint32(&o.RTC_SLP_TIMER0.Reg, value)
}
func (o *RTC_CNTL_Type) GetRTC_SLP_TIMER0() uint32 {
	return volatile.LoadUint32(&o.RTC_SLP_TIMER0.Reg)
}

// RTC_CNTL.RTC_SLP_TIMER1: rtc configure register
func (o *RTC_CNTL_Type) SetRTC_SLP_TIMER1_SLP_VAL_HI(value uint32) {
	volatile.StoreUint32(&o.RTC_SLP_TIMER1.Reg, volatile.LoadUint32(&o.RTC_SLP_TIMER1.Reg)&^(0xffff)|value)
}
func (o *RTC_CNTL_Type) GetRTC_SLP_TIMER1_SLP_VAL_HI() uint32 {
	return volatile.LoadUint32(&o.RTC_SLP_TIMER1.Reg) & 0xffff
}
func (o *RTC_CNTL_Type) SetRTC_SLP_TIMER1_RTC_MAIN_TIMER_ALARM_EN(value uint32) {
	volatile.StoreUint32(&o.RTC_SLP_TIMER1.Reg, volatile.LoadUint32(&o.RTC_SLP_TIMER1.Reg)&^(0x10000)|value<<16)
}
func (o *RTC_CNTL_Type) GetRTC_SLP_TIMER1_RTC_MAIN_TIMER_ALARM_EN() uint32 {
	return (volatile.LoadUint32(&o.RTC_SLP_TIMER1.Reg) & 0x10000) >> 16
}

// RTC_CNTL.RTC_TIME_UPDATE: rtc configure register
func (o *RTC_CNTL_Type) SetRTC_TIME_UPDATE_TIMER_SYS_STALL(value uint32) {
	volatile.StoreUint32(&o.RTC_TIME_UPDATE.Reg, volatile.LoadUint32(&o.RTC_TIME_UPDATE.Reg)&^(0x8000000)|value<<27)
}
func (o *RTC_CNTL_Type) GetRTC_TIME_UPDATE_TIMER_SYS_STALL() uint32 {
	return (volatile.LoadUint32(&o.RTC_TIME_UPDATE.Reg) & 0x8000000) >> 27
}
func (o *RTC_CNTL_Type) SetRTC_TIME_UPDATE_TIMER_XTL_OFF(value uint32) {
	volatile.StoreUint32(&o.RTC_TIME_UPDATE.Reg, volatile.LoadUint32(&o.RTC_TIME_UPDATE.Reg)&^(0x10000000)|value<<28)
}
func (o *RTC_CNTL_Type) GetRTC_TIME_UPDATE_TIMER_XTL_OFF() uint32 {
	return (volatile.LoadUint32(&o.RTC_TIME_UPDATE.Reg) & 0x10000000) >> 28
}
func (o *RTC_CNTL_Type) SetRTC_TIME_UPDATE_TIMER_SYS_RST(value uint32) {
	volatile.StoreUint32(&o.RTC_TIME_UPDATE.Reg, volatile.LoadUint32(&o.RTC_TIME_UPDATE.Reg)&^(0x20000000)|value<<29)
}
func (o *RTC_CNTL_Type) GetRTC_TIME_UPDATE_TIMER_SYS_RST() uint32 {
	return (volatile.LoadUint32(&o.RTC_TIME_UPDATE.Reg) & 0x20000000) >> 29
}
func (o *RTC_CNTL_Type) SetRTC_TIME_UPDATE(value uint32) {
	volatile.StoreUint32(&o.RTC_TIME_UPDATE.Reg, volatile.LoadUint32(&o.RTC_TIME_UPDATE.Reg)&^(0x80000000)|value<<31)
}
func (o *RTC_CNTL_Type) GetRTC_TIME_UPDATE() uint32 {
	return (volatile.LoadUint32(&o.RTC_TIME_UPDATE.Reg) & 0x80000000) >> 31
}

// RTC_CNTL.RTC_TIME_LOW0: rtc configure register
func (o *RTC_CNTL_Type) SetRTC_TIME_LOW0(value uint32) {
	volatile.StoreUint32(&o.RTC_TIME_LOW0.Reg, value)
}
func (o *RTC_CNTL_Type) GetRTC_TIME_LOW0() uint32 {
	return volatile.LoadUint32(&o.RTC_TIME_LOW0.Reg)
}

// RTC_CNTL.RTC_TIME_HIGH0: rtc configure register
func (o *RTC_CNTL_Type) SetRTC_TIME_HIGH0_RTC_TIMER_VALUE0_HIGH(value uint32) {
	volatile.StoreUint32(&o.RTC_TIME_HIGH0.Reg, volatile.LoadUint32(&o.RTC_TIME_HIGH0.Reg)&^(0xffff)|value)
}
func (o *RTC_CNTL_Type) GetRTC_TIME_HIGH0_RTC_TIMER_VALUE0_HIGH() uint32 {
	return volatile.LoadUint32(&o.RTC_TIME_HIGH0.Reg) & 0xffff
}

// RTC_CNTL.RTC_STATE0: rtc configure register
func (o *RTC_CNTL_Type) SetRTC_STATE0_RTC_SW_CPU_INT(value uint32) {
	volatile.StoreUint32(&o.RTC_STATE0.Reg, volatile.LoadUint32(&o.RTC_STATE0.Reg)&^(0x1)|value)
}
func (o *RTC_CNTL_Type) GetRTC_STATE0_RTC_SW_CPU_INT() uint32 {
	return volatile.LoadUint32(&o.RTC_STATE0.Reg) & 0x1
}
func (o *RTC_CNTL_Type) SetRTC_STATE0_RTC_SLP_REJECT_CAUSE_CLR(value uint32) {
	volatile.StoreUint32(&o.RTC_STATE0.Reg, volatile.LoadUint32(&o.RTC_STATE0.Reg)&^(0x2)|value<<1)
}
func (o *RTC_CNTL_Type) GetRTC_STATE0_RTC_SLP_REJECT_CAUSE_CLR() uint32 {
	return (volatile.LoadUint32(&o.RTC_STATE0.Reg) & 0x2) >> 1
}
func (o *RTC_CNTL_Type) SetRTC_STATE0_APB2RTC_BRIDGE_SEL(value uint32) {
	volatile.StoreUint32(&o.RTC_STATE0.Reg, volatile.LoadUint32(&o.RTC_STATE0.Reg)&^(0x400000)|value<<22)
}
func (o *RTC_CNTL_Type) GetRTC_STATE0_APB2RTC_BRIDGE_SEL() uint32 {
	return (volatile.LoadUint32(&o.RTC_STATE0.Reg) & 0x400000) >> 22
}
func (o *RTC_CNTL_Type) SetRTC_STATE0_SDIO_ACTIVE_IND(value uint32) {
	volatile.StoreUint32(&o.RTC_STATE0.Reg, volatile.LoadUint32(&o.RTC_STATE0.Reg)&^(0x10000000)|value<<28)
}
func (o *RTC_CNTL_Type) GetRTC_STATE0_SDIO_ACTIVE_IND() uint32 {
	return (volatile.LoadUint32(&o.RTC_STATE0.Reg) & 0x10000000) >> 28
}
func (o *RTC_CNTL_Type) SetRTC_STATE0_SLP_WAKEUP(value uint32) {
	volatile.StoreUint32(&o.RTC_STATE0.Reg, volatile.LoadUint32(&o.RTC_STATE0.Reg)&^(0x20000000)|value<<29)
}
func (o *RTC_CNTL_Type) GetRTC_STATE0_SLP_WAKEUP() uint32 {
	return (volatile.LoadUint32(&o.RTC_STATE0.Reg) & 0x20000000) >> 29
}
func (o *RTC_CNTL_Type) SetRTC_STATE0_SLP_REJECT(value uint32) {
	volatile.StoreUint32(&o.RTC_STATE0.Reg, volatile.LoadUint32(&o.RTC_STATE0.Reg)&^(0x40000000)|value<<30)
}
func (o *RTC_CNTL_Type) GetRTC_STATE0_SLP_REJECT() uint32 {
	return (volatile.LoadUint32(&o.RTC_STATE0.Reg) & 0x40000000) >> 30
}
func (o *RTC_CNTL_Type) SetRTC_STATE0_SLEEP_EN(value uint32) {
	volatile.StoreUint32(&o.RTC_STATE0.Reg, volatile.LoadUint32(&o.RTC_STATE0.Reg)&^(0x80000000)|value<<31)
}
func (o *RTC_CNTL_Type) GetRTC_STATE0_SLEEP_EN() uint32 {
	return (volatile.LoadUint32(&o.RTC_STATE0.Reg) & 0x80000000) >> 31
}

// RTC_CNTL.RTC_TIMER1: rtc configure register
func (o *RTC_CNTL_Type) SetRTC_TIMER1_CPU_STALL_EN(value uint32) {
	volatile.StoreUint32(&o.RTC_TIMER1.Reg, volatile.LoadUint32(&o.RTC_TIMER1.Reg)&^(0x1)|value)
}
func (o *RTC_CNTL_Type) GetRTC_TIMER1_CPU_STALL_EN() uint32 {
	return volatile.LoadUint32(&o.RTC_TIMER1.Reg) & 0x1
}
func (o *RTC_CNTL_Type) SetRTC_TIMER1_CPU_STALL_WAIT(value uint32) {
	volatile.StoreUint32(&o.RTC_TIMER1.Reg, volatile.LoadUint32(&o.RTC_TIMER1.Reg)&^(0x3e)|value<<1)
}
func (o *RTC_CNTL_Type) GetRTC_TIMER1_CPU_STALL_WAIT() uint32 {
	return (volatile.LoadUint32(&o.RTC_TIMER1.Reg) & 0x3e) >> 1
}
func (o *RTC_CNTL_Type) SetRTC_TIMER1_CK8M_WAIT(value uint32) {
	volatile.StoreUint32(&o.RTC_TIMER1.Reg, volatile.LoadUint32(&o.RTC_TIMER1.Reg)&^(0x3fc0)|value<<6)
}
func (o *RTC_CNTL_Type) GetRTC_TIMER1_CK8M_WAIT() uint32 {
	return (volatile.LoadUint32(&o.RTC_TIMER1.Reg) & 0x3fc0) >> 6
}
func (o *RTC_CNTL_Type) SetRTC_TIMER1_XTL_BUF_WAIT(value uint32) {
	volatile.StoreUint32(&o.RTC_TIMER1.Reg, volatile.LoadUint32(&o.RTC_TIMER1.Reg)&^(0xffc000)|value<<14)
}
func (o *RTC_CNTL_Type) GetRTC_TIMER1_XTL_BUF_WAIT() uint32 {
	return (volatile.LoadUint32(&o.RTC_TIMER1.Reg) & 0xffc000) >> 14
}
func (o *RTC_CNTL_Type) SetRTC_TIMER1_PLL_BUF_WAIT(value uint32) {
	volatile.StoreUint32(&o.RTC_TIMER1.Reg, volatile.LoadUint32(&o.RTC_TIMER1.Reg)&^(0xff000000)|value<<24)
}
func (o *RTC_CNTL_Type) GetRTC_TIMER1_PLL_BUF_WAIT() uint32 {
	return (volatile.LoadUint32(&o.RTC_TIMER1.Reg) & 0xff000000) >> 24
}

// RTC_CNTL.RTC_TIMER2: rtc configure register
func (o *RTC_CNTL_Type) SetRTC_TIMER2_MIN_TIME_CK8M_OFF(value uint32) {
	volatile.StoreUint32(&o.RTC_TIMER2.Reg, volatile.LoadUint32(&o.RTC_TIMER2.Reg)&^(0xff000000)|value<<24)
}
func (o *RTC_CNTL_Type) GetRTC_TIMER2_MIN_TIME_CK8M_OFF() uint32 {
	return (volatile.LoadUint32(&o.RTC_TIMER2.Reg) & 0xff000000) >> 24
}

// RTC_CNTL.RTC_TIMER3: rtc configure register
func (o *RTC_CNTL_Type) SetRTC_TIMER3_WIFI_WAIT_TIMER(value uint32) {
	volatile.StoreUint32(&o.RTC_TIMER3.Reg, volatile.LoadUint32(&o.RTC_TIMER3.Reg)&^(0x1ff)|value)
}
func (o *RTC_CNTL_Type) GetRTC_TIMER3_WIFI_WAIT_TIMER() uint32 {
	return volatile.LoadUint32(&o.RTC_TIMER3.Reg) & 0x1ff
}
func (o *RTC_CNTL_Type) SetRTC_TIMER3_WIFI_POWERUP_TIMER(value uint32) {
	volatile.StoreUint32(&o.RTC_TIMER3.Reg, volatile.LoadUint32(&o.RTC_TIMER3.Reg)&^(0xfe00)|value<<9)
}
func (o *RTC_CNTL_Type) GetRTC_TIMER3_WIFI_POWERUP_TIMER() uint32 {
	return (volatile.LoadUint32(&o.RTC_TIMER3.Reg) & 0xfe00) >> 9
}
func (o *RTC_CNTL_Type) SetRTC_TIMER3_BT_WAIT_TIMER(value uint32) {
	volatile.StoreUint32(&o.RTC_TIMER3.Reg, volatile.LoadUint32(&o.RTC_TIMER3.Reg)&^(0x1ff0000)|value<<16)
}
func (o *RTC_CNTL_Type) GetRTC_TIMER3_BT_WAIT_TIMER() uint32 {
	return (volatile.LoadUint32(&o.RTC_TIMER3.Reg) & 0x1ff0000) >> 16
}
func (o *RTC_CNTL_Type) SetRTC_TIMER3_BT_POWERUP_TIMER(value uint32) {
	volatile.StoreUint32(&o.RTC_TIMER3.Reg, volatile.LoadUint32(&o.RTC_TIMER3.Reg)&^(0xfe000000)|value<<25)
}
func (o *RTC_CNTL_Type) GetRTC_TIMER3_BT_POWERUP_TIMER() uint32 {
	return (volatile.LoadUint32(&o.RTC_TIMER3.Reg) & 0xfe000000) >> 25
}

// RTC_CNTL.RTC_TIMER4: rtc configure register
func (o *RTC_CNTL_Type) SetRTC_TIMER4_CPU_TOP_WAIT_TIMER(value uint32) {
	volatile.StoreUint32(&o.RTC_TIMER4.Reg, volatile.LoadUint32(&o.RTC_TIMER4.Reg)&^(0x1ff)|value)
}
func (o *RTC_CNTL_Type) GetRTC_TIMER4_CPU_TOP_WAIT_TIMER() uint32 {
	return volatile.LoadUint32(&o.RTC_TIMER4.Reg) & 0x1ff
}
func (o *RTC_CNTL_Type) SetRTC_TIMER4_CPU_TOP_POWERUP_TIMER(value uint32) {
	volatile.StoreUint32(&o.RTC_TIMER4.Reg, volatile.LoadUint32(&o.RTC_TIMER4.Reg)&^(0xfe00)|value<<9)
}
func (o *RTC_CNTL_Type) GetRTC_TIMER4_CPU_TOP_POWERUP_TIMER() uint32 {
	return (volatile.LoadUint32(&o.RTC_TIMER4.Reg) & 0xfe00) >> 9
}
func (o *RTC_CNTL_Type) SetRTC_TIMER4_DG_WRAP_WAIT_TIMER(value uint32) {
	volatile.StoreUint32(&o.RTC_TIMER4.Reg, volatile.LoadUint32(&o.RTC_TIMER4.Reg)&^(0x1ff0000)|value<<16)
}
func (o *RTC_CNTL_Type) GetRTC_TIMER4_DG_WRAP_WAIT_TIMER() uint32 {
	return (volatile.LoadUint32(&o.RTC_TIMER4.Reg) & 0x1ff0000) >> 16
}
func (o *RTC_CNTL_Type) SetRTC_TIMER4_DG_WRAP_POWERUP_TIMER(value uint32) {
	volatile.StoreUint32(&o.RTC_TIMER4.Reg, volatile.LoadUint32(&o.RTC_TIMER4.Reg)&^(0xfe000000)|value<<25)
}
func (o *RTC_CNTL_Type) GetRTC_TIMER4_DG_WRAP_POWERUP_TIMER() uint32 {
	return (volatile.LoadUint32(&o.RTC_TIMER4.Reg) & 0xfe000000) >> 25
}

// RTC_CNTL.RTC_TIMER5: rtc configure register
func (o *RTC_CNTL_Type) SetRTC_TIMER5_MIN_SLP_VAL(value uint32) {
	volatile.StoreUint32(&o.RTC_TIMER5.Reg, volatile.LoadUint32(&o.RTC_TIMER5.Reg)&^(0xff00)|value<<8)
}
func (o *RTC_CNTL_Type) GetRTC_TIMER5_MIN_SLP_VAL() uint32 {
	return (volatile.LoadUint32(&o.RTC_TIMER5.Reg) & 0xff00) >> 8
}

// RTC_CNTL.RTC_TIMER6: rtc configure register
func (o *RTC_CNTL_Type) SetRTC_TIMER6_DG_PERI_WAIT_TIMER(value uint32) {
	volatile.StoreUint32(&o.RTC_TIMER6.Reg, volatile.LoadUint32(&o.RTC_TIMER6.Reg)&^(0x1ff0000)|value<<16)
}
func (o *RTC_CNTL_Type) GetRTC_TIMER6_DG_PERI_WAIT_TIMER() uint32 {
	return (volatile.LoadUint32(&o.RTC_TIMER6.Reg) & 0x1ff0000) >> 16
}
func (o *RTC_CNTL_Type) SetRTC_TIMER6_DG_PERI_POWERUP_TIMER(value uint32) {
	volatile.StoreUint32(&o.RTC_TIMER6.Reg, volatile.LoadUint32(&o.RTC_TIMER6.Reg)&^(0xfe000000)|value<<25)
}
func (o *RTC_CNTL_Type) GetRTC_TIMER6_DG_PERI_POWERUP_TIMER() uint32 {
	return (volatile.LoadUint32(&o.RTC_TIMER6.Reg) & 0xfe000000) >> 25
}

// RTC_CNTL.RTC_ANA_CONF: rtc configure register
func (o *RTC_CNTL_Type) SetRTC_ANA_CONF_RESET_POR_FORCE_PD(value uint32) {
	volatile.StoreUint32(&o.RTC_ANA_CONF.Reg, volatile.LoadUint32(&o.RTC_ANA_CONF.Reg)&^(0x40000)|value<<18)
}
func (o *RTC_CNTL_Type) GetRTC_ANA_CONF_RESET_POR_FORCE_PD() uint32 {
	return (volatile.LoadUint32(&o.RTC_ANA_CONF.Reg) & 0x40000) >> 18
}
func (o *RTC_CNTL_Type) SetRTC_ANA_CONF_RESET_POR_FORCE_PU(value uint32) {
	volatile.StoreUint32(&o.RTC_ANA_CONF.Reg, volatile.LoadUint32(&o.RTC_ANA_CONF.Reg)&^(0x80000)|value<<19)
}
func (o *RTC_CNTL_Type) GetRTC_ANA_CONF_RESET_POR_FORCE_PU() uint32 {
	return (volatile.LoadUint32(&o.RTC_ANA_CONF.Reg) & 0x80000) >> 19
}
func (o *RTC_CNTL_Type) SetRTC_ANA_CONF_GLITCH_RST_EN(value uint32) {
	volatile.StoreUint32(&o.RTC_ANA_CONF.Reg, volatile.LoadUint32(&o.RTC_ANA_CONF.Reg)&^(0x100000)|value<<20)
}
func (o *RTC_CNTL_Type) GetRTC_ANA_CONF_GLITCH_RST_EN() uint32 {
	return (volatile.LoadUint32(&o.RTC_ANA_CONF.Reg) & 0x100000) >> 20
}
func (o *RTC_CNTL_Type) SetRTC_ANA_CONF_SAR_I2C_PU(value uint32) {
	volatile.StoreUint32(&o.RTC_ANA_CONF.Reg, volatile.LoadUint32(&o.RTC_ANA_CONF.Reg)&^(0x400000)|value<<22)
}
func (o *RTC_CNTL_Type) GetRTC_ANA_CONF_SAR_I2C_PU() uint32 {
	return (volatile.LoadUint32(&o.RTC_ANA_CONF.Reg) & 0x400000) >> 22
}
func (o *RTC_CNTL_Type) SetRTC_ANA_CONF_PLLA_FORCE_PD(value uint32) {
	volatile.StoreUint32(&o.RTC_ANA_CONF.Reg, volatile.LoadUint32(&o.RTC_ANA_CONF.Reg)&^(0x800000)|value<<23)
}
func (o *RTC_CNTL_Type) GetRTC_ANA_CONF_PLLA_FORCE_PD() uint32 {
	return (volatile.LoadUint32(&o.RTC_ANA_CONF.Reg) & 0x800000) >> 23
}
func (o *RTC_CNTL_Type) SetRTC_ANA_CONF_PLLA_FORCE_PU(value uint32) {
	volatile.StoreUint32(&o.RTC_ANA_CONF.Reg, volatile.LoadUint32(&o.RTC_ANA_CONF.Reg)&^(0x1000000)|value<<24)
}
func (o *RTC_CNTL_Type) GetRTC_ANA_CONF_PLLA_FORCE_PU() uint32 {
	return (volatile.LoadUint32(&o.RTC_ANA_CONF.Reg) & 0x1000000) >> 24
}
func (o *RTC_CNTL_Type) SetRTC_ANA_CONF_BBPLL_CAL_SLP_START(value uint32) {
	volatile.StoreUint32(&o.RTC_ANA_CONF.Reg, volatile.LoadUint32(&o.RTC_ANA_CONF.Reg)&^(0x2000000)|value<<25)
}
func (o *RTC_CNTL_Type) GetRTC_ANA_CONF_BBPLL_CAL_SLP_START() uint32 {
	return (volatile.LoadUint32(&o.RTC_ANA_CONF.Reg) & 0x2000000) >> 25
}
func (o *RTC_CNTL_Type) SetRTC_ANA_CONF_PVTMON_PU(value uint32) {
	volatile.StoreUint32(&o.RTC_ANA_CONF.Reg, volatile.LoadUint32(&o.RTC_ANA_CONF.Reg)&^(0x4000000)|value<<26)
}
func (o *RTC_CNTL_Type) GetRTC_ANA_CONF_PVTMON_PU() uint32 {
	return (volatile.LoadUint32(&o.RTC_ANA_CONF.Reg) & 0x4000000) >> 26
}
func (o *RTC_CNTL_Type) SetRTC_ANA_CONF_TXRF_I2C_PU(value uint32) {
	volatile.StoreUint32(&o.RTC_ANA_CONF.Reg, volatile.LoadUint32(&o.RTC_ANA_CONF.Reg)&^(0x8000000)|value<<27)
}
func (o *RTC_CNTL_Type) GetRTC_ANA_CONF_TXRF_I2C_PU() uint32 {
	return (volatile.LoadUint32(&o.RTC_ANA_CONF.Reg) & 0x8000000) >> 27
}
func (o *RTC_CNTL_Type) SetRTC_ANA_CONF_RFRX_PBUS_PU(value uint32) {
	volatile.StoreUint32(&o.RTC_ANA_CONF.Reg, volatile.LoadUint32(&o.RTC_ANA_CONF.Reg)&^(0x10000000)|value<<28)
}
func (o *RTC_CNTL_Type) GetRTC_ANA_CONF_RFRX_PBUS_PU() uint32 {
	return (volatile.LoadUint32(&o.RTC_ANA_CONF.Reg) & 0x10000000) >> 28
}
func (o *RTC_CNTL_Type) SetRTC_ANA_CONF_CKGEN_I2C_PU(value uint32) {
	volatile.StoreUint32(&o.RTC_ANA_CONF.Reg, volatile.LoadUint32(&o.RTC_ANA_CONF.Reg)&^(0x40000000)|value<<30)
}
func (o *RTC_CNTL_Type) GetRTC_ANA_CONF_CKGEN_I2C_PU() uint32 {
	return (volatile.LoadUint32(&o.RTC_ANA_CONF.Reg) & 0x40000000) >> 30
}
func (o *RTC_CNTL_Type) SetRTC_ANA_CONF_PLL_I2C_PU(value uint32) {
	volatile.StoreUint32(&o.RTC_ANA_CONF.Reg, volatile.LoadUint32(&o.RTC_ANA_CONF.Reg)&^(0x80000000)|value<<31)
}
func (o *RTC_CNTL_Type) GetRTC_ANA_CONF_PLL_I2C_PU() uint32 {
	return (volatile.LoadUint32(&o.RTC_ANA_CONF.Reg) & 0x80000000) >> 31
}

// RTC_CNTL.RTC_RESET_STATE: rtc configure register
func (o *RTC_CNTL_Type) SetRTC_RESET_STATE_RESET_CAUSE_PROCPU(value uint32) {
	volatile.StoreUint32(&o.RTC_RESET_STATE.Reg, volatile.LoadUint32(&o.RTC_RESET_STATE.Reg)&^(0x3f)|value)
}
func (o *RTC_CNTL_Type) GetRTC_RESET_STATE_RESET_CAUSE_PROCPU() uint32 {
	return volatile.LoadUint32(&o.RTC_RESET_STATE.Reg) & 0x3f
}
func (o *RTC_CNTL_Type) SetRTC_RESET_STATE_RESET_CAUSE_APPCPU(value uint32) {
	volatile.StoreUint32(&o.RTC_RESET_STATE.Reg, volatile.LoadUint32(&o.RTC_RESET_STATE.Reg)&^(0xfc0)|value<<6)
}
func (o *RTC_CNTL_Type) GetRTC_RESET_STATE_RESET_CAUSE_APPCPU() uint32 {
	return (volatile.LoadUint32(&o.RTC_RESET_STATE.Reg) & 0xfc0) >> 6
}
func (o *RTC_CNTL_Type) SetRTC_RESET_STATE_STAT_VECTOR_SEL_APPCPU(value uint32) {
	volatile.StoreUint32(&o.RTC_RESET_STATE.Reg, volatile.LoadUint32(&o.RTC_RESET_STATE.Reg)&^(0x1000)|value<<12)
}
func (o *RTC_CNTL_Type) GetRTC_RESET_STATE_STAT_VECTOR_SEL_APPCPU() uint32 {
	return (volatile.LoadUint32(&o.RTC_RESET_STATE.Reg) & 0x1000) >> 12
}
func (o *RTC_CNTL_Type) SetRTC_RESET_STATE_STAT_VECTOR_SEL_PROCPU(value uint32) {
	volatile.StoreUint32(&o.RTC_RESET_STATE.Reg, volatile.LoadUint32(&o.RTC_RESET_STATE.Reg)&^(0x2000)|value<<13)
}
func (o *RTC_CNTL_Type) GetRTC_RESET_STATE_STAT_VECTOR_SEL_PROCPU() uint32 {
	return (volatile.LoadUint32(&o.RTC_RESET_STATE.Reg) & 0x2000) >> 13
}
func (o *RTC_CNTL_Type) SetRTC_RESET_STATE_ALL_RESET_FLAG_PROCPU(value uint32) {
	volatile.StoreUint32(&o.RTC_RESET_STATE.Reg, volatile.LoadUint32(&o.RTC_RESET_STATE.Reg)&^(0x4000)|value<<14)
}
func (o *RTC_CNTL_Type) GetRTC_RESET_STATE_ALL_RESET_FLAG_PROCPU() uint32 {
	return (volatile.LoadUint32(&o.RTC_RESET_STATE.Reg) & 0x4000) >> 14
}
func (o *RTC_CNTL_Type) SetRTC_RESET_STATE_ALL_RESET_FLAG_APPCPU(value uint32) {
	volatile.StoreUint32(&o.RTC_RESET_STATE.Reg, volatile.LoadUint32(&o.RTC_RESET_STATE.Reg)&^(0x8000)|value<<15)
}
func (o *RTC_CNTL_Type) GetRTC_RESET_STATE_ALL_RESET_FLAG_APPCPU() uint32 {
	return (volatile.LoadUint32(&o.RTC_RESET_STATE.Reg) & 0x8000) >> 15
}
func (o *RTC_CNTL_Type) SetRTC_RESET_STATE_ALL_RESET_FLAG_CLR_PROCPU(value uint32) {
	volatile.StoreUint32(&o.RTC_RESET_STATE.Reg, volatile.LoadUint32(&o.RTC_RESET_STATE.Reg)&^(0x10000)|value<<16)
}
func (o *RTC_CNTL_Type) GetRTC_RESET_STATE_ALL_RESET_FLAG_CLR_PROCPU() uint32 {
	return (volatile.LoadUint32(&o.RTC_RESET_STATE.Reg) & 0x10000) >> 16
}
func (o *RTC_CNTL_Type) SetRTC_RESET_STATE_ALL_RESET_FLAG_CLR_APPCPU(value uint32) {
	volatile.StoreUint32(&o.RTC_RESET_STATE.Reg, volatile.LoadUint32(&o.RTC_RESET_STATE.Reg)&^(0x20000)|value<<17)
}
func (o *RTC_CNTL_Type) GetRTC_RESET_STATE_ALL_RESET_FLAG_CLR_APPCPU() uint32 {
	return (volatile.LoadUint32(&o.RTC_RESET_STATE.Reg) & 0x20000) >> 17
}
func (o *RTC_CNTL_Type) SetRTC_RESET_STATE_OCD_HALT_ON_RESET_APPCPU(value uint32) {
	volatile.StoreUint32(&o.RTC_RESET_STATE.Reg, volatile.LoadUint32(&o.RTC_RESET_STATE.Reg)&^(0x40000)|value<<18)
}
func (o *RTC_CNTL_Type) GetRTC_RESET_STATE_OCD_HALT_ON_RESET_APPCPU() uint32 {
	return (volatile.LoadUint32(&o.RTC_RESET_STATE.Reg) & 0x40000) >> 18
}
func (o *RTC_CNTL_Type) SetRTC_RESET_STATE_OCD_HALT_ON_RESET_PROCPU(value uint32) {
	volatile.StoreUint32(&o.RTC_RESET_STATE.Reg, volatile.LoadUint32(&o.RTC_RESET_STATE.Reg)&^(0x80000)|value<<19)
}
func (o *RTC_CNTL_Type) GetRTC_RESET_STATE_OCD_HALT_ON_RESET_PROCPU() uint32 {
	return (volatile.LoadUint32(&o.RTC_RESET_STATE.Reg) & 0x80000) >> 19
}
func (o *RTC_CNTL_Type) SetRTC_RESET_STATE_JTAG_RESET_FLAG_PROCPU(value uint32) {
	volatile.StoreUint32(&o.RTC_RESET_STATE.Reg, volatile.LoadUint32(&o.RTC_RESET_STATE.Reg)&^(0x100000)|value<<20)
}
func (o *RTC_CNTL_Type) GetRTC_RESET_STATE_JTAG_RESET_FLAG_PROCPU() uint32 {
	return (volatile.LoadUint32(&o.RTC_RESET_STATE.Reg) & 0x100000) >> 20
}
func (o *RTC_CNTL_Type) SetRTC_RESET_STATE_JTAG_RESET_FLAG_APPCPU(value uint32) {
	volatile.StoreUint32(&o.RTC_RESET_STATE.Reg, volatile.LoadUint32(&o.RTC_RESET_STATE.Reg)&^(0x200000)|value<<21)
}
func (o *RTC_CNTL_Type) GetRTC_RESET_STATE_JTAG_RESET_FLAG_APPCPU() uint32 {
	return (volatile.LoadUint32(&o.RTC_RESET_STATE.Reg) & 0x200000) >> 21
}
func (o *RTC_CNTL_Type) SetRTC_RESET_STATE_JTAG_RESET_FLAG_CLR_PROCPU(value uint32) {
	volatile.StoreUint32(&o.RTC_RESET_STATE.Reg, volatile.LoadUint32(&o.RTC_RESET_STATE.Reg)&^(0x400000)|value<<22)
}
func (o *RTC_CNTL_Type) GetRTC_RESET_STATE_JTAG_RESET_FLAG_CLR_PROCPU() uint32 {
	return (volatile.LoadUint32(&o.RTC_RESET_STATE.Reg) & 0x400000) >> 22
}
func (o *RTC_CNTL_Type) SetRTC_RESET_STATE_JTAG_RESET_FLAG_CLR_APPCPU(value uint32) {
	volatile.StoreUint32(&o.RTC_RESET_STATE.Reg, volatile.LoadUint32(&o.RTC_RESET_STATE.Reg)&^(0x800000)|value<<23)
}
func (o *RTC_CNTL_Type) GetRTC_RESET_STATE_JTAG_RESET_FLAG_CLR_APPCPU() uint32 {
	return (volatile.LoadUint32(&o.RTC_RESET_STATE.Reg) & 0x800000) >> 23
}
func (o *RTC_CNTL_Type) SetRTC_RESET_STATE_RTC_DRESET_MASK_APPCPU(value uint32) {
	volatile.StoreUint32(&o.RTC_RESET_STATE.Reg, volatile.LoadUint32(&o.RTC_RESET_STATE.Reg)&^(0x1000000)|value<<24)
}
func (o *RTC_CNTL_Type) GetRTC_RESET_STATE_RTC_DRESET_MASK_APPCPU() uint32 {
	return (volatile.LoadUint32(&o.RTC_RESET_STATE.Reg) & 0x1000000) >> 24
}
func (o *RTC_CNTL_Type) SetRTC_RESET_STATE_RTC_DRESET_MASK_PROCPU(value uint32) {
	volatile.StoreUint32(&o.RTC_RESET_STATE.Reg, volatile.LoadUint32(&o.RTC_RESET_STATE.Reg)&^(0x2000000)|value<<25)
}
func (o *RTC_CNTL_Type) GetRTC_RESET_STATE_RTC_DRESET_MASK_PROCPU() uint32 {
	return (volatile.LoadUint32(&o.RTC_RESET_STATE.Reg) & 0x2000000) >> 25
}

// RTC_CNTL.RTC_WAKEUP_STATE: rtc configure register
func (o *RTC_CNTL_Type) SetRTC_WAKEUP_STATE_RTC_WAKEUP_ENA(value uint32) {
	volatile.StoreUint32(&o.RTC_WAKEUP_STATE.Reg, volatile.LoadUint32(&o.RTC_WAKEUP_STATE.Reg)&^(0xffff8000)|value<<15)
}
func (o *RTC_CNTL_Type) GetRTC_WAKEUP_STATE_RTC_WAKEUP_ENA() uint32 {
	return (volatile.LoadUint32(&o.RTC_WAKEUP_STATE.Reg) & 0xffff8000) >> 15
}

// RTC_CNTL.INT_ENA_RTC: rtc configure register
func (o *RTC_CNTL_Type) SetINT_ENA_RTC_SLP_WAKEUP_INT_ENA(value uint32) {
	volatile.StoreUint32(&o.INT_ENA_RTC.Reg, volatile.LoadUint32(&o.INT_ENA_RTC.Reg)&^(0x1)|value)
}
func (o *RTC_CNTL_Type) GetINT_ENA_RTC_SLP_WAKEUP_INT_ENA() uint32 {
	return volatile.LoadUint32(&o.INT_ENA_RTC.Reg) & 0x1
}
func (o *RTC_CNTL_Type) SetINT_ENA_RTC_SLP_REJECT_INT_ENA(value uint32) {
	volatile.StoreUint32(&o.INT_ENA_RTC.Reg, volatile.LoadUint32(&o.INT_ENA_RTC.Reg)&^(0x2)|value<<1)
}
func (o *RTC_CNTL_Type) GetINT_ENA_RTC_SLP_REJECT_INT_ENA() uint32 {
	return (volatile.LoadUint32(&o.INT_ENA_RTC.Reg) & 0x2) >> 1
}
func (o *RTC_CNTL_Type) SetINT_ENA_RTC_RTC_WDT_INT_ENA(value uint32) {
	volatile.StoreUint32(&o.INT_ENA_RTC.Reg, volatile.LoadUint32(&o.INT_ENA_RTC.Reg)&^(0x8)|value<<3)
}
func (o *RTC_CNTL_Type) GetINT_ENA_RTC_RTC_WDT_INT_ENA() uint32 {
	return (volatile.LoadUint32(&o.INT_ENA_RTC.Reg) & 0x8) >> 3
}
func (o *RTC_CNTL_Type) SetINT_ENA_RTC_RTC_BROWN_OUT_INT_ENA(value uint32) {
	volatile.StoreUint32(&o.INT_ENA_RTC.Reg, volatile.LoadUint32(&o.INT_ENA_RTC.Reg)&^(0x200)|value<<9)
}
func (o *RTC_CNTL_Type) GetINT_ENA_RTC_RTC_BROWN_OUT_INT_ENA() uint32 {
	return (volatile.LoadUint32(&o.INT_ENA_RTC.Reg) & 0x200) >> 9
}
func (o *RTC_CNTL_Type) SetINT_ENA_RTC_RTC_MAIN_TIMER_INT_ENA(value uint32) {
	volatile.StoreUint32(&o.INT_ENA_RTC.Reg, volatile.LoadUint32(&o.INT_ENA_RTC.Reg)&^(0x400)|value<<10)
}
func (o *RTC_CNTL_Type) GetINT_ENA_RTC_RTC_MAIN_TIMER_INT_ENA() uint32 {
	return (volatile.LoadUint32(&o.INT_ENA_RTC.Reg) & 0x400) >> 10
}
func (o *RTC_CNTL_Type) SetINT_ENA_RTC_RTC_SWD_INT_ENA(value uint32) {
	volatile.StoreUint32(&o.INT_ENA_RTC.Reg, volatile.LoadUint32(&o.INT_ENA_RTC.Reg)&^(0x8000)|value<<15)
}
func (o *RTC_CNTL_Type) GetINT_ENA_RTC_RTC_SWD_INT_ENA() uint32 {
	return (volatile.LoadUint32(&o.INT_ENA_RTC.Reg) & 0x8000) >> 15
}
func (o *RTC_CNTL_Type) SetINT_ENA_RTC_RTC_XTAL32K_DEAD_INT_ENA(value uint32) {
	volatile.StoreUint32(&o.INT_ENA_RTC.Reg, volatile.LoadUint32(&o.INT_ENA_RTC.Reg)&^(0x10000)|value<<16)
}
func (o *RTC_CNTL_Type) GetINT_ENA_RTC_RTC_XTAL32K_DEAD_INT_ENA() uint32 {
	return (volatile.LoadUint32(&o.INT_ENA_RTC.Reg) & 0x10000) >> 16
}
func (o *RTC_CNTL_Type) SetINT_ENA_RTC_RTC_GLITCH_DET_INT_ENA(value uint32) {
	volatile.StoreUint32(&o.INT_ENA_RTC.Reg, volatile.LoadUint32(&o.INT_ENA_RTC.Reg)&^(0x80000)|value<<19)
}
func (o *RTC_CNTL_Type) GetINT_ENA_RTC_RTC_GLITCH_DET_INT_ENA() uint32 {
	return (volatile.LoadUint32(&o.INT_ENA_RTC.Reg) & 0x80000) >> 19
}
func (o *RTC_CNTL_Type) SetINT_ENA_RTC_RTC_BBPLL_CAL_INT_ENA(value uint32) {
	volatile.StoreUint32(&o.INT_ENA_RTC.Reg, volatile.LoadUint32(&o.INT_ENA_RTC.Reg)&^(0x100000)|value<<20)
}
func (o *RTC_CNTL_Type) GetINT_ENA_RTC_RTC_BBPLL_CAL_INT_ENA() uint32 {
	return (volatile.LoadUint32(&o.INT_ENA_RTC.Reg) & 0x100000) >> 20
}

// RTC_CNTL.INT_RAW_RTC: rtc configure register
func (o *RTC_CNTL_Type) SetINT_RAW_RTC_SLP_WAKEUP_INT_RAW(value uint32) {
	volatile.StoreUint32(&o.INT_RAW_RTC.Reg, volatile.LoadUint32(&o.INT_RAW_RTC.Reg)&^(0x1)|value)
}
func (o *RTC_CNTL_Type) GetINT_RAW_RTC_SLP_WAKEUP_INT_RAW() uint32 {
	return volatile.LoadUint32(&o.INT_RAW_RTC.Reg) & 0x1
}
func (o *RTC_CNTL_Type) SetINT_RAW_RTC_SLP_REJECT_INT_RAW(value uint32) {
	volatile.StoreUint32(&o.INT_RAW_RTC.Reg, volatile.LoadUint32(&o.INT_RAW_RTC.Reg)&^(0x2)|value<<1)
}
func (o *RTC_CNTL_Type) GetINT_RAW_RTC_SLP_REJECT_INT_RAW() uint32 {
	return (volatile.LoadUint32(&o.INT_RAW_RTC.Reg) & 0x2) >> 1
}
func (o *RTC_CNTL_Type) SetINT_RAW_RTC_RTC_WDT_INT_RAW(value uint32) {
	volatile.StoreUint32(&o.INT_RAW_RTC.Reg, volatile.LoadUint32(&o.INT_RAW_RTC.Reg)&^(0x8)|value<<3)
}
func (o *RTC_CNTL_Type) GetINT_RAW_RTC_RTC_WDT_INT_RAW() uint32 {
	return (volatile.LoadUint32(&o.INT_RAW_RTC.Reg) & 0x8) >> 3
}
func (o *RTC_CNTL_Type) SetINT_RAW_RTC_RTC_BROWN_OUT_INT_RAW(value uint32) {
	volatile.StoreUint32(&o.INT_RAW_RTC.Reg, volatile.LoadUint32(&o.INT_RAW_RTC.Reg)&^(0x200)|value<<9)
}
func (o *RTC_CNTL_Type) GetINT_RAW_RTC_RTC_BROWN_OUT_INT_RAW() uint32 {
	return (volatile.LoadUint32(&o.INT_RAW_RTC.Reg) & 0x200) >> 9
}
func (o *RTC_CNTL_Type) SetINT_RAW_RTC_RTC_MAIN_TIMER_INT_RAW(value uint32) {
	volatile.StoreUint32(&o.INT_RAW_RTC.Reg, volatile.LoadUint32(&o.INT_RAW_RTC.Reg)&^(0x400)|value<<10)
}
func (o *RTC_CNTL_Type) GetINT_RAW_RTC_RTC_MAIN_TIMER_INT_RAW() uint32 {
	return (volatile.LoadUint32(&o.INT_RAW_RTC.Reg) & 0x400) >> 10
}
func (o *RTC_CNTL_Type) SetINT_RAW_RTC_RTC_SWD_INT_RAW(value uint32) {
	volatile.StoreUint32(&o.INT_RAW_RTC.Reg, volatile.LoadUint32(&o.INT_RAW_RTC.Reg)&^(0x8000)|value<<15)
}
func (o *RTC_CNTL_Type) GetINT_RAW_RTC_RTC_SWD_INT_RAW() uint32 {
	return (volatile.LoadUint32(&o.INT_RAW_RTC.Reg) & 0x8000) >> 15
}
func (o *RTC_CNTL_Type) SetINT_RAW_RTC_RTC_XTAL32K_DEAD_INT_RAW(value uint32) {
	volatile.StoreUint32(&o.INT_RAW_RTC.Reg, volatile.LoadUint32(&o.INT_RAW_RTC.Reg)&^(0x10000)|value<<16)
}
func (o *RTC_CNTL_Type) GetINT_RAW_RTC_RTC_XTAL32K_DEAD_INT_RAW() uint32 {
	return (volatile.LoadUint32(&o.INT_RAW_RTC.Reg) & 0x10000) >> 16
}
func (o *RTC_CNTL_Type) SetINT_RAW_RTC_RTC_GLITCH_DET_INT_RAW(value uint32) {
	volatile.StoreUint32(&o.INT_RAW_RTC.Reg, volatile.LoadUint32(&o.INT_RAW_RTC.Reg)&^(0x80000)|value<<19)
}
func (o *RTC_CNTL_Type) GetINT_RAW_RTC_RTC_GLITCH_DET_INT_RAW() uint32 {
	return (volatile.LoadUint32(&o.INT_RAW_RTC.Reg) & 0x80000) >> 19
}
func (o *RTC_CNTL_Type) SetINT_RAW_RTC_RTC_BBPLL_CAL_INT_RAW(value uint32) {
	volatile.StoreUint32(&o.INT_RAW_RTC.Reg, volatile.LoadUint32(&o.INT_RAW_RTC.Reg)&^(0x100000)|value<<20)
}
func (o *RTC_CNTL_Type) GetINT_RAW_RTC_RTC_BBPLL_CAL_INT_RAW() uint32 {
	return (volatile.LoadUint32(&o.INT_RAW_RTC.Reg) & 0x100000) >> 20
}

// RTC_CNTL.INT_ST_RTC: rtc configure register
func (o *RTC_CNTL_Type) SetINT_ST_RTC_SLP_WAKEUP_INT_ST(value uint32) {
	volatile.StoreUint32(&o.INT_ST_RTC.Reg, volatile.LoadUint32(&o.INT_ST_RTC.Reg)&^(0x1)|value)
}
func (o *RTC_CNTL_Type) GetINT_ST_RTC_SLP_WAKEUP_INT_ST() uint32 {
	return volatile.LoadUint32(&o.INT_ST_RTC.Reg) & 0x1
}
func (o *RTC_CNTL_Type) SetINT_ST_RTC_SLP_REJECT_INT_ST(value uint32) {
	volatile.StoreUint32(&o.INT_ST_RTC.Reg, volatile.LoadUint32(&o.INT_ST_RTC.Reg)&^(0x2)|value<<1)
}
func (o *RTC_CNTL_Type) GetINT_ST_RTC_SLP_REJECT_INT_ST() uint32 {
	return (volatile.LoadUint32(&o.INT_ST_RTC.Reg) & 0x2) >> 1
}
func (o *RTC_CNTL_Type) SetINT_ST_RTC_RTC_WDT_INT_ST(value uint32) {
	volatile.StoreUint32(&o.INT_ST_RTC.Reg, volatile.LoadUint32(&o.INT_ST_RTC.Reg)&^(0x8)|value<<3)
}
func (o *RTC_CNTL_Type) GetINT_ST_RTC_RTC_WDT_INT_ST() uint32 {
	return (volatile.LoadUint32(&o.INT_ST_RTC.Reg) & 0x8) >> 3
}
func (o *RTC_CNTL_Type) SetINT_ST_RTC_RTC_BROWN_OUT_INT_ST(value uint32) {
	volatile.StoreUint32(&o.INT_ST_RTC.Reg, volatile.LoadUint32(&o.INT_ST_RTC.Reg)&^(0x200)|value<<9)
}
func (o *RTC_CNTL_Type) GetINT_ST_RTC_RTC_BROWN_OUT_INT_ST() uint32 {
	return (volatile.LoadUint32(&o.INT_ST_RTC.Reg) & 0x200) >> 9
}
func (o *RTC_CNTL_Type) SetINT_ST_RTC_RTC_MAIN_TIMER_INT_ST(value uint32) {
	volatile.StoreUint32(&o.INT_ST_RTC.Reg, volatile.LoadUint32(&o.INT_ST_RTC.Reg)&^(0x400)|value<<10)
}
func (o *RTC_CNTL_Type) GetINT_ST_RTC_RTC_MAIN_TIMER_INT_ST() uint32 {
	return (volatile.LoadUint32(&o.INT_ST_RTC.Reg) & 0x400) >> 10
}
func (o *RTC_CNTL_Type) SetINT_ST_RTC_RTC_SWD_INT_ST(value uint32) {
	volatile.StoreUint32(&o.INT_ST_RTC.Reg, volatile.LoadUint32(&o.INT_ST_RTC.Reg)&^(0x8000)|value<<15)
}
func (o *RTC_CNTL_Type) GetINT_ST_RTC_RTC_SWD_INT_ST() uint32 {
	return (volatile.LoadUint32(&o.INT_ST_RTC.Reg) & 0x8000) >> 15
}
func (o *RTC_CNTL_Type) SetINT_ST_RTC_RTC_XTAL32K_DEAD_INT_ST(value uint32) {
	volatile.StoreUint32(&o.INT_ST_RTC.Reg, volatile.LoadUint32(&o.INT_ST_RTC.Reg)&^(0x10000)|value<<16)
}
func (o *RTC_CNTL_Type) GetINT_ST_RTC_RTC_XTAL32K_DEAD_INT_ST() uint32 {
	return (volatile.LoadUint32(&o.INT_ST_RTC.Reg) & 0x10000) >> 16
}
func (o *RTC_CNTL_Type) SetINT_ST_RTC_RTC_GLITCH_DET_INT_ST(value uint32) {
	volatile.StoreUint32(&o.INT_ST_RTC.Reg, volatile.LoadUint32(&o.INT_ST_RTC.Reg)&^(0x80000)|value<<19)
}
func (o *RTC_CNTL_Type) GetINT_ST_RTC_RTC_GLITCH_DET_INT_ST() uint32 {
	return (volatile.LoadUint32(&o.INT_ST_RTC.Reg) & 0x80000) >> 19
}
func (o *RTC_CNTL_Type) SetINT_ST_RTC_RTC_BBPLL_CAL_INT_ST(value uint32) {
	volatile.StoreUint32(&o.INT_ST_RTC.Reg, volatile.LoadUint32(&o.INT_ST_RTC.Reg)&^(0x100000)|value<<20)
}
func (o *RTC_CNTL_Type) GetINT_ST_RTC_RTC_BBPLL_CAL_INT_ST() uint32 {
	return (volatile.LoadUint32(&o.INT_ST_RTC.Reg) & 0x100000) >> 20
}

// RTC_CNTL.INT_CLR_RTC: rtc configure register
func (o *RTC_CNTL_Type) SetINT_CLR_RTC_SLP_WAKEUP_INT_CLR(value uint32) {
	volatile.StoreUint32(&o.INT_CLR_RTC.Reg, volatile.LoadUint32(&o.INT_CLR_RTC.Reg)&^(0x1)|value)
}
func (o *RTC_CNTL_Type) GetINT_CLR_RTC_SLP_WAKEUP_INT_CLR() uint32 {
	return volatile.LoadUint32(&o.INT_CLR_RTC.Reg) & 0x1
}
func (o *RTC_CNTL_Type) SetINT_CLR_RTC_SLP_REJECT_INT_CLR(value uint32) {
	volatile.StoreUint32(&o.INT_CLR_RTC.Reg, volatile.LoadUint32(&o.INT_CLR_RTC.Reg)&^(0x2)|value<<1)
}
func (o *RTC_CNTL_Type) GetINT_CLR_RTC_SLP_REJECT_INT_CLR() uint32 {
	return (volatile.LoadUint32(&o.INT_CLR_RTC.Reg) & 0x2) >> 1
}
func (o *RTC_CNTL_Type) SetINT_CLR_RTC_RTC_WDT_INT_CLR(value uint32) {
	volatile.StoreUint32(&o.INT_CLR_RTC.Reg, volatile.LoadUint32(&o.INT_CLR_RTC.Reg)&^(0x8)|value<<3)
}
func (o *RTC_CNTL_Type) GetINT_CLR_RTC_RTC_WDT_INT_CLR() uint32 {
	return (volatile.LoadUint32(&o.INT_CLR_RTC.Reg) & 0x8) >> 3
}
func (o *RTC_CNTL_Type) SetINT_CLR_RTC_RTC_BROWN_OUT_INT_CLR(value uint32) {
	volatile.StoreUint32(&o.INT_CLR_RTC.Reg, volatile.LoadUint32(&o.INT_CLR_RTC.Reg)&^(0x200)|value<<9)
}
func (o *RTC_CNTL_Type) GetINT_CLR_RTC_RTC_BROWN_OUT_INT_CLR() uint32 {
	return (volatile.LoadUint32(&o.INT_CLR_RTC.Reg) & 0x200) >> 9
}
func (o *RTC_CNTL_Type) SetINT_CLR_RTC_RTC_MAIN_TIMER_INT_CLR(value uint32) {
	volatile.StoreUint32(&o.INT_CLR_RTC.Reg, volatile.LoadUint32(&o.INT_CLR_RTC.Reg)&^(0x400)|value<<10)
}
func (o *RTC_CNTL_Type) GetINT_CLR_RTC_RTC_MAIN_TIMER_INT_CLR() uint32 {
	return (volatile.LoadUint32(&o.INT_CLR_RTC.Reg) & 0x400) >> 10
}
func (o *RTC_CNTL_Type) SetINT_CLR_RTC_RTC_SWD_INT_CLR(value uint32) {
	volatile.StoreUint32(&o.INT_CLR_RTC.Reg, volatile.LoadUint32(&o.INT_CLR_RTC.Reg)&^(0x8000)|value<<15)
}
func (o *RTC_CNTL_Type) GetINT_CLR_RTC_RTC_SWD_INT_CLR() uint32 {
	return (volatile.LoadUint32(&o.INT_CLR_RTC.Reg) & 0x8000) >> 15
}
func (o *RTC_CNTL_Type) SetINT_CLR_RTC_RTC_XTAL32K_DEAD_INT_CLR(value uint32) {
	volatile.StoreUint32(&o.INT_CLR_RTC.Reg, volatile.LoadUint32(&o.INT_CLR_RTC.Reg)&^(0x10000)|value<<16)
}
func (o *RTC_CNTL_Type) GetINT_CLR_RTC_RTC_XTAL32K_DEAD_INT_CLR() uint32 {
	return (volatile.LoadUint32(&o.INT_CLR_RTC.Reg) & 0x10000) >> 16
}
func (o *RTC_CNTL_Type) SetINT_CLR_RTC_RTC_GLITCH_DET_INT_CLR(value uint32) {
	volatile.StoreUint32(&o.INT_CLR_RTC.Reg, volatile.LoadUint32(&o.INT_CLR_RTC.Reg)&^(0x80000)|value<<19)
}
func (o *RTC_CNTL_Type) GetINT_CLR_RTC_RTC_GLITCH_DET_INT_CLR() uint32 {
	return (volatile.LoadUint32(&o.INT_CLR_RTC.Reg) & 0x80000) >> 19
}
func (o *RTC_CNTL_Type) SetINT_CLR_RTC_RTC_BBPLL_CAL_INT_CLR(value uint32) {
	volatile.StoreUint32(&o.INT_CLR_RTC.Reg, volatile.LoadUint32(&o.INT_CLR_RTC.Reg)&^(0x100000)|value<<20)
}
func (o *RTC_CNTL_Type) GetINT_CLR_RTC_RTC_BBPLL_CAL_INT_CLR() uint32 {
	return (volatile.LoadUint32(&o.INT_CLR_RTC.Reg) & 0x100000) >> 20
}

// RTC_CNTL.RTC_STORE0: rtc configure register
func (o *RTC_CNTL_Type) SetRTC_STORE0(value uint32) {
	volatile.StoreUint32(&o.RTC_STORE0.Reg, value)
}
func (o *RTC_CNTL_Type) GetRTC_STORE0() uint32 {
	return volatile.LoadUint32(&o.RTC_STORE0.Reg)
}

// RTC_CNTL.RTC_STORE1: rtc configure register
func (o *RTC_CNTL_Type) SetRTC_STORE1(value uint32) {
	volatile.StoreUint32(&o.RTC_STORE1.Reg, value)
}
func (o *RTC_CNTL_Type) GetRTC_STORE1() uint32 {
	return volatile.LoadUint32(&o.RTC_STORE1.Reg)
}

// RTC_CNTL.RTC_STORE2: rtc configure register
func (o *RTC_CNTL_Type) SetRTC_STORE2(value uint32) {
	volatile.StoreUint32(&o.RTC_STORE2.Reg, value)
}
func (o *RTC_CNTL_Type) GetRTC_STORE2() uint32 {
	return volatile.LoadUint32(&o.RTC_STORE2.Reg)
}

// RTC_CNTL.RTC_STORE3: rtc configure register
func (o *RTC_CNTL_Type) SetRTC_STORE3(value uint32) {
	volatile.StoreUint32(&o.RTC_STORE3.Reg, value)
}
func (o *RTC_CNTL_Type) GetRTC_STORE3() uint32 {
	return volatile.LoadUint32(&o.RTC_STORE3.Reg)
}

// RTC_CNTL.RTC_EXT_XTL_CONF: rtc configure register
func (o *RTC_CNTL_Type) SetRTC_EXT_XTL_CONF_XTAL32K_WDT_EN(value uint32) {
	volatile.StoreUint32(&o.RTC_EXT_XTL_CONF.Reg, volatile.LoadUint32(&o.RTC_EXT_XTL_CONF.Reg)&^(0x1)|value)
}
func (o *RTC_CNTL_Type) GetRTC_EXT_XTL_CONF_XTAL32K_WDT_EN() uint32 {
	return volatile.LoadUint32(&o.RTC_EXT_XTL_CONF.Reg) & 0x1
}
func (o *RTC_CNTL_Type) SetRTC_EXT_XTL_CONF_XTAL32K_WDT_CLK_FO(value uint32) {
	volatile.StoreUint32(&o.RTC_EXT_XTL_CONF.Reg, volatile.LoadUint32(&o.RTC_EXT_XTL_CONF.Reg)&^(0x2)|value<<1)
}
func (o *RTC_CNTL_Type) GetRTC_EXT_XTL_CONF_XTAL32K_WDT_CLK_FO() uint32 {
	return (volatile.LoadUint32(&o.RTC_EXT_XTL_CONF.Reg) & 0x2) >> 1
}
func (o *RTC_CNTL_Type) SetRTC_EXT_XTL_CONF_XTAL32K_WDT_RESET(value uint32) {
	volatile.StoreUint32(&o.RTC_EXT_XTL_CONF.Reg, volatile.LoadUint32(&o.RTC_EXT_XTL_CONF.Reg)&^(0x4)|value<<2)
}
func (o *RTC_CNTL_Type) GetRTC_EXT_XTL_CONF_XTAL32K_WDT_RESET() uint32 {
	return (volatile.LoadUint32(&o.RTC_EXT_XTL_CONF.Reg) & 0x4) >> 2
}
func (o *RTC_CNTL_Type) SetRTC_EXT_XTL_CONF_XTAL32K_EXT_CLK_FO(value uint32) {
	volatile.StoreUint32(&o.RTC_EXT_XTL_CONF.Reg, volatile.LoadUint32(&o.RTC_EXT_XTL_CONF.Reg)&^(0x8)|value<<3)
}
func (o *RTC_CNTL_Type) GetRTC_EXT_XTL_CONF_XTAL32K_EXT_CLK_FO() uint32 {
	return (volatile.LoadUint32(&o.RTC_EXT_XTL_CONF.Reg) & 0x8) >> 3
}
func (o *RTC_CNTL_Type) SetRTC_EXT_XTL_CONF_XTAL32K_AUTO_BACKUP(value uint32) {
	volatile.StoreUint32(&o.RTC_EXT_XTL_CONF.Reg, volatile.LoadUint32(&o.RTC_EXT_XTL_CONF.Reg)&^(0x10)|value<<4)
}
func (o *RTC_CNTL_Type) GetRTC_EXT_XTL_CONF_XTAL32K_AUTO_BACKUP() uint32 {
	return (volatile.LoadUint32(&o.RTC_EXT_XTL_CONF.Reg) & 0x10) >> 4
}
func (o *RTC_CNTL_Type) SetRTC_EXT_XTL_CONF_XTAL32K_AUTO_RESTART(value uint32) {
	volatile.StoreUint32(&o.RTC_EXT_XTL_CONF.Reg, volatile.LoadUint32(&o.RTC_EXT_XTL_CONF.Reg)&^(0x20)|value<<5)
}
func (o *RTC_CNTL_Type) GetRTC_EXT_XTL_CONF_XTAL32K_AUTO_RESTART() uint32 {
	return (volatile.LoadUint32(&o.RTC_EXT_XTL_CONF.Reg) & 0x20) >> 5
}
func (o *RTC_CNTL_Type) SetRTC_EXT_XTL_CONF_XTAL32K_AUTO_RETURN(value uint32) {
	volatile.StoreUint32(&o.RTC_EXT_XTL_CONF.Reg, volatile.LoadUint32(&o.RTC_EXT_XTL_CONF.Reg)&^(0x40)|value<<6)
}
func (o *RTC_CNTL_Type) GetRTC_EXT_XTL_CONF_XTAL32K_AUTO_RETURN() uint32 {
	return (volatile.LoadUint32(&o.RTC_EXT_XTL_CONF.Reg) & 0x40) >> 6
}
func (o *RTC_CNTL_Type) SetRTC_EXT_XTL_CONF_XTAL32K_XPD_FORCE(value uint32) {
	volatile.StoreUint32(&o.RTC_EXT_XTL_CONF.Reg, volatile.LoadUint32(&o.RTC_EXT_XTL_CONF.Reg)&^(0x80)|value<<7)
}
func (o *RTC_CNTL_Type) GetRTC_EXT_XTL_CONF_XTAL32K_XPD_FORCE() uint32 {
	return (volatile.LoadUint32(&o.RTC_EXT_XTL_CONF.Reg) & 0x80) >> 7
}
func (o *RTC_CNTL_Type) SetRTC_EXT_XTL_CONF_ENCKINIT_XTAL_32K(value uint32) {
	volatile.StoreUint32(&o.RTC_EXT_XTL_CONF.Reg, volatile.LoadUint32(&o.RTC_EXT_XTL_CONF.Reg)&^(0x100)|value<<8)
}
func (o *RTC_CNTL_Type) GetRTC_EXT_XTL_CONF_ENCKINIT_XTAL_32K() uint32 {
	return (volatile.LoadUint32(&o.RTC_EXT_XTL_CONF.Reg) & 0x100) >> 8
}
func (o *RTC_CNTL_Type) SetRTC_EXT_XTL_CONF_DBUF_XTAL_32K(value uint32) {
	volatile.StoreUint32(&o.RTC_EXT_XTL_CONF.Reg, volatile.LoadUint32(&o.RTC_EXT_XTL_CONF.Reg)&^(0x200)|value<<9)
}
func (o *RTC_CNTL_Type) GetRTC_EXT_XTL_CONF_DBUF_XTAL_32K() uint32 {
	return (volatile.LoadUint32(&o.RTC_EXT_XTL_CONF.Reg) & 0x200) >> 9
}
func (o *RTC_CNTL_Type) SetRTC_EXT_XTL_CONF_DGM_XTAL_32K(value uint32) {
	volatile.StoreUint32(&o.RTC_EXT_XTL_CONF.Reg, volatile.LoadUint32(&o.RTC_EXT_XTL_CONF.Reg)&^(0x1c00)|value<<10)
}
func (o *RTC_CNTL_Type) GetRTC_EXT_XTL_CONF_DGM_XTAL_32K() uint32 {
	return (volatile.LoadUint32(&o.RTC_EXT_XTL_CONF.Reg) & 0x1c00) >> 10
}
func (o *RTC_CNTL_Type) SetRTC_EXT_XTL_CONF_DRES_XTAL_32K(value uint32) {
	volatile.StoreUint32(&o.RTC_EXT_XTL_CONF.Reg, volatile.LoadUint32(&o.RTC_EXT_XTL_CONF.Reg)&^(0xe000)|value<<13)
}
func (o *RTC_CNTL_Type) GetRTC_EXT_XTL_CONF_DRES_XTAL_32K() uint32 {
	return (volatile.LoadUint32(&o.RTC_EXT_XTL_CONF.Reg) & 0xe000) >> 13
}
func (o *RTC_CNTL_Type) SetRTC_EXT_XTL_CONF_XPD_XTAL_32K(value uint32) {
	volatile.StoreUint32(&o.RTC_EXT_XTL_CONF.Reg, volatile.LoadUint32(&o.RTC_EXT_XTL_CONF.Reg)&^(0x10000)|value<<16)
}
func (o *RTC_CNTL_Type) GetRTC_EXT_XTL_CONF_XPD_XTAL_32K() uint32 {
	return (volatile.LoadUint32(&o.RTC_EXT_XTL_CONF.Reg) & 0x10000) >> 16
}
func (o *RTC_CNTL_Type) SetRTC_EXT_XTL_CONF_DAC_XTAL_32K(value uint32) {
	volatile.StoreUint32(&o.RTC_EXT_XTL_CONF.Reg, volatile.LoadUint32(&o.RTC_EXT_XTL_CONF.Reg)&^(0xe0000)|value<<17)
}
func (o *RTC_CNTL_Type) GetRTC_EXT_XTL_CONF_DAC_XTAL_32K() uint32 {
	return (volatile.LoadUint32(&o.RTC_EXT_XTL_CONF.Reg) & 0xe0000) >> 17
}
func (o *RTC_CNTL_Type) SetRTC_EXT_XTL_CONF_RTC_WDT_STATE(value uint32) {
	volatile.StoreUint32(&o.RTC_EXT_XTL_CONF.Reg, volatile.LoadUint32(&o.RTC_EXT_XTL_CONF.Reg)&^(0x700000)|value<<20)
}
func (o *RTC_CNTL_Type) GetRTC_EXT_XTL_CONF_RTC_WDT_STATE() uint32 {
	return (volatile.LoadUint32(&o.RTC_EXT_XTL_CONF.Reg) & 0x700000) >> 20
}
func (o *RTC_CNTL_Type) SetRTC_EXT_XTL_CONF_RTC_XTAL32K_GPIO_SEL(value uint32) {
	volatile.StoreUint32(&o.RTC_EXT_XTL_CONF.Reg, volatile.LoadUint32(&o.RTC_EXT_XTL_CONF.Reg)&^(0x800000)|value<<23)
}
func (o *RTC_CNTL_Type) GetRTC_EXT_XTL_CONF_RTC_XTAL32K_GPIO_SEL() uint32 {
	return (volatile.LoadUint32(&o.RTC_EXT_XTL_CONF.Reg) & 0x800000) >> 23
}
func (o *RTC_CNTL_Type) SetRTC_EXT_XTL_CONF_XTL_EXT_CTR_LV(value uint32) {
	volatile.StoreUint32(&o.RTC_EXT_XTL_CONF.Reg, volatile.LoadUint32(&o.RTC_EXT_XTL_CONF.Reg)&^(0x40000000)|value<<30)
}
func (o *RTC_CNTL_Type) GetRTC_EXT_XTL_CONF_XTL_EXT_CTR_LV() uint32 {
	return (volatile.LoadUint32(&o.RTC_EXT_XTL_CONF.Reg) & 0x40000000) >> 30
}
func (o *RTC_CNTL_Type) SetRTC_EXT_XTL_CONF_XTL_EXT_CTR_EN(value uint32) {
	volatile.StoreUint32(&o.RTC_EXT_XTL_CONF.Reg, volatile.LoadUint32(&o.RTC_EXT_XTL_CONF.Reg)&^(0x80000000)|value<<31)
}
func (o *RTC_CNTL_Type) GetRTC_EXT_XTL_CONF_XTL_EXT_CTR_EN() uint32 {
	return (volatile.LoadUint32(&o.RTC_EXT_XTL_CONF.Reg) & 0x80000000) >> 31
}

// RTC_CNTL.RTC_EXT_WAKEUP_CONF: rtc configure register
func (o *RTC_CNTL_Type) SetRTC_EXT_WAKEUP_CONF_GPIO_WAKEUP_FILTER(value uint32) {
	volatile.StoreUint32(&o.RTC_EXT_WAKEUP_CONF.Reg, volatile.LoadUint32(&o.RTC_EXT_WAKEUP_CONF.Reg)&^(0x80000000)|value<<31)
}
func (o *RTC_CNTL_Type) GetRTC_EXT_WAKEUP_CONF_GPIO_WAKEUP_FILTER() uint32 {
	return (volatile.LoadUint32(&o.RTC_EXT_WAKEUP_CONF.Reg) & 0x80000000) >> 31
}

// RTC_CNTL.RTC_SLP_REJECT_CONF: rtc configure register
func (o *RTC_CNTL_Type) SetRTC_SLP_REJECT_CONF_RTC_SLEEP_REJECT_ENA(value uint32) {
	volatile.StoreUint32(&o.RTC_SLP_REJECT_CONF.Reg, volatile.LoadUint32(&o.RTC_SLP_REJECT_CONF.Reg)&^(0x3ffff000)|value<<12)
}
func (o *RTC_CNTL_Type) GetRTC_SLP_REJECT_CONF_RTC_SLEEP_REJECT_ENA() uint32 {
	return (volatile.LoadUint32(&o.RTC_SLP_REJECT_CONF.Reg) & 0x3ffff000) >> 12
}
func (o *RTC_CNTL_Type) SetRTC_SLP_REJECT_CONF_LIGHT_SLP_REJECT_EN(value uint32) {
	volatile.StoreUint32(&o.RTC_SLP_REJECT_CONF.Reg, volatile.LoadUint32(&o.RTC_SLP_REJECT_CONF.Reg)&^(0x40000000)|value<<30)
}
func (o *RTC_CNTL_Type) GetRTC_SLP_REJECT_CONF_LIGHT_SLP_REJECT_EN() uint32 {
	return (volatile.LoadUint32(&o.RTC_SLP_REJECT_CONF.Reg) & 0x40000000) >> 30
}
func (o *RTC_CNTL_Type) SetRTC_SLP_REJECT_CONF_DEEP_SLP_REJECT_EN(value uint32) {
	volatile.StoreUint32(&o.RTC_SLP_REJECT_CONF.Reg, volatile.LoadUint32(&o.RTC_SLP_REJECT_CONF.Reg)&^(0x80000000)|value<<31)
}
func (o *RTC_CNTL_Type) GetRTC_SLP_REJECT_CONF_DEEP_SLP_REJECT_EN() uint32 {
	return (volatile.LoadUint32(&o.RTC_SLP_REJECT_CONF.Reg) & 0x80000000) >> 31
}

// RTC_CNTL.RTC_CPU_PERIOD_CONF: rtc configure register
func (o *RTC_CNTL_Type) SetRTC_CPU_PERIOD_CONF_RTC_CPUSEL_CONF(value uint32) {
	volatile.StoreUint32(&o.RTC_CPU_PERIOD_CONF.Reg, volatile.LoadUint32(&o.RTC_CPU_PERIOD_CONF.Reg)&^(0x20000000)|value<<29)
}
func (o *RTC_CNTL_Type) GetRTC_CPU_PERIOD_CONF_RTC_CPUSEL_CONF() uint32 {
	return (volatile.LoadUint32(&o.RTC_CPU_PERIOD_CONF.Reg) & 0x20000000) >> 29
}
func (o *RTC_CNTL_Type) SetRTC_CPU_PERIOD_CONF_RTC_CPUPERIOD_SEL(value uint32) {
	volatile.StoreUint32(&o.RTC_CPU_PERIOD_CONF.Reg, volatile.LoadUint32(&o.RTC_CPU_PERIOD_CONF.Reg)&^(0xc0000000)|value<<30)
}
func (o *RTC_CNTL_Type) GetRTC_CPU_PERIOD_CONF_RTC_CPUPERIOD_SEL() uint32 {
	return (volatile.LoadUint32(&o.RTC_CPU_PERIOD_CONF.Reg) & 0xc0000000) >> 30
}

// RTC_CNTL.RTC_CLK_CONF: rtc configure register
func (o *RTC_CNTL_Type) SetRTC_CLK_CONF_EFUSE_CLK_FORCE_GATING(value uint32) {
	volatile.StoreUint32(&o.RTC_CLK_CONF.Reg, volatile.LoadUint32(&o.RTC_CLK_CONF.Reg)&^(0x2)|value<<1)
}
func (o *RTC_CNTL_Type) GetRTC_CLK_CONF_EFUSE_CLK_FORCE_GATING() uint32 {
	return (volatile.LoadUint32(&o.RTC_CLK_CONF.Reg) & 0x2) >> 1
}
func (o *RTC_CNTL_Type) SetRTC_CLK_CONF_EFUSE_CLK_FORCE_NOGATING(value uint32) {
	volatile.StoreUint32(&o.RTC_CLK_CONF.Reg, volatile.LoadUint32(&o.RTC_CLK_CONF.Reg)&^(0x4)|value<<2)
}
func (o *RTC_CNTL_Type) GetRTC_CLK_CONF_EFUSE_CLK_FORCE_NOGATING() uint32 {
	return (volatile.LoadUint32(&o.RTC_CLK_CONF.Reg) & 0x4) >> 2
}
func (o *RTC_CNTL_Type) SetRTC_CLK_CONF_CK8M_DIV_SEL_VLD(value uint32) {
	volatile.StoreUint32(&o.RTC_CLK_CONF.Reg, volatile.LoadUint32(&o.RTC_CLK_CONF.Reg)&^(0x8)|value<<3)
}
func (o *RTC_CNTL_Type) GetRTC_CLK_CONF_CK8M_DIV_SEL_VLD() uint32 {
	return (volatile.LoadUint32(&o.RTC_CLK_CONF.Reg) & 0x8) >> 3
}
func (o *RTC_CNTL_Type) SetRTC_CLK_CONF_CK8M_DIV(value uint32) {
	volatile.StoreUint32(&o.RTC_CLK_CONF.Reg, volatile.LoadUint32(&o.RTC_CLK_CONF.Reg)&^(0x30)|value<<4)
}
func (o *RTC_CNTL_Type) GetRTC_CLK_CONF_CK8M_DIV() uint32 {
	return (volatile.LoadUint32(&o.RTC_CLK_CONF.Reg) & 0x30) >> 4
}
func (o *RTC_CNTL_Type) SetRTC_CLK_CONF_ENB_CK8M(value uint32) {
	volatile.StoreUint32(&o.RTC_CLK_CONF.Reg, volatile.LoadUint32(&o.RTC_CLK_CONF.Reg)&^(0x40)|value<<6)
}
func (o *RTC_CNTL_Type) GetRTC_CLK_CONF_ENB_CK8M() uint32 {
	return (volatile.LoadUint32(&o.RTC_CLK_CONF.Reg) & 0x40) >> 6
}
func (o *RTC_CNTL_Type) SetRTC_CLK_CONF_ENB_CK8M_DIV(value uint32) {
	volatile.StoreUint32(&o.RTC_CLK_CONF.Reg, volatile.LoadUint32(&o.RTC_CLK_CONF.Reg)&^(0x80)|value<<7)
}
func (o *RTC_CNTL_Type) GetRTC_CLK_CONF_ENB_CK8M_DIV() uint32 {
	return (volatile.LoadUint32(&o.RTC_CLK_CONF.Reg) & 0x80) >> 7
}
func (o *RTC_CNTL_Type) SetRTC_CLK_CONF_DIG_XTAL32K_EN(value uint32) {
	volatile.StoreUint32(&o.RTC_CLK_CONF.Reg, volatile.LoadUint32(&o.RTC_CLK_CONF.Reg)&^(0x100)|value<<8)
}
func (o *RTC_CNTL_Type) GetRTC_CLK_CONF_DIG_XTAL32K_EN() uint32 {
	return (volatile.LoadUint32(&o.RTC_CLK_CONF.Reg) & 0x100) >> 8
}
func (o *RTC_CNTL_Type) SetRTC_CLK_CONF_DIG_CLK8M_D256_EN(value uint32) {
	volatile.StoreUint32(&o.RTC_CLK_CONF.Reg, volatile.LoadUint32(&o.RTC_CLK_CONF.Reg)&^(0x200)|value<<9)
}
func (o *RTC_CNTL_Type) GetRTC_CLK_CONF_DIG_CLK8M_D256_EN() uint32 {
	return (volatile.LoadUint32(&o.RTC_CLK_CONF.Reg) & 0x200) >> 9
}
func (o *RTC_CNTL_Type) SetRTC_CLK_CONF_DIG_CLK8M_EN(value uint32) {
	volatile.StoreUint32(&o.RTC_CLK_CONF.Reg, volatile.LoadUint32(&o.RTC_CLK_CONF.Reg)&^(0x400)|value<<10)
}
func (o *RTC_CNTL_Type) GetRTC_CLK_CONF_DIG_CLK8M_EN() uint32 {
	return (volatile.LoadUint32(&o.RTC_CLK_CONF.Reg) & 0x400) >> 10
}
func (o *RTC_CNTL_Type) SetRTC_CLK_CONF_CK8M_DIV_SEL(value uint32) {
	volatile.StoreUint32(&o.RTC_CLK_CONF.Reg, volatile.LoadUint32(&o.RTC_CLK_CONF.Reg)&^(0x7000)|value<<12)
}
func (o *RTC_CNTL_Type) GetRTC_CLK_CONF_CK8M_DIV_SEL() uint32 {
	return (volatile.LoadUint32(&o.RTC_CLK_CONF.Reg) & 0x7000) >> 12
}
func (o *RTC_CNTL_Type) SetRTC_CLK_CONF_XTAL_FORCE_NOGATING(value uint32) {
	volatile.StoreUint32(&o.RTC_CLK_CONF.Reg, volatile.LoadUint32(&o.RTC_CLK_CONF.Reg)&^(0x8000)|value<<15)
}
func (o *RTC_CNTL_Type) GetRTC_CLK_CONF_XTAL_FORCE_NOGATING() uint32 {
	return (volatile.LoadUint32(&o.RTC_CLK_CONF.Reg) & 0x8000) >> 15
}
func (o *RTC_CNTL_Type) SetRTC_CLK_CONF_CK8M_FORCE_NOGATING(value uint32) {
	volatile.StoreUint32(&o.RTC_CLK_CONF.Reg, volatile.LoadUint32(&o.RTC_CLK_CONF.Reg)&^(0x10000)|value<<16)
}
func (o *RTC_CNTL_Type) GetRTC_CLK_CONF_CK8M_FORCE_NOGATING() uint32 {
	return (volatile.LoadUint32(&o.RTC_CLK_CONF.Reg) & 0x10000) >> 16
}
func (o *RTC_CNTL_Type) SetRTC_CLK_CONF_CK8M_DFREQ(value uint32) {
	volatile.StoreUint32(&o.RTC_CLK_CONF.Reg, volatile.LoadUint32(&o.RTC_CLK_CONF.Reg)&^(0x1fe0000)|value<<17)
}
func (o *RTC_CNTL_Type) GetRTC_CLK_CONF_CK8M_DFREQ() uint32 {
	return (volatile.LoadUint32(&o.RTC_CLK_CONF.Reg) & 0x1fe0000) >> 17
}
func (o *RTC_CNTL_Type) SetRTC_CLK_CONF_CK8M_FORCE_PD(value uint32) {
	volatile.StoreUint32(&o.RTC_CLK_CONF.Reg, volatile.LoadUint32(&o.RTC_CLK_CONF.Reg)&^(0x2000000)|value<<25)
}
func (o *RTC_CNTL_Type) GetRTC_CLK_CONF_CK8M_FORCE_PD() uint32 {
	return (volatile.LoadUint32(&o.RTC_CLK_CONF.Reg) & 0x2000000) >> 25
}
func (o *RTC_CNTL_Type) SetRTC_CLK_CONF_CK8M_FORCE_PU(value uint32) {
	volatile.StoreUint32(&o.RTC_CLK_CONF.Reg, volatile.LoadUint32(&o.RTC_CLK_CONF.Reg)&^(0x4000000)|value<<26)
}
func (o *RTC_CNTL_Type) GetRTC_CLK_CONF_CK8M_FORCE_PU() uint32 {
	return (volatile.LoadUint32(&o.RTC_CLK_CONF.Reg) & 0x4000000) >> 26
}
func (o *RTC_CNTL_Type) SetRTC_CLK_CONF_XTAL_GLOBAL_FORCE_GATING(value uint32) {
	volatile.StoreUint32(&o.RTC_CLK_CONF.Reg, volatile.LoadUint32(&o.RTC_CLK_CONF.Reg)&^(0x8000000)|value<<27)
}
func (o *RTC_CNTL_Type) GetRTC_CLK_CONF_XTAL_GLOBAL_FORCE_GATING() uint32 {
	return (volatile.LoadUint32(&o.RTC_CLK_CONF.Reg) & 0x8000000) >> 27
}
func (o *RTC_CNTL_Type) SetRTC_CLK_CONF_XTAL_GLOBAL_FORCE_NOGATING(value uint32) {
	volatile.StoreUint32(&o.RTC_CLK_CONF.Reg, volatile.LoadUint32(&o.RTC_CLK_CONF.Reg)&^(0x10000000)|value<<28)
}
func (o *RTC_CNTL_Type) GetRTC_CLK_CONF_XTAL_GLOBAL_FORCE_NOGATING() uint32 {
	return (volatile.LoadUint32(&o.RTC_CLK_CONF.Reg) & 0x10000000) >> 28
}
func (o *RTC_CNTL_Type) SetRTC_CLK_CONF_FAST_CLK_RTC_SEL(value uint32) {
	volatile.StoreUint32(&o.RTC_CLK_CONF.Reg, volatile.LoadUint32(&o.RTC_CLK_CONF.Reg)&^(0x20000000)|value<<29)
}
func (o *RTC_CNTL_Type) GetRTC_CLK_CONF_FAST_CLK_RTC_SEL() uint32 {
	return (volatile.LoadUint32(&o.RTC_CLK_CONF.Reg) & 0x20000000) >> 29
}
func (o *RTC_CNTL_Type) SetRTC_CLK_CONF_ANA_CLK_RTC_SEL(value uint32) {
	volatile.StoreUint32(&o.RTC_CLK_CONF.Reg, volatile.LoadUint32(&o.RTC_CLK_CONF.Reg)&^(0xc0000000)|value<<30)
}
func (o *RTC_CNTL_Type) GetRTC_CLK_CONF_ANA_CLK_RTC_SEL() uint32 {
	return (volatile.LoadUint32(&o.RTC_CLK_CONF.Reg) & 0xc0000000) >> 30
}

// RTC_CNTL.RTC_SLOW_CLK_CONF: rtc configure register
func (o *RTC_CNTL_Type) SetRTC_SLOW_CLK_CONF_RTC_ANA_CLK_DIV_VLD(value uint32) {
	volatile.StoreUint32(&o.RTC_SLOW_CLK_CONF.Reg, volatile.LoadUint32(&o.RTC_SLOW_CLK_CONF.Reg)&^(0x400000)|value<<22)
}
func (o *RTC_CNTL_Type) GetRTC_SLOW_CLK_CONF_RTC_ANA_CLK_DIV_VLD() uint32 {
	return (volatile.LoadUint32(&o.RTC_SLOW_CLK_CONF.Reg) & 0x400000) >> 22
}
func (o *RTC_CNTL_Type) SetRTC_SLOW_CLK_CONF_RTC_ANA_CLK_DIV(value uint32) {
	volatile.StoreUint32(&o.RTC_SLOW_CLK_CONF.Reg, volatile.LoadUint32(&o.RTC_SLOW_CLK_CONF.Reg)&^(0x7f800000)|value<<23)
}
func (o *RTC_CNTL_Type) GetRTC_SLOW_CLK_CONF_RTC_ANA_CLK_DIV() uint32 {
	return (volatile.LoadUint32(&o.RTC_SLOW_CLK_CONF.Reg) & 0x7f800000) >> 23
}
func (o *RTC_CNTL_Type) SetRTC_SLOW_CLK_CONF_RTC_SLOW_CLK_NEXT_EDGE(value uint32) {
	volatile.StoreUint32(&o.RTC_SLOW_CLK_CONF.Reg, volatile.LoadUint32(&o.RTC_SLOW_CLK_CONF.Reg)&^(0x80000000)|value<<31)
}
func (o *RTC_CNTL_Type) GetRTC_SLOW_CLK_CONF_RTC_SLOW_CLK_NEXT_EDGE() uint32 {
	return (volatile.LoadUint32(&o.RTC_SLOW_CLK_CONF.Reg) & 0x80000000) >> 31
}

// RTC_CNTL.RTC_SDIO_CONF: rtc configure register
func (o *RTC_CNTL_Type) SetRTC_SDIO_CONF_SDIO_TIMER_TARGET(value uint32) {
	volatile.StoreUint32(&o.RTC_SDIO_CONF.Reg, volatile.LoadUint32(&o.RTC_SDIO_CONF.Reg)&^(0xff)|value)
}
func (o *RTC_CNTL_Type) GetRTC_SDIO_CONF_SDIO_TIMER_TARGET() uint32 {
	return volatile.LoadUint32(&o.RTC_SDIO_CONF.Reg) & 0xff
}
func (o *RTC_CNTL_Type) SetRTC_SDIO_CONF_SDIO_DTHDRV(value uint32) {
	volatile.StoreUint32(&o.RTC_SDIO_CONF.Reg, volatile.LoadUint32(&o.RTC_SDIO_CONF.Reg)&^(0x600)|value<<9)
}
func (o *RTC_CNTL_Type) GetRTC_SDIO_CONF_SDIO_DTHDRV() uint32 {
	return (volatile.LoadUint32(&o.RTC_SDIO_CONF.Reg) & 0x600) >> 9
}
func (o *RTC_CNTL_Type) SetRTC_SDIO_CONF_SDIO_DCAP(value uint32) {
	volatile.StoreUint32(&o.RTC_SDIO_CONF.Reg, volatile.LoadUint32(&o.RTC_SDIO_CONF.Reg)&^(0x1800)|value<<11)
}
func (o *RTC_CNTL_Type) GetRTC_SDIO_CONF_SDIO_DCAP() uint32 {
	return (volatile.LoadUint32(&o.RTC_SDIO_CONF.Reg) & 0x1800) >> 11
}
func (o *RTC_CNTL_Type) SetRTC_SDIO_CONF_SDIO_INITI(value uint32) {
	volatile.StoreUint32(&o.RTC_SDIO_CONF.Reg, volatile.LoadUint32(&o.RTC_SDIO_CONF.Reg)&^(0x6000)|value<<13)
}
func (o *RTC_CNTL_Type) GetRTC_SDIO_CONF_SDIO_INITI() uint32 {
	return (volatile.LoadUint32(&o.RTC_SDIO_CONF.Reg) & 0x6000) >> 13
}
func (o *RTC_CNTL_Type) SetRTC_SDIO_CONF_SDIO_EN_INITI(value uint32) {
	volatile.StoreUint32(&o.RTC_SDIO_CONF.Reg, volatile.LoadUint32(&o.RTC_SDIO_CONF.Reg)&^(0x8000)|value<<15)
}
func (o *RTC_CNTL_Type) GetRTC_SDIO_CONF_SDIO_EN_INITI() uint32 {
	return (volatile.LoadUint32(&o.RTC_SDIO_CONF.Reg) & 0x8000) >> 15
}
func (o *RTC_CNTL_Type) SetRTC_SDIO_CONF_SDIO_DCURLIM(value uint32) {
	volatile.StoreUint32(&o.RTC_SDIO_CONF.Reg, volatile.LoadUint32(&o.RTC_SDIO_CONF.Reg)&^(0x70000)|value<<16)
}
func (o *RTC_CNTL_Type) GetRTC_SDIO_CONF_SDIO_DCURLIM() uint32 {
	return (volatile.LoadUint32(&o.RTC_SDIO_CONF.Reg) & 0x70000) >> 16
}
func (o *RTC_CNTL_Type) SetRTC_SDIO_CONF_SDIO_MODECURLIM(value uint32) {
	volatile.StoreUint32(&o.RTC_SDIO_CONF.Reg, volatile.LoadUint32(&o.RTC_SDIO_CONF.Reg)&^(0x80000)|value<<19)
}
func (o *RTC_CNTL_Type) GetRTC_SDIO_CONF_SDIO_MODECURLIM() uint32 {
	return (volatile.LoadUint32(&o.RTC_SDIO_CONF.Reg) & 0x80000) >> 19
}
func (o *RTC_CNTL_Type) SetRTC_SDIO_CONF_SDIO_ENCURLIM(value uint32) {
	volatile.StoreUint32(&o.RTC_SDIO_CONF.Reg, volatile.LoadUint32(&o.RTC_SDIO_CONF.Reg)&^(0x100000)|value<<20)
}
func (o *RTC_CNTL_Type) GetRTC_SDIO_CONF_SDIO_ENCURLIM() uint32 {
	return (volatile.LoadUint32(&o.RTC_SDIO_CONF.Reg) & 0x100000) >> 20
}
func (o *RTC_CNTL_Type) SetRTC_SDIO_CONF_SDIO_REG_PD_EN(value uint32) {
	volatile.StoreUint32(&o.RTC_SDIO_CONF.Reg, volatile.LoadUint32(&o.RTC_SDIO_CONF.Reg)&^(0x200000)|value<<21)
}
func (o *RTC_CNTL_Type) GetRTC_SDIO_CONF_SDIO_REG_PD_EN() uint32 {
	return (volatile.LoadUint32(&o.RTC_SDIO_CONF.Reg) & 0x200000) >> 21
}
func (o *RTC_CNTL_Type) SetRTC_SDIO_CONF_SDIO_FORCE(value uint32) {
	volatile.StoreUint32(&o.RTC_SDIO_CONF.Reg, volatile.LoadUint32(&o.RTC_SDIO_CONF.Reg)&^(0x400000)|value<<22)
}
func (o *RTC_CNTL_Type) GetRTC_SDIO_CONF_SDIO_FORCE() uint32 {
	return (volatile.LoadUint32(&o.RTC_SDIO_CONF.Reg) & 0x400000) >> 22
}
func (o *RTC_CNTL_Type) SetRTC_SDIO_CONF_SDIO_TIEH(value uint32) {
	volatile.StoreUint32(&o.RTC_SDIO_CONF.Reg, volatile.LoadUint32(&o.RTC_SDIO_CONF.Reg)&^(0x800000)|value<<23)
}
func (o *RTC_CNTL_Type) GetRTC_SDIO_CONF_SDIO_TIEH() uint32 {
	return (volatile.LoadUint32(&o.RTC_SDIO_CONF.Reg) & 0x800000) >> 23
}
func (o *RTC_CNTL_Type) SetRTC_SDIO_CONF__1P8_READY(value uint32) {
	volatile.StoreUint32(&o.RTC_SDIO_CONF.Reg, volatile.LoadUint32(&o.RTC_SDIO_CONF.Reg)&^(0x1000000)|value<<24)
}
func (o *RTC_CNTL_Type) GetRTC_SDIO_CONF__1P8_READY() uint32 {
	return (volatile.LoadUint32(&o.RTC_SDIO_CONF.Reg) & 0x1000000) >> 24
}
func (o *RTC_CNTL_Type) SetRTC_SDIO_CONF_DREFL_SDIO(value uint32) {
	volatile.StoreUint32(&o.RTC_SDIO_CONF.Reg, volatile.LoadUint32(&o.RTC_SDIO_CONF.Reg)&^(0x6000000)|value<<25)
}
func (o *RTC_CNTL_Type) GetRTC_SDIO_CONF_DREFL_SDIO() uint32 {
	return (volatile.LoadUint32(&o.RTC_SDIO_CONF.Reg) & 0x6000000) >> 25
}
func (o *RTC_CNTL_Type) SetRTC_SDIO_CONF_DREFM_SDIO(value uint32) {
	volatile.StoreUint32(&o.RTC_SDIO_CONF.Reg, volatile.LoadUint32(&o.RTC_SDIO_CONF.Reg)&^(0x18000000)|value<<27)
}
func (o *RTC_CNTL_Type) GetRTC_SDIO_CONF_DREFM_SDIO() uint32 {
	return (volatile.LoadUint32(&o.RTC_SDIO_CONF.Reg) & 0x18000000) >> 27
}
func (o *RTC_CNTL_Type) SetRTC_SDIO_CONF_DREFH_SDIO(value uint32) {
	volatile.StoreUint32(&o.RTC_SDIO_CONF.Reg, volatile.LoadUint32(&o.RTC_SDIO_CONF.Reg)&^(0x60000000)|value<<29)
}
func (o *RTC_CNTL_Type) GetRTC_SDIO_CONF_DREFH_SDIO() uint32 {
	return (volatile.LoadUint32(&o.RTC_SDIO_CONF.Reg) & 0x60000000) >> 29
}
func (o *RTC_CNTL_Type) SetRTC_SDIO_CONF_XPD_SDIO(value uint32) {
	volatile.StoreUint32(&o.RTC_SDIO_CONF.Reg, volatile.LoadUint32(&o.RTC_SDIO_CONF.Reg)&^(0x80000000)|value<<31)
}
func (o *RTC_CNTL_Type) GetRTC_SDIO_CONF_XPD_SDIO() uint32 {
	return (volatile.LoadUint32(&o.RTC_SDIO_CONF.Reg) & 0x80000000) >> 31
}

// RTC_CNTL.RTC_BIAS_CONF: rtc configure register
func (o *RTC_CNTL_Type) SetRTC_BIAS_CONF_DG_VDD_DRV_B_SLP(value uint32) {
	volatile.StoreUint32(&o.RTC_BIAS_CONF.Reg, volatile.LoadUint32(&o.RTC_BIAS_CONF.Reg)&^(0xff)|value)
}
func (o *RTC_CNTL_Type) GetRTC_BIAS_CONF_DG_VDD_DRV_B_SLP() uint32 {
	return volatile.LoadUint32(&o.RTC_BIAS_CONF.Reg) & 0xff
}
func (o *RTC_CNTL_Type) SetRTC_BIAS_CONF_DG_VDD_DRV_B_SLP_EN(value uint32) {
	volatile.StoreUint32(&o.RTC_BIAS_CONF.Reg, volatile.LoadUint32(&o.RTC_BIAS_CONF.Reg)&^(0x100)|value<<8)
}
func (o *RTC_CNTL_Type) GetRTC_BIAS_CONF_DG_VDD_DRV_B_SLP_EN() uint32 {
	return (volatile.LoadUint32(&o.RTC_BIAS_CONF.Reg) & 0x100) >> 8
}
func (o *RTC_CNTL_Type) SetRTC_BIAS_CONF_BIAS_BUF_IDLE(value uint32) {
	volatile.StoreUint32(&o.RTC_BIAS_CONF.Reg, volatile.LoadUint32(&o.RTC_BIAS_CONF.Reg)&^(0x400)|value<<10)
}
func (o *RTC_CNTL_Type) GetRTC_BIAS_CONF_BIAS_BUF_IDLE() uint32 {
	return (volatile.LoadUint32(&o.RTC_BIAS_CONF.Reg) & 0x400) >> 10
}
func (o *RTC_CNTL_Type) SetRTC_BIAS_CONF_BIAS_BUF_WAKE(value uint32) {
	volatile.StoreUint32(&o.RTC_BIAS_CONF.Reg, volatile.LoadUint32(&o.RTC_BIAS_CONF.Reg)&^(0x800)|value<<11)
}
func (o *RTC_CNTL_Type) GetRTC_BIAS_CONF_BIAS_BUF_WAKE() uint32 {
	return (volatile.LoadUint32(&o.RTC_BIAS_CONF.Reg) & 0x800) >> 11
}
func (o *RTC_CNTL_Type) SetRTC_BIAS_CONF_BIAS_BUF_DEEP_SLP(value uint32) {
	volatile.StoreUint32(&o.RTC_BIAS_CONF.Reg, volatile.LoadUint32(&o.RTC_BIAS_CONF.Reg)&^(0x1000)|value<<12)
}
func (o *RTC_CNTL_Type) GetRTC_BIAS_CONF_BIAS_BUF_DEEP_SLP() uint32 {
	return (volatile.LoadUint32(&o.RTC_BIAS_CONF.Reg) & 0x1000) >> 12
}
func (o *RTC_CNTL_Type) SetRTC_BIAS_CONF_BIAS_BUF_MONITOR(value uint32) {
	volatile.StoreUint32(&o.RTC_BIAS_CONF.Reg, volatile.LoadUint32(&o.RTC_BIAS_CONF.Reg)&^(0x2000)|value<<13)
}
func (o *RTC_CNTL_Type) GetRTC_BIAS_CONF_BIAS_BUF_MONITOR() uint32 {
	return (volatile.LoadUint32(&o.RTC_BIAS_CONF.Reg) & 0x2000) >> 13
}
func (o *RTC_CNTL_Type) SetRTC_BIAS_CONF_PD_CUR_DEEP_SLP(value uint32) {
	volatile.StoreUint32(&o.RTC_BIAS_CONF.Reg, volatile.LoadUint32(&o.RTC_BIAS_CONF.Reg)&^(0x4000)|value<<14)
}
func (o *RTC_CNTL_Type) GetRTC_BIAS_CONF_PD_CUR_DEEP_SLP() uint32 {
	return (volatile.LoadUint32(&o.RTC_BIAS_CONF.Reg) & 0x4000) >> 14
}
func (o *RTC_CNTL_Type) SetRTC_BIAS_CONF_PD_CUR_MONITOR(value uint32) {
	volatile.StoreUint32(&o.RTC_BIAS_CONF.Reg, volatile.LoadUint32(&o.RTC_BIAS_CONF.Reg)&^(0x8000)|value<<15)
}
func (o *RTC_CNTL_Type) GetRTC_BIAS_CONF_PD_CUR_MONITOR() uint32 {
	return (volatile.LoadUint32(&o.RTC_BIAS_CONF.Reg) & 0x8000) >> 15
}
func (o *RTC_CNTL_Type) SetRTC_BIAS_CONF_BIAS_SLEEP_DEEP_SLP(value uint32) {
	volatile.StoreUint32(&o.RTC_BIAS_CONF.Reg, volatile.LoadUint32(&o.RTC_BIAS_CONF.Reg)&^(0x10000)|value<<16)
}
func (o *RTC_CNTL_Type) GetRTC_BIAS_CONF_BIAS_SLEEP_DEEP_SLP() uint32 {
	return (volatile.LoadUint32(&o.RTC_BIAS_CONF.Reg) & 0x10000) >> 16
}
func (o *RTC_CNTL_Type) SetRTC_BIAS_CONF_BIAS_SLEEP_MONITOR(value uint32) {
	volatile.StoreUint32(&o.RTC_BIAS_CONF.Reg, volatile.LoadUint32(&o.RTC_BIAS_CONF.Reg)&^(0x20000)|value<<17)
}
func (o *RTC_CNTL_Type) GetRTC_BIAS_CONF_BIAS_SLEEP_MONITOR() uint32 {
	return (volatile.LoadUint32(&o.RTC_BIAS_CONF.Reg) & 0x20000) >> 17
}
func (o *RTC_CNTL_Type) SetRTC_BIAS_CONF_DBG_ATTEN_DEEP_SLP(value uint32) {
	volatile.StoreUint32(&o.RTC_BIAS_CONF.Reg, volatile.LoadUint32(&o.RTC_BIAS_CONF.Reg)&^(0x3c0000)|value<<18)
}
func (o *RTC_CNTL_Type) GetRTC_BIAS_CONF_DBG_ATTEN_DEEP_SLP() uint32 {
	return (volatile.LoadUint32(&o.RTC_BIAS_CONF.Reg) & 0x3c0000) >> 18
}
func (o *RTC_CNTL_Type) SetRTC_BIAS_CONF_DBG_ATTEN_MONITOR(value uint32) {
	volatile.StoreUint32(&o.RTC_BIAS_CONF.Reg, volatile.LoadUint32(&o.RTC_BIAS_CONF.Reg)&^(0x3c00000)|value<<22)
}
func (o *RTC_CNTL_Type) GetRTC_BIAS_CONF_DBG_ATTEN_MONITOR() uint32 {
	return (volatile.LoadUint32(&o.RTC_BIAS_CONF.Reg) & 0x3c00000) >> 22
}

// RTC_CNTL.RTC: rtc configure register
func (o *RTC_CNTL_Type) SetRTC_DIG_REG_CAL_EN(value uint32) {
	volatile.StoreUint32(&o.RTC.Reg, volatile.LoadUint32(&o.RTC.Reg)&^(0x80)|value<<7)
}
func (o *RTC_CNTL_Type) GetRTC_DIG_REG_CAL_EN() uint32 {
	return (volatile.LoadUint32(&o.RTC.Reg) & 0x80) >> 7
}
func (o *RTC_CNTL_Type) SetRTC_SCK_DCAP(value uint32) {
	volatile.StoreUint32(&o.RTC.Reg, volatile.LoadUint32(&o.RTC.Reg)&^(0x3fc000)|value<<14)
}
func (o *RTC_CNTL_Type) GetRTC_SCK_DCAP() uint32 {
	return (volatile.LoadUint32(&o.RTC.Reg) & 0x3fc000) >> 14
}
func (o *RTC_CNTL_Type) SetRTC_DBOOST_FORCE_PD(value uint32) {
	volatile.StoreUint32(&o.RTC.Reg, volatile.LoadUint32(&o.RTC.Reg)&^(0x10000000)|value<<28)
}
func (o *RTC_CNTL_Type) GetRTC_DBOOST_FORCE_PD() uint32 {
	return (volatile.LoadUint32(&o.RTC.Reg) & 0x10000000) >> 28
}
func (o *RTC_CNTL_Type) SetRTC_DBOOST_FORCE_PU(value uint32) {
	volatile.StoreUint32(&o.RTC.Reg, volatile.LoadUint32(&o.RTC.Reg)&^(0x20000000)|value<<29)
}
func (o *RTC_CNTL_Type) GetRTC_DBOOST_FORCE_PU() uint32 {
	return (volatile.LoadUint32(&o.RTC.Reg) & 0x20000000) >> 29
}
func (o *RTC_CNTL_Type) SetRTC_REGULATOR_FORCE_PD(value uint32) {
	volatile.StoreUint32(&o.RTC.Reg, volatile.LoadUint32(&o.RTC.Reg)&^(0x40000000)|value<<30)
}
func (o *RTC_CNTL_Type) GetRTC_REGULATOR_FORCE_PD() uint32 {
	return (volatile.LoadUint32(&o.RTC.Reg) & 0x40000000) >> 30
}
func (o *RTC_CNTL_Type) SetRTC_REGULATOR_FORCE_PU(value uint32) {
	volatile.StoreUint32(&o.RTC.Reg, volatile.LoadUint32(&o.RTC.Reg)&^(0x80000000)|value<<31)
}
func (o *RTC_CNTL_Type) GetRTC_REGULATOR_FORCE_PU() uint32 {
	return (volatile.LoadUint32(&o.RTC.Reg) & 0x80000000) >> 31
}

// RTC_CNTL.RTC_PWC: rtc configure register
func (o *RTC_CNTL_Type) SetRTC_PWC_RTC_PAD_FORCE_HOLD(value uint32) {
	volatile.StoreUint32(&o.RTC_PWC.Reg, volatile.LoadUint32(&o.RTC_PWC.Reg)&^(0x200000)|value<<21)
}
func (o *RTC_CNTL_Type) GetRTC_PWC_RTC_PAD_FORCE_HOLD() uint32 {
	return (volatile.LoadUint32(&o.RTC_PWC.Reg) & 0x200000) >> 21
}

// RTC_CNTL.DIG_PWC: rtc configure register
func (o *RTC_CNTL_Type) SetDIG_PWC_VDD_SPI_PWR_DRV(value uint32) {
	volatile.StoreUint32(&o.DIG_PWC.Reg, volatile.LoadUint32(&o.DIG_PWC.Reg)&^(0x3)|value)
}
func (o *RTC_CNTL_Type) GetDIG_PWC_VDD_SPI_PWR_DRV() uint32 {
	return volatile.LoadUint32(&o.DIG_PWC.Reg) & 0x3
}
func (o *RTC_CNTL_Type) SetDIG_PWC_VDD_SPI_PWR_FORCE(value uint32) {
	volatile.StoreUint32(&o.DIG_PWC.Reg, volatile.LoadUint32(&o.DIG_PWC.Reg)&^(0x4)|value<<2)
}
func (o *RTC_CNTL_Type) GetDIG_PWC_VDD_SPI_PWR_FORCE() uint32 {
	return (volatile.LoadUint32(&o.DIG_PWC.Reg) & 0x4) >> 2
}
func (o *RTC_CNTL_Type) SetDIG_PWC_LSLP_MEM_FORCE_PD(value uint32) {
	volatile.StoreUint32(&o.DIG_PWC.Reg, volatile.LoadUint32(&o.DIG_PWC.Reg)&^(0x8)|value<<3)
}
func (o *RTC_CNTL_Type) GetDIG_PWC_LSLP_MEM_FORCE_PD() uint32 {
	return (volatile.LoadUint32(&o.DIG_PWC.Reg) & 0x8) >> 3
}
func (o *RTC_CNTL_Type) SetDIG_PWC_LSLP_MEM_FORCE_PU(value uint32) {
	volatile.StoreUint32(&o.DIG_PWC.Reg, volatile.LoadUint32(&o.DIG_PWC.Reg)&^(0x10)|value<<4)
}
func (o *RTC_CNTL_Type) GetDIG_PWC_LSLP_MEM_FORCE_PU() uint32 {
	return (volatile.LoadUint32(&o.DIG_PWC.Reg) & 0x10) >> 4
}
func (o *RTC_CNTL_Type) SetDIG_PWC_BT_FORCE_PD(value uint32) {
	volatile.StoreUint32(&o.DIG_PWC.Reg, volatile.LoadUint32(&o.DIG_PWC.Reg)&^(0x800)|value<<11)
}
func (o *RTC_CNTL_Type) GetDIG_PWC_BT_FORCE_PD() uint32 {
	return (volatile.LoadUint32(&o.DIG_PWC.Reg) & 0x800) >> 11
}
func (o *RTC_CNTL_Type) SetDIG_PWC_BT_FORCE_PU(value uint32) {
	volatile.StoreUint32(&o.DIG_PWC.Reg, volatile.LoadUint32(&o.DIG_PWC.Reg)&^(0x1000)|value<<12)
}
func (o *RTC_CNTL_Type) GetDIG_PWC_BT_FORCE_PU() uint32 {
	return (volatile.LoadUint32(&o.DIG_PWC.Reg) & 0x1000) >> 12
}
func (o *RTC_CNTL_Type) SetDIG_PWC_DG_PERI_FORCE_PD(value uint32) {
	volatile.StoreUint32(&o.DIG_PWC.Reg, volatile.LoadUint32(&o.DIG_PWC.Reg)&^(0x2000)|value<<13)
}
func (o *RTC_CNTL_Type) GetDIG_PWC_DG_PERI_FORCE_PD() uint32 {
	return (volatile.LoadUint32(&o.DIG_PWC.Reg) & 0x2000) >> 13
}
func (o *RTC_CNTL_Type) SetDIG_PWC_DG_PERI_FORCE_PU(value uint32) {
	volatile.StoreUint32(&o.DIG_PWC.Reg, volatile.LoadUint32(&o.DIG_PWC.Reg)&^(0x4000)|value<<14)
}
func (o *RTC_CNTL_Type) GetDIG_PWC_DG_PERI_FORCE_PU() uint32 {
	return (volatile.LoadUint32(&o.DIG_PWC.Reg) & 0x4000) >> 14
}
func (o *RTC_CNTL_Type) SetDIG_PWC_RTC_FASTMEM_FORCE_LPD(value uint32) {
	volatile.StoreUint32(&o.DIG_PWC.Reg, volatile.LoadUint32(&o.DIG_PWC.Reg)&^(0x8000)|value<<15)
}
func (o *RTC_CNTL_Type) GetDIG_PWC_RTC_FASTMEM_FORCE_LPD() uint32 {
	return (volatile.LoadUint32(&o.DIG_PWC.Reg) & 0x8000) >> 15
}
func (o *RTC_CNTL_Type) SetDIG_PWC_RTC_FASTMEM_FORCE_LPU(value uint32) {
	volatile.StoreUint32(&o.DIG_PWC.Reg, volatile.LoadUint32(&o.DIG_PWC.Reg)&^(0x10000)|value<<16)
}
func (o *RTC_CNTL_Type) GetDIG_PWC_RTC_FASTMEM_FORCE_LPU() uint32 {
	return (volatile.LoadUint32(&o.DIG_PWC.Reg) & 0x10000) >> 16
}
func (o *RTC_CNTL_Type) SetDIG_PWC_WIFI_FORCE_PD(value uint32) {
	volatile.StoreUint32(&o.DIG_PWC.Reg, volatile.LoadUint32(&o.DIG_PWC.Reg)&^(0x20000)|value<<17)
}
func (o *RTC_CNTL_Type) GetDIG_PWC_WIFI_FORCE_PD() uint32 {
	return (volatile.LoadUint32(&o.DIG_PWC.Reg) & 0x20000) >> 17
}
func (o *RTC_CNTL_Type) SetDIG_PWC_WIFI_FORCE_PU(value uint32) {
	volatile.StoreUint32(&o.DIG_PWC.Reg, volatile.LoadUint32(&o.DIG_PWC.Reg)&^(0x40000)|value<<18)
}
func (o *RTC_CNTL_Type) GetDIG_PWC_WIFI_FORCE_PU() uint32 {
	return (volatile.LoadUint32(&o.DIG_PWC.Reg) & 0x40000) >> 18
}
func (o *RTC_CNTL_Type) SetDIG_PWC_DG_WRAP_FORCE_PD(value uint32) {
	volatile.StoreUint32(&o.DIG_PWC.Reg, volatile.LoadUint32(&o.DIG_PWC.Reg)&^(0x80000)|value<<19)
}
func (o *RTC_CNTL_Type) GetDIG_PWC_DG_WRAP_FORCE_PD() uint32 {
	return (volatile.LoadUint32(&o.DIG_PWC.Reg) & 0x80000) >> 19
}
func (o *RTC_CNTL_Type) SetDIG_PWC_DG_WRAP_FORCE_PU(value uint32) {
	volatile.StoreUint32(&o.DIG_PWC.Reg, volatile.LoadUint32(&o.DIG_PWC.Reg)&^(0x100000)|value<<20)
}
func (o *RTC_CNTL_Type) GetDIG_PWC_DG_WRAP_FORCE_PU() uint32 {
	return (volatile.LoadUint32(&o.DIG_PWC.Reg) & 0x100000) >> 20
}
func (o *RTC_CNTL_Type) SetDIG_PWC_CPU_TOP_FORCE_PD(value uint32) {
	volatile.StoreUint32(&o.DIG_PWC.Reg, volatile.LoadUint32(&o.DIG_PWC.Reg)&^(0x200000)|value<<21)
}
func (o *RTC_CNTL_Type) GetDIG_PWC_CPU_TOP_FORCE_PD() uint32 {
	return (volatile.LoadUint32(&o.DIG_PWC.Reg) & 0x200000) >> 21
}
func (o *RTC_CNTL_Type) SetDIG_PWC_CPU_TOP_FORCE_PU(value uint32) {
	volatile.StoreUint32(&o.DIG_PWC.Reg, volatile.LoadUint32(&o.DIG_PWC.Reg)&^(0x400000)|value<<22)
}
func (o *RTC_CNTL_Type) GetDIG_PWC_CPU_TOP_FORCE_PU() uint32 {
	return (volatile.LoadUint32(&o.DIG_PWC.Reg) & 0x400000) >> 22
}
func (o *RTC_CNTL_Type) SetDIG_PWC_BT_PD_EN(value uint32) {
	volatile.StoreUint32(&o.DIG_PWC.Reg, volatile.LoadUint32(&o.DIG_PWC.Reg)&^(0x8000000)|value<<27)
}
func (o *RTC_CNTL_Type) GetDIG_PWC_BT_PD_EN() uint32 {
	return (volatile.LoadUint32(&o.DIG_PWC.Reg) & 0x8000000) >> 27
}
func (o *RTC_CNTL_Type) SetDIG_PWC_DG_PERI_PD_EN(value uint32) {
	volatile.StoreUint32(&o.DIG_PWC.Reg, volatile.LoadUint32(&o.DIG_PWC.Reg)&^(0x10000000)|value<<28)
}
func (o *RTC_CNTL_Type) GetDIG_PWC_DG_PERI_PD_EN() uint32 {
	return (volatile.LoadUint32(&o.DIG_PWC.Reg) & 0x10000000) >> 28
}
func (o *RTC_CNTL_Type) SetDIG_PWC_CPU_TOP_PD_EN(value uint32) {
	volatile.StoreUint32(&o.DIG_PWC.Reg, volatile.LoadUint32(&o.DIG_PWC.Reg)&^(0x20000000)|value<<29)
}
func (o *RTC_CNTL_Type) GetDIG_PWC_CPU_TOP_PD_EN() uint32 {
	return (volatile.LoadUint32(&o.DIG_PWC.Reg) & 0x20000000) >> 29
}
func (o *RTC_CNTL_Type) SetDIG_PWC_WIFI_PD_EN(value uint32) {
	volatile.StoreUint32(&o.DIG_PWC.Reg, volatile.LoadUint32(&o.DIG_PWC.Reg)&^(0x40000000)|value<<30)
}
func (o *RTC_CNTL_Type) GetDIG_PWC_WIFI_PD_EN() uint32 {
	return (volatile.LoadUint32(&o.DIG_PWC.Reg) & 0x40000000) >> 30
}
func (o *RTC_CNTL_Type) SetDIG_PWC_DG_WRAP_PD_EN(value uint32) {
	volatile.StoreUint32(&o.DIG_PWC.Reg, volatile.LoadUint32(&o.DIG_PWC.Reg)&^(0x80000000)|value<<31)
}
func (o *RTC_CNTL_Type) GetDIG_PWC_DG_WRAP_PD_EN() uint32 {
	return (volatile.LoadUint32(&o.DIG_PWC.Reg) & 0x80000000) >> 31
}

// RTC_CNTL.DIG_ISO: rtc configure register
func (o *RTC_CNTL_Type) SetDIG_ISO_FORCE_OFF(value uint32) {
	volatile.StoreUint32(&o.DIG_ISO.Reg, volatile.LoadUint32(&o.DIG_ISO.Reg)&^(0x80)|value<<7)
}
func (o *RTC_CNTL_Type) GetDIG_ISO_FORCE_OFF() uint32 {
	return (volatile.LoadUint32(&o.DIG_ISO.Reg) & 0x80) >> 7
}
func (o *RTC_CNTL_Type) SetDIG_ISO_FORCE_ON(value uint32) {
	volatile.StoreUint32(&o.DIG_ISO.Reg, volatile.LoadUint32(&o.DIG_ISO.Reg)&^(0x100)|value<<8)
}
func (o *RTC_CNTL_Type) GetDIG_ISO_FORCE_ON() uint32 {
	return (volatile.LoadUint32(&o.DIG_ISO.Reg) & 0x100) >> 8
}
func (o *RTC_CNTL_Type) SetDIG_ISO_DG_PAD_AUTOHOLD(value uint32) {
	volatile.StoreUint32(&o.DIG_ISO.Reg, volatile.LoadUint32(&o.DIG_ISO.Reg)&^(0x200)|value<<9)
}
func (o *RTC_CNTL_Type) GetDIG_ISO_DG_PAD_AUTOHOLD() uint32 {
	return (volatile.LoadUint32(&o.DIG_ISO.Reg) & 0x200) >> 9
}
func (o *RTC_CNTL_Type) SetDIG_ISO_CLR_DG_PAD_AUTOHOLD(value uint32) {
	volatile.StoreUint32(&o.DIG_ISO.Reg, volatile.LoadUint32(&o.DIG_ISO.Reg)&^(0x400)|value<<10)
}
func (o *RTC_CNTL_Type) GetDIG_ISO_CLR_DG_PAD_AUTOHOLD() uint32 {
	return (volatile.LoadUint32(&o.DIG_ISO.Reg) & 0x400) >> 10
}
func (o *RTC_CNTL_Type) SetDIG_ISO_DG_PAD_AUTOHOLD_EN(value uint32) {
	volatile.StoreUint32(&o.DIG_ISO.Reg, volatile.LoadUint32(&o.DIG_ISO.Reg)&^(0x800)|value<<11)
}
func (o *RTC_CNTL_Type) GetDIG_ISO_DG_PAD_AUTOHOLD_EN() uint32 {
	return (volatile.LoadUint32(&o.DIG_ISO.Reg) & 0x800) >> 11
}
func (o *RTC_CNTL_Type) SetDIG_ISO_DG_PAD_FORCE_NOISO(value uint32) {
	volatile.StoreUint32(&o.DIG_ISO.Reg, volatile.LoadUint32(&o.DIG_ISO.Reg)&^(0x1000)|value<<12)
}
func (o *RTC_CNTL_Type) GetDIG_ISO_DG_PAD_FORCE_NOISO() uint32 {
	return (volatile.LoadUint32(&o.DIG_ISO.Reg) & 0x1000) >> 12
}
func (o *RTC_CNTL_Type) SetDIG_ISO_DG_PAD_FORCE_ISO(value uint32) {
	volatile.StoreUint32(&o.DIG_ISO.Reg, volatile.LoadUint32(&o.DIG_ISO.Reg)&^(0x2000)|value<<13)
}
func (o *RTC_CNTL_Type) GetDIG_ISO_DG_PAD_FORCE_ISO() uint32 {
	return (volatile.LoadUint32(&o.DIG_ISO.Reg) & 0x2000) >> 13
}
func (o *RTC_CNTL_Type) SetDIG_ISO_DG_PAD_FORCE_UNHOLD(value uint32) {
	volatile.StoreUint32(&o.DIG_ISO.Reg, volatile.LoadUint32(&o.DIG_ISO.Reg)&^(0x4000)|value<<14)
}
func (o *RTC_CNTL_Type) GetDIG_ISO_DG_PAD_FORCE_UNHOLD() uint32 {
	return (volatile.LoadUint32(&o.DIG_ISO.Reg) & 0x4000) >> 14
}
func (o *RTC_CNTL_Type) SetDIG_ISO_DG_PAD_FORCE_HOLD(value uint32) {
	volatile.StoreUint32(&o.DIG_ISO.Reg, volatile.LoadUint32(&o.DIG_ISO.Reg)&^(0x8000)|value<<15)
}
func (o *RTC_CNTL_Type) GetDIG_ISO_DG_PAD_FORCE_HOLD() uint32 {
	return (volatile.LoadUint32(&o.DIG_ISO.Reg) & 0x8000) >> 15
}
func (o *RTC_CNTL_Type) SetDIG_ISO_BT_FORCE_ISO(value uint32) {
	volatile.StoreUint32(&o.DIG_ISO.Reg, volatile.LoadUint32(&o.DIG_ISO.Reg)&^(0x400000)|value<<22)
}
func (o *RTC_CNTL_Type) GetDIG_ISO_BT_FORCE_ISO() uint32 {
	return (volatile.LoadUint32(&o.DIG_ISO.Reg) & 0x400000) >> 22
}
func (o *RTC_CNTL_Type) SetDIG_ISO_BT_FORCE_NOISO(value uint32) {
	volatile.StoreUint32(&o.DIG_ISO.Reg, volatile.LoadUint32(&o.DIG_ISO.Reg)&^(0x800000)|value<<23)
}
func (o *RTC_CNTL_Type) GetDIG_ISO_BT_FORCE_NOISO() uint32 {
	return (volatile.LoadUint32(&o.DIG_ISO.Reg) & 0x800000) >> 23
}
func (o *RTC_CNTL_Type) SetDIG_ISO_DG_PERI_FORCE_ISO(value uint32) {
	volatile.StoreUint32(&o.DIG_ISO.Reg, volatile.LoadUint32(&o.DIG_ISO.Reg)&^(0x1000000)|value<<24)
}
func (o *RTC_CNTL_Type) GetDIG_ISO_DG_PERI_FORCE_ISO() uint32 {
	return (volatile.LoadUint32(&o.DIG_ISO.Reg) & 0x1000000) >> 24
}
func (o *RTC_CNTL_Type) SetDIG_ISO_DG_PERI_FORCE_NOISO(value uint32) {
	volatile.StoreUint32(&o.DIG_ISO.Reg, volatile.LoadUint32(&o.DIG_ISO.Reg)&^(0x2000000)|value<<25)
}
func (o *RTC_CNTL_Type) GetDIG_ISO_DG_PERI_FORCE_NOISO() uint32 {
	return (volatile.LoadUint32(&o.DIG_ISO.Reg) & 0x2000000) >> 25
}
func (o *RTC_CNTL_Type) SetDIG_ISO_CPU_TOP_FORCE_ISO(value uint32) {
	volatile.StoreUint32(&o.DIG_ISO.Reg, volatile.LoadUint32(&o.DIG_ISO.Reg)&^(0x4000000)|value<<26)
}
func (o *RTC_CNTL_Type) GetDIG_ISO_CPU_TOP_FORCE_ISO() uint32 {
	return (volatile.LoadUint32(&o.DIG_ISO.Reg) & 0x4000000) >> 26
}
func (o *RTC_CNTL_Type) SetDIG_ISO_CPU_TOP_FORCE_NOISO(value uint32) {
	volatile.StoreUint32(&o.DIG_ISO.Reg, volatile.LoadUint32(&o.DIG_ISO.Reg)&^(0x8000000)|value<<27)
}
func (o *RTC_CNTL_Type) GetDIG_ISO_CPU_TOP_FORCE_NOISO() uint32 {
	return (volatile.LoadUint32(&o.DIG_ISO.Reg) & 0x8000000) >> 27
}
func (o *RTC_CNTL_Type) SetDIG_ISO_WIFI_FORCE_ISO(value uint32) {
	volatile.StoreUint32(&o.DIG_ISO.Reg, volatile.LoadUint32(&o.DIG_ISO.Reg)&^(0x10000000)|value<<28)
}
func (o *RTC_CNTL_Type) GetDIG_ISO_WIFI_FORCE_ISO() uint32 {
	return (volatile.LoadUint32(&o.DIG_ISO.Reg) & 0x10000000) >> 28
}
func (o *RTC_CNTL_Type) SetDIG_ISO_WIFI_FORCE_NOISO(value uint32) {
	volatile.StoreUint32(&o.DIG_ISO.Reg, volatile.LoadUint32(&o.DIG_ISO.Reg)&^(0x20000000)|value<<29)
}
func (o *RTC_CNTL_Type) GetDIG_ISO_WIFI_FORCE_NOISO() uint32 {
	return (volatile.LoadUint32(&o.DIG_ISO.Reg) & 0x20000000) >> 29
}
func (o *RTC_CNTL_Type) SetDIG_ISO_DG_WRAP_FORCE_ISO(value uint32) {
	volatile.StoreUint32(&o.DIG_ISO.Reg, volatile.LoadUint32(&o.DIG_ISO.Reg)&^(0x40000000)|value<<30)
}
func (o *RTC_CNTL_Type) GetDIG_ISO_DG_WRAP_FORCE_ISO() uint32 {
	return (volatile.LoadUint32(&o.DIG_ISO.Reg) & 0x40000000) >> 30
}
func (o *RTC_CNTL_Type) SetDIG_ISO_DG_WRAP_FORCE_NOISO(value uint32) {
	volatile.StoreUint32(&o.DIG_ISO.Reg, volatile.LoadUint32(&o.DIG_ISO.Reg)&^(0x80000000)|value<<31)
}
func (o *RTC_CNTL_Type) GetDIG_ISO_DG_WRAP_FORCE_NOISO() uint32 {
	return (volatile.LoadUint32(&o.DIG_ISO.Reg) & 0x80000000) >> 31
}

// RTC_CNTL.RTC_WDTCONFIG0: rtc configure register
func (o *RTC_CNTL_Type) SetRTC_WDTCONFIG0_WDT_CHIP_RESET_WIDTH(value uint32) {
	volatile.StoreUint32(&o.RTC_WDTCONFIG0.Reg, volatile.LoadUint32(&o.RTC_WDTCONFIG0.Reg)&^(0xff)|value)
}
func (o *RTC_CNTL_Type) GetRTC_WDTCONFIG0_WDT_CHIP_RESET_WIDTH() uint32 {
	return volatile.LoadUint32(&o.RTC_WDTCONFIG0.Reg) & 0xff
}
func (o *RTC_CNTL_Type) SetRTC_WDTCONFIG0_WDT_CHIP_RESET_EN(value uint32) {
	volatile.StoreUint32(&o.RTC_WDTCONFIG0.Reg, volatile.LoadUint32(&o.RTC_WDTCONFIG0.Reg)&^(0x100)|value<<8)
}
func (o *RTC_CNTL_Type) GetRTC_WDTCONFIG0_WDT_CHIP_RESET_EN() uint32 {
	return (volatile.LoadUint32(&o.RTC_WDTCONFIG0.Reg) & 0x100) >> 8
}
func (o *RTC_CNTL_Type) SetRTC_WDTCONFIG0_WDT_PAUSE_IN_SLP(value uint32) {
	volatile.StoreUint32(&o.RTC_WDTCONFIG0.Reg, volatile.LoadUint32(&o.RTC_WDTCONFIG0.Reg)&^(0x200)|value<<9)
}
func (o *RTC_CNTL_Type) GetRTC_WDTCONFIG0_WDT_PAUSE_IN_SLP() uint32 {
	return (volatile.LoadUint32(&o.RTC_WDTCONFIG0.Reg) & 0x200) >> 9
}
func (o *RTC_CNTL_Type) SetRTC_WDTCONFIG0_WDT_APPCPU_RESET_EN(value uint32) {
	volatile.StoreUint32(&o.RTC_WDTCONFIG0.Reg, volatile.LoadUint32(&o.RTC_WDTCONFIG0.Reg)&^(0x400)|value<<10)
}
func (o *RTC_CNTL_Type) GetRTC_WDTCONFIG0_WDT_APPCPU_RESET_EN() uint32 {
	return (volatile.LoadUint32(&o.RTC_WDTCONFIG0.Reg) & 0x400) >> 10
}
func (o *RTC_CNTL_Type) SetRTC_WDTCONFIG0_WDT_PROCPU_RESET_EN(value uint32) {
	volatile.StoreUint32(&o.RTC_WDTCONFIG0.Reg, volatile.LoadUint32(&o.RTC_WDTCONFIG0.Reg)&^(0x800)|value<<11)
}
func (o *RTC_CNTL_Type) GetRTC_WDTCONFIG0_WDT_PROCPU_RESET_EN() uint32 {
	return (volatile.LoadUint32(&o.RTC_WDTCONFIG0.Reg) & 0x800) >> 11
}
func (o *RTC_CNTL_Type) SetRTC_WDTCONFIG0_WDT_FLASHBOOT_MOD_EN(value uint32) {
	volatile.StoreUint32(&o.RTC_WDTCONFIG0.Reg, volatile.LoadUint32(&o.RTC_WDTCONFIG0.Reg)&^(0x1000)|value<<12)
}
func (o *RTC_CNTL_Type) GetRTC_WDTCONFIG0_WDT_FLASHBOOT_MOD_EN() uint32 {
	return (volatile.LoadUint32(&o.RTC_WDTCONFIG0.Reg) & 0x1000) >> 12
}
func (o *RTC_CNTL_Type) SetRTC_WDTCONFIG0_WDT_SYS_RESET_LENGTH(value uint32) {
	volatile.StoreUint32(&o.RTC_WDTCONFIG0.Reg, volatile.LoadUint32(&o.RTC_WDTCONFIG0.Reg)&^(0xe000)|value<<13)
}
func (o *RTC_CNTL_Type) GetRTC_WDTCONFIG0_WDT_SYS_RESET_LENGTH() uint32 {
	return (volatile.LoadUint32(&o.RTC_WDTCONFIG0.Reg) & 0xe000) >> 13
}
func (o *RTC_CNTL_Type) SetRTC_WDTCONFIG0_WDT_CPU_RESET_LENGTH(value uint32) {
	volatile.StoreUint32(&o.RTC_WDTCONFIG0.Reg, volatile.LoadUint32(&o.RTC_WDTCONFIG0.Reg)&^(0x70000)|value<<16)
}
func (o *RTC_CNTL_Type) GetRTC_WDTCONFIG0_WDT_CPU_RESET_LENGTH() uint32 {
	return (volatile.LoadUint32(&o.RTC_WDTCONFIG0.Reg) & 0x70000) >> 16
}
func (o *RTC_CNTL_Type) SetRTC_WDTCONFIG0_WDT_STG3(value uint32) {
	volatile.StoreUint32(&o.RTC_WDTCONFIG0.Reg, volatile.LoadUint32(&o.RTC_WDTCONFIG0.Reg)&^(0x380000)|value<<19)
}
func (o *RTC_CNTL_Type) GetRTC_WDTCONFIG0_WDT_STG3() uint32 {
	return (volatile.LoadUint32(&o.RTC_WDTCONFIG0.Reg) & 0x380000) >> 19
}
func (o *RTC_CNTL_Type) SetRTC_WDTCONFIG0_WDT_STG2(value uint32) {
	volatile.StoreUint32(&o.RTC_WDTCONFIG0.Reg, volatile.LoadUint32(&o.RTC_WDTCONFIG0.Reg)&^(0x1c00000)|value<<22)
}
func (o *RTC_CNTL_Type) GetRTC_WDTCONFIG0_WDT_STG2() uint32 {
	return (volatile.LoadUint32(&o.RTC_WDTCONFIG0.Reg) & 0x1c00000) >> 22
}
func (o *RTC_CNTL_Type) SetRTC_WDTCONFIG0_WDT_STG1(value uint32) {
	volatile.StoreUint32(&o.RTC_WDTCONFIG0.Reg, volatile.LoadUint32(&o.RTC_WDTCONFIG0.Reg)&^(0xe000000)|value<<25)
}
func (o *RTC_CNTL_Type) GetRTC_WDTCONFIG0_WDT_STG1() uint32 {
	return (volatile.LoadUint32(&o.RTC_WDTCONFIG0.Reg) & 0xe000000) >> 25
}
func (o *RTC_CNTL_Type) SetRTC_WDTCONFIG0_WDT_STG0(value uint32) {
	volatile.StoreUint32(&o.RTC_WDTCONFIG0.Reg, volatile.LoadUint32(&o.RTC_WDTCONFIG0.Reg)&^(0x70000000)|value<<28)
}
func (o *RTC_CNTL_Type) GetRTC_WDTCONFIG0_WDT_STG0() uint32 {
	return (volatile.LoadUint32(&o.RTC_WDTCONFIG0.Reg) & 0x70000000) >> 28
}
func (o *RTC_CNTL_Type) SetRTC_WDTCONFIG0_WDT_EN(value uint32) {
	volatile.StoreUint32(&o.RTC_WDTCONFIG0.Reg, volatile.LoadUint32(&o.RTC_WDTCONFIG0.Reg)&^(0x80000000)|value<<31)
}
func (o *RTC_CNTL_Type) GetRTC_WDTCONFIG0_WDT_EN() uint32 {
	return (volatile.LoadUint32(&o.RTC_WDTCONFIG0.Reg) & 0x80000000) >> 31
}

// RTC_CNTL.RTC_WDTCONFIG1: rtc configure register
func (o *RTC_CNTL_Type) SetRTC_WDTCONFIG1(value uint32) {
	volatile.StoreUint32(&o.RTC_WDTCONFIG1.Reg, value)
}
func (o *RTC_CNTL_Type) GetRTC_WDTCONFIG1() uint32 {
	return volatile.LoadUint32(&o.RTC_WDTCONFIG1.Reg)
}

// RTC_CNTL.RTC_WDTCONFIG2: rtc configure register
func (o *RTC_CNTL_Type) SetRTC_WDTCONFIG2(value uint32) {
	volatile.StoreUint32(&o.RTC_WDTCONFIG2.Reg, value)
}
func (o *RTC_CNTL_Type) GetRTC_WDTCONFIG2() uint32 {
	return volatile.LoadUint32(&o.RTC_WDTCONFIG2.Reg)
}

// RTC_CNTL.RTC_WDTCONFIG3: rtc configure register
func (o *RTC_CNTL_Type) SetRTC_WDTCONFIG3(value uint32) {
	volatile.StoreUint32(&o.RTC_WDTCONFIG3.Reg, value)
}
func (o *RTC_CNTL_Type) GetRTC_WDTCONFIG3() uint32 {
	return volatile.LoadUint32(&o.RTC_WDTCONFIG3.Reg)
}

// RTC_CNTL.RTC_WDTCONFIG4: rtc configure register
func (o *RTC_CNTL_Type) SetRTC_WDTCONFIG4(value uint32) {
	volatile.StoreUint32(&o.RTC_WDTCONFIG4.Reg, value)
}
func (o *RTC_CNTL_Type) GetRTC_WDTCONFIG4() uint32 {
	return volatile.LoadUint32(&o.RTC_WDTCONFIG4.Reg)
}

// RTC_CNTL.RTC_WDTFEED: rtc configure register
func (o *RTC_CNTL_Type) SetRTC_WDTFEED_RTC_WDT_FEED(value uint32) {
	volatile.StoreUint32(&o.RTC_WDTFEED.Reg, volatile.LoadUint32(&o.RTC_WDTFEED.Reg)&^(0x80000000)|value<<31)
}
func (o *RTC_CNTL_Type) GetRTC_WDTFEED_RTC_WDT_FEED() uint32 {
	return (volatile.LoadUint32(&o.RTC_WDTFEED.Reg) & 0x80000000) >> 31
}

// RTC_CNTL.RTC_WDTWPROTECT: rtc configure register
func (o *RTC_CNTL_Type) SetRTC_WDTWPROTECT(value uint32) {
	volatile.StoreUint32(&o.RTC_WDTWPROTECT.Reg, value)
}
func (o *RTC_CNTL_Type) GetRTC_WDTWPROTECT() uint32 {
	return volatile.LoadUint32(&o.RTC_WDTWPROTECT.Reg)
}

// RTC_CNTL.RTC_SWD_CONF: rtc configure register
func (o *RTC_CNTL_Type) SetRTC_SWD_CONF_SWD_RESET_FLAG(value uint32) {
	volatile.StoreUint32(&o.RTC_SWD_CONF.Reg, volatile.LoadUint32(&o.RTC_SWD_CONF.Reg)&^(0x1)|value)
}
func (o *RTC_CNTL_Type) GetRTC_SWD_CONF_SWD_RESET_FLAG() uint32 {
	return volatile.LoadUint32(&o.RTC_SWD_CONF.Reg) & 0x1
}
func (o *RTC_CNTL_Type) SetRTC_SWD_CONF_SWD_FEED_INT(value uint32) {
	volatile.StoreUint32(&o.RTC_SWD_CONF.Reg, volatile.LoadUint32(&o.RTC_SWD_CONF.Reg)&^(0x2)|value<<1)
}
func (o *RTC_CNTL_Type) GetRTC_SWD_CONF_SWD_FEED_INT() uint32 {
	return (volatile.LoadUint32(&o.RTC_SWD_CONF.Reg) & 0x2) >> 1
}
func (o *RTC_CNTL_Type) SetRTC_SWD_CONF_SWD_BYPASS_RST(value uint32) {
	volatile.StoreUint32(&o.RTC_SWD_CONF.Reg, volatile.LoadUint32(&o.RTC_SWD_CONF.Reg)&^(0x20000)|value<<17)
}
func (o *RTC_CNTL_Type) GetRTC_SWD_CONF_SWD_BYPASS_RST() uint32 {
	return (volatile.LoadUint32(&o.RTC_SWD_CONF.Reg) & 0x20000) >> 17
}
func (o *RTC_CNTL_Type) SetRTC_SWD_CONF_SWD_SIGNAL_WIDTH(value uint32) {
	volatile.StoreUint32(&o.RTC_SWD_CONF.Reg, volatile.LoadUint32(&o.RTC_SWD_CONF.Reg)&^(0xffc0000)|value<<18)
}
func (o *RTC_CNTL_Type) GetRTC_SWD_CONF_SWD_SIGNAL_WIDTH() uint32 {
	return (volatile.LoadUint32(&o.RTC_SWD_CONF.Reg) & 0xffc0000) >> 18
}
func (o *RTC_CNTL_Type) SetRTC_SWD_CONF_SWD_RST_FLAG_CLR(value uint32) {
	volatile.StoreUint32(&o.RTC_SWD_CONF.Reg, volatile.LoadUint32(&o.RTC_SWD_CONF.Reg)&^(0x10000000)|value<<28)
}
func (o *RTC_CNTL_Type) GetRTC_SWD_CONF_SWD_RST_FLAG_CLR() uint32 {
	return (volatile.LoadUint32(&o.RTC_SWD_CONF.Reg) & 0x10000000) >> 28
}
func (o *RTC_CNTL_Type) SetRTC_SWD_CONF_SWD_FEED(value uint32) {
	volatile.StoreUint32(&o.RTC_SWD_CONF.Reg, volatile.LoadUint32(&o.RTC_SWD_CONF.Reg)&^(0x20000000)|value<<29)
}
func (o *RTC_CNTL_Type) GetRTC_SWD_CONF_SWD_FEED() uint32 {
	return (volatile.LoadUint32(&o.RTC_SWD_CONF.Reg) & 0x20000000) >> 29
}
func (o *RTC_CNTL_Type) SetRTC_SWD_CONF_SWD_DISABLE(value uint32) {
	volatile.StoreUint32(&o.RTC_SWD_CONF.Reg, volatile.LoadUint32(&o.RTC_SWD_CONF.Reg)&^(0x40000000)|value<<30)
}
func (o *RTC_CNTL_Type) GetRTC_SWD_CONF_SWD_DISABLE() uint32 {
	return (volatile.LoadUint32(&o.RTC_SWD_CONF.Reg) & 0x40000000) >> 30
}
func (o *RTC_CNTL_Type) SetRTC_SWD_CONF_SWD_AUTO_FEED_EN(value uint32) {
	volatile.StoreUint32(&o.RTC_SWD_CONF.Reg, volatile.LoadUint32(&o.RTC_SWD_CONF.Reg)&^(0x80000000)|value<<31)
}
func (o *RTC_CNTL_Type) GetRTC_SWD_CONF_SWD_AUTO_FEED_EN() uint32 {
	return (volatile.LoadUint32(&o.RTC_SWD_CONF.Reg) & 0x80000000) >> 31
}

// RTC_CNTL.RTC_SWD_WPROTECT: rtc configure register
func (o *RTC_CNTL_Type) SetRTC_SWD_WPROTECT(value uint32) {
	volatile.StoreUint32(&o.RTC_SWD_WPROTECT.Reg, value)
}
func (o *RTC_CNTL_Type) GetRTC_SWD_WPROTECT() uint32 {
	return volatile.LoadUint32(&o.RTC_SWD_WPROTECT.Reg)
}

// RTC_CNTL.RTC_SW_CPU_STALL: rtc configure register
func (o *RTC_CNTL_Type) SetRTC_SW_CPU_STALL_SW_STALL_APPCPU_C1(value uint32) {
	volatile.StoreUint32(&o.RTC_SW_CPU_STALL.Reg, volatile.LoadUint32(&o.RTC_SW_CPU_STALL.Reg)&^(0x3f00000)|value<<20)
}
func (o *RTC_CNTL_Type) GetRTC_SW_CPU_STALL_SW_STALL_APPCPU_C1() uint32 {
	return (volatile.LoadUint32(&o.RTC_SW_CPU_STALL.Reg) & 0x3f00000) >> 20
}
func (o *RTC_CNTL_Type) SetRTC_SW_CPU_STALL_SW_STALL_PROCPU_C1(value uint32) {
	volatile.StoreUint32(&o.RTC_SW_CPU_STALL.Reg, volatile.LoadUint32(&o.RTC_SW_CPU_STALL.Reg)&^(0xfc000000)|value<<26)
}
func (o *RTC_CNTL_Type) GetRTC_SW_CPU_STALL_SW_STALL_PROCPU_C1() uint32 {
	return (volatile.LoadUint32(&o.RTC_SW_CPU_STALL.Reg) & 0xfc000000) >> 26
}

// RTC_CNTL.RTC_STORE4: rtc configure register
func (o *RTC_CNTL_Type) SetRTC_STORE4(value uint32) {
	volatile.StoreUint32(&o.RTC_STORE4.Reg, value)
}
func (o *RTC_CNTL_Type) GetRTC_STORE4() uint32 {
	return volatile.LoadUint32(&o.RTC_STORE4.Reg)
}

// RTC_CNTL.RTC_STORE5: rtc configure register
func (o *RTC_CNTL_Type) SetRTC_STORE5(value uint32) {
	volatile.StoreUint32(&o.RTC_STORE5.Reg, value)
}
func (o *RTC_CNTL_Type) GetRTC_STORE5() uint32 {
	return volatile.LoadUint32(&o.RTC_STORE5.Reg)
}

// RTC_CNTL.RTC_STORE6: rtc configure register
func (o *RTC_CNTL_Type) SetRTC_STORE6(value uint32) {
	volatile.StoreUint32(&o.RTC_STORE6.Reg, value)
}
func (o *RTC_CNTL_Type) GetRTC_STORE6() uint32 {
	return volatile.LoadUint32(&o.RTC_STORE6.Reg)
}

// RTC_CNTL.RTC_STORE7: rtc configure register
func (o *RTC_CNTL_Type) SetRTC_STORE7(value uint32) {
	volatile.StoreUint32(&o.RTC_STORE7.Reg, value)
}
func (o *RTC_CNTL_Type) GetRTC_STORE7() uint32 {
	return volatile.LoadUint32(&o.RTC_STORE7.Reg)
}

// RTC_CNTL.RTC_LOW_POWER_ST: rtc configure register
func (o *RTC_CNTL_Type) SetRTC_LOW_POWER_ST_XPD_ROM0(value uint32) {
	volatile.StoreUint32(&o.RTC_LOW_POWER_ST.Reg, volatile.LoadUint32(&o.RTC_LOW_POWER_ST.Reg)&^(0x1)|value)
}
func (o *RTC_CNTL_Type) GetRTC_LOW_POWER_ST_XPD_ROM0() uint32 {
	return volatile.LoadUint32(&o.RTC_LOW_POWER_ST.Reg) & 0x1
}
func (o *RTC_CNTL_Type) SetRTC_LOW_POWER_ST_XPD_DIG_DCDC(value uint32) {
	volatile.StoreUint32(&o.RTC_LOW_POWER_ST.Reg, volatile.LoadUint32(&o.RTC_LOW_POWER_ST.Reg)&^(0x4)|value<<2)
}
func (o *RTC_CNTL_Type) GetRTC_LOW_POWER_ST_XPD_DIG_DCDC() uint32 {
	return (volatile.LoadUint32(&o.RTC_LOW_POWER_ST.Reg) & 0x4) >> 2
}
func (o *RTC_CNTL_Type) SetRTC_LOW_POWER_ST_RTC_PERI_ISO(value uint32) {
	volatile.StoreUint32(&o.RTC_LOW_POWER_ST.Reg, volatile.LoadUint32(&o.RTC_LOW_POWER_ST.Reg)&^(0x8)|value<<3)
}
func (o *RTC_CNTL_Type) GetRTC_LOW_POWER_ST_RTC_PERI_ISO() uint32 {
	return (volatile.LoadUint32(&o.RTC_LOW_POWER_ST.Reg) & 0x8) >> 3
}
func (o *RTC_CNTL_Type) SetRTC_LOW_POWER_ST_XPD_RTC_PERI(value uint32) {
	volatile.StoreUint32(&o.RTC_LOW_POWER_ST.Reg, volatile.LoadUint32(&o.RTC_LOW_POWER_ST.Reg)&^(0x10)|value<<4)
}
func (o *RTC_CNTL_Type) GetRTC_LOW_POWER_ST_XPD_RTC_PERI() uint32 {
	return (volatile.LoadUint32(&o.RTC_LOW_POWER_ST.Reg) & 0x10) >> 4
}
func (o *RTC_CNTL_Type) SetRTC_LOW_POWER_ST_WIFI_ISO(value uint32) {
	volatile.StoreUint32(&o.RTC_LOW_POWER_ST.Reg, volatile.LoadUint32(&o.RTC_LOW_POWER_ST.Reg)&^(0x20)|value<<5)
}
func (o *RTC_CNTL_Type) GetRTC_LOW_POWER_ST_WIFI_ISO() uint32 {
	return (volatile.LoadUint32(&o.RTC_LOW_POWER_ST.Reg) & 0x20) >> 5
}
func (o *RTC_CNTL_Type) SetRTC_LOW_POWER_ST_XPD_WIFI(value uint32) {
	volatile.StoreUint32(&o.RTC_LOW_POWER_ST.Reg, volatile.LoadUint32(&o.RTC_LOW_POWER_ST.Reg)&^(0x40)|value<<6)
}
func (o *RTC_CNTL_Type) GetRTC_LOW_POWER_ST_XPD_WIFI() uint32 {
	return (volatile.LoadUint32(&o.RTC_LOW_POWER_ST.Reg) & 0x40) >> 6
}
func (o *RTC_CNTL_Type) SetRTC_LOW_POWER_ST_DIG_ISO(value uint32) {
	volatile.StoreUint32(&o.RTC_LOW_POWER_ST.Reg, volatile.LoadUint32(&o.RTC_LOW_POWER_ST.Reg)&^(0x80)|value<<7)
}
func (o *RTC_CNTL_Type) GetRTC_LOW_POWER_ST_DIG_ISO() uint32 {
	return (volatile.LoadUint32(&o.RTC_LOW_POWER_ST.Reg) & 0x80) >> 7
}
func (o *RTC_CNTL_Type) SetRTC_LOW_POWER_ST_XPD_DIG(value uint32) {
	volatile.StoreUint32(&o.RTC_LOW_POWER_ST.Reg, volatile.LoadUint32(&o.RTC_LOW_POWER_ST.Reg)&^(0x100)|value<<8)
}
func (o *RTC_CNTL_Type) GetRTC_LOW_POWER_ST_XPD_DIG() uint32 {
	return (volatile.LoadUint32(&o.RTC_LOW_POWER_ST.Reg) & 0x100) >> 8
}
func (o *RTC_CNTL_Type) SetRTC_LOW_POWER_ST_RTC_TOUCH_STATE_START(value uint32) {
	volatile.StoreUint32(&o.RTC_LOW_POWER_ST.Reg, volatile.LoadUint32(&o.RTC_LOW_POWER_ST.Reg)&^(0x200)|value<<9)
}
func (o *RTC_CNTL_Type) GetRTC_LOW_POWER_ST_RTC_TOUCH_STATE_START() uint32 {
	return (volatile.LoadUint32(&o.RTC_LOW_POWER_ST.Reg) & 0x200) >> 9
}
func (o *RTC_CNTL_Type) SetRTC_LOW_POWER_ST_RTC_TOUCH_STATE_SWITCH(value uint32) {
	volatile.StoreUint32(&o.RTC_LOW_POWER_ST.Reg, volatile.LoadUint32(&o.RTC_LOW_POWER_ST.Reg)&^(0x400)|value<<10)
}
func (o *RTC_CNTL_Type) GetRTC_LOW_POWER_ST_RTC_TOUCH_STATE_SWITCH() uint32 {
	return (volatile.LoadUint32(&o.RTC_LOW_POWER_ST.Reg) & 0x400) >> 10
}
func (o *RTC_CNTL_Type) SetRTC_LOW_POWER_ST_RTC_TOUCH_STATE_SLP(value uint32) {
	volatile.StoreUint32(&o.RTC_LOW_POWER_ST.Reg, volatile.LoadUint32(&o.RTC_LOW_POWER_ST.Reg)&^(0x800)|value<<11)
}
func (o *RTC_CNTL_Type) GetRTC_LOW_POWER_ST_RTC_TOUCH_STATE_SLP() uint32 {
	return (volatile.LoadUint32(&o.RTC_LOW_POWER_ST.Reg) & 0x800) >> 11
}
func (o *RTC_CNTL_Type) SetRTC_LOW_POWER_ST_RTC_TOUCH_STATE_DONE(value uint32) {
	volatile.StoreUint32(&o.RTC_LOW_POWER_ST.Reg, volatile.LoadUint32(&o.RTC_LOW_POWER_ST.Reg)&^(0x1000)|value<<12)
}
func (o *RTC_CNTL_Type) GetRTC_LOW_POWER_ST_RTC_TOUCH_STATE_DONE() uint32 {
	return (volatile.LoadUint32(&o.RTC_LOW_POWER_ST.Reg) & 0x1000) >> 12
}
func (o *RTC_CNTL_Type) SetRTC_LOW_POWER_ST_RTC_COCPU_STATE_START(value uint32) {
	volatile.StoreUint32(&o.RTC_LOW_POWER_ST.Reg, volatile.LoadUint32(&o.RTC_LOW_POWER_ST.Reg)&^(0x2000)|value<<13)
}
func (o *RTC_CNTL_Type) GetRTC_LOW_POWER_ST_RTC_COCPU_STATE_START() uint32 {
	return (volatile.LoadUint32(&o.RTC_LOW_POWER_ST.Reg) & 0x2000) >> 13
}
func (o *RTC_CNTL_Type) SetRTC_LOW_POWER_ST_RTC_COCPU_STATE_SWITCH(value uint32) {
	volatile.StoreUint32(&o.RTC_LOW_POWER_ST.Reg, volatile.LoadUint32(&o.RTC_LOW_POWER_ST.Reg)&^(0x4000)|value<<14)
}
func (o *RTC_CNTL_Type) GetRTC_LOW_POWER_ST_RTC_COCPU_STATE_SWITCH() uint32 {
	return (volatile.LoadUint32(&o.RTC_LOW_POWER_ST.Reg) & 0x4000) >> 14
}
func (o *RTC_CNTL_Type) SetRTC_LOW_POWER_ST_RTC_COCPU_STATE_SLP(value uint32) {
	volatile.StoreUint32(&o.RTC_LOW_POWER_ST.Reg, volatile.LoadUint32(&o.RTC_LOW_POWER_ST.Reg)&^(0x8000)|value<<15)
}
func (o *RTC_CNTL_Type) GetRTC_LOW_POWER_ST_RTC_COCPU_STATE_SLP() uint32 {
	return (volatile.LoadUint32(&o.RTC_LOW_POWER_ST.Reg) & 0x8000) >> 15
}
func (o *RTC_CNTL_Type) SetRTC_LOW_POWER_ST_RTC_COCPU_STATE_DONE(value uint32) {
	volatile.StoreUint32(&o.RTC_LOW_POWER_ST.Reg, volatile.LoadUint32(&o.RTC_LOW_POWER_ST.Reg)&^(0x10000)|value<<16)
}
func (o *RTC_CNTL_Type) GetRTC_LOW_POWER_ST_RTC_COCPU_STATE_DONE() uint32 {
	return (volatile.LoadUint32(&o.RTC_LOW_POWER_ST.Reg) & 0x10000) >> 16
}
func (o *RTC_CNTL_Type) SetRTC_LOW_POWER_ST_RTC_MAIN_STATE_XTAL_ISO(value uint32) {
	volatile.StoreUint32(&o.RTC_LOW_POWER_ST.Reg, volatile.LoadUint32(&o.RTC_LOW_POWER_ST.Reg)&^(0x20000)|value<<17)
}
func (o *RTC_CNTL_Type) GetRTC_LOW_POWER_ST_RTC_MAIN_STATE_XTAL_ISO() uint32 {
	return (volatile.LoadUint32(&o.RTC_LOW_POWER_ST.Reg) & 0x20000) >> 17
}
func (o *RTC_CNTL_Type) SetRTC_LOW_POWER_ST_RTC_MAIN_STATE_PLL_ON(value uint32) {
	volatile.StoreUint32(&o.RTC_LOW_POWER_ST.Reg, volatile.LoadUint32(&o.RTC_LOW_POWER_ST.Reg)&^(0x40000)|value<<18)
}
func (o *RTC_CNTL_Type) GetRTC_LOW_POWER_ST_RTC_MAIN_STATE_PLL_ON() uint32 {
	return (volatile.LoadUint32(&o.RTC_LOW_POWER_ST.Reg) & 0x40000) >> 18
}
func (o *RTC_CNTL_Type) SetRTC_LOW_POWER_ST_RTC_RDY_FOR_WAKEUP(value uint32) {
	volatile.StoreUint32(&o.RTC_LOW_POWER_ST.Reg, volatile.LoadUint32(&o.RTC_LOW_POWER_ST.Reg)&^(0x80000)|value<<19)
}
func (o *RTC_CNTL_Type) GetRTC_LOW_POWER_ST_RTC_RDY_FOR_WAKEUP() uint32 {
	return (volatile.LoadUint32(&o.RTC_LOW_POWER_ST.Reg) & 0x80000) >> 19
}
func (o *RTC_CNTL_Type) SetRTC_LOW_POWER_ST_RTC_MAIN_STATE_WAIT_END(value uint32) {
	volatile.StoreUint32(&o.RTC_LOW_POWER_ST.Reg, volatile.LoadUint32(&o.RTC_LOW_POWER_ST.Reg)&^(0x100000)|value<<20)
}
func (o *RTC_CNTL_Type) GetRTC_LOW_POWER_ST_RTC_MAIN_STATE_WAIT_END() uint32 {
	return (volatile.LoadUint32(&o.RTC_LOW_POWER_ST.Reg) & 0x100000) >> 20
}
func (o *RTC_CNTL_Type) SetRTC_LOW_POWER_ST_RTC_IN_WAKEUP_STATE(value uint32) {
	volatile.StoreUint32(&o.RTC_LOW_POWER_ST.Reg, volatile.LoadUint32(&o.RTC_LOW_POWER_ST.Reg)&^(0x200000)|value<<21)
}
func (o *RTC_CNTL_Type) GetRTC_LOW_POWER_ST_RTC_IN_WAKEUP_STATE() uint32 {
	return (volatile.LoadUint32(&o.RTC_LOW_POWER_ST.Reg) & 0x200000) >> 21
}
func (o *RTC_CNTL_Type) SetRTC_LOW_POWER_ST_RTC_IN_LOW_POWER_STATE(value uint32) {
	volatile.StoreUint32(&o.RTC_LOW_POWER_ST.Reg, volatile.LoadUint32(&o.RTC_LOW_POWER_ST.Reg)&^(0x400000)|value<<22)
}
func (o *RTC_CNTL_Type) GetRTC_LOW_POWER_ST_RTC_IN_LOW_POWER_STATE() uint32 {
	return (volatile.LoadUint32(&o.RTC_LOW_POWER_ST.Reg) & 0x400000) >> 22
}
func (o *RTC_CNTL_Type) SetRTC_LOW_POWER_ST_RTC_MAIN_STATE_IN_WAIT_8M(value uint32) {
	volatile.StoreUint32(&o.RTC_LOW_POWER_ST.Reg, volatile.LoadUint32(&o.RTC_LOW_POWER_ST.Reg)&^(0x800000)|value<<23)
}
func (o *RTC_CNTL_Type) GetRTC_LOW_POWER_ST_RTC_MAIN_STATE_IN_WAIT_8M() uint32 {
	return (volatile.LoadUint32(&o.RTC_LOW_POWER_ST.Reg) & 0x800000) >> 23
}
func (o *RTC_CNTL_Type) SetRTC_LOW_POWER_ST_RTC_MAIN_STATE_IN_WAIT_PLL(value uint32) {
	volatile.StoreUint32(&o.RTC_LOW_POWER_ST.Reg, volatile.LoadUint32(&o.RTC_LOW_POWER_ST.Reg)&^(0x1000000)|value<<24)
}
func (o *RTC_CNTL_Type) GetRTC_LOW_POWER_ST_RTC_MAIN_STATE_IN_WAIT_PLL() uint32 {
	return (volatile.LoadUint32(&o.RTC_LOW_POWER_ST.Reg) & 0x1000000) >> 24
}
func (o *RTC_CNTL_Type) SetRTC_LOW_POWER_ST_RTC_MAIN_STATE_IN_WAIT_XTL(value uint32) {
	volatile.StoreUint32(&o.RTC_LOW_POWER_ST.Reg, volatile.LoadUint32(&o.RTC_LOW_POWER_ST.Reg)&^(0x2000000)|value<<25)
}
func (o *RTC_CNTL_Type) GetRTC_LOW_POWER_ST_RTC_MAIN_STATE_IN_WAIT_XTL() uint32 {
	return (volatile.LoadUint32(&o.RTC_LOW_POWER_ST.Reg) & 0x2000000) >> 25
}
func (o *RTC_CNTL_Type) SetRTC_LOW_POWER_ST_RTC_MAIN_STATE_IN_SLP(value uint32) {
	volatile.StoreUint32(&o.RTC_LOW_POWER_ST.Reg, volatile.LoadUint32(&o.RTC_LOW_POWER_ST.Reg)&^(0x4000000)|value<<26)
}
func (o *RTC_CNTL_Type) GetRTC_LOW_POWER_ST_RTC_MAIN_STATE_IN_SLP() uint32 {
	return (volatile.LoadUint32(&o.RTC_LOW_POWER_ST.Reg) & 0x4000000) >> 26
}
func (o *RTC_CNTL_Type) SetRTC_LOW_POWER_ST_RTC_MAIN_STATE_IN_IDLE(value uint32) {
	volatile.StoreUint32(&o.RTC_LOW_POWER_ST.Reg, volatile.LoadUint32(&o.RTC_LOW_POWER_ST.Reg)&^(0x8000000)|value<<27)
}
func (o *RTC_CNTL_Type) GetRTC_LOW_POWER_ST_RTC_MAIN_STATE_IN_IDLE() uint32 {
	return (volatile.LoadUint32(&o.RTC_LOW_POWER_ST.Reg) & 0x8000000) >> 27
}
func (o *RTC_CNTL_Type) SetRTC_LOW_POWER_ST_RTC_MAIN_STATE(value uint32) {
	volatile.StoreUint32(&o.RTC_LOW_POWER_ST.Reg, volatile.LoadUint32(&o.RTC_LOW_POWER_ST.Reg)&^(0xf0000000)|value<<28)
}
func (o *RTC_CNTL_Type) GetRTC_LOW_POWER_ST_RTC_MAIN_STATE() uint32 {
	return (volatile.LoadUint32(&o.RTC_LOW_POWER_ST.Reg) & 0xf0000000) >> 28
}

// RTC_CNTL.RTC_DIAG0: rtc configure register
func (o *RTC_CNTL_Type) SetRTC_DIAG0(value uint32) {
	volatile.StoreUint32(&o.RTC_DIAG0.Reg, value)
}
func (o *RTC_CNTL_Type) GetRTC_DIAG0() uint32 {
	return volatile.LoadUint32(&o.RTC_DIAG0.Reg)
}

// RTC_CNTL.RTC_PAD_HOLD: rtc configure register
func (o *RTC_CNTL_Type) SetRTC_PAD_HOLD_RTC_GPIO_PIN0_HOLD(value uint32) {
	volatile.StoreUint32(&o.RTC_PAD_HOLD.Reg, volatile.LoadUint32(&o.RTC_PAD_HOLD.Reg)&^(0x1)|value)
}
func (o *RTC_CNTL_Type) GetRTC_PAD_HOLD_RTC_GPIO_PIN0_HOLD() uint32 {
	return volatile.LoadUint32(&o.RTC_PAD_HOLD.Reg) & 0x1
}
func (o *RTC_CNTL_Type) SetRTC_PAD_HOLD_RTC_GPIO_PIN1_HOLD(value uint32) {
	volatile.StoreUint32(&o.RTC_PAD_HOLD.Reg, volatile.LoadUint32(&o.RTC_PAD_HOLD.Reg)&^(0x2)|value<<1)
}
func (o *RTC_CNTL_Type) GetRTC_PAD_HOLD_RTC_GPIO_PIN1_HOLD() uint32 {
	return (volatile.LoadUint32(&o.RTC_PAD_HOLD.Reg) & 0x2) >> 1
}
func (o *RTC_CNTL_Type) SetRTC_PAD_HOLD_RTC_GPIO_PIN2_HOLD(value uint32) {
	volatile.StoreUint32(&o.RTC_PAD_HOLD.Reg, volatile.LoadUint32(&o.RTC_PAD_HOLD.Reg)&^(0x4)|value<<2)
}
func (o *RTC_CNTL_Type) GetRTC_PAD_HOLD_RTC_GPIO_PIN2_HOLD() uint32 {
	return (volatile.LoadUint32(&o.RTC_PAD_HOLD.Reg) & 0x4) >> 2
}
func (o *RTC_CNTL_Type) SetRTC_PAD_HOLD_RTC_GPIO_PIN3_HOLD(value uint32) {
	volatile.StoreUint32(&o.RTC_PAD_HOLD.Reg, volatile.LoadUint32(&o.RTC_PAD_HOLD.Reg)&^(0x8)|value<<3)
}
func (o *RTC_CNTL_Type) GetRTC_PAD_HOLD_RTC_GPIO_PIN3_HOLD() uint32 {
	return (volatile.LoadUint32(&o.RTC_PAD_HOLD.Reg) & 0x8) >> 3
}
func (o *RTC_CNTL_Type) SetRTC_PAD_HOLD_RTC_GPIO_PIN4_HOLD(value uint32) {
	volatile.StoreUint32(&o.RTC_PAD_HOLD.Reg, volatile.LoadUint32(&o.RTC_PAD_HOLD.Reg)&^(0x10)|value<<4)
}
func (o *RTC_CNTL_Type) GetRTC_PAD_HOLD_RTC_GPIO_PIN4_HOLD() uint32 {
	return (volatile.LoadUint32(&o.RTC_PAD_HOLD.Reg) & 0x10) >> 4
}
func (o *RTC_CNTL_Type) SetRTC_PAD_HOLD_RTC_GPIO_PIN5_HOLD(value uint32) {
	volatile.StoreUint32(&o.RTC_PAD_HOLD.Reg, volatile.LoadUint32(&o.RTC_PAD_HOLD.Reg)&^(0x20)|value<<5)
}
func (o *RTC_CNTL_Type) GetRTC_PAD_HOLD_RTC_GPIO_PIN5_HOLD() uint32 {
	return (volatile.LoadUint32(&o.RTC_PAD_HOLD.Reg) & 0x20) >> 5
}

// RTC_CNTL.DIG_PAD_HOLD: rtc configure register
func (o *RTC_CNTL_Type) SetDIG_PAD_HOLD(value uint32) {
	volatile.StoreUint32(&o.DIG_PAD_HOLD.Reg, value)
}
func (o *RTC_CNTL_Type) GetDIG_PAD_HOLD() uint32 {
	return volatile.LoadUint32(&o.DIG_PAD_HOLD.Reg)
}

// RTC_CNTL.RTC_BROWN_OUT: rtc configure register
func (o *RTC_CNTL_Type) SetRTC_BROWN_OUT_BROWN_OUT_INT_WAIT(value uint32) {
	volatile.StoreUint32(&o.RTC_BROWN_OUT.Reg, volatile.LoadUint32(&o.RTC_BROWN_OUT.Reg)&^(0x3ff0)|value<<4)
}
func (o *RTC_CNTL_Type) GetRTC_BROWN_OUT_BROWN_OUT_INT_WAIT() uint32 {
	return (volatile.LoadUint32(&o.RTC_BROWN_OUT.Reg) & 0x3ff0) >> 4
}
func (o *RTC_CNTL_Type) SetRTC_BROWN_OUT_BROWN_OUT_CLOSE_FLASH_ENA(value uint32) {
	volatile.StoreUint32(&o.RTC_BROWN_OUT.Reg, volatile.LoadUint32(&o.RTC_BROWN_OUT.Reg)&^(0x4000)|value<<14)
}
func (o *RTC_CNTL_Type) GetRTC_BROWN_OUT_BROWN_OUT_CLOSE_FLASH_ENA() uint32 {
	return (volatile.LoadUint32(&o.RTC_BROWN_OUT.Reg) & 0x4000) >> 14
}
func (o *RTC_CNTL_Type) SetRTC_BROWN_OUT_BROWN_OUT_PD_RF_ENA(value uint32) {
	volatile.StoreUint32(&o.RTC_BROWN_OUT.Reg, volatile.LoadUint32(&o.RTC_BROWN_OUT.Reg)&^(0x8000)|value<<15)
}
func (o *RTC_CNTL_Type) GetRTC_BROWN_OUT_BROWN_OUT_PD_RF_ENA() uint32 {
	return (volatile.LoadUint32(&o.RTC_BROWN_OUT.Reg) & 0x8000) >> 15
}
func (o *RTC_CNTL_Type) SetRTC_BROWN_OUT_BROWN_OUT_RST_WAIT(value uint32) {
	volatile.StoreUint32(&o.RTC_BROWN_OUT.Reg, volatile.LoadUint32(&o.RTC_BROWN_OUT.Reg)&^(0x3ff0000)|value<<16)
}
func (o *RTC_CNTL_Type) GetRTC_BROWN_OUT_BROWN_OUT_RST_WAIT() uint32 {
	return (volatile.LoadUint32(&o.RTC_BROWN_OUT.Reg) & 0x3ff0000) >> 16
}
func (o *RTC_CNTL_Type) SetRTC_BROWN_OUT_BROWN_OUT_RST_ENA(value uint32) {
	volatile.StoreUint32(&o.RTC_BROWN_OUT.Reg, volatile.LoadUint32(&o.RTC_BROWN_OUT.Reg)&^(0x4000000)|value<<26)
}
func (o *RTC_CNTL_Type) GetRTC_BROWN_OUT_BROWN_OUT_RST_ENA() uint32 {
	return (volatile.LoadUint32(&o.RTC_BROWN_OUT.Reg) & 0x4000000) >> 26
}
func (o *RTC_CNTL_Type) SetRTC_BROWN_OUT_BROWN_OUT_RST_SEL(value uint32) {
	volatile.StoreUint32(&o.RTC_BROWN_OUT.Reg, volatile.LoadUint32(&o.RTC_BROWN_OUT.Reg)&^(0x8000000)|value<<27)
}
func (o *RTC_CNTL_Type) GetRTC_BROWN_OUT_BROWN_OUT_RST_SEL() uint32 {
	return (volatile.LoadUint32(&o.RTC_BROWN_OUT.Reg) & 0x8000000) >> 27
}
func (o *RTC_CNTL_Type) SetRTC_BROWN_OUT_BROWN_OUT_ANA_RST_EN(value uint32) {
	volatile.StoreUint32(&o.RTC_BROWN_OUT.Reg, volatile.LoadUint32(&o.RTC_BROWN_OUT.Reg)&^(0x10000000)|value<<28)
}
func (o *RTC_CNTL_Type) GetRTC_BROWN_OUT_BROWN_OUT_ANA_RST_EN() uint32 {
	return (volatile.LoadUint32(&o.RTC_BROWN_OUT.Reg) & 0x10000000) >> 28
}
func (o *RTC_CNTL_Type) SetRTC_BROWN_OUT_BROWN_OUT_CNT_CLR(value uint32) {
	volatile.StoreUint32(&o.RTC_BROWN_OUT.Reg, volatile.LoadUint32(&o.RTC_BROWN_OUT.Reg)&^(0x20000000)|value<<29)
}
func (o *RTC_CNTL_Type) GetRTC_BROWN_OUT_BROWN_OUT_CNT_CLR() uint32 {
	return (volatile.LoadUint32(&o.RTC_BROWN_OUT.Reg) & 0x20000000) >> 29
}
func (o *RTC_CNTL_Type) SetRTC_BROWN_OUT_BROWN_OUT_ENA(value uint32) {
	volatile.StoreUint32(&o.RTC_BROWN_OUT.Reg, volatile.LoadUint32(&o.RTC_BROWN_OUT.Reg)&^(0x40000000)|value<<30)
}
func (o *RTC_CNTL_Type) GetRTC_BROWN_OUT_BROWN_OUT_ENA() uint32 {
	return (volatile.LoadUint32(&o.RTC_BROWN_OUT.Reg) & 0x40000000) >> 30
}
func (o *RTC_CNTL_Type) SetRTC_BROWN_OUT_DET(value uint32) {
	volatile.StoreUint32(&o.RTC_BROWN_OUT.Reg, volatile.LoadUint32(&o.RTC_BROWN_OUT.Reg)&^(0x80000000)|value<<31)
}
func (o *RTC_CNTL_Type) GetRTC_BROWN_OUT_DET() uint32 {
	return (volatile.LoadUint32(&o.RTC_BROWN_OUT.Reg) & 0x80000000) >> 31
}

// RTC_CNTL.RTC_TIME_LOW1: rtc configure register
func (o *RTC_CNTL_Type) SetRTC_TIME_LOW1(value uint32) {
	volatile.StoreUint32(&o.RTC_TIME_LOW1.Reg, value)
}
func (o *RTC_CNTL_Type) GetRTC_TIME_LOW1() uint32 {
	return volatile.LoadUint32(&o.RTC_TIME_LOW1.Reg)
}

// RTC_CNTL.RTC_TIME_HIGH1: rtc configure register
func (o *RTC_CNTL_Type) SetRTC_TIME_HIGH1_RTC_TIMER_VALUE1_HIGH(value uint32) {
	volatile.StoreUint32(&o.RTC_TIME_HIGH1.Reg, volatile.LoadUint32(&o.RTC_TIME_HIGH1.Reg)&^(0xffff)|value)
}
func (o *RTC_CNTL_Type) GetRTC_TIME_HIGH1_RTC_TIMER_VALUE1_HIGH() uint32 {
	return volatile.LoadUint32(&o.RTC_TIME_HIGH1.Reg) & 0xffff
}

// RTC_CNTL.RTC_XTAL32K_CLK_FACTOR: rtc configure register
func (o *RTC_CNTL_Type) SetRTC_XTAL32K_CLK_FACTOR(value uint32) {
	volatile.StoreUint32(&o.RTC_XTAL32K_CLK_FACTOR.Reg, value)
}
func (o *RTC_CNTL_Type) GetRTC_XTAL32K_CLK_FACTOR() uint32 {
	return volatile.LoadUint32(&o.RTC_XTAL32K_CLK_FACTOR.Reg)
}

// RTC_CNTL.RTC_XTAL32K_CONF: rtc configure register
func (o *RTC_CNTL_Type) SetRTC_XTAL32K_CONF_XTAL32K_RETURN_WAIT(value uint32) {
	volatile.StoreUint32(&o.RTC_XTAL32K_CONF.Reg, volatile.LoadUint32(&o.RTC_XTAL32K_CONF.Reg)&^(0xf)|value)
}
func (o *RTC_CNTL_Type) GetRTC_XTAL32K_CONF_XTAL32K_RETURN_WAIT() uint32 {
	return volatile.LoadUint32(&o.RTC_XTAL32K_CONF.Reg) & 0xf
}
func (o *RTC_CNTL_Type) SetRTC_XTAL32K_CONF_XTAL32K_RESTART_WAIT(value uint32) {
	volatile.StoreUint32(&o.RTC_XTAL32K_CONF.Reg, volatile.LoadUint32(&o.RTC_XTAL32K_CONF.Reg)&^(0xffff0)|value<<4)
}
func (o *RTC_CNTL_Type) GetRTC_XTAL32K_CONF_XTAL32K_RESTART_WAIT() uint32 {
	return (volatile.LoadUint32(&o.RTC_XTAL32K_CONF.Reg) & 0xffff0) >> 4
}
func (o *RTC_CNTL_Type) SetRTC_XTAL32K_CONF_XTAL32K_WDT_TIMEOUT(value uint32) {
	volatile.StoreUint32(&o.RTC_XTAL32K_CONF.Reg, volatile.LoadUint32(&o.RTC_XTAL32K_CONF.Reg)&^(0xff00000)|value<<20)
}
func (o *RTC_CNTL_Type) GetRTC_XTAL32K_CONF_XTAL32K_WDT_TIMEOUT() uint32 {
	return (volatile.LoadUint32(&o.RTC_XTAL32K_CONF.Reg) & 0xff00000) >> 20
}
func (o *RTC_CNTL_Type) SetRTC_XTAL32K_CONF_XTAL32K_STABLE_THRES(value uint32) {
	volatile.StoreUint32(&o.RTC_XTAL32K_CONF.Reg, volatile.LoadUint32(&o.RTC_XTAL32K_CONF.Reg)&^(0xf0000000)|value<<28)
}
func (o *RTC_CNTL_Type) GetRTC_XTAL32K_CONF_XTAL32K_STABLE_THRES() uint32 {
	return (volatile.LoadUint32(&o.RTC_XTAL32K_CONF.Reg) & 0xf0000000) >> 28
}

// RTC_CNTL.RTC_USB_CONF: rtc configure register
func (o *RTC_CNTL_Type) SetRTC_USB_CONF_IO_MUX_RESET_DISABLE(value uint32) {
	volatile.StoreUint32(&o.RTC_USB_CONF.Reg, volatile.LoadUint32(&o.RTC_USB_CONF.Reg)&^(0x40000)|value<<18)
}
func (o *RTC_CNTL_Type) GetRTC_USB_CONF_IO_MUX_RESET_DISABLE() uint32 {
	return (volatile.LoadUint32(&o.RTC_USB_CONF.Reg) & 0x40000) >> 18
}

// RTC_CNTL.RTC_SLP_REJECT_CAUSE: RTC_CNTL_RTC_SLP_REJECT_CAUSE_REG
func (o *RTC_CNTL_Type) SetRTC_SLP_REJECT_CAUSE_REJECT_CAUSE(value uint32) {
	volatile.StoreUint32(&o.RTC_SLP_REJECT_CAUSE.Reg, volatile.LoadUint32(&o.RTC_SLP_REJECT_CAUSE.Reg)&^(0x3ffff)|value)
}
func (o *RTC_CNTL_Type) GetRTC_SLP_REJECT_CAUSE_REJECT_CAUSE() uint32 {
	return volatile.LoadUint32(&o.RTC_SLP_REJECT_CAUSE.Reg) & 0x3ffff
}

// RTC_CNTL.RTC_OPTION1: rtc configure register
func (o *RTC_CNTL_Type) SetRTC_OPTION1_FORCE_DOWNLOAD_BOOT(value uint32) {
	volatile.StoreUint32(&o.RTC_OPTION1.Reg, volatile.LoadUint32(&o.RTC_OPTION1.Reg)&^(0x1)|value)
}
func (o *RTC_CNTL_Type) GetRTC_OPTION1_FORCE_DOWNLOAD_BOOT() uint32 {
	return volatile.LoadUint32(&o.RTC_OPTION1.Reg) & 0x1
}

// RTC_CNTL.RTC_SLP_WAKEUP_CAUSE: RTC_CNTL_RTC_SLP_WAKEUP_CAUSE_REG
func (o *RTC_CNTL_Type) SetRTC_SLP_WAKEUP_CAUSE_WAKEUP_CAUSE(value uint32) {
	volatile.StoreUint32(&o.RTC_SLP_WAKEUP_CAUSE.Reg, volatile.LoadUint32(&o.RTC_SLP_WAKEUP_CAUSE.Reg)&^(0x1ffff)|value)
}
func (o *RTC_CNTL_Type) GetRTC_SLP_WAKEUP_CAUSE_WAKEUP_CAUSE() uint32 {
	return volatile.LoadUint32(&o.RTC_SLP_WAKEUP_CAUSE.Reg) & 0x1ffff
}

// RTC_CNTL.RTC_ULP_CP_TIMER_1: rtc configure register
func (o *RTC_CNTL_Type) SetRTC_ULP_CP_TIMER_1_ULP_CP_TIMER_SLP_CYCLE(value uint32) {
	volatile.StoreUint32(&o.RTC_ULP_CP_TIMER_1.Reg, volatile.LoadUint32(&o.RTC_ULP_CP_TIMER_1.Reg)&^(0xffffff00)|value<<8)
}
func (o *RTC_CNTL_Type) GetRTC_ULP_CP_TIMER_1_ULP_CP_TIMER_SLP_CYCLE() uint32 {
	return (volatile.LoadUint32(&o.RTC_ULP_CP_TIMER_1.Reg) & 0xffffff00) >> 8
}

// RTC_CNTL.INT_ENA_RTC_W1TS: rtc configure register
func (o *RTC_CNTL_Type) SetINT_ENA_RTC_W1TS_SLP_WAKEUP_INT_ENA_W1TS(value uint32) {
	volatile.StoreUint32(&o.INT_ENA_RTC_W1TS.Reg, volatile.LoadUint32(&o.INT_ENA_RTC_W1TS.Reg)&^(0x1)|value)
}
func (o *RTC_CNTL_Type) GetINT_ENA_RTC_W1TS_SLP_WAKEUP_INT_ENA_W1TS() uint32 {
	return volatile.LoadUint32(&o.INT_ENA_RTC_W1TS.Reg) & 0x1
}
func (o *RTC_CNTL_Type) SetINT_ENA_RTC_W1TS_SLP_REJECT_INT_ENA_W1TS(value uint32) {
	volatile.StoreUint32(&o.INT_ENA_RTC_W1TS.Reg, volatile.LoadUint32(&o.INT_ENA_RTC_W1TS.Reg)&^(0x2)|value<<1)
}
func (o *RTC_CNTL_Type) GetINT_ENA_RTC_W1TS_SLP_REJECT_INT_ENA_W1TS() uint32 {
	return (volatile.LoadUint32(&o.INT_ENA_RTC_W1TS.Reg) & 0x2) >> 1
}
func (o *RTC_CNTL_Type) SetINT_ENA_RTC_W1TS_RTC_WDT_INT_ENA_W1TS(value uint32) {
	volatile.StoreUint32(&o.INT_ENA_RTC_W1TS.Reg, volatile.LoadUint32(&o.INT_ENA_RTC_W1TS.Reg)&^(0x8)|value<<3)
}
func (o *RTC_CNTL_Type) GetINT_ENA_RTC_W1TS_RTC_WDT_INT_ENA_W1TS() uint32 {
	return (volatile.LoadUint32(&o.INT_ENA_RTC_W1TS.Reg) & 0x8) >> 3
}
func (o *RTC_CNTL_Type) SetINT_ENA_RTC_W1TS_RTC_BROWN_OUT_INT_ENA_W1TS(value uint32) {
	volatile.StoreUint32(&o.INT_ENA_RTC_W1TS.Reg, volatile.LoadUint32(&o.INT_ENA_RTC_W1TS.Reg)&^(0x200)|value<<9)
}
func (o *RTC_CNTL_Type) GetINT_ENA_RTC_W1TS_RTC_BROWN_OUT_INT_ENA_W1TS() uint32 {
	return (volatile.LoadUint32(&o.INT_ENA_RTC_W1TS.Reg) & 0x200) >> 9
}
func (o *RTC_CNTL_Type) SetINT_ENA_RTC_W1TS_RTC_MAIN_TIMER_INT_ENA_W1TS(value uint32) {
	volatile.StoreUint32(&o.INT_ENA_RTC_W1TS.Reg, volatile.LoadUint32(&o.INT_ENA_RTC_W1TS.Reg)&^(0x400)|value<<10)
}
func (o *RTC_CNTL_Type) GetINT_ENA_RTC_W1TS_RTC_MAIN_TIMER_INT_ENA_W1TS() uint32 {
	return (volatile.LoadUint32(&o.INT_ENA_RTC_W1TS.Reg) & 0x400) >> 10
}
func (o *RTC_CNTL_Type) SetINT_ENA_RTC_W1TS_RTC_SWD_INT_ENA_W1TS(value uint32) {
	volatile.StoreUint32(&o.INT_ENA_RTC_W1TS.Reg, volatile.LoadUint32(&o.INT_ENA_RTC_W1TS.Reg)&^(0x8000)|value<<15)
}
func (o *RTC_CNTL_Type) GetINT_ENA_RTC_W1TS_RTC_SWD_INT_ENA_W1TS() uint32 {
	return (volatile.LoadUint32(&o.INT_ENA_RTC_W1TS.Reg) & 0x8000) >> 15
}
func (o *RTC_CNTL_Type) SetINT_ENA_RTC_W1TS_RTC_XTAL32K_DEAD_INT_ENA_W1TS(value uint32) {
	volatile.StoreUint32(&o.INT_ENA_RTC_W1TS.Reg, volatile.LoadUint32(&o.INT_ENA_RTC_W1TS.Reg)&^(0x10000)|value<<16)
}
func (o *RTC_CNTL_Type) GetINT_ENA_RTC_W1TS_RTC_XTAL32K_DEAD_INT_ENA_W1TS() uint32 {
	return (volatile.LoadUint32(&o.INT_ENA_RTC_W1TS.Reg) & 0x10000) >> 16
}
func (o *RTC_CNTL_Type) SetINT_ENA_RTC_W1TS_RTC_GLITCH_DET_INT_ENA_W1TS(value uint32) {
	volatile.StoreUint32(&o.INT_ENA_RTC_W1TS.Reg, volatile.LoadUint32(&o.INT_ENA_RTC_W1TS.Reg)&^(0x80000)|value<<19)
}
func (o *RTC_CNTL_Type) GetINT_ENA_RTC_W1TS_RTC_GLITCH_DET_INT_ENA_W1TS() uint32 {
	return (volatile.LoadUint32(&o.INT_ENA_RTC_W1TS.Reg) & 0x80000) >> 19
}
func (o *RTC_CNTL_Type) SetINT_ENA_RTC_W1TS_RTC_BBPLL_CAL_INT_ENA_W1TS(value uint32) {
	volatile.StoreUint32(&o.INT_ENA_RTC_W1TS.Reg, volatile.LoadUint32(&o.INT_ENA_RTC_W1TS.Reg)&^(0x100000)|value<<20)
}
func (o *RTC_CNTL_Type) GetINT_ENA_RTC_W1TS_RTC_BBPLL_CAL_INT_ENA_W1TS() uint32 {
	return (volatile.LoadUint32(&o.INT_ENA_RTC_W1TS.Reg) & 0x100000) >> 20
}

// RTC_CNTL.INT_ENA_RTC_W1TC: rtc configure register
func (o *RTC_CNTL_Type) SetINT_ENA_RTC_W1TC_SLP_WAKEUP_INT_ENA_W1TC(value uint32) {
	volatile.StoreUint32(&o.INT_ENA_RTC_W1TC.Reg, volatile.LoadUint32(&o.INT_ENA_RTC_W1TC.Reg)&^(0x1)|value)
}
func (o *RTC_CNTL_Type) GetINT_ENA_RTC_W1TC_SLP_WAKEUP_INT_ENA_W1TC() uint32 {
	return volatile.LoadUint32(&o.INT_ENA_RTC_W1TC.Reg) & 0x1
}
func (o *RTC_CNTL_Type) SetINT_ENA_RTC_W1TC_SLP_REJECT_INT_ENA_W1TC(value uint32) {
	volatile.StoreUint32(&o.INT_ENA_RTC_W1TC.Reg, volatile.LoadUint32(&o.INT_ENA_RTC_W1TC.Reg)&^(0x2)|value<<1)
}
func (o *RTC_CNTL_Type) GetINT_ENA_RTC_W1TC_SLP_REJECT_INT_ENA_W1TC() uint32 {
	return (volatile.LoadUint32(&o.INT_ENA_RTC_W1TC.Reg) & 0x2) >> 1
}
func (o *RTC_CNTL_Type) SetINT_ENA_RTC_W1TC_RTC_WDT_INT_ENA_W1TC(value uint32) {
	volatile.StoreUint32(&o.INT_ENA_RTC_W1TC.Reg, volatile.LoadUint32(&o.INT_ENA_RTC_W1TC.Reg)&^(0x8)|value<<3)
}
func (o *RTC_CNTL_Type) GetINT_ENA_RTC_W1TC_RTC_WDT_INT_ENA_W1TC() uint32 {
	return (volatile.LoadUint32(&o.INT_ENA_RTC_W1TC.Reg) & 0x8) >> 3
}
func (o *RTC_CNTL_Type) SetINT_ENA_RTC_W1TC_RTC_BROWN_OUT_INT_ENA_W1TC(value uint32) {
	volatile.StoreUint32(&o.INT_ENA_RTC_W1TC.Reg, volatile.LoadUint32(&o.INT_ENA_RTC_W1TC.Reg)&^(0x200)|value<<9)
}
func (o *RTC_CNTL_Type) GetINT_ENA_RTC_W1TC_RTC_BROWN_OUT_INT_ENA_W1TC() uint32 {
	return (volatile.LoadUint32(&o.INT_ENA_RTC_W1TC.Reg) & 0x200) >> 9
}
func (o *RTC_CNTL_Type) SetINT_ENA_RTC_W1TC_RTC_MAIN_TIMER_INT_ENA_W1TC(value uint32) {
	volatile.StoreUint32(&o.INT_ENA_RTC_W1TC.Reg, volatile.LoadUint32(&o.INT_ENA_RTC_W1TC.Reg)&^(0x400)|value<<10)
}
func (o *RTC_CNTL_Type) GetINT_ENA_RTC_W1TC_RTC_MAIN_TIMER_INT_ENA_W1TC() uint32 {
	return (volatile.LoadUint32(&o.INT_ENA_RTC_W1TC.Reg) & 0x400) >> 10
}
func (o *RTC_CNTL_Type) SetINT_ENA_RTC_W1TC_RTC_SWD_INT_ENA_W1TC(value uint32) {
	volatile.StoreUint32(&o.INT_ENA_RTC_W1TC.Reg, volatile.LoadUint32(&o.INT_ENA_RTC_W1TC.Reg)&^(0x8000)|value<<15)
}
func (o *RTC_CNTL_Type) GetINT_ENA_RTC_W1TC_RTC_SWD_INT_ENA_W1TC() uint32 {
	return (volatile.LoadUint32(&o.INT_ENA_RTC_W1TC.Reg) & 0x8000) >> 15
}
func (o *RTC_CNTL_Type) SetINT_ENA_RTC_W1TC_RTC_XTAL32K_DEAD_INT_ENA_W1TC(value uint32) {
	volatile.StoreUint32(&o.INT_ENA_RTC_W1TC.Reg, volatile.LoadUint32(&o.INT_ENA_RTC_W1TC.Reg)&^(0x10000)|value<<16)
}
func (o *RTC_CNTL_Type) GetINT_ENA_RTC_W1TC_RTC_XTAL32K_DEAD_INT_ENA_W1TC() uint32 {
	return (volatile.LoadUint32(&o.INT_ENA_RTC_W1TC.Reg) & 0x10000) >> 16
}
func (o *RTC_CNTL_Type) SetINT_ENA_RTC_W1TC_RTC_GLITCH_DET_INT_ENA_W1TC(value uint32) {
	volatile.StoreUint32(&o.INT_ENA_RTC_W1TC.Reg, volatile.LoadUint32(&o.INT_ENA_RTC_W1TC.Reg)&^(0x80000)|value<<19)
}
func (o *RTC_CNTL_Type) GetINT_ENA_RTC_W1TC_RTC_GLITCH_DET_INT_ENA_W1TC() uint32 {
	return (volatile.LoadUint32(&o.INT_ENA_RTC_W1TC.Reg) & 0x80000) >> 19
}
func (o *RTC_CNTL_Type) SetINT_ENA_RTC_W1TC_RTC_BBPLL_CAL_INT_ENA_W1TC(value uint32) {
	volatile.StoreUint32(&o.INT_ENA_RTC_W1TC.Reg, volatile.LoadUint32(&o.INT_ENA_RTC_W1TC.Reg)&^(0x100000)|value<<20)
}
func (o *RTC_CNTL_Type) GetINT_ENA_RTC_W1TC_RTC_BBPLL_CAL_INT_ENA_W1TC() uint32 {
	return (volatile.LoadUint32(&o.INT_ENA_RTC_W1TC.Reg) & 0x100000) >> 20
}

// RTC_CNTL.RTC_CNTL_RETENTION_CTRL: rtc configure register
func (o *RTC_CNTL_Type) SetRTC_CNTL_RETENTION_CTRL_RETENTION_CLK_SEL(value uint32) {
	volatile.StoreUint32(&o.RTC_CNTL_RETENTION_CTRL.Reg, volatile.LoadUint32(&o.RTC_CNTL_RETENTION_CTRL.Reg)&^(0x40000)|value<<18)
}
func (o *RTC_CNTL_Type) GetRTC_CNTL_RETENTION_CTRL_RETENTION_CLK_SEL() uint32 {
	return (volatile.LoadUint32(&o.RTC_CNTL_RETENTION_CTRL.Reg) & 0x40000) >> 18
}
func (o *RTC_CNTL_Type) SetRTC_CNTL_RETENTION_CTRL_RETENTION_DONE_WAIT(value uint32) {
	volatile.StoreUint32(&o.RTC_CNTL_RETENTION_CTRL.Reg, volatile.LoadUint32(&o.RTC_CNTL_RETENTION_CTRL.Reg)&^(0x380000)|value<<19)
}
func (o *RTC_CNTL_Type) GetRTC_CNTL_RETENTION_CTRL_RETENTION_DONE_WAIT() uint32 {
	return (volatile.LoadUint32(&o.RTC_CNTL_RETENTION_CTRL.Reg) & 0x380000) >> 19
}
func (o *RTC_CNTL_Type) SetRTC_CNTL_RETENTION_CTRL_RETENTION_CLKOFF_WAIT(value uint32) {
	volatile.StoreUint32(&o.RTC_CNTL_RETENTION_CTRL.Reg, volatile.LoadUint32(&o.RTC_CNTL_RETENTION_CTRL.Reg)&^(0x3c00000)|value<<22)
}
func (o *RTC_CNTL_Type) GetRTC_CNTL_RETENTION_CTRL_RETENTION_CLKOFF_WAIT() uint32 {
	return (volatile.LoadUint32(&o.RTC_CNTL_RETENTION_CTRL.Reg) & 0x3c00000) >> 22
}
func (o *RTC_CNTL_Type) SetRTC_CNTL_RETENTION_CTRL_RETENTION_EN(value uint32) {
	volatile.StoreUint32(&o.RTC_CNTL_RETENTION_CTRL.Reg, volatile.LoadUint32(&o.RTC_CNTL_RETENTION_CTRL.Reg)&^(0x4000000)|value<<26)
}
func (o *RTC_CNTL_Type) GetRTC_CNTL_RETENTION_CTRL_RETENTION_EN() uint32 {
	return (volatile.LoadUint32(&o.RTC_CNTL_RETENTION_CTRL.Reg) & 0x4000000) >> 26
}
func (o *RTC_CNTL_Type) SetRTC_CNTL_RETENTION_CTRL_RETENTION_WAIT(value uint32) {
	volatile.StoreUint32(&o.RTC_CNTL_RETENTION_CTRL.Reg, volatile.LoadUint32(&o.RTC_CNTL_RETENTION_CTRL.Reg)&^(0xf8000000)|value<<27)
}
func (o *RTC_CNTL_Type) GetRTC_CNTL_RETENTION_CTRL_RETENTION_WAIT() uint32 {
	return (volatile.LoadUint32(&o.RTC_CNTL_RETENTION_CTRL.Reg) & 0xf8000000) >> 27
}

// RTC_CNTL.RTC_FIB_SEL: rtc configure register
func (o *RTC_CNTL_Type) SetRTC_FIB_SEL(value uint32) {
	volatile.StoreUint32(&o.RTC_FIB_SEL.Reg, volatile.LoadUint32(&o.RTC_FIB_SEL.Reg)&^(0x7)|value)
}
func (o *RTC_CNTL_Type) GetRTC_FIB_SEL() uint32 {
	return volatile.LoadUint32(&o.RTC_FIB_SEL.Reg) & 0x7
}

// RTC_CNTL.RTC_CNTL_GPIO_WAKEUP: rtc configure register
func (o *RTC_CNTL_Type) SetRTC_CNTL_GPIO_WAKEUP_RTC_GPIO_WAKEUP_STATUS(value uint32) {
	volatile.StoreUint32(&o.RTC_CNTL_GPIO_WAKEUP.Reg, volatile.LoadUint32(&o.RTC_CNTL_GPIO_WAKEUP.Reg)&^(0x3f)|value)
}
func (o *RTC_CNTL_Type) GetRTC_CNTL_GPIO_WAKEUP_RTC_GPIO_WAKEUP_STATUS() uint32 {
	return volatile.LoadUint32(&o.RTC_CNTL_GPIO_WAKEUP.Reg) & 0x3f
}
func (o *RTC_CNTL_Type) SetRTC_CNTL_GPIO_WAKEUP_RTC_GPIO_WAKEUP_STATUS_CLR(value uint32) {
	volatile.StoreUint32(&o.RTC_CNTL_GPIO_WAKEUP.Reg, volatile.LoadUint32(&o.RTC_CNTL_GPIO_WAKEUP.Reg)&^(0x40)|value<<6)
}
func (o *RTC_CNTL_Type) GetRTC_CNTL_GPIO_WAKEUP_RTC_GPIO_WAKEUP_STATUS_CLR() uint32 {
	return (volatile.LoadUint32(&o.RTC_CNTL_GPIO_WAKEUP.Reg) & 0x40) >> 6
}
func (o *RTC_CNTL_Type) SetRTC_CNTL_GPIO_WAKEUP_RTC_GPIO_PIN_CLK_GATE(value uint32) {
	volatile.StoreUint32(&o.RTC_CNTL_GPIO_WAKEUP.Reg, volatile.LoadUint32(&o.RTC_CNTL_GPIO_WAKEUP.Reg)&^(0x80)|value<<7)
}
func (o *RTC_CNTL_Type) GetRTC_CNTL_GPIO_WAKEUP_RTC_GPIO_PIN_CLK_GATE() uint32 {
	return (volatile.LoadUint32(&o.RTC_CNTL_GPIO_WAKEUP.Reg) & 0x80) >> 7
}
func (o *RTC_CNTL_Type) SetRTC_CNTL_GPIO_WAKEUP_RTC_GPIO_PIN5_INT_TYPE(value uint32) {
	volatile.StoreUint32(&o.RTC_CNTL_GPIO_WAKEUP.Reg, volatile.LoadUint32(&o.RTC_CNTL_GPIO_WAKEUP.Reg)&^(0x700)|value<<8)
}
func (o *RTC_CNTL_Type) GetRTC_CNTL_GPIO_WAKEUP_RTC_GPIO_PIN5_INT_TYPE() uint32 {
	return (volatile.LoadUint32(&o.RTC_CNTL_GPIO_WAKEUP.Reg) & 0x700) >> 8
}
func (o *RTC_CNTL_Type) SetRTC_CNTL_GPIO_WAKEUP_RTC_GPIO_PIN4_INT_TYPE(value uint32) {
	volatile.StoreUint32(&o.RTC_CNTL_GPIO_WAKEUP.Reg, volatile.LoadUint32(&o.RTC_CNTL_GPIO_WAKEUP.Reg)&^(0x3800)|value<<11)
}
func (o *RTC_CNTL_Type) GetRTC_CNTL_GPIO_WAKEUP_RTC_GPIO_PIN4_INT_TYPE() uint32 {
	return (volatile.LoadUint32(&o.RTC_CNTL_GPIO_WAKEUP.Reg) & 0x3800) >> 11
}
func (o *RTC_CNTL_Type) SetRTC_CNTL_GPIO_WAKEUP_RTC_GPIO_PIN3_INT_TYPE(value uint32) {
	volatile.StoreUint32(&o.RTC_CNTL_GPIO_WAKEUP.Reg, volatile.LoadUint32(&o.RTC_CNTL_GPIO_WAKEUP.Reg)&^(0x1c000)|value<<14)
}
func (o *RTC_CNTL_Type) GetRTC_CNTL_GPIO_WAKEUP_RTC_GPIO_PIN3_INT_TYPE() uint32 {
	return (volatile.LoadUint32(&o.RTC_CNTL_GPIO_WAKEUP.Reg) & 0x1c000) >> 14
}
func (o *RTC_CNTL_Type) SetRTC_CNTL_GPIO_WAKEUP_RTC_GPIO_PIN2_INT_TYPE(value uint32) {
	volatile.StoreUint32(&o.RTC_CNTL_GPIO_WAKEUP.Reg, volatile.LoadUint32(&o.RTC_CNTL_GPIO_WAKEUP.Reg)&^(0xe0000)|value<<17)
}
func (o *RTC_CNTL_Type) GetRTC_CNTL_GPIO_WAKEUP_RTC_GPIO_PIN2_INT_TYPE() uint32 {
	return (volatile.LoadUint32(&o.RTC_CNTL_GPIO_WAKEUP.Reg) & 0xe0000) >> 17
}
func (o *RTC_CNTL_Type) SetRTC_CNTL_GPIO_WAKEUP_RTC_GPIO_PIN1_INT_TYPE(value uint32) {
	volatile.StoreUint32(&o.RTC_CNTL_GPIO_WAKEUP.Reg, volatile.LoadUint32(&o.RTC_CNTL_GPIO_WAKEUP.Reg)&^(0x700000)|value<<20)
}
func (o *RTC_CNTL_Type) GetRTC_CNTL_GPIO_WAKEUP_RTC_GPIO_PIN1_INT_TYPE() uint32 {
	return (volatile.LoadUint32(&o.RTC_CNTL_GPIO_WAKEUP.Reg) & 0x700000) >> 20
}
func (o *RTC_CNTL_Type) SetRTC_CNTL_GPIO_WAKEUP_RTC_GPIO_PIN0_INT_TYPE(value uint32) {
	volatile.StoreUint32(&o.RTC_CNTL_GPIO_WAKEUP.Reg, volatile.LoadUint32(&o.RTC_CNTL_GPIO_WAKEUP.Reg)&^(0x3800000)|value<<23)
}
func (o *RTC_CNTL_Type) GetRTC_CNTL_GPIO_WAKEUP_RTC_GPIO_PIN0_INT_TYPE() uint32 {
	return (volatile.LoadUint32(&o.RTC_CNTL_GPIO_WAKEUP.Reg) & 0x3800000) >> 23
}
func (o *RTC_CNTL_Type) SetRTC_CNTL_GPIO_WAKEUP_RTC_GPIO_PIN5_WAKEUP_ENABLE(value uint32) {
	volatile.StoreUint32(&o.RTC_CNTL_GPIO_WAKEUP.Reg, volatile.LoadUint32(&o.RTC_CNTL_GPIO_WAKEUP.Reg)&^(0x4000000)|value<<26)
}
func (o *RTC_CNTL_Type) GetRTC_CNTL_GPIO_WAKEUP_RTC_GPIO_PIN5_WAKEUP_ENABLE() uint32 {
	return (volatile.LoadUint32(&o.RTC_CNTL_GPIO_WAKEUP.Reg) & 0x4000000) >> 26
}
func (o *RTC_CNTL_Type) SetRTC_CNTL_GPIO_WAKEUP_RTC_GPIO_PIN4_WAKEUP_ENABLE(value uint32) {
	volatile.StoreUint32(&o.RTC_CNTL_GPIO_WAKEUP.Reg, volatile.LoadUint32(&o.RTC_CNTL_GPIO_WAKEUP.Reg)&^(0x8000000)|value<<27)
}
func (o *RTC_CNTL_Type) GetRTC_CNTL_GPIO_WAKEUP_RTC_GPIO_PIN4_WAKEUP_ENABLE() uint32 {
	return (volatile.LoadUint32(&o.RTC_CNTL_GPIO_WAKEUP.Reg) & 0x8000000) >> 27
}
func (o *RTC_CNTL_Type) SetRTC_CNTL_GPIO_WAKEUP_RTC_GPIO_PIN3_WAKEUP_ENABLE(value uint32) {
	volatile.StoreUint32(&o.RTC_CNTL_GPIO_WAKEUP.Reg, volatile.LoadUint32(&o.RTC_CNTL_GPIO_WAKEUP.Reg)&^(0x10000000)|value<<28)
}
func (o *RTC_CNTL_Type) GetRTC_CNTL_GPIO_WAKEUP_RTC_GPIO_PIN3_WAKEUP_ENABLE() uint32 {
	return (volatile.LoadUint32(&o.RTC_CNTL_GPIO_WAKEUP.Reg) & 0x10000000) >> 28
}
func (o *RTC_CNTL_Type) SetRTC_CNTL_GPIO_WAKEUP_RTC_GPIO_PIN2_WAKEUP_ENABLE(value uint32) {
	volatile.StoreUint32(&o.RTC_CNTL_GPIO_WAKEUP.Reg, volatile.LoadUint32(&o.RTC_CNTL_GPIO_WAKEUP.Reg)&^(0x20000000)|value<<29)
}
func (o *RTC_CNTL_Type) GetRTC_CNTL_GPIO_WAKEUP_RTC_GPIO_PIN2_WAKEUP_ENABLE() uint32 {
	return (volatile.LoadUint32(&o.RTC_CNTL_GPIO_WAKEUP.Reg) & 0x20000000) >> 29
}
func (o *RTC_CNTL_Type) SetRTC_CNTL_GPIO_WAKEUP_RTC_GPIO_PIN1_WAKEUP_ENABLE(value uint32) {
	volatile.StoreUint32(&o.RTC_CNTL_GPIO_WAKEUP.Reg, volatile.LoadUint32(&o.RTC_CNTL_GPIO_WAKEUP.Reg)&^(0x40000000)|value<<30)
}
func (o *RTC_CNTL_Type) GetRTC_CNTL_GPIO_WAKEUP_RTC_GPIO_PIN1_WAKEUP_ENABLE() uint32 {
	return (volatile.LoadUint32(&o.RTC_CNTL_GPIO_WAKEUP.Reg) & 0x40000000) >> 30
}
func (o *RTC_CNTL_Type) SetRTC_CNTL_GPIO_WAKEUP_RTC_GPIO_PIN0_WAKEUP_ENABLE(value uint32) {
	volatile.StoreUint32(&o.RTC_CNTL_GPIO_WAKEUP.Reg, volatile.LoadUint32(&o.RTC_CNTL_GPIO_WAKEUP.Reg)&^(0x80000000)|value<<31)
}
func (o *RTC_CNTL_Type) GetRTC_CNTL_GPIO_WAKEUP_RTC_GPIO_PIN0_WAKEUP_ENABLE() uint32 {
	return (volatile.LoadUint32(&o.RTC_CNTL_GPIO_WAKEUP.Reg) & 0x80000000) >> 31
}

// RTC_CNTL.RTC_CNTL_DBG_SEL: rtc configure register
func (o *RTC_CNTL_Type) SetRTC_CNTL_DBG_SEL_RTC_DEBUG_12M_NO_GATING(value uint32) {
	volatile.StoreUint32(&o.RTC_CNTL_DBG_SEL.Reg, volatile.LoadUint32(&o.RTC_CNTL_DBG_SEL.Reg)&^(0x2)|value<<1)
}
func (o *RTC_CNTL_Type) GetRTC_CNTL_DBG_SEL_RTC_DEBUG_12M_NO_GATING() uint32 {
	return (volatile.LoadUint32(&o.RTC_CNTL_DBG_SEL.Reg) & 0x2) >> 1
}
func (o *RTC_CNTL_Type) SetRTC_CNTL_DBG_SEL_RTC_DEBUG_BIT_SEL(value uint32) {
	volatile.StoreUint32(&o.RTC_CNTL_DBG_SEL.Reg, volatile.LoadUint32(&o.RTC_CNTL_DBG_SEL.Reg)&^(0x7c)|value<<2)
}
func (o *RTC_CNTL_Type) GetRTC_CNTL_DBG_SEL_RTC_DEBUG_BIT_SEL() uint32 {
	return (volatile.LoadUint32(&o.RTC_CNTL_DBG_SEL.Reg) & 0x7c) >> 2
}
func (o *RTC_CNTL_Type) SetRTC_CNTL_DBG_SEL_RTC_DEBUG_SEL0(value uint32) {
	volatile.StoreUint32(&o.RTC_CNTL_DBG_SEL.Reg, volatile.LoadUint32(&o.RTC_CNTL_DBG_SEL.Reg)&^(0xf80)|value<<7)
}
func (o *RTC_CNTL_Type) GetRTC_CNTL_DBG_SEL_RTC_DEBUG_SEL0() uint32 {
	return (volatile.LoadUint32(&o.RTC_CNTL_DBG_SEL.Reg) & 0xf80) >> 7
}
func (o *RTC_CNTL_Type) SetRTC_CNTL_DBG_SEL_RTC_DEBUG_SEL1(value uint32) {
	volatile.StoreUint32(&o.RTC_CNTL_DBG_SEL.Reg, volatile.LoadUint32(&o.RTC_CNTL_DBG_SEL.Reg)&^(0x1f000)|value<<12)
}
func (o *RTC_CNTL_Type) GetRTC_CNTL_DBG_SEL_RTC_DEBUG_SEL1() uint32 {
	return (volatile.LoadUint32(&o.RTC_CNTL_DBG_SEL.Reg) & 0x1f000) >> 12
}
func (o *RTC_CNTL_Type) SetRTC_CNTL_DBG_SEL_RTC_DEBUG_SEL2(value uint32) {
	volatile.StoreUint32(&o.RTC_CNTL_DBG_SEL.Reg, volatile.LoadUint32(&o.RTC_CNTL_DBG_SEL.Reg)&^(0x3e0000)|value<<17)
}
func (o *RTC_CNTL_Type) GetRTC_CNTL_DBG_SEL_RTC_DEBUG_SEL2() uint32 {
	return (volatile.LoadUint32(&o.RTC_CNTL_DBG_SEL.Reg) & 0x3e0000) >> 17
}
func (o *RTC_CNTL_Type) SetRTC_CNTL_DBG_SEL_RTC_DEBUG_SEL3(value uint32) {
	volatile.StoreUint32(&o.RTC_CNTL_DBG_SEL.Reg, volatile.LoadUint32(&o.RTC_CNTL_DBG_SEL.Reg)&^(0x7c00000)|value<<22)
}
func (o *RTC_CNTL_Type) GetRTC_CNTL_DBG_SEL_RTC_DEBUG_SEL3() uint32 {
	return (volatile.LoadUint32(&o.RTC_CNTL_DBG_SEL.Reg) & 0x7c00000) >> 22
}
func (o *RTC_CNTL_Type) SetRTC_CNTL_DBG_SEL_RTC_DEBUG_SEL4(value uint32) {
	volatile.StoreUint32(&o.RTC_CNTL_DBG_SEL.Reg, volatile.LoadUint32(&o.RTC_CNTL_DBG_SEL.Reg)&^(0xf8000000)|value<<27)
}
func (o *RTC_CNTL_Type) GetRTC_CNTL_DBG_SEL_RTC_DEBUG_SEL4() uint32 {
	return (volatile.LoadUint32(&o.RTC_CNTL_DBG_SEL.Reg) & 0xf8000000) >> 27
}

// RTC_CNTL.RTC_CNTL_DBG_MAP: rtc configure register
func (o *RTC_CNTL_Type) SetRTC_CNTL_DBG_MAP_RTC_GPIO_PIN5_MUX_SEL(value uint32) {
	volatile.StoreUint32(&o.RTC_CNTL_DBG_MAP.Reg, volatile.LoadUint32(&o.RTC_CNTL_DBG_MAP.Reg)&^(0x4)|value<<2)
}
func (o *RTC_CNTL_Type) GetRTC_CNTL_DBG_MAP_RTC_GPIO_PIN5_MUX_SEL() uint32 {
	return (volatile.LoadUint32(&o.RTC_CNTL_DBG_MAP.Reg) & 0x4) >> 2
}
func (o *RTC_CNTL_Type) SetRTC_CNTL_DBG_MAP_RTC_GPIO_PIN4_MUX_SEL(value uint32) {
	volatile.StoreUint32(&o.RTC_CNTL_DBG_MAP.Reg, volatile.LoadUint32(&o.RTC_CNTL_DBG_MAP.Reg)&^(0x8)|value<<3)
}
func (o *RTC_CNTL_Type) GetRTC_CNTL_DBG_MAP_RTC_GPIO_PIN4_MUX_SEL() uint32 {
	return (volatile.LoadUint32(&o.RTC_CNTL_DBG_MAP.Reg) & 0x8) >> 3
}
func (o *RTC_CNTL_Type) SetRTC_CNTL_DBG_MAP_RTC_GPIO_PIN3_MUX_SEL(value uint32) {
	volatile.StoreUint32(&o.RTC_CNTL_DBG_MAP.Reg, volatile.LoadUint32(&o.RTC_CNTL_DBG_MAP.Reg)&^(0x10)|value<<4)
}
func (o *RTC_CNTL_Type) GetRTC_CNTL_DBG_MAP_RTC_GPIO_PIN3_MUX_SEL() uint32 {
	return (volatile.LoadUint32(&o.RTC_CNTL_DBG_MAP.Reg) & 0x10) >> 4
}
func (o *RTC_CNTL_Type) SetRTC_CNTL_DBG_MAP_RTC_GPIO_PIN2_MUX_SEL(value uint32) {
	volatile.StoreUint32(&o.RTC_CNTL_DBG_MAP.Reg, volatile.LoadUint32(&o.RTC_CNTL_DBG_MAP.Reg)&^(0x20)|value<<5)
}
func (o *RTC_CNTL_Type) GetRTC_CNTL_DBG_MAP_RTC_GPIO_PIN2_MUX_SEL() uint32 {
	return (volatile.LoadUint32(&o.RTC_CNTL_DBG_MAP.Reg) & 0x20) >> 5
}
func (o *RTC_CNTL_Type) SetRTC_CNTL_DBG_MAP_RTC_GPIO_PIN1_MUX_SEL(value uint32) {
	volatile.StoreUint32(&o.RTC_CNTL_DBG_MAP.Reg, volatile.LoadUint32(&o.RTC_CNTL_DBG_MAP.Reg)&^(0x40)|value<<6)
}
func (o *RTC_CNTL_Type) GetRTC_CNTL_DBG_MAP_RTC_GPIO_PIN1_MUX_SEL() uint32 {
	return (volatile.LoadUint32(&o.RTC_CNTL_DBG_MAP.Reg) & 0x40) >> 6
}
func (o *RTC_CNTL_Type) SetRTC_CNTL_DBG_MAP_RTC_GPIO_PIN0_MUX_SEL(value uint32) {
	volatile.StoreUint32(&o.RTC_CNTL_DBG_MAP.Reg, volatile.LoadUint32(&o.RTC_CNTL_DBG_MAP.Reg)&^(0x80)|value<<7)
}
func (o *RTC_CNTL_Type) GetRTC_CNTL_DBG_MAP_RTC_GPIO_PIN0_MUX_SEL() uint32 {
	return (volatile.LoadUint32(&o.RTC_CNTL_DBG_MAP.Reg) & 0x80) >> 7
}
func (o *RTC_CNTL_Type) SetRTC_CNTL_DBG_MAP_RTC_GPIO_PIN5_FUN_SEL(value uint32) {
	volatile.StoreUint32(&o.RTC_CNTL_DBG_MAP.Reg, volatile.LoadUint32(&o.RTC_CNTL_DBG_MAP.Reg)&^(0xf00)|value<<8)
}
func (o *RTC_CNTL_Type) GetRTC_CNTL_DBG_MAP_RTC_GPIO_PIN5_FUN_SEL() uint32 {
	return (volatile.LoadUint32(&o.RTC_CNTL_DBG_MAP.Reg) & 0xf00) >> 8
}
func (o *RTC_CNTL_Type) SetRTC_CNTL_DBG_MAP_RTC_GPIO_PIN4_FUN_SEL(value uint32) {
	volatile.StoreUint32(&o.RTC_CNTL_DBG_MAP.Reg, volatile.LoadUint32(&o.RTC_CNTL_DBG_MAP.Reg)&^(0xf000)|value<<12)
}
func (o *RTC_CNTL_Type) GetRTC_CNTL_DBG_MAP_RTC_GPIO_PIN4_FUN_SEL() uint32 {
	return (volatile.LoadUint32(&o.RTC_CNTL_DBG_MAP.Reg) & 0xf000) >> 12
}
func (o *RTC_CNTL_Type) SetRTC_CNTL_DBG_MAP_RTC_GPIO_PIN3_FUN_SEL(value uint32) {
	volatile.StoreUint32(&o.RTC_CNTL_DBG_MAP.Reg, volatile.LoadUint32(&o.RTC_CNTL_DBG_MAP.Reg)&^(0xf0000)|value<<16)
}
func (o *RTC_CNTL_Type) GetRTC_CNTL_DBG_MAP_RTC_GPIO_PIN3_FUN_SEL() uint32 {
	return (volatile.LoadUint32(&o.RTC_CNTL_DBG_MAP.Reg) & 0xf0000) >> 16
}
func (o *RTC_CNTL_Type) SetRTC_CNTL_DBG_MAP_RTC_GPIO_PIN2_FUN_SEL(value uint32) {
	volatile.StoreUint32(&o.RTC_CNTL_DBG_MAP.Reg, volatile.LoadUint32(&o.RTC_CNTL_DBG_MAP.Reg)&^(0xf00000)|value<<20)
}
func (o *RTC_CNTL_Type) GetRTC_CNTL_DBG_MAP_RTC_GPIO_PIN2_FUN_SEL() uint32 {
	return (volatile.LoadUint32(&o.RTC_CNTL_DBG_MAP.Reg) & 0xf00000) >> 20
}
func (o *RTC_CNTL_Type) SetRTC_CNTL_DBG_MAP_RTC_GPIO_PIN1_FUN_SEL(value uint32) {
	volatile.StoreUint32(&o.RTC_CNTL_DBG_MAP.Reg, volatile.LoadUint32(&o.RTC_CNTL_DBG_MAP.Reg)&^(0xf000000)|value<<24)
}
func (o *RTC_CNTL_Type) GetRTC_CNTL_DBG_MAP_RTC_GPIO_PIN1_FUN_SEL() uint32 {
	return (volatile.LoadUint32(&o.RTC_CNTL_DBG_MAP.Reg) & 0xf000000) >> 24
}
func (o *RTC_CNTL_Type) SetRTC_CNTL_DBG_MAP_RTC_GPIO_PIN0_FUN_SEL(value uint32) {
	volatile.StoreUint32(&o.RTC_CNTL_DBG_MAP.Reg, volatile.LoadUint32(&o.RTC_CNTL_DBG_MAP.Reg)&^(0xf0000000)|value<<28)
}
func (o *RTC_CNTL_Type) GetRTC_CNTL_DBG_MAP_RTC_GPIO_PIN0_FUN_SEL() uint32 {
	return (volatile.LoadUint32(&o.RTC_CNTL_DBG_MAP.Reg) & 0xf0000000) >> 28
}

// RTC_CNTL.RTC_CNTL_SENSOR_CTRL: rtc configure register
func (o *RTC_CNTL_Type) SetRTC_CNTL_SENSOR_CTRL_SAR2_PWDET_CCT(value uint32) {
	volatile.StoreUint32(&o.RTC_CNTL_SENSOR_CTRL.Reg, volatile.LoadUint32(&o.RTC_CNTL_SENSOR_CTRL.Reg)&^(0x38000000)|value<<27)
}
func (o *RTC_CNTL_Type) GetRTC_CNTL_SENSOR_CTRL_SAR2_PWDET_CCT() uint32 {
	return (volatile.LoadUint32(&o.RTC_CNTL_SENSOR_CTRL.Reg) & 0x38000000) >> 27
}
func (o *RTC_CNTL_Type) SetRTC_CNTL_SENSOR_CTRL_FORCE_XPD_SAR(value uint32) {
	volatile.StoreUint32(&o.RTC_CNTL_SENSOR_CTRL.Reg, volatile.LoadUint32(&o.RTC_CNTL_SENSOR_CTRL.Reg)&^(0xc0000000)|value<<30)
}
func (o *RTC_CNTL_Type) GetRTC_CNTL_SENSOR_CTRL_FORCE_XPD_SAR() uint32 {
	return (volatile.LoadUint32(&o.RTC_CNTL_SENSOR_CTRL.Reg) & 0xc0000000) >> 30
}

// RTC_CNTL.RTC_CNTL_DBG_SAR_SEL: rtc configure register
func (o *RTC_CNTL_Type) SetRTC_CNTL_DBG_SAR_SEL_SAR_DEBUG_SEL(value uint32) {
	volatile.StoreUint32(&o.RTC_CNTL_DBG_SAR_SEL.Reg, volatile.LoadUint32(&o.RTC_CNTL_DBG_SAR_SEL.Reg)&^(0xf8000000)|value<<27)
}
func (o *RTC_CNTL_Type) GetRTC_CNTL_DBG_SAR_SEL_SAR_DEBUG_SEL() uint32 {
	return (volatile.LoadUint32(&o.RTC_CNTL_DBG_SAR_SEL.Reg) & 0xf8000000) >> 27
}

// RTC_CNTL.RTC_CNTL_PG_CTRL: rtc configure register
func (o *RTC_CNTL_Type) SetRTC_CNTL_PG_CTRL_POWER_GLITCH_DSENSE(value uint32) {
	volatile.StoreUint32(&o.RTC_CNTL_PG_CTRL.Reg, volatile.LoadUint32(&o.RTC_CNTL_PG_CTRL.Reg)&^(0xc000000)|value<<26)
}
func (o *RTC_CNTL_Type) GetRTC_CNTL_PG_CTRL_POWER_GLITCH_DSENSE() uint32 {
	return (volatile.LoadUint32(&o.RTC_CNTL_PG_CTRL.Reg) & 0xc000000) >> 26
}
func (o *RTC_CNTL_Type) SetRTC_CNTL_PG_CTRL_POWER_GLITCH_FORCE_PD(value uint32) {
	volatile.StoreUint32(&o.RTC_CNTL_PG_CTRL.Reg, volatile.LoadUint32(&o.RTC_CNTL_PG_CTRL.Reg)&^(0x10000000)|value<<28)
}
func (o *RTC_CNTL_Type) GetRTC_CNTL_PG_CTRL_POWER_GLITCH_FORCE_PD() uint32 {
	return (volatile.LoadUint32(&o.RTC_CNTL_PG_CTRL.Reg) & 0x10000000) >> 28
}
func (o *RTC_CNTL_Type) SetRTC_CNTL_PG_CTRL_POWER_GLITCH_FORCE_PU(value uint32) {
	volatile.StoreUint32(&o.RTC_CNTL_PG_CTRL.Reg, volatile.LoadUint32(&o.RTC_CNTL_PG_CTRL.Reg)&^(0x20000000)|value<<29)
}
func (o *RTC_CNTL_Type) GetRTC_CNTL_PG_CTRL_POWER_GLITCH_FORCE_PU() uint32 {
	return (volatile.LoadUint32(&o.RTC_CNTL_PG_CTRL.Reg) & 0x20000000) >> 29
}
func (o *RTC_CNTL_Type) SetRTC_CNTL_PG_CTRL_POWER_GLITCH_EFUSE_SEL(value uint32) {
	volatile.StoreUint32(&o.RTC_CNTL_PG_CTRL.Reg, volatile.LoadUint32(&o.RTC_CNTL_PG_CTRL.Reg)&^(0x40000000)|value<<30)
}
func (o *RTC_CNTL_Type) GetRTC_CNTL_PG_CTRL_POWER_GLITCH_EFUSE_SEL() uint32 {
	return (volatile.LoadUint32(&o.RTC_CNTL_PG_CTRL.Reg) & 0x40000000) >> 30
}
func (o *RTC_CNTL_Type) SetRTC_CNTL_PG_CTRL_POWER_GLITCH_EN(value uint32) {
	volatile.StoreUint32(&o.RTC_CNTL_PG_CTRL.Reg, volatile.LoadUint32(&o.RTC_CNTL_PG_CTRL.Reg)&^(0x80000000)|value<<31)
}
func (o *RTC_CNTL_Type) GetRTC_CNTL_PG_CTRL_POWER_GLITCH_EN() uint32 {
	return (volatile.LoadUint32(&o.RTC_CNTL_PG_CTRL.Reg) & 0x80000000) >> 31
}

// RTC_CNTL.DATE: rtc configure register
func (o *RTC_CNTL_Type) SetDATE_RTC_CNTL_DATE(value uint32) {
	volatile.StoreUint32(&o.DATE.Reg, volatile.LoadUint32(&o.DATE.Reg)&^(0xfffffff)|value)
}
func (o *RTC_CNTL_Type) GetDATE_RTC_CNTL_DATE() uint32 {
	return volatile.LoadUint32(&o.DATE.Reg) & 0xfffffff
}

// Peripheral SENSITIVE
type SENSITIVE_Type struct {
	ROM_TABLE_LOCK                                volatile.Register32 // 0x0
	ROM_TABLE                                     volatile.Register32 // 0x4
	PRIVILEGE_MODE_SEL_LOCK                       volatile.Register32 // 0x8
	PRIVILEGE_MODE_SEL                            volatile.Register32 // 0xC
	APB_PERIPHERAL_ACCESS_0                       volatile.Register32 // 0x10
	APB_PERIPHERAL_ACCESS_1                       volatile.Register32 // 0x14
	INTERNAL_SRAM_USAGE_0                         volatile.Register32 // 0x18
	INTERNAL_SRAM_USAGE_1                         volatile.Register32 // 0x1C
	INTERNAL_SRAM_USAGE_3                         volatile.Register32 // 0x20
	INTERNAL_SRAM_USAGE_4                         volatile.Register32 // 0x24
	CACHE_TAG_ACCESS_0                            volatile.Register32 // 0x28
	CACHE_TAG_ACCESS_1                            volatile.Register32 // 0x2C
	CACHE_MMU_ACCESS_0                            volatile.Register32 // 0x30
	CACHE_MMU_ACCESS_1                            volatile.Register32 // 0x34
	DMA_APBPERI_SPI2_PMS_CONSTRAIN_0              volatile.Register32 // 0x38
	DMA_APBPERI_SPI2_PMS_CONSTRAIN_1              volatile.Register32 // 0x3C
	DMA_APBPERI_UCHI0_PMS_CONSTRAIN_0             volatile.Register32 // 0x40
	DMA_APBPERI_UCHI0_PMS_CONSTRAIN_1             volatile.Register32 // 0x44
	DMA_APBPERI_I2S0_PMS_CONSTRAIN_0              volatile.Register32 // 0x48
	DMA_APBPERI_I2S0_PMS_CONSTRAIN_1              volatile.Register32 // 0x4C
	DMA_APBPERI_MAC_PMS_CONSTRAIN_0               volatile.Register32 // 0x50
	DMA_APBPERI_MAC_PMS_CONSTRAIN_1               volatile.Register32 // 0x54
	DMA_APBPERI_BACKUP_PMS_CONSTRAIN_0            volatile.Register32 // 0x58
	DMA_APBPERI_BACKUP_PMS_CONSTRAIN_1            volatile.Register32 // 0x5C
	DMA_APBPERI_LC_PMS_CONSTRAIN_0                volatile.Register32 // 0x60
	DMA_APBPERI_LC_PMS_CONSTRAIN_1                volatile.Register32 // 0x64
	DMA_APBPERI_AES_PMS_CONSTRAIN_0               volatile.Register32 // 0x68
	DMA_APBPERI_AES_PMS_CONSTRAIN_1               volatile.Register32 // 0x6C
	DMA_APBPERI_SHA_PMS_CONSTRAIN_0               volatile.Register32 // 0x70
	DMA_APBPERI_SHA_PMS_CONSTRAIN_1               volatile.Register32 // 0x74
	DMA_APBPERI_ADC_DAC_PMS_CONSTRAIN_0           volatile.Register32 // 0x78
	DMA_APBPERI_ADC_DAC_PMS_CONSTRAIN_1           volatile.Register32 // 0x7C
	DMA_APBPERI_PMS_MONITOR_0                     volatile.Register32 // 0x80
	DMA_APBPERI_PMS_MONITOR_1                     volatile.Register32 // 0x84
	DMA_APBPERI_PMS_MONITOR_2                     volatile.Register32 // 0x88
	DMA_APBPERI_PMS_MONITOR_3                     volatile.Register32 // 0x8C
	CORE_X_IRAM0_DRAM0_DMA_SPLIT_LINE_CONSTRAIN_0 volatile.Register32 // 0x90
	CORE_X_IRAM0_DRAM0_DMA_SPLIT_LINE_CONSTRAIN_1 volatile.Register32 // 0x94
	CORE_X_IRAM0_DRAM0_DMA_SPLIT_LINE_CONSTRAIN_2 volatile.Register32 // 0x98
	CORE_X_IRAM0_DRAM0_DMA_SPLIT_LINE_CONSTRAIN_3 volatile.Register32 // 0x9C
	CORE_X_IRAM0_DRAM0_DMA_SPLIT_LINE_CONSTRAIN_4 volatile.Register32 // 0xA0
	CORE_X_IRAM0_DRAM0_DMA_SPLIT_LINE_CONSTRAIN_5 volatile.Register32 // 0xA4
	CORE_X_IRAM0_PMS_CONSTRAIN_0                  volatile.Register32 // 0xA8
	CORE_X_IRAM0_PMS_CONSTRAIN_1                  volatile.Register32 // 0xAC
	CORE_X_IRAM0_PMS_CONSTRAIN_2                  volatile.Register32 // 0xB0
	CORE_0_IRAM0_PMS_MONITOR_0                    volatile.Register32 // 0xB4
	CORE_0_IRAM0_PMS_MONITOR_1                    volatile.Register32 // 0xB8
	CORE_0_IRAM0_PMS_MONITOR_2                    volatile.Register32 // 0xBC
	CORE_X_DRAM0_PMS_CONSTRAIN_0                  volatile.Register32 // 0xC0
	CORE_X_DRAM0_PMS_CONSTRAIN_1                  volatile.Register32 // 0xC4
	CORE_0_DRAM0_PMS_MONITOR_0                    volatile.Register32 // 0xC8
	CORE_0_DRAM0_PMS_MONITOR_1                    volatile.Register32 // 0xCC
	CORE_0_DRAM0_PMS_MONITOR_2                    volatile.Register32 // 0xD0
	CORE_0_DRAM0_PMS_MONITOR_3                    volatile.Register32 // 0xD4
	CORE_0_PIF_PMS_CONSTRAIN_0                    volatile.Register32 // 0xD8
	CORE_0_PIF_PMS_CONSTRAIN_1                    volatile.Register32 // 0xDC
	CORE_0_PIF_PMS_CONSTRAIN_2                    volatile.Register32 // 0xE0
	CORE_0_PIF_PMS_CONSTRAIN_3                    volatile.Register32 // 0xE4
	CORE_0_PIF_PMS_CONSTRAIN_4                    volatile.Register32 // 0xE8
	CORE_0_PIF_PMS_CONSTRAIN_5                    volatile.Register32 // 0xEC
	CORE_0_PIF_PMS_CONSTRAIN_6                    volatile.Register32 // 0xF0
	CORE_0_PIF_PMS_CONSTRAIN_7                    volatile.Register32 // 0xF4
	CORE_0_PIF_PMS_CONSTRAIN_8                    volatile.Register32 // 0xF8
	CORE_0_PIF_PMS_CONSTRAIN_9                    volatile.Register32 // 0xFC
	CORE_0_PIF_PMS_CONSTRAIN_10                   volatile.Register32 // 0x100
	REGION_PMS_CONSTRAIN_0                        volatile.Register32 // 0x104
	REGION_PMS_CONSTRAIN_1                        volatile.Register32 // 0x108
	REGION_PMS_CONSTRAIN_2                        volatile.Register32 // 0x10C
	REGION_PMS_CONSTRAIN_3                        volatile.Register32 // 0x110
	REGION_PMS_CONSTRAIN_4                        volatile.Register32 // 0x114
	REGION_PMS_CONSTRAIN_5                        volatile.Register32 // 0x118
	REGION_PMS_CONSTRAIN_6                        volatile.Register32 // 0x11C
	REGION_PMS_CONSTRAIN_7                        volatile.Register32 // 0x120
	REGION_PMS_CONSTRAIN_8                        volatile.Register32 // 0x124
	REGION_PMS_CONSTRAIN_9                        volatile.Register32 // 0x128
	REGION_PMS_CONSTRAIN_10                       volatile.Register32 // 0x12C
	CORE_0_PIF_PMS_MONITOR_0                      volatile.Register32 // 0x130
	CORE_0_PIF_PMS_MONITOR_1                      volatile.Register32 // 0x134
	CORE_0_PIF_PMS_MONITOR_2                      volatile.Register32 // 0x138
	CORE_0_PIF_PMS_MONITOR_3                      volatile.Register32 // 0x13C
	CORE_0_PIF_PMS_MONITOR_4                      volatile.Register32 // 0x140
	CORE_0_PIF_PMS_MONITOR_5                      volatile.Register32 // 0x144
	CORE_0_PIF_PMS_MONITOR_6                      volatile.Register32 // 0x148
	BACKUP_BUS_PMS_CONSTRAIN_0                    volatile.Register32 // 0x14C
	BACKUP_BUS_PMS_CONSTRAIN_1                    volatile.Register32 // 0x150
	BACKUP_BUS_PMS_CONSTRAIN_2                    volatile.Register32 // 0x154
	BACKUP_BUS_PMS_CONSTRAIN_3                    volatile.Register32 // 0x158
	BACKUP_BUS_PMS_CONSTRAIN_4                    volatile.Register32 // 0x15C
	BACKUP_BUS_PMS_MONITOR_0                      volatile.Register32 // 0x160
	BACKUP_BUS_PMS_MONITOR_1                      volatile.Register32 // 0x164
	BACKUP_BUS_PMS_MONITOR_2                      volatile.Register32 // 0x168
	BACKUP_BUS_PMS_MONITOR_3                      volatile.Register32 // 0x16C
	CLOCK_GATE                                    volatile.Register32 // 0x170
	_                                             [3720]byte
	DATE                                          volatile.Register32 // 0xFFC
}

// SENSITIVE.ROM_TABLE_LOCK: SENSITIVE_ROM_TABLE_LOCK_REG
func (o *SENSITIVE_Type) SetROM_TABLE_LOCK(value uint32) {
	volatile.StoreUint32(&o.ROM_TABLE_LOCK.Reg, volatile.LoadUint32(&o.ROM_TABLE_LOCK.Reg)&^(0x1)|value)
}
func (o *SENSITIVE_Type) GetROM_TABLE_LOCK() uint32 {
	return volatile.LoadUint32(&o.ROM_TABLE_LOCK.Reg) & 0x1
}

// SENSITIVE.ROM_TABLE: SENSITIVE_ROM_TABLE_REG
func (o *SENSITIVE_Type) SetROM_TABLE(value uint32) {
	volatile.StoreUint32(&o.ROM_TABLE.Reg, value)
}
func (o *SENSITIVE_Type) GetROM_TABLE() uint32 {
	return volatile.LoadUint32(&o.ROM_TABLE.Reg)
}

// SENSITIVE.PRIVILEGE_MODE_SEL_LOCK: SENSITIVE_PRIVILEGE_MODE_SEL_LOCK_REG
func (o *SENSITIVE_Type) SetPRIVILEGE_MODE_SEL_LOCK(value uint32) {
	volatile.StoreUint32(&o.PRIVILEGE_MODE_SEL_LOCK.Reg, volatile.LoadUint32(&o.PRIVILEGE_MODE_SEL_LOCK.Reg)&^(0x1)|value)
}
func (o *SENSITIVE_Type) GetPRIVILEGE_MODE_SEL_LOCK() uint32 {
	return volatile.LoadUint32(&o.PRIVILEGE_MODE_SEL_LOCK.Reg) & 0x1
}

// SENSITIVE.PRIVILEGE_MODE_SEL: SENSITIVE_PRIVILEGE_MODE_SEL_REG
func (o *SENSITIVE_Type) SetPRIVILEGE_MODE_SEL(value uint32) {
	volatile.StoreUint32(&o.PRIVILEGE_MODE_SEL.Reg, volatile.LoadUint32(&o.PRIVILEGE_MODE_SEL.Reg)&^(0x1)|value)
}
func (o *SENSITIVE_Type) GetPRIVILEGE_MODE_SEL() uint32 {
	return volatile.LoadUint32(&o.PRIVILEGE_MODE_SEL.Reg) & 0x1
}

// SENSITIVE.APB_PERIPHERAL_ACCESS_0: SENSITIVE_APB_PERIPHERAL_ACCESS_0_REG
func (o *SENSITIVE_Type) SetAPB_PERIPHERAL_ACCESS_0_APB_PERIPHERAL_ACCESS_LOCK(value uint32) {
	volatile.StoreUint32(&o.APB_PERIPHERAL_ACCESS_0.Reg, volatile.LoadUint32(&o.APB_PERIPHERAL_ACCESS_0.Reg)&^(0x1)|value)
}
func (o *SENSITIVE_Type) GetAPB_PERIPHERAL_ACCESS_0_APB_PERIPHERAL_ACCESS_LOCK() uint32 {
	return volatile.LoadUint32(&o.APB_PERIPHERAL_ACCESS_0.Reg) & 0x1
}

// SENSITIVE.APB_PERIPHERAL_ACCESS_1: SENSITIVE_APB_PERIPHERAL_ACCESS_1_REG
func (o *SENSITIVE_Type) SetAPB_PERIPHERAL_ACCESS_1_APB_PERIPHERAL_ACCESS_SPLIT_BURST(value uint32) {
	volatile.StoreUint32(&o.APB_PERIPHERAL_ACCESS_1.Reg, volatile.LoadUint32(&o.APB_PERIPHERAL_ACCESS_1.Reg)&^(0x1)|value)
}
func (o *SENSITIVE_Type) GetAPB_PERIPHERAL_ACCESS_1_APB_PERIPHERAL_ACCESS_SPLIT_BURST() uint32 {
	return volatile.LoadUint32(&o.APB_PERIPHERAL_ACCESS_1.Reg) & 0x1
}

// SENSITIVE.INTERNAL_SRAM_USAGE_0: SENSITIVE_INTERNAL_SRAM_USAGE_0_REG
func (o *SENSITIVE_Type) SetINTERNAL_SRAM_USAGE_0_INTERNAL_SRAM_USAGE_LOCK(value uint32) {
	volatile.StoreUint32(&o.INTERNAL_SRAM_USAGE_0.Reg, volatile.LoadUint32(&o.INTERNAL_SRAM_USAGE_0.Reg)&^(0x1)|value)
}
func (o *SENSITIVE_Type) GetINTERNAL_SRAM_USAGE_0_INTERNAL_SRAM_USAGE_LOCK() uint32 {
	return volatile.LoadUint32(&o.INTERNAL_SRAM_USAGE_0.Reg) & 0x1
}

// SENSITIVE.INTERNAL_SRAM_USAGE_1: SENSITIVE_INTERNAL_SRAM_USAGE_1_REG
func (o *SENSITIVE_Type) SetINTERNAL_SRAM_USAGE_1_INTERNAL_SRAM_USAGE_CPU_CACHE(value uint32) {
	volatile.StoreUint32(&o.INTERNAL_SRAM_USAGE_1.Reg, volatile.LoadUint32(&o.INTERNAL_SRAM_USAGE_1.Reg)&^(0x1)|value)
}
func (o *SENSITIVE_Type) GetINTERNAL_SRAM_USAGE_1_INTERNAL_SRAM_USAGE_CPU_CACHE() uint32 {
	return volatile.LoadUint32(&o.INTERNAL_SRAM_USAGE_1.Reg) & 0x1
}
func (o *SENSITIVE_Type) SetINTERNAL_SRAM_USAGE_1_INTERNAL_SRAM_USAGE_CPU_SRAM(value uint32) {
	volatile.StoreUint32(&o.INTERNAL_SRAM_USAGE_1.Reg, volatile.LoadUint32(&o.INTERNAL_SRAM_USAGE_1.Reg)&^(0xe)|value<<1)
}
func (o *SENSITIVE_Type) GetINTERNAL_SRAM_USAGE_1_INTERNAL_SRAM_USAGE_CPU_SRAM() uint32 {
	return (volatile.LoadUint32(&o.INTERNAL_SRAM_USAGE_1.Reg) & 0xe) >> 1
}

// SENSITIVE.INTERNAL_SRAM_USAGE_3: SENSITIVE_INTERNAL_SRAM_USAGE_3_REG
func (o *SENSITIVE_Type) SetINTERNAL_SRAM_USAGE_3_INTERNAL_SRAM_USAGE_MAC_DUMP_SRAM(value uint32) {
	volatile.StoreUint32(&o.INTERNAL_SRAM_USAGE_3.Reg, volatile.LoadUint32(&o.INTERNAL_SRAM_USAGE_3.Reg)&^(0x7)|value)
}
func (o *SENSITIVE_Type) GetINTERNAL_SRAM_USAGE_3_INTERNAL_SRAM_USAGE_MAC_DUMP_SRAM() uint32 {
	return volatile.LoadUint32(&o.INTERNAL_SRAM_USAGE_3.Reg) & 0x7
}
func (o *SENSITIVE_Type) SetINTERNAL_SRAM_USAGE_3_INTERNAL_SRAM_ALLOC_MAC_DUMP(value uint32) {
	volatile.StoreUint32(&o.INTERNAL_SRAM_USAGE_3.Reg, volatile.LoadUint32(&o.INTERNAL_SRAM_USAGE_3.Reg)&^(0x8)|value<<3)
}
func (o *SENSITIVE_Type) GetINTERNAL_SRAM_USAGE_3_INTERNAL_SRAM_ALLOC_MAC_DUMP() uint32 {
	return (volatile.LoadUint32(&o.INTERNAL_SRAM_USAGE_3.Reg) & 0x8) >> 3
}

// SENSITIVE.INTERNAL_SRAM_USAGE_4: SENSITIVE_INTERNAL_SRAM_USAGE_4_REG
func (o *SENSITIVE_Type) SetINTERNAL_SRAM_USAGE_4_INTERNAL_SRAM_USAGE_LOG_SRAM(value uint32) {
	volatile.StoreUint32(&o.INTERNAL_SRAM_USAGE_4.Reg, volatile.LoadUint32(&o.INTERNAL_SRAM_USAGE_4.Reg)&^(0x1)|value)
}
func (o *SENSITIVE_Type) GetINTERNAL_SRAM_USAGE_4_INTERNAL_SRAM_USAGE_LOG_SRAM() uint32 {
	return volatile.LoadUint32(&o.INTERNAL_SRAM_USAGE_4.Reg) & 0x1
}

// SENSITIVE.CACHE_TAG_ACCESS_0: SENSITIVE_CACHE_TAG_ACCESS_0_REG
func (o *SENSITIVE_Type) SetCACHE_TAG_ACCESS_0_CACHE_TAG_ACCESS_LOCK(value uint32) {
	volatile.StoreUint32(&o.CACHE_TAG_ACCESS_0.Reg, volatile.LoadUint32(&o.CACHE_TAG_ACCESS_0.Reg)&^(0x1)|value)
}
func (o *SENSITIVE_Type) GetCACHE_TAG_ACCESS_0_CACHE_TAG_ACCESS_LOCK() uint32 {
	return volatile.LoadUint32(&o.CACHE_TAG_ACCESS_0.Reg) & 0x1
}

// SENSITIVE.CACHE_TAG_ACCESS_1: SENSITIVE_CACHE_TAG_ACCESS_1_REG
func (o *SENSITIVE_Type) SetCACHE_TAG_ACCESS_1_PRO_I_TAG_RD_ACS(value uint32) {
	volatile.StoreUint32(&o.CACHE_TAG_ACCESS_1.Reg, volatile.LoadUint32(&o.CACHE_TAG_ACCESS_1.Reg)&^(0x1)|value)
}
func (o *SENSITIVE_Type) GetCACHE_TAG_ACCESS_1_PRO_I_TAG_RD_ACS() uint32 {
	return volatile.LoadUint32(&o.CACHE_TAG_ACCESS_1.Reg) & 0x1
}
func (o *SENSITIVE_Type) SetCACHE_TAG_ACCESS_1_PRO_I_TAG_WR_ACS(value uint32) {
	volatile.StoreUint32(&o.CACHE_TAG_ACCESS_1.Reg, volatile.LoadUint32(&o.CACHE_TAG_ACCESS_1.Reg)&^(0x2)|value<<1)
}
func (o *SENSITIVE_Type) GetCACHE_TAG_ACCESS_1_PRO_I_TAG_WR_ACS() uint32 {
	return (volatile.LoadUint32(&o.CACHE_TAG_ACCESS_1.Reg) & 0x2) >> 1
}
func (o *SENSITIVE_Type) SetCACHE_TAG_ACCESS_1_PRO_D_TAG_RD_ACS(value uint32) {
	volatile.StoreUint32(&o.CACHE_TAG_ACCESS_1.Reg, volatile.LoadUint32(&o.CACHE_TAG_ACCESS_1.Reg)&^(0x4)|value<<2)
}
func (o *SENSITIVE_Type) GetCACHE_TAG_ACCESS_1_PRO_D_TAG_RD_ACS() uint32 {
	return (volatile.LoadUint32(&o.CACHE_TAG_ACCESS_1.Reg) & 0x4) >> 2
}
func (o *SENSITIVE_Type) SetCACHE_TAG_ACCESS_1_PRO_D_TAG_WR_ACS(value uint32) {
	volatile.StoreUint32(&o.CACHE_TAG_ACCESS_1.Reg, volatile.LoadUint32(&o.CACHE_TAG_ACCESS_1.Reg)&^(0x8)|value<<3)
}
func (o *SENSITIVE_Type) GetCACHE_TAG_ACCESS_1_PRO_D_TAG_WR_ACS() uint32 {
	return (volatile.LoadUint32(&o.CACHE_TAG_ACCESS_1.Reg) & 0x8) >> 3
}

// SENSITIVE.CACHE_MMU_ACCESS_0: SENSITIVE_CACHE_MMU_ACCESS_0_REG
func (o *SENSITIVE_Type) SetCACHE_MMU_ACCESS_0_CACHE_MMU_ACCESS_LOCK(value uint32) {
	volatile.StoreUint32(&o.CACHE_MMU_ACCESS_0.Reg, volatile.LoadUint32(&o.CACHE_MMU_ACCESS_0.Reg)&^(0x1)|value)
}
func (o *SENSITIVE_Type) GetCACHE_MMU_ACCESS_0_CACHE_MMU_ACCESS_LOCK() uint32 {
	return volatile.LoadUint32(&o.CACHE_MMU_ACCESS_0.Reg) & 0x1
}

// SENSITIVE.CACHE_MMU_ACCESS_1: SENSITIVE_CACHE_MMU_ACCESS_1_REG
func (o *SENSITIVE_Type) SetCACHE_MMU_ACCESS_1_PRO_MMU_RD_ACS(value uint32) {
	volatile.StoreUint32(&o.CACHE_MMU_ACCESS_1.Reg, volatile.LoadUint32(&o.CACHE_MMU_ACCESS_1.Reg)&^(0x1)|value)
}
func (o *SENSITIVE_Type) GetCACHE_MMU_ACCESS_1_PRO_MMU_RD_ACS() uint32 {
	return volatile.LoadUint32(&o.CACHE_MMU_ACCESS_1.Reg) & 0x1
}
func (o *SENSITIVE_Type) SetCACHE_MMU_ACCESS_1_PRO_MMU_WR_ACS(value uint32) {
	volatile.StoreUint32(&o.CACHE_MMU_ACCESS_1.Reg, volatile.LoadUint32(&o.CACHE_MMU_ACCESS_1.Reg)&^(0x2)|value<<1)
}
func (o *SENSITIVE_Type) GetCACHE_MMU_ACCESS_1_PRO_MMU_WR_ACS() uint32 {
	return (volatile.LoadUint32(&o.CACHE_MMU_ACCESS_1.Reg) & 0x2) >> 1
}

// SENSITIVE.DMA_APBPERI_SPI2_PMS_CONSTRAIN_0: SENSITIVE_DMA_APBPERI_SPI2_PMS_CONSTRAIN_0_REG
func (o *SENSITIVE_Type) SetDMA_APBPERI_SPI2_PMS_CONSTRAIN_0_DMA_APBPERI_SPI2_PMS_CONSTRAIN_LOCK(value uint32) {
	volatile.StoreUint32(&o.DMA_APBPERI_SPI2_PMS_CONSTRAIN_0.Reg, volatile.LoadUint32(&o.DMA_APBPERI_SPI2_PMS_CONSTRAIN_0.Reg)&^(0x1)|value)
}
func (o *SENSITIVE_Type) GetDMA_APBPERI_SPI2_PMS_CONSTRAIN_0_DMA_APBPERI_SPI2_PMS_CONSTRAIN_LOCK() uint32 {
	return volatile.LoadUint32(&o.DMA_APBPERI_SPI2_PMS_CONSTRAIN_0.Reg) & 0x1
}

// SENSITIVE.DMA_APBPERI_SPI2_PMS_CONSTRAIN_1: SENSITIVE_DMA_APBPERI_SPI2_PMS_CONSTRAIN_1_REG
func (o *SENSITIVE_Type) SetDMA_APBPERI_SPI2_PMS_CONSTRAIN_1_DMA_APBPERI_SPI2_PMS_CONSTRAIN_SRAM_WORLD_0_PMS_0(value uint32) {
	volatile.StoreUint32(&o.DMA_APBPERI_SPI2_PMS_CONSTRAIN_1.Reg, volatile.LoadUint32(&o.DMA_APBPERI_SPI2_PMS_CONSTRAIN_1.Reg)&^(0x3)|value)
}
func (o *SENSITIVE_Type) GetDMA_APBPERI_SPI2_PMS_CONSTRAIN_1_DMA_APBPERI_SPI2_PMS_CONSTRAIN_SRAM_WORLD_0_PMS_0() uint32 {
	return volatile.LoadUint32(&o.DMA_APBPERI_SPI2_PMS_CONSTRAIN_1.Reg) & 0x3
}
func (o *SENSITIVE_Type) SetDMA_APBPERI_SPI2_PMS_CONSTRAIN_1_DMA_APBPERI_SPI2_PMS_CONSTRAIN_SRAM_WORLD_0_PMS_1(value uint32) {
	volatile.StoreUint32(&o.DMA_APBPERI_SPI2_PMS_CONSTRAIN_1.Reg, volatile.LoadUint32(&o.DMA_APBPERI_SPI2_PMS_CONSTRAIN_1.Reg)&^(0xc)|value<<2)
}
func (o *SENSITIVE_Type) GetDMA_APBPERI_SPI2_PMS_CONSTRAIN_1_DMA_APBPERI_SPI2_PMS_CONSTRAIN_SRAM_WORLD_0_PMS_1() uint32 {
	return (volatile.LoadUint32(&o.DMA_APBPERI_SPI2_PMS_CONSTRAIN_1.Reg) & 0xc) >> 2
}
func (o *SENSITIVE_Type) SetDMA_APBPERI_SPI2_PMS_CONSTRAIN_1_DMA_APBPERI_SPI2_PMS_CONSTRAIN_SRAM_WORLD_0_PMS_2(value uint32) {
	volatile.StoreUint32(&o.DMA_APBPERI_SPI2_PMS_CONSTRAIN_1.Reg, volatile.LoadUint32(&o.DMA_APBPERI_SPI2_PMS_CONSTRAIN_1.Reg)&^(0x30)|value<<4)
}
func (o *SENSITIVE_Type) GetDMA_APBPERI_SPI2_PMS_CONSTRAIN_1_DMA_APBPERI_SPI2_PMS_CONSTRAIN_SRAM_WORLD_0_PMS_2() uint32 {
	return (volatile.LoadUint32(&o.DMA_APBPERI_SPI2_PMS_CONSTRAIN_1.Reg) & 0x30) >> 4
}
func (o *SENSITIVE_Type) SetDMA_APBPERI_SPI2_PMS_CONSTRAIN_1_DMA_APBPERI_SPI2_PMS_CONSTRAIN_SRAM_WORLD_0_PMS_3(value uint32) {
	volatile.StoreUint32(&o.DMA_APBPERI_SPI2_PMS_CONSTRAIN_1.Reg, volatile.LoadUint32(&o.DMA_APBPERI_SPI2_PMS_CONSTRAIN_1.Reg)&^(0xc0)|value<<6)
}
func (o *SENSITIVE_Type) GetDMA_APBPERI_SPI2_PMS_CONSTRAIN_1_DMA_APBPERI_SPI2_PMS_CONSTRAIN_SRAM_WORLD_0_PMS_3() uint32 {
	return (volatile.LoadUint32(&o.DMA_APBPERI_SPI2_PMS_CONSTRAIN_1.Reg) & 0xc0) >> 6
}
func (o *SENSITIVE_Type) SetDMA_APBPERI_SPI2_PMS_CONSTRAIN_1_DMA_APBPERI_SPI2_PMS_CONSTRAIN_SRAM_WORLD_1_PMS_0(value uint32) {
	volatile.StoreUint32(&o.DMA_APBPERI_SPI2_PMS_CONSTRAIN_1.Reg, volatile.LoadUint32(&o.DMA_APBPERI_SPI2_PMS_CONSTRAIN_1.Reg)&^(0x3000)|value<<12)
}
func (o *SENSITIVE_Type) GetDMA_APBPERI_SPI2_PMS_CONSTRAIN_1_DMA_APBPERI_SPI2_PMS_CONSTRAIN_SRAM_WORLD_1_PMS_0() uint32 {
	return (volatile.LoadUint32(&o.DMA_APBPERI_SPI2_PMS_CONSTRAIN_1.Reg) & 0x3000) >> 12
}
func (o *SENSITIVE_Type) SetDMA_APBPERI_SPI2_PMS_CONSTRAIN_1_DMA_APBPERI_SPI2_PMS_CONSTRAIN_SRAM_WORLD_1_PMS_1(value uint32) {
	volatile.StoreUint32(&o.DMA_APBPERI_SPI2_PMS_CONSTRAIN_1.Reg, volatile.LoadUint32(&o.DMA_APBPERI_SPI2_PMS_CONSTRAIN_1.Reg)&^(0xc000)|value<<14)
}
func (o *SENSITIVE_Type) GetDMA_APBPERI_SPI2_PMS_CONSTRAIN_1_DMA_APBPERI_SPI2_PMS_CONSTRAIN_SRAM_WORLD_1_PMS_1() uint32 {
	return (volatile.LoadUint32(&o.DMA_APBPERI_SPI2_PMS_CONSTRAIN_1.Reg) & 0xc000) >> 14
}
func (o *SENSITIVE_Type) SetDMA_APBPERI_SPI2_PMS_CONSTRAIN_1_DMA_APBPERI_SPI2_PMS_CONSTRAIN_SRAM_WORLD_1_PMS_2(value uint32) {
	volatile.StoreUint32(&o.DMA_APBPERI_SPI2_PMS_CONSTRAIN_1.Reg, volatile.LoadUint32(&o.DMA_APBPERI_SPI2_PMS_CONSTRAIN_1.Reg)&^(0x30000)|value<<16)
}
func (o *SENSITIVE_Type) GetDMA_APBPERI_SPI2_PMS_CONSTRAIN_1_DMA_APBPERI_SPI2_PMS_CONSTRAIN_SRAM_WORLD_1_PMS_2() uint32 {
	return (volatile.LoadUint32(&o.DMA_APBPERI_SPI2_PMS_CONSTRAIN_1.Reg) & 0x30000) >> 16
}
func (o *SENSITIVE_Type) SetDMA_APBPERI_SPI2_PMS_CONSTRAIN_1_DMA_APBPERI_SPI2_PMS_CONSTRAIN_SRAM_WORLD_1_PMS_3(value uint32) {
	volatile.StoreUint32(&o.DMA_APBPERI_SPI2_PMS_CONSTRAIN_1.Reg, volatile.LoadUint32(&o.DMA_APBPERI_SPI2_PMS_CONSTRAIN_1.Reg)&^(0xc0000)|value<<18)
}
func (o *SENSITIVE_Type) GetDMA_APBPERI_SPI2_PMS_CONSTRAIN_1_DMA_APBPERI_SPI2_PMS_CONSTRAIN_SRAM_WORLD_1_PMS_3() uint32 {
	return (volatile.LoadUint32(&o.DMA_APBPERI_SPI2_PMS_CONSTRAIN_1.Reg) & 0xc0000) >> 18
}

// SENSITIVE.DMA_APBPERI_UCHI0_PMS_CONSTRAIN_0: SENSITIVE_DMA_APBPERI_UCHI0_PMS_CONSTRAIN_0_REG
func (o *SENSITIVE_Type) SetDMA_APBPERI_UCHI0_PMS_CONSTRAIN_0_DMA_APBPERI_UCHI0_PMS_CONSTRAIN_LOCK(value uint32) {
	volatile.StoreUint32(&o.DMA_APBPERI_UCHI0_PMS_CONSTRAIN_0.Reg, volatile.LoadUint32(&o.DMA_APBPERI_UCHI0_PMS_CONSTRAIN_0.Reg)&^(0x1)|value)
}
func (o *SENSITIVE_Type) GetDMA_APBPERI_UCHI0_PMS_CONSTRAIN_0_DMA_APBPERI_UCHI0_PMS_CONSTRAIN_LOCK() uint32 {
	return volatile.LoadUint32(&o.DMA_APBPERI_UCHI0_PMS_CONSTRAIN_0.Reg) & 0x1
}

// SENSITIVE.DMA_APBPERI_UCHI0_PMS_CONSTRAIN_1: SENSITIVE_DMA_APBPERI_UCHI0_PMS_CONSTRAIN_1_REG
func (o *SENSITIVE_Type) SetDMA_APBPERI_UCHI0_PMS_CONSTRAIN_1_DMA_APBPERI_UCHI0_PMS_CONSTRAIN_SRAM_WORLD_0_PMS_0(value uint32) {
	volatile.StoreUint32(&o.DMA_APBPERI_UCHI0_PMS_CONSTRAIN_1.Reg, volatile.LoadUint32(&o.DMA_APBPERI_UCHI0_PMS_CONSTRAIN_1.Reg)&^(0x3)|value)
}
func (o *SENSITIVE_Type) GetDMA_APBPERI_UCHI0_PMS_CONSTRAIN_1_DMA_APBPERI_UCHI0_PMS_CONSTRAIN_SRAM_WORLD_0_PMS_0() uint32 {
	return volatile.LoadUint32(&o.DMA_APBPERI_UCHI0_PMS_CONSTRAIN_1.Reg) & 0x3
}
func (o *SENSITIVE_Type) SetDMA_APBPERI_UCHI0_PMS_CONSTRAIN_1_DMA_APBPERI_UCHI0_PMS_CONSTRAIN_SRAM_WORLD_0_PMS_1(value uint32) {
	volatile.StoreUint32(&o.DMA_APBPERI_UCHI0_PMS_CONSTRAIN_1.Reg, volatile.LoadUint32(&o.DMA_APBPERI_UCHI0_PMS_CONSTRAIN_1.Reg)&^(0xc)|value<<2)
}
func (o *SENSITIVE_Type) GetDMA_APBPERI_UCHI0_PMS_CONSTRAIN_1_DMA_APBPERI_UCHI0_PMS_CONSTRAIN_SRAM_WORLD_0_PMS_1() uint32 {
	return (volatile.LoadUint32(&o.DMA_APBPERI_UCHI0_PMS_CONSTRAIN_1.Reg) & 0xc) >> 2
}
func (o *SENSITIVE_Type) SetDMA_APBPERI_UCHI0_PMS_CONSTRAIN_1_DMA_APBPERI_UCHI0_PMS_CONSTRAIN_SRAM_WORLD_0_PMS_2(value uint32) {
	volatile.StoreUint32(&o.DMA_APBPERI_UCHI0_PMS_CONSTRAIN_1.Reg, volatile.LoadUint32(&o.DMA_APBPERI_UCHI0_PMS_CONSTRAIN_1.Reg)&^(0x30)|value<<4)
}
func (o *SENSITIVE_Type) GetDMA_APBPERI_UCHI0_PMS_CONSTRAIN_1_DMA_APBPERI_UCHI0_PMS_CONSTRAIN_SRAM_WORLD_0_PMS_2() uint32 {
	return (volatile.LoadUint32(&o.DMA_APBPERI_UCHI0_PMS_CONSTRAIN_1.Reg) & 0x30) >> 4
}
func (o *SENSITIVE_Type) SetDMA_APBPERI_UCHI0_PMS_CONSTRAIN_1_DMA_APBPERI_UCHI0_PMS_CONSTRAIN_SRAM_WORLD_0_PMS_3(value uint32) {
	volatile.StoreUint32(&o.DMA_APBPERI_UCHI0_PMS_CONSTRAIN_1.Reg, volatile.LoadUint32(&o.DMA_APBPERI_UCHI0_PMS_CONSTRAIN_1.Reg)&^(0xc0)|value<<6)
}
func (o *SENSITIVE_Type) GetDMA_APBPERI_UCHI0_PMS_CONSTRAIN_1_DMA_APBPERI_UCHI0_PMS_CONSTRAIN_SRAM_WORLD_0_PMS_3() uint32 {
	return (volatile.LoadUint32(&o.DMA_APBPERI_UCHI0_PMS_CONSTRAIN_1.Reg) & 0xc0) >> 6
}
func (o *SENSITIVE_Type) SetDMA_APBPERI_UCHI0_PMS_CONSTRAIN_1_DMA_APBPERI_UCHI0_PMS_CONSTRAIN_SRAM_WORLD_1_PMS_0(value uint32) {
	volatile.StoreUint32(&o.DMA_APBPERI_UCHI0_PMS_CONSTRAIN_1.Reg, volatile.LoadUint32(&o.DMA_APBPERI_UCHI0_PMS_CONSTRAIN_1.Reg)&^(0x3000)|value<<12)
}
func (o *SENSITIVE_Type) GetDMA_APBPERI_UCHI0_PMS_CONSTRAIN_1_DMA_APBPERI_UCHI0_PMS_CONSTRAIN_SRAM_WORLD_1_PMS_0() uint32 {
	return (volatile.LoadUint32(&o.DMA_APBPERI_UCHI0_PMS_CONSTRAIN_1.Reg) & 0x3000) >> 12
}
func (o *SENSITIVE_Type) SetDMA_APBPERI_UCHI0_PMS_CONSTRAIN_1_DMA_APBPERI_UCHI0_PMS_CONSTRAIN_SRAM_WORLD_1_PMS_1(value uint32) {
	volatile.StoreUint32(&o.DMA_APBPERI_UCHI0_PMS_CONSTRAIN_1.Reg, volatile.LoadUint32(&o.DMA_APBPERI_UCHI0_PMS_CONSTRAIN_1.Reg)&^(0xc000)|value<<14)
}
func (o *SENSITIVE_Type) GetDMA_APBPERI_UCHI0_PMS_CONSTRAIN_1_DMA_APBPERI_UCHI0_PMS_CONSTRAIN_SRAM_WORLD_1_PMS_1() uint32 {
	return (volatile.LoadUint32(&o.DMA_APBPERI_UCHI0_PMS_CONSTRAIN_1.Reg) & 0xc000) >> 14
}
func (o *SENSITIVE_Type) SetDMA_APBPERI_UCHI0_PMS_CONSTRAIN_1_DMA_APBPERI_UCHI0_PMS_CONSTRAIN_SRAM_WORLD_1_PMS_2(value uint32) {
	volatile.StoreUint32(&o.DMA_APBPERI_UCHI0_PMS_CONSTRAIN_1.Reg, volatile.LoadUint32(&o.DMA_APBPERI_UCHI0_PMS_CONSTRAIN_1.Reg)&^(0x30000)|value<<16)
}
func (o *SENSITIVE_Type) GetDMA_APBPERI_UCHI0_PMS_CONSTRAIN_1_DMA_APBPERI_UCHI0_PMS_CONSTRAIN_SRAM_WORLD_1_PMS_2() uint32 {
	return (volatile.LoadUint32(&o.DMA_APBPERI_UCHI0_PMS_CONSTRAIN_1.Reg) & 0x30000) >> 16
}
func (o *SENSITIVE_Type) SetDMA_APBPERI_UCHI0_PMS_CONSTRAIN_1_DMA_APBPERI_UCHI0_PMS_CONSTRAIN_SRAM_WORLD_1_PMS_3(value uint32) {
	volatile.StoreUint32(&o.DMA_APBPERI_UCHI0_PMS_CONSTRAIN_1.Reg, volatile.LoadUint32(&o.DMA_APBPERI_UCHI0_PMS_CONSTRAIN_1.Reg)&^(0xc0000)|value<<18)
}
func (o *SENSITIVE_Type) GetDMA_APBPERI_UCHI0_PMS_CONSTRAIN_1_DMA_APBPERI_UCHI0_PMS_CONSTRAIN_SRAM_WORLD_1_PMS_3() uint32 {
	return (volatile.LoadUint32(&o.DMA_APBPERI_UCHI0_PMS_CONSTRAIN_1.Reg) & 0xc0000) >> 18
}

// SENSITIVE.DMA_APBPERI_I2S0_PMS_CONSTRAIN_0: SENSITIVE_DMA_APBPERI_I2S0_PMS_CONSTRAIN_0_REG
func (o *SENSITIVE_Type) SetDMA_APBPERI_I2S0_PMS_CONSTRAIN_0_DMA_APBPERI_I2S0_PMS_CONSTRAIN_LOCK(value uint32) {
	volatile.StoreUint32(&o.DMA_APBPERI_I2S0_PMS_CONSTRAIN_0.Reg, volatile.LoadUint32(&o.DMA_APBPERI_I2S0_PMS_CONSTRAIN_0.Reg)&^(0x1)|value)
}
func (o *SENSITIVE_Type) GetDMA_APBPERI_I2S0_PMS_CONSTRAIN_0_DMA_APBPERI_I2S0_PMS_CONSTRAIN_LOCK() uint32 {
	return volatile.LoadUint32(&o.DMA_APBPERI_I2S0_PMS_CONSTRAIN_0.Reg) & 0x1
}

// SENSITIVE.DMA_APBPERI_I2S0_PMS_CONSTRAIN_1: SENSITIVE_DMA_APBPERI_I2S0_PMS_CONSTRAIN_1_REG
func (o *SENSITIVE_Type) SetDMA_APBPERI_I2S0_PMS_CONSTRAIN_1_DMA_APBPERI_I2S0_PMS_CONSTRAIN_SRAM_WORLD_0_PMS_0(value uint32) {
	volatile.StoreUint32(&o.DMA_APBPERI_I2S0_PMS_CONSTRAIN_1.Reg, volatile.LoadUint32(&o.DMA_APBPERI_I2S0_PMS_CONSTRAIN_1.Reg)&^(0x3)|value)
}
func (o *SENSITIVE_Type) GetDMA_APBPERI_I2S0_PMS_CONSTRAIN_1_DMA_APBPERI_I2S0_PMS_CONSTRAIN_SRAM_WORLD_0_PMS_0() uint32 {
	return volatile.LoadUint32(&o.DMA_APBPERI_I2S0_PMS_CONSTRAIN_1.Reg) & 0x3
}
func (o *SENSITIVE_Type) SetDMA_APBPERI_I2S0_PMS_CONSTRAIN_1_DMA_APBPERI_I2S0_PMS_CONSTRAIN_SRAM_WORLD_0_PMS_1(value uint32) {
	volatile.StoreUint32(&o.DMA_APBPERI_I2S0_PMS_CONSTRAIN_1.Reg, volatile.LoadUint32(&o.DMA_APBPERI_I2S0_PMS_CONSTRAIN_1.Reg)&^(0xc)|value<<2)
}
func (o *SENSITIVE_Type) GetDMA_APBPERI_I2S0_PMS_CONSTRAIN_1_DMA_APBPERI_I2S0_PMS_CONSTRAIN_SRAM_WORLD_0_PMS_1() uint32 {
	return (volatile.LoadUint32(&o.DMA_APBPERI_I2S0_PMS_CONSTRAIN_1.Reg) & 0xc) >> 2
}
func (o *SENSITIVE_Type) SetDMA_APBPERI_I2S0_PMS_CONSTRAIN_1_DMA_APBPERI_I2S0_PMS_CONSTRAIN_SRAM_WORLD_0_PMS_2(value uint32) {
	volatile.StoreUint32(&o.DMA_APBPERI_I2S0_PMS_CONSTRAIN_1.Reg, volatile.LoadUint32(&o.DMA_APBPERI_I2S0_PMS_CONSTRAIN_1.Reg)&^(0x30)|value<<4)
}
func (o *SENSITIVE_Type) GetDMA_APBPERI_I2S0_PMS_CONSTRAIN_1_DMA_APBPERI_I2S0_PMS_CONSTRAIN_SRAM_WORLD_0_PMS_2() uint32 {
	return (volatile.LoadUint32(&o.DMA_APBPERI_I2S0_PMS_CONSTRAIN_1.Reg) & 0x30) >> 4
}
func (o *SENSITIVE_Type) SetDMA_APBPERI_I2S0_PMS_CONSTRAIN_1_DMA_APBPERI_I2S0_PMS_CONSTRAIN_SRAM_WORLD_0_PMS_3(value uint32) {
	volatile.StoreUint32(&o.DMA_APBPERI_I2S0_PMS_CONSTRAIN_1.Reg, volatile.LoadUint32(&o.DMA_APBPERI_I2S0_PMS_CONSTRAIN_1.Reg)&^(0xc0)|value<<6)
}
func (o *SENSITIVE_Type) GetDMA_APBPERI_I2S0_PMS_CONSTRAIN_1_DMA_APBPERI_I2S0_PMS_CONSTRAIN_SRAM_WORLD_0_PMS_3() uint32 {
	return (volatile.LoadUint32(&o.DMA_APBPERI_I2S0_PMS_CONSTRAIN_1.Reg) & 0xc0) >> 6
}
func (o *SENSITIVE_Type) SetDMA_APBPERI_I2S0_PMS_CONSTRAIN_1_DMA_APBPERI_I2S0_PMS_CONSTRAIN_SRAM_WORLD_1_PMS_0(value uint32) {
	volatile.StoreUint32(&o.DMA_APBPERI_I2S0_PMS_CONSTRAIN_1.Reg, volatile.LoadUint32(&o.DMA_APBPERI_I2S0_PMS_CONSTRAIN_1.Reg)&^(0x3000)|value<<12)
}
func (o *SENSITIVE_Type) GetDMA_APBPERI_I2S0_PMS_CONSTRAIN_1_DMA_APBPERI_I2S0_PMS_CONSTRAIN_SRAM_WORLD_1_PMS_0() uint32 {
	return (volatile.LoadUint32(&o.DMA_APBPERI_I2S0_PMS_CONSTRAIN_1.Reg) & 0x3000) >> 12
}
func (o *SENSITIVE_Type) SetDMA_APBPERI_I2S0_PMS_CONSTRAIN_1_DMA_APBPERI_I2S0_PMS_CONSTRAIN_SRAM_WORLD_1_PMS_1(value uint32) {
	volatile.StoreUint32(&o.DMA_APBPERI_I2S0_PMS_CONSTRAIN_1.Reg, volatile.LoadUint32(&o.DMA_APBPERI_I2S0_PMS_CONSTRAIN_1.Reg)&^(0xc000)|value<<14)
}
func (o *SENSITIVE_Type) GetDMA_APBPERI_I2S0_PMS_CONSTRAIN_1_DMA_APBPERI_I2S0_PMS_CONSTRAIN_SRAM_WORLD_1_PMS_1() uint32 {
	return (volatile.LoadUint32(&o.DMA_APBPERI_I2S0_PMS_CONSTRAIN_1.Reg) & 0xc000) >> 14
}
func (o *SENSITIVE_Type) SetDMA_APBPERI_I2S0_PMS_CONSTRAIN_1_DMA_APBPERI_I2S0_PMS_CONSTRAIN_SRAM_WORLD_1_PMS_2(value uint32) {
	volatile.StoreUint32(&o.DMA_APBPERI_I2S0_PMS_CONSTRAIN_1.Reg, volatile.LoadUint32(&o.DMA_APBPERI_I2S0_PMS_CONSTRAIN_1.Reg)&^(0x30000)|value<<16)
}
func (o *SENSITIVE_Type) GetDMA_APBPERI_I2S0_PMS_CONSTRAIN_1_DMA_APBPERI_I2S0_PMS_CONSTRAIN_SRAM_WORLD_1_PMS_2() uint32 {
	return (volatile.LoadUint32(&o.DMA_APBPERI_I2S0_PMS_CONSTRAIN_1.Reg) & 0x30000) >> 16
}
func (o *SENSITIVE_Type) SetDMA_APBPERI_I2S0_PMS_CONSTRAIN_1_DMA_APBPERI_I2S0_PMS_CONSTRAIN_SRAM_WORLD_1_PMS_3(value uint32) {
	volatile.StoreUint32(&o.DMA_APBPERI_I2S0_PMS_CONSTRAIN_1.Reg, volatile.LoadUint32(&o.DMA_APBPERI_I2S0_PMS_CONSTRAIN_1.Reg)&^(0xc0000)|value<<18)
}
func (o *SENSITIVE_Type) GetDMA_APBPERI_I2S0_PMS_CONSTRAIN_1_DMA_APBPERI_I2S0_PMS_CONSTRAIN_SRAM_WORLD_1_PMS_3() uint32 {
	return (volatile.LoadUint32(&o.DMA_APBPERI_I2S0_PMS_CONSTRAIN_1.Reg) & 0xc0000) >> 18
}

// SENSITIVE.DMA_APBPERI_MAC_PMS_CONSTRAIN_0: SENSITIVE_DMA_APBPERI_MAC_PMS_CONSTRAIN_0_REG
func (o *SENSITIVE_Type) SetDMA_APBPERI_MAC_PMS_CONSTRAIN_0_DMA_APBPERI_MAC_PMS_CONSTRAIN_LOCK(value uint32) {
	volatile.StoreUint32(&o.DMA_APBPERI_MAC_PMS_CONSTRAIN_0.Reg, volatile.LoadUint32(&o.DMA_APBPERI_MAC_PMS_CONSTRAIN_0.Reg)&^(0x1)|value)
}
func (o *SENSITIVE_Type) GetDMA_APBPERI_MAC_PMS_CONSTRAIN_0_DMA_APBPERI_MAC_PMS_CONSTRAIN_LOCK() uint32 {
	return volatile.LoadUint32(&o.DMA_APBPERI_MAC_PMS_CONSTRAIN_0.Reg) & 0x1
}

// SENSITIVE.DMA_APBPERI_MAC_PMS_CONSTRAIN_1: SENSITIVE_DMA_APBPERI_MAC_PMS_CONSTRAIN_1_REG
func (o *SENSITIVE_Type) SetDMA_APBPERI_MAC_PMS_CONSTRAIN_1_DMA_APBPERI_MAC_PMS_CONSTRAIN_SRAM_WORLD_0_PMS_0(value uint32) {
	volatile.StoreUint32(&o.DMA_APBPERI_MAC_PMS_CONSTRAIN_1.Reg, volatile.LoadUint32(&o.DMA_APBPERI_MAC_PMS_CONSTRAIN_1.Reg)&^(0x3)|value)
}
func (o *SENSITIVE_Type) GetDMA_APBPERI_MAC_PMS_CONSTRAIN_1_DMA_APBPERI_MAC_PMS_CONSTRAIN_SRAM_WORLD_0_PMS_0() uint32 {
	return volatile.LoadUint32(&o.DMA_APBPERI_MAC_PMS_CONSTRAIN_1.Reg) & 0x3
}
func (o *SENSITIVE_Type) SetDMA_APBPERI_MAC_PMS_CONSTRAIN_1_DMA_APBPERI_MAC_PMS_CONSTRAIN_SRAM_WORLD_0_PMS_1(value uint32) {
	volatile.StoreUint32(&o.DMA_APBPERI_MAC_PMS_CONSTRAIN_1.Reg, volatile.LoadUint32(&o.DMA_APBPERI_MAC_PMS_CONSTRAIN_1.Reg)&^(0xc)|value<<2)
}
func (o *SENSITIVE_Type) GetDMA_APBPERI_MAC_PMS_CONSTRAIN_1_DMA_APBPERI_MAC_PMS_CONSTRAIN_SRAM_WORLD_0_PMS_1() uint32 {
	return (volatile.LoadUint32(&o.DMA_APBPERI_MAC_PMS_CONSTRAIN_1.Reg) & 0xc) >> 2
}
func (o *SENSITIVE_Type) SetDMA_APBPERI_MAC_PMS_CONSTRAIN_1_DMA_APBPERI_MAC_PMS_CONSTRAIN_SRAM_WORLD_0_PMS_2(value uint32) {
	volatile.StoreUint32(&o.DMA_APBPERI_MAC_PMS_CONSTRAIN_1.Reg, volatile.LoadUint32(&o.DMA_APBPERI_MAC_PMS_CONSTRAIN_1.Reg)&^(0x30)|value<<4)
}
func (o *SENSITIVE_Type) GetDMA_APBPERI_MAC_PMS_CONSTRAIN_1_DMA_APBPERI_MAC_PMS_CONSTRAIN_SRAM_WORLD_0_PMS_2() uint32 {
	return (volatile.LoadUint32(&o.DMA_APBPERI_MAC_PMS_CONSTRAIN_1.Reg) & 0x30) >> 4
}
func (o *SENSITIVE_Type) SetDMA_APBPERI_MAC_PMS_CONSTRAIN_1_DMA_APBPERI_MAC_PMS_CONSTRAIN_SRAM_WORLD_0_PMS_3(value uint32) {
	volatile.StoreUint32(&o.DMA_APBPERI_MAC_PMS_CONSTRAIN_1.Reg, volatile.LoadUint32(&o.DMA_APBPERI_MAC_PMS_CONSTRAIN_1.Reg)&^(0xc0)|value<<6)
}
func (o *SENSITIVE_Type) GetDMA_APBPERI_MAC_PMS_CONSTRAIN_1_DMA_APBPERI_MAC_PMS_CONSTRAIN_SRAM_WORLD_0_PMS_3() uint32 {
	return (volatile.LoadUint32(&o.DMA_APBPERI_MAC_PMS_CONSTRAIN_1.Reg) & 0xc0) >> 6
}
func (o *SENSITIVE_Type) SetDMA_APBPERI_MAC_PMS_CONSTRAIN_1_DMA_APBPERI_MAC_PMS_CONSTRAIN_SRAM_WORLD_1_PMS_0(value uint32) {
	volatile.StoreUint32(&o.DMA_APBPERI_MAC_PMS_CONSTRAIN_1.Reg, volatile.LoadUint32(&o.DMA_APBPERI_MAC_PMS_CONSTRAIN_1.Reg)&^(0x3000)|value<<12)
}
func (o *SENSITIVE_Type) GetDMA_APBPERI_MAC_PMS_CONSTRAIN_1_DMA_APBPERI_MAC_PMS_CONSTRAIN_SRAM_WORLD_1_PMS_0() uint32 {
	return (volatile.LoadUint32(&o.DMA_APBPERI_MAC_PMS_CONSTRAIN_1.Reg) & 0x3000) >> 12
}
func (o *SENSITIVE_Type) SetDMA_APBPERI_MAC_PMS_CONSTRAIN_1_DMA_APBPERI_MAC_PMS_CONSTRAIN_SRAM_WORLD_1_PMS_1(value uint32) {
	volatile.StoreUint32(&o.DMA_APBPERI_MAC_PMS_CONSTRAIN_1.Reg, volatile.LoadUint32(&o.DMA_APBPERI_MAC_PMS_CONSTRAIN_1.Reg)&^(0xc000)|value<<14)
}
func (o *SENSITIVE_Type) GetDMA_APBPERI_MAC_PMS_CONSTRAIN_1_DMA_APBPERI_MAC_PMS_CONSTRAIN_SRAM_WORLD_1_PMS_1() uint32 {
	return (volatile.LoadUint32(&o.DMA_APBPERI_MAC_PMS_CONSTRAIN_1.Reg) & 0xc000) >> 14
}
func (o *SENSITIVE_Type) SetDMA_APBPERI_MAC_PMS_CONSTRAIN_1_DMA_APBPERI_MAC_PMS_CONSTRAIN_SRAM_WORLD_1_PMS_2(value uint32) {
	volatile.StoreUint32(&o.DMA_APBPERI_MAC_PMS_CONSTRAIN_1.Reg, volatile.LoadUint32(&o.DMA_APBPERI_MAC_PMS_CONSTRAIN_1.Reg)&^(0x30000)|value<<16)
}
func (o *SENSITIVE_Type) GetDMA_APBPERI_MAC_PMS_CONSTRAIN_1_DMA_APBPERI_MAC_PMS_CONSTRAIN_SRAM_WORLD_1_PMS_2() uint32 {
	return (volatile.LoadUint32(&o.DMA_APBPERI_MAC_PMS_CONSTRAIN_1.Reg) & 0x30000) >> 16
}
func (o *SENSITIVE_Type) SetDMA_APBPERI_MAC_PMS_CONSTRAIN_1_DMA_APBPERI_MAC_PMS_CONSTRAIN_SRAM_WORLD_1_PMS_3(value uint32) {
	volatile.StoreUint32(&o.DMA_APBPERI_MAC_PMS_CONSTRAIN_1.Reg, volatile.LoadUint32(&o.DMA_APBPERI_MAC_PMS_CONSTRAIN_1.Reg)&^(0xc0000)|value<<18)
}
func (o *SENSITIVE_Type) GetDMA_APBPERI_MAC_PMS_CONSTRAIN_1_DMA_APBPERI_MAC_PMS_CONSTRAIN_SRAM_WORLD_1_PMS_3() uint32 {
	return (volatile.LoadUint32(&o.DMA_APBPERI_MAC_PMS_CONSTRAIN_1.Reg) & 0xc0000) >> 18
}

// SENSITIVE.DMA_APBPERI_BACKUP_PMS_CONSTRAIN_0: SENSITIVE_DMA_APBPERI_BACKUP_PMS_CONSTRAIN_0_REG
func (o *SENSITIVE_Type) SetDMA_APBPERI_BACKUP_PMS_CONSTRAIN_0_DMA_APBPERI_BACKUP_PMS_CONSTRAIN_LOCK(value uint32) {
	volatile.StoreUint32(&o.DMA_APBPERI_BACKUP_PMS_CONSTRAIN_0.Reg, volatile.LoadUint32(&o.DMA_APBPERI_BACKUP_PMS_CONSTRAIN_0.Reg)&^(0x1)|value)
}
func (o *SENSITIVE_Type) GetDMA_APBPERI_BACKUP_PMS_CONSTRAIN_0_DMA_APBPERI_BACKUP_PMS_CONSTRAIN_LOCK() uint32 {
	return volatile.LoadUint32(&o.DMA_APBPERI_BACKUP_PMS_CONSTRAIN_0.Reg) & 0x1
}

// SENSITIVE.DMA_APBPERI_BACKUP_PMS_CONSTRAIN_1: SENSITIVE_DMA_APBPERI_BACKUP_PMS_CONSTRAIN_1_REG
func (o *SENSITIVE_Type) SetDMA_APBPERI_BACKUP_PMS_CONSTRAIN_1_DMA_APBPERI_BACKUP_PMS_CONSTRAIN_SRAM_WORLD_0_PMS_0(value uint32) {
	volatile.StoreUint32(&o.DMA_APBPERI_BACKUP_PMS_CONSTRAIN_1.Reg, volatile.LoadUint32(&o.DMA_APBPERI_BACKUP_PMS_CONSTRAIN_1.Reg)&^(0x3)|value)
}
func (o *SENSITIVE_Type) GetDMA_APBPERI_BACKUP_PMS_CONSTRAIN_1_DMA_APBPERI_BACKUP_PMS_CONSTRAIN_SRAM_WORLD_0_PMS_0() uint32 {
	return volatile.LoadUint32(&o.DMA_APBPERI_BACKUP_PMS_CONSTRAIN_1.Reg) & 0x3
}
func (o *SENSITIVE_Type) SetDMA_APBPERI_BACKUP_PMS_CONSTRAIN_1_DMA_APBPERI_BACKUP_PMS_CONSTRAIN_SRAM_WORLD_0_PMS_1(value uint32) {
	volatile.StoreUint32(&o.DMA_APBPERI_BACKUP_PMS_CONSTRAIN_1.Reg, volatile.LoadUint32(&o.DMA_APBPERI_BACKUP_PMS_CONSTRAIN_1.Reg)&^(0xc)|value<<2)
}
func (o *SENSITIVE_Type) GetDMA_APBPERI_BACKUP_PMS_CONSTRAIN_1_DMA_APBPERI_BACKUP_PMS_CONSTRAIN_SRAM_WORLD_0_PMS_1() uint32 {
	return (volatile.LoadUint32(&o.DMA_APBPERI_BACKUP_PMS_CONSTRAIN_1.Reg) & 0xc) >> 2
}
func (o *SENSITIVE_Type) SetDMA_APBPERI_BACKUP_PMS_CONSTRAIN_1_DMA_APBPERI_BACKUP_PMS_CONSTRAIN_SRAM_WORLD_0_PMS_2(value uint32) {
	volatile.StoreUint32(&o.DMA_APBPERI_BACKUP_PMS_CONSTRAIN_1.Reg, volatile.LoadUint32(&o.DMA_APBPERI_BACKUP_PMS_CONSTRAIN_1.Reg)&^(0x30)|value<<4)
}
func (o *SENSITIVE_Type) GetDMA_APBPERI_BACKUP_PMS_CONSTRAIN_1_DMA_APBPERI_BACKUP_PMS_CONSTRAIN_SRAM_WORLD_0_PMS_2() uint32 {
	return (volatile.LoadUint32(&o.DMA_APBPERI_BACKUP_PMS_CONSTRAIN_1.Reg) & 0x30) >> 4
}
func (o *SENSITIVE_Type) SetDMA_APBPERI_BACKUP_PMS_CONSTRAIN_1_DMA_APBPERI_BACKUP_PMS_CONSTRAIN_SRAM_WORLD_0_PMS_3(value uint32) {
	volatile.StoreUint32(&o.DMA_APBPERI_BACKUP_PMS_CONSTRAIN_1.Reg, volatile.LoadUint32(&o.DMA_APBPERI_BACKUP_PMS_CONSTRAIN_1.Reg)&^(0xc0)|value<<6)
}
func (o *SENSITIVE_Type) GetDMA_APBPERI_BACKUP_PMS_CONSTRAIN_1_DMA_APBPERI_BACKUP_PMS_CONSTRAIN_SRAM_WORLD_0_PMS_3() uint32 {
	return (volatile.LoadUint32(&o.DMA_APBPERI_BACKUP_PMS_CONSTRAIN_1.Reg) & 0xc0) >> 6
}
func (o *SENSITIVE_Type) SetDMA_APBPERI_BACKUP_PMS_CONSTRAIN_1_DMA_APBPERI_BACKUP_PMS_CONSTRAIN_SRAM_WORLD_1_PMS_0(value uint32) {
	volatile.StoreUint32(&o.DMA_APBPERI_BACKUP_PMS_CONSTRAIN_1.Reg, volatile.LoadUint32(&o.DMA_APBPERI_BACKUP_PMS_CONSTRAIN_1.Reg)&^(0x3000)|value<<12)
}
func (o *SENSITIVE_Type) GetDMA_APBPERI_BACKUP_PMS_CONSTRAIN_1_DMA_APBPERI_BACKUP_PMS_CONSTRAIN_SRAM_WORLD_1_PMS_0() uint32 {
	return (volatile.LoadUint32(&o.DMA_APBPERI_BACKUP_PMS_CONSTRAIN_1.Reg) & 0x3000) >> 12
}
func (o *SENSITIVE_Type) SetDMA_APBPERI_BACKUP_PMS_CONSTRAIN_1_DMA_APBPERI_BACKUP_PMS_CONSTRAIN_SRAM_WORLD_1_PMS_1(value uint32) {
	volatile.StoreUint32(&o.DMA_APBPERI_BACKUP_PMS_CONSTRAIN_1.Reg, volatile.LoadUint32(&o.DMA_APBPERI_BACKUP_PMS_CONSTRAIN_1.Reg)&^(0xc000)|value<<14)
}
func (o *SENSITIVE_Type) GetDMA_APBPERI_BACKUP_PMS_CONSTRAIN_1_DMA_APBPERI_BACKUP_PMS_CONSTRAIN_SRAM_WORLD_1_PMS_1() uint32 {
	return (volatile.LoadUint32(&o.DMA_APBPERI_BACKUP_PMS_CONSTRAIN_1.Reg) & 0xc000) >> 14
}
func (o *SENSITIVE_Type) SetDMA_APBPERI_BACKUP_PMS_CONSTRAIN_1_DMA_APBPERI_BACKUP_PMS_CONSTRAIN_SRAM_WORLD_1_PMS_2(value uint32) {
	volatile.StoreUint32(&o.DMA_APBPERI_BACKUP_PMS_CONSTRAIN_1.Reg, volatile.LoadUint32(&o.DMA_APBPERI_BACKUP_PMS_CONSTRAIN_1.Reg)&^(0x30000)|value<<16)
}
func (o *SENSITIVE_Type) GetDMA_APBPERI_BACKUP_PMS_CONSTRAIN_1_DMA_APBPERI_BACKUP_PMS_CONSTRAIN_SRAM_WORLD_1_PMS_2() uint32 {
	return (volatile.LoadUint32(&o.DMA_APBPERI_BACKUP_PMS_CONSTRAIN_1.Reg) & 0x30000) >> 16
}
func (o *SENSITIVE_Type) SetDMA_APBPERI_BACKUP_PMS_CONSTRAIN_1_DMA_APBPERI_BACKUP_PMS_CONSTRAIN_SRAM_WORLD_1_PMS_3(value uint32) {
	volatile.StoreUint32(&o.DMA_APBPERI_BACKUP_PMS_CONSTRAIN_1.Reg, volatile.LoadUint32(&o.DMA_APBPERI_BACKUP_PMS_CONSTRAIN_1.Reg)&^(0xc0000)|value<<18)
}
func (o *SENSITIVE_Type) GetDMA_APBPERI_BACKUP_PMS_CONSTRAIN_1_DMA_APBPERI_BACKUP_PMS_CONSTRAIN_SRAM_WORLD_1_PMS_3() uint32 {
	return (volatile.LoadUint32(&o.DMA_APBPERI_BACKUP_PMS_CONSTRAIN_1.Reg) & 0xc0000) >> 18
}

// SENSITIVE.DMA_APBPERI_LC_PMS_CONSTRAIN_0: SENSITIVE_DMA_APBPERI_LC_PMS_CONSTRAIN_0_REG
func (o *SENSITIVE_Type) SetDMA_APBPERI_LC_PMS_CONSTRAIN_0_DMA_APBPERI_LC_PMS_CONSTRAIN_LOCK(value uint32) {
	volatile.StoreUint32(&o.DMA_APBPERI_LC_PMS_CONSTRAIN_0.Reg, volatile.LoadUint32(&o.DMA_APBPERI_LC_PMS_CONSTRAIN_0.Reg)&^(0x1)|value)
}
func (o *SENSITIVE_Type) GetDMA_APBPERI_LC_PMS_CONSTRAIN_0_DMA_APBPERI_LC_PMS_CONSTRAIN_LOCK() uint32 {
	return volatile.LoadUint32(&o.DMA_APBPERI_LC_PMS_CONSTRAIN_0.Reg) & 0x1
}

// SENSITIVE.DMA_APBPERI_LC_PMS_CONSTRAIN_1: SENSITIVE_DMA_APBPERI_LC_PMS_CONSTRAIN_1_REG
func (o *SENSITIVE_Type) SetDMA_APBPERI_LC_PMS_CONSTRAIN_1_DMA_APBPERI_LC_PMS_CONSTRAIN_SRAM_WORLD_0_PMS_0(value uint32) {
	volatile.StoreUint32(&o.DMA_APBPERI_LC_PMS_CONSTRAIN_1.Reg, volatile.LoadUint32(&o.DMA_APBPERI_LC_PMS_CONSTRAIN_1.Reg)&^(0x3)|value)
}
func (o *SENSITIVE_Type) GetDMA_APBPERI_LC_PMS_CONSTRAIN_1_DMA_APBPERI_LC_PMS_CONSTRAIN_SRAM_WORLD_0_PMS_0() uint32 {
	return volatile.LoadUint32(&o.DMA_APBPERI_LC_PMS_CONSTRAIN_1.Reg) & 0x3
}
func (o *SENSITIVE_Type) SetDMA_APBPERI_LC_PMS_CONSTRAIN_1_DMA_APBPERI_LC_PMS_CONSTRAIN_SRAM_WORLD_0_PMS_1(value uint32) {
	volatile.StoreUint32(&o.DMA_APBPERI_LC_PMS_CONSTRAIN_1.Reg, volatile.LoadUint32(&o.DMA_APBPERI_LC_PMS_CONSTRAIN_1.Reg)&^(0xc)|value<<2)
}
func (o *SENSITIVE_Type) GetDMA_APBPERI_LC_PMS_CONSTRAIN_1_DMA_APBPERI_LC_PMS_CONSTRAIN_SRAM_WORLD_0_PMS_1() uint32 {
	return (volatile.LoadUint32(&o.DMA_APBPERI_LC_PMS_CONSTRAIN_1.Reg) & 0xc) >> 2
}
func (o *SENSITIVE_Type) SetDMA_APBPERI_LC_PMS_CONSTRAIN_1_DMA_APBPERI_LC_PMS_CONSTRAIN_SRAM_WORLD_0_PMS_2(value uint32) {
	volatile.StoreUint32(&o.DMA_APBPERI_LC_PMS_CONSTRAIN_1.Reg, volatile.LoadUint32(&o.DMA_APBPERI_LC_PMS_CONSTRAIN_1.Reg)&^(0x30)|value<<4)
}
func (o *SENSITIVE_Type) GetDMA_APBPERI_LC_PMS_CONSTRAIN_1_DMA_APBPERI_LC_PMS_CONSTRAIN_SRAM_WORLD_0_PMS_2() uint32 {
	return (volatile.LoadUint32(&o.DMA_APBPERI_LC_PMS_CONSTRAIN_1.Reg) & 0x30) >> 4
}
func (o *SENSITIVE_Type) SetDMA_APBPERI_LC_PMS_CONSTRAIN_1_DMA_APBPERI_LC_PMS_CONSTRAIN_SRAM_WORLD_0_PMS_3(value uint32) {
	volatile.StoreUint32(&o.DMA_APBPERI_LC_PMS_CONSTRAIN_1.Reg, volatile.LoadUint32(&o.DMA_APBPERI_LC_PMS_CONSTRAIN_1.Reg)&^(0xc0)|value<<6)
}
func (o *SENSITIVE_Type) GetDMA_APBPERI_LC_PMS_CONSTRAIN_1_DMA_APBPERI_LC_PMS_CONSTRAIN_SRAM_WORLD_0_PMS_3() uint32 {
	return (volatile.LoadUint32(&o.DMA_APBPERI_LC_PMS_CONSTRAIN_1.Reg) & 0xc0) >> 6
}
func (o *SENSITIVE_Type) SetDMA_APBPERI_LC_PMS_CONSTRAIN_1_DMA_APBPERI_LC_PMS_CONSTRAIN_SRAM_WORLD_1_PMS_0(value uint32) {
	volatile.StoreUint32(&o.DMA_APBPERI_LC_PMS_CONSTRAIN_1.Reg, volatile.LoadUint32(&o.DMA_APBPERI_LC_PMS_CONSTRAIN_1.Reg)&^(0x3000)|value<<12)
}
func (o *SENSITIVE_Type) GetDMA_APBPERI_LC_PMS_CONSTRAIN_1_DMA_APBPERI_LC_PMS_CONSTRAIN_SRAM_WORLD_1_PMS_0() uint32 {
	return (volatile.LoadUint32(&o.DMA_APBPERI_LC_PMS_CONSTRAIN_1.Reg) & 0x3000) >> 12
}
func (o *SENSITIVE_Type) SetDMA_APBPERI_LC_PMS_CONSTRAIN_1_DMA_APBPERI_LC_PMS_CONSTRAIN_SRAM_WORLD_1_PMS_1(value uint32) {
	volatile.StoreUint32(&o.DMA_APBPERI_LC_PMS_CONSTRAIN_1.Reg, volatile.LoadUint32(&o.DMA_APBPERI_LC_PMS_CONSTRAIN_1.Reg)&^(0xc000)|value<<14)
}
func (o *SENSITIVE_Type) GetDMA_APBPERI_LC_PMS_CONSTRAIN_1_DMA_APBPERI_LC_PMS_CONSTRAIN_SRAM_WORLD_1_PMS_1() uint32 {
	return (volatile.LoadUint32(&o.DMA_APBPERI_LC_PMS_CONSTRAIN_1.Reg) & 0xc000) >> 14
}
func (o *SENSITIVE_Type) SetDMA_APBPERI_LC_PMS_CONSTRAIN_1_DMA_APBPERI_LC_PMS_CONSTRAIN_SRAM_WORLD_1_PMS_2(value uint32) {
	volatile.StoreUint32(&o.DMA_APBPERI_LC_PMS_CONSTRAIN_1.Reg, volatile.LoadUint32(&o.DMA_APBPERI_LC_PMS_CONSTRAIN_1.Reg)&^(0x30000)|value<<16)
}
func (o *SENSITIVE_Type) GetDMA_APBPERI_LC_PMS_CONSTRAIN_1_DMA_APBPERI_LC_PMS_CONSTRAIN_SRAM_WORLD_1_PMS_2() uint32 {
	return (volatile.LoadUint32(&o.DMA_APBPERI_LC_PMS_CONSTRAIN_1.Reg) & 0x30000) >> 16
}
func (o *SENSITIVE_Type) SetDMA_APBPERI_LC_PMS_CONSTRAIN_1_DMA_APBPERI_LC_PMS_CONSTRAIN_SRAM_WORLD_1_PMS_3(value uint32) {
	volatile.StoreUint32(&o.DMA_APBPERI_LC_PMS_CONSTRAIN_1.Reg, volatile.LoadUint32(&o.DMA_APBPERI_LC_PMS_CONSTRAIN_1.Reg)&^(0xc0000)|value<<18)
}
func (o *SENSITIVE_Type) GetDMA_APBPERI_LC_PMS_CONSTRAIN_1_DMA_APBPERI_LC_PMS_CONSTRAIN_SRAM_WORLD_1_PMS_3() uint32 {
	return (volatile.LoadUint32(&o.DMA_APBPERI_LC_PMS_CONSTRAIN_1.Reg) & 0xc0000) >> 18
}

// SENSITIVE.DMA_APBPERI_AES_PMS_CONSTRAIN_0: SENSITIVE_DMA_APBPERI_AES_PMS_CONSTRAIN_0_REG
func (o *SENSITIVE_Type) SetDMA_APBPERI_AES_PMS_CONSTRAIN_0_DMA_APBPERI_AES_PMS_CONSTRAIN_LOCK(value uint32) {
	volatile.StoreUint32(&o.DMA_APBPERI_AES_PMS_CONSTRAIN_0.Reg, volatile.LoadUint32(&o.DMA_APBPERI_AES_PMS_CONSTRAIN_0.Reg)&^(0x1)|value)
}
func (o *SENSITIVE_Type) GetDMA_APBPERI_AES_PMS_CONSTRAIN_0_DMA_APBPERI_AES_PMS_CONSTRAIN_LOCK() uint32 {
	return volatile.LoadUint32(&o.DMA_APBPERI_AES_PMS_CONSTRAIN_0.Reg) & 0x1
}

// SENSITIVE.DMA_APBPERI_AES_PMS_CONSTRAIN_1: SENSITIVE_DMA_APBPERI_AES_PMS_CONSTRAIN_1_REG
func (o *SENSITIVE_Type) SetDMA_APBPERI_AES_PMS_CONSTRAIN_1_DMA_APBPERI_AES_PMS_CONSTRAIN_SRAM_WORLD_0_PMS_0(value uint32) {
	volatile.StoreUint32(&o.DMA_APBPERI_AES_PMS_CONSTRAIN_1.Reg, volatile.LoadUint32(&o.DMA_APBPERI_AES_PMS_CONSTRAIN_1.Reg)&^(0x3)|value)
}
func (o *SENSITIVE_Type) GetDMA_APBPERI_AES_PMS_CONSTRAIN_1_DMA_APBPERI_AES_PMS_CONSTRAIN_SRAM_WORLD_0_PMS_0() uint32 {
	return volatile.LoadUint32(&o.DMA_APBPERI_AES_PMS_CONSTRAIN_1.Reg) & 0x3
}
func (o *SENSITIVE_Type) SetDMA_APBPERI_AES_PMS_CONSTRAIN_1_DMA_APBPERI_AES_PMS_CONSTRAIN_SRAM_WORLD_0_PMS_1(value uint32) {
	volatile.StoreUint32(&o.DMA_APBPERI_AES_PMS_CONSTRAIN_1.Reg, volatile.LoadUint32(&o.DMA_APBPERI_AES_PMS_CONSTRAIN_1.Reg)&^(0xc)|value<<2)
}
func (o *SENSITIVE_Type) GetDMA_APBPERI_AES_PMS_CONSTRAIN_1_DMA_APBPERI_AES_PMS_CONSTRAIN_SRAM_WORLD_0_PMS_1() uint32 {
	return (volatile.LoadUint32(&o.DMA_APBPERI_AES_PMS_CONSTRAIN_1.Reg) & 0xc) >> 2
}
func (o *SENSITIVE_Type) SetDMA_APBPERI_AES_PMS_CONSTRAIN_1_DMA_APBPERI_AES_PMS_CONSTRAIN_SRAM_WORLD_0_PMS_2(value uint32) {
	volatile.StoreUint32(&o.DMA_APBPERI_AES_PMS_CONSTRAIN_1.Reg, volatile.LoadUint32(&o.DMA_APBPERI_AES_PMS_CONSTRAIN_1.Reg)&^(0x30)|value<<4)
}
func (o *SENSITIVE_Type) GetDMA_APBPERI_AES_PMS_CONSTRAIN_1_DMA_APBPERI_AES_PMS_CONSTRAIN_SRAM_WORLD_0_PMS_2() uint32 {
	return (volatile.LoadUint32(&o.DMA_APBPERI_AES_PMS_CONSTRAIN_1.Reg) & 0x30) >> 4
}
func (o *SENSITIVE_Type) SetDMA_APBPERI_AES_PMS_CONSTRAIN_1_DMA_APBPERI_AES_PMS_CONSTRAIN_SRAM_WORLD_0_PMS_3(value uint32) {
	volatile.StoreUint32(&o.DMA_APBPERI_AES_PMS_CONSTRAIN_1.Reg, volatile.LoadUint32(&o.DMA_APBPERI_AES_PMS_CONSTRAIN_1.Reg)&^(0xc0)|value<<6)
}
func (o *SENSITIVE_Type) GetDMA_APBPERI_AES_PMS_CONSTRAIN_1_DMA_APBPERI_AES_PMS_CONSTRAIN_SRAM_WORLD_0_PMS_3() uint32 {
	return (volatile.LoadUint32(&o.DMA_APBPERI_AES_PMS_CONSTRAIN_1.Reg) & 0xc0) >> 6
}
func (o *SENSITIVE_Type) SetDMA_APBPERI_AES_PMS_CONSTRAIN_1_DMA_APBPERI_AES_PMS_CONSTRAIN_SRAM_WORLD_1_PMS_0(value uint32) {
	volatile.StoreUint32(&o.DMA_APBPERI_AES_PMS_CONSTRAIN_1.Reg, volatile.LoadUint32(&o.DMA_APBPERI_AES_PMS_CONSTRAIN_1.Reg)&^(0x3000)|value<<12)
}
func (o *SENSITIVE_Type) GetDMA_APBPERI_AES_PMS_CONSTRAIN_1_DMA_APBPERI_AES_PMS_CONSTRAIN_SRAM_WORLD_1_PMS_0() uint32 {
	return (volatile.LoadUint32(&o.DMA_APBPERI_AES_PMS_CONSTRAIN_1.Reg) & 0x3000) >> 12
}
func (o *SENSITIVE_Type) SetDMA_APBPERI_AES_PMS_CONSTRAIN_1_DMA_APBPERI_AES_PMS_CONSTRAIN_SRAM_WORLD_1_PMS_1(value uint32) {
	volatile.StoreUint32(&o.DMA_APBPERI_AES_PMS_CONSTRAIN_1.Reg, volatile.LoadUint32(&o.DMA_APBPERI_AES_PMS_CONSTRAIN_1.Reg)&^(0xc000)|value<<14)
}
func (o *SENSITIVE_Type) GetDMA_APBPERI_AES_PMS_CONSTRAIN_1_DMA_APBPERI_AES_PMS_CONSTRAIN_SRAM_WORLD_1_PMS_1() uint32 {
	return (volatile.LoadUint32(&o.DMA_APBPERI_AES_PMS_CONSTRAIN_1.Reg) & 0xc000) >> 14
}
func (o *SENSITIVE_Type) SetDMA_APBPERI_AES_PMS_CONSTRAIN_1_DMA_APBPERI_AES_PMS_CONSTRAIN_SRAM_WORLD_1_PMS_2(value uint32) {
	volatile.StoreUint32(&o.DMA_APBPERI_AES_PMS_CONSTRAIN_1.Reg, volatile.LoadUint32(&o.DMA_APBPERI_AES_PMS_CONSTRAIN_1.Reg)&^(0x30000)|value<<16)
}
func (o *SENSITIVE_Type) GetDMA_APBPERI_AES_PMS_CONSTRAIN_1_DMA_APBPERI_AES_PMS_CONSTRAIN_SRAM_WORLD_1_PMS_2() uint32 {
	return (volatile.LoadUint32(&o.DMA_APBPERI_AES_PMS_CONSTRAIN_1.Reg) & 0x30000) >> 16
}
func (o *SENSITIVE_Type) SetDMA_APBPERI_AES_PMS_CONSTRAIN_1_DMA_APBPERI_AES_PMS_CONSTRAIN_SRAM_WORLD_1_PMS_3(value uint32) {
	volatile.StoreUint32(&o.DMA_APBPERI_AES_PMS_CONSTRAIN_1.Reg, volatile.LoadUint32(&o.DMA_APBPERI_AES_PMS_CONSTRAIN_1.Reg)&^(0xc0000)|value<<18)
}
func (o *SENSITIVE_Type) GetDMA_APBPERI_AES_PMS_CONSTRAIN_1_DMA_APBPERI_AES_PMS_CONSTRAIN_SRAM_WORLD_1_PMS_3() uint32 {
	return (volatile.LoadUint32(&o.DMA_APBPERI_AES_PMS_CONSTRAIN_1.Reg) & 0xc0000) >> 18
}

// SENSITIVE.DMA_APBPERI_SHA_PMS_CONSTRAIN_0: SENSITIVE_DMA_APBPERI_SHA_PMS_CONSTRAIN_0_REG
func (o *SENSITIVE_Type) SetDMA_APBPERI_SHA_PMS_CONSTRAIN_0_DMA_APBPERI_SHA_PMS_CONSTRAIN_LOCK(value uint32) {
	volatile.StoreUint32(&o.DMA_APBPERI_SHA_PMS_CONSTRAIN_0.Reg, volatile.LoadUint32(&o.DMA_APBPERI_SHA_PMS_CONSTRAIN_0.Reg)&^(0x1)|value)
}
func (o *SENSITIVE_Type) GetDMA_APBPERI_SHA_PMS_CONSTRAIN_0_DMA_APBPERI_SHA_PMS_CONSTRAIN_LOCK() uint32 {
	return volatile.LoadUint32(&o.DMA_APBPERI_SHA_PMS_CONSTRAIN_0.Reg) & 0x1
}

// SENSITIVE.DMA_APBPERI_SHA_PMS_CONSTRAIN_1: SENSITIVE_DMA_APBPERI_SHA_PMS_CONSTRAIN_1_REG
func (o *SENSITIVE_Type) SetDMA_APBPERI_SHA_PMS_CONSTRAIN_1_DMA_APBPERI_SHA_PMS_CONSTRAIN_SRAM_WORLD_0_PMS_0(value uint32) {
	volatile.StoreUint32(&o.DMA_APBPERI_SHA_PMS_CONSTRAIN_1.Reg, volatile.LoadUint32(&o.DMA_APBPERI_SHA_PMS_CONSTRAIN_1.Reg)&^(0x3)|value)
}
func (o *SENSITIVE_Type) GetDMA_APBPERI_SHA_PMS_CONSTRAIN_1_DMA_APBPERI_SHA_PMS_CONSTRAIN_SRAM_WORLD_0_PMS_0() uint32 {
	return volatile.LoadUint32(&o.DMA_APBPERI_SHA_PMS_CONSTRAIN_1.Reg) & 0x3
}
func (o *SENSITIVE_Type) SetDMA_APBPERI_SHA_PMS_CONSTRAIN_1_DMA_APBPERI_SHA_PMS_CONSTRAIN_SRAM_WORLD_0_PMS_1(value uint32) {
	volatile.StoreUint32(&o.DMA_APBPERI_SHA_PMS_CONSTRAIN_1.Reg, volatile.LoadUint32(&o.DMA_APBPERI_SHA_PMS_CONSTRAIN_1.Reg)&^(0xc)|value<<2)
}
func (o *SENSITIVE_Type) GetDMA_APBPERI_SHA_PMS_CONSTRAIN_1_DMA_APBPERI_SHA_PMS_CONSTRAIN_SRAM_WORLD_0_PMS_1() uint32 {
	return (volatile.LoadUint32(&o.DMA_APBPERI_SHA_PMS_CONSTRAIN_1.Reg) & 0xc) >> 2
}
func (o *SENSITIVE_Type) SetDMA_APBPERI_SHA_PMS_CONSTRAIN_1_DMA_APBPERI_SHA_PMS_CONSTRAIN_SRAM_WORLD_0_PMS_2(value uint32) {
	volatile.StoreUint32(&o.DMA_APBPERI_SHA_PMS_CONSTRAIN_1.Reg, volatile.LoadUint32(&o.DMA_APBPERI_SHA_PMS_CONSTRAIN_1.Reg)&^(0x30)|value<<4)
}
func (o *SENSITIVE_Type) GetDMA_APBPERI_SHA_PMS_CONSTRAIN_1_DMA_APBPERI_SHA_PMS_CONSTRAIN_SRAM_WORLD_0_PMS_2() uint32 {
	return (volatile.LoadUint32(&o.DMA_APBPERI_SHA_PMS_CONSTRAIN_1.Reg) & 0x30) >> 4
}
func (o *SENSITIVE_Type) SetDMA_APBPERI_SHA_PMS_CONSTRAIN_1_DMA_APBPERI_SHA_PMS_CONSTRAIN_SRAM_WORLD_0_PMS_3(value uint32) {
	volatile.StoreUint32(&o.DMA_APBPERI_SHA_PMS_CONSTRAIN_1.Reg, volatile.LoadUint32(&o.DMA_APBPERI_SHA_PMS_CONSTRAIN_1.Reg)&^(0xc0)|value<<6)
}
func (o *SENSITIVE_Type) GetDMA_APBPERI_SHA_PMS_CONSTRAIN_1_DMA_APBPERI_SHA_PMS_CONSTRAIN_SRAM_WORLD_0_PMS_3() uint32 {
	return (volatile.LoadUint32(&o.DMA_APBPERI_SHA_PMS_CONSTRAIN_1.Reg) & 0xc0) >> 6
}
func (o *SENSITIVE_Type) SetDMA_APBPERI_SHA_PMS_CONSTRAIN_1_DMA_APBPERI_SHA_PMS_CONSTRAIN_SRAM_WORLD_1_PMS_0(value uint32) {
	volatile.StoreUint32(&o.DMA_APBPERI_SHA_PMS_CONSTRAIN_1.Reg, volatile.LoadUint32(&o.DMA_APBPERI_SHA_PMS_CONSTRAIN_1.Reg)&^(0x3000)|value<<12)
}
func (o *SENSITIVE_Type) GetDMA_APBPERI_SHA_PMS_CONSTRAIN_1_DMA_APBPERI_SHA_PMS_CONSTRAIN_SRAM_WORLD_1_PMS_0() uint32 {
	return (volatile.LoadUint32(&o.DMA_APBPERI_SHA_PMS_CONSTRAIN_1.Reg) & 0x3000) >> 12
}
func (o *SENSITIVE_Type) SetDMA_APBPERI_SHA_PMS_CONSTRAIN_1_DMA_APBPERI_SHA_PMS_CONSTRAIN_SRAM_WORLD_1_PMS_1(value uint32) {
	volatile.StoreUint32(&o.DMA_APBPERI_SHA_PMS_CONSTRAIN_1.Reg, volatile.LoadUint32(&o.DMA_APBPERI_SHA_PMS_CONSTRAIN_1.Reg)&^(0xc000)|value<<14)
}
func (o *SENSITIVE_Type) GetDMA_APBPERI_SHA_PMS_CONSTRAIN_1_DMA_APBPERI_SHA_PMS_CONSTRAIN_SRAM_WORLD_1_PMS_1() uint32 {
	return (volatile.LoadUint32(&o.DMA_APBPERI_SHA_PMS_CONSTRAIN_1.Reg) & 0xc000) >> 14
}
func (o *SENSITIVE_Type) SetDMA_APBPERI_SHA_PMS_CONSTRAIN_1_DMA_APBPERI_SHA_PMS_CONSTRAIN_SRAM_WORLD_1_PMS_2(value uint32) {
	volatile.StoreUint32(&o.DMA_APBPERI_SHA_PMS_CONSTRAIN_1.Reg, volatile.LoadUint32(&o.DMA_APBPERI_SHA_PMS_CONSTRAIN_1.Reg)&^(0x30000)|value<<16)
}
func (o *SENSITIVE_Type) GetDMA_APBPERI_SHA_PMS_CONSTRAIN_1_DMA_APBPERI_SHA_PMS_CONSTRAIN_SRAM_WORLD_1_PMS_2() uint32 {
	return (volatile.LoadUint32(&o.DMA_APBPERI_SHA_PMS_CONSTRAIN_1.Reg) & 0x30000) >> 16
}
func (o *SENSITIVE_Type) SetDMA_APBPERI_SHA_PMS_CONSTRAIN_1_DMA_APBPERI_SHA_PMS_CONSTRAIN_SRAM_WORLD_1_PMS_3(value uint32) {
	volatile.StoreUint32(&o.DMA_APBPERI_SHA_PMS_CONSTRAIN_1.Reg, volatile.LoadUint32(&o.DMA_APBPERI_SHA_PMS_CONSTRAIN_1.Reg)&^(0xc0000)|value<<18)
}
func (o *SENSITIVE_Type) GetDMA_APBPERI_SHA_PMS_CONSTRAIN_1_DMA_APBPERI_SHA_PMS_CONSTRAIN_SRAM_WORLD_1_PMS_3() uint32 {
	return (volatile.LoadUint32(&o.DMA_APBPERI_SHA_PMS_CONSTRAIN_1.Reg) & 0xc0000) >> 18
}

// SENSITIVE.DMA_APBPERI_ADC_DAC_PMS_CONSTRAIN_0: SENSITIVE_DMA_APBPERI_ADC_DAC_PMS_CONSTRAIN_0_REG
func (o *SENSITIVE_Type) SetDMA_APBPERI_ADC_DAC_PMS_CONSTRAIN_0_DMA_APBPERI_ADC_DAC_PMS_CONSTRAIN_LOCK(value uint32) {
	volatile.StoreUint32(&o.DMA_APBPERI_ADC_DAC_PMS_CONSTRAIN_0.Reg, volatile.LoadUint32(&o.DMA_APBPERI_ADC_DAC_PMS_CONSTRAIN_0.Reg)&^(0x1)|value)
}
func (o *SENSITIVE_Type) GetDMA_APBPERI_ADC_DAC_PMS_CONSTRAIN_0_DMA_APBPERI_ADC_DAC_PMS_CONSTRAIN_LOCK() uint32 {
	return volatile.LoadUint32(&o.DMA_APBPERI_ADC_DAC_PMS_CONSTRAIN_0.Reg) & 0x1
}

// SENSITIVE.DMA_APBPERI_ADC_DAC_PMS_CONSTRAIN_1: SENSITIVE_DMA_APBPERI_ADC_DAC_PMS_CONSTRAIN_1_REG
func (o *SENSITIVE_Type) SetDMA_APBPERI_ADC_DAC_PMS_CONSTRAIN_1_DMA_APBPERI_ADC_DAC_PMS_CONSTRAIN_SRAM_WORLD_0_PMS_0(value uint32) {
	volatile.StoreUint32(&o.DMA_APBPERI_ADC_DAC_PMS_CONSTRAIN_1.Reg, volatile.LoadUint32(&o.DMA_APBPERI_ADC_DAC_PMS_CONSTRAIN_1.Reg)&^(0x3)|value)
}
func (o *SENSITIVE_Type) GetDMA_APBPERI_ADC_DAC_PMS_CONSTRAIN_1_DMA_APBPERI_ADC_DAC_PMS_CONSTRAIN_SRAM_WORLD_0_PMS_0() uint32 {
	return volatile.LoadUint32(&o.DMA_APBPERI_ADC_DAC_PMS_CONSTRAIN_1.Reg) & 0x3
}
func (o *SENSITIVE_Type) SetDMA_APBPERI_ADC_DAC_PMS_CONSTRAIN_1_DMA_APBPERI_ADC_DAC_PMS_CONSTRAIN_SRAM_WORLD_0_PMS_1(value uint32) {
	volatile.StoreUint32(&o.DMA_APBPERI_ADC_DAC_PMS_CONSTRAIN_1.Reg, volatile.LoadUint32(&o.DMA_APBPERI_ADC_DAC_PMS_CONSTRAIN_1.Reg)&^(0xc)|value<<2)
}
func (o *SENSITIVE_Type) GetDMA_APBPERI_ADC_DAC_PMS_CONSTRAIN_1_DMA_APBPERI_ADC_DAC_PMS_CONSTRAIN_SRAM_WORLD_0_PMS_1() uint32 {
	return (volatile.LoadUint32(&o.DMA_APBPERI_ADC_DAC_PMS_CONSTRAIN_1.Reg) & 0xc) >> 2
}
func (o *SENSITIVE_Type) SetDMA_APBPERI_ADC_DAC_PMS_CONSTRAIN_1_DMA_APBPERI_ADC_DAC_PMS_CONSTRAIN_SRAM_WORLD_0_PMS_2(value uint32) {
	volatile.StoreUint32(&o.DMA_APBPERI_ADC_DAC_PMS_CONSTRAIN_1.Reg, volatile.LoadUint32(&o.DMA_APBPERI_ADC_DAC_PMS_CONSTRAIN_1.Reg)&^(0x30)|value<<4)
}
func (o *SENSITIVE_Type) GetDMA_APBPERI_ADC_DAC_PMS_CONSTRAIN_1_DMA_APBPERI_ADC_DAC_PMS_CONSTRAIN_SRAM_WORLD_0_PMS_2() uint32 {
	return (volatile.LoadUint32(&o.DMA_APBPERI_ADC_DAC_PMS_CONSTRAIN_1.Reg) & 0x30) >> 4
}
func (o *SENSITIVE_Type) SetDMA_APBPERI_ADC_DAC_PMS_CONSTRAIN_1_DMA_APBPERI_ADC_DAC_PMS_CONSTRAIN_SRAM_WORLD_0_PMS_3(value uint32) {
	volatile.StoreUint32(&o.DMA_APBPERI_ADC_DAC_PMS_CONSTRAIN_1.Reg, volatile.LoadUint32(&o.DMA_APBPERI_ADC_DAC_PMS_CONSTRAIN_1.Reg)&^(0xc0)|value<<6)
}
func (o *SENSITIVE_Type) GetDMA_APBPERI_ADC_DAC_PMS_CONSTRAIN_1_DMA_APBPERI_ADC_DAC_PMS_CONSTRAIN_SRAM_WORLD_0_PMS_3() uint32 {
	return (volatile.LoadUint32(&o.DMA_APBPERI_ADC_DAC_PMS_CONSTRAIN_1.Reg) & 0xc0) >> 6
}
func (o *SENSITIVE_Type) SetDMA_APBPERI_ADC_DAC_PMS_CONSTRAIN_1_DMA_APBPERI_ADC_DAC_PMS_CONSTRAIN_SRAM_WORLD_1_PMS_0(value uint32) {
	volatile.StoreUint32(&o.DMA_APBPERI_ADC_DAC_PMS_CONSTRAIN_1.Reg, volatile.LoadUint32(&o.DMA_APBPERI_ADC_DAC_PMS_CONSTRAIN_1.Reg)&^(0x3000)|value<<12)
}
func (o *SENSITIVE_Type) GetDMA_APBPERI_ADC_DAC_PMS_CONSTRAIN_1_DMA_APBPERI_ADC_DAC_PMS_CONSTRAIN_SRAM_WORLD_1_PMS_0() uint32 {
	return (volatile.LoadUint32(&o.DMA_APBPERI_ADC_DAC_PMS_CONSTRAIN_1.Reg) & 0x3000) >> 12
}
func (o *SENSITIVE_Type) SetDMA_APBPERI_ADC_DAC_PMS_CONSTRAIN_1_DMA_APBPERI_ADC_DAC_PMS_CONSTRAIN_SRAM_WORLD_1_PMS_1(value uint32) {
	volatile.StoreUint32(&o.DMA_APBPERI_ADC_DAC_PMS_CONSTRAIN_1.Reg, volatile.LoadUint32(&o.DMA_APBPERI_ADC_DAC_PMS_CONSTRAIN_1.Reg)&^(0xc000)|value<<14)
}
func (o *SENSITIVE_Type) GetDMA_APBPERI_ADC_DAC_PMS_CONSTRAIN_1_DMA_APBPERI_ADC_DAC_PMS_CONSTRAIN_SRAM_WORLD_1_PMS_1() uint32 {
	return (volatile.LoadUint32(&o.DMA_APBPERI_ADC_DAC_PMS_CONSTRAIN_1.Reg) & 0xc000) >> 14
}
func (o *SENSITIVE_Type) SetDMA_APBPERI_ADC_DAC_PMS_CONSTRAIN_1_DMA_APBPERI_ADC_DAC_PMS_CONSTRAIN_SRAM_WORLD_1_PMS_2(value uint32) {
	volatile.StoreUint32(&o.DMA_APBPERI_ADC_DAC_PMS_CONSTRAIN_1.Reg, volatile.LoadUint32(&o.DMA_APBPERI_ADC_DAC_PMS_CONSTRAIN_1.Reg)&^(0x30000)|value<<16)
}
func (o *SENSITIVE_Type) GetDMA_APBPERI_ADC_DAC_PMS_CONSTRAIN_1_DMA_APBPERI_ADC_DAC_PMS_CONSTRAIN_SRAM_WORLD_1_PMS_2() uint32 {
	return (volatile.LoadUint32(&o.DMA_APBPERI_ADC_DAC_PMS_CONSTRAIN_1.Reg) & 0x30000) >> 16
}
func (o *SENSITIVE_Type) SetDMA_APBPERI_ADC_DAC_PMS_CONSTRAIN_1_DMA_APBPERI_ADC_DAC_PMS_CONSTRAIN_SRAM_WORLD_1_PMS_3(value uint32) {
	volatile.StoreUint32(&o.DMA_APBPERI_ADC_DAC_PMS_CONSTRAIN_1.Reg, volatile.LoadUint32(&o.DMA_APBPERI_ADC_DAC_PMS_CONSTRAIN_1.Reg)&^(0xc0000)|value<<18)
}
func (o *SENSITIVE_Type) GetDMA_APBPERI_ADC_DAC_PMS_CONSTRAIN_1_DMA_APBPERI_ADC_DAC_PMS_CONSTRAIN_SRAM_WORLD_1_PMS_3() uint32 {
	return (volatile.LoadUint32(&o.DMA_APBPERI_ADC_DAC_PMS_CONSTRAIN_1.Reg) & 0xc0000) >> 18
}

// SENSITIVE.DMA_APBPERI_PMS_MONITOR_0: SENSITIVE_DMA_APBPERI_PMS_MONITOR_0_REG
func (o *SENSITIVE_Type) SetDMA_APBPERI_PMS_MONITOR_0_DMA_APBPERI_PMS_MONITOR_LOCK(value uint32) {
	volatile.StoreUint32(&o.DMA_APBPERI_PMS_MONITOR_0.Reg, volatile.LoadUint32(&o.DMA_APBPERI_PMS_MONITOR_0.Reg)&^(0x1)|value)
}
func (o *SENSITIVE_Type) GetDMA_APBPERI_PMS_MONITOR_0_DMA_APBPERI_PMS_MONITOR_LOCK() uint32 {
	return volatile.LoadUint32(&o.DMA_APBPERI_PMS_MONITOR_0.Reg) & 0x1
}

// SENSITIVE.DMA_APBPERI_PMS_MONITOR_1: SENSITIVE_DMA_APBPERI_PMS_MONITOR_1_REG
func (o *SENSITIVE_Type) SetDMA_APBPERI_PMS_MONITOR_1_DMA_APBPERI_PMS_MONITOR_VIOLATE_CLR(value uint32) {
	volatile.StoreUint32(&o.DMA_APBPERI_PMS_MONITOR_1.Reg, volatile.LoadUint32(&o.DMA_APBPERI_PMS_MONITOR_1.Reg)&^(0x1)|value)
}
func (o *SENSITIVE_Type) GetDMA_APBPERI_PMS_MONITOR_1_DMA_APBPERI_PMS_MONITOR_VIOLATE_CLR() uint32 {
	return volatile.LoadUint32(&o.DMA_APBPERI_PMS_MONITOR_1.Reg) & 0x1
}
func (o *SENSITIVE_Type) SetDMA_APBPERI_PMS_MONITOR_1_DMA_APBPERI_PMS_MONITOR_VIOLATE_EN(value uint32) {
	volatile.StoreUint32(&o.DMA_APBPERI_PMS_MONITOR_1.Reg, volatile.LoadUint32(&o.DMA_APBPERI_PMS_MONITOR_1.Reg)&^(0x2)|value<<1)
}
func (o *SENSITIVE_Type) GetDMA_APBPERI_PMS_MONITOR_1_DMA_APBPERI_PMS_MONITOR_VIOLATE_EN() uint32 {
	return (volatile.LoadUint32(&o.DMA_APBPERI_PMS_MONITOR_1.Reg) & 0x2) >> 1
}

// SENSITIVE.DMA_APBPERI_PMS_MONITOR_2: SENSITIVE_DMA_APBPERI_PMS_MONITOR_2_REG
func (o *SENSITIVE_Type) SetDMA_APBPERI_PMS_MONITOR_2_DMA_APBPERI_PMS_MONITOR_VIOLATE_INTR(value uint32) {
	volatile.StoreUint32(&o.DMA_APBPERI_PMS_MONITOR_2.Reg, volatile.LoadUint32(&o.DMA_APBPERI_PMS_MONITOR_2.Reg)&^(0x1)|value)
}
func (o *SENSITIVE_Type) GetDMA_APBPERI_PMS_MONITOR_2_DMA_APBPERI_PMS_MONITOR_VIOLATE_INTR() uint32 {
	return volatile.LoadUint32(&o.DMA_APBPERI_PMS_MONITOR_2.Reg) & 0x1
}
func (o *SENSITIVE_Type) SetDMA_APBPERI_PMS_MONITOR_2_DMA_APBPERI_PMS_MONITOR_VIOLATE_STATUS_WORLD(value uint32) {
	volatile.StoreUint32(&o.DMA_APBPERI_PMS_MONITOR_2.Reg, volatile.LoadUint32(&o.DMA_APBPERI_PMS_MONITOR_2.Reg)&^(0x6)|value<<1)
}
func (o *SENSITIVE_Type) GetDMA_APBPERI_PMS_MONITOR_2_DMA_APBPERI_PMS_MONITOR_VIOLATE_STATUS_WORLD() uint32 {
	return (volatile.LoadUint32(&o.DMA_APBPERI_PMS_MONITOR_2.Reg) & 0x6) >> 1
}
func (o *SENSITIVE_Type) SetDMA_APBPERI_PMS_MONITOR_2_DMA_APBPERI_PMS_MONITOR_VIOLATE_STATUS_ADDR(value uint32) {
	volatile.StoreUint32(&o.DMA_APBPERI_PMS_MONITOR_2.Reg, volatile.LoadUint32(&o.DMA_APBPERI_PMS_MONITOR_2.Reg)&^(0x7fffff8)|value<<3)
}
func (o *SENSITIVE_Type) GetDMA_APBPERI_PMS_MONITOR_2_DMA_APBPERI_PMS_MONITOR_VIOLATE_STATUS_ADDR() uint32 {
	return (volatile.LoadUint32(&o.DMA_APBPERI_PMS_MONITOR_2.Reg) & 0x7fffff8) >> 3
}

// SENSITIVE.DMA_APBPERI_PMS_MONITOR_3: SENSITIVE_DMA_APBPERI_PMS_MONITOR_3_REG
func (o *SENSITIVE_Type) SetDMA_APBPERI_PMS_MONITOR_3_DMA_APBPERI_PMS_MONITOR_VIOLATE_STATUS_WR(value uint32) {
	volatile.StoreUint32(&o.DMA_APBPERI_PMS_MONITOR_3.Reg, volatile.LoadUint32(&o.DMA_APBPERI_PMS_MONITOR_3.Reg)&^(0x1)|value)
}
func (o *SENSITIVE_Type) GetDMA_APBPERI_PMS_MONITOR_3_DMA_APBPERI_PMS_MONITOR_VIOLATE_STATUS_WR() uint32 {
	return volatile.LoadUint32(&o.DMA_APBPERI_PMS_MONITOR_3.Reg) & 0x1
}
func (o *SENSITIVE_Type) SetDMA_APBPERI_PMS_MONITOR_3_DMA_APBPERI_PMS_MONITOR_VIOLATE_STATUS_BYTEEN(value uint32) {
	volatile.StoreUint32(&o.DMA_APBPERI_PMS_MONITOR_3.Reg, volatile.LoadUint32(&o.DMA_APBPERI_PMS_MONITOR_3.Reg)&^(0x1e)|value<<1)
}
func (o *SENSITIVE_Type) GetDMA_APBPERI_PMS_MONITOR_3_DMA_APBPERI_PMS_MONITOR_VIOLATE_STATUS_BYTEEN() uint32 {
	return (volatile.LoadUint32(&o.DMA_APBPERI_PMS_MONITOR_3.Reg) & 0x1e) >> 1
}

// SENSITIVE.CORE_X_IRAM0_DRAM0_DMA_SPLIT_LINE_CONSTRAIN_0: SENSITIVE_CORE_X_IRAM0_DRAM0_DMA_SPLIT_LINE_CONSTRAIN_0_REG
func (o *SENSITIVE_Type) SetCORE_X_IRAM0_DRAM0_DMA_SPLIT_LINE_CONSTRAIN_0_CORE_X_IRAM0_DRAM0_DMA_SPLIT_LINE_CONSTRAIN_LOCK(value uint32) {
	volatile.StoreUint32(&o.CORE_X_IRAM0_DRAM0_DMA_SPLIT_LINE_CONSTRAIN_0.Reg, volatile.LoadUint32(&o.CORE_X_IRAM0_DRAM0_DMA_SPLIT_LINE_CONSTRAIN_0.Reg)&^(0x1)|value)
}
func (o *SENSITIVE_Type) GetCORE_X_IRAM0_DRAM0_DMA_SPLIT_LINE_CONSTRAIN_0_CORE_X_IRAM0_DRAM0_DMA_SPLIT_LINE_CONSTRAIN_LOCK() uint32 {
	return volatile.LoadUint32(&o.CORE_X_IRAM0_DRAM0_DMA_SPLIT_LINE_CONSTRAIN_0.Reg) & 0x1
}

// SENSITIVE.CORE_X_IRAM0_DRAM0_DMA_SPLIT_LINE_CONSTRAIN_1: SENSITIVE_CORE_X_IRAM0_DRAM0_DMA_SPLIT_LINE_CONSTRAIN_1_REG
func (o *SENSITIVE_Type) SetCORE_X_IRAM0_DRAM0_DMA_SPLIT_LINE_CONSTRAIN_1_CORE_X_IRAM0_DRAM0_DMA_SRAM_CATEGORY_0(value uint32) {
	volatile.StoreUint32(&o.CORE_X_IRAM0_DRAM0_DMA_SPLIT_LINE_CONSTRAIN_1.Reg, volatile.LoadUint32(&o.CORE_X_IRAM0_DRAM0_DMA_SPLIT_LINE_CONSTRAIN_1.Reg)&^(0x3)|value)
}
func (o *SENSITIVE_Type) GetCORE_X_IRAM0_DRAM0_DMA_SPLIT_LINE_CONSTRAIN_1_CORE_X_IRAM0_DRAM0_DMA_SRAM_CATEGORY_0() uint32 {
	return volatile.LoadUint32(&o.CORE_X_IRAM0_DRAM0_DMA_SPLIT_LINE_CONSTRAIN_1.Reg) & 0x3
}
func (o *SENSITIVE_Type) SetCORE_X_IRAM0_DRAM0_DMA_SPLIT_LINE_CONSTRAIN_1_CORE_X_IRAM0_DRAM0_DMA_SRAM_CATEGORY_1(value uint32) {
	volatile.StoreUint32(&o.CORE_X_IRAM0_DRAM0_DMA_SPLIT_LINE_CONSTRAIN_1.Reg, volatile.LoadUint32(&o.CORE_X_IRAM0_DRAM0_DMA_SPLIT_LINE_CONSTRAIN_1.Reg)&^(0xc)|value<<2)
}
func (o *SENSITIVE_Type) GetCORE_X_IRAM0_DRAM0_DMA_SPLIT_LINE_CONSTRAIN_1_CORE_X_IRAM0_DRAM0_DMA_SRAM_CATEGORY_1() uint32 {
	return (volatile.LoadUint32(&o.CORE_X_IRAM0_DRAM0_DMA_SPLIT_LINE_CONSTRAIN_1.Reg) & 0xc) >> 2
}
func (o *SENSITIVE_Type) SetCORE_X_IRAM0_DRAM0_DMA_SPLIT_LINE_CONSTRAIN_1_CORE_X_IRAM0_DRAM0_DMA_SRAM_CATEGORY_2(value uint32) {
	volatile.StoreUint32(&o.CORE_X_IRAM0_DRAM0_DMA_SPLIT_LINE_CONSTRAIN_1.Reg, volatile.LoadUint32(&o.CORE_X_IRAM0_DRAM0_DMA_SPLIT_LINE_CONSTRAIN_1.Reg)&^(0x30)|value<<4)
}
func (o *SENSITIVE_Type) GetCORE_X_IRAM0_DRAM0_DMA_SPLIT_LINE_CONSTRAIN_1_CORE_X_IRAM0_DRAM0_DMA_SRAM_CATEGORY_2() uint32 {
	return (volatile.LoadUint32(&o.CORE_X_IRAM0_DRAM0_DMA_SPLIT_LINE_CONSTRAIN_1.Reg) & 0x30) >> 4
}
func (o *SENSITIVE_Type) SetCORE_X_IRAM0_DRAM0_DMA_SPLIT_LINE_CONSTRAIN_1_CORE_X_IRAM0_DRAM0_DMA_SRAM_SPLITADDR(value uint32) {
	volatile.StoreUint32(&o.CORE_X_IRAM0_DRAM0_DMA_SPLIT_LINE_CONSTRAIN_1.Reg, volatile.LoadUint32(&o.CORE_X_IRAM0_DRAM0_DMA_SPLIT_LINE_CONSTRAIN_1.Reg)&^(0x3fc000)|value<<14)
}
func (o *SENSITIVE_Type) GetCORE_X_IRAM0_DRAM0_DMA_SPLIT_LINE_CONSTRAIN_1_CORE_X_IRAM0_DRAM0_DMA_SRAM_SPLITADDR() uint32 {
	return (volatile.LoadUint32(&o.CORE_X_IRAM0_DRAM0_DMA_SPLIT_LINE_CONSTRAIN_1.Reg) & 0x3fc000) >> 14
}

// SENSITIVE.CORE_X_IRAM0_DRAM0_DMA_SPLIT_LINE_CONSTRAIN_2: SENSITIVE_CORE_X_IRAM0_DRAM0_DMA_SPLIT_LINE_CONSTRAIN_2_REG
func (o *SENSITIVE_Type) SetCORE_X_IRAM0_DRAM0_DMA_SPLIT_LINE_CONSTRAIN_2_CORE_X_IRAM0_SRAM_LINE_0_CATEGORY_0(value uint32) {
	volatile.StoreUint32(&o.CORE_X_IRAM0_DRAM0_DMA_SPLIT_LINE_CONSTRAIN_2.Reg, volatile.LoadUint32(&o.CORE_X_IRAM0_DRAM0_DMA_SPLIT_LINE_CONSTRAIN_2.Reg)&^(0x3)|value)
}
func (o *SENSITIVE_Type) GetCORE_X_IRAM0_DRAM0_DMA_SPLIT_LINE_CONSTRAIN_2_CORE_X_IRAM0_SRAM_LINE_0_CATEGORY_0() uint32 {
	return volatile.LoadUint32(&o.CORE_X_IRAM0_DRAM0_DMA_SPLIT_LINE_CONSTRAIN_2.Reg) & 0x3
}
func (o *SENSITIVE_Type) SetCORE_X_IRAM0_DRAM0_DMA_SPLIT_LINE_CONSTRAIN_2_CORE_X_IRAM0_SRAM_LINE_0_CATEGORY_1(value uint32) {
	volatile.StoreUint32(&o.CORE_X_IRAM0_DRAM0_DMA_SPLIT_LINE_CONSTRAIN_2.Reg, volatile.LoadUint32(&o.CORE_X_IRAM0_DRAM0_DMA_SPLIT_LINE_CONSTRAIN_2.Reg)&^(0xc)|value<<2)
}
func (o *SENSITIVE_Type) GetCORE_X_IRAM0_DRAM0_DMA_SPLIT_LINE_CONSTRAIN_2_CORE_X_IRAM0_SRAM_LINE_0_CATEGORY_1() uint32 {
	return (volatile.LoadUint32(&o.CORE_X_IRAM0_DRAM0_DMA_SPLIT_LINE_CONSTRAIN_2.Reg) & 0xc) >> 2
}
func (o *SENSITIVE_Type) SetCORE_X_IRAM0_DRAM0_DMA_SPLIT_LINE_CONSTRAIN_2_CORE_X_IRAM0_SRAM_LINE_0_CATEGORY_2(value uint32) {
	volatile.StoreUint32(&o.CORE_X_IRAM0_DRAM0_DMA_SPLIT_LINE_CONSTRAIN_2.Reg, volatile.LoadUint32(&o.CORE_X_IRAM0_DRAM0_DMA_SPLIT_LINE_CONSTRAIN_2.Reg)&^(0x30)|value<<4)
}
func (o *SENSITIVE_Type) GetCORE_X_IRAM0_DRAM0_DMA_SPLIT_LINE_CONSTRAIN_2_CORE_X_IRAM0_SRAM_LINE_0_CATEGORY_2() uint32 {
	return (volatile.LoadUint32(&o.CORE_X_IRAM0_DRAM0_DMA_SPLIT_LINE_CONSTRAIN_2.Reg) & 0x30) >> 4
}
func (o *SENSITIVE_Type) SetCORE_X_IRAM0_DRAM0_DMA_SPLIT_LINE_CONSTRAIN_2_CORE_X_IRAM0_SRAM_LINE_0_SPLITADDR(value uint32) {
	volatile.StoreUint32(&o.CORE_X_IRAM0_DRAM0_DMA_SPLIT_LINE_CONSTRAIN_2.Reg, volatile.LoadUint32(&o.CORE_X_IRAM0_DRAM0_DMA_SPLIT_LINE_CONSTRAIN_2.Reg)&^(0x3fc000)|value<<14)
}
func (o *SENSITIVE_Type) GetCORE_X_IRAM0_DRAM0_DMA_SPLIT_LINE_CONSTRAIN_2_CORE_X_IRAM0_SRAM_LINE_0_SPLITADDR() uint32 {
	return (volatile.LoadUint32(&o.CORE_X_IRAM0_DRAM0_DMA_SPLIT_LINE_CONSTRAIN_2.Reg) & 0x3fc000) >> 14
}

// SENSITIVE.CORE_X_IRAM0_DRAM0_DMA_SPLIT_LINE_CONSTRAIN_3: SENSITIVE_CORE_X_IRAM0_DRAM0_DMA_SPLIT_LINE_CONSTRAIN_3_REG
func (o *SENSITIVE_Type) SetCORE_X_IRAM0_DRAM0_DMA_SPLIT_LINE_CONSTRAIN_3_CORE_X_IRAM0_SRAM_LINE_1_CATEGORY_0(value uint32) {
	volatile.StoreUint32(&o.CORE_X_IRAM0_DRAM0_DMA_SPLIT_LINE_CONSTRAIN_3.Reg, volatile.LoadUint32(&o.CORE_X_IRAM0_DRAM0_DMA_SPLIT_LINE_CONSTRAIN_3.Reg)&^(0x3)|value)
}
func (o *SENSITIVE_Type) GetCORE_X_IRAM0_DRAM0_DMA_SPLIT_LINE_CONSTRAIN_3_CORE_X_IRAM0_SRAM_LINE_1_CATEGORY_0() uint32 {
	return volatile.LoadUint32(&o.CORE_X_IRAM0_DRAM0_DMA_SPLIT_LINE_CONSTRAIN_3.Reg) & 0x3
}
func (o *SENSITIVE_Type) SetCORE_X_IRAM0_DRAM0_DMA_SPLIT_LINE_CONSTRAIN_3_CORE_X_IRAM0_SRAM_LINE_1_CATEGORY_1(value uint32) {
	volatile.StoreUint32(&o.CORE_X_IRAM0_DRAM0_DMA_SPLIT_LINE_CONSTRAIN_3.Reg, volatile.LoadUint32(&o.CORE_X_IRAM0_DRAM0_DMA_SPLIT_LINE_CONSTRAIN_3.Reg)&^(0xc)|value<<2)
}
func (o *SENSITIVE_Type) GetCORE_X_IRAM0_DRAM0_DMA_SPLIT_LINE_CONSTRAIN_3_CORE_X_IRAM0_SRAM_LINE_1_CATEGORY_1() uint32 {
	return (volatile.LoadUint32(&o.CORE_X_IRAM0_DRAM0_DMA_SPLIT_LINE_CONSTRAIN_3.Reg) & 0xc) >> 2
}
func (o *SENSITIVE_Type) SetCORE_X_IRAM0_DRAM0_DMA_SPLIT_LINE_CONSTRAIN_3_CORE_X_IRAM0_SRAM_LINE_1_CATEGORY_2(value uint32) {
	volatile.StoreUint32(&o.CORE_X_IRAM0_DRAM0_DMA_SPLIT_LINE_CONSTRAIN_3.Reg, volatile.LoadUint32(&o.CORE_X_IRAM0_DRAM0_DMA_SPLIT_LINE_CONSTRAIN_3.Reg)&^(0x30)|value<<4)
}
func (o *SENSITIVE_Type) GetCORE_X_IRAM0_DRAM0_DMA_SPLIT_LINE_CONSTRAIN_3_CORE_X_IRAM0_SRAM_LINE_1_CATEGORY_2() uint32 {
	return (volatile.LoadUint32(&o.CORE_X_IRAM0_DRAM0_DMA_SPLIT_LINE_CONSTRAIN_3.Reg) & 0x30) >> 4
}
func (o *SENSITIVE_Type) SetCORE_X_IRAM0_DRAM0_DMA_SPLIT_LINE_CONSTRAIN_3_CORE_X_IRAM0_SRAM_LINE_1_SPLITADDR(value uint32) {
	volatile.StoreUint32(&o.CORE_X_IRAM0_DRAM0_DMA_SPLIT_LINE_CONSTRAIN_3.Reg, volatile.LoadUint32(&o.CORE_X_IRAM0_DRAM0_DMA_SPLIT_LINE_CONSTRAIN_3.Reg)&^(0x3fc000)|value<<14)
}
func (o *SENSITIVE_Type) GetCORE_X_IRAM0_DRAM0_DMA_SPLIT_LINE_CONSTRAIN_3_CORE_X_IRAM0_SRAM_LINE_1_SPLITADDR() uint32 {
	return (volatile.LoadUint32(&o.CORE_X_IRAM0_DRAM0_DMA_SPLIT_LINE_CONSTRAIN_3.Reg) & 0x3fc000) >> 14
}

// SENSITIVE.CORE_X_IRAM0_DRAM0_DMA_SPLIT_LINE_CONSTRAIN_4: SENSITIVE_CORE_X_IRAM0_DRAM0_DMA_SPLIT_LINE_CONSTRAIN_4_REG
func (o *SENSITIVE_Type) SetCORE_X_IRAM0_DRAM0_DMA_SPLIT_LINE_CONSTRAIN_4_CORE_X_DRAM0_DMA_SRAM_LINE_0_CATEGORY_0(value uint32) {
	volatile.StoreUint32(&o.CORE_X_IRAM0_DRAM0_DMA_SPLIT_LINE_CONSTRAIN_4.Reg, volatile.LoadUint32(&o.CORE_X_IRAM0_DRAM0_DMA_SPLIT_LINE_CONSTRAIN_4.Reg)&^(0x3)|value)
}
func (o *SENSITIVE_Type) GetCORE_X_IRAM0_DRAM0_DMA_SPLIT_LINE_CONSTRAIN_4_CORE_X_DRAM0_DMA_SRAM_LINE_0_CATEGORY_0() uint32 {
	return volatile.LoadUint32(&o.CORE_X_IRAM0_DRAM0_DMA_SPLIT_LINE_CONSTRAIN_4.Reg) & 0x3
}
func (o *SENSITIVE_Type) SetCORE_X_IRAM0_DRAM0_DMA_SPLIT_LINE_CONSTRAIN_4_CORE_X_DRAM0_DMA_SRAM_LINE_0_CATEGORY_1(value uint32) {
	volatile.StoreUint32(&o.CORE_X_IRAM0_DRAM0_DMA_SPLIT_LINE_CONSTRAIN_4.Reg, volatile.LoadUint32(&o.CORE_X_IRAM0_DRAM0_DMA_SPLIT_LINE_CONSTRAIN_4.Reg)&^(0xc)|value<<2)
}
func (o *SENSITIVE_Type) GetCORE_X_IRAM0_DRAM0_DMA_SPLIT_LINE_CONSTRAIN_4_CORE_X_DRAM0_DMA_SRAM_LINE_0_CATEGORY_1() uint32 {
	return (volatile.LoadUint32(&o.CORE_X_IRAM0_DRAM0_DMA_SPLIT_LINE_CONSTRAIN_4.Reg) & 0xc) >> 2
}
func (o *SENSITIVE_Type) SetCORE_X_IRAM0_DRAM0_DMA_SPLIT_LINE_CONSTRAIN_4_CORE_X_DRAM0_DMA_SRAM_LINE_0_CATEGORY_2(value uint32) {
	volatile.StoreUint32(&o.CORE_X_IRAM0_DRAM0_DMA_SPLIT_LINE_CONSTRAIN_4.Reg, volatile.LoadUint32(&o.CORE_X_IRAM0_DRAM0_DMA_SPLIT_LINE_CONSTRAIN_4.Reg)&^(0x30)|value<<4)
}
func (o *SENSITIVE_Type) GetCORE_X_IRAM0_DRAM0_DMA_SPLIT_LINE_CONSTRAIN_4_CORE_X_DRAM0_DMA_SRAM_LINE_0_CATEGORY_2() uint32 {
	return (volatile.LoadUint32(&o.CORE_X_IRAM0_DRAM0_DMA_SPLIT_LINE_CONSTRAIN_4.Reg) & 0x30) >> 4
}
func (o *SENSITIVE_Type) SetCORE_X_IRAM0_DRAM0_DMA_SPLIT_LINE_CONSTRAIN_4_CORE_X_DRAM0_DMA_SRAM_LINE_0_SPLITADDR(value uint32) {
	volatile.StoreUint32(&o.CORE_X_IRAM0_DRAM0_DMA_SPLIT_LINE_CONSTRAIN_4.Reg, volatile.LoadUint32(&o.CORE_X_IRAM0_DRAM0_DMA_SPLIT_LINE_CONSTRAIN_4.Reg)&^(0x3fc000)|value<<14)
}
func (o *SENSITIVE_Type) GetCORE_X_IRAM0_DRAM0_DMA_SPLIT_LINE_CONSTRAIN_4_CORE_X_DRAM0_DMA_SRAM_LINE_0_SPLITADDR() uint32 {
	return (volatile.LoadUint32(&o.CORE_X_IRAM0_DRAM0_DMA_SPLIT_LINE_CONSTRAIN_4.Reg) & 0x3fc000) >> 14
}

// SENSITIVE.CORE_X_IRAM0_DRAM0_DMA_SPLIT_LINE_CONSTRAIN_5: SENSITIVE_CORE_X_IRAM0_DRAM0_DMA_SPLIT_LINE_CONSTRAIN_5_REG
func (o *SENSITIVE_Type) SetCORE_X_IRAM0_DRAM0_DMA_SPLIT_LINE_CONSTRAIN_5_CORE_X_DRAM0_DMA_SRAM_LINE_1_CATEGORY_0(value uint32) {
	volatile.StoreUint32(&o.CORE_X_IRAM0_DRAM0_DMA_SPLIT_LINE_CONSTRAIN_5.Reg, volatile.LoadUint32(&o.CORE_X_IRAM0_DRAM0_DMA_SPLIT_LINE_CONSTRAIN_5.Reg)&^(0x3)|value)
}
func (o *SENSITIVE_Type) GetCORE_X_IRAM0_DRAM0_DMA_SPLIT_LINE_CONSTRAIN_5_CORE_X_DRAM0_DMA_SRAM_LINE_1_CATEGORY_0() uint32 {
	return volatile.LoadUint32(&o.CORE_X_IRAM0_DRAM0_DMA_SPLIT_LINE_CONSTRAIN_5.Reg) & 0x3
}
func (o *SENSITIVE_Type) SetCORE_X_IRAM0_DRAM0_DMA_SPLIT_LINE_CONSTRAIN_5_CORE_X_DRAM0_DMA_SRAM_LINE_1_CATEGORY_1(value uint32) {
	volatile.StoreUint32(&o.CORE_X_IRAM0_DRAM0_DMA_SPLIT_LINE_CONSTRAIN_5.Reg, volatile.LoadUint32(&o.CORE_X_IRAM0_DRAM0_DMA_SPLIT_LINE_CONSTRAIN_5.Reg)&^(0xc)|value<<2)
}
func (o *SENSITIVE_Type) GetCORE_X_IRAM0_DRAM0_DMA_SPLIT_LINE_CONSTRAIN_5_CORE_X_DRAM0_DMA_SRAM_LINE_1_CATEGORY_1() uint32 {
	return (volatile.LoadUint32(&o.CORE_X_IRAM0_DRAM0_DMA_SPLIT_LINE_CONSTRAIN_5.Reg) & 0xc) >> 2
}
func (o *SENSITIVE_Type) SetCORE_X_IRAM0_DRAM0_DMA_SPLIT_LINE_CONSTRAIN_5_CORE_X_DRAM0_DMA_SRAM_LINE_1_CATEGORY_2(value uint32) {
	volatile.StoreUint32(&o.CORE_X_IRAM0_DRAM0_DMA_SPLIT_LINE_CONSTRAIN_5.Reg, volatile.LoadUint32(&o.CORE_X_IRAM0_DRAM0_DMA_SPLIT_LINE_CONSTRAIN_5.Reg)&^(0x30)|value<<4)
}
func (o *SENSITIVE_Type) GetCORE_X_IRAM0_DRAM0_DMA_SPLIT_LINE_CONSTRAIN_5_CORE_X_DRAM0_DMA_SRAM_LINE_1_CATEGORY_2() uint32 {
	return (volatile.LoadUint32(&o.CORE_X_IRAM0_DRAM0_DMA_SPLIT_LINE_CONSTRAIN_5.Reg) & 0x30) >> 4
}
func (o *SENSITIVE_Type) SetCORE_X_IRAM0_DRAM0_DMA_SPLIT_LINE_CONSTRAIN_5_CORE_X_DRAM0_DMA_SRAM_LINE_1_SPLITADDR(value uint32) {
	volatile.StoreUint32(&o.CORE_X_IRAM0_DRAM0_DMA_SPLIT_LINE_CONSTRAIN_5.Reg, volatile.LoadUint32(&o.CORE_X_IRAM0_DRAM0_DMA_SPLIT_LINE_CONSTRAIN_5.Reg)&^(0x3fc000)|value<<14)
}
func (o *SENSITIVE_Type) GetCORE_X_IRAM0_DRAM0_DMA_SPLIT_LINE_CONSTRAIN_5_CORE_X_DRAM0_DMA_SRAM_LINE_1_SPLITADDR() uint32 {
	return (volatile.LoadUint32(&o.CORE_X_IRAM0_DRAM0_DMA_SPLIT_LINE_CONSTRAIN_5.Reg) & 0x3fc000) >> 14
}

// SENSITIVE.CORE_X_IRAM0_PMS_CONSTRAIN_0: SENSITIVE_CORE_X_IRAM0_PMS_CONSTRAIN_0_REG
func (o *SENSITIVE_Type) SetCORE_X_IRAM0_PMS_CONSTRAIN_0_CORE_X_IRAM0_PMS_CONSTRAIN_LOCK(value uint32) {
	volatile.StoreUint32(&o.CORE_X_IRAM0_PMS_CONSTRAIN_0.Reg, volatile.LoadUint32(&o.CORE_X_IRAM0_PMS_CONSTRAIN_0.Reg)&^(0x1)|value)
}
func (o *SENSITIVE_Type) GetCORE_X_IRAM0_PMS_CONSTRAIN_0_CORE_X_IRAM0_PMS_CONSTRAIN_LOCK() uint32 {
	return volatile.LoadUint32(&o.CORE_X_IRAM0_PMS_CONSTRAIN_0.Reg) & 0x1
}

// SENSITIVE.CORE_X_IRAM0_PMS_CONSTRAIN_1: SENSITIVE_CORE_X_IRAM0_PMS_CONSTRAIN_1_REG
func (o *SENSITIVE_Type) SetCORE_X_IRAM0_PMS_CONSTRAIN_1_CORE_X_IRAM0_PMS_CONSTRAIN_SRAM_WORLD_1_PMS_0(value uint32) {
	volatile.StoreUint32(&o.CORE_X_IRAM0_PMS_CONSTRAIN_1.Reg, volatile.LoadUint32(&o.CORE_X_IRAM0_PMS_CONSTRAIN_1.Reg)&^(0x7)|value)
}
func (o *SENSITIVE_Type) GetCORE_X_IRAM0_PMS_CONSTRAIN_1_CORE_X_IRAM0_PMS_CONSTRAIN_SRAM_WORLD_1_PMS_0() uint32 {
	return volatile.LoadUint32(&o.CORE_X_IRAM0_PMS_CONSTRAIN_1.Reg) & 0x7
}
func (o *SENSITIVE_Type) SetCORE_X_IRAM0_PMS_CONSTRAIN_1_CORE_X_IRAM0_PMS_CONSTRAIN_SRAM_WORLD_1_PMS_1(value uint32) {
	volatile.StoreUint32(&o.CORE_X_IRAM0_PMS_CONSTRAIN_1.Reg, volatile.LoadUint32(&o.CORE_X_IRAM0_PMS_CONSTRAIN_1.Reg)&^(0x38)|value<<3)
}
func (o *SENSITIVE_Type) GetCORE_X_IRAM0_PMS_CONSTRAIN_1_CORE_X_IRAM0_PMS_CONSTRAIN_SRAM_WORLD_1_PMS_1() uint32 {
	return (volatile.LoadUint32(&o.CORE_X_IRAM0_PMS_CONSTRAIN_1.Reg) & 0x38) >> 3
}
func (o *SENSITIVE_Type) SetCORE_X_IRAM0_PMS_CONSTRAIN_1_CORE_X_IRAM0_PMS_CONSTRAIN_SRAM_WORLD_1_PMS_2(value uint32) {
	volatile.StoreUint32(&o.CORE_X_IRAM0_PMS_CONSTRAIN_1.Reg, volatile.LoadUint32(&o.CORE_X_IRAM0_PMS_CONSTRAIN_1.Reg)&^(0x1c0)|value<<6)
}
func (o *SENSITIVE_Type) GetCORE_X_IRAM0_PMS_CONSTRAIN_1_CORE_X_IRAM0_PMS_CONSTRAIN_SRAM_WORLD_1_PMS_2() uint32 {
	return (volatile.LoadUint32(&o.CORE_X_IRAM0_PMS_CONSTRAIN_1.Reg) & 0x1c0) >> 6
}
func (o *SENSITIVE_Type) SetCORE_X_IRAM0_PMS_CONSTRAIN_1_CORE_X_IRAM0_PMS_CONSTRAIN_SRAM_WORLD_1_PMS_3(value uint32) {
	volatile.StoreUint32(&o.CORE_X_IRAM0_PMS_CONSTRAIN_1.Reg, volatile.LoadUint32(&o.CORE_X_IRAM0_PMS_CONSTRAIN_1.Reg)&^(0xe00)|value<<9)
}
func (o *SENSITIVE_Type) GetCORE_X_IRAM0_PMS_CONSTRAIN_1_CORE_X_IRAM0_PMS_CONSTRAIN_SRAM_WORLD_1_PMS_3() uint32 {
	return (volatile.LoadUint32(&o.CORE_X_IRAM0_PMS_CONSTRAIN_1.Reg) & 0xe00) >> 9
}
func (o *SENSITIVE_Type) SetCORE_X_IRAM0_PMS_CONSTRAIN_1_CORE_X_IRAM0_PMS_CONSTRAIN_SRAM_WORLD_1_CACHEDATAARRAY_PMS_0(value uint32) {
	volatile.StoreUint32(&o.CORE_X_IRAM0_PMS_CONSTRAIN_1.Reg, volatile.LoadUint32(&o.CORE_X_IRAM0_PMS_CONSTRAIN_1.Reg)&^(0x7000)|value<<12)
}
func (o *SENSITIVE_Type) GetCORE_X_IRAM0_PMS_CONSTRAIN_1_CORE_X_IRAM0_PMS_CONSTRAIN_SRAM_WORLD_1_CACHEDATAARRAY_PMS_0() uint32 {
	return (volatile.LoadUint32(&o.CORE_X_IRAM0_PMS_CONSTRAIN_1.Reg) & 0x7000) >> 12
}
func (o *SENSITIVE_Type) SetCORE_X_IRAM0_PMS_CONSTRAIN_1_CORE_X_IRAM0_PMS_CONSTRAIN_ROM_WORLD_1_PMS(value uint32) {
	volatile.StoreUint32(&o.CORE_X_IRAM0_PMS_CONSTRAIN_1.Reg, volatile.LoadUint32(&o.CORE_X_IRAM0_PMS_CONSTRAIN_1.Reg)&^(0x1c0000)|value<<18)
}
func (o *SENSITIVE_Type) GetCORE_X_IRAM0_PMS_CONSTRAIN_1_CORE_X_IRAM0_PMS_CONSTRAIN_ROM_WORLD_1_PMS() uint32 {
	return (volatile.LoadUint32(&o.CORE_X_IRAM0_PMS_CONSTRAIN_1.Reg) & 0x1c0000) >> 18
}

// SENSITIVE.CORE_X_IRAM0_PMS_CONSTRAIN_2: SENSITIVE_CORE_X_IRAM0_PMS_CONSTRAIN_2_REG
func (o *SENSITIVE_Type) SetCORE_X_IRAM0_PMS_CONSTRAIN_2_CORE_X_IRAM0_PMS_CONSTRAIN_SRAM_WORLD_0_PMS_0(value uint32) {
	volatile.StoreUint32(&o.CORE_X_IRAM0_PMS_CONSTRAIN_2.Reg, volatile.LoadUint32(&o.CORE_X_IRAM0_PMS_CONSTRAIN_2.Reg)&^(0x7)|value)
}
func (o *SENSITIVE_Type) GetCORE_X_IRAM0_PMS_CONSTRAIN_2_CORE_X_IRAM0_PMS_CONSTRAIN_SRAM_WORLD_0_PMS_0() uint32 {
	return volatile.LoadUint32(&o.CORE_X_IRAM0_PMS_CONSTRAIN_2.Reg) & 0x7
}
func (o *SENSITIVE_Type) SetCORE_X_IRAM0_PMS_CONSTRAIN_2_CORE_X_IRAM0_PMS_CONSTRAIN_SRAM_WORLD_0_PMS_1(value uint32) {
	volatile.StoreUint32(&o.CORE_X_IRAM0_PMS_CONSTRAIN_2.Reg, volatile.LoadUint32(&o.CORE_X_IRAM0_PMS_CONSTRAIN_2.Reg)&^(0x38)|value<<3)
}
func (o *SENSITIVE_Type) GetCORE_X_IRAM0_PMS_CONSTRAIN_2_CORE_X_IRAM0_PMS_CONSTRAIN_SRAM_WORLD_0_PMS_1() uint32 {
	return (volatile.LoadUint32(&o.CORE_X_IRAM0_PMS_CONSTRAIN_2.Reg) & 0x38) >> 3
}
func (o *SENSITIVE_Type) SetCORE_X_IRAM0_PMS_CONSTRAIN_2_CORE_X_IRAM0_PMS_CONSTRAIN_SRAM_WORLD_0_PMS_2(value uint32) {
	volatile.StoreUint32(&o.CORE_X_IRAM0_PMS_CONSTRAIN_2.Reg, volatile.LoadUint32(&o.CORE_X_IRAM0_PMS_CONSTRAIN_2.Reg)&^(0x1c0)|value<<6)
}
func (o *SENSITIVE_Type) GetCORE_X_IRAM0_PMS_CONSTRAIN_2_CORE_X_IRAM0_PMS_CONSTRAIN_SRAM_WORLD_0_PMS_2() uint32 {
	return (volatile.LoadUint32(&o.CORE_X_IRAM0_PMS_CONSTRAIN_2.Reg) & 0x1c0) >> 6
}
func (o *SENSITIVE_Type) SetCORE_X_IRAM0_PMS_CONSTRAIN_2_CORE_X_IRAM0_PMS_CONSTRAIN_SRAM_WORLD_0_PMS_3(value uint32) {
	volatile.StoreUint32(&o.CORE_X_IRAM0_PMS_CONSTRAIN_2.Reg, volatile.LoadUint32(&o.CORE_X_IRAM0_PMS_CONSTRAIN_2.Reg)&^(0xe00)|value<<9)
}
func (o *SENSITIVE_Type) GetCORE_X_IRAM0_PMS_CONSTRAIN_2_CORE_X_IRAM0_PMS_CONSTRAIN_SRAM_WORLD_0_PMS_3() uint32 {
	return (volatile.LoadUint32(&o.CORE_X_IRAM0_PMS_CONSTRAIN_2.Reg) & 0xe00) >> 9
}
func (o *SENSITIVE_Type) SetCORE_X_IRAM0_PMS_CONSTRAIN_2_CORE_X_IRAM0_PMS_CONSTRAIN_SRAM_WORLD_0_CACHEDATAARRAY_PMS_0(value uint32) {
	volatile.StoreUint32(&o.CORE_X_IRAM0_PMS_CONSTRAIN_2.Reg, volatile.LoadUint32(&o.CORE_X_IRAM0_PMS_CONSTRAIN_2.Reg)&^(0x7000)|value<<12)
}
func (o *SENSITIVE_Type) GetCORE_X_IRAM0_PMS_CONSTRAIN_2_CORE_X_IRAM0_PMS_CONSTRAIN_SRAM_WORLD_0_CACHEDATAARRAY_PMS_0() uint32 {
	return (volatile.LoadUint32(&o.CORE_X_IRAM0_PMS_CONSTRAIN_2.Reg) & 0x7000) >> 12
}
func (o *SENSITIVE_Type) SetCORE_X_IRAM0_PMS_CONSTRAIN_2_CORE_X_IRAM0_PMS_CONSTRAIN_ROM_WORLD_0_PMS(value uint32) {
	volatile.StoreUint32(&o.CORE_X_IRAM0_PMS_CONSTRAIN_2.Reg, volatile.LoadUint32(&o.CORE_X_IRAM0_PMS_CONSTRAIN_2.Reg)&^(0x1c0000)|value<<18)
}
func (o *SENSITIVE_Type) GetCORE_X_IRAM0_PMS_CONSTRAIN_2_CORE_X_IRAM0_PMS_CONSTRAIN_ROM_WORLD_0_PMS() uint32 {
	return (volatile.LoadUint32(&o.CORE_X_IRAM0_PMS_CONSTRAIN_2.Reg) & 0x1c0000) >> 18
}

// SENSITIVE.CORE_0_IRAM0_PMS_MONITOR_0: SENSITIVE_CORE_0_IRAM0_PMS_MONITOR_0_REG
func (o *SENSITIVE_Type) SetCORE_0_IRAM0_PMS_MONITOR_0_CORE_0_IRAM0_PMS_MONITOR_LOCK(value uint32) {
	volatile.StoreUint32(&o.CORE_0_IRAM0_PMS_MONITOR_0.Reg, volatile.LoadUint32(&o.CORE_0_IRAM0_PMS_MONITOR_0.Reg)&^(0x1)|value)
}
func (o *SENSITIVE_Type) GetCORE_0_IRAM0_PMS_MONITOR_0_CORE_0_IRAM0_PMS_MONITOR_LOCK() uint32 {
	return volatile.LoadUint32(&o.CORE_0_IRAM0_PMS_MONITOR_0.Reg) & 0x1
}

// SENSITIVE.CORE_0_IRAM0_PMS_MONITOR_1: SENSITIVE_CORE_0_IRAM0_PMS_MONITOR_1_REG
func (o *SENSITIVE_Type) SetCORE_0_IRAM0_PMS_MONITOR_1_CORE_0_IRAM0_PMS_MONITOR_VIOLATE_CLR(value uint32) {
	volatile.StoreUint32(&o.CORE_0_IRAM0_PMS_MONITOR_1.Reg, volatile.LoadUint32(&o.CORE_0_IRAM0_PMS_MONITOR_1.Reg)&^(0x1)|value)
}
func (o *SENSITIVE_Type) GetCORE_0_IRAM0_PMS_MONITOR_1_CORE_0_IRAM0_PMS_MONITOR_VIOLATE_CLR() uint32 {
	return volatile.LoadUint32(&o.CORE_0_IRAM0_PMS_MONITOR_1.Reg) & 0x1
}
func (o *SENSITIVE_Type) SetCORE_0_IRAM0_PMS_MONITOR_1_CORE_0_IRAM0_PMS_MONITOR_VIOLATE_EN(value uint32) {
	volatile.StoreUint32(&o.CORE_0_IRAM0_PMS_MONITOR_1.Reg, volatile.LoadUint32(&o.CORE_0_IRAM0_PMS_MONITOR_1.Reg)&^(0x2)|value<<1)
}
func (o *SENSITIVE_Type) GetCORE_0_IRAM0_PMS_MONITOR_1_CORE_0_IRAM0_PMS_MONITOR_VIOLATE_EN() uint32 {
	return (volatile.LoadUint32(&o.CORE_0_IRAM0_PMS_MONITOR_1.Reg) & 0x2) >> 1
}

// SENSITIVE.CORE_0_IRAM0_PMS_MONITOR_2: SENSITIVE_CORE_0_IRAM0_PMS_MONITOR_2_REG
func (o *SENSITIVE_Type) SetCORE_0_IRAM0_PMS_MONITOR_2_CORE_0_IRAM0_PMS_MONITOR_VIOLATE_INTR(value uint32) {
	volatile.StoreUint32(&o.CORE_0_IRAM0_PMS_MONITOR_2.Reg, volatile.LoadUint32(&o.CORE_0_IRAM0_PMS_MONITOR_2.Reg)&^(0x1)|value)
}
func (o *SENSITIVE_Type) GetCORE_0_IRAM0_PMS_MONITOR_2_CORE_0_IRAM0_PMS_MONITOR_VIOLATE_INTR() uint32 {
	return volatile.LoadUint32(&o.CORE_0_IRAM0_PMS_MONITOR_2.Reg) & 0x1
}
func (o *SENSITIVE_Type) SetCORE_0_IRAM0_PMS_MONITOR_2_CORE_0_IRAM0_PMS_MONITOR_VIOLATE_STATUS_WR(value uint32) {
	volatile.StoreUint32(&o.CORE_0_IRAM0_PMS_MONITOR_2.Reg, volatile.LoadUint32(&o.CORE_0_IRAM0_PMS_MONITOR_2.Reg)&^(0x2)|value<<1)
}
func (o *SENSITIVE_Type) GetCORE_0_IRAM0_PMS_MONITOR_2_CORE_0_IRAM0_PMS_MONITOR_VIOLATE_STATUS_WR() uint32 {
	return (volatile.LoadUint32(&o.CORE_0_IRAM0_PMS_MONITOR_2.Reg) & 0x2) >> 1
}
func (o *SENSITIVE_Type) SetCORE_0_IRAM0_PMS_MONITOR_2_CORE_0_IRAM0_PMS_MONITOR_VIOLATE_STATUS_LOADSTORE(value uint32) {
	volatile.StoreUint32(&o.CORE_0_IRAM0_PMS_MONITOR_2.Reg, volatile.LoadUint32(&o.CORE_0_IRAM0_PMS_MONITOR_2.Reg)&^(0x4)|value<<2)
}
func (o *SENSITIVE_Type) GetCORE_0_IRAM0_PMS_MONITOR_2_CORE_0_IRAM0_PMS_MONITOR_VIOLATE_STATUS_LOADSTORE() uint32 {
	return (volatile.LoadUint32(&o.CORE_0_IRAM0_PMS_MONITOR_2.Reg) & 0x4) >> 2
}
func (o *SENSITIVE_Type) SetCORE_0_IRAM0_PMS_MONITOR_2_CORE_0_IRAM0_PMS_MONITOR_VIOLATE_STATUS_WORLD(value uint32) {
	volatile.StoreUint32(&o.CORE_0_IRAM0_PMS_MONITOR_2.Reg, volatile.LoadUint32(&o.CORE_0_IRAM0_PMS_MONITOR_2.Reg)&^(0x18)|value<<3)
}
func (o *SENSITIVE_Type) GetCORE_0_IRAM0_PMS_MONITOR_2_CORE_0_IRAM0_PMS_MONITOR_VIOLATE_STATUS_WORLD() uint32 {
	return (volatile.LoadUint32(&o.CORE_0_IRAM0_PMS_MONITOR_2.Reg) & 0x18) >> 3
}
func (o *SENSITIVE_Type) SetCORE_0_IRAM0_PMS_MONITOR_2_CORE_0_IRAM0_PMS_MONITOR_VIOLATE_STATUS_ADDR(value uint32) {
	volatile.StoreUint32(&o.CORE_0_IRAM0_PMS_MONITOR_2.Reg, volatile.LoadUint32(&o.CORE_0_IRAM0_PMS_MONITOR_2.Reg)&^(0x1fffffe0)|value<<5)
}
func (o *SENSITIVE_Type) GetCORE_0_IRAM0_PMS_MONITOR_2_CORE_0_IRAM0_PMS_MONITOR_VIOLATE_STATUS_ADDR() uint32 {
	return (volatile.LoadUint32(&o.CORE_0_IRAM0_PMS_MONITOR_2.Reg) & 0x1fffffe0) >> 5
}

// SENSITIVE.CORE_X_DRAM0_PMS_CONSTRAIN_0: SENSITIVE_CORE_X_DRAM0_PMS_CONSTRAIN_0_REG
func (o *SENSITIVE_Type) SetCORE_X_DRAM0_PMS_CONSTRAIN_0_CORE_X_DRAM0_PMS_CONSTRAIN_LOCK(value uint32) {
	volatile.StoreUint32(&o.CORE_X_DRAM0_PMS_CONSTRAIN_0.Reg, volatile.LoadUint32(&o.CORE_X_DRAM0_PMS_CONSTRAIN_0.Reg)&^(0x1)|value)
}
func (o *SENSITIVE_Type) GetCORE_X_DRAM0_PMS_CONSTRAIN_0_CORE_X_DRAM0_PMS_CONSTRAIN_LOCK() uint32 {
	return volatile.LoadUint32(&o.CORE_X_DRAM0_PMS_CONSTRAIN_0.Reg) & 0x1
}

// SENSITIVE.CORE_X_DRAM0_PMS_CONSTRAIN_1: SENSITIVE_CORE_X_DRAM0_PMS_CONSTRAIN_1_REG
func (o *SENSITIVE_Type) SetCORE_X_DRAM0_PMS_CONSTRAIN_1_CORE_X_DRAM0_PMS_CONSTRAIN_SRAM_WORLD_0_PMS_0(value uint32) {
	volatile.StoreUint32(&o.CORE_X_DRAM0_PMS_CONSTRAIN_1.Reg, volatile.LoadUint32(&o.CORE_X_DRAM0_PMS_CONSTRAIN_1.Reg)&^(0x3)|value)
}
func (o *SENSITIVE_Type) GetCORE_X_DRAM0_PMS_CONSTRAIN_1_CORE_X_DRAM0_PMS_CONSTRAIN_SRAM_WORLD_0_PMS_0() uint32 {
	return volatile.LoadUint32(&o.CORE_X_DRAM0_PMS_CONSTRAIN_1.Reg) & 0x3
}
func (o *SENSITIVE_Type) SetCORE_X_DRAM0_PMS_CONSTRAIN_1_CORE_X_DRAM0_PMS_CONSTRAIN_SRAM_WORLD_0_PMS_1(value uint32) {
	volatile.StoreUint32(&o.CORE_X_DRAM0_PMS_CONSTRAIN_1.Reg, volatile.LoadUint32(&o.CORE_X_DRAM0_PMS_CONSTRAIN_1.Reg)&^(0xc)|value<<2)
}
func (o *SENSITIVE_Type) GetCORE_X_DRAM0_PMS_CONSTRAIN_1_CORE_X_DRAM0_PMS_CONSTRAIN_SRAM_WORLD_0_PMS_1() uint32 {
	return (volatile.LoadUint32(&o.CORE_X_DRAM0_PMS_CONSTRAIN_1.Reg) & 0xc) >> 2
}
func (o *SENSITIVE_Type) SetCORE_X_DRAM0_PMS_CONSTRAIN_1_CORE_X_DRAM0_PMS_CONSTRAIN_SRAM_WORLD_0_PMS_2(value uint32) {
	volatile.StoreUint32(&o.CORE_X_DRAM0_PMS_CONSTRAIN_1.Reg, volatile.LoadUint32(&o.CORE_X_DRAM0_PMS_CONSTRAIN_1.Reg)&^(0x30)|value<<4)
}
func (o *SENSITIVE_Type) GetCORE_X_DRAM0_PMS_CONSTRAIN_1_CORE_X_DRAM0_PMS_CONSTRAIN_SRAM_WORLD_0_PMS_2() uint32 {
	return (volatile.LoadUint32(&o.CORE_X_DRAM0_PMS_CONSTRAIN_1.Reg) & 0x30) >> 4
}
func (o *SENSITIVE_Type) SetCORE_X_DRAM0_PMS_CONSTRAIN_1_CORE_X_DRAM0_PMS_CONSTRAIN_SRAM_WORLD_0_PMS_3(value uint32) {
	volatile.StoreUint32(&o.CORE_X_DRAM0_PMS_CONSTRAIN_1.Reg, volatile.LoadUint32(&o.CORE_X_DRAM0_PMS_CONSTRAIN_1.Reg)&^(0xc0)|value<<6)
}
func (o *SENSITIVE_Type) GetCORE_X_DRAM0_PMS_CONSTRAIN_1_CORE_X_DRAM0_PMS_CONSTRAIN_SRAM_WORLD_0_PMS_3() uint32 {
	return (volatile.LoadUint32(&o.CORE_X_DRAM0_PMS_CONSTRAIN_1.Reg) & 0xc0) >> 6
}
func (o *SENSITIVE_Type) SetCORE_X_DRAM0_PMS_CONSTRAIN_1_CORE_X_DRAM0_PMS_CONSTRAIN_SRAM_WORLD_1_PMS_0(value uint32) {
	volatile.StoreUint32(&o.CORE_X_DRAM0_PMS_CONSTRAIN_1.Reg, volatile.LoadUint32(&o.CORE_X_DRAM0_PMS_CONSTRAIN_1.Reg)&^(0x3000)|value<<12)
}
func (o *SENSITIVE_Type) GetCORE_X_DRAM0_PMS_CONSTRAIN_1_CORE_X_DRAM0_PMS_CONSTRAIN_SRAM_WORLD_1_PMS_0() uint32 {
	return (volatile.LoadUint32(&o.CORE_X_DRAM0_PMS_CONSTRAIN_1.Reg) & 0x3000) >> 12
}
func (o *SENSITIVE_Type) SetCORE_X_DRAM0_PMS_CONSTRAIN_1_CORE_X_DRAM0_PMS_CONSTRAIN_SRAM_WORLD_1_PMS_1(value uint32) {
	volatile.StoreUint32(&o.CORE_X_DRAM0_PMS_CONSTRAIN_1.Reg, volatile.LoadUint32(&o.CORE_X_DRAM0_PMS_CONSTRAIN_1.Reg)&^(0xc000)|value<<14)
}
func (o *SENSITIVE_Type) GetCORE_X_DRAM0_PMS_CONSTRAIN_1_CORE_X_DRAM0_PMS_CONSTRAIN_SRAM_WORLD_1_PMS_1() uint32 {
	return (volatile.LoadUint32(&o.CORE_X_DRAM0_PMS_CONSTRAIN_1.Reg) & 0xc000) >> 14
}
func (o *SENSITIVE_Type) SetCORE_X_DRAM0_PMS_CONSTRAIN_1_CORE_X_DRAM0_PMS_CONSTRAIN_SRAM_WORLD_1_PMS_2(value uint32) {
	volatile.StoreUint32(&o.CORE_X_DRAM0_PMS_CONSTRAIN_1.Reg, volatile.LoadUint32(&o.CORE_X_DRAM0_PMS_CONSTRAIN_1.Reg)&^(0x30000)|value<<16)
}
func (o *SENSITIVE_Type) GetCORE_X_DRAM0_PMS_CONSTRAIN_1_CORE_X_DRAM0_PMS_CONSTRAIN_SRAM_WORLD_1_PMS_2() uint32 {
	return (volatile.LoadUint32(&o.CORE_X_DRAM0_PMS_CONSTRAIN_1.Reg) & 0x30000) >> 16
}
func (o *SENSITIVE_Type) SetCORE_X_DRAM0_PMS_CONSTRAIN_1_CORE_X_DRAM0_PMS_CONSTRAIN_SRAM_WORLD_1_PMS_3(value uint32) {
	volatile.StoreUint32(&o.CORE_X_DRAM0_PMS_CONSTRAIN_1.Reg, volatile.LoadUint32(&o.CORE_X_DRAM0_PMS_CONSTRAIN_1.Reg)&^(0xc0000)|value<<18)
}
func (o *SENSITIVE_Type) GetCORE_X_DRAM0_PMS_CONSTRAIN_1_CORE_X_DRAM0_PMS_CONSTRAIN_SRAM_WORLD_1_PMS_3() uint32 {
	return (volatile.LoadUint32(&o.CORE_X_DRAM0_PMS_CONSTRAIN_1.Reg) & 0xc0000) >> 18
}
func (o *SENSITIVE_Type) SetCORE_X_DRAM0_PMS_CONSTRAIN_1_CORE_X_DRAM0_PMS_CONSTRAIN_ROM_WORLD_0_PMS(value uint32) {
	volatile.StoreUint32(&o.CORE_X_DRAM0_PMS_CONSTRAIN_1.Reg, volatile.LoadUint32(&o.CORE_X_DRAM0_PMS_CONSTRAIN_1.Reg)&^(0x3000000)|value<<24)
}
func (o *SENSITIVE_Type) GetCORE_X_DRAM0_PMS_CONSTRAIN_1_CORE_X_DRAM0_PMS_CONSTRAIN_ROM_WORLD_0_PMS() uint32 {
	return (volatile.LoadUint32(&o.CORE_X_DRAM0_PMS_CONSTRAIN_1.Reg) & 0x3000000) >> 24
}
func (o *SENSITIVE_Type) SetCORE_X_DRAM0_PMS_CONSTRAIN_1_CORE_X_DRAM0_PMS_CONSTRAIN_ROM_WORLD_1_PMS(value uint32) {
	volatile.StoreUint32(&o.CORE_X_DRAM0_PMS_CONSTRAIN_1.Reg, volatile.LoadUint32(&o.CORE_X_DRAM0_PMS_CONSTRAIN_1.Reg)&^(0xc000000)|value<<26)
}
func (o *SENSITIVE_Type) GetCORE_X_DRAM0_PMS_CONSTRAIN_1_CORE_X_DRAM0_PMS_CONSTRAIN_ROM_WORLD_1_PMS() uint32 {
	return (volatile.LoadUint32(&o.CORE_X_DRAM0_PMS_CONSTRAIN_1.Reg) & 0xc000000) >> 26
}

// SENSITIVE.CORE_0_DRAM0_PMS_MONITOR_0: SENSITIVE_CORE_0_DRAM0_PMS_MONITOR_0_REG
func (o *SENSITIVE_Type) SetCORE_0_DRAM0_PMS_MONITOR_0_CORE_0_DRAM0_PMS_MONITOR_LOCK(value uint32) {
	volatile.StoreUint32(&o.CORE_0_DRAM0_PMS_MONITOR_0.Reg, volatile.LoadUint32(&o.CORE_0_DRAM0_PMS_MONITOR_0.Reg)&^(0x1)|value)
}
func (o *SENSITIVE_Type) GetCORE_0_DRAM0_PMS_MONITOR_0_CORE_0_DRAM0_PMS_MONITOR_LOCK() uint32 {
	return volatile.LoadUint32(&o.CORE_0_DRAM0_PMS_MONITOR_0.Reg) & 0x1
}

// SENSITIVE.CORE_0_DRAM0_PMS_MONITOR_1: SENSITIVE_CORE_0_DRAM0_PMS_MONITOR_1_REG
func (o *SENSITIVE_Type) SetCORE_0_DRAM0_PMS_MONITOR_1_CORE_0_DRAM0_PMS_MONITOR_VIOLATE_CLR(value uint32) {
	volatile.StoreUint32(&o.CORE_0_DRAM0_PMS_MONITOR_1.Reg, volatile.LoadUint32(&o.CORE_0_DRAM0_PMS_MONITOR_1.Reg)&^(0x1)|value)
}
func (o *SENSITIVE_Type) GetCORE_0_DRAM0_PMS_MONITOR_1_CORE_0_DRAM0_PMS_MONITOR_VIOLATE_CLR() uint32 {
	return volatile.LoadUint32(&o.CORE_0_DRAM0_PMS_MONITOR_1.Reg) & 0x1
}
func (o *SENSITIVE_Type) SetCORE_0_DRAM0_PMS_MONITOR_1_CORE_0_DRAM0_PMS_MONITOR_VIOLATE_EN(value uint32) {
	volatile.StoreUint32(&o.CORE_0_DRAM0_PMS_MONITOR_1.Reg, volatile.LoadUint32(&o.CORE_0_DRAM0_PMS_MONITOR_1.Reg)&^(0x2)|value<<1)
}
func (o *SENSITIVE_Type) GetCORE_0_DRAM0_PMS_MONITOR_1_CORE_0_DRAM0_PMS_MONITOR_VIOLATE_EN() uint32 {
	return (volatile.LoadUint32(&o.CORE_0_DRAM0_PMS_MONITOR_1.Reg) & 0x2) >> 1
}

// SENSITIVE.CORE_0_DRAM0_PMS_MONITOR_2: SENSITIVE_CORE_0_DRAM0_PMS_MONITOR_2_REG
func (o *SENSITIVE_Type) SetCORE_0_DRAM0_PMS_MONITOR_2_CORE_0_DRAM0_PMS_MONITOR_VIOLATE_INTR(value uint32) {
	volatile.StoreUint32(&o.CORE_0_DRAM0_PMS_MONITOR_2.Reg, volatile.LoadUint32(&o.CORE_0_DRAM0_PMS_MONITOR_2.Reg)&^(0x1)|value)
}
func (o *SENSITIVE_Type) GetCORE_0_DRAM0_PMS_MONITOR_2_CORE_0_DRAM0_PMS_MONITOR_VIOLATE_INTR() uint32 {
	return volatile.LoadUint32(&o.CORE_0_DRAM0_PMS_MONITOR_2.Reg) & 0x1
}
func (o *SENSITIVE_Type) SetCORE_0_DRAM0_PMS_MONITOR_2_CORE_0_DRAM0_PMS_MONITOR_VIOLATE_STATUS_LOCK(value uint32) {
	volatile.StoreUint32(&o.CORE_0_DRAM0_PMS_MONITOR_2.Reg, volatile.LoadUint32(&o.CORE_0_DRAM0_PMS_MONITOR_2.Reg)&^(0x2)|value<<1)
}
func (o *SENSITIVE_Type) GetCORE_0_DRAM0_PMS_MONITOR_2_CORE_0_DRAM0_PMS_MONITOR_VIOLATE_STATUS_LOCK() uint32 {
	return (volatile.LoadUint32(&o.CORE_0_DRAM0_PMS_MONITOR_2.Reg) & 0x2) >> 1
}
func (o *SENSITIVE_Type) SetCORE_0_DRAM0_PMS_MONITOR_2_CORE_0_DRAM0_PMS_MONITOR_VIOLATE_STATUS_WORLD(value uint32) {
	volatile.StoreUint32(&o.CORE_0_DRAM0_PMS_MONITOR_2.Reg, volatile.LoadUint32(&o.CORE_0_DRAM0_PMS_MONITOR_2.Reg)&^(0xc)|value<<2)
}
func (o *SENSITIVE_Type) GetCORE_0_DRAM0_PMS_MONITOR_2_CORE_0_DRAM0_PMS_MONITOR_VIOLATE_STATUS_WORLD() uint32 {
	return (volatile.LoadUint32(&o.CORE_0_DRAM0_PMS_MONITOR_2.Reg) & 0xc) >> 2
}
func (o *SENSITIVE_Type) SetCORE_0_DRAM0_PMS_MONITOR_2_CORE_0_DRAM0_PMS_MONITOR_VIOLATE_STATUS_ADDR(value uint32) {
	volatile.StoreUint32(&o.CORE_0_DRAM0_PMS_MONITOR_2.Reg, volatile.LoadUint32(&o.CORE_0_DRAM0_PMS_MONITOR_2.Reg)&^(0xffffff0)|value<<4)
}
func (o *SENSITIVE_Type) GetCORE_0_DRAM0_PMS_MONITOR_2_CORE_0_DRAM0_PMS_MONITOR_VIOLATE_STATUS_ADDR() uint32 {
	return (volatile.LoadUint32(&o.CORE_0_DRAM0_PMS_MONITOR_2.Reg) & 0xffffff0) >> 4
}

// SENSITIVE.CORE_0_DRAM0_PMS_MONITOR_3: SENSITIVE_CORE_0_DRAM0_PMS_MONITOR_3_REG
func (o *SENSITIVE_Type) SetCORE_0_DRAM0_PMS_MONITOR_3_CORE_0_DRAM0_PMS_MONITOR_VIOLATE_STATUS_WR(value uint32) {
	volatile.StoreUint32(&o.CORE_0_DRAM0_PMS_MONITOR_3.Reg, volatile.LoadUint32(&o.CORE_0_DRAM0_PMS_MONITOR_3.Reg)&^(0x1)|value)
}
func (o *SENSITIVE_Type) GetCORE_0_DRAM0_PMS_MONITOR_3_CORE_0_DRAM0_PMS_MONITOR_VIOLATE_STATUS_WR() uint32 {
	return volatile.LoadUint32(&o.CORE_0_DRAM0_PMS_MONITOR_3.Reg) & 0x1
}
func (o *SENSITIVE_Type) SetCORE_0_DRAM0_PMS_MONITOR_3_CORE_0_DRAM0_PMS_MONITOR_VIOLATE_STATUS_BYTEEN(value uint32) {
	volatile.StoreUint32(&o.CORE_0_DRAM0_PMS_MONITOR_3.Reg, volatile.LoadUint32(&o.CORE_0_DRAM0_PMS_MONITOR_3.Reg)&^(0x1e)|value<<1)
}
func (o *SENSITIVE_Type) GetCORE_0_DRAM0_PMS_MONITOR_3_CORE_0_DRAM0_PMS_MONITOR_VIOLATE_STATUS_BYTEEN() uint32 {
	return (volatile.LoadUint32(&o.CORE_0_DRAM0_PMS_MONITOR_3.Reg) & 0x1e) >> 1
}

// SENSITIVE.CORE_0_PIF_PMS_CONSTRAIN_0: SENSITIVE_CORE_0_PIF_PMS_CONSTRAIN_0_REG
func (o *SENSITIVE_Type) SetCORE_0_PIF_PMS_CONSTRAIN_0_CORE_0_PIF_PMS_CONSTRAIN_LOCK(value uint32) {
	volatile.StoreUint32(&o.CORE_0_PIF_PMS_CONSTRAIN_0.Reg, volatile.LoadUint32(&o.CORE_0_PIF_PMS_CONSTRAIN_0.Reg)&^(0x1)|value)
}
func (o *SENSITIVE_Type) GetCORE_0_PIF_PMS_CONSTRAIN_0_CORE_0_PIF_PMS_CONSTRAIN_LOCK() uint32 {
	return volatile.LoadUint32(&o.CORE_0_PIF_PMS_CONSTRAIN_0.Reg) & 0x1
}

// SENSITIVE.CORE_0_PIF_PMS_CONSTRAIN_1: SENSITIVE_CORE_0_PIF_PMS_CONSTRAIN_1_REG
func (o *SENSITIVE_Type) SetCORE_0_PIF_PMS_CONSTRAIN_1_CORE_0_PIF_PMS_CONSTRAIN_WORLD_0_UART(value uint32) {
	volatile.StoreUint32(&o.CORE_0_PIF_PMS_CONSTRAIN_1.Reg, volatile.LoadUint32(&o.CORE_0_PIF_PMS_CONSTRAIN_1.Reg)&^(0x3)|value)
}
func (o *SENSITIVE_Type) GetCORE_0_PIF_PMS_CONSTRAIN_1_CORE_0_PIF_PMS_CONSTRAIN_WORLD_0_UART() uint32 {
	return volatile.LoadUint32(&o.CORE_0_PIF_PMS_CONSTRAIN_1.Reg) & 0x3
}
func (o *SENSITIVE_Type) SetCORE_0_PIF_PMS_CONSTRAIN_1_CORE_0_PIF_PMS_CONSTRAIN_WORLD_0_G0SPI_1(value uint32) {
	volatile.StoreUint32(&o.CORE_0_PIF_PMS_CONSTRAIN_1.Reg, volatile.LoadUint32(&o.CORE_0_PIF_PMS_CONSTRAIN_1.Reg)&^(0xc)|value<<2)
}
func (o *SENSITIVE_Type) GetCORE_0_PIF_PMS_CONSTRAIN_1_CORE_0_PIF_PMS_CONSTRAIN_WORLD_0_G0SPI_1() uint32 {
	return (volatile.LoadUint32(&o.CORE_0_PIF_PMS_CONSTRAIN_1.Reg) & 0xc) >> 2
}
func (o *SENSITIVE_Type) SetCORE_0_PIF_PMS_CONSTRAIN_1_CORE_0_PIF_PMS_CONSTRAIN_WORLD_0_G0SPI_0(value uint32) {
	volatile.StoreUint32(&o.CORE_0_PIF_PMS_CONSTRAIN_1.Reg, volatile.LoadUint32(&o.CORE_0_PIF_PMS_CONSTRAIN_1.Reg)&^(0x30)|value<<4)
}
func (o *SENSITIVE_Type) GetCORE_0_PIF_PMS_CONSTRAIN_1_CORE_0_PIF_PMS_CONSTRAIN_WORLD_0_G0SPI_0() uint32 {
	return (volatile.LoadUint32(&o.CORE_0_PIF_PMS_CONSTRAIN_1.Reg) & 0x30) >> 4
}
func (o *SENSITIVE_Type) SetCORE_0_PIF_PMS_CONSTRAIN_1_CORE_0_PIF_PMS_CONSTRAIN_WORLD_0_GPIO(value uint32) {
	volatile.StoreUint32(&o.CORE_0_PIF_PMS_CONSTRAIN_1.Reg, volatile.LoadUint32(&o.CORE_0_PIF_PMS_CONSTRAIN_1.Reg)&^(0xc0)|value<<6)
}
func (o *SENSITIVE_Type) GetCORE_0_PIF_PMS_CONSTRAIN_1_CORE_0_PIF_PMS_CONSTRAIN_WORLD_0_GPIO() uint32 {
	return (volatile.LoadUint32(&o.CORE_0_PIF_PMS_CONSTRAIN_1.Reg) & 0xc0) >> 6
}
func (o *SENSITIVE_Type) SetCORE_0_PIF_PMS_CONSTRAIN_1_CORE_0_PIF_PMS_CONSTRAIN_WORLD_0_FE2(value uint32) {
	volatile.StoreUint32(&o.CORE_0_PIF_PMS_CONSTRAIN_1.Reg, volatile.LoadUint32(&o.CORE_0_PIF_PMS_CONSTRAIN_1.Reg)&^(0x300)|value<<8)
}
func (o *SENSITIVE_Type) GetCORE_0_PIF_PMS_CONSTRAIN_1_CORE_0_PIF_PMS_CONSTRAIN_WORLD_0_FE2() uint32 {
	return (volatile.LoadUint32(&o.CORE_0_PIF_PMS_CONSTRAIN_1.Reg) & 0x300) >> 8
}
func (o *SENSITIVE_Type) SetCORE_0_PIF_PMS_CONSTRAIN_1_CORE_0_PIF_PMS_CONSTRAIN_WORLD_0_FE(value uint32) {
	volatile.StoreUint32(&o.CORE_0_PIF_PMS_CONSTRAIN_1.Reg, volatile.LoadUint32(&o.CORE_0_PIF_PMS_CONSTRAIN_1.Reg)&^(0xc00)|value<<10)
}
func (o *SENSITIVE_Type) GetCORE_0_PIF_PMS_CONSTRAIN_1_CORE_0_PIF_PMS_CONSTRAIN_WORLD_0_FE() uint32 {
	return (volatile.LoadUint32(&o.CORE_0_PIF_PMS_CONSTRAIN_1.Reg) & 0xc00) >> 10
}
func (o *SENSITIVE_Type) SetCORE_0_PIF_PMS_CONSTRAIN_1_CORE_0_PIF_PMS_CONSTRAIN_WORLD_0_TIMER(value uint32) {
	volatile.StoreUint32(&o.CORE_0_PIF_PMS_CONSTRAIN_1.Reg, volatile.LoadUint32(&o.CORE_0_PIF_PMS_CONSTRAIN_1.Reg)&^(0x3000)|value<<12)
}
func (o *SENSITIVE_Type) GetCORE_0_PIF_PMS_CONSTRAIN_1_CORE_0_PIF_PMS_CONSTRAIN_WORLD_0_TIMER() uint32 {
	return (volatile.LoadUint32(&o.CORE_0_PIF_PMS_CONSTRAIN_1.Reg) & 0x3000) >> 12
}
func (o *SENSITIVE_Type) SetCORE_0_PIF_PMS_CONSTRAIN_1_CORE_0_PIF_PMS_CONSTRAIN_WORLD_0_RTC(value uint32) {
	volatile.StoreUint32(&o.CORE_0_PIF_PMS_CONSTRAIN_1.Reg, volatile.LoadUint32(&o.CORE_0_PIF_PMS_CONSTRAIN_1.Reg)&^(0xc000)|value<<14)
}
func (o *SENSITIVE_Type) GetCORE_0_PIF_PMS_CONSTRAIN_1_CORE_0_PIF_PMS_CONSTRAIN_WORLD_0_RTC() uint32 {
	return (volatile.LoadUint32(&o.CORE_0_PIF_PMS_CONSTRAIN_1.Reg) & 0xc000) >> 14
}
func (o *SENSITIVE_Type) SetCORE_0_PIF_PMS_CONSTRAIN_1_CORE_0_PIF_PMS_CONSTRAIN_WORLD_0_IO_MUX(value uint32) {
	volatile.StoreUint32(&o.CORE_0_PIF_PMS_CONSTRAIN_1.Reg, volatile.LoadUint32(&o.CORE_0_PIF_PMS_CONSTRAIN_1.Reg)&^(0x30000)|value<<16)
}
func (o *SENSITIVE_Type) GetCORE_0_PIF_PMS_CONSTRAIN_1_CORE_0_PIF_PMS_CONSTRAIN_WORLD_0_IO_MUX() uint32 {
	return (volatile.LoadUint32(&o.CORE_0_PIF_PMS_CONSTRAIN_1.Reg) & 0x30000) >> 16
}
func (o *SENSITIVE_Type) SetCORE_0_PIF_PMS_CONSTRAIN_1_CORE_0_PIF_PMS_CONSTRAIN_WORLD_0_WDG(value uint32) {
	volatile.StoreUint32(&o.CORE_0_PIF_PMS_CONSTRAIN_1.Reg, volatile.LoadUint32(&o.CORE_0_PIF_PMS_CONSTRAIN_1.Reg)&^(0xc0000)|value<<18)
}
func (o *SENSITIVE_Type) GetCORE_0_PIF_PMS_CONSTRAIN_1_CORE_0_PIF_PMS_CONSTRAIN_WORLD_0_WDG() uint32 {
	return (volatile.LoadUint32(&o.CORE_0_PIF_PMS_CONSTRAIN_1.Reg) & 0xc0000) >> 18
}
func (o *SENSITIVE_Type) SetCORE_0_PIF_PMS_CONSTRAIN_1_CORE_0_PIF_PMS_CONSTRAIN_WORLD_0_MISC(value uint32) {
	volatile.StoreUint32(&o.CORE_0_PIF_PMS_CONSTRAIN_1.Reg, volatile.LoadUint32(&o.CORE_0_PIF_PMS_CONSTRAIN_1.Reg)&^(0x3000000)|value<<24)
}
func (o *SENSITIVE_Type) GetCORE_0_PIF_PMS_CONSTRAIN_1_CORE_0_PIF_PMS_CONSTRAIN_WORLD_0_MISC() uint32 {
	return (volatile.LoadUint32(&o.CORE_0_PIF_PMS_CONSTRAIN_1.Reg) & 0x3000000) >> 24
}
func (o *SENSITIVE_Type) SetCORE_0_PIF_PMS_CONSTRAIN_1_CORE_0_PIF_PMS_CONSTRAIN_WORLD_0_I2C(value uint32) {
	volatile.StoreUint32(&o.CORE_0_PIF_PMS_CONSTRAIN_1.Reg, volatile.LoadUint32(&o.CORE_0_PIF_PMS_CONSTRAIN_1.Reg)&^(0xc000000)|value<<26)
}
func (o *SENSITIVE_Type) GetCORE_0_PIF_PMS_CONSTRAIN_1_CORE_0_PIF_PMS_CONSTRAIN_WORLD_0_I2C() uint32 {
	return (volatile.LoadUint32(&o.CORE_0_PIF_PMS_CONSTRAIN_1.Reg) & 0xc000000) >> 26
}
func (o *SENSITIVE_Type) SetCORE_0_PIF_PMS_CONSTRAIN_1_CORE_0_PIF_PMS_CONSTRAIN_WORLD_0_UART1(value uint32) {
	volatile.StoreUint32(&o.CORE_0_PIF_PMS_CONSTRAIN_1.Reg, volatile.LoadUint32(&o.CORE_0_PIF_PMS_CONSTRAIN_1.Reg)&^(0xc0000000)|value<<30)
}
func (o *SENSITIVE_Type) GetCORE_0_PIF_PMS_CONSTRAIN_1_CORE_0_PIF_PMS_CONSTRAIN_WORLD_0_UART1() uint32 {
	return (volatile.LoadUint32(&o.CORE_0_PIF_PMS_CONSTRAIN_1.Reg) & 0xc0000000) >> 30
}

// SENSITIVE.CORE_0_PIF_PMS_CONSTRAIN_2: SENSITIVE_CORE_0_PIF_PMS_CONSTRAIN_2_REG
func (o *SENSITIVE_Type) SetCORE_0_PIF_PMS_CONSTRAIN_2_CORE_0_PIF_PMS_CONSTRAIN_WORLD_0_BT(value uint32) {
	volatile.StoreUint32(&o.CORE_0_PIF_PMS_CONSTRAIN_2.Reg, volatile.LoadUint32(&o.CORE_0_PIF_PMS_CONSTRAIN_2.Reg)&^(0x3)|value)
}
func (o *SENSITIVE_Type) GetCORE_0_PIF_PMS_CONSTRAIN_2_CORE_0_PIF_PMS_CONSTRAIN_WORLD_0_BT() uint32 {
	return volatile.LoadUint32(&o.CORE_0_PIF_PMS_CONSTRAIN_2.Reg) & 0x3
}
func (o *SENSITIVE_Type) SetCORE_0_PIF_PMS_CONSTRAIN_2_CORE_0_PIF_PMS_CONSTRAIN_WORLD_0_I2C_EXT0(value uint32) {
	volatile.StoreUint32(&o.CORE_0_PIF_PMS_CONSTRAIN_2.Reg, volatile.LoadUint32(&o.CORE_0_PIF_PMS_CONSTRAIN_2.Reg)&^(0x30)|value<<4)
}
func (o *SENSITIVE_Type) GetCORE_0_PIF_PMS_CONSTRAIN_2_CORE_0_PIF_PMS_CONSTRAIN_WORLD_0_I2C_EXT0() uint32 {
	return (volatile.LoadUint32(&o.CORE_0_PIF_PMS_CONSTRAIN_2.Reg) & 0x30) >> 4
}
func (o *SENSITIVE_Type) SetCORE_0_PIF_PMS_CONSTRAIN_2_CORE_0_PIF_PMS_CONSTRAIN_WORLD_0_UHCI0(value uint32) {
	volatile.StoreUint32(&o.CORE_0_PIF_PMS_CONSTRAIN_2.Reg, volatile.LoadUint32(&o.CORE_0_PIF_PMS_CONSTRAIN_2.Reg)&^(0xc0)|value<<6)
}
func (o *SENSITIVE_Type) GetCORE_0_PIF_PMS_CONSTRAIN_2_CORE_0_PIF_PMS_CONSTRAIN_WORLD_0_UHCI0() uint32 {
	return (volatile.LoadUint32(&o.CORE_0_PIF_PMS_CONSTRAIN_2.Reg) & 0xc0) >> 6
}
func (o *SENSITIVE_Type) SetCORE_0_PIF_PMS_CONSTRAIN_2_CORE_0_PIF_PMS_CONSTRAIN_WORLD_0_RMT(value uint32) {
	volatile.StoreUint32(&o.CORE_0_PIF_PMS_CONSTRAIN_2.Reg, volatile.LoadUint32(&o.CORE_0_PIF_PMS_CONSTRAIN_2.Reg)&^(0xc00)|value<<10)
}
func (o *SENSITIVE_Type) GetCORE_0_PIF_PMS_CONSTRAIN_2_CORE_0_PIF_PMS_CONSTRAIN_WORLD_0_RMT() uint32 {
	return (volatile.LoadUint32(&o.CORE_0_PIF_PMS_CONSTRAIN_2.Reg) & 0xc00) >> 10
}
func (o *SENSITIVE_Type) SetCORE_0_PIF_PMS_CONSTRAIN_2_CORE_0_PIF_PMS_CONSTRAIN_WORLD_0_LEDC(value uint32) {
	volatile.StoreUint32(&o.CORE_0_PIF_PMS_CONSTRAIN_2.Reg, volatile.LoadUint32(&o.CORE_0_PIF_PMS_CONSTRAIN_2.Reg)&^(0x30000)|value<<16)
}
func (o *SENSITIVE_Type) GetCORE_0_PIF_PMS_CONSTRAIN_2_CORE_0_PIF_PMS_CONSTRAIN_WORLD_0_LEDC() uint32 {
	return (volatile.LoadUint32(&o.CORE_0_PIF_PMS_CONSTRAIN_2.Reg) & 0x30000) >> 16
}
func (o *SENSITIVE_Type) SetCORE_0_PIF_PMS_CONSTRAIN_2_CORE_0_PIF_PMS_CONSTRAIN_WORLD_0_BB(value uint32) {
	volatile.StoreUint32(&o.CORE_0_PIF_PMS_CONSTRAIN_2.Reg, volatile.LoadUint32(&o.CORE_0_PIF_PMS_CONSTRAIN_2.Reg)&^(0xc00000)|value<<22)
}
func (o *SENSITIVE_Type) GetCORE_0_PIF_PMS_CONSTRAIN_2_CORE_0_PIF_PMS_CONSTRAIN_WORLD_0_BB() uint32 {
	return (volatile.LoadUint32(&o.CORE_0_PIF_PMS_CONSTRAIN_2.Reg) & 0xc00000) >> 22
}
func (o *SENSITIVE_Type) SetCORE_0_PIF_PMS_CONSTRAIN_2_CORE_0_PIF_PMS_CONSTRAIN_WORLD_0_TIMERGROUP(value uint32) {
	volatile.StoreUint32(&o.CORE_0_PIF_PMS_CONSTRAIN_2.Reg, volatile.LoadUint32(&o.CORE_0_PIF_PMS_CONSTRAIN_2.Reg)&^(0xc000000)|value<<26)
}
func (o *SENSITIVE_Type) GetCORE_0_PIF_PMS_CONSTRAIN_2_CORE_0_PIF_PMS_CONSTRAIN_WORLD_0_TIMERGROUP() uint32 {
	return (volatile.LoadUint32(&o.CORE_0_PIF_PMS_CONSTRAIN_2.Reg) & 0xc000000) >> 26
}
func (o *SENSITIVE_Type) SetCORE_0_PIF_PMS_CONSTRAIN_2_CORE_0_PIF_PMS_CONSTRAIN_WORLD_0_TIMERGROUP1(value uint32) {
	volatile.StoreUint32(&o.CORE_0_PIF_PMS_CONSTRAIN_2.Reg, volatile.LoadUint32(&o.CORE_0_PIF_PMS_CONSTRAIN_2.Reg)&^(0x30000000)|value<<28)
}
func (o *SENSITIVE_Type) GetCORE_0_PIF_PMS_CONSTRAIN_2_CORE_0_PIF_PMS_CONSTRAIN_WORLD_0_TIMERGROUP1() uint32 {
	return (volatile.LoadUint32(&o.CORE_0_PIF_PMS_CONSTRAIN_2.Reg) & 0x30000000) >> 28
}
func (o *SENSITIVE_Type) SetCORE_0_PIF_PMS_CONSTRAIN_2_CORE_0_PIF_PMS_CONSTRAIN_WORLD_0_SYSTIMER(value uint32) {
	volatile.StoreUint32(&o.CORE_0_PIF_PMS_CONSTRAIN_2.Reg, volatile.LoadUint32(&o.CORE_0_PIF_PMS_CONSTRAIN_2.Reg)&^(0xc0000000)|value<<30)
}
func (o *SENSITIVE_Type) GetCORE_0_PIF_PMS_CONSTRAIN_2_CORE_0_PIF_PMS_CONSTRAIN_WORLD_0_SYSTIMER() uint32 {
	return (volatile.LoadUint32(&o.CORE_0_PIF_PMS_CONSTRAIN_2.Reg) & 0xc0000000) >> 30
}

// SENSITIVE.CORE_0_PIF_PMS_CONSTRAIN_3: SENSITIVE_CORE_0_PIF_PMS_CONSTRAIN_3_REG
func (o *SENSITIVE_Type) SetCORE_0_PIF_PMS_CONSTRAIN_3_CORE_0_PIF_PMS_CONSTRAIN_WORLD_0_SPI_2(value uint32) {
	volatile.StoreUint32(&o.CORE_0_PIF_PMS_CONSTRAIN_3.Reg, volatile.LoadUint32(&o.CORE_0_PIF_PMS_CONSTRAIN_3.Reg)&^(0x3)|value)
}
func (o *SENSITIVE_Type) GetCORE_0_PIF_PMS_CONSTRAIN_3_CORE_0_PIF_PMS_CONSTRAIN_WORLD_0_SPI_2() uint32 {
	return volatile.LoadUint32(&o.CORE_0_PIF_PMS_CONSTRAIN_3.Reg) & 0x3
}
func (o *SENSITIVE_Type) SetCORE_0_PIF_PMS_CONSTRAIN_3_CORE_0_PIF_PMS_CONSTRAIN_WORLD_0_APB_CTRL(value uint32) {
	volatile.StoreUint32(&o.CORE_0_PIF_PMS_CONSTRAIN_3.Reg, volatile.LoadUint32(&o.CORE_0_PIF_PMS_CONSTRAIN_3.Reg)&^(0x30)|value<<4)
}
func (o *SENSITIVE_Type) GetCORE_0_PIF_PMS_CONSTRAIN_3_CORE_0_PIF_PMS_CONSTRAIN_WORLD_0_APB_CTRL() uint32 {
	return (volatile.LoadUint32(&o.CORE_0_PIF_PMS_CONSTRAIN_3.Reg) & 0x30) >> 4
}
func (o *SENSITIVE_Type) SetCORE_0_PIF_PMS_CONSTRAIN_3_CORE_0_PIF_PMS_CONSTRAIN_WORLD_0_CAN(value uint32) {
	volatile.StoreUint32(&o.CORE_0_PIF_PMS_CONSTRAIN_3.Reg, volatile.LoadUint32(&o.CORE_0_PIF_PMS_CONSTRAIN_3.Reg)&^(0xc00)|value<<10)
}
func (o *SENSITIVE_Type) GetCORE_0_PIF_PMS_CONSTRAIN_3_CORE_0_PIF_PMS_CONSTRAIN_WORLD_0_CAN() uint32 {
	return (volatile.LoadUint32(&o.CORE_0_PIF_PMS_CONSTRAIN_3.Reg) & 0xc00) >> 10
}
func (o *SENSITIVE_Type) SetCORE_0_PIF_PMS_CONSTRAIN_3_CORE_0_PIF_PMS_CONSTRAIN_WORLD_0_I2S1(value uint32) {
	volatile.StoreUint32(&o.CORE_0_PIF_PMS_CONSTRAIN_3.Reg, volatile.LoadUint32(&o.CORE_0_PIF_PMS_CONSTRAIN_3.Reg)&^(0xc000)|value<<14)
}
func (o *SENSITIVE_Type) GetCORE_0_PIF_PMS_CONSTRAIN_3_CORE_0_PIF_PMS_CONSTRAIN_WORLD_0_I2S1() uint32 {
	return (volatile.LoadUint32(&o.CORE_0_PIF_PMS_CONSTRAIN_3.Reg) & 0xc000) >> 14
}
func (o *SENSITIVE_Type) SetCORE_0_PIF_PMS_CONSTRAIN_3_CORE_0_PIF_PMS_CONSTRAIN_WORLD_0_RWBT(value uint32) {
	volatile.StoreUint32(&o.CORE_0_PIF_PMS_CONSTRAIN_3.Reg, volatile.LoadUint32(&o.CORE_0_PIF_PMS_CONSTRAIN_3.Reg)&^(0xc00000)|value<<22)
}
func (o *SENSITIVE_Type) GetCORE_0_PIF_PMS_CONSTRAIN_3_CORE_0_PIF_PMS_CONSTRAIN_WORLD_0_RWBT() uint32 {
	return (volatile.LoadUint32(&o.CORE_0_PIF_PMS_CONSTRAIN_3.Reg) & 0xc00000) >> 22
}
func (o *SENSITIVE_Type) SetCORE_0_PIF_PMS_CONSTRAIN_3_CORE_0_PIF_PMS_CONSTRAIN_WORLD_0_WIFIMAC(value uint32) {
	volatile.StoreUint32(&o.CORE_0_PIF_PMS_CONSTRAIN_3.Reg, volatile.LoadUint32(&o.CORE_0_PIF_PMS_CONSTRAIN_3.Reg)&^(0xc000000)|value<<26)
}
func (o *SENSITIVE_Type) GetCORE_0_PIF_PMS_CONSTRAIN_3_CORE_0_PIF_PMS_CONSTRAIN_WORLD_0_WIFIMAC() uint32 {
	return (volatile.LoadUint32(&o.CORE_0_PIF_PMS_CONSTRAIN_3.Reg) & 0xc000000) >> 26
}
func (o *SENSITIVE_Type) SetCORE_0_PIF_PMS_CONSTRAIN_3_CORE_0_PIF_PMS_CONSTRAIN_WORLD_0_PWR(value uint32) {
	volatile.StoreUint32(&o.CORE_0_PIF_PMS_CONSTRAIN_3.Reg, volatile.LoadUint32(&o.CORE_0_PIF_PMS_CONSTRAIN_3.Reg)&^(0x30000000)|value<<28)
}
func (o *SENSITIVE_Type) GetCORE_0_PIF_PMS_CONSTRAIN_3_CORE_0_PIF_PMS_CONSTRAIN_WORLD_0_PWR() uint32 {
	return (volatile.LoadUint32(&o.CORE_0_PIF_PMS_CONSTRAIN_3.Reg) & 0x30000000) >> 28
}

// SENSITIVE.CORE_0_PIF_PMS_CONSTRAIN_4: SENSITIVE_CORE_0_PIF_PMS_CONSTRAIN_4_REG
func (o *SENSITIVE_Type) SetCORE_0_PIF_PMS_CONSTRAIN_4_CORE_0_PIF_PMS_CONSTRAIN_WORLD_0_USB_WRAP(value uint32) {
	volatile.StoreUint32(&o.CORE_0_PIF_PMS_CONSTRAIN_4.Reg, volatile.LoadUint32(&o.CORE_0_PIF_PMS_CONSTRAIN_4.Reg)&^(0xc)|value<<2)
}
func (o *SENSITIVE_Type) GetCORE_0_PIF_PMS_CONSTRAIN_4_CORE_0_PIF_PMS_CONSTRAIN_WORLD_0_USB_WRAP() uint32 {
	return (volatile.LoadUint32(&o.CORE_0_PIF_PMS_CONSTRAIN_4.Reg) & 0xc) >> 2
}
func (o *SENSITIVE_Type) SetCORE_0_PIF_PMS_CONSTRAIN_4_CORE_0_PIF_PMS_CONSTRAIN_WORLD_0_CRYPTO_PERI(value uint32) {
	volatile.StoreUint32(&o.CORE_0_PIF_PMS_CONSTRAIN_4.Reg, volatile.LoadUint32(&o.CORE_0_PIF_PMS_CONSTRAIN_4.Reg)&^(0x30)|value<<4)
}
func (o *SENSITIVE_Type) GetCORE_0_PIF_PMS_CONSTRAIN_4_CORE_0_PIF_PMS_CONSTRAIN_WORLD_0_CRYPTO_PERI() uint32 {
	return (volatile.LoadUint32(&o.CORE_0_PIF_PMS_CONSTRAIN_4.Reg) & 0x30) >> 4
}
func (o *SENSITIVE_Type) SetCORE_0_PIF_PMS_CONSTRAIN_4_CORE_0_PIF_PMS_CONSTRAIN_WORLD_0_CRYPTO_DMA(value uint32) {
	volatile.StoreUint32(&o.CORE_0_PIF_PMS_CONSTRAIN_4.Reg, volatile.LoadUint32(&o.CORE_0_PIF_PMS_CONSTRAIN_4.Reg)&^(0xc0)|value<<6)
}
func (o *SENSITIVE_Type) GetCORE_0_PIF_PMS_CONSTRAIN_4_CORE_0_PIF_PMS_CONSTRAIN_WORLD_0_CRYPTO_DMA() uint32 {
	return (volatile.LoadUint32(&o.CORE_0_PIF_PMS_CONSTRAIN_4.Reg) & 0xc0) >> 6
}
func (o *SENSITIVE_Type) SetCORE_0_PIF_PMS_CONSTRAIN_4_CORE_0_PIF_PMS_CONSTRAIN_WORLD_0_APB_ADC(value uint32) {
	volatile.StoreUint32(&o.CORE_0_PIF_PMS_CONSTRAIN_4.Reg, volatile.LoadUint32(&o.CORE_0_PIF_PMS_CONSTRAIN_4.Reg)&^(0x300)|value<<8)
}
func (o *SENSITIVE_Type) GetCORE_0_PIF_PMS_CONSTRAIN_4_CORE_0_PIF_PMS_CONSTRAIN_WORLD_0_APB_ADC() uint32 {
	return (volatile.LoadUint32(&o.CORE_0_PIF_PMS_CONSTRAIN_4.Reg) & 0x300) >> 8
}
func (o *SENSITIVE_Type) SetCORE_0_PIF_PMS_CONSTRAIN_4_CORE_0_PIF_PMS_CONSTRAIN_WORLD_0_BT_PWR(value uint32) {
	volatile.StoreUint32(&o.CORE_0_PIF_PMS_CONSTRAIN_4.Reg, volatile.LoadUint32(&o.CORE_0_PIF_PMS_CONSTRAIN_4.Reg)&^(0x3000)|value<<12)
}
func (o *SENSITIVE_Type) GetCORE_0_PIF_PMS_CONSTRAIN_4_CORE_0_PIF_PMS_CONSTRAIN_WORLD_0_BT_PWR() uint32 {
	return (volatile.LoadUint32(&o.CORE_0_PIF_PMS_CONSTRAIN_4.Reg) & 0x3000) >> 12
}
func (o *SENSITIVE_Type) SetCORE_0_PIF_PMS_CONSTRAIN_4_CORE_0_PIF_PMS_CONSTRAIN_WORLD_0_USB_DEVICE(value uint32) {
	volatile.StoreUint32(&o.CORE_0_PIF_PMS_CONSTRAIN_4.Reg, volatile.LoadUint32(&o.CORE_0_PIF_PMS_CONSTRAIN_4.Reg)&^(0xc000)|value<<14)
}
func (o *SENSITIVE_Type) GetCORE_0_PIF_PMS_CONSTRAIN_4_CORE_0_PIF_PMS_CONSTRAIN_WORLD_0_USB_DEVICE() uint32 {
	return (volatile.LoadUint32(&o.CORE_0_PIF_PMS_CONSTRAIN_4.Reg) & 0xc000) >> 14
}
func (o *SENSITIVE_Type) SetCORE_0_PIF_PMS_CONSTRAIN_4_CORE_0_PIF_PMS_CONSTRAIN_WORLD_0_SYSTEM(value uint32) {
	volatile.StoreUint32(&o.CORE_0_PIF_PMS_CONSTRAIN_4.Reg, volatile.LoadUint32(&o.CORE_0_PIF_PMS_CONSTRAIN_4.Reg)&^(0x30000)|value<<16)
}
func (o *SENSITIVE_Type) GetCORE_0_PIF_PMS_CONSTRAIN_4_CORE_0_PIF_PMS_CONSTRAIN_WORLD_0_SYSTEM() uint32 {
	return (volatile.LoadUint32(&o.CORE_0_PIF_PMS_CONSTRAIN_4.Reg) & 0x30000) >> 16
}
func (o *SENSITIVE_Type) SetCORE_0_PIF_PMS_CONSTRAIN_4_CORE_0_PIF_PMS_CONSTRAIN_WORLD_0_SENSITIVE(value uint32) {
	volatile.StoreUint32(&o.CORE_0_PIF_PMS_CONSTRAIN_4.Reg, volatile.LoadUint32(&o.CORE_0_PIF_PMS_CONSTRAIN_4.Reg)&^(0xc0000)|value<<18)
}
func (o *SENSITIVE_Type) GetCORE_0_PIF_PMS_CONSTRAIN_4_CORE_0_PIF_PMS_CONSTRAIN_WORLD_0_SENSITIVE() uint32 {
	return (volatile.LoadUint32(&o.CORE_0_PIF_PMS_CONSTRAIN_4.Reg) & 0xc0000) >> 18
}
func (o *SENSITIVE_Type) SetCORE_0_PIF_PMS_CONSTRAIN_4_CORE_0_PIF_PMS_CONSTRAIN_WORLD_0_INTERRUPT(value uint32) {
	volatile.StoreUint32(&o.CORE_0_PIF_PMS_CONSTRAIN_4.Reg, volatile.LoadUint32(&o.CORE_0_PIF_PMS_CONSTRAIN_4.Reg)&^(0x300000)|value<<20)
}
func (o *SENSITIVE_Type) GetCORE_0_PIF_PMS_CONSTRAIN_4_CORE_0_PIF_PMS_CONSTRAIN_WORLD_0_INTERRUPT() uint32 {
	return (volatile.LoadUint32(&o.CORE_0_PIF_PMS_CONSTRAIN_4.Reg) & 0x300000) >> 20
}
func (o *SENSITIVE_Type) SetCORE_0_PIF_PMS_CONSTRAIN_4_CORE_0_PIF_PMS_CONSTRAIN_WORLD_0_DMA_COPY(value uint32) {
	volatile.StoreUint32(&o.CORE_0_PIF_PMS_CONSTRAIN_4.Reg, volatile.LoadUint32(&o.CORE_0_PIF_PMS_CONSTRAIN_4.Reg)&^(0xc00000)|value<<22)
}
func (o *SENSITIVE_Type) GetCORE_0_PIF_PMS_CONSTRAIN_4_CORE_0_PIF_PMS_CONSTRAIN_WORLD_0_DMA_COPY() uint32 {
	return (volatile.LoadUint32(&o.CORE_0_PIF_PMS_CONSTRAIN_4.Reg) & 0xc00000) >> 22
}
func (o *SENSITIVE_Type) SetCORE_0_PIF_PMS_CONSTRAIN_4_CORE_0_PIF_PMS_CONSTRAIN_WORLD_0_CACHE_CONFIG(value uint32) {
	volatile.StoreUint32(&o.CORE_0_PIF_PMS_CONSTRAIN_4.Reg, volatile.LoadUint32(&o.CORE_0_PIF_PMS_CONSTRAIN_4.Reg)&^(0x3000000)|value<<24)
}
func (o *SENSITIVE_Type) GetCORE_0_PIF_PMS_CONSTRAIN_4_CORE_0_PIF_PMS_CONSTRAIN_WORLD_0_CACHE_CONFIG() uint32 {
	return (volatile.LoadUint32(&o.CORE_0_PIF_PMS_CONSTRAIN_4.Reg) & 0x3000000) >> 24
}
func (o *SENSITIVE_Type) SetCORE_0_PIF_PMS_CONSTRAIN_4_CORE_0_PIF_PMS_CONSTRAIN_WORLD_0_AD(value uint32) {
	volatile.StoreUint32(&o.CORE_0_PIF_PMS_CONSTRAIN_4.Reg, volatile.LoadUint32(&o.CORE_0_PIF_PMS_CONSTRAIN_4.Reg)&^(0xc000000)|value<<26)
}
func (o *SENSITIVE_Type) GetCORE_0_PIF_PMS_CONSTRAIN_4_CORE_0_PIF_PMS_CONSTRAIN_WORLD_0_AD() uint32 {
	return (volatile.LoadUint32(&o.CORE_0_PIF_PMS_CONSTRAIN_4.Reg) & 0xc000000) >> 26
}
func (o *SENSITIVE_Type) SetCORE_0_PIF_PMS_CONSTRAIN_4_CORE_0_PIF_PMS_CONSTRAIN_WORLD_0_DIO(value uint32) {
	volatile.StoreUint32(&o.CORE_0_PIF_PMS_CONSTRAIN_4.Reg, volatile.LoadUint32(&o.CORE_0_PIF_PMS_CONSTRAIN_4.Reg)&^(0x30000000)|value<<28)
}
func (o *SENSITIVE_Type) GetCORE_0_PIF_PMS_CONSTRAIN_4_CORE_0_PIF_PMS_CONSTRAIN_WORLD_0_DIO() uint32 {
	return (volatile.LoadUint32(&o.CORE_0_PIF_PMS_CONSTRAIN_4.Reg) & 0x30000000) >> 28
}
func (o *SENSITIVE_Type) SetCORE_0_PIF_PMS_CONSTRAIN_4_CORE_0_PIF_PMS_CONSTRAIN_WORLD_0_WORLD_CONTROLLER(value uint32) {
	volatile.StoreUint32(&o.CORE_0_PIF_PMS_CONSTRAIN_4.Reg, volatile.LoadUint32(&o.CORE_0_PIF_PMS_CONSTRAIN_4.Reg)&^(0xc0000000)|value<<30)
}
func (o *SENSITIVE_Type) GetCORE_0_PIF_PMS_CONSTRAIN_4_CORE_0_PIF_PMS_CONSTRAIN_WORLD_0_WORLD_CONTROLLER() uint32 {
	return (volatile.LoadUint32(&o.CORE_0_PIF_PMS_CONSTRAIN_4.Reg) & 0xc0000000) >> 30
}

// SENSITIVE.CORE_0_PIF_PMS_CONSTRAIN_5: SENSITIVE_CORE_0_PIF_PMS_CONSTRAIN_5_REG
func (o *SENSITIVE_Type) SetCORE_0_PIF_PMS_CONSTRAIN_5_CORE_0_PIF_PMS_CONSTRAIN_WORLD_1_UART(value uint32) {
	volatile.StoreUint32(&o.CORE_0_PIF_PMS_CONSTRAIN_5.Reg, volatile.LoadUint32(&o.CORE_0_PIF_PMS_CONSTRAIN_5.Reg)&^(0x3)|value)
}
func (o *SENSITIVE_Type) GetCORE_0_PIF_PMS_CONSTRAIN_5_CORE_0_PIF_PMS_CONSTRAIN_WORLD_1_UART() uint32 {
	return volatile.LoadUint32(&o.CORE_0_PIF_PMS_CONSTRAIN_5.Reg) & 0x3
}
func (o *SENSITIVE_Type) SetCORE_0_PIF_PMS_CONSTRAIN_5_CORE_0_PIF_PMS_CONSTRAIN_WORLD_1_G0SPI_1(value uint32) {
	volatile.StoreUint32(&o.CORE_0_PIF_PMS_CONSTRAIN_5.Reg, volatile.LoadUint32(&o.CORE_0_PIF_PMS_CONSTRAIN_5.Reg)&^(0xc)|value<<2)
}
func (o *SENSITIVE_Type) GetCORE_0_PIF_PMS_CONSTRAIN_5_CORE_0_PIF_PMS_CONSTRAIN_WORLD_1_G0SPI_1() uint32 {
	return (volatile.LoadUint32(&o.CORE_0_PIF_PMS_CONSTRAIN_5.Reg) & 0xc) >> 2
}
func (o *SENSITIVE_Type) SetCORE_0_PIF_PMS_CONSTRAIN_5_CORE_0_PIF_PMS_CONSTRAIN_WORLD_1_G0SPI_0(value uint32) {
	volatile.StoreUint32(&o.CORE_0_PIF_PMS_CONSTRAIN_5.Reg, volatile.LoadUint32(&o.CORE_0_PIF_PMS_CONSTRAIN_5.Reg)&^(0x30)|value<<4)
}
func (o *SENSITIVE_Type) GetCORE_0_PIF_PMS_CONSTRAIN_5_CORE_0_PIF_PMS_CONSTRAIN_WORLD_1_G0SPI_0() uint32 {
	return (volatile.LoadUint32(&o.CORE_0_PIF_PMS_CONSTRAIN_5.Reg) & 0x30) >> 4
}
func (o *SENSITIVE_Type) SetCORE_0_PIF_PMS_CONSTRAIN_5_CORE_0_PIF_PMS_CONSTRAIN_WORLD_1_GPIO(value uint32) {
	volatile.StoreUint32(&o.CORE_0_PIF_PMS_CONSTRAIN_5.Reg, volatile.LoadUint32(&o.CORE_0_PIF_PMS_CONSTRAIN_5.Reg)&^(0xc0)|value<<6)
}
func (o *SENSITIVE_Type) GetCORE_0_PIF_PMS_CONSTRAIN_5_CORE_0_PIF_PMS_CONSTRAIN_WORLD_1_GPIO() uint32 {
	return (volatile.LoadUint32(&o.CORE_0_PIF_PMS_CONSTRAIN_5.Reg) & 0xc0) >> 6
}
func (o *SENSITIVE_Type) SetCORE_0_PIF_PMS_CONSTRAIN_5_CORE_0_PIF_PMS_CONSTRAIN_WORLD_1_FE2(value uint32) {
	volatile.StoreUint32(&o.CORE_0_PIF_PMS_CONSTRAIN_5.Reg, volatile.LoadUint32(&o.CORE_0_PIF_PMS_CONSTRAIN_5.Reg)&^(0x300)|value<<8)
}
func (o *SENSITIVE_Type) GetCORE_0_PIF_PMS_CONSTRAIN_5_CORE_0_PIF_PMS_CONSTRAIN_WORLD_1_FE2() uint32 {
	return (volatile.LoadUint32(&o.CORE_0_PIF_PMS_CONSTRAIN_5.Reg) & 0x300) >> 8
}
func (o *SENSITIVE_Type) SetCORE_0_PIF_PMS_CONSTRAIN_5_CORE_0_PIF_PMS_CONSTRAIN_WORLD_1_FE(value uint32) {
	volatile.StoreUint32(&o.CORE_0_PIF_PMS_CONSTRAIN_5.Reg, volatile.LoadUint32(&o.CORE_0_PIF_PMS_CONSTRAIN_5.Reg)&^(0xc00)|value<<10)
}
func (o *SENSITIVE_Type) GetCORE_0_PIF_PMS_CONSTRAIN_5_CORE_0_PIF_PMS_CONSTRAIN_WORLD_1_FE() uint32 {
	return (volatile.LoadUint32(&o.CORE_0_PIF_PMS_CONSTRAIN_5.Reg) & 0xc00) >> 10
}
func (o *SENSITIVE_Type) SetCORE_0_PIF_PMS_CONSTRAIN_5_CORE_0_PIF_PMS_CONSTRAIN_WORLD_1_TIMER(value uint32) {
	volatile.StoreUint32(&o.CORE_0_PIF_PMS_CONSTRAIN_5.Reg, volatile.LoadUint32(&o.CORE_0_PIF_PMS_CONSTRAIN_5.Reg)&^(0x3000)|value<<12)
}
func (o *SENSITIVE_Type) GetCORE_0_PIF_PMS_CONSTRAIN_5_CORE_0_PIF_PMS_CONSTRAIN_WORLD_1_TIMER() uint32 {
	return (volatile.LoadUint32(&o.CORE_0_PIF_PMS_CONSTRAIN_5.Reg) & 0x3000) >> 12
}
func (o *SENSITIVE_Type) SetCORE_0_PIF_PMS_CONSTRAIN_5_CORE_0_PIF_PMS_CONSTRAIN_WORLD_1_RTC(value uint32) {
	volatile.StoreUint32(&o.CORE_0_PIF_PMS_CONSTRAIN_5.Reg, volatile.LoadUint32(&o.CORE_0_PIF_PMS_CONSTRAIN_5.Reg)&^(0xc000)|value<<14)
}
func (o *SENSITIVE_Type) GetCORE_0_PIF_PMS_CONSTRAIN_5_CORE_0_PIF_PMS_CONSTRAIN_WORLD_1_RTC() uint32 {
	return (volatile.LoadUint32(&o.CORE_0_PIF_PMS_CONSTRAIN_5.Reg) & 0xc000) >> 14
}
func (o *SENSITIVE_Type) SetCORE_0_PIF_PMS_CONSTRAIN_5_CORE_0_PIF_PMS_CONSTRAIN_WORLD_1_IO_MUX(value uint32) {
	volatile.StoreUint32(&o.CORE_0_PIF_PMS_CONSTRAIN_5.Reg, volatile.LoadUint32(&o.CORE_0_PIF_PMS_CONSTRAIN_5.Reg)&^(0x30000)|value<<16)
}
func (o *SENSITIVE_Type) GetCORE_0_PIF_PMS_CONSTRAIN_5_CORE_0_PIF_PMS_CONSTRAIN_WORLD_1_IO_MUX() uint32 {
	return (volatile.LoadUint32(&o.CORE_0_PIF_PMS_CONSTRAIN_5.Reg) & 0x30000) >> 16
}
func (o *SENSITIVE_Type) SetCORE_0_PIF_PMS_CONSTRAIN_5_CORE_0_PIF_PMS_CONSTRAIN_WORLD_1_WDG(value uint32) {
	volatile.StoreUint32(&o.CORE_0_PIF_PMS_CONSTRAIN_5.Reg, volatile.LoadUint32(&o.CORE_0_PIF_PMS_CONSTRAIN_5.Reg)&^(0xc0000)|value<<18)
}
func (o *SENSITIVE_Type) GetCORE_0_PIF_PMS_CONSTRAIN_5_CORE_0_PIF_PMS_CONSTRAIN_WORLD_1_WDG() uint32 {
	return (volatile.LoadUint32(&o.CORE_0_PIF_PMS_CONSTRAIN_5.Reg) & 0xc0000) >> 18
}
func (o *SENSITIVE_Type) SetCORE_0_PIF_PMS_CONSTRAIN_5_CORE_0_PIF_PMS_CONSTRAIN_WORLD_1_MISC(value uint32) {
	volatile.StoreUint32(&o.CORE_0_PIF_PMS_CONSTRAIN_5.Reg, volatile.LoadUint32(&o.CORE_0_PIF_PMS_CONSTRAIN_5.Reg)&^(0x3000000)|value<<24)
}
func (o *SENSITIVE_Type) GetCORE_0_PIF_PMS_CONSTRAIN_5_CORE_0_PIF_PMS_CONSTRAIN_WORLD_1_MISC() uint32 {
	return (volatile.LoadUint32(&o.CORE_0_PIF_PMS_CONSTRAIN_5.Reg) & 0x3000000) >> 24
}
func (o *SENSITIVE_Type) SetCORE_0_PIF_PMS_CONSTRAIN_5_CORE_0_PIF_PMS_CONSTRAIN_WORLD_1_I2C(value uint32) {
	volatile.StoreUint32(&o.CORE_0_PIF_PMS_CONSTRAIN_5.Reg, volatile.LoadUint32(&o.CORE_0_PIF_PMS_CONSTRAIN_5.Reg)&^(0xc000000)|value<<26)
}
func (o *SENSITIVE_Type) GetCORE_0_PIF_PMS_CONSTRAIN_5_CORE_0_PIF_PMS_CONSTRAIN_WORLD_1_I2C() uint32 {
	return (volatile.LoadUint32(&o.CORE_0_PIF_PMS_CONSTRAIN_5.Reg) & 0xc000000) >> 26
}
func (o *SENSITIVE_Type) SetCORE_0_PIF_PMS_CONSTRAIN_5_CORE_0_PIF_PMS_CONSTRAIN_WORLD_1_UART1(value uint32) {
	volatile.StoreUint32(&o.CORE_0_PIF_PMS_CONSTRAIN_5.Reg, volatile.LoadUint32(&o.CORE_0_PIF_PMS_CONSTRAIN_5.Reg)&^(0xc0000000)|value<<30)
}
func (o *SENSITIVE_Type) GetCORE_0_PIF_PMS_CONSTRAIN_5_CORE_0_PIF_PMS_CONSTRAIN_WORLD_1_UART1() uint32 {
	return (volatile.LoadUint32(&o.CORE_0_PIF_PMS_CONSTRAIN_5.Reg) & 0xc0000000) >> 30
}

// SENSITIVE.CORE_0_PIF_PMS_CONSTRAIN_6: SENSITIVE_CORE_0_PIF_PMS_CONSTRAIN_6_REG
func (o *SENSITIVE_Type) SetCORE_0_PIF_PMS_CONSTRAIN_6_CORE_0_PIF_PMS_CONSTRAIN_WORLD_1_BT(value uint32) {
	volatile.StoreUint32(&o.CORE_0_PIF_PMS_CONSTRAIN_6.Reg, volatile.LoadUint32(&o.CORE_0_PIF_PMS_CONSTRAIN_6.Reg)&^(0x3)|value)
}
func (o *SENSITIVE_Type) GetCORE_0_PIF_PMS_CONSTRAIN_6_CORE_0_PIF_PMS_CONSTRAIN_WORLD_1_BT() uint32 {
	return volatile.LoadUint32(&o.CORE_0_PIF_PMS_CONSTRAIN_6.Reg) & 0x3
}
func (o *SENSITIVE_Type) SetCORE_0_PIF_PMS_CONSTRAIN_6_CORE_0_PIF_PMS_CONSTRAIN_WORLD_1_I2C_EXT0(value uint32) {
	volatile.StoreUint32(&o.CORE_0_PIF_PMS_CONSTRAIN_6.Reg, volatile.LoadUint32(&o.CORE_0_PIF_PMS_CONSTRAIN_6.Reg)&^(0x30)|value<<4)
}
func (o *SENSITIVE_Type) GetCORE_0_PIF_PMS_CONSTRAIN_6_CORE_0_PIF_PMS_CONSTRAIN_WORLD_1_I2C_EXT0() uint32 {
	return (volatile.LoadUint32(&o.CORE_0_PIF_PMS_CONSTRAIN_6.Reg) & 0x30) >> 4
}
func (o *SENSITIVE_Type) SetCORE_0_PIF_PMS_CONSTRAIN_6_CORE_0_PIF_PMS_CONSTRAIN_WORLD_1_UHCI0(value uint32) {
	volatile.StoreUint32(&o.CORE_0_PIF_PMS_CONSTRAIN_6.Reg, volatile.LoadUint32(&o.CORE_0_PIF_PMS_CONSTRAIN_6.Reg)&^(0xc0)|value<<6)
}
func (o *SENSITIVE_Type) GetCORE_0_PIF_PMS_CONSTRAIN_6_CORE_0_PIF_PMS_CONSTRAIN_WORLD_1_UHCI0() uint32 {
	return (volatile.LoadUint32(&o.CORE_0_PIF_PMS_CONSTRAIN_6.Reg) & 0xc0) >> 6
}
func (o *SENSITIVE_Type) SetCORE_0_PIF_PMS_CONSTRAIN_6_CORE_0_PIF_PMS_CONSTRAIN_WORLD_1_RMT(value uint32) {
	volatile.StoreUint32(&o.CORE_0_PIF_PMS_CONSTRAIN_6.Reg, volatile.LoadUint32(&o.CORE_0_PIF_PMS_CONSTRAIN_6.Reg)&^(0xc00)|value<<10)
}
func (o *SENSITIVE_Type) GetCORE_0_PIF_PMS_CONSTRAIN_6_CORE_0_PIF_PMS_CONSTRAIN_WORLD_1_RMT() uint32 {
	return (volatile.LoadUint32(&o.CORE_0_PIF_PMS_CONSTRAIN_6.Reg) & 0xc00) >> 10
}
func (o *SENSITIVE_Type) SetCORE_0_PIF_PMS_CONSTRAIN_6_CORE_0_PIF_PMS_CONSTRAIN_WORLD_1_LEDC(value uint32) {
	volatile.StoreUint32(&o.CORE_0_PIF_PMS_CONSTRAIN_6.Reg, volatile.LoadUint32(&o.CORE_0_PIF_PMS_CONSTRAIN_6.Reg)&^(0x30000)|value<<16)
}
func (o *SENSITIVE_Type) GetCORE_0_PIF_PMS_CONSTRAIN_6_CORE_0_PIF_PMS_CONSTRAIN_WORLD_1_LEDC() uint32 {
	return (volatile.LoadUint32(&o.CORE_0_PIF_PMS_CONSTRAIN_6.Reg) & 0x30000) >> 16
}
func (o *SENSITIVE_Type) SetCORE_0_PIF_PMS_CONSTRAIN_6_CORE_0_PIF_PMS_CONSTRAIN_WORLD_1_BB(value uint32) {
	volatile.StoreUint32(&o.CORE_0_PIF_PMS_CONSTRAIN_6.Reg, volatile.LoadUint32(&o.CORE_0_PIF_PMS_CONSTRAIN_6.Reg)&^(0xc00000)|value<<22)
}
func (o *SENSITIVE_Type) GetCORE_0_PIF_PMS_CONSTRAIN_6_CORE_0_PIF_PMS_CONSTRAIN_WORLD_1_BB() uint32 {
	return (volatile.LoadUint32(&o.CORE_0_PIF_PMS_CONSTRAIN_6.Reg) & 0xc00000) >> 22
}
func (o *SENSITIVE_Type) SetCORE_0_PIF_PMS_CONSTRAIN_6_CORE_0_PIF_PMS_CONSTRAIN_WORLD_1_TIMERGROUP(value uint32) {
	volatile.StoreUint32(&o.CORE_0_PIF_PMS_CONSTRAIN_6.Reg, volatile.LoadUint32(&o.CORE_0_PIF_PMS_CONSTRAIN_6.Reg)&^(0xc000000)|value<<26)
}
func (o *SENSITIVE_Type) GetCORE_0_PIF_PMS_CONSTRAIN_6_CORE_0_PIF_PMS_CONSTRAIN_WORLD_1_TIMERGROUP() uint32 {
	return (volatile.LoadUint32(&o.CORE_0_PIF_PMS_CONSTRAIN_6.Reg) & 0xc000000) >> 26
}
func (o *SENSITIVE_Type) SetCORE_0_PIF_PMS_CONSTRAIN_6_CORE_0_PIF_PMS_CONSTRAIN_WORLD_1_TIMERGROUP1(value uint32) {
	volatile.StoreUint32(&o.CORE_0_PIF_PMS_CONSTRAIN_6.Reg, volatile.LoadUint32(&o.CORE_0_PIF_PMS_CONSTRAIN_6.Reg)&^(0x30000000)|value<<28)
}
func (o *SENSITIVE_Type) GetCORE_0_PIF_PMS_CONSTRAIN_6_CORE_0_PIF_PMS_CONSTRAIN_WORLD_1_TIMERGROUP1() uint32 {
	return (volatile.LoadUint32(&o.CORE_0_PIF_PMS_CONSTRAIN_6.Reg) & 0x30000000) >> 28
}
func (o *SENSITIVE_Type) SetCORE_0_PIF_PMS_CONSTRAIN_6_CORE_0_PIF_PMS_CONSTRAIN_WORLD_1_SYSTIMER(value uint32) {
	volatile.StoreUint32(&o.CORE_0_PIF_PMS_CONSTRAIN_6.Reg, volatile.LoadUint32(&o.CORE_0_PIF_PMS_CONSTRAIN_6.Reg)&^(0xc0000000)|value<<30)
}
func (o *SENSITIVE_Type) GetCORE_0_PIF_PMS_CONSTRAIN_6_CORE_0_PIF_PMS_CONSTRAIN_WORLD_1_SYSTIMER() uint32 {
	return (volatile.LoadUint32(&o.CORE_0_PIF_PMS_CONSTRAIN_6.Reg) & 0xc0000000) >> 30
}

// SENSITIVE.CORE_0_PIF_PMS_CONSTRAIN_7: SENSITIVE_CORE_0_PIF_PMS_CONSTRAIN_7_REG
func (o *SENSITIVE_Type) SetCORE_0_PIF_PMS_CONSTRAIN_7_CORE_0_PIF_PMS_CONSTRAIN_WORLD_1_SPI_2(value uint32) {
	volatile.StoreUint32(&o.CORE_0_PIF_PMS_CONSTRAIN_7.Reg, volatile.LoadUint32(&o.CORE_0_PIF_PMS_CONSTRAIN_7.Reg)&^(0x3)|value)
}
func (o *SENSITIVE_Type) GetCORE_0_PIF_PMS_CONSTRAIN_7_CORE_0_PIF_PMS_CONSTRAIN_WORLD_1_SPI_2() uint32 {
	return volatile.LoadUint32(&o.CORE_0_PIF_PMS_CONSTRAIN_7.Reg) & 0x3
}
func (o *SENSITIVE_Type) SetCORE_0_PIF_PMS_CONSTRAIN_7_CORE_0_PIF_PMS_CONSTRAIN_WORLD_1_APB_CTRL(value uint32) {
	volatile.StoreUint32(&o.CORE_0_PIF_PMS_CONSTRAIN_7.Reg, volatile.LoadUint32(&o.CORE_0_PIF_PMS_CONSTRAIN_7.Reg)&^(0x30)|value<<4)
}
func (o *SENSITIVE_Type) GetCORE_0_PIF_PMS_CONSTRAIN_7_CORE_0_PIF_PMS_CONSTRAIN_WORLD_1_APB_CTRL() uint32 {
	return (volatile.LoadUint32(&o.CORE_0_PIF_PMS_CONSTRAIN_7.Reg) & 0x30) >> 4
}
func (o *SENSITIVE_Type) SetCORE_0_PIF_PMS_CONSTRAIN_7_CORE_0_PIF_PMS_CONSTRAIN_WORLD_1_CAN(value uint32) {
	volatile.StoreUint32(&o.CORE_0_PIF_PMS_CONSTRAIN_7.Reg, volatile.LoadUint32(&o.CORE_0_PIF_PMS_CONSTRAIN_7.Reg)&^(0xc00)|value<<10)
}
func (o *SENSITIVE_Type) GetCORE_0_PIF_PMS_CONSTRAIN_7_CORE_0_PIF_PMS_CONSTRAIN_WORLD_1_CAN() uint32 {
	return (volatile.LoadUint32(&o.CORE_0_PIF_PMS_CONSTRAIN_7.Reg) & 0xc00) >> 10
}
func (o *SENSITIVE_Type) SetCORE_0_PIF_PMS_CONSTRAIN_7_CORE_0_PIF_PMS_CONSTRAIN_WORLD_1_I2S1(value uint32) {
	volatile.StoreUint32(&o.CORE_0_PIF_PMS_CONSTRAIN_7.Reg, volatile.LoadUint32(&o.CORE_0_PIF_PMS_CONSTRAIN_7.Reg)&^(0xc000)|value<<14)
}
func (o *SENSITIVE_Type) GetCORE_0_PIF_PMS_CONSTRAIN_7_CORE_0_PIF_PMS_CONSTRAIN_WORLD_1_I2S1() uint32 {
	return (volatile.LoadUint32(&o.CORE_0_PIF_PMS_CONSTRAIN_7.Reg) & 0xc000) >> 14
}
func (o *SENSITIVE_Type) SetCORE_0_PIF_PMS_CONSTRAIN_7_CORE_0_PIF_PMS_CONSTRAIN_WORLD_1_RWBT(value uint32) {
	volatile.StoreUint32(&o.CORE_0_PIF_PMS_CONSTRAIN_7.Reg, volatile.LoadUint32(&o.CORE_0_PIF_PMS_CONSTRAIN_7.Reg)&^(0xc00000)|value<<22)
}
func (o *SENSITIVE_Type) GetCORE_0_PIF_PMS_CONSTRAIN_7_CORE_0_PIF_PMS_CONSTRAIN_WORLD_1_RWBT() uint32 {
	return (volatile.LoadUint32(&o.CORE_0_PIF_PMS_CONSTRAIN_7.Reg) & 0xc00000) >> 22
}
func (o *SENSITIVE_Type) SetCORE_0_PIF_PMS_CONSTRAIN_7_CORE_0_PIF_PMS_CONSTRAIN_WORLD_1_WIFIMAC(value uint32) {
	volatile.StoreUint32(&o.CORE_0_PIF_PMS_CONSTRAIN_7.Reg, volatile.LoadUint32(&o.CORE_0_PIF_PMS_CONSTRAIN_7.Reg)&^(0xc000000)|value<<26)
}
func (o *SENSITIVE_Type) GetCORE_0_PIF_PMS_CONSTRAIN_7_CORE_0_PIF_PMS_CONSTRAIN_WORLD_1_WIFIMAC() uint32 {
	return (volatile.LoadUint32(&o.CORE_0_PIF_PMS_CONSTRAIN_7.Reg) & 0xc000000) >> 26
}
func (o *SENSITIVE_Type) SetCORE_0_PIF_PMS_CONSTRAIN_7_CORE_0_PIF_PMS_CONSTRAIN_WORLD_1_PWR(value uint32) {
	volatile.StoreUint32(&o.CORE_0_PIF_PMS_CONSTRAIN_7.Reg, volatile.LoadUint32(&o.CORE_0_PIF_PMS_CONSTRAIN_7.Reg)&^(0x30000000)|value<<28)
}
func (o *SENSITIVE_Type) GetCORE_0_PIF_PMS_CONSTRAIN_7_CORE_0_PIF_PMS_CONSTRAIN_WORLD_1_PWR() uint32 {
	return (volatile.LoadUint32(&o.CORE_0_PIF_PMS_CONSTRAIN_7.Reg) & 0x30000000) >> 28
}

// SENSITIVE.CORE_0_PIF_PMS_CONSTRAIN_8: SENSITIVE_CORE_0_PIF_PMS_CONSTRAIN_8_REG
func (o *SENSITIVE_Type) SetCORE_0_PIF_PMS_CONSTRAIN_8_CORE_0_PIF_PMS_CONSTRAIN_WORLD_1_USB_WRAP(value uint32) {
	volatile.StoreUint32(&o.CORE_0_PIF_PMS_CONSTRAIN_8.Reg, volatile.LoadUint32(&o.CORE_0_PIF_PMS_CONSTRAIN_8.Reg)&^(0xc)|value<<2)
}
func (o *SENSITIVE_Type) GetCORE_0_PIF_PMS_CONSTRAIN_8_CORE_0_PIF_PMS_CONSTRAIN_WORLD_1_USB_WRAP() uint32 {
	return (volatile.LoadUint32(&o.CORE_0_PIF_PMS_CONSTRAIN_8.Reg) & 0xc) >> 2
}
func (o *SENSITIVE_Type) SetCORE_0_PIF_PMS_CONSTRAIN_8_CORE_0_PIF_PMS_CONSTRAIN_WORLD_1_CRYPTO_PERI(value uint32) {
	volatile.StoreUint32(&o.CORE_0_PIF_PMS_CONSTRAIN_8.Reg, volatile.LoadUint32(&o.CORE_0_PIF_PMS_CONSTRAIN_8.Reg)&^(0x30)|value<<4)
}
func (o *SENSITIVE_Type) GetCORE_0_PIF_PMS_CONSTRAIN_8_CORE_0_PIF_PMS_CONSTRAIN_WORLD_1_CRYPTO_PERI() uint32 {
	return (volatile.LoadUint32(&o.CORE_0_PIF_PMS_CONSTRAIN_8.Reg) & 0x30) >> 4
}
func (o *SENSITIVE_Type) SetCORE_0_PIF_PMS_CONSTRAIN_8_CORE_0_PIF_PMS_CONSTRAIN_WORLD_1_CRYPTO_DMA(value uint32) {
	volatile.StoreUint32(&o.CORE_0_PIF_PMS_CONSTRAIN_8.Reg, volatile.LoadUint32(&o.CORE_0_PIF_PMS_CONSTRAIN_8.Reg)&^(0xc0)|value<<6)
}
func (o *SENSITIVE_Type) GetCORE_0_PIF_PMS_CONSTRAIN_8_CORE_0_PIF_PMS_CONSTRAIN_WORLD_1_CRYPTO_DMA() uint32 {
	return (volatile.LoadUint32(&o.CORE_0_PIF_PMS_CONSTRAIN_8.Reg) & 0xc0) >> 6
}
func (o *SENSITIVE_Type) SetCORE_0_PIF_PMS_CONSTRAIN_8_CORE_0_PIF_PMS_CONSTRAIN_WORLD_1_APB_ADC(value uint32) {
	volatile.StoreUint32(&o.CORE_0_PIF_PMS_CONSTRAIN_8.Reg, volatile.LoadUint32(&o.CORE_0_PIF_PMS_CONSTRAIN_8.Reg)&^(0x300)|value<<8)
}
func (o *SENSITIVE_Type) GetCORE_0_PIF_PMS_CONSTRAIN_8_CORE_0_PIF_PMS_CONSTRAIN_WORLD_1_APB_ADC() uint32 {
	return (volatile.LoadUint32(&o.CORE_0_PIF_PMS_CONSTRAIN_8.Reg) & 0x300) >> 8
}
func (o *SENSITIVE_Type) SetCORE_0_PIF_PMS_CONSTRAIN_8_CORE_0_PIF_PMS_CONSTRAIN_WORLD_1_BT_PWR(value uint32) {
	volatile.StoreUint32(&o.CORE_0_PIF_PMS_CONSTRAIN_8.Reg, volatile.LoadUint32(&o.CORE_0_PIF_PMS_CONSTRAIN_8.Reg)&^(0x3000)|value<<12)
}
func (o *SENSITIVE_Type) GetCORE_0_PIF_PMS_CONSTRAIN_8_CORE_0_PIF_PMS_CONSTRAIN_WORLD_1_BT_PWR() uint32 {
	return (volatile.LoadUint32(&o.CORE_0_PIF_PMS_CONSTRAIN_8.Reg) & 0x3000) >> 12
}
func (o *SENSITIVE_Type) SetCORE_0_PIF_PMS_CONSTRAIN_8_CORE_0_PIF_PMS_CONSTRAIN_WORLD_1_USB_DEVICE(value uint32) {
	volatile.StoreUint32(&o.CORE_0_PIF_PMS_CONSTRAIN_8.Reg, volatile.LoadUint32(&o.CORE_0_PIF_PMS_CONSTRAIN_8.Reg)&^(0xc000)|value<<14)
}
func (o *SENSITIVE_Type) GetCORE_0_PIF_PMS_CONSTRAIN_8_CORE_0_PIF_PMS_CONSTRAIN_WORLD_1_USB_DEVICE() uint32 {
	return (volatile.LoadUint32(&o.CORE_0_PIF_PMS_CONSTRAIN_8.Reg) & 0xc000) >> 14
}
func (o *SENSITIVE_Type) SetCORE_0_PIF_PMS_CONSTRAIN_8_CORE_0_PIF_PMS_CONSTRAIN_WORLD_1_SYSTEM(value uint32) {
	volatile.StoreUint32(&o.CORE_0_PIF_PMS_CONSTRAIN_8.Reg, volatile.LoadUint32(&o.CORE_0_PIF_PMS_CONSTRAIN_8.Reg)&^(0x30000)|value<<16)
}
func (o *SENSITIVE_Type) GetCORE_0_PIF_PMS_CONSTRAIN_8_CORE_0_PIF_PMS_CONSTRAIN_WORLD_1_SYSTEM() uint32 {
	return (volatile.LoadUint32(&o.CORE_0_PIF_PMS_CONSTRAIN_8.Reg) & 0x30000) >> 16
}
func (o *SENSITIVE_Type) SetCORE_0_PIF_PMS_CONSTRAIN_8_CORE_0_PIF_PMS_CONSTRAIN_WORLD_1_SENSITIVE(value uint32) {
	volatile.StoreUint32(&o.CORE_0_PIF_PMS_CONSTRAIN_8.Reg, volatile.LoadUint32(&o.CORE_0_PIF_PMS_CONSTRAIN_8.Reg)&^(0xc0000)|value<<18)
}
func (o *SENSITIVE_Type) GetCORE_0_PIF_PMS_CONSTRAIN_8_CORE_0_PIF_PMS_CONSTRAIN_WORLD_1_SENSITIVE() uint32 {
	return (volatile.LoadUint32(&o.CORE_0_PIF_PMS_CONSTRAIN_8.Reg) & 0xc0000) >> 18
}
func (o *SENSITIVE_Type) SetCORE_0_PIF_PMS_CONSTRAIN_8_CORE_0_PIF_PMS_CONSTRAIN_WORLD_1_INTERRUPT(value uint32) {
	volatile.StoreUint32(&o.CORE_0_PIF_PMS_CONSTRAIN_8.Reg, volatile.LoadUint32(&o.CORE_0_PIF_PMS_CONSTRAIN_8.Reg)&^(0x300000)|value<<20)
}
func (o *SENSITIVE_Type) GetCORE_0_PIF_PMS_CONSTRAIN_8_CORE_0_PIF_PMS_CONSTRAIN_WORLD_1_INTERRUPT() uint32 {
	return (volatile.LoadUint32(&o.CORE_0_PIF_PMS_CONSTRAIN_8.Reg) & 0x300000) >> 20
}
func (o *SENSITIVE_Type) SetCORE_0_PIF_PMS_CONSTRAIN_8_CORE_0_PIF_PMS_CONSTRAIN_WORLD_1_DMA_COPY(value uint32) {
	volatile.StoreUint32(&o.CORE_0_PIF_PMS_CONSTRAIN_8.Reg, volatile.LoadUint32(&o.CORE_0_PIF_PMS_CONSTRAIN_8.Reg)&^(0xc00000)|value<<22)
}
func (o *SENSITIVE_Type) GetCORE_0_PIF_PMS_CONSTRAIN_8_CORE_0_PIF_PMS_CONSTRAIN_WORLD_1_DMA_COPY() uint32 {
	return (volatile.LoadUint32(&o.CORE_0_PIF_PMS_CONSTRAIN_8.Reg) & 0xc00000) >> 22
}
func (o *SENSITIVE_Type) SetCORE_0_PIF_PMS_CONSTRAIN_8_CORE_0_PIF_PMS_CONSTRAIN_WORLD_1_CACHE_CONFIG(value uint32) {
	volatile.StoreUint32(&o.CORE_0_PIF_PMS_CONSTRAIN_8.Reg, volatile.LoadUint32(&o.CORE_0_PIF_PMS_CONSTRAIN_8.Reg)&^(0x3000000)|value<<24)
}
func (o *SENSITIVE_Type) GetCORE_0_PIF_PMS_CONSTRAIN_8_CORE_0_PIF_PMS_CONSTRAIN_WORLD_1_CACHE_CONFIG() uint32 {
	return (volatile.LoadUint32(&o.CORE_0_PIF_PMS_CONSTRAIN_8.Reg) & 0x3000000) >> 24
}
func (o *SENSITIVE_Type) SetCORE_0_PIF_PMS_CONSTRAIN_8_CORE_0_PIF_PMS_CONSTRAIN_WORLD_1_AD(value uint32) {
	volatile.StoreUint32(&o.CORE_0_PIF_PMS_CONSTRAIN_8.Reg, volatile.LoadUint32(&o.CORE_0_PIF_PMS_CONSTRAIN_8.Reg)&^(0xc000000)|value<<26)
}
func (o *SENSITIVE_Type) GetCORE_0_PIF_PMS_CONSTRAIN_8_CORE_0_PIF_PMS_CONSTRAIN_WORLD_1_AD() uint32 {
	return (volatile.LoadUint32(&o.CORE_0_PIF_PMS_CONSTRAIN_8.Reg) & 0xc000000) >> 26
}
func (o *SENSITIVE_Type) SetCORE_0_PIF_PMS_CONSTRAIN_8_CORE_0_PIF_PMS_CONSTRAIN_WORLD_1_DIO(value uint32) {
	volatile.StoreUint32(&o.CORE_0_PIF_PMS_CONSTRAIN_8.Reg, volatile.LoadUint32(&o.CORE_0_PIF_PMS_CONSTRAIN_8.Reg)&^(0x30000000)|value<<28)
}
func (o *SENSITIVE_Type) GetCORE_0_PIF_PMS_CONSTRAIN_8_CORE_0_PIF_PMS_CONSTRAIN_WORLD_1_DIO() uint32 {
	return (volatile.LoadUint32(&o.CORE_0_PIF_PMS_CONSTRAIN_8.Reg) & 0x30000000) >> 28
}
func (o *SENSITIVE_Type) SetCORE_0_PIF_PMS_CONSTRAIN_8_CORE_0_PIF_PMS_CONSTRAIN_WORLD_1_WORLD_CONTROLLER(value uint32) {
	volatile.StoreUint32(&o.CORE_0_PIF_PMS_CONSTRAIN_8.Reg, volatile.LoadUint32(&o.CORE_0_PIF_PMS_CONSTRAIN_8.Reg)&^(0xc0000000)|value<<30)
}
func (o *SENSITIVE_Type) GetCORE_0_PIF_PMS_CONSTRAIN_8_CORE_0_PIF_PMS_CONSTRAIN_WORLD_1_WORLD_CONTROLLER() uint32 {
	return (volatile.LoadUint32(&o.CORE_0_PIF_PMS_CONSTRAIN_8.Reg) & 0xc0000000) >> 30
}

// SENSITIVE.CORE_0_PIF_PMS_CONSTRAIN_9: SENSITIVE_CORE_0_PIF_PMS_CONSTRAIN_9_REG
func (o *SENSITIVE_Type) SetCORE_0_PIF_PMS_CONSTRAIN_9_CORE_0_PIF_PMS_CONSTRAIN_RTCFAST_SPLTADDR_WORLD_0(value uint32) {
	volatile.StoreUint32(&o.CORE_0_PIF_PMS_CONSTRAIN_9.Reg, volatile.LoadUint32(&o.CORE_0_PIF_PMS_CONSTRAIN_9.Reg)&^(0x7ff)|value)
}
func (o *SENSITIVE_Type) GetCORE_0_PIF_PMS_CONSTRAIN_9_CORE_0_PIF_PMS_CONSTRAIN_RTCFAST_SPLTADDR_WORLD_0() uint32 {
	return volatile.LoadUint32(&o.CORE_0_PIF_PMS_CONSTRAIN_9.Reg) & 0x7ff
}
func (o *SENSITIVE_Type) SetCORE_0_PIF_PMS_CONSTRAIN_9_CORE_0_PIF_PMS_CONSTRAIN_RTCFAST_SPLTADDR_WORLD_1(value uint32) {
	volatile.StoreUint32(&o.CORE_0_PIF_PMS_CONSTRAIN_9.Reg, volatile.LoadUint32(&o.CORE_0_PIF_PMS_CONSTRAIN_9.Reg)&^(0x3ff800)|value<<11)
}
func (o *SENSITIVE_Type) GetCORE_0_PIF_PMS_CONSTRAIN_9_CORE_0_PIF_PMS_CONSTRAIN_RTCFAST_SPLTADDR_WORLD_1() uint32 {
	return (volatile.LoadUint32(&o.CORE_0_PIF_PMS_CONSTRAIN_9.Reg) & 0x3ff800) >> 11
}

// SENSITIVE.CORE_0_PIF_PMS_CONSTRAIN_10: SENSITIVE_CORE_0_PIF_PMS_CONSTRAIN_10_REG
func (o *SENSITIVE_Type) SetCORE_0_PIF_PMS_CONSTRAIN_10_CORE_0_PIF_PMS_CONSTRAIN_RTCFAST_WORLD_0_L(value uint32) {
	volatile.StoreUint32(&o.CORE_0_PIF_PMS_CONSTRAIN_10.Reg, volatile.LoadUint32(&o.CORE_0_PIF_PMS_CONSTRAIN_10.Reg)&^(0x7)|value)
}
func (o *SENSITIVE_Type) GetCORE_0_PIF_PMS_CONSTRAIN_10_CORE_0_PIF_PMS_CONSTRAIN_RTCFAST_WORLD_0_L() uint32 {
	return volatile.LoadUint32(&o.CORE_0_PIF_PMS_CONSTRAIN_10.Reg) & 0x7
}
func (o *SENSITIVE_Type) SetCORE_0_PIF_PMS_CONSTRAIN_10_CORE_0_PIF_PMS_CONSTRAIN_RTCFAST_WORLD_0_H(value uint32) {
	volatile.StoreUint32(&o.CORE_0_PIF_PMS_CONSTRAIN_10.Reg, volatile.LoadUint32(&o.CORE_0_PIF_PMS_CONSTRAIN_10.Reg)&^(0x38)|value<<3)
}
func (o *SENSITIVE_Type) GetCORE_0_PIF_PMS_CONSTRAIN_10_CORE_0_PIF_PMS_CONSTRAIN_RTCFAST_WORLD_0_H() uint32 {
	return (volatile.LoadUint32(&o.CORE_0_PIF_PMS_CONSTRAIN_10.Reg) & 0x38) >> 3
}
func (o *SENSITIVE_Type) SetCORE_0_PIF_PMS_CONSTRAIN_10_CORE_0_PIF_PMS_CONSTRAIN_RTCFAST_WORLD_1_L(value uint32) {
	volatile.StoreUint32(&o.CORE_0_PIF_PMS_CONSTRAIN_10.Reg, volatile.LoadUint32(&o.CORE_0_PIF_PMS_CONSTRAIN_10.Reg)&^(0x1c0)|value<<6)
}
func (o *SENSITIVE_Type) GetCORE_0_PIF_PMS_CONSTRAIN_10_CORE_0_PIF_PMS_CONSTRAIN_RTCFAST_WORLD_1_L() uint32 {
	return (volatile.LoadUint32(&o.CORE_0_PIF_PMS_CONSTRAIN_10.Reg) & 0x1c0) >> 6
}
func (o *SENSITIVE_Type) SetCORE_0_PIF_PMS_CONSTRAIN_10_CORE_0_PIF_PMS_CONSTRAIN_RTCFAST_WORLD_1_H(value uint32) {
	volatile.StoreUint32(&o.CORE_0_PIF_PMS_CONSTRAIN_10.Reg, volatile.LoadUint32(&o.CORE_0_PIF_PMS_CONSTRAIN_10.Reg)&^(0xe00)|value<<9)
}
func (o *SENSITIVE_Type) GetCORE_0_PIF_PMS_CONSTRAIN_10_CORE_0_PIF_PMS_CONSTRAIN_RTCFAST_WORLD_1_H() uint32 {
	return (volatile.LoadUint32(&o.CORE_0_PIF_PMS_CONSTRAIN_10.Reg) & 0xe00) >> 9
}

// SENSITIVE.REGION_PMS_CONSTRAIN_0: SENSITIVE_REGION_PMS_CONSTRAIN_0_REG
func (o *SENSITIVE_Type) SetREGION_PMS_CONSTRAIN_0_REGION_PMS_CONSTRAIN_LOCK(value uint32) {
	volatile.StoreUint32(&o.REGION_PMS_CONSTRAIN_0.Reg, volatile.LoadUint32(&o.REGION_PMS_CONSTRAIN_0.Reg)&^(0x1)|value)
}
func (o *SENSITIVE_Type) GetREGION_PMS_CONSTRAIN_0_REGION_PMS_CONSTRAIN_LOCK() uint32 {
	return volatile.LoadUint32(&o.REGION_PMS_CONSTRAIN_0.Reg) & 0x1
}

// SENSITIVE.REGION_PMS_CONSTRAIN_1: SENSITIVE_REGION_PMS_CONSTRAIN_1_REG
func (o *SENSITIVE_Type) SetREGION_PMS_CONSTRAIN_1_REGION_PMS_CONSTRAIN_WORLD_0_AREA_0(value uint32) {
	volatile.StoreUint32(&o.REGION_PMS_CONSTRAIN_1.Reg, volatile.LoadUint32(&o.REGION_PMS_CONSTRAIN_1.Reg)&^(0x3)|value)
}
func (o *SENSITIVE_Type) GetREGION_PMS_CONSTRAIN_1_REGION_PMS_CONSTRAIN_WORLD_0_AREA_0() uint32 {
	return volatile.LoadUint32(&o.REGION_PMS_CONSTRAIN_1.Reg) & 0x3
}
func (o *SENSITIVE_Type) SetREGION_PMS_CONSTRAIN_1_REGION_PMS_CONSTRAIN_WORLD_0_AREA_1(value uint32) {
	volatile.StoreUint32(&o.REGION_PMS_CONSTRAIN_1.Reg, volatile.LoadUint32(&o.REGION_PMS_CONSTRAIN_1.Reg)&^(0xc)|value<<2)
}
func (o *SENSITIVE_Type) GetREGION_PMS_CONSTRAIN_1_REGION_PMS_CONSTRAIN_WORLD_0_AREA_1() uint32 {
	return (volatile.LoadUint32(&o.REGION_PMS_CONSTRAIN_1.Reg) & 0xc) >> 2
}
func (o *SENSITIVE_Type) SetREGION_PMS_CONSTRAIN_1_REGION_PMS_CONSTRAIN_WORLD_0_AREA_2(value uint32) {
	volatile.StoreUint32(&o.REGION_PMS_CONSTRAIN_1.Reg, volatile.LoadUint32(&o.REGION_PMS_CONSTRAIN_1.Reg)&^(0x30)|value<<4)
}
func (o *SENSITIVE_Type) GetREGION_PMS_CONSTRAIN_1_REGION_PMS_CONSTRAIN_WORLD_0_AREA_2() uint32 {
	return (volatile.LoadUint32(&o.REGION_PMS_CONSTRAIN_1.Reg) & 0x30) >> 4
}
func (o *SENSITIVE_Type) SetREGION_PMS_CONSTRAIN_1_REGION_PMS_CONSTRAIN_WORLD_0_AREA_3(value uint32) {
	volatile.StoreUint32(&o.REGION_PMS_CONSTRAIN_1.Reg, volatile.LoadUint32(&o.REGION_PMS_CONSTRAIN_1.Reg)&^(0xc0)|value<<6)
}
func (o *SENSITIVE_Type) GetREGION_PMS_CONSTRAIN_1_REGION_PMS_CONSTRAIN_WORLD_0_AREA_3() uint32 {
	return (volatile.LoadUint32(&o.REGION_PMS_CONSTRAIN_1.Reg) & 0xc0) >> 6
}
func (o *SENSITIVE_Type) SetREGION_PMS_CONSTRAIN_1_REGION_PMS_CONSTRAIN_WORLD_0_AREA_4(value uint32) {
	volatile.StoreUint32(&o.REGION_PMS_CONSTRAIN_1.Reg, volatile.LoadUint32(&o.REGION_PMS_CONSTRAIN_1.Reg)&^(0x300)|value<<8)
}
func (o *SENSITIVE_Type) GetREGION_PMS_CONSTRAIN_1_REGION_PMS_CONSTRAIN_WORLD_0_AREA_4() uint32 {
	return (volatile.LoadUint32(&o.REGION_PMS_CONSTRAIN_1.Reg) & 0x300) >> 8
}
func (o *SENSITIVE_Type) SetREGION_PMS_CONSTRAIN_1_REGION_PMS_CONSTRAIN_WORLD_0_AREA_5(value uint32) {
	volatile.StoreUint32(&o.REGION_PMS_CONSTRAIN_1.Reg, volatile.LoadUint32(&o.REGION_PMS_CONSTRAIN_1.Reg)&^(0xc00)|value<<10)
}
func (o *SENSITIVE_Type) GetREGION_PMS_CONSTRAIN_1_REGION_PMS_CONSTRAIN_WORLD_0_AREA_5() uint32 {
	return (volatile.LoadUint32(&o.REGION_PMS_CONSTRAIN_1.Reg) & 0xc00) >> 10
}
func (o *SENSITIVE_Type) SetREGION_PMS_CONSTRAIN_1_REGION_PMS_CONSTRAIN_WORLD_0_AREA_6(value uint32) {
	volatile.StoreUint32(&o.REGION_PMS_CONSTRAIN_1.Reg, volatile.LoadUint32(&o.REGION_PMS_CONSTRAIN_1.Reg)&^(0x3000)|value<<12)
}
func (o *SENSITIVE_Type) GetREGION_PMS_CONSTRAIN_1_REGION_PMS_CONSTRAIN_WORLD_0_AREA_6() uint32 {
	return (volatile.LoadUint32(&o.REGION_PMS_CONSTRAIN_1.Reg) & 0x3000) >> 12
}

// SENSITIVE.REGION_PMS_CONSTRAIN_2: SENSITIVE_REGION_PMS_CONSTRAIN_2_REG
func (o *SENSITIVE_Type) SetREGION_PMS_CONSTRAIN_2_REGION_PMS_CONSTRAIN_WORLD_1_AREA_0(value uint32) {
	volatile.StoreUint32(&o.REGION_PMS_CONSTRAIN_2.Reg, volatile.LoadUint32(&o.REGION_PMS_CONSTRAIN_2.Reg)&^(0x3)|value)
}
func (o *SENSITIVE_Type) GetREGION_PMS_CONSTRAIN_2_REGION_PMS_CONSTRAIN_WORLD_1_AREA_0() uint32 {
	return volatile.LoadUint32(&o.REGION_PMS_CONSTRAIN_2.Reg) & 0x3
}
func (o *SENSITIVE_Type) SetREGION_PMS_CONSTRAIN_2_REGION_PMS_CONSTRAIN_WORLD_1_AREA_1(value uint32) {
	volatile.StoreUint32(&o.REGION_PMS_CONSTRAIN_2.Reg, volatile.LoadUint32(&o.REGION_PMS_CONSTRAIN_2.Reg)&^(0xc)|value<<2)
}
func (o *SENSITIVE_Type) GetREGION_PMS_CONSTRAIN_2_REGION_PMS_CONSTRAIN_WORLD_1_AREA_1() uint32 {
	return (volatile.LoadUint32(&o.REGION_PMS_CONSTRAIN_2.Reg) & 0xc) >> 2
}
func (o *SENSITIVE_Type) SetREGION_PMS_CONSTRAIN_2_REGION_PMS_CONSTRAIN_WORLD_1_AREA_2(value uint32) {
	volatile.StoreUint32(&o.REGION_PMS_CONSTRAIN_2.Reg, volatile.LoadUint32(&o.REGION_PMS_CONSTRAIN_2.Reg)&^(0x30)|value<<4)
}
func (o *SENSITIVE_Type) GetREGION_PMS_CONSTRAIN_2_REGION_PMS_CONSTRAIN_WORLD_1_AREA_2() uint32 {
	return (volatile.LoadUint32(&o.REGION_PMS_CONSTRAIN_2.Reg) & 0x30) >> 4
}
func (o *SENSITIVE_Type) SetREGION_PMS_CONSTRAIN_2_REGION_PMS_CONSTRAIN_WORLD_1_AREA_3(value uint32) {
	volatile.StoreUint32(&o.REGION_PMS_CONSTRAIN_2.Reg, volatile.LoadUint32(&o.REGION_PMS_CONSTRAIN_2.Reg)&^(0xc0)|value<<6)
}
func (o *SENSITIVE_Type) GetREGION_PMS_CONSTRAIN_2_REGION_PMS_CONSTRAIN_WORLD_1_AREA_3() uint32 {
	return (volatile.LoadUint32(&o.REGION_PMS_CONSTRAIN_2.Reg) & 0xc0) >> 6
}
func (o *SENSITIVE_Type) SetREGION_PMS_CONSTRAIN_2_REGION_PMS_CONSTRAIN_WORLD_1_AREA_4(value uint32) {
	volatile.StoreUint32(&o.REGION_PMS_CONSTRAIN_2.Reg, volatile.LoadUint32(&o.REGION_PMS_CONSTRAIN_2.Reg)&^(0x300)|value<<8)
}
func (o *SENSITIVE_Type) GetREGION_PMS_CONSTRAIN_2_REGION_PMS_CONSTRAIN_WORLD_1_AREA_4() uint32 {
	return (volatile.LoadUint32(&o.REGION_PMS_CONSTRAIN_2.Reg) & 0x300) >> 8
}
func (o *SENSITIVE_Type) SetREGION_PMS_CONSTRAIN_2_REGION_PMS_CONSTRAIN_WORLD_1_AREA_5(value uint32) {
	volatile.StoreUint32(&o.REGION_PMS_CONSTRAIN_2.Reg, volatile.LoadUint32(&o.REGION_PMS_CONSTRAIN_2.Reg)&^(0xc00)|value<<10)
}
func (o *SENSITIVE_Type) GetREGION_PMS_CONSTRAIN_2_REGION_PMS_CONSTRAIN_WORLD_1_AREA_5() uint32 {
	return (volatile.LoadUint32(&o.REGION_PMS_CONSTRAIN_2.Reg) & 0xc00) >> 10
}
func (o *SENSITIVE_Type) SetREGION_PMS_CONSTRAIN_2_REGION_PMS_CONSTRAIN_WORLD_1_AREA_6(value uint32) {
	volatile.StoreUint32(&o.REGION_PMS_CONSTRAIN_2.Reg, volatile.LoadUint32(&o.REGION_PMS_CONSTRAIN_2.Reg)&^(0x3000)|value<<12)
}
func (o *SENSITIVE_Type) GetREGION_PMS_CONSTRAIN_2_REGION_PMS_CONSTRAIN_WORLD_1_AREA_6() uint32 {
	return (volatile.LoadUint32(&o.REGION_PMS_CONSTRAIN_2.Reg) & 0x3000) >> 12
}

// SENSITIVE.REGION_PMS_CONSTRAIN_3: SENSITIVE_REGION_PMS_CONSTRAIN_3_REG
func (o *SENSITIVE_Type) SetREGION_PMS_CONSTRAIN_3_REGION_PMS_CONSTRAIN_ADDR_0(value uint32) {
	volatile.StoreUint32(&o.REGION_PMS_CONSTRAIN_3.Reg, volatile.LoadUint32(&o.REGION_PMS_CONSTRAIN_3.Reg)&^(0x3fffffff)|value)
}
func (o *SENSITIVE_Type) GetREGION_PMS_CONSTRAIN_3_REGION_PMS_CONSTRAIN_ADDR_0() uint32 {
	return volatile.LoadUint32(&o.REGION_PMS_CONSTRAIN_3.Reg) & 0x3fffffff
}

// SENSITIVE.REGION_PMS_CONSTRAIN_4: SENSITIVE_REGION_PMS_CONSTRAIN_4_REG
func (o *SENSITIVE_Type) SetREGION_PMS_CONSTRAIN_4_REGION_PMS_CONSTRAIN_ADDR_1(value uint32) {
	volatile.StoreUint32(&o.REGION_PMS_CONSTRAIN_4.Reg, volatile.LoadUint32(&o.REGION_PMS_CONSTRAIN_4.Reg)&^(0x3fffffff)|value)
}
func (o *SENSITIVE_Type) GetREGION_PMS_CONSTRAIN_4_REGION_PMS_CONSTRAIN_ADDR_1() uint32 {
	return volatile.LoadUint32(&o.REGION_PMS_CONSTRAIN_4.Reg) & 0x3fffffff
}

// SENSITIVE.REGION_PMS_CONSTRAIN_5: SENSITIVE_REGION_PMS_CONSTRAIN_5_REG
func (o *SENSITIVE_Type) SetREGION_PMS_CONSTRAIN_5_REGION_PMS_CONSTRAIN_ADDR_2(value uint32) {
	volatile.StoreUint32(&o.REGION_PMS_CONSTRAIN_5.Reg, volatile.LoadUint32(&o.REGION_PMS_CONSTRAIN_5.Reg)&^(0x3fffffff)|value)
}
func (o *SENSITIVE_Type) GetREGION_PMS_CONSTRAIN_5_REGION_PMS_CONSTRAIN_ADDR_2() uint32 {
	return volatile.LoadUint32(&o.REGION_PMS_CONSTRAIN_5.Reg) & 0x3fffffff
}

// SENSITIVE.REGION_PMS_CONSTRAIN_6: SENSITIVE_REGION_PMS_CONSTRAIN_6_REG
func (o *SENSITIVE_Type) SetREGION_PMS_CONSTRAIN_6_REGION_PMS_CONSTRAIN_ADDR_3(value uint32) {
	volatile.StoreUint32(&o.REGION_PMS_CONSTRAIN_6.Reg, volatile.LoadUint32(&o.REGION_PMS_CONSTRAIN_6.Reg)&^(0x3fffffff)|value)
}
func (o *SENSITIVE_Type) GetREGION_PMS_CONSTRAIN_6_REGION_PMS_CONSTRAIN_ADDR_3() uint32 {
	return volatile.LoadUint32(&o.REGION_PMS_CONSTRAIN_6.Reg) & 0x3fffffff
}

// SENSITIVE.REGION_PMS_CONSTRAIN_7: SENSITIVE_REGION_PMS_CONSTRAIN_7_REG
func (o *SENSITIVE_Type) SetREGION_PMS_CONSTRAIN_7_REGION_PMS_CONSTRAIN_ADDR_4(value uint32) {
	volatile.StoreUint32(&o.REGION_PMS_CONSTRAIN_7.Reg, volatile.LoadUint32(&o.REGION_PMS_CONSTRAIN_7.Reg)&^(0x3fffffff)|value)
}
func (o *SENSITIVE_Type) GetREGION_PMS_CONSTRAIN_7_REGION_PMS_CONSTRAIN_ADDR_4() uint32 {
	return volatile.LoadUint32(&o.REGION_PMS_CONSTRAIN_7.Reg) & 0x3fffffff
}

// SENSITIVE.REGION_PMS_CONSTRAIN_8: SENSITIVE_REGION_PMS_CONSTRAIN_8_REG
func (o *SENSITIVE_Type) SetREGION_PMS_CONSTRAIN_8_REGION_PMS_CONSTRAIN_ADDR_5(value uint32) {
	volatile.StoreUint32(&o.REGION_PMS_CONSTRAIN_8.Reg, volatile.LoadUint32(&o.REGION_PMS_CONSTRAIN_8.Reg)&^(0x3fffffff)|value)
}
func (o *SENSITIVE_Type) GetREGION_PMS_CONSTRAIN_8_REGION_PMS_CONSTRAIN_ADDR_5() uint32 {
	return volatile.LoadUint32(&o.REGION_PMS_CONSTRAIN_8.Reg) & 0x3fffffff
}

// SENSITIVE.REGION_PMS_CONSTRAIN_9: SENSITIVE_REGION_PMS_CONSTRAIN_9_REG
func (o *SENSITIVE_Type) SetREGION_PMS_CONSTRAIN_9_REGION_PMS_CONSTRAIN_ADDR_6(value uint32) {
	volatile.StoreUint32(&o.REGION_PMS_CONSTRAIN_9.Reg, volatile.LoadUint32(&o.REGION_PMS_CONSTRAIN_9.Reg)&^(0x3fffffff)|value)
}
func (o *SENSITIVE_Type) GetREGION_PMS_CONSTRAIN_9_REGION_PMS_CONSTRAIN_ADDR_6() uint32 {
	return volatile.LoadUint32(&o.REGION_PMS_CONSTRAIN_9.Reg) & 0x3fffffff
}

// SENSITIVE.REGION_PMS_CONSTRAIN_10: SENSITIVE_REGION_PMS_CONSTRAIN_10_REG
func (o *SENSITIVE_Type) SetREGION_PMS_CONSTRAIN_10_REGION_PMS_CONSTRAIN_ADDR_7(value uint32) {
	volatile.StoreUint32(&o.REGION_PMS_CONSTRAIN_10.Reg, volatile.LoadUint32(&o.REGION_PMS_CONSTRAIN_10.Reg)&^(0x3fffffff)|value)
}
func (o *SENSITIVE_Type) GetREGION_PMS_CONSTRAIN_10_REGION_PMS_CONSTRAIN_ADDR_7() uint32 {
	return volatile.LoadUint32(&o.REGION_PMS_CONSTRAIN_10.Reg) & 0x3fffffff
}

// SENSITIVE.CORE_0_PIF_PMS_MONITOR_0: SENSITIVE_CORE_0_PIF_PMS_MONITOR_0_REG
func (o *SENSITIVE_Type) SetCORE_0_PIF_PMS_MONITOR_0_CORE_0_PIF_PMS_MONITOR_LOCK(value uint32) {
	volatile.StoreUint32(&o.CORE_0_PIF_PMS_MONITOR_0.Reg, volatile.LoadUint32(&o.CORE_0_PIF_PMS_MONITOR_0.Reg)&^(0x1)|value)
}
func (o *SENSITIVE_Type) GetCORE_0_PIF_PMS_MONITOR_0_CORE_0_PIF_PMS_MONITOR_LOCK() uint32 {
	return volatile.LoadUint32(&o.CORE_0_PIF_PMS_MONITOR_0.Reg) & 0x1
}

// SENSITIVE.CORE_0_PIF_PMS_MONITOR_1: SENSITIVE_CORE_0_PIF_PMS_MONITOR_1_REG
func (o *SENSITIVE_Type) SetCORE_0_PIF_PMS_MONITOR_1_CORE_0_PIF_PMS_MONITOR_VIOLATE_CLR(value uint32) {
	volatile.StoreUint32(&o.CORE_0_PIF_PMS_MONITOR_1.Reg, volatile.LoadUint32(&o.CORE_0_PIF_PMS_MONITOR_1.Reg)&^(0x1)|value)
}
func (o *SENSITIVE_Type) GetCORE_0_PIF_PMS_MONITOR_1_CORE_0_PIF_PMS_MONITOR_VIOLATE_CLR() uint32 {
	return volatile.LoadUint32(&o.CORE_0_PIF_PMS_MONITOR_1.Reg) & 0x1
}
func (o *SENSITIVE_Type) SetCORE_0_PIF_PMS_MONITOR_1_CORE_0_PIF_PMS_MONITOR_VIOLATE_EN(value uint32) {
	volatile.StoreUint32(&o.CORE_0_PIF_PMS_MONITOR_1.Reg, volatile.LoadUint32(&o.CORE_0_PIF_PMS_MONITOR_1.Reg)&^(0x2)|value<<1)
}
func (o *SENSITIVE_Type) GetCORE_0_PIF_PMS_MONITOR_1_CORE_0_PIF_PMS_MONITOR_VIOLATE_EN() uint32 {
	return (volatile.LoadUint32(&o.CORE_0_PIF_PMS_MONITOR_1.Reg) & 0x2) >> 1
}

// SENSITIVE.CORE_0_PIF_PMS_MONITOR_2: SENSITIVE_CORE_0_PIF_PMS_MONITOR_2_REG
func (o *SENSITIVE_Type) SetCORE_0_PIF_PMS_MONITOR_2_CORE_0_PIF_PMS_MONITOR_VIOLATE_INTR(value uint32) {
	volatile.StoreUint32(&o.CORE_0_PIF_PMS_MONITOR_2.Reg, volatile.LoadUint32(&o.CORE_0_PIF_PMS_MONITOR_2.Reg)&^(0x1)|value)
}
func (o *SENSITIVE_Type) GetCORE_0_PIF_PMS_MONITOR_2_CORE_0_PIF_PMS_MONITOR_VIOLATE_INTR() uint32 {
	return volatile.LoadUint32(&o.CORE_0_PIF_PMS_MONITOR_2.Reg) & 0x1
}
func (o *SENSITIVE_Type) SetCORE_0_PIF_PMS_MONITOR_2_CORE_0_PIF_PMS_MONITOR_VIOLATE_STATUS_HPORT_0(value uint32) {
	volatile.StoreUint32(&o.CORE_0_PIF_PMS_MONITOR_2.Reg, volatile.LoadUint32(&o.CORE_0_PIF_PMS_MONITOR_2.Reg)&^(0x2)|value<<1)
}
func (o *SENSITIVE_Type) GetCORE_0_PIF_PMS_MONITOR_2_CORE_0_PIF_PMS_MONITOR_VIOLATE_STATUS_HPORT_0() uint32 {
	return (volatile.LoadUint32(&o.CORE_0_PIF_PMS_MONITOR_2.Reg) & 0x2) >> 1
}
func (o *SENSITIVE_Type) SetCORE_0_PIF_PMS_MONITOR_2_CORE_0_PIF_PMS_MONITOR_VIOLATE_STATUS_HSIZE(value uint32) {
	volatile.StoreUint32(&o.CORE_0_PIF_PMS_MONITOR_2.Reg, volatile.LoadUint32(&o.CORE_0_PIF_PMS_MONITOR_2.Reg)&^(0x1c)|value<<2)
}
func (o *SENSITIVE_Type) GetCORE_0_PIF_PMS_MONITOR_2_CORE_0_PIF_PMS_MONITOR_VIOLATE_STATUS_HSIZE() uint32 {
	return (volatile.LoadUint32(&o.CORE_0_PIF_PMS_MONITOR_2.Reg) & 0x1c) >> 2
}
func (o *SENSITIVE_Type) SetCORE_0_PIF_PMS_MONITOR_2_CORE_0_PIF_PMS_MONITOR_VIOLATE_STATUS_HWRITE(value uint32) {
	volatile.StoreUint32(&o.CORE_0_PIF_PMS_MONITOR_2.Reg, volatile.LoadUint32(&o.CORE_0_PIF_PMS_MONITOR_2.Reg)&^(0x20)|value<<5)
}
func (o *SENSITIVE_Type) GetCORE_0_PIF_PMS_MONITOR_2_CORE_0_PIF_PMS_MONITOR_VIOLATE_STATUS_HWRITE() uint32 {
	return (volatile.LoadUint32(&o.CORE_0_PIF_PMS_MONITOR_2.Reg) & 0x20) >> 5
}
func (o *SENSITIVE_Type) SetCORE_0_PIF_PMS_MONITOR_2_CORE_0_PIF_PMS_MONITOR_VIOLATE_STATUS_HWORLD(value uint32) {
	volatile.StoreUint32(&o.CORE_0_PIF_PMS_MONITOR_2.Reg, volatile.LoadUint32(&o.CORE_0_PIF_PMS_MONITOR_2.Reg)&^(0xc0)|value<<6)
}
func (o *SENSITIVE_Type) GetCORE_0_PIF_PMS_MONITOR_2_CORE_0_PIF_PMS_MONITOR_VIOLATE_STATUS_HWORLD() uint32 {
	return (volatile.LoadUint32(&o.CORE_0_PIF_PMS_MONITOR_2.Reg) & 0xc0) >> 6
}

// SENSITIVE.CORE_0_PIF_PMS_MONITOR_3: SENSITIVE_CORE_0_PIF_PMS_MONITOR_3_REG
func (o *SENSITIVE_Type) SetCORE_0_PIF_PMS_MONITOR_3(value uint32) {
	volatile.StoreUint32(&o.CORE_0_PIF_PMS_MONITOR_3.Reg, value)
}
func (o *SENSITIVE_Type) GetCORE_0_PIF_PMS_MONITOR_3() uint32 {
	return volatile.LoadUint32(&o.CORE_0_PIF_PMS_MONITOR_3.Reg)
}

// SENSITIVE.CORE_0_PIF_PMS_MONITOR_4: SENSITIVE_CORE_0_PIF_PMS_MONITOR_4_REG
func (o *SENSITIVE_Type) SetCORE_0_PIF_PMS_MONITOR_4_CORE_0_PIF_PMS_MONITOR_NONWORD_VIOLATE_CLR(value uint32) {
	volatile.StoreUint32(&o.CORE_0_PIF_PMS_MONITOR_4.Reg, volatile.LoadUint32(&o.CORE_0_PIF_PMS_MONITOR_4.Reg)&^(0x1)|value)
}
func (o *SENSITIVE_Type) GetCORE_0_PIF_PMS_MONITOR_4_CORE_0_PIF_PMS_MONITOR_NONWORD_VIOLATE_CLR() uint32 {
	return volatile.LoadUint32(&o.CORE_0_PIF_PMS_MONITOR_4.Reg) & 0x1
}
func (o *SENSITIVE_Type) SetCORE_0_PIF_PMS_MONITOR_4_CORE_0_PIF_PMS_MONITOR_NONWORD_VIOLATE_EN(value uint32) {
	volatile.StoreUint32(&o.CORE_0_PIF_PMS_MONITOR_4.Reg, volatile.LoadUint32(&o.CORE_0_PIF_PMS_MONITOR_4.Reg)&^(0x2)|value<<1)
}
func (o *SENSITIVE_Type) GetCORE_0_PIF_PMS_MONITOR_4_CORE_0_PIF_PMS_MONITOR_NONWORD_VIOLATE_EN() uint32 {
	return (volatile.LoadUint32(&o.CORE_0_PIF_PMS_MONITOR_4.Reg) & 0x2) >> 1
}

// SENSITIVE.CORE_0_PIF_PMS_MONITOR_5: SENSITIVE_CORE_0_PIF_PMS_MONITOR_5_REG
func (o *SENSITIVE_Type) SetCORE_0_PIF_PMS_MONITOR_5_CORE_0_PIF_PMS_MONITOR_NONWORD_VIOLATE_INTR(value uint32) {
	volatile.StoreUint32(&o.CORE_0_PIF_PMS_MONITOR_5.Reg, volatile.LoadUint32(&o.CORE_0_PIF_PMS_MONITOR_5.Reg)&^(0x1)|value)
}
func (o *SENSITIVE_Type) GetCORE_0_PIF_PMS_MONITOR_5_CORE_0_PIF_PMS_MONITOR_NONWORD_VIOLATE_INTR() uint32 {
	return volatile.LoadUint32(&o.CORE_0_PIF_PMS_MONITOR_5.Reg) & 0x1
}
func (o *SENSITIVE_Type) SetCORE_0_PIF_PMS_MONITOR_5_CORE_0_PIF_PMS_MONITOR_NONWORD_VIOLATE_STATUS_HSIZE(value uint32) {
	volatile.StoreUint32(&o.CORE_0_PIF_PMS_MONITOR_5.Reg, volatile.LoadUint32(&o.CORE_0_PIF_PMS_MONITOR_5.Reg)&^(0x6)|value<<1)
}
func (o *SENSITIVE_Type) GetCORE_0_PIF_PMS_MONITOR_5_CORE_0_PIF_PMS_MONITOR_NONWORD_VIOLATE_STATUS_HSIZE() uint32 {
	return (volatile.LoadUint32(&o.CORE_0_PIF_PMS_MONITOR_5.Reg) & 0x6) >> 1
}
func (o *SENSITIVE_Type) SetCORE_0_PIF_PMS_MONITOR_5_CORE_0_PIF_PMS_MONITOR_NONWORD_VIOLATE_STATUS_HWORLD(value uint32) {
	volatile.StoreUint32(&o.CORE_0_PIF_PMS_MONITOR_5.Reg, volatile.LoadUint32(&o.CORE_0_PIF_PMS_MONITOR_5.Reg)&^(0x18)|value<<3)
}
func (o *SENSITIVE_Type) GetCORE_0_PIF_PMS_MONITOR_5_CORE_0_PIF_PMS_MONITOR_NONWORD_VIOLATE_STATUS_HWORLD() uint32 {
	return (volatile.LoadUint32(&o.CORE_0_PIF_PMS_MONITOR_5.Reg) & 0x18) >> 3
}

// SENSITIVE.CORE_0_PIF_PMS_MONITOR_6: SENSITIVE_CORE_0_PIF_PMS_MONITOR_6_REG
func (o *SENSITIVE_Type) SetCORE_0_PIF_PMS_MONITOR_6(value uint32) {
	volatile.StoreUint32(&o.CORE_0_PIF_PMS_MONITOR_6.Reg, value)
}
func (o *SENSITIVE_Type) GetCORE_0_PIF_PMS_MONITOR_6() uint32 {
	return volatile.LoadUint32(&o.CORE_0_PIF_PMS_MONITOR_6.Reg)
}

// SENSITIVE.BACKUP_BUS_PMS_CONSTRAIN_0: SENSITIVE_BACKUP_BUS_PMS_CONSTRAIN_0_REG
func (o *SENSITIVE_Type) SetBACKUP_BUS_PMS_CONSTRAIN_0_BACKUP_BUS_PMS_CONSTRAIN_LOCK(value uint32) {
	volatile.StoreUint32(&o.BACKUP_BUS_PMS_CONSTRAIN_0.Reg, volatile.LoadUint32(&o.BACKUP_BUS_PMS_CONSTRAIN_0.Reg)&^(0x1)|value)
}
func (o *SENSITIVE_Type) GetBACKUP_BUS_PMS_CONSTRAIN_0_BACKUP_BUS_PMS_CONSTRAIN_LOCK() uint32 {
	return volatile.LoadUint32(&o.BACKUP_BUS_PMS_CONSTRAIN_0.Reg) & 0x1
}

// SENSITIVE.BACKUP_BUS_PMS_CONSTRAIN_1: SENSITIVE_BACKUP_BUS_PMS_CONSTRAIN_1_REG
func (o *SENSITIVE_Type) SetBACKUP_BUS_PMS_CONSTRAIN_1_BACKUP_BUS_PMS_CONSTRAIN_UART(value uint32) {
	volatile.StoreUint32(&o.BACKUP_BUS_PMS_CONSTRAIN_1.Reg, volatile.LoadUint32(&o.BACKUP_BUS_PMS_CONSTRAIN_1.Reg)&^(0x3)|value)
}
func (o *SENSITIVE_Type) GetBACKUP_BUS_PMS_CONSTRAIN_1_BACKUP_BUS_PMS_CONSTRAIN_UART() uint32 {
	return volatile.LoadUint32(&o.BACKUP_BUS_PMS_CONSTRAIN_1.Reg) & 0x3
}
func (o *SENSITIVE_Type) SetBACKUP_BUS_PMS_CONSTRAIN_1_BACKUP_BUS_PMS_CONSTRAIN_G0SPI_1(value uint32) {
	volatile.StoreUint32(&o.BACKUP_BUS_PMS_CONSTRAIN_1.Reg, volatile.LoadUint32(&o.BACKUP_BUS_PMS_CONSTRAIN_1.Reg)&^(0xc)|value<<2)
}
func (o *SENSITIVE_Type) GetBACKUP_BUS_PMS_CONSTRAIN_1_BACKUP_BUS_PMS_CONSTRAIN_G0SPI_1() uint32 {
	return (volatile.LoadUint32(&o.BACKUP_BUS_PMS_CONSTRAIN_1.Reg) & 0xc) >> 2
}
func (o *SENSITIVE_Type) SetBACKUP_BUS_PMS_CONSTRAIN_1_BACKUP_BUS_PMS_CONSTRAIN_G0SPI_0(value uint32) {
	volatile.StoreUint32(&o.BACKUP_BUS_PMS_CONSTRAIN_1.Reg, volatile.LoadUint32(&o.BACKUP_BUS_PMS_CONSTRAIN_1.Reg)&^(0x30)|value<<4)
}
func (o *SENSITIVE_Type) GetBACKUP_BUS_PMS_CONSTRAIN_1_BACKUP_BUS_PMS_CONSTRAIN_G0SPI_0() uint32 {
	return (volatile.LoadUint32(&o.BACKUP_BUS_PMS_CONSTRAIN_1.Reg) & 0x30) >> 4
}
func (o *SENSITIVE_Type) SetBACKUP_BUS_PMS_CONSTRAIN_1_BACKUP_BUS_PMS_CONSTRAIN_GPIO(value uint32) {
	volatile.StoreUint32(&o.BACKUP_BUS_PMS_CONSTRAIN_1.Reg, volatile.LoadUint32(&o.BACKUP_BUS_PMS_CONSTRAIN_1.Reg)&^(0xc0)|value<<6)
}
func (o *SENSITIVE_Type) GetBACKUP_BUS_PMS_CONSTRAIN_1_BACKUP_BUS_PMS_CONSTRAIN_GPIO() uint32 {
	return (volatile.LoadUint32(&o.BACKUP_BUS_PMS_CONSTRAIN_1.Reg) & 0xc0) >> 6
}
func (o *SENSITIVE_Type) SetBACKUP_BUS_PMS_CONSTRAIN_1_BACKUP_BUS_PMS_CONSTRAIN_FE2(value uint32) {
	volatile.StoreUint32(&o.BACKUP_BUS_PMS_CONSTRAIN_1.Reg, volatile.LoadUint32(&o.BACKUP_BUS_PMS_CONSTRAIN_1.Reg)&^(0x300)|value<<8)
}
func (o *SENSITIVE_Type) GetBACKUP_BUS_PMS_CONSTRAIN_1_BACKUP_BUS_PMS_CONSTRAIN_FE2() uint32 {
	return (volatile.LoadUint32(&o.BACKUP_BUS_PMS_CONSTRAIN_1.Reg) & 0x300) >> 8
}
func (o *SENSITIVE_Type) SetBACKUP_BUS_PMS_CONSTRAIN_1_BACKUP_BUS_PMS_CONSTRAIN_FE(value uint32) {
	volatile.StoreUint32(&o.BACKUP_BUS_PMS_CONSTRAIN_1.Reg, volatile.LoadUint32(&o.BACKUP_BUS_PMS_CONSTRAIN_1.Reg)&^(0xc00)|value<<10)
}
func (o *SENSITIVE_Type) GetBACKUP_BUS_PMS_CONSTRAIN_1_BACKUP_BUS_PMS_CONSTRAIN_FE() uint32 {
	return (volatile.LoadUint32(&o.BACKUP_BUS_PMS_CONSTRAIN_1.Reg) & 0xc00) >> 10
}
func (o *SENSITIVE_Type) SetBACKUP_BUS_PMS_CONSTRAIN_1_BACKUP_BUS_PMS_CONSTRAIN_TIMER(value uint32) {
	volatile.StoreUint32(&o.BACKUP_BUS_PMS_CONSTRAIN_1.Reg, volatile.LoadUint32(&o.BACKUP_BUS_PMS_CONSTRAIN_1.Reg)&^(0x3000)|value<<12)
}
func (o *SENSITIVE_Type) GetBACKUP_BUS_PMS_CONSTRAIN_1_BACKUP_BUS_PMS_CONSTRAIN_TIMER() uint32 {
	return (volatile.LoadUint32(&o.BACKUP_BUS_PMS_CONSTRAIN_1.Reg) & 0x3000) >> 12
}
func (o *SENSITIVE_Type) SetBACKUP_BUS_PMS_CONSTRAIN_1_BACKUP_BUS_PMS_CONSTRAIN_RTC(value uint32) {
	volatile.StoreUint32(&o.BACKUP_BUS_PMS_CONSTRAIN_1.Reg, volatile.LoadUint32(&o.BACKUP_BUS_PMS_CONSTRAIN_1.Reg)&^(0xc000)|value<<14)
}
func (o *SENSITIVE_Type) GetBACKUP_BUS_PMS_CONSTRAIN_1_BACKUP_BUS_PMS_CONSTRAIN_RTC() uint32 {
	return (volatile.LoadUint32(&o.BACKUP_BUS_PMS_CONSTRAIN_1.Reg) & 0xc000) >> 14
}
func (o *SENSITIVE_Type) SetBACKUP_BUS_PMS_CONSTRAIN_1_BACKUP_BUS_PMS_CONSTRAIN_IO_MUX(value uint32) {
	volatile.StoreUint32(&o.BACKUP_BUS_PMS_CONSTRAIN_1.Reg, volatile.LoadUint32(&o.BACKUP_BUS_PMS_CONSTRAIN_1.Reg)&^(0x30000)|value<<16)
}
func (o *SENSITIVE_Type) GetBACKUP_BUS_PMS_CONSTRAIN_1_BACKUP_BUS_PMS_CONSTRAIN_IO_MUX() uint32 {
	return (volatile.LoadUint32(&o.BACKUP_BUS_PMS_CONSTRAIN_1.Reg) & 0x30000) >> 16
}
func (o *SENSITIVE_Type) SetBACKUP_BUS_PMS_CONSTRAIN_1_BACKUP_BUS_PMS_CONSTRAIN_WDG(value uint32) {
	volatile.StoreUint32(&o.BACKUP_BUS_PMS_CONSTRAIN_1.Reg, volatile.LoadUint32(&o.BACKUP_BUS_PMS_CONSTRAIN_1.Reg)&^(0xc0000)|value<<18)
}
func (o *SENSITIVE_Type) GetBACKUP_BUS_PMS_CONSTRAIN_1_BACKUP_BUS_PMS_CONSTRAIN_WDG() uint32 {
	return (volatile.LoadUint32(&o.BACKUP_BUS_PMS_CONSTRAIN_1.Reg) & 0xc0000) >> 18
}
func (o *SENSITIVE_Type) SetBACKUP_BUS_PMS_CONSTRAIN_1_BACKUP_BUS_PMS_CONSTRAIN_MISC(value uint32) {
	volatile.StoreUint32(&o.BACKUP_BUS_PMS_CONSTRAIN_1.Reg, volatile.LoadUint32(&o.BACKUP_BUS_PMS_CONSTRAIN_1.Reg)&^(0x3000000)|value<<24)
}
func (o *SENSITIVE_Type) GetBACKUP_BUS_PMS_CONSTRAIN_1_BACKUP_BUS_PMS_CONSTRAIN_MISC() uint32 {
	return (volatile.LoadUint32(&o.BACKUP_BUS_PMS_CONSTRAIN_1.Reg) & 0x3000000) >> 24
}
func (o *SENSITIVE_Type) SetBACKUP_BUS_PMS_CONSTRAIN_1_BACKUP_BUS_PMS_CONSTRAIN_I2C(value uint32) {
	volatile.StoreUint32(&o.BACKUP_BUS_PMS_CONSTRAIN_1.Reg, volatile.LoadUint32(&o.BACKUP_BUS_PMS_CONSTRAIN_1.Reg)&^(0xc000000)|value<<26)
}
func (o *SENSITIVE_Type) GetBACKUP_BUS_PMS_CONSTRAIN_1_BACKUP_BUS_PMS_CONSTRAIN_I2C() uint32 {
	return (volatile.LoadUint32(&o.BACKUP_BUS_PMS_CONSTRAIN_1.Reg) & 0xc000000) >> 26
}
func (o *SENSITIVE_Type) SetBACKUP_BUS_PMS_CONSTRAIN_1_BACKUP_BUS_PMS_CONSTRAIN_UART1(value uint32) {
	volatile.StoreUint32(&o.BACKUP_BUS_PMS_CONSTRAIN_1.Reg, volatile.LoadUint32(&o.BACKUP_BUS_PMS_CONSTRAIN_1.Reg)&^(0xc0000000)|value<<30)
}
func (o *SENSITIVE_Type) GetBACKUP_BUS_PMS_CONSTRAIN_1_BACKUP_BUS_PMS_CONSTRAIN_UART1() uint32 {
	return (volatile.LoadUint32(&o.BACKUP_BUS_PMS_CONSTRAIN_1.Reg) & 0xc0000000) >> 30
}

// SENSITIVE.BACKUP_BUS_PMS_CONSTRAIN_2: SENSITIVE_BACKUP_BUS_PMS_CONSTRAIN_2_REG
func (o *SENSITIVE_Type) SetBACKUP_BUS_PMS_CONSTRAIN_2_BACKUP_BUS_PMS_CONSTRAIN_BT(value uint32) {
	volatile.StoreUint32(&o.BACKUP_BUS_PMS_CONSTRAIN_2.Reg, volatile.LoadUint32(&o.BACKUP_BUS_PMS_CONSTRAIN_2.Reg)&^(0x3)|value)
}
func (o *SENSITIVE_Type) GetBACKUP_BUS_PMS_CONSTRAIN_2_BACKUP_BUS_PMS_CONSTRAIN_BT() uint32 {
	return volatile.LoadUint32(&o.BACKUP_BUS_PMS_CONSTRAIN_2.Reg) & 0x3
}
func (o *SENSITIVE_Type) SetBACKUP_BUS_PMS_CONSTRAIN_2_BACKUP_BUS_PMS_CONSTRAIN_I2C_EXT0(value uint32) {
	volatile.StoreUint32(&o.BACKUP_BUS_PMS_CONSTRAIN_2.Reg, volatile.LoadUint32(&o.BACKUP_BUS_PMS_CONSTRAIN_2.Reg)&^(0x30)|value<<4)
}
func (o *SENSITIVE_Type) GetBACKUP_BUS_PMS_CONSTRAIN_2_BACKUP_BUS_PMS_CONSTRAIN_I2C_EXT0() uint32 {
	return (volatile.LoadUint32(&o.BACKUP_BUS_PMS_CONSTRAIN_2.Reg) & 0x30) >> 4
}
func (o *SENSITIVE_Type) SetBACKUP_BUS_PMS_CONSTRAIN_2_BACKUP_BUS_PMS_CONSTRAIN_UHCI0(value uint32) {
	volatile.StoreUint32(&o.BACKUP_BUS_PMS_CONSTRAIN_2.Reg, volatile.LoadUint32(&o.BACKUP_BUS_PMS_CONSTRAIN_2.Reg)&^(0xc0)|value<<6)
}
func (o *SENSITIVE_Type) GetBACKUP_BUS_PMS_CONSTRAIN_2_BACKUP_BUS_PMS_CONSTRAIN_UHCI0() uint32 {
	return (volatile.LoadUint32(&o.BACKUP_BUS_PMS_CONSTRAIN_2.Reg) & 0xc0) >> 6
}
func (o *SENSITIVE_Type) SetBACKUP_BUS_PMS_CONSTRAIN_2_BACKUP_BUS_PMS_CONSTRAIN_RMT(value uint32) {
	volatile.StoreUint32(&o.BACKUP_BUS_PMS_CONSTRAIN_2.Reg, volatile.LoadUint32(&o.BACKUP_BUS_PMS_CONSTRAIN_2.Reg)&^(0xc00)|value<<10)
}
func (o *SENSITIVE_Type) GetBACKUP_BUS_PMS_CONSTRAIN_2_BACKUP_BUS_PMS_CONSTRAIN_RMT() uint32 {
	return (volatile.LoadUint32(&o.BACKUP_BUS_PMS_CONSTRAIN_2.Reg) & 0xc00) >> 10
}
func (o *SENSITIVE_Type) SetBACKUP_BUS_PMS_CONSTRAIN_2_BACKUP_BUS_PMS_CONSTRAIN_LEDC(value uint32) {
	volatile.StoreUint32(&o.BACKUP_BUS_PMS_CONSTRAIN_2.Reg, volatile.LoadUint32(&o.BACKUP_BUS_PMS_CONSTRAIN_2.Reg)&^(0x30000)|value<<16)
}
func (o *SENSITIVE_Type) GetBACKUP_BUS_PMS_CONSTRAIN_2_BACKUP_BUS_PMS_CONSTRAIN_LEDC() uint32 {
	return (volatile.LoadUint32(&o.BACKUP_BUS_PMS_CONSTRAIN_2.Reg) & 0x30000) >> 16
}
func (o *SENSITIVE_Type) SetBACKUP_BUS_PMS_CONSTRAIN_2_BACKUP_BUS_PMS_CONSTRAIN_BB(value uint32) {
	volatile.StoreUint32(&o.BACKUP_BUS_PMS_CONSTRAIN_2.Reg, volatile.LoadUint32(&o.BACKUP_BUS_PMS_CONSTRAIN_2.Reg)&^(0xc00000)|value<<22)
}
func (o *SENSITIVE_Type) GetBACKUP_BUS_PMS_CONSTRAIN_2_BACKUP_BUS_PMS_CONSTRAIN_BB() uint32 {
	return (volatile.LoadUint32(&o.BACKUP_BUS_PMS_CONSTRAIN_2.Reg) & 0xc00000) >> 22
}
func (o *SENSITIVE_Type) SetBACKUP_BUS_PMS_CONSTRAIN_2_BACKUP_BUS_PMS_CONSTRAIN_TIMERGROUP(value uint32) {
	volatile.StoreUint32(&o.BACKUP_BUS_PMS_CONSTRAIN_2.Reg, volatile.LoadUint32(&o.BACKUP_BUS_PMS_CONSTRAIN_2.Reg)&^(0xc000000)|value<<26)
}
func (o *SENSITIVE_Type) GetBACKUP_BUS_PMS_CONSTRAIN_2_BACKUP_BUS_PMS_CONSTRAIN_TIMERGROUP() uint32 {
	return (volatile.LoadUint32(&o.BACKUP_BUS_PMS_CONSTRAIN_2.Reg) & 0xc000000) >> 26
}
func (o *SENSITIVE_Type) SetBACKUP_BUS_PMS_CONSTRAIN_2_BACKUP_BUS_PMS_CONSTRAIN_TIMERGROUP1(value uint32) {
	volatile.StoreUint32(&o.BACKUP_BUS_PMS_CONSTRAIN_2.Reg, volatile.LoadUint32(&o.BACKUP_BUS_PMS_CONSTRAIN_2.Reg)&^(0x30000000)|value<<28)
}
func (o *SENSITIVE_Type) GetBACKUP_BUS_PMS_CONSTRAIN_2_BACKUP_BUS_PMS_CONSTRAIN_TIMERGROUP1() uint32 {
	return (volatile.LoadUint32(&o.BACKUP_BUS_PMS_CONSTRAIN_2.Reg) & 0x30000000) >> 28
}
func (o *SENSITIVE_Type) SetBACKUP_BUS_PMS_CONSTRAIN_2_BACKUP_BUS_PMS_CONSTRAIN_SYSTIMER(value uint32) {
	volatile.StoreUint32(&o.BACKUP_BUS_PMS_CONSTRAIN_2.Reg, volatile.LoadUint32(&o.BACKUP_BUS_PMS_CONSTRAIN_2.Reg)&^(0xc0000000)|value<<30)
}
func (o *SENSITIVE_Type) GetBACKUP_BUS_PMS_CONSTRAIN_2_BACKUP_BUS_PMS_CONSTRAIN_SYSTIMER() uint32 {
	return (volatile.LoadUint32(&o.BACKUP_BUS_PMS_CONSTRAIN_2.Reg) & 0xc0000000) >> 30
}

// SENSITIVE.BACKUP_BUS_PMS_CONSTRAIN_3: SENSITIVE_BACKUP_BUS_PMS_CONSTRAIN_3_REG
func (o *SENSITIVE_Type) SetBACKUP_BUS_PMS_CONSTRAIN_3_BACKUP_BUS_PMS_CONSTRAIN_SPI_2(value uint32) {
	volatile.StoreUint32(&o.BACKUP_BUS_PMS_CONSTRAIN_3.Reg, volatile.LoadUint32(&o.BACKUP_BUS_PMS_CONSTRAIN_3.Reg)&^(0x3)|value)
}
func (o *SENSITIVE_Type) GetBACKUP_BUS_PMS_CONSTRAIN_3_BACKUP_BUS_PMS_CONSTRAIN_SPI_2() uint32 {
	return volatile.LoadUint32(&o.BACKUP_BUS_PMS_CONSTRAIN_3.Reg) & 0x3
}
func (o *SENSITIVE_Type) SetBACKUP_BUS_PMS_CONSTRAIN_3_BACKUP_BUS_PMS_CONSTRAIN_APB_CTRL(value uint32) {
	volatile.StoreUint32(&o.BACKUP_BUS_PMS_CONSTRAIN_3.Reg, volatile.LoadUint32(&o.BACKUP_BUS_PMS_CONSTRAIN_3.Reg)&^(0x30)|value<<4)
}
func (o *SENSITIVE_Type) GetBACKUP_BUS_PMS_CONSTRAIN_3_BACKUP_BUS_PMS_CONSTRAIN_APB_CTRL() uint32 {
	return (volatile.LoadUint32(&o.BACKUP_BUS_PMS_CONSTRAIN_3.Reg) & 0x30) >> 4
}
func (o *SENSITIVE_Type) SetBACKUP_BUS_PMS_CONSTRAIN_3_BACKUP_BUS_PMS_CONSTRAIN_CAN(value uint32) {
	volatile.StoreUint32(&o.BACKUP_BUS_PMS_CONSTRAIN_3.Reg, volatile.LoadUint32(&o.BACKUP_BUS_PMS_CONSTRAIN_3.Reg)&^(0xc00)|value<<10)
}
func (o *SENSITIVE_Type) GetBACKUP_BUS_PMS_CONSTRAIN_3_BACKUP_BUS_PMS_CONSTRAIN_CAN() uint32 {
	return (volatile.LoadUint32(&o.BACKUP_BUS_PMS_CONSTRAIN_3.Reg) & 0xc00) >> 10
}
func (o *SENSITIVE_Type) SetBACKUP_BUS_PMS_CONSTRAIN_3_BACKUP_BUS_PMS_CONSTRAIN_I2S1(value uint32) {
	volatile.StoreUint32(&o.BACKUP_BUS_PMS_CONSTRAIN_3.Reg, volatile.LoadUint32(&o.BACKUP_BUS_PMS_CONSTRAIN_3.Reg)&^(0xc000)|value<<14)
}
func (o *SENSITIVE_Type) GetBACKUP_BUS_PMS_CONSTRAIN_3_BACKUP_BUS_PMS_CONSTRAIN_I2S1() uint32 {
	return (volatile.LoadUint32(&o.BACKUP_BUS_PMS_CONSTRAIN_3.Reg) & 0xc000) >> 14
}
func (o *SENSITIVE_Type) SetBACKUP_BUS_PMS_CONSTRAIN_3_BACKUP_BUS_PMS_CONSTRAIN_RWBT(value uint32) {
	volatile.StoreUint32(&o.BACKUP_BUS_PMS_CONSTRAIN_3.Reg, volatile.LoadUint32(&o.BACKUP_BUS_PMS_CONSTRAIN_3.Reg)&^(0xc00000)|value<<22)
}
func (o *SENSITIVE_Type) GetBACKUP_BUS_PMS_CONSTRAIN_3_BACKUP_BUS_PMS_CONSTRAIN_RWBT() uint32 {
	return (volatile.LoadUint32(&o.BACKUP_BUS_PMS_CONSTRAIN_3.Reg) & 0xc00000) >> 22
}
func (o *SENSITIVE_Type) SetBACKUP_BUS_PMS_CONSTRAIN_3_BACKUP_BUS_PMS_CONSTRAIN_WIFIMAC(value uint32) {
	volatile.StoreUint32(&o.BACKUP_BUS_PMS_CONSTRAIN_3.Reg, volatile.LoadUint32(&o.BACKUP_BUS_PMS_CONSTRAIN_3.Reg)&^(0xc000000)|value<<26)
}
func (o *SENSITIVE_Type) GetBACKUP_BUS_PMS_CONSTRAIN_3_BACKUP_BUS_PMS_CONSTRAIN_WIFIMAC() uint32 {
	return (volatile.LoadUint32(&o.BACKUP_BUS_PMS_CONSTRAIN_3.Reg) & 0xc000000) >> 26
}
func (o *SENSITIVE_Type) SetBACKUP_BUS_PMS_CONSTRAIN_3_BACKUP_BUS_PMS_CONSTRAIN_PWR(value uint32) {
	volatile.StoreUint32(&o.BACKUP_BUS_PMS_CONSTRAIN_3.Reg, volatile.LoadUint32(&o.BACKUP_BUS_PMS_CONSTRAIN_3.Reg)&^(0x30000000)|value<<28)
}
func (o *SENSITIVE_Type) GetBACKUP_BUS_PMS_CONSTRAIN_3_BACKUP_BUS_PMS_CONSTRAIN_PWR() uint32 {
	return (volatile.LoadUint32(&o.BACKUP_BUS_PMS_CONSTRAIN_3.Reg) & 0x30000000) >> 28
}

// SENSITIVE.BACKUP_BUS_PMS_CONSTRAIN_4: SENSITIVE_BACKUP_BUS_PMS_CONSTRAIN_4_REG
func (o *SENSITIVE_Type) SetBACKUP_BUS_PMS_CONSTRAIN_4_BACKUP_BUS_PMS_CONSTRAIN_USB_WRAP(value uint32) {
	volatile.StoreUint32(&o.BACKUP_BUS_PMS_CONSTRAIN_4.Reg, volatile.LoadUint32(&o.BACKUP_BUS_PMS_CONSTRAIN_4.Reg)&^(0xc)|value<<2)
}
func (o *SENSITIVE_Type) GetBACKUP_BUS_PMS_CONSTRAIN_4_BACKUP_BUS_PMS_CONSTRAIN_USB_WRAP() uint32 {
	return (volatile.LoadUint32(&o.BACKUP_BUS_PMS_CONSTRAIN_4.Reg) & 0xc) >> 2
}
func (o *SENSITIVE_Type) SetBACKUP_BUS_PMS_CONSTRAIN_4_BACKUP_BUS_PMS_CONSTRAIN_CRYPTO_PERI(value uint32) {
	volatile.StoreUint32(&o.BACKUP_BUS_PMS_CONSTRAIN_4.Reg, volatile.LoadUint32(&o.BACKUP_BUS_PMS_CONSTRAIN_4.Reg)&^(0x30)|value<<4)
}
func (o *SENSITIVE_Type) GetBACKUP_BUS_PMS_CONSTRAIN_4_BACKUP_BUS_PMS_CONSTRAIN_CRYPTO_PERI() uint32 {
	return (volatile.LoadUint32(&o.BACKUP_BUS_PMS_CONSTRAIN_4.Reg) & 0x30) >> 4
}
func (o *SENSITIVE_Type) SetBACKUP_BUS_PMS_CONSTRAIN_4_BACKUP_BUS_PMS_CONSTRAIN_CRYPTO_DMA(value uint32) {
	volatile.StoreUint32(&o.BACKUP_BUS_PMS_CONSTRAIN_4.Reg, volatile.LoadUint32(&o.BACKUP_BUS_PMS_CONSTRAIN_4.Reg)&^(0xc0)|value<<6)
}
func (o *SENSITIVE_Type) GetBACKUP_BUS_PMS_CONSTRAIN_4_BACKUP_BUS_PMS_CONSTRAIN_CRYPTO_DMA() uint32 {
	return (volatile.LoadUint32(&o.BACKUP_BUS_PMS_CONSTRAIN_4.Reg) & 0xc0) >> 6
}
func (o *SENSITIVE_Type) SetBACKUP_BUS_PMS_CONSTRAIN_4_BACKUP_BUS_PMS_CONSTRAIN_APB_ADC(value uint32) {
	volatile.StoreUint32(&o.BACKUP_BUS_PMS_CONSTRAIN_4.Reg, volatile.LoadUint32(&o.BACKUP_BUS_PMS_CONSTRAIN_4.Reg)&^(0x300)|value<<8)
}
func (o *SENSITIVE_Type) GetBACKUP_BUS_PMS_CONSTRAIN_4_BACKUP_BUS_PMS_CONSTRAIN_APB_ADC() uint32 {
	return (volatile.LoadUint32(&o.BACKUP_BUS_PMS_CONSTRAIN_4.Reg) & 0x300) >> 8
}
func (o *SENSITIVE_Type) SetBACKUP_BUS_PMS_CONSTRAIN_4_BACKUP_BUS_PMS_CONSTRAIN_BT_PWR(value uint32) {
	volatile.StoreUint32(&o.BACKUP_BUS_PMS_CONSTRAIN_4.Reg, volatile.LoadUint32(&o.BACKUP_BUS_PMS_CONSTRAIN_4.Reg)&^(0x3000)|value<<12)
}
func (o *SENSITIVE_Type) GetBACKUP_BUS_PMS_CONSTRAIN_4_BACKUP_BUS_PMS_CONSTRAIN_BT_PWR() uint32 {
	return (volatile.LoadUint32(&o.BACKUP_BUS_PMS_CONSTRAIN_4.Reg) & 0x3000) >> 12
}
func (o *SENSITIVE_Type) SetBACKUP_BUS_PMS_CONSTRAIN_4_BACKUP_BUS_PMS_CONSTRAIN_USB_DEVICE(value uint32) {
	volatile.StoreUint32(&o.BACKUP_BUS_PMS_CONSTRAIN_4.Reg, volatile.LoadUint32(&o.BACKUP_BUS_PMS_CONSTRAIN_4.Reg)&^(0xc000)|value<<14)
}
func (o *SENSITIVE_Type) GetBACKUP_BUS_PMS_CONSTRAIN_4_BACKUP_BUS_PMS_CONSTRAIN_USB_DEVICE() uint32 {
	return (volatile.LoadUint32(&o.BACKUP_BUS_PMS_CONSTRAIN_4.Reg) & 0xc000) >> 14
}

// SENSITIVE.BACKUP_BUS_PMS_MONITOR_0: SENSITIVE_BACKUP_BUS_PMS_MONITOR_0_REG
func (o *SENSITIVE_Type) SetBACKUP_BUS_PMS_MONITOR_0_BACKUP_BUS_PMS_MONITOR_LOCK(value uint32) {
	volatile.StoreUint32(&o.BACKUP_BUS_PMS_MONITOR_0.Reg, volatile.LoadUint32(&o.BACKUP_BUS_PMS_MONITOR_0.Reg)&^(0x1)|value)
}
func (o *SENSITIVE_Type) GetBACKUP_BUS_PMS_MONITOR_0_BACKUP_BUS_PMS_MONITOR_LOCK() uint32 {
	return volatile.LoadUint32(&o.BACKUP_BUS_PMS_MONITOR_0.Reg) & 0x1
}

// SENSITIVE.BACKUP_BUS_PMS_MONITOR_1: SENSITIVE_BACKUP_BUS_PMS_MONITOR_1_REG
func (o *SENSITIVE_Type) SetBACKUP_BUS_PMS_MONITOR_1_BACKUP_BUS_PMS_MONITOR_VIOLATE_CLR(value uint32) {
	volatile.StoreUint32(&o.BACKUP_BUS_PMS_MONITOR_1.Reg, volatile.LoadUint32(&o.BACKUP_BUS_PMS_MONITOR_1.Reg)&^(0x1)|value)
}
func (o *SENSITIVE_Type) GetBACKUP_BUS_PMS_MONITOR_1_BACKUP_BUS_PMS_MONITOR_VIOLATE_CLR() uint32 {
	return volatile.LoadUint32(&o.BACKUP_BUS_PMS_MONITOR_1.Reg) & 0x1
}
func (o *SENSITIVE_Type) SetBACKUP_BUS_PMS_MONITOR_1_BACKUP_BUS_PMS_MONITOR_VIOLATE_EN(value uint32) {
	volatile.StoreUint32(&o.BACKUP_BUS_PMS_MONITOR_1.Reg, volatile.LoadUint32(&o.BACKUP_BUS_PMS_MONITOR_1.Reg)&^(0x2)|value<<1)
}
func (o *SENSITIVE_Type) GetBACKUP_BUS_PMS_MONITOR_1_BACKUP_BUS_PMS_MONITOR_VIOLATE_EN() uint32 {
	return (volatile.LoadUint32(&o.BACKUP_BUS_PMS_MONITOR_1.Reg) & 0x2) >> 1
}

// SENSITIVE.BACKUP_BUS_PMS_MONITOR_2: SENSITIVE_BACKUP_BUS_PMS_MONITOR_2_REG
func (o *SENSITIVE_Type) SetBACKUP_BUS_PMS_MONITOR_2_BACKUP_BUS_PMS_MONITOR_VIOLATE_INTR(value uint32) {
	volatile.StoreUint32(&o.BACKUP_BUS_PMS_MONITOR_2.Reg, volatile.LoadUint32(&o.BACKUP_BUS_PMS_MONITOR_2.Reg)&^(0x1)|value)
}
func (o *SENSITIVE_Type) GetBACKUP_BUS_PMS_MONITOR_2_BACKUP_BUS_PMS_MONITOR_VIOLATE_INTR() uint32 {
	return volatile.LoadUint32(&o.BACKUP_BUS_PMS_MONITOR_2.Reg) & 0x1
}
func (o *SENSITIVE_Type) SetBACKUP_BUS_PMS_MONITOR_2_BACKUP_BUS_PMS_MONITOR_VIOLATE_STATUS_HTRANS(value uint32) {
	volatile.StoreUint32(&o.BACKUP_BUS_PMS_MONITOR_2.Reg, volatile.LoadUint32(&o.BACKUP_BUS_PMS_MONITOR_2.Reg)&^(0x6)|value<<1)
}
func (o *SENSITIVE_Type) GetBACKUP_BUS_PMS_MONITOR_2_BACKUP_BUS_PMS_MONITOR_VIOLATE_STATUS_HTRANS() uint32 {
	return (volatile.LoadUint32(&o.BACKUP_BUS_PMS_MONITOR_2.Reg) & 0x6) >> 1
}
func (o *SENSITIVE_Type) SetBACKUP_BUS_PMS_MONITOR_2_BACKUP_BUS_PMS_MONITOR_VIOLATE_STATUS_HSIZE(value uint32) {
	volatile.StoreUint32(&o.BACKUP_BUS_PMS_MONITOR_2.Reg, volatile.LoadUint32(&o.BACKUP_BUS_PMS_MONITOR_2.Reg)&^(0x38)|value<<3)
}
func (o *SENSITIVE_Type) GetBACKUP_BUS_PMS_MONITOR_2_BACKUP_BUS_PMS_MONITOR_VIOLATE_STATUS_HSIZE() uint32 {
	return (volatile.LoadUint32(&o.BACKUP_BUS_PMS_MONITOR_2.Reg) & 0x38) >> 3
}
func (o *SENSITIVE_Type) SetBACKUP_BUS_PMS_MONITOR_2_BACKUP_BUS_PMS_MONITOR_VIOLATE_STATUS_HWRITE(value uint32) {
	volatile.StoreUint32(&o.BACKUP_BUS_PMS_MONITOR_2.Reg, volatile.LoadUint32(&o.BACKUP_BUS_PMS_MONITOR_2.Reg)&^(0x40)|value<<6)
}
func (o *SENSITIVE_Type) GetBACKUP_BUS_PMS_MONITOR_2_BACKUP_BUS_PMS_MONITOR_VIOLATE_STATUS_HWRITE() uint32 {
	return (volatile.LoadUint32(&o.BACKUP_BUS_PMS_MONITOR_2.Reg) & 0x40) >> 6
}

// SENSITIVE.BACKUP_BUS_PMS_MONITOR_3: SENSITIVE_BACKUP_BUS_PMS_MONITOR_3_REG
func (o *SENSITIVE_Type) SetBACKUP_BUS_PMS_MONITOR_3(value uint32) {
	volatile.StoreUint32(&o.BACKUP_BUS_PMS_MONITOR_3.Reg, value)
}
func (o *SENSITIVE_Type) GetBACKUP_BUS_PMS_MONITOR_3() uint32 {
	return volatile.LoadUint32(&o.BACKUP_BUS_PMS_MONITOR_3.Reg)
}

// SENSITIVE.CLOCK_GATE: SENSITIVE_CLOCK_GATE_REG
func (o *SENSITIVE_Type) SetCLOCK_GATE_CLK_EN(value uint32) {
	volatile.StoreUint32(&o.CLOCK_GATE.Reg, volatile.LoadUint32(&o.CLOCK_GATE.Reg)&^(0x1)|value)
}
func (o *SENSITIVE_Type) GetCLOCK_GATE_CLK_EN() uint32 {
	return volatile.LoadUint32(&o.CLOCK_GATE.Reg) & 0x1
}

// SENSITIVE.DATE: SENSITIVE_DATE_REG
func (o *SENSITIVE_Type) SetDATE(value uint32) {
	volatile.StoreUint32(&o.DATE.Reg, volatile.LoadUint32(&o.DATE.Reg)&^(0xfffffff)|value)
}
func (o *SENSITIVE_Type) GetDATE() uint32 {
	return volatile.LoadUint32(&o.DATE.Reg) & 0xfffffff
}

// Peripheral SHA
type SHA_Type struct {
	MODE          volatile.Register32 // 0x0
	T_STRING      volatile.Register32 // 0x4
	T_LENGTH      volatile.Register32 // 0x8
	DMA_BLOCK_NUM volatile.Register32 // 0xC
	START         volatile.Register32 // 0x10
	CONTINUE      volatile.Register32 // 0x14
	BUSY          volatile.Register32 // 0x18
	DMA_START     volatile.Register32 // 0x1C
	DMA_CONTINUE  volatile.Register32 // 0x20
	CLEAR_IRQ     volatile.Register32 // 0x24
	IRQ_ENA       volatile.Register32 // 0x28
	DATE          volatile.Register32 // 0x2C
	_             [16]byte
	H_MEM         volatile.Register32 // 0x40
	_             [60]byte
	M_MEM         volatile.Register32 // 0x80
}

// SHA.MODE: Initial configuration register.
func (o *SHA_Type) SetMODE(value uint32) {
	volatile.StoreUint32(&o.MODE.Reg, volatile.LoadUint32(&o.MODE.Reg)&^(0x7)|value)
}
func (o *SHA_Type) GetMODE() uint32 {
	return volatile.LoadUint32(&o.MODE.Reg) & 0x7
}

// SHA.T_STRING: SHA 512/t configuration register 0.
func (o *SHA_Type) SetT_STRING(value uint32) {
	volatile.StoreUint32(&o.T_STRING.Reg, value)
}
func (o *SHA_Type) GetT_STRING() uint32 {
	return volatile.LoadUint32(&o.T_STRING.Reg)
}

// SHA.T_LENGTH: SHA 512/t configuration register 1.
func (o *SHA_Type) SetT_LENGTH(value uint32) {
	volatile.StoreUint32(&o.T_LENGTH.Reg, volatile.LoadUint32(&o.T_LENGTH.Reg)&^(0x3f)|value)
}
func (o *SHA_Type) GetT_LENGTH() uint32 {
	return volatile.LoadUint32(&o.T_LENGTH.Reg) & 0x3f
}

// SHA.DMA_BLOCK_NUM: DMA configuration register 0.
func (o *SHA_Type) SetDMA_BLOCK_NUM(value uint32) {
	volatile.StoreUint32(&o.DMA_BLOCK_NUM.Reg, volatile.LoadUint32(&o.DMA_BLOCK_NUM.Reg)&^(0x3f)|value)
}
func (o *SHA_Type) GetDMA_BLOCK_NUM() uint32 {
	return volatile.LoadUint32(&o.DMA_BLOCK_NUM.Reg) & 0x3f
}

// SHA.START: Typical SHA configuration register 0.
func (o *SHA_Type) SetSTART(value uint32) {
	volatile.StoreUint32(&o.START.Reg, volatile.LoadUint32(&o.START.Reg)&^(0xfffffffe)|value<<1)
}
func (o *SHA_Type) GetSTART() uint32 {
	return (volatile.LoadUint32(&o.START.Reg) & 0xfffffffe) >> 1
}

// SHA.CONTINUE: Typical SHA configuration register 1.
func (o *SHA_Type) SetCONTINUE(value uint32) {
	volatile.StoreUint32(&o.CONTINUE.Reg, volatile.LoadUint32(&o.CONTINUE.Reg)&^(0xfffffffe)|value<<1)
}
func (o *SHA_Type) GetCONTINUE() uint32 {
	return (volatile.LoadUint32(&o.CONTINUE.Reg) & 0xfffffffe) >> 1
}

// SHA.BUSY: Busy register.
func (o *SHA_Type) SetBUSY_STATE(value uint32) {
	volatile.StoreUint32(&o.BUSY.Reg, volatile.LoadUint32(&o.BUSY.Reg)&^(0x1)|value)
}
func (o *SHA_Type) GetBUSY_STATE() uint32 {
	return volatile.LoadUint32(&o.BUSY.Reg) & 0x1
}

// SHA.DMA_START: DMA configuration register 1.
func (o *SHA_Type) SetDMA_START(value uint32) {
	volatile.StoreUint32(&o.DMA_START.Reg, volatile.LoadUint32(&o.DMA_START.Reg)&^(0x1)|value)
}
func (o *SHA_Type) GetDMA_START() uint32 {
	return volatile.LoadUint32(&o.DMA_START.Reg) & 0x1
}

// SHA.DMA_CONTINUE: DMA configuration register 2.
func (o *SHA_Type) SetDMA_CONTINUE(value uint32) {
	volatile.StoreUint32(&o.DMA_CONTINUE.Reg, volatile.LoadUint32(&o.DMA_CONTINUE.Reg)&^(0x1)|value)
}
func (o *SHA_Type) GetDMA_CONTINUE() uint32 {
	return volatile.LoadUint32(&o.DMA_CONTINUE.Reg) & 0x1
}

// SHA.CLEAR_IRQ: Interrupt clear register.
func (o *SHA_Type) SetCLEAR_IRQ_CLEAR_INTERRUPT(value uint32) {
	volatile.StoreUint32(&o.CLEAR_IRQ.Reg, volatile.LoadUint32(&o.CLEAR_IRQ.Reg)&^(0x1)|value)
}
func (o *SHA_Type) GetCLEAR_IRQ_CLEAR_INTERRUPT() uint32 {
	return volatile.LoadUint32(&o.CLEAR_IRQ.Reg) & 0x1
}

// SHA.IRQ_ENA: Interrupt enable register.
func (o *SHA_Type) SetIRQ_ENA_INTERRUPT_ENA(value uint32) {
	volatile.StoreUint32(&o.IRQ_ENA.Reg, volatile.LoadUint32(&o.IRQ_ENA.Reg)&^(0x1)|value)
}
func (o *SHA_Type) GetIRQ_ENA_INTERRUPT_ENA() uint32 {
	return volatile.LoadUint32(&o.IRQ_ENA.Reg) & 0x1
}

// SHA.DATE: Date register.
func (o *SHA_Type) SetDATE(value uint32) {
	volatile.StoreUint32(&o.DATE.Reg, volatile.LoadUint32(&o.DATE.Reg)&^(0x3fffffff)|value)
}
func (o *SHA_Type) GetDATE() uint32 {
	return volatile.LoadUint32(&o.DATE.Reg) & 0x3fffffff
}

// Peripheral SPI0
type SPI0_Type struct {
	_            [8]byte
	CTRL         volatile.Register32 // 0x8
	CTRL1        volatile.Register32 // 0xC
	CTRL2        volatile.Register32 // 0x10
	CLOCK        volatile.Register32 // 0x14
	USER         volatile.Register32 // 0x18
	USER1        volatile.Register32 // 0x1C
	USER2        volatile.Register32 // 0x20
	_            [8]byte
	RD_STATUS    volatile.Register32 // 0x2C
	_            [4]byte
	MISC         volatile.Register32 // 0x34
	_            [4]byte
	CACHE_FCTRL  volatile.Register32 // 0x3C
	_            [20]byte
	FSM          volatile.Register32 // 0x54
	_            [80]byte
	TIMING_CALI  volatile.Register32 // 0xA8
	DIN_MODE     volatile.Register32 // 0xAC
	DIN_NUM      volatile.Register32 // 0xB0
	DOUT_MODE    volatile.Register32 // 0xB4
	_            [36]byte
	CLOCK_GATE   volatile.Register32 // 0xDC
	CORE_CLK_SEL volatile.Register32 // 0xE0
	_            [792]byte
	DATE         volatile.Register32 // 0x3FC
}

// SPI0.CTRL: SPI0 control register.
func (o *SPI0_Type) SetCTRL_FDUMMY_OUT(value uint32) {
	volatile.StoreUint32(&o.CTRL.Reg, volatile.LoadUint32(&o.CTRL.Reg)&^(0x8)|value<<3)
}
func (o *SPI0_Type) GetCTRL_FDUMMY_OUT() uint32 {
	return (volatile.LoadUint32(&o.CTRL.Reg) & 0x8) >> 3
}
func (o *SPI0_Type) SetCTRL_FCMD_DUAL(value uint32) {
	volatile.StoreUint32(&o.CTRL.Reg, volatile.LoadUint32(&o.CTRL.Reg)&^(0x80)|value<<7)
}
func (o *SPI0_Type) GetCTRL_FCMD_DUAL() uint32 {
	return (volatile.LoadUint32(&o.CTRL.Reg) & 0x80) >> 7
}
func (o *SPI0_Type) SetCTRL_FCMD_QUAD(value uint32) {
	volatile.StoreUint32(&o.CTRL.Reg, volatile.LoadUint32(&o.CTRL.Reg)&^(0x100)|value<<8)
}
func (o *SPI0_Type) GetCTRL_FCMD_QUAD() uint32 {
	return (volatile.LoadUint32(&o.CTRL.Reg) & 0x100) >> 8
}
func (o *SPI0_Type) SetCTRL_FASTRD_MODE(value uint32) {
	volatile.StoreUint32(&o.CTRL.Reg, volatile.LoadUint32(&o.CTRL.Reg)&^(0x2000)|value<<13)
}
func (o *SPI0_Type) GetCTRL_FASTRD_MODE() uint32 {
	return (volatile.LoadUint32(&o.CTRL.Reg) & 0x2000) >> 13
}
func (o *SPI0_Type) SetCTRL_FREAD_DUAL(value uint32) {
	volatile.StoreUint32(&o.CTRL.Reg, volatile.LoadUint32(&o.CTRL.Reg)&^(0x4000)|value<<14)
}
func (o *SPI0_Type) GetCTRL_FREAD_DUAL() uint32 {
	return (volatile.LoadUint32(&o.CTRL.Reg) & 0x4000) >> 14
}
func (o *SPI0_Type) SetCTRL_Q_POL(value uint32) {
	volatile.StoreUint32(&o.CTRL.Reg, volatile.LoadUint32(&o.CTRL.Reg)&^(0x40000)|value<<18)
}
func (o *SPI0_Type) GetCTRL_Q_POL() uint32 {
	return (volatile.LoadUint32(&o.CTRL.Reg) & 0x40000) >> 18
}
func (o *SPI0_Type) SetCTRL_D_POL(value uint32) {
	volatile.StoreUint32(&o.CTRL.Reg, volatile.LoadUint32(&o.CTRL.Reg)&^(0x80000)|value<<19)
}
func (o *SPI0_Type) GetCTRL_D_POL() uint32 {
	return (volatile.LoadUint32(&o.CTRL.Reg) & 0x80000) >> 19
}
func (o *SPI0_Type) SetCTRL_FREAD_QUAD(value uint32) {
	volatile.StoreUint32(&o.CTRL.Reg, volatile.LoadUint32(&o.CTRL.Reg)&^(0x100000)|value<<20)
}
func (o *SPI0_Type) GetCTRL_FREAD_QUAD() uint32 {
	return (volatile.LoadUint32(&o.CTRL.Reg) & 0x100000) >> 20
}
func (o *SPI0_Type) SetCTRL_WP(value uint32) {
	volatile.StoreUint32(&o.CTRL.Reg, volatile.LoadUint32(&o.CTRL.Reg)&^(0x200000)|value<<21)
}
func (o *SPI0_Type) GetCTRL_WP() uint32 {
	return (volatile.LoadUint32(&o.CTRL.Reg) & 0x200000) >> 21
}
func (o *SPI0_Type) SetCTRL_FREAD_DIO(value uint32) {
	volatile.StoreUint32(&o.CTRL.Reg, volatile.LoadUint32(&o.CTRL.Reg)&^(0x800000)|value<<23)
}
func (o *SPI0_Type) GetCTRL_FREAD_DIO() uint32 {
	return (volatile.LoadUint32(&o.CTRL.Reg) & 0x800000) >> 23
}
func (o *SPI0_Type) SetCTRL_FREAD_QIO(value uint32) {
	volatile.StoreUint32(&o.CTRL.Reg, volatile.LoadUint32(&o.CTRL.Reg)&^(0x1000000)|value<<24)
}
func (o *SPI0_Type) GetCTRL_FREAD_QIO() uint32 {
	return (volatile.LoadUint32(&o.CTRL.Reg) & 0x1000000) >> 24
}

// SPI0.CTRL1: SPI0 control1 register.
func (o *SPI0_Type) SetCTRL1_CLK_MODE(value uint32) {
	volatile.StoreUint32(&o.CTRL1.Reg, volatile.LoadUint32(&o.CTRL1.Reg)&^(0x3)|value)
}
func (o *SPI0_Type) GetCTRL1_CLK_MODE() uint32 {
	return volatile.LoadUint32(&o.CTRL1.Reg) & 0x3
}
func (o *SPI0_Type) SetCTRL1_RXFIFO_RST(value uint32) {
	volatile.StoreUint32(&o.CTRL1.Reg, volatile.LoadUint32(&o.CTRL1.Reg)&^(0x40000000)|value<<30)
}
func (o *SPI0_Type) GetCTRL1_RXFIFO_RST() uint32 {
	return (volatile.LoadUint32(&o.CTRL1.Reg) & 0x40000000) >> 30
}

// SPI0.CTRL2: SPI0 control2 register.
func (o *SPI0_Type) SetCTRL2_CS_SETUP_TIME(value uint32) {
	volatile.StoreUint32(&o.CTRL2.Reg, volatile.LoadUint32(&o.CTRL2.Reg)&^(0x1f)|value)
}
func (o *SPI0_Type) GetCTRL2_CS_SETUP_TIME() uint32 {
	return volatile.LoadUint32(&o.CTRL2.Reg) & 0x1f
}
func (o *SPI0_Type) SetCTRL2_CS_HOLD_TIME(value uint32) {
	volatile.StoreUint32(&o.CTRL2.Reg, volatile.LoadUint32(&o.CTRL2.Reg)&^(0x3e0)|value<<5)
}
func (o *SPI0_Type) GetCTRL2_CS_HOLD_TIME() uint32 {
	return (volatile.LoadUint32(&o.CTRL2.Reg) & 0x3e0) >> 5
}
func (o *SPI0_Type) SetCTRL2_CS_HOLD_DELAY(value uint32) {
	volatile.StoreUint32(&o.CTRL2.Reg, volatile.LoadUint32(&o.CTRL2.Reg)&^(0x7e000000)|value<<25)
}
func (o *SPI0_Type) GetCTRL2_CS_HOLD_DELAY() uint32 {
	return (volatile.LoadUint32(&o.CTRL2.Reg) & 0x7e000000) >> 25
}
func (o *SPI0_Type) SetCTRL2_SYNC_RESET(value uint32) {
	volatile.StoreUint32(&o.CTRL2.Reg, volatile.LoadUint32(&o.CTRL2.Reg)&^(0x80000000)|value<<31)
}
func (o *SPI0_Type) GetCTRL2_SYNC_RESET() uint32 {
	return (volatile.LoadUint32(&o.CTRL2.Reg) & 0x80000000) >> 31
}

// SPI0.CLOCK: SPI clock division control register.
func (o *SPI0_Type) SetCLOCK_CLKCNT_L(value uint32) {
	volatile.StoreUint32(&o.CLOCK.Reg, volatile.LoadUint32(&o.CLOCK.Reg)&^(0xff)|value)
}
func (o *SPI0_Type) GetCLOCK_CLKCNT_L() uint32 {
	return volatile.LoadUint32(&o.CLOCK.Reg) & 0xff
}
func (o *SPI0_Type) SetCLOCK_CLKCNT_H(value uint32) {
	volatile.StoreUint32(&o.CLOCK.Reg, volatile.LoadUint32(&o.CLOCK.Reg)&^(0xff00)|value<<8)
}
func (o *SPI0_Type) GetCLOCK_CLKCNT_H() uint32 {
	return (volatile.LoadUint32(&o.CLOCK.Reg) & 0xff00) >> 8
}
func (o *SPI0_Type) SetCLOCK_CLKCNT_N(value uint32) {
	volatile.StoreUint32(&o.CLOCK.Reg, volatile.LoadUint32(&o.CLOCK.Reg)&^(0xff0000)|value<<16)
}
func (o *SPI0_Type) GetCLOCK_CLKCNT_N() uint32 {
	return (volatile.LoadUint32(&o.CLOCK.Reg) & 0xff0000) >> 16
}
func (o *SPI0_Type) SetCLOCK_CLK_EQU_SYSCLK(value uint32) {
	volatile.StoreUint32(&o.CLOCK.Reg, volatile.LoadUint32(&o.CLOCK.Reg)&^(0x80000000)|value<<31)
}
func (o *SPI0_Type) GetCLOCK_CLK_EQU_SYSCLK() uint32 {
	return (volatile.LoadUint32(&o.CLOCK.Reg) & 0x80000000) >> 31
}

// SPI0.USER: SPI0 user register.
func (o *SPI0_Type) SetUSER_CS_HOLD(value uint32) {
	volatile.StoreUint32(&o.USER.Reg, volatile.LoadUint32(&o.USER.Reg)&^(0x40)|value<<6)
}
func (o *SPI0_Type) GetUSER_CS_HOLD() uint32 {
	return (volatile.LoadUint32(&o.USER.Reg) & 0x40) >> 6
}
func (o *SPI0_Type) SetUSER_CS_SETUP(value uint32) {
	volatile.StoreUint32(&o.USER.Reg, volatile.LoadUint32(&o.USER.Reg)&^(0x80)|value<<7)
}
func (o *SPI0_Type) GetUSER_CS_SETUP() uint32 {
	return (volatile.LoadUint32(&o.USER.Reg) & 0x80) >> 7
}
func (o *SPI0_Type) SetUSER_CK_OUT_EDGE(value uint32) {
	volatile.StoreUint32(&o.USER.Reg, volatile.LoadUint32(&o.USER.Reg)&^(0x200)|value<<9)
}
func (o *SPI0_Type) GetUSER_CK_OUT_EDGE() uint32 {
	return (volatile.LoadUint32(&o.USER.Reg) & 0x200) >> 9
}
func (o *SPI0_Type) SetUSER_USR_DUMMY_IDLE(value uint32) {
	volatile.StoreUint32(&o.USER.Reg, volatile.LoadUint32(&o.USER.Reg)&^(0x4000000)|value<<26)
}
func (o *SPI0_Type) GetUSER_USR_DUMMY_IDLE() uint32 {
	return (volatile.LoadUint32(&o.USER.Reg) & 0x4000000) >> 26
}
func (o *SPI0_Type) SetUSER_USR_DUMMY(value uint32) {
	volatile.StoreUint32(&o.USER.Reg, volatile.LoadUint32(&o.USER.Reg)&^(0x20000000)|value<<29)
}
func (o *SPI0_Type) GetUSER_USR_DUMMY() uint32 {
	return (volatile.LoadUint32(&o.USER.Reg) & 0x20000000) >> 29
}

// SPI0.USER1: SPI0 user1 register.
func (o *SPI0_Type) SetUSER1_USR_DUMMY_CYCLELEN(value uint32) {
	volatile.StoreUint32(&o.USER1.Reg, volatile.LoadUint32(&o.USER1.Reg)&^(0x3f)|value)
}
func (o *SPI0_Type) GetUSER1_USR_DUMMY_CYCLELEN() uint32 {
	return volatile.LoadUint32(&o.USER1.Reg) & 0x3f
}
func (o *SPI0_Type) SetUSER1_USR_ADDR_BITLEN(value uint32) {
	volatile.StoreUint32(&o.USER1.Reg, volatile.LoadUint32(&o.USER1.Reg)&^(0xfc000000)|value<<26)
}
func (o *SPI0_Type) GetUSER1_USR_ADDR_BITLEN() uint32 {
	return (volatile.LoadUint32(&o.USER1.Reg) & 0xfc000000) >> 26
}

// SPI0.USER2: SPI0 user2 register.
func (o *SPI0_Type) SetUSER2_USR_COMMAND_VALUE(value uint32) {
	volatile.StoreUint32(&o.USER2.Reg, volatile.LoadUint32(&o.USER2.Reg)&^(0xffff)|value)
}
func (o *SPI0_Type) GetUSER2_USR_COMMAND_VALUE() uint32 {
	return volatile.LoadUint32(&o.USER2.Reg) & 0xffff
}
func (o *SPI0_Type) SetUSER2_USR_COMMAND_BITLEN(value uint32) {
	volatile.StoreUint32(&o.USER2.Reg, volatile.LoadUint32(&o.USER2.Reg)&^(0xf0000000)|value<<28)
}
func (o *SPI0_Type) GetUSER2_USR_COMMAND_BITLEN() uint32 {
	return (volatile.LoadUint32(&o.USER2.Reg) & 0xf0000000) >> 28
}

// SPI0.RD_STATUS: SPI0 read control register.
func (o *SPI0_Type) SetRD_STATUS_WB_MODE(value uint32) {
	volatile.StoreUint32(&o.RD_STATUS.Reg, volatile.LoadUint32(&o.RD_STATUS.Reg)&^(0xff0000)|value<<16)
}
func (o *SPI0_Type) GetRD_STATUS_WB_MODE() uint32 {
	return (volatile.LoadUint32(&o.RD_STATUS.Reg) & 0xff0000) >> 16
}

// SPI0.MISC: SPI0 misc register
func (o *SPI0_Type) SetMISC_TRANS_END(value uint32) {
	volatile.StoreUint32(&o.MISC.Reg, volatile.LoadUint32(&o.MISC.Reg)&^(0x8)|value<<3)
}
func (o *SPI0_Type) GetMISC_TRANS_END() uint32 {
	return (volatile.LoadUint32(&o.MISC.Reg) & 0x8) >> 3
}
func (o *SPI0_Type) SetMISC_TRANS_END_INT_ENA(value uint32) {
	volatile.StoreUint32(&o.MISC.Reg, volatile.LoadUint32(&o.MISC.Reg)&^(0x10)|value<<4)
}
func (o *SPI0_Type) GetMISC_TRANS_END_INT_ENA() uint32 {
	return (volatile.LoadUint32(&o.MISC.Reg) & 0x10) >> 4
}
func (o *SPI0_Type) SetMISC_CSPI_ST_TRANS_END(value uint32) {
	volatile.StoreUint32(&o.MISC.Reg, volatile.LoadUint32(&o.MISC.Reg)&^(0x20)|value<<5)
}
func (o *SPI0_Type) GetMISC_CSPI_ST_TRANS_END() uint32 {
	return (volatile.LoadUint32(&o.MISC.Reg) & 0x20) >> 5
}
func (o *SPI0_Type) SetMISC_CSPI_ST_TRANS_END_INT_ENA(value uint32) {
	volatile.StoreUint32(&o.MISC.Reg, volatile.LoadUint32(&o.MISC.Reg)&^(0x40)|value<<6)
}
func (o *SPI0_Type) GetMISC_CSPI_ST_TRANS_END_INT_ENA() uint32 {
	return (volatile.LoadUint32(&o.MISC.Reg) & 0x40) >> 6
}
func (o *SPI0_Type) SetMISC_CK_IDLE_EDGE(value uint32) {
	volatile.StoreUint32(&o.MISC.Reg, volatile.LoadUint32(&o.MISC.Reg)&^(0x200)|value<<9)
}
func (o *SPI0_Type) GetMISC_CK_IDLE_EDGE() uint32 {
	return (volatile.LoadUint32(&o.MISC.Reg) & 0x200) >> 9
}
func (o *SPI0_Type) SetMISC_CS_KEEP_ACTIVE(value uint32) {
	volatile.StoreUint32(&o.MISC.Reg, volatile.LoadUint32(&o.MISC.Reg)&^(0x400)|value<<10)
}
func (o *SPI0_Type) GetMISC_CS_KEEP_ACTIVE() uint32 {
	return (volatile.LoadUint32(&o.MISC.Reg) & 0x400) >> 10
}

// SPI0.CACHE_FCTRL: SPI0 bit mode control register.
func (o *SPI0_Type) SetCACHE_FCTRL_CACHE_REQ_EN(value uint32) {
	volatile.StoreUint32(&o.CACHE_FCTRL.Reg, volatile.LoadUint32(&o.CACHE_FCTRL.Reg)&^(0x1)|value)
}
func (o *SPI0_Type) GetCACHE_FCTRL_CACHE_REQ_EN() uint32 {
	return volatile.LoadUint32(&o.CACHE_FCTRL.Reg) & 0x1
}
func (o *SPI0_Type) SetCACHE_FCTRL_CACHE_USR_ADDR_4BYTE(value uint32) {
	volatile.StoreUint32(&o.CACHE_FCTRL.Reg, volatile.LoadUint32(&o.CACHE_FCTRL.Reg)&^(0x2)|value<<1)
}
func (o *SPI0_Type) GetCACHE_FCTRL_CACHE_USR_ADDR_4BYTE() uint32 {
	return (volatile.LoadUint32(&o.CACHE_FCTRL.Reg) & 0x2) >> 1
}
func (o *SPI0_Type) SetCACHE_FCTRL_CACHE_FLASH_USR_CMD(value uint32) {
	volatile.StoreUint32(&o.CACHE_FCTRL.Reg, volatile.LoadUint32(&o.CACHE_FCTRL.Reg)&^(0x4)|value<<2)
}
func (o *SPI0_Type) GetCACHE_FCTRL_CACHE_FLASH_USR_CMD() uint32 {
	return (volatile.LoadUint32(&o.CACHE_FCTRL.Reg) & 0x4) >> 2
}
func (o *SPI0_Type) SetCACHE_FCTRL_FDIN_DUAL(value uint32) {
	volatile.StoreUint32(&o.CACHE_FCTRL.Reg, volatile.LoadUint32(&o.CACHE_FCTRL.Reg)&^(0x8)|value<<3)
}
func (o *SPI0_Type) GetCACHE_FCTRL_FDIN_DUAL() uint32 {
	return (volatile.LoadUint32(&o.CACHE_FCTRL.Reg) & 0x8) >> 3
}
func (o *SPI0_Type) SetCACHE_FCTRL_FDOUT_DUAL(value uint32) {
	volatile.StoreUint32(&o.CACHE_FCTRL.Reg, volatile.LoadUint32(&o.CACHE_FCTRL.Reg)&^(0x10)|value<<4)
}
func (o *SPI0_Type) GetCACHE_FCTRL_FDOUT_DUAL() uint32 {
	return (volatile.LoadUint32(&o.CACHE_FCTRL.Reg) & 0x10) >> 4
}
func (o *SPI0_Type) SetCACHE_FCTRL_FADDR_DUAL(value uint32) {
	volatile.StoreUint32(&o.CACHE_FCTRL.Reg, volatile.LoadUint32(&o.CACHE_FCTRL.Reg)&^(0x20)|value<<5)
}
func (o *SPI0_Type) GetCACHE_FCTRL_FADDR_DUAL() uint32 {
	return (volatile.LoadUint32(&o.CACHE_FCTRL.Reg) & 0x20) >> 5
}
func (o *SPI0_Type) SetCACHE_FCTRL_FDIN_QUAD(value uint32) {
	volatile.StoreUint32(&o.CACHE_FCTRL.Reg, volatile.LoadUint32(&o.CACHE_FCTRL.Reg)&^(0x40)|value<<6)
}
func (o *SPI0_Type) GetCACHE_FCTRL_FDIN_QUAD() uint32 {
	return (volatile.LoadUint32(&o.CACHE_FCTRL.Reg) & 0x40) >> 6
}
func (o *SPI0_Type) SetCACHE_FCTRL_FDOUT_QUAD(value uint32) {
	volatile.StoreUint32(&o.CACHE_FCTRL.Reg, volatile.LoadUint32(&o.CACHE_FCTRL.Reg)&^(0x80)|value<<7)
}
func (o *SPI0_Type) GetCACHE_FCTRL_FDOUT_QUAD() uint32 {
	return (volatile.LoadUint32(&o.CACHE_FCTRL.Reg) & 0x80) >> 7
}
func (o *SPI0_Type) SetCACHE_FCTRL_FADDR_QUAD(value uint32) {
	volatile.StoreUint32(&o.CACHE_FCTRL.Reg, volatile.LoadUint32(&o.CACHE_FCTRL.Reg)&^(0x100)|value<<8)
}
func (o *SPI0_Type) GetCACHE_FCTRL_FADDR_QUAD() uint32 {
	return (volatile.LoadUint32(&o.CACHE_FCTRL.Reg) & 0x100) >> 8
}

// SPI0.FSM: SPI0 FSM status register
func (o *SPI0_Type) SetFSM_CSPI_ST(value uint32) {
	volatile.StoreUint32(&o.FSM.Reg, volatile.LoadUint32(&o.FSM.Reg)&^(0xf)|value)
}
func (o *SPI0_Type) GetFSM_CSPI_ST() uint32 {
	return volatile.LoadUint32(&o.FSM.Reg) & 0xf
}
func (o *SPI0_Type) SetFSM_EM_ST(value uint32) {
	volatile.StoreUint32(&o.FSM.Reg, volatile.LoadUint32(&o.FSM.Reg)&^(0x70)|value<<4)
}
func (o *SPI0_Type) GetFSM_EM_ST() uint32 {
	return (volatile.LoadUint32(&o.FSM.Reg) & 0x70) >> 4
}
func (o *SPI0_Type) SetFSM_CSPI_LOCK_DELAY_TIME(value uint32) {
	volatile.StoreUint32(&o.FSM.Reg, volatile.LoadUint32(&o.FSM.Reg)&^(0xf80)|value<<7)
}
func (o *SPI0_Type) GetFSM_CSPI_LOCK_DELAY_TIME() uint32 {
	return (volatile.LoadUint32(&o.FSM.Reg) & 0xf80) >> 7
}

// SPI0.TIMING_CALI: SPI0 timing calibration register
func (o *SPI0_Type) SetTIMING_CALI_TIMING_CLK_ENA(value uint32) {
	volatile.StoreUint32(&o.TIMING_CALI.Reg, volatile.LoadUint32(&o.TIMING_CALI.Reg)&^(0x1)|value)
}
func (o *SPI0_Type) GetTIMING_CALI_TIMING_CLK_ENA() uint32 {
	return volatile.LoadUint32(&o.TIMING_CALI.Reg) & 0x1
}
func (o *SPI0_Type) SetTIMING_CALI(value uint32) {
	volatile.StoreUint32(&o.TIMING_CALI.Reg, volatile.LoadUint32(&o.TIMING_CALI.Reg)&^(0x2)|value<<1)
}
func (o *SPI0_Type) GetTIMING_CALI() uint32 {
	return (volatile.LoadUint32(&o.TIMING_CALI.Reg) & 0x2) >> 1
}
func (o *SPI0_Type) SetTIMING_CALI_EXTRA_DUMMY_CYCLELEN(value uint32) {
	volatile.StoreUint32(&o.TIMING_CALI.Reg, volatile.LoadUint32(&o.TIMING_CALI.Reg)&^(0x1c)|value<<2)
}
func (o *SPI0_Type) GetTIMING_CALI_EXTRA_DUMMY_CYCLELEN() uint32 {
	return (volatile.LoadUint32(&o.TIMING_CALI.Reg) & 0x1c) >> 2
}

// SPI0.DIN_MODE: SPI0 input delay mode control register
func (o *SPI0_Type) SetDIN_MODE_DIN0_MODE(value uint32) {
	volatile.StoreUint32(&o.DIN_MODE.Reg, volatile.LoadUint32(&o.DIN_MODE.Reg)&^(0x3)|value)
}
func (o *SPI0_Type) GetDIN_MODE_DIN0_MODE() uint32 {
	return volatile.LoadUint32(&o.DIN_MODE.Reg) & 0x3
}
func (o *SPI0_Type) SetDIN_MODE_DIN1_MODE(value uint32) {
	volatile.StoreUint32(&o.DIN_MODE.Reg, volatile.LoadUint32(&o.DIN_MODE.Reg)&^(0xc)|value<<2)
}
func (o *SPI0_Type) GetDIN_MODE_DIN1_MODE() uint32 {
	return (volatile.LoadUint32(&o.DIN_MODE.Reg) & 0xc) >> 2
}
func (o *SPI0_Type) SetDIN_MODE_DIN2_MODE(value uint32) {
	volatile.StoreUint32(&o.DIN_MODE.Reg, volatile.LoadUint32(&o.DIN_MODE.Reg)&^(0x30)|value<<4)
}
func (o *SPI0_Type) GetDIN_MODE_DIN2_MODE() uint32 {
	return (volatile.LoadUint32(&o.DIN_MODE.Reg) & 0x30) >> 4
}
func (o *SPI0_Type) SetDIN_MODE_DIN3_MODE(value uint32) {
	volatile.StoreUint32(&o.DIN_MODE.Reg, volatile.LoadUint32(&o.DIN_MODE.Reg)&^(0xc0)|value<<6)
}
func (o *SPI0_Type) GetDIN_MODE_DIN3_MODE() uint32 {
	return (volatile.LoadUint32(&o.DIN_MODE.Reg) & 0xc0) >> 6
}

// SPI0.DIN_NUM: SPI0 input delay number control register
func (o *SPI0_Type) SetDIN_NUM_DIN0_NUM(value uint32) {
	volatile.StoreUint32(&o.DIN_NUM.Reg, volatile.LoadUint32(&o.DIN_NUM.Reg)&^(0x3)|value)
}
func (o *SPI0_Type) GetDIN_NUM_DIN0_NUM() uint32 {
	return volatile.LoadUint32(&o.DIN_NUM.Reg) & 0x3
}
func (o *SPI0_Type) SetDIN_NUM_DIN1_NUM(value uint32) {
	volatile.StoreUint32(&o.DIN_NUM.Reg, volatile.LoadUint32(&o.DIN_NUM.Reg)&^(0xc)|value<<2)
}
func (o *SPI0_Type) GetDIN_NUM_DIN1_NUM() uint32 {
	return (volatile.LoadUint32(&o.DIN_NUM.Reg) & 0xc) >> 2
}
func (o *SPI0_Type) SetDIN_NUM_DIN2_NUM(value uint32) {
	volatile.StoreUint32(&o.DIN_NUM.Reg, volatile.LoadUint32(&o.DIN_NUM.Reg)&^(0x30)|value<<4)
}
func (o *SPI0_Type) GetDIN_NUM_DIN2_NUM() uint32 {
	return (volatile.LoadUint32(&o.DIN_NUM.Reg) & 0x30) >> 4
}
func (o *SPI0_Type) SetDIN_NUM_DIN3_NUM(value uint32) {
	volatile.StoreUint32(&o.DIN_NUM.Reg, volatile.LoadUint32(&o.DIN_NUM.Reg)&^(0xc0)|value<<6)
}
func (o *SPI0_Type) GetDIN_NUM_DIN3_NUM() uint32 {
	return (volatile.LoadUint32(&o.DIN_NUM.Reg) & 0xc0) >> 6
}

// SPI0.DOUT_MODE: SPI0 output delay mode control register
func (o *SPI0_Type) SetDOUT_MODE_DOUT0_MODE(value uint32) {
	volatile.StoreUint32(&o.DOUT_MODE.Reg, volatile.LoadUint32(&o.DOUT_MODE.Reg)&^(0x1)|value)
}
func (o *SPI0_Type) GetDOUT_MODE_DOUT0_MODE() uint32 {
	return volatile.LoadUint32(&o.DOUT_MODE.Reg) & 0x1
}
func (o *SPI0_Type) SetDOUT_MODE_DOUT1_MODE(value uint32) {
	volatile.StoreUint32(&o.DOUT_MODE.Reg, volatile.LoadUint32(&o.DOUT_MODE.Reg)&^(0x2)|value<<1)
}
func (o *SPI0_Type) GetDOUT_MODE_DOUT1_MODE() uint32 {
	return (volatile.LoadUint32(&o.DOUT_MODE.Reg) & 0x2) >> 1
}
func (o *SPI0_Type) SetDOUT_MODE_DOUT2_MODE(value uint32) {
	volatile.StoreUint32(&o.DOUT_MODE.Reg, volatile.LoadUint32(&o.DOUT_MODE.Reg)&^(0x4)|value<<2)
}
func (o *SPI0_Type) GetDOUT_MODE_DOUT2_MODE() uint32 {
	return (volatile.LoadUint32(&o.DOUT_MODE.Reg) & 0x4) >> 2
}
func (o *SPI0_Type) SetDOUT_MODE_DOUT3_MODE(value uint32) {
	volatile.StoreUint32(&o.DOUT_MODE.Reg, volatile.LoadUint32(&o.DOUT_MODE.Reg)&^(0x8)|value<<3)
}
func (o *SPI0_Type) GetDOUT_MODE_DOUT3_MODE() uint32 {
	return (volatile.LoadUint32(&o.DOUT_MODE.Reg) & 0x8) >> 3
}

// SPI0.CLOCK_GATE: SPI0 clk_gate register
func (o *SPI0_Type) SetCLOCK_GATE_CLK_EN(value uint32) {
	volatile.StoreUint32(&o.CLOCK_GATE.Reg, volatile.LoadUint32(&o.CLOCK_GATE.Reg)&^(0x1)|value)
}
func (o *SPI0_Type) GetCLOCK_GATE_CLK_EN() uint32 {
	return volatile.LoadUint32(&o.CLOCK_GATE.Reg) & 0x1
}

// SPI0.CORE_CLK_SEL: SPI0 module clock select register
func (o *SPI0_Type) SetCORE_CLK_SEL_SPI01_CLK_SEL(value uint32) {
	volatile.StoreUint32(&o.CORE_CLK_SEL.Reg, volatile.LoadUint32(&o.CORE_CLK_SEL.Reg)&^(0x3)|value)
}
func (o *SPI0_Type) GetCORE_CLK_SEL_SPI01_CLK_SEL() uint32 {
	return volatile.LoadUint32(&o.CORE_CLK_SEL.Reg) & 0x3
}

// SPI0.DATE: Version control register
func (o *SPI0_Type) SetDATE(value uint32) {
	volatile.StoreUint32(&o.DATE.Reg, volatile.LoadUint32(&o.DATE.Reg)&^(0xfffffff)|value)
}
func (o *SPI0_Type) GetDATE() uint32 {
	return volatile.LoadUint32(&o.DATE.Reg) & 0xfffffff
}

// Peripheral SPI1
type SPI1_Type struct {
	CMD              volatile.Register32 // 0x0
	ADDR             volatile.Register32 // 0x4
	CTRL             volatile.Register32 // 0x8
	CTRL1            volatile.Register32 // 0xC
	CTRL2            volatile.Register32 // 0x10
	CLOCK            volatile.Register32 // 0x14
	USER             volatile.Register32 // 0x18
	USER1            volatile.Register32 // 0x1C
	USER2            volatile.Register32 // 0x20
	MOSI_DLEN        volatile.Register32 // 0x24
	MISO_DLEN        volatile.Register32 // 0x28
	RD_STATUS        volatile.Register32 // 0x2C
	_                [4]byte
	MISC             volatile.Register32 // 0x34
	TX_CRC           volatile.Register32 // 0x38
	CACHE_FCTRL      volatile.Register32 // 0x3C
	_                [24]byte
	W0               volatile.Register32 // 0x58
	W1               volatile.Register32 // 0x5C
	W2               volatile.Register32 // 0x60
	W3               volatile.Register32 // 0x64
	W4               volatile.Register32 // 0x68
	W5               volatile.Register32 // 0x6C
	W6               volatile.Register32 // 0x70
	W7               volatile.Register32 // 0x74
	W8               volatile.Register32 // 0x78
	W9               volatile.Register32 // 0x7C
	W10              volatile.Register32 // 0x80
	W11              volatile.Register32 // 0x84
	W12              volatile.Register32 // 0x88
	W13              volatile.Register32 // 0x8C
	W14              volatile.Register32 // 0x90
	W15              volatile.Register32 // 0x94
	FLASH_WAITI_CTRL volatile.Register32 // 0x98
	FLASH_SUS_CTRL   volatile.Register32 // 0x9C
	FLASH_SUS_CMD    volatile.Register32 // 0xA0
	SUS_STATUS       volatile.Register32 // 0xA4
	TIMING_CALI      volatile.Register32 // 0xA8
	_                [20]byte
	INT_ENA          volatile.Register32 // 0xC0
	INT_CLR          volatile.Register32 // 0xC4
	INT_RAW          volatile.Register32 // 0xC8
	INT_ST           volatile.Register32 // 0xCC
	_                [12]byte
	CLOCK_GATE       volatile.Register32 // 0xDC
	_                [796]byte
	DATE             volatile.Register32 // 0x3FC
}

// SPI1.CMD: SPI1 memory command register
func (o *SPI1_Type) SetCMD_SPI1_MST_ST(value uint32) {
	volatile.StoreUint32(&o.CMD.Reg, volatile.LoadUint32(&o.CMD.Reg)&^(0xf)|value)
}
func (o *SPI1_Type) GetCMD_SPI1_MST_ST() uint32 {
	return volatile.LoadUint32(&o.CMD.Reg) & 0xf
}
func (o *SPI1_Type) SetCMD_MSPI_ST(value uint32) {
	volatile.StoreUint32(&o.CMD.Reg, volatile.LoadUint32(&o.CMD.Reg)&^(0xf0)|value<<4)
}
func (o *SPI1_Type) GetCMD_MSPI_ST() uint32 {
	return (volatile.LoadUint32(&o.CMD.Reg) & 0xf0) >> 4
}
func (o *SPI1_Type) SetCMD_FLASH_PE(value uint32) {
	volatile.StoreUint32(&o.CMD.Reg, volatile.LoadUint32(&o.CMD.Reg)&^(0x20000)|value<<17)
}
func (o *SPI1_Type) GetCMD_FLASH_PE() uint32 {
	return (volatile.LoadUint32(&o.CMD.Reg) & 0x20000) >> 17
}
func (o *SPI1_Type) SetCMD_USR(value uint32) {
	volatile.StoreUint32(&o.CMD.Reg, volatile.LoadUint32(&o.CMD.Reg)&^(0x40000)|value<<18)
}
func (o *SPI1_Type) GetCMD_USR() uint32 {
	return (volatile.LoadUint32(&o.CMD.Reg) & 0x40000) >> 18
}
func (o *SPI1_Type) SetCMD_FLASH_HPM(value uint32) {
	volatile.StoreUint32(&o.CMD.Reg, volatile.LoadUint32(&o.CMD.Reg)&^(0x80000)|value<<19)
}
func (o *SPI1_Type) GetCMD_FLASH_HPM() uint32 {
	return (volatile.LoadUint32(&o.CMD.Reg) & 0x80000) >> 19
}
func (o *SPI1_Type) SetCMD_FLASH_RES(value uint32) {
	volatile.StoreUint32(&o.CMD.Reg, volatile.LoadUint32(&o.CMD.Reg)&^(0x100000)|value<<20)
}
func (o *SPI1_Type) GetCMD_FLASH_RES() uint32 {
	return (volatile.LoadUint32(&o.CMD.Reg) & 0x100000) >> 20
}
func (o *SPI1_Type) SetCMD_FLASH_DP(value uint32) {
	volatile.StoreUint32(&o.CMD.Reg, volatile.LoadUint32(&o.CMD.Reg)&^(0x200000)|value<<21)
}
func (o *SPI1_Type) GetCMD_FLASH_DP() uint32 {
	return (volatile.LoadUint32(&o.CMD.Reg) & 0x200000) >> 21
}
func (o *SPI1_Type) SetCMD_FLASH_CE(value uint32) {
	volatile.StoreUint32(&o.CMD.Reg, volatile.LoadUint32(&o.CMD.Reg)&^(0x400000)|value<<22)
}
func (o *SPI1_Type) GetCMD_FLASH_CE() uint32 {
	return (volatile.LoadUint32(&o.CMD.Reg) & 0x400000) >> 22
}
func (o *SPI1_Type) SetCMD_FLASH_BE(value uint32) {
	volatile.StoreUint32(&o.CMD.Reg, volatile.LoadUint32(&o.CMD.Reg)&^(0x800000)|value<<23)
}
func (o *SPI1_Type) GetCMD_FLASH_BE() uint32 {
	return (volatile.LoadUint32(&o.CMD.Reg) & 0x800000) >> 23
}
func (o *SPI1_Type) SetCMD_FLASH_SE(value uint32) {
	volatile.StoreUint32(&o.CMD.Reg, volatile.LoadUint32(&o.CMD.Reg)&^(0x1000000)|value<<24)
}
func (o *SPI1_Type) GetCMD_FLASH_SE() uint32 {
	return (volatile.LoadUint32(&o.CMD.Reg) & 0x1000000) >> 24
}
func (o *SPI1_Type) SetCMD_FLASH_PP(value uint32) {
	volatile.StoreUint32(&o.CMD.Reg, volatile.LoadUint32(&o.CMD.Reg)&^(0x2000000)|value<<25)
}
func (o *SPI1_Type) GetCMD_FLASH_PP() uint32 {
	return (volatile.LoadUint32(&o.CMD.Reg) & 0x2000000) >> 25
}
func (o *SPI1_Type) SetCMD_FLASH_WRSR(value uint32) {
	volatile.StoreUint32(&o.CMD.Reg, volatile.LoadUint32(&o.CMD.Reg)&^(0x4000000)|value<<26)
}
func (o *SPI1_Type) GetCMD_FLASH_WRSR() uint32 {
	return (volatile.LoadUint32(&o.CMD.Reg) & 0x4000000) >> 26
}
func (o *SPI1_Type) SetCMD_FLASH_RDSR(value uint32) {
	volatile.StoreUint32(&o.CMD.Reg, volatile.LoadUint32(&o.CMD.Reg)&^(0x8000000)|value<<27)
}
func (o *SPI1_Type) GetCMD_FLASH_RDSR() uint32 {
	return (volatile.LoadUint32(&o.CMD.Reg) & 0x8000000) >> 27
}
func (o *SPI1_Type) SetCMD_FLASH_RDID(value uint32) {
	volatile.StoreUint32(&o.CMD.Reg, volatile.LoadUint32(&o.CMD.Reg)&^(0x10000000)|value<<28)
}
func (o *SPI1_Type) GetCMD_FLASH_RDID() uint32 {
	return (volatile.LoadUint32(&o.CMD.Reg) & 0x10000000) >> 28
}
func (o *SPI1_Type) SetCMD_FLASH_WRDI(value uint32) {
	volatile.StoreUint32(&o.CMD.Reg, volatile.LoadUint32(&o.CMD.Reg)&^(0x20000000)|value<<29)
}
func (o *SPI1_Type) GetCMD_FLASH_WRDI() uint32 {
	return (volatile.LoadUint32(&o.CMD.Reg) & 0x20000000) >> 29
}
func (o *SPI1_Type) SetCMD_FLASH_WREN(value uint32) {
	volatile.StoreUint32(&o.CMD.Reg, volatile.LoadUint32(&o.CMD.Reg)&^(0x40000000)|value<<30)
}
func (o *SPI1_Type) GetCMD_FLASH_WREN() uint32 {
	return (volatile.LoadUint32(&o.CMD.Reg) & 0x40000000) >> 30
}
func (o *SPI1_Type) SetCMD_FLASH_READ(value uint32) {
	volatile.StoreUint32(&o.CMD.Reg, volatile.LoadUint32(&o.CMD.Reg)&^(0x80000000)|value<<31)
}
func (o *SPI1_Type) GetCMD_FLASH_READ() uint32 {
	return (volatile.LoadUint32(&o.CMD.Reg) & 0x80000000) >> 31
}

// SPI1.ADDR: SPI1 address register
func (o *SPI1_Type) SetADDR(value uint32) {
	volatile.StoreUint32(&o.ADDR.Reg, value)
}
func (o *SPI1_Type) GetADDR() uint32 {
	return volatile.LoadUint32(&o.ADDR.Reg)
}

// SPI1.CTRL: SPI1 control register.
func (o *SPI1_Type) SetCTRL_FDUMMY_OUT(value uint32) {
	volatile.StoreUint32(&o.CTRL.Reg, volatile.LoadUint32(&o.CTRL.Reg)&^(0x8)|value<<3)
}
func (o *SPI1_Type) GetCTRL_FDUMMY_OUT() uint32 {
	return (volatile.LoadUint32(&o.CTRL.Reg) & 0x8) >> 3
}
func (o *SPI1_Type) SetCTRL_FCMD_DUAL(value uint32) {
	volatile.StoreUint32(&o.CTRL.Reg, volatile.LoadUint32(&o.CTRL.Reg)&^(0x80)|value<<7)
}
func (o *SPI1_Type) GetCTRL_FCMD_DUAL() uint32 {
	return (volatile.LoadUint32(&o.CTRL.Reg) & 0x80) >> 7
}
func (o *SPI1_Type) SetCTRL_FCMD_QUAD(value uint32) {
	volatile.StoreUint32(&o.CTRL.Reg, volatile.LoadUint32(&o.CTRL.Reg)&^(0x100)|value<<8)
}
func (o *SPI1_Type) GetCTRL_FCMD_QUAD() uint32 {
	return (volatile.LoadUint32(&o.CTRL.Reg) & 0x100) >> 8
}
func (o *SPI1_Type) SetCTRL_FCS_CRC_EN(value uint32) {
	volatile.StoreUint32(&o.CTRL.Reg, volatile.LoadUint32(&o.CTRL.Reg)&^(0x400)|value<<10)
}
func (o *SPI1_Type) GetCTRL_FCS_CRC_EN() uint32 {
	return (volatile.LoadUint32(&o.CTRL.Reg) & 0x400) >> 10
}
func (o *SPI1_Type) SetCTRL_TX_CRC_EN(value uint32) {
	volatile.StoreUint32(&o.CTRL.Reg, volatile.LoadUint32(&o.CTRL.Reg)&^(0x800)|value<<11)
}
func (o *SPI1_Type) GetCTRL_TX_CRC_EN() uint32 {
	return (volatile.LoadUint32(&o.CTRL.Reg) & 0x800) >> 11
}
func (o *SPI1_Type) SetCTRL_FASTRD_MODE(value uint32) {
	volatile.StoreUint32(&o.CTRL.Reg, volatile.LoadUint32(&o.CTRL.Reg)&^(0x2000)|value<<13)
}
func (o *SPI1_Type) GetCTRL_FASTRD_MODE() uint32 {
	return (volatile.LoadUint32(&o.CTRL.Reg) & 0x2000) >> 13
}
func (o *SPI1_Type) SetCTRL_FREAD_DUAL(value uint32) {
	volatile.StoreUint32(&o.CTRL.Reg, volatile.LoadUint32(&o.CTRL.Reg)&^(0x4000)|value<<14)
}
func (o *SPI1_Type) GetCTRL_FREAD_DUAL() uint32 {
	return (volatile.LoadUint32(&o.CTRL.Reg) & 0x4000) >> 14
}
func (o *SPI1_Type) SetCTRL_RESANDRES(value uint32) {
	volatile.StoreUint32(&o.CTRL.Reg, volatile.LoadUint32(&o.CTRL.Reg)&^(0x8000)|value<<15)
}
func (o *SPI1_Type) GetCTRL_RESANDRES() uint32 {
	return (volatile.LoadUint32(&o.CTRL.Reg) & 0x8000) >> 15
}
func (o *SPI1_Type) SetCTRL_Q_POL(value uint32) {
	volatile.StoreUint32(&o.CTRL.Reg, volatile.LoadUint32(&o.CTRL.Reg)&^(0x40000)|value<<18)
}
func (o *SPI1_Type) GetCTRL_Q_POL() uint32 {
	return (volatile.LoadUint32(&o.CTRL.Reg) & 0x40000) >> 18
}
func (o *SPI1_Type) SetCTRL_D_POL(value uint32) {
	volatile.StoreUint32(&o.CTRL.Reg, volatile.LoadUint32(&o.CTRL.Reg)&^(0x80000)|value<<19)
}
func (o *SPI1_Type) GetCTRL_D_POL() uint32 {
	return (volatile.LoadUint32(&o.CTRL.Reg) & 0x80000) >> 19
}
func (o *SPI1_Type) SetCTRL_FREAD_QUAD(value uint32) {
	volatile.StoreUint32(&o.CTRL.Reg, volatile.LoadUint32(&o.CTRL.Reg)&^(0x100000)|value<<20)
}
func (o *SPI1_Type) GetCTRL_FREAD_QUAD() uint32 {
	return (volatile.LoadUint32(&o.CTRL.Reg) & 0x100000) >> 20
}
func (o *SPI1_Type) SetCTRL_WP(value uint32) {
	volatile.StoreUint32(&o.CTRL.Reg, volatile.LoadUint32(&o.CTRL.Reg)&^(0x200000)|value<<21)
}
func (o *SPI1_Type) GetCTRL_WP() uint32 {
	return (volatile.LoadUint32(&o.CTRL.Reg) & 0x200000) >> 21
}
func (o *SPI1_Type) SetCTRL_WRSR_2B(value uint32) {
	volatile.StoreUint32(&o.CTRL.Reg, volatile.LoadUint32(&o.CTRL.Reg)&^(0x400000)|value<<22)
}
func (o *SPI1_Type) GetCTRL_WRSR_2B() uint32 {
	return (volatile.LoadUint32(&o.CTRL.Reg) & 0x400000) >> 22
}
func (o *SPI1_Type) SetCTRL_FREAD_DIO(value uint32) {
	volatile.StoreUint32(&o.CTRL.Reg, volatile.LoadUint32(&o.CTRL.Reg)&^(0x800000)|value<<23)
}
func (o *SPI1_Type) GetCTRL_FREAD_DIO() uint32 {
	return (volatile.LoadUint32(&o.CTRL.Reg) & 0x800000) >> 23
}
func (o *SPI1_Type) SetCTRL_FREAD_QIO(value uint32) {
	volatile.StoreUint32(&o.CTRL.Reg, volatile.LoadUint32(&o.CTRL.Reg)&^(0x1000000)|value<<24)
}
func (o *SPI1_Type) GetCTRL_FREAD_QIO() uint32 {
	return (volatile.LoadUint32(&o.CTRL.Reg) & 0x1000000) >> 24
}

// SPI1.CTRL1: SPI1 control1 register.
func (o *SPI1_Type) SetCTRL1_CLK_MODE(value uint32) {
	volatile.StoreUint32(&o.CTRL1.Reg, volatile.LoadUint32(&o.CTRL1.Reg)&^(0x3)|value)
}
func (o *SPI1_Type) GetCTRL1_CLK_MODE() uint32 {
	return volatile.LoadUint32(&o.CTRL1.Reg) & 0x3
}
func (o *SPI1_Type) SetCTRL1_CS_HOLD_DLY_RES(value uint32) {
	volatile.StoreUint32(&o.CTRL1.Reg, volatile.LoadUint32(&o.CTRL1.Reg)&^(0xffc)|value<<2)
}
func (o *SPI1_Type) GetCTRL1_CS_HOLD_DLY_RES() uint32 {
	return (volatile.LoadUint32(&o.CTRL1.Reg) & 0xffc) >> 2
}

// SPI1.CTRL2: SPI1 control2 register.
func (o *SPI1_Type) SetCTRL2_SYNC_RESET(value uint32) {
	volatile.StoreUint32(&o.CTRL2.Reg, volatile.LoadUint32(&o.CTRL2.Reg)&^(0x80000000)|value<<31)
}
func (o *SPI1_Type) GetCTRL2_SYNC_RESET() uint32 {
	return (volatile.LoadUint32(&o.CTRL2.Reg) & 0x80000000) >> 31
}

// SPI1.CLOCK: SPI1 clock division control register.
func (o *SPI1_Type) SetCLOCK_CLKCNT_L(value uint32) {
	volatile.StoreUint32(&o.CLOCK.Reg, volatile.LoadUint32(&o.CLOCK.Reg)&^(0xff)|value)
}
func (o *SPI1_Type) GetCLOCK_CLKCNT_L() uint32 {
	return volatile.LoadUint32(&o.CLOCK.Reg) & 0xff
}
func (o *SPI1_Type) SetCLOCK_CLKCNT_H(value uint32) {
	volatile.StoreUint32(&o.CLOCK.Reg, volatile.LoadUint32(&o.CLOCK.Reg)&^(0xff00)|value<<8)
}
func (o *SPI1_Type) GetCLOCK_CLKCNT_H() uint32 {
	return (volatile.LoadUint32(&o.CLOCK.Reg) & 0xff00) >> 8
}
func (o *SPI1_Type) SetCLOCK_CLKCNT_N(value uint32) {
	volatile.StoreUint32(&o.CLOCK.Reg, volatile.LoadUint32(&o.CLOCK.Reg)&^(0xff0000)|value<<16)
}
func (o *SPI1_Type) GetCLOCK_CLKCNT_N() uint32 {
	return (volatile.LoadUint32(&o.CLOCK.Reg) & 0xff0000) >> 16
}
func (o *SPI1_Type) SetCLOCK_CLK_EQU_SYSCLK(value uint32) {
	volatile.StoreUint32(&o.CLOCK.Reg, volatile.LoadUint32(&o.CLOCK.Reg)&^(0x80000000)|value<<31)
}
func (o *SPI1_Type) GetCLOCK_CLK_EQU_SYSCLK() uint32 {
	return (volatile.LoadUint32(&o.CLOCK.Reg) & 0x80000000) >> 31
}

// SPI1.USER: SPI1 user register.
func (o *SPI1_Type) SetUSER_CK_OUT_EDGE(value uint32) {
	volatile.StoreUint32(&o.USER.Reg, volatile.LoadUint32(&o.USER.Reg)&^(0x200)|value<<9)
}
func (o *SPI1_Type) GetUSER_CK_OUT_EDGE() uint32 {
	return (volatile.LoadUint32(&o.USER.Reg) & 0x200) >> 9
}
func (o *SPI1_Type) SetUSER_FWRITE_DUAL(value uint32) {
	volatile.StoreUint32(&o.USER.Reg, volatile.LoadUint32(&o.USER.Reg)&^(0x1000)|value<<12)
}
func (o *SPI1_Type) GetUSER_FWRITE_DUAL() uint32 {
	return (volatile.LoadUint32(&o.USER.Reg) & 0x1000) >> 12
}
func (o *SPI1_Type) SetUSER_FWRITE_QUAD(value uint32) {
	volatile.StoreUint32(&o.USER.Reg, volatile.LoadUint32(&o.USER.Reg)&^(0x2000)|value<<13)
}
func (o *SPI1_Type) GetUSER_FWRITE_QUAD() uint32 {
	return (volatile.LoadUint32(&o.USER.Reg) & 0x2000) >> 13
}
func (o *SPI1_Type) SetUSER_FWRITE_DIO(value uint32) {
	volatile.StoreUint32(&o.USER.Reg, volatile.LoadUint32(&o.USER.Reg)&^(0x4000)|value<<14)
}
func (o *SPI1_Type) GetUSER_FWRITE_DIO() uint32 {
	return (volatile.LoadUint32(&o.USER.Reg) & 0x4000) >> 14
}
func (o *SPI1_Type) SetUSER_FWRITE_QIO(value uint32) {
	volatile.StoreUint32(&o.USER.Reg, volatile.LoadUint32(&o.USER.Reg)&^(0x8000)|value<<15)
}
func (o *SPI1_Type) GetUSER_FWRITE_QIO() uint32 {
	return (volatile.LoadUint32(&o.USER.Reg) & 0x8000) >> 15
}
func (o *SPI1_Type) SetUSER_USR_MISO_HIGHPART(value uint32) {
	volatile.StoreUint32(&o.USER.Reg, volatile.LoadUint32(&o.USER.Reg)&^(0x1000000)|value<<24)
}
func (o *SPI1_Type) GetUSER_USR_MISO_HIGHPART() uint32 {
	return (volatile.LoadUint32(&o.USER.Reg) & 0x1000000) >> 24
}
func (o *SPI1_Type) SetUSER_USR_MOSI_HIGHPART(value uint32) {
	volatile.StoreUint32(&o.USER.Reg, volatile.LoadUint32(&o.USER.Reg)&^(0x2000000)|value<<25)
}
func (o *SPI1_Type) GetUSER_USR_MOSI_HIGHPART() uint32 {
	return (volatile.LoadUint32(&o.USER.Reg) & 0x2000000) >> 25
}
func (o *SPI1_Type) SetUSER_USR_DUMMY_IDLE(value uint32) {
	volatile.StoreUint32(&o.USER.Reg, volatile.LoadUint32(&o.USER.Reg)&^(0x4000000)|value<<26)
}
func (o *SPI1_Type) GetUSER_USR_DUMMY_IDLE() uint32 {
	return (volatile.LoadUint32(&o.USER.Reg) & 0x4000000) >> 26
}
func (o *SPI1_Type) SetUSER_USR_MOSI(value uint32) {
	volatile.StoreUint32(&o.USER.Reg, volatile.LoadUint32(&o.USER.Reg)&^(0x8000000)|value<<27)
}
func (o *SPI1_Type) GetUSER_USR_MOSI() uint32 {
	return (volatile.LoadUint32(&o.USER.Reg) & 0x8000000) >> 27
}
func (o *SPI1_Type) SetUSER_USR_MISO(value uint32) {
	volatile.StoreUint32(&o.USER.Reg, volatile.LoadUint32(&o.USER.Reg)&^(0x10000000)|value<<28)
}
func (o *SPI1_Type) GetUSER_USR_MISO() uint32 {
	return (volatile.LoadUint32(&o.USER.Reg) & 0x10000000) >> 28
}
func (o *SPI1_Type) SetUSER_USR_DUMMY(value uint32) {
	volatile.StoreUint32(&o.USER.Reg, volatile.LoadUint32(&o.USER.Reg)&^(0x20000000)|value<<29)
}
func (o *SPI1_Type) GetUSER_USR_DUMMY() uint32 {
	return (volatile.LoadUint32(&o.USER.Reg) & 0x20000000) >> 29
}
func (o *SPI1_Type) SetUSER_USR_ADDR(value uint32) {
	volatile.StoreUint32(&o.USER.Reg, volatile.LoadUint32(&o.USER.Reg)&^(0x40000000)|value<<30)
}
func (o *SPI1_Type) GetUSER_USR_ADDR() uint32 {
	return (volatile.LoadUint32(&o.USER.Reg) & 0x40000000) >> 30
}
func (o *SPI1_Type) SetUSER_USR_COMMAND(value uint32) {
	volatile.StoreUint32(&o.USER.Reg, volatile.LoadUint32(&o.USER.Reg)&^(0x80000000)|value<<31)
}
func (o *SPI1_Type) GetUSER_USR_COMMAND() uint32 {
	return (volatile.LoadUint32(&o.USER.Reg) & 0x80000000) >> 31
}

// SPI1.USER1: SPI1 user1 register.
func (o *SPI1_Type) SetUSER1_USR_DUMMY_CYCLELEN(value uint32) {
	volatile.StoreUint32(&o.USER1.Reg, volatile.LoadUint32(&o.USER1.Reg)&^(0x3f)|value)
}
func (o *SPI1_Type) GetUSER1_USR_DUMMY_CYCLELEN() uint32 {
	return volatile.LoadUint32(&o.USER1.Reg) & 0x3f
}
func (o *SPI1_Type) SetUSER1_USR_ADDR_BITLEN(value uint32) {
	volatile.StoreUint32(&o.USER1.Reg, volatile.LoadUint32(&o.USER1.Reg)&^(0xfc000000)|value<<26)
}
func (o *SPI1_Type) GetUSER1_USR_ADDR_BITLEN() uint32 {
	return (volatile.LoadUint32(&o.USER1.Reg) & 0xfc000000) >> 26
}

// SPI1.USER2: SPI1 user2 register.
func (o *SPI1_Type) SetUSER2_USR_COMMAND_VALUE(value uint32) {
	volatile.StoreUint32(&o.USER2.Reg, volatile.LoadUint32(&o.USER2.Reg)&^(0xffff)|value)
}
func (o *SPI1_Type) GetUSER2_USR_COMMAND_VALUE() uint32 {
	return volatile.LoadUint32(&o.USER2.Reg) & 0xffff
}
func (o *SPI1_Type) SetUSER2_USR_COMMAND_BITLEN(value uint32) {
	volatile.StoreUint32(&o.USER2.Reg, volatile.LoadUint32(&o.USER2.Reg)&^(0xf0000000)|value<<28)
}
func (o *SPI1_Type) GetUSER2_USR_COMMAND_BITLEN() uint32 {
	return (volatile.LoadUint32(&o.USER2.Reg) & 0xf0000000) >> 28
}

// SPI1.MOSI_DLEN: SPI1 send data bit length control register.
func (o *SPI1_Type) SetMOSI_DLEN_USR_MOSI_DBITLEN(value uint32) {
	volatile.StoreUint32(&o.MOSI_DLEN.Reg, volatile.LoadUint32(&o.MOSI_DLEN.Reg)&^(0x3ff)|value)
}
func (o *SPI1_Type) GetMOSI_DLEN_USR_MOSI_DBITLEN() uint32 {
	return volatile.LoadUint32(&o.MOSI_DLEN.Reg) & 0x3ff
}

// SPI1.MISO_DLEN: SPI1 receive data bit length control register.
func (o *SPI1_Type) SetMISO_DLEN_USR_MISO_DBITLEN(value uint32) {
	volatile.StoreUint32(&o.MISO_DLEN.Reg, volatile.LoadUint32(&o.MISO_DLEN.Reg)&^(0x3ff)|value)
}
func (o *SPI1_Type) GetMISO_DLEN_USR_MISO_DBITLEN() uint32 {
	return volatile.LoadUint32(&o.MISO_DLEN.Reg) & 0x3ff
}

// SPI1.RD_STATUS: SPI1 status register.
func (o *SPI1_Type) SetRD_STATUS_STATUS(value uint32) {
	volatile.StoreUint32(&o.RD_STATUS.Reg, volatile.LoadUint32(&o.RD_STATUS.Reg)&^(0xffff)|value)
}
func (o *SPI1_Type) GetRD_STATUS_STATUS() uint32 {
	return volatile.LoadUint32(&o.RD_STATUS.Reg) & 0xffff
}
func (o *SPI1_Type) SetRD_STATUS_WB_MODE(value uint32) {
	volatile.StoreUint32(&o.RD_STATUS.Reg, volatile.LoadUint32(&o.RD_STATUS.Reg)&^(0xff0000)|value<<16)
}
func (o *SPI1_Type) GetRD_STATUS_WB_MODE() uint32 {
	return (volatile.LoadUint32(&o.RD_STATUS.Reg) & 0xff0000) >> 16
}

// SPI1.MISC: SPI1 misc register
func (o *SPI1_Type) SetMISC_CS0_DIS(value uint32) {
	volatile.StoreUint32(&o.MISC.Reg, volatile.LoadUint32(&o.MISC.Reg)&^(0x1)|value)
}
func (o *SPI1_Type) GetMISC_CS0_DIS() uint32 {
	return volatile.LoadUint32(&o.MISC.Reg) & 0x1
}
func (o *SPI1_Type) SetMISC_CS1_DIS(value uint32) {
	volatile.StoreUint32(&o.MISC.Reg, volatile.LoadUint32(&o.MISC.Reg)&^(0x2)|value<<1)
}
func (o *SPI1_Type) GetMISC_CS1_DIS() uint32 {
	return (volatile.LoadUint32(&o.MISC.Reg) & 0x2) >> 1
}
func (o *SPI1_Type) SetMISC_CK_IDLE_EDGE(value uint32) {
	volatile.StoreUint32(&o.MISC.Reg, volatile.LoadUint32(&o.MISC.Reg)&^(0x200)|value<<9)
}
func (o *SPI1_Type) GetMISC_CK_IDLE_EDGE() uint32 {
	return (volatile.LoadUint32(&o.MISC.Reg) & 0x200) >> 9
}
func (o *SPI1_Type) SetMISC_CS_KEEP_ACTIVE(value uint32) {
	volatile.StoreUint32(&o.MISC.Reg, volatile.LoadUint32(&o.MISC.Reg)&^(0x400)|value<<10)
}
func (o *SPI1_Type) GetMISC_CS_KEEP_ACTIVE() uint32 {
	return (volatile.LoadUint32(&o.MISC.Reg) & 0x400) >> 10
}

// SPI1.TX_CRC: SPI1 TX CRC data register.
func (o *SPI1_Type) SetTX_CRC(value uint32) {
	volatile.StoreUint32(&o.TX_CRC.Reg, value)
}
func (o *SPI1_Type) GetTX_CRC() uint32 {
	return volatile.LoadUint32(&o.TX_CRC.Reg)
}

// SPI1.CACHE_FCTRL: SPI1 bit mode control register.
func (o *SPI1_Type) SetCACHE_FCTRL_CACHE_USR_ADDR_4BYTE(value uint32) {
	volatile.StoreUint32(&o.CACHE_FCTRL.Reg, volatile.LoadUint32(&o.CACHE_FCTRL.Reg)&^(0x2)|value<<1)
}
func (o *SPI1_Type) GetCACHE_FCTRL_CACHE_USR_ADDR_4BYTE() uint32 {
	return (volatile.LoadUint32(&o.CACHE_FCTRL.Reg) & 0x2) >> 1
}
func (o *SPI1_Type) SetCACHE_FCTRL_FDIN_DUAL(value uint32) {
	volatile.StoreUint32(&o.CACHE_FCTRL.Reg, volatile.LoadUint32(&o.CACHE_FCTRL.Reg)&^(0x8)|value<<3)
}
func (o *SPI1_Type) GetCACHE_FCTRL_FDIN_DUAL() uint32 {
	return (volatile.LoadUint32(&o.CACHE_FCTRL.Reg) & 0x8) >> 3
}
func (o *SPI1_Type) SetCACHE_FCTRL_FDOUT_DUAL(value uint32) {
	volatile.StoreUint32(&o.CACHE_FCTRL.Reg, volatile.LoadUint32(&o.CACHE_FCTRL.Reg)&^(0x10)|value<<4)
}
func (o *SPI1_Type) GetCACHE_FCTRL_FDOUT_DUAL() uint32 {
	return (volatile.LoadUint32(&o.CACHE_FCTRL.Reg) & 0x10) >> 4
}
func (o *SPI1_Type) SetCACHE_FCTRL_FADDR_DUAL(value uint32) {
	volatile.StoreUint32(&o.CACHE_FCTRL.Reg, volatile.LoadUint32(&o.CACHE_FCTRL.Reg)&^(0x20)|value<<5)
}
func (o *SPI1_Type) GetCACHE_FCTRL_FADDR_DUAL() uint32 {
	return (volatile.LoadUint32(&o.CACHE_FCTRL.Reg) & 0x20) >> 5
}
func (o *SPI1_Type) SetCACHE_FCTRL_FDIN_QUAD(value uint32) {
	volatile.StoreUint32(&o.CACHE_FCTRL.Reg, volatile.LoadUint32(&o.CACHE_FCTRL.Reg)&^(0x40)|value<<6)
}
func (o *SPI1_Type) GetCACHE_FCTRL_FDIN_QUAD() uint32 {
	return (volatile.LoadUint32(&o.CACHE_FCTRL.Reg) & 0x40) >> 6
}
func (o *SPI1_Type) SetCACHE_FCTRL_FDOUT_QUAD(value uint32) {
	volatile.StoreUint32(&o.CACHE_FCTRL.Reg, volatile.LoadUint32(&o.CACHE_FCTRL.Reg)&^(0x80)|value<<7)
}
func (o *SPI1_Type) GetCACHE_FCTRL_FDOUT_QUAD() uint32 {
	return (volatile.LoadUint32(&o.CACHE_FCTRL.Reg) & 0x80) >> 7
}
func (o *SPI1_Type) SetCACHE_FCTRL_FADDR_QUAD(value uint32) {
	volatile.StoreUint32(&o.CACHE_FCTRL.Reg, volatile.LoadUint32(&o.CACHE_FCTRL.Reg)&^(0x100)|value<<8)
}
func (o *SPI1_Type) GetCACHE_FCTRL_FADDR_QUAD() uint32 {
	return (volatile.LoadUint32(&o.CACHE_FCTRL.Reg) & 0x100) >> 8
}

// SPI1.W0: SPI1 memory data buffer0
func (o *SPI1_Type) SetW0(value uint32) {
	volatile.StoreUint32(&o.W0.Reg, value)
}
func (o *SPI1_Type) GetW0() uint32 {
	return volatile.LoadUint32(&o.W0.Reg)
}

// SPI1.W1: SPI1 memory data buffer1
func (o *SPI1_Type) SetW1(value uint32) {
	volatile.StoreUint32(&o.W1.Reg, value)
}
func (o *SPI1_Type) GetW1() uint32 {
	return volatile.LoadUint32(&o.W1.Reg)
}

// SPI1.W2: SPI1 memory data buffer2
func (o *SPI1_Type) SetW2(value uint32) {
	volatile.StoreUint32(&o.W2.Reg, value)
}
func (o *SPI1_Type) GetW2() uint32 {
	return volatile.LoadUint32(&o.W2.Reg)
}

// SPI1.W3: SPI1 memory data buffer3
func (o *SPI1_Type) SetW3(value uint32) {
	volatile.StoreUint32(&o.W3.Reg, value)
}
func (o *SPI1_Type) GetW3() uint32 {
	return volatile.LoadUint32(&o.W3.Reg)
}

// SPI1.W4: SPI1 memory data buffer4
func (o *SPI1_Type) SetW4(value uint32) {
	volatile.StoreUint32(&o.W4.Reg, value)
}
func (o *SPI1_Type) GetW4() uint32 {
	return volatile.LoadUint32(&o.W4.Reg)
}

// SPI1.W5: SPI1 memory data buffer5
func (o *SPI1_Type) SetW5(value uint32) {
	volatile.StoreUint32(&o.W5.Reg, value)
}
func (o *SPI1_Type) GetW5() uint32 {
	return volatile.LoadUint32(&o.W5.Reg)
}

// SPI1.W6: SPI1 memory data buffer6
func (o *SPI1_Type) SetW6(value uint32) {
	volatile.StoreUint32(&o.W6.Reg, value)
}
func (o *SPI1_Type) GetW6() uint32 {
	return volatile.LoadUint32(&o.W6.Reg)
}

// SPI1.W7: SPI1 memory data buffer7
func (o *SPI1_Type) SetW7(value uint32) {
	volatile.StoreUint32(&o.W7.Reg, value)
}
func (o *SPI1_Type) GetW7() uint32 {
	return volatile.LoadUint32(&o.W7.Reg)
}

// SPI1.W8: SPI1 memory data buffer8
func (o *SPI1_Type) SetW8(value uint32) {
	volatile.StoreUint32(&o.W8.Reg, value)
}
func (o *SPI1_Type) GetW8() uint32 {
	return volatile.LoadUint32(&o.W8.Reg)
}

// SPI1.W9: SPI1 memory data buffer9
func (o *SPI1_Type) SetW9(value uint32) {
	volatile.StoreUint32(&o.W9.Reg, value)
}
func (o *SPI1_Type) GetW9() uint32 {
	return volatile.LoadUint32(&o.W9.Reg)
}

// SPI1.W10: SPI1 memory data buffer10
func (o *SPI1_Type) SetW10(value uint32) {
	volatile.StoreUint32(&o.W10.Reg, value)
}
func (o *SPI1_Type) GetW10() uint32 {
	return volatile.LoadUint32(&o.W10.Reg)
}

// SPI1.W11: SPI1 memory data buffer11
func (o *SPI1_Type) SetW11(value uint32) {
	volatile.StoreUint32(&o.W11.Reg, value)
}
func (o *SPI1_Type) GetW11() uint32 {
	return volatile.LoadUint32(&o.W11.Reg)
}

// SPI1.W12: SPI1 memory data buffer12
func (o *SPI1_Type) SetW12(value uint32) {
	volatile.StoreUint32(&o.W12.Reg, value)
}
func (o *SPI1_Type) GetW12() uint32 {
	return volatile.LoadUint32(&o.W12.Reg)
}

// SPI1.W13: SPI1 memory data buffer13
func (o *SPI1_Type) SetW13(value uint32) {
	volatile.StoreUint32(&o.W13.Reg, value)
}
func (o *SPI1_Type) GetW13() uint32 {
	return volatile.LoadUint32(&o.W13.Reg)
}

// SPI1.W14: SPI1 memory data buffer14
func (o *SPI1_Type) SetW14(value uint32) {
	volatile.StoreUint32(&o.W14.Reg, value)
}
func (o *SPI1_Type) GetW14() uint32 {
	return volatile.LoadUint32(&o.W14.Reg)
}

// SPI1.W15: SPI1 memory data buffer15
func (o *SPI1_Type) SetW15(value uint32) {
	volatile.StoreUint32(&o.W15.Reg, value)
}
func (o *SPI1_Type) GetW15() uint32 {
	return volatile.LoadUint32(&o.W15.Reg)
}

// SPI1.FLASH_WAITI_CTRL: SPI1 wait idle control register
func (o *SPI1_Type) SetFLASH_WAITI_CTRL_WAITI_DUMMY(value uint32) {
	volatile.StoreUint32(&o.FLASH_WAITI_CTRL.Reg, volatile.LoadUint32(&o.FLASH_WAITI_CTRL.Reg)&^(0x2)|value<<1)
}
func (o *SPI1_Type) GetFLASH_WAITI_CTRL_WAITI_DUMMY() uint32 {
	return (volatile.LoadUint32(&o.FLASH_WAITI_CTRL.Reg) & 0x2) >> 1
}
func (o *SPI1_Type) SetFLASH_WAITI_CTRL_WAITI_CMD(value uint32) {
	volatile.StoreUint32(&o.FLASH_WAITI_CTRL.Reg, volatile.LoadUint32(&o.FLASH_WAITI_CTRL.Reg)&^(0x3fc)|value<<2)
}
func (o *SPI1_Type) GetFLASH_WAITI_CTRL_WAITI_CMD() uint32 {
	return (volatile.LoadUint32(&o.FLASH_WAITI_CTRL.Reg) & 0x3fc) >> 2
}
func (o *SPI1_Type) SetFLASH_WAITI_CTRL_WAITI_DUMMY_CYCLELEN(value uint32) {
	volatile.StoreUint32(&o.FLASH_WAITI_CTRL.Reg, volatile.LoadUint32(&o.FLASH_WAITI_CTRL.Reg)&^(0xfc00)|value<<10)
}
func (o *SPI1_Type) GetFLASH_WAITI_CTRL_WAITI_DUMMY_CYCLELEN() uint32 {
	return (volatile.LoadUint32(&o.FLASH_WAITI_CTRL.Reg) & 0xfc00) >> 10
}

// SPI1.FLASH_SUS_CTRL: SPI1 flash suspend control register
func (o *SPI1_Type) SetFLASH_SUS_CTRL_FLASH_PER(value uint32) {
	volatile.StoreUint32(&o.FLASH_SUS_CTRL.Reg, volatile.LoadUint32(&o.FLASH_SUS_CTRL.Reg)&^(0x1)|value)
}
func (o *SPI1_Type) GetFLASH_SUS_CTRL_FLASH_PER() uint32 {
	return volatile.LoadUint32(&o.FLASH_SUS_CTRL.Reg) & 0x1
}
func (o *SPI1_Type) SetFLASH_SUS_CTRL_FLASH_PES(value uint32) {
	volatile.StoreUint32(&o.FLASH_SUS_CTRL.Reg, volatile.LoadUint32(&o.FLASH_SUS_CTRL.Reg)&^(0x2)|value<<1)
}
func (o *SPI1_Type) GetFLASH_SUS_CTRL_FLASH_PES() uint32 {
	return (volatile.LoadUint32(&o.FLASH_SUS_CTRL.Reg) & 0x2) >> 1
}
func (o *SPI1_Type) SetFLASH_SUS_CTRL_FLASH_PER_WAIT_EN(value uint32) {
	volatile.StoreUint32(&o.FLASH_SUS_CTRL.Reg, volatile.LoadUint32(&o.FLASH_SUS_CTRL.Reg)&^(0x4)|value<<2)
}
func (o *SPI1_Type) GetFLASH_SUS_CTRL_FLASH_PER_WAIT_EN() uint32 {
	return (volatile.LoadUint32(&o.FLASH_SUS_CTRL.Reg) & 0x4) >> 2
}
func (o *SPI1_Type) SetFLASH_SUS_CTRL_FLASH_PES_WAIT_EN(value uint32) {
	volatile.StoreUint32(&o.FLASH_SUS_CTRL.Reg, volatile.LoadUint32(&o.FLASH_SUS_CTRL.Reg)&^(0x8)|value<<3)
}
func (o *SPI1_Type) GetFLASH_SUS_CTRL_FLASH_PES_WAIT_EN() uint32 {
	return (volatile.LoadUint32(&o.FLASH_SUS_CTRL.Reg) & 0x8) >> 3
}
func (o *SPI1_Type) SetFLASH_SUS_CTRL_PES_PER_EN(value uint32) {
	volatile.StoreUint32(&o.FLASH_SUS_CTRL.Reg, volatile.LoadUint32(&o.FLASH_SUS_CTRL.Reg)&^(0x10)|value<<4)
}
func (o *SPI1_Type) GetFLASH_SUS_CTRL_PES_PER_EN() uint32 {
	return (volatile.LoadUint32(&o.FLASH_SUS_CTRL.Reg) & 0x10) >> 4
}
func (o *SPI1_Type) SetFLASH_SUS_CTRL_FLASH_PES_EN(value uint32) {
	volatile.StoreUint32(&o.FLASH_SUS_CTRL.Reg, volatile.LoadUint32(&o.FLASH_SUS_CTRL.Reg)&^(0x20)|value<<5)
}
func (o *SPI1_Type) GetFLASH_SUS_CTRL_FLASH_PES_EN() uint32 {
	return (volatile.LoadUint32(&o.FLASH_SUS_CTRL.Reg) & 0x20) >> 5
}
func (o *SPI1_Type) SetFLASH_SUS_CTRL_PESR_END_MSK(value uint32) {
	volatile.StoreUint32(&o.FLASH_SUS_CTRL.Reg, volatile.LoadUint32(&o.FLASH_SUS_CTRL.Reg)&^(0x3fffc0)|value<<6)
}
func (o *SPI1_Type) GetFLASH_SUS_CTRL_PESR_END_MSK() uint32 {
	return (volatile.LoadUint32(&o.FLASH_SUS_CTRL.Reg) & 0x3fffc0) >> 6
}
func (o *SPI1_Type) SetFLASH_SUS_CTRL_RD_SUS_2B(value uint32) {
	volatile.StoreUint32(&o.FLASH_SUS_CTRL.Reg, volatile.LoadUint32(&o.FLASH_SUS_CTRL.Reg)&^(0x400000)|value<<22)
}
func (o *SPI1_Type) GetFLASH_SUS_CTRL_RD_SUS_2B() uint32 {
	return (volatile.LoadUint32(&o.FLASH_SUS_CTRL.Reg) & 0x400000) >> 22
}
func (o *SPI1_Type) SetFLASH_SUS_CTRL_PER_END_EN(value uint32) {
	volatile.StoreUint32(&o.FLASH_SUS_CTRL.Reg, volatile.LoadUint32(&o.FLASH_SUS_CTRL.Reg)&^(0x800000)|value<<23)
}
func (o *SPI1_Type) GetFLASH_SUS_CTRL_PER_END_EN() uint32 {
	return (volatile.LoadUint32(&o.FLASH_SUS_CTRL.Reg) & 0x800000) >> 23
}
func (o *SPI1_Type) SetFLASH_SUS_CTRL_PES_END_EN(value uint32) {
	volatile.StoreUint32(&o.FLASH_SUS_CTRL.Reg, volatile.LoadUint32(&o.FLASH_SUS_CTRL.Reg)&^(0x1000000)|value<<24)
}
func (o *SPI1_Type) GetFLASH_SUS_CTRL_PES_END_EN() uint32 {
	return (volatile.LoadUint32(&o.FLASH_SUS_CTRL.Reg) & 0x1000000) >> 24
}
func (o *SPI1_Type) SetFLASH_SUS_CTRL_SUS_TIMEOUT_CNT(value uint32) {
	volatile.StoreUint32(&o.FLASH_SUS_CTRL.Reg, volatile.LoadUint32(&o.FLASH_SUS_CTRL.Reg)&^(0xfe000000)|value<<25)
}
func (o *SPI1_Type) GetFLASH_SUS_CTRL_SUS_TIMEOUT_CNT() uint32 {
	return (volatile.LoadUint32(&o.FLASH_SUS_CTRL.Reg) & 0xfe000000) >> 25
}

// SPI1.FLASH_SUS_CMD: SPI1 flash suspend command register
func (o *SPI1_Type) SetFLASH_SUS_CMD_FLASH_PER_COMMAND(value uint32) {
	volatile.StoreUint32(&o.FLASH_SUS_CMD.Reg, volatile.LoadUint32(&o.FLASH_SUS_CMD.Reg)&^(0xff)|value)
}
func (o *SPI1_Type) GetFLASH_SUS_CMD_FLASH_PER_COMMAND() uint32 {
	return volatile.LoadUint32(&o.FLASH_SUS_CMD.Reg) & 0xff
}
func (o *SPI1_Type) SetFLASH_SUS_CMD_FLASH_PES_COMMAND(value uint32) {
	volatile.StoreUint32(&o.FLASH_SUS_CMD.Reg, volatile.LoadUint32(&o.FLASH_SUS_CMD.Reg)&^(0xff00)|value<<8)
}
func (o *SPI1_Type) GetFLASH_SUS_CMD_FLASH_PES_COMMAND() uint32 {
	return (volatile.LoadUint32(&o.FLASH_SUS_CMD.Reg) & 0xff00) >> 8
}
func (o *SPI1_Type) SetFLASH_SUS_CMD_WAIT_PESR_COMMAND(value uint32) {
	volatile.StoreUint32(&o.FLASH_SUS_CMD.Reg, volatile.LoadUint32(&o.FLASH_SUS_CMD.Reg)&^(0xffff0000)|value<<16)
}
func (o *SPI1_Type) GetFLASH_SUS_CMD_WAIT_PESR_COMMAND() uint32 {
	return (volatile.LoadUint32(&o.FLASH_SUS_CMD.Reg) & 0xffff0000) >> 16
}

// SPI1.SUS_STATUS: SPI1 flash suspend status register
func (o *SPI1_Type) SetSUS_STATUS_FLASH_SUS(value uint32) {
	volatile.StoreUint32(&o.SUS_STATUS.Reg, volatile.LoadUint32(&o.SUS_STATUS.Reg)&^(0x1)|value)
}
func (o *SPI1_Type) GetSUS_STATUS_FLASH_SUS() uint32 {
	return volatile.LoadUint32(&o.SUS_STATUS.Reg) & 0x1
}
func (o *SPI1_Type) SetSUS_STATUS_WAIT_PESR_CMD_2B(value uint32) {
	volatile.StoreUint32(&o.SUS_STATUS.Reg, volatile.LoadUint32(&o.SUS_STATUS.Reg)&^(0x2)|value<<1)
}
func (o *SPI1_Type) GetSUS_STATUS_WAIT_PESR_CMD_2B() uint32 {
	return (volatile.LoadUint32(&o.SUS_STATUS.Reg) & 0x2) >> 1
}
func (o *SPI1_Type) SetSUS_STATUS_FLASH_HPM_DLY_128(value uint32) {
	volatile.StoreUint32(&o.SUS_STATUS.Reg, volatile.LoadUint32(&o.SUS_STATUS.Reg)&^(0x4)|value<<2)
}
func (o *SPI1_Type) GetSUS_STATUS_FLASH_HPM_DLY_128() uint32 {
	return (volatile.LoadUint32(&o.SUS_STATUS.Reg) & 0x4) >> 2
}
func (o *SPI1_Type) SetSUS_STATUS_FLASH_RES_DLY_128(value uint32) {
	volatile.StoreUint32(&o.SUS_STATUS.Reg, volatile.LoadUint32(&o.SUS_STATUS.Reg)&^(0x8)|value<<3)
}
func (o *SPI1_Type) GetSUS_STATUS_FLASH_RES_DLY_128() uint32 {
	return (volatile.LoadUint32(&o.SUS_STATUS.Reg) & 0x8) >> 3
}
func (o *SPI1_Type) SetSUS_STATUS_FLASH_DP_DLY_128(value uint32) {
	volatile.StoreUint32(&o.SUS_STATUS.Reg, volatile.LoadUint32(&o.SUS_STATUS.Reg)&^(0x10)|value<<4)
}
func (o *SPI1_Type) GetSUS_STATUS_FLASH_DP_DLY_128() uint32 {
	return (volatile.LoadUint32(&o.SUS_STATUS.Reg) & 0x10) >> 4
}
func (o *SPI1_Type) SetSUS_STATUS_FLASH_PER_DLY_128(value uint32) {
	volatile.StoreUint32(&o.SUS_STATUS.Reg, volatile.LoadUint32(&o.SUS_STATUS.Reg)&^(0x20)|value<<5)
}
func (o *SPI1_Type) GetSUS_STATUS_FLASH_PER_DLY_128() uint32 {
	return (volatile.LoadUint32(&o.SUS_STATUS.Reg) & 0x20) >> 5
}
func (o *SPI1_Type) SetSUS_STATUS_FLASH_PES_DLY_128(value uint32) {
	volatile.StoreUint32(&o.SUS_STATUS.Reg, volatile.LoadUint32(&o.SUS_STATUS.Reg)&^(0x40)|value<<6)
}
func (o *SPI1_Type) GetSUS_STATUS_FLASH_PES_DLY_128() uint32 {
	return (volatile.LoadUint32(&o.SUS_STATUS.Reg) & 0x40) >> 6
}
func (o *SPI1_Type) SetSUS_STATUS_SPI0_LOCK_EN(value uint32) {
	volatile.StoreUint32(&o.SUS_STATUS.Reg, volatile.LoadUint32(&o.SUS_STATUS.Reg)&^(0x80)|value<<7)
}
func (o *SPI1_Type) GetSUS_STATUS_SPI0_LOCK_EN() uint32 {
	return (volatile.LoadUint32(&o.SUS_STATUS.Reg) & 0x80) >> 7
}

// SPI1.TIMING_CALI: SPI1 timing control register
func (o *SPI1_Type) SetTIMING_CALI(value uint32) {
	volatile.StoreUint32(&o.TIMING_CALI.Reg, volatile.LoadUint32(&o.TIMING_CALI.Reg)&^(0x2)|value<<1)
}
func (o *SPI1_Type) GetTIMING_CALI() uint32 {
	return (volatile.LoadUint32(&o.TIMING_CALI.Reg) & 0x2) >> 1
}
func (o *SPI1_Type) SetTIMING_CALI_EXTRA_DUMMY_CYCLELEN(value uint32) {
	volatile.StoreUint32(&o.TIMING_CALI.Reg, volatile.LoadUint32(&o.TIMING_CALI.Reg)&^(0x1c)|value<<2)
}
func (o *SPI1_Type) GetTIMING_CALI_EXTRA_DUMMY_CYCLELEN() uint32 {
	return (volatile.LoadUint32(&o.TIMING_CALI.Reg) & 0x1c) >> 2
}

// SPI1.INT_ENA: SPI1 interrupt enable register
func (o *SPI1_Type) SetINT_ENA_PER_END_INT_ENA(value uint32) {
	volatile.StoreUint32(&o.INT_ENA.Reg, volatile.LoadUint32(&o.INT_ENA.Reg)&^(0x1)|value)
}
func (o *SPI1_Type) GetINT_ENA_PER_END_INT_ENA() uint32 {
	return volatile.LoadUint32(&o.INT_ENA.Reg) & 0x1
}
func (o *SPI1_Type) SetINT_ENA_PES_END_INT_ENA(value uint32) {
	volatile.StoreUint32(&o.INT_ENA.Reg, volatile.LoadUint32(&o.INT_ENA.Reg)&^(0x2)|value<<1)
}
func (o *SPI1_Type) GetINT_ENA_PES_END_INT_ENA() uint32 {
	return (volatile.LoadUint32(&o.INT_ENA.Reg) & 0x2) >> 1
}
func (o *SPI1_Type) SetINT_ENA_WPE_END_INT_ENA(value uint32) {
	volatile.StoreUint32(&o.INT_ENA.Reg, volatile.LoadUint32(&o.INT_ENA.Reg)&^(0x4)|value<<2)
}
func (o *SPI1_Type) GetINT_ENA_WPE_END_INT_ENA() uint32 {
	return (volatile.LoadUint32(&o.INT_ENA.Reg) & 0x4) >> 2
}
func (o *SPI1_Type) SetINT_ENA_SLV_ST_END_INT_ENA(value uint32) {
	volatile.StoreUint32(&o.INT_ENA.Reg, volatile.LoadUint32(&o.INT_ENA.Reg)&^(0x8)|value<<3)
}
func (o *SPI1_Type) GetINT_ENA_SLV_ST_END_INT_ENA() uint32 {
	return (volatile.LoadUint32(&o.INT_ENA.Reg) & 0x8) >> 3
}
func (o *SPI1_Type) SetINT_ENA_MST_ST_END_INT_ENA(value uint32) {
	volatile.StoreUint32(&o.INT_ENA.Reg, volatile.LoadUint32(&o.INT_ENA.Reg)&^(0x10)|value<<4)
}
func (o *SPI1_Type) GetINT_ENA_MST_ST_END_INT_ENA() uint32 {
	return (volatile.LoadUint32(&o.INT_ENA.Reg) & 0x10) >> 4
}

// SPI1.INT_CLR: SPI1 interrupt clear register
func (o *SPI1_Type) SetINT_CLR_PER_END_INT_CLR(value uint32) {
	volatile.StoreUint32(&o.INT_CLR.Reg, volatile.LoadUint32(&o.INT_CLR.Reg)&^(0x1)|value)
}
func (o *SPI1_Type) GetINT_CLR_PER_END_INT_CLR() uint32 {
	return volatile.LoadUint32(&o.INT_CLR.Reg) & 0x1
}
func (o *SPI1_Type) SetINT_CLR_PES_END_INT_CLR(value uint32) {
	volatile.StoreUint32(&o.INT_CLR.Reg, volatile.LoadUint32(&o.INT_CLR.Reg)&^(0x2)|value<<1)
}
func (o *SPI1_Type) GetINT_CLR_PES_END_INT_CLR() uint32 {
	return (volatile.LoadUint32(&o.INT_CLR.Reg) & 0x2) >> 1
}
func (o *SPI1_Type) SetINT_CLR_WPE_END_INT_CLR(value uint32) {
	volatile.StoreUint32(&o.INT_CLR.Reg, volatile.LoadUint32(&o.INT_CLR.Reg)&^(0x4)|value<<2)
}
func (o *SPI1_Type) GetINT_CLR_WPE_END_INT_CLR() uint32 {
	return (volatile.LoadUint32(&o.INT_CLR.Reg) & 0x4) >> 2
}
func (o *SPI1_Type) SetINT_CLR_SLV_ST_END_INT_CLR(value uint32) {
	volatile.StoreUint32(&o.INT_CLR.Reg, volatile.LoadUint32(&o.INT_CLR.Reg)&^(0x8)|value<<3)
}
func (o *SPI1_Type) GetINT_CLR_SLV_ST_END_INT_CLR() uint32 {
	return (volatile.LoadUint32(&o.INT_CLR.Reg) & 0x8) >> 3
}
func (o *SPI1_Type) SetINT_CLR_MST_ST_END_INT_CLR(value uint32) {
	volatile.StoreUint32(&o.INT_CLR.Reg, volatile.LoadUint32(&o.INT_CLR.Reg)&^(0x10)|value<<4)
}
func (o *SPI1_Type) GetINT_CLR_MST_ST_END_INT_CLR() uint32 {
	return (volatile.LoadUint32(&o.INT_CLR.Reg) & 0x10) >> 4
}

// SPI1.INT_RAW: SPI1 interrupt raw register
func (o *SPI1_Type) SetINT_RAW_PER_END_INT_RAW(value uint32) {
	volatile.StoreUint32(&o.INT_RAW.Reg, volatile.LoadUint32(&o.INT_RAW.Reg)&^(0x1)|value)
}
func (o *SPI1_Type) GetINT_RAW_PER_END_INT_RAW() uint32 {
	return volatile.LoadUint32(&o.INT_RAW.Reg) & 0x1
}
func (o *SPI1_Type) SetINT_RAW_PES_END_INT_RAW(value uint32) {
	volatile.StoreUint32(&o.INT_RAW.Reg, volatile.LoadUint32(&o.INT_RAW.Reg)&^(0x2)|value<<1)
}
func (o *SPI1_Type) GetINT_RAW_PES_END_INT_RAW() uint32 {
	return (volatile.LoadUint32(&o.INT_RAW.Reg) & 0x2) >> 1
}
func (o *SPI1_Type) SetINT_RAW_WPE_END_INT_RAW(value uint32) {
	volatile.StoreUint32(&o.INT_RAW.Reg, volatile.LoadUint32(&o.INT_RAW.Reg)&^(0x4)|value<<2)
}
func (o *SPI1_Type) GetINT_RAW_WPE_END_INT_RAW() uint32 {
	return (volatile.LoadUint32(&o.INT_RAW.Reg) & 0x4) >> 2
}
func (o *SPI1_Type) SetINT_RAW_SLV_ST_END_INT_RAW(value uint32) {
	volatile.StoreUint32(&o.INT_RAW.Reg, volatile.LoadUint32(&o.INT_RAW.Reg)&^(0x8)|value<<3)
}
func (o *SPI1_Type) GetINT_RAW_SLV_ST_END_INT_RAW() uint32 {
	return (volatile.LoadUint32(&o.INT_RAW.Reg) & 0x8) >> 3
}
func (o *SPI1_Type) SetINT_RAW_MST_ST_END_INT_RAW(value uint32) {
	volatile.StoreUint32(&o.INT_RAW.Reg, volatile.LoadUint32(&o.INT_RAW.Reg)&^(0x10)|value<<4)
}
func (o *SPI1_Type) GetINT_RAW_MST_ST_END_INT_RAW() uint32 {
	return (volatile.LoadUint32(&o.INT_RAW.Reg) & 0x10) >> 4
}

// SPI1.INT_ST: SPI1 interrupt status register
func (o *SPI1_Type) SetINT_ST_PER_END_INT_ST(value uint32) {
	volatile.StoreUint32(&o.INT_ST.Reg, volatile.LoadUint32(&o.INT_ST.Reg)&^(0x1)|value)
}
func (o *SPI1_Type) GetINT_ST_PER_END_INT_ST() uint32 {
	return volatile.LoadUint32(&o.INT_ST.Reg) & 0x1
}
func (o *SPI1_Type) SetINT_ST_PES_END_INT_ST(value uint32) {
	volatile.StoreUint32(&o.INT_ST.Reg, volatile.LoadUint32(&o.INT_ST.Reg)&^(0x2)|value<<1)
}
func (o *SPI1_Type) GetINT_ST_PES_END_INT_ST() uint32 {
	return (volatile.LoadUint32(&o.INT_ST.Reg) & 0x2) >> 1
}
func (o *SPI1_Type) SetINT_ST_WPE_END_INT_ST(value uint32) {
	volatile.StoreUint32(&o.INT_ST.Reg, volatile.LoadUint32(&o.INT_ST.Reg)&^(0x4)|value<<2)
}
func (o *SPI1_Type) GetINT_ST_WPE_END_INT_ST() uint32 {
	return (volatile.LoadUint32(&o.INT_ST.Reg) & 0x4) >> 2
}
func (o *SPI1_Type) SetINT_ST_SLV_ST_END_INT_ST(value uint32) {
	volatile.StoreUint32(&o.INT_ST.Reg, volatile.LoadUint32(&o.INT_ST.Reg)&^(0x8)|value<<3)
}
func (o *SPI1_Type) GetINT_ST_SLV_ST_END_INT_ST() uint32 {
	return (volatile.LoadUint32(&o.INT_ST.Reg) & 0x8) >> 3
}
func (o *SPI1_Type) SetINT_ST_MST_ST_END_INT_ST(value uint32) {
	volatile.StoreUint32(&o.INT_ST.Reg, volatile.LoadUint32(&o.INT_ST.Reg)&^(0x10)|value<<4)
}
func (o *SPI1_Type) GetINT_ST_MST_ST_END_INT_ST() uint32 {
	return (volatile.LoadUint32(&o.INT_ST.Reg) & 0x10) >> 4
}

// SPI1.CLOCK_GATE: SPI1 clk_gate register
func (o *SPI1_Type) SetCLOCK_GATE_CLK_EN(value uint32) {
	volatile.StoreUint32(&o.CLOCK_GATE.Reg, volatile.LoadUint32(&o.CLOCK_GATE.Reg)&^(0x1)|value)
}
func (o *SPI1_Type) GetCLOCK_GATE_CLK_EN() uint32 {
	return volatile.LoadUint32(&o.CLOCK_GATE.Reg) & 0x1
}

// SPI1.DATE: Version control register
func (o *SPI1_Type) SetDATE(value uint32) {
	volatile.StoreUint32(&o.DATE.Reg, volatile.LoadUint32(&o.DATE.Reg)&^(0xfffffff)|value)
}
func (o *SPI1_Type) GetDATE() uint32 {
	return volatile.LoadUint32(&o.DATE.Reg) & 0xfffffff
}

// Peripheral SPI2
type SPI2_Type struct {
	CMD         volatile.Register32 // 0x0
	ADDR        volatile.Register32 // 0x4
	CTRL        volatile.Register32 // 0x8
	CLOCK       volatile.Register32 // 0xC
	USER        volatile.Register32 // 0x10
	USER1       volatile.Register32 // 0x14
	USER2       volatile.Register32 // 0x18
	MS_DLEN     volatile.Register32 // 0x1C
	MISC        volatile.Register32 // 0x20
	DIN_MODE    volatile.Register32 // 0x24
	DIN_NUM     volatile.Register32 // 0x28
	DOUT_MODE   volatile.Register32 // 0x2C
	DMA_CONF    volatile.Register32 // 0x30
	DMA_INT_ENA volatile.Register32 // 0x34
	DMA_INT_CLR volatile.Register32 // 0x38
	DMA_INT_RAW volatile.Register32 // 0x3C
	DMA_INT_ST  volatile.Register32 // 0x40
	_           [84]byte
	W0          volatile.Register32 // 0x98
	W1          volatile.Register32 // 0x9C
	W2          volatile.Register32 // 0xA0
	W3          volatile.Register32 // 0xA4
	W4          volatile.Register32 // 0xA8
	W5          volatile.Register32 // 0xAC
	W6          volatile.Register32 // 0xB0
	W7          volatile.Register32 // 0xB4
	W8          volatile.Register32 // 0xB8
	W9          volatile.Register32 // 0xBC
	W10         volatile.Register32 // 0xC0
	W11         volatile.Register32 // 0xC4
	W12         volatile.Register32 // 0xC8
	W13         volatile.Register32 // 0xCC
	W14         volatile.Register32 // 0xD0
	W15         volatile.Register32 // 0xD4
	_           [8]byte
	SLAVE       volatile.Register32 // 0xE0
	SLAVE1      volatile.Register32 // 0xE4
	CLK_GATE    volatile.Register32 // 0xE8
	_           [4]byte
	DATE        volatile.Register32 // 0xF0
}

// SPI2.CMD: Command control register
func (o *SPI2_Type) SetCMD_CONF_BITLEN(value uint32) {
	volatile.StoreUint32(&o.CMD.Reg, volatile.LoadUint32(&o.CMD.Reg)&^(0x3ffff)|value)
}
func (o *SPI2_Type) GetCMD_CONF_BITLEN() uint32 {
	return volatile.LoadUint32(&o.CMD.Reg) & 0x3ffff
}
func (o *SPI2_Type) SetCMD_UPDATE(value uint32) {
	volatile.StoreUint32(&o.CMD.Reg, volatile.LoadUint32(&o.CMD.Reg)&^(0x800000)|value<<23)
}
func (o *SPI2_Type) GetCMD_UPDATE() uint32 {
	return (volatile.LoadUint32(&o.CMD.Reg) & 0x800000) >> 23
}
func (o *SPI2_Type) SetCMD_USR(value uint32) {
	volatile.StoreUint32(&o.CMD.Reg, volatile.LoadUint32(&o.CMD.Reg)&^(0x1000000)|value<<24)
}
func (o *SPI2_Type) GetCMD_USR() uint32 {
	return (volatile.LoadUint32(&o.CMD.Reg) & 0x1000000) >> 24
}

// SPI2.ADDR: Address value register
func (o *SPI2_Type) SetADDR(value uint32) {
	volatile.StoreUint32(&o.ADDR.Reg, value)
}
func (o *SPI2_Type) GetADDR() uint32 {
	return volatile.LoadUint32(&o.ADDR.Reg)
}

// SPI2.CTRL: SPI control register
func (o *SPI2_Type) SetCTRL_DUMMY_OUT(value uint32) {
	volatile.StoreUint32(&o.CTRL.Reg, volatile.LoadUint32(&o.CTRL.Reg)&^(0x8)|value<<3)
}
func (o *SPI2_Type) GetCTRL_DUMMY_OUT() uint32 {
	return (volatile.LoadUint32(&o.CTRL.Reg) & 0x8) >> 3
}
func (o *SPI2_Type) SetCTRL_FADDR_DUAL(value uint32) {
	volatile.StoreUint32(&o.CTRL.Reg, volatile.LoadUint32(&o.CTRL.Reg)&^(0x20)|value<<5)
}
func (o *SPI2_Type) GetCTRL_FADDR_DUAL() uint32 {
	return (volatile.LoadUint32(&o.CTRL.Reg) & 0x20) >> 5
}
func (o *SPI2_Type) SetCTRL_FADDR_QUAD(value uint32) {
	volatile.StoreUint32(&o.CTRL.Reg, volatile.LoadUint32(&o.CTRL.Reg)&^(0x40)|value<<6)
}
func (o *SPI2_Type) GetCTRL_FADDR_QUAD() uint32 {
	return (volatile.LoadUint32(&o.CTRL.Reg) & 0x40) >> 6
}
func (o *SPI2_Type) SetCTRL_FCMD_DUAL(value uint32) {
	volatile.StoreUint32(&o.CTRL.Reg, volatile.LoadUint32(&o.CTRL.Reg)&^(0x100)|value<<8)
}
func (o *SPI2_Type) GetCTRL_FCMD_DUAL() uint32 {
	return (volatile.LoadUint32(&o.CTRL.Reg) & 0x100) >> 8
}
func (o *SPI2_Type) SetCTRL_FCMD_QUAD(value uint32) {
	volatile.StoreUint32(&o.CTRL.Reg, volatile.LoadUint32(&o.CTRL.Reg)&^(0x200)|value<<9)
}
func (o *SPI2_Type) GetCTRL_FCMD_QUAD() uint32 {
	return (volatile.LoadUint32(&o.CTRL.Reg) & 0x200) >> 9
}
func (o *SPI2_Type) SetCTRL_FREAD_DUAL(value uint32) {
	volatile.StoreUint32(&o.CTRL.Reg, volatile.LoadUint32(&o.CTRL.Reg)&^(0x4000)|value<<14)
}
func (o *SPI2_Type) GetCTRL_FREAD_DUAL() uint32 {
	return (volatile.LoadUint32(&o.CTRL.Reg) & 0x4000) >> 14
}
func (o *SPI2_Type) SetCTRL_FREAD_QUAD(value uint32) {
	volatile.StoreUint32(&o.CTRL.Reg, volatile.LoadUint32(&o.CTRL.Reg)&^(0x8000)|value<<15)
}
func (o *SPI2_Type) GetCTRL_FREAD_QUAD() uint32 {
	return (volatile.LoadUint32(&o.CTRL.Reg) & 0x8000) >> 15
}
func (o *SPI2_Type) SetCTRL_Q_POL(value uint32) {
	volatile.StoreUint32(&o.CTRL.Reg, volatile.LoadUint32(&o.CTRL.Reg)&^(0x40000)|value<<18)
}
func (o *SPI2_Type) GetCTRL_Q_POL() uint32 {
	return (volatile.LoadUint32(&o.CTRL.Reg) & 0x40000) >> 18
}
func (o *SPI2_Type) SetCTRL_D_POL(value uint32) {
	volatile.StoreUint32(&o.CTRL.Reg, volatile.LoadUint32(&o.CTRL.Reg)&^(0x80000)|value<<19)
}
func (o *SPI2_Type) GetCTRL_D_POL() uint32 {
	return (volatile.LoadUint32(&o.CTRL.Reg) & 0x80000) >> 19
}
func (o *SPI2_Type) SetCTRL_HOLD_POL(value uint32) {
	volatile.StoreUint32(&o.CTRL.Reg, volatile.LoadUint32(&o.CTRL.Reg)&^(0x100000)|value<<20)
}
func (o *SPI2_Type) GetCTRL_HOLD_POL() uint32 {
	return (volatile.LoadUint32(&o.CTRL.Reg) & 0x100000) >> 20
}
func (o *SPI2_Type) SetCTRL_WP_POL(value uint32) {
	volatile.StoreUint32(&o.CTRL.Reg, volatile.LoadUint32(&o.CTRL.Reg)&^(0x200000)|value<<21)
}
func (o *SPI2_Type) GetCTRL_WP_POL() uint32 {
	return (volatile.LoadUint32(&o.CTRL.Reg) & 0x200000) >> 21
}
func (o *SPI2_Type) SetCTRL_RD_BIT_ORDER(value uint32) {
	volatile.StoreUint32(&o.CTRL.Reg, volatile.LoadUint32(&o.CTRL.Reg)&^(0x2000000)|value<<25)
}
func (o *SPI2_Type) GetCTRL_RD_BIT_ORDER() uint32 {
	return (volatile.LoadUint32(&o.CTRL.Reg) & 0x2000000) >> 25
}
func (o *SPI2_Type) SetCTRL_WR_BIT_ORDER(value uint32) {
	volatile.StoreUint32(&o.CTRL.Reg, volatile.LoadUint32(&o.CTRL.Reg)&^(0x4000000)|value<<26)
}
func (o *SPI2_Type) GetCTRL_WR_BIT_ORDER() uint32 {
	return (volatile.LoadUint32(&o.CTRL.Reg) & 0x4000000) >> 26
}

// SPI2.CLOCK: SPI clock control register
func (o *SPI2_Type) SetCLOCK_CLKCNT_L(value uint32) {
	volatile.StoreUint32(&o.CLOCK.Reg, volatile.LoadUint32(&o.CLOCK.Reg)&^(0x3f)|value)
}
func (o *SPI2_Type) GetCLOCK_CLKCNT_L() uint32 {
	return volatile.LoadUint32(&o.CLOCK.Reg) & 0x3f
}
func (o *SPI2_Type) SetCLOCK_CLKCNT_H(value uint32) {
	volatile.StoreUint32(&o.CLOCK.Reg, volatile.LoadUint32(&o.CLOCK.Reg)&^(0xfc0)|value<<6)
}
func (o *SPI2_Type) GetCLOCK_CLKCNT_H() uint32 {
	return (volatile.LoadUint32(&o.CLOCK.Reg) & 0xfc0) >> 6
}
func (o *SPI2_Type) SetCLOCK_CLKCNT_N(value uint32) {
	volatile.StoreUint32(&o.CLOCK.Reg, volatile.LoadUint32(&o.CLOCK.Reg)&^(0x3f000)|value<<12)
}
func (o *SPI2_Type) GetCLOCK_CLKCNT_N() uint32 {
	return (volatile.LoadUint32(&o.CLOCK.Reg) & 0x3f000) >> 12
}
func (o *SPI2_Type) SetCLOCK_CLKDIV_PRE(value uint32) {
	volatile.StoreUint32(&o.CLOCK.Reg, volatile.LoadUint32(&o.CLOCK.Reg)&^(0x3c0000)|value<<18)
}
func (o *SPI2_Type) GetCLOCK_CLKDIV_PRE() uint32 {
	return (volatile.LoadUint32(&o.CLOCK.Reg) & 0x3c0000) >> 18
}
func (o *SPI2_Type) SetCLOCK_CLK_EQU_SYSCLK(value uint32) {
	volatile.StoreUint32(&o.CLOCK.Reg, volatile.LoadUint32(&o.CLOCK.Reg)&^(0x80000000)|value<<31)
}
func (o *SPI2_Type) GetCLOCK_CLK_EQU_SYSCLK() uint32 {
	return (volatile.LoadUint32(&o.CLOCK.Reg) & 0x80000000) >> 31
}

// SPI2.USER: SPI USER control register
func (o *SPI2_Type) SetUSER_DOUTDIN(value uint32) {
	volatile.StoreUint32(&o.USER.Reg, volatile.LoadUint32(&o.USER.Reg)&^(0x1)|value)
}
func (o *SPI2_Type) GetUSER_DOUTDIN() uint32 {
	return volatile.LoadUint32(&o.USER.Reg) & 0x1
}
func (o *SPI2_Type) SetUSER_QPI_MODE(value uint32) {
	volatile.StoreUint32(&o.USER.Reg, volatile.LoadUint32(&o.USER.Reg)&^(0x8)|value<<3)
}
func (o *SPI2_Type) GetUSER_QPI_MODE() uint32 {
	return (volatile.LoadUint32(&o.USER.Reg) & 0x8) >> 3
}
func (o *SPI2_Type) SetUSER_TSCK_I_EDGE(value uint32) {
	volatile.StoreUint32(&o.USER.Reg, volatile.LoadUint32(&o.USER.Reg)&^(0x20)|value<<5)
}
func (o *SPI2_Type) GetUSER_TSCK_I_EDGE() uint32 {
	return (volatile.LoadUint32(&o.USER.Reg) & 0x20) >> 5
}
func (o *SPI2_Type) SetUSER_CS_HOLD(value uint32) {
	volatile.StoreUint32(&o.USER.Reg, volatile.LoadUint32(&o.USER.Reg)&^(0x40)|value<<6)
}
func (o *SPI2_Type) GetUSER_CS_HOLD() uint32 {
	return (volatile.LoadUint32(&o.USER.Reg) & 0x40) >> 6
}
func (o *SPI2_Type) SetUSER_CS_SETUP(value uint32) {
	volatile.StoreUint32(&o.USER.Reg, volatile.LoadUint32(&o.USER.Reg)&^(0x80)|value<<7)
}
func (o *SPI2_Type) GetUSER_CS_SETUP() uint32 {
	return (volatile.LoadUint32(&o.USER.Reg) & 0x80) >> 7
}
func (o *SPI2_Type) SetUSER_RSCK_I_EDGE(value uint32) {
	volatile.StoreUint32(&o.USER.Reg, volatile.LoadUint32(&o.USER.Reg)&^(0x100)|value<<8)
}
func (o *SPI2_Type) GetUSER_RSCK_I_EDGE() uint32 {
	return (volatile.LoadUint32(&o.USER.Reg) & 0x100) >> 8
}
func (o *SPI2_Type) SetUSER_CK_OUT_EDGE(value uint32) {
	volatile.StoreUint32(&o.USER.Reg, volatile.LoadUint32(&o.USER.Reg)&^(0x200)|value<<9)
}
func (o *SPI2_Type) GetUSER_CK_OUT_EDGE() uint32 {
	return (volatile.LoadUint32(&o.USER.Reg) & 0x200) >> 9
}
func (o *SPI2_Type) SetUSER_FWRITE_DUAL(value uint32) {
	volatile.StoreUint32(&o.USER.Reg, volatile.LoadUint32(&o.USER.Reg)&^(0x1000)|value<<12)
}
func (o *SPI2_Type) GetUSER_FWRITE_DUAL() uint32 {
	return (volatile.LoadUint32(&o.USER.Reg) & 0x1000) >> 12
}
func (o *SPI2_Type) SetUSER_FWRITE_QUAD(value uint32) {
	volatile.StoreUint32(&o.USER.Reg, volatile.LoadUint32(&o.USER.Reg)&^(0x2000)|value<<13)
}
func (o *SPI2_Type) GetUSER_FWRITE_QUAD() uint32 {
	return (volatile.LoadUint32(&o.USER.Reg) & 0x2000) >> 13
}
func (o *SPI2_Type) SetUSER_USR_CONF_NXT(value uint32) {
	volatile.StoreUint32(&o.USER.Reg, volatile.LoadUint32(&o.USER.Reg)&^(0x8000)|value<<15)
}
func (o *SPI2_Type) GetUSER_USR_CONF_NXT() uint32 {
	return (volatile.LoadUint32(&o.USER.Reg) & 0x8000) >> 15
}
func (o *SPI2_Type) SetUSER_SIO(value uint32) {
	volatile.StoreUint32(&o.USER.Reg, volatile.LoadUint32(&o.USER.Reg)&^(0x20000)|value<<17)
}
func (o *SPI2_Type) GetUSER_SIO() uint32 {
	return (volatile.LoadUint32(&o.USER.Reg) & 0x20000) >> 17
}
func (o *SPI2_Type) SetUSER_USR_MISO_HIGHPART(value uint32) {
	volatile.StoreUint32(&o.USER.Reg, volatile.LoadUint32(&o.USER.Reg)&^(0x1000000)|value<<24)
}
func (o *SPI2_Type) GetUSER_USR_MISO_HIGHPART() uint32 {
	return (volatile.LoadUint32(&o.USER.Reg) & 0x1000000) >> 24
}
func (o *SPI2_Type) SetUSER_USR_MOSI_HIGHPART(value uint32) {
	volatile.StoreUint32(&o.USER.Reg, volatile.LoadUint32(&o.USER.Reg)&^(0x2000000)|value<<25)
}
func (o *SPI2_Type) GetUSER_USR_MOSI_HIGHPART() uint32 {
	return (volatile.LoadUint32(&o.USER.Reg) & 0x2000000) >> 25
}
func (o *SPI2_Type) SetUSER_USR_DUMMY_IDLE(value uint32) {
	volatile.StoreUint32(&o.USER.Reg, volatile.LoadUint32(&o.USER.Reg)&^(0x4000000)|value<<26)
}
func (o *SPI2_Type) GetUSER_USR_DUMMY_IDLE() uint32 {
	return (volatile.LoadUint32(&o.USER.Reg) & 0x4000000) >> 26
}
func (o *SPI2_Type) SetUSER_USR_MOSI(value uint32) {
	volatile.StoreUint32(&o.USER.Reg, volatile.LoadUint32(&o.USER.Reg)&^(0x8000000)|value<<27)
}
func (o *SPI2_Type) GetUSER_USR_MOSI() uint32 {
	return (volatile.LoadUint32(&o.USER.Reg) & 0x8000000) >> 27
}
func (o *SPI2_Type) SetUSER_USR_MISO(value uint32) {
	volatile.StoreUint32(&o.USER.Reg, volatile.LoadUint32(&o.USER.Reg)&^(0x10000000)|value<<28)
}
func (o *SPI2_Type) GetUSER_USR_MISO() uint32 {
	return (volatile.LoadUint32(&o.USER.Reg) & 0x10000000) >> 28
}
func (o *SPI2_Type) SetUSER_USR_DUMMY(value uint32) {
	volatile.StoreUint32(&o.USER.Reg, volatile.LoadUint32(&o.USER.Reg)&^(0x20000000)|value<<29)
}
func (o *SPI2_Type) GetUSER_USR_DUMMY() uint32 {
	return (volatile.LoadUint32(&o.USER.Reg) & 0x20000000) >> 29
}
func (o *SPI2_Type) SetUSER_USR_ADDR(value uint32) {
	volatile.StoreUint32(&o.USER.Reg, volatile.LoadUint32(&o.USER.Reg)&^(0x40000000)|value<<30)
}
func (o *SPI2_Type) GetUSER_USR_ADDR() uint32 {
	return (volatile.LoadUint32(&o.USER.Reg) & 0x40000000) >> 30
}
func (o *SPI2_Type) SetUSER_USR_COMMAND(value uint32) {
	volatile.StoreUint32(&o.USER.Reg, volatile.LoadUint32(&o.USER.Reg)&^(0x80000000)|value<<31)
}
func (o *SPI2_Type) GetUSER_USR_COMMAND() uint32 {
	return (volatile.LoadUint32(&o.USER.Reg) & 0x80000000) >> 31
}

// SPI2.USER1: SPI USER control register 1
func (o *SPI2_Type) SetUSER1_USR_DUMMY_CYCLELEN(value uint32) {
	volatile.StoreUint32(&o.USER1.Reg, volatile.LoadUint32(&o.USER1.Reg)&^(0xff)|value)
}
func (o *SPI2_Type) GetUSER1_USR_DUMMY_CYCLELEN() uint32 {
	return volatile.LoadUint32(&o.USER1.Reg) & 0xff
}
func (o *SPI2_Type) SetUSER1_MST_WFULL_ERR_END_EN(value uint32) {
	volatile.StoreUint32(&o.USER1.Reg, volatile.LoadUint32(&o.USER1.Reg)&^(0x10000)|value<<16)
}
func (o *SPI2_Type) GetUSER1_MST_WFULL_ERR_END_EN() uint32 {
	return (volatile.LoadUint32(&o.USER1.Reg) & 0x10000) >> 16
}
func (o *SPI2_Type) SetUSER1_CS_SETUP_TIME(value uint32) {
	volatile.StoreUint32(&o.USER1.Reg, volatile.LoadUint32(&o.USER1.Reg)&^(0x3e0000)|value<<17)
}
func (o *SPI2_Type) GetUSER1_CS_SETUP_TIME() uint32 {
	return (volatile.LoadUint32(&o.USER1.Reg) & 0x3e0000) >> 17
}
func (o *SPI2_Type) SetUSER1_CS_HOLD_TIME(value uint32) {
	volatile.StoreUint32(&o.USER1.Reg, volatile.LoadUint32(&o.USER1.Reg)&^(0x7c00000)|value<<22)
}
func (o *SPI2_Type) GetUSER1_CS_HOLD_TIME() uint32 {
	return (volatile.LoadUint32(&o.USER1.Reg) & 0x7c00000) >> 22
}
func (o *SPI2_Type) SetUSER1_USR_ADDR_BITLEN(value uint32) {
	volatile.StoreUint32(&o.USER1.Reg, volatile.LoadUint32(&o.USER1.Reg)&^(0xf8000000)|value<<27)
}
func (o *SPI2_Type) GetUSER1_USR_ADDR_BITLEN() uint32 {
	return (volatile.LoadUint32(&o.USER1.Reg) & 0xf8000000) >> 27
}

// SPI2.USER2: SPI USER control register 2
func (o *SPI2_Type) SetUSER2_USR_COMMAND_VALUE(value uint32) {
	volatile.StoreUint32(&o.USER2.Reg, volatile.LoadUint32(&o.USER2.Reg)&^(0xffff)|value)
}
func (o *SPI2_Type) GetUSER2_USR_COMMAND_VALUE() uint32 {
	return volatile.LoadUint32(&o.USER2.Reg) & 0xffff
}
func (o *SPI2_Type) SetUSER2_MST_REMPTY_ERR_END_EN(value uint32) {
	volatile.StoreUint32(&o.USER2.Reg, volatile.LoadUint32(&o.USER2.Reg)&^(0x8000000)|value<<27)
}
func (o *SPI2_Type) GetUSER2_MST_REMPTY_ERR_END_EN() uint32 {
	return (volatile.LoadUint32(&o.USER2.Reg) & 0x8000000) >> 27
}
func (o *SPI2_Type) SetUSER2_USR_COMMAND_BITLEN(value uint32) {
	volatile.StoreUint32(&o.USER2.Reg, volatile.LoadUint32(&o.USER2.Reg)&^(0xf0000000)|value<<28)
}
func (o *SPI2_Type) GetUSER2_USR_COMMAND_BITLEN() uint32 {
	return (volatile.LoadUint32(&o.USER2.Reg) & 0xf0000000) >> 28
}

// SPI2.MS_DLEN: SPI data bit length control register
func (o *SPI2_Type) SetMS_DLEN_MS_DATA_BITLEN(value uint32) {
	volatile.StoreUint32(&o.MS_DLEN.Reg, volatile.LoadUint32(&o.MS_DLEN.Reg)&^(0x3ffff)|value)
}
func (o *SPI2_Type) GetMS_DLEN_MS_DATA_BITLEN() uint32 {
	return volatile.LoadUint32(&o.MS_DLEN.Reg) & 0x3ffff
}

// SPI2.MISC: SPI misc register
func (o *SPI2_Type) SetMISC_CS0_DIS(value uint32) {
	volatile.StoreUint32(&o.MISC.Reg, volatile.LoadUint32(&o.MISC.Reg)&^(0x1)|value)
}
func (o *SPI2_Type) GetMISC_CS0_DIS() uint32 {
	return volatile.LoadUint32(&o.MISC.Reg) & 0x1
}
func (o *SPI2_Type) SetMISC_CS1_DIS(value uint32) {
	volatile.StoreUint32(&o.MISC.Reg, volatile.LoadUint32(&o.MISC.Reg)&^(0x2)|value<<1)
}
func (o *SPI2_Type) GetMISC_CS1_DIS() uint32 {
	return (volatile.LoadUint32(&o.MISC.Reg) & 0x2) >> 1
}
func (o *SPI2_Type) SetMISC_CS2_DIS(value uint32) {
	volatile.StoreUint32(&o.MISC.Reg, volatile.LoadUint32(&o.MISC.Reg)&^(0x4)|value<<2)
}
func (o *SPI2_Type) GetMISC_CS2_DIS() uint32 {
	return (volatile.LoadUint32(&o.MISC.Reg) & 0x4) >> 2
}
func (o *SPI2_Type) SetMISC_CS3_DIS(value uint32) {
	volatile.StoreUint32(&o.MISC.Reg, volatile.LoadUint32(&o.MISC.Reg)&^(0x8)|value<<3)
}
func (o *SPI2_Type) GetMISC_CS3_DIS() uint32 {
	return (volatile.LoadUint32(&o.MISC.Reg) & 0x8) >> 3
}
func (o *SPI2_Type) SetMISC_CS4_DIS(value uint32) {
	volatile.StoreUint32(&o.MISC.Reg, volatile.LoadUint32(&o.MISC.Reg)&^(0x10)|value<<4)
}
func (o *SPI2_Type) GetMISC_CS4_DIS() uint32 {
	return (volatile.LoadUint32(&o.MISC.Reg) & 0x10) >> 4
}
func (o *SPI2_Type) SetMISC_CS5_DIS(value uint32) {
	volatile.StoreUint32(&o.MISC.Reg, volatile.LoadUint32(&o.MISC.Reg)&^(0x20)|value<<5)
}
func (o *SPI2_Type) GetMISC_CS5_DIS() uint32 {
	return (volatile.LoadUint32(&o.MISC.Reg) & 0x20) >> 5
}
func (o *SPI2_Type) SetMISC_CK_DIS(value uint32) {
	volatile.StoreUint32(&o.MISC.Reg, volatile.LoadUint32(&o.MISC.Reg)&^(0x40)|value<<6)
}
func (o *SPI2_Type) GetMISC_CK_DIS() uint32 {
	return (volatile.LoadUint32(&o.MISC.Reg) & 0x40) >> 6
}
func (o *SPI2_Type) SetMISC_MASTER_CS_POL(value uint32) {
	volatile.StoreUint32(&o.MISC.Reg, volatile.LoadUint32(&o.MISC.Reg)&^(0x1f80)|value<<7)
}
func (o *SPI2_Type) GetMISC_MASTER_CS_POL() uint32 {
	return (volatile.LoadUint32(&o.MISC.Reg) & 0x1f80) >> 7
}
func (o *SPI2_Type) SetMISC_SLAVE_CS_POL(value uint32) {
	volatile.StoreUint32(&o.MISC.Reg, volatile.LoadUint32(&o.MISC.Reg)&^(0x800000)|value<<23)
}
func (o *SPI2_Type) GetMISC_SLAVE_CS_POL() uint32 {
	return (volatile.LoadUint32(&o.MISC.Reg) & 0x800000) >> 23
}
func (o *SPI2_Type) SetMISC_CK_IDLE_EDGE(value uint32) {
	volatile.StoreUint32(&o.MISC.Reg, volatile.LoadUint32(&o.MISC.Reg)&^(0x20000000)|value<<29)
}
func (o *SPI2_Type) GetMISC_CK_IDLE_EDGE() uint32 {
	return (volatile.LoadUint32(&o.MISC.Reg) & 0x20000000) >> 29
}
func (o *SPI2_Type) SetMISC_CS_KEEP_ACTIVE(value uint32) {
	volatile.StoreUint32(&o.MISC.Reg, volatile.LoadUint32(&o.MISC.Reg)&^(0x40000000)|value<<30)
}
func (o *SPI2_Type) GetMISC_CS_KEEP_ACTIVE() uint32 {
	return (volatile.LoadUint32(&o.MISC.Reg) & 0x40000000) >> 30
}
func (o *SPI2_Type) SetMISC_QUAD_DIN_PIN_SWAP(value uint32) {
	volatile.StoreUint32(&o.MISC.Reg, volatile.LoadUint32(&o.MISC.Reg)&^(0x80000000)|value<<31)
}
func (o *SPI2_Type) GetMISC_QUAD_DIN_PIN_SWAP() uint32 {
	return (volatile.LoadUint32(&o.MISC.Reg) & 0x80000000) >> 31
}

// SPI2.DIN_MODE: SPI input delay mode configuration
func (o *SPI2_Type) SetDIN_MODE_DIN0_MODE(value uint32) {
	volatile.StoreUint32(&o.DIN_MODE.Reg, volatile.LoadUint32(&o.DIN_MODE.Reg)&^(0x3)|value)
}
func (o *SPI2_Type) GetDIN_MODE_DIN0_MODE() uint32 {
	return volatile.LoadUint32(&o.DIN_MODE.Reg) & 0x3
}
func (o *SPI2_Type) SetDIN_MODE_DIN1_MODE(value uint32) {
	volatile.StoreUint32(&o.DIN_MODE.Reg, volatile.LoadUint32(&o.DIN_MODE.Reg)&^(0xc)|value<<2)
}
func (o *SPI2_Type) GetDIN_MODE_DIN1_MODE() uint32 {
	return (volatile.LoadUint32(&o.DIN_MODE.Reg) & 0xc) >> 2
}
func (o *SPI2_Type) SetDIN_MODE_DIN2_MODE(value uint32) {
	volatile.StoreUint32(&o.DIN_MODE.Reg, volatile.LoadUint32(&o.DIN_MODE.Reg)&^(0x30)|value<<4)
}
func (o *SPI2_Type) GetDIN_MODE_DIN2_MODE() uint32 {
	return (volatile.LoadUint32(&o.DIN_MODE.Reg) & 0x30) >> 4
}
func (o *SPI2_Type) SetDIN_MODE_DIN3_MODE(value uint32) {
	volatile.StoreUint32(&o.DIN_MODE.Reg, volatile.LoadUint32(&o.DIN_MODE.Reg)&^(0xc0)|value<<6)
}
func (o *SPI2_Type) GetDIN_MODE_DIN3_MODE() uint32 {
	return (volatile.LoadUint32(&o.DIN_MODE.Reg) & 0xc0) >> 6
}
func (o *SPI2_Type) SetDIN_MODE_TIMING_HCLK_ACTIVE(value uint32) {
	volatile.StoreUint32(&o.DIN_MODE.Reg, volatile.LoadUint32(&o.DIN_MODE.Reg)&^(0x10000)|value<<16)
}
func (o *SPI2_Type) GetDIN_MODE_TIMING_HCLK_ACTIVE() uint32 {
	return (volatile.LoadUint32(&o.DIN_MODE.Reg) & 0x10000) >> 16
}

// SPI2.DIN_NUM: SPI input delay number configuration
func (o *SPI2_Type) SetDIN_NUM_DIN0_NUM(value uint32) {
	volatile.StoreUint32(&o.DIN_NUM.Reg, volatile.LoadUint32(&o.DIN_NUM.Reg)&^(0x3)|value)
}
func (o *SPI2_Type) GetDIN_NUM_DIN0_NUM() uint32 {
	return volatile.LoadUint32(&o.DIN_NUM.Reg) & 0x3
}
func (o *SPI2_Type) SetDIN_NUM_DIN1_NUM(value uint32) {
	volatile.StoreUint32(&o.DIN_NUM.Reg, volatile.LoadUint32(&o.DIN_NUM.Reg)&^(0xc)|value<<2)
}
func (o *SPI2_Type) GetDIN_NUM_DIN1_NUM() uint32 {
	return (volatile.LoadUint32(&o.DIN_NUM.Reg) & 0xc) >> 2
}
func (o *SPI2_Type) SetDIN_NUM_DIN2_NUM(value uint32) {
	volatile.StoreUint32(&o.DIN_NUM.Reg, volatile.LoadUint32(&o.DIN_NUM.Reg)&^(0x30)|value<<4)
}
func (o *SPI2_Type) GetDIN_NUM_DIN2_NUM() uint32 {
	return (volatile.LoadUint32(&o.DIN_NUM.Reg) & 0x30) >> 4
}
func (o *SPI2_Type) SetDIN_NUM_DIN3_NUM(value uint32) {
	volatile.StoreUint32(&o.DIN_NUM.Reg, volatile.LoadUint32(&o.DIN_NUM.Reg)&^(0xc0)|value<<6)
}
func (o *SPI2_Type) GetDIN_NUM_DIN3_NUM() uint32 {
	return (volatile.LoadUint32(&o.DIN_NUM.Reg) & 0xc0) >> 6
}

// SPI2.DOUT_MODE: SPI output delay mode configuration
func (o *SPI2_Type) SetDOUT_MODE_DOUT0_MODE(value uint32) {
	volatile.StoreUint32(&o.DOUT_MODE.Reg, volatile.LoadUint32(&o.DOUT_MODE.Reg)&^(0x1)|value)
}
func (o *SPI2_Type) GetDOUT_MODE_DOUT0_MODE() uint32 {
	return volatile.LoadUint32(&o.DOUT_MODE.Reg) & 0x1
}
func (o *SPI2_Type) SetDOUT_MODE_DOUT1_MODE(value uint32) {
	volatile.StoreUint32(&o.DOUT_MODE.Reg, volatile.LoadUint32(&o.DOUT_MODE.Reg)&^(0x2)|value<<1)
}
func (o *SPI2_Type) GetDOUT_MODE_DOUT1_MODE() uint32 {
	return (volatile.LoadUint32(&o.DOUT_MODE.Reg) & 0x2) >> 1
}
func (o *SPI2_Type) SetDOUT_MODE_DOUT2_MODE(value uint32) {
	volatile.StoreUint32(&o.DOUT_MODE.Reg, volatile.LoadUint32(&o.DOUT_MODE.Reg)&^(0x4)|value<<2)
}
func (o *SPI2_Type) GetDOUT_MODE_DOUT2_MODE() uint32 {
	return (volatile.LoadUint32(&o.DOUT_MODE.Reg) & 0x4) >> 2
}
func (o *SPI2_Type) SetDOUT_MODE_DOUT3_MODE(value uint32) {
	volatile.StoreUint32(&o.DOUT_MODE.Reg, volatile.LoadUint32(&o.DOUT_MODE.Reg)&^(0x8)|value<<3)
}
func (o *SPI2_Type) GetDOUT_MODE_DOUT3_MODE() uint32 {
	return (volatile.LoadUint32(&o.DOUT_MODE.Reg) & 0x8) >> 3
}

// SPI2.DMA_CONF: SPI DMA control register
func (o *SPI2_Type) SetDMA_CONF_DMA_SLV_SEG_TRANS_EN(value uint32) {
	volatile.StoreUint32(&o.DMA_CONF.Reg, volatile.LoadUint32(&o.DMA_CONF.Reg)&^(0x40000)|value<<18)
}
func (o *SPI2_Type) GetDMA_CONF_DMA_SLV_SEG_TRANS_EN() uint32 {
	return (volatile.LoadUint32(&o.DMA_CONF.Reg) & 0x40000) >> 18
}
func (o *SPI2_Type) SetDMA_CONF_SLV_RX_SEG_TRANS_CLR_EN(value uint32) {
	volatile.StoreUint32(&o.DMA_CONF.Reg, volatile.LoadUint32(&o.DMA_CONF.Reg)&^(0x80000)|value<<19)
}
func (o *SPI2_Type) GetDMA_CONF_SLV_RX_SEG_TRANS_CLR_EN() uint32 {
	return (volatile.LoadUint32(&o.DMA_CONF.Reg) & 0x80000) >> 19
}
func (o *SPI2_Type) SetDMA_CONF_SLV_TX_SEG_TRANS_CLR_EN(value uint32) {
	volatile.StoreUint32(&o.DMA_CONF.Reg, volatile.LoadUint32(&o.DMA_CONF.Reg)&^(0x100000)|value<<20)
}
func (o *SPI2_Type) GetDMA_CONF_SLV_TX_SEG_TRANS_CLR_EN() uint32 {
	return (volatile.LoadUint32(&o.DMA_CONF.Reg) & 0x100000) >> 20
}
func (o *SPI2_Type) SetDMA_CONF_RX_EOF_EN(value uint32) {
	volatile.StoreUint32(&o.DMA_CONF.Reg, volatile.LoadUint32(&o.DMA_CONF.Reg)&^(0x200000)|value<<21)
}
func (o *SPI2_Type) GetDMA_CONF_RX_EOF_EN() uint32 {
	return (volatile.LoadUint32(&o.DMA_CONF.Reg) & 0x200000) >> 21
}
func (o *SPI2_Type) SetDMA_CONF_DMA_RX_ENA(value uint32) {
	volatile.StoreUint32(&o.DMA_CONF.Reg, volatile.LoadUint32(&o.DMA_CONF.Reg)&^(0x8000000)|value<<27)
}
func (o *SPI2_Type) GetDMA_CONF_DMA_RX_ENA() uint32 {
	return (volatile.LoadUint32(&o.DMA_CONF.Reg) & 0x8000000) >> 27
}
func (o *SPI2_Type) SetDMA_CONF_DMA_TX_ENA(value uint32) {
	volatile.StoreUint32(&o.DMA_CONF.Reg, volatile.LoadUint32(&o.DMA_CONF.Reg)&^(0x10000000)|value<<28)
}
func (o *SPI2_Type) GetDMA_CONF_DMA_TX_ENA() uint32 {
	return (volatile.LoadUint32(&o.DMA_CONF.Reg) & 0x10000000) >> 28
}
func (o *SPI2_Type) SetDMA_CONF_RX_AFIFO_RST(value uint32) {
	volatile.StoreUint32(&o.DMA_CONF.Reg, volatile.LoadUint32(&o.DMA_CONF.Reg)&^(0x20000000)|value<<29)
}
func (o *SPI2_Type) GetDMA_CONF_RX_AFIFO_RST() uint32 {
	return (volatile.LoadUint32(&o.DMA_CONF.Reg) & 0x20000000) >> 29
}
func (o *SPI2_Type) SetDMA_CONF_BUF_AFIFO_RST(value uint32) {
	volatile.StoreUint32(&o.DMA_CONF.Reg, volatile.LoadUint32(&o.DMA_CONF.Reg)&^(0x40000000)|value<<30)
}
func (o *SPI2_Type) GetDMA_CONF_BUF_AFIFO_RST() uint32 {
	return (volatile.LoadUint32(&o.DMA_CONF.Reg) & 0x40000000) >> 30
}
func (o *SPI2_Type) SetDMA_CONF_DMA_AFIFO_RST(value uint32) {
	volatile.StoreUint32(&o.DMA_CONF.Reg, volatile.LoadUint32(&o.DMA_CONF.Reg)&^(0x80000000)|value<<31)
}
func (o *SPI2_Type) GetDMA_CONF_DMA_AFIFO_RST() uint32 {
	return (volatile.LoadUint32(&o.DMA_CONF.Reg) & 0x80000000) >> 31
}

// SPI2.DMA_INT_ENA: SPI DMA interrupt enable register
func (o *SPI2_Type) SetDMA_INT_ENA_DMA_INFIFO_FULL_ERR_INT_ENA(value uint32) {
	volatile.StoreUint32(&o.DMA_INT_ENA.Reg, volatile.LoadUint32(&o.DMA_INT_ENA.Reg)&^(0x1)|value)
}
func (o *SPI2_Type) GetDMA_INT_ENA_DMA_INFIFO_FULL_ERR_INT_ENA() uint32 {
	return volatile.LoadUint32(&o.DMA_INT_ENA.Reg) & 0x1
}
func (o *SPI2_Type) SetDMA_INT_ENA_DMA_OUTFIFO_EMPTY_ERR_INT_ENA(value uint32) {
	volatile.StoreUint32(&o.DMA_INT_ENA.Reg, volatile.LoadUint32(&o.DMA_INT_ENA.Reg)&^(0x2)|value<<1)
}
func (o *SPI2_Type) GetDMA_INT_ENA_DMA_OUTFIFO_EMPTY_ERR_INT_ENA() uint32 {
	return (volatile.LoadUint32(&o.DMA_INT_ENA.Reg) & 0x2) >> 1
}
func (o *SPI2_Type) SetDMA_INT_ENA_SLV_EX_QPI_INT_ENA(value uint32) {
	volatile.StoreUint32(&o.DMA_INT_ENA.Reg, volatile.LoadUint32(&o.DMA_INT_ENA.Reg)&^(0x4)|value<<2)
}
func (o *SPI2_Type) GetDMA_INT_ENA_SLV_EX_QPI_INT_ENA() uint32 {
	return (volatile.LoadUint32(&o.DMA_INT_ENA.Reg) & 0x4) >> 2
}
func (o *SPI2_Type) SetDMA_INT_ENA_SLV_EN_QPI_INT_ENA(value uint32) {
	volatile.StoreUint32(&o.DMA_INT_ENA.Reg, volatile.LoadUint32(&o.DMA_INT_ENA.Reg)&^(0x8)|value<<3)
}
func (o *SPI2_Type) GetDMA_INT_ENA_SLV_EN_QPI_INT_ENA() uint32 {
	return (volatile.LoadUint32(&o.DMA_INT_ENA.Reg) & 0x8) >> 3
}
func (o *SPI2_Type) SetDMA_INT_ENA_SLV_CMD7_INT_ENA(value uint32) {
	volatile.StoreUint32(&o.DMA_INT_ENA.Reg, volatile.LoadUint32(&o.DMA_INT_ENA.Reg)&^(0x10)|value<<4)
}
func (o *SPI2_Type) GetDMA_INT_ENA_SLV_CMD7_INT_ENA() uint32 {
	return (volatile.LoadUint32(&o.DMA_INT_ENA.Reg) & 0x10) >> 4
}
func (o *SPI2_Type) SetDMA_INT_ENA_SLV_CMD8_INT_ENA(value uint32) {
	volatile.StoreUint32(&o.DMA_INT_ENA.Reg, volatile.LoadUint32(&o.DMA_INT_ENA.Reg)&^(0x20)|value<<5)
}
func (o *SPI2_Type) GetDMA_INT_ENA_SLV_CMD8_INT_ENA() uint32 {
	return (volatile.LoadUint32(&o.DMA_INT_ENA.Reg) & 0x20) >> 5
}
func (o *SPI2_Type) SetDMA_INT_ENA_SLV_CMD9_INT_ENA(value uint32) {
	volatile.StoreUint32(&o.DMA_INT_ENA.Reg, volatile.LoadUint32(&o.DMA_INT_ENA.Reg)&^(0x40)|value<<6)
}
func (o *SPI2_Type) GetDMA_INT_ENA_SLV_CMD9_INT_ENA() uint32 {
	return (volatile.LoadUint32(&o.DMA_INT_ENA.Reg) & 0x40) >> 6
}
func (o *SPI2_Type) SetDMA_INT_ENA_SLV_CMDA_INT_ENA(value uint32) {
	volatile.StoreUint32(&o.DMA_INT_ENA.Reg, volatile.LoadUint32(&o.DMA_INT_ENA.Reg)&^(0x80)|value<<7)
}
func (o *SPI2_Type) GetDMA_INT_ENA_SLV_CMDA_INT_ENA() uint32 {
	return (volatile.LoadUint32(&o.DMA_INT_ENA.Reg) & 0x80) >> 7
}
func (o *SPI2_Type) SetDMA_INT_ENA_SLV_RD_DMA_DONE_INT_ENA(value uint32) {
	volatile.StoreUint32(&o.DMA_INT_ENA.Reg, volatile.LoadUint32(&o.DMA_INT_ENA.Reg)&^(0x100)|value<<8)
}
func (o *SPI2_Type) GetDMA_INT_ENA_SLV_RD_DMA_DONE_INT_ENA() uint32 {
	return (volatile.LoadUint32(&o.DMA_INT_ENA.Reg) & 0x100) >> 8
}
func (o *SPI2_Type) SetDMA_INT_ENA_SLV_WR_DMA_DONE_INT_ENA(value uint32) {
	volatile.StoreUint32(&o.DMA_INT_ENA.Reg, volatile.LoadUint32(&o.DMA_INT_ENA.Reg)&^(0x200)|value<<9)
}
func (o *SPI2_Type) GetDMA_INT_ENA_SLV_WR_DMA_DONE_INT_ENA() uint32 {
	return (volatile.LoadUint32(&o.DMA_INT_ENA.Reg) & 0x200) >> 9
}
func (o *SPI2_Type) SetDMA_INT_ENA_SLV_RD_BUF_DONE_INT_ENA(value uint32) {
	volatile.StoreUint32(&o.DMA_INT_ENA.Reg, volatile.LoadUint32(&o.DMA_INT_ENA.Reg)&^(0x400)|value<<10)
}
func (o *SPI2_Type) GetDMA_INT_ENA_SLV_RD_BUF_DONE_INT_ENA() uint32 {
	return (volatile.LoadUint32(&o.DMA_INT_ENA.Reg) & 0x400) >> 10
}
func (o *SPI2_Type) SetDMA_INT_ENA_SLV_WR_BUF_DONE_INT_ENA(value uint32) {
	volatile.StoreUint32(&o.DMA_INT_ENA.Reg, volatile.LoadUint32(&o.DMA_INT_ENA.Reg)&^(0x800)|value<<11)
}
func (o *SPI2_Type) GetDMA_INT_ENA_SLV_WR_BUF_DONE_INT_ENA() uint32 {
	return (volatile.LoadUint32(&o.DMA_INT_ENA.Reg) & 0x800) >> 11
}
func (o *SPI2_Type) SetDMA_INT_ENA_TRANS_DONE_INT_ENA(value uint32) {
	volatile.StoreUint32(&o.DMA_INT_ENA.Reg, volatile.LoadUint32(&o.DMA_INT_ENA.Reg)&^(0x1000)|value<<12)
}
func (o *SPI2_Type) GetDMA_INT_ENA_TRANS_DONE_INT_ENA() uint32 {
	return (volatile.LoadUint32(&o.DMA_INT_ENA.Reg) & 0x1000) >> 12
}
func (o *SPI2_Type) SetDMA_INT_ENA_DMA_SEG_TRANS_DONE_INT_ENA(value uint32) {
	volatile.StoreUint32(&o.DMA_INT_ENA.Reg, volatile.LoadUint32(&o.DMA_INT_ENA.Reg)&^(0x2000)|value<<13)
}
func (o *SPI2_Type) GetDMA_INT_ENA_DMA_SEG_TRANS_DONE_INT_ENA() uint32 {
	return (volatile.LoadUint32(&o.DMA_INT_ENA.Reg) & 0x2000) >> 13
}
func (o *SPI2_Type) SetDMA_INT_ENA_SEG_MAGIC_ERR_INT_ENA(value uint32) {
	volatile.StoreUint32(&o.DMA_INT_ENA.Reg, volatile.LoadUint32(&o.DMA_INT_ENA.Reg)&^(0x4000)|value<<14)
}
func (o *SPI2_Type) GetDMA_INT_ENA_SEG_MAGIC_ERR_INT_ENA() uint32 {
	return (volatile.LoadUint32(&o.DMA_INT_ENA.Reg) & 0x4000) >> 14
}
func (o *SPI2_Type) SetDMA_INT_ENA_SLV_BUF_ADDR_ERR_INT_ENA(value uint32) {
	volatile.StoreUint32(&o.DMA_INT_ENA.Reg, volatile.LoadUint32(&o.DMA_INT_ENA.Reg)&^(0x8000)|value<<15)
}
func (o *SPI2_Type) GetDMA_INT_ENA_SLV_BUF_ADDR_ERR_INT_ENA() uint32 {
	return (volatile.LoadUint32(&o.DMA_INT_ENA.Reg) & 0x8000) >> 15
}
func (o *SPI2_Type) SetDMA_INT_ENA_SLV_CMD_ERR_INT_ENA(value uint32) {
	volatile.StoreUint32(&o.DMA_INT_ENA.Reg, volatile.LoadUint32(&o.DMA_INT_ENA.Reg)&^(0x10000)|value<<16)
}
func (o *SPI2_Type) GetDMA_INT_ENA_SLV_CMD_ERR_INT_ENA() uint32 {
	return (volatile.LoadUint32(&o.DMA_INT_ENA.Reg) & 0x10000) >> 16
}
func (o *SPI2_Type) SetDMA_INT_ENA_MST_RX_AFIFO_WFULL_ERR_INT_ENA(value uint32) {
	volatile.StoreUint32(&o.DMA_INT_ENA.Reg, volatile.LoadUint32(&o.DMA_INT_ENA.Reg)&^(0x20000)|value<<17)
}
func (o *SPI2_Type) GetDMA_INT_ENA_MST_RX_AFIFO_WFULL_ERR_INT_ENA() uint32 {
	return (volatile.LoadUint32(&o.DMA_INT_ENA.Reg) & 0x20000) >> 17
}
func (o *SPI2_Type) SetDMA_INT_ENA_MST_TX_AFIFO_REMPTY_ERR_INT_ENA(value uint32) {
	volatile.StoreUint32(&o.DMA_INT_ENA.Reg, volatile.LoadUint32(&o.DMA_INT_ENA.Reg)&^(0x40000)|value<<18)
}
func (o *SPI2_Type) GetDMA_INT_ENA_MST_TX_AFIFO_REMPTY_ERR_INT_ENA() uint32 {
	return (volatile.LoadUint32(&o.DMA_INT_ENA.Reg) & 0x40000) >> 18
}
func (o *SPI2_Type) SetDMA_INT_ENA_APP2_INT_ENA(value uint32) {
	volatile.StoreUint32(&o.DMA_INT_ENA.Reg, volatile.LoadUint32(&o.DMA_INT_ENA.Reg)&^(0x80000)|value<<19)
}
func (o *SPI2_Type) GetDMA_INT_ENA_APP2_INT_ENA() uint32 {
	return (volatile.LoadUint32(&o.DMA_INT_ENA.Reg) & 0x80000) >> 19
}
func (o *SPI2_Type) SetDMA_INT_ENA_APP1_INT_ENA(value uint32) {
	volatile.StoreUint32(&o.DMA_INT_ENA.Reg, volatile.LoadUint32(&o.DMA_INT_ENA.Reg)&^(0x100000)|value<<20)
}
func (o *SPI2_Type) GetDMA_INT_ENA_APP1_INT_ENA() uint32 {
	return (volatile.LoadUint32(&o.DMA_INT_ENA.Reg) & 0x100000) >> 20
}

// SPI2.DMA_INT_CLR: SPI DMA interrupt clear register
func (o *SPI2_Type) SetDMA_INT_CLR_DMA_INFIFO_FULL_ERR_INT_CLR(value uint32) {
	volatile.StoreUint32(&o.DMA_INT_CLR.Reg, volatile.LoadUint32(&o.DMA_INT_CLR.Reg)&^(0x1)|value)
}
func (o *SPI2_Type) GetDMA_INT_CLR_DMA_INFIFO_FULL_ERR_INT_CLR() uint32 {
	return volatile.LoadUint32(&o.DMA_INT_CLR.Reg) & 0x1
}
func (o *SPI2_Type) SetDMA_INT_CLR_DMA_OUTFIFO_EMPTY_ERR_INT_CLR(value uint32) {
	volatile.StoreUint32(&o.DMA_INT_CLR.Reg, volatile.LoadUint32(&o.DMA_INT_CLR.Reg)&^(0x2)|value<<1)
}
func (o *SPI2_Type) GetDMA_INT_CLR_DMA_OUTFIFO_EMPTY_ERR_INT_CLR() uint32 {
	return (volatile.LoadUint32(&o.DMA_INT_CLR.Reg) & 0x2) >> 1
}
func (o *SPI2_Type) SetDMA_INT_CLR_SLV_EX_QPI_INT_CLR(value uint32) {
	volatile.StoreUint32(&o.DMA_INT_CLR.Reg, volatile.LoadUint32(&o.DMA_INT_CLR.Reg)&^(0x4)|value<<2)
}
func (o *SPI2_Type) GetDMA_INT_CLR_SLV_EX_QPI_INT_CLR() uint32 {
	return (volatile.LoadUint32(&o.DMA_INT_CLR.Reg) & 0x4) >> 2
}
func (o *SPI2_Type) SetDMA_INT_CLR_SLV_EN_QPI_INT_CLR(value uint32) {
	volatile.StoreUint32(&o.DMA_INT_CLR.Reg, volatile.LoadUint32(&o.DMA_INT_CLR.Reg)&^(0x8)|value<<3)
}
func (o *SPI2_Type) GetDMA_INT_CLR_SLV_EN_QPI_INT_CLR() uint32 {
	return (volatile.LoadUint32(&o.DMA_INT_CLR.Reg) & 0x8) >> 3
}
func (o *SPI2_Type) SetDMA_INT_CLR_SLV_CMD7_INT_CLR(value uint32) {
	volatile.StoreUint32(&o.DMA_INT_CLR.Reg, volatile.LoadUint32(&o.DMA_INT_CLR.Reg)&^(0x10)|value<<4)
}
func (o *SPI2_Type) GetDMA_INT_CLR_SLV_CMD7_INT_CLR() uint32 {
	return (volatile.LoadUint32(&o.DMA_INT_CLR.Reg) & 0x10) >> 4
}
func (o *SPI2_Type) SetDMA_INT_CLR_SLV_CMD8_INT_CLR(value uint32) {
	volatile.StoreUint32(&o.DMA_INT_CLR.Reg, volatile.LoadUint32(&o.DMA_INT_CLR.Reg)&^(0x20)|value<<5)
}
func (o *SPI2_Type) GetDMA_INT_CLR_SLV_CMD8_INT_CLR() uint32 {
	return (volatile.LoadUint32(&o.DMA_INT_CLR.Reg) & 0x20) >> 5
}
func (o *SPI2_Type) SetDMA_INT_CLR_SLV_CMD9_INT_CLR(value uint32) {
	volatile.StoreUint32(&o.DMA_INT_CLR.Reg, volatile.LoadUint32(&o.DMA_INT_CLR.Reg)&^(0x40)|value<<6)
}
func (o *SPI2_Type) GetDMA_INT_CLR_SLV_CMD9_INT_CLR() uint32 {
	return (volatile.LoadUint32(&o.DMA_INT_CLR.Reg) & 0x40) >> 6
}
func (o *SPI2_Type) SetDMA_INT_CLR_SLV_CMDA_INT_CLR(value uint32) {
	volatile.StoreUint32(&o.DMA_INT_CLR.Reg, volatile.LoadUint32(&o.DMA_INT_CLR.Reg)&^(0x80)|value<<7)
}
func (o *SPI2_Type) GetDMA_INT_CLR_SLV_CMDA_INT_CLR() uint32 {
	return (volatile.LoadUint32(&o.DMA_INT_CLR.Reg) & 0x80) >> 7
}
func (o *SPI2_Type) SetDMA_INT_CLR_SLV_RD_DMA_DONE_INT_CLR(value uint32) {
	volatile.StoreUint32(&o.DMA_INT_CLR.Reg, volatile.LoadUint32(&o.DMA_INT_CLR.Reg)&^(0x100)|value<<8)
}
func (o *SPI2_Type) GetDMA_INT_CLR_SLV_RD_DMA_DONE_INT_CLR() uint32 {
	return (volatile.LoadUint32(&o.DMA_INT_CLR.Reg) & 0x100) >> 8
}
func (o *SPI2_Type) SetDMA_INT_CLR_SLV_WR_DMA_DONE_INT_CLR(value uint32) {
	volatile.StoreUint32(&o.DMA_INT_CLR.Reg, volatile.LoadUint32(&o.DMA_INT_CLR.Reg)&^(0x200)|value<<9)
}
func (o *SPI2_Type) GetDMA_INT_CLR_SLV_WR_DMA_DONE_INT_CLR() uint32 {
	return (volatile.LoadUint32(&o.DMA_INT_CLR.Reg) & 0x200) >> 9
}
func (o *SPI2_Type) SetDMA_INT_CLR_SLV_RD_BUF_DONE_INT_CLR(value uint32) {
	volatile.StoreUint32(&o.DMA_INT_CLR.Reg, volatile.LoadUint32(&o.DMA_INT_CLR.Reg)&^(0x400)|value<<10)
}
func (o *SPI2_Type) GetDMA_INT_CLR_SLV_RD_BUF_DONE_INT_CLR() uint32 {
	return (volatile.LoadUint32(&o.DMA_INT_CLR.Reg) & 0x400) >> 10
}
func (o *SPI2_Type) SetDMA_INT_CLR_SLV_WR_BUF_DONE_INT_CLR(value uint32) {
	volatile.StoreUint32(&o.DMA_INT_CLR.Reg, volatile.LoadUint32(&o.DMA_INT_CLR.Reg)&^(0x800)|value<<11)
}
func (o *SPI2_Type) GetDMA_INT_CLR_SLV_WR_BUF_DONE_INT_CLR() uint32 {
	return (volatile.LoadUint32(&o.DMA_INT_CLR.Reg) & 0x800) >> 11
}
func (o *SPI2_Type) SetDMA_INT_CLR_TRANS_DONE_INT_CLR(value uint32) {
	volatile.StoreUint32(&o.DMA_INT_CLR.Reg, volatile.LoadUint32(&o.DMA_INT_CLR.Reg)&^(0x1000)|value<<12)
}
func (o *SPI2_Type) GetDMA_INT_CLR_TRANS_DONE_INT_CLR() uint32 {
	return (volatile.LoadUint32(&o.DMA_INT_CLR.Reg) & 0x1000) >> 12
}
func (o *SPI2_Type) SetDMA_INT_CLR_DMA_SEG_TRANS_DONE_INT_CLR(value uint32) {
	volatile.StoreUint32(&o.DMA_INT_CLR.Reg, volatile.LoadUint32(&o.DMA_INT_CLR.Reg)&^(0x2000)|value<<13)
}
func (o *SPI2_Type) GetDMA_INT_CLR_DMA_SEG_TRANS_DONE_INT_CLR() uint32 {
	return (volatile.LoadUint32(&o.DMA_INT_CLR.Reg) & 0x2000) >> 13
}
func (o *SPI2_Type) SetDMA_INT_CLR_SEG_MAGIC_ERR_INT_CLR(value uint32) {
	volatile.StoreUint32(&o.DMA_INT_CLR.Reg, volatile.LoadUint32(&o.DMA_INT_CLR.Reg)&^(0x4000)|value<<14)
}
func (o *SPI2_Type) GetDMA_INT_CLR_SEG_MAGIC_ERR_INT_CLR() uint32 {
	return (volatile.LoadUint32(&o.DMA_INT_CLR.Reg) & 0x4000) >> 14
}
func (o *SPI2_Type) SetDMA_INT_CLR_SLV_BUF_ADDR_ERR_INT_CLR(value uint32) {
	volatile.StoreUint32(&o.DMA_INT_CLR.Reg, volatile.LoadUint32(&o.DMA_INT_CLR.Reg)&^(0x8000)|value<<15)
}
func (o *SPI2_Type) GetDMA_INT_CLR_SLV_BUF_ADDR_ERR_INT_CLR() uint32 {
	return (volatile.LoadUint32(&o.DMA_INT_CLR.Reg) & 0x8000) >> 15
}
func (o *SPI2_Type) SetDMA_INT_CLR_SLV_CMD_ERR_INT_CLR(value uint32) {
	volatile.StoreUint32(&o.DMA_INT_CLR.Reg, volatile.LoadUint32(&o.DMA_INT_CLR.Reg)&^(0x10000)|value<<16)
}
func (o *SPI2_Type) GetDMA_INT_CLR_SLV_CMD_ERR_INT_CLR() uint32 {
	return (volatile.LoadUint32(&o.DMA_INT_CLR.Reg) & 0x10000) >> 16
}
func (o *SPI2_Type) SetDMA_INT_CLR_MST_RX_AFIFO_WFULL_ERR_INT_CLR(value uint32) {
	volatile.StoreUint32(&o.DMA_INT_CLR.Reg, volatile.LoadUint32(&o.DMA_INT_CLR.Reg)&^(0x20000)|value<<17)
}
func (o *SPI2_Type) GetDMA_INT_CLR_MST_RX_AFIFO_WFULL_ERR_INT_CLR() uint32 {
	return (volatile.LoadUint32(&o.DMA_INT_CLR.Reg) & 0x20000) >> 17
}
func (o *SPI2_Type) SetDMA_INT_CLR_MST_TX_AFIFO_REMPTY_ERR_INT_CLR(value uint32) {
	volatile.StoreUint32(&o.DMA_INT_CLR.Reg, volatile.LoadUint32(&o.DMA_INT_CLR.Reg)&^(0x40000)|value<<18)
}
func (o *SPI2_Type) GetDMA_INT_CLR_MST_TX_AFIFO_REMPTY_ERR_INT_CLR() uint32 {
	return (volatile.LoadUint32(&o.DMA_INT_CLR.Reg) & 0x40000) >> 18
}
func (o *SPI2_Type) SetDMA_INT_CLR_APP2_INT_CLR(value uint32) {
	volatile.StoreUint32(&o.DMA_INT_CLR.Reg, volatile.LoadUint32(&o.DMA_INT_CLR.Reg)&^(0x80000)|value<<19)
}
func (o *SPI2_Type) GetDMA_INT_CLR_APP2_INT_CLR() uint32 {
	return (volatile.LoadUint32(&o.DMA_INT_CLR.Reg) & 0x80000) >> 19
}
func (o *SPI2_Type) SetDMA_INT_CLR_APP1_INT_CLR(value uint32) {
	volatile.StoreUint32(&o.DMA_INT_CLR.Reg, volatile.LoadUint32(&o.DMA_INT_CLR.Reg)&^(0x100000)|value<<20)
}
func (o *SPI2_Type) GetDMA_INT_CLR_APP1_INT_CLR() uint32 {
	return (volatile.LoadUint32(&o.DMA_INT_CLR.Reg) & 0x100000) >> 20
}

// SPI2.DMA_INT_RAW: SPI DMA interrupt raw register
func (o *SPI2_Type) SetDMA_INT_RAW_DMA_INFIFO_FULL_ERR_INT_RAW(value uint32) {
	volatile.StoreUint32(&o.DMA_INT_RAW.Reg, volatile.LoadUint32(&o.DMA_INT_RAW.Reg)&^(0x1)|value)
}
func (o *SPI2_Type) GetDMA_INT_RAW_DMA_INFIFO_FULL_ERR_INT_RAW() uint32 {
	return volatile.LoadUint32(&o.DMA_INT_RAW.Reg) & 0x1
}
func (o *SPI2_Type) SetDMA_INT_RAW_DMA_OUTFIFO_EMPTY_ERR_INT_RAW(value uint32) {
	volatile.StoreUint32(&o.DMA_INT_RAW.Reg, volatile.LoadUint32(&o.DMA_INT_RAW.Reg)&^(0x2)|value<<1)
}
func (o *SPI2_Type) GetDMA_INT_RAW_DMA_OUTFIFO_EMPTY_ERR_INT_RAW() uint32 {
	return (volatile.LoadUint32(&o.DMA_INT_RAW.Reg) & 0x2) >> 1
}
func (o *SPI2_Type) SetDMA_INT_RAW_SLV_EX_QPI_INT_RAW(value uint32) {
	volatile.StoreUint32(&o.DMA_INT_RAW.Reg, volatile.LoadUint32(&o.DMA_INT_RAW.Reg)&^(0x4)|value<<2)
}
func (o *SPI2_Type) GetDMA_INT_RAW_SLV_EX_QPI_INT_RAW() uint32 {
	return (volatile.LoadUint32(&o.DMA_INT_RAW.Reg) & 0x4) >> 2
}
func (o *SPI2_Type) SetDMA_INT_RAW_SLV_EN_QPI_INT_RAW(value uint32) {
	volatile.StoreUint32(&o.DMA_INT_RAW.Reg, volatile.LoadUint32(&o.DMA_INT_RAW.Reg)&^(0x8)|value<<3)
}
func (o *SPI2_Type) GetDMA_INT_RAW_SLV_EN_QPI_INT_RAW() uint32 {
	return (volatile.LoadUint32(&o.DMA_INT_RAW.Reg) & 0x8) >> 3
}
func (o *SPI2_Type) SetDMA_INT_RAW_SLV_CMD7_INT_RAW(value uint32) {
	volatile.StoreUint32(&o.DMA_INT_RAW.Reg, volatile.LoadUint32(&o.DMA_INT_RAW.Reg)&^(0x10)|value<<4)
}
func (o *SPI2_Type) GetDMA_INT_RAW_SLV_CMD7_INT_RAW() uint32 {
	return (volatile.LoadUint32(&o.DMA_INT_RAW.Reg) & 0x10) >> 4
}
func (o *SPI2_Type) SetDMA_INT_RAW_SLV_CMD8_INT_RAW(value uint32) {
	volatile.StoreUint32(&o.DMA_INT_RAW.Reg, volatile.LoadUint32(&o.DMA_INT_RAW.Reg)&^(0x20)|value<<5)
}
func (o *SPI2_Type) GetDMA_INT_RAW_SLV_CMD8_INT_RAW() uint32 {
	return (volatile.LoadUint32(&o.DMA_INT_RAW.Reg) & 0x20) >> 5
}
func (o *SPI2_Type) SetDMA_INT_RAW_SLV_CMD9_INT_RAW(value uint32) {
	volatile.StoreUint32(&o.DMA_INT_RAW.Reg, volatile.LoadUint32(&o.DMA_INT_RAW.Reg)&^(0x40)|value<<6)
}
func (o *SPI2_Type) GetDMA_INT_RAW_SLV_CMD9_INT_RAW() uint32 {
	return (volatile.LoadUint32(&o.DMA_INT_RAW.Reg) & 0x40) >> 6
}
func (o *SPI2_Type) SetDMA_INT_RAW_SLV_CMDA_INT_RAW(value uint32) {
	volatile.StoreUint32(&o.DMA_INT_RAW.Reg, volatile.LoadUint32(&o.DMA_INT_RAW.Reg)&^(0x80)|value<<7)
}
func (o *SPI2_Type) GetDMA_INT_RAW_SLV_CMDA_INT_RAW() uint32 {
	return (volatile.LoadUint32(&o.DMA_INT_RAW.Reg) & 0x80) >> 7
}
func (o *SPI2_Type) SetDMA_INT_RAW_SLV_RD_DMA_DONE_INT_RAW(value uint32) {
	volatile.StoreUint32(&o.DMA_INT_RAW.Reg, volatile.LoadUint32(&o.DMA_INT_RAW.Reg)&^(0x100)|value<<8)
}
func (o *SPI2_Type) GetDMA_INT_RAW_SLV_RD_DMA_DONE_INT_RAW() uint32 {
	return (volatile.LoadUint32(&o.DMA_INT_RAW.Reg) & 0x100) >> 8
}
func (o *SPI2_Type) SetDMA_INT_RAW_SLV_WR_DMA_DONE_INT_RAW(value uint32) {
	volatile.StoreUint32(&o.DMA_INT_RAW.Reg, volatile.LoadUint32(&o.DMA_INT_RAW.Reg)&^(0x200)|value<<9)
}
func (o *SPI2_Type) GetDMA_INT_RAW_SLV_WR_DMA_DONE_INT_RAW() uint32 {
	return (volatile.LoadUint32(&o.DMA_INT_RAW.Reg) & 0x200) >> 9
}
func (o *SPI2_Type) SetDMA_INT_RAW_SLV_RD_BUF_DONE_INT_RAW(value uint32) {
	volatile.StoreUint32(&o.DMA_INT_RAW.Reg, volatile.LoadUint32(&o.DMA_INT_RAW.Reg)&^(0x400)|value<<10)
}
func (o *SPI2_Type) GetDMA_INT_RAW_SLV_RD_BUF_DONE_INT_RAW() uint32 {
	return (volatile.LoadUint32(&o.DMA_INT_RAW.Reg) & 0x400) >> 10
}
func (o *SPI2_Type) SetDMA_INT_RAW_SLV_WR_BUF_DONE_INT_RAW(value uint32) {
	volatile.StoreUint32(&o.DMA_INT_RAW.Reg, volatile.LoadUint32(&o.DMA_INT_RAW.Reg)&^(0x800)|value<<11)
}
func (o *SPI2_Type) GetDMA_INT_RAW_SLV_WR_BUF_DONE_INT_RAW() uint32 {
	return (volatile.LoadUint32(&o.DMA_INT_RAW.Reg) & 0x800) >> 11
}
func (o *SPI2_Type) SetDMA_INT_RAW_TRANS_DONE_INT_RAW(value uint32) {
	volatile.StoreUint32(&o.DMA_INT_RAW.Reg, volatile.LoadUint32(&o.DMA_INT_RAW.Reg)&^(0x1000)|value<<12)
}
func (o *SPI2_Type) GetDMA_INT_RAW_TRANS_DONE_INT_RAW() uint32 {
	return (volatile.LoadUint32(&o.DMA_INT_RAW.Reg) & 0x1000) >> 12
}
func (o *SPI2_Type) SetDMA_INT_RAW_DMA_SEG_TRANS_DONE_INT_RAW(value uint32) {
	volatile.StoreUint32(&o.DMA_INT_RAW.Reg, volatile.LoadUint32(&o.DMA_INT_RAW.Reg)&^(0x2000)|value<<13)
}
func (o *SPI2_Type) GetDMA_INT_RAW_DMA_SEG_TRANS_DONE_INT_RAW() uint32 {
	return (volatile.LoadUint32(&o.DMA_INT_RAW.Reg) & 0x2000) >> 13
}
func (o *SPI2_Type) SetDMA_INT_RAW_SEG_MAGIC_ERR_INT_RAW(value uint32) {
	volatile.StoreUint32(&o.DMA_INT_RAW.Reg, volatile.LoadUint32(&o.DMA_INT_RAW.Reg)&^(0x4000)|value<<14)
}
func (o *SPI2_Type) GetDMA_INT_RAW_SEG_MAGIC_ERR_INT_RAW() uint32 {
	return (volatile.LoadUint32(&o.DMA_INT_RAW.Reg) & 0x4000) >> 14
}
func (o *SPI2_Type) SetDMA_INT_RAW_SLV_BUF_ADDR_ERR_INT_RAW(value uint32) {
	volatile.StoreUint32(&o.DMA_INT_RAW.Reg, volatile.LoadUint32(&o.DMA_INT_RAW.Reg)&^(0x8000)|value<<15)
}
func (o *SPI2_Type) GetDMA_INT_RAW_SLV_BUF_ADDR_ERR_INT_RAW() uint32 {
	return (volatile.LoadUint32(&o.DMA_INT_RAW.Reg) & 0x8000) >> 15
}
func (o *SPI2_Type) SetDMA_INT_RAW_SLV_CMD_ERR_INT_RAW(value uint32) {
	volatile.StoreUint32(&o.DMA_INT_RAW.Reg, volatile.LoadUint32(&o.DMA_INT_RAW.Reg)&^(0x10000)|value<<16)
}
func (o *SPI2_Type) GetDMA_INT_RAW_SLV_CMD_ERR_INT_RAW() uint32 {
	return (volatile.LoadUint32(&o.DMA_INT_RAW.Reg) & 0x10000) >> 16
}
func (o *SPI2_Type) SetDMA_INT_RAW_MST_RX_AFIFO_WFULL_ERR_INT_RAW(value uint32) {
	volatile.StoreUint32(&o.DMA_INT_RAW.Reg, volatile.LoadUint32(&o.DMA_INT_RAW.Reg)&^(0x20000)|value<<17)
}
func (o *SPI2_Type) GetDMA_INT_RAW_MST_RX_AFIFO_WFULL_ERR_INT_RAW() uint32 {
	return (volatile.LoadUint32(&o.DMA_INT_RAW.Reg) & 0x20000) >> 17
}
func (o *SPI2_Type) SetDMA_INT_RAW_MST_TX_AFIFO_REMPTY_ERR_INT_RAW(value uint32) {
	volatile.StoreUint32(&o.DMA_INT_RAW.Reg, volatile.LoadUint32(&o.DMA_INT_RAW.Reg)&^(0x40000)|value<<18)
}
func (o *SPI2_Type) GetDMA_INT_RAW_MST_TX_AFIFO_REMPTY_ERR_INT_RAW() uint32 {
	return (volatile.LoadUint32(&o.DMA_INT_RAW.Reg) & 0x40000) >> 18
}
func (o *SPI2_Type) SetDMA_INT_RAW_APP2_INT_RAW(value uint32) {
	volatile.StoreUint32(&o.DMA_INT_RAW.Reg, volatile.LoadUint32(&o.DMA_INT_RAW.Reg)&^(0x80000)|value<<19)
}
func (o *SPI2_Type) GetDMA_INT_RAW_APP2_INT_RAW() uint32 {
	return (volatile.LoadUint32(&o.DMA_INT_RAW.Reg) & 0x80000) >> 19
}
func (o *SPI2_Type) SetDMA_INT_RAW_APP1_INT_RAW(value uint32) {
	volatile.StoreUint32(&o.DMA_INT_RAW.Reg, volatile.LoadUint32(&o.DMA_INT_RAW.Reg)&^(0x100000)|value<<20)
}
func (o *SPI2_Type) GetDMA_INT_RAW_APP1_INT_RAW() uint32 {
	return (volatile.LoadUint32(&o.DMA_INT_RAW.Reg) & 0x100000) >> 20
}

// SPI2.DMA_INT_ST: SPI DMA interrupt status register
func (o *SPI2_Type) SetDMA_INT_ST_DMA_INFIFO_FULL_ERR_INT_ST(value uint32) {
	volatile.StoreUint32(&o.DMA_INT_ST.Reg, volatile.LoadUint32(&o.DMA_INT_ST.Reg)&^(0x1)|value)
}
func (o *SPI2_Type) GetDMA_INT_ST_DMA_INFIFO_FULL_ERR_INT_ST() uint32 {
	return volatile.LoadUint32(&o.DMA_INT_ST.Reg) & 0x1
}
func (o *SPI2_Type) SetDMA_INT_ST_DMA_OUTFIFO_EMPTY_ERR_INT_ST(value uint32) {
	volatile.StoreUint32(&o.DMA_INT_ST.Reg, volatile.LoadUint32(&o.DMA_INT_ST.Reg)&^(0x2)|value<<1)
}
func (o *SPI2_Type) GetDMA_INT_ST_DMA_OUTFIFO_EMPTY_ERR_INT_ST() uint32 {
	return (volatile.LoadUint32(&o.DMA_INT_ST.Reg) & 0x2) >> 1
}
func (o *SPI2_Type) SetDMA_INT_ST_SLV_EX_QPI_INT_ST(value uint32) {
	volatile.StoreUint32(&o.DMA_INT_ST.Reg, volatile.LoadUint32(&o.DMA_INT_ST.Reg)&^(0x4)|value<<2)
}
func (o *SPI2_Type) GetDMA_INT_ST_SLV_EX_QPI_INT_ST() uint32 {
	return (volatile.LoadUint32(&o.DMA_INT_ST.Reg) & 0x4) >> 2
}
func (o *SPI2_Type) SetDMA_INT_ST_SLV_EN_QPI_INT_ST(value uint32) {
	volatile.StoreUint32(&o.DMA_INT_ST.Reg, volatile.LoadUint32(&o.DMA_INT_ST.Reg)&^(0x8)|value<<3)
}
func (o *SPI2_Type) GetDMA_INT_ST_SLV_EN_QPI_INT_ST() uint32 {
	return (volatile.LoadUint32(&o.DMA_INT_ST.Reg) & 0x8) >> 3
}
func (o *SPI2_Type) SetDMA_INT_ST_SLV_CMD7_INT_ST(value uint32) {
	volatile.StoreUint32(&o.DMA_INT_ST.Reg, volatile.LoadUint32(&o.DMA_INT_ST.Reg)&^(0x10)|value<<4)
}
func (o *SPI2_Type) GetDMA_INT_ST_SLV_CMD7_INT_ST() uint32 {
	return (volatile.LoadUint32(&o.DMA_INT_ST.Reg) & 0x10) >> 4
}
func (o *SPI2_Type) SetDMA_INT_ST_SLV_CMD8_INT_ST(value uint32) {
	volatile.StoreUint32(&o.DMA_INT_ST.Reg, volatile.LoadUint32(&o.DMA_INT_ST.Reg)&^(0x20)|value<<5)
}
func (o *SPI2_Type) GetDMA_INT_ST_SLV_CMD8_INT_ST() uint32 {
	return (volatile.LoadUint32(&o.DMA_INT_ST.Reg) & 0x20) >> 5
}
func (o *SPI2_Type) SetDMA_INT_ST_SLV_CMD9_INT_ST(value uint32) {
	volatile.StoreUint32(&o.DMA_INT_ST.Reg, volatile.LoadUint32(&o.DMA_INT_ST.Reg)&^(0x40)|value<<6)
}
func (o *SPI2_Type) GetDMA_INT_ST_SLV_CMD9_INT_ST() uint32 {
	return (volatile.LoadUint32(&o.DMA_INT_ST.Reg) & 0x40) >> 6
}
func (o *SPI2_Type) SetDMA_INT_ST_SLV_CMDA_INT_ST(value uint32) {
	volatile.StoreUint32(&o.DMA_INT_ST.Reg, volatile.LoadUint32(&o.DMA_INT_ST.Reg)&^(0x80)|value<<7)
}
func (o *SPI2_Type) GetDMA_INT_ST_SLV_CMDA_INT_ST() uint32 {
	return (volatile.LoadUint32(&o.DMA_INT_ST.Reg) & 0x80) >> 7
}
func (o *SPI2_Type) SetDMA_INT_ST_SLV_RD_DMA_DONE_INT_ST(value uint32) {
	volatile.StoreUint32(&o.DMA_INT_ST.Reg, volatile.LoadUint32(&o.DMA_INT_ST.Reg)&^(0x100)|value<<8)
}
func (o *SPI2_Type) GetDMA_INT_ST_SLV_RD_DMA_DONE_INT_ST() uint32 {
	return (volatile.LoadUint32(&o.DMA_INT_ST.Reg) & 0x100) >> 8
}
func (o *SPI2_Type) SetDMA_INT_ST_SLV_WR_DMA_DONE_INT_ST(value uint32) {
	volatile.StoreUint32(&o.DMA_INT_ST.Reg, volatile.LoadUint32(&o.DMA_INT_ST.Reg)&^(0x200)|value<<9)
}
func (o *SPI2_Type) GetDMA_INT_ST_SLV_WR_DMA_DONE_INT_ST() uint32 {
	return (volatile.LoadUint32(&o.DMA_INT_ST.Reg) & 0x200) >> 9
}
func (o *SPI2_Type) SetDMA_INT_ST_SLV_RD_BUF_DONE_INT_ST(value uint32) {
	volatile.StoreUint32(&o.DMA_INT_ST.Reg, volatile.LoadUint32(&o.DMA_INT_ST.Reg)&^(0x400)|value<<10)
}
func (o *SPI2_Type) GetDMA_INT_ST_SLV_RD_BUF_DONE_INT_ST() uint32 {
	return (volatile.LoadUint32(&o.DMA_INT_ST.Reg) & 0x400) >> 10
}
func (o *SPI2_Type) SetDMA_INT_ST_SLV_WR_BUF_DONE_INT_ST(value uint32) {
	volatile.StoreUint32(&o.DMA_INT_ST.Reg, volatile.LoadUint32(&o.DMA_INT_ST.Reg)&^(0x800)|value<<11)
}
func (o *SPI2_Type) GetDMA_INT_ST_SLV_WR_BUF_DONE_INT_ST() uint32 {
	return (volatile.LoadUint32(&o.DMA_INT_ST.Reg) & 0x800) >> 11
}
func (o *SPI2_Type) SetDMA_INT_ST_TRANS_DONE_INT_ST(value uint32) {
	volatile.StoreUint32(&o.DMA_INT_ST.Reg, volatile.LoadUint32(&o.DMA_INT_ST.Reg)&^(0x1000)|value<<12)
}
func (o *SPI2_Type) GetDMA_INT_ST_TRANS_DONE_INT_ST() uint32 {
	return (volatile.LoadUint32(&o.DMA_INT_ST.Reg) & 0x1000) >> 12
}
func (o *SPI2_Type) SetDMA_INT_ST_DMA_SEG_TRANS_DONE_INT_ST(value uint32) {
	volatile.StoreUint32(&o.DMA_INT_ST.Reg, volatile.LoadUint32(&o.DMA_INT_ST.Reg)&^(0x2000)|value<<13)
}
func (o *SPI2_Type) GetDMA_INT_ST_DMA_SEG_TRANS_DONE_INT_ST() uint32 {
	return (volatile.LoadUint32(&o.DMA_INT_ST.Reg) & 0x2000) >> 13
}
func (o *SPI2_Type) SetDMA_INT_ST_SEG_MAGIC_ERR_INT_ST(value uint32) {
	volatile.StoreUint32(&o.DMA_INT_ST.Reg, volatile.LoadUint32(&o.DMA_INT_ST.Reg)&^(0x4000)|value<<14)
}
func (o *SPI2_Type) GetDMA_INT_ST_SEG_MAGIC_ERR_INT_ST() uint32 {
	return (volatile.LoadUint32(&o.DMA_INT_ST.Reg) & 0x4000) >> 14
}
func (o *SPI2_Type) SetDMA_INT_ST_SLV_BUF_ADDR_ERR_INT_ST(value uint32) {
	volatile.StoreUint32(&o.DMA_INT_ST.Reg, volatile.LoadUint32(&o.DMA_INT_ST.Reg)&^(0x8000)|value<<15)
}
func (o *SPI2_Type) GetDMA_INT_ST_SLV_BUF_ADDR_ERR_INT_ST() uint32 {
	return (volatile.LoadUint32(&o.DMA_INT_ST.Reg) & 0x8000) >> 15
}
func (o *SPI2_Type) SetDMA_INT_ST_SLV_CMD_ERR_INT_ST(value uint32) {
	volatile.StoreUint32(&o.DMA_INT_ST.Reg, volatile.LoadUint32(&o.DMA_INT_ST.Reg)&^(0x10000)|value<<16)
}
func (o *SPI2_Type) GetDMA_INT_ST_SLV_CMD_ERR_INT_ST() uint32 {
	return (volatile.LoadUint32(&o.DMA_INT_ST.Reg) & 0x10000) >> 16
}
func (o *SPI2_Type) SetDMA_INT_ST_MST_RX_AFIFO_WFULL_ERR_INT_ST(value uint32) {
	volatile.StoreUint32(&o.DMA_INT_ST.Reg, volatile.LoadUint32(&o.DMA_INT_ST.Reg)&^(0x20000)|value<<17)
}
func (o *SPI2_Type) GetDMA_INT_ST_MST_RX_AFIFO_WFULL_ERR_INT_ST() uint32 {
	return (volatile.LoadUint32(&o.DMA_INT_ST.Reg) & 0x20000) >> 17
}
func (o *SPI2_Type) SetDMA_INT_ST_MST_TX_AFIFO_REMPTY_ERR_INT_ST(value uint32) {
	volatile.StoreUint32(&o.DMA_INT_ST.Reg, volatile.LoadUint32(&o.DMA_INT_ST.Reg)&^(0x40000)|value<<18)
}
func (o *SPI2_Type) GetDMA_INT_ST_MST_TX_AFIFO_REMPTY_ERR_INT_ST() uint32 {
	return (volatile.LoadUint32(&o.DMA_INT_ST.Reg) & 0x40000) >> 18
}
func (o *SPI2_Type) SetDMA_INT_ST_APP2_INT_ST(value uint32) {
	volatile.StoreUint32(&o.DMA_INT_ST.Reg, volatile.LoadUint32(&o.DMA_INT_ST.Reg)&^(0x80000)|value<<19)
}
func (o *SPI2_Type) GetDMA_INT_ST_APP2_INT_ST() uint32 {
	return (volatile.LoadUint32(&o.DMA_INT_ST.Reg) & 0x80000) >> 19
}
func (o *SPI2_Type) SetDMA_INT_ST_APP1_INT_ST(value uint32) {
	volatile.StoreUint32(&o.DMA_INT_ST.Reg, volatile.LoadUint32(&o.DMA_INT_ST.Reg)&^(0x100000)|value<<20)
}
func (o *SPI2_Type) GetDMA_INT_ST_APP1_INT_ST() uint32 {
	return (volatile.LoadUint32(&o.DMA_INT_ST.Reg) & 0x100000) >> 20
}

// SPI2.W0: SPI CPU-controlled buffer0
func (o *SPI2_Type) SetW0(value uint32) {
	volatile.StoreUint32(&o.W0.Reg, value)
}
func (o *SPI2_Type) GetW0() uint32 {
	return volatile.LoadUint32(&o.W0.Reg)
}

// SPI2.W1: SPI CPU-controlled buffer1
func (o *SPI2_Type) SetW1(value uint32) {
	volatile.StoreUint32(&o.W1.Reg, value)
}
func (o *SPI2_Type) GetW1() uint32 {
	return volatile.LoadUint32(&o.W1.Reg)
}

// SPI2.W2: SPI CPU-controlled buffer2
func (o *SPI2_Type) SetW2(value uint32) {
	volatile.StoreUint32(&o.W2.Reg, value)
}
func (o *SPI2_Type) GetW2() uint32 {
	return volatile.LoadUint32(&o.W2.Reg)
}

// SPI2.W3: SPI CPU-controlled buffer3
func (o *SPI2_Type) SetW3(value uint32) {
	volatile.StoreUint32(&o.W3.Reg, value)
}
func (o *SPI2_Type) GetW3() uint32 {
	return volatile.LoadUint32(&o.W3.Reg)
}

// SPI2.W4: SPI CPU-controlled buffer4
func (o *SPI2_Type) SetW4(value uint32) {
	volatile.StoreUint32(&o.W4.Reg, value)
}
func (o *SPI2_Type) GetW4() uint32 {
	return volatile.LoadUint32(&o.W4.Reg)
}

// SPI2.W5: SPI CPU-controlled buffer5
func (o *SPI2_Type) SetW5(value uint32) {
	volatile.StoreUint32(&o.W5.Reg, value)
}
func (o *SPI2_Type) GetW5() uint32 {
	return volatile.LoadUint32(&o.W5.Reg)
}

// SPI2.W6: SPI CPU-controlled buffer6
func (o *SPI2_Type) SetW6(value uint32) {
	volatile.StoreUint32(&o.W6.Reg, value)
}
func (o *SPI2_Type) GetW6() uint32 {
	return volatile.LoadUint32(&o.W6.Reg)
}

// SPI2.W7: SPI CPU-controlled buffer7
func (o *SPI2_Type) SetW7(value uint32) {
	volatile.StoreUint32(&o.W7.Reg, value)
}
func (o *SPI2_Type) GetW7() uint32 {
	return volatile.LoadUint32(&o.W7.Reg)
}

// SPI2.W8: SPI CPU-controlled buffer8
func (o *SPI2_Type) SetW8(value uint32) {
	volatile.StoreUint32(&o.W8.Reg, value)
}
func (o *SPI2_Type) GetW8() uint32 {
	return volatile.LoadUint32(&o.W8.Reg)
}

// SPI2.W9: SPI CPU-controlled buffer9
func (o *SPI2_Type) SetW9(value uint32) {
	volatile.StoreUint32(&o.W9.Reg, value)
}
func (o *SPI2_Type) GetW9() uint32 {
	return volatile.LoadUint32(&o.W9.Reg)
}

// SPI2.W10: SPI CPU-controlled buffer10
func (o *SPI2_Type) SetW10(value uint32) {
	volatile.StoreUint32(&o.W10.Reg, value)
}
func (o *SPI2_Type) GetW10() uint32 {
	return volatile.LoadUint32(&o.W10.Reg)
}

// SPI2.W11: SPI CPU-controlled buffer11
func (o *SPI2_Type) SetW11(value uint32) {
	volatile.StoreUint32(&o.W11.Reg, value)
}
func (o *SPI2_Type) GetW11() uint32 {
	return volatile.LoadUint32(&o.W11.Reg)
}

// SPI2.W12: SPI CPU-controlled buffer12
func (o *SPI2_Type) SetW12(value uint32) {
	volatile.StoreUint32(&o.W12.Reg, value)
}
func (o *SPI2_Type) GetW12() uint32 {
	return volatile.LoadUint32(&o.W12.Reg)
}

// SPI2.W13: SPI CPU-controlled buffer13
func (o *SPI2_Type) SetW13(value uint32) {
	volatile.StoreUint32(&o.W13.Reg, value)
}
func (o *SPI2_Type) GetW13() uint32 {
	return volatile.LoadUint32(&o.W13.Reg)
}

// SPI2.W14: SPI CPU-controlled buffer14
func (o *SPI2_Type) SetW14(value uint32) {
	volatile.StoreUint32(&o.W14.Reg, value)
}
func (o *SPI2_Type) GetW14() uint32 {
	return volatile.LoadUint32(&o.W14.Reg)
}

// SPI2.W15: SPI CPU-controlled buffer15
func (o *SPI2_Type) SetW15(value uint32) {
	volatile.StoreUint32(&o.W15.Reg, value)
}
func (o *SPI2_Type) GetW15() uint32 {
	return volatile.LoadUint32(&o.W15.Reg)
}

// SPI2.SLAVE: SPI slave control register
func (o *SPI2_Type) SetSLAVE_CLK_MODE(value uint32) {
	volatile.StoreUint32(&o.SLAVE.Reg, volatile.LoadUint32(&o.SLAVE.Reg)&^(0x3)|value)
}
func (o *SPI2_Type) GetSLAVE_CLK_MODE() uint32 {
	return volatile.LoadUint32(&o.SLAVE.Reg) & 0x3
}
func (o *SPI2_Type) SetSLAVE_CLK_MODE_13(value uint32) {
	volatile.StoreUint32(&o.SLAVE.Reg, volatile.LoadUint32(&o.SLAVE.Reg)&^(0x4)|value<<2)
}
func (o *SPI2_Type) GetSLAVE_CLK_MODE_13() uint32 {
	return (volatile.LoadUint32(&o.SLAVE.Reg) & 0x4) >> 2
}
func (o *SPI2_Type) SetSLAVE_RSCK_DATA_OUT(value uint32) {
	volatile.StoreUint32(&o.SLAVE.Reg, volatile.LoadUint32(&o.SLAVE.Reg)&^(0x8)|value<<3)
}
func (o *SPI2_Type) GetSLAVE_RSCK_DATA_OUT() uint32 {
	return (volatile.LoadUint32(&o.SLAVE.Reg) & 0x8) >> 3
}
func (o *SPI2_Type) SetSLAVE_SLV_RDDMA_BITLEN_EN(value uint32) {
	volatile.StoreUint32(&o.SLAVE.Reg, volatile.LoadUint32(&o.SLAVE.Reg)&^(0x100)|value<<8)
}
func (o *SPI2_Type) GetSLAVE_SLV_RDDMA_BITLEN_EN() uint32 {
	return (volatile.LoadUint32(&o.SLAVE.Reg) & 0x100) >> 8
}
func (o *SPI2_Type) SetSLAVE_SLV_WRDMA_BITLEN_EN(value uint32) {
	volatile.StoreUint32(&o.SLAVE.Reg, volatile.LoadUint32(&o.SLAVE.Reg)&^(0x200)|value<<9)
}
func (o *SPI2_Type) GetSLAVE_SLV_WRDMA_BITLEN_EN() uint32 {
	return (volatile.LoadUint32(&o.SLAVE.Reg) & 0x200) >> 9
}
func (o *SPI2_Type) SetSLAVE_SLV_RDBUF_BITLEN_EN(value uint32) {
	volatile.StoreUint32(&o.SLAVE.Reg, volatile.LoadUint32(&o.SLAVE.Reg)&^(0x400)|value<<10)
}
func (o *SPI2_Type) GetSLAVE_SLV_RDBUF_BITLEN_EN() uint32 {
	return (volatile.LoadUint32(&o.SLAVE.Reg) & 0x400) >> 10
}
func (o *SPI2_Type) SetSLAVE_SLV_WRBUF_BITLEN_EN(value uint32) {
	volatile.StoreUint32(&o.SLAVE.Reg, volatile.LoadUint32(&o.SLAVE.Reg)&^(0x800)|value<<11)
}
func (o *SPI2_Type) GetSLAVE_SLV_WRBUF_BITLEN_EN() uint32 {
	return (volatile.LoadUint32(&o.SLAVE.Reg) & 0x800) >> 11
}
func (o *SPI2_Type) SetSLAVE_DMA_SEG_MAGIC_VALUE(value uint32) {
	volatile.StoreUint32(&o.SLAVE.Reg, volatile.LoadUint32(&o.SLAVE.Reg)&^(0x3c00000)|value<<22)
}
func (o *SPI2_Type) GetSLAVE_DMA_SEG_MAGIC_VALUE() uint32 {
	return (volatile.LoadUint32(&o.SLAVE.Reg) & 0x3c00000) >> 22
}
func (o *SPI2_Type) SetSLAVE_MODE(value uint32) {
	volatile.StoreUint32(&o.SLAVE.Reg, volatile.LoadUint32(&o.SLAVE.Reg)&^(0x4000000)|value<<26)
}
func (o *SPI2_Type) GetSLAVE_MODE() uint32 {
	return (volatile.LoadUint32(&o.SLAVE.Reg) & 0x4000000) >> 26
}
func (o *SPI2_Type) SetSLAVE_SOFT_RESET(value uint32) {
	volatile.StoreUint32(&o.SLAVE.Reg, volatile.LoadUint32(&o.SLAVE.Reg)&^(0x8000000)|value<<27)
}
func (o *SPI2_Type) GetSLAVE_SOFT_RESET() uint32 {
	return (volatile.LoadUint32(&o.SLAVE.Reg) & 0x8000000) >> 27
}
func (o *SPI2_Type) SetSLAVE_USR_CONF(value uint32) {
	volatile.StoreUint32(&o.SLAVE.Reg, volatile.LoadUint32(&o.SLAVE.Reg)&^(0x10000000)|value<<28)
}
func (o *SPI2_Type) GetSLAVE_USR_CONF() uint32 {
	return (volatile.LoadUint32(&o.SLAVE.Reg) & 0x10000000) >> 28
}

// SPI2.SLAVE1: SPI slave control register 1
func (o *SPI2_Type) SetSLAVE1_SLV_DATA_BITLEN(value uint32) {
	volatile.StoreUint32(&o.SLAVE1.Reg, volatile.LoadUint32(&o.SLAVE1.Reg)&^(0x3ffff)|value)
}
func (o *SPI2_Type) GetSLAVE1_SLV_DATA_BITLEN() uint32 {
	return volatile.LoadUint32(&o.SLAVE1.Reg) & 0x3ffff
}
func (o *SPI2_Type) SetSLAVE1_SLV_LAST_COMMAND(value uint32) {
	volatile.StoreUint32(&o.SLAVE1.Reg, volatile.LoadUint32(&o.SLAVE1.Reg)&^(0x3fc0000)|value<<18)
}
func (o *SPI2_Type) GetSLAVE1_SLV_LAST_COMMAND() uint32 {
	return (volatile.LoadUint32(&o.SLAVE1.Reg) & 0x3fc0000) >> 18
}
func (o *SPI2_Type) SetSLAVE1_SLV_LAST_ADDR(value uint32) {
	volatile.StoreUint32(&o.SLAVE1.Reg, volatile.LoadUint32(&o.SLAVE1.Reg)&^(0xfc000000)|value<<26)
}
func (o *SPI2_Type) GetSLAVE1_SLV_LAST_ADDR() uint32 {
	return (volatile.LoadUint32(&o.SLAVE1.Reg) & 0xfc000000) >> 26
}

// SPI2.CLK_GATE: SPI module clock and register clock control
func (o *SPI2_Type) SetCLK_GATE_CLK_EN(value uint32) {
	volatile.StoreUint32(&o.CLK_GATE.Reg, volatile.LoadUint32(&o.CLK_GATE.Reg)&^(0x1)|value)
}
func (o *SPI2_Type) GetCLK_GATE_CLK_EN() uint32 {
	return volatile.LoadUint32(&o.CLK_GATE.Reg) & 0x1
}
func (o *SPI2_Type) SetCLK_GATE_MST_CLK_ACTIVE(value uint32) {
	volatile.StoreUint32(&o.CLK_GATE.Reg, volatile.LoadUint32(&o.CLK_GATE.Reg)&^(0x2)|value<<1)
}
func (o *SPI2_Type) GetCLK_GATE_MST_CLK_ACTIVE() uint32 {
	return (volatile.LoadUint32(&o.CLK_GATE.Reg) & 0x2) >> 1
}
func (o *SPI2_Type) SetCLK_GATE_MST_CLK_SEL(value uint32) {
	volatile.StoreUint32(&o.CLK_GATE.Reg, volatile.LoadUint32(&o.CLK_GATE.Reg)&^(0x4)|value<<2)
}
func (o *SPI2_Type) GetCLK_GATE_MST_CLK_SEL() uint32 {
	return (volatile.LoadUint32(&o.CLK_GATE.Reg) & 0x4) >> 2
}

// SPI2.DATE: Version control
func (o *SPI2_Type) SetDATE(value uint32) {
	volatile.StoreUint32(&o.DATE.Reg, volatile.LoadUint32(&o.DATE.Reg)&^(0xfffffff)|value)
}
func (o *SPI2_Type) GetDATE() uint32 {
	return volatile.LoadUint32(&o.DATE.Reg) & 0xfffffff
}

// Peripheral SYSTEM
type SYSTEM_Type struct {
	CPU_PERI_CLK_EN                         volatile.Register32 // 0x0
	CPU_PERI_RST_EN                         volatile.Register32 // 0x4
	CPU_PER_CONF                            volatile.Register32 // 0x8
	MEM_PD_MASK                             volatile.Register32 // 0xC
	PERIP_CLK_EN0                           volatile.Register32 // 0x10
	PERIP_CLK_EN1                           volatile.Register32 // 0x14
	PERIP_RST_EN0                           volatile.Register32 // 0x18
	PERIP_RST_EN1                           volatile.Register32 // 0x1C
	BT_LPCK_DIV_INT                         volatile.Register32 // 0x20
	BT_LPCK_DIV_FRAC                        volatile.Register32 // 0x24
	CPU_INTR_FROM_CPU_0                     volatile.Register32 // 0x28
	CPU_INTR_FROM_CPU_1                     volatile.Register32 // 0x2C
	CPU_INTR_FROM_CPU_2                     volatile.Register32 // 0x30
	CPU_INTR_FROM_CPU_3                     volatile.Register32 // 0x34
	RSA_PD_CTRL                             volatile.Register32 // 0x38
	EDMA_CTRL                               volatile.Register32 // 0x3C
	CACHE_CONTROL                           volatile.Register32 // 0x40
	EXTERNAL_DEVICE_ENCRYPT_DECRYPT_CONTROL volatile.Register32 // 0x44
	RTC_FASTMEM_CONFIG                      volatile.Register32 // 0x48
	RTC_FASTMEM_CRC                         volatile.Register32 // 0x4C
	REDUNDANT_ECO_CTRL                      volatile.Register32 // 0x50
	CLOCK_GATE                              volatile.Register32 // 0x54
	SYSCLK_CONF                             volatile.Register32 // 0x58
	MEM_PVT                                 volatile.Register32 // 0x5C
	COMB_PVT_LVT_CONF                       volatile.Register32 // 0x60
	COMB_PVT_NVT_CONF                       volatile.Register32 // 0x64
	COMB_PVT_HVT_CONF                       volatile.Register32 // 0x68
	COMB_PVT_ERR_LVT_SITE0                  volatile.Register32 // 0x6C
	COMB_PVT_ERR_NVT_SITE0                  volatile.Register32 // 0x70
	COMB_PVT_ERR_HVT_SITE0                  volatile.Register32 // 0x74
	COMB_PVT_ERR_LVT_SITE1                  volatile.Register32 // 0x78
	COMB_PVT_ERR_NVT_SITE1                  volatile.Register32 // 0x7C
	COMB_PVT_ERR_HVT_SITE1                  volatile.Register32 // 0x80
	COMB_PVT_ERR_LVT_SITE2                  volatile.Register32 // 0x84
	COMB_PVT_ERR_NVT_SITE2                  volatile.Register32 // 0x88
	COMB_PVT_ERR_HVT_SITE2                  volatile.Register32 // 0x8C
	COMB_PVT_ERR_LVT_SITE3                  volatile.Register32 // 0x90
	COMB_PVT_ERR_NVT_SITE3                  volatile.Register32 // 0x94
	COMB_PVT_ERR_HVT_SITE3                  volatile.Register32 // 0x98
	_                                       [3936]byte
	SYSTEM_REG_DATE                         volatile.Register32 // 0xFFC
}

// SYSTEM.CPU_PERI_CLK_EN: cpu_peripheral clock gating register
func (o *SYSTEM_Type) SetCPU_PERI_CLK_EN_CLK_EN_ASSIST_DEBUG(value uint32) {
	volatile.StoreUint32(&o.CPU_PERI_CLK_EN.Reg, volatile.LoadUint32(&o.CPU_PERI_CLK_EN.Reg)&^(0x40)|value<<6)
}
func (o *SYSTEM_Type) GetCPU_PERI_CLK_EN_CLK_EN_ASSIST_DEBUG() uint32 {
	return (volatile.LoadUint32(&o.CPU_PERI_CLK_EN.Reg) & 0x40) >> 6
}
func (o *SYSTEM_Type) SetCPU_PERI_CLK_EN_CLK_EN_DEDICATED_GPIO(value uint32) {
	volatile.StoreUint32(&o.CPU_PERI_CLK_EN.Reg, volatile.LoadUint32(&o.CPU_PERI_CLK_EN.Reg)&^(0x80)|value<<7)
}
func (o *SYSTEM_Type) GetCPU_PERI_CLK_EN_CLK_EN_DEDICATED_GPIO() uint32 {
	return (volatile.LoadUint32(&o.CPU_PERI_CLK_EN.Reg) & 0x80) >> 7
}

// SYSTEM.CPU_PERI_RST_EN: cpu_peripheral reset register
func (o *SYSTEM_Type) SetCPU_PERI_RST_EN_RST_EN_ASSIST_DEBUG(value uint32) {
	volatile.StoreUint32(&o.CPU_PERI_RST_EN.Reg, volatile.LoadUint32(&o.CPU_PERI_RST_EN.Reg)&^(0x40)|value<<6)
}
func (o *SYSTEM_Type) GetCPU_PERI_RST_EN_RST_EN_ASSIST_DEBUG() uint32 {
	return (volatile.LoadUint32(&o.CPU_PERI_RST_EN.Reg) & 0x40) >> 6
}
func (o *SYSTEM_Type) SetCPU_PERI_RST_EN_RST_EN_DEDICATED_GPIO(value uint32) {
	volatile.StoreUint32(&o.CPU_PERI_RST_EN.Reg, volatile.LoadUint32(&o.CPU_PERI_RST_EN.Reg)&^(0x80)|value<<7)
}
func (o *SYSTEM_Type) GetCPU_PERI_RST_EN_RST_EN_DEDICATED_GPIO() uint32 {
	return (volatile.LoadUint32(&o.CPU_PERI_RST_EN.Reg) & 0x80) >> 7
}

// SYSTEM.CPU_PER_CONF: cpu clock config register
func (o *SYSTEM_Type) SetCPU_PER_CONF_CPUPERIOD_SEL(value uint32) {
	volatile.StoreUint32(&o.CPU_PER_CONF.Reg, volatile.LoadUint32(&o.CPU_PER_CONF.Reg)&^(0x3)|value)
}
func (o *SYSTEM_Type) GetCPU_PER_CONF_CPUPERIOD_SEL() uint32 {
	return volatile.LoadUint32(&o.CPU_PER_CONF.Reg) & 0x3
}
func (o *SYSTEM_Type) SetCPU_PER_CONF_PLL_FREQ_SEL(value uint32) {
	volatile.StoreUint32(&o.CPU_PER_CONF.Reg, volatile.LoadUint32(&o.CPU_PER_CONF.Reg)&^(0x4)|value<<2)
}
func (o *SYSTEM_Type) GetCPU_PER_CONF_PLL_FREQ_SEL() uint32 {
	return (volatile.LoadUint32(&o.CPU_PER_CONF.Reg) & 0x4) >> 2
}
func (o *SYSTEM_Type) SetCPU_PER_CONF_CPU_WAIT_MODE_FORCE_ON(value uint32) {
	volatile.StoreUint32(&o.CPU_PER_CONF.Reg, volatile.LoadUint32(&o.CPU_PER_CONF.Reg)&^(0x8)|value<<3)
}
func (o *SYSTEM_Type) GetCPU_PER_CONF_CPU_WAIT_MODE_FORCE_ON() uint32 {
	return (volatile.LoadUint32(&o.CPU_PER_CONF.Reg) & 0x8) >> 3
}
func (o *SYSTEM_Type) SetCPU_PER_CONF_CPU_WAITI_DELAY_NUM(value uint32) {
	volatile.StoreUint32(&o.CPU_PER_CONF.Reg, volatile.LoadUint32(&o.CPU_PER_CONF.Reg)&^(0xf0)|value<<4)
}
func (o *SYSTEM_Type) GetCPU_PER_CONF_CPU_WAITI_DELAY_NUM() uint32 {
	return (volatile.LoadUint32(&o.CPU_PER_CONF.Reg) & 0xf0) >> 4
}

// SYSTEM.MEM_PD_MASK: memory power down mask register
func (o *SYSTEM_Type) SetMEM_PD_MASK_LSLP_MEM_PD_MASK(value uint32) {
	volatile.StoreUint32(&o.MEM_PD_MASK.Reg, volatile.LoadUint32(&o.MEM_PD_MASK.Reg)&^(0x1)|value)
}
func (o *SYSTEM_Type) GetMEM_PD_MASK_LSLP_MEM_PD_MASK() uint32 {
	return volatile.LoadUint32(&o.MEM_PD_MASK.Reg) & 0x1
}

// SYSTEM.PERIP_CLK_EN0: peripheral clock gating register
func (o *SYSTEM_Type) SetPERIP_CLK_EN0_TIMERS_CLK_EN(value uint32) {
	volatile.StoreUint32(&o.PERIP_CLK_EN0.Reg, volatile.LoadUint32(&o.PERIP_CLK_EN0.Reg)&^(0x1)|value)
}
func (o *SYSTEM_Type) GetPERIP_CLK_EN0_TIMERS_CLK_EN() uint32 {
	return volatile.LoadUint32(&o.PERIP_CLK_EN0.Reg) & 0x1
}
func (o *SYSTEM_Type) SetPERIP_CLK_EN0_SPI01_CLK_EN(value uint32) {
	volatile.StoreUint32(&o.PERIP_CLK_EN0.Reg, volatile.LoadUint32(&o.PERIP_CLK_EN0.Reg)&^(0x2)|value<<1)
}
func (o *SYSTEM_Type) GetPERIP_CLK_EN0_SPI01_CLK_EN() uint32 {
	return (volatile.LoadUint32(&o.PERIP_CLK_EN0.Reg) & 0x2) >> 1
}
func (o *SYSTEM_Type) SetPERIP_CLK_EN0_UART_CLK_EN(value uint32) {
	volatile.StoreUint32(&o.PERIP_CLK_EN0.Reg, volatile.LoadUint32(&o.PERIP_CLK_EN0.Reg)&^(0x4)|value<<2)
}
func (o *SYSTEM_Type) GetPERIP_CLK_EN0_UART_CLK_EN() uint32 {
	return (volatile.LoadUint32(&o.PERIP_CLK_EN0.Reg) & 0x4) >> 2
}
func (o *SYSTEM_Type) SetPERIP_CLK_EN0_WDG_CLK_EN(value uint32) {
	volatile.StoreUint32(&o.PERIP_CLK_EN0.Reg, volatile.LoadUint32(&o.PERIP_CLK_EN0.Reg)&^(0x8)|value<<3)
}
func (o *SYSTEM_Type) GetPERIP_CLK_EN0_WDG_CLK_EN() uint32 {
	return (volatile.LoadUint32(&o.PERIP_CLK_EN0.Reg) & 0x8) >> 3
}
func (o *SYSTEM_Type) SetPERIP_CLK_EN0_I2S0_CLK_EN(value uint32) {
	volatile.StoreUint32(&o.PERIP_CLK_EN0.Reg, volatile.LoadUint32(&o.PERIP_CLK_EN0.Reg)&^(0x10)|value<<4)
}
func (o *SYSTEM_Type) GetPERIP_CLK_EN0_I2S0_CLK_EN() uint32 {
	return (volatile.LoadUint32(&o.PERIP_CLK_EN0.Reg) & 0x10) >> 4
}
func (o *SYSTEM_Type) SetPERIP_CLK_EN0_UART1_CLK_EN(value uint32) {
	volatile.StoreUint32(&o.PERIP_CLK_EN0.Reg, volatile.LoadUint32(&o.PERIP_CLK_EN0.Reg)&^(0x20)|value<<5)
}
func (o *SYSTEM_Type) GetPERIP_CLK_EN0_UART1_CLK_EN() uint32 {
	return (volatile.LoadUint32(&o.PERIP_CLK_EN0.Reg) & 0x20) >> 5
}
func (o *SYSTEM_Type) SetPERIP_CLK_EN0_SPI2_CLK_EN(value uint32) {
	volatile.StoreUint32(&o.PERIP_CLK_EN0.Reg, volatile.LoadUint32(&o.PERIP_CLK_EN0.Reg)&^(0x40)|value<<6)
}
func (o *SYSTEM_Type) GetPERIP_CLK_EN0_SPI2_CLK_EN() uint32 {
	return (volatile.LoadUint32(&o.PERIP_CLK_EN0.Reg) & 0x40) >> 6
}
func (o *SYSTEM_Type) SetPERIP_CLK_EN0_EXT0_CLK_EN(value uint32) {
	volatile.StoreUint32(&o.PERIP_CLK_EN0.Reg, volatile.LoadUint32(&o.PERIP_CLK_EN0.Reg)&^(0x80)|value<<7)
}
func (o *SYSTEM_Type) GetPERIP_CLK_EN0_EXT0_CLK_EN() uint32 {
	return (volatile.LoadUint32(&o.PERIP_CLK_EN0.Reg) & 0x80) >> 7
}
func (o *SYSTEM_Type) SetPERIP_CLK_EN0_UHCI0_CLK_EN(value uint32) {
	volatile.StoreUint32(&o.PERIP_CLK_EN0.Reg, volatile.LoadUint32(&o.PERIP_CLK_EN0.Reg)&^(0x100)|value<<8)
}
func (o *SYSTEM_Type) GetPERIP_CLK_EN0_UHCI0_CLK_EN() uint32 {
	return (volatile.LoadUint32(&o.PERIP_CLK_EN0.Reg) & 0x100) >> 8
}
func (o *SYSTEM_Type) SetPERIP_CLK_EN0_RMT_CLK_EN(value uint32) {
	volatile.StoreUint32(&o.PERIP_CLK_EN0.Reg, volatile.LoadUint32(&o.PERIP_CLK_EN0.Reg)&^(0x200)|value<<9)
}
func (o *SYSTEM_Type) GetPERIP_CLK_EN0_RMT_CLK_EN() uint32 {
	return (volatile.LoadUint32(&o.PERIP_CLK_EN0.Reg) & 0x200) >> 9
}
func (o *SYSTEM_Type) SetPERIP_CLK_EN0_PCNT_CLK_EN(value uint32) {
	volatile.StoreUint32(&o.PERIP_CLK_EN0.Reg, volatile.LoadUint32(&o.PERIP_CLK_EN0.Reg)&^(0x400)|value<<10)
}
func (o *SYSTEM_Type) GetPERIP_CLK_EN0_PCNT_CLK_EN() uint32 {
	return (volatile.LoadUint32(&o.PERIP_CLK_EN0.Reg) & 0x400) >> 10
}
func (o *SYSTEM_Type) SetPERIP_CLK_EN0_LEDC_CLK_EN(value uint32) {
	volatile.StoreUint32(&o.PERIP_CLK_EN0.Reg, volatile.LoadUint32(&o.PERIP_CLK_EN0.Reg)&^(0x800)|value<<11)
}
func (o *SYSTEM_Type) GetPERIP_CLK_EN0_LEDC_CLK_EN() uint32 {
	return (volatile.LoadUint32(&o.PERIP_CLK_EN0.Reg) & 0x800) >> 11
}
func (o *SYSTEM_Type) SetPERIP_CLK_EN0_UHCI1_CLK_EN(value uint32) {
	volatile.StoreUint32(&o.PERIP_CLK_EN0.Reg, volatile.LoadUint32(&o.PERIP_CLK_EN0.Reg)&^(0x1000)|value<<12)
}
func (o *SYSTEM_Type) GetPERIP_CLK_EN0_UHCI1_CLK_EN() uint32 {
	return (volatile.LoadUint32(&o.PERIP_CLK_EN0.Reg) & 0x1000) >> 12
}
func (o *SYSTEM_Type) SetPERIP_CLK_EN0_TIMERGROUP_CLK_EN(value uint32) {
	volatile.StoreUint32(&o.PERIP_CLK_EN0.Reg, volatile.LoadUint32(&o.PERIP_CLK_EN0.Reg)&^(0x2000)|value<<13)
}
func (o *SYSTEM_Type) GetPERIP_CLK_EN0_TIMERGROUP_CLK_EN() uint32 {
	return (volatile.LoadUint32(&o.PERIP_CLK_EN0.Reg) & 0x2000) >> 13
}
func (o *SYSTEM_Type) SetPERIP_CLK_EN0_EFUSE_CLK_EN(value uint32) {
	volatile.StoreUint32(&o.PERIP_CLK_EN0.Reg, volatile.LoadUint32(&o.PERIP_CLK_EN0.Reg)&^(0x4000)|value<<14)
}
func (o *SYSTEM_Type) GetPERIP_CLK_EN0_EFUSE_CLK_EN() uint32 {
	return (volatile.LoadUint32(&o.PERIP_CLK_EN0.Reg) & 0x4000) >> 14
}
func (o *SYSTEM_Type) SetPERIP_CLK_EN0_TIMERGROUP1_CLK_EN(value uint32) {
	volatile.StoreUint32(&o.PERIP_CLK_EN0.Reg, volatile.LoadUint32(&o.PERIP_CLK_EN0.Reg)&^(0x8000)|value<<15)
}
func (o *SYSTEM_Type) GetPERIP_CLK_EN0_TIMERGROUP1_CLK_EN() uint32 {
	return (volatile.LoadUint32(&o.PERIP_CLK_EN0.Reg) & 0x8000) >> 15
}
func (o *SYSTEM_Type) SetPERIP_CLK_EN0_SPI3_CLK_EN(value uint32) {
	volatile.StoreUint32(&o.PERIP_CLK_EN0.Reg, volatile.LoadUint32(&o.PERIP_CLK_EN0.Reg)&^(0x10000)|value<<16)
}
func (o *SYSTEM_Type) GetPERIP_CLK_EN0_SPI3_CLK_EN() uint32 {
	return (volatile.LoadUint32(&o.PERIP_CLK_EN0.Reg) & 0x10000) >> 16
}
func (o *SYSTEM_Type) SetPERIP_CLK_EN0_PWM0_CLK_EN(value uint32) {
	volatile.StoreUint32(&o.PERIP_CLK_EN0.Reg, volatile.LoadUint32(&o.PERIP_CLK_EN0.Reg)&^(0x20000)|value<<17)
}
func (o *SYSTEM_Type) GetPERIP_CLK_EN0_PWM0_CLK_EN() uint32 {
	return (volatile.LoadUint32(&o.PERIP_CLK_EN0.Reg) & 0x20000) >> 17
}
func (o *SYSTEM_Type) SetPERIP_CLK_EN0_EXT1_CLK_EN(value uint32) {
	volatile.StoreUint32(&o.PERIP_CLK_EN0.Reg, volatile.LoadUint32(&o.PERIP_CLK_EN0.Reg)&^(0x40000)|value<<18)
}
func (o *SYSTEM_Type) GetPERIP_CLK_EN0_EXT1_CLK_EN() uint32 {
	return (volatile.LoadUint32(&o.PERIP_CLK_EN0.Reg) & 0x40000) >> 18
}
func (o *SYSTEM_Type) SetPERIP_CLK_EN0_CAN_CLK_EN(value uint32) {
	volatile.StoreUint32(&o.PERIP_CLK_EN0.Reg, volatile.LoadUint32(&o.PERIP_CLK_EN0.Reg)&^(0x80000)|value<<19)
}
func (o *SYSTEM_Type) GetPERIP_CLK_EN0_CAN_CLK_EN() uint32 {
	return (volatile.LoadUint32(&o.PERIP_CLK_EN0.Reg) & 0x80000) >> 19
}
func (o *SYSTEM_Type) SetPERIP_CLK_EN0_PWM1_CLK_EN(value uint32) {
	volatile.StoreUint32(&o.PERIP_CLK_EN0.Reg, volatile.LoadUint32(&o.PERIP_CLK_EN0.Reg)&^(0x100000)|value<<20)
}
func (o *SYSTEM_Type) GetPERIP_CLK_EN0_PWM1_CLK_EN() uint32 {
	return (volatile.LoadUint32(&o.PERIP_CLK_EN0.Reg) & 0x100000) >> 20
}
func (o *SYSTEM_Type) SetPERIP_CLK_EN0_I2S1_CLK_EN(value uint32) {
	volatile.StoreUint32(&o.PERIP_CLK_EN0.Reg, volatile.LoadUint32(&o.PERIP_CLK_EN0.Reg)&^(0x200000)|value<<21)
}
func (o *SYSTEM_Type) GetPERIP_CLK_EN0_I2S1_CLK_EN() uint32 {
	return (volatile.LoadUint32(&o.PERIP_CLK_EN0.Reg) & 0x200000) >> 21
}
func (o *SYSTEM_Type) SetPERIP_CLK_EN0_SPI2_DMA_CLK_EN(value uint32) {
	volatile.StoreUint32(&o.PERIP_CLK_EN0.Reg, volatile.LoadUint32(&o.PERIP_CLK_EN0.Reg)&^(0x400000)|value<<22)
}
func (o *SYSTEM_Type) GetPERIP_CLK_EN0_SPI2_DMA_CLK_EN() uint32 {
	return (volatile.LoadUint32(&o.PERIP_CLK_EN0.Reg) & 0x400000) >> 22
}
func (o *SYSTEM_Type) SetPERIP_CLK_EN0_USB_DEVICE_CLK_EN(value uint32) {
	volatile.StoreUint32(&o.PERIP_CLK_EN0.Reg, volatile.LoadUint32(&o.PERIP_CLK_EN0.Reg)&^(0x800000)|value<<23)
}
func (o *SYSTEM_Type) GetPERIP_CLK_EN0_USB_DEVICE_CLK_EN() uint32 {
	return (volatile.LoadUint32(&o.PERIP_CLK_EN0.Reg) & 0x800000) >> 23
}
func (o *SYSTEM_Type) SetPERIP_CLK_EN0_UART_MEM_CLK_EN(value uint32) {
	volatile.StoreUint32(&o.PERIP_CLK_EN0.Reg, volatile.LoadUint32(&o.PERIP_CLK_EN0.Reg)&^(0x1000000)|value<<24)
}
func (o *SYSTEM_Type) GetPERIP_CLK_EN0_UART_MEM_CLK_EN() uint32 {
	return (volatile.LoadUint32(&o.PERIP_CLK_EN0.Reg) & 0x1000000) >> 24
}
func (o *SYSTEM_Type) SetPERIP_CLK_EN0_PWM2_CLK_EN(value uint32) {
	volatile.StoreUint32(&o.PERIP_CLK_EN0.Reg, volatile.LoadUint32(&o.PERIP_CLK_EN0.Reg)&^(0x2000000)|value<<25)
}
func (o *SYSTEM_Type) GetPERIP_CLK_EN0_PWM2_CLK_EN() uint32 {
	return (volatile.LoadUint32(&o.PERIP_CLK_EN0.Reg) & 0x2000000) >> 25
}
func (o *SYSTEM_Type) SetPERIP_CLK_EN0_PWM3_CLK_EN(value uint32) {
	volatile.StoreUint32(&o.PERIP_CLK_EN0.Reg, volatile.LoadUint32(&o.PERIP_CLK_EN0.Reg)&^(0x4000000)|value<<26)
}
func (o *SYSTEM_Type) GetPERIP_CLK_EN0_PWM3_CLK_EN() uint32 {
	return (volatile.LoadUint32(&o.PERIP_CLK_EN0.Reg) & 0x4000000) >> 26
}
func (o *SYSTEM_Type) SetPERIP_CLK_EN0_SPI3_DMA_CLK_EN(value uint32) {
	volatile.StoreUint32(&o.PERIP_CLK_EN0.Reg, volatile.LoadUint32(&o.PERIP_CLK_EN0.Reg)&^(0x8000000)|value<<27)
}
func (o *SYSTEM_Type) GetPERIP_CLK_EN0_SPI3_DMA_CLK_EN() uint32 {
	return (volatile.LoadUint32(&o.PERIP_CLK_EN0.Reg) & 0x8000000) >> 27
}
func (o *SYSTEM_Type) SetPERIP_CLK_EN0_APB_SARADC_CLK_EN(value uint32) {
	volatile.StoreUint32(&o.PERIP_CLK_EN0.Reg, volatile.LoadUint32(&o.PERIP_CLK_EN0.Reg)&^(0x10000000)|value<<28)
}
func (o *SYSTEM_Type) GetPERIP_CLK_EN0_APB_SARADC_CLK_EN() uint32 {
	return (volatile.LoadUint32(&o.PERIP_CLK_EN0.Reg) & 0x10000000) >> 28
}
func (o *SYSTEM_Type) SetPERIP_CLK_EN0_SYSTIMER_CLK_EN(value uint32) {
	volatile.StoreUint32(&o.PERIP_CLK_EN0.Reg, volatile.LoadUint32(&o.PERIP_CLK_EN0.Reg)&^(0x20000000)|value<<29)
}
func (o *SYSTEM_Type) GetPERIP_CLK_EN0_SYSTIMER_CLK_EN() uint32 {
	return (volatile.LoadUint32(&o.PERIP_CLK_EN0.Reg) & 0x20000000) >> 29
}
func (o *SYSTEM_Type) SetPERIP_CLK_EN0_ADC2_ARB_CLK_EN(value uint32) {
	volatile.StoreUint32(&o.PERIP_CLK_EN0.Reg, volatile.LoadUint32(&o.PERIP_CLK_EN0.Reg)&^(0x40000000)|value<<30)
}
func (o *SYSTEM_Type) GetPERIP_CLK_EN0_ADC2_ARB_CLK_EN() uint32 {
	return (volatile.LoadUint32(&o.PERIP_CLK_EN0.Reg) & 0x40000000) >> 30
}
func (o *SYSTEM_Type) SetPERIP_CLK_EN0_SPI4_CLK_EN(value uint32) {
	volatile.StoreUint32(&o.PERIP_CLK_EN0.Reg, volatile.LoadUint32(&o.PERIP_CLK_EN0.Reg)&^(0x80000000)|value<<31)
}
func (o *SYSTEM_Type) GetPERIP_CLK_EN0_SPI4_CLK_EN() uint32 {
	return (volatile.LoadUint32(&o.PERIP_CLK_EN0.Reg) & 0x80000000) >> 31
}

// SYSTEM.PERIP_CLK_EN1: peripheral clock gating register
func (o *SYSTEM_Type) SetPERIP_CLK_EN1_CRYPTO_AES_CLK_EN(value uint32) {
	volatile.StoreUint32(&o.PERIP_CLK_EN1.Reg, volatile.LoadUint32(&o.PERIP_CLK_EN1.Reg)&^(0x2)|value<<1)
}
func (o *SYSTEM_Type) GetPERIP_CLK_EN1_CRYPTO_AES_CLK_EN() uint32 {
	return (volatile.LoadUint32(&o.PERIP_CLK_EN1.Reg) & 0x2) >> 1
}
func (o *SYSTEM_Type) SetPERIP_CLK_EN1_CRYPTO_SHA_CLK_EN(value uint32) {
	volatile.StoreUint32(&o.PERIP_CLK_EN1.Reg, volatile.LoadUint32(&o.PERIP_CLK_EN1.Reg)&^(0x4)|value<<2)
}
func (o *SYSTEM_Type) GetPERIP_CLK_EN1_CRYPTO_SHA_CLK_EN() uint32 {
	return (volatile.LoadUint32(&o.PERIP_CLK_EN1.Reg) & 0x4) >> 2
}
func (o *SYSTEM_Type) SetPERIP_CLK_EN1_CRYPTO_RSA_CLK_EN(value uint32) {
	volatile.StoreUint32(&o.PERIP_CLK_EN1.Reg, volatile.LoadUint32(&o.PERIP_CLK_EN1.Reg)&^(0x8)|value<<3)
}
func (o *SYSTEM_Type) GetPERIP_CLK_EN1_CRYPTO_RSA_CLK_EN() uint32 {
	return (volatile.LoadUint32(&o.PERIP_CLK_EN1.Reg) & 0x8) >> 3
}
func (o *SYSTEM_Type) SetPERIP_CLK_EN1_CRYPTO_DS_CLK_EN(value uint32) {
	volatile.StoreUint32(&o.PERIP_CLK_EN1.Reg, volatile.LoadUint32(&o.PERIP_CLK_EN1.Reg)&^(0x10)|value<<4)
}
func (o *SYSTEM_Type) GetPERIP_CLK_EN1_CRYPTO_DS_CLK_EN() uint32 {
	return (volatile.LoadUint32(&o.PERIP_CLK_EN1.Reg) & 0x10) >> 4
}
func (o *SYSTEM_Type) SetPERIP_CLK_EN1_CRYPTO_HMAC_CLK_EN(value uint32) {
	volatile.StoreUint32(&o.PERIP_CLK_EN1.Reg, volatile.LoadUint32(&o.PERIP_CLK_EN1.Reg)&^(0x20)|value<<5)
}
func (o *SYSTEM_Type) GetPERIP_CLK_EN1_CRYPTO_HMAC_CLK_EN() uint32 {
	return (volatile.LoadUint32(&o.PERIP_CLK_EN1.Reg) & 0x20) >> 5
}
func (o *SYSTEM_Type) SetPERIP_CLK_EN1_DMA_CLK_EN(value uint32) {
	volatile.StoreUint32(&o.PERIP_CLK_EN1.Reg, volatile.LoadUint32(&o.PERIP_CLK_EN1.Reg)&^(0x40)|value<<6)
}
func (o *SYSTEM_Type) GetPERIP_CLK_EN1_DMA_CLK_EN() uint32 {
	return (volatile.LoadUint32(&o.PERIP_CLK_EN1.Reg) & 0x40) >> 6
}
func (o *SYSTEM_Type) SetPERIP_CLK_EN1_SDIO_HOST_CLK_EN(value uint32) {
	volatile.StoreUint32(&o.PERIP_CLK_EN1.Reg, volatile.LoadUint32(&o.PERIP_CLK_EN1.Reg)&^(0x80)|value<<7)
}
func (o *SYSTEM_Type) GetPERIP_CLK_EN1_SDIO_HOST_CLK_EN() uint32 {
	return (volatile.LoadUint32(&o.PERIP_CLK_EN1.Reg) & 0x80) >> 7
}
func (o *SYSTEM_Type) SetPERIP_CLK_EN1_LCD_CAM_CLK_EN(value uint32) {
	volatile.StoreUint32(&o.PERIP_CLK_EN1.Reg, volatile.LoadUint32(&o.PERIP_CLK_EN1.Reg)&^(0x100)|value<<8)
}
func (o *SYSTEM_Type) GetPERIP_CLK_EN1_LCD_CAM_CLK_EN() uint32 {
	return (volatile.LoadUint32(&o.PERIP_CLK_EN1.Reg) & 0x100) >> 8
}
func (o *SYSTEM_Type) SetPERIP_CLK_EN1_UART2_CLK_EN(value uint32) {
	volatile.StoreUint32(&o.PERIP_CLK_EN1.Reg, volatile.LoadUint32(&o.PERIP_CLK_EN1.Reg)&^(0x200)|value<<9)
}
func (o *SYSTEM_Type) GetPERIP_CLK_EN1_UART2_CLK_EN() uint32 {
	return (volatile.LoadUint32(&o.PERIP_CLK_EN1.Reg) & 0x200) >> 9
}
func (o *SYSTEM_Type) SetPERIP_CLK_EN1_TSENS_CLK_EN(value uint32) {
	volatile.StoreUint32(&o.PERIP_CLK_EN1.Reg, volatile.LoadUint32(&o.PERIP_CLK_EN1.Reg)&^(0x400)|value<<10)
}
func (o *SYSTEM_Type) GetPERIP_CLK_EN1_TSENS_CLK_EN() uint32 {
	return (volatile.LoadUint32(&o.PERIP_CLK_EN1.Reg) & 0x400) >> 10
}

// SYSTEM.PERIP_RST_EN0: reserved
func (o *SYSTEM_Type) SetPERIP_RST_EN0_TIMERS_RST(value uint32) {
	volatile.StoreUint32(&o.PERIP_RST_EN0.Reg, volatile.LoadUint32(&o.PERIP_RST_EN0.Reg)&^(0x1)|value)
}
func (o *SYSTEM_Type) GetPERIP_RST_EN0_TIMERS_RST() uint32 {
	return volatile.LoadUint32(&o.PERIP_RST_EN0.Reg) & 0x1
}
func (o *SYSTEM_Type) SetPERIP_RST_EN0_SPI01_RST(value uint32) {
	volatile.StoreUint32(&o.PERIP_RST_EN0.Reg, volatile.LoadUint32(&o.PERIP_RST_EN0.Reg)&^(0x2)|value<<1)
}
func (o *SYSTEM_Type) GetPERIP_RST_EN0_SPI01_RST() uint32 {
	return (volatile.LoadUint32(&o.PERIP_RST_EN0.Reg) & 0x2) >> 1
}
func (o *SYSTEM_Type) SetPERIP_RST_EN0_UART_RST(value uint32) {
	volatile.StoreUint32(&o.PERIP_RST_EN0.Reg, volatile.LoadUint32(&o.PERIP_RST_EN0.Reg)&^(0x4)|value<<2)
}
func (o *SYSTEM_Type) GetPERIP_RST_EN0_UART_RST() uint32 {
	return (volatile.LoadUint32(&o.PERIP_RST_EN0.Reg) & 0x4) >> 2
}
func (o *SYSTEM_Type) SetPERIP_RST_EN0_WDG_RST(value uint32) {
	volatile.StoreUint32(&o.PERIP_RST_EN0.Reg, volatile.LoadUint32(&o.PERIP_RST_EN0.Reg)&^(0x8)|value<<3)
}
func (o *SYSTEM_Type) GetPERIP_RST_EN0_WDG_RST() uint32 {
	return (volatile.LoadUint32(&o.PERIP_RST_EN0.Reg) & 0x8) >> 3
}
func (o *SYSTEM_Type) SetPERIP_RST_EN0_I2S0_RST(value uint32) {
	volatile.StoreUint32(&o.PERIP_RST_EN0.Reg, volatile.LoadUint32(&o.PERIP_RST_EN0.Reg)&^(0x10)|value<<4)
}
func (o *SYSTEM_Type) GetPERIP_RST_EN0_I2S0_RST() uint32 {
	return (volatile.LoadUint32(&o.PERIP_RST_EN0.Reg) & 0x10) >> 4
}
func (o *SYSTEM_Type) SetPERIP_RST_EN0_UART1_RST(value uint32) {
	volatile.StoreUint32(&o.PERIP_RST_EN0.Reg, volatile.LoadUint32(&o.PERIP_RST_EN0.Reg)&^(0x20)|value<<5)
}
func (o *SYSTEM_Type) GetPERIP_RST_EN0_UART1_RST() uint32 {
	return (volatile.LoadUint32(&o.PERIP_RST_EN0.Reg) & 0x20) >> 5
}
func (o *SYSTEM_Type) SetPERIP_RST_EN0_SPI2_RST(value uint32) {
	volatile.StoreUint32(&o.PERIP_RST_EN0.Reg, volatile.LoadUint32(&o.PERIP_RST_EN0.Reg)&^(0x40)|value<<6)
}
func (o *SYSTEM_Type) GetPERIP_RST_EN0_SPI2_RST() uint32 {
	return (volatile.LoadUint32(&o.PERIP_RST_EN0.Reg) & 0x40) >> 6
}
func (o *SYSTEM_Type) SetPERIP_RST_EN0_EXT0_RST(value uint32) {
	volatile.StoreUint32(&o.PERIP_RST_EN0.Reg, volatile.LoadUint32(&o.PERIP_RST_EN0.Reg)&^(0x80)|value<<7)
}
func (o *SYSTEM_Type) GetPERIP_RST_EN0_EXT0_RST() uint32 {
	return (volatile.LoadUint32(&o.PERIP_RST_EN0.Reg) & 0x80) >> 7
}
func (o *SYSTEM_Type) SetPERIP_RST_EN0_UHCI0_RST(value uint32) {
	volatile.StoreUint32(&o.PERIP_RST_EN0.Reg, volatile.LoadUint32(&o.PERIP_RST_EN0.Reg)&^(0x100)|value<<8)
}
func (o *SYSTEM_Type) GetPERIP_RST_EN0_UHCI0_RST() uint32 {
	return (volatile.LoadUint32(&o.PERIP_RST_EN0.Reg) & 0x100) >> 8
}
func (o *SYSTEM_Type) SetPERIP_RST_EN0_RMT_RST(value uint32) {
	volatile.StoreUint32(&o.PERIP_RST_EN0.Reg, volatile.LoadUint32(&o.PERIP_RST_EN0.Reg)&^(0x200)|value<<9)
}
func (o *SYSTEM_Type) GetPERIP_RST_EN0_RMT_RST() uint32 {
	return (volatile.LoadUint32(&o.PERIP_RST_EN0.Reg) & 0x200) >> 9
}
func (o *SYSTEM_Type) SetPERIP_RST_EN0_PCNT_RST(value uint32) {
	volatile.StoreUint32(&o.PERIP_RST_EN0.Reg, volatile.LoadUint32(&o.PERIP_RST_EN0.Reg)&^(0x400)|value<<10)
}
func (o *SYSTEM_Type) GetPERIP_RST_EN0_PCNT_RST() uint32 {
	return (volatile.LoadUint32(&o.PERIP_RST_EN0.Reg) & 0x400) >> 10
}
func (o *SYSTEM_Type) SetPERIP_RST_EN0_LEDC_RST(value uint32) {
	volatile.StoreUint32(&o.PERIP_RST_EN0.Reg, volatile.LoadUint32(&o.PERIP_RST_EN0.Reg)&^(0x800)|value<<11)
}
func (o *SYSTEM_Type) GetPERIP_RST_EN0_LEDC_RST() uint32 {
	return (volatile.LoadUint32(&o.PERIP_RST_EN0.Reg) & 0x800) >> 11
}
func (o *SYSTEM_Type) SetPERIP_RST_EN0_UHCI1_RST(value uint32) {
	volatile.StoreUint32(&o.PERIP_RST_EN0.Reg, volatile.LoadUint32(&o.PERIP_RST_EN0.Reg)&^(0x1000)|value<<12)
}
func (o *SYSTEM_Type) GetPERIP_RST_EN0_UHCI1_RST() uint32 {
	return (volatile.LoadUint32(&o.PERIP_RST_EN0.Reg) & 0x1000) >> 12
}
func (o *SYSTEM_Type) SetPERIP_RST_EN0_TIMERGROUP_RST(value uint32) {
	volatile.StoreUint32(&o.PERIP_RST_EN0.Reg, volatile.LoadUint32(&o.PERIP_RST_EN0.Reg)&^(0x2000)|value<<13)
}
func (o *SYSTEM_Type) GetPERIP_RST_EN0_TIMERGROUP_RST() uint32 {
	return (volatile.LoadUint32(&o.PERIP_RST_EN0.Reg) & 0x2000) >> 13
}
func (o *SYSTEM_Type) SetPERIP_RST_EN0_EFUSE_RST(value uint32) {
	volatile.StoreUint32(&o.PERIP_RST_EN0.Reg, volatile.LoadUint32(&o.PERIP_RST_EN0.Reg)&^(0x4000)|value<<14)
}
func (o *SYSTEM_Type) GetPERIP_RST_EN0_EFUSE_RST() uint32 {
	return (volatile.LoadUint32(&o.PERIP_RST_EN0.Reg) & 0x4000) >> 14
}
func (o *SYSTEM_Type) SetPERIP_RST_EN0_TIMERGROUP1_RST(value uint32) {
	volatile.StoreUint32(&o.PERIP_RST_EN0.Reg, volatile.LoadUint32(&o.PERIP_RST_EN0.Reg)&^(0x8000)|value<<15)
}
func (o *SYSTEM_Type) GetPERIP_RST_EN0_TIMERGROUP1_RST() uint32 {
	return (volatile.LoadUint32(&o.PERIP_RST_EN0.Reg) & 0x8000) >> 15
}
func (o *SYSTEM_Type) SetPERIP_RST_EN0_SPI3_RST(value uint32) {
	volatile.StoreUint32(&o.PERIP_RST_EN0.Reg, volatile.LoadUint32(&o.PERIP_RST_EN0.Reg)&^(0x10000)|value<<16)
}
func (o *SYSTEM_Type) GetPERIP_RST_EN0_SPI3_RST() uint32 {
	return (volatile.LoadUint32(&o.PERIP_RST_EN0.Reg) & 0x10000) >> 16
}
func (o *SYSTEM_Type) SetPERIP_RST_EN0_PWM0_RST(value uint32) {
	volatile.StoreUint32(&o.PERIP_RST_EN0.Reg, volatile.LoadUint32(&o.PERIP_RST_EN0.Reg)&^(0x20000)|value<<17)
}
func (o *SYSTEM_Type) GetPERIP_RST_EN0_PWM0_RST() uint32 {
	return (volatile.LoadUint32(&o.PERIP_RST_EN0.Reg) & 0x20000) >> 17
}
func (o *SYSTEM_Type) SetPERIP_RST_EN0_EXT1_RST(value uint32) {
	volatile.StoreUint32(&o.PERIP_RST_EN0.Reg, volatile.LoadUint32(&o.PERIP_RST_EN0.Reg)&^(0x40000)|value<<18)
}
func (o *SYSTEM_Type) GetPERIP_RST_EN0_EXT1_RST() uint32 {
	return (volatile.LoadUint32(&o.PERIP_RST_EN0.Reg) & 0x40000) >> 18
}
func (o *SYSTEM_Type) SetPERIP_RST_EN0_CAN_RST(value uint32) {
	volatile.StoreUint32(&o.PERIP_RST_EN0.Reg, volatile.LoadUint32(&o.PERIP_RST_EN0.Reg)&^(0x80000)|value<<19)
}
func (o *SYSTEM_Type) GetPERIP_RST_EN0_CAN_RST() uint32 {
	return (volatile.LoadUint32(&o.PERIP_RST_EN0.Reg) & 0x80000) >> 19
}
func (o *SYSTEM_Type) SetPERIP_RST_EN0_PWM1_RST(value uint32) {
	volatile.StoreUint32(&o.PERIP_RST_EN0.Reg, volatile.LoadUint32(&o.PERIP_RST_EN0.Reg)&^(0x100000)|value<<20)
}
func (o *SYSTEM_Type) GetPERIP_RST_EN0_PWM1_RST() uint32 {
	return (volatile.LoadUint32(&o.PERIP_RST_EN0.Reg) & 0x100000) >> 20
}
func (o *SYSTEM_Type) SetPERIP_RST_EN0_I2S1_RST(value uint32) {
	volatile.StoreUint32(&o.PERIP_RST_EN0.Reg, volatile.LoadUint32(&o.PERIP_RST_EN0.Reg)&^(0x200000)|value<<21)
}
func (o *SYSTEM_Type) GetPERIP_RST_EN0_I2S1_RST() uint32 {
	return (volatile.LoadUint32(&o.PERIP_RST_EN0.Reg) & 0x200000) >> 21
}
func (o *SYSTEM_Type) SetPERIP_RST_EN0_SPI2_DMA_RST(value uint32) {
	volatile.StoreUint32(&o.PERIP_RST_EN0.Reg, volatile.LoadUint32(&o.PERIP_RST_EN0.Reg)&^(0x400000)|value<<22)
}
func (o *SYSTEM_Type) GetPERIP_RST_EN0_SPI2_DMA_RST() uint32 {
	return (volatile.LoadUint32(&o.PERIP_RST_EN0.Reg) & 0x400000) >> 22
}
func (o *SYSTEM_Type) SetPERIP_RST_EN0_USB_DEVICE_RST(value uint32) {
	volatile.StoreUint32(&o.PERIP_RST_EN0.Reg, volatile.LoadUint32(&o.PERIP_RST_EN0.Reg)&^(0x800000)|value<<23)
}
func (o *SYSTEM_Type) GetPERIP_RST_EN0_USB_DEVICE_RST() uint32 {
	return (volatile.LoadUint32(&o.PERIP_RST_EN0.Reg) & 0x800000) >> 23
}
func (o *SYSTEM_Type) SetPERIP_RST_EN0_UART_MEM_RST(value uint32) {
	volatile.StoreUint32(&o.PERIP_RST_EN0.Reg, volatile.LoadUint32(&o.PERIP_RST_EN0.Reg)&^(0x1000000)|value<<24)
}
func (o *SYSTEM_Type) GetPERIP_RST_EN0_UART_MEM_RST() uint32 {
	return (volatile.LoadUint32(&o.PERIP_RST_EN0.Reg) & 0x1000000) >> 24
}
func (o *SYSTEM_Type) SetPERIP_RST_EN0_PWM2_RST(value uint32) {
	volatile.StoreUint32(&o.PERIP_RST_EN0.Reg, volatile.LoadUint32(&o.PERIP_RST_EN0.Reg)&^(0x2000000)|value<<25)
}
func (o *SYSTEM_Type) GetPERIP_RST_EN0_PWM2_RST() uint32 {
	return (volatile.LoadUint32(&o.PERIP_RST_EN0.Reg) & 0x2000000) >> 25
}
func (o *SYSTEM_Type) SetPERIP_RST_EN0_PWM3_RST(value uint32) {
	volatile.StoreUint32(&o.PERIP_RST_EN0.Reg, volatile.LoadUint32(&o.PERIP_RST_EN0.Reg)&^(0x4000000)|value<<26)
}
func (o *SYSTEM_Type) GetPERIP_RST_EN0_PWM3_RST() uint32 {
	return (volatile.LoadUint32(&o.PERIP_RST_EN0.Reg) & 0x4000000) >> 26
}
func (o *SYSTEM_Type) SetPERIP_RST_EN0_SPI3_DMA_RST(value uint32) {
	volatile.StoreUint32(&o.PERIP_RST_EN0.Reg, volatile.LoadUint32(&o.PERIP_RST_EN0.Reg)&^(0x8000000)|value<<27)
}
func (o *SYSTEM_Type) GetPERIP_RST_EN0_SPI3_DMA_RST() uint32 {
	return (volatile.LoadUint32(&o.PERIP_RST_EN0.Reg) & 0x8000000) >> 27
}
func (o *SYSTEM_Type) SetPERIP_RST_EN0_APB_SARADC_RST(value uint32) {
	volatile.StoreUint32(&o.PERIP_RST_EN0.Reg, volatile.LoadUint32(&o.PERIP_RST_EN0.Reg)&^(0x10000000)|value<<28)
}
func (o *SYSTEM_Type) GetPERIP_RST_EN0_APB_SARADC_RST() uint32 {
	return (volatile.LoadUint32(&o.PERIP_RST_EN0.Reg) & 0x10000000) >> 28
}
func (o *SYSTEM_Type) SetPERIP_RST_EN0_SYSTIMER_RST(value uint32) {
	volatile.StoreUint32(&o.PERIP_RST_EN0.Reg, volatile.LoadUint32(&o.PERIP_RST_EN0.Reg)&^(0x20000000)|value<<29)
}
func (o *SYSTEM_Type) GetPERIP_RST_EN0_SYSTIMER_RST() uint32 {
	return (volatile.LoadUint32(&o.PERIP_RST_EN0.Reg) & 0x20000000) >> 29
}
func (o *SYSTEM_Type) SetPERIP_RST_EN0_ADC2_ARB_RST(value uint32) {
	volatile.StoreUint32(&o.PERIP_RST_EN0.Reg, volatile.LoadUint32(&o.PERIP_RST_EN0.Reg)&^(0x40000000)|value<<30)
}
func (o *SYSTEM_Type) GetPERIP_RST_EN0_ADC2_ARB_RST() uint32 {
	return (volatile.LoadUint32(&o.PERIP_RST_EN0.Reg) & 0x40000000) >> 30
}
func (o *SYSTEM_Type) SetPERIP_RST_EN0_SPI4_RST(value uint32) {
	volatile.StoreUint32(&o.PERIP_RST_EN0.Reg, volatile.LoadUint32(&o.PERIP_RST_EN0.Reg)&^(0x80000000)|value<<31)
}
func (o *SYSTEM_Type) GetPERIP_RST_EN0_SPI4_RST() uint32 {
	return (volatile.LoadUint32(&o.PERIP_RST_EN0.Reg) & 0x80000000) >> 31
}

// SYSTEM.PERIP_RST_EN1: peripheral reset register
func (o *SYSTEM_Type) SetPERIP_RST_EN1_CRYPTO_AES_RST(value uint32) {
	volatile.StoreUint32(&o.PERIP_RST_EN1.Reg, volatile.LoadUint32(&o.PERIP_RST_EN1.Reg)&^(0x2)|value<<1)
}
func (o *SYSTEM_Type) GetPERIP_RST_EN1_CRYPTO_AES_RST() uint32 {
	return (volatile.LoadUint32(&o.PERIP_RST_EN1.Reg) & 0x2) >> 1
}
func (o *SYSTEM_Type) SetPERIP_RST_EN1_CRYPTO_SHA_RST(value uint32) {
	volatile.StoreUint32(&o.PERIP_RST_EN1.Reg, volatile.LoadUint32(&o.PERIP_RST_EN1.Reg)&^(0x4)|value<<2)
}
func (o *SYSTEM_Type) GetPERIP_RST_EN1_CRYPTO_SHA_RST() uint32 {
	return (volatile.LoadUint32(&o.PERIP_RST_EN1.Reg) & 0x4) >> 2
}
func (o *SYSTEM_Type) SetPERIP_RST_EN1_CRYPTO_RSA_RST(value uint32) {
	volatile.StoreUint32(&o.PERIP_RST_EN1.Reg, volatile.LoadUint32(&o.PERIP_RST_EN1.Reg)&^(0x8)|value<<3)
}
func (o *SYSTEM_Type) GetPERIP_RST_EN1_CRYPTO_RSA_RST() uint32 {
	return (volatile.LoadUint32(&o.PERIP_RST_EN1.Reg) & 0x8) >> 3
}
func (o *SYSTEM_Type) SetPERIP_RST_EN1_CRYPTO_DS_RST(value uint32) {
	volatile.StoreUint32(&o.PERIP_RST_EN1.Reg, volatile.LoadUint32(&o.PERIP_RST_EN1.Reg)&^(0x10)|value<<4)
}
func (o *SYSTEM_Type) GetPERIP_RST_EN1_CRYPTO_DS_RST() uint32 {
	return (volatile.LoadUint32(&o.PERIP_RST_EN1.Reg) & 0x10) >> 4
}
func (o *SYSTEM_Type) SetPERIP_RST_EN1_CRYPTO_HMAC_RST(value uint32) {
	volatile.StoreUint32(&o.PERIP_RST_EN1.Reg, volatile.LoadUint32(&o.PERIP_RST_EN1.Reg)&^(0x20)|value<<5)
}
func (o *SYSTEM_Type) GetPERIP_RST_EN1_CRYPTO_HMAC_RST() uint32 {
	return (volatile.LoadUint32(&o.PERIP_RST_EN1.Reg) & 0x20) >> 5
}
func (o *SYSTEM_Type) SetPERIP_RST_EN1_DMA_RST(value uint32) {
	volatile.StoreUint32(&o.PERIP_RST_EN1.Reg, volatile.LoadUint32(&o.PERIP_RST_EN1.Reg)&^(0x40)|value<<6)
}
func (o *SYSTEM_Type) GetPERIP_RST_EN1_DMA_RST() uint32 {
	return (volatile.LoadUint32(&o.PERIP_RST_EN1.Reg) & 0x40) >> 6
}
func (o *SYSTEM_Type) SetPERIP_RST_EN1_SDIO_HOST_RST(value uint32) {
	volatile.StoreUint32(&o.PERIP_RST_EN1.Reg, volatile.LoadUint32(&o.PERIP_RST_EN1.Reg)&^(0x80)|value<<7)
}
func (o *SYSTEM_Type) GetPERIP_RST_EN1_SDIO_HOST_RST() uint32 {
	return (volatile.LoadUint32(&o.PERIP_RST_EN1.Reg) & 0x80) >> 7
}
func (o *SYSTEM_Type) SetPERIP_RST_EN1_LCD_CAM_RST(value uint32) {
	volatile.StoreUint32(&o.PERIP_RST_EN1.Reg, volatile.LoadUint32(&o.PERIP_RST_EN1.Reg)&^(0x100)|value<<8)
}
func (o *SYSTEM_Type) GetPERIP_RST_EN1_LCD_CAM_RST() uint32 {
	return (volatile.LoadUint32(&o.PERIP_RST_EN1.Reg) & 0x100) >> 8
}
func (o *SYSTEM_Type) SetPERIP_RST_EN1_UART2_RST(value uint32) {
	volatile.StoreUint32(&o.PERIP_RST_EN1.Reg, volatile.LoadUint32(&o.PERIP_RST_EN1.Reg)&^(0x200)|value<<9)
}
func (o *SYSTEM_Type) GetPERIP_RST_EN1_UART2_RST() uint32 {
	return (volatile.LoadUint32(&o.PERIP_RST_EN1.Reg) & 0x200) >> 9
}
func (o *SYSTEM_Type) SetPERIP_RST_EN1_TSENS_RST(value uint32) {
	volatile.StoreUint32(&o.PERIP_RST_EN1.Reg, volatile.LoadUint32(&o.PERIP_RST_EN1.Reg)&^(0x400)|value<<10)
}
func (o *SYSTEM_Type) GetPERIP_RST_EN1_TSENS_RST() uint32 {
	return (volatile.LoadUint32(&o.PERIP_RST_EN1.Reg) & 0x400) >> 10
}

// SYSTEM.BT_LPCK_DIV_INT: clock config register
func (o *SYSTEM_Type) SetBT_LPCK_DIV_INT_BT_LPCK_DIV_NUM(value uint32) {
	volatile.StoreUint32(&o.BT_LPCK_DIV_INT.Reg, volatile.LoadUint32(&o.BT_LPCK_DIV_INT.Reg)&^(0xfff)|value)
}
func (o *SYSTEM_Type) GetBT_LPCK_DIV_INT_BT_LPCK_DIV_NUM() uint32 {
	return volatile.LoadUint32(&o.BT_LPCK_DIV_INT.Reg) & 0xfff
}

// SYSTEM.BT_LPCK_DIV_FRAC: clock config register
func (o *SYSTEM_Type) SetBT_LPCK_DIV_FRAC_BT_LPCK_DIV_B(value uint32) {
	volatile.StoreUint32(&o.BT_LPCK_DIV_FRAC.Reg, volatile.LoadUint32(&o.BT_LPCK_DIV_FRAC.Reg)&^(0xfff)|value)
}
func (o *SYSTEM_Type) GetBT_LPCK_DIV_FRAC_BT_LPCK_DIV_B() uint32 {
	return volatile.LoadUint32(&o.BT_LPCK_DIV_FRAC.Reg) & 0xfff
}
func (o *SYSTEM_Type) SetBT_LPCK_DIV_FRAC_BT_LPCK_DIV_A(value uint32) {
	volatile.StoreUint32(&o.BT_LPCK_DIV_FRAC.Reg, volatile.LoadUint32(&o.BT_LPCK_DIV_FRAC.Reg)&^(0xfff000)|value<<12)
}
func (o *SYSTEM_Type) GetBT_LPCK_DIV_FRAC_BT_LPCK_DIV_A() uint32 {
	return (volatile.LoadUint32(&o.BT_LPCK_DIV_FRAC.Reg) & 0xfff000) >> 12
}
func (o *SYSTEM_Type) SetBT_LPCK_DIV_FRAC_LPCLK_SEL_RTC_SLOW(value uint32) {
	volatile.StoreUint32(&o.BT_LPCK_DIV_FRAC.Reg, volatile.LoadUint32(&o.BT_LPCK_DIV_FRAC.Reg)&^(0x1000000)|value<<24)
}
func (o *SYSTEM_Type) GetBT_LPCK_DIV_FRAC_LPCLK_SEL_RTC_SLOW() uint32 {
	return (volatile.LoadUint32(&o.BT_LPCK_DIV_FRAC.Reg) & 0x1000000) >> 24
}
func (o *SYSTEM_Type) SetBT_LPCK_DIV_FRAC_LPCLK_SEL_8M(value uint32) {
	volatile.StoreUint32(&o.BT_LPCK_DIV_FRAC.Reg, volatile.LoadUint32(&o.BT_LPCK_DIV_FRAC.Reg)&^(0x2000000)|value<<25)
}
func (o *SYSTEM_Type) GetBT_LPCK_DIV_FRAC_LPCLK_SEL_8M() uint32 {
	return (volatile.LoadUint32(&o.BT_LPCK_DIV_FRAC.Reg) & 0x2000000) >> 25
}
func (o *SYSTEM_Type) SetBT_LPCK_DIV_FRAC_LPCLK_SEL_XTAL(value uint32) {
	volatile.StoreUint32(&o.BT_LPCK_DIV_FRAC.Reg, volatile.LoadUint32(&o.BT_LPCK_DIV_FRAC.Reg)&^(0x4000000)|value<<26)
}
func (o *SYSTEM_Type) GetBT_LPCK_DIV_FRAC_LPCLK_SEL_XTAL() uint32 {
	return (volatile.LoadUint32(&o.BT_LPCK_DIV_FRAC.Reg) & 0x4000000) >> 26
}
func (o *SYSTEM_Type) SetBT_LPCK_DIV_FRAC_LPCLK_SEL_XTAL32K(value uint32) {
	volatile.StoreUint32(&o.BT_LPCK_DIV_FRAC.Reg, volatile.LoadUint32(&o.BT_LPCK_DIV_FRAC.Reg)&^(0x8000000)|value<<27)
}
func (o *SYSTEM_Type) GetBT_LPCK_DIV_FRAC_LPCLK_SEL_XTAL32K() uint32 {
	return (volatile.LoadUint32(&o.BT_LPCK_DIV_FRAC.Reg) & 0x8000000) >> 27
}
func (o *SYSTEM_Type) SetBT_LPCK_DIV_FRAC_LPCLK_RTC_EN(value uint32) {
	volatile.StoreUint32(&o.BT_LPCK_DIV_FRAC.Reg, volatile.LoadUint32(&o.BT_LPCK_DIV_FRAC.Reg)&^(0x10000000)|value<<28)
}
func (o *SYSTEM_Type) GetBT_LPCK_DIV_FRAC_LPCLK_RTC_EN() uint32 {
	return (volatile.LoadUint32(&o.BT_LPCK_DIV_FRAC.Reg) & 0x10000000) >> 28
}

// SYSTEM.CPU_INTR_FROM_CPU_0: interrupt generate register
func (o *SYSTEM_Type) SetCPU_INTR_FROM_CPU_0(value uint32) {
	volatile.StoreUint32(&o.CPU_INTR_FROM_CPU_0.Reg, volatile.LoadUint32(&o.CPU_INTR_FROM_CPU_0.Reg)&^(0x1)|value)
}
func (o *SYSTEM_Type) GetCPU_INTR_FROM_CPU_0() uint32 {
	return volatile.LoadUint32(&o.CPU_INTR_FROM_CPU_0.Reg) & 0x1
}

// SYSTEM.CPU_INTR_FROM_CPU_1: interrupt generate register
func (o *SYSTEM_Type) SetCPU_INTR_FROM_CPU_1(value uint32) {
	volatile.StoreUint32(&o.CPU_INTR_FROM_CPU_1.Reg, volatile.LoadUint32(&o.CPU_INTR_FROM_CPU_1.Reg)&^(0x1)|value)
}
func (o *SYSTEM_Type) GetCPU_INTR_FROM_CPU_1() uint32 {
	return volatile.LoadUint32(&o.CPU_INTR_FROM_CPU_1.Reg) & 0x1
}

// SYSTEM.CPU_INTR_FROM_CPU_2: interrupt generate register
func (o *SYSTEM_Type) SetCPU_INTR_FROM_CPU_2(value uint32) {
	volatile.StoreUint32(&o.CPU_INTR_FROM_CPU_2.Reg, volatile.LoadUint32(&o.CPU_INTR_FROM_CPU_2.Reg)&^(0x1)|value)
}
func (o *SYSTEM_Type) GetCPU_INTR_FROM_CPU_2() uint32 {
	return volatile.LoadUint32(&o.CPU_INTR_FROM_CPU_2.Reg) & 0x1
}

// SYSTEM.CPU_INTR_FROM_CPU_3: interrupt generate register
func (o *SYSTEM_Type) SetCPU_INTR_FROM_CPU_3(value uint32) {
	volatile.StoreUint32(&o.CPU_INTR_FROM_CPU_3.Reg, volatile.LoadUint32(&o.CPU_INTR_FROM_CPU_3.Reg)&^(0x1)|value)
}
func (o *SYSTEM_Type) GetCPU_INTR_FROM_CPU_3() uint32 {
	return volatile.LoadUint32(&o.CPU_INTR_FROM_CPU_3.Reg) & 0x1
}

// SYSTEM.RSA_PD_CTRL: rsa memory power control register
func (o *SYSTEM_Type) SetRSA_PD_CTRL_RSA_MEM_PD(value uint32) {
	volatile.StoreUint32(&o.RSA_PD_CTRL.Reg, volatile.LoadUint32(&o.RSA_PD_CTRL.Reg)&^(0x1)|value)
}
func (o *SYSTEM_Type) GetRSA_PD_CTRL_RSA_MEM_PD() uint32 {
	return volatile.LoadUint32(&o.RSA_PD_CTRL.Reg) & 0x1
}
func (o *SYSTEM_Type) SetRSA_PD_CTRL_RSA_MEM_FORCE_PU(value uint32) {
	volatile.StoreUint32(&o.RSA_PD_CTRL.Reg, volatile.LoadUint32(&o.RSA_PD_CTRL.Reg)&^(0x2)|value<<1)
}
func (o *SYSTEM_Type) GetRSA_PD_CTRL_RSA_MEM_FORCE_PU() uint32 {
	return (volatile.LoadUint32(&o.RSA_PD_CTRL.Reg) & 0x2) >> 1
}
func (o *SYSTEM_Type) SetRSA_PD_CTRL_RSA_MEM_FORCE_PD(value uint32) {
	volatile.StoreUint32(&o.RSA_PD_CTRL.Reg, volatile.LoadUint32(&o.RSA_PD_CTRL.Reg)&^(0x4)|value<<2)
}
func (o *SYSTEM_Type) GetRSA_PD_CTRL_RSA_MEM_FORCE_PD() uint32 {
	return (volatile.LoadUint32(&o.RSA_PD_CTRL.Reg) & 0x4) >> 2
}

// SYSTEM.EDMA_CTRL: edma clcok and reset register
func (o *SYSTEM_Type) SetEDMA_CTRL_EDMA_CLK_ON(value uint32) {
	volatile.StoreUint32(&o.EDMA_CTRL.Reg, volatile.LoadUint32(&o.EDMA_CTRL.Reg)&^(0x1)|value)
}
func (o *SYSTEM_Type) GetEDMA_CTRL_EDMA_CLK_ON() uint32 {
	return volatile.LoadUint32(&o.EDMA_CTRL.Reg) & 0x1
}
func (o *SYSTEM_Type) SetEDMA_CTRL_EDMA_RESET(value uint32) {
	volatile.StoreUint32(&o.EDMA_CTRL.Reg, volatile.LoadUint32(&o.EDMA_CTRL.Reg)&^(0x2)|value<<1)
}
func (o *SYSTEM_Type) GetEDMA_CTRL_EDMA_RESET() uint32 {
	return (volatile.LoadUint32(&o.EDMA_CTRL.Reg) & 0x2) >> 1
}

// SYSTEM.CACHE_CONTROL: cache control register
func (o *SYSTEM_Type) SetCACHE_CONTROL_ICACHE_CLK_ON(value uint32) {
	volatile.StoreUint32(&o.CACHE_CONTROL.Reg, volatile.LoadUint32(&o.CACHE_CONTROL.Reg)&^(0x1)|value)
}
func (o *SYSTEM_Type) GetCACHE_CONTROL_ICACHE_CLK_ON() uint32 {
	return volatile.LoadUint32(&o.CACHE_CONTROL.Reg) & 0x1
}
func (o *SYSTEM_Type) SetCACHE_CONTROL_ICACHE_RESET(value uint32) {
	volatile.StoreUint32(&o.CACHE_CONTROL.Reg, volatile.LoadUint32(&o.CACHE_CONTROL.Reg)&^(0x2)|value<<1)
}
func (o *SYSTEM_Type) GetCACHE_CONTROL_ICACHE_RESET() uint32 {
	return (volatile.LoadUint32(&o.CACHE_CONTROL.Reg) & 0x2) >> 1
}
func (o *SYSTEM_Type) SetCACHE_CONTROL_DCACHE_CLK_ON(value uint32) {
	volatile.StoreUint32(&o.CACHE_CONTROL.Reg, volatile.LoadUint32(&o.CACHE_CONTROL.Reg)&^(0x4)|value<<2)
}
func (o *SYSTEM_Type) GetCACHE_CONTROL_DCACHE_CLK_ON() uint32 {
	return (volatile.LoadUint32(&o.CACHE_CONTROL.Reg) & 0x4) >> 2
}
func (o *SYSTEM_Type) SetCACHE_CONTROL_DCACHE_RESET(value uint32) {
	volatile.StoreUint32(&o.CACHE_CONTROL.Reg, volatile.LoadUint32(&o.CACHE_CONTROL.Reg)&^(0x8)|value<<3)
}
func (o *SYSTEM_Type) GetCACHE_CONTROL_DCACHE_RESET() uint32 {
	return (volatile.LoadUint32(&o.CACHE_CONTROL.Reg) & 0x8) >> 3
}

// SYSTEM.EXTERNAL_DEVICE_ENCRYPT_DECRYPT_CONTROL: SYSTEM_EXTERNAL_DEVICE_ENCRYPT_DECRYPT_CONTROL_REG
func (o *SYSTEM_Type) SetEXTERNAL_DEVICE_ENCRYPT_DECRYPT_CONTROL_ENABLE_SPI_MANUAL_ENCRYPT(value uint32) {
	volatile.StoreUint32(&o.EXTERNAL_DEVICE_ENCRYPT_DECRYPT_CONTROL.Reg, volatile.LoadUint32(&o.EXTERNAL_DEVICE_ENCRYPT_DECRYPT_CONTROL.Reg)&^(0x1)|value)
}
func (o *SYSTEM_Type) GetEXTERNAL_DEVICE_ENCRYPT_DECRYPT_CONTROL_ENABLE_SPI_MANUAL_ENCRYPT() uint32 {
	return volatile.LoadUint32(&o.EXTERNAL_DEVICE_ENCRYPT_DECRYPT_CONTROL.Reg) & 0x1
}
func (o *SYSTEM_Type) SetEXTERNAL_DEVICE_ENCRYPT_DECRYPT_CONTROL_ENABLE_DOWNLOAD_DB_ENCRYPT(value uint32) {
	volatile.StoreUint32(&o.EXTERNAL_DEVICE_ENCRYPT_DECRYPT_CONTROL.Reg, volatile.LoadUint32(&o.EXTERNAL_DEVICE_ENCRYPT_DECRYPT_CONTROL.Reg)&^(0x2)|value<<1)
}
func (o *SYSTEM_Type) GetEXTERNAL_DEVICE_ENCRYPT_DECRYPT_CONTROL_ENABLE_DOWNLOAD_DB_ENCRYPT() uint32 {
	return (volatile.LoadUint32(&o.EXTERNAL_DEVICE_ENCRYPT_DECRYPT_CONTROL.Reg) & 0x2) >> 1
}
func (o *SYSTEM_Type) SetEXTERNAL_DEVICE_ENCRYPT_DECRYPT_CONTROL_ENABLE_DOWNLOAD_G0CB_DECRYPT(value uint32) {
	volatile.StoreUint32(&o.EXTERNAL_DEVICE_ENCRYPT_DECRYPT_CONTROL.Reg, volatile.LoadUint32(&o.EXTERNAL_DEVICE_ENCRYPT_DECRYPT_CONTROL.Reg)&^(0x4)|value<<2)
}
func (o *SYSTEM_Type) GetEXTERNAL_DEVICE_ENCRYPT_DECRYPT_CONTROL_ENABLE_DOWNLOAD_G0CB_DECRYPT() uint32 {
	return (volatile.LoadUint32(&o.EXTERNAL_DEVICE_ENCRYPT_DECRYPT_CONTROL.Reg) & 0x4) >> 2
}
func (o *SYSTEM_Type) SetEXTERNAL_DEVICE_ENCRYPT_DECRYPT_CONTROL_ENABLE_DOWNLOAD_MANUAL_ENCRYPT(value uint32) {
	volatile.StoreUint32(&o.EXTERNAL_DEVICE_ENCRYPT_DECRYPT_CONTROL.Reg, volatile.LoadUint32(&o.EXTERNAL_DEVICE_ENCRYPT_DECRYPT_CONTROL.Reg)&^(0x8)|value<<3)
}
func (o *SYSTEM_Type) GetEXTERNAL_DEVICE_ENCRYPT_DECRYPT_CONTROL_ENABLE_DOWNLOAD_MANUAL_ENCRYPT() uint32 {
	return (volatile.LoadUint32(&o.EXTERNAL_DEVICE_ENCRYPT_DECRYPT_CONTROL.Reg) & 0x8) >> 3
}

// SYSTEM.RTC_FASTMEM_CONFIG: fast memory config register
func (o *SYSTEM_Type) SetRTC_FASTMEM_CONFIG_RTC_MEM_CRC_START(value uint32) {
	volatile.StoreUint32(&o.RTC_FASTMEM_CONFIG.Reg, volatile.LoadUint32(&o.RTC_FASTMEM_CONFIG.Reg)&^(0x100)|value<<8)
}
func (o *SYSTEM_Type) GetRTC_FASTMEM_CONFIG_RTC_MEM_CRC_START() uint32 {
	return (volatile.LoadUint32(&o.RTC_FASTMEM_CONFIG.Reg) & 0x100) >> 8
}
func (o *SYSTEM_Type) SetRTC_FASTMEM_CONFIG_RTC_MEM_CRC_ADDR(value uint32) {
	volatile.StoreUint32(&o.RTC_FASTMEM_CONFIG.Reg, volatile.LoadUint32(&o.RTC_FASTMEM_CONFIG.Reg)&^(0xffe00)|value<<9)
}
func (o *SYSTEM_Type) GetRTC_FASTMEM_CONFIG_RTC_MEM_CRC_ADDR() uint32 {
	return (volatile.LoadUint32(&o.RTC_FASTMEM_CONFIG.Reg) & 0xffe00) >> 9
}
func (o *SYSTEM_Type) SetRTC_FASTMEM_CONFIG_RTC_MEM_CRC_LEN(value uint32) {
	volatile.StoreUint32(&o.RTC_FASTMEM_CONFIG.Reg, volatile.LoadUint32(&o.RTC_FASTMEM_CONFIG.Reg)&^(0x7ff00000)|value<<20)
}
func (o *SYSTEM_Type) GetRTC_FASTMEM_CONFIG_RTC_MEM_CRC_LEN() uint32 {
	return (volatile.LoadUint32(&o.RTC_FASTMEM_CONFIG.Reg) & 0x7ff00000) >> 20
}
func (o *SYSTEM_Type) SetRTC_FASTMEM_CONFIG_RTC_MEM_CRC_FINISH(value uint32) {
	volatile.StoreUint32(&o.RTC_FASTMEM_CONFIG.Reg, volatile.LoadUint32(&o.RTC_FASTMEM_CONFIG.Reg)&^(0x80000000)|value<<31)
}
func (o *SYSTEM_Type) GetRTC_FASTMEM_CONFIG_RTC_MEM_CRC_FINISH() uint32 {
	return (volatile.LoadUint32(&o.RTC_FASTMEM_CONFIG.Reg) & 0x80000000) >> 31
}

// SYSTEM.RTC_FASTMEM_CRC: reserved
func (o *SYSTEM_Type) SetRTC_FASTMEM_CRC(value uint32) {
	volatile.StoreUint32(&o.RTC_FASTMEM_CRC.Reg, value)
}
func (o *SYSTEM_Type) GetRTC_FASTMEM_CRC() uint32 {
	return volatile.LoadUint32(&o.RTC_FASTMEM_CRC.Reg)
}

// SYSTEM.REDUNDANT_ECO_CTRL: eco register
func (o *SYSTEM_Type) SetREDUNDANT_ECO_CTRL_REDUNDANT_ECO_DRIVE(value uint32) {
	volatile.StoreUint32(&o.REDUNDANT_ECO_CTRL.Reg, volatile.LoadUint32(&o.REDUNDANT_ECO_CTRL.Reg)&^(0x1)|value)
}
func (o *SYSTEM_Type) GetREDUNDANT_ECO_CTRL_REDUNDANT_ECO_DRIVE() uint32 {
	return volatile.LoadUint32(&o.REDUNDANT_ECO_CTRL.Reg) & 0x1
}
func (o *SYSTEM_Type) SetREDUNDANT_ECO_CTRL_REDUNDANT_ECO_RESULT(value uint32) {
	volatile.StoreUint32(&o.REDUNDANT_ECO_CTRL.Reg, volatile.LoadUint32(&o.REDUNDANT_ECO_CTRL.Reg)&^(0x2)|value<<1)
}
func (o *SYSTEM_Type) GetREDUNDANT_ECO_CTRL_REDUNDANT_ECO_RESULT() uint32 {
	return (volatile.LoadUint32(&o.REDUNDANT_ECO_CTRL.Reg) & 0x2) >> 1
}

// SYSTEM.CLOCK_GATE: clock gating register
func (o *SYSTEM_Type) SetCLOCK_GATE_CLK_EN(value uint32) {
	volatile.StoreUint32(&o.CLOCK_GATE.Reg, volatile.LoadUint32(&o.CLOCK_GATE.Reg)&^(0x1)|value)
}
func (o *SYSTEM_Type) GetCLOCK_GATE_CLK_EN() uint32 {
	return volatile.LoadUint32(&o.CLOCK_GATE.Reg) & 0x1
}

// SYSTEM.SYSCLK_CONF: system clock config register
func (o *SYSTEM_Type) SetSYSCLK_CONF_PRE_DIV_CNT(value uint32) {
	volatile.StoreUint32(&o.SYSCLK_CONF.Reg, volatile.LoadUint32(&o.SYSCLK_CONF.Reg)&^(0x3ff)|value)
}
func (o *SYSTEM_Type) GetSYSCLK_CONF_PRE_DIV_CNT() uint32 {
	return volatile.LoadUint32(&o.SYSCLK_CONF.Reg) & 0x3ff
}
func (o *SYSTEM_Type) SetSYSCLK_CONF_SOC_CLK_SEL(value uint32) {
	volatile.StoreUint32(&o.SYSCLK_CONF.Reg, volatile.LoadUint32(&o.SYSCLK_CONF.Reg)&^(0xc00)|value<<10)
}
func (o *SYSTEM_Type) GetSYSCLK_CONF_SOC_CLK_SEL() uint32 {
	return (volatile.LoadUint32(&o.SYSCLK_CONF.Reg) & 0xc00) >> 10
}
func (o *SYSTEM_Type) SetSYSCLK_CONF_CLK_XTAL_FREQ(value uint32) {
	volatile.StoreUint32(&o.SYSCLK_CONF.Reg, volatile.LoadUint32(&o.SYSCLK_CONF.Reg)&^(0x7f000)|value<<12)
}
func (o *SYSTEM_Type) GetSYSCLK_CONF_CLK_XTAL_FREQ() uint32 {
	return (volatile.LoadUint32(&o.SYSCLK_CONF.Reg) & 0x7f000) >> 12
}
func (o *SYSTEM_Type) SetSYSCLK_CONF_CLK_DIV_EN(value uint32) {
	volatile.StoreUint32(&o.SYSCLK_CONF.Reg, volatile.LoadUint32(&o.SYSCLK_CONF.Reg)&^(0x80000)|value<<19)
}
func (o *SYSTEM_Type) GetSYSCLK_CONF_CLK_DIV_EN() uint32 {
	return (volatile.LoadUint32(&o.SYSCLK_CONF.Reg) & 0x80000) >> 19
}

// SYSTEM.MEM_PVT: mem pvt register
func (o *SYSTEM_Type) SetMEM_PVT_MEM_PATH_LEN(value uint32) {
	volatile.StoreUint32(&o.MEM_PVT.Reg, volatile.LoadUint32(&o.MEM_PVT.Reg)&^(0xf)|value)
}
func (o *SYSTEM_Type) GetMEM_PVT_MEM_PATH_LEN() uint32 {
	return volatile.LoadUint32(&o.MEM_PVT.Reg) & 0xf
}
func (o *SYSTEM_Type) SetMEM_PVT_MEM_ERR_CNT_CLR(value uint32) {
	volatile.StoreUint32(&o.MEM_PVT.Reg, volatile.LoadUint32(&o.MEM_PVT.Reg)&^(0x10)|value<<4)
}
func (o *SYSTEM_Type) GetMEM_PVT_MEM_ERR_CNT_CLR() uint32 {
	return (volatile.LoadUint32(&o.MEM_PVT.Reg) & 0x10) >> 4
}
func (o *SYSTEM_Type) SetMEM_PVT_MONITOR_EN(value uint32) {
	volatile.StoreUint32(&o.MEM_PVT.Reg, volatile.LoadUint32(&o.MEM_PVT.Reg)&^(0x20)|value<<5)
}
func (o *SYSTEM_Type) GetMEM_PVT_MONITOR_EN() uint32 {
	return (volatile.LoadUint32(&o.MEM_PVT.Reg) & 0x20) >> 5
}
func (o *SYSTEM_Type) SetMEM_PVT_MEM_TIMING_ERR_CNT(value uint32) {
	volatile.StoreUint32(&o.MEM_PVT.Reg, volatile.LoadUint32(&o.MEM_PVT.Reg)&^(0x3fffc0)|value<<6)
}
func (o *SYSTEM_Type) GetMEM_PVT_MEM_TIMING_ERR_CNT() uint32 {
	return (volatile.LoadUint32(&o.MEM_PVT.Reg) & 0x3fffc0) >> 6
}
func (o *SYSTEM_Type) SetMEM_PVT_MEM_VT_SEL(value uint32) {
	volatile.StoreUint32(&o.MEM_PVT.Reg, volatile.LoadUint32(&o.MEM_PVT.Reg)&^(0xc00000)|value<<22)
}
func (o *SYSTEM_Type) GetMEM_PVT_MEM_VT_SEL() uint32 {
	return (volatile.LoadUint32(&o.MEM_PVT.Reg) & 0xc00000) >> 22
}

// SYSTEM.COMB_PVT_LVT_CONF: mem pvt register
func (o *SYSTEM_Type) SetCOMB_PVT_LVT_CONF_COMB_PATH_LEN_LVT(value uint32) {
	volatile.StoreUint32(&o.COMB_PVT_LVT_CONF.Reg, volatile.LoadUint32(&o.COMB_PVT_LVT_CONF.Reg)&^(0x1f)|value)
}
func (o *SYSTEM_Type) GetCOMB_PVT_LVT_CONF_COMB_PATH_LEN_LVT() uint32 {
	return volatile.LoadUint32(&o.COMB_PVT_LVT_CONF.Reg) & 0x1f
}
func (o *SYSTEM_Type) SetCOMB_PVT_LVT_CONF_COMB_ERR_CNT_CLR_LVT(value uint32) {
	volatile.StoreUint32(&o.COMB_PVT_LVT_CONF.Reg, volatile.LoadUint32(&o.COMB_PVT_LVT_CONF.Reg)&^(0x20)|value<<5)
}
func (o *SYSTEM_Type) GetCOMB_PVT_LVT_CONF_COMB_ERR_CNT_CLR_LVT() uint32 {
	return (volatile.LoadUint32(&o.COMB_PVT_LVT_CONF.Reg) & 0x20) >> 5
}
func (o *SYSTEM_Type) SetCOMB_PVT_LVT_CONF_COMB_PVT_MONITOR_EN_LVT(value uint32) {
	volatile.StoreUint32(&o.COMB_PVT_LVT_CONF.Reg, volatile.LoadUint32(&o.COMB_PVT_LVT_CONF.Reg)&^(0x40)|value<<6)
}
func (o *SYSTEM_Type) GetCOMB_PVT_LVT_CONF_COMB_PVT_MONITOR_EN_LVT() uint32 {
	return (volatile.LoadUint32(&o.COMB_PVT_LVT_CONF.Reg) & 0x40) >> 6
}

// SYSTEM.COMB_PVT_NVT_CONF: mem pvt register
func (o *SYSTEM_Type) SetCOMB_PVT_NVT_CONF_COMB_PATH_LEN_NVT(value uint32) {
	volatile.StoreUint32(&o.COMB_PVT_NVT_CONF.Reg, volatile.LoadUint32(&o.COMB_PVT_NVT_CONF.Reg)&^(0x1f)|value)
}
func (o *SYSTEM_Type) GetCOMB_PVT_NVT_CONF_COMB_PATH_LEN_NVT() uint32 {
	return volatile.LoadUint32(&o.COMB_PVT_NVT_CONF.Reg) & 0x1f
}
func (o *SYSTEM_Type) SetCOMB_PVT_NVT_CONF_COMB_ERR_CNT_CLR_NVT(value uint32) {
	volatile.StoreUint32(&o.COMB_PVT_NVT_CONF.Reg, volatile.LoadUint32(&o.COMB_PVT_NVT_CONF.Reg)&^(0x20)|value<<5)
}
func (o *SYSTEM_Type) GetCOMB_PVT_NVT_CONF_COMB_ERR_CNT_CLR_NVT() uint32 {
	return (volatile.LoadUint32(&o.COMB_PVT_NVT_CONF.Reg) & 0x20) >> 5
}
func (o *SYSTEM_Type) SetCOMB_PVT_NVT_CONF_COMB_PVT_MONITOR_EN_NVT(value uint32) {
	volatile.StoreUint32(&o.COMB_PVT_NVT_CONF.Reg, volatile.LoadUint32(&o.COMB_PVT_NVT_CONF.Reg)&^(0x40)|value<<6)
}
func (o *SYSTEM_Type) GetCOMB_PVT_NVT_CONF_COMB_PVT_MONITOR_EN_NVT() uint32 {
	return (volatile.LoadUint32(&o.COMB_PVT_NVT_CONF.Reg) & 0x40) >> 6
}

// SYSTEM.COMB_PVT_HVT_CONF: mem pvt register
func (o *SYSTEM_Type) SetCOMB_PVT_HVT_CONF_COMB_PATH_LEN_HVT(value uint32) {
	volatile.StoreUint32(&o.COMB_PVT_HVT_CONF.Reg, volatile.LoadUint32(&o.COMB_PVT_HVT_CONF.Reg)&^(0x1f)|value)
}
func (o *SYSTEM_Type) GetCOMB_PVT_HVT_CONF_COMB_PATH_LEN_HVT() uint32 {
	return volatile.LoadUint32(&o.COMB_PVT_HVT_CONF.Reg) & 0x1f
}
func (o *SYSTEM_Type) SetCOMB_PVT_HVT_CONF_COMB_ERR_CNT_CLR_HVT(value uint32) {
	volatile.StoreUint32(&o.COMB_PVT_HVT_CONF.Reg, volatile.LoadUint32(&o.COMB_PVT_HVT_CONF.Reg)&^(0x20)|value<<5)
}
func (o *SYSTEM_Type) GetCOMB_PVT_HVT_CONF_COMB_ERR_CNT_CLR_HVT() uint32 {
	return (volatile.LoadUint32(&o.COMB_PVT_HVT_CONF.Reg) & 0x20) >> 5
}
func (o *SYSTEM_Type) SetCOMB_PVT_HVT_CONF_COMB_PVT_MONITOR_EN_HVT(value uint32) {
	volatile.StoreUint32(&o.COMB_PVT_HVT_CONF.Reg, volatile.LoadUint32(&o.COMB_PVT_HVT_CONF.Reg)&^(0x40)|value<<6)
}
func (o *SYSTEM_Type) GetCOMB_PVT_HVT_CONF_COMB_PVT_MONITOR_EN_HVT() uint32 {
	return (volatile.LoadUint32(&o.COMB_PVT_HVT_CONF.Reg) & 0x40) >> 6
}

// SYSTEM.COMB_PVT_ERR_LVT_SITE0: mem pvt register
func (o *SYSTEM_Type) SetCOMB_PVT_ERR_LVT_SITE0_COMB_TIMING_ERR_CNT_LVT_SITE0(value uint32) {
	volatile.StoreUint32(&o.COMB_PVT_ERR_LVT_SITE0.Reg, volatile.LoadUint32(&o.COMB_PVT_ERR_LVT_SITE0.Reg)&^(0xffff)|value)
}
func (o *SYSTEM_Type) GetCOMB_PVT_ERR_LVT_SITE0_COMB_TIMING_ERR_CNT_LVT_SITE0() uint32 {
	return volatile.LoadUint32(&o.COMB_PVT_ERR_LVT_SITE0.Reg) & 0xffff
}

// SYSTEM.COMB_PVT_ERR_NVT_SITE0: mem pvt register
func (o *SYSTEM_Type) SetCOMB_PVT_ERR_NVT_SITE0_COMB_TIMING_ERR_CNT_NVT_SITE0(value uint32) {
	volatile.StoreUint32(&o.COMB_PVT_ERR_NVT_SITE0.Reg, volatile.LoadUint32(&o.COMB_PVT_ERR_NVT_SITE0.Reg)&^(0xffff)|value)
}
func (o *SYSTEM_Type) GetCOMB_PVT_ERR_NVT_SITE0_COMB_TIMING_ERR_CNT_NVT_SITE0() uint32 {
	return volatile.LoadUint32(&o.COMB_PVT_ERR_NVT_SITE0.Reg) & 0xffff
}

// SYSTEM.COMB_PVT_ERR_HVT_SITE0: mem pvt register
func (o *SYSTEM_Type) SetCOMB_PVT_ERR_HVT_SITE0_COMB_TIMING_ERR_CNT_HVT_SITE0(value uint32) {
	volatile.StoreUint32(&o.COMB_PVT_ERR_HVT_SITE0.Reg, volatile.LoadUint32(&o.COMB_PVT_ERR_HVT_SITE0.Reg)&^(0xffff)|value)
}
func (o *SYSTEM_Type) GetCOMB_PVT_ERR_HVT_SITE0_COMB_TIMING_ERR_CNT_HVT_SITE0() uint32 {
	return volatile.LoadUint32(&o.COMB_PVT_ERR_HVT_SITE0.Reg) & 0xffff
}

// SYSTEM.COMB_PVT_ERR_LVT_SITE1: mem pvt register
func (o *SYSTEM_Type) SetCOMB_PVT_ERR_LVT_SITE1_COMB_TIMING_ERR_CNT_LVT_SITE1(value uint32) {
	volatile.StoreUint32(&o.COMB_PVT_ERR_LVT_SITE1.Reg, volatile.LoadUint32(&o.COMB_PVT_ERR_LVT_SITE1.Reg)&^(0xffff)|value)
}
func (o *SYSTEM_Type) GetCOMB_PVT_ERR_LVT_SITE1_COMB_TIMING_ERR_CNT_LVT_SITE1() uint32 {
	return volatile.LoadUint32(&o.COMB_PVT_ERR_LVT_SITE1.Reg) & 0xffff
}

// SYSTEM.COMB_PVT_ERR_NVT_SITE1: mem pvt register
func (o *SYSTEM_Type) SetCOMB_PVT_ERR_NVT_SITE1_COMB_TIMING_ERR_CNT_NVT_SITE1(value uint32) {
	volatile.StoreUint32(&o.COMB_PVT_ERR_NVT_SITE1.Reg, volatile.LoadUint32(&o.COMB_PVT_ERR_NVT_SITE1.Reg)&^(0xffff)|value)
}
func (o *SYSTEM_Type) GetCOMB_PVT_ERR_NVT_SITE1_COMB_TIMING_ERR_CNT_NVT_SITE1() uint32 {
	return volatile.LoadUint32(&o.COMB_PVT_ERR_NVT_SITE1.Reg) & 0xffff
}

// SYSTEM.COMB_PVT_ERR_HVT_SITE1: mem pvt register
func (o *SYSTEM_Type) SetCOMB_PVT_ERR_HVT_SITE1_COMB_TIMING_ERR_CNT_HVT_SITE1(value uint32) {
	volatile.StoreUint32(&o.COMB_PVT_ERR_HVT_SITE1.Reg, volatile.LoadUint32(&o.COMB_PVT_ERR_HVT_SITE1.Reg)&^(0xffff)|value)
}
func (o *SYSTEM_Type) GetCOMB_PVT_ERR_HVT_SITE1_COMB_TIMING_ERR_CNT_HVT_SITE1() uint32 {
	return volatile.LoadUint32(&o.COMB_PVT_ERR_HVT_SITE1.Reg) & 0xffff
}

// SYSTEM.COMB_PVT_ERR_LVT_SITE2: mem pvt register
func (o *SYSTEM_Type) SetCOMB_PVT_ERR_LVT_SITE2_COMB_TIMING_ERR_CNT_LVT_SITE2(value uint32) {
	volatile.StoreUint32(&o.COMB_PVT_ERR_LVT_SITE2.Reg, volatile.LoadUint32(&o.COMB_PVT_ERR_LVT_SITE2.Reg)&^(0xffff)|value)
}
func (o *SYSTEM_Type) GetCOMB_PVT_ERR_LVT_SITE2_COMB_TIMING_ERR_CNT_LVT_SITE2() uint32 {
	return volatile.LoadUint32(&o.COMB_PVT_ERR_LVT_SITE2.Reg) & 0xffff
}

// SYSTEM.COMB_PVT_ERR_NVT_SITE2: mem pvt register
func (o *SYSTEM_Type) SetCOMB_PVT_ERR_NVT_SITE2_COMB_TIMING_ERR_CNT_NVT_SITE2(value uint32) {
	volatile.StoreUint32(&o.COMB_PVT_ERR_NVT_SITE2.Reg, volatile.LoadUint32(&o.COMB_PVT_ERR_NVT_SITE2.Reg)&^(0xffff)|value)
}
func (o *SYSTEM_Type) GetCOMB_PVT_ERR_NVT_SITE2_COMB_TIMING_ERR_CNT_NVT_SITE2() uint32 {
	return volatile.LoadUint32(&o.COMB_PVT_ERR_NVT_SITE2.Reg) & 0xffff
}

// SYSTEM.COMB_PVT_ERR_HVT_SITE2: mem pvt register
func (o *SYSTEM_Type) SetCOMB_PVT_ERR_HVT_SITE2_COMB_TIMING_ERR_CNT_HVT_SITE2(value uint32) {
	volatile.StoreUint32(&o.COMB_PVT_ERR_HVT_SITE2.Reg, volatile.LoadUint32(&o.COMB_PVT_ERR_HVT_SITE2.Reg)&^(0xffff)|value)
}
func (o *SYSTEM_Type) GetCOMB_PVT_ERR_HVT_SITE2_COMB_TIMING_ERR_CNT_HVT_SITE2() uint32 {
	return volatile.LoadUint32(&o.COMB_PVT_ERR_HVT_SITE2.Reg) & 0xffff
}

// SYSTEM.COMB_PVT_ERR_LVT_SITE3: mem pvt register
func (o *SYSTEM_Type) SetCOMB_PVT_ERR_LVT_SITE3_COMB_TIMING_ERR_CNT_LVT_SITE3(value uint32) {
	volatile.StoreUint32(&o.COMB_PVT_ERR_LVT_SITE3.Reg, volatile.LoadUint32(&o.COMB_PVT_ERR_LVT_SITE3.Reg)&^(0xffff)|value)
}
func (o *SYSTEM_Type) GetCOMB_PVT_ERR_LVT_SITE3_COMB_TIMING_ERR_CNT_LVT_SITE3() uint32 {
	return volatile.LoadUint32(&o.COMB_PVT_ERR_LVT_SITE3.Reg) & 0xffff
}

// SYSTEM.COMB_PVT_ERR_NVT_SITE3: mem pvt register
func (o *SYSTEM_Type) SetCOMB_PVT_ERR_NVT_SITE3_COMB_TIMING_ERR_CNT_NVT_SITE3(value uint32) {
	volatile.StoreUint32(&o.COMB_PVT_ERR_NVT_SITE3.Reg, volatile.LoadUint32(&o.COMB_PVT_ERR_NVT_SITE3.Reg)&^(0xffff)|value)
}
func (o *SYSTEM_Type) GetCOMB_PVT_ERR_NVT_SITE3_COMB_TIMING_ERR_CNT_NVT_SITE3() uint32 {
	return volatile.LoadUint32(&o.COMB_PVT_ERR_NVT_SITE3.Reg) & 0xffff
}

// SYSTEM.COMB_PVT_ERR_HVT_SITE3: mem pvt register
func (o *SYSTEM_Type) SetCOMB_PVT_ERR_HVT_SITE3_COMB_TIMING_ERR_CNT_HVT_SITE3(value uint32) {
	volatile.StoreUint32(&o.COMB_PVT_ERR_HVT_SITE3.Reg, volatile.LoadUint32(&o.COMB_PVT_ERR_HVT_SITE3.Reg)&^(0xffff)|value)
}
func (o *SYSTEM_Type) GetCOMB_PVT_ERR_HVT_SITE3_COMB_TIMING_ERR_CNT_HVT_SITE3() uint32 {
	return volatile.LoadUint32(&o.COMB_PVT_ERR_HVT_SITE3.Reg) & 0xffff
}

// SYSTEM.SYSTEM_REG_DATE: Version register
func (o *SYSTEM_Type) SetSYSTEM_REG_DATE(value uint32) {
	volatile.StoreUint32(&o.SYSTEM_REG_DATE.Reg, volatile.LoadUint32(&o.SYSTEM_REG_DATE.Reg)&^(0xfffffff)|value)
}
func (o *SYSTEM_Type) GetSYSTEM_REG_DATE() uint32 {
	return volatile.LoadUint32(&o.SYSTEM_REG_DATE.Reg) & 0xfffffff
}

// Peripheral SYSTIMER
type SYSTIMER_Type struct {
	CONF           volatile.Register32 // 0x0
	UNIT0_OP       volatile.Register32 // 0x4
	UNIT1_OP       volatile.Register32 // 0x8
	UNIT0_LOAD_HI  volatile.Register32 // 0xC
	UNIT0_LOAD_LO  volatile.Register32 // 0x10
	UNIT1_LOAD_HI  volatile.Register32 // 0x14
	UNIT1_LOAD_LO  volatile.Register32 // 0x18
	TARGET0_HI     volatile.Register32 // 0x1C
	TARGET0_LO     volatile.Register32 // 0x20
	TARGET1_HI     volatile.Register32 // 0x24
	TARGET1_LO     volatile.Register32 // 0x28
	TARGET2_HI     volatile.Register32 // 0x2C
	TARGET2_LO     volatile.Register32 // 0x30
	TARGET0_CONF   volatile.Register32 // 0x34
	TARGET1_CONF   volatile.Register32 // 0x38
	TARGET2_CONF   volatile.Register32 // 0x3C
	UNIT0_VALUE_HI volatile.Register32 // 0x40
	UNIT0_VALUE_LO volatile.Register32 // 0x44
	UNIT1_VALUE_HI volatile.Register32 // 0x48
	UNIT1_VALUE_LO volatile.Register32 // 0x4C
	COMP0_LOAD     volatile.Register32 // 0x50
	COMP1_LOAD     volatile.Register32 // 0x54
	COMP2_LOAD     volatile.Register32 // 0x58
	UNIT0_LOAD     volatile.Register32 // 0x5C
	UNIT1_LOAD     volatile.Register32 // 0x60
	INT_ENA        volatile.Register32 // 0x64
	INT_RAW        volatile.Register32 // 0x68
	INT_CLR        volatile.Register32 // 0x6C
	INT_ST         volatile.Register32 // 0x70
	_              [136]byte
	DATE           volatile.Register32 // 0xFC
}

// SYSTIMER.CONF: SYSTIMER_CONF.
func (o *SYSTIMER_Type) SetCONF_SYSTIMER_CLK_FO(value uint32) {
	volatile.StoreUint32(&o.CONF.Reg, volatile.LoadUint32(&o.CONF.Reg)&^(0x1)|value)
}
func (o *SYSTIMER_Type) GetCONF_SYSTIMER_CLK_FO() uint32 {
	return volatile.LoadUint32(&o.CONF.Reg) & 0x1
}
func (o *SYSTIMER_Type) SetCONF_TARGET2_WORK_EN(value uint32) {
	volatile.StoreUint32(&o.CONF.Reg, volatile.LoadUint32(&o.CONF.Reg)&^(0x400000)|value<<22)
}
func (o *SYSTIMER_Type) GetCONF_TARGET2_WORK_EN() uint32 {
	return (volatile.LoadUint32(&o.CONF.Reg) & 0x400000) >> 22
}
func (o *SYSTIMER_Type) SetCONF_TARGET1_WORK_EN(value uint32) {
	volatile.StoreUint32(&o.CONF.Reg, volatile.LoadUint32(&o.CONF.Reg)&^(0x800000)|value<<23)
}
func (o *SYSTIMER_Type) GetCONF_TARGET1_WORK_EN() uint32 {
	return (volatile.LoadUint32(&o.CONF.Reg) & 0x800000) >> 23
}
func (o *SYSTIMER_Type) SetCONF_TARGET0_WORK_EN(value uint32) {
	volatile.StoreUint32(&o.CONF.Reg, volatile.LoadUint32(&o.CONF.Reg)&^(0x1000000)|value<<24)
}
func (o *SYSTIMER_Type) GetCONF_TARGET0_WORK_EN() uint32 {
	return (volatile.LoadUint32(&o.CONF.Reg) & 0x1000000) >> 24
}
func (o *SYSTIMER_Type) SetCONF_TIMER_UNIT1_CORE1_STALL_EN(value uint32) {
	volatile.StoreUint32(&o.CONF.Reg, volatile.LoadUint32(&o.CONF.Reg)&^(0x2000000)|value<<25)
}
func (o *SYSTIMER_Type) GetCONF_TIMER_UNIT1_CORE1_STALL_EN() uint32 {
	return (volatile.LoadUint32(&o.CONF.Reg) & 0x2000000) >> 25
}
func (o *SYSTIMER_Type) SetCONF_TIMER_UNIT1_CORE0_STALL_EN(value uint32) {
	volatile.StoreUint32(&o.CONF.Reg, volatile.LoadUint32(&o.CONF.Reg)&^(0x4000000)|value<<26)
}
func (o *SYSTIMER_Type) GetCONF_TIMER_UNIT1_CORE0_STALL_EN() uint32 {
	return (volatile.LoadUint32(&o.CONF.Reg) & 0x4000000) >> 26
}
func (o *SYSTIMER_Type) SetCONF_TIMER_UNIT0_CORE1_STALL_EN(value uint32) {
	volatile.StoreUint32(&o.CONF.Reg, volatile.LoadUint32(&o.CONF.Reg)&^(0x8000000)|value<<27)
}
func (o *SYSTIMER_Type) GetCONF_TIMER_UNIT0_CORE1_STALL_EN() uint32 {
	return (volatile.LoadUint32(&o.CONF.Reg) & 0x8000000) >> 27
}
func (o *SYSTIMER_Type) SetCONF_TIMER_UNIT0_CORE0_STALL_EN(value uint32) {
	volatile.StoreUint32(&o.CONF.Reg, volatile.LoadUint32(&o.CONF.Reg)&^(0x10000000)|value<<28)
}
func (o *SYSTIMER_Type) GetCONF_TIMER_UNIT0_CORE0_STALL_EN() uint32 {
	return (volatile.LoadUint32(&o.CONF.Reg) & 0x10000000) >> 28
}
func (o *SYSTIMER_Type) SetCONF_TIMER_UNIT1_WORK_EN(value uint32) {
	volatile.StoreUint32(&o.CONF.Reg, volatile.LoadUint32(&o.CONF.Reg)&^(0x20000000)|value<<29)
}
func (o *SYSTIMER_Type) GetCONF_TIMER_UNIT1_WORK_EN() uint32 {
	return (volatile.LoadUint32(&o.CONF.Reg) & 0x20000000) >> 29
}
func (o *SYSTIMER_Type) SetCONF_TIMER_UNIT0_WORK_EN(value uint32) {
	volatile.StoreUint32(&o.CONF.Reg, volatile.LoadUint32(&o.CONF.Reg)&^(0x40000000)|value<<30)
}
func (o *SYSTIMER_Type) GetCONF_TIMER_UNIT0_WORK_EN() uint32 {
	return (volatile.LoadUint32(&o.CONF.Reg) & 0x40000000) >> 30
}
func (o *SYSTIMER_Type) SetCONF_CLK_EN(value uint32) {
	volatile.StoreUint32(&o.CONF.Reg, volatile.LoadUint32(&o.CONF.Reg)&^(0x80000000)|value<<31)
}
func (o *SYSTIMER_Type) GetCONF_CLK_EN() uint32 {
	return (volatile.LoadUint32(&o.CONF.Reg) & 0x80000000) >> 31
}

// SYSTIMER.UNIT0_OP: SYSTIMER_UNIT0_OP.
func (o *SYSTIMER_Type) SetUNIT0_OP_TIMER_UNIT0_VALUE_VALID(value uint32) {
	volatile.StoreUint32(&o.UNIT0_OP.Reg, volatile.LoadUint32(&o.UNIT0_OP.Reg)&^(0x20000000)|value<<29)
}
func (o *SYSTIMER_Type) GetUNIT0_OP_TIMER_UNIT0_VALUE_VALID() uint32 {
	return (volatile.LoadUint32(&o.UNIT0_OP.Reg) & 0x20000000) >> 29
}
func (o *SYSTIMER_Type) SetUNIT0_OP_TIMER_UNIT0_UPDATE(value uint32) {
	volatile.StoreUint32(&o.UNIT0_OP.Reg, volatile.LoadUint32(&o.UNIT0_OP.Reg)&^(0x40000000)|value<<30)
}
func (o *SYSTIMER_Type) GetUNIT0_OP_TIMER_UNIT0_UPDATE() uint32 {
	return (volatile.LoadUint32(&o.UNIT0_OP.Reg) & 0x40000000) >> 30
}

// SYSTIMER.UNIT1_OP: SYSTIMER_UNIT1_OP.
func (o *SYSTIMER_Type) SetUNIT1_OP_TIMER_UNIT1_VALUE_VALID(value uint32) {
	volatile.StoreUint32(&o.UNIT1_OP.Reg, volatile.LoadUint32(&o.UNIT1_OP.Reg)&^(0x20000000)|value<<29)
}
func (o *SYSTIMER_Type) GetUNIT1_OP_TIMER_UNIT1_VALUE_VALID() uint32 {
	return (volatile.LoadUint32(&o.UNIT1_OP.Reg) & 0x20000000) >> 29
}
func (o *SYSTIMER_Type) SetUNIT1_OP_TIMER_UNIT1_UPDATE(value uint32) {
	volatile.StoreUint32(&o.UNIT1_OP.Reg, volatile.LoadUint32(&o.UNIT1_OP.Reg)&^(0x40000000)|value<<30)
}
func (o *SYSTIMER_Type) GetUNIT1_OP_TIMER_UNIT1_UPDATE() uint32 {
	return (volatile.LoadUint32(&o.UNIT1_OP.Reg) & 0x40000000) >> 30
}

// SYSTIMER.UNIT0_LOAD_HI: SYSTIMER_UNIT0_LOAD_HI.
func (o *SYSTIMER_Type) SetUNIT0_LOAD_HI_TIMER_UNIT0_LOAD_HI(value uint32) {
	volatile.StoreUint32(&o.UNIT0_LOAD_HI.Reg, volatile.LoadUint32(&o.UNIT0_LOAD_HI.Reg)&^(0xfffff)|value)
}
func (o *SYSTIMER_Type) GetUNIT0_LOAD_HI_TIMER_UNIT0_LOAD_HI() uint32 {
	return volatile.LoadUint32(&o.UNIT0_LOAD_HI.Reg) & 0xfffff
}

// SYSTIMER.UNIT0_LOAD_LO: SYSTIMER_UNIT0_LOAD_LO.
func (o *SYSTIMER_Type) SetUNIT0_LOAD_LO(value uint32) {
	volatile.StoreUint32(&o.UNIT0_LOAD_LO.Reg, value)
}
func (o *SYSTIMER_Type) GetUNIT0_LOAD_LO() uint32 {
	return volatile.LoadUint32(&o.UNIT0_LOAD_LO.Reg)
}

// SYSTIMER.UNIT1_LOAD_HI: SYSTIMER_UNIT1_LOAD_HI.
func (o *SYSTIMER_Type) SetUNIT1_LOAD_HI_TIMER_UNIT1_LOAD_HI(value uint32) {
	volatile.StoreUint32(&o.UNIT1_LOAD_HI.Reg, volatile.LoadUint32(&o.UNIT1_LOAD_HI.Reg)&^(0xfffff)|value)
}
func (o *SYSTIMER_Type) GetUNIT1_LOAD_HI_TIMER_UNIT1_LOAD_HI() uint32 {
	return volatile.LoadUint32(&o.UNIT1_LOAD_HI.Reg) & 0xfffff
}

// SYSTIMER.UNIT1_LOAD_LO: SYSTIMER_UNIT1_LOAD_LO.
func (o *SYSTIMER_Type) SetUNIT1_LOAD_LO(value uint32) {
	volatile.StoreUint32(&o.UNIT1_LOAD_LO.Reg, value)
}
func (o *SYSTIMER_Type) GetUNIT1_LOAD_LO() uint32 {
	return volatile.LoadUint32(&o.UNIT1_LOAD_LO.Reg)
}

// SYSTIMER.TARGET0_HI: SYSTIMER_TARGET0_HI.
func (o *SYSTIMER_Type) SetTARGET0_HI_TIMER_TARGET0_HI(value uint32) {
	volatile.StoreUint32(&o.TARGET0_HI.Reg, volatile.LoadUint32(&o.TARGET0_HI.Reg)&^(0xfffff)|value)
}
func (o *SYSTIMER_Type) GetTARGET0_HI_TIMER_TARGET0_HI() uint32 {
	return volatile.LoadUint32(&o.TARGET0_HI.Reg) & 0xfffff
}

// SYSTIMER.TARGET0_LO: SYSTIMER_TARGET0_LO.
func (o *SYSTIMER_Type) SetTARGET0_LO(value uint32) {
	volatile.StoreUint32(&o.TARGET0_LO.Reg, value)
}
func (o *SYSTIMER_Type) GetTARGET0_LO() uint32 {
	return volatile.LoadUint32(&o.TARGET0_LO.Reg)
}

// SYSTIMER.TARGET1_HI: SYSTIMER_TARGET1_HI.
func (o *SYSTIMER_Type) SetTARGET1_HI_TIMER_TARGET1_HI(value uint32) {
	volatile.StoreUint32(&o.TARGET1_HI.Reg, volatile.LoadUint32(&o.TARGET1_HI.Reg)&^(0xfffff)|value)
}
func (o *SYSTIMER_Type) GetTARGET1_HI_TIMER_TARGET1_HI() uint32 {
	return volatile.LoadUint32(&o.TARGET1_HI.Reg) & 0xfffff
}

// SYSTIMER.TARGET1_LO: SYSTIMER_TARGET1_LO.
func (o *SYSTIMER_Type) SetTARGET1_LO(value uint32) {
	volatile.StoreUint32(&o.TARGET1_LO.Reg, value)
}
func (o *SYSTIMER_Type) GetTARGET1_LO() uint32 {
	return volatile.LoadUint32(&o.TARGET1_LO.Reg)
}

// SYSTIMER.TARGET2_HI: SYSTIMER_TARGET2_HI.
func (o *SYSTIMER_Type) SetTARGET2_HI_TIMER_TARGET2_HI(value uint32) {
	volatile.StoreUint32(&o.TARGET2_HI.Reg, volatile.LoadUint32(&o.TARGET2_HI.Reg)&^(0xfffff)|value)
}
func (o *SYSTIMER_Type) GetTARGET2_HI_TIMER_TARGET2_HI() uint32 {
	return volatile.LoadUint32(&o.TARGET2_HI.Reg) & 0xfffff
}

// SYSTIMER.TARGET2_LO: SYSTIMER_TARGET2_LO.
func (o *SYSTIMER_Type) SetTARGET2_LO(value uint32) {
	volatile.StoreUint32(&o.TARGET2_LO.Reg, value)
}
func (o *SYSTIMER_Type) GetTARGET2_LO() uint32 {
	return volatile.LoadUint32(&o.TARGET2_LO.Reg)
}

// SYSTIMER.TARGET0_CONF: SYSTIMER_TARGET0_CONF.
func (o *SYSTIMER_Type) SetTARGET0_CONF_TARGET0_PERIOD(value uint32) {
	volatile.StoreUint32(&o.TARGET0_CONF.Reg, volatile.LoadUint32(&o.TARGET0_CONF.Reg)&^(0x3ffffff)|value)
}
func (o *SYSTIMER_Type) GetTARGET0_CONF_TARGET0_PERIOD() uint32 {
	return volatile.LoadUint32(&o.TARGET0_CONF.Reg) & 0x3ffffff
}
func (o *SYSTIMER_Type) SetTARGET0_CONF_TARGET0_PERIOD_MODE(value uint32) {
	volatile.StoreUint32(&o.TARGET0_CONF.Reg, volatile.LoadUint32(&o.TARGET0_CONF.Reg)&^(0x40000000)|value<<30)
}
func (o *SYSTIMER_Type) GetTARGET0_CONF_TARGET0_PERIOD_MODE() uint32 {
	return (volatile.LoadUint32(&o.TARGET0_CONF.Reg) & 0x40000000) >> 30
}
func (o *SYSTIMER_Type) SetTARGET0_CONF_TARGET0_TIMER_UNIT_SEL(value uint32) {
	volatile.StoreUint32(&o.TARGET0_CONF.Reg, volatile.LoadUint32(&o.TARGET0_CONF.Reg)&^(0x80000000)|value<<31)
}
func (o *SYSTIMER_Type) GetTARGET0_CONF_TARGET0_TIMER_UNIT_SEL() uint32 {
	return (volatile.LoadUint32(&o.TARGET0_CONF.Reg) & 0x80000000) >> 31
}

// SYSTIMER.TARGET1_CONF: SYSTIMER_TARGET1_CONF.
func (o *SYSTIMER_Type) SetTARGET1_CONF_TARGET1_PERIOD(value uint32) {
	volatile.StoreUint32(&o.TARGET1_CONF.Reg, volatile.LoadUint32(&o.TARGET1_CONF.Reg)&^(0x3ffffff)|value)
}
func (o *SYSTIMER_Type) GetTARGET1_CONF_TARGET1_PERIOD() uint32 {
	return volatile.LoadUint32(&o.TARGET1_CONF.Reg) & 0x3ffffff
}
func (o *SYSTIMER_Type) SetTARGET1_CONF_TARGET1_PERIOD_MODE(value uint32) {
	volatile.StoreUint32(&o.TARGET1_CONF.Reg, volatile.LoadUint32(&o.TARGET1_CONF.Reg)&^(0x40000000)|value<<30)
}
func (o *SYSTIMER_Type) GetTARGET1_CONF_TARGET1_PERIOD_MODE() uint32 {
	return (volatile.LoadUint32(&o.TARGET1_CONF.Reg) & 0x40000000) >> 30
}
func (o *SYSTIMER_Type) SetTARGET1_CONF_TARGET1_TIMER_UNIT_SEL(value uint32) {
	volatile.StoreUint32(&o.TARGET1_CONF.Reg, volatile.LoadUint32(&o.TARGET1_CONF.Reg)&^(0x80000000)|value<<31)
}
func (o *SYSTIMER_Type) GetTARGET1_CONF_TARGET1_TIMER_UNIT_SEL() uint32 {
	return (volatile.LoadUint32(&o.TARGET1_CONF.Reg) & 0x80000000) >> 31
}

// SYSTIMER.TARGET2_CONF: SYSTIMER_TARGET2_CONF.
func (o *SYSTIMER_Type) SetTARGET2_CONF_TARGET2_PERIOD(value uint32) {
	volatile.StoreUint32(&o.TARGET2_CONF.Reg, volatile.LoadUint32(&o.TARGET2_CONF.Reg)&^(0x3ffffff)|value)
}
func (o *SYSTIMER_Type) GetTARGET2_CONF_TARGET2_PERIOD() uint32 {
	return volatile.LoadUint32(&o.TARGET2_CONF.Reg) & 0x3ffffff
}
func (o *SYSTIMER_Type) SetTARGET2_CONF_TARGET2_PERIOD_MODE(value uint32) {
	volatile.StoreUint32(&o.TARGET2_CONF.Reg, volatile.LoadUint32(&o.TARGET2_CONF.Reg)&^(0x40000000)|value<<30)
}
func (o *SYSTIMER_Type) GetTARGET2_CONF_TARGET2_PERIOD_MODE() uint32 {
	return (volatile.LoadUint32(&o.TARGET2_CONF.Reg) & 0x40000000) >> 30
}
func (o *SYSTIMER_Type) SetTARGET2_CONF_TARGET2_TIMER_UNIT_SEL(value uint32) {
	volatile.StoreUint32(&o.TARGET2_CONF.Reg, volatile.LoadUint32(&o.TARGET2_CONF.Reg)&^(0x80000000)|value<<31)
}
func (o *SYSTIMER_Type) GetTARGET2_CONF_TARGET2_TIMER_UNIT_SEL() uint32 {
	return (volatile.LoadUint32(&o.TARGET2_CONF.Reg) & 0x80000000) >> 31
}

// SYSTIMER.UNIT0_VALUE_HI: SYSTIMER_UNIT0_VALUE_HI.
func (o *SYSTIMER_Type) SetUNIT0_VALUE_HI_TIMER_UNIT0_VALUE_HI(value uint32) {
	volatile.StoreUint32(&o.UNIT0_VALUE_HI.Reg, volatile.LoadUint32(&o.UNIT0_VALUE_HI.Reg)&^(0xfffff)|value)
}
func (o *SYSTIMER_Type) GetUNIT0_VALUE_HI_TIMER_UNIT0_VALUE_HI() uint32 {
	return volatile.LoadUint32(&o.UNIT0_VALUE_HI.Reg) & 0xfffff
}

// SYSTIMER.UNIT0_VALUE_LO: SYSTIMER_UNIT0_VALUE_LO.
func (o *SYSTIMER_Type) SetUNIT0_VALUE_LO(value uint32) {
	volatile.StoreUint32(&o.UNIT0_VALUE_LO.Reg, value)
}
func (o *SYSTIMER_Type) GetUNIT0_VALUE_LO() uint32 {
	return volatile.LoadUint32(&o.UNIT0_VALUE_LO.Reg)
}

// SYSTIMER.UNIT1_VALUE_HI: SYSTIMER_UNIT1_VALUE_HI.
func (o *SYSTIMER_Type) SetUNIT1_VALUE_HI_TIMER_UNIT1_VALUE_HI(value uint32) {
	volatile.StoreUint32(&o.UNIT1_VALUE_HI.Reg, volatile.LoadUint32(&o.UNIT1_VALUE_HI.Reg)&^(0xfffff)|value)
}
func (o *SYSTIMER_Type) GetUNIT1_VALUE_HI_TIMER_UNIT1_VALUE_HI() uint32 {
	return volatile.LoadUint32(&o.UNIT1_VALUE_HI.Reg) & 0xfffff
}

// SYSTIMER.UNIT1_VALUE_LO: SYSTIMER_UNIT1_VALUE_LO.
func (o *SYSTIMER_Type) SetUNIT1_VALUE_LO(value uint32) {
	volatile.StoreUint32(&o.UNIT1_VALUE_LO.Reg, value)
}
func (o *SYSTIMER_Type) GetUNIT1_VALUE_LO() uint32 {
	return volatile.LoadUint32(&o.UNIT1_VALUE_LO.Reg)
}

// SYSTIMER.COMP0_LOAD: SYSTIMER_COMP0_LOAD.
func (o *SYSTIMER_Type) SetCOMP0_LOAD_TIMER_COMP0_LOAD(value uint32) {
	volatile.StoreUint32(&o.COMP0_LOAD.Reg, volatile.LoadUint32(&o.COMP0_LOAD.Reg)&^(0x1)|value)
}
func (o *SYSTIMER_Type) GetCOMP0_LOAD_TIMER_COMP0_LOAD() uint32 {
	return volatile.LoadUint32(&o.COMP0_LOAD.Reg) & 0x1
}

// SYSTIMER.COMP1_LOAD: SYSTIMER_COMP1_LOAD.
func (o *SYSTIMER_Type) SetCOMP1_LOAD_TIMER_COMP1_LOAD(value uint32) {
	volatile.StoreUint32(&o.COMP1_LOAD.Reg, volatile.LoadUint32(&o.COMP1_LOAD.Reg)&^(0x1)|value)
}
func (o *SYSTIMER_Type) GetCOMP1_LOAD_TIMER_COMP1_LOAD() uint32 {
	return volatile.LoadUint32(&o.COMP1_LOAD.Reg) & 0x1
}

// SYSTIMER.COMP2_LOAD: SYSTIMER_COMP2_LOAD.
func (o *SYSTIMER_Type) SetCOMP2_LOAD_TIMER_COMP2_LOAD(value uint32) {
	volatile.StoreUint32(&o.COMP2_LOAD.Reg, volatile.LoadUint32(&o.COMP2_LOAD.Reg)&^(0x1)|value)
}
func (o *SYSTIMER_Type) GetCOMP2_LOAD_TIMER_COMP2_LOAD() uint32 {
	return volatile.LoadUint32(&o.COMP2_LOAD.Reg) & 0x1
}

// SYSTIMER.UNIT0_LOAD: SYSTIMER_UNIT0_LOAD.
func (o *SYSTIMER_Type) SetUNIT0_LOAD_TIMER_UNIT0_LOAD(value uint32) {
	volatile.StoreUint32(&o.UNIT0_LOAD.Reg, volatile.LoadUint32(&o.UNIT0_LOAD.Reg)&^(0x1)|value)
}
func (o *SYSTIMER_Type) GetUNIT0_LOAD_TIMER_UNIT0_LOAD() uint32 {
	return volatile.LoadUint32(&o.UNIT0_LOAD.Reg) & 0x1
}

// SYSTIMER.UNIT1_LOAD: SYSTIMER_UNIT1_LOAD.
func (o *SYSTIMER_Type) SetUNIT1_LOAD_TIMER_UNIT1_LOAD(value uint32) {
	volatile.StoreUint32(&o.UNIT1_LOAD.Reg, volatile.LoadUint32(&o.UNIT1_LOAD.Reg)&^(0x1)|value)
}
func (o *SYSTIMER_Type) GetUNIT1_LOAD_TIMER_UNIT1_LOAD() uint32 {
	return volatile.LoadUint32(&o.UNIT1_LOAD.Reg) & 0x1
}

// SYSTIMER.INT_ENA: SYSTIMER_INT_ENA.
func (o *SYSTIMER_Type) SetINT_ENA_TARGET0_INT_ENA(value uint32) {
	volatile.StoreUint32(&o.INT_ENA.Reg, volatile.LoadUint32(&o.INT_ENA.Reg)&^(0x1)|value)
}
func (o *SYSTIMER_Type) GetINT_ENA_TARGET0_INT_ENA() uint32 {
	return volatile.LoadUint32(&o.INT_ENA.Reg) & 0x1
}
func (o *SYSTIMER_Type) SetINT_ENA_TARGET1_INT_ENA(value uint32) {
	volatile.StoreUint32(&o.INT_ENA.Reg, volatile.LoadUint32(&o.INT_ENA.Reg)&^(0x2)|value<<1)
}
func (o *SYSTIMER_Type) GetINT_ENA_TARGET1_INT_ENA() uint32 {
	return (volatile.LoadUint32(&o.INT_ENA.Reg) & 0x2) >> 1
}
func (o *SYSTIMER_Type) SetINT_ENA_TARGET2_INT_ENA(value uint32) {
	volatile.StoreUint32(&o.INT_ENA.Reg, volatile.LoadUint32(&o.INT_ENA.Reg)&^(0x4)|value<<2)
}
func (o *SYSTIMER_Type) GetINT_ENA_TARGET2_INT_ENA() uint32 {
	return (volatile.LoadUint32(&o.INT_ENA.Reg) & 0x4) >> 2
}

// SYSTIMER.INT_RAW: SYSTIMER_INT_RAW.
func (o *SYSTIMER_Type) SetINT_RAW_TARGET0_INT_RAW(value uint32) {
	volatile.StoreUint32(&o.INT_RAW.Reg, volatile.LoadUint32(&o.INT_RAW.Reg)&^(0x1)|value)
}
func (o *SYSTIMER_Type) GetINT_RAW_TARGET0_INT_RAW() uint32 {
	return volatile.LoadUint32(&o.INT_RAW.Reg) & 0x1
}
func (o *SYSTIMER_Type) SetINT_RAW_TARGET1_INT_RAW(value uint32) {
	volatile.StoreUint32(&o.INT_RAW.Reg, volatile.LoadUint32(&o.INT_RAW.Reg)&^(0x2)|value<<1)
}
func (o *SYSTIMER_Type) GetINT_RAW_TARGET1_INT_RAW() uint32 {
	return (volatile.LoadUint32(&o.INT_RAW.Reg) & 0x2) >> 1
}
func (o *SYSTIMER_Type) SetINT_RAW_TARGET2_INT_RAW(value uint32) {
	volatile.StoreUint32(&o.INT_RAW.Reg, volatile.LoadUint32(&o.INT_RAW.Reg)&^(0x4)|value<<2)
}
func (o *SYSTIMER_Type) GetINT_RAW_TARGET2_INT_RAW() uint32 {
	return (volatile.LoadUint32(&o.INT_RAW.Reg) & 0x4) >> 2
}

// SYSTIMER.INT_CLR: SYSTIMER_INT_CLR.
func (o *SYSTIMER_Type) SetINT_CLR_TARGET0_INT_CLR(value uint32) {
	volatile.StoreUint32(&o.INT_CLR.Reg, volatile.LoadUint32(&o.INT_CLR.Reg)&^(0x1)|value)
}
func (o *SYSTIMER_Type) GetINT_CLR_TARGET0_INT_CLR() uint32 {
	return volatile.LoadUint32(&o.INT_CLR.Reg) & 0x1
}
func (o *SYSTIMER_Type) SetINT_CLR_TARGET1_INT_CLR(value uint32) {
	volatile.StoreUint32(&o.INT_CLR.Reg, volatile.LoadUint32(&o.INT_CLR.Reg)&^(0x2)|value<<1)
}
func (o *SYSTIMER_Type) GetINT_CLR_TARGET1_INT_CLR() uint32 {
	return (volatile.LoadUint32(&o.INT_CLR.Reg) & 0x2) >> 1
}
func (o *SYSTIMER_Type) SetINT_CLR_TARGET2_INT_CLR(value uint32) {
	volatile.StoreUint32(&o.INT_CLR.Reg, volatile.LoadUint32(&o.INT_CLR.Reg)&^(0x4)|value<<2)
}
func (o *SYSTIMER_Type) GetINT_CLR_TARGET2_INT_CLR() uint32 {
	return (volatile.LoadUint32(&o.INT_CLR.Reg) & 0x4) >> 2
}

// SYSTIMER.INT_ST: SYSTIMER_INT_ST.
func (o *SYSTIMER_Type) SetINT_ST_TARGET0_INT_ST(value uint32) {
	volatile.StoreUint32(&o.INT_ST.Reg, volatile.LoadUint32(&o.INT_ST.Reg)&^(0x1)|value)
}
func (o *SYSTIMER_Type) GetINT_ST_TARGET0_INT_ST() uint32 {
	return volatile.LoadUint32(&o.INT_ST.Reg) & 0x1
}
func (o *SYSTIMER_Type) SetINT_ST_TARGET1_INT_ST(value uint32) {
	volatile.StoreUint32(&o.INT_ST.Reg, volatile.LoadUint32(&o.INT_ST.Reg)&^(0x2)|value<<1)
}
func (o *SYSTIMER_Type) GetINT_ST_TARGET1_INT_ST() uint32 {
	return (volatile.LoadUint32(&o.INT_ST.Reg) & 0x2) >> 1
}
func (o *SYSTIMER_Type) SetINT_ST_TARGET2_INT_ST(value uint32) {
	volatile.StoreUint32(&o.INT_ST.Reg, volatile.LoadUint32(&o.INT_ST.Reg)&^(0x4)|value<<2)
}
func (o *SYSTIMER_Type) GetINT_ST_TARGET2_INT_ST() uint32 {
	return (volatile.LoadUint32(&o.INT_ST.Reg) & 0x4) >> 2
}

// SYSTIMER.DATE: SYSTIMER_DATE.
func (o *SYSTIMER_Type) SetDATE(value uint32) {
	volatile.StoreUint32(&o.DATE.Reg, value)
}
func (o *SYSTIMER_Type) GetDATE() uint32 {
	return volatile.LoadUint32(&o.DATE.Reg)
}

// Peripheral TIMG
type TIMG_Type struct {
	T0CONFIG     volatile.Register32 // 0x0
	T0LO         volatile.Register32 // 0x4
	T0HI         volatile.Register32 // 0x8
	T0UPDATE     volatile.Register32 // 0xC
	T0ALARMLO    volatile.Register32 // 0x10
	T0ALARMHI    volatile.Register32 // 0x14
	T0LOADLO     volatile.Register32 // 0x18
	T0LOADHI     volatile.Register32 // 0x1C
	T0LOAD       volatile.Register32 // 0x20
	_            [36]byte
	WDTCONFIG0   volatile.Register32 // 0x48
	WDTCONFIG1   volatile.Register32 // 0x4C
	WDTCONFIG2   volatile.Register32 // 0x50
	WDTCONFIG3   volatile.Register32 // 0x54
	WDTCONFIG4   volatile.Register32 // 0x58
	WDTCONFIG5   volatile.Register32 // 0x5C
	WDTFEED      volatile.Register32 // 0x60
	WDTWPROTECT  volatile.Register32 // 0x64
	RTCCALICFG   volatile.Register32 // 0x68
	RTCCALICFG1  volatile.Register32 // 0x6C
	INT_ENA_TIMG volatile.Register32 // 0x70
	INT_RAW_TIMG volatile.Register32 // 0x74
	INT_ST_TIMG  volatile.Register32 // 0x78
	INT_CLR_TIMG volatile.Register32 // 0x7C
	RTCCALICFG2  volatile.Register32 // 0x80
	_            [116]byte
	NTIMG_DATE   volatile.Register32 // 0xF8
	REGCLK       volatile.Register32 // 0xFC
}

// TIMG.T0CONFIG: TIMG_T0CONFIG_REG.
func (o *TIMG_Type) SetT0CONFIG_T0_USE_XTAL(value uint32) {
	volatile.StoreUint32(&o.T0CONFIG.Reg, volatile.LoadUint32(&o.T0CONFIG.Reg)&^(0x200)|value<<9)
}
func (o *TIMG_Type) GetT0CONFIG_T0_USE_XTAL() uint32 {
	return (volatile.LoadUint32(&o.T0CONFIG.Reg) & 0x200) >> 9
}
func (o *TIMG_Type) SetT0CONFIG_T0_ALARM_EN(value uint32) {
	volatile.StoreUint32(&o.T0CONFIG.Reg, volatile.LoadUint32(&o.T0CONFIG.Reg)&^(0x400)|value<<10)
}
func (o *TIMG_Type) GetT0CONFIG_T0_ALARM_EN() uint32 {
	return (volatile.LoadUint32(&o.T0CONFIG.Reg) & 0x400) >> 10
}
func (o *TIMG_Type) SetT0CONFIG_T0_DIVCNT_RST(value uint32) {
	volatile.StoreUint32(&o.T0CONFIG.Reg, volatile.LoadUint32(&o.T0CONFIG.Reg)&^(0x1000)|value<<12)
}
func (o *TIMG_Type) GetT0CONFIG_T0_DIVCNT_RST() uint32 {
	return (volatile.LoadUint32(&o.T0CONFIG.Reg) & 0x1000) >> 12
}
func (o *TIMG_Type) SetT0CONFIG_T0_DIVIDER(value uint32) {
	volatile.StoreUint32(&o.T0CONFIG.Reg, volatile.LoadUint32(&o.T0CONFIG.Reg)&^(0x1fffe000)|value<<13)
}
func (o *TIMG_Type) GetT0CONFIG_T0_DIVIDER() uint32 {
	return (volatile.LoadUint32(&o.T0CONFIG.Reg) & 0x1fffe000) >> 13
}
func (o *TIMG_Type) SetT0CONFIG_T0_AUTORELOAD(value uint32) {
	volatile.StoreUint32(&o.T0CONFIG.Reg, volatile.LoadUint32(&o.T0CONFIG.Reg)&^(0x20000000)|value<<29)
}
func (o *TIMG_Type) GetT0CONFIG_T0_AUTORELOAD() uint32 {
	return (volatile.LoadUint32(&o.T0CONFIG.Reg) & 0x20000000) >> 29
}
func (o *TIMG_Type) SetT0CONFIG_T0_INCREASE(value uint32) {
	volatile.StoreUint32(&o.T0CONFIG.Reg, volatile.LoadUint32(&o.T0CONFIG.Reg)&^(0x40000000)|value<<30)
}
func (o *TIMG_Type) GetT0CONFIG_T0_INCREASE() uint32 {
	return (volatile.LoadUint32(&o.T0CONFIG.Reg) & 0x40000000) >> 30
}
func (o *TIMG_Type) SetT0CONFIG_T0_EN(value uint32) {
	volatile.StoreUint32(&o.T0CONFIG.Reg, volatile.LoadUint32(&o.T0CONFIG.Reg)&^(0x80000000)|value<<31)
}
func (o *TIMG_Type) GetT0CONFIG_T0_EN() uint32 {
	return (volatile.LoadUint32(&o.T0CONFIG.Reg) & 0x80000000) >> 31
}

// TIMG.T0LO: TIMG_T0LO_REG.
func (o *TIMG_Type) SetT0LO(value uint32) {
	volatile.StoreUint32(&o.T0LO.Reg, value)
}
func (o *TIMG_Type) GetT0LO() uint32 {
	return volatile.LoadUint32(&o.T0LO.Reg)
}

// TIMG.T0HI: TIMG_T0HI_REG.
func (o *TIMG_Type) SetT0HI_T0_HI(value uint32) {
	volatile.StoreUint32(&o.T0HI.Reg, volatile.LoadUint32(&o.T0HI.Reg)&^(0x3fffff)|value)
}
func (o *TIMG_Type) GetT0HI_T0_HI() uint32 {
	return volatile.LoadUint32(&o.T0HI.Reg) & 0x3fffff
}

// TIMG.T0UPDATE: TIMG_T0UPDATE_REG.
func (o *TIMG_Type) SetT0UPDATE_T0_UPDATE(value uint32) {
	volatile.StoreUint32(&o.T0UPDATE.Reg, volatile.LoadUint32(&o.T0UPDATE.Reg)&^(0x80000000)|value<<31)
}
func (o *TIMG_Type) GetT0UPDATE_T0_UPDATE() uint32 {
	return (volatile.LoadUint32(&o.T0UPDATE.Reg) & 0x80000000) >> 31
}

// TIMG.T0ALARMLO: TIMG_T0ALARMLO_REG.
func (o *TIMG_Type) SetT0ALARMLO(value uint32) {
	volatile.StoreUint32(&o.T0ALARMLO.Reg, value)
}
func (o *TIMG_Type) GetT0ALARMLO() uint32 {
	return volatile.LoadUint32(&o.T0ALARMLO.Reg)
}

// TIMG.T0ALARMHI: TIMG_T0ALARMHI_REG.
func (o *TIMG_Type) SetT0ALARMHI_T0_ALARM_HI(value uint32) {
	volatile.StoreUint32(&o.T0ALARMHI.Reg, volatile.LoadUint32(&o.T0ALARMHI.Reg)&^(0x3fffff)|value)
}
func (o *TIMG_Type) GetT0ALARMHI_T0_ALARM_HI() uint32 {
	return volatile.LoadUint32(&o.T0ALARMHI.Reg) & 0x3fffff
}

// TIMG.T0LOADLO: TIMG_T0LOADLO_REG.
func (o *TIMG_Type) SetT0LOADLO(value uint32) {
	volatile.StoreUint32(&o.T0LOADLO.Reg, value)
}
func (o *TIMG_Type) GetT0LOADLO() uint32 {
	return volatile.LoadUint32(&o.T0LOADLO.Reg)
}

// TIMG.T0LOADHI: TIMG_T0LOADHI_REG.
func (o *TIMG_Type) SetT0LOADHI_T0_LOAD_HI(value uint32) {
	volatile.StoreUint32(&o.T0LOADHI.Reg, volatile.LoadUint32(&o.T0LOADHI.Reg)&^(0x3fffff)|value)
}
func (o *TIMG_Type) GetT0LOADHI_T0_LOAD_HI() uint32 {
	return volatile.LoadUint32(&o.T0LOADHI.Reg) & 0x3fffff
}

// TIMG.T0LOAD: TIMG_T0LOAD_REG.
func (o *TIMG_Type) SetT0LOAD(value uint32) {
	volatile.StoreUint32(&o.T0LOAD.Reg, value)
}
func (o *TIMG_Type) GetT0LOAD() uint32 {
	return volatile.LoadUint32(&o.T0LOAD.Reg)
}

// TIMG.WDTCONFIG0: TIMG_WDTCONFIG0_REG.
func (o *TIMG_Type) SetWDTCONFIG0_WDT_APPCPU_RESET_EN(value uint32) {
	volatile.StoreUint32(&o.WDTCONFIG0.Reg, volatile.LoadUint32(&o.WDTCONFIG0.Reg)&^(0x1000)|value<<12)
}
func (o *TIMG_Type) GetWDTCONFIG0_WDT_APPCPU_RESET_EN() uint32 {
	return (volatile.LoadUint32(&o.WDTCONFIG0.Reg) & 0x1000) >> 12
}
func (o *TIMG_Type) SetWDTCONFIG0_WDT_PROCPU_RESET_EN(value uint32) {
	volatile.StoreUint32(&o.WDTCONFIG0.Reg, volatile.LoadUint32(&o.WDTCONFIG0.Reg)&^(0x2000)|value<<13)
}
func (o *TIMG_Type) GetWDTCONFIG0_WDT_PROCPU_RESET_EN() uint32 {
	return (volatile.LoadUint32(&o.WDTCONFIG0.Reg) & 0x2000) >> 13
}
func (o *TIMG_Type) SetWDTCONFIG0_WDT_FLASHBOOT_MOD_EN(value uint32) {
	volatile.StoreUint32(&o.WDTCONFIG0.Reg, volatile.LoadUint32(&o.WDTCONFIG0.Reg)&^(0x4000)|value<<14)
}
func (o *TIMG_Type) GetWDTCONFIG0_WDT_FLASHBOOT_MOD_EN() uint32 {
	return (volatile.LoadUint32(&o.WDTCONFIG0.Reg) & 0x4000) >> 14
}
func (o *TIMG_Type) SetWDTCONFIG0_WDT_SYS_RESET_LENGTH(value uint32) {
	volatile.StoreUint32(&o.WDTCONFIG0.Reg, volatile.LoadUint32(&o.WDTCONFIG0.Reg)&^(0x38000)|value<<15)
}
func (o *TIMG_Type) GetWDTCONFIG0_WDT_SYS_RESET_LENGTH() uint32 {
	return (volatile.LoadUint32(&o.WDTCONFIG0.Reg) & 0x38000) >> 15
}
func (o *TIMG_Type) SetWDTCONFIG0_WDT_CPU_RESET_LENGTH(value uint32) {
	volatile.StoreUint32(&o.WDTCONFIG0.Reg, volatile.LoadUint32(&o.WDTCONFIG0.Reg)&^(0x1c0000)|value<<18)
}
func (o *TIMG_Type) GetWDTCONFIG0_WDT_CPU_RESET_LENGTH() uint32 {
	return (volatile.LoadUint32(&o.WDTCONFIG0.Reg) & 0x1c0000) >> 18
}
func (o *TIMG_Type) SetWDTCONFIG0_WDT_USE_XTAL(value uint32) {
	volatile.StoreUint32(&o.WDTCONFIG0.Reg, volatile.LoadUint32(&o.WDTCONFIG0.Reg)&^(0x200000)|value<<21)
}
func (o *TIMG_Type) GetWDTCONFIG0_WDT_USE_XTAL() uint32 {
	return (volatile.LoadUint32(&o.WDTCONFIG0.Reg) & 0x200000) >> 21
}
func (o *TIMG_Type) SetWDTCONFIG0_WDT_CONF_UPDATE_EN(value uint32) {
	volatile.StoreUint32(&o.WDTCONFIG0.Reg, volatile.LoadUint32(&o.WDTCONFIG0.Reg)&^(0x400000)|value<<22)
}
func (o *TIMG_Type) GetWDTCONFIG0_WDT_CONF_UPDATE_EN() uint32 {
	return (volatile.LoadUint32(&o.WDTCONFIG0.Reg) & 0x400000) >> 22
}
func (o *TIMG_Type) SetWDTCONFIG0_WDT_STG3(value uint32) {
	volatile.StoreUint32(&o.WDTCONFIG0.Reg, volatile.LoadUint32(&o.WDTCONFIG0.Reg)&^(0x1800000)|value<<23)
}
func (o *TIMG_Type) GetWDTCONFIG0_WDT_STG3() uint32 {
	return (volatile.LoadUint32(&o.WDTCONFIG0.Reg) & 0x1800000) >> 23
}
func (o *TIMG_Type) SetWDTCONFIG0_WDT_STG2(value uint32) {
	volatile.StoreUint32(&o.WDTCONFIG0.Reg, volatile.LoadUint32(&o.WDTCONFIG0.Reg)&^(0x6000000)|value<<25)
}
func (o *TIMG_Type) GetWDTCONFIG0_WDT_STG2() uint32 {
	return (volatile.LoadUint32(&o.WDTCONFIG0.Reg) & 0x6000000) >> 25
}
func (o *TIMG_Type) SetWDTCONFIG0_WDT_STG1(value uint32) {
	volatile.StoreUint32(&o.WDTCONFIG0.Reg, volatile.LoadUint32(&o.WDTCONFIG0.Reg)&^(0x18000000)|value<<27)
}
func (o *TIMG_Type) GetWDTCONFIG0_WDT_STG1() uint32 {
	return (volatile.LoadUint32(&o.WDTCONFIG0.Reg) & 0x18000000) >> 27
}
func (o *TIMG_Type) SetWDTCONFIG0_WDT_STG0(value uint32) {
	volatile.StoreUint32(&o.WDTCONFIG0.Reg, volatile.LoadUint32(&o.WDTCONFIG0.Reg)&^(0x60000000)|value<<29)
}
func (o *TIMG_Type) GetWDTCONFIG0_WDT_STG0() uint32 {
	return (volatile.LoadUint32(&o.WDTCONFIG0.Reg) & 0x60000000) >> 29
}
func (o *TIMG_Type) SetWDTCONFIG0_WDT_EN(value uint32) {
	volatile.StoreUint32(&o.WDTCONFIG0.Reg, volatile.LoadUint32(&o.WDTCONFIG0.Reg)&^(0x80000000)|value<<31)
}
func (o *TIMG_Type) GetWDTCONFIG0_WDT_EN() uint32 {
	return (volatile.LoadUint32(&o.WDTCONFIG0.Reg) & 0x80000000) >> 31
}

// TIMG.WDTCONFIG1: TIMG_WDTCONFIG1_REG.
func (o *TIMG_Type) SetWDTCONFIG1_WDT_DIVCNT_RST(value uint32) {
	volatile.StoreUint32(&o.WDTCONFIG1.Reg, volatile.LoadUint32(&o.WDTCONFIG1.Reg)&^(0x1)|value)
}
func (o *TIMG_Type) GetWDTCONFIG1_WDT_DIVCNT_RST() uint32 {
	return volatile.LoadUint32(&o.WDTCONFIG1.Reg) & 0x1
}
func (o *TIMG_Type) SetWDTCONFIG1_WDT_CLK_PRESCALE(value uint32) {
	volatile.StoreUint32(&o.WDTCONFIG1.Reg, volatile.LoadUint32(&o.WDTCONFIG1.Reg)&^(0xffff0000)|value<<16)
}
func (o *TIMG_Type) GetWDTCONFIG1_WDT_CLK_PRESCALE() uint32 {
	return (volatile.LoadUint32(&o.WDTCONFIG1.Reg) & 0xffff0000) >> 16
}

// TIMG.WDTCONFIG2: TIMG_WDTCONFIG2_REG.
func (o *TIMG_Type) SetWDTCONFIG2(value uint32) {
	volatile.StoreUint32(&o.WDTCONFIG2.Reg, value)
}
func (o *TIMG_Type) GetWDTCONFIG2() uint32 {
	return volatile.LoadUint32(&o.WDTCONFIG2.Reg)
}

// TIMG.WDTCONFIG3: TIMG_WDTCONFIG3_REG.
func (o *TIMG_Type) SetWDTCONFIG3(value uint32) {
	volatile.StoreUint32(&o.WDTCONFIG3.Reg, value)
}
func (o *TIMG_Type) GetWDTCONFIG3() uint32 {
	return volatile.LoadUint32(&o.WDTCONFIG3.Reg)
}

// TIMG.WDTCONFIG4: TIMG_WDTCONFIG4_REG.
func (o *TIMG_Type) SetWDTCONFIG4(value uint32) {
	volatile.StoreUint32(&o.WDTCONFIG4.Reg, value)
}
func (o *TIMG_Type) GetWDTCONFIG4() uint32 {
	return volatile.LoadUint32(&o.WDTCONFIG4.Reg)
}

// TIMG.WDTCONFIG5: TIMG_WDTCONFIG5_REG.
func (o *TIMG_Type) SetWDTCONFIG5(value uint32) {
	volatile.StoreUint32(&o.WDTCONFIG5.Reg, value)
}
func (o *TIMG_Type) GetWDTCONFIG5() uint32 {
	return volatile.LoadUint32(&o.WDTCONFIG5.Reg)
}

// TIMG.WDTFEED: TIMG_WDTFEED_REG.
func (o *TIMG_Type) SetWDTFEED(value uint32) {
	volatile.StoreUint32(&o.WDTFEED.Reg, value)
}
func (o *TIMG_Type) GetWDTFEED() uint32 {
	return volatile.LoadUint32(&o.WDTFEED.Reg)
}

// TIMG.WDTWPROTECT: TIMG_WDTWPROTECT_REG.
func (o *TIMG_Type) SetWDTWPROTECT(value uint32) {
	volatile.StoreUint32(&o.WDTWPROTECT.Reg, value)
}
func (o *TIMG_Type) GetWDTWPROTECT() uint32 {
	return volatile.LoadUint32(&o.WDTWPROTECT.Reg)
}

// TIMG.RTCCALICFG: TIMG_RTCCALICFG_REG.
func (o *TIMG_Type) SetRTCCALICFG_RTC_CALI_START_CYCLING(value uint32) {
	volatile.StoreUint32(&o.RTCCALICFG.Reg, volatile.LoadUint32(&o.RTCCALICFG.Reg)&^(0x1000)|value<<12)
}
func (o *TIMG_Type) GetRTCCALICFG_RTC_CALI_START_CYCLING() uint32 {
	return (volatile.LoadUint32(&o.RTCCALICFG.Reg) & 0x1000) >> 12
}
func (o *TIMG_Type) SetRTCCALICFG_RTC_CALI_CLK_SEL(value uint32) {
	volatile.StoreUint32(&o.RTCCALICFG.Reg, volatile.LoadUint32(&o.RTCCALICFG.Reg)&^(0x6000)|value<<13)
}
func (o *TIMG_Type) GetRTCCALICFG_RTC_CALI_CLK_SEL() uint32 {
	return (volatile.LoadUint32(&o.RTCCALICFG.Reg) & 0x6000) >> 13
}
func (o *TIMG_Type) SetRTCCALICFG_RTC_CALI_RDY(value uint32) {
	volatile.StoreUint32(&o.RTCCALICFG.Reg, volatile.LoadUint32(&o.RTCCALICFG.Reg)&^(0x8000)|value<<15)
}
func (o *TIMG_Type) GetRTCCALICFG_RTC_CALI_RDY() uint32 {
	return (volatile.LoadUint32(&o.RTCCALICFG.Reg) & 0x8000) >> 15
}
func (o *TIMG_Type) SetRTCCALICFG_RTC_CALI_MAX(value uint32) {
	volatile.StoreUint32(&o.RTCCALICFG.Reg, volatile.LoadUint32(&o.RTCCALICFG.Reg)&^(0x7fff0000)|value<<16)
}
func (o *TIMG_Type) GetRTCCALICFG_RTC_CALI_MAX() uint32 {
	return (volatile.LoadUint32(&o.RTCCALICFG.Reg) & 0x7fff0000) >> 16
}
func (o *TIMG_Type) SetRTCCALICFG_RTC_CALI_START(value uint32) {
	volatile.StoreUint32(&o.RTCCALICFG.Reg, volatile.LoadUint32(&o.RTCCALICFG.Reg)&^(0x80000000)|value<<31)
}
func (o *TIMG_Type) GetRTCCALICFG_RTC_CALI_START() uint32 {
	return (volatile.LoadUint32(&o.RTCCALICFG.Reg) & 0x80000000) >> 31
}

// TIMG.RTCCALICFG1: TIMG_RTCCALICFG1_REG.
func (o *TIMG_Type) SetRTCCALICFG1_RTC_CALI_CYCLING_DATA_VLD(value uint32) {
	volatile.StoreUint32(&o.RTCCALICFG1.Reg, volatile.LoadUint32(&o.RTCCALICFG1.Reg)&^(0x1)|value)
}
func (o *TIMG_Type) GetRTCCALICFG1_RTC_CALI_CYCLING_DATA_VLD() uint32 {
	return volatile.LoadUint32(&o.RTCCALICFG1.Reg) & 0x1
}
func (o *TIMG_Type) SetRTCCALICFG1_RTC_CALI_VALUE(value uint32) {
	volatile.StoreUint32(&o.RTCCALICFG1.Reg, volatile.LoadUint32(&o.RTCCALICFG1.Reg)&^(0xffffff80)|value<<7)
}
func (o *TIMG_Type) GetRTCCALICFG1_RTC_CALI_VALUE() uint32 {
	return (volatile.LoadUint32(&o.RTCCALICFG1.Reg) & 0xffffff80) >> 7
}

// TIMG.INT_ENA_TIMG: INT_ENA_TIMG_REG
func (o *TIMG_Type) SetINT_ENA_TIMG_T0_INT_ENA(value uint32) {
	volatile.StoreUint32(&o.INT_ENA_TIMG.Reg, volatile.LoadUint32(&o.INT_ENA_TIMG.Reg)&^(0x1)|value)
}
func (o *TIMG_Type) GetINT_ENA_TIMG_T0_INT_ENA() uint32 {
	return volatile.LoadUint32(&o.INT_ENA_TIMG.Reg) & 0x1
}
func (o *TIMG_Type) SetINT_ENA_TIMG_WDT_INT_ENA(value uint32) {
	volatile.StoreUint32(&o.INT_ENA_TIMG.Reg, volatile.LoadUint32(&o.INT_ENA_TIMG.Reg)&^(0x2)|value<<1)
}
func (o *TIMG_Type) GetINT_ENA_TIMG_WDT_INT_ENA() uint32 {
	return (volatile.LoadUint32(&o.INT_ENA_TIMG.Reg) & 0x2) >> 1
}

// TIMG.INT_RAW_TIMG: INT_RAW_TIMG_REG
func (o *TIMG_Type) SetINT_RAW_TIMG_T0_INT_RAW(value uint32) {
	volatile.StoreUint32(&o.INT_RAW_TIMG.Reg, volatile.LoadUint32(&o.INT_RAW_TIMG.Reg)&^(0x1)|value)
}
func (o *TIMG_Type) GetINT_RAW_TIMG_T0_INT_RAW() uint32 {
	return volatile.LoadUint32(&o.INT_RAW_TIMG.Reg) & 0x1
}
func (o *TIMG_Type) SetINT_RAW_TIMG_WDT_INT_RAW(value uint32) {
	volatile.StoreUint32(&o.INT_RAW_TIMG.Reg, volatile.LoadUint32(&o.INT_RAW_TIMG.Reg)&^(0x2)|value<<1)
}
func (o *TIMG_Type) GetINT_RAW_TIMG_WDT_INT_RAW() uint32 {
	return (volatile.LoadUint32(&o.INT_RAW_TIMG.Reg) & 0x2) >> 1
}

// TIMG.INT_ST_TIMG: INT_ST_TIMG_REG
func (o *TIMG_Type) SetINT_ST_TIMG_T0_INT_ST(value uint32) {
	volatile.StoreUint32(&o.INT_ST_TIMG.Reg, volatile.LoadUint32(&o.INT_ST_TIMG.Reg)&^(0x1)|value)
}
func (o *TIMG_Type) GetINT_ST_TIMG_T0_INT_ST() uint32 {
	return volatile.LoadUint32(&o.INT_ST_TIMG.Reg) & 0x1
}
func (o *TIMG_Type) SetINT_ST_TIMG_WDT_INT_ST(value uint32) {
	volatile.StoreUint32(&o.INT_ST_TIMG.Reg, volatile.LoadUint32(&o.INT_ST_TIMG.Reg)&^(0x2)|value<<1)
}
func (o *TIMG_Type) GetINT_ST_TIMG_WDT_INT_ST() uint32 {
	return (volatile.LoadUint32(&o.INT_ST_TIMG.Reg) & 0x2) >> 1
}

// TIMG.INT_CLR_TIMG: INT_CLR_TIMG_REG
func (o *TIMG_Type) SetINT_CLR_TIMG_T0_INT_CLR(value uint32) {
	volatile.StoreUint32(&o.INT_CLR_TIMG.Reg, volatile.LoadUint32(&o.INT_CLR_TIMG.Reg)&^(0x1)|value)
}
func (o *TIMG_Type) GetINT_CLR_TIMG_T0_INT_CLR() uint32 {
	return volatile.LoadUint32(&o.INT_CLR_TIMG.Reg) & 0x1
}
func (o *TIMG_Type) SetINT_CLR_TIMG_WDT_INT_CLR(value uint32) {
	volatile.StoreUint32(&o.INT_CLR_TIMG.Reg, volatile.LoadUint32(&o.INT_CLR_TIMG.Reg)&^(0x2)|value<<1)
}
func (o *TIMG_Type) GetINT_CLR_TIMG_WDT_INT_CLR() uint32 {
	return (volatile.LoadUint32(&o.INT_CLR_TIMG.Reg) & 0x2) >> 1
}

// TIMG.RTCCALICFG2: TIMG_RTCCALICFG2_REG.
func (o *TIMG_Type) SetRTCCALICFG2_RTC_CALI_TIMEOUT(value uint32) {
	volatile.StoreUint32(&o.RTCCALICFG2.Reg, volatile.LoadUint32(&o.RTCCALICFG2.Reg)&^(0x1)|value)
}
func (o *TIMG_Type) GetRTCCALICFG2_RTC_CALI_TIMEOUT() uint32 {
	return volatile.LoadUint32(&o.RTCCALICFG2.Reg) & 0x1
}
func (o *TIMG_Type) SetRTCCALICFG2_RTC_CALI_TIMEOUT_RST_CNT(value uint32) {
	volatile.StoreUint32(&o.RTCCALICFG2.Reg, volatile.LoadUint32(&o.RTCCALICFG2.Reg)&^(0x78)|value<<3)
}
func (o *TIMG_Type) GetRTCCALICFG2_RTC_CALI_TIMEOUT_RST_CNT() uint32 {
	return (volatile.LoadUint32(&o.RTCCALICFG2.Reg) & 0x78) >> 3
}
func (o *TIMG_Type) SetRTCCALICFG2_RTC_CALI_TIMEOUT_THRES(value uint32) {
	volatile.StoreUint32(&o.RTCCALICFG2.Reg, volatile.LoadUint32(&o.RTCCALICFG2.Reg)&^(0xffffff80)|value<<7)
}
func (o *TIMG_Type) GetRTCCALICFG2_RTC_CALI_TIMEOUT_THRES() uint32 {
	return (volatile.LoadUint32(&o.RTCCALICFG2.Reg) & 0xffffff80) >> 7
}

// TIMG.NTIMG_DATE: TIMG_NTIMG_DATE_REG.
func (o *TIMG_Type) SetNTIMG_DATE_NTIMGS_DATE(value uint32) {
	volatile.StoreUint32(&o.NTIMG_DATE.Reg, volatile.LoadUint32(&o.NTIMG_DATE.Reg)&^(0xfffffff)|value)
}
func (o *TIMG_Type) GetNTIMG_DATE_NTIMGS_DATE() uint32 {
	return volatile.LoadUint32(&o.NTIMG_DATE.Reg) & 0xfffffff
}

// TIMG.REGCLK: TIMG_REGCLK_REG.
func (o *TIMG_Type) SetREGCLK_WDT_CLK_IS_ACTIVE(value uint32) {
	volatile.StoreUint32(&o.REGCLK.Reg, volatile.LoadUint32(&o.REGCLK.Reg)&^(0x20000000)|value<<29)
}
func (o *TIMG_Type) GetREGCLK_WDT_CLK_IS_ACTIVE() uint32 {
	return (volatile.LoadUint32(&o.REGCLK.Reg) & 0x20000000) >> 29
}
func (o *TIMG_Type) SetREGCLK_TIMER_CLK_IS_ACTIVE(value uint32) {
	volatile.StoreUint32(&o.REGCLK.Reg, volatile.LoadUint32(&o.REGCLK.Reg)&^(0x40000000)|value<<30)
}
func (o *TIMG_Type) GetREGCLK_TIMER_CLK_IS_ACTIVE() uint32 {
	return (volatile.LoadUint32(&o.REGCLK.Reg) & 0x40000000) >> 30
}
func (o *TIMG_Type) SetREGCLK_CLK_EN(value uint32) {
	volatile.StoreUint32(&o.REGCLK.Reg, volatile.LoadUint32(&o.REGCLK.Reg)&^(0x80000000)|value<<31)
}
func (o *TIMG_Type) GetREGCLK_CLK_EN() uint32 {
	return (volatile.LoadUint32(&o.REGCLK.Reg) & 0x80000000) >> 31
}

// Peripheral UART
type UART_Type struct {
	FIFO           volatile.Register32 // 0x0
	INT_RAW        volatile.Register32 // 0x4
	INT_ST         volatile.Register32 // 0x8
	INT_ENA        volatile.Register32 // 0xC
	INT_CLR        volatile.Register32 // 0x10
	CLKDIV         volatile.Register32 // 0x14
	RX_FILT        volatile.Register32 // 0x18
	STATUS         volatile.Register32 // 0x1C
	CONF0          volatile.Register32 // 0x20
	CONF1          volatile.Register32 // 0x24
	LOWPULSE       volatile.Register32 // 0x28
	HIGHPULSE      volatile.Register32 // 0x2C
	RXD_CNT        volatile.Register32 // 0x30
	FLOW_CONF      volatile.Register32 // 0x34
	SLEEP_CONF     volatile.Register32 // 0x38
	SWFC_CONF0     volatile.Register32 // 0x3C
	SWFC_CONF1     volatile.Register32 // 0x40
	TXBRK_CONF     volatile.Register32 // 0x44
	IDLE_CONF      volatile.Register32 // 0x48
	RS485_CONF     volatile.Register32 // 0x4C
	AT_CMD_PRECNT  volatile.Register32 // 0x50
	AT_CMD_POSTCNT volatile.Register32 // 0x54
	AT_CMD_GAPTOUT volatile.Register32 // 0x58
	AT_CMD_CHAR    volatile.Register32 // 0x5C
	MEM_CONF       volatile.Register32 // 0x60
	MEM_TX_STATUS  volatile.Register32 // 0x64
	MEM_RX_STATUS  volatile.Register32 // 0x68
	FSM_STATUS     volatile.Register32 // 0x6C
	POSPULSE       volatile.Register32 // 0x70
	NEGPULSE       volatile.Register32 // 0x74
	CLK_CONF       volatile.Register32 // 0x78
	DATE           volatile.Register32 // 0x7C
	ID             volatile.Register32 // 0x80
}

// UART.FIFO: FIFO data register
func (o *UART_Type) SetFIFO_RXFIFO_RD_BYTE(value uint32) {
	volatile.StoreUint32(&o.FIFO.Reg, volatile.LoadUint32(&o.FIFO.Reg)&^(0xff)|value)
}
func (o *UART_Type) GetFIFO_RXFIFO_RD_BYTE() uint32 {
	return volatile.LoadUint32(&o.FIFO.Reg) & 0xff
}

// UART.INT_RAW: Raw interrupt status
func (o *UART_Type) SetINT_RAW_RXFIFO_FULL_INT_RAW(value uint32) {
	volatile.StoreUint32(&o.INT_RAW.Reg, volatile.LoadUint32(&o.INT_RAW.Reg)&^(0x1)|value)
}
func (o *UART_Type) GetINT_RAW_RXFIFO_FULL_INT_RAW() uint32 {
	return volatile.LoadUint32(&o.INT_RAW.Reg) & 0x1
}
func (o *UART_Type) SetINT_RAW_TXFIFO_EMPTY_INT_RAW(value uint32) {
	volatile.StoreUint32(&o.INT_RAW.Reg, volatile.LoadUint32(&o.INT_RAW.Reg)&^(0x2)|value<<1)
}
func (o *UART_Type) GetINT_RAW_TXFIFO_EMPTY_INT_RAW() uint32 {
	return (volatile.LoadUint32(&o.INT_RAW.Reg) & 0x2) >> 1
}
func (o *UART_Type) SetINT_RAW_PARITY_ERR_INT_RAW(value uint32) {
	volatile.StoreUint32(&o.INT_RAW.Reg, volatile.LoadUint32(&o.INT_RAW.Reg)&^(0x4)|value<<2)
}
func (o *UART_Type) GetINT_RAW_PARITY_ERR_INT_RAW() uint32 {
	return (volatile.LoadUint32(&o.INT_RAW.Reg) & 0x4) >> 2
}
func (o *UART_Type) SetINT_RAW_FRM_ERR_INT_RAW(value uint32) {
	volatile.StoreUint32(&o.INT_RAW.Reg, volatile.LoadUint32(&o.INT_RAW.Reg)&^(0x8)|value<<3)
}
func (o *UART_Type) GetINT_RAW_FRM_ERR_INT_RAW() uint32 {
	return (volatile.LoadUint32(&o.INT_RAW.Reg) & 0x8) >> 3
}
func (o *UART_Type) SetINT_RAW_RXFIFO_OVF_INT_RAW(value uint32) {
	volatile.StoreUint32(&o.INT_RAW.Reg, volatile.LoadUint32(&o.INT_RAW.Reg)&^(0x10)|value<<4)
}
func (o *UART_Type) GetINT_RAW_RXFIFO_OVF_INT_RAW() uint32 {
	return (volatile.LoadUint32(&o.INT_RAW.Reg) & 0x10) >> 4
}
func (o *UART_Type) SetINT_RAW_DSR_CHG_INT_RAW(value uint32) {
	volatile.StoreUint32(&o.INT_RAW.Reg, volatile.LoadUint32(&o.INT_RAW.Reg)&^(0x20)|value<<5)
}
func (o *UART_Type) GetINT_RAW_DSR_CHG_INT_RAW() uint32 {
	return (volatile.LoadUint32(&o.INT_RAW.Reg) & 0x20) >> 5
}
func (o *UART_Type) SetINT_RAW_CTS_CHG_INT_RAW(value uint32) {
	volatile.StoreUint32(&o.INT_RAW.Reg, volatile.LoadUint32(&o.INT_RAW.Reg)&^(0x40)|value<<6)
}
func (o *UART_Type) GetINT_RAW_CTS_CHG_INT_RAW() uint32 {
	return (volatile.LoadUint32(&o.INT_RAW.Reg) & 0x40) >> 6
}
func (o *UART_Type) SetINT_RAW_BRK_DET_INT_RAW(value uint32) {
	volatile.StoreUint32(&o.INT_RAW.Reg, volatile.LoadUint32(&o.INT_RAW.Reg)&^(0x80)|value<<7)
}
func (o *UART_Type) GetINT_RAW_BRK_DET_INT_RAW() uint32 {
	return (volatile.LoadUint32(&o.INT_RAW.Reg) & 0x80) >> 7
}
func (o *UART_Type) SetINT_RAW_RXFIFO_TOUT_INT_RAW(value uint32) {
	volatile.StoreUint32(&o.INT_RAW.Reg, volatile.LoadUint32(&o.INT_RAW.Reg)&^(0x100)|value<<8)
}
func (o *UART_Type) GetINT_RAW_RXFIFO_TOUT_INT_RAW() uint32 {
	return (volatile.LoadUint32(&o.INT_RAW.Reg) & 0x100) >> 8
}
func (o *UART_Type) SetINT_RAW_SW_XON_INT_RAW(value uint32) {
	volatile.StoreUint32(&o.INT_RAW.Reg, volatile.LoadUint32(&o.INT_RAW.Reg)&^(0x200)|value<<9)
}
func (o *UART_Type) GetINT_RAW_SW_XON_INT_RAW() uint32 {
	return (volatile.LoadUint32(&o.INT_RAW.Reg) & 0x200) >> 9
}
func (o *UART_Type) SetINT_RAW_SW_XOFF_INT_RAW(value uint32) {
	volatile.StoreUint32(&o.INT_RAW.Reg, volatile.LoadUint32(&o.INT_RAW.Reg)&^(0x400)|value<<10)
}
func (o *UART_Type) GetINT_RAW_SW_XOFF_INT_RAW() uint32 {
	return (volatile.LoadUint32(&o.INT_RAW.Reg) & 0x400) >> 10
}
func (o *UART_Type) SetINT_RAW_GLITCH_DET_INT_RAW(value uint32) {
	volatile.StoreUint32(&o.INT_RAW.Reg, volatile.LoadUint32(&o.INT_RAW.Reg)&^(0x800)|value<<11)
}
func (o *UART_Type) GetINT_RAW_GLITCH_DET_INT_RAW() uint32 {
	return (volatile.LoadUint32(&o.INT_RAW.Reg) & 0x800) >> 11
}
func (o *UART_Type) SetINT_RAW_TX_BRK_DONE_INT_RAW(value uint32) {
	volatile.StoreUint32(&o.INT_RAW.Reg, volatile.LoadUint32(&o.INT_RAW.Reg)&^(0x1000)|value<<12)
}
func (o *UART_Type) GetINT_RAW_TX_BRK_DONE_INT_RAW() uint32 {
	return (volatile.LoadUint32(&o.INT_RAW.Reg) & 0x1000) >> 12
}
func (o *UART_Type) SetINT_RAW_TX_BRK_IDLE_DONE_INT_RAW(value uint32) {
	volatile.StoreUint32(&o.INT_RAW.Reg, volatile.LoadUint32(&o.INT_RAW.Reg)&^(0x2000)|value<<13)
}
func (o *UART_Type) GetINT_RAW_TX_BRK_IDLE_DONE_INT_RAW() uint32 {
	return (volatile.LoadUint32(&o.INT_RAW.Reg) & 0x2000) >> 13
}
func (o *UART_Type) SetINT_RAW_TX_DONE_INT_RAW(value uint32) {
	volatile.StoreUint32(&o.INT_RAW.Reg, volatile.LoadUint32(&o.INT_RAW.Reg)&^(0x4000)|value<<14)
}
func (o *UART_Type) GetINT_RAW_TX_DONE_INT_RAW() uint32 {
	return (volatile.LoadUint32(&o.INT_RAW.Reg) & 0x4000) >> 14
}
func (o *UART_Type) SetINT_RAW_RS485_PARITY_ERR_INT_RAW(value uint32) {
	volatile.StoreUint32(&o.INT_RAW.Reg, volatile.LoadUint32(&o.INT_RAW.Reg)&^(0x8000)|value<<15)
}
func (o *UART_Type) GetINT_RAW_RS485_PARITY_ERR_INT_RAW() uint32 {
	return (volatile.LoadUint32(&o.INT_RAW.Reg) & 0x8000) >> 15
}
func (o *UART_Type) SetINT_RAW_RS485_FRM_ERR_INT_RAW(value uint32) {
	volatile.StoreUint32(&o.INT_RAW.Reg, volatile.LoadUint32(&o.INT_RAW.Reg)&^(0x10000)|value<<16)
}
func (o *UART_Type) GetINT_RAW_RS485_FRM_ERR_INT_RAW() uint32 {
	return (volatile.LoadUint32(&o.INT_RAW.Reg) & 0x10000) >> 16
}
func (o *UART_Type) SetINT_RAW_RS485_CLASH_INT_RAW(value uint32) {
	volatile.StoreUint32(&o.INT_RAW.Reg, volatile.LoadUint32(&o.INT_RAW.Reg)&^(0x20000)|value<<17)
}
func (o *UART_Type) GetINT_RAW_RS485_CLASH_INT_RAW() uint32 {
	return (volatile.LoadUint32(&o.INT_RAW.Reg) & 0x20000) >> 17
}
func (o *UART_Type) SetINT_RAW_AT_CMD_CHAR_DET_INT_RAW(value uint32) {
	volatile.StoreUint32(&o.INT_RAW.Reg, volatile.LoadUint32(&o.INT_RAW.Reg)&^(0x40000)|value<<18)
}
func (o *UART_Type) GetINT_RAW_AT_CMD_CHAR_DET_INT_RAW() uint32 {
	return (volatile.LoadUint32(&o.INT_RAW.Reg) & 0x40000) >> 18
}
func (o *UART_Type) SetINT_RAW_WAKEUP_INT_RAW(value uint32) {
	volatile.StoreUint32(&o.INT_RAW.Reg, volatile.LoadUint32(&o.INT_RAW.Reg)&^(0x80000)|value<<19)
}
func (o *UART_Type) GetINT_RAW_WAKEUP_INT_RAW() uint32 {
	return (volatile.LoadUint32(&o.INT_RAW.Reg) & 0x80000) >> 19
}

// UART.INT_ST: Masked interrupt status
func (o *UART_Type) SetINT_ST_RXFIFO_FULL_INT_ST(value uint32) {
	volatile.StoreUint32(&o.INT_ST.Reg, volatile.LoadUint32(&o.INT_ST.Reg)&^(0x1)|value)
}
func (o *UART_Type) GetINT_ST_RXFIFO_FULL_INT_ST() uint32 {
	return volatile.LoadUint32(&o.INT_ST.Reg) & 0x1
}
func (o *UART_Type) SetINT_ST_TXFIFO_EMPTY_INT_ST(value uint32) {
	volatile.StoreUint32(&o.INT_ST.Reg, volatile.LoadUint32(&o.INT_ST.Reg)&^(0x2)|value<<1)
}
func (o *UART_Type) GetINT_ST_TXFIFO_EMPTY_INT_ST() uint32 {
	return (volatile.LoadUint32(&o.INT_ST.Reg) & 0x2) >> 1
}
func (o *UART_Type) SetINT_ST_PARITY_ERR_INT_ST(value uint32) {
	volatile.StoreUint32(&o.INT_ST.Reg, volatile.LoadUint32(&o.INT_ST.Reg)&^(0x4)|value<<2)
}
func (o *UART_Type) GetINT_ST_PARITY_ERR_INT_ST() uint32 {
	return (volatile.LoadUint32(&o.INT_ST.Reg) & 0x4) >> 2
}
func (o *UART_Type) SetINT_ST_FRM_ERR_INT_ST(value uint32) {
	volatile.StoreUint32(&o.INT_ST.Reg, volatile.LoadUint32(&o.INT_ST.Reg)&^(0x8)|value<<3)
}
func (o *UART_Type) GetINT_ST_FRM_ERR_INT_ST() uint32 {
	return (volatile.LoadUint32(&o.INT_ST.Reg) & 0x8) >> 3
}
func (o *UART_Type) SetINT_ST_RXFIFO_OVF_INT_ST(value uint32) {
	volatile.StoreUint32(&o.INT_ST.Reg, volatile.LoadUint32(&o.INT_ST.Reg)&^(0x10)|value<<4)
}
func (o *UART_Type) GetINT_ST_RXFIFO_OVF_INT_ST() uint32 {
	return (volatile.LoadUint32(&o.INT_ST.Reg) & 0x10) >> 4
}
func (o *UART_Type) SetINT_ST_DSR_CHG_INT_ST(value uint32) {
	volatile.StoreUint32(&o.INT_ST.Reg, volatile.LoadUint32(&o.INT_ST.Reg)&^(0x20)|value<<5)
}
func (o *UART_Type) GetINT_ST_DSR_CHG_INT_ST() uint32 {
	return (volatile.LoadUint32(&o.INT_ST.Reg) & 0x20) >> 5
}
func (o *UART_Type) SetINT_ST_CTS_CHG_INT_ST(value uint32) {
	volatile.StoreUint32(&o.INT_ST.Reg, volatile.LoadUint32(&o.INT_ST.Reg)&^(0x40)|value<<6)
}
func (o *UART_Type) GetINT_ST_CTS_CHG_INT_ST() uint32 {
	return (volatile.LoadUint32(&o.INT_ST.Reg) & 0x40) >> 6
}
func (o *UART_Type) SetINT_ST_BRK_DET_INT_ST(value uint32) {
	volatile.StoreUint32(&o.INT_ST.Reg, volatile.LoadUint32(&o.INT_ST.Reg)&^(0x80)|value<<7)
}
func (o *UART_Type) GetINT_ST_BRK_DET_INT_ST() uint32 {
	return (volatile.LoadUint32(&o.INT_ST.Reg) & 0x80) >> 7
}
func (o *UART_Type) SetINT_ST_RXFIFO_TOUT_INT_ST(value uint32) {
	volatile.StoreUint32(&o.INT_ST.Reg, volatile.LoadUint32(&o.INT_ST.Reg)&^(0x100)|value<<8)
}
func (o *UART_Type) GetINT_ST_RXFIFO_TOUT_INT_ST() uint32 {
	return (volatile.LoadUint32(&o.INT_ST.Reg) & 0x100) >> 8
}
func (o *UART_Type) SetINT_ST_SW_XON_INT_ST(value uint32) {
	volatile.StoreUint32(&o.INT_ST.Reg, volatile.LoadUint32(&o.INT_ST.Reg)&^(0x200)|value<<9)
}
func (o *UART_Type) GetINT_ST_SW_XON_INT_ST() uint32 {
	return (volatile.LoadUint32(&o.INT_ST.Reg) & 0x200) >> 9
}
func (o *UART_Type) SetINT_ST_SW_XOFF_INT_ST(value uint32) {
	volatile.StoreUint32(&o.INT_ST.Reg, volatile.LoadUint32(&o.INT_ST.Reg)&^(0x400)|value<<10)
}
func (o *UART_Type) GetINT_ST_SW_XOFF_INT_ST() uint32 {
	return (volatile.LoadUint32(&o.INT_ST.Reg) & 0x400) >> 10
}
func (o *UART_Type) SetINT_ST_GLITCH_DET_INT_ST(value uint32) {
	volatile.StoreUint32(&o.INT_ST.Reg, volatile.LoadUint32(&o.INT_ST.Reg)&^(0x800)|value<<11)
}
func (o *UART_Type) GetINT_ST_GLITCH_DET_INT_ST() uint32 {
	return (volatile.LoadUint32(&o.INT_ST.Reg) & 0x800) >> 11
}
func (o *UART_Type) SetINT_ST_TX_BRK_DONE_INT_ST(value uint32) {
	volatile.StoreUint32(&o.INT_ST.Reg, volatile.LoadUint32(&o.INT_ST.Reg)&^(0x1000)|value<<12)
}
func (o *UART_Type) GetINT_ST_TX_BRK_DONE_INT_ST() uint32 {
	return (volatile.LoadUint32(&o.INT_ST.Reg) & 0x1000) >> 12
}
func (o *UART_Type) SetINT_ST_TX_BRK_IDLE_DONE_INT_ST(value uint32) {
	volatile.StoreUint32(&o.INT_ST.Reg, volatile.LoadUint32(&o.INT_ST.Reg)&^(0x2000)|value<<13)
}
func (o *UART_Type) GetINT_ST_TX_BRK_IDLE_DONE_INT_ST() uint32 {
	return (volatile.LoadUint32(&o.INT_ST.Reg) & 0x2000) >> 13
}
func (o *UART_Type) SetINT_ST_TX_DONE_INT_ST(value uint32) {
	volatile.StoreUint32(&o.INT_ST.Reg, volatile.LoadUint32(&o.INT_ST.Reg)&^(0x4000)|value<<14)
}
func (o *UART_Type) GetINT_ST_TX_DONE_INT_ST() uint32 {
	return (volatile.LoadUint32(&o.INT_ST.Reg) & 0x4000) >> 14
}
func (o *UART_Type) SetINT_ST_RS485_PARITY_ERR_INT_ST(value uint32) {
	volatile.StoreUint32(&o.INT_ST.Reg, volatile.LoadUint32(&o.INT_ST.Reg)&^(0x8000)|value<<15)
}
func (o *UART_Type) GetINT_ST_RS485_PARITY_ERR_INT_ST() uint32 {
	return (volatile.LoadUint32(&o.INT_ST.Reg) & 0x8000) >> 15
}
func (o *UART_Type) SetINT_ST_RS485_FRM_ERR_INT_ST(value uint32) {
	volatile.StoreUint32(&o.INT_ST.Reg, volatile.LoadUint32(&o.INT_ST.Reg)&^(0x10000)|value<<16)
}
func (o *UART_Type) GetINT_ST_RS485_FRM_ERR_INT_ST() uint32 {
	return (volatile.LoadUint32(&o.INT_ST.Reg) & 0x10000) >> 16
}
func (o *UART_Type) SetINT_ST_RS485_CLASH_INT_ST(value uint32) {
	volatile.StoreUint32(&o.INT_ST.Reg, volatile.LoadUint32(&o.INT_ST.Reg)&^(0x20000)|value<<17)
}
func (o *UART_Type) GetINT_ST_RS485_CLASH_INT_ST() uint32 {
	return (volatile.LoadUint32(&o.INT_ST.Reg) & 0x20000) >> 17
}
func (o *UART_Type) SetINT_ST_AT_CMD_CHAR_DET_INT_ST(value uint32) {
	volatile.StoreUint32(&o.INT_ST.Reg, volatile.LoadUint32(&o.INT_ST.Reg)&^(0x40000)|value<<18)
}
func (o *UART_Type) GetINT_ST_AT_CMD_CHAR_DET_INT_ST() uint32 {
	return (volatile.LoadUint32(&o.INT_ST.Reg) & 0x40000) >> 18
}
func (o *UART_Type) SetINT_ST_WAKEUP_INT_ST(value uint32) {
	volatile.StoreUint32(&o.INT_ST.Reg, volatile.LoadUint32(&o.INT_ST.Reg)&^(0x80000)|value<<19)
}
func (o *UART_Type) GetINT_ST_WAKEUP_INT_ST() uint32 {
	return (volatile.LoadUint32(&o.INT_ST.Reg) & 0x80000) >> 19
}

// UART.INT_ENA: Interrupt enable bits
func (o *UART_Type) SetINT_ENA_RXFIFO_FULL_INT_ENA(value uint32) {
	volatile.StoreUint32(&o.INT_ENA.Reg, volatile.LoadUint32(&o.INT_ENA.Reg)&^(0x1)|value)
}
func (o *UART_Type) GetINT_ENA_RXFIFO_FULL_INT_ENA() uint32 {
	return volatile.LoadUint32(&o.INT_ENA.Reg) & 0x1
}
func (o *UART_Type) SetINT_ENA_TXFIFO_EMPTY_INT_ENA(value uint32) {
	volatile.StoreUint32(&o.INT_ENA.Reg, volatile.LoadUint32(&o.INT_ENA.Reg)&^(0x2)|value<<1)
}
func (o *UART_Type) GetINT_ENA_TXFIFO_EMPTY_INT_ENA() uint32 {
	return (volatile.LoadUint32(&o.INT_ENA.Reg) & 0x2) >> 1
}
func (o *UART_Type) SetINT_ENA_PARITY_ERR_INT_ENA(value uint32) {
	volatile.StoreUint32(&o.INT_ENA.Reg, volatile.LoadUint32(&o.INT_ENA.Reg)&^(0x4)|value<<2)
}
func (o *UART_Type) GetINT_ENA_PARITY_ERR_INT_ENA() uint32 {
	return (volatile.LoadUint32(&o.INT_ENA.Reg) & 0x4) >> 2
}
func (o *UART_Type) SetINT_ENA_FRM_ERR_INT_ENA(value uint32) {
	volatile.StoreUint32(&o.INT_ENA.Reg, volatile.LoadUint32(&o.INT_ENA.Reg)&^(0x8)|value<<3)
}
func (o *UART_Type) GetINT_ENA_FRM_ERR_INT_ENA() uint32 {
	return (volatile.LoadUint32(&o.INT_ENA.Reg) & 0x8) >> 3
}
func (o *UART_Type) SetINT_ENA_RXFIFO_OVF_INT_ENA(value uint32) {
	volatile.StoreUint32(&o.INT_ENA.Reg, volatile.LoadUint32(&o.INT_ENA.Reg)&^(0x10)|value<<4)
}
func (o *UART_Type) GetINT_ENA_RXFIFO_OVF_INT_ENA() uint32 {
	return (volatile.LoadUint32(&o.INT_ENA.Reg) & 0x10) >> 4
}
func (o *UART_Type) SetINT_ENA_DSR_CHG_INT_ENA(value uint32) {
	volatile.StoreUint32(&o.INT_ENA.Reg, volatile.LoadUint32(&o.INT_ENA.Reg)&^(0x20)|value<<5)
}
func (o *UART_Type) GetINT_ENA_DSR_CHG_INT_ENA() uint32 {
	return (volatile.LoadUint32(&o.INT_ENA.Reg) & 0x20) >> 5
}
func (o *UART_Type) SetINT_ENA_CTS_CHG_INT_ENA(value uint32) {
	volatile.StoreUint32(&o.INT_ENA.Reg, volatile.LoadUint32(&o.INT_ENA.Reg)&^(0x40)|value<<6)
}
func (o *UART_Type) GetINT_ENA_CTS_CHG_INT_ENA() uint32 {
	return (volatile.LoadUint32(&o.INT_ENA.Reg) & 0x40) >> 6
}
func (o *UART_Type) SetINT_ENA_BRK_DET_INT_ENA(value uint32) {
	volatile.StoreUint32(&o.INT_ENA.Reg, volatile.LoadUint32(&o.INT_ENA.Reg)&^(0x80)|value<<7)
}
func (o *UART_Type) GetINT_ENA_BRK_DET_INT_ENA() uint32 {
	return (volatile.LoadUint32(&o.INT_ENA.Reg) & 0x80) >> 7
}
func (o *UART_Type) SetINT_ENA_RXFIFO_TOUT_INT_ENA(value uint32) {
	volatile.StoreUint32(&o.INT_ENA.Reg, volatile.LoadUint32(&o.INT_ENA.Reg)&^(0x100)|value<<8)
}
func (o *UART_Type) GetINT_ENA_RXFIFO_TOUT_INT_ENA() uint32 {
	return (volatile.LoadUint32(&o.INT_ENA.Reg) & 0x100) >> 8
}
func (o *UART_Type) SetINT_ENA_SW_XON_INT_ENA(value uint32) {
	volatile.StoreUint32(&o.INT_ENA.Reg, volatile.LoadUint32(&o.INT_ENA.Reg)&^(0x200)|value<<9)
}
func (o *UART_Type) GetINT_ENA_SW_XON_INT_ENA() uint32 {
	return (volatile.LoadUint32(&o.INT_ENA.Reg) & 0x200) >> 9
}
func (o *UART_Type) SetINT_ENA_SW_XOFF_INT_ENA(value uint32) {
	volatile.StoreUint32(&o.INT_ENA.Reg, volatile.LoadUint32(&o.INT_ENA.Reg)&^(0x400)|value<<10)
}
func (o *UART_Type) GetINT_ENA_SW_XOFF_INT_ENA() uint32 {
	return (volatile.LoadUint32(&o.INT_ENA.Reg) & 0x400) >> 10
}
func (o *UART_Type) SetINT_ENA_GLITCH_DET_INT_ENA(value uint32) {
	volatile.StoreUint32(&o.INT_ENA.Reg, volatile.LoadUint32(&o.INT_ENA.Reg)&^(0x800)|value<<11)
}
func (o *UART_Type) GetINT_ENA_GLITCH_DET_INT_ENA() uint32 {
	return (volatile.LoadUint32(&o.INT_ENA.Reg) & 0x800) >> 11
}
func (o *UART_Type) SetINT_ENA_TX_BRK_DONE_INT_ENA(value uint32) {
	volatile.StoreUint32(&o.INT_ENA.Reg, volatile.LoadUint32(&o.INT_ENA.Reg)&^(0x1000)|value<<12)
}
func (o *UART_Type) GetINT_ENA_TX_BRK_DONE_INT_ENA() uint32 {
	return (volatile.LoadUint32(&o.INT_ENA.Reg) & 0x1000) >> 12
}
func (o *UART_Type) SetINT_ENA_TX_BRK_IDLE_DONE_INT_ENA(value uint32) {
	volatile.StoreUint32(&o.INT_ENA.Reg, volatile.LoadUint32(&o.INT_ENA.Reg)&^(0x2000)|value<<13)
}
func (o *UART_Type) GetINT_ENA_TX_BRK_IDLE_DONE_INT_ENA() uint32 {
	return (volatile.LoadUint32(&o.INT_ENA.Reg) & 0x2000) >> 13
}
func (o *UART_Type) SetINT_ENA_TX_DONE_INT_ENA(value uint32) {
	volatile.StoreUint32(&o.INT_ENA.Reg, volatile.LoadUint32(&o.INT_ENA.Reg)&^(0x4000)|value<<14)
}
func (o *UART_Type) GetINT_ENA_TX_DONE_INT_ENA() uint32 {
	return (volatile.LoadUint32(&o.INT_ENA.Reg) & 0x4000) >> 14
}
func (o *UART_Type) SetINT_ENA_RS485_PARITY_ERR_INT_ENA(value uint32) {
	volatile.StoreUint32(&o.INT_ENA.Reg, volatile.LoadUint32(&o.INT_ENA.Reg)&^(0x8000)|value<<15)
}
func (o *UART_Type) GetINT_ENA_RS485_PARITY_ERR_INT_ENA() uint32 {
	return (volatile.LoadUint32(&o.INT_ENA.Reg) & 0x8000) >> 15
}
func (o *UART_Type) SetINT_ENA_RS485_FRM_ERR_INT_ENA(value uint32) {
	volatile.StoreUint32(&o.INT_ENA.Reg, volatile.LoadUint32(&o.INT_ENA.Reg)&^(0x10000)|value<<16)
}
func (o *UART_Type) GetINT_ENA_RS485_FRM_ERR_INT_ENA() uint32 {
	return (volatile.LoadUint32(&o.INT_ENA.Reg) & 0x10000) >> 16
}
func (o *UART_Type) SetINT_ENA_RS485_CLASH_INT_ENA(value uint32) {
	volatile.StoreUint32(&o.INT_ENA.Reg, volatile.LoadUint32(&o.INT_ENA.Reg)&^(0x20000)|value<<17)
}
func (o *UART_Type) GetINT_ENA_RS485_CLASH_INT_ENA() uint32 {
	return (volatile.LoadUint32(&o.INT_ENA.Reg) & 0x20000) >> 17
}
func (o *UART_Type) SetINT_ENA_AT_CMD_CHAR_DET_INT_ENA(value uint32) {
	volatile.StoreUint32(&o.INT_ENA.Reg, volatile.LoadUint32(&o.INT_ENA.Reg)&^(0x40000)|value<<18)
}
func (o *UART_Type) GetINT_ENA_AT_CMD_CHAR_DET_INT_ENA() uint32 {
	return (volatile.LoadUint32(&o.INT_ENA.Reg) & 0x40000) >> 18
}
func (o *UART_Type) SetINT_ENA_WAKEUP_INT_ENA(value uint32) {
	volatile.StoreUint32(&o.INT_ENA.Reg, volatile.LoadUint32(&o.INT_ENA.Reg)&^(0x80000)|value<<19)
}
func (o *UART_Type) GetINT_ENA_WAKEUP_INT_ENA() uint32 {
	return (volatile.LoadUint32(&o.INT_ENA.Reg) & 0x80000) >> 19
}

// UART.INT_CLR: Interrupt clear bits
func (o *UART_Type) SetINT_CLR_RXFIFO_FULL_INT_CLR(value uint32) {
	volatile.StoreUint32(&o.INT_CLR.Reg, volatile.LoadUint32(&o.INT_CLR.Reg)&^(0x1)|value)
}
func (o *UART_Type) GetINT_CLR_RXFIFO_FULL_INT_CLR() uint32 {
	return volatile.LoadUint32(&o.INT_CLR.Reg) & 0x1
}
func (o *UART_Type) SetINT_CLR_TXFIFO_EMPTY_INT_CLR(value uint32) {
	volatile.StoreUint32(&o.INT_CLR.Reg, volatile.LoadUint32(&o.INT_CLR.Reg)&^(0x2)|value<<1)
}
func (o *UART_Type) GetINT_CLR_TXFIFO_EMPTY_INT_CLR() uint32 {
	return (volatile.LoadUint32(&o.INT_CLR.Reg) & 0x2) >> 1
}
func (o *UART_Type) SetINT_CLR_PARITY_ERR_INT_CLR(value uint32) {
	volatile.StoreUint32(&o.INT_CLR.Reg, volatile.LoadUint32(&o.INT_CLR.Reg)&^(0x4)|value<<2)
}
func (o *UART_Type) GetINT_CLR_PARITY_ERR_INT_CLR() uint32 {
	return (volatile.LoadUint32(&o.INT_CLR.Reg) & 0x4) >> 2
}
func (o *UART_Type) SetINT_CLR_FRM_ERR_INT_CLR(value uint32) {
	volatile.StoreUint32(&o.INT_CLR.Reg, volatile.LoadUint32(&o.INT_CLR.Reg)&^(0x8)|value<<3)
}
func (o *UART_Type) GetINT_CLR_FRM_ERR_INT_CLR() uint32 {
	return (volatile.LoadUint32(&o.INT_CLR.Reg) & 0x8) >> 3
}
func (o *UART_Type) SetINT_CLR_RXFIFO_OVF_INT_CLR(value uint32) {
	volatile.StoreUint32(&o.INT_CLR.Reg, volatile.LoadUint32(&o.INT_CLR.Reg)&^(0x10)|value<<4)
}
func (o *UART_Type) GetINT_CLR_RXFIFO_OVF_INT_CLR() uint32 {
	return (volatile.LoadUint32(&o.INT_CLR.Reg) & 0x10) >> 4
}
func (o *UART_Type) SetINT_CLR_DSR_CHG_INT_CLR(value uint32) {
	volatile.StoreUint32(&o.INT_CLR.Reg, volatile.LoadUint32(&o.INT_CLR.Reg)&^(0x20)|value<<5)
}
func (o *UART_Type) GetINT_CLR_DSR_CHG_INT_CLR() uint32 {
	return (volatile.LoadUint32(&o.INT_CLR.Reg) & 0x20) >> 5
}
func (o *UART_Type) SetINT_CLR_CTS_CHG_INT_CLR(value uint32) {
	volatile.StoreUint32(&o.INT_CLR.Reg, volatile.LoadUint32(&o.INT_CLR.Reg)&^(0x40)|value<<6)
}
func (o *UART_Type) GetINT_CLR_CTS_CHG_INT_CLR() uint32 {
	return (volatile.LoadUint32(&o.INT_CLR.Reg) & 0x40) >> 6
}
func (o *UART_Type) SetINT_CLR_BRK_DET_INT_CLR(value uint32) {
	volatile.StoreUint32(&o.INT_CLR.Reg, volatile.LoadUint32(&o.INT_CLR.Reg)&^(0x80)|value<<7)
}
func (o *UART_Type) GetINT_CLR_BRK_DET_INT_CLR() uint32 {
	return (volatile.LoadUint32(&o.INT_CLR.Reg) & 0x80) >> 7
}
func (o *UART_Type) SetINT_CLR_RXFIFO_TOUT_INT_CLR(value uint32) {
	volatile.StoreUint32(&o.INT_CLR.Reg, volatile.LoadUint32(&o.INT_CLR.Reg)&^(0x100)|value<<8)
}
func (o *UART_Type) GetINT_CLR_RXFIFO_TOUT_INT_CLR() uint32 {
	return (volatile.LoadUint32(&o.INT_CLR.Reg) & 0x100) >> 8
}
func (o *UART_Type) SetINT_CLR_SW_XON_INT_CLR(value uint32) {
	volatile.StoreUint32(&o.INT_CLR.Reg, volatile.LoadUint32(&o.INT_CLR.Reg)&^(0x200)|value<<9)
}
func (o *UART_Type) GetINT_CLR_SW_XON_INT_CLR() uint32 {
	return (volatile.LoadUint32(&o.INT_CLR.Reg) & 0x200) >> 9
}
func (o *UART_Type) SetINT_CLR_SW_XOFF_INT_CLR(value uint32) {
	volatile.StoreUint32(&o.INT_CLR.Reg, volatile.LoadUint32(&o.INT_CLR.Reg)&^(0x400)|value<<10)
}
func (o *UART_Type) GetINT_CLR_SW_XOFF_INT_CLR() uint32 {
	return (volatile.LoadUint32(&o.INT_CLR.Reg) & 0x400) >> 10
}
func (o *UART_Type) SetINT_CLR_GLITCH_DET_INT_CLR(value uint32) {
	volatile.StoreUint32(&o.INT_CLR.Reg, volatile.LoadUint32(&o.INT_CLR.Reg)&^(0x800)|value<<11)
}
func (o *UART_Type) GetINT_CLR_GLITCH_DET_INT_CLR() uint32 {
	return (volatile.LoadUint32(&o.INT_CLR.Reg) & 0x800) >> 11
}
func (o *UART_Type) SetINT_CLR_TX_BRK_DONE_INT_CLR(value uint32) {
	volatile.StoreUint32(&o.INT_CLR.Reg, volatile.LoadUint32(&o.INT_CLR.Reg)&^(0x1000)|value<<12)
}
func (o *UART_Type) GetINT_CLR_TX_BRK_DONE_INT_CLR() uint32 {
	return (volatile.LoadUint32(&o.INT_CLR.Reg) & 0x1000) >> 12
}
func (o *UART_Type) SetINT_CLR_TX_BRK_IDLE_DONE_INT_CLR(value uint32) {
	volatile.StoreUint32(&o.INT_CLR.Reg, volatile.LoadUint32(&o.INT_CLR.Reg)&^(0x2000)|value<<13)
}
func (o *UART_Type) GetINT_CLR_TX_BRK_IDLE_DONE_INT_CLR() uint32 {
	return (volatile.LoadUint32(&o.INT_CLR.Reg) & 0x2000) >> 13
}
func (o *UART_Type) SetINT_CLR_TX_DONE_INT_CLR(value uint32) {
	volatile.StoreUint32(&o.INT_CLR.Reg, volatile.LoadUint32(&o.INT_CLR.Reg)&^(0x4000)|value<<14)
}
func (o *UART_Type) GetINT_CLR_TX_DONE_INT_CLR() uint32 {
	return (volatile.LoadUint32(&o.INT_CLR.Reg) & 0x4000) >> 14
}
func (o *UART_Type) SetINT_CLR_RS485_PARITY_ERR_INT_CLR(value uint32) {
	volatile.StoreUint32(&o.INT_CLR.Reg, volatile.LoadUint32(&o.INT_CLR.Reg)&^(0x8000)|value<<15)
}
func (o *UART_Type) GetINT_CLR_RS485_PARITY_ERR_INT_CLR() uint32 {
	return (volatile.LoadUint32(&o.INT_CLR.Reg) & 0x8000) >> 15
}
func (o *UART_Type) SetINT_CLR_RS485_FRM_ERR_INT_CLR(value uint32) {
	volatile.StoreUint32(&o.INT_CLR.Reg, volatile.LoadUint32(&o.INT_CLR.Reg)&^(0x10000)|value<<16)
}
func (o *UART_Type) GetINT_CLR_RS485_FRM_ERR_INT_CLR() uint32 {
	return (volatile.LoadUint32(&o.INT_CLR.Reg) & 0x10000) >> 16
}
func (o *UART_Type) SetINT_CLR_RS485_CLASH_INT_CLR(value uint32) {
	volatile.StoreUint32(&o.INT_CLR.Reg, volatile.LoadUint32(&o.INT_CLR.Reg)&^(0x20000)|value<<17)
}
func (o *UART_Type) GetINT_CLR_RS485_CLASH_INT_CLR() uint32 {
	return (volatile.LoadUint32(&o.INT_CLR.Reg) & 0x20000) >> 17
}
func (o *UART_Type) SetINT_CLR_AT_CMD_CHAR_DET_INT_CLR(value uint32) {
	volatile.StoreUint32(&o.INT_CLR.Reg, volatile.LoadUint32(&o.INT_CLR.Reg)&^(0x40000)|value<<18)
}
func (o *UART_Type) GetINT_CLR_AT_CMD_CHAR_DET_INT_CLR() uint32 {
	return (volatile.LoadUint32(&o.INT_CLR.Reg) & 0x40000) >> 18
}
func (o *UART_Type) SetINT_CLR_WAKEUP_INT_CLR(value uint32) {
	volatile.StoreUint32(&o.INT_CLR.Reg, volatile.LoadUint32(&o.INT_CLR.Reg)&^(0x80000)|value<<19)
}
func (o *UART_Type) GetINT_CLR_WAKEUP_INT_CLR() uint32 {
	return (volatile.LoadUint32(&o.INT_CLR.Reg) & 0x80000) >> 19
}

// UART.CLKDIV: Clock divider configuration
func (o *UART_Type) SetCLKDIV(value uint32) {
	volatile.StoreUint32(&o.CLKDIV.Reg, volatile.LoadUint32(&o.CLKDIV.Reg)&^(0xfff)|value)
}
func (o *UART_Type) GetCLKDIV() uint32 {
	return volatile.LoadUint32(&o.CLKDIV.Reg) & 0xfff
}
func (o *UART_Type) SetCLKDIV_FRAG(value uint32) {
	volatile.StoreUint32(&o.CLKDIV.Reg, volatile.LoadUint32(&o.CLKDIV.Reg)&^(0xf00000)|value<<20)
}
func (o *UART_Type) GetCLKDIV_FRAG() uint32 {
	return (volatile.LoadUint32(&o.CLKDIV.Reg) & 0xf00000) >> 20
}

// UART.RX_FILT: Rx Filter configuration
func (o *UART_Type) SetRX_FILT_GLITCH_FILT(value uint32) {
	volatile.StoreUint32(&o.RX_FILT.Reg, volatile.LoadUint32(&o.RX_FILT.Reg)&^(0xff)|value)
}
func (o *UART_Type) GetRX_FILT_GLITCH_FILT() uint32 {
	return volatile.LoadUint32(&o.RX_FILT.Reg) & 0xff
}
func (o *UART_Type) SetRX_FILT_GLITCH_FILT_EN(value uint32) {
	volatile.StoreUint32(&o.RX_FILT.Reg, volatile.LoadUint32(&o.RX_FILT.Reg)&^(0x100)|value<<8)
}
func (o *UART_Type) GetRX_FILT_GLITCH_FILT_EN() uint32 {
	return (volatile.LoadUint32(&o.RX_FILT.Reg) & 0x100) >> 8
}

// UART.STATUS: UART status register
func (o *UART_Type) SetSTATUS_RXFIFO_CNT(value uint32) {
	volatile.StoreUint32(&o.STATUS.Reg, volatile.LoadUint32(&o.STATUS.Reg)&^(0x3ff)|value)
}
func (o *UART_Type) GetSTATUS_RXFIFO_CNT() uint32 {
	return volatile.LoadUint32(&o.STATUS.Reg) & 0x3ff
}
func (o *UART_Type) SetSTATUS_DSRN(value uint32) {
	volatile.StoreUint32(&o.STATUS.Reg, volatile.LoadUint32(&o.STATUS.Reg)&^(0x2000)|value<<13)
}
func (o *UART_Type) GetSTATUS_DSRN() uint32 {
	return (volatile.LoadUint32(&o.STATUS.Reg) & 0x2000) >> 13
}
func (o *UART_Type) SetSTATUS_CTSN(value uint32) {
	volatile.StoreUint32(&o.STATUS.Reg, volatile.LoadUint32(&o.STATUS.Reg)&^(0x4000)|value<<14)
}
func (o *UART_Type) GetSTATUS_CTSN() uint32 {
	return (volatile.LoadUint32(&o.STATUS.Reg) & 0x4000) >> 14
}
func (o *UART_Type) SetSTATUS_RXD(value uint32) {
	volatile.StoreUint32(&o.STATUS.Reg, volatile.LoadUint32(&o.STATUS.Reg)&^(0x8000)|value<<15)
}
func (o *UART_Type) GetSTATUS_RXD() uint32 {
	return (volatile.LoadUint32(&o.STATUS.Reg) & 0x8000) >> 15
}
func (o *UART_Type) SetSTATUS_TXFIFO_CNT(value uint32) {
	volatile.StoreUint32(&o.STATUS.Reg, volatile.LoadUint32(&o.STATUS.Reg)&^(0x3ff0000)|value<<16)
}
func (o *UART_Type) GetSTATUS_TXFIFO_CNT() uint32 {
	return (volatile.LoadUint32(&o.STATUS.Reg) & 0x3ff0000) >> 16
}
func (o *UART_Type) SetSTATUS_DTRN(value uint32) {
	volatile.StoreUint32(&o.STATUS.Reg, volatile.LoadUint32(&o.STATUS.Reg)&^(0x20000000)|value<<29)
}
func (o *UART_Type) GetSTATUS_DTRN() uint32 {
	return (volatile.LoadUint32(&o.STATUS.Reg) & 0x20000000) >> 29
}
func (o *UART_Type) SetSTATUS_RTSN(value uint32) {
	volatile.StoreUint32(&o.STATUS.Reg, volatile.LoadUint32(&o.STATUS.Reg)&^(0x40000000)|value<<30)
}
func (o *UART_Type) GetSTATUS_RTSN() uint32 {
	return (volatile.LoadUint32(&o.STATUS.Reg) & 0x40000000) >> 30
}
func (o *UART_Type) SetSTATUS_TXD(value uint32) {
	volatile.StoreUint32(&o.STATUS.Reg, volatile.LoadUint32(&o.STATUS.Reg)&^(0x80000000)|value<<31)
}
func (o *UART_Type) GetSTATUS_TXD() uint32 {
	return (volatile.LoadUint32(&o.STATUS.Reg) & 0x80000000) >> 31
}

// UART.CONF0: a
func (o *UART_Type) SetCONF0_PARITY(value uint32) {
	volatile.StoreUint32(&o.CONF0.Reg, volatile.LoadUint32(&o.CONF0.Reg)&^(0x1)|value)
}
func (o *UART_Type) GetCONF0_PARITY() uint32 {
	return volatile.LoadUint32(&o.CONF0.Reg) & 0x1
}
func (o *UART_Type) SetCONF0_PARITY_EN(value uint32) {
	volatile.StoreUint32(&o.CONF0.Reg, volatile.LoadUint32(&o.CONF0.Reg)&^(0x2)|value<<1)
}
func (o *UART_Type) GetCONF0_PARITY_EN() uint32 {
	return (volatile.LoadUint32(&o.CONF0.Reg) & 0x2) >> 1
}
func (o *UART_Type) SetCONF0_BIT_NUM(value uint32) {
	volatile.StoreUint32(&o.CONF0.Reg, volatile.LoadUint32(&o.CONF0.Reg)&^(0xc)|value<<2)
}
func (o *UART_Type) GetCONF0_BIT_NUM() uint32 {
	return (volatile.LoadUint32(&o.CONF0.Reg) & 0xc) >> 2
}
func (o *UART_Type) SetCONF0_STOP_BIT_NUM(value uint32) {
	volatile.StoreUint32(&o.CONF0.Reg, volatile.LoadUint32(&o.CONF0.Reg)&^(0x30)|value<<4)
}
func (o *UART_Type) GetCONF0_STOP_BIT_NUM() uint32 {
	return (volatile.LoadUint32(&o.CONF0.Reg) & 0x30) >> 4
}
func (o *UART_Type) SetCONF0_SW_RTS(value uint32) {
	volatile.StoreUint32(&o.CONF0.Reg, volatile.LoadUint32(&o.CONF0.Reg)&^(0x40)|value<<6)
}
func (o *UART_Type) GetCONF0_SW_RTS() uint32 {
	return (volatile.LoadUint32(&o.CONF0.Reg) & 0x40) >> 6
}
func (o *UART_Type) SetCONF0_SW_DTR(value uint32) {
	volatile.StoreUint32(&o.CONF0.Reg, volatile.LoadUint32(&o.CONF0.Reg)&^(0x80)|value<<7)
}
func (o *UART_Type) GetCONF0_SW_DTR() uint32 {
	return (volatile.LoadUint32(&o.CONF0.Reg) & 0x80) >> 7
}
func (o *UART_Type) SetCONF0_TXD_BRK(value uint32) {
	volatile.StoreUint32(&o.CONF0.Reg, volatile.LoadUint32(&o.CONF0.Reg)&^(0x100)|value<<8)
}
func (o *UART_Type) GetCONF0_TXD_BRK() uint32 {
	return (volatile.LoadUint32(&o.CONF0.Reg) & 0x100) >> 8
}
func (o *UART_Type) SetCONF0_IRDA_DPLX(value uint32) {
	volatile.StoreUint32(&o.CONF0.Reg, volatile.LoadUint32(&o.CONF0.Reg)&^(0x200)|value<<9)
}
func (o *UART_Type) GetCONF0_IRDA_DPLX() uint32 {
	return (volatile.LoadUint32(&o.CONF0.Reg) & 0x200) >> 9
}
func (o *UART_Type) SetCONF0_IRDA_TX_EN(value uint32) {
	volatile.StoreUint32(&o.CONF0.Reg, volatile.LoadUint32(&o.CONF0.Reg)&^(0x400)|value<<10)
}
func (o *UART_Type) GetCONF0_IRDA_TX_EN() uint32 {
	return (volatile.LoadUint32(&o.CONF0.Reg) & 0x400) >> 10
}
func (o *UART_Type) SetCONF0_IRDA_WCTL(value uint32) {
	volatile.StoreUint32(&o.CONF0.Reg, volatile.LoadUint32(&o.CONF0.Reg)&^(0x800)|value<<11)
}
func (o *UART_Type) GetCONF0_IRDA_WCTL() uint32 {
	return (volatile.LoadUint32(&o.CONF0.Reg) & 0x800) >> 11
}
func (o *UART_Type) SetCONF0_IRDA_TX_INV(value uint32) {
	volatile.StoreUint32(&o.CONF0.Reg, volatile.LoadUint32(&o.CONF0.Reg)&^(0x1000)|value<<12)
}
func (o *UART_Type) GetCONF0_IRDA_TX_INV() uint32 {
	return (volatile.LoadUint32(&o.CONF0.Reg) & 0x1000) >> 12
}
func (o *UART_Type) SetCONF0_IRDA_RX_INV(value uint32) {
	volatile.StoreUint32(&o.CONF0.Reg, volatile.LoadUint32(&o.CONF0.Reg)&^(0x2000)|value<<13)
}
func (o *UART_Type) GetCONF0_IRDA_RX_INV() uint32 {
	return (volatile.LoadUint32(&o.CONF0.Reg) & 0x2000) >> 13
}
func (o *UART_Type) SetCONF0_LOOPBACK(value uint32) {
	volatile.StoreUint32(&o.CONF0.Reg, volatile.LoadUint32(&o.CONF0.Reg)&^(0x4000)|value<<14)
}
func (o *UART_Type) GetCONF0_LOOPBACK() uint32 {
	return (volatile.LoadUint32(&o.CONF0.Reg) & 0x4000) >> 14
}
func (o *UART_Type) SetCONF0_TX_FLOW_EN(value uint32) {
	volatile.StoreUint32(&o.CONF0.Reg, volatile.LoadUint32(&o.CONF0.Reg)&^(0x8000)|value<<15)
}
func (o *UART_Type) GetCONF0_TX_FLOW_EN() uint32 {
	return (volatile.LoadUint32(&o.CONF0.Reg) & 0x8000) >> 15
}
func (o *UART_Type) SetCONF0_IRDA_EN(value uint32) {
	volatile.StoreUint32(&o.CONF0.Reg, volatile.LoadUint32(&o.CONF0.Reg)&^(0x10000)|value<<16)
}
func (o *UART_Type) GetCONF0_IRDA_EN() uint32 {
	return (volatile.LoadUint32(&o.CONF0.Reg) & 0x10000) >> 16
}
func (o *UART_Type) SetCONF0_RXFIFO_RST(value uint32) {
	volatile.StoreUint32(&o.CONF0.Reg, volatile.LoadUint32(&o.CONF0.Reg)&^(0x20000)|value<<17)
}
func (o *UART_Type) GetCONF0_RXFIFO_RST() uint32 {
	return (volatile.LoadUint32(&o.CONF0.Reg) & 0x20000) >> 17
}
func (o *UART_Type) SetCONF0_TXFIFO_RST(value uint32) {
	volatile.StoreUint32(&o.CONF0.Reg, volatile.LoadUint32(&o.CONF0.Reg)&^(0x40000)|value<<18)
}
func (o *UART_Type) GetCONF0_TXFIFO_RST() uint32 {
	return (volatile.LoadUint32(&o.CONF0.Reg) & 0x40000) >> 18
}
func (o *UART_Type) SetCONF0_RXD_INV(value uint32) {
	volatile.StoreUint32(&o.CONF0.Reg, volatile.LoadUint32(&o.CONF0.Reg)&^(0x80000)|value<<19)
}
func (o *UART_Type) GetCONF0_RXD_INV() uint32 {
	return (volatile.LoadUint32(&o.CONF0.Reg) & 0x80000) >> 19
}
func (o *UART_Type) SetCONF0_CTS_INV(value uint32) {
	volatile.StoreUint32(&o.CONF0.Reg, volatile.LoadUint32(&o.CONF0.Reg)&^(0x100000)|value<<20)
}
func (o *UART_Type) GetCONF0_CTS_INV() uint32 {
	return (volatile.LoadUint32(&o.CONF0.Reg) & 0x100000) >> 20
}
func (o *UART_Type) SetCONF0_DSR_INV(value uint32) {
	volatile.StoreUint32(&o.CONF0.Reg, volatile.LoadUint32(&o.CONF0.Reg)&^(0x200000)|value<<21)
}
func (o *UART_Type) GetCONF0_DSR_INV() uint32 {
	return (volatile.LoadUint32(&o.CONF0.Reg) & 0x200000) >> 21
}
func (o *UART_Type) SetCONF0_TXD_INV(value uint32) {
	volatile.StoreUint32(&o.CONF0.Reg, volatile.LoadUint32(&o.CONF0.Reg)&^(0x400000)|value<<22)
}
func (o *UART_Type) GetCONF0_TXD_INV() uint32 {
	return (volatile.LoadUint32(&o.CONF0.Reg) & 0x400000) >> 22
}
func (o *UART_Type) SetCONF0_RTS_INV(value uint32) {
	volatile.StoreUint32(&o.CONF0.Reg, volatile.LoadUint32(&o.CONF0.Reg)&^(0x800000)|value<<23)
}
func (o *UART_Type) GetCONF0_RTS_INV() uint32 {
	return (volatile.LoadUint32(&o.CONF0.Reg) & 0x800000) >> 23
}
func (o *UART_Type) SetCONF0_DTR_INV(value uint32) {
	volatile.StoreUint32(&o.CONF0.Reg, volatile.LoadUint32(&o.CONF0.Reg)&^(0x1000000)|value<<24)
}
func (o *UART_Type) GetCONF0_DTR_INV() uint32 {
	return (volatile.LoadUint32(&o.CONF0.Reg) & 0x1000000) >> 24
}
func (o *UART_Type) SetCONF0_CLK_EN(value uint32) {
	volatile.StoreUint32(&o.CONF0.Reg, volatile.LoadUint32(&o.CONF0.Reg)&^(0x2000000)|value<<25)
}
func (o *UART_Type) GetCONF0_CLK_EN() uint32 {
	return (volatile.LoadUint32(&o.CONF0.Reg) & 0x2000000) >> 25
}
func (o *UART_Type) SetCONF0_ERR_WR_MASK(value uint32) {
	volatile.StoreUint32(&o.CONF0.Reg, volatile.LoadUint32(&o.CONF0.Reg)&^(0x4000000)|value<<26)
}
func (o *UART_Type) GetCONF0_ERR_WR_MASK() uint32 {
	return (volatile.LoadUint32(&o.CONF0.Reg) & 0x4000000) >> 26
}
func (o *UART_Type) SetCONF0_AUTOBAUD_EN(value uint32) {
	volatile.StoreUint32(&o.CONF0.Reg, volatile.LoadUint32(&o.CONF0.Reg)&^(0x8000000)|value<<27)
}
func (o *UART_Type) GetCONF0_AUTOBAUD_EN() uint32 {
	return (volatile.LoadUint32(&o.CONF0.Reg) & 0x8000000) >> 27
}
func (o *UART_Type) SetCONF0_MEM_CLK_EN(value uint32) {
	volatile.StoreUint32(&o.CONF0.Reg, volatile.LoadUint32(&o.CONF0.Reg)&^(0x10000000)|value<<28)
}
func (o *UART_Type) GetCONF0_MEM_CLK_EN() uint32 {
	return (volatile.LoadUint32(&o.CONF0.Reg) & 0x10000000) >> 28
}

// UART.CONF1: Configuration register 1
func (o *UART_Type) SetCONF1_RXFIFO_FULL_THRHD(value uint32) {
	volatile.StoreUint32(&o.CONF1.Reg, volatile.LoadUint32(&o.CONF1.Reg)&^(0x1ff)|value)
}
func (o *UART_Type) GetCONF1_RXFIFO_FULL_THRHD() uint32 {
	return volatile.LoadUint32(&o.CONF1.Reg) & 0x1ff
}
func (o *UART_Type) SetCONF1_TXFIFO_EMPTY_THRHD(value uint32) {
	volatile.StoreUint32(&o.CONF1.Reg, volatile.LoadUint32(&o.CONF1.Reg)&^(0x3fe00)|value<<9)
}
func (o *UART_Type) GetCONF1_TXFIFO_EMPTY_THRHD() uint32 {
	return (volatile.LoadUint32(&o.CONF1.Reg) & 0x3fe00) >> 9
}
func (o *UART_Type) SetCONF1_DIS_RX_DAT_OVF(value uint32) {
	volatile.StoreUint32(&o.CONF1.Reg, volatile.LoadUint32(&o.CONF1.Reg)&^(0x40000)|value<<18)
}
func (o *UART_Type) GetCONF1_DIS_RX_DAT_OVF() uint32 {
	return (volatile.LoadUint32(&o.CONF1.Reg) & 0x40000) >> 18
}
func (o *UART_Type) SetCONF1_RX_TOUT_FLOW_DIS(value uint32) {
	volatile.StoreUint32(&o.CONF1.Reg, volatile.LoadUint32(&o.CONF1.Reg)&^(0x80000)|value<<19)
}
func (o *UART_Type) GetCONF1_RX_TOUT_FLOW_DIS() uint32 {
	return (volatile.LoadUint32(&o.CONF1.Reg) & 0x80000) >> 19
}
func (o *UART_Type) SetCONF1_RX_FLOW_EN(value uint32) {
	volatile.StoreUint32(&o.CONF1.Reg, volatile.LoadUint32(&o.CONF1.Reg)&^(0x100000)|value<<20)
}
func (o *UART_Type) GetCONF1_RX_FLOW_EN() uint32 {
	return (volatile.LoadUint32(&o.CONF1.Reg) & 0x100000) >> 20
}
func (o *UART_Type) SetCONF1_RX_TOUT_EN(value uint32) {
	volatile.StoreUint32(&o.CONF1.Reg, volatile.LoadUint32(&o.CONF1.Reg)&^(0x200000)|value<<21)
}
func (o *UART_Type) GetCONF1_RX_TOUT_EN() uint32 {
	return (volatile.LoadUint32(&o.CONF1.Reg) & 0x200000) >> 21
}

// UART.LOWPULSE: Autobaud minimum low pulse duration register
func (o *UART_Type) SetLOWPULSE_MIN_CNT(value uint32) {
	volatile.StoreUint32(&o.LOWPULSE.Reg, volatile.LoadUint32(&o.LOWPULSE.Reg)&^(0xfff)|value)
}
func (o *UART_Type) GetLOWPULSE_MIN_CNT() uint32 {
	return volatile.LoadUint32(&o.LOWPULSE.Reg) & 0xfff
}

// UART.HIGHPULSE: Autobaud minimum high pulse duration register
func (o *UART_Type) SetHIGHPULSE_MIN_CNT(value uint32) {
	volatile.StoreUint32(&o.HIGHPULSE.Reg, volatile.LoadUint32(&o.HIGHPULSE.Reg)&^(0xfff)|value)
}
func (o *UART_Type) GetHIGHPULSE_MIN_CNT() uint32 {
	return volatile.LoadUint32(&o.HIGHPULSE.Reg) & 0xfff
}

// UART.RXD_CNT: Autobaud edge change count register
func (o *UART_Type) SetRXD_CNT_RXD_EDGE_CNT(value uint32) {
	volatile.StoreUint32(&o.RXD_CNT.Reg, volatile.LoadUint32(&o.RXD_CNT.Reg)&^(0x3ff)|value)
}
func (o *UART_Type) GetRXD_CNT_RXD_EDGE_CNT() uint32 {
	return volatile.LoadUint32(&o.RXD_CNT.Reg) & 0x3ff
}

// UART.FLOW_CONF: Software flow-control configuration
func (o *UART_Type) SetFLOW_CONF_SW_FLOW_CON_EN(value uint32) {
	volatile.StoreUint32(&o.FLOW_CONF.Reg, volatile.LoadUint32(&o.FLOW_CONF.Reg)&^(0x1)|value)
}
func (o *UART_Type) GetFLOW_CONF_SW_FLOW_CON_EN() uint32 {
	return volatile.LoadUint32(&o.FLOW_CONF.Reg) & 0x1
}
func (o *UART_Type) SetFLOW_CONF_XONOFF_DEL(value uint32) {
	volatile.StoreUint32(&o.FLOW_CONF.Reg, volatile.LoadUint32(&o.FLOW_CONF.Reg)&^(0x2)|value<<1)
}
func (o *UART_Type) GetFLOW_CONF_XONOFF_DEL() uint32 {
	return (volatile.LoadUint32(&o.FLOW_CONF.Reg) & 0x2) >> 1
}
func (o *UART_Type) SetFLOW_CONF_FORCE_XON(value uint32) {
	volatile.StoreUint32(&o.FLOW_CONF.Reg, volatile.LoadUint32(&o.FLOW_CONF.Reg)&^(0x4)|value<<2)
}
func (o *UART_Type) GetFLOW_CONF_FORCE_XON() uint32 {
	return (volatile.LoadUint32(&o.FLOW_CONF.Reg) & 0x4) >> 2
}
func (o *UART_Type) SetFLOW_CONF_FORCE_XOFF(value uint32) {
	volatile.StoreUint32(&o.FLOW_CONF.Reg, volatile.LoadUint32(&o.FLOW_CONF.Reg)&^(0x8)|value<<3)
}
func (o *UART_Type) GetFLOW_CONF_FORCE_XOFF() uint32 {
	return (volatile.LoadUint32(&o.FLOW_CONF.Reg) & 0x8) >> 3
}
func (o *UART_Type) SetFLOW_CONF_SEND_XON(value uint32) {
	volatile.StoreUint32(&o.FLOW_CONF.Reg, volatile.LoadUint32(&o.FLOW_CONF.Reg)&^(0x10)|value<<4)
}
func (o *UART_Type) GetFLOW_CONF_SEND_XON() uint32 {
	return (volatile.LoadUint32(&o.FLOW_CONF.Reg) & 0x10) >> 4
}
func (o *UART_Type) SetFLOW_CONF_SEND_XOFF(value uint32) {
	volatile.StoreUint32(&o.FLOW_CONF.Reg, volatile.LoadUint32(&o.FLOW_CONF.Reg)&^(0x20)|value<<5)
}
func (o *UART_Type) GetFLOW_CONF_SEND_XOFF() uint32 {
	return (volatile.LoadUint32(&o.FLOW_CONF.Reg) & 0x20) >> 5
}

// UART.SLEEP_CONF: Sleep-mode configuration
func (o *UART_Type) SetSLEEP_CONF_ACTIVE_THRESHOLD(value uint32) {
	volatile.StoreUint32(&o.SLEEP_CONF.Reg, volatile.LoadUint32(&o.SLEEP_CONF.Reg)&^(0x3ff)|value)
}
func (o *UART_Type) GetSLEEP_CONF_ACTIVE_THRESHOLD() uint32 {
	return volatile.LoadUint32(&o.SLEEP_CONF.Reg) & 0x3ff
}

// UART.SWFC_CONF0: Software flow-control character configuration
func (o *UART_Type) SetSWFC_CONF0_XOFF_THRESHOLD(value uint32) {
	volatile.StoreUint32(&o.SWFC_CONF0.Reg, volatile.LoadUint32(&o.SWFC_CONF0.Reg)&^(0x1ff)|value)
}
func (o *UART_Type) GetSWFC_CONF0_XOFF_THRESHOLD() uint32 {
	return volatile.LoadUint32(&o.SWFC_CONF0.Reg) & 0x1ff
}
func (o *UART_Type) SetSWFC_CONF0_XOFF_CHAR(value uint32) {
	volatile.StoreUint32(&o.SWFC_CONF0.Reg, volatile.LoadUint32(&o.SWFC_CONF0.Reg)&^(0x1fe00)|value<<9)
}
func (o *UART_Type) GetSWFC_CONF0_XOFF_CHAR() uint32 {
	return (volatile.LoadUint32(&o.SWFC_CONF0.Reg) & 0x1fe00) >> 9
}

// UART.SWFC_CONF1: Software flow-control character configuration
func (o *UART_Type) SetSWFC_CONF1_XON_THRESHOLD(value uint32) {
	volatile.StoreUint32(&o.SWFC_CONF1.Reg, volatile.LoadUint32(&o.SWFC_CONF1.Reg)&^(0x1ff)|value)
}
func (o *UART_Type) GetSWFC_CONF1_XON_THRESHOLD() uint32 {
	return volatile.LoadUint32(&o.SWFC_CONF1.Reg) & 0x1ff
}
func (o *UART_Type) SetSWFC_CONF1_XON_CHAR(value uint32) {
	volatile.StoreUint32(&o.SWFC_CONF1.Reg, volatile.LoadUint32(&o.SWFC_CONF1.Reg)&^(0x1fe00)|value<<9)
}
func (o *UART_Type) GetSWFC_CONF1_XON_CHAR() uint32 {
	return (volatile.LoadUint32(&o.SWFC_CONF1.Reg) & 0x1fe00) >> 9
}

// UART.TXBRK_CONF: Tx Break character configuration
func (o *UART_Type) SetTXBRK_CONF_TX_BRK_NUM(value uint32) {
	volatile.StoreUint32(&o.TXBRK_CONF.Reg, volatile.LoadUint32(&o.TXBRK_CONF.Reg)&^(0xff)|value)
}
func (o *UART_Type) GetTXBRK_CONF_TX_BRK_NUM() uint32 {
	return volatile.LoadUint32(&o.TXBRK_CONF.Reg) & 0xff
}

// UART.IDLE_CONF: Frame-end idle configuration
func (o *UART_Type) SetIDLE_CONF_RX_IDLE_THRHD(value uint32) {
	volatile.StoreUint32(&o.IDLE_CONF.Reg, volatile.LoadUint32(&o.IDLE_CONF.Reg)&^(0x3ff)|value)
}
func (o *UART_Type) GetIDLE_CONF_RX_IDLE_THRHD() uint32 {
	return volatile.LoadUint32(&o.IDLE_CONF.Reg) & 0x3ff
}
func (o *UART_Type) SetIDLE_CONF_TX_IDLE_NUM(value uint32) {
	volatile.StoreUint32(&o.IDLE_CONF.Reg, volatile.LoadUint32(&o.IDLE_CONF.Reg)&^(0xffc00)|value<<10)
}
func (o *UART_Type) GetIDLE_CONF_TX_IDLE_NUM() uint32 {
	return (volatile.LoadUint32(&o.IDLE_CONF.Reg) & 0xffc00) >> 10
}

// UART.RS485_CONF: RS485 mode configuration
func (o *UART_Type) SetRS485_CONF_RS485_EN(value uint32) {
	volatile.StoreUint32(&o.RS485_CONF.Reg, volatile.LoadUint32(&o.RS485_CONF.Reg)&^(0x1)|value)
}
func (o *UART_Type) GetRS485_CONF_RS485_EN() uint32 {
	return volatile.LoadUint32(&o.RS485_CONF.Reg) & 0x1
}
func (o *UART_Type) SetRS485_CONF_DL0_EN(value uint32) {
	volatile.StoreUint32(&o.RS485_CONF.Reg, volatile.LoadUint32(&o.RS485_CONF.Reg)&^(0x2)|value<<1)
}
func (o *UART_Type) GetRS485_CONF_DL0_EN() uint32 {
	return (volatile.LoadUint32(&o.RS485_CONF.Reg) & 0x2) >> 1
}
func (o *UART_Type) SetRS485_CONF_DL1_EN(value uint32) {
	volatile.StoreUint32(&o.RS485_CONF.Reg, volatile.LoadUint32(&o.RS485_CONF.Reg)&^(0x4)|value<<2)
}
func (o *UART_Type) GetRS485_CONF_DL1_EN() uint32 {
	return (volatile.LoadUint32(&o.RS485_CONF.Reg) & 0x4) >> 2
}
func (o *UART_Type) SetRS485_CONF_RS485TX_RX_EN(value uint32) {
	volatile.StoreUint32(&o.RS485_CONF.Reg, volatile.LoadUint32(&o.RS485_CONF.Reg)&^(0x8)|value<<3)
}
func (o *UART_Type) GetRS485_CONF_RS485TX_RX_EN() uint32 {
	return (volatile.LoadUint32(&o.RS485_CONF.Reg) & 0x8) >> 3
}
func (o *UART_Type) SetRS485_CONF_RS485RXBY_TX_EN(value uint32) {
	volatile.StoreUint32(&o.RS485_CONF.Reg, volatile.LoadUint32(&o.RS485_CONF.Reg)&^(0x10)|value<<4)
}
func (o *UART_Type) GetRS485_CONF_RS485RXBY_TX_EN() uint32 {
	return (volatile.LoadUint32(&o.RS485_CONF.Reg) & 0x10) >> 4
}
func (o *UART_Type) SetRS485_CONF_RS485_RX_DLY_NUM(value uint32) {
	volatile.StoreUint32(&o.RS485_CONF.Reg, volatile.LoadUint32(&o.RS485_CONF.Reg)&^(0x20)|value<<5)
}
func (o *UART_Type) GetRS485_CONF_RS485_RX_DLY_NUM() uint32 {
	return (volatile.LoadUint32(&o.RS485_CONF.Reg) & 0x20) >> 5
}
func (o *UART_Type) SetRS485_CONF_RS485_TX_DLY_NUM(value uint32) {
	volatile.StoreUint32(&o.RS485_CONF.Reg, volatile.LoadUint32(&o.RS485_CONF.Reg)&^(0x3c0)|value<<6)
}
func (o *UART_Type) GetRS485_CONF_RS485_TX_DLY_NUM() uint32 {
	return (volatile.LoadUint32(&o.RS485_CONF.Reg) & 0x3c0) >> 6
}

// UART.AT_CMD_PRECNT: Pre-sequence timing configuration
func (o *UART_Type) SetAT_CMD_PRECNT_PRE_IDLE_NUM(value uint32) {
	volatile.StoreUint32(&o.AT_CMD_PRECNT.Reg, volatile.LoadUint32(&o.AT_CMD_PRECNT.Reg)&^(0xffff)|value)
}
func (o *UART_Type) GetAT_CMD_PRECNT_PRE_IDLE_NUM() uint32 {
	return volatile.LoadUint32(&o.AT_CMD_PRECNT.Reg) & 0xffff
}

// UART.AT_CMD_POSTCNT: Post-sequence timing configuration
func (o *UART_Type) SetAT_CMD_POSTCNT_POST_IDLE_NUM(value uint32) {
	volatile.StoreUint32(&o.AT_CMD_POSTCNT.Reg, volatile.LoadUint32(&o.AT_CMD_POSTCNT.Reg)&^(0xffff)|value)
}
func (o *UART_Type) GetAT_CMD_POSTCNT_POST_IDLE_NUM() uint32 {
	return volatile.LoadUint32(&o.AT_CMD_POSTCNT.Reg) & 0xffff
}

// UART.AT_CMD_GAPTOUT: Timeout configuration
func (o *UART_Type) SetAT_CMD_GAPTOUT_RX_GAP_TOUT(value uint32) {
	volatile.StoreUint32(&o.AT_CMD_GAPTOUT.Reg, volatile.LoadUint32(&o.AT_CMD_GAPTOUT.Reg)&^(0xffff)|value)
}
func (o *UART_Type) GetAT_CMD_GAPTOUT_RX_GAP_TOUT() uint32 {
	return volatile.LoadUint32(&o.AT_CMD_GAPTOUT.Reg) & 0xffff
}

// UART.AT_CMD_CHAR: AT escape sequence detection configuration
func (o *UART_Type) SetAT_CMD_CHAR(value uint32) {
	volatile.StoreUint32(&o.AT_CMD_CHAR.Reg, volatile.LoadUint32(&o.AT_CMD_CHAR.Reg)&^(0xff)|value)
}
func (o *UART_Type) GetAT_CMD_CHAR() uint32 {
	return volatile.LoadUint32(&o.AT_CMD_CHAR.Reg) & 0xff
}
func (o *UART_Type) SetAT_CMD_CHAR_CHAR_NUM(value uint32) {
	volatile.StoreUint32(&o.AT_CMD_CHAR.Reg, volatile.LoadUint32(&o.AT_CMD_CHAR.Reg)&^(0xff00)|value<<8)
}
func (o *UART_Type) GetAT_CMD_CHAR_CHAR_NUM() uint32 {
	return (volatile.LoadUint32(&o.AT_CMD_CHAR.Reg) & 0xff00) >> 8
}

// UART.MEM_CONF: UART threshold and allocation configuration
func (o *UART_Type) SetMEM_CONF_RX_SIZE(value uint32) {
	volatile.StoreUint32(&o.MEM_CONF.Reg, volatile.LoadUint32(&o.MEM_CONF.Reg)&^(0xe)|value<<1)
}
func (o *UART_Type) GetMEM_CONF_RX_SIZE() uint32 {
	return (volatile.LoadUint32(&o.MEM_CONF.Reg) & 0xe) >> 1
}
func (o *UART_Type) SetMEM_CONF_TX_SIZE(value uint32) {
	volatile.StoreUint32(&o.MEM_CONF.Reg, volatile.LoadUint32(&o.MEM_CONF.Reg)&^(0x70)|value<<4)
}
func (o *UART_Type) GetMEM_CONF_TX_SIZE() uint32 {
	return (volatile.LoadUint32(&o.MEM_CONF.Reg) & 0x70) >> 4
}
func (o *UART_Type) SetMEM_CONF_RX_FLOW_THRHD(value uint32) {
	volatile.StoreUint32(&o.MEM_CONF.Reg, volatile.LoadUint32(&o.MEM_CONF.Reg)&^(0xff80)|value<<7)
}
func (o *UART_Type) GetMEM_CONF_RX_FLOW_THRHD() uint32 {
	return (volatile.LoadUint32(&o.MEM_CONF.Reg) & 0xff80) >> 7
}
func (o *UART_Type) SetMEM_CONF_RX_TOUT_THRHD(value uint32) {
	volatile.StoreUint32(&o.MEM_CONF.Reg, volatile.LoadUint32(&o.MEM_CONF.Reg)&^(0x3ff0000)|value<<16)
}
func (o *UART_Type) GetMEM_CONF_RX_TOUT_THRHD() uint32 {
	return (volatile.LoadUint32(&o.MEM_CONF.Reg) & 0x3ff0000) >> 16
}
func (o *UART_Type) SetMEM_CONF_MEM_FORCE_PD(value uint32) {
	volatile.StoreUint32(&o.MEM_CONF.Reg, volatile.LoadUint32(&o.MEM_CONF.Reg)&^(0x4000000)|value<<26)
}
func (o *UART_Type) GetMEM_CONF_MEM_FORCE_PD() uint32 {
	return (volatile.LoadUint32(&o.MEM_CONF.Reg) & 0x4000000) >> 26
}
func (o *UART_Type) SetMEM_CONF_MEM_FORCE_PU(value uint32) {
	volatile.StoreUint32(&o.MEM_CONF.Reg, volatile.LoadUint32(&o.MEM_CONF.Reg)&^(0x8000000)|value<<27)
}
func (o *UART_Type) GetMEM_CONF_MEM_FORCE_PU() uint32 {
	return (volatile.LoadUint32(&o.MEM_CONF.Reg) & 0x8000000) >> 27
}

// UART.MEM_TX_STATUS: Tx-FIFO write and read offset address.
func (o *UART_Type) SetMEM_TX_STATUS_APB_TX_WADDR(value uint32) {
	volatile.StoreUint32(&o.MEM_TX_STATUS.Reg, volatile.LoadUint32(&o.MEM_TX_STATUS.Reg)&^(0x3ff)|value)
}
func (o *UART_Type) GetMEM_TX_STATUS_APB_TX_WADDR() uint32 {
	return volatile.LoadUint32(&o.MEM_TX_STATUS.Reg) & 0x3ff
}
func (o *UART_Type) SetMEM_TX_STATUS_TX_RADDR(value uint32) {
	volatile.StoreUint32(&o.MEM_TX_STATUS.Reg, volatile.LoadUint32(&o.MEM_TX_STATUS.Reg)&^(0x1ff800)|value<<11)
}
func (o *UART_Type) GetMEM_TX_STATUS_TX_RADDR() uint32 {
	return (volatile.LoadUint32(&o.MEM_TX_STATUS.Reg) & 0x1ff800) >> 11
}

// UART.MEM_RX_STATUS: Rx-FIFO write and read offset address.
func (o *UART_Type) SetMEM_RX_STATUS_APB_RX_RADDR(value uint32) {
	volatile.StoreUint32(&o.MEM_RX_STATUS.Reg, volatile.LoadUint32(&o.MEM_RX_STATUS.Reg)&^(0x3ff)|value)
}
func (o *UART_Type) GetMEM_RX_STATUS_APB_RX_RADDR() uint32 {
	return volatile.LoadUint32(&o.MEM_RX_STATUS.Reg) & 0x3ff
}
func (o *UART_Type) SetMEM_RX_STATUS_RX_WADDR(value uint32) {
	volatile.StoreUint32(&o.MEM_RX_STATUS.Reg, volatile.LoadUint32(&o.MEM_RX_STATUS.Reg)&^(0x1ff800)|value<<11)
}
func (o *UART_Type) GetMEM_RX_STATUS_RX_WADDR() uint32 {
	return (volatile.LoadUint32(&o.MEM_RX_STATUS.Reg) & 0x1ff800) >> 11
}

// UART.FSM_STATUS: UART transmit and receive status.
func (o *UART_Type) SetFSM_STATUS_ST_URX_OUT(value uint32) {
	volatile.StoreUint32(&o.FSM_STATUS.Reg, volatile.LoadUint32(&o.FSM_STATUS.Reg)&^(0xf)|value)
}
func (o *UART_Type) GetFSM_STATUS_ST_URX_OUT() uint32 {
	return volatile.LoadUint32(&o.FSM_STATUS.Reg) & 0xf
}
func (o *UART_Type) SetFSM_STATUS_ST_UTX_OUT(value uint32) {
	volatile.StoreUint32(&o.FSM_STATUS.Reg, volatile.LoadUint32(&o.FSM_STATUS.Reg)&^(0xf0)|value<<4)
}
func (o *UART_Type) GetFSM_STATUS_ST_UTX_OUT() uint32 {
	return (volatile.LoadUint32(&o.FSM_STATUS.Reg) & 0xf0) >> 4
}

// UART.POSPULSE: Autobaud high pulse register
func (o *UART_Type) SetPOSPULSE_POSEDGE_MIN_CNT(value uint32) {
	volatile.StoreUint32(&o.POSPULSE.Reg, volatile.LoadUint32(&o.POSPULSE.Reg)&^(0xfff)|value)
}
func (o *UART_Type) GetPOSPULSE_POSEDGE_MIN_CNT() uint32 {
	return volatile.LoadUint32(&o.POSPULSE.Reg) & 0xfff
}

// UART.NEGPULSE: Autobaud low pulse register
func (o *UART_Type) SetNEGPULSE_NEGEDGE_MIN_CNT(value uint32) {
	volatile.StoreUint32(&o.NEGPULSE.Reg, volatile.LoadUint32(&o.NEGPULSE.Reg)&^(0xfff)|value)
}
func (o *UART_Type) GetNEGPULSE_NEGEDGE_MIN_CNT() uint32 {
	return volatile.LoadUint32(&o.NEGPULSE.Reg) & 0xfff
}

// UART.CLK_CONF: UART core clock configuration
func (o *UART_Type) SetCLK_CONF_SCLK_DIV_B(value uint32) {
	volatile.StoreUint32(&o.CLK_CONF.Reg, volatile.LoadUint32(&o.CLK_CONF.Reg)&^(0x3f)|value)
}
func (o *UART_Type) GetCLK_CONF_SCLK_DIV_B() uint32 {
	return volatile.LoadUint32(&o.CLK_CONF.Reg) & 0x3f
}
func (o *UART_Type) SetCLK_CONF_SCLK_DIV_A(value uint32) {
	volatile.StoreUint32(&o.CLK_CONF.Reg, volatile.LoadUint32(&o.CLK_CONF.Reg)&^(0xfc0)|value<<6)
}
func (o *UART_Type) GetCLK_CONF_SCLK_DIV_A() uint32 {
	return (volatile.LoadUint32(&o.CLK_CONF.Reg) & 0xfc0) >> 6
}
func (o *UART_Type) SetCLK_CONF_SCLK_DIV_NUM(value uint32) {
	volatile.StoreUint32(&o.CLK_CONF.Reg, volatile.LoadUint32(&o.CLK_CONF.Reg)&^(0xff000)|value<<12)
}
func (o *UART_Type) GetCLK_CONF_SCLK_DIV_NUM() uint32 {
	return (volatile.LoadUint32(&o.CLK_CONF.Reg) & 0xff000) >> 12
}
func (o *UART_Type) SetCLK_CONF_SCLK_SEL(value uint32) {
	volatile.StoreUint32(&o.CLK_CONF.Reg, volatile.LoadUint32(&o.CLK_CONF.Reg)&^(0x300000)|value<<20)
}
func (o *UART_Type) GetCLK_CONF_SCLK_SEL() uint32 {
	return (volatile.LoadUint32(&o.CLK_CONF.Reg) & 0x300000) >> 20
}
func (o *UART_Type) SetCLK_CONF_SCLK_EN(value uint32) {
	volatile.StoreUint32(&o.CLK_CONF.Reg, volatile.LoadUint32(&o.CLK_CONF.Reg)&^(0x400000)|value<<22)
}
func (o *UART_Type) GetCLK_CONF_SCLK_EN() uint32 {
	return (volatile.LoadUint32(&o.CLK_CONF.Reg) & 0x400000) >> 22
}
func (o *UART_Type) SetCLK_CONF_RST_CORE(value uint32) {
	volatile.StoreUint32(&o.CLK_CONF.Reg, volatile.LoadUint32(&o.CLK_CONF.Reg)&^(0x800000)|value<<23)
}
func (o *UART_Type) GetCLK_CONF_RST_CORE() uint32 {
	return (volatile.LoadUint32(&o.CLK_CONF.Reg) & 0x800000) >> 23
}
func (o *UART_Type) SetCLK_CONF_TX_SCLK_EN(value uint32) {
	volatile.StoreUint32(&o.CLK_CONF.Reg, volatile.LoadUint32(&o.CLK_CONF.Reg)&^(0x1000000)|value<<24)
}
func (o *UART_Type) GetCLK_CONF_TX_SCLK_EN() uint32 {
	return (volatile.LoadUint32(&o.CLK_CONF.Reg) & 0x1000000) >> 24
}
func (o *UART_Type) SetCLK_CONF_RX_SCLK_EN(value uint32) {
	volatile.StoreUint32(&o.CLK_CONF.Reg, volatile.LoadUint32(&o.CLK_CONF.Reg)&^(0x2000000)|value<<25)
}
func (o *UART_Type) GetCLK_CONF_RX_SCLK_EN() uint32 {
	return (volatile.LoadUint32(&o.CLK_CONF.Reg) & 0x2000000) >> 25
}
func (o *UART_Type) SetCLK_CONF_TX_RST_CORE(value uint32) {
	volatile.StoreUint32(&o.CLK_CONF.Reg, volatile.LoadUint32(&o.CLK_CONF.Reg)&^(0x4000000)|value<<26)
}
func (o *UART_Type) GetCLK_CONF_TX_RST_CORE() uint32 {
	return (volatile.LoadUint32(&o.CLK_CONF.Reg) & 0x4000000) >> 26
}
func (o *UART_Type) SetCLK_CONF_RX_RST_CORE(value uint32) {
	volatile.StoreUint32(&o.CLK_CONF.Reg, volatile.LoadUint32(&o.CLK_CONF.Reg)&^(0x8000000)|value<<27)
}
func (o *UART_Type) GetCLK_CONF_RX_RST_CORE() uint32 {
	return (volatile.LoadUint32(&o.CLK_CONF.Reg) & 0x8000000) >> 27
}

// UART.DATE: UART Version register
func (o *UART_Type) SetDATE(value uint32) {
	volatile.StoreUint32(&o.DATE.Reg, value)
}
func (o *UART_Type) GetDATE() uint32 {
	return volatile.LoadUint32(&o.DATE.Reg)
}

// UART.ID: UART ID register
func (o *UART_Type) SetID(value uint32) {
	volatile.StoreUint32(&o.ID.Reg, volatile.LoadUint32(&o.ID.Reg)&^(0x3fffffff)|value)
}
func (o *UART_Type) GetID() uint32 {
	return volatile.LoadUint32(&o.ID.Reg) & 0x3fffffff
}
func (o *UART_Type) SetID_HIGH_SPEED(value uint32) {
	volatile.StoreUint32(&o.ID.Reg, volatile.LoadUint32(&o.ID.Reg)&^(0x40000000)|value<<30)
}
func (o *UART_Type) GetID_HIGH_SPEED() uint32 {
	return (volatile.LoadUint32(&o.ID.Reg) & 0x40000000) >> 30
}
func (o *UART_Type) SetID_REG_UPDATE(value uint32) {
	volatile.StoreUint32(&o.ID.Reg, volatile.LoadUint32(&o.ID.Reg)&^(0x80000000)|value<<31)
}
func (o *UART_Type) GetID_REG_UPDATE() uint32 {
	return (volatile.LoadUint32(&o.ID.Reg) & 0x80000000) >> 31
}

// Peripheral UHCI
type UHCI_Type struct {
	CONF0        volatile.Register32 // 0x0
	INT_RAW      volatile.Register32 // 0x4
	INT_ST       volatile.Register32 // 0x8
	INT_ENA      volatile.Register32 // 0xC
	INT_CLR      volatile.Register32 // 0x10
	CONF1        volatile.Register32 // 0x14
	STATE0       volatile.Register32 // 0x18
	STATE1       volatile.Register32 // 0x1C
	ESCAPE_CONF  volatile.Register32 // 0x20
	HUNG_CONF    volatile.Register32 // 0x24
	ACK_NUM      volatile.Register32 // 0x28
	RX_HEAD      volatile.Register32 // 0x2C
	QUICK_SENT   volatile.Register32 // 0x30
	REG_Q0_WORD0 volatile.Register32 // 0x34
	REG_Q0_WORD1 volatile.Register32 // 0x38
	REG_Q1_WORD0 volatile.Register32 // 0x3C
	REG_Q1_WORD1 volatile.Register32 // 0x40
	REG_Q2_WORD0 volatile.Register32 // 0x44
	REG_Q2_WORD1 volatile.Register32 // 0x48
	REG_Q3_WORD0 volatile.Register32 // 0x4C
	REG_Q3_WORD1 volatile.Register32 // 0x50
	REG_Q4_WORD0 volatile.Register32 // 0x54
	REG_Q4_WORD1 volatile.Register32 // 0x58
	REG_Q5_WORD0 volatile.Register32 // 0x5C
	REG_Q5_WORD1 volatile.Register32 // 0x60
	REG_Q6_WORD0 volatile.Register32 // 0x64
	REG_Q6_WORD1 volatile.Register32 // 0x68
	ESC_CONF0    volatile.Register32 // 0x6C
	ESC_CONF1    volatile.Register32 // 0x70
	ESC_CONF2    volatile.Register32 // 0x74
	ESC_CONF3    volatile.Register32 // 0x78
	PKT_THRES    volatile.Register32 // 0x7C
	DATE         volatile.Register32 // 0x80
}

// UHCI.CONF0: a
func (o *UHCI_Type) SetCONF0_TX_RST(value uint32) {
	volatile.StoreUint32(&o.CONF0.Reg, volatile.LoadUint32(&o.CONF0.Reg)&^(0x1)|value)
}
func (o *UHCI_Type) GetCONF0_TX_RST() uint32 {
	return volatile.LoadUint32(&o.CONF0.Reg) & 0x1
}
func (o *UHCI_Type) SetCONF0_RX_RST(value uint32) {
	volatile.StoreUint32(&o.CONF0.Reg, volatile.LoadUint32(&o.CONF0.Reg)&^(0x2)|value<<1)
}
func (o *UHCI_Type) GetCONF0_RX_RST() uint32 {
	return (volatile.LoadUint32(&o.CONF0.Reg) & 0x2) >> 1
}
func (o *UHCI_Type) SetCONF0_UART0_CE(value uint32) {
	volatile.StoreUint32(&o.CONF0.Reg, volatile.LoadUint32(&o.CONF0.Reg)&^(0x4)|value<<2)
}
func (o *UHCI_Type) GetCONF0_UART0_CE() uint32 {
	return (volatile.LoadUint32(&o.CONF0.Reg) & 0x4) >> 2
}
func (o *UHCI_Type) SetCONF0_UART1_CE(value uint32) {
	volatile.StoreUint32(&o.CONF0.Reg, volatile.LoadUint32(&o.CONF0.Reg)&^(0x8)|value<<3)
}
func (o *UHCI_Type) GetCONF0_UART1_CE() uint32 {
	return (volatile.LoadUint32(&o.CONF0.Reg) & 0x8) >> 3
}
func (o *UHCI_Type) SetCONF0_SEPER_EN(value uint32) {
	volatile.StoreUint32(&o.CONF0.Reg, volatile.LoadUint32(&o.CONF0.Reg)&^(0x20)|value<<5)
}
func (o *UHCI_Type) GetCONF0_SEPER_EN() uint32 {
	return (volatile.LoadUint32(&o.CONF0.Reg) & 0x20) >> 5
}
func (o *UHCI_Type) SetCONF0_HEAD_EN(value uint32) {
	volatile.StoreUint32(&o.CONF0.Reg, volatile.LoadUint32(&o.CONF0.Reg)&^(0x40)|value<<6)
}
func (o *UHCI_Type) GetCONF0_HEAD_EN() uint32 {
	return (volatile.LoadUint32(&o.CONF0.Reg) & 0x40) >> 6
}
func (o *UHCI_Type) SetCONF0_CRC_REC_EN(value uint32) {
	volatile.StoreUint32(&o.CONF0.Reg, volatile.LoadUint32(&o.CONF0.Reg)&^(0x80)|value<<7)
}
func (o *UHCI_Type) GetCONF0_CRC_REC_EN() uint32 {
	return (volatile.LoadUint32(&o.CONF0.Reg) & 0x80) >> 7
}
func (o *UHCI_Type) SetCONF0_UART_IDLE_EOF_EN(value uint32) {
	volatile.StoreUint32(&o.CONF0.Reg, volatile.LoadUint32(&o.CONF0.Reg)&^(0x100)|value<<8)
}
func (o *UHCI_Type) GetCONF0_UART_IDLE_EOF_EN() uint32 {
	return (volatile.LoadUint32(&o.CONF0.Reg) & 0x100) >> 8
}
func (o *UHCI_Type) SetCONF0_LEN_EOF_EN(value uint32) {
	volatile.StoreUint32(&o.CONF0.Reg, volatile.LoadUint32(&o.CONF0.Reg)&^(0x200)|value<<9)
}
func (o *UHCI_Type) GetCONF0_LEN_EOF_EN() uint32 {
	return (volatile.LoadUint32(&o.CONF0.Reg) & 0x200) >> 9
}
func (o *UHCI_Type) SetCONF0_ENCODE_CRC_EN(value uint32) {
	volatile.StoreUint32(&o.CONF0.Reg, volatile.LoadUint32(&o.CONF0.Reg)&^(0x400)|value<<10)
}
func (o *UHCI_Type) GetCONF0_ENCODE_CRC_EN() uint32 {
	return (volatile.LoadUint32(&o.CONF0.Reg) & 0x400) >> 10
}
func (o *UHCI_Type) SetCONF0_CLK_EN(value uint32) {
	volatile.StoreUint32(&o.CONF0.Reg, volatile.LoadUint32(&o.CONF0.Reg)&^(0x800)|value<<11)
}
func (o *UHCI_Type) GetCONF0_CLK_EN() uint32 {
	return (volatile.LoadUint32(&o.CONF0.Reg) & 0x800) >> 11
}
func (o *UHCI_Type) SetCONF0_UART_RX_BRK_EOF_EN(value uint32) {
	volatile.StoreUint32(&o.CONF0.Reg, volatile.LoadUint32(&o.CONF0.Reg)&^(0x1000)|value<<12)
}
func (o *UHCI_Type) GetCONF0_UART_RX_BRK_EOF_EN() uint32 {
	return (volatile.LoadUint32(&o.CONF0.Reg) & 0x1000) >> 12
}

// UHCI.INT_RAW: a
func (o *UHCI_Type) SetINT_RAW_RX_START_INT_RAW(value uint32) {
	volatile.StoreUint32(&o.INT_RAW.Reg, volatile.LoadUint32(&o.INT_RAW.Reg)&^(0x1)|value)
}
func (o *UHCI_Type) GetINT_RAW_RX_START_INT_RAW() uint32 {
	return volatile.LoadUint32(&o.INT_RAW.Reg) & 0x1
}
func (o *UHCI_Type) SetINT_RAW_TX_START_INT_RAW(value uint32) {
	volatile.StoreUint32(&o.INT_RAW.Reg, volatile.LoadUint32(&o.INT_RAW.Reg)&^(0x2)|value<<1)
}
func (o *UHCI_Type) GetINT_RAW_TX_START_INT_RAW() uint32 {
	return (volatile.LoadUint32(&o.INT_RAW.Reg) & 0x2) >> 1
}
func (o *UHCI_Type) SetINT_RAW_RX_HUNG_INT_RAW(value uint32) {
	volatile.StoreUint32(&o.INT_RAW.Reg, volatile.LoadUint32(&o.INT_RAW.Reg)&^(0x4)|value<<2)
}
func (o *UHCI_Type) GetINT_RAW_RX_HUNG_INT_RAW() uint32 {
	return (volatile.LoadUint32(&o.INT_RAW.Reg) & 0x4) >> 2
}
func (o *UHCI_Type) SetINT_RAW_TX_HUNG_INT_RAW(value uint32) {
	volatile.StoreUint32(&o.INT_RAW.Reg, volatile.LoadUint32(&o.INT_RAW.Reg)&^(0x8)|value<<3)
}
func (o *UHCI_Type) GetINT_RAW_TX_HUNG_INT_RAW() uint32 {
	return (volatile.LoadUint32(&o.INT_RAW.Reg) & 0x8) >> 3
}
func (o *UHCI_Type) SetINT_RAW_SEND_S_REG_Q_INT_RAW(value uint32) {
	volatile.StoreUint32(&o.INT_RAW.Reg, volatile.LoadUint32(&o.INT_RAW.Reg)&^(0x10)|value<<4)
}
func (o *UHCI_Type) GetINT_RAW_SEND_S_REG_Q_INT_RAW() uint32 {
	return (volatile.LoadUint32(&o.INT_RAW.Reg) & 0x10) >> 4
}
func (o *UHCI_Type) SetINT_RAW_SEND_A_REG_Q_INT_RAW(value uint32) {
	volatile.StoreUint32(&o.INT_RAW.Reg, volatile.LoadUint32(&o.INT_RAW.Reg)&^(0x20)|value<<5)
}
func (o *UHCI_Type) GetINT_RAW_SEND_A_REG_Q_INT_RAW() uint32 {
	return (volatile.LoadUint32(&o.INT_RAW.Reg) & 0x20) >> 5
}
func (o *UHCI_Type) SetINT_RAW_OUT_EOF_INT_RAW(value uint32) {
	volatile.StoreUint32(&o.INT_RAW.Reg, volatile.LoadUint32(&o.INT_RAW.Reg)&^(0x40)|value<<6)
}
func (o *UHCI_Type) GetINT_RAW_OUT_EOF_INT_RAW() uint32 {
	return (volatile.LoadUint32(&o.INT_RAW.Reg) & 0x40) >> 6
}
func (o *UHCI_Type) SetINT_RAW_APP_CTRL0_INT_RAW(value uint32) {
	volatile.StoreUint32(&o.INT_RAW.Reg, volatile.LoadUint32(&o.INT_RAW.Reg)&^(0x80)|value<<7)
}
func (o *UHCI_Type) GetINT_RAW_APP_CTRL0_INT_RAW() uint32 {
	return (volatile.LoadUint32(&o.INT_RAW.Reg) & 0x80) >> 7
}
func (o *UHCI_Type) SetINT_RAW_APP_CTRL1_INT_RAW(value uint32) {
	volatile.StoreUint32(&o.INT_RAW.Reg, volatile.LoadUint32(&o.INT_RAW.Reg)&^(0x100)|value<<8)
}
func (o *UHCI_Type) GetINT_RAW_APP_CTRL1_INT_RAW() uint32 {
	return (volatile.LoadUint32(&o.INT_RAW.Reg) & 0x100) >> 8
}

// UHCI.INT_ST: a
func (o *UHCI_Type) SetINT_ST_RX_START_INT_ST(value uint32) {
	volatile.StoreUint32(&o.INT_ST.Reg, volatile.LoadUint32(&o.INT_ST.Reg)&^(0x1)|value)
}
func (o *UHCI_Type) GetINT_ST_RX_START_INT_ST() uint32 {
	return volatile.LoadUint32(&o.INT_ST.Reg) & 0x1
}
func (o *UHCI_Type) SetINT_ST_TX_START_INT_ST(value uint32) {
	volatile.StoreUint32(&o.INT_ST.Reg, volatile.LoadUint32(&o.INT_ST.Reg)&^(0x2)|value<<1)
}
func (o *UHCI_Type) GetINT_ST_TX_START_INT_ST() uint32 {
	return (volatile.LoadUint32(&o.INT_ST.Reg) & 0x2) >> 1
}
func (o *UHCI_Type) SetINT_ST_RX_HUNG_INT_ST(value uint32) {
	volatile.StoreUint32(&o.INT_ST.Reg, volatile.LoadUint32(&o.INT_ST.Reg)&^(0x4)|value<<2)
}
func (o *UHCI_Type) GetINT_ST_RX_HUNG_INT_ST() uint32 {
	return (volatile.LoadUint32(&o.INT_ST.Reg) & 0x4) >> 2
}
func (o *UHCI_Type) SetINT_ST_TX_HUNG_INT_ST(value uint32) {
	volatile.StoreUint32(&o.INT_ST.Reg, volatile.LoadUint32(&o.INT_ST.Reg)&^(0x8)|value<<3)
}
func (o *UHCI_Type) GetINT_ST_TX_HUNG_INT_ST() uint32 {
	return (volatile.LoadUint32(&o.INT_ST.Reg) & 0x8) >> 3
}
func (o *UHCI_Type) SetINT_ST_SEND_S_REG_Q_INT_ST(value uint32) {
	volatile.StoreUint32(&o.INT_ST.Reg, volatile.LoadUint32(&o.INT_ST.Reg)&^(0x10)|value<<4)
}
func (o *UHCI_Type) GetINT_ST_SEND_S_REG_Q_INT_ST() uint32 {
	return (volatile.LoadUint32(&o.INT_ST.Reg) & 0x10) >> 4
}
func (o *UHCI_Type) SetINT_ST_SEND_A_REG_Q_INT_ST(value uint32) {
	volatile.StoreUint32(&o.INT_ST.Reg, volatile.LoadUint32(&o.INT_ST.Reg)&^(0x20)|value<<5)
}
func (o *UHCI_Type) GetINT_ST_SEND_A_REG_Q_INT_ST() uint32 {
	return (volatile.LoadUint32(&o.INT_ST.Reg) & 0x20) >> 5
}
func (o *UHCI_Type) SetINT_ST_OUTLINK_EOF_ERR_INT_ST(value uint32) {
	volatile.StoreUint32(&o.INT_ST.Reg, volatile.LoadUint32(&o.INT_ST.Reg)&^(0x40)|value<<6)
}
func (o *UHCI_Type) GetINT_ST_OUTLINK_EOF_ERR_INT_ST() uint32 {
	return (volatile.LoadUint32(&o.INT_ST.Reg) & 0x40) >> 6
}
func (o *UHCI_Type) SetINT_ST_APP_CTRL0_INT_ST(value uint32) {
	volatile.StoreUint32(&o.INT_ST.Reg, volatile.LoadUint32(&o.INT_ST.Reg)&^(0x80)|value<<7)
}
func (o *UHCI_Type) GetINT_ST_APP_CTRL0_INT_ST() uint32 {
	return (volatile.LoadUint32(&o.INT_ST.Reg) & 0x80) >> 7
}
func (o *UHCI_Type) SetINT_ST_APP_CTRL1_INT_ST(value uint32) {
	volatile.StoreUint32(&o.INT_ST.Reg, volatile.LoadUint32(&o.INT_ST.Reg)&^(0x100)|value<<8)
}
func (o *UHCI_Type) GetINT_ST_APP_CTRL1_INT_ST() uint32 {
	return (volatile.LoadUint32(&o.INT_ST.Reg) & 0x100) >> 8
}

// UHCI.INT_ENA: a
func (o *UHCI_Type) SetINT_ENA_RX_START_INT_ENA(value uint32) {
	volatile.StoreUint32(&o.INT_ENA.Reg, volatile.LoadUint32(&o.INT_ENA.Reg)&^(0x1)|value)
}
func (o *UHCI_Type) GetINT_ENA_RX_START_INT_ENA() uint32 {
	return volatile.LoadUint32(&o.INT_ENA.Reg) & 0x1
}
func (o *UHCI_Type) SetINT_ENA_TX_START_INT_ENA(value uint32) {
	volatile.StoreUint32(&o.INT_ENA.Reg, volatile.LoadUint32(&o.INT_ENA.Reg)&^(0x2)|value<<1)
}
func (o *UHCI_Type) GetINT_ENA_TX_START_INT_ENA() uint32 {
	return (volatile.LoadUint32(&o.INT_ENA.Reg) & 0x2) >> 1
}
func (o *UHCI_Type) SetINT_ENA_RX_HUNG_INT_ENA(value uint32) {
	volatile.StoreUint32(&o.INT_ENA.Reg, volatile.LoadUint32(&o.INT_ENA.Reg)&^(0x4)|value<<2)
}
func (o *UHCI_Type) GetINT_ENA_RX_HUNG_INT_ENA() uint32 {
	return (volatile.LoadUint32(&o.INT_ENA.Reg) & 0x4) >> 2
}
func (o *UHCI_Type) SetINT_ENA_TX_HUNG_INT_ENA(value uint32) {
	volatile.StoreUint32(&o.INT_ENA.Reg, volatile.LoadUint32(&o.INT_ENA.Reg)&^(0x8)|value<<3)
}
func (o *UHCI_Type) GetINT_ENA_TX_HUNG_INT_ENA() uint32 {
	return (volatile.LoadUint32(&o.INT_ENA.Reg) & 0x8) >> 3
}
func (o *UHCI_Type) SetINT_ENA_SEND_S_REG_Q_INT_ENA(value uint32) {
	volatile.StoreUint32(&o.INT_ENA.Reg, volatile.LoadUint32(&o.INT_ENA.Reg)&^(0x10)|value<<4)
}
func (o *UHCI_Type) GetINT_ENA_SEND_S_REG_Q_INT_ENA() uint32 {
	return (volatile.LoadUint32(&o.INT_ENA.Reg) & 0x10) >> 4
}
func (o *UHCI_Type) SetINT_ENA_SEND_A_REG_Q_INT_ENA(value uint32) {
	volatile.StoreUint32(&o.INT_ENA.Reg, volatile.LoadUint32(&o.INT_ENA.Reg)&^(0x20)|value<<5)
}
func (o *UHCI_Type) GetINT_ENA_SEND_A_REG_Q_INT_ENA() uint32 {
	return (volatile.LoadUint32(&o.INT_ENA.Reg) & 0x20) >> 5
}
func (o *UHCI_Type) SetINT_ENA_OUTLINK_EOF_ERR_INT_ENA(value uint32) {
	volatile.StoreUint32(&o.INT_ENA.Reg, volatile.LoadUint32(&o.INT_ENA.Reg)&^(0x40)|value<<6)
}
func (o *UHCI_Type) GetINT_ENA_OUTLINK_EOF_ERR_INT_ENA() uint32 {
	return (volatile.LoadUint32(&o.INT_ENA.Reg) & 0x40) >> 6
}
func (o *UHCI_Type) SetINT_ENA_APP_CTRL0_INT_ENA(value uint32) {
	volatile.StoreUint32(&o.INT_ENA.Reg, volatile.LoadUint32(&o.INT_ENA.Reg)&^(0x80)|value<<7)
}
func (o *UHCI_Type) GetINT_ENA_APP_CTRL0_INT_ENA() uint32 {
	return (volatile.LoadUint32(&o.INT_ENA.Reg) & 0x80) >> 7
}
func (o *UHCI_Type) SetINT_ENA_APP_CTRL1_INT_ENA(value uint32) {
	volatile.StoreUint32(&o.INT_ENA.Reg, volatile.LoadUint32(&o.INT_ENA.Reg)&^(0x100)|value<<8)
}
func (o *UHCI_Type) GetINT_ENA_APP_CTRL1_INT_ENA() uint32 {
	return (volatile.LoadUint32(&o.INT_ENA.Reg) & 0x100) >> 8
}

// UHCI.INT_CLR: a
func (o *UHCI_Type) SetINT_CLR_RX_START_INT_CLR(value uint32) {
	volatile.StoreUint32(&o.INT_CLR.Reg, volatile.LoadUint32(&o.INT_CLR.Reg)&^(0x1)|value)
}
func (o *UHCI_Type) GetINT_CLR_RX_START_INT_CLR() uint32 {
	return volatile.LoadUint32(&o.INT_CLR.Reg) & 0x1
}
func (o *UHCI_Type) SetINT_CLR_TX_START_INT_CLR(value uint32) {
	volatile.StoreUint32(&o.INT_CLR.Reg, volatile.LoadUint32(&o.INT_CLR.Reg)&^(0x2)|value<<1)
}
func (o *UHCI_Type) GetINT_CLR_TX_START_INT_CLR() uint32 {
	return (volatile.LoadUint32(&o.INT_CLR.Reg) & 0x2) >> 1
}
func (o *UHCI_Type) SetINT_CLR_RX_HUNG_INT_CLR(value uint32) {
	volatile.StoreUint32(&o.INT_CLR.Reg, volatile.LoadUint32(&o.INT_CLR.Reg)&^(0x4)|value<<2)
}
func (o *UHCI_Type) GetINT_CLR_RX_HUNG_INT_CLR() uint32 {
	return (volatile.LoadUint32(&o.INT_CLR.Reg) & 0x4) >> 2
}
func (o *UHCI_Type) SetINT_CLR_TX_HUNG_INT_CLR(value uint32) {
	volatile.StoreUint32(&o.INT_CLR.Reg, volatile.LoadUint32(&o.INT_CLR.Reg)&^(0x8)|value<<3)
}
func (o *UHCI_Type) GetINT_CLR_TX_HUNG_INT_CLR() uint32 {
	return (volatile.LoadUint32(&o.INT_CLR.Reg) & 0x8) >> 3
}
func (o *UHCI_Type) SetINT_CLR_SEND_S_REG_Q_INT_CLR(value uint32) {
	volatile.StoreUint32(&o.INT_CLR.Reg, volatile.LoadUint32(&o.INT_CLR.Reg)&^(0x10)|value<<4)
}
func (o *UHCI_Type) GetINT_CLR_SEND_S_REG_Q_INT_CLR() uint32 {
	return (volatile.LoadUint32(&o.INT_CLR.Reg) & 0x10) >> 4
}
func (o *UHCI_Type) SetINT_CLR_SEND_A_REG_Q_INT_CLR(value uint32) {
	volatile.StoreUint32(&o.INT_CLR.Reg, volatile.LoadUint32(&o.INT_CLR.Reg)&^(0x20)|value<<5)
}
func (o *UHCI_Type) GetINT_CLR_SEND_A_REG_Q_INT_CLR() uint32 {
	return (volatile.LoadUint32(&o.INT_CLR.Reg) & 0x20) >> 5
}
func (o *UHCI_Type) SetINT_CLR_OUTLINK_EOF_ERR_INT_CLR(value uint32) {
	volatile.StoreUint32(&o.INT_CLR.Reg, volatile.LoadUint32(&o.INT_CLR.Reg)&^(0x40)|value<<6)
}
func (o *UHCI_Type) GetINT_CLR_OUTLINK_EOF_ERR_INT_CLR() uint32 {
	return (volatile.LoadUint32(&o.INT_CLR.Reg) & 0x40) >> 6
}
func (o *UHCI_Type) SetINT_CLR_APP_CTRL0_INT_CLR(value uint32) {
	volatile.StoreUint32(&o.INT_CLR.Reg, volatile.LoadUint32(&o.INT_CLR.Reg)&^(0x80)|value<<7)
}
func (o *UHCI_Type) GetINT_CLR_APP_CTRL0_INT_CLR() uint32 {
	return (volatile.LoadUint32(&o.INT_CLR.Reg) & 0x80) >> 7
}
func (o *UHCI_Type) SetINT_CLR_APP_CTRL1_INT_CLR(value uint32) {
	volatile.StoreUint32(&o.INT_CLR.Reg, volatile.LoadUint32(&o.INT_CLR.Reg)&^(0x100)|value<<8)
}
func (o *UHCI_Type) GetINT_CLR_APP_CTRL1_INT_CLR() uint32 {
	return (volatile.LoadUint32(&o.INT_CLR.Reg) & 0x100) >> 8
}

// UHCI.CONF1: a
func (o *UHCI_Type) SetCONF1_CHECK_SUM_EN(value uint32) {
	volatile.StoreUint32(&o.CONF1.Reg, volatile.LoadUint32(&o.CONF1.Reg)&^(0x1)|value)
}
func (o *UHCI_Type) GetCONF1_CHECK_SUM_EN() uint32 {
	return volatile.LoadUint32(&o.CONF1.Reg) & 0x1
}
func (o *UHCI_Type) SetCONF1_CHECK_SEQ_EN(value uint32) {
	volatile.StoreUint32(&o.CONF1.Reg, volatile.LoadUint32(&o.CONF1.Reg)&^(0x2)|value<<1)
}
func (o *UHCI_Type) GetCONF1_CHECK_SEQ_EN() uint32 {
	return (volatile.LoadUint32(&o.CONF1.Reg) & 0x2) >> 1
}
func (o *UHCI_Type) SetCONF1_CRC_DISABLE(value uint32) {
	volatile.StoreUint32(&o.CONF1.Reg, volatile.LoadUint32(&o.CONF1.Reg)&^(0x4)|value<<2)
}
func (o *UHCI_Type) GetCONF1_CRC_DISABLE() uint32 {
	return (volatile.LoadUint32(&o.CONF1.Reg) & 0x4) >> 2
}
func (o *UHCI_Type) SetCONF1_SAVE_HEAD(value uint32) {
	volatile.StoreUint32(&o.CONF1.Reg, volatile.LoadUint32(&o.CONF1.Reg)&^(0x8)|value<<3)
}
func (o *UHCI_Type) GetCONF1_SAVE_HEAD() uint32 {
	return (volatile.LoadUint32(&o.CONF1.Reg) & 0x8) >> 3
}
func (o *UHCI_Type) SetCONF1_TX_CHECK_SUM_RE(value uint32) {
	volatile.StoreUint32(&o.CONF1.Reg, volatile.LoadUint32(&o.CONF1.Reg)&^(0x10)|value<<4)
}
func (o *UHCI_Type) GetCONF1_TX_CHECK_SUM_RE() uint32 {
	return (volatile.LoadUint32(&o.CONF1.Reg) & 0x10) >> 4
}
func (o *UHCI_Type) SetCONF1_TX_ACK_NUM_RE(value uint32) {
	volatile.StoreUint32(&o.CONF1.Reg, volatile.LoadUint32(&o.CONF1.Reg)&^(0x20)|value<<5)
}
func (o *UHCI_Type) GetCONF1_TX_ACK_NUM_RE() uint32 {
	return (volatile.LoadUint32(&o.CONF1.Reg) & 0x20) >> 5
}
func (o *UHCI_Type) SetCONF1_WAIT_SW_START(value uint32) {
	volatile.StoreUint32(&o.CONF1.Reg, volatile.LoadUint32(&o.CONF1.Reg)&^(0x80)|value<<7)
}
func (o *UHCI_Type) GetCONF1_WAIT_SW_START() uint32 {
	return (volatile.LoadUint32(&o.CONF1.Reg) & 0x80) >> 7
}
func (o *UHCI_Type) SetCONF1_SW_START(value uint32) {
	volatile.StoreUint32(&o.CONF1.Reg, volatile.LoadUint32(&o.CONF1.Reg)&^(0x100)|value<<8)
}
func (o *UHCI_Type) GetCONF1_SW_START() uint32 {
	return (volatile.LoadUint32(&o.CONF1.Reg) & 0x100) >> 8
}

// UHCI.STATE0: a
func (o *UHCI_Type) SetSTATE0_RX_ERR_CAUSE(value uint32) {
	volatile.StoreUint32(&o.STATE0.Reg, volatile.LoadUint32(&o.STATE0.Reg)&^(0x7)|value)
}
func (o *UHCI_Type) GetSTATE0_RX_ERR_CAUSE() uint32 {
	return volatile.LoadUint32(&o.STATE0.Reg) & 0x7
}
func (o *UHCI_Type) SetSTATE0_DECODE_STATE(value uint32) {
	volatile.StoreUint32(&o.STATE0.Reg, volatile.LoadUint32(&o.STATE0.Reg)&^(0x38)|value<<3)
}
func (o *UHCI_Type) GetSTATE0_DECODE_STATE() uint32 {
	return (volatile.LoadUint32(&o.STATE0.Reg) & 0x38) >> 3
}

// UHCI.STATE1: a
func (o *UHCI_Type) SetSTATE1_ENCODE_STATE(value uint32) {
	volatile.StoreUint32(&o.STATE1.Reg, volatile.LoadUint32(&o.STATE1.Reg)&^(0x7)|value)
}
func (o *UHCI_Type) GetSTATE1_ENCODE_STATE() uint32 {
	return volatile.LoadUint32(&o.STATE1.Reg) & 0x7
}

// UHCI.ESCAPE_CONF: a
func (o *UHCI_Type) SetESCAPE_CONF_TX_C0_ESC_EN(value uint32) {
	volatile.StoreUint32(&o.ESCAPE_CONF.Reg, volatile.LoadUint32(&o.ESCAPE_CONF.Reg)&^(0x1)|value)
}
func (o *UHCI_Type) GetESCAPE_CONF_TX_C0_ESC_EN() uint32 {
	return volatile.LoadUint32(&o.ESCAPE_CONF.Reg) & 0x1
}
func (o *UHCI_Type) SetESCAPE_CONF_TX_DB_ESC_EN(value uint32) {
	volatile.StoreUint32(&o.ESCAPE_CONF.Reg, volatile.LoadUint32(&o.ESCAPE_CONF.Reg)&^(0x2)|value<<1)
}
func (o *UHCI_Type) GetESCAPE_CONF_TX_DB_ESC_EN() uint32 {
	return (volatile.LoadUint32(&o.ESCAPE_CONF.Reg) & 0x2) >> 1
}
func (o *UHCI_Type) SetESCAPE_CONF_TX_11_ESC_EN(value uint32) {
	volatile.StoreUint32(&o.ESCAPE_CONF.Reg, volatile.LoadUint32(&o.ESCAPE_CONF.Reg)&^(0x4)|value<<2)
}
func (o *UHCI_Type) GetESCAPE_CONF_TX_11_ESC_EN() uint32 {
	return (volatile.LoadUint32(&o.ESCAPE_CONF.Reg) & 0x4) >> 2
}
func (o *UHCI_Type) SetESCAPE_CONF_TX_13_ESC_EN(value uint32) {
	volatile.StoreUint32(&o.ESCAPE_CONF.Reg, volatile.LoadUint32(&o.ESCAPE_CONF.Reg)&^(0x8)|value<<3)
}
func (o *UHCI_Type) GetESCAPE_CONF_TX_13_ESC_EN() uint32 {
	return (volatile.LoadUint32(&o.ESCAPE_CONF.Reg) & 0x8) >> 3
}
func (o *UHCI_Type) SetESCAPE_CONF_RX_C0_ESC_EN(value uint32) {
	volatile.StoreUint32(&o.ESCAPE_CONF.Reg, volatile.LoadUint32(&o.ESCAPE_CONF.Reg)&^(0x10)|value<<4)
}
func (o *UHCI_Type) GetESCAPE_CONF_RX_C0_ESC_EN() uint32 {
	return (volatile.LoadUint32(&o.ESCAPE_CONF.Reg) & 0x10) >> 4
}
func (o *UHCI_Type) SetESCAPE_CONF_RX_DB_ESC_EN(value uint32) {
	volatile.StoreUint32(&o.ESCAPE_CONF.Reg, volatile.LoadUint32(&o.ESCAPE_CONF.Reg)&^(0x20)|value<<5)
}
func (o *UHCI_Type) GetESCAPE_CONF_RX_DB_ESC_EN() uint32 {
	return (volatile.LoadUint32(&o.ESCAPE_CONF.Reg) & 0x20) >> 5
}
func (o *UHCI_Type) SetESCAPE_CONF_RX_11_ESC_EN(value uint32) {
	volatile.StoreUint32(&o.ESCAPE_CONF.Reg, volatile.LoadUint32(&o.ESCAPE_CONF.Reg)&^(0x40)|value<<6)
}
func (o *UHCI_Type) GetESCAPE_CONF_RX_11_ESC_EN() uint32 {
	return (volatile.LoadUint32(&o.ESCAPE_CONF.Reg) & 0x40) >> 6
}
func (o *UHCI_Type) SetESCAPE_CONF_RX_13_ESC_EN(value uint32) {
	volatile.StoreUint32(&o.ESCAPE_CONF.Reg, volatile.LoadUint32(&o.ESCAPE_CONF.Reg)&^(0x80)|value<<7)
}
func (o *UHCI_Type) GetESCAPE_CONF_RX_13_ESC_EN() uint32 {
	return (volatile.LoadUint32(&o.ESCAPE_CONF.Reg) & 0x80) >> 7
}

// UHCI.HUNG_CONF: a
func (o *UHCI_Type) SetHUNG_CONF_TXFIFO_TIMEOUT(value uint32) {
	volatile.StoreUint32(&o.HUNG_CONF.Reg, volatile.LoadUint32(&o.HUNG_CONF.Reg)&^(0xff)|value)
}
func (o *UHCI_Type) GetHUNG_CONF_TXFIFO_TIMEOUT() uint32 {
	return volatile.LoadUint32(&o.HUNG_CONF.Reg) & 0xff
}
func (o *UHCI_Type) SetHUNG_CONF_TXFIFO_TIMEOUT_SHIFT(value uint32) {
	volatile.StoreUint32(&o.HUNG_CONF.Reg, volatile.LoadUint32(&o.HUNG_CONF.Reg)&^(0x700)|value<<8)
}
func (o *UHCI_Type) GetHUNG_CONF_TXFIFO_TIMEOUT_SHIFT() uint32 {
	return (volatile.LoadUint32(&o.HUNG_CONF.Reg) & 0x700) >> 8
}
func (o *UHCI_Type) SetHUNG_CONF_TXFIFO_TIMEOUT_ENA(value uint32) {
	volatile.StoreUint32(&o.HUNG_CONF.Reg, volatile.LoadUint32(&o.HUNG_CONF.Reg)&^(0x800)|value<<11)
}
func (o *UHCI_Type) GetHUNG_CONF_TXFIFO_TIMEOUT_ENA() uint32 {
	return (volatile.LoadUint32(&o.HUNG_CONF.Reg) & 0x800) >> 11
}
func (o *UHCI_Type) SetHUNG_CONF_RXFIFO_TIMEOUT(value uint32) {
	volatile.StoreUint32(&o.HUNG_CONF.Reg, volatile.LoadUint32(&o.HUNG_CONF.Reg)&^(0xff000)|value<<12)
}
func (o *UHCI_Type) GetHUNG_CONF_RXFIFO_TIMEOUT() uint32 {
	return (volatile.LoadUint32(&o.HUNG_CONF.Reg) & 0xff000) >> 12
}
func (o *UHCI_Type) SetHUNG_CONF_RXFIFO_TIMEOUT_SHIFT(value uint32) {
	volatile.StoreUint32(&o.HUNG_CONF.Reg, volatile.LoadUint32(&o.HUNG_CONF.Reg)&^(0x700000)|value<<20)
}
func (o *UHCI_Type) GetHUNG_CONF_RXFIFO_TIMEOUT_SHIFT() uint32 {
	return (volatile.LoadUint32(&o.HUNG_CONF.Reg) & 0x700000) >> 20
}
func (o *UHCI_Type) SetHUNG_CONF_RXFIFO_TIMEOUT_ENA(value uint32) {
	volatile.StoreUint32(&o.HUNG_CONF.Reg, volatile.LoadUint32(&o.HUNG_CONF.Reg)&^(0x800000)|value<<23)
}
func (o *UHCI_Type) GetHUNG_CONF_RXFIFO_TIMEOUT_ENA() uint32 {
	return (volatile.LoadUint32(&o.HUNG_CONF.Reg) & 0x800000) >> 23
}

// UHCI.ACK_NUM: a
func (o *UHCI_Type) SetACK_NUM(value uint32) {
	volatile.StoreUint32(&o.ACK_NUM.Reg, volatile.LoadUint32(&o.ACK_NUM.Reg)&^(0x7)|value)
}
func (o *UHCI_Type) GetACK_NUM() uint32 {
	return volatile.LoadUint32(&o.ACK_NUM.Reg) & 0x7
}
func (o *UHCI_Type) SetACK_NUM_LOAD(value uint32) {
	volatile.StoreUint32(&o.ACK_NUM.Reg, volatile.LoadUint32(&o.ACK_NUM.Reg)&^(0x8)|value<<3)
}
func (o *UHCI_Type) GetACK_NUM_LOAD() uint32 {
	return (volatile.LoadUint32(&o.ACK_NUM.Reg) & 0x8) >> 3
}

// UHCI.RX_HEAD: a
func (o *UHCI_Type) SetRX_HEAD(value uint32) {
	volatile.StoreUint32(&o.RX_HEAD.Reg, value)
}
func (o *UHCI_Type) GetRX_HEAD() uint32 {
	return volatile.LoadUint32(&o.RX_HEAD.Reg)
}

// UHCI.QUICK_SENT: a
func (o *UHCI_Type) SetQUICK_SENT_SINGLE_SEND_NUM(value uint32) {
	volatile.StoreUint32(&o.QUICK_SENT.Reg, volatile.LoadUint32(&o.QUICK_SENT.Reg)&^(0x7)|value)
}
func (o *UHCI_Type) GetQUICK_SENT_SINGLE_SEND_NUM() uint32 {
	return volatile.LoadUint32(&o.QUICK_SENT.Reg) & 0x7
}
func (o *UHCI_Type) SetQUICK_SENT_SINGLE_SEND_EN(value uint32) {
	volatile.StoreUint32(&o.QUICK_SENT.Reg, volatile.LoadUint32(&o.QUICK_SENT.Reg)&^(0x8)|value<<3)
}
func (o *UHCI_Type) GetQUICK_SENT_SINGLE_SEND_EN() uint32 {
	return (volatile.LoadUint32(&o.QUICK_SENT.Reg) & 0x8) >> 3
}
func (o *UHCI_Type) SetQUICK_SENT_ALWAYS_SEND_NUM(value uint32) {
	volatile.StoreUint32(&o.QUICK_SENT.Reg, volatile.LoadUint32(&o.QUICK_SENT.Reg)&^(0x70)|value<<4)
}
func (o *UHCI_Type) GetQUICK_SENT_ALWAYS_SEND_NUM() uint32 {
	return (volatile.LoadUint32(&o.QUICK_SENT.Reg) & 0x70) >> 4
}
func (o *UHCI_Type) SetQUICK_SENT_ALWAYS_SEND_EN(value uint32) {
	volatile.StoreUint32(&o.QUICK_SENT.Reg, volatile.LoadUint32(&o.QUICK_SENT.Reg)&^(0x80)|value<<7)
}
func (o *UHCI_Type) GetQUICK_SENT_ALWAYS_SEND_EN() uint32 {
	return (volatile.LoadUint32(&o.QUICK_SENT.Reg) & 0x80) >> 7
}

// UHCI.REG_Q0_WORD0: a
func (o *UHCI_Type) SetREG_Q0_WORD0(value uint32) {
	volatile.StoreUint32(&o.REG_Q0_WORD0.Reg, value)
}
func (o *UHCI_Type) GetREG_Q0_WORD0() uint32 {
	return volatile.LoadUint32(&o.REG_Q0_WORD0.Reg)
}

// UHCI.REG_Q0_WORD1: a
func (o *UHCI_Type) SetREG_Q0_WORD1(value uint32) {
	volatile.StoreUint32(&o.REG_Q0_WORD1.Reg, value)
}
func (o *UHCI_Type) GetREG_Q0_WORD1() uint32 {
	return volatile.LoadUint32(&o.REG_Q0_WORD1.Reg)
}

// UHCI.REG_Q1_WORD0: a
func (o *UHCI_Type) SetREG_Q1_WORD0(value uint32) {
	volatile.StoreUint32(&o.REG_Q1_WORD0.Reg, value)
}
func (o *UHCI_Type) GetREG_Q1_WORD0() uint32 {
	return volatile.LoadUint32(&o.REG_Q1_WORD0.Reg)
}

// UHCI.REG_Q1_WORD1: a
func (o *UHCI_Type) SetREG_Q1_WORD1(value uint32) {
	volatile.StoreUint32(&o.REG_Q1_WORD1.Reg, value)
}
func (o *UHCI_Type) GetREG_Q1_WORD1() uint32 {
	return volatile.LoadUint32(&o.REG_Q1_WORD1.Reg)
}

// UHCI.REG_Q2_WORD0: a
func (o *UHCI_Type) SetREG_Q2_WORD0(value uint32) {
	volatile.StoreUint32(&o.REG_Q2_WORD0.Reg, value)
}
func (o *UHCI_Type) GetREG_Q2_WORD0() uint32 {
	return volatile.LoadUint32(&o.REG_Q2_WORD0.Reg)
}

// UHCI.REG_Q2_WORD1: a
func (o *UHCI_Type) SetREG_Q2_WORD1(value uint32) {
	volatile.StoreUint32(&o.REG_Q2_WORD1.Reg, value)
}
func (o *UHCI_Type) GetREG_Q2_WORD1() uint32 {
	return volatile.LoadUint32(&o.REG_Q2_WORD1.Reg)
}

// UHCI.REG_Q3_WORD0: a
func (o *UHCI_Type) SetREG_Q3_WORD0(value uint32) {
	volatile.StoreUint32(&o.REG_Q3_WORD0.Reg, value)
}
func (o *UHCI_Type) GetREG_Q3_WORD0() uint32 {
	return volatile.LoadUint32(&o.REG_Q3_WORD0.Reg)
}

// UHCI.REG_Q3_WORD1: a
func (o *UHCI_Type) SetREG_Q3_WORD1(value uint32) {
	volatile.StoreUint32(&o.REG_Q3_WORD1.Reg, value)
}
func (o *UHCI_Type) GetREG_Q3_WORD1() uint32 {
	return volatile.LoadUint32(&o.REG_Q3_WORD1.Reg)
}

// UHCI.REG_Q4_WORD0: a
func (o *UHCI_Type) SetREG_Q4_WORD0(value uint32) {
	volatile.StoreUint32(&o.REG_Q4_WORD0.Reg, value)
}
func (o *UHCI_Type) GetREG_Q4_WORD0() uint32 {
	return volatile.LoadUint32(&o.REG_Q4_WORD0.Reg)
}

// UHCI.REG_Q4_WORD1: a
func (o *UHCI_Type) SetREG_Q4_WORD1(value uint32) {
	volatile.StoreUint32(&o.REG_Q4_WORD1.Reg, value)
}
func (o *UHCI_Type) GetREG_Q4_WORD1() uint32 {
	return volatile.LoadUint32(&o.REG_Q4_WORD1.Reg)
}

// UHCI.REG_Q5_WORD0: a
func (o *UHCI_Type) SetREG_Q5_WORD0(value uint32) {
	volatile.StoreUint32(&o.REG_Q5_WORD0.Reg, value)
}
func (o *UHCI_Type) GetREG_Q5_WORD0() uint32 {
	return volatile.LoadUint32(&o.REG_Q5_WORD0.Reg)
}

// UHCI.REG_Q5_WORD1: a
func (o *UHCI_Type) SetREG_Q5_WORD1(value uint32) {
	volatile.StoreUint32(&o.REG_Q5_WORD1.Reg, value)
}
func (o *UHCI_Type) GetREG_Q5_WORD1() uint32 {
	return volatile.LoadUint32(&o.REG_Q5_WORD1.Reg)
}

// UHCI.REG_Q6_WORD0: a
func (o *UHCI_Type) SetREG_Q6_WORD0(value uint32) {
	volatile.StoreUint32(&o.REG_Q6_WORD0.Reg, value)
}
func (o *UHCI_Type) GetREG_Q6_WORD0() uint32 {
	return volatile.LoadUint32(&o.REG_Q6_WORD0.Reg)
}

// UHCI.REG_Q6_WORD1: a
func (o *UHCI_Type) SetREG_Q6_WORD1(value uint32) {
	volatile.StoreUint32(&o.REG_Q6_WORD1.Reg, value)
}
func (o *UHCI_Type) GetREG_Q6_WORD1() uint32 {
	return volatile.LoadUint32(&o.REG_Q6_WORD1.Reg)
}

// UHCI.ESC_CONF0: a
func (o *UHCI_Type) SetESC_CONF0_SEPER_CHAR(value uint32) {
	volatile.StoreUint32(&o.ESC_CONF0.Reg, volatile.LoadUint32(&o.ESC_CONF0.Reg)&^(0xff)|value)
}
func (o *UHCI_Type) GetESC_CONF0_SEPER_CHAR() uint32 {
	return volatile.LoadUint32(&o.ESC_CONF0.Reg) & 0xff
}
func (o *UHCI_Type) SetESC_CONF0_SEPER_ESC_CHAR0(value uint32) {
	volatile.StoreUint32(&o.ESC_CONF0.Reg, volatile.LoadUint32(&o.ESC_CONF0.Reg)&^(0xff00)|value<<8)
}
func (o *UHCI_Type) GetESC_CONF0_SEPER_ESC_CHAR0() uint32 {
	return (volatile.LoadUint32(&o.ESC_CONF0.Reg) & 0xff00) >> 8
}
func (o *UHCI_Type) SetESC_CONF0_SEPER_ESC_CHAR1(value uint32) {
	volatile.StoreUint32(&o.ESC_CONF0.Reg, volatile.LoadUint32(&o.ESC_CONF0.Reg)&^(0xff0000)|value<<16)
}
func (o *UHCI_Type) GetESC_CONF0_SEPER_ESC_CHAR1() uint32 {
	return (volatile.LoadUint32(&o.ESC_CONF0.Reg) & 0xff0000) >> 16
}

// UHCI.ESC_CONF1: a
func (o *UHCI_Type) SetESC_CONF1_ESC_SEQ0(value uint32) {
	volatile.StoreUint32(&o.ESC_CONF1.Reg, volatile.LoadUint32(&o.ESC_CONF1.Reg)&^(0xff)|value)
}
func (o *UHCI_Type) GetESC_CONF1_ESC_SEQ0() uint32 {
	return volatile.LoadUint32(&o.ESC_CONF1.Reg) & 0xff
}
func (o *UHCI_Type) SetESC_CONF1_ESC_SEQ0_CHAR0(value uint32) {
	volatile.StoreUint32(&o.ESC_CONF1.Reg, volatile.LoadUint32(&o.ESC_CONF1.Reg)&^(0xff00)|value<<8)
}
func (o *UHCI_Type) GetESC_CONF1_ESC_SEQ0_CHAR0() uint32 {
	return (volatile.LoadUint32(&o.ESC_CONF1.Reg) & 0xff00) >> 8
}
func (o *UHCI_Type) SetESC_CONF1_ESC_SEQ0_CHAR1(value uint32) {
	volatile.StoreUint32(&o.ESC_CONF1.Reg, volatile.LoadUint32(&o.ESC_CONF1.Reg)&^(0xff0000)|value<<16)
}
func (o *UHCI_Type) GetESC_CONF1_ESC_SEQ0_CHAR1() uint32 {
	return (volatile.LoadUint32(&o.ESC_CONF1.Reg) & 0xff0000) >> 16
}

// UHCI.ESC_CONF2: a
func (o *UHCI_Type) SetESC_CONF2_ESC_SEQ1(value uint32) {
	volatile.StoreUint32(&o.ESC_CONF2.Reg, volatile.LoadUint32(&o.ESC_CONF2.Reg)&^(0xff)|value)
}
func (o *UHCI_Type) GetESC_CONF2_ESC_SEQ1() uint32 {
	return volatile.LoadUint32(&o.ESC_CONF2.Reg) & 0xff
}
func (o *UHCI_Type) SetESC_CONF2_ESC_SEQ1_CHAR0(value uint32) {
	volatile.StoreUint32(&o.ESC_CONF2.Reg, volatile.LoadUint32(&o.ESC_CONF2.Reg)&^(0xff00)|value<<8)
}
func (o *UHCI_Type) GetESC_CONF2_ESC_SEQ1_CHAR0() uint32 {
	return (volatile.LoadUint32(&o.ESC_CONF2.Reg) & 0xff00) >> 8
}
func (o *UHCI_Type) SetESC_CONF2_ESC_SEQ1_CHAR1(value uint32) {
	volatile.StoreUint32(&o.ESC_CONF2.Reg, volatile.LoadUint32(&o.ESC_CONF2.Reg)&^(0xff0000)|value<<16)
}
func (o *UHCI_Type) GetESC_CONF2_ESC_SEQ1_CHAR1() uint32 {
	return (volatile.LoadUint32(&o.ESC_CONF2.Reg) & 0xff0000) >> 16
}

// UHCI.ESC_CONF3: a
func (o *UHCI_Type) SetESC_CONF3_ESC_SEQ2(value uint32) {
	volatile.StoreUint32(&o.ESC_CONF3.Reg, volatile.LoadUint32(&o.ESC_CONF3.Reg)&^(0xff)|value)
}
func (o *UHCI_Type) GetESC_CONF3_ESC_SEQ2() uint32 {
	return volatile.LoadUint32(&o.ESC_CONF3.Reg) & 0xff
}
func (o *UHCI_Type) SetESC_CONF3_ESC_SEQ2_CHAR0(value uint32) {
	volatile.StoreUint32(&o.ESC_CONF3.Reg, volatile.LoadUint32(&o.ESC_CONF3.Reg)&^(0xff00)|value<<8)
}
func (o *UHCI_Type) GetESC_CONF3_ESC_SEQ2_CHAR0() uint32 {
	return (volatile.LoadUint32(&o.ESC_CONF3.Reg) & 0xff00) >> 8
}
func (o *UHCI_Type) SetESC_CONF3_ESC_SEQ2_CHAR1(value uint32) {
	volatile.StoreUint32(&o.ESC_CONF3.Reg, volatile.LoadUint32(&o.ESC_CONF3.Reg)&^(0xff0000)|value<<16)
}
func (o *UHCI_Type) GetESC_CONF3_ESC_SEQ2_CHAR1() uint32 {
	return (volatile.LoadUint32(&o.ESC_CONF3.Reg) & 0xff0000) >> 16
}

// UHCI.PKT_THRES: a
func (o *UHCI_Type) SetPKT_THRES_PKT_THRS(value uint32) {
	volatile.StoreUint32(&o.PKT_THRES.Reg, volatile.LoadUint32(&o.PKT_THRES.Reg)&^(0x1fff)|value)
}
func (o *UHCI_Type) GetPKT_THRES_PKT_THRS() uint32 {
	return volatile.LoadUint32(&o.PKT_THRES.Reg) & 0x1fff
}

// UHCI.DATE: a
func (o *UHCI_Type) SetDATE(value uint32) {
	volatile.StoreUint32(&o.DATE.Reg, value)
}
func (o *UHCI_Type) GetDATE() uint32 {
	return volatile.LoadUint32(&o.DATE.Reg)
}

// Peripheral USB_DEVICE
type USB_DEVICE_Type struct {
	EP1        volatile.Register32 // 0x0
	EP1_CONF   volatile.Register32 // 0x4
	INT_RAW    volatile.Register32 // 0x8
	INT_ST     volatile.Register32 // 0xC
	INT_ENA    volatile.Register32 // 0x10
	INT_CLR    volatile.Register32 // 0x14
	CONF0      volatile.Register32 // 0x18
	TEST       volatile.Register32 // 0x1C
	JFIFO_ST   volatile.Register32 // 0x20
	FRAM_NUM   volatile.Register32 // 0x24
	IN_EP0_ST  volatile.Register32 // 0x28
	IN_EP1_ST  volatile.Register32 // 0x2C
	IN_EP2_ST  volatile.Register32 // 0x30
	IN_EP3_ST  volatile.Register32 // 0x34
	OUT_EP0_ST volatile.Register32 // 0x38
	OUT_EP1_ST volatile.Register32 // 0x3C
	OUT_EP2_ST volatile.Register32 // 0x40
	MISC_CONF  volatile.Register32 // 0x44
	MEM_CONF   volatile.Register32 // 0x48
	_          [52]byte
	DATE       volatile.Register32 // 0x80
}

// USB_DEVICE.EP1: USB_DEVICE_EP1_REG.
func (o *USB_DEVICE_Type) SetEP1_RDWR_BYTE(value uint32) {
	volatile.StoreUint32(&o.EP1.Reg, volatile.LoadUint32(&o.EP1.Reg)&^(0xff)|value)
}
func (o *USB_DEVICE_Type) GetEP1_RDWR_BYTE() uint32 {
	return volatile.LoadUint32(&o.EP1.Reg) & 0xff
}

// USB_DEVICE.EP1_CONF: USB_DEVICE_EP1_CONF_REG.
func (o *USB_DEVICE_Type) SetEP1_CONF_WR_DONE(value uint32) {
	volatile.StoreUint32(&o.EP1_CONF.Reg, volatile.LoadUint32(&o.EP1_CONF.Reg)&^(0x1)|value)
}
func (o *USB_DEVICE_Type) GetEP1_CONF_WR_DONE() uint32 {
	return volatile.LoadUint32(&o.EP1_CONF.Reg) & 0x1
}
func (o *USB_DEVICE_Type) SetEP1_CONF_SERIAL_IN_EP_DATA_FREE(value uint32) {
	volatile.StoreUint32(&o.EP1_CONF.Reg, volatile.LoadUint32(&o.EP1_CONF.Reg)&^(0x2)|value<<1)
}
func (o *USB_DEVICE_Type) GetEP1_CONF_SERIAL_IN_EP_DATA_FREE() uint32 {
	return (volatile.LoadUint32(&o.EP1_CONF.Reg) & 0x2) >> 1
}
func (o *USB_DEVICE_Type) SetEP1_CONF_SERIAL_OUT_EP_DATA_AVAIL(value uint32) {
	volatile.StoreUint32(&o.EP1_CONF.Reg, volatile.LoadUint32(&o.EP1_CONF.Reg)&^(0x4)|value<<2)
}
func (o *USB_DEVICE_Type) GetEP1_CONF_SERIAL_OUT_EP_DATA_AVAIL() uint32 {
	return (volatile.LoadUint32(&o.EP1_CONF.Reg) & 0x4) >> 2
}

// USB_DEVICE.INT_RAW: USB_DEVICE_INT_RAW_REG.
func (o *USB_DEVICE_Type) SetINT_RAW_JTAG_IN_FLUSH_INT_RAW(value uint32) {
	volatile.StoreUint32(&o.INT_RAW.Reg, volatile.LoadUint32(&o.INT_RAW.Reg)&^(0x1)|value)
}
func (o *USB_DEVICE_Type) GetINT_RAW_JTAG_IN_FLUSH_INT_RAW() uint32 {
	return volatile.LoadUint32(&o.INT_RAW.Reg) & 0x1
}
func (o *USB_DEVICE_Type) SetINT_RAW_SOF_INT_RAW(value uint32) {
	volatile.StoreUint32(&o.INT_RAW.Reg, volatile.LoadUint32(&o.INT_RAW.Reg)&^(0x2)|value<<1)
}
func (o *USB_DEVICE_Type) GetINT_RAW_SOF_INT_RAW() uint32 {
	return (volatile.LoadUint32(&o.INT_RAW.Reg) & 0x2) >> 1
}
func (o *USB_DEVICE_Type) SetINT_RAW_SERIAL_OUT_RECV_PKT_INT_RAW(value uint32) {
	volatile.StoreUint32(&o.INT_RAW.Reg, volatile.LoadUint32(&o.INT_RAW.Reg)&^(0x4)|value<<2)
}
func (o *USB_DEVICE_Type) GetINT_RAW_SERIAL_OUT_RECV_PKT_INT_RAW() uint32 {
	return (volatile.LoadUint32(&o.INT_RAW.Reg) & 0x4) >> 2
}
func (o *USB_DEVICE_Type) SetINT_RAW_SERIAL_IN_EMPTY_INT_RAW(value uint32) {
	volatile.StoreUint32(&o.INT_RAW.Reg, volatile.LoadUint32(&o.INT_RAW.Reg)&^(0x8)|value<<3)
}
func (o *USB_DEVICE_Type) GetINT_RAW_SERIAL_IN_EMPTY_INT_RAW() uint32 {
	return (volatile.LoadUint32(&o.INT_RAW.Reg) & 0x8) >> 3
}
func (o *USB_DEVICE_Type) SetINT_RAW_PID_ERR_INT_RAW(value uint32) {
	volatile.StoreUint32(&o.INT_RAW.Reg, volatile.LoadUint32(&o.INT_RAW.Reg)&^(0x10)|value<<4)
}
func (o *USB_DEVICE_Type) GetINT_RAW_PID_ERR_INT_RAW() uint32 {
	return (volatile.LoadUint32(&o.INT_RAW.Reg) & 0x10) >> 4
}
func (o *USB_DEVICE_Type) SetINT_RAW_CRC5_ERR_INT_RAW(value uint32) {
	volatile.StoreUint32(&o.INT_RAW.Reg, volatile.LoadUint32(&o.INT_RAW.Reg)&^(0x20)|value<<5)
}
func (o *USB_DEVICE_Type) GetINT_RAW_CRC5_ERR_INT_RAW() uint32 {
	return (volatile.LoadUint32(&o.INT_RAW.Reg) & 0x20) >> 5
}
func (o *USB_DEVICE_Type) SetINT_RAW_CRC16_ERR_INT_RAW(value uint32) {
	volatile.StoreUint32(&o.INT_RAW.Reg, volatile.LoadUint32(&o.INT_RAW.Reg)&^(0x40)|value<<6)
}
func (o *USB_DEVICE_Type) GetINT_RAW_CRC16_ERR_INT_RAW() uint32 {
	return (volatile.LoadUint32(&o.INT_RAW.Reg) & 0x40) >> 6
}
func (o *USB_DEVICE_Type) SetINT_RAW_STUFF_ERR_INT_RAW(value uint32) {
	volatile.StoreUint32(&o.INT_RAW.Reg, volatile.LoadUint32(&o.INT_RAW.Reg)&^(0x80)|value<<7)
}
func (o *USB_DEVICE_Type) GetINT_RAW_STUFF_ERR_INT_RAW() uint32 {
	return (volatile.LoadUint32(&o.INT_RAW.Reg) & 0x80) >> 7
}
func (o *USB_DEVICE_Type) SetINT_RAW_IN_TOKEN_REC_IN_EP1_INT_RAW(value uint32) {
	volatile.StoreUint32(&o.INT_RAW.Reg, volatile.LoadUint32(&o.INT_RAW.Reg)&^(0x100)|value<<8)
}
func (o *USB_DEVICE_Type) GetINT_RAW_IN_TOKEN_REC_IN_EP1_INT_RAW() uint32 {
	return (volatile.LoadUint32(&o.INT_RAW.Reg) & 0x100) >> 8
}
func (o *USB_DEVICE_Type) SetINT_RAW_USB_BUS_RESET_INT_RAW(value uint32) {
	volatile.StoreUint32(&o.INT_RAW.Reg, volatile.LoadUint32(&o.INT_RAW.Reg)&^(0x200)|value<<9)
}
func (o *USB_DEVICE_Type) GetINT_RAW_USB_BUS_RESET_INT_RAW() uint32 {
	return (volatile.LoadUint32(&o.INT_RAW.Reg) & 0x200) >> 9
}
func (o *USB_DEVICE_Type) SetINT_RAW_OUT_EP1_ZERO_PAYLOAD_INT_RAW(value uint32) {
	volatile.StoreUint32(&o.INT_RAW.Reg, volatile.LoadUint32(&o.INT_RAW.Reg)&^(0x400)|value<<10)
}
func (o *USB_DEVICE_Type) GetINT_RAW_OUT_EP1_ZERO_PAYLOAD_INT_RAW() uint32 {
	return (volatile.LoadUint32(&o.INT_RAW.Reg) & 0x400) >> 10
}
func (o *USB_DEVICE_Type) SetINT_RAW_OUT_EP2_ZERO_PAYLOAD_INT_RAW(value uint32) {
	volatile.StoreUint32(&o.INT_RAW.Reg, volatile.LoadUint32(&o.INT_RAW.Reg)&^(0x800)|value<<11)
}
func (o *USB_DEVICE_Type) GetINT_RAW_OUT_EP2_ZERO_PAYLOAD_INT_RAW() uint32 {
	return (volatile.LoadUint32(&o.INT_RAW.Reg) & 0x800) >> 11
}

// USB_DEVICE.INT_ST: USB_DEVICE_INT_ST_REG.
func (o *USB_DEVICE_Type) SetINT_ST_JTAG_IN_FLUSH_INT_ST(value uint32) {
	volatile.StoreUint32(&o.INT_ST.Reg, volatile.LoadUint32(&o.INT_ST.Reg)&^(0x1)|value)
}
func (o *USB_DEVICE_Type) GetINT_ST_JTAG_IN_FLUSH_INT_ST() uint32 {
	return volatile.LoadUint32(&o.INT_ST.Reg) & 0x1
}
func (o *USB_DEVICE_Type) SetINT_ST_SOF_INT_ST(value uint32) {
	volatile.StoreUint32(&o.INT_ST.Reg, volatile.LoadUint32(&o.INT_ST.Reg)&^(0x2)|value<<1)
}
func (o *USB_DEVICE_Type) GetINT_ST_SOF_INT_ST() uint32 {
	return (volatile.LoadUint32(&o.INT_ST.Reg) & 0x2) >> 1
}
func (o *USB_DEVICE_Type) SetINT_ST_SERIAL_OUT_RECV_PKT_INT_ST(value uint32) {
	volatile.StoreUint32(&o.INT_ST.Reg, volatile.LoadUint32(&o.INT_ST.Reg)&^(0x4)|value<<2)
}
func (o *USB_DEVICE_Type) GetINT_ST_SERIAL_OUT_RECV_PKT_INT_ST() uint32 {
	return (volatile.LoadUint32(&o.INT_ST.Reg) & 0x4) >> 2
}
func (o *USB_DEVICE_Type) SetINT_ST_SERIAL_IN_EMPTY_INT_ST(value uint32) {
	volatile.StoreUint32(&o.INT_ST.Reg, volatile.LoadUint32(&o.INT_ST.Reg)&^(0x8)|value<<3)
}
func (o *USB_DEVICE_Type) GetINT_ST_SERIAL_IN_EMPTY_INT_ST() uint32 {
	return (volatile.LoadUint32(&o.INT_ST.Reg) & 0x8) >> 3
}
func (o *USB_DEVICE_Type) SetINT_ST_PID_ERR_INT_ST(value uint32) {
	volatile.StoreUint32(&o.INT_ST.Reg, volatile.LoadUint32(&o.INT_ST.Reg)&^(0x10)|value<<4)
}
func (o *USB_DEVICE_Type) GetINT_ST_PID_ERR_INT_ST() uint32 {
	return (volatile.LoadUint32(&o.INT_ST.Reg) & 0x10) >> 4
}
func (o *USB_DEVICE_Type) SetINT_ST_CRC5_ERR_INT_ST(value uint32) {
	volatile.StoreUint32(&o.INT_ST.Reg, volatile.LoadUint32(&o.INT_ST.Reg)&^(0x20)|value<<5)
}
func (o *USB_DEVICE_Type) GetINT_ST_CRC5_ERR_INT_ST() uint32 {
	return (volatile.LoadUint32(&o.INT_ST.Reg) & 0x20) >> 5
}
func (o *USB_DEVICE_Type) SetINT_ST_CRC16_ERR_INT_ST(value uint32) {
	volatile.StoreUint32(&o.INT_ST.Reg, volatile.LoadUint32(&o.INT_ST.Reg)&^(0x40)|value<<6)
}
func (o *USB_DEVICE_Type) GetINT_ST_CRC16_ERR_INT_ST() uint32 {
	return (volatile.LoadUint32(&o.INT_ST.Reg) & 0x40) >> 6
}
func (o *USB_DEVICE_Type) SetINT_ST_STUFF_ERR_INT_ST(value uint32) {
	volatile.StoreUint32(&o.INT_ST.Reg, volatile.LoadUint32(&o.INT_ST.Reg)&^(0x80)|value<<7)
}
func (o *USB_DEVICE_Type) GetINT_ST_STUFF_ERR_INT_ST() uint32 {
	return (volatile.LoadUint32(&o.INT_ST.Reg) & 0x80) >> 7
}
func (o *USB_DEVICE_Type) SetINT_ST_IN_TOKEN_REC_IN_EP1_INT_ST(value uint32) {
	volatile.StoreUint32(&o.INT_ST.Reg, volatile.LoadUint32(&o.INT_ST.Reg)&^(0x100)|value<<8)
}
func (o *USB_DEVICE_Type) GetINT_ST_IN_TOKEN_REC_IN_EP1_INT_ST() uint32 {
	return (volatile.LoadUint32(&o.INT_ST.Reg) & 0x100) >> 8
}
func (o *USB_DEVICE_Type) SetINT_ST_USB_BUS_RESET_INT_ST(value uint32) {
	volatile.StoreUint32(&o.INT_ST.Reg, volatile.LoadUint32(&o.INT_ST.Reg)&^(0x200)|value<<9)
}
func (o *USB_DEVICE_Type) GetINT_ST_USB_BUS_RESET_INT_ST() uint32 {
	return (volatile.LoadUint32(&o.INT_ST.Reg) & 0x200) >> 9
}
func (o *USB_DEVICE_Type) SetINT_ST_OUT_EP1_ZERO_PAYLOAD_INT_ST(value uint32) {
	volatile.StoreUint32(&o.INT_ST.Reg, volatile.LoadUint32(&o.INT_ST.Reg)&^(0x400)|value<<10)
}
func (o *USB_DEVICE_Type) GetINT_ST_OUT_EP1_ZERO_PAYLOAD_INT_ST() uint32 {
	return (volatile.LoadUint32(&o.INT_ST.Reg) & 0x400) >> 10
}
func (o *USB_DEVICE_Type) SetINT_ST_OUT_EP2_ZERO_PAYLOAD_INT_ST(value uint32) {
	volatile.StoreUint32(&o.INT_ST.Reg, volatile.LoadUint32(&o.INT_ST.Reg)&^(0x800)|value<<11)
}
func (o *USB_DEVICE_Type) GetINT_ST_OUT_EP2_ZERO_PAYLOAD_INT_ST() uint32 {
	return (volatile.LoadUint32(&o.INT_ST.Reg) & 0x800) >> 11
}

// USB_DEVICE.INT_ENA: USB_DEVICE_INT_ENA_REG.
func (o *USB_DEVICE_Type) SetINT_ENA_JTAG_IN_FLUSH_INT_ENA(value uint32) {
	volatile.StoreUint32(&o.INT_ENA.Reg, volatile.LoadUint32(&o.INT_ENA.Reg)&^(0x1)|value)
}
func (o *USB_DEVICE_Type) GetINT_ENA_JTAG_IN_FLUSH_INT_ENA() uint32 {
	return volatile.LoadUint32(&o.INT_ENA.Reg) & 0x1
}
func (o *USB_DEVICE_Type) SetINT_ENA_SOF_INT_ENA(value uint32) {
	volatile.StoreUint32(&o.INT_ENA.Reg, volatile.LoadUint32(&o.INT_ENA.Reg)&^(0x2)|value<<1)
}
func (o *USB_DEVICE_Type) GetINT_ENA_SOF_INT_ENA() uint32 {
	return (volatile.LoadUint32(&o.INT_ENA.Reg) & 0x2) >> 1
}
func (o *USB_DEVICE_Type) SetINT_ENA_SERIAL_OUT_RECV_PKT_INT_ENA(value uint32) {
	volatile.StoreUint32(&o.INT_ENA.Reg, volatile.LoadUint32(&o.INT_ENA.Reg)&^(0x4)|value<<2)
}
func (o *USB_DEVICE_Type) GetINT_ENA_SERIAL_OUT_RECV_PKT_INT_ENA() uint32 {
	return (volatile.LoadUint32(&o.INT_ENA.Reg) & 0x4) >> 2
}
func (o *USB_DEVICE_Type) SetINT_ENA_SERIAL_IN_EMPTY_INT_ENA(value uint32) {
	volatile.StoreUint32(&o.INT_ENA.Reg, volatile.LoadUint32(&o.INT_ENA.Reg)&^(0x8)|value<<3)
}
func (o *USB_DEVICE_Type) GetINT_ENA_SERIAL_IN_EMPTY_INT_ENA() uint32 {
	return (volatile.LoadUint32(&o.INT_ENA.Reg) & 0x8) >> 3
}
func (o *USB_DEVICE_Type) SetINT_ENA_PID_ERR_INT_ENA(value uint32) {
	volatile.StoreUint32(&o.INT_ENA.Reg, volatile.LoadUint32(&o.INT_ENA.Reg)&^(0x10)|value<<4)
}
func (o *USB_DEVICE_Type) GetINT_ENA_PID_ERR_INT_ENA() uint32 {
	return (volatile.LoadUint32(&o.INT_ENA.Reg) & 0x10) >> 4
}
func (o *USB_DEVICE_Type) SetINT_ENA_CRC5_ERR_INT_ENA(value uint32) {
	volatile.StoreUint32(&o.INT_ENA.Reg, volatile.LoadUint32(&o.INT_ENA.Reg)&^(0x20)|value<<5)
}
func (o *USB_DEVICE_Type) GetINT_ENA_CRC5_ERR_INT_ENA() uint32 {
	return (volatile.LoadUint32(&o.INT_ENA.Reg) & 0x20) >> 5
}
func (o *USB_DEVICE_Type) SetINT_ENA_CRC16_ERR_INT_ENA(value uint32) {
	volatile.StoreUint32(&o.INT_ENA.Reg, volatile.LoadUint32(&o.INT_ENA.Reg)&^(0x40)|value<<6)
}
func (o *USB_DEVICE_Type) GetINT_ENA_CRC16_ERR_INT_ENA() uint32 {
	return (volatile.LoadUint32(&o.INT_ENA.Reg) & 0x40) >> 6
}
func (o *USB_DEVICE_Type) SetINT_ENA_STUFF_ERR_INT_ENA(value uint32) {
	volatile.StoreUint32(&o.INT_ENA.Reg, volatile.LoadUint32(&o.INT_ENA.Reg)&^(0x80)|value<<7)
}
func (o *USB_DEVICE_Type) GetINT_ENA_STUFF_ERR_INT_ENA() uint32 {
	return (volatile.LoadUint32(&o.INT_ENA.Reg) & 0x80) >> 7
}
func (o *USB_DEVICE_Type) SetINT_ENA_IN_TOKEN_REC_IN_EP1_INT_ENA(value uint32) {
	volatile.StoreUint32(&o.INT_ENA.Reg, volatile.LoadUint32(&o.INT_ENA.Reg)&^(0x100)|value<<8)
}
func (o *USB_DEVICE_Type) GetINT_ENA_IN_TOKEN_REC_IN_EP1_INT_ENA() uint32 {
	return (volatile.LoadUint32(&o.INT_ENA.Reg) & 0x100) >> 8
}
func (o *USB_DEVICE_Type) SetINT_ENA_USB_BUS_RESET_INT_ENA(value uint32) {
	volatile.StoreUint32(&o.INT_ENA.Reg, volatile.LoadUint32(&o.INT_ENA.Reg)&^(0x200)|value<<9)
}
func (o *USB_DEVICE_Type) GetINT_ENA_USB_BUS_RESET_INT_ENA() uint32 {
	return (volatile.LoadUint32(&o.INT_ENA.Reg) & 0x200) >> 9
}
func (o *USB_DEVICE_Type) SetINT_ENA_OUT_EP1_ZERO_PAYLOAD_INT_ENA(value uint32) {
	volatile.StoreUint32(&o.INT_ENA.Reg, volatile.LoadUint32(&o.INT_ENA.Reg)&^(0x400)|value<<10)
}
func (o *USB_DEVICE_Type) GetINT_ENA_OUT_EP1_ZERO_PAYLOAD_INT_ENA() uint32 {
	return (volatile.LoadUint32(&o.INT_ENA.Reg) & 0x400) >> 10
}
func (o *USB_DEVICE_Type) SetINT_ENA_OUT_EP2_ZERO_PAYLOAD_INT_ENA(value uint32) {
	volatile.StoreUint32(&o.INT_ENA.Reg, volatile.LoadUint32(&o.INT_ENA.Reg)&^(0x800)|value<<11)
}
func (o *USB_DEVICE_Type) GetINT_ENA_OUT_EP2_ZERO_PAYLOAD_INT_ENA() uint32 {
	return (volatile.LoadUint32(&o.INT_ENA.Reg) & 0x800) >> 11
}

// USB_DEVICE.INT_CLR: USB_DEVICE_INT_CLR_REG.
func (o *USB_DEVICE_Type) SetINT_CLR_JTAG_IN_FLUSH_INT_CLR(value uint32) {
	volatile.StoreUint32(&o.INT_CLR.Reg, volatile.LoadUint32(&o.INT_CLR.Reg)&^(0x1)|value)
}
func (o *USB_DEVICE_Type) GetINT_CLR_JTAG_IN_FLUSH_INT_CLR() uint32 {
	return volatile.LoadUint32(&o.INT_CLR.Reg) & 0x1
}
func (o *USB_DEVICE_Type) SetINT_CLR_SOF_INT_CLR(value uint32) {
	volatile.StoreUint32(&o.INT_CLR.Reg, volatile.LoadUint32(&o.INT_CLR.Reg)&^(0x2)|value<<1)
}
func (o *USB_DEVICE_Type) GetINT_CLR_SOF_INT_CLR() uint32 {
	return (volatile.LoadUint32(&o.INT_CLR.Reg) & 0x2) >> 1
}
func (o *USB_DEVICE_Type) SetINT_CLR_SERIAL_OUT_RECV_PKT_INT_CLR(value uint32) {
	volatile.StoreUint32(&o.INT_CLR.Reg, volatile.LoadUint32(&o.INT_CLR.Reg)&^(0x4)|value<<2)
}
func (o *USB_DEVICE_Type) GetINT_CLR_SERIAL_OUT_RECV_PKT_INT_CLR() uint32 {
	return (volatile.LoadUint32(&o.INT_CLR.Reg) & 0x4) >> 2
}
func (o *USB_DEVICE_Type) SetINT_CLR_SERIAL_IN_EMPTY_INT_CLR(value uint32) {
	volatile.StoreUint32(&o.INT_CLR.Reg, volatile.LoadUint32(&o.INT_CLR.Reg)&^(0x8)|value<<3)
}
func (o *USB_DEVICE_Type) GetINT_CLR_SERIAL_IN_EMPTY_INT_CLR() uint32 {
	return (volatile.LoadUint32(&o.INT_CLR.Reg) & 0x8) >> 3
}
func (o *USB_DEVICE_Type) SetINT_CLR_PID_ERR_INT_CLR(value uint32) {
	volatile.StoreUint32(&o.INT_CLR.Reg, volatile.LoadUint32(&o.INT_CLR.Reg)&^(0x10)|value<<4)
}
func (o *USB_DEVICE_Type) GetINT_CLR_PID_ERR_INT_CLR() uint32 {
	return (volatile.LoadUint32(&o.INT_CLR.Reg) & 0x10) >> 4
}
func (o *USB_DEVICE_Type) SetINT_CLR_CRC5_ERR_INT_CLR(value uint32) {
	volatile.StoreUint32(&o.INT_CLR.Reg, volatile.LoadUint32(&o.INT_CLR.Reg)&^(0x20)|value<<5)
}
func (o *USB_DEVICE_Type) GetINT_CLR_CRC5_ERR_INT_CLR() uint32 {
	return (volatile.LoadUint32(&o.INT_CLR.Reg) & 0x20) >> 5
}
func (o *USB_DEVICE_Type) SetINT_CLR_CRC16_ERR_INT_CLR(value uint32) {
	volatile.StoreUint32(&o.INT_CLR.Reg, volatile.LoadUint32(&o.INT_CLR.Reg)&^(0x40)|value<<6)
}
func (o *USB_DEVICE_Type) GetINT_CLR_CRC16_ERR_INT_CLR() uint32 {
	return (volatile.LoadUint32(&o.INT_CLR.Reg) & 0x40) >> 6
}
func (o *USB_DEVICE_Type) SetINT_CLR_STUFF_ERR_INT_CLR(value uint32) {
	volatile.StoreUint32(&o.INT_CLR.Reg, volatile.LoadUint32(&o.INT_CLR.Reg)&^(0x80)|value<<7)
}
func (o *USB_DEVICE_Type) GetINT_CLR_STUFF_ERR_INT_CLR() uint32 {
	return (volatile.LoadUint32(&o.INT_CLR.Reg) & 0x80) >> 7
}
func (o *USB_DEVICE_Type) SetINT_CLR_IN_TOKEN_REC_IN_EP1_INT_CLR(value uint32) {
	volatile.StoreUint32(&o.INT_CLR.Reg, volatile.LoadUint32(&o.INT_CLR.Reg)&^(0x100)|value<<8)
}
func (o *USB_DEVICE_Type) GetINT_CLR_IN_TOKEN_REC_IN_EP1_INT_CLR() uint32 {
	return (volatile.LoadUint32(&o.INT_CLR.Reg) & 0x100) >> 8
}
func (o *USB_DEVICE_Type) SetINT_CLR_USB_BUS_RESET_INT_CLR(value uint32) {
	volatile.StoreUint32(&o.INT_CLR.Reg, volatile.LoadUint32(&o.INT_CLR.Reg)&^(0x200)|value<<9)
}
func (o *USB_DEVICE_Type) GetINT_CLR_USB_BUS_RESET_INT_CLR() uint32 {
	return (volatile.LoadUint32(&o.INT_CLR.Reg) & 0x200) >> 9
}
func (o *USB_DEVICE_Type) SetINT_CLR_OUT_EP1_ZERO_PAYLOAD_INT_CLR(value uint32) {
	volatile.StoreUint32(&o.INT_CLR.Reg, volatile.LoadUint32(&o.INT_CLR.Reg)&^(0x400)|value<<10)
}
func (o *USB_DEVICE_Type) GetINT_CLR_OUT_EP1_ZERO_PAYLOAD_INT_CLR() uint32 {
	return (volatile.LoadUint32(&o.INT_CLR.Reg) & 0x400) >> 10
}
func (o *USB_DEVICE_Type) SetINT_CLR_OUT_EP2_ZERO_PAYLOAD_INT_CLR(value uint32) {
	volatile.StoreUint32(&o.INT_CLR.Reg, volatile.LoadUint32(&o.INT_CLR.Reg)&^(0x800)|value<<11)
}
func (o *USB_DEVICE_Type) GetINT_CLR_OUT_EP2_ZERO_PAYLOAD_INT_CLR() uint32 {
	return (volatile.LoadUint32(&o.INT_CLR.Reg) & 0x800) >> 11
}

// USB_DEVICE.CONF0: USB_DEVICE_CONF0_REG.
func (o *USB_DEVICE_Type) SetCONF0_PHY_SEL(value uint32) {
	volatile.StoreUint32(&o.CONF0.Reg, volatile.LoadUint32(&o.CONF0.Reg)&^(0x1)|value)
}
func (o *USB_DEVICE_Type) GetCONF0_PHY_SEL() uint32 {
	return volatile.LoadUint32(&o.CONF0.Reg) & 0x1
}
func (o *USB_DEVICE_Type) SetCONF0_EXCHG_PINS_OVERRIDE(value uint32) {
	volatile.StoreUint32(&o.CONF0.Reg, volatile.LoadUint32(&o.CONF0.Reg)&^(0x2)|value<<1)
}
func (o *USB_DEVICE_Type) GetCONF0_EXCHG_PINS_OVERRIDE() uint32 {
	return (volatile.LoadUint32(&o.CONF0.Reg) & 0x2) >> 1
}
func (o *USB_DEVICE_Type) SetCONF0_EXCHG_PINS(value uint32) {
	volatile.StoreUint32(&o.CONF0.Reg, volatile.LoadUint32(&o.CONF0.Reg)&^(0x4)|value<<2)
}
func (o *USB_DEVICE_Type) GetCONF0_EXCHG_PINS() uint32 {
	return (volatile.LoadUint32(&o.CONF0.Reg) & 0x4) >> 2
}
func (o *USB_DEVICE_Type) SetCONF0_VREFH(value uint32) {
	volatile.StoreUint32(&o.CONF0.Reg, volatile.LoadUint32(&o.CONF0.Reg)&^(0x18)|value<<3)
}
func (o *USB_DEVICE_Type) GetCONF0_VREFH() uint32 {
	return (volatile.LoadUint32(&o.CONF0.Reg) & 0x18) >> 3
}
func (o *USB_DEVICE_Type) SetCONF0_VREFL(value uint32) {
	volatile.StoreUint32(&o.CONF0.Reg, volatile.LoadUint32(&o.CONF0.Reg)&^(0x60)|value<<5)
}
func (o *USB_DEVICE_Type) GetCONF0_VREFL() uint32 {
	return (volatile.LoadUint32(&o.CONF0.Reg) & 0x60) >> 5
}
func (o *USB_DEVICE_Type) SetCONF0_VREF_OVERRIDE(value uint32) {
	volatile.StoreUint32(&o.CONF0.Reg, volatile.LoadUint32(&o.CONF0.Reg)&^(0x80)|value<<7)
}
func (o *USB_DEVICE_Type) GetCONF0_VREF_OVERRIDE() uint32 {
	return (volatile.LoadUint32(&o.CONF0.Reg) & 0x80) >> 7
}
func (o *USB_DEVICE_Type) SetCONF0_PAD_PULL_OVERRIDE(value uint32) {
	volatile.StoreUint32(&o.CONF0.Reg, volatile.LoadUint32(&o.CONF0.Reg)&^(0x100)|value<<8)
}
func (o *USB_DEVICE_Type) GetCONF0_PAD_PULL_OVERRIDE() uint32 {
	return (volatile.LoadUint32(&o.CONF0.Reg) & 0x100) >> 8
}
func (o *USB_DEVICE_Type) SetCONF0_DP_PULLUP(value uint32) {
	volatile.StoreUint32(&o.CONF0.Reg, volatile.LoadUint32(&o.CONF0.Reg)&^(0x200)|value<<9)
}
func (o *USB_DEVICE_Type) GetCONF0_DP_PULLUP() uint32 {
	return (volatile.LoadUint32(&o.CONF0.Reg) & 0x200) >> 9
}
func (o *USB_DEVICE_Type) SetCONF0_DP_PULLDOWN(value uint32) {
	volatile.StoreUint32(&o.CONF0.Reg, volatile.LoadUint32(&o.CONF0.Reg)&^(0x400)|value<<10)
}
func (o *USB_DEVICE_Type) GetCONF0_DP_PULLDOWN() uint32 {
	return (volatile.LoadUint32(&o.CONF0.Reg) & 0x400) >> 10
}
func (o *USB_DEVICE_Type) SetCONF0_DM_PULLUP(value uint32) {
	volatile.StoreUint32(&o.CONF0.Reg, volatile.LoadUint32(&o.CONF0.Reg)&^(0x800)|value<<11)
}
func (o *USB_DEVICE_Type) GetCONF0_DM_PULLUP() uint32 {
	return (volatile.LoadUint32(&o.CONF0.Reg) & 0x800) >> 11
}
func (o *USB_DEVICE_Type) SetCONF0_DM_PULLDOWN(value uint32) {
	volatile.StoreUint32(&o.CONF0.Reg, volatile.LoadUint32(&o.CONF0.Reg)&^(0x1000)|value<<12)
}
func (o *USB_DEVICE_Type) GetCONF0_DM_PULLDOWN() uint32 {
	return (volatile.LoadUint32(&o.CONF0.Reg) & 0x1000) >> 12
}
func (o *USB_DEVICE_Type) SetCONF0_PULLUP_VALUE(value uint32) {
	volatile.StoreUint32(&o.CONF0.Reg, volatile.LoadUint32(&o.CONF0.Reg)&^(0x2000)|value<<13)
}
func (o *USB_DEVICE_Type) GetCONF0_PULLUP_VALUE() uint32 {
	return (volatile.LoadUint32(&o.CONF0.Reg) & 0x2000) >> 13
}
func (o *USB_DEVICE_Type) SetCONF0_USB_PAD_ENABLE(value uint32) {
	volatile.StoreUint32(&o.CONF0.Reg, volatile.LoadUint32(&o.CONF0.Reg)&^(0x4000)|value<<14)
}
func (o *USB_DEVICE_Type) GetCONF0_USB_PAD_ENABLE() uint32 {
	return (volatile.LoadUint32(&o.CONF0.Reg) & 0x4000) >> 14
}

// USB_DEVICE.TEST: USB_DEVICE_TEST_REG.
func (o *USB_DEVICE_Type) SetTEST_ENABLE(value uint32) {
	volatile.StoreUint32(&o.TEST.Reg, volatile.LoadUint32(&o.TEST.Reg)&^(0x1)|value)
}
func (o *USB_DEVICE_Type) GetTEST_ENABLE() uint32 {
	return volatile.LoadUint32(&o.TEST.Reg) & 0x1
}
func (o *USB_DEVICE_Type) SetTEST_USB_OE(value uint32) {
	volatile.StoreUint32(&o.TEST.Reg, volatile.LoadUint32(&o.TEST.Reg)&^(0x2)|value<<1)
}
func (o *USB_DEVICE_Type) GetTEST_USB_OE() uint32 {
	return (volatile.LoadUint32(&o.TEST.Reg) & 0x2) >> 1
}
func (o *USB_DEVICE_Type) SetTEST_TX_DP(value uint32) {
	volatile.StoreUint32(&o.TEST.Reg, volatile.LoadUint32(&o.TEST.Reg)&^(0x4)|value<<2)
}
func (o *USB_DEVICE_Type) GetTEST_TX_DP() uint32 {
	return (volatile.LoadUint32(&o.TEST.Reg) & 0x4) >> 2
}
func (o *USB_DEVICE_Type) SetTEST_TX_DM(value uint32) {
	volatile.StoreUint32(&o.TEST.Reg, volatile.LoadUint32(&o.TEST.Reg)&^(0x8)|value<<3)
}
func (o *USB_DEVICE_Type) GetTEST_TX_DM() uint32 {
	return (volatile.LoadUint32(&o.TEST.Reg) & 0x8) >> 3
}

// USB_DEVICE.JFIFO_ST: USB_DEVICE_JFIFO_ST_REG.
func (o *USB_DEVICE_Type) SetJFIFO_ST_IN_FIFO_CNT(value uint32) {
	volatile.StoreUint32(&o.JFIFO_ST.Reg, volatile.LoadUint32(&o.JFIFO_ST.Reg)&^(0x3)|value)
}
func (o *USB_DEVICE_Type) GetJFIFO_ST_IN_FIFO_CNT() uint32 {
	return volatile.LoadUint32(&o.JFIFO_ST.Reg) & 0x3
}
func (o *USB_DEVICE_Type) SetJFIFO_ST_IN_FIFO_EMPTY(value uint32) {
	volatile.StoreUint32(&o.JFIFO_ST.Reg, volatile.LoadUint32(&o.JFIFO_ST.Reg)&^(0x4)|value<<2)
}
func (o *USB_DEVICE_Type) GetJFIFO_ST_IN_FIFO_EMPTY() uint32 {
	return (volatile.LoadUint32(&o.JFIFO_ST.Reg) & 0x4) >> 2
}
func (o *USB_DEVICE_Type) SetJFIFO_ST_IN_FIFO_FULL(value uint32) {
	volatile.StoreUint32(&o.JFIFO_ST.Reg, volatile.LoadUint32(&o.JFIFO_ST.Reg)&^(0x8)|value<<3)
}
func (o *USB_DEVICE_Type) GetJFIFO_ST_IN_FIFO_FULL() uint32 {
	return (volatile.LoadUint32(&o.JFIFO_ST.Reg) & 0x8) >> 3
}
func (o *USB_DEVICE_Type) SetJFIFO_ST_OUT_FIFO_CNT(value uint32) {
	volatile.StoreUint32(&o.JFIFO_ST.Reg, volatile.LoadUint32(&o.JFIFO_ST.Reg)&^(0x30)|value<<4)
}
func (o *USB_DEVICE_Type) GetJFIFO_ST_OUT_FIFO_CNT() uint32 {
	return (volatile.LoadUint32(&o.JFIFO_ST.Reg) & 0x30) >> 4
}
func (o *USB_DEVICE_Type) SetJFIFO_ST_OUT_FIFO_EMPTY(value uint32) {
	volatile.StoreUint32(&o.JFIFO_ST.Reg, volatile.LoadUint32(&o.JFIFO_ST.Reg)&^(0x40)|value<<6)
}
func (o *USB_DEVICE_Type) GetJFIFO_ST_OUT_FIFO_EMPTY() uint32 {
	return (volatile.LoadUint32(&o.JFIFO_ST.Reg) & 0x40) >> 6
}
func (o *USB_DEVICE_Type) SetJFIFO_ST_OUT_FIFO_FULL(value uint32) {
	volatile.StoreUint32(&o.JFIFO_ST.Reg, volatile.LoadUint32(&o.JFIFO_ST.Reg)&^(0x80)|value<<7)
}
func (o *USB_DEVICE_Type) GetJFIFO_ST_OUT_FIFO_FULL() uint32 {
	return (volatile.LoadUint32(&o.JFIFO_ST.Reg) & 0x80) >> 7
}
func (o *USB_DEVICE_Type) SetJFIFO_ST_IN_FIFO_RESET(value uint32) {
	volatile.StoreUint32(&o.JFIFO_ST.Reg, volatile.LoadUint32(&o.JFIFO_ST.Reg)&^(0x100)|value<<8)
}
func (o *USB_DEVICE_Type) GetJFIFO_ST_IN_FIFO_RESET() uint32 {
	return (volatile.LoadUint32(&o.JFIFO_ST.Reg) & 0x100) >> 8
}
func (o *USB_DEVICE_Type) SetJFIFO_ST_OUT_FIFO_RESET(value uint32) {
	volatile.StoreUint32(&o.JFIFO_ST.Reg, volatile.LoadUint32(&o.JFIFO_ST.Reg)&^(0x200)|value<<9)
}
func (o *USB_DEVICE_Type) GetJFIFO_ST_OUT_FIFO_RESET() uint32 {
	return (volatile.LoadUint32(&o.JFIFO_ST.Reg) & 0x200) >> 9
}

// USB_DEVICE.FRAM_NUM: USB_DEVICE_FRAM_NUM_REG.
func (o *USB_DEVICE_Type) SetFRAM_NUM_SOF_FRAME_INDEX(value uint32) {
	volatile.StoreUint32(&o.FRAM_NUM.Reg, volatile.LoadUint32(&o.FRAM_NUM.Reg)&^(0x7ff)|value)
}
func (o *USB_DEVICE_Type) GetFRAM_NUM_SOF_FRAME_INDEX() uint32 {
	return volatile.LoadUint32(&o.FRAM_NUM.Reg) & 0x7ff
}

// USB_DEVICE.IN_EP0_ST: USB_DEVICE_IN_EP0_ST_REG.
func (o *USB_DEVICE_Type) SetIN_EP0_ST_IN_EP0_STATE(value uint32) {
	volatile.StoreUint32(&o.IN_EP0_ST.Reg, volatile.LoadUint32(&o.IN_EP0_ST.Reg)&^(0x3)|value)
}
func (o *USB_DEVICE_Type) GetIN_EP0_ST_IN_EP0_STATE() uint32 {
	return volatile.LoadUint32(&o.IN_EP0_ST.Reg) & 0x3
}
func (o *USB_DEVICE_Type) SetIN_EP0_ST_IN_EP0_WR_ADDR(value uint32) {
	volatile.StoreUint32(&o.IN_EP0_ST.Reg, volatile.LoadUint32(&o.IN_EP0_ST.Reg)&^(0x1fc)|value<<2)
}
func (o *USB_DEVICE_Type) GetIN_EP0_ST_IN_EP0_WR_ADDR() uint32 {
	return (volatile.LoadUint32(&o.IN_EP0_ST.Reg) & 0x1fc) >> 2
}
func (o *USB_DEVICE_Type) SetIN_EP0_ST_IN_EP0_RD_ADDR(value uint32) {
	volatile.StoreUint32(&o.IN_EP0_ST.Reg, volatile.LoadUint32(&o.IN_EP0_ST.Reg)&^(0xfe00)|value<<9)
}
func (o *USB_DEVICE_Type) GetIN_EP0_ST_IN_EP0_RD_ADDR() uint32 {
	return (volatile.LoadUint32(&o.IN_EP0_ST.Reg) & 0xfe00) >> 9
}

// USB_DEVICE.IN_EP1_ST: USB_DEVICE_IN_EP1_ST_REG.
func (o *USB_DEVICE_Type) SetIN_EP1_ST_IN_EP1_STATE(value uint32) {
	volatile.StoreUint32(&o.IN_EP1_ST.Reg, volatile.LoadUint32(&o.IN_EP1_ST.Reg)&^(0x3)|value)
}
func (o *USB_DEVICE_Type) GetIN_EP1_ST_IN_EP1_STATE() uint32 {
	return volatile.LoadUint32(&o.IN_EP1_ST.Reg) & 0x3
}
func (o *USB_DEVICE_Type) SetIN_EP1_ST_IN_EP1_WR_ADDR(value uint32) {
	volatile.StoreUint32(&o.IN_EP1_ST.Reg, volatile.LoadUint32(&o.IN_EP1_ST.Reg)&^(0x1fc)|value<<2)
}
func (o *USB_DEVICE_Type) GetIN_EP1_ST_IN_EP1_WR_ADDR() uint32 {
	return (volatile.LoadUint32(&o.IN_EP1_ST.Reg) & 0x1fc) >> 2
}
func (o *USB_DEVICE_Type) SetIN_EP1_ST_IN_EP1_RD_ADDR(value uint32) {
	volatile.StoreUint32(&o.IN_EP1_ST.Reg, volatile.LoadUint32(&o.IN_EP1_ST.Reg)&^(0xfe00)|value<<9)
}
func (o *USB_DEVICE_Type) GetIN_EP1_ST_IN_EP1_RD_ADDR() uint32 {
	return (volatile.LoadUint32(&o.IN_EP1_ST.Reg) & 0xfe00) >> 9
}

// USB_DEVICE.IN_EP2_ST: USB_DEVICE_IN_EP2_ST_REG.
func (o *USB_DEVICE_Type) SetIN_EP2_ST_IN_EP2_STATE(value uint32) {
	volatile.StoreUint32(&o.IN_EP2_ST.Reg, volatile.LoadUint32(&o.IN_EP2_ST.Reg)&^(0x3)|value)
}
func (o *USB_DEVICE_Type) GetIN_EP2_ST_IN_EP2_STATE() uint32 {
	return volatile.LoadUint32(&o.IN_EP2_ST.Reg) & 0x3
}
func (o *USB_DEVICE_Type) SetIN_EP2_ST_IN_EP2_WR_ADDR(value uint32) {
	volatile.StoreUint32(&o.IN_EP2_ST.Reg, volatile.LoadUint32(&o.IN_EP2_ST.Reg)&^(0x1fc)|value<<2)
}
func (o *USB_DEVICE_Type) GetIN_EP2_ST_IN_EP2_WR_ADDR() uint32 {
	return (volatile.LoadUint32(&o.IN_EP2_ST.Reg) & 0x1fc) >> 2
}
func (o *USB_DEVICE_Type) SetIN_EP2_ST_IN_EP2_RD_ADDR(value uint32) {
	volatile.StoreUint32(&o.IN_EP2_ST.Reg, volatile.LoadUint32(&o.IN_EP2_ST.Reg)&^(0xfe00)|value<<9)
}
func (o *USB_DEVICE_Type) GetIN_EP2_ST_IN_EP2_RD_ADDR() uint32 {
	return (volatile.LoadUint32(&o.IN_EP2_ST.Reg) & 0xfe00) >> 9
}

// USB_DEVICE.IN_EP3_ST: USB_DEVICE_IN_EP3_ST_REG.
func (o *USB_DEVICE_Type) SetIN_EP3_ST_IN_EP3_STATE(value uint32) {
	volatile.StoreUint32(&o.IN_EP3_ST.Reg, volatile.LoadUint32(&o.IN_EP3_ST.Reg)&^(0x3)|value)
}
func (o *USB_DEVICE_Type) GetIN_EP3_ST_IN_EP3_STATE() uint32 {
	return volatile.LoadUint32(&o.IN_EP3_ST.Reg) & 0x3
}
func (o *USB_DEVICE_Type) SetIN_EP3_ST_IN_EP3_WR_ADDR(value uint32) {
	volatile.StoreUint32(&o.IN_EP3_ST.Reg, volatile.LoadUint32(&o.IN_EP3_ST.Reg)&^(0x1fc)|value<<2)
}
func (o *USB_DEVICE_Type) GetIN_EP3_ST_IN_EP3_WR_ADDR() uint32 {
	return (volatile.LoadUint32(&o.IN_EP3_ST.Reg) & 0x1fc) >> 2
}
func (o *USB_DEVICE_Type) SetIN_EP3_ST_IN_EP3_RD_ADDR(value uint32) {
	volatile.StoreUint32(&o.IN_EP3_ST.Reg, volatile.LoadUint32(&o.IN_EP3_ST.Reg)&^(0xfe00)|value<<9)
}
func (o *USB_DEVICE_Type) GetIN_EP3_ST_IN_EP3_RD_ADDR() uint32 {
	return (volatile.LoadUint32(&o.IN_EP3_ST.Reg) & 0xfe00) >> 9
}

// USB_DEVICE.OUT_EP0_ST: USB_DEVICE_OUT_EP0_ST_REG.
func (o *USB_DEVICE_Type) SetOUT_EP0_ST_OUT_EP0_STATE(value uint32) {
	volatile.StoreUint32(&o.OUT_EP0_ST.Reg, volatile.LoadUint32(&o.OUT_EP0_ST.Reg)&^(0x3)|value)
}
func (o *USB_DEVICE_Type) GetOUT_EP0_ST_OUT_EP0_STATE() uint32 {
	return volatile.LoadUint32(&o.OUT_EP0_ST.Reg) & 0x3
}
func (o *USB_DEVICE_Type) SetOUT_EP0_ST_OUT_EP0_WR_ADDR(value uint32) {
	volatile.StoreUint32(&o.OUT_EP0_ST.Reg, volatile.LoadUint32(&o.OUT_EP0_ST.Reg)&^(0x1fc)|value<<2)
}
func (o *USB_DEVICE_Type) GetOUT_EP0_ST_OUT_EP0_WR_ADDR() uint32 {
	return (volatile.LoadUint32(&o.OUT_EP0_ST.Reg) & 0x1fc) >> 2
}
func (o *USB_DEVICE_Type) SetOUT_EP0_ST_OUT_EP0_RD_ADDR(value uint32) {
	volatile.StoreUint32(&o.OUT_EP0_ST.Reg, volatile.LoadUint32(&o.OUT_EP0_ST.Reg)&^(0xfe00)|value<<9)
}
func (o *USB_DEVICE_Type) GetOUT_EP0_ST_OUT_EP0_RD_ADDR() uint32 {
	return (volatile.LoadUint32(&o.OUT_EP0_ST.Reg) & 0xfe00) >> 9
}

// USB_DEVICE.OUT_EP1_ST: USB_DEVICE_OUT_EP1_ST_REG.
func (o *USB_DEVICE_Type) SetOUT_EP1_ST_OUT_EP1_STATE(value uint32) {
	volatile.StoreUint32(&o.OUT_EP1_ST.Reg, volatile.LoadUint32(&o.OUT_EP1_ST.Reg)&^(0x3)|value)
}
func (o *USB_DEVICE_Type) GetOUT_EP1_ST_OUT_EP1_STATE() uint32 {
	return volatile.LoadUint32(&o.OUT_EP1_ST.Reg) & 0x3
}
func (o *USB_DEVICE_Type) SetOUT_EP1_ST_OUT_EP1_WR_ADDR(value uint32) {
	volatile.StoreUint32(&o.OUT_EP1_ST.Reg, volatile.LoadUint32(&o.OUT_EP1_ST.Reg)&^(0x1fc)|value<<2)
}
func (o *USB_DEVICE_Type) GetOUT_EP1_ST_OUT_EP1_WR_ADDR() uint32 {
	return (volatile.LoadUint32(&o.OUT_EP1_ST.Reg) & 0x1fc) >> 2
}
func (o *USB_DEVICE_Type) SetOUT_EP1_ST_OUT_EP1_RD_ADDR(value uint32) {
	volatile.StoreUint32(&o.OUT_EP1_ST.Reg, volatile.LoadUint32(&o.OUT_EP1_ST.Reg)&^(0xfe00)|value<<9)
}
func (o *USB_DEVICE_Type) GetOUT_EP1_ST_OUT_EP1_RD_ADDR() uint32 {
	return (volatile.LoadUint32(&o.OUT_EP1_ST.Reg) & 0xfe00) >> 9
}
func (o *USB_DEVICE_Type) SetOUT_EP1_ST_OUT_EP1_REC_DATA_CNT(value uint32) {
	volatile.StoreUint32(&o.OUT_EP1_ST.Reg, volatile.LoadUint32(&o.OUT_EP1_ST.Reg)&^(0x7f0000)|value<<16)
}
func (o *USB_DEVICE_Type) GetOUT_EP1_ST_OUT_EP1_REC_DATA_CNT() uint32 {
	return (volatile.LoadUint32(&o.OUT_EP1_ST.Reg) & 0x7f0000) >> 16
}

// USB_DEVICE.OUT_EP2_ST: USB_DEVICE_OUT_EP2_ST_REG.
func (o *USB_DEVICE_Type) SetOUT_EP2_ST_OUT_EP2_STATE(value uint32) {
	volatile.StoreUint32(&o.OUT_EP2_ST.Reg, volatile.LoadUint32(&o.OUT_EP2_ST.Reg)&^(0x3)|value)
}
func (o *USB_DEVICE_Type) GetOUT_EP2_ST_OUT_EP2_STATE() uint32 {
	return volatile.LoadUint32(&o.OUT_EP2_ST.Reg) & 0x3
}
func (o *USB_DEVICE_Type) SetOUT_EP2_ST_OUT_EP2_WR_ADDR(value uint32) {
	volatile.StoreUint32(&o.OUT_EP2_ST.Reg, volatile.LoadUint32(&o.OUT_EP2_ST.Reg)&^(0x1fc)|value<<2)
}
func (o *USB_DEVICE_Type) GetOUT_EP2_ST_OUT_EP2_WR_ADDR() uint32 {
	return (volatile.LoadUint32(&o.OUT_EP2_ST.Reg) & 0x1fc) >> 2
}
func (o *USB_DEVICE_Type) SetOUT_EP2_ST_OUT_EP2_RD_ADDR(value uint32) {
	volatile.StoreUint32(&o.OUT_EP2_ST.Reg, volatile.LoadUint32(&o.OUT_EP2_ST.Reg)&^(0xfe00)|value<<9)
}
func (o *USB_DEVICE_Type) GetOUT_EP2_ST_OUT_EP2_RD_ADDR() uint32 {
	return (volatile.LoadUint32(&o.OUT_EP2_ST.Reg) & 0xfe00) >> 9
}

// USB_DEVICE.MISC_CONF: USB_DEVICE_MISC_CONF_REG.
func (o *USB_DEVICE_Type) SetMISC_CONF_CLK_EN(value uint32) {
	volatile.StoreUint32(&o.MISC_CONF.Reg, volatile.LoadUint32(&o.MISC_CONF.Reg)&^(0x1)|value)
}
func (o *USB_DEVICE_Type) GetMISC_CONF_CLK_EN() uint32 {
	return volatile.LoadUint32(&o.MISC_CONF.Reg) & 0x1
}

// USB_DEVICE.MEM_CONF: USB_DEVICE_MEM_CONF_REG.
func (o *USB_DEVICE_Type) SetMEM_CONF_USB_MEM_PD(value uint32) {
	volatile.StoreUint32(&o.MEM_CONF.Reg, volatile.LoadUint32(&o.MEM_CONF.Reg)&^(0x1)|value)
}
func (o *USB_DEVICE_Type) GetMEM_CONF_USB_MEM_PD() uint32 {
	return volatile.LoadUint32(&o.MEM_CONF.Reg) & 0x1
}
func (o *USB_DEVICE_Type) SetMEM_CONF_USB_MEM_CLK_EN(value uint32) {
	volatile.StoreUint32(&o.MEM_CONF.Reg, volatile.LoadUint32(&o.MEM_CONF.Reg)&^(0x2)|value<<1)
}
func (o *USB_DEVICE_Type) GetMEM_CONF_USB_MEM_CLK_EN() uint32 {
	return (volatile.LoadUint32(&o.MEM_CONF.Reg) & 0x2) >> 1
}

// USB_DEVICE.DATE: USB_DEVICE_DATE_REG.
func (o *USB_DEVICE_Type) SetDATE(value uint32) {
	volatile.StoreUint32(&o.DATE.Reg, value)
}
func (o *USB_DEVICE_Type) GetDATE() uint32 {
	return volatile.LoadUint32(&o.DATE.Reg)
}

// Peripheral XTS_AES
type XTS_AES_Type struct {
	PLAIN_MEM        volatile.Register32 // 0x0
	_                [60]byte
	LINESIZE         volatile.Register32 // 0x40
	DESTINATION      volatile.Register32 // 0x44
	PHYSICAL_ADDRESS volatile.Register32 // 0x48
	TRIGGER          volatile.Register32 // 0x4C
	RELEASE          volatile.Register32 // 0x50
	DESTROY          volatile.Register32 // 0x54
	STATE            volatile.Register32 // 0x58
	DATE             volatile.Register32 // 0x5C
}

// XTS_AES.LINESIZE: XTS-AES line-size register
func (o *XTS_AES_Type) SetLINESIZE(value uint32) {
	volatile.StoreUint32(&o.LINESIZE.Reg, volatile.LoadUint32(&o.LINESIZE.Reg)&^(0x1)|value)
}
func (o *XTS_AES_Type) GetLINESIZE() uint32 {
	return volatile.LoadUint32(&o.LINESIZE.Reg) & 0x1
}

// XTS_AES.DESTINATION: XTS-AES destination register
func (o *XTS_AES_Type) SetDESTINATION(value uint32) {
	volatile.StoreUint32(&o.DESTINATION.Reg, volatile.LoadUint32(&o.DESTINATION.Reg)&^(0x1)|value)
}
func (o *XTS_AES_Type) GetDESTINATION() uint32 {
	return volatile.LoadUint32(&o.DESTINATION.Reg) & 0x1
}

// XTS_AES.PHYSICAL_ADDRESS: XTS-AES physical address register
func (o *XTS_AES_Type) SetPHYSICAL_ADDRESS(value uint32) {
	volatile.StoreUint32(&o.PHYSICAL_ADDRESS.Reg, volatile.LoadUint32(&o.PHYSICAL_ADDRESS.Reg)&^(0x3fffffff)|value)
}
func (o *XTS_AES_Type) GetPHYSICAL_ADDRESS() uint32 {
	return volatile.LoadUint32(&o.PHYSICAL_ADDRESS.Reg) & 0x3fffffff
}

// XTS_AES.TRIGGER: XTS-AES trigger register
func (o *XTS_AES_Type) SetTRIGGER(value uint32) {
	volatile.StoreUint32(&o.TRIGGER.Reg, volatile.LoadUint32(&o.TRIGGER.Reg)&^(0x1)|value)
}
func (o *XTS_AES_Type) GetTRIGGER() uint32 {
	return volatile.LoadUint32(&o.TRIGGER.Reg) & 0x1
}

// XTS_AES.RELEASE: XTS-AES release register
func (o *XTS_AES_Type) SetRELEASE(value uint32) {
	volatile.StoreUint32(&o.RELEASE.Reg, volatile.LoadUint32(&o.RELEASE.Reg)&^(0x1)|value)
}
func (o *XTS_AES_Type) GetRELEASE() uint32 {
	return volatile.LoadUint32(&o.RELEASE.Reg) & 0x1
}

// XTS_AES.DESTROY: XTS-AES destroy register
func (o *XTS_AES_Type) SetDESTROY(value uint32) {
	volatile.StoreUint32(&o.DESTROY.Reg, volatile.LoadUint32(&o.DESTROY.Reg)&^(0x1)|value)
}
func (o *XTS_AES_Type) GetDESTROY() uint32 {
	return volatile.LoadUint32(&o.DESTROY.Reg) & 0x1
}

// XTS_AES.STATE: XTS-AES status register
func (o *XTS_AES_Type) SetSTATE(value uint32) {
	volatile.StoreUint32(&o.STATE.Reg, volatile.LoadUint32(&o.STATE.Reg)&^(0x3)|value)
}
func (o *XTS_AES_Type) GetSTATE() uint32 {
	return volatile.LoadUint32(&o.STATE.Reg) & 0x3
}

// XTS_AES.DATE: XTS-AES version control register
func (o *XTS_AES_Type) SetDATE(value uint32) {
	volatile.StoreUint32(&o.DATE.Reg, volatile.LoadUint32(&o.DATE.Reg)&^(0x3fffffff)|value)
}
func (o *XTS_AES_Type) GetDATE() uint32 {
	return volatile.LoadUint32(&o.DATE.Reg) & 0x3fffffff
}

// Constants for AES: Peripheral AES
const (
	// KEY_0: Key material key_0 configure register
	// Position of KEY_0 field.
	AES_KEY_0_KEY_0_Pos = 0x0
	// Bit mask of KEY_0 field.
	AES_KEY_0_KEY_0_Msk = 0xffffffff

	// KEY_1: Key material key_1 configure register
	// Position of KEY_1 field.
	AES_KEY_1_KEY_1_Pos = 0x0
	// Bit mask of KEY_1 field.
	AES_KEY_1_KEY_1_Msk = 0xffffffff

	// KEY_2: Key material key_2 configure register
	// Position of KEY_2 field.
	AES_KEY_2_KEY_2_Pos = 0x0
	// Bit mask of KEY_2 field.
	AES_KEY_2_KEY_2_Msk = 0xffffffff

	// KEY_3: Key material key_3 configure register
	// Position of KEY_3 field.
	AES_KEY_3_KEY_3_Pos = 0x0
	// Bit mask of KEY_3 field.
	AES_KEY_3_KEY_3_Msk = 0xffffffff

	// KEY_4: Key material key_4 configure register
	// Position of KEY_4 field.
	AES_KEY_4_KEY_4_Pos = 0x0
	// Bit mask of KEY_4 field.
	AES_KEY_4_KEY_4_Msk = 0xffffffff

	// KEY_5: Key material key_5 configure register
	// Position of KEY_5 field.
	AES_KEY_5_KEY_5_Pos = 0x0
	// Bit mask of KEY_5 field.
	AES_KEY_5_KEY_5_Msk = 0xffffffff

	// KEY_6: Key material key_6 configure register
	// Position of KEY_6 field.
	AES_KEY_6_KEY_6_Pos = 0x0
	// Bit mask of KEY_6 field.
	AES_KEY_6_KEY_6_Msk = 0xffffffff

	// KEY_7: Key material key_7 configure register
	// Position of KEY_7 field.
	AES_KEY_7_KEY_7_Pos = 0x0
	// Bit mask of KEY_7 field.
	AES_KEY_7_KEY_7_Msk = 0xffffffff

	// TEXT_IN_0: source text material text_in_0 configure register
	// Position of TEXT_IN_0 field.
	AES_TEXT_IN_0_TEXT_IN_0_Pos = 0x0
	// Bit mask of TEXT_IN_0 field.
	AES_TEXT_IN_0_TEXT_IN_0_Msk = 0xffffffff

	// TEXT_IN_1: source text material text_in_1 configure register
	// Position of TEXT_IN_1 field.
	AES_TEXT_IN_1_TEXT_IN_1_Pos = 0x0
	// Bit mask of TEXT_IN_1 field.
	AES_TEXT_IN_1_TEXT_IN_1_Msk = 0xffffffff

	// TEXT_IN_2: source text material text_in_2 configure register
	// Position of TEXT_IN_2 field.
	AES_TEXT_IN_2_TEXT_IN_2_Pos = 0x0
	// Bit mask of TEXT_IN_2 field.
	AES_TEXT_IN_2_TEXT_IN_2_Msk = 0xffffffff

	// TEXT_IN_3: source text material text_in_3 configure register
	// Position of TEXT_IN_3 field.
	AES_TEXT_IN_3_TEXT_IN_3_Pos = 0x0
	// Bit mask of TEXT_IN_3 field.
	AES_TEXT_IN_3_TEXT_IN_3_Msk = 0xffffffff

	// TEXT_OUT_0: result text material text_out_0 configure register
	// Position of TEXT_OUT_0 field.
	AES_TEXT_OUT_0_TEXT_OUT_0_Pos = 0x0
	// Bit mask of TEXT_OUT_0 field.
	AES_TEXT_OUT_0_TEXT_OUT_0_Msk = 0xffffffff

	// TEXT_OUT_1: result text material text_out_1 configure register
	// Position of TEXT_OUT_1 field.
	AES_TEXT_OUT_1_TEXT_OUT_1_Pos = 0x0
	// Bit mask of TEXT_OUT_1 field.
	AES_TEXT_OUT_1_TEXT_OUT_1_Msk = 0xffffffff

	// TEXT_OUT_2: result text material text_out_2 configure register
	// Position of TEXT_OUT_2 field.
	AES_TEXT_OUT_2_TEXT_OUT_2_Pos = 0x0
	// Bit mask of TEXT_OUT_2 field.
	AES_TEXT_OUT_2_TEXT_OUT_2_Msk = 0xffffffff

	// TEXT_OUT_3: result text material text_out_3 configure register
	// Position of TEXT_OUT_3 field.
	AES_TEXT_OUT_3_TEXT_OUT_3_Pos = 0x0
	// Bit mask of TEXT_OUT_3 field.
	AES_TEXT_OUT_3_TEXT_OUT_3_Msk = 0xffffffff

	// MODE: AES Mode register
	// Position of MODE field.
	AES_MODE_MODE_Pos = 0x0
	// Bit mask of MODE field.
	AES_MODE_MODE_Msk = 0x7

	// ENDIAN: AES Endian configure register
	// Position of ENDIAN field.
	AES_ENDIAN_ENDIAN_Pos = 0x0
	// Bit mask of ENDIAN field.
	AES_ENDIAN_ENDIAN_Msk = 0x3f

	// TRIGGER: AES trigger register
	// Position of TRIGGER field.
	AES_TRIGGER_TRIGGER_Pos = 0x0
	// Bit mask of TRIGGER field.
	AES_TRIGGER_TRIGGER_Msk = 0x1
	// Bit TRIGGER.
	AES_TRIGGER_TRIGGER = 0x1

	// STATE: AES state register
	// Position of STATE field.
	AES_STATE_STATE_Pos = 0x0
	// Bit mask of STATE field.
	AES_STATE_STATE_Msk = 0x3

	// DMA_ENABLE: DMA-AES working mode register
	// Position of DMA_ENABLE field.
	AES_DMA_ENABLE_DMA_ENABLE_Pos = 0x0
	// Bit mask of DMA_ENABLE field.
	AES_DMA_ENABLE_DMA_ENABLE_Msk = 0x1
	// Bit DMA_ENABLE.
	AES_DMA_ENABLE_DMA_ENABLE = 0x1

	// BLOCK_MODE: AES cipher block mode register
	// Position of BLOCK_MODE field.
	AES_BLOCK_MODE_BLOCK_MODE_Pos = 0x0
	// Bit mask of BLOCK_MODE field.
	AES_BLOCK_MODE_BLOCK_MODE_Msk = 0x7

	// BLOCK_NUM: AES block number register
	// Position of BLOCK_NUM field.
	AES_BLOCK_NUM_BLOCK_NUM_Pos = 0x0
	// Bit mask of BLOCK_NUM field.
	AES_BLOCK_NUM_BLOCK_NUM_Msk = 0xffffffff

	// INC_SEL: Standard incrementing function configure register
	// Position of INC_SEL field.
	AES_INC_SEL_INC_SEL_Pos = 0x0
	// Bit mask of INC_SEL field.
	AES_INC_SEL_INC_SEL_Msk = 0x1
	// Bit INC_SEL.
	AES_INC_SEL_INC_SEL = 0x1

	// AAD_BLOCK_NUM: Additional Authential Data block number register
	// Position of AAD_BLOCK_NUM field.
	AES_AAD_BLOCK_NUM_AAD_BLOCK_NUM_Pos = 0x0
	// Bit mask of AAD_BLOCK_NUM field.
	AES_AAD_BLOCK_NUM_AAD_BLOCK_NUM_Msk = 0xffffffff

	// REMAINDER_BIT_NUM: AES remainder bit number register
	// Position of REMAINDER_BIT_NUM field.
	AES_REMAINDER_BIT_NUM_REMAINDER_BIT_NUM_Pos = 0x0
	// Bit mask of REMAINDER_BIT_NUM field.
	AES_REMAINDER_BIT_NUM_REMAINDER_BIT_NUM_Msk = 0x7f

	// CONTINUE: AES continue register
	// Position of CONTINUE field.
	AES_CONTINUE_CONTINUE_Pos = 0x0
	// Bit mask of CONTINUE field.
	AES_CONTINUE_CONTINUE_Msk = 0x1
	// Bit CONTINUE.
	AES_CONTINUE_CONTINUE = 0x1

	// INT_CLEAR: AES Interrupt clear register
	// Position of INT_CLEAR field.
	AES_INT_CLEAR_INT_CLEAR_Pos = 0x0
	// Bit mask of INT_CLEAR field.
	AES_INT_CLEAR_INT_CLEAR_Msk = 0x1
	// Bit INT_CLEAR.
	AES_INT_CLEAR_INT_CLEAR = 0x1

	// INT_ENA: AES Interrupt enable register
	// Position of INT_ENA field.
	AES_INT_ENA_INT_ENA_Pos = 0x0
	// Bit mask of INT_ENA field.
	AES_INT_ENA_INT_ENA_Msk = 0x1
	// Bit INT_ENA.
	AES_INT_ENA_INT_ENA = 0x1

	// DATE: AES version control register
	// Position of DATE field.
	AES_DATE_DATE_Pos = 0x0
	// Bit mask of DATE field.
	AES_DATE_DATE_Msk = 0x3fffffff

	// DMA_EXIT: AES-DMA exit config
	// Position of DMA_EXIT field.
	AES_DMA_EXIT_DMA_EXIT_Pos = 0x0
	// Bit mask of DMA_EXIT field.
	AES_DMA_EXIT_DMA_EXIT_Msk = 0x1
	// Bit DMA_EXIT.
	AES_DMA_EXIT_DMA_EXIT = 0x1
)

// Constants for APB_CTRL: Peripheral APB_CTRL
const (
	// SYSCLK_CONF: APB_CTRL_SYSCLK_CONF_REG
	// Position of PRE_DIV_CNT field.
	APB_CTRL_SYSCLK_CONF_PRE_DIV_CNT_Pos = 0x0
	// Bit mask of PRE_DIV_CNT field.
	APB_CTRL_SYSCLK_CONF_PRE_DIV_CNT_Msk = 0x3ff
	// Position of CLK_320M_EN field.
	APB_CTRL_SYSCLK_CONF_CLK_320M_EN_Pos = 0xa
	// Bit mask of CLK_320M_EN field.
	APB_CTRL_SYSCLK_CONF_CLK_320M_EN_Msk = 0x400
	// Bit CLK_320M_EN.
	APB_CTRL_SYSCLK_CONF_CLK_320M_EN = 0x400
	// Position of CLK_EN field.
	APB_CTRL_SYSCLK_CONF_CLK_EN_Pos = 0xb
	// Bit mask of CLK_EN field.
	APB_CTRL_SYSCLK_CONF_CLK_EN_Msk = 0x800
	// Bit CLK_EN.
	APB_CTRL_SYSCLK_CONF_CLK_EN = 0x800
	// Position of RST_TICK_CNT field.
	APB_CTRL_SYSCLK_CONF_RST_TICK_CNT_Pos = 0xc
	// Bit mask of RST_TICK_CNT field.
	APB_CTRL_SYSCLK_CONF_RST_TICK_CNT_Msk = 0x1000
	// Bit RST_TICK_CNT.
	APB_CTRL_SYSCLK_CONF_RST_TICK_CNT = 0x1000

	// TICK_CONF: APB_CTRL_TICK_CONF_REG
	// Position of XTAL_TICK_NUM field.
	APB_CTRL_TICK_CONF_XTAL_TICK_NUM_Pos = 0x0
	// Bit mask of XTAL_TICK_NUM field.
	APB_CTRL_TICK_CONF_XTAL_TICK_NUM_Msk = 0xff
	// Position of CK8M_TICK_NUM field.
	APB_CTRL_TICK_CONF_CK8M_TICK_NUM_Pos = 0x8
	// Bit mask of CK8M_TICK_NUM field.
	APB_CTRL_TICK_CONF_CK8M_TICK_NUM_Msk = 0xff00
	// Position of TICK_ENABLE field.
	APB_CTRL_TICK_CONF_TICK_ENABLE_Pos = 0x10
	// Bit mask of TICK_ENABLE field.
	APB_CTRL_TICK_CONF_TICK_ENABLE_Msk = 0x10000
	// Bit TICK_ENABLE.
	APB_CTRL_TICK_CONF_TICK_ENABLE = 0x10000

	// CLK_OUT_EN: APB_CTRL_CLK_OUT_EN_REG
	// Position of CLK20_OEN field.
	APB_CTRL_CLK_OUT_EN_CLK20_OEN_Pos = 0x0
	// Bit mask of CLK20_OEN field.
	APB_CTRL_CLK_OUT_EN_CLK20_OEN_Msk = 0x1
	// Bit CLK20_OEN.
	APB_CTRL_CLK_OUT_EN_CLK20_OEN = 0x1
	// Position of CLK22_OEN field.
	APB_CTRL_CLK_OUT_EN_CLK22_OEN_Pos = 0x1
	// Bit mask of CLK22_OEN field.
	APB_CTRL_CLK_OUT_EN_CLK22_OEN_Msk = 0x2
	// Bit CLK22_OEN.
	APB_CTRL_CLK_OUT_EN_CLK22_OEN = 0x2
	// Position of CLK44_OEN field.
	APB_CTRL_CLK_OUT_EN_CLK44_OEN_Pos = 0x2
	// Bit mask of CLK44_OEN field.
	APB_CTRL_CLK_OUT_EN_CLK44_OEN_Msk = 0x4
	// Bit CLK44_OEN.
	APB_CTRL_CLK_OUT_EN_CLK44_OEN = 0x4
	// Position of CLK_BB_OEN field.
	APB_CTRL_CLK_OUT_EN_CLK_BB_OEN_Pos = 0x3
	// Bit mask of CLK_BB_OEN field.
	APB_CTRL_CLK_OUT_EN_CLK_BB_OEN_Msk = 0x8
	// Bit CLK_BB_OEN.
	APB_CTRL_CLK_OUT_EN_CLK_BB_OEN = 0x8
	// Position of CLK80_OEN field.
	APB_CTRL_CLK_OUT_EN_CLK80_OEN_Pos = 0x4
	// Bit mask of CLK80_OEN field.
	APB_CTRL_CLK_OUT_EN_CLK80_OEN_Msk = 0x10
	// Bit CLK80_OEN.
	APB_CTRL_CLK_OUT_EN_CLK80_OEN = 0x10
	// Position of CLK160_OEN field.
	APB_CTRL_CLK_OUT_EN_CLK160_OEN_Pos = 0x5
	// Bit mask of CLK160_OEN field.
	APB_CTRL_CLK_OUT_EN_CLK160_OEN_Msk = 0x20
	// Bit CLK160_OEN.
	APB_CTRL_CLK_OUT_EN_CLK160_OEN = 0x20
	// Position of CLK_320M_OEN field.
	APB_CTRL_CLK_OUT_EN_CLK_320M_OEN_Pos = 0x6
	// Bit mask of CLK_320M_OEN field.
	APB_CTRL_CLK_OUT_EN_CLK_320M_OEN_Msk = 0x40
	// Bit CLK_320M_OEN.
	APB_CTRL_CLK_OUT_EN_CLK_320M_OEN = 0x40
	// Position of CLK_ADC_INF_OEN field.
	APB_CTRL_CLK_OUT_EN_CLK_ADC_INF_OEN_Pos = 0x7
	// Bit mask of CLK_ADC_INF_OEN field.
	APB_CTRL_CLK_OUT_EN_CLK_ADC_INF_OEN_Msk = 0x80
	// Bit CLK_ADC_INF_OEN.
	APB_CTRL_CLK_OUT_EN_CLK_ADC_INF_OEN = 0x80
	// Position of CLK_DAC_CPU_OEN field.
	APB_CTRL_CLK_OUT_EN_CLK_DAC_CPU_OEN_Pos = 0x8
	// Bit mask of CLK_DAC_CPU_OEN field.
	APB_CTRL_CLK_OUT_EN_CLK_DAC_CPU_OEN_Msk = 0x100
	// Bit CLK_DAC_CPU_OEN.
	APB_CTRL_CLK_OUT_EN_CLK_DAC_CPU_OEN = 0x100
	// Position of CLK40X_BB_OEN field.
	APB_CTRL_CLK_OUT_EN_CLK40X_BB_OEN_Pos = 0x9
	// Bit mask of CLK40X_BB_OEN field.
	APB_CTRL_CLK_OUT_EN_CLK40X_BB_OEN_Msk = 0x200
	// Bit CLK40X_BB_OEN.
	APB_CTRL_CLK_OUT_EN_CLK40X_BB_OEN = 0x200
	// Position of CLK_XTAL_OEN field.
	APB_CTRL_CLK_OUT_EN_CLK_XTAL_OEN_Pos = 0xa
	// Bit mask of CLK_XTAL_OEN field.
	APB_CTRL_CLK_OUT_EN_CLK_XTAL_OEN_Msk = 0x400
	// Bit CLK_XTAL_OEN.
	APB_CTRL_CLK_OUT_EN_CLK_XTAL_OEN = 0x400

	// WIFI_BB_CFG: APB_CTRL_WIFI_BB_CFG_REG
	// Position of WIFI_BB_CFG field.
	APB_CTRL_WIFI_BB_CFG_WIFI_BB_CFG_Pos = 0x0
	// Bit mask of WIFI_BB_CFG field.
	APB_CTRL_WIFI_BB_CFG_WIFI_BB_CFG_Msk = 0xffffffff

	// WIFI_BB_CFG_2: APB_CTRL_WIFI_BB_CFG_2_REG
	// Position of WIFI_BB_CFG_2 field.
	APB_CTRL_WIFI_BB_CFG_2_WIFI_BB_CFG_2_Pos = 0x0
	// Bit mask of WIFI_BB_CFG_2 field.
	APB_CTRL_WIFI_BB_CFG_2_WIFI_BB_CFG_2_Msk = 0xffffffff

	// WIFI_CLK_EN: APB_CTRL_WIFI_CLK_EN_REG
	// Position of WIFI_CLK_EN field.
	APB_CTRL_WIFI_CLK_EN_WIFI_CLK_EN_Pos = 0x0
	// Bit mask of WIFI_CLK_EN field.
	APB_CTRL_WIFI_CLK_EN_WIFI_CLK_EN_Msk = 0xffffffff

	// WIFI_RST_EN: APB_CTRL_WIFI_RST_EN_REG
	// Position of WIFI_RST field.
	APB_CTRL_WIFI_RST_EN_WIFI_RST_Pos = 0x0
	// Bit mask of WIFI_RST field.
	APB_CTRL_WIFI_RST_EN_WIFI_RST_Msk = 0xffffffff

	// HOST_INF_SEL: APB_CTRL_HOST_INF_SEL_REG
	// Position of PERI_IO_SWAP field.
	APB_CTRL_HOST_INF_SEL_PERI_IO_SWAP_Pos = 0x0
	// Bit mask of PERI_IO_SWAP field.
	APB_CTRL_HOST_INF_SEL_PERI_IO_SWAP_Msk = 0xff

	// EXT_MEM_PMS_LOCK: APB_CTRL_EXT_MEM_PMS_LOCK_REG
	// Position of EXT_MEM_PMS_LOCK field.
	APB_CTRL_EXT_MEM_PMS_LOCK_EXT_MEM_PMS_LOCK_Pos = 0x0
	// Bit mask of EXT_MEM_PMS_LOCK field.
	APB_CTRL_EXT_MEM_PMS_LOCK_EXT_MEM_PMS_LOCK_Msk = 0x1
	// Bit EXT_MEM_PMS_LOCK.
	APB_CTRL_EXT_MEM_PMS_LOCK_EXT_MEM_PMS_LOCK = 0x1

	// FLASH_ACE0_ATTR: APB_CTRL_FLASH_ACE0_ATTR_REG
	// Position of FLASH_ACE0_ATTR field.
	APB_CTRL_FLASH_ACE0_ATTR_FLASH_ACE0_ATTR_Pos = 0x0
	// Bit mask of FLASH_ACE0_ATTR field.
	APB_CTRL_FLASH_ACE0_ATTR_FLASH_ACE0_ATTR_Msk = 0x3

	// FLASH_ACE1_ATTR: APB_CTRL_FLASH_ACE1_ATTR_REG
	// Position of FLASH_ACE1_ATTR field.
	APB_CTRL_FLASH_ACE1_ATTR_FLASH_ACE1_ATTR_Pos = 0x0
	// Bit mask of FLASH_ACE1_ATTR field.
	APB_CTRL_FLASH_ACE1_ATTR_FLASH_ACE1_ATTR_Msk = 0x3

	// FLASH_ACE2_ATTR: APB_CTRL_FLASH_ACE2_ATTR_REG
	// Position of FLASH_ACE2_ATTR field.
	APB_CTRL_FLASH_ACE2_ATTR_FLASH_ACE2_ATTR_Pos = 0x0
	// Bit mask of FLASH_ACE2_ATTR field.
	APB_CTRL_FLASH_ACE2_ATTR_FLASH_ACE2_ATTR_Msk = 0x3

	// FLASH_ACE3_ATTR: APB_CTRL_FLASH_ACE3_ATTR_REG
	// Position of FLASH_ACE3_ATTR field.
	APB_CTRL_FLASH_ACE3_ATTR_FLASH_ACE3_ATTR_Pos = 0x0
	// Bit mask of FLASH_ACE3_ATTR field.
	APB_CTRL_FLASH_ACE3_ATTR_FLASH_ACE3_ATTR_Msk = 0x3

	// FLASH_ACE0_ADDR: APB_CTRL_FLASH_ACE0_ADDR_REG
	// Position of S field.
	APB_CTRL_FLASH_ACE0_ADDR_S_Pos = 0x0
	// Bit mask of S field.
	APB_CTRL_FLASH_ACE0_ADDR_S_Msk = 0xffffffff

	// FLASH_ACE1_ADDR: APB_CTRL_FLASH_ACE1_ADDR_REG
	// Position of S field.
	APB_CTRL_FLASH_ACE1_ADDR_S_Pos = 0x0
	// Bit mask of S field.
	APB_CTRL_FLASH_ACE1_ADDR_S_Msk = 0xffffffff

	// FLASH_ACE2_ADDR: APB_CTRL_FLASH_ACE2_ADDR_REG
	// Position of S field.
	APB_CTRL_FLASH_ACE2_ADDR_S_Pos = 0x0
	// Bit mask of S field.
	APB_CTRL_FLASH_ACE2_ADDR_S_Msk = 0xffffffff

	// FLASH_ACE3_ADDR: APB_CTRL_FLASH_ACE3_ADDR_REG
	// Position of S field.
	APB_CTRL_FLASH_ACE3_ADDR_S_Pos = 0x0
	// Bit mask of S field.
	APB_CTRL_FLASH_ACE3_ADDR_S_Msk = 0xffffffff

	// FLASH_ACE0_SIZE: APB_CTRL_FLASH_ACE0_SIZE_REG
	// Position of FLASH_ACE0_SIZE field.
	APB_CTRL_FLASH_ACE0_SIZE_FLASH_ACE0_SIZE_Pos = 0x0
	// Bit mask of FLASH_ACE0_SIZE field.
	APB_CTRL_FLASH_ACE0_SIZE_FLASH_ACE0_SIZE_Msk = 0x1fff

	// FLASH_ACE1_SIZE: APB_CTRL_FLASH_ACE1_SIZE_REG
	// Position of FLASH_ACE1_SIZE field.
	APB_CTRL_FLASH_ACE1_SIZE_FLASH_ACE1_SIZE_Pos = 0x0
	// Bit mask of FLASH_ACE1_SIZE field.
	APB_CTRL_FLASH_ACE1_SIZE_FLASH_ACE1_SIZE_Msk = 0x1fff

	// FLASH_ACE2_SIZE: APB_CTRL_FLASH_ACE2_SIZE_REG
	// Position of FLASH_ACE2_SIZE field.
	APB_CTRL_FLASH_ACE2_SIZE_FLASH_ACE2_SIZE_Pos = 0x0
	// Bit mask of FLASH_ACE2_SIZE field.
	APB_CTRL_FLASH_ACE2_SIZE_FLASH_ACE2_SIZE_Msk = 0x1fff

	// FLASH_ACE3_SIZE: APB_CTRL_FLASH_ACE3_SIZE_REG
	// Position of FLASH_ACE3_SIZE field.
	APB_CTRL_FLASH_ACE3_SIZE_FLASH_ACE3_SIZE_Pos = 0x0
	// Bit mask of FLASH_ACE3_SIZE field.
	APB_CTRL_FLASH_ACE3_SIZE_FLASH_ACE3_SIZE_Msk = 0x1fff

	// SPI_MEM_PMS_CTRL: APB_CTRL_SPI_MEM_PMS_CTRL_REG
	// Position of SPI_MEM_REJECT_INT field.
	APB_CTRL_SPI_MEM_PMS_CTRL_SPI_MEM_REJECT_INT_Pos = 0x0
	// Bit mask of SPI_MEM_REJECT_INT field.
	APB_CTRL_SPI_MEM_PMS_CTRL_SPI_MEM_REJECT_INT_Msk = 0x1
	// Bit SPI_MEM_REJECT_INT.
	APB_CTRL_SPI_MEM_PMS_CTRL_SPI_MEM_REJECT_INT = 0x1
	// Position of SPI_MEM_REJECT_CLR field.
	APB_CTRL_SPI_MEM_PMS_CTRL_SPI_MEM_REJECT_CLR_Pos = 0x1
	// Bit mask of SPI_MEM_REJECT_CLR field.
	APB_CTRL_SPI_MEM_PMS_CTRL_SPI_MEM_REJECT_CLR_Msk = 0x2
	// Bit SPI_MEM_REJECT_CLR.
	APB_CTRL_SPI_MEM_PMS_CTRL_SPI_MEM_REJECT_CLR = 0x2
	// Position of SPI_MEM_REJECT_CDE field.
	APB_CTRL_SPI_MEM_PMS_CTRL_SPI_MEM_REJECT_CDE_Pos = 0x2
	// Bit mask of SPI_MEM_REJECT_CDE field.
	APB_CTRL_SPI_MEM_PMS_CTRL_SPI_MEM_REJECT_CDE_Msk = 0x7c

	// SPI_MEM_REJECT_ADDR: APB_CTRL_SPI_MEM_REJECT_ADDR_REG
	// Position of SPI_MEM_REJECT_ADDR field.
	APB_CTRL_SPI_MEM_REJECT_ADDR_SPI_MEM_REJECT_ADDR_Pos = 0x0
	// Bit mask of SPI_MEM_REJECT_ADDR field.
	APB_CTRL_SPI_MEM_REJECT_ADDR_SPI_MEM_REJECT_ADDR_Msk = 0xffffffff

	// SDIO_CTRL: APB_CTRL_SDIO_CTRL_REG
	// Position of SDIO_WIN_ACCESS_EN field.
	APB_CTRL_SDIO_CTRL_SDIO_WIN_ACCESS_EN_Pos = 0x0
	// Bit mask of SDIO_WIN_ACCESS_EN field.
	APB_CTRL_SDIO_CTRL_SDIO_WIN_ACCESS_EN_Msk = 0x1
	// Bit SDIO_WIN_ACCESS_EN.
	APB_CTRL_SDIO_CTRL_SDIO_WIN_ACCESS_EN = 0x1

	// REDCY_SIG0: APB_CTRL_REDCY_SIG0_REG
	// Position of REDCY_SIG0 field.
	APB_CTRL_REDCY_SIG0_REDCY_SIG0_Pos = 0x0
	// Bit mask of REDCY_SIG0 field.
	APB_CTRL_REDCY_SIG0_REDCY_SIG0_Msk = 0x7fffffff
	// Position of REDCY_ANDOR field.
	APB_CTRL_REDCY_SIG0_REDCY_ANDOR_Pos = 0x1f
	// Bit mask of REDCY_ANDOR field.
	APB_CTRL_REDCY_SIG0_REDCY_ANDOR_Msk = 0x80000000
	// Bit REDCY_ANDOR.
	APB_CTRL_REDCY_SIG0_REDCY_ANDOR = 0x80000000

	// REDCY_SIG1: APB_CTRL_REDCY_SIG1_REG
	// Position of REDCY_SIG1 field.
	APB_CTRL_REDCY_SIG1_REDCY_SIG1_Pos = 0x0
	// Bit mask of REDCY_SIG1 field.
	APB_CTRL_REDCY_SIG1_REDCY_SIG1_Msk = 0x7fffffff
	// Position of REDCY_NANDOR field.
	APB_CTRL_REDCY_SIG1_REDCY_NANDOR_Pos = 0x1f
	// Bit mask of REDCY_NANDOR field.
	APB_CTRL_REDCY_SIG1_REDCY_NANDOR_Msk = 0x80000000
	// Bit REDCY_NANDOR.
	APB_CTRL_REDCY_SIG1_REDCY_NANDOR = 0x80000000

	// FRONT_END_MEM_PD: APB_CTRL_FRONT_END_MEM_PD_REG
	// Position of AGC_MEM_FORCE_PU field.
	APB_CTRL_FRONT_END_MEM_PD_AGC_MEM_FORCE_PU_Pos = 0x0
	// Bit mask of AGC_MEM_FORCE_PU field.
	APB_CTRL_FRONT_END_MEM_PD_AGC_MEM_FORCE_PU_Msk = 0x1
	// Bit AGC_MEM_FORCE_PU.
	APB_CTRL_FRONT_END_MEM_PD_AGC_MEM_FORCE_PU = 0x1
	// Position of AGC_MEM_FORCE_PD field.
	APB_CTRL_FRONT_END_MEM_PD_AGC_MEM_FORCE_PD_Pos = 0x1
	// Bit mask of AGC_MEM_FORCE_PD field.
	APB_CTRL_FRONT_END_MEM_PD_AGC_MEM_FORCE_PD_Msk = 0x2
	// Bit AGC_MEM_FORCE_PD.
	APB_CTRL_FRONT_END_MEM_PD_AGC_MEM_FORCE_PD = 0x2
	// Position of PBUS_MEM_FORCE_PU field.
	APB_CTRL_FRONT_END_MEM_PD_PBUS_MEM_FORCE_PU_Pos = 0x2
	// Bit mask of PBUS_MEM_FORCE_PU field.
	APB_CTRL_FRONT_END_MEM_PD_PBUS_MEM_FORCE_PU_Msk = 0x4
	// Bit PBUS_MEM_FORCE_PU.
	APB_CTRL_FRONT_END_MEM_PD_PBUS_MEM_FORCE_PU = 0x4
	// Position of PBUS_MEM_FORCE_PD field.
	APB_CTRL_FRONT_END_MEM_PD_PBUS_MEM_FORCE_PD_Pos = 0x3
	// Bit mask of PBUS_MEM_FORCE_PD field.
	APB_CTRL_FRONT_END_MEM_PD_PBUS_MEM_FORCE_PD_Msk = 0x8
	// Bit PBUS_MEM_FORCE_PD.
	APB_CTRL_FRONT_END_MEM_PD_PBUS_MEM_FORCE_PD = 0x8
	// Position of DC_MEM_FORCE_PU field.
	APB_CTRL_FRONT_END_MEM_PD_DC_MEM_FORCE_PU_Pos = 0x4
	// Bit mask of DC_MEM_FORCE_PU field.
	APB_CTRL_FRONT_END_MEM_PD_DC_MEM_FORCE_PU_Msk = 0x10
	// Bit DC_MEM_FORCE_PU.
	APB_CTRL_FRONT_END_MEM_PD_DC_MEM_FORCE_PU = 0x10
	// Position of DC_MEM_FORCE_PD field.
	APB_CTRL_FRONT_END_MEM_PD_DC_MEM_FORCE_PD_Pos = 0x5
	// Bit mask of DC_MEM_FORCE_PD field.
	APB_CTRL_FRONT_END_MEM_PD_DC_MEM_FORCE_PD_Msk = 0x20
	// Bit DC_MEM_FORCE_PD.
	APB_CTRL_FRONT_END_MEM_PD_DC_MEM_FORCE_PD = 0x20

	// RETENTION_CTRL: APB_CTRL_RETENTION_CTRL_REG
	// Position of RETENTION_LINK_ADDR field.
	APB_CTRL_RETENTION_CTRL_RETENTION_LINK_ADDR_Pos = 0x0
	// Bit mask of RETENTION_LINK_ADDR field.
	APB_CTRL_RETENTION_CTRL_RETENTION_LINK_ADDR_Msk = 0x7ffffff
	// Position of NOBYPASS_CPU_ISO_RST field.
	APB_CTRL_RETENTION_CTRL_NOBYPASS_CPU_ISO_RST_Pos = 0x1b
	// Bit mask of NOBYPASS_CPU_ISO_RST field.
	APB_CTRL_RETENTION_CTRL_NOBYPASS_CPU_ISO_RST_Msk = 0x8000000
	// Bit NOBYPASS_CPU_ISO_RST.
	APB_CTRL_RETENTION_CTRL_NOBYPASS_CPU_ISO_RST = 0x8000000

	// CLKGATE_FORCE_ON: APB_CTRL_CLKGATE_FORCE_ON_REG
	// Position of ROM_CLKGATE_FORCE_ON field.
	APB_CTRL_CLKGATE_FORCE_ON_ROM_CLKGATE_FORCE_ON_Pos = 0x0
	// Bit mask of ROM_CLKGATE_FORCE_ON field.
	APB_CTRL_CLKGATE_FORCE_ON_ROM_CLKGATE_FORCE_ON_Msk = 0x3
	// Position of SRAM_CLKGATE_FORCE_ON field.
	APB_CTRL_CLKGATE_FORCE_ON_SRAM_CLKGATE_FORCE_ON_Pos = 0x2
	// Bit mask of SRAM_CLKGATE_FORCE_ON field.
	APB_CTRL_CLKGATE_FORCE_ON_SRAM_CLKGATE_FORCE_ON_Msk = 0x3c

	// MEM_POWER_DOWN: APB_CTRL_MEM_POWER_DOWN_REG
	// Position of ROM_POWER_DOWN field.
	APB_CTRL_MEM_POWER_DOWN_ROM_POWER_DOWN_Pos = 0x0
	// Bit mask of ROM_POWER_DOWN field.
	APB_CTRL_MEM_POWER_DOWN_ROM_POWER_DOWN_Msk = 0x3
	// Position of SRAM_POWER_DOWN field.
	APB_CTRL_MEM_POWER_DOWN_SRAM_POWER_DOWN_Pos = 0x2
	// Bit mask of SRAM_POWER_DOWN field.
	APB_CTRL_MEM_POWER_DOWN_SRAM_POWER_DOWN_Msk = 0x3c

	// MEM_POWER_UP: APB_CTRL_MEM_POWER_UP_REG
	// Position of ROM_POWER_UP field.
	APB_CTRL_MEM_POWER_UP_ROM_POWER_UP_Pos = 0x0
	// Bit mask of ROM_POWER_UP field.
	APB_CTRL_MEM_POWER_UP_ROM_POWER_UP_Msk = 0x3
	// Position of SRAM_POWER_UP field.
	APB_CTRL_MEM_POWER_UP_SRAM_POWER_UP_Pos = 0x2
	// Bit mask of SRAM_POWER_UP field.
	APB_CTRL_MEM_POWER_UP_SRAM_POWER_UP_Msk = 0x3c

	// RND_DATA: APB_CTRL_RND_DATA_REG
	// Position of RND_DATA field.
	APB_CTRL_RND_DATA_RND_DATA_Pos = 0x0
	// Bit mask of RND_DATA field.
	APB_CTRL_RND_DATA_RND_DATA_Msk = 0xffffffff

	// PERI_BACKUP_CONFIG: APB_CTRL_PERI_BACKUP_CONFIG_REG
	// Position of PERI_BACKUP_FLOW_ERR field.
	APB_CTRL_PERI_BACKUP_CONFIG_PERI_BACKUP_FLOW_ERR_Pos = 0x1
	// Bit mask of PERI_BACKUP_FLOW_ERR field.
	APB_CTRL_PERI_BACKUP_CONFIG_PERI_BACKUP_FLOW_ERR_Msk = 0x6
	// Position of PERI_BACKUP_BURST_LIMIT field.
	APB_CTRL_PERI_BACKUP_CONFIG_PERI_BACKUP_BURST_LIMIT_Pos = 0x4
	// Bit mask of PERI_BACKUP_BURST_LIMIT field.
	APB_CTRL_PERI_BACKUP_CONFIG_PERI_BACKUP_BURST_LIMIT_Msk = 0x1f0
	// Position of PERI_BACKUP_TOUT_THRES field.
	APB_CTRL_PERI_BACKUP_CONFIG_PERI_BACKUP_TOUT_THRES_Pos = 0x9
	// Bit mask of PERI_BACKUP_TOUT_THRES field.
	APB_CTRL_PERI_BACKUP_CONFIG_PERI_BACKUP_TOUT_THRES_Msk = 0x7fe00
	// Position of PERI_BACKUP_SIZE field.
	APB_CTRL_PERI_BACKUP_CONFIG_PERI_BACKUP_SIZE_Pos = 0x13
	// Bit mask of PERI_BACKUP_SIZE field.
	APB_CTRL_PERI_BACKUP_CONFIG_PERI_BACKUP_SIZE_Msk = 0x1ff80000
	// Position of PERI_BACKUP_START field.
	APB_CTRL_PERI_BACKUP_CONFIG_PERI_BACKUP_START_Pos = 0x1d
	// Bit mask of PERI_BACKUP_START field.
	APB_CTRL_PERI_BACKUP_CONFIG_PERI_BACKUP_START_Msk = 0x20000000
	// Bit PERI_BACKUP_START.
	APB_CTRL_PERI_BACKUP_CONFIG_PERI_BACKUP_START = 0x20000000
	// Position of PERI_BACKUP_TO_MEM field.
	APB_CTRL_PERI_BACKUP_CONFIG_PERI_BACKUP_TO_MEM_Pos = 0x1e
	// Bit mask of PERI_BACKUP_TO_MEM field.
	APB_CTRL_PERI_BACKUP_CONFIG_PERI_BACKUP_TO_MEM_Msk = 0x40000000
	// Bit PERI_BACKUP_TO_MEM.
	APB_CTRL_PERI_BACKUP_CONFIG_PERI_BACKUP_TO_MEM = 0x40000000
	// Position of PERI_BACKUP_ENA field.
	APB_CTRL_PERI_BACKUP_CONFIG_PERI_BACKUP_ENA_Pos = 0x1f
	// Bit mask of PERI_BACKUP_ENA field.
	APB_CTRL_PERI_BACKUP_CONFIG_PERI_BACKUP_ENA_Msk = 0x80000000
	// Bit PERI_BACKUP_ENA.
	APB_CTRL_PERI_BACKUP_CONFIG_PERI_BACKUP_ENA = 0x80000000

	// PERI_BACKUP_APB_ADDR: APB_CTRL_PERI_BACKUP_APB_ADDR_REG
	// Position of BACKUP_APB_START_ADDR field.
	APB_CTRL_PERI_BACKUP_APB_ADDR_BACKUP_APB_START_ADDR_Pos = 0x0
	// Bit mask of BACKUP_APB_START_ADDR field.
	APB_CTRL_PERI_BACKUP_APB_ADDR_BACKUP_APB_START_ADDR_Msk = 0xffffffff

	// PERI_BACKUP_MEM_ADDR: APB_CTRL_PERI_BACKUP_MEM_ADDR_REG
	// Position of BACKUP_MEM_START_ADDR field.
	APB_CTRL_PERI_BACKUP_MEM_ADDR_BACKUP_MEM_START_ADDR_Pos = 0x0
	// Bit mask of BACKUP_MEM_START_ADDR field.
	APB_CTRL_PERI_BACKUP_MEM_ADDR_BACKUP_MEM_START_ADDR_Msk = 0xffffffff

	// PERI_BACKUP_INT_RAW: APB_CTRL_PERI_BACKUP_INT_RAW_REG
	// Position of PERI_BACKUP_DONE_INT_RAW field.
	APB_CTRL_PERI_BACKUP_INT_RAW_PERI_BACKUP_DONE_INT_RAW_Pos = 0x0
	// Bit mask of PERI_BACKUP_DONE_INT_RAW field.
	APB_CTRL_PERI_BACKUP_INT_RAW_PERI_BACKUP_DONE_INT_RAW_Msk = 0x1
	// Bit PERI_BACKUP_DONE_INT_RAW.
	APB_CTRL_PERI_BACKUP_INT_RAW_PERI_BACKUP_DONE_INT_RAW = 0x1
	// Position of PERI_BACKUP_ERR_INT_RAW field.
	APB_CTRL_PERI_BACKUP_INT_RAW_PERI_BACKUP_ERR_INT_RAW_Pos = 0x1
	// Bit mask of PERI_BACKUP_ERR_INT_RAW field.
	APB_CTRL_PERI_BACKUP_INT_RAW_PERI_BACKUP_ERR_INT_RAW_Msk = 0x2
	// Bit PERI_BACKUP_ERR_INT_RAW.
	APB_CTRL_PERI_BACKUP_INT_RAW_PERI_BACKUP_ERR_INT_RAW = 0x2

	// PERI_BACKUP_INT_ST: APB_CTRL_PERI_BACKUP_INT_ST_REG
	// Position of PERI_BACKUP_DONE_INT_ST field.
	APB_CTRL_PERI_BACKUP_INT_ST_PERI_BACKUP_DONE_INT_ST_Pos = 0x0
	// Bit mask of PERI_BACKUP_DONE_INT_ST field.
	APB_CTRL_PERI_BACKUP_INT_ST_PERI_BACKUP_DONE_INT_ST_Msk = 0x1
	// Bit PERI_BACKUP_DONE_INT_ST.
	APB_CTRL_PERI_BACKUP_INT_ST_PERI_BACKUP_DONE_INT_ST = 0x1
	// Position of PERI_BACKUP_ERR_INT_ST field.
	APB_CTRL_PERI_BACKUP_INT_ST_PERI_BACKUP_ERR_INT_ST_Pos = 0x1
	// Bit mask of PERI_BACKUP_ERR_INT_ST field.
	APB_CTRL_PERI_BACKUP_INT_ST_PERI_BACKUP_ERR_INT_ST_Msk = 0x2
	// Bit PERI_BACKUP_ERR_INT_ST.
	APB_CTRL_PERI_BACKUP_INT_ST_PERI_BACKUP_ERR_INT_ST = 0x2

	// PERI_BACKUP_INT_ENA: APB_CTRL_PERI_BACKUP_INT_ENA_REG
	// Position of PERI_BACKUP_DONE_INT_ENA field.
	APB_CTRL_PERI_BACKUP_INT_ENA_PERI_BACKUP_DONE_INT_ENA_Pos = 0x0
	// Bit mask of PERI_BACKUP_DONE_INT_ENA field.
	APB_CTRL_PERI_BACKUP_INT_ENA_PERI_BACKUP_DONE_INT_ENA_Msk = 0x1
	// Bit PERI_BACKUP_DONE_INT_ENA.
	APB_CTRL_PERI_BACKUP_INT_ENA_PERI_BACKUP_DONE_INT_ENA = 0x1
	// Position of PERI_BACKUP_ERR_INT_ENA field.
	APB_CTRL_PERI_BACKUP_INT_ENA_PERI_BACKUP_ERR_INT_ENA_Pos = 0x1
	// Bit mask of PERI_BACKUP_ERR_INT_ENA field.
	APB_CTRL_PERI_BACKUP_INT_ENA_PERI_BACKUP_ERR_INT_ENA_Msk = 0x2
	// Bit PERI_BACKUP_ERR_INT_ENA.
	APB_CTRL_PERI_BACKUP_INT_ENA_PERI_BACKUP_ERR_INT_ENA = 0x2

	// PERI_BACKUP_INT_CLR: APB_CTRL_PERI_BACKUP_INT_CLR_REG
	// Position of PERI_BACKUP_DONE_INT_CLR field.
	APB_CTRL_PERI_BACKUP_INT_CLR_PERI_BACKUP_DONE_INT_CLR_Pos = 0x0
	// Bit mask of PERI_BACKUP_DONE_INT_CLR field.
	APB_CTRL_PERI_BACKUP_INT_CLR_PERI_BACKUP_DONE_INT_CLR_Msk = 0x1
	// Bit PERI_BACKUP_DONE_INT_CLR.
	APB_CTRL_PERI_BACKUP_INT_CLR_PERI_BACKUP_DONE_INT_CLR = 0x1
	// Position of PERI_BACKUP_ERR_INT_CLR field.
	APB_CTRL_PERI_BACKUP_INT_CLR_PERI_BACKUP_ERR_INT_CLR_Pos = 0x1
	// Bit mask of PERI_BACKUP_ERR_INT_CLR field.
	APB_CTRL_PERI_BACKUP_INT_CLR_PERI_BACKUP_ERR_INT_CLR_Msk = 0x2
	// Bit PERI_BACKUP_ERR_INT_CLR.
	APB_CTRL_PERI_BACKUP_INT_CLR_PERI_BACKUP_ERR_INT_CLR = 0x2

	// DATE: APB_CTRL_DATE_REG
	// Position of DATE field.
	APB_CTRL_DATE_DATE_Pos = 0x0
	// Bit mask of DATE field.
	APB_CTRL_DATE_DATE_Msk = 0xffffffff
)

// Constants for APB_SARADC: Peripheral APB_SARADC
const (
	// CTRL: digital saradc configure register
	// Position of SARADC_START_FORCE field.
	APB_SARADC_CTRL_SARADC_START_FORCE_Pos = 0x0
	// Bit mask of SARADC_START_FORCE field.
	APB_SARADC_CTRL_SARADC_START_FORCE_Msk = 0x1
	// Bit SARADC_START_FORCE.
	APB_SARADC_CTRL_SARADC_START_FORCE = 0x1
	// Position of SARADC_START field.
	APB_SARADC_CTRL_SARADC_START_Pos = 0x1
	// Bit mask of SARADC_START field.
	APB_SARADC_CTRL_SARADC_START_Msk = 0x2
	// Bit SARADC_START.
	APB_SARADC_CTRL_SARADC_START = 0x2
	// Position of SARADC_SAR_CLK_GATED field.
	APB_SARADC_CTRL_SARADC_SAR_CLK_GATED_Pos = 0x6
	// Bit mask of SARADC_SAR_CLK_GATED field.
	APB_SARADC_CTRL_SARADC_SAR_CLK_GATED_Msk = 0x40
	// Bit SARADC_SAR_CLK_GATED.
	APB_SARADC_CTRL_SARADC_SAR_CLK_GATED = 0x40
	// Position of SARADC_SAR_CLK_DIV field.
	APB_SARADC_CTRL_SARADC_SAR_CLK_DIV_Pos = 0x7
	// Bit mask of SARADC_SAR_CLK_DIV field.
	APB_SARADC_CTRL_SARADC_SAR_CLK_DIV_Msk = 0x7f80
	// Position of SARADC_SAR_PATT_LEN field.
	APB_SARADC_CTRL_SARADC_SAR_PATT_LEN_Pos = 0xf
	// Bit mask of SARADC_SAR_PATT_LEN field.
	APB_SARADC_CTRL_SARADC_SAR_PATT_LEN_Msk = 0x38000
	// Position of SARADC_SAR_PATT_P_CLEAR field.
	APB_SARADC_CTRL_SARADC_SAR_PATT_P_CLEAR_Pos = 0x17
	// Bit mask of SARADC_SAR_PATT_P_CLEAR field.
	APB_SARADC_CTRL_SARADC_SAR_PATT_P_CLEAR_Msk = 0x800000
	// Bit SARADC_SAR_PATT_P_CLEAR.
	APB_SARADC_CTRL_SARADC_SAR_PATT_P_CLEAR = 0x800000
	// Position of SARADC_XPD_SAR_FORCE field.
	APB_SARADC_CTRL_SARADC_XPD_SAR_FORCE_Pos = 0x1b
	// Bit mask of SARADC_XPD_SAR_FORCE field.
	APB_SARADC_CTRL_SARADC_XPD_SAR_FORCE_Msk = 0x18000000
	// Position of SARADC_WAIT_ARB_CYCLE field.
	APB_SARADC_CTRL_SARADC_WAIT_ARB_CYCLE_Pos = 0x1e
	// Bit mask of SARADC_WAIT_ARB_CYCLE field.
	APB_SARADC_CTRL_SARADC_WAIT_ARB_CYCLE_Msk = 0xc0000000

	// CTRL2: digital saradc configure register
	// Position of SARADC_MEAS_NUM_LIMIT field.
	APB_SARADC_CTRL2_SARADC_MEAS_NUM_LIMIT_Pos = 0x0
	// Bit mask of SARADC_MEAS_NUM_LIMIT field.
	APB_SARADC_CTRL2_SARADC_MEAS_NUM_LIMIT_Msk = 0x1
	// Bit SARADC_MEAS_NUM_LIMIT.
	APB_SARADC_CTRL2_SARADC_MEAS_NUM_LIMIT = 0x1
	// Position of SARADC_MAX_MEAS_NUM field.
	APB_SARADC_CTRL2_SARADC_MAX_MEAS_NUM_Pos = 0x1
	// Bit mask of SARADC_MAX_MEAS_NUM field.
	APB_SARADC_CTRL2_SARADC_MAX_MEAS_NUM_Msk = 0x1fe
	// Position of SARADC_SAR1_INV field.
	APB_SARADC_CTRL2_SARADC_SAR1_INV_Pos = 0x9
	// Bit mask of SARADC_SAR1_INV field.
	APB_SARADC_CTRL2_SARADC_SAR1_INV_Msk = 0x200
	// Bit SARADC_SAR1_INV.
	APB_SARADC_CTRL2_SARADC_SAR1_INV = 0x200
	// Position of SARADC_SAR2_INV field.
	APB_SARADC_CTRL2_SARADC_SAR2_INV_Pos = 0xa
	// Bit mask of SARADC_SAR2_INV field.
	APB_SARADC_CTRL2_SARADC_SAR2_INV_Msk = 0x400
	// Bit SARADC_SAR2_INV.
	APB_SARADC_CTRL2_SARADC_SAR2_INV = 0x400
	// Position of SARADC_TIMER_TARGET field.
	APB_SARADC_CTRL2_SARADC_TIMER_TARGET_Pos = 0xc
	// Bit mask of SARADC_TIMER_TARGET field.
	APB_SARADC_CTRL2_SARADC_TIMER_TARGET_Msk = 0xfff000
	// Position of SARADC_TIMER_EN field.
	APB_SARADC_CTRL2_SARADC_TIMER_EN_Pos = 0x18
	// Bit mask of SARADC_TIMER_EN field.
	APB_SARADC_CTRL2_SARADC_TIMER_EN_Msk = 0x1000000
	// Bit SARADC_TIMER_EN.
	APB_SARADC_CTRL2_SARADC_TIMER_EN = 0x1000000

	// FILTER_CTRL1: digital saradc configure register
	// Position of APB_SARADC_FILTER_FACTOR1 field.
	APB_SARADC_FILTER_CTRL1_APB_SARADC_FILTER_FACTOR1_Pos = 0x1a
	// Bit mask of APB_SARADC_FILTER_FACTOR1 field.
	APB_SARADC_FILTER_CTRL1_APB_SARADC_FILTER_FACTOR1_Msk = 0x1c000000
	// Position of APB_SARADC_FILTER_FACTOR0 field.
	APB_SARADC_FILTER_CTRL1_APB_SARADC_FILTER_FACTOR0_Pos = 0x1d
	// Bit mask of APB_SARADC_FILTER_FACTOR0 field.
	APB_SARADC_FILTER_CTRL1_APB_SARADC_FILTER_FACTOR0_Msk = 0xe0000000

	// FSM_WAIT: digital saradc configure register
	// Position of SARADC_XPD_WAIT field.
	APB_SARADC_FSM_WAIT_SARADC_XPD_WAIT_Pos = 0x0
	// Bit mask of SARADC_XPD_WAIT field.
	APB_SARADC_FSM_WAIT_SARADC_XPD_WAIT_Msk = 0xff
	// Position of SARADC_RSTB_WAIT field.
	APB_SARADC_FSM_WAIT_SARADC_RSTB_WAIT_Pos = 0x8
	// Bit mask of SARADC_RSTB_WAIT field.
	APB_SARADC_FSM_WAIT_SARADC_RSTB_WAIT_Msk = 0xff00
	// Position of SARADC_STANDBY_WAIT field.
	APB_SARADC_FSM_WAIT_SARADC_STANDBY_WAIT_Pos = 0x10
	// Bit mask of SARADC_STANDBY_WAIT field.
	APB_SARADC_FSM_WAIT_SARADC_STANDBY_WAIT_Msk = 0xff0000

	// SAR1_STATUS: digital saradc configure register
	// Position of SARADC_SAR1_STATUS field.
	APB_SARADC_SAR1_STATUS_SARADC_SAR1_STATUS_Pos = 0x0
	// Bit mask of SARADC_SAR1_STATUS field.
	APB_SARADC_SAR1_STATUS_SARADC_SAR1_STATUS_Msk = 0xffffffff

	// SAR2_STATUS: digital saradc configure register
	// Position of SARADC_SAR2_STATUS field.
	APB_SARADC_SAR2_STATUS_SARADC_SAR2_STATUS_Pos = 0x0
	// Bit mask of SARADC_SAR2_STATUS field.
	APB_SARADC_SAR2_STATUS_SARADC_SAR2_STATUS_Msk = 0xffffffff

	// SAR_PATT_TAB1: digital saradc configure register
	// Position of SARADC_SAR_PATT_TAB1 field.
	APB_SARADC_SAR_PATT_TAB1_SARADC_SAR_PATT_TAB1_Pos = 0x0
	// Bit mask of SARADC_SAR_PATT_TAB1 field.
	APB_SARADC_SAR_PATT_TAB1_SARADC_SAR_PATT_TAB1_Msk = 0xffffff

	// SAR_PATT_TAB2: digital saradc configure register
	// Position of SARADC_SAR_PATT_TAB2 field.
	APB_SARADC_SAR_PATT_TAB2_SARADC_SAR_PATT_TAB2_Pos = 0x0
	// Bit mask of SARADC_SAR_PATT_TAB2 field.
	APB_SARADC_SAR_PATT_TAB2_SARADC_SAR_PATT_TAB2_Msk = 0xffffff

	// ONETIME_SAMPLE: digital saradc configure register
	// Position of SARADC_ONETIME_ATTEN field.
	APB_SARADC_ONETIME_SAMPLE_SARADC_ONETIME_ATTEN_Pos = 0x17
	// Bit mask of SARADC_ONETIME_ATTEN field.
	APB_SARADC_ONETIME_SAMPLE_SARADC_ONETIME_ATTEN_Msk = 0x1800000
	// Position of SARADC_ONETIME_CHANNEL field.
	APB_SARADC_ONETIME_SAMPLE_SARADC_ONETIME_CHANNEL_Pos = 0x19
	// Bit mask of SARADC_ONETIME_CHANNEL field.
	APB_SARADC_ONETIME_SAMPLE_SARADC_ONETIME_CHANNEL_Msk = 0x1e000000
	// Position of SARADC_ONETIME_START field.
	APB_SARADC_ONETIME_SAMPLE_SARADC_ONETIME_START_Pos = 0x1d
	// Bit mask of SARADC_ONETIME_START field.
	APB_SARADC_ONETIME_SAMPLE_SARADC_ONETIME_START_Msk = 0x20000000
	// Bit SARADC_ONETIME_START.
	APB_SARADC_ONETIME_SAMPLE_SARADC_ONETIME_START = 0x20000000
	// Position of SARADC2_ONETIME_SAMPLE field.
	APB_SARADC_ONETIME_SAMPLE_SARADC2_ONETIME_SAMPLE_Pos = 0x1e
	// Bit mask of SARADC2_ONETIME_SAMPLE field.
	APB_SARADC_ONETIME_SAMPLE_SARADC2_ONETIME_SAMPLE_Msk = 0x40000000
	// Bit SARADC2_ONETIME_SAMPLE.
	APB_SARADC_ONETIME_SAMPLE_SARADC2_ONETIME_SAMPLE = 0x40000000
	// Position of SARADC1_ONETIME_SAMPLE field.
	APB_SARADC_ONETIME_SAMPLE_SARADC1_ONETIME_SAMPLE_Pos = 0x1f
	// Bit mask of SARADC1_ONETIME_SAMPLE field.
	APB_SARADC_ONETIME_SAMPLE_SARADC1_ONETIME_SAMPLE_Msk = 0x80000000
	// Bit SARADC1_ONETIME_SAMPLE.
	APB_SARADC_ONETIME_SAMPLE_SARADC1_ONETIME_SAMPLE = 0x80000000

	// ARB_CTRL: digital saradc configure register
	// Position of ADC_ARB_APB_FORCE field.
	APB_SARADC_ARB_CTRL_ADC_ARB_APB_FORCE_Pos = 0x2
	// Bit mask of ADC_ARB_APB_FORCE field.
	APB_SARADC_ARB_CTRL_ADC_ARB_APB_FORCE_Msk = 0x4
	// Bit ADC_ARB_APB_FORCE.
	APB_SARADC_ARB_CTRL_ADC_ARB_APB_FORCE = 0x4
	// Position of ADC_ARB_RTC_FORCE field.
	APB_SARADC_ARB_CTRL_ADC_ARB_RTC_FORCE_Pos = 0x3
	// Bit mask of ADC_ARB_RTC_FORCE field.
	APB_SARADC_ARB_CTRL_ADC_ARB_RTC_FORCE_Msk = 0x8
	// Bit ADC_ARB_RTC_FORCE.
	APB_SARADC_ARB_CTRL_ADC_ARB_RTC_FORCE = 0x8
	// Position of ADC_ARB_WIFI_FORCE field.
	APB_SARADC_ARB_CTRL_ADC_ARB_WIFI_FORCE_Pos = 0x4
	// Bit mask of ADC_ARB_WIFI_FORCE field.
	APB_SARADC_ARB_CTRL_ADC_ARB_WIFI_FORCE_Msk = 0x10
	// Bit ADC_ARB_WIFI_FORCE.
	APB_SARADC_ARB_CTRL_ADC_ARB_WIFI_FORCE = 0x10
	// Position of ADC_ARB_GRANT_FORCE field.
	APB_SARADC_ARB_CTRL_ADC_ARB_GRANT_FORCE_Pos = 0x5
	// Bit mask of ADC_ARB_GRANT_FORCE field.
	APB_SARADC_ARB_CTRL_ADC_ARB_GRANT_FORCE_Msk = 0x20
	// Bit ADC_ARB_GRANT_FORCE.
	APB_SARADC_ARB_CTRL_ADC_ARB_GRANT_FORCE = 0x20
	// Position of ADC_ARB_APB_PRIORITY field.
	APB_SARADC_ARB_CTRL_ADC_ARB_APB_PRIORITY_Pos = 0x6
	// Bit mask of ADC_ARB_APB_PRIORITY field.
	APB_SARADC_ARB_CTRL_ADC_ARB_APB_PRIORITY_Msk = 0xc0
	// Position of ADC_ARB_RTC_PRIORITY field.
	APB_SARADC_ARB_CTRL_ADC_ARB_RTC_PRIORITY_Pos = 0x8
	// Bit mask of ADC_ARB_RTC_PRIORITY field.
	APB_SARADC_ARB_CTRL_ADC_ARB_RTC_PRIORITY_Msk = 0x300
	// Position of ADC_ARB_WIFI_PRIORITY field.
	APB_SARADC_ARB_CTRL_ADC_ARB_WIFI_PRIORITY_Pos = 0xa
	// Bit mask of ADC_ARB_WIFI_PRIORITY field.
	APB_SARADC_ARB_CTRL_ADC_ARB_WIFI_PRIORITY_Msk = 0xc00
	// Position of ADC_ARB_FIX_PRIORITY field.
	APB_SARADC_ARB_CTRL_ADC_ARB_FIX_PRIORITY_Pos = 0xc
	// Bit mask of ADC_ARB_FIX_PRIORITY field.
	APB_SARADC_ARB_CTRL_ADC_ARB_FIX_PRIORITY_Msk = 0x1000
	// Bit ADC_ARB_FIX_PRIORITY.
	APB_SARADC_ARB_CTRL_ADC_ARB_FIX_PRIORITY = 0x1000

	// FILTER_CTRL0: digital saradc configure register
	// Position of APB_SARADC_FILTER_CHANNEL1 field.
	APB_SARADC_FILTER_CTRL0_APB_SARADC_FILTER_CHANNEL1_Pos = 0x12
	// Bit mask of APB_SARADC_FILTER_CHANNEL1 field.
	APB_SARADC_FILTER_CTRL0_APB_SARADC_FILTER_CHANNEL1_Msk = 0x3c0000
	// Position of APB_SARADC_FILTER_CHANNEL0 field.
	APB_SARADC_FILTER_CTRL0_APB_SARADC_FILTER_CHANNEL0_Pos = 0x16
	// Bit mask of APB_SARADC_FILTER_CHANNEL0 field.
	APB_SARADC_FILTER_CTRL0_APB_SARADC_FILTER_CHANNEL0_Msk = 0x3c00000
	// Position of APB_SARADC_FILTER_RESET field.
	APB_SARADC_FILTER_CTRL0_APB_SARADC_FILTER_RESET_Pos = 0x1f
	// Bit mask of APB_SARADC_FILTER_RESET field.
	APB_SARADC_FILTER_CTRL0_APB_SARADC_FILTER_RESET_Msk = 0x80000000
	// Bit APB_SARADC_FILTER_RESET.
	APB_SARADC_FILTER_CTRL0_APB_SARADC_FILTER_RESET = 0x80000000

	// SAR1DATA_STATUS: digital saradc configure register
	// Position of APB_SARADC1_DATA field.
	APB_SARADC_SAR1DATA_STATUS_APB_SARADC1_DATA_Pos = 0x0
	// Bit mask of APB_SARADC1_DATA field.
	APB_SARADC_SAR1DATA_STATUS_APB_SARADC1_DATA_Msk = 0x1ffff

	// SAR2DATA_STATUS: digital saradc configure register
	// Position of APB_SARADC2_DATA field.
	APB_SARADC_SAR2DATA_STATUS_APB_SARADC2_DATA_Pos = 0x0
	// Bit mask of APB_SARADC2_DATA field.
	APB_SARADC_SAR2DATA_STATUS_APB_SARADC2_DATA_Msk = 0x1ffff

	// THRES0_CTRL: digital saradc configure register
	// Position of APB_SARADC_THRES0_CHANNEL field.
	APB_SARADC_THRES0_CTRL_APB_SARADC_THRES0_CHANNEL_Pos = 0x0
	// Bit mask of APB_SARADC_THRES0_CHANNEL field.
	APB_SARADC_THRES0_CTRL_APB_SARADC_THRES0_CHANNEL_Msk = 0xf
	// Position of APB_SARADC_THRES0_HIGH field.
	APB_SARADC_THRES0_CTRL_APB_SARADC_THRES0_HIGH_Pos = 0x5
	// Bit mask of APB_SARADC_THRES0_HIGH field.
	APB_SARADC_THRES0_CTRL_APB_SARADC_THRES0_HIGH_Msk = 0x3ffe0
	// Position of APB_SARADC_THRES0_LOW field.
	APB_SARADC_THRES0_CTRL_APB_SARADC_THRES0_LOW_Pos = 0x12
	// Bit mask of APB_SARADC_THRES0_LOW field.
	APB_SARADC_THRES0_CTRL_APB_SARADC_THRES0_LOW_Msk = 0x7ffc0000

	// THRES1_CTRL: digital saradc configure register
	// Position of APB_SARADC_THRES1_CHANNEL field.
	APB_SARADC_THRES1_CTRL_APB_SARADC_THRES1_CHANNEL_Pos = 0x0
	// Bit mask of APB_SARADC_THRES1_CHANNEL field.
	APB_SARADC_THRES1_CTRL_APB_SARADC_THRES1_CHANNEL_Msk = 0xf
	// Position of APB_SARADC_THRES1_HIGH field.
	APB_SARADC_THRES1_CTRL_APB_SARADC_THRES1_HIGH_Pos = 0x5
	// Bit mask of APB_SARADC_THRES1_HIGH field.
	APB_SARADC_THRES1_CTRL_APB_SARADC_THRES1_HIGH_Msk = 0x3ffe0
	// Position of APB_SARADC_THRES1_LOW field.
	APB_SARADC_THRES1_CTRL_APB_SARADC_THRES1_LOW_Pos = 0x12
	// Bit mask of APB_SARADC_THRES1_LOW field.
	APB_SARADC_THRES1_CTRL_APB_SARADC_THRES1_LOW_Msk = 0x7ffc0000

	// THRES_CTRL: digital saradc configure register
	// Position of APB_SARADC_THRES_ALL_EN field.
	APB_SARADC_THRES_CTRL_APB_SARADC_THRES_ALL_EN_Pos = 0x1b
	// Bit mask of APB_SARADC_THRES_ALL_EN field.
	APB_SARADC_THRES_CTRL_APB_SARADC_THRES_ALL_EN_Msk = 0x8000000
	// Bit APB_SARADC_THRES_ALL_EN.
	APB_SARADC_THRES_CTRL_APB_SARADC_THRES_ALL_EN = 0x8000000
	// Position of APB_SARADC_THRES1_EN field.
	APB_SARADC_THRES_CTRL_APB_SARADC_THRES1_EN_Pos = 0x1e
	// Bit mask of APB_SARADC_THRES1_EN field.
	APB_SARADC_THRES_CTRL_APB_SARADC_THRES1_EN_Msk = 0x40000000
	// Bit APB_SARADC_THRES1_EN.
	APB_SARADC_THRES_CTRL_APB_SARADC_THRES1_EN = 0x40000000
	// Position of APB_SARADC_THRES0_EN field.
	APB_SARADC_THRES_CTRL_APB_SARADC_THRES0_EN_Pos = 0x1f
	// Bit mask of APB_SARADC_THRES0_EN field.
	APB_SARADC_THRES_CTRL_APB_SARADC_THRES0_EN_Msk = 0x80000000
	// Bit APB_SARADC_THRES0_EN.
	APB_SARADC_THRES_CTRL_APB_SARADC_THRES0_EN = 0x80000000

	// INT_ENA: digital saradc int register
	// Position of APB_SARADC_THRES1_LOW_INT_ENA field.
	APB_SARADC_INT_ENA_APB_SARADC_THRES1_LOW_INT_ENA_Pos = 0x1a
	// Bit mask of APB_SARADC_THRES1_LOW_INT_ENA field.
	APB_SARADC_INT_ENA_APB_SARADC_THRES1_LOW_INT_ENA_Msk = 0x4000000
	// Bit APB_SARADC_THRES1_LOW_INT_ENA.
	APB_SARADC_INT_ENA_APB_SARADC_THRES1_LOW_INT_ENA = 0x4000000
	// Position of APB_SARADC_THRES0_LOW_INT_ENA field.
	APB_SARADC_INT_ENA_APB_SARADC_THRES0_LOW_INT_ENA_Pos = 0x1b
	// Bit mask of APB_SARADC_THRES0_LOW_INT_ENA field.
	APB_SARADC_INT_ENA_APB_SARADC_THRES0_LOW_INT_ENA_Msk = 0x8000000
	// Bit APB_SARADC_THRES0_LOW_INT_ENA.
	APB_SARADC_INT_ENA_APB_SARADC_THRES0_LOW_INT_ENA = 0x8000000
	// Position of APB_SARADC_THRES1_HIGH_INT_ENA field.
	APB_SARADC_INT_ENA_APB_SARADC_THRES1_HIGH_INT_ENA_Pos = 0x1c
	// Bit mask of APB_SARADC_THRES1_HIGH_INT_ENA field.
	APB_SARADC_INT_ENA_APB_SARADC_THRES1_HIGH_INT_ENA_Msk = 0x10000000
	// Bit APB_SARADC_THRES1_HIGH_INT_ENA.
	APB_SARADC_INT_ENA_APB_SARADC_THRES1_HIGH_INT_ENA = 0x10000000
	// Position of APB_SARADC_THRES0_HIGH_INT_ENA field.
	APB_SARADC_INT_ENA_APB_SARADC_THRES0_HIGH_INT_ENA_Pos = 0x1d
	// Bit mask of APB_SARADC_THRES0_HIGH_INT_ENA field.
	APB_SARADC_INT_ENA_APB_SARADC_THRES0_HIGH_INT_ENA_Msk = 0x20000000
	// Bit APB_SARADC_THRES0_HIGH_INT_ENA.
	APB_SARADC_INT_ENA_APB_SARADC_THRES0_HIGH_INT_ENA = 0x20000000
	// Position of APB_SARADC2_DONE_INT_ENA field.
	APB_SARADC_INT_ENA_APB_SARADC2_DONE_INT_ENA_Pos = 0x1e
	// Bit mask of APB_SARADC2_DONE_INT_ENA field.
	APB_SARADC_INT_ENA_APB_SARADC2_DONE_INT_ENA_Msk = 0x40000000
	// Bit APB_SARADC2_DONE_INT_ENA.
	APB_SARADC_INT_ENA_APB_SARADC2_DONE_INT_ENA = 0x40000000
	// Position of APB_SARADC1_DONE_INT_ENA field.
	APB_SARADC_INT_ENA_APB_SARADC1_DONE_INT_ENA_Pos = 0x1f
	// Bit mask of APB_SARADC1_DONE_INT_ENA field.
	APB_SARADC_INT_ENA_APB_SARADC1_DONE_INT_ENA_Msk = 0x80000000
	// Bit APB_SARADC1_DONE_INT_ENA.
	APB_SARADC_INT_ENA_APB_SARADC1_DONE_INT_ENA = 0x80000000

	// INT_RAW: digital saradc int register
	// Position of APB_SARADC_THRES1_LOW_INT_RAW field.
	APB_SARADC_INT_RAW_APB_SARADC_THRES1_LOW_INT_RAW_Pos = 0x1a
	// Bit mask of APB_SARADC_THRES1_LOW_INT_RAW field.
	APB_SARADC_INT_RAW_APB_SARADC_THRES1_LOW_INT_RAW_Msk = 0x4000000
	// Bit APB_SARADC_THRES1_LOW_INT_RAW.
	APB_SARADC_INT_RAW_APB_SARADC_THRES1_LOW_INT_RAW = 0x4000000
	// Position of APB_SARADC_THRES0_LOW_INT_RAW field.
	APB_SARADC_INT_RAW_APB_SARADC_THRES0_LOW_INT_RAW_Pos = 0x1b
	// Bit mask of APB_SARADC_THRES0_LOW_INT_RAW field.
	APB_SARADC_INT_RAW_APB_SARADC_THRES0_LOW_INT_RAW_Msk = 0x8000000
	// Bit APB_SARADC_THRES0_LOW_INT_RAW.
	APB_SARADC_INT_RAW_APB_SARADC_THRES0_LOW_INT_RAW = 0x8000000
	// Position of APB_SARADC_THRES1_HIGH_INT_RAW field.
	APB_SARADC_INT_RAW_APB_SARADC_THRES1_HIGH_INT_RAW_Pos = 0x1c
	// Bit mask of APB_SARADC_THRES1_HIGH_INT_RAW field.
	APB_SARADC_INT_RAW_APB_SARADC_THRES1_HIGH_INT_RAW_Msk = 0x10000000
	// Bit APB_SARADC_THRES1_HIGH_INT_RAW.
	APB_SARADC_INT_RAW_APB_SARADC_THRES1_HIGH_INT_RAW = 0x10000000
	// Position of APB_SARADC_THRES0_HIGH_INT_RAW field.
	APB_SARADC_INT_RAW_APB_SARADC_THRES0_HIGH_INT_RAW_Pos = 0x1d
	// Bit mask of APB_SARADC_THRES0_HIGH_INT_RAW field.
	APB_SARADC_INT_RAW_APB_SARADC_THRES0_HIGH_INT_RAW_Msk = 0x20000000
	// Bit APB_SARADC_THRES0_HIGH_INT_RAW.
	APB_SARADC_INT_RAW_APB_SARADC_THRES0_HIGH_INT_RAW = 0x20000000
	// Position of APB_SARADC2_DONE_INT_RAW field.
	APB_SARADC_INT_RAW_APB_SARADC2_DONE_INT_RAW_Pos = 0x1e
	// Bit mask of APB_SARADC2_DONE_INT_RAW field.
	APB_SARADC_INT_RAW_APB_SARADC2_DONE_INT_RAW_Msk = 0x40000000
	// Bit APB_SARADC2_DONE_INT_RAW.
	APB_SARADC_INT_RAW_APB_SARADC2_DONE_INT_RAW = 0x40000000
	// Position of APB_SARADC1_DONE_INT_RAW field.
	APB_SARADC_INT_RAW_APB_SARADC1_DONE_INT_RAW_Pos = 0x1f
	// Bit mask of APB_SARADC1_DONE_INT_RAW field.
	APB_SARADC_INT_RAW_APB_SARADC1_DONE_INT_RAW_Msk = 0x80000000
	// Bit APB_SARADC1_DONE_INT_RAW.
	APB_SARADC_INT_RAW_APB_SARADC1_DONE_INT_RAW = 0x80000000

	// INT_ST: digital saradc int register
	// Position of APB_SARADC_THRES1_LOW_INT_ST field.
	APB_SARADC_INT_ST_APB_SARADC_THRES1_LOW_INT_ST_Pos = 0x1a
	// Bit mask of APB_SARADC_THRES1_LOW_INT_ST field.
	APB_SARADC_INT_ST_APB_SARADC_THRES1_LOW_INT_ST_Msk = 0x4000000
	// Bit APB_SARADC_THRES1_LOW_INT_ST.
	APB_SARADC_INT_ST_APB_SARADC_THRES1_LOW_INT_ST = 0x4000000
	// Position of APB_SARADC_THRES0_LOW_INT_ST field.
	APB_SARADC_INT_ST_APB_SARADC_THRES0_LOW_INT_ST_Pos = 0x1b
	// Bit mask of APB_SARADC_THRES0_LOW_INT_ST field.
	APB_SARADC_INT_ST_APB_SARADC_THRES0_LOW_INT_ST_Msk = 0x8000000
	// Bit APB_SARADC_THRES0_LOW_INT_ST.
	APB_SARADC_INT_ST_APB_SARADC_THRES0_LOW_INT_ST = 0x8000000
	// Position of APB_SARADC_THRES1_HIGH_INT_ST field.
	APB_SARADC_INT_ST_APB_SARADC_THRES1_HIGH_INT_ST_Pos = 0x1c
	// Bit mask of APB_SARADC_THRES1_HIGH_INT_ST field.
	APB_SARADC_INT_ST_APB_SARADC_THRES1_HIGH_INT_ST_Msk = 0x10000000
	// Bit APB_SARADC_THRES1_HIGH_INT_ST.
	APB_SARADC_INT_ST_APB_SARADC_THRES1_HIGH_INT_ST = 0x10000000
	// Position of APB_SARADC_THRES0_HIGH_INT_ST field.
	APB_SARADC_INT_ST_APB_SARADC_THRES0_HIGH_INT_ST_Pos = 0x1d
	// Bit mask of APB_SARADC_THRES0_HIGH_INT_ST field.
	APB_SARADC_INT_ST_APB_SARADC_THRES0_HIGH_INT_ST_Msk = 0x20000000
	// Bit APB_SARADC_THRES0_HIGH_INT_ST.
	APB_SARADC_INT_ST_APB_SARADC_THRES0_HIGH_INT_ST = 0x20000000
	// Position of APB_SARADC2_DONE_INT_ST field.
	APB_SARADC_INT_ST_APB_SARADC2_DONE_INT_ST_Pos = 0x1e
	// Bit mask of APB_SARADC2_DONE_INT_ST field.
	APB_SARADC_INT_ST_APB_SARADC2_DONE_INT_ST_Msk = 0x40000000
	// Bit APB_SARADC2_DONE_INT_ST.
	APB_SARADC_INT_ST_APB_SARADC2_DONE_INT_ST = 0x40000000
	// Position of APB_SARADC1_DONE_INT_ST field.
	APB_SARADC_INT_ST_APB_SARADC1_DONE_INT_ST_Pos = 0x1f
	// Bit mask of APB_SARADC1_DONE_INT_ST field.
	APB_SARADC_INT_ST_APB_SARADC1_DONE_INT_ST_Msk = 0x80000000
	// Bit APB_SARADC1_DONE_INT_ST.
	APB_SARADC_INT_ST_APB_SARADC1_DONE_INT_ST = 0x80000000

	// INT_CLR: digital saradc int register
	// Position of APB_SARADC_THRES1_LOW_INT_CLR field.
	APB_SARADC_INT_CLR_APB_SARADC_THRES1_LOW_INT_CLR_Pos = 0x1a
	// Bit mask of APB_SARADC_THRES1_LOW_INT_CLR field.
	APB_SARADC_INT_CLR_APB_SARADC_THRES1_LOW_INT_CLR_Msk = 0x4000000
	// Bit APB_SARADC_THRES1_LOW_INT_CLR.
	APB_SARADC_INT_CLR_APB_SARADC_THRES1_LOW_INT_CLR = 0x4000000
	// Position of APB_SARADC_THRES0_LOW_INT_CLR field.
	APB_SARADC_INT_CLR_APB_SARADC_THRES0_LOW_INT_CLR_Pos = 0x1b
	// Bit mask of APB_SARADC_THRES0_LOW_INT_CLR field.
	APB_SARADC_INT_CLR_APB_SARADC_THRES0_LOW_INT_CLR_Msk = 0x8000000
	// Bit APB_SARADC_THRES0_LOW_INT_CLR.
	APB_SARADC_INT_CLR_APB_SARADC_THRES0_LOW_INT_CLR = 0x8000000
	// Position of APB_SARADC_THRES1_HIGH_INT_CLR field.
	APB_SARADC_INT_CLR_APB_SARADC_THRES1_HIGH_INT_CLR_Pos = 0x1c
	// Bit mask of APB_SARADC_THRES1_HIGH_INT_CLR field.
	APB_SARADC_INT_CLR_APB_SARADC_THRES1_HIGH_INT_CLR_Msk = 0x10000000
	// Bit APB_SARADC_THRES1_HIGH_INT_CLR.
	APB_SARADC_INT_CLR_APB_SARADC_THRES1_HIGH_INT_CLR = 0x10000000
	// Position of APB_SARADC_THRES0_HIGH_INT_CLR field.
	APB_SARADC_INT_CLR_APB_SARADC_THRES0_HIGH_INT_CLR_Pos = 0x1d
	// Bit mask of APB_SARADC_THRES0_HIGH_INT_CLR field.
	APB_SARADC_INT_CLR_APB_SARADC_THRES0_HIGH_INT_CLR_Msk = 0x20000000
	// Bit APB_SARADC_THRES0_HIGH_INT_CLR.
	APB_SARADC_INT_CLR_APB_SARADC_THRES0_HIGH_INT_CLR = 0x20000000
	// Position of APB_SARADC2_DONE_INT_CLR field.
	APB_SARADC_INT_CLR_APB_SARADC2_DONE_INT_CLR_Pos = 0x1e
	// Bit mask of APB_SARADC2_DONE_INT_CLR field.
	APB_SARADC_INT_CLR_APB_SARADC2_DONE_INT_CLR_Msk = 0x40000000
	// Bit APB_SARADC2_DONE_INT_CLR.
	APB_SARADC_INT_CLR_APB_SARADC2_DONE_INT_CLR = 0x40000000
	// Position of APB_SARADC1_DONE_INT_CLR field.
	APB_SARADC_INT_CLR_APB_SARADC1_DONE_INT_CLR_Pos = 0x1f
	// Bit mask of APB_SARADC1_DONE_INT_CLR field.
	APB_SARADC_INT_CLR_APB_SARADC1_DONE_INT_CLR_Msk = 0x80000000
	// Bit APB_SARADC1_DONE_INT_CLR.
	APB_SARADC_INT_CLR_APB_SARADC1_DONE_INT_CLR = 0x80000000

	// DMA_CONF: digital saradc configure register
	// Position of APB_ADC_EOF_NUM field.
	APB_SARADC_DMA_CONF_APB_ADC_EOF_NUM_Pos = 0x0
	// Bit mask of APB_ADC_EOF_NUM field.
	APB_SARADC_DMA_CONF_APB_ADC_EOF_NUM_Msk = 0xffff
	// Position of APB_ADC_RESET_FSM field.
	APB_SARADC_DMA_CONF_APB_ADC_RESET_FSM_Pos = 0x1e
	// Bit mask of APB_ADC_RESET_FSM field.
	APB_SARADC_DMA_CONF_APB_ADC_RESET_FSM_Msk = 0x40000000
	// Bit APB_ADC_RESET_FSM.
	APB_SARADC_DMA_CONF_APB_ADC_RESET_FSM = 0x40000000
	// Position of APB_ADC_TRANS field.
	APB_SARADC_DMA_CONF_APB_ADC_TRANS_Pos = 0x1f
	// Bit mask of APB_ADC_TRANS field.
	APB_SARADC_DMA_CONF_APB_ADC_TRANS_Msk = 0x80000000
	// Bit APB_ADC_TRANS.
	APB_SARADC_DMA_CONF_APB_ADC_TRANS = 0x80000000

	// CLKM_CONF: digital saradc configure register
	// Position of CLKM_DIV_NUM field.
	APB_SARADC_CLKM_CONF_CLKM_DIV_NUM_Pos = 0x0
	// Bit mask of CLKM_DIV_NUM field.
	APB_SARADC_CLKM_CONF_CLKM_DIV_NUM_Msk = 0xff
	// Position of CLKM_DIV_B field.
	APB_SARADC_CLKM_CONF_CLKM_DIV_B_Pos = 0x8
	// Bit mask of CLKM_DIV_B field.
	APB_SARADC_CLKM_CONF_CLKM_DIV_B_Msk = 0x3f00
	// Position of CLKM_DIV_A field.
	APB_SARADC_CLKM_CONF_CLKM_DIV_A_Pos = 0xe
	// Bit mask of CLKM_DIV_A field.
	APB_SARADC_CLKM_CONF_CLKM_DIV_A_Msk = 0xfc000
	// Position of CLK_EN field.
	APB_SARADC_CLKM_CONF_CLK_EN_Pos = 0x14
	// Bit mask of CLK_EN field.
	APB_SARADC_CLKM_CONF_CLK_EN_Msk = 0x100000
	// Bit CLK_EN.
	APB_SARADC_CLKM_CONF_CLK_EN = 0x100000
	// Position of CLK_SEL field.
	APB_SARADC_CLKM_CONF_CLK_SEL_Pos = 0x15
	// Bit mask of CLK_SEL field.
	APB_SARADC_CLKM_CONF_CLK_SEL_Msk = 0x600000

	// APB_TSENS_CTRL: digital tsens configure register
	// Position of TSENS_OUT field.
	APB_SARADC_APB_TSENS_CTRL_TSENS_OUT_Pos = 0x0
	// Bit mask of TSENS_OUT field.
	APB_SARADC_APB_TSENS_CTRL_TSENS_OUT_Msk = 0xff
	// Position of TSENS_IN_INV field.
	APB_SARADC_APB_TSENS_CTRL_TSENS_IN_INV_Pos = 0xd
	// Bit mask of TSENS_IN_INV field.
	APB_SARADC_APB_TSENS_CTRL_TSENS_IN_INV_Msk = 0x2000
	// Bit TSENS_IN_INV.
	APB_SARADC_APB_TSENS_CTRL_TSENS_IN_INV = 0x2000
	// Position of TSENS_CLK_DIV field.
	APB_SARADC_APB_TSENS_CTRL_TSENS_CLK_DIV_Pos = 0xe
	// Bit mask of TSENS_CLK_DIV field.
	APB_SARADC_APB_TSENS_CTRL_TSENS_CLK_DIV_Msk = 0x3fc000
	// Position of TSENS_PU field.
	APB_SARADC_APB_TSENS_CTRL_TSENS_PU_Pos = 0x16
	// Bit mask of TSENS_PU field.
	APB_SARADC_APB_TSENS_CTRL_TSENS_PU_Msk = 0x400000
	// Bit TSENS_PU.
	APB_SARADC_APB_TSENS_CTRL_TSENS_PU = 0x400000

	// TSENS_CTRL2: digital tsens configure register
	// Position of TSENS_XPD_WAIT field.
	APB_SARADC_TSENS_CTRL2_TSENS_XPD_WAIT_Pos = 0x0
	// Bit mask of TSENS_XPD_WAIT field.
	APB_SARADC_TSENS_CTRL2_TSENS_XPD_WAIT_Msk = 0xfff
	// Position of TSENS_XPD_FORCE field.
	APB_SARADC_TSENS_CTRL2_TSENS_XPD_FORCE_Pos = 0xc
	// Bit mask of TSENS_XPD_FORCE field.
	APB_SARADC_TSENS_CTRL2_TSENS_XPD_FORCE_Msk = 0x3000
	// Position of TSENS_CLK_INV field.
	APB_SARADC_TSENS_CTRL2_TSENS_CLK_INV_Pos = 0xe
	// Bit mask of TSENS_CLK_INV field.
	APB_SARADC_TSENS_CTRL2_TSENS_CLK_INV_Msk = 0x4000
	// Bit TSENS_CLK_INV.
	APB_SARADC_TSENS_CTRL2_TSENS_CLK_INV = 0x4000
	// Position of TSENS_CLK_SEL field.
	APB_SARADC_TSENS_CTRL2_TSENS_CLK_SEL_Pos = 0xf
	// Bit mask of TSENS_CLK_SEL field.
	APB_SARADC_TSENS_CTRL2_TSENS_CLK_SEL_Msk = 0x8000
	// Bit TSENS_CLK_SEL.
	APB_SARADC_TSENS_CTRL2_TSENS_CLK_SEL = 0x8000

	// CALI: digital saradc configure register
	// Position of APB_SARADC_CALI_CFG field.
	APB_SARADC_CALI_APB_SARADC_CALI_CFG_Pos = 0x0
	// Bit mask of APB_SARADC_CALI_CFG field.
	APB_SARADC_CALI_APB_SARADC_CALI_CFG_Msk = 0x1ffff

	// CTRL_DATE: version
	// Position of DATE field.
	APB_SARADC_CTRL_DATE_DATE_Pos = 0x0
	// Bit mask of DATE field.
	APB_SARADC_CTRL_DATE_DATE_Msk = 0xffffffff
)

// Constants for ASSIST_DEBUG: Peripheral ASSIST_DEBUG
const (
	// C0RE_0_MONTR_ENA: ASSIST_DEBUG_C0RE_0_MONTR_ENA_REG
	// Position of CORE_0_AREA_DRAM0_0_RD_ENA field.
	ASSIST_DEBUG_C0RE_0_MONTR_ENA_CORE_0_AREA_DRAM0_0_RD_ENA_Pos = 0x0
	// Bit mask of CORE_0_AREA_DRAM0_0_RD_ENA field.
	ASSIST_DEBUG_C0RE_0_MONTR_ENA_CORE_0_AREA_DRAM0_0_RD_ENA_Msk = 0x1
	// Bit CORE_0_AREA_DRAM0_0_RD_ENA.
	ASSIST_DEBUG_C0RE_0_MONTR_ENA_CORE_0_AREA_DRAM0_0_RD_ENA = 0x1
	// Position of CORE_0_AREA_DRAM0_0_WR_ENA field.
	ASSIST_DEBUG_C0RE_0_MONTR_ENA_CORE_0_AREA_DRAM0_0_WR_ENA_Pos = 0x1
	// Bit mask of CORE_0_AREA_DRAM0_0_WR_ENA field.
	ASSIST_DEBUG_C0RE_0_MONTR_ENA_CORE_0_AREA_DRAM0_0_WR_ENA_Msk = 0x2
	// Bit CORE_0_AREA_DRAM0_0_WR_ENA.
	ASSIST_DEBUG_C0RE_0_MONTR_ENA_CORE_0_AREA_DRAM0_0_WR_ENA = 0x2
	// Position of CORE_0_AREA_DRAM0_1_RD_ENA field.
	ASSIST_DEBUG_C0RE_0_MONTR_ENA_CORE_0_AREA_DRAM0_1_RD_ENA_Pos = 0x2
	// Bit mask of CORE_0_AREA_DRAM0_1_RD_ENA field.
	ASSIST_DEBUG_C0RE_0_MONTR_ENA_CORE_0_AREA_DRAM0_1_RD_ENA_Msk = 0x4
	// Bit CORE_0_AREA_DRAM0_1_RD_ENA.
	ASSIST_DEBUG_C0RE_0_MONTR_ENA_CORE_0_AREA_DRAM0_1_RD_ENA = 0x4
	// Position of CORE_0_AREA_DRAM0_1_WR_ENA field.
	ASSIST_DEBUG_C0RE_0_MONTR_ENA_CORE_0_AREA_DRAM0_1_WR_ENA_Pos = 0x3
	// Bit mask of CORE_0_AREA_DRAM0_1_WR_ENA field.
	ASSIST_DEBUG_C0RE_0_MONTR_ENA_CORE_0_AREA_DRAM0_1_WR_ENA_Msk = 0x8
	// Bit CORE_0_AREA_DRAM0_1_WR_ENA.
	ASSIST_DEBUG_C0RE_0_MONTR_ENA_CORE_0_AREA_DRAM0_1_WR_ENA = 0x8
	// Position of CORE_0_AREA_PIF_0_RD_ENA field.
	ASSIST_DEBUG_C0RE_0_MONTR_ENA_CORE_0_AREA_PIF_0_RD_ENA_Pos = 0x4
	// Bit mask of CORE_0_AREA_PIF_0_RD_ENA field.
	ASSIST_DEBUG_C0RE_0_MONTR_ENA_CORE_0_AREA_PIF_0_RD_ENA_Msk = 0x10
	// Bit CORE_0_AREA_PIF_0_RD_ENA.
	ASSIST_DEBUG_C0RE_0_MONTR_ENA_CORE_0_AREA_PIF_0_RD_ENA = 0x10
	// Position of CORE_0_AREA_PIF_0_WR_ENA field.
	ASSIST_DEBUG_C0RE_0_MONTR_ENA_CORE_0_AREA_PIF_0_WR_ENA_Pos = 0x5
	// Bit mask of CORE_0_AREA_PIF_0_WR_ENA field.
	ASSIST_DEBUG_C0RE_0_MONTR_ENA_CORE_0_AREA_PIF_0_WR_ENA_Msk = 0x20
	// Bit CORE_0_AREA_PIF_0_WR_ENA.
	ASSIST_DEBUG_C0RE_0_MONTR_ENA_CORE_0_AREA_PIF_0_WR_ENA = 0x20
	// Position of CORE_0_AREA_PIF_1_RD_ENA field.
	ASSIST_DEBUG_C0RE_0_MONTR_ENA_CORE_0_AREA_PIF_1_RD_ENA_Pos = 0x6
	// Bit mask of CORE_0_AREA_PIF_1_RD_ENA field.
	ASSIST_DEBUG_C0RE_0_MONTR_ENA_CORE_0_AREA_PIF_1_RD_ENA_Msk = 0x40
	// Bit CORE_0_AREA_PIF_1_RD_ENA.
	ASSIST_DEBUG_C0RE_0_MONTR_ENA_CORE_0_AREA_PIF_1_RD_ENA = 0x40
	// Position of CORE_0_AREA_PIF_1_WR_ENA field.
	ASSIST_DEBUG_C0RE_0_MONTR_ENA_CORE_0_AREA_PIF_1_WR_ENA_Pos = 0x7
	// Bit mask of CORE_0_AREA_PIF_1_WR_ENA field.
	ASSIST_DEBUG_C0RE_0_MONTR_ENA_CORE_0_AREA_PIF_1_WR_ENA_Msk = 0x80
	// Bit CORE_0_AREA_PIF_1_WR_ENA.
	ASSIST_DEBUG_C0RE_0_MONTR_ENA_CORE_0_AREA_PIF_1_WR_ENA = 0x80
	// Position of CORE_0_SP_SPILL_MIN_ENA field.
	ASSIST_DEBUG_C0RE_0_MONTR_ENA_CORE_0_SP_SPILL_MIN_ENA_Pos = 0x8
	// Bit mask of CORE_0_SP_SPILL_MIN_ENA field.
	ASSIST_DEBUG_C0RE_0_MONTR_ENA_CORE_0_SP_SPILL_MIN_ENA_Msk = 0x100
	// Bit CORE_0_SP_SPILL_MIN_ENA.
	ASSIST_DEBUG_C0RE_0_MONTR_ENA_CORE_0_SP_SPILL_MIN_ENA = 0x100
	// Position of CORE_0_SP_SPILL_MAX_ENA field.
	ASSIST_DEBUG_C0RE_0_MONTR_ENA_CORE_0_SP_SPILL_MAX_ENA_Pos = 0x9
	// Bit mask of CORE_0_SP_SPILL_MAX_ENA field.
	ASSIST_DEBUG_C0RE_0_MONTR_ENA_CORE_0_SP_SPILL_MAX_ENA_Msk = 0x200
	// Bit CORE_0_SP_SPILL_MAX_ENA.
	ASSIST_DEBUG_C0RE_0_MONTR_ENA_CORE_0_SP_SPILL_MAX_ENA = 0x200
	// Position of CORE_0_IRAM0_EXCEPTION_MONITOR_ENA field.
	ASSIST_DEBUG_C0RE_0_MONTR_ENA_CORE_0_IRAM0_EXCEPTION_MONITOR_ENA_Pos = 0xa
	// Bit mask of CORE_0_IRAM0_EXCEPTION_MONITOR_ENA field.
	ASSIST_DEBUG_C0RE_0_MONTR_ENA_CORE_0_IRAM0_EXCEPTION_MONITOR_ENA_Msk = 0x400
	// Bit CORE_0_IRAM0_EXCEPTION_MONITOR_ENA.
	ASSIST_DEBUG_C0RE_0_MONTR_ENA_CORE_0_IRAM0_EXCEPTION_MONITOR_ENA = 0x400
	// Position of CORE_0_DRAM0_EXCEPTION_MONITOR_ENA field.
	ASSIST_DEBUG_C0RE_0_MONTR_ENA_CORE_0_DRAM0_EXCEPTION_MONITOR_ENA_Pos = 0xb
	// Bit mask of CORE_0_DRAM0_EXCEPTION_MONITOR_ENA field.
	ASSIST_DEBUG_C0RE_0_MONTR_ENA_CORE_0_DRAM0_EXCEPTION_MONITOR_ENA_Msk = 0x800
	// Bit CORE_0_DRAM0_EXCEPTION_MONITOR_ENA.
	ASSIST_DEBUG_C0RE_0_MONTR_ENA_CORE_0_DRAM0_EXCEPTION_MONITOR_ENA = 0x800

	// CORE_0_INTR_RAW: ASSIST_DEBUG_CORE_0_INTR_RAW_REG
	// Position of CORE_0_AREA_DRAM0_0_RD_RAW field.
	ASSIST_DEBUG_CORE_0_INTR_RAW_CORE_0_AREA_DRAM0_0_RD_RAW_Pos = 0x0
	// Bit mask of CORE_0_AREA_DRAM0_0_RD_RAW field.
	ASSIST_DEBUG_CORE_0_INTR_RAW_CORE_0_AREA_DRAM0_0_RD_RAW_Msk = 0x1
	// Bit CORE_0_AREA_DRAM0_0_RD_RAW.
	ASSIST_DEBUG_CORE_0_INTR_RAW_CORE_0_AREA_DRAM0_0_RD_RAW = 0x1
	// Position of CORE_0_AREA_DRAM0_0_WR_RAW field.
	ASSIST_DEBUG_CORE_0_INTR_RAW_CORE_0_AREA_DRAM0_0_WR_RAW_Pos = 0x1
	// Bit mask of CORE_0_AREA_DRAM0_0_WR_RAW field.
	ASSIST_DEBUG_CORE_0_INTR_RAW_CORE_0_AREA_DRAM0_0_WR_RAW_Msk = 0x2
	// Bit CORE_0_AREA_DRAM0_0_WR_RAW.
	ASSIST_DEBUG_CORE_0_INTR_RAW_CORE_0_AREA_DRAM0_0_WR_RAW = 0x2
	// Position of CORE_0_AREA_DRAM0_1_RD_RAW field.
	ASSIST_DEBUG_CORE_0_INTR_RAW_CORE_0_AREA_DRAM0_1_RD_RAW_Pos = 0x2
	// Bit mask of CORE_0_AREA_DRAM0_1_RD_RAW field.
	ASSIST_DEBUG_CORE_0_INTR_RAW_CORE_0_AREA_DRAM0_1_RD_RAW_Msk = 0x4
	// Bit CORE_0_AREA_DRAM0_1_RD_RAW.
	ASSIST_DEBUG_CORE_0_INTR_RAW_CORE_0_AREA_DRAM0_1_RD_RAW = 0x4
	// Position of CORE_0_AREA_DRAM0_1_WR_RAW field.
	ASSIST_DEBUG_CORE_0_INTR_RAW_CORE_0_AREA_DRAM0_1_WR_RAW_Pos = 0x3
	// Bit mask of CORE_0_AREA_DRAM0_1_WR_RAW field.
	ASSIST_DEBUG_CORE_0_INTR_RAW_CORE_0_AREA_DRAM0_1_WR_RAW_Msk = 0x8
	// Bit CORE_0_AREA_DRAM0_1_WR_RAW.
	ASSIST_DEBUG_CORE_0_INTR_RAW_CORE_0_AREA_DRAM0_1_WR_RAW = 0x8
	// Position of CORE_0_AREA_PIF_0_RD_RAW field.
	ASSIST_DEBUG_CORE_0_INTR_RAW_CORE_0_AREA_PIF_0_RD_RAW_Pos = 0x4
	// Bit mask of CORE_0_AREA_PIF_0_RD_RAW field.
	ASSIST_DEBUG_CORE_0_INTR_RAW_CORE_0_AREA_PIF_0_RD_RAW_Msk = 0x10
	// Bit CORE_0_AREA_PIF_0_RD_RAW.
	ASSIST_DEBUG_CORE_0_INTR_RAW_CORE_0_AREA_PIF_0_RD_RAW = 0x10
	// Position of CORE_0_AREA_PIF_0_WR_RAW field.
	ASSIST_DEBUG_CORE_0_INTR_RAW_CORE_0_AREA_PIF_0_WR_RAW_Pos = 0x5
	// Bit mask of CORE_0_AREA_PIF_0_WR_RAW field.
	ASSIST_DEBUG_CORE_0_INTR_RAW_CORE_0_AREA_PIF_0_WR_RAW_Msk = 0x20
	// Bit CORE_0_AREA_PIF_0_WR_RAW.
	ASSIST_DEBUG_CORE_0_INTR_RAW_CORE_0_AREA_PIF_0_WR_RAW = 0x20
	// Position of CORE_0_AREA_PIF_1_RD_RAW field.
	ASSIST_DEBUG_CORE_0_INTR_RAW_CORE_0_AREA_PIF_1_RD_RAW_Pos = 0x6
	// Bit mask of CORE_0_AREA_PIF_1_RD_RAW field.
	ASSIST_DEBUG_CORE_0_INTR_RAW_CORE_0_AREA_PIF_1_RD_RAW_Msk = 0x40
	// Bit CORE_0_AREA_PIF_1_RD_RAW.
	ASSIST_DEBUG_CORE_0_INTR_RAW_CORE_0_AREA_PIF_1_RD_RAW = 0x40
	// Position of CORE_0_AREA_PIF_1_WR_RAW field.
	ASSIST_DEBUG_CORE_0_INTR_RAW_CORE_0_AREA_PIF_1_WR_RAW_Pos = 0x7
	// Bit mask of CORE_0_AREA_PIF_1_WR_RAW field.
	ASSIST_DEBUG_CORE_0_INTR_RAW_CORE_0_AREA_PIF_1_WR_RAW_Msk = 0x80
	// Bit CORE_0_AREA_PIF_1_WR_RAW.
	ASSIST_DEBUG_CORE_0_INTR_RAW_CORE_0_AREA_PIF_1_WR_RAW = 0x80
	// Position of CORE_0_SP_SPILL_MIN_RAW field.
	ASSIST_DEBUG_CORE_0_INTR_RAW_CORE_0_SP_SPILL_MIN_RAW_Pos = 0x8
	// Bit mask of CORE_0_SP_SPILL_MIN_RAW field.
	ASSIST_DEBUG_CORE_0_INTR_RAW_CORE_0_SP_SPILL_MIN_RAW_Msk = 0x100
	// Bit CORE_0_SP_SPILL_MIN_RAW.
	ASSIST_DEBUG_CORE_0_INTR_RAW_CORE_0_SP_SPILL_MIN_RAW = 0x100
	// Position of CORE_0_SP_SPILL_MAX_RAW field.
	ASSIST_DEBUG_CORE_0_INTR_RAW_CORE_0_SP_SPILL_MAX_RAW_Pos = 0x9
	// Bit mask of CORE_0_SP_SPILL_MAX_RAW field.
	ASSIST_DEBUG_CORE_0_INTR_RAW_CORE_0_SP_SPILL_MAX_RAW_Msk = 0x200
	// Bit CORE_0_SP_SPILL_MAX_RAW.
	ASSIST_DEBUG_CORE_0_INTR_RAW_CORE_0_SP_SPILL_MAX_RAW = 0x200
	// Position of CORE_0_IRAM0_EXCEPTION_MONITOR_RAW field.
	ASSIST_DEBUG_CORE_0_INTR_RAW_CORE_0_IRAM0_EXCEPTION_MONITOR_RAW_Pos = 0xa
	// Bit mask of CORE_0_IRAM0_EXCEPTION_MONITOR_RAW field.
	ASSIST_DEBUG_CORE_0_INTR_RAW_CORE_0_IRAM0_EXCEPTION_MONITOR_RAW_Msk = 0x400
	// Bit CORE_0_IRAM0_EXCEPTION_MONITOR_RAW.
	ASSIST_DEBUG_CORE_0_INTR_RAW_CORE_0_IRAM0_EXCEPTION_MONITOR_RAW = 0x400
	// Position of CORE_0_DRAM0_EXCEPTION_MONITOR_RAW field.
	ASSIST_DEBUG_CORE_0_INTR_RAW_CORE_0_DRAM0_EXCEPTION_MONITOR_RAW_Pos = 0xb
	// Bit mask of CORE_0_DRAM0_EXCEPTION_MONITOR_RAW field.
	ASSIST_DEBUG_CORE_0_INTR_RAW_CORE_0_DRAM0_EXCEPTION_MONITOR_RAW_Msk = 0x800
	// Bit CORE_0_DRAM0_EXCEPTION_MONITOR_RAW.
	ASSIST_DEBUG_CORE_0_INTR_RAW_CORE_0_DRAM0_EXCEPTION_MONITOR_RAW = 0x800

	// CORE_0_INTR_ENA: ASSIST_DEBUG_CORE_0_INTR_ENA_REG
	// Position of CORE_0_AREA_DRAM0_0_RD_INTR_ENA field.
	ASSIST_DEBUG_CORE_0_INTR_ENA_CORE_0_AREA_DRAM0_0_RD_INTR_ENA_Pos = 0x0
	// Bit mask of CORE_0_AREA_DRAM0_0_RD_INTR_ENA field.
	ASSIST_DEBUG_CORE_0_INTR_ENA_CORE_0_AREA_DRAM0_0_RD_INTR_ENA_Msk = 0x1
	// Bit CORE_0_AREA_DRAM0_0_RD_INTR_ENA.
	ASSIST_DEBUG_CORE_0_INTR_ENA_CORE_0_AREA_DRAM0_0_RD_INTR_ENA = 0x1
	// Position of CORE_0_AREA_DRAM0_0_WR_INTR_ENA field.
	ASSIST_DEBUG_CORE_0_INTR_ENA_CORE_0_AREA_DRAM0_0_WR_INTR_ENA_Pos = 0x1
	// Bit mask of CORE_0_AREA_DRAM0_0_WR_INTR_ENA field.
	ASSIST_DEBUG_CORE_0_INTR_ENA_CORE_0_AREA_DRAM0_0_WR_INTR_ENA_Msk = 0x2
	// Bit CORE_0_AREA_DRAM0_0_WR_INTR_ENA.
	ASSIST_DEBUG_CORE_0_INTR_ENA_CORE_0_AREA_DRAM0_0_WR_INTR_ENA = 0x2
	// Position of CORE_0_AREA_DRAM0_1_RD_INTR_ENA field.
	ASSIST_DEBUG_CORE_0_INTR_ENA_CORE_0_AREA_DRAM0_1_RD_INTR_ENA_Pos = 0x2
	// Bit mask of CORE_0_AREA_DRAM0_1_RD_INTR_ENA field.
	ASSIST_DEBUG_CORE_0_INTR_ENA_CORE_0_AREA_DRAM0_1_RD_INTR_ENA_Msk = 0x4
	// Bit CORE_0_AREA_DRAM0_1_RD_INTR_ENA.
	ASSIST_DEBUG_CORE_0_INTR_ENA_CORE_0_AREA_DRAM0_1_RD_INTR_ENA = 0x4
	// Position of CORE_0_AREA_DRAM0_1_WR_INTR_ENA field.
	ASSIST_DEBUG_CORE_0_INTR_ENA_CORE_0_AREA_DRAM0_1_WR_INTR_ENA_Pos = 0x3
	// Bit mask of CORE_0_AREA_DRAM0_1_WR_INTR_ENA field.
	ASSIST_DEBUG_CORE_0_INTR_ENA_CORE_0_AREA_DRAM0_1_WR_INTR_ENA_Msk = 0x8
	// Bit CORE_0_AREA_DRAM0_1_WR_INTR_ENA.
	ASSIST_DEBUG_CORE_0_INTR_ENA_CORE_0_AREA_DRAM0_1_WR_INTR_ENA = 0x8
	// Position of CORE_0_AREA_PIF_0_RD_INTR_ENA field.
	ASSIST_DEBUG_CORE_0_INTR_ENA_CORE_0_AREA_PIF_0_RD_INTR_ENA_Pos = 0x4
	// Bit mask of CORE_0_AREA_PIF_0_RD_INTR_ENA field.
	ASSIST_DEBUG_CORE_0_INTR_ENA_CORE_0_AREA_PIF_0_RD_INTR_ENA_Msk = 0x10
	// Bit CORE_0_AREA_PIF_0_RD_INTR_ENA.
	ASSIST_DEBUG_CORE_0_INTR_ENA_CORE_0_AREA_PIF_0_RD_INTR_ENA = 0x10
	// Position of CORE_0_AREA_PIF_0_WR_INTR_ENA field.
	ASSIST_DEBUG_CORE_0_INTR_ENA_CORE_0_AREA_PIF_0_WR_INTR_ENA_Pos = 0x5
	// Bit mask of CORE_0_AREA_PIF_0_WR_INTR_ENA field.
	ASSIST_DEBUG_CORE_0_INTR_ENA_CORE_0_AREA_PIF_0_WR_INTR_ENA_Msk = 0x20
	// Bit CORE_0_AREA_PIF_0_WR_INTR_ENA.
	ASSIST_DEBUG_CORE_0_INTR_ENA_CORE_0_AREA_PIF_0_WR_INTR_ENA = 0x20
	// Position of CORE_0_AREA_PIF_1_RD_INTR_ENA field.
	ASSIST_DEBUG_CORE_0_INTR_ENA_CORE_0_AREA_PIF_1_RD_INTR_ENA_Pos = 0x6
	// Bit mask of CORE_0_AREA_PIF_1_RD_INTR_ENA field.
	ASSIST_DEBUG_CORE_0_INTR_ENA_CORE_0_AREA_PIF_1_RD_INTR_ENA_Msk = 0x40
	// Bit CORE_0_AREA_PIF_1_RD_INTR_ENA.
	ASSIST_DEBUG_CORE_0_INTR_ENA_CORE_0_AREA_PIF_1_RD_INTR_ENA = 0x40
	// Position of CORE_0_AREA_PIF_1_WR_INTR_ENA field.
	ASSIST_DEBUG_CORE_0_INTR_ENA_CORE_0_AREA_PIF_1_WR_INTR_ENA_Pos = 0x7
	// Bit mask of CORE_0_AREA_PIF_1_WR_INTR_ENA field.
	ASSIST_DEBUG_CORE_0_INTR_ENA_CORE_0_AREA_PIF_1_WR_INTR_ENA_Msk = 0x80
	// Bit CORE_0_AREA_PIF_1_WR_INTR_ENA.
	ASSIST_DEBUG_CORE_0_INTR_ENA_CORE_0_AREA_PIF_1_WR_INTR_ENA = 0x80
	// Position of CORE_0_SP_SPILL_MIN_INTR_ENA field.
	ASSIST_DEBUG_CORE_0_INTR_ENA_CORE_0_SP_SPILL_MIN_INTR_ENA_Pos = 0x8
	// Bit mask of CORE_0_SP_SPILL_MIN_INTR_ENA field.
	ASSIST_DEBUG_CORE_0_INTR_ENA_CORE_0_SP_SPILL_MIN_INTR_ENA_Msk = 0x100
	// Bit CORE_0_SP_SPILL_MIN_INTR_ENA.
	ASSIST_DEBUG_CORE_0_INTR_ENA_CORE_0_SP_SPILL_MIN_INTR_ENA = 0x100
	// Position of CORE_0_SP_SPILL_MAX_INTR_ENA field.
	ASSIST_DEBUG_CORE_0_INTR_ENA_CORE_0_SP_SPILL_MAX_INTR_ENA_Pos = 0x9
	// Bit mask of CORE_0_SP_SPILL_MAX_INTR_ENA field.
	ASSIST_DEBUG_CORE_0_INTR_ENA_CORE_0_SP_SPILL_MAX_INTR_ENA_Msk = 0x200
	// Bit CORE_0_SP_SPILL_MAX_INTR_ENA.
	ASSIST_DEBUG_CORE_0_INTR_ENA_CORE_0_SP_SPILL_MAX_INTR_ENA = 0x200
	// Position of CORE_0_IRAM0_EXCEPTION_MONITOR_RLS field.
	ASSIST_DEBUG_CORE_0_INTR_ENA_CORE_0_IRAM0_EXCEPTION_MONITOR_RLS_Pos = 0xa
	// Bit mask of CORE_0_IRAM0_EXCEPTION_MONITOR_RLS field.
	ASSIST_DEBUG_CORE_0_INTR_ENA_CORE_0_IRAM0_EXCEPTION_MONITOR_RLS_Msk = 0x400
	// Bit CORE_0_IRAM0_EXCEPTION_MONITOR_RLS.
	ASSIST_DEBUG_CORE_0_INTR_ENA_CORE_0_IRAM0_EXCEPTION_MONITOR_RLS = 0x400
	// Position of CORE_0_DRAM0_EXCEPTION_MONITOR_RLS field.
	ASSIST_DEBUG_CORE_0_INTR_ENA_CORE_0_DRAM0_EXCEPTION_MONITOR_RLS_Pos = 0xb
	// Bit mask of CORE_0_DRAM0_EXCEPTION_MONITOR_RLS field.
	ASSIST_DEBUG_CORE_0_INTR_ENA_CORE_0_DRAM0_EXCEPTION_MONITOR_RLS_Msk = 0x800
	// Bit CORE_0_DRAM0_EXCEPTION_MONITOR_RLS.
	ASSIST_DEBUG_CORE_0_INTR_ENA_CORE_0_DRAM0_EXCEPTION_MONITOR_RLS = 0x800

	// CORE_0_INTR_CLR: ASSIST_DEBUG_CORE_0_INTR_CLR_REG
	// Position of CORE_0_AREA_DRAM0_0_RD_CLR field.
	ASSIST_DEBUG_CORE_0_INTR_CLR_CORE_0_AREA_DRAM0_0_RD_CLR_Pos = 0x0
	// Bit mask of CORE_0_AREA_DRAM0_0_RD_CLR field.
	ASSIST_DEBUG_CORE_0_INTR_CLR_CORE_0_AREA_DRAM0_0_RD_CLR_Msk = 0x1
	// Bit CORE_0_AREA_DRAM0_0_RD_CLR.
	ASSIST_DEBUG_CORE_0_INTR_CLR_CORE_0_AREA_DRAM0_0_RD_CLR = 0x1
	// Position of CORE_0_AREA_DRAM0_0_WR_CLR field.
	ASSIST_DEBUG_CORE_0_INTR_CLR_CORE_0_AREA_DRAM0_0_WR_CLR_Pos = 0x1
	// Bit mask of CORE_0_AREA_DRAM0_0_WR_CLR field.
	ASSIST_DEBUG_CORE_0_INTR_CLR_CORE_0_AREA_DRAM0_0_WR_CLR_Msk = 0x2
	// Bit CORE_0_AREA_DRAM0_0_WR_CLR.
	ASSIST_DEBUG_CORE_0_INTR_CLR_CORE_0_AREA_DRAM0_0_WR_CLR = 0x2
	// Position of CORE_0_AREA_DRAM0_1_RD_CLR field.
	ASSIST_DEBUG_CORE_0_INTR_CLR_CORE_0_AREA_DRAM0_1_RD_CLR_Pos = 0x2
	// Bit mask of CORE_0_AREA_DRAM0_1_RD_CLR field.
	ASSIST_DEBUG_CORE_0_INTR_CLR_CORE_0_AREA_DRAM0_1_RD_CLR_Msk = 0x4
	// Bit CORE_0_AREA_DRAM0_1_RD_CLR.
	ASSIST_DEBUG_CORE_0_INTR_CLR_CORE_0_AREA_DRAM0_1_RD_CLR = 0x4
	// Position of CORE_0_AREA_DRAM0_1_WR_CLR field.
	ASSIST_DEBUG_CORE_0_INTR_CLR_CORE_0_AREA_DRAM0_1_WR_CLR_Pos = 0x3
	// Bit mask of CORE_0_AREA_DRAM0_1_WR_CLR field.
	ASSIST_DEBUG_CORE_0_INTR_CLR_CORE_0_AREA_DRAM0_1_WR_CLR_Msk = 0x8
	// Bit CORE_0_AREA_DRAM0_1_WR_CLR.
	ASSIST_DEBUG_CORE_0_INTR_CLR_CORE_0_AREA_DRAM0_1_WR_CLR = 0x8
	// Position of CORE_0_AREA_PIF_0_RD_CLR field.
	ASSIST_DEBUG_CORE_0_INTR_CLR_CORE_0_AREA_PIF_0_RD_CLR_Pos = 0x4
	// Bit mask of CORE_0_AREA_PIF_0_RD_CLR field.
	ASSIST_DEBUG_CORE_0_INTR_CLR_CORE_0_AREA_PIF_0_RD_CLR_Msk = 0x10
	// Bit CORE_0_AREA_PIF_0_RD_CLR.
	ASSIST_DEBUG_CORE_0_INTR_CLR_CORE_0_AREA_PIF_0_RD_CLR = 0x10
	// Position of CORE_0_AREA_PIF_0_WR_CLR field.
	ASSIST_DEBUG_CORE_0_INTR_CLR_CORE_0_AREA_PIF_0_WR_CLR_Pos = 0x5
	// Bit mask of CORE_0_AREA_PIF_0_WR_CLR field.
	ASSIST_DEBUG_CORE_0_INTR_CLR_CORE_0_AREA_PIF_0_WR_CLR_Msk = 0x20
	// Bit CORE_0_AREA_PIF_0_WR_CLR.
	ASSIST_DEBUG_CORE_0_INTR_CLR_CORE_0_AREA_PIF_0_WR_CLR = 0x20
	// Position of CORE_0_AREA_PIF_1_RD_CLR field.
	ASSIST_DEBUG_CORE_0_INTR_CLR_CORE_0_AREA_PIF_1_RD_CLR_Pos = 0x6
	// Bit mask of CORE_0_AREA_PIF_1_RD_CLR field.
	ASSIST_DEBUG_CORE_0_INTR_CLR_CORE_0_AREA_PIF_1_RD_CLR_Msk = 0x40
	// Bit CORE_0_AREA_PIF_1_RD_CLR.
	ASSIST_DEBUG_CORE_0_INTR_CLR_CORE_0_AREA_PIF_1_RD_CLR = 0x40
	// Position of CORE_0_AREA_PIF_1_WR_CLR field.
	ASSIST_DEBUG_CORE_0_INTR_CLR_CORE_0_AREA_PIF_1_WR_CLR_Pos = 0x7
	// Bit mask of CORE_0_AREA_PIF_1_WR_CLR field.
	ASSIST_DEBUG_CORE_0_INTR_CLR_CORE_0_AREA_PIF_1_WR_CLR_Msk = 0x80
	// Bit CORE_0_AREA_PIF_1_WR_CLR.
	ASSIST_DEBUG_CORE_0_INTR_CLR_CORE_0_AREA_PIF_1_WR_CLR = 0x80
	// Position of CORE_0_SP_SPILL_MIN_CLR field.
	ASSIST_DEBUG_CORE_0_INTR_CLR_CORE_0_SP_SPILL_MIN_CLR_Pos = 0x8
	// Bit mask of CORE_0_SP_SPILL_MIN_CLR field.
	ASSIST_DEBUG_CORE_0_INTR_CLR_CORE_0_SP_SPILL_MIN_CLR_Msk = 0x100
	// Bit CORE_0_SP_SPILL_MIN_CLR.
	ASSIST_DEBUG_CORE_0_INTR_CLR_CORE_0_SP_SPILL_MIN_CLR = 0x100
	// Position of CORE_0_SP_SPILL_MAX_CLR field.
	ASSIST_DEBUG_CORE_0_INTR_CLR_CORE_0_SP_SPILL_MAX_CLR_Pos = 0x9
	// Bit mask of CORE_0_SP_SPILL_MAX_CLR field.
	ASSIST_DEBUG_CORE_0_INTR_CLR_CORE_0_SP_SPILL_MAX_CLR_Msk = 0x200
	// Bit CORE_0_SP_SPILL_MAX_CLR.
	ASSIST_DEBUG_CORE_0_INTR_CLR_CORE_0_SP_SPILL_MAX_CLR = 0x200
	// Position of CORE_0_IRAM0_EXCEPTION_MONITOR_CLR field.
	ASSIST_DEBUG_CORE_0_INTR_CLR_CORE_0_IRAM0_EXCEPTION_MONITOR_CLR_Pos = 0xa
	// Bit mask of CORE_0_IRAM0_EXCEPTION_MONITOR_CLR field.
	ASSIST_DEBUG_CORE_0_INTR_CLR_CORE_0_IRAM0_EXCEPTION_MONITOR_CLR_Msk = 0x400
	// Bit CORE_0_IRAM0_EXCEPTION_MONITOR_CLR.
	ASSIST_DEBUG_CORE_0_INTR_CLR_CORE_0_IRAM0_EXCEPTION_MONITOR_CLR = 0x400
	// Position of CORE_0_DRAM0_EXCEPTION_MONITOR_CLR field.
	ASSIST_DEBUG_CORE_0_INTR_CLR_CORE_0_DRAM0_EXCEPTION_MONITOR_CLR_Pos = 0xb
	// Bit mask of CORE_0_DRAM0_EXCEPTION_MONITOR_CLR field.
	ASSIST_DEBUG_CORE_0_INTR_CLR_CORE_0_DRAM0_EXCEPTION_MONITOR_CLR_Msk = 0x800
	// Bit CORE_0_DRAM0_EXCEPTION_MONITOR_CLR.
	ASSIST_DEBUG_CORE_0_INTR_CLR_CORE_0_DRAM0_EXCEPTION_MONITOR_CLR = 0x800

	// CORE_0_AREA_DRAM0_0_MIN: ASSIST_DEBUG_CORE_0_AREA_DRAM0_0_MIN_REG
	// Position of CORE_0_AREA_DRAM0_0_MIN field.
	ASSIST_DEBUG_CORE_0_AREA_DRAM0_0_MIN_CORE_0_AREA_DRAM0_0_MIN_Pos = 0x0
	// Bit mask of CORE_0_AREA_DRAM0_0_MIN field.
	ASSIST_DEBUG_CORE_0_AREA_DRAM0_0_MIN_CORE_0_AREA_DRAM0_0_MIN_Msk = 0xffffffff

	// CORE_0_AREA_DRAM0_0_MAX: ASSIST_DEBUG_CORE_0_AREA_DRAM0_0_MAX_REG
	// Position of CORE_0_AREA_DRAM0_0_MAX field.
	ASSIST_DEBUG_CORE_0_AREA_DRAM0_0_MAX_CORE_0_AREA_DRAM0_0_MAX_Pos = 0x0
	// Bit mask of CORE_0_AREA_DRAM0_0_MAX field.
	ASSIST_DEBUG_CORE_0_AREA_DRAM0_0_MAX_CORE_0_AREA_DRAM0_0_MAX_Msk = 0xffffffff

	// CORE_0_AREA_DRAM0_1_MIN: ASSIST_DEBUG_CORE_0_AREA_DRAM0_1_MIN_REG
	// Position of CORE_0_AREA_DRAM0_1_MIN field.
	ASSIST_DEBUG_CORE_0_AREA_DRAM0_1_MIN_CORE_0_AREA_DRAM0_1_MIN_Pos = 0x0
	// Bit mask of CORE_0_AREA_DRAM0_1_MIN field.
	ASSIST_DEBUG_CORE_0_AREA_DRAM0_1_MIN_CORE_0_AREA_DRAM0_1_MIN_Msk = 0xffffffff

	// CORE_0_AREA_DRAM0_1_MAX: ASSIST_DEBUG_CORE_0_AREA_DRAM0_1_MAX_REG
	// Position of CORE_0_AREA_DRAM0_1_MAX field.
	ASSIST_DEBUG_CORE_0_AREA_DRAM0_1_MAX_CORE_0_AREA_DRAM0_1_MAX_Pos = 0x0
	// Bit mask of CORE_0_AREA_DRAM0_1_MAX field.
	ASSIST_DEBUG_CORE_0_AREA_DRAM0_1_MAX_CORE_0_AREA_DRAM0_1_MAX_Msk = 0xffffffff

	// CORE_0_AREA_PIF_0_MIN: ASSIST_DEBUG_CORE_0_AREA_PIF_0_MIN_REG
	// Position of CORE_0_AREA_PIF_0_MIN field.
	ASSIST_DEBUG_CORE_0_AREA_PIF_0_MIN_CORE_0_AREA_PIF_0_MIN_Pos = 0x0
	// Bit mask of CORE_0_AREA_PIF_0_MIN field.
	ASSIST_DEBUG_CORE_0_AREA_PIF_0_MIN_CORE_0_AREA_PIF_0_MIN_Msk = 0xffffffff

	// CORE_0_AREA_PIF_0_MAX: ASSIST_DEBUG_CORE_0_AREA_PIF_0_MAX_REG
	// Position of CORE_0_AREA_PIF_0_MAX field.
	ASSIST_DEBUG_CORE_0_AREA_PIF_0_MAX_CORE_0_AREA_PIF_0_MAX_Pos = 0x0
	// Bit mask of CORE_0_AREA_PIF_0_MAX field.
	ASSIST_DEBUG_CORE_0_AREA_PIF_0_MAX_CORE_0_AREA_PIF_0_MAX_Msk = 0xffffffff

	// CORE_0_AREA_PIF_1_MIN: ASSIST_DEBUG_CORE_0_AREA_PIF_1_MIN_REG
	// Position of CORE_0_AREA_PIF_1_MIN field.
	ASSIST_DEBUG_CORE_0_AREA_PIF_1_MIN_CORE_0_AREA_PIF_1_MIN_Pos = 0x0
	// Bit mask of CORE_0_AREA_PIF_1_MIN field.
	ASSIST_DEBUG_CORE_0_AREA_PIF_1_MIN_CORE_0_AREA_PIF_1_MIN_Msk = 0xffffffff

	// CORE_0_AREA_PIF_1_MAX: ASSIST_DEBUG_CORE_0_AREA_PIF_1_MAX_REG
	// Position of CORE_0_AREA_PIF_1_MAX field.
	ASSIST_DEBUG_CORE_0_AREA_PIF_1_MAX_CORE_0_AREA_PIF_1_MAX_Pos = 0x0
	// Bit mask of CORE_0_AREA_PIF_1_MAX field.
	ASSIST_DEBUG_CORE_0_AREA_PIF_1_MAX_CORE_0_AREA_PIF_1_MAX_Msk = 0xffffffff

	// CORE_0_AREA_PC: ASSIST_DEBUG_CORE_0_AREA_PC_REG
	// Position of CORE_0_AREA_PC field.
	ASSIST_DEBUG_CORE_0_AREA_PC_CORE_0_AREA_PC_Pos = 0x0
	// Bit mask of CORE_0_AREA_PC field.
	ASSIST_DEBUG_CORE_0_AREA_PC_CORE_0_AREA_PC_Msk = 0xffffffff

	// CORE_0_AREA_SP: ASSIST_DEBUG_CORE_0_AREA_SP_REG
	// Position of CORE_0_AREA_SP field.
	ASSIST_DEBUG_CORE_0_AREA_SP_CORE_0_AREA_SP_Pos = 0x0
	// Bit mask of CORE_0_AREA_SP field.
	ASSIST_DEBUG_CORE_0_AREA_SP_CORE_0_AREA_SP_Msk = 0xffffffff

	// CORE_0_SP_MIN: ASSIST_DEBUG_CORE_0_SP_MIN_REG
	// Position of CORE_0_SP_MIN field.
	ASSIST_DEBUG_CORE_0_SP_MIN_CORE_0_SP_MIN_Pos = 0x0
	// Bit mask of CORE_0_SP_MIN field.
	ASSIST_DEBUG_CORE_0_SP_MIN_CORE_0_SP_MIN_Msk = 0xffffffff

	// CORE_0_SP_MAX: ASSIST_DEBUG_CORE_0_SP_MAX_REG
	// Position of CORE_0_SP_MAX field.
	ASSIST_DEBUG_CORE_0_SP_MAX_CORE_0_SP_MAX_Pos = 0x0
	// Bit mask of CORE_0_SP_MAX field.
	ASSIST_DEBUG_CORE_0_SP_MAX_CORE_0_SP_MAX_Msk = 0xffffffff

	// CORE_0_SP_PC: ASSIST_DEBUG_CORE_0_SP_PC_REG
	// Position of CORE_0_SP_PC field.
	ASSIST_DEBUG_CORE_0_SP_PC_CORE_0_SP_PC_Pos = 0x0
	// Bit mask of CORE_0_SP_PC field.
	ASSIST_DEBUG_CORE_0_SP_PC_CORE_0_SP_PC_Msk = 0xffffffff

	// CORE_0_RCD_EN: ASSIST_DEBUG_CORE_0_RCD_EN_REG
	// Position of CORE_0_RCD_RECORDEN field.
	ASSIST_DEBUG_CORE_0_RCD_EN_CORE_0_RCD_RECORDEN_Pos = 0x0
	// Bit mask of CORE_0_RCD_RECORDEN field.
	ASSIST_DEBUG_CORE_0_RCD_EN_CORE_0_RCD_RECORDEN_Msk = 0x1
	// Bit CORE_0_RCD_RECORDEN.
	ASSIST_DEBUG_CORE_0_RCD_EN_CORE_0_RCD_RECORDEN = 0x1
	// Position of CORE_0_RCD_PDEBUGEN field.
	ASSIST_DEBUG_CORE_0_RCD_EN_CORE_0_RCD_PDEBUGEN_Pos = 0x1
	// Bit mask of CORE_0_RCD_PDEBUGEN field.
	ASSIST_DEBUG_CORE_0_RCD_EN_CORE_0_RCD_PDEBUGEN_Msk = 0x2
	// Bit CORE_0_RCD_PDEBUGEN.
	ASSIST_DEBUG_CORE_0_RCD_EN_CORE_0_RCD_PDEBUGEN = 0x2

	// CORE_0_RCD_PDEBUGPC: ASSIST_DEBUG_CORE_0_RCD_PDEBUGPC_REG
	// Position of CORE_0_RCD_PDEBUGPC field.
	ASSIST_DEBUG_CORE_0_RCD_PDEBUGPC_CORE_0_RCD_PDEBUGPC_Pos = 0x0
	// Bit mask of CORE_0_RCD_PDEBUGPC field.
	ASSIST_DEBUG_CORE_0_RCD_PDEBUGPC_CORE_0_RCD_PDEBUGPC_Msk = 0xffffffff

	// CORE_0_RCD_PDEBUGSP: ASSIST_DEBUG_CORE_0_RCD_PDEBUGSP_REG
	// Position of CORE_0_RCD_PDEBUGSP field.
	ASSIST_DEBUG_CORE_0_RCD_PDEBUGSP_CORE_0_RCD_PDEBUGSP_Pos = 0x0
	// Bit mask of CORE_0_RCD_PDEBUGSP field.
	ASSIST_DEBUG_CORE_0_RCD_PDEBUGSP_CORE_0_RCD_PDEBUGSP_Msk = 0xffffffff

	// CORE_0_IRAM0_EXCEPTION_MONITOR_0: ASSIST_DEBUG_CORE_0_RCD_PDEBUGSP_REG
	// Position of CORE_0_IRAM0_RECORDING_ADDR_0 field.
	ASSIST_DEBUG_CORE_0_IRAM0_EXCEPTION_MONITOR_0_CORE_0_IRAM0_RECORDING_ADDR_0_Pos = 0x0
	// Bit mask of CORE_0_IRAM0_RECORDING_ADDR_0 field.
	ASSIST_DEBUG_CORE_0_IRAM0_EXCEPTION_MONITOR_0_CORE_0_IRAM0_RECORDING_ADDR_0_Msk = 0xffffff
	// Position of CORE_0_IRAM0_RECORDING_WR_0 field.
	ASSIST_DEBUG_CORE_0_IRAM0_EXCEPTION_MONITOR_0_CORE_0_IRAM0_RECORDING_WR_0_Pos = 0x18
	// Bit mask of CORE_0_IRAM0_RECORDING_WR_0 field.
	ASSIST_DEBUG_CORE_0_IRAM0_EXCEPTION_MONITOR_0_CORE_0_IRAM0_RECORDING_WR_0_Msk = 0x1000000
	// Bit CORE_0_IRAM0_RECORDING_WR_0.
	ASSIST_DEBUG_CORE_0_IRAM0_EXCEPTION_MONITOR_0_CORE_0_IRAM0_RECORDING_WR_0 = 0x1000000
	// Position of CORE_0_IRAM0_RECORDING_LOADSTORE_0 field.
	ASSIST_DEBUG_CORE_0_IRAM0_EXCEPTION_MONITOR_0_CORE_0_IRAM0_RECORDING_LOADSTORE_0_Pos = 0x19
	// Bit mask of CORE_0_IRAM0_RECORDING_LOADSTORE_0 field.
	ASSIST_DEBUG_CORE_0_IRAM0_EXCEPTION_MONITOR_0_CORE_0_IRAM0_RECORDING_LOADSTORE_0_Msk = 0x2000000
	// Bit CORE_0_IRAM0_RECORDING_LOADSTORE_0.
	ASSIST_DEBUG_CORE_0_IRAM0_EXCEPTION_MONITOR_0_CORE_0_IRAM0_RECORDING_LOADSTORE_0 = 0x2000000

	// CORE_0_IRAM0_EXCEPTION_MONITOR_1: ASSIST_DEBUG_CORE_0_IRAM0_EXCEPTION_MONITOR_1_REG
	// Position of CORE_0_IRAM0_RECORDING_ADDR_1 field.
	ASSIST_DEBUG_CORE_0_IRAM0_EXCEPTION_MONITOR_1_CORE_0_IRAM0_RECORDING_ADDR_1_Pos = 0x0
	// Bit mask of CORE_0_IRAM0_RECORDING_ADDR_1 field.
	ASSIST_DEBUG_CORE_0_IRAM0_EXCEPTION_MONITOR_1_CORE_0_IRAM0_RECORDING_ADDR_1_Msk = 0xffffff
	// Position of CORE_0_IRAM0_RECORDING_WR_1 field.
	ASSIST_DEBUG_CORE_0_IRAM0_EXCEPTION_MONITOR_1_CORE_0_IRAM0_RECORDING_WR_1_Pos = 0x18
	// Bit mask of CORE_0_IRAM0_RECORDING_WR_1 field.
	ASSIST_DEBUG_CORE_0_IRAM0_EXCEPTION_MONITOR_1_CORE_0_IRAM0_RECORDING_WR_1_Msk = 0x1000000
	// Bit CORE_0_IRAM0_RECORDING_WR_1.
	ASSIST_DEBUG_CORE_0_IRAM0_EXCEPTION_MONITOR_1_CORE_0_IRAM0_RECORDING_WR_1 = 0x1000000
	// Position of CORE_0_IRAM0_RECORDING_LOADSTORE_1 field.
	ASSIST_DEBUG_CORE_0_IRAM0_EXCEPTION_MONITOR_1_CORE_0_IRAM0_RECORDING_LOADSTORE_1_Pos = 0x19
	// Bit mask of CORE_0_IRAM0_RECORDING_LOADSTORE_1 field.
	ASSIST_DEBUG_CORE_0_IRAM0_EXCEPTION_MONITOR_1_CORE_0_IRAM0_RECORDING_LOADSTORE_1_Msk = 0x2000000
	// Bit CORE_0_IRAM0_RECORDING_LOADSTORE_1.
	ASSIST_DEBUG_CORE_0_IRAM0_EXCEPTION_MONITOR_1_CORE_0_IRAM0_RECORDING_LOADSTORE_1 = 0x2000000

	// CORE_0_DRAM0_EXCEPTION_MONITOR_0: ASSIST_DEBUG_CORE_0_DRAM0_EXCEPTION_MONITOR_0_REG
	// Position of CORE_0_DRAM0_RECORDING_ADDR_0 field.
	ASSIST_DEBUG_CORE_0_DRAM0_EXCEPTION_MONITOR_0_CORE_0_DRAM0_RECORDING_ADDR_0_Pos = 0x0
	// Bit mask of CORE_0_DRAM0_RECORDING_ADDR_0 field.
	ASSIST_DEBUG_CORE_0_DRAM0_EXCEPTION_MONITOR_0_CORE_0_DRAM0_RECORDING_ADDR_0_Msk = 0xffffff
	// Position of CORE_0_DRAM0_RECORDING_WR_0 field.
	ASSIST_DEBUG_CORE_0_DRAM0_EXCEPTION_MONITOR_0_CORE_0_DRAM0_RECORDING_WR_0_Pos = 0x18
	// Bit mask of CORE_0_DRAM0_RECORDING_WR_0 field.
	ASSIST_DEBUG_CORE_0_DRAM0_EXCEPTION_MONITOR_0_CORE_0_DRAM0_RECORDING_WR_0_Msk = 0x1000000
	// Bit CORE_0_DRAM0_RECORDING_WR_0.
	ASSIST_DEBUG_CORE_0_DRAM0_EXCEPTION_MONITOR_0_CORE_0_DRAM0_RECORDING_WR_0 = 0x1000000
	// Position of CORE_0_DRAM0_RECORDING_BYTEEN_0 field.
	ASSIST_DEBUG_CORE_0_DRAM0_EXCEPTION_MONITOR_0_CORE_0_DRAM0_RECORDING_BYTEEN_0_Pos = 0x19
	// Bit mask of CORE_0_DRAM0_RECORDING_BYTEEN_0 field.
	ASSIST_DEBUG_CORE_0_DRAM0_EXCEPTION_MONITOR_0_CORE_0_DRAM0_RECORDING_BYTEEN_0_Msk = 0x1e000000

	// CORE_0_DRAM0_EXCEPTION_MONITOR_1: ASSIST_DEBUG_CORE_0_DRAM0_EXCEPTION_MONITOR_1_REG
	// Position of CORE_0_DRAM0_RECORDING_PC_0 field.
	ASSIST_DEBUG_CORE_0_DRAM0_EXCEPTION_MONITOR_1_CORE_0_DRAM0_RECORDING_PC_0_Pos = 0x0
	// Bit mask of CORE_0_DRAM0_RECORDING_PC_0 field.
	ASSIST_DEBUG_CORE_0_DRAM0_EXCEPTION_MONITOR_1_CORE_0_DRAM0_RECORDING_PC_0_Msk = 0xffffffff

	// CORE_0_DRAM0_EXCEPTION_MONITOR_2: ASSIST_DEBUG_CORE_0_DRAM0_EXCEPTION_MONITOR_1_REG
	// Position of CORE_0_DRAM0_RECORDING_ADDR_1 field.
	ASSIST_DEBUG_CORE_0_DRAM0_EXCEPTION_MONITOR_2_CORE_0_DRAM0_RECORDING_ADDR_1_Pos = 0x0
	// Bit mask of CORE_0_DRAM0_RECORDING_ADDR_1 field.
	ASSIST_DEBUG_CORE_0_DRAM0_EXCEPTION_MONITOR_2_CORE_0_DRAM0_RECORDING_ADDR_1_Msk = 0xffffff
	// Position of CORE_0_DRAM0_RECORDING_WR_1 field.
	ASSIST_DEBUG_CORE_0_DRAM0_EXCEPTION_MONITOR_2_CORE_0_DRAM0_RECORDING_WR_1_Pos = 0x18
	// Bit mask of CORE_0_DRAM0_RECORDING_WR_1 field.
	ASSIST_DEBUG_CORE_0_DRAM0_EXCEPTION_MONITOR_2_CORE_0_DRAM0_RECORDING_WR_1_Msk = 0x1000000
	// Bit CORE_0_DRAM0_RECORDING_WR_1.
	ASSIST_DEBUG_CORE_0_DRAM0_EXCEPTION_MONITOR_2_CORE_0_DRAM0_RECORDING_WR_1 = 0x1000000
	// Position of CORE_0_DRAM0_RECORDING_BYTEEN_1 field.
	ASSIST_DEBUG_CORE_0_DRAM0_EXCEPTION_MONITOR_2_CORE_0_DRAM0_RECORDING_BYTEEN_1_Pos = 0x19
	// Bit mask of CORE_0_DRAM0_RECORDING_BYTEEN_1 field.
	ASSIST_DEBUG_CORE_0_DRAM0_EXCEPTION_MONITOR_2_CORE_0_DRAM0_RECORDING_BYTEEN_1_Msk = 0x1e000000

	// CORE_0_DRAM0_EXCEPTION_MONITOR_3: ASSIST_DEBUG_CORE_0_DRAM0_EXCEPTION_MONITOR_3_REG
	// Position of CORE_0_DRAM0_RECORDING_PC_1 field.
	ASSIST_DEBUG_CORE_0_DRAM0_EXCEPTION_MONITOR_3_CORE_0_DRAM0_RECORDING_PC_1_Pos = 0x0
	// Bit mask of CORE_0_DRAM0_RECORDING_PC_1 field.
	ASSIST_DEBUG_CORE_0_DRAM0_EXCEPTION_MONITOR_3_CORE_0_DRAM0_RECORDING_PC_1_Msk = 0xffffffff

	// CORE_X_IRAM0_DRAM0_EXCEPTION_MONITOR_0: ASSIST_DEBUG_CORE_X_IRAM0_DRAM0_EXCEPTION_MONITOR_0_REG
	// Position of CORE_X_IRAM0_DRAM0_LIMIT_CYCLE_0 field.
	ASSIST_DEBUG_CORE_X_IRAM0_DRAM0_EXCEPTION_MONITOR_0_CORE_X_IRAM0_DRAM0_LIMIT_CYCLE_0_Pos = 0x0
	// Bit mask of CORE_X_IRAM0_DRAM0_LIMIT_CYCLE_0 field.
	ASSIST_DEBUG_CORE_X_IRAM0_DRAM0_EXCEPTION_MONITOR_0_CORE_X_IRAM0_DRAM0_LIMIT_CYCLE_0_Msk = 0xfffff

	// CORE_X_IRAM0_DRAM0_EXCEPTION_MONITOR_1: ASSIST_DEBUG_CORE_X_IRAM0_DRAM0_EXCEPTION_MONITOR_1_REG
	// Position of CORE_X_IRAM0_DRAM0_LIMIT_CYCLE_1 field.
	ASSIST_DEBUG_CORE_X_IRAM0_DRAM0_EXCEPTION_MONITOR_1_CORE_X_IRAM0_DRAM0_LIMIT_CYCLE_1_Pos = 0x0
	// Bit mask of CORE_X_IRAM0_DRAM0_LIMIT_CYCLE_1 field.
	ASSIST_DEBUG_CORE_X_IRAM0_DRAM0_EXCEPTION_MONITOR_1_CORE_X_IRAM0_DRAM0_LIMIT_CYCLE_1_Msk = 0xfffff

	// LOG_SETTING: ASSIST_DEBUG_LOG_SETTING
	// Position of LOG_ENA field.
	ASSIST_DEBUG_LOG_SETTING_LOG_ENA_Pos = 0x0
	// Bit mask of LOG_ENA field.
	ASSIST_DEBUG_LOG_SETTING_LOG_ENA_Msk = 0x7
	// Position of LOG_MODE field.
	ASSIST_DEBUG_LOG_SETTING_LOG_MODE_Pos = 0x3
	// Bit mask of LOG_MODE field.
	ASSIST_DEBUG_LOG_SETTING_LOG_MODE_Msk = 0x78
	// Position of LOG_MEM_LOOP_ENABLE field.
	ASSIST_DEBUG_LOG_SETTING_LOG_MEM_LOOP_ENABLE_Pos = 0x7
	// Bit mask of LOG_MEM_LOOP_ENABLE field.
	ASSIST_DEBUG_LOG_SETTING_LOG_MEM_LOOP_ENABLE_Msk = 0x80
	// Bit LOG_MEM_LOOP_ENABLE.
	ASSIST_DEBUG_LOG_SETTING_LOG_MEM_LOOP_ENABLE = 0x80

	// LOG_DATA_0: ASSIST_DEBUG_LOG_DATA_0_REG
	// Position of LOG_DATA_0 field.
	ASSIST_DEBUG_LOG_DATA_0_LOG_DATA_0_Pos = 0x0
	// Bit mask of LOG_DATA_0 field.
	ASSIST_DEBUG_LOG_DATA_0_LOG_DATA_0_Msk = 0xffffffff

	// LOG_DATA_MASK: ASSIST_DEBUG_LOG_DATA_MASK_REG
	// Position of LOG_DATA_SIZE field.
	ASSIST_DEBUG_LOG_DATA_MASK_LOG_DATA_SIZE_Pos = 0x0
	// Bit mask of LOG_DATA_SIZE field.
	ASSIST_DEBUG_LOG_DATA_MASK_LOG_DATA_SIZE_Msk = 0xffff

	// LOG_MIN: ASSIST_DEBUG_LOG_MIN_REG
	// Position of LOG_MIN field.
	ASSIST_DEBUG_LOG_MIN_LOG_MIN_Pos = 0x0
	// Bit mask of LOG_MIN field.
	ASSIST_DEBUG_LOG_MIN_LOG_MIN_Msk = 0xffffffff

	// LOG_MAX: ASSIST_DEBUG_LOG_MAX_REG
	// Position of LOG_MAX field.
	ASSIST_DEBUG_LOG_MAX_LOG_MAX_Pos = 0x0
	// Bit mask of LOG_MAX field.
	ASSIST_DEBUG_LOG_MAX_LOG_MAX_Msk = 0xffffffff

	// LOG_MEM_START: ASSIST_DEBUG_LOG_MEM_START_REG
	// Position of LOG_MEM_START field.
	ASSIST_DEBUG_LOG_MEM_START_LOG_MEM_START_Pos = 0x0
	// Bit mask of LOG_MEM_START field.
	ASSIST_DEBUG_LOG_MEM_START_LOG_MEM_START_Msk = 0xffffffff

	// LOG_MEM_END: ASSIST_DEBUG_LOG_MEM_END_REG
	// Position of LOG_MEM_END field.
	ASSIST_DEBUG_LOG_MEM_END_LOG_MEM_END_Pos = 0x0
	// Bit mask of LOG_MEM_END field.
	ASSIST_DEBUG_LOG_MEM_END_LOG_MEM_END_Msk = 0xffffffff

	// LOG_MEM_WRITING_ADDR: ASSIST_DEBUG_LOG_MEM_WRITING_ADDR_REG
	// Position of LOG_MEM_WRITING_ADDR field.
	ASSIST_DEBUG_LOG_MEM_WRITING_ADDR_LOG_MEM_WRITING_ADDR_Pos = 0x0
	// Bit mask of LOG_MEM_WRITING_ADDR field.
	ASSIST_DEBUG_LOG_MEM_WRITING_ADDR_LOG_MEM_WRITING_ADDR_Msk = 0xffffffff

	// LOG_MEM_FULL_FLAG: ASSIST_DEBUG_LOG_MEM_FULL_FLAG_REG
	// Position of LOG_MEM_FULL_FLAG field.
	ASSIST_DEBUG_LOG_MEM_FULL_FLAG_LOG_MEM_FULL_FLAG_Pos = 0x0
	// Bit mask of LOG_MEM_FULL_FLAG field.
	ASSIST_DEBUG_LOG_MEM_FULL_FLAG_LOG_MEM_FULL_FLAG_Msk = 0x1
	// Bit LOG_MEM_FULL_FLAG.
	ASSIST_DEBUG_LOG_MEM_FULL_FLAG_LOG_MEM_FULL_FLAG = 0x1
	// Position of CLR_LOG_MEM_FULL_FLAG field.
	ASSIST_DEBUG_LOG_MEM_FULL_FLAG_CLR_LOG_MEM_FULL_FLAG_Pos = 0x1
	// Bit mask of CLR_LOG_MEM_FULL_FLAG field.
	ASSIST_DEBUG_LOG_MEM_FULL_FLAG_CLR_LOG_MEM_FULL_FLAG_Msk = 0x2
	// Bit CLR_LOG_MEM_FULL_FLAG.
	ASSIST_DEBUG_LOG_MEM_FULL_FLAG_CLR_LOG_MEM_FULL_FLAG = 0x2

	// C0RE_0_LASTPC_BEFORE_EXCEPTION: ASSIST_DEBUG_C0RE_0_LASTPC_BEFORE_EXCEPTION
	// Position of CORE_0_LASTPC_BEFORE_EXC field.
	ASSIST_DEBUG_C0RE_0_LASTPC_BEFORE_EXCEPTION_CORE_0_LASTPC_BEFORE_EXC_Pos = 0x0
	// Bit mask of CORE_0_LASTPC_BEFORE_EXC field.
	ASSIST_DEBUG_C0RE_0_LASTPC_BEFORE_EXCEPTION_CORE_0_LASTPC_BEFORE_EXC_Msk = 0xffffffff

	// C0RE_0_DEBUG_MODE: ASSIST_DEBUG_C0RE_0_DEBUG_MODE
	// Position of CORE_0_DEBUG_MODE field.
	ASSIST_DEBUG_C0RE_0_DEBUG_MODE_CORE_0_DEBUG_MODE_Pos = 0x0
	// Bit mask of CORE_0_DEBUG_MODE field.
	ASSIST_DEBUG_C0RE_0_DEBUG_MODE_CORE_0_DEBUG_MODE_Msk = 0x1
	// Bit CORE_0_DEBUG_MODE.
	ASSIST_DEBUG_C0RE_0_DEBUG_MODE_CORE_0_DEBUG_MODE = 0x1
	// Position of CORE_0_DEBUG_MODULE_ACTIVE field.
	ASSIST_DEBUG_C0RE_0_DEBUG_MODE_CORE_0_DEBUG_MODULE_ACTIVE_Pos = 0x1
	// Bit mask of CORE_0_DEBUG_MODULE_ACTIVE field.
	ASSIST_DEBUG_C0RE_0_DEBUG_MODE_CORE_0_DEBUG_MODULE_ACTIVE_Msk = 0x2
	// Bit CORE_0_DEBUG_MODULE_ACTIVE.
	ASSIST_DEBUG_C0RE_0_DEBUG_MODE_CORE_0_DEBUG_MODULE_ACTIVE = 0x2

	// DATE: ASSIST_DEBUG_DATE_REG
	// Position of ASSIST_DEBUG_DATE field.
	ASSIST_DEBUG_DATE_ASSIST_DEBUG_DATE_Pos = 0x0
	// Bit mask of ASSIST_DEBUG_DATE field.
	ASSIST_DEBUG_DATE_ASSIST_DEBUG_DATE_Msk = 0xfffffff
)

// Constants for DMA: Peripheral DMA
const (
	// INT_RAW_CH0: DMA_INT_RAW_CH0_REG.
	// Position of IN_DONE_CH0_INT_RAW field.
	DMA_INT_RAW_CH0_IN_DONE_CH0_INT_RAW_Pos = 0x0
	// Bit mask of IN_DONE_CH0_INT_RAW field.
	DMA_INT_RAW_CH0_IN_DONE_CH0_INT_RAW_Msk = 0x1
	// Bit IN_DONE_CH0_INT_RAW.
	DMA_INT_RAW_CH0_IN_DONE_CH0_INT_RAW = 0x1
	// Position of IN_SUC_EOF_CH0_INT_RAW field.
	DMA_INT_RAW_CH0_IN_SUC_EOF_CH0_INT_RAW_Pos = 0x1
	// Bit mask of IN_SUC_EOF_CH0_INT_RAW field.
	DMA_INT_RAW_CH0_IN_SUC_EOF_CH0_INT_RAW_Msk = 0x2
	// Bit IN_SUC_EOF_CH0_INT_RAW.
	DMA_INT_RAW_CH0_IN_SUC_EOF_CH0_INT_RAW = 0x2
	// Position of IN_ERR_EOF_CH0_INT_RAW field.
	DMA_INT_RAW_CH0_IN_ERR_EOF_CH0_INT_RAW_Pos = 0x2
	// Bit mask of IN_ERR_EOF_CH0_INT_RAW field.
	DMA_INT_RAW_CH0_IN_ERR_EOF_CH0_INT_RAW_Msk = 0x4
	// Bit IN_ERR_EOF_CH0_INT_RAW.
	DMA_INT_RAW_CH0_IN_ERR_EOF_CH0_INT_RAW = 0x4
	// Position of OUT_DONE_CH0_INT_RAW field.
	DMA_INT_RAW_CH0_OUT_DONE_CH0_INT_RAW_Pos = 0x3
	// Bit mask of OUT_DONE_CH0_INT_RAW field.
	DMA_INT_RAW_CH0_OUT_DONE_CH0_INT_RAW_Msk = 0x8
	// Bit OUT_DONE_CH0_INT_RAW.
	DMA_INT_RAW_CH0_OUT_DONE_CH0_INT_RAW = 0x8
	// Position of OUT_EOF_CH0_INT_RAW field.
	DMA_INT_RAW_CH0_OUT_EOF_CH0_INT_RAW_Pos = 0x4
	// Bit mask of OUT_EOF_CH0_INT_RAW field.
	DMA_INT_RAW_CH0_OUT_EOF_CH0_INT_RAW_Msk = 0x10
	// Bit OUT_EOF_CH0_INT_RAW.
	DMA_INT_RAW_CH0_OUT_EOF_CH0_INT_RAW = 0x10
	// Position of IN_DSCR_ERR_CH0_INT_RAW field.
	DMA_INT_RAW_CH0_IN_DSCR_ERR_CH0_INT_RAW_Pos = 0x5
	// Bit mask of IN_DSCR_ERR_CH0_INT_RAW field.
	DMA_INT_RAW_CH0_IN_DSCR_ERR_CH0_INT_RAW_Msk = 0x20
	// Bit IN_DSCR_ERR_CH0_INT_RAW.
	DMA_INT_RAW_CH0_IN_DSCR_ERR_CH0_INT_RAW = 0x20
	// Position of OUT_DSCR_ERR_CH0_INT_RAW field.
	DMA_INT_RAW_CH0_OUT_DSCR_ERR_CH0_INT_RAW_Pos = 0x6
	// Bit mask of OUT_DSCR_ERR_CH0_INT_RAW field.
	DMA_INT_RAW_CH0_OUT_DSCR_ERR_CH0_INT_RAW_Msk = 0x40
	// Bit OUT_DSCR_ERR_CH0_INT_RAW.
	DMA_INT_RAW_CH0_OUT_DSCR_ERR_CH0_INT_RAW = 0x40
	// Position of IN_DSCR_EMPTY_CH0_INT_RAW field.
	DMA_INT_RAW_CH0_IN_DSCR_EMPTY_CH0_INT_RAW_Pos = 0x7
	// Bit mask of IN_DSCR_EMPTY_CH0_INT_RAW field.
	DMA_INT_RAW_CH0_IN_DSCR_EMPTY_CH0_INT_RAW_Msk = 0x80
	// Bit IN_DSCR_EMPTY_CH0_INT_RAW.
	DMA_INT_RAW_CH0_IN_DSCR_EMPTY_CH0_INT_RAW = 0x80
	// Position of OUT_TOTAL_EOF_CH0_INT_RAW field.
	DMA_INT_RAW_CH0_OUT_TOTAL_EOF_CH0_INT_RAW_Pos = 0x8
	// Bit mask of OUT_TOTAL_EOF_CH0_INT_RAW field.
	DMA_INT_RAW_CH0_OUT_TOTAL_EOF_CH0_INT_RAW_Msk = 0x100
	// Bit OUT_TOTAL_EOF_CH0_INT_RAW.
	DMA_INT_RAW_CH0_OUT_TOTAL_EOF_CH0_INT_RAW = 0x100
	// Position of INFIFO_OVF_CH0_INT_RAW field.
	DMA_INT_RAW_CH0_INFIFO_OVF_CH0_INT_RAW_Pos = 0x9
	// Bit mask of INFIFO_OVF_CH0_INT_RAW field.
	DMA_INT_RAW_CH0_INFIFO_OVF_CH0_INT_RAW_Msk = 0x200
	// Bit INFIFO_OVF_CH0_INT_RAW.
	DMA_INT_RAW_CH0_INFIFO_OVF_CH0_INT_RAW = 0x200
	// Position of INFIFO_UDF_CH0_INT_RAW field.
	DMA_INT_RAW_CH0_INFIFO_UDF_CH0_INT_RAW_Pos = 0xa
	// Bit mask of INFIFO_UDF_CH0_INT_RAW field.
	DMA_INT_RAW_CH0_INFIFO_UDF_CH0_INT_RAW_Msk = 0x400
	// Bit INFIFO_UDF_CH0_INT_RAW.
	DMA_INT_RAW_CH0_INFIFO_UDF_CH0_INT_RAW = 0x400
	// Position of OUTFIFO_OVF_CH0_INT_RAW field.
	DMA_INT_RAW_CH0_OUTFIFO_OVF_CH0_INT_RAW_Pos = 0xb
	// Bit mask of OUTFIFO_OVF_CH0_INT_RAW field.
	DMA_INT_RAW_CH0_OUTFIFO_OVF_CH0_INT_RAW_Msk = 0x800
	// Bit OUTFIFO_OVF_CH0_INT_RAW.
	DMA_INT_RAW_CH0_OUTFIFO_OVF_CH0_INT_RAW = 0x800
	// Position of OUTFIFO_UDF_CH0_INT_RAW field.
	DMA_INT_RAW_CH0_OUTFIFO_UDF_CH0_INT_RAW_Pos = 0xc
	// Bit mask of OUTFIFO_UDF_CH0_INT_RAW field.
	DMA_INT_RAW_CH0_OUTFIFO_UDF_CH0_INT_RAW_Msk = 0x1000
	// Bit OUTFIFO_UDF_CH0_INT_RAW.
	DMA_INT_RAW_CH0_OUTFIFO_UDF_CH0_INT_RAW = 0x1000

	// INT_ST_CH0: DMA_INT_ST_CH0_REG.
	// Position of IN_DONE_CH0_INT_ST field.
	DMA_INT_ST_CH0_IN_DONE_CH0_INT_ST_Pos = 0x0
	// Bit mask of IN_DONE_CH0_INT_ST field.
	DMA_INT_ST_CH0_IN_DONE_CH0_INT_ST_Msk = 0x1
	// Bit IN_DONE_CH0_INT_ST.
	DMA_INT_ST_CH0_IN_DONE_CH0_INT_ST = 0x1
	// Position of IN_SUC_EOF_CH0_INT_ST field.
	DMA_INT_ST_CH0_IN_SUC_EOF_CH0_INT_ST_Pos = 0x1
	// Bit mask of IN_SUC_EOF_CH0_INT_ST field.
	DMA_INT_ST_CH0_IN_SUC_EOF_CH0_INT_ST_Msk = 0x2
	// Bit IN_SUC_EOF_CH0_INT_ST.
	DMA_INT_ST_CH0_IN_SUC_EOF_CH0_INT_ST = 0x2
	// Position of IN_ERR_EOF_CH0_INT_ST field.
	DMA_INT_ST_CH0_IN_ERR_EOF_CH0_INT_ST_Pos = 0x2
	// Bit mask of IN_ERR_EOF_CH0_INT_ST field.
	DMA_INT_ST_CH0_IN_ERR_EOF_CH0_INT_ST_Msk = 0x4
	// Bit IN_ERR_EOF_CH0_INT_ST.
	DMA_INT_ST_CH0_IN_ERR_EOF_CH0_INT_ST = 0x4
	// Position of OUT_DONE_CH0_INT_ST field.
	DMA_INT_ST_CH0_OUT_DONE_CH0_INT_ST_Pos = 0x3
	// Bit mask of OUT_DONE_CH0_INT_ST field.
	DMA_INT_ST_CH0_OUT_DONE_CH0_INT_ST_Msk = 0x8
	// Bit OUT_DONE_CH0_INT_ST.
	DMA_INT_ST_CH0_OUT_DONE_CH0_INT_ST = 0x8
	// Position of OUT_EOF_CH0_INT_ST field.
	DMA_INT_ST_CH0_OUT_EOF_CH0_INT_ST_Pos = 0x4
	// Bit mask of OUT_EOF_CH0_INT_ST field.
	DMA_INT_ST_CH0_OUT_EOF_CH0_INT_ST_Msk = 0x10
	// Bit OUT_EOF_CH0_INT_ST.
	DMA_INT_ST_CH0_OUT_EOF_CH0_INT_ST = 0x10
	// Position of IN_DSCR_ERR_CH0_INT_ST field.
	DMA_INT_ST_CH0_IN_DSCR_ERR_CH0_INT_ST_Pos = 0x5
	// Bit mask of IN_DSCR_ERR_CH0_INT_ST field.
	DMA_INT_ST_CH0_IN_DSCR_ERR_CH0_INT_ST_Msk = 0x20
	// Bit IN_DSCR_ERR_CH0_INT_ST.
	DMA_INT_ST_CH0_IN_DSCR_ERR_CH0_INT_ST = 0x20
	// Position of OUT_DSCR_ERR_CH0_INT_ST field.
	DMA_INT_ST_CH0_OUT_DSCR_ERR_CH0_INT_ST_Pos = 0x6
	// Bit mask of OUT_DSCR_ERR_CH0_INT_ST field.
	DMA_INT_ST_CH0_OUT_DSCR_ERR_CH0_INT_ST_Msk = 0x40
	// Bit OUT_DSCR_ERR_CH0_INT_ST.
	DMA_INT_ST_CH0_OUT_DSCR_ERR_CH0_INT_ST = 0x40
	// Position of IN_DSCR_EMPTY_CH0_INT_ST field.
	DMA_INT_ST_CH0_IN_DSCR_EMPTY_CH0_INT_ST_Pos = 0x7
	// Bit mask of IN_DSCR_EMPTY_CH0_INT_ST field.
	DMA_INT_ST_CH0_IN_DSCR_EMPTY_CH0_INT_ST_Msk = 0x80
	// Bit IN_DSCR_EMPTY_CH0_INT_ST.
	DMA_INT_ST_CH0_IN_DSCR_EMPTY_CH0_INT_ST = 0x80
	// Position of OUT_TOTAL_EOF_CH0_INT_ST field.
	DMA_INT_ST_CH0_OUT_TOTAL_EOF_CH0_INT_ST_Pos = 0x8
	// Bit mask of OUT_TOTAL_EOF_CH0_INT_ST field.
	DMA_INT_ST_CH0_OUT_TOTAL_EOF_CH0_INT_ST_Msk = 0x100
	// Bit OUT_TOTAL_EOF_CH0_INT_ST.
	DMA_INT_ST_CH0_OUT_TOTAL_EOF_CH0_INT_ST = 0x100
	// Position of INFIFO_OVF_CH0_INT_ST field.
	DMA_INT_ST_CH0_INFIFO_OVF_CH0_INT_ST_Pos = 0x9
	// Bit mask of INFIFO_OVF_CH0_INT_ST field.
	DMA_INT_ST_CH0_INFIFO_OVF_CH0_INT_ST_Msk = 0x200
	// Bit INFIFO_OVF_CH0_INT_ST.
	DMA_INT_ST_CH0_INFIFO_OVF_CH0_INT_ST = 0x200
	// Position of INFIFO_UDF_CH0_INT_ST field.
	DMA_INT_ST_CH0_INFIFO_UDF_CH0_INT_ST_Pos = 0xa
	// Bit mask of INFIFO_UDF_CH0_INT_ST field.
	DMA_INT_ST_CH0_INFIFO_UDF_CH0_INT_ST_Msk = 0x400
	// Bit INFIFO_UDF_CH0_INT_ST.
	DMA_INT_ST_CH0_INFIFO_UDF_CH0_INT_ST = 0x400
	// Position of OUTFIFO_OVF_CH0_INT_ST field.
	DMA_INT_ST_CH0_OUTFIFO_OVF_CH0_INT_ST_Pos = 0xb
	// Bit mask of OUTFIFO_OVF_CH0_INT_ST field.
	DMA_INT_ST_CH0_OUTFIFO_OVF_CH0_INT_ST_Msk = 0x800
	// Bit OUTFIFO_OVF_CH0_INT_ST.
	DMA_INT_ST_CH0_OUTFIFO_OVF_CH0_INT_ST = 0x800
	// Position of OUTFIFO_UDF_CH0_INT_ST field.
	DMA_INT_ST_CH0_OUTFIFO_UDF_CH0_INT_ST_Pos = 0xc
	// Bit mask of OUTFIFO_UDF_CH0_INT_ST field.
	DMA_INT_ST_CH0_OUTFIFO_UDF_CH0_INT_ST_Msk = 0x1000
	// Bit OUTFIFO_UDF_CH0_INT_ST.
	DMA_INT_ST_CH0_OUTFIFO_UDF_CH0_INT_ST = 0x1000

	// INT_ENA_CH0: DMA_INT_ENA_CH0_REG.
	// Position of IN_DONE_CH0_INT_ENA field.
	DMA_INT_ENA_CH0_IN_DONE_CH0_INT_ENA_Pos = 0x0
	// Bit mask of IN_DONE_CH0_INT_ENA field.
	DMA_INT_ENA_CH0_IN_DONE_CH0_INT_ENA_Msk = 0x1
	// Bit IN_DONE_CH0_INT_ENA.
	DMA_INT_ENA_CH0_IN_DONE_CH0_INT_ENA = 0x1
	// Position of IN_SUC_EOF_CH0_INT_ENA field.
	DMA_INT_ENA_CH0_IN_SUC_EOF_CH0_INT_ENA_Pos = 0x1
	// Bit mask of IN_SUC_EOF_CH0_INT_ENA field.
	DMA_INT_ENA_CH0_IN_SUC_EOF_CH0_INT_ENA_Msk = 0x2
	// Bit IN_SUC_EOF_CH0_INT_ENA.
	DMA_INT_ENA_CH0_IN_SUC_EOF_CH0_INT_ENA = 0x2
	// Position of IN_ERR_EOF_CH0_INT_ENA field.
	DMA_INT_ENA_CH0_IN_ERR_EOF_CH0_INT_ENA_Pos = 0x2
	// Bit mask of IN_ERR_EOF_CH0_INT_ENA field.
	DMA_INT_ENA_CH0_IN_ERR_EOF_CH0_INT_ENA_Msk = 0x4
	// Bit IN_ERR_EOF_CH0_INT_ENA.
	DMA_INT_ENA_CH0_IN_ERR_EOF_CH0_INT_ENA = 0x4
	// Position of OUT_DONE_CH0_INT_ENA field.
	DMA_INT_ENA_CH0_OUT_DONE_CH0_INT_ENA_Pos = 0x3
	// Bit mask of OUT_DONE_CH0_INT_ENA field.
	DMA_INT_ENA_CH0_OUT_DONE_CH0_INT_ENA_Msk = 0x8
	// Bit OUT_DONE_CH0_INT_ENA.
	DMA_INT_ENA_CH0_OUT_DONE_CH0_INT_ENA = 0x8
	// Position of OUT_EOF_CH0_INT_ENA field.
	DMA_INT_ENA_CH0_OUT_EOF_CH0_INT_ENA_Pos = 0x4
	// Bit mask of OUT_EOF_CH0_INT_ENA field.
	DMA_INT_ENA_CH0_OUT_EOF_CH0_INT_ENA_Msk = 0x10
	// Bit OUT_EOF_CH0_INT_ENA.
	DMA_INT_ENA_CH0_OUT_EOF_CH0_INT_ENA = 0x10
	// Position of IN_DSCR_ERR_CH0_INT_ENA field.
	DMA_INT_ENA_CH0_IN_DSCR_ERR_CH0_INT_ENA_Pos = 0x5
	// Bit mask of IN_DSCR_ERR_CH0_INT_ENA field.
	DMA_INT_ENA_CH0_IN_DSCR_ERR_CH0_INT_ENA_Msk = 0x20
	// Bit IN_DSCR_ERR_CH0_INT_ENA.
	DMA_INT_ENA_CH0_IN_DSCR_ERR_CH0_INT_ENA = 0x20
	// Position of OUT_DSCR_ERR_CH0_INT_ENA field.
	DMA_INT_ENA_CH0_OUT_DSCR_ERR_CH0_INT_ENA_Pos = 0x6
	// Bit mask of OUT_DSCR_ERR_CH0_INT_ENA field.
	DMA_INT_ENA_CH0_OUT_DSCR_ERR_CH0_INT_ENA_Msk = 0x40
	// Bit OUT_DSCR_ERR_CH0_INT_ENA.
	DMA_INT_ENA_CH0_OUT_DSCR_ERR_CH0_INT_ENA = 0x40
	// Position of IN_DSCR_EMPTY_CH0_INT_ENA field.
	DMA_INT_ENA_CH0_IN_DSCR_EMPTY_CH0_INT_ENA_Pos = 0x7
	// Bit mask of IN_DSCR_EMPTY_CH0_INT_ENA field.
	DMA_INT_ENA_CH0_IN_DSCR_EMPTY_CH0_INT_ENA_Msk = 0x80
	// Bit IN_DSCR_EMPTY_CH0_INT_ENA.
	DMA_INT_ENA_CH0_IN_DSCR_EMPTY_CH0_INT_ENA = 0x80
	// Position of OUT_TOTAL_EOF_CH0_INT_ENA field.
	DMA_INT_ENA_CH0_OUT_TOTAL_EOF_CH0_INT_ENA_Pos = 0x8
	// Bit mask of OUT_TOTAL_EOF_CH0_INT_ENA field.
	DMA_INT_ENA_CH0_OUT_TOTAL_EOF_CH0_INT_ENA_Msk = 0x100
	// Bit OUT_TOTAL_EOF_CH0_INT_ENA.
	DMA_INT_ENA_CH0_OUT_TOTAL_EOF_CH0_INT_ENA = 0x100
	// Position of INFIFO_OVF_CH0_INT_ENA field.
	DMA_INT_ENA_CH0_INFIFO_OVF_CH0_INT_ENA_Pos = 0x9
	// Bit mask of INFIFO_OVF_CH0_INT_ENA field.
	DMA_INT_ENA_CH0_INFIFO_OVF_CH0_INT_ENA_Msk = 0x200
	// Bit INFIFO_OVF_CH0_INT_ENA.
	DMA_INT_ENA_CH0_INFIFO_OVF_CH0_INT_ENA = 0x200
	// Position of INFIFO_UDF_CH0_INT_ENA field.
	DMA_INT_ENA_CH0_INFIFO_UDF_CH0_INT_ENA_Pos = 0xa
	// Bit mask of INFIFO_UDF_CH0_INT_ENA field.
	DMA_INT_ENA_CH0_INFIFO_UDF_CH0_INT_ENA_Msk = 0x400
	// Bit INFIFO_UDF_CH0_INT_ENA.
	DMA_INT_ENA_CH0_INFIFO_UDF_CH0_INT_ENA = 0x400
	// Position of OUTFIFO_OVF_CH0_INT_ENA field.
	DMA_INT_ENA_CH0_OUTFIFO_OVF_CH0_INT_ENA_Pos = 0xb
	// Bit mask of OUTFIFO_OVF_CH0_INT_ENA field.
	DMA_INT_ENA_CH0_OUTFIFO_OVF_CH0_INT_ENA_Msk = 0x800
	// Bit OUTFIFO_OVF_CH0_INT_ENA.
	DMA_INT_ENA_CH0_OUTFIFO_OVF_CH0_INT_ENA = 0x800
	// Position of OUTFIFO_UDF_CH0_INT_ENA field.
	DMA_INT_ENA_CH0_OUTFIFO_UDF_CH0_INT_ENA_Pos = 0xc
	// Bit mask of OUTFIFO_UDF_CH0_INT_ENA field.
	DMA_INT_ENA_CH0_OUTFIFO_UDF_CH0_INT_ENA_Msk = 0x1000
	// Bit OUTFIFO_UDF_CH0_INT_ENA.
	DMA_INT_ENA_CH0_OUTFIFO_UDF_CH0_INT_ENA = 0x1000

	// INT_CLR_CH0: DMA_INT_CLR_CH0_REG.
	// Position of IN_DONE_CH0_INT_CLR field.
	DMA_INT_CLR_CH0_IN_DONE_CH0_INT_CLR_Pos = 0x0
	// Bit mask of IN_DONE_CH0_INT_CLR field.
	DMA_INT_CLR_CH0_IN_DONE_CH0_INT_CLR_Msk = 0x1
	// Bit IN_DONE_CH0_INT_CLR.
	DMA_INT_CLR_CH0_IN_DONE_CH0_INT_CLR = 0x1
	// Position of IN_SUC_EOF_CH0_INT_CLR field.
	DMA_INT_CLR_CH0_IN_SUC_EOF_CH0_INT_CLR_Pos = 0x1
	// Bit mask of IN_SUC_EOF_CH0_INT_CLR field.
	DMA_INT_CLR_CH0_IN_SUC_EOF_CH0_INT_CLR_Msk = 0x2
	// Bit IN_SUC_EOF_CH0_INT_CLR.
	DMA_INT_CLR_CH0_IN_SUC_EOF_CH0_INT_CLR = 0x2
	// Position of IN_ERR_EOF_CH0_INT_CLR field.
	DMA_INT_CLR_CH0_IN_ERR_EOF_CH0_INT_CLR_Pos = 0x2
	// Bit mask of IN_ERR_EOF_CH0_INT_CLR field.
	DMA_INT_CLR_CH0_IN_ERR_EOF_CH0_INT_CLR_Msk = 0x4
	// Bit IN_ERR_EOF_CH0_INT_CLR.
	DMA_INT_CLR_CH0_IN_ERR_EOF_CH0_INT_CLR = 0x4
	// Position of OUT_DONE_CH0_INT_CLR field.
	DMA_INT_CLR_CH0_OUT_DONE_CH0_INT_CLR_Pos = 0x3
	// Bit mask of OUT_DONE_CH0_INT_CLR field.
	DMA_INT_CLR_CH0_OUT_DONE_CH0_INT_CLR_Msk = 0x8
	// Bit OUT_DONE_CH0_INT_CLR.
	DMA_INT_CLR_CH0_OUT_DONE_CH0_INT_CLR = 0x8
	// Position of OUT_EOF_CH0_INT_CLR field.
	DMA_INT_CLR_CH0_OUT_EOF_CH0_INT_CLR_Pos = 0x4
	// Bit mask of OUT_EOF_CH0_INT_CLR field.
	DMA_INT_CLR_CH0_OUT_EOF_CH0_INT_CLR_Msk = 0x10
	// Bit OUT_EOF_CH0_INT_CLR.
	DMA_INT_CLR_CH0_OUT_EOF_CH0_INT_CLR = 0x10
	// Position of IN_DSCR_ERR_CH0_INT_CLR field.
	DMA_INT_CLR_CH0_IN_DSCR_ERR_CH0_INT_CLR_Pos = 0x5
	// Bit mask of IN_DSCR_ERR_CH0_INT_CLR field.
	DMA_INT_CLR_CH0_IN_DSCR_ERR_CH0_INT_CLR_Msk = 0x20
	// Bit IN_DSCR_ERR_CH0_INT_CLR.
	DMA_INT_CLR_CH0_IN_DSCR_ERR_CH0_INT_CLR = 0x20
	// Position of OUT_DSCR_ERR_CH0_INT_CLR field.
	DMA_INT_CLR_CH0_OUT_DSCR_ERR_CH0_INT_CLR_Pos = 0x6
	// Bit mask of OUT_DSCR_ERR_CH0_INT_CLR field.
	DMA_INT_CLR_CH0_OUT_DSCR_ERR_CH0_INT_CLR_Msk = 0x40
	// Bit OUT_DSCR_ERR_CH0_INT_CLR.
	DMA_INT_CLR_CH0_OUT_DSCR_ERR_CH0_INT_CLR = 0x40
	// Position of IN_DSCR_EMPTY_CH0_INT_CLR field.
	DMA_INT_CLR_CH0_IN_DSCR_EMPTY_CH0_INT_CLR_Pos = 0x7
	// Bit mask of IN_DSCR_EMPTY_CH0_INT_CLR field.
	DMA_INT_CLR_CH0_IN_DSCR_EMPTY_CH0_INT_CLR_Msk = 0x80
	// Bit IN_DSCR_EMPTY_CH0_INT_CLR.
	DMA_INT_CLR_CH0_IN_DSCR_EMPTY_CH0_INT_CLR = 0x80
	// Position of OUT_TOTAL_EOF_CH0_INT_CLR field.
	DMA_INT_CLR_CH0_OUT_TOTAL_EOF_CH0_INT_CLR_Pos = 0x8
	// Bit mask of OUT_TOTAL_EOF_CH0_INT_CLR field.
	DMA_INT_CLR_CH0_OUT_TOTAL_EOF_CH0_INT_CLR_Msk = 0x100
	// Bit OUT_TOTAL_EOF_CH0_INT_CLR.
	DMA_INT_CLR_CH0_OUT_TOTAL_EOF_CH0_INT_CLR = 0x100
	// Position of INFIFO_OVF_CH0_INT_CLR field.
	DMA_INT_CLR_CH0_INFIFO_OVF_CH0_INT_CLR_Pos = 0x9
	// Bit mask of INFIFO_OVF_CH0_INT_CLR field.
	DMA_INT_CLR_CH0_INFIFO_OVF_CH0_INT_CLR_Msk = 0x200
	// Bit INFIFO_OVF_CH0_INT_CLR.
	DMA_INT_CLR_CH0_INFIFO_OVF_CH0_INT_CLR = 0x200
	// Position of INFIFO_UDF_CH0_INT_CLR field.
	DMA_INT_CLR_CH0_INFIFO_UDF_CH0_INT_CLR_Pos = 0xa
	// Bit mask of INFIFO_UDF_CH0_INT_CLR field.
	DMA_INT_CLR_CH0_INFIFO_UDF_CH0_INT_CLR_Msk = 0x400
	// Bit INFIFO_UDF_CH0_INT_CLR.
	DMA_INT_CLR_CH0_INFIFO_UDF_CH0_INT_CLR = 0x400
	// Position of OUTFIFO_OVF_CH0_INT_CLR field.
	DMA_INT_CLR_CH0_OUTFIFO_OVF_CH0_INT_CLR_Pos = 0xb
	// Bit mask of OUTFIFO_OVF_CH0_INT_CLR field.
	DMA_INT_CLR_CH0_OUTFIFO_OVF_CH0_INT_CLR_Msk = 0x800
	// Bit OUTFIFO_OVF_CH0_INT_CLR.
	DMA_INT_CLR_CH0_OUTFIFO_OVF_CH0_INT_CLR = 0x800
	// Position of OUTFIFO_UDF_CH0_INT_CLR field.
	DMA_INT_CLR_CH0_OUTFIFO_UDF_CH0_INT_CLR_Pos = 0xc
	// Bit mask of OUTFIFO_UDF_CH0_INT_CLR field.
	DMA_INT_CLR_CH0_OUTFIFO_UDF_CH0_INT_CLR_Msk = 0x1000
	// Bit OUTFIFO_UDF_CH0_INT_CLR.
	DMA_INT_CLR_CH0_OUTFIFO_UDF_CH0_INT_CLR = 0x1000

	// INT_RAW_CH1: DMA_INT_RAW_CH1_REG.
	// Position of IN_DONE_CH1_INT_RAW field.
	DMA_INT_RAW_CH1_IN_DONE_CH1_INT_RAW_Pos = 0x0
	// Bit mask of IN_DONE_CH1_INT_RAW field.
	DMA_INT_RAW_CH1_IN_DONE_CH1_INT_RAW_Msk = 0x1
	// Bit IN_DONE_CH1_INT_RAW.
	DMA_INT_RAW_CH1_IN_DONE_CH1_INT_RAW = 0x1
	// Position of IN_SUC_EOF_CH1_INT_RAW field.
	DMA_INT_RAW_CH1_IN_SUC_EOF_CH1_INT_RAW_Pos = 0x1
	// Bit mask of IN_SUC_EOF_CH1_INT_RAW field.
	DMA_INT_RAW_CH1_IN_SUC_EOF_CH1_INT_RAW_Msk = 0x2
	// Bit IN_SUC_EOF_CH1_INT_RAW.
	DMA_INT_RAW_CH1_IN_SUC_EOF_CH1_INT_RAW = 0x2
	// Position of IN_ERR_EOF_CH1_INT_RAW field.
	DMA_INT_RAW_CH1_IN_ERR_EOF_CH1_INT_RAW_Pos = 0x2
	// Bit mask of IN_ERR_EOF_CH1_INT_RAW field.
	DMA_INT_RAW_CH1_IN_ERR_EOF_CH1_INT_RAW_Msk = 0x4
	// Bit IN_ERR_EOF_CH1_INT_RAW.
	DMA_INT_RAW_CH1_IN_ERR_EOF_CH1_INT_RAW = 0x4
	// Position of OUT_DONE_CH1_INT_RAW field.
	DMA_INT_RAW_CH1_OUT_DONE_CH1_INT_RAW_Pos = 0x3
	// Bit mask of OUT_DONE_CH1_INT_RAW field.
	DMA_INT_RAW_CH1_OUT_DONE_CH1_INT_RAW_Msk = 0x8
	// Bit OUT_DONE_CH1_INT_RAW.
	DMA_INT_RAW_CH1_OUT_DONE_CH1_INT_RAW = 0x8
	// Position of OUT_EOF_CH1_INT_RAW field.
	DMA_INT_RAW_CH1_OUT_EOF_CH1_INT_RAW_Pos = 0x4
	// Bit mask of OUT_EOF_CH1_INT_RAW field.
	DMA_INT_RAW_CH1_OUT_EOF_CH1_INT_RAW_Msk = 0x10
	// Bit OUT_EOF_CH1_INT_RAW.
	DMA_INT_RAW_CH1_OUT_EOF_CH1_INT_RAW = 0x10
	// Position of IN_DSCR_ERR_CH1_INT_RAW field.
	DMA_INT_RAW_CH1_IN_DSCR_ERR_CH1_INT_RAW_Pos = 0x5
	// Bit mask of IN_DSCR_ERR_CH1_INT_RAW field.
	DMA_INT_RAW_CH1_IN_DSCR_ERR_CH1_INT_RAW_Msk = 0x20
	// Bit IN_DSCR_ERR_CH1_INT_RAW.
	DMA_INT_RAW_CH1_IN_DSCR_ERR_CH1_INT_RAW = 0x20
	// Position of OUT_DSCR_ERR_CH1_INT_RAW field.
	DMA_INT_RAW_CH1_OUT_DSCR_ERR_CH1_INT_RAW_Pos = 0x6
	// Bit mask of OUT_DSCR_ERR_CH1_INT_RAW field.
	DMA_INT_RAW_CH1_OUT_DSCR_ERR_CH1_INT_RAW_Msk = 0x40
	// Bit OUT_DSCR_ERR_CH1_INT_RAW.
	DMA_INT_RAW_CH1_OUT_DSCR_ERR_CH1_INT_RAW = 0x40
	// Position of IN_DSCR_EMPTY_CH1_INT_RAW field.
	DMA_INT_RAW_CH1_IN_DSCR_EMPTY_CH1_INT_RAW_Pos = 0x7
	// Bit mask of IN_DSCR_EMPTY_CH1_INT_RAW field.
	DMA_INT_RAW_CH1_IN_DSCR_EMPTY_CH1_INT_RAW_Msk = 0x80
	// Bit IN_DSCR_EMPTY_CH1_INT_RAW.
	DMA_INT_RAW_CH1_IN_DSCR_EMPTY_CH1_INT_RAW = 0x80
	// Position of OUT_TOTAL_EOF_CH1_INT_RAW field.
	DMA_INT_RAW_CH1_OUT_TOTAL_EOF_CH1_INT_RAW_Pos = 0x8
	// Bit mask of OUT_TOTAL_EOF_CH1_INT_RAW field.
	DMA_INT_RAW_CH1_OUT_TOTAL_EOF_CH1_INT_RAW_Msk = 0x100
	// Bit OUT_TOTAL_EOF_CH1_INT_RAW.
	DMA_INT_RAW_CH1_OUT_TOTAL_EOF_CH1_INT_RAW = 0x100
	// Position of INFIFO_OVF_CH1_INT_RAW field.
	DMA_INT_RAW_CH1_INFIFO_OVF_CH1_INT_RAW_Pos = 0x9
	// Bit mask of INFIFO_OVF_CH1_INT_RAW field.
	DMA_INT_RAW_CH1_INFIFO_OVF_CH1_INT_RAW_Msk = 0x200
	// Bit INFIFO_OVF_CH1_INT_RAW.
	DMA_INT_RAW_CH1_INFIFO_OVF_CH1_INT_RAW = 0x200
	// Position of INFIFO_UDF_CH1_INT_RAW field.
	DMA_INT_RAW_CH1_INFIFO_UDF_CH1_INT_RAW_Pos = 0xa
	// Bit mask of INFIFO_UDF_CH1_INT_RAW field.
	DMA_INT_RAW_CH1_INFIFO_UDF_CH1_INT_RAW_Msk = 0x400
	// Bit INFIFO_UDF_CH1_INT_RAW.
	DMA_INT_RAW_CH1_INFIFO_UDF_CH1_INT_RAW = 0x400
	// Position of OUTFIFO_OVF_CH1_INT_RAW field.
	DMA_INT_RAW_CH1_OUTFIFO_OVF_CH1_INT_RAW_Pos = 0xb
	// Bit mask of OUTFIFO_OVF_CH1_INT_RAW field.
	DMA_INT_RAW_CH1_OUTFIFO_OVF_CH1_INT_RAW_Msk = 0x800
	// Bit OUTFIFO_OVF_CH1_INT_RAW.
	DMA_INT_RAW_CH1_OUTFIFO_OVF_CH1_INT_RAW = 0x800
	// Position of OUTFIFO_UDF_CH1_INT_RAW field.
	DMA_INT_RAW_CH1_OUTFIFO_UDF_CH1_INT_RAW_Pos = 0xc
	// Bit mask of OUTFIFO_UDF_CH1_INT_RAW field.
	DMA_INT_RAW_CH1_OUTFIFO_UDF_CH1_INT_RAW_Msk = 0x1000
	// Bit OUTFIFO_UDF_CH1_INT_RAW.
	DMA_INT_RAW_CH1_OUTFIFO_UDF_CH1_INT_RAW = 0x1000

	// INT_ST_CH1: DMA_INT_ST_CH1_REG.
	// Position of IN_DONE_CH1_INT_ST field.
	DMA_INT_ST_CH1_IN_DONE_CH1_INT_ST_Pos = 0x0
	// Bit mask of IN_DONE_CH1_INT_ST field.
	DMA_INT_ST_CH1_IN_DONE_CH1_INT_ST_Msk = 0x1
	// Bit IN_DONE_CH1_INT_ST.
	DMA_INT_ST_CH1_IN_DONE_CH1_INT_ST = 0x1
	// Position of IN_SUC_EOF_CH1_INT_ST field.
	DMA_INT_ST_CH1_IN_SUC_EOF_CH1_INT_ST_Pos = 0x1
	// Bit mask of IN_SUC_EOF_CH1_INT_ST field.
	DMA_INT_ST_CH1_IN_SUC_EOF_CH1_INT_ST_Msk = 0x2
	// Bit IN_SUC_EOF_CH1_INT_ST.
	DMA_INT_ST_CH1_IN_SUC_EOF_CH1_INT_ST = 0x2
	// Position of IN_ERR_EOF_CH1_INT_ST field.
	DMA_INT_ST_CH1_IN_ERR_EOF_CH1_INT_ST_Pos = 0x2
	// Bit mask of IN_ERR_EOF_CH1_INT_ST field.
	DMA_INT_ST_CH1_IN_ERR_EOF_CH1_INT_ST_Msk = 0x4
	// Bit IN_ERR_EOF_CH1_INT_ST.
	DMA_INT_ST_CH1_IN_ERR_EOF_CH1_INT_ST = 0x4
	// Position of OUT_DONE_CH1_INT_ST field.
	DMA_INT_ST_CH1_OUT_DONE_CH1_INT_ST_Pos = 0x3
	// Bit mask of OUT_DONE_CH1_INT_ST field.
	DMA_INT_ST_CH1_OUT_DONE_CH1_INT_ST_Msk = 0x8
	// Bit OUT_DONE_CH1_INT_ST.
	DMA_INT_ST_CH1_OUT_DONE_CH1_INT_ST = 0x8
	// Position of OUT_EOF_CH1_INT_ST field.
	DMA_INT_ST_CH1_OUT_EOF_CH1_INT_ST_Pos = 0x4
	// Bit mask of OUT_EOF_CH1_INT_ST field.
	DMA_INT_ST_CH1_OUT_EOF_CH1_INT_ST_Msk = 0x10
	// Bit OUT_EOF_CH1_INT_ST.
	DMA_INT_ST_CH1_OUT_EOF_CH1_INT_ST = 0x10
	// Position of IN_DSCR_ERR_CH1_INT_ST field.
	DMA_INT_ST_CH1_IN_DSCR_ERR_CH1_INT_ST_Pos = 0x5
	// Bit mask of IN_DSCR_ERR_CH1_INT_ST field.
	DMA_INT_ST_CH1_IN_DSCR_ERR_CH1_INT_ST_Msk = 0x20
	// Bit IN_DSCR_ERR_CH1_INT_ST.
	DMA_INT_ST_CH1_IN_DSCR_ERR_CH1_INT_ST = 0x20
	// Position of OUT_DSCR_ERR_CH1_INT_ST field.
	DMA_INT_ST_CH1_OUT_DSCR_ERR_CH1_INT_ST_Pos = 0x6
	// Bit mask of OUT_DSCR_ERR_CH1_INT_ST field.
	DMA_INT_ST_CH1_OUT_DSCR_ERR_CH1_INT_ST_Msk = 0x40
	// Bit OUT_DSCR_ERR_CH1_INT_ST.
	DMA_INT_ST_CH1_OUT_DSCR_ERR_CH1_INT_ST = 0x40
	// Position of IN_DSCR_EMPTY_CH1_INT_ST field.
	DMA_INT_ST_CH1_IN_DSCR_EMPTY_CH1_INT_ST_Pos = 0x7
	// Bit mask of IN_DSCR_EMPTY_CH1_INT_ST field.
	DMA_INT_ST_CH1_IN_DSCR_EMPTY_CH1_INT_ST_Msk = 0x80
	// Bit IN_DSCR_EMPTY_CH1_INT_ST.
	DMA_INT_ST_CH1_IN_DSCR_EMPTY_CH1_INT_ST = 0x80
	// Position of OUT_TOTAL_EOF_CH1_INT_ST field.
	DMA_INT_ST_CH1_OUT_TOTAL_EOF_CH1_INT_ST_Pos = 0x8
	// Bit mask of OUT_TOTAL_EOF_CH1_INT_ST field.
	DMA_INT_ST_CH1_OUT_TOTAL_EOF_CH1_INT_ST_Msk = 0x100
	// Bit OUT_TOTAL_EOF_CH1_INT_ST.
	DMA_INT_ST_CH1_OUT_TOTAL_EOF_CH1_INT_ST = 0x100
	// Position of INFIFO_OVF_CH1_INT_ST field.
	DMA_INT_ST_CH1_INFIFO_OVF_CH1_INT_ST_Pos = 0x9
	// Bit mask of INFIFO_OVF_CH1_INT_ST field.
	DMA_INT_ST_CH1_INFIFO_OVF_CH1_INT_ST_Msk = 0x200
	// Bit INFIFO_OVF_CH1_INT_ST.
	DMA_INT_ST_CH1_INFIFO_OVF_CH1_INT_ST = 0x200
	// Position of INFIFO_UDF_CH1_INT_ST field.
	DMA_INT_ST_CH1_INFIFO_UDF_CH1_INT_ST_Pos = 0xa
	// Bit mask of INFIFO_UDF_CH1_INT_ST field.
	DMA_INT_ST_CH1_INFIFO_UDF_CH1_INT_ST_Msk = 0x400
	// Bit INFIFO_UDF_CH1_INT_ST.
	DMA_INT_ST_CH1_INFIFO_UDF_CH1_INT_ST = 0x400
	// Position of OUTFIFO_OVF_CH1_INT_ST field.
	DMA_INT_ST_CH1_OUTFIFO_OVF_CH1_INT_ST_Pos = 0xb
	// Bit mask of OUTFIFO_OVF_CH1_INT_ST field.
	DMA_INT_ST_CH1_OUTFIFO_OVF_CH1_INT_ST_Msk = 0x800
	// Bit OUTFIFO_OVF_CH1_INT_ST.
	DMA_INT_ST_CH1_OUTFIFO_OVF_CH1_INT_ST = 0x800
	// Position of OUTFIFO_UDF_CH1_INT_ST field.
	DMA_INT_ST_CH1_OUTFIFO_UDF_CH1_INT_ST_Pos = 0xc
	// Bit mask of OUTFIFO_UDF_CH1_INT_ST field.
	DMA_INT_ST_CH1_OUTFIFO_UDF_CH1_INT_ST_Msk = 0x1000
	// Bit OUTFIFO_UDF_CH1_INT_ST.
	DMA_INT_ST_CH1_OUTFIFO_UDF_CH1_INT_ST = 0x1000

	// INT_ENA_CH1: DMA_INT_ENA_CH1_REG.
	// Position of IN_DONE_CH1_INT_ENA field.
	DMA_INT_ENA_CH1_IN_DONE_CH1_INT_ENA_Pos = 0x0
	// Bit mask of IN_DONE_CH1_INT_ENA field.
	DMA_INT_ENA_CH1_IN_DONE_CH1_INT_ENA_Msk = 0x1
	// Bit IN_DONE_CH1_INT_ENA.
	DMA_INT_ENA_CH1_IN_DONE_CH1_INT_ENA = 0x1
	// Position of IN_SUC_EOF_CH1_INT_ENA field.
	DMA_INT_ENA_CH1_IN_SUC_EOF_CH1_INT_ENA_Pos = 0x1
	// Bit mask of IN_SUC_EOF_CH1_INT_ENA field.
	DMA_INT_ENA_CH1_IN_SUC_EOF_CH1_INT_ENA_Msk = 0x2
	// Bit IN_SUC_EOF_CH1_INT_ENA.
	DMA_INT_ENA_CH1_IN_SUC_EOF_CH1_INT_ENA = 0x2
	// Position of IN_ERR_EOF_CH1_INT_ENA field.
	DMA_INT_ENA_CH1_IN_ERR_EOF_CH1_INT_ENA_Pos = 0x2
	// Bit mask of IN_ERR_EOF_CH1_INT_ENA field.
	DMA_INT_ENA_CH1_IN_ERR_EOF_CH1_INT_ENA_Msk = 0x4
	// Bit IN_ERR_EOF_CH1_INT_ENA.
	DMA_INT_ENA_CH1_IN_ERR_EOF_CH1_INT_ENA = 0x4
	// Position of OUT_DONE_CH1_INT_ENA field.
	DMA_INT_ENA_CH1_OUT_DONE_CH1_INT_ENA_Pos = 0x3
	// Bit mask of OUT_DONE_CH1_INT_ENA field.
	DMA_INT_ENA_CH1_OUT_DONE_CH1_INT_ENA_Msk = 0x8
	// Bit OUT_DONE_CH1_INT_ENA.
	DMA_INT_ENA_CH1_OUT_DONE_CH1_INT_ENA = 0x8
	// Position of OUT_EOF_CH1_INT_ENA field.
	DMA_INT_ENA_CH1_OUT_EOF_CH1_INT_ENA_Pos = 0x4
	// Bit mask of OUT_EOF_CH1_INT_ENA field.
	DMA_INT_ENA_CH1_OUT_EOF_CH1_INT_ENA_Msk = 0x10
	// Bit OUT_EOF_CH1_INT_ENA.
	DMA_INT_ENA_CH1_OUT_EOF_CH1_INT_ENA = 0x10
	// Position of IN_DSCR_ERR_CH1_INT_ENA field.
	DMA_INT_ENA_CH1_IN_DSCR_ERR_CH1_INT_ENA_Pos = 0x5
	// Bit mask of IN_DSCR_ERR_CH1_INT_ENA field.
	DMA_INT_ENA_CH1_IN_DSCR_ERR_CH1_INT_ENA_Msk = 0x20
	// Bit IN_DSCR_ERR_CH1_INT_ENA.
	DMA_INT_ENA_CH1_IN_DSCR_ERR_CH1_INT_ENA = 0x20
	// Position of OUT_DSCR_ERR_CH1_INT_ENA field.
	DMA_INT_ENA_CH1_OUT_DSCR_ERR_CH1_INT_ENA_Pos = 0x6
	// Bit mask of OUT_DSCR_ERR_CH1_INT_ENA field.
	DMA_INT_ENA_CH1_OUT_DSCR_ERR_CH1_INT_ENA_Msk = 0x40
	// Bit OUT_DSCR_ERR_CH1_INT_ENA.
	DMA_INT_ENA_CH1_OUT_DSCR_ERR_CH1_INT_ENA = 0x40
	// Position of IN_DSCR_EMPTY_CH1_INT_ENA field.
	DMA_INT_ENA_CH1_IN_DSCR_EMPTY_CH1_INT_ENA_Pos = 0x7
	// Bit mask of IN_DSCR_EMPTY_CH1_INT_ENA field.
	DMA_INT_ENA_CH1_IN_DSCR_EMPTY_CH1_INT_ENA_Msk = 0x80
	// Bit IN_DSCR_EMPTY_CH1_INT_ENA.
	DMA_INT_ENA_CH1_IN_DSCR_EMPTY_CH1_INT_ENA = 0x80
	// Position of OUT_TOTAL_EOF_CH1_INT_ENA field.
	DMA_INT_ENA_CH1_OUT_TOTAL_EOF_CH1_INT_ENA_Pos = 0x8
	// Bit mask of OUT_TOTAL_EOF_CH1_INT_ENA field.
	DMA_INT_ENA_CH1_OUT_TOTAL_EOF_CH1_INT_ENA_Msk = 0x100
	// Bit OUT_TOTAL_EOF_CH1_INT_ENA.
	DMA_INT_ENA_CH1_OUT_TOTAL_EOF_CH1_INT_ENA = 0x100
	// Position of INFIFO_OVF_CH1_INT_ENA field.
	DMA_INT_ENA_CH1_INFIFO_OVF_CH1_INT_ENA_Pos = 0x9
	// Bit mask of INFIFO_OVF_CH1_INT_ENA field.
	DMA_INT_ENA_CH1_INFIFO_OVF_CH1_INT_ENA_Msk = 0x200
	// Bit INFIFO_OVF_CH1_INT_ENA.
	DMA_INT_ENA_CH1_INFIFO_OVF_CH1_INT_ENA = 0x200
	// Position of INFIFO_UDF_CH1_INT_ENA field.
	DMA_INT_ENA_CH1_INFIFO_UDF_CH1_INT_ENA_Pos = 0xa
	// Bit mask of INFIFO_UDF_CH1_INT_ENA field.
	DMA_INT_ENA_CH1_INFIFO_UDF_CH1_INT_ENA_Msk = 0x400
	// Bit INFIFO_UDF_CH1_INT_ENA.
	DMA_INT_ENA_CH1_INFIFO_UDF_CH1_INT_ENA = 0x400
	// Position of OUTFIFO_OVF_CH1_INT_ENA field.
	DMA_INT_ENA_CH1_OUTFIFO_OVF_CH1_INT_ENA_Pos = 0xb
	// Bit mask of OUTFIFO_OVF_CH1_INT_ENA field.
	DMA_INT_ENA_CH1_OUTFIFO_OVF_CH1_INT_ENA_Msk = 0x800
	// Bit OUTFIFO_OVF_CH1_INT_ENA.
	DMA_INT_ENA_CH1_OUTFIFO_OVF_CH1_INT_ENA = 0x800
	// Position of OUTFIFO_UDF_CH1_INT_ENA field.
	DMA_INT_ENA_CH1_OUTFIFO_UDF_CH1_INT_ENA_Pos = 0xc
	// Bit mask of OUTFIFO_UDF_CH1_INT_ENA field.
	DMA_INT_ENA_CH1_OUTFIFO_UDF_CH1_INT_ENA_Msk = 0x1000
	// Bit OUTFIFO_UDF_CH1_INT_ENA.
	DMA_INT_ENA_CH1_OUTFIFO_UDF_CH1_INT_ENA = 0x1000

	// INT_CLR_CH1: DMA_INT_CLR_CH1_REG.
	// Position of IN_DONE_CH1_INT_CLR field.
	DMA_INT_CLR_CH1_IN_DONE_CH1_INT_CLR_Pos = 0x0
	// Bit mask of IN_DONE_CH1_INT_CLR field.
	DMA_INT_CLR_CH1_IN_DONE_CH1_INT_CLR_Msk = 0x1
	// Bit IN_DONE_CH1_INT_CLR.
	DMA_INT_CLR_CH1_IN_DONE_CH1_INT_CLR = 0x1
	// Position of IN_SUC_EOF_CH1_INT_CLR field.
	DMA_INT_CLR_CH1_IN_SUC_EOF_CH1_INT_CLR_Pos = 0x1
	// Bit mask of IN_SUC_EOF_CH1_INT_CLR field.
	DMA_INT_CLR_CH1_IN_SUC_EOF_CH1_INT_CLR_Msk = 0x2
	// Bit IN_SUC_EOF_CH1_INT_CLR.
	DMA_INT_CLR_CH1_IN_SUC_EOF_CH1_INT_CLR = 0x2
	// Position of IN_ERR_EOF_CH1_INT_CLR field.
	DMA_INT_CLR_CH1_IN_ERR_EOF_CH1_INT_CLR_Pos = 0x2
	// Bit mask of IN_ERR_EOF_CH1_INT_CLR field.
	DMA_INT_CLR_CH1_IN_ERR_EOF_CH1_INT_CLR_Msk = 0x4
	// Bit IN_ERR_EOF_CH1_INT_CLR.
	DMA_INT_CLR_CH1_IN_ERR_EOF_CH1_INT_CLR = 0x4
	// Position of OUT_DONE_CH1_INT_CLR field.
	DMA_INT_CLR_CH1_OUT_DONE_CH1_INT_CLR_Pos = 0x3
	// Bit mask of OUT_DONE_CH1_INT_CLR field.
	DMA_INT_CLR_CH1_OUT_DONE_CH1_INT_CLR_Msk = 0x8
	// Bit OUT_DONE_CH1_INT_CLR.
	DMA_INT_CLR_CH1_OUT_DONE_CH1_INT_CLR = 0x8
	// Position of OUT_EOF_CH1_INT_CLR field.
	DMA_INT_CLR_CH1_OUT_EOF_CH1_INT_CLR_Pos = 0x4
	// Bit mask of OUT_EOF_CH1_INT_CLR field.
	DMA_INT_CLR_CH1_OUT_EOF_CH1_INT_CLR_Msk = 0x10
	// Bit OUT_EOF_CH1_INT_CLR.
	DMA_INT_CLR_CH1_OUT_EOF_CH1_INT_CLR = 0x10
	// Position of IN_DSCR_ERR_CH1_INT_CLR field.
	DMA_INT_CLR_CH1_IN_DSCR_ERR_CH1_INT_CLR_Pos = 0x5
	// Bit mask of IN_DSCR_ERR_CH1_INT_CLR field.
	DMA_INT_CLR_CH1_IN_DSCR_ERR_CH1_INT_CLR_Msk = 0x20
	// Bit IN_DSCR_ERR_CH1_INT_CLR.
	DMA_INT_CLR_CH1_IN_DSCR_ERR_CH1_INT_CLR = 0x20
	// Position of OUT_DSCR_ERR_CH1_INT_CLR field.
	DMA_INT_CLR_CH1_OUT_DSCR_ERR_CH1_INT_CLR_Pos = 0x6
	// Bit mask of OUT_DSCR_ERR_CH1_INT_CLR field.
	DMA_INT_CLR_CH1_OUT_DSCR_ERR_CH1_INT_CLR_Msk = 0x40
	// Bit OUT_DSCR_ERR_CH1_INT_CLR.
	DMA_INT_CLR_CH1_OUT_DSCR_ERR_CH1_INT_CLR = 0x40
	// Position of IN_DSCR_EMPTY_CH1_INT_CLR field.
	DMA_INT_CLR_CH1_IN_DSCR_EMPTY_CH1_INT_CLR_Pos = 0x7
	// Bit mask of IN_DSCR_EMPTY_CH1_INT_CLR field.
	DMA_INT_CLR_CH1_IN_DSCR_EMPTY_CH1_INT_CLR_Msk = 0x80
	// Bit IN_DSCR_EMPTY_CH1_INT_CLR.
	DMA_INT_CLR_CH1_IN_DSCR_EMPTY_CH1_INT_CLR = 0x80
	// Position of OUT_TOTAL_EOF_CH1_INT_CLR field.
	DMA_INT_CLR_CH1_OUT_TOTAL_EOF_CH1_INT_CLR_Pos = 0x8
	// Bit mask of OUT_TOTAL_EOF_CH1_INT_CLR field.
	DMA_INT_CLR_CH1_OUT_TOTAL_EOF_CH1_INT_CLR_Msk = 0x100
	// Bit OUT_TOTAL_EOF_CH1_INT_CLR.
	DMA_INT_CLR_CH1_OUT_TOTAL_EOF_CH1_INT_CLR = 0x100
	// Position of INFIFO_OVF_CH1_INT_CLR field.
	DMA_INT_CLR_CH1_INFIFO_OVF_CH1_INT_CLR_Pos = 0x9
	// Bit mask of INFIFO_OVF_CH1_INT_CLR field.
	DMA_INT_CLR_CH1_INFIFO_OVF_CH1_INT_CLR_Msk = 0x200
	// Bit INFIFO_OVF_CH1_INT_CLR.
	DMA_INT_CLR_CH1_INFIFO_OVF_CH1_INT_CLR = 0x200
	// Position of INFIFO_UDF_CH1_INT_CLR field.
	DMA_INT_CLR_CH1_INFIFO_UDF_CH1_INT_CLR_Pos = 0xa
	// Bit mask of INFIFO_UDF_CH1_INT_CLR field.
	DMA_INT_CLR_CH1_INFIFO_UDF_CH1_INT_CLR_Msk = 0x400
	// Bit INFIFO_UDF_CH1_INT_CLR.
	DMA_INT_CLR_CH1_INFIFO_UDF_CH1_INT_CLR = 0x400
	// Position of OUTFIFO_OVF_CH1_INT_CLR field.
	DMA_INT_CLR_CH1_OUTFIFO_OVF_CH1_INT_CLR_Pos = 0xb
	// Bit mask of OUTFIFO_OVF_CH1_INT_CLR field.
	DMA_INT_CLR_CH1_OUTFIFO_OVF_CH1_INT_CLR_Msk = 0x800
	// Bit OUTFIFO_OVF_CH1_INT_CLR.
	DMA_INT_CLR_CH1_OUTFIFO_OVF_CH1_INT_CLR = 0x800
	// Position of OUTFIFO_UDF_CH1_INT_CLR field.
	DMA_INT_CLR_CH1_OUTFIFO_UDF_CH1_INT_CLR_Pos = 0xc
	// Bit mask of OUTFIFO_UDF_CH1_INT_CLR field.
	DMA_INT_CLR_CH1_OUTFIFO_UDF_CH1_INT_CLR_Msk = 0x1000
	// Bit OUTFIFO_UDF_CH1_INT_CLR.
	DMA_INT_CLR_CH1_OUTFIFO_UDF_CH1_INT_CLR = 0x1000

	// INT_RAW_CH2: DMA_INT_RAW_CH2_REG.
	// Position of IN_DONE_CH2_INT_RAW field.
	DMA_INT_RAW_CH2_IN_DONE_CH2_INT_RAW_Pos = 0x0
	// Bit mask of IN_DONE_CH2_INT_RAW field.
	DMA_INT_RAW_CH2_IN_DONE_CH2_INT_RAW_Msk = 0x1
	// Bit IN_DONE_CH2_INT_RAW.
	DMA_INT_RAW_CH2_IN_DONE_CH2_INT_RAW = 0x1
	// Position of IN_SUC_EOF_CH2_INT_RAW field.
	DMA_INT_RAW_CH2_IN_SUC_EOF_CH2_INT_RAW_Pos = 0x1
	// Bit mask of IN_SUC_EOF_CH2_INT_RAW field.
	DMA_INT_RAW_CH2_IN_SUC_EOF_CH2_INT_RAW_Msk = 0x2
	// Bit IN_SUC_EOF_CH2_INT_RAW.
	DMA_INT_RAW_CH2_IN_SUC_EOF_CH2_INT_RAW = 0x2
	// Position of IN_ERR_EOF_CH2_INT_RAW field.
	DMA_INT_RAW_CH2_IN_ERR_EOF_CH2_INT_RAW_Pos = 0x2
	// Bit mask of IN_ERR_EOF_CH2_INT_RAW field.
	DMA_INT_RAW_CH2_IN_ERR_EOF_CH2_INT_RAW_Msk = 0x4
	// Bit IN_ERR_EOF_CH2_INT_RAW.
	DMA_INT_RAW_CH2_IN_ERR_EOF_CH2_INT_RAW = 0x4
	// Position of OUT_DONE_CH2_INT_RAW field.
	DMA_INT_RAW_CH2_OUT_DONE_CH2_INT_RAW_Pos = 0x3
	// Bit mask of OUT_DONE_CH2_INT_RAW field.
	DMA_INT_RAW_CH2_OUT_DONE_CH2_INT_RAW_Msk = 0x8
	// Bit OUT_DONE_CH2_INT_RAW.
	DMA_INT_RAW_CH2_OUT_DONE_CH2_INT_RAW = 0x8
	// Position of OUT_EOF_CH2_INT_RAW field.
	DMA_INT_RAW_CH2_OUT_EOF_CH2_INT_RAW_Pos = 0x4
	// Bit mask of OUT_EOF_CH2_INT_RAW field.
	DMA_INT_RAW_CH2_OUT_EOF_CH2_INT_RAW_Msk = 0x10
	// Bit OUT_EOF_CH2_INT_RAW.
	DMA_INT_RAW_CH2_OUT_EOF_CH2_INT_RAW = 0x10
	// Position of IN_DSCR_ERR_CH2_INT_RAW field.
	DMA_INT_RAW_CH2_IN_DSCR_ERR_CH2_INT_RAW_Pos = 0x5
	// Bit mask of IN_DSCR_ERR_CH2_INT_RAW field.
	DMA_INT_RAW_CH2_IN_DSCR_ERR_CH2_INT_RAW_Msk = 0x20
	// Bit IN_DSCR_ERR_CH2_INT_RAW.
	DMA_INT_RAW_CH2_IN_DSCR_ERR_CH2_INT_RAW = 0x20
	// Position of OUT_DSCR_ERR_CH2_INT_RAW field.
	DMA_INT_RAW_CH2_OUT_DSCR_ERR_CH2_INT_RAW_Pos = 0x6
	// Bit mask of OUT_DSCR_ERR_CH2_INT_RAW field.
	DMA_INT_RAW_CH2_OUT_DSCR_ERR_CH2_INT_RAW_Msk = 0x40
	// Bit OUT_DSCR_ERR_CH2_INT_RAW.
	DMA_INT_RAW_CH2_OUT_DSCR_ERR_CH2_INT_RAW = 0x40
	// Position of IN_DSCR_EMPTY_CH2_INT_RAW field.
	DMA_INT_RAW_CH2_IN_DSCR_EMPTY_CH2_INT_RAW_Pos = 0x7
	// Bit mask of IN_DSCR_EMPTY_CH2_INT_RAW field.
	DMA_INT_RAW_CH2_IN_DSCR_EMPTY_CH2_INT_RAW_Msk = 0x80
	// Bit IN_DSCR_EMPTY_CH2_INT_RAW.
	DMA_INT_RAW_CH2_IN_DSCR_EMPTY_CH2_INT_RAW = 0x80
	// Position of OUT_TOTAL_EOF_CH2_INT_RAW field.
	DMA_INT_RAW_CH2_OUT_TOTAL_EOF_CH2_INT_RAW_Pos = 0x8
	// Bit mask of OUT_TOTAL_EOF_CH2_INT_RAW field.
	DMA_INT_RAW_CH2_OUT_TOTAL_EOF_CH2_INT_RAW_Msk = 0x100
	// Bit OUT_TOTAL_EOF_CH2_INT_RAW.
	DMA_INT_RAW_CH2_OUT_TOTAL_EOF_CH2_INT_RAW = 0x100
	// Position of INFIFO_OVF_CH2_INT_RAW field.
	DMA_INT_RAW_CH2_INFIFO_OVF_CH2_INT_RAW_Pos = 0x9
	// Bit mask of INFIFO_OVF_CH2_INT_RAW field.
	DMA_INT_RAW_CH2_INFIFO_OVF_CH2_INT_RAW_Msk = 0x200
	// Bit INFIFO_OVF_CH2_INT_RAW.
	DMA_INT_RAW_CH2_INFIFO_OVF_CH2_INT_RAW = 0x200
	// Position of INFIFO_UDF_CH2_INT_RAW field.
	DMA_INT_RAW_CH2_INFIFO_UDF_CH2_INT_RAW_Pos = 0xa
	// Bit mask of INFIFO_UDF_CH2_INT_RAW field.
	DMA_INT_RAW_CH2_INFIFO_UDF_CH2_INT_RAW_Msk = 0x400
	// Bit INFIFO_UDF_CH2_INT_RAW.
	DMA_INT_RAW_CH2_INFIFO_UDF_CH2_INT_RAW = 0x400
	// Position of OUTFIFO_OVF_CH2_INT_RAW field.
	DMA_INT_RAW_CH2_OUTFIFO_OVF_CH2_INT_RAW_Pos = 0xb
	// Bit mask of OUTFIFO_OVF_CH2_INT_RAW field.
	DMA_INT_RAW_CH2_OUTFIFO_OVF_CH2_INT_RAW_Msk = 0x800
	// Bit OUTFIFO_OVF_CH2_INT_RAW.
	DMA_INT_RAW_CH2_OUTFIFO_OVF_CH2_INT_RAW = 0x800
	// Position of OUTFIFO_UDF_CH2_INT_RAW field.
	DMA_INT_RAW_CH2_OUTFIFO_UDF_CH2_INT_RAW_Pos = 0xc
	// Bit mask of OUTFIFO_UDF_CH2_INT_RAW field.
	DMA_INT_RAW_CH2_OUTFIFO_UDF_CH2_INT_RAW_Msk = 0x1000
	// Bit OUTFIFO_UDF_CH2_INT_RAW.
	DMA_INT_RAW_CH2_OUTFIFO_UDF_CH2_INT_RAW = 0x1000

	// INT_ST_CH2: DMA_INT_ST_CH2_REG.
	// Position of IN_DONE_CH2_INT_ST field.
	DMA_INT_ST_CH2_IN_DONE_CH2_INT_ST_Pos = 0x0
	// Bit mask of IN_DONE_CH2_INT_ST field.
	DMA_INT_ST_CH2_IN_DONE_CH2_INT_ST_Msk = 0x1
	// Bit IN_DONE_CH2_INT_ST.
	DMA_INT_ST_CH2_IN_DONE_CH2_INT_ST = 0x1
	// Position of IN_SUC_EOF_CH2_INT_ST field.
	DMA_INT_ST_CH2_IN_SUC_EOF_CH2_INT_ST_Pos = 0x1
	// Bit mask of IN_SUC_EOF_CH2_INT_ST field.
	DMA_INT_ST_CH2_IN_SUC_EOF_CH2_INT_ST_Msk = 0x2
	// Bit IN_SUC_EOF_CH2_INT_ST.
	DMA_INT_ST_CH2_IN_SUC_EOF_CH2_INT_ST = 0x2
	// Position of IN_ERR_EOF_CH2_INT_ST field.
	DMA_INT_ST_CH2_IN_ERR_EOF_CH2_INT_ST_Pos = 0x2
	// Bit mask of IN_ERR_EOF_CH2_INT_ST field.
	DMA_INT_ST_CH2_IN_ERR_EOF_CH2_INT_ST_Msk = 0x4
	// Bit IN_ERR_EOF_CH2_INT_ST.
	DMA_INT_ST_CH2_IN_ERR_EOF_CH2_INT_ST = 0x4
	// Position of OUT_DONE_CH2_INT_ST field.
	DMA_INT_ST_CH2_OUT_DONE_CH2_INT_ST_Pos = 0x3
	// Bit mask of OUT_DONE_CH2_INT_ST field.
	DMA_INT_ST_CH2_OUT_DONE_CH2_INT_ST_Msk = 0x8
	// Bit OUT_DONE_CH2_INT_ST.
	DMA_INT_ST_CH2_OUT_DONE_CH2_INT_ST = 0x8
	// Position of OUT_EOF_CH2_INT_ST field.
	DMA_INT_ST_CH2_OUT_EOF_CH2_INT_ST_Pos = 0x4
	// Bit mask of OUT_EOF_CH2_INT_ST field.
	DMA_INT_ST_CH2_OUT_EOF_CH2_INT_ST_Msk = 0x10
	// Bit OUT_EOF_CH2_INT_ST.
	DMA_INT_ST_CH2_OUT_EOF_CH2_INT_ST = 0x10
	// Position of IN_DSCR_ERR_CH2_INT_ST field.
	DMA_INT_ST_CH2_IN_DSCR_ERR_CH2_INT_ST_Pos = 0x5
	// Bit mask of IN_DSCR_ERR_CH2_INT_ST field.
	DMA_INT_ST_CH2_IN_DSCR_ERR_CH2_INT_ST_Msk = 0x20
	// Bit IN_DSCR_ERR_CH2_INT_ST.
	DMA_INT_ST_CH2_IN_DSCR_ERR_CH2_INT_ST = 0x20
	// Position of OUT_DSCR_ERR_CH2_INT_ST field.
	DMA_INT_ST_CH2_OUT_DSCR_ERR_CH2_INT_ST_Pos = 0x6
	// Bit mask of OUT_DSCR_ERR_CH2_INT_ST field.
	DMA_INT_ST_CH2_OUT_DSCR_ERR_CH2_INT_ST_Msk = 0x40
	// Bit OUT_DSCR_ERR_CH2_INT_ST.
	DMA_INT_ST_CH2_OUT_DSCR_ERR_CH2_INT_ST = 0x40
	// Position of IN_DSCR_EMPTY_CH2_INT_ST field.
	DMA_INT_ST_CH2_IN_DSCR_EMPTY_CH2_INT_ST_Pos = 0x7
	// Bit mask of IN_DSCR_EMPTY_CH2_INT_ST field.
	DMA_INT_ST_CH2_IN_DSCR_EMPTY_CH2_INT_ST_Msk = 0x80
	// Bit IN_DSCR_EMPTY_CH2_INT_ST.
	DMA_INT_ST_CH2_IN_DSCR_EMPTY_CH2_INT_ST = 0x80
	// Position of OUT_TOTAL_EOF_CH2_INT_ST field.
	DMA_INT_ST_CH2_OUT_TOTAL_EOF_CH2_INT_ST_Pos = 0x8
	// Bit mask of OUT_TOTAL_EOF_CH2_INT_ST field.
	DMA_INT_ST_CH2_OUT_TOTAL_EOF_CH2_INT_ST_Msk = 0x100
	// Bit OUT_TOTAL_EOF_CH2_INT_ST.
	DMA_INT_ST_CH2_OUT_TOTAL_EOF_CH2_INT_ST = 0x100
	// Position of INFIFO_OVF_CH2_INT_ST field.
	DMA_INT_ST_CH2_INFIFO_OVF_CH2_INT_ST_Pos = 0x9
	// Bit mask of INFIFO_OVF_CH2_INT_ST field.
	DMA_INT_ST_CH2_INFIFO_OVF_CH2_INT_ST_Msk = 0x200
	// Bit INFIFO_OVF_CH2_INT_ST.
	DMA_INT_ST_CH2_INFIFO_OVF_CH2_INT_ST = 0x200
	// Position of INFIFO_UDF_CH2_INT_ST field.
	DMA_INT_ST_CH2_INFIFO_UDF_CH2_INT_ST_Pos = 0xa
	// Bit mask of INFIFO_UDF_CH2_INT_ST field.
	DMA_INT_ST_CH2_INFIFO_UDF_CH2_INT_ST_Msk = 0x400
	// Bit INFIFO_UDF_CH2_INT_ST.
	DMA_INT_ST_CH2_INFIFO_UDF_CH2_INT_ST = 0x400
	// Position of OUTFIFO_OVF_CH2_INT_ST field.
	DMA_INT_ST_CH2_OUTFIFO_OVF_CH2_INT_ST_Pos = 0xb
	// Bit mask of OUTFIFO_OVF_CH2_INT_ST field.
	DMA_INT_ST_CH2_OUTFIFO_OVF_CH2_INT_ST_Msk = 0x800
	// Bit OUTFIFO_OVF_CH2_INT_ST.
	DMA_INT_ST_CH2_OUTFIFO_OVF_CH2_INT_ST = 0x800
	// Position of OUTFIFO_UDF_CH2_INT_ST field.
	DMA_INT_ST_CH2_OUTFIFO_UDF_CH2_INT_ST_Pos = 0xc
	// Bit mask of OUTFIFO_UDF_CH2_INT_ST field.
	DMA_INT_ST_CH2_OUTFIFO_UDF_CH2_INT_ST_Msk = 0x1000
	// Bit OUTFIFO_UDF_CH2_INT_ST.
	DMA_INT_ST_CH2_OUTFIFO_UDF_CH2_INT_ST = 0x1000

	// INT_ENA_CH2: DMA_INT_ENA_CH2_REG.
	// Position of IN_DONE_CH2_INT_ENA field.
	DMA_INT_ENA_CH2_IN_DONE_CH2_INT_ENA_Pos = 0x0
	// Bit mask of IN_DONE_CH2_INT_ENA field.
	DMA_INT_ENA_CH2_IN_DONE_CH2_INT_ENA_Msk = 0x1
	// Bit IN_DONE_CH2_INT_ENA.
	DMA_INT_ENA_CH2_IN_DONE_CH2_INT_ENA = 0x1
	// Position of IN_SUC_EOF_CH2_INT_ENA field.
	DMA_INT_ENA_CH2_IN_SUC_EOF_CH2_INT_ENA_Pos = 0x1
	// Bit mask of IN_SUC_EOF_CH2_INT_ENA field.
	DMA_INT_ENA_CH2_IN_SUC_EOF_CH2_INT_ENA_Msk = 0x2
	// Bit IN_SUC_EOF_CH2_INT_ENA.
	DMA_INT_ENA_CH2_IN_SUC_EOF_CH2_INT_ENA = 0x2
	// Position of IN_ERR_EOF_CH2_INT_ENA field.
	DMA_INT_ENA_CH2_IN_ERR_EOF_CH2_INT_ENA_Pos = 0x2
	// Bit mask of IN_ERR_EOF_CH2_INT_ENA field.
	DMA_INT_ENA_CH2_IN_ERR_EOF_CH2_INT_ENA_Msk = 0x4
	// Bit IN_ERR_EOF_CH2_INT_ENA.
	DMA_INT_ENA_CH2_IN_ERR_EOF_CH2_INT_ENA = 0x4
	// Position of OUT_DONE_CH2_INT_ENA field.
	DMA_INT_ENA_CH2_OUT_DONE_CH2_INT_ENA_Pos = 0x3
	// Bit mask of OUT_DONE_CH2_INT_ENA field.
	DMA_INT_ENA_CH2_OUT_DONE_CH2_INT_ENA_Msk = 0x8
	// Bit OUT_DONE_CH2_INT_ENA.
	DMA_INT_ENA_CH2_OUT_DONE_CH2_INT_ENA = 0x8
	// Position of OUT_EOF_CH2_INT_ENA field.
	DMA_INT_ENA_CH2_OUT_EOF_CH2_INT_ENA_Pos = 0x4
	// Bit mask of OUT_EOF_CH2_INT_ENA field.
	DMA_INT_ENA_CH2_OUT_EOF_CH2_INT_ENA_Msk = 0x10
	// Bit OUT_EOF_CH2_INT_ENA.
	DMA_INT_ENA_CH2_OUT_EOF_CH2_INT_ENA = 0x10
	// Position of IN_DSCR_ERR_CH2_INT_ENA field.
	DMA_INT_ENA_CH2_IN_DSCR_ERR_CH2_INT_ENA_Pos = 0x5
	// Bit mask of IN_DSCR_ERR_CH2_INT_ENA field.
	DMA_INT_ENA_CH2_IN_DSCR_ERR_CH2_INT_ENA_Msk = 0x20
	// Bit IN_DSCR_ERR_CH2_INT_ENA.
	DMA_INT_ENA_CH2_IN_DSCR_ERR_CH2_INT_ENA = 0x20
	// Position of OUT_DSCR_ERR_CH2_INT_ENA field.
	DMA_INT_ENA_CH2_OUT_DSCR_ERR_CH2_INT_ENA_Pos = 0x6
	// Bit mask of OUT_DSCR_ERR_CH2_INT_ENA field.
	DMA_INT_ENA_CH2_OUT_DSCR_ERR_CH2_INT_ENA_Msk = 0x40
	// Bit OUT_DSCR_ERR_CH2_INT_ENA.
	DMA_INT_ENA_CH2_OUT_DSCR_ERR_CH2_INT_ENA = 0x40
	// Position of IN_DSCR_EMPTY_CH2_INT_ENA field.
	DMA_INT_ENA_CH2_IN_DSCR_EMPTY_CH2_INT_ENA_Pos = 0x7
	// Bit mask of IN_DSCR_EMPTY_CH2_INT_ENA field.
	DMA_INT_ENA_CH2_IN_DSCR_EMPTY_CH2_INT_ENA_Msk = 0x80
	// Bit IN_DSCR_EMPTY_CH2_INT_ENA.
	DMA_INT_ENA_CH2_IN_DSCR_EMPTY_CH2_INT_ENA = 0x80
	// Position of OUT_TOTAL_EOF_CH2_INT_ENA field.
	DMA_INT_ENA_CH2_OUT_TOTAL_EOF_CH2_INT_ENA_Pos = 0x8
	// Bit mask of OUT_TOTAL_EOF_CH2_INT_ENA field.
	DMA_INT_ENA_CH2_OUT_TOTAL_EOF_CH2_INT_ENA_Msk = 0x100
	// Bit OUT_TOTAL_EOF_CH2_INT_ENA.
	DMA_INT_ENA_CH2_OUT_TOTAL_EOF_CH2_INT_ENA = 0x100
	// Position of INFIFO_OVF_CH2_INT_ENA field.
	DMA_INT_ENA_CH2_INFIFO_OVF_CH2_INT_ENA_Pos = 0x9
	// Bit mask of INFIFO_OVF_CH2_INT_ENA field.
	DMA_INT_ENA_CH2_INFIFO_OVF_CH2_INT_ENA_Msk = 0x200
	// Bit INFIFO_OVF_CH2_INT_ENA.
	DMA_INT_ENA_CH2_INFIFO_OVF_CH2_INT_ENA = 0x200
	// Position of INFIFO_UDF_CH2_INT_ENA field.
	DMA_INT_ENA_CH2_INFIFO_UDF_CH2_INT_ENA_Pos = 0xa
	// Bit mask of INFIFO_UDF_CH2_INT_ENA field.
	DMA_INT_ENA_CH2_INFIFO_UDF_CH2_INT_ENA_Msk = 0x400
	// Bit INFIFO_UDF_CH2_INT_ENA.
	DMA_INT_ENA_CH2_INFIFO_UDF_CH2_INT_ENA = 0x400
	// Position of OUTFIFO_OVF_CH2_INT_ENA field.
	DMA_INT_ENA_CH2_OUTFIFO_OVF_CH2_INT_ENA_Pos = 0xb
	// Bit mask of OUTFIFO_OVF_CH2_INT_ENA field.
	DMA_INT_ENA_CH2_OUTFIFO_OVF_CH2_INT_ENA_Msk = 0x800
	// Bit OUTFIFO_OVF_CH2_INT_ENA.
	DMA_INT_ENA_CH2_OUTFIFO_OVF_CH2_INT_ENA = 0x800
	// Position of OUTFIFO_UDF_CH2_INT_ENA field.
	DMA_INT_ENA_CH2_OUTFIFO_UDF_CH2_INT_ENA_Pos = 0xc
	// Bit mask of OUTFIFO_UDF_CH2_INT_ENA field.
	DMA_INT_ENA_CH2_OUTFIFO_UDF_CH2_INT_ENA_Msk = 0x1000
	// Bit OUTFIFO_UDF_CH2_INT_ENA.
	DMA_INT_ENA_CH2_OUTFIFO_UDF_CH2_INT_ENA = 0x1000

	// INT_CLR_CH2: DMA_INT_CLR_CH2_REG.
	// Position of IN_DONE_CH2_INT_CLR field.
	DMA_INT_CLR_CH2_IN_DONE_CH2_INT_CLR_Pos = 0x0
	// Bit mask of IN_DONE_CH2_INT_CLR field.
	DMA_INT_CLR_CH2_IN_DONE_CH2_INT_CLR_Msk = 0x1
	// Bit IN_DONE_CH2_INT_CLR.
	DMA_INT_CLR_CH2_IN_DONE_CH2_INT_CLR = 0x1
	// Position of IN_SUC_EOF_CH2_INT_CLR field.
	DMA_INT_CLR_CH2_IN_SUC_EOF_CH2_INT_CLR_Pos = 0x1
	// Bit mask of IN_SUC_EOF_CH2_INT_CLR field.
	DMA_INT_CLR_CH2_IN_SUC_EOF_CH2_INT_CLR_Msk = 0x2
	// Bit IN_SUC_EOF_CH2_INT_CLR.
	DMA_INT_CLR_CH2_IN_SUC_EOF_CH2_INT_CLR = 0x2
	// Position of IN_ERR_EOF_CH2_INT_CLR field.
	DMA_INT_CLR_CH2_IN_ERR_EOF_CH2_INT_CLR_Pos = 0x2
	// Bit mask of IN_ERR_EOF_CH2_INT_CLR field.
	DMA_INT_CLR_CH2_IN_ERR_EOF_CH2_INT_CLR_Msk = 0x4
	// Bit IN_ERR_EOF_CH2_INT_CLR.
	DMA_INT_CLR_CH2_IN_ERR_EOF_CH2_INT_CLR = 0x4
	// Position of OUT_DONE_CH2_INT_CLR field.
	DMA_INT_CLR_CH2_OUT_DONE_CH2_INT_CLR_Pos = 0x3
	// Bit mask of OUT_DONE_CH2_INT_CLR field.
	DMA_INT_CLR_CH2_OUT_DONE_CH2_INT_CLR_Msk = 0x8
	// Bit OUT_DONE_CH2_INT_CLR.
	DMA_INT_CLR_CH2_OUT_DONE_CH2_INT_CLR = 0x8
	// Position of OUT_EOF_CH2_INT_CLR field.
	DMA_INT_CLR_CH2_OUT_EOF_CH2_INT_CLR_Pos = 0x4
	// Bit mask of OUT_EOF_CH2_INT_CLR field.
	DMA_INT_CLR_CH2_OUT_EOF_CH2_INT_CLR_Msk = 0x10
	// Bit OUT_EOF_CH2_INT_CLR.
	DMA_INT_CLR_CH2_OUT_EOF_CH2_INT_CLR = 0x10
	// Position of IN_DSCR_ERR_CH2_INT_CLR field.
	DMA_INT_CLR_CH2_IN_DSCR_ERR_CH2_INT_CLR_Pos = 0x5
	// Bit mask of IN_DSCR_ERR_CH2_INT_CLR field.
	DMA_INT_CLR_CH2_IN_DSCR_ERR_CH2_INT_CLR_Msk = 0x20
	// Bit IN_DSCR_ERR_CH2_INT_CLR.
	DMA_INT_CLR_CH2_IN_DSCR_ERR_CH2_INT_CLR = 0x20
	// Position of OUT_DSCR_ERR_CH2_INT_CLR field.
	DMA_INT_CLR_CH2_OUT_DSCR_ERR_CH2_INT_CLR_Pos = 0x6
	// Bit mask of OUT_DSCR_ERR_CH2_INT_CLR field.
	DMA_INT_CLR_CH2_OUT_DSCR_ERR_CH2_INT_CLR_Msk = 0x40
	// Bit OUT_DSCR_ERR_CH2_INT_CLR.
	DMA_INT_CLR_CH2_OUT_DSCR_ERR_CH2_INT_CLR = 0x40
	// Position of IN_DSCR_EMPTY_CH2_INT_CLR field.
	DMA_INT_CLR_CH2_IN_DSCR_EMPTY_CH2_INT_CLR_Pos = 0x7
	// Bit mask of IN_DSCR_EMPTY_CH2_INT_CLR field.
	DMA_INT_CLR_CH2_IN_DSCR_EMPTY_CH2_INT_CLR_Msk = 0x80
	// Bit IN_DSCR_EMPTY_CH2_INT_CLR.
	DMA_INT_CLR_CH2_IN_DSCR_EMPTY_CH2_INT_CLR = 0x80
	// Position of OUT_TOTAL_EOF_CH2_INT_CLR field.
	DMA_INT_CLR_CH2_OUT_TOTAL_EOF_CH2_INT_CLR_Pos = 0x8
	// Bit mask of OUT_TOTAL_EOF_CH2_INT_CLR field.
	DMA_INT_CLR_CH2_OUT_TOTAL_EOF_CH2_INT_CLR_Msk = 0x100
	// Bit OUT_TOTAL_EOF_CH2_INT_CLR.
	DMA_INT_CLR_CH2_OUT_TOTAL_EOF_CH2_INT_CLR = 0x100
	// Position of INFIFO_OVF_CH2_INT_CLR field.
	DMA_INT_CLR_CH2_INFIFO_OVF_CH2_INT_CLR_Pos = 0x9
	// Bit mask of INFIFO_OVF_CH2_INT_CLR field.
	DMA_INT_CLR_CH2_INFIFO_OVF_CH2_INT_CLR_Msk = 0x200
	// Bit INFIFO_OVF_CH2_INT_CLR.
	DMA_INT_CLR_CH2_INFIFO_OVF_CH2_INT_CLR = 0x200
	// Position of INFIFO_UDF_CH2_INT_CLR field.
	DMA_INT_CLR_CH2_INFIFO_UDF_CH2_INT_CLR_Pos = 0xa
	// Bit mask of INFIFO_UDF_CH2_INT_CLR field.
	DMA_INT_CLR_CH2_INFIFO_UDF_CH2_INT_CLR_Msk = 0x400
	// Bit INFIFO_UDF_CH2_INT_CLR.
	DMA_INT_CLR_CH2_INFIFO_UDF_CH2_INT_CLR = 0x400
	// Position of OUTFIFO_OVF_CH2_INT_CLR field.
	DMA_INT_CLR_CH2_OUTFIFO_OVF_CH2_INT_CLR_Pos = 0xb
	// Bit mask of OUTFIFO_OVF_CH2_INT_CLR field.
	DMA_INT_CLR_CH2_OUTFIFO_OVF_CH2_INT_CLR_Msk = 0x800
	// Bit OUTFIFO_OVF_CH2_INT_CLR.
	DMA_INT_CLR_CH2_OUTFIFO_OVF_CH2_INT_CLR = 0x800
	// Position of OUTFIFO_UDF_CH2_INT_CLR field.
	DMA_INT_CLR_CH2_OUTFIFO_UDF_CH2_INT_CLR_Pos = 0xc
	// Bit mask of OUTFIFO_UDF_CH2_INT_CLR field.
	DMA_INT_CLR_CH2_OUTFIFO_UDF_CH2_INT_CLR_Msk = 0x1000
	// Bit OUTFIFO_UDF_CH2_INT_CLR.
	DMA_INT_CLR_CH2_OUTFIFO_UDF_CH2_INT_CLR = 0x1000

	// AHB_TEST: DMA_AHB_TEST_REG.
	// Position of AHB_TESTMODE field.
	DMA_AHB_TEST_AHB_TESTMODE_Pos = 0x0
	// Bit mask of AHB_TESTMODE field.
	DMA_AHB_TEST_AHB_TESTMODE_Msk = 0x7
	// Position of AHB_TESTADDR field.
	DMA_AHB_TEST_AHB_TESTADDR_Pos = 0x4
	// Bit mask of AHB_TESTADDR field.
	DMA_AHB_TEST_AHB_TESTADDR_Msk = 0x30

	// MISC_CONF: DMA_MISC_CONF_REG.
	// Position of AHBM_RST_INTER field.
	DMA_MISC_CONF_AHBM_RST_INTER_Pos = 0x0
	// Bit mask of AHBM_RST_INTER field.
	DMA_MISC_CONF_AHBM_RST_INTER_Msk = 0x1
	// Bit AHBM_RST_INTER.
	DMA_MISC_CONF_AHBM_RST_INTER = 0x1
	// Position of ARB_PRI_DIS field.
	DMA_MISC_CONF_ARB_PRI_DIS_Pos = 0x2
	// Bit mask of ARB_PRI_DIS field.
	DMA_MISC_CONF_ARB_PRI_DIS_Msk = 0x4
	// Bit ARB_PRI_DIS.
	DMA_MISC_CONF_ARB_PRI_DIS = 0x4
	// Position of CLK_EN field.
	DMA_MISC_CONF_CLK_EN_Pos = 0x3
	// Bit mask of CLK_EN field.
	DMA_MISC_CONF_CLK_EN_Msk = 0x8
	// Bit CLK_EN.
	DMA_MISC_CONF_CLK_EN = 0x8

	// DATE: DMA_DATE_REG.
	// Position of DATE field.
	DMA_DATE_DATE_Pos = 0x0
	// Bit mask of DATE field.
	DMA_DATE_DATE_Msk = 0xffffffff

	// IN_CONF0_CH0: DMA_IN_CONF0_CH0_REG.
	// Position of IN_RST_CH0 field.
	DMA_IN_CONF0_CH0_IN_RST_CH0_Pos = 0x0
	// Bit mask of IN_RST_CH0 field.
	DMA_IN_CONF0_CH0_IN_RST_CH0_Msk = 0x1
	// Bit IN_RST_CH0.
	DMA_IN_CONF0_CH0_IN_RST_CH0 = 0x1
	// Position of IN_LOOP_TEST_CH0 field.
	DMA_IN_CONF0_CH0_IN_LOOP_TEST_CH0_Pos = 0x1
	// Bit mask of IN_LOOP_TEST_CH0 field.
	DMA_IN_CONF0_CH0_IN_LOOP_TEST_CH0_Msk = 0x2
	// Bit IN_LOOP_TEST_CH0.
	DMA_IN_CONF0_CH0_IN_LOOP_TEST_CH0 = 0x2
	// Position of INDSCR_BURST_EN_CH0 field.
	DMA_IN_CONF0_CH0_INDSCR_BURST_EN_CH0_Pos = 0x2
	// Bit mask of INDSCR_BURST_EN_CH0 field.
	DMA_IN_CONF0_CH0_INDSCR_BURST_EN_CH0_Msk = 0x4
	// Bit INDSCR_BURST_EN_CH0.
	DMA_IN_CONF0_CH0_INDSCR_BURST_EN_CH0 = 0x4
	// Position of IN_DATA_BURST_EN_CH0 field.
	DMA_IN_CONF0_CH0_IN_DATA_BURST_EN_CH0_Pos = 0x3
	// Bit mask of IN_DATA_BURST_EN_CH0 field.
	DMA_IN_CONF0_CH0_IN_DATA_BURST_EN_CH0_Msk = 0x8
	// Bit IN_DATA_BURST_EN_CH0.
	DMA_IN_CONF0_CH0_IN_DATA_BURST_EN_CH0 = 0x8
	// Position of MEM_TRANS_EN_CH0 field.
	DMA_IN_CONF0_CH0_MEM_TRANS_EN_CH0_Pos = 0x4
	// Bit mask of MEM_TRANS_EN_CH0 field.
	DMA_IN_CONF0_CH0_MEM_TRANS_EN_CH0_Msk = 0x10
	// Bit MEM_TRANS_EN_CH0.
	DMA_IN_CONF0_CH0_MEM_TRANS_EN_CH0 = 0x10

	// IN_CONF1_CH0: DMA_IN_CONF1_CH0_REG.
	// Position of IN_CHECK_OWNER_CH0 field.
	DMA_IN_CONF1_CH0_IN_CHECK_OWNER_CH0_Pos = 0xc
	// Bit mask of IN_CHECK_OWNER_CH0 field.
	DMA_IN_CONF1_CH0_IN_CHECK_OWNER_CH0_Msk = 0x1000
	// Bit IN_CHECK_OWNER_CH0.
	DMA_IN_CONF1_CH0_IN_CHECK_OWNER_CH0 = 0x1000

	// INFIFO_STATUS_CH0: DMA_INFIFO_STATUS_CH0_REG.
	// Position of INFIFO_FULL_CH0 field.
	DMA_INFIFO_STATUS_CH0_INFIFO_FULL_CH0_Pos = 0x0
	// Bit mask of INFIFO_FULL_CH0 field.
	DMA_INFIFO_STATUS_CH0_INFIFO_FULL_CH0_Msk = 0x1
	// Bit INFIFO_FULL_CH0.
	DMA_INFIFO_STATUS_CH0_INFIFO_FULL_CH0 = 0x1
	// Position of INFIFO_EMPTY_CH0 field.
	DMA_INFIFO_STATUS_CH0_INFIFO_EMPTY_CH0_Pos = 0x1
	// Bit mask of INFIFO_EMPTY_CH0 field.
	DMA_INFIFO_STATUS_CH0_INFIFO_EMPTY_CH0_Msk = 0x2
	// Bit INFIFO_EMPTY_CH0.
	DMA_INFIFO_STATUS_CH0_INFIFO_EMPTY_CH0 = 0x2
	// Position of INFIFO_CNT_CH0 field.
	DMA_INFIFO_STATUS_CH0_INFIFO_CNT_CH0_Pos = 0x2
	// Bit mask of INFIFO_CNT_CH0 field.
	DMA_INFIFO_STATUS_CH0_INFIFO_CNT_CH0_Msk = 0xfc
	// Position of IN_REMAIN_UNDER_1B_CH0 field.
	DMA_INFIFO_STATUS_CH0_IN_REMAIN_UNDER_1B_CH0_Pos = 0x17
	// Bit mask of IN_REMAIN_UNDER_1B_CH0 field.
	DMA_INFIFO_STATUS_CH0_IN_REMAIN_UNDER_1B_CH0_Msk = 0x800000
	// Bit IN_REMAIN_UNDER_1B_CH0.
	DMA_INFIFO_STATUS_CH0_IN_REMAIN_UNDER_1B_CH0 = 0x800000
	// Position of IN_REMAIN_UNDER_2B_CH0 field.
	DMA_INFIFO_STATUS_CH0_IN_REMAIN_UNDER_2B_CH0_Pos = 0x18
	// Bit mask of IN_REMAIN_UNDER_2B_CH0 field.
	DMA_INFIFO_STATUS_CH0_IN_REMAIN_UNDER_2B_CH0_Msk = 0x1000000
	// Bit IN_REMAIN_UNDER_2B_CH0.
	DMA_INFIFO_STATUS_CH0_IN_REMAIN_UNDER_2B_CH0 = 0x1000000
	// Position of IN_REMAIN_UNDER_3B_CH0 field.
	DMA_INFIFO_STATUS_CH0_IN_REMAIN_UNDER_3B_CH0_Pos = 0x19
	// Bit mask of IN_REMAIN_UNDER_3B_CH0 field.
	DMA_INFIFO_STATUS_CH0_IN_REMAIN_UNDER_3B_CH0_Msk = 0x2000000
	// Bit IN_REMAIN_UNDER_3B_CH0.
	DMA_INFIFO_STATUS_CH0_IN_REMAIN_UNDER_3B_CH0 = 0x2000000
	// Position of IN_REMAIN_UNDER_4B_CH0 field.
	DMA_INFIFO_STATUS_CH0_IN_REMAIN_UNDER_4B_CH0_Pos = 0x1a
	// Bit mask of IN_REMAIN_UNDER_4B_CH0 field.
	DMA_INFIFO_STATUS_CH0_IN_REMAIN_UNDER_4B_CH0_Msk = 0x4000000
	// Bit IN_REMAIN_UNDER_4B_CH0.
	DMA_INFIFO_STATUS_CH0_IN_REMAIN_UNDER_4B_CH0 = 0x4000000
	// Position of IN_BUF_HUNGRY_CH0 field.
	DMA_INFIFO_STATUS_CH0_IN_BUF_HUNGRY_CH0_Pos = 0x1b
	// Bit mask of IN_BUF_HUNGRY_CH0 field.
	DMA_INFIFO_STATUS_CH0_IN_BUF_HUNGRY_CH0_Msk = 0x8000000
	// Bit IN_BUF_HUNGRY_CH0.
	DMA_INFIFO_STATUS_CH0_IN_BUF_HUNGRY_CH0 = 0x8000000

	// IN_POP_CH0: DMA_IN_POP_CH0_REG.
	// Position of INFIFO_RDATA_CH0 field.
	DMA_IN_POP_CH0_INFIFO_RDATA_CH0_Pos = 0x0
	// Bit mask of INFIFO_RDATA_CH0 field.
	DMA_IN_POP_CH0_INFIFO_RDATA_CH0_Msk = 0xfff
	// Position of INFIFO_POP_CH0 field.
	DMA_IN_POP_CH0_INFIFO_POP_CH0_Pos = 0xc
	// Bit mask of INFIFO_POP_CH0 field.
	DMA_IN_POP_CH0_INFIFO_POP_CH0_Msk = 0x1000
	// Bit INFIFO_POP_CH0.
	DMA_IN_POP_CH0_INFIFO_POP_CH0 = 0x1000

	// IN_LINK_CH0: DMA_IN_LINK_CH0_REG.
	// Position of INLINK_ADDR_CH0 field.
	DMA_IN_LINK_CH0_INLINK_ADDR_CH0_Pos = 0x0
	// Bit mask of INLINK_ADDR_CH0 field.
	DMA_IN_LINK_CH0_INLINK_ADDR_CH0_Msk = 0xfffff
	// Position of INLINK_AUTO_RET_CH0 field.
	DMA_IN_LINK_CH0_INLINK_AUTO_RET_CH0_Pos = 0x14
	// Bit mask of INLINK_AUTO_RET_CH0 field.
	DMA_IN_LINK_CH0_INLINK_AUTO_RET_CH0_Msk = 0x100000
	// Bit INLINK_AUTO_RET_CH0.
	DMA_IN_LINK_CH0_INLINK_AUTO_RET_CH0 = 0x100000
	// Position of INLINK_STOP_CH0 field.
	DMA_IN_LINK_CH0_INLINK_STOP_CH0_Pos = 0x15
	// Bit mask of INLINK_STOP_CH0 field.
	DMA_IN_LINK_CH0_INLINK_STOP_CH0_Msk = 0x200000
	// Bit INLINK_STOP_CH0.
	DMA_IN_LINK_CH0_INLINK_STOP_CH0 = 0x200000
	// Position of INLINK_START_CH0 field.
	DMA_IN_LINK_CH0_INLINK_START_CH0_Pos = 0x16
	// Bit mask of INLINK_START_CH0 field.
	DMA_IN_LINK_CH0_INLINK_START_CH0_Msk = 0x400000
	// Bit INLINK_START_CH0.
	DMA_IN_LINK_CH0_INLINK_START_CH0 = 0x400000
	// Position of INLINK_RESTART_CH0 field.
	DMA_IN_LINK_CH0_INLINK_RESTART_CH0_Pos = 0x17
	// Bit mask of INLINK_RESTART_CH0 field.
	DMA_IN_LINK_CH0_INLINK_RESTART_CH0_Msk = 0x800000
	// Bit INLINK_RESTART_CH0.
	DMA_IN_LINK_CH0_INLINK_RESTART_CH0 = 0x800000
	// Position of INLINK_PARK_CH0 field.
	DMA_IN_LINK_CH0_INLINK_PARK_CH0_Pos = 0x18
	// Bit mask of INLINK_PARK_CH0 field.
	DMA_IN_LINK_CH0_INLINK_PARK_CH0_Msk = 0x1000000
	// Bit INLINK_PARK_CH0.
	DMA_IN_LINK_CH0_INLINK_PARK_CH0 = 0x1000000

	// IN_STATE_CH0: DMA_IN_STATE_CH0_REG.
	// Position of INLINK_DSCR_ADDR_CH0 field.
	DMA_IN_STATE_CH0_INLINK_DSCR_ADDR_CH0_Pos = 0x0
	// Bit mask of INLINK_DSCR_ADDR_CH0 field.
	DMA_IN_STATE_CH0_INLINK_DSCR_ADDR_CH0_Msk = 0x3ffff
	// Position of IN_DSCR_STATE_CH0 field.
	DMA_IN_STATE_CH0_IN_DSCR_STATE_CH0_Pos = 0x12
	// Bit mask of IN_DSCR_STATE_CH0 field.
	DMA_IN_STATE_CH0_IN_DSCR_STATE_CH0_Msk = 0xc0000
	// Position of IN_STATE_CH0 field.
	DMA_IN_STATE_CH0_IN_STATE_CH0_Pos = 0x14
	// Bit mask of IN_STATE_CH0 field.
	DMA_IN_STATE_CH0_IN_STATE_CH0_Msk = 0x700000

	// IN_SUC_EOF_DES_ADDR_CH0: DMA_IN_SUC_EOF_DES_ADDR_CH0_REG.
	// Position of IN_SUC_EOF_DES_ADDR_CH0 field.
	DMA_IN_SUC_EOF_DES_ADDR_CH0_IN_SUC_EOF_DES_ADDR_CH0_Pos = 0x0
	// Bit mask of IN_SUC_EOF_DES_ADDR_CH0 field.
	DMA_IN_SUC_EOF_DES_ADDR_CH0_IN_SUC_EOF_DES_ADDR_CH0_Msk = 0xffffffff

	// IN_ERR_EOF_DES_ADDR_CH0: DMA_IN_ERR_EOF_DES_ADDR_CH0_REG.
	// Position of IN_ERR_EOF_DES_ADDR_CH0 field.
	DMA_IN_ERR_EOF_DES_ADDR_CH0_IN_ERR_EOF_DES_ADDR_CH0_Pos = 0x0
	// Bit mask of IN_ERR_EOF_DES_ADDR_CH0 field.
	DMA_IN_ERR_EOF_DES_ADDR_CH0_IN_ERR_EOF_DES_ADDR_CH0_Msk = 0xffffffff

	// IN_DSCR_CH0: DMA_IN_DSCR_CH0_REG.
	// Position of INLINK_DSCR_CH0 field.
	DMA_IN_DSCR_CH0_INLINK_DSCR_CH0_Pos = 0x0
	// Bit mask of INLINK_DSCR_CH0 field.
	DMA_IN_DSCR_CH0_INLINK_DSCR_CH0_Msk = 0xffffffff

	// IN_DSCR_BF0_CH0: DMA_IN_DSCR_BF0_CH0_REG.
	// Position of INLINK_DSCR_BF0_CH0 field.
	DMA_IN_DSCR_BF0_CH0_INLINK_DSCR_BF0_CH0_Pos = 0x0
	// Bit mask of INLINK_DSCR_BF0_CH0 field.
	DMA_IN_DSCR_BF0_CH0_INLINK_DSCR_BF0_CH0_Msk = 0xffffffff

	// IN_DSCR_BF1_CH0: DMA_IN_DSCR_BF1_CH0_REG.
	// Position of INLINK_DSCR_BF1_CH0 field.
	DMA_IN_DSCR_BF1_CH0_INLINK_DSCR_BF1_CH0_Pos = 0x0
	// Bit mask of INLINK_DSCR_BF1_CH0 field.
	DMA_IN_DSCR_BF1_CH0_INLINK_DSCR_BF1_CH0_Msk = 0xffffffff

	// IN_PRI_CH0: DMA_IN_PRI_CH0_REG.
	// Position of RX_PRI_CH0 field.
	DMA_IN_PRI_CH0_RX_PRI_CH0_Pos = 0x0
	// Bit mask of RX_PRI_CH0 field.
	DMA_IN_PRI_CH0_RX_PRI_CH0_Msk = 0xf

	// IN_PERI_SEL_CH0: DMA_IN_PERI_SEL_CH0_REG.
	// Position of PERI_IN_SEL_CH0 field.
	DMA_IN_PERI_SEL_CH0_PERI_IN_SEL_CH0_Pos = 0x0
	// Bit mask of PERI_IN_SEL_CH0 field.
	DMA_IN_PERI_SEL_CH0_PERI_IN_SEL_CH0_Msk = 0x3f

	// OUT_CONF0_CH0: DMA_OUT_CONF0_CH0_REG.
	// Position of OUT_RST_CH0 field.
	DMA_OUT_CONF0_CH0_OUT_RST_CH0_Pos = 0x0
	// Bit mask of OUT_RST_CH0 field.
	DMA_OUT_CONF0_CH0_OUT_RST_CH0_Msk = 0x1
	// Bit OUT_RST_CH0.
	DMA_OUT_CONF0_CH0_OUT_RST_CH0 = 0x1
	// Position of OUT_LOOP_TEST_CH0 field.
	DMA_OUT_CONF0_CH0_OUT_LOOP_TEST_CH0_Pos = 0x1
	// Bit mask of OUT_LOOP_TEST_CH0 field.
	DMA_OUT_CONF0_CH0_OUT_LOOP_TEST_CH0_Msk = 0x2
	// Bit OUT_LOOP_TEST_CH0.
	DMA_OUT_CONF0_CH0_OUT_LOOP_TEST_CH0 = 0x2
	// Position of OUT_AUTO_WRBACK_CH0 field.
	DMA_OUT_CONF0_CH0_OUT_AUTO_WRBACK_CH0_Pos = 0x2
	// Bit mask of OUT_AUTO_WRBACK_CH0 field.
	DMA_OUT_CONF0_CH0_OUT_AUTO_WRBACK_CH0_Msk = 0x4
	// Bit OUT_AUTO_WRBACK_CH0.
	DMA_OUT_CONF0_CH0_OUT_AUTO_WRBACK_CH0 = 0x4
	// Position of OUT_EOF_MODE_CH0 field.
	DMA_OUT_CONF0_CH0_OUT_EOF_MODE_CH0_Pos = 0x3
	// Bit mask of OUT_EOF_MODE_CH0 field.
	DMA_OUT_CONF0_CH0_OUT_EOF_MODE_CH0_Msk = 0x8
	// Bit OUT_EOF_MODE_CH0.
	DMA_OUT_CONF0_CH0_OUT_EOF_MODE_CH0 = 0x8
	// Position of OUTDSCR_BURST_EN_CH0 field.
	DMA_OUT_CONF0_CH0_OUTDSCR_BURST_EN_CH0_Pos = 0x4
	// Bit mask of OUTDSCR_BURST_EN_CH0 field.
	DMA_OUT_CONF0_CH0_OUTDSCR_BURST_EN_CH0_Msk = 0x10
	// Bit OUTDSCR_BURST_EN_CH0.
	DMA_OUT_CONF0_CH0_OUTDSCR_BURST_EN_CH0 = 0x10
	// Position of OUT_DATA_BURST_EN_CH0 field.
	DMA_OUT_CONF0_CH0_OUT_DATA_BURST_EN_CH0_Pos = 0x5
	// Bit mask of OUT_DATA_BURST_EN_CH0 field.
	DMA_OUT_CONF0_CH0_OUT_DATA_BURST_EN_CH0_Msk = 0x20
	// Bit OUT_DATA_BURST_EN_CH0.
	DMA_OUT_CONF0_CH0_OUT_DATA_BURST_EN_CH0 = 0x20

	// OUT_CONF1_CH0: DMA_OUT_CONF1_CH0_REG.
	// Position of OUT_CHECK_OWNER_CH0 field.
	DMA_OUT_CONF1_CH0_OUT_CHECK_OWNER_CH0_Pos = 0xc
	// Bit mask of OUT_CHECK_OWNER_CH0 field.
	DMA_OUT_CONF1_CH0_OUT_CHECK_OWNER_CH0_Msk = 0x1000
	// Bit OUT_CHECK_OWNER_CH0.
	DMA_OUT_CONF1_CH0_OUT_CHECK_OWNER_CH0 = 0x1000

	// OUTFIFO_STATUS_CH0: DMA_OUTFIFO_STATUS_CH0_REG.
	// Position of OUTFIFO_FULL_CH0 field.
	DMA_OUTFIFO_STATUS_CH0_OUTFIFO_FULL_CH0_Pos = 0x0
	// Bit mask of OUTFIFO_FULL_CH0 field.
	DMA_OUTFIFO_STATUS_CH0_OUTFIFO_FULL_CH0_Msk = 0x1
	// Bit OUTFIFO_FULL_CH0.
	DMA_OUTFIFO_STATUS_CH0_OUTFIFO_FULL_CH0 = 0x1
	// Position of OUTFIFO_EMPTY_CH0 field.
	DMA_OUTFIFO_STATUS_CH0_OUTFIFO_EMPTY_CH0_Pos = 0x1
	// Bit mask of OUTFIFO_EMPTY_CH0 field.
	DMA_OUTFIFO_STATUS_CH0_OUTFIFO_EMPTY_CH0_Msk = 0x2
	// Bit OUTFIFO_EMPTY_CH0.
	DMA_OUTFIFO_STATUS_CH0_OUTFIFO_EMPTY_CH0 = 0x2
	// Position of OUTFIFO_CNT_CH0 field.
	DMA_OUTFIFO_STATUS_CH0_OUTFIFO_CNT_CH0_Pos = 0x2
	// Bit mask of OUTFIFO_CNT_CH0 field.
	DMA_OUTFIFO_STATUS_CH0_OUTFIFO_CNT_CH0_Msk = 0xfc
	// Position of OUT_REMAIN_UNDER_1B_CH0 field.
	DMA_OUTFIFO_STATUS_CH0_OUT_REMAIN_UNDER_1B_CH0_Pos = 0x17
	// Bit mask of OUT_REMAIN_UNDER_1B_CH0 field.
	DMA_OUTFIFO_STATUS_CH0_OUT_REMAIN_UNDER_1B_CH0_Msk = 0x800000
	// Bit OUT_REMAIN_UNDER_1B_CH0.
	DMA_OUTFIFO_STATUS_CH0_OUT_REMAIN_UNDER_1B_CH0 = 0x800000
	// Position of OUT_REMAIN_UNDER_2B_CH0 field.
	DMA_OUTFIFO_STATUS_CH0_OUT_REMAIN_UNDER_2B_CH0_Pos = 0x18
	// Bit mask of OUT_REMAIN_UNDER_2B_CH0 field.
	DMA_OUTFIFO_STATUS_CH0_OUT_REMAIN_UNDER_2B_CH0_Msk = 0x1000000
	// Bit OUT_REMAIN_UNDER_2B_CH0.
	DMA_OUTFIFO_STATUS_CH0_OUT_REMAIN_UNDER_2B_CH0 = 0x1000000
	// Position of OUT_REMAIN_UNDER_3B_CH0 field.
	DMA_OUTFIFO_STATUS_CH0_OUT_REMAIN_UNDER_3B_CH0_Pos = 0x19
	// Bit mask of OUT_REMAIN_UNDER_3B_CH0 field.
	DMA_OUTFIFO_STATUS_CH0_OUT_REMAIN_UNDER_3B_CH0_Msk = 0x2000000
	// Bit OUT_REMAIN_UNDER_3B_CH0.
	DMA_OUTFIFO_STATUS_CH0_OUT_REMAIN_UNDER_3B_CH0 = 0x2000000
	// Position of OUT_REMAIN_UNDER_4B_CH0 field.
	DMA_OUTFIFO_STATUS_CH0_OUT_REMAIN_UNDER_4B_CH0_Pos = 0x1a
	// Bit mask of OUT_REMAIN_UNDER_4B_CH0 field.
	DMA_OUTFIFO_STATUS_CH0_OUT_REMAIN_UNDER_4B_CH0_Msk = 0x4000000
	// Bit OUT_REMAIN_UNDER_4B_CH0.
	DMA_OUTFIFO_STATUS_CH0_OUT_REMAIN_UNDER_4B_CH0 = 0x4000000

	// OUT_PUSH_CH0: DMA_OUT_PUSH_CH0_REG.
	// Position of OUTFIFO_WDATA_CH0 field.
	DMA_OUT_PUSH_CH0_OUTFIFO_WDATA_CH0_Pos = 0x0
	// Bit mask of OUTFIFO_WDATA_CH0 field.
	DMA_OUT_PUSH_CH0_OUTFIFO_WDATA_CH0_Msk = 0x1ff
	// Position of OUTFIFO_PUSH_CH0 field.
	DMA_OUT_PUSH_CH0_OUTFIFO_PUSH_CH0_Pos = 0x9
	// Bit mask of OUTFIFO_PUSH_CH0 field.
	DMA_OUT_PUSH_CH0_OUTFIFO_PUSH_CH0_Msk = 0x200
	// Bit OUTFIFO_PUSH_CH0.
	DMA_OUT_PUSH_CH0_OUTFIFO_PUSH_CH0 = 0x200

	// OUT_LINK_CH0: DMA_OUT_LINK_CH0_REG.
	// Position of OUTLINK_ADDR_CH0 field.
	DMA_OUT_LINK_CH0_OUTLINK_ADDR_CH0_Pos = 0x0
	// Bit mask of OUTLINK_ADDR_CH0 field.
	DMA_OUT_LINK_CH0_OUTLINK_ADDR_CH0_Msk = 0xfffff
	// Position of OUTLINK_STOP_CH0 field.
	DMA_OUT_LINK_CH0_OUTLINK_STOP_CH0_Pos = 0x14
	// Bit mask of OUTLINK_STOP_CH0 field.
	DMA_OUT_LINK_CH0_OUTLINK_STOP_CH0_Msk = 0x100000
	// Bit OUTLINK_STOP_CH0.
	DMA_OUT_LINK_CH0_OUTLINK_STOP_CH0 = 0x100000
	// Position of OUTLINK_START_CH0 field.
	DMA_OUT_LINK_CH0_OUTLINK_START_CH0_Pos = 0x15
	// Bit mask of OUTLINK_START_CH0 field.
	DMA_OUT_LINK_CH0_OUTLINK_START_CH0_Msk = 0x200000
	// Bit OUTLINK_START_CH0.
	DMA_OUT_LINK_CH0_OUTLINK_START_CH0 = 0x200000
	// Position of OUTLINK_RESTART_CH0 field.
	DMA_OUT_LINK_CH0_OUTLINK_RESTART_CH0_Pos = 0x16
	// Bit mask of OUTLINK_RESTART_CH0 field.
	DMA_OUT_LINK_CH0_OUTLINK_RESTART_CH0_Msk = 0x400000
	// Bit OUTLINK_RESTART_CH0.
	DMA_OUT_LINK_CH0_OUTLINK_RESTART_CH0 = 0x400000
	// Position of OUTLINK_PARK_CH0 field.
	DMA_OUT_LINK_CH0_OUTLINK_PARK_CH0_Pos = 0x17
	// Bit mask of OUTLINK_PARK_CH0 field.
	DMA_OUT_LINK_CH0_OUTLINK_PARK_CH0_Msk = 0x800000
	// Bit OUTLINK_PARK_CH0.
	DMA_OUT_LINK_CH0_OUTLINK_PARK_CH0 = 0x800000

	// OUT_STATE_CH0: DMA_OUT_STATE_CH0_REG.
	// Position of OUTLINK_DSCR_ADDR_CH0 field.
	DMA_OUT_STATE_CH0_OUTLINK_DSCR_ADDR_CH0_Pos = 0x0
	// Bit mask of OUTLINK_DSCR_ADDR_CH0 field.
	DMA_OUT_STATE_CH0_OUTLINK_DSCR_ADDR_CH0_Msk = 0x3ffff
	// Position of OUT_DSCR_STATE_CH0 field.
	DMA_OUT_STATE_CH0_OUT_DSCR_STATE_CH0_Pos = 0x12
	// Bit mask of OUT_DSCR_STATE_CH0 field.
	DMA_OUT_STATE_CH0_OUT_DSCR_STATE_CH0_Msk = 0xc0000
	// Position of OUT_STATE_CH0 field.
	DMA_OUT_STATE_CH0_OUT_STATE_CH0_Pos = 0x14
	// Bit mask of OUT_STATE_CH0 field.
	DMA_OUT_STATE_CH0_OUT_STATE_CH0_Msk = 0x700000

	// OUT_EOF_DES_ADDR_CH0: DMA_OUT_EOF_DES_ADDR_CH0_REG.
	// Position of OUT_EOF_DES_ADDR_CH0 field.
	DMA_OUT_EOF_DES_ADDR_CH0_OUT_EOF_DES_ADDR_CH0_Pos = 0x0
	// Bit mask of OUT_EOF_DES_ADDR_CH0 field.
	DMA_OUT_EOF_DES_ADDR_CH0_OUT_EOF_DES_ADDR_CH0_Msk = 0xffffffff

	// OUT_EOF_BFR_DES_ADDR_CH0: DMA_OUT_EOF_BFR_DES_ADDR_CH0_REG.
	// Position of OUT_EOF_BFR_DES_ADDR_CH0 field.
	DMA_OUT_EOF_BFR_DES_ADDR_CH0_OUT_EOF_BFR_DES_ADDR_CH0_Pos = 0x0
	// Bit mask of OUT_EOF_BFR_DES_ADDR_CH0 field.
	DMA_OUT_EOF_BFR_DES_ADDR_CH0_OUT_EOF_BFR_DES_ADDR_CH0_Msk = 0xffffffff

	// OUT_DSCR_CH0: DMA_OUT_DSCR_CH0_REG.
	// Position of OUTLINK_DSCR_CH0 field.
	DMA_OUT_DSCR_CH0_OUTLINK_DSCR_CH0_Pos = 0x0
	// Bit mask of OUTLINK_DSCR_CH0 field.
	DMA_OUT_DSCR_CH0_OUTLINK_DSCR_CH0_Msk = 0xffffffff

	// OUT_DSCR_BF0_CH0: DMA_OUT_DSCR_BF0_CH0_REG.
	// Position of OUTLINK_DSCR_BF0_CH0 field.
	DMA_OUT_DSCR_BF0_CH0_OUTLINK_DSCR_BF0_CH0_Pos = 0x0
	// Bit mask of OUTLINK_DSCR_BF0_CH0 field.
	DMA_OUT_DSCR_BF0_CH0_OUTLINK_DSCR_BF0_CH0_Msk = 0xffffffff

	// OUT_DSCR_BF1_CH0: DMA_OUT_DSCR_BF1_CH0_REG.
	// Position of OUTLINK_DSCR_BF1_CH0 field.
	DMA_OUT_DSCR_BF1_CH0_OUTLINK_DSCR_BF1_CH0_Pos = 0x0
	// Bit mask of OUTLINK_DSCR_BF1_CH0 field.
	DMA_OUT_DSCR_BF1_CH0_OUTLINK_DSCR_BF1_CH0_Msk = 0xffffffff

	// OUT_PRI_CH0: DMA_OUT_PRI_CH0_REG.
	// Position of TX_PRI_CH0 field.
	DMA_OUT_PRI_CH0_TX_PRI_CH0_Pos = 0x0
	// Bit mask of TX_PRI_CH0 field.
	DMA_OUT_PRI_CH0_TX_PRI_CH0_Msk = 0xf

	// OUT_PERI_SEL_CH0: DMA_OUT_PERI_SEL_CH0_REG.
	// Position of PERI_OUT_SEL_CH0 field.
	DMA_OUT_PERI_SEL_CH0_PERI_OUT_SEL_CH0_Pos = 0x0
	// Bit mask of PERI_OUT_SEL_CH0 field.
	DMA_OUT_PERI_SEL_CH0_PERI_OUT_SEL_CH0_Msk = 0x3f

	// IN_CONF0_CH1: DMA_IN_CONF0_CH1_REG.
	// Position of IN_RST_CH1 field.
	DMA_IN_CONF0_CH1_IN_RST_CH1_Pos = 0x0
	// Bit mask of IN_RST_CH1 field.
	DMA_IN_CONF0_CH1_IN_RST_CH1_Msk = 0x1
	// Bit IN_RST_CH1.
	DMA_IN_CONF0_CH1_IN_RST_CH1 = 0x1
	// Position of IN_LOOP_TEST_CH1 field.
	DMA_IN_CONF0_CH1_IN_LOOP_TEST_CH1_Pos = 0x1
	// Bit mask of IN_LOOP_TEST_CH1 field.
	DMA_IN_CONF0_CH1_IN_LOOP_TEST_CH1_Msk = 0x2
	// Bit IN_LOOP_TEST_CH1.
	DMA_IN_CONF0_CH1_IN_LOOP_TEST_CH1 = 0x2
	// Position of INDSCR_BURST_EN_CH1 field.
	DMA_IN_CONF0_CH1_INDSCR_BURST_EN_CH1_Pos = 0x2
	// Bit mask of INDSCR_BURST_EN_CH1 field.
	DMA_IN_CONF0_CH1_INDSCR_BURST_EN_CH1_Msk = 0x4
	// Bit INDSCR_BURST_EN_CH1.
	DMA_IN_CONF0_CH1_INDSCR_BURST_EN_CH1 = 0x4
	// Position of IN_DATA_BURST_EN_CH1 field.
	DMA_IN_CONF0_CH1_IN_DATA_BURST_EN_CH1_Pos = 0x3
	// Bit mask of IN_DATA_BURST_EN_CH1 field.
	DMA_IN_CONF0_CH1_IN_DATA_BURST_EN_CH1_Msk = 0x8
	// Bit IN_DATA_BURST_EN_CH1.
	DMA_IN_CONF0_CH1_IN_DATA_BURST_EN_CH1 = 0x8
	// Position of MEM_TRANS_EN_CH1 field.
	DMA_IN_CONF0_CH1_MEM_TRANS_EN_CH1_Pos = 0x4
	// Bit mask of MEM_TRANS_EN_CH1 field.
	DMA_IN_CONF0_CH1_MEM_TRANS_EN_CH1_Msk = 0x10
	// Bit MEM_TRANS_EN_CH1.
	DMA_IN_CONF0_CH1_MEM_TRANS_EN_CH1 = 0x10

	// IN_CONF1_CH1: DMA_IN_CONF1_CH1_REG.
	// Position of IN_CHECK_OWNER_CH1 field.
	DMA_IN_CONF1_CH1_IN_CHECK_OWNER_CH1_Pos = 0xc
	// Bit mask of IN_CHECK_OWNER_CH1 field.
	DMA_IN_CONF1_CH1_IN_CHECK_OWNER_CH1_Msk = 0x1000
	// Bit IN_CHECK_OWNER_CH1.
	DMA_IN_CONF1_CH1_IN_CHECK_OWNER_CH1 = 0x1000

	// INFIFO_STATUS_CH1: DMA_INFIFO_STATUS_CH1_REG.
	// Position of INFIFO_FULL_CH1 field.
	DMA_INFIFO_STATUS_CH1_INFIFO_FULL_CH1_Pos = 0x0
	// Bit mask of INFIFO_FULL_CH1 field.
	DMA_INFIFO_STATUS_CH1_INFIFO_FULL_CH1_Msk = 0x1
	// Bit INFIFO_FULL_CH1.
	DMA_INFIFO_STATUS_CH1_INFIFO_FULL_CH1 = 0x1
	// Position of INFIFO_EMPTY_CH1 field.
	DMA_INFIFO_STATUS_CH1_INFIFO_EMPTY_CH1_Pos = 0x1
	// Bit mask of INFIFO_EMPTY_CH1 field.
	DMA_INFIFO_STATUS_CH1_INFIFO_EMPTY_CH1_Msk = 0x2
	// Bit INFIFO_EMPTY_CH1.
	DMA_INFIFO_STATUS_CH1_INFIFO_EMPTY_CH1 = 0x2
	// Position of INFIFO_CNT_CH1 field.
	DMA_INFIFO_STATUS_CH1_INFIFO_CNT_CH1_Pos = 0x2
	// Bit mask of INFIFO_CNT_CH1 field.
	DMA_INFIFO_STATUS_CH1_INFIFO_CNT_CH1_Msk = 0xfc
	// Position of IN_REMAIN_UNDER_1B_CH1 field.
	DMA_INFIFO_STATUS_CH1_IN_REMAIN_UNDER_1B_CH1_Pos = 0x17
	// Bit mask of IN_REMAIN_UNDER_1B_CH1 field.
	DMA_INFIFO_STATUS_CH1_IN_REMAIN_UNDER_1B_CH1_Msk = 0x800000
	// Bit IN_REMAIN_UNDER_1B_CH1.
	DMA_INFIFO_STATUS_CH1_IN_REMAIN_UNDER_1B_CH1 = 0x800000
	// Position of IN_REMAIN_UNDER_2B_CH1 field.
	DMA_INFIFO_STATUS_CH1_IN_REMAIN_UNDER_2B_CH1_Pos = 0x18
	// Bit mask of IN_REMAIN_UNDER_2B_CH1 field.
	DMA_INFIFO_STATUS_CH1_IN_REMAIN_UNDER_2B_CH1_Msk = 0x1000000
	// Bit IN_REMAIN_UNDER_2B_CH1.
	DMA_INFIFO_STATUS_CH1_IN_REMAIN_UNDER_2B_CH1 = 0x1000000
	// Position of IN_REMAIN_UNDER_3B_CH1 field.
	DMA_INFIFO_STATUS_CH1_IN_REMAIN_UNDER_3B_CH1_Pos = 0x19
	// Bit mask of IN_REMAIN_UNDER_3B_CH1 field.
	DMA_INFIFO_STATUS_CH1_IN_REMAIN_UNDER_3B_CH1_Msk = 0x2000000
	// Bit IN_REMAIN_UNDER_3B_CH1.
	DMA_INFIFO_STATUS_CH1_IN_REMAIN_UNDER_3B_CH1 = 0x2000000
	// Position of IN_REMAIN_UNDER_4B_CH1 field.
	DMA_INFIFO_STATUS_CH1_IN_REMAIN_UNDER_4B_CH1_Pos = 0x1a
	// Bit mask of IN_REMAIN_UNDER_4B_CH1 field.
	DMA_INFIFO_STATUS_CH1_IN_REMAIN_UNDER_4B_CH1_Msk = 0x4000000
	// Bit IN_REMAIN_UNDER_4B_CH1.
	DMA_INFIFO_STATUS_CH1_IN_REMAIN_UNDER_4B_CH1 = 0x4000000
	// Position of IN_BUF_HUNGRY_CH1 field.
	DMA_INFIFO_STATUS_CH1_IN_BUF_HUNGRY_CH1_Pos = 0x1b
	// Bit mask of IN_BUF_HUNGRY_CH1 field.
	DMA_INFIFO_STATUS_CH1_IN_BUF_HUNGRY_CH1_Msk = 0x8000000
	// Bit IN_BUF_HUNGRY_CH1.
	DMA_INFIFO_STATUS_CH1_IN_BUF_HUNGRY_CH1 = 0x8000000

	// IN_POP_CH1: DMA_IN_POP_CH1_REG.
	// Position of INFIFO_RDATA_CH1 field.
	DMA_IN_POP_CH1_INFIFO_RDATA_CH1_Pos = 0x0
	// Bit mask of INFIFO_RDATA_CH1 field.
	DMA_IN_POP_CH1_INFIFO_RDATA_CH1_Msk = 0xfff
	// Position of INFIFO_POP_CH1 field.
	DMA_IN_POP_CH1_INFIFO_POP_CH1_Pos = 0xc
	// Bit mask of INFIFO_POP_CH1 field.
	DMA_IN_POP_CH1_INFIFO_POP_CH1_Msk = 0x1000
	// Bit INFIFO_POP_CH1.
	DMA_IN_POP_CH1_INFIFO_POP_CH1 = 0x1000

	// IN_LINK_CH1: DMA_IN_LINK_CH1_REG.
	// Position of INLINK_ADDR_CH1 field.
	DMA_IN_LINK_CH1_INLINK_ADDR_CH1_Pos = 0x0
	// Bit mask of INLINK_ADDR_CH1 field.
	DMA_IN_LINK_CH1_INLINK_ADDR_CH1_Msk = 0xfffff
	// Position of INLINK_AUTO_RET_CH1 field.
	DMA_IN_LINK_CH1_INLINK_AUTO_RET_CH1_Pos = 0x14
	// Bit mask of INLINK_AUTO_RET_CH1 field.
	DMA_IN_LINK_CH1_INLINK_AUTO_RET_CH1_Msk = 0x100000
	// Bit INLINK_AUTO_RET_CH1.
	DMA_IN_LINK_CH1_INLINK_AUTO_RET_CH1 = 0x100000
	// Position of INLINK_STOP_CH1 field.
	DMA_IN_LINK_CH1_INLINK_STOP_CH1_Pos = 0x15
	// Bit mask of INLINK_STOP_CH1 field.
	DMA_IN_LINK_CH1_INLINK_STOP_CH1_Msk = 0x200000
	// Bit INLINK_STOP_CH1.
	DMA_IN_LINK_CH1_INLINK_STOP_CH1 = 0x200000
	// Position of INLINK_START_CH1 field.
	DMA_IN_LINK_CH1_INLINK_START_CH1_Pos = 0x16
	// Bit mask of INLINK_START_CH1 field.
	DMA_IN_LINK_CH1_INLINK_START_CH1_Msk = 0x400000
	// Bit INLINK_START_CH1.
	DMA_IN_LINK_CH1_INLINK_START_CH1 = 0x400000
	// Position of INLINK_RESTART_CH1 field.
	DMA_IN_LINK_CH1_INLINK_RESTART_CH1_Pos = 0x17
	// Bit mask of INLINK_RESTART_CH1 field.
	DMA_IN_LINK_CH1_INLINK_RESTART_CH1_Msk = 0x800000
	// Bit INLINK_RESTART_CH1.
	DMA_IN_LINK_CH1_INLINK_RESTART_CH1 = 0x800000
	// Position of INLINK_PARK_CH1 field.
	DMA_IN_LINK_CH1_INLINK_PARK_CH1_Pos = 0x18
	// Bit mask of INLINK_PARK_CH1 field.
	DMA_IN_LINK_CH1_INLINK_PARK_CH1_Msk = 0x1000000
	// Bit INLINK_PARK_CH1.
	DMA_IN_LINK_CH1_INLINK_PARK_CH1 = 0x1000000

	// IN_STATE_CH1: DMA_IN_STATE_CH1_REG.
	// Position of INLINK_DSCR_ADDR_CH1 field.
	DMA_IN_STATE_CH1_INLINK_DSCR_ADDR_CH1_Pos = 0x0
	// Bit mask of INLINK_DSCR_ADDR_CH1 field.
	DMA_IN_STATE_CH1_INLINK_DSCR_ADDR_CH1_Msk = 0x3ffff
	// Position of IN_DSCR_STATE_CH1 field.
	DMA_IN_STATE_CH1_IN_DSCR_STATE_CH1_Pos = 0x12
	// Bit mask of IN_DSCR_STATE_CH1 field.
	DMA_IN_STATE_CH1_IN_DSCR_STATE_CH1_Msk = 0xc0000
	// Position of IN_STATE_CH1 field.
	DMA_IN_STATE_CH1_IN_STATE_CH1_Pos = 0x14
	// Bit mask of IN_STATE_CH1 field.
	DMA_IN_STATE_CH1_IN_STATE_CH1_Msk = 0x700000

	// IN_SUC_EOF_DES_ADDR_CH1: DMA_IN_SUC_EOF_DES_ADDR_CH1_REG.
	// Position of IN_SUC_EOF_DES_ADDR_CH1 field.
	DMA_IN_SUC_EOF_DES_ADDR_CH1_IN_SUC_EOF_DES_ADDR_CH1_Pos = 0x0
	// Bit mask of IN_SUC_EOF_DES_ADDR_CH1 field.
	DMA_IN_SUC_EOF_DES_ADDR_CH1_IN_SUC_EOF_DES_ADDR_CH1_Msk = 0xffffffff

	// IN_ERR_EOF_DES_ADDR_CH1: DMA_IN_ERR_EOF_DES_ADDR_CH1_REG.
	// Position of IN_ERR_EOF_DES_ADDR_CH1 field.
	DMA_IN_ERR_EOF_DES_ADDR_CH1_IN_ERR_EOF_DES_ADDR_CH1_Pos = 0x0
	// Bit mask of IN_ERR_EOF_DES_ADDR_CH1 field.
	DMA_IN_ERR_EOF_DES_ADDR_CH1_IN_ERR_EOF_DES_ADDR_CH1_Msk = 0xffffffff

	// IN_DSCR_CH1: DMA_IN_DSCR_CH1_REG.
	// Position of INLINK_DSCR_CH1 field.
	DMA_IN_DSCR_CH1_INLINK_DSCR_CH1_Pos = 0x0
	// Bit mask of INLINK_DSCR_CH1 field.
	DMA_IN_DSCR_CH1_INLINK_DSCR_CH1_Msk = 0xffffffff

	// IN_DSCR_BF0_CH1: DMA_IN_DSCR_BF0_CH1_REG.
	// Position of INLINK_DSCR_BF0_CH1 field.
	DMA_IN_DSCR_BF0_CH1_INLINK_DSCR_BF0_CH1_Pos = 0x0
	// Bit mask of INLINK_DSCR_BF0_CH1 field.
	DMA_IN_DSCR_BF0_CH1_INLINK_DSCR_BF0_CH1_Msk = 0xffffffff

	// IN_DSCR_BF1_CH1: DMA_IN_DSCR_BF1_CH1_REG.
	// Position of INLINK_DSCR_BF1_CH1 field.
	DMA_IN_DSCR_BF1_CH1_INLINK_DSCR_BF1_CH1_Pos = 0x0
	// Bit mask of INLINK_DSCR_BF1_CH1 field.
	DMA_IN_DSCR_BF1_CH1_INLINK_DSCR_BF1_CH1_Msk = 0xffffffff

	// IN_PRI_CH1: DMA_IN_PRI_CH1_REG.
	// Position of RX_PRI_CH1 field.
	DMA_IN_PRI_CH1_RX_PRI_CH1_Pos = 0x0
	// Bit mask of RX_PRI_CH1 field.
	DMA_IN_PRI_CH1_RX_PRI_CH1_Msk = 0xf

	// IN_PERI_SEL_CH1: DMA_IN_PERI_SEL_CH1_REG.
	// Position of PERI_IN_SEL_CH1 field.
	DMA_IN_PERI_SEL_CH1_PERI_IN_SEL_CH1_Pos = 0x0
	// Bit mask of PERI_IN_SEL_CH1 field.
	DMA_IN_PERI_SEL_CH1_PERI_IN_SEL_CH1_Msk = 0x3f

	// OUT_CONF0_CH1: DMA_OUT_CONF0_CH1_REG.
	// Position of OUT_RST_CH1 field.
	DMA_OUT_CONF0_CH1_OUT_RST_CH1_Pos = 0x0
	// Bit mask of OUT_RST_CH1 field.
	DMA_OUT_CONF0_CH1_OUT_RST_CH1_Msk = 0x1
	// Bit OUT_RST_CH1.
	DMA_OUT_CONF0_CH1_OUT_RST_CH1 = 0x1
	// Position of OUT_LOOP_TEST_CH1 field.
	DMA_OUT_CONF0_CH1_OUT_LOOP_TEST_CH1_Pos = 0x1
	// Bit mask of OUT_LOOP_TEST_CH1 field.
	DMA_OUT_CONF0_CH1_OUT_LOOP_TEST_CH1_Msk = 0x2
	// Bit OUT_LOOP_TEST_CH1.
	DMA_OUT_CONF0_CH1_OUT_LOOP_TEST_CH1 = 0x2
	// Position of OUT_AUTO_WRBACK_CH1 field.
	DMA_OUT_CONF0_CH1_OUT_AUTO_WRBACK_CH1_Pos = 0x2
	// Bit mask of OUT_AUTO_WRBACK_CH1 field.
	DMA_OUT_CONF0_CH1_OUT_AUTO_WRBACK_CH1_Msk = 0x4
	// Bit OUT_AUTO_WRBACK_CH1.
	DMA_OUT_CONF0_CH1_OUT_AUTO_WRBACK_CH1 = 0x4
	// Position of OUT_EOF_MODE_CH1 field.
	DMA_OUT_CONF0_CH1_OUT_EOF_MODE_CH1_Pos = 0x3
	// Bit mask of OUT_EOF_MODE_CH1 field.
	DMA_OUT_CONF0_CH1_OUT_EOF_MODE_CH1_Msk = 0x8
	// Bit OUT_EOF_MODE_CH1.
	DMA_OUT_CONF0_CH1_OUT_EOF_MODE_CH1 = 0x8
	// Position of OUTDSCR_BURST_EN_CH1 field.
	DMA_OUT_CONF0_CH1_OUTDSCR_BURST_EN_CH1_Pos = 0x4
	// Bit mask of OUTDSCR_BURST_EN_CH1 field.
	DMA_OUT_CONF0_CH1_OUTDSCR_BURST_EN_CH1_Msk = 0x10
	// Bit OUTDSCR_BURST_EN_CH1.
	DMA_OUT_CONF0_CH1_OUTDSCR_BURST_EN_CH1 = 0x10
	// Position of OUT_DATA_BURST_EN_CH1 field.
	DMA_OUT_CONF0_CH1_OUT_DATA_BURST_EN_CH1_Pos = 0x5
	// Bit mask of OUT_DATA_BURST_EN_CH1 field.
	DMA_OUT_CONF0_CH1_OUT_DATA_BURST_EN_CH1_Msk = 0x20
	// Bit OUT_DATA_BURST_EN_CH1.
	DMA_OUT_CONF0_CH1_OUT_DATA_BURST_EN_CH1 = 0x20

	// OUT_CONF1_CH1: DMA_OUT_CONF1_CH1_REG.
	// Position of OUT_CHECK_OWNER_CH1 field.
	DMA_OUT_CONF1_CH1_OUT_CHECK_OWNER_CH1_Pos = 0xc
	// Bit mask of OUT_CHECK_OWNER_CH1 field.
	DMA_OUT_CONF1_CH1_OUT_CHECK_OWNER_CH1_Msk = 0x1000
	// Bit OUT_CHECK_OWNER_CH1.
	DMA_OUT_CONF1_CH1_OUT_CHECK_OWNER_CH1 = 0x1000

	// OUTFIFO_STATUS_CH1: DMA_OUTFIFO_STATUS_CH1_REG.
	// Position of OUTFIFO_FULL_CH1 field.
	DMA_OUTFIFO_STATUS_CH1_OUTFIFO_FULL_CH1_Pos = 0x0
	// Bit mask of OUTFIFO_FULL_CH1 field.
	DMA_OUTFIFO_STATUS_CH1_OUTFIFO_FULL_CH1_Msk = 0x1
	// Bit OUTFIFO_FULL_CH1.
	DMA_OUTFIFO_STATUS_CH1_OUTFIFO_FULL_CH1 = 0x1
	// Position of OUTFIFO_EMPTY_CH1 field.
	DMA_OUTFIFO_STATUS_CH1_OUTFIFO_EMPTY_CH1_Pos = 0x1
	// Bit mask of OUTFIFO_EMPTY_CH1 field.
	DMA_OUTFIFO_STATUS_CH1_OUTFIFO_EMPTY_CH1_Msk = 0x2
	// Bit OUTFIFO_EMPTY_CH1.
	DMA_OUTFIFO_STATUS_CH1_OUTFIFO_EMPTY_CH1 = 0x2
	// Position of OUTFIFO_CNT_CH1 field.
	DMA_OUTFIFO_STATUS_CH1_OUTFIFO_CNT_CH1_Pos = 0x2
	// Bit mask of OUTFIFO_CNT_CH1 field.
	DMA_OUTFIFO_STATUS_CH1_OUTFIFO_CNT_CH1_Msk = 0xfc
	// Position of OUT_REMAIN_UNDER_1B_CH1 field.
	DMA_OUTFIFO_STATUS_CH1_OUT_REMAIN_UNDER_1B_CH1_Pos = 0x17
	// Bit mask of OUT_REMAIN_UNDER_1B_CH1 field.
	DMA_OUTFIFO_STATUS_CH1_OUT_REMAIN_UNDER_1B_CH1_Msk = 0x800000
	// Bit OUT_REMAIN_UNDER_1B_CH1.
	DMA_OUTFIFO_STATUS_CH1_OUT_REMAIN_UNDER_1B_CH1 = 0x800000
	// Position of OUT_REMAIN_UNDER_2B_CH1 field.
	DMA_OUTFIFO_STATUS_CH1_OUT_REMAIN_UNDER_2B_CH1_Pos = 0x18
	// Bit mask of OUT_REMAIN_UNDER_2B_CH1 field.
	DMA_OUTFIFO_STATUS_CH1_OUT_REMAIN_UNDER_2B_CH1_Msk = 0x1000000
	// Bit OUT_REMAIN_UNDER_2B_CH1.
	DMA_OUTFIFO_STATUS_CH1_OUT_REMAIN_UNDER_2B_CH1 = 0x1000000
	// Position of OUT_REMAIN_UNDER_3B_CH1 field.
	DMA_OUTFIFO_STATUS_CH1_OUT_REMAIN_UNDER_3B_CH1_Pos = 0x19
	// Bit mask of OUT_REMAIN_UNDER_3B_CH1 field.
	DMA_OUTFIFO_STATUS_CH1_OUT_REMAIN_UNDER_3B_CH1_Msk = 0x2000000
	// Bit OUT_REMAIN_UNDER_3B_CH1.
	DMA_OUTFIFO_STATUS_CH1_OUT_REMAIN_UNDER_3B_CH1 = 0x2000000
	// Position of OUT_REMAIN_UNDER_4B_CH1 field.
	DMA_OUTFIFO_STATUS_CH1_OUT_REMAIN_UNDER_4B_CH1_Pos = 0x1a
	// Bit mask of OUT_REMAIN_UNDER_4B_CH1 field.
	DMA_OUTFIFO_STATUS_CH1_OUT_REMAIN_UNDER_4B_CH1_Msk = 0x4000000
	// Bit OUT_REMAIN_UNDER_4B_CH1.
	DMA_OUTFIFO_STATUS_CH1_OUT_REMAIN_UNDER_4B_CH1 = 0x4000000

	// OUT_PUSH_CH1: DMA_OUT_PUSH_CH1_REG.
	// Position of OUTFIFO_WDATA_CH1 field.
	DMA_OUT_PUSH_CH1_OUTFIFO_WDATA_CH1_Pos = 0x0
	// Bit mask of OUTFIFO_WDATA_CH1 field.
	DMA_OUT_PUSH_CH1_OUTFIFO_WDATA_CH1_Msk = 0x1ff
	// Position of OUTFIFO_PUSH_CH1 field.
	DMA_OUT_PUSH_CH1_OUTFIFO_PUSH_CH1_Pos = 0x9
	// Bit mask of OUTFIFO_PUSH_CH1 field.
	DMA_OUT_PUSH_CH1_OUTFIFO_PUSH_CH1_Msk = 0x200
	// Bit OUTFIFO_PUSH_CH1.
	DMA_OUT_PUSH_CH1_OUTFIFO_PUSH_CH1 = 0x200

	// OUT_LINK_CH1: DMA_OUT_LINK_CH1_REG.
	// Position of OUTLINK_ADDR_CH1 field.
	DMA_OUT_LINK_CH1_OUTLINK_ADDR_CH1_Pos = 0x0
	// Bit mask of OUTLINK_ADDR_CH1 field.
	DMA_OUT_LINK_CH1_OUTLINK_ADDR_CH1_Msk = 0xfffff
	// Position of OUTLINK_STOP_CH1 field.
	DMA_OUT_LINK_CH1_OUTLINK_STOP_CH1_Pos = 0x14
	// Bit mask of OUTLINK_STOP_CH1 field.
	DMA_OUT_LINK_CH1_OUTLINK_STOP_CH1_Msk = 0x100000
	// Bit OUTLINK_STOP_CH1.
	DMA_OUT_LINK_CH1_OUTLINK_STOP_CH1 = 0x100000
	// Position of OUTLINK_START_CH1 field.
	DMA_OUT_LINK_CH1_OUTLINK_START_CH1_Pos = 0x15
	// Bit mask of OUTLINK_START_CH1 field.
	DMA_OUT_LINK_CH1_OUTLINK_START_CH1_Msk = 0x200000
	// Bit OUTLINK_START_CH1.
	DMA_OUT_LINK_CH1_OUTLINK_START_CH1 = 0x200000
	// Position of OUTLINK_RESTART_CH1 field.
	DMA_OUT_LINK_CH1_OUTLINK_RESTART_CH1_Pos = 0x16
	// Bit mask of OUTLINK_RESTART_CH1 field.
	DMA_OUT_LINK_CH1_OUTLINK_RESTART_CH1_Msk = 0x400000
	// Bit OUTLINK_RESTART_CH1.
	DMA_OUT_LINK_CH1_OUTLINK_RESTART_CH1 = 0x400000
	// Position of OUTLINK_PARK_CH1 field.
	DMA_OUT_LINK_CH1_OUTLINK_PARK_CH1_Pos = 0x17
	// Bit mask of OUTLINK_PARK_CH1 field.
	DMA_OUT_LINK_CH1_OUTLINK_PARK_CH1_Msk = 0x800000
	// Bit OUTLINK_PARK_CH1.
	DMA_OUT_LINK_CH1_OUTLINK_PARK_CH1 = 0x800000

	// OUT_STATE_CH1: DMA_OUT_STATE_CH1_REG.
	// Position of OUTLINK_DSCR_ADDR_CH1 field.
	DMA_OUT_STATE_CH1_OUTLINK_DSCR_ADDR_CH1_Pos = 0x0
	// Bit mask of OUTLINK_DSCR_ADDR_CH1 field.
	DMA_OUT_STATE_CH1_OUTLINK_DSCR_ADDR_CH1_Msk = 0x3ffff
	// Position of OUT_DSCR_STATE_CH1 field.
	DMA_OUT_STATE_CH1_OUT_DSCR_STATE_CH1_Pos = 0x12
	// Bit mask of OUT_DSCR_STATE_CH1 field.
	DMA_OUT_STATE_CH1_OUT_DSCR_STATE_CH1_Msk = 0xc0000
	// Position of OUT_STATE_CH1 field.
	DMA_OUT_STATE_CH1_OUT_STATE_CH1_Pos = 0x14
	// Bit mask of OUT_STATE_CH1 field.
	DMA_OUT_STATE_CH1_OUT_STATE_CH1_Msk = 0x700000

	// OUT_EOF_DES_ADDR_CH1: DMA_OUT_EOF_DES_ADDR_CH1_REG.
	// Position of OUT_EOF_DES_ADDR_CH1 field.
	DMA_OUT_EOF_DES_ADDR_CH1_OUT_EOF_DES_ADDR_CH1_Pos = 0x0
	// Bit mask of OUT_EOF_DES_ADDR_CH1 field.
	DMA_OUT_EOF_DES_ADDR_CH1_OUT_EOF_DES_ADDR_CH1_Msk = 0xffffffff

	// OUT_EOF_BFR_DES_ADDR_CH1: DMA_OUT_EOF_BFR_DES_ADDR_CH1_REG.
	// Position of OUT_EOF_BFR_DES_ADDR_CH1 field.
	DMA_OUT_EOF_BFR_DES_ADDR_CH1_OUT_EOF_BFR_DES_ADDR_CH1_Pos = 0x0
	// Bit mask of OUT_EOF_BFR_DES_ADDR_CH1 field.
	DMA_OUT_EOF_BFR_DES_ADDR_CH1_OUT_EOF_BFR_DES_ADDR_CH1_Msk = 0xffffffff

	// OUT_DSCR_CH1: DMA_OUT_DSCR_CH1_REG.
	// Position of OUTLINK_DSCR_CH1 field.
	DMA_OUT_DSCR_CH1_OUTLINK_DSCR_CH1_Pos = 0x0
	// Bit mask of OUTLINK_DSCR_CH1 field.
	DMA_OUT_DSCR_CH1_OUTLINK_DSCR_CH1_Msk = 0xffffffff

	// OUT_DSCR_BF0_CH1: DMA_OUT_DSCR_BF0_CH1_REG.
	// Position of OUTLINK_DSCR_BF0_CH1 field.
	DMA_OUT_DSCR_BF0_CH1_OUTLINK_DSCR_BF0_CH1_Pos = 0x0
	// Bit mask of OUTLINK_DSCR_BF0_CH1 field.
	DMA_OUT_DSCR_BF0_CH1_OUTLINK_DSCR_BF0_CH1_Msk = 0xffffffff

	// OUT_DSCR_BF1_CH1: DMA_OUT_DSCR_BF1_CH1_REG.
	// Position of OUTLINK_DSCR_BF1_CH1 field.
	DMA_OUT_DSCR_BF1_CH1_OUTLINK_DSCR_BF1_CH1_Pos = 0x0
	// Bit mask of OUTLINK_DSCR_BF1_CH1 field.
	DMA_OUT_DSCR_BF1_CH1_OUTLINK_DSCR_BF1_CH1_Msk = 0xffffffff

	// OUT_PRI_CH1: DMA_OUT_PRI_CH1_REG.
	// Position of TX_PRI_CH1 field.
	DMA_OUT_PRI_CH1_TX_PRI_CH1_Pos = 0x0
	// Bit mask of TX_PRI_CH1 field.
	DMA_OUT_PRI_CH1_TX_PRI_CH1_Msk = 0xf

	// OUT_PERI_SEL_CH1: DMA_OUT_PERI_SEL_CH1_REG.
	// Position of PERI_OUT_SEL_CH1 field.
	DMA_OUT_PERI_SEL_CH1_PERI_OUT_SEL_CH1_Pos = 0x0
	// Bit mask of PERI_OUT_SEL_CH1 field.
	DMA_OUT_PERI_SEL_CH1_PERI_OUT_SEL_CH1_Msk = 0x3f

	// IN_CONF0_CH2: DMA_IN_CONF0_CH2_REG.
	// Position of IN_RST_CH2 field.
	DMA_IN_CONF0_CH2_IN_RST_CH2_Pos = 0x0
	// Bit mask of IN_RST_CH2 field.
	DMA_IN_CONF0_CH2_IN_RST_CH2_Msk = 0x1
	// Bit IN_RST_CH2.
	DMA_IN_CONF0_CH2_IN_RST_CH2 = 0x1
	// Position of IN_LOOP_TEST_CH2 field.
	DMA_IN_CONF0_CH2_IN_LOOP_TEST_CH2_Pos = 0x1
	// Bit mask of IN_LOOP_TEST_CH2 field.
	DMA_IN_CONF0_CH2_IN_LOOP_TEST_CH2_Msk = 0x2
	// Bit IN_LOOP_TEST_CH2.
	DMA_IN_CONF0_CH2_IN_LOOP_TEST_CH2 = 0x2
	// Position of INDSCR_BURST_EN_CH2 field.
	DMA_IN_CONF0_CH2_INDSCR_BURST_EN_CH2_Pos = 0x2
	// Bit mask of INDSCR_BURST_EN_CH2 field.
	DMA_IN_CONF0_CH2_INDSCR_BURST_EN_CH2_Msk = 0x4
	// Bit INDSCR_BURST_EN_CH2.
	DMA_IN_CONF0_CH2_INDSCR_BURST_EN_CH2 = 0x4
	// Position of IN_DATA_BURST_EN_CH2 field.
	DMA_IN_CONF0_CH2_IN_DATA_BURST_EN_CH2_Pos = 0x3
	// Bit mask of IN_DATA_BURST_EN_CH2 field.
	DMA_IN_CONF0_CH2_IN_DATA_BURST_EN_CH2_Msk = 0x8
	// Bit IN_DATA_BURST_EN_CH2.
	DMA_IN_CONF0_CH2_IN_DATA_BURST_EN_CH2 = 0x8
	// Position of MEM_TRANS_EN_CH2 field.
	DMA_IN_CONF0_CH2_MEM_TRANS_EN_CH2_Pos = 0x4
	// Bit mask of MEM_TRANS_EN_CH2 field.
	DMA_IN_CONF0_CH2_MEM_TRANS_EN_CH2_Msk = 0x10
	// Bit MEM_TRANS_EN_CH2.
	DMA_IN_CONF0_CH2_MEM_TRANS_EN_CH2 = 0x10

	// IN_CONF1_CH2: DMA_IN_CONF1_CH2_REG.
	// Position of IN_CHECK_OWNER_CH2 field.
	DMA_IN_CONF1_CH2_IN_CHECK_OWNER_CH2_Pos = 0xc
	// Bit mask of IN_CHECK_OWNER_CH2 field.
	DMA_IN_CONF1_CH2_IN_CHECK_OWNER_CH2_Msk = 0x1000
	// Bit IN_CHECK_OWNER_CH2.
	DMA_IN_CONF1_CH2_IN_CHECK_OWNER_CH2 = 0x1000

	// INFIFO_STATUS_CH2: DMA_INFIFO_STATUS_CH2_REG.
	// Position of INFIFO_FULL_CH2 field.
	DMA_INFIFO_STATUS_CH2_INFIFO_FULL_CH2_Pos = 0x0
	// Bit mask of INFIFO_FULL_CH2 field.
	DMA_INFIFO_STATUS_CH2_INFIFO_FULL_CH2_Msk = 0x1
	// Bit INFIFO_FULL_CH2.
	DMA_INFIFO_STATUS_CH2_INFIFO_FULL_CH2 = 0x1
	// Position of INFIFO_EMPTY_CH2 field.
	DMA_INFIFO_STATUS_CH2_INFIFO_EMPTY_CH2_Pos = 0x1
	// Bit mask of INFIFO_EMPTY_CH2 field.
	DMA_INFIFO_STATUS_CH2_INFIFO_EMPTY_CH2_Msk = 0x2
	// Bit INFIFO_EMPTY_CH2.
	DMA_INFIFO_STATUS_CH2_INFIFO_EMPTY_CH2 = 0x2
	// Position of INFIFO_CNT_CH2 field.
	DMA_INFIFO_STATUS_CH2_INFIFO_CNT_CH2_Pos = 0x2
	// Bit mask of INFIFO_CNT_CH2 field.
	DMA_INFIFO_STATUS_CH2_INFIFO_CNT_CH2_Msk = 0xfc
	// Position of IN_REMAIN_UNDER_1B_CH2 field.
	DMA_INFIFO_STATUS_CH2_IN_REMAIN_UNDER_1B_CH2_Pos = 0x17
	// Bit mask of IN_REMAIN_UNDER_1B_CH2 field.
	DMA_INFIFO_STATUS_CH2_IN_REMAIN_UNDER_1B_CH2_Msk = 0x800000
	// Bit IN_REMAIN_UNDER_1B_CH2.
	DMA_INFIFO_STATUS_CH2_IN_REMAIN_UNDER_1B_CH2 = 0x800000
	// Position of IN_REMAIN_UNDER_2B_CH2 field.
	DMA_INFIFO_STATUS_CH2_IN_REMAIN_UNDER_2B_CH2_Pos = 0x18
	// Bit mask of IN_REMAIN_UNDER_2B_CH2 field.
	DMA_INFIFO_STATUS_CH2_IN_REMAIN_UNDER_2B_CH2_Msk = 0x1000000
	// Bit IN_REMAIN_UNDER_2B_CH2.
	DMA_INFIFO_STATUS_CH2_IN_REMAIN_UNDER_2B_CH2 = 0x1000000
	// Position of IN_REMAIN_UNDER_3B_CH2 field.
	DMA_INFIFO_STATUS_CH2_IN_REMAIN_UNDER_3B_CH2_Pos = 0x19
	// Bit mask of IN_REMAIN_UNDER_3B_CH2 field.
	DMA_INFIFO_STATUS_CH2_IN_REMAIN_UNDER_3B_CH2_Msk = 0x2000000
	// Bit IN_REMAIN_UNDER_3B_CH2.
	DMA_INFIFO_STATUS_CH2_IN_REMAIN_UNDER_3B_CH2 = 0x2000000
	// Position of IN_REMAIN_UNDER_4B_CH2 field.
	DMA_INFIFO_STATUS_CH2_IN_REMAIN_UNDER_4B_CH2_Pos = 0x1a
	// Bit mask of IN_REMAIN_UNDER_4B_CH2 field.
	DMA_INFIFO_STATUS_CH2_IN_REMAIN_UNDER_4B_CH2_Msk = 0x4000000
	// Bit IN_REMAIN_UNDER_4B_CH2.
	DMA_INFIFO_STATUS_CH2_IN_REMAIN_UNDER_4B_CH2 = 0x4000000
	// Position of IN_BUF_HUNGRY_CH2 field.
	DMA_INFIFO_STATUS_CH2_IN_BUF_HUNGRY_CH2_Pos = 0x1b
	// Bit mask of IN_BUF_HUNGRY_CH2 field.
	DMA_INFIFO_STATUS_CH2_IN_BUF_HUNGRY_CH2_Msk = 0x8000000
	// Bit IN_BUF_HUNGRY_CH2.
	DMA_INFIFO_STATUS_CH2_IN_BUF_HUNGRY_CH2 = 0x8000000

	// IN_POP_CH2: DMA_IN_POP_CH2_REG.
	// Position of INFIFO_RDATA_CH2 field.
	DMA_IN_POP_CH2_INFIFO_RDATA_CH2_Pos = 0x0
	// Bit mask of INFIFO_RDATA_CH2 field.
	DMA_IN_POP_CH2_INFIFO_RDATA_CH2_Msk = 0xfff
	// Position of INFIFO_POP_CH2 field.
	DMA_IN_POP_CH2_INFIFO_POP_CH2_Pos = 0xc
	// Bit mask of INFIFO_POP_CH2 field.
	DMA_IN_POP_CH2_INFIFO_POP_CH2_Msk = 0x1000
	// Bit INFIFO_POP_CH2.
	DMA_IN_POP_CH2_INFIFO_POP_CH2 = 0x1000

	// IN_LINK_CH2: DMA_IN_LINK_CH2_REG.
	// Position of INLINK_ADDR_CH2 field.
	DMA_IN_LINK_CH2_INLINK_ADDR_CH2_Pos = 0x0
	// Bit mask of INLINK_ADDR_CH2 field.
	DMA_IN_LINK_CH2_INLINK_ADDR_CH2_Msk = 0xfffff
	// Position of INLINK_AUTO_RET_CH2 field.
	DMA_IN_LINK_CH2_INLINK_AUTO_RET_CH2_Pos = 0x14
	// Bit mask of INLINK_AUTO_RET_CH2 field.
	DMA_IN_LINK_CH2_INLINK_AUTO_RET_CH2_Msk = 0x100000
	// Bit INLINK_AUTO_RET_CH2.
	DMA_IN_LINK_CH2_INLINK_AUTO_RET_CH2 = 0x100000
	// Position of INLINK_STOP_CH2 field.
	DMA_IN_LINK_CH2_INLINK_STOP_CH2_Pos = 0x15
	// Bit mask of INLINK_STOP_CH2 field.
	DMA_IN_LINK_CH2_INLINK_STOP_CH2_Msk = 0x200000
	// Bit INLINK_STOP_CH2.
	DMA_IN_LINK_CH2_INLINK_STOP_CH2 = 0x200000
	// Position of INLINK_START_CH2 field.
	DMA_IN_LINK_CH2_INLINK_START_CH2_Pos = 0x16
	// Bit mask of INLINK_START_CH2 field.
	DMA_IN_LINK_CH2_INLINK_START_CH2_Msk = 0x400000
	// Bit INLINK_START_CH2.
	DMA_IN_LINK_CH2_INLINK_START_CH2 = 0x400000
	// Position of INLINK_RESTART_CH2 field.
	DMA_IN_LINK_CH2_INLINK_RESTART_CH2_Pos = 0x17
	// Bit mask of INLINK_RESTART_CH2 field.
	DMA_IN_LINK_CH2_INLINK_RESTART_CH2_Msk = 0x800000
	// Bit INLINK_RESTART_CH2.
	DMA_IN_LINK_CH2_INLINK_RESTART_CH2 = 0x800000
	// Position of INLINK_PARK_CH2 field.
	DMA_IN_LINK_CH2_INLINK_PARK_CH2_Pos = 0x18
	// Bit mask of INLINK_PARK_CH2 field.
	DMA_IN_LINK_CH2_INLINK_PARK_CH2_Msk = 0x1000000
	// Bit INLINK_PARK_CH2.
	DMA_IN_LINK_CH2_INLINK_PARK_CH2 = 0x1000000

	// IN_STATE_CH2: DMA_IN_STATE_CH2_REG.
	// Position of INLINK_DSCR_ADDR_CH2 field.
	DMA_IN_STATE_CH2_INLINK_DSCR_ADDR_CH2_Pos = 0x0
	// Bit mask of INLINK_DSCR_ADDR_CH2 field.
	DMA_IN_STATE_CH2_INLINK_DSCR_ADDR_CH2_Msk = 0x3ffff
	// Position of IN_DSCR_STATE_CH2 field.
	DMA_IN_STATE_CH2_IN_DSCR_STATE_CH2_Pos = 0x12
	// Bit mask of IN_DSCR_STATE_CH2 field.
	DMA_IN_STATE_CH2_IN_DSCR_STATE_CH2_Msk = 0xc0000
	// Position of IN_STATE_CH2 field.
	DMA_IN_STATE_CH2_IN_STATE_CH2_Pos = 0x14
	// Bit mask of IN_STATE_CH2 field.
	DMA_IN_STATE_CH2_IN_STATE_CH2_Msk = 0x700000

	// IN_SUC_EOF_DES_ADDR_CH2: DMA_IN_SUC_EOF_DES_ADDR_CH2_REG.
	// Position of IN_SUC_EOF_DES_ADDR_CH2 field.
	DMA_IN_SUC_EOF_DES_ADDR_CH2_IN_SUC_EOF_DES_ADDR_CH2_Pos = 0x0
	// Bit mask of IN_SUC_EOF_DES_ADDR_CH2 field.
	DMA_IN_SUC_EOF_DES_ADDR_CH2_IN_SUC_EOF_DES_ADDR_CH2_Msk = 0xffffffff

	// IN_ERR_EOF_DES_ADDR_CH2: DMA_IN_ERR_EOF_DES_ADDR_CH2_REG.
	// Position of IN_ERR_EOF_DES_ADDR_CH2 field.
	DMA_IN_ERR_EOF_DES_ADDR_CH2_IN_ERR_EOF_DES_ADDR_CH2_Pos = 0x0
	// Bit mask of IN_ERR_EOF_DES_ADDR_CH2 field.
	DMA_IN_ERR_EOF_DES_ADDR_CH2_IN_ERR_EOF_DES_ADDR_CH2_Msk = 0xffffffff

	// IN_DSCR_CH2: DMA_IN_DSCR_CH2_REG.
	// Position of INLINK_DSCR_CH2 field.
	DMA_IN_DSCR_CH2_INLINK_DSCR_CH2_Pos = 0x0
	// Bit mask of INLINK_DSCR_CH2 field.
	DMA_IN_DSCR_CH2_INLINK_DSCR_CH2_Msk = 0xffffffff

	// IN_DSCR_BF0_CH2: DMA_IN_DSCR_BF0_CH2_REG.
	// Position of INLINK_DSCR_BF0_CH2 field.
	DMA_IN_DSCR_BF0_CH2_INLINK_DSCR_BF0_CH2_Pos = 0x0
	// Bit mask of INLINK_DSCR_BF0_CH2 field.
	DMA_IN_DSCR_BF0_CH2_INLINK_DSCR_BF0_CH2_Msk = 0xffffffff

	// IN_DSCR_BF1_CH2: DMA_IN_DSCR_BF1_CH2_REG.
	// Position of INLINK_DSCR_BF1_CH2 field.
	DMA_IN_DSCR_BF1_CH2_INLINK_DSCR_BF1_CH2_Pos = 0x0
	// Bit mask of INLINK_DSCR_BF1_CH2 field.
	DMA_IN_DSCR_BF1_CH2_INLINK_DSCR_BF1_CH2_Msk = 0xffffffff

	// IN_PRI_CH2: DMA_IN_PRI_CH2_REG.
	// Position of RX_PRI_CH2 field.
	DMA_IN_PRI_CH2_RX_PRI_CH2_Pos = 0x0
	// Bit mask of RX_PRI_CH2 field.
	DMA_IN_PRI_CH2_RX_PRI_CH2_Msk = 0xf

	// IN_PERI_SEL_CH2: DMA_IN_PERI_SEL_CH2_REG.
	// Position of PERI_IN_SEL_CH2 field.
	DMA_IN_PERI_SEL_CH2_PERI_IN_SEL_CH2_Pos = 0x0
	// Bit mask of PERI_IN_SEL_CH2 field.
	DMA_IN_PERI_SEL_CH2_PERI_IN_SEL_CH2_Msk = 0x3f

	// OUT_CONF0_CH2: DMA_OUT_CONF0_CH2_REG.
	// Position of OUT_RST_CH2 field.
	DMA_OUT_CONF0_CH2_OUT_RST_CH2_Pos = 0x0
	// Bit mask of OUT_RST_CH2 field.
	DMA_OUT_CONF0_CH2_OUT_RST_CH2_Msk = 0x1
	// Bit OUT_RST_CH2.
	DMA_OUT_CONF0_CH2_OUT_RST_CH2 = 0x1
	// Position of OUT_LOOP_TEST_CH2 field.
	DMA_OUT_CONF0_CH2_OUT_LOOP_TEST_CH2_Pos = 0x1
	// Bit mask of OUT_LOOP_TEST_CH2 field.
	DMA_OUT_CONF0_CH2_OUT_LOOP_TEST_CH2_Msk = 0x2
	// Bit OUT_LOOP_TEST_CH2.
	DMA_OUT_CONF0_CH2_OUT_LOOP_TEST_CH2 = 0x2
	// Position of OUT_AUTO_WRBACK_CH2 field.
	DMA_OUT_CONF0_CH2_OUT_AUTO_WRBACK_CH2_Pos = 0x2
	// Bit mask of OUT_AUTO_WRBACK_CH2 field.
	DMA_OUT_CONF0_CH2_OUT_AUTO_WRBACK_CH2_Msk = 0x4
	// Bit OUT_AUTO_WRBACK_CH2.
	DMA_OUT_CONF0_CH2_OUT_AUTO_WRBACK_CH2 = 0x4
	// Position of OUT_EOF_MODE_CH2 field.
	DMA_OUT_CONF0_CH2_OUT_EOF_MODE_CH2_Pos = 0x3
	// Bit mask of OUT_EOF_MODE_CH2 field.
	DMA_OUT_CONF0_CH2_OUT_EOF_MODE_CH2_Msk = 0x8
	// Bit OUT_EOF_MODE_CH2.
	DMA_OUT_CONF0_CH2_OUT_EOF_MODE_CH2 = 0x8
	// Position of OUTDSCR_BURST_EN_CH2 field.
	DMA_OUT_CONF0_CH2_OUTDSCR_BURST_EN_CH2_Pos = 0x4
	// Bit mask of OUTDSCR_BURST_EN_CH2 field.
	DMA_OUT_CONF0_CH2_OUTDSCR_BURST_EN_CH2_Msk = 0x10
	// Bit OUTDSCR_BURST_EN_CH2.
	DMA_OUT_CONF0_CH2_OUTDSCR_BURST_EN_CH2 = 0x10
	// Position of OUT_DATA_BURST_EN_CH2 field.
	DMA_OUT_CONF0_CH2_OUT_DATA_BURST_EN_CH2_Pos = 0x5
	// Bit mask of OUT_DATA_BURST_EN_CH2 field.
	DMA_OUT_CONF0_CH2_OUT_DATA_BURST_EN_CH2_Msk = 0x20
	// Bit OUT_DATA_BURST_EN_CH2.
	DMA_OUT_CONF0_CH2_OUT_DATA_BURST_EN_CH2 = 0x20

	// OUT_CONF1_CH2: DMA_OUT_CONF1_CH2_REG.
	// Position of OUT_CHECK_OWNER_CH2 field.
	DMA_OUT_CONF1_CH2_OUT_CHECK_OWNER_CH2_Pos = 0xc
	// Bit mask of OUT_CHECK_OWNER_CH2 field.
	DMA_OUT_CONF1_CH2_OUT_CHECK_OWNER_CH2_Msk = 0x1000
	// Bit OUT_CHECK_OWNER_CH2.
	DMA_OUT_CONF1_CH2_OUT_CHECK_OWNER_CH2 = 0x1000

	// OUTFIFO_STATUS_CH2: DMA_OUTFIFO_STATUS_CH2_REG.
	// Position of OUTFIFO_FULL_CH2 field.
	DMA_OUTFIFO_STATUS_CH2_OUTFIFO_FULL_CH2_Pos = 0x0
	// Bit mask of OUTFIFO_FULL_CH2 field.
	DMA_OUTFIFO_STATUS_CH2_OUTFIFO_FULL_CH2_Msk = 0x1
	// Bit OUTFIFO_FULL_CH2.
	DMA_OUTFIFO_STATUS_CH2_OUTFIFO_FULL_CH2 = 0x1
	// Position of OUTFIFO_EMPTY_CH2 field.
	DMA_OUTFIFO_STATUS_CH2_OUTFIFO_EMPTY_CH2_Pos = 0x1
	// Bit mask of OUTFIFO_EMPTY_CH2 field.
	DMA_OUTFIFO_STATUS_CH2_OUTFIFO_EMPTY_CH2_Msk = 0x2
	// Bit OUTFIFO_EMPTY_CH2.
	DMA_OUTFIFO_STATUS_CH2_OUTFIFO_EMPTY_CH2 = 0x2
	// Position of OUTFIFO_CNT_CH2 field.
	DMA_OUTFIFO_STATUS_CH2_OUTFIFO_CNT_CH2_Pos = 0x2
	// Bit mask of OUTFIFO_CNT_CH2 field.
	DMA_OUTFIFO_STATUS_CH2_OUTFIFO_CNT_CH2_Msk = 0xfc
	// Position of OUT_REMAIN_UNDER_1B_CH2 field.
	DMA_OUTFIFO_STATUS_CH2_OUT_REMAIN_UNDER_1B_CH2_Pos = 0x17
	// Bit mask of OUT_REMAIN_UNDER_1B_CH2 field.
	DMA_OUTFIFO_STATUS_CH2_OUT_REMAIN_UNDER_1B_CH2_Msk = 0x800000
	// Bit OUT_REMAIN_UNDER_1B_CH2.
	DMA_OUTFIFO_STATUS_CH2_OUT_REMAIN_UNDER_1B_CH2 = 0x800000
	// Position of OUT_REMAIN_UNDER_2B_CH2 field.
	DMA_OUTFIFO_STATUS_CH2_OUT_REMAIN_UNDER_2B_CH2_Pos = 0x18
	// Bit mask of OUT_REMAIN_UNDER_2B_CH2 field.
	DMA_OUTFIFO_STATUS_CH2_OUT_REMAIN_UNDER_2B_CH2_Msk = 0x1000000
	// Bit OUT_REMAIN_UNDER_2B_CH2.
	DMA_OUTFIFO_STATUS_CH2_OUT_REMAIN_UNDER_2B_CH2 = 0x1000000
	// Position of OUT_REMAIN_UNDER_3B_CH2 field.
	DMA_OUTFIFO_STATUS_CH2_OUT_REMAIN_UNDER_3B_CH2_Pos = 0x19
	// Bit mask of OUT_REMAIN_UNDER_3B_CH2 field.
	DMA_OUTFIFO_STATUS_CH2_OUT_REMAIN_UNDER_3B_CH2_Msk = 0x2000000
	// Bit OUT_REMAIN_UNDER_3B_CH2.
	DMA_OUTFIFO_STATUS_CH2_OUT_REMAIN_UNDER_3B_CH2 = 0x2000000
	// Position of OUT_REMAIN_UNDER_4B_CH2 field.
	DMA_OUTFIFO_STATUS_CH2_OUT_REMAIN_UNDER_4B_CH2_Pos = 0x1a
	// Bit mask of OUT_REMAIN_UNDER_4B_CH2 field.
	DMA_OUTFIFO_STATUS_CH2_OUT_REMAIN_UNDER_4B_CH2_Msk = 0x4000000
	// Bit OUT_REMAIN_UNDER_4B_CH2.
	DMA_OUTFIFO_STATUS_CH2_OUT_REMAIN_UNDER_4B_CH2 = 0x4000000

	// OUT_PUSH_CH2: DMA_OUT_PUSH_CH2_REG.
	// Position of OUTFIFO_WDATA_CH2 field.
	DMA_OUT_PUSH_CH2_OUTFIFO_WDATA_CH2_Pos = 0x0
	// Bit mask of OUTFIFO_WDATA_CH2 field.
	DMA_OUT_PUSH_CH2_OUTFIFO_WDATA_CH2_Msk = 0x1ff
	// Position of OUTFIFO_PUSH_CH2 field.
	DMA_OUT_PUSH_CH2_OUTFIFO_PUSH_CH2_Pos = 0x9
	// Bit mask of OUTFIFO_PUSH_CH2 field.
	DMA_OUT_PUSH_CH2_OUTFIFO_PUSH_CH2_Msk = 0x200
	// Bit OUTFIFO_PUSH_CH2.
	DMA_OUT_PUSH_CH2_OUTFIFO_PUSH_CH2 = 0x200

	// OUT_LINK_CH2: DMA_OUT_LINK_CH2_REG.
	// Position of OUTLINK_ADDR_CH2 field.
	DMA_OUT_LINK_CH2_OUTLINK_ADDR_CH2_Pos = 0x0
	// Bit mask of OUTLINK_ADDR_CH2 field.
	DMA_OUT_LINK_CH2_OUTLINK_ADDR_CH2_Msk = 0xfffff
	// Position of OUTLINK_STOP_CH2 field.
	DMA_OUT_LINK_CH2_OUTLINK_STOP_CH2_Pos = 0x14
	// Bit mask of OUTLINK_STOP_CH2 field.
	DMA_OUT_LINK_CH2_OUTLINK_STOP_CH2_Msk = 0x100000
	// Bit OUTLINK_STOP_CH2.
	DMA_OUT_LINK_CH2_OUTLINK_STOP_CH2 = 0x100000
	// Position of OUTLINK_START_CH2 field.
	DMA_OUT_LINK_CH2_OUTLINK_START_CH2_Pos = 0x15
	// Bit mask of OUTLINK_START_CH2 field.
	DMA_OUT_LINK_CH2_OUTLINK_START_CH2_Msk = 0x200000
	// Bit OUTLINK_START_CH2.
	DMA_OUT_LINK_CH2_OUTLINK_START_CH2 = 0x200000
	// Position of OUTLINK_RESTART_CH2 field.
	DMA_OUT_LINK_CH2_OUTLINK_RESTART_CH2_Pos = 0x16
	// Bit mask of OUTLINK_RESTART_CH2 field.
	DMA_OUT_LINK_CH2_OUTLINK_RESTART_CH2_Msk = 0x400000
	// Bit OUTLINK_RESTART_CH2.
	DMA_OUT_LINK_CH2_OUTLINK_RESTART_CH2 = 0x400000
	// Position of OUTLINK_PARK_CH2 field.
	DMA_OUT_LINK_CH2_OUTLINK_PARK_CH2_Pos = 0x17
	// Bit mask of OUTLINK_PARK_CH2 field.
	DMA_OUT_LINK_CH2_OUTLINK_PARK_CH2_Msk = 0x800000
	// Bit OUTLINK_PARK_CH2.
	DMA_OUT_LINK_CH2_OUTLINK_PARK_CH2 = 0x800000

	// OUT_STATE_CH2: DMA_OUT_STATE_CH2_REG.
	// Position of OUTLINK_DSCR_ADDR_CH2 field.
	DMA_OUT_STATE_CH2_OUTLINK_DSCR_ADDR_CH2_Pos = 0x0
	// Bit mask of OUTLINK_DSCR_ADDR_CH2 field.
	DMA_OUT_STATE_CH2_OUTLINK_DSCR_ADDR_CH2_Msk = 0x3ffff
	// Position of OUT_DSCR_STATE_CH2 field.
	DMA_OUT_STATE_CH2_OUT_DSCR_STATE_CH2_Pos = 0x12
	// Bit mask of OUT_DSCR_STATE_CH2 field.
	DMA_OUT_STATE_CH2_OUT_DSCR_STATE_CH2_Msk = 0xc0000
	// Position of OUT_STATE_CH2 field.
	DMA_OUT_STATE_CH2_OUT_STATE_CH2_Pos = 0x14
	// Bit mask of OUT_STATE_CH2 field.
	DMA_OUT_STATE_CH2_OUT_STATE_CH2_Msk = 0x700000

	// OUT_EOF_DES_ADDR_CH2: DMA_OUT_EOF_DES_ADDR_CH2_REG.
	// Position of OUT_EOF_DES_ADDR_CH2 field.
	DMA_OUT_EOF_DES_ADDR_CH2_OUT_EOF_DES_ADDR_CH2_Pos = 0x0
	// Bit mask of OUT_EOF_DES_ADDR_CH2 field.
	DMA_OUT_EOF_DES_ADDR_CH2_OUT_EOF_DES_ADDR_CH2_Msk = 0xffffffff

	// OUT_EOF_BFR_DES_ADDR_CH2: DMA_OUT_EOF_BFR_DES_ADDR_CH2_REG.
	// Position of OUT_EOF_BFR_DES_ADDR_CH2 field.
	DMA_OUT_EOF_BFR_DES_ADDR_CH2_OUT_EOF_BFR_DES_ADDR_CH2_Pos = 0x0
	// Bit mask of OUT_EOF_BFR_DES_ADDR_CH2 field.
	DMA_OUT_EOF_BFR_DES_ADDR_CH2_OUT_EOF_BFR_DES_ADDR_CH2_Msk = 0xffffffff

	// OUT_DSCR_CH2: DMA_OUT_DSCR_CH2_REG.
	// Position of OUTLINK_DSCR_CH2 field.
	DMA_OUT_DSCR_CH2_OUTLINK_DSCR_CH2_Pos = 0x0
	// Bit mask of OUTLINK_DSCR_CH2 field.
	DMA_OUT_DSCR_CH2_OUTLINK_DSCR_CH2_Msk = 0xffffffff

	// OUT_DSCR_BF0_CH2: DMA_OUT_DSCR_BF0_CH2_REG.
	// Position of OUTLINK_DSCR_BF0_CH2 field.
	DMA_OUT_DSCR_BF0_CH2_OUTLINK_DSCR_BF0_CH2_Pos = 0x0
	// Bit mask of OUTLINK_DSCR_BF0_CH2 field.
	DMA_OUT_DSCR_BF0_CH2_OUTLINK_DSCR_BF0_CH2_Msk = 0xffffffff

	// OUT_DSCR_BF1_CH2: DMA_OUT_DSCR_BF1_CH2_REG.
	// Position of OUTLINK_DSCR_BF1_CH2 field.
	DMA_OUT_DSCR_BF1_CH2_OUTLINK_DSCR_BF1_CH2_Pos = 0x0
	// Bit mask of OUTLINK_DSCR_BF1_CH2 field.
	DMA_OUT_DSCR_BF1_CH2_OUTLINK_DSCR_BF1_CH2_Msk = 0xffffffff

	// OUT_PRI_CH2: DMA_OUT_PRI_CH2_REG.
	// Position of TX_PRI_CH2 field.
	DMA_OUT_PRI_CH2_TX_PRI_CH2_Pos = 0x0
	// Bit mask of TX_PRI_CH2 field.
	DMA_OUT_PRI_CH2_TX_PRI_CH2_Msk = 0xf

	// OUT_PERI_SEL_CH2: DMA_OUT_PERI_SEL_CH2_REG.
	// Position of PERI_OUT_SEL_CH2 field.
	DMA_OUT_PERI_SEL_CH2_PERI_OUT_SEL_CH2_Pos = 0x0
	// Bit mask of PERI_OUT_SEL_CH2 field.
	DMA_OUT_PERI_SEL_CH2_PERI_OUT_SEL_CH2_Msk = 0x3f
)

// Constants for DS: Peripheral DS
const (
	// SET_START: DS start control register
	// Position of SET_START field.
	DS_SET_START_SET_START_Pos = 0x0
	// Bit mask of SET_START field.
	DS_SET_START_SET_START_Msk = 0x1
	// Bit SET_START.
	DS_SET_START_SET_START = 0x1

	// SET_CONTINUE: DS continue control register
	// Position of SET_CONTINUE field.
	DS_SET_CONTINUE_SET_CONTINUE_Pos = 0x0
	// Bit mask of SET_CONTINUE field.
	DS_SET_CONTINUE_SET_CONTINUE_Msk = 0x1
	// Bit SET_CONTINUE.
	DS_SET_CONTINUE_SET_CONTINUE = 0x1

	// SET_FINISH: DS finish control register
	// Position of SET_FINISH field.
	DS_SET_FINISH_SET_FINISH_Pos = 0x0
	// Bit mask of SET_FINISH field.
	DS_SET_FINISH_SET_FINISH_Msk = 0x1
	// Bit SET_FINISH.
	DS_SET_FINISH_SET_FINISH = 0x1

	// QUERY_BUSY: DS query busy register
	// Position of QUERY_BUSY field.
	DS_QUERY_BUSY_QUERY_BUSY_Pos = 0x0
	// Bit mask of QUERY_BUSY field.
	DS_QUERY_BUSY_QUERY_BUSY_Msk = 0x1
	// Bit QUERY_BUSY.
	DS_QUERY_BUSY_QUERY_BUSY = 0x1

	// QUERY_KEY_WRONG: DS query key-wrong counter register
	// Position of QUERY_KEY_WRONG field.
	DS_QUERY_KEY_WRONG_QUERY_KEY_WRONG_Pos = 0x0
	// Bit mask of QUERY_KEY_WRONG field.
	DS_QUERY_KEY_WRONG_QUERY_KEY_WRONG_Msk = 0xf

	// QUERY_CHECK: DS query check result register
	// Position of MD_ERROR field.
	DS_QUERY_CHECK_MD_ERROR_Pos = 0x0
	// Bit mask of MD_ERROR field.
	DS_QUERY_CHECK_MD_ERROR_Msk = 0x1
	// Bit MD_ERROR.
	DS_QUERY_CHECK_MD_ERROR = 0x1
	// Position of PADDING_BAD field.
	DS_QUERY_CHECK_PADDING_BAD_Pos = 0x1
	// Bit mask of PADDING_BAD field.
	DS_QUERY_CHECK_PADDING_BAD_Msk = 0x2
	// Bit PADDING_BAD.
	DS_QUERY_CHECK_PADDING_BAD = 0x2

	// DATE: DS version control register
	// Position of DATE field.
	DS_DATE_DATE_Pos = 0x0
	// Bit mask of DATE field.
	DS_DATE_DATE_Msk = 0x3fffffff
)

// Constants for EFUSE: Peripheral EFUSE
const (
	// PGM_DATA0: Register 0 that stores data to be programmed.
	// Position of PGM_DATA_0 field.
	EFUSE_PGM_DATA0_PGM_DATA_0_Pos = 0x0
	// Bit mask of PGM_DATA_0 field.
	EFUSE_PGM_DATA0_PGM_DATA_0_Msk = 0xffffffff

	// PGM_DATA1: Register 1 that stores data to be programmed.
	// Position of PGM_DATA_1 field.
	EFUSE_PGM_DATA1_PGM_DATA_1_Pos = 0x0
	// Bit mask of PGM_DATA_1 field.
	EFUSE_PGM_DATA1_PGM_DATA_1_Msk = 0xffffffff

	// PGM_DATA2: Register 2 that stores data to be programmed.
	// Position of PGM_DATA_2 field.
	EFUSE_PGM_DATA2_PGM_DATA_2_Pos = 0x0
	// Bit mask of PGM_DATA_2 field.
	EFUSE_PGM_DATA2_PGM_DATA_2_Msk = 0xffffffff

	// PGM_DATA3: Register 3 that stores data to be programmed.
	// Position of PGM_DATA_3 field.
	EFUSE_PGM_DATA3_PGM_DATA_3_Pos = 0x0
	// Bit mask of PGM_DATA_3 field.
	EFUSE_PGM_DATA3_PGM_DATA_3_Msk = 0xffffffff

	// PGM_DATA4: Register 4 that stores data to be programmed.
	// Position of PGM_DATA_4 field.
	EFUSE_PGM_DATA4_PGM_DATA_4_Pos = 0x0
	// Bit mask of PGM_DATA_4 field.
	EFUSE_PGM_DATA4_PGM_DATA_4_Msk = 0xffffffff

	// PGM_DATA5: Register 5 that stores data to be programmed.
	// Position of PGM_DATA_5 field.
	EFUSE_PGM_DATA5_PGM_DATA_5_Pos = 0x0
	// Bit mask of PGM_DATA_5 field.
	EFUSE_PGM_DATA5_PGM_DATA_5_Msk = 0xffffffff

	// PGM_DATA6: Register 6 that stores data to be programmed.
	// Position of PGM_DATA_6 field.
	EFUSE_PGM_DATA6_PGM_DATA_6_Pos = 0x0
	// Bit mask of PGM_DATA_6 field.
	EFUSE_PGM_DATA6_PGM_DATA_6_Msk = 0xffffffff

	// PGM_DATA7: Register 7 that stores data to be programmed.
	// Position of PGM_DATA_7 field.
	EFUSE_PGM_DATA7_PGM_DATA_7_Pos = 0x0
	// Bit mask of PGM_DATA_7 field.
	EFUSE_PGM_DATA7_PGM_DATA_7_Msk = 0xffffffff

	// PGM_CHECK_VALUE0: Register 0 that stores the RS code to be programmed.
	// Position of PGM_RS_DATA_0 field.
	EFUSE_PGM_CHECK_VALUE0_PGM_RS_DATA_0_Pos = 0x0
	// Bit mask of PGM_RS_DATA_0 field.
	EFUSE_PGM_CHECK_VALUE0_PGM_RS_DATA_0_Msk = 0xffffffff

	// PGM_CHECK_VALUE1: Register 1 that stores the RS code to be programmed.
	// Position of PGM_RS_DATA_1 field.
	EFUSE_PGM_CHECK_VALUE1_PGM_RS_DATA_1_Pos = 0x0
	// Bit mask of PGM_RS_DATA_1 field.
	EFUSE_PGM_CHECK_VALUE1_PGM_RS_DATA_1_Msk = 0xffffffff

	// PGM_CHECK_VALUE2: Register 2 that stores the RS code to be programmed.
	// Position of PGM_RS_DATA_2 field.
	EFUSE_PGM_CHECK_VALUE2_PGM_RS_DATA_2_Pos = 0x0
	// Bit mask of PGM_RS_DATA_2 field.
	EFUSE_PGM_CHECK_VALUE2_PGM_RS_DATA_2_Msk = 0xffffffff

	// RD_WR_DIS: BLOCK0 data register 0.
	// Position of WR_DIS field.
	EFUSE_RD_WR_DIS_WR_DIS_Pos = 0x0
	// Bit mask of WR_DIS field.
	EFUSE_RD_WR_DIS_WR_DIS_Msk = 0xffffffff

	// RD_REPEAT_DATA0: BLOCK0 data register 1.
	// Position of RD_DIS field.
	EFUSE_RD_REPEAT_DATA0_RD_DIS_Pos = 0x0
	// Bit mask of RD_DIS field.
	EFUSE_RD_REPEAT_DATA0_RD_DIS_Msk = 0x7f
	// Position of DIS_RTC_RAM_BOOT field.
	EFUSE_RD_REPEAT_DATA0_DIS_RTC_RAM_BOOT_Pos = 0x7
	// Bit mask of DIS_RTC_RAM_BOOT field.
	EFUSE_RD_REPEAT_DATA0_DIS_RTC_RAM_BOOT_Msk = 0x80
	// Bit DIS_RTC_RAM_BOOT.
	EFUSE_RD_REPEAT_DATA0_DIS_RTC_RAM_BOOT = 0x80
	// Position of DIS_ICACHE field.
	EFUSE_RD_REPEAT_DATA0_DIS_ICACHE_Pos = 0x8
	// Bit mask of DIS_ICACHE field.
	EFUSE_RD_REPEAT_DATA0_DIS_ICACHE_Msk = 0x100
	// Bit DIS_ICACHE.
	EFUSE_RD_REPEAT_DATA0_DIS_ICACHE = 0x100
	// Position of DIS_USB_JTAG field.
	EFUSE_RD_REPEAT_DATA0_DIS_USB_JTAG_Pos = 0x9
	// Bit mask of DIS_USB_JTAG field.
	EFUSE_RD_REPEAT_DATA0_DIS_USB_JTAG_Msk = 0x200
	// Bit DIS_USB_JTAG.
	EFUSE_RD_REPEAT_DATA0_DIS_USB_JTAG = 0x200
	// Position of DIS_DOWNLOAD_ICACHE field.
	EFUSE_RD_REPEAT_DATA0_DIS_DOWNLOAD_ICACHE_Pos = 0xa
	// Bit mask of DIS_DOWNLOAD_ICACHE field.
	EFUSE_RD_REPEAT_DATA0_DIS_DOWNLOAD_ICACHE_Msk = 0x400
	// Bit DIS_DOWNLOAD_ICACHE.
	EFUSE_RD_REPEAT_DATA0_DIS_DOWNLOAD_ICACHE = 0x400
	// Position of DIS_USB_DEVICE field.
	EFUSE_RD_REPEAT_DATA0_DIS_USB_DEVICE_Pos = 0xb
	// Bit mask of DIS_USB_DEVICE field.
	EFUSE_RD_REPEAT_DATA0_DIS_USB_DEVICE_Msk = 0x800
	// Bit DIS_USB_DEVICE.
	EFUSE_RD_REPEAT_DATA0_DIS_USB_DEVICE = 0x800
	// Position of DIS_FORCE_DOWNLOAD field.
	EFUSE_RD_REPEAT_DATA0_DIS_FORCE_DOWNLOAD_Pos = 0xc
	// Bit mask of DIS_FORCE_DOWNLOAD field.
	EFUSE_RD_REPEAT_DATA0_DIS_FORCE_DOWNLOAD_Msk = 0x1000
	// Bit DIS_FORCE_DOWNLOAD.
	EFUSE_RD_REPEAT_DATA0_DIS_FORCE_DOWNLOAD = 0x1000
	// Position of RPT4_RESERVED6 field.
	EFUSE_RD_REPEAT_DATA0_RPT4_RESERVED6_Pos = 0xd
	// Bit mask of RPT4_RESERVED6 field.
	EFUSE_RD_REPEAT_DATA0_RPT4_RESERVED6_Msk = 0x2000
	// Bit RPT4_RESERVED6.
	EFUSE_RD_REPEAT_DATA0_RPT4_RESERVED6 = 0x2000
	// Position of DIS_CAN field.
	EFUSE_RD_REPEAT_DATA0_DIS_CAN_Pos = 0xe
	// Bit mask of DIS_CAN field.
	EFUSE_RD_REPEAT_DATA0_DIS_CAN_Msk = 0x4000
	// Bit DIS_CAN.
	EFUSE_RD_REPEAT_DATA0_DIS_CAN = 0x4000
	// Position of JTAG_SEL_ENABLE field.
	EFUSE_RD_REPEAT_DATA0_JTAG_SEL_ENABLE_Pos = 0xf
	// Bit mask of JTAG_SEL_ENABLE field.
	EFUSE_RD_REPEAT_DATA0_JTAG_SEL_ENABLE_Msk = 0x8000
	// Bit JTAG_SEL_ENABLE.
	EFUSE_RD_REPEAT_DATA0_JTAG_SEL_ENABLE = 0x8000
	// Position of SOFT_DIS_JTAG field.
	EFUSE_RD_REPEAT_DATA0_SOFT_DIS_JTAG_Pos = 0x10
	// Bit mask of SOFT_DIS_JTAG field.
	EFUSE_RD_REPEAT_DATA0_SOFT_DIS_JTAG_Msk = 0x70000
	// Position of DIS_PAD_JTAG field.
	EFUSE_RD_REPEAT_DATA0_DIS_PAD_JTAG_Pos = 0x13
	// Bit mask of DIS_PAD_JTAG field.
	EFUSE_RD_REPEAT_DATA0_DIS_PAD_JTAG_Msk = 0x80000
	// Bit DIS_PAD_JTAG.
	EFUSE_RD_REPEAT_DATA0_DIS_PAD_JTAG = 0x80000
	// Position of DIS_DOWNLOAD_MANUAL_ENCRYPT field.
	EFUSE_RD_REPEAT_DATA0_DIS_DOWNLOAD_MANUAL_ENCRYPT_Pos = 0x14
	// Bit mask of DIS_DOWNLOAD_MANUAL_ENCRYPT field.
	EFUSE_RD_REPEAT_DATA0_DIS_DOWNLOAD_MANUAL_ENCRYPT_Msk = 0x100000
	// Bit DIS_DOWNLOAD_MANUAL_ENCRYPT.
	EFUSE_RD_REPEAT_DATA0_DIS_DOWNLOAD_MANUAL_ENCRYPT = 0x100000
	// Position of USB_DREFH field.
	EFUSE_RD_REPEAT_DATA0_USB_DREFH_Pos = 0x15
	// Bit mask of USB_DREFH field.
	EFUSE_RD_REPEAT_DATA0_USB_DREFH_Msk = 0x600000
	// Position of USB_DREFL field.
	EFUSE_RD_REPEAT_DATA0_USB_DREFL_Pos = 0x17
	// Bit mask of USB_DREFL field.
	EFUSE_RD_REPEAT_DATA0_USB_DREFL_Msk = 0x1800000
	// Position of USB_EXCHG_PINS field.
	EFUSE_RD_REPEAT_DATA0_USB_EXCHG_PINS_Pos = 0x19
	// Bit mask of USB_EXCHG_PINS field.
	EFUSE_RD_REPEAT_DATA0_USB_EXCHG_PINS_Msk = 0x2000000
	// Bit USB_EXCHG_PINS.
	EFUSE_RD_REPEAT_DATA0_USB_EXCHG_PINS = 0x2000000
	// Position of VDD_SPI_AS_GPIO field.
	EFUSE_RD_REPEAT_DATA0_VDD_SPI_AS_GPIO_Pos = 0x1a
	// Bit mask of VDD_SPI_AS_GPIO field.
	EFUSE_RD_REPEAT_DATA0_VDD_SPI_AS_GPIO_Msk = 0x4000000
	// Bit VDD_SPI_AS_GPIO.
	EFUSE_RD_REPEAT_DATA0_VDD_SPI_AS_GPIO = 0x4000000
	// Position of BTLC_GPIO_ENABLE field.
	EFUSE_RD_REPEAT_DATA0_BTLC_GPIO_ENABLE_Pos = 0x1b
	// Bit mask of BTLC_GPIO_ENABLE field.
	EFUSE_RD_REPEAT_DATA0_BTLC_GPIO_ENABLE_Msk = 0x18000000
	// Position of POWERGLITCH_EN field.
	EFUSE_RD_REPEAT_DATA0_POWERGLITCH_EN_Pos = 0x1d
	// Bit mask of POWERGLITCH_EN field.
	EFUSE_RD_REPEAT_DATA0_POWERGLITCH_EN_Msk = 0x20000000
	// Bit POWERGLITCH_EN.
	EFUSE_RD_REPEAT_DATA0_POWERGLITCH_EN = 0x20000000
	// Position of POWER_GLITCH_DSENSE field.
	EFUSE_RD_REPEAT_DATA0_POWER_GLITCH_DSENSE_Pos = 0x1e
	// Bit mask of POWER_GLITCH_DSENSE field.
	EFUSE_RD_REPEAT_DATA0_POWER_GLITCH_DSENSE_Msk = 0xc0000000

	// RD_REPEAT_DATA1: BLOCK0 data register 2.
	// Position of RPT4_RESERVED2 field.
	EFUSE_RD_REPEAT_DATA1_RPT4_RESERVED2_Pos = 0x0
	// Bit mask of RPT4_RESERVED2 field.
	EFUSE_RD_REPEAT_DATA1_RPT4_RESERVED2_Msk = 0xffff
	// Position of WDT_DELAY_SEL field.
	EFUSE_RD_REPEAT_DATA1_WDT_DELAY_SEL_Pos = 0x10
	// Bit mask of WDT_DELAY_SEL field.
	EFUSE_RD_REPEAT_DATA1_WDT_DELAY_SEL_Msk = 0x30000
	// Position of SPI_BOOT_CRYPT_CNT field.
	EFUSE_RD_REPEAT_DATA1_SPI_BOOT_CRYPT_CNT_Pos = 0x12
	// Bit mask of SPI_BOOT_CRYPT_CNT field.
	EFUSE_RD_REPEAT_DATA1_SPI_BOOT_CRYPT_CNT_Msk = 0x1c0000
	// Position of SECURE_BOOT_KEY_REVOKE0 field.
	EFUSE_RD_REPEAT_DATA1_SECURE_BOOT_KEY_REVOKE0_Pos = 0x15
	// Bit mask of SECURE_BOOT_KEY_REVOKE0 field.
	EFUSE_RD_REPEAT_DATA1_SECURE_BOOT_KEY_REVOKE0_Msk = 0x200000
	// Bit SECURE_BOOT_KEY_REVOKE0.
	EFUSE_RD_REPEAT_DATA1_SECURE_BOOT_KEY_REVOKE0 = 0x200000
	// Position of SECURE_BOOT_KEY_REVOKE1 field.
	EFUSE_RD_REPEAT_DATA1_SECURE_BOOT_KEY_REVOKE1_Pos = 0x16
	// Bit mask of SECURE_BOOT_KEY_REVOKE1 field.
	EFUSE_RD_REPEAT_DATA1_SECURE_BOOT_KEY_REVOKE1_Msk = 0x400000
	// Bit SECURE_BOOT_KEY_REVOKE1.
	EFUSE_RD_REPEAT_DATA1_SECURE_BOOT_KEY_REVOKE1 = 0x400000
	// Position of SECURE_BOOT_KEY_REVOKE2 field.
	EFUSE_RD_REPEAT_DATA1_SECURE_BOOT_KEY_REVOKE2_Pos = 0x17
	// Bit mask of SECURE_BOOT_KEY_REVOKE2 field.
	EFUSE_RD_REPEAT_DATA1_SECURE_BOOT_KEY_REVOKE2_Msk = 0x800000
	// Bit SECURE_BOOT_KEY_REVOKE2.
	EFUSE_RD_REPEAT_DATA1_SECURE_BOOT_KEY_REVOKE2 = 0x800000
	// Position of KEY_PURPOSE_0 field.
	EFUSE_RD_REPEAT_DATA1_KEY_PURPOSE_0_Pos = 0x18
	// Bit mask of KEY_PURPOSE_0 field.
	EFUSE_RD_REPEAT_DATA1_KEY_PURPOSE_0_Msk = 0xf000000
	// Position of KEY_PURPOSE_1 field.
	EFUSE_RD_REPEAT_DATA1_KEY_PURPOSE_1_Pos = 0x1c
	// Bit mask of KEY_PURPOSE_1 field.
	EFUSE_RD_REPEAT_DATA1_KEY_PURPOSE_1_Msk = 0xf0000000

	// RD_REPEAT_DATA2: BLOCK0 data register 3.
	// Position of KEY_PURPOSE_2 field.
	EFUSE_RD_REPEAT_DATA2_KEY_PURPOSE_2_Pos = 0x0
	// Bit mask of KEY_PURPOSE_2 field.
	EFUSE_RD_REPEAT_DATA2_KEY_PURPOSE_2_Msk = 0xf
	// Position of KEY_PURPOSE_3 field.
	EFUSE_RD_REPEAT_DATA2_KEY_PURPOSE_3_Pos = 0x4
	// Bit mask of KEY_PURPOSE_3 field.
	EFUSE_RD_REPEAT_DATA2_KEY_PURPOSE_3_Msk = 0xf0
	// Position of KEY_PURPOSE_4 field.
	EFUSE_RD_REPEAT_DATA2_KEY_PURPOSE_4_Pos = 0x8
	// Bit mask of KEY_PURPOSE_4 field.
	EFUSE_RD_REPEAT_DATA2_KEY_PURPOSE_4_Msk = 0xf00
	// Position of KEY_PURPOSE_5 field.
	EFUSE_RD_REPEAT_DATA2_KEY_PURPOSE_5_Pos = 0xc
	// Bit mask of KEY_PURPOSE_5 field.
	EFUSE_RD_REPEAT_DATA2_KEY_PURPOSE_5_Msk = 0xf000
	// Position of RPT4_RESERVED3 field.
	EFUSE_RD_REPEAT_DATA2_RPT4_RESERVED3_Pos = 0x10
	// Bit mask of RPT4_RESERVED3 field.
	EFUSE_RD_REPEAT_DATA2_RPT4_RESERVED3_Msk = 0xf0000
	// Position of SECURE_BOOT_EN field.
	EFUSE_RD_REPEAT_DATA2_SECURE_BOOT_EN_Pos = 0x14
	// Bit mask of SECURE_BOOT_EN field.
	EFUSE_RD_REPEAT_DATA2_SECURE_BOOT_EN_Msk = 0x100000
	// Bit SECURE_BOOT_EN.
	EFUSE_RD_REPEAT_DATA2_SECURE_BOOT_EN = 0x100000
	// Position of SECURE_BOOT_AGGRESSIVE_REVOKE field.
	EFUSE_RD_REPEAT_DATA2_SECURE_BOOT_AGGRESSIVE_REVOKE_Pos = 0x15
	// Bit mask of SECURE_BOOT_AGGRESSIVE_REVOKE field.
	EFUSE_RD_REPEAT_DATA2_SECURE_BOOT_AGGRESSIVE_REVOKE_Msk = 0x200000
	// Bit SECURE_BOOT_AGGRESSIVE_REVOKE.
	EFUSE_RD_REPEAT_DATA2_SECURE_BOOT_AGGRESSIVE_REVOKE = 0x200000
	// Position of RPT4_RESERVED0 field.
	EFUSE_RD_REPEAT_DATA2_RPT4_RESERVED0_Pos = 0x16
	// Bit mask of RPT4_RESERVED0 field.
	EFUSE_RD_REPEAT_DATA2_RPT4_RESERVED0_Msk = 0xfc00000
	// Position of FLASH_TPUW field.
	EFUSE_RD_REPEAT_DATA2_FLASH_TPUW_Pos = 0x1c
	// Bit mask of FLASH_TPUW field.
	EFUSE_RD_REPEAT_DATA2_FLASH_TPUW_Msk = 0xf0000000

	// RD_REPEAT_DATA3: BLOCK0 data register 4.
	// Position of DIS_DOWNLOAD_MODE field.
	EFUSE_RD_REPEAT_DATA3_DIS_DOWNLOAD_MODE_Pos = 0x0
	// Bit mask of DIS_DOWNLOAD_MODE field.
	EFUSE_RD_REPEAT_DATA3_DIS_DOWNLOAD_MODE_Msk = 0x1
	// Bit DIS_DOWNLOAD_MODE.
	EFUSE_RD_REPEAT_DATA3_DIS_DOWNLOAD_MODE = 0x1
	// Position of DIS_LEGACY_SPI_BOOT field.
	EFUSE_RD_REPEAT_DATA3_DIS_LEGACY_SPI_BOOT_Pos = 0x1
	// Bit mask of DIS_LEGACY_SPI_BOOT field.
	EFUSE_RD_REPEAT_DATA3_DIS_LEGACY_SPI_BOOT_Msk = 0x2
	// Bit DIS_LEGACY_SPI_BOOT.
	EFUSE_RD_REPEAT_DATA3_DIS_LEGACY_SPI_BOOT = 0x2
	// Position of UART_PRINT_CHANNEL field.
	EFUSE_RD_REPEAT_DATA3_UART_PRINT_CHANNEL_Pos = 0x2
	// Bit mask of UART_PRINT_CHANNEL field.
	EFUSE_RD_REPEAT_DATA3_UART_PRINT_CHANNEL_Msk = 0x4
	// Bit UART_PRINT_CHANNEL.
	EFUSE_RD_REPEAT_DATA3_UART_PRINT_CHANNEL = 0x4
	// Position of FLASH_ECC_MODE field.
	EFUSE_RD_REPEAT_DATA3_FLASH_ECC_MODE_Pos = 0x3
	// Bit mask of FLASH_ECC_MODE field.
	EFUSE_RD_REPEAT_DATA3_FLASH_ECC_MODE_Msk = 0x8
	// Bit FLASH_ECC_MODE.
	EFUSE_RD_REPEAT_DATA3_FLASH_ECC_MODE = 0x8
	// Position of DIS_USB_DOWNLOAD_MODE field.
	EFUSE_RD_REPEAT_DATA3_DIS_USB_DOWNLOAD_MODE_Pos = 0x4
	// Bit mask of DIS_USB_DOWNLOAD_MODE field.
	EFUSE_RD_REPEAT_DATA3_DIS_USB_DOWNLOAD_MODE_Msk = 0x10
	// Bit DIS_USB_DOWNLOAD_MODE.
	EFUSE_RD_REPEAT_DATA3_DIS_USB_DOWNLOAD_MODE = 0x10
	// Position of ENABLE_SECURITY_DOWNLOAD field.
	EFUSE_RD_REPEAT_DATA3_ENABLE_SECURITY_DOWNLOAD_Pos = 0x5
	// Bit mask of ENABLE_SECURITY_DOWNLOAD field.
	EFUSE_RD_REPEAT_DATA3_ENABLE_SECURITY_DOWNLOAD_Msk = 0x20
	// Bit ENABLE_SECURITY_DOWNLOAD.
	EFUSE_RD_REPEAT_DATA3_ENABLE_SECURITY_DOWNLOAD = 0x20
	// Position of UART_PRINT_CONTROL field.
	EFUSE_RD_REPEAT_DATA3_UART_PRINT_CONTROL_Pos = 0x6
	// Bit mask of UART_PRINT_CONTROL field.
	EFUSE_RD_REPEAT_DATA3_UART_PRINT_CONTROL_Msk = 0xc0
	// Position of PIN_POWER_SELECTION field.
	EFUSE_RD_REPEAT_DATA3_PIN_POWER_SELECTION_Pos = 0x8
	// Bit mask of PIN_POWER_SELECTION field.
	EFUSE_RD_REPEAT_DATA3_PIN_POWER_SELECTION_Msk = 0x100
	// Bit PIN_POWER_SELECTION.
	EFUSE_RD_REPEAT_DATA3_PIN_POWER_SELECTION = 0x100
	// Position of FLASH_TYPE field.
	EFUSE_RD_REPEAT_DATA3_FLASH_TYPE_Pos = 0x9
	// Bit mask of FLASH_TYPE field.
	EFUSE_RD_REPEAT_DATA3_FLASH_TYPE_Msk = 0x200
	// Bit FLASH_TYPE.
	EFUSE_RD_REPEAT_DATA3_FLASH_TYPE = 0x200
	// Position of FLASH_PAGE_SIZE field.
	EFUSE_RD_REPEAT_DATA3_FLASH_PAGE_SIZE_Pos = 0xa
	// Bit mask of FLASH_PAGE_SIZE field.
	EFUSE_RD_REPEAT_DATA3_FLASH_PAGE_SIZE_Msk = 0xc00
	// Position of FLASH_ECC_EN field.
	EFUSE_RD_REPEAT_DATA3_FLASH_ECC_EN_Pos = 0xc
	// Bit mask of FLASH_ECC_EN field.
	EFUSE_RD_REPEAT_DATA3_FLASH_ECC_EN_Msk = 0x1000
	// Bit FLASH_ECC_EN.
	EFUSE_RD_REPEAT_DATA3_FLASH_ECC_EN = 0x1000
	// Position of FORCE_SEND_RESUME field.
	EFUSE_RD_REPEAT_DATA3_FORCE_SEND_RESUME_Pos = 0xd
	// Bit mask of FORCE_SEND_RESUME field.
	EFUSE_RD_REPEAT_DATA3_FORCE_SEND_RESUME_Msk = 0x2000
	// Bit FORCE_SEND_RESUME.
	EFUSE_RD_REPEAT_DATA3_FORCE_SEND_RESUME = 0x2000
	// Position of SECURE_VERSION field.
	EFUSE_RD_REPEAT_DATA3_SECURE_VERSION_Pos = 0xe
	// Bit mask of SECURE_VERSION field.
	EFUSE_RD_REPEAT_DATA3_SECURE_VERSION_Msk = 0x3fffc000
	// Position of RPT4_RESERVED1 field.
	EFUSE_RD_REPEAT_DATA3_RPT4_RESERVED1_Pos = 0x1e
	// Bit mask of RPT4_RESERVED1 field.
	EFUSE_RD_REPEAT_DATA3_RPT4_RESERVED1_Msk = 0xc0000000

	// RD_REPEAT_DATA4: BLOCK0 data register 5.
	// Position of RPT4_RESERVED4 field.
	EFUSE_RD_REPEAT_DATA4_RPT4_RESERVED4_Pos = 0x0
	// Bit mask of RPT4_RESERVED4 field.
	EFUSE_RD_REPEAT_DATA4_RPT4_RESERVED4_Msk = 0xffffff

	// RD_MAC_SPI_SYS_0: BLOCK1 data register 0.
	// Position of MAC_0 field.
	EFUSE_RD_MAC_SPI_SYS_0_MAC_0_Pos = 0x0
	// Bit mask of MAC_0 field.
	EFUSE_RD_MAC_SPI_SYS_0_MAC_0_Msk = 0xffffffff

	// RD_MAC_SPI_SYS_1: BLOCK1 data register 1.
	// Position of MAC_1 field.
	EFUSE_RD_MAC_SPI_SYS_1_MAC_1_Pos = 0x0
	// Bit mask of MAC_1 field.
	EFUSE_RD_MAC_SPI_SYS_1_MAC_1_Msk = 0xffff
	// Position of SPI_PAD_CONF_0 field.
	EFUSE_RD_MAC_SPI_SYS_1_SPI_PAD_CONF_0_Pos = 0x10
	// Bit mask of SPI_PAD_CONF_0 field.
	EFUSE_RD_MAC_SPI_SYS_1_SPI_PAD_CONF_0_Msk = 0xffff0000

	// RD_MAC_SPI_SYS_2: BLOCK1 data register 2.
	// Position of SPI_PAD_CONF_1 field.
	EFUSE_RD_MAC_SPI_SYS_2_SPI_PAD_CONF_1_Pos = 0x0
	// Bit mask of SPI_PAD_CONF_1 field.
	EFUSE_RD_MAC_SPI_SYS_2_SPI_PAD_CONF_1_Msk = 0xffffffff

	// RD_MAC_SPI_SYS_3: BLOCK1 data register 3.
	// Position of SPI_PAD_CONF_2 field.
	EFUSE_RD_MAC_SPI_SYS_3_SPI_PAD_CONF_2_Pos = 0x0
	// Bit mask of SPI_PAD_CONF_2 field.
	EFUSE_RD_MAC_SPI_SYS_3_SPI_PAD_CONF_2_Msk = 0x3ffff
	// Position of SYS_DATA_PART0_0 field.
	EFUSE_RD_MAC_SPI_SYS_3_SYS_DATA_PART0_0_Pos = 0x12
	// Bit mask of SYS_DATA_PART0_0 field.
	EFUSE_RD_MAC_SPI_SYS_3_SYS_DATA_PART0_0_Msk = 0xfffc0000

	// RD_MAC_SPI_SYS_4: BLOCK1 data register 4.
	// Position of SYS_DATA_PART0_1 field.
	EFUSE_RD_MAC_SPI_SYS_4_SYS_DATA_PART0_1_Pos = 0x0
	// Bit mask of SYS_DATA_PART0_1 field.
	EFUSE_RD_MAC_SPI_SYS_4_SYS_DATA_PART0_1_Msk = 0xffffffff

	// RD_MAC_SPI_SYS_5: BLOCK1 data register 5.
	// Position of SYS_DATA_PART0_2 field.
	EFUSE_RD_MAC_SPI_SYS_5_SYS_DATA_PART0_2_Pos = 0x0
	// Bit mask of SYS_DATA_PART0_2 field.
	EFUSE_RD_MAC_SPI_SYS_5_SYS_DATA_PART0_2_Msk = 0xffffffff

	// RD_SYS_PART1_DATA0: Register 0 of BLOCK2 (system).
	// Position of SYS_DATA_PART1_0 field.
	EFUSE_RD_SYS_PART1_DATA0_SYS_DATA_PART1_0_Pos = 0x0
	// Bit mask of SYS_DATA_PART1_0 field.
	EFUSE_RD_SYS_PART1_DATA0_SYS_DATA_PART1_0_Msk = 0xffffffff

	// RD_SYS_PART1_DATA1: Register 1 of BLOCK2 (system).
	// Position of SYS_DATA_PART1_1 field.
	EFUSE_RD_SYS_PART1_DATA1_SYS_DATA_PART1_1_Pos = 0x0
	// Bit mask of SYS_DATA_PART1_1 field.
	EFUSE_RD_SYS_PART1_DATA1_SYS_DATA_PART1_1_Msk = 0xffffffff

	// RD_SYS_PART1_DATA2: Register 2 of BLOCK2 (system).
	// Position of SYS_DATA_PART1_2 field.
	EFUSE_RD_SYS_PART1_DATA2_SYS_DATA_PART1_2_Pos = 0x0
	// Bit mask of SYS_DATA_PART1_2 field.
	EFUSE_RD_SYS_PART1_DATA2_SYS_DATA_PART1_2_Msk = 0xffffffff

	// RD_SYS_PART1_DATA3: Register 3 of BLOCK2 (system).
	// Position of SYS_DATA_PART1_3 field.
	EFUSE_RD_SYS_PART1_DATA3_SYS_DATA_PART1_3_Pos = 0x0
	// Bit mask of SYS_DATA_PART1_3 field.
	EFUSE_RD_SYS_PART1_DATA3_SYS_DATA_PART1_3_Msk = 0xffffffff

	// RD_SYS_PART1_DATA4: Register 4 of BLOCK2 (system).
	// Position of SYS_DATA_PART1_4 field.
	EFUSE_RD_SYS_PART1_DATA4_SYS_DATA_PART1_4_Pos = 0x0
	// Bit mask of SYS_DATA_PART1_4 field.
	EFUSE_RD_SYS_PART1_DATA4_SYS_DATA_PART1_4_Msk = 0xffffffff

	// RD_SYS_PART1_DATA5: Register 5 of BLOCK2 (system).
	// Position of SYS_DATA_PART1_5 field.
	EFUSE_RD_SYS_PART1_DATA5_SYS_DATA_PART1_5_Pos = 0x0
	// Bit mask of SYS_DATA_PART1_5 field.
	EFUSE_RD_SYS_PART1_DATA5_SYS_DATA_PART1_5_Msk = 0xffffffff

	// RD_SYS_PART1_DATA6: Register 6 of BLOCK2 (system).
	// Position of SYS_DATA_PART1_6 field.
	EFUSE_RD_SYS_PART1_DATA6_SYS_DATA_PART1_6_Pos = 0x0
	// Bit mask of SYS_DATA_PART1_6 field.
	EFUSE_RD_SYS_PART1_DATA6_SYS_DATA_PART1_6_Msk = 0xffffffff

	// RD_SYS_PART1_DATA7: Register 7 of BLOCK2 (system).
	// Position of SYS_DATA_PART1_7 field.
	EFUSE_RD_SYS_PART1_DATA7_SYS_DATA_PART1_7_Pos = 0x0
	// Bit mask of SYS_DATA_PART1_7 field.
	EFUSE_RD_SYS_PART1_DATA7_SYS_DATA_PART1_7_Msk = 0xffffffff

	// RD_USR_DATA0: Register 0 of BLOCK3 (user).
	// Position of USR_DATA0 field.
	EFUSE_RD_USR_DATA0_USR_DATA0_Pos = 0x0
	// Bit mask of USR_DATA0 field.
	EFUSE_RD_USR_DATA0_USR_DATA0_Msk = 0xffffffff

	// RD_USR_DATA1: Register 1 of BLOCK3 (user).
	// Position of USR_DATA1 field.
	EFUSE_RD_USR_DATA1_USR_DATA1_Pos = 0x0
	// Bit mask of USR_DATA1 field.
	EFUSE_RD_USR_DATA1_USR_DATA1_Msk = 0xffffffff

	// RD_USR_DATA2: Register 2 of BLOCK3 (user).
	// Position of USR_DATA2 field.
	EFUSE_RD_USR_DATA2_USR_DATA2_Pos = 0x0
	// Bit mask of USR_DATA2 field.
	EFUSE_RD_USR_DATA2_USR_DATA2_Msk = 0xffffffff

	// RD_USR_DATA3: Register 3 of BLOCK3 (user).
	// Position of USR_DATA3 field.
	EFUSE_RD_USR_DATA3_USR_DATA3_Pos = 0x0
	// Bit mask of USR_DATA3 field.
	EFUSE_RD_USR_DATA3_USR_DATA3_Msk = 0xffffffff

	// RD_USR_DATA4: Register 4 of BLOCK3 (user).
	// Position of USR_DATA4 field.
	EFUSE_RD_USR_DATA4_USR_DATA4_Pos = 0x0
	// Bit mask of USR_DATA4 field.
	EFUSE_RD_USR_DATA4_USR_DATA4_Msk = 0xffffffff

	// RD_USR_DATA5: Register 5 of BLOCK3 (user).
	// Position of USR_DATA5 field.
	EFUSE_RD_USR_DATA5_USR_DATA5_Pos = 0x0
	// Bit mask of USR_DATA5 field.
	EFUSE_RD_USR_DATA5_USR_DATA5_Msk = 0xffffffff

	// RD_USR_DATA6: Register 6 of BLOCK3 (user).
	// Position of USR_DATA6 field.
	EFUSE_RD_USR_DATA6_USR_DATA6_Pos = 0x0
	// Bit mask of USR_DATA6 field.
	EFUSE_RD_USR_DATA6_USR_DATA6_Msk = 0xffffffff

	// RD_USR_DATA7: Register 7 of BLOCK3 (user).
	// Position of USR_DATA7 field.
	EFUSE_RD_USR_DATA7_USR_DATA7_Pos = 0x0
	// Bit mask of USR_DATA7 field.
	EFUSE_RD_USR_DATA7_USR_DATA7_Msk = 0xffffffff

	// RD_KEY0_DATA0: Register 0 of BLOCK4 (KEY0).
	// Position of KEY0_DATA0 field.
	EFUSE_RD_KEY0_DATA0_KEY0_DATA0_Pos = 0x0
	// Bit mask of KEY0_DATA0 field.
	EFUSE_RD_KEY0_DATA0_KEY0_DATA0_Msk = 0xffffffff

	// RD_KEY0_DATA1: Register 1 of BLOCK4 (KEY0).
	// Position of KEY0_DATA1 field.
	EFUSE_RD_KEY0_DATA1_KEY0_DATA1_Pos = 0x0
	// Bit mask of KEY0_DATA1 field.
	EFUSE_RD_KEY0_DATA1_KEY0_DATA1_Msk = 0xffffffff

	// RD_KEY0_DATA2: Register 2 of BLOCK4 (KEY0).
	// Position of KEY0_DATA2 field.
	EFUSE_RD_KEY0_DATA2_KEY0_DATA2_Pos = 0x0
	// Bit mask of KEY0_DATA2 field.
	EFUSE_RD_KEY0_DATA2_KEY0_DATA2_Msk = 0xffffffff

	// RD_KEY0_DATA3: Register 3 of BLOCK4 (KEY0).
	// Position of KEY0_DATA3 field.
	EFUSE_RD_KEY0_DATA3_KEY0_DATA3_Pos = 0x0
	// Bit mask of KEY0_DATA3 field.
	EFUSE_RD_KEY0_DATA3_KEY0_DATA3_Msk = 0xffffffff

	// RD_KEY0_DATA4: Register 4 of BLOCK4 (KEY0).
	// Position of KEY0_DATA4 field.
	EFUSE_RD_KEY0_DATA4_KEY0_DATA4_Pos = 0x0
	// Bit mask of KEY0_DATA4 field.
	EFUSE_RD_KEY0_DATA4_KEY0_DATA4_Msk = 0xffffffff

	// RD_KEY0_DATA5: Register 5 of BLOCK4 (KEY0).
	// Position of KEY0_DATA5 field.
	EFUSE_RD_KEY0_DATA5_KEY0_DATA5_Pos = 0x0
	// Bit mask of KEY0_DATA5 field.
	EFUSE_RD_KEY0_DATA5_KEY0_DATA5_Msk = 0xffffffff

	// RD_KEY0_DATA6: Register 6 of BLOCK4 (KEY0).
	// Position of KEY0_DATA6 field.
	EFUSE_RD_KEY0_DATA6_KEY0_DATA6_Pos = 0x0
	// Bit mask of KEY0_DATA6 field.
	EFUSE_RD_KEY0_DATA6_KEY0_DATA6_Msk = 0xffffffff

	// RD_KEY0_DATA7: Register 7 of BLOCK4 (KEY0).
	// Position of KEY0_DATA7 field.
	EFUSE_RD_KEY0_DATA7_KEY0_DATA7_Pos = 0x0
	// Bit mask of KEY0_DATA7 field.
	EFUSE_RD_KEY0_DATA7_KEY0_DATA7_Msk = 0xffffffff

	// RD_KEY1_DATA0: Register 0 of BLOCK5 (KEY1).
	// Position of KEY1_DATA0 field.
	EFUSE_RD_KEY1_DATA0_KEY1_DATA0_Pos = 0x0
	// Bit mask of KEY1_DATA0 field.
	EFUSE_RD_KEY1_DATA0_KEY1_DATA0_Msk = 0xffffffff

	// RD_KEY1_DATA1: Register 1 of BLOCK5 (KEY1).
	// Position of KEY1_DATA1 field.
	EFUSE_RD_KEY1_DATA1_KEY1_DATA1_Pos = 0x0
	// Bit mask of KEY1_DATA1 field.
	EFUSE_RD_KEY1_DATA1_KEY1_DATA1_Msk = 0xffffffff

	// RD_KEY1_DATA2: Register 2 of BLOCK5 (KEY1).
	// Position of KEY1_DATA2 field.
	EFUSE_RD_KEY1_DATA2_KEY1_DATA2_Pos = 0x0
	// Bit mask of KEY1_DATA2 field.
	EFUSE_RD_KEY1_DATA2_KEY1_DATA2_Msk = 0xffffffff

	// RD_KEY1_DATA3: Register 3 of BLOCK5 (KEY1).
	// Position of KEY1_DATA3 field.
	EFUSE_RD_KEY1_DATA3_KEY1_DATA3_Pos = 0x0
	// Bit mask of KEY1_DATA3 field.
	EFUSE_RD_KEY1_DATA3_KEY1_DATA3_Msk = 0xffffffff

	// RD_KEY1_DATA4: Register 4 of BLOCK5 (KEY1).
	// Position of KEY1_DATA4 field.
	EFUSE_RD_KEY1_DATA4_KEY1_DATA4_Pos = 0x0
	// Bit mask of KEY1_DATA4 field.
	EFUSE_RD_KEY1_DATA4_KEY1_DATA4_Msk = 0xffffffff

	// RD_KEY1_DATA5: Register 5 of BLOCK5 (KEY1).
	// Position of KEY1_DATA5 field.
	EFUSE_RD_KEY1_DATA5_KEY1_DATA5_Pos = 0x0
	// Bit mask of KEY1_DATA5 field.
	EFUSE_RD_KEY1_DATA5_KEY1_DATA5_Msk = 0xffffffff

	// RD_KEY1_DATA6: Register 6 of BLOCK5 (KEY1).
	// Position of KEY1_DATA6 field.
	EFUSE_RD_KEY1_DATA6_KEY1_DATA6_Pos = 0x0
	// Bit mask of KEY1_DATA6 field.
	EFUSE_RD_KEY1_DATA6_KEY1_DATA6_Msk = 0xffffffff

	// RD_KEY1_DATA7: Register 7 of BLOCK5 (KEY1).
	// Position of KEY1_DATA7 field.
	EFUSE_RD_KEY1_DATA7_KEY1_DATA7_Pos = 0x0
	// Bit mask of KEY1_DATA7 field.
	EFUSE_RD_KEY1_DATA7_KEY1_DATA7_Msk = 0xffffffff

	// RD_KEY2_DATA0: Register 0 of BLOCK6 (KEY2).
	// Position of KEY2_DATA0 field.
	EFUSE_RD_KEY2_DATA0_KEY2_DATA0_Pos = 0x0
	// Bit mask of KEY2_DATA0 field.
	EFUSE_RD_KEY2_DATA0_KEY2_DATA0_Msk = 0xffffffff

	// RD_KEY2_DATA1: Register 1 of BLOCK6 (KEY2).
	// Position of KEY2_DATA1 field.
	EFUSE_RD_KEY2_DATA1_KEY2_DATA1_Pos = 0x0
	// Bit mask of KEY2_DATA1 field.
	EFUSE_RD_KEY2_DATA1_KEY2_DATA1_Msk = 0xffffffff

	// RD_KEY2_DATA2: Register 2 of BLOCK6 (KEY2).
	// Position of KEY2_DATA2 field.
	EFUSE_RD_KEY2_DATA2_KEY2_DATA2_Pos = 0x0
	// Bit mask of KEY2_DATA2 field.
	EFUSE_RD_KEY2_DATA2_KEY2_DATA2_Msk = 0xffffffff

	// RD_KEY2_DATA3: Register 3 of BLOCK6 (KEY2).
	// Position of KEY2_DATA3 field.
	EFUSE_RD_KEY2_DATA3_KEY2_DATA3_Pos = 0x0
	// Bit mask of KEY2_DATA3 field.
	EFUSE_RD_KEY2_DATA3_KEY2_DATA3_Msk = 0xffffffff

	// RD_KEY2_DATA4: Register 4 of BLOCK6 (KEY2).
	// Position of KEY2_DATA4 field.
	EFUSE_RD_KEY2_DATA4_KEY2_DATA4_Pos = 0x0
	// Bit mask of KEY2_DATA4 field.
	EFUSE_RD_KEY2_DATA4_KEY2_DATA4_Msk = 0xffffffff

	// RD_KEY2_DATA5: Register 5 of BLOCK6 (KEY2).
	// Position of KEY2_DATA5 field.
	EFUSE_RD_KEY2_DATA5_KEY2_DATA5_Pos = 0x0
	// Bit mask of KEY2_DATA5 field.
	EFUSE_RD_KEY2_DATA5_KEY2_DATA5_Msk = 0xffffffff

	// RD_KEY2_DATA6: Register 6 of BLOCK6 (KEY2).
	// Position of KEY2_DATA6 field.
	EFUSE_RD_KEY2_DATA6_KEY2_DATA6_Pos = 0x0
	// Bit mask of KEY2_DATA6 field.
	EFUSE_RD_KEY2_DATA6_KEY2_DATA6_Msk = 0xffffffff

	// RD_KEY2_DATA7: Register 7 of BLOCK6 (KEY2).
	// Position of KEY2_DATA7 field.
	EFUSE_RD_KEY2_DATA7_KEY2_DATA7_Pos = 0x0
	// Bit mask of KEY2_DATA7 field.
	EFUSE_RD_KEY2_DATA7_KEY2_DATA7_Msk = 0xffffffff

	// RD_KEY3_DATA0: Register 0 of BLOCK7 (KEY3).
	// Position of KEY3_DATA0 field.
	EFUSE_RD_KEY3_DATA0_KEY3_DATA0_Pos = 0x0
	// Bit mask of KEY3_DATA0 field.
	EFUSE_RD_KEY3_DATA0_KEY3_DATA0_Msk = 0xffffffff

	// RD_KEY3_DATA1: Register 1 of BLOCK7 (KEY3).
	// Position of KEY3_DATA1 field.
	EFUSE_RD_KEY3_DATA1_KEY3_DATA1_Pos = 0x0
	// Bit mask of KEY3_DATA1 field.
	EFUSE_RD_KEY3_DATA1_KEY3_DATA1_Msk = 0xffffffff

	// RD_KEY3_DATA2: Register 2 of BLOCK7 (KEY3).
	// Position of KEY3_DATA2 field.
	EFUSE_RD_KEY3_DATA2_KEY3_DATA2_Pos = 0x0
	// Bit mask of KEY3_DATA2 field.
	EFUSE_RD_KEY3_DATA2_KEY3_DATA2_Msk = 0xffffffff

	// RD_KEY3_DATA3: Register 3 of BLOCK7 (KEY3).
	// Position of KEY3_DATA3 field.
	EFUSE_RD_KEY3_DATA3_KEY3_DATA3_Pos = 0x0
	// Bit mask of KEY3_DATA3 field.
	EFUSE_RD_KEY3_DATA3_KEY3_DATA3_Msk = 0xffffffff

	// RD_KEY3_DATA4: Register 4 of BLOCK7 (KEY3).
	// Position of KEY3_DATA4 field.
	EFUSE_RD_KEY3_DATA4_KEY3_DATA4_Pos = 0x0
	// Bit mask of KEY3_DATA4 field.
	EFUSE_RD_KEY3_DATA4_KEY3_DATA4_Msk = 0xffffffff

	// RD_KEY3_DATA5: Register 5 of BLOCK7 (KEY3).
	// Position of KEY3_DATA5 field.
	EFUSE_RD_KEY3_DATA5_KEY3_DATA5_Pos = 0x0
	// Bit mask of KEY3_DATA5 field.
	EFUSE_RD_KEY3_DATA5_KEY3_DATA5_Msk = 0xffffffff

	// RD_KEY3_DATA6: Register 6 of BLOCK7 (KEY3).
	// Position of KEY3_DATA6 field.
	EFUSE_RD_KEY3_DATA6_KEY3_DATA6_Pos = 0x0
	// Bit mask of KEY3_DATA6 field.
	EFUSE_RD_KEY3_DATA6_KEY3_DATA6_Msk = 0xffffffff

	// RD_KEY3_DATA7: Register 7 of BLOCK7 (KEY3).
	// Position of KEY3_DATA7 field.
	EFUSE_RD_KEY3_DATA7_KEY3_DATA7_Pos = 0x0
	// Bit mask of KEY3_DATA7 field.
	EFUSE_RD_KEY3_DATA7_KEY3_DATA7_Msk = 0xffffffff

	// RD_KEY4_DATA0: Register 0 of BLOCK8 (KEY4).
	// Position of KEY4_DATA0 field.
	EFUSE_RD_KEY4_DATA0_KEY4_DATA0_Pos = 0x0
	// Bit mask of KEY4_DATA0 field.
	EFUSE_RD_KEY4_DATA0_KEY4_DATA0_Msk = 0xffffffff

	// RD_KEY4_DATA1: Register 1 of BLOCK8 (KEY4).
	// Position of KEY4_DATA1 field.
	EFUSE_RD_KEY4_DATA1_KEY4_DATA1_Pos = 0x0
	// Bit mask of KEY4_DATA1 field.
	EFUSE_RD_KEY4_DATA1_KEY4_DATA1_Msk = 0xffffffff

	// RD_KEY4_DATA2: Register 2 of BLOCK8 (KEY4).
	// Position of KEY4_DATA2 field.
	EFUSE_RD_KEY4_DATA2_KEY4_DATA2_Pos = 0x0
	// Bit mask of KEY4_DATA2 field.
	EFUSE_RD_KEY4_DATA2_KEY4_DATA2_Msk = 0xffffffff

	// RD_KEY4_DATA3: Register 3 of BLOCK8 (KEY4).
	// Position of KEY4_DATA3 field.
	EFUSE_RD_KEY4_DATA3_KEY4_DATA3_Pos = 0x0
	// Bit mask of KEY4_DATA3 field.
	EFUSE_RD_KEY4_DATA3_KEY4_DATA3_Msk = 0xffffffff

	// RD_KEY4_DATA4: Register 4 of BLOCK8 (KEY4).
	// Position of KEY4_DATA4 field.
	EFUSE_RD_KEY4_DATA4_KEY4_DATA4_Pos = 0x0
	// Bit mask of KEY4_DATA4 field.
	EFUSE_RD_KEY4_DATA4_KEY4_DATA4_Msk = 0xffffffff

	// RD_KEY4_DATA5: Register 5 of BLOCK8 (KEY4).
	// Position of KEY4_DATA5 field.
	EFUSE_RD_KEY4_DATA5_KEY4_DATA5_Pos = 0x0
	// Bit mask of KEY4_DATA5 field.
	EFUSE_RD_KEY4_DATA5_KEY4_DATA5_Msk = 0xffffffff

	// RD_KEY4_DATA6: Register 6 of BLOCK8 (KEY4).
	// Position of KEY4_DATA6 field.
	EFUSE_RD_KEY4_DATA6_KEY4_DATA6_Pos = 0x0
	// Bit mask of KEY4_DATA6 field.
	EFUSE_RD_KEY4_DATA6_KEY4_DATA6_Msk = 0xffffffff

	// RD_KEY4_DATA7: Register 7 of BLOCK8 (KEY4).
	// Position of KEY4_DATA7 field.
	EFUSE_RD_KEY4_DATA7_KEY4_DATA7_Pos = 0x0
	// Bit mask of KEY4_DATA7 field.
	EFUSE_RD_KEY4_DATA7_KEY4_DATA7_Msk = 0xffffffff

	// RD_KEY5_DATA0: Register 0 of BLOCK9 (KEY5).
	// Position of KEY5_DATA0 field.
	EFUSE_RD_KEY5_DATA0_KEY5_DATA0_Pos = 0x0
	// Bit mask of KEY5_DATA0 field.
	EFUSE_RD_KEY5_DATA0_KEY5_DATA0_Msk = 0xffffffff

	// RD_KEY5_DATA1: Register 1 of BLOCK9 (KEY5).
	// Position of KEY5_DATA1 field.
	EFUSE_RD_KEY5_DATA1_KEY5_DATA1_Pos = 0x0
	// Bit mask of KEY5_DATA1 field.
	EFUSE_RD_KEY5_DATA1_KEY5_DATA1_Msk = 0xffffffff

	// RD_KEY5_DATA2: Register 2 of BLOCK9 (KEY5).
	// Position of KEY5_DATA2 field.
	EFUSE_RD_KEY5_DATA2_KEY5_DATA2_Pos = 0x0
	// Bit mask of KEY5_DATA2 field.
	EFUSE_RD_KEY5_DATA2_KEY5_DATA2_Msk = 0xffffffff

	// RD_KEY5_DATA3: Register 3 of BLOCK9 (KEY5).
	// Position of KEY5_DATA3 field.
	EFUSE_RD_KEY5_DATA3_KEY5_DATA3_Pos = 0x0
	// Bit mask of KEY5_DATA3 field.
	EFUSE_RD_KEY5_DATA3_KEY5_DATA3_Msk = 0xffffffff

	// RD_KEY5_DATA4: Register 4 of BLOCK9 (KEY5).
	// Position of KEY5_DATA4 field.
	EFUSE_RD_KEY5_DATA4_KEY5_DATA4_Pos = 0x0
	// Bit mask of KEY5_DATA4 field.
	EFUSE_RD_KEY5_DATA4_KEY5_DATA4_Msk = 0xffffffff

	// RD_KEY5_DATA5: Register 5 of BLOCK9 (KEY5).
	// Position of KEY5_DATA5 field.
	EFUSE_RD_KEY5_DATA5_KEY5_DATA5_Pos = 0x0
	// Bit mask of KEY5_DATA5 field.
	EFUSE_RD_KEY5_DATA5_KEY5_DATA5_Msk = 0xffffffff

	// RD_KEY5_DATA6: Register 6 of BLOCK9 (KEY5).
	// Position of KEY5_DATA6 field.
	EFUSE_RD_KEY5_DATA6_KEY5_DATA6_Pos = 0x0
	// Bit mask of KEY5_DATA6 field.
	EFUSE_RD_KEY5_DATA6_KEY5_DATA6_Msk = 0xffffffff

	// RD_KEY5_DATA7: Register 7 of BLOCK9 (KEY5).
	// Position of KEY5_DATA7 field.
	EFUSE_RD_KEY5_DATA7_KEY5_DATA7_Pos = 0x0
	// Bit mask of KEY5_DATA7 field.
	EFUSE_RD_KEY5_DATA7_KEY5_DATA7_Msk = 0xffffffff

	// RD_SYS_PART2_DATA0: Register 0 of BLOCK10 (system).
	// Position of SYS_DATA_PART2_0 field.
	EFUSE_RD_SYS_PART2_DATA0_SYS_DATA_PART2_0_Pos = 0x0
	// Bit mask of SYS_DATA_PART2_0 field.
	EFUSE_RD_SYS_PART2_DATA0_SYS_DATA_PART2_0_Msk = 0xffffffff

	// RD_SYS_PART2_DATA1: Register 1 of BLOCK9 (KEY5).
	// Position of SYS_DATA_PART2_1 field.
	EFUSE_RD_SYS_PART2_DATA1_SYS_DATA_PART2_1_Pos = 0x0
	// Bit mask of SYS_DATA_PART2_1 field.
	EFUSE_RD_SYS_PART2_DATA1_SYS_DATA_PART2_1_Msk = 0xffffffff

	// RD_SYS_PART2_DATA2: Register 2 of BLOCK10 (system).
	// Position of SYS_DATA_PART2_2 field.
	EFUSE_RD_SYS_PART2_DATA2_SYS_DATA_PART2_2_Pos = 0x0
	// Bit mask of SYS_DATA_PART2_2 field.
	EFUSE_RD_SYS_PART2_DATA2_SYS_DATA_PART2_2_Msk = 0xffffffff

	// RD_SYS_PART2_DATA3: Register 3 of BLOCK10 (system).
	// Position of SYS_DATA_PART2_3 field.
	EFUSE_RD_SYS_PART2_DATA3_SYS_DATA_PART2_3_Pos = 0x0
	// Bit mask of SYS_DATA_PART2_3 field.
	EFUSE_RD_SYS_PART2_DATA3_SYS_DATA_PART2_3_Msk = 0xffffffff

	// RD_SYS_PART2_DATA4: Register 4 of BLOCK10 (system).
	// Position of SYS_DATA_PART2_4 field.
	EFUSE_RD_SYS_PART2_DATA4_SYS_DATA_PART2_4_Pos = 0x0
	// Bit mask of SYS_DATA_PART2_4 field.
	EFUSE_RD_SYS_PART2_DATA4_SYS_DATA_PART2_4_Msk = 0xffffffff

	// RD_SYS_PART2_DATA5: Register 5 of BLOCK10 (system).
	// Position of SYS_DATA_PART2_5 field.
	EFUSE_RD_SYS_PART2_DATA5_SYS_DATA_PART2_5_Pos = 0x0
	// Bit mask of SYS_DATA_PART2_5 field.
	EFUSE_RD_SYS_PART2_DATA5_SYS_DATA_PART2_5_Msk = 0xffffffff

	// RD_SYS_PART2_DATA6: Register 6 of BLOCK10 (system).
	// Position of SYS_DATA_PART2_6 field.
	EFUSE_RD_SYS_PART2_DATA6_SYS_DATA_PART2_6_Pos = 0x0
	// Bit mask of SYS_DATA_PART2_6 field.
	EFUSE_RD_SYS_PART2_DATA6_SYS_DATA_PART2_6_Msk = 0xffffffff

	// RD_SYS_PART2_DATA7: Register 7 of BLOCK10 (system).
	// Position of SYS_DATA_PART2_7 field.
	EFUSE_RD_SYS_PART2_DATA7_SYS_DATA_PART2_7_Pos = 0x0
	// Bit mask of SYS_DATA_PART2_7 field.
	EFUSE_RD_SYS_PART2_DATA7_SYS_DATA_PART2_7_Msk = 0xffffffff

	// RD_REPEAT_ERR0: Programming error record register 0 of BLOCK0.
	// Position of RD_DIS_ERR field.
	EFUSE_RD_REPEAT_ERR0_RD_DIS_ERR_Pos = 0x0
	// Bit mask of RD_DIS_ERR field.
	EFUSE_RD_REPEAT_ERR0_RD_DIS_ERR_Msk = 0x7f
	// Position of DIS_RTC_RAM_BOOT_ERR field.
	EFUSE_RD_REPEAT_ERR0_DIS_RTC_RAM_BOOT_ERR_Pos = 0x7
	// Bit mask of DIS_RTC_RAM_BOOT_ERR field.
	EFUSE_RD_REPEAT_ERR0_DIS_RTC_RAM_BOOT_ERR_Msk = 0x80
	// Bit DIS_RTC_RAM_BOOT_ERR.
	EFUSE_RD_REPEAT_ERR0_DIS_RTC_RAM_BOOT_ERR = 0x80
	// Position of DIS_ICACHE_ERR field.
	EFUSE_RD_REPEAT_ERR0_DIS_ICACHE_ERR_Pos = 0x8
	// Bit mask of DIS_ICACHE_ERR field.
	EFUSE_RD_REPEAT_ERR0_DIS_ICACHE_ERR_Msk = 0x100
	// Bit DIS_ICACHE_ERR.
	EFUSE_RD_REPEAT_ERR0_DIS_ICACHE_ERR = 0x100
	// Position of DIS_USB_JTAG_ERR field.
	EFUSE_RD_REPEAT_ERR0_DIS_USB_JTAG_ERR_Pos = 0x9
	// Bit mask of DIS_USB_JTAG_ERR field.
	EFUSE_RD_REPEAT_ERR0_DIS_USB_JTAG_ERR_Msk = 0x200
	// Bit DIS_USB_JTAG_ERR.
	EFUSE_RD_REPEAT_ERR0_DIS_USB_JTAG_ERR = 0x200
	// Position of DIS_DOWNLOAD_ICACHE_ERR field.
	EFUSE_RD_REPEAT_ERR0_DIS_DOWNLOAD_ICACHE_ERR_Pos = 0xa
	// Bit mask of DIS_DOWNLOAD_ICACHE_ERR field.
	EFUSE_RD_REPEAT_ERR0_DIS_DOWNLOAD_ICACHE_ERR_Msk = 0x400
	// Bit DIS_DOWNLOAD_ICACHE_ERR.
	EFUSE_RD_REPEAT_ERR0_DIS_DOWNLOAD_ICACHE_ERR = 0x400
	// Position of DIS_USB_DEVICE_ERR field.
	EFUSE_RD_REPEAT_ERR0_DIS_USB_DEVICE_ERR_Pos = 0xb
	// Bit mask of DIS_USB_DEVICE_ERR field.
	EFUSE_RD_REPEAT_ERR0_DIS_USB_DEVICE_ERR_Msk = 0x800
	// Bit DIS_USB_DEVICE_ERR.
	EFUSE_RD_REPEAT_ERR0_DIS_USB_DEVICE_ERR = 0x800
	// Position of DIS_FORCE_DOWNLOAD_ERR field.
	EFUSE_RD_REPEAT_ERR0_DIS_FORCE_DOWNLOAD_ERR_Pos = 0xc
	// Bit mask of DIS_FORCE_DOWNLOAD_ERR field.
	EFUSE_RD_REPEAT_ERR0_DIS_FORCE_DOWNLOAD_ERR_Msk = 0x1000
	// Bit DIS_FORCE_DOWNLOAD_ERR.
	EFUSE_RD_REPEAT_ERR0_DIS_FORCE_DOWNLOAD_ERR = 0x1000
	// Position of RPT4_RESERVED6_ERR field.
	EFUSE_RD_REPEAT_ERR0_RPT4_RESERVED6_ERR_Pos = 0xd
	// Bit mask of RPT4_RESERVED6_ERR field.
	EFUSE_RD_REPEAT_ERR0_RPT4_RESERVED6_ERR_Msk = 0x2000
	// Bit RPT4_RESERVED6_ERR.
	EFUSE_RD_REPEAT_ERR0_RPT4_RESERVED6_ERR = 0x2000
	// Position of DIS_CAN_ERR field.
	EFUSE_RD_REPEAT_ERR0_DIS_CAN_ERR_Pos = 0xe
	// Bit mask of DIS_CAN_ERR field.
	EFUSE_RD_REPEAT_ERR0_DIS_CAN_ERR_Msk = 0x4000
	// Bit DIS_CAN_ERR.
	EFUSE_RD_REPEAT_ERR0_DIS_CAN_ERR = 0x4000
	// Position of JTAG_SEL_ENABLE_ERR field.
	EFUSE_RD_REPEAT_ERR0_JTAG_SEL_ENABLE_ERR_Pos = 0xf
	// Bit mask of JTAG_SEL_ENABLE_ERR field.
	EFUSE_RD_REPEAT_ERR0_JTAG_SEL_ENABLE_ERR_Msk = 0x8000
	// Bit JTAG_SEL_ENABLE_ERR.
	EFUSE_RD_REPEAT_ERR0_JTAG_SEL_ENABLE_ERR = 0x8000
	// Position of SOFT_DIS_JTAG_ERR field.
	EFUSE_RD_REPEAT_ERR0_SOFT_DIS_JTAG_ERR_Pos = 0x10
	// Bit mask of SOFT_DIS_JTAG_ERR field.
	EFUSE_RD_REPEAT_ERR0_SOFT_DIS_JTAG_ERR_Msk = 0x70000
	// Position of DIS_PAD_JTAG_ERR field.
	EFUSE_RD_REPEAT_ERR0_DIS_PAD_JTAG_ERR_Pos = 0x13
	// Bit mask of DIS_PAD_JTAG_ERR field.
	EFUSE_RD_REPEAT_ERR0_DIS_PAD_JTAG_ERR_Msk = 0x80000
	// Bit DIS_PAD_JTAG_ERR.
	EFUSE_RD_REPEAT_ERR0_DIS_PAD_JTAG_ERR = 0x80000
	// Position of DIS_DOWNLOAD_MANUAL_ENCRYPT_ERR field.
	EFUSE_RD_REPEAT_ERR0_DIS_DOWNLOAD_MANUAL_ENCRYPT_ERR_Pos = 0x14
	// Bit mask of DIS_DOWNLOAD_MANUAL_ENCRYPT_ERR field.
	EFUSE_RD_REPEAT_ERR0_DIS_DOWNLOAD_MANUAL_ENCRYPT_ERR_Msk = 0x100000
	// Bit DIS_DOWNLOAD_MANUAL_ENCRYPT_ERR.
	EFUSE_RD_REPEAT_ERR0_DIS_DOWNLOAD_MANUAL_ENCRYPT_ERR = 0x100000
	// Position of USB_DREFH_ERR field.
	EFUSE_RD_REPEAT_ERR0_USB_DREFH_ERR_Pos = 0x15
	// Bit mask of USB_DREFH_ERR field.
	EFUSE_RD_REPEAT_ERR0_USB_DREFH_ERR_Msk = 0x600000
	// Position of USB_DREFL_ERR field.
	EFUSE_RD_REPEAT_ERR0_USB_DREFL_ERR_Pos = 0x17
	// Bit mask of USB_DREFL_ERR field.
	EFUSE_RD_REPEAT_ERR0_USB_DREFL_ERR_Msk = 0x1800000
	// Position of USB_EXCHG_PINS_ERR field.
	EFUSE_RD_REPEAT_ERR0_USB_EXCHG_PINS_ERR_Pos = 0x19
	// Bit mask of USB_EXCHG_PINS_ERR field.
	EFUSE_RD_REPEAT_ERR0_USB_EXCHG_PINS_ERR_Msk = 0x2000000
	// Bit USB_EXCHG_PINS_ERR.
	EFUSE_RD_REPEAT_ERR0_USB_EXCHG_PINS_ERR = 0x2000000
	// Position of VDD_SPI_AS_GPIO_ERR field.
	EFUSE_RD_REPEAT_ERR0_VDD_SPI_AS_GPIO_ERR_Pos = 0x1a
	// Bit mask of VDD_SPI_AS_GPIO_ERR field.
	EFUSE_RD_REPEAT_ERR0_VDD_SPI_AS_GPIO_ERR_Msk = 0x4000000
	// Bit VDD_SPI_AS_GPIO_ERR.
	EFUSE_RD_REPEAT_ERR0_VDD_SPI_AS_GPIO_ERR = 0x4000000
	// Position of BTLC_GPIO_ENABLE_ERR field.
	EFUSE_RD_REPEAT_ERR0_BTLC_GPIO_ENABLE_ERR_Pos = 0x1b
	// Bit mask of BTLC_GPIO_ENABLE_ERR field.
	EFUSE_RD_REPEAT_ERR0_BTLC_GPIO_ENABLE_ERR_Msk = 0x18000000
	// Position of POWERGLITCH_EN_ERR field.
	EFUSE_RD_REPEAT_ERR0_POWERGLITCH_EN_ERR_Pos = 0x1d
	// Bit mask of POWERGLITCH_EN_ERR field.
	EFUSE_RD_REPEAT_ERR0_POWERGLITCH_EN_ERR_Msk = 0x20000000
	// Bit POWERGLITCH_EN_ERR.
	EFUSE_RD_REPEAT_ERR0_POWERGLITCH_EN_ERR = 0x20000000
	// Position of POWER_GLITCH_DSENSE_ERR field.
	EFUSE_RD_REPEAT_ERR0_POWER_GLITCH_DSENSE_ERR_Pos = 0x1e
	// Bit mask of POWER_GLITCH_DSENSE_ERR field.
	EFUSE_RD_REPEAT_ERR0_POWER_GLITCH_DSENSE_ERR_Msk = 0xc0000000

	// RD_REPEAT_ERR1: Programming error record register 1 of BLOCK0.
	// Position of RPT4_RESERVED2_ERR field.
	EFUSE_RD_REPEAT_ERR1_RPT4_RESERVED2_ERR_Pos = 0x0
	// Bit mask of RPT4_RESERVED2_ERR field.
	EFUSE_RD_REPEAT_ERR1_RPT4_RESERVED2_ERR_Msk = 0xffff
	// Position of WDT_DELAY_SEL_ERR field.
	EFUSE_RD_REPEAT_ERR1_WDT_DELAY_SEL_ERR_Pos = 0x10
	// Bit mask of WDT_DELAY_SEL_ERR field.
	EFUSE_RD_REPEAT_ERR1_WDT_DELAY_SEL_ERR_Msk = 0x30000
	// Position of SPI_BOOT_CRYPT_CNT_ERR field.
	EFUSE_RD_REPEAT_ERR1_SPI_BOOT_CRYPT_CNT_ERR_Pos = 0x12
	// Bit mask of SPI_BOOT_CRYPT_CNT_ERR field.
	EFUSE_RD_REPEAT_ERR1_SPI_BOOT_CRYPT_CNT_ERR_Msk = 0x1c0000
	// Position of SECURE_BOOT_KEY_REVOKE0_ERR field.
	EFUSE_RD_REPEAT_ERR1_SECURE_BOOT_KEY_REVOKE0_ERR_Pos = 0x15
	// Bit mask of SECURE_BOOT_KEY_REVOKE0_ERR field.
	EFUSE_RD_REPEAT_ERR1_SECURE_BOOT_KEY_REVOKE0_ERR_Msk = 0x200000
	// Bit SECURE_BOOT_KEY_REVOKE0_ERR.
	EFUSE_RD_REPEAT_ERR1_SECURE_BOOT_KEY_REVOKE0_ERR = 0x200000
	// Position of SECURE_BOOT_KEY_REVOKE1_ERR field.
	EFUSE_RD_REPEAT_ERR1_SECURE_BOOT_KEY_REVOKE1_ERR_Pos = 0x16
	// Bit mask of SECURE_BOOT_KEY_REVOKE1_ERR field.
	EFUSE_RD_REPEAT_ERR1_SECURE_BOOT_KEY_REVOKE1_ERR_Msk = 0x400000
	// Bit SECURE_BOOT_KEY_REVOKE1_ERR.
	EFUSE_RD_REPEAT_ERR1_SECURE_BOOT_KEY_REVOKE1_ERR = 0x400000
	// Position of SECURE_BOOT_KEY_REVOKE2_ERR field.
	EFUSE_RD_REPEAT_ERR1_SECURE_BOOT_KEY_REVOKE2_ERR_Pos = 0x17
	// Bit mask of SECURE_BOOT_KEY_REVOKE2_ERR field.
	EFUSE_RD_REPEAT_ERR1_SECURE_BOOT_KEY_REVOKE2_ERR_Msk = 0x800000
	// Bit SECURE_BOOT_KEY_REVOKE2_ERR.
	EFUSE_RD_REPEAT_ERR1_SECURE_BOOT_KEY_REVOKE2_ERR = 0x800000
	// Position of KEY_PURPOSE_0_ERR field.
	EFUSE_RD_REPEAT_ERR1_KEY_PURPOSE_0_ERR_Pos = 0x18
	// Bit mask of KEY_PURPOSE_0_ERR field.
	EFUSE_RD_REPEAT_ERR1_KEY_PURPOSE_0_ERR_Msk = 0xf000000
	// Position of KEY_PURPOSE_1_ERR field.
	EFUSE_RD_REPEAT_ERR1_KEY_PURPOSE_1_ERR_Pos = 0x1c
	// Bit mask of KEY_PURPOSE_1_ERR field.
	EFUSE_RD_REPEAT_ERR1_KEY_PURPOSE_1_ERR_Msk = 0xf0000000

	// RD_REPEAT_ERR2: Programming error record register 2 of BLOCK0.
	// Position of KEY_PURPOSE_2_ERR field.
	EFUSE_RD_REPEAT_ERR2_KEY_PURPOSE_2_ERR_Pos = 0x0
	// Bit mask of KEY_PURPOSE_2_ERR field.
	EFUSE_RD_REPEAT_ERR2_KEY_PURPOSE_2_ERR_Msk = 0xf
	// Position of KEY_PURPOSE_3_ERR field.
	EFUSE_RD_REPEAT_ERR2_KEY_PURPOSE_3_ERR_Pos = 0x4
	// Bit mask of KEY_PURPOSE_3_ERR field.
	EFUSE_RD_REPEAT_ERR2_KEY_PURPOSE_3_ERR_Msk = 0xf0
	// Position of KEY_PURPOSE_4_ERR field.
	EFUSE_RD_REPEAT_ERR2_KEY_PURPOSE_4_ERR_Pos = 0x8
	// Bit mask of KEY_PURPOSE_4_ERR field.
	EFUSE_RD_REPEAT_ERR2_KEY_PURPOSE_4_ERR_Msk = 0xf00
	// Position of KEY_PURPOSE_5_ERR field.
	EFUSE_RD_REPEAT_ERR2_KEY_PURPOSE_5_ERR_Pos = 0xc
	// Bit mask of KEY_PURPOSE_5_ERR field.
	EFUSE_RD_REPEAT_ERR2_KEY_PURPOSE_5_ERR_Msk = 0xf000
	// Position of RPT4_RESERVED3_ERR field.
	EFUSE_RD_REPEAT_ERR2_RPT4_RESERVED3_ERR_Pos = 0x10
	// Bit mask of RPT4_RESERVED3_ERR field.
	EFUSE_RD_REPEAT_ERR2_RPT4_RESERVED3_ERR_Msk = 0xf0000
	// Position of SECURE_BOOT_EN_ERR field.
	EFUSE_RD_REPEAT_ERR2_SECURE_BOOT_EN_ERR_Pos = 0x14
	// Bit mask of SECURE_BOOT_EN_ERR field.
	EFUSE_RD_REPEAT_ERR2_SECURE_BOOT_EN_ERR_Msk = 0x100000
	// Bit SECURE_BOOT_EN_ERR.
	EFUSE_RD_REPEAT_ERR2_SECURE_BOOT_EN_ERR = 0x100000
	// Position of SECURE_BOOT_AGGRESSIVE_REVOKE_ERR field.
	EFUSE_RD_REPEAT_ERR2_SECURE_BOOT_AGGRESSIVE_REVOKE_ERR_Pos = 0x15
	// Bit mask of SECURE_BOOT_AGGRESSIVE_REVOKE_ERR field.
	EFUSE_RD_REPEAT_ERR2_SECURE_BOOT_AGGRESSIVE_REVOKE_ERR_Msk = 0x200000
	// Bit SECURE_BOOT_AGGRESSIVE_REVOKE_ERR.
	EFUSE_RD_REPEAT_ERR2_SECURE_BOOT_AGGRESSIVE_REVOKE_ERR = 0x200000
	// Position of RPT4_RESERVED0_ERR field.
	EFUSE_RD_REPEAT_ERR2_RPT4_RESERVED0_ERR_Pos = 0x16
	// Bit mask of RPT4_RESERVED0_ERR field.
	EFUSE_RD_REPEAT_ERR2_RPT4_RESERVED0_ERR_Msk = 0xfc00000
	// Position of FLASH_TPUW_ERR field.
	EFUSE_RD_REPEAT_ERR2_FLASH_TPUW_ERR_Pos = 0x1c
	// Bit mask of FLASH_TPUW_ERR field.
	EFUSE_RD_REPEAT_ERR2_FLASH_TPUW_ERR_Msk = 0xf0000000

	// RD_REPEAT_ERR3: Programming error record register 3 of BLOCK0.
	// Position of DIS_DOWNLOAD_MODE_ERR field.
	EFUSE_RD_REPEAT_ERR3_DIS_DOWNLOAD_MODE_ERR_Pos = 0x0
	// Bit mask of DIS_DOWNLOAD_MODE_ERR field.
	EFUSE_RD_REPEAT_ERR3_DIS_DOWNLOAD_MODE_ERR_Msk = 0x1
	// Bit DIS_DOWNLOAD_MODE_ERR.
	EFUSE_RD_REPEAT_ERR3_DIS_DOWNLOAD_MODE_ERR = 0x1
	// Position of DIS_LEGACY_SPI_BOOT_ERR field.
	EFUSE_RD_REPEAT_ERR3_DIS_LEGACY_SPI_BOOT_ERR_Pos = 0x1
	// Bit mask of DIS_LEGACY_SPI_BOOT_ERR field.
	EFUSE_RD_REPEAT_ERR3_DIS_LEGACY_SPI_BOOT_ERR_Msk = 0x2
	// Bit DIS_LEGACY_SPI_BOOT_ERR.
	EFUSE_RD_REPEAT_ERR3_DIS_LEGACY_SPI_BOOT_ERR = 0x2
	// Position of UART_PRINT_CHANNEL_ERR field.
	EFUSE_RD_REPEAT_ERR3_UART_PRINT_CHANNEL_ERR_Pos = 0x2
	// Bit mask of UART_PRINT_CHANNEL_ERR field.
	EFUSE_RD_REPEAT_ERR3_UART_PRINT_CHANNEL_ERR_Msk = 0x4
	// Bit UART_PRINT_CHANNEL_ERR.
	EFUSE_RD_REPEAT_ERR3_UART_PRINT_CHANNEL_ERR = 0x4
	// Position of FLASH_ECC_MODE_ERR field.
	EFUSE_RD_REPEAT_ERR3_FLASH_ECC_MODE_ERR_Pos = 0x3
	// Bit mask of FLASH_ECC_MODE_ERR field.
	EFUSE_RD_REPEAT_ERR3_FLASH_ECC_MODE_ERR_Msk = 0x8
	// Bit FLASH_ECC_MODE_ERR.
	EFUSE_RD_REPEAT_ERR3_FLASH_ECC_MODE_ERR = 0x8
	// Position of DIS_USB_DOWNLOAD_MODE_ERR field.
	EFUSE_RD_REPEAT_ERR3_DIS_USB_DOWNLOAD_MODE_ERR_Pos = 0x4
	// Bit mask of DIS_USB_DOWNLOAD_MODE_ERR field.
	EFUSE_RD_REPEAT_ERR3_DIS_USB_DOWNLOAD_MODE_ERR_Msk = 0x10
	// Bit DIS_USB_DOWNLOAD_MODE_ERR.
	EFUSE_RD_REPEAT_ERR3_DIS_USB_DOWNLOAD_MODE_ERR = 0x10
	// Position of ENABLE_SECURITY_DOWNLOAD_ERR field.
	EFUSE_RD_REPEAT_ERR3_ENABLE_SECURITY_DOWNLOAD_ERR_Pos = 0x5
	// Bit mask of ENABLE_SECURITY_DOWNLOAD_ERR field.
	EFUSE_RD_REPEAT_ERR3_ENABLE_SECURITY_DOWNLOAD_ERR_Msk = 0x20
	// Bit ENABLE_SECURITY_DOWNLOAD_ERR.
	EFUSE_RD_REPEAT_ERR3_ENABLE_SECURITY_DOWNLOAD_ERR = 0x20
	// Position of UART_PRINT_CONTROL_ERR field.
	EFUSE_RD_REPEAT_ERR3_UART_PRINT_CONTROL_ERR_Pos = 0x6
	// Bit mask of UART_PRINT_CONTROL_ERR field.
	EFUSE_RD_REPEAT_ERR3_UART_PRINT_CONTROL_ERR_Msk = 0xc0
	// Position of PIN_POWER_SELECTION_ERR field.
	EFUSE_RD_REPEAT_ERR3_PIN_POWER_SELECTION_ERR_Pos = 0x8
	// Bit mask of PIN_POWER_SELECTION_ERR field.
	EFUSE_RD_REPEAT_ERR3_PIN_POWER_SELECTION_ERR_Msk = 0x100
	// Bit PIN_POWER_SELECTION_ERR.
	EFUSE_RD_REPEAT_ERR3_PIN_POWER_SELECTION_ERR = 0x100
	// Position of FLASH_TYPE_ERR field.
	EFUSE_RD_REPEAT_ERR3_FLASH_TYPE_ERR_Pos = 0x9
	// Bit mask of FLASH_TYPE_ERR field.
	EFUSE_RD_REPEAT_ERR3_FLASH_TYPE_ERR_Msk = 0x200
	// Bit FLASH_TYPE_ERR.
	EFUSE_RD_REPEAT_ERR3_FLASH_TYPE_ERR = 0x200
	// Position of FLASH_PAGE_SIZE_ERR field.
	EFUSE_RD_REPEAT_ERR3_FLASH_PAGE_SIZE_ERR_Pos = 0xa
	// Bit mask of FLASH_PAGE_SIZE_ERR field.
	EFUSE_RD_REPEAT_ERR3_FLASH_PAGE_SIZE_ERR_Msk = 0xc00
	// Position of FLASH_ECC_EN_ERR field.
	EFUSE_RD_REPEAT_ERR3_FLASH_ECC_EN_ERR_Pos = 0xc
	// Bit mask of FLASH_ECC_EN_ERR field.
	EFUSE_RD_REPEAT_ERR3_FLASH_ECC_EN_ERR_Msk = 0x1000
	// Bit FLASH_ECC_EN_ERR.
	EFUSE_RD_REPEAT_ERR3_FLASH_ECC_EN_ERR = 0x1000
	// Position of FORCE_SEND_RESUME_ERR field.
	EFUSE_RD_REPEAT_ERR3_FORCE_SEND_RESUME_ERR_Pos = 0xd
	// Bit mask of FORCE_SEND_RESUME_ERR field.
	EFUSE_RD_REPEAT_ERR3_FORCE_SEND_RESUME_ERR_Msk = 0x2000
	// Bit FORCE_SEND_RESUME_ERR.
	EFUSE_RD_REPEAT_ERR3_FORCE_SEND_RESUME_ERR = 0x2000
	// Position of SECURE_VERSION_ERR field.
	EFUSE_RD_REPEAT_ERR3_SECURE_VERSION_ERR_Pos = 0xe
	// Bit mask of SECURE_VERSION_ERR field.
	EFUSE_RD_REPEAT_ERR3_SECURE_VERSION_ERR_Msk = 0x3fffc000
	// Position of RPT4_RESERVED1_ERR field.
	EFUSE_RD_REPEAT_ERR3_RPT4_RESERVED1_ERR_Pos = 0x1e
	// Bit mask of RPT4_RESERVED1_ERR field.
	EFUSE_RD_REPEAT_ERR3_RPT4_RESERVED1_ERR_Msk = 0xc0000000

	// RD_REPEAT_ERR4: Programming error record register 4 of BLOCK0.
	// Position of RPT4_RESERVED4_ERR field.
	EFUSE_RD_REPEAT_ERR4_RPT4_RESERVED4_ERR_Pos = 0x0
	// Bit mask of RPT4_RESERVED4_ERR field.
	EFUSE_RD_REPEAT_ERR4_RPT4_RESERVED4_ERR_Msk = 0xffffff

	// RD_RS_ERR0: Programming error record register 0 of BLOCK1-10.
	// Position of MAC_SPI_8M_ERR_NUM field.
	EFUSE_RD_RS_ERR0_MAC_SPI_8M_ERR_NUM_Pos = 0x0
	// Bit mask of MAC_SPI_8M_ERR_NUM field.
	EFUSE_RD_RS_ERR0_MAC_SPI_8M_ERR_NUM_Msk = 0x7
	// Position of MAC_SPI_8M_FAIL field.
	EFUSE_RD_RS_ERR0_MAC_SPI_8M_FAIL_Pos = 0x3
	// Bit mask of MAC_SPI_8M_FAIL field.
	EFUSE_RD_RS_ERR0_MAC_SPI_8M_FAIL_Msk = 0x8
	// Bit MAC_SPI_8M_FAIL.
	EFUSE_RD_RS_ERR0_MAC_SPI_8M_FAIL = 0x8
	// Position of SYS_PART1_NUM field.
	EFUSE_RD_RS_ERR0_SYS_PART1_NUM_Pos = 0x4
	// Bit mask of SYS_PART1_NUM field.
	EFUSE_RD_RS_ERR0_SYS_PART1_NUM_Msk = 0x70
	// Position of SYS_PART1_FAIL field.
	EFUSE_RD_RS_ERR0_SYS_PART1_FAIL_Pos = 0x7
	// Bit mask of SYS_PART1_FAIL field.
	EFUSE_RD_RS_ERR0_SYS_PART1_FAIL_Msk = 0x80
	// Bit SYS_PART1_FAIL.
	EFUSE_RD_RS_ERR0_SYS_PART1_FAIL = 0x80
	// Position of USR_DATA_ERR_NUM field.
	EFUSE_RD_RS_ERR0_USR_DATA_ERR_NUM_Pos = 0x8
	// Bit mask of USR_DATA_ERR_NUM field.
	EFUSE_RD_RS_ERR0_USR_DATA_ERR_NUM_Msk = 0x700
	// Position of USR_DATA_FAIL field.
	EFUSE_RD_RS_ERR0_USR_DATA_FAIL_Pos = 0xb
	// Bit mask of USR_DATA_FAIL field.
	EFUSE_RD_RS_ERR0_USR_DATA_FAIL_Msk = 0x800
	// Bit USR_DATA_FAIL.
	EFUSE_RD_RS_ERR0_USR_DATA_FAIL = 0x800
	// Position of KEY0_ERR_NUM field.
	EFUSE_RD_RS_ERR0_KEY0_ERR_NUM_Pos = 0xc
	// Bit mask of KEY0_ERR_NUM field.
	EFUSE_RD_RS_ERR0_KEY0_ERR_NUM_Msk = 0x7000
	// Position of KEY0_FAIL field.
	EFUSE_RD_RS_ERR0_KEY0_FAIL_Pos = 0xf
	// Bit mask of KEY0_FAIL field.
	EFUSE_RD_RS_ERR0_KEY0_FAIL_Msk = 0x8000
	// Bit KEY0_FAIL.
	EFUSE_RD_RS_ERR0_KEY0_FAIL = 0x8000
	// Position of KEY1_ERR_NUM field.
	EFUSE_RD_RS_ERR0_KEY1_ERR_NUM_Pos = 0x10
	// Bit mask of KEY1_ERR_NUM field.
	EFUSE_RD_RS_ERR0_KEY1_ERR_NUM_Msk = 0x70000
	// Position of KEY1_FAIL field.
	EFUSE_RD_RS_ERR0_KEY1_FAIL_Pos = 0x13
	// Bit mask of KEY1_FAIL field.
	EFUSE_RD_RS_ERR0_KEY1_FAIL_Msk = 0x80000
	// Bit KEY1_FAIL.
	EFUSE_RD_RS_ERR0_KEY1_FAIL = 0x80000
	// Position of KEY2_ERR_NUM field.
	EFUSE_RD_RS_ERR0_KEY2_ERR_NUM_Pos = 0x14
	// Bit mask of KEY2_ERR_NUM field.
	EFUSE_RD_RS_ERR0_KEY2_ERR_NUM_Msk = 0x700000
	// Position of KEY2_FAIL field.
	EFUSE_RD_RS_ERR0_KEY2_FAIL_Pos = 0x17
	// Bit mask of KEY2_FAIL field.
	EFUSE_RD_RS_ERR0_KEY2_FAIL_Msk = 0x800000
	// Bit KEY2_FAIL.
	EFUSE_RD_RS_ERR0_KEY2_FAIL = 0x800000
	// Position of KEY3_ERR_NUM field.
	EFUSE_RD_RS_ERR0_KEY3_ERR_NUM_Pos = 0x18
	// Bit mask of KEY3_ERR_NUM field.
	EFUSE_RD_RS_ERR0_KEY3_ERR_NUM_Msk = 0x7000000
	// Position of KEY3_FAIL field.
	EFUSE_RD_RS_ERR0_KEY3_FAIL_Pos = 0x1b
	// Bit mask of KEY3_FAIL field.
	EFUSE_RD_RS_ERR0_KEY3_FAIL_Msk = 0x8000000
	// Bit KEY3_FAIL.
	EFUSE_RD_RS_ERR0_KEY3_FAIL = 0x8000000
	// Position of KEY4_ERR_NUM field.
	EFUSE_RD_RS_ERR0_KEY4_ERR_NUM_Pos = 0x1c
	// Bit mask of KEY4_ERR_NUM field.
	EFUSE_RD_RS_ERR0_KEY4_ERR_NUM_Msk = 0x70000000
	// Position of KEY4_FAIL field.
	EFUSE_RD_RS_ERR0_KEY4_FAIL_Pos = 0x1f
	// Bit mask of KEY4_FAIL field.
	EFUSE_RD_RS_ERR0_KEY4_FAIL_Msk = 0x80000000
	// Bit KEY4_FAIL.
	EFUSE_RD_RS_ERR0_KEY4_FAIL = 0x80000000

	// RD_RS_ERR1: Programming error record register 1 of BLOCK1-10.
	// Position of KEY5_ERR_NUM field.
	EFUSE_RD_RS_ERR1_KEY5_ERR_NUM_Pos = 0x0
	// Bit mask of KEY5_ERR_NUM field.
	EFUSE_RD_RS_ERR1_KEY5_ERR_NUM_Msk = 0x7
	// Position of KEY5_FAIL field.
	EFUSE_RD_RS_ERR1_KEY5_FAIL_Pos = 0x3
	// Bit mask of KEY5_FAIL field.
	EFUSE_RD_RS_ERR1_KEY5_FAIL_Msk = 0x8
	// Bit KEY5_FAIL.
	EFUSE_RD_RS_ERR1_KEY5_FAIL = 0x8
	// Position of SYS_PART2_ERR_NUM field.
	EFUSE_RD_RS_ERR1_SYS_PART2_ERR_NUM_Pos = 0x4
	// Bit mask of SYS_PART2_ERR_NUM field.
	EFUSE_RD_RS_ERR1_SYS_PART2_ERR_NUM_Msk = 0x70
	// Position of SYS_PART2_FAIL field.
	EFUSE_RD_RS_ERR1_SYS_PART2_FAIL_Pos = 0x7
	// Bit mask of SYS_PART2_FAIL field.
	EFUSE_RD_RS_ERR1_SYS_PART2_FAIL_Msk = 0x80
	// Bit SYS_PART2_FAIL.
	EFUSE_RD_RS_ERR1_SYS_PART2_FAIL = 0x80

	// CLK: eFuse clcok configuration register.
	// Position of EFUSE_MEM_FORCE_PD field.
	EFUSE_CLK_EFUSE_MEM_FORCE_PD_Pos = 0x0
	// Bit mask of EFUSE_MEM_FORCE_PD field.
	EFUSE_CLK_EFUSE_MEM_FORCE_PD_Msk = 0x1
	// Bit EFUSE_MEM_FORCE_PD.
	EFUSE_CLK_EFUSE_MEM_FORCE_PD = 0x1
	// Position of MEM_CLK_FORCE_ON field.
	EFUSE_CLK_MEM_CLK_FORCE_ON_Pos = 0x1
	// Bit mask of MEM_CLK_FORCE_ON field.
	EFUSE_CLK_MEM_CLK_FORCE_ON_Msk = 0x2
	// Bit MEM_CLK_FORCE_ON.
	EFUSE_CLK_MEM_CLK_FORCE_ON = 0x2
	// Position of EFUSE_MEM_FORCE_PU field.
	EFUSE_CLK_EFUSE_MEM_FORCE_PU_Pos = 0x2
	// Bit mask of EFUSE_MEM_FORCE_PU field.
	EFUSE_CLK_EFUSE_MEM_FORCE_PU_Msk = 0x4
	// Bit EFUSE_MEM_FORCE_PU.
	EFUSE_CLK_EFUSE_MEM_FORCE_PU = 0x4
	// Position of EN field.
	EFUSE_CLK_EN_Pos = 0x10
	// Bit mask of EN field.
	EFUSE_CLK_EN_Msk = 0x10000
	// Bit EN.
	EFUSE_CLK_EN = 0x10000

	// CONF: eFuse operation mode configuraiton register;
	// Position of OP_CODE field.
	EFUSE_CONF_OP_CODE_Pos = 0x0
	// Bit mask of OP_CODE field.
	EFUSE_CONF_OP_CODE_Msk = 0xffff

	// STATUS: eFuse status register.
	// Position of STATE field.
	EFUSE_STATUS_STATE_Pos = 0x0
	// Bit mask of STATE field.
	EFUSE_STATUS_STATE_Msk = 0xf
	// Position of OTP_LOAD_SW field.
	EFUSE_STATUS_OTP_LOAD_SW_Pos = 0x4
	// Bit mask of OTP_LOAD_SW field.
	EFUSE_STATUS_OTP_LOAD_SW_Msk = 0x10
	// Bit OTP_LOAD_SW.
	EFUSE_STATUS_OTP_LOAD_SW = 0x10
	// Position of OTP_VDDQ_C_SYNC2 field.
	EFUSE_STATUS_OTP_VDDQ_C_SYNC2_Pos = 0x5
	// Bit mask of OTP_VDDQ_C_SYNC2 field.
	EFUSE_STATUS_OTP_VDDQ_C_SYNC2_Msk = 0x20
	// Bit OTP_VDDQ_C_SYNC2.
	EFUSE_STATUS_OTP_VDDQ_C_SYNC2 = 0x20
	// Position of OTP_STROBE_SW field.
	EFUSE_STATUS_OTP_STROBE_SW_Pos = 0x6
	// Bit mask of OTP_STROBE_SW field.
	EFUSE_STATUS_OTP_STROBE_SW_Msk = 0x40
	// Bit OTP_STROBE_SW.
	EFUSE_STATUS_OTP_STROBE_SW = 0x40
	// Position of OTP_CSB_SW field.
	EFUSE_STATUS_OTP_CSB_SW_Pos = 0x7
	// Bit mask of OTP_CSB_SW field.
	EFUSE_STATUS_OTP_CSB_SW_Msk = 0x80
	// Bit OTP_CSB_SW.
	EFUSE_STATUS_OTP_CSB_SW = 0x80
	// Position of OTP_PGENB_SW field.
	EFUSE_STATUS_OTP_PGENB_SW_Pos = 0x8
	// Bit mask of OTP_PGENB_SW field.
	EFUSE_STATUS_OTP_PGENB_SW_Msk = 0x100
	// Bit OTP_PGENB_SW.
	EFUSE_STATUS_OTP_PGENB_SW = 0x100
	// Position of OTP_VDDQ_IS_SW field.
	EFUSE_STATUS_OTP_VDDQ_IS_SW_Pos = 0x9
	// Bit mask of OTP_VDDQ_IS_SW field.
	EFUSE_STATUS_OTP_VDDQ_IS_SW_Msk = 0x200
	// Bit OTP_VDDQ_IS_SW.
	EFUSE_STATUS_OTP_VDDQ_IS_SW = 0x200
	// Position of REPEAT_ERR_CNT field.
	EFUSE_STATUS_REPEAT_ERR_CNT_Pos = 0xa
	// Bit mask of REPEAT_ERR_CNT field.
	EFUSE_STATUS_REPEAT_ERR_CNT_Msk = 0x3fc00

	// CMD: eFuse command register.
	// Position of READ_CMD field.
	EFUSE_CMD_READ_CMD_Pos = 0x0
	// Bit mask of READ_CMD field.
	EFUSE_CMD_READ_CMD_Msk = 0x1
	// Bit READ_CMD.
	EFUSE_CMD_READ_CMD = 0x1
	// Position of PGM_CMD field.
	EFUSE_CMD_PGM_CMD_Pos = 0x1
	// Bit mask of PGM_CMD field.
	EFUSE_CMD_PGM_CMD_Msk = 0x2
	// Bit PGM_CMD.
	EFUSE_CMD_PGM_CMD = 0x2
	// Position of BLK_NUM field.
	EFUSE_CMD_BLK_NUM_Pos = 0x2
	// Bit mask of BLK_NUM field.
	EFUSE_CMD_BLK_NUM_Msk = 0x3c

	// INT_RAW: eFuse raw interrupt register.
	// Position of READ_DONE_INT_RAW field.
	EFUSE_INT_RAW_READ_DONE_INT_RAW_Pos = 0x0
	// Bit mask of READ_DONE_INT_RAW field.
	EFUSE_INT_RAW_READ_DONE_INT_RAW_Msk = 0x1
	// Bit READ_DONE_INT_RAW.
	EFUSE_INT_RAW_READ_DONE_INT_RAW = 0x1
	// Position of PGM_DONE_INT_RAW field.
	EFUSE_INT_RAW_PGM_DONE_INT_RAW_Pos = 0x1
	// Bit mask of PGM_DONE_INT_RAW field.
	EFUSE_INT_RAW_PGM_DONE_INT_RAW_Msk = 0x2
	// Bit PGM_DONE_INT_RAW.
	EFUSE_INT_RAW_PGM_DONE_INT_RAW = 0x2

	// INT_ST: eFuse interrupt status register.
	// Position of READ_DONE_INT_ST field.
	EFUSE_INT_ST_READ_DONE_INT_ST_Pos = 0x0
	// Bit mask of READ_DONE_INT_ST field.
	EFUSE_INT_ST_READ_DONE_INT_ST_Msk = 0x1
	// Bit READ_DONE_INT_ST.
	EFUSE_INT_ST_READ_DONE_INT_ST = 0x1
	// Position of PGM_DONE_INT_ST field.
	EFUSE_INT_ST_PGM_DONE_INT_ST_Pos = 0x1
	// Bit mask of PGM_DONE_INT_ST field.
	EFUSE_INT_ST_PGM_DONE_INT_ST_Msk = 0x2
	// Bit PGM_DONE_INT_ST.
	EFUSE_INT_ST_PGM_DONE_INT_ST = 0x2

	// INT_ENA: eFuse interrupt enable register.
	// Position of READ_DONE_INT_ENA field.
	EFUSE_INT_ENA_READ_DONE_INT_ENA_Pos = 0x0
	// Bit mask of READ_DONE_INT_ENA field.
	EFUSE_INT_ENA_READ_DONE_INT_ENA_Msk = 0x1
	// Bit READ_DONE_INT_ENA.
	EFUSE_INT_ENA_READ_DONE_INT_ENA = 0x1
	// Position of PGM_DONE_INT_ENA field.
	EFUSE_INT_ENA_PGM_DONE_INT_ENA_Pos = 0x1
	// Bit mask of PGM_DONE_INT_ENA field.
	EFUSE_INT_ENA_PGM_DONE_INT_ENA_Msk = 0x2
	// Bit PGM_DONE_INT_ENA.
	EFUSE_INT_ENA_PGM_DONE_INT_ENA = 0x2

	// INT_CLR: eFuse interrupt clear register.
	// Position of READ_DONE_INT_CLR field.
	EFUSE_INT_CLR_READ_DONE_INT_CLR_Pos = 0x0
	// Bit mask of READ_DONE_INT_CLR field.
	EFUSE_INT_CLR_READ_DONE_INT_CLR_Msk = 0x1
	// Bit READ_DONE_INT_CLR.
	EFUSE_INT_CLR_READ_DONE_INT_CLR = 0x1
	// Position of PGM_DONE_INT_CLR field.
	EFUSE_INT_CLR_PGM_DONE_INT_CLR_Pos = 0x1
	// Bit mask of PGM_DONE_INT_CLR field.
	EFUSE_INT_CLR_PGM_DONE_INT_CLR_Msk = 0x2
	// Bit PGM_DONE_INT_CLR.
	EFUSE_INT_CLR_PGM_DONE_INT_CLR = 0x2

	// DAC_CONF: Controls the eFuse programming voltage.
	// Position of DAC_CLK_DIV field.
	EFUSE_DAC_CONF_DAC_CLK_DIV_Pos = 0x0
	// Bit mask of DAC_CLK_DIV field.
	EFUSE_DAC_CONF_DAC_CLK_DIV_Msk = 0xff
	// Position of DAC_CLK_PAD_SEL field.
	EFUSE_DAC_CONF_DAC_CLK_PAD_SEL_Pos = 0x8
	// Bit mask of DAC_CLK_PAD_SEL field.
	EFUSE_DAC_CONF_DAC_CLK_PAD_SEL_Msk = 0x100
	// Bit DAC_CLK_PAD_SEL.
	EFUSE_DAC_CONF_DAC_CLK_PAD_SEL = 0x100
	// Position of DAC_NUM field.
	EFUSE_DAC_CONF_DAC_NUM_Pos = 0x9
	// Bit mask of DAC_NUM field.
	EFUSE_DAC_CONF_DAC_NUM_Msk = 0x1fe00
	// Position of OE_CLR field.
	EFUSE_DAC_CONF_OE_CLR_Pos = 0x11
	// Bit mask of OE_CLR field.
	EFUSE_DAC_CONF_OE_CLR_Msk = 0x20000
	// Bit OE_CLR.
	EFUSE_DAC_CONF_OE_CLR = 0x20000

	// RD_TIM_CONF: Configures read timing parameters.
	// Position of READ_INIT_NUM field.
	EFUSE_RD_TIM_CONF_READ_INIT_NUM_Pos = 0x18
	// Bit mask of READ_INIT_NUM field.
	EFUSE_RD_TIM_CONF_READ_INIT_NUM_Msk = 0xff000000

	// WR_TIM_CONF1: Configurarion register 1 of eFuse programming timing parameters.
	// Position of PWR_ON_NUM field.
	EFUSE_WR_TIM_CONF1_PWR_ON_NUM_Pos = 0x8
	// Bit mask of PWR_ON_NUM field.
	EFUSE_WR_TIM_CONF1_PWR_ON_NUM_Msk = 0xffff00

	// WR_TIM_CONF2: Configurarion register 2 of eFuse programming timing parameters.
	// Position of PWR_OFF_NUM field.
	EFUSE_WR_TIM_CONF2_PWR_OFF_NUM_Pos = 0x0
	// Bit mask of PWR_OFF_NUM field.
	EFUSE_WR_TIM_CONF2_PWR_OFF_NUM_Msk = 0xffff

	// DATE: eFuse version register.
	// Position of DATE field.
	EFUSE_DATE_DATE_Pos = 0x0
	// Bit mask of DATE field.
	EFUSE_DATE_DATE_Msk = 0xfffffff
)

// Constants for GPIO: Peripheral GPIO
const (
	// BT_SELECT: GPIO bit select register
	// Position of BT_SEL field.
	GPIO_BT_SELECT_BT_SEL_Pos = 0x0
	// Bit mask of BT_SEL field.
	GPIO_BT_SELECT_BT_SEL_Msk = 0xffffffff

	// OUT: GPIO output register
	// Position of DATA_ORIG field.
	GPIO_OUT_DATA_ORIG_Pos = 0x0
	// Bit mask of DATA_ORIG field.
	GPIO_OUT_DATA_ORIG_Msk = 0x3ffffff

	// OUT_W1TS: GPIO output set register
	// Position of OUT_W1TS field.
	GPIO_OUT_W1TS_OUT_W1TS_Pos = 0x0
	// Bit mask of OUT_W1TS field.
	GPIO_OUT_W1TS_OUT_W1TS_Msk = 0x3ffffff

	// OUT_W1TC: GPIO output clear register
	// Position of OUT_W1TC field.
	GPIO_OUT_W1TC_OUT_W1TC_Pos = 0x0
	// Bit mask of OUT_W1TC field.
	GPIO_OUT_W1TC_OUT_W1TC_Msk = 0x3ffffff

	// SDIO_SELECT: GPIO sdio select register
	// Position of SDIO_SEL field.
	GPIO_SDIO_SELECT_SDIO_SEL_Pos = 0x0
	// Bit mask of SDIO_SEL field.
	GPIO_SDIO_SELECT_SDIO_SEL_Msk = 0xff

	// ENABLE: GPIO output enable register
	// Position of DATA field.
	GPIO_ENABLE_DATA_Pos = 0x0
	// Bit mask of DATA field.
	GPIO_ENABLE_DATA_Msk = 0x3ffffff

	// ENABLE_W1TS: GPIO output enable set register
	// Position of ENABLE_W1TS field.
	GPIO_ENABLE_W1TS_ENABLE_W1TS_Pos = 0x0
	// Bit mask of ENABLE_W1TS field.
	GPIO_ENABLE_W1TS_ENABLE_W1TS_Msk = 0x3ffffff

	// ENABLE_W1TC: GPIO output enable clear register
	// Position of ENABLE_W1TC field.
	GPIO_ENABLE_W1TC_ENABLE_W1TC_Pos = 0x0
	// Bit mask of ENABLE_W1TC field.
	GPIO_ENABLE_W1TC_ENABLE_W1TC_Msk = 0x3ffffff

	// STRAP: pad strapping register
	// Position of STRAPPING field.
	GPIO_STRAP_STRAPPING_Pos = 0x0
	// Bit mask of STRAPPING field.
	GPIO_STRAP_STRAPPING_Msk = 0xffff

	// IN: GPIO input register
	// Position of DATA_NEXT field.
	GPIO_IN_DATA_NEXT_Pos = 0x0
	// Bit mask of DATA_NEXT field.
	GPIO_IN_DATA_NEXT_Msk = 0x3ffffff

	// STATUS: GPIO interrupt status register
	// Position of INTERRUPT field.
	GPIO_STATUS_INTERRUPT_Pos = 0x0
	// Bit mask of INTERRUPT field.
	GPIO_STATUS_INTERRUPT_Msk = 0x3ffffff

	// STATUS_W1TS: GPIO interrupt status set register
	// Position of STATUS_W1TS field.
	GPIO_STATUS_W1TS_STATUS_W1TS_Pos = 0x0
	// Bit mask of STATUS_W1TS field.
	GPIO_STATUS_W1TS_STATUS_W1TS_Msk = 0x3ffffff

	// STATUS_W1TC: GPIO interrupt status clear register
	// Position of STATUS_W1TC field.
	GPIO_STATUS_W1TC_STATUS_W1TC_Pos = 0x0
	// Bit mask of STATUS_W1TC field.
	GPIO_STATUS_W1TC_STATUS_W1TC_Msk = 0x3ffffff

	// PCPU_INT: GPIO PRO_CPU interrupt status register
	// Position of PROCPU_INT field.
	GPIO_PCPU_INT_PROCPU_INT_Pos = 0x0
	// Bit mask of PROCPU_INT field.
	GPIO_PCPU_INT_PROCPU_INT_Msk = 0x3ffffff

	// PCPU_NMI_INT: GPIO PRO_CPU(not shielded) interrupt status register
	// Position of PROCPU_NMI_INT field.
	GPIO_PCPU_NMI_INT_PROCPU_NMI_INT_Pos = 0x0
	// Bit mask of PROCPU_NMI_INT field.
	GPIO_PCPU_NMI_INT_PROCPU_NMI_INT_Msk = 0x3ffffff

	// CPUSDIO_INT: GPIO CPUSDIO interrupt status register
	// Position of SDIO_INT field.
	GPIO_CPUSDIO_INT_SDIO_INT_Pos = 0x0
	// Bit mask of SDIO_INT field.
	GPIO_CPUSDIO_INT_SDIO_INT_Msk = 0x3ffffff

	// PIN0: GPIO pin configuration register
	// Position of PIN_SYNC2_BYPASS field.
	GPIO_PIN_PIN_SYNC2_BYPASS_Pos = 0x0
	// Bit mask of PIN_SYNC2_BYPASS field.
	GPIO_PIN_PIN_SYNC2_BYPASS_Msk = 0x3
	// Position of PIN_PAD_DRIVER field.
	GPIO_PIN_PIN_PAD_DRIVER_Pos = 0x2
	// Bit mask of PIN_PAD_DRIVER field.
	GPIO_PIN_PIN_PAD_DRIVER_Msk = 0x4
	// Bit PIN_PAD_DRIVER.
	GPIO_PIN_PIN_PAD_DRIVER = 0x4
	// Position of PIN_SYNC1_BYPASS field.
	GPIO_PIN_PIN_SYNC1_BYPASS_Pos = 0x3
	// Bit mask of PIN_SYNC1_BYPASS field.
	GPIO_PIN_PIN_SYNC1_BYPASS_Msk = 0x18
	// Position of PIN_INT_TYPE field.
	GPIO_PIN_PIN_INT_TYPE_Pos = 0x7
	// Bit mask of PIN_INT_TYPE field.
	GPIO_PIN_PIN_INT_TYPE_Msk = 0x380
	// Position of PIN_WAKEUP_ENABLE field.
	GPIO_PIN_PIN_WAKEUP_ENABLE_Pos = 0xa
	// Bit mask of PIN_WAKEUP_ENABLE field.
	GPIO_PIN_PIN_WAKEUP_ENABLE_Msk = 0x400
	// Bit PIN_WAKEUP_ENABLE.
	GPIO_PIN_PIN_WAKEUP_ENABLE = 0x400
	// Position of PIN_CONFIG field.
	GPIO_PIN_PIN_CONFIG_Pos = 0xb
	// Bit mask of PIN_CONFIG field.
	GPIO_PIN_PIN_CONFIG_Msk = 0x1800
	// Position of PIN_INT_ENA field.
	GPIO_PIN_PIN_INT_ENA_Pos = 0xd
	// Bit mask of PIN_INT_ENA field.
	GPIO_PIN_PIN_INT_ENA_Msk = 0x3e000

	// STATUS_NEXT: GPIO interrupt source register
	// Position of STATUS_INTERRUPT_NEXT field.
	GPIO_STATUS_NEXT_STATUS_INTERRUPT_NEXT_Pos = 0x0
	// Bit mask of STATUS_INTERRUPT_NEXT field.
	GPIO_STATUS_NEXT_STATUS_INTERRUPT_NEXT_Msk = 0x3ffffff

	// FUNC0_IN_SEL_CFG: GPIO input function configuration register
	// Position of FUNC_IN_SEL field.
	GPIO_FUNC_IN_SEL_CFG_FUNC_IN_SEL_Pos = 0x0
	// Bit mask of FUNC_IN_SEL field.
	GPIO_FUNC_IN_SEL_CFG_FUNC_IN_SEL_Msk = 0x1f
	// Position of FUNC_IN_INV_SEL field.
	GPIO_FUNC_IN_SEL_CFG_FUNC_IN_INV_SEL_Pos = 0x5
	// Bit mask of FUNC_IN_INV_SEL field.
	GPIO_FUNC_IN_SEL_CFG_FUNC_IN_INV_SEL_Msk = 0x20
	// Bit FUNC_IN_INV_SEL.
	GPIO_FUNC_IN_SEL_CFG_FUNC_IN_INV_SEL = 0x20
	// Position of SIG_IN_SEL field.
	GPIO_FUNC_IN_SEL_CFG_SIG_IN_SEL_Pos = 0x6
	// Bit mask of SIG_IN_SEL field.
	GPIO_FUNC_IN_SEL_CFG_SIG_IN_SEL_Msk = 0x40
	// Bit SIG_IN_SEL.
	GPIO_FUNC_IN_SEL_CFG_SIG_IN_SEL = 0x40

	// FUNC0_OUT_SEL_CFG: GPIO output function select register
	// Position of FUNC_OUT_SEL field.
	GPIO_FUNC_OUT_SEL_CFG_FUNC_OUT_SEL_Pos = 0x0
	// Bit mask of FUNC_OUT_SEL field.
	GPIO_FUNC_OUT_SEL_CFG_FUNC_OUT_SEL_Msk = 0xff
	// Position of FUNC_OUT_INV_SEL field.
	GPIO_FUNC_OUT_SEL_CFG_FUNC_OUT_INV_SEL_Pos = 0x8
	// Bit mask of FUNC_OUT_INV_SEL field.
	GPIO_FUNC_OUT_SEL_CFG_FUNC_OUT_INV_SEL_Msk = 0x100
	// Bit FUNC_OUT_INV_SEL.
	GPIO_FUNC_OUT_SEL_CFG_FUNC_OUT_INV_SEL = 0x100
	// Position of FUNC_OEN_SEL field.
	GPIO_FUNC_OUT_SEL_CFG_FUNC_OEN_SEL_Pos = 0x9
	// Bit mask of FUNC_OEN_SEL field.
	GPIO_FUNC_OUT_SEL_CFG_FUNC_OEN_SEL_Msk = 0x200
	// Bit FUNC_OEN_SEL.
	GPIO_FUNC_OUT_SEL_CFG_FUNC_OEN_SEL = 0x200
	// Position of FUNC_OEN_INV_SEL field.
	GPIO_FUNC_OUT_SEL_CFG_FUNC_OEN_INV_SEL_Pos = 0xa
	// Bit mask of FUNC_OEN_INV_SEL field.
	GPIO_FUNC_OUT_SEL_CFG_FUNC_OEN_INV_SEL_Msk = 0x400
	// Bit FUNC_OEN_INV_SEL.
	GPIO_FUNC_OUT_SEL_CFG_FUNC_OEN_INV_SEL = 0x400

	// CLOCK_GATE: GPIO clock gate register
	// Position of CLK_EN field.
	GPIO_CLOCK_GATE_CLK_EN_Pos = 0x0
	// Bit mask of CLK_EN field.
	GPIO_CLOCK_GATE_CLK_EN_Msk = 0x1
	// Bit CLK_EN.
	GPIO_CLOCK_GATE_CLK_EN = 0x1

	// REG_DATE: GPIO version register
	// Position of REG_DATE field.
	GPIO_REG_DATE_REG_DATE_Pos = 0x0
	// Bit mask of REG_DATE field.
	GPIO_REG_DATE_REG_DATE_Msk = 0xfffffff
)

// Constants for GPIOSD: Peripheral GPIOSD
const (
	// SIGMADELTA0: Duty Cycle Configure Register of SDM%s
	// Position of SD0_IN field.
	GPIOSD_SIGMADELTA_SD0_IN_Pos = 0x0
	// Bit mask of SD0_IN field.
	GPIOSD_SIGMADELTA_SD0_IN_Msk = 0xff
	// Position of SD0_PRESCALE field.
	GPIOSD_SIGMADELTA_SD0_PRESCALE_Pos = 0x8
	// Bit mask of SD0_PRESCALE field.
	GPIOSD_SIGMADELTA_SD0_PRESCALE_Msk = 0xff00

	// SIGMADELTA_CG: Clock Gating Configure Register
	// Position of CLK_EN field.
	GPIOSD_SIGMADELTA_CG_CLK_EN_Pos = 0x1f
	// Bit mask of CLK_EN field.
	GPIOSD_SIGMADELTA_CG_CLK_EN_Msk = 0x80000000
	// Bit CLK_EN.
	GPIOSD_SIGMADELTA_CG_CLK_EN = 0x80000000

	// SIGMADELTA_MISC: MISC Register
	// Position of FUNCTION_CLK_EN field.
	GPIOSD_SIGMADELTA_MISC_FUNCTION_CLK_EN_Pos = 0x1e
	// Bit mask of FUNCTION_CLK_EN field.
	GPIOSD_SIGMADELTA_MISC_FUNCTION_CLK_EN_Msk = 0x40000000
	// Bit FUNCTION_CLK_EN.
	GPIOSD_SIGMADELTA_MISC_FUNCTION_CLK_EN = 0x40000000
	// Position of SPI_SWAP field.
	GPIOSD_SIGMADELTA_MISC_SPI_SWAP_Pos = 0x1f
	// Bit mask of SPI_SWAP field.
	GPIOSD_SIGMADELTA_MISC_SPI_SWAP_Msk = 0x80000000
	// Bit SPI_SWAP.
	GPIOSD_SIGMADELTA_MISC_SPI_SWAP = 0x80000000

	// SIGMADELTA_VERSION: Version Control Register
	// Position of GPIO_SD_DATE field.
	GPIOSD_SIGMADELTA_VERSION_GPIO_SD_DATE_Pos = 0x0
	// Bit mask of GPIO_SD_DATE field.
	GPIOSD_SIGMADELTA_VERSION_GPIO_SD_DATE_Msk = 0xfffffff
)

// Constants for HMAC: Peripheral HMAC
const (
	// SET_START: Process control register 0.
	// Position of SET_START field.
	HMAC_SET_START_SET_START_Pos = 0x0
	// Bit mask of SET_START field.
	HMAC_SET_START_SET_START_Msk = 0x1
	// Bit SET_START.
	HMAC_SET_START_SET_START = 0x1

	// SET_PARA_PURPOSE: Configure purpose.
	// Position of PURPOSE_SET field.
	HMAC_SET_PARA_PURPOSE_PURPOSE_SET_Pos = 0x0
	// Bit mask of PURPOSE_SET field.
	HMAC_SET_PARA_PURPOSE_PURPOSE_SET_Msk = 0xf

	// SET_PARA_KEY: Configure key.
	// Position of KEY_SET field.
	HMAC_SET_PARA_KEY_KEY_SET_Pos = 0x0
	// Bit mask of KEY_SET field.
	HMAC_SET_PARA_KEY_KEY_SET_Msk = 0x7

	// SET_PARA_FINISH: Finish initial configuration.
	// Position of SET_PARA_END field.
	HMAC_SET_PARA_FINISH_SET_PARA_END_Pos = 0x0
	// Bit mask of SET_PARA_END field.
	HMAC_SET_PARA_FINISH_SET_PARA_END_Msk = 0x1
	// Bit SET_PARA_END.
	HMAC_SET_PARA_FINISH_SET_PARA_END = 0x1

	// SET_MESSAGE_ONE: Process control register 1.
	// Position of SET_TEXT_ONE field.
	HMAC_SET_MESSAGE_ONE_SET_TEXT_ONE_Pos = 0x0
	// Bit mask of SET_TEXT_ONE field.
	HMAC_SET_MESSAGE_ONE_SET_TEXT_ONE_Msk = 0x1
	// Bit SET_TEXT_ONE.
	HMAC_SET_MESSAGE_ONE_SET_TEXT_ONE = 0x1

	// SET_MESSAGE_ING: Process control register 2.
	// Position of SET_TEXT_ING field.
	HMAC_SET_MESSAGE_ING_SET_TEXT_ING_Pos = 0x0
	// Bit mask of SET_TEXT_ING field.
	HMAC_SET_MESSAGE_ING_SET_TEXT_ING_Msk = 0x1
	// Bit SET_TEXT_ING.
	HMAC_SET_MESSAGE_ING_SET_TEXT_ING = 0x1

	// SET_MESSAGE_END: Process control register 3.
	// Position of SET_TEXT_END field.
	HMAC_SET_MESSAGE_END_SET_TEXT_END_Pos = 0x0
	// Bit mask of SET_TEXT_END field.
	HMAC_SET_MESSAGE_END_SET_TEXT_END_Msk = 0x1
	// Bit SET_TEXT_END.
	HMAC_SET_MESSAGE_END_SET_TEXT_END = 0x1

	// SET_RESULT_FINISH: Process control register 4.
	// Position of SET_RESULT_END field.
	HMAC_SET_RESULT_FINISH_SET_RESULT_END_Pos = 0x0
	// Bit mask of SET_RESULT_END field.
	HMAC_SET_RESULT_FINISH_SET_RESULT_END_Msk = 0x1
	// Bit SET_RESULT_END.
	HMAC_SET_RESULT_FINISH_SET_RESULT_END = 0x1

	// SET_INVALIDATE_JTAG: Invalidate register 0.
	// Position of SET_INVALIDATE_JTAG field.
	HMAC_SET_INVALIDATE_JTAG_SET_INVALIDATE_JTAG_Pos = 0x0
	// Bit mask of SET_INVALIDATE_JTAG field.
	HMAC_SET_INVALIDATE_JTAG_SET_INVALIDATE_JTAG_Msk = 0x1
	// Bit SET_INVALIDATE_JTAG.
	HMAC_SET_INVALIDATE_JTAG_SET_INVALIDATE_JTAG = 0x1

	// SET_INVALIDATE_DS: Invalidate register 1.
	// Position of SET_INVALIDATE_DS field.
	HMAC_SET_INVALIDATE_DS_SET_INVALIDATE_DS_Pos = 0x0
	// Bit mask of SET_INVALIDATE_DS field.
	HMAC_SET_INVALIDATE_DS_SET_INVALIDATE_DS_Msk = 0x1
	// Bit SET_INVALIDATE_DS.
	HMAC_SET_INVALIDATE_DS_SET_INVALIDATE_DS = 0x1

	// QUERY_ERROR: Error register.
	// Position of QUREY_CHECK field.
	HMAC_QUERY_ERROR_QUREY_CHECK_Pos = 0x0
	// Bit mask of QUREY_CHECK field.
	HMAC_QUERY_ERROR_QUREY_CHECK_Msk = 0x1
	// Bit QUREY_CHECK.
	HMAC_QUERY_ERROR_QUREY_CHECK = 0x1

	// QUERY_BUSY: Busy register.
	// Position of BUSY_STATE field.
	HMAC_QUERY_BUSY_BUSY_STATE_Pos = 0x0
	// Bit mask of BUSY_STATE field.
	HMAC_QUERY_BUSY_BUSY_STATE_Msk = 0x1
	// Bit BUSY_STATE.
	HMAC_QUERY_BUSY_BUSY_STATE = 0x1

	// SET_MESSAGE_PAD: Process control register 5.
	// Position of SET_TEXT_PAD field.
	HMAC_SET_MESSAGE_PAD_SET_TEXT_PAD_Pos = 0x0
	// Bit mask of SET_TEXT_PAD field.
	HMAC_SET_MESSAGE_PAD_SET_TEXT_PAD_Msk = 0x1
	// Bit SET_TEXT_PAD.
	HMAC_SET_MESSAGE_PAD_SET_TEXT_PAD = 0x1

	// ONE_BLOCK: Process control register 6.
	// Position of SET_ONE_BLOCK field.
	HMAC_ONE_BLOCK_SET_ONE_BLOCK_Pos = 0x0
	// Bit mask of SET_ONE_BLOCK field.
	HMAC_ONE_BLOCK_SET_ONE_BLOCK_Msk = 0x1
	// Bit SET_ONE_BLOCK.
	HMAC_ONE_BLOCK_SET_ONE_BLOCK = 0x1

	// SOFT_JTAG_CTRL: Jtag register 0.
	// Position of SOFT_JTAG_CTRL field.
	HMAC_SOFT_JTAG_CTRL_SOFT_JTAG_CTRL_Pos = 0x0
	// Bit mask of SOFT_JTAG_CTRL field.
	HMAC_SOFT_JTAG_CTRL_SOFT_JTAG_CTRL_Msk = 0x1
	// Bit SOFT_JTAG_CTRL.
	HMAC_SOFT_JTAG_CTRL_SOFT_JTAG_CTRL = 0x1

	// WR_JTAG: Jtag register 1.
	// Position of WR_JTAG field.
	HMAC_WR_JTAG_WR_JTAG_Pos = 0x0
	// Bit mask of WR_JTAG field.
	HMAC_WR_JTAG_WR_JTAG_Msk = 0xffffffff
)

// Constants for I2C: Peripheral I2C
const (
	// SCL_LOW_PERIOD: I2C_SCL_LOW_PERIOD_REG
	// Position of SCL_LOW_PERIOD field.
	I2C_SCL_LOW_PERIOD_SCL_LOW_PERIOD_Pos = 0x0
	// Bit mask of SCL_LOW_PERIOD field.
	I2C_SCL_LOW_PERIOD_SCL_LOW_PERIOD_Msk = 0x1ff

	// CTR: I2C_CTR_REG
	// Position of SDA_FORCE_OUT field.
	I2C_CTR_SDA_FORCE_OUT_Pos = 0x0
	// Bit mask of SDA_FORCE_OUT field.
	I2C_CTR_SDA_FORCE_OUT_Msk = 0x1
	// Bit SDA_FORCE_OUT.
	I2C_CTR_SDA_FORCE_OUT = 0x1
	// Position of SCL_FORCE_OUT field.
	I2C_CTR_SCL_FORCE_OUT_Pos = 0x1
	// Bit mask of SCL_FORCE_OUT field.
	I2C_CTR_SCL_FORCE_OUT_Msk = 0x2
	// Bit SCL_FORCE_OUT.
	I2C_CTR_SCL_FORCE_OUT = 0x2
	// Position of SAMPLE_SCL_LEVEL field.
	I2C_CTR_SAMPLE_SCL_LEVEL_Pos = 0x2
	// Bit mask of SAMPLE_SCL_LEVEL field.
	I2C_CTR_SAMPLE_SCL_LEVEL_Msk = 0x4
	// Bit SAMPLE_SCL_LEVEL.
	I2C_CTR_SAMPLE_SCL_LEVEL = 0x4
	// Position of RX_FULL_ACK_LEVEL field.
	I2C_CTR_RX_FULL_ACK_LEVEL_Pos = 0x3
	// Bit mask of RX_FULL_ACK_LEVEL field.
	I2C_CTR_RX_FULL_ACK_LEVEL_Msk = 0x8
	// Bit RX_FULL_ACK_LEVEL.
	I2C_CTR_RX_FULL_ACK_LEVEL = 0x8
	// Position of MS_MODE field.
	I2C_CTR_MS_MODE_Pos = 0x4
	// Bit mask of MS_MODE field.
	I2C_CTR_MS_MODE_Msk = 0x10
	// Bit MS_MODE.
	I2C_CTR_MS_MODE = 0x10
	// Position of TRANS_START field.
	I2C_CTR_TRANS_START_Pos = 0x5
	// Bit mask of TRANS_START field.
	I2C_CTR_TRANS_START_Msk = 0x20
	// Bit TRANS_START.
	I2C_CTR_TRANS_START = 0x20
	// Position of TX_LSB_FIRST field.
	I2C_CTR_TX_LSB_FIRST_Pos = 0x6
	// Bit mask of TX_LSB_FIRST field.
	I2C_CTR_TX_LSB_FIRST_Msk = 0x40
	// Bit TX_LSB_FIRST.
	I2C_CTR_TX_LSB_FIRST = 0x40
	// Position of RX_LSB_FIRST field.
	I2C_CTR_RX_LSB_FIRST_Pos = 0x7
	// Bit mask of RX_LSB_FIRST field.
	I2C_CTR_RX_LSB_FIRST_Msk = 0x80
	// Bit RX_LSB_FIRST.
	I2C_CTR_RX_LSB_FIRST = 0x80
	// Position of CLK_EN field.
	I2C_CTR_CLK_EN_Pos = 0x8
	// Bit mask of CLK_EN field.
	I2C_CTR_CLK_EN_Msk = 0x100
	// Bit CLK_EN.
	I2C_CTR_CLK_EN = 0x100
	// Position of ARBITRATION_EN field.
	I2C_CTR_ARBITRATION_EN_Pos = 0x9
	// Bit mask of ARBITRATION_EN field.
	I2C_CTR_ARBITRATION_EN_Msk = 0x200
	// Bit ARBITRATION_EN.
	I2C_CTR_ARBITRATION_EN = 0x200
	// Position of FSM_RST field.
	I2C_CTR_FSM_RST_Pos = 0xa
	// Bit mask of FSM_RST field.
	I2C_CTR_FSM_RST_Msk = 0x400
	// Bit FSM_RST.
	I2C_CTR_FSM_RST = 0x400
	// Position of CONF_UPGATE field.
	I2C_CTR_CONF_UPGATE_Pos = 0xb
	// Bit mask of CONF_UPGATE field.
	I2C_CTR_CONF_UPGATE_Msk = 0x800
	// Bit CONF_UPGATE.
	I2C_CTR_CONF_UPGATE = 0x800
	// Position of SLV_TX_AUTO_START_EN field.
	I2C_CTR_SLV_TX_AUTO_START_EN_Pos = 0xc
	// Bit mask of SLV_TX_AUTO_START_EN field.
	I2C_CTR_SLV_TX_AUTO_START_EN_Msk = 0x1000
	// Bit SLV_TX_AUTO_START_EN.
	I2C_CTR_SLV_TX_AUTO_START_EN = 0x1000
	// Position of ADDR_10BIT_RW_CHECK_EN field.
	I2C_CTR_ADDR_10BIT_RW_CHECK_EN_Pos = 0xd
	// Bit mask of ADDR_10BIT_RW_CHECK_EN field.
	I2C_CTR_ADDR_10BIT_RW_CHECK_EN_Msk = 0x2000
	// Bit ADDR_10BIT_RW_CHECK_EN.
	I2C_CTR_ADDR_10BIT_RW_CHECK_EN = 0x2000
	// Position of ADDR_BROADCASTING_EN field.
	I2C_CTR_ADDR_BROADCASTING_EN_Pos = 0xe
	// Bit mask of ADDR_BROADCASTING_EN field.
	I2C_CTR_ADDR_BROADCASTING_EN_Msk = 0x4000
	// Bit ADDR_BROADCASTING_EN.
	I2C_CTR_ADDR_BROADCASTING_EN = 0x4000

	// SR: I2C_SR_REG
	// Position of RESP_REC field.
	I2C_SR_RESP_REC_Pos = 0x0
	// Bit mask of RESP_REC field.
	I2C_SR_RESP_REC_Msk = 0x1
	// Bit RESP_REC.
	I2C_SR_RESP_REC = 0x1
	// Position of SLAVE_RW field.
	I2C_SR_SLAVE_RW_Pos = 0x1
	// Bit mask of SLAVE_RW field.
	I2C_SR_SLAVE_RW_Msk = 0x2
	// Bit SLAVE_RW.
	I2C_SR_SLAVE_RW = 0x2
	// Position of ARB_LOST field.
	I2C_SR_ARB_LOST_Pos = 0x3
	// Bit mask of ARB_LOST field.
	I2C_SR_ARB_LOST_Msk = 0x8
	// Bit ARB_LOST.
	I2C_SR_ARB_LOST = 0x8
	// Position of BUS_BUSY field.
	I2C_SR_BUS_BUSY_Pos = 0x4
	// Bit mask of BUS_BUSY field.
	I2C_SR_BUS_BUSY_Msk = 0x10
	// Bit BUS_BUSY.
	I2C_SR_BUS_BUSY = 0x10
	// Position of SLAVE_ADDRESSED field.
	I2C_SR_SLAVE_ADDRESSED_Pos = 0x5
	// Bit mask of SLAVE_ADDRESSED field.
	I2C_SR_SLAVE_ADDRESSED_Msk = 0x20
	// Bit SLAVE_ADDRESSED.
	I2C_SR_SLAVE_ADDRESSED = 0x20
	// Position of RXFIFO_CNT field.
	I2C_SR_RXFIFO_CNT_Pos = 0x8
	// Bit mask of RXFIFO_CNT field.
	I2C_SR_RXFIFO_CNT_Msk = 0x3f00
	// Position of STRETCH_CAUSE field.
	I2C_SR_STRETCH_CAUSE_Pos = 0xe
	// Bit mask of STRETCH_CAUSE field.
	I2C_SR_STRETCH_CAUSE_Msk = 0xc000
	// Position of TXFIFO_CNT field.
	I2C_SR_TXFIFO_CNT_Pos = 0x12
	// Bit mask of TXFIFO_CNT field.
	I2C_SR_TXFIFO_CNT_Msk = 0xfc0000
	// Position of SCL_MAIN_STATE_LAST field.
	I2C_SR_SCL_MAIN_STATE_LAST_Pos = 0x18
	// Bit mask of SCL_MAIN_STATE_LAST field.
	I2C_SR_SCL_MAIN_STATE_LAST_Msk = 0x7000000
	// Position of SCL_STATE_LAST field.
	I2C_SR_SCL_STATE_LAST_Pos = 0x1c
	// Bit mask of SCL_STATE_LAST field.
	I2C_SR_SCL_STATE_LAST_Msk = 0x70000000

	// TO: I2C_TO_REG
	// Position of TIME_OUT_VALUE field.
	I2C_TO_TIME_OUT_VALUE_Pos = 0x0
	// Bit mask of TIME_OUT_VALUE field.
	I2C_TO_TIME_OUT_VALUE_Msk = 0x1f
	// Position of TIME_OUT_EN field.
	I2C_TO_TIME_OUT_EN_Pos = 0x5
	// Bit mask of TIME_OUT_EN field.
	I2C_TO_TIME_OUT_EN_Msk = 0x20
	// Bit TIME_OUT_EN.
	I2C_TO_TIME_OUT_EN = 0x20

	// SLAVE_ADDR: I2C_SLAVE_ADDR_REG
	// Position of SLAVE_ADDR field.
	I2C_SLAVE_ADDR_SLAVE_ADDR_Pos = 0x0
	// Bit mask of SLAVE_ADDR field.
	I2C_SLAVE_ADDR_SLAVE_ADDR_Msk = 0x7fff
	// Position of ADDR_10BIT_EN field.
	I2C_SLAVE_ADDR_ADDR_10BIT_EN_Pos = 0x1f
	// Bit mask of ADDR_10BIT_EN field.
	I2C_SLAVE_ADDR_ADDR_10BIT_EN_Msk = 0x80000000
	// Bit ADDR_10BIT_EN.
	I2C_SLAVE_ADDR_ADDR_10BIT_EN = 0x80000000

	// FIFO_ST: I2C_FIFO_ST_REG
	// Position of RXFIFO_RADDR field.
	I2C_FIFO_ST_RXFIFO_RADDR_Pos = 0x0
	// Bit mask of RXFIFO_RADDR field.
	I2C_FIFO_ST_RXFIFO_RADDR_Msk = 0x1f
	// Position of RXFIFO_WADDR field.
	I2C_FIFO_ST_RXFIFO_WADDR_Pos = 0x5
	// Bit mask of RXFIFO_WADDR field.
	I2C_FIFO_ST_RXFIFO_WADDR_Msk = 0x3e0
	// Position of TXFIFO_RADDR field.
	I2C_FIFO_ST_TXFIFO_RADDR_Pos = 0xa
	// Bit mask of TXFIFO_RADDR field.
	I2C_FIFO_ST_TXFIFO_RADDR_Msk = 0x7c00
	// Position of TXFIFO_WADDR field.
	I2C_FIFO_ST_TXFIFO_WADDR_Pos = 0xf
	// Bit mask of TXFIFO_WADDR field.
	I2C_FIFO_ST_TXFIFO_WADDR_Msk = 0xf8000
	// Position of SLAVE_RW_POINT field.
	I2C_FIFO_ST_SLAVE_RW_POINT_Pos = 0x16
	// Bit mask of SLAVE_RW_POINT field.
	I2C_FIFO_ST_SLAVE_RW_POINT_Msk = 0x3fc00000

	// FIFO_CONF: I2C_FIFO_CONF_REG
	// Position of RXFIFO_WM_THRHD field.
	I2C_FIFO_CONF_RXFIFO_WM_THRHD_Pos = 0x0
	// Bit mask of RXFIFO_WM_THRHD field.
	I2C_FIFO_CONF_RXFIFO_WM_THRHD_Msk = 0x1f
	// Position of TXFIFO_WM_THRHD field.
	I2C_FIFO_CONF_TXFIFO_WM_THRHD_Pos = 0x5
	// Bit mask of TXFIFO_WM_THRHD field.
	I2C_FIFO_CONF_TXFIFO_WM_THRHD_Msk = 0x3e0
	// Position of NONFIFO_EN field.
	I2C_FIFO_CONF_NONFIFO_EN_Pos = 0xa
	// Bit mask of NONFIFO_EN field.
	I2C_FIFO_CONF_NONFIFO_EN_Msk = 0x400
	// Bit NONFIFO_EN.
	I2C_FIFO_CONF_NONFIFO_EN = 0x400
	// Position of FIFO_ADDR_CFG_EN field.
	I2C_FIFO_CONF_FIFO_ADDR_CFG_EN_Pos = 0xb
	// Bit mask of FIFO_ADDR_CFG_EN field.
	I2C_FIFO_CONF_FIFO_ADDR_CFG_EN_Msk = 0x800
	// Bit FIFO_ADDR_CFG_EN.
	I2C_FIFO_CONF_FIFO_ADDR_CFG_EN = 0x800
	// Position of RX_FIFO_RST field.
	I2C_FIFO_CONF_RX_FIFO_RST_Pos = 0xc
	// Bit mask of RX_FIFO_RST field.
	I2C_FIFO_CONF_RX_FIFO_RST_Msk = 0x1000
	// Bit RX_FIFO_RST.
	I2C_FIFO_CONF_RX_FIFO_RST = 0x1000
	// Position of TX_FIFO_RST field.
	I2C_FIFO_CONF_TX_FIFO_RST_Pos = 0xd
	// Bit mask of TX_FIFO_RST field.
	I2C_FIFO_CONF_TX_FIFO_RST_Msk = 0x2000
	// Bit TX_FIFO_RST.
	I2C_FIFO_CONF_TX_FIFO_RST = 0x2000
	// Position of FIFO_PRT_EN field.
	I2C_FIFO_CONF_FIFO_PRT_EN_Pos = 0xe
	// Bit mask of FIFO_PRT_EN field.
	I2C_FIFO_CONF_FIFO_PRT_EN_Msk = 0x4000
	// Bit FIFO_PRT_EN.
	I2C_FIFO_CONF_FIFO_PRT_EN = 0x4000

	// FIFO_DATA: I2C_FIFO_DATA_REG
	// Position of FIFO_RDATA field.
	I2C_FIFO_DATA_FIFO_RDATA_Pos = 0x0
	// Bit mask of FIFO_RDATA field.
	I2C_FIFO_DATA_FIFO_RDATA_Msk = 0xff

	// INT_RAW: I2C_INT_RAW_REG
	// Position of RXFIFO_WM_INT_RAW field.
	I2C_INT_RAW_RXFIFO_WM_INT_RAW_Pos = 0x0
	// Bit mask of RXFIFO_WM_INT_RAW field.
	I2C_INT_RAW_RXFIFO_WM_INT_RAW_Msk = 0x1
	// Bit RXFIFO_WM_INT_RAW.
	I2C_INT_RAW_RXFIFO_WM_INT_RAW = 0x1
	// Position of TXFIFO_WM_INT_RAW field.
	I2C_INT_RAW_TXFIFO_WM_INT_RAW_Pos = 0x1
	// Bit mask of TXFIFO_WM_INT_RAW field.
	I2C_INT_RAW_TXFIFO_WM_INT_RAW_Msk = 0x2
	// Bit TXFIFO_WM_INT_RAW.
	I2C_INT_RAW_TXFIFO_WM_INT_RAW = 0x2
	// Position of RXFIFO_OVF_INT_RAW field.
	I2C_INT_RAW_RXFIFO_OVF_INT_RAW_Pos = 0x2
	// Bit mask of RXFIFO_OVF_INT_RAW field.
	I2C_INT_RAW_RXFIFO_OVF_INT_RAW_Msk = 0x4
	// Bit RXFIFO_OVF_INT_RAW.
	I2C_INT_RAW_RXFIFO_OVF_INT_RAW = 0x4
	// Position of END_DETECT_INT_RAW field.
	I2C_INT_RAW_END_DETECT_INT_RAW_Pos = 0x3
	// Bit mask of END_DETECT_INT_RAW field.
	I2C_INT_RAW_END_DETECT_INT_RAW_Msk = 0x8
	// Bit END_DETECT_INT_RAW.
	I2C_INT_RAW_END_DETECT_INT_RAW = 0x8
	// Position of BYTE_TRANS_DONE_INT_RAW field.
	I2C_INT_RAW_BYTE_TRANS_DONE_INT_RAW_Pos = 0x4
	// Bit mask of BYTE_TRANS_DONE_INT_RAW field.
	I2C_INT_RAW_BYTE_TRANS_DONE_INT_RAW_Msk = 0x10
	// Bit BYTE_TRANS_DONE_INT_RAW.
	I2C_INT_RAW_BYTE_TRANS_DONE_INT_RAW = 0x10
	// Position of ARBITRATION_LOST_INT_RAW field.
	I2C_INT_RAW_ARBITRATION_LOST_INT_RAW_Pos = 0x5
	// Bit mask of ARBITRATION_LOST_INT_RAW field.
	I2C_INT_RAW_ARBITRATION_LOST_INT_RAW_Msk = 0x20
	// Bit ARBITRATION_LOST_INT_RAW.
	I2C_INT_RAW_ARBITRATION_LOST_INT_RAW = 0x20
	// Position of MST_TXFIFO_UDF_INT_RAW field.
	I2C_INT_RAW_MST_TXFIFO_UDF_INT_RAW_Pos = 0x6
	// Bit mask of MST_TXFIFO_UDF_INT_RAW field.
	I2C_INT_RAW_MST_TXFIFO_UDF_INT_RAW_Msk = 0x40
	// Bit MST_TXFIFO_UDF_INT_RAW.
	I2C_INT_RAW_MST_TXFIFO_UDF_INT_RAW = 0x40
	// Position of TRANS_COMPLETE_INT_RAW field.
	I2C_INT_RAW_TRANS_COMPLETE_INT_RAW_Pos = 0x7
	// Bit mask of TRANS_COMPLETE_INT_RAW field.
	I2C_INT_RAW_TRANS_COMPLETE_INT_RAW_Msk = 0x80
	// Bit TRANS_COMPLETE_INT_RAW.
	I2C_INT_RAW_TRANS_COMPLETE_INT_RAW = 0x80
	// Position of TIME_OUT_INT_RAW field.
	I2C_INT_RAW_TIME_OUT_INT_RAW_Pos = 0x8
	// Bit mask of TIME_OUT_INT_RAW field.
	I2C_INT_RAW_TIME_OUT_INT_RAW_Msk = 0x100
	// Bit TIME_OUT_INT_RAW.
	I2C_INT_RAW_TIME_OUT_INT_RAW = 0x100
	// Position of TRANS_START_INT_RAW field.
	I2C_INT_RAW_TRANS_START_INT_RAW_Pos = 0x9
	// Bit mask of TRANS_START_INT_RAW field.
	I2C_INT_RAW_TRANS_START_INT_RAW_Msk = 0x200
	// Bit TRANS_START_INT_RAW.
	I2C_INT_RAW_TRANS_START_INT_RAW = 0x200
	// Position of NACK_INT_RAW field.
	I2C_INT_RAW_NACK_INT_RAW_Pos = 0xa
	// Bit mask of NACK_INT_RAW field.
	I2C_INT_RAW_NACK_INT_RAW_Msk = 0x400
	// Bit NACK_INT_RAW.
	I2C_INT_RAW_NACK_INT_RAW = 0x400
	// Position of TXFIFO_OVF_INT_RAW field.
	I2C_INT_RAW_TXFIFO_OVF_INT_RAW_Pos = 0xb
	// Bit mask of TXFIFO_OVF_INT_RAW field.
	I2C_INT_RAW_TXFIFO_OVF_INT_RAW_Msk = 0x800
	// Bit TXFIFO_OVF_INT_RAW.
	I2C_INT_RAW_TXFIFO_OVF_INT_RAW = 0x800
	// Position of RXFIFO_UDF_INT_RAW field.
	I2C_INT_RAW_RXFIFO_UDF_INT_RAW_Pos = 0xc
	// Bit mask of RXFIFO_UDF_INT_RAW field.
	I2C_INT_RAW_RXFIFO_UDF_INT_RAW_Msk = 0x1000
	// Bit RXFIFO_UDF_INT_RAW.
	I2C_INT_RAW_RXFIFO_UDF_INT_RAW = 0x1000
	// Position of SCL_ST_TO_INT_RAW field.
	I2C_INT_RAW_SCL_ST_TO_INT_RAW_Pos = 0xd
	// Bit mask of SCL_ST_TO_INT_RAW field.
	I2C_INT_RAW_SCL_ST_TO_INT_RAW_Msk = 0x2000
	// Bit SCL_ST_TO_INT_RAW.
	I2C_INT_RAW_SCL_ST_TO_INT_RAW = 0x2000
	// Position of SCL_MAIN_ST_TO_INT_RAW field.
	I2C_INT_RAW_SCL_MAIN_ST_TO_INT_RAW_Pos = 0xe
	// Bit mask of SCL_MAIN_ST_TO_INT_RAW field.
	I2C_INT_RAW_SCL_MAIN_ST_TO_INT_RAW_Msk = 0x4000
	// Bit SCL_MAIN_ST_TO_INT_RAW.
	I2C_INT_RAW_SCL_MAIN_ST_TO_INT_RAW = 0x4000
	// Position of DET_START_INT_RAW field.
	I2C_INT_RAW_DET_START_INT_RAW_Pos = 0xf
	// Bit mask of DET_START_INT_RAW field.
	I2C_INT_RAW_DET_START_INT_RAW_Msk = 0x8000
	// Bit DET_START_INT_RAW.
	I2C_INT_RAW_DET_START_INT_RAW = 0x8000
	// Position of SLAVE_STRETCH_INT_RAW field.
	I2C_INT_RAW_SLAVE_STRETCH_INT_RAW_Pos = 0x10
	// Bit mask of SLAVE_STRETCH_INT_RAW field.
	I2C_INT_RAW_SLAVE_STRETCH_INT_RAW_Msk = 0x10000
	// Bit SLAVE_STRETCH_INT_RAW.
	I2C_INT_RAW_SLAVE_STRETCH_INT_RAW = 0x10000
	// Position of GENERAL_CALL_INT_RAW field.
	I2C_INT_RAW_GENERAL_CALL_INT_RAW_Pos = 0x11
	// Bit mask of GENERAL_CALL_INT_RAW field.
	I2C_INT_RAW_GENERAL_CALL_INT_RAW_Msk = 0x20000
	// Bit GENERAL_CALL_INT_RAW.
	I2C_INT_RAW_GENERAL_CALL_INT_RAW = 0x20000

	// INT_CLR: I2C_INT_CLR_REG
	// Position of RXFIFO_WM_INT_CLR field.
	I2C_INT_CLR_RXFIFO_WM_INT_CLR_Pos = 0x0
	// Bit mask of RXFIFO_WM_INT_CLR field.
	I2C_INT_CLR_RXFIFO_WM_INT_CLR_Msk = 0x1
	// Bit RXFIFO_WM_INT_CLR.
	I2C_INT_CLR_RXFIFO_WM_INT_CLR = 0x1
	// Position of TXFIFO_WM_INT_CLR field.
	I2C_INT_CLR_TXFIFO_WM_INT_CLR_Pos = 0x1
	// Bit mask of TXFIFO_WM_INT_CLR field.
	I2C_INT_CLR_TXFIFO_WM_INT_CLR_Msk = 0x2
	// Bit TXFIFO_WM_INT_CLR.
	I2C_INT_CLR_TXFIFO_WM_INT_CLR = 0x2
	// Position of RXFIFO_OVF_INT_CLR field.
	I2C_INT_CLR_RXFIFO_OVF_INT_CLR_Pos = 0x2
	// Bit mask of RXFIFO_OVF_INT_CLR field.
	I2C_INT_CLR_RXFIFO_OVF_INT_CLR_Msk = 0x4
	// Bit RXFIFO_OVF_INT_CLR.
	I2C_INT_CLR_RXFIFO_OVF_INT_CLR = 0x4
	// Position of END_DETECT_INT_CLR field.
	I2C_INT_CLR_END_DETECT_INT_CLR_Pos = 0x3
	// Bit mask of END_DETECT_INT_CLR field.
	I2C_INT_CLR_END_DETECT_INT_CLR_Msk = 0x8
	// Bit END_DETECT_INT_CLR.
	I2C_INT_CLR_END_DETECT_INT_CLR = 0x8
	// Position of BYTE_TRANS_DONE_INT_CLR field.
	I2C_INT_CLR_BYTE_TRANS_DONE_INT_CLR_Pos = 0x4
	// Bit mask of BYTE_TRANS_DONE_INT_CLR field.
	I2C_INT_CLR_BYTE_TRANS_DONE_INT_CLR_Msk = 0x10
	// Bit BYTE_TRANS_DONE_INT_CLR.
	I2C_INT_CLR_BYTE_TRANS_DONE_INT_CLR = 0x10
	// Position of ARBITRATION_LOST_INT_CLR field.
	I2C_INT_CLR_ARBITRATION_LOST_INT_CLR_Pos = 0x5
	// Bit mask of ARBITRATION_LOST_INT_CLR field.
	I2C_INT_CLR_ARBITRATION_LOST_INT_CLR_Msk = 0x20
	// Bit ARBITRATION_LOST_INT_CLR.
	I2C_INT_CLR_ARBITRATION_LOST_INT_CLR = 0x20
	// Position of MST_TXFIFO_UDF_INT_CLR field.
	I2C_INT_CLR_MST_TXFIFO_UDF_INT_CLR_Pos = 0x6
	// Bit mask of MST_TXFIFO_UDF_INT_CLR field.
	I2C_INT_CLR_MST_TXFIFO_UDF_INT_CLR_Msk = 0x40
	// Bit MST_TXFIFO_UDF_INT_CLR.
	I2C_INT_CLR_MST_TXFIFO_UDF_INT_CLR = 0x40
	// Position of TRANS_COMPLETE_INT_CLR field.
	I2C_INT_CLR_TRANS_COMPLETE_INT_CLR_Pos = 0x7
	// Bit mask of TRANS_COMPLETE_INT_CLR field.
	I2C_INT_CLR_TRANS_COMPLETE_INT_CLR_Msk = 0x80
	// Bit TRANS_COMPLETE_INT_CLR.
	I2C_INT_CLR_TRANS_COMPLETE_INT_CLR = 0x80
	// Position of TIME_OUT_INT_CLR field.
	I2C_INT_CLR_TIME_OUT_INT_CLR_Pos = 0x8
	// Bit mask of TIME_OUT_INT_CLR field.
	I2C_INT_CLR_TIME_OUT_INT_CLR_Msk = 0x100
	// Bit TIME_OUT_INT_CLR.
	I2C_INT_CLR_TIME_OUT_INT_CLR = 0x100
	// Position of TRANS_START_INT_CLR field.
	I2C_INT_CLR_TRANS_START_INT_CLR_Pos = 0x9
	// Bit mask of TRANS_START_INT_CLR field.
	I2C_INT_CLR_TRANS_START_INT_CLR_Msk = 0x200
	// Bit TRANS_START_INT_CLR.
	I2C_INT_CLR_TRANS_START_INT_CLR = 0x200
	// Position of NACK_INT_CLR field.
	I2C_INT_CLR_NACK_INT_CLR_Pos = 0xa
	// Bit mask of NACK_INT_CLR field.
	I2C_INT_CLR_NACK_INT_CLR_Msk = 0x400
	// Bit NACK_INT_CLR.
	I2C_INT_CLR_NACK_INT_CLR = 0x400
	// Position of TXFIFO_OVF_INT_CLR field.
	I2C_INT_CLR_TXFIFO_OVF_INT_CLR_Pos = 0xb
	// Bit mask of TXFIFO_OVF_INT_CLR field.
	I2C_INT_CLR_TXFIFO_OVF_INT_CLR_Msk = 0x800
	// Bit TXFIFO_OVF_INT_CLR.
	I2C_INT_CLR_TXFIFO_OVF_INT_CLR = 0x800
	// Position of RXFIFO_UDF_INT_CLR field.
	I2C_INT_CLR_RXFIFO_UDF_INT_CLR_Pos = 0xc
	// Bit mask of RXFIFO_UDF_INT_CLR field.
	I2C_INT_CLR_RXFIFO_UDF_INT_CLR_Msk = 0x1000
	// Bit RXFIFO_UDF_INT_CLR.
	I2C_INT_CLR_RXFIFO_UDF_INT_CLR = 0x1000
	// Position of SCL_ST_TO_INT_CLR field.
	I2C_INT_CLR_SCL_ST_TO_INT_CLR_Pos = 0xd
	// Bit mask of SCL_ST_TO_INT_CLR field.
	I2C_INT_CLR_SCL_ST_TO_INT_CLR_Msk = 0x2000
	// Bit SCL_ST_TO_INT_CLR.
	I2C_INT_CLR_SCL_ST_TO_INT_CLR = 0x2000
	// Position of SCL_MAIN_ST_TO_INT_CLR field.
	I2C_INT_CLR_SCL_MAIN_ST_TO_INT_CLR_Pos = 0xe
	// Bit mask of SCL_MAIN_ST_TO_INT_CLR field.
	I2C_INT_CLR_SCL_MAIN_ST_TO_INT_CLR_Msk = 0x4000
	// Bit SCL_MAIN_ST_TO_INT_CLR.
	I2C_INT_CLR_SCL_MAIN_ST_TO_INT_CLR = 0x4000
	// Position of DET_START_INT_CLR field.
	I2C_INT_CLR_DET_START_INT_CLR_Pos = 0xf
	// Bit mask of DET_START_INT_CLR field.
	I2C_INT_CLR_DET_START_INT_CLR_Msk = 0x8000
	// Bit DET_START_INT_CLR.
	I2C_INT_CLR_DET_START_INT_CLR = 0x8000
	// Position of SLAVE_STRETCH_INT_CLR field.
	I2C_INT_CLR_SLAVE_STRETCH_INT_CLR_Pos = 0x10
	// Bit mask of SLAVE_STRETCH_INT_CLR field.
	I2C_INT_CLR_SLAVE_STRETCH_INT_CLR_Msk = 0x10000
	// Bit SLAVE_STRETCH_INT_CLR.
	I2C_INT_CLR_SLAVE_STRETCH_INT_CLR = 0x10000
	// Position of GENERAL_CALL_INT_CLR field.
	I2C_INT_CLR_GENERAL_CALL_INT_CLR_Pos = 0x11
	// Bit mask of GENERAL_CALL_INT_CLR field.
	I2C_INT_CLR_GENERAL_CALL_INT_CLR_Msk = 0x20000
	// Bit GENERAL_CALL_INT_CLR.
	I2C_INT_CLR_GENERAL_CALL_INT_CLR = 0x20000

	// INT_ENA: I2C_INT_ENA_REG
	// Position of RXFIFO_WM_INT_ENA field.
	I2C_INT_ENA_RXFIFO_WM_INT_ENA_Pos = 0x0
	// Bit mask of RXFIFO_WM_INT_ENA field.
	I2C_INT_ENA_RXFIFO_WM_INT_ENA_Msk = 0x1
	// Bit RXFIFO_WM_INT_ENA.
	I2C_INT_ENA_RXFIFO_WM_INT_ENA = 0x1
	// Position of TXFIFO_WM_INT_ENA field.
	I2C_INT_ENA_TXFIFO_WM_INT_ENA_Pos = 0x1
	// Bit mask of TXFIFO_WM_INT_ENA field.
	I2C_INT_ENA_TXFIFO_WM_INT_ENA_Msk = 0x2
	// Bit TXFIFO_WM_INT_ENA.
	I2C_INT_ENA_TXFIFO_WM_INT_ENA = 0x2
	// Position of RXFIFO_OVF_INT_ENA field.
	I2C_INT_ENA_RXFIFO_OVF_INT_ENA_Pos = 0x2
	// Bit mask of RXFIFO_OVF_INT_ENA field.
	I2C_INT_ENA_RXFIFO_OVF_INT_ENA_Msk = 0x4
	// Bit RXFIFO_OVF_INT_ENA.
	I2C_INT_ENA_RXFIFO_OVF_INT_ENA = 0x4
	// Position of END_DETECT_INT_ENA field.
	I2C_INT_ENA_END_DETECT_INT_ENA_Pos = 0x3
	// Bit mask of END_DETECT_INT_ENA field.
	I2C_INT_ENA_END_DETECT_INT_ENA_Msk = 0x8
	// Bit END_DETECT_INT_ENA.
	I2C_INT_ENA_END_DETECT_INT_ENA = 0x8
	// Position of BYTE_TRANS_DONE_INT_ENA field.
	I2C_INT_ENA_BYTE_TRANS_DONE_INT_ENA_Pos = 0x4
	// Bit mask of BYTE_TRANS_DONE_INT_ENA field.
	I2C_INT_ENA_BYTE_TRANS_DONE_INT_ENA_Msk = 0x10
	// Bit BYTE_TRANS_DONE_INT_ENA.
	I2C_INT_ENA_BYTE_TRANS_DONE_INT_ENA = 0x10
	// Position of ARBITRATION_LOST_INT_ENA field.
	I2C_INT_ENA_ARBITRATION_LOST_INT_ENA_Pos = 0x5
	// Bit mask of ARBITRATION_LOST_INT_ENA field.
	I2C_INT_ENA_ARBITRATION_LOST_INT_ENA_Msk = 0x20
	// Bit ARBITRATION_LOST_INT_ENA.
	I2C_INT_ENA_ARBITRATION_LOST_INT_ENA = 0x20
	// Position of MST_TXFIFO_UDF_INT_ENA field.
	I2C_INT_ENA_MST_TXFIFO_UDF_INT_ENA_Pos = 0x6
	// Bit mask of MST_TXFIFO_UDF_INT_ENA field.
	I2C_INT_ENA_MST_TXFIFO_UDF_INT_ENA_Msk = 0x40
	// Bit MST_TXFIFO_UDF_INT_ENA.
	I2C_INT_ENA_MST_TXFIFO_UDF_INT_ENA = 0x40
	// Position of TRANS_COMPLETE_INT_ENA field.
	I2C_INT_ENA_TRANS_COMPLETE_INT_ENA_Pos = 0x7
	// Bit mask of TRANS_COMPLETE_INT_ENA field.
	I2C_INT_ENA_TRANS_COMPLETE_INT_ENA_Msk = 0x80
	// Bit TRANS_COMPLETE_INT_ENA.
	I2C_INT_ENA_TRANS_COMPLETE_INT_ENA = 0x80
	// Position of TIME_OUT_INT_ENA field.
	I2C_INT_ENA_TIME_OUT_INT_ENA_Pos = 0x8
	// Bit mask of TIME_OUT_INT_ENA field.
	I2C_INT_ENA_TIME_OUT_INT_ENA_Msk = 0x100
	// Bit TIME_OUT_INT_ENA.
	I2C_INT_ENA_TIME_OUT_INT_ENA = 0x100
	// Position of TRANS_START_INT_ENA field.
	I2C_INT_ENA_TRANS_START_INT_ENA_Pos = 0x9
	// Bit mask of TRANS_START_INT_ENA field.
	I2C_INT_ENA_TRANS_START_INT_ENA_Msk = 0x200
	// Bit TRANS_START_INT_ENA.
	I2C_INT_ENA_TRANS_START_INT_ENA = 0x200
	// Position of NACK_INT_ENA field.
	I2C_INT_ENA_NACK_INT_ENA_Pos = 0xa
	// Bit mask of NACK_INT_ENA field.
	I2C_INT_ENA_NACK_INT_ENA_Msk = 0x400
	// Bit NACK_INT_ENA.
	I2C_INT_ENA_NACK_INT_ENA = 0x400
	// Position of TXFIFO_OVF_INT_ENA field.
	I2C_INT_ENA_TXFIFO_OVF_INT_ENA_Pos = 0xb
	// Bit mask of TXFIFO_OVF_INT_ENA field.
	I2C_INT_ENA_TXFIFO_OVF_INT_ENA_Msk = 0x800
	// Bit TXFIFO_OVF_INT_ENA.
	I2C_INT_ENA_TXFIFO_OVF_INT_ENA = 0x800
	// Position of RXFIFO_UDF_INT_ENA field.
	I2C_INT_ENA_RXFIFO_UDF_INT_ENA_Pos = 0xc
	// Bit mask of RXFIFO_UDF_INT_ENA field.
	I2C_INT_ENA_RXFIFO_UDF_INT_ENA_Msk = 0x1000
	// Bit RXFIFO_UDF_INT_ENA.
	I2C_INT_ENA_RXFIFO_UDF_INT_ENA = 0x1000
	// Position of SCL_ST_TO_INT_ENA field.
	I2C_INT_ENA_SCL_ST_TO_INT_ENA_Pos = 0xd
	// Bit mask of SCL_ST_TO_INT_ENA field.
	I2C_INT_ENA_SCL_ST_TO_INT_ENA_Msk = 0x2000
	// Bit SCL_ST_TO_INT_ENA.
	I2C_INT_ENA_SCL_ST_TO_INT_ENA = 0x2000
	// Position of SCL_MAIN_ST_TO_INT_ENA field.
	I2C_INT_ENA_SCL_MAIN_ST_TO_INT_ENA_Pos = 0xe
	// Bit mask of SCL_MAIN_ST_TO_INT_ENA field.
	I2C_INT_ENA_SCL_MAIN_ST_TO_INT_ENA_Msk = 0x4000
	// Bit SCL_MAIN_ST_TO_INT_ENA.
	I2C_INT_ENA_SCL_MAIN_ST_TO_INT_ENA = 0x4000
	// Position of DET_START_INT_ENA field.
	I2C_INT_ENA_DET_START_INT_ENA_Pos = 0xf
	// Bit mask of DET_START_INT_ENA field.
	I2C_INT_ENA_DET_START_INT_ENA_Msk = 0x8000
	// Bit DET_START_INT_ENA.
	I2C_INT_ENA_DET_START_INT_ENA = 0x8000
	// Position of SLAVE_STRETCH_INT_ENA field.
	I2C_INT_ENA_SLAVE_STRETCH_INT_ENA_Pos = 0x10
	// Bit mask of SLAVE_STRETCH_INT_ENA field.
	I2C_INT_ENA_SLAVE_STRETCH_INT_ENA_Msk = 0x10000
	// Bit SLAVE_STRETCH_INT_ENA.
	I2C_INT_ENA_SLAVE_STRETCH_INT_ENA = 0x10000
	// Position of GENERAL_CALL_INT_ENA field.
	I2C_INT_ENA_GENERAL_CALL_INT_ENA_Pos = 0x11
	// Bit mask of GENERAL_CALL_INT_ENA field.
	I2C_INT_ENA_GENERAL_CALL_INT_ENA_Msk = 0x20000
	// Bit GENERAL_CALL_INT_ENA.
	I2C_INT_ENA_GENERAL_CALL_INT_ENA = 0x20000

	// INT_STATUS: I2C_INT_STATUS_REG
	// Position of RXFIFO_WM_INT_ST field.
	I2C_INT_STATUS_RXFIFO_WM_INT_ST_Pos = 0x0
	// Bit mask of RXFIFO_WM_INT_ST field.
	I2C_INT_STATUS_RXFIFO_WM_INT_ST_Msk = 0x1
	// Bit RXFIFO_WM_INT_ST.
	I2C_INT_STATUS_RXFIFO_WM_INT_ST = 0x1
	// Position of TXFIFO_WM_INT_ST field.
	I2C_INT_STATUS_TXFIFO_WM_INT_ST_Pos = 0x1
	// Bit mask of TXFIFO_WM_INT_ST field.
	I2C_INT_STATUS_TXFIFO_WM_INT_ST_Msk = 0x2
	// Bit TXFIFO_WM_INT_ST.
	I2C_INT_STATUS_TXFIFO_WM_INT_ST = 0x2
	// Position of RXFIFO_OVF_INT_ST field.
	I2C_INT_STATUS_RXFIFO_OVF_INT_ST_Pos = 0x2
	// Bit mask of RXFIFO_OVF_INT_ST field.
	I2C_INT_STATUS_RXFIFO_OVF_INT_ST_Msk = 0x4
	// Bit RXFIFO_OVF_INT_ST.
	I2C_INT_STATUS_RXFIFO_OVF_INT_ST = 0x4
	// Position of END_DETECT_INT_ST field.
	I2C_INT_STATUS_END_DETECT_INT_ST_Pos = 0x3
	// Bit mask of END_DETECT_INT_ST field.
	I2C_INT_STATUS_END_DETECT_INT_ST_Msk = 0x8
	// Bit END_DETECT_INT_ST.
	I2C_INT_STATUS_END_DETECT_INT_ST = 0x8
	// Position of BYTE_TRANS_DONE_INT_ST field.
	I2C_INT_STATUS_BYTE_TRANS_DONE_INT_ST_Pos = 0x4
	// Bit mask of BYTE_TRANS_DONE_INT_ST field.
	I2C_INT_STATUS_BYTE_TRANS_DONE_INT_ST_Msk = 0x10
	// Bit BYTE_TRANS_DONE_INT_ST.
	I2C_INT_STATUS_BYTE_TRANS_DONE_INT_ST = 0x10
	// Position of ARBITRATION_LOST_INT_ST field.
	I2C_INT_STATUS_ARBITRATION_LOST_INT_ST_Pos = 0x5
	// Bit mask of ARBITRATION_LOST_INT_ST field.
	I2C_INT_STATUS_ARBITRATION_LOST_INT_ST_Msk = 0x20
	// Bit ARBITRATION_LOST_INT_ST.
	I2C_INT_STATUS_ARBITRATION_LOST_INT_ST = 0x20
	// Position of MST_TXFIFO_UDF_INT_ST field.
	I2C_INT_STATUS_MST_TXFIFO_UDF_INT_ST_Pos = 0x6
	// Bit mask of MST_TXFIFO_UDF_INT_ST field.
	I2C_INT_STATUS_MST_TXFIFO_UDF_INT_ST_Msk = 0x40
	// Bit MST_TXFIFO_UDF_INT_ST.
	I2C_INT_STATUS_MST_TXFIFO_UDF_INT_ST = 0x40
	// Position of TRANS_COMPLETE_INT_ST field.
	I2C_INT_STATUS_TRANS_COMPLETE_INT_ST_Pos = 0x7
	// Bit mask of TRANS_COMPLETE_INT_ST field.
	I2C_INT_STATUS_TRANS_COMPLETE_INT_ST_Msk = 0x80
	// Bit TRANS_COMPLETE_INT_ST.
	I2C_INT_STATUS_TRANS_COMPLETE_INT_ST = 0x80
	// Position of TIME_OUT_INT_ST field.
	I2C_INT_STATUS_TIME_OUT_INT_ST_Pos = 0x8
	// Bit mask of TIME_OUT_INT_ST field.
	I2C_INT_STATUS_TIME_OUT_INT_ST_Msk = 0x100
	// Bit TIME_OUT_INT_ST.
	I2C_INT_STATUS_TIME_OUT_INT_ST = 0x100
	// Position of TRANS_START_INT_ST field.
	I2C_INT_STATUS_TRANS_START_INT_ST_Pos = 0x9
	// Bit mask of TRANS_START_INT_ST field.
	I2C_INT_STATUS_TRANS_START_INT_ST_Msk = 0x200
	// Bit TRANS_START_INT_ST.
	I2C_INT_STATUS_TRANS_START_INT_ST = 0x200
	// Position of NACK_INT_ST field.
	I2C_INT_STATUS_NACK_INT_ST_Pos = 0xa
	// Bit mask of NACK_INT_ST field.
	I2C_INT_STATUS_NACK_INT_ST_Msk = 0x400
	// Bit NACK_INT_ST.
	I2C_INT_STATUS_NACK_INT_ST = 0x400
	// Position of TXFIFO_OVF_INT_ST field.
	I2C_INT_STATUS_TXFIFO_OVF_INT_ST_Pos = 0xb
	// Bit mask of TXFIFO_OVF_INT_ST field.
	I2C_INT_STATUS_TXFIFO_OVF_INT_ST_Msk = 0x800
	// Bit TXFIFO_OVF_INT_ST.
	I2C_INT_STATUS_TXFIFO_OVF_INT_ST = 0x800
	// Position of RXFIFO_UDF_INT_ST field.
	I2C_INT_STATUS_RXFIFO_UDF_INT_ST_Pos = 0xc
	// Bit mask of RXFIFO_UDF_INT_ST field.
	I2C_INT_STATUS_RXFIFO_UDF_INT_ST_Msk = 0x1000
	// Bit RXFIFO_UDF_INT_ST.
	I2C_INT_STATUS_RXFIFO_UDF_INT_ST = 0x1000
	// Position of SCL_ST_TO_INT_ST field.
	I2C_INT_STATUS_SCL_ST_TO_INT_ST_Pos = 0xd
	// Bit mask of SCL_ST_TO_INT_ST field.
	I2C_INT_STATUS_SCL_ST_TO_INT_ST_Msk = 0x2000
	// Bit SCL_ST_TO_INT_ST.
	I2C_INT_STATUS_SCL_ST_TO_INT_ST = 0x2000
	// Position of SCL_MAIN_ST_TO_INT_ST field.
	I2C_INT_STATUS_SCL_MAIN_ST_TO_INT_ST_Pos = 0xe
	// Bit mask of SCL_MAIN_ST_TO_INT_ST field.
	I2C_INT_STATUS_SCL_MAIN_ST_TO_INT_ST_Msk = 0x4000
	// Bit SCL_MAIN_ST_TO_INT_ST.
	I2C_INT_STATUS_SCL_MAIN_ST_TO_INT_ST = 0x4000
	// Position of DET_START_INT_ST field.
	I2C_INT_STATUS_DET_START_INT_ST_Pos = 0xf
	// Bit mask of DET_START_INT_ST field.
	I2C_INT_STATUS_DET_START_INT_ST_Msk = 0x8000
	// Bit DET_START_INT_ST.
	I2C_INT_STATUS_DET_START_INT_ST = 0x8000
	// Position of SLAVE_STRETCH_INT_ST field.
	I2C_INT_STATUS_SLAVE_STRETCH_INT_ST_Pos = 0x10
	// Bit mask of SLAVE_STRETCH_INT_ST field.
	I2C_INT_STATUS_SLAVE_STRETCH_INT_ST_Msk = 0x10000
	// Bit SLAVE_STRETCH_INT_ST.
	I2C_INT_STATUS_SLAVE_STRETCH_INT_ST = 0x10000
	// Position of GENERAL_CALL_INT_ST field.
	I2C_INT_STATUS_GENERAL_CALL_INT_ST_Pos = 0x11
	// Bit mask of GENERAL_CALL_INT_ST field.
	I2C_INT_STATUS_GENERAL_CALL_INT_ST_Msk = 0x20000
	// Bit GENERAL_CALL_INT_ST.
	I2C_INT_STATUS_GENERAL_CALL_INT_ST = 0x20000

	// SDA_HOLD: I2C_SDA_HOLD_REG
	// Position of TIME field.
	I2C_SDA_HOLD_TIME_Pos = 0x0
	// Bit mask of TIME field.
	I2C_SDA_HOLD_TIME_Msk = 0x1ff

	// SDA_SAMPLE: I2C_SDA_SAMPLE_REG
	// Position of TIME field.
	I2C_SDA_SAMPLE_TIME_Pos = 0x0
	// Bit mask of TIME field.
	I2C_SDA_SAMPLE_TIME_Msk = 0x1ff

	// SCL_HIGH_PERIOD: I2C_SCL_HIGH_PERIOD_REG
	// Position of SCL_HIGH_PERIOD field.
	I2C_SCL_HIGH_PERIOD_SCL_HIGH_PERIOD_Pos = 0x0
	// Bit mask of SCL_HIGH_PERIOD field.
	I2C_SCL_HIGH_PERIOD_SCL_HIGH_PERIOD_Msk = 0x1ff
	// Position of SCL_WAIT_HIGH_PERIOD field.
	I2C_SCL_HIGH_PERIOD_SCL_WAIT_HIGH_PERIOD_Pos = 0x9
	// Bit mask of SCL_WAIT_HIGH_PERIOD field.
	I2C_SCL_HIGH_PERIOD_SCL_WAIT_HIGH_PERIOD_Msk = 0xfe00

	// SCL_START_HOLD: I2C_SCL_START_HOLD_REG
	// Position of TIME field.
	I2C_SCL_START_HOLD_TIME_Pos = 0x0
	// Bit mask of TIME field.
	I2C_SCL_START_HOLD_TIME_Msk = 0x1ff

	// SCL_RSTART_SETUP: I2C_SCL_RSTART_SETUP_REG
	// Position of TIME field.
	I2C_SCL_RSTART_SETUP_TIME_Pos = 0x0
	// Bit mask of TIME field.
	I2C_SCL_RSTART_SETUP_TIME_Msk = 0x1ff

	// SCL_STOP_HOLD: I2C_SCL_STOP_HOLD_REG
	// Position of TIME field.
	I2C_SCL_STOP_HOLD_TIME_Pos = 0x0
	// Bit mask of TIME field.
	I2C_SCL_STOP_HOLD_TIME_Msk = 0x1ff

	// SCL_STOP_SETUP: I2C_SCL_STOP_SETUP_REG
	// Position of TIME field.
	I2C_SCL_STOP_SETUP_TIME_Pos = 0x0
	// Bit mask of TIME field.
	I2C_SCL_STOP_SETUP_TIME_Msk = 0x1ff

	// FILTER_CFG: I2C_FILTER_CFG_REG
	// Position of SCL_FILTER_THRES field.
	I2C_FILTER_CFG_SCL_FILTER_THRES_Pos = 0x0
	// Bit mask of SCL_FILTER_THRES field.
	I2C_FILTER_CFG_SCL_FILTER_THRES_Msk = 0xf
	// Position of SDA_FILTER_THRES field.
	I2C_FILTER_CFG_SDA_FILTER_THRES_Pos = 0x4
	// Bit mask of SDA_FILTER_THRES field.
	I2C_FILTER_CFG_SDA_FILTER_THRES_Msk = 0xf0
	// Position of SCL_FILTER_EN field.
	I2C_FILTER_CFG_SCL_FILTER_EN_Pos = 0x8
	// Bit mask of SCL_FILTER_EN field.
	I2C_FILTER_CFG_SCL_FILTER_EN_Msk = 0x100
	// Bit SCL_FILTER_EN.
	I2C_FILTER_CFG_SCL_FILTER_EN = 0x100
	// Position of SDA_FILTER_EN field.
	I2C_FILTER_CFG_SDA_FILTER_EN_Pos = 0x9
	// Bit mask of SDA_FILTER_EN field.
	I2C_FILTER_CFG_SDA_FILTER_EN_Msk = 0x200
	// Bit SDA_FILTER_EN.
	I2C_FILTER_CFG_SDA_FILTER_EN = 0x200

	// CLK_CONF: I2C_CLK_CONF_REG
	// Position of SCLK_DIV_NUM field.
	I2C_CLK_CONF_SCLK_DIV_NUM_Pos = 0x0
	// Bit mask of SCLK_DIV_NUM field.
	I2C_CLK_CONF_SCLK_DIV_NUM_Msk = 0xff
	// Position of SCLK_DIV_A field.
	I2C_CLK_CONF_SCLK_DIV_A_Pos = 0x8
	// Bit mask of SCLK_DIV_A field.
	I2C_CLK_CONF_SCLK_DIV_A_Msk = 0x3f00
	// Position of SCLK_DIV_B field.
	I2C_CLK_CONF_SCLK_DIV_B_Pos = 0xe
	// Bit mask of SCLK_DIV_B field.
	I2C_CLK_CONF_SCLK_DIV_B_Msk = 0xfc000
	// Position of SCLK_SEL field.
	I2C_CLK_CONF_SCLK_SEL_Pos = 0x14
	// Bit mask of SCLK_SEL field.
	I2C_CLK_CONF_SCLK_SEL_Msk = 0x100000
	// Bit SCLK_SEL.
	I2C_CLK_CONF_SCLK_SEL = 0x100000
	// Position of SCLK_ACTIVE field.
	I2C_CLK_CONF_SCLK_ACTIVE_Pos = 0x15
	// Bit mask of SCLK_ACTIVE field.
	I2C_CLK_CONF_SCLK_ACTIVE_Msk = 0x200000
	// Bit SCLK_ACTIVE.
	I2C_CLK_CONF_SCLK_ACTIVE = 0x200000

	// COMD0: I2C_COMD%s_REG
	// Position of COMMAND field.
	I2C_COMD_COMMAND_Pos = 0x0
	// Bit mask of COMMAND field.
	I2C_COMD_COMMAND_Msk = 0x3fff
	// Position of COMMAND_DONE field.
	I2C_COMD_COMMAND_DONE_Pos = 0x1f
	// Bit mask of COMMAND_DONE field.
	I2C_COMD_COMMAND_DONE_Msk = 0x80000000
	// Bit COMMAND_DONE.
	I2C_COMD_COMMAND_DONE = 0x80000000

	// SCL_ST_TIME_OUT: I2C_SCL_ST_TIME_OUT_REG
	// Position of SCL_ST_TO_I2C field.
	I2C_SCL_ST_TIME_OUT_SCL_ST_TO_I2C_Pos = 0x0
	// Bit mask of SCL_ST_TO_I2C field.
	I2C_SCL_ST_TIME_OUT_SCL_ST_TO_I2C_Msk = 0x1f

	// SCL_MAIN_ST_TIME_OUT: I2C_SCL_MAIN_ST_TIME_OUT_REG
	// Position of SCL_MAIN_ST_TO_I2C field.
	I2C_SCL_MAIN_ST_TIME_OUT_SCL_MAIN_ST_TO_I2C_Pos = 0x0
	// Bit mask of SCL_MAIN_ST_TO_I2C field.
	I2C_SCL_MAIN_ST_TIME_OUT_SCL_MAIN_ST_TO_I2C_Msk = 0x1f

	// SCL_SP_CONF: I2C_SCL_SP_CONF_REG
	// Position of SCL_RST_SLV_EN field.
	I2C_SCL_SP_CONF_SCL_RST_SLV_EN_Pos = 0x0
	// Bit mask of SCL_RST_SLV_EN field.
	I2C_SCL_SP_CONF_SCL_RST_SLV_EN_Msk = 0x1
	// Bit SCL_RST_SLV_EN.
	I2C_SCL_SP_CONF_SCL_RST_SLV_EN = 0x1
	// Position of SCL_RST_SLV_NUM field.
	I2C_SCL_SP_CONF_SCL_RST_SLV_NUM_Pos = 0x1
	// Bit mask of SCL_RST_SLV_NUM field.
	I2C_SCL_SP_CONF_SCL_RST_SLV_NUM_Msk = 0x3e
	// Position of SCL_PD_EN field.
	I2C_SCL_SP_CONF_SCL_PD_EN_Pos = 0x6
	// Bit mask of SCL_PD_EN field.
	I2C_SCL_SP_CONF_SCL_PD_EN_Msk = 0x40
	// Bit SCL_PD_EN.
	I2C_SCL_SP_CONF_SCL_PD_EN = 0x40
	// Position of SDA_PD_EN field.
	I2C_SCL_SP_CONF_SDA_PD_EN_Pos = 0x7
	// Bit mask of SDA_PD_EN field.
	I2C_SCL_SP_CONF_SDA_PD_EN_Msk = 0x80
	// Bit SDA_PD_EN.
	I2C_SCL_SP_CONF_SDA_PD_EN = 0x80

	// SCL_STRETCH_CONF: I2C_SCL_STRETCH_CONF_REG
	// Position of STRETCH_PROTECT_NUM field.
	I2C_SCL_STRETCH_CONF_STRETCH_PROTECT_NUM_Pos = 0x0
	// Bit mask of STRETCH_PROTECT_NUM field.
	I2C_SCL_STRETCH_CONF_STRETCH_PROTECT_NUM_Msk = 0x3ff
	// Position of SLAVE_SCL_STRETCH_EN field.
	I2C_SCL_STRETCH_CONF_SLAVE_SCL_STRETCH_EN_Pos = 0xa
	// Bit mask of SLAVE_SCL_STRETCH_EN field.
	I2C_SCL_STRETCH_CONF_SLAVE_SCL_STRETCH_EN_Msk = 0x400
	// Bit SLAVE_SCL_STRETCH_EN.
	I2C_SCL_STRETCH_CONF_SLAVE_SCL_STRETCH_EN = 0x400
	// Position of SLAVE_SCL_STRETCH_CLR field.
	I2C_SCL_STRETCH_CONF_SLAVE_SCL_STRETCH_CLR_Pos = 0xb
	// Bit mask of SLAVE_SCL_STRETCH_CLR field.
	I2C_SCL_STRETCH_CONF_SLAVE_SCL_STRETCH_CLR_Msk = 0x800
	// Bit SLAVE_SCL_STRETCH_CLR.
	I2C_SCL_STRETCH_CONF_SLAVE_SCL_STRETCH_CLR = 0x800
	// Position of SLAVE_BYTE_ACK_CTL_EN field.
	I2C_SCL_STRETCH_CONF_SLAVE_BYTE_ACK_CTL_EN_Pos = 0xc
	// Bit mask of SLAVE_BYTE_ACK_CTL_EN field.
	I2C_SCL_STRETCH_CONF_SLAVE_BYTE_ACK_CTL_EN_Msk = 0x1000
	// Bit SLAVE_BYTE_ACK_CTL_EN.
	I2C_SCL_STRETCH_CONF_SLAVE_BYTE_ACK_CTL_EN = 0x1000
	// Position of SLAVE_BYTE_ACK_LVL field.
	I2C_SCL_STRETCH_CONF_SLAVE_BYTE_ACK_LVL_Pos = 0xd
	// Bit mask of SLAVE_BYTE_ACK_LVL field.
	I2C_SCL_STRETCH_CONF_SLAVE_BYTE_ACK_LVL_Msk = 0x2000
	// Bit SLAVE_BYTE_ACK_LVL.
	I2C_SCL_STRETCH_CONF_SLAVE_BYTE_ACK_LVL = 0x2000

	// DATE: I2C_DATE_REG
	// Position of DATE field.
	I2C_DATE_DATE_Pos = 0x0
	// Bit mask of DATE field.
	I2C_DATE_DATE_Msk = 0xffffffff

	// TXFIFO_START_ADDR: I2C_TXFIFO_START_ADDR_REG
	// Position of TXFIFO_START_ADDR field.
	I2C_TXFIFO_START_ADDR_TXFIFO_START_ADDR_Pos = 0x0
	// Bit mask of TXFIFO_START_ADDR field.
	I2C_TXFIFO_START_ADDR_TXFIFO_START_ADDR_Msk = 0xffffffff

	// RXFIFO_START_ADDR: I2C_RXFIFO_START_ADDR_REG
	// Position of RXFIFO_START_ADDR field.
	I2C_RXFIFO_START_ADDR_RXFIFO_START_ADDR_Pos = 0x0
	// Bit mask of RXFIFO_START_ADDR field.
	I2C_RXFIFO_START_ADDR_RXFIFO_START_ADDR_Msk = 0xffffffff
)

// Constants for I2S: Peripheral I2S
const (
	// INT_RAW: I2S interrupt raw register, valid in level.
	// Position of RX_DONE_INT_RAW field.
	I2S_INT_RAW_RX_DONE_INT_RAW_Pos = 0x0
	// Bit mask of RX_DONE_INT_RAW field.
	I2S_INT_RAW_RX_DONE_INT_RAW_Msk = 0x1
	// Bit RX_DONE_INT_RAW.
	I2S_INT_RAW_RX_DONE_INT_RAW = 0x1
	// Position of TX_DONE_INT_RAW field.
	I2S_INT_RAW_TX_DONE_INT_RAW_Pos = 0x1
	// Bit mask of TX_DONE_INT_RAW field.
	I2S_INT_RAW_TX_DONE_INT_RAW_Msk = 0x2
	// Bit TX_DONE_INT_RAW.
	I2S_INT_RAW_TX_DONE_INT_RAW = 0x2
	// Position of RX_HUNG_INT_RAW field.
	I2S_INT_RAW_RX_HUNG_INT_RAW_Pos = 0x2
	// Bit mask of RX_HUNG_INT_RAW field.
	I2S_INT_RAW_RX_HUNG_INT_RAW_Msk = 0x4
	// Bit RX_HUNG_INT_RAW.
	I2S_INT_RAW_RX_HUNG_INT_RAW = 0x4
	// Position of TX_HUNG_INT_RAW field.
	I2S_INT_RAW_TX_HUNG_INT_RAW_Pos = 0x3
	// Bit mask of TX_HUNG_INT_RAW field.
	I2S_INT_RAW_TX_HUNG_INT_RAW_Msk = 0x8
	// Bit TX_HUNG_INT_RAW.
	I2S_INT_RAW_TX_HUNG_INT_RAW = 0x8

	// INT_ST: I2S interrupt status register.
	// Position of RX_DONE_INT_ST field.
	I2S_INT_ST_RX_DONE_INT_ST_Pos = 0x0
	// Bit mask of RX_DONE_INT_ST field.
	I2S_INT_ST_RX_DONE_INT_ST_Msk = 0x1
	// Bit RX_DONE_INT_ST.
	I2S_INT_ST_RX_DONE_INT_ST = 0x1
	// Position of TX_DONE_INT_ST field.
	I2S_INT_ST_TX_DONE_INT_ST_Pos = 0x1
	// Bit mask of TX_DONE_INT_ST field.
	I2S_INT_ST_TX_DONE_INT_ST_Msk = 0x2
	// Bit TX_DONE_INT_ST.
	I2S_INT_ST_TX_DONE_INT_ST = 0x2
	// Position of RX_HUNG_INT_ST field.
	I2S_INT_ST_RX_HUNG_INT_ST_Pos = 0x2
	// Bit mask of RX_HUNG_INT_ST field.
	I2S_INT_ST_RX_HUNG_INT_ST_Msk = 0x4
	// Bit RX_HUNG_INT_ST.
	I2S_INT_ST_RX_HUNG_INT_ST = 0x4
	// Position of TX_HUNG_INT_ST field.
	I2S_INT_ST_TX_HUNG_INT_ST_Pos = 0x3
	// Bit mask of TX_HUNG_INT_ST field.
	I2S_INT_ST_TX_HUNG_INT_ST_Msk = 0x8
	// Bit TX_HUNG_INT_ST.
	I2S_INT_ST_TX_HUNG_INT_ST = 0x8

	// INT_ENA: I2S interrupt enable register.
	// Position of RX_DONE_INT_ENA field.
	I2S_INT_ENA_RX_DONE_INT_ENA_Pos = 0x0
	// Bit mask of RX_DONE_INT_ENA field.
	I2S_INT_ENA_RX_DONE_INT_ENA_Msk = 0x1
	// Bit RX_DONE_INT_ENA.
	I2S_INT_ENA_RX_DONE_INT_ENA = 0x1
	// Position of TX_DONE_INT_ENA field.
	I2S_INT_ENA_TX_DONE_INT_ENA_Pos = 0x1
	// Bit mask of TX_DONE_INT_ENA field.
	I2S_INT_ENA_TX_DONE_INT_ENA_Msk = 0x2
	// Bit TX_DONE_INT_ENA.
	I2S_INT_ENA_TX_DONE_INT_ENA = 0x2
	// Position of RX_HUNG_INT_ENA field.
	I2S_INT_ENA_RX_HUNG_INT_ENA_Pos = 0x2
	// Bit mask of RX_HUNG_INT_ENA field.
	I2S_INT_ENA_RX_HUNG_INT_ENA_Msk = 0x4
	// Bit RX_HUNG_INT_ENA.
	I2S_INT_ENA_RX_HUNG_INT_ENA = 0x4
	// Position of TX_HUNG_INT_ENA field.
	I2S_INT_ENA_TX_HUNG_INT_ENA_Pos = 0x3
	// Bit mask of TX_HUNG_INT_ENA field.
	I2S_INT_ENA_TX_HUNG_INT_ENA_Msk = 0x8
	// Bit TX_HUNG_INT_ENA.
	I2S_INT_ENA_TX_HUNG_INT_ENA = 0x8

	// INT_CLR: I2S interrupt clear register.
	// Position of RX_DONE_INT_CLR field.
	I2S_INT_CLR_RX_DONE_INT_CLR_Pos = 0x0
	// Bit mask of RX_DONE_INT_CLR field.
	I2S_INT_CLR_RX_DONE_INT_CLR_Msk = 0x1
	// Bit RX_DONE_INT_CLR.
	I2S_INT_CLR_RX_DONE_INT_CLR = 0x1
	// Position of TX_DONE_INT_CLR field.
	I2S_INT_CLR_TX_DONE_INT_CLR_Pos = 0x1
	// Bit mask of TX_DONE_INT_CLR field.
	I2S_INT_CLR_TX_DONE_INT_CLR_Msk = 0x2
	// Bit TX_DONE_INT_CLR.
	I2S_INT_CLR_TX_DONE_INT_CLR = 0x2
	// Position of RX_HUNG_INT_CLR field.
	I2S_INT_CLR_RX_HUNG_INT_CLR_Pos = 0x2
	// Bit mask of RX_HUNG_INT_CLR field.
	I2S_INT_CLR_RX_HUNG_INT_CLR_Msk = 0x4
	// Bit RX_HUNG_INT_CLR.
	I2S_INT_CLR_RX_HUNG_INT_CLR = 0x4
	// Position of TX_HUNG_INT_CLR field.
	I2S_INT_CLR_TX_HUNG_INT_CLR_Pos = 0x3
	// Bit mask of TX_HUNG_INT_CLR field.
	I2S_INT_CLR_TX_HUNG_INT_CLR_Msk = 0x8
	// Bit TX_HUNG_INT_CLR.
	I2S_INT_CLR_TX_HUNG_INT_CLR = 0x8

	// RX_CONF: I2S RX configure register
	// Position of RX_RESET field.
	I2S_RX_CONF_RX_RESET_Pos = 0x0
	// Bit mask of RX_RESET field.
	I2S_RX_CONF_RX_RESET_Msk = 0x1
	// Bit RX_RESET.
	I2S_RX_CONF_RX_RESET = 0x1
	// Position of RX_FIFO_RESET field.
	I2S_RX_CONF_RX_FIFO_RESET_Pos = 0x1
	// Bit mask of RX_FIFO_RESET field.
	I2S_RX_CONF_RX_FIFO_RESET_Msk = 0x2
	// Bit RX_FIFO_RESET.
	I2S_RX_CONF_RX_FIFO_RESET = 0x2
	// Position of RX_START field.
	I2S_RX_CONF_RX_START_Pos = 0x2
	// Bit mask of RX_START field.
	I2S_RX_CONF_RX_START_Msk = 0x4
	// Bit RX_START.
	I2S_RX_CONF_RX_START = 0x4
	// Position of RX_SLAVE_MOD field.
	I2S_RX_CONF_RX_SLAVE_MOD_Pos = 0x3
	// Bit mask of RX_SLAVE_MOD field.
	I2S_RX_CONF_RX_SLAVE_MOD_Msk = 0x8
	// Bit RX_SLAVE_MOD.
	I2S_RX_CONF_RX_SLAVE_MOD = 0x8
	// Position of RX_MONO field.
	I2S_RX_CONF_RX_MONO_Pos = 0x5
	// Bit mask of RX_MONO field.
	I2S_RX_CONF_RX_MONO_Msk = 0x20
	// Bit RX_MONO.
	I2S_RX_CONF_RX_MONO = 0x20
	// Position of RX_BIG_ENDIAN field.
	I2S_RX_CONF_RX_BIG_ENDIAN_Pos = 0x7
	// Bit mask of RX_BIG_ENDIAN field.
	I2S_RX_CONF_RX_BIG_ENDIAN_Msk = 0x80
	// Bit RX_BIG_ENDIAN.
	I2S_RX_CONF_RX_BIG_ENDIAN = 0x80
	// Position of RX_UPDATE field.
	I2S_RX_CONF_RX_UPDATE_Pos = 0x8
	// Bit mask of RX_UPDATE field.
	I2S_RX_CONF_RX_UPDATE_Msk = 0x100
	// Bit RX_UPDATE.
	I2S_RX_CONF_RX_UPDATE = 0x100
	// Position of RX_MONO_FST_VLD field.
	I2S_RX_CONF_RX_MONO_FST_VLD_Pos = 0x9
	// Bit mask of RX_MONO_FST_VLD field.
	I2S_RX_CONF_RX_MONO_FST_VLD_Msk = 0x200
	// Bit RX_MONO_FST_VLD.
	I2S_RX_CONF_RX_MONO_FST_VLD = 0x200
	// Position of RX_PCM_CONF field.
	I2S_RX_CONF_RX_PCM_CONF_Pos = 0xa
	// Bit mask of RX_PCM_CONF field.
	I2S_RX_CONF_RX_PCM_CONF_Msk = 0xc00
	// Position of RX_PCM_BYPASS field.
	I2S_RX_CONF_RX_PCM_BYPASS_Pos = 0xc
	// Bit mask of RX_PCM_BYPASS field.
	I2S_RX_CONF_RX_PCM_BYPASS_Msk = 0x1000
	// Bit RX_PCM_BYPASS.
	I2S_RX_CONF_RX_PCM_BYPASS = 0x1000
	// Position of RX_STOP_MODE field.
	I2S_RX_CONF_RX_STOP_MODE_Pos = 0xd
	// Bit mask of RX_STOP_MODE field.
	I2S_RX_CONF_RX_STOP_MODE_Msk = 0x6000
	// Position of RX_LEFT_ALIGN field.
	I2S_RX_CONF_RX_LEFT_ALIGN_Pos = 0xf
	// Bit mask of RX_LEFT_ALIGN field.
	I2S_RX_CONF_RX_LEFT_ALIGN_Msk = 0x8000
	// Bit RX_LEFT_ALIGN.
	I2S_RX_CONF_RX_LEFT_ALIGN = 0x8000
	// Position of RX_24_FILL_EN field.
	I2S_RX_CONF_RX_24_FILL_EN_Pos = 0x10
	// Bit mask of RX_24_FILL_EN field.
	I2S_RX_CONF_RX_24_FILL_EN_Msk = 0x10000
	// Bit RX_24_FILL_EN.
	I2S_RX_CONF_RX_24_FILL_EN = 0x10000
	// Position of RX_WS_IDLE_POL field.
	I2S_RX_CONF_RX_WS_IDLE_POL_Pos = 0x11
	// Bit mask of RX_WS_IDLE_POL field.
	I2S_RX_CONF_RX_WS_IDLE_POL_Msk = 0x20000
	// Bit RX_WS_IDLE_POL.
	I2S_RX_CONF_RX_WS_IDLE_POL = 0x20000
	// Position of RX_BIT_ORDER field.
	I2S_RX_CONF_RX_BIT_ORDER_Pos = 0x12
	// Bit mask of RX_BIT_ORDER field.
	I2S_RX_CONF_RX_BIT_ORDER_Msk = 0x40000
	// Bit RX_BIT_ORDER.
	I2S_RX_CONF_RX_BIT_ORDER = 0x40000
	// Position of RX_TDM_EN field.
	I2S_RX_CONF_RX_TDM_EN_Pos = 0x13
	// Bit mask of RX_TDM_EN field.
	I2S_RX_CONF_RX_TDM_EN_Msk = 0x80000
	// Bit RX_TDM_EN.
	I2S_RX_CONF_RX_TDM_EN = 0x80000
	// Position of RX_PDM_EN field.
	I2S_RX_CONF_RX_PDM_EN_Pos = 0x14
	// Bit mask of RX_PDM_EN field.
	I2S_RX_CONF_RX_PDM_EN_Msk = 0x100000
	// Bit RX_PDM_EN.
	I2S_RX_CONF_RX_PDM_EN = 0x100000

	// TX_CONF: I2S TX configure register
	// Position of TX_RESET field.
	I2S_TX_CONF_TX_RESET_Pos = 0x0
	// Bit mask of TX_RESET field.
	I2S_TX_CONF_TX_RESET_Msk = 0x1
	// Bit TX_RESET.
	I2S_TX_CONF_TX_RESET = 0x1
	// Position of TX_FIFO_RESET field.
	I2S_TX_CONF_TX_FIFO_RESET_Pos = 0x1
	// Bit mask of TX_FIFO_RESET field.
	I2S_TX_CONF_TX_FIFO_RESET_Msk = 0x2
	// Bit TX_FIFO_RESET.
	I2S_TX_CONF_TX_FIFO_RESET = 0x2
	// Position of TX_START field.
	I2S_TX_CONF_TX_START_Pos = 0x2
	// Bit mask of TX_START field.
	I2S_TX_CONF_TX_START_Msk = 0x4
	// Bit TX_START.
	I2S_TX_CONF_TX_START = 0x4
	// Position of TX_SLAVE_MOD field.
	I2S_TX_CONF_TX_SLAVE_MOD_Pos = 0x3
	// Bit mask of TX_SLAVE_MOD field.
	I2S_TX_CONF_TX_SLAVE_MOD_Msk = 0x8
	// Bit TX_SLAVE_MOD.
	I2S_TX_CONF_TX_SLAVE_MOD = 0x8
	// Position of TX_MONO field.
	I2S_TX_CONF_TX_MONO_Pos = 0x5
	// Bit mask of TX_MONO field.
	I2S_TX_CONF_TX_MONO_Msk = 0x20
	// Bit TX_MONO.
	I2S_TX_CONF_TX_MONO = 0x20
	// Position of TX_CHAN_EQUAL field.
	I2S_TX_CONF_TX_CHAN_EQUAL_Pos = 0x6
	// Bit mask of TX_CHAN_EQUAL field.
	I2S_TX_CONF_TX_CHAN_EQUAL_Msk = 0x40
	// Bit TX_CHAN_EQUAL.
	I2S_TX_CONF_TX_CHAN_EQUAL = 0x40
	// Position of TX_BIG_ENDIAN field.
	I2S_TX_CONF_TX_BIG_ENDIAN_Pos = 0x7
	// Bit mask of TX_BIG_ENDIAN field.
	I2S_TX_CONF_TX_BIG_ENDIAN_Msk = 0x80
	// Bit TX_BIG_ENDIAN.
	I2S_TX_CONF_TX_BIG_ENDIAN = 0x80
	// Position of TX_UPDATE field.
	I2S_TX_CONF_TX_UPDATE_Pos = 0x8
	// Bit mask of TX_UPDATE field.
	I2S_TX_CONF_TX_UPDATE_Msk = 0x100
	// Bit TX_UPDATE.
	I2S_TX_CONF_TX_UPDATE = 0x100
	// Position of TX_MONO_FST_VLD field.
	I2S_TX_CONF_TX_MONO_FST_VLD_Pos = 0x9
	// Bit mask of TX_MONO_FST_VLD field.
	I2S_TX_CONF_TX_MONO_FST_VLD_Msk = 0x200
	// Bit TX_MONO_FST_VLD.
	I2S_TX_CONF_TX_MONO_FST_VLD = 0x200
	// Position of TX_PCM_CONF field.
	I2S_TX_CONF_TX_PCM_CONF_Pos = 0xa
	// Bit mask of TX_PCM_CONF field.
	I2S_TX_CONF_TX_PCM_CONF_Msk = 0xc00
	// Position of TX_PCM_BYPASS field.
	I2S_TX_CONF_TX_PCM_BYPASS_Pos = 0xc
	// Bit mask of TX_PCM_BYPASS field.
	I2S_TX_CONF_TX_PCM_BYPASS_Msk = 0x1000
	// Bit TX_PCM_BYPASS.
	I2S_TX_CONF_TX_PCM_BYPASS = 0x1000
	// Position of TX_STOP_EN field.
	I2S_TX_CONF_TX_STOP_EN_Pos = 0xd
	// Bit mask of TX_STOP_EN field.
	I2S_TX_CONF_TX_STOP_EN_Msk = 0x2000
	// Bit TX_STOP_EN.
	I2S_TX_CONF_TX_STOP_EN = 0x2000
	// Position of TX_LEFT_ALIGN field.
	I2S_TX_CONF_TX_LEFT_ALIGN_Pos = 0xf
	// Bit mask of TX_LEFT_ALIGN field.
	I2S_TX_CONF_TX_LEFT_ALIGN_Msk = 0x8000
	// Bit TX_LEFT_ALIGN.
	I2S_TX_CONF_TX_LEFT_ALIGN = 0x8000
	// Position of TX_24_FILL_EN field.
	I2S_TX_CONF_TX_24_FILL_EN_Pos = 0x10
	// Bit mask of TX_24_FILL_EN field.
	I2S_TX_CONF_TX_24_FILL_EN_Msk = 0x10000
	// Bit TX_24_FILL_EN.
	I2S_TX_CONF_TX_24_FILL_EN = 0x10000
	// Position of TX_WS_IDLE_POL field.
	I2S_TX_CONF_TX_WS_IDLE_POL_Pos = 0x11
	// Bit mask of TX_WS_IDLE_POL field.
	I2S_TX_CONF_TX_WS_IDLE_POL_Msk = 0x20000
	// Bit TX_WS_IDLE_POL.
	I2S_TX_CONF_TX_WS_IDLE_POL = 0x20000
	// Position of TX_BIT_ORDER field.
	I2S_TX_CONF_TX_BIT_ORDER_Pos = 0x12
	// Bit mask of TX_BIT_ORDER field.
	I2S_TX_CONF_TX_BIT_ORDER_Msk = 0x40000
	// Bit TX_BIT_ORDER.
	I2S_TX_CONF_TX_BIT_ORDER = 0x40000
	// Position of TX_TDM_EN field.
	I2S_TX_CONF_TX_TDM_EN_Pos = 0x13
	// Bit mask of TX_TDM_EN field.
	I2S_TX_CONF_TX_TDM_EN_Msk = 0x80000
	// Bit TX_TDM_EN.
	I2S_TX_CONF_TX_TDM_EN = 0x80000
	// Position of TX_PDM_EN field.
	I2S_TX_CONF_TX_PDM_EN_Pos = 0x14
	// Bit mask of TX_PDM_EN field.
	I2S_TX_CONF_TX_PDM_EN_Msk = 0x100000
	// Bit TX_PDM_EN.
	I2S_TX_CONF_TX_PDM_EN = 0x100000
	// Position of TX_CHAN_MOD field.
	I2S_TX_CONF_TX_CHAN_MOD_Pos = 0x18
	// Bit mask of TX_CHAN_MOD field.
	I2S_TX_CONF_TX_CHAN_MOD_Msk = 0x7000000
	// Position of SIG_LOOPBACK field.
	I2S_TX_CONF_SIG_LOOPBACK_Pos = 0x1b
	// Bit mask of SIG_LOOPBACK field.
	I2S_TX_CONF_SIG_LOOPBACK_Msk = 0x8000000
	// Bit SIG_LOOPBACK.
	I2S_TX_CONF_SIG_LOOPBACK = 0x8000000

	// RX_CONF1: I2S RX configure register 1
	// Position of RX_TDM_WS_WIDTH field.
	I2S_RX_CONF1_RX_TDM_WS_WIDTH_Pos = 0x0
	// Bit mask of RX_TDM_WS_WIDTH field.
	I2S_RX_CONF1_RX_TDM_WS_WIDTH_Msk = 0x7f
	// Position of RX_BCK_DIV_NUM field.
	I2S_RX_CONF1_RX_BCK_DIV_NUM_Pos = 0x7
	// Bit mask of RX_BCK_DIV_NUM field.
	I2S_RX_CONF1_RX_BCK_DIV_NUM_Msk = 0x1f80
	// Position of RX_BITS_MOD field.
	I2S_RX_CONF1_RX_BITS_MOD_Pos = 0xd
	// Bit mask of RX_BITS_MOD field.
	I2S_RX_CONF1_RX_BITS_MOD_Msk = 0x3e000
	// Position of RX_HALF_SAMPLE_BITS field.
	I2S_RX_CONF1_RX_HALF_SAMPLE_BITS_Pos = 0x12
	// Bit mask of RX_HALF_SAMPLE_BITS field.
	I2S_RX_CONF1_RX_HALF_SAMPLE_BITS_Msk = 0xfc0000
	// Position of RX_TDM_CHAN_BITS field.
	I2S_RX_CONF1_RX_TDM_CHAN_BITS_Pos = 0x18
	// Bit mask of RX_TDM_CHAN_BITS field.
	I2S_RX_CONF1_RX_TDM_CHAN_BITS_Msk = 0x1f000000
	// Position of RX_MSB_SHIFT field.
	I2S_RX_CONF1_RX_MSB_SHIFT_Pos = 0x1d
	// Bit mask of RX_MSB_SHIFT field.
	I2S_RX_CONF1_RX_MSB_SHIFT_Msk = 0x20000000
	// Bit RX_MSB_SHIFT.
	I2S_RX_CONF1_RX_MSB_SHIFT = 0x20000000

	// TX_CONF1: I2S TX configure register 1
	// Position of TX_TDM_WS_WIDTH field.
	I2S_TX_CONF1_TX_TDM_WS_WIDTH_Pos = 0x0
	// Bit mask of TX_TDM_WS_WIDTH field.
	I2S_TX_CONF1_TX_TDM_WS_WIDTH_Msk = 0x7f
	// Position of TX_BCK_DIV_NUM field.
	I2S_TX_CONF1_TX_BCK_DIV_NUM_Pos = 0x7
	// Bit mask of TX_BCK_DIV_NUM field.
	I2S_TX_CONF1_TX_BCK_DIV_NUM_Msk = 0x1f80
	// Position of TX_BITS_MOD field.
	I2S_TX_CONF1_TX_BITS_MOD_Pos = 0xd
	// Bit mask of TX_BITS_MOD field.
	I2S_TX_CONF1_TX_BITS_MOD_Msk = 0x3e000
	// Position of TX_HALF_SAMPLE_BITS field.
	I2S_TX_CONF1_TX_HALF_SAMPLE_BITS_Pos = 0x12
	// Bit mask of TX_HALF_SAMPLE_BITS field.
	I2S_TX_CONF1_TX_HALF_SAMPLE_BITS_Msk = 0xfc0000
	// Position of TX_TDM_CHAN_BITS field.
	I2S_TX_CONF1_TX_TDM_CHAN_BITS_Pos = 0x18
	// Bit mask of TX_TDM_CHAN_BITS field.
	I2S_TX_CONF1_TX_TDM_CHAN_BITS_Msk = 0x1f000000
	// Position of TX_MSB_SHIFT field.
	I2S_TX_CONF1_TX_MSB_SHIFT_Pos = 0x1d
	// Bit mask of TX_MSB_SHIFT field.
	I2S_TX_CONF1_TX_MSB_SHIFT_Msk = 0x20000000
	// Bit TX_MSB_SHIFT.
	I2S_TX_CONF1_TX_MSB_SHIFT = 0x20000000
	// Position of TX_BCK_NO_DLY field.
	I2S_TX_CONF1_TX_BCK_NO_DLY_Pos = 0x1e
	// Bit mask of TX_BCK_NO_DLY field.
	I2S_TX_CONF1_TX_BCK_NO_DLY_Msk = 0x40000000
	// Bit TX_BCK_NO_DLY.
	I2S_TX_CONF1_TX_BCK_NO_DLY = 0x40000000

	// RX_CLKM_CONF: I2S RX clock configure register
	// Position of RX_CLKM_DIV_NUM field.
	I2S_RX_CLKM_CONF_RX_CLKM_DIV_NUM_Pos = 0x0
	// Bit mask of RX_CLKM_DIV_NUM field.
	I2S_RX_CLKM_CONF_RX_CLKM_DIV_NUM_Msk = 0xff
	// Position of RX_CLK_ACTIVE field.
	I2S_RX_CLKM_CONF_RX_CLK_ACTIVE_Pos = 0x1a
	// Bit mask of RX_CLK_ACTIVE field.
	I2S_RX_CLKM_CONF_RX_CLK_ACTIVE_Msk = 0x4000000
	// Bit RX_CLK_ACTIVE.
	I2S_RX_CLKM_CONF_RX_CLK_ACTIVE = 0x4000000
	// Position of RX_CLK_SEL field.
	I2S_RX_CLKM_CONF_RX_CLK_SEL_Pos = 0x1b
	// Bit mask of RX_CLK_SEL field.
	I2S_RX_CLKM_CONF_RX_CLK_SEL_Msk = 0x18000000
	// Position of MCLK_SEL field.
	I2S_RX_CLKM_CONF_MCLK_SEL_Pos = 0x1d
	// Bit mask of MCLK_SEL field.
	I2S_RX_CLKM_CONF_MCLK_SEL_Msk = 0x20000000
	// Bit MCLK_SEL.
	I2S_RX_CLKM_CONF_MCLK_SEL = 0x20000000

	// TX_CLKM_CONF: I2S TX clock configure register
	// Position of TX_CLKM_DIV_NUM field.
	I2S_TX_CLKM_CONF_TX_CLKM_DIV_NUM_Pos = 0x0
	// Bit mask of TX_CLKM_DIV_NUM field.
	I2S_TX_CLKM_CONF_TX_CLKM_DIV_NUM_Msk = 0xff
	// Position of TX_CLK_ACTIVE field.
	I2S_TX_CLKM_CONF_TX_CLK_ACTIVE_Pos = 0x1a
	// Bit mask of TX_CLK_ACTIVE field.
	I2S_TX_CLKM_CONF_TX_CLK_ACTIVE_Msk = 0x4000000
	// Bit TX_CLK_ACTIVE.
	I2S_TX_CLKM_CONF_TX_CLK_ACTIVE = 0x4000000
	// Position of TX_CLK_SEL field.
	I2S_TX_CLKM_CONF_TX_CLK_SEL_Pos = 0x1b
	// Bit mask of TX_CLK_SEL field.
	I2S_TX_CLKM_CONF_TX_CLK_SEL_Msk = 0x18000000
	// Position of CLK_EN field.
	I2S_TX_CLKM_CONF_CLK_EN_Pos = 0x1d
	// Bit mask of CLK_EN field.
	I2S_TX_CLKM_CONF_CLK_EN_Msk = 0x20000000
	// Bit CLK_EN.
	I2S_TX_CLKM_CONF_CLK_EN = 0x20000000

	// RX_CLKM_DIV_CONF: I2S RX module clock divider configure register
	// Position of RX_CLKM_DIV_Z field.
	I2S_RX_CLKM_DIV_CONF_RX_CLKM_DIV_Z_Pos = 0x0
	// Bit mask of RX_CLKM_DIV_Z field.
	I2S_RX_CLKM_DIV_CONF_RX_CLKM_DIV_Z_Msk = 0x1ff
	// Position of RX_CLKM_DIV_Y field.
	I2S_RX_CLKM_DIV_CONF_RX_CLKM_DIV_Y_Pos = 0x9
	// Bit mask of RX_CLKM_DIV_Y field.
	I2S_RX_CLKM_DIV_CONF_RX_CLKM_DIV_Y_Msk = 0x3fe00
	// Position of RX_CLKM_DIV_X field.
	I2S_RX_CLKM_DIV_CONF_RX_CLKM_DIV_X_Pos = 0x12
	// Bit mask of RX_CLKM_DIV_X field.
	I2S_RX_CLKM_DIV_CONF_RX_CLKM_DIV_X_Msk = 0x7fc0000
	// Position of RX_CLKM_DIV_YN1 field.
	I2S_RX_CLKM_DIV_CONF_RX_CLKM_DIV_YN1_Pos = 0x1b
	// Bit mask of RX_CLKM_DIV_YN1 field.
	I2S_RX_CLKM_DIV_CONF_RX_CLKM_DIV_YN1_Msk = 0x8000000
	// Bit RX_CLKM_DIV_YN1.
	I2S_RX_CLKM_DIV_CONF_RX_CLKM_DIV_YN1 = 0x8000000

	// TX_CLKM_DIV_CONF: I2S TX module clock divider configure register
	// Position of TX_CLKM_DIV_Z field.
	I2S_TX_CLKM_DIV_CONF_TX_CLKM_DIV_Z_Pos = 0x0
	// Bit mask of TX_CLKM_DIV_Z field.
	I2S_TX_CLKM_DIV_CONF_TX_CLKM_DIV_Z_Msk = 0x1ff
	// Position of TX_CLKM_DIV_Y field.
	I2S_TX_CLKM_DIV_CONF_TX_CLKM_DIV_Y_Pos = 0x9
	// Bit mask of TX_CLKM_DIV_Y field.
	I2S_TX_CLKM_DIV_CONF_TX_CLKM_DIV_Y_Msk = 0x3fe00
	// Position of TX_CLKM_DIV_X field.
	I2S_TX_CLKM_DIV_CONF_TX_CLKM_DIV_X_Pos = 0x12
	// Bit mask of TX_CLKM_DIV_X field.
	I2S_TX_CLKM_DIV_CONF_TX_CLKM_DIV_X_Msk = 0x7fc0000
	// Position of TX_CLKM_DIV_YN1 field.
	I2S_TX_CLKM_DIV_CONF_TX_CLKM_DIV_YN1_Pos = 0x1b
	// Bit mask of TX_CLKM_DIV_YN1 field.
	I2S_TX_CLKM_DIV_CONF_TX_CLKM_DIV_YN1_Msk = 0x8000000
	// Bit TX_CLKM_DIV_YN1.
	I2S_TX_CLKM_DIV_CONF_TX_CLKM_DIV_YN1 = 0x8000000

	// TX_PCM2PDM_CONF: I2S TX PCM2PDM configuration register
	// Position of TX_PDM_HP_BYPASS field.
	I2S_TX_PCM2PDM_CONF_TX_PDM_HP_BYPASS_Pos = 0x0
	// Bit mask of TX_PDM_HP_BYPASS field.
	I2S_TX_PCM2PDM_CONF_TX_PDM_HP_BYPASS_Msk = 0x1
	// Bit TX_PDM_HP_BYPASS.
	I2S_TX_PCM2PDM_CONF_TX_PDM_HP_BYPASS = 0x1
	// Position of TX_PDM_SINC_OSR2 field.
	I2S_TX_PCM2PDM_CONF_TX_PDM_SINC_OSR2_Pos = 0x1
	// Bit mask of TX_PDM_SINC_OSR2 field.
	I2S_TX_PCM2PDM_CONF_TX_PDM_SINC_OSR2_Msk = 0x1e
	// Position of TX_PDM_PRESCALE field.
	I2S_TX_PCM2PDM_CONF_TX_PDM_PRESCALE_Pos = 0x5
	// Bit mask of TX_PDM_PRESCALE field.
	I2S_TX_PCM2PDM_CONF_TX_PDM_PRESCALE_Msk = 0x1fe0
	// Position of TX_PDM_HP_IN_SHIFT field.
	I2S_TX_PCM2PDM_CONF_TX_PDM_HP_IN_SHIFT_Pos = 0xd
	// Bit mask of TX_PDM_HP_IN_SHIFT field.
	I2S_TX_PCM2PDM_CONF_TX_PDM_HP_IN_SHIFT_Msk = 0x6000
	// Position of TX_PDM_LP_IN_SHIFT field.
	I2S_TX_PCM2PDM_CONF_TX_PDM_LP_IN_SHIFT_Pos = 0xf
	// Bit mask of TX_PDM_LP_IN_SHIFT field.
	I2S_TX_PCM2PDM_CONF_TX_PDM_LP_IN_SHIFT_Msk = 0x18000
	// Position of TX_PDM_SINC_IN_SHIFT field.
	I2S_TX_PCM2PDM_CONF_TX_PDM_SINC_IN_SHIFT_Pos = 0x11
	// Bit mask of TX_PDM_SINC_IN_SHIFT field.
	I2S_TX_PCM2PDM_CONF_TX_PDM_SINC_IN_SHIFT_Msk = 0x60000
	// Position of TX_PDM_SIGMADELTA_IN_SHIFT field.
	I2S_TX_PCM2PDM_CONF_TX_PDM_SIGMADELTA_IN_SHIFT_Pos = 0x13
	// Bit mask of TX_PDM_SIGMADELTA_IN_SHIFT field.
	I2S_TX_PCM2PDM_CONF_TX_PDM_SIGMADELTA_IN_SHIFT_Msk = 0x180000
	// Position of TX_PDM_SIGMADELTA_DITHER2 field.
	I2S_TX_PCM2PDM_CONF_TX_PDM_SIGMADELTA_DITHER2_Pos = 0x15
	// Bit mask of TX_PDM_SIGMADELTA_DITHER2 field.
	I2S_TX_PCM2PDM_CONF_TX_PDM_SIGMADELTA_DITHER2_Msk = 0x200000
	// Bit TX_PDM_SIGMADELTA_DITHER2.
	I2S_TX_PCM2PDM_CONF_TX_PDM_SIGMADELTA_DITHER2 = 0x200000
	// Position of TX_PDM_SIGMADELTA_DITHER field.
	I2S_TX_PCM2PDM_CONF_TX_PDM_SIGMADELTA_DITHER_Pos = 0x16
	// Bit mask of TX_PDM_SIGMADELTA_DITHER field.
	I2S_TX_PCM2PDM_CONF_TX_PDM_SIGMADELTA_DITHER_Msk = 0x400000
	// Bit TX_PDM_SIGMADELTA_DITHER.
	I2S_TX_PCM2PDM_CONF_TX_PDM_SIGMADELTA_DITHER = 0x400000
	// Position of TX_PDM_DAC_2OUT_EN field.
	I2S_TX_PCM2PDM_CONF_TX_PDM_DAC_2OUT_EN_Pos = 0x17
	// Bit mask of TX_PDM_DAC_2OUT_EN field.
	I2S_TX_PCM2PDM_CONF_TX_PDM_DAC_2OUT_EN_Msk = 0x800000
	// Bit TX_PDM_DAC_2OUT_EN.
	I2S_TX_PCM2PDM_CONF_TX_PDM_DAC_2OUT_EN = 0x800000
	// Position of TX_PDM_DAC_MODE_EN field.
	I2S_TX_PCM2PDM_CONF_TX_PDM_DAC_MODE_EN_Pos = 0x18
	// Bit mask of TX_PDM_DAC_MODE_EN field.
	I2S_TX_PCM2PDM_CONF_TX_PDM_DAC_MODE_EN_Msk = 0x1000000
	// Bit TX_PDM_DAC_MODE_EN.
	I2S_TX_PCM2PDM_CONF_TX_PDM_DAC_MODE_EN = 0x1000000
	// Position of PCM2PDM_CONV_EN field.
	I2S_TX_PCM2PDM_CONF_PCM2PDM_CONV_EN_Pos = 0x19
	// Bit mask of PCM2PDM_CONV_EN field.
	I2S_TX_PCM2PDM_CONF_PCM2PDM_CONV_EN_Msk = 0x2000000
	// Bit PCM2PDM_CONV_EN.
	I2S_TX_PCM2PDM_CONF_PCM2PDM_CONV_EN = 0x2000000

	// TX_PCM2PDM_CONF1: I2S TX PCM2PDM configuration register
	// Position of TX_PDM_FP field.
	I2S_TX_PCM2PDM_CONF1_TX_PDM_FP_Pos = 0x0
	// Bit mask of TX_PDM_FP field.
	I2S_TX_PCM2PDM_CONF1_TX_PDM_FP_Msk = 0x3ff
	// Position of TX_PDM_FS field.
	I2S_TX_PCM2PDM_CONF1_TX_PDM_FS_Pos = 0xa
	// Bit mask of TX_PDM_FS field.
	I2S_TX_PCM2PDM_CONF1_TX_PDM_FS_Msk = 0xffc00
	// Position of TX_IIR_HP_MULT12_5 field.
	I2S_TX_PCM2PDM_CONF1_TX_IIR_HP_MULT12_5_Pos = 0x14
	// Bit mask of TX_IIR_HP_MULT12_5 field.
	I2S_TX_PCM2PDM_CONF1_TX_IIR_HP_MULT12_5_Msk = 0x700000
	// Position of TX_IIR_HP_MULT12_0 field.
	I2S_TX_PCM2PDM_CONF1_TX_IIR_HP_MULT12_0_Pos = 0x17
	// Bit mask of TX_IIR_HP_MULT12_0 field.
	I2S_TX_PCM2PDM_CONF1_TX_IIR_HP_MULT12_0_Msk = 0x3800000

	// RX_TDM_CTRL: I2S TX TDM mode control register
	// Position of RX_TDM_PDM_CHAN0_EN field.
	I2S_RX_TDM_CTRL_RX_TDM_PDM_CHAN0_EN_Pos = 0x0
	// Bit mask of RX_TDM_PDM_CHAN0_EN field.
	I2S_RX_TDM_CTRL_RX_TDM_PDM_CHAN0_EN_Msk = 0x1
	// Bit RX_TDM_PDM_CHAN0_EN.
	I2S_RX_TDM_CTRL_RX_TDM_PDM_CHAN0_EN = 0x1
	// Position of RX_TDM_PDM_CHAN1_EN field.
	I2S_RX_TDM_CTRL_RX_TDM_PDM_CHAN1_EN_Pos = 0x1
	// Bit mask of RX_TDM_PDM_CHAN1_EN field.
	I2S_RX_TDM_CTRL_RX_TDM_PDM_CHAN1_EN_Msk = 0x2
	// Bit RX_TDM_PDM_CHAN1_EN.
	I2S_RX_TDM_CTRL_RX_TDM_PDM_CHAN1_EN = 0x2
	// Position of RX_TDM_PDM_CHAN2_EN field.
	I2S_RX_TDM_CTRL_RX_TDM_PDM_CHAN2_EN_Pos = 0x2
	// Bit mask of RX_TDM_PDM_CHAN2_EN field.
	I2S_RX_TDM_CTRL_RX_TDM_PDM_CHAN2_EN_Msk = 0x4
	// Bit RX_TDM_PDM_CHAN2_EN.
	I2S_RX_TDM_CTRL_RX_TDM_PDM_CHAN2_EN = 0x4
	// Position of RX_TDM_PDM_CHAN3_EN field.
	I2S_RX_TDM_CTRL_RX_TDM_PDM_CHAN3_EN_Pos = 0x3
	// Bit mask of RX_TDM_PDM_CHAN3_EN field.
	I2S_RX_TDM_CTRL_RX_TDM_PDM_CHAN3_EN_Msk = 0x8
	// Bit RX_TDM_PDM_CHAN3_EN.
	I2S_RX_TDM_CTRL_RX_TDM_PDM_CHAN3_EN = 0x8
	// Position of RX_TDM_PDM_CHAN4_EN field.
	I2S_RX_TDM_CTRL_RX_TDM_PDM_CHAN4_EN_Pos = 0x4
	// Bit mask of RX_TDM_PDM_CHAN4_EN field.
	I2S_RX_TDM_CTRL_RX_TDM_PDM_CHAN4_EN_Msk = 0x10
	// Bit RX_TDM_PDM_CHAN4_EN.
	I2S_RX_TDM_CTRL_RX_TDM_PDM_CHAN4_EN = 0x10
	// Position of RX_TDM_PDM_CHAN5_EN field.
	I2S_RX_TDM_CTRL_RX_TDM_PDM_CHAN5_EN_Pos = 0x5
	// Bit mask of RX_TDM_PDM_CHAN5_EN field.
	I2S_RX_TDM_CTRL_RX_TDM_PDM_CHAN5_EN_Msk = 0x20
	// Bit RX_TDM_PDM_CHAN5_EN.
	I2S_RX_TDM_CTRL_RX_TDM_PDM_CHAN5_EN = 0x20
	// Position of RX_TDM_PDM_CHAN6_EN field.
	I2S_RX_TDM_CTRL_RX_TDM_PDM_CHAN6_EN_Pos = 0x6
	// Bit mask of RX_TDM_PDM_CHAN6_EN field.
	I2S_RX_TDM_CTRL_RX_TDM_PDM_CHAN6_EN_Msk = 0x40
	// Bit RX_TDM_PDM_CHAN6_EN.
	I2S_RX_TDM_CTRL_RX_TDM_PDM_CHAN6_EN = 0x40
	// Position of RX_TDM_PDM_CHAN7_EN field.
	I2S_RX_TDM_CTRL_RX_TDM_PDM_CHAN7_EN_Pos = 0x7
	// Bit mask of RX_TDM_PDM_CHAN7_EN field.
	I2S_RX_TDM_CTRL_RX_TDM_PDM_CHAN7_EN_Msk = 0x80
	// Bit RX_TDM_PDM_CHAN7_EN.
	I2S_RX_TDM_CTRL_RX_TDM_PDM_CHAN7_EN = 0x80
	// Position of RX_TDM_CHAN8_EN field.
	I2S_RX_TDM_CTRL_RX_TDM_CHAN8_EN_Pos = 0x8
	// Bit mask of RX_TDM_CHAN8_EN field.
	I2S_RX_TDM_CTRL_RX_TDM_CHAN8_EN_Msk = 0x100
	// Bit RX_TDM_CHAN8_EN.
	I2S_RX_TDM_CTRL_RX_TDM_CHAN8_EN = 0x100
	// Position of RX_TDM_CHAN9_EN field.
	I2S_RX_TDM_CTRL_RX_TDM_CHAN9_EN_Pos = 0x9
	// Bit mask of RX_TDM_CHAN9_EN field.
	I2S_RX_TDM_CTRL_RX_TDM_CHAN9_EN_Msk = 0x200
	// Bit RX_TDM_CHAN9_EN.
	I2S_RX_TDM_CTRL_RX_TDM_CHAN9_EN = 0x200
	// Position of RX_TDM_CHAN10_EN field.
	I2S_RX_TDM_CTRL_RX_TDM_CHAN10_EN_Pos = 0xa
	// Bit mask of RX_TDM_CHAN10_EN field.
	I2S_RX_TDM_CTRL_RX_TDM_CHAN10_EN_Msk = 0x400
	// Bit RX_TDM_CHAN10_EN.
	I2S_RX_TDM_CTRL_RX_TDM_CHAN10_EN = 0x400
	// Position of RX_TDM_CHAN11_EN field.
	I2S_RX_TDM_CTRL_RX_TDM_CHAN11_EN_Pos = 0xb
	// Bit mask of RX_TDM_CHAN11_EN field.
	I2S_RX_TDM_CTRL_RX_TDM_CHAN11_EN_Msk = 0x800
	// Bit RX_TDM_CHAN11_EN.
	I2S_RX_TDM_CTRL_RX_TDM_CHAN11_EN = 0x800
	// Position of RX_TDM_CHAN12_EN field.
	I2S_RX_TDM_CTRL_RX_TDM_CHAN12_EN_Pos = 0xc
	// Bit mask of RX_TDM_CHAN12_EN field.
	I2S_RX_TDM_CTRL_RX_TDM_CHAN12_EN_Msk = 0x1000
	// Bit RX_TDM_CHAN12_EN.
	I2S_RX_TDM_CTRL_RX_TDM_CHAN12_EN = 0x1000
	// Position of RX_TDM_CHAN13_EN field.
	I2S_RX_TDM_CTRL_RX_TDM_CHAN13_EN_Pos = 0xd
	// Bit mask of RX_TDM_CHAN13_EN field.
	I2S_RX_TDM_CTRL_RX_TDM_CHAN13_EN_Msk = 0x2000
	// Bit RX_TDM_CHAN13_EN.
	I2S_RX_TDM_CTRL_RX_TDM_CHAN13_EN = 0x2000
	// Position of RX_TDM_CHAN14_EN field.
	I2S_RX_TDM_CTRL_RX_TDM_CHAN14_EN_Pos = 0xe
	// Bit mask of RX_TDM_CHAN14_EN field.
	I2S_RX_TDM_CTRL_RX_TDM_CHAN14_EN_Msk = 0x4000
	// Bit RX_TDM_CHAN14_EN.
	I2S_RX_TDM_CTRL_RX_TDM_CHAN14_EN = 0x4000
	// Position of RX_TDM_CHAN15_EN field.
	I2S_RX_TDM_CTRL_RX_TDM_CHAN15_EN_Pos = 0xf
	// Bit mask of RX_TDM_CHAN15_EN field.
	I2S_RX_TDM_CTRL_RX_TDM_CHAN15_EN_Msk = 0x8000
	// Bit RX_TDM_CHAN15_EN.
	I2S_RX_TDM_CTRL_RX_TDM_CHAN15_EN = 0x8000
	// Position of RX_TDM_TOT_CHAN_NUM field.
	I2S_RX_TDM_CTRL_RX_TDM_TOT_CHAN_NUM_Pos = 0x10
	// Bit mask of RX_TDM_TOT_CHAN_NUM field.
	I2S_RX_TDM_CTRL_RX_TDM_TOT_CHAN_NUM_Msk = 0xf0000

	// TX_TDM_CTRL: I2S TX TDM mode control register
	// Position of TX_TDM_CHAN0_EN field.
	I2S_TX_TDM_CTRL_TX_TDM_CHAN0_EN_Pos = 0x0
	// Bit mask of TX_TDM_CHAN0_EN field.
	I2S_TX_TDM_CTRL_TX_TDM_CHAN0_EN_Msk = 0x1
	// Bit TX_TDM_CHAN0_EN.
	I2S_TX_TDM_CTRL_TX_TDM_CHAN0_EN = 0x1
	// Position of TX_TDM_CHAN1_EN field.
	I2S_TX_TDM_CTRL_TX_TDM_CHAN1_EN_Pos = 0x1
	// Bit mask of TX_TDM_CHAN1_EN field.
	I2S_TX_TDM_CTRL_TX_TDM_CHAN1_EN_Msk = 0x2
	// Bit TX_TDM_CHAN1_EN.
	I2S_TX_TDM_CTRL_TX_TDM_CHAN1_EN = 0x2
	// Position of TX_TDM_CHAN2_EN field.
	I2S_TX_TDM_CTRL_TX_TDM_CHAN2_EN_Pos = 0x2
	// Bit mask of TX_TDM_CHAN2_EN field.
	I2S_TX_TDM_CTRL_TX_TDM_CHAN2_EN_Msk = 0x4
	// Bit TX_TDM_CHAN2_EN.
	I2S_TX_TDM_CTRL_TX_TDM_CHAN2_EN = 0x4
	// Position of TX_TDM_CHAN3_EN field.
	I2S_TX_TDM_CTRL_TX_TDM_CHAN3_EN_Pos = 0x3
	// Bit mask of TX_TDM_CHAN3_EN field.
	I2S_TX_TDM_CTRL_TX_TDM_CHAN3_EN_Msk = 0x8
	// Bit TX_TDM_CHAN3_EN.
	I2S_TX_TDM_CTRL_TX_TDM_CHAN3_EN = 0x8
	// Position of TX_TDM_CHAN4_EN field.
	I2S_TX_TDM_CTRL_TX_TDM_CHAN4_EN_Pos = 0x4
	// Bit mask of TX_TDM_CHAN4_EN field.
	I2S_TX_TDM_CTRL_TX_TDM_CHAN4_EN_Msk = 0x10
	// Bit TX_TDM_CHAN4_EN.
	I2S_TX_TDM_CTRL_TX_TDM_CHAN4_EN = 0x10
	// Position of TX_TDM_CHAN5_EN field.
	I2S_TX_TDM_CTRL_TX_TDM_CHAN5_EN_Pos = 0x5
	// Bit mask of TX_TDM_CHAN5_EN field.
	I2S_TX_TDM_CTRL_TX_TDM_CHAN5_EN_Msk = 0x20
	// Bit TX_TDM_CHAN5_EN.
	I2S_TX_TDM_CTRL_TX_TDM_CHAN5_EN = 0x20
	// Position of TX_TDM_CHAN6_EN field.
	I2S_TX_TDM_CTRL_TX_TDM_CHAN6_EN_Pos = 0x6
	// Bit mask of TX_TDM_CHAN6_EN field.
	I2S_TX_TDM_CTRL_TX_TDM_CHAN6_EN_Msk = 0x40
	// Bit TX_TDM_CHAN6_EN.
	I2S_TX_TDM_CTRL_TX_TDM_CHAN6_EN = 0x40
	// Position of TX_TDM_CHAN7_EN field.
	I2S_TX_TDM_CTRL_TX_TDM_CHAN7_EN_Pos = 0x7
	// Bit mask of TX_TDM_CHAN7_EN field.
	I2S_TX_TDM_CTRL_TX_TDM_CHAN7_EN_Msk = 0x80
	// Bit TX_TDM_CHAN7_EN.
	I2S_TX_TDM_CTRL_TX_TDM_CHAN7_EN = 0x80
	// Position of TX_TDM_CHAN8_EN field.
	I2S_TX_TDM_CTRL_TX_TDM_CHAN8_EN_Pos = 0x8
	// Bit mask of TX_TDM_CHAN8_EN field.
	I2S_TX_TDM_CTRL_TX_TDM_CHAN8_EN_Msk = 0x100
	// Bit TX_TDM_CHAN8_EN.
	I2S_TX_TDM_CTRL_TX_TDM_CHAN8_EN = 0x100
	// Position of TX_TDM_CHAN9_EN field.
	I2S_TX_TDM_CTRL_TX_TDM_CHAN9_EN_Pos = 0x9
	// Bit mask of TX_TDM_CHAN9_EN field.
	I2S_TX_TDM_CTRL_TX_TDM_CHAN9_EN_Msk = 0x200
	// Bit TX_TDM_CHAN9_EN.
	I2S_TX_TDM_CTRL_TX_TDM_CHAN9_EN = 0x200
	// Position of TX_TDM_CHAN10_EN field.
	I2S_TX_TDM_CTRL_TX_TDM_CHAN10_EN_Pos = 0xa
	// Bit mask of TX_TDM_CHAN10_EN field.
	I2S_TX_TDM_CTRL_TX_TDM_CHAN10_EN_Msk = 0x400
	// Bit TX_TDM_CHAN10_EN.
	I2S_TX_TDM_CTRL_TX_TDM_CHAN10_EN = 0x400
	// Position of TX_TDM_CHAN11_EN field.
	I2S_TX_TDM_CTRL_TX_TDM_CHAN11_EN_Pos = 0xb
	// Bit mask of TX_TDM_CHAN11_EN field.
	I2S_TX_TDM_CTRL_TX_TDM_CHAN11_EN_Msk = 0x800
	// Bit TX_TDM_CHAN11_EN.
	I2S_TX_TDM_CTRL_TX_TDM_CHAN11_EN = 0x800
	// Position of TX_TDM_CHAN12_EN field.
	I2S_TX_TDM_CTRL_TX_TDM_CHAN12_EN_Pos = 0xc
	// Bit mask of TX_TDM_CHAN12_EN field.
	I2S_TX_TDM_CTRL_TX_TDM_CHAN12_EN_Msk = 0x1000
	// Bit TX_TDM_CHAN12_EN.
	I2S_TX_TDM_CTRL_TX_TDM_CHAN12_EN = 0x1000
	// Position of TX_TDM_CHAN13_EN field.
	I2S_TX_TDM_CTRL_TX_TDM_CHAN13_EN_Pos = 0xd
	// Bit mask of TX_TDM_CHAN13_EN field.
	I2S_TX_TDM_CTRL_TX_TDM_CHAN13_EN_Msk = 0x2000
	// Bit TX_TDM_CHAN13_EN.
	I2S_TX_TDM_CTRL_TX_TDM_CHAN13_EN = 0x2000
	// Position of TX_TDM_CHAN14_EN field.
	I2S_TX_TDM_CTRL_TX_TDM_CHAN14_EN_Pos = 0xe
	// Bit mask of TX_TDM_CHAN14_EN field.
	I2S_TX_TDM_CTRL_TX_TDM_CHAN14_EN_Msk = 0x4000
	// Bit TX_TDM_CHAN14_EN.
	I2S_TX_TDM_CTRL_TX_TDM_CHAN14_EN = 0x4000
	// Position of TX_TDM_CHAN15_EN field.
	I2S_TX_TDM_CTRL_TX_TDM_CHAN15_EN_Pos = 0xf
	// Bit mask of TX_TDM_CHAN15_EN field.
	I2S_TX_TDM_CTRL_TX_TDM_CHAN15_EN_Msk = 0x8000
	// Bit TX_TDM_CHAN15_EN.
	I2S_TX_TDM_CTRL_TX_TDM_CHAN15_EN = 0x8000
	// Position of TX_TDM_TOT_CHAN_NUM field.
	I2S_TX_TDM_CTRL_TX_TDM_TOT_CHAN_NUM_Pos = 0x10
	// Bit mask of TX_TDM_TOT_CHAN_NUM field.
	I2S_TX_TDM_CTRL_TX_TDM_TOT_CHAN_NUM_Msk = 0xf0000
	// Position of TX_TDM_SKIP_MSK_EN field.
	I2S_TX_TDM_CTRL_TX_TDM_SKIP_MSK_EN_Pos = 0x14
	// Bit mask of TX_TDM_SKIP_MSK_EN field.
	I2S_TX_TDM_CTRL_TX_TDM_SKIP_MSK_EN_Msk = 0x100000
	// Bit TX_TDM_SKIP_MSK_EN.
	I2S_TX_TDM_CTRL_TX_TDM_SKIP_MSK_EN = 0x100000

	// RX_TIMING: I2S RX timing control register
	// Position of RX_SD_IN_DM field.
	I2S_RX_TIMING_RX_SD_IN_DM_Pos = 0x0
	// Bit mask of RX_SD_IN_DM field.
	I2S_RX_TIMING_RX_SD_IN_DM_Msk = 0x3
	// Position of RX_WS_OUT_DM field.
	I2S_RX_TIMING_RX_WS_OUT_DM_Pos = 0x10
	// Bit mask of RX_WS_OUT_DM field.
	I2S_RX_TIMING_RX_WS_OUT_DM_Msk = 0x30000
	// Position of RX_BCK_OUT_DM field.
	I2S_RX_TIMING_RX_BCK_OUT_DM_Pos = 0x14
	// Bit mask of RX_BCK_OUT_DM field.
	I2S_RX_TIMING_RX_BCK_OUT_DM_Msk = 0x300000
	// Position of RX_WS_IN_DM field.
	I2S_RX_TIMING_RX_WS_IN_DM_Pos = 0x18
	// Bit mask of RX_WS_IN_DM field.
	I2S_RX_TIMING_RX_WS_IN_DM_Msk = 0x3000000
	// Position of RX_BCK_IN_DM field.
	I2S_RX_TIMING_RX_BCK_IN_DM_Pos = 0x1c
	// Bit mask of RX_BCK_IN_DM field.
	I2S_RX_TIMING_RX_BCK_IN_DM_Msk = 0x30000000

	// TX_TIMING: I2S TX timing control register
	// Position of TX_SD_OUT_DM field.
	I2S_TX_TIMING_TX_SD_OUT_DM_Pos = 0x0
	// Bit mask of TX_SD_OUT_DM field.
	I2S_TX_TIMING_TX_SD_OUT_DM_Msk = 0x3
	// Position of TX_SD1_OUT_DM field.
	I2S_TX_TIMING_TX_SD1_OUT_DM_Pos = 0x4
	// Bit mask of TX_SD1_OUT_DM field.
	I2S_TX_TIMING_TX_SD1_OUT_DM_Msk = 0x30
	// Position of TX_WS_OUT_DM field.
	I2S_TX_TIMING_TX_WS_OUT_DM_Pos = 0x10
	// Bit mask of TX_WS_OUT_DM field.
	I2S_TX_TIMING_TX_WS_OUT_DM_Msk = 0x30000
	// Position of TX_BCK_OUT_DM field.
	I2S_TX_TIMING_TX_BCK_OUT_DM_Pos = 0x14
	// Bit mask of TX_BCK_OUT_DM field.
	I2S_TX_TIMING_TX_BCK_OUT_DM_Msk = 0x300000
	// Position of TX_WS_IN_DM field.
	I2S_TX_TIMING_TX_WS_IN_DM_Pos = 0x18
	// Bit mask of TX_WS_IN_DM field.
	I2S_TX_TIMING_TX_WS_IN_DM_Msk = 0x3000000
	// Position of TX_BCK_IN_DM field.
	I2S_TX_TIMING_TX_BCK_IN_DM_Pos = 0x1c
	// Bit mask of TX_BCK_IN_DM field.
	I2S_TX_TIMING_TX_BCK_IN_DM_Msk = 0x30000000

	// LC_HUNG_CONF: I2S HUNG configure register.
	// Position of LC_FIFO_TIMEOUT field.
	I2S_LC_HUNG_CONF_LC_FIFO_TIMEOUT_Pos = 0x0
	// Bit mask of LC_FIFO_TIMEOUT field.
	I2S_LC_HUNG_CONF_LC_FIFO_TIMEOUT_Msk = 0xff
	// Position of LC_FIFO_TIMEOUT_SHIFT field.
	I2S_LC_HUNG_CONF_LC_FIFO_TIMEOUT_SHIFT_Pos = 0x8
	// Bit mask of LC_FIFO_TIMEOUT_SHIFT field.
	I2S_LC_HUNG_CONF_LC_FIFO_TIMEOUT_SHIFT_Msk = 0x700
	// Position of LC_FIFO_TIMEOUT_ENA field.
	I2S_LC_HUNG_CONF_LC_FIFO_TIMEOUT_ENA_Pos = 0xb
	// Bit mask of LC_FIFO_TIMEOUT_ENA field.
	I2S_LC_HUNG_CONF_LC_FIFO_TIMEOUT_ENA_Msk = 0x800
	// Bit LC_FIFO_TIMEOUT_ENA.
	I2S_LC_HUNG_CONF_LC_FIFO_TIMEOUT_ENA = 0x800

	// RXEOF_NUM: I2S RX data number control register.
	// Position of RX_EOF_NUM field.
	I2S_RXEOF_NUM_RX_EOF_NUM_Pos = 0x0
	// Bit mask of RX_EOF_NUM field.
	I2S_RXEOF_NUM_RX_EOF_NUM_Msk = 0xfff

	// CONF_SIGLE_DATA: I2S signal data register
	// Position of SINGLE_DATA field.
	I2S_CONF_SIGLE_DATA_SINGLE_DATA_Pos = 0x0
	// Bit mask of SINGLE_DATA field.
	I2S_CONF_SIGLE_DATA_SINGLE_DATA_Msk = 0xffffffff

	// STATE: I2S TX status register
	// Position of TX_IDLE field.
	I2S_STATE_TX_IDLE_Pos = 0x0
	// Bit mask of TX_IDLE field.
	I2S_STATE_TX_IDLE_Msk = 0x1
	// Bit TX_IDLE.
	I2S_STATE_TX_IDLE = 0x1

	// DATE: Version control register
	// Position of DATE field.
	I2S_DATE_DATE_Pos = 0x0
	// Bit mask of DATE field.
	I2S_DATE_DATE_Msk = 0xfffffff
)

// Constants for INTERRUPT_CORE0: Peripheral INTERRUPT_CORE0
const (
	// MAC_INTR_MAP: mac intr map register
	// Position of MAC_INTR_MAP field.
	INTERRUPT_CORE0_MAC_INTR_MAP_MAC_INTR_MAP_Pos = 0x0
	// Bit mask of MAC_INTR_MAP field.
	INTERRUPT_CORE0_MAC_INTR_MAP_MAC_INTR_MAP_Msk = 0x1f

	// MAC_NMI_MAP: mac nmi_intr map register
	// Position of MAC_NMI_MAP field.
	INTERRUPT_CORE0_MAC_NMI_MAP_MAC_NMI_MAP_Pos = 0x0
	// Bit mask of MAC_NMI_MAP field.
	INTERRUPT_CORE0_MAC_NMI_MAP_MAC_NMI_MAP_Msk = 0x1f

	// PWR_INTR_MAP: pwr intr map register
	// Position of PWR_INTR_MAP field.
	INTERRUPT_CORE0_PWR_INTR_MAP_PWR_INTR_MAP_Pos = 0x0
	// Bit mask of PWR_INTR_MAP field.
	INTERRUPT_CORE0_PWR_INTR_MAP_PWR_INTR_MAP_Msk = 0x1f

	// BB_INT_MAP: bb intr map register
	// Position of BB_INT_MAP field.
	INTERRUPT_CORE0_BB_INT_MAP_BB_INT_MAP_Pos = 0x0
	// Bit mask of BB_INT_MAP field.
	INTERRUPT_CORE0_BB_INT_MAP_BB_INT_MAP_Msk = 0x1f

	// BT_MAC_INT_MAP: bt intr map register
	// Position of BT_MAC_INT_MAP field.
	INTERRUPT_CORE0_BT_MAC_INT_MAP_BT_MAC_INT_MAP_Pos = 0x0
	// Bit mask of BT_MAC_INT_MAP field.
	INTERRUPT_CORE0_BT_MAC_INT_MAP_BT_MAC_INT_MAP_Msk = 0x1f

	// BT_BB_INT_MAP: bb_bt intr map register
	// Position of BT_BB_INT_MAP field.
	INTERRUPT_CORE0_BT_BB_INT_MAP_BT_BB_INT_MAP_Pos = 0x0
	// Bit mask of BT_BB_INT_MAP field.
	INTERRUPT_CORE0_BT_BB_INT_MAP_BT_BB_INT_MAP_Msk = 0x1f

	// BT_BB_NMI_MAP: bb_bt_nmi intr map register
	// Position of BT_BB_NMI_MAP field.
	INTERRUPT_CORE0_BT_BB_NMI_MAP_BT_BB_NMI_MAP_Pos = 0x0
	// Bit mask of BT_BB_NMI_MAP field.
	INTERRUPT_CORE0_BT_BB_NMI_MAP_BT_BB_NMI_MAP_Msk = 0x1f

	// RWBT_IRQ_MAP: rwbt intr map register
	// Position of RWBT_IRQ_MAP field.
	INTERRUPT_CORE0_RWBT_IRQ_MAP_RWBT_IRQ_MAP_Pos = 0x0
	// Bit mask of RWBT_IRQ_MAP field.
	INTERRUPT_CORE0_RWBT_IRQ_MAP_RWBT_IRQ_MAP_Msk = 0x1f

	// RWBLE_IRQ_MAP: rwble intr map register
	// Position of RWBLE_IRQ_MAP field.
	INTERRUPT_CORE0_RWBLE_IRQ_MAP_RWBLE_IRQ_MAP_Pos = 0x0
	// Bit mask of RWBLE_IRQ_MAP field.
	INTERRUPT_CORE0_RWBLE_IRQ_MAP_RWBLE_IRQ_MAP_Msk = 0x1f

	// RWBT_NMI_MAP: rwbt_nmi intr map register
	// Position of RWBT_NMI_MAP field.
	INTERRUPT_CORE0_RWBT_NMI_MAP_RWBT_NMI_MAP_Pos = 0x0
	// Bit mask of RWBT_NMI_MAP field.
	INTERRUPT_CORE0_RWBT_NMI_MAP_RWBT_NMI_MAP_Msk = 0x1f

	// RWBLE_NMI_MAP: rwble_nmi intr map register
	// Position of RWBLE_NMI_MAP field.
	INTERRUPT_CORE0_RWBLE_NMI_MAP_RWBLE_NMI_MAP_Pos = 0x0
	// Bit mask of RWBLE_NMI_MAP field.
	INTERRUPT_CORE0_RWBLE_NMI_MAP_RWBLE_NMI_MAP_Msk = 0x1f

	// I2C_MST_INT_MAP: i2c intr map register
	// Position of I2C_MST_INT_MAP field.
	INTERRUPT_CORE0_I2C_MST_INT_MAP_I2C_MST_INT_MAP_Pos = 0x0
	// Bit mask of I2C_MST_INT_MAP field.
	INTERRUPT_CORE0_I2C_MST_INT_MAP_I2C_MST_INT_MAP_Msk = 0x1f

	// SLC0_INTR_MAP: slc0 intr map register
	// Position of SLC0_INTR_MAP field.
	INTERRUPT_CORE0_SLC0_INTR_MAP_SLC0_INTR_MAP_Pos = 0x0
	// Bit mask of SLC0_INTR_MAP field.
	INTERRUPT_CORE0_SLC0_INTR_MAP_SLC0_INTR_MAP_Msk = 0x1f

	// SLC1_INTR_MAP: slc1 intr map register
	// Position of SLC1_INTR_MAP field.
	INTERRUPT_CORE0_SLC1_INTR_MAP_SLC1_INTR_MAP_Pos = 0x0
	// Bit mask of SLC1_INTR_MAP field.
	INTERRUPT_CORE0_SLC1_INTR_MAP_SLC1_INTR_MAP_Msk = 0x1f

	// APB_CTRL_INTR_MAP: apb_ctrl intr map register
	// Position of APB_CTRL_INTR_MAP field.
	INTERRUPT_CORE0_APB_CTRL_INTR_MAP_APB_CTRL_INTR_MAP_Pos = 0x0
	// Bit mask of APB_CTRL_INTR_MAP field.
	INTERRUPT_CORE0_APB_CTRL_INTR_MAP_APB_CTRL_INTR_MAP_Msk = 0x1f

	// UHCI0_INTR_MAP: uchi0 intr map register
	// Position of UHCI0_INTR_MAP field.
	INTERRUPT_CORE0_UHCI0_INTR_MAP_UHCI0_INTR_MAP_Pos = 0x0
	// Bit mask of UHCI0_INTR_MAP field.
	INTERRUPT_CORE0_UHCI0_INTR_MAP_UHCI0_INTR_MAP_Msk = 0x1f

	// GPIO_INTERRUPT_PRO_MAP: gpio intr map register
	// Position of GPIO_INTERRUPT_PRO_MAP field.
	INTERRUPT_CORE0_GPIO_INTERRUPT_PRO_MAP_GPIO_INTERRUPT_PRO_MAP_Pos = 0x0
	// Bit mask of GPIO_INTERRUPT_PRO_MAP field.
	INTERRUPT_CORE0_GPIO_INTERRUPT_PRO_MAP_GPIO_INTERRUPT_PRO_MAP_Msk = 0x1f

	// GPIO_INTERRUPT_PRO_NMI_MAP: gpio_pro intr map register
	// Position of GPIO_INTERRUPT_PRO_NMI_MAP field.
	INTERRUPT_CORE0_GPIO_INTERRUPT_PRO_NMI_MAP_GPIO_INTERRUPT_PRO_NMI_MAP_Pos = 0x0
	// Bit mask of GPIO_INTERRUPT_PRO_NMI_MAP field.
	INTERRUPT_CORE0_GPIO_INTERRUPT_PRO_NMI_MAP_GPIO_INTERRUPT_PRO_NMI_MAP_Msk = 0x1f

	// SPI_INTR_1_MAP: gpio_pro_nmi intr map register
	// Position of SPI_INTR_1_MAP field.
	INTERRUPT_CORE0_SPI_INTR_1_MAP_SPI_INTR_1_MAP_Pos = 0x0
	// Bit mask of SPI_INTR_1_MAP field.
	INTERRUPT_CORE0_SPI_INTR_1_MAP_SPI_INTR_1_MAP_Msk = 0x1f

	// SPI_INTR_2_MAP: spi1 intr map register
	// Position of SPI_INTR_2_MAP field.
	INTERRUPT_CORE0_SPI_INTR_2_MAP_SPI_INTR_2_MAP_Pos = 0x0
	// Bit mask of SPI_INTR_2_MAP field.
	INTERRUPT_CORE0_SPI_INTR_2_MAP_SPI_INTR_2_MAP_Msk = 0x1f

	// I2S1_INT_MAP: spi2 intr map register
	// Position of I2S1_INT_MAP field.
	INTERRUPT_CORE0_I2S1_INT_MAP_I2S1_INT_MAP_Pos = 0x0
	// Bit mask of I2S1_INT_MAP field.
	INTERRUPT_CORE0_I2S1_INT_MAP_I2S1_INT_MAP_Msk = 0x1f

	// UART_INTR_MAP: i2s1 intr map register
	// Position of UART_INTR_MAP field.
	INTERRUPT_CORE0_UART_INTR_MAP_UART_INTR_MAP_Pos = 0x0
	// Bit mask of UART_INTR_MAP field.
	INTERRUPT_CORE0_UART_INTR_MAP_UART_INTR_MAP_Msk = 0x1f

	// UART1_INTR_MAP: uart1 intr map register
	// Position of UART1_INTR_MAP field.
	INTERRUPT_CORE0_UART1_INTR_MAP_UART1_INTR_MAP_Pos = 0x0
	// Bit mask of UART1_INTR_MAP field.
	INTERRUPT_CORE0_UART1_INTR_MAP_UART1_INTR_MAP_Msk = 0x1f

	// LEDC_INT_MAP: ledc intr map register
	// Position of LEDC_INT_MAP field.
	INTERRUPT_CORE0_LEDC_INT_MAP_LEDC_INT_MAP_Pos = 0x0
	// Bit mask of LEDC_INT_MAP field.
	INTERRUPT_CORE0_LEDC_INT_MAP_LEDC_INT_MAP_Msk = 0x1f

	// EFUSE_INT_MAP: efuse intr map register
	// Position of EFUSE_INT_MAP field.
	INTERRUPT_CORE0_EFUSE_INT_MAP_EFUSE_INT_MAP_Pos = 0x0
	// Bit mask of EFUSE_INT_MAP field.
	INTERRUPT_CORE0_EFUSE_INT_MAP_EFUSE_INT_MAP_Msk = 0x1f

	// CAN_INT_MAP: can intr map register
	// Position of CAN_INT_MAP field.
	INTERRUPT_CORE0_CAN_INT_MAP_CAN_INT_MAP_Pos = 0x0
	// Bit mask of CAN_INT_MAP field.
	INTERRUPT_CORE0_CAN_INT_MAP_CAN_INT_MAP_Msk = 0x1f

	// USB_INTR_MAP: usb intr map register
	// Position of USB_INTR_MAP field.
	INTERRUPT_CORE0_USB_INTR_MAP_USB_INTR_MAP_Pos = 0x0
	// Bit mask of USB_INTR_MAP field.
	INTERRUPT_CORE0_USB_INTR_MAP_USB_INTR_MAP_Msk = 0x1f

	// RTC_CORE_INTR_MAP: rtc intr map register
	// Position of RTC_CORE_INTR_MAP field.
	INTERRUPT_CORE0_RTC_CORE_INTR_MAP_RTC_CORE_INTR_MAP_Pos = 0x0
	// Bit mask of RTC_CORE_INTR_MAP field.
	INTERRUPT_CORE0_RTC_CORE_INTR_MAP_RTC_CORE_INTR_MAP_Msk = 0x1f

	// RMT_INTR_MAP: rmt intr map register
	// Position of RMT_INTR_MAP field.
	INTERRUPT_CORE0_RMT_INTR_MAP_RMT_INTR_MAP_Pos = 0x0
	// Bit mask of RMT_INTR_MAP field.
	INTERRUPT_CORE0_RMT_INTR_MAP_RMT_INTR_MAP_Msk = 0x1f

	// I2C_EXT0_INTR_MAP: i2c intr map register
	// Position of I2C_EXT0_INTR_MAP field.
	INTERRUPT_CORE0_I2C_EXT0_INTR_MAP_I2C_EXT0_INTR_MAP_Pos = 0x0
	// Bit mask of I2C_EXT0_INTR_MAP field.
	INTERRUPT_CORE0_I2C_EXT0_INTR_MAP_I2C_EXT0_INTR_MAP_Msk = 0x1f

	// TIMER_INT1_MAP: timer1 intr map register
	// Position of TIMER_INT1_MAP field.
	INTERRUPT_CORE0_TIMER_INT1_MAP_TIMER_INT1_MAP_Pos = 0x0
	// Bit mask of TIMER_INT1_MAP field.
	INTERRUPT_CORE0_TIMER_INT1_MAP_TIMER_INT1_MAP_Msk = 0x1f

	// TIMER_INT2_MAP: timer2 intr map register
	// Position of TIMER_INT2_MAP field.
	INTERRUPT_CORE0_TIMER_INT2_MAP_TIMER_INT2_MAP_Pos = 0x0
	// Bit mask of TIMER_INT2_MAP field.
	INTERRUPT_CORE0_TIMER_INT2_MAP_TIMER_INT2_MAP_Msk = 0x1f

	// TG_T0_INT_MAP: tg to intr map register
	// Position of TG_T0_INT_MAP field.
	INTERRUPT_CORE0_TG_T0_INT_MAP_TG_T0_INT_MAP_Pos = 0x0
	// Bit mask of TG_T0_INT_MAP field.
	INTERRUPT_CORE0_TG_T0_INT_MAP_TG_T0_INT_MAP_Msk = 0x1f

	// TG_WDT_INT_MAP: tg wdt intr map register
	// Position of TG_WDT_INT_MAP field.
	INTERRUPT_CORE0_TG_WDT_INT_MAP_TG_WDT_INT_MAP_Pos = 0x0
	// Bit mask of TG_WDT_INT_MAP field.
	INTERRUPT_CORE0_TG_WDT_INT_MAP_TG_WDT_INT_MAP_Msk = 0x1f

	// TG1_T0_INT_MAP: tg1 to intr map register
	// Position of TG1_T0_INT_MAP field.
	INTERRUPT_CORE0_TG1_T0_INT_MAP_TG1_T0_INT_MAP_Pos = 0x0
	// Bit mask of TG1_T0_INT_MAP field.
	INTERRUPT_CORE0_TG1_T0_INT_MAP_TG1_T0_INT_MAP_Msk = 0x1f

	// TG1_WDT_INT_MAP: tg1 wdt intr map register
	// Position of TG1_WDT_INT_MAP field.
	INTERRUPT_CORE0_TG1_WDT_INT_MAP_TG1_WDT_INT_MAP_Pos = 0x0
	// Bit mask of TG1_WDT_INT_MAP field.
	INTERRUPT_CORE0_TG1_WDT_INT_MAP_TG1_WDT_INT_MAP_Msk = 0x1f

	// CACHE_IA_INT_MAP: cache ia intr map register
	// Position of CACHE_IA_INT_MAP field.
	INTERRUPT_CORE0_CACHE_IA_INT_MAP_CACHE_IA_INT_MAP_Pos = 0x0
	// Bit mask of CACHE_IA_INT_MAP field.
	INTERRUPT_CORE0_CACHE_IA_INT_MAP_CACHE_IA_INT_MAP_Msk = 0x1f

	// SYSTIMER_TARGET0_INT_MAP: systimer intr map register
	// Position of SYSTIMER_TARGET0_INT_MAP field.
	INTERRUPT_CORE0_SYSTIMER_TARGET0_INT_MAP_SYSTIMER_TARGET0_INT_MAP_Pos = 0x0
	// Bit mask of SYSTIMER_TARGET0_INT_MAP field.
	INTERRUPT_CORE0_SYSTIMER_TARGET0_INT_MAP_SYSTIMER_TARGET0_INT_MAP_Msk = 0x1f

	// SYSTIMER_TARGET1_INT_MAP: systimer target1 intr map register
	// Position of SYSTIMER_TARGET1_INT_MAP field.
	INTERRUPT_CORE0_SYSTIMER_TARGET1_INT_MAP_SYSTIMER_TARGET1_INT_MAP_Pos = 0x0
	// Bit mask of SYSTIMER_TARGET1_INT_MAP field.
	INTERRUPT_CORE0_SYSTIMER_TARGET1_INT_MAP_SYSTIMER_TARGET1_INT_MAP_Msk = 0x1f

	// SYSTIMER_TARGET2_INT_MAP: systimer target2 intr map register
	// Position of SYSTIMER_TARGET2_INT_MAP field.
	INTERRUPT_CORE0_SYSTIMER_TARGET2_INT_MAP_SYSTIMER_TARGET2_INT_MAP_Pos = 0x0
	// Bit mask of SYSTIMER_TARGET2_INT_MAP field.
	INTERRUPT_CORE0_SYSTIMER_TARGET2_INT_MAP_SYSTIMER_TARGET2_INT_MAP_Msk = 0x1f

	// SPI_MEM_REJECT_INTR_MAP: spi mem reject intr map register
	// Position of SPI_MEM_REJECT_INTR_MAP field.
	INTERRUPT_CORE0_SPI_MEM_REJECT_INTR_MAP_SPI_MEM_REJECT_INTR_MAP_Pos = 0x0
	// Bit mask of SPI_MEM_REJECT_INTR_MAP field.
	INTERRUPT_CORE0_SPI_MEM_REJECT_INTR_MAP_SPI_MEM_REJECT_INTR_MAP_Msk = 0x1f

	// ICACHE_PRELOAD_INT_MAP: icache perload intr map register
	// Position of ICACHE_PRELOAD_INT_MAP field.
	INTERRUPT_CORE0_ICACHE_PRELOAD_INT_MAP_ICACHE_PRELOAD_INT_MAP_Pos = 0x0
	// Bit mask of ICACHE_PRELOAD_INT_MAP field.
	INTERRUPT_CORE0_ICACHE_PRELOAD_INT_MAP_ICACHE_PRELOAD_INT_MAP_Msk = 0x1f

	// ICACHE_SYNC_INT_MAP: icache sync intr map register
	// Position of ICACHE_SYNC_INT_MAP field.
	INTERRUPT_CORE0_ICACHE_SYNC_INT_MAP_ICACHE_SYNC_INT_MAP_Pos = 0x0
	// Bit mask of ICACHE_SYNC_INT_MAP field.
	INTERRUPT_CORE0_ICACHE_SYNC_INT_MAP_ICACHE_SYNC_INT_MAP_Msk = 0x1f

	// APB_ADC_INT_MAP: adc intr map register
	// Position of APB_ADC_INT_MAP field.
	INTERRUPT_CORE0_APB_ADC_INT_MAP_APB_ADC_INT_MAP_Pos = 0x0
	// Bit mask of APB_ADC_INT_MAP field.
	INTERRUPT_CORE0_APB_ADC_INT_MAP_APB_ADC_INT_MAP_Msk = 0x1f

	// DMA_CH0_INT_MAP: dma ch0 intr map register
	// Position of DMA_CH0_INT_MAP field.
	INTERRUPT_CORE0_DMA_CH0_INT_MAP_DMA_CH0_INT_MAP_Pos = 0x0
	// Bit mask of DMA_CH0_INT_MAP field.
	INTERRUPT_CORE0_DMA_CH0_INT_MAP_DMA_CH0_INT_MAP_Msk = 0x1f

	// DMA_CH1_INT_MAP: dma ch1 intr map register
	// Position of DMA_CH1_INT_MAP field.
	INTERRUPT_CORE0_DMA_CH1_INT_MAP_DMA_CH1_INT_MAP_Pos = 0x0
	// Bit mask of DMA_CH1_INT_MAP field.
	INTERRUPT_CORE0_DMA_CH1_INT_MAP_DMA_CH1_INT_MAP_Msk = 0x1f

	// DMA_CH2_INT_MAP: dma ch2 intr map register
	// Position of DMA_CH2_INT_MAP field.
	INTERRUPT_CORE0_DMA_CH2_INT_MAP_DMA_CH2_INT_MAP_Pos = 0x0
	// Bit mask of DMA_CH2_INT_MAP field.
	INTERRUPT_CORE0_DMA_CH2_INT_MAP_DMA_CH2_INT_MAP_Msk = 0x1f

	// RSA_INT_MAP: rsa intr map register
	// Position of RSA_INT_MAP field.
	INTERRUPT_CORE0_RSA_INT_MAP_RSA_INT_MAP_Pos = 0x0
	// Bit mask of RSA_INT_MAP field.
	INTERRUPT_CORE0_RSA_INT_MAP_RSA_INT_MAP_Msk = 0x1f

	// AES_INT_MAP: aes intr map register
	// Position of AES_INT_MAP field.
	INTERRUPT_CORE0_AES_INT_MAP_AES_INT_MAP_Pos = 0x0
	// Bit mask of AES_INT_MAP field.
	INTERRUPT_CORE0_AES_INT_MAP_AES_INT_MAP_Msk = 0x1f

	// SHA_INT_MAP: sha intr map register
	// Position of SHA_INT_MAP field.
	INTERRUPT_CORE0_SHA_INT_MAP_SHA_INT_MAP_Pos = 0x0
	// Bit mask of SHA_INT_MAP field.
	INTERRUPT_CORE0_SHA_INT_MAP_SHA_INT_MAP_Msk = 0x1f

	// CPU_INTR_FROM_CPU_0_MAP: cpu from cpu 0 intr map register
	// Position of CPU_INTR_FROM_CPU_0_MAP field.
	INTERRUPT_CORE0_CPU_INTR_FROM_CPU_0_MAP_CPU_INTR_FROM_CPU_0_MAP_Pos = 0x0
	// Bit mask of CPU_INTR_FROM_CPU_0_MAP field.
	INTERRUPT_CORE0_CPU_INTR_FROM_CPU_0_MAP_CPU_INTR_FROM_CPU_0_MAP_Msk = 0x1f

	// CPU_INTR_FROM_CPU_1_MAP: cpu from cpu 0 intr map register
	// Position of CPU_INTR_FROM_CPU_1_MAP field.
	INTERRUPT_CORE0_CPU_INTR_FROM_CPU_1_MAP_CPU_INTR_FROM_CPU_1_MAP_Pos = 0x0
	// Bit mask of CPU_INTR_FROM_CPU_1_MAP field.
	INTERRUPT_CORE0_CPU_INTR_FROM_CPU_1_MAP_CPU_INTR_FROM_CPU_1_MAP_Msk = 0x1f

	// CPU_INTR_FROM_CPU_2_MAP: cpu from cpu 1 intr map register
	// Position of CPU_INTR_FROM_CPU_2_MAP field.
	INTERRUPT_CORE0_CPU_INTR_FROM_CPU_2_MAP_CPU_INTR_FROM_CPU_2_MAP_Pos = 0x0
	// Bit mask of CPU_INTR_FROM_CPU_2_MAP field.
	INTERRUPT_CORE0_CPU_INTR_FROM_CPU_2_MAP_CPU_INTR_FROM_CPU_2_MAP_Msk = 0x1f

	// CPU_INTR_FROM_CPU_3_MAP: cpu from cpu 3 intr map register
	// Position of CPU_INTR_FROM_CPU_3_MAP field.
	INTERRUPT_CORE0_CPU_INTR_FROM_CPU_3_MAP_CPU_INTR_FROM_CPU_3_MAP_Pos = 0x0
	// Bit mask of CPU_INTR_FROM_CPU_3_MAP field.
	INTERRUPT_CORE0_CPU_INTR_FROM_CPU_3_MAP_CPU_INTR_FROM_CPU_3_MAP_Msk = 0x1f

	// ASSIST_DEBUG_INTR_MAP: assist debug intr map register
	// Position of ASSIST_DEBUG_INTR_MAP field.
	INTERRUPT_CORE0_ASSIST_DEBUG_INTR_MAP_ASSIST_DEBUG_INTR_MAP_Pos = 0x0
	// Bit mask of ASSIST_DEBUG_INTR_MAP field.
	INTERRUPT_CORE0_ASSIST_DEBUG_INTR_MAP_ASSIST_DEBUG_INTR_MAP_Msk = 0x1f

	// DMA_APBPERI_PMS_MONITOR_VIOLATE_INTR_MAP: dma pms violatile intr map register
	// Position of DMA_APBPERI_PMS_MONITOR_VIOLATE_INTR_MAP field.
	INTERRUPT_CORE0_DMA_APBPERI_PMS_MONITOR_VIOLATE_INTR_MAP_DMA_APBPERI_PMS_MONITOR_VIOLATE_INTR_MAP_Pos = 0x0
	// Bit mask of DMA_APBPERI_PMS_MONITOR_VIOLATE_INTR_MAP field.
	INTERRUPT_CORE0_DMA_APBPERI_PMS_MONITOR_VIOLATE_INTR_MAP_DMA_APBPERI_PMS_MONITOR_VIOLATE_INTR_MAP_Msk = 0x1f

	// CORE_0_IRAM0_PMS_MONITOR_VIOLATE_INTR_MAP: iram0 pms violatile intr map register
	// Position of CORE_0_IRAM0_PMS_MONITOR_VIOLATE_INTR_MAP field.
	INTERRUPT_CORE0_CORE_0_IRAM0_PMS_MONITOR_VIOLATE_INTR_MAP_CORE_0_IRAM0_PMS_MONITOR_VIOLATE_INTR_MAP_Pos = 0x0
	// Bit mask of CORE_0_IRAM0_PMS_MONITOR_VIOLATE_INTR_MAP field.
	INTERRUPT_CORE0_CORE_0_IRAM0_PMS_MONITOR_VIOLATE_INTR_MAP_CORE_0_IRAM0_PMS_MONITOR_VIOLATE_INTR_MAP_Msk = 0x1f

	// CORE_0_DRAM0_PMS_MONITOR_VIOLATE_INTR_MAP: mac intr map register
	// Position of CORE_0_DRAM0_PMS_MONITOR_VIOLATE_INTR_MAP field.
	INTERRUPT_CORE0_CORE_0_DRAM0_PMS_MONITOR_VIOLATE_INTR_MAP_CORE_0_DRAM0_PMS_MONITOR_VIOLATE_INTR_MAP_Pos = 0x0
	// Bit mask of CORE_0_DRAM0_PMS_MONITOR_VIOLATE_INTR_MAP field.
	INTERRUPT_CORE0_CORE_0_DRAM0_PMS_MONITOR_VIOLATE_INTR_MAP_CORE_0_DRAM0_PMS_MONITOR_VIOLATE_INTR_MAP_Msk = 0x1f

	// CORE_0_PIF_PMS_MONITOR_VIOLATE_INTR_MAP: mac intr map register
	// Position of CORE_0_PIF_PMS_MONITOR_VIOLATE_INTR_MAP field.
	INTERRUPT_CORE0_CORE_0_PIF_PMS_MONITOR_VIOLATE_INTR_MAP_CORE_0_PIF_PMS_MONITOR_VIOLATE_INTR_MAP_Pos = 0x0
	// Bit mask of CORE_0_PIF_PMS_MONITOR_VIOLATE_INTR_MAP field.
	INTERRUPT_CORE0_CORE_0_PIF_PMS_MONITOR_VIOLATE_INTR_MAP_CORE_0_PIF_PMS_MONITOR_VIOLATE_INTR_MAP_Msk = 0x1f

	// CORE_0_PIF_PMS_MONITOR_VIOLATE_SIZE_INTR_MAP: mac intr map register
	// Position of CORE_0_PIF_PMS_MONITOR_VIOLATE_SIZE_INTR_MAP field.
	INTERRUPT_CORE0_CORE_0_PIF_PMS_MONITOR_VIOLATE_SIZE_INTR_MAP_CORE_0_PIF_PMS_MONITOR_VIOLATE_SIZE_INTR_MAP_Pos = 0x0
	// Bit mask of CORE_0_PIF_PMS_MONITOR_VIOLATE_SIZE_INTR_MAP field.
	INTERRUPT_CORE0_CORE_0_PIF_PMS_MONITOR_VIOLATE_SIZE_INTR_MAP_CORE_0_PIF_PMS_MONITOR_VIOLATE_SIZE_INTR_MAP_Msk = 0x1f

	// BACKUP_PMS_VIOLATE_INTR_MAP: mac intr map register
	// Position of BACKUP_PMS_VIOLATE_INTR_MAP field.
	INTERRUPT_CORE0_BACKUP_PMS_VIOLATE_INTR_MAP_BACKUP_PMS_VIOLATE_INTR_MAP_Pos = 0x0
	// Bit mask of BACKUP_PMS_VIOLATE_INTR_MAP field.
	INTERRUPT_CORE0_BACKUP_PMS_VIOLATE_INTR_MAP_BACKUP_PMS_VIOLATE_INTR_MAP_Msk = 0x1f

	// CACHE_CORE0_ACS_INT_MAP: mac intr map register
	// Position of CACHE_CORE0_ACS_INT_MAP field.
	INTERRUPT_CORE0_CACHE_CORE0_ACS_INT_MAP_CACHE_CORE0_ACS_INT_MAP_Pos = 0x0
	// Bit mask of CACHE_CORE0_ACS_INT_MAP field.
	INTERRUPT_CORE0_CACHE_CORE0_ACS_INT_MAP_CACHE_CORE0_ACS_INT_MAP_Msk = 0x1f

	// INTR_STATUS_REG_0: mac intr map register
	// Position of INTR_STATUS_0 field.
	INTERRUPT_CORE0_INTR_STATUS_REG_0_INTR_STATUS_0_Pos = 0x0
	// Bit mask of INTR_STATUS_0 field.
	INTERRUPT_CORE0_INTR_STATUS_REG_0_INTR_STATUS_0_Msk = 0xffffffff

	// INTR_STATUS_REG_1: mac intr map register
	// Position of INTR_STATUS_1 field.
	INTERRUPT_CORE0_INTR_STATUS_REG_1_INTR_STATUS_1_Pos = 0x0
	// Bit mask of INTR_STATUS_1 field.
	INTERRUPT_CORE0_INTR_STATUS_REG_1_INTR_STATUS_1_Msk = 0xffffffff

	// CLOCK_GATE: mac intr map register
	// Position of REG_CLK_EN field.
	INTERRUPT_CORE0_CLOCK_GATE_REG_CLK_EN_Pos = 0x0
	// Bit mask of REG_CLK_EN field.
	INTERRUPT_CORE0_CLOCK_GATE_REG_CLK_EN_Msk = 0x1
	// Bit REG_CLK_EN.
	INTERRUPT_CORE0_CLOCK_GATE_REG_CLK_EN = 0x1

	// CPU_INT_ENABLE: mac intr map register
	// Position of CPU_INT_ENABLE field.
	INTERRUPT_CORE0_CPU_INT_ENABLE_CPU_INT_ENABLE_Pos = 0x0
	// Bit mask of CPU_INT_ENABLE field.
	INTERRUPT_CORE0_CPU_INT_ENABLE_CPU_INT_ENABLE_Msk = 0xffffffff

	// CPU_INT_TYPE: mac intr map register
	// Position of CPU_INT_TYPE field.
	INTERRUPT_CORE0_CPU_INT_TYPE_CPU_INT_TYPE_Pos = 0x0
	// Bit mask of CPU_INT_TYPE field.
	INTERRUPT_CORE0_CPU_INT_TYPE_CPU_INT_TYPE_Msk = 0xffffffff

	// CPU_INT_CLEAR: mac intr map register
	// Position of CPU_INT_CLEAR field.
	INTERRUPT_CORE0_CPU_INT_CLEAR_CPU_INT_CLEAR_Pos = 0x0
	// Bit mask of CPU_INT_CLEAR field.
	INTERRUPT_CORE0_CPU_INT_CLEAR_CPU_INT_CLEAR_Msk = 0xffffffff

	// CPU_INT_EIP_STATUS: mac intr map register
	// Position of CPU_INT_EIP_STATUS field.
	INTERRUPT_CORE0_CPU_INT_EIP_STATUS_CPU_INT_EIP_STATUS_Pos = 0x0
	// Bit mask of CPU_INT_EIP_STATUS field.
	INTERRUPT_CORE0_CPU_INT_EIP_STATUS_CPU_INT_EIP_STATUS_Msk = 0xffffffff

	// CPU_INT_PRI_0: mac intr map register
	// Position of CPU_PRI_0_MAP field.
	INTERRUPT_CORE0_CPU_INT_PRI_0_CPU_PRI_0_MAP_Pos = 0x0
	// Bit mask of CPU_PRI_0_MAP field.
	INTERRUPT_CORE0_CPU_INT_PRI_0_CPU_PRI_0_MAP_Msk = 0xf

	// CPU_INT_PRI_1: mac intr map register
	// Position of CPU_PRI_1_MAP field.
	INTERRUPT_CORE0_CPU_INT_PRI_1_CPU_PRI_1_MAP_Pos = 0x0
	// Bit mask of CPU_PRI_1_MAP field.
	INTERRUPT_CORE0_CPU_INT_PRI_1_CPU_PRI_1_MAP_Msk = 0xf

	// CPU_INT_PRI_2: mac intr map register
	// Position of CPU_PRI_2_MAP field.
	INTERRUPT_CORE0_CPU_INT_PRI_2_CPU_PRI_2_MAP_Pos = 0x0
	// Bit mask of CPU_PRI_2_MAP field.
	INTERRUPT_CORE0_CPU_INT_PRI_2_CPU_PRI_2_MAP_Msk = 0xf

	// CPU_INT_PRI_3: mac intr map register
	// Position of CPU_PRI_3_MAP field.
	INTERRUPT_CORE0_CPU_INT_PRI_3_CPU_PRI_3_MAP_Pos = 0x0
	// Bit mask of CPU_PRI_3_MAP field.
	INTERRUPT_CORE0_CPU_INT_PRI_3_CPU_PRI_3_MAP_Msk = 0xf

	// CPU_INT_PRI_4: mac intr map register
	// Position of CPU_PRI_4_MAP field.
	INTERRUPT_CORE0_CPU_INT_PRI_4_CPU_PRI_4_MAP_Pos = 0x0
	// Bit mask of CPU_PRI_4_MAP field.
	INTERRUPT_CORE0_CPU_INT_PRI_4_CPU_PRI_4_MAP_Msk = 0xf

	// CPU_INT_PRI_5: mac intr map register
	// Position of CPU_PRI_5_MAP field.
	INTERRUPT_CORE0_CPU_INT_PRI_5_CPU_PRI_5_MAP_Pos = 0x0
	// Bit mask of CPU_PRI_5_MAP field.
	INTERRUPT_CORE0_CPU_INT_PRI_5_CPU_PRI_5_MAP_Msk = 0xf

	// CPU_INT_PRI_6: mac intr map register
	// Position of CPU_PRI_6_MAP field.
	INTERRUPT_CORE0_CPU_INT_PRI_6_CPU_PRI_6_MAP_Pos = 0x0
	// Bit mask of CPU_PRI_6_MAP field.
	INTERRUPT_CORE0_CPU_INT_PRI_6_CPU_PRI_6_MAP_Msk = 0xf

	// CPU_INT_PRI_7: mac intr map register
	// Position of CPU_PRI_7_MAP field.
	INTERRUPT_CORE0_CPU_INT_PRI_7_CPU_PRI_7_MAP_Pos = 0x0
	// Bit mask of CPU_PRI_7_MAP field.
	INTERRUPT_CORE0_CPU_INT_PRI_7_CPU_PRI_7_MAP_Msk = 0xf

	// CPU_INT_PRI_8: mac intr map register
	// Position of CPU_PRI_8_MAP field.
	INTERRUPT_CORE0_CPU_INT_PRI_8_CPU_PRI_8_MAP_Pos = 0x0
	// Bit mask of CPU_PRI_8_MAP field.
	INTERRUPT_CORE0_CPU_INT_PRI_8_CPU_PRI_8_MAP_Msk = 0xf

	// CPU_INT_PRI_9: mac intr map register
	// Position of CPU_PRI_9_MAP field.
	INTERRUPT_CORE0_CPU_INT_PRI_9_CPU_PRI_9_MAP_Pos = 0x0
	// Bit mask of CPU_PRI_9_MAP field.
	INTERRUPT_CORE0_CPU_INT_PRI_9_CPU_PRI_9_MAP_Msk = 0xf

	// CPU_INT_PRI_10: mac intr map register
	// Position of CPU_PRI_10_MAP field.
	INTERRUPT_CORE0_CPU_INT_PRI_10_CPU_PRI_10_MAP_Pos = 0x0
	// Bit mask of CPU_PRI_10_MAP field.
	INTERRUPT_CORE0_CPU_INT_PRI_10_CPU_PRI_10_MAP_Msk = 0xf

	// CPU_INT_PRI_11: mac intr map register
	// Position of CPU_PRI_11_MAP field.
	INTERRUPT_CORE0_CPU_INT_PRI_11_CPU_PRI_11_MAP_Pos = 0x0
	// Bit mask of CPU_PRI_11_MAP field.
	INTERRUPT_CORE0_CPU_INT_PRI_11_CPU_PRI_11_MAP_Msk = 0xf

	// CPU_INT_PRI_12: mac intr map register
	// Position of CPU_PRI_12_MAP field.
	INTERRUPT_CORE0_CPU_INT_PRI_12_CPU_PRI_12_MAP_Pos = 0x0
	// Bit mask of CPU_PRI_12_MAP field.
	INTERRUPT_CORE0_CPU_INT_PRI_12_CPU_PRI_12_MAP_Msk = 0xf

	// CPU_INT_PRI_13: mac intr map register
	// Position of CPU_PRI_13_MAP field.
	INTERRUPT_CORE0_CPU_INT_PRI_13_CPU_PRI_13_MAP_Pos = 0x0
	// Bit mask of CPU_PRI_13_MAP field.
	INTERRUPT_CORE0_CPU_INT_PRI_13_CPU_PRI_13_MAP_Msk = 0xf

	// CPU_INT_PRI_14: mac intr map register
	// Position of CPU_PRI_14_MAP field.
	INTERRUPT_CORE0_CPU_INT_PRI_14_CPU_PRI_14_MAP_Pos = 0x0
	// Bit mask of CPU_PRI_14_MAP field.
	INTERRUPT_CORE0_CPU_INT_PRI_14_CPU_PRI_14_MAP_Msk = 0xf

	// CPU_INT_PRI_15: mac intr map register
	// Position of CPU_PRI_15_MAP field.
	INTERRUPT_CORE0_CPU_INT_PRI_15_CPU_PRI_15_MAP_Pos = 0x0
	// Bit mask of CPU_PRI_15_MAP field.
	INTERRUPT_CORE0_CPU_INT_PRI_15_CPU_PRI_15_MAP_Msk = 0xf

	// CPU_INT_PRI_16: mac intr map register
	// Position of CPU_PRI_16_MAP field.
	INTERRUPT_CORE0_CPU_INT_PRI_16_CPU_PRI_16_MAP_Pos = 0x0
	// Bit mask of CPU_PRI_16_MAP field.
	INTERRUPT_CORE0_CPU_INT_PRI_16_CPU_PRI_16_MAP_Msk = 0xf

	// CPU_INT_PRI_17: mac intr map register
	// Position of CPU_PRI_17_MAP field.
	INTERRUPT_CORE0_CPU_INT_PRI_17_CPU_PRI_17_MAP_Pos = 0x0
	// Bit mask of CPU_PRI_17_MAP field.
	INTERRUPT_CORE0_CPU_INT_PRI_17_CPU_PRI_17_MAP_Msk = 0xf

	// CPU_INT_PRI_18: mac intr map register
	// Position of CPU_PRI_18_MAP field.
	INTERRUPT_CORE0_CPU_INT_PRI_18_CPU_PRI_18_MAP_Pos = 0x0
	// Bit mask of CPU_PRI_18_MAP field.
	INTERRUPT_CORE0_CPU_INT_PRI_18_CPU_PRI_18_MAP_Msk = 0xf

	// CPU_INT_PRI_19: mac intr map register
	// Position of CPU_PRI_19_MAP field.
	INTERRUPT_CORE0_CPU_INT_PRI_19_CPU_PRI_19_MAP_Pos = 0x0
	// Bit mask of CPU_PRI_19_MAP field.
	INTERRUPT_CORE0_CPU_INT_PRI_19_CPU_PRI_19_MAP_Msk = 0xf

	// CPU_INT_PRI_20: mac intr map register
	// Position of CPU_PRI_20_MAP field.
	INTERRUPT_CORE0_CPU_INT_PRI_20_CPU_PRI_20_MAP_Pos = 0x0
	// Bit mask of CPU_PRI_20_MAP field.
	INTERRUPT_CORE0_CPU_INT_PRI_20_CPU_PRI_20_MAP_Msk = 0xf

	// CPU_INT_PRI_21: mac intr map register
	// Position of CPU_PRI_21_MAP field.
	INTERRUPT_CORE0_CPU_INT_PRI_21_CPU_PRI_21_MAP_Pos = 0x0
	// Bit mask of CPU_PRI_21_MAP field.
	INTERRUPT_CORE0_CPU_INT_PRI_21_CPU_PRI_21_MAP_Msk = 0xf

	// CPU_INT_PRI_22: mac intr map register
	// Position of CPU_PRI_22_MAP field.
	INTERRUPT_CORE0_CPU_INT_PRI_22_CPU_PRI_22_MAP_Pos = 0x0
	// Bit mask of CPU_PRI_22_MAP field.
	INTERRUPT_CORE0_CPU_INT_PRI_22_CPU_PRI_22_MAP_Msk = 0xf

	// CPU_INT_PRI_23: mac intr map register
	// Position of CPU_PRI_23_MAP field.
	INTERRUPT_CORE0_CPU_INT_PRI_23_CPU_PRI_23_MAP_Pos = 0x0
	// Bit mask of CPU_PRI_23_MAP field.
	INTERRUPT_CORE0_CPU_INT_PRI_23_CPU_PRI_23_MAP_Msk = 0xf

	// CPU_INT_PRI_24: mac intr map register
	// Position of CPU_PRI_24_MAP field.
	INTERRUPT_CORE0_CPU_INT_PRI_24_CPU_PRI_24_MAP_Pos = 0x0
	// Bit mask of CPU_PRI_24_MAP field.
	INTERRUPT_CORE0_CPU_INT_PRI_24_CPU_PRI_24_MAP_Msk = 0xf

	// CPU_INT_PRI_25: mac intr map register
	// Position of CPU_PRI_25_MAP field.
	INTERRUPT_CORE0_CPU_INT_PRI_25_CPU_PRI_25_MAP_Pos = 0x0
	// Bit mask of CPU_PRI_25_MAP field.
	INTERRUPT_CORE0_CPU_INT_PRI_25_CPU_PRI_25_MAP_Msk = 0xf

	// CPU_INT_PRI_26: mac intr map register
	// Position of CPU_PRI_26_MAP field.
	INTERRUPT_CORE0_CPU_INT_PRI_26_CPU_PRI_26_MAP_Pos = 0x0
	// Bit mask of CPU_PRI_26_MAP field.
	INTERRUPT_CORE0_CPU_INT_PRI_26_CPU_PRI_26_MAP_Msk = 0xf

	// CPU_INT_PRI_27: mac intr map register
	// Position of CPU_PRI_27_MAP field.
	INTERRUPT_CORE0_CPU_INT_PRI_27_CPU_PRI_27_MAP_Pos = 0x0
	// Bit mask of CPU_PRI_27_MAP field.
	INTERRUPT_CORE0_CPU_INT_PRI_27_CPU_PRI_27_MAP_Msk = 0xf

	// CPU_INT_PRI_28: mac intr map register
	// Position of CPU_PRI_28_MAP field.
	INTERRUPT_CORE0_CPU_INT_PRI_28_CPU_PRI_28_MAP_Pos = 0x0
	// Bit mask of CPU_PRI_28_MAP field.
	INTERRUPT_CORE0_CPU_INT_PRI_28_CPU_PRI_28_MAP_Msk = 0xf

	// CPU_INT_PRI_29: mac intr map register
	// Position of CPU_PRI_29_MAP field.
	INTERRUPT_CORE0_CPU_INT_PRI_29_CPU_PRI_29_MAP_Pos = 0x0
	// Bit mask of CPU_PRI_29_MAP field.
	INTERRUPT_CORE0_CPU_INT_PRI_29_CPU_PRI_29_MAP_Msk = 0xf

	// CPU_INT_PRI_30: mac intr map register
	// Position of CPU_PRI_30_MAP field.
	INTERRUPT_CORE0_CPU_INT_PRI_30_CPU_PRI_30_MAP_Pos = 0x0
	// Bit mask of CPU_PRI_30_MAP field.
	INTERRUPT_CORE0_CPU_INT_PRI_30_CPU_PRI_30_MAP_Msk = 0xf

	// CPU_INT_PRI_31: mac intr map register
	// Position of CPU_PRI_31_MAP field.
	INTERRUPT_CORE0_CPU_INT_PRI_31_CPU_PRI_31_MAP_Pos = 0x0
	// Bit mask of CPU_PRI_31_MAP field.
	INTERRUPT_CORE0_CPU_INT_PRI_31_CPU_PRI_31_MAP_Msk = 0xf

	// CPU_INT_THRESH: mac intr map register
	// Position of CPU_INT_THRESH field.
	INTERRUPT_CORE0_CPU_INT_THRESH_CPU_INT_THRESH_Pos = 0x0
	// Bit mask of CPU_INT_THRESH field.
	INTERRUPT_CORE0_CPU_INT_THRESH_CPU_INT_THRESH_Msk = 0xf

	// INTERRUPT_REG_DATE: mac intr map register
	// Position of INTERRUPT_REG_DATE field.
	INTERRUPT_CORE0_INTERRUPT_REG_DATE_INTERRUPT_REG_DATE_Pos = 0x0
	// Bit mask of INTERRUPT_REG_DATE field.
	INTERRUPT_CORE0_INTERRUPT_REG_DATE_INTERRUPT_REG_DATE_Msk = 0xfffffff
)

// Constants for IO_MUX: Peripheral IO_MUX
const (
	// PIN_CTRL: Clock Output Configuration Register
	// Position of CLK_OUT1 field.
	IO_MUX_PIN_CTRL_CLK_OUT1_Pos = 0x0
	// Bit mask of CLK_OUT1 field.
	IO_MUX_PIN_CTRL_CLK_OUT1_Msk = 0xf
	// Position of CLK_OUT2 field.
	IO_MUX_PIN_CTRL_CLK_OUT2_Pos = 0x4
	// Bit mask of CLK_OUT2 field.
	IO_MUX_PIN_CTRL_CLK_OUT2_Msk = 0xf0
	// Position of CLK_OUT3 field.
	IO_MUX_PIN_CTRL_CLK_OUT3_Pos = 0x8
	// Bit mask of CLK_OUT3 field.
	IO_MUX_PIN_CTRL_CLK_OUT3_Msk = 0xf00

	// GPIO0: IO MUX Configure Register for pad XTAL_32K_P
	// Position of MCU_OE field.
	IO_MUX_GPIO_MCU_OE_Pos = 0x0
	// Bit mask of MCU_OE field.
	IO_MUX_GPIO_MCU_OE_Msk = 0x1
	// Bit MCU_OE.
	IO_MUX_GPIO_MCU_OE = 0x1
	// Position of SLP_SEL field.
	IO_MUX_GPIO_SLP_SEL_Pos = 0x1
	// Bit mask of SLP_SEL field.
	IO_MUX_GPIO_SLP_SEL_Msk = 0x2
	// Bit SLP_SEL.
	IO_MUX_GPIO_SLP_SEL = 0x2
	// Position of MCU_WPD field.
	IO_MUX_GPIO_MCU_WPD_Pos = 0x2
	// Bit mask of MCU_WPD field.
	IO_MUX_GPIO_MCU_WPD_Msk = 0x4
	// Bit MCU_WPD.
	IO_MUX_GPIO_MCU_WPD = 0x4
	// Position of MCU_WPU field.
	IO_MUX_GPIO_MCU_WPU_Pos = 0x3
	// Bit mask of MCU_WPU field.
	IO_MUX_GPIO_MCU_WPU_Msk = 0x8
	// Bit MCU_WPU.
	IO_MUX_GPIO_MCU_WPU = 0x8
	// Position of MCU_IE field.
	IO_MUX_GPIO_MCU_IE_Pos = 0x4
	// Bit mask of MCU_IE field.
	IO_MUX_GPIO_MCU_IE_Msk = 0x10
	// Bit MCU_IE.
	IO_MUX_GPIO_MCU_IE = 0x10
	// Position of FUN_WPD field.
	IO_MUX_GPIO_FUN_WPD_Pos = 0x7
	// Bit mask of FUN_WPD field.
	IO_MUX_GPIO_FUN_WPD_Msk = 0x80
	// Bit FUN_WPD.
	IO_MUX_GPIO_FUN_WPD = 0x80
	// Position of FUN_WPU field.
	IO_MUX_GPIO_FUN_WPU_Pos = 0x8
	// Bit mask of FUN_WPU field.
	IO_MUX_GPIO_FUN_WPU_Msk = 0x100
	// Bit FUN_WPU.
	IO_MUX_GPIO_FUN_WPU = 0x100
	// Position of FUN_IE field.
	IO_MUX_GPIO_FUN_IE_Pos = 0x9
	// Bit mask of FUN_IE field.
	IO_MUX_GPIO_FUN_IE_Msk = 0x200
	// Bit FUN_IE.
	IO_MUX_GPIO_FUN_IE = 0x200
	// Position of FUN_DRV field.
	IO_MUX_GPIO_FUN_DRV_Pos = 0xa
	// Bit mask of FUN_DRV field.
	IO_MUX_GPIO_FUN_DRV_Msk = 0xc00
	// Position of MCU_SEL field.
	IO_MUX_GPIO_MCU_SEL_Pos = 0xc
	// Bit mask of MCU_SEL field.
	IO_MUX_GPIO_MCU_SEL_Msk = 0x7000
	// Position of FILTER_EN field.
	IO_MUX_GPIO_FILTER_EN_Pos = 0xf
	// Bit mask of FILTER_EN field.
	IO_MUX_GPIO_FILTER_EN_Msk = 0x8000
	// Bit FILTER_EN.
	IO_MUX_GPIO_FILTER_EN = 0x8000

	// DATE: IO MUX Version Control Register
	// Position of REG_DATE field.
	IO_MUX_DATE_REG_DATE_Pos = 0x0
	// Bit mask of REG_DATE field.
	IO_MUX_DATE_REG_DATE_Msk = 0xfffffff
)

// Constants for LEDC: Peripheral LEDC
const (
	// LSCH0_CONF0: LEDC_LSCH0_CONF0.
	// Position of TIMER_SEL_LSCH0 field.
	LEDC_LSCH0_CONF0_TIMER_SEL_LSCH0_Pos = 0x0
	// Bit mask of TIMER_SEL_LSCH0 field.
	LEDC_LSCH0_CONF0_TIMER_SEL_LSCH0_Msk = 0x3
	// Position of SIG_OUT_EN_LSCH0 field.
	LEDC_LSCH0_CONF0_SIG_OUT_EN_LSCH0_Pos = 0x2
	// Bit mask of SIG_OUT_EN_LSCH0 field.
	LEDC_LSCH0_CONF0_SIG_OUT_EN_LSCH0_Msk = 0x4
	// Bit SIG_OUT_EN_LSCH0.
	LEDC_LSCH0_CONF0_SIG_OUT_EN_LSCH0 = 0x4
	// Position of IDLE_LV_LSCH0 field.
	LEDC_LSCH0_CONF0_IDLE_LV_LSCH0_Pos = 0x3
	// Bit mask of IDLE_LV_LSCH0 field.
	LEDC_LSCH0_CONF0_IDLE_LV_LSCH0_Msk = 0x8
	// Bit IDLE_LV_LSCH0.
	LEDC_LSCH0_CONF0_IDLE_LV_LSCH0 = 0x8
	// Position of PARA_UP_LSCH0 field.
	LEDC_LSCH0_CONF0_PARA_UP_LSCH0_Pos = 0x4
	// Bit mask of PARA_UP_LSCH0 field.
	LEDC_LSCH0_CONF0_PARA_UP_LSCH0_Msk = 0x10
	// Bit PARA_UP_LSCH0.
	LEDC_LSCH0_CONF0_PARA_UP_LSCH0 = 0x10
	// Position of OVF_NUM_LSCH0 field.
	LEDC_LSCH0_CONF0_OVF_NUM_LSCH0_Pos = 0x5
	// Bit mask of OVF_NUM_LSCH0 field.
	LEDC_LSCH0_CONF0_OVF_NUM_LSCH0_Msk = 0x7fe0
	// Position of OVF_CNT_EN_LSCH0 field.
	LEDC_LSCH0_CONF0_OVF_CNT_EN_LSCH0_Pos = 0xf
	// Bit mask of OVF_CNT_EN_LSCH0 field.
	LEDC_LSCH0_CONF0_OVF_CNT_EN_LSCH0_Msk = 0x8000
	// Bit OVF_CNT_EN_LSCH0.
	LEDC_LSCH0_CONF0_OVF_CNT_EN_LSCH0 = 0x8000
	// Position of OVF_CNT_RESET_LSCH0 field.
	LEDC_LSCH0_CONF0_OVF_CNT_RESET_LSCH0_Pos = 0x10
	// Bit mask of OVF_CNT_RESET_LSCH0 field.
	LEDC_LSCH0_CONF0_OVF_CNT_RESET_LSCH0_Msk = 0x10000
	// Bit OVF_CNT_RESET_LSCH0.
	LEDC_LSCH0_CONF0_OVF_CNT_RESET_LSCH0 = 0x10000

	// LSCH0_HPOINT: LEDC_LSCH0_HPOINT.
	// Position of HPOINT_LSCH0 field.
	LEDC_LSCH0_HPOINT_HPOINT_LSCH0_Pos = 0x0
	// Bit mask of HPOINT_LSCH0 field.
	LEDC_LSCH0_HPOINT_HPOINT_LSCH0_Msk = 0x3fff

	// LSCH0_DUTY: LEDC_LSCH0_DUTY.
	// Position of DUTY_LSCH0 field.
	LEDC_LSCH0_DUTY_DUTY_LSCH0_Pos = 0x0
	// Bit mask of DUTY_LSCH0 field.
	LEDC_LSCH0_DUTY_DUTY_LSCH0_Msk = 0x7ffff

	// LSCH0_CONF1: LEDC_LSCH0_CONF1.
	// Position of DUTY_SCALE_LSCH0 field.
	LEDC_LSCH0_CONF1_DUTY_SCALE_LSCH0_Pos = 0x0
	// Bit mask of DUTY_SCALE_LSCH0 field.
	LEDC_LSCH0_CONF1_DUTY_SCALE_LSCH0_Msk = 0x3ff
	// Position of DUTY_CYCLE_LSCH0 field.
	LEDC_LSCH0_CONF1_DUTY_CYCLE_LSCH0_Pos = 0xa
	// Bit mask of DUTY_CYCLE_LSCH0 field.
	LEDC_LSCH0_CONF1_DUTY_CYCLE_LSCH0_Msk = 0xffc00
	// Position of DUTY_NUM_LSCH0 field.
	LEDC_LSCH0_CONF1_DUTY_NUM_LSCH0_Pos = 0x14
	// Bit mask of DUTY_NUM_LSCH0 field.
	LEDC_LSCH0_CONF1_DUTY_NUM_LSCH0_Msk = 0x3ff00000
	// Position of DUTY_INC_LSCH0 field.
	LEDC_LSCH0_CONF1_DUTY_INC_LSCH0_Pos = 0x1e
	// Bit mask of DUTY_INC_LSCH0 field.
	LEDC_LSCH0_CONF1_DUTY_INC_LSCH0_Msk = 0x40000000
	// Bit DUTY_INC_LSCH0.
	LEDC_LSCH0_CONF1_DUTY_INC_LSCH0 = 0x40000000
	// Position of DUTY_START_LSCH0 field.
	LEDC_LSCH0_CONF1_DUTY_START_LSCH0_Pos = 0x1f
	// Bit mask of DUTY_START_LSCH0 field.
	LEDC_LSCH0_CONF1_DUTY_START_LSCH0_Msk = 0x80000000
	// Bit DUTY_START_LSCH0.
	LEDC_LSCH0_CONF1_DUTY_START_LSCH0 = 0x80000000

	// LSCH0_DUTY_R: LEDC_LSCH0_DUTY_R.
	// Position of DUTY_LSCH0_R field.
	LEDC_LSCH0_DUTY_R_DUTY_LSCH0_R_Pos = 0x0
	// Bit mask of DUTY_LSCH0_R field.
	LEDC_LSCH0_DUTY_R_DUTY_LSCH0_R_Msk = 0x7ffff

	// LSCH1_CONF0: LEDC_LSCH1_CONF0.
	// Position of TIMER_SEL_LSCH1 field.
	LEDC_LSCH1_CONF0_TIMER_SEL_LSCH1_Pos = 0x0
	// Bit mask of TIMER_SEL_LSCH1 field.
	LEDC_LSCH1_CONF0_TIMER_SEL_LSCH1_Msk = 0x3
	// Position of SIG_OUT_EN_LSCH1 field.
	LEDC_LSCH1_CONF0_SIG_OUT_EN_LSCH1_Pos = 0x2
	// Bit mask of SIG_OUT_EN_LSCH1 field.
	LEDC_LSCH1_CONF0_SIG_OUT_EN_LSCH1_Msk = 0x4
	// Bit SIG_OUT_EN_LSCH1.
	LEDC_LSCH1_CONF0_SIG_OUT_EN_LSCH1 = 0x4
	// Position of IDLE_LV_LSCH1 field.
	LEDC_LSCH1_CONF0_IDLE_LV_LSCH1_Pos = 0x3
	// Bit mask of IDLE_LV_LSCH1 field.
	LEDC_LSCH1_CONF0_IDLE_LV_LSCH1_Msk = 0x8
	// Bit IDLE_LV_LSCH1.
	LEDC_LSCH1_CONF0_IDLE_LV_LSCH1 = 0x8
	// Position of PARA_UP_LSCH1 field.
	LEDC_LSCH1_CONF0_PARA_UP_LSCH1_Pos = 0x4
	// Bit mask of PARA_UP_LSCH1 field.
	LEDC_LSCH1_CONF0_PARA_UP_LSCH1_Msk = 0x10
	// Bit PARA_UP_LSCH1.
	LEDC_LSCH1_CONF0_PARA_UP_LSCH1 = 0x10
	// Position of OVF_NUM_LSCH1 field.
	LEDC_LSCH1_CONF0_OVF_NUM_LSCH1_Pos = 0x5
	// Bit mask of OVF_NUM_LSCH1 field.
	LEDC_LSCH1_CONF0_OVF_NUM_LSCH1_Msk = 0x7fe0
	// Position of OVF_CNT_EN_LSCH1 field.
	LEDC_LSCH1_CONF0_OVF_CNT_EN_LSCH1_Pos = 0xf
	// Bit mask of OVF_CNT_EN_LSCH1 field.
	LEDC_LSCH1_CONF0_OVF_CNT_EN_LSCH1_Msk = 0x8000
	// Bit OVF_CNT_EN_LSCH1.
	LEDC_LSCH1_CONF0_OVF_CNT_EN_LSCH1 = 0x8000
	// Position of OVF_CNT_RESET_LSCH1 field.
	LEDC_LSCH1_CONF0_OVF_CNT_RESET_LSCH1_Pos = 0x10
	// Bit mask of OVF_CNT_RESET_LSCH1 field.
	LEDC_LSCH1_CONF0_OVF_CNT_RESET_LSCH1_Msk = 0x10000
	// Bit OVF_CNT_RESET_LSCH1.
	LEDC_LSCH1_CONF0_OVF_CNT_RESET_LSCH1 = 0x10000

	// LSCH1_HPOINT: LEDC_LSCH1_HPOINT.
	// Position of HPOINT_LSCH1 field.
	LEDC_LSCH1_HPOINT_HPOINT_LSCH1_Pos = 0x0
	// Bit mask of HPOINT_LSCH1 field.
	LEDC_LSCH1_HPOINT_HPOINT_LSCH1_Msk = 0x3fff

	// LSCH1_DUTY: LEDC_LSCH1_DUTY.
	// Position of DUTY_LSCH1 field.
	LEDC_LSCH1_DUTY_DUTY_LSCH1_Pos = 0x0
	// Bit mask of DUTY_LSCH1 field.
	LEDC_LSCH1_DUTY_DUTY_LSCH1_Msk = 0x7ffff

	// LSCH1_CONF1: LEDC_LSCH1_CONF1.
	// Position of DUTY_SCALE_LSCH1 field.
	LEDC_LSCH1_CONF1_DUTY_SCALE_LSCH1_Pos = 0x0
	// Bit mask of DUTY_SCALE_LSCH1 field.
	LEDC_LSCH1_CONF1_DUTY_SCALE_LSCH1_Msk = 0x3ff
	// Position of DUTY_CYCLE_LSCH1 field.
	LEDC_LSCH1_CONF1_DUTY_CYCLE_LSCH1_Pos = 0xa
	// Bit mask of DUTY_CYCLE_LSCH1 field.
	LEDC_LSCH1_CONF1_DUTY_CYCLE_LSCH1_Msk = 0xffc00
	// Position of DUTY_NUM_LSCH1 field.
	LEDC_LSCH1_CONF1_DUTY_NUM_LSCH1_Pos = 0x14
	// Bit mask of DUTY_NUM_LSCH1 field.
	LEDC_LSCH1_CONF1_DUTY_NUM_LSCH1_Msk = 0x3ff00000
	// Position of DUTY_INC_LSCH1 field.
	LEDC_LSCH1_CONF1_DUTY_INC_LSCH1_Pos = 0x1e
	// Bit mask of DUTY_INC_LSCH1 field.
	LEDC_LSCH1_CONF1_DUTY_INC_LSCH1_Msk = 0x40000000
	// Bit DUTY_INC_LSCH1.
	LEDC_LSCH1_CONF1_DUTY_INC_LSCH1 = 0x40000000
	// Position of DUTY_START_LSCH1 field.
	LEDC_LSCH1_CONF1_DUTY_START_LSCH1_Pos = 0x1f
	// Bit mask of DUTY_START_LSCH1 field.
	LEDC_LSCH1_CONF1_DUTY_START_LSCH1_Msk = 0x80000000
	// Bit DUTY_START_LSCH1.
	LEDC_LSCH1_CONF1_DUTY_START_LSCH1 = 0x80000000

	// LSCH1_DUTY_R: LEDC_LSCH1_DUTY_R.
	// Position of DUTY_LSCH1_R field.
	LEDC_LSCH1_DUTY_R_DUTY_LSCH1_R_Pos = 0x0
	// Bit mask of DUTY_LSCH1_R field.
	LEDC_LSCH1_DUTY_R_DUTY_LSCH1_R_Msk = 0x7ffff

	// LSCH2_CONF0: LEDC_LSCH2_CONF0.
	// Position of TIMER_SEL_LSCH2 field.
	LEDC_LSCH2_CONF0_TIMER_SEL_LSCH2_Pos = 0x0
	// Bit mask of TIMER_SEL_LSCH2 field.
	LEDC_LSCH2_CONF0_TIMER_SEL_LSCH2_Msk = 0x3
	// Position of SIG_OUT_EN_LSCH2 field.
	LEDC_LSCH2_CONF0_SIG_OUT_EN_LSCH2_Pos = 0x2
	// Bit mask of SIG_OUT_EN_LSCH2 field.
	LEDC_LSCH2_CONF0_SIG_OUT_EN_LSCH2_Msk = 0x4
	// Bit SIG_OUT_EN_LSCH2.
	LEDC_LSCH2_CONF0_SIG_OUT_EN_LSCH2 = 0x4
	// Position of IDLE_LV_LSCH2 field.
	LEDC_LSCH2_CONF0_IDLE_LV_LSCH2_Pos = 0x3
	// Bit mask of IDLE_LV_LSCH2 field.
	LEDC_LSCH2_CONF0_IDLE_LV_LSCH2_Msk = 0x8
	// Bit IDLE_LV_LSCH2.
	LEDC_LSCH2_CONF0_IDLE_LV_LSCH2 = 0x8
	// Position of PARA_UP_LSCH2 field.
	LEDC_LSCH2_CONF0_PARA_UP_LSCH2_Pos = 0x4
	// Bit mask of PARA_UP_LSCH2 field.
	LEDC_LSCH2_CONF0_PARA_UP_LSCH2_Msk = 0x10
	// Bit PARA_UP_LSCH2.
	LEDC_LSCH2_CONF0_PARA_UP_LSCH2 = 0x10
	// Position of OVF_NUM_LSCH2 field.
	LEDC_LSCH2_CONF0_OVF_NUM_LSCH2_Pos = 0x5
	// Bit mask of OVF_NUM_LSCH2 field.
	LEDC_LSCH2_CONF0_OVF_NUM_LSCH2_Msk = 0x7fe0
	// Position of OVF_CNT_EN_LSCH2 field.
	LEDC_LSCH2_CONF0_OVF_CNT_EN_LSCH2_Pos = 0xf
	// Bit mask of OVF_CNT_EN_LSCH2 field.
	LEDC_LSCH2_CONF0_OVF_CNT_EN_LSCH2_Msk = 0x8000
	// Bit OVF_CNT_EN_LSCH2.
	LEDC_LSCH2_CONF0_OVF_CNT_EN_LSCH2 = 0x8000
	// Position of OVF_CNT_RESET_LSCH2 field.
	LEDC_LSCH2_CONF0_OVF_CNT_RESET_LSCH2_Pos = 0x10
	// Bit mask of OVF_CNT_RESET_LSCH2 field.
	LEDC_LSCH2_CONF0_OVF_CNT_RESET_LSCH2_Msk = 0x10000
	// Bit OVF_CNT_RESET_LSCH2.
	LEDC_LSCH2_CONF0_OVF_CNT_RESET_LSCH2 = 0x10000

	// LSCH2_HPOINT: LEDC_LSCH2_HPOINT.
	// Position of HPOINT_LSCH2 field.
	LEDC_LSCH2_HPOINT_HPOINT_LSCH2_Pos = 0x0
	// Bit mask of HPOINT_LSCH2 field.
	LEDC_LSCH2_HPOINT_HPOINT_LSCH2_Msk = 0x3fff

	// LSCH2_DUTY: LEDC_LSCH2_DUTY.
	// Position of DUTY_LSCH2 field.
	LEDC_LSCH2_DUTY_DUTY_LSCH2_Pos = 0x0
	// Bit mask of DUTY_LSCH2 field.
	LEDC_LSCH2_DUTY_DUTY_LSCH2_Msk = 0x7ffff

	// LSCH2_CONF1: LEDC_LSCH2_CONF1.
	// Position of DUTY_SCALE_LSCH2 field.
	LEDC_LSCH2_CONF1_DUTY_SCALE_LSCH2_Pos = 0x0
	// Bit mask of DUTY_SCALE_LSCH2 field.
	LEDC_LSCH2_CONF1_DUTY_SCALE_LSCH2_Msk = 0x3ff
	// Position of DUTY_CYCLE_LSCH2 field.
	LEDC_LSCH2_CONF1_DUTY_CYCLE_LSCH2_Pos = 0xa
	// Bit mask of DUTY_CYCLE_LSCH2 field.
	LEDC_LSCH2_CONF1_DUTY_CYCLE_LSCH2_Msk = 0xffc00
	// Position of DUTY_NUM_LSCH2 field.
	LEDC_LSCH2_CONF1_DUTY_NUM_LSCH2_Pos = 0x14
	// Bit mask of DUTY_NUM_LSCH2 field.
	LEDC_LSCH2_CONF1_DUTY_NUM_LSCH2_Msk = 0x3ff00000
	// Position of DUTY_INC_LSCH2 field.
	LEDC_LSCH2_CONF1_DUTY_INC_LSCH2_Pos = 0x1e
	// Bit mask of DUTY_INC_LSCH2 field.
	LEDC_LSCH2_CONF1_DUTY_INC_LSCH2_Msk = 0x40000000
	// Bit DUTY_INC_LSCH2.
	LEDC_LSCH2_CONF1_DUTY_INC_LSCH2 = 0x40000000
	// Position of DUTY_START_LSCH2 field.
	LEDC_LSCH2_CONF1_DUTY_START_LSCH2_Pos = 0x1f
	// Bit mask of DUTY_START_LSCH2 field.
	LEDC_LSCH2_CONF1_DUTY_START_LSCH2_Msk = 0x80000000
	// Bit DUTY_START_LSCH2.
	LEDC_LSCH2_CONF1_DUTY_START_LSCH2 = 0x80000000

	// LSCH2_DUTY_R: LEDC_LSCH2_DUTY_R.
	// Position of DUTY_LSCH2_R field.
	LEDC_LSCH2_DUTY_R_DUTY_LSCH2_R_Pos = 0x0
	// Bit mask of DUTY_LSCH2_R field.
	LEDC_LSCH2_DUTY_R_DUTY_LSCH2_R_Msk = 0x7ffff

	// LSCH3_CONF0: LEDC_LSCH3_CONF0.
	// Position of TIMER_SEL_LSCH3 field.
	LEDC_LSCH3_CONF0_TIMER_SEL_LSCH3_Pos = 0x0
	// Bit mask of TIMER_SEL_LSCH3 field.
	LEDC_LSCH3_CONF0_TIMER_SEL_LSCH3_Msk = 0x3
	// Position of SIG_OUT_EN_LSCH3 field.
	LEDC_LSCH3_CONF0_SIG_OUT_EN_LSCH3_Pos = 0x2
	// Bit mask of SIG_OUT_EN_LSCH3 field.
	LEDC_LSCH3_CONF0_SIG_OUT_EN_LSCH3_Msk = 0x4
	// Bit SIG_OUT_EN_LSCH3.
	LEDC_LSCH3_CONF0_SIG_OUT_EN_LSCH3 = 0x4
	// Position of IDLE_LV_LSCH3 field.
	LEDC_LSCH3_CONF0_IDLE_LV_LSCH3_Pos = 0x3
	// Bit mask of IDLE_LV_LSCH3 field.
	LEDC_LSCH3_CONF0_IDLE_LV_LSCH3_Msk = 0x8
	// Bit IDLE_LV_LSCH3.
	LEDC_LSCH3_CONF0_IDLE_LV_LSCH3 = 0x8
	// Position of PARA_UP_LSCH3 field.
	LEDC_LSCH3_CONF0_PARA_UP_LSCH3_Pos = 0x4
	// Bit mask of PARA_UP_LSCH3 field.
	LEDC_LSCH3_CONF0_PARA_UP_LSCH3_Msk = 0x10
	// Bit PARA_UP_LSCH3.
	LEDC_LSCH3_CONF0_PARA_UP_LSCH3 = 0x10
	// Position of OVF_NUM_LSCH3 field.
	LEDC_LSCH3_CONF0_OVF_NUM_LSCH3_Pos = 0x5
	// Bit mask of OVF_NUM_LSCH3 field.
	LEDC_LSCH3_CONF0_OVF_NUM_LSCH3_Msk = 0x7fe0
	// Position of OVF_CNT_EN_LSCH3 field.
	LEDC_LSCH3_CONF0_OVF_CNT_EN_LSCH3_Pos = 0xf
	// Bit mask of OVF_CNT_EN_LSCH3 field.
	LEDC_LSCH3_CONF0_OVF_CNT_EN_LSCH3_Msk = 0x8000
	// Bit OVF_CNT_EN_LSCH3.
	LEDC_LSCH3_CONF0_OVF_CNT_EN_LSCH3 = 0x8000
	// Position of OVF_CNT_RESET_LSCH3 field.
	LEDC_LSCH3_CONF0_OVF_CNT_RESET_LSCH3_Pos = 0x10
	// Bit mask of OVF_CNT_RESET_LSCH3 field.
	LEDC_LSCH3_CONF0_OVF_CNT_RESET_LSCH3_Msk = 0x10000
	// Bit OVF_CNT_RESET_LSCH3.
	LEDC_LSCH3_CONF0_OVF_CNT_RESET_LSCH3 = 0x10000

	// LSCH3_HPOINT: LEDC_LSCH3_HPOINT.
	// Position of HPOINT_LSCH3 field.
	LEDC_LSCH3_HPOINT_HPOINT_LSCH3_Pos = 0x0
	// Bit mask of HPOINT_LSCH3 field.
	LEDC_LSCH3_HPOINT_HPOINT_LSCH3_Msk = 0x3fff

	// LSCH3_DUTY: LEDC_LSCH3_DUTY.
	// Position of DUTY_LSCH3 field.
	LEDC_LSCH3_DUTY_DUTY_LSCH3_Pos = 0x0
	// Bit mask of DUTY_LSCH3 field.
	LEDC_LSCH3_DUTY_DUTY_LSCH3_Msk = 0x7ffff

	// LSCH3_CONF1: LEDC_LSCH3_CONF1.
	// Position of DUTY_SCALE_LSCH3 field.
	LEDC_LSCH3_CONF1_DUTY_SCALE_LSCH3_Pos = 0x0
	// Bit mask of DUTY_SCALE_LSCH3 field.
	LEDC_LSCH3_CONF1_DUTY_SCALE_LSCH3_Msk = 0x3ff
	// Position of DUTY_CYCLE_LSCH3 field.
	LEDC_LSCH3_CONF1_DUTY_CYCLE_LSCH3_Pos = 0xa
	// Bit mask of DUTY_CYCLE_LSCH3 field.
	LEDC_LSCH3_CONF1_DUTY_CYCLE_LSCH3_Msk = 0xffc00
	// Position of DUTY_NUM_LSCH3 field.
	LEDC_LSCH3_CONF1_DUTY_NUM_LSCH3_Pos = 0x14
	// Bit mask of DUTY_NUM_LSCH3 field.
	LEDC_LSCH3_CONF1_DUTY_NUM_LSCH3_Msk = 0x3ff00000
	// Position of DUTY_INC_LSCH3 field.
	LEDC_LSCH3_CONF1_DUTY_INC_LSCH3_Pos = 0x1e
	// Bit mask of DUTY_INC_LSCH3 field.
	LEDC_LSCH3_CONF1_DUTY_INC_LSCH3_Msk = 0x40000000
	// Bit DUTY_INC_LSCH3.
	LEDC_LSCH3_CONF1_DUTY_INC_LSCH3 = 0x40000000
	// Position of DUTY_START_LSCH3 field.
	LEDC_LSCH3_CONF1_DUTY_START_LSCH3_Pos = 0x1f
	// Bit mask of DUTY_START_LSCH3 field.
	LEDC_LSCH3_CONF1_DUTY_START_LSCH3_Msk = 0x80000000
	// Bit DUTY_START_LSCH3.
	LEDC_LSCH3_CONF1_DUTY_START_LSCH3 = 0x80000000

	// LSCH3_DUTY_R: LEDC_LSCH3_DUTY_R.
	// Position of DUTY_LSCH3_R field.
	LEDC_LSCH3_DUTY_R_DUTY_LSCH3_R_Pos = 0x0
	// Bit mask of DUTY_LSCH3_R field.
	LEDC_LSCH3_DUTY_R_DUTY_LSCH3_R_Msk = 0x7ffff

	// LSCH4_CONF0: LEDC_LSCH4_CONF0.
	// Position of TIMER_SEL_LSCH4 field.
	LEDC_LSCH4_CONF0_TIMER_SEL_LSCH4_Pos = 0x0
	// Bit mask of TIMER_SEL_LSCH4 field.
	LEDC_LSCH4_CONF0_TIMER_SEL_LSCH4_Msk = 0x3
	// Position of SIG_OUT_EN_LSCH4 field.
	LEDC_LSCH4_CONF0_SIG_OUT_EN_LSCH4_Pos = 0x2
	// Bit mask of SIG_OUT_EN_LSCH4 field.
	LEDC_LSCH4_CONF0_SIG_OUT_EN_LSCH4_Msk = 0x4
	// Bit SIG_OUT_EN_LSCH4.
	LEDC_LSCH4_CONF0_SIG_OUT_EN_LSCH4 = 0x4
	// Position of IDLE_LV_LSCH4 field.
	LEDC_LSCH4_CONF0_IDLE_LV_LSCH4_Pos = 0x3
	// Bit mask of IDLE_LV_LSCH4 field.
	LEDC_LSCH4_CONF0_IDLE_LV_LSCH4_Msk = 0x8
	// Bit IDLE_LV_LSCH4.
	LEDC_LSCH4_CONF0_IDLE_LV_LSCH4 = 0x8
	// Position of PARA_UP_LSCH4 field.
	LEDC_LSCH4_CONF0_PARA_UP_LSCH4_Pos = 0x4
	// Bit mask of PARA_UP_LSCH4 field.
	LEDC_LSCH4_CONF0_PARA_UP_LSCH4_Msk = 0x10
	// Bit PARA_UP_LSCH4.
	LEDC_LSCH4_CONF0_PARA_UP_LSCH4 = 0x10
	// Position of OVF_NUM_LSCH4 field.
	LEDC_LSCH4_CONF0_OVF_NUM_LSCH4_Pos = 0x5
	// Bit mask of OVF_NUM_LSCH4 field.
	LEDC_LSCH4_CONF0_OVF_NUM_LSCH4_Msk = 0x7fe0
	// Position of OVF_CNT_EN_LSCH4 field.
	LEDC_LSCH4_CONF0_OVF_CNT_EN_LSCH4_Pos = 0xf
	// Bit mask of OVF_CNT_EN_LSCH4 field.
	LEDC_LSCH4_CONF0_OVF_CNT_EN_LSCH4_Msk = 0x8000
	// Bit OVF_CNT_EN_LSCH4.
	LEDC_LSCH4_CONF0_OVF_CNT_EN_LSCH4 = 0x8000
	// Position of OVF_CNT_RESET_LSCH4 field.
	LEDC_LSCH4_CONF0_OVF_CNT_RESET_LSCH4_Pos = 0x10
	// Bit mask of OVF_CNT_RESET_LSCH4 field.
	LEDC_LSCH4_CONF0_OVF_CNT_RESET_LSCH4_Msk = 0x10000
	// Bit OVF_CNT_RESET_LSCH4.
	LEDC_LSCH4_CONF0_OVF_CNT_RESET_LSCH4 = 0x10000

	// LSCH4_HPOINT: LEDC_LSCH4_HPOINT.
	// Position of HPOINT_LSCH4 field.
	LEDC_LSCH4_HPOINT_HPOINT_LSCH4_Pos = 0x0
	// Bit mask of HPOINT_LSCH4 field.
	LEDC_LSCH4_HPOINT_HPOINT_LSCH4_Msk = 0x3fff

	// LSCH4_DUTY: LEDC_LSCH4_DUTY.
	// Position of DUTY_LSCH4 field.
	LEDC_LSCH4_DUTY_DUTY_LSCH4_Pos = 0x0
	// Bit mask of DUTY_LSCH4 field.
	LEDC_LSCH4_DUTY_DUTY_LSCH4_Msk = 0x7ffff

	// LSCH4_CONF1: LEDC_LSCH4_CONF1.
	// Position of DUTY_SCALE_LSCH4 field.
	LEDC_LSCH4_CONF1_DUTY_SCALE_LSCH4_Pos = 0x0
	// Bit mask of DUTY_SCALE_LSCH4 field.
	LEDC_LSCH4_CONF1_DUTY_SCALE_LSCH4_Msk = 0x3ff
	// Position of DUTY_CYCLE_LSCH4 field.
	LEDC_LSCH4_CONF1_DUTY_CYCLE_LSCH4_Pos = 0xa
	// Bit mask of DUTY_CYCLE_LSCH4 field.
	LEDC_LSCH4_CONF1_DUTY_CYCLE_LSCH4_Msk = 0xffc00
	// Position of DUTY_NUM_LSCH4 field.
	LEDC_LSCH4_CONF1_DUTY_NUM_LSCH4_Pos = 0x14
	// Bit mask of DUTY_NUM_LSCH4 field.
	LEDC_LSCH4_CONF1_DUTY_NUM_LSCH4_Msk = 0x3ff00000
	// Position of DUTY_INC_LSCH4 field.
	LEDC_LSCH4_CONF1_DUTY_INC_LSCH4_Pos = 0x1e
	// Bit mask of DUTY_INC_LSCH4 field.
	LEDC_LSCH4_CONF1_DUTY_INC_LSCH4_Msk = 0x40000000
	// Bit DUTY_INC_LSCH4.
	LEDC_LSCH4_CONF1_DUTY_INC_LSCH4 = 0x40000000
	// Position of DUTY_START_LSCH4 field.
	LEDC_LSCH4_CONF1_DUTY_START_LSCH4_Pos = 0x1f
	// Bit mask of DUTY_START_LSCH4 field.
	LEDC_LSCH4_CONF1_DUTY_START_LSCH4_Msk = 0x80000000
	// Bit DUTY_START_LSCH4.
	LEDC_LSCH4_CONF1_DUTY_START_LSCH4 = 0x80000000

	// LSCH4_DUTY_R: LEDC_LSCH4_DUTY_R.
	// Position of DUTY_LSCH4_R field.
	LEDC_LSCH4_DUTY_R_DUTY_LSCH4_R_Pos = 0x0
	// Bit mask of DUTY_LSCH4_R field.
	LEDC_LSCH4_DUTY_R_DUTY_LSCH4_R_Msk = 0x7ffff

	// LSCH5_CONF0: LEDC_LSCH5_CONF0.
	// Position of TIMER_SEL_LSCH5 field.
	LEDC_LSCH5_CONF0_TIMER_SEL_LSCH5_Pos = 0x0
	// Bit mask of TIMER_SEL_LSCH5 field.
	LEDC_LSCH5_CONF0_TIMER_SEL_LSCH5_Msk = 0x3
	// Position of SIG_OUT_EN_LSCH5 field.
	LEDC_LSCH5_CONF0_SIG_OUT_EN_LSCH5_Pos = 0x2
	// Bit mask of SIG_OUT_EN_LSCH5 field.
	LEDC_LSCH5_CONF0_SIG_OUT_EN_LSCH5_Msk = 0x4
	// Bit SIG_OUT_EN_LSCH5.
	LEDC_LSCH5_CONF0_SIG_OUT_EN_LSCH5 = 0x4
	// Position of IDLE_LV_LSCH5 field.
	LEDC_LSCH5_CONF0_IDLE_LV_LSCH5_Pos = 0x3
	// Bit mask of IDLE_LV_LSCH5 field.
	LEDC_LSCH5_CONF0_IDLE_LV_LSCH5_Msk = 0x8
	// Bit IDLE_LV_LSCH5.
	LEDC_LSCH5_CONF0_IDLE_LV_LSCH5 = 0x8
	// Position of PARA_UP_LSCH5 field.
	LEDC_LSCH5_CONF0_PARA_UP_LSCH5_Pos = 0x4
	// Bit mask of PARA_UP_LSCH5 field.
	LEDC_LSCH5_CONF0_PARA_UP_LSCH5_Msk = 0x10
	// Bit PARA_UP_LSCH5.
	LEDC_LSCH5_CONF0_PARA_UP_LSCH5 = 0x10
	// Position of OVF_NUM_LSCH5 field.
	LEDC_LSCH5_CONF0_OVF_NUM_LSCH5_Pos = 0x5
	// Bit mask of OVF_NUM_LSCH5 field.
	LEDC_LSCH5_CONF0_OVF_NUM_LSCH5_Msk = 0x7fe0
	// Position of OVF_CNT_EN_LSCH5 field.
	LEDC_LSCH5_CONF0_OVF_CNT_EN_LSCH5_Pos = 0xf
	// Bit mask of OVF_CNT_EN_LSCH5 field.
	LEDC_LSCH5_CONF0_OVF_CNT_EN_LSCH5_Msk = 0x8000
	// Bit OVF_CNT_EN_LSCH5.
	LEDC_LSCH5_CONF0_OVF_CNT_EN_LSCH5 = 0x8000
	// Position of OVF_CNT_RESET_LSCH5 field.
	LEDC_LSCH5_CONF0_OVF_CNT_RESET_LSCH5_Pos = 0x10
	// Bit mask of OVF_CNT_RESET_LSCH5 field.
	LEDC_LSCH5_CONF0_OVF_CNT_RESET_LSCH5_Msk = 0x10000
	// Bit OVF_CNT_RESET_LSCH5.
	LEDC_LSCH5_CONF0_OVF_CNT_RESET_LSCH5 = 0x10000

	// LSCH5_HPOINT: LEDC_LSCH5_HPOINT.
	// Position of HPOINT_LSCH5 field.
	LEDC_LSCH5_HPOINT_HPOINT_LSCH5_Pos = 0x0
	// Bit mask of HPOINT_LSCH5 field.
	LEDC_LSCH5_HPOINT_HPOINT_LSCH5_Msk = 0x3fff

	// LSCH5_DUTY: LEDC_LSCH5_DUTY.
	// Position of DUTY_LSCH5 field.
	LEDC_LSCH5_DUTY_DUTY_LSCH5_Pos = 0x0
	// Bit mask of DUTY_LSCH5 field.
	LEDC_LSCH5_DUTY_DUTY_LSCH5_Msk = 0x7ffff

	// LSCH5_CONF1: LEDC_LSCH5_CONF1.
	// Position of DUTY_SCALE_LSCH5 field.
	LEDC_LSCH5_CONF1_DUTY_SCALE_LSCH5_Pos = 0x0
	// Bit mask of DUTY_SCALE_LSCH5 field.
	LEDC_LSCH5_CONF1_DUTY_SCALE_LSCH5_Msk = 0x3ff
	// Position of DUTY_CYCLE_LSCH5 field.
	LEDC_LSCH5_CONF1_DUTY_CYCLE_LSCH5_Pos = 0xa
	// Bit mask of DUTY_CYCLE_LSCH5 field.
	LEDC_LSCH5_CONF1_DUTY_CYCLE_LSCH5_Msk = 0xffc00
	// Position of DUTY_NUM_LSCH5 field.
	LEDC_LSCH5_CONF1_DUTY_NUM_LSCH5_Pos = 0x14
	// Bit mask of DUTY_NUM_LSCH5 field.
	LEDC_LSCH5_CONF1_DUTY_NUM_LSCH5_Msk = 0x3ff00000
	// Position of DUTY_INC_LSCH5 field.
	LEDC_LSCH5_CONF1_DUTY_INC_LSCH5_Pos = 0x1e
	// Bit mask of DUTY_INC_LSCH5 field.
	LEDC_LSCH5_CONF1_DUTY_INC_LSCH5_Msk = 0x40000000
	// Bit DUTY_INC_LSCH5.
	LEDC_LSCH5_CONF1_DUTY_INC_LSCH5 = 0x40000000
	// Position of DUTY_START_LSCH5 field.
	LEDC_LSCH5_CONF1_DUTY_START_LSCH5_Pos = 0x1f
	// Bit mask of DUTY_START_LSCH5 field.
	LEDC_LSCH5_CONF1_DUTY_START_LSCH5_Msk = 0x80000000
	// Bit DUTY_START_LSCH5.
	LEDC_LSCH5_CONF1_DUTY_START_LSCH5 = 0x80000000

	// LSCH5_DUTY_R: LEDC_LSCH5_DUTY_R.
	// Position of DUTY_LSCH5_R field.
	LEDC_LSCH5_DUTY_R_DUTY_LSCH5_R_Pos = 0x0
	// Bit mask of DUTY_LSCH5_R field.
	LEDC_LSCH5_DUTY_R_DUTY_LSCH5_R_Msk = 0x7ffff

	// LSTIMER0_CONF: LEDC_LSTIMER0_CONF.
	// Position of LSTIMER0_DUTY_RES field.
	LEDC_LSTIMER0_CONF_LSTIMER0_DUTY_RES_Pos = 0x0
	// Bit mask of LSTIMER0_DUTY_RES field.
	LEDC_LSTIMER0_CONF_LSTIMER0_DUTY_RES_Msk = 0xf
	// Position of CLK_DIV_LSTIMER0 field.
	LEDC_LSTIMER0_CONF_CLK_DIV_LSTIMER0_Pos = 0x4
	// Bit mask of CLK_DIV_LSTIMER0 field.
	LEDC_LSTIMER0_CONF_CLK_DIV_LSTIMER0_Msk = 0x3ffff0
	// Position of LSTIMER0_PAUSE field.
	LEDC_LSTIMER0_CONF_LSTIMER0_PAUSE_Pos = 0x16
	// Bit mask of LSTIMER0_PAUSE field.
	LEDC_LSTIMER0_CONF_LSTIMER0_PAUSE_Msk = 0x400000
	// Bit LSTIMER0_PAUSE.
	LEDC_LSTIMER0_CONF_LSTIMER0_PAUSE = 0x400000
	// Position of LSTIMER0_RST field.
	LEDC_LSTIMER0_CONF_LSTIMER0_RST_Pos = 0x17
	// Bit mask of LSTIMER0_RST field.
	LEDC_LSTIMER0_CONF_LSTIMER0_RST_Msk = 0x800000
	// Bit LSTIMER0_RST.
	LEDC_LSTIMER0_CONF_LSTIMER0_RST = 0x800000
	// Position of TICK_SEL_LSTIMER0 field.
	LEDC_LSTIMER0_CONF_TICK_SEL_LSTIMER0_Pos = 0x18
	// Bit mask of TICK_SEL_LSTIMER0 field.
	LEDC_LSTIMER0_CONF_TICK_SEL_LSTIMER0_Msk = 0x1000000
	// Bit TICK_SEL_LSTIMER0.
	LEDC_LSTIMER0_CONF_TICK_SEL_LSTIMER0 = 0x1000000
	// Position of LSTIMER0_PARA_UP field.
	LEDC_LSTIMER0_CONF_LSTIMER0_PARA_UP_Pos = 0x19
	// Bit mask of LSTIMER0_PARA_UP field.
	LEDC_LSTIMER0_CONF_LSTIMER0_PARA_UP_Msk = 0x2000000
	// Bit LSTIMER0_PARA_UP.
	LEDC_LSTIMER0_CONF_LSTIMER0_PARA_UP = 0x2000000

	// LSTIMER0_VALUE: LEDC_LSTIMER0_VALUE.
	// Position of LSTIMER0_CNT field.
	LEDC_LSTIMER0_VALUE_LSTIMER0_CNT_Pos = 0x0
	// Bit mask of LSTIMER0_CNT field.
	LEDC_LSTIMER0_VALUE_LSTIMER0_CNT_Msk = 0x3fff

	// LSTIMER1_CONF: LEDC_LSTIMER1_CONF.
	// Position of LSTIMER1_DUTY_RES field.
	LEDC_LSTIMER1_CONF_LSTIMER1_DUTY_RES_Pos = 0x0
	// Bit mask of LSTIMER1_DUTY_RES field.
	LEDC_LSTIMER1_CONF_LSTIMER1_DUTY_RES_Msk = 0xf
	// Position of CLK_DIV_LSTIMER1 field.
	LEDC_LSTIMER1_CONF_CLK_DIV_LSTIMER1_Pos = 0x4
	// Bit mask of CLK_DIV_LSTIMER1 field.
	LEDC_LSTIMER1_CONF_CLK_DIV_LSTIMER1_Msk = 0x3ffff0
	// Position of LSTIMER1_PAUSE field.
	LEDC_LSTIMER1_CONF_LSTIMER1_PAUSE_Pos = 0x16
	// Bit mask of LSTIMER1_PAUSE field.
	LEDC_LSTIMER1_CONF_LSTIMER1_PAUSE_Msk = 0x400000
	// Bit LSTIMER1_PAUSE.
	LEDC_LSTIMER1_CONF_LSTIMER1_PAUSE = 0x400000
	// Position of LSTIMER1_RST field.
	LEDC_LSTIMER1_CONF_LSTIMER1_RST_Pos = 0x17
	// Bit mask of LSTIMER1_RST field.
	LEDC_LSTIMER1_CONF_LSTIMER1_RST_Msk = 0x800000
	// Bit LSTIMER1_RST.
	LEDC_LSTIMER1_CONF_LSTIMER1_RST = 0x800000
	// Position of TICK_SEL_LSTIMER1 field.
	LEDC_LSTIMER1_CONF_TICK_SEL_LSTIMER1_Pos = 0x18
	// Bit mask of TICK_SEL_LSTIMER1 field.
	LEDC_LSTIMER1_CONF_TICK_SEL_LSTIMER1_Msk = 0x1000000
	// Bit TICK_SEL_LSTIMER1.
	LEDC_LSTIMER1_CONF_TICK_SEL_LSTIMER1 = 0x1000000
	// Position of LSTIMER1_PARA_UP field.
	LEDC_LSTIMER1_CONF_LSTIMER1_PARA_UP_Pos = 0x19
	// Bit mask of LSTIMER1_PARA_UP field.
	LEDC_LSTIMER1_CONF_LSTIMER1_PARA_UP_Msk = 0x2000000
	// Bit LSTIMER1_PARA_UP.
	LEDC_LSTIMER1_CONF_LSTIMER1_PARA_UP = 0x2000000

	// LSTIMER1_VALUE: LEDC_LSTIMER1_VALUE.
	// Position of LSTIMER1_CNT field.
	LEDC_LSTIMER1_VALUE_LSTIMER1_CNT_Pos = 0x0
	// Bit mask of LSTIMER1_CNT field.
	LEDC_LSTIMER1_VALUE_LSTIMER1_CNT_Msk = 0x3fff

	// LSTIMER2_CONF: LEDC_LSTIMER2_CONF.
	// Position of LSTIMER2_DUTY_RES field.
	LEDC_LSTIMER2_CONF_LSTIMER2_DUTY_RES_Pos = 0x0
	// Bit mask of LSTIMER2_DUTY_RES field.
	LEDC_LSTIMER2_CONF_LSTIMER2_DUTY_RES_Msk = 0xf
	// Position of CLK_DIV_LSTIMER2 field.
	LEDC_LSTIMER2_CONF_CLK_DIV_LSTIMER2_Pos = 0x4
	// Bit mask of CLK_DIV_LSTIMER2 field.
	LEDC_LSTIMER2_CONF_CLK_DIV_LSTIMER2_Msk = 0x3ffff0
	// Position of LSTIMER2_PAUSE field.
	LEDC_LSTIMER2_CONF_LSTIMER2_PAUSE_Pos = 0x16
	// Bit mask of LSTIMER2_PAUSE field.
	LEDC_LSTIMER2_CONF_LSTIMER2_PAUSE_Msk = 0x400000
	// Bit LSTIMER2_PAUSE.
	LEDC_LSTIMER2_CONF_LSTIMER2_PAUSE = 0x400000
	// Position of LSTIMER2_RST field.
	LEDC_LSTIMER2_CONF_LSTIMER2_RST_Pos = 0x17
	// Bit mask of LSTIMER2_RST field.
	LEDC_LSTIMER2_CONF_LSTIMER2_RST_Msk = 0x800000
	// Bit LSTIMER2_RST.
	LEDC_LSTIMER2_CONF_LSTIMER2_RST = 0x800000
	// Position of TICK_SEL_LSTIMER2 field.
	LEDC_LSTIMER2_CONF_TICK_SEL_LSTIMER2_Pos = 0x18
	// Bit mask of TICK_SEL_LSTIMER2 field.
	LEDC_LSTIMER2_CONF_TICK_SEL_LSTIMER2_Msk = 0x1000000
	// Bit TICK_SEL_LSTIMER2.
	LEDC_LSTIMER2_CONF_TICK_SEL_LSTIMER2 = 0x1000000
	// Position of LSTIMER2_PARA_UP field.
	LEDC_LSTIMER2_CONF_LSTIMER2_PARA_UP_Pos = 0x19
	// Bit mask of LSTIMER2_PARA_UP field.
	LEDC_LSTIMER2_CONF_LSTIMER2_PARA_UP_Msk = 0x2000000
	// Bit LSTIMER2_PARA_UP.
	LEDC_LSTIMER2_CONF_LSTIMER2_PARA_UP = 0x2000000

	// LSTIMER2_VALUE: LEDC_LSTIMER2_VALUE.
	// Position of LSTIMER2_CNT field.
	LEDC_LSTIMER2_VALUE_LSTIMER2_CNT_Pos = 0x0
	// Bit mask of LSTIMER2_CNT field.
	LEDC_LSTIMER2_VALUE_LSTIMER2_CNT_Msk = 0x3fff

	// LSTIMER3_CONF: LEDC_LSTIMER3_CONF.
	// Position of LSTIMER3_DUTY_RES field.
	LEDC_LSTIMER3_CONF_LSTIMER3_DUTY_RES_Pos = 0x0
	// Bit mask of LSTIMER3_DUTY_RES field.
	LEDC_LSTIMER3_CONF_LSTIMER3_DUTY_RES_Msk = 0xf
	// Position of CLK_DIV_LSTIMER3 field.
	LEDC_LSTIMER3_CONF_CLK_DIV_LSTIMER3_Pos = 0x4
	// Bit mask of CLK_DIV_LSTIMER3 field.
	LEDC_LSTIMER3_CONF_CLK_DIV_LSTIMER3_Msk = 0x3ffff0
	// Position of LSTIMER3_PAUSE field.
	LEDC_LSTIMER3_CONF_LSTIMER3_PAUSE_Pos = 0x16
	// Bit mask of LSTIMER3_PAUSE field.
	LEDC_LSTIMER3_CONF_LSTIMER3_PAUSE_Msk = 0x400000
	// Bit LSTIMER3_PAUSE.
	LEDC_LSTIMER3_CONF_LSTIMER3_PAUSE = 0x400000
	// Position of LSTIMER3_RST field.
	LEDC_LSTIMER3_CONF_LSTIMER3_RST_Pos = 0x17
	// Bit mask of LSTIMER3_RST field.
	LEDC_LSTIMER3_CONF_LSTIMER3_RST_Msk = 0x800000
	// Bit LSTIMER3_RST.
	LEDC_LSTIMER3_CONF_LSTIMER3_RST = 0x800000
	// Position of TICK_SEL_LSTIMER3 field.
	LEDC_LSTIMER3_CONF_TICK_SEL_LSTIMER3_Pos = 0x18
	// Bit mask of TICK_SEL_LSTIMER3 field.
	LEDC_LSTIMER3_CONF_TICK_SEL_LSTIMER3_Msk = 0x1000000
	// Bit TICK_SEL_LSTIMER3.
	LEDC_LSTIMER3_CONF_TICK_SEL_LSTIMER3 = 0x1000000
	// Position of LSTIMER3_PARA_UP field.
	LEDC_LSTIMER3_CONF_LSTIMER3_PARA_UP_Pos = 0x19
	// Bit mask of LSTIMER3_PARA_UP field.
	LEDC_LSTIMER3_CONF_LSTIMER3_PARA_UP_Msk = 0x2000000
	// Bit LSTIMER3_PARA_UP.
	LEDC_LSTIMER3_CONF_LSTIMER3_PARA_UP = 0x2000000

	// LSTIMER3_VALUE: LEDC_LSTIMER3_VALUE.
	// Position of LSTIMER3_CNT field.
	LEDC_LSTIMER3_VALUE_LSTIMER3_CNT_Pos = 0x0
	// Bit mask of LSTIMER3_CNT field.
	LEDC_LSTIMER3_VALUE_LSTIMER3_CNT_Msk = 0x3fff

	// INT_RAW: LEDC_INT_RAW.
	// Position of LSTIMER0_OVF_INT_RAW field.
	LEDC_INT_RAW_LSTIMER0_OVF_INT_RAW_Pos = 0x0
	// Bit mask of LSTIMER0_OVF_INT_RAW field.
	LEDC_INT_RAW_LSTIMER0_OVF_INT_RAW_Msk = 0x1
	// Bit LSTIMER0_OVF_INT_RAW.
	LEDC_INT_RAW_LSTIMER0_OVF_INT_RAW = 0x1
	// Position of LSTIMER1_OVF_INT_RAW field.
	LEDC_INT_RAW_LSTIMER1_OVF_INT_RAW_Pos = 0x1
	// Bit mask of LSTIMER1_OVF_INT_RAW field.
	LEDC_INT_RAW_LSTIMER1_OVF_INT_RAW_Msk = 0x2
	// Bit LSTIMER1_OVF_INT_RAW.
	LEDC_INT_RAW_LSTIMER1_OVF_INT_RAW = 0x2
	// Position of LSTIMER2_OVF_INT_RAW field.
	LEDC_INT_RAW_LSTIMER2_OVF_INT_RAW_Pos = 0x2
	// Bit mask of LSTIMER2_OVF_INT_RAW field.
	LEDC_INT_RAW_LSTIMER2_OVF_INT_RAW_Msk = 0x4
	// Bit LSTIMER2_OVF_INT_RAW.
	LEDC_INT_RAW_LSTIMER2_OVF_INT_RAW = 0x4
	// Position of LSTIMER3_OVF_INT_RAW field.
	LEDC_INT_RAW_LSTIMER3_OVF_INT_RAW_Pos = 0x3
	// Bit mask of LSTIMER3_OVF_INT_RAW field.
	LEDC_INT_RAW_LSTIMER3_OVF_INT_RAW_Msk = 0x8
	// Bit LSTIMER3_OVF_INT_RAW.
	LEDC_INT_RAW_LSTIMER3_OVF_INT_RAW = 0x8
	// Position of DUTY_CHNG_END_LSCH0_INT_RAW field.
	LEDC_INT_RAW_DUTY_CHNG_END_LSCH0_INT_RAW_Pos = 0x4
	// Bit mask of DUTY_CHNG_END_LSCH0_INT_RAW field.
	LEDC_INT_RAW_DUTY_CHNG_END_LSCH0_INT_RAW_Msk = 0x10
	// Bit DUTY_CHNG_END_LSCH0_INT_RAW.
	LEDC_INT_RAW_DUTY_CHNG_END_LSCH0_INT_RAW = 0x10
	// Position of DUTY_CHNG_END_LSCH1_INT_RAW field.
	LEDC_INT_RAW_DUTY_CHNG_END_LSCH1_INT_RAW_Pos = 0x5
	// Bit mask of DUTY_CHNG_END_LSCH1_INT_RAW field.
	LEDC_INT_RAW_DUTY_CHNG_END_LSCH1_INT_RAW_Msk = 0x20
	// Bit DUTY_CHNG_END_LSCH1_INT_RAW.
	LEDC_INT_RAW_DUTY_CHNG_END_LSCH1_INT_RAW = 0x20
	// Position of DUTY_CHNG_END_LSCH2_INT_RAW field.
	LEDC_INT_RAW_DUTY_CHNG_END_LSCH2_INT_RAW_Pos = 0x6
	// Bit mask of DUTY_CHNG_END_LSCH2_INT_RAW field.
	LEDC_INT_RAW_DUTY_CHNG_END_LSCH2_INT_RAW_Msk = 0x40
	// Bit DUTY_CHNG_END_LSCH2_INT_RAW.
	LEDC_INT_RAW_DUTY_CHNG_END_LSCH2_INT_RAW = 0x40
	// Position of DUTY_CHNG_END_LSCH3_INT_RAW field.
	LEDC_INT_RAW_DUTY_CHNG_END_LSCH3_INT_RAW_Pos = 0x7
	// Bit mask of DUTY_CHNG_END_LSCH3_INT_RAW field.
	LEDC_INT_RAW_DUTY_CHNG_END_LSCH3_INT_RAW_Msk = 0x80
	// Bit DUTY_CHNG_END_LSCH3_INT_RAW.
	LEDC_INT_RAW_DUTY_CHNG_END_LSCH3_INT_RAW = 0x80
	// Position of DUTY_CHNG_END_LSCH4_INT_RAW field.
	LEDC_INT_RAW_DUTY_CHNG_END_LSCH4_INT_RAW_Pos = 0x8
	// Bit mask of DUTY_CHNG_END_LSCH4_INT_RAW field.
	LEDC_INT_RAW_DUTY_CHNG_END_LSCH4_INT_RAW_Msk = 0x100
	// Bit DUTY_CHNG_END_LSCH4_INT_RAW.
	LEDC_INT_RAW_DUTY_CHNG_END_LSCH4_INT_RAW = 0x100
	// Position of DUTY_CHNG_END_LSCH5_INT_RAW field.
	LEDC_INT_RAW_DUTY_CHNG_END_LSCH5_INT_RAW_Pos = 0x9
	// Bit mask of DUTY_CHNG_END_LSCH5_INT_RAW field.
	LEDC_INT_RAW_DUTY_CHNG_END_LSCH5_INT_RAW_Msk = 0x200
	// Bit DUTY_CHNG_END_LSCH5_INT_RAW.
	LEDC_INT_RAW_DUTY_CHNG_END_LSCH5_INT_RAW = 0x200
	// Position of OVF_CNT_LSCH0_INT_RAW field.
	LEDC_INT_RAW_OVF_CNT_LSCH0_INT_RAW_Pos = 0xa
	// Bit mask of OVF_CNT_LSCH0_INT_RAW field.
	LEDC_INT_RAW_OVF_CNT_LSCH0_INT_RAW_Msk = 0x400
	// Bit OVF_CNT_LSCH0_INT_RAW.
	LEDC_INT_RAW_OVF_CNT_LSCH0_INT_RAW = 0x400
	// Position of OVF_CNT_LSCH1_INT_RAW field.
	LEDC_INT_RAW_OVF_CNT_LSCH1_INT_RAW_Pos = 0xb
	// Bit mask of OVF_CNT_LSCH1_INT_RAW field.
	LEDC_INT_RAW_OVF_CNT_LSCH1_INT_RAW_Msk = 0x800
	// Bit OVF_CNT_LSCH1_INT_RAW.
	LEDC_INT_RAW_OVF_CNT_LSCH1_INT_RAW = 0x800
	// Position of OVF_CNT_LSCH2_INT_RAW field.
	LEDC_INT_RAW_OVF_CNT_LSCH2_INT_RAW_Pos = 0xc
	// Bit mask of OVF_CNT_LSCH2_INT_RAW field.
	LEDC_INT_RAW_OVF_CNT_LSCH2_INT_RAW_Msk = 0x1000
	// Bit OVF_CNT_LSCH2_INT_RAW.
	LEDC_INT_RAW_OVF_CNT_LSCH2_INT_RAW = 0x1000
	// Position of OVF_CNT_LSCH3_INT_RAW field.
	LEDC_INT_RAW_OVF_CNT_LSCH3_INT_RAW_Pos = 0xd
	// Bit mask of OVF_CNT_LSCH3_INT_RAW field.
	LEDC_INT_RAW_OVF_CNT_LSCH3_INT_RAW_Msk = 0x2000
	// Bit OVF_CNT_LSCH3_INT_RAW.
	LEDC_INT_RAW_OVF_CNT_LSCH3_INT_RAW = 0x2000
	// Position of OVF_CNT_LSCH4_INT_RAW field.
	LEDC_INT_RAW_OVF_CNT_LSCH4_INT_RAW_Pos = 0xe
	// Bit mask of OVF_CNT_LSCH4_INT_RAW field.
	LEDC_INT_RAW_OVF_CNT_LSCH4_INT_RAW_Msk = 0x4000
	// Bit OVF_CNT_LSCH4_INT_RAW.
	LEDC_INT_RAW_OVF_CNT_LSCH4_INT_RAW = 0x4000
	// Position of OVF_CNT_LSCH5_INT_RAW field.
	LEDC_INT_RAW_OVF_CNT_LSCH5_INT_RAW_Pos = 0xf
	// Bit mask of OVF_CNT_LSCH5_INT_RAW field.
	LEDC_INT_RAW_OVF_CNT_LSCH5_INT_RAW_Msk = 0x8000
	// Bit OVF_CNT_LSCH5_INT_RAW.
	LEDC_INT_RAW_OVF_CNT_LSCH5_INT_RAW = 0x8000

	// INT_ST: LEDC_INT_ST.
	// Position of LSTIMER0_OVF_INT_ST field.
	LEDC_INT_ST_LSTIMER0_OVF_INT_ST_Pos = 0x0
	// Bit mask of LSTIMER0_OVF_INT_ST field.
	LEDC_INT_ST_LSTIMER0_OVF_INT_ST_Msk = 0x1
	// Bit LSTIMER0_OVF_INT_ST.
	LEDC_INT_ST_LSTIMER0_OVF_INT_ST = 0x1
	// Position of LSTIMER1_OVF_INT_ST field.
	LEDC_INT_ST_LSTIMER1_OVF_INT_ST_Pos = 0x1
	// Bit mask of LSTIMER1_OVF_INT_ST field.
	LEDC_INT_ST_LSTIMER1_OVF_INT_ST_Msk = 0x2
	// Bit LSTIMER1_OVF_INT_ST.
	LEDC_INT_ST_LSTIMER1_OVF_INT_ST = 0x2
	// Position of LSTIMER2_OVF_INT_ST field.
	LEDC_INT_ST_LSTIMER2_OVF_INT_ST_Pos = 0x2
	// Bit mask of LSTIMER2_OVF_INT_ST field.
	LEDC_INT_ST_LSTIMER2_OVF_INT_ST_Msk = 0x4
	// Bit LSTIMER2_OVF_INT_ST.
	LEDC_INT_ST_LSTIMER2_OVF_INT_ST = 0x4
	// Position of LSTIMER3_OVF_INT_ST field.
	LEDC_INT_ST_LSTIMER3_OVF_INT_ST_Pos = 0x3
	// Bit mask of LSTIMER3_OVF_INT_ST field.
	LEDC_INT_ST_LSTIMER3_OVF_INT_ST_Msk = 0x8
	// Bit LSTIMER3_OVF_INT_ST.
	LEDC_INT_ST_LSTIMER3_OVF_INT_ST = 0x8
	// Position of DUTY_CHNG_END_LSCH0_INT_ST field.
	LEDC_INT_ST_DUTY_CHNG_END_LSCH0_INT_ST_Pos = 0x4
	// Bit mask of DUTY_CHNG_END_LSCH0_INT_ST field.
	LEDC_INT_ST_DUTY_CHNG_END_LSCH0_INT_ST_Msk = 0x10
	// Bit DUTY_CHNG_END_LSCH0_INT_ST.
	LEDC_INT_ST_DUTY_CHNG_END_LSCH0_INT_ST = 0x10
	// Position of DUTY_CHNG_END_LSCH1_INT_ST field.
	LEDC_INT_ST_DUTY_CHNG_END_LSCH1_INT_ST_Pos = 0x5
	// Bit mask of DUTY_CHNG_END_LSCH1_INT_ST field.
	LEDC_INT_ST_DUTY_CHNG_END_LSCH1_INT_ST_Msk = 0x20
	// Bit DUTY_CHNG_END_LSCH1_INT_ST.
	LEDC_INT_ST_DUTY_CHNG_END_LSCH1_INT_ST = 0x20
	// Position of DUTY_CHNG_END_LSCH2_INT_ST field.
	LEDC_INT_ST_DUTY_CHNG_END_LSCH2_INT_ST_Pos = 0x6
	// Bit mask of DUTY_CHNG_END_LSCH2_INT_ST field.
	LEDC_INT_ST_DUTY_CHNG_END_LSCH2_INT_ST_Msk = 0x40
	// Bit DUTY_CHNG_END_LSCH2_INT_ST.
	LEDC_INT_ST_DUTY_CHNG_END_LSCH2_INT_ST = 0x40
	// Position of DUTY_CHNG_END_LSCH3_INT_ST field.
	LEDC_INT_ST_DUTY_CHNG_END_LSCH3_INT_ST_Pos = 0x7
	// Bit mask of DUTY_CHNG_END_LSCH3_INT_ST field.
	LEDC_INT_ST_DUTY_CHNG_END_LSCH3_INT_ST_Msk = 0x80
	// Bit DUTY_CHNG_END_LSCH3_INT_ST.
	LEDC_INT_ST_DUTY_CHNG_END_LSCH3_INT_ST = 0x80
	// Position of DUTY_CHNG_END_LSCH4_INT_ST field.
	LEDC_INT_ST_DUTY_CHNG_END_LSCH4_INT_ST_Pos = 0x8
	// Bit mask of DUTY_CHNG_END_LSCH4_INT_ST field.
	LEDC_INT_ST_DUTY_CHNG_END_LSCH4_INT_ST_Msk = 0x100
	// Bit DUTY_CHNG_END_LSCH4_INT_ST.
	LEDC_INT_ST_DUTY_CHNG_END_LSCH4_INT_ST = 0x100
	// Position of DUTY_CHNG_END_LSCH5_INT_ST field.
	LEDC_INT_ST_DUTY_CHNG_END_LSCH5_INT_ST_Pos = 0x9
	// Bit mask of DUTY_CHNG_END_LSCH5_INT_ST field.
	LEDC_INT_ST_DUTY_CHNG_END_LSCH5_INT_ST_Msk = 0x200
	// Bit DUTY_CHNG_END_LSCH5_INT_ST.
	LEDC_INT_ST_DUTY_CHNG_END_LSCH5_INT_ST = 0x200
	// Position of OVF_CNT_LSCH0_INT_ST field.
	LEDC_INT_ST_OVF_CNT_LSCH0_INT_ST_Pos = 0xa
	// Bit mask of OVF_CNT_LSCH0_INT_ST field.
	LEDC_INT_ST_OVF_CNT_LSCH0_INT_ST_Msk = 0x400
	// Bit OVF_CNT_LSCH0_INT_ST.
	LEDC_INT_ST_OVF_CNT_LSCH0_INT_ST = 0x400
	// Position of OVF_CNT_LSCH1_INT_ST field.
	LEDC_INT_ST_OVF_CNT_LSCH1_INT_ST_Pos = 0xb
	// Bit mask of OVF_CNT_LSCH1_INT_ST field.
	LEDC_INT_ST_OVF_CNT_LSCH1_INT_ST_Msk = 0x800
	// Bit OVF_CNT_LSCH1_INT_ST.
	LEDC_INT_ST_OVF_CNT_LSCH1_INT_ST = 0x800
	// Position of OVF_CNT_LSCH2_INT_ST field.
	LEDC_INT_ST_OVF_CNT_LSCH2_INT_ST_Pos = 0xc
	// Bit mask of OVF_CNT_LSCH2_INT_ST field.
	LEDC_INT_ST_OVF_CNT_LSCH2_INT_ST_Msk = 0x1000
	// Bit OVF_CNT_LSCH2_INT_ST.
	LEDC_INT_ST_OVF_CNT_LSCH2_INT_ST = 0x1000
	// Position of OVF_CNT_LSCH3_INT_ST field.
	LEDC_INT_ST_OVF_CNT_LSCH3_INT_ST_Pos = 0xd
	// Bit mask of OVF_CNT_LSCH3_INT_ST field.
	LEDC_INT_ST_OVF_CNT_LSCH3_INT_ST_Msk = 0x2000
	// Bit OVF_CNT_LSCH3_INT_ST.
	LEDC_INT_ST_OVF_CNT_LSCH3_INT_ST = 0x2000
	// Position of OVF_CNT_LSCH4_INT_ST field.
	LEDC_INT_ST_OVF_CNT_LSCH4_INT_ST_Pos = 0xe
	// Bit mask of OVF_CNT_LSCH4_INT_ST field.
	LEDC_INT_ST_OVF_CNT_LSCH4_INT_ST_Msk = 0x4000
	// Bit OVF_CNT_LSCH4_INT_ST.
	LEDC_INT_ST_OVF_CNT_LSCH4_INT_ST = 0x4000
	// Position of OVF_CNT_LSCH5_INT_ST field.
	LEDC_INT_ST_OVF_CNT_LSCH5_INT_ST_Pos = 0xf
	// Bit mask of OVF_CNT_LSCH5_INT_ST field.
	LEDC_INT_ST_OVF_CNT_LSCH5_INT_ST_Msk = 0x8000
	// Bit OVF_CNT_LSCH5_INT_ST.
	LEDC_INT_ST_OVF_CNT_LSCH5_INT_ST = 0x8000

	// INT_ENA: LEDC_INT_ENA.
	// Position of LSTIMER0_OVF_INT_ENA field.
	LEDC_INT_ENA_LSTIMER0_OVF_INT_ENA_Pos = 0x0
	// Bit mask of LSTIMER0_OVF_INT_ENA field.
	LEDC_INT_ENA_LSTIMER0_OVF_INT_ENA_Msk = 0x1
	// Bit LSTIMER0_OVF_INT_ENA.
	LEDC_INT_ENA_LSTIMER0_OVF_INT_ENA = 0x1
	// Position of LSTIMER1_OVF_INT_ENA field.
	LEDC_INT_ENA_LSTIMER1_OVF_INT_ENA_Pos = 0x1
	// Bit mask of LSTIMER1_OVF_INT_ENA field.
	LEDC_INT_ENA_LSTIMER1_OVF_INT_ENA_Msk = 0x2
	// Bit LSTIMER1_OVF_INT_ENA.
	LEDC_INT_ENA_LSTIMER1_OVF_INT_ENA = 0x2
	// Position of LSTIMER2_OVF_INT_ENA field.
	LEDC_INT_ENA_LSTIMER2_OVF_INT_ENA_Pos = 0x2
	// Bit mask of LSTIMER2_OVF_INT_ENA field.
	LEDC_INT_ENA_LSTIMER2_OVF_INT_ENA_Msk = 0x4
	// Bit LSTIMER2_OVF_INT_ENA.
	LEDC_INT_ENA_LSTIMER2_OVF_INT_ENA = 0x4
	// Position of LSTIMER3_OVF_INT_ENA field.
	LEDC_INT_ENA_LSTIMER3_OVF_INT_ENA_Pos = 0x3
	// Bit mask of LSTIMER3_OVF_INT_ENA field.
	LEDC_INT_ENA_LSTIMER3_OVF_INT_ENA_Msk = 0x8
	// Bit LSTIMER3_OVF_INT_ENA.
	LEDC_INT_ENA_LSTIMER3_OVF_INT_ENA = 0x8
	// Position of DUTY_CHNG_END_LSCH0_INT_ENA field.
	LEDC_INT_ENA_DUTY_CHNG_END_LSCH0_INT_ENA_Pos = 0x4
	// Bit mask of DUTY_CHNG_END_LSCH0_INT_ENA field.
	LEDC_INT_ENA_DUTY_CHNG_END_LSCH0_INT_ENA_Msk = 0x10
	// Bit DUTY_CHNG_END_LSCH0_INT_ENA.
	LEDC_INT_ENA_DUTY_CHNG_END_LSCH0_INT_ENA = 0x10
	// Position of DUTY_CHNG_END_LSCH1_INT_ENA field.
	LEDC_INT_ENA_DUTY_CHNG_END_LSCH1_INT_ENA_Pos = 0x5
	// Bit mask of DUTY_CHNG_END_LSCH1_INT_ENA field.
	LEDC_INT_ENA_DUTY_CHNG_END_LSCH1_INT_ENA_Msk = 0x20
	// Bit DUTY_CHNG_END_LSCH1_INT_ENA.
	LEDC_INT_ENA_DUTY_CHNG_END_LSCH1_INT_ENA = 0x20
	// Position of DUTY_CHNG_END_LSCH2_INT_ENA field.
	LEDC_INT_ENA_DUTY_CHNG_END_LSCH2_INT_ENA_Pos = 0x6
	// Bit mask of DUTY_CHNG_END_LSCH2_INT_ENA field.
	LEDC_INT_ENA_DUTY_CHNG_END_LSCH2_INT_ENA_Msk = 0x40
	// Bit DUTY_CHNG_END_LSCH2_INT_ENA.
	LEDC_INT_ENA_DUTY_CHNG_END_LSCH2_INT_ENA = 0x40
	// Position of DUTY_CHNG_END_LSCH3_INT_ENA field.
	LEDC_INT_ENA_DUTY_CHNG_END_LSCH3_INT_ENA_Pos = 0x7
	// Bit mask of DUTY_CHNG_END_LSCH3_INT_ENA field.
	LEDC_INT_ENA_DUTY_CHNG_END_LSCH3_INT_ENA_Msk = 0x80
	// Bit DUTY_CHNG_END_LSCH3_INT_ENA.
	LEDC_INT_ENA_DUTY_CHNG_END_LSCH3_INT_ENA = 0x80
	// Position of DUTY_CHNG_END_LSCH4_INT_ENA field.
	LEDC_INT_ENA_DUTY_CHNG_END_LSCH4_INT_ENA_Pos = 0x8
	// Bit mask of DUTY_CHNG_END_LSCH4_INT_ENA field.
	LEDC_INT_ENA_DUTY_CHNG_END_LSCH4_INT_ENA_Msk = 0x100
	// Bit DUTY_CHNG_END_LSCH4_INT_ENA.
	LEDC_INT_ENA_DUTY_CHNG_END_LSCH4_INT_ENA = 0x100
	// Position of DUTY_CHNG_END_LSCH5_INT_ENA field.
	LEDC_INT_ENA_DUTY_CHNG_END_LSCH5_INT_ENA_Pos = 0x9
	// Bit mask of DUTY_CHNG_END_LSCH5_INT_ENA field.
	LEDC_INT_ENA_DUTY_CHNG_END_LSCH5_INT_ENA_Msk = 0x200
	// Bit DUTY_CHNG_END_LSCH5_INT_ENA.
	LEDC_INT_ENA_DUTY_CHNG_END_LSCH5_INT_ENA = 0x200
	// Position of OVF_CNT_LSCH0_INT_ENA field.
	LEDC_INT_ENA_OVF_CNT_LSCH0_INT_ENA_Pos = 0xa
	// Bit mask of OVF_CNT_LSCH0_INT_ENA field.
	LEDC_INT_ENA_OVF_CNT_LSCH0_INT_ENA_Msk = 0x400
	// Bit OVF_CNT_LSCH0_INT_ENA.
	LEDC_INT_ENA_OVF_CNT_LSCH0_INT_ENA = 0x400
	// Position of OVF_CNT_LSCH1_INT_ENA field.
	LEDC_INT_ENA_OVF_CNT_LSCH1_INT_ENA_Pos = 0xb
	// Bit mask of OVF_CNT_LSCH1_INT_ENA field.
	LEDC_INT_ENA_OVF_CNT_LSCH1_INT_ENA_Msk = 0x800
	// Bit OVF_CNT_LSCH1_INT_ENA.
	LEDC_INT_ENA_OVF_CNT_LSCH1_INT_ENA = 0x800
	// Position of OVF_CNT_LSCH2_INT_ENA field.
	LEDC_INT_ENA_OVF_CNT_LSCH2_INT_ENA_Pos = 0xc
	// Bit mask of OVF_CNT_LSCH2_INT_ENA field.
	LEDC_INT_ENA_OVF_CNT_LSCH2_INT_ENA_Msk = 0x1000
	// Bit OVF_CNT_LSCH2_INT_ENA.
	LEDC_INT_ENA_OVF_CNT_LSCH2_INT_ENA = 0x1000
	// Position of OVF_CNT_LSCH3_INT_ENA field.
	LEDC_INT_ENA_OVF_CNT_LSCH3_INT_ENA_Pos = 0xd
	// Bit mask of OVF_CNT_LSCH3_INT_ENA field.
	LEDC_INT_ENA_OVF_CNT_LSCH3_INT_ENA_Msk = 0x2000
	// Bit OVF_CNT_LSCH3_INT_ENA.
	LEDC_INT_ENA_OVF_CNT_LSCH3_INT_ENA = 0x2000
	// Position of OVF_CNT_LSCH4_INT_ENA field.
	LEDC_INT_ENA_OVF_CNT_LSCH4_INT_ENA_Pos = 0xe
	// Bit mask of OVF_CNT_LSCH4_INT_ENA field.
	LEDC_INT_ENA_OVF_CNT_LSCH4_INT_ENA_Msk = 0x4000
	// Bit OVF_CNT_LSCH4_INT_ENA.
	LEDC_INT_ENA_OVF_CNT_LSCH4_INT_ENA = 0x4000
	// Position of OVF_CNT_LSCH5_INT_ENA field.
	LEDC_INT_ENA_OVF_CNT_LSCH5_INT_ENA_Pos = 0xf
	// Bit mask of OVF_CNT_LSCH5_INT_ENA field.
	LEDC_INT_ENA_OVF_CNT_LSCH5_INT_ENA_Msk = 0x8000
	// Bit OVF_CNT_LSCH5_INT_ENA.
	LEDC_INT_ENA_OVF_CNT_LSCH5_INT_ENA = 0x8000

	// INT_CLR: LEDC_INT_CLR.
	// Position of LSTIMER0_OVF_INT_CLR field.
	LEDC_INT_CLR_LSTIMER0_OVF_INT_CLR_Pos = 0x0
	// Bit mask of LSTIMER0_OVF_INT_CLR field.
	LEDC_INT_CLR_LSTIMER0_OVF_INT_CLR_Msk = 0x1
	// Bit LSTIMER0_OVF_INT_CLR.
	LEDC_INT_CLR_LSTIMER0_OVF_INT_CLR = 0x1
	// Position of LSTIMER1_OVF_INT_CLR field.
	LEDC_INT_CLR_LSTIMER1_OVF_INT_CLR_Pos = 0x1
	// Bit mask of LSTIMER1_OVF_INT_CLR field.
	LEDC_INT_CLR_LSTIMER1_OVF_INT_CLR_Msk = 0x2
	// Bit LSTIMER1_OVF_INT_CLR.
	LEDC_INT_CLR_LSTIMER1_OVF_INT_CLR = 0x2
	// Position of LSTIMER2_OVF_INT_CLR field.
	LEDC_INT_CLR_LSTIMER2_OVF_INT_CLR_Pos = 0x2
	// Bit mask of LSTIMER2_OVF_INT_CLR field.
	LEDC_INT_CLR_LSTIMER2_OVF_INT_CLR_Msk = 0x4
	// Bit LSTIMER2_OVF_INT_CLR.
	LEDC_INT_CLR_LSTIMER2_OVF_INT_CLR = 0x4
	// Position of LSTIMER3_OVF_INT_CLR field.
	LEDC_INT_CLR_LSTIMER3_OVF_INT_CLR_Pos = 0x3
	// Bit mask of LSTIMER3_OVF_INT_CLR field.
	LEDC_INT_CLR_LSTIMER3_OVF_INT_CLR_Msk = 0x8
	// Bit LSTIMER3_OVF_INT_CLR.
	LEDC_INT_CLR_LSTIMER3_OVF_INT_CLR = 0x8
	// Position of DUTY_CHNG_END_LSCH0_INT_CLR field.
	LEDC_INT_CLR_DUTY_CHNG_END_LSCH0_INT_CLR_Pos = 0x4
	// Bit mask of DUTY_CHNG_END_LSCH0_INT_CLR field.
	LEDC_INT_CLR_DUTY_CHNG_END_LSCH0_INT_CLR_Msk = 0x10
	// Bit DUTY_CHNG_END_LSCH0_INT_CLR.
	LEDC_INT_CLR_DUTY_CHNG_END_LSCH0_INT_CLR = 0x10
	// Position of DUTY_CHNG_END_LSCH1_INT_CLR field.
	LEDC_INT_CLR_DUTY_CHNG_END_LSCH1_INT_CLR_Pos = 0x5
	// Bit mask of DUTY_CHNG_END_LSCH1_INT_CLR field.
	LEDC_INT_CLR_DUTY_CHNG_END_LSCH1_INT_CLR_Msk = 0x20
	// Bit DUTY_CHNG_END_LSCH1_INT_CLR.
	LEDC_INT_CLR_DUTY_CHNG_END_LSCH1_INT_CLR = 0x20
	// Position of DUTY_CHNG_END_LSCH2_INT_CLR field.
	LEDC_INT_CLR_DUTY_CHNG_END_LSCH2_INT_CLR_Pos = 0x6
	// Bit mask of DUTY_CHNG_END_LSCH2_INT_CLR field.
	LEDC_INT_CLR_DUTY_CHNG_END_LSCH2_INT_CLR_Msk = 0x40
	// Bit DUTY_CHNG_END_LSCH2_INT_CLR.
	LEDC_INT_CLR_DUTY_CHNG_END_LSCH2_INT_CLR = 0x40
	// Position of DUTY_CHNG_END_LSCH3_INT_CLR field.
	LEDC_INT_CLR_DUTY_CHNG_END_LSCH3_INT_CLR_Pos = 0x7
	// Bit mask of DUTY_CHNG_END_LSCH3_INT_CLR field.
	LEDC_INT_CLR_DUTY_CHNG_END_LSCH3_INT_CLR_Msk = 0x80
	// Bit DUTY_CHNG_END_LSCH3_INT_CLR.
	LEDC_INT_CLR_DUTY_CHNG_END_LSCH3_INT_CLR = 0x80
	// Position of DUTY_CHNG_END_LSCH4_INT_CLR field.
	LEDC_INT_CLR_DUTY_CHNG_END_LSCH4_INT_CLR_Pos = 0x8
	// Bit mask of DUTY_CHNG_END_LSCH4_INT_CLR field.
	LEDC_INT_CLR_DUTY_CHNG_END_LSCH4_INT_CLR_Msk = 0x100
	// Bit DUTY_CHNG_END_LSCH4_INT_CLR.
	LEDC_INT_CLR_DUTY_CHNG_END_LSCH4_INT_CLR = 0x100
	// Position of DUTY_CHNG_END_LSCH5_INT_CLR field.
	LEDC_INT_CLR_DUTY_CHNG_END_LSCH5_INT_CLR_Pos = 0x9
	// Bit mask of DUTY_CHNG_END_LSCH5_INT_CLR field.
	LEDC_INT_CLR_DUTY_CHNG_END_LSCH5_INT_CLR_Msk = 0x200
	// Bit DUTY_CHNG_END_LSCH5_INT_CLR.
	LEDC_INT_CLR_DUTY_CHNG_END_LSCH5_INT_CLR = 0x200
	// Position of OVF_CNT_LSCH0_INT_CLR field.
	LEDC_INT_CLR_OVF_CNT_LSCH0_INT_CLR_Pos = 0xa
	// Bit mask of OVF_CNT_LSCH0_INT_CLR field.
	LEDC_INT_CLR_OVF_CNT_LSCH0_INT_CLR_Msk = 0x400
	// Bit OVF_CNT_LSCH0_INT_CLR.
	LEDC_INT_CLR_OVF_CNT_LSCH0_INT_CLR = 0x400
	// Position of OVF_CNT_LSCH1_INT_CLR field.
	LEDC_INT_CLR_OVF_CNT_LSCH1_INT_CLR_Pos = 0xb
	// Bit mask of OVF_CNT_LSCH1_INT_CLR field.
	LEDC_INT_CLR_OVF_CNT_LSCH1_INT_CLR_Msk = 0x800
	// Bit OVF_CNT_LSCH1_INT_CLR.
	LEDC_INT_CLR_OVF_CNT_LSCH1_INT_CLR = 0x800
	// Position of OVF_CNT_LSCH2_INT_CLR field.
	LEDC_INT_CLR_OVF_CNT_LSCH2_INT_CLR_Pos = 0xc
	// Bit mask of OVF_CNT_LSCH2_INT_CLR field.
	LEDC_INT_CLR_OVF_CNT_LSCH2_INT_CLR_Msk = 0x1000
	// Bit OVF_CNT_LSCH2_INT_CLR.
	LEDC_INT_CLR_OVF_CNT_LSCH2_INT_CLR = 0x1000
	// Position of OVF_CNT_LSCH3_INT_CLR field.
	LEDC_INT_CLR_OVF_CNT_LSCH3_INT_CLR_Pos = 0xd
	// Bit mask of OVF_CNT_LSCH3_INT_CLR field.
	LEDC_INT_CLR_OVF_CNT_LSCH3_INT_CLR_Msk = 0x2000
	// Bit OVF_CNT_LSCH3_INT_CLR.
	LEDC_INT_CLR_OVF_CNT_LSCH3_INT_CLR = 0x2000
	// Position of OVF_CNT_LSCH4_INT_CLR field.
	LEDC_INT_CLR_OVF_CNT_LSCH4_INT_CLR_Pos = 0xe
	// Bit mask of OVF_CNT_LSCH4_INT_CLR field.
	LEDC_INT_CLR_OVF_CNT_LSCH4_INT_CLR_Msk = 0x4000
	// Bit OVF_CNT_LSCH4_INT_CLR.
	LEDC_INT_CLR_OVF_CNT_LSCH4_INT_CLR = 0x4000
	// Position of OVF_CNT_LSCH5_INT_CLR field.
	LEDC_INT_CLR_OVF_CNT_LSCH5_INT_CLR_Pos = 0xf
	// Bit mask of OVF_CNT_LSCH5_INT_CLR field.
	LEDC_INT_CLR_OVF_CNT_LSCH5_INT_CLR_Msk = 0x8000
	// Bit OVF_CNT_LSCH5_INT_CLR.
	LEDC_INT_CLR_OVF_CNT_LSCH5_INT_CLR = 0x8000

	// CONF: LEDC_CONF.
	// Position of APB_CLK_SEL field.
	LEDC_CONF_APB_CLK_SEL_Pos = 0x0
	// Bit mask of APB_CLK_SEL field.
	LEDC_CONF_APB_CLK_SEL_Msk = 0x3
	// Position of CLK_EN field.
	LEDC_CONF_CLK_EN_Pos = 0x1f
	// Bit mask of CLK_EN field.
	LEDC_CONF_CLK_EN_Msk = 0x80000000
	// Bit CLK_EN.
	LEDC_CONF_CLK_EN = 0x80000000

	// DATE: LEDC_DATE.
	// Position of LEDC_DATE field.
	LEDC_DATE_LEDC_DATE_Pos = 0x0
	// Bit mask of LEDC_DATE field.
	LEDC_DATE_LEDC_DATE_Msk = 0xffffffff
)

// Constants for RMT: Peripheral RMT
const (
	// CH0DATA: RMT_CH0DATA_REG.
	// Position of CH0DATA field.
	RMT_CH0DATA_CH0DATA_Pos = 0x0
	// Bit mask of CH0DATA field.
	RMT_CH0DATA_CH0DATA_Msk = 0xffffffff

	// CH1DATA: RMT_CH1DATA_REG.
	// Position of CH1DATA field.
	RMT_CH1DATA_CH1DATA_Pos = 0x0
	// Bit mask of CH1DATA field.
	RMT_CH1DATA_CH1DATA_Msk = 0xffffffff

	// CH2DATA: RMT_CH2DATA_REG.
	// Position of CH2DATA field.
	RMT_CH2DATA_CH2DATA_Pos = 0x0
	// Bit mask of CH2DATA field.
	RMT_CH2DATA_CH2DATA_Msk = 0xffffffff

	// CH3DATA: RMT_CH3DATA_REG.
	// Position of CH3DATA field.
	RMT_CH3DATA_CH3DATA_Pos = 0x0
	// Bit mask of CH3DATA field.
	RMT_CH3DATA_CH3DATA_Msk = 0xffffffff

	// CH0CONF0: RMT_CH0CONF0_REG.
	// Position of TX_START_CH0 field.
	RMT_CH0CONF0_TX_START_CH0_Pos = 0x0
	// Bit mask of TX_START_CH0 field.
	RMT_CH0CONF0_TX_START_CH0_Msk = 0x1
	// Bit TX_START_CH0.
	RMT_CH0CONF0_TX_START_CH0 = 0x1
	// Position of MEM_RD_RST_CH0 field.
	RMT_CH0CONF0_MEM_RD_RST_CH0_Pos = 0x1
	// Bit mask of MEM_RD_RST_CH0 field.
	RMT_CH0CONF0_MEM_RD_RST_CH0_Msk = 0x2
	// Bit MEM_RD_RST_CH0.
	RMT_CH0CONF0_MEM_RD_RST_CH0 = 0x2
	// Position of APB_MEM_RST_CH0 field.
	RMT_CH0CONF0_APB_MEM_RST_CH0_Pos = 0x2
	// Bit mask of APB_MEM_RST_CH0 field.
	RMT_CH0CONF0_APB_MEM_RST_CH0_Msk = 0x4
	// Bit APB_MEM_RST_CH0.
	RMT_CH0CONF0_APB_MEM_RST_CH0 = 0x4
	// Position of TX_CONTI_MODE_CH0 field.
	RMT_CH0CONF0_TX_CONTI_MODE_CH0_Pos = 0x3
	// Bit mask of TX_CONTI_MODE_CH0 field.
	RMT_CH0CONF0_TX_CONTI_MODE_CH0_Msk = 0x8
	// Bit TX_CONTI_MODE_CH0.
	RMT_CH0CONF0_TX_CONTI_MODE_CH0 = 0x8
	// Position of MEM_TX_WRAP_EN_CH0 field.
	RMT_CH0CONF0_MEM_TX_WRAP_EN_CH0_Pos = 0x4
	// Bit mask of MEM_TX_WRAP_EN_CH0 field.
	RMT_CH0CONF0_MEM_TX_WRAP_EN_CH0_Msk = 0x10
	// Bit MEM_TX_WRAP_EN_CH0.
	RMT_CH0CONF0_MEM_TX_WRAP_EN_CH0 = 0x10
	// Position of IDLE_OUT_LV_CH0 field.
	RMT_CH0CONF0_IDLE_OUT_LV_CH0_Pos = 0x5
	// Bit mask of IDLE_OUT_LV_CH0 field.
	RMT_CH0CONF0_IDLE_OUT_LV_CH0_Msk = 0x20
	// Bit IDLE_OUT_LV_CH0.
	RMT_CH0CONF0_IDLE_OUT_LV_CH0 = 0x20
	// Position of IDLE_OUT_EN_CH0 field.
	RMT_CH0CONF0_IDLE_OUT_EN_CH0_Pos = 0x6
	// Bit mask of IDLE_OUT_EN_CH0 field.
	RMT_CH0CONF0_IDLE_OUT_EN_CH0_Msk = 0x40
	// Bit IDLE_OUT_EN_CH0.
	RMT_CH0CONF0_IDLE_OUT_EN_CH0 = 0x40
	// Position of TX_STOP_CH0 field.
	RMT_CH0CONF0_TX_STOP_CH0_Pos = 0x7
	// Bit mask of TX_STOP_CH0 field.
	RMT_CH0CONF0_TX_STOP_CH0_Msk = 0x80
	// Bit TX_STOP_CH0.
	RMT_CH0CONF0_TX_STOP_CH0 = 0x80
	// Position of DIV_CNT_CH0 field.
	RMT_CH0CONF0_DIV_CNT_CH0_Pos = 0x8
	// Bit mask of DIV_CNT_CH0 field.
	RMT_CH0CONF0_DIV_CNT_CH0_Msk = 0xff00
	// Position of MEM_SIZE_CH0 field.
	RMT_CH0CONF0_MEM_SIZE_CH0_Pos = 0x10
	// Bit mask of MEM_SIZE_CH0 field.
	RMT_CH0CONF0_MEM_SIZE_CH0_Msk = 0x70000
	// Position of CARRIER_EFF_EN_CH0 field.
	RMT_CH0CONF0_CARRIER_EFF_EN_CH0_Pos = 0x14
	// Bit mask of CARRIER_EFF_EN_CH0 field.
	RMT_CH0CONF0_CARRIER_EFF_EN_CH0_Msk = 0x100000
	// Bit CARRIER_EFF_EN_CH0.
	RMT_CH0CONF0_CARRIER_EFF_EN_CH0 = 0x100000
	// Position of CARRIER_EN_CH0 field.
	RMT_CH0CONF0_CARRIER_EN_CH0_Pos = 0x15
	// Bit mask of CARRIER_EN_CH0 field.
	RMT_CH0CONF0_CARRIER_EN_CH0_Msk = 0x200000
	// Bit CARRIER_EN_CH0.
	RMT_CH0CONF0_CARRIER_EN_CH0 = 0x200000
	// Position of CARRIER_OUT_LV_CH0 field.
	RMT_CH0CONF0_CARRIER_OUT_LV_CH0_Pos = 0x16
	// Bit mask of CARRIER_OUT_LV_CH0 field.
	RMT_CH0CONF0_CARRIER_OUT_LV_CH0_Msk = 0x400000
	// Bit CARRIER_OUT_LV_CH0.
	RMT_CH0CONF0_CARRIER_OUT_LV_CH0 = 0x400000
	// Position of AFIFO_RST_CH0 field.
	RMT_CH0CONF0_AFIFO_RST_CH0_Pos = 0x17
	// Bit mask of AFIFO_RST_CH0 field.
	RMT_CH0CONF0_AFIFO_RST_CH0_Msk = 0x800000
	// Bit AFIFO_RST_CH0.
	RMT_CH0CONF0_AFIFO_RST_CH0 = 0x800000
	// Position of REG_CONF_UPDATE_CH0 field.
	RMT_CH0CONF0_REG_CONF_UPDATE_CH0_Pos = 0x18
	// Bit mask of REG_CONF_UPDATE_CH0 field.
	RMT_CH0CONF0_REG_CONF_UPDATE_CH0_Msk = 0x1000000
	// Bit REG_CONF_UPDATE_CH0.
	RMT_CH0CONF0_REG_CONF_UPDATE_CH0 = 0x1000000

	// CH1CONF0: RMT_CH1CONF0_REG.
	// Position of TX_START_CH1 field.
	RMT_CH1CONF0_TX_START_CH1_Pos = 0x0
	// Bit mask of TX_START_CH1 field.
	RMT_CH1CONF0_TX_START_CH1_Msk = 0x1
	// Bit TX_START_CH1.
	RMT_CH1CONF0_TX_START_CH1 = 0x1
	// Position of MEM_RD_RST_CH1 field.
	RMT_CH1CONF0_MEM_RD_RST_CH1_Pos = 0x1
	// Bit mask of MEM_RD_RST_CH1 field.
	RMT_CH1CONF0_MEM_RD_RST_CH1_Msk = 0x2
	// Bit MEM_RD_RST_CH1.
	RMT_CH1CONF0_MEM_RD_RST_CH1 = 0x2
	// Position of APB_MEM_RST_CH1 field.
	RMT_CH1CONF0_APB_MEM_RST_CH1_Pos = 0x2
	// Bit mask of APB_MEM_RST_CH1 field.
	RMT_CH1CONF0_APB_MEM_RST_CH1_Msk = 0x4
	// Bit APB_MEM_RST_CH1.
	RMT_CH1CONF0_APB_MEM_RST_CH1 = 0x4
	// Position of TX_CONTI_MODE_CH1 field.
	RMT_CH1CONF0_TX_CONTI_MODE_CH1_Pos = 0x3
	// Bit mask of TX_CONTI_MODE_CH1 field.
	RMT_CH1CONF0_TX_CONTI_MODE_CH1_Msk = 0x8
	// Bit TX_CONTI_MODE_CH1.
	RMT_CH1CONF0_TX_CONTI_MODE_CH1 = 0x8
	// Position of MEM_TX_WRAP_EN_CH1 field.
	RMT_CH1CONF0_MEM_TX_WRAP_EN_CH1_Pos = 0x4
	// Bit mask of MEM_TX_WRAP_EN_CH1 field.
	RMT_CH1CONF0_MEM_TX_WRAP_EN_CH1_Msk = 0x10
	// Bit MEM_TX_WRAP_EN_CH1.
	RMT_CH1CONF0_MEM_TX_WRAP_EN_CH1 = 0x10
	// Position of IDLE_OUT_LV_CH1 field.
	RMT_CH1CONF0_IDLE_OUT_LV_CH1_Pos = 0x5
	// Bit mask of IDLE_OUT_LV_CH1 field.
	RMT_CH1CONF0_IDLE_OUT_LV_CH1_Msk = 0x20
	// Bit IDLE_OUT_LV_CH1.
	RMT_CH1CONF0_IDLE_OUT_LV_CH1 = 0x20
	// Position of IDLE_OUT_EN_CH1 field.
	RMT_CH1CONF0_IDLE_OUT_EN_CH1_Pos = 0x6
	// Bit mask of IDLE_OUT_EN_CH1 field.
	RMT_CH1CONF0_IDLE_OUT_EN_CH1_Msk = 0x40
	// Bit IDLE_OUT_EN_CH1.
	RMT_CH1CONF0_IDLE_OUT_EN_CH1 = 0x40
	// Position of TX_STOP_CH1 field.
	RMT_CH1CONF0_TX_STOP_CH1_Pos = 0x7
	// Bit mask of TX_STOP_CH1 field.
	RMT_CH1CONF0_TX_STOP_CH1_Msk = 0x80
	// Bit TX_STOP_CH1.
	RMT_CH1CONF0_TX_STOP_CH1 = 0x80
	// Position of DIV_CNT_CH1 field.
	RMT_CH1CONF0_DIV_CNT_CH1_Pos = 0x8
	// Bit mask of DIV_CNT_CH1 field.
	RMT_CH1CONF0_DIV_CNT_CH1_Msk = 0xff00
	// Position of MEM_SIZE_CH1 field.
	RMT_CH1CONF0_MEM_SIZE_CH1_Pos = 0x10
	// Bit mask of MEM_SIZE_CH1 field.
	RMT_CH1CONF0_MEM_SIZE_CH1_Msk = 0x70000
	// Position of CARRIER_EFF_EN_CH1 field.
	RMT_CH1CONF0_CARRIER_EFF_EN_CH1_Pos = 0x14
	// Bit mask of CARRIER_EFF_EN_CH1 field.
	RMT_CH1CONF0_CARRIER_EFF_EN_CH1_Msk = 0x100000
	// Bit CARRIER_EFF_EN_CH1.
	RMT_CH1CONF0_CARRIER_EFF_EN_CH1 = 0x100000
	// Position of CARRIER_EN_CH1 field.
	RMT_CH1CONF0_CARRIER_EN_CH1_Pos = 0x15
	// Bit mask of CARRIER_EN_CH1 field.
	RMT_CH1CONF0_CARRIER_EN_CH1_Msk = 0x200000
	// Bit CARRIER_EN_CH1.
	RMT_CH1CONF0_CARRIER_EN_CH1 = 0x200000
	// Position of CARRIER_OUT_LV_CH1 field.
	RMT_CH1CONF0_CARRIER_OUT_LV_CH1_Pos = 0x16
	// Bit mask of CARRIER_OUT_LV_CH1 field.
	RMT_CH1CONF0_CARRIER_OUT_LV_CH1_Msk = 0x400000
	// Bit CARRIER_OUT_LV_CH1.
	RMT_CH1CONF0_CARRIER_OUT_LV_CH1 = 0x400000
	// Position of AFIFO_RST_CH1 field.
	RMT_CH1CONF0_AFIFO_RST_CH1_Pos = 0x17
	// Bit mask of AFIFO_RST_CH1 field.
	RMT_CH1CONF0_AFIFO_RST_CH1_Msk = 0x800000
	// Bit AFIFO_RST_CH1.
	RMT_CH1CONF0_AFIFO_RST_CH1 = 0x800000
	// Position of CONF_UPDATE_CH1 field.
	RMT_CH1CONF0_CONF_UPDATE_CH1_Pos = 0x18
	// Bit mask of CONF_UPDATE_CH1 field.
	RMT_CH1CONF0_CONF_UPDATE_CH1_Msk = 0x1000000
	// Bit CONF_UPDATE_CH1.
	RMT_CH1CONF0_CONF_UPDATE_CH1 = 0x1000000

	// CH2CONF0: RMT_CH2CONF0_REG.
	// Position of DIV_CNT_CH2 field.
	RMT_CH2CONF0_DIV_CNT_CH2_Pos = 0x0
	// Bit mask of DIV_CNT_CH2 field.
	RMT_CH2CONF0_DIV_CNT_CH2_Msk = 0xff
	// Position of IDLE_THRES_CH2 field.
	RMT_CH2CONF0_IDLE_THRES_CH2_Pos = 0x8
	// Bit mask of IDLE_THRES_CH2 field.
	RMT_CH2CONF0_IDLE_THRES_CH2_Msk = 0x7fff00
	// Position of MEM_SIZE_CH2 field.
	RMT_CH2CONF0_MEM_SIZE_CH2_Pos = 0x17
	// Bit mask of MEM_SIZE_CH2 field.
	RMT_CH2CONF0_MEM_SIZE_CH2_Msk = 0x3800000
	// Position of CARRIER_EN_CH2 field.
	RMT_CH2CONF0_CARRIER_EN_CH2_Pos = 0x1c
	// Bit mask of CARRIER_EN_CH2 field.
	RMT_CH2CONF0_CARRIER_EN_CH2_Msk = 0x10000000
	// Bit CARRIER_EN_CH2.
	RMT_CH2CONF0_CARRIER_EN_CH2 = 0x10000000
	// Position of CARRIER_OUT_LV_CH2 field.
	RMT_CH2CONF0_CARRIER_OUT_LV_CH2_Pos = 0x1d
	// Bit mask of CARRIER_OUT_LV_CH2 field.
	RMT_CH2CONF0_CARRIER_OUT_LV_CH2_Msk = 0x20000000
	// Bit CARRIER_OUT_LV_CH2.
	RMT_CH2CONF0_CARRIER_OUT_LV_CH2 = 0x20000000

	// CH2CONF1: RMT_CH2CONF1_REG.
	// Position of RX_EN_CH2 field.
	RMT_CH2CONF1_RX_EN_CH2_Pos = 0x0
	// Bit mask of RX_EN_CH2 field.
	RMT_CH2CONF1_RX_EN_CH2_Msk = 0x1
	// Bit RX_EN_CH2.
	RMT_CH2CONF1_RX_EN_CH2 = 0x1
	// Position of MEM_WR_RST_CH2 field.
	RMT_CH2CONF1_MEM_WR_RST_CH2_Pos = 0x1
	// Bit mask of MEM_WR_RST_CH2 field.
	RMT_CH2CONF1_MEM_WR_RST_CH2_Msk = 0x2
	// Bit MEM_WR_RST_CH2.
	RMT_CH2CONF1_MEM_WR_RST_CH2 = 0x2
	// Position of APB_MEM_RST_CH2 field.
	RMT_CH2CONF1_APB_MEM_RST_CH2_Pos = 0x2
	// Bit mask of APB_MEM_RST_CH2 field.
	RMT_CH2CONF1_APB_MEM_RST_CH2_Msk = 0x4
	// Bit APB_MEM_RST_CH2.
	RMT_CH2CONF1_APB_MEM_RST_CH2 = 0x4
	// Position of MEM_OWNER_CH2 field.
	RMT_CH2CONF1_MEM_OWNER_CH2_Pos = 0x3
	// Bit mask of MEM_OWNER_CH2 field.
	RMT_CH2CONF1_MEM_OWNER_CH2_Msk = 0x8
	// Bit MEM_OWNER_CH2.
	RMT_CH2CONF1_MEM_OWNER_CH2 = 0x8
	// Position of RX_FILTER_EN_CH2 field.
	RMT_CH2CONF1_RX_FILTER_EN_CH2_Pos = 0x4
	// Bit mask of RX_FILTER_EN_CH2 field.
	RMT_CH2CONF1_RX_FILTER_EN_CH2_Msk = 0x10
	// Bit RX_FILTER_EN_CH2.
	RMT_CH2CONF1_RX_FILTER_EN_CH2 = 0x10
	// Position of RX_FILTER_THRES_CH2 field.
	RMT_CH2CONF1_RX_FILTER_THRES_CH2_Pos = 0x5
	// Bit mask of RX_FILTER_THRES_CH2 field.
	RMT_CH2CONF1_RX_FILTER_THRES_CH2_Msk = 0x1fe0
	// Position of MEM_RX_WRAP_EN_CH2 field.
	RMT_CH2CONF1_MEM_RX_WRAP_EN_CH2_Pos = 0xd
	// Bit mask of MEM_RX_WRAP_EN_CH2 field.
	RMT_CH2CONF1_MEM_RX_WRAP_EN_CH2_Msk = 0x2000
	// Bit MEM_RX_WRAP_EN_CH2.
	RMT_CH2CONF1_MEM_RX_WRAP_EN_CH2 = 0x2000
	// Position of AFIFO_RST_CH2 field.
	RMT_CH2CONF1_AFIFO_RST_CH2_Pos = 0xe
	// Bit mask of AFIFO_RST_CH2 field.
	RMT_CH2CONF1_AFIFO_RST_CH2_Msk = 0x4000
	// Bit AFIFO_RST_CH2.
	RMT_CH2CONF1_AFIFO_RST_CH2 = 0x4000
	// Position of CONF_UPDATE_CH2 field.
	RMT_CH2CONF1_CONF_UPDATE_CH2_Pos = 0xf
	// Bit mask of CONF_UPDATE_CH2 field.
	RMT_CH2CONF1_CONF_UPDATE_CH2_Msk = 0x8000
	// Bit CONF_UPDATE_CH2.
	RMT_CH2CONF1_CONF_UPDATE_CH2 = 0x8000

	// CH3CONF0: RMT_CH3CONF0_REG.
	// Position of DIV_CNT_CH3 field.
	RMT_CH3CONF0_DIV_CNT_CH3_Pos = 0x0
	// Bit mask of DIV_CNT_CH3 field.
	RMT_CH3CONF0_DIV_CNT_CH3_Msk = 0xff
	// Position of IDLE_THRES_CH3 field.
	RMT_CH3CONF0_IDLE_THRES_CH3_Pos = 0x8
	// Bit mask of IDLE_THRES_CH3 field.
	RMT_CH3CONF0_IDLE_THRES_CH3_Msk = 0x7fff00
	// Position of MEM_SIZE_CH3 field.
	RMT_CH3CONF0_MEM_SIZE_CH3_Pos = 0x17
	// Bit mask of MEM_SIZE_CH3 field.
	RMT_CH3CONF0_MEM_SIZE_CH3_Msk = 0x3800000
	// Position of CARRIER_EN_CH3 field.
	RMT_CH3CONF0_CARRIER_EN_CH3_Pos = 0x1c
	// Bit mask of CARRIER_EN_CH3 field.
	RMT_CH3CONF0_CARRIER_EN_CH3_Msk = 0x10000000
	// Bit CARRIER_EN_CH3.
	RMT_CH3CONF0_CARRIER_EN_CH3 = 0x10000000
	// Position of CARRIER_OUT_LV_CH3 field.
	RMT_CH3CONF0_CARRIER_OUT_LV_CH3_Pos = 0x1d
	// Bit mask of CARRIER_OUT_LV_CH3 field.
	RMT_CH3CONF0_CARRIER_OUT_LV_CH3_Msk = 0x20000000
	// Bit CARRIER_OUT_LV_CH3.
	RMT_CH3CONF0_CARRIER_OUT_LV_CH3 = 0x20000000

	// CH3CONF1: RMT_CH3CONF1_REG.
	// Position of RX_EN_CH3 field.
	RMT_CH3CONF1_RX_EN_CH3_Pos = 0x0
	// Bit mask of RX_EN_CH3 field.
	RMT_CH3CONF1_RX_EN_CH3_Msk = 0x1
	// Bit RX_EN_CH3.
	RMT_CH3CONF1_RX_EN_CH3 = 0x1
	// Position of MEM_WR_RST_CH3 field.
	RMT_CH3CONF1_MEM_WR_RST_CH3_Pos = 0x1
	// Bit mask of MEM_WR_RST_CH3 field.
	RMT_CH3CONF1_MEM_WR_RST_CH3_Msk = 0x2
	// Bit MEM_WR_RST_CH3.
	RMT_CH3CONF1_MEM_WR_RST_CH3 = 0x2
	// Position of APB_MEM_RST_CH3 field.
	RMT_CH3CONF1_APB_MEM_RST_CH3_Pos = 0x2
	// Bit mask of APB_MEM_RST_CH3 field.
	RMT_CH3CONF1_APB_MEM_RST_CH3_Msk = 0x4
	// Bit APB_MEM_RST_CH3.
	RMT_CH3CONF1_APB_MEM_RST_CH3 = 0x4
	// Position of MEM_OWNER_CH3 field.
	RMT_CH3CONF1_MEM_OWNER_CH3_Pos = 0x3
	// Bit mask of MEM_OWNER_CH3 field.
	RMT_CH3CONF1_MEM_OWNER_CH3_Msk = 0x8
	// Bit MEM_OWNER_CH3.
	RMT_CH3CONF1_MEM_OWNER_CH3 = 0x8
	// Position of RX_FILTER_EN_CH3 field.
	RMT_CH3CONF1_RX_FILTER_EN_CH3_Pos = 0x4
	// Bit mask of RX_FILTER_EN_CH3 field.
	RMT_CH3CONF1_RX_FILTER_EN_CH3_Msk = 0x10
	// Bit RX_FILTER_EN_CH3.
	RMT_CH3CONF1_RX_FILTER_EN_CH3 = 0x10
	// Position of RX_FILTER_THRES_CH3 field.
	RMT_CH3CONF1_RX_FILTER_THRES_CH3_Pos = 0x5
	// Bit mask of RX_FILTER_THRES_CH3 field.
	RMT_CH3CONF1_RX_FILTER_THRES_CH3_Msk = 0x1fe0
	// Position of MEM_RX_WRAP_EN_CH3 field.
	RMT_CH3CONF1_MEM_RX_WRAP_EN_CH3_Pos = 0xd
	// Bit mask of MEM_RX_WRAP_EN_CH3 field.
	RMT_CH3CONF1_MEM_RX_WRAP_EN_CH3_Msk = 0x2000
	// Bit MEM_RX_WRAP_EN_CH3.
	RMT_CH3CONF1_MEM_RX_WRAP_EN_CH3 = 0x2000
	// Position of AFIFO_RST_CH3 field.
	RMT_CH3CONF1_AFIFO_RST_CH3_Pos = 0xe
	// Bit mask of AFIFO_RST_CH3 field.
	RMT_CH3CONF1_AFIFO_RST_CH3_Msk = 0x4000
	// Bit AFIFO_RST_CH3.
	RMT_CH3CONF1_AFIFO_RST_CH3 = 0x4000
	// Position of CONF_UPDATE_CH3 field.
	RMT_CH3CONF1_CONF_UPDATE_CH3_Pos = 0xf
	// Bit mask of CONF_UPDATE_CH3 field.
	RMT_CH3CONF1_CONF_UPDATE_CH3_Msk = 0x8000
	// Bit CONF_UPDATE_CH3.
	RMT_CH3CONF1_CONF_UPDATE_CH3 = 0x8000

	// CH0STATUS: RMT_CH0STATUS_REG.
	// Position of MEM_RADDR_EX_CH0 field.
	RMT_CH0STATUS_MEM_RADDR_EX_CH0_Pos = 0x0
	// Bit mask of MEM_RADDR_EX_CH0 field.
	RMT_CH0STATUS_MEM_RADDR_EX_CH0_Msk = 0x1ff
	// Position of STATE_CH0 field.
	RMT_CH0STATUS_STATE_CH0_Pos = 0x9
	// Bit mask of STATE_CH0 field.
	RMT_CH0STATUS_STATE_CH0_Msk = 0xe00
	// Position of APB_MEM_WADDR_CH0 field.
	RMT_CH0STATUS_APB_MEM_WADDR_CH0_Pos = 0xc
	// Bit mask of APB_MEM_WADDR_CH0 field.
	RMT_CH0STATUS_APB_MEM_WADDR_CH0_Msk = 0x1ff000
	// Position of APB_MEM_RD_ERR_CH0 field.
	RMT_CH0STATUS_APB_MEM_RD_ERR_CH0_Pos = 0x15
	// Bit mask of APB_MEM_RD_ERR_CH0 field.
	RMT_CH0STATUS_APB_MEM_RD_ERR_CH0_Msk = 0x200000
	// Bit APB_MEM_RD_ERR_CH0.
	RMT_CH0STATUS_APB_MEM_RD_ERR_CH0 = 0x200000
	// Position of MEM_EMPTY_CH0 field.
	RMT_CH0STATUS_MEM_EMPTY_CH0_Pos = 0x16
	// Bit mask of MEM_EMPTY_CH0 field.
	RMT_CH0STATUS_MEM_EMPTY_CH0_Msk = 0x400000
	// Bit MEM_EMPTY_CH0.
	RMT_CH0STATUS_MEM_EMPTY_CH0 = 0x400000
	// Position of APB_MEM_WR_ERR_CH0 field.
	RMT_CH0STATUS_APB_MEM_WR_ERR_CH0_Pos = 0x17
	// Bit mask of APB_MEM_WR_ERR_CH0 field.
	RMT_CH0STATUS_APB_MEM_WR_ERR_CH0_Msk = 0x800000
	// Bit APB_MEM_WR_ERR_CH0.
	RMT_CH0STATUS_APB_MEM_WR_ERR_CH0 = 0x800000
	// Position of APB_MEM_RADDR_CH0 field.
	RMT_CH0STATUS_APB_MEM_RADDR_CH0_Pos = 0x18
	// Bit mask of APB_MEM_RADDR_CH0 field.
	RMT_CH0STATUS_APB_MEM_RADDR_CH0_Msk = 0xff000000

	// CH1STATUS: RMT_CH1STATUS_REG.
	// Position of MEM_RADDR_EX_CH1 field.
	RMT_CH1STATUS_MEM_RADDR_EX_CH1_Pos = 0x0
	// Bit mask of MEM_RADDR_EX_CH1 field.
	RMT_CH1STATUS_MEM_RADDR_EX_CH1_Msk = 0x1ff
	// Position of STATE_CH1 field.
	RMT_CH1STATUS_STATE_CH1_Pos = 0x9
	// Bit mask of STATE_CH1 field.
	RMT_CH1STATUS_STATE_CH1_Msk = 0xe00
	// Position of APB_MEM_WADDR_CH1 field.
	RMT_CH1STATUS_APB_MEM_WADDR_CH1_Pos = 0xc
	// Bit mask of APB_MEM_WADDR_CH1 field.
	RMT_CH1STATUS_APB_MEM_WADDR_CH1_Msk = 0x1ff000
	// Position of APB_MEM_RD_ERR_CH1 field.
	RMT_CH1STATUS_APB_MEM_RD_ERR_CH1_Pos = 0x15
	// Bit mask of APB_MEM_RD_ERR_CH1 field.
	RMT_CH1STATUS_APB_MEM_RD_ERR_CH1_Msk = 0x200000
	// Bit APB_MEM_RD_ERR_CH1.
	RMT_CH1STATUS_APB_MEM_RD_ERR_CH1 = 0x200000
	// Position of MEM_EMPTY_CH1 field.
	RMT_CH1STATUS_MEM_EMPTY_CH1_Pos = 0x16
	// Bit mask of MEM_EMPTY_CH1 field.
	RMT_CH1STATUS_MEM_EMPTY_CH1_Msk = 0x400000
	// Bit MEM_EMPTY_CH1.
	RMT_CH1STATUS_MEM_EMPTY_CH1 = 0x400000
	// Position of APB_MEM_WR_ERR_CH1 field.
	RMT_CH1STATUS_APB_MEM_WR_ERR_CH1_Pos = 0x17
	// Bit mask of APB_MEM_WR_ERR_CH1 field.
	RMT_CH1STATUS_APB_MEM_WR_ERR_CH1_Msk = 0x800000
	// Bit APB_MEM_WR_ERR_CH1.
	RMT_CH1STATUS_APB_MEM_WR_ERR_CH1 = 0x800000
	// Position of APB_MEM_RADDR_CH1 field.
	RMT_CH1STATUS_APB_MEM_RADDR_CH1_Pos = 0x18
	// Bit mask of APB_MEM_RADDR_CH1 field.
	RMT_CH1STATUS_APB_MEM_RADDR_CH1_Msk = 0xff000000

	// CH2STATUS: RMT_CH2STATUS_REG.
	// Position of MEM_WADDR_EX_CH2 field.
	RMT_CH2STATUS_MEM_WADDR_EX_CH2_Pos = 0x0
	// Bit mask of MEM_WADDR_EX_CH2 field.
	RMT_CH2STATUS_MEM_WADDR_EX_CH2_Msk = 0x1ff
	// Position of APB_MEM_RADDR_CH2 field.
	RMT_CH2STATUS_APB_MEM_RADDR_CH2_Pos = 0xc
	// Bit mask of APB_MEM_RADDR_CH2 field.
	RMT_CH2STATUS_APB_MEM_RADDR_CH2_Msk = 0x1ff000
	// Position of STATE_CH2 field.
	RMT_CH2STATUS_STATE_CH2_Pos = 0x16
	// Bit mask of STATE_CH2 field.
	RMT_CH2STATUS_STATE_CH2_Msk = 0x1c00000
	// Position of MEM_OWNER_ERR_CH2 field.
	RMT_CH2STATUS_MEM_OWNER_ERR_CH2_Pos = 0x19
	// Bit mask of MEM_OWNER_ERR_CH2 field.
	RMT_CH2STATUS_MEM_OWNER_ERR_CH2_Msk = 0x2000000
	// Bit MEM_OWNER_ERR_CH2.
	RMT_CH2STATUS_MEM_OWNER_ERR_CH2 = 0x2000000
	// Position of MEM_FULL_CH2 field.
	RMT_CH2STATUS_MEM_FULL_CH2_Pos = 0x1a
	// Bit mask of MEM_FULL_CH2 field.
	RMT_CH2STATUS_MEM_FULL_CH2_Msk = 0x4000000
	// Bit MEM_FULL_CH2.
	RMT_CH2STATUS_MEM_FULL_CH2 = 0x4000000
	// Position of APB_MEM_RD_ERR_CH2 field.
	RMT_CH2STATUS_APB_MEM_RD_ERR_CH2_Pos = 0x1b
	// Bit mask of APB_MEM_RD_ERR_CH2 field.
	RMT_CH2STATUS_APB_MEM_RD_ERR_CH2_Msk = 0x8000000
	// Bit APB_MEM_RD_ERR_CH2.
	RMT_CH2STATUS_APB_MEM_RD_ERR_CH2 = 0x8000000

	// CH3STATUS: RMT_CH3STATUS_REG.
	// Position of MEM_WADDR_EX_CH3 field.
	RMT_CH3STATUS_MEM_WADDR_EX_CH3_Pos = 0x0
	// Bit mask of MEM_WADDR_EX_CH3 field.
	RMT_CH3STATUS_MEM_WADDR_EX_CH3_Msk = 0x1ff
	// Position of APB_MEM_RADDR_CH3 field.
	RMT_CH3STATUS_APB_MEM_RADDR_CH3_Pos = 0xc
	// Bit mask of APB_MEM_RADDR_CH3 field.
	RMT_CH3STATUS_APB_MEM_RADDR_CH3_Msk = 0x1ff000
	// Position of STATE_CH3 field.
	RMT_CH3STATUS_STATE_CH3_Pos = 0x16
	// Bit mask of STATE_CH3 field.
	RMT_CH3STATUS_STATE_CH3_Msk = 0x1c00000
	// Position of MEM_OWNER_ERR_CH3 field.
	RMT_CH3STATUS_MEM_OWNER_ERR_CH3_Pos = 0x19
	// Bit mask of MEM_OWNER_ERR_CH3 field.
	RMT_CH3STATUS_MEM_OWNER_ERR_CH3_Msk = 0x2000000
	// Bit MEM_OWNER_ERR_CH3.
	RMT_CH3STATUS_MEM_OWNER_ERR_CH3 = 0x2000000
	// Position of MEM_FULL_CH3 field.
	RMT_CH3STATUS_MEM_FULL_CH3_Pos = 0x1a
	// Bit mask of MEM_FULL_CH3 field.
	RMT_CH3STATUS_MEM_FULL_CH3_Msk = 0x4000000
	// Bit MEM_FULL_CH3.
	RMT_CH3STATUS_MEM_FULL_CH3 = 0x4000000
	// Position of APB_MEM_RD_ERR_CH3 field.
	RMT_CH3STATUS_APB_MEM_RD_ERR_CH3_Pos = 0x1b
	// Bit mask of APB_MEM_RD_ERR_CH3 field.
	RMT_CH3STATUS_APB_MEM_RD_ERR_CH3_Msk = 0x8000000
	// Bit APB_MEM_RD_ERR_CH3.
	RMT_CH3STATUS_APB_MEM_RD_ERR_CH3 = 0x8000000

	// INT_RAW: RMT_INT_RAW_REG.
	// Position of CH0_TX_END_INT_RAW field.
	RMT_INT_RAW_CH0_TX_END_INT_RAW_Pos = 0x0
	// Bit mask of CH0_TX_END_INT_RAW field.
	RMT_INT_RAW_CH0_TX_END_INT_RAW_Msk = 0x1
	// Bit CH0_TX_END_INT_RAW.
	RMT_INT_RAW_CH0_TX_END_INT_RAW = 0x1
	// Position of CH1_TX_END_INT_RAW field.
	RMT_INT_RAW_CH1_TX_END_INT_RAW_Pos = 0x1
	// Bit mask of CH1_TX_END_INT_RAW field.
	RMT_INT_RAW_CH1_TX_END_INT_RAW_Msk = 0x2
	// Bit CH1_TX_END_INT_RAW.
	RMT_INT_RAW_CH1_TX_END_INT_RAW = 0x2
	// Position of CH2_RX_END_INT_RAW field.
	RMT_INT_RAW_CH2_RX_END_INT_RAW_Pos = 0x2
	// Bit mask of CH2_RX_END_INT_RAW field.
	RMT_INT_RAW_CH2_RX_END_INT_RAW_Msk = 0x4
	// Bit CH2_RX_END_INT_RAW.
	RMT_INT_RAW_CH2_RX_END_INT_RAW = 0x4
	// Position of CH3_RX_END_INT_RAW field.
	RMT_INT_RAW_CH3_RX_END_INT_RAW_Pos = 0x3
	// Bit mask of CH3_RX_END_INT_RAW field.
	RMT_INT_RAW_CH3_RX_END_INT_RAW_Msk = 0x8
	// Bit CH3_RX_END_INT_RAW.
	RMT_INT_RAW_CH3_RX_END_INT_RAW = 0x8
	// Position of CH0_ERR_INT_RAW field.
	RMT_INT_RAW_CH0_ERR_INT_RAW_Pos = 0x4
	// Bit mask of CH0_ERR_INT_RAW field.
	RMT_INT_RAW_CH0_ERR_INT_RAW_Msk = 0x10
	// Bit CH0_ERR_INT_RAW.
	RMT_INT_RAW_CH0_ERR_INT_RAW = 0x10
	// Position of CH1_ERR_INT_RAW field.
	RMT_INT_RAW_CH1_ERR_INT_RAW_Pos = 0x5
	// Bit mask of CH1_ERR_INT_RAW field.
	RMT_INT_RAW_CH1_ERR_INT_RAW_Msk = 0x20
	// Bit CH1_ERR_INT_RAW.
	RMT_INT_RAW_CH1_ERR_INT_RAW = 0x20
	// Position of CH2_ERR_INT_RAW field.
	RMT_INT_RAW_CH2_ERR_INT_RAW_Pos = 0x6
	// Bit mask of CH2_ERR_INT_RAW field.
	RMT_INT_RAW_CH2_ERR_INT_RAW_Msk = 0x40
	// Bit CH2_ERR_INT_RAW.
	RMT_INT_RAW_CH2_ERR_INT_RAW = 0x40
	// Position of CH3_ERR_INT_RAW field.
	RMT_INT_RAW_CH3_ERR_INT_RAW_Pos = 0x7
	// Bit mask of CH3_ERR_INT_RAW field.
	RMT_INT_RAW_CH3_ERR_INT_RAW_Msk = 0x80
	// Bit CH3_ERR_INT_RAW.
	RMT_INT_RAW_CH3_ERR_INT_RAW = 0x80
	// Position of CH0_TX_THR_EVENT_INT_RAW field.
	RMT_INT_RAW_CH0_TX_THR_EVENT_INT_RAW_Pos = 0x8
	// Bit mask of CH0_TX_THR_EVENT_INT_RAW field.
	RMT_INT_RAW_CH0_TX_THR_EVENT_INT_RAW_Msk = 0x100
	// Bit CH0_TX_THR_EVENT_INT_RAW.
	RMT_INT_RAW_CH0_TX_THR_EVENT_INT_RAW = 0x100
	// Position of CH1_TX_THR_EVENT_INT_RAW field.
	RMT_INT_RAW_CH1_TX_THR_EVENT_INT_RAW_Pos = 0x9
	// Bit mask of CH1_TX_THR_EVENT_INT_RAW field.
	RMT_INT_RAW_CH1_TX_THR_EVENT_INT_RAW_Msk = 0x200
	// Bit CH1_TX_THR_EVENT_INT_RAW.
	RMT_INT_RAW_CH1_TX_THR_EVENT_INT_RAW = 0x200
	// Position of CH2_RX_THR_EVENT_INT_RAW field.
	RMT_INT_RAW_CH2_RX_THR_EVENT_INT_RAW_Pos = 0xa
	// Bit mask of CH2_RX_THR_EVENT_INT_RAW field.
	RMT_INT_RAW_CH2_RX_THR_EVENT_INT_RAW_Msk = 0x400
	// Bit CH2_RX_THR_EVENT_INT_RAW.
	RMT_INT_RAW_CH2_RX_THR_EVENT_INT_RAW = 0x400
	// Position of CH3_RX_THR_EVENT_INT_RAW field.
	RMT_INT_RAW_CH3_RX_THR_EVENT_INT_RAW_Pos = 0xb
	// Bit mask of CH3_RX_THR_EVENT_INT_RAW field.
	RMT_INT_RAW_CH3_RX_THR_EVENT_INT_RAW_Msk = 0x800
	// Bit CH3_RX_THR_EVENT_INT_RAW.
	RMT_INT_RAW_CH3_RX_THR_EVENT_INT_RAW = 0x800
	// Position of CH0_TX_LOOP_INT_RAW field.
	RMT_INT_RAW_CH0_TX_LOOP_INT_RAW_Pos = 0xc
	// Bit mask of CH0_TX_LOOP_INT_RAW field.
	RMT_INT_RAW_CH0_TX_LOOP_INT_RAW_Msk = 0x1000
	// Bit CH0_TX_LOOP_INT_RAW.
	RMT_INT_RAW_CH0_TX_LOOP_INT_RAW = 0x1000
	// Position of CH1_TX_LOOP_INT_RAW field.
	RMT_INT_RAW_CH1_TX_LOOP_INT_RAW_Pos = 0xd
	// Bit mask of CH1_TX_LOOP_INT_RAW field.
	RMT_INT_RAW_CH1_TX_LOOP_INT_RAW_Msk = 0x2000
	// Bit CH1_TX_LOOP_INT_RAW.
	RMT_INT_RAW_CH1_TX_LOOP_INT_RAW = 0x2000

	// INT_ST: RMT_INT_ST_REG.
	// Position of CH0_TX_END_INT_ST field.
	RMT_INT_ST_CH0_TX_END_INT_ST_Pos = 0x0
	// Bit mask of CH0_TX_END_INT_ST field.
	RMT_INT_ST_CH0_TX_END_INT_ST_Msk = 0x1
	// Bit CH0_TX_END_INT_ST.
	RMT_INT_ST_CH0_TX_END_INT_ST = 0x1
	// Position of CH1_TX_END_INT_ST field.
	RMT_INT_ST_CH1_TX_END_INT_ST_Pos = 0x1
	// Bit mask of CH1_TX_END_INT_ST field.
	RMT_INT_ST_CH1_TX_END_INT_ST_Msk = 0x2
	// Bit CH1_TX_END_INT_ST.
	RMT_INT_ST_CH1_TX_END_INT_ST = 0x2
	// Position of CH2_RX_END_INT_ST field.
	RMT_INT_ST_CH2_RX_END_INT_ST_Pos = 0x2
	// Bit mask of CH2_RX_END_INT_ST field.
	RMT_INT_ST_CH2_RX_END_INT_ST_Msk = 0x4
	// Bit CH2_RX_END_INT_ST.
	RMT_INT_ST_CH2_RX_END_INT_ST = 0x4
	// Position of CH3_RX_END_INT_ST field.
	RMT_INT_ST_CH3_RX_END_INT_ST_Pos = 0x3
	// Bit mask of CH3_RX_END_INT_ST field.
	RMT_INT_ST_CH3_RX_END_INT_ST_Msk = 0x8
	// Bit CH3_RX_END_INT_ST.
	RMT_INT_ST_CH3_RX_END_INT_ST = 0x8
	// Position of CH0_ERR_INT_ST field.
	RMT_INT_ST_CH0_ERR_INT_ST_Pos = 0x4
	// Bit mask of CH0_ERR_INT_ST field.
	RMT_INT_ST_CH0_ERR_INT_ST_Msk = 0x10
	// Bit CH0_ERR_INT_ST.
	RMT_INT_ST_CH0_ERR_INT_ST = 0x10
	// Position of CH1_ERR_INT_ST field.
	RMT_INT_ST_CH1_ERR_INT_ST_Pos = 0x5
	// Bit mask of CH1_ERR_INT_ST field.
	RMT_INT_ST_CH1_ERR_INT_ST_Msk = 0x20
	// Bit CH1_ERR_INT_ST.
	RMT_INT_ST_CH1_ERR_INT_ST = 0x20
	// Position of CH2_ERR_INT_ST field.
	RMT_INT_ST_CH2_ERR_INT_ST_Pos = 0x6
	// Bit mask of CH2_ERR_INT_ST field.
	RMT_INT_ST_CH2_ERR_INT_ST_Msk = 0x40
	// Bit CH2_ERR_INT_ST.
	RMT_INT_ST_CH2_ERR_INT_ST = 0x40
	// Position of CH3_ERR_INT_ST field.
	RMT_INT_ST_CH3_ERR_INT_ST_Pos = 0x7
	// Bit mask of CH3_ERR_INT_ST field.
	RMT_INT_ST_CH3_ERR_INT_ST_Msk = 0x80
	// Bit CH3_ERR_INT_ST.
	RMT_INT_ST_CH3_ERR_INT_ST = 0x80
	// Position of CH0_TX_THR_EVENT_INT_ST field.
	RMT_INT_ST_CH0_TX_THR_EVENT_INT_ST_Pos = 0x8
	// Bit mask of CH0_TX_THR_EVENT_INT_ST field.
	RMT_INT_ST_CH0_TX_THR_EVENT_INT_ST_Msk = 0x100
	// Bit CH0_TX_THR_EVENT_INT_ST.
	RMT_INT_ST_CH0_TX_THR_EVENT_INT_ST = 0x100
	// Position of CH1_TX_THR_EVENT_INT_ST field.
	RMT_INT_ST_CH1_TX_THR_EVENT_INT_ST_Pos = 0x9
	// Bit mask of CH1_TX_THR_EVENT_INT_ST field.
	RMT_INT_ST_CH1_TX_THR_EVENT_INT_ST_Msk = 0x200
	// Bit CH1_TX_THR_EVENT_INT_ST.
	RMT_INT_ST_CH1_TX_THR_EVENT_INT_ST = 0x200
	// Position of CH2_RX_THR_EVENT_INT_ST field.
	RMT_INT_ST_CH2_RX_THR_EVENT_INT_ST_Pos = 0xa
	// Bit mask of CH2_RX_THR_EVENT_INT_ST field.
	RMT_INT_ST_CH2_RX_THR_EVENT_INT_ST_Msk = 0x400
	// Bit CH2_RX_THR_EVENT_INT_ST.
	RMT_INT_ST_CH2_RX_THR_EVENT_INT_ST = 0x400
	// Position of CH3_RX_THR_EVENT_INT_ST field.
	RMT_INT_ST_CH3_RX_THR_EVENT_INT_ST_Pos = 0xb
	// Bit mask of CH3_RX_THR_EVENT_INT_ST field.
	RMT_INT_ST_CH3_RX_THR_EVENT_INT_ST_Msk = 0x800
	// Bit CH3_RX_THR_EVENT_INT_ST.
	RMT_INT_ST_CH3_RX_THR_EVENT_INT_ST = 0x800
	// Position of CH0_TX_LOOP_INT_ST field.
	RMT_INT_ST_CH0_TX_LOOP_INT_ST_Pos = 0xc
	// Bit mask of CH0_TX_LOOP_INT_ST field.
	RMT_INT_ST_CH0_TX_LOOP_INT_ST_Msk = 0x1000
	// Bit CH0_TX_LOOP_INT_ST.
	RMT_INT_ST_CH0_TX_LOOP_INT_ST = 0x1000
	// Position of CH1_TX_LOOP_INT_ST field.
	RMT_INT_ST_CH1_TX_LOOP_INT_ST_Pos = 0xd
	// Bit mask of CH1_TX_LOOP_INT_ST field.
	RMT_INT_ST_CH1_TX_LOOP_INT_ST_Msk = 0x2000
	// Bit CH1_TX_LOOP_INT_ST.
	RMT_INT_ST_CH1_TX_LOOP_INT_ST = 0x2000

	// INT_ENA: RMT_INT_ENA_REG.
	// Position of CH0_TX_END_INT_ENA field.
	RMT_INT_ENA_CH0_TX_END_INT_ENA_Pos = 0x0
	// Bit mask of CH0_TX_END_INT_ENA field.
	RMT_INT_ENA_CH0_TX_END_INT_ENA_Msk = 0x1
	// Bit CH0_TX_END_INT_ENA.
	RMT_INT_ENA_CH0_TX_END_INT_ENA = 0x1
	// Position of CH1_TX_END_INT_ENA field.
	RMT_INT_ENA_CH1_TX_END_INT_ENA_Pos = 0x1
	// Bit mask of CH1_TX_END_INT_ENA field.
	RMT_INT_ENA_CH1_TX_END_INT_ENA_Msk = 0x2
	// Bit CH1_TX_END_INT_ENA.
	RMT_INT_ENA_CH1_TX_END_INT_ENA = 0x2
	// Position of CH2_RX_END_INT_ENA field.
	RMT_INT_ENA_CH2_RX_END_INT_ENA_Pos = 0x2
	// Bit mask of CH2_RX_END_INT_ENA field.
	RMT_INT_ENA_CH2_RX_END_INT_ENA_Msk = 0x4
	// Bit CH2_RX_END_INT_ENA.
	RMT_INT_ENA_CH2_RX_END_INT_ENA = 0x4
	// Position of CH3_RX_END_INT_ENA field.
	RMT_INT_ENA_CH3_RX_END_INT_ENA_Pos = 0x3
	// Bit mask of CH3_RX_END_INT_ENA field.
	RMT_INT_ENA_CH3_RX_END_INT_ENA_Msk = 0x8
	// Bit CH3_RX_END_INT_ENA.
	RMT_INT_ENA_CH3_RX_END_INT_ENA = 0x8
	// Position of CH0_ERR_INT_ENA field.
	RMT_INT_ENA_CH0_ERR_INT_ENA_Pos = 0x4
	// Bit mask of CH0_ERR_INT_ENA field.
	RMT_INT_ENA_CH0_ERR_INT_ENA_Msk = 0x10
	// Bit CH0_ERR_INT_ENA.
	RMT_INT_ENA_CH0_ERR_INT_ENA = 0x10
	// Position of CH1_ERR_INT_ENA field.
	RMT_INT_ENA_CH1_ERR_INT_ENA_Pos = 0x5
	// Bit mask of CH1_ERR_INT_ENA field.
	RMT_INT_ENA_CH1_ERR_INT_ENA_Msk = 0x20
	// Bit CH1_ERR_INT_ENA.
	RMT_INT_ENA_CH1_ERR_INT_ENA = 0x20
	// Position of CH2_ERR_INT_ENA field.
	RMT_INT_ENA_CH2_ERR_INT_ENA_Pos = 0x6
	// Bit mask of CH2_ERR_INT_ENA field.
	RMT_INT_ENA_CH2_ERR_INT_ENA_Msk = 0x40
	// Bit CH2_ERR_INT_ENA.
	RMT_INT_ENA_CH2_ERR_INT_ENA = 0x40
	// Position of CH3_ERR_INT_ENA field.
	RMT_INT_ENA_CH3_ERR_INT_ENA_Pos = 0x7
	// Bit mask of CH3_ERR_INT_ENA field.
	RMT_INT_ENA_CH3_ERR_INT_ENA_Msk = 0x80
	// Bit CH3_ERR_INT_ENA.
	RMT_INT_ENA_CH3_ERR_INT_ENA = 0x80
	// Position of CH0_TX_THR_EVENT_INT_ENA field.
	RMT_INT_ENA_CH0_TX_THR_EVENT_INT_ENA_Pos = 0x8
	// Bit mask of CH0_TX_THR_EVENT_INT_ENA field.
	RMT_INT_ENA_CH0_TX_THR_EVENT_INT_ENA_Msk = 0x100
	// Bit CH0_TX_THR_EVENT_INT_ENA.
	RMT_INT_ENA_CH0_TX_THR_EVENT_INT_ENA = 0x100
	// Position of CH1_TX_THR_EVENT_INT_ENA field.
	RMT_INT_ENA_CH1_TX_THR_EVENT_INT_ENA_Pos = 0x9
	// Bit mask of CH1_TX_THR_EVENT_INT_ENA field.
	RMT_INT_ENA_CH1_TX_THR_EVENT_INT_ENA_Msk = 0x200
	// Bit CH1_TX_THR_EVENT_INT_ENA.
	RMT_INT_ENA_CH1_TX_THR_EVENT_INT_ENA = 0x200
	// Position of CH2_RX_THR_EVENT_INT_ENA field.
	RMT_INT_ENA_CH2_RX_THR_EVENT_INT_ENA_Pos = 0xa
	// Bit mask of CH2_RX_THR_EVENT_INT_ENA field.
	RMT_INT_ENA_CH2_RX_THR_EVENT_INT_ENA_Msk = 0x400
	// Bit CH2_RX_THR_EVENT_INT_ENA.
	RMT_INT_ENA_CH2_RX_THR_EVENT_INT_ENA = 0x400
	// Position of CH3_RX_THR_EVENT_INT_ENA field.
	RMT_INT_ENA_CH3_RX_THR_EVENT_INT_ENA_Pos = 0xb
	// Bit mask of CH3_RX_THR_EVENT_INT_ENA field.
	RMT_INT_ENA_CH3_RX_THR_EVENT_INT_ENA_Msk = 0x800
	// Bit CH3_RX_THR_EVENT_INT_ENA.
	RMT_INT_ENA_CH3_RX_THR_EVENT_INT_ENA = 0x800
	// Position of CH0_TX_LOOP_INT_ENA field.
	RMT_INT_ENA_CH0_TX_LOOP_INT_ENA_Pos = 0xc
	// Bit mask of CH0_TX_LOOP_INT_ENA field.
	RMT_INT_ENA_CH0_TX_LOOP_INT_ENA_Msk = 0x1000
	// Bit CH0_TX_LOOP_INT_ENA.
	RMT_INT_ENA_CH0_TX_LOOP_INT_ENA = 0x1000
	// Position of CH1_TX_LOOP_INT_ENA field.
	RMT_INT_ENA_CH1_TX_LOOP_INT_ENA_Pos = 0xd
	// Bit mask of CH1_TX_LOOP_INT_ENA field.
	RMT_INT_ENA_CH1_TX_LOOP_INT_ENA_Msk = 0x2000
	// Bit CH1_TX_LOOP_INT_ENA.
	RMT_INT_ENA_CH1_TX_LOOP_INT_ENA = 0x2000

	// INT_CLR: RMT_INT_CLR_REG.
	// Position of CH0_TX_END_INT_CLR field.
	RMT_INT_CLR_CH0_TX_END_INT_CLR_Pos = 0x0
	// Bit mask of CH0_TX_END_INT_CLR field.
	RMT_INT_CLR_CH0_TX_END_INT_CLR_Msk = 0x1
	// Bit CH0_TX_END_INT_CLR.
	RMT_INT_CLR_CH0_TX_END_INT_CLR = 0x1
	// Position of CH1_TX_END_INT_CLR field.
	RMT_INT_CLR_CH1_TX_END_INT_CLR_Pos = 0x1
	// Bit mask of CH1_TX_END_INT_CLR field.
	RMT_INT_CLR_CH1_TX_END_INT_CLR_Msk = 0x2
	// Bit CH1_TX_END_INT_CLR.
	RMT_INT_CLR_CH1_TX_END_INT_CLR = 0x2
	// Position of CH2_RX_END_INT_CLR field.
	RMT_INT_CLR_CH2_RX_END_INT_CLR_Pos = 0x2
	// Bit mask of CH2_RX_END_INT_CLR field.
	RMT_INT_CLR_CH2_RX_END_INT_CLR_Msk = 0x4
	// Bit CH2_RX_END_INT_CLR.
	RMT_INT_CLR_CH2_RX_END_INT_CLR = 0x4
	// Position of CH3_RX_END_INT_CLR field.
	RMT_INT_CLR_CH3_RX_END_INT_CLR_Pos = 0x3
	// Bit mask of CH3_RX_END_INT_CLR field.
	RMT_INT_CLR_CH3_RX_END_INT_CLR_Msk = 0x8
	// Bit CH3_RX_END_INT_CLR.
	RMT_INT_CLR_CH3_RX_END_INT_CLR = 0x8
	// Position of CH0_ERR_INT_CLR field.
	RMT_INT_CLR_CH0_ERR_INT_CLR_Pos = 0x4
	// Bit mask of CH0_ERR_INT_CLR field.
	RMT_INT_CLR_CH0_ERR_INT_CLR_Msk = 0x10
	// Bit CH0_ERR_INT_CLR.
	RMT_INT_CLR_CH0_ERR_INT_CLR = 0x10
	// Position of CH1_ERR_INT_CLR field.
	RMT_INT_CLR_CH1_ERR_INT_CLR_Pos = 0x5
	// Bit mask of CH1_ERR_INT_CLR field.
	RMT_INT_CLR_CH1_ERR_INT_CLR_Msk = 0x20
	// Bit CH1_ERR_INT_CLR.
	RMT_INT_CLR_CH1_ERR_INT_CLR = 0x20
	// Position of CH2_ERR_INT_CLR field.
	RMT_INT_CLR_CH2_ERR_INT_CLR_Pos = 0x6
	// Bit mask of CH2_ERR_INT_CLR field.
	RMT_INT_CLR_CH2_ERR_INT_CLR_Msk = 0x40
	// Bit CH2_ERR_INT_CLR.
	RMT_INT_CLR_CH2_ERR_INT_CLR = 0x40
	// Position of CH3_ERR_INT_CLR field.
	RMT_INT_CLR_CH3_ERR_INT_CLR_Pos = 0x7
	// Bit mask of CH3_ERR_INT_CLR field.
	RMT_INT_CLR_CH3_ERR_INT_CLR_Msk = 0x80
	// Bit CH3_ERR_INT_CLR.
	RMT_INT_CLR_CH3_ERR_INT_CLR = 0x80
	// Position of CH0_TX_THR_EVENT_INT_CLR field.
	RMT_INT_CLR_CH0_TX_THR_EVENT_INT_CLR_Pos = 0x8
	// Bit mask of CH0_TX_THR_EVENT_INT_CLR field.
	RMT_INT_CLR_CH0_TX_THR_EVENT_INT_CLR_Msk = 0x100
	// Bit CH0_TX_THR_EVENT_INT_CLR.
	RMT_INT_CLR_CH0_TX_THR_EVENT_INT_CLR = 0x100
	// Position of CH1_TX_THR_EVENT_INT_CLR field.
	RMT_INT_CLR_CH1_TX_THR_EVENT_INT_CLR_Pos = 0x9
	// Bit mask of CH1_TX_THR_EVENT_INT_CLR field.
	RMT_INT_CLR_CH1_TX_THR_EVENT_INT_CLR_Msk = 0x200
	// Bit CH1_TX_THR_EVENT_INT_CLR.
	RMT_INT_CLR_CH1_TX_THR_EVENT_INT_CLR = 0x200
	// Position of CH2_RX_THR_EVENT_INT_CLR field.
	RMT_INT_CLR_CH2_RX_THR_EVENT_INT_CLR_Pos = 0xa
	// Bit mask of CH2_RX_THR_EVENT_INT_CLR field.
	RMT_INT_CLR_CH2_RX_THR_EVENT_INT_CLR_Msk = 0x400
	// Bit CH2_RX_THR_EVENT_INT_CLR.
	RMT_INT_CLR_CH2_RX_THR_EVENT_INT_CLR = 0x400
	// Position of CH3_RX_THR_EVENT_INT_CLR field.
	RMT_INT_CLR_CH3_RX_THR_EVENT_INT_CLR_Pos = 0xb
	// Bit mask of CH3_RX_THR_EVENT_INT_CLR field.
	RMT_INT_CLR_CH3_RX_THR_EVENT_INT_CLR_Msk = 0x800
	// Bit CH3_RX_THR_EVENT_INT_CLR.
	RMT_INT_CLR_CH3_RX_THR_EVENT_INT_CLR = 0x800
	// Position of CH0_TX_LOOP_INT_CLR field.
	RMT_INT_CLR_CH0_TX_LOOP_INT_CLR_Pos = 0xc
	// Bit mask of CH0_TX_LOOP_INT_CLR field.
	RMT_INT_CLR_CH0_TX_LOOP_INT_CLR_Msk = 0x1000
	// Bit CH0_TX_LOOP_INT_CLR.
	RMT_INT_CLR_CH0_TX_LOOP_INT_CLR = 0x1000
	// Position of CH1_TX_LOOP_INT_CLR field.
	RMT_INT_CLR_CH1_TX_LOOP_INT_CLR_Pos = 0xd
	// Bit mask of CH1_TX_LOOP_INT_CLR field.
	RMT_INT_CLR_CH1_TX_LOOP_INT_CLR_Msk = 0x2000
	// Bit CH1_TX_LOOP_INT_CLR.
	RMT_INT_CLR_CH1_TX_LOOP_INT_CLR = 0x2000

	// CH0CARRIER_DUTY: RMT_CH0CARRIER_DUTY_REG.
	// Position of CARRIER_LOW_CH0 field.
	RMT_CH0CARRIER_DUTY_CARRIER_LOW_CH0_Pos = 0x0
	// Bit mask of CARRIER_LOW_CH0 field.
	RMT_CH0CARRIER_DUTY_CARRIER_LOW_CH0_Msk = 0xffff
	// Position of CARRIER_HIGH_CH0 field.
	RMT_CH0CARRIER_DUTY_CARRIER_HIGH_CH0_Pos = 0x10
	// Bit mask of CARRIER_HIGH_CH0 field.
	RMT_CH0CARRIER_DUTY_CARRIER_HIGH_CH0_Msk = 0xffff0000

	// CH1CARRIER_DUTY: RMT_CH1CARRIER_DUTY_REG.
	// Position of CARRIER_LOW_CH1 field.
	RMT_CH1CARRIER_DUTY_CARRIER_LOW_CH1_Pos = 0x0
	// Bit mask of CARRIER_LOW_CH1 field.
	RMT_CH1CARRIER_DUTY_CARRIER_LOW_CH1_Msk = 0xffff
	// Position of CARRIER_HIGH_CH1 field.
	RMT_CH1CARRIER_DUTY_CARRIER_HIGH_CH1_Pos = 0x10
	// Bit mask of CARRIER_HIGH_CH1 field.
	RMT_CH1CARRIER_DUTY_CARRIER_HIGH_CH1_Msk = 0xffff0000

	// CH2_RX_CARRIER_RM: RMT_CH2_RX_CARRIER_RM_REG.
	// Position of CARRIER_LOW_THRES_CH2 field.
	RMT_CH2_RX_CARRIER_RM_CARRIER_LOW_THRES_CH2_Pos = 0x0
	// Bit mask of CARRIER_LOW_THRES_CH2 field.
	RMT_CH2_RX_CARRIER_RM_CARRIER_LOW_THRES_CH2_Msk = 0xffff
	// Position of CARRIER_HIGH_THRES_CH2 field.
	RMT_CH2_RX_CARRIER_RM_CARRIER_HIGH_THRES_CH2_Pos = 0x10
	// Bit mask of CARRIER_HIGH_THRES_CH2 field.
	RMT_CH2_RX_CARRIER_RM_CARRIER_HIGH_THRES_CH2_Msk = 0xffff0000

	// CH3_RX_CARRIER_RM: RMT_CH3_RX_CARRIER_RM_REG.
	// Position of CARRIER_LOW_THRES_CH3 field.
	RMT_CH3_RX_CARRIER_RM_CARRIER_LOW_THRES_CH3_Pos = 0x0
	// Bit mask of CARRIER_LOW_THRES_CH3 field.
	RMT_CH3_RX_CARRIER_RM_CARRIER_LOW_THRES_CH3_Msk = 0xffff
	// Position of CARRIER_HIGH_THRES_CH3 field.
	RMT_CH3_RX_CARRIER_RM_CARRIER_HIGH_THRES_CH3_Pos = 0x10
	// Bit mask of CARRIER_HIGH_THRES_CH3 field.
	RMT_CH3_RX_CARRIER_RM_CARRIER_HIGH_THRES_CH3_Msk = 0xffff0000

	// CH0_TX_LIM: RMT_CH0_TX_LIM_REG.
	// Position of RMT_TX_LIM_CH0 field.
	RMT_CH0_TX_LIM_RMT_TX_LIM_CH0_Pos = 0x0
	// Bit mask of RMT_TX_LIM_CH0 field.
	RMT_CH0_TX_LIM_RMT_TX_LIM_CH0_Msk = 0x1ff
	// Position of RMT_TX_LOOP_NUM_CH0 field.
	RMT_CH0_TX_LIM_RMT_TX_LOOP_NUM_CH0_Pos = 0x9
	// Bit mask of RMT_TX_LOOP_NUM_CH0 field.
	RMT_CH0_TX_LIM_RMT_TX_LOOP_NUM_CH0_Msk = 0x7fe00
	// Position of RMT_TX_LOOP_CNT_EN_CH0 field.
	RMT_CH0_TX_LIM_RMT_TX_LOOP_CNT_EN_CH0_Pos = 0x13
	// Bit mask of RMT_TX_LOOP_CNT_EN_CH0 field.
	RMT_CH0_TX_LIM_RMT_TX_LOOP_CNT_EN_CH0_Msk = 0x80000
	// Bit RMT_TX_LOOP_CNT_EN_CH0.
	RMT_CH0_TX_LIM_RMT_TX_LOOP_CNT_EN_CH0 = 0x80000
	// Position of LOOP_COUNT_RESET_CH0 field.
	RMT_CH0_TX_LIM_LOOP_COUNT_RESET_CH0_Pos = 0x14
	// Bit mask of LOOP_COUNT_RESET_CH0 field.
	RMT_CH0_TX_LIM_LOOP_COUNT_RESET_CH0_Msk = 0x100000
	// Bit LOOP_COUNT_RESET_CH0.
	RMT_CH0_TX_LIM_LOOP_COUNT_RESET_CH0 = 0x100000

	// CH1_TX_LIM: RMT_CH1_TX_LIM_REG.
	// Position of RMT_TX_LIM_CH1 field.
	RMT_CH1_TX_LIM_RMT_TX_LIM_CH1_Pos = 0x0
	// Bit mask of RMT_TX_LIM_CH1 field.
	RMT_CH1_TX_LIM_RMT_TX_LIM_CH1_Msk = 0x1ff
	// Position of RMT_TX_LOOP_NUM_CH1 field.
	RMT_CH1_TX_LIM_RMT_TX_LOOP_NUM_CH1_Pos = 0x9
	// Bit mask of RMT_TX_LOOP_NUM_CH1 field.
	RMT_CH1_TX_LIM_RMT_TX_LOOP_NUM_CH1_Msk = 0x7fe00
	// Position of RMT_TX_LOOP_CNT_EN_CH1 field.
	RMT_CH1_TX_LIM_RMT_TX_LOOP_CNT_EN_CH1_Pos = 0x13
	// Bit mask of RMT_TX_LOOP_CNT_EN_CH1 field.
	RMT_CH1_TX_LIM_RMT_TX_LOOP_CNT_EN_CH1_Msk = 0x80000
	// Bit RMT_TX_LOOP_CNT_EN_CH1.
	RMT_CH1_TX_LIM_RMT_TX_LOOP_CNT_EN_CH1 = 0x80000
	// Position of LOOP_COUNT_RESET_CH1 field.
	RMT_CH1_TX_LIM_LOOP_COUNT_RESET_CH1_Pos = 0x14
	// Bit mask of LOOP_COUNT_RESET_CH1 field.
	RMT_CH1_TX_LIM_LOOP_COUNT_RESET_CH1_Msk = 0x100000
	// Bit LOOP_COUNT_RESET_CH1.
	RMT_CH1_TX_LIM_LOOP_COUNT_RESET_CH1 = 0x100000

	// CH2_RX_LIM: RMT_CH2_RX_LIM_REG.
	// Position of RMT_RX_LIM_CH2 field.
	RMT_CH2_RX_LIM_RMT_RX_LIM_CH2_Pos = 0x0
	// Bit mask of RMT_RX_LIM_CH2 field.
	RMT_CH2_RX_LIM_RMT_RX_LIM_CH2_Msk = 0x1ff

	// CH3_RX_LIM: RMT_CH3_RX_LIM_REG.
	// Position of RMT_RX_LIM_CH3 field.
	RMT_CH3_RX_LIM_RMT_RX_LIM_CH3_Pos = 0x0
	// Bit mask of RMT_RX_LIM_CH3 field.
	RMT_CH3_RX_LIM_RMT_RX_LIM_CH3_Msk = 0x1ff

	// SYS_CONF: RMT_SYS_CONF_REG.
	// Position of APB_FIFO_MASK field.
	RMT_SYS_CONF_APB_FIFO_MASK_Pos = 0x0
	// Bit mask of APB_FIFO_MASK field.
	RMT_SYS_CONF_APB_FIFO_MASK_Msk = 0x1
	// Bit APB_FIFO_MASK.
	RMT_SYS_CONF_APB_FIFO_MASK = 0x1
	// Position of MEM_CLK_FORCE_ON field.
	RMT_SYS_CONF_MEM_CLK_FORCE_ON_Pos = 0x1
	// Bit mask of MEM_CLK_FORCE_ON field.
	RMT_SYS_CONF_MEM_CLK_FORCE_ON_Msk = 0x2
	// Bit MEM_CLK_FORCE_ON.
	RMT_SYS_CONF_MEM_CLK_FORCE_ON = 0x2
	// Position of RMT_MEM_FORCE_PD field.
	RMT_SYS_CONF_RMT_MEM_FORCE_PD_Pos = 0x2
	// Bit mask of RMT_MEM_FORCE_PD field.
	RMT_SYS_CONF_RMT_MEM_FORCE_PD_Msk = 0x4
	// Bit RMT_MEM_FORCE_PD.
	RMT_SYS_CONF_RMT_MEM_FORCE_PD = 0x4
	// Position of RMT_MEM_FORCE_PU field.
	RMT_SYS_CONF_RMT_MEM_FORCE_PU_Pos = 0x3
	// Bit mask of RMT_MEM_FORCE_PU field.
	RMT_SYS_CONF_RMT_MEM_FORCE_PU_Msk = 0x8
	// Bit RMT_MEM_FORCE_PU.
	RMT_SYS_CONF_RMT_MEM_FORCE_PU = 0x8
	// Position of RMT_SCLK_DIV_NUM field.
	RMT_SYS_CONF_RMT_SCLK_DIV_NUM_Pos = 0x4
	// Bit mask of RMT_SCLK_DIV_NUM field.
	RMT_SYS_CONF_RMT_SCLK_DIV_NUM_Msk = 0xff0
	// Position of RMT_SCLK_DIV_A field.
	RMT_SYS_CONF_RMT_SCLK_DIV_A_Pos = 0xc
	// Bit mask of RMT_SCLK_DIV_A field.
	RMT_SYS_CONF_RMT_SCLK_DIV_A_Msk = 0x3f000
	// Position of RMT_SCLK_DIV_B field.
	RMT_SYS_CONF_RMT_SCLK_DIV_B_Pos = 0x12
	// Bit mask of RMT_SCLK_DIV_B field.
	RMT_SYS_CONF_RMT_SCLK_DIV_B_Msk = 0xfc0000
	// Position of RMT_SCLK_SEL field.
	RMT_SYS_CONF_RMT_SCLK_SEL_Pos = 0x18
	// Bit mask of RMT_SCLK_SEL field.
	RMT_SYS_CONF_RMT_SCLK_SEL_Msk = 0x3000000
	// Position of RMT_SCLK_ACTIVE field.
	RMT_SYS_CONF_RMT_SCLK_ACTIVE_Pos = 0x1a
	// Bit mask of RMT_SCLK_ACTIVE field.
	RMT_SYS_CONF_RMT_SCLK_ACTIVE_Msk = 0x4000000
	// Bit RMT_SCLK_ACTIVE.
	RMT_SYS_CONF_RMT_SCLK_ACTIVE = 0x4000000
	// Position of CLK_EN field.
	RMT_SYS_CONF_CLK_EN_Pos = 0x1f
	// Bit mask of CLK_EN field.
	RMT_SYS_CONF_CLK_EN_Msk = 0x80000000
	// Bit CLK_EN.
	RMT_SYS_CONF_CLK_EN = 0x80000000

	// TX_SIM: RMT_TX_SIM_REG.
	// Position of RMT_TX_SIM_CH0 field.
	RMT_TX_SIM_RMT_TX_SIM_CH0_Pos = 0x0
	// Bit mask of RMT_TX_SIM_CH0 field.
	RMT_TX_SIM_RMT_TX_SIM_CH0_Msk = 0x1
	// Bit RMT_TX_SIM_CH0.
	RMT_TX_SIM_RMT_TX_SIM_CH0 = 0x1
	// Position of RMT_TX_SIM_CH1 field.
	RMT_TX_SIM_RMT_TX_SIM_CH1_Pos = 0x1
	// Bit mask of RMT_TX_SIM_CH1 field.
	RMT_TX_SIM_RMT_TX_SIM_CH1_Msk = 0x2
	// Bit RMT_TX_SIM_CH1.
	RMT_TX_SIM_RMT_TX_SIM_CH1 = 0x2
	// Position of RMT_TX_SIM_EN field.
	RMT_TX_SIM_RMT_TX_SIM_EN_Pos = 0x2
	// Bit mask of RMT_TX_SIM_EN field.
	RMT_TX_SIM_RMT_TX_SIM_EN_Msk = 0x4
	// Bit RMT_TX_SIM_EN.
	RMT_TX_SIM_RMT_TX_SIM_EN = 0x4

	// REF_CNT_RST: RMT_REF_CNT_RST_REG.
	// Position of CH0 field.
	RMT_REF_CNT_RST_CH0_Pos = 0x0
	// Bit mask of CH0 field.
	RMT_REF_CNT_RST_CH0_Msk = 0x1
	// Bit CH0.
	RMT_REF_CNT_RST_CH0 = 0x1
	// Position of CH1 field.
	RMT_REF_CNT_RST_CH1_Pos = 0x1
	// Bit mask of CH1 field.
	RMT_REF_CNT_RST_CH1_Msk = 0x2
	// Bit CH1.
	RMT_REF_CNT_RST_CH1 = 0x2
	// Position of CH2 field.
	RMT_REF_CNT_RST_CH2_Pos = 0x2
	// Bit mask of CH2 field.
	RMT_REF_CNT_RST_CH2_Msk = 0x4
	// Bit CH2.
	RMT_REF_CNT_RST_CH2 = 0x4
	// Position of CH3 field.
	RMT_REF_CNT_RST_CH3_Pos = 0x3
	// Bit mask of CH3 field.
	RMT_REF_CNT_RST_CH3_Msk = 0x8
	// Bit CH3.
	RMT_REF_CNT_RST_CH3 = 0x8

	// DATE: RMT_DATE_REG.
	// Position of RMT_DATE field.
	RMT_DATE_RMT_DATE_Pos = 0x0
	// Bit mask of RMT_DATE field.
	RMT_DATE_RMT_DATE_Msk = 0xfffffff
)

// Constants for RSA: Peripheral RSA
const (
	// M_PRIME: RSA M_prime register
	// Position of M_PRIME field.
	RSA_M_PRIME_M_PRIME_Pos = 0x0
	// Bit mask of M_PRIME field.
	RSA_M_PRIME_M_PRIME_Msk = 0xffffffff

	// MODE: RSA mode register
	// Position of MODE field.
	RSA_MODE_MODE_Pos = 0x0
	// Bit mask of MODE field.
	RSA_MODE_MODE_Msk = 0x7f

	// QUERY_CLEAN: RSA query clean register
	// Position of QUERY_CLEAN field.
	RSA_QUERY_CLEAN_QUERY_CLEAN_Pos = 0x0
	// Bit mask of QUERY_CLEAN field.
	RSA_QUERY_CLEAN_QUERY_CLEAN_Msk = 0x1
	// Bit QUERY_CLEAN.
	RSA_QUERY_CLEAN_QUERY_CLEAN = 0x1

	// SET_START_MODEXP: RSA modular exponentiation trigger register.
	// Position of SET_START_MODEXP field.
	RSA_SET_START_MODEXP_SET_START_MODEXP_Pos = 0x0
	// Bit mask of SET_START_MODEXP field.
	RSA_SET_START_MODEXP_SET_START_MODEXP_Msk = 0x1
	// Bit SET_START_MODEXP.
	RSA_SET_START_MODEXP_SET_START_MODEXP = 0x1

	// SET_START_MODMULT: RSA modular multiplication trigger register.
	// Position of SET_START_MODMULT field.
	RSA_SET_START_MODMULT_SET_START_MODMULT_Pos = 0x0
	// Bit mask of SET_START_MODMULT field.
	RSA_SET_START_MODMULT_SET_START_MODMULT_Msk = 0x1
	// Bit SET_START_MODMULT.
	RSA_SET_START_MODMULT_SET_START_MODMULT = 0x1

	// SET_START_MULT: RSA normal multiplication trigger register.
	// Position of SET_START_MULT field.
	RSA_SET_START_MULT_SET_START_MULT_Pos = 0x0
	// Bit mask of SET_START_MULT field.
	RSA_SET_START_MULT_SET_START_MULT_Msk = 0x1
	// Bit SET_START_MULT.
	RSA_SET_START_MULT_SET_START_MULT = 0x1

	// QUERY_IDLE: RSA query idle register
	// Position of QUERY_IDLE field.
	RSA_QUERY_IDLE_QUERY_IDLE_Pos = 0x0
	// Bit mask of QUERY_IDLE field.
	RSA_QUERY_IDLE_QUERY_IDLE_Msk = 0x1
	// Bit QUERY_IDLE.
	RSA_QUERY_IDLE_QUERY_IDLE = 0x1

	// INT_CLR: RSA interrupt clear register
	// Position of CLEAR_INTERRUPT field.
	RSA_INT_CLR_CLEAR_INTERRUPT_Pos = 0x0
	// Bit mask of CLEAR_INTERRUPT field.
	RSA_INT_CLR_CLEAR_INTERRUPT_Msk = 0x1
	// Bit CLEAR_INTERRUPT.
	RSA_INT_CLR_CLEAR_INTERRUPT = 0x1

	// CONSTANT_TIME: RSA constant time option register
	// Position of CONSTANT_TIME field.
	RSA_CONSTANT_TIME_CONSTANT_TIME_Pos = 0x0
	// Bit mask of CONSTANT_TIME field.
	RSA_CONSTANT_TIME_CONSTANT_TIME_Msk = 0x1
	// Bit CONSTANT_TIME.
	RSA_CONSTANT_TIME_CONSTANT_TIME = 0x1

	// SEARCH_ENABLE: RSA search option
	// Position of SEARCH_ENABLE field.
	RSA_SEARCH_ENABLE_SEARCH_ENABLE_Pos = 0x0
	// Bit mask of SEARCH_ENABLE field.
	RSA_SEARCH_ENABLE_SEARCH_ENABLE_Msk = 0x1
	// Bit SEARCH_ENABLE.
	RSA_SEARCH_ENABLE_SEARCH_ENABLE = 0x1

	// SEARCH_POS: RSA search position configure register
	// Position of SEARCH_POS field.
	RSA_SEARCH_POS_SEARCH_POS_Pos = 0x0
	// Bit mask of SEARCH_POS field.
	RSA_SEARCH_POS_SEARCH_POS_Msk = 0xfff

	// INT_ENA: RSA interrupt enable register
	// Position of INT_ENA field.
	RSA_INT_ENA_INT_ENA_Pos = 0x0
	// Bit mask of INT_ENA field.
	RSA_INT_ENA_INT_ENA_Msk = 0x1
	// Bit INT_ENA.
	RSA_INT_ENA_INT_ENA = 0x1

	// DATE: RSA version control register
	// Position of DATE field.
	RSA_DATE_DATE_Pos = 0x0
	// Bit mask of DATE field.
	RSA_DATE_DATE_Msk = 0x3fffffff
)

// Constants for RTC_CNTL: Peripheral RTC_CNTL
const (
	// RTC_OPTIONS0: rtc configure register
	// Position of SW_STALL_APPCPU_C0 field.
	RTC_CNTL_RTC_OPTIONS0_SW_STALL_APPCPU_C0_Pos = 0x0
	// Bit mask of SW_STALL_APPCPU_C0 field.
	RTC_CNTL_RTC_OPTIONS0_SW_STALL_APPCPU_C0_Msk = 0x3
	// Position of SW_STALL_PROCPU_C0 field.
	RTC_CNTL_RTC_OPTIONS0_SW_STALL_PROCPU_C0_Pos = 0x2
	// Bit mask of SW_STALL_PROCPU_C0 field.
	RTC_CNTL_RTC_OPTIONS0_SW_STALL_PROCPU_C0_Msk = 0xc
	// Position of SW_APPCPU_RST field.
	RTC_CNTL_RTC_OPTIONS0_SW_APPCPU_RST_Pos = 0x4
	// Bit mask of SW_APPCPU_RST field.
	RTC_CNTL_RTC_OPTIONS0_SW_APPCPU_RST_Msk = 0x10
	// Bit SW_APPCPU_RST.
	RTC_CNTL_RTC_OPTIONS0_SW_APPCPU_RST = 0x10
	// Position of SW_PROCPU_RST field.
	RTC_CNTL_RTC_OPTIONS0_SW_PROCPU_RST_Pos = 0x5
	// Bit mask of SW_PROCPU_RST field.
	RTC_CNTL_RTC_OPTIONS0_SW_PROCPU_RST_Msk = 0x20
	// Bit SW_PROCPU_RST.
	RTC_CNTL_RTC_OPTIONS0_SW_PROCPU_RST = 0x20
	// Position of BB_I2C_FORCE_PD field.
	RTC_CNTL_RTC_OPTIONS0_BB_I2C_FORCE_PD_Pos = 0x6
	// Bit mask of BB_I2C_FORCE_PD field.
	RTC_CNTL_RTC_OPTIONS0_BB_I2C_FORCE_PD_Msk = 0x40
	// Bit BB_I2C_FORCE_PD.
	RTC_CNTL_RTC_OPTIONS0_BB_I2C_FORCE_PD = 0x40
	// Position of BB_I2C_FORCE_PU field.
	RTC_CNTL_RTC_OPTIONS0_BB_I2C_FORCE_PU_Pos = 0x7
	// Bit mask of BB_I2C_FORCE_PU field.
	RTC_CNTL_RTC_OPTIONS0_BB_I2C_FORCE_PU_Msk = 0x80
	// Bit BB_I2C_FORCE_PU.
	RTC_CNTL_RTC_OPTIONS0_BB_I2C_FORCE_PU = 0x80
	// Position of BBPLL_I2C_FORCE_PD field.
	RTC_CNTL_RTC_OPTIONS0_BBPLL_I2C_FORCE_PD_Pos = 0x8
	// Bit mask of BBPLL_I2C_FORCE_PD field.
	RTC_CNTL_RTC_OPTIONS0_BBPLL_I2C_FORCE_PD_Msk = 0x100
	// Bit BBPLL_I2C_FORCE_PD.
	RTC_CNTL_RTC_OPTIONS0_BBPLL_I2C_FORCE_PD = 0x100
	// Position of BBPLL_I2C_FORCE_PU field.
	RTC_CNTL_RTC_OPTIONS0_BBPLL_I2C_FORCE_PU_Pos = 0x9
	// Bit mask of BBPLL_I2C_FORCE_PU field.
	RTC_CNTL_RTC_OPTIONS0_BBPLL_I2C_FORCE_PU_Msk = 0x200
	// Bit BBPLL_I2C_FORCE_PU.
	RTC_CNTL_RTC_OPTIONS0_BBPLL_I2C_FORCE_PU = 0x200
	// Position of BBPLL_FORCE_PD field.
	RTC_CNTL_RTC_OPTIONS0_BBPLL_FORCE_PD_Pos = 0xa
	// Bit mask of BBPLL_FORCE_PD field.
	RTC_CNTL_RTC_OPTIONS0_BBPLL_FORCE_PD_Msk = 0x400
	// Bit BBPLL_FORCE_PD.
	RTC_CNTL_RTC_OPTIONS0_BBPLL_FORCE_PD = 0x400
	// Position of BBPLL_FORCE_PU field.
	RTC_CNTL_RTC_OPTIONS0_BBPLL_FORCE_PU_Pos = 0xb
	// Bit mask of BBPLL_FORCE_PU field.
	RTC_CNTL_RTC_OPTIONS0_BBPLL_FORCE_PU_Msk = 0x800
	// Bit BBPLL_FORCE_PU.
	RTC_CNTL_RTC_OPTIONS0_BBPLL_FORCE_PU = 0x800
	// Position of XTL_FORCE_PD field.
	RTC_CNTL_RTC_OPTIONS0_XTL_FORCE_PD_Pos = 0xc
	// Bit mask of XTL_FORCE_PD field.
	RTC_CNTL_RTC_OPTIONS0_XTL_FORCE_PD_Msk = 0x1000
	// Bit XTL_FORCE_PD.
	RTC_CNTL_RTC_OPTIONS0_XTL_FORCE_PD = 0x1000
	// Position of XTL_FORCE_PU field.
	RTC_CNTL_RTC_OPTIONS0_XTL_FORCE_PU_Pos = 0xd
	// Bit mask of XTL_FORCE_PU field.
	RTC_CNTL_RTC_OPTIONS0_XTL_FORCE_PU_Msk = 0x2000
	// Bit XTL_FORCE_PU.
	RTC_CNTL_RTC_OPTIONS0_XTL_FORCE_PU = 0x2000
	// Position of XTL_EN_WAIT field.
	RTC_CNTL_RTC_OPTIONS0_XTL_EN_WAIT_Pos = 0xe
	// Bit mask of XTL_EN_WAIT field.
	RTC_CNTL_RTC_OPTIONS0_XTL_EN_WAIT_Msk = 0x3c000
	// Position of XTL_EXT_CTR_SEL field.
	RTC_CNTL_RTC_OPTIONS0_XTL_EXT_CTR_SEL_Pos = 0x14
	// Bit mask of XTL_EXT_CTR_SEL field.
	RTC_CNTL_RTC_OPTIONS0_XTL_EXT_CTR_SEL_Msk = 0x700000
	// Position of XTL_FORCE_ISO field.
	RTC_CNTL_RTC_OPTIONS0_XTL_FORCE_ISO_Pos = 0x17
	// Bit mask of XTL_FORCE_ISO field.
	RTC_CNTL_RTC_OPTIONS0_XTL_FORCE_ISO_Msk = 0x800000
	// Bit XTL_FORCE_ISO.
	RTC_CNTL_RTC_OPTIONS0_XTL_FORCE_ISO = 0x800000
	// Position of PLL_FORCE_ISO field.
	RTC_CNTL_RTC_OPTIONS0_PLL_FORCE_ISO_Pos = 0x18
	// Bit mask of PLL_FORCE_ISO field.
	RTC_CNTL_RTC_OPTIONS0_PLL_FORCE_ISO_Msk = 0x1000000
	// Bit PLL_FORCE_ISO.
	RTC_CNTL_RTC_OPTIONS0_PLL_FORCE_ISO = 0x1000000
	// Position of ANALOG_FORCE_ISO field.
	RTC_CNTL_RTC_OPTIONS0_ANALOG_FORCE_ISO_Pos = 0x19
	// Bit mask of ANALOG_FORCE_ISO field.
	RTC_CNTL_RTC_OPTIONS0_ANALOG_FORCE_ISO_Msk = 0x2000000
	// Bit ANALOG_FORCE_ISO.
	RTC_CNTL_RTC_OPTIONS0_ANALOG_FORCE_ISO = 0x2000000
	// Position of XTL_FORCE_NOISO field.
	RTC_CNTL_RTC_OPTIONS0_XTL_FORCE_NOISO_Pos = 0x1a
	// Bit mask of XTL_FORCE_NOISO field.
	RTC_CNTL_RTC_OPTIONS0_XTL_FORCE_NOISO_Msk = 0x4000000
	// Bit XTL_FORCE_NOISO.
	RTC_CNTL_RTC_OPTIONS0_XTL_FORCE_NOISO = 0x4000000
	// Position of PLL_FORCE_NOISO field.
	RTC_CNTL_RTC_OPTIONS0_PLL_FORCE_NOISO_Pos = 0x1b
	// Bit mask of PLL_FORCE_NOISO field.
	RTC_CNTL_RTC_OPTIONS0_PLL_FORCE_NOISO_Msk = 0x8000000
	// Bit PLL_FORCE_NOISO.
	RTC_CNTL_RTC_OPTIONS0_PLL_FORCE_NOISO = 0x8000000
	// Position of ANALOG_FORCE_NOISO field.
	RTC_CNTL_RTC_OPTIONS0_ANALOG_FORCE_NOISO_Pos = 0x1c
	// Bit mask of ANALOG_FORCE_NOISO field.
	RTC_CNTL_RTC_OPTIONS0_ANALOG_FORCE_NOISO_Msk = 0x10000000
	// Bit ANALOG_FORCE_NOISO.
	RTC_CNTL_RTC_OPTIONS0_ANALOG_FORCE_NOISO = 0x10000000
	// Position of DG_WRAP_FORCE_RST field.
	RTC_CNTL_RTC_OPTIONS0_DG_WRAP_FORCE_RST_Pos = 0x1d
	// Bit mask of DG_WRAP_FORCE_RST field.
	RTC_CNTL_RTC_OPTIONS0_DG_WRAP_FORCE_RST_Msk = 0x20000000
	// Bit DG_WRAP_FORCE_RST.
	RTC_CNTL_RTC_OPTIONS0_DG_WRAP_FORCE_RST = 0x20000000
	// Position of DG_WRAP_FORCE_NORST field.
	RTC_CNTL_RTC_OPTIONS0_DG_WRAP_FORCE_NORST_Pos = 0x1e
	// Bit mask of DG_WRAP_FORCE_NORST field.
	RTC_CNTL_RTC_OPTIONS0_DG_WRAP_FORCE_NORST_Msk = 0x40000000
	// Bit DG_WRAP_FORCE_NORST.
	RTC_CNTL_RTC_OPTIONS0_DG_WRAP_FORCE_NORST = 0x40000000
	// Position of SW_SYS_RST field.
	RTC_CNTL_RTC_OPTIONS0_SW_SYS_RST_Pos = 0x1f
	// Bit mask of SW_SYS_RST field.
	RTC_CNTL_RTC_OPTIONS0_SW_SYS_RST_Msk = 0x80000000
	// Bit SW_SYS_RST.
	RTC_CNTL_RTC_OPTIONS0_SW_SYS_RST = 0x80000000

	// RTC_SLP_TIMER0: rtc configure register
	// Position of SLP_VAL_LO field.
	RTC_CNTL_RTC_SLP_TIMER0_SLP_VAL_LO_Pos = 0x0
	// Bit mask of SLP_VAL_LO field.
	RTC_CNTL_RTC_SLP_TIMER0_SLP_VAL_LO_Msk = 0xffffffff

	// RTC_SLP_TIMER1: rtc configure register
	// Position of SLP_VAL_HI field.
	RTC_CNTL_RTC_SLP_TIMER1_SLP_VAL_HI_Pos = 0x0
	// Bit mask of SLP_VAL_HI field.
	RTC_CNTL_RTC_SLP_TIMER1_SLP_VAL_HI_Msk = 0xffff
	// Position of RTC_MAIN_TIMER_ALARM_EN field.
	RTC_CNTL_RTC_SLP_TIMER1_RTC_MAIN_TIMER_ALARM_EN_Pos = 0x10
	// Bit mask of RTC_MAIN_TIMER_ALARM_EN field.
	RTC_CNTL_RTC_SLP_TIMER1_RTC_MAIN_TIMER_ALARM_EN_Msk = 0x10000
	// Bit RTC_MAIN_TIMER_ALARM_EN.
	RTC_CNTL_RTC_SLP_TIMER1_RTC_MAIN_TIMER_ALARM_EN = 0x10000

	// RTC_TIME_UPDATE: rtc configure register
	// Position of TIMER_SYS_STALL field.
	RTC_CNTL_RTC_TIME_UPDATE_TIMER_SYS_STALL_Pos = 0x1b
	// Bit mask of TIMER_SYS_STALL field.
	RTC_CNTL_RTC_TIME_UPDATE_TIMER_SYS_STALL_Msk = 0x8000000
	// Bit TIMER_SYS_STALL.
	RTC_CNTL_RTC_TIME_UPDATE_TIMER_SYS_STALL = 0x8000000
	// Position of TIMER_XTL_OFF field.
	RTC_CNTL_RTC_TIME_UPDATE_TIMER_XTL_OFF_Pos = 0x1c
	// Bit mask of TIMER_XTL_OFF field.
	RTC_CNTL_RTC_TIME_UPDATE_TIMER_XTL_OFF_Msk = 0x10000000
	// Bit TIMER_XTL_OFF.
	RTC_CNTL_RTC_TIME_UPDATE_TIMER_XTL_OFF = 0x10000000
	// Position of TIMER_SYS_RST field.
	RTC_CNTL_RTC_TIME_UPDATE_TIMER_SYS_RST_Pos = 0x1d
	// Bit mask of TIMER_SYS_RST field.
	RTC_CNTL_RTC_TIME_UPDATE_TIMER_SYS_RST_Msk = 0x20000000
	// Bit TIMER_SYS_RST.
	RTC_CNTL_RTC_TIME_UPDATE_TIMER_SYS_RST = 0x20000000
	// Position of RTC_TIME_UPDATE field.
	RTC_CNTL_RTC_TIME_UPDATE_RTC_TIME_UPDATE_Pos = 0x1f
	// Bit mask of RTC_TIME_UPDATE field.
	RTC_CNTL_RTC_TIME_UPDATE_RTC_TIME_UPDATE_Msk = 0x80000000
	// Bit RTC_TIME_UPDATE.
	RTC_CNTL_RTC_TIME_UPDATE_RTC_TIME_UPDATE = 0x80000000

	// RTC_TIME_LOW0: rtc configure register
	// Position of RTC_TIMER_VALUE0_LOW field.
	RTC_CNTL_RTC_TIME_LOW0_RTC_TIMER_VALUE0_LOW_Pos = 0x0
	// Bit mask of RTC_TIMER_VALUE0_LOW field.
	RTC_CNTL_RTC_TIME_LOW0_RTC_TIMER_VALUE0_LOW_Msk = 0xffffffff

	// RTC_TIME_HIGH0: rtc configure register
	// Position of RTC_TIMER_VALUE0_HIGH field.
	RTC_CNTL_RTC_TIME_HIGH0_RTC_TIMER_VALUE0_HIGH_Pos = 0x0
	// Bit mask of RTC_TIMER_VALUE0_HIGH field.
	RTC_CNTL_RTC_TIME_HIGH0_RTC_TIMER_VALUE0_HIGH_Msk = 0xffff

	// RTC_STATE0: rtc configure register
	// Position of RTC_SW_CPU_INT field.
	RTC_CNTL_RTC_STATE0_RTC_SW_CPU_INT_Pos = 0x0
	// Bit mask of RTC_SW_CPU_INT field.
	RTC_CNTL_RTC_STATE0_RTC_SW_CPU_INT_Msk = 0x1
	// Bit RTC_SW_CPU_INT.
	RTC_CNTL_RTC_STATE0_RTC_SW_CPU_INT = 0x1
	// Position of RTC_SLP_REJECT_CAUSE_CLR field.
	RTC_CNTL_RTC_STATE0_RTC_SLP_REJECT_CAUSE_CLR_Pos = 0x1
	// Bit mask of RTC_SLP_REJECT_CAUSE_CLR field.
	RTC_CNTL_RTC_STATE0_RTC_SLP_REJECT_CAUSE_CLR_Msk = 0x2
	// Bit RTC_SLP_REJECT_CAUSE_CLR.
	RTC_CNTL_RTC_STATE0_RTC_SLP_REJECT_CAUSE_CLR = 0x2
	// Position of APB2RTC_BRIDGE_SEL field.
	RTC_CNTL_RTC_STATE0_APB2RTC_BRIDGE_SEL_Pos = 0x16
	// Bit mask of APB2RTC_BRIDGE_SEL field.
	RTC_CNTL_RTC_STATE0_APB2RTC_BRIDGE_SEL_Msk = 0x400000
	// Bit APB2RTC_BRIDGE_SEL.
	RTC_CNTL_RTC_STATE0_APB2RTC_BRIDGE_SEL = 0x400000
	// Position of SDIO_ACTIVE_IND field.
	RTC_CNTL_RTC_STATE0_SDIO_ACTIVE_IND_Pos = 0x1c
	// Bit mask of SDIO_ACTIVE_IND field.
	RTC_CNTL_RTC_STATE0_SDIO_ACTIVE_IND_Msk = 0x10000000
	// Bit SDIO_ACTIVE_IND.
	RTC_CNTL_RTC_STATE0_SDIO_ACTIVE_IND = 0x10000000
	// Position of SLP_WAKEUP field.
	RTC_CNTL_RTC_STATE0_SLP_WAKEUP_Pos = 0x1d
	// Bit mask of SLP_WAKEUP field.
	RTC_CNTL_RTC_STATE0_SLP_WAKEUP_Msk = 0x20000000
	// Bit SLP_WAKEUP.
	RTC_CNTL_RTC_STATE0_SLP_WAKEUP = 0x20000000
	// Position of SLP_REJECT field.
	RTC_CNTL_RTC_STATE0_SLP_REJECT_Pos = 0x1e
	// Bit mask of SLP_REJECT field.
	RTC_CNTL_RTC_STATE0_SLP_REJECT_Msk = 0x40000000
	// Bit SLP_REJECT.
	RTC_CNTL_RTC_STATE0_SLP_REJECT = 0x40000000
	// Position of SLEEP_EN field.
	RTC_CNTL_RTC_STATE0_SLEEP_EN_Pos = 0x1f
	// Bit mask of SLEEP_EN field.
	RTC_CNTL_RTC_STATE0_SLEEP_EN_Msk = 0x80000000
	// Bit SLEEP_EN.
	RTC_CNTL_RTC_STATE0_SLEEP_EN = 0x80000000

	// RTC_TIMER1: rtc configure register
	// Position of CPU_STALL_EN field.
	RTC_CNTL_RTC_TIMER1_CPU_STALL_EN_Pos = 0x0
	// Bit mask of CPU_STALL_EN field.
	RTC_CNTL_RTC_TIMER1_CPU_STALL_EN_Msk = 0x1
	// Bit CPU_STALL_EN.
	RTC_CNTL_RTC_TIMER1_CPU_STALL_EN = 0x1
	// Position of CPU_STALL_WAIT field.
	RTC_CNTL_RTC_TIMER1_CPU_STALL_WAIT_Pos = 0x1
	// Bit mask of CPU_STALL_WAIT field.
	RTC_CNTL_RTC_TIMER1_CPU_STALL_WAIT_Msk = 0x3e
	// Position of CK8M_WAIT field.
	RTC_CNTL_RTC_TIMER1_CK8M_WAIT_Pos = 0x6
	// Bit mask of CK8M_WAIT field.
	RTC_CNTL_RTC_TIMER1_CK8M_WAIT_Msk = 0x3fc0
	// Position of XTL_BUF_WAIT field.
	RTC_CNTL_RTC_TIMER1_XTL_BUF_WAIT_Pos = 0xe
	// Bit mask of XTL_BUF_WAIT field.
	RTC_CNTL_RTC_TIMER1_XTL_BUF_WAIT_Msk = 0xffc000
	// Position of PLL_BUF_WAIT field.
	RTC_CNTL_RTC_TIMER1_PLL_BUF_WAIT_Pos = 0x18
	// Bit mask of PLL_BUF_WAIT field.
	RTC_CNTL_RTC_TIMER1_PLL_BUF_WAIT_Msk = 0xff000000

	// RTC_TIMER2: rtc configure register
	// Position of MIN_TIME_CK8M_OFF field.
	RTC_CNTL_RTC_TIMER2_MIN_TIME_CK8M_OFF_Pos = 0x18
	// Bit mask of MIN_TIME_CK8M_OFF field.
	RTC_CNTL_RTC_TIMER2_MIN_TIME_CK8M_OFF_Msk = 0xff000000

	// RTC_TIMER3: rtc configure register
	// Position of WIFI_WAIT_TIMER field.
	RTC_CNTL_RTC_TIMER3_WIFI_WAIT_TIMER_Pos = 0x0
	// Bit mask of WIFI_WAIT_TIMER field.
	RTC_CNTL_RTC_TIMER3_WIFI_WAIT_TIMER_Msk = 0x1ff
	// Position of WIFI_POWERUP_TIMER field.
	RTC_CNTL_RTC_TIMER3_WIFI_POWERUP_TIMER_Pos = 0x9
	// Bit mask of WIFI_POWERUP_TIMER field.
	RTC_CNTL_RTC_TIMER3_WIFI_POWERUP_TIMER_Msk = 0xfe00
	// Position of BT_WAIT_TIMER field.
	RTC_CNTL_RTC_TIMER3_BT_WAIT_TIMER_Pos = 0x10
	// Bit mask of BT_WAIT_TIMER field.
	RTC_CNTL_RTC_TIMER3_BT_WAIT_TIMER_Msk = 0x1ff0000
	// Position of BT_POWERUP_TIMER field.
	RTC_CNTL_RTC_TIMER3_BT_POWERUP_TIMER_Pos = 0x19
	// Bit mask of BT_POWERUP_TIMER field.
	RTC_CNTL_RTC_TIMER3_BT_POWERUP_TIMER_Msk = 0xfe000000

	// RTC_TIMER4: rtc configure register
	// Position of CPU_TOP_WAIT_TIMER field.
	RTC_CNTL_RTC_TIMER4_CPU_TOP_WAIT_TIMER_Pos = 0x0
	// Bit mask of CPU_TOP_WAIT_TIMER field.
	RTC_CNTL_RTC_TIMER4_CPU_TOP_WAIT_TIMER_Msk = 0x1ff
	// Position of CPU_TOP_POWERUP_TIMER field.
	RTC_CNTL_RTC_TIMER4_CPU_TOP_POWERUP_TIMER_Pos = 0x9
	// Bit mask of CPU_TOP_POWERUP_TIMER field.
	RTC_CNTL_RTC_TIMER4_CPU_TOP_POWERUP_TIMER_Msk = 0xfe00
	// Position of DG_WRAP_WAIT_TIMER field.
	RTC_CNTL_RTC_TIMER4_DG_WRAP_WAIT_TIMER_Pos = 0x10
	// Bit mask of DG_WRAP_WAIT_TIMER field.
	RTC_CNTL_RTC_TIMER4_DG_WRAP_WAIT_TIMER_Msk = 0x1ff0000
	// Position of DG_WRAP_POWERUP_TIMER field.
	RTC_CNTL_RTC_TIMER4_DG_WRAP_POWERUP_TIMER_Pos = 0x19
	// Bit mask of DG_WRAP_POWERUP_TIMER field.
	RTC_CNTL_RTC_TIMER4_DG_WRAP_POWERUP_TIMER_Msk = 0xfe000000

	// RTC_TIMER5: rtc configure register
	// Position of MIN_SLP_VAL field.
	RTC_CNTL_RTC_TIMER5_MIN_SLP_VAL_Pos = 0x8
	// Bit mask of MIN_SLP_VAL field.
	RTC_CNTL_RTC_TIMER5_MIN_SLP_VAL_Msk = 0xff00

	// RTC_TIMER6: rtc configure register
	// Position of DG_PERI_WAIT_TIMER field.
	RTC_CNTL_RTC_TIMER6_DG_PERI_WAIT_TIMER_Pos = 0x10
	// Bit mask of DG_PERI_WAIT_TIMER field.
	RTC_CNTL_RTC_TIMER6_DG_PERI_WAIT_TIMER_Msk = 0x1ff0000
	// Position of DG_PERI_POWERUP_TIMER field.
	RTC_CNTL_RTC_TIMER6_DG_PERI_POWERUP_TIMER_Pos = 0x19
	// Bit mask of DG_PERI_POWERUP_TIMER field.
	RTC_CNTL_RTC_TIMER6_DG_PERI_POWERUP_TIMER_Msk = 0xfe000000

	// RTC_ANA_CONF: rtc configure register
	// Position of RESET_POR_FORCE_PD field.
	RTC_CNTL_RTC_ANA_CONF_RESET_POR_FORCE_PD_Pos = 0x12
	// Bit mask of RESET_POR_FORCE_PD field.
	RTC_CNTL_RTC_ANA_CONF_RESET_POR_FORCE_PD_Msk = 0x40000
	// Bit RESET_POR_FORCE_PD.
	RTC_CNTL_RTC_ANA_CONF_RESET_POR_FORCE_PD = 0x40000
	// Position of RESET_POR_FORCE_PU field.
	RTC_CNTL_RTC_ANA_CONF_RESET_POR_FORCE_PU_Pos = 0x13
	// Bit mask of RESET_POR_FORCE_PU field.
	RTC_CNTL_RTC_ANA_CONF_RESET_POR_FORCE_PU_Msk = 0x80000
	// Bit RESET_POR_FORCE_PU.
	RTC_CNTL_RTC_ANA_CONF_RESET_POR_FORCE_PU = 0x80000
	// Position of GLITCH_RST_EN field.
	RTC_CNTL_RTC_ANA_CONF_GLITCH_RST_EN_Pos = 0x14
	// Bit mask of GLITCH_RST_EN field.
	RTC_CNTL_RTC_ANA_CONF_GLITCH_RST_EN_Msk = 0x100000
	// Bit GLITCH_RST_EN.
	RTC_CNTL_RTC_ANA_CONF_GLITCH_RST_EN = 0x100000
	// Position of SAR_I2C_PU field.
	RTC_CNTL_RTC_ANA_CONF_SAR_I2C_PU_Pos = 0x16
	// Bit mask of SAR_I2C_PU field.
	RTC_CNTL_RTC_ANA_CONF_SAR_I2C_PU_Msk = 0x400000
	// Bit SAR_I2C_PU.
	RTC_CNTL_RTC_ANA_CONF_SAR_I2C_PU = 0x400000
	// Position of PLLA_FORCE_PD field.
	RTC_CNTL_RTC_ANA_CONF_PLLA_FORCE_PD_Pos = 0x17
	// Bit mask of PLLA_FORCE_PD field.
	RTC_CNTL_RTC_ANA_CONF_PLLA_FORCE_PD_Msk = 0x800000
	// Bit PLLA_FORCE_PD.
	RTC_CNTL_RTC_ANA_CONF_PLLA_FORCE_PD = 0x800000
	// Position of PLLA_FORCE_PU field.
	RTC_CNTL_RTC_ANA_CONF_PLLA_FORCE_PU_Pos = 0x18
	// Bit mask of PLLA_FORCE_PU field.
	RTC_CNTL_RTC_ANA_CONF_PLLA_FORCE_PU_Msk = 0x1000000
	// Bit PLLA_FORCE_PU.
	RTC_CNTL_RTC_ANA_CONF_PLLA_FORCE_PU = 0x1000000
	// Position of BBPLL_CAL_SLP_START field.
	RTC_CNTL_RTC_ANA_CONF_BBPLL_CAL_SLP_START_Pos = 0x19
	// Bit mask of BBPLL_CAL_SLP_START field.
	RTC_CNTL_RTC_ANA_CONF_BBPLL_CAL_SLP_START_Msk = 0x2000000
	// Bit BBPLL_CAL_SLP_START.
	RTC_CNTL_RTC_ANA_CONF_BBPLL_CAL_SLP_START = 0x2000000
	// Position of PVTMON_PU field.
	RTC_CNTL_RTC_ANA_CONF_PVTMON_PU_Pos = 0x1a
	// Bit mask of PVTMON_PU field.
	RTC_CNTL_RTC_ANA_CONF_PVTMON_PU_Msk = 0x4000000
	// Bit PVTMON_PU.
	RTC_CNTL_RTC_ANA_CONF_PVTMON_PU = 0x4000000
	// Position of TXRF_I2C_PU field.
	RTC_CNTL_RTC_ANA_CONF_TXRF_I2C_PU_Pos = 0x1b
	// Bit mask of TXRF_I2C_PU field.
	RTC_CNTL_RTC_ANA_CONF_TXRF_I2C_PU_Msk = 0x8000000
	// Bit TXRF_I2C_PU.
	RTC_CNTL_RTC_ANA_CONF_TXRF_I2C_PU = 0x8000000
	// Position of RFRX_PBUS_PU field.
	RTC_CNTL_RTC_ANA_CONF_RFRX_PBUS_PU_Pos = 0x1c
	// Bit mask of RFRX_PBUS_PU field.
	RTC_CNTL_RTC_ANA_CONF_RFRX_PBUS_PU_Msk = 0x10000000
	// Bit RFRX_PBUS_PU.
	RTC_CNTL_RTC_ANA_CONF_RFRX_PBUS_PU = 0x10000000
	// Position of CKGEN_I2C_PU field.
	RTC_CNTL_RTC_ANA_CONF_CKGEN_I2C_PU_Pos = 0x1e
	// Bit mask of CKGEN_I2C_PU field.
	RTC_CNTL_RTC_ANA_CONF_CKGEN_I2C_PU_Msk = 0x40000000
	// Bit CKGEN_I2C_PU.
	RTC_CNTL_RTC_ANA_CONF_CKGEN_I2C_PU = 0x40000000
	// Position of PLL_I2C_PU field.
	RTC_CNTL_RTC_ANA_CONF_PLL_I2C_PU_Pos = 0x1f
	// Bit mask of PLL_I2C_PU field.
	RTC_CNTL_RTC_ANA_CONF_PLL_I2C_PU_Msk = 0x80000000
	// Bit PLL_I2C_PU.
	RTC_CNTL_RTC_ANA_CONF_PLL_I2C_PU = 0x80000000

	// RTC_RESET_STATE: rtc configure register
	// Position of RESET_CAUSE_PROCPU field.
	RTC_CNTL_RTC_RESET_STATE_RESET_CAUSE_PROCPU_Pos = 0x0
	// Bit mask of RESET_CAUSE_PROCPU field.
	RTC_CNTL_RTC_RESET_STATE_RESET_CAUSE_PROCPU_Msk = 0x3f
	// Position of RESET_CAUSE_APPCPU field.
	RTC_CNTL_RTC_RESET_STATE_RESET_CAUSE_APPCPU_Pos = 0x6
	// Bit mask of RESET_CAUSE_APPCPU field.
	RTC_CNTL_RTC_RESET_STATE_RESET_CAUSE_APPCPU_Msk = 0xfc0
	// Position of STAT_VECTOR_SEL_APPCPU field.
	RTC_CNTL_RTC_RESET_STATE_STAT_VECTOR_SEL_APPCPU_Pos = 0xc
	// Bit mask of STAT_VECTOR_SEL_APPCPU field.
	RTC_CNTL_RTC_RESET_STATE_STAT_VECTOR_SEL_APPCPU_Msk = 0x1000
	// Bit STAT_VECTOR_SEL_APPCPU.
	RTC_CNTL_RTC_RESET_STATE_STAT_VECTOR_SEL_APPCPU = 0x1000
	// Position of STAT_VECTOR_SEL_PROCPU field.
	RTC_CNTL_RTC_RESET_STATE_STAT_VECTOR_SEL_PROCPU_Pos = 0xd
	// Bit mask of STAT_VECTOR_SEL_PROCPU field.
	RTC_CNTL_RTC_RESET_STATE_STAT_VECTOR_SEL_PROCPU_Msk = 0x2000
	// Bit STAT_VECTOR_SEL_PROCPU.
	RTC_CNTL_RTC_RESET_STATE_STAT_VECTOR_SEL_PROCPU = 0x2000
	// Position of ALL_RESET_FLAG_PROCPU field.
	RTC_CNTL_RTC_RESET_STATE_ALL_RESET_FLAG_PROCPU_Pos = 0xe
	// Bit mask of ALL_RESET_FLAG_PROCPU field.
	RTC_CNTL_RTC_RESET_STATE_ALL_RESET_FLAG_PROCPU_Msk = 0x4000
	// Bit ALL_RESET_FLAG_PROCPU.
	RTC_CNTL_RTC_RESET_STATE_ALL_RESET_FLAG_PROCPU = 0x4000
	// Position of ALL_RESET_FLAG_APPCPU field.
	RTC_CNTL_RTC_RESET_STATE_ALL_RESET_FLAG_APPCPU_Pos = 0xf
	// Bit mask of ALL_RESET_FLAG_APPCPU field.
	RTC_CNTL_RTC_RESET_STATE_ALL_RESET_FLAG_APPCPU_Msk = 0x8000
	// Bit ALL_RESET_FLAG_APPCPU.
	RTC_CNTL_RTC_RESET_STATE_ALL_RESET_FLAG_APPCPU = 0x8000
	// Position of ALL_RESET_FLAG_CLR_PROCPU field.
	RTC_CNTL_RTC_RESET_STATE_ALL_RESET_FLAG_CLR_PROCPU_Pos = 0x10
	// Bit mask of ALL_RESET_FLAG_CLR_PROCPU field.
	RTC_CNTL_RTC_RESET_STATE_ALL_RESET_FLAG_CLR_PROCPU_Msk = 0x10000
	// Bit ALL_RESET_FLAG_CLR_PROCPU.
	RTC_CNTL_RTC_RESET_STATE_ALL_RESET_FLAG_CLR_PROCPU = 0x10000
	// Position of ALL_RESET_FLAG_CLR_APPCPU field.
	RTC_CNTL_RTC_RESET_STATE_ALL_RESET_FLAG_CLR_APPCPU_Pos = 0x11
	// Bit mask of ALL_RESET_FLAG_CLR_APPCPU field.
	RTC_CNTL_RTC_RESET_STATE_ALL_RESET_FLAG_CLR_APPCPU_Msk = 0x20000
	// Bit ALL_RESET_FLAG_CLR_APPCPU.
	RTC_CNTL_RTC_RESET_STATE_ALL_RESET_FLAG_CLR_APPCPU = 0x20000
	// Position of OCD_HALT_ON_RESET_APPCPU field.
	RTC_CNTL_RTC_RESET_STATE_OCD_HALT_ON_RESET_APPCPU_Pos = 0x12
	// Bit mask of OCD_HALT_ON_RESET_APPCPU field.
	RTC_CNTL_RTC_RESET_STATE_OCD_HALT_ON_RESET_APPCPU_Msk = 0x40000
	// Bit OCD_HALT_ON_RESET_APPCPU.
	RTC_CNTL_RTC_RESET_STATE_OCD_HALT_ON_RESET_APPCPU = 0x40000
	// Position of OCD_HALT_ON_RESET_PROCPU field.
	RTC_CNTL_RTC_RESET_STATE_OCD_HALT_ON_RESET_PROCPU_Pos = 0x13
	// Bit mask of OCD_HALT_ON_RESET_PROCPU field.
	RTC_CNTL_RTC_RESET_STATE_OCD_HALT_ON_RESET_PROCPU_Msk = 0x80000
	// Bit OCD_HALT_ON_RESET_PROCPU.
	RTC_CNTL_RTC_RESET_STATE_OCD_HALT_ON_RESET_PROCPU = 0x80000
	// Position of JTAG_RESET_FLAG_PROCPU field.
	RTC_CNTL_RTC_RESET_STATE_JTAG_RESET_FLAG_PROCPU_Pos = 0x14
	// Bit mask of JTAG_RESET_FLAG_PROCPU field.
	RTC_CNTL_RTC_RESET_STATE_JTAG_RESET_FLAG_PROCPU_Msk = 0x100000
	// Bit JTAG_RESET_FLAG_PROCPU.
	RTC_CNTL_RTC_RESET_STATE_JTAG_RESET_FLAG_PROCPU = 0x100000
	// Position of JTAG_RESET_FLAG_APPCPU field.
	RTC_CNTL_RTC_RESET_STATE_JTAG_RESET_FLAG_APPCPU_Pos = 0x15
	// Bit mask of JTAG_RESET_FLAG_APPCPU field.
	RTC_CNTL_RTC_RESET_STATE_JTAG_RESET_FLAG_APPCPU_Msk = 0x200000
	// Bit JTAG_RESET_FLAG_APPCPU.
	RTC_CNTL_RTC_RESET_STATE_JTAG_RESET_FLAG_APPCPU = 0x200000
	// Position of JTAG_RESET_FLAG_CLR_PROCPU field.
	RTC_CNTL_RTC_RESET_STATE_JTAG_RESET_FLAG_CLR_PROCPU_Pos = 0x16
	// Bit mask of JTAG_RESET_FLAG_CLR_PROCPU field.
	RTC_CNTL_RTC_RESET_STATE_JTAG_RESET_FLAG_CLR_PROCPU_Msk = 0x400000
	// Bit JTAG_RESET_FLAG_CLR_PROCPU.
	RTC_CNTL_RTC_RESET_STATE_JTAG_RESET_FLAG_CLR_PROCPU = 0x400000
	// Position of JTAG_RESET_FLAG_CLR_APPCPU field.
	RTC_CNTL_RTC_RESET_STATE_JTAG_RESET_FLAG_CLR_APPCPU_Pos = 0x17
	// Bit mask of JTAG_RESET_FLAG_CLR_APPCPU field.
	RTC_CNTL_RTC_RESET_STATE_JTAG_RESET_FLAG_CLR_APPCPU_Msk = 0x800000
	// Bit JTAG_RESET_FLAG_CLR_APPCPU.
	RTC_CNTL_RTC_RESET_STATE_JTAG_RESET_FLAG_CLR_APPCPU = 0x800000
	// Position of RTC_DRESET_MASK_APPCPU field.
	RTC_CNTL_RTC_RESET_STATE_RTC_DRESET_MASK_APPCPU_Pos = 0x18
	// Bit mask of RTC_DRESET_MASK_APPCPU field.
	RTC_CNTL_RTC_RESET_STATE_RTC_DRESET_MASK_APPCPU_Msk = 0x1000000
	// Bit RTC_DRESET_MASK_APPCPU.
	RTC_CNTL_RTC_RESET_STATE_RTC_DRESET_MASK_APPCPU = 0x1000000
	// Position of RTC_DRESET_MASK_PROCPU field.
	RTC_CNTL_RTC_RESET_STATE_RTC_DRESET_MASK_PROCPU_Pos = 0x19
	// Bit mask of RTC_DRESET_MASK_PROCPU field.
	RTC_CNTL_RTC_RESET_STATE_RTC_DRESET_MASK_PROCPU_Msk = 0x2000000
	// Bit RTC_DRESET_MASK_PROCPU.
	RTC_CNTL_RTC_RESET_STATE_RTC_DRESET_MASK_PROCPU = 0x2000000

	// RTC_WAKEUP_STATE: rtc configure register
	// Position of RTC_WAKEUP_ENA field.
	RTC_CNTL_RTC_WAKEUP_STATE_RTC_WAKEUP_ENA_Pos = 0xf
	// Bit mask of RTC_WAKEUP_ENA field.
	RTC_CNTL_RTC_WAKEUP_STATE_RTC_WAKEUP_ENA_Msk = 0xffff8000

	// INT_ENA_RTC: rtc configure register
	// Position of SLP_WAKEUP_INT_ENA field.
	RTC_CNTL_INT_ENA_RTC_SLP_WAKEUP_INT_ENA_Pos = 0x0
	// Bit mask of SLP_WAKEUP_INT_ENA field.
	RTC_CNTL_INT_ENA_RTC_SLP_WAKEUP_INT_ENA_Msk = 0x1
	// Bit SLP_WAKEUP_INT_ENA.
	RTC_CNTL_INT_ENA_RTC_SLP_WAKEUP_INT_ENA = 0x1
	// Position of SLP_REJECT_INT_ENA field.
	RTC_CNTL_INT_ENA_RTC_SLP_REJECT_INT_ENA_Pos = 0x1
	// Bit mask of SLP_REJECT_INT_ENA field.
	RTC_CNTL_INT_ENA_RTC_SLP_REJECT_INT_ENA_Msk = 0x2
	// Bit SLP_REJECT_INT_ENA.
	RTC_CNTL_INT_ENA_RTC_SLP_REJECT_INT_ENA = 0x2
	// Position of RTC_WDT_INT_ENA field.
	RTC_CNTL_INT_ENA_RTC_RTC_WDT_INT_ENA_Pos = 0x3
	// Bit mask of RTC_WDT_INT_ENA field.
	RTC_CNTL_INT_ENA_RTC_RTC_WDT_INT_ENA_Msk = 0x8
	// Bit RTC_WDT_INT_ENA.
	RTC_CNTL_INT_ENA_RTC_RTC_WDT_INT_ENA = 0x8
	// Position of RTC_BROWN_OUT_INT_ENA field.
	RTC_CNTL_INT_ENA_RTC_RTC_BROWN_OUT_INT_ENA_Pos = 0x9
	// Bit mask of RTC_BROWN_OUT_INT_ENA field.
	RTC_CNTL_INT_ENA_RTC_RTC_BROWN_OUT_INT_ENA_Msk = 0x200
	// Bit RTC_BROWN_OUT_INT_ENA.
	RTC_CNTL_INT_ENA_RTC_RTC_BROWN_OUT_INT_ENA = 0x200
	// Position of RTC_MAIN_TIMER_INT_ENA field.
	RTC_CNTL_INT_ENA_RTC_RTC_MAIN_TIMER_INT_ENA_Pos = 0xa
	// Bit mask of RTC_MAIN_TIMER_INT_ENA field.
	RTC_CNTL_INT_ENA_RTC_RTC_MAIN_TIMER_INT_ENA_Msk = 0x400
	// Bit RTC_MAIN_TIMER_INT_ENA.
	RTC_CNTL_INT_ENA_RTC_RTC_MAIN_TIMER_INT_ENA = 0x400
	// Position of RTC_SWD_INT_ENA field.
	RTC_CNTL_INT_ENA_RTC_RTC_SWD_INT_ENA_Pos = 0xf
	// Bit mask of RTC_SWD_INT_ENA field.
	RTC_CNTL_INT_ENA_RTC_RTC_SWD_INT_ENA_Msk = 0x8000
	// Bit RTC_SWD_INT_ENA.
	RTC_CNTL_INT_ENA_RTC_RTC_SWD_INT_ENA = 0x8000
	// Position of RTC_XTAL32K_DEAD_INT_ENA field.
	RTC_CNTL_INT_ENA_RTC_RTC_XTAL32K_DEAD_INT_ENA_Pos = 0x10
	// Bit mask of RTC_XTAL32K_DEAD_INT_ENA field.
	RTC_CNTL_INT_ENA_RTC_RTC_XTAL32K_DEAD_INT_ENA_Msk = 0x10000
	// Bit RTC_XTAL32K_DEAD_INT_ENA.
	RTC_CNTL_INT_ENA_RTC_RTC_XTAL32K_DEAD_INT_ENA = 0x10000
	// Position of RTC_GLITCH_DET_INT_ENA field.
	RTC_CNTL_INT_ENA_RTC_RTC_GLITCH_DET_INT_ENA_Pos = 0x13
	// Bit mask of RTC_GLITCH_DET_INT_ENA field.
	RTC_CNTL_INT_ENA_RTC_RTC_GLITCH_DET_INT_ENA_Msk = 0x80000
	// Bit RTC_GLITCH_DET_INT_ENA.
	RTC_CNTL_INT_ENA_RTC_RTC_GLITCH_DET_INT_ENA = 0x80000
	// Position of RTC_BBPLL_CAL_INT_ENA field.
	RTC_CNTL_INT_ENA_RTC_RTC_BBPLL_CAL_INT_ENA_Pos = 0x14
	// Bit mask of RTC_BBPLL_CAL_INT_ENA field.
	RTC_CNTL_INT_ENA_RTC_RTC_BBPLL_CAL_INT_ENA_Msk = 0x100000
	// Bit RTC_BBPLL_CAL_INT_ENA.
	RTC_CNTL_INT_ENA_RTC_RTC_BBPLL_CAL_INT_ENA = 0x100000

	// INT_RAW_RTC: rtc configure register
	// Position of SLP_WAKEUP_INT_RAW field.
	RTC_CNTL_INT_RAW_RTC_SLP_WAKEUP_INT_RAW_Pos = 0x0
	// Bit mask of SLP_WAKEUP_INT_RAW field.
	RTC_CNTL_INT_RAW_RTC_SLP_WAKEUP_INT_RAW_Msk = 0x1
	// Bit SLP_WAKEUP_INT_RAW.
	RTC_CNTL_INT_RAW_RTC_SLP_WAKEUP_INT_RAW = 0x1
	// Position of SLP_REJECT_INT_RAW field.
	RTC_CNTL_INT_RAW_RTC_SLP_REJECT_INT_RAW_Pos = 0x1
	// Bit mask of SLP_REJECT_INT_RAW field.
	RTC_CNTL_INT_RAW_RTC_SLP_REJECT_INT_RAW_Msk = 0x2
	// Bit SLP_REJECT_INT_RAW.
	RTC_CNTL_INT_RAW_RTC_SLP_REJECT_INT_RAW = 0x2
	// Position of RTC_WDT_INT_RAW field.
	RTC_CNTL_INT_RAW_RTC_RTC_WDT_INT_RAW_Pos = 0x3
	// Bit mask of RTC_WDT_INT_RAW field.
	RTC_CNTL_INT_RAW_RTC_RTC_WDT_INT_RAW_Msk = 0x8
	// Bit RTC_WDT_INT_RAW.
	RTC_CNTL_INT_RAW_RTC_RTC_WDT_INT_RAW = 0x8
	// Position of RTC_BROWN_OUT_INT_RAW field.
	RTC_CNTL_INT_RAW_RTC_RTC_BROWN_OUT_INT_RAW_Pos = 0x9
	// Bit mask of RTC_BROWN_OUT_INT_RAW field.
	RTC_CNTL_INT_RAW_RTC_RTC_BROWN_OUT_INT_RAW_Msk = 0x200
	// Bit RTC_BROWN_OUT_INT_RAW.
	RTC_CNTL_INT_RAW_RTC_RTC_BROWN_OUT_INT_RAW = 0x200
	// Position of RTC_MAIN_TIMER_INT_RAW field.
	RTC_CNTL_INT_RAW_RTC_RTC_MAIN_TIMER_INT_RAW_Pos = 0xa
	// Bit mask of RTC_MAIN_TIMER_INT_RAW field.
	RTC_CNTL_INT_RAW_RTC_RTC_MAIN_TIMER_INT_RAW_Msk = 0x400
	// Bit RTC_MAIN_TIMER_INT_RAW.
	RTC_CNTL_INT_RAW_RTC_RTC_MAIN_TIMER_INT_RAW = 0x400
	// Position of RTC_SWD_INT_RAW field.
	RTC_CNTL_INT_RAW_RTC_RTC_SWD_INT_RAW_Pos = 0xf
	// Bit mask of RTC_SWD_INT_RAW field.
	RTC_CNTL_INT_RAW_RTC_RTC_SWD_INT_RAW_Msk = 0x8000
	// Bit RTC_SWD_INT_RAW.
	RTC_CNTL_INT_RAW_RTC_RTC_SWD_INT_RAW = 0x8000
	// Position of RTC_XTAL32K_DEAD_INT_RAW field.
	RTC_CNTL_INT_RAW_RTC_RTC_XTAL32K_DEAD_INT_RAW_Pos = 0x10
	// Bit mask of RTC_XTAL32K_DEAD_INT_RAW field.
	RTC_CNTL_INT_RAW_RTC_RTC_XTAL32K_DEAD_INT_RAW_Msk = 0x10000
	// Bit RTC_XTAL32K_DEAD_INT_RAW.
	RTC_CNTL_INT_RAW_RTC_RTC_XTAL32K_DEAD_INT_RAW = 0x10000
	// Position of RTC_GLITCH_DET_INT_RAW field.
	RTC_CNTL_INT_RAW_RTC_RTC_GLITCH_DET_INT_RAW_Pos = 0x13
	// Bit mask of RTC_GLITCH_DET_INT_RAW field.
	RTC_CNTL_INT_RAW_RTC_RTC_GLITCH_DET_INT_RAW_Msk = 0x80000
	// Bit RTC_GLITCH_DET_INT_RAW.
	RTC_CNTL_INT_RAW_RTC_RTC_GLITCH_DET_INT_RAW = 0x80000
	// Position of RTC_BBPLL_CAL_INT_RAW field.
	RTC_CNTL_INT_RAW_RTC_RTC_BBPLL_CAL_INT_RAW_Pos = 0x14
	// Bit mask of RTC_BBPLL_CAL_INT_RAW field.
	RTC_CNTL_INT_RAW_RTC_RTC_BBPLL_CAL_INT_RAW_Msk = 0x100000
	// Bit RTC_BBPLL_CAL_INT_RAW.
	RTC_CNTL_INT_RAW_RTC_RTC_BBPLL_CAL_INT_RAW = 0x100000

	// INT_ST_RTC: rtc configure register
	// Position of SLP_WAKEUP_INT_ST field.
	RTC_CNTL_INT_ST_RTC_SLP_WAKEUP_INT_ST_Pos = 0x0
	// Bit mask of SLP_WAKEUP_INT_ST field.
	RTC_CNTL_INT_ST_RTC_SLP_WAKEUP_INT_ST_Msk = 0x1
	// Bit SLP_WAKEUP_INT_ST.
	RTC_CNTL_INT_ST_RTC_SLP_WAKEUP_INT_ST = 0x1
	// Position of SLP_REJECT_INT_ST field.
	RTC_CNTL_INT_ST_RTC_SLP_REJECT_INT_ST_Pos = 0x1
	// Bit mask of SLP_REJECT_INT_ST field.
	RTC_CNTL_INT_ST_RTC_SLP_REJECT_INT_ST_Msk = 0x2
	// Bit SLP_REJECT_INT_ST.
	RTC_CNTL_INT_ST_RTC_SLP_REJECT_INT_ST = 0x2
	// Position of RTC_WDT_INT_ST field.
	RTC_CNTL_INT_ST_RTC_RTC_WDT_INT_ST_Pos = 0x3
	// Bit mask of RTC_WDT_INT_ST field.
	RTC_CNTL_INT_ST_RTC_RTC_WDT_INT_ST_Msk = 0x8
	// Bit RTC_WDT_INT_ST.
	RTC_CNTL_INT_ST_RTC_RTC_WDT_INT_ST = 0x8
	// Position of RTC_BROWN_OUT_INT_ST field.
	RTC_CNTL_INT_ST_RTC_RTC_BROWN_OUT_INT_ST_Pos = 0x9
	// Bit mask of RTC_BROWN_OUT_INT_ST field.
	RTC_CNTL_INT_ST_RTC_RTC_BROWN_OUT_INT_ST_Msk = 0x200
	// Bit RTC_BROWN_OUT_INT_ST.
	RTC_CNTL_INT_ST_RTC_RTC_BROWN_OUT_INT_ST = 0x200
	// Position of RTC_MAIN_TIMER_INT_ST field.
	RTC_CNTL_INT_ST_RTC_RTC_MAIN_TIMER_INT_ST_Pos = 0xa
	// Bit mask of RTC_MAIN_TIMER_INT_ST field.
	RTC_CNTL_INT_ST_RTC_RTC_MAIN_TIMER_INT_ST_Msk = 0x400
	// Bit RTC_MAIN_TIMER_INT_ST.
	RTC_CNTL_INT_ST_RTC_RTC_MAIN_TIMER_INT_ST = 0x400
	// Position of RTC_SWD_INT_ST field.
	RTC_CNTL_INT_ST_RTC_RTC_SWD_INT_ST_Pos = 0xf
	// Bit mask of RTC_SWD_INT_ST field.
	RTC_CNTL_INT_ST_RTC_RTC_SWD_INT_ST_Msk = 0x8000
	// Bit RTC_SWD_INT_ST.
	RTC_CNTL_INT_ST_RTC_RTC_SWD_INT_ST = 0x8000
	// Position of RTC_XTAL32K_DEAD_INT_ST field.
	RTC_CNTL_INT_ST_RTC_RTC_XTAL32K_DEAD_INT_ST_Pos = 0x10
	// Bit mask of RTC_XTAL32K_DEAD_INT_ST field.
	RTC_CNTL_INT_ST_RTC_RTC_XTAL32K_DEAD_INT_ST_Msk = 0x10000
	// Bit RTC_XTAL32K_DEAD_INT_ST.
	RTC_CNTL_INT_ST_RTC_RTC_XTAL32K_DEAD_INT_ST = 0x10000
	// Position of RTC_GLITCH_DET_INT_ST field.
	RTC_CNTL_INT_ST_RTC_RTC_GLITCH_DET_INT_ST_Pos = 0x13
	// Bit mask of RTC_GLITCH_DET_INT_ST field.
	RTC_CNTL_INT_ST_RTC_RTC_GLITCH_DET_INT_ST_Msk = 0x80000
	// Bit RTC_GLITCH_DET_INT_ST.
	RTC_CNTL_INT_ST_RTC_RTC_GLITCH_DET_INT_ST = 0x80000
	// Position of RTC_BBPLL_CAL_INT_ST field.
	RTC_CNTL_INT_ST_RTC_RTC_BBPLL_CAL_INT_ST_Pos = 0x14
	// Bit mask of RTC_BBPLL_CAL_INT_ST field.
	RTC_CNTL_INT_ST_RTC_RTC_BBPLL_CAL_INT_ST_Msk = 0x100000
	// Bit RTC_BBPLL_CAL_INT_ST.
	RTC_CNTL_INT_ST_RTC_RTC_BBPLL_CAL_INT_ST = 0x100000

	// INT_CLR_RTC: rtc configure register
	// Position of SLP_WAKEUP_INT_CLR field.
	RTC_CNTL_INT_CLR_RTC_SLP_WAKEUP_INT_CLR_Pos = 0x0
	// Bit mask of SLP_WAKEUP_INT_CLR field.
	RTC_CNTL_INT_CLR_RTC_SLP_WAKEUP_INT_CLR_Msk = 0x1
	// Bit SLP_WAKEUP_INT_CLR.
	RTC_CNTL_INT_CLR_RTC_SLP_WAKEUP_INT_CLR = 0x1
	// Position of SLP_REJECT_INT_CLR field.
	RTC_CNTL_INT_CLR_RTC_SLP_REJECT_INT_CLR_Pos = 0x1
	// Bit mask of SLP_REJECT_INT_CLR field.
	RTC_CNTL_INT_CLR_RTC_SLP_REJECT_INT_CLR_Msk = 0x2
	// Bit SLP_REJECT_INT_CLR.
	RTC_CNTL_INT_CLR_RTC_SLP_REJECT_INT_CLR = 0x2
	// Position of RTC_WDT_INT_CLR field.
	RTC_CNTL_INT_CLR_RTC_RTC_WDT_INT_CLR_Pos = 0x3
	// Bit mask of RTC_WDT_INT_CLR field.
	RTC_CNTL_INT_CLR_RTC_RTC_WDT_INT_CLR_Msk = 0x8
	// Bit RTC_WDT_INT_CLR.
	RTC_CNTL_INT_CLR_RTC_RTC_WDT_INT_CLR = 0x8
	// Position of RTC_BROWN_OUT_INT_CLR field.
	RTC_CNTL_INT_CLR_RTC_RTC_BROWN_OUT_INT_CLR_Pos = 0x9
	// Bit mask of RTC_BROWN_OUT_INT_CLR field.
	RTC_CNTL_INT_CLR_RTC_RTC_BROWN_OUT_INT_CLR_Msk = 0x200
	// Bit RTC_BROWN_OUT_INT_CLR.
	RTC_CNTL_INT_CLR_RTC_RTC_BROWN_OUT_INT_CLR = 0x200
	// Position of RTC_MAIN_TIMER_INT_CLR field.
	RTC_CNTL_INT_CLR_RTC_RTC_MAIN_TIMER_INT_CLR_Pos = 0xa
	// Bit mask of RTC_MAIN_TIMER_INT_CLR field.
	RTC_CNTL_INT_CLR_RTC_RTC_MAIN_TIMER_INT_CLR_Msk = 0x400
	// Bit RTC_MAIN_TIMER_INT_CLR.
	RTC_CNTL_INT_CLR_RTC_RTC_MAIN_TIMER_INT_CLR = 0x400
	// Position of RTC_SWD_INT_CLR field.
	RTC_CNTL_INT_CLR_RTC_RTC_SWD_INT_CLR_Pos = 0xf
	// Bit mask of RTC_SWD_INT_CLR field.
	RTC_CNTL_INT_CLR_RTC_RTC_SWD_INT_CLR_Msk = 0x8000
	// Bit RTC_SWD_INT_CLR.
	RTC_CNTL_INT_CLR_RTC_RTC_SWD_INT_CLR = 0x8000
	// Position of RTC_XTAL32K_DEAD_INT_CLR field.
	RTC_CNTL_INT_CLR_RTC_RTC_XTAL32K_DEAD_INT_CLR_Pos = 0x10
	// Bit mask of RTC_XTAL32K_DEAD_INT_CLR field.
	RTC_CNTL_INT_CLR_RTC_RTC_XTAL32K_DEAD_INT_CLR_Msk = 0x10000
	// Bit RTC_XTAL32K_DEAD_INT_CLR.
	RTC_CNTL_INT_CLR_RTC_RTC_XTAL32K_DEAD_INT_CLR = 0x10000
	// Position of RTC_GLITCH_DET_INT_CLR field.
	RTC_CNTL_INT_CLR_RTC_RTC_GLITCH_DET_INT_CLR_Pos = 0x13
	// Bit mask of RTC_GLITCH_DET_INT_CLR field.
	RTC_CNTL_INT_CLR_RTC_RTC_GLITCH_DET_INT_CLR_Msk = 0x80000
	// Bit RTC_GLITCH_DET_INT_CLR.
	RTC_CNTL_INT_CLR_RTC_RTC_GLITCH_DET_INT_CLR = 0x80000
	// Position of RTC_BBPLL_CAL_INT_CLR field.
	RTC_CNTL_INT_CLR_RTC_RTC_BBPLL_CAL_INT_CLR_Pos = 0x14
	// Bit mask of RTC_BBPLL_CAL_INT_CLR field.
	RTC_CNTL_INT_CLR_RTC_RTC_BBPLL_CAL_INT_CLR_Msk = 0x100000
	// Bit RTC_BBPLL_CAL_INT_CLR.
	RTC_CNTL_INT_CLR_RTC_RTC_BBPLL_CAL_INT_CLR = 0x100000

	// RTC_STORE0: rtc configure register
	// Position of RTC_SCRATCH0 field.
	RTC_CNTL_RTC_STORE0_RTC_SCRATCH0_Pos = 0x0
	// Bit mask of RTC_SCRATCH0 field.
	RTC_CNTL_RTC_STORE0_RTC_SCRATCH0_Msk = 0xffffffff

	// RTC_STORE1: rtc configure register
	// Position of RTC_SCRATCH1 field.
	RTC_CNTL_RTC_STORE1_RTC_SCRATCH1_Pos = 0x0
	// Bit mask of RTC_SCRATCH1 field.
	RTC_CNTL_RTC_STORE1_RTC_SCRATCH1_Msk = 0xffffffff

	// RTC_STORE2: rtc configure register
	// Position of RTC_SCRATCH2 field.
	RTC_CNTL_RTC_STORE2_RTC_SCRATCH2_Pos = 0x0
	// Bit mask of RTC_SCRATCH2 field.
	RTC_CNTL_RTC_STORE2_RTC_SCRATCH2_Msk = 0xffffffff

	// RTC_STORE3: rtc configure register
	// Position of RTC_SCRATCH3 field.
	RTC_CNTL_RTC_STORE3_RTC_SCRATCH3_Pos = 0x0
	// Bit mask of RTC_SCRATCH3 field.
	RTC_CNTL_RTC_STORE3_RTC_SCRATCH3_Msk = 0xffffffff

	// RTC_EXT_XTL_CONF: rtc configure register
	// Position of XTAL32K_WDT_EN field.
	RTC_CNTL_RTC_EXT_XTL_CONF_XTAL32K_WDT_EN_Pos = 0x0
	// Bit mask of XTAL32K_WDT_EN field.
	RTC_CNTL_RTC_EXT_XTL_CONF_XTAL32K_WDT_EN_Msk = 0x1
	// Bit XTAL32K_WDT_EN.
	RTC_CNTL_RTC_EXT_XTL_CONF_XTAL32K_WDT_EN = 0x1
	// Position of XTAL32K_WDT_CLK_FO field.
	RTC_CNTL_RTC_EXT_XTL_CONF_XTAL32K_WDT_CLK_FO_Pos = 0x1
	// Bit mask of XTAL32K_WDT_CLK_FO field.
	RTC_CNTL_RTC_EXT_XTL_CONF_XTAL32K_WDT_CLK_FO_Msk = 0x2
	// Bit XTAL32K_WDT_CLK_FO.
	RTC_CNTL_RTC_EXT_XTL_CONF_XTAL32K_WDT_CLK_FO = 0x2
	// Position of XTAL32K_WDT_RESET field.
	RTC_CNTL_RTC_EXT_XTL_CONF_XTAL32K_WDT_RESET_Pos = 0x2
	// Bit mask of XTAL32K_WDT_RESET field.
	RTC_CNTL_RTC_EXT_XTL_CONF_XTAL32K_WDT_RESET_Msk = 0x4
	// Bit XTAL32K_WDT_RESET.
	RTC_CNTL_RTC_EXT_XTL_CONF_XTAL32K_WDT_RESET = 0x4
	// Position of XTAL32K_EXT_CLK_FO field.
	RTC_CNTL_RTC_EXT_XTL_CONF_XTAL32K_EXT_CLK_FO_Pos = 0x3
	// Bit mask of XTAL32K_EXT_CLK_FO field.
	RTC_CNTL_RTC_EXT_XTL_CONF_XTAL32K_EXT_CLK_FO_Msk = 0x8
	// Bit XTAL32K_EXT_CLK_FO.
	RTC_CNTL_RTC_EXT_XTL_CONF_XTAL32K_EXT_CLK_FO = 0x8
	// Position of XTAL32K_AUTO_BACKUP field.
	RTC_CNTL_RTC_EXT_XTL_CONF_XTAL32K_AUTO_BACKUP_Pos = 0x4
	// Bit mask of XTAL32K_AUTO_BACKUP field.
	RTC_CNTL_RTC_EXT_XTL_CONF_XTAL32K_AUTO_BACKUP_Msk = 0x10
	// Bit XTAL32K_AUTO_BACKUP.
	RTC_CNTL_RTC_EXT_XTL_CONF_XTAL32K_AUTO_BACKUP = 0x10
	// Position of XTAL32K_AUTO_RESTART field.
	RTC_CNTL_RTC_EXT_XTL_CONF_XTAL32K_AUTO_RESTART_Pos = 0x5
	// Bit mask of XTAL32K_AUTO_RESTART field.
	RTC_CNTL_RTC_EXT_XTL_CONF_XTAL32K_AUTO_RESTART_Msk = 0x20
	// Bit XTAL32K_AUTO_RESTART.
	RTC_CNTL_RTC_EXT_XTL_CONF_XTAL32K_AUTO_RESTART = 0x20
	// Position of XTAL32K_AUTO_RETURN field.
	RTC_CNTL_RTC_EXT_XTL_CONF_XTAL32K_AUTO_RETURN_Pos = 0x6
	// Bit mask of XTAL32K_AUTO_RETURN field.
	RTC_CNTL_RTC_EXT_XTL_CONF_XTAL32K_AUTO_RETURN_Msk = 0x40
	// Bit XTAL32K_AUTO_RETURN.
	RTC_CNTL_RTC_EXT_XTL_CONF_XTAL32K_AUTO_RETURN = 0x40
	// Position of XTAL32K_XPD_FORCE field.
	RTC_CNTL_RTC_EXT_XTL_CONF_XTAL32K_XPD_FORCE_Pos = 0x7
	// Bit mask of XTAL32K_XPD_FORCE field.
	RTC_CNTL_RTC_EXT_XTL_CONF_XTAL32K_XPD_FORCE_Msk = 0x80
	// Bit XTAL32K_XPD_FORCE.
	RTC_CNTL_RTC_EXT_XTL_CONF_XTAL32K_XPD_FORCE = 0x80
	// Position of ENCKINIT_XTAL_32K field.
	RTC_CNTL_RTC_EXT_XTL_CONF_ENCKINIT_XTAL_32K_Pos = 0x8
	// Bit mask of ENCKINIT_XTAL_32K field.
	RTC_CNTL_RTC_EXT_XTL_CONF_ENCKINIT_XTAL_32K_Msk = 0x100
	// Bit ENCKINIT_XTAL_32K.
	RTC_CNTL_RTC_EXT_XTL_CONF_ENCKINIT_XTAL_32K = 0x100
	// Position of DBUF_XTAL_32K field.
	RTC_CNTL_RTC_EXT_XTL_CONF_DBUF_XTAL_32K_Pos = 0x9
	// Bit mask of DBUF_XTAL_32K field.
	RTC_CNTL_RTC_EXT_XTL_CONF_DBUF_XTAL_32K_Msk = 0x200
	// Bit DBUF_XTAL_32K.
	RTC_CNTL_RTC_EXT_XTL_CONF_DBUF_XTAL_32K = 0x200
	// Position of DGM_XTAL_32K field.
	RTC_CNTL_RTC_EXT_XTL_CONF_DGM_XTAL_32K_Pos = 0xa
	// Bit mask of DGM_XTAL_32K field.
	RTC_CNTL_RTC_EXT_XTL_CONF_DGM_XTAL_32K_Msk = 0x1c00
	// Position of DRES_XTAL_32K field.
	RTC_CNTL_RTC_EXT_XTL_CONF_DRES_XTAL_32K_Pos = 0xd
	// Bit mask of DRES_XTAL_32K field.
	RTC_CNTL_RTC_EXT_XTL_CONF_DRES_XTAL_32K_Msk = 0xe000
	// Position of XPD_XTAL_32K field.
	RTC_CNTL_RTC_EXT_XTL_CONF_XPD_XTAL_32K_Pos = 0x10
	// Bit mask of XPD_XTAL_32K field.
	RTC_CNTL_RTC_EXT_XTL_CONF_XPD_XTAL_32K_Msk = 0x10000
	// Bit XPD_XTAL_32K.
	RTC_CNTL_RTC_EXT_XTL_CONF_XPD_XTAL_32K = 0x10000
	// Position of DAC_XTAL_32K field.
	RTC_CNTL_RTC_EXT_XTL_CONF_DAC_XTAL_32K_Pos = 0x11
	// Bit mask of DAC_XTAL_32K field.
	RTC_CNTL_RTC_EXT_XTL_CONF_DAC_XTAL_32K_Msk = 0xe0000
	// Position of RTC_WDT_STATE field.
	RTC_CNTL_RTC_EXT_XTL_CONF_RTC_WDT_STATE_Pos = 0x14
	// Bit mask of RTC_WDT_STATE field.
	RTC_CNTL_RTC_EXT_XTL_CONF_RTC_WDT_STATE_Msk = 0x700000
	// Position of RTC_XTAL32K_GPIO_SEL field.
	RTC_CNTL_RTC_EXT_XTL_CONF_RTC_XTAL32K_GPIO_SEL_Pos = 0x17
	// Bit mask of RTC_XTAL32K_GPIO_SEL field.
	RTC_CNTL_RTC_EXT_XTL_CONF_RTC_XTAL32K_GPIO_SEL_Msk = 0x800000
	// Bit RTC_XTAL32K_GPIO_SEL.
	RTC_CNTL_RTC_EXT_XTL_CONF_RTC_XTAL32K_GPIO_SEL = 0x800000
	// Position of XTL_EXT_CTR_LV field.
	RTC_CNTL_RTC_EXT_XTL_CONF_XTL_EXT_CTR_LV_Pos = 0x1e
	// Bit mask of XTL_EXT_CTR_LV field.
	RTC_CNTL_RTC_EXT_XTL_CONF_XTL_EXT_CTR_LV_Msk = 0x40000000
	// Bit XTL_EXT_CTR_LV.
	RTC_CNTL_RTC_EXT_XTL_CONF_XTL_EXT_CTR_LV = 0x40000000
	// Position of XTL_EXT_CTR_EN field.
	RTC_CNTL_RTC_EXT_XTL_CONF_XTL_EXT_CTR_EN_Pos = 0x1f
	// Bit mask of XTL_EXT_CTR_EN field.
	RTC_CNTL_RTC_EXT_XTL_CONF_XTL_EXT_CTR_EN_Msk = 0x80000000
	// Bit XTL_EXT_CTR_EN.
	RTC_CNTL_RTC_EXT_XTL_CONF_XTL_EXT_CTR_EN = 0x80000000

	// RTC_EXT_WAKEUP_CONF: rtc configure register
	// Position of GPIO_WAKEUP_FILTER field.
	RTC_CNTL_RTC_EXT_WAKEUP_CONF_GPIO_WAKEUP_FILTER_Pos = 0x1f
	// Bit mask of GPIO_WAKEUP_FILTER field.
	RTC_CNTL_RTC_EXT_WAKEUP_CONF_GPIO_WAKEUP_FILTER_Msk = 0x80000000
	// Bit GPIO_WAKEUP_FILTER.
	RTC_CNTL_RTC_EXT_WAKEUP_CONF_GPIO_WAKEUP_FILTER = 0x80000000

	// RTC_SLP_REJECT_CONF: rtc configure register
	// Position of RTC_SLEEP_REJECT_ENA field.
	RTC_CNTL_RTC_SLP_REJECT_CONF_RTC_SLEEP_REJECT_ENA_Pos = 0xc
	// Bit mask of RTC_SLEEP_REJECT_ENA field.
	RTC_CNTL_RTC_SLP_REJECT_CONF_RTC_SLEEP_REJECT_ENA_Msk = 0x3ffff000
	// Position of LIGHT_SLP_REJECT_EN field.
	RTC_CNTL_RTC_SLP_REJECT_CONF_LIGHT_SLP_REJECT_EN_Pos = 0x1e
	// Bit mask of LIGHT_SLP_REJECT_EN field.
	RTC_CNTL_RTC_SLP_REJECT_CONF_LIGHT_SLP_REJECT_EN_Msk = 0x40000000
	// Bit LIGHT_SLP_REJECT_EN.
	RTC_CNTL_RTC_SLP_REJECT_CONF_LIGHT_SLP_REJECT_EN = 0x40000000
	// Position of DEEP_SLP_REJECT_EN field.
	RTC_CNTL_RTC_SLP_REJECT_CONF_DEEP_SLP_REJECT_EN_Pos = 0x1f
	// Bit mask of DEEP_SLP_REJECT_EN field.
	RTC_CNTL_RTC_SLP_REJECT_CONF_DEEP_SLP_REJECT_EN_Msk = 0x80000000
	// Bit DEEP_SLP_REJECT_EN.
	RTC_CNTL_RTC_SLP_REJECT_CONF_DEEP_SLP_REJECT_EN = 0x80000000

	// RTC_CPU_PERIOD_CONF: rtc configure register
	// Position of RTC_CPUSEL_CONF field.
	RTC_CNTL_RTC_CPU_PERIOD_CONF_RTC_CPUSEL_CONF_Pos = 0x1d
	// Bit mask of RTC_CPUSEL_CONF field.
	RTC_CNTL_RTC_CPU_PERIOD_CONF_RTC_CPUSEL_CONF_Msk = 0x20000000
	// Bit RTC_CPUSEL_CONF.
	RTC_CNTL_RTC_CPU_PERIOD_CONF_RTC_CPUSEL_CONF = 0x20000000
	// Position of RTC_CPUPERIOD_SEL field.
	RTC_CNTL_RTC_CPU_PERIOD_CONF_RTC_CPUPERIOD_SEL_Pos = 0x1e
	// Bit mask of RTC_CPUPERIOD_SEL field.
	RTC_CNTL_RTC_CPU_PERIOD_CONF_RTC_CPUPERIOD_SEL_Msk = 0xc0000000

	// RTC_CLK_CONF: rtc configure register
	// Position of EFUSE_CLK_FORCE_GATING field.
	RTC_CNTL_RTC_CLK_CONF_EFUSE_CLK_FORCE_GATING_Pos = 0x1
	// Bit mask of EFUSE_CLK_FORCE_GATING field.
	RTC_CNTL_RTC_CLK_CONF_EFUSE_CLK_FORCE_GATING_Msk = 0x2
	// Bit EFUSE_CLK_FORCE_GATING.
	RTC_CNTL_RTC_CLK_CONF_EFUSE_CLK_FORCE_GATING = 0x2
	// Position of EFUSE_CLK_FORCE_NOGATING field.
	RTC_CNTL_RTC_CLK_CONF_EFUSE_CLK_FORCE_NOGATING_Pos = 0x2
	// Bit mask of EFUSE_CLK_FORCE_NOGATING field.
	RTC_CNTL_RTC_CLK_CONF_EFUSE_CLK_FORCE_NOGATING_Msk = 0x4
	// Bit EFUSE_CLK_FORCE_NOGATING.
	RTC_CNTL_RTC_CLK_CONF_EFUSE_CLK_FORCE_NOGATING = 0x4
	// Position of CK8M_DIV_SEL_VLD field.
	RTC_CNTL_RTC_CLK_CONF_CK8M_DIV_SEL_VLD_Pos = 0x3
	// Bit mask of CK8M_DIV_SEL_VLD field.
	RTC_CNTL_RTC_CLK_CONF_CK8M_DIV_SEL_VLD_Msk = 0x8
	// Bit CK8M_DIV_SEL_VLD.
	RTC_CNTL_RTC_CLK_CONF_CK8M_DIV_SEL_VLD = 0x8
	// Position of CK8M_DIV field.
	RTC_CNTL_RTC_CLK_CONF_CK8M_DIV_Pos = 0x4
	// Bit mask of CK8M_DIV field.
	RTC_CNTL_RTC_CLK_CONF_CK8M_DIV_Msk = 0x30
	// Position of ENB_CK8M field.
	RTC_CNTL_RTC_CLK_CONF_ENB_CK8M_Pos = 0x6
	// Bit mask of ENB_CK8M field.
	RTC_CNTL_RTC_CLK_CONF_ENB_CK8M_Msk = 0x40
	// Bit ENB_CK8M.
	RTC_CNTL_RTC_CLK_CONF_ENB_CK8M = 0x40
	// Position of ENB_CK8M_DIV field.
	RTC_CNTL_RTC_CLK_CONF_ENB_CK8M_DIV_Pos = 0x7
	// Bit mask of ENB_CK8M_DIV field.
	RTC_CNTL_RTC_CLK_CONF_ENB_CK8M_DIV_Msk = 0x80
	// Bit ENB_CK8M_DIV.
	RTC_CNTL_RTC_CLK_CONF_ENB_CK8M_DIV = 0x80
	// Position of DIG_XTAL32K_EN field.
	RTC_CNTL_RTC_CLK_CONF_DIG_XTAL32K_EN_Pos = 0x8
	// Bit mask of DIG_XTAL32K_EN field.
	RTC_CNTL_RTC_CLK_CONF_DIG_XTAL32K_EN_Msk = 0x100
	// Bit DIG_XTAL32K_EN.
	RTC_CNTL_RTC_CLK_CONF_DIG_XTAL32K_EN = 0x100
	// Position of DIG_CLK8M_D256_EN field.
	RTC_CNTL_RTC_CLK_CONF_DIG_CLK8M_D256_EN_Pos = 0x9
	// Bit mask of DIG_CLK8M_D256_EN field.
	RTC_CNTL_RTC_CLK_CONF_DIG_CLK8M_D256_EN_Msk = 0x200
	// Bit DIG_CLK8M_D256_EN.
	RTC_CNTL_RTC_CLK_CONF_DIG_CLK8M_D256_EN = 0x200
	// Position of DIG_CLK8M_EN field.
	RTC_CNTL_RTC_CLK_CONF_DIG_CLK8M_EN_Pos = 0xa
	// Bit mask of DIG_CLK8M_EN field.
	RTC_CNTL_RTC_CLK_CONF_DIG_CLK8M_EN_Msk = 0x400
	// Bit DIG_CLK8M_EN.
	RTC_CNTL_RTC_CLK_CONF_DIG_CLK8M_EN = 0x400
	// Position of CK8M_DIV_SEL field.
	RTC_CNTL_RTC_CLK_CONF_CK8M_DIV_SEL_Pos = 0xc
	// Bit mask of CK8M_DIV_SEL field.
	RTC_CNTL_RTC_CLK_CONF_CK8M_DIV_SEL_Msk = 0x7000
	// Position of XTAL_FORCE_NOGATING field.
	RTC_CNTL_RTC_CLK_CONF_XTAL_FORCE_NOGATING_Pos = 0xf
	// Bit mask of XTAL_FORCE_NOGATING field.
	RTC_CNTL_RTC_CLK_CONF_XTAL_FORCE_NOGATING_Msk = 0x8000
	// Bit XTAL_FORCE_NOGATING.
	RTC_CNTL_RTC_CLK_CONF_XTAL_FORCE_NOGATING = 0x8000
	// Position of CK8M_FORCE_NOGATING field.
	RTC_CNTL_RTC_CLK_CONF_CK8M_FORCE_NOGATING_Pos = 0x10
	// Bit mask of CK8M_FORCE_NOGATING field.
	RTC_CNTL_RTC_CLK_CONF_CK8M_FORCE_NOGATING_Msk = 0x10000
	// Bit CK8M_FORCE_NOGATING.
	RTC_CNTL_RTC_CLK_CONF_CK8M_FORCE_NOGATING = 0x10000
	// Position of CK8M_DFREQ field.
	RTC_CNTL_RTC_CLK_CONF_CK8M_DFREQ_Pos = 0x11
	// Bit mask of CK8M_DFREQ field.
	RTC_CNTL_RTC_CLK_CONF_CK8M_DFREQ_Msk = 0x1fe0000
	// Position of CK8M_FORCE_PD field.
	RTC_CNTL_RTC_CLK_CONF_CK8M_FORCE_PD_Pos = 0x19
	// Bit mask of CK8M_FORCE_PD field.
	RTC_CNTL_RTC_CLK_CONF_CK8M_FORCE_PD_Msk = 0x2000000
	// Bit CK8M_FORCE_PD.
	RTC_CNTL_RTC_CLK_CONF_CK8M_FORCE_PD = 0x2000000
	// Position of CK8M_FORCE_PU field.
	RTC_CNTL_RTC_CLK_CONF_CK8M_FORCE_PU_Pos = 0x1a
	// Bit mask of CK8M_FORCE_PU field.
	RTC_CNTL_RTC_CLK_CONF_CK8M_FORCE_PU_Msk = 0x4000000
	// Bit CK8M_FORCE_PU.
	RTC_CNTL_RTC_CLK_CONF_CK8M_FORCE_PU = 0x4000000
	// Position of XTAL_GLOBAL_FORCE_GATING field.
	RTC_CNTL_RTC_CLK_CONF_XTAL_GLOBAL_FORCE_GATING_Pos = 0x1b
	// Bit mask of XTAL_GLOBAL_FORCE_GATING field.
	RTC_CNTL_RTC_CLK_CONF_XTAL_GLOBAL_FORCE_GATING_Msk = 0x8000000
	// Bit XTAL_GLOBAL_FORCE_GATING.
	RTC_CNTL_RTC_CLK_CONF_XTAL_GLOBAL_FORCE_GATING = 0x8000000
	// Position of XTAL_GLOBAL_FORCE_NOGATING field.
	RTC_CNTL_RTC_CLK_CONF_XTAL_GLOBAL_FORCE_NOGATING_Pos = 0x1c
	// Bit mask of XTAL_GLOBAL_FORCE_NOGATING field.
	RTC_CNTL_RTC_CLK_CONF_XTAL_GLOBAL_FORCE_NOGATING_Msk = 0x10000000
	// Bit XTAL_GLOBAL_FORCE_NOGATING.
	RTC_CNTL_RTC_CLK_CONF_XTAL_GLOBAL_FORCE_NOGATING = 0x10000000
	// Position of FAST_CLK_RTC_SEL field.
	RTC_CNTL_RTC_CLK_CONF_FAST_CLK_RTC_SEL_Pos = 0x1d
	// Bit mask of FAST_CLK_RTC_SEL field.
	RTC_CNTL_RTC_CLK_CONF_FAST_CLK_RTC_SEL_Msk = 0x20000000
	// Bit FAST_CLK_RTC_SEL.
	RTC_CNTL_RTC_CLK_CONF_FAST_CLK_RTC_SEL = 0x20000000
	// Position of ANA_CLK_RTC_SEL field.
	RTC_CNTL_RTC_CLK_CONF_ANA_CLK_RTC_SEL_Pos = 0x1e
	// Bit mask of ANA_CLK_RTC_SEL field.
	RTC_CNTL_RTC_CLK_CONF_ANA_CLK_RTC_SEL_Msk = 0xc0000000

	// RTC_SLOW_CLK_CONF: rtc configure register
	// Position of RTC_ANA_CLK_DIV_VLD field.
	RTC_CNTL_RTC_SLOW_CLK_CONF_RTC_ANA_CLK_DIV_VLD_Pos = 0x16
	// Bit mask of RTC_ANA_CLK_DIV_VLD field.
	RTC_CNTL_RTC_SLOW_CLK_CONF_RTC_ANA_CLK_DIV_VLD_Msk = 0x400000
	// Bit RTC_ANA_CLK_DIV_VLD.
	RTC_CNTL_RTC_SLOW_CLK_CONF_RTC_ANA_CLK_DIV_VLD = 0x400000
	// Position of RTC_ANA_CLK_DIV field.
	RTC_CNTL_RTC_SLOW_CLK_CONF_RTC_ANA_CLK_DIV_Pos = 0x17
	// Bit mask of RTC_ANA_CLK_DIV field.
	RTC_CNTL_RTC_SLOW_CLK_CONF_RTC_ANA_CLK_DIV_Msk = 0x7f800000
	// Position of RTC_SLOW_CLK_NEXT_EDGE field.
	RTC_CNTL_RTC_SLOW_CLK_CONF_RTC_SLOW_CLK_NEXT_EDGE_Pos = 0x1f
	// Bit mask of RTC_SLOW_CLK_NEXT_EDGE field.
	RTC_CNTL_RTC_SLOW_CLK_CONF_RTC_SLOW_CLK_NEXT_EDGE_Msk = 0x80000000
	// Bit RTC_SLOW_CLK_NEXT_EDGE.
	RTC_CNTL_RTC_SLOW_CLK_CONF_RTC_SLOW_CLK_NEXT_EDGE = 0x80000000

	// RTC_SDIO_CONF: rtc configure register
	// Position of SDIO_TIMER_TARGET field.
	RTC_CNTL_RTC_SDIO_CONF_SDIO_TIMER_TARGET_Pos = 0x0
	// Bit mask of SDIO_TIMER_TARGET field.
	RTC_CNTL_RTC_SDIO_CONF_SDIO_TIMER_TARGET_Msk = 0xff
	// Position of SDIO_DTHDRV field.
	RTC_CNTL_RTC_SDIO_CONF_SDIO_DTHDRV_Pos = 0x9
	// Bit mask of SDIO_DTHDRV field.
	RTC_CNTL_RTC_SDIO_CONF_SDIO_DTHDRV_Msk = 0x600
	// Position of SDIO_DCAP field.
	RTC_CNTL_RTC_SDIO_CONF_SDIO_DCAP_Pos = 0xb
	// Bit mask of SDIO_DCAP field.
	RTC_CNTL_RTC_SDIO_CONF_SDIO_DCAP_Msk = 0x1800
	// Position of SDIO_INITI field.
	RTC_CNTL_RTC_SDIO_CONF_SDIO_INITI_Pos = 0xd
	// Bit mask of SDIO_INITI field.
	RTC_CNTL_RTC_SDIO_CONF_SDIO_INITI_Msk = 0x6000
	// Position of SDIO_EN_INITI field.
	RTC_CNTL_RTC_SDIO_CONF_SDIO_EN_INITI_Pos = 0xf
	// Bit mask of SDIO_EN_INITI field.
	RTC_CNTL_RTC_SDIO_CONF_SDIO_EN_INITI_Msk = 0x8000
	// Bit SDIO_EN_INITI.
	RTC_CNTL_RTC_SDIO_CONF_SDIO_EN_INITI = 0x8000
	// Position of SDIO_DCURLIM field.
	RTC_CNTL_RTC_SDIO_CONF_SDIO_DCURLIM_Pos = 0x10
	// Bit mask of SDIO_DCURLIM field.
	RTC_CNTL_RTC_SDIO_CONF_SDIO_DCURLIM_Msk = 0x70000
	// Position of SDIO_MODECURLIM field.
	RTC_CNTL_RTC_SDIO_CONF_SDIO_MODECURLIM_Pos = 0x13
	// Bit mask of SDIO_MODECURLIM field.
	RTC_CNTL_RTC_SDIO_CONF_SDIO_MODECURLIM_Msk = 0x80000
	// Bit SDIO_MODECURLIM.
	RTC_CNTL_RTC_SDIO_CONF_SDIO_MODECURLIM = 0x80000
	// Position of SDIO_ENCURLIM field.
	RTC_CNTL_RTC_SDIO_CONF_SDIO_ENCURLIM_Pos = 0x14
	// Bit mask of SDIO_ENCURLIM field.
	RTC_CNTL_RTC_SDIO_CONF_SDIO_ENCURLIM_Msk = 0x100000
	// Bit SDIO_ENCURLIM.
	RTC_CNTL_RTC_SDIO_CONF_SDIO_ENCURLIM = 0x100000
	// Position of SDIO_REG_PD_EN field.
	RTC_CNTL_RTC_SDIO_CONF_SDIO_REG_PD_EN_Pos = 0x15
	// Bit mask of SDIO_REG_PD_EN field.
	RTC_CNTL_RTC_SDIO_CONF_SDIO_REG_PD_EN_Msk = 0x200000
	// Bit SDIO_REG_PD_EN.
	RTC_CNTL_RTC_SDIO_CONF_SDIO_REG_PD_EN = 0x200000
	// Position of SDIO_FORCE field.
	RTC_CNTL_RTC_SDIO_CONF_SDIO_FORCE_Pos = 0x16
	// Bit mask of SDIO_FORCE field.
	RTC_CNTL_RTC_SDIO_CONF_SDIO_FORCE_Msk = 0x400000
	// Bit SDIO_FORCE.
	RTC_CNTL_RTC_SDIO_CONF_SDIO_FORCE = 0x400000
	// Position of SDIO_TIEH field.
	RTC_CNTL_RTC_SDIO_CONF_SDIO_TIEH_Pos = 0x17
	// Bit mask of SDIO_TIEH field.
	RTC_CNTL_RTC_SDIO_CONF_SDIO_TIEH_Msk = 0x800000
	// Bit SDIO_TIEH.
	RTC_CNTL_RTC_SDIO_CONF_SDIO_TIEH = 0x800000
	// Position of _1P8_READY field.
	RTC_CNTL_RTC_SDIO_CONF__1P8_READY_Pos = 0x18
	// Bit mask of _1P8_READY field.
	RTC_CNTL_RTC_SDIO_CONF__1P8_READY_Msk = 0x1000000
	// Bit _1P8_READY.
	RTC_CNTL_RTC_SDIO_CONF__1P8_READY = 0x1000000
	// Position of DREFL_SDIO field.
	RTC_CNTL_RTC_SDIO_CONF_DREFL_SDIO_Pos = 0x19
	// Bit mask of DREFL_SDIO field.
	RTC_CNTL_RTC_SDIO_CONF_DREFL_SDIO_Msk = 0x6000000
	// Position of DREFM_SDIO field.
	RTC_CNTL_RTC_SDIO_CONF_DREFM_SDIO_Pos = 0x1b
	// Bit mask of DREFM_SDIO field.
	RTC_CNTL_RTC_SDIO_CONF_DREFM_SDIO_Msk = 0x18000000
	// Position of DREFH_SDIO field.
	RTC_CNTL_RTC_SDIO_CONF_DREFH_SDIO_Pos = 0x1d
	// Bit mask of DREFH_SDIO field.
	RTC_CNTL_RTC_SDIO_CONF_DREFH_SDIO_Msk = 0x60000000
	// Position of XPD_SDIO field.
	RTC_CNTL_RTC_SDIO_CONF_XPD_SDIO_Pos = 0x1f
	// Bit mask of XPD_SDIO field.
	RTC_CNTL_RTC_SDIO_CONF_XPD_SDIO_Msk = 0x80000000
	// Bit XPD_SDIO.
	RTC_CNTL_RTC_SDIO_CONF_XPD_SDIO = 0x80000000

	// RTC_BIAS_CONF: rtc configure register
	// Position of DG_VDD_DRV_B_SLP field.
	RTC_CNTL_RTC_BIAS_CONF_DG_VDD_DRV_B_SLP_Pos = 0x0
	// Bit mask of DG_VDD_DRV_B_SLP field.
	RTC_CNTL_RTC_BIAS_CONF_DG_VDD_DRV_B_SLP_Msk = 0xff
	// Position of DG_VDD_DRV_B_SLP_EN field.
	RTC_CNTL_RTC_BIAS_CONF_DG_VDD_DRV_B_SLP_EN_Pos = 0x8
	// Bit mask of DG_VDD_DRV_B_SLP_EN field.
	RTC_CNTL_RTC_BIAS_CONF_DG_VDD_DRV_B_SLP_EN_Msk = 0x100
	// Bit DG_VDD_DRV_B_SLP_EN.
	RTC_CNTL_RTC_BIAS_CONF_DG_VDD_DRV_B_SLP_EN = 0x100
	// Position of BIAS_BUF_IDLE field.
	RTC_CNTL_RTC_BIAS_CONF_BIAS_BUF_IDLE_Pos = 0xa
	// Bit mask of BIAS_BUF_IDLE field.
	RTC_CNTL_RTC_BIAS_CONF_BIAS_BUF_IDLE_Msk = 0x400
	// Bit BIAS_BUF_IDLE.
	RTC_CNTL_RTC_BIAS_CONF_BIAS_BUF_IDLE = 0x400
	// Position of BIAS_BUF_WAKE field.
	RTC_CNTL_RTC_BIAS_CONF_BIAS_BUF_WAKE_Pos = 0xb
	// Bit mask of BIAS_BUF_WAKE field.
	RTC_CNTL_RTC_BIAS_CONF_BIAS_BUF_WAKE_Msk = 0x800
	// Bit BIAS_BUF_WAKE.
	RTC_CNTL_RTC_BIAS_CONF_BIAS_BUF_WAKE = 0x800
	// Position of BIAS_BUF_DEEP_SLP field.
	RTC_CNTL_RTC_BIAS_CONF_BIAS_BUF_DEEP_SLP_Pos = 0xc
	// Bit mask of BIAS_BUF_DEEP_SLP field.
	RTC_CNTL_RTC_BIAS_CONF_BIAS_BUF_DEEP_SLP_Msk = 0x1000
	// Bit BIAS_BUF_DEEP_SLP.
	RTC_CNTL_RTC_BIAS_CONF_BIAS_BUF_DEEP_SLP = 0x1000
	// Position of BIAS_BUF_MONITOR field.
	RTC_CNTL_RTC_BIAS_CONF_BIAS_BUF_MONITOR_Pos = 0xd
	// Bit mask of BIAS_BUF_MONITOR field.
	RTC_CNTL_RTC_BIAS_CONF_BIAS_BUF_MONITOR_Msk = 0x2000
	// Bit BIAS_BUF_MONITOR.
	RTC_CNTL_RTC_BIAS_CONF_BIAS_BUF_MONITOR = 0x2000
	// Position of PD_CUR_DEEP_SLP field.
	RTC_CNTL_RTC_BIAS_CONF_PD_CUR_DEEP_SLP_Pos = 0xe
	// Bit mask of PD_CUR_DEEP_SLP field.
	RTC_CNTL_RTC_BIAS_CONF_PD_CUR_DEEP_SLP_Msk = 0x4000
	// Bit PD_CUR_DEEP_SLP.
	RTC_CNTL_RTC_BIAS_CONF_PD_CUR_DEEP_SLP = 0x4000
	// Position of PD_CUR_MONITOR field.
	RTC_CNTL_RTC_BIAS_CONF_PD_CUR_MONITOR_Pos = 0xf
	// Bit mask of PD_CUR_MONITOR field.
	RTC_CNTL_RTC_BIAS_CONF_PD_CUR_MONITOR_Msk = 0x8000
	// Bit PD_CUR_MONITOR.
	RTC_CNTL_RTC_BIAS_CONF_PD_CUR_MONITOR = 0x8000
	// Position of BIAS_SLEEP_DEEP_SLP field.
	RTC_CNTL_RTC_BIAS_CONF_BIAS_SLEEP_DEEP_SLP_Pos = 0x10
	// Bit mask of BIAS_SLEEP_DEEP_SLP field.
	RTC_CNTL_RTC_BIAS_CONF_BIAS_SLEEP_DEEP_SLP_Msk = 0x10000
	// Bit BIAS_SLEEP_DEEP_SLP.
	RTC_CNTL_RTC_BIAS_CONF_BIAS_SLEEP_DEEP_SLP = 0x10000
	// Position of BIAS_SLEEP_MONITOR field.
	RTC_CNTL_RTC_BIAS_CONF_BIAS_SLEEP_MONITOR_Pos = 0x11
	// Bit mask of BIAS_SLEEP_MONITOR field.
	RTC_CNTL_RTC_BIAS_CONF_BIAS_SLEEP_MONITOR_Msk = 0x20000
	// Bit BIAS_SLEEP_MONITOR.
	RTC_CNTL_RTC_BIAS_CONF_BIAS_SLEEP_MONITOR = 0x20000
	// Position of DBG_ATTEN_DEEP_SLP field.
	RTC_CNTL_RTC_BIAS_CONF_DBG_ATTEN_DEEP_SLP_Pos = 0x12
	// Bit mask of DBG_ATTEN_DEEP_SLP field.
	RTC_CNTL_RTC_BIAS_CONF_DBG_ATTEN_DEEP_SLP_Msk = 0x3c0000
	// Position of DBG_ATTEN_MONITOR field.
	RTC_CNTL_RTC_BIAS_CONF_DBG_ATTEN_MONITOR_Pos = 0x16
	// Bit mask of DBG_ATTEN_MONITOR field.
	RTC_CNTL_RTC_BIAS_CONF_DBG_ATTEN_MONITOR_Msk = 0x3c00000

	// RTC: rtc configure register
	// Position of DIG_REG_CAL_EN field.
	RTC_CNTL_RTC_DIG_REG_CAL_EN_Pos = 0x7
	// Bit mask of DIG_REG_CAL_EN field.
	RTC_CNTL_RTC_DIG_REG_CAL_EN_Msk = 0x80
	// Bit DIG_REG_CAL_EN.
	RTC_CNTL_RTC_DIG_REG_CAL_EN = 0x80
	// Position of SCK_DCAP field.
	RTC_CNTL_RTC_SCK_DCAP_Pos = 0xe
	// Bit mask of SCK_DCAP field.
	RTC_CNTL_RTC_SCK_DCAP_Msk = 0x3fc000
	// Position of DBOOST_FORCE_PD field.
	RTC_CNTL_RTC_DBOOST_FORCE_PD_Pos = 0x1c
	// Bit mask of DBOOST_FORCE_PD field.
	RTC_CNTL_RTC_DBOOST_FORCE_PD_Msk = 0x10000000
	// Bit DBOOST_FORCE_PD.
	RTC_CNTL_RTC_DBOOST_FORCE_PD = 0x10000000
	// Position of DBOOST_FORCE_PU field.
	RTC_CNTL_RTC_DBOOST_FORCE_PU_Pos = 0x1d
	// Bit mask of DBOOST_FORCE_PU field.
	RTC_CNTL_RTC_DBOOST_FORCE_PU_Msk = 0x20000000
	// Bit DBOOST_FORCE_PU.
	RTC_CNTL_RTC_DBOOST_FORCE_PU = 0x20000000
	// Position of REGULATOR_FORCE_PD field.
	RTC_CNTL_RTC_REGULATOR_FORCE_PD_Pos = 0x1e
	// Bit mask of REGULATOR_FORCE_PD field.
	RTC_CNTL_RTC_REGULATOR_FORCE_PD_Msk = 0x40000000
	// Bit REGULATOR_FORCE_PD.
	RTC_CNTL_RTC_REGULATOR_FORCE_PD = 0x40000000
	// Position of REGULATOR_FORCE_PU field.
	RTC_CNTL_RTC_REGULATOR_FORCE_PU_Pos = 0x1f
	// Bit mask of REGULATOR_FORCE_PU field.
	RTC_CNTL_RTC_REGULATOR_FORCE_PU_Msk = 0x80000000
	// Bit REGULATOR_FORCE_PU.
	RTC_CNTL_RTC_REGULATOR_FORCE_PU = 0x80000000

	// RTC_PWC: rtc configure register
	// Position of RTC_PAD_FORCE_HOLD field.
	RTC_CNTL_RTC_PWC_RTC_PAD_FORCE_HOLD_Pos = 0x15
	// Bit mask of RTC_PAD_FORCE_HOLD field.
	RTC_CNTL_RTC_PWC_RTC_PAD_FORCE_HOLD_Msk = 0x200000
	// Bit RTC_PAD_FORCE_HOLD.
	RTC_CNTL_RTC_PWC_RTC_PAD_FORCE_HOLD = 0x200000

	// DIG_PWC: rtc configure register
	// Position of VDD_SPI_PWR_DRV field.
	RTC_CNTL_DIG_PWC_VDD_SPI_PWR_DRV_Pos = 0x0
	// Bit mask of VDD_SPI_PWR_DRV field.
	RTC_CNTL_DIG_PWC_VDD_SPI_PWR_DRV_Msk = 0x3
	// Position of VDD_SPI_PWR_FORCE field.
	RTC_CNTL_DIG_PWC_VDD_SPI_PWR_FORCE_Pos = 0x2
	// Bit mask of VDD_SPI_PWR_FORCE field.
	RTC_CNTL_DIG_PWC_VDD_SPI_PWR_FORCE_Msk = 0x4
	// Bit VDD_SPI_PWR_FORCE.
	RTC_CNTL_DIG_PWC_VDD_SPI_PWR_FORCE = 0x4
	// Position of LSLP_MEM_FORCE_PD field.
	RTC_CNTL_DIG_PWC_LSLP_MEM_FORCE_PD_Pos = 0x3
	// Bit mask of LSLP_MEM_FORCE_PD field.
	RTC_CNTL_DIG_PWC_LSLP_MEM_FORCE_PD_Msk = 0x8
	// Bit LSLP_MEM_FORCE_PD.
	RTC_CNTL_DIG_PWC_LSLP_MEM_FORCE_PD = 0x8
	// Position of LSLP_MEM_FORCE_PU field.
	RTC_CNTL_DIG_PWC_LSLP_MEM_FORCE_PU_Pos = 0x4
	// Bit mask of LSLP_MEM_FORCE_PU field.
	RTC_CNTL_DIG_PWC_LSLP_MEM_FORCE_PU_Msk = 0x10
	// Bit LSLP_MEM_FORCE_PU.
	RTC_CNTL_DIG_PWC_LSLP_MEM_FORCE_PU = 0x10
	// Position of BT_FORCE_PD field.
	RTC_CNTL_DIG_PWC_BT_FORCE_PD_Pos = 0xb
	// Bit mask of BT_FORCE_PD field.
	RTC_CNTL_DIG_PWC_BT_FORCE_PD_Msk = 0x800
	// Bit BT_FORCE_PD.
	RTC_CNTL_DIG_PWC_BT_FORCE_PD = 0x800
	// Position of BT_FORCE_PU field.
	RTC_CNTL_DIG_PWC_BT_FORCE_PU_Pos = 0xc
	// Bit mask of BT_FORCE_PU field.
	RTC_CNTL_DIG_PWC_BT_FORCE_PU_Msk = 0x1000
	// Bit BT_FORCE_PU.
	RTC_CNTL_DIG_PWC_BT_FORCE_PU = 0x1000
	// Position of DG_PERI_FORCE_PD field.
	RTC_CNTL_DIG_PWC_DG_PERI_FORCE_PD_Pos = 0xd
	// Bit mask of DG_PERI_FORCE_PD field.
	RTC_CNTL_DIG_PWC_DG_PERI_FORCE_PD_Msk = 0x2000
	// Bit DG_PERI_FORCE_PD.
	RTC_CNTL_DIG_PWC_DG_PERI_FORCE_PD = 0x2000
	// Position of DG_PERI_FORCE_PU field.
	RTC_CNTL_DIG_PWC_DG_PERI_FORCE_PU_Pos = 0xe
	// Bit mask of DG_PERI_FORCE_PU field.
	RTC_CNTL_DIG_PWC_DG_PERI_FORCE_PU_Msk = 0x4000
	// Bit DG_PERI_FORCE_PU.
	RTC_CNTL_DIG_PWC_DG_PERI_FORCE_PU = 0x4000
	// Position of RTC_FASTMEM_FORCE_LPD field.
	RTC_CNTL_DIG_PWC_RTC_FASTMEM_FORCE_LPD_Pos = 0xf
	// Bit mask of RTC_FASTMEM_FORCE_LPD field.
	RTC_CNTL_DIG_PWC_RTC_FASTMEM_FORCE_LPD_Msk = 0x8000
	// Bit RTC_FASTMEM_FORCE_LPD.
	RTC_CNTL_DIG_PWC_RTC_FASTMEM_FORCE_LPD = 0x8000
	// Position of RTC_FASTMEM_FORCE_LPU field.
	RTC_CNTL_DIG_PWC_RTC_FASTMEM_FORCE_LPU_Pos = 0x10
	// Bit mask of RTC_FASTMEM_FORCE_LPU field.
	RTC_CNTL_DIG_PWC_RTC_FASTMEM_FORCE_LPU_Msk = 0x10000
	// Bit RTC_FASTMEM_FORCE_LPU.
	RTC_CNTL_DIG_PWC_RTC_FASTMEM_FORCE_LPU = 0x10000
	// Position of WIFI_FORCE_PD field.
	RTC_CNTL_DIG_PWC_WIFI_FORCE_PD_Pos = 0x11
	// Bit mask of WIFI_FORCE_PD field.
	RTC_CNTL_DIG_PWC_WIFI_FORCE_PD_Msk = 0x20000
	// Bit WIFI_FORCE_PD.
	RTC_CNTL_DIG_PWC_WIFI_FORCE_PD = 0x20000
	// Position of WIFI_FORCE_PU field.
	RTC_CNTL_DIG_PWC_WIFI_FORCE_PU_Pos = 0x12
	// Bit mask of WIFI_FORCE_PU field.
	RTC_CNTL_DIG_PWC_WIFI_FORCE_PU_Msk = 0x40000
	// Bit WIFI_FORCE_PU.
	RTC_CNTL_DIG_PWC_WIFI_FORCE_PU = 0x40000
	// Position of DG_WRAP_FORCE_PD field.
	RTC_CNTL_DIG_PWC_DG_WRAP_FORCE_PD_Pos = 0x13
	// Bit mask of DG_WRAP_FORCE_PD field.
	RTC_CNTL_DIG_PWC_DG_WRAP_FORCE_PD_Msk = 0x80000
	// Bit DG_WRAP_FORCE_PD.
	RTC_CNTL_DIG_PWC_DG_WRAP_FORCE_PD = 0x80000
	// Position of DG_WRAP_FORCE_PU field.
	RTC_CNTL_DIG_PWC_DG_WRAP_FORCE_PU_Pos = 0x14
	// Bit mask of DG_WRAP_FORCE_PU field.
	RTC_CNTL_DIG_PWC_DG_WRAP_FORCE_PU_Msk = 0x100000
	// Bit DG_WRAP_FORCE_PU.
	RTC_CNTL_DIG_PWC_DG_WRAP_FORCE_PU = 0x100000
	// Position of CPU_TOP_FORCE_PD field.
	RTC_CNTL_DIG_PWC_CPU_TOP_FORCE_PD_Pos = 0x15
	// Bit mask of CPU_TOP_FORCE_PD field.
	RTC_CNTL_DIG_PWC_CPU_TOP_FORCE_PD_Msk = 0x200000
	// Bit CPU_TOP_FORCE_PD.
	RTC_CNTL_DIG_PWC_CPU_TOP_FORCE_PD = 0x200000
	// Position of CPU_TOP_FORCE_PU field.
	RTC_CNTL_DIG_PWC_CPU_TOP_FORCE_PU_Pos = 0x16
	// Bit mask of CPU_TOP_FORCE_PU field.
	RTC_CNTL_DIG_PWC_CPU_TOP_FORCE_PU_Msk = 0x400000
	// Bit CPU_TOP_FORCE_PU.
	RTC_CNTL_DIG_PWC_CPU_TOP_FORCE_PU = 0x400000
	// Position of BT_PD_EN field.
	RTC_CNTL_DIG_PWC_BT_PD_EN_Pos = 0x1b
	// Bit mask of BT_PD_EN field.
	RTC_CNTL_DIG_PWC_BT_PD_EN_Msk = 0x8000000
	// Bit BT_PD_EN.
	RTC_CNTL_DIG_PWC_BT_PD_EN = 0x8000000
	// Position of DG_PERI_PD_EN field.
	RTC_CNTL_DIG_PWC_DG_PERI_PD_EN_Pos = 0x1c
	// Bit mask of DG_PERI_PD_EN field.
	RTC_CNTL_DIG_PWC_DG_PERI_PD_EN_Msk = 0x10000000
	// Bit DG_PERI_PD_EN.
	RTC_CNTL_DIG_PWC_DG_PERI_PD_EN = 0x10000000
	// Position of CPU_TOP_PD_EN field.
	RTC_CNTL_DIG_PWC_CPU_TOP_PD_EN_Pos = 0x1d
	// Bit mask of CPU_TOP_PD_EN field.
	RTC_CNTL_DIG_PWC_CPU_TOP_PD_EN_Msk = 0x20000000
	// Bit CPU_TOP_PD_EN.
	RTC_CNTL_DIG_PWC_CPU_TOP_PD_EN = 0x20000000
	// Position of WIFI_PD_EN field.
	RTC_CNTL_DIG_PWC_WIFI_PD_EN_Pos = 0x1e
	// Bit mask of WIFI_PD_EN field.
	RTC_CNTL_DIG_PWC_WIFI_PD_EN_Msk = 0x40000000
	// Bit WIFI_PD_EN.
	RTC_CNTL_DIG_PWC_WIFI_PD_EN = 0x40000000
	// Position of DG_WRAP_PD_EN field.
	RTC_CNTL_DIG_PWC_DG_WRAP_PD_EN_Pos = 0x1f
	// Bit mask of DG_WRAP_PD_EN field.
	RTC_CNTL_DIG_PWC_DG_WRAP_PD_EN_Msk = 0x80000000
	// Bit DG_WRAP_PD_EN.
	RTC_CNTL_DIG_PWC_DG_WRAP_PD_EN = 0x80000000

	// DIG_ISO: rtc configure register
	// Position of FORCE_OFF field.
	RTC_CNTL_DIG_ISO_FORCE_OFF_Pos = 0x7
	// Bit mask of FORCE_OFF field.
	RTC_CNTL_DIG_ISO_FORCE_OFF_Msk = 0x80
	// Bit FORCE_OFF.
	RTC_CNTL_DIG_ISO_FORCE_OFF = 0x80
	// Position of FORCE_ON field.
	RTC_CNTL_DIG_ISO_FORCE_ON_Pos = 0x8
	// Bit mask of FORCE_ON field.
	RTC_CNTL_DIG_ISO_FORCE_ON_Msk = 0x100
	// Bit FORCE_ON.
	RTC_CNTL_DIG_ISO_FORCE_ON = 0x100
	// Position of DG_PAD_AUTOHOLD field.
	RTC_CNTL_DIG_ISO_DG_PAD_AUTOHOLD_Pos = 0x9
	// Bit mask of DG_PAD_AUTOHOLD field.
	RTC_CNTL_DIG_ISO_DG_PAD_AUTOHOLD_Msk = 0x200
	// Bit DG_PAD_AUTOHOLD.
	RTC_CNTL_DIG_ISO_DG_PAD_AUTOHOLD = 0x200
	// Position of CLR_DG_PAD_AUTOHOLD field.
	RTC_CNTL_DIG_ISO_CLR_DG_PAD_AUTOHOLD_Pos = 0xa
	// Bit mask of CLR_DG_PAD_AUTOHOLD field.
	RTC_CNTL_DIG_ISO_CLR_DG_PAD_AUTOHOLD_Msk = 0x400
	// Bit CLR_DG_PAD_AUTOHOLD.
	RTC_CNTL_DIG_ISO_CLR_DG_PAD_AUTOHOLD = 0x400
	// Position of DG_PAD_AUTOHOLD_EN field.
	RTC_CNTL_DIG_ISO_DG_PAD_AUTOHOLD_EN_Pos = 0xb
	// Bit mask of DG_PAD_AUTOHOLD_EN field.
	RTC_CNTL_DIG_ISO_DG_PAD_AUTOHOLD_EN_Msk = 0x800
	// Bit DG_PAD_AUTOHOLD_EN.
	RTC_CNTL_DIG_ISO_DG_PAD_AUTOHOLD_EN = 0x800
	// Position of DG_PAD_FORCE_NOISO field.
	RTC_CNTL_DIG_ISO_DG_PAD_FORCE_NOISO_Pos = 0xc
	// Bit mask of DG_PAD_FORCE_NOISO field.
	RTC_CNTL_DIG_ISO_DG_PAD_FORCE_NOISO_Msk = 0x1000
	// Bit DG_PAD_FORCE_NOISO.
	RTC_CNTL_DIG_ISO_DG_PAD_FORCE_NOISO = 0x1000
	// Position of DG_PAD_FORCE_ISO field.
	RTC_CNTL_DIG_ISO_DG_PAD_FORCE_ISO_Pos = 0xd
	// Bit mask of DG_PAD_FORCE_ISO field.
	RTC_CNTL_DIG_ISO_DG_PAD_FORCE_ISO_Msk = 0x2000
	// Bit DG_PAD_FORCE_ISO.
	RTC_CNTL_DIG_ISO_DG_PAD_FORCE_ISO = 0x2000
	// Position of DG_PAD_FORCE_UNHOLD field.
	RTC_CNTL_DIG_ISO_DG_PAD_FORCE_UNHOLD_Pos = 0xe
	// Bit mask of DG_PAD_FORCE_UNHOLD field.
	RTC_CNTL_DIG_ISO_DG_PAD_FORCE_UNHOLD_Msk = 0x4000
	// Bit DG_PAD_FORCE_UNHOLD.
	RTC_CNTL_DIG_ISO_DG_PAD_FORCE_UNHOLD = 0x4000
	// Position of DG_PAD_FORCE_HOLD field.
	RTC_CNTL_DIG_ISO_DG_PAD_FORCE_HOLD_Pos = 0xf
	// Bit mask of DG_PAD_FORCE_HOLD field.
	RTC_CNTL_DIG_ISO_DG_PAD_FORCE_HOLD_Msk = 0x8000
	// Bit DG_PAD_FORCE_HOLD.
	RTC_CNTL_DIG_ISO_DG_PAD_FORCE_HOLD = 0x8000
	// Position of BT_FORCE_ISO field.
	RTC_CNTL_DIG_ISO_BT_FORCE_ISO_Pos = 0x16
	// Bit mask of BT_FORCE_ISO field.
	RTC_CNTL_DIG_ISO_BT_FORCE_ISO_Msk = 0x400000
	// Bit BT_FORCE_ISO.
	RTC_CNTL_DIG_ISO_BT_FORCE_ISO = 0x400000
	// Position of BT_FORCE_NOISO field.
	RTC_CNTL_DIG_ISO_BT_FORCE_NOISO_Pos = 0x17
	// Bit mask of BT_FORCE_NOISO field.
	RTC_CNTL_DIG_ISO_BT_FORCE_NOISO_Msk = 0x800000
	// Bit BT_FORCE_NOISO.
	RTC_CNTL_DIG_ISO_BT_FORCE_NOISO = 0x800000
	// Position of DG_PERI_FORCE_ISO field.
	RTC_CNTL_DIG_ISO_DG_PERI_FORCE_ISO_Pos = 0x18
	// Bit mask of DG_PERI_FORCE_ISO field.
	RTC_CNTL_DIG_ISO_DG_PERI_FORCE_ISO_Msk = 0x1000000
	// Bit DG_PERI_FORCE_ISO.
	RTC_CNTL_DIG_ISO_DG_PERI_FORCE_ISO = 0x1000000
	// Position of DG_PERI_FORCE_NOISO field.
	RTC_CNTL_DIG_ISO_DG_PERI_FORCE_NOISO_Pos = 0x19
	// Bit mask of DG_PERI_FORCE_NOISO field.
	RTC_CNTL_DIG_ISO_DG_PERI_FORCE_NOISO_Msk = 0x2000000
	// Bit DG_PERI_FORCE_NOISO.
	RTC_CNTL_DIG_ISO_DG_PERI_FORCE_NOISO = 0x2000000
	// Position of CPU_TOP_FORCE_ISO field.
	RTC_CNTL_DIG_ISO_CPU_TOP_FORCE_ISO_Pos = 0x1a
	// Bit mask of CPU_TOP_FORCE_ISO field.
	RTC_CNTL_DIG_ISO_CPU_TOP_FORCE_ISO_Msk = 0x4000000
	// Bit CPU_TOP_FORCE_ISO.
	RTC_CNTL_DIG_ISO_CPU_TOP_FORCE_ISO = 0x4000000
	// Position of CPU_TOP_FORCE_NOISO field.
	RTC_CNTL_DIG_ISO_CPU_TOP_FORCE_NOISO_Pos = 0x1b
	// Bit mask of CPU_TOP_FORCE_NOISO field.
	RTC_CNTL_DIG_ISO_CPU_TOP_FORCE_NOISO_Msk = 0x8000000
	// Bit CPU_TOP_FORCE_NOISO.
	RTC_CNTL_DIG_ISO_CPU_TOP_FORCE_NOISO = 0x8000000
	// Position of WIFI_FORCE_ISO field.
	RTC_CNTL_DIG_ISO_WIFI_FORCE_ISO_Pos = 0x1c
	// Bit mask of WIFI_FORCE_ISO field.
	RTC_CNTL_DIG_ISO_WIFI_FORCE_ISO_Msk = 0x10000000
	// Bit WIFI_FORCE_ISO.
	RTC_CNTL_DIG_ISO_WIFI_FORCE_ISO = 0x10000000
	// Position of WIFI_FORCE_NOISO field.
	RTC_CNTL_DIG_ISO_WIFI_FORCE_NOISO_Pos = 0x1d
	// Bit mask of WIFI_FORCE_NOISO field.
	RTC_CNTL_DIG_ISO_WIFI_FORCE_NOISO_Msk = 0x20000000
	// Bit WIFI_FORCE_NOISO.
	RTC_CNTL_DIG_ISO_WIFI_FORCE_NOISO = 0x20000000
	// Position of DG_WRAP_FORCE_ISO field.
	RTC_CNTL_DIG_ISO_DG_WRAP_FORCE_ISO_Pos = 0x1e
	// Bit mask of DG_WRAP_FORCE_ISO field.
	RTC_CNTL_DIG_ISO_DG_WRAP_FORCE_ISO_Msk = 0x40000000
	// Bit DG_WRAP_FORCE_ISO.
	RTC_CNTL_DIG_ISO_DG_WRAP_FORCE_ISO = 0x40000000
	// Position of DG_WRAP_FORCE_NOISO field.
	RTC_CNTL_DIG_ISO_DG_WRAP_FORCE_NOISO_Pos = 0x1f
	// Bit mask of DG_WRAP_FORCE_NOISO field.
	RTC_CNTL_DIG_ISO_DG_WRAP_FORCE_NOISO_Msk = 0x80000000
	// Bit DG_WRAP_FORCE_NOISO.
	RTC_CNTL_DIG_ISO_DG_WRAP_FORCE_NOISO = 0x80000000

	// RTC_WDTCONFIG0: rtc configure register
	// Position of WDT_CHIP_RESET_WIDTH field.
	RTC_CNTL_RTC_WDTCONFIG0_WDT_CHIP_RESET_WIDTH_Pos = 0x0
	// Bit mask of WDT_CHIP_RESET_WIDTH field.
	RTC_CNTL_RTC_WDTCONFIG0_WDT_CHIP_RESET_WIDTH_Msk = 0xff
	// Position of WDT_CHIP_RESET_EN field.
	RTC_CNTL_RTC_WDTCONFIG0_WDT_CHIP_RESET_EN_Pos = 0x8
	// Bit mask of WDT_CHIP_RESET_EN field.
	RTC_CNTL_RTC_WDTCONFIG0_WDT_CHIP_RESET_EN_Msk = 0x100
	// Bit WDT_CHIP_RESET_EN.
	RTC_CNTL_RTC_WDTCONFIG0_WDT_CHIP_RESET_EN = 0x100
	// Position of WDT_PAUSE_IN_SLP field.
	RTC_CNTL_RTC_WDTCONFIG0_WDT_PAUSE_IN_SLP_Pos = 0x9
	// Bit mask of WDT_PAUSE_IN_SLP field.
	RTC_CNTL_RTC_WDTCONFIG0_WDT_PAUSE_IN_SLP_Msk = 0x200
	// Bit WDT_PAUSE_IN_SLP.
	RTC_CNTL_RTC_WDTCONFIG0_WDT_PAUSE_IN_SLP = 0x200
	// Position of WDT_APPCPU_RESET_EN field.
	RTC_CNTL_RTC_WDTCONFIG0_WDT_APPCPU_RESET_EN_Pos = 0xa
	// Bit mask of WDT_APPCPU_RESET_EN field.
	RTC_CNTL_RTC_WDTCONFIG0_WDT_APPCPU_RESET_EN_Msk = 0x400
	// Bit WDT_APPCPU_RESET_EN.
	RTC_CNTL_RTC_WDTCONFIG0_WDT_APPCPU_RESET_EN = 0x400
	// Position of WDT_PROCPU_RESET_EN field.
	RTC_CNTL_RTC_WDTCONFIG0_WDT_PROCPU_RESET_EN_Pos = 0xb
	// Bit mask of WDT_PROCPU_RESET_EN field.
	RTC_CNTL_RTC_WDTCONFIG0_WDT_PROCPU_RESET_EN_Msk = 0x800
	// Bit WDT_PROCPU_RESET_EN.
	RTC_CNTL_RTC_WDTCONFIG0_WDT_PROCPU_RESET_EN = 0x800
	// Position of WDT_FLASHBOOT_MOD_EN field.
	RTC_CNTL_RTC_WDTCONFIG0_WDT_FLASHBOOT_MOD_EN_Pos = 0xc
	// Bit mask of WDT_FLASHBOOT_MOD_EN field.
	RTC_CNTL_RTC_WDTCONFIG0_WDT_FLASHBOOT_MOD_EN_Msk = 0x1000
	// Bit WDT_FLASHBOOT_MOD_EN.
	RTC_CNTL_RTC_WDTCONFIG0_WDT_FLASHBOOT_MOD_EN = 0x1000
	// Position of WDT_SYS_RESET_LENGTH field.
	RTC_CNTL_RTC_WDTCONFIG0_WDT_SYS_RESET_LENGTH_Pos = 0xd
	// Bit mask of WDT_SYS_RESET_LENGTH field.
	RTC_CNTL_RTC_WDTCONFIG0_WDT_SYS_RESET_LENGTH_Msk = 0xe000
	// Position of WDT_CPU_RESET_LENGTH field.
	RTC_CNTL_RTC_WDTCONFIG0_WDT_CPU_RESET_LENGTH_Pos = 0x10
	// Bit mask of WDT_CPU_RESET_LENGTH field.
	RTC_CNTL_RTC_WDTCONFIG0_WDT_CPU_RESET_LENGTH_Msk = 0x70000
	// Position of WDT_STG3 field.
	RTC_CNTL_RTC_WDTCONFIG0_WDT_STG3_Pos = 0x13
	// Bit mask of WDT_STG3 field.
	RTC_CNTL_RTC_WDTCONFIG0_WDT_STG3_Msk = 0x380000
	// Position of WDT_STG2 field.
	RTC_CNTL_RTC_WDTCONFIG0_WDT_STG2_Pos = 0x16
	// Bit mask of WDT_STG2 field.
	RTC_CNTL_RTC_WDTCONFIG0_WDT_STG2_Msk = 0x1c00000
	// Position of WDT_STG1 field.
	RTC_CNTL_RTC_WDTCONFIG0_WDT_STG1_Pos = 0x19
	// Bit mask of WDT_STG1 field.
	RTC_CNTL_RTC_WDTCONFIG0_WDT_STG1_Msk = 0xe000000
	// Position of WDT_STG0 field.
	RTC_CNTL_RTC_WDTCONFIG0_WDT_STG0_Pos = 0x1c
	// Bit mask of WDT_STG0 field.
	RTC_CNTL_RTC_WDTCONFIG0_WDT_STG0_Msk = 0x70000000
	// Position of WDT_EN field.
	RTC_CNTL_RTC_WDTCONFIG0_WDT_EN_Pos = 0x1f
	// Bit mask of WDT_EN field.
	RTC_CNTL_RTC_WDTCONFIG0_WDT_EN_Msk = 0x80000000
	// Bit WDT_EN.
	RTC_CNTL_RTC_WDTCONFIG0_WDT_EN = 0x80000000

	// RTC_WDTCONFIG1: rtc configure register
	// Position of WDT_STG0_HOLD field.
	RTC_CNTL_RTC_WDTCONFIG1_WDT_STG0_HOLD_Pos = 0x0
	// Bit mask of WDT_STG0_HOLD field.
	RTC_CNTL_RTC_WDTCONFIG1_WDT_STG0_HOLD_Msk = 0xffffffff

	// RTC_WDTCONFIG2: rtc configure register
	// Position of WDT_STG1_HOLD field.
	RTC_CNTL_RTC_WDTCONFIG2_WDT_STG1_HOLD_Pos = 0x0
	// Bit mask of WDT_STG1_HOLD field.
	RTC_CNTL_RTC_WDTCONFIG2_WDT_STG1_HOLD_Msk = 0xffffffff

	// RTC_WDTCONFIG3: rtc configure register
	// Position of WDT_STG2_HOLD field.
	RTC_CNTL_RTC_WDTCONFIG3_WDT_STG2_HOLD_Pos = 0x0
	// Bit mask of WDT_STG2_HOLD field.
	RTC_CNTL_RTC_WDTCONFIG3_WDT_STG2_HOLD_Msk = 0xffffffff

	// RTC_WDTCONFIG4: rtc configure register
	// Position of WDT_STG3_HOLD field.
	RTC_CNTL_RTC_WDTCONFIG4_WDT_STG3_HOLD_Pos = 0x0
	// Bit mask of WDT_STG3_HOLD field.
	RTC_CNTL_RTC_WDTCONFIG4_WDT_STG3_HOLD_Msk = 0xffffffff

	// RTC_WDTFEED: rtc configure register
	// Position of RTC_WDT_FEED field.
	RTC_CNTL_RTC_WDTFEED_RTC_WDT_FEED_Pos = 0x1f
	// Bit mask of RTC_WDT_FEED field.
	RTC_CNTL_RTC_WDTFEED_RTC_WDT_FEED_Msk = 0x80000000
	// Bit RTC_WDT_FEED.
	RTC_CNTL_RTC_WDTFEED_RTC_WDT_FEED = 0x80000000

	// RTC_WDTWPROTECT: rtc configure register
	// Position of WDT_WKEY field.
	RTC_CNTL_RTC_WDTWPROTECT_WDT_WKEY_Pos = 0x0
	// Bit mask of WDT_WKEY field.
	RTC_CNTL_RTC_WDTWPROTECT_WDT_WKEY_Msk = 0xffffffff

	// RTC_SWD_CONF: rtc configure register
	// Position of SWD_RESET_FLAG field.
	RTC_CNTL_RTC_SWD_CONF_SWD_RESET_FLAG_Pos = 0x0
	// Bit mask of SWD_RESET_FLAG field.
	RTC_CNTL_RTC_SWD_CONF_SWD_RESET_FLAG_Msk = 0x1
	// Bit SWD_RESET_FLAG.
	RTC_CNTL_RTC_SWD_CONF_SWD_RESET_FLAG = 0x1
	// Position of SWD_FEED_INT field.
	RTC_CNTL_RTC_SWD_CONF_SWD_FEED_INT_Pos = 0x1
	// Bit mask of SWD_FEED_INT field.
	RTC_CNTL_RTC_SWD_CONF_SWD_FEED_INT_Msk = 0x2
	// Bit SWD_FEED_INT.
	RTC_CNTL_RTC_SWD_CONF_SWD_FEED_INT = 0x2
	// Position of SWD_BYPASS_RST field.
	RTC_CNTL_RTC_SWD_CONF_SWD_BYPASS_RST_Pos = 0x11
	// Bit mask of SWD_BYPASS_RST field.
	RTC_CNTL_RTC_SWD_CONF_SWD_BYPASS_RST_Msk = 0x20000
	// Bit SWD_BYPASS_RST.
	RTC_CNTL_RTC_SWD_CONF_SWD_BYPASS_RST = 0x20000
	// Position of SWD_SIGNAL_WIDTH field.
	RTC_CNTL_RTC_SWD_CONF_SWD_SIGNAL_WIDTH_Pos = 0x12
	// Bit mask of SWD_SIGNAL_WIDTH field.
	RTC_CNTL_RTC_SWD_CONF_SWD_SIGNAL_WIDTH_Msk = 0xffc0000
	// Position of SWD_RST_FLAG_CLR field.
	RTC_CNTL_RTC_SWD_CONF_SWD_RST_FLAG_CLR_Pos = 0x1c
	// Bit mask of SWD_RST_FLAG_CLR field.
	RTC_CNTL_RTC_SWD_CONF_SWD_RST_FLAG_CLR_Msk = 0x10000000
	// Bit SWD_RST_FLAG_CLR.
	RTC_CNTL_RTC_SWD_CONF_SWD_RST_FLAG_CLR = 0x10000000
	// Position of SWD_FEED field.
	RTC_CNTL_RTC_SWD_CONF_SWD_FEED_Pos = 0x1d
	// Bit mask of SWD_FEED field.
	RTC_CNTL_RTC_SWD_CONF_SWD_FEED_Msk = 0x20000000
	// Bit SWD_FEED.
	RTC_CNTL_RTC_SWD_CONF_SWD_FEED = 0x20000000
	// Position of SWD_DISABLE field.
	RTC_CNTL_RTC_SWD_CONF_SWD_DISABLE_Pos = 0x1e
	// Bit mask of SWD_DISABLE field.
	RTC_CNTL_RTC_SWD_CONF_SWD_DISABLE_Msk = 0x40000000
	// Bit SWD_DISABLE.
	RTC_CNTL_RTC_SWD_CONF_SWD_DISABLE = 0x40000000
	// Position of SWD_AUTO_FEED_EN field.
	RTC_CNTL_RTC_SWD_CONF_SWD_AUTO_FEED_EN_Pos = 0x1f
	// Bit mask of SWD_AUTO_FEED_EN field.
	RTC_CNTL_RTC_SWD_CONF_SWD_AUTO_FEED_EN_Msk = 0x80000000
	// Bit SWD_AUTO_FEED_EN.
	RTC_CNTL_RTC_SWD_CONF_SWD_AUTO_FEED_EN = 0x80000000

	// RTC_SWD_WPROTECT: rtc configure register
	// Position of SWD_WKEY field.
	RTC_CNTL_RTC_SWD_WPROTECT_SWD_WKEY_Pos = 0x0
	// Bit mask of SWD_WKEY field.
	RTC_CNTL_RTC_SWD_WPROTECT_SWD_WKEY_Msk = 0xffffffff

	// RTC_SW_CPU_STALL: rtc configure register
	// Position of SW_STALL_APPCPU_C1 field.
	RTC_CNTL_RTC_SW_CPU_STALL_SW_STALL_APPCPU_C1_Pos = 0x14
	// Bit mask of SW_STALL_APPCPU_C1 field.
	RTC_CNTL_RTC_SW_CPU_STALL_SW_STALL_APPCPU_C1_Msk = 0x3f00000
	// Position of SW_STALL_PROCPU_C1 field.
	RTC_CNTL_RTC_SW_CPU_STALL_SW_STALL_PROCPU_C1_Pos = 0x1a
	// Bit mask of SW_STALL_PROCPU_C1 field.
	RTC_CNTL_RTC_SW_CPU_STALL_SW_STALL_PROCPU_C1_Msk = 0xfc000000

	// RTC_STORE4: rtc configure register
	// Position of RTC_SCRATCH4 field.
	RTC_CNTL_RTC_STORE4_RTC_SCRATCH4_Pos = 0x0
	// Bit mask of RTC_SCRATCH4 field.
	RTC_CNTL_RTC_STORE4_RTC_SCRATCH4_Msk = 0xffffffff

	// RTC_STORE5: rtc configure register
	// Position of RTC_SCRATCH5 field.
	RTC_CNTL_RTC_STORE5_RTC_SCRATCH5_Pos = 0x0
	// Bit mask of RTC_SCRATCH5 field.
	RTC_CNTL_RTC_STORE5_RTC_SCRATCH5_Msk = 0xffffffff

	// RTC_STORE6: rtc configure register
	// Position of RTC_SCRATCH6 field.
	RTC_CNTL_RTC_STORE6_RTC_SCRATCH6_Pos = 0x0
	// Bit mask of RTC_SCRATCH6 field.
	RTC_CNTL_RTC_STORE6_RTC_SCRATCH6_Msk = 0xffffffff

	// RTC_STORE7: rtc configure register
	// Position of RTC_SCRATCH7 field.
	RTC_CNTL_RTC_STORE7_RTC_SCRATCH7_Pos = 0x0
	// Bit mask of RTC_SCRATCH7 field.
	RTC_CNTL_RTC_STORE7_RTC_SCRATCH7_Msk = 0xffffffff

	// RTC_LOW_POWER_ST: rtc configure register
	// Position of XPD_ROM0 field.
	RTC_CNTL_RTC_LOW_POWER_ST_XPD_ROM0_Pos = 0x0
	// Bit mask of XPD_ROM0 field.
	RTC_CNTL_RTC_LOW_POWER_ST_XPD_ROM0_Msk = 0x1
	// Bit XPD_ROM0.
	RTC_CNTL_RTC_LOW_POWER_ST_XPD_ROM0 = 0x1
	// Position of XPD_DIG_DCDC field.
	RTC_CNTL_RTC_LOW_POWER_ST_XPD_DIG_DCDC_Pos = 0x2
	// Bit mask of XPD_DIG_DCDC field.
	RTC_CNTL_RTC_LOW_POWER_ST_XPD_DIG_DCDC_Msk = 0x4
	// Bit XPD_DIG_DCDC.
	RTC_CNTL_RTC_LOW_POWER_ST_XPD_DIG_DCDC = 0x4
	// Position of RTC_PERI_ISO field.
	RTC_CNTL_RTC_LOW_POWER_ST_RTC_PERI_ISO_Pos = 0x3
	// Bit mask of RTC_PERI_ISO field.
	RTC_CNTL_RTC_LOW_POWER_ST_RTC_PERI_ISO_Msk = 0x8
	// Bit RTC_PERI_ISO.
	RTC_CNTL_RTC_LOW_POWER_ST_RTC_PERI_ISO = 0x8
	// Position of XPD_RTC_PERI field.
	RTC_CNTL_RTC_LOW_POWER_ST_XPD_RTC_PERI_Pos = 0x4
	// Bit mask of XPD_RTC_PERI field.
	RTC_CNTL_RTC_LOW_POWER_ST_XPD_RTC_PERI_Msk = 0x10
	// Bit XPD_RTC_PERI.
	RTC_CNTL_RTC_LOW_POWER_ST_XPD_RTC_PERI = 0x10
	// Position of WIFI_ISO field.
	RTC_CNTL_RTC_LOW_POWER_ST_WIFI_ISO_Pos = 0x5
	// Bit mask of WIFI_ISO field.
	RTC_CNTL_RTC_LOW_POWER_ST_WIFI_ISO_Msk = 0x20
	// Bit WIFI_ISO.
	RTC_CNTL_RTC_LOW_POWER_ST_WIFI_ISO = 0x20
	// Position of XPD_WIFI field.
	RTC_CNTL_RTC_LOW_POWER_ST_XPD_WIFI_Pos = 0x6
	// Bit mask of XPD_WIFI field.
	RTC_CNTL_RTC_LOW_POWER_ST_XPD_WIFI_Msk = 0x40
	// Bit XPD_WIFI.
	RTC_CNTL_RTC_LOW_POWER_ST_XPD_WIFI = 0x40
	// Position of DIG_ISO field.
	RTC_CNTL_RTC_LOW_POWER_ST_DIG_ISO_Pos = 0x7
	// Bit mask of DIG_ISO field.
	RTC_CNTL_RTC_LOW_POWER_ST_DIG_ISO_Msk = 0x80
	// Bit DIG_ISO.
	RTC_CNTL_RTC_LOW_POWER_ST_DIG_ISO = 0x80
	// Position of XPD_DIG field.
	RTC_CNTL_RTC_LOW_POWER_ST_XPD_DIG_Pos = 0x8
	// Bit mask of XPD_DIG field.
	RTC_CNTL_RTC_LOW_POWER_ST_XPD_DIG_Msk = 0x100
	// Bit XPD_DIG.
	RTC_CNTL_RTC_LOW_POWER_ST_XPD_DIG = 0x100
	// Position of RTC_TOUCH_STATE_START field.
	RTC_CNTL_RTC_LOW_POWER_ST_RTC_TOUCH_STATE_START_Pos = 0x9
	// Bit mask of RTC_TOUCH_STATE_START field.
	RTC_CNTL_RTC_LOW_POWER_ST_RTC_TOUCH_STATE_START_Msk = 0x200
	// Bit RTC_TOUCH_STATE_START.
	RTC_CNTL_RTC_LOW_POWER_ST_RTC_TOUCH_STATE_START = 0x200
	// Position of RTC_TOUCH_STATE_SWITCH field.
	RTC_CNTL_RTC_LOW_POWER_ST_RTC_TOUCH_STATE_SWITCH_Pos = 0xa
	// Bit mask of RTC_TOUCH_STATE_SWITCH field.
	RTC_CNTL_RTC_LOW_POWER_ST_RTC_TOUCH_STATE_SWITCH_Msk = 0x400
	// Bit RTC_TOUCH_STATE_SWITCH.
	RTC_CNTL_RTC_LOW_POWER_ST_RTC_TOUCH_STATE_SWITCH = 0x400
	// Position of RTC_TOUCH_STATE_SLP field.
	RTC_CNTL_RTC_LOW_POWER_ST_RTC_TOUCH_STATE_SLP_Pos = 0xb
	// Bit mask of RTC_TOUCH_STATE_SLP field.
	RTC_CNTL_RTC_LOW_POWER_ST_RTC_TOUCH_STATE_SLP_Msk = 0x800
	// Bit RTC_TOUCH_STATE_SLP.
	RTC_CNTL_RTC_LOW_POWER_ST_RTC_TOUCH_STATE_SLP = 0x800
	// Position of RTC_TOUCH_STATE_DONE field.
	RTC_CNTL_RTC_LOW_POWER_ST_RTC_TOUCH_STATE_DONE_Pos = 0xc
	// Bit mask of RTC_TOUCH_STATE_DONE field.
	RTC_CNTL_RTC_LOW_POWER_ST_RTC_TOUCH_STATE_DONE_Msk = 0x1000
	// Bit RTC_TOUCH_STATE_DONE.
	RTC_CNTL_RTC_LOW_POWER_ST_RTC_TOUCH_STATE_DONE = 0x1000
	// Position of RTC_COCPU_STATE_START field.
	RTC_CNTL_RTC_LOW_POWER_ST_RTC_COCPU_STATE_START_Pos = 0xd
	// Bit mask of RTC_COCPU_STATE_START field.
	RTC_CNTL_RTC_LOW_POWER_ST_RTC_COCPU_STATE_START_Msk = 0x2000
	// Bit RTC_COCPU_STATE_START.
	RTC_CNTL_RTC_LOW_POWER_ST_RTC_COCPU_STATE_START = 0x2000
	// Position of RTC_COCPU_STATE_SWITCH field.
	RTC_CNTL_RTC_LOW_POWER_ST_RTC_COCPU_STATE_SWITCH_Pos = 0xe
	// Bit mask of RTC_COCPU_STATE_SWITCH field.
	RTC_CNTL_RTC_LOW_POWER_ST_RTC_COCPU_STATE_SWITCH_Msk = 0x4000
	// Bit RTC_COCPU_STATE_SWITCH.
	RTC_CNTL_RTC_LOW_POWER_ST_RTC_COCPU_STATE_SWITCH = 0x4000
	// Position of RTC_COCPU_STATE_SLP field.
	RTC_CNTL_RTC_LOW_POWER_ST_RTC_COCPU_STATE_SLP_Pos = 0xf
	// Bit mask of RTC_COCPU_STATE_SLP field.
	RTC_CNTL_RTC_LOW_POWER_ST_RTC_COCPU_STATE_SLP_Msk = 0x8000
	// Bit RTC_COCPU_STATE_SLP.
	RTC_CNTL_RTC_LOW_POWER_ST_RTC_COCPU_STATE_SLP = 0x8000
	// Position of RTC_COCPU_STATE_DONE field.
	RTC_CNTL_RTC_LOW_POWER_ST_RTC_COCPU_STATE_DONE_Pos = 0x10
	// Bit mask of RTC_COCPU_STATE_DONE field.
	RTC_CNTL_RTC_LOW_POWER_ST_RTC_COCPU_STATE_DONE_Msk = 0x10000
	// Bit RTC_COCPU_STATE_DONE.
	RTC_CNTL_RTC_LOW_POWER_ST_RTC_COCPU_STATE_DONE = 0x10000
	// Position of RTC_MAIN_STATE_XTAL_ISO field.
	RTC_CNTL_RTC_LOW_POWER_ST_RTC_MAIN_STATE_XTAL_ISO_Pos = 0x11
	// Bit mask of RTC_MAIN_STATE_XTAL_ISO field.
	RTC_CNTL_RTC_LOW_POWER_ST_RTC_MAIN_STATE_XTAL_ISO_Msk = 0x20000
	// Bit RTC_MAIN_STATE_XTAL_ISO.
	RTC_CNTL_RTC_LOW_POWER_ST_RTC_MAIN_STATE_XTAL_ISO = 0x20000
	// Position of RTC_MAIN_STATE_PLL_ON field.
	RTC_CNTL_RTC_LOW_POWER_ST_RTC_MAIN_STATE_PLL_ON_Pos = 0x12
	// Bit mask of RTC_MAIN_STATE_PLL_ON field.
	RTC_CNTL_RTC_LOW_POWER_ST_RTC_MAIN_STATE_PLL_ON_Msk = 0x40000
	// Bit RTC_MAIN_STATE_PLL_ON.
	RTC_CNTL_RTC_LOW_POWER_ST_RTC_MAIN_STATE_PLL_ON = 0x40000
	// Position of RTC_RDY_FOR_WAKEUP field.
	RTC_CNTL_RTC_LOW_POWER_ST_RTC_RDY_FOR_WAKEUP_Pos = 0x13
	// Bit mask of RTC_RDY_FOR_WAKEUP field.
	RTC_CNTL_RTC_LOW_POWER_ST_RTC_RDY_FOR_WAKEUP_Msk = 0x80000
	// Bit RTC_RDY_FOR_WAKEUP.
	RTC_CNTL_RTC_LOW_POWER_ST_RTC_RDY_FOR_WAKEUP = 0x80000
	// Position of RTC_MAIN_STATE_WAIT_END field.
	RTC_CNTL_RTC_LOW_POWER_ST_RTC_MAIN_STATE_WAIT_END_Pos = 0x14
	// Bit mask of RTC_MAIN_STATE_WAIT_END field.
	RTC_CNTL_RTC_LOW_POWER_ST_RTC_MAIN_STATE_WAIT_END_Msk = 0x100000
	// Bit RTC_MAIN_STATE_WAIT_END.
	RTC_CNTL_RTC_LOW_POWER_ST_RTC_MAIN_STATE_WAIT_END = 0x100000
	// Position of RTC_IN_WAKEUP_STATE field.
	RTC_CNTL_RTC_LOW_POWER_ST_RTC_IN_WAKEUP_STATE_Pos = 0x15
	// Bit mask of RTC_IN_WAKEUP_STATE field.
	RTC_CNTL_RTC_LOW_POWER_ST_RTC_IN_WAKEUP_STATE_Msk = 0x200000
	// Bit RTC_IN_WAKEUP_STATE.
	RTC_CNTL_RTC_LOW_POWER_ST_RTC_IN_WAKEUP_STATE = 0x200000
	// Position of RTC_IN_LOW_POWER_STATE field.
	RTC_CNTL_RTC_LOW_POWER_ST_RTC_IN_LOW_POWER_STATE_Pos = 0x16
	// Bit mask of RTC_IN_LOW_POWER_STATE field.
	RTC_CNTL_RTC_LOW_POWER_ST_RTC_IN_LOW_POWER_STATE_Msk = 0x400000
	// Bit RTC_IN_LOW_POWER_STATE.
	RTC_CNTL_RTC_LOW_POWER_ST_RTC_IN_LOW_POWER_STATE = 0x400000
	// Position of RTC_MAIN_STATE_IN_WAIT_8M field.
	RTC_CNTL_RTC_LOW_POWER_ST_RTC_MAIN_STATE_IN_WAIT_8M_Pos = 0x17
	// Bit mask of RTC_MAIN_STATE_IN_WAIT_8M field.
	RTC_CNTL_RTC_LOW_POWER_ST_RTC_MAIN_STATE_IN_WAIT_8M_Msk = 0x800000
	// Bit RTC_MAIN_STATE_IN_WAIT_8M.
	RTC_CNTL_RTC_LOW_POWER_ST_RTC_MAIN_STATE_IN_WAIT_8M = 0x800000
	// Position of RTC_MAIN_STATE_IN_WAIT_PLL field.
	RTC_CNTL_RTC_LOW_POWER_ST_RTC_MAIN_STATE_IN_WAIT_PLL_Pos = 0x18
	// Bit mask of RTC_MAIN_STATE_IN_WAIT_PLL field.
	RTC_CNTL_RTC_LOW_POWER_ST_RTC_MAIN_STATE_IN_WAIT_PLL_Msk = 0x1000000
	// Bit RTC_MAIN_STATE_IN_WAIT_PLL.
	RTC_CNTL_RTC_LOW_POWER_ST_RTC_MAIN_STATE_IN_WAIT_PLL = 0x1000000
	// Position of RTC_MAIN_STATE_IN_WAIT_XTL field.
	RTC_CNTL_RTC_LOW_POWER_ST_RTC_MAIN_STATE_IN_WAIT_XTL_Pos = 0x19
	// Bit mask of RTC_MAIN_STATE_IN_WAIT_XTL field.
	RTC_CNTL_RTC_LOW_POWER_ST_RTC_MAIN_STATE_IN_WAIT_XTL_Msk = 0x2000000
	// Bit RTC_MAIN_STATE_IN_WAIT_XTL.
	RTC_CNTL_RTC_LOW_POWER_ST_RTC_MAIN_STATE_IN_WAIT_XTL = 0x2000000
	// Position of RTC_MAIN_STATE_IN_SLP field.
	RTC_CNTL_RTC_LOW_POWER_ST_RTC_MAIN_STATE_IN_SLP_Pos = 0x1a
	// Bit mask of RTC_MAIN_STATE_IN_SLP field.
	RTC_CNTL_RTC_LOW_POWER_ST_RTC_MAIN_STATE_IN_SLP_Msk = 0x4000000
	// Bit RTC_MAIN_STATE_IN_SLP.
	RTC_CNTL_RTC_LOW_POWER_ST_RTC_MAIN_STATE_IN_SLP = 0x4000000
	// Position of RTC_MAIN_STATE_IN_IDLE field.
	RTC_CNTL_RTC_LOW_POWER_ST_RTC_MAIN_STATE_IN_IDLE_Pos = 0x1b
	// Bit mask of RTC_MAIN_STATE_IN_IDLE field.
	RTC_CNTL_RTC_LOW_POWER_ST_RTC_MAIN_STATE_IN_IDLE_Msk = 0x8000000
	// Bit RTC_MAIN_STATE_IN_IDLE.
	RTC_CNTL_RTC_LOW_POWER_ST_RTC_MAIN_STATE_IN_IDLE = 0x8000000
	// Position of RTC_MAIN_STATE field.
	RTC_CNTL_RTC_LOW_POWER_ST_RTC_MAIN_STATE_Pos = 0x1c
	// Bit mask of RTC_MAIN_STATE field.
	RTC_CNTL_RTC_LOW_POWER_ST_RTC_MAIN_STATE_Msk = 0xf0000000

	// RTC_DIAG0: rtc configure register
	// Position of RTC_LOW_POWER_DIAG1 field.
	RTC_CNTL_RTC_DIAG0_RTC_LOW_POWER_DIAG1_Pos = 0x0
	// Bit mask of RTC_LOW_POWER_DIAG1 field.
	RTC_CNTL_RTC_DIAG0_RTC_LOW_POWER_DIAG1_Msk = 0xffffffff

	// RTC_PAD_HOLD: rtc configure register
	// Position of RTC_GPIO_PIN0_HOLD field.
	RTC_CNTL_RTC_PAD_HOLD_RTC_GPIO_PIN0_HOLD_Pos = 0x0
	// Bit mask of RTC_GPIO_PIN0_HOLD field.
	RTC_CNTL_RTC_PAD_HOLD_RTC_GPIO_PIN0_HOLD_Msk = 0x1
	// Bit RTC_GPIO_PIN0_HOLD.
	RTC_CNTL_RTC_PAD_HOLD_RTC_GPIO_PIN0_HOLD = 0x1
	// Position of RTC_GPIO_PIN1_HOLD field.
	RTC_CNTL_RTC_PAD_HOLD_RTC_GPIO_PIN1_HOLD_Pos = 0x1
	// Bit mask of RTC_GPIO_PIN1_HOLD field.
	RTC_CNTL_RTC_PAD_HOLD_RTC_GPIO_PIN1_HOLD_Msk = 0x2
	// Bit RTC_GPIO_PIN1_HOLD.
	RTC_CNTL_RTC_PAD_HOLD_RTC_GPIO_PIN1_HOLD = 0x2
	// Position of RTC_GPIO_PIN2_HOLD field.
	RTC_CNTL_RTC_PAD_HOLD_RTC_GPIO_PIN2_HOLD_Pos = 0x2
	// Bit mask of RTC_GPIO_PIN2_HOLD field.
	RTC_CNTL_RTC_PAD_HOLD_RTC_GPIO_PIN2_HOLD_Msk = 0x4
	// Bit RTC_GPIO_PIN2_HOLD.
	RTC_CNTL_RTC_PAD_HOLD_RTC_GPIO_PIN2_HOLD = 0x4
	// Position of RTC_GPIO_PIN3_HOLD field.
	RTC_CNTL_RTC_PAD_HOLD_RTC_GPIO_PIN3_HOLD_Pos = 0x3
	// Bit mask of RTC_GPIO_PIN3_HOLD field.
	RTC_CNTL_RTC_PAD_HOLD_RTC_GPIO_PIN3_HOLD_Msk = 0x8
	// Bit RTC_GPIO_PIN3_HOLD.
	RTC_CNTL_RTC_PAD_HOLD_RTC_GPIO_PIN3_HOLD = 0x8
	// Position of RTC_GPIO_PIN4_HOLD field.
	RTC_CNTL_RTC_PAD_HOLD_RTC_GPIO_PIN4_HOLD_Pos = 0x4
	// Bit mask of RTC_GPIO_PIN4_HOLD field.
	RTC_CNTL_RTC_PAD_HOLD_RTC_GPIO_PIN4_HOLD_Msk = 0x10
	// Bit RTC_GPIO_PIN4_HOLD.
	RTC_CNTL_RTC_PAD_HOLD_RTC_GPIO_PIN4_HOLD = 0x10
	// Position of RTC_GPIO_PIN5_HOLD field.
	RTC_CNTL_RTC_PAD_HOLD_RTC_GPIO_PIN5_HOLD_Pos = 0x5
	// Bit mask of RTC_GPIO_PIN5_HOLD field.
	RTC_CNTL_RTC_PAD_HOLD_RTC_GPIO_PIN5_HOLD_Msk = 0x20
	// Bit RTC_GPIO_PIN5_HOLD.
	RTC_CNTL_RTC_PAD_HOLD_RTC_GPIO_PIN5_HOLD = 0x20

	// DIG_PAD_HOLD: rtc configure register
	// Position of DIG_PAD_HOLD field.
	RTC_CNTL_DIG_PAD_HOLD_DIG_PAD_HOLD_Pos = 0x0
	// Bit mask of DIG_PAD_HOLD field.
	RTC_CNTL_DIG_PAD_HOLD_DIG_PAD_HOLD_Msk = 0xffffffff

	// RTC_BROWN_OUT: rtc configure register
	// Position of BROWN_OUT_INT_WAIT field.
	RTC_CNTL_RTC_BROWN_OUT_BROWN_OUT_INT_WAIT_Pos = 0x4
	// Bit mask of BROWN_OUT_INT_WAIT field.
	RTC_CNTL_RTC_BROWN_OUT_BROWN_OUT_INT_WAIT_Msk = 0x3ff0
	// Position of BROWN_OUT_CLOSE_FLASH_ENA field.
	RTC_CNTL_RTC_BROWN_OUT_BROWN_OUT_CLOSE_FLASH_ENA_Pos = 0xe
	// Bit mask of BROWN_OUT_CLOSE_FLASH_ENA field.
	RTC_CNTL_RTC_BROWN_OUT_BROWN_OUT_CLOSE_FLASH_ENA_Msk = 0x4000
	// Bit BROWN_OUT_CLOSE_FLASH_ENA.
	RTC_CNTL_RTC_BROWN_OUT_BROWN_OUT_CLOSE_FLASH_ENA = 0x4000
	// Position of BROWN_OUT_PD_RF_ENA field.
	RTC_CNTL_RTC_BROWN_OUT_BROWN_OUT_PD_RF_ENA_Pos = 0xf
	// Bit mask of BROWN_OUT_PD_RF_ENA field.
	RTC_CNTL_RTC_BROWN_OUT_BROWN_OUT_PD_RF_ENA_Msk = 0x8000
	// Bit BROWN_OUT_PD_RF_ENA.
	RTC_CNTL_RTC_BROWN_OUT_BROWN_OUT_PD_RF_ENA = 0x8000
	// Position of BROWN_OUT_RST_WAIT field.
	RTC_CNTL_RTC_BROWN_OUT_BROWN_OUT_RST_WAIT_Pos = 0x10
	// Bit mask of BROWN_OUT_RST_WAIT field.
	RTC_CNTL_RTC_BROWN_OUT_BROWN_OUT_RST_WAIT_Msk = 0x3ff0000
	// Position of BROWN_OUT_RST_ENA field.
	RTC_CNTL_RTC_BROWN_OUT_BROWN_OUT_RST_ENA_Pos = 0x1a
	// Bit mask of BROWN_OUT_RST_ENA field.
	RTC_CNTL_RTC_BROWN_OUT_BROWN_OUT_RST_ENA_Msk = 0x4000000
	// Bit BROWN_OUT_RST_ENA.
	RTC_CNTL_RTC_BROWN_OUT_BROWN_OUT_RST_ENA = 0x4000000
	// Position of BROWN_OUT_RST_SEL field.
	RTC_CNTL_RTC_BROWN_OUT_BROWN_OUT_RST_SEL_Pos = 0x1b
	// Bit mask of BROWN_OUT_RST_SEL field.
	RTC_CNTL_RTC_BROWN_OUT_BROWN_OUT_RST_SEL_Msk = 0x8000000
	// Bit BROWN_OUT_RST_SEL.
	RTC_CNTL_RTC_BROWN_OUT_BROWN_OUT_RST_SEL = 0x8000000
	// Position of BROWN_OUT_ANA_RST_EN field.
	RTC_CNTL_RTC_BROWN_OUT_BROWN_OUT_ANA_RST_EN_Pos = 0x1c
	// Bit mask of BROWN_OUT_ANA_RST_EN field.
	RTC_CNTL_RTC_BROWN_OUT_BROWN_OUT_ANA_RST_EN_Msk = 0x10000000
	// Bit BROWN_OUT_ANA_RST_EN.
	RTC_CNTL_RTC_BROWN_OUT_BROWN_OUT_ANA_RST_EN = 0x10000000
	// Position of BROWN_OUT_CNT_CLR field.
	RTC_CNTL_RTC_BROWN_OUT_BROWN_OUT_CNT_CLR_Pos = 0x1d
	// Bit mask of BROWN_OUT_CNT_CLR field.
	RTC_CNTL_RTC_BROWN_OUT_BROWN_OUT_CNT_CLR_Msk = 0x20000000
	// Bit BROWN_OUT_CNT_CLR.
	RTC_CNTL_RTC_BROWN_OUT_BROWN_OUT_CNT_CLR = 0x20000000
	// Position of BROWN_OUT_ENA field.
	RTC_CNTL_RTC_BROWN_OUT_BROWN_OUT_ENA_Pos = 0x1e
	// Bit mask of BROWN_OUT_ENA field.
	RTC_CNTL_RTC_BROWN_OUT_BROWN_OUT_ENA_Msk = 0x40000000
	// Bit BROWN_OUT_ENA.
	RTC_CNTL_RTC_BROWN_OUT_BROWN_OUT_ENA = 0x40000000
	// Position of DET field.
	RTC_CNTL_RTC_BROWN_OUT_DET_Pos = 0x1f
	// Bit mask of DET field.
	RTC_CNTL_RTC_BROWN_OUT_DET_Msk = 0x80000000
	// Bit DET.
	RTC_CNTL_RTC_BROWN_OUT_DET = 0x80000000

	// RTC_TIME_LOW1: rtc configure register
	// Position of RTC_TIMER_VALUE1_LOW field.
	RTC_CNTL_RTC_TIME_LOW1_RTC_TIMER_VALUE1_LOW_Pos = 0x0
	// Bit mask of RTC_TIMER_VALUE1_LOW field.
	RTC_CNTL_RTC_TIME_LOW1_RTC_TIMER_VALUE1_LOW_Msk = 0xffffffff

	// RTC_TIME_HIGH1: rtc configure register
	// Position of RTC_TIMER_VALUE1_HIGH field.
	RTC_CNTL_RTC_TIME_HIGH1_RTC_TIMER_VALUE1_HIGH_Pos = 0x0
	// Bit mask of RTC_TIMER_VALUE1_HIGH field.
	RTC_CNTL_RTC_TIME_HIGH1_RTC_TIMER_VALUE1_HIGH_Msk = 0xffff

	// RTC_XTAL32K_CLK_FACTOR: rtc configure register
	// Position of XTAL32K_CLK_FACTOR field.
	RTC_CNTL_RTC_XTAL32K_CLK_FACTOR_XTAL32K_CLK_FACTOR_Pos = 0x0
	// Bit mask of XTAL32K_CLK_FACTOR field.
	RTC_CNTL_RTC_XTAL32K_CLK_FACTOR_XTAL32K_CLK_FACTOR_Msk = 0xffffffff

	// RTC_XTAL32K_CONF: rtc configure register
	// Position of XTAL32K_RETURN_WAIT field.
	RTC_CNTL_RTC_XTAL32K_CONF_XTAL32K_RETURN_WAIT_Pos = 0x0
	// Bit mask of XTAL32K_RETURN_WAIT field.
	RTC_CNTL_RTC_XTAL32K_CONF_XTAL32K_RETURN_WAIT_Msk = 0xf
	// Position of XTAL32K_RESTART_WAIT field.
	RTC_CNTL_RTC_XTAL32K_CONF_XTAL32K_RESTART_WAIT_Pos = 0x4
	// Bit mask of XTAL32K_RESTART_WAIT field.
	RTC_CNTL_RTC_XTAL32K_CONF_XTAL32K_RESTART_WAIT_Msk = 0xffff0
	// Position of XTAL32K_WDT_TIMEOUT field.
	RTC_CNTL_RTC_XTAL32K_CONF_XTAL32K_WDT_TIMEOUT_Pos = 0x14
	// Bit mask of XTAL32K_WDT_TIMEOUT field.
	RTC_CNTL_RTC_XTAL32K_CONF_XTAL32K_WDT_TIMEOUT_Msk = 0xff00000
	// Position of XTAL32K_STABLE_THRES field.
	RTC_CNTL_RTC_XTAL32K_CONF_XTAL32K_STABLE_THRES_Pos = 0x1c
	// Bit mask of XTAL32K_STABLE_THRES field.
	RTC_CNTL_RTC_XTAL32K_CONF_XTAL32K_STABLE_THRES_Msk = 0xf0000000

	// RTC_USB_CONF: rtc configure register
	// Position of IO_MUX_RESET_DISABLE field.
	RTC_CNTL_RTC_USB_CONF_IO_MUX_RESET_DISABLE_Pos = 0x12
	// Bit mask of IO_MUX_RESET_DISABLE field.
	RTC_CNTL_RTC_USB_CONF_IO_MUX_RESET_DISABLE_Msk = 0x40000
	// Bit IO_MUX_RESET_DISABLE.
	RTC_CNTL_RTC_USB_CONF_IO_MUX_RESET_DISABLE = 0x40000

	// RTC_SLP_REJECT_CAUSE: RTC_CNTL_RTC_SLP_REJECT_CAUSE_REG
	// Position of REJECT_CAUSE field.
	RTC_CNTL_RTC_SLP_REJECT_CAUSE_REJECT_CAUSE_Pos = 0x0
	// Bit mask of REJECT_CAUSE field.
	RTC_CNTL_RTC_SLP_REJECT_CAUSE_REJECT_CAUSE_Msk = 0x3ffff

	// RTC_OPTION1: rtc configure register
	// Position of FORCE_DOWNLOAD_BOOT field.
	RTC_CNTL_RTC_OPTION1_FORCE_DOWNLOAD_BOOT_Pos = 0x0
	// Bit mask of FORCE_DOWNLOAD_BOOT field.
	RTC_CNTL_RTC_OPTION1_FORCE_DOWNLOAD_BOOT_Msk = 0x1
	// Bit FORCE_DOWNLOAD_BOOT.
	RTC_CNTL_RTC_OPTION1_FORCE_DOWNLOAD_BOOT = 0x1

	// RTC_SLP_WAKEUP_CAUSE: RTC_CNTL_RTC_SLP_WAKEUP_CAUSE_REG
	// Position of WAKEUP_CAUSE field.
	RTC_CNTL_RTC_SLP_WAKEUP_CAUSE_WAKEUP_CAUSE_Pos = 0x0
	// Bit mask of WAKEUP_CAUSE field.
	RTC_CNTL_RTC_SLP_WAKEUP_CAUSE_WAKEUP_CAUSE_Msk = 0x1ffff

	// RTC_ULP_CP_TIMER_1: rtc configure register
	// Position of ULP_CP_TIMER_SLP_CYCLE field.
	RTC_CNTL_RTC_ULP_CP_TIMER_1_ULP_CP_TIMER_SLP_CYCLE_Pos = 0x8
	// Bit mask of ULP_CP_TIMER_SLP_CYCLE field.
	RTC_CNTL_RTC_ULP_CP_TIMER_1_ULP_CP_TIMER_SLP_CYCLE_Msk = 0xffffff00

	// INT_ENA_RTC_W1TS: rtc configure register
	// Position of SLP_WAKEUP_INT_ENA_W1TS field.
	RTC_CNTL_INT_ENA_RTC_W1TS_SLP_WAKEUP_INT_ENA_W1TS_Pos = 0x0
	// Bit mask of SLP_WAKEUP_INT_ENA_W1TS field.
	RTC_CNTL_INT_ENA_RTC_W1TS_SLP_WAKEUP_INT_ENA_W1TS_Msk = 0x1
	// Bit SLP_WAKEUP_INT_ENA_W1TS.
	RTC_CNTL_INT_ENA_RTC_W1TS_SLP_WAKEUP_INT_ENA_W1TS = 0x1
	// Position of SLP_REJECT_INT_ENA_W1TS field.
	RTC_CNTL_INT_ENA_RTC_W1TS_SLP_REJECT_INT_ENA_W1TS_Pos = 0x1
	// Bit mask of SLP_REJECT_INT_ENA_W1TS field.
	RTC_CNTL_INT_ENA_RTC_W1TS_SLP_REJECT_INT_ENA_W1TS_Msk = 0x2
	// Bit SLP_REJECT_INT_ENA_W1TS.
	RTC_CNTL_INT_ENA_RTC_W1TS_SLP_REJECT_INT_ENA_W1TS = 0x2
	// Position of RTC_WDT_INT_ENA_W1TS field.
	RTC_CNTL_INT_ENA_RTC_W1TS_RTC_WDT_INT_ENA_W1TS_Pos = 0x3
	// Bit mask of RTC_WDT_INT_ENA_W1TS field.
	RTC_CNTL_INT_ENA_RTC_W1TS_RTC_WDT_INT_ENA_W1TS_Msk = 0x8
	// Bit RTC_WDT_INT_ENA_W1TS.
	RTC_CNTL_INT_ENA_RTC_W1TS_RTC_WDT_INT_ENA_W1TS = 0x8
	// Position of RTC_BROWN_OUT_INT_ENA_W1TS field.
	RTC_CNTL_INT_ENA_RTC_W1TS_RTC_BROWN_OUT_INT_ENA_W1TS_Pos = 0x9
	// Bit mask of RTC_BROWN_OUT_INT_ENA_W1TS field.
	RTC_CNTL_INT_ENA_RTC_W1TS_RTC_BROWN_OUT_INT_ENA_W1TS_Msk = 0x200
	// Bit RTC_BROWN_OUT_INT_ENA_W1TS.
	RTC_CNTL_INT_ENA_RTC_W1TS_RTC_BROWN_OUT_INT_ENA_W1TS = 0x200
	// Position of RTC_MAIN_TIMER_INT_ENA_W1TS field.
	RTC_CNTL_INT_ENA_RTC_W1TS_RTC_MAIN_TIMER_INT_ENA_W1TS_Pos = 0xa
	// Bit mask of RTC_MAIN_TIMER_INT_ENA_W1TS field.
	RTC_CNTL_INT_ENA_RTC_W1TS_RTC_MAIN_TIMER_INT_ENA_W1TS_Msk = 0x400
	// Bit RTC_MAIN_TIMER_INT_ENA_W1TS.
	RTC_CNTL_INT_ENA_RTC_W1TS_RTC_MAIN_TIMER_INT_ENA_W1TS = 0x400
	// Position of RTC_SWD_INT_ENA_W1TS field.
	RTC_CNTL_INT_ENA_RTC_W1TS_RTC_SWD_INT_ENA_W1TS_Pos = 0xf
	// Bit mask of RTC_SWD_INT_ENA_W1TS field.
	RTC_CNTL_INT_ENA_RTC_W1TS_RTC_SWD_INT_ENA_W1TS_Msk = 0x8000
	// Bit RTC_SWD_INT_ENA_W1TS.
	RTC_CNTL_INT_ENA_RTC_W1TS_RTC_SWD_INT_ENA_W1TS = 0x8000
	// Position of RTC_XTAL32K_DEAD_INT_ENA_W1TS field.
	RTC_CNTL_INT_ENA_RTC_W1TS_RTC_XTAL32K_DEAD_INT_ENA_W1TS_Pos = 0x10
	// Bit mask of RTC_XTAL32K_DEAD_INT_ENA_W1TS field.
	RTC_CNTL_INT_ENA_RTC_W1TS_RTC_XTAL32K_DEAD_INT_ENA_W1TS_Msk = 0x10000
	// Bit RTC_XTAL32K_DEAD_INT_ENA_W1TS.
	RTC_CNTL_INT_ENA_RTC_W1TS_RTC_XTAL32K_DEAD_INT_ENA_W1TS = 0x10000
	// Position of RTC_GLITCH_DET_INT_ENA_W1TS field.
	RTC_CNTL_INT_ENA_RTC_W1TS_RTC_GLITCH_DET_INT_ENA_W1TS_Pos = 0x13
	// Bit mask of RTC_GLITCH_DET_INT_ENA_W1TS field.
	RTC_CNTL_INT_ENA_RTC_W1TS_RTC_GLITCH_DET_INT_ENA_W1TS_Msk = 0x80000
	// Bit RTC_GLITCH_DET_INT_ENA_W1TS.
	RTC_CNTL_INT_ENA_RTC_W1TS_RTC_GLITCH_DET_INT_ENA_W1TS = 0x80000
	// Position of RTC_BBPLL_CAL_INT_ENA_W1TS field.
	RTC_CNTL_INT_ENA_RTC_W1TS_RTC_BBPLL_CAL_INT_ENA_W1TS_Pos = 0x14
	// Bit mask of RTC_BBPLL_CAL_INT_ENA_W1TS field.
	RTC_CNTL_INT_ENA_RTC_W1TS_RTC_BBPLL_CAL_INT_ENA_W1TS_Msk = 0x100000
	// Bit RTC_BBPLL_CAL_INT_ENA_W1TS.
	RTC_CNTL_INT_ENA_RTC_W1TS_RTC_BBPLL_CAL_INT_ENA_W1TS = 0x100000

	// INT_ENA_RTC_W1TC: rtc configure register
	// Position of SLP_WAKEUP_INT_ENA_W1TC field.
	RTC_CNTL_INT_ENA_RTC_W1TC_SLP_WAKEUP_INT_ENA_W1TC_Pos = 0x0
	// Bit mask of SLP_WAKEUP_INT_ENA_W1TC field.
	RTC_CNTL_INT_ENA_RTC_W1TC_SLP_WAKEUP_INT_ENA_W1TC_Msk = 0x1
	// Bit SLP_WAKEUP_INT_ENA_W1TC.
	RTC_CNTL_INT_ENA_RTC_W1TC_SLP_WAKEUP_INT_ENA_W1TC = 0x1
	// Position of SLP_REJECT_INT_ENA_W1TC field.
	RTC_CNTL_INT_ENA_RTC_W1TC_SLP_REJECT_INT_ENA_W1TC_Pos = 0x1
	// Bit mask of SLP_REJECT_INT_ENA_W1TC field.
	RTC_CNTL_INT_ENA_RTC_W1TC_SLP_REJECT_INT_ENA_W1TC_Msk = 0x2
	// Bit SLP_REJECT_INT_ENA_W1TC.
	RTC_CNTL_INT_ENA_RTC_W1TC_SLP_REJECT_INT_ENA_W1TC = 0x2
	// Position of RTC_WDT_INT_ENA_W1TC field.
	RTC_CNTL_INT_ENA_RTC_W1TC_RTC_WDT_INT_ENA_W1TC_Pos = 0x3
	// Bit mask of RTC_WDT_INT_ENA_W1TC field.
	RTC_CNTL_INT_ENA_RTC_W1TC_RTC_WDT_INT_ENA_W1TC_Msk = 0x8
	// Bit RTC_WDT_INT_ENA_W1TC.
	RTC_CNTL_INT_ENA_RTC_W1TC_RTC_WDT_INT_ENA_W1TC = 0x8
	// Position of RTC_BROWN_OUT_INT_ENA_W1TC field.
	RTC_CNTL_INT_ENA_RTC_W1TC_RTC_BROWN_OUT_INT_ENA_W1TC_Pos = 0x9
	// Bit mask of RTC_BROWN_OUT_INT_ENA_W1TC field.
	RTC_CNTL_INT_ENA_RTC_W1TC_RTC_BROWN_OUT_INT_ENA_W1TC_Msk = 0x200
	// Bit RTC_BROWN_OUT_INT_ENA_W1TC.
	RTC_CNTL_INT_ENA_RTC_W1TC_RTC_BROWN_OUT_INT_ENA_W1TC = 0x200
	// Position of RTC_MAIN_TIMER_INT_ENA_W1TC field.
	RTC_CNTL_INT_ENA_RTC_W1TC_RTC_MAIN_TIMER_INT_ENA_W1TC_Pos = 0xa
	// Bit mask of RTC_MAIN_TIMER_INT_ENA_W1TC field.
	RTC_CNTL_INT_ENA_RTC_W1TC_RTC_MAIN_TIMER_INT_ENA_W1TC_Msk = 0x400
	// Bit RTC_MAIN_TIMER_INT_ENA_W1TC.
	RTC_CNTL_INT_ENA_RTC_W1TC_RTC_MAIN_TIMER_INT_ENA_W1TC = 0x400
	// Position of RTC_SWD_INT_ENA_W1TC field.
	RTC_CNTL_INT_ENA_RTC_W1TC_RTC_SWD_INT_ENA_W1TC_Pos = 0xf
	// Bit mask of RTC_SWD_INT_ENA_W1TC field.
	RTC_CNTL_INT_ENA_RTC_W1TC_RTC_SWD_INT_ENA_W1TC_Msk = 0x8000
	// Bit RTC_SWD_INT_ENA_W1TC.
	RTC_CNTL_INT_ENA_RTC_W1TC_RTC_SWD_INT_ENA_W1TC = 0x8000
	// Position of RTC_XTAL32K_DEAD_INT_ENA_W1TC field.
	RTC_CNTL_INT_ENA_RTC_W1TC_RTC_XTAL32K_DEAD_INT_ENA_W1TC_Pos = 0x10
	// Bit mask of RTC_XTAL32K_DEAD_INT_ENA_W1TC field.
	RTC_CNTL_INT_ENA_RTC_W1TC_RTC_XTAL32K_DEAD_INT_ENA_W1TC_Msk = 0x10000
	// Bit RTC_XTAL32K_DEAD_INT_ENA_W1TC.
	RTC_CNTL_INT_ENA_RTC_W1TC_RTC_XTAL32K_DEAD_INT_ENA_W1TC = 0x10000
	// Position of RTC_GLITCH_DET_INT_ENA_W1TC field.
	RTC_CNTL_INT_ENA_RTC_W1TC_RTC_GLITCH_DET_INT_ENA_W1TC_Pos = 0x13
	// Bit mask of RTC_GLITCH_DET_INT_ENA_W1TC field.
	RTC_CNTL_INT_ENA_RTC_W1TC_RTC_GLITCH_DET_INT_ENA_W1TC_Msk = 0x80000
	// Bit RTC_GLITCH_DET_INT_ENA_W1TC.
	RTC_CNTL_INT_ENA_RTC_W1TC_RTC_GLITCH_DET_INT_ENA_W1TC = 0x80000
	// Position of RTC_BBPLL_CAL_INT_ENA_W1TC field.
	RTC_CNTL_INT_ENA_RTC_W1TC_RTC_BBPLL_CAL_INT_ENA_W1TC_Pos = 0x14
	// Bit mask of RTC_BBPLL_CAL_INT_ENA_W1TC field.
	RTC_CNTL_INT_ENA_RTC_W1TC_RTC_BBPLL_CAL_INT_ENA_W1TC_Msk = 0x100000
	// Bit RTC_BBPLL_CAL_INT_ENA_W1TC.
	RTC_CNTL_INT_ENA_RTC_W1TC_RTC_BBPLL_CAL_INT_ENA_W1TC = 0x100000

	// RTC_CNTL_RETENTION_CTRL: rtc configure register
	// Position of RETENTION_CLK_SEL field.
	RTC_CNTL_RTC_CNTL_RETENTION_CTRL_RETENTION_CLK_SEL_Pos = 0x12
	// Bit mask of RETENTION_CLK_SEL field.
	RTC_CNTL_RTC_CNTL_RETENTION_CTRL_RETENTION_CLK_SEL_Msk = 0x40000
	// Bit RETENTION_CLK_SEL.
	RTC_CNTL_RTC_CNTL_RETENTION_CTRL_RETENTION_CLK_SEL = 0x40000
	// Position of RETENTION_DONE_WAIT field.
	RTC_CNTL_RTC_CNTL_RETENTION_CTRL_RETENTION_DONE_WAIT_Pos = 0x13
	// Bit mask of RETENTION_DONE_WAIT field.
	RTC_CNTL_RTC_CNTL_RETENTION_CTRL_RETENTION_DONE_WAIT_Msk = 0x380000
	// Position of RETENTION_CLKOFF_WAIT field.
	RTC_CNTL_RTC_CNTL_RETENTION_CTRL_RETENTION_CLKOFF_WAIT_Pos = 0x16
	// Bit mask of RETENTION_CLKOFF_WAIT field.
	RTC_CNTL_RTC_CNTL_RETENTION_CTRL_RETENTION_CLKOFF_WAIT_Msk = 0x3c00000
	// Position of RETENTION_EN field.
	RTC_CNTL_RTC_CNTL_RETENTION_CTRL_RETENTION_EN_Pos = 0x1a
	// Bit mask of RETENTION_EN field.
	RTC_CNTL_RTC_CNTL_RETENTION_CTRL_RETENTION_EN_Msk = 0x4000000
	// Bit RETENTION_EN.
	RTC_CNTL_RTC_CNTL_RETENTION_CTRL_RETENTION_EN = 0x4000000
	// Position of RETENTION_WAIT field.
	RTC_CNTL_RTC_CNTL_RETENTION_CTRL_RETENTION_WAIT_Pos = 0x1b
	// Bit mask of RETENTION_WAIT field.
	RTC_CNTL_RTC_CNTL_RETENTION_CTRL_RETENTION_WAIT_Msk = 0xf8000000

	// RTC_FIB_SEL: rtc configure register
	// Position of RTC_FIB_SEL field.
	RTC_CNTL_RTC_FIB_SEL_RTC_FIB_SEL_Pos = 0x0
	// Bit mask of RTC_FIB_SEL field.
	RTC_CNTL_RTC_FIB_SEL_RTC_FIB_SEL_Msk = 0x7

	// RTC_CNTL_GPIO_WAKEUP: rtc configure register
	// Position of RTC_GPIO_WAKEUP_STATUS field.
	RTC_CNTL_RTC_CNTL_GPIO_WAKEUP_RTC_GPIO_WAKEUP_STATUS_Pos = 0x0
	// Bit mask of RTC_GPIO_WAKEUP_STATUS field.
	RTC_CNTL_RTC_CNTL_GPIO_WAKEUP_RTC_GPIO_WAKEUP_STATUS_Msk = 0x3f
	// Position of RTC_GPIO_WAKEUP_STATUS_CLR field.
	RTC_CNTL_RTC_CNTL_GPIO_WAKEUP_RTC_GPIO_WAKEUP_STATUS_CLR_Pos = 0x6
	// Bit mask of RTC_GPIO_WAKEUP_STATUS_CLR field.
	RTC_CNTL_RTC_CNTL_GPIO_WAKEUP_RTC_GPIO_WAKEUP_STATUS_CLR_Msk = 0x40
	// Bit RTC_GPIO_WAKEUP_STATUS_CLR.
	RTC_CNTL_RTC_CNTL_GPIO_WAKEUP_RTC_GPIO_WAKEUP_STATUS_CLR = 0x40
	// Position of RTC_GPIO_PIN_CLK_GATE field.
	RTC_CNTL_RTC_CNTL_GPIO_WAKEUP_RTC_GPIO_PIN_CLK_GATE_Pos = 0x7
	// Bit mask of RTC_GPIO_PIN_CLK_GATE field.
	RTC_CNTL_RTC_CNTL_GPIO_WAKEUP_RTC_GPIO_PIN_CLK_GATE_Msk = 0x80
	// Bit RTC_GPIO_PIN_CLK_GATE.
	RTC_CNTL_RTC_CNTL_GPIO_WAKEUP_RTC_GPIO_PIN_CLK_GATE = 0x80
	// Position of RTC_GPIO_PIN5_INT_TYPE field.
	RTC_CNTL_RTC_CNTL_GPIO_WAKEUP_RTC_GPIO_PIN5_INT_TYPE_Pos = 0x8
	// Bit mask of RTC_GPIO_PIN5_INT_TYPE field.
	RTC_CNTL_RTC_CNTL_GPIO_WAKEUP_RTC_GPIO_PIN5_INT_TYPE_Msk = 0x700
	// Position of RTC_GPIO_PIN4_INT_TYPE field.
	RTC_CNTL_RTC_CNTL_GPIO_WAKEUP_RTC_GPIO_PIN4_INT_TYPE_Pos = 0xb
	// Bit mask of RTC_GPIO_PIN4_INT_TYPE field.
	RTC_CNTL_RTC_CNTL_GPIO_WAKEUP_RTC_GPIO_PIN4_INT_TYPE_Msk = 0x3800
	// Position of RTC_GPIO_PIN3_INT_TYPE field.
	RTC_CNTL_RTC_CNTL_GPIO_WAKEUP_RTC_GPIO_PIN3_INT_TYPE_Pos = 0xe
	// Bit mask of RTC_GPIO_PIN3_INT_TYPE field.
	RTC_CNTL_RTC_CNTL_GPIO_WAKEUP_RTC_GPIO_PIN3_INT_TYPE_Msk = 0x1c000
	// Position of RTC_GPIO_PIN2_INT_TYPE field.
	RTC_CNTL_RTC_CNTL_GPIO_WAKEUP_RTC_GPIO_PIN2_INT_TYPE_Pos = 0x11
	// Bit mask of RTC_GPIO_PIN2_INT_TYPE field.
	RTC_CNTL_RTC_CNTL_GPIO_WAKEUP_RTC_GPIO_PIN2_INT_TYPE_Msk = 0xe0000
	// Position of RTC_GPIO_PIN1_INT_TYPE field.
	RTC_CNTL_RTC_CNTL_GPIO_WAKEUP_RTC_GPIO_PIN1_INT_TYPE_Pos = 0x14
	// Bit mask of RTC_GPIO_PIN1_INT_TYPE field.
	RTC_CNTL_RTC_CNTL_GPIO_WAKEUP_RTC_GPIO_PIN1_INT_TYPE_Msk = 0x700000
	// Position of RTC_GPIO_PIN0_INT_TYPE field.
	RTC_CNTL_RTC_CNTL_GPIO_WAKEUP_RTC_GPIO_PIN0_INT_TYPE_Pos = 0x17
	// Bit mask of RTC_GPIO_PIN0_INT_TYPE field.
	RTC_CNTL_RTC_CNTL_GPIO_WAKEUP_RTC_GPIO_PIN0_INT_TYPE_Msk = 0x3800000
	// Position of RTC_GPIO_PIN5_WAKEUP_ENABLE field.
	RTC_CNTL_RTC_CNTL_GPIO_WAKEUP_RTC_GPIO_PIN5_WAKEUP_ENABLE_Pos = 0x1a
	// Bit mask of RTC_GPIO_PIN5_WAKEUP_ENABLE field.
	RTC_CNTL_RTC_CNTL_GPIO_WAKEUP_RTC_GPIO_PIN5_WAKEUP_ENABLE_Msk = 0x4000000
	// Bit RTC_GPIO_PIN5_WAKEUP_ENABLE.
	RTC_CNTL_RTC_CNTL_GPIO_WAKEUP_RTC_GPIO_PIN5_WAKEUP_ENABLE = 0x4000000
	// Position of RTC_GPIO_PIN4_WAKEUP_ENABLE field.
	RTC_CNTL_RTC_CNTL_GPIO_WAKEUP_RTC_GPIO_PIN4_WAKEUP_ENABLE_Pos = 0x1b
	// Bit mask of RTC_GPIO_PIN4_WAKEUP_ENABLE field.
	RTC_CNTL_RTC_CNTL_GPIO_WAKEUP_RTC_GPIO_PIN4_WAKEUP_ENABLE_Msk = 0x8000000
	// Bit RTC_GPIO_PIN4_WAKEUP_ENABLE.
	RTC_CNTL_RTC_CNTL_GPIO_WAKEUP_RTC_GPIO_PIN4_WAKEUP_ENABLE = 0x8000000
	// Position of RTC_GPIO_PIN3_WAKEUP_ENABLE field.
	RTC_CNTL_RTC_CNTL_GPIO_WAKEUP_RTC_GPIO_PIN3_WAKEUP_ENABLE_Pos = 0x1c
	// Bit mask of RTC_GPIO_PIN3_WAKEUP_ENABLE field.
	RTC_CNTL_RTC_CNTL_GPIO_WAKEUP_RTC_GPIO_PIN3_WAKEUP_ENABLE_Msk = 0x10000000
	// Bit RTC_GPIO_PIN3_WAKEUP_ENABLE.
	RTC_CNTL_RTC_CNTL_GPIO_WAKEUP_RTC_GPIO_PIN3_WAKEUP_ENABLE = 0x10000000
	// Position of RTC_GPIO_PIN2_WAKEUP_ENABLE field.
	RTC_CNTL_RTC_CNTL_GPIO_WAKEUP_RTC_GPIO_PIN2_WAKEUP_ENABLE_Pos = 0x1d
	// Bit mask of RTC_GPIO_PIN2_WAKEUP_ENABLE field.
	RTC_CNTL_RTC_CNTL_GPIO_WAKEUP_RTC_GPIO_PIN2_WAKEUP_ENABLE_Msk = 0x20000000
	// Bit RTC_GPIO_PIN2_WAKEUP_ENABLE.
	RTC_CNTL_RTC_CNTL_GPIO_WAKEUP_RTC_GPIO_PIN2_WAKEUP_ENABLE = 0x20000000
	// Position of RTC_GPIO_PIN1_WAKEUP_ENABLE field.
	RTC_CNTL_RTC_CNTL_GPIO_WAKEUP_RTC_GPIO_PIN1_WAKEUP_ENABLE_Pos = 0x1e
	// Bit mask of RTC_GPIO_PIN1_WAKEUP_ENABLE field.
	RTC_CNTL_RTC_CNTL_GPIO_WAKEUP_RTC_GPIO_PIN1_WAKEUP_ENABLE_Msk = 0x40000000
	// Bit RTC_GPIO_PIN1_WAKEUP_ENABLE.
	RTC_CNTL_RTC_CNTL_GPIO_WAKEUP_RTC_GPIO_PIN1_WAKEUP_ENABLE = 0x40000000
	// Position of RTC_GPIO_PIN0_WAKEUP_ENABLE field.
	RTC_CNTL_RTC_CNTL_GPIO_WAKEUP_RTC_GPIO_PIN0_WAKEUP_ENABLE_Pos = 0x1f
	// Bit mask of RTC_GPIO_PIN0_WAKEUP_ENABLE field.
	RTC_CNTL_RTC_CNTL_GPIO_WAKEUP_RTC_GPIO_PIN0_WAKEUP_ENABLE_Msk = 0x80000000
	// Bit RTC_GPIO_PIN0_WAKEUP_ENABLE.
	RTC_CNTL_RTC_CNTL_GPIO_WAKEUP_RTC_GPIO_PIN0_WAKEUP_ENABLE = 0x80000000

	// RTC_CNTL_DBG_SEL: rtc configure register
	// Position of RTC_DEBUG_12M_NO_GATING field.
	RTC_CNTL_RTC_CNTL_DBG_SEL_RTC_DEBUG_12M_NO_GATING_Pos = 0x1
	// Bit mask of RTC_DEBUG_12M_NO_GATING field.
	RTC_CNTL_RTC_CNTL_DBG_SEL_RTC_DEBUG_12M_NO_GATING_Msk = 0x2
	// Bit RTC_DEBUG_12M_NO_GATING.
	RTC_CNTL_RTC_CNTL_DBG_SEL_RTC_DEBUG_12M_NO_GATING = 0x2
	// Position of RTC_DEBUG_BIT_SEL field.
	RTC_CNTL_RTC_CNTL_DBG_SEL_RTC_DEBUG_BIT_SEL_Pos = 0x2
	// Bit mask of RTC_DEBUG_BIT_SEL field.
	RTC_CNTL_RTC_CNTL_DBG_SEL_RTC_DEBUG_BIT_SEL_Msk = 0x7c
	// Position of RTC_DEBUG_SEL0 field.
	RTC_CNTL_RTC_CNTL_DBG_SEL_RTC_DEBUG_SEL0_Pos = 0x7
	// Bit mask of RTC_DEBUG_SEL0 field.
	RTC_CNTL_RTC_CNTL_DBG_SEL_RTC_DEBUG_SEL0_Msk = 0xf80
	// Position of RTC_DEBUG_SEL1 field.
	RTC_CNTL_RTC_CNTL_DBG_SEL_RTC_DEBUG_SEL1_Pos = 0xc
	// Bit mask of RTC_DEBUG_SEL1 field.
	RTC_CNTL_RTC_CNTL_DBG_SEL_RTC_DEBUG_SEL1_Msk = 0x1f000
	// Position of RTC_DEBUG_SEL2 field.
	RTC_CNTL_RTC_CNTL_DBG_SEL_RTC_DEBUG_SEL2_Pos = 0x11
	// Bit mask of RTC_DEBUG_SEL2 field.
	RTC_CNTL_RTC_CNTL_DBG_SEL_RTC_DEBUG_SEL2_Msk = 0x3e0000
	// Position of RTC_DEBUG_SEL3 field.
	RTC_CNTL_RTC_CNTL_DBG_SEL_RTC_DEBUG_SEL3_Pos = 0x16
	// Bit mask of RTC_DEBUG_SEL3 field.
	RTC_CNTL_RTC_CNTL_DBG_SEL_RTC_DEBUG_SEL3_Msk = 0x7c00000
	// Position of RTC_DEBUG_SEL4 field.
	RTC_CNTL_RTC_CNTL_DBG_SEL_RTC_DEBUG_SEL4_Pos = 0x1b
	// Bit mask of RTC_DEBUG_SEL4 field.
	RTC_CNTL_RTC_CNTL_DBG_SEL_RTC_DEBUG_SEL4_Msk = 0xf8000000

	// RTC_CNTL_DBG_MAP: rtc configure register
	// Position of RTC_GPIO_PIN5_MUX_SEL field.
	RTC_CNTL_RTC_CNTL_DBG_MAP_RTC_GPIO_PIN5_MUX_SEL_Pos = 0x2
	// Bit mask of RTC_GPIO_PIN5_MUX_SEL field.
	RTC_CNTL_RTC_CNTL_DBG_MAP_RTC_GPIO_PIN5_MUX_SEL_Msk = 0x4
	// Bit RTC_GPIO_PIN5_MUX_SEL.
	RTC_CNTL_RTC_CNTL_DBG_MAP_RTC_GPIO_PIN5_MUX_SEL = 0x4
	// Position of RTC_GPIO_PIN4_MUX_SEL field.
	RTC_CNTL_RTC_CNTL_DBG_MAP_RTC_GPIO_PIN4_MUX_SEL_Pos = 0x3
	// Bit mask of RTC_GPIO_PIN4_MUX_SEL field.
	RTC_CNTL_RTC_CNTL_DBG_MAP_RTC_GPIO_PIN4_MUX_SEL_Msk = 0x8
	// Bit RTC_GPIO_PIN4_MUX_SEL.
	RTC_CNTL_RTC_CNTL_DBG_MAP_RTC_GPIO_PIN4_MUX_SEL = 0x8
	// Position of RTC_GPIO_PIN3_MUX_SEL field.
	RTC_CNTL_RTC_CNTL_DBG_MAP_RTC_GPIO_PIN3_MUX_SEL_Pos = 0x4
	// Bit mask of RTC_GPIO_PIN3_MUX_SEL field.
	RTC_CNTL_RTC_CNTL_DBG_MAP_RTC_GPIO_PIN3_MUX_SEL_Msk = 0x10
	// Bit RTC_GPIO_PIN3_MUX_SEL.
	RTC_CNTL_RTC_CNTL_DBG_MAP_RTC_GPIO_PIN3_MUX_SEL = 0x10
	// Position of RTC_GPIO_PIN2_MUX_SEL field.
	RTC_CNTL_RTC_CNTL_DBG_MAP_RTC_GPIO_PIN2_MUX_SEL_Pos = 0x5
	// Bit mask of RTC_GPIO_PIN2_MUX_SEL field.
	RTC_CNTL_RTC_CNTL_DBG_MAP_RTC_GPIO_PIN2_MUX_SEL_Msk = 0x20
	// Bit RTC_GPIO_PIN2_MUX_SEL.
	RTC_CNTL_RTC_CNTL_DBG_MAP_RTC_GPIO_PIN2_MUX_SEL = 0x20
	// Position of RTC_GPIO_PIN1_MUX_SEL field.
	RTC_CNTL_RTC_CNTL_DBG_MAP_RTC_GPIO_PIN1_MUX_SEL_Pos = 0x6
	// Bit mask of RTC_GPIO_PIN1_MUX_SEL field.
	RTC_CNTL_RTC_CNTL_DBG_MAP_RTC_GPIO_PIN1_MUX_SEL_Msk = 0x40
	// Bit RTC_GPIO_PIN1_MUX_SEL.
	RTC_CNTL_RTC_CNTL_DBG_MAP_RTC_GPIO_PIN1_MUX_SEL = 0x40
	// Position of RTC_GPIO_PIN0_MUX_SEL field.
	RTC_CNTL_RTC_CNTL_DBG_MAP_RTC_GPIO_PIN0_MUX_SEL_Pos = 0x7
	// Bit mask of RTC_GPIO_PIN0_MUX_SEL field.
	RTC_CNTL_RTC_CNTL_DBG_MAP_RTC_GPIO_PIN0_MUX_SEL_Msk = 0x80
	// Bit RTC_GPIO_PIN0_MUX_SEL.
	RTC_CNTL_RTC_CNTL_DBG_MAP_RTC_GPIO_PIN0_MUX_SEL = 0x80
	// Position of RTC_GPIO_PIN5_FUN_SEL field.
	RTC_CNTL_RTC_CNTL_DBG_MAP_RTC_GPIO_PIN5_FUN_SEL_Pos = 0x8
	// Bit mask of RTC_GPIO_PIN5_FUN_SEL field.
	RTC_CNTL_RTC_CNTL_DBG_MAP_RTC_GPIO_PIN5_FUN_SEL_Msk = 0xf00
	// Position of RTC_GPIO_PIN4_FUN_SEL field.
	RTC_CNTL_RTC_CNTL_DBG_MAP_RTC_GPIO_PIN4_FUN_SEL_Pos = 0xc
	// Bit mask of RTC_GPIO_PIN4_FUN_SEL field.
	RTC_CNTL_RTC_CNTL_DBG_MAP_RTC_GPIO_PIN4_FUN_SEL_Msk = 0xf000
	// Position of RTC_GPIO_PIN3_FUN_SEL field.
	RTC_CNTL_RTC_CNTL_DBG_MAP_RTC_GPIO_PIN3_FUN_SEL_Pos = 0x10
	// Bit mask of RTC_GPIO_PIN3_FUN_SEL field.
	RTC_CNTL_RTC_CNTL_DBG_MAP_RTC_GPIO_PIN3_FUN_SEL_Msk = 0xf0000
	// Position of RTC_GPIO_PIN2_FUN_SEL field.
	RTC_CNTL_RTC_CNTL_DBG_MAP_RTC_GPIO_PIN2_FUN_SEL_Pos = 0x14
	// Bit mask of RTC_GPIO_PIN2_FUN_SEL field.
	RTC_CNTL_RTC_CNTL_DBG_MAP_RTC_GPIO_PIN2_FUN_SEL_Msk = 0xf00000
	// Position of RTC_GPIO_PIN1_FUN_SEL field.
	RTC_CNTL_RTC_CNTL_DBG_MAP_RTC_GPIO_PIN1_FUN_SEL_Pos = 0x18
	// Bit mask of RTC_GPIO_PIN1_FUN_SEL field.
	RTC_CNTL_RTC_CNTL_DBG_MAP_RTC_GPIO_PIN1_FUN_SEL_Msk = 0xf000000
	// Position of RTC_GPIO_PIN0_FUN_SEL field.
	RTC_CNTL_RTC_CNTL_DBG_MAP_RTC_GPIO_PIN0_FUN_SEL_Pos = 0x1c
	// Bit mask of RTC_GPIO_PIN0_FUN_SEL field.
	RTC_CNTL_RTC_CNTL_DBG_MAP_RTC_GPIO_PIN0_FUN_SEL_Msk = 0xf0000000

	// RTC_CNTL_SENSOR_CTRL: rtc configure register
	// Position of SAR2_PWDET_CCT field.
	RTC_CNTL_RTC_CNTL_SENSOR_CTRL_SAR2_PWDET_CCT_Pos = 0x1b
	// Bit mask of SAR2_PWDET_CCT field.
	RTC_CNTL_RTC_CNTL_SENSOR_CTRL_SAR2_PWDET_CCT_Msk = 0x38000000
	// Position of FORCE_XPD_SAR field.
	RTC_CNTL_RTC_CNTL_SENSOR_CTRL_FORCE_XPD_SAR_Pos = 0x1e
	// Bit mask of FORCE_XPD_SAR field.
	RTC_CNTL_RTC_CNTL_SENSOR_CTRL_FORCE_XPD_SAR_Msk = 0xc0000000

	// RTC_CNTL_DBG_SAR_SEL: rtc configure register
	// Position of SAR_DEBUG_SEL field.
	RTC_CNTL_RTC_CNTL_DBG_SAR_SEL_SAR_DEBUG_SEL_Pos = 0x1b
	// Bit mask of SAR_DEBUG_SEL field.
	RTC_CNTL_RTC_CNTL_DBG_SAR_SEL_SAR_DEBUG_SEL_Msk = 0xf8000000

	// RTC_CNTL_PG_CTRL: rtc configure register
	// Position of POWER_GLITCH_DSENSE field.
	RTC_CNTL_RTC_CNTL_PG_CTRL_POWER_GLITCH_DSENSE_Pos = 0x1a
	// Bit mask of POWER_GLITCH_DSENSE field.
	RTC_CNTL_RTC_CNTL_PG_CTRL_POWER_GLITCH_DSENSE_Msk = 0xc000000
	// Position of POWER_GLITCH_FORCE_PD field.
	RTC_CNTL_RTC_CNTL_PG_CTRL_POWER_GLITCH_FORCE_PD_Pos = 0x1c
	// Bit mask of POWER_GLITCH_FORCE_PD field.
	RTC_CNTL_RTC_CNTL_PG_CTRL_POWER_GLITCH_FORCE_PD_Msk = 0x10000000
	// Bit POWER_GLITCH_FORCE_PD.
	RTC_CNTL_RTC_CNTL_PG_CTRL_POWER_GLITCH_FORCE_PD = 0x10000000
	// Position of POWER_GLITCH_FORCE_PU field.
	RTC_CNTL_RTC_CNTL_PG_CTRL_POWER_GLITCH_FORCE_PU_Pos = 0x1d
	// Bit mask of POWER_GLITCH_FORCE_PU field.
	RTC_CNTL_RTC_CNTL_PG_CTRL_POWER_GLITCH_FORCE_PU_Msk = 0x20000000
	// Bit POWER_GLITCH_FORCE_PU.
	RTC_CNTL_RTC_CNTL_PG_CTRL_POWER_GLITCH_FORCE_PU = 0x20000000
	// Position of POWER_GLITCH_EFUSE_SEL field.
	RTC_CNTL_RTC_CNTL_PG_CTRL_POWER_GLITCH_EFUSE_SEL_Pos = 0x1e
	// Bit mask of POWER_GLITCH_EFUSE_SEL field.
	RTC_CNTL_RTC_CNTL_PG_CTRL_POWER_GLITCH_EFUSE_SEL_Msk = 0x40000000
	// Bit POWER_GLITCH_EFUSE_SEL.
	RTC_CNTL_RTC_CNTL_PG_CTRL_POWER_GLITCH_EFUSE_SEL = 0x40000000
	// Position of POWER_GLITCH_EN field.
	RTC_CNTL_RTC_CNTL_PG_CTRL_POWER_GLITCH_EN_Pos = 0x1f
	// Bit mask of POWER_GLITCH_EN field.
	RTC_CNTL_RTC_CNTL_PG_CTRL_POWER_GLITCH_EN_Msk = 0x80000000
	// Bit POWER_GLITCH_EN.
	RTC_CNTL_RTC_CNTL_PG_CTRL_POWER_GLITCH_EN = 0x80000000

	// DATE: rtc configure register
	// Position of RTC_CNTL_DATE field.
	RTC_CNTL_DATE_RTC_CNTL_DATE_Pos = 0x0
	// Bit mask of RTC_CNTL_DATE field.
	RTC_CNTL_DATE_RTC_CNTL_DATE_Msk = 0xfffffff
)

// Constants for SENSITIVE: Peripheral SENSITIVE
const (
	// ROM_TABLE_LOCK: SENSITIVE_ROM_TABLE_LOCK_REG
	// Position of ROM_TABLE_LOCK field.
	SENSITIVE_ROM_TABLE_LOCK_ROM_TABLE_LOCK_Pos = 0x0
	// Bit mask of ROM_TABLE_LOCK field.
	SENSITIVE_ROM_TABLE_LOCK_ROM_TABLE_LOCK_Msk = 0x1
	// Bit ROM_TABLE_LOCK.
	SENSITIVE_ROM_TABLE_LOCK_ROM_TABLE_LOCK = 0x1

	// ROM_TABLE: SENSITIVE_ROM_TABLE_REG
	// Position of ROM_TABLE field.
	SENSITIVE_ROM_TABLE_ROM_TABLE_Pos = 0x0
	// Bit mask of ROM_TABLE field.
	SENSITIVE_ROM_TABLE_ROM_TABLE_Msk = 0xffffffff

	// PRIVILEGE_MODE_SEL_LOCK: SENSITIVE_PRIVILEGE_MODE_SEL_LOCK_REG
	// Position of PRIVILEGE_MODE_SEL_LOCK field.
	SENSITIVE_PRIVILEGE_MODE_SEL_LOCK_PRIVILEGE_MODE_SEL_LOCK_Pos = 0x0
	// Bit mask of PRIVILEGE_MODE_SEL_LOCK field.
	SENSITIVE_PRIVILEGE_MODE_SEL_LOCK_PRIVILEGE_MODE_SEL_LOCK_Msk = 0x1
	// Bit PRIVILEGE_MODE_SEL_LOCK.
	SENSITIVE_PRIVILEGE_MODE_SEL_LOCK_PRIVILEGE_MODE_SEL_LOCK = 0x1

	// PRIVILEGE_MODE_SEL: SENSITIVE_PRIVILEGE_MODE_SEL_REG
	// Position of PRIVILEGE_MODE_SEL field.
	SENSITIVE_PRIVILEGE_MODE_SEL_PRIVILEGE_MODE_SEL_Pos = 0x0
	// Bit mask of PRIVILEGE_MODE_SEL field.
	SENSITIVE_PRIVILEGE_MODE_SEL_PRIVILEGE_MODE_SEL_Msk = 0x1
	// Bit PRIVILEGE_MODE_SEL.
	SENSITIVE_PRIVILEGE_MODE_SEL_PRIVILEGE_MODE_SEL = 0x1

	// APB_PERIPHERAL_ACCESS_0: SENSITIVE_APB_PERIPHERAL_ACCESS_0_REG
	// Position of APB_PERIPHERAL_ACCESS_LOCK field.
	SENSITIVE_APB_PERIPHERAL_ACCESS_0_APB_PERIPHERAL_ACCESS_LOCK_Pos = 0x0
	// Bit mask of APB_PERIPHERAL_ACCESS_LOCK field.
	SENSITIVE_APB_PERIPHERAL_ACCESS_0_APB_PERIPHERAL_ACCESS_LOCK_Msk = 0x1
	// Bit APB_PERIPHERAL_ACCESS_LOCK.
	SENSITIVE_APB_PERIPHERAL_ACCESS_0_APB_PERIPHERAL_ACCESS_LOCK = 0x1

	// APB_PERIPHERAL_ACCESS_1: SENSITIVE_APB_PERIPHERAL_ACCESS_1_REG
	// Position of APB_PERIPHERAL_ACCESS_SPLIT_BURST field.
	SENSITIVE_APB_PERIPHERAL_ACCESS_1_APB_PERIPHERAL_ACCESS_SPLIT_BURST_Pos = 0x0
	// Bit mask of APB_PERIPHERAL_ACCESS_SPLIT_BURST field.
	SENSITIVE_APB_PERIPHERAL_ACCESS_1_APB_PERIPHERAL_ACCESS_SPLIT_BURST_Msk = 0x1
	// Bit APB_PERIPHERAL_ACCESS_SPLIT_BURST.
	SENSITIVE_APB_PERIPHERAL_ACCESS_1_APB_PERIPHERAL_ACCESS_SPLIT_BURST = 0x1

	// INTERNAL_SRAM_USAGE_0: SENSITIVE_INTERNAL_SRAM_USAGE_0_REG
	// Position of INTERNAL_SRAM_USAGE_LOCK field.
	SENSITIVE_INTERNAL_SRAM_USAGE_0_INTERNAL_SRAM_USAGE_LOCK_Pos = 0x0
	// Bit mask of INTERNAL_SRAM_USAGE_LOCK field.
	SENSITIVE_INTERNAL_SRAM_USAGE_0_INTERNAL_SRAM_USAGE_LOCK_Msk = 0x1
	// Bit INTERNAL_SRAM_USAGE_LOCK.
	SENSITIVE_INTERNAL_SRAM_USAGE_0_INTERNAL_SRAM_USAGE_LOCK = 0x1

	// INTERNAL_SRAM_USAGE_1: SENSITIVE_INTERNAL_SRAM_USAGE_1_REG
	// Position of INTERNAL_SRAM_USAGE_CPU_CACHE field.
	SENSITIVE_INTERNAL_SRAM_USAGE_1_INTERNAL_SRAM_USAGE_CPU_CACHE_Pos = 0x0
	// Bit mask of INTERNAL_SRAM_USAGE_CPU_CACHE field.
	SENSITIVE_INTERNAL_SRAM_USAGE_1_INTERNAL_SRAM_USAGE_CPU_CACHE_Msk = 0x1
	// Bit INTERNAL_SRAM_USAGE_CPU_CACHE.
	SENSITIVE_INTERNAL_SRAM_USAGE_1_INTERNAL_SRAM_USAGE_CPU_CACHE = 0x1
	// Position of INTERNAL_SRAM_USAGE_CPU_SRAM field.
	SENSITIVE_INTERNAL_SRAM_USAGE_1_INTERNAL_SRAM_USAGE_CPU_SRAM_Pos = 0x1
	// Bit mask of INTERNAL_SRAM_USAGE_CPU_SRAM field.
	SENSITIVE_INTERNAL_SRAM_USAGE_1_INTERNAL_SRAM_USAGE_CPU_SRAM_Msk = 0xe

	// INTERNAL_SRAM_USAGE_3: SENSITIVE_INTERNAL_SRAM_USAGE_3_REG
	// Position of INTERNAL_SRAM_USAGE_MAC_DUMP_SRAM field.
	SENSITIVE_INTERNAL_SRAM_USAGE_3_INTERNAL_SRAM_USAGE_MAC_DUMP_SRAM_Pos = 0x0
	// Bit mask of INTERNAL_SRAM_USAGE_MAC_DUMP_SRAM field.
	SENSITIVE_INTERNAL_SRAM_USAGE_3_INTERNAL_SRAM_USAGE_MAC_DUMP_SRAM_Msk = 0x7
	// Position of INTERNAL_SRAM_ALLOC_MAC_DUMP field.
	SENSITIVE_INTERNAL_SRAM_USAGE_3_INTERNAL_SRAM_ALLOC_MAC_DUMP_Pos = 0x3
	// Bit mask of INTERNAL_SRAM_ALLOC_MAC_DUMP field.
	SENSITIVE_INTERNAL_SRAM_USAGE_3_INTERNAL_SRAM_ALLOC_MAC_DUMP_Msk = 0x8
	// Bit INTERNAL_SRAM_ALLOC_MAC_DUMP.
	SENSITIVE_INTERNAL_SRAM_USAGE_3_INTERNAL_SRAM_ALLOC_MAC_DUMP = 0x8

	// INTERNAL_SRAM_USAGE_4: SENSITIVE_INTERNAL_SRAM_USAGE_4_REG
	// Position of INTERNAL_SRAM_USAGE_LOG_SRAM field.
	SENSITIVE_INTERNAL_SRAM_USAGE_4_INTERNAL_SRAM_USAGE_LOG_SRAM_Pos = 0x0
	// Bit mask of INTERNAL_SRAM_USAGE_LOG_SRAM field.
	SENSITIVE_INTERNAL_SRAM_USAGE_4_INTERNAL_SRAM_USAGE_LOG_SRAM_Msk = 0x1
	// Bit INTERNAL_SRAM_USAGE_LOG_SRAM.
	SENSITIVE_INTERNAL_SRAM_USAGE_4_INTERNAL_SRAM_USAGE_LOG_SRAM = 0x1

	// CACHE_TAG_ACCESS_0: SENSITIVE_CACHE_TAG_ACCESS_0_REG
	// Position of CACHE_TAG_ACCESS_LOCK field.
	SENSITIVE_CACHE_TAG_ACCESS_0_CACHE_TAG_ACCESS_LOCK_Pos = 0x0
	// Bit mask of CACHE_TAG_ACCESS_LOCK field.
	SENSITIVE_CACHE_TAG_ACCESS_0_CACHE_TAG_ACCESS_LOCK_Msk = 0x1
	// Bit CACHE_TAG_ACCESS_LOCK.
	SENSITIVE_CACHE_TAG_ACCESS_0_CACHE_TAG_ACCESS_LOCK = 0x1

	// CACHE_TAG_ACCESS_1: SENSITIVE_CACHE_TAG_ACCESS_1_REG
	// Position of PRO_I_TAG_RD_ACS field.
	SENSITIVE_CACHE_TAG_ACCESS_1_PRO_I_TAG_RD_ACS_Pos = 0x0
	// Bit mask of PRO_I_TAG_RD_ACS field.
	SENSITIVE_CACHE_TAG_ACCESS_1_PRO_I_TAG_RD_ACS_Msk = 0x1
	// Bit PRO_I_TAG_RD_ACS.
	SENSITIVE_CACHE_TAG_ACCESS_1_PRO_I_TAG_RD_ACS = 0x1
	// Position of PRO_I_TAG_WR_ACS field.
	SENSITIVE_CACHE_TAG_ACCESS_1_PRO_I_TAG_WR_ACS_Pos = 0x1
	// Bit mask of PRO_I_TAG_WR_ACS field.
	SENSITIVE_CACHE_TAG_ACCESS_1_PRO_I_TAG_WR_ACS_Msk = 0x2
	// Bit PRO_I_TAG_WR_ACS.
	SENSITIVE_CACHE_TAG_ACCESS_1_PRO_I_TAG_WR_ACS = 0x2
	// Position of PRO_D_TAG_RD_ACS field.
	SENSITIVE_CACHE_TAG_ACCESS_1_PRO_D_TAG_RD_ACS_Pos = 0x2
	// Bit mask of PRO_D_TAG_RD_ACS field.
	SENSITIVE_CACHE_TAG_ACCESS_1_PRO_D_TAG_RD_ACS_Msk = 0x4
	// Bit PRO_D_TAG_RD_ACS.
	SENSITIVE_CACHE_TAG_ACCESS_1_PRO_D_TAG_RD_ACS = 0x4
	// Position of PRO_D_TAG_WR_ACS field.
	SENSITIVE_CACHE_TAG_ACCESS_1_PRO_D_TAG_WR_ACS_Pos = 0x3
	// Bit mask of PRO_D_TAG_WR_ACS field.
	SENSITIVE_CACHE_TAG_ACCESS_1_PRO_D_TAG_WR_ACS_Msk = 0x8
	// Bit PRO_D_TAG_WR_ACS.
	SENSITIVE_CACHE_TAG_ACCESS_1_PRO_D_TAG_WR_ACS = 0x8

	// CACHE_MMU_ACCESS_0: SENSITIVE_CACHE_MMU_ACCESS_0_REG
	// Position of CACHE_MMU_ACCESS_LOCK field.
	SENSITIVE_CACHE_MMU_ACCESS_0_CACHE_MMU_ACCESS_LOCK_Pos = 0x0
	// Bit mask of CACHE_MMU_ACCESS_LOCK field.
	SENSITIVE_CACHE_MMU_ACCESS_0_CACHE_MMU_ACCESS_LOCK_Msk = 0x1
	// Bit CACHE_MMU_ACCESS_LOCK.
	SENSITIVE_CACHE_MMU_ACCESS_0_CACHE_MMU_ACCESS_LOCK = 0x1

	// CACHE_MMU_ACCESS_1: SENSITIVE_CACHE_MMU_ACCESS_1_REG
	// Position of PRO_MMU_RD_ACS field.
	SENSITIVE_CACHE_MMU_ACCESS_1_PRO_MMU_RD_ACS_Pos = 0x0
	// Bit mask of PRO_MMU_RD_ACS field.
	SENSITIVE_CACHE_MMU_ACCESS_1_PRO_MMU_RD_ACS_Msk = 0x1
	// Bit PRO_MMU_RD_ACS.
	SENSITIVE_CACHE_MMU_ACCESS_1_PRO_MMU_RD_ACS = 0x1
	// Position of PRO_MMU_WR_ACS field.
	SENSITIVE_CACHE_MMU_ACCESS_1_PRO_MMU_WR_ACS_Pos = 0x1
	// Bit mask of PRO_MMU_WR_ACS field.
	SENSITIVE_CACHE_MMU_ACCESS_1_PRO_MMU_WR_ACS_Msk = 0x2
	// Bit PRO_MMU_WR_ACS.
	SENSITIVE_CACHE_MMU_ACCESS_1_PRO_MMU_WR_ACS = 0x2

	// DMA_APBPERI_SPI2_PMS_CONSTRAIN_0: SENSITIVE_DMA_APBPERI_SPI2_PMS_CONSTRAIN_0_REG
	// Position of DMA_APBPERI_SPI2_PMS_CONSTRAIN_LOCK field.
	SENSITIVE_DMA_APBPERI_SPI2_PMS_CONSTRAIN_0_DMA_APBPERI_SPI2_PMS_CONSTRAIN_LOCK_Pos = 0x0
	// Bit mask of DMA_APBPERI_SPI2_PMS_CONSTRAIN_LOCK field.
	SENSITIVE_DMA_APBPERI_SPI2_PMS_CONSTRAIN_0_DMA_APBPERI_SPI2_PMS_CONSTRAIN_LOCK_Msk = 0x1
	// Bit DMA_APBPERI_SPI2_PMS_CONSTRAIN_LOCK.
	SENSITIVE_DMA_APBPERI_SPI2_PMS_CONSTRAIN_0_DMA_APBPERI_SPI2_PMS_CONSTRAIN_LOCK = 0x1

	// DMA_APBPERI_SPI2_PMS_CONSTRAIN_1: SENSITIVE_DMA_APBPERI_SPI2_PMS_CONSTRAIN_1_REG
	// Position of DMA_APBPERI_SPI2_PMS_CONSTRAIN_SRAM_WORLD_0_PMS_0 field.
	SENSITIVE_DMA_APBPERI_SPI2_PMS_CONSTRAIN_1_DMA_APBPERI_SPI2_PMS_CONSTRAIN_SRAM_WORLD_0_PMS_0_Pos = 0x0
	// Bit mask of DMA_APBPERI_SPI2_PMS_CONSTRAIN_SRAM_WORLD_0_PMS_0 field.
	SENSITIVE_DMA_APBPERI_SPI2_PMS_CONSTRAIN_1_DMA_APBPERI_SPI2_PMS_CONSTRAIN_SRAM_WORLD_0_PMS_0_Msk = 0x3
	// Position of DMA_APBPERI_SPI2_PMS_CONSTRAIN_SRAM_WORLD_0_PMS_1 field.
	SENSITIVE_DMA_APBPERI_SPI2_PMS_CONSTRAIN_1_DMA_APBPERI_SPI2_PMS_CONSTRAIN_SRAM_WORLD_0_PMS_1_Pos = 0x2
	// Bit mask of DMA_APBPERI_SPI2_PMS_CONSTRAIN_SRAM_WORLD_0_PMS_1 field.
	SENSITIVE_DMA_APBPERI_SPI2_PMS_CONSTRAIN_1_DMA_APBPERI_SPI2_PMS_CONSTRAIN_SRAM_WORLD_0_PMS_1_Msk = 0xc
	// Position of DMA_APBPERI_SPI2_PMS_CONSTRAIN_SRAM_WORLD_0_PMS_2 field.
	SENSITIVE_DMA_APBPERI_SPI2_PMS_CONSTRAIN_1_DMA_APBPERI_SPI2_PMS_CONSTRAIN_SRAM_WORLD_0_PMS_2_Pos = 0x4
	// Bit mask of DMA_APBPERI_SPI2_PMS_CONSTRAIN_SRAM_WORLD_0_PMS_2 field.
	SENSITIVE_DMA_APBPERI_SPI2_PMS_CONSTRAIN_1_DMA_APBPERI_SPI2_PMS_CONSTRAIN_SRAM_WORLD_0_PMS_2_Msk = 0x30
	// Position of DMA_APBPERI_SPI2_PMS_CONSTRAIN_SRAM_WORLD_0_PMS_3 field.
	SENSITIVE_DMA_APBPERI_SPI2_PMS_CONSTRAIN_1_DMA_APBPERI_SPI2_PMS_CONSTRAIN_SRAM_WORLD_0_PMS_3_Pos = 0x6
	// Bit mask of DMA_APBPERI_SPI2_PMS_CONSTRAIN_SRAM_WORLD_0_PMS_3 field.
	SENSITIVE_DMA_APBPERI_SPI2_PMS_CONSTRAIN_1_DMA_APBPERI_SPI2_PMS_CONSTRAIN_SRAM_WORLD_0_PMS_3_Msk = 0xc0
	// Position of DMA_APBPERI_SPI2_PMS_CONSTRAIN_SRAM_WORLD_1_PMS_0 field.
	SENSITIVE_DMA_APBPERI_SPI2_PMS_CONSTRAIN_1_DMA_APBPERI_SPI2_PMS_CONSTRAIN_SRAM_WORLD_1_PMS_0_Pos = 0xc
	// Bit mask of DMA_APBPERI_SPI2_PMS_CONSTRAIN_SRAM_WORLD_1_PMS_0 field.
	SENSITIVE_DMA_APBPERI_SPI2_PMS_CONSTRAIN_1_DMA_APBPERI_SPI2_PMS_CONSTRAIN_SRAM_WORLD_1_PMS_0_Msk = 0x3000
	// Position of DMA_APBPERI_SPI2_PMS_CONSTRAIN_SRAM_WORLD_1_PMS_1 field.
	SENSITIVE_DMA_APBPERI_SPI2_PMS_CONSTRAIN_1_DMA_APBPERI_SPI2_PMS_CONSTRAIN_SRAM_WORLD_1_PMS_1_Pos = 0xe
	// Bit mask of DMA_APBPERI_SPI2_PMS_CONSTRAIN_SRAM_WORLD_1_PMS_1 field.
	SENSITIVE_DMA_APBPERI_SPI2_PMS_CONSTRAIN_1_DMA_APBPERI_SPI2_PMS_CONSTRAIN_SRAM_WORLD_1_PMS_1_Msk = 0xc000
	// Position of DMA_APBPERI_SPI2_PMS_CONSTRAIN_SRAM_WORLD_1_PMS_2 field.
	SENSITIVE_DMA_APBPERI_SPI2_PMS_CONSTRAIN_1_DMA_APBPERI_SPI2_PMS_CONSTRAIN_SRAM_WORLD_1_PMS_2_Pos = 0x10
	// Bit mask of DMA_APBPERI_SPI2_PMS_CONSTRAIN_SRAM_WORLD_1_PMS_2 field.
	SENSITIVE_DMA_APBPERI_SPI2_PMS_CONSTRAIN_1_DMA_APBPERI_SPI2_PMS_CONSTRAIN_SRAM_WORLD_1_PMS_2_Msk = 0x30000
	// Position of DMA_APBPERI_SPI2_PMS_CONSTRAIN_SRAM_WORLD_1_PMS_3 field.
	SENSITIVE_DMA_APBPERI_SPI2_PMS_CONSTRAIN_1_DMA_APBPERI_SPI2_PMS_CONSTRAIN_SRAM_WORLD_1_PMS_3_Pos = 0x12
	// Bit mask of DMA_APBPERI_SPI2_PMS_CONSTRAIN_SRAM_WORLD_1_PMS_3 field.
	SENSITIVE_DMA_APBPERI_SPI2_PMS_CONSTRAIN_1_DMA_APBPERI_SPI2_PMS_CONSTRAIN_SRAM_WORLD_1_PMS_3_Msk = 0xc0000

	// DMA_APBPERI_UCHI0_PMS_CONSTRAIN_0: SENSITIVE_DMA_APBPERI_UCHI0_PMS_CONSTRAIN_0_REG
	// Position of DMA_APBPERI_UCHI0_PMS_CONSTRAIN_LOCK field.
	SENSITIVE_DMA_APBPERI_UCHI0_PMS_CONSTRAIN_0_DMA_APBPERI_UCHI0_PMS_CONSTRAIN_LOCK_Pos = 0x0
	// Bit mask of DMA_APBPERI_UCHI0_PMS_CONSTRAIN_LOCK field.
	SENSITIVE_DMA_APBPERI_UCHI0_PMS_CONSTRAIN_0_DMA_APBPERI_UCHI0_PMS_CONSTRAIN_LOCK_Msk = 0x1
	// Bit DMA_APBPERI_UCHI0_PMS_CONSTRAIN_LOCK.
	SENSITIVE_DMA_APBPERI_UCHI0_PMS_CONSTRAIN_0_DMA_APBPERI_UCHI0_PMS_CONSTRAIN_LOCK = 0x1

	// DMA_APBPERI_UCHI0_PMS_CONSTRAIN_1: SENSITIVE_DMA_APBPERI_UCHI0_PMS_CONSTRAIN_1_REG
	// Position of DMA_APBPERI_UCHI0_PMS_CONSTRAIN_SRAM_WORLD_0_PMS_0 field.
	SENSITIVE_DMA_APBPERI_UCHI0_PMS_CONSTRAIN_1_DMA_APBPERI_UCHI0_PMS_CONSTRAIN_SRAM_WORLD_0_PMS_0_Pos = 0x0
	// Bit mask of DMA_APBPERI_UCHI0_PMS_CONSTRAIN_SRAM_WORLD_0_PMS_0 field.
	SENSITIVE_DMA_APBPERI_UCHI0_PMS_CONSTRAIN_1_DMA_APBPERI_UCHI0_PMS_CONSTRAIN_SRAM_WORLD_0_PMS_0_Msk = 0x3
	// Position of DMA_APBPERI_UCHI0_PMS_CONSTRAIN_SRAM_WORLD_0_PMS_1 field.
	SENSITIVE_DMA_APBPERI_UCHI0_PMS_CONSTRAIN_1_DMA_APBPERI_UCHI0_PMS_CONSTRAIN_SRAM_WORLD_0_PMS_1_Pos = 0x2
	// Bit mask of DMA_APBPERI_UCHI0_PMS_CONSTRAIN_SRAM_WORLD_0_PMS_1 field.
	SENSITIVE_DMA_APBPERI_UCHI0_PMS_CONSTRAIN_1_DMA_APBPERI_UCHI0_PMS_CONSTRAIN_SRAM_WORLD_0_PMS_1_Msk = 0xc
	// Position of DMA_APBPERI_UCHI0_PMS_CONSTRAIN_SRAM_WORLD_0_PMS_2 field.
	SENSITIVE_DMA_APBPERI_UCHI0_PMS_CONSTRAIN_1_DMA_APBPERI_UCHI0_PMS_CONSTRAIN_SRAM_WORLD_0_PMS_2_Pos = 0x4
	// Bit mask of DMA_APBPERI_UCHI0_PMS_CONSTRAIN_SRAM_WORLD_0_PMS_2 field.
	SENSITIVE_DMA_APBPERI_UCHI0_PMS_CONSTRAIN_1_DMA_APBPERI_UCHI0_PMS_CONSTRAIN_SRAM_WORLD_0_PMS_2_Msk = 0x30
	// Position of DMA_APBPERI_UCHI0_PMS_CONSTRAIN_SRAM_WORLD_0_PMS_3 field.
	SENSITIVE_DMA_APBPERI_UCHI0_PMS_CONSTRAIN_1_DMA_APBPERI_UCHI0_PMS_CONSTRAIN_SRAM_WORLD_0_PMS_3_Pos = 0x6
	// Bit mask of DMA_APBPERI_UCHI0_PMS_CONSTRAIN_SRAM_WORLD_0_PMS_3 field.
	SENSITIVE_DMA_APBPERI_UCHI0_PMS_CONSTRAIN_1_DMA_APBPERI_UCHI0_PMS_CONSTRAIN_SRAM_WORLD_0_PMS_3_Msk = 0xc0
	// Position of DMA_APBPERI_UCHI0_PMS_CONSTRAIN_SRAM_WORLD_1_PMS_0 field.
	SENSITIVE_DMA_APBPERI_UCHI0_PMS_CONSTRAIN_1_DMA_APBPERI_UCHI0_PMS_CONSTRAIN_SRAM_WORLD_1_PMS_0_Pos = 0xc
	// Bit mask of DMA_APBPERI_UCHI0_PMS_CONSTRAIN_SRAM_WORLD_1_PMS_0 field.
	SENSITIVE_DMA_APBPERI_UCHI0_PMS_CONSTRAIN_1_DMA_APBPERI_UCHI0_PMS_CONSTRAIN_SRAM_WORLD_1_PMS_0_Msk = 0x3000
	// Position of DMA_APBPERI_UCHI0_PMS_CONSTRAIN_SRAM_WORLD_1_PMS_1 field.
	SENSITIVE_DMA_APBPERI_UCHI0_PMS_CONSTRAIN_1_DMA_APBPERI_UCHI0_PMS_CONSTRAIN_SRAM_WORLD_1_PMS_1_Pos = 0xe
	// Bit mask of DMA_APBPERI_UCHI0_PMS_CONSTRAIN_SRAM_WORLD_1_PMS_1 field.
	SENSITIVE_DMA_APBPERI_UCHI0_PMS_CONSTRAIN_1_DMA_APBPERI_UCHI0_PMS_CONSTRAIN_SRAM_WORLD_1_PMS_1_Msk = 0xc000
	// Position of DMA_APBPERI_UCHI0_PMS_CONSTRAIN_SRAM_WORLD_1_PMS_2 field.
	SENSITIVE_DMA_APBPERI_UCHI0_PMS_CONSTRAIN_1_DMA_APBPERI_UCHI0_PMS_CONSTRAIN_SRAM_WORLD_1_PMS_2_Pos = 0x10
	// Bit mask of DMA_APBPERI_UCHI0_PMS_CONSTRAIN_SRAM_WORLD_1_PMS_2 field.
	SENSITIVE_DMA_APBPERI_UCHI0_PMS_CONSTRAIN_1_DMA_APBPERI_UCHI0_PMS_CONSTRAIN_SRAM_WORLD_1_PMS_2_Msk = 0x30000
	// Position of DMA_APBPERI_UCHI0_PMS_CONSTRAIN_SRAM_WORLD_1_PMS_3 field.
	SENSITIVE_DMA_APBPERI_UCHI0_PMS_CONSTRAIN_1_DMA_APBPERI_UCHI0_PMS_CONSTRAIN_SRAM_WORLD_1_PMS_3_Pos = 0x12
	// Bit mask of DMA_APBPERI_UCHI0_PMS_CONSTRAIN_SRAM_WORLD_1_PMS_3 field.
	SENSITIVE_DMA_APBPERI_UCHI0_PMS_CONSTRAIN_1_DMA_APBPERI_UCHI0_PMS_CONSTRAIN_SRAM_WORLD_1_PMS_3_Msk = 0xc0000

	// DMA_APBPERI_I2S0_PMS_CONSTRAIN_0: SENSITIVE_DMA_APBPERI_I2S0_PMS_CONSTRAIN_0_REG
	// Position of DMA_APBPERI_I2S0_PMS_CONSTRAIN_LOCK field.
	SENSITIVE_DMA_APBPERI_I2S0_PMS_CONSTRAIN_0_DMA_APBPERI_I2S0_PMS_CONSTRAIN_LOCK_Pos = 0x0
	// Bit mask of DMA_APBPERI_I2S0_PMS_CONSTRAIN_LOCK field.
	SENSITIVE_DMA_APBPERI_I2S0_PMS_CONSTRAIN_0_DMA_APBPERI_I2S0_PMS_CONSTRAIN_LOCK_Msk = 0x1
	// Bit DMA_APBPERI_I2S0_PMS_CONSTRAIN_LOCK.
	SENSITIVE_DMA_APBPERI_I2S0_PMS_CONSTRAIN_0_DMA_APBPERI_I2S0_PMS_CONSTRAIN_LOCK = 0x1

	// DMA_APBPERI_I2S0_PMS_CONSTRAIN_1: SENSITIVE_DMA_APBPERI_I2S0_PMS_CONSTRAIN_1_REG
	// Position of DMA_APBPERI_I2S0_PMS_CONSTRAIN_SRAM_WORLD_0_PMS_0 field.
	SENSITIVE_DMA_APBPERI_I2S0_PMS_CONSTRAIN_1_DMA_APBPERI_I2S0_PMS_CONSTRAIN_SRAM_WORLD_0_PMS_0_Pos = 0x0
	// Bit mask of DMA_APBPERI_I2S0_PMS_CONSTRAIN_SRAM_WORLD_0_PMS_0 field.
	SENSITIVE_DMA_APBPERI_I2S0_PMS_CONSTRAIN_1_DMA_APBPERI_I2S0_PMS_CONSTRAIN_SRAM_WORLD_0_PMS_0_Msk = 0x3
	// Position of DMA_APBPERI_I2S0_PMS_CONSTRAIN_SRAM_WORLD_0_PMS_1 field.
	SENSITIVE_DMA_APBPERI_I2S0_PMS_CONSTRAIN_1_DMA_APBPERI_I2S0_PMS_CONSTRAIN_SRAM_WORLD_0_PMS_1_Pos = 0x2
	// Bit mask of DMA_APBPERI_I2S0_PMS_CONSTRAIN_SRAM_WORLD_0_PMS_1 field.
	SENSITIVE_DMA_APBPERI_I2S0_PMS_CONSTRAIN_1_DMA_APBPERI_I2S0_PMS_CONSTRAIN_SRAM_WORLD_0_PMS_1_Msk = 0xc
	// Position of DMA_APBPERI_I2S0_PMS_CONSTRAIN_SRAM_WORLD_0_PMS_2 field.
	SENSITIVE_DMA_APBPERI_I2S0_PMS_CONSTRAIN_1_DMA_APBPERI_I2S0_PMS_CONSTRAIN_SRAM_WORLD_0_PMS_2_Pos = 0x4
	// Bit mask of DMA_APBPERI_I2S0_PMS_CONSTRAIN_SRAM_WORLD_0_PMS_2 field.
	SENSITIVE_DMA_APBPERI_I2S0_PMS_CONSTRAIN_1_DMA_APBPERI_I2S0_PMS_CONSTRAIN_SRAM_WORLD_0_PMS_2_Msk = 0x30
	// Position of DMA_APBPERI_I2S0_PMS_CONSTRAIN_SRAM_WORLD_0_PMS_3 field.
	SENSITIVE_DMA_APBPERI_I2S0_PMS_CONSTRAIN_1_DMA_APBPERI_I2S0_PMS_CONSTRAIN_SRAM_WORLD_0_PMS_3_Pos = 0x6
	// Bit mask of DMA_APBPERI_I2S0_PMS_CONSTRAIN_SRAM_WORLD_0_PMS_3 field.
	SENSITIVE_DMA_APBPERI_I2S0_PMS_CONSTRAIN_1_DMA_APBPERI_I2S0_PMS_CONSTRAIN_SRAM_WORLD_0_PMS_3_Msk = 0xc0
	// Position of DMA_APBPERI_I2S0_PMS_CONSTRAIN_SRAM_WORLD_1_PMS_0 field.
	SENSITIVE_DMA_APBPERI_I2S0_PMS_CONSTRAIN_1_DMA_APBPERI_I2S0_PMS_CONSTRAIN_SRAM_WORLD_1_PMS_0_Pos = 0xc
	// Bit mask of DMA_APBPERI_I2S0_PMS_CONSTRAIN_SRAM_WORLD_1_PMS_0 field.
	SENSITIVE_DMA_APBPERI_I2S0_PMS_CONSTRAIN_1_DMA_APBPERI_I2S0_PMS_CONSTRAIN_SRAM_WORLD_1_PMS_0_Msk = 0x3000
	// Position of DMA_APBPERI_I2S0_PMS_CONSTRAIN_SRAM_WORLD_1_PMS_1 field.
	SENSITIVE_DMA_APBPERI_I2S0_PMS_CONSTRAIN_1_DMA_APBPERI_I2S0_PMS_CONSTRAIN_SRAM_WORLD_1_PMS_1_Pos = 0xe
	// Bit mask of DMA_APBPERI_I2S0_PMS_CONSTRAIN_SRAM_WORLD_1_PMS_1 field.
	SENSITIVE_DMA_APBPERI_I2S0_PMS_CONSTRAIN_1_DMA_APBPERI_I2S0_PMS_CONSTRAIN_SRAM_WORLD_1_PMS_1_Msk = 0xc000
	// Position of DMA_APBPERI_I2S0_PMS_CONSTRAIN_SRAM_WORLD_1_PMS_2 field.
	SENSITIVE_DMA_APBPERI_I2S0_PMS_CONSTRAIN_1_DMA_APBPERI_I2S0_PMS_CONSTRAIN_SRAM_WORLD_1_PMS_2_Pos = 0x10
	// Bit mask of DMA_APBPERI_I2S0_PMS_CONSTRAIN_SRAM_WORLD_1_PMS_2 field.
	SENSITIVE_DMA_APBPERI_I2S0_PMS_CONSTRAIN_1_DMA_APBPERI_I2S0_PMS_CONSTRAIN_SRAM_WORLD_1_PMS_2_Msk = 0x30000
	// Position of DMA_APBPERI_I2S0_PMS_CONSTRAIN_SRAM_WORLD_1_PMS_3 field.
	SENSITIVE_DMA_APBPERI_I2S0_PMS_CONSTRAIN_1_DMA_APBPERI_I2S0_PMS_CONSTRAIN_SRAM_WORLD_1_PMS_3_Pos = 0x12
	// Bit mask of DMA_APBPERI_I2S0_PMS_CONSTRAIN_SRAM_WORLD_1_PMS_3 field.
	SENSITIVE_DMA_APBPERI_I2S0_PMS_CONSTRAIN_1_DMA_APBPERI_I2S0_PMS_CONSTRAIN_SRAM_WORLD_1_PMS_3_Msk = 0xc0000

	// DMA_APBPERI_MAC_PMS_CONSTRAIN_0: SENSITIVE_DMA_APBPERI_MAC_PMS_CONSTRAIN_0_REG
	// Position of DMA_APBPERI_MAC_PMS_CONSTRAIN_LOCK field.
	SENSITIVE_DMA_APBPERI_MAC_PMS_CONSTRAIN_0_DMA_APBPERI_MAC_PMS_CONSTRAIN_LOCK_Pos = 0x0
	// Bit mask of DMA_APBPERI_MAC_PMS_CONSTRAIN_LOCK field.
	SENSITIVE_DMA_APBPERI_MAC_PMS_CONSTRAIN_0_DMA_APBPERI_MAC_PMS_CONSTRAIN_LOCK_Msk = 0x1
	// Bit DMA_APBPERI_MAC_PMS_CONSTRAIN_LOCK.
	SENSITIVE_DMA_APBPERI_MAC_PMS_CONSTRAIN_0_DMA_APBPERI_MAC_PMS_CONSTRAIN_LOCK = 0x1

	// DMA_APBPERI_MAC_PMS_CONSTRAIN_1: SENSITIVE_DMA_APBPERI_MAC_PMS_CONSTRAIN_1_REG
	// Position of DMA_APBPERI_MAC_PMS_CONSTRAIN_SRAM_WORLD_0_PMS_0 field.
	SENSITIVE_DMA_APBPERI_MAC_PMS_CONSTRAIN_1_DMA_APBPERI_MAC_PMS_CONSTRAIN_SRAM_WORLD_0_PMS_0_Pos = 0x0
	// Bit mask of DMA_APBPERI_MAC_PMS_CONSTRAIN_SRAM_WORLD_0_PMS_0 field.
	SENSITIVE_DMA_APBPERI_MAC_PMS_CONSTRAIN_1_DMA_APBPERI_MAC_PMS_CONSTRAIN_SRAM_WORLD_0_PMS_0_Msk = 0x3
	// Position of DMA_APBPERI_MAC_PMS_CONSTRAIN_SRAM_WORLD_0_PMS_1 field.
	SENSITIVE_DMA_APBPERI_MAC_PMS_CONSTRAIN_1_DMA_APBPERI_MAC_PMS_CONSTRAIN_SRAM_WORLD_0_PMS_1_Pos = 0x2
	// Bit mask of DMA_APBPERI_MAC_PMS_CONSTRAIN_SRAM_WORLD_0_PMS_1 field.
	SENSITIVE_DMA_APBPERI_MAC_PMS_CONSTRAIN_1_DMA_APBPERI_MAC_PMS_CONSTRAIN_SRAM_WORLD_0_PMS_1_Msk = 0xc
	// Position of DMA_APBPERI_MAC_PMS_CONSTRAIN_SRAM_WORLD_0_PMS_2 field.
	SENSITIVE_DMA_APBPERI_MAC_PMS_CONSTRAIN_1_DMA_APBPERI_MAC_PMS_CONSTRAIN_SRAM_WORLD_0_PMS_2_Pos = 0x4
	// Bit mask of DMA_APBPERI_MAC_PMS_CONSTRAIN_SRAM_WORLD_0_PMS_2 field.
	SENSITIVE_DMA_APBPERI_MAC_PMS_CONSTRAIN_1_DMA_APBPERI_MAC_PMS_CONSTRAIN_SRAM_WORLD_0_PMS_2_Msk = 0x30
	// Position of DMA_APBPERI_MAC_PMS_CONSTRAIN_SRAM_WORLD_0_PMS_3 field.
	SENSITIVE_DMA_APBPERI_MAC_PMS_CONSTRAIN_1_DMA_APBPERI_MAC_PMS_CONSTRAIN_SRAM_WORLD_0_PMS_3_Pos = 0x6
	// Bit mask of DMA_APBPERI_MAC_PMS_CONSTRAIN_SRAM_WORLD_0_PMS_3 field.
	SENSITIVE_DMA_APBPERI_MAC_PMS_CONSTRAIN_1_DMA_APBPERI_MAC_PMS_CONSTRAIN_SRAM_WORLD_0_PMS_3_Msk = 0xc0
	// Position of DMA_APBPERI_MAC_PMS_CONSTRAIN_SRAM_WORLD_1_PMS_0 field.
	SENSITIVE_DMA_APBPERI_MAC_PMS_CONSTRAIN_1_DMA_APBPERI_MAC_PMS_CONSTRAIN_SRAM_WORLD_1_PMS_0_Pos = 0xc
	// Bit mask of DMA_APBPERI_MAC_PMS_CONSTRAIN_SRAM_WORLD_1_PMS_0 field.
	SENSITIVE_DMA_APBPERI_MAC_PMS_CONSTRAIN_1_DMA_APBPERI_MAC_PMS_CONSTRAIN_SRAM_WORLD_1_PMS_0_Msk = 0x3000
	// Position of DMA_APBPERI_MAC_PMS_CONSTRAIN_SRAM_WORLD_1_PMS_1 field.
	SENSITIVE_DMA_APBPERI_MAC_PMS_CONSTRAIN_1_DMA_APBPERI_MAC_PMS_CONSTRAIN_SRAM_WORLD_1_PMS_1_Pos = 0xe
	// Bit mask of DMA_APBPERI_MAC_PMS_CONSTRAIN_SRAM_WORLD_1_PMS_1 field.
	SENSITIVE_DMA_APBPERI_MAC_PMS_CONSTRAIN_1_DMA_APBPERI_MAC_PMS_CONSTRAIN_SRAM_WORLD_1_PMS_1_Msk = 0xc000
	// Position of DMA_APBPERI_MAC_PMS_CONSTRAIN_SRAM_WORLD_1_PMS_2 field.
	SENSITIVE_DMA_APBPERI_MAC_PMS_CONSTRAIN_1_DMA_APBPERI_MAC_PMS_CONSTRAIN_SRAM_WORLD_1_PMS_2_Pos = 0x10
	// Bit mask of DMA_APBPERI_MAC_PMS_CONSTRAIN_SRAM_WORLD_1_PMS_2 field.
	SENSITIVE_DMA_APBPERI_MAC_PMS_CONSTRAIN_1_DMA_APBPERI_MAC_PMS_CONSTRAIN_SRAM_WORLD_1_PMS_2_Msk = 0x30000
	// Position of DMA_APBPERI_MAC_PMS_CONSTRAIN_SRAM_WORLD_1_PMS_3 field.
	SENSITIVE_DMA_APBPERI_MAC_PMS_CONSTRAIN_1_DMA_APBPERI_MAC_PMS_CONSTRAIN_SRAM_WORLD_1_PMS_3_Pos = 0x12
	// Bit mask of DMA_APBPERI_MAC_PMS_CONSTRAIN_SRAM_WORLD_1_PMS_3 field.
	SENSITIVE_DMA_APBPERI_MAC_PMS_CONSTRAIN_1_DMA_APBPERI_MAC_PMS_CONSTRAIN_SRAM_WORLD_1_PMS_3_Msk = 0xc0000

	// DMA_APBPERI_BACKUP_PMS_CONSTRAIN_0: SENSITIVE_DMA_APBPERI_BACKUP_PMS_CONSTRAIN_0_REG
	// Position of DMA_APBPERI_BACKUP_PMS_CONSTRAIN_LOCK field.
	SENSITIVE_DMA_APBPERI_BACKUP_PMS_CONSTRAIN_0_DMA_APBPERI_BACKUP_PMS_CONSTRAIN_LOCK_Pos = 0x0
	// Bit mask of DMA_APBPERI_BACKUP_PMS_CONSTRAIN_LOCK field.
	SENSITIVE_DMA_APBPERI_BACKUP_PMS_CONSTRAIN_0_DMA_APBPERI_BACKUP_PMS_CONSTRAIN_LOCK_Msk = 0x1
	// Bit DMA_APBPERI_BACKUP_PMS_CONSTRAIN_LOCK.
	SENSITIVE_DMA_APBPERI_BACKUP_PMS_CONSTRAIN_0_DMA_APBPERI_BACKUP_PMS_CONSTRAIN_LOCK = 0x1

	// DMA_APBPERI_BACKUP_PMS_CONSTRAIN_1: SENSITIVE_DMA_APBPERI_BACKUP_PMS_CONSTRAIN_1_REG
	// Position of DMA_APBPERI_BACKUP_PMS_CONSTRAIN_SRAM_WORLD_0_PMS_0 field.
	SENSITIVE_DMA_APBPERI_BACKUP_PMS_CONSTRAIN_1_DMA_APBPERI_BACKUP_PMS_CONSTRAIN_SRAM_WORLD_0_PMS_0_Pos = 0x0
	// Bit mask of DMA_APBPERI_BACKUP_PMS_CONSTRAIN_SRAM_WORLD_0_PMS_0 field.
	SENSITIVE_DMA_APBPERI_BACKUP_PMS_CONSTRAIN_1_DMA_APBPERI_BACKUP_PMS_CONSTRAIN_SRAM_WORLD_0_PMS_0_Msk = 0x3
	// Position of DMA_APBPERI_BACKUP_PMS_CONSTRAIN_SRAM_WORLD_0_PMS_1 field.
	SENSITIVE_DMA_APBPERI_BACKUP_PMS_CONSTRAIN_1_DMA_APBPERI_BACKUP_PMS_CONSTRAIN_SRAM_WORLD_0_PMS_1_Pos = 0x2
	// Bit mask of DMA_APBPERI_BACKUP_PMS_CONSTRAIN_SRAM_WORLD_0_PMS_1 field.
	SENSITIVE_DMA_APBPERI_BACKUP_PMS_CONSTRAIN_1_DMA_APBPERI_BACKUP_PMS_CONSTRAIN_SRAM_WORLD_0_PMS_1_Msk = 0xc
	// Position of DMA_APBPERI_BACKUP_PMS_CONSTRAIN_SRAM_WORLD_0_PMS_2 field.
	SENSITIVE_DMA_APBPERI_BACKUP_PMS_CONSTRAIN_1_DMA_APBPERI_BACKUP_PMS_CONSTRAIN_SRAM_WORLD_0_PMS_2_Pos = 0x4
	// Bit mask of DMA_APBPERI_BACKUP_PMS_CONSTRAIN_SRAM_WORLD_0_PMS_2 field.
	SENSITIVE_DMA_APBPERI_BACKUP_PMS_CONSTRAIN_1_DMA_APBPERI_BACKUP_PMS_CONSTRAIN_SRAM_WORLD_0_PMS_2_Msk = 0x30
	// Position of DMA_APBPERI_BACKUP_PMS_CONSTRAIN_SRAM_WORLD_0_PMS_3 field.
	SENSITIVE_DMA_APBPERI_BACKUP_PMS_CONSTRAIN_1_DMA_APBPERI_BACKUP_PMS_CONSTRAIN_SRAM_WORLD_0_PMS_3_Pos = 0x6
	// Bit mask of DMA_APBPERI_BACKUP_PMS_CONSTRAIN_SRAM_WORLD_0_PMS_3 field.
	SENSITIVE_DMA_APBPERI_BACKUP_PMS_CONSTRAIN_1_DMA_APBPERI_BACKUP_PMS_CONSTRAIN_SRAM_WORLD_0_PMS_3_Msk = 0xc0
	// Position of DMA_APBPERI_BACKUP_PMS_CONSTRAIN_SRAM_WORLD_1_PMS_0 field.
	SENSITIVE_DMA_APBPERI_BACKUP_PMS_CONSTRAIN_1_DMA_APBPERI_BACKUP_PMS_CONSTRAIN_SRAM_WORLD_1_PMS_0_Pos = 0xc
	// Bit mask of DMA_APBPERI_BACKUP_PMS_CONSTRAIN_SRAM_WORLD_1_PMS_0 field.
	SENSITIVE_DMA_APBPERI_BACKUP_PMS_CONSTRAIN_1_DMA_APBPERI_BACKUP_PMS_CONSTRAIN_SRAM_WORLD_1_PMS_0_Msk = 0x3000
	// Position of DMA_APBPERI_BACKUP_PMS_CONSTRAIN_SRAM_WORLD_1_PMS_1 field.
	SENSITIVE_DMA_APBPERI_BACKUP_PMS_CONSTRAIN_1_DMA_APBPERI_BACKUP_PMS_CONSTRAIN_SRAM_WORLD_1_PMS_1_Pos = 0xe
	// Bit mask of DMA_APBPERI_BACKUP_PMS_CONSTRAIN_SRAM_WORLD_1_PMS_1 field.
	SENSITIVE_DMA_APBPERI_BACKUP_PMS_CONSTRAIN_1_DMA_APBPERI_BACKUP_PMS_CONSTRAIN_SRAM_WORLD_1_PMS_1_Msk = 0xc000
	// Position of DMA_APBPERI_BACKUP_PMS_CONSTRAIN_SRAM_WORLD_1_PMS_2 field.
	SENSITIVE_DMA_APBPERI_BACKUP_PMS_CONSTRAIN_1_DMA_APBPERI_BACKUP_PMS_CONSTRAIN_SRAM_WORLD_1_PMS_2_Pos = 0x10
	// Bit mask of DMA_APBPERI_BACKUP_PMS_CONSTRAIN_SRAM_WORLD_1_PMS_2 field.
	SENSITIVE_DMA_APBPERI_BACKUP_PMS_CONSTRAIN_1_DMA_APBPERI_BACKUP_PMS_CONSTRAIN_SRAM_WORLD_1_PMS_2_Msk = 0x30000
	// Position of DMA_APBPERI_BACKUP_PMS_CONSTRAIN_SRAM_WORLD_1_PMS_3 field.
	SENSITIVE_DMA_APBPERI_BACKUP_PMS_CONSTRAIN_1_DMA_APBPERI_BACKUP_PMS_CONSTRAIN_SRAM_WORLD_1_PMS_3_Pos = 0x12
	// Bit mask of DMA_APBPERI_BACKUP_PMS_CONSTRAIN_SRAM_WORLD_1_PMS_3 field.
	SENSITIVE_DMA_APBPERI_BACKUP_PMS_CONSTRAIN_1_DMA_APBPERI_BACKUP_PMS_CONSTRAIN_SRAM_WORLD_1_PMS_3_Msk = 0xc0000

	// DMA_APBPERI_LC_PMS_CONSTRAIN_0: SENSITIVE_DMA_APBPERI_LC_PMS_CONSTRAIN_0_REG
	// Position of DMA_APBPERI_LC_PMS_CONSTRAIN_LOCK field.
	SENSITIVE_DMA_APBPERI_LC_PMS_CONSTRAIN_0_DMA_APBPERI_LC_PMS_CONSTRAIN_LOCK_Pos = 0x0
	// Bit mask of DMA_APBPERI_LC_PMS_CONSTRAIN_LOCK field.
	SENSITIVE_DMA_APBPERI_LC_PMS_CONSTRAIN_0_DMA_APBPERI_LC_PMS_CONSTRAIN_LOCK_Msk = 0x1
	// Bit DMA_APBPERI_LC_PMS_CONSTRAIN_LOCK.
	SENSITIVE_DMA_APBPERI_LC_PMS_CONSTRAIN_0_DMA_APBPERI_LC_PMS_CONSTRAIN_LOCK = 0x1

	// DMA_APBPERI_LC_PMS_CONSTRAIN_1: SENSITIVE_DMA_APBPERI_LC_PMS_CONSTRAIN_1_REG
	// Position of DMA_APBPERI_LC_PMS_CONSTRAIN_SRAM_WORLD_0_PMS_0 field.
	SENSITIVE_DMA_APBPERI_LC_PMS_CONSTRAIN_1_DMA_APBPERI_LC_PMS_CONSTRAIN_SRAM_WORLD_0_PMS_0_Pos = 0x0
	// Bit mask of DMA_APBPERI_LC_PMS_CONSTRAIN_SRAM_WORLD_0_PMS_0 field.
	SENSITIVE_DMA_APBPERI_LC_PMS_CONSTRAIN_1_DMA_APBPERI_LC_PMS_CONSTRAIN_SRAM_WORLD_0_PMS_0_Msk = 0x3
	// Position of DMA_APBPERI_LC_PMS_CONSTRAIN_SRAM_WORLD_0_PMS_1 field.
	SENSITIVE_DMA_APBPERI_LC_PMS_CONSTRAIN_1_DMA_APBPERI_LC_PMS_CONSTRAIN_SRAM_WORLD_0_PMS_1_Pos = 0x2
	// Bit mask of DMA_APBPERI_LC_PMS_CONSTRAIN_SRAM_WORLD_0_PMS_1 field.
	SENSITIVE_DMA_APBPERI_LC_PMS_CONSTRAIN_1_DMA_APBPERI_LC_PMS_CONSTRAIN_SRAM_WORLD_0_PMS_1_Msk = 0xc
	// Position of DMA_APBPERI_LC_PMS_CONSTRAIN_SRAM_WORLD_0_PMS_2 field.
	SENSITIVE_DMA_APBPERI_LC_PMS_CONSTRAIN_1_DMA_APBPERI_LC_PMS_CONSTRAIN_SRAM_WORLD_0_PMS_2_Pos = 0x4
	// Bit mask of DMA_APBPERI_LC_PMS_CONSTRAIN_SRAM_WORLD_0_PMS_2 field.
	SENSITIVE_DMA_APBPERI_LC_PMS_CONSTRAIN_1_DMA_APBPERI_LC_PMS_CONSTRAIN_SRAM_WORLD_0_PMS_2_Msk = 0x30
	// Position of DMA_APBPERI_LC_PMS_CONSTRAIN_SRAM_WORLD_0_PMS_3 field.
	SENSITIVE_DMA_APBPERI_LC_PMS_CONSTRAIN_1_DMA_APBPERI_LC_PMS_CONSTRAIN_SRAM_WORLD_0_PMS_3_Pos = 0x6
	// Bit mask of DMA_APBPERI_LC_PMS_CONSTRAIN_SRAM_WORLD_0_PMS_3 field.
	SENSITIVE_DMA_APBPERI_LC_PMS_CONSTRAIN_1_DMA_APBPERI_LC_PMS_CONSTRAIN_SRAM_WORLD_0_PMS_3_Msk = 0xc0
	// Position of DMA_APBPERI_LC_PMS_CONSTRAIN_SRAM_WORLD_1_PMS_0 field.
	SENSITIVE_DMA_APBPERI_LC_PMS_CONSTRAIN_1_DMA_APBPERI_LC_PMS_CONSTRAIN_SRAM_WORLD_1_PMS_0_Pos = 0xc
	// Bit mask of DMA_APBPERI_LC_PMS_CONSTRAIN_SRAM_WORLD_1_PMS_0 field.
	SENSITIVE_DMA_APBPERI_LC_PMS_CONSTRAIN_1_DMA_APBPERI_LC_PMS_CONSTRAIN_SRAM_WORLD_1_PMS_0_Msk = 0x3000
	// Position of DMA_APBPERI_LC_PMS_CONSTRAIN_SRAM_WORLD_1_PMS_1 field.
	SENSITIVE_DMA_APBPERI_LC_PMS_CONSTRAIN_1_DMA_APBPERI_LC_PMS_CONSTRAIN_SRAM_WORLD_1_PMS_1_Pos = 0xe
	// Bit mask of DMA_APBPERI_LC_PMS_CONSTRAIN_SRAM_WORLD_1_PMS_1 field.
	SENSITIVE_DMA_APBPERI_LC_PMS_CONSTRAIN_1_DMA_APBPERI_LC_PMS_CONSTRAIN_SRAM_WORLD_1_PMS_1_Msk = 0xc000
	// Position of DMA_APBPERI_LC_PMS_CONSTRAIN_SRAM_WORLD_1_PMS_2 field.
	SENSITIVE_DMA_APBPERI_LC_PMS_CONSTRAIN_1_DMA_APBPERI_LC_PMS_CONSTRAIN_SRAM_WORLD_1_PMS_2_Pos = 0x10
	// Bit mask of DMA_APBPERI_LC_PMS_CONSTRAIN_SRAM_WORLD_1_PMS_2 field.
	SENSITIVE_DMA_APBPERI_LC_PMS_CONSTRAIN_1_DMA_APBPERI_LC_PMS_CONSTRAIN_SRAM_WORLD_1_PMS_2_Msk = 0x30000
	// Position of DMA_APBPERI_LC_PMS_CONSTRAIN_SRAM_WORLD_1_PMS_3 field.
	SENSITIVE_DMA_APBPERI_LC_PMS_CONSTRAIN_1_DMA_APBPERI_LC_PMS_CONSTRAIN_SRAM_WORLD_1_PMS_3_Pos = 0x12
	// Bit mask of DMA_APBPERI_LC_PMS_CONSTRAIN_SRAM_WORLD_1_PMS_3 field.
	SENSITIVE_DMA_APBPERI_LC_PMS_CONSTRAIN_1_DMA_APBPERI_LC_PMS_CONSTRAIN_SRAM_WORLD_1_PMS_3_Msk = 0xc0000

	// DMA_APBPERI_AES_PMS_CONSTRAIN_0: SENSITIVE_DMA_APBPERI_AES_PMS_CONSTRAIN_0_REG
	// Position of DMA_APBPERI_AES_PMS_CONSTRAIN_LOCK field.
	SENSITIVE_DMA_APBPERI_AES_PMS_CONSTRAIN_0_DMA_APBPERI_AES_PMS_CONSTRAIN_LOCK_Pos = 0x0
	// Bit mask of DMA_APBPERI_AES_PMS_CONSTRAIN_LOCK field.
	SENSITIVE_DMA_APBPERI_AES_PMS_CONSTRAIN_0_DMA_APBPERI_AES_PMS_CONSTRAIN_LOCK_Msk = 0x1
	// Bit DMA_APBPERI_AES_PMS_CONSTRAIN_LOCK.
	SENSITIVE_DMA_APBPERI_AES_PMS_CONSTRAIN_0_DMA_APBPERI_AES_PMS_CONSTRAIN_LOCK = 0x1

	// DMA_APBPERI_AES_PMS_CONSTRAIN_1: SENSITIVE_DMA_APBPERI_AES_PMS_CONSTRAIN_1_REG
	// Position of DMA_APBPERI_AES_PMS_CONSTRAIN_SRAM_WORLD_0_PMS_0 field.
	SENSITIVE_DMA_APBPERI_AES_PMS_CONSTRAIN_1_DMA_APBPERI_AES_PMS_CONSTRAIN_SRAM_WORLD_0_PMS_0_Pos = 0x0
	// Bit mask of DMA_APBPERI_AES_PMS_CONSTRAIN_SRAM_WORLD_0_PMS_0 field.
	SENSITIVE_DMA_APBPERI_AES_PMS_CONSTRAIN_1_DMA_APBPERI_AES_PMS_CONSTRAIN_SRAM_WORLD_0_PMS_0_Msk = 0x3
	// Position of DMA_APBPERI_AES_PMS_CONSTRAIN_SRAM_WORLD_0_PMS_1 field.
	SENSITIVE_DMA_APBPERI_AES_PMS_CONSTRAIN_1_DMA_APBPERI_AES_PMS_CONSTRAIN_SRAM_WORLD_0_PMS_1_Pos = 0x2
	// Bit mask of DMA_APBPERI_AES_PMS_CONSTRAIN_SRAM_WORLD_0_PMS_1 field.
	SENSITIVE_DMA_APBPERI_AES_PMS_CONSTRAIN_1_DMA_APBPERI_AES_PMS_CONSTRAIN_SRAM_WORLD_0_PMS_1_Msk = 0xc
	// Position of DMA_APBPERI_AES_PMS_CONSTRAIN_SRAM_WORLD_0_PMS_2 field.
	SENSITIVE_DMA_APBPERI_AES_PMS_CONSTRAIN_1_DMA_APBPERI_AES_PMS_CONSTRAIN_SRAM_WORLD_0_PMS_2_Pos = 0x4
	// Bit mask of DMA_APBPERI_AES_PMS_CONSTRAIN_SRAM_WORLD_0_PMS_2 field.
	SENSITIVE_DMA_APBPERI_AES_PMS_CONSTRAIN_1_DMA_APBPERI_AES_PMS_CONSTRAIN_SRAM_WORLD_0_PMS_2_Msk = 0x30
	// Position of DMA_APBPERI_AES_PMS_CONSTRAIN_SRAM_WORLD_0_PMS_3 field.
	SENSITIVE_DMA_APBPERI_AES_PMS_CONSTRAIN_1_DMA_APBPERI_AES_PMS_CONSTRAIN_SRAM_WORLD_0_PMS_3_Pos = 0x6
	// Bit mask of DMA_APBPERI_AES_PMS_CONSTRAIN_SRAM_WORLD_0_PMS_3 field.
	SENSITIVE_DMA_APBPERI_AES_PMS_CONSTRAIN_1_DMA_APBPERI_AES_PMS_CONSTRAIN_SRAM_WORLD_0_PMS_3_Msk = 0xc0
	// Position of DMA_APBPERI_AES_PMS_CONSTRAIN_SRAM_WORLD_1_PMS_0 field.
	SENSITIVE_DMA_APBPERI_AES_PMS_CONSTRAIN_1_DMA_APBPERI_AES_PMS_CONSTRAIN_SRAM_WORLD_1_PMS_0_Pos = 0xc
	// Bit mask of DMA_APBPERI_AES_PMS_CONSTRAIN_SRAM_WORLD_1_PMS_0 field.
	SENSITIVE_DMA_APBPERI_AES_PMS_CONSTRAIN_1_DMA_APBPERI_AES_PMS_CONSTRAIN_SRAM_WORLD_1_PMS_0_Msk = 0x3000
	// Position of DMA_APBPERI_AES_PMS_CONSTRAIN_SRAM_WORLD_1_PMS_1 field.
	SENSITIVE_DMA_APBPERI_AES_PMS_CONSTRAIN_1_DMA_APBPERI_AES_PMS_CONSTRAIN_SRAM_WORLD_1_PMS_1_Pos = 0xe
	// Bit mask of DMA_APBPERI_AES_PMS_CONSTRAIN_SRAM_WORLD_1_PMS_1 field.
	SENSITIVE_DMA_APBPERI_AES_PMS_CONSTRAIN_1_DMA_APBPERI_AES_PMS_CONSTRAIN_SRAM_WORLD_1_PMS_1_Msk = 0xc000
	// Position of DMA_APBPERI_AES_PMS_CONSTRAIN_SRAM_WORLD_1_PMS_2 field.
	SENSITIVE_DMA_APBPERI_AES_PMS_CONSTRAIN_1_DMA_APBPERI_AES_PMS_CONSTRAIN_SRAM_WORLD_1_PMS_2_Pos = 0x10
	// Bit mask of DMA_APBPERI_AES_PMS_CONSTRAIN_SRAM_WORLD_1_PMS_2 field.
	SENSITIVE_DMA_APBPERI_AES_PMS_CONSTRAIN_1_DMA_APBPERI_AES_PMS_CONSTRAIN_SRAM_WORLD_1_PMS_2_Msk = 0x30000
	// Position of DMA_APBPERI_AES_PMS_CONSTRAIN_SRAM_WORLD_1_PMS_3 field.
	SENSITIVE_DMA_APBPERI_AES_PMS_CONSTRAIN_1_DMA_APBPERI_AES_PMS_CONSTRAIN_SRAM_WORLD_1_PMS_3_Pos = 0x12
	// Bit mask of DMA_APBPERI_AES_PMS_CONSTRAIN_SRAM_WORLD_1_PMS_3 field.
	SENSITIVE_DMA_APBPERI_AES_PMS_CONSTRAIN_1_DMA_APBPERI_AES_PMS_CONSTRAIN_SRAM_WORLD_1_PMS_3_Msk = 0xc0000

	// DMA_APBPERI_SHA_PMS_CONSTRAIN_0: SENSITIVE_DMA_APBPERI_SHA_PMS_CONSTRAIN_0_REG
	// Position of DMA_APBPERI_SHA_PMS_CONSTRAIN_LOCK field.
	SENSITIVE_DMA_APBPERI_SHA_PMS_CONSTRAIN_0_DMA_APBPERI_SHA_PMS_CONSTRAIN_LOCK_Pos = 0x0
	// Bit mask of DMA_APBPERI_SHA_PMS_CONSTRAIN_LOCK field.
	SENSITIVE_DMA_APBPERI_SHA_PMS_CONSTRAIN_0_DMA_APBPERI_SHA_PMS_CONSTRAIN_LOCK_Msk = 0x1
	// Bit DMA_APBPERI_SHA_PMS_CONSTRAIN_LOCK.
	SENSITIVE_DMA_APBPERI_SHA_PMS_CONSTRAIN_0_DMA_APBPERI_SHA_PMS_CONSTRAIN_LOCK = 0x1

	// DMA_APBPERI_SHA_PMS_CONSTRAIN_1: SENSITIVE_DMA_APBPERI_SHA_PMS_CONSTRAIN_1_REG
	// Position of DMA_APBPERI_SHA_PMS_CONSTRAIN_SRAM_WORLD_0_PMS_0 field.
	SENSITIVE_DMA_APBPERI_SHA_PMS_CONSTRAIN_1_DMA_APBPERI_SHA_PMS_CONSTRAIN_SRAM_WORLD_0_PMS_0_Pos = 0x0
	// Bit mask of DMA_APBPERI_SHA_PMS_CONSTRAIN_SRAM_WORLD_0_PMS_0 field.
	SENSITIVE_DMA_APBPERI_SHA_PMS_CONSTRAIN_1_DMA_APBPERI_SHA_PMS_CONSTRAIN_SRAM_WORLD_0_PMS_0_Msk = 0x3
	// Position of DMA_APBPERI_SHA_PMS_CONSTRAIN_SRAM_WORLD_0_PMS_1 field.
	SENSITIVE_DMA_APBPERI_SHA_PMS_CONSTRAIN_1_DMA_APBPERI_SHA_PMS_CONSTRAIN_SRAM_WORLD_0_PMS_1_Pos = 0x2
	// Bit mask of DMA_APBPERI_SHA_PMS_CONSTRAIN_SRAM_WORLD_0_PMS_1 field.
	SENSITIVE_DMA_APBPERI_SHA_PMS_CONSTRAIN_1_DMA_APBPERI_SHA_PMS_CONSTRAIN_SRAM_WORLD_0_PMS_1_Msk = 0xc
	// Position of DMA_APBPERI_SHA_PMS_CONSTRAIN_SRAM_WORLD_0_PMS_2 field.
	SENSITIVE_DMA_APBPERI_SHA_PMS_CONSTRAIN_1_DMA_APBPERI_SHA_PMS_CONSTRAIN_SRAM_WORLD_0_PMS_2_Pos = 0x4
	// Bit mask of DMA_APBPERI_SHA_PMS_CONSTRAIN_SRAM_WORLD_0_PMS_2 field.
	SENSITIVE_DMA_APBPERI_SHA_PMS_CONSTRAIN_1_DMA_APBPERI_SHA_PMS_CONSTRAIN_SRAM_WORLD_0_PMS_2_Msk = 0x30
	// Position of DMA_APBPERI_SHA_PMS_CONSTRAIN_SRAM_WORLD_0_PMS_3 field.
	SENSITIVE_DMA_APBPERI_SHA_PMS_CONSTRAIN_1_DMA_APBPERI_SHA_PMS_CONSTRAIN_SRAM_WORLD_0_PMS_3_Pos = 0x6
	// Bit mask of DMA_APBPERI_SHA_PMS_CONSTRAIN_SRAM_WORLD_0_PMS_3 field.
	SENSITIVE_DMA_APBPERI_SHA_PMS_CONSTRAIN_1_DMA_APBPERI_SHA_PMS_CONSTRAIN_SRAM_WORLD_0_PMS_3_Msk = 0xc0
	// Position of DMA_APBPERI_SHA_PMS_CONSTRAIN_SRAM_WORLD_1_PMS_0 field.
	SENSITIVE_DMA_APBPERI_SHA_PMS_CONSTRAIN_1_DMA_APBPERI_SHA_PMS_CONSTRAIN_SRAM_WORLD_1_PMS_0_Pos = 0xc
	// Bit mask of DMA_APBPERI_SHA_PMS_CONSTRAIN_SRAM_WORLD_1_PMS_0 field.
	SENSITIVE_DMA_APBPERI_SHA_PMS_CONSTRAIN_1_DMA_APBPERI_SHA_PMS_CONSTRAIN_SRAM_WORLD_1_PMS_0_Msk = 0x3000
	// Position of DMA_APBPERI_SHA_PMS_CONSTRAIN_SRAM_WORLD_1_PMS_1 field.
	SENSITIVE_DMA_APBPERI_SHA_PMS_CONSTRAIN_1_DMA_APBPERI_SHA_PMS_CONSTRAIN_SRAM_WORLD_1_PMS_1_Pos = 0xe
	// Bit mask of DMA_APBPERI_SHA_PMS_CONSTRAIN_SRAM_WORLD_1_PMS_1 field.
	SENSITIVE_DMA_APBPERI_SHA_PMS_CONSTRAIN_1_DMA_APBPERI_SHA_PMS_CONSTRAIN_SRAM_WORLD_1_PMS_1_Msk = 0xc000
	// Position of DMA_APBPERI_SHA_PMS_CONSTRAIN_SRAM_WORLD_1_PMS_2 field.
	SENSITIVE_DMA_APBPERI_SHA_PMS_CONSTRAIN_1_DMA_APBPERI_SHA_PMS_CONSTRAIN_SRAM_WORLD_1_PMS_2_Pos = 0x10
	// Bit mask of DMA_APBPERI_SHA_PMS_CONSTRAIN_SRAM_WORLD_1_PMS_2 field.
	SENSITIVE_DMA_APBPERI_SHA_PMS_CONSTRAIN_1_DMA_APBPERI_SHA_PMS_CONSTRAIN_SRAM_WORLD_1_PMS_2_Msk = 0x30000
	// Position of DMA_APBPERI_SHA_PMS_CONSTRAIN_SRAM_WORLD_1_PMS_3 field.
	SENSITIVE_DMA_APBPERI_SHA_PMS_CONSTRAIN_1_DMA_APBPERI_SHA_PMS_CONSTRAIN_SRAM_WORLD_1_PMS_3_Pos = 0x12
	// Bit mask of DMA_APBPERI_SHA_PMS_CONSTRAIN_SRAM_WORLD_1_PMS_3 field.
	SENSITIVE_DMA_APBPERI_SHA_PMS_CONSTRAIN_1_DMA_APBPERI_SHA_PMS_CONSTRAIN_SRAM_WORLD_1_PMS_3_Msk = 0xc0000

	// DMA_APBPERI_ADC_DAC_PMS_CONSTRAIN_0: SENSITIVE_DMA_APBPERI_ADC_DAC_PMS_CONSTRAIN_0_REG
	// Position of DMA_APBPERI_ADC_DAC_PMS_CONSTRAIN_LOCK field.
	SENSITIVE_DMA_APBPERI_ADC_DAC_PMS_CONSTRAIN_0_DMA_APBPERI_ADC_DAC_PMS_CONSTRAIN_LOCK_Pos = 0x0
	// Bit mask of DMA_APBPERI_ADC_DAC_PMS_CONSTRAIN_LOCK field.
	SENSITIVE_DMA_APBPERI_ADC_DAC_PMS_CONSTRAIN_0_DMA_APBPERI_ADC_DAC_PMS_CONSTRAIN_LOCK_Msk = 0x1
	// Bit DMA_APBPERI_ADC_DAC_PMS_CONSTRAIN_LOCK.
	SENSITIVE_DMA_APBPERI_ADC_DAC_PMS_CONSTRAIN_0_DMA_APBPERI_ADC_DAC_PMS_CONSTRAIN_LOCK = 0x1

	// DMA_APBPERI_ADC_DAC_PMS_CONSTRAIN_1: SENSITIVE_DMA_APBPERI_ADC_DAC_PMS_CONSTRAIN_1_REG
	// Position of DMA_APBPERI_ADC_DAC_PMS_CONSTRAIN_SRAM_WORLD_0_PMS_0 field.
	SENSITIVE_DMA_APBPERI_ADC_DAC_PMS_CONSTRAIN_1_DMA_APBPERI_ADC_DAC_PMS_CONSTRAIN_SRAM_WORLD_0_PMS_0_Pos = 0x0
	// Bit mask of DMA_APBPERI_ADC_DAC_PMS_CONSTRAIN_SRAM_WORLD_0_PMS_0 field.
	SENSITIVE_DMA_APBPERI_ADC_DAC_PMS_CONSTRAIN_1_DMA_APBPERI_ADC_DAC_PMS_CONSTRAIN_SRAM_WORLD_0_PMS_0_Msk = 0x3
	// Position of DMA_APBPERI_ADC_DAC_PMS_CONSTRAIN_SRAM_WORLD_0_PMS_1 field.
	SENSITIVE_DMA_APBPERI_ADC_DAC_PMS_CONSTRAIN_1_DMA_APBPERI_ADC_DAC_PMS_CONSTRAIN_SRAM_WORLD_0_PMS_1_Pos = 0x2
	// Bit mask of DMA_APBPERI_ADC_DAC_PMS_CONSTRAIN_SRAM_WORLD_0_PMS_1 field.
	SENSITIVE_DMA_APBPERI_ADC_DAC_PMS_CONSTRAIN_1_DMA_APBPERI_ADC_DAC_PMS_CONSTRAIN_SRAM_WORLD_0_PMS_1_Msk = 0xc
	// Position of DMA_APBPERI_ADC_DAC_PMS_CONSTRAIN_SRAM_WORLD_0_PMS_2 field.
	SENSITIVE_DMA_APBPERI_ADC_DAC_PMS_CONSTRAIN_1_DMA_APBPERI_ADC_DAC_PMS_CONSTRAIN_SRAM_WORLD_0_PMS_2_Pos = 0x4
	// Bit mask of DMA_APBPERI_ADC_DAC_PMS_CONSTRAIN_SRAM_WORLD_0_PMS_2 field.
	SENSITIVE_DMA_APBPERI_ADC_DAC_PMS_CONSTRAIN_1_DMA_APBPERI_ADC_DAC_PMS_CONSTRAIN_SRAM_WORLD_0_PMS_2_Msk = 0x30
	// Position of DMA_APBPERI_ADC_DAC_PMS_CONSTRAIN_SRAM_WORLD_0_PMS_3 field.
	SENSITIVE_DMA_APBPERI_ADC_DAC_PMS_CONSTRAIN_1_DMA_APBPERI_ADC_DAC_PMS_CONSTRAIN_SRAM_WORLD_0_PMS_3_Pos = 0x6
	// Bit mask of DMA_APBPERI_ADC_DAC_PMS_CONSTRAIN_SRAM_WORLD_0_PMS_3 field.
	SENSITIVE_DMA_APBPERI_ADC_DAC_PMS_CONSTRAIN_1_DMA_APBPERI_ADC_DAC_PMS_CONSTRAIN_SRAM_WORLD_0_PMS_3_Msk = 0xc0
	// Position of DMA_APBPERI_ADC_DAC_PMS_CONSTRAIN_SRAM_WORLD_1_PMS_0 field.
	SENSITIVE_DMA_APBPERI_ADC_DAC_PMS_CONSTRAIN_1_DMA_APBPERI_ADC_DAC_PMS_CONSTRAIN_SRAM_WORLD_1_PMS_0_Pos = 0xc
	// Bit mask of DMA_APBPERI_ADC_DAC_PMS_CONSTRAIN_SRAM_WORLD_1_PMS_0 field.
	SENSITIVE_DMA_APBPERI_ADC_DAC_PMS_CONSTRAIN_1_DMA_APBPERI_ADC_DAC_PMS_CONSTRAIN_SRAM_WORLD_1_PMS_0_Msk = 0x3000
	// Position of DMA_APBPERI_ADC_DAC_PMS_CONSTRAIN_SRAM_WORLD_1_PMS_1 field.
	SENSITIVE_DMA_APBPERI_ADC_DAC_PMS_CONSTRAIN_1_DMA_APBPERI_ADC_DAC_PMS_CONSTRAIN_SRAM_WORLD_1_PMS_1_Pos = 0xe
	// Bit mask of DMA_APBPERI_ADC_DAC_PMS_CONSTRAIN_SRAM_WORLD_1_PMS_1 field.
	SENSITIVE_DMA_APBPERI_ADC_DAC_PMS_CONSTRAIN_1_DMA_APBPERI_ADC_DAC_PMS_CONSTRAIN_SRAM_WORLD_1_PMS_1_Msk = 0xc000
	// Position of DMA_APBPERI_ADC_DAC_PMS_CONSTRAIN_SRAM_WORLD_1_PMS_2 field.
	SENSITIVE_DMA_APBPERI_ADC_DAC_PMS_CONSTRAIN_1_DMA_APBPERI_ADC_DAC_PMS_CONSTRAIN_SRAM_WORLD_1_PMS_2_Pos = 0x10
	// Bit mask of DMA_APBPERI_ADC_DAC_PMS_CONSTRAIN_SRAM_WORLD_1_PMS_2 field.
	SENSITIVE_DMA_APBPERI_ADC_DAC_PMS_CONSTRAIN_1_DMA_APBPERI_ADC_DAC_PMS_CONSTRAIN_SRAM_WORLD_1_PMS_2_Msk = 0x30000
	// Position of DMA_APBPERI_ADC_DAC_PMS_CONSTRAIN_SRAM_WORLD_1_PMS_3 field.
	SENSITIVE_DMA_APBPERI_ADC_DAC_PMS_CONSTRAIN_1_DMA_APBPERI_ADC_DAC_PMS_CONSTRAIN_SRAM_WORLD_1_PMS_3_Pos = 0x12
	// Bit mask of DMA_APBPERI_ADC_DAC_PMS_CONSTRAIN_SRAM_WORLD_1_PMS_3 field.
	SENSITIVE_DMA_APBPERI_ADC_DAC_PMS_CONSTRAIN_1_DMA_APBPERI_ADC_DAC_PMS_CONSTRAIN_SRAM_WORLD_1_PMS_3_Msk = 0xc0000

	// DMA_APBPERI_PMS_MONITOR_0: SENSITIVE_DMA_APBPERI_PMS_MONITOR_0_REG
	// Position of DMA_APBPERI_PMS_MONITOR_LOCK field.
	SENSITIVE_DMA_APBPERI_PMS_MONITOR_0_DMA_APBPERI_PMS_MONITOR_LOCK_Pos = 0x0
	// Bit mask of DMA_APBPERI_PMS_MONITOR_LOCK field.
	SENSITIVE_DMA_APBPERI_PMS_MONITOR_0_DMA_APBPERI_PMS_MONITOR_LOCK_Msk = 0x1
	// Bit DMA_APBPERI_PMS_MONITOR_LOCK.
	SENSITIVE_DMA_APBPERI_PMS_MONITOR_0_DMA_APBPERI_PMS_MONITOR_LOCK = 0x1

	// DMA_APBPERI_PMS_MONITOR_1: SENSITIVE_DMA_APBPERI_PMS_MONITOR_1_REG
	// Position of DMA_APBPERI_PMS_MONITOR_VIOLATE_CLR field.
	SENSITIVE_DMA_APBPERI_PMS_MONITOR_1_DMA_APBPERI_PMS_MONITOR_VIOLATE_CLR_Pos = 0x0
	// Bit mask of DMA_APBPERI_PMS_MONITOR_VIOLATE_CLR field.
	SENSITIVE_DMA_APBPERI_PMS_MONITOR_1_DMA_APBPERI_PMS_MONITOR_VIOLATE_CLR_Msk = 0x1
	// Bit DMA_APBPERI_PMS_MONITOR_VIOLATE_CLR.
	SENSITIVE_DMA_APBPERI_PMS_MONITOR_1_DMA_APBPERI_PMS_MONITOR_VIOLATE_CLR = 0x1
	// Position of DMA_APBPERI_PMS_MONITOR_VIOLATE_EN field.
	SENSITIVE_DMA_APBPERI_PMS_MONITOR_1_DMA_APBPERI_PMS_MONITOR_VIOLATE_EN_Pos = 0x1
	// Bit mask of DMA_APBPERI_PMS_MONITOR_VIOLATE_EN field.
	SENSITIVE_DMA_APBPERI_PMS_MONITOR_1_DMA_APBPERI_PMS_MONITOR_VIOLATE_EN_Msk = 0x2
	// Bit DMA_APBPERI_PMS_MONITOR_VIOLATE_EN.
	SENSITIVE_DMA_APBPERI_PMS_MONITOR_1_DMA_APBPERI_PMS_MONITOR_VIOLATE_EN = 0x2

	// DMA_APBPERI_PMS_MONITOR_2: SENSITIVE_DMA_APBPERI_PMS_MONITOR_2_REG
	// Position of DMA_APBPERI_PMS_MONITOR_VIOLATE_INTR field.
	SENSITIVE_DMA_APBPERI_PMS_MONITOR_2_DMA_APBPERI_PMS_MONITOR_VIOLATE_INTR_Pos = 0x0
	// Bit mask of DMA_APBPERI_PMS_MONITOR_VIOLATE_INTR field.
	SENSITIVE_DMA_APBPERI_PMS_MONITOR_2_DMA_APBPERI_PMS_MONITOR_VIOLATE_INTR_Msk = 0x1
	// Bit DMA_APBPERI_PMS_MONITOR_VIOLATE_INTR.
	SENSITIVE_DMA_APBPERI_PMS_MONITOR_2_DMA_APBPERI_PMS_MONITOR_VIOLATE_INTR = 0x1
	// Position of DMA_APBPERI_PMS_MONITOR_VIOLATE_STATUS_WORLD field.
	SENSITIVE_DMA_APBPERI_PMS_MONITOR_2_DMA_APBPERI_PMS_MONITOR_VIOLATE_STATUS_WORLD_Pos = 0x1
	// Bit mask of DMA_APBPERI_PMS_MONITOR_VIOLATE_STATUS_WORLD field.
	SENSITIVE_DMA_APBPERI_PMS_MONITOR_2_DMA_APBPERI_PMS_MONITOR_VIOLATE_STATUS_WORLD_Msk = 0x6
	// Position of DMA_APBPERI_PMS_MONITOR_VIOLATE_STATUS_ADDR field.
	SENSITIVE_DMA_APBPERI_PMS_MONITOR_2_DMA_APBPERI_PMS_MONITOR_VIOLATE_STATUS_ADDR_Pos = 0x3
	// Bit mask of DMA_APBPERI_PMS_MONITOR_VIOLATE_STATUS_ADDR field.
	SENSITIVE_DMA_APBPERI_PMS_MONITOR_2_DMA_APBPERI_PMS_MONITOR_VIOLATE_STATUS_ADDR_Msk = 0x7fffff8

	// DMA_APBPERI_PMS_MONITOR_3: SENSITIVE_DMA_APBPERI_PMS_MONITOR_3_REG
	// Position of DMA_APBPERI_PMS_MONITOR_VIOLATE_STATUS_WR field.
	SENSITIVE_DMA_APBPERI_PMS_MONITOR_3_DMA_APBPERI_PMS_MONITOR_VIOLATE_STATUS_WR_Pos = 0x0
	// Bit mask of DMA_APBPERI_PMS_MONITOR_VIOLATE_STATUS_WR field.
	SENSITIVE_DMA_APBPERI_PMS_MONITOR_3_DMA_APBPERI_PMS_MONITOR_VIOLATE_STATUS_WR_Msk = 0x1
	// Bit DMA_APBPERI_PMS_MONITOR_VIOLATE_STATUS_WR.
	SENSITIVE_DMA_APBPERI_PMS_MONITOR_3_DMA_APBPERI_PMS_MONITOR_VIOLATE_STATUS_WR = 0x1
	// Position of DMA_APBPERI_PMS_MONITOR_VIOLATE_STATUS_BYTEEN field.
	SENSITIVE_DMA_APBPERI_PMS_MONITOR_3_DMA_APBPERI_PMS_MONITOR_VIOLATE_STATUS_BYTEEN_Pos = 0x1
	// Bit mask of DMA_APBPERI_PMS_MONITOR_VIOLATE_STATUS_BYTEEN field.
	SENSITIVE_DMA_APBPERI_PMS_MONITOR_3_DMA_APBPERI_PMS_MONITOR_VIOLATE_STATUS_BYTEEN_Msk = 0x1e

	// CORE_X_IRAM0_DRAM0_DMA_SPLIT_LINE_CONSTRAIN_0: SENSITIVE_CORE_X_IRAM0_DRAM0_DMA_SPLIT_LINE_CONSTRAIN_0_REG
	// Position of CORE_X_IRAM0_DRAM0_DMA_SPLIT_LINE_CONSTRAIN_LOCK field.
	SENSITIVE_CORE_X_IRAM0_DRAM0_DMA_SPLIT_LINE_CONSTRAIN_0_CORE_X_IRAM0_DRAM0_DMA_SPLIT_LINE_CONSTRAIN_LOCK_Pos = 0x0
	// Bit mask of CORE_X_IRAM0_DRAM0_DMA_SPLIT_LINE_CONSTRAIN_LOCK field.
	SENSITIVE_CORE_X_IRAM0_DRAM0_DMA_SPLIT_LINE_CONSTRAIN_0_CORE_X_IRAM0_DRAM0_DMA_SPLIT_LINE_CONSTRAIN_LOCK_Msk = 0x1
	// Bit CORE_X_IRAM0_DRAM0_DMA_SPLIT_LINE_CONSTRAIN_LOCK.
	SENSITIVE_CORE_X_IRAM0_DRAM0_DMA_SPLIT_LINE_CONSTRAIN_0_CORE_X_IRAM0_DRAM0_DMA_SPLIT_LINE_CONSTRAIN_LOCK = 0x1

	// CORE_X_IRAM0_DRAM0_DMA_SPLIT_LINE_CONSTRAIN_1: SENSITIVE_CORE_X_IRAM0_DRAM0_DMA_SPLIT_LINE_CONSTRAIN_1_REG
	// Position of CORE_X_IRAM0_DRAM0_DMA_SRAM_CATEGORY_0 field.
	SENSITIVE_CORE_X_IRAM0_DRAM0_DMA_SPLIT_LINE_CONSTRAIN_1_CORE_X_IRAM0_DRAM0_DMA_SRAM_CATEGORY_0_Pos = 0x0
	// Bit mask of CORE_X_IRAM0_DRAM0_DMA_SRAM_CATEGORY_0 field.
	SENSITIVE_CORE_X_IRAM0_DRAM0_DMA_SPLIT_LINE_CONSTRAIN_1_CORE_X_IRAM0_DRAM0_DMA_SRAM_CATEGORY_0_Msk = 0x3
	// Position of CORE_X_IRAM0_DRAM0_DMA_SRAM_CATEGORY_1 field.
	SENSITIVE_CORE_X_IRAM0_DRAM0_DMA_SPLIT_LINE_CONSTRAIN_1_CORE_X_IRAM0_DRAM0_DMA_SRAM_CATEGORY_1_Pos = 0x2
	// Bit mask of CORE_X_IRAM0_DRAM0_DMA_SRAM_CATEGORY_1 field.
	SENSITIVE_CORE_X_IRAM0_DRAM0_DMA_SPLIT_LINE_CONSTRAIN_1_CORE_X_IRAM0_DRAM0_DMA_SRAM_CATEGORY_1_Msk = 0xc
	// Position of CORE_X_IRAM0_DRAM0_DMA_SRAM_CATEGORY_2 field.
	SENSITIVE_CORE_X_IRAM0_DRAM0_DMA_SPLIT_LINE_CONSTRAIN_1_CORE_X_IRAM0_DRAM0_DMA_SRAM_CATEGORY_2_Pos = 0x4
	// Bit mask of CORE_X_IRAM0_DRAM0_DMA_SRAM_CATEGORY_2 field.
	SENSITIVE_CORE_X_IRAM0_DRAM0_DMA_SPLIT_LINE_CONSTRAIN_1_CORE_X_IRAM0_DRAM0_DMA_SRAM_CATEGORY_2_Msk = 0x30
	// Position of CORE_X_IRAM0_DRAM0_DMA_SRAM_SPLITADDR field.
	SENSITIVE_CORE_X_IRAM0_DRAM0_DMA_SPLIT_LINE_CONSTRAIN_1_CORE_X_IRAM0_DRAM0_DMA_SRAM_SPLITADDR_Pos = 0xe
	// Bit mask of CORE_X_IRAM0_DRAM0_DMA_SRAM_SPLITADDR field.
	SENSITIVE_CORE_X_IRAM0_DRAM0_DMA_SPLIT_LINE_CONSTRAIN_1_CORE_X_IRAM0_DRAM0_DMA_SRAM_SPLITADDR_Msk = 0x3fc000

	// CORE_X_IRAM0_DRAM0_DMA_SPLIT_LINE_CONSTRAIN_2: SENSITIVE_CORE_X_IRAM0_DRAM0_DMA_SPLIT_LINE_CONSTRAIN_2_REG
	// Position of CORE_X_IRAM0_SRAM_LINE_0_CATEGORY_0 field.
	SENSITIVE_CORE_X_IRAM0_DRAM0_DMA_SPLIT_LINE_CONSTRAIN_2_CORE_X_IRAM0_SRAM_LINE_0_CATEGORY_0_Pos = 0x0
	// Bit mask of CORE_X_IRAM0_SRAM_LINE_0_CATEGORY_0 field.
	SENSITIVE_CORE_X_IRAM0_DRAM0_DMA_SPLIT_LINE_CONSTRAIN_2_CORE_X_IRAM0_SRAM_LINE_0_CATEGORY_0_Msk = 0x3
	// Position of CORE_X_IRAM0_SRAM_LINE_0_CATEGORY_1 field.
	SENSITIVE_CORE_X_IRAM0_DRAM0_DMA_SPLIT_LINE_CONSTRAIN_2_CORE_X_IRAM0_SRAM_LINE_0_CATEGORY_1_Pos = 0x2
	// Bit mask of CORE_X_IRAM0_SRAM_LINE_0_CATEGORY_1 field.
	SENSITIVE_CORE_X_IRAM0_DRAM0_DMA_SPLIT_LINE_CONSTRAIN_2_CORE_X_IRAM0_SRAM_LINE_0_CATEGORY_1_Msk = 0xc
	// Position of CORE_X_IRAM0_SRAM_LINE_0_CATEGORY_2 field.
	SENSITIVE_CORE_X_IRAM0_DRAM0_DMA_SPLIT_LINE_CONSTRAIN_2_CORE_X_IRAM0_SRAM_LINE_0_CATEGORY_2_Pos = 0x4
	// Bit mask of CORE_X_IRAM0_SRAM_LINE_0_CATEGORY_2 field.
	SENSITIVE_CORE_X_IRAM0_DRAM0_DMA_SPLIT_LINE_CONSTRAIN_2_CORE_X_IRAM0_SRAM_LINE_0_CATEGORY_2_Msk = 0x30
	// Position of CORE_X_IRAM0_SRAM_LINE_0_SPLITADDR field.
	SENSITIVE_CORE_X_IRAM0_DRAM0_DMA_SPLIT_LINE_CONSTRAIN_2_CORE_X_IRAM0_SRAM_LINE_0_SPLITADDR_Pos = 0xe
	// Bit mask of CORE_X_IRAM0_SRAM_LINE_0_SPLITADDR field.
	SENSITIVE_CORE_X_IRAM0_DRAM0_DMA_SPLIT_LINE_CONSTRAIN_2_CORE_X_IRAM0_SRAM_LINE_0_SPLITADDR_Msk = 0x3fc000

	// CORE_X_IRAM0_DRAM0_DMA_SPLIT_LINE_CONSTRAIN_3: SENSITIVE_CORE_X_IRAM0_DRAM0_DMA_SPLIT_LINE_CONSTRAIN_3_REG
	// Position of CORE_X_IRAM0_SRAM_LINE_1_CATEGORY_0 field.
	SENSITIVE_CORE_X_IRAM0_DRAM0_DMA_SPLIT_LINE_CONSTRAIN_3_CORE_X_IRAM0_SRAM_LINE_1_CATEGORY_0_Pos = 0x0
	// Bit mask of CORE_X_IRAM0_SRAM_LINE_1_CATEGORY_0 field.
	SENSITIVE_CORE_X_IRAM0_DRAM0_DMA_SPLIT_LINE_CONSTRAIN_3_CORE_X_IRAM0_SRAM_LINE_1_CATEGORY_0_Msk = 0x3
	// Position of CORE_X_IRAM0_SRAM_LINE_1_CATEGORY_1 field.
	SENSITIVE_CORE_X_IRAM0_DRAM0_DMA_SPLIT_LINE_CONSTRAIN_3_CORE_X_IRAM0_SRAM_LINE_1_CATEGORY_1_Pos = 0x2
	// Bit mask of CORE_X_IRAM0_SRAM_LINE_1_CATEGORY_1 field.
	SENSITIVE_CORE_X_IRAM0_DRAM0_DMA_SPLIT_LINE_CONSTRAIN_3_CORE_X_IRAM0_SRAM_LINE_1_CATEGORY_1_Msk = 0xc
	// Position of CORE_X_IRAM0_SRAM_LINE_1_CATEGORY_2 field.
	SENSITIVE_CORE_X_IRAM0_DRAM0_DMA_SPLIT_LINE_CONSTRAIN_3_CORE_X_IRAM0_SRAM_LINE_1_CATEGORY_2_Pos = 0x4
	// Bit mask of CORE_X_IRAM0_SRAM_LINE_1_CATEGORY_2 field.
	SENSITIVE_CORE_X_IRAM0_DRAM0_DMA_SPLIT_LINE_CONSTRAIN_3_CORE_X_IRAM0_SRAM_LINE_1_CATEGORY_2_Msk = 0x30
	// Position of CORE_X_IRAM0_SRAM_LINE_1_SPLITADDR field.
	SENSITIVE_CORE_X_IRAM0_DRAM0_DMA_SPLIT_LINE_CONSTRAIN_3_CORE_X_IRAM0_SRAM_LINE_1_SPLITADDR_Pos = 0xe
	// Bit mask of CORE_X_IRAM0_SRAM_LINE_1_SPLITADDR field.
	SENSITIVE_CORE_X_IRAM0_DRAM0_DMA_SPLIT_LINE_CONSTRAIN_3_CORE_X_IRAM0_SRAM_LINE_1_SPLITADDR_Msk = 0x3fc000

	// CORE_X_IRAM0_DRAM0_DMA_SPLIT_LINE_CONSTRAIN_4: SENSITIVE_CORE_X_IRAM0_DRAM0_DMA_SPLIT_LINE_CONSTRAIN_4_REG
	// Position of CORE_X_DRAM0_DMA_SRAM_LINE_0_CATEGORY_0 field.
	SENSITIVE_CORE_X_IRAM0_DRAM0_DMA_SPLIT_LINE_CONSTRAIN_4_CORE_X_DRAM0_DMA_SRAM_LINE_0_CATEGORY_0_Pos = 0x0
	// Bit mask of CORE_X_DRAM0_DMA_SRAM_LINE_0_CATEGORY_0 field.
	SENSITIVE_CORE_X_IRAM0_DRAM0_DMA_SPLIT_LINE_CONSTRAIN_4_CORE_X_DRAM0_DMA_SRAM_LINE_0_CATEGORY_0_Msk = 0x3
	// Position of CORE_X_DRAM0_DMA_SRAM_LINE_0_CATEGORY_1 field.
	SENSITIVE_CORE_X_IRAM0_DRAM0_DMA_SPLIT_LINE_CONSTRAIN_4_CORE_X_DRAM0_DMA_SRAM_LINE_0_CATEGORY_1_Pos = 0x2
	// Bit mask of CORE_X_DRAM0_DMA_SRAM_LINE_0_CATEGORY_1 field.
	SENSITIVE_CORE_X_IRAM0_DRAM0_DMA_SPLIT_LINE_CONSTRAIN_4_CORE_X_DRAM0_DMA_SRAM_LINE_0_CATEGORY_1_Msk = 0xc
	// Position of CORE_X_DRAM0_DMA_SRAM_LINE_0_CATEGORY_2 field.
	SENSITIVE_CORE_X_IRAM0_DRAM0_DMA_SPLIT_LINE_CONSTRAIN_4_CORE_X_DRAM0_DMA_SRAM_LINE_0_CATEGORY_2_Pos = 0x4
	// Bit mask of CORE_X_DRAM0_DMA_SRAM_LINE_0_CATEGORY_2 field.
	SENSITIVE_CORE_X_IRAM0_DRAM0_DMA_SPLIT_LINE_CONSTRAIN_4_CORE_X_DRAM0_DMA_SRAM_LINE_0_CATEGORY_2_Msk = 0x30
	// Position of CORE_X_DRAM0_DMA_SRAM_LINE_0_SPLITADDR field.
	SENSITIVE_CORE_X_IRAM0_DRAM0_DMA_SPLIT_LINE_CONSTRAIN_4_CORE_X_DRAM0_DMA_SRAM_LINE_0_SPLITADDR_Pos = 0xe
	// Bit mask of CORE_X_DRAM0_DMA_SRAM_LINE_0_SPLITADDR field.
	SENSITIVE_CORE_X_IRAM0_DRAM0_DMA_SPLIT_LINE_CONSTRAIN_4_CORE_X_DRAM0_DMA_SRAM_LINE_0_SPLITADDR_Msk = 0x3fc000

	// CORE_X_IRAM0_DRAM0_DMA_SPLIT_LINE_CONSTRAIN_5: SENSITIVE_CORE_X_IRAM0_DRAM0_DMA_SPLIT_LINE_CONSTRAIN_5_REG
	// Position of CORE_X_DRAM0_DMA_SRAM_LINE_1_CATEGORY_0 field.
	SENSITIVE_CORE_X_IRAM0_DRAM0_DMA_SPLIT_LINE_CONSTRAIN_5_CORE_X_DRAM0_DMA_SRAM_LINE_1_CATEGORY_0_Pos = 0x0
	// Bit mask of CORE_X_DRAM0_DMA_SRAM_LINE_1_CATEGORY_0 field.
	SENSITIVE_CORE_X_IRAM0_DRAM0_DMA_SPLIT_LINE_CONSTRAIN_5_CORE_X_DRAM0_DMA_SRAM_LINE_1_CATEGORY_0_Msk = 0x3
	// Position of CORE_X_DRAM0_DMA_SRAM_LINE_1_CATEGORY_1 field.
	SENSITIVE_CORE_X_IRAM0_DRAM0_DMA_SPLIT_LINE_CONSTRAIN_5_CORE_X_DRAM0_DMA_SRAM_LINE_1_CATEGORY_1_Pos = 0x2
	// Bit mask of CORE_X_DRAM0_DMA_SRAM_LINE_1_CATEGORY_1 field.
	SENSITIVE_CORE_X_IRAM0_DRAM0_DMA_SPLIT_LINE_CONSTRAIN_5_CORE_X_DRAM0_DMA_SRAM_LINE_1_CATEGORY_1_Msk = 0xc
	// Position of CORE_X_DRAM0_DMA_SRAM_LINE_1_CATEGORY_2 field.
	SENSITIVE_CORE_X_IRAM0_DRAM0_DMA_SPLIT_LINE_CONSTRAIN_5_CORE_X_DRAM0_DMA_SRAM_LINE_1_CATEGORY_2_Pos = 0x4
	// Bit mask of CORE_X_DRAM0_DMA_SRAM_LINE_1_CATEGORY_2 field.
	SENSITIVE_CORE_X_IRAM0_DRAM0_DMA_SPLIT_LINE_CONSTRAIN_5_CORE_X_DRAM0_DMA_SRAM_LINE_1_CATEGORY_2_Msk = 0x30
	// Position of CORE_X_DRAM0_DMA_SRAM_LINE_1_SPLITADDR field.
	SENSITIVE_CORE_X_IRAM0_DRAM0_DMA_SPLIT_LINE_CONSTRAIN_5_CORE_X_DRAM0_DMA_SRAM_LINE_1_SPLITADDR_Pos = 0xe
	// Bit mask of CORE_X_DRAM0_DMA_SRAM_LINE_1_SPLITADDR field.
	SENSITIVE_CORE_X_IRAM0_DRAM0_DMA_SPLIT_LINE_CONSTRAIN_5_CORE_X_DRAM0_DMA_SRAM_LINE_1_SPLITADDR_Msk = 0x3fc000

	// CORE_X_IRAM0_PMS_CONSTRAIN_0: SENSITIVE_CORE_X_IRAM0_PMS_CONSTRAIN_0_REG
	// Position of CORE_X_IRAM0_PMS_CONSTRAIN_LOCK field.
	SENSITIVE_CORE_X_IRAM0_PMS_CONSTRAIN_0_CORE_X_IRAM0_PMS_CONSTRAIN_LOCK_Pos = 0x0
	// Bit mask of CORE_X_IRAM0_PMS_CONSTRAIN_LOCK field.
	SENSITIVE_CORE_X_IRAM0_PMS_CONSTRAIN_0_CORE_X_IRAM0_PMS_CONSTRAIN_LOCK_Msk = 0x1
	// Bit CORE_X_IRAM0_PMS_CONSTRAIN_LOCK.
	SENSITIVE_CORE_X_IRAM0_PMS_CONSTRAIN_0_CORE_X_IRAM0_PMS_CONSTRAIN_LOCK = 0x1

	// CORE_X_IRAM0_PMS_CONSTRAIN_1: SENSITIVE_CORE_X_IRAM0_PMS_CONSTRAIN_1_REG
	// Position of CORE_X_IRAM0_PMS_CONSTRAIN_SRAM_WORLD_1_PMS_0 field.
	SENSITIVE_CORE_X_IRAM0_PMS_CONSTRAIN_1_CORE_X_IRAM0_PMS_CONSTRAIN_SRAM_WORLD_1_PMS_0_Pos = 0x0
	// Bit mask of CORE_X_IRAM0_PMS_CONSTRAIN_SRAM_WORLD_1_PMS_0 field.
	SENSITIVE_CORE_X_IRAM0_PMS_CONSTRAIN_1_CORE_X_IRAM0_PMS_CONSTRAIN_SRAM_WORLD_1_PMS_0_Msk = 0x7
	// Position of CORE_X_IRAM0_PMS_CONSTRAIN_SRAM_WORLD_1_PMS_1 field.
	SENSITIVE_CORE_X_IRAM0_PMS_CONSTRAIN_1_CORE_X_IRAM0_PMS_CONSTRAIN_SRAM_WORLD_1_PMS_1_Pos = 0x3
	// Bit mask of CORE_X_IRAM0_PMS_CONSTRAIN_SRAM_WORLD_1_PMS_1 field.
	SENSITIVE_CORE_X_IRAM0_PMS_CONSTRAIN_1_CORE_X_IRAM0_PMS_CONSTRAIN_SRAM_WORLD_1_PMS_1_Msk = 0x38
	// Position of CORE_X_IRAM0_PMS_CONSTRAIN_SRAM_WORLD_1_PMS_2 field.
	SENSITIVE_CORE_X_IRAM0_PMS_CONSTRAIN_1_CORE_X_IRAM0_PMS_CONSTRAIN_SRAM_WORLD_1_PMS_2_Pos = 0x6
	// Bit mask of CORE_X_IRAM0_PMS_CONSTRAIN_SRAM_WORLD_1_PMS_2 field.
	SENSITIVE_CORE_X_IRAM0_PMS_CONSTRAIN_1_CORE_X_IRAM0_PMS_CONSTRAIN_SRAM_WORLD_1_PMS_2_Msk = 0x1c0
	// Position of CORE_X_IRAM0_PMS_CONSTRAIN_SRAM_WORLD_1_PMS_3 field.
	SENSITIVE_CORE_X_IRAM0_PMS_CONSTRAIN_1_CORE_X_IRAM0_PMS_CONSTRAIN_SRAM_WORLD_1_PMS_3_Pos = 0x9
	// Bit mask of CORE_X_IRAM0_PMS_CONSTRAIN_SRAM_WORLD_1_PMS_3 field.
	SENSITIVE_CORE_X_IRAM0_PMS_CONSTRAIN_1_CORE_X_IRAM0_PMS_CONSTRAIN_SRAM_WORLD_1_PMS_3_Msk = 0xe00
	// Position of CORE_X_IRAM0_PMS_CONSTRAIN_SRAM_WORLD_1_CACHEDATAARRAY_PMS_0 field.
	SENSITIVE_CORE_X_IRAM0_PMS_CONSTRAIN_1_CORE_X_IRAM0_PMS_CONSTRAIN_SRAM_WORLD_1_CACHEDATAARRAY_PMS_0_Pos = 0xc
	// Bit mask of CORE_X_IRAM0_PMS_CONSTRAIN_SRAM_WORLD_1_CACHEDATAARRAY_PMS_0 field.
	SENSITIVE_CORE_X_IRAM0_PMS_CONSTRAIN_1_CORE_X_IRAM0_PMS_CONSTRAIN_SRAM_WORLD_1_CACHEDATAARRAY_PMS_0_Msk = 0x7000
	// Position of CORE_X_IRAM0_PMS_CONSTRAIN_ROM_WORLD_1_PMS field.
	SENSITIVE_CORE_X_IRAM0_PMS_CONSTRAIN_1_CORE_X_IRAM0_PMS_CONSTRAIN_ROM_WORLD_1_PMS_Pos = 0x12
	// Bit mask of CORE_X_IRAM0_PMS_CONSTRAIN_ROM_WORLD_1_PMS field.
	SENSITIVE_CORE_X_IRAM0_PMS_CONSTRAIN_1_CORE_X_IRAM0_PMS_CONSTRAIN_ROM_WORLD_1_PMS_Msk = 0x1c0000

	// CORE_X_IRAM0_PMS_CONSTRAIN_2: SENSITIVE_CORE_X_IRAM0_PMS_CONSTRAIN_2_REG
	// Position of CORE_X_IRAM0_PMS_CONSTRAIN_SRAM_WORLD_0_PMS_0 field.
	SENSITIVE_CORE_X_IRAM0_PMS_CONSTRAIN_2_CORE_X_IRAM0_PMS_CONSTRAIN_SRAM_WORLD_0_PMS_0_Pos = 0x0
	// Bit mask of CORE_X_IRAM0_PMS_CONSTRAIN_SRAM_WORLD_0_PMS_0 field.
	SENSITIVE_CORE_X_IRAM0_PMS_CONSTRAIN_2_CORE_X_IRAM0_PMS_CONSTRAIN_SRAM_WORLD_0_PMS_0_Msk = 0x7
	// Position of CORE_X_IRAM0_PMS_CONSTRAIN_SRAM_WORLD_0_PMS_1 field.
	SENSITIVE_CORE_X_IRAM0_PMS_CONSTRAIN_2_CORE_X_IRAM0_PMS_CONSTRAIN_SRAM_WORLD_0_PMS_1_Pos = 0x3
	// Bit mask of CORE_X_IRAM0_PMS_CONSTRAIN_SRAM_WORLD_0_PMS_1 field.
	SENSITIVE_CORE_X_IRAM0_PMS_CONSTRAIN_2_CORE_X_IRAM0_PMS_CONSTRAIN_SRAM_WORLD_0_PMS_1_Msk = 0x38
	// Position of CORE_X_IRAM0_PMS_CONSTRAIN_SRAM_WORLD_0_PMS_2 field.
	SENSITIVE_CORE_X_IRAM0_PMS_CONSTRAIN_2_CORE_X_IRAM0_PMS_CONSTRAIN_SRAM_WORLD_0_PMS_2_Pos = 0x6
	// Bit mask of CORE_X_IRAM0_PMS_CONSTRAIN_SRAM_WORLD_0_PMS_2 field.
	SENSITIVE_CORE_X_IRAM0_PMS_CONSTRAIN_2_CORE_X_IRAM0_PMS_CONSTRAIN_SRAM_WORLD_0_PMS_2_Msk = 0x1c0
	// Position of CORE_X_IRAM0_PMS_CONSTRAIN_SRAM_WORLD_0_PMS_3 field.
	SENSITIVE_CORE_X_IRAM0_PMS_CONSTRAIN_2_CORE_X_IRAM0_PMS_CONSTRAIN_SRAM_WORLD_0_PMS_3_Pos = 0x9
	// Bit mask of CORE_X_IRAM0_PMS_CONSTRAIN_SRAM_WORLD_0_PMS_3 field.
	SENSITIVE_CORE_X_IRAM0_PMS_CONSTRAIN_2_CORE_X_IRAM0_PMS_CONSTRAIN_SRAM_WORLD_0_PMS_3_Msk = 0xe00
	// Position of CORE_X_IRAM0_PMS_CONSTRAIN_SRAM_WORLD_0_CACHEDATAARRAY_PMS_0 field.
	SENSITIVE_CORE_X_IRAM0_PMS_CONSTRAIN_2_CORE_X_IRAM0_PMS_CONSTRAIN_SRAM_WORLD_0_CACHEDATAARRAY_PMS_0_Pos = 0xc
	// Bit mask of CORE_X_IRAM0_PMS_CONSTRAIN_SRAM_WORLD_0_CACHEDATAARRAY_PMS_0 field.
	SENSITIVE_CORE_X_IRAM0_PMS_CONSTRAIN_2_CORE_X_IRAM0_PMS_CONSTRAIN_SRAM_WORLD_0_CACHEDATAARRAY_PMS_0_Msk = 0x7000
	// Position of CORE_X_IRAM0_PMS_CONSTRAIN_ROM_WORLD_0_PMS field.
	SENSITIVE_CORE_X_IRAM0_PMS_CONSTRAIN_2_CORE_X_IRAM0_PMS_CONSTRAIN_ROM_WORLD_0_PMS_Pos = 0x12
	// Bit mask of CORE_X_IRAM0_PMS_CONSTRAIN_ROM_WORLD_0_PMS field.
	SENSITIVE_CORE_X_IRAM0_PMS_CONSTRAIN_2_CORE_X_IRAM0_PMS_CONSTRAIN_ROM_WORLD_0_PMS_Msk = 0x1c0000

	// CORE_0_IRAM0_PMS_MONITOR_0: SENSITIVE_CORE_0_IRAM0_PMS_MONITOR_0_REG
	// Position of CORE_0_IRAM0_PMS_MONITOR_LOCK field.
	SENSITIVE_CORE_0_IRAM0_PMS_MONITOR_0_CORE_0_IRAM0_PMS_MONITOR_LOCK_Pos = 0x0
	// Bit mask of CORE_0_IRAM0_PMS_MONITOR_LOCK field.
	SENSITIVE_CORE_0_IRAM0_PMS_MONITOR_0_CORE_0_IRAM0_PMS_MONITOR_LOCK_Msk = 0x1
	// Bit CORE_0_IRAM0_PMS_MONITOR_LOCK.
	SENSITIVE_CORE_0_IRAM0_PMS_MONITOR_0_CORE_0_IRAM0_PMS_MONITOR_LOCK = 0x1

	// CORE_0_IRAM0_PMS_MONITOR_1: SENSITIVE_CORE_0_IRAM0_PMS_MONITOR_1_REG
	// Position of CORE_0_IRAM0_PMS_MONITOR_VIOLATE_CLR field.
	SENSITIVE_CORE_0_IRAM0_PMS_MONITOR_1_CORE_0_IRAM0_PMS_MONITOR_VIOLATE_CLR_Pos = 0x0
	// Bit mask of CORE_0_IRAM0_PMS_MONITOR_VIOLATE_CLR field.
	SENSITIVE_CORE_0_IRAM0_PMS_MONITOR_1_CORE_0_IRAM0_PMS_MONITOR_VIOLATE_CLR_Msk = 0x1
	// Bit CORE_0_IRAM0_PMS_MONITOR_VIOLATE_CLR.
	SENSITIVE_CORE_0_IRAM0_PMS_MONITOR_1_CORE_0_IRAM0_PMS_MONITOR_VIOLATE_CLR = 0x1
	// Position of CORE_0_IRAM0_PMS_MONITOR_VIOLATE_EN field.
	SENSITIVE_CORE_0_IRAM0_PMS_MONITOR_1_CORE_0_IRAM0_PMS_MONITOR_VIOLATE_EN_Pos = 0x1
	// Bit mask of CORE_0_IRAM0_PMS_MONITOR_VIOLATE_EN field.
	SENSITIVE_CORE_0_IRAM0_PMS_MONITOR_1_CORE_0_IRAM0_PMS_MONITOR_VIOLATE_EN_Msk = 0x2
	// Bit CORE_0_IRAM0_PMS_MONITOR_VIOLATE_EN.
	SENSITIVE_CORE_0_IRAM0_PMS_MONITOR_1_CORE_0_IRAM0_PMS_MONITOR_VIOLATE_EN = 0x2

	// CORE_0_IRAM0_PMS_MONITOR_2: SENSITIVE_CORE_0_IRAM0_PMS_MONITOR_2_REG
	// Position of CORE_0_IRAM0_PMS_MONITOR_VIOLATE_INTR field.
	SENSITIVE_CORE_0_IRAM0_PMS_MONITOR_2_CORE_0_IRAM0_PMS_MONITOR_VIOLATE_INTR_Pos = 0x0
	// Bit mask of CORE_0_IRAM0_PMS_MONITOR_VIOLATE_INTR field.
	SENSITIVE_CORE_0_IRAM0_PMS_MONITOR_2_CORE_0_IRAM0_PMS_MONITOR_VIOLATE_INTR_Msk = 0x1
	// Bit CORE_0_IRAM0_PMS_MONITOR_VIOLATE_INTR.
	SENSITIVE_CORE_0_IRAM0_PMS_MONITOR_2_CORE_0_IRAM0_PMS_MONITOR_VIOLATE_INTR = 0x1
	// Position of CORE_0_IRAM0_PMS_MONITOR_VIOLATE_STATUS_WR field.
	SENSITIVE_CORE_0_IRAM0_PMS_MONITOR_2_CORE_0_IRAM0_PMS_MONITOR_VIOLATE_STATUS_WR_Pos = 0x1
	// Bit mask of CORE_0_IRAM0_PMS_MONITOR_VIOLATE_STATUS_WR field.
	SENSITIVE_CORE_0_IRAM0_PMS_MONITOR_2_CORE_0_IRAM0_PMS_MONITOR_VIOLATE_STATUS_WR_Msk = 0x2
	// Bit CORE_0_IRAM0_PMS_MONITOR_VIOLATE_STATUS_WR.
	SENSITIVE_CORE_0_IRAM0_PMS_MONITOR_2_CORE_0_IRAM0_PMS_MONITOR_VIOLATE_STATUS_WR = 0x2
	// Position of CORE_0_IRAM0_PMS_MONITOR_VIOLATE_STATUS_LOADSTORE field.
	SENSITIVE_CORE_0_IRAM0_PMS_MONITOR_2_CORE_0_IRAM0_PMS_MONITOR_VIOLATE_STATUS_LOADSTORE_Pos = 0x2
	// Bit mask of CORE_0_IRAM0_PMS_MONITOR_VIOLATE_STATUS_LOADSTORE field.
	SENSITIVE_CORE_0_IRAM0_PMS_MONITOR_2_CORE_0_IRAM0_PMS_MONITOR_VIOLATE_STATUS_LOADSTORE_Msk = 0x4
	// Bit CORE_0_IRAM0_PMS_MONITOR_VIOLATE_STATUS_LOADSTORE.
	SENSITIVE_CORE_0_IRAM0_PMS_MONITOR_2_CORE_0_IRAM0_PMS_MONITOR_VIOLATE_STATUS_LOADSTORE = 0x4
	// Position of CORE_0_IRAM0_PMS_MONITOR_VIOLATE_STATUS_WORLD field.
	SENSITIVE_CORE_0_IRAM0_PMS_MONITOR_2_CORE_0_IRAM0_PMS_MONITOR_VIOLATE_STATUS_WORLD_Pos = 0x3
	// Bit mask of CORE_0_IRAM0_PMS_MONITOR_VIOLATE_STATUS_WORLD field.
	SENSITIVE_CORE_0_IRAM0_PMS_MONITOR_2_CORE_0_IRAM0_PMS_MONITOR_VIOLATE_STATUS_WORLD_Msk = 0x18
	// Position of CORE_0_IRAM0_PMS_MONITOR_VIOLATE_STATUS_ADDR field.
	SENSITIVE_CORE_0_IRAM0_PMS_MONITOR_2_CORE_0_IRAM0_PMS_MONITOR_VIOLATE_STATUS_ADDR_Pos = 0x5
	// Bit mask of CORE_0_IRAM0_PMS_MONITOR_VIOLATE_STATUS_ADDR field.
	SENSITIVE_CORE_0_IRAM0_PMS_MONITOR_2_CORE_0_IRAM0_PMS_MONITOR_VIOLATE_STATUS_ADDR_Msk = 0x1fffffe0

	// CORE_X_DRAM0_PMS_CONSTRAIN_0: SENSITIVE_CORE_X_DRAM0_PMS_CONSTRAIN_0_REG
	// Position of CORE_X_DRAM0_PMS_CONSTRAIN_LOCK field.
	SENSITIVE_CORE_X_DRAM0_PMS_CONSTRAIN_0_CORE_X_DRAM0_PMS_CONSTRAIN_LOCK_Pos = 0x0
	// Bit mask of CORE_X_DRAM0_PMS_CONSTRAIN_LOCK field.
	SENSITIVE_CORE_X_DRAM0_PMS_CONSTRAIN_0_CORE_X_DRAM0_PMS_CONSTRAIN_LOCK_Msk = 0x1
	// Bit CORE_X_DRAM0_PMS_CONSTRAIN_LOCK.
	SENSITIVE_CORE_X_DRAM0_PMS_CONSTRAIN_0_CORE_X_DRAM0_PMS_CONSTRAIN_LOCK = 0x1

	// CORE_X_DRAM0_PMS_CONSTRAIN_1: SENSITIVE_CORE_X_DRAM0_PMS_CONSTRAIN_1_REG
	// Position of CORE_X_DRAM0_PMS_CONSTRAIN_SRAM_WORLD_0_PMS_0 field.
	SENSITIVE_CORE_X_DRAM0_PMS_CONSTRAIN_1_CORE_X_DRAM0_PMS_CONSTRAIN_SRAM_WORLD_0_PMS_0_Pos = 0x0
	// Bit mask of CORE_X_DRAM0_PMS_CONSTRAIN_SRAM_WORLD_0_PMS_0 field.
	SENSITIVE_CORE_X_DRAM0_PMS_CONSTRAIN_1_CORE_X_DRAM0_PMS_CONSTRAIN_SRAM_WORLD_0_PMS_0_Msk = 0x3
	// Position of CORE_X_DRAM0_PMS_CONSTRAIN_SRAM_WORLD_0_PMS_1 field.
	SENSITIVE_CORE_X_DRAM0_PMS_CONSTRAIN_1_CORE_X_DRAM0_PMS_CONSTRAIN_SRAM_WORLD_0_PMS_1_Pos = 0x2
	// Bit mask of CORE_X_DRAM0_PMS_CONSTRAIN_SRAM_WORLD_0_PMS_1 field.
	SENSITIVE_CORE_X_DRAM0_PMS_CONSTRAIN_1_CORE_X_DRAM0_PMS_CONSTRAIN_SRAM_WORLD_0_PMS_1_Msk = 0xc
	// Position of CORE_X_DRAM0_PMS_CONSTRAIN_SRAM_WORLD_0_PMS_2 field.
	SENSITIVE_CORE_X_DRAM0_PMS_CONSTRAIN_1_CORE_X_DRAM0_PMS_CONSTRAIN_SRAM_WORLD_0_PMS_2_Pos = 0x4
	// Bit mask of CORE_X_DRAM0_PMS_CONSTRAIN_SRAM_WORLD_0_PMS_2 field.
	SENSITIVE_CORE_X_DRAM0_PMS_CONSTRAIN_1_CORE_X_DRAM0_PMS_CONSTRAIN_SRAM_WORLD_0_PMS_2_Msk = 0x30
	// Position of CORE_X_DRAM0_PMS_CONSTRAIN_SRAM_WORLD_0_PMS_3 field.
	SENSITIVE_CORE_X_DRAM0_PMS_CONSTRAIN_1_CORE_X_DRAM0_PMS_CONSTRAIN_SRAM_WORLD_0_PMS_3_Pos = 0x6
	// Bit mask of CORE_X_DRAM0_PMS_CONSTRAIN_SRAM_WORLD_0_PMS_3 field.
	SENSITIVE_CORE_X_DRAM0_PMS_CONSTRAIN_1_CORE_X_DRAM0_PMS_CONSTRAIN_SRAM_WORLD_0_PMS_3_Msk = 0xc0
	// Position of CORE_X_DRAM0_PMS_CONSTRAIN_SRAM_WORLD_1_PMS_0 field.
	SENSITIVE_CORE_X_DRAM0_PMS_CONSTRAIN_1_CORE_X_DRAM0_PMS_CONSTRAIN_SRAM_WORLD_1_PMS_0_Pos = 0xc
	// Bit mask of CORE_X_DRAM0_PMS_CONSTRAIN_SRAM_WORLD_1_PMS_0 field.
	SENSITIVE_CORE_X_DRAM0_PMS_CONSTRAIN_1_CORE_X_DRAM0_PMS_CONSTRAIN_SRAM_WORLD_1_PMS_0_Msk = 0x3000
	// Position of CORE_X_DRAM0_PMS_CONSTRAIN_SRAM_WORLD_1_PMS_1 field.
	SENSITIVE_CORE_X_DRAM0_PMS_CONSTRAIN_1_CORE_X_DRAM0_PMS_CONSTRAIN_SRAM_WORLD_1_PMS_1_Pos = 0xe
	// Bit mask of CORE_X_DRAM0_PMS_CONSTRAIN_SRAM_WORLD_1_PMS_1 field.
	SENSITIVE_CORE_X_DRAM0_PMS_CONSTRAIN_1_CORE_X_DRAM0_PMS_CONSTRAIN_SRAM_WORLD_1_PMS_1_Msk = 0xc000
	// Position of CORE_X_DRAM0_PMS_CONSTRAIN_SRAM_WORLD_1_PMS_2 field.
	SENSITIVE_CORE_X_DRAM0_PMS_CONSTRAIN_1_CORE_X_DRAM0_PMS_CONSTRAIN_SRAM_WORLD_1_PMS_2_Pos = 0x10
	// Bit mask of CORE_X_DRAM0_PMS_CONSTRAIN_SRAM_WORLD_1_PMS_2 field.
	SENSITIVE_CORE_X_DRAM0_PMS_CONSTRAIN_1_CORE_X_DRAM0_PMS_CONSTRAIN_SRAM_WORLD_1_PMS_2_Msk = 0x30000
	// Position of CORE_X_DRAM0_PMS_CONSTRAIN_SRAM_WORLD_1_PMS_3 field.
	SENSITIVE_CORE_X_DRAM0_PMS_CONSTRAIN_1_CORE_X_DRAM0_PMS_CONSTRAIN_SRAM_WORLD_1_PMS_3_Pos = 0x12
	// Bit mask of CORE_X_DRAM0_PMS_CONSTRAIN_SRAM_WORLD_1_PMS_3 field.
	SENSITIVE_CORE_X_DRAM0_PMS_CONSTRAIN_1_CORE_X_DRAM0_PMS_CONSTRAIN_SRAM_WORLD_1_PMS_3_Msk = 0xc0000
	// Position of CORE_X_DRAM0_PMS_CONSTRAIN_ROM_WORLD_0_PMS field.
	SENSITIVE_CORE_X_DRAM0_PMS_CONSTRAIN_1_CORE_X_DRAM0_PMS_CONSTRAIN_ROM_WORLD_0_PMS_Pos = 0x18
	// Bit mask of CORE_X_DRAM0_PMS_CONSTRAIN_ROM_WORLD_0_PMS field.
	SENSITIVE_CORE_X_DRAM0_PMS_CONSTRAIN_1_CORE_X_DRAM0_PMS_CONSTRAIN_ROM_WORLD_0_PMS_Msk = 0x3000000
	// Position of CORE_X_DRAM0_PMS_CONSTRAIN_ROM_WORLD_1_PMS field.
	SENSITIVE_CORE_X_DRAM0_PMS_CONSTRAIN_1_CORE_X_DRAM0_PMS_CONSTRAIN_ROM_WORLD_1_PMS_Pos = 0x1a
	// Bit mask of CORE_X_DRAM0_PMS_CONSTRAIN_ROM_WORLD_1_PMS field.
	SENSITIVE_CORE_X_DRAM0_PMS_CONSTRAIN_1_CORE_X_DRAM0_PMS_CONSTRAIN_ROM_WORLD_1_PMS_Msk = 0xc000000

	// CORE_0_DRAM0_PMS_MONITOR_0: SENSITIVE_CORE_0_DRAM0_PMS_MONITOR_0_REG
	// Position of CORE_0_DRAM0_PMS_MONITOR_LOCK field.
	SENSITIVE_CORE_0_DRAM0_PMS_MONITOR_0_CORE_0_DRAM0_PMS_MONITOR_LOCK_Pos = 0x0
	// Bit mask of CORE_0_DRAM0_PMS_MONITOR_LOCK field.
	SENSITIVE_CORE_0_DRAM0_PMS_MONITOR_0_CORE_0_DRAM0_PMS_MONITOR_LOCK_Msk = 0x1
	// Bit CORE_0_DRAM0_PMS_MONITOR_LOCK.
	SENSITIVE_CORE_0_DRAM0_PMS_MONITOR_0_CORE_0_DRAM0_PMS_MONITOR_LOCK = 0x1

	// CORE_0_DRAM0_PMS_MONITOR_1: SENSITIVE_CORE_0_DRAM0_PMS_MONITOR_1_REG
	// Position of CORE_0_DRAM0_PMS_MONITOR_VIOLATE_CLR field.
	SENSITIVE_CORE_0_DRAM0_PMS_MONITOR_1_CORE_0_DRAM0_PMS_MONITOR_VIOLATE_CLR_Pos = 0x0
	// Bit mask of CORE_0_DRAM0_PMS_MONITOR_VIOLATE_CLR field.
	SENSITIVE_CORE_0_DRAM0_PMS_MONITOR_1_CORE_0_DRAM0_PMS_MONITOR_VIOLATE_CLR_Msk = 0x1
	// Bit CORE_0_DRAM0_PMS_MONITOR_VIOLATE_CLR.
	SENSITIVE_CORE_0_DRAM0_PMS_MONITOR_1_CORE_0_DRAM0_PMS_MONITOR_VIOLATE_CLR = 0x1
	// Position of CORE_0_DRAM0_PMS_MONITOR_VIOLATE_EN field.
	SENSITIVE_CORE_0_DRAM0_PMS_MONITOR_1_CORE_0_DRAM0_PMS_MONITOR_VIOLATE_EN_Pos = 0x1
	// Bit mask of CORE_0_DRAM0_PMS_MONITOR_VIOLATE_EN field.
	SENSITIVE_CORE_0_DRAM0_PMS_MONITOR_1_CORE_0_DRAM0_PMS_MONITOR_VIOLATE_EN_Msk = 0x2
	// Bit CORE_0_DRAM0_PMS_MONITOR_VIOLATE_EN.
	SENSITIVE_CORE_0_DRAM0_PMS_MONITOR_1_CORE_0_DRAM0_PMS_MONITOR_VIOLATE_EN = 0x2

	// CORE_0_DRAM0_PMS_MONITOR_2: SENSITIVE_CORE_0_DRAM0_PMS_MONITOR_2_REG
	// Position of CORE_0_DRAM0_PMS_MONITOR_VIOLATE_INTR field.
	SENSITIVE_CORE_0_DRAM0_PMS_MONITOR_2_CORE_0_DRAM0_PMS_MONITOR_VIOLATE_INTR_Pos = 0x0
	// Bit mask of CORE_0_DRAM0_PMS_MONITOR_VIOLATE_INTR field.
	SENSITIVE_CORE_0_DRAM0_PMS_MONITOR_2_CORE_0_DRAM0_PMS_MONITOR_VIOLATE_INTR_Msk = 0x1
	// Bit CORE_0_DRAM0_PMS_MONITOR_VIOLATE_INTR.
	SENSITIVE_CORE_0_DRAM0_PMS_MONITOR_2_CORE_0_DRAM0_PMS_MONITOR_VIOLATE_INTR = 0x1
	// Position of CORE_0_DRAM0_PMS_MONITOR_VIOLATE_STATUS_LOCK field.
	SENSITIVE_CORE_0_DRAM0_PMS_MONITOR_2_CORE_0_DRAM0_PMS_MONITOR_VIOLATE_STATUS_LOCK_Pos = 0x1
	// Bit mask of CORE_0_DRAM0_PMS_MONITOR_VIOLATE_STATUS_LOCK field.
	SENSITIVE_CORE_0_DRAM0_PMS_MONITOR_2_CORE_0_DRAM0_PMS_MONITOR_VIOLATE_STATUS_LOCK_Msk = 0x2
	// Bit CORE_0_DRAM0_PMS_MONITOR_VIOLATE_STATUS_LOCK.
	SENSITIVE_CORE_0_DRAM0_PMS_MONITOR_2_CORE_0_DRAM0_PMS_MONITOR_VIOLATE_STATUS_LOCK = 0x2
	// Position of CORE_0_DRAM0_PMS_MONITOR_VIOLATE_STATUS_WORLD field.
	SENSITIVE_CORE_0_DRAM0_PMS_MONITOR_2_CORE_0_DRAM0_PMS_MONITOR_VIOLATE_STATUS_WORLD_Pos = 0x2
	// Bit mask of CORE_0_DRAM0_PMS_MONITOR_VIOLATE_STATUS_WORLD field.
	SENSITIVE_CORE_0_DRAM0_PMS_MONITOR_2_CORE_0_DRAM0_PMS_MONITOR_VIOLATE_STATUS_WORLD_Msk = 0xc
	// Position of CORE_0_DRAM0_PMS_MONITOR_VIOLATE_STATUS_ADDR field.
	SENSITIVE_CORE_0_DRAM0_PMS_MONITOR_2_CORE_0_DRAM0_PMS_MONITOR_VIOLATE_STATUS_ADDR_Pos = 0x4
	// Bit mask of CORE_0_DRAM0_PMS_MONITOR_VIOLATE_STATUS_ADDR field.
	SENSITIVE_CORE_0_DRAM0_PMS_MONITOR_2_CORE_0_DRAM0_PMS_MONITOR_VIOLATE_STATUS_ADDR_Msk = 0xffffff0

	// CORE_0_DRAM0_PMS_MONITOR_3: SENSITIVE_CORE_0_DRAM0_PMS_MONITOR_3_REG
	// Position of CORE_0_DRAM0_PMS_MONITOR_VIOLATE_STATUS_WR field.
	SENSITIVE_CORE_0_DRAM0_PMS_MONITOR_3_CORE_0_DRAM0_PMS_MONITOR_VIOLATE_STATUS_WR_Pos = 0x0
	// Bit mask of CORE_0_DRAM0_PMS_MONITOR_VIOLATE_STATUS_WR field.
	SENSITIVE_CORE_0_DRAM0_PMS_MONITOR_3_CORE_0_DRAM0_PMS_MONITOR_VIOLATE_STATUS_WR_Msk = 0x1
	// Bit CORE_0_DRAM0_PMS_MONITOR_VIOLATE_STATUS_WR.
	SENSITIVE_CORE_0_DRAM0_PMS_MONITOR_3_CORE_0_DRAM0_PMS_MONITOR_VIOLATE_STATUS_WR = 0x1
	// Position of CORE_0_DRAM0_PMS_MONITOR_VIOLATE_STATUS_BYTEEN field.
	SENSITIVE_CORE_0_DRAM0_PMS_MONITOR_3_CORE_0_DRAM0_PMS_MONITOR_VIOLATE_STATUS_BYTEEN_Pos = 0x1
	// Bit mask of CORE_0_DRAM0_PMS_MONITOR_VIOLATE_STATUS_BYTEEN field.
	SENSITIVE_CORE_0_DRAM0_PMS_MONITOR_3_CORE_0_DRAM0_PMS_MONITOR_VIOLATE_STATUS_BYTEEN_Msk = 0x1e

	// CORE_0_PIF_PMS_CONSTRAIN_0: SENSITIVE_CORE_0_PIF_PMS_CONSTRAIN_0_REG
	// Position of CORE_0_PIF_PMS_CONSTRAIN_LOCK field.
	SENSITIVE_CORE_0_PIF_PMS_CONSTRAIN_0_CORE_0_PIF_PMS_CONSTRAIN_LOCK_Pos = 0x0
	// Bit mask of CORE_0_PIF_PMS_CONSTRAIN_LOCK field.
	SENSITIVE_CORE_0_PIF_PMS_CONSTRAIN_0_CORE_0_PIF_PMS_CONSTRAIN_LOCK_Msk = 0x1
	// Bit CORE_0_PIF_PMS_CONSTRAIN_LOCK.
	SENSITIVE_CORE_0_PIF_PMS_CONSTRAIN_0_CORE_0_PIF_PMS_CONSTRAIN_LOCK = 0x1

	// CORE_0_PIF_PMS_CONSTRAIN_1: SENSITIVE_CORE_0_PIF_PMS_CONSTRAIN_1_REG
	// Position of CORE_0_PIF_PMS_CONSTRAIN_WORLD_0_UART field.
	SENSITIVE_CORE_0_PIF_PMS_CONSTRAIN_1_CORE_0_PIF_PMS_CONSTRAIN_WORLD_0_UART_Pos = 0x0
	// Bit mask of CORE_0_PIF_PMS_CONSTRAIN_WORLD_0_UART field.
	SENSITIVE_CORE_0_PIF_PMS_CONSTRAIN_1_CORE_0_PIF_PMS_CONSTRAIN_WORLD_0_UART_Msk = 0x3
	// Position of CORE_0_PIF_PMS_CONSTRAIN_WORLD_0_G0SPI_1 field.
	SENSITIVE_CORE_0_PIF_PMS_CONSTRAIN_1_CORE_0_PIF_PMS_CONSTRAIN_WORLD_0_G0SPI_1_Pos = 0x2
	// Bit mask of CORE_0_PIF_PMS_CONSTRAIN_WORLD_0_G0SPI_1 field.
	SENSITIVE_CORE_0_PIF_PMS_CONSTRAIN_1_CORE_0_PIF_PMS_CONSTRAIN_WORLD_0_G0SPI_1_Msk = 0xc
	// Position of CORE_0_PIF_PMS_CONSTRAIN_WORLD_0_G0SPI_0 field.
	SENSITIVE_CORE_0_PIF_PMS_CONSTRAIN_1_CORE_0_PIF_PMS_CONSTRAIN_WORLD_0_G0SPI_0_Pos = 0x4
	// Bit mask of CORE_0_PIF_PMS_CONSTRAIN_WORLD_0_G0SPI_0 field.
	SENSITIVE_CORE_0_PIF_PMS_CONSTRAIN_1_CORE_0_PIF_PMS_CONSTRAIN_WORLD_0_G0SPI_0_Msk = 0x30
	// Position of CORE_0_PIF_PMS_CONSTRAIN_WORLD_0_GPIO field.
	SENSITIVE_CORE_0_PIF_PMS_CONSTRAIN_1_CORE_0_PIF_PMS_CONSTRAIN_WORLD_0_GPIO_Pos = 0x6
	// Bit mask of CORE_0_PIF_PMS_CONSTRAIN_WORLD_0_GPIO field.
	SENSITIVE_CORE_0_PIF_PMS_CONSTRAIN_1_CORE_0_PIF_PMS_CONSTRAIN_WORLD_0_GPIO_Msk = 0xc0
	// Position of CORE_0_PIF_PMS_CONSTRAIN_WORLD_0_FE2 field.
	SENSITIVE_CORE_0_PIF_PMS_CONSTRAIN_1_CORE_0_PIF_PMS_CONSTRAIN_WORLD_0_FE2_Pos = 0x8
	// Bit mask of CORE_0_PIF_PMS_CONSTRAIN_WORLD_0_FE2 field.
	SENSITIVE_CORE_0_PIF_PMS_CONSTRAIN_1_CORE_0_PIF_PMS_CONSTRAIN_WORLD_0_FE2_Msk = 0x300
	// Position of CORE_0_PIF_PMS_CONSTRAIN_WORLD_0_FE field.
	SENSITIVE_CORE_0_PIF_PMS_CONSTRAIN_1_CORE_0_PIF_PMS_CONSTRAIN_WORLD_0_FE_Pos = 0xa
	// Bit mask of CORE_0_PIF_PMS_CONSTRAIN_WORLD_0_FE field.
	SENSITIVE_CORE_0_PIF_PMS_CONSTRAIN_1_CORE_0_PIF_PMS_CONSTRAIN_WORLD_0_FE_Msk = 0xc00
	// Position of CORE_0_PIF_PMS_CONSTRAIN_WORLD_0_TIMER field.
	SENSITIVE_CORE_0_PIF_PMS_CONSTRAIN_1_CORE_0_PIF_PMS_CONSTRAIN_WORLD_0_TIMER_Pos = 0xc
	// Bit mask of CORE_0_PIF_PMS_CONSTRAIN_WORLD_0_TIMER field.
	SENSITIVE_CORE_0_PIF_PMS_CONSTRAIN_1_CORE_0_PIF_PMS_CONSTRAIN_WORLD_0_TIMER_Msk = 0x3000
	// Position of CORE_0_PIF_PMS_CONSTRAIN_WORLD_0_RTC field.
	SENSITIVE_CORE_0_PIF_PMS_CONSTRAIN_1_CORE_0_PIF_PMS_CONSTRAIN_WORLD_0_RTC_Pos = 0xe
	// Bit mask of CORE_0_PIF_PMS_CONSTRAIN_WORLD_0_RTC field.
	SENSITIVE_CORE_0_PIF_PMS_CONSTRAIN_1_CORE_0_PIF_PMS_CONSTRAIN_WORLD_0_RTC_Msk = 0xc000
	// Position of CORE_0_PIF_PMS_CONSTRAIN_WORLD_0_IO_MUX field.
	SENSITIVE_CORE_0_PIF_PMS_CONSTRAIN_1_CORE_0_PIF_PMS_CONSTRAIN_WORLD_0_IO_MUX_Pos = 0x10
	// Bit mask of CORE_0_PIF_PMS_CONSTRAIN_WORLD_0_IO_MUX field.
	SENSITIVE_CORE_0_PIF_PMS_CONSTRAIN_1_CORE_0_PIF_PMS_CONSTRAIN_WORLD_0_IO_MUX_Msk = 0x30000
	// Position of CORE_0_PIF_PMS_CONSTRAIN_WORLD_0_WDG field.
	SENSITIVE_CORE_0_PIF_PMS_CONSTRAIN_1_CORE_0_PIF_PMS_CONSTRAIN_WORLD_0_WDG_Pos = 0x12
	// Bit mask of CORE_0_PIF_PMS_CONSTRAIN_WORLD_0_WDG field.
	SENSITIVE_CORE_0_PIF_PMS_CONSTRAIN_1_CORE_0_PIF_PMS_CONSTRAIN_WORLD_0_WDG_Msk = 0xc0000
	// Position of CORE_0_PIF_PMS_CONSTRAIN_WORLD_0_MISC field.
	SENSITIVE_CORE_0_PIF_PMS_CONSTRAIN_1_CORE_0_PIF_PMS_CONSTRAIN_WORLD_0_MISC_Pos = 0x18
	// Bit mask of CORE_0_PIF_PMS_CONSTRAIN_WORLD_0_MISC field.
	SENSITIVE_CORE_0_PIF_PMS_CONSTRAIN_1_CORE_0_PIF_PMS_CONSTRAIN_WORLD_0_MISC_Msk = 0x3000000
	// Position of CORE_0_PIF_PMS_CONSTRAIN_WORLD_0_I2C field.
	SENSITIVE_CORE_0_PIF_PMS_CONSTRAIN_1_CORE_0_PIF_PMS_CONSTRAIN_WORLD_0_I2C_Pos = 0x1a
	// Bit mask of CORE_0_PIF_PMS_CONSTRAIN_WORLD_0_I2C field.
	SENSITIVE_CORE_0_PIF_PMS_CONSTRAIN_1_CORE_0_PIF_PMS_CONSTRAIN_WORLD_0_I2C_Msk = 0xc000000
	// Position of CORE_0_PIF_PMS_CONSTRAIN_WORLD_0_UART1 field.
	SENSITIVE_CORE_0_PIF_PMS_CONSTRAIN_1_CORE_0_PIF_PMS_CONSTRAIN_WORLD_0_UART1_Pos = 0x1e
	// Bit mask of CORE_0_PIF_PMS_CONSTRAIN_WORLD_0_UART1 field.
	SENSITIVE_CORE_0_PIF_PMS_CONSTRAIN_1_CORE_0_PIF_PMS_CONSTRAIN_WORLD_0_UART1_Msk = 0xc0000000

	// CORE_0_PIF_PMS_CONSTRAIN_2: SENSITIVE_CORE_0_PIF_PMS_CONSTRAIN_2_REG
	// Position of CORE_0_PIF_PMS_CONSTRAIN_WORLD_0_BT field.
	SENSITIVE_CORE_0_PIF_PMS_CONSTRAIN_2_CORE_0_PIF_PMS_CONSTRAIN_WORLD_0_BT_Pos = 0x0
	// Bit mask of CORE_0_PIF_PMS_CONSTRAIN_WORLD_0_BT field.
	SENSITIVE_CORE_0_PIF_PMS_CONSTRAIN_2_CORE_0_PIF_PMS_CONSTRAIN_WORLD_0_BT_Msk = 0x3
	// Position of CORE_0_PIF_PMS_CONSTRAIN_WORLD_0_I2C_EXT0 field.
	SENSITIVE_CORE_0_PIF_PMS_CONSTRAIN_2_CORE_0_PIF_PMS_CONSTRAIN_WORLD_0_I2C_EXT0_Pos = 0x4
	// Bit mask of CORE_0_PIF_PMS_CONSTRAIN_WORLD_0_I2C_EXT0 field.
	SENSITIVE_CORE_0_PIF_PMS_CONSTRAIN_2_CORE_0_PIF_PMS_CONSTRAIN_WORLD_0_I2C_EXT0_Msk = 0x30
	// Position of CORE_0_PIF_PMS_CONSTRAIN_WORLD_0_UHCI0 field.
	SENSITIVE_CORE_0_PIF_PMS_CONSTRAIN_2_CORE_0_PIF_PMS_CONSTRAIN_WORLD_0_UHCI0_Pos = 0x6
	// Bit mask of CORE_0_PIF_PMS_CONSTRAIN_WORLD_0_UHCI0 field.
	SENSITIVE_CORE_0_PIF_PMS_CONSTRAIN_2_CORE_0_PIF_PMS_CONSTRAIN_WORLD_0_UHCI0_Msk = 0xc0
	// Position of CORE_0_PIF_PMS_CONSTRAIN_WORLD_0_RMT field.
	SENSITIVE_CORE_0_PIF_PMS_CONSTRAIN_2_CORE_0_PIF_PMS_CONSTRAIN_WORLD_0_RMT_Pos = 0xa
	// Bit mask of CORE_0_PIF_PMS_CONSTRAIN_WORLD_0_RMT field.
	SENSITIVE_CORE_0_PIF_PMS_CONSTRAIN_2_CORE_0_PIF_PMS_CONSTRAIN_WORLD_0_RMT_Msk = 0xc00
	// Position of CORE_0_PIF_PMS_CONSTRAIN_WORLD_0_LEDC field.
	SENSITIVE_CORE_0_PIF_PMS_CONSTRAIN_2_CORE_0_PIF_PMS_CONSTRAIN_WORLD_0_LEDC_Pos = 0x10
	// Bit mask of CORE_0_PIF_PMS_CONSTRAIN_WORLD_0_LEDC field.
	SENSITIVE_CORE_0_PIF_PMS_CONSTRAIN_2_CORE_0_PIF_PMS_CONSTRAIN_WORLD_0_LEDC_Msk = 0x30000
	// Position of CORE_0_PIF_PMS_CONSTRAIN_WORLD_0_BB field.
	SENSITIVE_CORE_0_PIF_PMS_CONSTRAIN_2_CORE_0_PIF_PMS_CONSTRAIN_WORLD_0_BB_Pos = 0x16
	// Bit mask of CORE_0_PIF_PMS_CONSTRAIN_WORLD_0_BB field.
	SENSITIVE_CORE_0_PIF_PMS_CONSTRAIN_2_CORE_0_PIF_PMS_CONSTRAIN_WORLD_0_BB_Msk = 0xc00000
	// Position of CORE_0_PIF_PMS_CONSTRAIN_WORLD_0_TIMERGROUP field.
	SENSITIVE_CORE_0_PIF_PMS_CONSTRAIN_2_CORE_0_PIF_PMS_CONSTRAIN_WORLD_0_TIMERGROUP_Pos = 0x1a
	// Bit mask of CORE_0_PIF_PMS_CONSTRAIN_WORLD_0_TIMERGROUP field.
	SENSITIVE_CORE_0_PIF_PMS_CONSTRAIN_2_CORE_0_PIF_PMS_CONSTRAIN_WORLD_0_TIMERGROUP_Msk = 0xc000000
	// Position of CORE_0_PIF_PMS_CONSTRAIN_WORLD_0_TIMERGROUP1 field.
	SENSITIVE_CORE_0_PIF_PMS_CONSTRAIN_2_CORE_0_PIF_PMS_CONSTRAIN_WORLD_0_TIMERGROUP1_Pos = 0x1c
	// Bit mask of CORE_0_PIF_PMS_CONSTRAIN_WORLD_0_TIMERGROUP1 field.
	SENSITIVE_CORE_0_PIF_PMS_CONSTRAIN_2_CORE_0_PIF_PMS_CONSTRAIN_WORLD_0_TIMERGROUP1_Msk = 0x30000000
	// Position of CORE_0_PIF_PMS_CONSTRAIN_WORLD_0_SYSTIMER field.
	SENSITIVE_CORE_0_PIF_PMS_CONSTRAIN_2_CORE_0_PIF_PMS_CONSTRAIN_WORLD_0_SYSTIMER_Pos = 0x1e
	// Bit mask of CORE_0_PIF_PMS_CONSTRAIN_WORLD_0_SYSTIMER field.
	SENSITIVE_CORE_0_PIF_PMS_CONSTRAIN_2_CORE_0_PIF_PMS_CONSTRAIN_WORLD_0_SYSTIMER_Msk = 0xc0000000

	// CORE_0_PIF_PMS_CONSTRAIN_3: SENSITIVE_CORE_0_PIF_PMS_CONSTRAIN_3_REG
	// Position of CORE_0_PIF_PMS_CONSTRAIN_WORLD_0_SPI_2 field.
	SENSITIVE_CORE_0_PIF_PMS_CONSTRAIN_3_CORE_0_PIF_PMS_CONSTRAIN_WORLD_0_SPI_2_Pos = 0x0
	// Bit mask of CORE_0_PIF_PMS_CONSTRAIN_WORLD_0_SPI_2 field.
	SENSITIVE_CORE_0_PIF_PMS_CONSTRAIN_3_CORE_0_PIF_PMS_CONSTRAIN_WORLD_0_SPI_2_Msk = 0x3
	// Position of CORE_0_PIF_PMS_CONSTRAIN_WORLD_0_APB_CTRL field.
	SENSITIVE_CORE_0_PIF_PMS_CONSTRAIN_3_CORE_0_PIF_PMS_CONSTRAIN_WORLD_0_APB_CTRL_Pos = 0x4
	// Bit mask of CORE_0_PIF_PMS_CONSTRAIN_WORLD_0_APB_CTRL field.
	SENSITIVE_CORE_0_PIF_PMS_CONSTRAIN_3_CORE_0_PIF_PMS_CONSTRAIN_WORLD_0_APB_CTRL_Msk = 0x30
	// Position of CORE_0_PIF_PMS_CONSTRAIN_WORLD_0_CAN field.
	SENSITIVE_CORE_0_PIF_PMS_CONSTRAIN_3_CORE_0_PIF_PMS_CONSTRAIN_WORLD_0_CAN_Pos = 0xa
	// Bit mask of CORE_0_PIF_PMS_CONSTRAIN_WORLD_0_CAN field.
	SENSITIVE_CORE_0_PIF_PMS_CONSTRAIN_3_CORE_0_PIF_PMS_CONSTRAIN_WORLD_0_CAN_Msk = 0xc00
	// Position of CORE_0_PIF_PMS_CONSTRAIN_WORLD_0_I2S1 field.
	SENSITIVE_CORE_0_PIF_PMS_CONSTRAIN_3_CORE_0_PIF_PMS_CONSTRAIN_WORLD_0_I2S1_Pos = 0xe
	// Bit mask of CORE_0_PIF_PMS_CONSTRAIN_WORLD_0_I2S1 field.
	SENSITIVE_CORE_0_PIF_PMS_CONSTRAIN_3_CORE_0_PIF_PMS_CONSTRAIN_WORLD_0_I2S1_Msk = 0xc000
	// Position of CORE_0_PIF_PMS_CONSTRAIN_WORLD_0_RWBT field.
	SENSITIVE_CORE_0_PIF_PMS_CONSTRAIN_3_CORE_0_PIF_PMS_CONSTRAIN_WORLD_0_RWBT_Pos = 0x16
	// Bit mask of CORE_0_PIF_PMS_CONSTRAIN_WORLD_0_RWBT field.
	SENSITIVE_CORE_0_PIF_PMS_CONSTRAIN_3_CORE_0_PIF_PMS_CONSTRAIN_WORLD_0_RWBT_Msk = 0xc00000
	// Position of CORE_0_PIF_PMS_CONSTRAIN_WORLD_0_WIFIMAC field.
	SENSITIVE_CORE_0_PIF_PMS_CONSTRAIN_3_CORE_0_PIF_PMS_CONSTRAIN_WORLD_0_WIFIMAC_Pos = 0x1a
	// Bit mask of CORE_0_PIF_PMS_CONSTRAIN_WORLD_0_WIFIMAC field.
	SENSITIVE_CORE_0_PIF_PMS_CONSTRAIN_3_CORE_0_PIF_PMS_CONSTRAIN_WORLD_0_WIFIMAC_Msk = 0xc000000
	// Position of CORE_0_PIF_PMS_CONSTRAIN_WORLD_0_PWR field.
	SENSITIVE_CORE_0_PIF_PMS_CONSTRAIN_3_CORE_0_PIF_PMS_CONSTRAIN_WORLD_0_PWR_Pos = 0x1c
	// Bit mask of CORE_0_PIF_PMS_CONSTRAIN_WORLD_0_PWR field.
	SENSITIVE_CORE_0_PIF_PMS_CONSTRAIN_3_CORE_0_PIF_PMS_CONSTRAIN_WORLD_0_PWR_Msk = 0x30000000

	// CORE_0_PIF_PMS_CONSTRAIN_4: SENSITIVE_CORE_0_PIF_PMS_CONSTRAIN_4_REG
	// Position of CORE_0_PIF_PMS_CONSTRAIN_WORLD_0_USB_WRAP field.
	SENSITIVE_CORE_0_PIF_PMS_CONSTRAIN_4_CORE_0_PIF_PMS_CONSTRAIN_WORLD_0_USB_WRAP_Pos = 0x2
	// Bit mask of CORE_0_PIF_PMS_CONSTRAIN_WORLD_0_USB_WRAP field.
	SENSITIVE_CORE_0_PIF_PMS_CONSTRAIN_4_CORE_0_PIF_PMS_CONSTRAIN_WORLD_0_USB_WRAP_Msk = 0xc
	// Position of CORE_0_PIF_PMS_CONSTRAIN_WORLD_0_CRYPTO_PERI field.
	SENSITIVE_CORE_0_PIF_PMS_CONSTRAIN_4_CORE_0_PIF_PMS_CONSTRAIN_WORLD_0_CRYPTO_PERI_Pos = 0x4
	// Bit mask of CORE_0_PIF_PMS_CONSTRAIN_WORLD_0_CRYPTO_PERI field.
	SENSITIVE_CORE_0_PIF_PMS_CONSTRAIN_4_CORE_0_PIF_PMS_CONSTRAIN_WORLD_0_CRYPTO_PERI_Msk = 0x30
	// Position of CORE_0_PIF_PMS_CONSTRAIN_WORLD_0_CRYPTO_DMA field.
	SENSITIVE_CORE_0_PIF_PMS_CONSTRAIN_4_CORE_0_PIF_PMS_CONSTRAIN_WORLD_0_CRYPTO_DMA_Pos = 0x6
	// Bit mask of CORE_0_PIF_PMS_CONSTRAIN_WORLD_0_CRYPTO_DMA field.
	SENSITIVE_CORE_0_PIF_PMS_CONSTRAIN_4_CORE_0_PIF_PMS_CONSTRAIN_WORLD_0_CRYPTO_DMA_Msk = 0xc0
	// Position of CORE_0_PIF_PMS_CONSTRAIN_WORLD_0_APB_ADC field.
	SENSITIVE_CORE_0_PIF_PMS_CONSTRAIN_4_CORE_0_PIF_PMS_CONSTRAIN_WORLD_0_APB_ADC_Pos = 0x8
	// Bit mask of CORE_0_PIF_PMS_CONSTRAIN_WORLD_0_APB_ADC field.
	SENSITIVE_CORE_0_PIF_PMS_CONSTRAIN_4_CORE_0_PIF_PMS_CONSTRAIN_WORLD_0_APB_ADC_Msk = 0x300
	// Position of CORE_0_PIF_PMS_CONSTRAIN_WORLD_0_BT_PWR field.
	SENSITIVE_CORE_0_PIF_PMS_CONSTRAIN_4_CORE_0_PIF_PMS_CONSTRAIN_WORLD_0_BT_PWR_Pos = 0xc
	// Bit mask of CORE_0_PIF_PMS_CONSTRAIN_WORLD_0_BT_PWR field.
	SENSITIVE_CORE_0_PIF_PMS_CONSTRAIN_4_CORE_0_PIF_PMS_CONSTRAIN_WORLD_0_BT_PWR_Msk = 0x3000
	// Position of CORE_0_PIF_PMS_CONSTRAIN_WORLD_0_USB_DEVICE field.
	SENSITIVE_CORE_0_PIF_PMS_CONSTRAIN_4_CORE_0_PIF_PMS_CONSTRAIN_WORLD_0_USB_DEVICE_Pos = 0xe
	// Bit mask of CORE_0_PIF_PMS_CONSTRAIN_WORLD_0_USB_DEVICE field.
	SENSITIVE_CORE_0_PIF_PMS_CONSTRAIN_4_CORE_0_PIF_PMS_CONSTRAIN_WORLD_0_USB_DEVICE_Msk = 0xc000
	// Position of CORE_0_PIF_PMS_CONSTRAIN_WORLD_0_SYSTEM field.
	SENSITIVE_CORE_0_PIF_PMS_CONSTRAIN_4_CORE_0_PIF_PMS_CONSTRAIN_WORLD_0_SYSTEM_Pos = 0x10
	// Bit mask of CORE_0_PIF_PMS_CONSTRAIN_WORLD_0_SYSTEM field.
	SENSITIVE_CORE_0_PIF_PMS_CONSTRAIN_4_CORE_0_PIF_PMS_CONSTRAIN_WORLD_0_SYSTEM_Msk = 0x30000
	// Position of CORE_0_PIF_PMS_CONSTRAIN_WORLD_0_SENSITIVE field.
	SENSITIVE_CORE_0_PIF_PMS_CONSTRAIN_4_CORE_0_PIF_PMS_CONSTRAIN_WORLD_0_SENSITIVE_Pos = 0x12
	// Bit mask of CORE_0_PIF_PMS_CONSTRAIN_WORLD_0_SENSITIVE field.
	SENSITIVE_CORE_0_PIF_PMS_CONSTRAIN_4_CORE_0_PIF_PMS_CONSTRAIN_WORLD_0_SENSITIVE_Msk = 0xc0000
	// Position of CORE_0_PIF_PMS_CONSTRAIN_WORLD_0_INTERRUPT field.
	SENSITIVE_CORE_0_PIF_PMS_CONSTRAIN_4_CORE_0_PIF_PMS_CONSTRAIN_WORLD_0_INTERRUPT_Pos = 0x14
	// Bit mask of CORE_0_PIF_PMS_CONSTRAIN_WORLD_0_INTERRUPT field.
	SENSITIVE_CORE_0_PIF_PMS_CONSTRAIN_4_CORE_0_PIF_PMS_CONSTRAIN_WORLD_0_INTERRUPT_Msk = 0x300000
	// Position of CORE_0_PIF_PMS_CONSTRAIN_WORLD_0_DMA_COPY field.
	SENSITIVE_CORE_0_PIF_PMS_CONSTRAIN_4_CORE_0_PIF_PMS_CONSTRAIN_WORLD_0_DMA_COPY_Pos = 0x16
	// Bit mask of CORE_0_PIF_PMS_CONSTRAIN_WORLD_0_DMA_COPY field.
	SENSITIVE_CORE_0_PIF_PMS_CONSTRAIN_4_CORE_0_PIF_PMS_CONSTRAIN_WORLD_0_DMA_COPY_Msk = 0xc00000
	// Position of CORE_0_PIF_PMS_CONSTRAIN_WORLD_0_CACHE_CONFIG field.
	SENSITIVE_CORE_0_PIF_PMS_CONSTRAIN_4_CORE_0_PIF_PMS_CONSTRAIN_WORLD_0_CACHE_CONFIG_Pos = 0x18
	// Bit mask of CORE_0_PIF_PMS_CONSTRAIN_WORLD_0_CACHE_CONFIG field.
	SENSITIVE_CORE_0_PIF_PMS_CONSTRAIN_4_CORE_0_PIF_PMS_CONSTRAIN_WORLD_0_CACHE_CONFIG_Msk = 0x3000000
	// Position of CORE_0_PIF_PMS_CONSTRAIN_WORLD_0_AD field.
	SENSITIVE_CORE_0_PIF_PMS_CONSTRAIN_4_CORE_0_PIF_PMS_CONSTRAIN_WORLD_0_AD_Pos = 0x1a
	// Bit mask of CORE_0_PIF_PMS_CONSTRAIN_WORLD_0_AD field.
	SENSITIVE_CORE_0_PIF_PMS_CONSTRAIN_4_CORE_0_PIF_PMS_CONSTRAIN_WORLD_0_AD_Msk = 0xc000000
	// Position of CORE_0_PIF_PMS_CONSTRAIN_WORLD_0_DIO field.
	SENSITIVE_CORE_0_PIF_PMS_CONSTRAIN_4_CORE_0_PIF_PMS_CONSTRAIN_WORLD_0_DIO_Pos = 0x1c
	// Bit mask of CORE_0_PIF_PMS_CONSTRAIN_WORLD_0_DIO field.
	SENSITIVE_CORE_0_PIF_PMS_CONSTRAIN_4_CORE_0_PIF_PMS_CONSTRAIN_WORLD_0_DIO_Msk = 0x30000000
	// Position of CORE_0_PIF_PMS_CONSTRAIN_WORLD_0_WORLD_CONTROLLER field.
	SENSITIVE_CORE_0_PIF_PMS_CONSTRAIN_4_CORE_0_PIF_PMS_CONSTRAIN_WORLD_0_WORLD_CONTROLLER_Pos = 0x1e
	// Bit mask of CORE_0_PIF_PMS_CONSTRAIN_WORLD_0_WORLD_CONTROLLER field.
	SENSITIVE_CORE_0_PIF_PMS_CONSTRAIN_4_CORE_0_PIF_PMS_CONSTRAIN_WORLD_0_WORLD_CONTROLLER_Msk = 0xc0000000

	// CORE_0_PIF_PMS_CONSTRAIN_5: SENSITIVE_CORE_0_PIF_PMS_CONSTRAIN_5_REG
	// Position of CORE_0_PIF_PMS_CONSTRAIN_WORLD_1_UART field.
	SENSITIVE_CORE_0_PIF_PMS_CONSTRAIN_5_CORE_0_PIF_PMS_CONSTRAIN_WORLD_1_UART_Pos = 0x0
	// Bit mask of CORE_0_PIF_PMS_CONSTRAIN_WORLD_1_UART field.
	SENSITIVE_CORE_0_PIF_PMS_CONSTRAIN_5_CORE_0_PIF_PMS_CONSTRAIN_WORLD_1_UART_Msk = 0x3
	// Position of CORE_0_PIF_PMS_CONSTRAIN_WORLD_1_G0SPI_1 field.
	SENSITIVE_CORE_0_PIF_PMS_CONSTRAIN_5_CORE_0_PIF_PMS_CONSTRAIN_WORLD_1_G0SPI_1_Pos = 0x2
	// Bit mask of CORE_0_PIF_PMS_CONSTRAIN_WORLD_1_G0SPI_1 field.
	SENSITIVE_CORE_0_PIF_PMS_CONSTRAIN_5_CORE_0_PIF_PMS_CONSTRAIN_WORLD_1_G0SPI_1_Msk = 0xc
	// Position of CORE_0_PIF_PMS_CONSTRAIN_WORLD_1_G0SPI_0 field.
	SENSITIVE_CORE_0_PIF_PMS_CONSTRAIN_5_CORE_0_PIF_PMS_CONSTRAIN_WORLD_1_G0SPI_0_Pos = 0x4
	// Bit mask of CORE_0_PIF_PMS_CONSTRAIN_WORLD_1_G0SPI_0 field.
	SENSITIVE_CORE_0_PIF_PMS_CONSTRAIN_5_CORE_0_PIF_PMS_CONSTRAIN_WORLD_1_G0SPI_0_Msk = 0x30
	// Position of CORE_0_PIF_PMS_CONSTRAIN_WORLD_1_GPIO field.
	SENSITIVE_CORE_0_PIF_PMS_CONSTRAIN_5_CORE_0_PIF_PMS_CONSTRAIN_WORLD_1_GPIO_Pos = 0x6
	// Bit mask of CORE_0_PIF_PMS_CONSTRAIN_WORLD_1_GPIO field.
	SENSITIVE_CORE_0_PIF_PMS_CONSTRAIN_5_CORE_0_PIF_PMS_CONSTRAIN_WORLD_1_GPIO_Msk = 0xc0
	// Position of CORE_0_PIF_PMS_CONSTRAIN_WORLD_1_FE2 field.
	SENSITIVE_CORE_0_PIF_PMS_CONSTRAIN_5_CORE_0_PIF_PMS_CONSTRAIN_WORLD_1_FE2_Pos = 0x8
	// Bit mask of CORE_0_PIF_PMS_CONSTRAIN_WORLD_1_FE2 field.
	SENSITIVE_CORE_0_PIF_PMS_CONSTRAIN_5_CORE_0_PIF_PMS_CONSTRAIN_WORLD_1_FE2_Msk = 0x300
	// Position of CORE_0_PIF_PMS_CONSTRAIN_WORLD_1_FE field.
	SENSITIVE_CORE_0_PIF_PMS_CONSTRAIN_5_CORE_0_PIF_PMS_CONSTRAIN_WORLD_1_FE_Pos = 0xa
	// Bit mask of CORE_0_PIF_PMS_CONSTRAIN_WORLD_1_FE field.
	SENSITIVE_CORE_0_PIF_PMS_CONSTRAIN_5_CORE_0_PIF_PMS_CONSTRAIN_WORLD_1_FE_Msk = 0xc00
	// Position of CORE_0_PIF_PMS_CONSTRAIN_WORLD_1_TIMER field.
	SENSITIVE_CORE_0_PIF_PMS_CONSTRAIN_5_CORE_0_PIF_PMS_CONSTRAIN_WORLD_1_TIMER_Pos = 0xc
	// Bit mask of CORE_0_PIF_PMS_CONSTRAIN_WORLD_1_TIMER field.
	SENSITIVE_CORE_0_PIF_PMS_CONSTRAIN_5_CORE_0_PIF_PMS_CONSTRAIN_WORLD_1_TIMER_Msk = 0x3000
	// Position of CORE_0_PIF_PMS_CONSTRAIN_WORLD_1_RTC field.
	SENSITIVE_CORE_0_PIF_PMS_CONSTRAIN_5_CORE_0_PIF_PMS_CONSTRAIN_WORLD_1_RTC_Pos = 0xe
	// Bit mask of CORE_0_PIF_PMS_CONSTRAIN_WORLD_1_RTC field.
	SENSITIVE_CORE_0_PIF_PMS_CONSTRAIN_5_CORE_0_PIF_PMS_CONSTRAIN_WORLD_1_RTC_Msk = 0xc000
	// Position of CORE_0_PIF_PMS_CONSTRAIN_WORLD_1_IO_MUX field.
	SENSITIVE_CORE_0_PIF_PMS_CONSTRAIN_5_CORE_0_PIF_PMS_CONSTRAIN_WORLD_1_IO_MUX_Pos = 0x10
	// Bit mask of CORE_0_PIF_PMS_CONSTRAIN_WORLD_1_IO_MUX field.
	SENSITIVE_CORE_0_PIF_PMS_CONSTRAIN_5_CORE_0_PIF_PMS_CONSTRAIN_WORLD_1_IO_MUX_Msk = 0x30000
	// Position of CORE_0_PIF_PMS_CONSTRAIN_WORLD_1_WDG field.
	SENSITIVE_CORE_0_PIF_PMS_CONSTRAIN_5_CORE_0_PIF_PMS_CONSTRAIN_WORLD_1_WDG_Pos = 0x12
	// Bit mask of CORE_0_PIF_PMS_CONSTRAIN_WORLD_1_WDG field.
	SENSITIVE_CORE_0_PIF_PMS_CONSTRAIN_5_CORE_0_PIF_PMS_CONSTRAIN_WORLD_1_WDG_Msk = 0xc0000
	// Position of CORE_0_PIF_PMS_CONSTRAIN_WORLD_1_MISC field.
	SENSITIVE_CORE_0_PIF_PMS_CONSTRAIN_5_CORE_0_PIF_PMS_CONSTRAIN_WORLD_1_MISC_Pos = 0x18
	// Bit mask of CORE_0_PIF_PMS_CONSTRAIN_WORLD_1_MISC field.
	SENSITIVE_CORE_0_PIF_PMS_CONSTRAIN_5_CORE_0_PIF_PMS_CONSTRAIN_WORLD_1_MISC_Msk = 0x3000000
	// Position of CORE_0_PIF_PMS_CONSTRAIN_WORLD_1_I2C field.
	SENSITIVE_CORE_0_PIF_PMS_CONSTRAIN_5_CORE_0_PIF_PMS_CONSTRAIN_WORLD_1_I2C_Pos = 0x1a
	// Bit mask of CORE_0_PIF_PMS_CONSTRAIN_WORLD_1_I2C field.
	SENSITIVE_CORE_0_PIF_PMS_CONSTRAIN_5_CORE_0_PIF_PMS_CONSTRAIN_WORLD_1_I2C_Msk = 0xc000000
	// Position of CORE_0_PIF_PMS_CONSTRAIN_WORLD_1_UART1 field.
	SENSITIVE_CORE_0_PIF_PMS_CONSTRAIN_5_CORE_0_PIF_PMS_CONSTRAIN_WORLD_1_UART1_Pos = 0x1e
	// Bit mask of CORE_0_PIF_PMS_CONSTRAIN_WORLD_1_UART1 field.
	SENSITIVE_CORE_0_PIF_PMS_CONSTRAIN_5_CORE_0_PIF_PMS_CONSTRAIN_WORLD_1_UART1_Msk = 0xc0000000

	// CORE_0_PIF_PMS_CONSTRAIN_6: SENSITIVE_CORE_0_PIF_PMS_CONSTRAIN_6_REG
	// Position of CORE_0_PIF_PMS_CONSTRAIN_WORLD_1_BT field.
	SENSITIVE_CORE_0_PIF_PMS_CONSTRAIN_6_CORE_0_PIF_PMS_CONSTRAIN_WORLD_1_BT_Pos = 0x0
	// Bit mask of CORE_0_PIF_PMS_CONSTRAIN_WORLD_1_BT field.
	SENSITIVE_CORE_0_PIF_PMS_CONSTRAIN_6_CORE_0_PIF_PMS_CONSTRAIN_WORLD_1_BT_Msk = 0x3
	// Position of CORE_0_PIF_PMS_CONSTRAIN_WORLD_1_I2C_EXT0 field.
	SENSITIVE_CORE_0_PIF_PMS_CONSTRAIN_6_CORE_0_PIF_PMS_CONSTRAIN_WORLD_1_I2C_EXT0_Pos = 0x4
	// Bit mask of CORE_0_PIF_PMS_CONSTRAIN_WORLD_1_I2C_EXT0 field.
	SENSITIVE_CORE_0_PIF_PMS_CONSTRAIN_6_CORE_0_PIF_PMS_CONSTRAIN_WORLD_1_I2C_EXT0_Msk = 0x30
	// Position of CORE_0_PIF_PMS_CONSTRAIN_WORLD_1_UHCI0 field.
	SENSITIVE_CORE_0_PIF_PMS_CONSTRAIN_6_CORE_0_PIF_PMS_CONSTRAIN_WORLD_1_UHCI0_Pos = 0x6
	// Bit mask of CORE_0_PIF_PMS_CONSTRAIN_WORLD_1_UHCI0 field.
	SENSITIVE_CORE_0_PIF_PMS_CONSTRAIN_6_CORE_0_PIF_PMS_CONSTRAIN_WORLD_1_UHCI0_Msk = 0xc0
	// Position of CORE_0_PIF_PMS_CONSTRAIN_WORLD_1_RMT field.
	SENSITIVE_CORE_0_PIF_PMS_CONSTRAIN_6_CORE_0_PIF_PMS_CONSTRAIN_WORLD_1_RMT_Pos = 0xa
	// Bit mask of CORE_0_PIF_PMS_CONSTRAIN_WORLD_1_RMT field.
	SENSITIVE_CORE_0_PIF_PMS_CONSTRAIN_6_CORE_0_PIF_PMS_CONSTRAIN_WORLD_1_RMT_Msk = 0xc00
	// Position of CORE_0_PIF_PMS_CONSTRAIN_WORLD_1_LEDC field.
	SENSITIVE_CORE_0_PIF_PMS_CONSTRAIN_6_CORE_0_PIF_PMS_CONSTRAIN_WORLD_1_LEDC_Pos = 0x10
	// Bit mask of CORE_0_PIF_PMS_CONSTRAIN_WORLD_1_LEDC field.
	SENSITIVE_CORE_0_PIF_PMS_CONSTRAIN_6_CORE_0_PIF_PMS_CONSTRAIN_WORLD_1_LEDC_Msk = 0x30000
	// Position of CORE_0_PIF_PMS_CONSTRAIN_WORLD_1_BB field.
	SENSITIVE_CORE_0_PIF_PMS_CONSTRAIN_6_CORE_0_PIF_PMS_CONSTRAIN_WORLD_1_BB_Pos = 0x16
	// Bit mask of CORE_0_PIF_PMS_CONSTRAIN_WORLD_1_BB field.
	SENSITIVE_CORE_0_PIF_PMS_CONSTRAIN_6_CORE_0_PIF_PMS_CONSTRAIN_WORLD_1_BB_Msk = 0xc00000
	// Position of CORE_0_PIF_PMS_CONSTRAIN_WORLD_1_TIMERGROUP field.
	SENSITIVE_CORE_0_PIF_PMS_CONSTRAIN_6_CORE_0_PIF_PMS_CONSTRAIN_WORLD_1_TIMERGROUP_Pos = 0x1a
	// Bit mask of CORE_0_PIF_PMS_CONSTRAIN_WORLD_1_TIMERGROUP field.
	SENSITIVE_CORE_0_PIF_PMS_CONSTRAIN_6_CORE_0_PIF_PMS_CONSTRAIN_WORLD_1_TIMERGROUP_Msk = 0xc000000
	// Position of CORE_0_PIF_PMS_CONSTRAIN_WORLD_1_TIMERGROUP1 field.
	SENSITIVE_CORE_0_PIF_PMS_CONSTRAIN_6_CORE_0_PIF_PMS_CONSTRAIN_WORLD_1_TIMERGROUP1_Pos = 0x1c
	// Bit mask of CORE_0_PIF_PMS_CONSTRAIN_WORLD_1_TIMERGROUP1 field.
	SENSITIVE_CORE_0_PIF_PMS_CONSTRAIN_6_CORE_0_PIF_PMS_CONSTRAIN_WORLD_1_TIMERGROUP1_Msk = 0x30000000
	// Position of CORE_0_PIF_PMS_CONSTRAIN_WORLD_1_SYSTIMER field.
	SENSITIVE_CORE_0_PIF_PMS_CONSTRAIN_6_CORE_0_PIF_PMS_CONSTRAIN_WORLD_1_SYSTIMER_Pos = 0x1e
	// Bit mask of CORE_0_PIF_PMS_CONSTRAIN_WORLD_1_SYSTIMER field.
	SENSITIVE_CORE_0_PIF_PMS_CONSTRAIN_6_CORE_0_PIF_PMS_CONSTRAIN_WORLD_1_SYSTIMER_Msk = 0xc0000000

	// CORE_0_PIF_PMS_CONSTRAIN_7: SENSITIVE_CORE_0_PIF_PMS_CONSTRAIN_7_REG
	// Position of CORE_0_PIF_PMS_CONSTRAIN_WORLD_1_SPI_2 field.
	SENSITIVE_CORE_0_PIF_PMS_CONSTRAIN_7_CORE_0_PIF_PMS_CONSTRAIN_WORLD_1_SPI_2_Pos = 0x0
	// Bit mask of CORE_0_PIF_PMS_CONSTRAIN_WORLD_1_SPI_2 field.
	SENSITIVE_CORE_0_PIF_PMS_CONSTRAIN_7_CORE_0_PIF_PMS_CONSTRAIN_WORLD_1_SPI_2_Msk = 0x3
	// Position of CORE_0_PIF_PMS_CONSTRAIN_WORLD_1_APB_CTRL field.
	SENSITIVE_CORE_0_PIF_PMS_CONSTRAIN_7_CORE_0_PIF_PMS_CONSTRAIN_WORLD_1_APB_CTRL_Pos = 0x4
	// Bit mask of CORE_0_PIF_PMS_CONSTRAIN_WORLD_1_APB_CTRL field.
	SENSITIVE_CORE_0_PIF_PMS_CONSTRAIN_7_CORE_0_PIF_PMS_CONSTRAIN_WORLD_1_APB_CTRL_Msk = 0x30
	// Position of CORE_0_PIF_PMS_CONSTRAIN_WORLD_1_CAN field.
	SENSITIVE_CORE_0_PIF_PMS_CONSTRAIN_7_CORE_0_PIF_PMS_CONSTRAIN_WORLD_1_CAN_Pos = 0xa
	// Bit mask of CORE_0_PIF_PMS_CONSTRAIN_WORLD_1_CAN field.
	SENSITIVE_CORE_0_PIF_PMS_CONSTRAIN_7_CORE_0_PIF_PMS_CONSTRAIN_WORLD_1_CAN_Msk = 0xc00
	// Position of CORE_0_PIF_PMS_CONSTRAIN_WORLD_1_I2S1 field.
	SENSITIVE_CORE_0_PIF_PMS_CONSTRAIN_7_CORE_0_PIF_PMS_CONSTRAIN_WORLD_1_I2S1_Pos = 0xe
	// Bit mask of CORE_0_PIF_PMS_CONSTRAIN_WORLD_1_I2S1 field.
	SENSITIVE_CORE_0_PIF_PMS_CONSTRAIN_7_CORE_0_PIF_PMS_CONSTRAIN_WORLD_1_I2S1_Msk = 0xc000
	// Position of CORE_0_PIF_PMS_CONSTRAIN_WORLD_1_RWBT field.
	SENSITIVE_CORE_0_PIF_PMS_CONSTRAIN_7_CORE_0_PIF_PMS_CONSTRAIN_WORLD_1_RWBT_Pos = 0x16
	// Bit mask of CORE_0_PIF_PMS_CONSTRAIN_WORLD_1_RWBT field.
	SENSITIVE_CORE_0_PIF_PMS_CONSTRAIN_7_CORE_0_PIF_PMS_CONSTRAIN_WORLD_1_RWBT_Msk = 0xc00000
	// Position of CORE_0_PIF_PMS_CONSTRAIN_WORLD_1_WIFIMAC field.
	SENSITIVE_CORE_0_PIF_PMS_CONSTRAIN_7_CORE_0_PIF_PMS_CONSTRAIN_WORLD_1_WIFIMAC_Pos = 0x1a
	// Bit mask of CORE_0_PIF_PMS_CONSTRAIN_WORLD_1_WIFIMAC field.
	SENSITIVE_CORE_0_PIF_PMS_CONSTRAIN_7_CORE_0_PIF_PMS_CONSTRAIN_WORLD_1_WIFIMAC_Msk = 0xc000000
	// Position of CORE_0_PIF_PMS_CONSTRAIN_WORLD_1_PWR field.
	SENSITIVE_CORE_0_PIF_PMS_CONSTRAIN_7_CORE_0_PIF_PMS_CONSTRAIN_WORLD_1_PWR_Pos = 0x1c
	// Bit mask of CORE_0_PIF_PMS_CONSTRAIN_WORLD_1_PWR field.
	SENSITIVE_CORE_0_PIF_PMS_CONSTRAIN_7_CORE_0_PIF_PMS_CONSTRAIN_WORLD_1_PWR_Msk = 0x30000000

	// CORE_0_PIF_PMS_CONSTRAIN_8: SENSITIVE_CORE_0_PIF_PMS_CONSTRAIN_8_REG
	// Position of CORE_0_PIF_PMS_CONSTRAIN_WORLD_1_USB_WRAP field.
	SENSITIVE_CORE_0_PIF_PMS_CONSTRAIN_8_CORE_0_PIF_PMS_CONSTRAIN_WORLD_1_USB_WRAP_Pos = 0x2
	// Bit mask of CORE_0_PIF_PMS_CONSTRAIN_WORLD_1_USB_WRAP field.
	SENSITIVE_CORE_0_PIF_PMS_CONSTRAIN_8_CORE_0_PIF_PMS_CONSTRAIN_WORLD_1_USB_WRAP_Msk = 0xc
	// Position of CORE_0_PIF_PMS_CONSTRAIN_WORLD_1_CRYPTO_PERI field.
	SENSITIVE_CORE_0_PIF_PMS_CONSTRAIN_8_CORE_0_PIF_PMS_CONSTRAIN_WORLD_1_CRYPTO_PERI_Pos = 0x4
	// Bit mask of CORE_0_PIF_PMS_CONSTRAIN_WORLD_1_CRYPTO_PERI field.
	SENSITIVE_CORE_0_PIF_PMS_CONSTRAIN_8_CORE_0_PIF_PMS_CONSTRAIN_WORLD_1_CRYPTO_PERI_Msk = 0x30
	// Position of CORE_0_PIF_PMS_CONSTRAIN_WORLD_1_CRYPTO_DMA field.
	SENSITIVE_CORE_0_PIF_PMS_CONSTRAIN_8_CORE_0_PIF_PMS_CONSTRAIN_WORLD_1_CRYPTO_DMA_Pos = 0x6
	// Bit mask of CORE_0_PIF_PMS_CONSTRAIN_WORLD_1_CRYPTO_DMA field.
	SENSITIVE_CORE_0_PIF_PMS_CONSTRAIN_8_CORE_0_PIF_PMS_CONSTRAIN_WORLD_1_CRYPTO_DMA_Msk = 0xc0
	// Position of CORE_0_PIF_PMS_CONSTRAIN_WORLD_1_APB_ADC field.
	SENSITIVE_CORE_0_PIF_PMS_CONSTRAIN_8_CORE_0_PIF_PMS_CONSTRAIN_WORLD_1_APB_ADC_Pos = 0x8
	// Bit mask of CORE_0_PIF_PMS_CONSTRAIN_WORLD_1_APB_ADC field.
	SENSITIVE_CORE_0_PIF_PMS_CONSTRAIN_8_CORE_0_PIF_PMS_CONSTRAIN_WORLD_1_APB_ADC_Msk = 0x300
	// Position of CORE_0_PIF_PMS_CONSTRAIN_WORLD_1_BT_PWR field.
	SENSITIVE_CORE_0_PIF_PMS_CONSTRAIN_8_CORE_0_PIF_PMS_CONSTRAIN_WORLD_1_BT_PWR_Pos = 0xc
	// Bit mask of CORE_0_PIF_PMS_CONSTRAIN_WORLD_1_BT_PWR field.
	SENSITIVE_CORE_0_PIF_PMS_CONSTRAIN_8_CORE_0_PIF_PMS_CONSTRAIN_WORLD_1_BT_PWR_Msk = 0x3000
	// Position of CORE_0_PIF_PMS_CONSTRAIN_WORLD_1_USB_DEVICE field.
	SENSITIVE_CORE_0_PIF_PMS_CONSTRAIN_8_CORE_0_PIF_PMS_CONSTRAIN_WORLD_1_USB_DEVICE_Pos = 0xe
	// Bit mask of CORE_0_PIF_PMS_CONSTRAIN_WORLD_1_USB_DEVICE field.
	SENSITIVE_CORE_0_PIF_PMS_CONSTRAIN_8_CORE_0_PIF_PMS_CONSTRAIN_WORLD_1_USB_DEVICE_Msk = 0xc000
	// Position of CORE_0_PIF_PMS_CONSTRAIN_WORLD_1_SYSTEM field.
	SENSITIVE_CORE_0_PIF_PMS_CONSTRAIN_8_CORE_0_PIF_PMS_CONSTRAIN_WORLD_1_SYSTEM_Pos = 0x10
	// Bit mask of CORE_0_PIF_PMS_CONSTRAIN_WORLD_1_SYSTEM field.
	SENSITIVE_CORE_0_PIF_PMS_CONSTRAIN_8_CORE_0_PIF_PMS_CONSTRAIN_WORLD_1_SYSTEM_Msk = 0x30000
	// Position of CORE_0_PIF_PMS_CONSTRAIN_WORLD_1_SENSITIVE field.
	SENSITIVE_CORE_0_PIF_PMS_CONSTRAIN_8_CORE_0_PIF_PMS_CONSTRAIN_WORLD_1_SENSITIVE_Pos = 0x12
	// Bit mask of CORE_0_PIF_PMS_CONSTRAIN_WORLD_1_SENSITIVE field.
	SENSITIVE_CORE_0_PIF_PMS_CONSTRAIN_8_CORE_0_PIF_PMS_CONSTRAIN_WORLD_1_SENSITIVE_Msk = 0xc0000
	// Position of CORE_0_PIF_PMS_CONSTRAIN_WORLD_1_INTERRUPT field.
	SENSITIVE_CORE_0_PIF_PMS_CONSTRAIN_8_CORE_0_PIF_PMS_CONSTRAIN_WORLD_1_INTERRUPT_Pos = 0x14
	// Bit mask of CORE_0_PIF_PMS_CONSTRAIN_WORLD_1_INTERRUPT field.
	SENSITIVE_CORE_0_PIF_PMS_CONSTRAIN_8_CORE_0_PIF_PMS_CONSTRAIN_WORLD_1_INTERRUPT_Msk = 0x300000
	// Position of CORE_0_PIF_PMS_CONSTRAIN_WORLD_1_DMA_COPY field.
	SENSITIVE_CORE_0_PIF_PMS_CONSTRAIN_8_CORE_0_PIF_PMS_CONSTRAIN_WORLD_1_DMA_COPY_Pos = 0x16
	// Bit mask of CORE_0_PIF_PMS_CONSTRAIN_WORLD_1_DMA_COPY field.
	SENSITIVE_CORE_0_PIF_PMS_CONSTRAIN_8_CORE_0_PIF_PMS_CONSTRAIN_WORLD_1_DMA_COPY_Msk = 0xc00000
	// Position of CORE_0_PIF_PMS_CONSTRAIN_WORLD_1_CACHE_CONFIG field.
	SENSITIVE_CORE_0_PIF_PMS_CONSTRAIN_8_CORE_0_PIF_PMS_CONSTRAIN_WORLD_1_CACHE_CONFIG_Pos = 0x18
	// Bit mask of CORE_0_PIF_PMS_CONSTRAIN_WORLD_1_CACHE_CONFIG field.
	SENSITIVE_CORE_0_PIF_PMS_CONSTRAIN_8_CORE_0_PIF_PMS_CONSTRAIN_WORLD_1_CACHE_CONFIG_Msk = 0x3000000
	// Position of CORE_0_PIF_PMS_CONSTRAIN_WORLD_1_AD field.
	SENSITIVE_CORE_0_PIF_PMS_CONSTRAIN_8_CORE_0_PIF_PMS_CONSTRAIN_WORLD_1_AD_Pos = 0x1a
	// Bit mask of CORE_0_PIF_PMS_CONSTRAIN_WORLD_1_AD field.
	SENSITIVE_CORE_0_PIF_PMS_CONSTRAIN_8_CORE_0_PIF_PMS_CONSTRAIN_WORLD_1_AD_Msk = 0xc000000
	// Position of CORE_0_PIF_PMS_CONSTRAIN_WORLD_1_DIO field.
	SENSITIVE_CORE_0_PIF_PMS_CONSTRAIN_8_CORE_0_PIF_PMS_CONSTRAIN_WORLD_1_DIO_Pos = 0x1c
	// Bit mask of CORE_0_PIF_PMS_CONSTRAIN_WORLD_1_DIO field.
	SENSITIVE_CORE_0_PIF_PMS_CONSTRAIN_8_CORE_0_PIF_PMS_CONSTRAIN_WORLD_1_DIO_Msk = 0x30000000
	// Position of CORE_0_PIF_PMS_CONSTRAIN_WORLD_1_WORLD_CONTROLLER field.
	SENSITIVE_CORE_0_PIF_PMS_CONSTRAIN_8_CORE_0_PIF_PMS_CONSTRAIN_WORLD_1_WORLD_CONTROLLER_Pos = 0x1e
	// Bit mask of CORE_0_PIF_PMS_CONSTRAIN_WORLD_1_WORLD_CONTROLLER field.
	SENSITIVE_CORE_0_PIF_PMS_CONSTRAIN_8_CORE_0_PIF_PMS_CONSTRAIN_WORLD_1_WORLD_CONTROLLER_Msk = 0xc0000000

	// CORE_0_PIF_PMS_CONSTRAIN_9: SENSITIVE_CORE_0_PIF_PMS_CONSTRAIN_9_REG
	// Position of CORE_0_PIF_PMS_CONSTRAIN_RTCFAST_SPLTADDR_WORLD_0 field.
	SENSITIVE_CORE_0_PIF_PMS_CONSTRAIN_9_CORE_0_PIF_PMS_CONSTRAIN_RTCFAST_SPLTADDR_WORLD_0_Pos = 0x0
	// Bit mask of CORE_0_PIF_PMS_CONSTRAIN_RTCFAST_SPLTADDR_WORLD_0 field.
	SENSITIVE_CORE_0_PIF_PMS_CONSTRAIN_9_CORE_0_PIF_PMS_CONSTRAIN_RTCFAST_SPLTADDR_WORLD_0_Msk = 0x7ff
	// Position of CORE_0_PIF_PMS_CONSTRAIN_RTCFAST_SPLTADDR_WORLD_1 field.
	SENSITIVE_CORE_0_PIF_PMS_CONSTRAIN_9_CORE_0_PIF_PMS_CONSTRAIN_RTCFAST_SPLTADDR_WORLD_1_Pos = 0xb
	// Bit mask of CORE_0_PIF_PMS_CONSTRAIN_RTCFAST_SPLTADDR_WORLD_1 field.
	SENSITIVE_CORE_0_PIF_PMS_CONSTRAIN_9_CORE_0_PIF_PMS_CONSTRAIN_RTCFAST_SPLTADDR_WORLD_1_Msk = 0x3ff800

	// CORE_0_PIF_PMS_CONSTRAIN_10: SENSITIVE_CORE_0_PIF_PMS_CONSTRAIN_10_REG
	// Position of CORE_0_PIF_PMS_CONSTRAIN_RTCFAST_WORLD_0_L field.
	SENSITIVE_CORE_0_PIF_PMS_CONSTRAIN_10_CORE_0_PIF_PMS_CONSTRAIN_RTCFAST_WORLD_0_L_Pos = 0x0
	// Bit mask of CORE_0_PIF_PMS_CONSTRAIN_RTCFAST_WORLD_0_L field.
	SENSITIVE_CORE_0_PIF_PMS_CONSTRAIN_10_CORE_0_PIF_PMS_CONSTRAIN_RTCFAST_WORLD_0_L_Msk = 0x7
	// Position of CORE_0_PIF_PMS_CONSTRAIN_RTCFAST_WORLD_0_H field.
	SENSITIVE_CORE_0_PIF_PMS_CONSTRAIN_10_CORE_0_PIF_PMS_CONSTRAIN_RTCFAST_WORLD_0_H_Pos = 0x3
	// Bit mask of CORE_0_PIF_PMS_CONSTRAIN_RTCFAST_WORLD_0_H field.
	SENSITIVE_CORE_0_PIF_PMS_CONSTRAIN_10_CORE_0_PIF_PMS_CONSTRAIN_RTCFAST_WORLD_0_H_Msk = 0x38
	// Position of CORE_0_PIF_PMS_CONSTRAIN_RTCFAST_WORLD_1_L field.
	SENSITIVE_CORE_0_PIF_PMS_CONSTRAIN_10_CORE_0_PIF_PMS_CONSTRAIN_RTCFAST_WORLD_1_L_Pos = 0x6
	// Bit mask of CORE_0_PIF_PMS_CONSTRAIN_RTCFAST_WORLD_1_L field.
	SENSITIVE_CORE_0_PIF_PMS_CONSTRAIN_10_CORE_0_PIF_PMS_CONSTRAIN_RTCFAST_WORLD_1_L_Msk = 0x1c0
	// Position of CORE_0_PIF_PMS_CONSTRAIN_RTCFAST_WORLD_1_H field.
	SENSITIVE_CORE_0_PIF_PMS_CONSTRAIN_10_CORE_0_PIF_PMS_CONSTRAIN_RTCFAST_WORLD_1_H_Pos = 0x9
	// Bit mask of CORE_0_PIF_PMS_CONSTRAIN_RTCFAST_WORLD_1_H field.
	SENSITIVE_CORE_0_PIF_PMS_CONSTRAIN_10_CORE_0_PIF_PMS_CONSTRAIN_RTCFAST_WORLD_1_H_Msk = 0xe00

	// REGION_PMS_CONSTRAIN_0: SENSITIVE_REGION_PMS_CONSTRAIN_0_REG
	// Position of REGION_PMS_CONSTRAIN_LOCK field.
	SENSITIVE_REGION_PMS_CONSTRAIN_0_REGION_PMS_CONSTRAIN_LOCK_Pos = 0x0
	// Bit mask of REGION_PMS_CONSTRAIN_LOCK field.
	SENSITIVE_REGION_PMS_CONSTRAIN_0_REGION_PMS_CONSTRAIN_LOCK_Msk = 0x1
	// Bit REGION_PMS_CONSTRAIN_LOCK.
	SENSITIVE_REGION_PMS_CONSTRAIN_0_REGION_PMS_CONSTRAIN_LOCK = 0x1

	// REGION_PMS_CONSTRAIN_1: SENSITIVE_REGION_PMS_CONSTRAIN_1_REG
	// Position of REGION_PMS_CONSTRAIN_WORLD_0_AREA_0 field.
	SENSITIVE_REGION_PMS_CONSTRAIN_1_REGION_PMS_CONSTRAIN_WORLD_0_AREA_0_Pos = 0x0
	// Bit mask of REGION_PMS_CONSTRAIN_WORLD_0_AREA_0 field.
	SENSITIVE_REGION_PMS_CONSTRAIN_1_REGION_PMS_CONSTRAIN_WORLD_0_AREA_0_Msk = 0x3
	// Position of REGION_PMS_CONSTRAIN_WORLD_0_AREA_1 field.
	SENSITIVE_REGION_PMS_CONSTRAIN_1_REGION_PMS_CONSTRAIN_WORLD_0_AREA_1_Pos = 0x2
	// Bit mask of REGION_PMS_CONSTRAIN_WORLD_0_AREA_1 field.
	SENSITIVE_REGION_PMS_CONSTRAIN_1_REGION_PMS_CONSTRAIN_WORLD_0_AREA_1_Msk = 0xc
	// Position of REGION_PMS_CONSTRAIN_WORLD_0_AREA_2 field.
	SENSITIVE_REGION_PMS_CONSTRAIN_1_REGION_PMS_CONSTRAIN_WORLD_0_AREA_2_Pos = 0x4
	// Bit mask of REGION_PMS_CONSTRAIN_WORLD_0_AREA_2 field.
	SENSITIVE_REGION_PMS_CONSTRAIN_1_REGION_PMS_CONSTRAIN_WORLD_0_AREA_2_Msk = 0x30
	// Position of REGION_PMS_CONSTRAIN_WORLD_0_AREA_3 field.
	SENSITIVE_REGION_PMS_CONSTRAIN_1_REGION_PMS_CONSTRAIN_WORLD_0_AREA_3_Pos = 0x6
	// Bit mask of REGION_PMS_CONSTRAIN_WORLD_0_AREA_3 field.
	SENSITIVE_REGION_PMS_CONSTRAIN_1_REGION_PMS_CONSTRAIN_WORLD_0_AREA_3_Msk = 0xc0
	// Position of REGION_PMS_CONSTRAIN_WORLD_0_AREA_4 field.
	SENSITIVE_REGION_PMS_CONSTRAIN_1_REGION_PMS_CONSTRAIN_WORLD_0_AREA_4_Pos = 0x8
	// Bit mask of REGION_PMS_CONSTRAIN_WORLD_0_AREA_4 field.
	SENSITIVE_REGION_PMS_CONSTRAIN_1_REGION_PMS_CONSTRAIN_WORLD_0_AREA_4_Msk = 0x300
	// Position of REGION_PMS_CONSTRAIN_WORLD_0_AREA_5 field.
	SENSITIVE_REGION_PMS_CONSTRAIN_1_REGION_PMS_CONSTRAIN_WORLD_0_AREA_5_Pos = 0xa
	// Bit mask of REGION_PMS_CONSTRAIN_WORLD_0_AREA_5 field.
	SENSITIVE_REGION_PMS_CONSTRAIN_1_REGION_PMS_CONSTRAIN_WORLD_0_AREA_5_Msk = 0xc00
	// Position of REGION_PMS_CONSTRAIN_WORLD_0_AREA_6 field.
	SENSITIVE_REGION_PMS_CONSTRAIN_1_REGION_PMS_CONSTRAIN_WORLD_0_AREA_6_Pos = 0xc
	// Bit mask of REGION_PMS_CONSTRAIN_WORLD_0_AREA_6 field.
	SENSITIVE_REGION_PMS_CONSTRAIN_1_REGION_PMS_CONSTRAIN_WORLD_0_AREA_6_Msk = 0x3000

	// REGION_PMS_CONSTRAIN_2: SENSITIVE_REGION_PMS_CONSTRAIN_2_REG
	// Position of REGION_PMS_CONSTRAIN_WORLD_1_AREA_0 field.
	SENSITIVE_REGION_PMS_CONSTRAIN_2_REGION_PMS_CONSTRAIN_WORLD_1_AREA_0_Pos = 0x0
	// Bit mask of REGION_PMS_CONSTRAIN_WORLD_1_AREA_0 field.
	SENSITIVE_REGION_PMS_CONSTRAIN_2_REGION_PMS_CONSTRAIN_WORLD_1_AREA_0_Msk = 0x3
	// Position of REGION_PMS_CONSTRAIN_WORLD_1_AREA_1 field.
	SENSITIVE_REGION_PMS_CONSTRAIN_2_REGION_PMS_CONSTRAIN_WORLD_1_AREA_1_Pos = 0x2
	// Bit mask of REGION_PMS_CONSTRAIN_WORLD_1_AREA_1 field.
	SENSITIVE_REGION_PMS_CONSTRAIN_2_REGION_PMS_CONSTRAIN_WORLD_1_AREA_1_Msk = 0xc
	// Position of REGION_PMS_CONSTRAIN_WORLD_1_AREA_2 field.
	SENSITIVE_REGION_PMS_CONSTRAIN_2_REGION_PMS_CONSTRAIN_WORLD_1_AREA_2_Pos = 0x4
	// Bit mask of REGION_PMS_CONSTRAIN_WORLD_1_AREA_2 field.
	SENSITIVE_REGION_PMS_CONSTRAIN_2_REGION_PMS_CONSTRAIN_WORLD_1_AREA_2_Msk = 0x30
	// Position of REGION_PMS_CONSTRAIN_WORLD_1_AREA_3 field.
	SENSITIVE_REGION_PMS_CONSTRAIN_2_REGION_PMS_CONSTRAIN_WORLD_1_AREA_3_Pos = 0x6
	// Bit mask of REGION_PMS_CONSTRAIN_WORLD_1_AREA_3 field.
	SENSITIVE_REGION_PMS_CONSTRAIN_2_REGION_PMS_CONSTRAIN_WORLD_1_AREA_3_Msk = 0xc0
	// Position of REGION_PMS_CONSTRAIN_WORLD_1_AREA_4 field.
	SENSITIVE_REGION_PMS_CONSTRAIN_2_REGION_PMS_CONSTRAIN_WORLD_1_AREA_4_Pos = 0x8
	// Bit mask of REGION_PMS_CONSTRAIN_WORLD_1_AREA_4 field.
	SENSITIVE_REGION_PMS_CONSTRAIN_2_REGION_PMS_CONSTRAIN_WORLD_1_AREA_4_Msk = 0x300
	// Position of REGION_PMS_CONSTRAIN_WORLD_1_AREA_5 field.
	SENSITIVE_REGION_PMS_CONSTRAIN_2_REGION_PMS_CONSTRAIN_WORLD_1_AREA_5_Pos = 0xa
	// Bit mask of REGION_PMS_CONSTRAIN_WORLD_1_AREA_5 field.
	SENSITIVE_REGION_PMS_CONSTRAIN_2_REGION_PMS_CONSTRAIN_WORLD_1_AREA_5_Msk = 0xc00
	// Position of REGION_PMS_CONSTRAIN_WORLD_1_AREA_6 field.
	SENSITIVE_REGION_PMS_CONSTRAIN_2_REGION_PMS_CONSTRAIN_WORLD_1_AREA_6_Pos = 0xc
	// Bit mask of REGION_PMS_CONSTRAIN_WORLD_1_AREA_6 field.
	SENSITIVE_REGION_PMS_CONSTRAIN_2_REGION_PMS_CONSTRAIN_WORLD_1_AREA_6_Msk = 0x3000

	// REGION_PMS_CONSTRAIN_3: SENSITIVE_REGION_PMS_CONSTRAIN_3_REG
	// Position of REGION_PMS_CONSTRAIN_ADDR_0 field.
	SENSITIVE_REGION_PMS_CONSTRAIN_3_REGION_PMS_CONSTRAIN_ADDR_0_Pos = 0x0
	// Bit mask of REGION_PMS_CONSTRAIN_ADDR_0 field.
	SENSITIVE_REGION_PMS_CONSTRAIN_3_REGION_PMS_CONSTRAIN_ADDR_0_Msk = 0x3fffffff

	// REGION_PMS_CONSTRAIN_4: SENSITIVE_REGION_PMS_CONSTRAIN_4_REG
	// Position of REGION_PMS_CONSTRAIN_ADDR_1 field.
	SENSITIVE_REGION_PMS_CONSTRAIN_4_REGION_PMS_CONSTRAIN_ADDR_1_Pos = 0x0
	// Bit mask of REGION_PMS_CONSTRAIN_ADDR_1 field.
	SENSITIVE_REGION_PMS_CONSTRAIN_4_REGION_PMS_CONSTRAIN_ADDR_1_Msk = 0x3fffffff

	// REGION_PMS_CONSTRAIN_5: SENSITIVE_REGION_PMS_CONSTRAIN_5_REG
	// Position of REGION_PMS_CONSTRAIN_ADDR_2 field.
	SENSITIVE_REGION_PMS_CONSTRAIN_5_REGION_PMS_CONSTRAIN_ADDR_2_Pos = 0x0
	// Bit mask of REGION_PMS_CONSTRAIN_ADDR_2 field.
	SENSITIVE_REGION_PMS_CONSTRAIN_5_REGION_PMS_CONSTRAIN_ADDR_2_Msk = 0x3fffffff

	// REGION_PMS_CONSTRAIN_6: SENSITIVE_REGION_PMS_CONSTRAIN_6_REG
	// Position of REGION_PMS_CONSTRAIN_ADDR_3 field.
	SENSITIVE_REGION_PMS_CONSTRAIN_6_REGION_PMS_CONSTRAIN_ADDR_3_Pos = 0x0
	// Bit mask of REGION_PMS_CONSTRAIN_ADDR_3 field.
	SENSITIVE_REGION_PMS_CONSTRAIN_6_REGION_PMS_CONSTRAIN_ADDR_3_Msk = 0x3fffffff

	// REGION_PMS_CONSTRAIN_7: SENSITIVE_REGION_PMS_CONSTRAIN_7_REG
	// Position of REGION_PMS_CONSTRAIN_ADDR_4 field.
	SENSITIVE_REGION_PMS_CONSTRAIN_7_REGION_PMS_CONSTRAIN_ADDR_4_Pos = 0x0
	// Bit mask of REGION_PMS_CONSTRAIN_ADDR_4 field.
	SENSITIVE_REGION_PMS_CONSTRAIN_7_REGION_PMS_CONSTRAIN_ADDR_4_Msk = 0x3fffffff

	// REGION_PMS_CONSTRAIN_8: SENSITIVE_REGION_PMS_CONSTRAIN_8_REG
	// Position of REGION_PMS_CONSTRAIN_ADDR_5 field.
	SENSITIVE_REGION_PMS_CONSTRAIN_8_REGION_PMS_CONSTRAIN_ADDR_5_Pos = 0x0
	// Bit mask of REGION_PMS_CONSTRAIN_ADDR_5 field.
	SENSITIVE_REGION_PMS_CONSTRAIN_8_REGION_PMS_CONSTRAIN_ADDR_5_Msk = 0x3fffffff

	// REGION_PMS_CONSTRAIN_9: SENSITIVE_REGION_PMS_CONSTRAIN_9_REG
	// Position of REGION_PMS_CONSTRAIN_ADDR_6 field.
	SENSITIVE_REGION_PMS_CONSTRAIN_9_REGION_PMS_CONSTRAIN_ADDR_6_Pos = 0x0
	// Bit mask of REGION_PMS_CONSTRAIN_ADDR_6 field.
	SENSITIVE_REGION_PMS_CONSTRAIN_9_REGION_PMS_CONSTRAIN_ADDR_6_Msk = 0x3fffffff

	// REGION_PMS_CONSTRAIN_10: SENSITIVE_REGION_PMS_CONSTRAIN_10_REG
	// Position of REGION_PMS_CONSTRAIN_ADDR_7 field.
	SENSITIVE_REGION_PMS_CONSTRAIN_10_REGION_PMS_CONSTRAIN_ADDR_7_Pos = 0x0
	// Bit mask of REGION_PMS_CONSTRAIN_ADDR_7 field.
	SENSITIVE_REGION_PMS_CONSTRAIN_10_REGION_PMS_CONSTRAIN_ADDR_7_Msk = 0x3fffffff

	// CORE_0_PIF_PMS_MONITOR_0: SENSITIVE_CORE_0_PIF_PMS_MONITOR_0_REG
	// Position of CORE_0_PIF_PMS_MONITOR_LOCK field.
	SENSITIVE_CORE_0_PIF_PMS_MONITOR_0_CORE_0_PIF_PMS_MONITOR_LOCK_Pos = 0x0
	// Bit mask of CORE_0_PIF_PMS_MONITOR_LOCK field.
	SENSITIVE_CORE_0_PIF_PMS_MONITOR_0_CORE_0_PIF_PMS_MONITOR_LOCK_Msk = 0x1
	// Bit CORE_0_PIF_PMS_MONITOR_LOCK.
	SENSITIVE_CORE_0_PIF_PMS_MONITOR_0_CORE_0_PIF_PMS_MONITOR_LOCK = 0x1

	// CORE_0_PIF_PMS_MONITOR_1: SENSITIVE_CORE_0_PIF_PMS_MONITOR_1_REG
	// Position of CORE_0_PIF_PMS_MONITOR_VIOLATE_CLR field.
	SENSITIVE_CORE_0_PIF_PMS_MONITOR_1_CORE_0_PIF_PMS_MONITOR_VIOLATE_CLR_Pos = 0x0
	// Bit mask of CORE_0_PIF_PMS_MONITOR_VIOLATE_CLR field.
	SENSITIVE_CORE_0_PIF_PMS_MONITOR_1_CORE_0_PIF_PMS_MONITOR_VIOLATE_CLR_Msk = 0x1
	// Bit CORE_0_PIF_PMS_MONITOR_VIOLATE_CLR.
	SENSITIVE_CORE_0_PIF_PMS_MONITOR_1_CORE_0_PIF_PMS_MONITOR_VIOLATE_CLR = 0x1
	// Position of CORE_0_PIF_PMS_MONITOR_VIOLATE_EN field.
	SENSITIVE_CORE_0_PIF_PMS_MONITOR_1_CORE_0_PIF_PMS_MONITOR_VIOLATE_EN_Pos = 0x1
	// Bit mask of CORE_0_PIF_PMS_MONITOR_VIOLATE_EN field.
	SENSITIVE_CORE_0_PIF_PMS_MONITOR_1_CORE_0_PIF_PMS_MONITOR_VIOLATE_EN_Msk = 0x2
	// Bit CORE_0_PIF_PMS_MONITOR_VIOLATE_EN.
	SENSITIVE_CORE_0_PIF_PMS_MONITOR_1_CORE_0_PIF_PMS_MONITOR_VIOLATE_EN = 0x2

	// CORE_0_PIF_PMS_MONITOR_2: SENSITIVE_CORE_0_PIF_PMS_MONITOR_2_REG
	// Position of CORE_0_PIF_PMS_MONITOR_VIOLATE_INTR field.
	SENSITIVE_CORE_0_PIF_PMS_MONITOR_2_CORE_0_PIF_PMS_MONITOR_VIOLATE_INTR_Pos = 0x0
	// Bit mask of CORE_0_PIF_PMS_MONITOR_VIOLATE_INTR field.
	SENSITIVE_CORE_0_PIF_PMS_MONITOR_2_CORE_0_PIF_PMS_MONITOR_VIOLATE_INTR_Msk = 0x1
	// Bit CORE_0_PIF_PMS_MONITOR_VIOLATE_INTR.
	SENSITIVE_CORE_0_PIF_PMS_MONITOR_2_CORE_0_PIF_PMS_MONITOR_VIOLATE_INTR = 0x1
	// Position of CORE_0_PIF_PMS_MONITOR_VIOLATE_STATUS_HPORT_0 field.
	SENSITIVE_CORE_0_PIF_PMS_MONITOR_2_CORE_0_PIF_PMS_MONITOR_VIOLATE_STATUS_HPORT_0_Pos = 0x1
	// Bit mask of CORE_0_PIF_PMS_MONITOR_VIOLATE_STATUS_HPORT_0 field.
	SENSITIVE_CORE_0_PIF_PMS_MONITOR_2_CORE_0_PIF_PMS_MONITOR_VIOLATE_STATUS_HPORT_0_Msk = 0x2
	// Bit CORE_0_PIF_PMS_MONITOR_VIOLATE_STATUS_HPORT_0.
	SENSITIVE_CORE_0_PIF_PMS_MONITOR_2_CORE_0_PIF_PMS_MONITOR_VIOLATE_STATUS_HPORT_0 = 0x2
	// Position of CORE_0_PIF_PMS_MONITOR_VIOLATE_STATUS_HSIZE field.
	SENSITIVE_CORE_0_PIF_PMS_MONITOR_2_CORE_0_PIF_PMS_MONITOR_VIOLATE_STATUS_HSIZE_Pos = 0x2
	// Bit mask of CORE_0_PIF_PMS_MONITOR_VIOLATE_STATUS_HSIZE field.
	SENSITIVE_CORE_0_PIF_PMS_MONITOR_2_CORE_0_PIF_PMS_MONITOR_VIOLATE_STATUS_HSIZE_Msk = 0x1c
	// Position of CORE_0_PIF_PMS_MONITOR_VIOLATE_STATUS_HWRITE field.
	SENSITIVE_CORE_0_PIF_PMS_MONITOR_2_CORE_0_PIF_PMS_MONITOR_VIOLATE_STATUS_HWRITE_Pos = 0x5
	// Bit mask of CORE_0_PIF_PMS_MONITOR_VIOLATE_STATUS_HWRITE field.
	SENSITIVE_CORE_0_PIF_PMS_MONITOR_2_CORE_0_PIF_PMS_MONITOR_VIOLATE_STATUS_HWRITE_Msk = 0x20
	// Bit CORE_0_PIF_PMS_MONITOR_VIOLATE_STATUS_HWRITE.
	SENSITIVE_CORE_0_PIF_PMS_MONITOR_2_CORE_0_PIF_PMS_MONITOR_VIOLATE_STATUS_HWRITE = 0x20
	// Position of CORE_0_PIF_PMS_MONITOR_VIOLATE_STATUS_HWORLD field.
	SENSITIVE_CORE_0_PIF_PMS_MONITOR_2_CORE_0_PIF_PMS_MONITOR_VIOLATE_STATUS_HWORLD_Pos = 0x6
	// Bit mask of CORE_0_PIF_PMS_MONITOR_VIOLATE_STATUS_HWORLD field.
	SENSITIVE_CORE_0_PIF_PMS_MONITOR_2_CORE_0_PIF_PMS_MONITOR_VIOLATE_STATUS_HWORLD_Msk = 0xc0

	// CORE_0_PIF_PMS_MONITOR_3: SENSITIVE_CORE_0_PIF_PMS_MONITOR_3_REG
	// Position of CORE_0_PIF_PMS_MONITOR_VIOLATE_STATUS_HADDR field.
	SENSITIVE_CORE_0_PIF_PMS_MONITOR_3_CORE_0_PIF_PMS_MONITOR_VIOLATE_STATUS_HADDR_Pos = 0x0
	// Bit mask of CORE_0_PIF_PMS_MONITOR_VIOLATE_STATUS_HADDR field.
	SENSITIVE_CORE_0_PIF_PMS_MONITOR_3_CORE_0_PIF_PMS_MONITOR_VIOLATE_STATUS_HADDR_Msk = 0xffffffff

	// CORE_0_PIF_PMS_MONITOR_4: SENSITIVE_CORE_0_PIF_PMS_MONITOR_4_REG
	// Position of CORE_0_PIF_PMS_MONITOR_NONWORD_VIOLATE_CLR field.
	SENSITIVE_CORE_0_PIF_PMS_MONITOR_4_CORE_0_PIF_PMS_MONITOR_NONWORD_VIOLATE_CLR_Pos = 0x0
	// Bit mask of CORE_0_PIF_PMS_MONITOR_NONWORD_VIOLATE_CLR field.
	SENSITIVE_CORE_0_PIF_PMS_MONITOR_4_CORE_0_PIF_PMS_MONITOR_NONWORD_VIOLATE_CLR_Msk = 0x1
	// Bit CORE_0_PIF_PMS_MONITOR_NONWORD_VIOLATE_CLR.
	SENSITIVE_CORE_0_PIF_PMS_MONITOR_4_CORE_0_PIF_PMS_MONITOR_NONWORD_VIOLATE_CLR = 0x1
	// Position of CORE_0_PIF_PMS_MONITOR_NONWORD_VIOLATE_EN field.
	SENSITIVE_CORE_0_PIF_PMS_MONITOR_4_CORE_0_PIF_PMS_MONITOR_NONWORD_VIOLATE_EN_Pos = 0x1
	// Bit mask of CORE_0_PIF_PMS_MONITOR_NONWORD_VIOLATE_EN field.
	SENSITIVE_CORE_0_PIF_PMS_MONITOR_4_CORE_0_PIF_PMS_MONITOR_NONWORD_VIOLATE_EN_Msk = 0x2
	// Bit CORE_0_PIF_PMS_MONITOR_NONWORD_VIOLATE_EN.
	SENSITIVE_CORE_0_PIF_PMS_MONITOR_4_CORE_0_PIF_PMS_MONITOR_NONWORD_VIOLATE_EN = 0x2

	// CORE_0_PIF_PMS_MONITOR_5: SENSITIVE_CORE_0_PIF_PMS_MONITOR_5_REG
	// Position of CORE_0_PIF_PMS_MONITOR_NONWORD_VIOLATE_INTR field.
	SENSITIVE_CORE_0_PIF_PMS_MONITOR_5_CORE_0_PIF_PMS_MONITOR_NONWORD_VIOLATE_INTR_Pos = 0x0
	// Bit mask of CORE_0_PIF_PMS_MONITOR_NONWORD_VIOLATE_INTR field.
	SENSITIVE_CORE_0_PIF_PMS_MONITOR_5_CORE_0_PIF_PMS_MONITOR_NONWORD_VIOLATE_INTR_Msk = 0x1
	// Bit CORE_0_PIF_PMS_MONITOR_NONWORD_VIOLATE_INTR.
	SENSITIVE_CORE_0_PIF_PMS_MONITOR_5_CORE_0_PIF_PMS_MONITOR_NONWORD_VIOLATE_INTR = 0x1
	// Position of CORE_0_PIF_PMS_MONITOR_NONWORD_VIOLATE_STATUS_HSIZE field.
	SENSITIVE_CORE_0_PIF_PMS_MONITOR_5_CORE_0_PIF_PMS_MONITOR_NONWORD_VIOLATE_STATUS_HSIZE_Pos = 0x1
	// Bit mask of CORE_0_PIF_PMS_MONITOR_NONWORD_VIOLATE_STATUS_HSIZE field.
	SENSITIVE_CORE_0_PIF_PMS_MONITOR_5_CORE_0_PIF_PMS_MONITOR_NONWORD_VIOLATE_STATUS_HSIZE_Msk = 0x6
	// Position of CORE_0_PIF_PMS_MONITOR_NONWORD_VIOLATE_STATUS_HWORLD field.
	SENSITIVE_CORE_0_PIF_PMS_MONITOR_5_CORE_0_PIF_PMS_MONITOR_NONWORD_VIOLATE_STATUS_HWORLD_Pos = 0x3
	// Bit mask of CORE_0_PIF_PMS_MONITOR_NONWORD_VIOLATE_STATUS_HWORLD field.
	SENSITIVE_CORE_0_PIF_PMS_MONITOR_5_CORE_0_PIF_PMS_MONITOR_NONWORD_VIOLATE_STATUS_HWORLD_Msk = 0x18

	// CORE_0_PIF_PMS_MONITOR_6: SENSITIVE_CORE_0_PIF_PMS_MONITOR_6_REG
	// Position of CORE_0_PIF_PMS_MONITOR_NONWORD_VIOLATE_STATUS_HADDR field.
	SENSITIVE_CORE_0_PIF_PMS_MONITOR_6_CORE_0_PIF_PMS_MONITOR_NONWORD_VIOLATE_STATUS_HADDR_Pos = 0x0
	// Bit mask of CORE_0_PIF_PMS_MONITOR_NONWORD_VIOLATE_STATUS_HADDR field.
	SENSITIVE_CORE_0_PIF_PMS_MONITOR_6_CORE_0_PIF_PMS_MONITOR_NONWORD_VIOLATE_STATUS_HADDR_Msk = 0xffffffff

	// BACKUP_BUS_PMS_CONSTRAIN_0: SENSITIVE_BACKUP_BUS_PMS_CONSTRAIN_0_REG
	// Position of BACKUP_BUS_PMS_CONSTRAIN_LOCK field.
	SENSITIVE_BACKUP_BUS_PMS_CONSTRAIN_0_BACKUP_BUS_PMS_CONSTRAIN_LOCK_Pos = 0x0
	// Bit mask of BACKUP_BUS_PMS_CONSTRAIN_LOCK field.
	SENSITIVE_BACKUP_BUS_PMS_CONSTRAIN_0_BACKUP_BUS_PMS_CONSTRAIN_LOCK_Msk = 0x1
	// Bit BACKUP_BUS_PMS_CONSTRAIN_LOCK.
	SENSITIVE_BACKUP_BUS_PMS_CONSTRAIN_0_BACKUP_BUS_PMS_CONSTRAIN_LOCK = 0x1

	// BACKUP_BUS_PMS_CONSTRAIN_1: SENSITIVE_BACKUP_BUS_PMS_CONSTRAIN_1_REG
	// Position of BACKUP_BUS_PMS_CONSTRAIN_UART field.
	SENSITIVE_BACKUP_BUS_PMS_CONSTRAIN_1_BACKUP_BUS_PMS_CONSTRAIN_UART_Pos = 0x0
	// Bit mask of BACKUP_BUS_PMS_CONSTRAIN_UART field.
	SENSITIVE_BACKUP_BUS_PMS_CONSTRAIN_1_BACKUP_BUS_PMS_CONSTRAIN_UART_Msk = 0x3
	// Position of BACKUP_BUS_PMS_CONSTRAIN_G0SPI_1 field.
	SENSITIVE_BACKUP_BUS_PMS_CONSTRAIN_1_BACKUP_BUS_PMS_CONSTRAIN_G0SPI_1_Pos = 0x2
	// Bit mask of BACKUP_BUS_PMS_CONSTRAIN_G0SPI_1 field.
	SENSITIVE_BACKUP_BUS_PMS_CONSTRAIN_1_BACKUP_BUS_PMS_CONSTRAIN_G0SPI_1_Msk = 0xc
	// Position of BACKUP_BUS_PMS_CONSTRAIN_G0SPI_0 field.
	SENSITIVE_BACKUP_BUS_PMS_CONSTRAIN_1_BACKUP_BUS_PMS_CONSTRAIN_G0SPI_0_Pos = 0x4
	// Bit mask of BACKUP_BUS_PMS_CONSTRAIN_G0SPI_0 field.
	SENSITIVE_BACKUP_BUS_PMS_CONSTRAIN_1_BACKUP_BUS_PMS_CONSTRAIN_G0SPI_0_Msk = 0x30
	// Position of BACKUP_BUS_PMS_CONSTRAIN_GPIO field.
	SENSITIVE_BACKUP_BUS_PMS_CONSTRAIN_1_BACKUP_BUS_PMS_CONSTRAIN_GPIO_Pos = 0x6
	// Bit mask of BACKUP_BUS_PMS_CONSTRAIN_GPIO field.
	SENSITIVE_BACKUP_BUS_PMS_CONSTRAIN_1_BACKUP_BUS_PMS_CONSTRAIN_GPIO_Msk = 0xc0
	// Position of BACKUP_BUS_PMS_CONSTRAIN_FE2 field.
	SENSITIVE_BACKUP_BUS_PMS_CONSTRAIN_1_BACKUP_BUS_PMS_CONSTRAIN_FE2_Pos = 0x8
	// Bit mask of BACKUP_BUS_PMS_CONSTRAIN_FE2 field.
	SENSITIVE_BACKUP_BUS_PMS_CONSTRAIN_1_BACKUP_BUS_PMS_CONSTRAIN_FE2_Msk = 0x300
	// Position of BACKUP_BUS_PMS_CONSTRAIN_FE field.
	SENSITIVE_BACKUP_BUS_PMS_CONSTRAIN_1_BACKUP_BUS_PMS_CONSTRAIN_FE_Pos = 0xa
	// Bit mask of BACKUP_BUS_PMS_CONSTRAIN_FE field.
	SENSITIVE_BACKUP_BUS_PMS_CONSTRAIN_1_BACKUP_BUS_PMS_CONSTRAIN_FE_Msk = 0xc00
	// Position of BACKUP_BUS_PMS_CONSTRAIN_TIMER field.
	SENSITIVE_BACKUP_BUS_PMS_CONSTRAIN_1_BACKUP_BUS_PMS_CONSTRAIN_TIMER_Pos = 0xc
	// Bit mask of BACKUP_BUS_PMS_CONSTRAIN_TIMER field.
	SENSITIVE_BACKUP_BUS_PMS_CONSTRAIN_1_BACKUP_BUS_PMS_CONSTRAIN_TIMER_Msk = 0x3000
	// Position of BACKUP_BUS_PMS_CONSTRAIN_RTC field.
	SENSITIVE_BACKUP_BUS_PMS_CONSTRAIN_1_BACKUP_BUS_PMS_CONSTRAIN_RTC_Pos = 0xe
	// Bit mask of BACKUP_BUS_PMS_CONSTRAIN_RTC field.
	SENSITIVE_BACKUP_BUS_PMS_CONSTRAIN_1_BACKUP_BUS_PMS_CONSTRAIN_RTC_Msk = 0xc000
	// Position of BACKUP_BUS_PMS_CONSTRAIN_IO_MUX field.
	SENSITIVE_BACKUP_BUS_PMS_CONSTRAIN_1_BACKUP_BUS_PMS_CONSTRAIN_IO_MUX_Pos = 0x10
	// Bit mask of BACKUP_BUS_PMS_CONSTRAIN_IO_MUX field.
	SENSITIVE_BACKUP_BUS_PMS_CONSTRAIN_1_BACKUP_BUS_PMS_CONSTRAIN_IO_MUX_Msk = 0x30000
	// Position of BACKUP_BUS_PMS_CONSTRAIN_WDG field.
	SENSITIVE_BACKUP_BUS_PMS_CONSTRAIN_1_BACKUP_BUS_PMS_CONSTRAIN_WDG_Pos = 0x12
	// Bit mask of BACKUP_BUS_PMS_CONSTRAIN_WDG field.
	SENSITIVE_BACKUP_BUS_PMS_CONSTRAIN_1_BACKUP_BUS_PMS_CONSTRAIN_WDG_Msk = 0xc0000
	// Position of BACKUP_BUS_PMS_CONSTRAIN_MISC field.
	SENSITIVE_BACKUP_BUS_PMS_CONSTRAIN_1_BACKUP_BUS_PMS_CONSTRAIN_MISC_Pos = 0x18
	// Bit mask of BACKUP_BUS_PMS_CONSTRAIN_MISC field.
	SENSITIVE_BACKUP_BUS_PMS_CONSTRAIN_1_BACKUP_BUS_PMS_CONSTRAIN_MISC_Msk = 0x3000000
	// Position of BACKUP_BUS_PMS_CONSTRAIN_I2C field.
	SENSITIVE_BACKUP_BUS_PMS_CONSTRAIN_1_BACKUP_BUS_PMS_CONSTRAIN_I2C_Pos = 0x1a
	// Bit mask of BACKUP_BUS_PMS_CONSTRAIN_I2C field.
	SENSITIVE_BACKUP_BUS_PMS_CONSTRAIN_1_BACKUP_BUS_PMS_CONSTRAIN_I2C_Msk = 0xc000000
	// Position of BACKUP_BUS_PMS_CONSTRAIN_UART1 field.
	SENSITIVE_BACKUP_BUS_PMS_CONSTRAIN_1_BACKUP_BUS_PMS_CONSTRAIN_UART1_Pos = 0x1e
	// Bit mask of BACKUP_BUS_PMS_CONSTRAIN_UART1 field.
	SENSITIVE_BACKUP_BUS_PMS_CONSTRAIN_1_BACKUP_BUS_PMS_CONSTRAIN_UART1_Msk = 0xc0000000

	// BACKUP_BUS_PMS_CONSTRAIN_2: SENSITIVE_BACKUP_BUS_PMS_CONSTRAIN_2_REG
	// Position of BACKUP_BUS_PMS_CONSTRAIN_BT field.
	SENSITIVE_BACKUP_BUS_PMS_CONSTRAIN_2_BACKUP_BUS_PMS_CONSTRAIN_BT_Pos = 0x0
	// Bit mask of BACKUP_BUS_PMS_CONSTRAIN_BT field.
	SENSITIVE_BACKUP_BUS_PMS_CONSTRAIN_2_BACKUP_BUS_PMS_CONSTRAIN_BT_Msk = 0x3
	// Position of BACKUP_BUS_PMS_CONSTRAIN_I2C_EXT0 field.
	SENSITIVE_BACKUP_BUS_PMS_CONSTRAIN_2_BACKUP_BUS_PMS_CONSTRAIN_I2C_EXT0_Pos = 0x4
	// Bit mask of BACKUP_BUS_PMS_CONSTRAIN_I2C_EXT0 field.
	SENSITIVE_BACKUP_BUS_PMS_CONSTRAIN_2_BACKUP_BUS_PMS_CONSTRAIN_I2C_EXT0_Msk = 0x30
	// Position of BACKUP_BUS_PMS_CONSTRAIN_UHCI0 field.
	SENSITIVE_BACKUP_BUS_PMS_CONSTRAIN_2_BACKUP_BUS_PMS_CONSTRAIN_UHCI0_Pos = 0x6
	// Bit mask of BACKUP_BUS_PMS_CONSTRAIN_UHCI0 field.
	SENSITIVE_BACKUP_BUS_PMS_CONSTRAIN_2_BACKUP_BUS_PMS_CONSTRAIN_UHCI0_Msk = 0xc0
	// Position of BACKUP_BUS_PMS_CONSTRAIN_RMT field.
	SENSITIVE_BACKUP_BUS_PMS_CONSTRAIN_2_BACKUP_BUS_PMS_CONSTRAIN_RMT_Pos = 0xa
	// Bit mask of BACKUP_BUS_PMS_CONSTRAIN_RMT field.
	SENSITIVE_BACKUP_BUS_PMS_CONSTRAIN_2_BACKUP_BUS_PMS_CONSTRAIN_RMT_Msk = 0xc00
	// Position of BACKUP_BUS_PMS_CONSTRAIN_LEDC field.
	SENSITIVE_BACKUP_BUS_PMS_CONSTRAIN_2_BACKUP_BUS_PMS_CONSTRAIN_LEDC_Pos = 0x10
	// Bit mask of BACKUP_BUS_PMS_CONSTRAIN_LEDC field.
	SENSITIVE_BACKUP_BUS_PMS_CONSTRAIN_2_BACKUP_BUS_PMS_CONSTRAIN_LEDC_Msk = 0x30000
	// Position of BACKUP_BUS_PMS_CONSTRAIN_BB field.
	SENSITIVE_BACKUP_BUS_PMS_CONSTRAIN_2_BACKUP_BUS_PMS_CONSTRAIN_BB_Pos = 0x16
	// Bit mask of BACKUP_BUS_PMS_CONSTRAIN_BB field.
	SENSITIVE_BACKUP_BUS_PMS_CONSTRAIN_2_BACKUP_BUS_PMS_CONSTRAIN_BB_Msk = 0xc00000
	// Position of BACKUP_BUS_PMS_CONSTRAIN_TIMERGROUP field.
	SENSITIVE_BACKUP_BUS_PMS_CONSTRAIN_2_BACKUP_BUS_PMS_CONSTRAIN_TIMERGROUP_Pos = 0x1a
	// Bit mask of BACKUP_BUS_PMS_CONSTRAIN_TIMERGROUP field.
	SENSITIVE_BACKUP_BUS_PMS_CONSTRAIN_2_BACKUP_BUS_PMS_CONSTRAIN_TIMERGROUP_Msk = 0xc000000
	// Position of BACKUP_BUS_PMS_CONSTRAIN_TIMERGROUP1 field.
	SENSITIVE_BACKUP_BUS_PMS_CONSTRAIN_2_BACKUP_BUS_PMS_CONSTRAIN_TIMERGROUP1_Pos = 0x1c
	// Bit mask of BACKUP_BUS_PMS_CONSTRAIN_TIMERGROUP1 field.
	SENSITIVE_BACKUP_BUS_PMS_CONSTRAIN_2_BACKUP_BUS_PMS_CONSTRAIN_TIMERGROUP1_Msk = 0x30000000
	// Position of BACKUP_BUS_PMS_CONSTRAIN_SYSTIMER field.
	SENSITIVE_BACKUP_BUS_PMS_CONSTRAIN_2_BACKUP_BUS_PMS_CONSTRAIN_SYSTIMER_Pos = 0x1e
	// Bit mask of BACKUP_BUS_PMS_CONSTRAIN_SYSTIMER field.
	SENSITIVE_BACKUP_BUS_PMS_CONSTRAIN_2_BACKUP_BUS_PMS_CONSTRAIN_SYSTIMER_Msk = 0xc0000000

	// BACKUP_BUS_PMS_CONSTRAIN_3: SENSITIVE_BACKUP_BUS_PMS_CONSTRAIN_3_REG
	// Position of BACKUP_BUS_PMS_CONSTRAIN_SPI_2 field.
	SENSITIVE_BACKUP_BUS_PMS_CONSTRAIN_3_BACKUP_BUS_PMS_CONSTRAIN_SPI_2_Pos = 0x0
	// Bit mask of BACKUP_BUS_PMS_CONSTRAIN_SPI_2 field.
	SENSITIVE_BACKUP_BUS_PMS_CONSTRAIN_3_BACKUP_BUS_PMS_CONSTRAIN_SPI_2_Msk = 0x3
	// Position of BACKUP_BUS_PMS_CONSTRAIN_APB_CTRL field.
	SENSITIVE_BACKUP_BUS_PMS_CONSTRAIN_3_BACKUP_BUS_PMS_CONSTRAIN_APB_CTRL_Pos = 0x4
	// Bit mask of BACKUP_BUS_PMS_CONSTRAIN_APB_CTRL field.
	SENSITIVE_BACKUP_BUS_PMS_CONSTRAIN_3_BACKUP_BUS_PMS_CONSTRAIN_APB_CTRL_Msk = 0x30
	// Position of BACKUP_BUS_PMS_CONSTRAIN_CAN field.
	SENSITIVE_BACKUP_BUS_PMS_CONSTRAIN_3_BACKUP_BUS_PMS_CONSTRAIN_CAN_Pos = 0xa
	// Bit mask of BACKUP_BUS_PMS_CONSTRAIN_CAN field.
	SENSITIVE_BACKUP_BUS_PMS_CONSTRAIN_3_BACKUP_BUS_PMS_CONSTRAIN_CAN_Msk = 0xc00
	// Position of BACKUP_BUS_PMS_CONSTRAIN_I2S1 field.
	SENSITIVE_BACKUP_BUS_PMS_CONSTRAIN_3_BACKUP_BUS_PMS_CONSTRAIN_I2S1_Pos = 0xe
	// Bit mask of BACKUP_BUS_PMS_CONSTRAIN_I2S1 field.
	SENSITIVE_BACKUP_BUS_PMS_CONSTRAIN_3_BACKUP_BUS_PMS_CONSTRAIN_I2S1_Msk = 0xc000
	// Position of BACKUP_BUS_PMS_CONSTRAIN_RWBT field.
	SENSITIVE_BACKUP_BUS_PMS_CONSTRAIN_3_BACKUP_BUS_PMS_CONSTRAIN_RWBT_Pos = 0x16
	// Bit mask of BACKUP_BUS_PMS_CONSTRAIN_RWBT field.
	SENSITIVE_BACKUP_BUS_PMS_CONSTRAIN_3_BACKUP_BUS_PMS_CONSTRAIN_RWBT_Msk = 0xc00000
	// Position of BACKUP_BUS_PMS_CONSTRAIN_WIFIMAC field.
	SENSITIVE_BACKUP_BUS_PMS_CONSTRAIN_3_BACKUP_BUS_PMS_CONSTRAIN_WIFIMAC_Pos = 0x1a
	// Bit mask of BACKUP_BUS_PMS_CONSTRAIN_WIFIMAC field.
	SENSITIVE_BACKUP_BUS_PMS_CONSTRAIN_3_BACKUP_BUS_PMS_CONSTRAIN_WIFIMAC_Msk = 0xc000000
	// Position of BACKUP_BUS_PMS_CONSTRAIN_PWR field.
	SENSITIVE_BACKUP_BUS_PMS_CONSTRAIN_3_BACKUP_BUS_PMS_CONSTRAIN_PWR_Pos = 0x1c
	// Bit mask of BACKUP_BUS_PMS_CONSTRAIN_PWR field.
	SENSITIVE_BACKUP_BUS_PMS_CONSTRAIN_3_BACKUP_BUS_PMS_CONSTRAIN_PWR_Msk = 0x30000000

	// BACKUP_BUS_PMS_CONSTRAIN_4: SENSITIVE_BACKUP_BUS_PMS_CONSTRAIN_4_REG
	// Position of BACKUP_BUS_PMS_CONSTRAIN_USB_WRAP field.
	SENSITIVE_BACKUP_BUS_PMS_CONSTRAIN_4_BACKUP_BUS_PMS_CONSTRAIN_USB_WRAP_Pos = 0x2
	// Bit mask of BACKUP_BUS_PMS_CONSTRAIN_USB_WRAP field.
	SENSITIVE_BACKUP_BUS_PMS_CONSTRAIN_4_BACKUP_BUS_PMS_CONSTRAIN_USB_WRAP_Msk = 0xc
	// Position of BACKUP_BUS_PMS_CONSTRAIN_CRYPTO_PERI field.
	SENSITIVE_BACKUP_BUS_PMS_CONSTRAIN_4_BACKUP_BUS_PMS_CONSTRAIN_CRYPTO_PERI_Pos = 0x4
	// Bit mask of BACKUP_BUS_PMS_CONSTRAIN_CRYPTO_PERI field.
	SENSITIVE_BACKUP_BUS_PMS_CONSTRAIN_4_BACKUP_BUS_PMS_CONSTRAIN_CRYPTO_PERI_Msk = 0x30
	// Position of BACKUP_BUS_PMS_CONSTRAIN_CRYPTO_DMA field.
	SENSITIVE_BACKUP_BUS_PMS_CONSTRAIN_4_BACKUP_BUS_PMS_CONSTRAIN_CRYPTO_DMA_Pos = 0x6
	// Bit mask of BACKUP_BUS_PMS_CONSTRAIN_CRYPTO_DMA field.
	SENSITIVE_BACKUP_BUS_PMS_CONSTRAIN_4_BACKUP_BUS_PMS_CONSTRAIN_CRYPTO_DMA_Msk = 0xc0
	// Position of BACKUP_BUS_PMS_CONSTRAIN_APB_ADC field.
	SENSITIVE_BACKUP_BUS_PMS_CONSTRAIN_4_BACKUP_BUS_PMS_CONSTRAIN_APB_ADC_Pos = 0x8
	// Bit mask of BACKUP_BUS_PMS_CONSTRAIN_APB_ADC field.
	SENSITIVE_BACKUP_BUS_PMS_CONSTRAIN_4_BACKUP_BUS_PMS_CONSTRAIN_APB_ADC_Msk = 0x300
	// Position of BACKUP_BUS_PMS_CONSTRAIN_BT_PWR field.
	SENSITIVE_BACKUP_BUS_PMS_CONSTRAIN_4_BACKUP_BUS_PMS_CONSTRAIN_BT_PWR_Pos = 0xc
	// Bit mask of BACKUP_BUS_PMS_CONSTRAIN_BT_PWR field.
	SENSITIVE_BACKUP_BUS_PMS_CONSTRAIN_4_BACKUP_BUS_PMS_CONSTRAIN_BT_PWR_Msk = 0x3000
	// Position of BACKUP_BUS_PMS_CONSTRAIN_USB_DEVICE field.
	SENSITIVE_BACKUP_BUS_PMS_CONSTRAIN_4_BACKUP_BUS_PMS_CONSTRAIN_USB_DEVICE_Pos = 0xe
	// Bit mask of BACKUP_BUS_PMS_CONSTRAIN_USB_DEVICE field.
	SENSITIVE_BACKUP_BUS_PMS_CONSTRAIN_4_BACKUP_BUS_PMS_CONSTRAIN_USB_DEVICE_Msk = 0xc000

	// BACKUP_BUS_PMS_MONITOR_0: SENSITIVE_BACKUP_BUS_PMS_MONITOR_0_REG
	// Position of BACKUP_BUS_PMS_MONITOR_LOCK field.
	SENSITIVE_BACKUP_BUS_PMS_MONITOR_0_BACKUP_BUS_PMS_MONITOR_LOCK_Pos = 0x0
	// Bit mask of BACKUP_BUS_PMS_MONITOR_LOCK field.
	SENSITIVE_BACKUP_BUS_PMS_MONITOR_0_BACKUP_BUS_PMS_MONITOR_LOCK_Msk = 0x1
	// Bit BACKUP_BUS_PMS_MONITOR_LOCK.
	SENSITIVE_BACKUP_BUS_PMS_MONITOR_0_BACKUP_BUS_PMS_MONITOR_LOCK = 0x1

	// BACKUP_BUS_PMS_MONITOR_1: SENSITIVE_BACKUP_BUS_PMS_MONITOR_1_REG
	// Position of BACKUP_BUS_PMS_MONITOR_VIOLATE_CLR field.
	SENSITIVE_BACKUP_BUS_PMS_MONITOR_1_BACKUP_BUS_PMS_MONITOR_VIOLATE_CLR_Pos = 0x0
	// Bit mask of BACKUP_BUS_PMS_MONITOR_VIOLATE_CLR field.
	SENSITIVE_BACKUP_BUS_PMS_MONITOR_1_BACKUP_BUS_PMS_MONITOR_VIOLATE_CLR_Msk = 0x1
	// Bit BACKUP_BUS_PMS_MONITOR_VIOLATE_CLR.
	SENSITIVE_BACKUP_BUS_PMS_MONITOR_1_BACKUP_BUS_PMS_MONITOR_VIOLATE_CLR = 0x1
	// Position of BACKUP_BUS_PMS_MONITOR_VIOLATE_EN field.
	SENSITIVE_BACKUP_BUS_PMS_MONITOR_1_BACKUP_BUS_PMS_MONITOR_VIOLATE_EN_Pos = 0x1
	// Bit mask of BACKUP_BUS_PMS_MONITOR_VIOLATE_EN field.
	SENSITIVE_BACKUP_BUS_PMS_MONITOR_1_BACKUP_BUS_PMS_MONITOR_VIOLATE_EN_Msk = 0x2
	// Bit BACKUP_BUS_PMS_MONITOR_VIOLATE_EN.
	SENSITIVE_BACKUP_BUS_PMS_MONITOR_1_BACKUP_BUS_PMS_MONITOR_VIOLATE_EN = 0x2

	// BACKUP_BUS_PMS_MONITOR_2: SENSITIVE_BACKUP_BUS_PMS_MONITOR_2_REG
	// Position of BACKUP_BUS_PMS_MONITOR_VIOLATE_INTR field.
	SENSITIVE_BACKUP_BUS_PMS_MONITOR_2_BACKUP_BUS_PMS_MONITOR_VIOLATE_INTR_Pos = 0x0
	// Bit mask of BACKUP_BUS_PMS_MONITOR_VIOLATE_INTR field.
	SENSITIVE_BACKUP_BUS_PMS_MONITOR_2_BACKUP_BUS_PMS_MONITOR_VIOLATE_INTR_Msk = 0x1
	// Bit BACKUP_BUS_PMS_MONITOR_VIOLATE_INTR.
	SENSITIVE_BACKUP_BUS_PMS_MONITOR_2_BACKUP_BUS_PMS_MONITOR_VIOLATE_INTR = 0x1
	// Position of BACKUP_BUS_PMS_MONITOR_VIOLATE_STATUS_HTRANS field.
	SENSITIVE_BACKUP_BUS_PMS_MONITOR_2_BACKUP_BUS_PMS_MONITOR_VIOLATE_STATUS_HTRANS_Pos = 0x1
	// Bit mask of BACKUP_BUS_PMS_MONITOR_VIOLATE_STATUS_HTRANS field.
	SENSITIVE_BACKUP_BUS_PMS_MONITOR_2_BACKUP_BUS_PMS_MONITOR_VIOLATE_STATUS_HTRANS_Msk = 0x6
	// Position of BACKUP_BUS_PMS_MONITOR_VIOLATE_STATUS_HSIZE field.
	SENSITIVE_BACKUP_BUS_PMS_MONITOR_2_BACKUP_BUS_PMS_MONITOR_VIOLATE_STATUS_HSIZE_Pos = 0x3
	// Bit mask of BACKUP_BUS_PMS_MONITOR_VIOLATE_STATUS_HSIZE field.
	SENSITIVE_BACKUP_BUS_PMS_MONITOR_2_BACKUP_BUS_PMS_MONITOR_VIOLATE_STATUS_HSIZE_Msk = 0x38
	// Position of BACKUP_BUS_PMS_MONITOR_VIOLATE_STATUS_HWRITE field.
	SENSITIVE_BACKUP_BUS_PMS_MONITOR_2_BACKUP_BUS_PMS_MONITOR_VIOLATE_STATUS_HWRITE_Pos = 0x6
	// Bit mask of BACKUP_BUS_PMS_MONITOR_VIOLATE_STATUS_HWRITE field.
	SENSITIVE_BACKUP_BUS_PMS_MONITOR_2_BACKUP_BUS_PMS_MONITOR_VIOLATE_STATUS_HWRITE_Msk = 0x40
	// Bit BACKUP_BUS_PMS_MONITOR_VIOLATE_STATUS_HWRITE.
	SENSITIVE_BACKUP_BUS_PMS_MONITOR_2_BACKUP_BUS_PMS_MONITOR_VIOLATE_STATUS_HWRITE = 0x40

	// BACKUP_BUS_PMS_MONITOR_3: SENSITIVE_BACKUP_BUS_PMS_MONITOR_3_REG
	// Position of BACKUP_BUS_PMS_MONITOR_VIOLATE_HADDR field.
	SENSITIVE_BACKUP_BUS_PMS_MONITOR_3_BACKUP_BUS_PMS_MONITOR_VIOLATE_HADDR_Pos = 0x0
	// Bit mask of BACKUP_BUS_PMS_MONITOR_VIOLATE_HADDR field.
	SENSITIVE_BACKUP_BUS_PMS_MONITOR_3_BACKUP_BUS_PMS_MONITOR_VIOLATE_HADDR_Msk = 0xffffffff

	// CLOCK_GATE: SENSITIVE_CLOCK_GATE_REG
	// Position of CLK_EN field.
	SENSITIVE_CLOCK_GATE_CLK_EN_Pos = 0x0
	// Bit mask of CLK_EN field.
	SENSITIVE_CLOCK_GATE_CLK_EN_Msk = 0x1
	// Bit CLK_EN.
	SENSITIVE_CLOCK_GATE_CLK_EN = 0x1

	// DATE: SENSITIVE_DATE_REG
	// Position of DATE field.
	SENSITIVE_DATE_DATE_Pos = 0x0
	// Bit mask of DATE field.
	SENSITIVE_DATE_DATE_Msk = 0xfffffff
)

// Constants for SHA: Peripheral SHA
const (
	// MODE: Initial configuration register.
	// Position of MODE field.
	SHA_MODE_MODE_Pos = 0x0
	// Bit mask of MODE field.
	SHA_MODE_MODE_Msk = 0x7

	// T_STRING: SHA 512/t configuration register 0.
	// Position of T_STRING field.
	SHA_T_STRING_T_STRING_Pos = 0x0
	// Bit mask of T_STRING field.
	SHA_T_STRING_T_STRING_Msk = 0xffffffff

	// T_LENGTH: SHA 512/t configuration register 1.
	// Position of T_LENGTH field.
	SHA_T_LENGTH_T_LENGTH_Pos = 0x0
	// Bit mask of T_LENGTH field.
	SHA_T_LENGTH_T_LENGTH_Msk = 0x3f

	// DMA_BLOCK_NUM: DMA configuration register 0.
	// Position of DMA_BLOCK_NUM field.
	SHA_DMA_BLOCK_NUM_DMA_BLOCK_NUM_Pos = 0x0
	// Bit mask of DMA_BLOCK_NUM field.
	SHA_DMA_BLOCK_NUM_DMA_BLOCK_NUM_Msk = 0x3f

	// START: Typical SHA configuration register 0.
	// Position of START field.
	SHA_START_START_Pos = 0x1
	// Bit mask of START field.
	SHA_START_START_Msk = 0xfffffffe

	// CONTINUE: Typical SHA configuration register 1.
	// Position of CONTINUE field.
	SHA_CONTINUE_CONTINUE_Pos = 0x1
	// Bit mask of CONTINUE field.
	SHA_CONTINUE_CONTINUE_Msk = 0xfffffffe

	// BUSY: Busy register.
	// Position of STATE field.
	SHA_BUSY_STATE_Pos = 0x0
	// Bit mask of STATE field.
	SHA_BUSY_STATE_Msk = 0x1
	// Bit STATE.
	SHA_BUSY_STATE = 0x1

	// DMA_START: DMA configuration register 1.
	// Position of DMA_START field.
	SHA_DMA_START_DMA_START_Pos = 0x0
	// Bit mask of DMA_START field.
	SHA_DMA_START_DMA_START_Msk = 0x1
	// Bit DMA_START.
	SHA_DMA_START_DMA_START = 0x1

	// DMA_CONTINUE: DMA configuration register 2.
	// Position of DMA_CONTINUE field.
	SHA_DMA_CONTINUE_DMA_CONTINUE_Pos = 0x0
	// Bit mask of DMA_CONTINUE field.
	SHA_DMA_CONTINUE_DMA_CONTINUE_Msk = 0x1
	// Bit DMA_CONTINUE.
	SHA_DMA_CONTINUE_DMA_CONTINUE = 0x1

	// CLEAR_IRQ: Interrupt clear register.
	// Position of CLEAR_INTERRUPT field.
	SHA_CLEAR_IRQ_CLEAR_INTERRUPT_Pos = 0x0
	// Bit mask of CLEAR_INTERRUPT field.
	SHA_CLEAR_IRQ_CLEAR_INTERRUPT_Msk = 0x1
	// Bit CLEAR_INTERRUPT.
	SHA_CLEAR_IRQ_CLEAR_INTERRUPT = 0x1

	// IRQ_ENA: Interrupt enable register.
	// Position of INTERRUPT_ENA field.
	SHA_IRQ_ENA_INTERRUPT_ENA_Pos = 0x0
	// Bit mask of INTERRUPT_ENA field.
	SHA_IRQ_ENA_INTERRUPT_ENA_Msk = 0x1
	// Bit INTERRUPT_ENA.
	SHA_IRQ_ENA_INTERRUPT_ENA = 0x1

	// DATE: Date register.
	// Position of DATE field.
	SHA_DATE_DATE_Pos = 0x0
	// Bit mask of DATE field.
	SHA_DATE_DATE_Msk = 0x3fffffff
)

// Constants for SPI0: Peripheral SPI0
const (
	// CTRL: SPI0 control register.
	// Position of FDUMMY_OUT field.
	SPI0_CTRL_FDUMMY_OUT_Pos = 0x3
	// Bit mask of FDUMMY_OUT field.
	SPI0_CTRL_FDUMMY_OUT_Msk = 0x8
	// Bit FDUMMY_OUT.
	SPI0_CTRL_FDUMMY_OUT = 0x8
	// Position of FCMD_DUAL field.
	SPI0_CTRL_FCMD_DUAL_Pos = 0x7
	// Bit mask of FCMD_DUAL field.
	SPI0_CTRL_FCMD_DUAL_Msk = 0x80
	// Bit FCMD_DUAL.
	SPI0_CTRL_FCMD_DUAL = 0x80
	// Position of FCMD_QUAD field.
	SPI0_CTRL_FCMD_QUAD_Pos = 0x8
	// Bit mask of FCMD_QUAD field.
	SPI0_CTRL_FCMD_QUAD_Msk = 0x100
	// Bit FCMD_QUAD.
	SPI0_CTRL_FCMD_QUAD = 0x100
	// Position of FASTRD_MODE field.
	SPI0_CTRL_FASTRD_MODE_Pos = 0xd
	// Bit mask of FASTRD_MODE field.
	SPI0_CTRL_FASTRD_MODE_Msk = 0x2000
	// Bit FASTRD_MODE.
	SPI0_CTRL_FASTRD_MODE = 0x2000
	// Position of FREAD_DUAL field.
	SPI0_CTRL_FREAD_DUAL_Pos = 0xe
	// Bit mask of FREAD_DUAL field.
	SPI0_CTRL_FREAD_DUAL_Msk = 0x4000
	// Bit FREAD_DUAL.
	SPI0_CTRL_FREAD_DUAL = 0x4000
	// Position of Q_POL field.
	SPI0_CTRL_Q_POL_Pos = 0x12
	// Bit mask of Q_POL field.
	SPI0_CTRL_Q_POL_Msk = 0x40000
	// Bit Q_POL.
	SPI0_CTRL_Q_POL = 0x40000
	// Position of D_POL field.
	SPI0_CTRL_D_POL_Pos = 0x13
	// Bit mask of D_POL field.
	SPI0_CTRL_D_POL_Msk = 0x80000
	// Bit D_POL.
	SPI0_CTRL_D_POL = 0x80000
	// Position of FREAD_QUAD field.
	SPI0_CTRL_FREAD_QUAD_Pos = 0x14
	// Bit mask of FREAD_QUAD field.
	SPI0_CTRL_FREAD_QUAD_Msk = 0x100000
	// Bit FREAD_QUAD.
	SPI0_CTRL_FREAD_QUAD = 0x100000
	// Position of WP field.
	SPI0_CTRL_WP_Pos = 0x15
	// Bit mask of WP field.
	SPI0_CTRL_WP_Msk = 0x200000
	// Bit WP.
	SPI0_CTRL_WP = 0x200000
	// Position of FREAD_DIO field.
	SPI0_CTRL_FREAD_DIO_Pos = 0x17
	// Bit mask of FREAD_DIO field.
	SPI0_CTRL_FREAD_DIO_Msk = 0x800000
	// Bit FREAD_DIO.
	SPI0_CTRL_FREAD_DIO = 0x800000
	// Position of FREAD_QIO field.
	SPI0_CTRL_FREAD_QIO_Pos = 0x18
	// Bit mask of FREAD_QIO field.
	SPI0_CTRL_FREAD_QIO_Msk = 0x1000000
	// Bit FREAD_QIO.
	SPI0_CTRL_FREAD_QIO = 0x1000000

	// CTRL1: SPI0 control1 register.
	// Position of CLK_MODE field.
	SPI0_CTRL1_CLK_MODE_Pos = 0x0
	// Bit mask of CLK_MODE field.
	SPI0_CTRL1_CLK_MODE_Msk = 0x3
	// Position of RXFIFO_RST field.
	SPI0_CTRL1_RXFIFO_RST_Pos = 0x1e
	// Bit mask of RXFIFO_RST field.
	SPI0_CTRL1_RXFIFO_RST_Msk = 0x40000000
	// Bit RXFIFO_RST.
	SPI0_CTRL1_RXFIFO_RST = 0x40000000

	// CTRL2: SPI0 control2 register.
	// Position of CS_SETUP_TIME field.
	SPI0_CTRL2_CS_SETUP_TIME_Pos = 0x0
	// Bit mask of CS_SETUP_TIME field.
	SPI0_CTRL2_CS_SETUP_TIME_Msk = 0x1f
	// Position of CS_HOLD_TIME field.
	SPI0_CTRL2_CS_HOLD_TIME_Pos = 0x5
	// Bit mask of CS_HOLD_TIME field.
	SPI0_CTRL2_CS_HOLD_TIME_Msk = 0x3e0
	// Position of CS_HOLD_DELAY field.
	SPI0_CTRL2_CS_HOLD_DELAY_Pos = 0x19
	// Bit mask of CS_HOLD_DELAY field.
	SPI0_CTRL2_CS_HOLD_DELAY_Msk = 0x7e000000
	// Position of SYNC_RESET field.
	SPI0_CTRL2_SYNC_RESET_Pos = 0x1f
	// Bit mask of SYNC_RESET field.
	SPI0_CTRL2_SYNC_RESET_Msk = 0x80000000
	// Bit SYNC_RESET.
	SPI0_CTRL2_SYNC_RESET = 0x80000000

	// CLOCK: SPI clock division control register.
	// Position of CLKCNT_L field.
	SPI0_CLOCK_CLKCNT_L_Pos = 0x0
	// Bit mask of CLKCNT_L field.
	SPI0_CLOCK_CLKCNT_L_Msk = 0xff
	// Position of CLKCNT_H field.
	SPI0_CLOCK_CLKCNT_H_Pos = 0x8
	// Bit mask of CLKCNT_H field.
	SPI0_CLOCK_CLKCNT_H_Msk = 0xff00
	// Position of CLKCNT_N field.
	SPI0_CLOCK_CLKCNT_N_Pos = 0x10
	// Bit mask of CLKCNT_N field.
	SPI0_CLOCK_CLKCNT_N_Msk = 0xff0000
	// Position of CLK_EQU_SYSCLK field.
	SPI0_CLOCK_CLK_EQU_SYSCLK_Pos = 0x1f
	// Bit mask of CLK_EQU_SYSCLK field.
	SPI0_CLOCK_CLK_EQU_SYSCLK_Msk = 0x80000000
	// Bit CLK_EQU_SYSCLK.
	SPI0_CLOCK_CLK_EQU_SYSCLK = 0x80000000

	// USER: SPI0 user register.
	// Position of CS_HOLD field.
	SPI0_USER_CS_HOLD_Pos = 0x6
	// Bit mask of CS_HOLD field.
	SPI0_USER_CS_HOLD_Msk = 0x40
	// Bit CS_HOLD.
	SPI0_USER_CS_HOLD = 0x40
	// Position of CS_SETUP field.
	SPI0_USER_CS_SETUP_Pos = 0x7
	// Bit mask of CS_SETUP field.
	SPI0_USER_CS_SETUP_Msk = 0x80
	// Bit CS_SETUP.
	SPI0_USER_CS_SETUP = 0x80
	// Position of CK_OUT_EDGE field.
	SPI0_USER_CK_OUT_EDGE_Pos = 0x9
	// Bit mask of CK_OUT_EDGE field.
	SPI0_USER_CK_OUT_EDGE_Msk = 0x200
	// Bit CK_OUT_EDGE.
	SPI0_USER_CK_OUT_EDGE = 0x200
	// Position of USR_DUMMY_IDLE field.
	SPI0_USER_USR_DUMMY_IDLE_Pos = 0x1a
	// Bit mask of USR_DUMMY_IDLE field.
	SPI0_USER_USR_DUMMY_IDLE_Msk = 0x4000000
	// Bit USR_DUMMY_IDLE.
	SPI0_USER_USR_DUMMY_IDLE = 0x4000000
	// Position of USR_DUMMY field.
	SPI0_USER_USR_DUMMY_Pos = 0x1d
	// Bit mask of USR_DUMMY field.
	SPI0_USER_USR_DUMMY_Msk = 0x20000000
	// Bit USR_DUMMY.
	SPI0_USER_USR_DUMMY = 0x20000000

	// USER1: SPI0 user1 register.
	// Position of USR_DUMMY_CYCLELEN field.
	SPI0_USER1_USR_DUMMY_CYCLELEN_Pos = 0x0
	// Bit mask of USR_DUMMY_CYCLELEN field.
	SPI0_USER1_USR_DUMMY_CYCLELEN_Msk = 0x3f
	// Position of USR_ADDR_BITLEN field.
	SPI0_USER1_USR_ADDR_BITLEN_Pos = 0x1a
	// Bit mask of USR_ADDR_BITLEN field.
	SPI0_USER1_USR_ADDR_BITLEN_Msk = 0xfc000000

	// USER2: SPI0 user2 register.
	// Position of USR_COMMAND_VALUE field.
	SPI0_USER2_USR_COMMAND_VALUE_Pos = 0x0
	// Bit mask of USR_COMMAND_VALUE field.
	SPI0_USER2_USR_COMMAND_VALUE_Msk = 0xffff
	// Position of USR_COMMAND_BITLEN field.
	SPI0_USER2_USR_COMMAND_BITLEN_Pos = 0x1c
	// Bit mask of USR_COMMAND_BITLEN field.
	SPI0_USER2_USR_COMMAND_BITLEN_Msk = 0xf0000000

	// RD_STATUS: SPI0 read control register.
	// Position of WB_MODE field.
	SPI0_RD_STATUS_WB_MODE_Pos = 0x10
	// Bit mask of WB_MODE field.
	SPI0_RD_STATUS_WB_MODE_Msk = 0xff0000

	// MISC: SPI0 misc register
	// Position of TRANS_END field.
	SPI0_MISC_TRANS_END_Pos = 0x3
	// Bit mask of TRANS_END field.
	SPI0_MISC_TRANS_END_Msk = 0x8
	// Bit TRANS_END.
	SPI0_MISC_TRANS_END = 0x8
	// Position of TRANS_END_INT_ENA field.
	SPI0_MISC_TRANS_END_INT_ENA_Pos = 0x4
	// Bit mask of TRANS_END_INT_ENA field.
	SPI0_MISC_TRANS_END_INT_ENA_Msk = 0x10
	// Bit TRANS_END_INT_ENA.
	SPI0_MISC_TRANS_END_INT_ENA = 0x10
	// Position of CSPI_ST_TRANS_END field.
	SPI0_MISC_CSPI_ST_TRANS_END_Pos = 0x5
	// Bit mask of CSPI_ST_TRANS_END field.
	SPI0_MISC_CSPI_ST_TRANS_END_Msk = 0x20
	// Bit CSPI_ST_TRANS_END.
	SPI0_MISC_CSPI_ST_TRANS_END = 0x20
	// Position of CSPI_ST_TRANS_END_INT_ENA field.
	SPI0_MISC_CSPI_ST_TRANS_END_INT_ENA_Pos = 0x6
	// Bit mask of CSPI_ST_TRANS_END_INT_ENA field.
	SPI0_MISC_CSPI_ST_TRANS_END_INT_ENA_Msk = 0x40
	// Bit CSPI_ST_TRANS_END_INT_ENA.
	SPI0_MISC_CSPI_ST_TRANS_END_INT_ENA = 0x40
	// Position of CK_IDLE_EDGE field.
	SPI0_MISC_CK_IDLE_EDGE_Pos = 0x9
	// Bit mask of CK_IDLE_EDGE field.
	SPI0_MISC_CK_IDLE_EDGE_Msk = 0x200
	// Bit CK_IDLE_EDGE.
	SPI0_MISC_CK_IDLE_EDGE = 0x200
	// Position of CS_KEEP_ACTIVE field.
	SPI0_MISC_CS_KEEP_ACTIVE_Pos = 0xa
	// Bit mask of CS_KEEP_ACTIVE field.
	SPI0_MISC_CS_KEEP_ACTIVE_Msk = 0x400
	// Bit CS_KEEP_ACTIVE.
	SPI0_MISC_CS_KEEP_ACTIVE = 0x400

	// CACHE_FCTRL: SPI0 bit mode control register.
	// Position of CACHE_REQ_EN field.
	SPI0_CACHE_FCTRL_CACHE_REQ_EN_Pos = 0x0
	// Bit mask of CACHE_REQ_EN field.
	SPI0_CACHE_FCTRL_CACHE_REQ_EN_Msk = 0x1
	// Bit CACHE_REQ_EN.
	SPI0_CACHE_FCTRL_CACHE_REQ_EN = 0x1
	// Position of CACHE_USR_ADDR_4BYTE field.
	SPI0_CACHE_FCTRL_CACHE_USR_ADDR_4BYTE_Pos = 0x1
	// Bit mask of CACHE_USR_ADDR_4BYTE field.
	SPI0_CACHE_FCTRL_CACHE_USR_ADDR_4BYTE_Msk = 0x2
	// Bit CACHE_USR_ADDR_4BYTE.
	SPI0_CACHE_FCTRL_CACHE_USR_ADDR_4BYTE = 0x2
	// Position of CACHE_FLASH_USR_CMD field.
	SPI0_CACHE_FCTRL_CACHE_FLASH_USR_CMD_Pos = 0x2
	// Bit mask of CACHE_FLASH_USR_CMD field.
	SPI0_CACHE_FCTRL_CACHE_FLASH_USR_CMD_Msk = 0x4
	// Bit CACHE_FLASH_USR_CMD.
	SPI0_CACHE_FCTRL_CACHE_FLASH_USR_CMD = 0x4
	// Position of FDIN_DUAL field.
	SPI0_CACHE_FCTRL_FDIN_DUAL_Pos = 0x3
	// Bit mask of FDIN_DUAL field.
	SPI0_CACHE_FCTRL_FDIN_DUAL_Msk = 0x8
	// Bit FDIN_DUAL.
	SPI0_CACHE_FCTRL_FDIN_DUAL = 0x8
	// Position of FDOUT_DUAL field.
	SPI0_CACHE_FCTRL_FDOUT_DUAL_Pos = 0x4
	// Bit mask of FDOUT_DUAL field.
	SPI0_CACHE_FCTRL_FDOUT_DUAL_Msk = 0x10
	// Bit FDOUT_DUAL.
	SPI0_CACHE_FCTRL_FDOUT_DUAL = 0x10
	// Position of FADDR_DUAL field.
	SPI0_CACHE_FCTRL_FADDR_DUAL_Pos = 0x5
	// Bit mask of FADDR_DUAL field.
	SPI0_CACHE_FCTRL_FADDR_DUAL_Msk = 0x20
	// Bit FADDR_DUAL.
	SPI0_CACHE_FCTRL_FADDR_DUAL = 0x20
	// Position of FDIN_QUAD field.
	SPI0_CACHE_FCTRL_FDIN_QUAD_Pos = 0x6
	// Bit mask of FDIN_QUAD field.
	SPI0_CACHE_FCTRL_FDIN_QUAD_Msk = 0x40
	// Bit FDIN_QUAD.
	SPI0_CACHE_FCTRL_FDIN_QUAD = 0x40
	// Position of FDOUT_QUAD field.
	SPI0_CACHE_FCTRL_FDOUT_QUAD_Pos = 0x7
	// Bit mask of FDOUT_QUAD field.
	SPI0_CACHE_FCTRL_FDOUT_QUAD_Msk = 0x80
	// Bit FDOUT_QUAD.
	SPI0_CACHE_FCTRL_FDOUT_QUAD = 0x80
	// Position of FADDR_QUAD field.
	SPI0_CACHE_FCTRL_FADDR_QUAD_Pos = 0x8
	// Bit mask of FADDR_QUAD field.
	SPI0_CACHE_FCTRL_FADDR_QUAD_Msk = 0x100
	// Bit FADDR_QUAD.
	SPI0_CACHE_FCTRL_FADDR_QUAD = 0x100

	// FSM: SPI0 FSM status register
	// Position of CSPI_ST field.
	SPI0_FSM_CSPI_ST_Pos = 0x0
	// Bit mask of CSPI_ST field.
	SPI0_FSM_CSPI_ST_Msk = 0xf
	// Position of EM_ST field.
	SPI0_FSM_EM_ST_Pos = 0x4
	// Bit mask of EM_ST field.
	SPI0_FSM_EM_ST_Msk = 0x70
	// Position of CSPI_LOCK_DELAY_TIME field.
	SPI0_FSM_CSPI_LOCK_DELAY_TIME_Pos = 0x7
	// Bit mask of CSPI_LOCK_DELAY_TIME field.
	SPI0_FSM_CSPI_LOCK_DELAY_TIME_Msk = 0xf80

	// TIMING_CALI: SPI0 timing calibration register
	// Position of TIMING_CLK_ENA field.
	SPI0_TIMING_CALI_TIMING_CLK_ENA_Pos = 0x0
	// Bit mask of TIMING_CLK_ENA field.
	SPI0_TIMING_CALI_TIMING_CLK_ENA_Msk = 0x1
	// Bit TIMING_CLK_ENA.
	SPI0_TIMING_CALI_TIMING_CLK_ENA = 0x1
	// Position of TIMING_CALI field.
	SPI0_TIMING_CALI_TIMING_CALI_Pos = 0x1
	// Bit mask of TIMING_CALI field.
	SPI0_TIMING_CALI_TIMING_CALI_Msk = 0x2
	// Bit TIMING_CALI.
	SPI0_TIMING_CALI_TIMING_CALI = 0x2
	// Position of EXTRA_DUMMY_CYCLELEN field.
	SPI0_TIMING_CALI_EXTRA_DUMMY_CYCLELEN_Pos = 0x2
	// Bit mask of EXTRA_DUMMY_CYCLELEN field.
	SPI0_TIMING_CALI_EXTRA_DUMMY_CYCLELEN_Msk = 0x1c

	// DIN_MODE: SPI0 input delay mode control register
	// Position of DIN0_MODE field.
	SPI0_DIN_MODE_DIN0_MODE_Pos = 0x0
	// Bit mask of DIN0_MODE field.
	SPI0_DIN_MODE_DIN0_MODE_Msk = 0x3
	// Position of DIN1_MODE field.
	SPI0_DIN_MODE_DIN1_MODE_Pos = 0x2
	// Bit mask of DIN1_MODE field.
	SPI0_DIN_MODE_DIN1_MODE_Msk = 0xc
	// Position of DIN2_MODE field.
	SPI0_DIN_MODE_DIN2_MODE_Pos = 0x4
	// Bit mask of DIN2_MODE field.
	SPI0_DIN_MODE_DIN2_MODE_Msk = 0x30
	// Position of DIN3_MODE field.
	SPI0_DIN_MODE_DIN3_MODE_Pos = 0x6
	// Bit mask of DIN3_MODE field.
	SPI0_DIN_MODE_DIN3_MODE_Msk = 0xc0

	// DIN_NUM: SPI0 input delay number control register
	// Position of DIN0_NUM field.
	SPI0_DIN_NUM_DIN0_NUM_Pos = 0x0
	// Bit mask of DIN0_NUM field.
	SPI0_DIN_NUM_DIN0_NUM_Msk = 0x3
	// Position of DIN1_NUM field.
	SPI0_DIN_NUM_DIN1_NUM_Pos = 0x2
	// Bit mask of DIN1_NUM field.
	SPI0_DIN_NUM_DIN1_NUM_Msk = 0xc
	// Position of DIN2_NUM field.
	SPI0_DIN_NUM_DIN2_NUM_Pos = 0x4
	// Bit mask of DIN2_NUM field.
	SPI0_DIN_NUM_DIN2_NUM_Msk = 0x30
	// Position of DIN3_NUM field.
	SPI0_DIN_NUM_DIN3_NUM_Pos = 0x6
	// Bit mask of DIN3_NUM field.
	SPI0_DIN_NUM_DIN3_NUM_Msk = 0xc0

	// DOUT_MODE: SPI0 output delay mode control register
	// Position of DOUT0_MODE field.
	SPI0_DOUT_MODE_DOUT0_MODE_Pos = 0x0
	// Bit mask of DOUT0_MODE field.
	SPI0_DOUT_MODE_DOUT0_MODE_Msk = 0x1
	// Bit DOUT0_MODE.
	SPI0_DOUT_MODE_DOUT0_MODE = 0x1
	// Position of DOUT1_MODE field.
	SPI0_DOUT_MODE_DOUT1_MODE_Pos = 0x1
	// Bit mask of DOUT1_MODE field.
	SPI0_DOUT_MODE_DOUT1_MODE_Msk = 0x2
	// Bit DOUT1_MODE.
	SPI0_DOUT_MODE_DOUT1_MODE = 0x2
	// Position of DOUT2_MODE field.
	SPI0_DOUT_MODE_DOUT2_MODE_Pos = 0x2
	// Bit mask of DOUT2_MODE field.
	SPI0_DOUT_MODE_DOUT2_MODE_Msk = 0x4
	// Bit DOUT2_MODE.
	SPI0_DOUT_MODE_DOUT2_MODE = 0x4
	// Position of DOUT3_MODE field.
	SPI0_DOUT_MODE_DOUT3_MODE_Pos = 0x3
	// Bit mask of DOUT3_MODE field.
	SPI0_DOUT_MODE_DOUT3_MODE_Msk = 0x8
	// Bit DOUT3_MODE.
	SPI0_DOUT_MODE_DOUT3_MODE = 0x8

	// CLOCK_GATE: SPI0 clk_gate register
	// Position of CLK_EN field.
	SPI0_CLOCK_GATE_CLK_EN_Pos = 0x0
	// Bit mask of CLK_EN field.
	SPI0_CLOCK_GATE_CLK_EN_Msk = 0x1
	// Bit CLK_EN.
	SPI0_CLOCK_GATE_CLK_EN = 0x1

	// CORE_CLK_SEL: SPI0 module clock select register
	// Position of SPI01_CLK_SEL field.
	SPI0_CORE_CLK_SEL_SPI01_CLK_SEL_Pos = 0x0
	// Bit mask of SPI01_CLK_SEL field.
	SPI0_CORE_CLK_SEL_SPI01_CLK_SEL_Msk = 0x3

	// DATE: Version control register
	// Position of DATE field.
	SPI0_DATE_DATE_Pos = 0x0
	// Bit mask of DATE field.
	SPI0_DATE_DATE_Msk = 0xfffffff
)

// Constants for SPI1: Peripheral SPI1
const (
	// CMD: SPI1 memory command register
	// Position of SPI1_MST_ST field.
	SPI1_CMD_SPI1_MST_ST_Pos = 0x0
	// Bit mask of SPI1_MST_ST field.
	SPI1_CMD_SPI1_MST_ST_Msk = 0xf
	// Position of MSPI_ST field.
	SPI1_CMD_MSPI_ST_Pos = 0x4
	// Bit mask of MSPI_ST field.
	SPI1_CMD_MSPI_ST_Msk = 0xf0
	// Position of FLASH_PE field.
	SPI1_CMD_FLASH_PE_Pos = 0x11
	// Bit mask of FLASH_PE field.
	SPI1_CMD_FLASH_PE_Msk = 0x20000
	// Bit FLASH_PE.
	SPI1_CMD_FLASH_PE = 0x20000
	// Position of USR field.
	SPI1_CMD_USR_Pos = 0x12
	// Bit mask of USR field.
	SPI1_CMD_USR_Msk = 0x40000
	// Bit USR.
	SPI1_CMD_USR = 0x40000
	// Position of FLASH_HPM field.
	SPI1_CMD_FLASH_HPM_Pos = 0x13
	// Bit mask of FLASH_HPM field.
	SPI1_CMD_FLASH_HPM_Msk = 0x80000
	// Bit FLASH_HPM.
	SPI1_CMD_FLASH_HPM = 0x80000
	// Position of FLASH_RES field.
	SPI1_CMD_FLASH_RES_Pos = 0x14
	// Bit mask of FLASH_RES field.
	SPI1_CMD_FLASH_RES_Msk = 0x100000
	// Bit FLASH_RES.
	SPI1_CMD_FLASH_RES = 0x100000
	// Position of FLASH_DP field.
	SPI1_CMD_FLASH_DP_Pos = 0x15
	// Bit mask of FLASH_DP field.
	SPI1_CMD_FLASH_DP_Msk = 0x200000
	// Bit FLASH_DP.
	SPI1_CMD_FLASH_DP = 0x200000
	// Position of FLASH_CE field.
	SPI1_CMD_FLASH_CE_Pos = 0x16
	// Bit mask of FLASH_CE field.
	SPI1_CMD_FLASH_CE_Msk = 0x400000
	// Bit FLASH_CE.
	SPI1_CMD_FLASH_CE = 0x400000
	// Position of FLASH_BE field.
	SPI1_CMD_FLASH_BE_Pos = 0x17
	// Bit mask of FLASH_BE field.
	SPI1_CMD_FLASH_BE_Msk = 0x800000
	// Bit FLASH_BE.
	SPI1_CMD_FLASH_BE = 0x800000
	// Position of FLASH_SE field.
	SPI1_CMD_FLASH_SE_Pos = 0x18
	// Bit mask of FLASH_SE field.
	SPI1_CMD_FLASH_SE_Msk = 0x1000000
	// Bit FLASH_SE.
	SPI1_CMD_FLASH_SE = 0x1000000
	// Position of FLASH_PP field.
	SPI1_CMD_FLASH_PP_Pos = 0x19
	// Bit mask of FLASH_PP field.
	SPI1_CMD_FLASH_PP_Msk = 0x2000000
	// Bit FLASH_PP.
	SPI1_CMD_FLASH_PP = 0x2000000
	// Position of FLASH_WRSR field.
	SPI1_CMD_FLASH_WRSR_Pos = 0x1a
	// Bit mask of FLASH_WRSR field.
	SPI1_CMD_FLASH_WRSR_Msk = 0x4000000
	// Bit FLASH_WRSR.
	SPI1_CMD_FLASH_WRSR = 0x4000000
	// Position of FLASH_RDSR field.
	SPI1_CMD_FLASH_RDSR_Pos = 0x1b
	// Bit mask of FLASH_RDSR field.
	SPI1_CMD_FLASH_RDSR_Msk = 0x8000000
	// Bit FLASH_RDSR.
	SPI1_CMD_FLASH_RDSR = 0x8000000
	// Position of FLASH_RDID field.
	SPI1_CMD_FLASH_RDID_Pos = 0x1c
	// Bit mask of FLASH_RDID field.
	SPI1_CMD_FLASH_RDID_Msk = 0x10000000
	// Bit FLASH_RDID.
	SPI1_CMD_FLASH_RDID = 0x10000000
	// Position of FLASH_WRDI field.
	SPI1_CMD_FLASH_WRDI_Pos = 0x1d
	// Bit mask of FLASH_WRDI field.
	SPI1_CMD_FLASH_WRDI_Msk = 0x20000000
	// Bit FLASH_WRDI.
	SPI1_CMD_FLASH_WRDI = 0x20000000
	// Position of FLASH_WREN field.
	SPI1_CMD_FLASH_WREN_Pos = 0x1e
	// Bit mask of FLASH_WREN field.
	SPI1_CMD_FLASH_WREN_Msk = 0x40000000
	// Bit FLASH_WREN.
	SPI1_CMD_FLASH_WREN = 0x40000000
	// Position of FLASH_READ field.
	SPI1_CMD_FLASH_READ_Pos = 0x1f
	// Bit mask of FLASH_READ field.
	SPI1_CMD_FLASH_READ_Msk = 0x80000000
	// Bit FLASH_READ.
	SPI1_CMD_FLASH_READ = 0x80000000

	// ADDR: SPI1 address register
	// Position of USR_ADDR_VALUE field.
	SPI1_ADDR_USR_ADDR_VALUE_Pos = 0x0
	// Bit mask of USR_ADDR_VALUE field.
	SPI1_ADDR_USR_ADDR_VALUE_Msk = 0xffffffff

	// CTRL: SPI1 control register.
	// Position of FDUMMY_OUT field.
	SPI1_CTRL_FDUMMY_OUT_Pos = 0x3
	// Bit mask of FDUMMY_OUT field.
	SPI1_CTRL_FDUMMY_OUT_Msk = 0x8
	// Bit FDUMMY_OUT.
	SPI1_CTRL_FDUMMY_OUT = 0x8
	// Position of FCMD_DUAL field.
	SPI1_CTRL_FCMD_DUAL_Pos = 0x7
	// Bit mask of FCMD_DUAL field.
	SPI1_CTRL_FCMD_DUAL_Msk = 0x80
	// Bit FCMD_DUAL.
	SPI1_CTRL_FCMD_DUAL = 0x80
	// Position of FCMD_QUAD field.
	SPI1_CTRL_FCMD_QUAD_Pos = 0x8
	// Bit mask of FCMD_QUAD field.
	SPI1_CTRL_FCMD_QUAD_Msk = 0x100
	// Bit FCMD_QUAD.
	SPI1_CTRL_FCMD_QUAD = 0x100
	// Position of FCS_CRC_EN field.
	SPI1_CTRL_FCS_CRC_EN_Pos = 0xa
	// Bit mask of FCS_CRC_EN field.
	SPI1_CTRL_FCS_CRC_EN_Msk = 0x400
	// Bit FCS_CRC_EN.
	SPI1_CTRL_FCS_CRC_EN = 0x400
	// Position of TX_CRC_EN field.
	SPI1_CTRL_TX_CRC_EN_Pos = 0xb
	// Bit mask of TX_CRC_EN field.
	SPI1_CTRL_TX_CRC_EN_Msk = 0x800
	// Bit TX_CRC_EN.
	SPI1_CTRL_TX_CRC_EN = 0x800
	// Position of FASTRD_MODE field.
	SPI1_CTRL_FASTRD_MODE_Pos = 0xd
	// Bit mask of FASTRD_MODE field.
	SPI1_CTRL_FASTRD_MODE_Msk = 0x2000
	// Bit FASTRD_MODE.
	SPI1_CTRL_FASTRD_MODE = 0x2000
	// Position of FREAD_DUAL field.
	SPI1_CTRL_FREAD_DUAL_Pos = 0xe
	// Bit mask of FREAD_DUAL field.
	SPI1_CTRL_FREAD_DUAL_Msk = 0x4000
	// Bit FREAD_DUAL.
	SPI1_CTRL_FREAD_DUAL = 0x4000
	// Position of RESANDRES field.
	SPI1_CTRL_RESANDRES_Pos = 0xf
	// Bit mask of RESANDRES field.
	SPI1_CTRL_RESANDRES_Msk = 0x8000
	// Bit RESANDRES.
	SPI1_CTRL_RESANDRES = 0x8000
	// Position of Q_POL field.
	SPI1_CTRL_Q_POL_Pos = 0x12
	// Bit mask of Q_POL field.
	SPI1_CTRL_Q_POL_Msk = 0x40000
	// Bit Q_POL.
	SPI1_CTRL_Q_POL = 0x40000
	// Position of D_POL field.
	SPI1_CTRL_D_POL_Pos = 0x13
	// Bit mask of D_POL field.
	SPI1_CTRL_D_POL_Msk = 0x80000
	// Bit D_POL.
	SPI1_CTRL_D_POL = 0x80000
	// Position of FREAD_QUAD field.
	SPI1_CTRL_FREAD_QUAD_Pos = 0x14
	// Bit mask of FREAD_QUAD field.
	SPI1_CTRL_FREAD_QUAD_Msk = 0x100000
	// Bit FREAD_QUAD.
	SPI1_CTRL_FREAD_QUAD = 0x100000
	// Position of WP field.
	SPI1_CTRL_WP_Pos = 0x15
	// Bit mask of WP field.
	SPI1_CTRL_WP_Msk = 0x200000
	// Bit WP.
	SPI1_CTRL_WP = 0x200000
	// Position of WRSR_2B field.
	SPI1_CTRL_WRSR_2B_Pos = 0x16
	// Bit mask of WRSR_2B field.
	SPI1_CTRL_WRSR_2B_Msk = 0x400000
	// Bit WRSR_2B.
	SPI1_CTRL_WRSR_2B = 0x400000
	// Position of FREAD_DIO field.
	SPI1_CTRL_FREAD_DIO_Pos = 0x17
	// Bit mask of FREAD_DIO field.
	SPI1_CTRL_FREAD_DIO_Msk = 0x800000
	// Bit FREAD_DIO.
	SPI1_CTRL_FREAD_DIO = 0x800000
	// Position of FREAD_QIO field.
	SPI1_CTRL_FREAD_QIO_Pos = 0x18
	// Bit mask of FREAD_QIO field.
	SPI1_CTRL_FREAD_QIO_Msk = 0x1000000
	// Bit FREAD_QIO.
	SPI1_CTRL_FREAD_QIO = 0x1000000

	// CTRL1: SPI1 control1 register.
	// Position of CLK_MODE field.
	SPI1_CTRL1_CLK_MODE_Pos = 0x0
	// Bit mask of CLK_MODE field.
	SPI1_CTRL1_CLK_MODE_Msk = 0x3
	// Position of CS_HOLD_DLY_RES field.
	SPI1_CTRL1_CS_HOLD_DLY_RES_Pos = 0x2
	// Bit mask of CS_HOLD_DLY_RES field.
	SPI1_CTRL1_CS_HOLD_DLY_RES_Msk = 0xffc

	// CTRL2: SPI1 control2 register.
	// Position of SYNC_RESET field.
	SPI1_CTRL2_SYNC_RESET_Pos = 0x1f
	// Bit mask of SYNC_RESET field.
	SPI1_CTRL2_SYNC_RESET_Msk = 0x80000000
	// Bit SYNC_RESET.
	SPI1_CTRL2_SYNC_RESET = 0x80000000

	// CLOCK: SPI1 clock division control register.
	// Position of CLKCNT_L field.
	SPI1_CLOCK_CLKCNT_L_Pos = 0x0
	// Bit mask of CLKCNT_L field.
	SPI1_CLOCK_CLKCNT_L_Msk = 0xff
	// Position of CLKCNT_H field.
	SPI1_CLOCK_CLKCNT_H_Pos = 0x8
	// Bit mask of CLKCNT_H field.
	SPI1_CLOCK_CLKCNT_H_Msk = 0xff00
	// Position of CLKCNT_N field.
	SPI1_CLOCK_CLKCNT_N_Pos = 0x10
	// Bit mask of CLKCNT_N field.
	SPI1_CLOCK_CLKCNT_N_Msk = 0xff0000
	// Position of CLK_EQU_SYSCLK field.
	SPI1_CLOCK_CLK_EQU_SYSCLK_Pos = 0x1f
	// Bit mask of CLK_EQU_SYSCLK field.
	SPI1_CLOCK_CLK_EQU_SYSCLK_Msk = 0x80000000
	// Bit CLK_EQU_SYSCLK.
	SPI1_CLOCK_CLK_EQU_SYSCLK = 0x80000000

	// USER: SPI1 user register.
	// Position of CK_OUT_EDGE field.
	SPI1_USER_CK_OUT_EDGE_Pos = 0x9
	// Bit mask of CK_OUT_EDGE field.
	SPI1_USER_CK_OUT_EDGE_Msk = 0x200
	// Bit CK_OUT_EDGE.
	SPI1_USER_CK_OUT_EDGE = 0x200
	// Position of FWRITE_DUAL field.
	SPI1_USER_FWRITE_DUAL_Pos = 0xc
	// Bit mask of FWRITE_DUAL field.
	SPI1_USER_FWRITE_DUAL_Msk = 0x1000
	// Bit FWRITE_DUAL.
	SPI1_USER_FWRITE_DUAL = 0x1000
	// Position of FWRITE_QUAD field.
	SPI1_USER_FWRITE_QUAD_Pos = 0xd
	// Bit mask of FWRITE_QUAD field.
	SPI1_USER_FWRITE_QUAD_Msk = 0x2000
	// Bit FWRITE_QUAD.
	SPI1_USER_FWRITE_QUAD = 0x2000
	// Position of FWRITE_DIO field.
	SPI1_USER_FWRITE_DIO_Pos = 0xe
	// Bit mask of FWRITE_DIO field.
	SPI1_USER_FWRITE_DIO_Msk = 0x4000
	// Bit FWRITE_DIO.
	SPI1_USER_FWRITE_DIO = 0x4000
	// Position of FWRITE_QIO field.
	SPI1_USER_FWRITE_QIO_Pos = 0xf
	// Bit mask of FWRITE_QIO field.
	SPI1_USER_FWRITE_QIO_Msk = 0x8000
	// Bit FWRITE_QIO.
	SPI1_USER_FWRITE_QIO = 0x8000
	// Position of USR_MISO_HIGHPART field.
	SPI1_USER_USR_MISO_HIGHPART_Pos = 0x18
	// Bit mask of USR_MISO_HIGHPART field.
	SPI1_USER_USR_MISO_HIGHPART_Msk = 0x1000000
	// Bit USR_MISO_HIGHPART.
	SPI1_USER_USR_MISO_HIGHPART = 0x1000000
	// Position of USR_MOSI_HIGHPART field.
	SPI1_USER_USR_MOSI_HIGHPART_Pos = 0x19
	// Bit mask of USR_MOSI_HIGHPART field.
	SPI1_USER_USR_MOSI_HIGHPART_Msk = 0x2000000
	// Bit USR_MOSI_HIGHPART.
	SPI1_USER_USR_MOSI_HIGHPART = 0x2000000
	// Position of USR_DUMMY_IDLE field.
	SPI1_USER_USR_DUMMY_IDLE_Pos = 0x1a
	// Bit mask of USR_DUMMY_IDLE field.
	SPI1_USER_USR_DUMMY_IDLE_Msk = 0x4000000
	// Bit USR_DUMMY_IDLE.
	SPI1_USER_USR_DUMMY_IDLE = 0x4000000
	// Position of USR_MOSI field.
	SPI1_USER_USR_MOSI_Pos = 0x1b
	// Bit mask of USR_MOSI field.
	SPI1_USER_USR_MOSI_Msk = 0x8000000
	// Bit USR_MOSI.
	SPI1_USER_USR_MOSI = 0x8000000
	// Position of USR_MISO field.
	SPI1_USER_USR_MISO_Pos = 0x1c
	// Bit mask of USR_MISO field.
	SPI1_USER_USR_MISO_Msk = 0x10000000
	// Bit USR_MISO.
	SPI1_USER_USR_MISO = 0x10000000
	// Position of USR_DUMMY field.
	SPI1_USER_USR_DUMMY_Pos = 0x1d
	// Bit mask of USR_DUMMY field.
	SPI1_USER_USR_DUMMY_Msk = 0x20000000
	// Bit USR_DUMMY.
	SPI1_USER_USR_DUMMY = 0x20000000
	// Position of USR_ADDR field.
	SPI1_USER_USR_ADDR_Pos = 0x1e
	// Bit mask of USR_ADDR field.
	SPI1_USER_USR_ADDR_Msk = 0x40000000
	// Bit USR_ADDR.
	SPI1_USER_USR_ADDR = 0x40000000
	// Position of USR_COMMAND field.
	SPI1_USER_USR_COMMAND_Pos = 0x1f
	// Bit mask of USR_COMMAND field.
	SPI1_USER_USR_COMMAND_Msk = 0x80000000
	// Bit USR_COMMAND.
	SPI1_USER_USR_COMMAND = 0x80000000

	// USER1: SPI1 user1 register.
	// Position of USR_DUMMY_CYCLELEN field.
	SPI1_USER1_USR_DUMMY_CYCLELEN_Pos = 0x0
	// Bit mask of USR_DUMMY_CYCLELEN field.
	SPI1_USER1_USR_DUMMY_CYCLELEN_Msk = 0x3f
	// Position of USR_ADDR_BITLEN field.
	SPI1_USER1_USR_ADDR_BITLEN_Pos = 0x1a
	// Bit mask of USR_ADDR_BITLEN field.
	SPI1_USER1_USR_ADDR_BITLEN_Msk = 0xfc000000

	// USER2: SPI1 user2 register.
	// Position of USR_COMMAND_VALUE field.
	SPI1_USER2_USR_COMMAND_VALUE_Pos = 0x0
	// Bit mask of USR_COMMAND_VALUE field.
	SPI1_USER2_USR_COMMAND_VALUE_Msk = 0xffff
	// Position of USR_COMMAND_BITLEN field.
	SPI1_USER2_USR_COMMAND_BITLEN_Pos = 0x1c
	// Bit mask of USR_COMMAND_BITLEN field.
	SPI1_USER2_USR_COMMAND_BITLEN_Msk = 0xf0000000

	// MOSI_DLEN: SPI1 send data bit length control register.
	// Position of USR_MOSI_DBITLEN field.
	SPI1_MOSI_DLEN_USR_MOSI_DBITLEN_Pos = 0x0
	// Bit mask of USR_MOSI_DBITLEN field.
	SPI1_MOSI_DLEN_USR_MOSI_DBITLEN_Msk = 0x3ff

	// MISO_DLEN: SPI1 receive data bit length control register.
	// Position of USR_MISO_DBITLEN field.
	SPI1_MISO_DLEN_USR_MISO_DBITLEN_Pos = 0x0
	// Bit mask of USR_MISO_DBITLEN field.
	SPI1_MISO_DLEN_USR_MISO_DBITLEN_Msk = 0x3ff

	// RD_STATUS: SPI1 status register.
	// Position of STATUS field.
	SPI1_RD_STATUS_STATUS_Pos = 0x0
	// Bit mask of STATUS field.
	SPI1_RD_STATUS_STATUS_Msk = 0xffff
	// Position of WB_MODE field.
	SPI1_RD_STATUS_WB_MODE_Pos = 0x10
	// Bit mask of WB_MODE field.
	SPI1_RD_STATUS_WB_MODE_Msk = 0xff0000

	// MISC: SPI1 misc register
	// Position of CS0_DIS field.
	SPI1_MISC_CS0_DIS_Pos = 0x0
	// Bit mask of CS0_DIS field.
	SPI1_MISC_CS0_DIS_Msk = 0x1
	// Bit CS0_DIS.
	SPI1_MISC_CS0_DIS = 0x1
	// Position of CS1_DIS field.
	SPI1_MISC_CS1_DIS_Pos = 0x1
	// Bit mask of CS1_DIS field.
	SPI1_MISC_CS1_DIS_Msk = 0x2
	// Bit CS1_DIS.
	SPI1_MISC_CS1_DIS = 0x2
	// Position of CK_IDLE_EDGE field.
	SPI1_MISC_CK_IDLE_EDGE_Pos = 0x9
	// Bit mask of CK_IDLE_EDGE field.
	SPI1_MISC_CK_IDLE_EDGE_Msk = 0x200
	// Bit CK_IDLE_EDGE.
	SPI1_MISC_CK_IDLE_EDGE = 0x200
	// Position of CS_KEEP_ACTIVE field.
	SPI1_MISC_CS_KEEP_ACTIVE_Pos = 0xa
	// Bit mask of CS_KEEP_ACTIVE field.
	SPI1_MISC_CS_KEEP_ACTIVE_Msk = 0x400
	// Bit CS_KEEP_ACTIVE.
	SPI1_MISC_CS_KEEP_ACTIVE = 0x400

	// TX_CRC: SPI1 TX CRC data register.
	// Position of DATA field.
	SPI1_TX_CRC_DATA_Pos = 0x0
	// Bit mask of DATA field.
	SPI1_TX_CRC_DATA_Msk = 0xffffffff

	// CACHE_FCTRL: SPI1 bit mode control register.
	// Position of CACHE_USR_ADDR_4BYTE field.
	SPI1_CACHE_FCTRL_CACHE_USR_ADDR_4BYTE_Pos = 0x1
	// Bit mask of CACHE_USR_ADDR_4BYTE field.
	SPI1_CACHE_FCTRL_CACHE_USR_ADDR_4BYTE_Msk = 0x2
	// Bit CACHE_USR_ADDR_4BYTE.
	SPI1_CACHE_FCTRL_CACHE_USR_ADDR_4BYTE = 0x2
	// Position of FDIN_DUAL field.
	SPI1_CACHE_FCTRL_FDIN_DUAL_Pos = 0x3
	// Bit mask of FDIN_DUAL field.
	SPI1_CACHE_FCTRL_FDIN_DUAL_Msk = 0x8
	// Bit FDIN_DUAL.
	SPI1_CACHE_FCTRL_FDIN_DUAL = 0x8
	// Position of FDOUT_DUAL field.
	SPI1_CACHE_FCTRL_FDOUT_DUAL_Pos = 0x4
	// Bit mask of FDOUT_DUAL field.
	SPI1_CACHE_FCTRL_FDOUT_DUAL_Msk = 0x10
	// Bit FDOUT_DUAL.
	SPI1_CACHE_FCTRL_FDOUT_DUAL = 0x10
	// Position of FADDR_DUAL field.
	SPI1_CACHE_FCTRL_FADDR_DUAL_Pos = 0x5
	// Bit mask of FADDR_DUAL field.
	SPI1_CACHE_FCTRL_FADDR_DUAL_Msk = 0x20
	// Bit FADDR_DUAL.
	SPI1_CACHE_FCTRL_FADDR_DUAL = 0x20
	// Position of FDIN_QUAD field.
	SPI1_CACHE_FCTRL_FDIN_QUAD_Pos = 0x6
	// Bit mask of FDIN_QUAD field.
	SPI1_CACHE_FCTRL_FDIN_QUAD_Msk = 0x40
	// Bit FDIN_QUAD.
	SPI1_CACHE_FCTRL_FDIN_QUAD = 0x40
	// Position of FDOUT_QUAD field.
	SPI1_CACHE_FCTRL_FDOUT_QUAD_Pos = 0x7
	// Bit mask of FDOUT_QUAD field.
	SPI1_CACHE_FCTRL_FDOUT_QUAD_Msk = 0x80
	// Bit FDOUT_QUAD.
	SPI1_CACHE_FCTRL_FDOUT_QUAD = 0x80
	// Position of FADDR_QUAD field.
	SPI1_CACHE_FCTRL_FADDR_QUAD_Pos = 0x8
	// Bit mask of FADDR_QUAD field.
	SPI1_CACHE_FCTRL_FADDR_QUAD_Msk = 0x100
	// Bit FADDR_QUAD.
	SPI1_CACHE_FCTRL_FADDR_QUAD = 0x100

	// W0: SPI1 memory data buffer0
	// Position of BUF0 field.
	SPI1_W0_BUF0_Pos = 0x0
	// Bit mask of BUF0 field.
	SPI1_W0_BUF0_Msk = 0xffffffff

	// W1: SPI1 memory data buffer1
	// Position of BUF1 field.
	SPI1_W1_BUF1_Pos = 0x0
	// Bit mask of BUF1 field.
	SPI1_W1_BUF1_Msk = 0xffffffff

	// W2: SPI1 memory data buffer2
	// Position of BUF2 field.
	SPI1_W2_BUF2_Pos = 0x0
	// Bit mask of BUF2 field.
	SPI1_W2_BUF2_Msk = 0xffffffff

	// W3: SPI1 memory data buffer3
	// Position of BUF3 field.
	SPI1_W3_BUF3_Pos = 0x0
	// Bit mask of BUF3 field.
	SPI1_W3_BUF3_Msk = 0xffffffff

	// W4: SPI1 memory data buffer4
	// Position of BUF4 field.
	SPI1_W4_BUF4_Pos = 0x0
	// Bit mask of BUF4 field.
	SPI1_W4_BUF4_Msk = 0xffffffff

	// W5: SPI1 memory data buffer5
	// Position of BUF5 field.
	SPI1_W5_BUF5_Pos = 0x0
	// Bit mask of BUF5 field.
	SPI1_W5_BUF5_Msk = 0xffffffff

	// W6: SPI1 memory data buffer6
	// Position of BUF6 field.
	SPI1_W6_BUF6_Pos = 0x0
	// Bit mask of BUF6 field.
	SPI1_W6_BUF6_Msk = 0xffffffff

	// W7: SPI1 memory data buffer7
	// Position of BUF7 field.
	SPI1_W7_BUF7_Pos = 0x0
	// Bit mask of BUF7 field.
	SPI1_W7_BUF7_Msk = 0xffffffff

	// W8: SPI1 memory data buffer8
	// Position of BUF8 field.
	SPI1_W8_BUF8_Pos = 0x0
	// Bit mask of BUF8 field.
	SPI1_W8_BUF8_Msk = 0xffffffff

	// W9: SPI1 memory data buffer9
	// Position of BUF9 field.
	SPI1_W9_BUF9_Pos = 0x0
	// Bit mask of BUF9 field.
	SPI1_W9_BUF9_Msk = 0xffffffff

	// W10: SPI1 memory data buffer10
	// Position of BUF10 field.
	SPI1_W10_BUF10_Pos = 0x0
	// Bit mask of BUF10 field.
	SPI1_W10_BUF10_Msk = 0xffffffff

	// W11: SPI1 memory data buffer11
	// Position of BUF11 field.
	SPI1_W11_BUF11_Pos = 0x0
	// Bit mask of BUF11 field.
	SPI1_W11_BUF11_Msk = 0xffffffff

	// W12: SPI1 memory data buffer12
	// Position of BUF12 field.
	SPI1_W12_BUF12_Pos = 0x0
	// Bit mask of BUF12 field.
	SPI1_W12_BUF12_Msk = 0xffffffff

	// W13: SPI1 memory data buffer13
	// Position of BUF13 field.
	SPI1_W13_BUF13_Pos = 0x0
	// Bit mask of BUF13 field.
	SPI1_W13_BUF13_Msk = 0xffffffff

	// W14: SPI1 memory data buffer14
	// Position of BUF14 field.
	SPI1_W14_BUF14_Pos = 0x0
	// Bit mask of BUF14 field.
	SPI1_W14_BUF14_Msk = 0xffffffff

	// W15: SPI1 memory data buffer15
	// Position of BUF15 field.
	SPI1_W15_BUF15_Pos = 0x0
	// Bit mask of BUF15 field.
	SPI1_W15_BUF15_Msk = 0xffffffff

	// FLASH_WAITI_CTRL: SPI1 wait idle control register
	// Position of WAITI_DUMMY field.
	SPI1_FLASH_WAITI_CTRL_WAITI_DUMMY_Pos = 0x1
	// Bit mask of WAITI_DUMMY field.
	SPI1_FLASH_WAITI_CTRL_WAITI_DUMMY_Msk = 0x2
	// Bit WAITI_DUMMY.
	SPI1_FLASH_WAITI_CTRL_WAITI_DUMMY = 0x2
	// Position of WAITI_CMD field.
	SPI1_FLASH_WAITI_CTRL_WAITI_CMD_Pos = 0x2
	// Bit mask of WAITI_CMD field.
	SPI1_FLASH_WAITI_CTRL_WAITI_CMD_Msk = 0x3fc
	// Position of WAITI_DUMMY_CYCLELEN field.
	SPI1_FLASH_WAITI_CTRL_WAITI_DUMMY_CYCLELEN_Pos = 0xa
	// Bit mask of WAITI_DUMMY_CYCLELEN field.
	SPI1_FLASH_WAITI_CTRL_WAITI_DUMMY_CYCLELEN_Msk = 0xfc00

	// FLASH_SUS_CTRL: SPI1 flash suspend control register
	// Position of FLASH_PER field.
	SPI1_FLASH_SUS_CTRL_FLASH_PER_Pos = 0x0
	// Bit mask of FLASH_PER field.
	SPI1_FLASH_SUS_CTRL_FLASH_PER_Msk = 0x1
	// Bit FLASH_PER.
	SPI1_FLASH_SUS_CTRL_FLASH_PER = 0x1
	// Position of FLASH_PES field.
	SPI1_FLASH_SUS_CTRL_FLASH_PES_Pos = 0x1
	// Bit mask of FLASH_PES field.
	SPI1_FLASH_SUS_CTRL_FLASH_PES_Msk = 0x2
	// Bit FLASH_PES.
	SPI1_FLASH_SUS_CTRL_FLASH_PES = 0x2
	// Position of FLASH_PER_WAIT_EN field.
	SPI1_FLASH_SUS_CTRL_FLASH_PER_WAIT_EN_Pos = 0x2
	// Bit mask of FLASH_PER_WAIT_EN field.
	SPI1_FLASH_SUS_CTRL_FLASH_PER_WAIT_EN_Msk = 0x4
	// Bit FLASH_PER_WAIT_EN.
	SPI1_FLASH_SUS_CTRL_FLASH_PER_WAIT_EN = 0x4
	// Position of FLASH_PES_WAIT_EN field.
	SPI1_FLASH_SUS_CTRL_FLASH_PES_WAIT_EN_Pos = 0x3
	// Bit mask of FLASH_PES_WAIT_EN field.
	SPI1_FLASH_SUS_CTRL_FLASH_PES_WAIT_EN_Msk = 0x8
	// Bit FLASH_PES_WAIT_EN.
	SPI1_FLASH_SUS_CTRL_FLASH_PES_WAIT_EN = 0x8
	// Position of PES_PER_EN field.
	SPI1_FLASH_SUS_CTRL_PES_PER_EN_Pos = 0x4
	// Bit mask of PES_PER_EN field.
	SPI1_FLASH_SUS_CTRL_PES_PER_EN_Msk = 0x10
	// Bit PES_PER_EN.
	SPI1_FLASH_SUS_CTRL_PES_PER_EN = 0x10
	// Position of FLASH_PES_EN field.
	SPI1_FLASH_SUS_CTRL_FLASH_PES_EN_Pos = 0x5
	// Bit mask of FLASH_PES_EN field.
	SPI1_FLASH_SUS_CTRL_FLASH_PES_EN_Msk = 0x20
	// Bit FLASH_PES_EN.
	SPI1_FLASH_SUS_CTRL_FLASH_PES_EN = 0x20
	// Position of PESR_END_MSK field.
	SPI1_FLASH_SUS_CTRL_PESR_END_MSK_Pos = 0x6
	// Bit mask of PESR_END_MSK field.
	SPI1_FLASH_SUS_CTRL_PESR_END_MSK_Msk = 0x3fffc0
	// Position of RD_SUS_2B field.
	SPI1_FLASH_SUS_CTRL_RD_SUS_2B_Pos = 0x16
	// Bit mask of RD_SUS_2B field.
	SPI1_FLASH_SUS_CTRL_RD_SUS_2B_Msk = 0x400000
	// Bit RD_SUS_2B.
	SPI1_FLASH_SUS_CTRL_RD_SUS_2B = 0x400000
	// Position of PER_END_EN field.
	SPI1_FLASH_SUS_CTRL_PER_END_EN_Pos = 0x17
	// Bit mask of PER_END_EN field.
	SPI1_FLASH_SUS_CTRL_PER_END_EN_Msk = 0x800000
	// Bit PER_END_EN.
	SPI1_FLASH_SUS_CTRL_PER_END_EN = 0x800000
	// Position of PES_END_EN field.
	SPI1_FLASH_SUS_CTRL_PES_END_EN_Pos = 0x18
	// Bit mask of PES_END_EN field.
	SPI1_FLASH_SUS_CTRL_PES_END_EN_Msk = 0x1000000
	// Bit PES_END_EN.
	SPI1_FLASH_SUS_CTRL_PES_END_EN = 0x1000000
	// Position of SUS_TIMEOUT_CNT field.
	SPI1_FLASH_SUS_CTRL_SUS_TIMEOUT_CNT_Pos = 0x19
	// Bit mask of SUS_TIMEOUT_CNT field.
	SPI1_FLASH_SUS_CTRL_SUS_TIMEOUT_CNT_Msk = 0xfe000000

	// FLASH_SUS_CMD: SPI1 flash suspend command register
	// Position of FLASH_PER_COMMAND field.
	SPI1_FLASH_SUS_CMD_FLASH_PER_COMMAND_Pos = 0x0
	// Bit mask of FLASH_PER_COMMAND field.
	SPI1_FLASH_SUS_CMD_FLASH_PER_COMMAND_Msk = 0xff
	// Position of FLASH_PES_COMMAND field.
	SPI1_FLASH_SUS_CMD_FLASH_PES_COMMAND_Pos = 0x8
	// Bit mask of FLASH_PES_COMMAND field.
	SPI1_FLASH_SUS_CMD_FLASH_PES_COMMAND_Msk = 0xff00
	// Position of WAIT_PESR_COMMAND field.
	SPI1_FLASH_SUS_CMD_WAIT_PESR_COMMAND_Pos = 0x10
	// Bit mask of WAIT_PESR_COMMAND field.
	SPI1_FLASH_SUS_CMD_WAIT_PESR_COMMAND_Msk = 0xffff0000

	// SUS_STATUS: SPI1 flash suspend status register
	// Position of FLASH_SUS field.
	SPI1_SUS_STATUS_FLASH_SUS_Pos = 0x0
	// Bit mask of FLASH_SUS field.
	SPI1_SUS_STATUS_FLASH_SUS_Msk = 0x1
	// Bit FLASH_SUS.
	SPI1_SUS_STATUS_FLASH_SUS = 0x1
	// Position of WAIT_PESR_CMD_2B field.
	SPI1_SUS_STATUS_WAIT_PESR_CMD_2B_Pos = 0x1
	// Bit mask of WAIT_PESR_CMD_2B field.
	SPI1_SUS_STATUS_WAIT_PESR_CMD_2B_Msk = 0x2
	// Bit WAIT_PESR_CMD_2B.
	SPI1_SUS_STATUS_WAIT_PESR_CMD_2B = 0x2
	// Position of FLASH_HPM_DLY_128 field.
	SPI1_SUS_STATUS_FLASH_HPM_DLY_128_Pos = 0x2
	// Bit mask of FLASH_HPM_DLY_128 field.
	SPI1_SUS_STATUS_FLASH_HPM_DLY_128_Msk = 0x4
	// Bit FLASH_HPM_DLY_128.
	SPI1_SUS_STATUS_FLASH_HPM_DLY_128 = 0x4
	// Position of FLASH_RES_DLY_128 field.
	SPI1_SUS_STATUS_FLASH_RES_DLY_128_Pos = 0x3
	// Bit mask of FLASH_RES_DLY_128 field.
	SPI1_SUS_STATUS_FLASH_RES_DLY_128_Msk = 0x8
	// Bit FLASH_RES_DLY_128.
	SPI1_SUS_STATUS_FLASH_RES_DLY_128 = 0x8
	// Position of FLASH_DP_DLY_128 field.
	SPI1_SUS_STATUS_FLASH_DP_DLY_128_Pos = 0x4
	// Bit mask of FLASH_DP_DLY_128 field.
	SPI1_SUS_STATUS_FLASH_DP_DLY_128_Msk = 0x10
	// Bit FLASH_DP_DLY_128.
	SPI1_SUS_STATUS_FLASH_DP_DLY_128 = 0x10
	// Position of FLASH_PER_DLY_128 field.
	SPI1_SUS_STATUS_FLASH_PER_DLY_128_Pos = 0x5
	// Bit mask of FLASH_PER_DLY_128 field.
	SPI1_SUS_STATUS_FLASH_PER_DLY_128_Msk = 0x20
	// Bit FLASH_PER_DLY_128.
	SPI1_SUS_STATUS_FLASH_PER_DLY_128 = 0x20
	// Position of FLASH_PES_DLY_128 field.
	SPI1_SUS_STATUS_FLASH_PES_DLY_128_Pos = 0x6
	// Bit mask of FLASH_PES_DLY_128 field.
	SPI1_SUS_STATUS_FLASH_PES_DLY_128_Msk = 0x40
	// Bit FLASH_PES_DLY_128.
	SPI1_SUS_STATUS_FLASH_PES_DLY_128 = 0x40
	// Position of SPI0_LOCK_EN field.
	SPI1_SUS_STATUS_SPI0_LOCK_EN_Pos = 0x7
	// Bit mask of SPI0_LOCK_EN field.
	SPI1_SUS_STATUS_SPI0_LOCK_EN_Msk = 0x80
	// Bit SPI0_LOCK_EN.
	SPI1_SUS_STATUS_SPI0_LOCK_EN = 0x80

	// TIMING_CALI: SPI1 timing control register
	// Position of TIMING_CALI field.
	SPI1_TIMING_CALI_TIMING_CALI_Pos = 0x1
	// Bit mask of TIMING_CALI field.
	SPI1_TIMING_CALI_TIMING_CALI_Msk = 0x2
	// Bit TIMING_CALI.
	SPI1_TIMING_CALI_TIMING_CALI = 0x2
	// Position of EXTRA_DUMMY_CYCLELEN field.
	SPI1_TIMING_CALI_EXTRA_DUMMY_CYCLELEN_Pos = 0x2
	// Bit mask of EXTRA_DUMMY_CYCLELEN field.
	SPI1_TIMING_CALI_EXTRA_DUMMY_CYCLELEN_Msk = 0x1c

	// INT_ENA: SPI1 interrupt enable register
	// Position of PER_END_INT_ENA field.
	SPI1_INT_ENA_PER_END_INT_ENA_Pos = 0x0
	// Bit mask of PER_END_INT_ENA field.
	SPI1_INT_ENA_PER_END_INT_ENA_Msk = 0x1
	// Bit PER_END_INT_ENA.
	SPI1_INT_ENA_PER_END_INT_ENA = 0x1
	// Position of PES_END_INT_ENA field.
	SPI1_INT_ENA_PES_END_INT_ENA_Pos = 0x1
	// Bit mask of PES_END_INT_ENA field.
	SPI1_INT_ENA_PES_END_INT_ENA_Msk = 0x2
	// Bit PES_END_INT_ENA.
	SPI1_INT_ENA_PES_END_INT_ENA = 0x2
	// Position of WPE_END_INT_ENA field.
	SPI1_INT_ENA_WPE_END_INT_ENA_Pos = 0x2
	// Bit mask of WPE_END_INT_ENA field.
	SPI1_INT_ENA_WPE_END_INT_ENA_Msk = 0x4
	// Bit WPE_END_INT_ENA.
	SPI1_INT_ENA_WPE_END_INT_ENA = 0x4
	// Position of SLV_ST_END_INT_ENA field.
	SPI1_INT_ENA_SLV_ST_END_INT_ENA_Pos = 0x3
	// Bit mask of SLV_ST_END_INT_ENA field.
	SPI1_INT_ENA_SLV_ST_END_INT_ENA_Msk = 0x8
	// Bit SLV_ST_END_INT_ENA.
	SPI1_INT_ENA_SLV_ST_END_INT_ENA = 0x8
	// Position of MST_ST_END_INT_ENA field.
	SPI1_INT_ENA_MST_ST_END_INT_ENA_Pos = 0x4
	// Bit mask of MST_ST_END_INT_ENA field.
	SPI1_INT_ENA_MST_ST_END_INT_ENA_Msk = 0x10
	// Bit MST_ST_END_INT_ENA.
	SPI1_INT_ENA_MST_ST_END_INT_ENA = 0x10

	// INT_CLR: SPI1 interrupt clear register
	// Position of PER_END_INT_CLR field.
	SPI1_INT_CLR_PER_END_INT_CLR_Pos = 0x0
	// Bit mask of PER_END_INT_CLR field.
	SPI1_INT_CLR_PER_END_INT_CLR_Msk = 0x1
	// Bit PER_END_INT_CLR.
	SPI1_INT_CLR_PER_END_INT_CLR = 0x1
	// Position of PES_END_INT_CLR field.
	SPI1_INT_CLR_PES_END_INT_CLR_Pos = 0x1
	// Bit mask of PES_END_INT_CLR field.
	SPI1_INT_CLR_PES_END_INT_CLR_Msk = 0x2
	// Bit PES_END_INT_CLR.
	SPI1_INT_CLR_PES_END_INT_CLR = 0x2
	// Position of WPE_END_INT_CLR field.
	SPI1_INT_CLR_WPE_END_INT_CLR_Pos = 0x2
	// Bit mask of WPE_END_INT_CLR field.
	SPI1_INT_CLR_WPE_END_INT_CLR_Msk = 0x4
	// Bit WPE_END_INT_CLR.
	SPI1_INT_CLR_WPE_END_INT_CLR = 0x4
	// Position of SLV_ST_END_INT_CLR field.
	SPI1_INT_CLR_SLV_ST_END_INT_CLR_Pos = 0x3
	// Bit mask of SLV_ST_END_INT_CLR field.
	SPI1_INT_CLR_SLV_ST_END_INT_CLR_Msk = 0x8
	// Bit SLV_ST_END_INT_CLR.
	SPI1_INT_CLR_SLV_ST_END_INT_CLR = 0x8
	// Position of MST_ST_END_INT_CLR field.
	SPI1_INT_CLR_MST_ST_END_INT_CLR_Pos = 0x4
	// Bit mask of MST_ST_END_INT_CLR field.
	SPI1_INT_CLR_MST_ST_END_INT_CLR_Msk = 0x10
	// Bit MST_ST_END_INT_CLR.
	SPI1_INT_CLR_MST_ST_END_INT_CLR = 0x10

	// INT_RAW: SPI1 interrupt raw register
	// Position of PER_END_INT_RAW field.
	SPI1_INT_RAW_PER_END_INT_RAW_Pos = 0x0
	// Bit mask of PER_END_INT_RAW field.
	SPI1_INT_RAW_PER_END_INT_RAW_Msk = 0x1
	// Bit PER_END_INT_RAW.
	SPI1_INT_RAW_PER_END_INT_RAW = 0x1
	// Position of PES_END_INT_RAW field.
	SPI1_INT_RAW_PES_END_INT_RAW_Pos = 0x1
	// Bit mask of PES_END_INT_RAW field.
	SPI1_INT_RAW_PES_END_INT_RAW_Msk = 0x2
	// Bit PES_END_INT_RAW.
	SPI1_INT_RAW_PES_END_INT_RAW = 0x2
	// Position of WPE_END_INT_RAW field.
	SPI1_INT_RAW_WPE_END_INT_RAW_Pos = 0x2
	// Bit mask of WPE_END_INT_RAW field.
	SPI1_INT_RAW_WPE_END_INT_RAW_Msk = 0x4
	// Bit WPE_END_INT_RAW.
	SPI1_INT_RAW_WPE_END_INT_RAW = 0x4
	// Position of SLV_ST_END_INT_RAW field.
	SPI1_INT_RAW_SLV_ST_END_INT_RAW_Pos = 0x3
	// Bit mask of SLV_ST_END_INT_RAW field.
	SPI1_INT_RAW_SLV_ST_END_INT_RAW_Msk = 0x8
	// Bit SLV_ST_END_INT_RAW.
	SPI1_INT_RAW_SLV_ST_END_INT_RAW = 0x8
	// Position of MST_ST_END_INT_RAW field.
	SPI1_INT_RAW_MST_ST_END_INT_RAW_Pos = 0x4
	// Bit mask of MST_ST_END_INT_RAW field.
	SPI1_INT_RAW_MST_ST_END_INT_RAW_Msk = 0x10
	// Bit MST_ST_END_INT_RAW.
	SPI1_INT_RAW_MST_ST_END_INT_RAW = 0x10

	// INT_ST: SPI1 interrupt status register
	// Position of PER_END_INT_ST field.
	SPI1_INT_ST_PER_END_INT_ST_Pos = 0x0
	// Bit mask of PER_END_INT_ST field.
	SPI1_INT_ST_PER_END_INT_ST_Msk = 0x1
	// Bit PER_END_INT_ST.
	SPI1_INT_ST_PER_END_INT_ST = 0x1
	// Position of PES_END_INT_ST field.
	SPI1_INT_ST_PES_END_INT_ST_Pos = 0x1
	// Bit mask of PES_END_INT_ST field.
	SPI1_INT_ST_PES_END_INT_ST_Msk = 0x2
	// Bit PES_END_INT_ST.
	SPI1_INT_ST_PES_END_INT_ST = 0x2
	// Position of WPE_END_INT_ST field.
	SPI1_INT_ST_WPE_END_INT_ST_Pos = 0x2
	// Bit mask of WPE_END_INT_ST field.
	SPI1_INT_ST_WPE_END_INT_ST_Msk = 0x4
	// Bit WPE_END_INT_ST.
	SPI1_INT_ST_WPE_END_INT_ST = 0x4
	// Position of SLV_ST_END_INT_ST field.
	SPI1_INT_ST_SLV_ST_END_INT_ST_Pos = 0x3
	// Bit mask of SLV_ST_END_INT_ST field.
	SPI1_INT_ST_SLV_ST_END_INT_ST_Msk = 0x8
	// Bit SLV_ST_END_INT_ST.
	SPI1_INT_ST_SLV_ST_END_INT_ST = 0x8
	// Position of MST_ST_END_INT_ST field.
	SPI1_INT_ST_MST_ST_END_INT_ST_Pos = 0x4
	// Bit mask of MST_ST_END_INT_ST field.
	SPI1_INT_ST_MST_ST_END_INT_ST_Msk = 0x10
	// Bit MST_ST_END_INT_ST.
	SPI1_INT_ST_MST_ST_END_INT_ST = 0x10

	// CLOCK_GATE: SPI1 clk_gate register
	// Position of CLK_EN field.
	SPI1_CLOCK_GATE_CLK_EN_Pos = 0x0
	// Bit mask of CLK_EN field.
	SPI1_CLOCK_GATE_CLK_EN_Msk = 0x1
	// Bit CLK_EN.
	SPI1_CLOCK_GATE_CLK_EN = 0x1

	// DATE: Version control register
	// Position of DATE field.
	SPI1_DATE_DATE_Pos = 0x0
	// Bit mask of DATE field.
	SPI1_DATE_DATE_Msk = 0xfffffff
)

// Constants for SPI2: Peripheral SPI2
const (
	// CMD: Command control register
	// Position of CONF_BITLEN field.
	SPI2_CMD_CONF_BITLEN_Pos = 0x0
	// Bit mask of CONF_BITLEN field.
	SPI2_CMD_CONF_BITLEN_Msk = 0x3ffff
	// Position of UPDATE field.
	SPI2_CMD_UPDATE_Pos = 0x17
	// Bit mask of UPDATE field.
	SPI2_CMD_UPDATE_Msk = 0x800000
	// Bit UPDATE.
	SPI2_CMD_UPDATE = 0x800000
	// Position of USR field.
	SPI2_CMD_USR_Pos = 0x18
	// Bit mask of USR field.
	SPI2_CMD_USR_Msk = 0x1000000
	// Bit USR.
	SPI2_CMD_USR = 0x1000000

	// ADDR: Address value register
	// Position of USR_ADDR_VALUE field.
	SPI2_ADDR_USR_ADDR_VALUE_Pos = 0x0
	// Bit mask of USR_ADDR_VALUE field.
	SPI2_ADDR_USR_ADDR_VALUE_Msk = 0xffffffff

	// CTRL: SPI control register
	// Position of DUMMY_OUT field.
	SPI2_CTRL_DUMMY_OUT_Pos = 0x3
	// Bit mask of DUMMY_OUT field.
	SPI2_CTRL_DUMMY_OUT_Msk = 0x8
	// Bit DUMMY_OUT.
	SPI2_CTRL_DUMMY_OUT = 0x8
	// Position of FADDR_DUAL field.
	SPI2_CTRL_FADDR_DUAL_Pos = 0x5
	// Bit mask of FADDR_DUAL field.
	SPI2_CTRL_FADDR_DUAL_Msk = 0x20
	// Bit FADDR_DUAL.
	SPI2_CTRL_FADDR_DUAL = 0x20
	// Position of FADDR_QUAD field.
	SPI2_CTRL_FADDR_QUAD_Pos = 0x6
	// Bit mask of FADDR_QUAD field.
	SPI2_CTRL_FADDR_QUAD_Msk = 0x40
	// Bit FADDR_QUAD.
	SPI2_CTRL_FADDR_QUAD = 0x40
	// Position of FCMD_DUAL field.
	SPI2_CTRL_FCMD_DUAL_Pos = 0x8
	// Bit mask of FCMD_DUAL field.
	SPI2_CTRL_FCMD_DUAL_Msk = 0x100
	// Bit FCMD_DUAL.
	SPI2_CTRL_FCMD_DUAL = 0x100
	// Position of FCMD_QUAD field.
	SPI2_CTRL_FCMD_QUAD_Pos = 0x9
	// Bit mask of FCMD_QUAD field.
	SPI2_CTRL_FCMD_QUAD_Msk = 0x200
	// Bit FCMD_QUAD.
	SPI2_CTRL_FCMD_QUAD = 0x200
	// Position of FREAD_DUAL field.
	SPI2_CTRL_FREAD_DUAL_Pos = 0xe
	// Bit mask of FREAD_DUAL field.
	SPI2_CTRL_FREAD_DUAL_Msk = 0x4000
	// Bit FREAD_DUAL.
	SPI2_CTRL_FREAD_DUAL = 0x4000
	// Position of FREAD_QUAD field.
	SPI2_CTRL_FREAD_QUAD_Pos = 0xf
	// Bit mask of FREAD_QUAD field.
	SPI2_CTRL_FREAD_QUAD_Msk = 0x8000
	// Bit FREAD_QUAD.
	SPI2_CTRL_FREAD_QUAD = 0x8000
	// Position of Q_POL field.
	SPI2_CTRL_Q_POL_Pos = 0x12
	// Bit mask of Q_POL field.
	SPI2_CTRL_Q_POL_Msk = 0x40000
	// Bit Q_POL.
	SPI2_CTRL_Q_POL = 0x40000
	// Position of D_POL field.
	SPI2_CTRL_D_POL_Pos = 0x13
	// Bit mask of D_POL field.
	SPI2_CTRL_D_POL_Msk = 0x80000
	// Bit D_POL.
	SPI2_CTRL_D_POL = 0x80000
	// Position of HOLD_POL field.
	SPI2_CTRL_HOLD_POL_Pos = 0x14
	// Bit mask of HOLD_POL field.
	SPI2_CTRL_HOLD_POL_Msk = 0x100000
	// Bit HOLD_POL.
	SPI2_CTRL_HOLD_POL = 0x100000
	// Position of WP_POL field.
	SPI2_CTRL_WP_POL_Pos = 0x15
	// Bit mask of WP_POL field.
	SPI2_CTRL_WP_POL_Msk = 0x200000
	// Bit WP_POL.
	SPI2_CTRL_WP_POL = 0x200000
	// Position of RD_BIT_ORDER field.
	SPI2_CTRL_RD_BIT_ORDER_Pos = 0x19
	// Bit mask of RD_BIT_ORDER field.
	SPI2_CTRL_RD_BIT_ORDER_Msk = 0x2000000
	// Bit RD_BIT_ORDER.
	SPI2_CTRL_RD_BIT_ORDER = 0x2000000
	// Position of WR_BIT_ORDER field.
	SPI2_CTRL_WR_BIT_ORDER_Pos = 0x1a
	// Bit mask of WR_BIT_ORDER field.
	SPI2_CTRL_WR_BIT_ORDER_Msk = 0x4000000
	// Bit WR_BIT_ORDER.
	SPI2_CTRL_WR_BIT_ORDER = 0x4000000

	// CLOCK: SPI clock control register
	// Position of CLKCNT_L field.
	SPI2_CLOCK_CLKCNT_L_Pos = 0x0
	// Bit mask of CLKCNT_L field.
	SPI2_CLOCK_CLKCNT_L_Msk = 0x3f
	// Position of CLKCNT_H field.
	SPI2_CLOCK_CLKCNT_H_Pos = 0x6
	// Bit mask of CLKCNT_H field.
	SPI2_CLOCK_CLKCNT_H_Msk = 0xfc0
	// Position of CLKCNT_N field.
	SPI2_CLOCK_CLKCNT_N_Pos = 0xc
	// Bit mask of CLKCNT_N field.
	SPI2_CLOCK_CLKCNT_N_Msk = 0x3f000
	// Position of CLKDIV_PRE field.
	SPI2_CLOCK_CLKDIV_PRE_Pos = 0x12
	// Bit mask of CLKDIV_PRE field.
	SPI2_CLOCK_CLKDIV_PRE_Msk = 0x3c0000
	// Position of CLK_EQU_SYSCLK field.
	SPI2_CLOCK_CLK_EQU_SYSCLK_Pos = 0x1f
	// Bit mask of CLK_EQU_SYSCLK field.
	SPI2_CLOCK_CLK_EQU_SYSCLK_Msk = 0x80000000
	// Bit CLK_EQU_SYSCLK.
	SPI2_CLOCK_CLK_EQU_SYSCLK = 0x80000000

	// USER: SPI USER control register
	// Position of DOUTDIN field.
	SPI2_USER_DOUTDIN_Pos = 0x0
	// Bit mask of DOUTDIN field.
	SPI2_USER_DOUTDIN_Msk = 0x1
	// Bit DOUTDIN.
	SPI2_USER_DOUTDIN = 0x1
	// Position of QPI_MODE field.
	SPI2_USER_QPI_MODE_Pos = 0x3
	// Bit mask of QPI_MODE field.
	SPI2_USER_QPI_MODE_Msk = 0x8
	// Bit QPI_MODE.
	SPI2_USER_QPI_MODE = 0x8
	// Position of TSCK_I_EDGE field.
	SPI2_USER_TSCK_I_EDGE_Pos = 0x5
	// Bit mask of TSCK_I_EDGE field.
	SPI2_USER_TSCK_I_EDGE_Msk = 0x20
	// Bit TSCK_I_EDGE.
	SPI2_USER_TSCK_I_EDGE = 0x20
	// Position of CS_HOLD field.
	SPI2_USER_CS_HOLD_Pos = 0x6
	// Bit mask of CS_HOLD field.
	SPI2_USER_CS_HOLD_Msk = 0x40
	// Bit CS_HOLD.
	SPI2_USER_CS_HOLD = 0x40
	// Position of CS_SETUP field.
	SPI2_USER_CS_SETUP_Pos = 0x7
	// Bit mask of CS_SETUP field.
	SPI2_USER_CS_SETUP_Msk = 0x80
	// Bit CS_SETUP.
	SPI2_USER_CS_SETUP = 0x80
	// Position of RSCK_I_EDGE field.
	SPI2_USER_RSCK_I_EDGE_Pos = 0x8
	// Bit mask of RSCK_I_EDGE field.
	SPI2_USER_RSCK_I_EDGE_Msk = 0x100
	// Bit RSCK_I_EDGE.
	SPI2_USER_RSCK_I_EDGE = 0x100
	// Position of CK_OUT_EDGE field.
	SPI2_USER_CK_OUT_EDGE_Pos = 0x9
	// Bit mask of CK_OUT_EDGE field.
	SPI2_USER_CK_OUT_EDGE_Msk = 0x200
	// Bit CK_OUT_EDGE.
	SPI2_USER_CK_OUT_EDGE = 0x200
	// Position of FWRITE_DUAL field.
	SPI2_USER_FWRITE_DUAL_Pos = 0xc
	// Bit mask of FWRITE_DUAL field.
	SPI2_USER_FWRITE_DUAL_Msk = 0x1000
	// Bit FWRITE_DUAL.
	SPI2_USER_FWRITE_DUAL = 0x1000
	// Position of FWRITE_QUAD field.
	SPI2_USER_FWRITE_QUAD_Pos = 0xd
	// Bit mask of FWRITE_QUAD field.
	SPI2_USER_FWRITE_QUAD_Msk = 0x2000
	// Bit FWRITE_QUAD.
	SPI2_USER_FWRITE_QUAD = 0x2000
	// Position of USR_CONF_NXT field.
	SPI2_USER_USR_CONF_NXT_Pos = 0xf
	// Bit mask of USR_CONF_NXT field.
	SPI2_USER_USR_CONF_NXT_Msk = 0x8000
	// Bit USR_CONF_NXT.
	SPI2_USER_USR_CONF_NXT = 0x8000
	// Position of SIO field.
	SPI2_USER_SIO_Pos = 0x11
	// Bit mask of SIO field.
	SPI2_USER_SIO_Msk = 0x20000
	// Bit SIO.
	SPI2_USER_SIO = 0x20000
	// Position of USR_MISO_HIGHPART field.
	SPI2_USER_USR_MISO_HIGHPART_Pos = 0x18
	// Bit mask of USR_MISO_HIGHPART field.
	SPI2_USER_USR_MISO_HIGHPART_Msk = 0x1000000
	// Bit USR_MISO_HIGHPART.
	SPI2_USER_USR_MISO_HIGHPART = 0x1000000
	// Position of USR_MOSI_HIGHPART field.
	SPI2_USER_USR_MOSI_HIGHPART_Pos = 0x19
	// Bit mask of USR_MOSI_HIGHPART field.
	SPI2_USER_USR_MOSI_HIGHPART_Msk = 0x2000000
	// Bit USR_MOSI_HIGHPART.
	SPI2_USER_USR_MOSI_HIGHPART = 0x2000000
	// Position of USR_DUMMY_IDLE field.
	SPI2_USER_USR_DUMMY_IDLE_Pos = 0x1a
	// Bit mask of USR_DUMMY_IDLE field.
	SPI2_USER_USR_DUMMY_IDLE_Msk = 0x4000000
	// Bit USR_DUMMY_IDLE.
	SPI2_USER_USR_DUMMY_IDLE = 0x4000000
	// Position of USR_MOSI field.
	SPI2_USER_USR_MOSI_Pos = 0x1b
	// Bit mask of USR_MOSI field.
	SPI2_USER_USR_MOSI_Msk = 0x8000000
	// Bit USR_MOSI.
	SPI2_USER_USR_MOSI = 0x8000000
	// Position of USR_MISO field.
	SPI2_USER_USR_MISO_Pos = 0x1c
	// Bit mask of USR_MISO field.
	SPI2_USER_USR_MISO_Msk = 0x10000000
	// Bit USR_MISO.
	SPI2_USER_USR_MISO = 0x10000000
	// Position of USR_DUMMY field.
	SPI2_USER_USR_DUMMY_Pos = 0x1d
	// Bit mask of USR_DUMMY field.
	SPI2_USER_USR_DUMMY_Msk = 0x20000000
	// Bit USR_DUMMY.
	SPI2_USER_USR_DUMMY = 0x20000000
	// Position of USR_ADDR field.
	SPI2_USER_USR_ADDR_Pos = 0x1e
	// Bit mask of USR_ADDR field.
	SPI2_USER_USR_ADDR_Msk = 0x40000000
	// Bit USR_ADDR.
	SPI2_USER_USR_ADDR = 0x40000000
	// Position of USR_COMMAND field.
	SPI2_USER_USR_COMMAND_Pos = 0x1f
	// Bit mask of USR_COMMAND field.
	SPI2_USER_USR_COMMAND_Msk = 0x80000000
	// Bit USR_COMMAND.
	SPI2_USER_USR_COMMAND = 0x80000000

	// USER1: SPI USER control register 1
	// Position of USR_DUMMY_CYCLELEN field.
	SPI2_USER1_USR_DUMMY_CYCLELEN_Pos = 0x0
	// Bit mask of USR_DUMMY_CYCLELEN field.
	SPI2_USER1_USR_DUMMY_CYCLELEN_Msk = 0xff
	// Position of MST_WFULL_ERR_END_EN field.
	SPI2_USER1_MST_WFULL_ERR_END_EN_Pos = 0x10
	// Bit mask of MST_WFULL_ERR_END_EN field.
	SPI2_USER1_MST_WFULL_ERR_END_EN_Msk = 0x10000
	// Bit MST_WFULL_ERR_END_EN.
	SPI2_USER1_MST_WFULL_ERR_END_EN = 0x10000
	// Position of CS_SETUP_TIME field.
	SPI2_USER1_CS_SETUP_TIME_Pos = 0x11
	// Bit mask of CS_SETUP_TIME field.
	SPI2_USER1_CS_SETUP_TIME_Msk = 0x3e0000
	// Position of CS_HOLD_TIME field.
	SPI2_USER1_CS_HOLD_TIME_Pos = 0x16
	// Bit mask of CS_HOLD_TIME field.
	SPI2_USER1_CS_HOLD_TIME_Msk = 0x7c00000
	// Position of USR_ADDR_BITLEN field.
	SPI2_USER1_USR_ADDR_BITLEN_Pos = 0x1b
	// Bit mask of USR_ADDR_BITLEN field.
	SPI2_USER1_USR_ADDR_BITLEN_Msk = 0xf8000000

	// USER2: SPI USER control register 2
	// Position of USR_COMMAND_VALUE field.
	SPI2_USER2_USR_COMMAND_VALUE_Pos = 0x0
	// Bit mask of USR_COMMAND_VALUE field.
	SPI2_USER2_USR_COMMAND_VALUE_Msk = 0xffff
	// Position of MST_REMPTY_ERR_END_EN field.
	SPI2_USER2_MST_REMPTY_ERR_END_EN_Pos = 0x1b
	// Bit mask of MST_REMPTY_ERR_END_EN field.
	SPI2_USER2_MST_REMPTY_ERR_END_EN_Msk = 0x8000000
	// Bit MST_REMPTY_ERR_END_EN.
	SPI2_USER2_MST_REMPTY_ERR_END_EN = 0x8000000
	// Position of USR_COMMAND_BITLEN field.
	SPI2_USER2_USR_COMMAND_BITLEN_Pos = 0x1c
	// Bit mask of USR_COMMAND_BITLEN field.
	SPI2_USER2_USR_COMMAND_BITLEN_Msk = 0xf0000000

	// MS_DLEN: SPI data bit length control register
	// Position of MS_DATA_BITLEN field.
	SPI2_MS_DLEN_MS_DATA_BITLEN_Pos = 0x0
	// Bit mask of MS_DATA_BITLEN field.
	SPI2_MS_DLEN_MS_DATA_BITLEN_Msk = 0x3ffff

	// MISC: SPI misc register
	// Position of CS0_DIS field.
	SPI2_MISC_CS0_DIS_Pos = 0x0
	// Bit mask of CS0_DIS field.
	SPI2_MISC_CS0_DIS_Msk = 0x1
	// Bit CS0_DIS.
	SPI2_MISC_CS0_DIS = 0x1
	// Position of CS1_DIS field.
	SPI2_MISC_CS1_DIS_Pos = 0x1
	// Bit mask of CS1_DIS field.
	SPI2_MISC_CS1_DIS_Msk = 0x2
	// Bit CS1_DIS.
	SPI2_MISC_CS1_DIS = 0x2
	// Position of CS2_DIS field.
	SPI2_MISC_CS2_DIS_Pos = 0x2
	// Bit mask of CS2_DIS field.
	SPI2_MISC_CS2_DIS_Msk = 0x4
	// Bit CS2_DIS.
	SPI2_MISC_CS2_DIS = 0x4
	// Position of CS3_DIS field.
	SPI2_MISC_CS3_DIS_Pos = 0x3
	// Bit mask of CS3_DIS field.
	SPI2_MISC_CS3_DIS_Msk = 0x8
	// Bit CS3_DIS.
	SPI2_MISC_CS3_DIS = 0x8
	// Position of CS4_DIS field.
	SPI2_MISC_CS4_DIS_Pos = 0x4
	// Bit mask of CS4_DIS field.
	SPI2_MISC_CS4_DIS_Msk = 0x10
	// Bit CS4_DIS.
	SPI2_MISC_CS4_DIS = 0x10
	// Position of CS5_DIS field.
	SPI2_MISC_CS5_DIS_Pos = 0x5
	// Bit mask of CS5_DIS field.
	SPI2_MISC_CS5_DIS_Msk = 0x20
	// Bit CS5_DIS.
	SPI2_MISC_CS5_DIS = 0x20
	// Position of CK_DIS field.
	SPI2_MISC_CK_DIS_Pos = 0x6
	// Bit mask of CK_DIS field.
	SPI2_MISC_CK_DIS_Msk = 0x40
	// Bit CK_DIS.
	SPI2_MISC_CK_DIS = 0x40
	// Position of MASTER_CS_POL field.
	SPI2_MISC_MASTER_CS_POL_Pos = 0x7
	// Bit mask of MASTER_CS_POL field.
	SPI2_MISC_MASTER_CS_POL_Msk = 0x1f80
	// Position of SLAVE_CS_POL field.
	SPI2_MISC_SLAVE_CS_POL_Pos = 0x17
	// Bit mask of SLAVE_CS_POL field.
	SPI2_MISC_SLAVE_CS_POL_Msk = 0x800000
	// Bit SLAVE_CS_POL.
	SPI2_MISC_SLAVE_CS_POL = 0x800000
	// Position of CK_IDLE_EDGE field.
	SPI2_MISC_CK_IDLE_EDGE_Pos = 0x1d
	// Bit mask of CK_IDLE_EDGE field.
	SPI2_MISC_CK_IDLE_EDGE_Msk = 0x20000000
	// Bit CK_IDLE_EDGE.
	SPI2_MISC_CK_IDLE_EDGE = 0x20000000
	// Position of CS_KEEP_ACTIVE field.
	SPI2_MISC_CS_KEEP_ACTIVE_Pos = 0x1e
	// Bit mask of CS_KEEP_ACTIVE field.
	SPI2_MISC_CS_KEEP_ACTIVE_Msk = 0x40000000
	// Bit CS_KEEP_ACTIVE.
	SPI2_MISC_CS_KEEP_ACTIVE = 0x40000000
	// Position of QUAD_DIN_PIN_SWAP field.
	SPI2_MISC_QUAD_DIN_PIN_SWAP_Pos = 0x1f
	// Bit mask of QUAD_DIN_PIN_SWAP field.
	SPI2_MISC_QUAD_DIN_PIN_SWAP_Msk = 0x80000000
	// Bit QUAD_DIN_PIN_SWAP.
	SPI2_MISC_QUAD_DIN_PIN_SWAP = 0x80000000

	// DIN_MODE: SPI input delay mode configuration
	// Position of DIN0_MODE field.
	SPI2_DIN_MODE_DIN0_MODE_Pos = 0x0
	// Bit mask of DIN0_MODE field.
	SPI2_DIN_MODE_DIN0_MODE_Msk = 0x3
	// Position of DIN1_MODE field.
	SPI2_DIN_MODE_DIN1_MODE_Pos = 0x2
	// Bit mask of DIN1_MODE field.
	SPI2_DIN_MODE_DIN1_MODE_Msk = 0xc
	// Position of DIN2_MODE field.
	SPI2_DIN_MODE_DIN2_MODE_Pos = 0x4
	// Bit mask of DIN2_MODE field.
	SPI2_DIN_MODE_DIN2_MODE_Msk = 0x30
	// Position of DIN3_MODE field.
	SPI2_DIN_MODE_DIN3_MODE_Pos = 0x6
	// Bit mask of DIN3_MODE field.
	SPI2_DIN_MODE_DIN3_MODE_Msk = 0xc0
	// Position of TIMING_HCLK_ACTIVE field.
	SPI2_DIN_MODE_TIMING_HCLK_ACTIVE_Pos = 0x10
	// Bit mask of TIMING_HCLK_ACTIVE field.
	SPI2_DIN_MODE_TIMING_HCLK_ACTIVE_Msk = 0x10000
	// Bit TIMING_HCLK_ACTIVE.
	SPI2_DIN_MODE_TIMING_HCLK_ACTIVE = 0x10000

	// DIN_NUM: SPI input delay number configuration
	// Position of DIN0_NUM field.
	SPI2_DIN_NUM_DIN0_NUM_Pos = 0x0
	// Bit mask of DIN0_NUM field.
	SPI2_DIN_NUM_DIN0_NUM_Msk = 0x3
	// Position of DIN1_NUM field.
	SPI2_DIN_NUM_DIN1_NUM_Pos = 0x2
	// Bit mask of DIN1_NUM field.
	SPI2_DIN_NUM_DIN1_NUM_Msk = 0xc
	// Position of DIN2_NUM field.
	SPI2_DIN_NUM_DIN2_NUM_Pos = 0x4
	// Bit mask of DIN2_NUM field.
	SPI2_DIN_NUM_DIN2_NUM_Msk = 0x30
	// Position of DIN3_NUM field.
	SPI2_DIN_NUM_DIN3_NUM_Pos = 0x6
	// Bit mask of DIN3_NUM field.
	SPI2_DIN_NUM_DIN3_NUM_Msk = 0xc0

	// DOUT_MODE: SPI output delay mode configuration
	// Position of DOUT0_MODE field.
	SPI2_DOUT_MODE_DOUT0_MODE_Pos = 0x0
	// Bit mask of DOUT0_MODE field.
	SPI2_DOUT_MODE_DOUT0_MODE_Msk = 0x1
	// Bit DOUT0_MODE.
	SPI2_DOUT_MODE_DOUT0_MODE = 0x1
	// Position of DOUT1_MODE field.
	SPI2_DOUT_MODE_DOUT1_MODE_Pos = 0x1
	// Bit mask of DOUT1_MODE field.
	SPI2_DOUT_MODE_DOUT1_MODE_Msk = 0x2
	// Bit DOUT1_MODE.
	SPI2_DOUT_MODE_DOUT1_MODE = 0x2
	// Position of DOUT2_MODE field.
	SPI2_DOUT_MODE_DOUT2_MODE_Pos = 0x2
	// Bit mask of DOUT2_MODE field.
	SPI2_DOUT_MODE_DOUT2_MODE_Msk = 0x4
	// Bit DOUT2_MODE.
	SPI2_DOUT_MODE_DOUT2_MODE = 0x4
	// Position of DOUT3_MODE field.
	SPI2_DOUT_MODE_DOUT3_MODE_Pos = 0x3
	// Bit mask of DOUT3_MODE field.
	SPI2_DOUT_MODE_DOUT3_MODE_Msk = 0x8
	// Bit DOUT3_MODE.
	SPI2_DOUT_MODE_DOUT3_MODE = 0x8

	// DMA_CONF: SPI DMA control register
	// Position of DMA_SLV_SEG_TRANS_EN field.
	SPI2_DMA_CONF_DMA_SLV_SEG_TRANS_EN_Pos = 0x12
	// Bit mask of DMA_SLV_SEG_TRANS_EN field.
	SPI2_DMA_CONF_DMA_SLV_SEG_TRANS_EN_Msk = 0x40000
	// Bit DMA_SLV_SEG_TRANS_EN.
	SPI2_DMA_CONF_DMA_SLV_SEG_TRANS_EN = 0x40000
	// Position of SLV_RX_SEG_TRANS_CLR_EN field.
	SPI2_DMA_CONF_SLV_RX_SEG_TRANS_CLR_EN_Pos = 0x13
	// Bit mask of SLV_RX_SEG_TRANS_CLR_EN field.
	SPI2_DMA_CONF_SLV_RX_SEG_TRANS_CLR_EN_Msk = 0x80000
	// Bit SLV_RX_SEG_TRANS_CLR_EN.
	SPI2_DMA_CONF_SLV_RX_SEG_TRANS_CLR_EN = 0x80000
	// Position of SLV_TX_SEG_TRANS_CLR_EN field.
	SPI2_DMA_CONF_SLV_TX_SEG_TRANS_CLR_EN_Pos = 0x14
	// Bit mask of SLV_TX_SEG_TRANS_CLR_EN field.
	SPI2_DMA_CONF_SLV_TX_SEG_TRANS_CLR_EN_Msk = 0x100000
	// Bit SLV_TX_SEG_TRANS_CLR_EN.
	SPI2_DMA_CONF_SLV_TX_SEG_TRANS_CLR_EN = 0x100000
	// Position of RX_EOF_EN field.
	SPI2_DMA_CONF_RX_EOF_EN_Pos = 0x15
	// Bit mask of RX_EOF_EN field.
	SPI2_DMA_CONF_RX_EOF_EN_Msk = 0x200000
	// Bit RX_EOF_EN.
	SPI2_DMA_CONF_RX_EOF_EN = 0x200000
	// Position of DMA_RX_ENA field.
	SPI2_DMA_CONF_DMA_RX_ENA_Pos = 0x1b
	// Bit mask of DMA_RX_ENA field.
	SPI2_DMA_CONF_DMA_RX_ENA_Msk = 0x8000000
	// Bit DMA_RX_ENA.
	SPI2_DMA_CONF_DMA_RX_ENA = 0x8000000
	// Position of DMA_TX_ENA field.
	SPI2_DMA_CONF_DMA_TX_ENA_Pos = 0x1c
	// Bit mask of DMA_TX_ENA field.
	SPI2_DMA_CONF_DMA_TX_ENA_Msk = 0x10000000
	// Bit DMA_TX_ENA.
	SPI2_DMA_CONF_DMA_TX_ENA = 0x10000000
	// Position of RX_AFIFO_RST field.
	SPI2_DMA_CONF_RX_AFIFO_RST_Pos = 0x1d
	// Bit mask of RX_AFIFO_RST field.
	SPI2_DMA_CONF_RX_AFIFO_RST_Msk = 0x20000000
	// Bit RX_AFIFO_RST.
	SPI2_DMA_CONF_RX_AFIFO_RST = 0x20000000
	// Position of BUF_AFIFO_RST field.
	SPI2_DMA_CONF_BUF_AFIFO_RST_Pos = 0x1e
	// Bit mask of BUF_AFIFO_RST field.
	SPI2_DMA_CONF_BUF_AFIFO_RST_Msk = 0x40000000
	// Bit BUF_AFIFO_RST.
	SPI2_DMA_CONF_BUF_AFIFO_RST = 0x40000000
	// Position of DMA_AFIFO_RST field.
	SPI2_DMA_CONF_DMA_AFIFO_RST_Pos = 0x1f
	// Bit mask of DMA_AFIFO_RST field.
	SPI2_DMA_CONF_DMA_AFIFO_RST_Msk = 0x80000000
	// Bit DMA_AFIFO_RST.
	SPI2_DMA_CONF_DMA_AFIFO_RST = 0x80000000

	// DMA_INT_ENA: SPI DMA interrupt enable register
	// Position of DMA_INFIFO_FULL_ERR_INT_ENA field.
	SPI2_DMA_INT_ENA_DMA_INFIFO_FULL_ERR_INT_ENA_Pos = 0x0
	// Bit mask of DMA_INFIFO_FULL_ERR_INT_ENA field.
	SPI2_DMA_INT_ENA_DMA_INFIFO_FULL_ERR_INT_ENA_Msk = 0x1
	// Bit DMA_INFIFO_FULL_ERR_INT_ENA.
	SPI2_DMA_INT_ENA_DMA_INFIFO_FULL_ERR_INT_ENA = 0x1
	// Position of DMA_OUTFIFO_EMPTY_ERR_INT_ENA field.
	SPI2_DMA_INT_ENA_DMA_OUTFIFO_EMPTY_ERR_INT_ENA_Pos = 0x1
	// Bit mask of DMA_OUTFIFO_EMPTY_ERR_INT_ENA field.
	SPI2_DMA_INT_ENA_DMA_OUTFIFO_EMPTY_ERR_INT_ENA_Msk = 0x2
	// Bit DMA_OUTFIFO_EMPTY_ERR_INT_ENA.
	SPI2_DMA_INT_ENA_DMA_OUTFIFO_EMPTY_ERR_INT_ENA = 0x2
	// Position of SLV_EX_QPI_INT_ENA field.
	SPI2_DMA_INT_ENA_SLV_EX_QPI_INT_ENA_Pos = 0x2
	// Bit mask of SLV_EX_QPI_INT_ENA field.
	SPI2_DMA_INT_ENA_SLV_EX_QPI_INT_ENA_Msk = 0x4
	// Bit SLV_EX_QPI_INT_ENA.
	SPI2_DMA_INT_ENA_SLV_EX_QPI_INT_ENA = 0x4
	// Position of SLV_EN_QPI_INT_ENA field.
	SPI2_DMA_INT_ENA_SLV_EN_QPI_INT_ENA_Pos = 0x3
	// Bit mask of SLV_EN_QPI_INT_ENA field.
	SPI2_DMA_INT_ENA_SLV_EN_QPI_INT_ENA_Msk = 0x8
	// Bit SLV_EN_QPI_INT_ENA.
	SPI2_DMA_INT_ENA_SLV_EN_QPI_INT_ENA = 0x8
	// Position of SLV_CMD7_INT_ENA field.
	SPI2_DMA_INT_ENA_SLV_CMD7_INT_ENA_Pos = 0x4
	// Bit mask of SLV_CMD7_INT_ENA field.
	SPI2_DMA_INT_ENA_SLV_CMD7_INT_ENA_Msk = 0x10
	// Bit SLV_CMD7_INT_ENA.
	SPI2_DMA_INT_ENA_SLV_CMD7_INT_ENA = 0x10
	// Position of SLV_CMD8_INT_ENA field.
	SPI2_DMA_INT_ENA_SLV_CMD8_INT_ENA_Pos = 0x5
	// Bit mask of SLV_CMD8_INT_ENA field.
	SPI2_DMA_INT_ENA_SLV_CMD8_INT_ENA_Msk = 0x20
	// Bit SLV_CMD8_INT_ENA.
	SPI2_DMA_INT_ENA_SLV_CMD8_INT_ENA = 0x20
	// Position of SLV_CMD9_INT_ENA field.
	SPI2_DMA_INT_ENA_SLV_CMD9_INT_ENA_Pos = 0x6
	// Bit mask of SLV_CMD9_INT_ENA field.
	SPI2_DMA_INT_ENA_SLV_CMD9_INT_ENA_Msk = 0x40
	// Bit SLV_CMD9_INT_ENA.
	SPI2_DMA_INT_ENA_SLV_CMD9_INT_ENA = 0x40
	// Position of SLV_CMDA_INT_ENA field.
	SPI2_DMA_INT_ENA_SLV_CMDA_INT_ENA_Pos = 0x7
	// Bit mask of SLV_CMDA_INT_ENA field.
	SPI2_DMA_INT_ENA_SLV_CMDA_INT_ENA_Msk = 0x80
	// Bit SLV_CMDA_INT_ENA.
	SPI2_DMA_INT_ENA_SLV_CMDA_INT_ENA = 0x80
	// Position of SLV_RD_DMA_DONE_INT_ENA field.
	SPI2_DMA_INT_ENA_SLV_RD_DMA_DONE_INT_ENA_Pos = 0x8
	// Bit mask of SLV_RD_DMA_DONE_INT_ENA field.
	SPI2_DMA_INT_ENA_SLV_RD_DMA_DONE_INT_ENA_Msk = 0x100
	// Bit SLV_RD_DMA_DONE_INT_ENA.
	SPI2_DMA_INT_ENA_SLV_RD_DMA_DONE_INT_ENA = 0x100
	// Position of SLV_WR_DMA_DONE_INT_ENA field.
	SPI2_DMA_INT_ENA_SLV_WR_DMA_DONE_INT_ENA_Pos = 0x9
	// Bit mask of SLV_WR_DMA_DONE_INT_ENA field.
	SPI2_DMA_INT_ENA_SLV_WR_DMA_DONE_INT_ENA_Msk = 0x200
	// Bit SLV_WR_DMA_DONE_INT_ENA.
	SPI2_DMA_INT_ENA_SLV_WR_DMA_DONE_INT_ENA = 0x200
	// Position of SLV_RD_BUF_DONE_INT_ENA field.
	SPI2_DMA_INT_ENA_SLV_RD_BUF_DONE_INT_ENA_Pos = 0xa
	// Bit mask of SLV_RD_BUF_DONE_INT_ENA field.
	SPI2_DMA_INT_ENA_SLV_RD_BUF_DONE_INT_ENA_Msk = 0x400
	// Bit SLV_RD_BUF_DONE_INT_ENA.
	SPI2_DMA_INT_ENA_SLV_RD_BUF_DONE_INT_ENA = 0x400
	// Position of SLV_WR_BUF_DONE_INT_ENA field.
	SPI2_DMA_INT_ENA_SLV_WR_BUF_DONE_INT_ENA_Pos = 0xb
	// Bit mask of SLV_WR_BUF_DONE_INT_ENA field.
	SPI2_DMA_INT_ENA_SLV_WR_BUF_DONE_INT_ENA_Msk = 0x800
	// Bit SLV_WR_BUF_DONE_INT_ENA.
	SPI2_DMA_INT_ENA_SLV_WR_BUF_DONE_INT_ENA = 0x800
	// Position of TRANS_DONE_INT_ENA field.
	SPI2_DMA_INT_ENA_TRANS_DONE_INT_ENA_Pos = 0xc
	// Bit mask of TRANS_DONE_INT_ENA field.
	SPI2_DMA_INT_ENA_TRANS_DONE_INT_ENA_Msk = 0x1000
	// Bit TRANS_DONE_INT_ENA.
	SPI2_DMA_INT_ENA_TRANS_DONE_INT_ENA = 0x1000
	// Position of DMA_SEG_TRANS_DONE_INT_ENA field.
	SPI2_DMA_INT_ENA_DMA_SEG_TRANS_DONE_INT_ENA_Pos = 0xd
	// Bit mask of DMA_SEG_TRANS_DONE_INT_ENA field.
	SPI2_DMA_INT_ENA_DMA_SEG_TRANS_DONE_INT_ENA_Msk = 0x2000
	// Bit DMA_SEG_TRANS_DONE_INT_ENA.
	SPI2_DMA_INT_ENA_DMA_SEG_TRANS_DONE_INT_ENA = 0x2000
	// Position of SEG_MAGIC_ERR_INT_ENA field.
	SPI2_DMA_INT_ENA_SEG_MAGIC_ERR_INT_ENA_Pos = 0xe
	// Bit mask of SEG_MAGIC_ERR_INT_ENA field.
	SPI2_DMA_INT_ENA_SEG_MAGIC_ERR_INT_ENA_Msk = 0x4000
	// Bit SEG_MAGIC_ERR_INT_ENA.
	SPI2_DMA_INT_ENA_SEG_MAGIC_ERR_INT_ENA = 0x4000
	// Position of SLV_BUF_ADDR_ERR_INT_ENA field.
	SPI2_DMA_INT_ENA_SLV_BUF_ADDR_ERR_INT_ENA_Pos = 0xf
	// Bit mask of SLV_BUF_ADDR_ERR_INT_ENA field.
	SPI2_DMA_INT_ENA_SLV_BUF_ADDR_ERR_INT_ENA_Msk = 0x8000
	// Bit SLV_BUF_ADDR_ERR_INT_ENA.
	SPI2_DMA_INT_ENA_SLV_BUF_ADDR_ERR_INT_ENA = 0x8000
	// Position of SLV_CMD_ERR_INT_ENA field.
	SPI2_DMA_INT_ENA_SLV_CMD_ERR_INT_ENA_Pos = 0x10
	// Bit mask of SLV_CMD_ERR_INT_ENA field.
	SPI2_DMA_INT_ENA_SLV_CMD_ERR_INT_ENA_Msk = 0x10000
	// Bit SLV_CMD_ERR_INT_ENA.
	SPI2_DMA_INT_ENA_SLV_CMD_ERR_INT_ENA = 0x10000
	// Position of MST_RX_AFIFO_WFULL_ERR_INT_ENA field.
	SPI2_DMA_INT_ENA_MST_RX_AFIFO_WFULL_ERR_INT_ENA_Pos = 0x11
	// Bit mask of MST_RX_AFIFO_WFULL_ERR_INT_ENA field.
	SPI2_DMA_INT_ENA_MST_RX_AFIFO_WFULL_ERR_INT_ENA_Msk = 0x20000
	// Bit MST_RX_AFIFO_WFULL_ERR_INT_ENA.
	SPI2_DMA_INT_ENA_MST_RX_AFIFO_WFULL_ERR_INT_ENA = 0x20000
	// Position of MST_TX_AFIFO_REMPTY_ERR_INT_ENA field.
	SPI2_DMA_INT_ENA_MST_TX_AFIFO_REMPTY_ERR_INT_ENA_Pos = 0x12
	// Bit mask of MST_TX_AFIFO_REMPTY_ERR_INT_ENA field.
	SPI2_DMA_INT_ENA_MST_TX_AFIFO_REMPTY_ERR_INT_ENA_Msk = 0x40000
	// Bit MST_TX_AFIFO_REMPTY_ERR_INT_ENA.
	SPI2_DMA_INT_ENA_MST_TX_AFIFO_REMPTY_ERR_INT_ENA = 0x40000
	// Position of APP2_INT_ENA field.
	SPI2_DMA_INT_ENA_APP2_INT_ENA_Pos = 0x13
	// Bit mask of APP2_INT_ENA field.
	SPI2_DMA_INT_ENA_APP2_INT_ENA_Msk = 0x80000
	// Bit APP2_INT_ENA.
	SPI2_DMA_INT_ENA_APP2_INT_ENA = 0x80000
	// Position of APP1_INT_ENA field.
	SPI2_DMA_INT_ENA_APP1_INT_ENA_Pos = 0x14
	// Bit mask of APP1_INT_ENA field.
	SPI2_DMA_INT_ENA_APP1_INT_ENA_Msk = 0x100000
	// Bit APP1_INT_ENA.
	SPI2_DMA_INT_ENA_APP1_INT_ENA = 0x100000

	// DMA_INT_CLR: SPI DMA interrupt clear register
	// Position of DMA_INFIFO_FULL_ERR_INT_CLR field.
	SPI2_DMA_INT_CLR_DMA_INFIFO_FULL_ERR_INT_CLR_Pos = 0x0
	// Bit mask of DMA_INFIFO_FULL_ERR_INT_CLR field.
	SPI2_DMA_INT_CLR_DMA_INFIFO_FULL_ERR_INT_CLR_Msk = 0x1
	// Bit DMA_INFIFO_FULL_ERR_INT_CLR.
	SPI2_DMA_INT_CLR_DMA_INFIFO_FULL_ERR_INT_CLR = 0x1
	// Position of DMA_OUTFIFO_EMPTY_ERR_INT_CLR field.
	SPI2_DMA_INT_CLR_DMA_OUTFIFO_EMPTY_ERR_INT_CLR_Pos = 0x1
	// Bit mask of DMA_OUTFIFO_EMPTY_ERR_INT_CLR field.
	SPI2_DMA_INT_CLR_DMA_OUTFIFO_EMPTY_ERR_INT_CLR_Msk = 0x2
	// Bit DMA_OUTFIFO_EMPTY_ERR_INT_CLR.
	SPI2_DMA_INT_CLR_DMA_OUTFIFO_EMPTY_ERR_INT_CLR = 0x2
	// Position of SLV_EX_QPI_INT_CLR field.
	SPI2_DMA_INT_CLR_SLV_EX_QPI_INT_CLR_Pos = 0x2
	// Bit mask of SLV_EX_QPI_INT_CLR field.
	SPI2_DMA_INT_CLR_SLV_EX_QPI_INT_CLR_Msk = 0x4
	// Bit SLV_EX_QPI_INT_CLR.
	SPI2_DMA_INT_CLR_SLV_EX_QPI_INT_CLR = 0x4
	// Position of SLV_EN_QPI_INT_CLR field.
	SPI2_DMA_INT_CLR_SLV_EN_QPI_INT_CLR_Pos = 0x3
	// Bit mask of SLV_EN_QPI_INT_CLR field.
	SPI2_DMA_INT_CLR_SLV_EN_QPI_INT_CLR_Msk = 0x8
	// Bit SLV_EN_QPI_INT_CLR.
	SPI2_DMA_INT_CLR_SLV_EN_QPI_INT_CLR = 0x8
	// Position of SLV_CMD7_INT_CLR field.
	SPI2_DMA_INT_CLR_SLV_CMD7_INT_CLR_Pos = 0x4
	// Bit mask of SLV_CMD7_INT_CLR field.
	SPI2_DMA_INT_CLR_SLV_CMD7_INT_CLR_Msk = 0x10
	// Bit SLV_CMD7_INT_CLR.
	SPI2_DMA_INT_CLR_SLV_CMD7_INT_CLR = 0x10
	// Position of SLV_CMD8_INT_CLR field.
	SPI2_DMA_INT_CLR_SLV_CMD8_INT_CLR_Pos = 0x5
	// Bit mask of SLV_CMD8_INT_CLR field.
	SPI2_DMA_INT_CLR_SLV_CMD8_INT_CLR_Msk = 0x20
	// Bit SLV_CMD8_INT_CLR.
	SPI2_DMA_INT_CLR_SLV_CMD8_INT_CLR = 0x20
	// Position of SLV_CMD9_INT_CLR field.
	SPI2_DMA_INT_CLR_SLV_CMD9_INT_CLR_Pos = 0x6
	// Bit mask of SLV_CMD9_INT_CLR field.
	SPI2_DMA_INT_CLR_SLV_CMD9_INT_CLR_Msk = 0x40
	// Bit SLV_CMD9_INT_CLR.
	SPI2_DMA_INT_CLR_SLV_CMD9_INT_CLR = 0x40
	// Position of SLV_CMDA_INT_CLR field.
	SPI2_DMA_INT_CLR_SLV_CMDA_INT_CLR_Pos = 0x7
	// Bit mask of SLV_CMDA_INT_CLR field.
	SPI2_DMA_INT_CLR_SLV_CMDA_INT_CLR_Msk = 0x80
	// Bit SLV_CMDA_INT_CLR.
	SPI2_DMA_INT_CLR_SLV_CMDA_INT_CLR = 0x80
	// Position of SLV_RD_DMA_DONE_INT_CLR field.
	SPI2_DMA_INT_CLR_SLV_RD_DMA_DONE_INT_CLR_Pos = 0x8
	// Bit mask of SLV_RD_DMA_DONE_INT_CLR field.
	SPI2_DMA_INT_CLR_SLV_RD_DMA_DONE_INT_CLR_Msk = 0x100
	// Bit SLV_RD_DMA_DONE_INT_CLR.
	SPI2_DMA_INT_CLR_SLV_RD_DMA_DONE_INT_CLR = 0x100
	// Position of SLV_WR_DMA_DONE_INT_CLR field.
	SPI2_DMA_INT_CLR_SLV_WR_DMA_DONE_INT_CLR_Pos = 0x9
	// Bit mask of SLV_WR_DMA_DONE_INT_CLR field.
	SPI2_DMA_INT_CLR_SLV_WR_DMA_DONE_INT_CLR_Msk = 0x200
	// Bit SLV_WR_DMA_DONE_INT_CLR.
	SPI2_DMA_INT_CLR_SLV_WR_DMA_DONE_INT_CLR = 0x200
	// Position of SLV_RD_BUF_DONE_INT_CLR field.
	SPI2_DMA_INT_CLR_SLV_RD_BUF_DONE_INT_CLR_Pos = 0xa
	// Bit mask of SLV_RD_BUF_DONE_INT_CLR field.
	SPI2_DMA_INT_CLR_SLV_RD_BUF_DONE_INT_CLR_Msk = 0x400
	// Bit SLV_RD_BUF_DONE_INT_CLR.
	SPI2_DMA_INT_CLR_SLV_RD_BUF_DONE_INT_CLR = 0x400
	// Position of SLV_WR_BUF_DONE_INT_CLR field.
	SPI2_DMA_INT_CLR_SLV_WR_BUF_DONE_INT_CLR_Pos = 0xb
	// Bit mask of SLV_WR_BUF_DONE_INT_CLR field.
	SPI2_DMA_INT_CLR_SLV_WR_BUF_DONE_INT_CLR_Msk = 0x800
	// Bit SLV_WR_BUF_DONE_INT_CLR.
	SPI2_DMA_INT_CLR_SLV_WR_BUF_DONE_INT_CLR = 0x800
	// Position of TRANS_DONE_INT_CLR field.
	SPI2_DMA_INT_CLR_TRANS_DONE_INT_CLR_Pos = 0xc
	// Bit mask of TRANS_DONE_INT_CLR field.
	SPI2_DMA_INT_CLR_TRANS_DONE_INT_CLR_Msk = 0x1000
	// Bit TRANS_DONE_INT_CLR.
	SPI2_DMA_INT_CLR_TRANS_DONE_INT_CLR = 0x1000
	// Position of DMA_SEG_TRANS_DONE_INT_CLR field.
	SPI2_DMA_INT_CLR_DMA_SEG_TRANS_DONE_INT_CLR_Pos = 0xd
	// Bit mask of DMA_SEG_TRANS_DONE_INT_CLR field.
	SPI2_DMA_INT_CLR_DMA_SEG_TRANS_DONE_INT_CLR_Msk = 0x2000
	// Bit DMA_SEG_TRANS_DONE_INT_CLR.
	SPI2_DMA_INT_CLR_DMA_SEG_TRANS_DONE_INT_CLR = 0x2000
	// Position of SEG_MAGIC_ERR_INT_CLR field.
	SPI2_DMA_INT_CLR_SEG_MAGIC_ERR_INT_CLR_Pos = 0xe
	// Bit mask of SEG_MAGIC_ERR_INT_CLR field.
	SPI2_DMA_INT_CLR_SEG_MAGIC_ERR_INT_CLR_Msk = 0x4000
	// Bit SEG_MAGIC_ERR_INT_CLR.
	SPI2_DMA_INT_CLR_SEG_MAGIC_ERR_INT_CLR = 0x4000
	// Position of SLV_BUF_ADDR_ERR_INT_CLR field.
	SPI2_DMA_INT_CLR_SLV_BUF_ADDR_ERR_INT_CLR_Pos = 0xf
	// Bit mask of SLV_BUF_ADDR_ERR_INT_CLR field.
	SPI2_DMA_INT_CLR_SLV_BUF_ADDR_ERR_INT_CLR_Msk = 0x8000
	// Bit SLV_BUF_ADDR_ERR_INT_CLR.
	SPI2_DMA_INT_CLR_SLV_BUF_ADDR_ERR_INT_CLR = 0x8000
	// Position of SLV_CMD_ERR_INT_CLR field.
	SPI2_DMA_INT_CLR_SLV_CMD_ERR_INT_CLR_Pos = 0x10
	// Bit mask of SLV_CMD_ERR_INT_CLR field.
	SPI2_DMA_INT_CLR_SLV_CMD_ERR_INT_CLR_Msk = 0x10000
	// Bit SLV_CMD_ERR_INT_CLR.
	SPI2_DMA_INT_CLR_SLV_CMD_ERR_INT_CLR = 0x10000
	// Position of MST_RX_AFIFO_WFULL_ERR_INT_CLR field.
	SPI2_DMA_INT_CLR_MST_RX_AFIFO_WFULL_ERR_INT_CLR_Pos = 0x11
	// Bit mask of MST_RX_AFIFO_WFULL_ERR_INT_CLR field.
	SPI2_DMA_INT_CLR_MST_RX_AFIFO_WFULL_ERR_INT_CLR_Msk = 0x20000
	// Bit MST_RX_AFIFO_WFULL_ERR_INT_CLR.
	SPI2_DMA_INT_CLR_MST_RX_AFIFO_WFULL_ERR_INT_CLR = 0x20000
	// Position of MST_TX_AFIFO_REMPTY_ERR_INT_CLR field.
	SPI2_DMA_INT_CLR_MST_TX_AFIFO_REMPTY_ERR_INT_CLR_Pos = 0x12
	// Bit mask of MST_TX_AFIFO_REMPTY_ERR_INT_CLR field.
	SPI2_DMA_INT_CLR_MST_TX_AFIFO_REMPTY_ERR_INT_CLR_Msk = 0x40000
	// Bit MST_TX_AFIFO_REMPTY_ERR_INT_CLR.
	SPI2_DMA_INT_CLR_MST_TX_AFIFO_REMPTY_ERR_INT_CLR = 0x40000
	// Position of APP2_INT_CLR field.
	SPI2_DMA_INT_CLR_APP2_INT_CLR_Pos = 0x13
	// Bit mask of APP2_INT_CLR field.
	SPI2_DMA_INT_CLR_APP2_INT_CLR_Msk = 0x80000
	// Bit APP2_INT_CLR.
	SPI2_DMA_INT_CLR_APP2_INT_CLR = 0x80000
	// Position of APP1_INT_CLR field.
	SPI2_DMA_INT_CLR_APP1_INT_CLR_Pos = 0x14
	// Bit mask of APP1_INT_CLR field.
	SPI2_DMA_INT_CLR_APP1_INT_CLR_Msk = 0x100000
	// Bit APP1_INT_CLR.
	SPI2_DMA_INT_CLR_APP1_INT_CLR = 0x100000

	// DMA_INT_RAW: SPI DMA interrupt raw register
	// Position of DMA_INFIFO_FULL_ERR_INT_RAW field.
	SPI2_DMA_INT_RAW_DMA_INFIFO_FULL_ERR_INT_RAW_Pos = 0x0
	// Bit mask of DMA_INFIFO_FULL_ERR_INT_RAW field.
	SPI2_DMA_INT_RAW_DMA_INFIFO_FULL_ERR_INT_RAW_Msk = 0x1
	// Bit DMA_INFIFO_FULL_ERR_INT_RAW.
	SPI2_DMA_INT_RAW_DMA_INFIFO_FULL_ERR_INT_RAW = 0x1
	// Position of DMA_OUTFIFO_EMPTY_ERR_INT_RAW field.
	SPI2_DMA_INT_RAW_DMA_OUTFIFO_EMPTY_ERR_INT_RAW_Pos = 0x1
	// Bit mask of DMA_OUTFIFO_EMPTY_ERR_INT_RAW field.
	SPI2_DMA_INT_RAW_DMA_OUTFIFO_EMPTY_ERR_INT_RAW_Msk = 0x2
	// Bit DMA_OUTFIFO_EMPTY_ERR_INT_RAW.
	SPI2_DMA_INT_RAW_DMA_OUTFIFO_EMPTY_ERR_INT_RAW = 0x2
	// Position of SLV_EX_QPI_INT_RAW field.
	SPI2_DMA_INT_RAW_SLV_EX_QPI_INT_RAW_Pos = 0x2
	// Bit mask of SLV_EX_QPI_INT_RAW field.
	SPI2_DMA_INT_RAW_SLV_EX_QPI_INT_RAW_Msk = 0x4
	// Bit SLV_EX_QPI_INT_RAW.
	SPI2_DMA_INT_RAW_SLV_EX_QPI_INT_RAW = 0x4
	// Position of SLV_EN_QPI_INT_RAW field.
	SPI2_DMA_INT_RAW_SLV_EN_QPI_INT_RAW_Pos = 0x3
	// Bit mask of SLV_EN_QPI_INT_RAW field.
	SPI2_DMA_INT_RAW_SLV_EN_QPI_INT_RAW_Msk = 0x8
	// Bit SLV_EN_QPI_INT_RAW.
	SPI2_DMA_INT_RAW_SLV_EN_QPI_INT_RAW = 0x8
	// Position of SLV_CMD7_INT_RAW field.
	SPI2_DMA_INT_RAW_SLV_CMD7_INT_RAW_Pos = 0x4
	// Bit mask of SLV_CMD7_INT_RAW field.
	SPI2_DMA_INT_RAW_SLV_CMD7_INT_RAW_Msk = 0x10
	// Bit SLV_CMD7_INT_RAW.
	SPI2_DMA_INT_RAW_SLV_CMD7_INT_RAW = 0x10
	// Position of SLV_CMD8_INT_RAW field.
	SPI2_DMA_INT_RAW_SLV_CMD8_INT_RAW_Pos = 0x5
	// Bit mask of SLV_CMD8_INT_RAW field.
	SPI2_DMA_INT_RAW_SLV_CMD8_INT_RAW_Msk = 0x20
	// Bit SLV_CMD8_INT_RAW.
	SPI2_DMA_INT_RAW_SLV_CMD8_INT_RAW = 0x20
	// Position of SLV_CMD9_INT_RAW field.
	SPI2_DMA_INT_RAW_SLV_CMD9_INT_RAW_Pos = 0x6
	// Bit mask of SLV_CMD9_INT_RAW field.
	SPI2_DMA_INT_RAW_SLV_CMD9_INT_RAW_Msk = 0x40
	// Bit SLV_CMD9_INT_RAW.
	SPI2_DMA_INT_RAW_SLV_CMD9_INT_RAW = 0x40
	// Position of SLV_CMDA_INT_RAW field.
	SPI2_DMA_INT_RAW_SLV_CMDA_INT_RAW_Pos = 0x7
	// Bit mask of SLV_CMDA_INT_RAW field.
	SPI2_DMA_INT_RAW_SLV_CMDA_INT_RAW_Msk = 0x80
	// Bit SLV_CMDA_INT_RAW.
	SPI2_DMA_INT_RAW_SLV_CMDA_INT_RAW = 0x80
	// Position of SLV_RD_DMA_DONE_INT_RAW field.
	SPI2_DMA_INT_RAW_SLV_RD_DMA_DONE_INT_RAW_Pos = 0x8
	// Bit mask of SLV_RD_DMA_DONE_INT_RAW field.
	SPI2_DMA_INT_RAW_SLV_RD_DMA_DONE_INT_RAW_Msk = 0x100
	// Bit SLV_RD_DMA_DONE_INT_RAW.
	SPI2_DMA_INT_RAW_SLV_RD_DMA_DONE_INT_RAW = 0x100
	// Position of SLV_WR_DMA_DONE_INT_RAW field.
	SPI2_DMA_INT_RAW_SLV_WR_DMA_DONE_INT_RAW_Pos = 0x9
	// Bit mask of SLV_WR_DMA_DONE_INT_RAW field.
	SPI2_DMA_INT_RAW_SLV_WR_DMA_DONE_INT_RAW_Msk = 0x200
	// Bit SLV_WR_DMA_DONE_INT_RAW.
	SPI2_DMA_INT_RAW_SLV_WR_DMA_DONE_INT_RAW = 0x200
	// Position of SLV_RD_BUF_DONE_INT_RAW field.
	SPI2_DMA_INT_RAW_SLV_RD_BUF_DONE_INT_RAW_Pos = 0xa
	// Bit mask of SLV_RD_BUF_DONE_INT_RAW field.
	SPI2_DMA_INT_RAW_SLV_RD_BUF_DONE_INT_RAW_Msk = 0x400
	// Bit SLV_RD_BUF_DONE_INT_RAW.
	SPI2_DMA_INT_RAW_SLV_RD_BUF_DONE_INT_RAW = 0x400
	// Position of SLV_WR_BUF_DONE_INT_RAW field.
	SPI2_DMA_INT_RAW_SLV_WR_BUF_DONE_INT_RAW_Pos = 0xb
	// Bit mask of SLV_WR_BUF_DONE_INT_RAW field.
	SPI2_DMA_INT_RAW_SLV_WR_BUF_DONE_INT_RAW_Msk = 0x800
	// Bit SLV_WR_BUF_DONE_INT_RAW.
	SPI2_DMA_INT_RAW_SLV_WR_BUF_DONE_INT_RAW = 0x800
	// Position of TRANS_DONE_INT_RAW field.
	SPI2_DMA_INT_RAW_TRANS_DONE_INT_RAW_Pos = 0xc
	// Bit mask of TRANS_DONE_INT_RAW field.
	SPI2_DMA_INT_RAW_TRANS_DONE_INT_RAW_Msk = 0x1000
	// Bit TRANS_DONE_INT_RAW.
	SPI2_DMA_INT_RAW_TRANS_DONE_INT_RAW = 0x1000
	// Position of DMA_SEG_TRANS_DONE_INT_RAW field.
	SPI2_DMA_INT_RAW_DMA_SEG_TRANS_DONE_INT_RAW_Pos = 0xd
	// Bit mask of DMA_SEG_TRANS_DONE_INT_RAW field.
	SPI2_DMA_INT_RAW_DMA_SEG_TRANS_DONE_INT_RAW_Msk = 0x2000
	// Bit DMA_SEG_TRANS_DONE_INT_RAW.
	SPI2_DMA_INT_RAW_DMA_SEG_TRANS_DONE_INT_RAW = 0x2000
	// Position of SEG_MAGIC_ERR_INT_RAW field.
	SPI2_DMA_INT_RAW_SEG_MAGIC_ERR_INT_RAW_Pos = 0xe
	// Bit mask of SEG_MAGIC_ERR_INT_RAW field.
	SPI2_DMA_INT_RAW_SEG_MAGIC_ERR_INT_RAW_Msk = 0x4000
	// Bit SEG_MAGIC_ERR_INT_RAW.
	SPI2_DMA_INT_RAW_SEG_MAGIC_ERR_INT_RAW = 0x4000
	// Position of SLV_BUF_ADDR_ERR_INT_RAW field.
	SPI2_DMA_INT_RAW_SLV_BUF_ADDR_ERR_INT_RAW_Pos = 0xf
	// Bit mask of SLV_BUF_ADDR_ERR_INT_RAW field.
	SPI2_DMA_INT_RAW_SLV_BUF_ADDR_ERR_INT_RAW_Msk = 0x8000
	// Bit SLV_BUF_ADDR_ERR_INT_RAW.
	SPI2_DMA_INT_RAW_SLV_BUF_ADDR_ERR_INT_RAW = 0x8000
	// Position of SLV_CMD_ERR_INT_RAW field.
	SPI2_DMA_INT_RAW_SLV_CMD_ERR_INT_RAW_Pos = 0x10
	// Bit mask of SLV_CMD_ERR_INT_RAW field.
	SPI2_DMA_INT_RAW_SLV_CMD_ERR_INT_RAW_Msk = 0x10000
	// Bit SLV_CMD_ERR_INT_RAW.
	SPI2_DMA_INT_RAW_SLV_CMD_ERR_INT_RAW = 0x10000
	// Position of MST_RX_AFIFO_WFULL_ERR_INT_RAW field.
	SPI2_DMA_INT_RAW_MST_RX_AFIFO_WFULL_ERR_INT_RAW_Pos = 0x11
	// Bit mask of MST_RX_AFIFO_WFULL_ERR_INT_RAW field.
	SPI2_DMA_INT_RAW_MST_RX_AFIFO_WFULL_ERR_INT_RAW_Msk = 0x20000
	// Bit MST_RX_AFIFO_WFULL_ERR_INT_RAW.
	SPI2_DMA_INT_RAW_MST_RX_AFIFO_WFULL_ERR_INT_RAW = 0x20000
	// Position of MST_TX_AFIFO_REMPTY_ERR_INT_RAW field.
	SPI2_DMA_INT_RAW_MST_TX_AFIFO_REMPTY_ERR_INT_RAW_Pos = 0x12
	// Bit mask of MST_TX_AFIFO_REMPTY_ERR_INT_RAW field.
	SPI2_DMA_INT_RAW_MST_TX_AFIFO_REMPTY_ERR_INT_RAW_Msk = 0x40000
	// Bit MST_TX_AFIFO_REMPTY_ERR_INT_RAW.
	SPI2_DMA_INT_RAW_MST_TX_AFIFO_REMPTY_ERR_INT_RAW = 0x40000
	// Position of APP2_INT_RAW field.
	SPI2_DMA_INT_RAW_APP2_INT_RAW_Pos = 0x13
	// Bit mask of APP2_INT_RAW field.
	SPI2_DMA_INT_RAW_APP2_INT_RAW_Msk = 0x80000
	// Bit APP2_INT_RAW.
	SPI2_DMA_INT_RAW_APP2_INT_RAW = 0x80000
	// Position of APP1_INT_RAW field.
	SPI2_DMA_INT_RAW_APP1_INT_RAW_Pos = 0x14
	// Bit mask of APP1_INT_RAW field.
	SPI2_DMA_INT_RAW_APP1_INT_RAW_Msk = 0x100000
	// Bit APP1_INT_RAW.
	SPI2_DMA_INT_RAW_APP1_INT_RAW = 0x100000

	// DMA_INT_ST: SPI DMA interrupt status register
	// Position of DMA_INFIFO_FULL_ERR_INT_ST field.
	SPI2_DMA_INT_ST_DMA_INFIFO_FULL_ERR_INT_ST_Pos = 0x0
	// Bit mask of DMA_INFIFO_FULL_ERR_INT_ST field.
	SPI2_DMA_INT_ST_DMA_INFIFO_FULL_ERR_INT_ST_Msk = 0x1
	// Bit DMA_INFIFO_FULL_ERR_INT_ST.
	SPI2_DMA_INT_ST_DMA_INFIFO_FULL_ERR_INT_ST = 0x1
	// Position of DMA_OUTFIFO_EMPTY_ERR_INT_ST field.
	SPI2_DMA_INT_ST_DMA_OUTFIFO_EMPTY_ERR_INT_ST_Pos = 0x1
	// Bit mask of DMA_OUTFIFO_EMPTY_ERR_INT_ST field.
	SPI2_DMA_INT_ST_DMA_OUTFIFO_EMPTY_ERR_INT_ST_Msk = 0x2
	// Bit DMA_OUTFIFO_EMPTY_ERR_INT_ST.
	SPI2_DMA_INT_ST_DMA_OUTFIFO_EMPTY_ERR_INT_ST = 0x2
	// Position of SLV_EX_QPI_INT_ST field.
	SPI2_DMA_INT_ST_SLV_EX_QPI_INT_ST_Pos = 0x2
	// Bit mask of SLV_EX_QPI_INT_ST field.
	SPI2_DMA_INT_ST_SLV_EX_QPI_INT_ST_Msk = 0x4
	// Bit SLV_EX_QPI_INT_ST.
	SPI2_DMA_INT_ST_SLV_EX_QPI_INT_ST = 0x4
	// Position of SLV_EN_QPI_INT_ST field.
	SPI2_DMA_INT_ST_SLV_EN_QPI_INT_ST_Pos = 0x3
	// Bit mask of SLV_EN_QPI_INT_ST field.
	SPI2_DMA_INT_ST_SLV_EN_QPI_INT_ST_Msk = 0x8
	// Bit SLV_EN_QPI_INT_ST.
	SPI2_DMA_INT_ST_SLV_EN_QPI_INT_ST = 0x8
	// Position of SLV_CMD7_INT_ST field.
	SPI2_DMA_INT_ST_SLV_CMD7_INT_ST_Pos = 0x4
	// Bit mask of SLV_CMD7_INT_ST field.
	SPI2_DMA_INT_ST_SLV_CMD7_INT_ST_Msk = 0x10
	// Bit SLV_CMD7_INT_ST.
	SPI2_DMA_INT_ST_SLV_CMD7_INT_ST = 0x10
	// Position of SLV_CMD8_INT_ST field.
	SPI2_DMA_INT_ST_SLV_CMD8_INT_ST_Pos = 0x5
	// Bit mask of SLV_CMD8_INT_ST field.
	SPI2_DMA_INT_ST_SLV_CMD8_INT_ST_Msk = 0x20
	// Bit SLV_CMD8_INT_ST.
	SPI2_DMA_INT_ST_SLV_CMD8_INT_ST = 0x20
	// Position of SLV_CMD9_INT_ST field.
	SPI2_DMA_INT_ST_SLV_CMD9_INT_ST_Pos = 0x6
	// Bit mask of SLV_CMD9_INT_ST field.
	SPI2_DMA_INT_ST_SLV_CMD9_INT_ST_Msk = 0x40
	// Bit SLV_CMD9_INT_ST.
	SPI2_DMA_INT_ST_SLV_CMD9_INT_ST = 0x40
	// Position of SLV_CMDA_INT_ST field.
	SPI2_DMA_INT_ST_SLV_CMDA_INT_ST_Pos = 0x7
	// Bit mask of SLV_CMDA_INT_ST field.
	SPI2_DMA_INT_ST_SLV_CMDA_INT_ST_Msk = 0x80
	// Bit SLV_CMDA_INT_ST.
	SPI2_DMA_INT_ST_SLV_CMDA_INT_ST = 0x80
	// Position of SLV_RD_DMA_DONE_INT_ST field.
	SPI2_DMA_INT_ST_SLV_RD_DMA_DONE_INT_ST_Pos = 0x8
	// Bit mask of SLV_RD_DMA_DONE_INT_ST field.
	SPI2_DMA_INT_ST_SLV_RD_DMA_DONE_INT_ST_Msk = 0x100
	// Bit SLV_RD_DMA_DONE_INT_ST.
	SPI2_DMA_INT_ST_SLV_RD_DMA_DONE_INT_ST = 0x100
	// Position of SLV_WR_DMA_DONE_INT_ST field.
	SPI2_DMA_INT_ST_SLV_WR_DMA_DONE_INT_ST_Pos = 0x9
	// Bit mask of SLV_WR_DMA_DONE_INT_ST field.
	SPI2_DMA_INT_ST_SLV_WR_DMA_DONE_INT_ST_Msk = 0x200
	// Bit SLV_WR_DMA_DONE_INT_ST.
	SPI2_DMA_INT_ST_SLV_WR_DMA_DONE_INT_ST = 0x200
	// Position of SLV_RD_BUF_DONE_INT_ST field.
	SPI2_DMA_INT_ST_SLV_RD_BUF_DONE_INT_ST_Pos = 0xa
	// Bit mask of SLV_RD_BUF_DONE_INT_ST field.
	SPI2_DMA_INT_ST_SLV_RD_BUF_DONE_INT_ST_Msk = 0x400
	// Bit SLV_RD_BUF_DONE_INT_ST.
	SPI2_DMA_INT_ST_SLV_RD_BUF_DONE_INT_ST = 0x400
	// Position of SLV_WR_BUF_DONE_INT_ST field.
	SPI2_DMA_INT_ST_SLV_WR_BUF_DONE_INT_ST_Pos = 0xb
	// Bit mask of SLV_WR_BUF_DONE_INT_ST field.
	SPI2_DMA_INT_ST_SLV_WR_BUF_DONE_INT_ST_Msk = 0x800
	// Bit SLV_WR_BUF_DONE_INT_ST.
	SPI2_DMA_INT_ST_SLV_WR_BUF_DONE_INT_ST = 0x800
	// Position of TRANS_DONE_INT_ST field.
	SPI2_DMA_INT_ST_TRANS_DONE_INT_ST_Pos = 0xc
	// Bit mask of TRANS_DONE_INT_ST field.
	SPI2_DMA_INT_ST_TRANS_DONE_INT_ST_Msk = 0x1000
	// Bit TRANS_DONE_INT_ST.
	SPI2_DMA_INT_ST_TRANS_DONE_INT_ST = 0x1000
	// Position of DMA_SEG_TRANS_DONE_INT_ST field.
	SPI2_DMA_INT_ST_DMA_SEG_TRANS_DONE_INT_ST_Pos = 0xd
	// Bit mask of DMA_SEG_TRANS_DONE_INT_ST field.
	SPI2_DMA_INT_ST_DMA_SEG_TRANS_DONE_INT_ST_Msk = 0x2000
	// Bit DMA_SEG_TRANS_DONE_INT_ST.
	SPI2_DMA_INT_ST_DMA_SEG_TRANS_DONE_INT_ST = 0x2000
	// Position of SEG_MAGIC_ERR_INT_ST field.
	SPI2_DMA_INT_ST_SEG_MAGIC_ERR_INT_ST_Pos = 0xe
	// Bit mask of SEG_MAGIC_ERR_INT_ST field.
	SPI2_DMA_INT_ST_SEG_MAGIC_ERR_INT_ST_Msk = 0x4000
	// Bit SEG_MAGIC_ERR_INT_ST.
	SPI2_DMA_INT_ST_SEG_MAGIC_ERR_INT_ST = 0x4000
	// Position of SLV_BUF_ADDR_ERR_INT_ST field.
	SPI2_DMA_INT_ST_SLV_BUF_ADDR_ERR_INT_ST_Pos = 0xf
	// Bit mask of SLV_BUF_ADDR_ERR_INT_ST field.
	SPI2_DMA_INT_ST_SLV_BUF_ADDR_ERR_INT_ST_Msk = 0x8000
	// Bit SLV_BUF_ADDR_ERR_INT_ST.
	SPI2_DMA_INT_ST_SLV_BUF_ADDR_ERR_INT_ST = 0x8000
	// Position of SLV_CMD_ERR_INT_ST field.
	SPI2_DMA_INT_ST_SLV_CMD_ERR_INT_ST_Pos = 0x10
	// Bit mask of SLV_CMD_ERR_INT_ST field.
	SPI2_DMA_INT_ST_SLV_CMD_ERR_INT_ST_Msk = 0x10000
	// Bit SLV_CMD_ERR_INT_ST.
	SPI2_DMA_INT_ST_SLV_CMD_ERR_INT_ST = 0x10000
	// Position of MST_RX_AFIFO_WFULL_ERR_INT_ST field.
	SPI2_DMA_INT_ST_MST_RX_AFIFO_WFULL_ERR_INT_ST_Pos = 0x11
	// Bit mask of MST_RX_AFIFO_WFULL_ERR_INT_ST field.
	SPI2_DMA_INT_ST_MST_RX_AFIFO_WFULL_ERR_INT_ST_Msk = 0x20000
	// Bit MST_RX_AFIFO_WFULL_ERR_INT_ST.
	SPI2_DMA_INT_ST_MST_RX_AFIFO_WFULL_ERR_INT_ST = 0x20000
	// Position of MST_TX_AFIFO_REMPTY_ERR_INT_ST field.
	SPI2_DMA_INT_ST_MST_TX_AFIFO_REMPTY_ERR_INT_ST_Pos = 0x12
	// Bit mask of MST_TX_AFIFO_REMPTY_ERR_INT_ST field.
	SPI2_DMA_INT_ST_MST_TX_AFIFO_REMPTY_ERR_INT_ST_Msk = 0x40000
	// Bit MST_TX_AFIFO_REMPTY_ERR_INT_ST.
	SPI2_DMA_INT_ST_MST_TX_AFIFO_REMPTY_ERR_INT_ST = 0x40000
	// Position of APP2_INT_ST field.
	SPI2_DMA_INT_ST_APP2_INT_ST_Pos = 0x13
	// Bit mask of APP2_INT_ST field.
	SPI2_DMA_INT_ST_APP2_INT_ST_Msk = 0x80000
	// Bit APP2_INT_ST.
	SPI2_DMA_INT_ST_APP2_INT_ST = 0x80000
	// Position of APP1_INT_ST field.
	SPI2_DMA_INT_ST_APP1_INT_ST_Pos = 0x14
	// Bit mask of APP1_INT_ST field.
	SPI2_DMA_INT_ST_APP1_INT_ST_Msk = 0x100000
	// Bit APP1_INT_ST.
	SPI2_DMA_INT_ST_APP1_INT_ST = 0x100000

	// W0: SPI CPU-controlled buffer0
	// Position of BUF0 field.
	SPI2_W0_BUF0_Pos = 0x0
	// Bit mask of BUF0 field.
	SPI2_W0_BUF0_Msk = 0xffffffff

	// W1: SPI CPU-controlled buffer1
	// Position of BUF1 field.
	SPI2_W1_BUF1_Pos = 0x0
	// Bit mask of BUF1 field.
	SPI2_W1_BUF1_Msk = 0xffffffff

	// W2: SPI CPU-controlled buffer2
	// Position of BUF2 field.
	SPI2_W2_BUF2_Pos = 0x0
	// Bit mask of BUF2 field.
	SPI2_W2_BUF2_Msk = 0xffffffff

	// W3: SPI CPU-controlled buffer3
	// Position of BUF3 field.
	SPI2_W3_BUF3_Pos = 0x0
	// Bit mask of BUF3 field.
	SPI2_W3_BUF3_Msk = 0xffffffff

	// W4: SPI CPU-controlled buffer4
	// Position of BUF4 field.
	SPI2_W4_BUF4_Pos = 0x0
	// Bit mask of BUF4 field.
	SPI2_W4_BUF4_Msk = 0xffffffff

	// W5: SPI CPU-controlled buffer5
	// Position of BUF5 field.
	SPI2_W5_BUF5_Pos = 0x0
	// Bit mask of BUF5 field.
	SPI2_W5_BUF5_Msk = 0xffffffff

	// W6: SPI CPU-controlled buffer6
	// Position of BUF6 field.
	SPI2_W6_BUF6_Pos = 0x0
	// Bit mask of BUF6 field.
	SPI2_W6_BUF6_Msk = 0xffffffff

	// W7: SPI CPU-controlled buffer7
	// Position of BUF7 field.
	SPI2_W7_BUF7_Pos = 0x0
	// Bit mask of BUF7 field.
	SPI2_W7_BUF7_Msk = 0xffffffff

	// W8: SPI CPU-controlled buffer8
	// Position of BUF8 field.
	SPI2_W8_BUF8_Pos = 0x0
	// Bit mask of BUF8 field.
	SPI2_W8_BUF8_Msk = 0xffffffff

	// W9: SPI CPU-controlled buffer9
	// Position of BUF9 field.
	SPI2_W9_BUF9_Pos = 0x0
	// Bit mask of BUF9 field.
	SPI2_W9_BUF9_Msk = 0xffffffff

	// W10: SPI CPU-controlled buffer10
	// Position of BUF10 field.
	SPI2_W10_BUF10_Pos = 0x0
	// Bit mask of BUF10 field.
	SPI2_W10_BUF10_Msk = 0xffffffff

	// W11: SPI CPU-controlled buffer11
	// Position of BUF11 field.
	SPI2_W11_BUF11_Pos = 0x0
	// Bit mask of BUF11 field.
	SPI2_W11_BUF11_Msk = 0xffffffff

	// W12: SPI CPU-controlled buffer12
	// Position of BUF12 field.
	SPI2_W12_BUF12_Pos = 0x0
	// Bit mask of BUF12 field.
	SPI2_W12_BUF12_Msk = 0xffffffff

	// W13: SPI CPU-controlled buffer13
	// Position of BUF13 field.
	SPI2_W13_BUF13_Pos = 0x0
	// Bit mask of BUF13 field.
	SPI2_W13_BUF13_Msk = 0xffffffff

	// W14: SPI CPU-controlled buffer14
	// Position of BUF14 field.
	SPI2_W14_BUF14_Pos = 0x0
	// Bit mask of BUF14 field.
	SPI2_W14_BUF14_Msk = 0xffffffff

	// W15: SPI CPU-controlled buffer15
	// Position of BUF15 field.
	SPI2_W15_BUF15_Pos = 0x0
	// Bit mask of BUF15 field.
	SPI2_W15_BUF15_Msk = 0xffffffff

	// SLAVE: SPI slave control register
	// Position of CLK_MODE field.
	SPI2_SLAVE_CLK_MODE_Pos = 0x0
	// Bit mask of CLK_MODE field.
	SPI2_SLAVE_CLK_MODE_Msk = 0x3
	// Position of CLK_MODE_13 field.
	SPI2_SLAVE_CLK_MODE_13_Pos = 0x2
	// Bit mask of CLK_MODE_13 field.
	SPI2_SLAVE_CLK_MODE_13_Msk = 0x4
	// Bit CLK_MODE_13.
	SPI2_SLAVE_CLK_MODE_13 = 0x4
	// Position of RSCK_DATA_OUT field.
	SPI2_SLAVE_RSCK_DATA_OUT_Pos = 0x3
	// Bit mask of RSCK_DATA_OUT field.
	SPI2_SLAVE_RSCK_DATA_OUT_Msk = 0x8
	// Bit RSCK_DATA_OUT.
	SPI2_SLAVE_RSCK_DATA_OUT = 0x8
	// Position of SLV_RDDMA_BITLEN_EN field.
	SPI2_SLAVE_SLV_RDDMA_BITLEN_EN_Pos = 0x8
	// Bit mask of SLV_RDDMA_BITLEN_EN field.
	SPI2_SLAVE_SLV_RDDMA_BITLEN_EN_Msk = 0x100
	// Bit SLV_RDDMA_BITLEN_EN.
	SPI2_SLAVE_SLV_RDDMA_BITLEN_EN = 0x100
	// Position of SLV_WRDMA_BITLEN_EN field.
	SPI2_SLAVE_SLV_WRDMA_BITLEN_EN_Pos = 0x9
	// Bit mask of SLV_WRDMA_BITLEN_EN field.
	SPI2_SLAVE_SLV_WRDMA_BITLEN_EN_Msk = 0x200
	// Bit SLV_WRDMA_BITLEN_EN.
	SPI2_SLAVE_SLV_WRDMA_BITLEN_EN = 0x200
	// Position of SLV_RDBUF_BITLEN_EN field.
	SPI2_SLAVE_SLV_RDBUF_BITLEN_EN_Pos = 0xa
	// Bit mask of SLV_RDBUF_BITLEN_EN field.
	SPI2_SLAVE_SLV_RDBUF_BITLEN_EN_Msk = 0x400
	// Bit SLV_RDBUF_BITLEN_EN.
	SPI2_SLAVE_SLV_RDBUF_BITLEN_EN = 0x400
	// Position of SLV_WRBUF_BITLEN_EN field.
	SPI2_SLAVE_SLV_WRBUF_BITLEN_EN_Pos = 0xb
	// Bit mask of SLV_WRBUF_BITLEN_EN field.
	SPI2_SLAVE_SLV_WRBUF_BITLEN_EN_Msk = 0x800
	// Bit SLV_WRBUF_BITLEN_EN.
	SPI2_SLAVE_SLV_WRBUF_BITLEN_EN = 0x800
	// Position of DMA_SEG_MAGIC_VALUE field.
	SPI2_SLAVE_DMA_SEG_MAGIC_VALUE_Pos = 0x16
	// Bit mask of DMA_SEG_MAGIC_VALUE field.
	SPI2_SLAVE_DMA_SEG_MAGIC_VALUE_Msk = 0x3c00000
	// Position of MODE field.
	SPI2_SLAVE_MODE_Pos = 0x1a
	// Bit mask of MODE field.
	SPI2_SLAVE_MODE_Msk = 0x4000000
	// Bit MODE.
	SPI2_SLAVE_MODE = 0x4000000
	// Position of SOFT_RESET field.
	SPI2_SLAVE_SOFT_RESET_Pos = 0x1b
	// Bit mask of SOFT_RESET field.
	SPI2_SLAVE_SOFT_RESET_Msk = 0x8000000
	// Bit SOFT_RESET.
	SPI2_SLAVE_SOFT_RESET = 0x8000000
	// Position of USR_CONF field.
	SPI2_SLAVE_USR_CONF_Pos = 0x1c
	// Bit mask of USR_CONF field.
	SPI2_SLAVE_USR_CONF_Msk = 0x10000000
	// Bit USR_CONF.
	SPI2_SLAVE_USR_CONF = 0x10000000

	// SLAVE1: SPI slave control register 1
	// Position of SLV_DATA_BITLEN field.
	SPI2_SLAVE1_SLV_DATA_BITLEN_Pos = 0x0
	// Bit mask of SLV_DATA_BITLEN field.
	SPI2_SLAVE1_SLV_DATA_BITLEN_Msk = 0x3ffff
	// Position of SLV_LAST_COMMAND field.
	SPI2_SLAVE1_SLV_LAST_COMMAND_Pos = 0x12
	// Bit mask of SLV_LAST_COMMAND field.
	SPI2_SLAVE1_SLV_LAST_COMMAND_Msk = 0x3fc0000
	// Position of SLV_LAST_ADDR field.
	SPI2_SLAVE1_SLV_LAST_ADDR_Pos = 0x1a
	// Bit mask of SLV_LAST_ADDR field.
	SPI2_SLAVE1_SLV_LAST_ADDR_Msk = 0xfc000000

	// CLK_GATE: SPI module clock and register clock control
	// Position of CLK_EN field.
	SPI2_CLK_GATE_CLK_EN_Pos = 0x0
	// Bit mask of CLK_EN field.
	SPI2_CLK_GATE_CLK_EN_Msk = 0x1
	// Bit CLK_EN.
	SPI2_CLK_GATE_CLK_EN = 0x1
	// Position of MST_CLK_ACTIVE field.
	SPI2_CLK_GATE_MST_CLK_ACTIVE_Pos = 0x1
	// Bit mask of MST_CLK_ACTIVE field.
	SPI2_CLK_GATE_MST_CLK_ACTIVE_Msk = 0x2
	// Bit MST_CLK_ACTIVE.
	SPI2_CLK_GATE_MST_CLK_ACTIVE = 0x2
	// Position of MST_CLK_SEL field.
	SPI2_CLK_GATE_MST_CLK_SEL_Pos = 0x2
	// Bit mask of MST_CLK_SEL field.
	SPI2_CLK_GATE_MST_CLK_SEL_Msk = 0x4
	// Bit MST_CLK_SEL.
	SPI2_CLK_GATE_MST_CLK_SEL = 0x4

	// DATE: Version control
	// Position of DATE field.
	SPI2_DATE_DATE_Pos = 0x0
	// Bit mask of DATE field.
	SPI2_DATE_DATE_Msk = 0xfffffff
)

// Constants for SYSTEM: Peripheral SYSTEM
const (
	// CPU_PERI_CLK_EN: cpu_peripheral clock gating register
	// Position of CLK_EN_ASSIST_DEBUG field.
	SYSTEM_CPU_PERI_CLK_EN_CLK_EN_ASSIST_DEBUG_Pos = 0x6
	// Bit mask of CLK_EN_ASSIST_DEBUG field.
	SYSTEM_CPU_PERI_CLK_EN_CLK_EN_ASSIST_DEBUG_Msk = 0x40
	// Bit CLK_EN_ASSIST_DEBUG.
	SYSTEM_CPU_PERI_CLK_EN_CLK_EN_ASSIST_DEBUG = 0x40
	// Position of CLK_EN_DEDICATED_GPIO field.
	SYSTEM_CPU_PERI_CLK_EN_CLK_EN_DEDICATED_GPIO_Pos = 0x7
	// Bit mask of CLK_EN_DEDICATED_GPIO field.
	SYSTEM_CPU_PERI_CLK_EN_CLK_EN_DEDICATED_GPIO_Msk = 0x80
	// Bit CLK_EN_DEDICATED_GPIO.
	SYSTEM_CPU_PERI_CLK_EN_CLK_EN_DEDICATED_GPIO = 0x80

	// CPU_PERI_RST_EN: cpu_peripheral reset register
	// Position of RST_EN_ASSIST_DEBUG field.
	SYSTEM_CPU_PERI_RST_EN_RST_EN_ASSIST_DEBUG_Pos = 0x6
	// Bit mask of RST_EN_ASSIST_DEBUG field.
	SYSTEM_CPU_PERI_RST_EN_RST_EN_ASSIST_DEBUG_Msk = 0x40
	// Bit RST_EN_ASSIST_DEBUG.
	SYSTEM_CPU_PERI_RST_EN_RST_EN_ASSIST_DEBUG = 0x40
	// Position of RST_EN_DEDICATED_GPIO field.
	SYSTEM_CPU_PERI_RST_EN_RST_EN_DEDICATED_GPIO_Pos = 0x7
	// Bit mask of RST_EN_DEDICATED_GPIO field.
	SYSTEM_CPU_PERI_RST_EN_RST_EN_DEDICATED_GPIO_Msk = 0x80
	// Bit RST_EN_DEDICATED_GPIO.
	SYSTEM_CPU_PERI_RST_EN_RST_EN_DEDICATED_GPIO = 0x80

	// CPU_PER_CONF: cpu clock config register
	// Position of CPUPERIOD_SEL field.
	SYSTEM_CPU_PER_CONF_CPUPERIOD_SEL_Pos = 0x0
	// Bit mask of CPUPERIOD_SEL field.
	SYSTEM_CPU_PER_CONF_CPUPERIOD_SEL_Msk = 0x3
	// Position of PLL_FREQ_SEL field.
	SYSTEM_CPU_PER_CONF_PLL_FREQ_SEL_Pos = 0x2
	// Bit mask of PLL_FREQ_SEL field.
	SYSTEM_CPU_PER_CONF_PLL_FREQ_SEL_Msk = 0x4
	// Bit PLL_FREQ_SEL.
	SYSTEM_CPU_PER_CONF_PLL_FREQ_SEL = 0x4
	// Position of CPU_WAIT_MODE_FORCE_ON field.
	SYSTEM_CPU_PER_CONF_CPU_WAIT_MODE_FORCE_ON_Pos = 0x3
	// Bit mask of CPU_WAIT_MODE_FORCE_ON field.
	SYSTEM_CPU_PER_CONF_CPU_WAIT_MODE_FORCE_ON_Msk = 0x8
	// Bit CPU_WAIT_MODE_FORCE_ON.
	SYSTEM_CPU_PER_CONF_CPU_WAIT_MODE_FORCE_ON = 0x8
	// Position of CPU_WAITI_DELAY_NUM field.
	SYSTEM_CPU_PER_CONF_CPU_WAITI_DELAY_NUM_Pos = 0x4
	// Bit mask of CPU_WAITI_DELAY_NUM field.
	SYSTEM_CPU_PER_CONF_CPU_WAITI_DELAY_NUM_Msk = 0xf0

	// MEM_PD_MASK: memory power down mask register
	// Position of LSLP_MEM_PD_MASK field.
	SYSTEM_MEM_PD_MASK_LSLP_MEM_PD_MASK_Pos = 0x0
	// Bit mask of LSLP_MEM_PD_MASK field.
	SYSTEM_MEM_PD_MASK_LSLP_MEM_PD_MASK_Msk = 0x1
	// Bit LSLP_MEM_PD_MASK.
	SYSTEM_MEM_PD_MASK_LSLP_MEM_PD_MASK = 0x1

	// PERIP_CLK_EN0: peripheral clock gating register
	// Position of TIMERS_CLK_EN field.
	SYSTEM_PERIP_CLK_EN0_TIMERS_CLK_EN_Pos = 0x0
	// Bit mask of TIMERS_CLK_EN field.
	SYSTEM_PERIP_CLK_EN0_TIMERS_CLK_EN_Msk = 0x1
	// Bit TIMERS_CLK_EN.
	SYSTEM_PERIP_CLK_EN0_TIMERS_CLK_EN = 0x1
	// Position of SPI01_CLK_EN field.
	SYSTEM_PERIP_CLK_EN0_SPI01_CLK_EN_Pos = 0x1
	// Bit mask of SPI01_CLK_EN field.
	SYSTEM_PERIP_CLK_EN0_SPI01_CLK_EN_Msk = 0x2
	// Bit SPI01_CLK_EN.
	SYSTEM_PERIP_CLK_EN0_SPI01_CLK_EN = 0x2
	// Position of UART_CLK_EN field.
	SYSTEM_PERIP_CLK_EN0_UART_CLK_EN_Pos = 0x2
	// Bit mask of UART_CLK_EN field.
	SYSTEM_PERIP_CLK_EN0_UART_CLK_EN_Msk = 0x4
	// Bit UART_CLK_EN.
	SYSTEM_PERIP_CLK_EN0_UART_CLK_EN = 0x4
	// Position of WDG_CLK_EN field.
	SYSTEM_PERIP_CLK_EN0_WDG_CLK_EN_Pos = 0x3
	// Bit mask of WDG_CLK_EN field.
	SYSTEM_PERIP_CLK_EN0_WDG_CLK_EN_Msk = 0x8
	// Bit WDG_CLK_EN.
	SYSTEM_PERIP_CLK_EN0_WDG_CLK_EN = 0x8
	// Position of I2S0_CLK_EN field.
	SYSTEM_PERIP_CLK_EN0_I2S0_CLK_EN_Pos = 0x4
	// Bit mask of I2S0_CLK_EN field.
	SYSTEM_PERIP_CLK_EN0_I2S0_CLK_EN_Msk = 0x10
	// Bit I2S0_CLK_EN.
	SYSTEM_PERIP_CLK_EN0_I2S0_CLK_EN = 0x10
	// Position of UART1_CLK_EN field.
	SYSTEM_PERIP_CLK_EN0_UART1_CLK_EN_Pos = 0x5
	// Bit mask of UART1_CLK_EN field.
	SYSTEM_PERIP_CLK_EN0_UART1_CLK_EN_Msk = 0x20
	// Bit UART1_CLK_EN.
	SYSTEM_PERIP_CLK_EN0_UART1_CLK_EN = 0x20
	// Position of SPI2_CLK_EN field.
	SYSTEM_PERIP_CLK_EN0_SPI2_CLK_EN_Pos = 0x6
	// Bit mask of SPI2_CLK_EN field.
	SYSTEM_PERIP_CLK_EN0_SPI2_CLK_EN_Msk = 0x40
	// Bit SPI2_CLK_EN.
	SYSTEM_PERIP_CLK_EN0_SPI2_CLK_EN = 0x40
	// Position of EXT0_CLK_EN field.
	SYSTEM_PERIP_CLK_EN0_EXT0_CLK_EN_Pos = 0x7
	// Bit mask of EXT0_CLK_EN field.
	SYSTEM_PERIP_CLK_EN0_EXT0_CLK_EN_Msk = 0x80
	// Bit EXT0_CLK_EN.
	SYSTEM_PERIP_CLK_EN0_EXT0_CLK_EN = 0x80
	// Position of UHCI0_CLK_EN field.
	SYSTEM_PERIP_CLK_EN0_UHCI0_CLK_EN_Pos = 0x8
	// Bit mask of UHCI0_CLK_EN field.
	SYSTEM_PERIP_CLK_EN0_UHCI0_CLK_EN_Msk = 0x100
	// Bit UHCI0_CLK_EN.
	SYSTEM_PERIP_CLK_EN0_UHCI0_CLK_EN = 0x100
	// Position of RMT_CLK_EN field.
	SYSTEM_PERIP_CLK_EN0_RMT_CLK_EN_Pos = 0x9
	// Bit mask of RMT_CLK_EN field.
	SYSTEM_PERIP_CLK_EN0_RMT_CLK_EN_Msk = 0x200
	// Bit RMT_CLK_EN.
	SYSTEM_PERIP_CLK_EN0_RMT_CLK_EN = 0x200
	// Position of PCNT_CLK_EN field.
	SYSTEM_PERIP_CLK_EN0_PCNT_CLK_EN_Pos = 0xa
	// Bit mask of PCNT_CLK_EN field.
	SYSTEM_PERIP_CLK_EN0_PCNT_CLK_EN_Msk = 0x400
	// Bit PCNT_CLK_EN.
	SYSTEM_PERIP_CLK_EN0_PCNT_CLK_EN = 0x400
	// Position of LEDC_CLK_EN field.
	SYSTEM_PERIP_CLK_EN0_LEDC_CLK_EN_Pos = 0xb
	// Bit mask of LEDC_CLK_EN field.
	SYSTEM_PERIP_CLK_EN0_LEDC_CLK_EN_Msk = 0x800
	// Bit LEDC_CLK_EN.
	SYSTEM_PERIP_CLK_EN0_LEDC_CLK_EN = 0x800
	// Position of UHCI1_CLK_EN field.
	SYSTEM_PERIP_CLK_EN0_UHCI1_CLK_EN_Pos = 0xc
	// Bit mask of UHCI1_CLK_EN field.
	SYSTEM_PERIP_CLK_EN0_UHCI1_CLK_EN_Msk = 0x1000
	// Bit UHCI1_CLK_EN.
	SYSTEM_PERIP_CLK_EN0_UHCI1_CLK_EN = 0x1000
	// Position of TIMERGROUP_CLK_EN field.
	SYSTEM_PERIP_CLK_EN0_TIMERGROUP_CLK_EN_Pos = 0xd
	// Bit mask of TIMERGROUP_CLK_EN field.
	SYSTEM_PERIP_CLK_EN0_TIMERGROUP_CLK_EN_Msk = 0x2000
	// Bit TIMERGROUP_CLK_EN.
	SYSTEM_PERIP_CLK_EN0_TIMERGROUP_CLK_EN = 0x2000
	// Position of EFUSE_CLK_EN field.
	SYSTEM_PERIP_CLK_EN0_EFUSE_CLK_EN_Pos = 0xe
	// Bit mask of EFUSE_CLK_EN field.
	SYSTEM_PERIP_CLK_EN0_EFUSE_CLK_EN_Msk = 0x4000
	// Bit EFUSE_CLK_EN.
	SYSTEM_PERIP_CLK_EN0_EFUSE_CLK_EN = 0x4000
	// Position of TIMERGROUP1_CLK_EN field.
	SYSTEM_PERIP_CLK_EN0_TIMERGROUP1_CLK_EN_Pos = 0xf
	// Bit mask of TIMERGROUP1_CLK_EN field.
	SYSTEM_PERIP_CLK_EN0_TIMERGROUP1_CLK_EN_Msk = 0x8000
	// Bit TIMERGROUP1_CLK_EN.
	SYSTEM_PERIP_CLK_EN0_TIMERGROUP1_CLK_EN = 0x8000
	// Position of SPI3_CLK_EN field.
	SYSTEM_PERIP_CLK_EN0_SPI3_CLK_EN_Pos = 0x10
	// Bit mask of SPI3_CLK_EN field.
	SYSTEM_PERIP_CLK_EN0_SPI3_CLK_EN_Msk = 0x10000
	// Bit SPI3_CLK_EN.
	SYSTEM_PERIP_CLK_EN0_SPI3_CLK_EN = 0x10000
	// Position of PWM0_CLK_EN field.
	SYSTEM_PERIP_CLK_EN0_PWM0_CLK_EN_Pos = 0x11
	// Bit mask of PWM0_CLK_EN field.
	SYSTEM_PERIP_CLK_EN0_PWM0_CLK_EN_Msk = 0x20000
	// Bit PWM0_CLK_EN.
	SYSTEM_PERIP_CLK_EN0_PWM0_CLK_EN = 0x20000
	// Position of EXT1_CLK_EN field.
	SYSTEM_PERIP_CLK_EN0_EXT1_CLK_EN_Pos = 0x12
	// Bit mask of EXT1_CLK_EN field.
	SYSTEM_PERIP_CLK_EN0_EXT1_CLK_EN_Msk = 0x40000
	// Bit EXT1_CLK_EN.
	SYSTEM_PERIP_CLK_EN0_EXT1_CLK_EN = 0x40000
	// Position of CAN_CLK_EN field.
	SYSTEM_PERIP_CLK_EN0_CAN_CLK_EN_Pos = 0x13
	// Bit mask of CAN_CLK_EN field.
	SYSTEM_PERIP_CLK_EN0_CAN_CLK_EN_Msk = 0x80000
	// Bit CAN_CLK_EN.
	SYSTEM_PERIP_CLK_EN0_CAN_CLK_EN = 0x80000
	// Position of PWM1_CLK_EN field.
	SYSTEM_PERIP_CLK_EN0_PWM1_CLK_EN_Pos = 0x14
	// Bit mask of PWM1_CLK_EN field.
	SYSTEM_PERIP_CLK_EN0_PWM1_CLK_EN_Msk = 0x100000
	// Bit PWM1_CLK_EN.
	SYSTEM_PERIP_CLK_EN0_PWM1_CLK_EN = 0x100000
	// Position of I2S1_CLK_EN field.
	SYSTEM_PERIP_CLK_EN0_I2S1_CLK_EN_Pos = 0x15
	// Bit mask of I2S1_CLK_EN field.
	SYSTEM_PERIP_CLK_EN0_I2S1_CLK_EN_Msk = 0x200000
	// Bit I2S1_CLK_EN.
	SYSTEM_PERIP_CLK_EN0_I2S1_CLK_EN = 0x200000
	// Position of SPI2_DMA_CLK_EN field.
	SYSTEM_PERIP_CLK_EN0_SPI2_DMA_CLK_EN_Pos = 0x16
	// Bit mask of SPI2_DMA_CLK_EN field.
	SYSTEM_PERIP_CLK_EN0_SPI2_DMA_CLK_EN_Msk = 0x400000
	// Bit SPI2_DMA_CLK_EN.
	SYSTEM_PERIP_CLK_EN0_SPI2_DMA_CLK_EN = 0x400000
	// Position of USB_DEVICE_CLK_EN field.
	SYSTEM_PERIP_CLK_EN0_USB_DEVICE_CLK_EN_Pos = 0x17
	// Bit mask of USB_DEVICE_CLK_EN field.
	SYSTEM_PERIP_CLK_EN0_USB_DEVICE_CLK_EN_Msk = 0x800000
	// Bit USB_DEVICE_CLK_EN.
	SYSTEM_PERIP_CLK_EN0_USB_DEVICE_CLK_EN = 0x800000
	// Position of UART_MEM_CLK_EN field.
	SYSTEM_PERIP_CLK_EN0_UART_MEM_CLK_EN_Pos = 0x18
	// Bit mask of UART_MEM_CLK_EN field.
	SYSTEM_PERIP_CLK_EN0_UART_MEM_CLK_EN_Msk = 0x1000000
	// Bit UART_MEM_CLK_EN.
	SYSTEM_PERIP_CLK_EN0_UART_MEM_CLK_EN = 0x1000000
	// Position of PWM2_CLK_EN field.
	SYSTEM_PERIP_CLK_EN0_PWM2_CLK_EN_Pos = 0x19
	// Bit mask of PWM2_CLK_EN field.
	SYSTEM_PERIP_CLK_EN0_PWM2_CLK_EN_Msk = 0x2000000
	// Bit PWM2_CLK_EN.
	SYSTEM_PERIP_CLK_EN0_PWM2_CLK_EN = 0x2000000
	// Position of PWM3_CLK_EN field.
	SYSTEM_PERIP_CLK_EN0_PWM3_CLK_EN_Pos = 0x1a
	// Bit mask of PWM3_CLK_EN field.
	SYSTEM_PERIP_CLK_EN0_PWM3_CLK_EN_Msk = 0x4000000
	// Bit PWM3_CLK_EN.
	SYSTEM_PERIP_CLK_EN0_PWM3_CLK_EN = 0x4000000
	// Position of SPI3_DMA_CLK_EN field.
	SYSTEM_PERIP_CLK_EN0_SPI3_DMA_CLK_EN_Pos = 0x1b
	// Bit mask of SPI3_DMA_CLK_EN field.
	SYSTEM_PERIP_CLK_EN0_SPI3_DMA_CLK_EN_Msk = 0x8000000
	// Bit SPI3_DMA_CLK_EN.
	SYSTEM_PERIP_CLK_EN0_SPI3_DMA_CLK_EN = 0x8000000
	// Position of APB_SARADC_CLK_EN field.
	SYSTEM_PERIP_CLK_EN0_APB_SARADC_CLK_EN_Pos = 0x1c
	// Bit mask of APB_SARADC_CLK_EN field.
	SYSTEM_PERIP_CLK_EN0_APB_SARADC_CLK_EN_Msk = 0x10000000
	// Bit APB_SARADC_CLK_EN.
	SYSTEM_PERIP_CLK_EN0_APB_SARADC_CLK_EN = 0x10000000
	// Position of SYSTIMER_CLK_EN field.
	SYSTEM_PERIP_CLK_EN0_SYSTIMER_CLK_EN_Pos = 0x1d
	// Bit mask of SYSTIMER_CLK_EN field.
	SYSTEM_PERIP_CLK_EN0_SYSTIMER_CLK_EN_Msk = 0x20000000
	// Bit SYSTIMER_CLK_EN.
	SYSTEM_PERIP_CLK_EN0_SYSTIMER_CLK_EN = 0x20000000
	// Position of ADC2_ARB_CLK_EN field.
	SYSTEM_PERIP_CLK_EN0_ADC2_ARB_CLK_EN_Pos = 0x1e
	// Bit mask of ADC2_ARB_CLK_EN field.
	SYSTEM_PERIP_CLK_EN0_ADC2_ARB_CLK_EN_Msk = 0x40000000
	// Bit ADC2_ARB_CLK_EN.
	SYSTEM_PERIP_CLK_EN0_ADC2_ARB_CLK_EN = 0x40000000
	// Position of SPI4_CLK_EN field.
	SYSTEM_PERIP_CLK_EN0_SPI4_CLK_EN_Pos = 0x1f
	// Bit mask of SPI4_CLK_EN field.
	SYSTEM_PERIP_CLK_EN0_SPI4_CLK_EN_Msk = 0x80000000
	// Bit SPI4_CLK_EN.
	SYSTEM_PERIP_CLK_EN0_SPI4_CLK_EN = 0x80000000

	// PERIP_CLK_EN1: peripheral clock gating register
	// Position of CRYPTO_AES_CLK_EN field.
	SYSTEM_PERIP_CLK_EN1_CRYPTO_AES_CLK_EN_Pos = 0x1
	// Bit mask of CRYPTO_AES_CLK_EN field.
	SYSTEM_PERIP_CLK_EN1_CRYPTO_AES_CLK_EN_Msk = 0x2
	// Bit CRYPTO_AES_CLK_EN.
	SYSTEM_PERIP_CLK_EN1_CRYPTO_AES_CLK_EN = 0x2
	// Position of CRYPTO_SHA_CLK_EN field.
	SYSTEM_PERIP_CLK_EN1_CRYPTO_SHA_CLK_EN_Pos = 0x2
	// Bit mask of CRYPTO_SHA_CLK_EN field.
	SYSTEM_PERIP_CLK_EN1_CRYPTO_SHA_CLK_EN_Msk = 0x4
	// Bit CRYPTO_SHA_CLK_EN.
	SYSTEM_PERIP_CLK_EN1_CRYPTO_SHA_CLK_EN = 0x4
	// Position of CRYPTO_RSA_CLK_EN field.
	SYSTEM_PERIP_CLK_EN1_CRYPTO_RSA_CLK_EN_Pos = 0x3
	// Bit mask of CRYPTO_RSA_CLK_EN field.
	SYSTEM_PERIP_CLK_EN1_CRYPTO_RSA_CLK_EN_Msk = 0x8
	// Bit CRYPTO_RSA_CLK_EN.
	SYSTEM_PERIP_CLK_EN1_CRYPTO_RSA_CLK_EN = 0x8
	// Position of CRYPTO_DS_CLK_EN field.
	SYSTEM_PERIP_CLK_EN1_CRYPTO_DS_CLK_EN_Pos = 0x4
	// Bit mask of CRYPTO_DS_CLK_EN field.
	SYSTEM_PERIP_CLK_EN1_CRYPTO_DS_CLK_EN_Msk = 0x10
	// Bit CRYPTO_DS_CLK_EN.
	SYSTEM_PERIP_CLK_EN1_CRYPTO_DS_CLK_EN = 0x10
	// Position of CRYPTO_HMAC_CLK_EN field.
	SYSTEM_PERIP_CLK_EN1_CRYPTO_HMAC_CLK_EN_Pos = 0x5
	// Bit mask of CRYPTO_HMAC_CLK_EN field.
	SYSTEM_PERIP_CLK_EN1_CRYPTO_HMAC_CLK_EN_Msk = 0x20
	// Bit CRYPTO_HMAC_CLK_EN.
	SYSTEM_PERIP_CLK_EN1_CRYPTO_HMAC_CLK_EN = 0x20
	// Position of DMA_CLK_EN field.
	SYSTEM_PERIP_CLK_EN1_DMA_CLK_EN_Pos = 0x6
	// Bit mask of DMA_CLK_EN field.
	SYSTEM_PERIP_CLK_EN1_DMA_CLK_EN_Msk = 0x40
	// Bit DMA_CLK_EN.
	SYSTEM_PERIP_CLK_EN1_DMA_CLK_EN = 0x40
	// Position of SDIO_HOST_CLK_EN field.
	SYSTEM_PERIP_CLK_EN1_SDIO_HOST_CLK_EN_Pos = 0x7
	// Bit mask of SDIO_HOST_CLK_EN field.
	SYSTEM_PERIP_CLK_EN1_SDIO_HOST_CLK_EN_Msk = 0x80
	// Bit SDIO_HOST_CLK_EN.
	SYSTEM_PERIP_CLK_EN1_SDIO_HOST_CLK_EN = 0x80
	// Position of LCD_CAM_CLK_EN field.
	SYSTEM_PERIP_CLK_EN1_LCD_CAM_CLK_EN_Pos = 0x8
	// Bit mask of LCD_CAM_CLK_EN field.
	SYSTEM_PERIP_CLK_EN1_LCD_CAM_CLK_EN_Msk = 0x100
	// Bit LCD_CAM_CLK_EN.
	SYSTEM_PERIP_CLK_EN1_LCD_CAM_CLK_EN = 0x100
	// Position of UART2_CLK_EN field.
	SYSTEM_PERIP_CLK_EN1_UART2_CLK_EN_Pos = 0x9
	// Bit mask of UART2_CLK_EN field.
	SYSTEM_PERIP_CLK_EN1_UART2_CLK_EN_Msk = 0x200
	// Bit UART2_CLK_EN.
	SYSTEM_PERIP_CLK_EN1_UART2_CLK_EN = 0x200
	// Position of TSENS_CLK_EN field.
	SYSTEM_PERIP_CLK_EN1_TSENS_CLK_EN_Pos = 0xa
	// Bit mask of TSENS_CLK_EN field.
	SYSTEM_PERIP_CLK_EN1_TSENS_CLK_EN_Msk = 0x400
	// Bit TSENS_CLK_EN.
	SYSTEM_PERIP_CLK_EN1_TSENS_CLK_EN = 0x400

	// PERIP_RST_EN0: reserved
	// Position of TIMERS_RST field.
	SYSTEM_PERIP_RST_EN0_TIMERS_RST_Pos = 0x0
	// Bit mask of TIMERS_RST field.
	SYSTEM_PERIP_RST_EN0_TIMERS_RST_Msk = 0x1
	// Bit TIMERS_RST.
	SYSTEM_PERIP_RST_EN0_TIMERS_RST = 0x1
	// Position of SPI01_RST field.
	SYSTEM_PERIP_RST_EN0_SPI01_RST_Pos = 0x1
	// Bit mask of SPI01_RST field.
	SYSTEM_PERIP_RST_EN0_SPI01_RST_Msk = 0x2
	// Bit SPI01_RST.
	SYSTEM_PERIP_RST_EN0_SPI01_RST = 0x2
	// Position of UART_RST field.
	SYSTEM_PERIP_RST_EN0_UART_RST_Pos = 0x2
	// Bit mask of UART_RST field.
	SYSTEM_PERIP_RST_EN0_UART_RST_Msk = 0x4
	// Bit UART_RST.
	SYSTEM_PERIP_RST_EN0_UART_RST = 0x4
	// Position of WDG_RST field.
	SYSTEM_PERIP_RST_EN0_WDG_RST_Pos = 0x3
	// Bit mask of WDG_RST field.
	SYSTEM_PERIP_RST_EN0_WDG_RST_Msk = 0x8
	// Bit WDG_RST.
	SYSTEM_PERIP_RST_EN0_WDG_RST = 0x8
	// Position of I2S0_RST field.
	SYSTEM_PERIP_RST_EN0_I2S0_RST_Pos = 0x4
	// Bit mask of I2S0_RST field.
	SYSTEM_PERIP_RST_EN0_I2S0_RST_Msk = 0x10
	// Bit I2S0_RST.
	SYSTEM_PERIP_RST_EN0_I2S0_RST = 0x10
	// Position of UART1_RST field.
	SYSTEM_PERIP_RST_EN0_UART1_RST_Pos = 0x5
	// Bit mask of UART1_RST field.
	SYSTEM_PERIP_RST_EN0_UART1_RST_Msk = 0x20
	// Bit UART1_RST.
	SYSTEM_PERIP_RST_EN0_UART1_RST = 0x20
	// Position of SPI2_RST field.
	SYSTEM_PERIP_RST_EN0_SPI2_RST_Pos = 0x6
	// Bit mask of SPI2_RST field.
	SYSTEM_PERIP_RST_EN0_SPI2_RST_Msk = 0x40
	// Bit SPI2_RST.
	SYSTEM_PERIP_RST_EN0_SPI2_RST = 0x40
	// Position of EXT0_RST field.
	SYSTEM_PERIP_RST_EN0_EXT0_RST_Pos = 0x7
	// Bit mask of EXT0_RST field.
	SYSTEM_PERIP_RST_EN0_EXT0_RST_Msk = 0x80
	// Bit EXT0_RST.
	SYSTEM_PERIP_RST_EN0_EXT0_RST = 0x80
	// Position of UHCI0_RST field.
	SYSTEM_PERIP_RST_EN0_UHCI0_RST_Pos = 0x8
	// Bit mask of UHCI0_RST field.
	SYSTEM_PERIP_RST_EN0_UHCI0_RST_Msk = 0x100
	// Bit UHCI0_RST.
	SYSTEM_PERIP_RST_EN0_UHCI0_RST = 0x100
	// Position of RMT_RST field.
	SYSTEM_PERIP_RST_EN0_RMT_RST_Pos = 0x9
	// Bit mask of RMT_RST field.
	SYSTEM_PERIP_RST_EN0_RMT_RST_Msk = 0x200
	// Bit RMT_RST.
	SYSTEM_PERIP_RST_EN0_RMT_RST = 0x200
	// Position of PCNT_RST field.
	SYSTEM_PERIP_RST_EN0_PCNT_RST_Pos = 0xa
	// Bit mask of PCNT_RST field.
	SYSTEM_PERIP_RST_EN0_PCNT_RST_Msk = 0x400
	// Bit PCNT_RST.
	SYSTEM_PERIP_RST_EN0_PCNT_RST = 0x400
	// Position of LEDC_RST field.
	SYSTEM_PERIP_RST_EN0_LEDC_RST_Pos = 0xb
	// Bit mask of LEDC_RST field.
	SYSTEM_PERIP_RST_EN0_LEDC_RST_Msk = 0x800
	// Bit LEDC_RST.
	SYSTEM_PERIP_RST_EN0_LEDC_RST = 0x800
	// Position of UHCI1_RST field.
	SYSTEM_PERIP_RST_EN0_UHCI1_RST_Pos = 0xc
	// Bit mask of UHCI1_RST field.
	SYSTEM_PERIP_RST_EN0_UHCI1_RST_Msk = 0x1000
	// Bit UHCI1_RST.
	SYSTEM_PERIP_RST_EN0_UHCI1_RST = 0x1000
	// Position of TIMERGROUP_RST field.
	SYSTEM_PERIP_RST_EN0_TIMERGROUP_RST_Pos = 0xd
	// Bit mask of TIMERGROUP_RST field.
	SYSTEM_PERIP_RST_EN0_TIMERGROUP_RST_Msk = 0x2000
	// Bit TIMERGROUP_RST.
	SYSTEM_PERIP_RST_EN0_TIMERGROUP_RST = 0x2000
	// Position of EFUSE_RST field.
	SYSTEM_PERIP_RST_EN0_EFUSE_RST_Pos = 0xe
	// Bit mask of EFUSE_RST field.
	SYSTEM_PERIP_RST_EN0_EFUSE_RST_Msk = 0x4000
	// Bit EFUSE_RST.
	SYSTEM_PERIP_RST_EN0_EFUSE_RST = 0x4000
	// Position of TIMERGROUP1_RST field.
	SYSTEM_PERIP_RST_EN0_TIMERGROUP1_RST_Pos = 0xf
	// Bit mask of TIMERGROUP1_RST field.
	SYSTEM_PERIP_RST_EN0_TIMERGROUP1_RST_Msk = 0x8000
	// Bit TIMERGROUP1_RST.
	SYSTEM_PERIP_RST_EN0_TIMERGROUP1_RST = 0x8000
	// Position of SPI3_RST field.
	SYSTEM_PERIP_RST_EN0_SPI3_RST_Pos = 0x10
	// Bit mask of SPI3_RST field.
	SYSTEM_PERIP_RST_EN0_SPI3_RST_Msk = 0x10000
	// Bit SPI3_RST.
	SYSTEM_PERIP_RST_EN0_SPI3_RST = 0x10000
	// Position of PWM0_RST field.
	SYSTEM_PERIP_RST_EN0_PWM0_RST_Pos = 0x11
	// Bit mask of PWM0_RST field.
	SYSTEM_PERIP_RST_EN0_PWM0_RST_Msk = 0x20000
	// Bit PWM0_RST.
	SYSTEM_PERIP_RST_EN0_PWM0_RST = 0x20000
	// Position of EXT1_RST field.
	SYSTEM_PERIP_RST_EN0_EXT1_RST_Pos = 0x12
	// Bit mask of EXT1_RST field.
	SYSTEM_PERIP_RST_EN0_EXT1_RST_Msk = 0x40000
	// Bit EXT1_RST.
	SYSTEM_PERIP_RST_EN0_EXT1_RST = 0x40000
	// Position of CAN_RST field.
	SYSTEM_PERIP_RST_EN0_CAN_RST_Pos = 0x13
	// Bit mask of CAN_RST field.
	SYSTEM_PERIP_RST_EN0_CAN_RST_Msk = 0x80000
	// Bit CAN_RST.
	SYSTEM_PERIP_RST_EN0_CAN_RST = 0x80000
	// Position of PWM1_RST field.
	SYSTEM_PERIP_RST_EN0_PWM1_RST_Pos = 0x14
	// Bit mask of PWM1_RST field.
	SYSTEM_PERIP_RST_EN0_PWM1_RST_Msk = 0x100000
	// Bit PWM1_RST.
	SYSTEM_PERIP_RST_EN0_PWM1_RST = 0x100000
	// Position of I2S1_RST field.
	SYSTEM_PERIP_RST_EN0_I2S1_RST_Pos = 0x15
	// Bit mask of I2S1_RST field.
	SYSTEM_PERIP_RST_EN0_I2S1_RST_Msk = 0x200000
	// Bit I2S1_RST.
	SYSTEM_PERIP_RST_EN0_I2S1_RST = 0x200000
	// Position of SPI2_DMA_RST field.
	SYSTEM_PERIP_RST_EN0_SPI2_DMA_RST_Pos = 0x16
	// Bit mask of SPI2_DMA_RST field.
	SYSTEM_PERIP_RST_EN0_SPI2_DMA_RST_Msk = 0x400000
	// Bit SPI2_DMA_RST.
	SYSTEM_PERIP_RST_EN0_SPI2_DMA_RST = 0x400000
	// Position of USB_DEVICE_RST field.
	SYSTEM_PERIP_RST_EN0_USB_DEVICE_RST_Pos = 0x17
	// Bit mask of USB_DEVICE_RST field.
	SYSTEM_PERIP_RST_EN0_USB_DEVICE_RST_Msk = 0x800000
	// Bit USB_DEVICE_RST.
	SYSTEM_PERIP_RST_EN0_USB_DEVICE_RST = 0x800000
	// Position of UART_MEM_RST field.
	SYSTEM_PERIP_RST_EN0_UART_MEM_RST_Pos = 0x18
	// Bit mask of UART_MEM_RST field.
	SYSTEM_PERIP_RST_EN0_UART_MEM_RST_Msk = 0x1000000
	// Bit UART_MEM_RST.
	SYSTEM_PERIP_RST_EN0_UART_MEM_RST = 0x1000000
	// Position of PWM2_RST field.
	SYSTEM_PERIP_RST_EN0_PWM2_RST_Pos = 0x19
	// Bit mask of PWM2_RST field.
	SYSTEM_PERIP_RST_EN0_PWM2_RST_Msk = 0x2000000
	// Bit PWM2_RST.
	SYSTEM_PERIP_RST_EN0_PWM2_RST = 0x2000000
	// Position of PWM3_RST field.
	SYSTEM_PERIP_RST_EN0_PWM3_RST_Pos = 0x1a
	// Bit mask of PWM3_RST field.
	SYSTEM_PERIP_RST_EN0_PWM3_RST_Msk = 0x4000000
	// Bit PWM3_RST.
	SYSTEM_PERIP_RST_EN0_PWM3_RST = 0x4000000
	// Position of SPI3_DMA_RST field.
	SYSTEM_PERIP_RST_EN0_SPI3_DMA_RST_Pos = 0x1b
	// Bit mask of SPI3_DMA_RST field.
	SYSTEM_PERIP_RST_EN0_SPI3_DMA_RST_Msk = 0x8000000
	// Bit SPI3_DMA_RST.
	SYSTEM_PERIP_RST_EN0_SPI3_DMA_RST = 0x8000000
	// Position of APB_SARADC_RST field.
	SYSTEM_PERIP_RST_EN0_APB_SARADC_RST_Pos = 0x1c
	// Bit mask of APB_SARADC_RST field.
	SYSTEM_PERIP_RST_EN0_APB_SARADC_RST_Msk = 0x10000000
	// Bit APB_SARADC_RST.
	SYSTEM_PERIP_RST_EN0_APB_SARADC_RST = 0x10000000
	// Position of SYSTIMER_RST field.
	SYSTEM_PERIP_RST_EN0_SYSTIMER_RST_Pos = 0x1d
	// Bit mask of SYSTIMER_RST field.
	SYSTEM_PERIP_RST_EN0_SYSTIMER_RST_Msk = 0x20000000
	// Bit SYSTIMER_RST.
	SYSTEM_PERIP_RST_EN0_SYSTIMER_RST = 0x20000000
	// Position of ADC2_ARB_RST field.
	SYSTEM_PERIP_RST_EN0_ADC2_ARB_RST_Pos = 0x1e
	// Bit mask of ADC2_ARB_RST field.
	SYSTEM_PERIP_RST_EN0_ADC2_ARB_RST_Msk = 0x40000000
	// Bit ADC2_ARB_RST.
	SYSTEM_PERIP_RST_EN0_ADC2_ARB_RST = 0x40000000
	// Position of SPI4_RST field.
	SYSTEM_PERIP_RST_EN0_SPI4_RST_Pos = 0x1f
	// Bit mask of SPI4_RST field.
	SYSTEM_PERIP_RST_EN0_SPI4_RST_Msk = 0x80000000
	// Bit SPI4_RST.
	SYSTEM_PERIP_RST_EN0_SPI4_RST = 0x80000000

	// PERIP_RST_EN1: peripheral reset register
	// Position of CRYPTO_AES_RST field.
	SYSTEM_PERIP_RST_EN1_CRYPTO_AES_RST_Pos = 0x1
	// Bit mask of CRYPTO_AES_RST field.
	SYSTEM_PERIP_RST_EN1_CRYPTO_AES_RST_Msk = 0x2
	// Bit CRYPTO_AES_RST.
	SYSTEM_PERIP_RST_EN1_CRYPTO_AES_RST = 0x2
	// Position of CRYPTO_SHA_RST field.
	SYSTEM_PERIP_RST_EN1_CRYPTO_SHA_RST_Pos = 0x2
	// Bit mask of CRYPTO_SHA_RST field.
	SYSTEM_PERIP_RST_EN1_CRYPTO_SHA_RST_Msk = 0x4
	// Bit CRYPTO_SHA_RST.
	SYSTEM_PERIP_RST_EN1_CRYPTO_SHA_RST = 0x4
	// Position of CRYPTO_RSA_RST field.
	SYSTEM_PERIP_RST_EN1_CRYPTO_RSA_RST_Pos = 0x3
	// Bit mask of CRYPTO_RSA_RST field.
	SYSTEM_PERIP_RST_EN1_CRYPTO_RSA_RST_Msk = 0x8
	// Bit CRYPTO_RSA_RST.
	SYSTEM_PERIP_RST_EN1_CRYPTO_RSA_RST = 0x8
	// Position of CRYPTO_DS_RST field.
	SYSTEM_PERIP_RST_EN1_CRYPTO_DS_RST_Pos = 0x4
	// Bit mask of CRYPTO_DS_RST field.
	SYSTEM_PERIP_RST_EN1_CRYPTO_DS_RST_Msk = 0x10
	// Bit CRYPTO_DS_RST.
	SYSTEM_PERIP_RST_EN1_CRYPTO_DS_RST = 0x10
	// Position of CRYPTO_HMAC_RST field.
	SYSTEM_PERIP_RST_EN1_CRYPTO_HMAC_RST_Pos = 0x5
	// Bit mask of CRYPTO_HMAC_RST field.
	SYSTEM_PERIP_RST_EN1_CRYPTO_HMAC_RST_Msk = 0x20
	// Bit CRYPTO_HMAC_RST.
	SYSTEM_PERIP_RST_EN1_CRYPTO_HMAC_RST = 0x20
	// Position of DMA_RST field.
	SYSTEM_PERIP_RST_EN1_DMA_RST_Pos = 0x6
	// Bit mask of DMA_RST field.
	SYSTEM_PERIP_RST_EN1_DMA_RST_Msk = 0x40
	// Bit DMA_RST.
	SYSTEM_PERIP_RST_EN1_DMA_RST = 0x40
	// Position of SDIO_HOST_RST field.
	SYSTEM_PERIP_RST_EN1_SDIO_HOST_RST_Pos = 0x7
	// Bit mask of SDIO_HOST_RST field.
	SYSTEM_PERIP_RST_EN1_SDIO_HOST_RST_Msk = 0x80
	// Bit SDIO_HOST_RST.
	SYSTEM_PERIP_RST_EN1_SDIO_HOST_RST = 0x80
	// Position of LCD_CAM_RST field.
	SYSTEM_PERIP_RST_EN1_LCD_CAM_RST_Pos = 0x8
	// Bit mask of LCD_CAM_RST field.
	SYSTEM_PERIP_RST_EN1_LCD_CAM_RST_Msk = 0x100
	// Bit LCD_CAM_RST.
	SYSTEM_PERIP_RST_EN1_LCD_CAM_RST = 0x100
	// Position of UART2_RST field.
	SYSTEM_PERIP_RST_EN1_UART2_RST_Pos = 0x9
	// Bit mask of UART2_RST field.
	SYSTEM_PERIP_RST_EN1_UART2_RST_Msk = 0x200
	// Bit UART2_RST.
	SYSTEM_PERIP_RST_EN1_UART2_RST = 0x200
	// Position of TSENS_RST field.
	SYSTEM_PERIP_RST_EN1_TSENS_RST_Pos = 0xa
	// Bit mask of TSENS_RST field.
	SYSTEM_PERIP_RST_EN1_TSENS_RST_Msk = 0x400
	// Bit TSENS_RST.
	SYSTEM_PERIP_RST_EN1_TSENS_RST = 0x400

	// BT_LPCK_DIV_INT: clock config register
	// Position of BT_LPCK_DIV_NUM field.
	SYSTEM_BT_LPCK_DIV_INT_BT_LPCK_DIV_NUM_Pos = 0x0
	// Bit mask of BT_LPCK_DIV_NUM field.
	SYSTEM_BT_LPCK_DIV_INT_BT_LPCK_DIV_NUM_Msk = 0xfff

	// BT_LPCK_DIV_FRAC: clock config register
	// Position of BT_LPCK_DIV_B field.
	SYSTEM_BT_LPCK_DIV_FRAC_BT_LPCK_DIV_B_Pos = 0x0
	// Bit mask of BT_LPCK_DIV_B field.
	SYSTEM_BT_LPCK_DIV_FRAC_BT_LPCK_DIV_B_Msk = 0xfff
	// Position of BT_LPCK_DIV_A field.
	SYSTEM_BT_LPCK_DIV_FRAC_BT_LPCK_DIV_A_Pos = 0xc
	// Bit mask of BT_LPCK_DIV_A field.
	SYSTEM_BT_LPCK_DIV_FRAC_BT_LPCK_DIV_A_Msk = 0xfff000
	// Position of LPCLK_SEL_RTC_SLOW field.
	SYSTEM_BT_LPCK_DIV_FRAC_LPCLK_SEL_RTC_SLOW_Pos = 0x18
	// Bit mask of LPCLK_SEL_RTC_SLOW field.
	SYSTEM_BT_LPCK_DIV_FRAC_LPCLK_SEL_RTC_SLOW_Msk = 0x1000000
	// Bit LPCLK_SEL_RTC_SLOW.
	SYSTEM_BT_LPCK_DIV_FRAC_LPCLK_SEL_RTC_SLOW = 0x1000000
	// Position of LPCLK_SEL_8M field.
	SYSTEM_BT_LPCK_DIV_FRAC_LPCLK_SEL_8M_Pos = 0x19
	// Bit mask of LPCLK_SEL_8M field.
	SYSTEM_BT_LPCK_DIV_FRAC_LPCLK_SEL_8M_Msk = 0x2000000
	// Bit LPCLK_SEL_8M.
	SYSTEM_BT_LPCK_DIV_FRAC_LPCLK_SEL_8M = 0x2000000
	// Position of LPCLK_SEL_XTAL field.
	SYSTEM_BT_LPCK_DIV_FRAC_LPCLK_SEL_XTAL_Pos = 0x1a
	// Bit mask of LPCLK_SEL_XTAL field.
	SYSTEM_BT_LPCK_DIV_FRAC_LPCLK_SEL_XTAL_Msk = 0x4000000
	// Bit LPCLK_SEL_XTAL.
	SYSTEM_BT_LPCK_DIV_FRAC_LPCLK_SEL_XTAL = 0x4000000
	// Position of LPCLK_SEL_XTAL32K field.
	SYSTEM_BT_LPCK_DIV_FRAC_LPCLK_SEL_XTAL32K_Pos = 0x1b
	// Bit mask of LPCLK_SEL_XTAL32K field.
	SYSTEM_BT_LPCK_DIV_FRAC_LPCLK_SEL_XTAL32K_Msk = 0x8000000
	// Bit LPCLK_SEL_XTAL32K.
	SYSTEM_BT_LPCK_DIV_FRAC_LPCLK_SEL_XTAL32K = 0x8000000
	// Position of LPCLK_RTC_EN field.
	SYSTEM_BT_LPCK_DIV_FRAC_LPCLK_RTC_EN_Pos = 0x1c
	// Bit mask of LPCLK_RTC_EN field.
	SYSTEM_BT_LPCK_DIV_FRAC_LPCLK_RTC_EN_Msk = 0x10000000
	// Bit LPCLK_RTC_EN.
	SYSTEM_BT_LPCK_DIV_FRAC_LPCLK_RTC_EN = 0x10000000

	// CPU_INTR_FROM_CPU_0: interrupt generate register
	// Position of CPU_INTR_FROM_CPU_0 field.
	SYSTEM_CPU_INTR_FROM_CPU_0_CPU_INTR_FROM_CPU_0_Pos = 0x0
	// Bit mask of CPU_INTR_FROM_CPU_0 field.
	SYSTEM_CPU_INTR_FROM_CPU_0_CPU_INTR_FROM_CPU_0_Msk = 0x1
	// Bit CPU_INTR_FROM_CPU_0.
	SYSTEM_CPU_INTR_FROM_CPU_0_CPU_INTR_FROM_CPU_0 = 0x1

	// CPU_INTR_FROM_CPU_1: interrupt generate register
	// Position of CPU_INTR_FROM_CPU_1 field.
	SYSTEM_CPU_INTR_FROM_CPU_1_CPU_INTR_FROM_CPU_1_Pos = 0x0
	// Bit mask of CPU_INTR_FROM_CPU_1 field.
	SYSTEM_CPU_INTR_FROM_CPU_1_CPU_INTR_FROM_CPU_1_Msk = 0x1
	// Bit CPU_INTR_FROM_CPU_1.
	SYSTEM_CPU_INTR_FROM_CPU_1_CPU_INTR_FROM_CPU_1 = 0x1

	// CPU_INTR_FROM_CPU_2: interrupt generate register
	// Position of CPU_INTR_FROM_CPU_2 field.
	SYSTEM_CPU_INTR_FROM_CPU_2_CPU_INTR_FROM_CPU_2_Pos = 0x0
	// Bit mask of CPU_INTR_FROM_CPU_2 field.
	SYSTEM_CPU_INTR_FROM_CPU_2_CPU_INTR_FROM_CPU_2_Msk = 0x1
	// Bit CPU_INTR_FROM_CPU_2.
	SYSTEM_CPU_INTR_FROM_CPU_2_CPU_INTR_FROM_CPU_2 = 0x1

	// CPU_INTR_FROM_CPU_3: interrupt generate register
	// Position of CPU_INTR_FROM_CPU_3 field.
	SYSTEM_CPU_INTR_FROM_CPU_3_CPU_INTR_FROM_CPU_3_Pos = 0x0
	// Bit mask of CPU_INTR_FROM_CPU_3 field.
	SYSTEM_CPU_INTR_FROM_CPU_3_CPU_INTR_FROM_CPU_3_Msk = 0x1
	// Bit CPU_INTR_FROM_CPU_3.
	SYSTEM_CPU_INTR_FROM_CPU_3_CPU_INTR_FROM_CPU_3 = 0x1

	// RSA_PD_CTRL: rsa memory power control register
	// Position of RSA_MEM_PD field.
	SYSTEM_RSA_PD_CTRL_RSA_MEM_PD_Pos = 0x0
	// Bit mask of RSA_MEM_PD field.
	SYSTEM_RSA_PD_CTRL_RSA_MEM_PD_Msk = 0x1
	// Bit RSA_MEM_PD.
	SYSTEM_RSA_PD_CTRL_RSA_MEM_PD = 0x1
	// Position of RSA_MEM_FORCE_PU field.
	SYSTEM_RSA_PD_CTRL_RSA_MEM_FORCE_PU_Pos = 0x1
	// Bit mask of RSA_MEM_FORCE_PU field.
	SYSTEM_RSA_PD_CTRL_RSA_MEM_FORCE_PU_Msk = 0x2
	// Bit RSA_MEM_FORCE_PU.
	SYSTEM_RSA_PD_CTRL_RSA_MEM_FORCE_PU = 0x2
	// Position of RSA_MEM_FORCE_PD field.
	SYSTEM_RSA_PD_CTRL_RSA_MEM_FORCE_PD_Pos = 0x2
	// Bit mask of RSA_MEM_FORCE_PD field.
	SYSTEM_RSA_PD_CTRL_RSA_MEM_FORCE_PD_Msk = 0x4
	// Bit RSA_MEM_FORCE_PD.
	SYSTEM_RSA_PD_CTRL_RSA_MEM_FORCE_PD = 0x4

	// EDMA_CTRL: edma clcok and reset register
	// Position of EDMA_CLK_ON field.
	SYSTEM_EDMA_CTRL_EDMA_CLK_ON_Pos = 0x0
	// Bit mask of EDMA_CLK_ON field.
	SYSTEM_EDMA_CTRL_EDMA_CLK_ON_Msk = 0x1
	// Bit EDMA_CLK_ON.
	SYSTEM_EDMA_CTRL_EDMA_CLK_ON = 0x1
	// Position of EDMA_RESET field.
	SYSTEM_EDMA_CTRL_EDMA_RESET_Pos = 0x1
	// Bit mask of EDMA_RESET field.
	SYSTEM_EDMA_CTRL_EDMA_RESET_Msk = 0x2
	// Bit EDMA_RESET.
	SYSTEM_EDMA_CTRL_EDMA_RESET = 0x2

	// CACHE_CONTROL: cache control register
	// Position of ICACHE_CLK_ON field.
	SYSTEM_CACHE_CONTROL_ICACHE_CLK_ON_Pos = 0x0
	// Bit mask of ICACHE_CLK_ON field.
	SYSTEM_CACHE_CONTROL_ICACHE_CLK_ON_Msk = 0x1
	// Bit ICACHE_CLK_ON.
	SYSTEM_CACHE_CONTROL_ICACHE_CLK_ON = 0x1
	// Position of ICACHE_RESET field.
	SYSTEM_CACHE_CONTROL_ICACHE_RESET_Pos = 0x1
	// Bit mask of ICACHE_RESET field.
	SYSTEM_CACHE_CONTROL_ICACHE_RESET_Msk = 0x2
	// Bit ICACHE_RESET.
	SYSTEM_CACHE_CONTROL_ICACHE_RESET = 0x2
	// Position of DCACHE_CLK_ON field.
	SYSTEM_CACHE_CONTROL_DCACHE_CLK_ON_Pos = 0x2
	// Bit mask of DCACHE_CLK_ON field.
	SYSTEM_CACHE_CONTROL_DCACHE_CLK_ON_Msk = 0x4
	// Bit DCACHE_CLK_ON.
	SYSTEM_CACHE_CONTROL_DCACHE_CLK_ON = 0x4
	// Position of DCACHE_RESET field.
	SYSTEM_CACHE_CONTROL_DCACHE_RESET_Pos = 0x3
	// Bit mask of DCACHE_RESET field.
	SYSTEM_CACHE_CONTROL_DCACHE_RESET_Msk = 0x8
	// Bit DCACHE_RESET.
	SYSTEM_CACHE_CONTROL_DCACHE_RESET = 0x8

	// EXTERNAL_DEVICE_ENCRYPT_DECRYPT_CONTROL: SYSTEM_EXTERNAL_DEVICE_ENCRYPT_DECRYPT_CONTROL_REG
	// Position of ENABLE_SPI_MANUAL_ENCRYPT field.
	SYSTEM_EXTERNAL_DEVICE_ENCRYPT_DECRYPT_CONTROL_ENABLE_SPI_MANUAL_ENCRYPT_Pos = 0x0
	// Bit mask of ENABLE_SPI_MANUAL_ENCRYPT field.
	SYSTEM_EXTERNAL_DEVICE_ENCRYPT_DECRYPT_CONTROL_ENABLE_SPI_MANUAL_ENCRYPT_Msk = 0x1
	// Bit ENABLE_SPI_MANUAL_ENCRYPT.
	SYSTEM_EXTERNAL_DEVICE_ENCRYPT_DECRYPT_CONTROL_ENABLE_SPI_MANUAL_ENCRYPT = 0x1
	// Position of ENABLE_DOWNLOAD_DB_ENCRYPT field.
	SYSTEM_EXTERNAL_DEVICE_ENCRYPT_DECRYPT_CONTROL_ENABLE_DOWNLOAD_DB_ENCRYPT_Pos = 0x1
	// Bit mask of ENABLE_DOWNLOAD_DB_ENCRYPT field.
	SYSTEM_EXTERNAL_DEVICE_ENCRYPT_DECRYPT_CONTROL_ENABLE_DOWNLOAD_DB_ENCRYPT_Msk = 0x2
	// Bit ENABLE_DOWNLOAD_DB_ENCRYPT.
	SYSTEM_EXTERNAL_DEVICE_ENCRYPT_DECRYPT_CONTROL_ENABLE_DOWNLOAD_DB_ENCRYPT = 0x2
	// Position of ENABLE_DOWNLOAD_G0CB_DECRYPT field.
	SYSTEM_EXTERNAL_DEVICE_ENCRYPT_DECRYPT_CONTROL_ENABLE_DOWNLOAD_G0CB_DECRYPT_Pos = 0x2
	// Bit mask of ENABLE_DOWNLOAD_G0CB_DECRYPT field.
	SYSTEM_EXTERNAL_DEVICE_ENCRYPT_DECRYPT_CONTROL_ENABLE_DOWNLOAD_G0CB_DECRYPT_Msk = 0x4
	// Bit ENABLE_DOWNLOAD_G0CB_DECRYPT.
	SYSTEM_EXTERNAL_DEVICE_ENCRYPT_DECRYPT_CONTROL_ENABLE_DOWNLOAD_G0CB_DECRYPT = 0x4
	// Position of ENABLE_DOWNLOAD_MANUAL_ENCRYPT field.
	SYSTEM_EXTERNAL_DEVICE_ENCRYPT_DECRYPT_CONTROL_ENABLE_DOWNLOAD_MANUAL_ENCRYPT_Pos = 0x3
	// Bit mask of ENABLE_DOWNLOAD_MANUAL_ENCRYPT field.
	SYSTEM_EXTERNAL_DEVICE_ENCRYPT_DECRYPT_CONTROL_ENABLE_DOWNLOAD_MANUAL_ENCRYPT_Msk = 0x8
	// Bit ENABLE_DOWNLOAD_MANUAL_ENCRYPT.
	SYSTEM_EXTERNAL_DEVICE_ENCRYPT_DECRYPT_CONTROL_ENABLE_DOWNLOAD_MANUAL_ENCRYPT = 0x8

	// RTC_FASTMEM_CONFIG: fast memory config register
	// Position of RTC_MEM_CRC_START field.
	SYSTEM_RTC_FASTMEM_CONFIG_RTC_MEM_CRC_START_Pos = 0x8
	// Bit mask of RTC_MEM_CRC_START field.
	SYSTEM_RTC_FASTMEM_CONFIG_RTC_MEM_CRC_START_Msk = 0x100
	// Bit RTC_MEM_CRC_START.
	SYSTEM_RTC_FASTMEM_CONFIG_RTC_MEM_CRC_START = 0x100
	// Position of RTC_MEM_CRC_ADDR field.
	SYSTEM_RTC_FASTMEM_CONFIG_RTC_MEM_CRC_ADDR_Pos = 0x9
	// Bit mask of RTC_MEM_CRC_ADDR field.
	SYSTEM_RTC_FASTMEM_CONFIG_RTC_MEM_CRC_ADDR_Msk = 0xffe00
	// Position of RTC_MEM_CRC_LEN field.
	SYSTEM_RTC_FASTMEM_CONFIG_RTC_MEM_CRC_LEN_Pos = 0x14
	// Bit mask of RTC_MEM_CRC_LEN field.
	SYSTEM_RTC_FASTMEM_CONFIG_RTC_MEM_CRC_LEN_Msk = 0x7ff00000
	// Position of RTC_MEM_CRC_FINISH field.
	SYSTEM_RTC_FASTMEM_CONFIG_RTC_MEM_CRC_FINISH_Pos = 0x1f
	// Bit mask of RTC_MEM_CRC_FINISH field.
	SYSTEM_RTC_FASTMEM_CONFIG_RTC_MEM_CRC_FINISH_Msk = 0x80000000
	// Bit RTC_MEM_CRC_FINISH.
	SYSTEM_RTC_FASTMEM_CONFIG_RTC_MEM_CRC_FINISH = 0x80000000

	// RTC_FASTMEM_CRC: reserved
	// Position of RTC_MEM_CRC_RES field.
	SYSTEM_RTC_FASTMEM_CRC_RTC_MEM_CRC_RES_Pos = 0x0
	// Bit mask of RTC_MEM_CRC_RES field.
	SYSTEM_RTC_FASTMEM_CRC_RTC_MEM_CRC_RES_Msk = 0xffffffff

	// REDUNDANT_ECO_CTRL: eco register
	// Position of REDUNDANT_ECO_DRIVE field.
	SYSTEM_REDUNDANT_ECO_CTRL_REDUNDANT_ECO_DRIVE_Pos = 0x0
	// Bit mask of REDUNDANT_ECO_DRIVE field.
	SYSTEM_REDUNDANT_ECO_CTRL_REDUNDANT_ECO_DRIVE_Msk = 0x1
	// Bit REDUNDANT_ECO_DRIVE.
	SYSTEM_REDUNDANT_ECO_CTRL_REDUNDANT_ECO_DRIVE = 0x1
	// Position of REDUNDANT_ECO_RESULT field.
	SYSTEM_REDUNDANT_ECO_CTRL_REDUNDANT_ECO_RESULT_Pos = 0x1
	// Bit mask of REDUNDANT_ECO_RESULT field.
	SYSTEM_REDUNDANT_ECO_CTRL_REDUNDANT_ECO_RESULT_Msk = 0x2
	// Bit REDUNDANT_ECO_RESULT.
	SYSTEM_REDUNDANT_ECO_CTRL_REDUNDANT_ECO_RESULT = 0x2

	// CLOCK_GATE: clock gating register
	// Position of CLK_EN field.
	SYSTEM_CLOCK_GATE_CLK_EN_Pos = 0x0
	// Bit mask of CLK_EN field.
	SYSTEM_CLOCK_GATE_CLK_EN_Msk = 0x1
	// Bit CLK_EN.
	SYSTEM_CLOCK_GATE_CLK_EN = 0x1

	// SYSCLK_CONF: system clock config register
	// Position of PRE_DIV_CNT field.
	SYSTEM_SYSCLK_CONF_PRE_DIV_CNT_Pos = 0x0
	// Bit mask of PRE_DIV_CNT field.
	SYSTEM_SYSCLK_CONF_PRE_DIV_CNT_Msk = 0x3ff
	// Position of SOC_CLK_SEL field.
	SYSTEM_SYSCLK_CONF_SOC_CLK_SEL_Pos = 0xa
	// Bit mask of SOC_CLK_SEL field.
	SYSTEM_SYSCLK_CONF_SOC_CLK_SEL_Msk = 0xc00
	// Position of CLK_XTAL_FREQ field.
	SYSTEM_SYSCLK_CONF_CLK_XTAL_FREQ_Pos = 0xc
	// Bit mask of CLK_XTAL_FREQ field.
	SYSTEM_SYSCLK_CONF_CLK_XTAL_FREQ_Msk = 0x7f000
	// Position of CLK_DIV_EN field.
	SYSTEM_SYSCLK_CONF_CLK_DIV_EN_Pos = 0x13
	// Bit mask of CLK_DIV_EN field.
	SYSTEM_SYSCLK_CONF_CLK_DIV_EN_Msk = 0x80000
	// Bit CLK_DIV_EN.
	SYSTEM_SYSCLK_CONF_CLK_DIV_EN = 0x80000

	// MEM_PVT: mem pvt register
	// Position of MEM_PATH_LEN field.
	SYSTEM_MEM_PVT_MEM_PATH_LEN_Pos = 0x0
	// Bit mask of MEM_PATH_LEN field.
	SYSTEM_MEM_PVT_MEM_PATH_LEN_Msk = 0xf
	// Position of MEM_ERR_CNT_CLR field.
	SYSTEM_MEM_PVT_MEM_ERR_CNT_CLR_Pos = 0x4
	// Bit mask of MEM_ERR_CNT_CLR field.
	SYSTEM_MEM_PVT_MEM_ERR_CNT_CLR_Msk = 0x10
	// Bit MEM_ERR_CNT_CLR.
	SYSTEM_MEM_PVT_MEM_ERR_CNT_CLR = 0x10
	// Position of MONITOR_EN field.
	SYSTEM_MEM_PVT_MONITOR_EN_Pos = 0x5
	// Bit mask of MONITOR_EN field.
	SYSTEM_MEM_PVT_MONITOR_EN_Msk = 0x20
	// Bit MONITOR_EN.
	SYSTEM_MEM_PVT_MONITOR_EN = 0x20
	// Position of MEM_TIMING_ERR_CNT field.
	SYSTEM_MEM_PVT_MEM_TIMING_ERR_CNT_Pos = 0x6
	// Bit mask of MEM_TIMING_ERR_CNT field.
	SYSTEM_MEM_PVT_MEM_TIMING_ERR_CNT_Msk = 0x3fffc0
	// Position of MEM_VT_SEL field.
	SYSTEM_MEM_PVT_MEM_VT_SEL_Pos = 0x16
	// Bit mask of MEM_VT_SEL field.
	SYSTEM_MEM_PVT_MEM_VT_SEL_Msk = 0xc00000

	// COMB_PVT_LVT_CONF: mem pvt register
	// Position of COMB_PATH_LEN_LVT field.
	SYSTEM_COMB_PVT_LVT_CONF_COMB_PATH_LEN_LVT_Pos = 0x0
	// Bit mask of COMB_PATH_LEN_LVT field.
	SYSTEM_COMB_PVT_LVT_CONF_COMB_PATH_LEN_LVT_Msk = 0x1f
	// Position of COMB_ERR_CNT_CLR_LVT field.
	SYSTEM_COMB_PVT_LVT_CONF_COMB_ERR_CNT_CLR_LVT_Pos = 0x5
	// Bit mask of COMB_ERR_CNT_CLR_LVT field.
	SYSTEM_COMB_PVT_LVT_CONF_COMB_ERR_CNT_CLR_LVT_Msk = 0x20
	// Bit COMB_ERR_CNT_CLR_LVT.
	SYSTEM_COMB_PVT_LVT_CONF_COMB_ERR_CNT_CLR_LVT = 0x20
	// Position of COMB_PVT_MONITOR_EN_LVT field.
	SYSTEM_COMB_PVT_LVT_CONF_COMB_PVT_MONITOR_EN_LVT_Pos = 0x6
	// Bit mask of COMB_PVT_MONITOR_EN_LVT field.
	SYSTEM_COMB_PVT_LVT_CONF_COMB_PVT_MONITOR_EN_LVT_Msk = 0x40
	// Bit COMB_PVT_MONITOR_EN_LVT.
	SYSTEM_COMB_PVT_LVT_CONF_COMB_PVT_MONITOR_EN_LVT = 0x40

	// COMB_PVT_NVT_CONF: mem pvt register
	// Position of COMB_PATH_LEN_NVT field.
	SYSTEM_COMB_PVT_NVT_CONF_COMB_PATH_LEN_NVT_Pos = 0x0
	// Bit mask of COMB_PATH_LEN_NVT field.
	SYSTEM_COMB_PVT_NVT_CONF_COMB_PATH_LEN_NVT_Msk = 0x1f
	// Position of COMB_ERR_CNT_CLR_NVT field.
	SYSTEM_COMB_PVT_NVT_CONF_COMB_ERR_CNT_CLR_NVT_Pos = 0x5
	// Bit mask of COMB_ERR_CNT_CLR_NVT field.
	SYSTEM_COMB_PVT_NVT_CONF_COMB_ERR_CNT_CLR_NVT_Msk = 0x20
	// Bit COMB_ERR_CNT_CLR_NVT.
	SYSTEM_COMB_PVT_NVT_CONF_COMB_ERR_CNT_CLR_NVT = 0x20
	// Position of COMB_PVT_MONITOR_EN_NVT field.
	SYSTEM_COMB_PVT_NVT_CONF_COMB_PVT_MONITOR_EN_NVT_Pos = 0x6
	// Bit mask of COMB_PVT_MONITOR_EN_NVT field.
	SYSTEM_COMB_PVT_NVT_CONF_COMB_PVT_MONITOR_EN_NVT_Msk = 0x40
	// Bit COMB_PVT_MONITOR_EN_NVT.
	SYSTEM_COMB_PVT_NVT_CONF_COMB_PVT_MONITOR_EN_NVT = 0x40

	// COMB_PVT_HVT_CONF: mem pvt register
	// Position of COMB_PATH_LEN_HVT field.
	SYSTEM_COMB_PVT_HVT_CONF_COMB_PATH_LEN_HVT_Pos = 0x0
	// Bit mask of COMB_PATH_LEN_HVT field.
	SYSTEM_COMB_PVT_HVT_CONF_COMB_PATH_LEN_HVT_Msk = 0x1f
	// Position of COMB_ERR_CNT_CLR_HVT field.
	SYSTEM_COMB_PVT_HVT_CONF_COMB_ERR_CNT_CLR_HVT_Pos = 0x5
	// Bit mask of COMB_ERR_CNT_CLR_HVT field.
	SYSTEM_COMB_PVT_HVT_CONF_COMB_ERR_CNT_CLR_HVT_Msk = 0x20
	// Bit COMB_ERR_CNT_CLR_HVT.
	SYSTEM_COMB_PVT_HVT_CONF_COMB_ERR_CNT_CLR_HVT = 0x20
	// Position of COMB_PVT_MONITOR_EN_HVT field.
	SYSTEM_COMB_PVT_HVT_CONF_COMB_PVT_MONITOR_EN_HVT_Pos = 0x6
	// Bit mask of COMB_PVT_MONITOR_EN_HVT field.
	SYSTEM_COMB_PVT_HVT_CONF_COMB_PVT_MONITOR_EN_HVT_Msk = 0x40
	// Bit COMB_PVT_MONITOR_EN_HVT.
	SYSTEM_COMB_PVT_HVT_CONF_COMB_PVT_MONITOR_EN_HVT = 0x40

	// COMB_PVT_ERR_LVT_SITE0: mem pvt register
	// Position of COMB_TIMING_ERR_CNT_LVT_SITE0 field.
	SYSTEM_COMB_PVT_ERR_LVT_SITE0_COMB_TIMING_ERR_CNT_LVT_SITE0_Pos = 0x0
	// Bit mask of COMB_TIMING_ERR_CNT_LVT_SITE0 field.
	SYSTEM_COMB_PVT_ERR_LVT_SITE0_COMB_TIMING_ERR_CNT_LVT_SITE0_Msk = 0xffff

	// COMB_PVT_ERR_NVT_SITE0: mem pvt register
	// Position of COMB_TIMING_ERR_CNT_NVT_SITE0 field.
	SYSTEM_COMB_PVT_ERR_NVT_SITE0_COMB_TIMING_ERR_CNT_NVT_SITE0_Pos = 0x0
	// Bit mask of COMB_TIMING_ERR_CNT_NVT_SITE0 field.
	SYSTEM_COMB_PVT_ERR_NVT_SITE0_COMB_TIMING_ERR_CNT_NVT_SITE0_Msk = 0xffff

	// COMB_PVT_ERR_HVT_SITE0: mem pvt register
	// Position of COMB_TIMING_ERR_CNT_HVT_SITE0 field.
	SYSTEM_COMB_PVT_ERR_HVT_SITE0_COMB_TIMING_ERR_CNT_HVT_SITE0_Pos = 0x0
	// Bit mask of COMB_TIMING_ERR_CNT_HVT_SITE0 field.
	SYSTEM_COMB_PVT_ERR_HVT_SITE0_COMB_TIMING_ERR_CNT_HVT_SITE0_Msk = 0xffff

	// COMB_PVT_ERR_LVT_SITE1: mem pvt register
	// Position of COMB_TIMING_ERR_CNT_LVT_SITE1 field.
	SYSTEM_COMB_PVT_ERR_LVT_SITE1_COMB_TIMING_ERR_CNT_LVT_SITE1_Pos = 0x0
	// Bit mask of COMB_TIMING_ERR_CNT_LVT_SITE1 field.
	SYSTEM_COMB_PVT_ERR_LVT_SITE1_COMB_TIMING_ERR_CNT_LVT_SITE1_Msk = 0xffff

	// COMB_PVT_ERR_NVT_SITE1: mem pvt register
	// Position of COMB_TIMING_ERR_CNT_NVT_SITE1 field.
	SYSTEM_COMB_PVT_ERR_NVT_SITE1_COMB_TIMING_ERR_CNT_NVT_SITE1_Pos = 0x0
	// Bit mask of COMB_TIMING_ERR_CNT_NVT_SITE1 field.
	SYSTEM_COMB_PVT_ERR_NVT_SITE1_COMB_TIMING_ERR_CNT_NVT_SITE1_Msk = 0xffff

	// COMB_PVT_ERR_HVT_SITE1: mem pvt register
	// Position of COMB_TIMING_ERR_CNT_HVT_SITE1 field.
	SYSTEM_COMB_PVT_ERR_HVT_SITE1_COMB_TIMING_ERR_CNT_HVT_SITE1_Pos = 0x0
	// Bit mask of COMB_TIMING_ERR_CNT_HVT_SITE1 field.
	SYSTEM_COMB_PVT_ERR_HVT_SITE1_COMB_TIMING_ERR_CNT_HVT_SITE1_Msk = 0xffff

	// COMB_PVT_ERR_LVT_SITE2: mem pvt register
	// Position of COMB_TIMING_ERR_CNT_LVT_SITE2 field.
	SYSTEM_COMB_PVT_ERR_LVT_SITE2_COMB_TIMING_ERR_CNT_LVT_SITE2_Pos = 0x0
	// Bit mask of COMB_TIMING_ERR_CNT_LVT_SITE2 field.
	SYSTEM_COMB_PVT_ERR_LVT_SITE2_COMB_TIMING_ERR_CNT_LVT_SITE2_Msk = 0xffff

	// COMB_PVT_ERR_NVT_SITE2: mem pvt register
	// Position of COMB_TIMING_ERR_CNT_NVT_SITE2 field.
	SYSTEM_COMB_PVT_ERR_NVT_SITE2_COMB_TIMING_ERR_CNT_NVT_SITE2_Pos = 0x0
	// Bit mask of COMB_TIMING_ERR_CNT_NVT_SITE2 field.
	SYSTEM_COMB_PVT_ERR_NVT_SITE2_COMB_TIMING_ERR_CNT_NVT_SITE2_Msk = 0xffff

	// COMB_PVT_ERR_HVT_SITE2: mem pvt register
	// Position of COMB_TIMING_ERR_CNT_HVT_SITE2 field.
	SYSTEM_COMB_PVT_ERR_HVT_SITE2_COMB_TIMING_ERR_CNT_HVT_SITE2_Pos = 0x0
	// Bit mask of COMB_TIMING_ERR_CNT_HVT_SITE2 field.
	SYSTEM_COMB_PVT_ERR_HVT_SITE2_COMB_TIMING_ERR_CNT_HVT_SITE2_Msk = 0xffff

	// COMB_PVT_ERR_LVT_SITE3: mem pvt register
	// Position of COMB_TIMING_ERR_CNT_LVT_SITE3 field.
	SYSTEM_COMB_PVT_ERR_LVT_SITE3_COMB_TIMING_ERR_CNT_LVT_SITE3_Pos = 0x0
	// Bit mask of COMB_TIMING_ERR_CNT_LVT_SITE3 field.
	SYSTEM_COMB_PVT_ERR_LVT_SITE3_COMB_TIMING_ERR_CNT_LVT_SITE3_Msk = 0xffff

	// COMB_PVT_ERR_NVT_SITE3: mem pvt register
	// Position of COMB_TIMING_ERR_CNT_NVT_SITE3 field.
	SYSTEM_COMB_PVT_ERR_NVT_SITE3_COMB_TIMING_ERR_CNT_NVT_SITE3_Pos = 0x0
	// Bit mask of COMB_TIMING_ERR_CNT_NVT_SITE3 field.
	SYSTEM_COMB_PVT_ERR_NVT_SITE3_COMB_TIMING_ERR_CNT_NVT_SITE3_Msk = 0xffff

	// COMB_PVT_ERR_HVT_SITE3: mem pvt register
	// Position of COMB_TIMING_ERR_CNT_HVT_SITE3 field.
	SYSTEM_COMB_PVT_ERR_HVT_SITE3_COMB_TIMING_ERR_CNT_HVT_SITE3_Pos = 0x0
	// Bit mask of COMB_TIMING_ERR_CNT_HVT_SITE3 field.
	SYSTEM_COMB_PVT_ERR_HVT_SITE3_COMB_TIMING_ERR_CNT_HVT_SITE3_Msk = 0xffff

	// SYSTEM_REG_DATE: Version register
	// Position of SYSTEM_REG_DATE field.
	SYSTEM_SYSTEM_REG_DATE_SYSTEM_REG_DATE_Pos = 0x0
	// Bit mask of SYSTEM_REG_DATE field.
	SYSTEM_SYSTEM_REG_DATE_SYSTEM_REG_DATE_Msk = 0xfffffff
)

// Constants for SYSTIMER: Peripheral SYSTIMER
const (
	// CONF: SYSTIMER_CONF.
	// Position of SYSTIMER_CLK_FO field.
	SYSTIMER_CONF_SYSTIMER_CLK_FO_Pos = 0x0
	// Bit mask of SYSTIMER_CLK_FO field.
	SYSTIMER_CONF_SYSTIMER_CLK_FO_Msk = 0x1
	// Bit SYSTIMER_CLK_FO.
	SYSTIMER_CONF_SYSTIMER_CLK_FO = 0x1
	// Position of TARGET2_WORK_EN field.
	SYSTIMER_CONF_TARGET2_WORK_EN_Pos = 0x16
	// Bit mask of TARGET2_WORK_EN field.
	SYSTIMER_CONF_TARGET2_WORK_EN_Msk = 0x400000
	// Bit TARGET2_WORK_EN.
	SYSTIMER_CONF_TARGET2_WORK_EN = 0x400000
	// Position of TARGET1_WORK_EN field.
	SYSTIMER_CONF_TARGET1_WORK_EN_Pos = 0x17
	// Bit mask of TARGET1_WORK_EN field.
	SYSTIMER_CONF_TARGET1_WORK_EN_Msk = 0x800000
	// Bit TARGET1_WORK_EN.
	SYSTIMER_CONF_TARGET1_WORK_EN = 0x800000
	// Position of TARGET0_WORK_EN field.
	SYSTIMER_CONF_TARGET0_WORK_EN_Pos = 0x18
	// Bit mask of TARGET0_WORK_EN field.
	SYSTIMER_CONF_TARGET0_WORK_EN_Msk = 0x1000000
	// Bit TARGET0_WORK_EN.
	SYSTIMER_CONF_TARGET0_WORK_EN = 0x1000000
	// Position of TIMER_UNIT1_CORE1_STALL_EN field.
	SYSTIMER_CONF_TIMER_UNIT1_CORE1_STALL_EN_Pos = 0x19
	// Bit mask of TIMER_UNIT1_CORE1_STALL_EN field.
	SYSTIMER_CONF_TIMER_UNIT1_CORE1_STALL_EN_Msk = 0x2000000
	// Bit TIMER_UNIT1_CORE1_STALL_EN.
	SYSTIMER_CONF_TIMER_UNIT1_CORE1_STALL_EN = 0x2000000
	// Position of TIMER_UNIT1_CORE0_STALL_EN field.
	SYSTIMER_CONF_TIMER_UNIT1_CORE0_STALL_EN_Pos = 0x1a
	// Bit mask of TIMER_UNIT1_CORE0_STALL_EN field.
	SYSTIMER_CONF_TIMER_UNIT1_CORE0_STALL_EN_Msk = 0x4000000
	// Bit TIMER_UNIT1_CORE0_STALL_EN.
	SYSTIMER_CONF_TIMER_UNIT1_CORE0_STALL_EN = 0x4000000
	// Position of TIMER_UNIT0_CORE1_STALL_EN field.
	SYSTIMER_CONF_TIMER_UNIT0_CORE1_STALL_EN_Pos = 0x1b
	// Bit mask of TIMER_UNIT0_CORE1_STALL_EN field.
	SYSTIMER_CONF_TIMER_UNIT0_CORE1_STALL_EN_Msk = 0x8000000
	// Bit TIMER_UNIT0_CORE1_STALL_EN.
	SYSTIMER_CONF_TIMER_UNIT0_CORE1_STALL_EN = 0x8000000
	// Position of TIMER_UNIT0_CORE0_STALL_EN field.
	SYSTIMER_CONF_TIMER_UNIT0_CORE0_STALL_EN_Pos = 0x1c
	// Bit mask of TIMER_UNIT0_CORE0_STALL_EN field.
	SYSTIMER_CONF_TIMER_UNIT0_CORE0_STALL_EN_Msk = 0x10000000
	// Bit TIMER_UNIT0_CORE0_STALL_EN.
	SYSTIMER_CONF_TIMER_UNIT0_CORE0_STALL_EN = 0x10000000
	// Position of TIMER_UNIT1_WORK_EN field.
	SYSTIMER_CONF_TIMER_UNIT1_WORK_EN_Pos = 0x1d
	// Bit mask of TIMER_UNIT1_WORK_EN field.
	SYSTIMER_CONF_TIMER_UNIT1_WORK_EN_Msk = 0x20000000
	// Bit TIMER_UNIT1_WORK_EN.
	SYSTIMER_CONF_TIMER_UNIT1_WORK_EN = 0x20000000
	// Position of TIMER_UNIT0_WORK_EN field.
	SYSTIMER_CONF_TIMER_UNIT0_WORK_EN_Pos = 0x1e
	// Bit mask of TIMER_UNIT0_WORK_EN field.
	SYSTIMER_CONF_TIMER_UNIT0_WORK_EN_Msk = 0x40000000
	// Bit TIMER_UNIT0_WORK_EN.
	SYSTIMER_CONF_TIMER_UNIT0_WORK_EN = 0x40000000
	// Position of CLK_EN field.
	SYSTIMER_CONF_CLK_EN_Pos = 0x1f
	// Bit mask of CLK_EN field.
	SYSTIMER_CONF_CLK_EN_Msk = 0x80000000
	// Bit CLK_EN.
	SYSTIMER_CONF_CLK_EN = 0x80000000

	// UNIT0_OP: SYSTIMER_UNIT0_OP.
	// Position of TIMER_UNIT0_VALUE_VALID field.
	SYSTIMER_UNIT0_OP_TIMER_UNIT0_VALUE_VALID_Pos = 0x1d
	// Bit mask of TIMER_UNIT0_VALUE_VALID field.
	SYSTIMER_UNIT0_OP_TIMER_UNIT0_VALUE_VALID_Msk = 0x20000000
	// Bit TIMER_UNIT0_VALUE_VALID.
	SYSTIMER_UNIT0_OP_TIMER_UNIT0_VALUE_VALID = 0x20000000
	// Position of TIMER_UNIT0_UPDATE field.
	SYSTIMER_UNIT0_OP_TIMER_UNIT0_UPDATE_Pos = 0x1e
	// Bit mask of TIMER_UNIT0_UPDATE field.
	SYSTIMER_UNIT0_OP_TIMER_UNIT0_UPDATE_Msk = 0x40000000
	// Bit TIMER_UNIT0_UPDATE.
	SYSTIMER_UNIT0_OP_TIMER_UNIT0_UPDATE = 0x40000000

	// UNIT1_OP: SYSTIMER_UNIT1_OP.
	// Position of TIMER_UNIT1_VALUE_VALID field.
	SYSTIMER_UNIT1_OP_TIMER_UNIT1_VALUE_VALID_Pos = 0x1d
	// Bit mask of TIMER_UNIT1_VALUE_VALID field.
	SYSTIMER_UNIT1_OP_TIMER_UNIT1_VALUE_VALID_Msk = 0x20000000
	// Bit TIMER_UNIT1_VALUE_VALID.
	SYSTIMER_UNIT1_OP_TIMER_UNIT1_VALUE_VALID = 0x20000000
	// Position of TIMER_UNIT1_UPDATE field.
	SYSTIMER_UNIT1_OP_TIMER_UNIT1_UPDATE_Pos = 0x1e
	// Bit mask of TIMER_UNIT1_UPDATE field.
	SYSTIMER_UNIT1_OP_TIMER_UNIT1_UPDATE_Msk = 0x40000000
	// Bit TIMER_UNIT1_UPDATE.
	SYSTIMER_UNIT1_OP_TIMER_UNIT1_UPDATE = 0x40000000

	// UNIT0_LOAD_HI: SYSTIMER_UNIT0_LOAD_HI.
	// Position of TIMER_UNIT0_LOAD_HI field.
	SYSTIMER_UNIT0_LOAD_HI_TIMER_UNIT0_LOAD_HI_Pos = 0x0
	// Bit mask of TIMER_UNIT0_LOAD_HI field.
	SYSTIMER_UNIT0_LOAD_HI_TIMER_UNIT0_LOAD_HI_Msk = 0xfffff

	// UNIT0_LOAD_LO: SYSTIMER_UNIT0_LOAD_LO.
	// Position of TIMER_UNIT0_LOAD_LO field.
	SYSTIMER_UNIT0_LOAD_LO_TIMER_UNIT0_LOAD_LO_Pos = 0x0
	// Bit mask of TIMER_UNIT0_LOAD_LO field.
	SYSTIMER_UNIT0_LOAD_LO_TIMER_UNIT0_LOAD_LO_Msk = 0xffffffff

	// UNIT1_LOAD_HI: SYSTIMER_UNIT1_LOAD_HI.
	// Position of TIMER_UNIT1_LOAD_HI field.
	SYSTIMER_UNIT1_LOAD_HI_TIMER_UNIT1_LOAD_HI_Pos = 0x0
	// Bit mask of TIMER_UNIT1_LOAD_HI field.
	SYSTIMER_UNIT1_LOAD_HI_TIMER_UNIT1_LOAD_HI_Msk = 0xfffff

	// UNIT1_LOAD_LO: SYSTIMER_UNIT1_LOAD_LO.
	// Position of TIMER_UNIT1_LOAD_LO field.
	SYSTIMER_UNIT1_LOAD_LO_TIMER_UNIT1_LOAD_LO_Pos = 0x0
	// Bit mask of TIMER_UNIT1_LOAD_LO field.
	SYSTIMER_UNIT1_LOAD_LO_TIMER_UNIT1_LOAD_LO_Msk = 0xffffffff

	// TARGET0_HI: SYSTIMER_TARGET0_HI.
	// Position of TIMER_TARGET0_HI field.
	SYSTIMER_TARGET0_HI_TIMER_TARGET0_HI_Pos = 0x0
	// Bit mask of TIMER_TARGET0_HI field.
	SYSTIMER_TARGET0_HI_TIMER_TARGET0_HI_Msk = 0xfffff

	// TARGET0_LO: SYSTIMER_TARGET0_LO.
	// Position of TIMER_TARGET0_LO field.
	SYSTIMER_TARGET0_LO_TIMER_TARGET0_LO_Pos = 0x0
	// Bit mask of TIMER_TARGET0_LO field.
	SYSTIMER_TARGET0_LO_TIMER_TARGET0_LO_Msk = 0xffffffff

	// TARGET1_HI: SYSTIMER_TARGET1_HI.
	// Position of TIMER_TARGET1_HI field.
	SYSTIMER_TARGET1_HI_TIMER_TARGET1_HI_Pos = 0x0
	// Bit mask of TIMER_TARGET1_HI field.
	SYSTIMER_TARGET1_HI_TIMER_TARGET1_HI_Msk = 0xfffff

	// TARGET1_LO: SYSTIMER_TARGET1_LO.
	// Position of TIMER_TARGET1_LO field.
	SYSTIMER_TARGET1_LO_TIMER_TARGET1_LO_Pos = 0x0
	// Bit mask of TIMER_TARGET1_LO field.
	SYSTIMER_TARGET1_LO_TIMER_TARGET1_LO_Msk = 0xffffffff

	// TARGET2_HI: SYSTIMER_TARGET2_HI.
	// Position of TIMER_TARGET2_HI field.
	SYSTIMER_TARGET2_HI_TIMER_TARGET2_HI_Pos = 0x0
	// Bit mask of TIMER_TARGET2_HI field.
	SYSTIMER_TARGET2_HI_TIMER_TARGET2_HI_Msk = 0xfffff

	// TARGET2_LO: SYSTIMER_TARGET2_LO.
	// Position of TIMER_TARGET2_LO field.
	SYSTIMER_TARGET2_LO_TIMER_TARGET2_LO_Pos = 0x0
	// Bit mask of TIMER_TARGET2_LO field.
	SYSTIMER_TARGET2_LO_TIMER_TARGET2_LO_Msk = 0xffffffff

	// TARGET0_CONF: SYSTIMER_TARGET0_CONF.
	// Position of TARGET0_PERIOD field.
	SYSTIMER_TARGET0_CONF_TARGET0_PERIOD_Pos = 0x0
	// Bit mask of TARGET0_PERIOD field.
	SYSTIMER_TARGET0_CONF_TARGET0_PERIOD_Msk = 0x3ffffff
	// Position of TARGET0_PERIOD_MODE field.
	SYSTIMER_TARGET0_CONF_TARGET0_PERIOD_MODE_Pos = 0x1e
	// Bit mask of TARGET0_PERIOD_MODE field.
	SYSTIMER_TARGET0_CONF_TARGET0_PERIOD_MODE_Msk = 0x40000000
	// Bit TARGET0_PERIOD_MODE.
	SYSTIMER_TARGET0_CONF_TARGET0_PERIOD_MODE = 0x40000000
	// Position of TARGET0_TIMER_UNIT_SEL field.
	SYSTIMER_TARGET0_CONF_TARGET0_TIMER_UNIT_SEL_Pos = 0x1f
	// Bit mask of TARGET0_TIMER_UNIT_SEL field.
	SYSTIMER_TARGET0_CONF_TARGET0_TIMER_UNIT_SEL_Msk = 0x80000000
	// Bit TARGET0_TIMER_UNIT_SEL.
	SYSTIMER_TARGET0_CONF_TARGET0_TIMER_UNIT_SEL = 0x80000000

	// TARGET1_CONF: SYSTIMER_TARGET1_CONF.
	// Position of TARGET1_PERIOD field.
	SYSTIMER_TARGET1_CONF_TARGET1_PERIOD_Pos = 0x0
	// Bit mask of TARGET1_PERIOD field.
	SYSTIMER_TARGET1_CONF_TARGET1_PERIOD_Msk = 0x3ffffff
	// Position of TARGET1_PERIOD_MODE field.
	SYSTIMER_TARGET1_CONF_TARGET1_PERIOD_MODE_Pos = 0x1e
	// Bit mask of TARGET1_PERIOD_MODE field.
	SYSTIMER_TARGET1_CONF_TARGET1_PERIOD_MODE_Msk = 0x40000000
	// Bit TARGET1_PERIOD_MODE.
	SYSTIMER_TARGET1_CONF_TARGET1_PERIOD_MODE = 0x40000000
	// Position of TARGET1_TIMER_UNIT_SEL field.
	SYSTIMER_TARGET1_CONF_TARGET1_TIMER_UNIT_SEL_Pos = 0x1f
	// Bit mask of TARGET1_TIMER_UNIT_SEL field.
	SYSTIMER_TARGET1_CONF_TARGET1_TIMER_UNIT_SEL_Msk = 0x80000000
	// Bit TARGET1_TIMER_UNIT_SEL.
	SYSTIMER_TARGET1_CONF_TARGET1_TIMER_UNIT_SEL = 0x80000000

	// TARGET2_CONF: SYSTIMER_TARGET2_CONF.
	// Position of TARGET2_PERIOD field.
	SYSTIMER_TARGET2_CONF_TARGET2_PERIOD_Pos = 0x0
	// Bit mask of TARGET2_PERIOD field.
	SYSTIMER_TARGET2_CONF_TARGET2_PERIOD_Msk = 0x3ffffff
	// Position of TARGET2_PERIOD_MODE field.
	SYSTIMER_TARGET2_CONF_TARGET2_PERIOD_MODE_Pos = 0x1e
	// Bit mask of TARGET2_PERIOD_MODE field.
	SYSTIMER_TARGET2_CONF_TARGET2_PERIOD_MODE_Msk = 0x40000000
	// Bit TARGET2_PERIOD_MODE.
	SYSTIMER_TARGET2_CONF_TARGET2_PERIOD_MODE = 0x40000000
	// Position of TARGET2_TIMER_UNIT_SEL field.
	SYSTIMER_TARGET2_CONF_TARGET2_TIMER_UNIT_SEL_Pos = 0x1f
	// Bit mask of TARGET2_TIMER_UNIT_SEL field.
	SYSTIMER_TARGET2_CONF_TARGET2_TIMER_UNIT_SEL_Msk = 0x80000000
	// Bit TARGET2_TIMER_UNIT_SEL.
	SYSTIMER_TARGET2_CONF_TARGET2_TIMER_UNIT_SEL = 0x80000000

	// UNIT0_VALUE_HI: SYSTIMER_UNIT0_VALUE_HI.
	// Position of TIMER_UNIT0_VALUE_HI field.
	SYSTIMER_UNIT0_VALUE_HI_TIMER_UNIT0_VALUE_HI_Pos = 0x0
	// Bit mask of TIMER_UNIT0_VALUE_HI field.
	SYSTIMER_UNIT0_VALUE_HI_TIMER_UNIT0_VALUE_HI_Msk = 0xfffff

	// UNIT0_VALUE_LO: SYSTIMER_UNIT0_VALUE_LO.
	// Position of TIMER_UNIT0_VALUE_LO field.
	SYSTIMER_UNIT0_VALUE_LO_TIMER_UNIT0_VALUE_LO_Pos = 0x0
	// Bit mask of TIMER_UNIT0_VALUE_LO field.
	SYSTIMER_UNIT0_VALUE_LO_TIMER_UNIT0_VALUE_LO_Msk = 0xffffffff

	// UNIT1_VALUE_HI: SYSTIMER_UNIT1_VALUE_HI.
	// Position of TIMER_UNIT1_VALUE_HI field.
	SYSTIMER_UNIT1_VALUE_HI_TIMER_UNIT1_VALUE_HI_Pos = 0x0
	// Bit mask of TIMER_UNIT1_VALUE_HI field.
	SYSTIMER_UNIT1_VALUE_HI_TIMER_UNIT1_VALUE_HI_Msk = 0xfffff

	// UNIT1_VALUE_LO: SYSTIMER_UNIT1_VALUE_LO.
	// Position of TIMER_UNIT1_VALUE_LO field.
	SYSTIMER_UNIT1_VALUE_LO_TIMER_UNIT1_VALUE_LO_Pos = 0x0
	// Bit mask of TIMER_UNIT1_VALUE_LO field.
	SYSTIMER_UNIT1_VALUE_LO_TIMER_UNIT1_VALUE_LO_Msk = 0xffffffff

	// COMP0_LOAD: SYSTIMER_COMP0_LOAD.
	// Position of TIMER_COMP0_LOAD field.
	SYSTIMER_COMP0_LOAD_TIMER_COMP0_LOAD_Pos = 0x0
	// Bit mask of TIMER_COMP0_LOAD field.
	SYSTIMER_COMP0_LOAD_TIMER_COMP0_LOAD_Msk = 0x1
	// Bit TIMER_COMP0_LOAD.
	SYSTIMER_COMP0_LOAD_TIMER_COMP0_LOAD = 0x1

	// COMP1_LOAD: SYSTIMER_COMP1_LOAD.
	// Position of TIMER_COMP1_LOAD field.
	SYSTIMER_COMP1_LOAD_TIMER_COMP1_LOAD_Pos = 0x0
	// Bit mask of TIMER_COMP1_LOAD field.
	SYSTIMER_COMP1_LOAD_TIMER_COMP1_LOAD_Msk = 0x1
	// Bit TIMER_COMP1_LOAD.
	SYSTIMER_COMP1_LOAD_TIMER_COMP1_LOAD = 0x1

	// COMP2_LOAD: SYSTIMER_COMP2_LOAD.
	// Position of TIMER_COMP2_LOAD field.
	SYSTIMER_COMP2_LOAD_TIMER_COMP2_LOAD_Pos = 0x0
	// Bit mask of TIMER_COMP2_LOAD field.
	SYSTIMER_COMP2_LOAD_TIMER_COMP2_LOAD_Msk = 0x1
	// Bit TIMER_COMP2_LOAD.
	SYSTIMER_COMP2_LOAD_TIMER_COMP2_LOAD = 0x1

	// UNIT0_LOAD: SYSTIMER_UNIT0_LOAD.
	// Position of TIMER_UNIT0_LOAD field.
	SYSTIMER_UNIT0_LOAD_TIMER_UNIT0_LOAD_Pos = 0x0
	// Bit mask of TIMER_UNIT0_LOAD field.
	SYSTIMER_UNIT0_LOAD_TIMER_UNIT0_LOAD_Msk = 0x1
	// Bit TIMER_UNIT0_LOAD.
	SYSTIMER_UNIT0_LOAD_TIMER_UNIT0_LOAD = 0x1

	// UNIT1_LOAD: SYSTIMER_UNIT1_LOAD.
	// Position of TIMER_UNIT1_LOAD field.
	SYSTIMER_UNIT1_LOAD_TIMER_UNIT1_LOAD_Pos = 0x0
	// Bit mask of TIMER_UNIT1_LOAD field.
	SYSTIMER_UNIT1_LOAD_TIMER_UNIT1_LOAD_Msk = 0x1
	// Bit TIMER_UNIT1_LOAD.
	SYSTIMER_UNIT1_LOAD_TIMER_UNIT1_LOAD = 0x1

	// INT_ENA: SYSTIMER_INT_ENA.
	// Position of TARGET0_INT_ENA field.
	SYSTIMER_INT_ENA_TARGET0_INT_ENA_Pos = 0x0
	// Bit mask of TARGET0_INT_ENA field.
	SYSTIMER_INT_ENA_TARGET0_INT_ENA_Msk = 0x1
	// Bit TARGET0_INT_ENA.
	SYSTIMER_INT_ENA_TARGET0_INT_ENA = 0x1
	// Position of TARGET1_INT_ENA field.
	SYSTIMER_INT_ENA_TARGET1_INT_ENA_Pos = 0x1
	// Bit mask of TARGET1_INT_ENA field.
	SYSTIMER_INT_ENA_TARGET1_INT_ENA_Msk = 0x2
	// Bit TARGET1_INT_ENA.
	SYSTIMER_INT_ENA_TARGET1_INT_ENA = 0x2
	// Position of TARGET2_INT_ENA field.
	SYSTIMER_INT_ENA_TARGET2_INT_ENA_Pos = 0x2
	// Bit mask of TARGET2_INT_ENA field.
	SYSTIMER_INT_ENA_TARGET2_INT_ENA_Msk = 0x4
	// Bit TARGET2_INT_ENA.
	SYSTIMER_INT_ENA_TARGET2_INT_ENA = 0x4

	// INT_RAW: SYSTIMER_INT_RAW.
	// Position of TARGET0_INT_RAW field.
	SYSTIMER_INT_RAW_TARGET0_INT_RAW_Pos = 0x0
	// Bit mask of TARGET0_INT_RAW field.
	SYSTIMER_INT_RAW_TARGET0_INT_RAW_Msk = 0x1
	// Bit TARGET0_INT_RAW.
	SYSTIMER_INT_RAW_TARGET0_INT_RAW = 0x1
	// Position of TARGET1_INT_RAW field.
	SYSTIMER_INT_RAW_TARGET1_INT_RAW_Pos = 0x1
	// Bit mask of TARGET1_INT_RAW field.
	SYSTIMER_INT_RAW_TARGET1_INT_RAW_Msk = 0x2
	// Bit TARGET1_INT_RAW.
	SYSTIMER_INT_RAW_TARGET1_INT_RAW = 0x2
	// Position of TARGET2_INT_RAW field.
	SYSTIMER_INT_RAW_TARGET2_INT_RAW_Pos = 0x2
	// Bit mask of TARGET2_INT_RAW field.
	SYSTIMER_INT_RAW_TARGET2_INT_RAW_Msk = 0x4
	// Bit TARGET2_INT_RAW.
	SYSTIMER_INT_RAW_TARGET2_INT_RAW = 0x4

	// INT_CLR: SYSTIMER_INT_CLR.
	// Position of TARGET0_INT_CLR field.
	SYSTIMER_INT_CLR_TARGET0_INT_CLR_Pos = 0x0
	// Bit mask of TARGET0_INT_CLR field.
	SYSTIMER_INT_CLR_TARGET0_INT_CLR_Msk = 0x1
	// Bit TARGET0_INT_CLR.
	SYSTIMER_INT_CLR_TARGET0_INT_CLR = 0x1
	// Position of TARGET1_INT_CLR field.
	SYSTIMER_INT_CLR_TARGET1_INT_CLR_Pos = 0x1
	// Bit mask of TARGET1_INT_CLR field.
	SYSTIMER_INT_CLR_TARGET1_INT_CLR_Msk = 0x2
	// Bit TARGET1_INT_CLR.
	SYSTIMER_INT_CLR_TARGET1_INT_CLR = 0x2
	// Position of TARGET2_INT_CLR field.
	SYSTIMER_INT_CLR_TARGET2_INT_CLR_Pos = 0x2
	// Bit mask of TARGET2_INT_CLR field.
	SYSTIMER_INT_CLR_TARGET2_INT_CLR_Msk = 0x4
	// Bit TARGET2_INT_CLR.
	SYSTIMER_INT_CLR_TARGET2_INT_CLR = 0x4

	// INT_ST: SYSTIMER_INT_ST.
	// Position of TARGET0_INT_ST field.
	SYSTIMER_INT_ST_TARGET0_INT_ST_Pos = 0x0
	// Bit mask of TARGET0_INT_ST field.
	SYSTIMER_INT_ST_TARGET0_INT_ST_Msk = 0x1
	// Bit TARGET0_INT_ST.
	SYSTIMER_INT_ST_TARGET0_INT_ST = 0x1
	// Position of TARGET1_INT_ST field.
	SYSTIMER_INT_ST_TARGET1_INT_ST_Pos = 0x1
	// Bit mask of TARGET1_INT_ST field.
	SYSTIMER_INT_ST_TARGET1_INT_ST_Msk = 0x2
	// Bit TARGET1_INT_ST.
	SYSTIMER_INT_ST_TARGET1_INT_ST = 0x2
	// Position of TARGET2_INT_ST field.
	SYSTIMER_INT_ST_TARGET2_INT_ST_Pos = 0x2
	// Bit mask of TARGET2_INT_ST field.
	SYSTIMER_INT_ST_TARGET2_INT_ST_Msk = 0x4
	// Bit TARGET2_INT_ST.
	SYSTIMER_INT_ST_TARGET2_INT_ST = 0x4

	// DATE: SYSTIMER_DATE.
	// Position of DATE field.
	SYSTIMER_DATE_DATE_Pos = 0x0
	// Bit mask of DATE field.
	SYSTIMER_DATE_DATE_Msk = 0xffffffff
)

// Constants for TIMG0: Peripheral TIMG
const (
	// T0CONFIG: TIMG_T0CONFIG_REG.
	// Position of T0_USE_XTAL field.
	TIMG_T0CONFIG_T0_USE_XTAL_Pos = 0x9
	// Bit mask of T0_USE_XTAL field.
	TIMG_T0CONFIG_T0_USE_XTAL_Msk = 0x200
	// Bit T0_USE_XTAL.
	TIMG_T0CONFIG_T0_USE_XTAL = 0x200
	// Position of T0_ALARM_EN field.
	TIMG_T0CONFIG_T0_ALARM_EN_Pos = 0xa
	// Bit mask of T0_ALARM_EN field.
	TIMG_T0CONFIG_T0_ALARM_EN_Msk = 0x400
	// Bit T0_ALARM_EN.
	TIMG_T0CONFIG_T0_ALARM_EN = 0x400
	// Position of T0_DIVCNT_RST field.
	TIMG_T0CONFIG_T0_DIVCNT_RST_Pos = 0xc
	// Bit mask of T0_DIVCNT_RST field.
	TIMG_T0CONFIG_T0_DIVCNT_RST_Msk = 0x1000
	// Bit T0_DIVCNT_RST.
	TIMG_T0CONFIG_T0_DIVCNT_RST = 0x1000
	// Position of T0_DIVIDER field.
	TIMG_T0CONFIG_T0_DIVIDER_Pos = 0xd
	// Bit mask of T0_DIVIDER field.
	TIMG_T0CONFIG_T0_DIVIDER_Msk = 0x1fffe000
	// Position of T0_AUTORELOAD field.
	TIMG_T0CONFIG_T0_AUTORELOAD_Pos = 0x1d
	// Bit mask of T0_AUTORELOAD field.
	TIMG_T0CONFIG_T0_AUTORELOAD_Msk = 0x20000000
	// Bit T0_AUTORELOAD.
	TIMG_T0CONFIG_T0_AUTORELOAD = 0x20000000
	// Position of T0_INCREASE field.
	TIMG_T0CONFIG_T0_INCREASE_Pos = 0x1e
	// Bit mask of T0_INCREASE field.
	TIMG_T0CONFIG_T0_INCREASE_Msk = 0x40000000
	// Bit T0_INCREASE.
	TIMG_T0CONFIG_T0_INCREASE = 0x40000000
	// Position of T0_EN field.
	TIMG_T0CONFIG_T0_EN_Pos = 0x1f
	// Bit mask of T0_EN field.
	TIMG_T0CONFIG_T0_EN_Msk = 0x80000000
	// Bit T0_EN.
	TIMG_T0CONFIG_T0_EN = 0x80000000

	// T0LO: TIMG_T0LO_REG.
	// Position of T0_LO field.
	TIMG_T0LO_T0_LO_Pos = 0x0
	// Bit mask of T0_LO field.
	TIMG_T0LO_T0_LO_Msk = 0xffffffff

	// T0HI: TIMG_T0HI_REG.
	// Position of T0_HI field.
	TIMG_T0HI_T0_HI_Pos = 0x0
	// Bit mask of T0_HI field.
	TIMG_T0HI_T0_HI_Msk = 0x3fffff

	// T0UPDATE: TIMG_T0UPDATE_REG.
	// Position of T0_UPDATE field.
	TIMG_T0UPDATE_T0_UPDATE_Pos = 0x1f
	// Bit mask of T0_UPDATE field.
	TIMG_T0UPDATE_T0_UPDATE_Msk = 0x80000000
	// Bit T0_UPDATE.
	TIMG_T0UPDATE_T0_UPDATE = 0x80000000

	// T0ALARMLO: TIMG_T0ALARMLO_REG.
	// Position of T0_ALARM_LO field.
	TIMG_T0ALARMLO_T0_ALARM_LO_Pos = 0x0
	// Bit mask of T0_ALARM_LO field.
	TIMG_T0ALARMLO_T0_ALARM_LO_Msk = 0xffffffff

	// T0ALARMHI: TIMG_T0ALARMHI_REG.
	// Position of T0_ALARM_HI field.
	TIMG_T0ALARMHI_T0_ALARM_HI_Pos = 0x0
	// Bit mask of T0_ALARM_HI field.
	TIMG_T0ALARMHI_T0_ALARM_HI_Msk = 0x3fffff

	// T0LOADLO: TIMG_T0LOADLO_REG.
	// Position of T0_LOAD_LO field.
	TIMG_T0LOADLO_T0_LOAD_LO_Pos = 0x0
	// Bit mask of T0_LOAD_LO field.
	TIMG_T0LOADLO_T0_LOAD_LO_Msk = 0xffffffff

	// T0LOADHI: TIMG_T0LOADHI_REG.
	// Position of T0_LOAD_HI field.
	TIMG_T0LOADHI_T0_LOAD_HI_Pos = 0x0
	// Bit mask of T0_LOAD_HI field.
	TIMG_T0LOADHI_T0_LOAD_HI_Msk = 0x3fffff

	// T0LOAD: TIMG_T0LOAD_REG.
	// Position of T0_LOAD field.
	TIMG_T0LOAD_T0_LOAD_Pos = 0x0
	// Bit mask of T0_LOAD field.
	TIMG_T0LOAD_T0_LOAD_Msk = 0xffffffff

	// WDTCONFIG0: TIMG_WDTCONFIG0_REG.
	// Position of WDT_APPCPU_RESET_EN field.
	TIMG_WDTCONFIG0_WDT_APPCPU_RESET_EN_Pos = 0xc
	// Bit mask of WDT_APPCPU_RESET_EN field.
	TIMG_WDTCONFIG0_WDT_APPCPU_RESET_EN_Msk = 0x1000
	// Bit WDT_APPCPU_RESET_EN.
	TIMG_WDTCONFIG0_WDT_APPCPU_RESET_EN = 0x1000
	// Position of WDT_PROCPU_RESET_EN field.
	TIMG_WDTCONFIG0_WDT_PROCPU_RESET_EN_Pos = 0xd
	// Bit mask of WDT_PROCPU_RESET_EN field.
	TIMG_WDTCONFIG0_WDT_PROCPU_RESET_EN_Msk = 0x2000
	// Bit WDT_PROCPU_RESET_EN.
	TIMG_WDTCONFIG0_WDT_PROCPU_RESET_EN = 0x2000
	// Position of WDT_FLASHBOOT_MOD_EN field.
	TIMG_WDTCONFIG0_WDT_FLASHBOOT_MOD_EN_Pos = 0xe
	// Bit mask of WDT_FLASHBOOT_MOD_EN field.
	TIMG_WDTCONFIG0_WDT_FLASHBOOT_MOD_EN_Msk = 0x4000
	// Bit WDT_FLASHBOOT_MOD_EN.
	TIMG_WDTCONFIG0_WDT_FLASHBOOT_MOD_EN = 0x4000
	// Position of WDT_SYS_RESET_LENGTH field.
	TIMG_WDTCONFIG0_WDT_SYS_RESET_LENGTH_Pos = 0xf
	// Bit mask of WDT_SYS_RESET_LENGTH field.
	TIMG_WDTCONFIG0_WDT_SYS_RESET_LENGTH_Msk = 0x38000
	// Position of WDT_CPU_RESET_LENGTH field.
	TIMG_WDTCONFIG0_WDT_CPU_RESET_LENGTH_Pos = 0x12
	// Bit mask of WDT_CPU_RESET_LENGTH field.
	TIMG_WDTCONFIG0_WDT_CPU_RESET_LENGTH_Msk = 0x1c0000
	// Position of WDT_USE_XTAL field.
	TIMG_WDTCONFIG0_WDT_USE_XTAL_Pos = 0x15
	// Bit mask of WDT_USE_XTAL field.
	TIMG_WDTCONFIG0_WDT_USE_XTAL_Msk = 0x200000
	// Bit WDT_USE_XTAL.
	TIMG_WDTCONFIG0_WDT_USE_XTAL = 0x200000
	// Position of WDT_CONF_UPDATE_EN field.
	TIMG_WDTCONFIG0_WDT_CONF_UPDATE_EN_Pos = 0x16
	// Bit mask of WDT_CONF_UPDATE_EN field.
	TIMG_WDTCONFIG0_WDT_CONF_UPDATE_EN_Msk = 0x400000
	// Bit WDT_CONF_UPDATE_EN.
	TIMG_WDTCONFIG0_WDT_CONF_UPDATE_EN = 0x400000
	// Position of WDT_STG3 field.
	TIMG_WDTCONFIG0_WDT_STG3_Pos = 0x17
	// Bit mask of WDT_STG3 field.
	TIMG_WDTCONFIG0_WDT_STG3_Msk = 0x1800000
	// Position of WDT_STG2 field.
	TIMG_WDTCONFIG0_WDT_STG2_Pos = 0x19
	// Bit mask of WDT_STG2 field.
	TIMG_WDTCONFIG0_WDT_STG2_Msk = 0x6000000
	// Position of WDT_STG1 field.
	TIMG_WDTCONFIG0_WDT_STG1_Pos = 0x1b
	// Bit mask of WDT_STG1 field.
	TIMG_WDTCONFIG0_WDT_STG1_Msk = 0x18000000
	// Position of WDT_STG0 field.
	TIMG_WDTCONFIG0_WDT_STG0_Pos = 0x1d
	// Bit mask of WDT_STG0 field.
	TIMG_WDTCONFIG0_WDT_STG0_Msk = 0x60000000
	// Position of WDT_EN field.
	TIMG_WDTCONFIG0_WDT_EN_Pos = 0x1f
	// Bit mask of WDT_EN field.
	TIMG_WDTCONFIG0_WDT_EN_Msk = 0x80000000
	// Bit WDT_EN.
	TIMG_WDTCONFIG0_WDT_EN = 0x80000000

	// WDTCONFIG1: TIMG_WDTCONFIG1_REG.
	// Position of WDT_DIVCNT_RST field.
	TIMG_WDTCONFIG1_WDT_DIVCNT_RST_Pos = 0x0
	// Bit mask of WDT_DIVCNT_RST field.
	TIMG_WDTCONFIG1_WDT_DIVCNT_RST_Msk = 0x1
	// Bit WDT_DIVCNT_RST.
	TIMG_WDTCONFIG1_WDT_DIVCNT_RST = 0x1
	// Position of WDT_CLK_PRESCALE field.
	TIMG_WDTCONFIG1_WDT_CLK_PRESCALE_Pos = 0x10
	// Bit mask of WDT_CLK_PRESCALE field.
	TIMG_WDTCONFIG1_WDT_CLK_PRESCALE_Msk = 0xffff0000

	// WDTCONFIG2: TIMG_WDTCONFIG2_REG.
	// Position of WDT_STG0_HOLD field.
	TIMG_WDTCONFIG2_WDT_STG0_HOLD_Pos = 0x0
	// Bit mask of WDT_STG0_HOLD field.
	TIMG_WDTCONFIG2_WDT_STG0_HOLD_Msk = 0xffffffff

	// WDTCONFIG3: TIMG_WDTCONFIG3_REG.
	// Position of WDT_STG1_HOLD field.
	TIMG_WDTCONFIG3_WDT_STG1_HOLD_Pos = 0x0
	// Bit mask of WDT_STG1_HOLD field.
	TIMG_WDTCONFIG3_WDT_STG1_HOLD_Msk = 0xffffffff

	// WDTCONFIG4: TIMG_WDTCONFIG4_REG.
	// Position of WDT_STG2_HOLD field.
	TIMG_WDTCONFIG4_WDT_STG2_HOLD_Pos = 0x0
	// Bit mask of WDT_STG2_HOLD field.
	TIMG_WDTCONFIG4_WDT_STG2_HOLD_Msk = 0xffffffff

	// WDTCONFIG5: TIMG_WDTCONFIG5_REG.
	// Position of WDT_STG3_HOLD field.
	TIMG_WDTCONFIG5_WDT_STG3_HOLD_Pos = 0x0
	// Bit mask of WDT_STG3_HOLD field.
	TIMG_WDTCONFIG5_WDT_STG3_HOLD_Msk = 0xffffffff

	// WDTFEED: TIMG_WDTFEED_REG.
	// Position of WDT_FEED field.
	TIMG_WDTFEED_WDT_FEED_Pos = 0x0
	// Bit mask of WDT_FEED field.
	TIMG_WDTFEED_WDT_FEED_Msk = 0xffffffff

	// WDTWPROTECT: TIMG_WDTWPROTECT_REG.
	// Position of WDT_WKEY field.
	TIMG_WDTWPROTECT_WDT_WKEY_Pos = 0x0
	// Bit mask of WDT_WKEY field.
	TIMG_WDTWPROTECT_WDT_WKEY_Msk = 0xffffffff

	// RTCCALICFG: TIMG_RTCCALICFG_REG.
	// Position of RTC_CALI_START_CYCLING field.
	TIMG_RTCCALICFG_RTC_CALI_START_CYCLING_Pos = 0xc
	// Bit mask of RTC_CALI_START_CYCLING field.
	TIMG_RTCCALICFG_RTC_CALI_START_CYCLING_Msk = 0x1000
	// Bit RTC_CALI_START_CYCLING.
	TIMG_RTCCALICFG_RTC_CALI_START_CYCLING = 0x1000
	// Position of RTC_CALI_CLK_SEL field.
	TIMG_RTCCALICFG_RTC_CALI_CLK_SEL_Pos = 0xd
	// Bit mask of RTC_CALI_CLK_SEL field.
	TIMG_RTCCALICFG_RTC_CALI_CLK_SEL_Msk = 0x6000
	// Position of RTC_CALI_RDY field.
	TIMG_RTCCALICFG_RTC_CALI_RDY_Pos = 0xf
	// Bit mask of RTC_CALI_RDY field.
	TIMG_RTCCALICFG_RTC_CALI_RDY_Msk = 0x8000
	// Bit RTC_CALI_RDY.
	TIMG_RTCCALICFG_RTC_CALI_RDY = 0x8000
	// Position of RTC_CALI_MAX field.
	TIMG_RTCCALICFG_RTC_CALI_MAX_Pos = 0x10
	// Bit mask of RTC_CALI_MAX field.
	TIMG_RTCCALICFG_RTC_CALI_MAX_Msk = 0x7fff0000
	// Position of RTC_CALI_START field.
	TIMG_RTCCALICFG_RTC_CALI_START_Pos = 0x1f
	// Bit mask of RTC_CALI_START field.
	TIMG_RTCCALICFG_RTC_CALI_START_Msk = 0x80000000
	// Bit RTC_CALI_START.
	TIMG_RTCCALICFG_RTC_CALI_START = 0x80000000

	// RTCCALICFG1: TIMG_RTCCALICFG1_REG.
	// Position of RTC_CALI_CYCLING_DATA_VLD field.
	TIMG_RTCCALICFG1_RTC_CALI_CYCLING_DATA_VLD_Pos = 0x0
	// Bit mask of RTC_CALI_CYCLING_DATA_VLD field.
	TIMG_RTCCALICFG1_RTC_CALI_CYCLING_DATA_VLD_Msk = 0x1
	// Bit RTC_CALI_CYCLING_DATA_VLD.
	TIMG_RTCCALICFG1_RTC_CALI_CYCLING_DATA_VLD = 0x1
	// Position of RTC_CALI_VALUE field.
	TIMG_RTCCALICFG1_RTC_CALI_VALUE_Pos = 0x7
	// Bit mask of RTC_CALI_VALUE field.
	TIMG_RTCCALICFG1_RTC_CALI_VALUE_Msk = 0xffffff80

	// INT_ENA_TIMG: INT_ENA_TIMG_REG
	// Position of T0_INT_ENA field.
	TIMG_INT_ENA_TIMG_T0_INT_ENA_Pos = 0x0
	// Bit mask of T0_INT_ENA field.
	TIMG_INT_ENA_TIMG_T0_INT_ENA_Msk = 0x1
	// Bit T0_INT_ENA.
	TIMG_INT_ENA_TIMG_T0_INT_ENA = 0x1
	// Position of WDT_INT_ENA field.
	TIMG_INT_ENA_TIMG_WDT_INT_ENA_Pos = 0x1
	// Bit mask of WDT_INT_ENA field.
	TIMG_INT_ENA_TIMG_WDT_INT_ENA_Msk = 0x2
	// Bit WDT_INT_ENA.
	TIMG_INT_ENA_TIMG_WDT_INT_ENA = 0x2

	// INT_RAW_TIMG: INT_RAW_TIMG_REG
	// Position of T0_INT_RAW field.
	TIMG_INT_RAW_TIMG_T0_INT_RAW_Pos = 0x0
	// Bit mask of T0_INT_RAW field.
	TIMG_INT_RAW_TIMG_T0_INT_RAW_Msk = 0x1
	// Bit T0_INT_RAW.
	TIMG_INT_RAW_TIMG_T0_INT_RAW = 0x1
	// Position of WDT_INT_RAW field.
	TIMG_INT_RAW_TIMG_WDT_INT_RAW_Pos = 0x1
	// Bit mask of WDT_INT_RAW field.
	TIMG_INT_RAW_TIMG_WDT_INT_RAW_Msk = 0x2
	// Bit WDT_INT_RAW.
	TIMG_INT_RAW_TIMG_WDT_INT_RAW = 0x2

	// INT_ST_TIMG: INT_ST_TIMG_REG
	// Position of T0_INT_ST field.
	TIMG_INT_ST_TIMG_T0_INT_ST_Pos = 0x0
	// Bit mask of T0_INT_ST field.
	TIMG_INT_ST_TIMG_T0_INT_ST_Msk = 0x1
	// Bit T0_INT_ST.
	TIMG_INT_ST_TIMG_T0_INT_ST = 0x1
	// Position of WDT_INT_ST field.
	TIMG_INT_ST_TIMG_WDT_INT_ST_Pos = 0x1
	// Bit mask of WDT_INT_ST field.
	TIMG_INT_ST_TIMG_WDT_INT_ST_Msk = 0x2
	// Bit WDT_INT_ST.
	TIMG_INT_ST_TIMG_WDT_INT_ST = 0x2

	// INT_CLR_TIMG: INT_CLR_TIMG_REG
	// Position of T0_INT_CLR field.
	TIMG_INT_CLR_TIMG_T0_INT_CLR_Pos = 0x0
	// Bit mask of T0_INT_CLR field.
	TIMG_INT_CLR_TIMG_T0_INT_CLR_Msk = 0x1
	// Bit T0_INT_CLR.
	TIMG_INT_CLR_TIMG_T0_INT_CLR = 0x1
	// Position of WDT_INT_CLR field.
	TIMG_INT_CLR_TIMG_WDT_INT_CLR_Pos = 0x1
	// Bit mask of WDT_INT_CLR field.
	TIMG_INT_CLR_TIMG_WDT_INT_CLR_Msk = 0x2
	// Bit WDT_INT_CLR.
	TIMG_INT_CLR_TIMG_WDT_INT_CLR = 0x2

	// RTCCALICFG2: TIMG_RTCCALICFG2_REG.
	// Position of RTC_CALI_TIMEOUT field.
	TIMG_RTCCALICFG2_RTC_CALI_TIMEOUT_Pos = 0x0
	// Bit mask of RTC_CALI_TIMEOUT field.
	TIMG_RTCCALICFG2_RTC_CALI_TIMEOUT_Msk = 0x1
	// Bit RTC_CALI_TIMEOUT.
	TIMG_RTCCALICFG2_RTC_CALI_TIMEOUT = 0x1
	// Position of RTC_CALI_TIMEOUT_RST_CNT field.
	TIMG_RTCCALICFG2_RTC_CALI_TIMEOUT_RST_CNT_Pos = 0x3
	// Bit mask of RTC_CALI_TIMEOUT_RST_CNT field.
	TIMG_RTCCALICFG2_RTC_CALI_TIMEOUT_RST_CNT_Msk = 0x78
	// Position of RTC_CALI_TIMEOUT_THRES field.
	TIMG_RTCCALICFG2_RTC_CALI_TIMEOUT_THRES_Pos = 0x7
	// Bit mask of RTC_CALI_TIMEOUT_THRES field.
	TIMG_RTCCALICFG2_RTC_CALI_TIMEOUT_THRES_Msk = 0xffffff80

	// NTIMG_DATE: TIMG_NTIMG_DATE_REG.
	// Position of NTIMGS_DATE field.
	TIMG_NTIMG_DATE_NTIMGS_DATE_Pos = 0x0
	// Bit mask of NTIMGS_DATE field.
	TIMG_NTIMG_DATE_NTIMGS_DATE_Msk = 0xfffffff

	// REGCLK: TIMG_REGCLK_REG.
	// Position of WDT_CLK_IS_ACTIVE field.
	TIMG_REGCLK_WDT_CLK_IS_ACTIVE_Pos = 0x1d
	// Bit mask of WDT_CLK_IS_ACTIVE field.
	TIMG_REGCLK_WDT_CLK_IS_ACTIVE_Msk = 0x20000000
	// Bit WDT_CLK_IS_ACTIVE.
	TIMG_REGCLK_WDT_CLK_IS_ACTIVE = 0x20000000
	// Position of TIMER_CLK_IS_ACTIVE field.
	TIMG_REGCLK_TIMER_CLK_IS_ACTIVE_Pos = 0x1e
	// Bit mask of TIMER_CLK_IS_ACTIVE field.
	TIMG_REGCLK_TIMER_CLK_IS_ACTIVE_Msk = 0x40000000
	// Bit TIMER_CLK_IS_ACTIVE.
	TIMG_REGCLK_TIMER_CLK_IS_ACTIVE = 0x40000000
	// Position of CLK_EN field.
	TIMG_REGCLK_CLK_EN_Pos = 0x1f
	// Bit mask of CLK_EN field.
	TIMG_REGCLK_CLK_EN_Msk = 0x80000000
	// Bit CLK_EN.
	TIMG_REGCLK_CLK_EN = 0x80000000
)

// Constants for UART0: Peripheral UART
const (
	// FIFO: FIFO data register
	// Position of RXFIFO_RD_BYTE field.
	UART_FIFO_RXFIFO_RD_BYTE_Pos = 0x0
	// Bit mask of RXFIFO_RD_BYTE field.
	UART_FIFO_RXFIFO_RD_BYTE_Msk = 0xff

	// INT_RAW: Raw interrupt status
	// Position of RXFIFO_FULL_INT_RAW field.
	UART_INT_RAW_RXFIFO_FULL_INT_RAW_Pos = 0x0
	// Bit mask of RXFIFO_FULL_INT_RAW field.
	UART_INT_RAW_RXFIFO_FULL_INT_RAW_Msk = 0x1
	// Bit RXFIFO_FULL_INT_RAW.
	UART_INT_RAW_RXFIFO_FULL_INT_RAW = 0x1
	// Position of TXFIFO_EMPTY_INT_RAW field.
	UART_INT_RAW_TXFIFO_EMPTY_INT_RAW_Pos = 0x1
	// Bit mask of TXFIFO_EMPTY_INT_RAW field.
	UART_INT_RAW_TXFIFO_EMPTY_INT_RAW_Msk = 0x2
	// Bit TXFIFO_EMPTY_INT_RAW.
	UART_INT_RAW_TXFIFO_EMPTY_INT_RAW = 0x2
	// Position of PARITY_ERR_INT_RAW field.
	UART_INT_RAW_PARITY_ERR_INT_RAW_Pos = 0x2
	// Bit mask of PARITY_ERR_INT_RAW field.
	UART_INT_RAW_PARITY_ERR_INT_RAW_Msk = 0x4
	// Bit PARITY_ERR_INT_RAW.
	UART_INT_RAW_PARITY_ERR_INT_RAW = 0x4
	// Position of FRM_ERR_INT_RAW field.
	UART_INT_RAW_FRM_ERR_INT_RAW_Pos = 0x3
	// Bit mask of FRM_ERR_INT_RAW field.
	UART_INT_RAW_FRM_ERR_INT_RAW_Msk = 0x8
	// Bit FRM_ERR_INT_RAW.
	UART_INT_RAW_FRM_ERR_INT_RAW = 0x8
	// Position of RXFIFO_OVF_INT_RAW field.
	UART_INT_RAW_RXFIFO_OVF_INT_RAW_Pos = 0x4
	// Bit mask of RXFIFO_OVF_INT_RAW field.
	UART_INT_RAW_RXFIFO_OVF_INT_RAW_Msk = 0x10
	// Bit RXFIFO_OVF_INT_RAW.
	UART_INT_RAW_RXFIFO_OVF_INT_RAW = 0x10
	// Position of DSR_CHG_INT_RAW field.
	UART_INT_RAW_DSR_CHG_INT_RAW_Pos = 0x5
	// Bit mask of DSR_CHG_INT_RAW field.
	UART_INT_RAW_DSR_CHG_INT_RAW_Msk = 0x20
	// Bit DSR_CHG_INT_RAW.
	UART_INT_RAW_DSR_CHG_INT_RAW = 0x20
	// Position of CTS_CHG_INT_RAW field.
	UART_INT_RAW_CTS_CHG_INT_RAW_Pos = 0x6
	// Bit mask of CTS_CHG_INT_RAW field.
	UART_INT_RAW_CTS_CHG_INT_RAW_Msk = 0x40
	// Bit CTS_CHG_INT_RAW.
	UART_INT_RAW_CTS_CHG_INT_RAW = 0x40
	// Position of BRK_DET_INT_RAW field.
	UART_INT_RAW_BRK_DET_INT_RAW_Pos = 0x7
	// Bit mask of BRK_DET_INT_RAW field.
	UART_INT_RAW_BRK_DET_INT_RAW_Msk = 0x80
	// Bit BRK_DET_INT_RAW.
	UART_INT_RAW_BRK_DET_INT_RAW = 0x80
	// Position of RXFIFO_TOUT_INT_RAW field.
	UART_INT_RAW_RXFIFO_TOUT_INT_RAW_Pos = 0x8
	// Bit mask of RXFIFO_TOUT_INT_RAW field.
	UART_INT_RAW_RXFIFO_TOUT_INT_RAW_Msk = 0x100
	// Bit RXFIFO_TOUT_INT_RAW.
	UART_INT_RAW_RXFIFO_TOUT_INT_RAW = 0x100
	// Position of SW_XON_INT_RAW field.
	UART_INT_RAW_SW_XON_INT_RAW_Pos = 0x9
	// Bit mask of SW_XON_INT_RAW field.
	UART_INT_RAW_SW_XON_INT_RAW_Msk = 0x200
	// Bit SW_XON_INT_RAW.
	UART_INT_RAW_SW_XON_INT_RAW = 0x200
	// Position of SW_XOFF_INT_RAW field.
	UART_INT_RAW_SW_XOFF_INT_RAW_Pos = 0xa
	// Bit mask of SW_XOFF_INT_RAW field.
	UART_INT_RAW_SW_XOFF_INT_RAW_Msk = 0x400
	// Bit SW_XOFF_INT_RAW.
	UART_INT_RAW_SW_XOFF_INT_RAW = 0x400
	// Position of GLITCH_DET_INT_RAW field.
	UART_INT_RAW_GLITCH_DET_INT_RAW_Pos = 0xb
	// Bit mask of GLITCH_DET_INT_RAW field.
	UART_INT_RAW_GLITCH_DET_INT_RAW_Msk = 0x800
	// Bit GLITCH_DET_INT_RAW.
	UART_INT_RAW_GLITCH_DET_INT_RAW = 0x800
	// Position of TX_BRK_DONE_INT_RAW field.
	UART_INT_RAW_TX_BRK_DONE_INT_RAW_Pos = 0xc
	// Bit mask of TX_BRK_DONE_INT_RAW field.
	UART_INT_RAW_TX_BRK_DONE_INT_RAW_Msk = 0x1000
	// Bit TX_BRK_DONE_INT_RAW.
	UART_INT_RAW_TX_BRK_DONE_INT_RAW = 0x1000
	// Position of TX_BRK_IDLE_DONE_INT_RAW field.
	UART_INT_RAW_TX_BRK_IDLE_DONE_INT_RAW_Pos = 0xd
	// Bit mask of TX_BRK_IDLE_DONE_INT_RAW field.
	UART_INT_RAW_TX_BRK_IDLE_DONE_INT_RAW_Msk = 0x2000
	// Bit TX_BRK_IDLE_DONE_INT_RAW.
	UART_INT_RAW_TX_BRK_IDLE_DONE_INT_RAW = 0x2000
	// Position of TX_DONE_INT_RAW field.
	UART_INT_RAW_TX_DONE_INT_RAW_Pos = 0xe
	// Bit mask of TX_DONE_INT_RAW field.
	UART_INT_RAW_TX_DONE_INT_RAW_Msk = 0x4000
	// Bit TX_DONE_INT_RAW.
	UART_INT_RAW_TX_DONE_INT_RAW = 0x4000
	// Position of RS485_PARITY_ERR_INT_RAW field.
	UART_INT_RAW_RS485_PARITY_ERR_INT_RAW_Pos = 0xf
	// Bit mask of RS485_PARITY_ERR_INT_RAW field.
	UART_INT_RAW_RS485_PARITY_ERR_INT_RAW_Msk = 0x8000
	// Bit RS485_PARITY_ERR_INT_RAW.
	UART_INT_RAW_RS485_PARITY_ERR_INT_RAW = 0x8000
	// Position of RS485_FRM_ERR_INT_RAW field.
	UART_INT_RAW_RS485_FRM_ERR_INT_RAW_Pos = 0x10
	// Bit mask of RS485_FRM_ERR_INT_RAW field.
	UART_INT_RAW_RS485_FRM_ERR_INT_RAW_Msk = 0x10000
	// Bit RS485_FRM_ERR_INT_RAW.
	UART_INT_RAW_RS485_FRM_ERR_INT_RAW = 0x10000
	// Position of RS485_CLASH_INT_RAW field.
	UART_INT_RAW_RS485_CLASH_INT_RAW_Pos = 0x11
	// Bit mask of RS485_CLASH_INT_RAW field.
	UART_INT_RAW_RS485_CLASH_INT_RAW_Msk = 0x20000
	// Bit RS485_CLASH_INT_RAW.
	UART_INT_RAW_RS485_CLASH_INT_RAW = 0x20000
	// Position of AT_CMD_CHAR_DET_INT_RAW field.
	UART_INT_RAW_AT_CMD_CHAR_DET_INT_RAW_Pos = 0x12
	// Bit mask of AT_CMD_CHAR_DET_INT_RAW field.
	UART_INT_RAW_AT_CMD_CHAR_DET_INT_RAW_Msk = 0x40000
	// Bit AT_CMD_CHAR_DET_INT_RAW.
	UART_INT_RAW_AT_CMD_CHAR_DET_INT_RAW = 0x40000
	// Position of WAKEUP_INT_RAW field.
	UART_INT_RAW_WAKEUP_INT_RAW_Pos = 0x13
	// Bit mask of WAKEUP_INT_RAW field.
	UART_INT_RAW_WAKEUP_INT_RAW_Msk = 0x80000
	// Bit WAKEUP_INT_RAW.
	UART_INT_RAW_WAKEUP_INT_RAW = 0x80000

	// INT_ST: Masked interrupt status
	// Position of RXFIFO_FULL_INT_ST field.
	UART_INT_ST_RXFIFO_FULL_INT_ST_Pos = 0x0
	// Bit mask of RXFIFO_FULL_INT_ST field.
	UART_INT_ST_RXFIFO_FULL_INT_ST_Msk = 0x1
	// Bit RXFIFO_FULL_INT_ST.
	UART_INT_ST_RXFIFO_FULL_INT_ST = 0x1
	// Position of TXFIFO_EMPTY_INT_ST field.
	UART_INT_ST_TXFIFO_EMPTY_INT_ST_Pos = 0x1
	// Bit mask of TXFIFO_EMPTY_INT_ST field.
	UART_INT_ST_TXFIFO_EMPTY_INT_ST_Msk = 0x2
	// Bit TXFIFO_EMPTY_INT_ST.
	UART_INT_ST_TXFIFO_EMPTY_INT_ST = 0x2
	// Position of PARITY_ERR_INT_ST field.
	UART_INT_ST_PARITY_ERR_INT_ST_Pos = 0x2
	// Bit mask of PARITY_ERR_INT_ST field.
	UART_INT_ST_PARITY_ERR_INT_ST_Msk = 0x4
	// Bit PARITY_ERR_INT_ST.
	UART_INT_ST_PARITY_ERR_INT_ST = 0x4
	// Position of FRM_ERR_INT_ST field.
	UART_INT_ST_FRM_ERR_INT_ST_Pos = 0x3
	// Bit mask of FRM_ERR_INT_ST field.
	UART_INT_ST_FRM_ERR_INT_ST_Msk = 0x8
	// Bit FRM_ERR_INT_ST.
	UART_INT_ST_FRM_ERR_INT_ST = 0x8
	// Position of RXFIFO_OVF_INT_ST field.
	UART_INT_ST_RXFIFO_OVF_INT_ST_Pos = 0x4
	// Bit mask of RXFIFO_OVF_INT_ST field.
	UART_INT_ST_RXFIFO_OVF_INT_ST_Msk = 0x10
	// Bit RXFIFO_OVF_INT_ST.
	UART_INT_ST_RXFIFO_OVF_INT_ST = 0x10
	// Position of DSR_CHG_INT_ST field.
	UART_INT_ST_DSR_CHG_INT_ST_Pos = 0x5
	// Bit mask of DSR_CHG_INT_ST field.
	UART_INT_ST_DSR_CHG_INT_ST_Msk = 0x20
	// Bit DSR_CHG_INT_ST.
	UART_INT_ST_DSR_CHG_INT_ST = 0x20
	// Position of CTS_CHG_INT_ST field.
	UART_INT_ST_CTS_CHG_INT_ST_Pos = 0x6
	// Bit mask of CTS_CHG_INT_ST field.
	UART_INT_ST_CTS_CHG_INT_ST_Msk = 0x40
	// Bit CTS_CHG_INT_ST.
	UART_INT_ST_CTS_CHG_INT_ST = 0x40
	// Position of BRK_DET_INT_ST field.
	UART_INT_ST_BRK_DET_INT_ST_Pos = 0x7
	// Bit mask of BRK_DET_INT_ST field.
	UART_INT_ST_BRK_DET_INT_ST_Msk = 0x80
	// Bit BRK_DET_INT_ST.
	UART_INT_ST_BRK_DET_INT_ST = 0x80
	// Position of RXFIFO_TOUT_INT_ST field.
	UART_INT_ST_RXFIFO_TOUT_INT_ST_Pos = 0x8
	// Bit mask of RXFIFO_TOUT_INT_ST field.
	UART_INT_ST_RXFIFO_TOUT_INT_ST_Msk = 0x100
	// Bit RXFIFO_TOUT_INT_ST.
	UART_INT_ST_RXFIFO_TOUT_INT_ST = 0x100
	// Position of SW_XON_INT_ST field.
	UART_INT_ST_SW_XON_INT_ST_Pos = 0x9
	// Bit mask of SW_XON_INT_ST field.
	UART_INT_ST_SW_XON_INT_ST_Msk = 0x200
	// Bit SW_XON_INT_ST.
	UART_INT_ST_SW_XON_INT_ST = 0x200
	// Position of SW_XOFF_INT_ST field.
	UART_INT_ST_SW_XOFF_INT_ST_Pos = 0xa
	// Bit mask of SW_XOFF_INT_ST field.
	UART_INT_ST_SW_XOFF_INT_ST_Msk = 0x400
	// Bit SW_XOFF_INT_ST.
	UART_INT_ST_SW_XOFF_INT_ST = 0x400
	// Position of GLITCH_DET_INT_ST field.
	UART_INT_ST_GLITCH_DET_INT_ST_Pos = 0xb
	// Bit mask of GLITCH_DET_INT_ST field.
	UART_INT_ST_GLITCH_DET_INT_ST_Msk = 0x800
	// Bit GLITCH_DET_INT_ST.
	UART_INT_ST_GLITCH_DET_INT_ST = 0x800
	// Position of TX_BRK_DONE_INT_ST field.
	UART_INT_ST_TX_BRK_DONE_INT_ST_Pos = 0xc
	// Bit mask of TX_BRK_DONE_INT_ST field.
	UART_INT_ST_TX_BRK_DONE_INT_ST_Msk = 0x1000
	// Bit TX_BRK_DONE_INT_ST.
	UART_INT_ST_TX_BRK_DONE_INT_ST = 0x1000
	// Position of TX_BRK_IDLE_DONE_INT_ST field.
	UART_INT_ST_TX_BRK_IDLE_DONE_INT_ST_Pos = 0xd
	// Bit mask of TX_BRK_IDLE_DONE_INT_ST field.
	UART_INT_ST_TX_BRK_IDLE_DONE_INT_ST_Msk = 0x2000
	// Bit TX_BRK_IDLE_DONE_INT_ST.
	UART_INT_ST_TX_BRK_IDLE_DONE_INT_ST = 0x2000
	// Position of TX_DONE_INT_ST field.
	UART_INT_ST_TX_DONE_INT_ST_Pos = 0xe
	// Bit mask of TX_DONE_INT_ST field.
	UART_INT_ST_TX_DONE_INT_ST_Msk = 0x4000
	// Bit TX_DONE_INT_ST.
	UART_INT_ST_TX_DONE_INT_ST = 0x4000
	// Position of RS485_PARITY_ERR_INT_ST field.
	UART_INT_ST_RS485_PARITY_ERR_INT_ST_Pos = 0xf
	// Bit mask of RS485_PARITY_ERR_INT_ST field.
	UART_INT_ST_RS485_PARITY_ERR_INT_ST_Msk = 0x8000
	// Bit RS485_PARITY_ERR_INT_ST.
	UART_INT_ST_RS485_PARITY_ERR_INT_ST = 0x8000
	// Position of RS485_FRM_ERR_INT_ST field.
	UART_INT_ST_RS485_FRM_ERR_INT_ST_Pos = 0x10
	// Bit mask of RS485_FRM_ERR_INT_ST field.
	UART_INT_ST_RS485_FRM_ERR_INT_ST_Msk = 0x10000
	// Bit RS485_FRM_ERR_INT_ST.
	UART_INT_ST_RS485_FRM_ERR_INT_ST = 0x10000
	// Position of RS485_CLASH_INT_ST field.
	UART_INT_ST_RS485_CLASH_INT_ST_Pos = 0x11
	// Bit mask of RS485_CLASH_INT_ST field.
	UART_INT_ST_RS485_CLASH_INT_ST_Msk = 0x20000
	// Bit RS485_CLASH_INT_ST.
	UART_INT_ST_RS485_CLASH_INT_ST = 0x20000
	// Position of AT_CMD_CHAR_DET_INT_ST field.
	UART_INT_ST_AT_CMD_CHAR_DET_INT_ST_Pos = 0x12
	// Bit mask of AT_CMD_CHAR_DET_INT_ST field.
	UART_INT_ST_AT_CMD_CHAR_DET_INT_ST_Msk = 0x40000
	// Bit AT_CMD_CHAR_DET_INT_ST.
	UART_INT_ST_AT_CMD_CHAR_DET_INT_ST = 0x40000
	// Position of WAKEUP_INT_ST field.
	UART_INT_ST_WAKEUP_INT_ST_Pos = 0x13
	// Bit mask of WAKEUP_INT_ST field.
	UART_INT_ST_WAKEUP_INT_ST_Msk = 0x80000
	// Bit WAKEUP_INT_ST.
	UART_INT_ST_WAKEUP_INT_ST = 0x80000

	// INT_ENA: Interrupt enable bits
	// Position of RXFIFO_FULL_INT_ENA field.
	UART_INT_ENA_RXFIFO_FULL_INT_ENA_Pos = 0x0
	// Bit mask of RXFIFO_FULL_INT_ENA field.
	UART_INT_ENA_RXFIFO_FULL_INT_ENA_Msk = 0x1
	// Bit RXFIFO_FULL_INT_ENA.
	UART_INT_ENA_RXFIFO_FULL_INT_ENA = 0x1
	// Position of TXFIFO_EMPTY_INT_ENA field.
	UART_INT_ENA_TXFIFO_EMPTY_INT_ENA_Pos = 0x1
	// Bit mask of TXFIFO_EMPTY_INT_ENA field.
	UART_INT_ENA_TXFIFO_EMPTY_INT_ENA_Msk = 0x2
	// Bit TXFIFO_EMPTY_INT_ENA.
	UART_INT_ENA_TXFIFO_EMPTY_INT_ENA = 0x2
	// Position of PARITY_ERR_INT_ENA field.
	UART_INT_ENA_PARITY_ERR_INT_ENA_Pos = 0x2
	// Bit mask of PARITY_ERR_INT_ENA field.
	UART_INT_ENA_PARITY_ERR_INT_ENA_Msk = 0x4
	// Bit PARITY_ERR_INT_ENA.
	UART_INT_ENA_PARITY_ERR_INT_ENA = 0x4
	// Position of FRM_ERR_INT_ENA field.
	UART_INT_ENA_FRM_ERR_INT_ENA_Pos = 0x3
	// Bit mask of FRM_ERR_INT_ENA field.
	UART_INT_ENA_FRM_ERR_INT_ENA_Msk = 0x8
	// Bit FRM_ERR_INT_ENA.
	UART_INT_ENA_FRM_ERR_INT_ENA = 0x8
	// Position of RXFIFO_OVF_INT_ENA field.
	UART_INT_ENA_RXFIFO_OVF_INT_ENA_Pos = 0x4
	// Bit mask of RXFIFO_OVF_INT_ENA field.
	UART_INT_ENA_RXFIFO_OVF_INT_ENA_Msk = 0x10
	// Bit RXFIFO_OVF_INT_ENA.
	UART_INT_ENA_RXFIFO_OVF_INT_ENA = 0x10
	// Position of DSR_CHG_INT_ENA field.
	UART_INT_ENA_DSR_CHG_INT_ENA_Pos = 0x5
	// Bit mask of DSR_CHG_INT_ENA field.
	UART_INT_ENA_DSR_CHG_INT_ENA_Msk = 0x20
	// Bit DSR_CHG_INT_ENA.
	UART_INT_ENA_DSR_CHG_INT_ENA = 0x20
	// Position of CTS_CHG_INT_ENA field.
	UART_INT_ENA_CTS_CHG_INT_ENA_Pos = 0x6
	// Bit mask of CTS_CHG_INT_ENA field.
	UART_INT_ENA_CTS_CHG_INT_ENA_Msk = 0x40
	// Bit CTS_CHG_INT_ENA.
	UART_INT_ENA_CTS_CHG_INT_ENA = 0x40
	// Position of BRK_DET_INT_ENA field.
	UART_INT_ENA_BRK_DET_INT_ENA_Pos = 0x7
	// Bit mask of BRK_DET_INT_ENA field.
	UART_INT_ENA_BRK_DET_INT_ENA_Msk = 0x80
	// Bit BRK_DET_INT_ENA.
	UART_INT_ENA_BRK_DET_INT_ENA = 0x80
	// Position of RXFIFO_TOUT_INT_ENA field.
	UART_INT_ENA_RXFIFO_TOUT_INT_ENA_Pos = 0x8
	// Bit mask of RXFIFO_TOUT_INT_ENA field.
	UART_INT_ENA_RXFIFO_TOUT_INT_ENA_Msk = 0x100
	// Bit RXFIFO_TOUT_INT_ENA.
	UART_INT_ENA_RXFIFO_TOUT_INT_ENA = 0x100
	// Position of SW_XON_INT_ENA field.
	UART_INT_ENA_SW_XON_INT_ENA_Pos = 0x9
	// Bit mask of SW_XON_INT_ENA field.
	UART_INT_ENA_SW_XON_INT_ENA_Msk = 0x200
	// Bit SW_XON_INT_ENA.
	UART_INT_ENA_SW_XON_INT_ENA = 0x200
	// Position of SW_XOFF_INT_ENA field.
	UART_INT_ENA_SW_XOFF_INT_ENA_Pos = 0xa
	// Bit mask of SW_XOFF_INT_ENA field.
	UART_INT_ENA_SW_XOFF_INT_ENA_Msk = 0x400
	// Bit SW_XOFF_INT_ENA.
	UART_INT_ENA_SW_XOFF_INT_ENA = 0x400
	// Position of GLITCH_DET_INT_ENA field.
	UART_INT_ENA_GLITCH_DET_INT_ENA_Pos = 0xb
	// Bit mask of GLITCH_DET_INT_ENA field.
	UART_INT_ENA_GLITCH_DET_INT_ENA_Msk = 0x800
	// Bit GLITCH_DET_INT_ENA.
	UART_INT_ENA_GLITCH_DET_INT_ENA = 0x800
	// Position of TX_BRK_DONE_INT_ENA field.
	UART_INT_ENA_TX_BRK_DONE_INT_ENA_Pos = 0xc
	// Bit mask of TX_BRK_DONE_INT_ENA field.
	UART_INT_ENA_TX_BRK_DONE_INT_ENA_Msk = 0x1000
	// Bit TX_BRK_DONE_INT_ENA.
	UART_INT_ENA_TX_BRK_DONE_INT_ENA = 0x1000
	// Position of TX_BRK_IDLE_DONE_INT_ENA field.
	UART_INT_ENA_TX_BRK_IDLE_DONE_INT_ENA_Pos = 0xd
	// Bit mask of TX_BRK_IDLE_DONE_INT_ENA field.
	UART_INT_ENA_TX_BRK_IDLE_DONE_INT_ENA_Msk = 0x2000
	// Bit TX_BRK_IDLE_DONE_INT_ENA.
	UART_INT_ENA_TX_BRK_IDLE_DONE_INT_ENA = 0x2000
	// Position of TX_DONE_INT_ENA field.
	UART_INT_ENA_TX_DONE_INT_ENA_Pos = 0xe
	// Bit mask of TX_DONE_INT_ENA field.
	UART_INT_ENA_TX_DONE_INT_ENA_Msk = 0x4000
	// Bit TX_DONE_INT_ENA.
	UART_INT_ENA_TX_DONE_INT_ENA = 0x4000
	// Position of RS485_PARITY_ERR_INT_ENA field.
	UART_INT_ENA_RS485_PARITY_ERR_INT_ENA_Pos = 0xf
	// Bit mask of RS485_PARITY_ERR_INT_ENA field.
	UART_INT_ENA_RS485_PARITY_ERR_INT_ENA_Msk = 0x8000
	// Bit RS485_PARITY_ERR_INT_ENA.
	UART_INT_ENA_RS485_PARITY_ERR_INT_ENA = 0x8000
	// Position of RS485_FRM_ERR_INT_ENA field.
	UART_INT_ENA_RS485_FRM_ERR_INT_ENA_Pos = 0x10
	// Bit mask of RS485_FRM_ERR_INT_ENA field.
	UART_INT_ENA_RS485_FRM_ERR_INT_ENA_Msk = 0x10000
	// Bit RS485_FRM_ERR_INT_ENA.
	UART_INT_ENA_RS485_FRM_ERR_INT_ENA = 0x10000
	// Position of RS485_CLASH_INT_ENA field.
	UART_INT_ENA_RS485_CLASH_INT_ENA_Pos = 0x11
	// Bit mask of RS485_CLASH_INT_ENA field.
	UART_INT_ENA_RS485_CLASH_INT_ENA_Msk = 0x20000
	// Bit RS485_CLASH_INT_ENA.
	UART_INT_ENA_RS485_CLASH_INT_ENA = 0x20000
	// Position of AT_CMD_CHAR_DET_INT_ENA field.
	UART_INT_ENA_AT_CMD_CHAR_DET_INT_ENA_Pos = 0x12
	// Bit mask of AT_CMD_CHAR_DET_INT_ENA field.
	UART_INT_ENA_AT_CMD_CHAR_DET_INT_ENA_Msk = 0x40000
	// Bit AT_CMD_CHAR_DET_INT_ENA.
	UART_INT_ENA_AT_CMD_CHAR_DET_INT_ENA = 0x40000
	// Position of WAKEUP_INT_ENA field.
	UART_INT_ENA_WAKEUP_INT_ENA_Pos = 0x13
	// Bit mask of WAKEUP_INT_ENA field.
	UART_INT_ENA_WAKEUP_INT_ENA_Msk = 0x80000
	// Bit WAKEUP_INT_ENA.
	UART_INT_ENA_WAKEUP_INT_ENA = 0x80000

	// INT_CLR: Interrupt clear bits
	// Position of RXFIFO_FULL_INT_CLR field.
	UART_INT_CLR_RXFIFO_FULL_INT_CLR_Pos = 0x0
	// Bit mask of RXFIFO_FULL_INT_CLR field.
	UART_INT_CLR_RXFIFO_FULL_INT_CLR_Msk = 0x1
	// Bit RXFIFO_FULL_INT_CLR.
	UART_INT_CLR_RXFIFO_FULL_INT_CLR = 0x1
	// Position of TXFIFO_EMPTY_INT_CLR field.
	UART_INT_CLR_TXFIFO_EMPTY_INT_CLR_Pos = 0x1
	// Bit mask of TXFIFO_EMPTY_INT_CLR field.
	UART_INT_CLR_TXFIFO_EMPTY_INT_CLR_Msk = 0x2
	// Bit TXFIFO_EMPTY_INT_CLR.
	UART_INT_CLR_TXFIFO_EMPTY_INT_CLR = 0x2
	// Position of PARITY_ERR_INT_CLR field.
	UART_INT_CLR_PARITY_ERR_INT_CLR_Pos = 0x2
	// Bit mask of PARITY_ERR_INT_CLR field.
	UART_INT_CLR_PARITY_ERR_INT_CLR_Msk = 0x4
	// Bit PARITY_ERR_INT_CLR.
	UART_INT_CLR_PARITY_ERR_INT_CLR = 0x4
	// Position of FRM_ERR_INT_CLR field.
	UART_INT_CLR_FRM_ERR_INT_CLR_Pos = 0x3
	// Bit mask of FRM_ERR_INT_CLR field.
	UART_INT_CLR_FRM_ERR_INT_CLR_Msk = 0x8
	// Bit FRM_ERR_INT_CLR.
	UART_INT_CLR_FRM_ERR_INT_CLR = 0x8
	// Position of RXFIFO_OVF_INT_CLR field.
	UART_INT_CLR_RXFIFO_OVF_INT_CLR_Pos = 0x4
	// Bit mask of RXFIFO_OVF_INT_CLR field.
	UART_INT_CLR_RXFIFO_OVF_INT_CLR_Msk = 0x10
	// Bit RXFIFO_OVF_INT_CLR.
	UART_INT_CLR_RXFIFO_OVF_INT_CLR = 0x10
	// Position of DSR_CHG_INT_CLR field.
	UART_INT_CLR_DSR_CHG_INT_CLR_Pos = 0x5
	// Bit mask of DSR_CHG_INT_CLR field.
	UART_INT_CLR_DSR_CHG_INT_CLR_Msk = 0x20
	// Bit DSR_CHG_INT_CLR.
	UART_INT_CLR_DSR_CHG_INT_CLR = 0x20
	// Position of CTS_CHG_INT_CLR field.
	UART_INT_CLR_CTS_CHG_INT_CLR_Pos = 0x6
	// Bit mask of CTS_CHG_INT_CLR field.
	UART_INT_CLR_CTS_CHG_INT_CLR_Msk = 0x40
	// Bit CTS_CHG_INT_CLR.
	UART_INT_CLR_CTS_CHG_INT_CLR = 0x40
	// Position of BRK_DET_INT_CLR field.
	UART_INT_CLR_BRK_DET_INT_CLR_Pos = 0x7
	// Bit mask of BRK_DET_INT_CLR field.
	UART_INT_CLR_BRK_DET_INT_CLR_Msk = 0x80
	// Bit BRK_DET_INT_CLR.
	UART_INT_CLR_BRK_DET_INT_CLR = 0x80
	// Position of RXFIFO_TOUT_INT_CLR field.
	UART_INT_CLR_RXFIFO_TOUT_INT_CLR_Pos = 0x8
	// Bit mask of RXFIFO_TOUT_INT_CLR field.
	UART_INT_CLR_RXFIFO_TOUT_INT_CLR_Msk = 0x100
	// Bit RXFIFO_TOUT_INT_CLR.
	UART_INT_CLR_RXFIFO_TOUT_INT_CLR = 0x100
	// Position of SW_XON_INT_CLR field.
	UART_INT_CLR_SW_XON_INT_CLR_Pos = 0x9
	// Bit mask of SW_XON_INT_CLR field.
	UART_INT_CLR_SW_XON_INT_CLR_Msk = 0x200
	// Bit SW_XON_INT_CLR.
	UART_INT_CLR_SW_XON_INT_CLR = 0x200
	// Position of SW_XOFF_INT_CLR field.
	UART_INT_CLR_SW_XOFF_INT_CLR_Pos = 0xa
	// Bit mask of SW_XOFF_INT_CLR field.
	UART_INT_CLR_SW_XOFF_INT_CLR_Msk = 0x400
	// Bit SW_XOFF_INT_CLR.
	UART_INT_CLR_SW_XOFF_INT_CLR = 0x400
	// Position of GLITCH_DET_INT_CLR field.
	UART_INT_CLR_GLITCH_DET_INT_CLR_Pos = 0xb
	// Bit mask of GLITCH_DET_INT_CLR field.
	UART_INT_CLR_GLITCH_DET_INT_CLR_Msk = 0x800
	// Bit GLITCH_DET_INT_CLR.
	UART_INT_CLR_GLITCH_DET_INT_CLR = 0x800
	// Position of TX_BRK_DONE_INT_CLR field.
	UART_INT_CLR_TX_BRK_DONE_INT_CLR_Pos = 0xc
	// Bit mask of TX_BRK_DONE_INT_CLR field.
	UART_INT_CLR_TX_BRK_DONE_INT_CLR_Msk = 0x1000
	// Bit TX_BRK_DONE_INT_CLR.
	UART_INT_CLR_TX_BRK_DONE_INT_CLR = 0x1000
	// Position of TX_BRK_IDLE_DONE_INT_CLR field.
	UART_INT_CLR_TX_BRK_IDLE_DONE_INT_CLR_Pos = 0xd
	// Bit mask of TX_BRK_IDLE_DONE_INT_CLR field.
	UART_INT_CLR_TX_BRK_IDLE_DONE_INT_CLR_Msk = 0x2000
	// Bit TX_BRK_IDLE_DONE_INT_CLR.
	UART_INT_CLR_TX_BRK_IDLE_DONE_INT_CLR = 0x2000
	// Position of TX_DONE_INT_CLR field.
	UART_INT_CLR_TX_DONE_INT_CLR_Pos = 0xe
	// Bit mask of TX_DONE_INT_CLR field.
	UART_INT_CLR_TX_DONE_INT_CLR_Msk = 0x4000
	// Bit TX_DONE_INT_CLR.
	UART_INT_CLR_TX_DONE_INT_CLR = 0x4000
	// Position of RS485_PARITY_ERR_INT_CLR field.
	UART_INT_CLR_RS485_PARITY_ERR_INT_CLR_Pos = 0xf
	// Bit mask of RS485_PARITY_ERR_INT_CLR field.
	UART_INT_CLR_RS485_PARITY_ERR_INT_CLR_Msk = 0x8000
	// Bit RS485_PARITY_ERR_INT_CLR.
	UART_INT_CLR_RS485_PARITY_ERR_INT_CLR = 0x8000
	// Position of RS485_FRM_ERR_INT_CLR field.
	UART_INT_CLR_RS485_FRM_ERR_INT_CLR_Pos = 0x10
	// Bit mask of RS485_FRM_ERR_INT_CLR field.
	UART_INT_CLR_RS485_FRM_ERR_INT_CLR_Msk = 0x10000
	// Bit RS485_FRM_ERR_INT_CLR.
	UART_INT_CLR_RS485_FRM_ERR_INT_CLR = 0x10000
	// Position of RS485_CLASH_INT_CLR field.
	UART_INT_CLR_RS485_CLASH_INT_CLR_Pos = 0x11
	// Bit mask of RS485_CLASH_INT_CLR field.
	UART_INT_CLR_RS485_CLASH_INT_CLR_Msk = 0x20000
	// Bit RS485_CLASH_INT_CLR.
	UART_INT_CLR_RS485_CLASH_INT_CLR = 0x20000
	// Position of AT_CMD_CHAR_DET_INT_CLR field.
	UART_INT_CLR_AT_CMD_CHAR_DET_INT_CLR_Pos = 0x12
	// Bit mask of AT_CMD_CHAR_DET_INT_CLR field.
	UART_INT_CLR_AT_CMD_CHAR_DET_INT_CLR_Msk = 0x40000
	// Bit AT_CMD_CHAR_DET_INT_CLR.
	UART_INT_CLR_AT_CMD_CHAR_DET_INT_CLR = 0x40000
	// Position of WAKEUP_INT_CLR field.
	UART_INT_CLR_WAKEUP_INT_CLR_Pos = 0x13
	// Bit mask of WAKEUP_INT_CLR field.
	UART_INT_CLR_WAKEUP_INT_CLR_Msk = 0x80000
	// Bit WAKEUP_INT_CLR.
	UART_INT_CLR_WAKEUP_INT_CLR = 0x80000

	// CLKDIV: Clock divider configuration
	// Position of CLKDIV field.
	UART_CLKDIV_CLKDIV_Pos = 0x0
	// Bit mask of CLKDIV field.
	UART_CLKDIV_CLKDIV_Msk = 0xfff
	// Position of FRAG field.
	UART_CLKDIV_FRAG_Pos = 0x14
	// Bit mask of FRAG field.
	UART_CLKDIV_FRAG_Msk = 0xf00000

	// RX_FILT: Rx Filter configuration
	// Position of GLITCH_FILT field.
	UART_RX_FILT_GLITCH_FILT_Pos = 0x0
	// Bit mask of GLITCH_FILT field.
	UART_RX_FILT_GLITCH_FILT_Msk = 0xff
	// Position of GLITCH_FILT_EN field.
	UART_RX_FILT_GLITCH_FILT_EN_Pos = 0x8
	// Bit mask of GLITCH_FILT_EN field.
	UART_RX_FILT_GLITCH_FILT_EN_Msk = 0x100
	// Bit GLITCH_FILT_EN.
	UART_RX_FILT_GLITCH_FILT_EN = 0x100

	// STATUS: UART status register
	// Position of RXFIFO_CNT field.
	UART_STATUS_RXFIFO_CNT_Pos = 0x0
	// Bit mask of RXFIFO_CNT field.
	UART_STATUS_RXFIFO_CNT_Msk = 0x3ff
	// Position of DSRN field.
	UART_STATUS_DSRN_Pos = 0xd
	// Bit mask of DSRN field.
	UART_STATUS_DSRN_Msk = 0x2000
	// Bit DSRN.
	UART_STATUS_DSRN = 0x2000
	// Position of CTSN field.
	UART_STATUS_CTSN_Pos = 0xe
	// Bit mask of CTSN field.
	UART_STATUS_CTSN_Msk = 0x4000
	// Bit CTSN.
	UART_STATUS_CTSN = 0x4000
	// Position of RXD field.
	UART_STATUS_RXD_Pos = 0xf
	// Bit mask of RXD field.
	UART_STATUS_RXD_Msk = 0x8000
	// Bit RXD.
	UART_STATUS_RXD = 0x8000
	// Position of TXFIFO_CNT field.
	UART_STATUS_TXFIFO_CNT_Pos = 0x10
	// Bit mask of TXFIFO_CNT field.
	UART_STATUS_TXFIFO_CNT_Msk = 0x3ff0000
	// Position of DTRN field.
	UART_STATUS_DTRN_Pos = 0x1d
	// Bit mask of DTRN field.
	UART_STATUS_DTRN_Msk = 0x20000000
	// Bit DTRN.
	UART_STATUS_DTRN = 0x20000000
	// Position of RTSN field.
	UART_STATUS_RTSN_Pos = 0x1e
	// Bit mask of RTSN field.
	UART_STATUS_RTSN_Msk = 0x40000000
	// Bit RTSN.
	UART_STATUS_RTSN = 0x40000000
	// Position of TXD field.
	UART_STATUS_TXD_Pos = 0x1f
	// Bit mask of TXD field.
	UART_STATUS_TXD_Msk = 0x80000000
	// Bit TXD.
	UART_STATUS_TXD = 0x80000000

	// CONF0: a
	// Position of PARITY field.
	UART_CONF0_PARITY_Pos = 0x0
	// Bit mask of PARITY field.
	UART_CONF0_PARITY_Msk = 0x1
	// Bit PARITY.
	UART_CONF0_PARITY = 0x1
	// Position of PARITY_EN field.
	UART_CONF0_PARITY_EN_Pos = 0x1
	// Bit mask of PARITY_EN field.
	UART_CONF0_PARITY_EN_Msk = 0x2
	// Bit PARITY_EN.
	UART_CONF0_PARITY_EN = 0x2
	// Position of BIT_NUM field.
	UART_CONF0_BIT_NUM_Pos = 0x2
	// Bit mask of BIT_NUM field.
	UART_CONF0_BIT_NUM_Msk = 0xc
	// Position of STOP_BIT_NUM field.
	UART_CONF0_STOP_BIT_NUM_Pos = 0x4
	// Bit mask of STOP_BIT_NUM field.
	UART_CONF0_STOP_BIT_NUM_Msk = 0x30
	// Position of SW_RTS field.
	UART_CONF0_SW_RTS_Pos = 0x6
	// Bit mask of SW_RTS field.
	UART_CONF0_SW_RTS_Msk = 0x40
	// Bit SW_RTS.
	UART_CONF0_SW_RTS = 0x40
	// Position of SW_DTR field.
	UART_CONF0_SW_DTR_Pos = 0x7
	// Bit mask of SW_DTR field.
	UART_CONF0_SW_DTR_Msk = 0x80
	// Bit SW_DTR.
	UART_CONF0_SW_DTR = 0x80
	// Position of TXD_BRK field.
	UART_CONF0_TXD_BRK_Pos = 0x8
	// Bit mask of TXD_BRK field.
	UART_CONF0_TXD_BRK_Msk = 0x100
	// Bit TXD_BRK.
	UART_CONF0_TXD_BRK = 0x100
	// Position of IRDA_DPLX field.
	UART_CONF0_IRDA_DPLX_Pos = 0x9
	// Bit mask of IRDA_DPLX field.
	UART_CONF0_IRDA_DPLX_Msk = 0x200
	// Bit IRDA_DPLX.
	UART_CONF0_IRDA_DPLX = 0x200
	// Position of IRDA_TX_EN field.
	UART_CONF0_IRDA_TX_EN_Pos = 0xa
	// Bit mask of IRDA_TX_EN field.
	UART_CONF0_IRDA_TX_EN_Msk = 0x400
	// Bit IRDA_TX_EN.
	UART_CONF0_IRDA_TX_EN = 0x400
	// Position of IRDA_WCTL field.
	UART_CONF0_IRDA_WCTL_Pos = 0xb
	// Bit mask of IRDA_WCTL field.
	UART_CONF0_IRDA_WCTL_Msk = 0x800
	// Bit IRDA_WCTL.
	UART_CONF0_IRDA_WCTL = 0x800
	// Position of IRDA_TX_INV field.
	UART_CONF0_IRDA_TX_INV_Pos = 0xc
	// Bit mask of IRDA_TX_INV field.
	UART_CONF0_IRDA_TX_INV_Msk = 0x1000
	// Bit IRDA_TX_INV.
	UART_CONF0_IRDA_TX_INV = 0x1000
	// Position of IRDA_RX_INV field.
	UART_CONF0_IRDA_RX_INV_Pos = 0xd
	// Bit mask of IRDA_RX_INV field.
	UART_CONF0_IRDA_RX_INV_Msk = 0x2000
	// Bit IRDA_RX_INV.
	UART_CONF0_IRDA_RX_INV = 0x2000
	// Position of LOOPBACK field.
	UART_CONF0_LOOPBACK_Pos = 0xe
	// Bit mask of LOOPBACK field.
	UART_CONF0_LOOPBACK_Msk = 0x4000
	// Bit LOOPBACK.
	UART_CONF0_LOOPBACK = 0x4000
	// Position of TX_FLOW_EN field.
	UART_CONF0_TX_FLOW_EN_Pos = 0xf
	// Bit mask of TX_FLOW_EN field.
	UART_CONF0_TX_FLOW_EN_Msk = 0x8000
	// Bit TX_FLOW_EN.
	UART_CONF0_TX_FLOW_EN = 0x8000
	// Position of IRDA_EN field.
	UART_CONF0_IRDA_EN_Pos = 0x10
	// Bit mask of IRDA_EN field.
	UART_CONF0_IRDA_EN_Msk = 0x10000
	// Bit IRDA_EN.
	UART_CONF0_IRDA_EN = 0x10000
	// Position of RXFIFO_RST field.
	UART_CONF0_RXFIFO_RST_Pos = 0x11
	// Bit mask of RXFIFO_RST field.
	UART_CONF0_RXFIFO_RST_Msk = 0x20000
	// Bit RXFIFO_RST.
	UART_CONF0_RXFIFO_RST = 0x20000
	// Position of TXFIFO_RST field.
	UART_CONF0_TXFIFO_RST_Pos = 0x12
	// Bit mask of TXFIFO_RST field.
	UART_CONF0_TXFIFO_RST_Msk = 0x40000
	// Bit TXFIFO_RST.
	UART_CONF0_TXFIFO_RST = 0x40000
	// Position of RXD_INV field.
	UART_CONF0_RXD_INV_Pos = 0x13
	// Bit mask of RXD_INV field.
	UART_CONF0_RXD_INV_Msk = 0x80000
	// Bit RXD_INV.
	UART_CONF0_RXD_INV = 0x80000
	// Position of CTS_INV field.
	UART_CONF0_CTS_INV_Pos = 0x14
	// Bit mask of CTS_INV field.
	UART_CONF0_CTS_INV_Msk = 0x100000
	// Bit CTS_INV.
	UART_CONF0_CTS_INV = 0x100000
	// Position of DSR_INV field.
	UART_CONF0_DSR_INV_Pos = 0x15
	// Bit mask of DSR_INV field.
	UART_CONF0_DSR_INV_Msk = 0x200000
	// Bit DSR_INV.
	UART_CONF0_DSR_INV = 0x200000
	// Position of TXD_INV field.
	UART_CONF0_TXD_INV_Pos = 0x16
	// Bit mask of TXD_INV field.
	UART_CONF0_TXD_INV_Msk = 0x400000
	// Bit TXD_INV.
	UART_CONF0_TXD_INV = 0x400000
	// Position of RTS_INV field.
	UART_CONF0_RTS_INV_Pos = 0x17
	// Bit mask of RTS_INV field.
	UART_CONF0_RTS_INV_Msk = 0x800000
	// Bit RTS_INV.
	UART_CONF0_RTS_INV = 0x800000
	// Position of DTR_INV field.
	UART_CONF0_DTR_INV_Pos = 0x18
	// Bit mask of DTR_INV field.
	UART_CONF0_DTR_INV_Msk = 0x1000000
	// Bit DTR_INV.
	UART_CONF0_DTR_INV = 0x1000000
	// Position of CLK_EN field.
	UART_CONF0_CLK_EN_Pos = 0x19
	// Bit mask of CLK_EN field.
	UART_CONF0_CLK_EN_Msk = 0x2000000
	// Bit CLK_EN.
	UART_CONF0_CLK_EN = 0x2000000
	// Position of ERR_WR_MASK field.
	UART_CONF0_ERR_WR_MASK_Pos = 0x1a
	// Bit mask of ERR_WR_MASK field.
	UART_CONF0_ERR_WR_MASK_Msk = 0x4000000
	// Bit ERR_WR_MASK.
	UART_CONF0_ERR_WR_MASK = 0x4000000
	// Position of AUTOBAUD_EN field.
	UART_CONF0_AUTOBAUD_EN_Pos = 0x1b
	// Bit mask of AUTOBAUD_EN field.
	UART_CONF0_AUTOBAUD_EN_Msk = 0x8000000
	// Bit AUTOBAUD_EN.
	UART_CONF0_AUTOBAUD_EN = 0x8000000
	// Position of MEM_CLK_EN field.
	UART_CONF0_MEM_CLK_EN_Pos = 0x1c
	// Bit mask of MEM_CLK_EN field.
	UART_CONF0_MEM_CLK_EN_Msk = 0x10000000
	// Bit MEM_CLK_EN.
	UART_CONF0_MEM_CLK_EN = 0x10000000

	// CONF1: Configuration register 1
	// Position of RXFIFO_FULL_THRHD field.
	UART_CONF1_RXFIFO_FULL_THRHD_Pos = 0x0
	// Bit mask of RXFIFO_FULL_THRHD field.
	UART_CONF1_RXFIFO_FULL_THRHD_Msk = 0x1ff
	// Position of TXFIFO_EMPTY_THRHD field.
	UART_CONF1_TXFIFO_EMPTY_THRHD_Pos = 0x9
	// Bit mask of TXFIFO_EMPTY_THRHD field.
	UART_CONF1_TXFIFO_EMPTY_THRHD_Msk = 0x3fe00
	// Position of DIS_RX_DAT_OVF field.
	UART_CONF1_DIS_RX_DAT_OVF_Pos = 0x12
	// Bit mask of DIS_RX_DAT_OVF field.
	UART_CONF1_DIS_RX_DAT_OVF_Msk = 0x40000
	// Bit DIS_RX_DAT_OVF.
	UART_CONF1_DIS_RX_DAT_OVF = 0x40000
	// Position of RX_TOUT_FLOW_DIS field.
	UART_CONF1_RX_TOUT_FLOW_DIS_Pos = 0x13
	// Bit mask of RX_TOUT_FLOW_DIS field.
	UART_CONF1_RX_TOUT_FLOW_DIS_Msk = 0x80000
	// Bit RX_TOUT_FLOW_DIS.
	UART_CONF1_RX_TOUT_FLOW_DIS = 0x80000
	// Position of RX_FLOW_EN field.
	UART_CONF1_RX_FLOW_EN_Pos = 0x14
	// Bit mask of RX_FLOW_EN field.
	UART_CONF1_RX_FLOW_EN_Msk = 0x100000
	// Bit RX_FLOW_EN.
	UART_CONF1_RX_FLOW_EN = 0x100000
	// Position of RX_TOUT_EN field.
	UART_CONF1_RX_TOUT_EN_Pos = 0x15
	// Bit mask of RX_TOUT_EN field.
	UART_CONF1_RX_TOUT_EN_Msk = 0x200000
	// Bit RX_TOUT_EN.
	UART_CONF1_RX_TOUT_EN = 0x200000

	// LOWPULSE: Autobaud minimum low pulse duration register
	// Position of MIN_CNT field.
	UART_LOWPULSE_MIN_CNT_Pos = 0x0
	// Bit mask of MIN_CNT field.
	UART_LOWPULSE_MIN_CNT_Msk = 0xfff

	// HIGHPULSE: Autobaud minimum high pulse duration register
	// Position of MIN_CNT field.
	UART_HIGHPULSE_MIN_CNT_Pos = 0x0
	// Bit mask of MIN_CNT field.
	UART_HIGHPULSE_MIN_CNT_Msk = 0xfff

	// RXD_CNT: Autobaud edge change count register
	// Position of RXD_EDGE_CNT field.
	UART_RXD_CNT_RXD_EDGE_CNT_Pos = 0x0
	// Bit mask of RXD_EDGE_CNT field.
	UART_RXD_CNT_RXD_EDGE_CNT_Msk = 0x3ff

	// FLOW_CONF: Software flow-control configuration
	// Position of SW_FLOW_CON_EN field.
	UART_FLOW_CONF_SW_FLOW_CON_EN_Pos = 0x0
	// Bit mask of SW_FLOW_CON_EN field.
	UART_FLOW_CONF_SW_FLOW_CON_EN_Msk = 0x1
	// Bit SW_FLOW_CON_EN.
	UART_FLOW_CONF_SW_FLOW_CON_EN = 0x1
	// Position of XONOFF_DEL field.
	UART_FLOW_CONF_XONOFF_DEL_Pos = 0x1
	// Bit mask of XONOFF_DEL field.
	UART_FLOW_CONF_XONOFF_DEL_Msk = 0x2
	// Bit XONOFF_DEL.
	UART_FLOW_CONF_XONOFF_DEL = 0x2
	// Position of FORCE_XON field.
	UART_FLOW_CONF_FORCE_XON_Pos = 0x2
	// Bit mask of FORCE_XON field.
	UART_FLOW_CONF_FORCE_XON_Msk = 0x4
	// Bit FORCE_XON.
	UART_FLOW_CONF_FORCE_XON = 0x4
	// Position of FORCE_XOFF field.
	UART_FLOW_CONF_FORCE_XOFF_Pos = 0x3
	// Bit mask of FORCE_XOFF field.
	UART_FLOW_CONF_FORCE_XOFF_Msk = 0x8
	// Bit FORCE_XOFF.
	UART_FLOW_CONF_FORCE_XOFF = 0x8
	// Position of SEND_XON field.
	UART_FLOW_CONF_SEND_XON_Pos = 0x4
	// Bit mask of SEND_XON field.
	UART_FLOW_CONF_SEND_XON_Msk = 0x10
	// Bit SEND_XON.
	UART_FLOW_CONF_SEND_XON = 0x10
	// Position of SEND_XOFF field.
	UART_FLOW_CONF_SEND_XOFF_Pos = 0x5
	// Bit mask of SEND_XOFF field.
	UART_FLOW_CONF_SEND_XOFF_Msk = 0x20
	// Bit SEND_XOFF.
	UART_FLOW_CONF_SEND_XOFF = 0x20

	// SLEEP_CONF: Sleep-mode configuration
	// Position of ACTIVE_THRESHOLD field.
	UART_SLEEP_CONF_ACTIVE_THRESHOLD_Pos = 0x0
	// Bit mask of ACTIVE_THRESHOLD field.
	UART_SLEEP_CONF_ACTIVE_THRESHOLD_Msk = 0x3ff

	// SWFC_CONF0: Software flow-control character configuration
	// Position of XOFF_THRESHOLD field.
	UART_SWFC_CONF0_XOFF_THRESHOLD_Pos = 0x0
	// Bit mask of XOFF_THRESHOLD field.
	UART_SWFC_CONF0_XOFF_THRESHOLD_Msk = 0x1ff
	// Position of XOFF_CHAR field.
	UART_SWFC_CONF0_XOFF_CHAR_Pos = 0x9
	// Bit mask of XOFF_CHAR field.
	UART_SWFC_CONF0_XOFF_CHAR_Msk = 0x1fe00

	// SWFC_CONF1: Software flow-control character configuration
	// Position of XON_THRESHOLD field.
	UART_SWFC_CONF1_XON_THRESHOLD_Pos = 0x0
	// Bit mask of XON_THRESHOLD field.
	UART_SWFC_CONF1_XON_THRESHOLD_Msk = 0x1ff
	// Position of XON_CHAR field.
	UART_SWFC_CONF1_XON_CHAR_Pos = 0x9
	// Bit mask of XON_CHAR field.
	UART_SWFC_CONF1_XON_CHAR_Msk = 0x1fe00

	// TXBRK_CONF: Tx Break character configuration
	// Position of TX_BRK_NUM field.
	UART_TXBRK_CONF_TX_BRK_NUM_Pos = 0x0
	// Bit mask of TX_BRK_NUM field.
	UART_TXBRK_CONF_TX_BRK_NUM_Msk = 0xff

	// IDLE_CONF: Frame-end idle configuration
	// Position of RX_IDLE_THRHD field.
	UART_IDLE_CONF_RX_IDLE_THRHD_Pos = 0x0
	// Bit mask of RX_IDLE_THRHD field.
	UART_IDLE_CONF_RX_IDLE_THRHD_Msk = 0x3ff
	// Position of TX_IDLE_NUM field.
	UART_IDLE_CONF_TX_IDLE_NUM_Pos = 0xa
	// Bit mask of TX_IDLE_NUM field.
	UART_IDLE_CONF_TX_IDLE_NUM_Msk = 0xffc00

	// RS485_CONF: RS485 mode configuration
	// Position of RS485_EN field.
	UART_RS485_CONF_RS485_EN_Pos = 0x0
	// Bit mask of RS485_EN field.
	UART_RS485_CONF_RS485_EN_Msk = 0x1
	// Bit RS485_EN.
	UART_RS485_CONF_RS485_EN = 0x1
	// Position of DL0_EN field.
	UART_RS485_CONF_DL0_EN_Pos = 0x1
	// Bit mask of DL0_EN field.
	UART_RS485_CONF_DL0_EN_Msk = 0x2
	// Bit DL0_EN.
	UART_RS485_CONF_DL0_EN = 0x2
	// Position of DL1_EN field.
	UART_RS485_CONF_DL1_EN_Pos = 0x2
	// Bit mask of DL1_EN field.
	UART_RS485_CONF_DL1_EN_Msk = 0x4
	// Bit DL1_EN.
	UART_RS485_CONF_DL1_EN = 0x4
	// Position of RS485TX_RX_EN field.
	UART_RS485_CONF_RS485TX_RX_EN_Pos = 0x3
	// Bit mask of RS485TX_RX_EN field.
	UART_RS485_CONF_RS485TX_RX_EN_Msk = 0x8
	// Bit RS485TX_RX_EN.
	UART_RS485_CONF_RS485TX_RX_EN = 0x8
	// Position of RS485RXBY_TX_EN field.
	UART_RS485_CONF_RS485RXBY_TX_EN_Pos = 0x4
	// Bit mask of RS485RXBY_TX_EN field.
	UART_RS485_CONF_RS485RXBY_TX_EN_Msk = 0x10
	// Bit RS485RXBY_TX_EN.
	UART_RS485_CONF_RS485RXBY_TX_EN = 0x10
	// Position of RS485_RX_DLY_NUM field.
	UART_RS485_CONF_RS485_RX_DLY_NUM_Pos = 0x5
	// Bit mask of RS485_RX_DLY_NUM field.
	UART_RS485_CONF_RS485_RX_DLY_NUM_Msk = 0x20
	// Bit RS485_RX_DLY_NUM.
	UART_RS485_CONF_RS485_RX_DLY_NUM = 0x20
	// Position of RS485_TX_DLY_NUM field.
	UART_RS485_CONF_RS485_TX_DLY_NUM_Pos = 0x6
	// Bit mask of RS485_TX_DLY_NUM field.
	UART_RS485_CONF_RS485_TX_DLY_NUM_Msk = 0x3c0

	// AT_CMD_PRECNT: Pre-sequence timing configuration
	// Position of PRE_IDLE_NUM field.
	UART_AT_CMD_PRECNT_PRE_IDLE_NUM_Pos = 0x0
	// Bit mask of PRE_IDLE_NUM field.
	UART_AT_CMD_PRECNT_PRE_IDLE_NUM_Msk = 0xffff

	// AT_CMD_POSTCNT: Post-sequence timing configuration
	// Position of POST_IDLE_NUM field.
	UART_AT_CMD_POSTCNT_POST_IDLE_NUM_Pos = 0x0
	// Bit mask of POST_IDLE_NUM field.
	UART_AT_CMD_POSTCNT_POST_IDLE_NUM_Msk = 0xffff

	// AT_CMD_GAPTOUT: Timeout configuration
	// Position of RX_GAP_TOUT field.
	UART_AT_CMD_GAPTOUT_RX_GAP_TOUT_Pos = 0x0
	// Bit mask of RX_GAP_TOUT field.
	UART_AT_CMD_GAPTOUT_RX_GAP_TOUT_Msk = 0xffff

	// AT_CMD_CHAR: AT escape sequence detection configuration
	// Position of AT_CMD_CHAR field.
	UART_AT_CMD_CHAR_AT_CMD_CHAR_Pos = 0x0
	// Bit mask of AT_CMD_CHAR field.
	UART_AT_CMD_CHAR_AT_CMD_CHAR_Msk = 0xff
	// Position of CHAR_NUM field.
	UART_AT_CMD_CHAR_CHAR_NUM_Pos = 0x8
	// Bit mask of CHAR_NUM field.
	UART_AT_CMD_CHAR_CHAR_NUM_Msk = 0xff00

	// MEM_CONF: UART threshold and allocation configuration
	// Position of RX_SIZE field.
	UART_MEM_CONF_RX_SIZE_Pos = 0x1
	// Bit mask of RX_SIZE field.
	UART_MEM_CONF_RX_SIZE_Msk = 0xe
	// Position of TX_SIZE field.
	UART_MEM_CONF_TX_SIZE_Pos = 0x4
	// Bit mask of TX_SIZE field.
	UART_MEM_CONF_TX_SIZE_Msk = 0x70
	// Position of RX_FLOW_THRHD field.
	UART_MEM_CONF_RX_FLOW_THRHD_Pos = 0x7
	// Bit mask of RX_FLOW_THRHD field.
	UART_MEM_CONF_RX_FLOW_THRHD_Msk = 0xff80
	// Position of RX_TOUT_THRHD field.
	UART_MEM_CONF_RX_TOUT_THRHD_Pos = 0x10
	// Bit mask of RX_TOUT_THRHD field.
	UART_MEM_CONF_RX_TOUT_THRHD_Msk = 0x3ff0000
	// Position of MEM_FORCE_PD field.
	UART_MEM_CONF_MEM_FORCE_PD_Pos = 0x1a
	// Bit mask of MEM_FORCE_PD field.
	UART_MEM_CONF_MEM_FORCE_PD_Msk = 0x4000000
	// Bit MEM_FORCE_PD.
	UART_MEM_CONF_MEM_FORCE_PD = 0x4000000
	// Position of MEM_FORCE_PU field.
	UART_MEM_CONF_MEM_FORCE_PU_Pos = 0x1b
	// Bit mask of MEM_FORCE_PU field.
	UART_MEM_CONF_MEM_FORCE_PU_Msk = 0x8000000
	// Bit MEM_FORCE_PU.
	UART_MEM_CONF_MEM_FORCE_PU = 0x8000000

	// MEM_TX_STATUS: Tx-FIFO write and read offset address.
	// Position of APB_TX_WADDR field.
	UART_MEM_TX_STATUS_APB_TX_WADDR_Pos = 0x0
	// Bit mask of APB_TX_WADDR field.
	UART_MEM_TX_STATUS_APB_TX_WADDR_Msk = 0x3ff
	// Position of TX_RADDR field.
	UART_MEM_TX_STATUS_TX_RADDR_Pos = 0xb
	// Bit mask of TX_RADDR field.
	UART_MEM_TX_STATUS_TX_RADDR_Msk = 0x1ff800

	// MEM_RX_STATUS: Rx-FIFO write and read offset address.
	// Position of APB_RX_RADDR field.
	UART_MEM_RX_STATUS_APB_RX_RADDR_Pos = 0x0
	// Bit mask of APB_RX_RADDR field.
	UART_MEM_RX_STATUS_APB_RX_RADDR_Msk = 0x3ff
	// Position of RX_WADDR field.
	UART_MEM_RX_STATUS_RX_WADDR_Pos = 0xb
	// Bit mask of RX_WADDR field.
	UART_MEM_RX_STATUS_RX_WADDR_Msk = 0x1ff800

	// FSM_STATUS: UART transmit and receive status.
	// Position of ST_URX_OUT field.
	UART_FSM_STATUS_ST_URX_OUT_Pos = 0x0
	// Bit mask of ST_URX_OUT field.
	UART_FSM_STATUS_ST_URX_OUT_Msk = 0xf
	// Position of ST_UTX_OUT field.
	UART_FSM_STATUS_ST_UTX_OUT_Pos = 0x4
	// Bit mask of ST_UTX_OUT field.
	UART_FSM_STATUS_ST_UTX_OUT_Msk = 0xf0

	// POSPULSE: Autobaud high pulse register
	// Position of POSEDGE_MIN_CNT field.
	UART_POSPULSE_POSEDGE_MIN_CNT_Pos = 0x0
	// Bit mask of POSEDGE_MIN_CNT field.
	UART_POSPULSE_POSEDGE_MIN_CNT_Msk = 0xfff

	// NEGPULSE: Autobaud low pulse register
	// Position of NEGEDGE_MIN_CNT field.
	UART_NEGPULSE_NEGEDGE_MIN_CNT_Pos = 0x0
	// Bit mask of NEGEDGE_MIN_CNT field.
	UART_NEGPULSE_NEGEDGE_MIN_CNT_Msk = 0xfff

	// CLK_CONF: UART core clock configuration
	// Position of SCLK_DIV_B field.
	UART_CLK_CONF_SCLK_DIV_B_Pos = 0x0
	// Bit mask of SCLK_DIV_B field.
	UART_CLK_CONF_SCLK_DIV_B_Msk = 0x3f
	// Position of SCLK_DIV_A field.
	UART_CLK_CONF_SCLK_DIV_A_Pos = 0x6
	// Bit mask of SCLK_DIV_A field.
	UART_CLK_CONF_SCLK_DIV_A_Msk = 0xfc0
	// Position of SCLK_DIV_NUM field.
	UART_CLK_CONF_SCLK_DIV_NUM_Pos = 0xc
	// Bit mask of SCLK_DIV_NUM field.
	UART_CLK_CONF_SCLK_DIV_NUM_Msk = 0xff000
	// Position of SCLK_SEL field.
	UART_CLK_CONF_SCLK_SEL_Pos = 0x14
	// Bit mask of SCLK_SEL field.
	UART_CLK_CONF_SCLK_SEL_Msk = 0x300000
	// Position of SCLK_EN field.
	UART_CLK_CONF_SCLK_EN_Pos = 0x16
	// Bit mask of SCLK_EN field.
	UART_CLK_CONF_SCLK_EN_Msk = 0x400000
	// Bit SCLK_EN.
	UART_CLK_CONF_SCLK_EN = 0x400000
	// Position of RST_CORE field.
	UART_CLK_CONF_RST_CORE_Pos = 0x17
	// Bit mask of RST_CORE field.
	UART_CLK_CONF_RST_CORE_Msk = 0x800000
	// Bit RST_CORE.
	UART_CLK_CONF_RST_CORE = 0x800000
	// Position of TX_SCLK_EN field.
	UART_CLK_CONF_TX_SCLK_EN_Pos = 0x18
	// Bit mask of TX_SCLK_EN field.
	UART_CLK_CONF_TX_SCLK_EN_Msk = 0x1000000
	// Bit TX_SCLK_EN.
	UART_CLK_CONF_TX_SCLK_EN = 0x1000000
	// Position of RX_SCLK_EN field.
	UART_CLK_CONF_RX_SCLK_EN_Pos = 0x19
	// Bit mask of RX_SCLK_EN field.
	UART_CLK_CONF_RX_SCLK_EN_Msk = 0x2000000
	// Bit RX_SCLK_EN.
	UART_CLK_CONF_RX_SCLK_EN = 0x2000000
	// Position of TX_RST_CORE field.
	UART_CLK_CONF_TX_RST_CORE_Pos = 0x1a
	// Bit mask of TX_RST_CORE field.
	UART_CLK_CONF_TX_RST_CORE_Msk = 0x4000000
	// Bit TX_RST_CORE.
	UART_CLK_CONF_TX_RST_CORE = 0x4000000
	// Position of RX_RST_CORE field.
	UART_CLK_CONF_RX_RST_CORE_Pos = 0x1b
	// Bit mask of RX_RST_CORE field.
	UART_CLK_CONF_RX_RST_CORE_Msk = 0x8000000
	// Bit RX_RST_CORE.
	UART_CLK_CONF_RX_RST_CORE = 0x8000000

	// DATE: UART Version register
	// Position of DATE field.
	UART_DATE_DATE_Pos = 0x0
	// Bit mask of DATE field.
	UART_DATE_DATE_Msk = 0xffffffff

	// ID: UART ID register
	// Position of ID field.
	UART_ID_ID_Pos = 0x0
	// Bit mask of ID field.
	UART_ID_ID_Msk = 0x3fffffff
	// Position of HIGH_SPEED field.
	UART_ID_HIGH_SPEED_Pos = 0x1e
	// Bit mask of HIGH_SPEED field.
	UART_ID_HIGH_SPEED_Msk = 0x40000000
	// Bit HIGH_SPEED.
	UART_ID_HIGH_SPEED = 0x40000000
	// Position of REG_UPDATE field.
	UART_ID_REG_UPDATE_Pos = 0x1f
	// Bit mask of REG_UPDATE field.
	UART_ID_REG_UPDATE_Msk = 0x80000000
	// Bit REG_UPDATE.
	UART_ID_REG_UPDATE = 0x80000000
)

// Constants for UHCI0: Peripheral UHCI
const (
	// CONF0: a
	// Position of TX_RST field.
	UHCI_CONF0_TX_RST_Pos = 0x0
	// Bit mask of TX_RST field.
	UHCI_CONF0_TX_RST_Msk = 0x1
	// Bit TX_RST.
	UHCI_CONF0_TX_RST = 0x1
	// Position of RX_RST field.
	UHCI_CONF0_RX_RST_Pos = 0x1
	// Bit mask of RX_RST field.
	UHCI_CONF0_RX_RST_Msk = 0x2
	// Bit RX_RST.
	UHCI_CONF0_RX_RST = 0x2
	// Position of UART0_CE field.
	UHCI_CONF0_UART0_CE_Pos = 0x2
	// Bit mask of UART0_CE field.
	UHCI_CONF0_UART0_CE_Msk = 0x4
	// Bit UART0_CE.
	UHCI_CONF0_UART0_CE = 0x4
	// Position of UART1_CE field.
	UHCI_CONF0_UART1_CE_Pos = 0x3
	// Bit mask of UART1_CE field.
	UHCI_CONF0_UART1_CE_Msk = 0x8
	// Bit UART1_CE.
	UHCI_CONF0_UART1_CE = 0x8
	// Position of SEPER_EN field.
	UHCI_CONF0_SEPER_EN_Pos = 0x5
	// Bit mask of SEPER_EN field.
	UHCI_CONF0_SEPER_EN_Msk = 0x20
	// Bit SEPER_EN.
	UHCI_CONF0_SEPER_EN = 0x20
	// Position of HEAD_EN field.
	UHCI_CONF0_HEAD_EN_Pos = 0x6
	// Bit mask of HEAD_EN field.
	UHCI_CONF0_HEAD_EN_Msk = 0x40
	// Bit HEAD_EN.
	UHCI_CONF0_HEAD_EN = 0x40
	// Position of CRC_REC_EN field.
	UHCI_CONF0_CRC_REC_EN_Pos = 0x7
	// Bit mask of CRC_REC_EN field.
	UHCI_CONF0_CRC_REC_EN_Msk = 0x80
	// Bit CRC_REC_EN.
	UHCI_CONF0_CRC_REC_EN = 0x80
	// Position of UART_IDLE_EOF_EN field.
	UHCI_CONF0_UART_IDLE_EOF_EN_Pos = 0x8
	// Bit mask of UART_IDLE_EOF_EN field.
	UHCI_CONF0_UART_IDLE_EOF_EN_Msk = 0x100
	// Bit UART_IDLE_EOF_EN.
	UHCI_CONF0_UART_IDLE_EOF_EN = 0x100
	// Position of LEN_EOF_EN field.
	UHCI_CONF0_LEN_EOF_EN_Pos = 0x9
	// Bit mask of LEN_EOF_EN field.
	UHCI_CONF0_LEN_EOF_EN_Msk = 0x200
	// Bit LEN_EOF_EN.
	UHCI_CONF0_LEN_EOF_EN = 0x200
	// Position of ENCODE_CRC_EN field.
	UHCI_CONF0_ENCODE_CRC_EN_Pos = 0xa
	// Bit mask of ENCODE_CRC_EN field.
	UHCI_CONF0_ENCODE_CRC_EN_Msk = 0x400
	// Bit ENCODE_CRC_EN.
	UHCI_CONF0_ENCODE_CRC_EN = 0x400
	// Position of CLK_EN field.
	UHCI_CONF0_CLK_EN_Pos = 0xb
	// Bit mask of CLK_EN field.
	UHCI_CONF0_CLK_EN_Msk = 0x800
	// Bit CLK_EN.
	UHCI_CONF0_CLK_EN = 0x800
	// Position of UART_RX_BRK_EOF_EN field.
	UHCI_CONF0_UART_RX_BRK_EOF_EN_Pos = 0xc
	// Bit mask of UART_RX_BRK_EOF_EN field.
	UHCI_CONF0_UART_RX_BRK_EOF_EN_Msk = 0x1000
	// Bit UART_RX_BRK_EOF_EN.
	UHCI_CONF0_UART_RX_BRK_EOF_EN = 0x1000

	// INT_RAW: a
	// Position of RX_START_INT_RAW field.
	UHCI_INT_RAW_RX_START_INT_RAW_Pos = 0x0
	// Bit mask of RX_START_INT_RAW field.
	UHCI_INT_RAW_RX_START_INT_RAW_Msk = 0x1
	// Bit RX_START_INT_RAW.
	UHCI_INT_RAW_RX_START_INT_RAW = 0x1
	// Position of TX_START_INT_RAW field.
	UHCI_INT_RAW_TX_START_INT_RAW_Pos = 0x1
	// Bit mask of TX_START_INT_RAW field.
	UHCI_INT_RAW_TX_START_INT_RAW_Msk = 0x2
	// Bit TX_START_INT_RAW.
	UHCI_INT_RAW_TX_START_INT_RAW = 0x2
	// Position of RX_HUNG_INT_RAW field.
	UHCI_INT_RAW_RX_HUNG_INT_RAW_Pos = 0x2
	// Bit mask of RX_HUNG_INT_RAW field.
	UHCI_INT_RAW_RX_HUNG_INT_RAW_Msk = 0x4
	// Bit RX_HUNG_INT_RAW.
	UHCI_INT_RAW_RX_HUNG_INT_RAW = 0x4
	// Position of TX_HUNG_INT_RAW field.
	UHCI_INT_RAW_TX_HUNG_INT_RAW_Pos = 0x3
	// Bit mask of TX_HUNG_INT_RAW field.
	UHCI_INT_RAW_TX_HUNG_INT_RAW_Msk = 0x8
	// Bit TX_HUNG_INT_RAW.
	UHCI_INT_RAW_TX_HUNG_INT_RAW = 0x8
	// Position of SEND_S_REG_Q_INT_RAW field.
	UHCI_INT_RAW_SEND_S_REG_Q_INT_RAW_Pos = 0x4
	// Bit mask of SEND_S_REG_Q_INT_RAW field.
	UHCI_INT_RAW_SEND_S_REG_Q_INT_RAW_Msk = 0x10
	// Bit SEND_S_REG_Q_INT_RAW.
	UHCI_INT_RAW_SEND_S_REG_Q_INT_RAW = 0x10
	// Position of SEND_A_REG_Q_INT_RAW field.
	UHCI_INT_RAW_SEND_A_REG_Q_INT_RAW_Pos = 0x5
	// Bit mask of SEND_A_REG_Q_INT_RAW field.
	UHCI_INT_RAW_SEND_A_REG_Q_INT_RAW_Msk = 0x20
	// Bit SEND_A_REG_Q_INT_RAW.
	UHCI_INT_RAW_SEND_A_REG_Q_INT_RAW = 0x20
	// Position of OUT_EOF_INT_RAW field.
	UHCI_INT_RAW_OUT_EOF_INT_RAW_Pos = 0x6
	// Bit mask of OUT_EOF_INT_RAW field.
	UHCI_INT_RAW_OUT_EOF_INT_RAW_Msk = 0x40
	// Bit OUT_EOF_INT_RAW.
	UHCI_INT_RAW_OUT_EOF_INT_RAW = 0x40
	// Position of APP_CTRL0_INT_RAW field.
	UHCI_INT_RAW_APP_CTRL0_INT_RAW_Pos = 0x7
	// Bit mask of APP_CTRL0_INT_RAW field.
	UHCI_INT_RAW_APP_CTRL0_INT_RAW_Msk = 0x80
	// Bit APP_CTRL0_INT_RAW.
	UHCI_INT_RAW_APP_CTRL0_INT_RAW = 0x80
	// Position of APP_CTRL1_INT_RAW field.
	UHCI_INT_RAW_APP_CTRL1_INT_RAW_Pos = 0x8
	// Bit mask of APP_CTRL1_INT_RAW field.
	UHCI_INT_RAW_APP_CTRL1_INT_RAW_Msk = 0x100
	// Bit APP_CTRL1_INT_RAW.
	UHCI_INT_RAW_APP_CTRL1_INT_RAW = 0x100

	// INT_ST: a
	// Position of RX_START_INT_ST field.
	UHCI_INT_ST_RX_START_INT_ST_Pos = 0x0
	// Bit mask of RX_START_INT_ST field.
	UHCI_INT_ST_RX_START_INT_ST_Msk = 0x1
	// Bit RX_START_INT_ST.
	UHCI_INT_ST_RX_START_INT_ST = 0x1
	// Position of TX_START_INT_ST field.
	UHCI_INT_ST_TX_START_INT_ST_Pos = 0x1
	// Bit mask of TX_START_INT_ST field.
	UHCI_INT_ST_TX_START_INT_ST_Msk = 0x2
	// Bit TX_START_INT_ST.
	UHCI_INT_ST_TX_START_INT_ST = 0x2
	// Position of RX_HUNG_INT_ST field.
	UHCI_INT_ST_RX_HUNG_INT_ST_Pos = 0x2
	// Bit mask of RX_HUNG_INT_ST field.
	UHCI_INT_ST_RX_HUNG_INT_ST_Msk = 0x4
	// Bit RX_HUNG_INT_ST.
	UHCI_INT_ST_RX_HUNG_INT_ST = 0x4
	// Position of TX_HUNG_INT_ST field.
	UHCI_INT_ST_TX_HUNG_INT_ST_Pos = 0x3
	// Bit mask of TX_HUNG_INT_ST field.
	UHCI_INT_ST_TX_HUNG_INT_ST_Msk = 0x8
	// Bit TX_HUNG_INT_ST.
	UHCI_INT_ST_TX_HUNG_INT_ST = 0x8
	// Position of SEND_S_REG_Q_INT_ST field.
	UHCI_INT_ST_SEND_S_REG_Q_INT_ST_Pos = 0x4
	// Bit mask of SEND_S_REG_Q_INT_ST field.
	UHCI_INT_ST_SEND_S_REG_Q_INT_ST_Msk = 0x10
	// Bit SEND_S_REG_Q_INT_ST.
	UHCI_INT_ST_SEND_S_REG_Q_INT_ST = 0x10
	// Position of SEND_A_REG_Q_INT_ST field.
	UHCI_INT_ST_SEND_A_REG_Q_INT_ST_Pos = 0x5
	// Bit mask of SEND_A_REG_Q_INT_ST field.
	UHCI_INT_ST_SEND_A_REG_Q_INT_ST_Msk = 0x20
	// Bit SEND_A_REG_Q_INT_ST.
	UHCI_INT_ST_SEND_A_REG_Q_INT_ST = 0x20
	// Position of OUTLINK_EOF_ERR_INT_ST field.
	UHCI_INT_ST_OUTLINK_EOF_ERR_INT_ST_Pos = 0x6
	// Bit mask of OUTLINK_EOF_ERR_INT_ST field.
	UHCI_INT_ST_OUTLINK_EOF_ERR_INT_ST_Msk = 0x40
	// Bit OUTLINK_EOF_ERR_INT_ST.
	UHCI_INT_ST_OUTLINK_EOF_ERR_INT_ST = 0x40
	// Position of APP_CTRL0_INT_ST field.
	UHCI_INT_ST_APP_CTRL0_INT_ST_Pos = 0x7
	// Bit mask of APP_CTRL0_INT_ST field.
	UHCI_INT_ST_APP_CTRL0_INT_ST_Msk = 0x80
	// Bit APP_CTRL0_INT_ST.
	UHCI_INT_ST_APP_CTRL0_INT_ST = 0x80
	// Position of APP_CTRL1_INT_ST field.
	UHCI_INT_ST_APP_CTRL1_INT_ST_Pos = 0x8
	// Bit mask of APP_CTRL1_INT_ST field.
	UHCI_INT_ST_APP_CTRL1_INT_ST_Msk = 0x100
	// Bit APP_CTRL1_INT_ST.
	UHCI_INT_ST_APP_CTRL1_INT_ST = 0x100

	// INT_ENA: a
	// Position of RX_START_INT_ENA field.
	UHCI_INT_ENA_RX_START_INT_ENA_Pos = 0x0
	// Bit mask of RX_START_INT_ENA field.
	UHCI_INT_ENA_RX_START_INT_ENA_Msk = 0x1
	// Bit RX_START_INT_ENA.
	UHCI_INT_ENA_RX_START_INT_ENA = 0x1
	// Position of TX_START_INT_ENA field.
	UHCI_INT_ENA_TX_START_INT_ENA_Pos = 0x1
	// Bit mask of TX_START_INT_ENA field.
	UHCI_INT_ENA_TX_START_INT_ENA_Msk = 0x2
	// Bit TX_START_INT_ENA.
	UHCI_INT_ENA_TX_START_INT_ENA = 0x2
	// Position of RX_HUNG_INT_ENA field.
	UHCI_INT_ENA_RX_HUNG_INT_ENA_Pos = 0x2
	// Bit mask of RX_HUNG_INT_ENA field.
	UHCI_INT_ENA_RX_HUNG_INT_ENA_Msk = 0x4
	// Bit RX_HUNG_INT_ENA.
	UHCI_INT_ENA_RX_HUNG_INT_ENA = 0x4
	// Position of TX_HUNG_INT_ENA field.
	UHCI_INT_ENA_TX_HUNG_INT_ENA_Pos = 0x3
	// Bit mask of TX_HUNG_INT_ENA field.
	UHCI_INT_ENA_TX_HUNG_INT_ENA_Msk = 0x8
	// Bit TX_HUNG_INT_ENA.
	UHCI_INT_ENA_TX_HUNG_INT_ENA = 0x8
	// Position of SEND_S_REG_Q_INT_ENA field.
	UHCI_INT_ENA_SEND_S_REG_Q_INT_ENA_Pos = 0x4
	// Bit mask of SEND_S_REG_Q_INT_ENA field.
	UHCI_INT_ENA_SEND_S_REG_Q_INT_ENA_Msk = 0x10
	// Bit SEND_S_REG_Q_INT_ENA.
	UHCI_INT_ENA_SEND_S_REG_Q_INT_ENA = 0x10
	// Position of SEND_A_REG_Q_INT_ENA field.
	UHCI_INT_ENA_SEND_A_REG_Q_INT_ENA_Pos = 0x5
	// Bit mask of SEND_A_REG_Q_INT_ENA field.
	UHCI_INT_ENA_SEND_A_REG_Q_INT_ENA_Msk = 0x20
	// Bit SEND_A_REG_Q_INT_ENA.
	UHCI_INT_ENA_SEND_A_REG_Q_INT_ENA = 0x20
	// Position of OUTLINK_EOF_ERR_INT_ENA field.
	UHCI_INT_ENA_OUTLINK_EOF_ERR_INT_ENA_Pos = 0x6
	// Bit mask of OUTLINK_EOF_ERR_INT_ENA field.
	UHCI_INT_ENA_OUTLINK_EOF_ERR_INT_ENA_Msk = 0x40
	// Bit OUTLINK_EOF_ERR_INT_ENA.
	UHCI_INT_ENA_OUTLINK_EOF_ERR_INT_ENA = 0x40
	// Position of APP_CTRL0_INT_ENA field.
	UHCI_INT_ENA_APP_CTRL0_INT_ENA_Pos = 0x7
	// Bit mask of APP_CTRL0_INT_ENA field.
	UHCI_INT_ENA_APP_CTRL0_INT_ENA_Msk = 0x80
	// Bit APP_CTRL0_INT_ENA.
	UHCI_INT_ENA_APP_CTRL0_INT_ENA = 0x80
	// Position of APP_CTRL1_INT_ENA field.
	UHCI_INT_ENA_APP_CTRL1_INT_ENA_Pos = 0x8
	// Bit mask of APP_CTRL1_INT_ENA field.
	UHCI_INT_ENA_APP_CTRL1_INT_ENA_Msk = 0x100
	// Bit APP_CTRL1_INT_ENA.
	UHCI_INT_ENA_APP_CTRL1_INT_ENA = 0x100

	// INT_CLR: a
	// Position of RX_START_INT_CLR field.
	UHCI_INT_CLR_RX_START_INT_CLR_Pos = 0x0
	// Bit mask of RX_START_INT_CLR field.
	UHCI_INT_CLR_RX_START_INT_CLR_Msk = 0x1
	// Bit RX_START_INT_CLR.
	UHCI_INT_CLR_RX_START_INT_CLR = 0x1
	// Position of TX_START_INT_CLR field.
	UHCI_INT_CLR_TX_START_INT_CLR_Pos = 0x1
	// Bit mask of TX_START_INT_CLR field.
	UHCI_INT_CLR_TX_START_INT_CLR_Msk = 0x2
	// Bit TX_START_INT_CLR.
	UHCI_INT_CLR_TX_START_INT_CLR = 0x2
	// Position of RX_HUNG_INT_CLR field.
	UHCI_INT_CLR_RX_HUNG_INT_CLR_Pos = 0x2
	// Bit mask of RX_HUNG_INT_CLR field.
	UHCI_INT_CLR_RX_HUNG_INT_CLR_Msk = 0x4
	// Bit RX_HUNG_INT_CLR.
	UHCI_INT_CLR_RX_HUNG_INT_CLR = 0x4
	// Position of TX_HUNG_INT_CLR field.
	UHCI_INT_CLR_TX_HUNG_INT_CLR_Pos = 0x3
	// Bit mask of TX_HUNG_INT_CLR field.
	UHCI_INT_CLR_TX_HUNG_INT_CLR_Msk = 0x8
	// Bit TX_HUNG_INT_CLR.
	UHCI_INT_CLR_TX_HUNG_INT_CLR = 0x8
	// Position of SEND_S_REG_Q_INT_CLR field.
	UHCI_INT_CLR_SEND_S_REG_Q_INT_CLR_Pos = 0x4
	// Bit mask of SEND_S_REG_Q_INT_CLR field.
	UHCI_INT_CLR_SEND_S_REG_Q_INT_CLR_Msk = 0x10
	// Bit SEND_S_REG_Q_INT_CLR.
	UHCI_INT_CLR_SEND_S_REG_Q_INT_CLR = 0x10
	// Position of SEND_A_REG_Q_INT_CLR field.
	UHCI_INT_CLR_SEND_A_REG_Q_INT_CLR_Pos = 0x5
	// Bit mask of SEND_A_REG_Q_INT_CLR field.
	UHCI_INT_CLR_SEND_A_REG_Q_INT_CLR_Msk = 0x20
	// Bit SEND_A_REG_Q_INT_CLR.
	UHCI_INT_CLR_SEND_A_REG_Q_INT_CLR = 0x20
	// Position of OUTLINK_EOF_ERR_INT_CLR field.
	UHCI_INT_CLR_OUTLINK_EOF_ERR_INT_CLR_Pos = 0x6
	// Bit mask of OUTLINK_EOF_ERR_INT_CLR field.
	UHCI_INT_CLR_OUTLINK_EOF_ERR_INT_CLR_Msk = 0x40
	// Bit OUTLINK_EOF_ERR_INT_CLR.
	UHCI_INT_CLR_OUTLINK_EOF_ERR_INT_CLR = 0x40
	// Position of APP_CTRL0_INT_CLR field.
	UHCI_INT_CLR_APP_CTRL0_INT_CLR_Pos = 0x7
	// Bit mask of APP_CTRL0_INT_CLR field.
	UHCI_INT_CLR_APP_CTRL0_INT_CLR_Msk = 0x80
	// Bit APP_CTRL0_INT_CLR.
	UHCI_INT_CLR_APP_CTRL0_INT_CLR = 0x80
	// Position of APP_CTRL1_INT_CLR field.
	UHCI_INT_CLR_APP_CTRL1_INT_CLR_Pos = 0x8
	// Bit mask of APP_CTRL1_INT_CLR field.
	UHCI_INT_CLR_APP_CTRL1_INT_CLR_Msk = 0x100
	// Bit APP_CTRL1_INT_CLR.
	UHCI_INT_CLR_APP_CTRL1_INT_CLR = 0x100

	// CONF1: a
	// Position of CHECK_SUM_EN field.
	UHCI_CONF1_CHECK_SUM_EN_Pos = 0x0
	// Bit mask of CHECK_SUM_EN field.
	UHCI_CONF1_CHECK_SUM_EN_Msk = 0x1
	// Bit CHECK_SUM_EN.
	UHCI_CONF1_CHECK_SUM_EN = 0x1
	// Position of CHECK_SEQ_EN field.
	UHCI_CONF1_CHECK_SEQ_EN_Pos = 0x1
	// Bit mask of CHECK_SEQ_EN field.
	UHCI_CONF1_CHECK_SEQ_EN_Msk = 0x2
	// Bit CHECK_SEQ_EN.
	UHCI_CONF1_CHECK_SEQ_EN = 0x2
	// Position of CRC_DISABLE field.
	UHCI_CONF1_CRC_DISABLE_Pos = 0x2
	// Bit mask of CRC_DISABLE field.
	UHCI_CONF1_CRC_DISABLE_Msk = 0x4
	// Bit CRC_DISABLE.
	UHCI_CONF1_CRC_DISABLE = 0x4
	// Position of SAVE_HEAD field.
	UHCI_CONF1_SAVE_HEAD_Pos = 0x3
	// Bit mask of SAVE_HEAD field.
	UHCI_CONF1_SAVE_HEAD_Msk = 0x8
	// Bit SAVE_HEAD.
	UHCI_CONF1_SAVE_HEAD = 0x8
	// Position of TX_CHECK_SUM_RE field.
	UHCI_CONF1_TX_CHECK_SUM_RE_Pos = 0x4
	// Bit mask of TX_CHECK_SUM_RE field.
	UHCI_CONF1_TX_CHECK_SUM_RE_Msk = 0x10
	// Bit TX_CHECK_SUM_RE.
	UHCI_CONF1_TX_CHECK_SUM_RE = 0x10
	// Position of TX_ACK_NUM_RE field.
	UHCI_CONF1_TX_ACK_NUM_RE_Pos = 0x5
	// Bit mask of TX_ACK_NUM_RE field.
	UHCI_CONF1_TX_ACK_NUM_RE_Msk = 0x20
	// Bit TX_ACK_NUM_RE.
	UHCI_CONF1_TX_ACK_NUM_RE = 0x20
	// Position of WAIT_SW_START field.
	UHCI_CONF1_WAIT_SW_START_Pos = 0x7
	// Bit mask of WAIT_SW_START field.
	UHCI_CONF1_WAIT_SW_START_Msk = 0x80
	// Bit WAIT_SW_START.
	UHCI_CONF1_WAIT_SW_START = 0x80
	// Position of SW_START field.
	UHCI_CONF1_SW_START_Pos = 0x8
	// Bit mask of SW_START field.
	UHCI_CONF1_SW_START_Msk = 0x100
	// Bit SW_START.
	UHCI_CONF1_SW_START = 0x100

	// STATE0: a
	// Position of RX_ERR_CAUSE field.
	UHCI_STATE0_RX_ERR_CAUSE_Pos = 0x0
	// Bit mask of RX_ERR_CAUSE field.
	UHCI_STATE0_RX_ERR_CAUSE_Msk = 0x7
	// Position of DECODE_STATE field.
	UHCI_STATE0_DECODE_STATE_Pos = 0x3
	// Bit mask of DECODE_STATE field.
	UHCI_STATE0_DECODE_STATE_Msk = 0x38

	// STATE1: a
	// Position of ENCODE_STATE field.
	UHCI_STATE1_ENCODE_STATE_Pos = 0x0
	// Bit mask of ENCODE_STATE field.
	UHCI_STATE1_ENCODE_STATE_Msk = 0x7

	// ESCAPE_CONF: a
	// Position of TX_C0_ESC_EN field.
	UHCI_ESCAPE_CONF_TX_C0_ESC_EN_Pos = 0x0
	// Bit mask of TX_C0_ESC_EN field.
	UHCI_ESCAPE_CONF_TX_C0_ESC_EN_Msk = 0x1
	// Bit TX_C0_ESC_EN.
	UHCI_ESCAPE_CONF_TX_C0_ESC_EN = 0x1
	// Position of TX_DB_ESC_EN field.
	UHCI_ESCAPE_CONF_TX_DB_ESC_EN_Pos = 0x1
	// Bit mask of TX_DB_ESC_EN field.
	UHCI_ESCAPE_CONF_TX_DB_ESC_EN_Msk = 0x2
	// Bit TX_DB_ESC_EN.
	UHCI_ESCAPE_CONF_TX_DB_ESC_EN = 0x2
	// Position of TX_11_ESC_EN field.
	UHCI_ESCAPE_CONF_TX_11_ESC_EN_Pos = 0x2
	// Bit mask of TX_11_ESC_EN field.
	UHCI_ESCAPE_CONF_TX_11_ESC_EN_Msk = 0x4
	// Bit TX_11_ESC_EN.
	UHCI_ESCAPE_CONF_TX_11_ESC_EN = 0x4
	// Position of TX_13_ESC_EN field.
	UHCI_ESCAPE_CONF_TX_13_ESC_EN_Pos = 0x3
	// Bit mask of TX_13_ESC_EN field.
	UHCI_ESCAPE_CONF_TX_13_ESC_EN_Msk = 0x8
	// Bit TX_13_ESC_EN.
	UHCI_ESCAPE_CONF_TX_13_ESC_EN = 0x8
	// Position of RX_C0_ESC_EN field.
	UHCI_ESCAPE_CONF_RX_C0_ESC_EN_Pos = 0x4
	// Bit mask of RX_C0_ESC_EN field.
	UHCI_ESCAPE_CONF_RX_C0_ESC_EN_Msk = 0x10
	// Bit RX_C0_ESC_EN.
	UHCI_ESCAPE_CONF_RX_C0_ESC_EN = 0x10
	// Position of RX_DB_ESC_EN field.
	UHCI_ESCAPE_CONF_RX_DB_ESC_EN_Pos = 0x5
	// Bit mask of RX_DB_ESC_EN field.
	UHCI_ESCAPE_CONF_RX_DB_ESC_EN_Msk = 0x20
	// Bit RX_DB_ESC_EN.
	UHCI_ESCAPE_CONF_RX_DB_ESC_EN = 0x20
	// Position of RX_11_ESC_EN field.
	UHCI_ESCAPE_CONF_RX_11_ESC_EN_Pos = 0x6
	// Bit mask of RX_11_ESC_EN field.
	UHCI_ESCAPE_CONF_RX_11_ESC_EN_Msk = 0x40
	// Bit RX_11_ESC_EN.
	UHCI_ESCAPE_CONF_RX_11_ESC_EN = 0x40
	// Position of RX_13_ESC_EN field.
	UHCI_ESCAPE_CONF_RX_13_ESC_EN_Pos = 0x7
	// Bit mask of RX_13_ESC_EN field.
	UHCI_ESCAPE_CONF_RX_13_ESC_EN_Msk = 0x80
	// Bit RX_13_ESC_EN.
	UHCI_ESCAPE_CONF_RX_13_ESC_EN = 0x80

	// HUNG_CONF: a
	// Position of TXFIFO_TIMEOUT field.
	UHCI_HUNG_CONF_TXFIFO_TIMEOUT_Pos = 0x0
	// Bit mask of TXFIFO_TIMEOUT field.
	UHCI_HUNG_CONF_TXFIFO_TIMEOUT_Msk = 0xff
	// Position of TXFIFO_TIMEOUT_SHIFT field.
	UHCI_HUNG_CONF_TXFIFO_TIMEOUT_SHIFT_Pos = 0x8
	// Bit mask of TXFIFO_TIMEOUT_SHIFT field.
	UHCI_HUNG_CONF_TXFIFO_TIMEOUT_SHIFT_Msk = 0x700
	// Position of TXFIFO_TIMEOUT_ENA field.
	UHCI_HUNG_CONF_TXFIFO_TIMEOUT_ENA_Pos = 0xb
	// Bit mask of TXFIFO_TIMEOUT_ENA field.
	UHCI_HUNG_CONF_TXFIFO_TIMEOUT_ENA_Msk = 0x800
	// Bit TXFIFO_TIMEOUT_ENA.
	UHCI_HUNG_CONF_TXFIFO_TIMEOUT_ENA = 0x800
	// Position of RXFIFO_TIMEOUT field.
	UHCI_HUNG_CONF_RXFIFO_TIMEOUT_Pos = 0xc
	// Bit mask of RXFIFO_TIMEOUT field.
	UHCI_HUNG_CONF_RXFIFO_TIMEOUT_Msk = 0xff000
	// Position of RXFIFO_TIMEOUT_SHIFT field.
	UHCI_HUNG_CONF_RXFIFO_TIMEOUT_SHIFT_Pos = 0x14
	// Bit mask of RXFIFO_TIMEOUT_SHIFT field.
	UHCI_HUNG_CONF_RXFIFO_TIMEOUT_SHIFT_Msk = 0x700000
	// Position of RXFIFO_TIMEOUT_ENA field.
	UHCI_HUNG_CONF_RXFIFO_TIMEOUT_ENA_Pos = 0x17
	// Bit mask of RXFIFO_TIMEOUT_ENA field.
	UHCI_HUNG_CONF_RXFIFO_TIMEOUT_ENA_Msk = 0x800000
	// Bit RXFIFO_TIMEOUT_ENA.
	UHCI_HUNG_CONF_RXFIFO_TIMEOUT_ENA = 0x800000

	// ACK_NUM: a
	// Position of ACK_NUM field.
	UHCI_ACK_NUM_ACK_NUM_Pos = 0x0
	// Bit mask of ACK_NUM field.
	UHCI_ACK_NUM_ACK_NUM_Msk = 0x7
	// Position of LOAD field.
	UHCI_ACK_NUM_LOAD_Pos = 0x3
	// Bit mask of LOAD field.
	UHCI_ACK_NUM_LOAD_Msk = 0x8
	// Bit LOAD.
	UHCI_ACK_NUM_LOAD = 0x8

	// RX_HEAD: a
	// Position of RX_HEAD field.
	UHCI_RX_HEAD_RX_HEAD_Pos = 0x0
	// Bit mask of RX_HEAD field.
	UHCI_RX_HEAD_RX_HEAD_Msk = 0xffffffff

	// QUICK_SENT: a
	// Position of SINGLE_SEND_NUM field.
	UHCI_QUICK_SENT_SINGLE_SEND_NUM_Pos = 0x0
	// Bit mask of SINGLE_SEND_NUM field.
	UHCI_QUICK_SENT_SINGLE_SEND_NUM_Msk = 0x7
	// Position of SINGLE_SEND_EN field.
	UHCI_QUICK_SENT_SINGLE_SEND_EN_Pos = 0x3
	// Bit mask of SINGLE_SEND_EN field.
	UHCI_QUICK_SENT_SINGLE_SEND_EN_Msk = 0x8
	// Bit SINGLE_SEND_EN.
	UHCI_QUICK_SENT_SINGLE_SEND_EN = 0x8
	// Position of ALWAYS_SEND_NUM field.
	UHCI_QUICK_SENT_ALWAYS_SEND_NUM_Pos = 0x4
	// Bit mask of ALWAYS_SEND_NUM field.
	UHCI_QUICK_SENT_ALWAYS_SEND_NUM_Msk = 0x70
	// Position of ALWAYS_SEND_EN field.
	UHCI_QUICK_SENT_ALWAYS_SEND_EN_Pos = 0x7
	// Bit mask of ALWAYS_SEND_EN field.
	UHCI_QUICK_SENT_ALWAYS_SEND_EN_Msk = 0x80
	// Bit ALWAYS_SEND_EN.
	UHCI_QUICK_SENT_ALWAYS_SEND_EN = 0x80

	// REG_Q0_WORD0: a
	// Position of SEND_Q0_WORD0 field.
	UHCI_REG_Q0_WORD0_SEND_Q0_WORD0_Pos = 0x0
	// Bit mask of SEND_Q0_WORD0 field.
	UHCI_REG_Q0_WORD0_SEND_Q0_WORD0_Msk = 0xffffffff

	// REG_Q0_WORD1: a
	// Position of SEND_Q0_WORD1 field.
	UHCI_REG_Q0_WORD1_SEND_Q0_WORD1_Pos = 0x0
	// Bit mask of SEND_Q0_WORD1 field.
	UHCI_REG_Q0_WORD1_SEND_Q0_WORD1_Msk = 0xffffffff

	// REG_Q1_WORD0: a
	// Position of SEND_Q1_WORD0 field.
	UHCI_REG_Q1_WORD0_SEND_Q1_WORD0_Pos = 0x0
	// Bit mask of SEND_Q1_WORD0 field.
	UHCI_REG_Q1_WORD0_SEND_Q1_WORD0_Msk = 0xffffffff

	// REG_Q1_WORD1: a
	// Position of SEND_Q1_WORD1 field.
	UHCI_REG_Q1_WORD1_SEND_Q1_WORD1_Pos = 0x0
	// Bit mask of SEND_Q1_WORD1 field.
	UHCI_REG_Q1_WORD1_SEND_Q1_WORD1_Msk = 0xffffffff

	// REG_Q2_WORD0: a
	// Position of SEND_Q2_WORD0 field.
	UHCI_REG_Q2_WORD0_SEND_Q2_WORD0_Pos = 0x0
	// Bit mask of SEND_Q2_WORD0 field.
	UHCI_REG_Q2_WORD0_SEND_Q2_WORD0_Msk = 0xffffffff

	// REG_Q2_WORD1: a
	// Position of SEND_Q2_WORD1 field.
	UHCI_REG_Q2_WORD1_SEND_Q2_WORD1_Pos = 0x0
	// Bit mask of SEND_Q2_WORD1 field.
	UHCI_REG_Q2_WORD1_SEND_Q2_WORD1_Msk = 0xffffffff

	// REG_Q3_WORD0: a
	// Position of SEND_Q3_WORD0 field.
	UHCI_REG_Q3_WORD0_SEND_Q3_WORD0_Pos = 0x0
	// Bit mask of SEND_Q3_WORD0 field.
	UHCI_REG_Q3_WORD0_SEND_Q3_WORD0_Msk = 0xffffffff

	// REG_Q3_WORD1: a
	// Position of SEND_Q3_WORD1 field.
	UHCI_REG_Q3_WORD1_SEND_Q3_WORD1_Pos = 0x0
	// Bit mask of SEND_Q3_WORD1 field.
	UHCI_REG_Q3_WORD1_SEND_Q3_WORD1_Msk = 0xffffffff

	// REG_Q4_WORD0: a
	// Position of SEND_Q4_WORD0 field.
	UHCI_REG_Q4_WORD0_SEND_Q4_WORD0_Pos = 0x0
	// Bit mask of SEND_Q4_WORD0 field.
	UHCI_REG_Q4_WORD0_SEND_Q4_WORD0_Msk = 0xffffffff

	// REG_Q4_WORD1: a
	// Position of SEND_Q4_WORD1 field.
	UHCI_REG_Q4_WORD1_SEND_Q4_WORD1_Pos = 0x0
	// Bit mask of SEND_Q4_WORD1 field.
	UHCI_REG_Q4_WORD1_SEND_Q4_WORD1_Msk = 0xffffffff

	// REG_Q5_WORD0: a
	// Position of SEND_Q5_WORD0 field.
	UHCI_REG_Q5_WORD0_SEND_Q5_WORD0_Pos = 0x0
	// Bit mask of SEND_Q5_WORD0 field.
	UHCI_REG_Q5_WORD0_SEND_Q5_WORD0_Msk = 0xffffffff

	// REG_Q5_WORD1: a
	// Position of SEND_Q5_WORD1 field.
	UHCI_REG_Q5_WORD1_SEND_Q5_WORD1_Pos = 0x0
	// Bit mask of SEND_Q5_WORD1 field.
	UHCI_REG_Q5_WORD1_SEND_Q5_WORD1_Msk = 0xffffffff

	// REG_Q6_WORD0: a
	// Position of SEND_Q6_WORD0 field.
	UHCI_REG_Q6_WORD0_SEND_Q6_WORD0_Pos = 0x0
	// Bit mask of SEND_Q6_WORD0 field.
	UHCI_REG_Q6_WORD0_SEND_Q6_WORD0_Msk = 0xffffffff

	// REG_Q6_WORD1: a
	// Position of SEND_Q6_WORD1 field.
	UHCI_REG_Q6_WORD1_SEND_Q6_WORD1_Pos = 0x0
	// Bit mask of SEND_Q6_WORD1 field.
	UHCI_REG_Q6_WORD1_SEND_Q6_WORD1_Msk = 0xffffffff

	// ESC_CONF0: a
	// Position of SEPER_CHAR field.
	UHCI_ESC_CONF0_SEPER_CHAR_Pos = 0x0
	// Bit mask of SEPER_CHAR field.
	UHCI_ESC_CONF0_SEPER_CHAR_Msk = 0xff
	// Position of SEPER_ESC_CHAR0 field.
	UHCI_ESC_CONF0_SEPER_ESC_CHAR0_Pos = 0x8
	// Bit mask of SEPER_ESC_CHAR0 field.
	UHCI_ESC_CONF0_SEPER_ESC_CHAR0_Msk = 0xff00
	// Position of SEPER_ESC_CHAR1 field.
	UHCI_ESC_CONF0_SEPER_ESC_CHAR1_Pos = 0x10
	// Bit mask of SEPER_ESC_CHAR1 field.
	UHCI_ESC_CONF0_SEPER_ESC_CHAR1_Msk = 0xff0000

	// ESC_CONF1: a
	// Position of ESC_SEQ0 field.
	UHCI_ESC_CONF1_ESC_SEQ0_Pos = 0x0
	// Bit mask of ESC_SEQ0 field.
	UHCI_ESC_CONF1_ESC_SEQ0_Msk = 0xff
	// Position of ESC_SEQ0_CHAR0 field.
	UHCI_ESC_CONF1_ESC_SEQ0_CHAR0_Pos = 0x8
	// Bit mask of ESC_SEQ0_CHAR0 field.
	UHCI_ESC_CONF1_ESC_SEQ0_CHAR0_Msk = 0xff00
	// Position of ESC_SEQ0_CHAR1 field.
	UHCI_ESC_CONF1_ESC_SEQ0_CHAR1_Pos = 0x10
	// Bit mask of ESC_SEQ0_CHAR1 field.
	UHCI_ESC_CONF1_ESC_SEQ0_CHAR1_Msk = 0xff0000

	// ESC_CONF2: a
	// Position of ESC_SEQ1 field.
	UHCI_ESC_CONF2_ESC_SEQ1_Pos = 0x0
	// Bit mask of ESC_SEQ1 field.
	UHCI_ESC_CONF2_ESC_SEQ1_Msk = 0xff
	// Position of ESC_SEQ1_CHAR0 field.
	UHCI_ESC_CONF2_ESC_SEQ1_CHAR0_Pos = 0x8
	// Bit mask of ESC_SEQ1_CHAR0 field.
	UHCI_ESC_CONF2_ESC_SEQ1_CHAR0_Msk = 0xff00
	// Position of ESC_SEQ1_CHAR1 field.
	UHCI_ESC_CONF2_ESC_SEQ1_CHAR1_Pos = 0x10
	// Bit mask of ESC_SEQ1_CHAR1 field.
	UHCI_ESC_CONF2_ESC_SEQ1_CHAR1_Msk = 0xff0000

	// ESC_CONF3: a
	// Position of ESC_SEQ2 field.
	UHCI_ESC_CONF3_ESC_SEQ2_Pos = 0x0
	// Bit mask of ESC_SEQ2 field.
	UHCI_ESC_CONF3_ESC_SEQ2_Msk = 0xff
	// Position of ESC_SEQ2_CHAR0 field.
	UHCI_ESC_CONF3_ESC_SEQ2_CHAR0_Pos = 0x8
	// Bit mask of ESC_SEQ2_CHAR0 field.
	UHCI_ESC_CONF3_ESC_SEQ2_CHAR0_Msk = 0xff00
	// Position of ESC_SEQ2_CHAR1 field.
	UHCI_ESC_CONF3_ESC_SEQ2_CHAR1_Pos = 0x10
	// Bit mask of ESC_SEQ2_CHAR1 field.
	UHCI_ESC_CONF3_ESC_SEQ2_CHAR1_Msk = 0xff0000

	// PKT_THRES: a
	// Position of PKT_THRS field.
	UHCI_PKT_THRES_PKT_THRS_Pos = 0x0
	// Bit mask of PKT_THRS field.
	UHCI_PKT_THRES_PKT_THRS_Msk = 0x1fff

	// DATE: a
	// Position of DATE field.
	UHCI_DATE_DATE_Pos = 0x0
	// Bit mask of DATE field.
	UHCI_DATE_DATE_Msk = 0xffffffff
)

// Constants for USB_DEVICE: Peripheral USB_DEVICE
const (
	// EP1: USB_DEVICE_EP1_REG.
	// Position of RDWR_BYTE field.
	USB_DEVICE_EP1_RDWR_BYTE_Pos = 0x0
	// Bit mask of RDWR_BYTE field.
	USB_DEVICE_EP1_RDWR_BYTE_Msk = 0xff

	// EP1_CONF: USB_DEVICE_EP1_CONF_REG.
	// Position of WR_DONE field.
	USB_DEVICE_EP1_CONF_WR_DONE_Pos = 0x0
	// Bit mask of WR_DONE field.
	USB_DEVICE_EP1_CONF_WR_DONE_Msk = 0x1
	// Bit WR_DONE.
	USB_DEVICE_EP1_CONF_WR_DONE = 0x1
	// Position of SERIAL_IN_EP_DATA_FREE field.
	USB_DEVICE_EP1_CONF_SERIAL_IN_EP_DATA_FREE_Pos = 0x1
	// Bit mask of SERIAL_IN_EP_DATA_FREE field.
	USB_DEVICE_EP1_CONF_SERIAL_IN_EP_DATA_FREE_Msk = 0x2
	// Bit SERIAL_IN_EP_DATA_FREE.
	USB_DEVICE_EP1_CONF_SERIAL_IN_EP_DATA_FREE = 0x2
	// Position of SERIAL_OUT_EP_DATA_AVAIL field.
	USB_DEVICE_EP1_CONF_SERIAL_OUT_EP_DATA_AVAIL_Pos = 0x2
	// Bit mask of SERIAL_OUT_EP_DATA_AVAIL field.
	USB_DEVICE_EP1_CONF_SERIAL_OUT_EP_DATA_AVAIL_Msk = 0x4
	// Bit SERIAL_OUT_EP_DATA_AVAIL.
	USB_DEVICE_EP1_CONF_SERIAL_OUT_EP_DATA_AVAIL = 0x4

	// INT_RAW: USB_DEVICE_INT_RAW_REG.
	// Position of JTAG_IN_FLUSH_INT_RAW field.
	USB_DEVICE_INT_RAW_JTAG_IN_FLUSH_INT_RAW_Pos = 0x0
	// Bit mask of JTAG_IN_FLUSH_INT_RAW field.
	USB_DEVICE_INT_RAW_JTAG_IN_FLUSH_INT_RAW_Msk = 0x1
	// Bit JTAG_IN_FLUSH_INT_RAW.
	USB_DEVICE_INT_RAW_JTAG_IN_FLUSH_INT_RAW = 0x1
	// Position of SOF_INT_RAW field.
	USB_DEVICE_INT_RAW_SOF_INT_RAW_Pos = 0x1
	// Bit mask of SOF_INT_RAW field.
	USB_DEVICE_INT_RAW_SOF_INT_RAW_Msk = 0x2
	// Bit SOF_INT_RAW.
	USB_DEVICE_INT_RAW_SOF_INT_RAW = 0x2
	// Position of SERIAL_OUT_RECV_PKT_INT_RAW field.
	USB_DEVICE_INT_RAW_SERIAL_OUT_RECV_PKT_INT_RAW_Pos = 0x2
	// Bit mask of SERIAL_OUT_RECV_PKT_INT_RAW field.
	USB_DEVICE_INT_RAW_SERIAL_OUT_RECV_PKT_INT_RAW_Msk = 0x4
	// Bit SERIAL_OUT_RECV_PKT_INT_RAW.
	USB_DEVICE_INT_RAW_SERIAL_OUT_RECV_PKT_INT_RAW = 0x4
	// Position of SERIAL_IN_EMPTY_INT_RAW field.
	USB_DEVICE_INT_RAW_SERIAL_IN_EMPTY_INT_RAW_Pos = 0x3
	// Bit mask of SERIAL_IN_EMPTY_INT_RAW field.
	USB_DEVICE_INT_RAW_SERIAL_IN_EMPTY_INT_RAW_Msk = 0x8
	// Bit SERIAL_IN_EMPTY_INT_RAW.
	USB_DEVICE_INT_RAW_SERIAL_IN_EMPTY_INT_RAW = 0x8
	// Position of PID_ERR_INT_RAW field.
	USB_DEVICE_INT_RAW_PID_ERR_INT_RAW_Pos = 0x4
	// Bit mask of PID_ERR_INT_RAW field.
	USB_DEVICE_INT_RAW_PID_ERR_INT_RAW_Msk = 0x10
	// Bit PID_ERR_INT_RAW.
	USB_DEVICE_INT_RAW_PID_ERR_INT_RAW = 0x10
	// Position of CRC5_ERR_INT_RAW field.
	USB_DEVICE_INT_RAW_CRC5_ERR_INT_RAW_Pos = 0x5
	// Bit mask of CRC5_ERR_INT_RAW field.
	USB_DEVICE_INT_RAW_CRC5_ERR_INT_RAW_Msk = 0x20
	// Bit CRC5_ERR_INT_RAW.
	USB_DEVICE_INT_RAW_CRC5_ERR_INT_RAW = 0x20
	// Position of CRC16_ERR_INT_RAW field.
	USB_DEVICE_INT_RAW_CRC16_ERR_INT_RAW_Pos = 0x6
	// Bit mask of CRC16_ERR_INT_RAW field.
	USB_DEVICE_INT_RAW_CRC16_ERR_INT_RAW_Msk = 0x40
	// Bit CRC16_ERR_INT_RAW.
	USB_DEVICE_INT_RAW_CRC16_ERR_INT_RAW = 0x40
	// Position of STUFF_ERR_INT_RAW field.
	USB_DEVICE_INT_RAW_STUFF_ERR_INT_RAW_Pos = 0x7
	// Bit mask of STUFF_ERR_INT_RAW field.
	USB_DEVICE_INT_RAW_STUFF_ERR_INT_RAW_Msk = 0x80
	// Bit STUFF_ERR_INT_RAW.
	USB_DEVICE_INT_RAW_STUFF_ERR_INT_RAW = 0x80
	// Position of IN_TOKEN_REC_IN_EP1_INT_RAW field.
	USB_DEVICE_INT_RAW_IN_TOKEN_REC_IN_EP1_INT_RAW_Pos = 0x8
	// Bit mask of IN_TOKEN_REC_IN_EP1_INT_RAW field.
	USB_DEVICE_INT_RAW_IN_TOKEN_REC_IN_EP1_INT_RAW_Msk = 0x100
	// Bit IN_TOKEN_REC_IN_EP1_INT_RAW.
	USB_DEVICE_INT_RAW_IN_TOKEN_REC_IN_EP1_INT_RAW = 0x100
	// Position of USB_BUS_RESET_INT_RAW field.
	USB_DEVICE_INT_RAW_USB_BUS_RESET_INT_RAW_Pos = 0x9
	// Bit mask of USB_BUS_RESET_INT_RAW field.
	USB_DEVICE_INT_RAW_USB_BUS_RESET_INT_RAW_Msk = 0x200
	// Bit USB_BUS_RESET_INT_RAW.
	USB_DEVICE_INT_RAW_USB_BUS_RESET_INT_RAW = 0x200
	// Position of OUT_EP1_ZERO_PAYLOAD_INT_RAW field.
	USB_DEVICE_INT_RAW_OUT_EP1_ZERO_PAYLOAD_INT_RAW_Pos = 0xa
	// Bit mask of OUT_EP1_ZERO_PAYLOAD_INT_RAW field.
	USB_DEVICE_INT_RAW_OUT_EP1_ZERO_PAYLOAD_INT_RAW_Msk = 0x400
	// Bit OUT_EP1_ZERO_PAYLOAD_INT_RAW.
	USB_DEVICE_INT_RAW_OUT_EP1_ZERO_PAYLOAD_INT_RAW = 0x400
	// Position of OUT_EP2_ZERO_PAYLOAD_INT_RAW field.
	USB_DEVICE_INT_RAW_OUT_EP2_ZERO_PAYLOAD_INT_RAW_Pos = 0xb
	// Bit mask of OUT_EP2_ZERO_PAYLOAD_INT_RAW field.
	USB_DEVICE_INT_RAW_OUT_EP2_ZERO_PAYLOAD_INT_RAW_Msk = 0x800
	// Bit OUT_EP2_ZERO_PAYLOAD_INT_RAW.
	USB_DEVICE_INT_RAW_OUT_EP2_ZERO_PAYLOAD_INT_RAW = 0x800

	// INT_ST: USB_DEVICE_INT_ST_REG.
	// Position of JTAG_IN_FLUSH_INT_ST field.
	USB_DEVICE_INT_ST_JTAG_IN_FLUSH_INT_ST_Pos = 0x0
	// Bit mask of JTAG_IN_FLUSH_INT_ST field.
	USB_DEVICE_INT_ST_JTAG_IN_FLUSH_INT_ST_Msk = 0x1
	// Bit JTAG_IN_FLUSH_INT_ST.
	USB_DEVICE_INT_ST_JTAG_IN_FLUSH_INT_ST = 0x1
	// Position of SOF_INT_ST field.
	USB_DEVICE_INT_ST_SOF_INT_ST_Pos = 0x1
	// Bit mask of SOF_INT_ST field.
	USB_DEVICE_INT_ST_SOF_INT_ST_Msk = 0x2
	// Bit SOF_INT_ST.
	USB_DEVICE_INT_ST_SOF_INT_ST = 0x2
	// Position of SERIAL_OUT_RECV_PKT_INT_ST field.
	USB_DEVICE_INT_ST_SERIAL_OUT_RECV_PKT_INT_ST_Pos = 0x2
	// Bit mask of SERIAL_OUT_RECV_PKT_INT_ST field.
	USB_DEVICE_INT_ST_SERIAL_OUT_RECV_PKT_INT_ST_Msk = 0x4
	// Bit SERIAL_OUT_RECV_PKT_INT_ST.
	USB_DEVICE_INT_ST_SERIAL_OUT_RECV_PKT_INT_ST = 0x4
	// Position of SERIAL_IN_EMPTY_INT_ST field.
	USB_DEVICE_INT_ST_SERIAL_IN_EMPTY_INT_ST_Pos = 0x3
	// Bit mask of SERIAL_IN_EMPTY_INT_ST field.
	USB_DEVICE_INT_ST_SERIAL_IN_EMPTY_INT_ST_Msk = 0x8
	// Bit SERIAL_IN_EMPTY_INT_ST.
	USB_DEVICE_INT_ST_SERIAL_IN_EMPTY_INT_ST = 0x8
	// Position of PID_ERR_INT_ST field.
	USB_DEVICE_INT_ST_PID_ERR_INT_ST_Pos = 0x4
	// Bit mask of PID_ERR_INT_ST field.
	USB_DEVICE_INT_ST_PID_ERR_INT_ST_Msk = 0x10
	// Bit PID_ERR_INT_ST.
	USB_DEVICE_INT_ST_PID_ERR_INT_ST = 0x10
	// Position of CRC5_ERR_INT_ST field.
	USB_DEVICE_INT_ST_CRC5_ERR_INT_ST_Pos = 0x5
	// Bit mask of CRC5_ERR_INT_ST field.
	USB_DEVICE_INT_ST_CRC5_ERR_INT_ST_Msk = 0x20
	// Bit CRC5_ERR_INT_ST.
	USB_DEVICE_INT_ST_CRC5_ERR_INT_ST = 0x20
	// Position of CRC16_ERR_INT_ST field.
	USB_DEVICE_INT_ST_CRC16_ERR_INT_ST_Pos = 0x6
	// Bit mask of CRC16_ERR_INT_ST field.
	USB_DEVICE_INT_ST_CRC16_ERR_INT_ST_Msk = 0x40
	// Bit CRC16_ERR_INT_ST.
	USB_DEVICE_INT_ST_CRC16_ERR_INT_ST = 0x40
	// Position of STUFF_ERR_INT_ST field.
	USB_DEVICE_INT_ST_STUFF_ERR_INT_ST_Pos = 0x7
	// Bit mask of STUFF_ERR_INT_ST field.
	USB_DEVICE_INT_ST_STUFF_ERR_INT_ST_Msk = 0x80
	// Bit STUFF_ERR_INT_ST.
	USB_DEVICE_INT_ST_STUFF_ERR_INT_ST = 0x80
	// Position of IN_TOKEN_REC_IN_EP1_INT_ST field.
	USB_DEVICE_INT_ST_IN_TOKEN_REC_IN_EP1_INT_ST_Pos = 0x8
	// Bit mask of IN_TOKEN_REC_IN_EP1_INT_ST field.
	USB_DEVICE_INT_ST_IN_TOKEN_REC_IN_EP1_INT_ST_Msk = 0x100
	// Bit IN_TOKEN_REC_IN_EP1_INT_ST.
	USB_DEVICE_INT_ST_IN_TOKEN_REC_IN_EP1_INT_ST = 0x100
	// Position of USB_BUS_RESET_INT_ST field.
	USB_DEVICE_INT_ST_USB_BUS_RESET_INT_ST_Pos = 0x9
	// Bit mask of USB_BUS_RESET_INT_ST field.
	USB_DEVICE_INT_ST_USB_BUS_RESET_INT_ST_Msk = 0x200
	// Bit USB_BUS_RESET_INT_ST.
	USB_DEVICE_INT_ST_USB_BUS_RESET_INT_ST = 0x200
	// Position of OUT_EP1_ZERO_PAYLOAD_INT_ST field.
	USB_DEVICE_INT_ST_OUT_EP1_ZERO_PAYLOAD_INT_ST_Pos = 0xa
	// Bit mask of OUT_EP1_ZERO_PAYLOAD_INT_ST field.
	USB_DEVICE_INT_ST_OUT_EP1_ZERO_PAYLOAD_INT_ST_Msk = 0x400
	// Bit OUT_EP1_ZERO_PAYLOAD_INT_ST.
	USB_DEVICE_INT_ST_OUT_EP1_ZERO_PAYLOAD_INT_ST = 0x400
	// Position of OUT_EP2_ZERO_PAYLOAD_INT_ST field.
	USB_DEVICE_INT_ST_OUT_EP2_ZERO_PAYLOAD_INT_ST_Pos = 0xb
	// Bit mask of OUT_EP2_ZERO_PAYLOAD_INT_ST field.
	USB_DEVICE_INT_ST_OUT_EP2_ZERO_PAYLOAD_INT_ST_Msk = 0x800
	// Bit OUT_EP2_ZERO_PAYLOAD_INT_ST.
	USB_DEVICE_INT_ST_OUT_EP2_ZERO_PAYLOAD_INT_ST = 0x800

	// INT_ENA: USB_DEVICE_INT_ENA_REG.
	// Position of JTAG_IN_FLUSH_INT_ENA field.
	USB_DEVICE_INT_ENA_JTAG_IN_FLUSH_INT_ENA_Pos = 0x0
	// Bit mask of JTAG_IN_FLUSH_INT_ENA field.
	USB_DEVICE_INT_ENA_JTAG_IN_FLUSH_INT_ENA_Msk = 0x1
	// Bit JTAG_IN_FLUSH_INT_ENA.
	USB_DEVICE_INT_ENA_JTAG_IN_FLUSH_INT_ENA = 0x1
	// Position of SOF_INT_ENA field.
	USB_DEVICE_INT_ENA_SOF_INT_ENA_Pos = 0x1
	// Bit mask of SOF_INT_ENA field.
	USB_DEVICE_INT_ENA_SOF_INT_ENA_Msk = 0x2
	// Bit SOF_INT_ENA.
	USB_DEVICE_INT_ENA_SOF_INT_ENA = 0x2
	// Position of SERIAL_OUT_RECV_PKT_INT_ENA field.
	USB_DEVICE_INT_ENA_SERIAL_OUT_RECV_PKT_INT_ENA_Pos = 0x2
	// Bit mask of SERIAL_OUT_RECV_PKT_INT_ENA field.
	USB_DEVICE_INT_ENA_SERIAL_OUT_RECV_PKT_INT_ENA_Msk = 0x4
	// Bit SERIAL_OUT_RECV_PKT_INT_ENA.
	USB_DEVICE_INT_ENA_SERIAL_OUT_RECV_PKT_INT_ENA = 0x4
	// Position of SERIAL_IN_EMPTY_INT_ENA field.
	USB_DEVICE_INT_ENA_SERIAL_IN_EMPTY_INT_ENA_Pos = 0x3
	// Bit mask of SERIAL_IN_EMPTY_INT_ENA field.
	USB_DEVICE_INT_ENA_SERIAL_IN_EMPTY_INT_ENA_Msk = 0x8
	// Bit SERIAL_IN_EMPTY_INT_ENA.
	USB_DEVICE_INT_ENA_SERIAL_IN_EMPTY_INT_ENA = 0x8
	// Position of PID_ERR_INT_ENA field.
	USB_DEVICE_INT_ENA_PID_ERR_INT_ENA_Pos = 0x4
	// Bit mask of PID_ERR_INT_ENA field.
	USB_DEVICE_INT_ENA_PID_ERR_INT_ENA_Msk = 0x10
	// Bit PID_ERR_INT_ENA.
	USB_DEVICE_INT_ENA_PID_ERR_INT_ENA = 0x10
	// Position of CRC5_ERR_INT_ENA field.
	USB_DEVICE_INT_ENA_CRC5_ERR_INT_ENA_Pos = 0x5
	// Bit mask of CRC5_ERR_INT_ENA field.
	USB_DEVICE_INT_ENA_CRC5_ERR_INT_ENA_Msk = 0x20
	// Bit CRC5_ERR_INT_ENA.
	USB_DEVICE_INT_ENA_CRC5_ERR_INT_ENA = 0x20
	// Position of CRC16_ERR_INT_ENA field.
	USB_DEVICE_INT_ENA_CRC16_ERR_INT_ENA_Pos = 0x6
	// Bit mask of CRC16_ERR_INT_ENA field.
	USB_DEVICE_INT_ENA_CRC16_ERR_INT_ENA_Msk = 0x40
	// Bit CRC16_ERR_INT_ENA.
	USB_DEVICE_INT_ENA_CRC16_ERR_INT_ENA = 0x40
	// Position of STUFF_ERR_INT_ENA field.
	USB_DEVICE_INT_ENA_STUFF_ERR_INT_ENA_Pos = 0x7
	// Bit mask of STUFF_ERR_INT_ENA field.
	USB_DEVICE_INT_ENA_STUFF_ERR_INT_ENA_Msk = 0x80
	// Bit STUFF_ERR_INT_ENA.
	USB_DEVICE_INT_ENA_STUFF_ERR_INT_ENA = 0x80
	// Position of IN_TOKEN_REC_IN_EP1_INT_ENA field.
	USB_DEVICE_INT_ENA_IN_TOKEN_REC_IN_EP1_INT_ENA_Pos = 0x8
	// Bit mask of IN_TOKEN_REC_IN_EP1_INT_ENA field.
	USB_DEVICE_INT_ENA_IN_TOKEN_REC_IN_EP1_INT_ENA_Msk = 0x100
	// Bit IN_TOKEN_REC_IN_EP1_INT_ENA.
	USB_DEVICE_INT_ENA_IN_TOKEN_REC_IN_EP1_INT_ENA = 0x100
	// Position of USB_BUS_RESET_INT_ENA field.
	USB_DEVICE_INT_ENA_USB_BUS_RESET_INT_ENA_Pos = 0x9
	// Bit mask of USB_BUS_RESET_INT_ENA field.
	USB_DEVICE_INT_ENA_USB_BUS_RESET_INT_ENA_Msk = 0x200
	// Bit USB_BUS_RESET_INT_ENA.
	USB_DEVICE_INT_ENA_USB_BUS_RESET_INT_ENA = 0x200
	// Position of OUT_EP1_ZERO_PAYLOAD_INT_ENA field.
	USB_DEVICE_INT_ENA_OUT_EP1_ZERO_PAYLOAD_INT_ENA_Pos = 0xa
	// Bit mask of OUT_EP1_ZERO_PAYLOAD_INT_ENA field.
	USB_DEVICE_INT_ENA_OUT_EP1_ZERO_PAYLOAD_INT_ENA_Msk = 0x400
	// Bit OUT_EP1_ZERO_PAYLOAD_INT_ENA.
	USB_DEVICE_INT_ENA_OUT_EP1_ZERO_PAYLOAD_INT_ENA = 0x400
	// Position of OUT_EP2_ZERO_PAYLOAD_INT_ENA field.
	USB_DEVICE_INT_ENA_OUT_EP2_ZERO_PAYLOAD_INT_ENA_Pos = 0xb
	// Bit mask of OUT_EP2_ZERO_PAYLOAD_INT_ENA field.
	USB_DEVICE_INT_ENA_OUT_EP2_ZERO_PAYLOAD_INT_ENA_Msk = 0x800
	// Bit OUT_EP2_ZERO_PAYLOAD_INT_ENA.
	USB_DEVICE_INT_ENA_OUT_EP2_ZERO_PAYLOAD_INT_ENA = 0x800

	// INT_CLR: USB_DEVICE_INT_CLR_REG.
	// Position of JTAG_IN_FLUSH_INT_CLR field.
	USB_DEVICE_INT_CLR_JTAG_IN_FLUSH_INT_CLR_Pos = 0x0
	// Bit mask of JTAG_IN_FLUSH_INT_CLR field.
	USB_DEVICE_INT_CLR_JTAG_IN_FLUSH_INT_CLR_Msk = 0x1
	// Bit JTAG_IN_FLUSH_INT_CLR.
	USB_DEVICE_INT_CLR_JTAG_IN_FLUSH_INT_CLR = 0x1
	// Position of SOF_INT_CLR field.
	USB_DEVICE_INT_CLR_SOF_INT_CLR_Pos = 0x1
	// Bit mask of SOF_INT_CLR field.
	USB_DEVICE_INT_CLR_SOF_INT_CLR_Msk = 0x2
	// Bit SOF_INT_CLR.
	USB_DEVICE_INT_CLR_SOF_INT_CLR = 0x2
	// Position of SERIAL_OUT_RECV_PKT_INT_CLR field.
	USB_DEVICE_INT_CLR_SERIAL_OUT_RECV_PKT_INT_CLR_Pos = 0x2
	// Bit mask of SERIAL_OUT_RECV_PKT_INT_CLR field.
	USB_DEVICE_INT_CLR_SERIAL_OUT_RECV_PKT_INT_CLR_Msk = 0x4
	// Bit SERIAL_OUT_RECV_PKT_INT_CLR.
	USB_DEVICE_INT_CLR_SERIAL_OUT_RECV_PKT_INT_CLR = 0x4
	// Position of SERIAL_IN_EMPTY_INT_CLR field.
	USB_DEVICE_INT_CLR_SERIAL_IN_EMPTY_INT_CLR_Pos = 0x3
	// Bit mask of SERIAL_IN_EMPTY_INT_CLR field.
	USB_DEVICE_INT_CLR_SERIAL_IN_EMPTY_INT_CLR_Msk = 0x8
	// Bit SERIAL_IN_EMPTY_INT_CLR.
	USB_DEVICE_INT_CLR_SERIAL_IN_EMPTY_INT_CLR = 0x8
	// Position of PID_ERR_INT_CLR field.
	USB_DEVICE_INT_CLR_PID_ERR_INT_CLR_Pos = 0x4
	// Bit mask of PID_ERR_INT_CLR field.
	USB_DEVICE_INT_CLR_PID_ERR_INT_CLR_Msk = 0x10
	// Bit PID_ERR_INT_CLR.
	USB_DEVICE_INT_CLR_PID_ERR_INT_CLR = 0x10
	// Position of CRC5_ERR_INT_CLR field.
	USB_DEVICE_INT_CLR_CRC5_ERR_INT_CLR_Pos = 0x5
	// Bit mask of CRC5_ERR_INT_CLR field.
	USB_DEVICE_INT_CLR_CRC5_ERR_INT_CLR_Msk = 0x20
	// Bit CRC5_ERR_INT_CLR.
	USB_DEVICE_INT_CLR_CRC5_ERR_INT_CLR = 0x20
	// Position of CRC16_ERR_INT_CLR field.
	USB_DEVICE_INT_CLR_CRC16_ERR_INT_CLR_Pos = 0x6
	// Bit mask of CRC16_ERR_INT_CLR field.
	USB_DEVICE_INT_CLR_CRC16_ERR_INT_CLR_Msk = 0x40
	// Bit CRC16_ERR_INT_CLR.
	USB_DEVICE_INT_CLR_CRC16_ERR_INT_CLR = 0x40
	// Position of STUFF_ERR_INT_CLR field.
	USB_DEVICE_INT_CLR_STUFF_ERR_INT_CLR_Pos = 0x7
	// Bit mask of STUFF_ERR_INT_CLR field.
	USB_DEVICE_INT_CLR_STUFF_ERR_INT_CLR_Msk = 0x80
	// Bit STUFF_ERR_INT_CLR.
	USB_DEVICE_INT_CLR_STUFF_ERR_INT_CLR = 0x80
	// Position of IN_TOKEN_REC_IN_EP1_INT_CLR field.
	USB_DEVICE_INT_CLR_IN_TOKEN_REC_IN_EP1_INT_CLR_Pos = 0x8
	// Bit mask of IN_TOKEN_REC_IN_EP1_INT_CLR field.
	USB_DEVICE_INT_CLR_IN_TOKEN_REC_IN_EP1_INT_CLR_Msk = 0x100
	// Bit IN_TOKEN_REC_IN_EP1_INT_CLR.
	USB_DEVICE_INT_CLR_IN_TOKEN_REC_IN_EP1_INT_CLR = 0x100
	// Position of USB_BUS_RESET_INT_CLR field.
	USB_DEVICE_INT_CLR_USB_BUS_RESET_INT_CLR_Pos = 0x9
	// Bit mask of USB_BUS_RESET_INT_CLR field.
	USB_DEVICE_INT_CLR_USB_BUS_RESET_INT_CLR_Msk = 0x200
	// Bit USB_BUS_RESET_INT_CLR.
	USB_DEVICE_INT_CLR_USB_BUS_RESET_INT_CLR = 0x200
	// Position of OUT_EP1_ZERO_PAYLOAD_INT_CLR field.
	USB_DEVICE_INT_CLR_OUT_EP1_ZERO_PAYLOAD_INT_CLR_Pos = 0xa
	// Bit mask of OUT_EP1_ZERO_PAYLOAD_INT_CLR field.
	USB_DEVICE_INT_CLR_OUT_EP1_ZERO_PAYLOAD_INT_CLR_Msk = 0x400
	// Bit OUT_EP1_ZERO_PAYLOAD_INT_CLR.
	USB_DEVICE_INT_CLR_OUT_EP1_ZERO_PAYLOAD_INT_CLR = 0x400
	// Position of OUT_EP2_ZERO_PAYLOAD_INT_CLR field.
	USB_DEVICE_INT_CLR_OUT_EP2_ZERO_PAYLOAD_INT_CLR_Pos = 0xb
	// Bit mask of OUT_EP2_ZERO_PAYLOAD_INT_CLR field.
	USB_DEVICE_INT_CLR_OUT_EP2_ZERO_PAYLOAD_INT_CLR_Msk = 0x800
	// Bit OUT_EP2_ZERO_PAYLOAD_INT_CLR.
	USB_DEVICE_INT_CLR_OUT_EP2_ZERO_PAYLOAD_INT_CLR = 0x800

	// CONF0: USB_DEVICE_CONF0_REG.
	// Position of PHY_SEL field.
	USB_DEVICE_CONF0_PHY_SEL_Pos = 0x0
	// Bit mask of PHY_SEL field.
	USB_DEVICE_CONF0_PHY_SEL_Msk = 0x1
	// Bit PHY_SEL.
	USB_DEVICE_CONF0_PHY_SEL = 0x1
	// Position of EXCHG_PINS_OVERRIDE field.
	USB_DEVICE_CONF0_EXCHG_PINS_OVERRIDE_Pos = 0x1
	// Bit mask of EXCHG_PINS_OVERRIDE field.
	USB_DEVICE_CONF0_EXCHG_PINS_OVERRIDE_Msk = 0x2
	// Bit EXCHG_PINS_OVERRIDE.
	USB_DEVICE_CONF0_EXCHG_PINS_OVERRIDE = 0x2
	// Position of EXCHG_PINS field.
	USB_DEVICE_CONF0_EXCHG_PINS_Pos = 0x2
	// Bit mask of EXCHG_PINS field.
	USB_DEVICE_CONF0_EXCHG_PINS_Msk = 0x4
	// Bit EXCHG_PINS.
	USB_DEVICE_CONF0_EXCHG_PINS = 0x4
	// Position of VREFH field.
	USB_DEVICE_CONF0_VREFH_Pos = 0x3
	// Bit mask of VREFH field.
	USB_DEVICE_CONF0_VREFH_Msk = 0x18
	// Position of VREFL field.
	USB_DEVICE_CONF0_VREFL_Pos = 0x5
	// Bit mask of VREFL field.
	USB_DEVICE_CONF0_VREFL_Msk = 0x60
	// Position of VREF_OVERRIDE field.
	USB_DEVICE_CONF0_VREF_OVERRIDE_Pos = 0x7
	// Bit mask of VREF_OVERRIDE field.
	USB_DEVICE_CONF0_VREF_OVERRIDE_Msk = 0x80
	// Bit VREF_OVERRIDE.
	USB_DEVICE_CONF0_VREF_OVERRIDE = 0x80
	// Position of PAD_PULL_OVERRIDE field.
	USB_DEVICE_CONF0_PAD_PULL_OVERRIDE_Pos = 0x8
	// Bit mask of PAD_PULL_OVERRIDE field.
	USB_DEVICE_CONF0_PAD_PULL_OVERRIDE_Msk = 0x100
	// Bit PAD_PULL_OVERRIDE.
	USB_DEVICE_CONF0_PAD_PULL_OVERRIDE = 0x100
	// Position of DP_PULLUP field.
	USB_DEVICE_CONF0_DP_PULLUP_Pos = 0x9
	// Bit mask of DP_PULLUP field.
	USB_DEVICE_CONF0_DP_PULLUP_Msk = 0x200
	// Bit DP_PULLUP.
	USB_DEVICE_CONF0_DP_PULLUP = 0x200
	// Position of DP_PULLDOWN field.
	USB_DEVICE_CONF0_DP_PULLDOWN_Pos = 0xa
	// Bit mask of DP_PULLDOWN field.
	USB_DEVICE_CONF0_DP_PULLDOWN_Msk = 0x400
	// Bit DP_PULLDOWN.
	USB_DEVICE_CONF0_DP_PULLDOWN = 0x400
	// Position of DM_PULLUP field.
	USB_DEVICE_CONF0_DM_PULLUP_Pos = 0xb
	// Bit mask of DM_PULLUP field.
	USB_DEVICE_CONF0_DM_PULLUP_Msk = 0x800
	// Bit DM_PULLUP.
	USB_DEVICE_CONF0_DM_PULLUP = 0x800
	// Position of DM_PULLDOWN field.
	USB_DEVICE_CONF0_DM_PULLDOWN_Pos = 0xc
	// Bit mask of DM_PULLDOWN field.
	USB_DEVICE_CONF0_DM_PULLDOWN_Msk = 0x1000
	// Bit DM_PULLDOWN.
	USB_DEVICE_CONF0_DM_PULLDOWN = 0x1000
	// Position of PULLUP_VALUE field.
	USB_DEVICE_CONF0_PULLUP_VALUE_Pos = 0xd
	// Bit mask of PULLUP_VALUE field.
	USB_DEVICE_CONF0_PULLUP_VALUE_Msk = 0x2000
	// Bit PULLUP_VALUE.
	USB_DEVICE_CONF0_PULLUP_VALUE = 0x2000
	// Position of USB_PAD_ENABLE field.
	USB_DEVICE_CONF0_USB_PAD_ENABLE_Pos = 0xe
	// Bit mask of USB_PAD_ENABLE field.
	USB_DEVICE_CONF0_USB_PAD_ENABLE_Msk = 0x4000
	// Bit USB_PAD_ENABLE.
	USB_DEVICE_CONF0_USB_PAD_ENABLE = 0x4000

	// TEST: USB_DEVICE_TEST_REG.
	// Position of ENABLE field.
	USB_DEVICE_TEST_ENABLE_Pos = 0x0
	// Bit mask of ENABLE field.
	USB_DEVICE_TEST_ENABLE_Msk = 0x1
	// Bit ENABLE.
	USB_DEVICE_TEST_ENABLE = 0x1
	// Position of USB_OE field.
	USB_DEVICE_TEST_USB_OE_Pos = 0x1
	// Bit mask of USB_OE field.
	USB_DEVICE_TEST_USB_OE_Msk = 0x2
	// Bit USB_OE.
	USB_DEVICE_TEST_USB_OE = 0x2
	// Position of TX_DP field.
	USB_DEVICE_TEST_TX_DP_Pos = 0x2
	// Bit mask of TX_DP field.
	USB_DEVICE_TEST_TX_DP_Msk = 0x4
	// Bit TX_DP.
	USB_DEVICE_TEST_TX_DP = 0x4
	// Position of TX_DM field.
	USB_DEVICE_TEST_TX_DM_Pos = 0x3
	// Bit mask of TX_DM field.
	USB_DEVICE_TEST_TX_DM_Msk = 0x8
	// Bit TX_DM.
	USB_DEVICE_TEST_TX_DM = 0x8

	// JFIFO_ST: USB_DEVICE_JFIFO_ST_REG.
	// Position of IN_FIFO_CNT field.
	USB_DEVICE_JFIFO_ST_IN_FIFO_CNT_Pos = 0x0
	// Bit mask of IN_FIFO_CNT field.
	USB_DEVICE_JFIFO_ST_IN_FIFO_CNT_Msk = 0x3
	// Position of IN_FIFO_EMPTY field.
	USB_DEVICE_JFIFO_ST_IN_FIFO_EMPTY_Pos = 0x2
	// Bit mask of IN_FIFO_EMPTY field.
	USB_DEVICE_JFIFO_ST_IN_FIFO_EMPTY_Msk = 0x4
	// Bit IN_FIFO_EMPTY.
	USB_DEVICE_JFIFO_ST_IN_FIFO_EMPTY = 0x4
	// Position of IN_FIFO_FULL field.
	USB_DEVICE_JFIFO_ST_IN_FIFO_FULL_Pos = 0x3
	// Bit mask of IN_FIFO_FULL field.
	USB_DEVICE_JFIFO_ST_IN_FIFO_FULL_Msk = 0x8
	// Bit IN_FIFO_FULL.
	USB_DEVICE_JFIFO_ST_IN_FIFO_FULL = 0x8
	// Position of OUT_FIFO_CNT field.
	USB_DEVICE_JFIFO_ST_OUT_FIFO_CNT_Pos = 0x4
	// Bit mask of OUT_FIFO_CNT field.
	USB_DEVICE_JFIFO_ST_OUT_FIFO_CNT_Msk = 0x30
	// Position of OUT_FIFO_EMPTY field.
	USB_DEVICE_JFIFO_ST_OUT_FIFO_EMPTY_Pos = 0x6
	// Bit mask of OUT_FIFO_EMPTY field.
	USB_DEVICE_JFIFO_ST_OUT_FIFO_EMPTY_Msk = 0x40
	// Bit OUT_FIFO_EMPTY.
	USB_DEVICE_JFIFO_ST_OUT_FIFO_EMPTY = 0x40
	// Position of OUT_FIFO_FULL field.
	USB_DEVICE_JFIFO_ST_OUT_FIFO_FULL_Pos = 0x7
	// Bit mask of OUT_FIFO_FULL field.
	USB_DEVICE_JFIFO_ST_OUT_FIFO_FULL_Msk = 0x80
	// Bit OUT_FIFO_FULL.
	USB_DEVICE_JFIFO_ST_OUT_FIFO_FULL = 0x80
	// Position of IN_FIFO_RESET field.
	USB_DEVICE_JFIFO_ST_IN_FIFO_RESET_Pos = 0x8
	// Bit mask of IN_FIFO_RESET field.
	USB_DEVICE_JFIFO_ST_IN_FIFO_RESET_Msk = 0x100
	// Bit IN_FIFO_RESET.
	USB_DEVICE_JFIFO_ST_IN_FIFO_RESET = 0x100
	// Position of OUT_FIFO_RESET field.
	USB_DEVICE_JFIFO_ST_OUT_FIFO_RESET_Pos = 0x9
	// Bit mask of OUT_FIFO_RESET field.
	USB_DEVICE_JFIFO_ST_OUT_FIFO_RESET_Msk = 0x200
	// Bit OUT_FIFO_RESET.
	USB_DEVICE_JFIFO_ST_OUT_FIFO_RESET = 0x200

	// FRAM_NUM: USB_DEVICE_FRAM_NUM_REG.
	// Position of SOF_FRAME_INDEX field.
	USB_DEVICE_FRAM_NUM_SOF_FRAME_INDEX_Pos = 0x0
	// Bit mask of SOF_FRAME_INDEX field.
	USB_DEVICE_FRAM_NUM_SOF_FRAME_INDEX_Msk = 0x7ff

	// IN_EP0_ST: USB_DEVICE_IN_EP0_ST_REG.
	// Position of IN_EP0_STATE field.
	USB_DEVICE_IN_EP0_ST_IN_EP0_STATE_Pos = 0x0
	// Bit mask of IN_EP0_STATE field.
	USB_DEVICE_IN_EP0_ST_IN_EP0_STATE_Msk = 0x3
	// Position of IN_EP0_WR_ADDR field.
	USB_DEVICE_IN_EP0_ST_IN_EP0_WR_ADDR_Pos = 0x2
	// Bit mask of IN_EP0_WR_ADDR field.
	USB_DEVICE_IN_EP0_ST_IN_EP0_WR_ADDR_Msk = 0x1fc
	// Position of IN_EP0_RD_ADDR field.
	USB_DEVICE_IN_EP0_ST_IN_EP0_RD_ADDR_Pos = 0x9
	// Bit mask of IN_EP0_RD_ADDR field.
	USB_DEVICE_IN_EP0_ST_IN_EP0_RD_ADDR_Msk = 0xfe00

	// IN_EP1_ST: USB_DEVICE_IN_EP1_ST_REG.
	// Position of IN_EP1_STATE field.
	USB_DEVICE_IN_EP1_ST_IN_EP1_STATE_Pos = 0x0
	// Bit mask of IN_EP1_STATE field.
	USB_DEVICE_IN_EP1_ST_IN_EP1_STATE_Msk = 0x3
	// Position of IN_EP1_WR_ADDR field.
	USB_DEVICE_IN_EP1_ST_IN_EP1_WR_ADDR_Pos = 0x2
	// Bit mask of IN_EP1_WR_ADDR field.
	USB_DEVICE_IN_EP1_ST_IN_EP1_WR_ADDR_Msk = 0x1fc
	// Position of IN_EP1_RD_ADDR field.
	USB_DEVICE_IN_EP1_ST_IN_EP1_RD_ADDR_Pos = 0x9
	// Bit mask of IN_EP1_RD_ADDR field.
	USB_DEVICE_IN_EP1_ST_IN_EP1_RD_ADDR_Msk = 0xfe00

	// IN_EP2_ST: USB_DEVICE_IN_EP2_ST_REG.
	// Position of IN_EP2_STATE field.
	USB_DEVICE_IN_EP2_ST_IN_EP2_STATE_Pos = 0x0
	// Bit mask of IN_EP2_STATE field.
	USB_DEVICE_IN_EP2_ST_IN_EP2_STATE_Msk = 0x3
	// Position of IN_EP2_WR_ADDR field.
	USB_DEVICE_IN_EP2_ST_IN_EP2_WR_ADDR_Pos = 0x2
	// Bit mask of IN_EP2_WR_ADDR field.
	USB_DEVICE_IN_EP2_ST_IN_EP2_WR_ADDR_Msk = 0x1fc
	// Position of IN_EP2_RD_ADDR field.
	USB_DEVICE_IN_EP2_ST_IN_EP2_RD_ADDR_Pos = 0x9
	// Bit mask of IN_EP2_RD_ADDR field.
	USB_DEVICE_IN_EP2_ST_IN_EP2_RD_ADDR_Msk = 0xfe00

	// IN_EP3_ST: USB_DEVICE_IN_EP3_ST_REG.
	// Position of IN_EP3_STATE field.
	USB_DEVICE_IN_EP3_ST_IN_EP3_STATE_Pos = 0x0
	// Bit mask of IN_EP3_STATE field.
	USB_DEVICE_IN_EP3_ST_IN_EP3_STATE_Msk = 0x3
	// Position of IN_EP3_WR_ADDR field.
	USB_DEVICE_IN_EP3_ST_IN_EP3_WR_ADDR_Pos = 0x2
	// Bit mask of IN_EP3_WR_ADDR field.
	USB_DEVICE_IN_EP3_ST_IN_EP3_WR_ADDR_Msk = 0x1fc
	// Position of IN_EP3_RD_ADDR field.
	USB_DEVICE_IN_EP3_ST_IN_EP3_RD_ADDR_Pos = 0x9
	// Bit mask of IN_EP3_RD_ADDR field.
	USB_DEVICE_IN_EP3_ST_IN_EP3_RD_ADDR_Msk = 0xfe00

	// OUT_EP0_ST: USB_DEVICE_OUT_EP0_ST_REG.
	// Position of OUT_EP0_STATE field.
	USB_DEVICE_OUT_EP0_ST_OUT_EP0_STATE_Pos = 0x0
	// Bit mask of OUT_EP0_STATE field.
	USB_DEVICE_OUT_EP0_ST_OUT_EP0_STATE_Msk = 0x3
	// Position of OUT_EP0_WR_ADDR field.
	USB_DEVICE_OUT_EP0_ST_OUT_EP0_WR_ADDR_Pos = 0x2
	// Bit mask of OUT_EP0_WR_ADDR field.
	USB_DEVICE_OUT_EP0_ST_OUT_EP0_WR_ADDR_Msk = 0x1fc
	// Position of OUT_EP0_RD_ADDR field.
	USB_DEVICE_OUT_EP0_ST_OUT_EP0_RD_ADDR_Pos = 0x9
	// Bit mask of OUT_EP0_RD_ADDR field.
	USB_DEVICE_OUT_EP0_ST_OUT_EP0_RD_ADDR_Msk = 0xfe00

	// OUT_EP1_ST: USB_DEVICE_OUT_EP1_ST_REG.
	// Position of OUT_EP1_STATE field.
	USB_DEVICE_OUT_EP1_ST_OUT_EP1_STATE_Pos = 0x0
	// Bit mask of OUT_EP1_STATE field.
	USB_DEVICE_OUT_EP1_ST_OUT_EP1_STATE_Msk = 0x3
	// Position of OUT_EP1_WR_ADDR field.
	USB_DEVICE_OUT_EP1_ST_OUT_EP1_WR_ADDR_Pos = 0x2
	// Bit mask of OUT_EP1_WR_ADDR field.
	USB_DEVICE_OUT_EP1_ST_OUT_EP1_WR_ADDR_Msk = 0x1fc
	// Position of OUT_EP1_RD_ADDR field.
	USB_DEVICE_OUT_EP1_ST_OUT_EP1_RD_ADDR_Pos = 0x9
	// Bit mask of OUT_EP1_RD_ADDR field.
	USB_DEVICE_OUT_EP1_ST_OUT_EP1_RD_ADDR_Msk = 0xfe00
	// Position of OUT_EP1_REC_DATA_CNT field.
	USB_DEVICE_OUT_EP1_ST_OUT_EP1_REC_DATA_CNT_Pos = 0x10
	// Bit mask of OUT_EP1_REC_DATA_CNT field.
	USB_DEVICE_OUT_EP1_ST_OUT_EP1_REC_DATA_CNT_Msk = 0x7f0000

	// OUT_EP2_ST: USB_DEVICE_OUT_EP2_ST_REG.
	// Position of OUT_EP2_STATE field.
	USB_DEVICE_OUT_EP2_ST_OUT_EP2_STATE_Pos = 0x0
	// Bit mask of OUT_EP2_STATE field.
	USB_DEVICE_OUT_EP2_ST_OUT_EP2_STATE_Msk = 0x3
	// Position of OUT_EP2_WR_ADDR field.
	USB_DEVICE_OUT_EP2_ST_OUT_EP2_WR_ADDR_Pos = 0x2
	// Bit mask of OUT_EP2_WR_ADDR field.
	USB_DEVICE_OUT_EP2_ST_OUT_EP2_WR_ADDR_Msk = 0x1fc
	// Position of OUT_EP2_RD_ADDR field.
	USB_DEVICE_OUT_EP2_ST_OUT_EP2_RD_ADDR_Pos = 0x9
	// Bit mask of OUT_EP2_RD_ADDR field.
	USB_DEVICE_OUT_EP2_ST_OUT_EP2_RD_ADDR_Msk = 0xfe00

	// MISC_CONF: USB_DEVICE_MISC_CONF_REG.
	// Position of CLK_EN field.
	USB_DEVICE_MISC_CONF_CLK_EN_Pos = 0x0
	// Bit mask of CLK_EN field.
	USB_DEVICE_MISC_CONF_CLK_EN_Msk = 0x1
	// Bit CLK_EN.
	USB_DEVICE_MISC_CONF_CLK_EN = 0x1

	// MEM_CONF: USB_DEVICE_MEM_CONF_REG.
	// Position of USB_MEM_PD field.
	USB_DEVICE_MEM_CONF_USB_MEM_PD_Pos = 0x0
	// Bit mask of USB_MEM_PD field.
	USB_DEVICE_MEM_CONF_USB_MEM_PD_Msk = 0x1
	// Bit USB_MEM_PD.
	USB_DEVICE_MEM_CONF_USB_MEM_PD = 0x1
	// Position of USB_MEM_CLK_EN field.
	USB_DEVICE_MEM_CONF_USB_MEM_CLK_EN_Pos = 0x1
	// Bit mask of USB_MEM_CLK_EN field.
	USB_DEVICE_MEM_CONF_USB_MEM_CLK_EN_Msk = 0x2
	// Bit USB_MEM_CLK_EN.
	USB_DEVICE_MEM_CONF_USB_MEM_CLK_EN = 0x2

	// DATE: USB_DEVICE_DATE_REG.
	// Position of DATE field.
	USB_DEVICE_DATE_DATE_Pos = 0x0
	// Bit mask of DATE field.
	USB_DEVICE_DATE_DATE_Msk = 0xffffffff
)

// Constants for XTS_AES: Peripheral XTS_AES
const (
	// LINESIZE: XTS-AES line-size register
	// Position of LINESIZE field.
	XTS_AES_LINESIZE_LINESIZE_Pos = 0x0
	// Bit mask of LINESIZE field.
	XTS_AES_LINESIZE_LINESIZE_Msk = 0x1
	// Bit LINESIZE.
	XTS_AES_LINESIZE_LINESIZE = 0x1

	// DESTINATION: XTS-AES destination register
	// Position of DESTINATION field.
	XTS_AES_DESTINATION_DESTINATION_Pos = 0x0
	// Bit mask of DESTINATION field.
	XTS_AES_DESTINATION_DESTINATION_Msk = 0x1
	// Bit DESTINATION.
	XTS_AES_DESTINATION_DESTINATION = 0x1

	// PHYSICAL_ADDRESS: XTS-AES physical address register
	// Position of PHYSICAL_ADDRESS field.
	XTS_AES_PHYSICAL_ADDRESS_PHYSICAL_ADDRESS_Pos = 0x0
	// Bit mask of PHYSICAL_ADDRESS field.
	XTS_AES_PHYSICAL_ADDRESS_PHYSICAL_ADDRESS_Msk = 0x3fffffff

	// TRIGGER: XTS-AES trigger register
	// Position of TRIGGER field.
	XTS_AES_TRIGGER_TRIGGER_Pos = 0x0
	// Bit mask of TRIGGER field.
	XTS_AES_TRIGGER_TRIGGER_Msk = 0x1
	// Bit TRIGGER.
	XTS_AES_TRIGGER_TRIGGER = 0x1

	// RELEASE: XTS-AES release register
	// Position of RELEASE field.
	XTS_AES_RELEASE_RELEASE_Pos = 0x0
	// Bit mask of RELEASE field.
	XTS_AES_RELEASE_RELEASE_Msk = 0x1
	// Bit RELEASE.
	XTS_AES_RELEASE_RELEASE = 0x1

	// DESTROY: XTS-AES destroy register
	// Position of DESTROY field.
	XTS_AES_DESTROY_DESTROY_Pos = 0x0
	// Bit mask of DESTROY field.
	XTS_AES_DESTROY_DESTROY_Msk = 0x1
	// Bit DESTROY.
	XTS_AES_DESTROY_DESTROY = 0x1

	// STATE: XTS-AES status register
	// Position of STATE field.
	XTS_AES_STATE_STATE_Pos = 0x0
	// Bit mask of STATE field.
	XTS_AES_STATE_STATE_Msk = 0x3

	// DATE: XTS-AES version control register
	// Position of DATE field.
	XTS_AES_DATE_DATE_Pos = 0x0
	// Bit mask of DATE field.
	XTS_AES_DATE_DATE_Msk = 0x3fffffff
)
